//@ui5-bundle sap/f/library-preload.js
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/f/Avatar',["sap/m/Avatar","sap/m/AvatarRenderer","./library"],function(M,A){"use strict";
var a=M.extend("sap.f.Avatar",{
metadata:{library:"sap.f",deprecated:true,properties:{},designtime:"sap/f/designtime/Avatar.designtime"},
renderer:A
});
a.prototype._getDefaultTooltip=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.f").getText("AVATAR_TOOLTIP");};
return a;});
sap.ui.predefine('sap/f/AvatarGroup',["./library","sap/ui/core/Control","sap/ui/core/delegate/ItemNavigation","sap/ui/dom/units/Rem","./AvatarGroupRenderer","sap/m/Button","sap/m/library","sap/ui/core/ResizeHandler","sap/ui/events/KeyCodes","sap/ui/core/Core"],function(l,C,I,R,A,B,L,a,K,b){"use strict";var c=l.AvatarGroupType;var d=L.AvatarColor;var e=L.AvatarSize;var f={XS:2,S:3,M:4,L:5,XL:7};var g={XS:0.75,S:1.25,M:1.625,L:2,XL:2.75};var h={XS:0.0625,S:0.125,M:0.125,L:0.125,XL:0.25};
var i=C.extend("sap.f.AvatarGroup",{metadata:{library:"sap.f",properties:{groupType:{type:"sap.f.AvatarGroupType",group:"Appearance",defaultValue:c.Group},avatarDisplaySize:{type:"sap.m.AvatarSize",group:"Appearance",defaultValue:e.S}},defaultAggregation:"items",aggregations:{items:{type:'sap.f.AvatarGroupItem',multiple:true}},events:{press:{parameters:{groupType:{type:"string"},overflowButtonPressed:{type:"boolean"},avatarsDisplayed:{type:"int"}}}}}});
i.prototype.init=function(){this._oShowMoreButton=new B({});this._oShowMoreButton.addStyleClass("sapFAvatarGroupMoreButton");this._bFirstRendering=true;this._onResizeRef=this._onResize.bind(this);this._iCurrentAvatarColorNumber=1;this._bShowMoreButton=false;};
i.prototype.exit=function(){this._detachResizeHandlers();if(this._oItemNavigation){this.removeEventDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}this._oShowMoreButton.destroy();this._oShowMoreButton=null;};
i.prototype.onBeforeRendering=function(){if(this._bFirstRendering){this._iAvatarsToShow=this.getItems().length;this._bFirstRendering=false;}};
i.prototype.onAfterRendering=function(){var D,j=[];if(!this._oItemNavigation){this._oItemNavigation=new I(null,null);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});this.addEventDelegate(this._oItemNavigation);}D=this.getDomRef();this._oItemNavigation.setRootDomRef(D);if(this.getGroupType()===c.Individual){this.getItems().forEach(function(o){j.push(o.getDomRef());});this._oItemNavigation.setItemDomRefs(j);}this._detachResizeHandlers();this._attachResizeHandlers();if(b.isThemeApplied()){this._onResize();}if(this._shouldShowMoreButton()){this._oShowMoreButton.$().attr("role","button");if(this.getGroupType()===c.Group){this._oShowMoreButton.$().attr("tabindex","-1");}else{this._oShowMoreButton.$().attr("aria-label",this._getResourceBundle().getText("AVATARGROUP_POPUP"));}}this._updateAccState();};
i.prototype.onThemeChanged=function(){if(!this.getDomRef()){return;}this._onResize();};
i.prototype._getResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.f");};
i.prototype._updateAccState=function(){var r=this._getResourceBundle(),s=r.getText("AVATARGROUP_NUMBER_OF_AVATARS",[this._iAvatarsToShow,(this.getItems().length-this._iAvatarsToShow)]),p=r.getText("AVATARGROUP_POPUP");if(this.getGroupType()===c.Group){this.$().attr("aria-label",p+" "+s);}};
i.prototype._attachResizeHandlers=function(){this._iResizeHandlerId=a.register(this,this._onResizeRef);};
i.prototype._detachResizeHandlers=function(){if(this._iResizeHandlerId){a.deregister(this._iResizeHandlerId);this._iResizeHandlerId=null;}};
i.prototype.setGroupType=function(v){this.getItems().forEach(function(o){o._setGroupType(v);});return this.setProperty("groupType",v);};
i.prototype.addItem=function(o){o._setDisplaySize(this.getAvatarDisplaySize());o._setAvatarColor(d["Accent"+this._iCurrentAvatarColorNumber]);o._setGroupType(this.getGroupType());this._iAvatarsToShow=this.getItems().length;this._iCurrentAvatarColorNumber++;if(this._iCurrentAvatarColorNumber>10){this._iCurrentAvatarColorNumber=1;}return this.addAggregation("items",o);};
i.prototype.setAvatarDisplaySize=function(v){var o=this.getAvatarDisplaySize();this._oShowMoreButton.removeStyleClass("sapFAvatarGroupMoreButton"+o);this._oShowMoreButton.addStyleClass("sapFAvatarGroupMoreButton"+v);if(o===v){return this;}this.getItems().forEach(function(j){j._setDisplaySize(v);});return this.setProperty("avatarDisplaySize",v);};
i.prototype.ontap=function(E){var o=E.srcControl;this.firePress({groupType:this.getGroupType(),eventSource:o,overflowButtonPressed:o===this._oShowMoreButton,avatarsDisplayed:this._iAvatarsToShow});};
i.prototype.onsapspace=function(E){this.ontap(E);};
i.prototype.onsapenter=function(E){this.ontap(E);};
i.prototype.onkeyup=function(E){if(E.shiftKey&&E.keyCode==K.ENTER||E.shiftKey&&E.keyCode==K.SPACE){E.preventDefault();}};
i.prototype._getAvatarMargin=function(s){var G=this.getGroupType(),m;if(G===c.Group){m=g[s];}else{m=h[s];}return m;};
i.prototype._getAvatarNetWidth=function(j,k){var G=this.getGroupType();if(G===c.Group){return j-k;}else{return j+k;}};
i.prototype._getAvatarsToShow=function(w,j,k){var r=R.toPx(1),m=w-(j*r),n=Math.floor(m/(k*r));return n+1;};
i.prototype._adjustAvatarsToShow=function(j){if(j-this._iAvatarsToShow>99){this._iAvatarsToShow-=2;}else{this._iAvatarsToShow--;}};
i.prototype._getWidth=function(){return Math.ceil(this.$().width());};
i.prototype._onResize=function(){var w=this._getWidth(),j=this.getItems(),k=j.length,s=this.getAvatarDisplaySize(),m=f[s],n=this._getAvatarMargin(s),o=this._getAvatarNetWidth(m,n),r=this.$().children(".sapFAvatarGroupItem").length;this._iAvatarsToShow=this._getAvatarsToShow(w,m,o);if(k>this._iAvatarsToShow&&k>0){this._bShowMoreButton=true;this._bAutoWidth=false;this._adjustAvatarsToShow(k);if(r!=this._iAvatarsToShow){this._oShowMoreButton.setText("+"+(k-this._iAvatarsToShow));this.invalidate();}}else{this._bAutoWidth=true;this.getDomRef().style.width="auto";if(this._bShowMoreButton){this._bShowMoreButton=false;this.invalidate();}}};
i.prototype._shouldShowMoreButton=function(){return this._bShowMoreButton;};
return i;});
sap.ui.predefine('sap/f/AvatarGroupItem',["./library","sap/ui/base/ManagedObject","sap/ui/core/Control","./Avatar","./AvatarGroupItemRenderer"],function(l,M,C,A,a){"use strict";
var b=C.extend("sap.f.AvatarGroupItem",{metadata:{library:"sap.f",properties:{src:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},initials:{type:"string",group:"Data",defaultValue:null},fallbackIcon:{type:"string",group:"Data",defaultValue:null}}}});
b.prototype.onBeforeRendering=function(){this._getAvatar();};
b.prototype.destroy=function(){if(this._oAvatar){this._oAvatar.destroy();this._oAvatar=null;}if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}M.prototype.destroy.apply(this);};
b.prototype.setSrc=function(v){if(this.getSrc()===v){return this;}this._getAvatar().setSrc(v);return this.setProperty("src",v);};
b.prototype.setInitials=function(v){if(this.getInitials()===v){return this;}this._getAvatar().setInitials(v);return this.setProperty("initials",v);};
b.prototype.setFallbackIcon=function(v){if(this.getFallbackIcon()===v){return this;}this._getAvatar().setFallbackIcon(v);return this.setProperty("fallbackIcon",v);};
b.prototype.getAvatarColor=function(){return this._sAvatarColor;};
b.prototype._setGroupType=function(v){this._sGroupType=v;this.invalidate();};
b.prototype._getGroupType=function(){return this._sGroupType;};
b.prototype._setAvatarColor=function(v){this._sAvatarColor=v;this._getAvatar().setBackgroundColor(v);};
b.prototype._setDisplaySize=function(v){this._sAvatarDisplaySize=v;this._getAvatar().setDisplaySize(v);};
b.prototype._getDisplaySize=function(){return this._sAvatarDisplaySize;};
b.prototype._getAvatar=function(){if(!this._oAvatar){this._oAvatar=new A({src:this.getSrc(),initials:this.getInitials(),fallbackIcon:this.getFallbackIcon(),backgroundColor:this.getAvatarColor(),showBorder:true,displaySize:this._getDisplaySize()});}return this._oAvatar;};
return b;});
sap.ui.predefine('sap/f/AvatarGroupItemRenderer',["sap/f/library"],function(l){"use strict";var A={apiVersion:2};
A.render=function(r,a){r.openStart("div",a).class("sapFAvatarGroupItem").class("sapFAvatarGroupItem"+a._sAvatarDisplaySize);if(a._getGroupType()==="Individual"){r.attr("tabindex",0);}r.openEnd();r.renderControl(a._getAvatar());r.close("div");};
return A;},true);
sap.ui.predefine('sap/f/AvatarGroupRenderer',["sap/f/library"],function(l){"use strict";var A={apiVersion:2};
A.render=function(r,a){var s="sapFAvatarGroup",g=a.getGroupType(),b=s+g,I=a.getItems(),S=a._shouldShowMoreButton();r.openStart("div",a).class(s).class(b).class(s+a.getAvatarDisplaySize());if(S){r.class("sapFAvatarGroupShowMore");}if(a._bAutoWidth){r.style("width","auto");}if(g==="Group"){r.attr("role","button");}r.openEnd();for(var i=0;i<a._iAvatarsToShow;i++){r.renderControl(I[i]);}if(S){r.renderControl(a._oShowMoreButton);}r.close("div");};
return A;},true);
sap.ui.predefine('sap/f/CalendarAppointmentInCard',['sap/ui/unified/CalendarAppointment'],function(C){"use strict";
var a=C.extend("sap.f.CalendarAppointmentInCard",{metadata:{library:"sap.f",properties:{clickable:{type:"boolean",group:"Data",defaultValue:false}},events:{press:{}}}});
a.prototype.ontap=function(){this._firePress();};
a.prototype.onsapenter=function(){this._firePress();};
a.prototype._firePress=function(){if(this.getClickable()){this.$().addClass("sapUiCalendarAppSel");setTimeout(function(){this.$().removeClass("sapUiCalendarAppSel");}.bind(this),180);this.firePress({});}};
return a;});
sap.ui.predefine('sap/f/CalendarInCard',['sap/m/Button','sap/m/Toolbar','sap/ui/core/Core','sap/ui/core/date/UniversalDate','sap/ui/core/format/DateFormat','sap/ui/core/IconPool','sap/ui/core/InvisibleText','sap/ui/dom/containsOrEquals','sap/ui/unified/Calendar','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','./CalendarInCardRenderer'],function(B,T,C,U,D,I,a,c,b,d,e,f){"use strict";
var g=b.extend("sap.f.CalendarInCard",{metadata:{library:"sap.f"}});
g.prototype.init=function(){b.prototype.init.apply(this,arguments);this.setProperty("_currentPicker","month");};
g.prototype.onBeforeRendering=function(){var m=this.getAggregation("month"),F=this._getFocusedDate().toLocalJSDate();m[0].displayDate(F);this._iSize=0;switch(this._iMode){case 0:this._oPickerBtn.setText(this._formatPickerText(F));break;case 1:this._oPickerBtn.setText(this._formatMonthPickerText());break;case 2:case 3:this._oPickerBtn.setText(this._formatYearPickerText());break;}this._updateTodayButtonState();};
g.prototype.onAfterRendering=function(E){};
g.prototype.onsaptabnext=function(E){};
g.prototype.onsaptabprevious=function(E){};
g.prototype._initializeHeader=function(){var n=this.getId()+"--Head",r=C.getLibraryResourceBundle("sap.f"),p=new B(n+"-PrevBtn",{icon:I.getIconURI('slim-arrow-left'),tooltip:r.getText("CALENDAR_BTN_PREV"),type:"Transparent",press:function(){this._handlePrevious();}.bind(this)}),N=new B({icon:I.getIconURI('slim-arrow-right'),tooltip:r.getText("CALENDAR_BTN_NEXT"),type:"Transparent",press:function(){this._handleNext();}.bind(this)}),h=new T(n,{ariaLabelledBy:a.getStaticId("sap.f","CALENDAR_NAVIGATION")});this._oTodayBtn=new B({text:r.getText("CALENDAR_TODAY"),ariaLabelledBy:a.getStaticId("sap.f","CALENDAR_NAVIGATE_TO_TODAY"),type:"Transparent",press:function(){this._handleTodayPress();}.bind(this)});this._oPickerBtn=new B({type:"Transparent",ariaLabelledBy:a.getStaticId("sap.f","CALENDAR_SELECT_RANGE"),press:function(){this._handlePickerButtonPress();}.bind(this)});h.addContent(p).addContent(this._oTodayBtn).addContent(N).addContent(this._oPickerBtn);this.setAggregation("header",h);};
g.prototype._handlePickerButtonPress=function(){switch(this._iMode){case 0:this._showMonthPicker();this._oPickerBtn.getDomRef().focus();break;case 1:this._showYearPicker();this._oPickerBtn.getDomRef().focus();break;case 2:this._showYearRangePicker();break;}};
g.prototype._handleTodayPress=function(){var o=new Date(),h=d.fromLocalJSDate(o);this.getAggregation("month")[0].setDate(o);this.getSelectedDates()[0].setStartDate(o);this._setFocusedDate(h);if(this._iMode===3){o.setFullYear(o.getFullYear()-(this._getYearRangePicker().getRangeSize()/2));this._getYearRangePicker().setDate(o);this._oPickerBtn.setText(this._formatYearPickerText());}else if(this._iMode===2){this._getYearPicker().setDate(o);this._oPickerBtn.setText(this._formatYearPickerText());}else if(this._iMode===1){this.displayDate(o);this._getMonthPicker()._iYear=o.getFullYear();this._getMonthPicker().setMonth(o.getMonth());this._oPickerBtn.setText(this._formatMonthPickerText());}else{this._oPickerBtn.setText(this._formatPickerText());}this._addMonthFocusDelegate();this._updateTodayButtonState();this.fireStartDateChange();this.fireSelect();};
g.prototype._formatPickerText=function(F){var o=F?F:this.getSelectedDates()[0].getStartDate(),r=C.getConfiguration().getRTL(),h=D.getDateInstance({format:"yMMMM"}),s=h.format(o),R,E;if(!r){R=s;if(E){R+=" - "+E;}}else{if(E){R=E+" - "+s;}else{R=s;}}return R;};
g.prototype._formatYearPickerText=function(){var i=this._getYearPicker().getDate().getFullYear(),y=this._getYearPicker().getYears(),s=i-Math.floor(y/2),E=i+y/2-1;return""+s+" - "+E;};
g.prototype._formatMonthPickerText=function(){return D.getDateInstance({format:"y"}).format(this.getStartDate());};
g.prototype._showMonthPicker=function(s){var o=this._getFocusedDate(),m=this._getMonthPicker();this.setProperty("_currentPicker","monthPicker");m._setYear(o.getYear());if(!s){m.setMonth(o.getMonth());this._setDisabledMonths(o.getYear(),m);}this._iMode=1;this._togglePrevNext(o,false);this._oPickerBtn.setText(this._formatMonthPickerText());};
g.prototype._showYearPicker=function(){var o=this._getFocusedDate(),y=this._getYearPicker();this.setProperty("_currentPicker","yearPicker");this._togglePrevNexYearPicker();this._iMode=2;y.setDate(o.toLocalJSDate());this._oPickerBtn.setText(this._formatYearPickerText());};
g.prototype._showYearRangePicker=function(){b.prototype._showYearRangePicker.apply(this,arguments);this._oPickerBtn.setVisible(false);};
g.prototype._selectMonth=function(){b.prototype._selectMonth.apply(this,arguments);this._oPickerBtn.setText(this._formatPickerText());this._updateTodayButtonState();};
g.prototype._selectYear=function(){b.prototype._selectYear.apply(this,arguments);this._oPickerBtn.setText(this._formatMonthPickerText());this._showMonthPicker();this._updateTodayButtonState();};
g.prototype._selectYearRange=function(){var y=this.getAggregation("yearRangePicker"),r=y.getRangeSize(),p=this.getPrimaryCalendarType(),s=d.fromLocalJSDate(y.getDate(),p),F=this._getFocusedDate();s.setMonth(F.getMonth(),F.getDate());s.setYear(s.getYear()+Math.floor(r/2));F.setYear(s.getYear());this._setFocusedDate(F);this._showYearPicker();this._oPickerBtn.setVisible(true).setText(this._formatYearPickerText());this._updateTodayButtonState();};
g.prototype._handlePrevious=function(){b.prototype._handlePrevious.apply(this,arguments);this._handleArrowNavigation(-1);};
g.prototype._handleNext=function(){b.prototype._handleNext.apply(this,arguments);this._handleArrowNavigation(1);};
g.prototype._handleArrowNavigation=function(i){var m,y,Y;if(this._iMode===3){Y=this._getYearRangePicker();Y.getDate().setFullYear(Y.getDate().getFullYear()+(i*Y.getYears()));this._oPickerBtn.setText(this._formatYearPickerText());}else if(this._iMode===2){y=this._getYearPicker();y.getDate().setFullYear(y.getDate().getFullYear()+(i*y.getYears()));this._oPickerBtn.setText(this._formatYearPickerText());}else if(this._iMode===1){m=this._getMonthPicker();this._getFocusedDate().setYear(m._iYear);this.getAggregation("month")[0].getDate().setYear(m._iYear);this._oPickerBtn.setText(this._formatMonthPickerText());}else{this._oPickerBtn.setText(this._formatPickerText(this._getFocusedDate().toLocalJSDate()));}this._updateTodayButtonState();};
g.prototype._dateMatchesVisibleRange=function(){var o=d.fromLocalJSDate(new Date()),s,i,y,Y,S;switch(this._iMode){case 0:s=this.getSelectedDates().length?this.getSelectedDates()[0].getStartDate():this.getStartDate();i=s.getDate()===o.getDate();return i&&e._isSameMonthAndYear(d.fromLocalJSDate(this.getStartDate()),o);case 1:return e._isSameMonthAndYear(d.fromLocalJSDate(this.getStartDate()),o);case 2:return e._isSameMonthAndYear(d.fromLocalJSDate(this._getYearPicker().getDate()),o);case 3:y=this._getYearRangePicker();Y=y.getDate();S=new Date(Y.getFullYear()+(y.getRangeSize()/2),Y.getMonth(),Y.getDate());return e._isSameMonthAndYear(d.fromLocalJSDate(S),o);}};
g.prototype._updateTodayButtonState=function(){if(this._oTodayBtn){this._oTodayBtn.setEnabled(!this._dateMatchesVisibleRange());}};
g.prototype._updateHeader=function(){};
g.prototype.onsapescape=function(){this.fireCancel();this._closePickers();this._oPickerBtn.setVisible(true);this._oPickerBtn.setText(this._formatPickerText());};
g.prototype._updateHeadersButtons=function(){};
g.prototype._togglePrevNext=function(){};
g.prototype._togglePrevNexYearPicker=function(){};
g.prototype._initializeSecondMonthHeader=function(){};
g.prototype._updateHeadersYearPrimaryText=function(){};
g.prototype._updateHeadersYearAdditionalText=function(){};
g.prototype._updateActiveHeaderYearButtonVisibility=function(){};
g.prototype._setHeaderText=function(){};
return g;});
sap.ui.predefine('sap/f/CalendarInCardRenderer',['sap/ui/core/Renderer','sap/ui/unified/CalendarRenderer'],function(R,C){"use strict";var a=R.extend(C);a.apiVersion=2;
a.render=function(r,c){var i=c.getId(),t=c.getTooltip_AsString(),m=c.getAggregation("month"),w=c.getWidth(),b=sap.ui.getCore().getLibraryResourceBundle("sap.f"),A={labelledby:{value:"",append:false}};r.openStart("div",c);r.class("sapUiCal");if(m.length>1){r.class("sapUiCalMulti");}r.accessibilityState(c,A);if(t){r.attr("title",t);}if(w){r.class("sapUiCalWidth");r.style("width",w);}if(c._getSecondaryCalendarType()){r.class("sapUiCalSecType");}r.openEnd();var h=c.getAggregation("header");r.renderControl(h);r.openStart("div",i+"-content");r.class("sapUiCalContent");r.openEnd();switch(c.getProperty("_currentPicker")){case"month":r.renderControl(m[0]);break;case"monthPicker":r.renderControl(c._getMonthPicker());break;case"yearPicker":r.renderControl(c._getYearPicker());break;case"yearRangePicker":r.renderControl(c._getYearRangePicker());break;}r.close("div");if(!c._bSkipCancelButtonRendering){r.openStart("button",i+"-cancel");r.class("sapUiCalCancel");r.attr("tabindex","-1");r.openEnd();r.text(b.getText("CALENDAR_CANCEL"));r.close("button");}r.openStart("div",i+"-end");r.attr("tabindex","0");r.style("position","absolute");r.style("width","0");r.style("height","0");r.style("right","0");r.style("bottom","0");r.openEnd();r.close("div");this.renderCalContentAndArrowsOverlay(r,c,i);r.close("div");};
return a;},true);
sap.ui.predefine('sap/f/Card',["sap/f/library","./CardBase","sap/f/CardRenderer"],function(l,C,a){"use strict";var H=l.cards.HeaderPosition;
var b=C.extend("sap.f.Card",{
metadata:{library:"sap.f",properties:{headerPosition:{type:"sap.f.cards.HeaderPosition",group:"Appearance",defaultValue:H.Top}},aggregations:{header:{type:"sap.f.cards.IHeader",multiple:false},content:{type:"sap.ui.core.Control",multiple:false}}},
renderer:a
});
b.prototype.getCardHeader=function(){return this.getHeader();};
b.prototype.getCardHeaderPosition=function(){return this.getHeaderPosition();};
b.prototype.getCardContent=function(){return this.getContent();};
return b;});
sap.ui.predefine('sap/f/CardBase',["sap/ui/core/Control","sap/f/library","sap/m/library","sap/ui/core/InvisibleText","sap/ui/core/Core","sap/m/BadgeEnabler","sap/f/CardRenderer"],function(C,l,L,I,a,B,b){"use strict";var c=L.BadgeState;var d=3000;
var e=C.extend("sap.f.CardBase",{
metadata:{library:"sap.f",interfaces:["sap.f.ICard","sap.m.IBadge"],properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"auto"}},aggregations:{}},
renderer:b
});
B.call(e.prototype);
e.prototype.init=function(){this._oRb=a.getLibraryResourceBundle("sap.f");this._ariaContentText=new I({id:this.getId()+"-ariaContentText"});this._ariaContentText.setText(this._oRb.getText("ARIA_LABEL_CARD_CONTENT"));this._ariaText=new I({id:this.getId()+"-ariaText"});this._ariaText.setText(this._oRb.getText("ARIA_ROLEDESCRIPTION_CARD"));this.initBadgeEnablement();};
e.prototype.exit=function(){this._oRb=null;if(this._ariaContentText){this._ariaContentText.destroy();this._ariaContentText=null;}if(this._ariaText){this._ariaText.destroy();this._ariaText=null;}};
e.prototype.setAggregation=function(A,o){var p;if(A==="header"||A==="_header"){p=this.getAggregation(A);if(p){p.detachEvent("_change",this._onHeaderVisibilityChange,this);}if(o){o.attachEvent("_change",this._onHeaderVisibilityChange,this);}}return C.prototype.setAggregation.apply(this,arguments);};
e.prototype._onHeaderVisibilityChange=function(E){if(E.getParameters().name==="visible"){setTimeout(function(){this.invalidate();}.bind(this),0);}};
e.prototype.getCardHeader=function(){return null;};
e.prototype.getCardHeaderPosition=function(){return null;};
e.prototype.getCardContent=function(){return null;};
e.prototype.getFocusDomRef=function(){return this.getCardHeader()?this.getCardHeader().getDomRef():this.getDomRef();};
e.prototype.onmousedown=function(){this._hideBadge();};
e.prototype.onsapenter=function(){this._hideBadge();};
e.prototype.onfocusin=function(){this._startBadgeHiding();};
e.prototype._startBadgeHiding=function(){if(this._iHideBadgeTimeout){return;}this._iHideBadgeTimeout=setTimeout(this._hideBadge.bind(this),d);};
e.prototype._hideBadge=function(){var o=this.getBadgeCustomData();if(o){o.setVisible(false);}this._iHideBadgeTimeout=null;};
e.prototype.onBadgeUpdate=function(v,s,f){var h=this.getCardHeader(),D,A;if(h){D=h.getDomRef();}else{D=this.getDomRef("contentSection");}if(!D){return;}A=D.getAttribute("aria-labelledby")||"";switch(s){case c.Appear:A=f+" "+A;D.setAttribute("aria-labelledby",A);break;case c.Disappear:A=A.replace(f,"").trim();D.setAttribute("aria-labelledby",A);break;}};
e.prototype.getAriaLabelBadgeText=function(){return this.getBadgeCustomData().getValue();};
e.prototype._getAriaLabelledIds=function(){var h=this.getCardHeader(),A="";if(h&&h._getTitle()){A=h._getTitle().getId();}return A;};
e.prototype.getAriaRoleDescription=function(){var h=this.getCardHeader();if(h){return h.getAriaRoleDescription();}return null;};
return e;});
sap.ui.predefine('sap/f/CardRenderer',["sap/ui/core/Renderer","sap/f/library"],function(R,l){"use strict";var H=l.cards.HeaderPosition;
var C=R.extend("sap.f.CardRenderer",{apiVersion:2});
C.render=function(r,c){var h=c.getCardHeader(),b=h&&c.getCardHeaderPosition()===H.Top;r.openStart("div",c);this.renderContainerAttributes(r,c);r.openEnd();if(b){r.renderControl(h);}this.renderContentSection(r,c);if(!b){r.renderControl(h);}this.renderFooterSection(r,c);r.renderControl(c._ariaText);r.renderControl(c._ariaContentText);r.close("div");};
C.renderContainerAttributes=function(r,c){var h=c.getHeight(),t=c.getTooltip_AsString();var b=!!(c.getCardHeader()&&c.getCardHeader().getVisible()),a=b&&c.getCardHeaderPosition()===H.Bottom;r.class("sapFCard").style("width",c.getWidth());if(!b){r.class("sapFCardNoHeader");}if(!c.getCardContent()){r.class("sapFCardNoContent");}if(a){r.class("sapFCardBottomHeader");}if(h&&h!=="auto"){r.style("height",h);}if(t){r.attr("title",t);}r.accessibilityState(c,{role:"region",labelledby:{value:c._getAriaLabelledIds(),append:true}});};
C.renderContentSection=function(r,c){var o=c.getCardContent();if(o){r.openStart("div",c.getId()+"-contentSection").class("sapFCardContent").accessibilityState(c,{role:"group",labelledby:{value:c.getId()+"-ariaContentText",append:true}}).openEnd();r.renderControl(o);r.close("div");}};
C.renderFooterSection=function(r,c){};
return C;});
sap.ui.predefine('sap/f/DynamicPage',["./library","sap/ui/core/Control","sap/ui/core/Core","sap/m/ScrollBar","sap/m/library","sap/ui/base/ManagedObjectObserver","sap/ui/core/ResizeHandler","sap/ui/core/Configuration","sap/ui/core/delegate/ScrollEnablement","sap/ui/Device","sap/ui/base/ManagedObject","sap/f/DynamicPageTitle","sap/f/DynamicPageHeader","./DynamicPageRenderer","sap/base/Log","sap/ui/core/theming/Parameters",'sap/ui/dom/units/Rem',"sap/ui/core/library"],function(l,C,a,S,L,M,R,b,c,D,d,e,f,g,h,P,i,j){"use strict";var k=L.PageBackgroundDesign;
var m=C.extend("sap.f.DynamicPage",{metadata:{library:"sap.f",properties:{preserveHeaderStateOnScroll:{type:"boolean",group:"Behavior",defaultValue:false},headerExpanded:{type:"boolean",group:"Behavior",defaultValue:true},headerPinned:{type:"boolean",group:"Behavior",defaultValue:false},toggleHeaderOnTitleClick:{type:"boolean",group:"Behavior",defaultValue:true},showFooter:{type:"boolean",group:"Behavior",defaultValue:false},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:k.Standard},fitContent:{type:"boolean",group:"Behavior",defaultValue:false}},associations:{stickySubheaderProvider:{type:"sap.f.IDynamicPageStickyContent",multiple:false}},aggregations:{title:{type:"sap.f.DynamicPageTitle",multiple:false},header:{type:"sap.f.DynamicPageHeader",multiple:false},content:{type:"sap.ui.core.Control",multiple:false},footer:{type:"sap.m.IBar",multiple:false},landmarkInfo:{type:"sap.f.DynamicPageAccessibleLandmarkInfo",multiple:false},_scrollBar:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{pinnedStateChange:{parameters:{pinned:{type:"boolean"}}}},dnd:{draggable:false,droppable:true},designtime:"sap/f/designtime/DynamicPage.designtime"}});
function n(O){if(arguments.length===1){return O&&("length"in O)?O.length>0:!!O;}return Array.prototype.slice.call(arguments).every(function(p){return n(p);});}
function o(E){var p;if(!E){return false;}p=E.getBoundingClientRect();return!!(p.width&&p.height);}
var A=j.AccessibleLandmarkRole;m.HEADER_MAX_ALLOWED_PINNED_PERCENTAGE=0.6;m.HEADER_MAX_ALLOWED_NON_SROLLABLE_PERCENTAGE=0.6;m.HEADER_MAX_ALLOWED_NON_SROLLABLE_ON_MOBILE=0.3;m.BREAK_POINTS={DESKTOP:1439,TABLET:1024,PHONE:600};m.EVENTS={TITLE_PRESS:"_titlePress",TITLE_MOUSE_OVER:"_titleMouseOver",TITLE_MOUSE_OUT:"_titleMouseOut",PIN_UNPIN_PRESS:"_pinUnpinPress",VISUAL_INDICATOR_MOUSE_OVER:"_visualIndicatorMouseOver",VISUAL_INDICATOR_MOUSE_OUT:"_visualIndicatorMouseOut",HEADER_VISUAL_INDICATOR_PRESS:"_headerVisualIndicatorPress",TITLE_VISUAL_INDICATOR_PRESS:"_titleVisualIndicatorPress"};m.MEDIA={PHONE:"sapFDynamicPage-Std-Phone",TABLET:"sapFDynamicPage-Std-Tablet",DESKTOP:"sapFDynamicPage-Std-Desktop",DESKTOP_XL:"sapFDynamicPage-Std-Desktop-XL"};m.RESIZE_HANDLER_ID={PAGE:"_sResizeHandlerId",TITLE:"_sTitleResizeHandlerId",HEADER:"_sHeaderResizeHandlerId",CONTENT:"_sContentResizeHandlerId"};m.DIV="div";m.HEADER="header";m.FOOTER="footer";m.HEADER_CONTENT_PADDING_BOTTOM=i.toPx("1rem");m.SHOW_FOOTER_CLASS_NAME="sapFDynamicPageActualFooterControlShow";m.HIDE_FOOTER_CLASS_NAME="sapFDynamicPageActualFooterControlHide";m.NAVIGATION_CLASS_NAME="sapFDynamicPageNavigation";m.ARIA_ROLE_DESCRIPTION="DYNAMIC_PAGE_ROLE_DESCRIPTION";
m.prototype.init=function(){this._bPinned=false;this._bHeaderInTitleArea=false;this._bExpandingWithAClick=false;this._bSuppressToggleHeaderOnce=false;this._headerBiggerThanAllowedHeight=false;this._oStickySubheader=null;this._bStickySubheaderInTitleArea=false;this._oScrollHelper=new c(this,this.getId()+"-content",{horizontal:false,vertical:true});this._oScrollHelper.setOnAfterScrollToElement(this._onAfterScrollToElement.bind(this));this._oStickyHeaderObserver=null;this._oHeaderObserver=null;this._oSubHeaderAfterRenderingDelegate={onAfterRendering:function(){this._bStickySubheaderInTitleArea=false;this._adjustStickyContent();}};this._setAriaRoleDescription(a.getLibraryResourceBundle("sap.f").getText(m.ARIA_ROLE_DESCRIPTION));};
m.prototype.onBeforeRendering=function(){if(!this._preserveHeaderStateOnScroll()){this._attachPinPressHandler();}this._attachTitlePressHandler();this._attachVisualIndicatorsPressHandlers();if(D.system.desktop){this._attachVisualIndicatorMouseOverHandlers();this._attachTitleMouseOverHandlers();}this._attachHeaderObserver();this._addStickySubheaderAfterRenderingDelegate();this._detachScrollHandler();this._detachResizeHandlers();this._toggleAdditionalNavigationClass();};
m.prototype.onAfterRendering=function(){var s,p;if(this.getPreserveHeaderStateOnScroll()){setTimeout(this._overridePreserveHeaderStateOnScroll.bind(this),0);}this._cacheDomElements();this._attachResizeHandlers();this._updateMedia(this._getWidth(this));this._attachScrollHandler();this._updateScrollBar();this._attachPageChildrenAfterRenderingDelegates();this._updatePinButtonState();this._hidePinButtonIfNotApplicable();if(!this.getHeaderExpanded()){this._snapHeader(false);s=this.getHeader()&&!this.getPreserveHeaderStateOnScroll()&&this._canSnapHeaderOnScroll();if(s){p=this._getScrollBar().getScrollPosition();this._setScrollPosition(p?p:this._getSnappingHeight());}else{this._toggleHeaderVisibility(false);this._moveHeaderToTitleArea();}}this._updateToggleHeaderVisualIndicators();this._updateTitleVisualState();};
m.prototype.exit=function(){this._detachResizeHandlers();if(this._oScrollHelper){this._oScrollHelper.destroy();}if(this._oStickyHeaderObserver){this._oStickyHeaderObserver.disconnect();}if(this._oHeaderObserver){this._oHeaderObserver.disconnect();}if(this._oStickySubheader){this._oStickySubheader.removeEventDelegate(this._oSubHeaderAfterRenderingDelegate);}};
m.prototype.setShowFooter=function(s){var r=this.setProperty("showFooter",s,true);this._toggleFooter(s);return r;};
m.prototype.setHeader=function(H){var O=this.getHeader();if(H===O){return this;}if(O){if(this._oStickyHeaderObserver){this._oStickyHeaderObserver.disconnect();}if(this._oHeaderObserver){this._oHeaderObserver.disconnect();}this._deRegisterResizeHandler(m.RESIZE_HANDLER_ID.HEADER);O.detachEvent(m.EVENTS.PIN_UNPIN_PRESS,this._onPinUnpinButtonPress);this._bAlreadyAttachedPinPressHandler=false;O.detachEvent(m.EVENTS.HEADER_VISUAL_INDICATOR_PRESS,this._onCollapseHeaderVisualIndicatorPress);this._bAlreadyAttachedHeaderIndicatorPressHandler=false;O.detachEvent(m.EVENTS.VISUAL_INDICATOR_MOUSE_OVER,this._onVisualIndicatorMouseOver);O.detachEvent(m.EVENTS.VISUAL_INDICATOR_MOUSE_OUT,this._onVisualIndicatorMouseOut);this._bAlreadyAttachedVisualIndicatorMouseOverOutHandler=false;this._bAlreadyAttachedStickyHeaderObserver=false;this._bAlreadyAttachedHeaderObserver=false;}this.setAggregation("header",H);return this;};
m.prototype.setStickySubheaderProvider=function(s){var O,p=this.getStickySubheaderProvider();if(s===p){return this;}O=a.byId(p);if(this._oStickySubheader&&O){O._returnStickyContent();O._setStickySubheaderSticked(false);this._oStickySubheader.removeEventDelegate(this._oSubHeaderAfterRenderingDelegate);this._bAlreadyAddedStickySubheaderAfterRenderingDelegate=false;this._oStickySubheader=null;}this.setAssociation("stickySubheaderProvider",s);return this;};
m.prototype.setHeaderExpanded=function(H){H=this.validateProperty("headerExpanded",H);if(this._bPinned){return this;}if(this.getHeaderExpanded()===H){return this;}if(this.getDomRef()){this._titleExpandCollapseWhenAllowed();}this.setProperty("headerExpanded",H,true);this._updatePinButtonState();return this;};
m.prototype.setToggleHeaderOnTitleClick=function(t){var H=this.getHeaderExpanded(),r=this.setProperty("toggleHeaderOnTitleClick",t,true);t=this.getProperty("toggleHeaderOnTitleClick");this._updateTitleVisualState();this._updateToggleHeaderVisualIndicators();this._updateARIAStates(H);return r;};
m.prototype.setFitContent=function(F){var r=this.setProperty("fitContent",F,true);if(n(this.$())){this._updateFitContainer();}return r;};
m.prototype.getScrollDelegate=function(){return this._oScrollHelper;};
m.prototype._onAfterScrollToElement=function(){var s=this.$wrapper.scrollTop(),w=this._bStickySubheaderInTitleArea;this._toggleHeaderOnScroll();if(this._bStickySubheaderInTitleArea&&!w&&this.$wrapper.scrollTop()===s){this.$wrapper.scrollTop(s-this._getHeight(this._oStickySubheader));}};
m.prototype._overridePreserveHeaderStateOnScroll=function(){var O=this._headerBiggerThanAllowedHeight,p;this._headerBiggerThanAllowedHeight=this._headerBiggerThanAllowedToBeFixed();p=O!==this._headerBiggerThanAllowedHeight;if(!this._headerBiggerThanAllowedHeight||!p){return;}if(this.getHeaderExpanded()){this._moveHeaderToContentArea();}else{this._adjustSnap();}this._updateScrollBar();};
m.prototype._toggleFooter=function(s){var F=this.getFooter(),u,p;if(!n(this.$())||!n(F)||!n(this.$footerWrapper)){return;}p=a.getConfiguration().getAnimationMode();u=p!==b.AnimationMode.none&&p!==b.AnimationMode.minimal;if(n(this.$contentFitContainer)){this.$contentFitContainer.toggleClass("sapFDynamicPageContentFitContainerFooterVisible",s);}if(u){this._toggleFooterAnimation(s,F);}else{this.$footerWrapper.toggleClass("sapUiHidden",!s);}this._updateScrollBar();};
m.prototype._toggleFooterAnimation=function(s,F){this.$footerWrapper.on("webkitAnimationEnd animationend",this._onToggleFooterAnimationEnd.bind(this,F));if(s){this.$footerWrapper.removeClass("sapUiHidden");}F.toggleStyleClass(m.SHOW_FOOTER_CLASS_NAME,s);F.toggleStyleClass(m.HIDE_FOOTER_CLASS_NAME,!s);};
m.prototype._onToggleFooterAnimationEnd=function(F){this.$footerWrapper.off("webkitAnimationEnd animationend");if(F.hasStyleClass(m.HIDE_FOOTER_CLASS_NAME)){this.$footerWrapper.addClass("sapUiHidden");F.removeStyleClass(m.HIDE_FOOTER_CLASS_NAME);}else{F.removeStyleClass(m.SHOW_FOOTER_CLASS_NAME);}};
m.prototype._toggleHeaderInTabChain=function(t){var p=this.getTitle(),q=this.getHeader();if(!n(p)||!n(q)){return;}q.$().css("visibility",t?"visible":"hidden");};
m.prototype._snapHeader=function(p,u){var q=this.getTitle();if(this._bPinned&&!u){h.debug("DynamicPage :: aborted snapping, header is pinned",this);return;}h.debug("DynamicPage :: snapped header",this);if(this._bPinned&&u){this._unPin(u);this._togglePinButtonPressedState(false);}if(n(q)){q._toggleState(false,u);if(p&&this._bHeaderInTitleArea){this._moveHeaderToContentArea(true);}}if(!n(this.$titleArea)){h.warning("DynamicPage :: couldn't snap header. There's no title.",this);return;}this.setProperty("headerExpanded",false,true);if(this._hasVisibleTitleAndHeader()){this.$titleArea.addClass(D.system.phone&&q.getSnappedTitleOnMobile()?"sapFDynamicPageTitleSnappedTitleOnMobile":"sapFDynamicPageTitleSnapped");this._updateToggleHeaderVisualIndicators();this._togglePinButtonVisibility(false);}this._toggleHeaderInTabChain(false);this._updateARIAStates(false);this._toggleHeaderBackground(true);};
m.prototype._expandHeader=function(p,u){var q=this.getTitle();h.debug("DynamicPage :: expand header",this);if(n(q)){q._toggleState(true,u);if(p){this._moveHeaderToTitleArea(true);}}if(!n(this.$titleArea)){h.warning("DynamicPage :: couldn't expand header. There's no title.",this);return;}this.setProperty("headerExpanded",true,true);if(this._hasVisibleTitleAndHeader()){this.$titleArea.removeClass(D.system.phone&&q.getSnappedTitleOnMobile()?"sapFDynamicPageTitleSnappedTitleOnMobile":"sapFDynamicPageTitleSnapped");this._updateToggleHeaderVisualIndicators();if(!this.getPreserveHeaderStateOnScroll()&&!this._headerBiggerThanAllowedToPin()){this._togglePinButtonVisibility(true);}}this._toggleHeaderInTabChain(true);this._updateARIAStates(true);this._toggleHeaderBackground(false);};
m.prototype._toggleHeaderVisibility=function(s,u){var E=this.getHeaderExpanded(),p=this.getTitle(),q=this.getHeader();if(this._bPinned&&!u){h.debug("DynamicPage :: header toggle aborted, header is pinned",this);return;}if(n(p)){p._toggleState(E);}if(n(q)){q.$().toggleClass("sapFDynamicPageHeaderHidden",!s);this._updateScrollBar();}};
m.prototype._toggleHeaderBackground=function(s){this.$headerInContentWrapper.toggleClass("sapFDynamicPageHeaderSolid",s);};
m.prototype._moveHeaderToContentArea=function(O){var p=this.getHeader();if(n(p)){p.$().prependTo(this.$headerInContentWrapper);this._bHeaderInTitleArea=false;if(O){this._offsetContentOnMoveHeader();}this.fireEvent("_moveHeader");}};
m.prototype._moveHeaderToTitleArea=function(O){var p=this.getHeader();if(n(p)){p.$().prependTo(this.$stickyPlaceholder);this._bHeaderInTitleArea=true;if(O){this._offsetContentOnMoveHeader();}this.fireEvent("_moveHeader");}};
m.prototype._offsetContentOnMoveHeader=function(){var O=Math.ceil(this._getHeaderHeight()),p=this._getScrollPosition(),q=this._getScrollBar().getScrollPosition(),N;if(!O){return;}if(!p&&q){N=this._getScrollBar().getScrollPosition();}else{N=this._bHeaderInTitleArea?p-O:p+O;}N=Math.max(N,0);this._setScrollPosition(N,true);};
m.prototype._isHeaderPinnable=function(){var H=this.getHeader();return H&&H.getPinnable()&&this.getHeaderExpanded()&&!this.getPreserveHeaderStateOnScroll();};
m.prototype._updatePinButtonState=function(){var s=this.getHeaderPinned()&&this._isHeaderPinnable();this._togglePinButtonPressedState(s);if(s){this._pin();}else{this._unPin();}};
m.prototype._pin=function(u){if(this._bPinned){return;}this._bPinned=true;if(u){this.setProperty("headerPinned",true,true);this.fireEvent("pinnedStateChange",{pinned:true});}if(!this._bHeaderInTitleArea){this._moveHeaderToTitleArea(true);this._updateScrollBar();}this._updateToggleHeaderVisualIndicators();this.addStyleClass("sapFDynamicPageHeaderPinned");};
m.prototype._unPin=function(u){if(!this._bPinned){return;}this._bPinned=false;if(u){this.setProperty("headerPinned",false,true);this.fireEvent("pinnedStateChange",{pinned:false});}this._updateToggleHeaderVisualIndicators();this.removeStyleClass("sapFDynamicPageHeaderPinned");};
m.prototype._togglePinButtonVisibility=function(t){var p=this.getHeader();if(n(p)){p._setShowPinBtn(t);}};
m.prototype._togglePinButtonPressedState=function(p){var q=this.getHeader();if(n(q)){q._togglePinButton(p);}};
m.prototype._hidePinButtonIfNotApplicable=function(){if(this._preserveHeaderStateOnScroll()){this._togglePinButtonVisibility(false);}};
m.prototype._isHeaderPinnable=function(){var H=this.getHeader();return H&&H.getPinnable()&&this.getHeaderExpanded()&&!this.getPreserveHeaderStateOnScroll();};
m.prototype._restorePinButtonFocus=function(){this.getHeader()._focusPinButton();};
m.prototype._getScrollPosition=function(){return n(this.$wrapper)?Math.ceil(this.$wrapper.scrollTop()):0;};
m.prototype._setAriaRoleDescription=function(s){this._sAriaRoleDescription=s;return this;};
m.prototype._getAriaRoleDescription=function(){return this._sAriaRoleDescription;};
m.prototype._setScrollPosition=function(N,s){if(!n(this.$wrapper)){return;}if(this._getScrollPosition()===N){return;}if(s){this._bSuppressToggleHeaderOnce=true;}if(!this.getScrollDelegate()._$Container){this.getScrollDelegate()._$Container=this.$wrapper;}this.getScrollDelegate().scrollTo(0,N);};
m.prototype._shouldSnapOnScroll=function(){return!this._preserveHeaderStateOnScroll()&&this._getScrollPosition()>=this._getSnappingHeight()&&this.getHeaderExpanded()&&!this._bPinned;};
m.prototype._shouldExpandOnScroll=function(){var I=this._needsVerticalScrollBar();return!this._preserveHeaderStateOnScroll()&&this._getScrollPosition()<this._getSnappingHeight()&&!this.getHeaderExpanded()&&!this._bPinned&&I;};
m.prototype._shouldStickStickyContent=function(){var I,s,p;p=this._getScrollPosition();I=p<this._getSnappingHeight()&&!this._bPinned&&!this.getPreserveHeaderStateOnScroll();s=p===0||I&&this._hasVisibleHeader();return!s;};
m.prototype._headerScrolledOut=function(){return this._getScrollPosition()>=this._getSnappingHeight();};
m.prototype._headerSnapAllowed=function(){return!this._preserveHeaderStateOnScroll()&&this.getHeaderExpanded()&&!this._bPinned;};
m.prototype._canSnapHeaderOnScroll=function(){return this._getMaxScrollPosition()>this._getSnappingHeight();};
m.prototype._getSnappingHeight=function(){var t=this.getTitle(),$=t&&t.$expandWrapper,p=t&&t.$snappedWrapper,q=t&&t.$expandHeadingWrapper,r=t&&t.$snappedHeadingWrapper,E=$&&$.length?$.height():0,s=r&&r.length?r.height():0,u=q&&q.length?q.height():0,v=p&&p.length?p.height():0,w=Math.ceil(this._getHeaderHeight()||E+v+s+u)-m.HEADER_CONTENT_PADDING_BOTTOM;return w>0?w:0;};
m.prototype._getMaxScrollPosition=function(){var $,p;if(n(this.$wrapper)){$=this.$wrapper[0];p=Math.max($.clientHeight,Math.ceil($.getBoundingClientRect().height));return $.scrollHeight-p;}return 0;};
m.prototype._needsVerticalScrollBar=function(){return Math.floor(this._getMaxScrollPosition())>0;};
m.prototype._getOwnHeight=function(){return this._getHeight(this);};
m.prototype._getEntireHeaderHeight=function(){var t=0,H=0,p=this.getTitle(),q=this.getHeader();if(n(p)){t=p.$().outerHeight();}if(n(q)){H=q.$().outerHeight();}return t+H;};
m.prototype._headerBiggerThanAllowedToPin=function(p){if(!(typeof p==="number"&&!isNaN(parseInt(p)))){p=this._getOwnHeight();}return this._getEntireHeaderHeight()>m.HEADER_MAX_ALLOWED_PINNED_PERCENTAGE*p;};
m.prototype._headerBiggerThanAllowedToBeFixed=function(){var p=this._getOwnHeight();return this._getEntireHeaderHeight()>m.HEADER_MAX_ALLOWED_NON_SROLLABLE_PERCENTAGE*p;};
m.prototype._headerBiggerThanAllowedToBeExpandedInTitleArea=function(){var E=this._getEntireHeaderHeight(),p=this._getOwnHeight();if(p===0){return false;}return D.system.phone?E>=m.HEADER_MAX_ALLOWED_NON_SROLLABLE_ON_MOBILE*p:E>=p;};
m.prototype._measureScrollBarOffsetHeight=function(){var H=0,s=!this.getHeaderExpanded(),p=this._bHeaderInTitleArea,$=this._oStickySubheader&&this._oStickySubheader.$();if(this._preserveHeaderStateOnScroll()||this._bPinned||(!s&&this._bHeaderInTitleArea)){H=this._getTitleAreaHeight();h.debug("DynamicPage :: preserveHeaderState is enabled or header pinned :: title area height"+H,this);return H;}if(s||!n(this.getTitle())||!this._canSnapHeaderOnScroll()){H=this._getTitleHeight();if(this._bStickySubheaderInTitleArea&&$.length){H+=$.height();}h.debug("DynamicPage :: header snapped :: title height "+H,this);return H;}this._snapHeader(true);H=this._getTitleHeight();if(!s){this._expandHeader(p);}h.debug("DynamicPage :: snapped mode :: title height "+H,this);return H;};
m.prototype._updateScrollBar=function(){var s,p,N;if(!n(this.$wrapper)||(this._getHeight(this)===0)){return;}if(!D.system.desktop){setTimeout(this._updateFitContainer.bind(this),0);return;}s=this._getScrollBar();s.setContentSize(this._measureScrollBarOffsetHeight()+this.$wrapper[0].scrollHeight+"px");p=this._needsVerticalScrollBar();N=this.bHasScrollbar!==p;if(N){s.toggleStyleClass("sapUiHidden",!p);this.toggleStyleClass("sapFDynamicPageWithScroll",p);this.bHasScrollbar=p;}setTimeout(this._updateFitContainer.bind(this),0);};
m.prototype._updateFitContainer=function(N){var p=typeof N!=='undefined'?!N:!this._needsVerticalScrollBar(),F=this.getFitContent(),t=F||p;this.$contentFitContainer.toggleClass("sapFDynamicPageContentFitContainer",t);};
m.prototype._updateHeaderARIAState=function(E){var p=this.getHeader();if(n(p)){p._updateARIAState(E);}};
m.prototype._updateTitleARIAState=function(E){var p=this.getTitle();if(n(p)){p._updateARIAState(E);}};
m.prototype._updateARIAStates=function(E){this._updateHeaderARIAState(E);this._updateTitleARIAState(E);};
m.prototype._applyContextualSettings=function(p){var q=p.contextualWidth;this._updateMedia(q);return d.prototype._applyContextualSettings.call(this,p);};
m.prototype._updateMedia=function(w){if(!w){return;}if(w<=m.BREAK_POINTS.PHONE){this._updateMediaStyle(m.MEDIA.PHONE);}else if(w<=m.BREAK_POINTS.TABLET){this._updateMediaStyle(m.MEDIA.TABLET);}else if(w<=m.BREAK_POINTS.DESKTOP){this._updateMediaStyle(m.MEDIA.DESKTOP);}else{this._updateMediaStyle(m.MEDIA.DESKTOP_XL);}};
m.prototype._updateMediaStyle=function(s){Object.keys(m.MEDIA).forEach(function(p){var E=s===m.MEDIA[p];this.toggleStyleClass(m.MEDIA[p],E);},this);};
m.prototype._toggleExpandVisualIndicator=function(t){var p=this.getTitle();if(n(p)){p._toggleExpandButton(t);}};
m.prototype._focusExpandVisualIndicator=function(){var p=this.getTitle();if(n(p)){p._focusExpandButton();}};
m.prototype._toggleCollapseVisualIndicator=function(t){var p=this.getHeader();if(n(p)){p._toggleCollapseButton(t);}};
m.prototype._focusCollapseVisualIndicator=function(){var p=this.getHeader();if(n(p)){p._focusCollapseButton();}};
m.prototype._updateToggleHeaderVisualIndicators=function(){var H,p,E,q=this._hasVisibleTitleAndHeader(),r=this.getHeader(),s=false;if(n(r)){s=!!r.getContent().length;}if(!this.getToggleHeaderOnTitleClick()||!q){p=false;E=false;}else{H=this.getHeaderExpanded();p=H;E=D.system.phone&&this.getTitle().getAggregation("snappedTitleOnMobile")?false:!H;}E=E&&s;p=p&&s;this._toggleCollapseVisualIndicator(p);this._toggleExpandVisualIndicator(E);this._updateTitleVisualState();};
m.prototype._updateHeaderVisualState=function(H,p){var q=this.getHeader();if(H&&this.getPreserveHeaderStateOnScroll()){this._overridePreserveHeaderStateOnScroll();}if(!this._preserveHeaderStateOnScroll()&&q){if(this._headerBiggerThanAllowedToPin(p)||D.system.phone){this._unPin();this._togglePinButtonVisibility(false);this._togglePinButtonPressedState(false);}else{this._togglePinButtonVisibility(true);this._updatePinButtonState();}if(this.getHeaderExpanded()&&this._bHeaderInTitleArea&&this._headerBiggerThanAllowedToBeExpandedInTitleArea()){this._expandHeader(false);this._setScrollPosition(0);}}else if(this._preserveHeaderStateOnScroll()&&q){this._togglePinButtonVisibility(false);}};
m.prototype._updateTitleVisualState=function(){var t=this.getTitle(),T=this._hasVisibleTitleAndHeader()&&this.getToggleHeaderOnTitleClick();this.$().toggleClass("sapFDynamicPageTitleClickEnabled",T&&!D.system.phone);if(n(t)){t._toggleFocusableState(T);}};
m.prototype._scrollBellowCollapseVisualIndicator=function(){var H=this.getHeader(),$,p,v,O;if(n(H)){$=this.getHeader()._getCollapseButton().getDomRef();p=$.getBoundingClientRect().height;v=this.$wrapper[0].getBoundingClientRect().height;O=$.offsetTop+p-v;this._setScrollPosition(O);}};
m.prototype._hasVisibleTitleAndHeader=function(){var t=this.getTitle();return n(t)&&t.getVisible()&&this._hasVisibleHeader();};
m.prototype._hasVisibleHeader=function(){var H=this.getHeader();return n(H)&&H.getVisible()&&n(H.getContent());};
m.prototype._getHeight=function(p){var $;if(!(p instanceof C)){return 0;}$=p.getDomRef();return $?$.getBoundingClientRect().height:0;};
m.prototype._getWidth=function(p){return!(p instanceof C)?0:p.$().outerWidth()||0;};
m.prototype._getTitleAreaHeight=function(){return n(this.$titleArea)?this.$titleArea.outerHeight()||0:0;};
m.prototype._getTitleHeight=function(){return this._getHeight(this.getTitle());};
m.prototype._getHeaderHeight=function(){return this._getHeight(this.getHeader());};
m.prototype._preserveHeaderStateOnScroll=function(){return this.getPreserveHeaderStateOnScroll()&&!this._headerBiggerThanAllowedHeight;};
m.prototype._getScrollBar=function(){if(!n(this.getAggregation("_scrollBar"))){var v=new S(this.getId()+"-vertSB",{scrollPosition:0,scroll:this._onScrollBarScroll.bind(this)});this.setAggregation("_scrollBar",v,true);}return this.getAggregation("_scrollBar");};
m.prototype._cacheDomElements=function(){var F=this.getFooter();if(n(F)){this.$footer=F.$();this.$footerWrapper=this.$("footerWrapper");}this.$wrapper=this.$("contentWrapper");this.$headerInContentWrapper=this.$("headerWrapper");this.$contentFitContainer=this.$("contentFitContainer");this.$titleArea=this.$("header");this.$stickyPlaceholder=this.$("stickyPlaceholder");this._cacheTitleDom();this._cacheHeaderDom();};
m.prototype._cacheTitleDom=function(){var t=this.getTitle();if(n(t)){this.$title=t.$();}};
m.prototype._cacheHeaderDom=function(){var H=this.getHeader();if(n(H)){this.$header=H.$();}};
m.prototype._adjustSnap=function(){var p,I,q,r,s,t,$=this.$();if(!n($)){return;}if(!o($[0])){return;}p=this.getHeader();I=!this.getHeaderExpanded();if(!p||!I){return;}q=!this._preserveHeaderStateOnScroll()&&this._canSnapHeaderOnScroll();r=I&&p.$().hasClass("sapFDynamicPageHeaderHidden");if(q&&r){this._toggleHeaderVisibility(true);this._moveHeaderToContentArea(true);return;}if(!q&&!r){this._moveHeaderToTitleArea(true);this._toggleHeaderVisibility(false);return;}if(q){s=this._getScrollPosition();t=this._getSnappingHeight();if(s<t){this._setScrollPosition(t);}}};
m.prototype.ontouchmove=function(E){E.setMarked();};
m.prototype._onChildControlAfterRendering=function(E){var s=E.srcControl;if(s instanceof e){this._cacheTitleDom();this._deRegisterResizeHandler(m.RESIZE_HANDLER_ID.TITLE);this._registerResizeHandler(m.RESIZE_HANDLER_ID.TITLE,this.$title[0],this._onChildControlsHeightChange.bind(this));}else if(s instanceof f&&s.getDomRef()!==this.$header.get(0)){this._cacheHeaderDom();this._deRegisterResizeHandler(m.RESIZE_HANDLER_ID.HEADER);this._registerResizeHandler(m.RESIZE_HANDLER_ID.HEADER,this.$header[0],this._onChildControlsHeightChange.bind(this));}setTimeout(this._updateScrollBar.bind(this),0);};
m.prototype._onChildControlsHeightChange=function(E){var N=this._needsVerticalScrollBar(),H=this.getHeader(),p,O;if(N){this._updateFitContainer(N);}this._adjustSnap();if(!this._bExpandingWithAClick){this._updateScrollBar();}this._bExpandingWithAClick=false;if(H&&E.target.id===H.getId()){p=E.size.height;O=E.oldSize.height;this._updateHeaderVisualState(p!==O);this._adaptScrollPositionOnHeaderChange(p,O);}};
m.prototype._onResize=function(E){var p=this.getTitle(),q=E.size.width,r=E.size.height,H=r!==E.oldSize.height;this._updateHeaderVisualState(H,r);if(n(p)){p._onResize(q);}this._adjustSnap();this._updateScrollBar();this._updateMedia(q);};
m.prototype._onWrapperScroll=function(E){var s=Math.max(E.target.scrollTop,0);if(D.system.desktop){if(this.allowCustomScroll===true){this.allowCustomScroll=false;return;}this.allowInnerDiv=true;this._getScrollBar().setScrollPosition(s);this.toggleStyleClass("sapFDynamicPageWithScroll",this._needsVerticalScrollBar());}};
m.prototype._toggleHeaderOnScroll=function(){this._adjustStickyContent();if(this._bSuppressToggleHeaderOnce){this._bSuppressToggleHeaderOnce=false;return;}if(D.system.desktop&&this._bExpandingWithAClick){return;}if(this._preserveHeaderStateOnScroll()){return;}if(this._shouldSnapOnScroll()){this._snapHeader(true,true);}else if(this._shouldExpandOnScroll()){this._expandHeader(false,true);this._toggleHeaderVisibility(true);}else if(!this._bPinned&&this._bHeaderInTitleArea){var p=(this._getScrollPosition()>=this._getSnappingHeight());this._moveHeaderToContentArea(p);}};
m.prototype._adjustStickyContent=function(){if(!this._oStickySubheader){return;}var p,s=this._shouldStickStickyContent(),q,r=this.getStickySubheaderProvider();if(s===this._bStickySubheaderInTitleArea){return;}q=a.byId(r);if(!n(q)){return;}p=document.activeElement;q._setStickySubheaderSticked(s);if(s){this._oStickySubheader.$().appendTo(this.$stickyPlaceholder);}else{q._returnStickyContent();}p.focus();this._bStickySubheaderInTitleArea=s;};
m.prototype._onScrollBarScroll=function(){if(this.allowInnerDiv===true){this.allowInnerDiv=false;return;}this.allowCustomScroll=true;this._setScrollPosition(this._getScrollBar().getScrollPosition());};
m.prototype._adaptScrollPositionOnHeaderChange=function(N,O){var H=N-O,p=this.getHeader();if(H&&(!this.getHeaderExpanded()&&(p.$().css("visibility")!=="hidden"))&&!this._bHeaderInTitleArea&&this._needsVerticalScrollBar()){this._setScrollPosition(this._getScrollPosition()+H);}};
m.prototype._onTitlePress=function(){if(this.getToggleHeaderOnTitleClick()&&this._hasVisibleTitleAndHeader()){this._titleExpandCollapseWhenAllowed(true);this.getTitle()._focus();}};
m.prototype._onExpandHeaderVisualIndicatorPress=function(){this._onTitlePress();if(this._headerBiggerThanAllowedToBeExpandedInTitleArea()){this._scrollBellowCollapseVisualIndicator();}this._focusCollapseVisualIndicator();};
m.prototype._onCollapseHeaderVisualIndicatorPress=function(){this._onTitlePress();this._focusExpandVisualIndicator();};
m.prototype._onVisualIndicatorMouseOver=function(){var $=this.$();if(n($)){$.addClass("sapFDynamicPageTitleForceHovered");}};
m.prototype._onVisualIndicatorMouseOut=function(){var $=this.$();if(n($)){$.removeClass("sapFDynamicPageTitleForceHovered");}};
m.prototype._onTitleMouseOver=m.prototype._onVisualIndicatorMouseOver;m.prototype._onTitleMouseOut=m.prototype._onVisualIndicatorMouseOut;
m.prototype._titleExpandCollapseWhenAllowed=function(u){var p,s;if(this._bPinned&&!u){return this;}if(this._preserveHeaderStateOnScroll()||!this._canSnapHeaderOnScroll()||!this.getHeader()){if(!this.getHeaderExpanded()){this._expandHeader(false,u);this._toggleHeaderVisibility(true,u);}else{this._snapHeader(false,u);this._toggleHeaderVisibility(false,u);}}else if(!this.getHeaderExpanded()){p=!this._headerBiggerThanAllowedToBeExpandedInTitleArea();this._bExpandingWithAClick=true;this._expandHeader(p,u);this.getHeader().$().removeClass("sapFDynamicPageHeaderHidden");if(!p){this._setScrollPosition(0);}this._bExpandingWithAClick=false;}else{var q=this._bHeaderInTitleArea;this._snapHeader(q,u);if(!q){s=this._getSnappingHeight();this._setScrollPosition(s?(s+m.HEADER_CONTENT_PADDING_BOTTOM):0);}}};
m.prototype._onPinUnpinButtonPress=function(){if(this._bPinned){this._unPin(true);}else{this._pin(true);this._restorePinButtonFocus();}};
m.prototype._attachResizeHandlers=function(){var p=this._onChildControlsHeightChange.bind(this);this._registerResizeHandler(m.RESIZE_HANDLER_ID.PAGE,this,this._onResize.bind(this));if(n(this.$title)){this._registerResizeHandler(m.RESIZE_HANDLER_ID.TITLE,this.$title[0],p);}if(n(this.$header)){this._registerResizeHandler(m.RESIZE_HANDLER_ID.HEADER,this.$header[0],p);}if(n(this.$contentFitContainer)){this._registerResizeHandler(m.RESIZE_HANDLER_ID.CONTENT,this.$contentFitContainer[0],p);}};
m.prototype._registerResizeHandler=function(H,O,p){if(!this[H]){this[H]=R.register(O,p);}};
m.prototype._detachResizeHandlers=function(){this._deRegisterResizeHandler(m.RESIZE_HANDLER_ID.PAGE);this._deRegisterResizeHandler(m.RESIZE_HANDLER_ID.TITLE);this._deRegisterResizeHandler(m.RESIZE_HANDLER_ID.HEADER);this._deRegisterResizeHandler(m.RESIZE_HANDLER_ID.CONTENT);};
m.prototype._deRegisterResizeHandler=function(H){if(this[H]){R.deregister(this[H]);this[H]=null;}};
m.prototype._attachPageChildrenAfterRenderingDelegates=function(){var t=this.getTitle(),H=this.getHeader(),p=this.getContent(),q={onAfterRendering:this._onChildControlAfterRendering.bind(this)};if(n(t)){t.addEventDelegate(q);}if(n(p)){p.addEventDelegate(q);}if(n(H)){H.addEventDelegate(q);}};
m.prototype._attachTitlePressHandler=function(){var t=this.getTitle();if(n(t)&&!this._bAlreadyAttachedTitlePressHandler){t.attachEvent(m.EVENTS.TITLE_PRESS,this._onTitlePress,this);this._bAlreadyAttachedTitlePressHandler=true;}};
m.prototype._attachPinPressHandler=function(){var H=this.getHeader();if(n(H)&&!this._bAlreadyAttachedPinPressHandler){H.attachEvent(m.EVENTS.PIN_UNPIN_PRESS,this._onPinUnpinButtonPress,this);this._bAlreadyAttachedPinPressHandler=true;}};
m.prototype._attachStickyHeaderObserver=function(){var H=this.getHeader();if(n(H)&&!this._bAlreadyAttachedStickyHeaderObserver){if(!this._oStickyHeaderObserver){this._oStickyHeaderObserver=new M(this._adjustStickyContent.bind(this));}this._oStickyHeaderObserver.observe(H,{properties:["visible"]});this._bAlreadyAttachedStickyHeaderObserver=true;}};
m.prototype._attachHeaderObserver=function(){var H=this.getHeader();if(n(H)&&!this._bAlreadyAttachedHeaderObserver){if(!this._oHeaderObserver){this._oHeaderObserver=new M(this._onHeaderFieldChange.bind(this));}this._oHeaderObserver.observe(H,{aggregations:["content"],properties:["visible","pinnable"]});this._bAlreadyAttachedHeaderObserver=true;}};
m.prototype._onHeaderFieldChange=function(E){if((E.type==="property")&&(E.name==="pinnable")){this._updatePinButtonState();return;}this._updateToggleHeaderVisualIndicators();};
m.prototype._attachVisualIndicatorsPressHandlers=function(){var t=this.getTitle(),H=this.getHeader();if(n(t)&&!this._bAlreadyAttachedTitleIndicatorPressHandler){t.attachEvent(m.EVENTS.TITLE_VISUAL_INDICATOR_PRESS,this._onExpandHeaderVisualIndicatorPress,this);this._bAlreadyAttachedTitleIndicatorPressHandler=true;}if(n(H)&&!this._bAlreadyAttachedHeaderIndicatorPressHandler){H.attachEvent(m.EVENTS.HEADER_VISUAL_INDICATOR_PRESS,this._onCollapseHeaderVisualIndicatorPress,this);this._bAlreadyAttachedHeaderIndicatorPressHandler=true;}};
m.prototype._addStickySubheaderAfterRenderingDelegate=function(){var s,p=this.getStickySubheaderProvider(),I;s=a.byId(p);if(n(s)&&!this._bAlreadyAddedStickySubheaderAfterRenderingDelegate){I=s.getMetadata().getInterfaces().indexOf("sap.f.IDynamicPageStickyContent")!==-1;if(I){this._oStickySubheader=s._getStickyContent();this._oStickySubheader.addEventDelegate(this._oSubHeaderAfterRenderingDelegate,this);this._bAlreadyAddedStickySubheaderAfterRenderingDelegate=true;this._attachStickyHeaderObserver();}}};
m.prototype._attachVisualIndicatorMouseOverHandlers=function(){var H=this.getHeader();if(n(H)&&!this._bAlreadyAttachedVisualIndicatorMouseOverOutHandler){H.attachEvent(m.EVENTS.VISUAL_INDICATOR_MOUSE_OVER,this._onVisualIndicatorMouseOver,this);H.attachEvent(m.EVENTS.VISUAL_INDICATOR_MOUSE_OUT,this._onVisualIndicatorMouseOut,this);this._bAlreadyAttachedVisualIndicatorMouseOverOutHandler=true;}};
m.prototype._attachTitleMouseOverHandlers=function(){var t=this.getTitle();if(n(t)&&!this._bAlreadyAttachedTitleMouseOverOutHandler){t.attachEvent(m.EVENTS.TITLE_MOUSE_OVER,this._onTitleMouseOver,this);t.attachEvent(m.EVENTS.TITLE_MOUSE_OUT,this._onTitleMouseOut,this);this._bAlreadyAttachedTitleMouseOverOutHandler=true;}};
m.prototype._attachScrollHandler=function(){this._onWrapperScrollReference=this._onWrapperScroll.bind(this);this._toggleHeaderOnScrollReference=this._toggleHeaderOnScroll.bind(this);this.$wrapper.on("scroll",this._onWrapperScrollReference);this.$wrapper.on("scroll",this._toggleHeaderOnScrollReference);};
m.prototype._toggleAdditionalNavigationClass=function(){var s=this._bStickySubheaderProviderExists();this.toggleStyleClass(m.NAVIGATION_CLASS_NAME,s);};
m.prototype._bStickySubheaderProviderExists=function(){var s=a.byId(this.getStickySubheaderProvider());return!!s&&s.isA("sap.f.IDynamicPageStickyContent");};
m.prototype._detachScrollHandler=function(){if(this.$wrapper){this.$wrapper.off("scroll",this._onWrapperScrollReference);this.$wrapper.off("scroll",this._toggleHeaderOnScrollReference);}};
m.prototype._formatLandmarkInfo=function(p,s){if(p){var r=p["get"+s+"Role"]()||"",q=p["get"+s+"Label"]()||"";if(r===A.None){r='';}return{role:r.toLowerCase(),label:q};}return{};};
m.prototype._getHeaderTag=function(p){if(p&&p.getHeaderRole()!==A.None){return m.DIV;}return m.HEADER;};
m.prototype._getFooterTag=function(p){if(p&&p.getFooterRole()!==A.None){return m.DIV;}return m.FOOTER;};
return m;});
sap.ui.predefine('sap/f/DynamicPageAccessibleLandmarkInfo',['sap/ui/core/Element','./library'],function(E,l){"use strict";
var D=E.extend("sap.f.DynamicPageAccessibleLandmarkInfo",{metadata:{library:"sap.f",properties:{rootRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"None"},rootLabel:{type:"string",defaultValue:null},contentRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"None"},contentLabel:{type:"string",defaultValue:null},headerRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"None"},headerLabel:{type:"string",defaultValue:null},footerRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"None"},footerLabel:{type:"string",defaultValue:null}}}});
return D;});
sap.ui.predefine('sap/f/DynamicPageHeader',["./library","sap/ui/Device","sap/ui/core/Control","sap/ui/core/library","sap/m/ToggleButton","sap/m/Button","./DynamicPageHeaderRenderer","sap/ui/core/InvisibleMessage"],function(l,D,C,a,T,B,b,I){"use strict";var c=a.InvisibleMessageMode;
var d=C.extend("sap.f.DynamicPageHeader",{metadata:{library:"sap.f",properties:{pinnable:{type:"boolean",group:"Appearance",defaultValue:true},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance"}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true},_pinButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_collapseButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},designtime:"sap/f/designtime/DynamicPageHeader.designtime"}});
d._getResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.f");};
d.ARIA={ARIA_CONTROLS:"aria-controls",ARIA_LABEL:"aria-label",LABEL_EXPANDED:d._getResourceBundle().getText("EXPANDED_HEADER"),LABEL_COLLAPSED:d._getResourceBundle().getText("SNAPPED_HEADER"),LABEL_PINNED:d._getResourceBundle().getText("PIN_HEADER"),TOOLTIP_COLLAPSE_BUTTON:d._getResourceBundle().getText("COLLAPSE_HEADER_BUTTON_TOOLTIP"),STATE_TRUE:"true",STATE_FALSE:"false"};
d.prototype.init=function(){this._bShowCollapseButton=true;this._oInvisibleMessage=null;};
d.prototype.onAfterRendering=function(){this._initARIAState();this._initPinButtonARIAState();if(!this._oInvisibleMessage){this._oInvisibleMessage=I.getInstance();}};
d.prototype._togglePinButton=function(v){this._getPinButton().setPressed(v);};
d.prototype._setShowPinBtn=function(v){this._getPinButton().$().toggleClass("sapUiHidden",!v);};
d.prototype._pinUnpinFireEvent=function(){this.fireEvent("_pinUnpinPress");};
d.prototype._onCollapseButtonPress=function(){this.fireEvent("_headerVisualIndicatorPress");};
d.prototype._onCollapseButtonMouseOver=function(){this.fireEvent("_visualIndicatorMouseOver");};
d.prototype._onCollapseButtonMouseOut=function(){this.fireEvent("_visualIndicatorMouseOut");};
d.prototype._initARIAState=function(){var $=this.$();$.attr(d.ARIA.ARIA_LABEL,d.ARIA.LABEL_EXPANDED);};
d.prototype._initPinButtonARIAState=function(){var $;if(this.getPinnable()){$=this._getPinButtonJQueryRef();$.attr(d.ARIA.ARIA_CONTROLS,this.getId());}};
d.prototype._updateARIAState=function(e){var $=this.$();if(e){$.attr(d.ARIA.ARIA_LABEL,d.ARIA.LABEL_EXPANDED);}else{$.attr(d.ARIA.ARIA_LABEL,d.ARIA.LABEL_COLLAPSED);}};
d.prototype._getPinButton=function(){if(!this.getAggregation("_pinButton")){var p=new T({id:this.getId()+"-pinBtn",icon:"sap-icon://pushpin-off",tooltip:d.ARIA.LABEL_PINNED,press:this._pinUnpinFireEvent.bind(this)}).addStyleClass("sapFDynamicPageHeaderPinButton");this.setAggregation("_pinButton",p,true);}return this.getAggregation("_pinButton");};
d.prototype._getCollapseButton=function(){if(!this.getAggregation("_collapseButton")){var o=new B({id:this.getId()+"-collapseBtn",icon:"sap-icon://slim-arrow-up",press:this._onCollapseButtonPress.bind(this),tooltip:d.ARIA.TOOLTIP_COLLAPSE_BUTTON}).addStyleClass("sapFDynamicPageToggleHeaderIndicator");o.onmouseover=this._onCollapseButtonMouseOver.bind(this);o.onmouseout=this._onCollapseButtonMouseOut.bind(this);this.setAggregation("_collapseButton",o,true);}return this.getAggregation("_collapseButton");};
d.prototype._toggleCollapseButton=function(t){this._setShowCollapseButton(t);this._getCollapseButton().$().toggleClass("sapUiHidden",!t);};
d.prototype._getShowCollapseButton=function(){return this._bShowCollapseButton&&!!this.getContent().length;};
d.prototype._setShowCollapseButton=function(v){this._bShowCollapseButton=!!v;};
d.prototype._focusCollapseButton=function(){var t=this._getCollapseButton().getTooltip()+" "+d._getResourceBundle().getText("EXPANDED_HEADER");this._getCollapseButton().$().trigger("focus");this._oInvisibleMessage.announce(t,c.Polite);};
d.prototype._focusPinButton=function(){this._getPinButtonJQueryRef().trigger("focus");};
d.prototype._getPinButtonJQueryRef=function(){return this._getPinButton().$();};
d.prototype._getState=function(){var e=this.getContent(),h=e.length>0,H=this.getPinnable()&&h&&!D.system.phone,p=this._getPinButton(),o=this._getCollapseButton();o.toggleStyleClass("sapUiHidden",!this._getShowCollapseButton());return{content:e,headerHasContent:h,headerPinnable:H,hasContent:e.length>0,pinButton:p,collapseButton:o};};
return d;});
sap.ui.predefine('sap/f/DynamicPageHeaderRenderer',[],function(){"use strict";var D={apiVersion:2};
D.render=function(r,d){var o=d._getState(),s="sapFDynamicPageHeader",b=d.getBackgroundDesign();r.openStart("section",d);r.accessibilityState({role:"region"});r.class("sapContrastPlus");r.class(s);if(o.headerHasContent){r.class("sapFDynamicPageHeaderWithContent");}if(o.headerPinnable){r.class("sapFDynamicPageHeaderPinnable");}if(b){r.class(s+b);}r.openEnd();this._renderHeaderContent(r,o);r.renderControl(o.collapseButton);if(o.headerPinnable){r.renderControl(o.pinButton);}r.close("section");};
D._renderHeaderContent=function(r,d){if(d.headerHasContent){r.openStart("div");r.class("sapFDynamicPageHeaderContent");r.openEnd();d.content.forEach(r.renderControl,r);r.close("div");}};
return D;},true);
sap.ui.predefine('sap/f/DynamicPageRenderer',["sap/ui/Device"],function(D){"use strict";var a={apiVersion:2};
a.render=function(r,d){var o=d.getTitle(),b=d.getHeader(),c=d.getFooter(),e=d.getContent(),h=d.getHeaderExpanded(),H=b?b.getContent():[],f=H.length>0,s=d.getShowFooter(),p=d._preserveHeaderStateOnScroll(),g=p||d._bHeaderInTitleArea,l=d.getLandmarkInfo(),i=d._getHeaderTag(l),F=d._getFooterTag(l);r.openStart("article",d);r.class("sapFDynamicPage");if(d.getToggleHeaderOnTitleClick()){r.class("sapFDynamicPageTitleClickEnabled");}r.attr("aria-roledescription",d._getAriaRoleDescription());r.accessibilityState(d,d._formatLandmarkInfo(l,"Root"));r.openEnd();if(D.system.desktop){r.renderControl(d._getScrollBar());}r.openStart(i,d.getId()+"-header");r.class("sapContrastPlus");r.class("sapFDynamicPageTitleWrapper");if(!h){r.class(D.system.phone&&o&&o.getSnappedTitleOnMobile()?"sapFDynamicPageTitleSnappedTitleOnMobile":"sapFDynamicPageTitleSnapped");}if(!f){r.class("sapFDynamicPageTitleOnly");}r.accessibilityState(d,d._formatLandmarkInfo(l,"Header"));r.attr("data-sap-ui-customfastnavgroup",true);r.openEnd();r.renderControl(o);r.openStart("div",d.getId()+"-stickyPlaceholder");r.openEnd();if(g){r.renderControl(b);}r.close("div");r.close(i);r.openStart("div",d.getId()+"-contentWrapper");r.class("sapFDynamicPageContentWrapper");if(d.getBackgroundDesign()){r.class("sapFDynamicPageContentWrapper"+d.getBackgroundDesign());}r.openEnd();r.openStart("div",d.getId()+"-headerWrapper");r.class("sapFDynamicPageHeaderWrapper");r.openEnd();if(!g){r.renderControl(b);}r.close("div");r.openStart("div",d.getId()+"-content");r.class("sapFDynamicPageContent");r.accessibilityState(d,d._formatLandmarkInfo(l,"Content"));r.openEnd();r.openStart("div",d.getId()+"-contentFitContainer");if(d.getFitContent()){r.class("sapFDynamicPageContentFitContainer");}if(c&&s){r.class("sapFDynamicPageContentFitContainerFooterVisible");}r.openEnd();r.renderControl(e);r.close("div");r.close("div");r.close("div");a.renderFooter(r,d,c,s,F,l);r.close("article");};
a.renderFooter=function(r,d,o,s,f,l){if(o){r.openStart(f,d.getId()+"-footerWrapper");r.class("sapContrast").class("sapContrastPlus").class("sapFDynamicPageFooter").class("sapMFooter-CTX");if(!s){r.class("sapUiHidden");}r.accessibilityState(d,d._formatLandmarkInfo(l,"Footer"));r.openEnd();o.addStyleClass("sapFDynamicPageActualFooterControl");r.renderControl(o);r.close(f);}};
return a;},true);
sap.ui.predefine('sap/f/DynamicPageTitle',["./library","sap/ui/core/library","sap/ui/core/Control","sap/ui/base/ManagedObjectObserver","sap/m/library","sap/m/Toolbar","sap/m/ToolbarSeparator","sap/m/OverflowToolbar","sap/m/Button","sap/ui/core/InvisibleText","./DynamicPageTitleRenderer","sap/base/Log","sap/ui/core/HTML","sap/ui/core/Icon","sap/ui/Device","sap/ui/events/KeyCodes","sap/ui/core/InvisibleMessage"],function(l,C,a,M,m,T,b,O,B,I,D,L,H,c,d,K,e){"use strict";var f=l.DynamicPageTitleArea,g=m.ToolbarStyle,h=C.InvisibleMessageMode;var o=sap.ui.getCore();
var i=a.extend("sap.f.DynamicPageTitle",{metadata:{library:"sap.f",properties:{primaryArea:{type:"sap.f.DynamicPageTitleArea",group:"Appearance",defaultValue:f.Begin,deprecated:true},areaShrinkRatio:{type:"sap.f.DynamicPageTitleShrinkRatio",group:"Appearance",defaultValue:"1:1.6:1.6"},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance"}},aggregations:{heading:{type:"sap.ui.core.Control",multiple:false,defaultValue:null},snappedHeading:{type:"sap.ui.core.Control",multiple:false,defaultValue:null},expandedHeading:{type:"sap.ui.core.Control",multiple:false,defaultValue:null},actions:{type:"sap.ui.core.Control",multiple:true,singularName:"action"},navigationActions:{type:"sap.m.Button",multiple:true,singularName:"navigationAction"},content:{type:"sap.ui.core.Control",multiple:true},snappedContent:{type:"sap.ui.core.Control",multiple:true},expandedContent:{type:"sap.ui.core.Control",multiple:true},snappedTitleOnMobile:{type:"sap.m.Title",multiple:false},breadcrumbs:{type:"sap.m.IBreadcrumbs",multiple:false},_actionsToolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"},_navActionsToolbar:{type:"sap.m.Toolbar",multiple:false,visibility:"hidden"},_navActionsToolbarSeparator:{type:"sap.m.ToolbarSeparator",multiple:false,visibility:"hidden"},_expandButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_snappedTitleOnMobileIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{stateChange:{parameters:{isExpanded:{type:"boolean"}}}},designtime:"sap/f/designtime/DynamicPageTitle.designtime"}});
function j(v){if(arguments.length===1){return v&&("length"in v)?v.length>0:!!v;}return Array.prototype.slice.call(arguments).every(function(n){return j(n);});}
i.NAV_ACTIONS_PLACEMENT_BREAK_POINT=1280;i.PRIMARY_AREA_MIDDLE_SHRINK_FACTORS={headingAreaShrinkFactor:1.6,contentAreaShrinkFactor:1,actionsAreaShrinkFactor:1.6};i.TOGGLE_HEADER_TEXT_ID=I.getStaticId("sap.f","TOGGLE_HEADER");i.DEFAULT_HEADER_TEXT_ID=I.getStaticId("sap.f","DEFAULT_HEADER_TEXT");
i._renderControl=function(n,p){var r;if(!p||!n){return;}r=o.createRenderManager();r.renderControl(p);r.flush(n);r.destroy();};
function k(n){return typeof n==="function";}
i.prototype.init=function(){this._bExpandedState=true;this._bShowExpandButton=false;this._bIsFocusable=true;this._fnActionSubstituteParentFunction=function(){return this;}.bind(this);this._bNavigationActionsInTopArea=false;this._oRB=o.getLibraryResourceBundle("sap.f");this._oObserver=new M(i.prototype._observeChanges.bind(this));this._oObserver.observe(this,{aggregations:["content","_actionsToolbar"]});this._oRB=sap.ui.getCore().getLibraryResourceBundle("sap.f");this._oInvisibleMessage=null;};
i.prototype.onBeforeRendering=function(){this._getActionsToolbar();this._observeControl(this.getBreadcrumbs());this._detachFocusSpanHandlers();};
i.prototype.onAfterRendering=function(){this._cacheDomElements();this._attachFocusSpanHandlers();this._toggleState(this._bExpandedState);this._toggleFocusableState(this._bIsFocusable);this._doNavigationActionsLayout();this._updateTopAreaVisibility();if(this._getFocusSpan().is(":focus")){this._addFocusClass();}if(!this._oInvisibleMessage){this._oInvisibleMessage=e.getInstance();}};
i.prototype.exit=function(){if(this._oObserver){this._oObserver.disconnect();this._oObserver=null;}};
i.prototype.setPrimaryArea=function(A){var s=this.getAreaShrinkRatio(),S=this._getShrinkFactorsObject(),n=this.getMetadata().getProperty("areaShrinkRatio").getDefaultValue();if(!this.getDomRef()){return this.setProperty("primaryArea",A,true);}if(s!==n){return this.setProperty("primaryArea",A,true);}if(A===f.Begin){this._setShrinkFactors(S.headingAreaShrinkFactor,S.contentAreaShrinkFactor,S.actionsAreaShrinkFactor);}else{this._setShrinkFactors(i.PRIMARY_AREA_MIDDLE_SHRINK_FACTORS.headingAreaShrinkFactor,i.PRIMARY_AREA_MIDDLE_SHRINK_FACTORS.contentAreaShrinkFactor,i.PRIMARY_AREA_MIDDLE_SHRINK_FACTORS.actionsAreaShrinkFactor);}return this.setProperty("primaryArea",A,true);};
i.prototype.setAreaShrinkRatio=function(A){A=this.validateProperty("areaShrinkRatio",A);this.setProperty("areaShrinkRatio",A,true);var s=this._getShrinkFactorsObject();if(this.getPrimaryArea()===f.Middle){L.warning("DynamicPageTitle :: Property primaryArea is disregarded when areaShrinkRatio is set.",this);}if(s.headingAreaShrinkFactor>1&&s.contentAreaShrinkFactor>1&&s.actionsAreaShrinkFactor>1){L.warning("DynamicPageTitle :: One of the shrink factors should be set to 1.",this);}this._setShrinkFactors(s.headingAreaShrinkFactor,s.contentAreaShrinkFactor,s.actionsAreaShrinkFactor);return this;};
i.prototype.ontap=function(E){var s=E.srcControl;if(s===this||s===this.getAggregation("_actionsToolbar")||s===this.getAggregation("breadcrumbs")||s===this.getAggregation("snappedTitleOnMobile")){this.fireEvent("_titlePress");}};
i.prototype.onmouseover=function(){if(this._bTitleMouseOverFired){return;}this.fireEvent("_titleMouseOver");this._bTitleMouseOverFired=true;};
i.prototype.onmouseout=function(E){if(E&&this.getDomRef().contains(E.relatedTarget)){return;}this.fireEvent("_titleMouseOut");this._bTitleMouseOverFired=false;};
i.prototype.onkeyup=function(E){if(E&&E.which===K.SPACE&&!E.shiftKey){this.onsapenter(E);}};
i.prototype.onsapspace=function(E){if(E.srcControl===this){E.preventDefault();}};
i.prototype.onsapenter=function(E){if(E.srcControl===this){this.fireEvent("_titlePress");}};
["addAction","insertAction","removeAction","indexOfAction","removeAllActions","destroyActions","getActions"].forEach(function(s){i.prototype[s]=function(n){var t=this._getActionsToolbar(),p=s.replace(/Actions?/,"Content"),S=true,r;if(s==="addAction"||s==="insertAction"){if(!this._actionExists(n,"actions")){t[p].apply(t,arguments);this._preProcessAction(n,"actions");}r=this;}else if(s==="removeAction"){this._postProcessAction(n);}else if(s==="removeAllActions"){this.getActions().forEach(this._postProcessAction,this);}else if(s==="destroyActions"){this.getActions().forEach(this._postProcessAction,this);t[p].apply(t,arguments);r=this;}else if(s==="getActions"){S=false;}r=r||t[p].apply(t,arguments);S&&this._updateSeparatorVisibility();return r;};});["addNavigationAction","insertNavigationAction","removeNavigationAction","indexOfNavigationAction","removeAllNavigationActions","destroyNavigationActions","getNavigationActions"].forEach(function(s){i.prototype[s]=function(n){var t=this._getNavigationActionsToolbar(),p=s.replace(/NavigationActions?/,"Content"),q=true,r;if(s==="addNavigationAction"||s==="insertNavigationAction"){if(!this._actionExists(n,"navigationActions")){t[p].apply(t,arguments);this._preProcessAction(n,"navigationActions");}r=this;}else if(s==="removeNavigationAction"){this._postProcessAction(n);}else if(s==="removeAllNavigationActions"){this.getNavigationActions().forEach(this._postProcessAction,this);}else if(s==="destroyNavigationActions"){this.getNavigationActions().forEach(this._postProcessAction,this);t[p].apply(t,arguments);r=this;}else if(s==="getNavigationActions"){q=false;}r=r||t[p].apply(t,arguments);q&&this._updateTopAreaVisibility();return r;};});
i.prototype.clone=function(s,n,p){var t=a.prototype.clone.apply(this,arguments),q=true;if(p){q=!!p.cloneChildren;}if(!q){return t;}var r=function(A){if(!this.isBound(A)){var u=this.getMetadata().getAggregation(A);u.get(this).forEach(function(v){u.add(t,v.clone());},this);}}.bind(this);r("actions");r("navigationActions");return t;};
i.prototype._actionExists=function(A,s){return this.getMetadata().getAggregation(s).get(this).indexOf(A)>-1;};
i.prototype._cacheDomElements=function(){this.$topNavigationActionsArea=this.$("topNavigationArea");this.$mainNavigationActionsArea=this.$("mainNavigationArea");this.$beginArea=this.$("left-inner");this.$topArea=this.$("top");this.$mainArea=this.$("main");this.$middleArea=this.$("content");this.$snappedTitleOnMobileWrapper=this.$("snapped-title-on-mobile-wrapper");this.$snappedHeadingWrapper=this.$("snapped-heading-wrapper");this.$expandHeadingWrapper=this.$("expand-heading-wrapper");this.$snappedWrapper=this.$("snapped-wrapper");this.$expandWrapper=this.$("expand-wrapper");this._$focusSpan=this.$("focusSpan");};
i.prototype._getActionsToolbar=function(){if(!this.getAggregation("_actionsToolbar")){this.setAggregation("_actionsToolbar",new O({id:this.getId()+"-_actionsToolbar",style:g.Clear}).addStyleClass("sapFDynamicPageTitleActionsBar"),true);}return this.getAggregation("_actionsToolbar");};
i.prototype._getNavigationActionsToolbar=function(){if(!this.getAggregation("_navActionsToolbar")){this.setAggregation("_navActionsToolbar",new T({id:this.getId()+"-navActionsToolbar",style:g.Clear}).addStyleClass("sapFDynamicPageTitleActionsBar"),true);}return this.getAggregation("_navActionsToolbar");};
i.prototype._getToolbarSeparator=function(){if(!this.getAggregation("_navActionsToolbarSeparator")){this.setAggregation("_navActionsToolbarSeparator",new b({id:this.getId()+"-separator"}),true);}return this.getAggregation("_navActionsToolbarSeparator");};
i.prototype._toggleFocusableState=function(F){var $;this._bIsFocusable=F;$=this._getFocusSpan();if($){F?$.show():$.hide();}};
i.prototype._preProcessAction=function(A,p){if(k(A._fnOriginalGetParent)){return;}this._observeControl(A);A._fnOriginalGetParent=A.getParent;A.getParent=this._fnActionSubstituteParentFunction;A._sOriginalParentAggregationName=A.sParentAggregationName;A.sParentAggregationName=p;};
i.prototype._postProcessAction=function(A){if(!k(A._fnOriginalGetParent)){return;}this._unobserveControl(A);A.getParent=A._fnOriginalGetParent;A._fnOriginalGetParent=null;A.sParentAggregationName=A._sOriginalParentAggregationName;A._sOriginalParentAggregationName=null;};
i.prototype._observeControl=function(n){this._oObserver.observe(n,{properties:["visible"]});};
i.prototype._unobserveControl=function(n){this._oObserver.unobserve(n,{properties:["visible"]});};
i.prototype._doNavigationActionsLayout=function(){var r,n,N;if(this.getNavigationActions().length===0){return;}N=this._getNavigationActionsToolbar();r=this._shouldRenderNavigationActionsInTopArea();if(r){n=this.$topNavigationActionsArea[0];}else{n=this.$mainNavigationActionsArea[0];}this._bNavigationActionsInTopArea=r;i._renderControl(n,N);this._updateSeparatorVisibility();};
i.prototype._updateTopAreaVisibility=function(n){var N=this._areNavigationActionsInTopArea(),p=this._shouldRenderNavigationActionsInTopArea(n),q=this.getBreadcrumbs()&&this.getBreadcrumbs().getVisible(),r=d.system.phone&&this.getSnappedTitleOnMobile()&&!this._bExpandedState,s=(q||p)&&!r,S=this.getNavigationActions().length>0&&(p^N);this._toggleTopAreaVisibility(s);if(S){this._toggleNavigationActionsPlacement(p);}else{this._updateSeparatorVisibility();}};
i.prototype._onResize=function(n){this._updateTopAreaVisibility(n);};
i.prototype._toggleNavigationActionsPlacement=function(s){this["_showNavigationActionsIn"+(s?"Top":"Main")+"Area"]();this._updateSeparatorVisibility();};
i.prototype._showNavigationActionsInTopArea=function(){var n=this._getNavigationActionsToolbar(),p;if(this.$topNavigationActionsArea&&this.$topNavigationActionsArea.length>0){p=document.activeElement;this.$topNavigationActionsArea.html(n.$());p&&p.focus();}this._bNavigationActionsInTopArea=true;};
i.prototype._showNavigationActionsInMainArea=function(){var n=this._getNavigationActionsToolbar(),p;if(this.$mainNavigationActionsArea&&this.$mainNavigationActionsArea.length>0){p=document.activeElement;this.$mainNavigationActionsArea.html(n.$());p&&p.focus();}this._bNavigationActionsInTopArea=false;};
i.prototype._areNavigationActionsInTopArea=function(){return this._bNavigationActionsInTopArea;};
i.prototype._updateSeparatorVisibility=function(){if(this.getDomRef()){this._getToolbarSeparator().toggleStyleClass("sapUiHidden",!this._shouldShowSeparator());}};
i.prototype._toggleTopAreaVisibility=function(s){if(this.getDomRef()){this.$("top").toggleClass("sapUiHidden",!s);}};
i.prototype._shouldShowSeparator=function(){var n,p;if(this._bNavigationActionsInTopArea){return false;}n=this._getVisibleActions().length>0;p=this._getVisibleNavigationActions().length>0;return n&&p;};
i.prototype._getVisibleActions=function(){return this.getActions().filter(function(A){return A.getVisible();});};
i.prototype._getVisibleNavigationActions=function(){return this.getNavigationActions().filter(function(A){return A.getVisible();});};
i.prototype._setShrinkFactors=function(n,p,A){this.$("left-inner").css("flex-shrink",n);this.$("content").css("flex-shrink",p);this.$("mainActions").css("flex-shrink",A);};
i.prototype._shouldRenderNavigationActionsInTopArea=function(n){var w,p,q;if(this._getVisibleNavigationActions().length===0){return false;}w=n?n:this._getWidth();p=this._getVisibleActions().length>0;q=this.getBreadcrumbs()&&this.getBreadcrumbs().getVisible();return w<i.NAV_ACTIONS_PLACEMENT_BREAK_POINT&&(q||p);};
i.prototype._toggleState=function(E,u){var n=this._bExpandedState;this._bExpandedState=E;if(!this.getDomRef()){return;}if(d.system.phone&&this.getSnappedTitleOnMobile()){this.$snappedTitleOnMobileWrapper.toggleClass("sapUiHidden",E);this.$topArea.toggleClass("sapUiHidden",!E);this.$mainArea.toggleClass("sapUiHidden",!E);this.$().toggleClass("sapContrast",!E);}else{if(j(this.getSnappedHeading())){this.$snappedHeadingWrapper.toggleClass("sapUiHidden",E);}if(j(this.getExpandedHeading())){this.$expandHeadingWrapper.toggleClass("sapUiHidden",!E);}if(u&&n!==E){this.fireEvent("stateChange",{isExpanded:E});}}if(j(this.getSnappedContent())){this.$snappedWrapper.toggleClass("sapUiHidden",E);this.$snappedWrapper.parent().toggleClass("sapFDynamicPageTitleMainSnapContentVisible",!E);}if(j(this.getExpandedContent())){this.$expandWrapper.toggleClass("sapUiHidden",!E);this.$expandWrapper.parent().toggleClass("sapFDynamicPageTitleMainExpandContentVisible",E);}};
i.prototype._getExpandButton=function(){if(!this.getAggregation("_expandButton")){var E=new B({id:this.getId()+"-expandBtn",icon:"sap-icon://slim-arrow-down",press:this._onExpandButtonPress.bind(this),tooltip:this._oRB.getText("EXPAND_HEADER_BUTTON_TOOLTIP")}).addStyleClass("sapFDynamicPageToggleHeaderIndicator sapUiHidden");this.setAggregation("_expandButton",E,true);}return this.getAggregation("_expandButton");};
i.prototype._getSnappedTitleOnMobileIcon=function(){if(!this.getAggregation("_snappedTitleOnMobileIcon")){var n=new c({id:this.getId()+"-snappedTitleOnMobileIcon",src:"sap-icon://slim-arrow-down",press:this._onExpandButtonPress.bind(this)});this.setAggregation("_snappedTitleOnMobileIcon",n,true);}return this.getAggregation("_snappedTitleOnMobileIcon");};
i.prototype._onExpandButtonPress=function(){this.fireEvent("_titleVisualIndicatorPress");};
i.prototype._toggleExpandButton=function(t){this._setShowExpandButton(t);this._getExpandButton().$().toggleClass("sapUiHidden",!t);};
i.prototype._getShowExpandButton=function(){return this._bShowExpandButton;};
i.prototype._setShowExpandButton=function(v){this._bShowExpandButton=!!v;};
i.prototype._focusExpandButton=function(){var t=this._getExpandButton().getTooltip()+" "+this._oRB.getText("SNAPPED_HEADER");this._getExpandButton().$().trigger("focus");this._oInvisibleMessage.announce(t,h.Polite);};
i.prototype._getWidth=function(){return this.$().outerWidth();};
i.prototype.getFocusDomRef=function(){return this._getFocusSpan()[0]||null;};
i.prototype._getState=function(){var n=this.getActions().length>0,p=this.getNavigationActions().length>0,q=this.getContent(),s=this.getSnappedContent(),E=this.getExpandedContent(),r=E.length>0,t=s.length>0,S=this._getShrinkFactorsObject(),u=this._getExpandButton(),F=this._getFocusSpan(),v=this.getBreadcrumbs(),w=this.getSnappedTitleOnMobile(),x=this._getSnappedTitleOnMobileIcon(),y=w&&d.system.phone,z=v||p,A=!!(v&&!p),G=p&&!v,J=this.getMetadata().getProperty("areaShrinkRatio").getDefaultValue();if(this.getAreaShrinkRatio()===J&&this.getPrimaryArea()===f.Middle){S.headingAreaShrinkFactor=i.PRIMARY_AREA_MIDDLE_SHRINK_FACTORS.headingAreaShrinkFactor;S.contentAreaShrinkFactor=i.PRIMARY_AREA_MIDDLE_SHRINK_FACTORS.contentAreaShrinkFactor;S.actionsAreaShrinkFactor=i.PRIMARY_AREA_MIDDLE_SHRINK_FACTORS.actionsAreaShrinkFactor;}u.toggleStyleClass("sapUiHidden",!this._getShowExpandButton());return{id:this.getId(),actionBar:this._getActionsToolbar(),navigationBar:this._getNavigationActionsToolbar(),hasActions:n,hasNavigationActions:p,content:q,hasContent:q.length>0,heading:this.getHeading(),snappedHeading:this.getSnappedHeading(),expandedHeading:this.getExpandedHeading(),expandButton:u,focusSpan:F,snappedTitleOnMobileContext:w,snappedTitleOnMobileIcon:x,snappedContent:s,expandedContent:E,hasSnappedContent:t,hasExpandedContent:r,hasSnappedTitleOnMobile:y,hasAdditionalContent:r||(t&&!y),isSnapped:!this._bExpandedState,headingAreaShrinkFactor:S.headingAreaShrinkFactor,contentAreaShrinkFactor:S.contentAreaShrinkFactor,actionsAreaShrinkFactor:S.actionsAreaShrinkFactor,breadcrumbs:this.getBreadcrumbs(),separator:this._getToolbarSeparator(),hasTopContent:z,hasOnlyBreadcrumbs:A,hasOnlyNavigationActions:G,contentAreaFlexBasis:this._sContentAreaFlexBasis,actionsAreaFlexBasis:this._sActionsAreaFlexBasis,contentAreaHasContent:this._bContentAreaHasContent,actionsAreaHasContent:this._bActionsAreaHasContent,isFocusable:this._bIsFocusable};};
i.prototype._getShrinkFactorsObject=function(){var r={},A=this.getAreaShrinkRatio().split(":");r.headingAreaShrinkFactor=parseFloat(A[0]);r.contentAreaShrinkFactor=parseFloat(A[1]);r.actionsAreaShrinkFactor=parseFloat(A[2]);return r;};
i.prototype._observeChanges=function(n){var p=n.object,s=n.name;if(p===this){if(s==="content"||s==="_actionsToolbar"){this._observeContentChanges(n);}}else if(s==="visible"){this._updateTopAreaVisibility();}};
i.prototype._observeContentChanges=function(n){var p=n.child,s=n.mutation;if(!(p instanceof O)){return;}if(s==="insert"){p.attachEvent("_contentSizeChange",this._onContentSizeChange,this);}else if(s==="remove"){p.detachEvent("_contentSizeChange",this._onContentSizeChange,this);this._setContentAreaFlexBasis(0,p.$().parent());}};
i.prototype._onContentSizeChange=function(E){var n=E.getParameter("contentSize");this._setContentAreaFlexBasis(n,E.getSource().$().parent());};
i.prototype._setContentAreaFlexBasis=function(n,$){var F,s,A;n=parseInt(n);A=n&&n>1;F=n?n+"px":"auto";s=F!=="auto"?F:undefined;$.css({"flex-basis":F});if($.hasClass("sapFDynamicPageTitleMainContent")){this._sContentAreaFlexBasis=s;this._bContentAreaHasContent=A;$.toggleClass("sapFDynamicPageTitleMainContentHasContent",A);}else if($.hasClass("sapFDynamicPageTitleMainActions")){this._sActionsAreaFlexBasis=s;this._bActionsAreaHasContent=A;$.toggleClass("sapFDynamicPageTitleMainActionsHasContent",A);}};
i.prototype._updateARIAState=function(E){var A=this._getARIALabelReferences(E)||i.DEFAULT_HEADER_TEXT_ID,$=this._getFocusSpan();if($){$.attr("aria-labelledby",A);$.attr("aria-expanded",E);}return this;};
i.prototype._getARIALabelReferences=function(E){var r="",t,s,n=this.getHeading()||(E?this.getExpandedHeading():this.getSnappedHeading());if(n){t=n.getTitle&&n.getTitle();if(t&&t.getId){s=t.getId();}r+=s||n.getId();}return r;};
i.prototype._focus=function(){this._getFocusSpan().trigger("focus");};
i.prototype._getAriaDescribedByReferences=function(){var t=this.getAriaDescribedBy(),s=i.TOGGLE_HEADER_TEXT_ID;if(t.length>0){s+=" "+t.join(" ");}return s;};
i.prototype._attachFocusSpanHandlers=function(){this._$focusSpan.on("focusin",this._addFocusClass.bind(this));this._$focusSpan.on("focusout",this._removeFocusClass.bind(this));};
i.prototype._detachFocusSpanHandlers=function(){if(this._$focusSpan){this._$focusSpan.off("focusin");this._$focusSpan.off("focusout");}};
i.prototype._getFocusSpan=function(){return this._$focusSpan;};
i.prototype._addFocusClass=function(){this.$().addClass("sapFDynamicPageTitleFocus");};
i.prototype._removeFocusClass=function(){this.$().removeClass("sapFDynamicPageTitleFocus");};
return i;});
sap.ui.predefine('sap/f/DynamicPageTitleRenderer',["./library"],function(l){"use strict";var D={apiVersion:2};
D.render=function(r,d){var o=d._getState(),s="sapFDynamicPageTitle",b=d.getBackgroundDesign(),L=d._getARIALabelReferences(d._bExpandedState)||d.DEFAULT_HEADER_TEXT_ID,a=d._getAriaDescribedByReferences();r.openStart("div",d);r.class(s);if(b){r.class(s+b);}r.openEnd();r.openStart("span",d.getId()+"-focusSpan").class("sapFDynamicPageTitleFocusSpan").attr("role","button").attr("aria-expanded",d._bExpandedState).attr("aria-labelledby",L).attr("aria-describedby",a).attr("tabindex",0);r.openEnd().close("span");this._renderTopArea(r,o);this._renderMainArea(r,o);this._renderSnappedExpandedContentArea(r,o);if(o.hasSnappedTitleOnMobile){this._renderSnappedTitleOnMobile(r,o);}r.renderControl(o.expandButton);r.close("div");};
D._renderTopArea=function(r,d){if(d.hasTopContent){r.openStart("div",d.id+"-top");r.class("sapFDynamicPageTitleTop");if(d.hasOnlyBreadcrumbs){r.class("sapFDynamicPageTitleTopBreadCrumbsOnly");}if(d.hasOnlyNavigationActions){r.class("sapFDynamicPageTitleTopNavActionsOnly");}r.openEnd();this._renderTopBreadcrumbsArea(r,d);this._renderTopNavigationArea(r,d);r.close("div");}};
D._renderTopBreadcrumbsArea=function(r,d){if(d.breadcrumbs){r.openStart("div",d.id+"-breadcrumbs");r.class("sapFDynamicPageTitleTopLeft");r.openEnd();r.renderControl(d.breadcrumbs);r.close("div");}};
D._renderTopNavigationArea=function(r,d){if(d.hasNavigationActions){r.openStart("div",d.id+"-topNavigationArea");r.class("sapFDynamicPageTitleTopRight");r.openEnd();r.close("div");}};
D._renderMainArea=function(r,d){r.openStart("div",d.id+"-main");r.class("sapFDynamicPageTitleMain");if(!d.hasContent){r.class("sapFDynamicPageTitleMainNoContent");}r.openEnd();r.openStart("div");r.class("sapFDynamicPageTitleMainInner");r.openEnd();this._renderMainHeadingArea(r,d);this._renderMainContentArea(r,d);this._renderMainActionsArea(r,d);r.close("div");this._renderMainNavigationArea(r,d);r.close("div");};
D._renderMainHeadingArea=function(r,d){r.openStart("div",d.id+"-left-inner");r.class("sapFDynamicPageTitleMainHeading");r.style("flex-shrink",d.headingAreaShrinkFactor.toString());r.openEnd();r.openStart("div");r.class("sapFDynamicPageTitleHeading-CTX");r.class("sapFDynamicPageTitleMainHeadingInner");r.openEnd();if(d.heading){r.renderControl(d.heading);}else{if(d.snappedHeading){D._renderSnappedHeading(r,d);}if(d.expandedHeading){D._renderExpandHeading(r,d);}}r.close("div");r.close("div");};
D._renderMainContentArea=function(r,d){r.openStart("div",d.id+"-content");r.class("sapFDynamicPageTitleMainContent");r.class("sapFDynamicPageTitleContent-CTX");r.style("flex-shrink",d.contentAreaShrinkFactor.toString());if(d.contentAreaFlexBasis){r.style("flex-basis",d.contentAreaFlexBasis);}if(d.contentAreaHasContent){r.class("sapFDynamicPageTitleMainContentHasContent");}r.openEnd();d.content.forEach(r.renderControl,r);r.close("div");};
D._renderMainActionsArea=function(r,d){r.openStart("div",d.id+"-mainActions");r.class("sapFDynamicPageTitleMainActions");r.style("flex-shrink",d.actionsAreaShrinkFactor.toString());if(d.actionsAreaFlexBasis){r.style("flex-basis",d.actionsAreaFlexBasis);}if(d.actionsAreaHasContent){r.class("sapFDynamicPageTitleMainActionsHasContent");}r.openEnd();if(d.hasActions){r.renderControl(d.actionBar);}r.close("div");};
D._renderMainNavigationArea=function(r,d){if(d.hasNavigationActions){r.openStart("div",d.id+"-mainNavigationAreaWrapper");r.class("sapFDynamicPageTitleMainNavigationArea");r.openEnd();r.renderControl(d.separator);r.openStart("div",d.id+"-mainNavigationArea");r.class("sapFDynamicPageTitleMainNavigationAreaInner");r.openEnd();r.close("div");r.close("div");}};
D._renderSnappedExpandedContentArea=function(r,d){if(d.hasAdditionalContent){r.openStart("div");r.class("sapFDynamicPageTitleMainHeadingSnappedExpandContent");r.openEnd();if(d.hasSnappedContent&&!d.hasSnappedTitleOnMobile){D._renderSnappedContent(r,d);}if(d.hasExpandedContent){D._renderExpandContent(r,d);}r.close("div");}};
D._renderExpandHeading=function(r,d){r.openStart("div",d.id+"-expand-heading-wrapper");r.openEnd();r.renderControl(d.expandedHeading);r.close("div");};
D._renderSnappedHeading=function(r,d){r.openStart("div",d.id+"-snapped-heading-wrapper");if(!d.isSnapped){r.class("sapUiHidden");}r.openEnd();r.renderControl(d.snappedHeading);r.close("div");};
D._renderExpandContent=function(r,d){r.openStart("div",d.id+"-expand-wrapper");r.openEnd();d.expandedContent.forEach(r.renderControl,r);r.close("div");};
D._renderSnappedContent=function(r,d){r.openStart("div",d.id+"-snapped-wrapper");if(!d.isSnapped){r.class("sapUiHidden");}r.class("sapFDynamicPageTitleSnapped");r.openEnd();d.snappedContent.forEach(r.renderControl,r);r.close("div");};
D._renderSnappedTitleOnMobile=function(r,d){r.openStart("div",d.id+"-snapped-title-on-mobile-wrapper");if(!d.isSnapped){r.class("sapUiHidden");}r.class("sapFDynamicPageTitleSnappedTitleOnMobile");r.openEnd();r.renderControl(d.snappedTitleOnMobileContext);r.renderControl(d.snappedTitleOnMobileIcon);r.close("div");};
return D;},true);
sap.ui.predefine('sap/f/FlexibleColumnLayout',["sap/ui/thirdparty/jquery","./library","sap/ui/core/library","sap/ui/Device","sap/ui/core/ResizeHandler","sap/ui/core/Control","sap/m/library","sap/m/Button","sap/m/NavContainer","sap/ui/core/Configuration","sap/ui/core/theming/Parameters",'sap/ui/dom/units/Rem',"./FlexibleColumnLayoutRenderer","sap/base/Log","sap/base/assert","sap/base/util/isEmptyObject","sap/base/util/merge","sap/ui/core/InvisibleMessage"],function(q,l,c,D,R,C,m,B,N,a,P,b,F,L,d,e,f,I){"use strict";var g=l.LayoutType;var h=c.InvisibleMessageMode;
var j=C.extend("sap.f.FlexibleColumnLayout",{metadata:{interfaces:["sap.ui.core.IPlaceholderSupport"],properties:{autoFocus:{type:"boolean",group:"Behavior",defaultValue:true},layout:{type:"sap.f.LayoutType",defaultValue:g.OneColumn},defaultTransitionNameBeginColumn:{type:"string",group:"Appearance",defaultValue:"slide"},defaultTransitionNameMidColumn:{type:"string",group:"Appearance",defaultValue:"slide"},defaultTransitionNameEndColumn:{type:"string",group:"Appearance",defaultValue:"slide"},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:m.BackgroundDesign.Transparent},restoreFocusOnBackNavigation:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{beginColumnPages:{type:"sap.ui.core.Control",multiple:true,forwarding:{getter:"_getBeginColumn",aggregation:"pages"}},midColumnPages:{type:"sap.ui.core.Control",multiple:true,forwarding:{getter:"_getMidColumn",aggregation:"pages"}},endColumnPages:{type:"sap.ui.core.Control",multiple:true,forwarding:{getter:"_getEndColumn",aggregation:"pages"}},landmarkInfo:{type:"sap.f.FlexibleColumnLayoutAccessibleLandmarkInfo",multiple:false},_beginColumnNav:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"},_midColumnNav:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"},_endColumnNav:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"},_beginColumnBackArrow:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_midColumnForwardArrow:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_midColumnBackArrow:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_endColumnForwardArrow:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{initialBeginColumnPage:{type:"sap.ui.core.Control",multiple:false},initialMidColumnPage:{type:"sap.ui.core.Control",multiple:false},initialEndColumnPage:{type:"sap.ui.core.Control",multiple:false}},events:{stateChange:{parameters:{layout:{type:"sap.f.LayoutType"},maxColumnsCount:{type:"int"},isNavigationArrow:{type:"boolean"},isResize:{type:"boolean"}}},beginColumnNavigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterBeginColumnNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},midColumnNavigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterMidColumnNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},endColumnNavigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterEndColumnNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},columnResize:{parameters:{beginColumn:{type:"boolean"},midColumn:{type:"boolean"},endColumn:{type:"boolean"}}}}}});
j.DEFAULT_COLUMN_LABELS={"FirstColumn":"FCL_BEGIN_COLUMN_REGION_TEXT","MiddleColumn":"FCL_MID_COLUMN_REGION_TEXT","LastColumn":"FCL_END_COLUMN_REGION_TEXT"};j.COLUMN_RESIZING_ANIMATION_DURATION=560;j.PINNED_COLUMN_CLASS_NAME="sapFFCLPinnedColumn";j.COLUMN_ORDER=["begin","mid","end"];j.NAVIGATION_ARROW_WIDTH=b.toPx("1rem");
j.prototype.init=function(){this._iWidth=0;this._oColumnFocusInfo={begin:{},mid:{},end:{}};this._initNavContainers();this._initButtons();this._oLayoutHistory=new k();this._oAnimationEndListener=new A();this._oRenderedColumnPagesBoolMap={};this._oColumnWidthInfo={begin:0,mid:0,end:0};this._oInvisibleMessage=null;};
j.prototype._announceMessage=function(r){var t=j._getResourceBundle().getText(r);if(this._oInvisibleMessage){this._oInvisibleMessage.announce(t,h.Polite);}};
j.prototype._onNavContainerRendered=function(E){var o=E.srcControl,H=o.getPages().length>0,i=this._hasAnyColumnPagesRendered();this._setColumnPagesRendered(o.getId(),H);if(this._hasAnyColumnPagesRendered()!==i){this._hideShowArrows();}};
j.prototype._createNavContainer=function(s){var i=s.charAt(0).toUpperCase()+s.slice(1);var n=new N(this.getId()+"-"+s+"ColumnNav",{autoFocus:this.getAutoFocus(),navigate:function(E){this._handleNavigationEvent(E,false,s);}.bind(this),afterNavigate:function(E){this._handleNavigationEvent(E,true,s);}.bind(this),defaultTransitionName:this["getDefaultTransitionName"+i+"Column"]()});n.addDelegate({"onAfterRendering":this._onNavContainerRendered},this);this["_"+s+'ColumnFocusOutDelegate']={onfocusout:function(E){this._oColumnFocusInfo[s]=E.target;}};n.addEventDelegate(this["_"+s+'ColumnFocusOutDelegate'],this);return n;};
j.prototype._formatLandmarkInfo=function(o,s){var i=null;if(o){i=o["get"+s+"Label"]();}return{role:"region",label:i||j._getResourceBundle().getText(j.DEFAULT_COLUMN_LABELS[s])};};
j.prototype._handleNavigationEvent=function(E,i,s){var n,o;if(i){n="after"+(s.charAt(0).toUpperCase()+s.slice(1))+"ColumnNavigate";}else{n=s+"ColumnNavigate";}o=this.fireEvent(n,E.mParameters,true);if(!o){E.preventDefault();}};
j.prototype._getColumnByStringName=function(s){if(s==='end'){return this._getEndColumn();}else if(s==='mid'){return this._getMidColumn();}else{return this._getBeginColumn();}};
j.prototype._getBeginColumn=function(){return this.getAggregation("_beginColumnNav");};
j.prototype._getMidColumn=function(){return this.getAggregation("_midColumnNav");};
j.prototype._getEndColumn=function(){return this.getAggregation("_endColumnNav");};
j.prototype._flushColumnContent=function(s){var o=this.getAggregation("_"+s+"ColumnNav"),r=sap.ui.getCore().createRenderManager();r.renderControl(o);r.flush(this._$columns[s].find(".sapFFCLColumnContent")[0],undefined,true);r.destroy();};
j.prototype.setLayout=function(n){n=this.validateProperty("layout",n);var s=this.getLayout();if(s===n){return this;}var r=this.setProperty("layout",n,true);this._oLayoutHistory.addEntry(n);this._hideShowArrows();this._resizeColumns();return r;};
j.prototype.setAutoFocus=function(n){n=this.validateProperty("autoFocus",n);var i=this.getAutoFocus();if(i===n){return this;}this._getNavContainers().forEach(function(o){o.setAutoFocus(n);});return this.setProperty("autoFocus",n,true);};
j.prototype.onBeforeRendering=function(){if(!this._oInvisibleMessage){this._oInvisibleMessage=I.getInstance();}this._deregisterResizeHandler();this._oAnimationEndListener.cancelAll();};
j.prototype.onAfterRendering=function(){this._measureControlWidth();this._registerResizeHandler();this._cacheDOMElements();this._hideShowArrows();this._resizeColumns();this._flushColumnContent("begin");this._flushColumnContent("mid");this._flushColumnContent("end");this._fireStateChange(false,false);};
j.prototype._restoreFocusToColumn=function(s){var E=this._oColumnFocusInfo[s];if(!E||e(E)){E=this._getFirstFocusableElement(s);}q(E).trigger("focus");};
j.prototype._getFirstFocusableElement=function(s){var o=this._getColumnByStringName(s),i=o.getCurrentPage();if(i){return i.$().firstFocusableDomRef();}return null;};
j.prototype._isFocusInSomeOfThePreviousColumns=function(){var i=j.COLUMN_ORDER.indexOf(this._sPreviuosLastVisibleColumn)-1,o;for(;i>=0;i--){o=this._getColumnByStringName(j.COLUMN_ORDER[i]);if(o&&o._isFocusInControl(o)){return true;}}return false;};
j.prototype._getControlWidth=function(){if(this._iWidth===0){this._measureControlWidth();}return this._iWidth;};
j.prototype._measureControlWidth=function(){if(this.$().is(":visible")){this._iWidth=this.$().width();}else{this._iWidth=0;}};
j.prototype.exit=function(){this._removeNavContainersFocusOutDelegate();this._oRenderedColumnPagesBoolMap=null;this._oColumnFocusInfo=null;this._deregisterResizeHandler();this._handleEvent(q.Event("Destroy"));};
j.prototype._removeNavContainersFocusOutDelegate=function(){j.COLUMN_ORDER.forEach(function(s){this._getColumnByStringName(s).removeEventDelegate(this["_"+s+"ColumnFocusOutDelegate"]);},this);};
j.prototype._registerResizeHandler=function(){d(!this._iResizeHandlerId,"Resize handler already registered");this._iResizeHandlerId=R.register(this,this._onResize.bind(this));};
j.prototype._deregisterResizeHandler=function(){if(this._iResizeHandlerId){R.deregister(this._iResizeHandlerId);this._iResizeHandlerId=null;}};
j.prototype._initNavContainers=function(){this.setAggregation("_beginColumnNav",this._createNavContainer("begin"),true);this.setAggregation("_midColumnNav",this._createNavContainer("mid"),true);this.setAggregation("_endColumnNav",this._createNavContainer("end"),true);};
j.prototype._getNavContainers=function(){return[this._getBeginColumn(),this._getMidColumn(),this._getEndColumn()];};
j.prototype._initButtons=function(){var o=new B(this.getId()+"-beginBack",{icon:"sap-icon://slim-arrow-left",tooltip:j._getResourceBundle().getText("FCL_BEGIN_COLUMN_BACK_ARROW"),type:"Transparent",press:function(){this._onArrowClick("left");this._announceMessage("FCL_MIDDLE_COLUMN_EXPANDED_MESSAGE");}.bind(this)}).addStyleClass("sapFFCLNavigationButton").addStyleClass("sapFFCLNavigationButtonRight");this.setAggregation("_beginColumnBackArrow",o,true);var M=new B(this.getId()+"-midForward",{icon:"sap-icon://slim-arrow-right",tooltip:j._getResourceBundle().getText("FCL_MID_COLUMN_FORWARD_ARROW"),type:"Transparent",press:function(){this._onArrowClick("right");this._announceMessage("FCL_FIRST_COLUMN_EXPANDED_MESSAGE");}.bind(this)}).addStyleClass("sapFFCLNavigationButton").addStyleClass("sapFFCLNavigationButtonLeft");this.setAggregation("_midColumnForwardArrow",M,true);var i=new B(this.getId()+"-midBack",{icon:"sap-icon://slim-arrow-left",tooltip:j._getResourceBundle().getText("FCL_MID_COLUMN_BACK_ARROW"),type:"Transparent",press:function(){this._onArrowClick("left");this._announceMessage("FCL_LAST_COLUMN_EXPANDED_MESSAGE");}.bind(this)}).addStyleClass("sapFFCLNavigationButton").addStyleClass("sapFFCLNavigationButtonRight");this.setAggregation("_midColumnBackArrow",i,true);var E=new B(this.getId()+"-endForward",{icon:"sap-icon://slim-arrow-right",tooltip:j._getResourceBundle().getText("FCL_END_COLUMN_FORWARD_ARROW"),type:"Transparent",press:function(){this._onArrowClick("right");this._announceMessage("FCL_MIDDLE_COLUMN_EXPANDED_MESSAGE");}.bind(this)}).addStyleClass("sapFFCLNavigationButton").addStyleClass("sapFFCLNavigationButtonLeft");this.setAggregation("_endColumnForwardArrow",E,true);};
j.prototype._cacheDOMElements=function(){this._cacheColumns();if(!D.system.phone){this._cacheArrows();}};
j.prototype._cacheColumns=function(){this._$columns={begin:this.$("beginColumn"),mid:this.$("midColumn"),end:this.$("endColumn")};};
j.prototype._cacheArrows=function(){this._oColumnSeparatorArrows={beginBack:this.$("beginBack"),midForward:this.$("midForward"),midBack:this.$("midBack"),endForward:this.$("endForward")};};
j.prototype._getVisibleColumnsCount=function(){return j.COLUMN_ORDER.filter(function(s){return this._getColumnSize(s)>0;},this).length;};
j.prototype._getVisibleArrowsCount=function(){if(!this._oColumnSeparatorArrows){return 0;}return Object.keys(this._oColumnSeparatorArrows).filter(function(s){return this._oColumnSeparatorArrows[s].data("visible");},this).length;};
j.prototype._getTotalColumnsWidth=function(H){var s=this._getVisibleArrowsCount();if(H){s++;}return this._getControlWidth()-s*j.NAVIGATION_ARROW_WIDTH;};
j.prototype._resizeColumns=function(){var p,i,n=j.COLUMN_ORDER.slice(),r=sap.ui.getCore().getConfiguration().getRTL(),s=sap.ui.getCore().getConfiguration().getAnimationMode(),H=s!==a.AnimationMode.none&&s!==a.AnimationMode.minimal,o,v,t,u,w,x,y,z={};if(!this.isActive()){return;}v=this._getVisibleColumnsCount();if(v===0){return;}u=this.getLayout();t=this._getMaxColumnsCountForLayout(u,j.DESKTOP_BREAKPOINT);w=n[t-1];y=this.getRestoreFocusOnBackNavigation()&&this._isNavigatingBackward(w)&&!this._isFocusInSomeOfThePreviousColumns();x=(v===3)&&(u===g.ThreeColumnsEndExpanded);i=this._getTotalColumnsWidth(x);if(H){n.forEach(function(E){var S=this._shouldConcealColumn(t,E),G=this._shouldRevealColumn(t,E===w),J=this._$columns[E];J.toggleClass(j.PINNED_COLUMN_CLASS_NAME,S||G);},this);n.forEach(function(E){z[E]=this._oAnimationEndListener.isWaitingForColumnResizeEnd(this._$columns[E]);},this);this._oAnimationEndListener.cancelAll();}n.forEach(function(E){var G=this._$columns[E],J=G.get(0),K,M,S,O,Q,T,U;p=this._getColumnSize(E);K=Math.round(i*(p/100));if([100,0].indexOf(p)!==-1){M=p+"%";}else{M=K+"px";}U={previousAnimationCompleted:!z[G],iNewWidth:K,shouldRestoreFocus:y&&(E===w),hidden:p===0&&this._oColumnWidthInfo[E]===0};if(H){S=this._shouldRevealColumn(t,E===w);O=this._shouldConcealColumn(t,E);Q=S||O;U=f(U,{hasAnimations:true,shouldConcealColumn:O,pinned:Q});T=this._canResizeColumnWithAnimation(E,U);}if(!O){G.toggleClass("sapFFCLColumnActive",p>0);}G.toggleClass("sapFFCLColumnInset",x&&(E==="mid"));G.removeClass("sapFFCLColumnHidden");G.removeClass("sapFFCLColumnOnlyActive");G.removeClass("sapFFCLColumnLastActive");G.removeClass("sapFFCLColumnFirstActive");if(T){R.suspend(J);this._oAnimationEndListener.waitForColumnResizeEnd(G).then(function(){R.resume(J);}).catch(function(){R.resume(J);});}if(!O){G.width(M);}else{this._oAnimationEndListener.waitForAllColumnsResizeEnd().then(function(){G.width(M);}).catch(function(){});}if(T||Q){this._oAnimationEndListener.waitForAllColumnsResizeEnd().then(this._afterColumnResize.bind(this,E,U)).catch(function(){});}else{this._afterColumnResize(E,U);}if(!D.system.phone){this._updateColumnContextualSettings(E,K);this._updateColumnCSSClasses(E,K);}},this);o=n.filter(function(E){return this._getColumnSize(E)>0;},this);if(r){n.reverse();}if(o.length===1){this._$columns[o[0]].addClass("sapFFCLColumnOnlyActive");}if(o.length>1){this._$columns[o[0]].addClass("sapFFCLColumnFirstActive");this._$columns[o[o.length-1]].addClass("sapFFCLColumnLastActive");}this._storePreviousResizingInfo(t,w);};
j.prototype._afterColumnResize=function(s,o){var i=this._$columns[s],S=o.shouldConcealColumn,n=o.iNewWidth,p=o.shouldRestoreFocus;i.toggleClass(j.PINNED_COLUMN_CLASS_NAME,false);if(S){i.removeClass("sapFFCLColumnActive");}i.toggleClass("sapFFCLColumnHidden",n===0);this._cacheColumnWidth(s,n);if(p){this._restoreFocusToColumn(s);}};
j.prototype._getColumnWidth=function(s){var o=this._$columns[s].get(0),i=o.style.width,n=parseInt(i),p;if(/px$/.test(i)){return n;}p=/%$/.test(i);if(p&&(n===100)){return this._getControlWidth();}if(p&&(n===0)){return 0;}return o.offsetWidth;};
j.prototype._cacheColumnWidth=function(s,n){var E;if(this._oColumnWidthInfo[s]!==n){E={};j.COLUMN_ORDER.forEach(function(i){E[i+"Column"]=i===s;});this.fireColumnResize(E);}this._oColumnWidthInfo[s]=n;};
j.prototype._storePreviousResizingInfo=function(v,s){var o=this.getLayout();this._iPreviousVisibleColumnsCount=v;this._bWasFullScreen=o===g.MidColumnFullScreen||o===g.EndColumnFullScreen;this._sPreviuosLastVisibleColumn=s;};
j.prototype._isNavigatingBackward=function(s){return this._bWasFullScreen||j.COLUMN_ORDER.indexOf(this._sPreviuosLastVisibleColumn)>j.COLUMN_ORDER.indexOf(s);};
j.prototype._shouldRevealColumn=function(v,i){return(v>this._iPreviousVisibleColumnsCount)&&!this._bWasFullScreen&&i;};
j.prototype._shouldConcealColumn=function(v,s){return(v<this._iPreviousVisibleColumnsCount&&s===this._sPreviuosLastVisibleColumn&&!this._bWasFullScreen&&this._getColumnSize(s)===0);};
j.prototype._canResizeColumnWithAnimation=function(s,o){var i,n,p=o.iNewWidth,H=o.hasAnimations,r=o.pinned,t=o.hidden,w=!o.previousAnimationCompleted;if(!H||r||t){return false;}i=this._$columns[s];if(w){return i.width()!==p;}n=!i.get(0).style.width;if(n){return false;}return this._getColumnWidth(s)!==p;};
j.prototype._propagateContextualSettings=function(){};
j.prototype._updateColumnContextualSettings=function(s,w){var o,i;o=this.getAggregation("_"+s+"ColumnNav");if(!o){return;}i=o._getContextualSettings();if(!i||i.contextualWidth!==w){o._applyContextualSettings({contextualWidth:w});}};
j.prototype._updateColumnCSSClasses=function(s,w){var n="";this._$columns[s].removeClass("sapUiContainer-Narrow sapUiContainer-Medium sapUiContainer-Wide sapUiContainer-ExtraWide");if(w<D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[0]){n="Narrow";}else if(w<D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[1]){n="Medium";}else if(w<D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[2]){n="Wide";}else{n="ExtraWide";}this._$columns[s].addClass("sapUiContainer-"+n);};
j.prototype._getColumnSize=function(s){var i=this.getLayout(),n=this._getColumnWidthDistributionForLayout(i),S=n.split("/"),M={begin:0,mid:1,end:2},o=S[M[s]];return parseInt(o);};
j.prototype.getMaxColumnsCount=function(){return this._getMaxColumnsCountForWidth(this._getControlWidth());};
j.prototype._getMaxColumnsCountForWidth=function(w){if(w>=j.DESKTOP_BREAKPOINT){return 3;}if(w>=j.TABLET_BREAKPOINT&&w<j.DESKTOP_BREAKPOINT){return 2;}if(w>0){return 1;}return 0;};
j.prototype._getMaxColumnsCountForLayout=function(s,w){var i=this._getMaxColumnsCountForWidth(w),n=this._getColumnWidthDistributionForLayout(s,false,i),S=n.split("/"),M={begin:0,mid:1,end:2},o,p,r=0;Object.keys(M).forEach(function(t){o=S[M[t]];p=parseInt(o);if(p){r++;}});return r;};
j.prototype._onResize=function(E){var o=E.oldSize.width,n=E.size.width,O,M;this._iWidth=n;if(n===0){return;}O=this._getMaxColumnsCountForWidth(o);M=this._getMaxColumnsCountForWidth(n);this._resizeColumns();if(M!==O){this._hideShowArrows();this._fireStateChange(false,true);}};
j.prototype._setColumnPagesRendered=function(i,H){this._oRenderedColumnPagesBoolMap[i]=H;};
j.prototype._hasAnyColumnPagesRendered=function(){return Object.keys(this._oRenderedColumnPagesBoolMap).some(function(K){return this._oRenderedColumnPagesBoolMap[K];},this);};
j.prototype._onArrowClick=function(s){var i=this.getLayout(),n=typeof j.SHIFT_TARGETS[i]!=="undefined"&&typeof j.SHIFT_TARGETS[i][s]!=="undefined",o;d(n,"An invalid layout was used for determining arrow behavior");o=n?j.SHIFT_TARGETS[i][s]:g.OneColumn;this.setLayout(o);if(j.ARROWS_NAMES[o][s]!==j.ARROWS_NAMES[i][s]&&n){var O=s==='right'?'left':'right';this._oColumnSeparatorArrows[j.ARROWS_NAMES[o][O]].trigger("focus");}this._fireStateChange(true,false);};
j.prototype._hideShowArrows=function(){var s=this.getLayout(),M={},n=[],i,o;if(!this.isActive()||D.system.phone){return;}i=this.getMaxColumnsCount();if(i>1){M[g.TwoColumnsBeginExpanded]=["beginBack"];M[g.TwoColumnsMidExpanded]=["midForward"];M[g.ThreeColumnsMidExpanded]=["midForward","midBack"];M[g.ThreeColumnsEndExpanded]=["endForward"];M[g.ThreeColumnsMidExpandedEndHidden]=["midForward","midBack"];M[g.ThreeColumnsBeginExpandedEndHidden]=["beginBack"];if(typeof M[s]==="object"){n=M[s];}}o=this._hasAnyColumnPagesRendered();Object.keys(this._oColumnSeparatorArrows).forEach(function(p){this._toggleButton(p,n.indexOf(p)!==-1,o);},this);};
j.prototype._toggleButton=function(s,S,r){this._oColumnSeparatorArrows[s].toggle(S&&r);this._oColumnSeparatorArrows[s].data("visible",S);};
j.prototype._fireStateChange=function(i,n){if(this._getControlWidth()===0){return;}this.fireStateChange({isNavigationArrow:i,isResize:n,layout:this.getLayout(),maxColumnsCount:this.getMaxColumnsCount()});};
j.prototype.setInitialBeginColumnPage=function(p){this._getBeginColumn().setInitialPage(p);this.setAssociation('initialBeginColumnPage',p,true);return this;};
j.prototype.setInitialMidColumnPage=function(p){this._getMidColumn().setInitialPage(p);this.setAssociation('initialMidColumnPage',p,true);return this;};
j.prototype.setInitialEndColumnPage=function(p){this._getEndColumn().setInitialPage(p);this.setAssociation('initialEndColumnPage',p,true);return this;};
j.prototype.to=function(p,t,o,T){if(this._getBeginColumn().getPage(p)){this._getBeginColumn().to(p,t,o,T);}else if(this._getMidColumn().getPage(p)){this._getMidColumn().to(p,t,o,T);}else{this._getEndColumn().to(p,t,o,T);}return this;};
j.prototype.backToPage=function(p,o,t){if(this._getBeginColumn().getPage(p)){this._getBeginColumn().backToPage(p,o,t);}else if(this._getMidColumn().getPage(p)){this._getMidColumn().backToPage(p,o,t);}else{this._getEndColumn().backToPage(p,o,t);}return this;};
j.prototype._safeBackToPage=function(p,t,i,T){if(this._getBeginColumn().getPage(p)){this._getBeginColumn()._safeBackToPage(p,t,i,T);}else if(this._getMidColumn().getPage(p)){this._getMidColumn()._safeBackToPage(p,t,i,T);}else{this._getEndColumn()._safeBackToPage(p,t,i,T);}};
j.prototype.toBeginColumnPage=function(p,t,o,T){this._getBeginColumn().to(p,t,o,T);return this;};
j.prototype.toMidColumnPage=function(p,t,o,T){this._getMidColumn().to(p,t,o,T);return this;};
j.prototype.toEndColumnPage=function(p,t,o,T){this._getEndColumn().to(p,t,o,T);return this;};
j.prototype.backBeginColumn=function(i,t){return this._getBeginColumn().back(i,t);};
j.prototype.backMidColumn=function(i,t){return this._getMidColumn().back(i,t);};
j.prototype.backEndColumn=function(i,t){return this._getEndColumn().back(i,t);};
j.prototype.backBeginColumnToPage=function(p,i,t){return this._getBeginColumn().backToPage(p,i,t);};
j.prototype.backMidColumnToPage=function(p,i,t){return this._getMidColumn().backToPage(p,i,t);};
j.prototype.backEndColumnToPage=function(p,i,t){return this._getEndColumn().backToPage(p,i,t);};
j.prototype.backToTopBeginColumn=function(o,t){this._getBeginColumn().backToTop(o,t);return this;};
j.prototype.backToTopMidColumn=function(o,t){this._getMidColumn().backToTop(o,t);return this;};
j.prototype.backToTopEndColumn=function(o,t){this._getEndColumn().backToTop(o,t);return this;};
j.prototype.getCurrentBeginColumnPage=function(){return this._getBeginColumn().getCurrentPage();};
j.prototype.getCurrentMidColumnPage=function(){return this._getMidColumn().getCurrentPage();};
j.prototype.getCurrentEndColumnPage=function(){return this._getEndColumn().getCurrentPage();};
j.prototype.setDefaultTransitionNameBeginColumn=function(t){this.setProperty("defaultTransitionNameBeginColumn",t,true);this._getBeginColumn().setDefaultTransitionName(t);return this;};
j.prototype.setDefaultTransitionNameMidColumn=function(t){this.setProperty("defaultTransitionNameMidColumn",t,true);this._getMidColumn().setDefaultTransitionName(t);return this;};
j.prototype.setDefaultTransitionNameEndColumn=function(t){this.setProperty("defaultTransitionNameEndColumn",t,true);this._getEndColumn().setDefaultTransitionName(t);return this;};
j.prototype._getLayoutHistory=function(){return this._oLayoutHistory;};
j.prototype._getColumnWidthDistributionForLayout=function(s,i,M){var o={},r;M||(M=this.getMaxColumnsCount());if(M===0){r="0/0/0";}else{o[g.OneColumn]="100/0/0";o[g.MidColumnFullScreen]="0/100/0";o[g.EndColumnFullScreen]="0/0/100";if(M===1){o[g.TwoColumnsBeginExpanded]="0/100/0";o[g.TwoColumnsMidExpanded]="0/100/0";o[g.ThreeColumnsMidExpanded]="0/0/100";o[g.ThreeColumnsEndExpanded]="0/0/100";o[g.ThreeColumnsMidExpandedEndHidden]="0/0/100";o[g.ThreeColumnsBeginExpandedEndHidden]="0/0/100";}else{o[g.TwoColumnsBeginExpanded]="67/33/0";o[g.TwoColumnsMidExpanded]="33/67/0";o[g.ThreeColumnsMidExpanded]=M===2?"0/67/33":"25/50/25";o[g.ThreeColumnsEndExpanded]=M===2?"0/33/67":"25/25/50";o[g.ThreeColumnsMidExpandedEndHidden]="33/67/0";o[g.ThreeColumnsBeginExpandedEndHidden]="67/33/0";}r=o[s];}if(i){r=r.split("/").map(function(n){return parseInt(n);});}return r;};
j.DESKTOP_BREAKPOINT=1280;j.TABLET_BREAKPOINT=960;j.ARROWS_NAMES={TwoColumnsBeginExpanded:{"left":"beginBack"},TwoColumnsMidExpanded:{"right":"midForward"},ThreeColumnsMidExpanded:{"left":"midBack","right":"midForward"},ThreeColumnsEndExpanded:{"right":"endForward"},ThreeColumnsMidExpandedEndHidden:{"left":"midBack","right":"midForward"},ThreeColumnsBeginExpandedEndHidden:{"left":"beginBack"}};
j._getResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.f");};
j.SHIFT_TARGETS={TwoColumnsBeginExpanded:{"left":g.TwoColumnsMidExpanded},TwoColumnsMidExpanded:{"right":g.TwoColumnsBeginExpanded},ThreeColumnsMidExpanded:{"left":g.ThreeColumnsEndExpanded,"right":g.ThreeColumnsMidExpandedEndHidden},ThreeColumnsEndExpanded:{"right":g.ThreeColumnsMidExpanded},ThreeColumnsMidExpandedEndHidden:{"left":g.ThreeColumnsMidExpanded,"right":g.ThreeColumnsBeginExpandedEndHidden},ThreeColumnsBeginExpandedEndHidden:{"left":g.ThreeColumnsMidExpandedEndHidden}};
j.prototype.showPlaceholder=function(s){if(!sap.ui.getCore().getConfiguration().getPlaceholder()){return;}switch(s&&s.aggregation){case"beginColumnPages":return this.getAggregation("_beginColumnNav").showPlaceholder(s);case"midColumnPages":return this.getAggregation("_midColumnNav").showPlaceholder(s);default:return this.getAggregation("_endColumnNav").showPlaceholder(s);}};
j.prototype.hidePlaceholder=function(s){switch(s.aggregation){case"beginColumnPages":this.getAggregation("_beginColumnNav").hidePlaceholder(s);break;case"midColumnPages":this.getAggregation("_midColumnNav").hidePlaceholder(s);break;default:this.getAggregation("_endColumnNav").hidePlaceholder(s);}};
j.prototype.needPlaceholder=function(s,o){var i;switch(s){case"beginColumnPages":i=this.getAggregation("_beginColumnNav");break;case"midColumnPages":i=this.getAggregation("_midColumnNav");break;default:i=this.getAggregation("_endColumnNav");}return!o||(i.getCurrentPage()!==o);};
function k(){this._aLayoutHistory=[];}
k.prototype.addEntry=function(s){if(typeof s!=="undefined"){this._aLayoutHistory.push(s);}};
k.prototype.getClosestEntryThatMatches=function(n){var i;for(i=this._aLayoutHistory.length-1;i>=0;i--){if(n.indexOf(this._aLayoutHistory[i])!==-1){return this._aLayoutHistory[i];}}};
function A(){this._oListeners={};this._aPendingPromises=[];this._oPendingPromises={};this._oCancelPromises={};this._oPendingPromiseAll=null;}
A.prototype.waitForColumnResizeEnd=function($){var i=$.get(0).id,p;if(!this._oPendingPromises[i]){p=new Promise(function(r,n){L.debug("FlexibleColumnLayout","wait for column "+i+" to resize");this._attachTransitionEnd($,function(){L.debug("FlexibleColumnLayout","completed column "+i+" resize");this._cleanUp($);r();}.bind(this));this._oCancelPromises[i]={cancel:function(){L.debug("FlexibleColumnLayout","cancel column "+i+" resize");this._cleanUp($);n();}.bind(this)};}.bind(this));this._aPendingPromises.push(p);this._oPendingPromises[i]=p;}return this._oPendingPromises[i];};
A.prototype.waitForAllColumnsResizeEnd=function(){if(!this._oPendingPromiseAll){this._oPendingPromiseAll=new Promise(function(r,i){this.iTimer=setTimeout(function(){Promise.all(this._aPendingPromises).then(function(){L.debug("FlexibleColumnLayout","completed all columns resize");r();},0).catch(function(){i();});this.iTimer=null;}.bind(this));}.bind(this));}return this._oPendingPromiseAll;};
A.prototype.isWaitingForColumnResizeEnd=function($){var i=$.get(0).id;return!!this._oListeners[i];};
A.prototype.cancelAll=function(){Object.keys(this._oCancelPromises).forEach(function(i){this._oCancelPromises[i].cancel();},this);this._oPendingPromises={};this._aPendingPromises=[];this._oCancelPromises={};this._oPendingPromiseAll=null;if(this.iTimer){clearTimeout(this.iTimer);this.iTimer=null;}L.debug("FlexibleColumnLayout","detached all listeners for columns resize");};
A.prototype._attachTransitionEnd=function($,i){var s=$.get(0).id;if(!this._oListeners[s]){$.on("webkitTransitionEnd transitionend",i);this._oListeners[s]=i;}};
A.prototype._detachTransitionEnd=function($){var i=$.get(0).id;if(this._oListeners[i]){$.off("webkitTransitionEnd transitionend",this._oListeners[i]);this._oListeners[i]=null;}};
A.prototype._cleanUp=function($){if($.length){var i=$.get(0).id;this._detachTransitionEnd($);delete this._oPendingPromises[i];delete this._oCancelPromises[i];}};
return j;});
sap.ui.predefine('sap/f/FlexibleColumnLayoutAccessibleLandmarkInfo',['sap/ui/core/Element','./library'],function(E,l){"use strict";
var F=E.extend("sap.f.FlexibleColumnLayoutAccessibleLandmarkInfo",{metadata:{library:"sap.f",properties:{firstColumnLabel:{type:"string",defaultValue:null},middleColumnLabel:{type:"string",defaultValue:null},lastColumnLabel:{type:"string",defaultValue:null}}}});
return F;});
sap.ui.predefine('sap/f/FlexibleColumnLayoutRenderer',["sap/ui/core/InvisibleText","sap/ui/Device","sap/m/library"],function(I,D,m){"use strict";var F={apiVersion:2};
F.render=function(r,c){var b=c.getBackgroundDesign(),l=c.getLandmarkInfo();r.openStart("div",c);r.class("sapFFCL");if(b!==m.BackgroundDesign.Transparent){r.class("sapFFCLBackgroundDesign"+b);}r.openEnd();F.renderBeginColumn(r,c,l);F.renderMidColumn(r,c,l);F.renderEndColumn(r,c,l);r.close("div");};
F.renderBeginColumn=function(r,c,l){var b=c.getAggregation("_beginColumnBackArrow");r.openStart("div",c.getId()+"-beginColumn");r.accessibilityState(c,c._formatLandmarkInfo(l,"FirstColumn"));r.class("sapFFCLColumn");r.class("sapFFCLColumnBegin");r.class("sapFFCLColumnActive");r.openEnd();F.renderColumnContentWrapper(r);r.close("div");F.renderArrow(r,b);};
F.renderMidColumn=function(r,c,l){var M=c.getAggregation("_midColumnForwardArrow"),o=c.getAggregation("_midColumnBackArrow");F.renderArrow(r,M);r.openStart("div",c.getId()+"-midColumn");r.accessibilityState(c,c._formatLandmarkInfo(l,"MiddleColumn"));r.class("sapFFCLColumn");r.class("sapFFCLColumnMid");r.openEnd();F.renderColumnContentWrapper(r);r.close("div");F.renderArrow(r,o);};
F.renderEndColumn=function(r,c,l){var e=c.getAggregation("_endColumnForwardArrow");F.renderArrow(r,e);r.openStart("div",c.getId()+"-endColumn");r.accessibilityState(c,c._formatLandmarkInfo(l,"LastColumn"));r.class("sapFFCLColumn");r.class("sapFFCLColumnEnd");r.openEnd();F.renderColumnContentWrapper(r);r.close("div");};
F.renderArrow=function(r,a){if(!D.system.phone){r.openStart("div");r.class("sapFFCLArrow");r.class("sapContrastPlus");r.openEnd();r.renderControl(a);r.close("div");}};
F.renderColumnContentWrapper=function(r){r.openStart("div");r.class("sapFFCLColumnContent");r.openEnd();r.close("div");};
return F;},true);
sap.ui.predefine('sap/f/FlexibleColumnLayoutSemanticHelper',["./library","./FlexibleColumnLayout","sap/base/assert"],function(l,F,a){"use strict";var L=l.LayoutType;var b=function(f,s){var m={Normal:3,MasterDetail:2,SingleColumn:1},i,M;s||(s={});this._oFCL=f;this._defaultLayoutType=L.OneColumn;this._defaultTwoColumnLayoutType=[L.TwoColumnsBeginExpanded,L.TwoColumnsMidExpanded].indexOf(s.defaultTwoColumnLayoutType)!==-1?s.defaultTwoColumnLayoutType:L.TwoColumnsBeginExpanded;this._defaultThreeColumnLayoutType=[L.ThreeColumnsMidExpanded,L.ThreeColumnsEndExpanded].indexOf(s.defaultThreeColumnLayoutType)!==-1?s.defaultThreeColumnLayoutType:L.ThreeColumnsMidExpanded;if(["Normal","MasterDetail","SingleColumn"].indexOf(s.mode)!==-1&&!s.maxColumnsCount){M=m[s.mode];}else{M=s.maxColumnsCount?parseInt(s.maxColumnsCount):3;if(M<1||M>3){M=3;}}this._maxColumnsCount=M;i=s.initialColumnsCount?parseInt(s.initialColumnsCount):1;if(i<1||i>2||this._maxColumnsCount===1){i=1;}this._initialColumnsCount=i;};b._oInstances={};
b.getInstanceFor=function(f,s){a(f instanceof F,"Passed control is not FlexibleColumnLayout");var i=f.getId();if(typeof b._oInstances[i]==="undefined"){b._oInstances[i]=new b(f,s);var d={onDestroy:function(){delete b._oInstances[i];}};f.addEventDelegate(d);}return b._oInstances[i];};
b.prototype.getCurrentUIState=function(){var c=this._oFCL.getLayout();return this._getUIStateForLayout(c);};
b.prototype.getNextUIState=function(n){var c=this._oFCL.getLayout(),i=this._initialColumnsCount,N;if(n===0){if(i===2&&this._canShowTwoColumns()){N=this._defaultTwoColumnLayoutType;}else{N=L.OneColumn;}}if(n===1){if(this._maxColumnsCount===1){N=L.MidColumnFullScreen;}else{if([L.TwoColumnsBeginExpanded,L.TwoColumnsMidExpanded].indexOf(c)!==-1){N=c;}else if([L.MidColumnFullScreen,L.EndColumnFullScreen].indexOf(c)!==-1){N=L.MidColumnFullScreen;}else{N=this._defaultTwoColumnLayoutType;}}}if(n===2){if(this._maxColumnsCount<3){N=L.EndColumnFullScreen;}else{if([L.ThreeColumnsMidExpandedEndHidden,L.ThreeColumnsBeginExpandedEndHidden].indexOf(c)!==-1){N=this._defaultThreeColumnLayoutType;}else if([L.ThreeColumnsMidExpanded,L.ThreeColumnsEndExpanded].indexOf(c)!==-1){N=c;}else if([L.MidColumnFullScreen,L.EndColumnFullScreen].indexOf(c)!==-1){N=L.EndColumnFullScreen;}else{N=this._defaultThreeColumnLayoutType;}}}if(n>2){N=L.EndColumnFullScreen;}return this._getUIStateForLayout(N);};
b.prototype._getUIStateForLayout=function(s){var S=this._oFCL._getColumnWidthDistributionForLayout(s,true),c=S.join("/"),m=this._oFCL.getMaxColumnsCount();return{layout:s,maxColumnsCount:m,columnsSizes:this._getColumnsSizes(S),columnsVisibility:this._getColumnsVisibility(S),isFullScreen:this._getIsFullScreen(S),isLogicallyFullScreen:this._getIsLogicallyFullScreen(s),actionButtonsInfo:this._getActionButtonsInfo(c,m)};};
b.prototype._getColumnsSizes=function(s){return{beginColumn:s[0],midColumn:s[1],endColumn:s[2]};};
b.prototype._getColumnsVisibility=function(s){return{beginColumn:s[0]!==0,midColumn:s[1]!==0,endColumn:s[2]!==0};};
b.prototype._getIsFullScreen=function(s){return s.indexOf(100)!==-1;};
b.prototype._getIsLogicallyFullScreen=function(s){return[L.OneColumn,L.MidColumnFullScreen,L.EndColumnFullScreen].indexOf(s)!==-1;};
b.prototype._getActionButtonsInfo=function(c,m){var M={fullScreen:null,exitFullScreen:null,closeColumn:null},e={fullScreen:null,exitFullScreen:null,closeColumn:null},E,s;if(this._maxColumnsCount===1){return{midColumn:M,endColumn:e};}if(m===1){M.closeColumn=this._defaultLayoutType;e.closeColumn=this._defaultTwoColumnLayoutType;}else{if(c==="67/33/0"||c==="33/67/0"){M.fullScreen=L.MidColumnFullScreen;M.closeColumn=this._defaultLayoutType;}if(c==="25/50/25"||c==="25/25/50"||c==="0/67/33"||c==="0/33/67"){e.fullScreen=L.EndColumnFullScreen;e.closeColumn=this._defaultTwoColumnLayoutType;}if(c==="0/100/0"){E=[L.TwoColumnsBeginExpanded,L.TwoColumnsMidExpanded,L.ThreeColumnsBeginExpandedEndHidden,L.ThreeColumnsMidExpandedEndHidden];s=this._oFCL._getLayoutHistory().getClosestEntryThatMatches(E)||this._defaultTwoColumnLayoutType;M.exitFullScreen=s;M.closeColumn=this._defaultLayoutType;}if(c==="0/0/100"){if(this._maxColumnsCount!==2){E=[L.ThreeColumnsMidExpanded,L.ThreeColumnsEndExpanded];s=this._oFCL._getLayoutHistory().getClosestEntryThatMatches(E)||this._defaultThreeColumnLayoutType;e.exitFullScreen=s;e.closeColumn=this._defaultTwoColumnLayoutType;}}}return{midColumn:M,endColumn:e};};
b.prototype.getDefaultLayouts=function(){return{defaultLayoutType:this._defaultLayoutType,defaultTwoColumnLayoutType:this._defaultTwoColumnLayoutType,defaultThreeColumnLayoutType:this._defaultThreeColumnLayoutType};};
b.prototype._canShowTwoColumns=function(){var c=this._oFCL._getControlWidth(),m=this._oFCL._getMaxColumnsCountForWidth(c||window.innerWidth);return m>1;};
b.prototype.isReady=function(){return this.isDOMReady();};
b.prototype.isDOMReady=function(){return this._oFCL.getDomRef()!==null;};
b.prototype.whenReady=function(){var t=this;return new Promise(function(r,c){t.whenDOMReady().then(function(){r();}).catch(function(d){c(d);});});};
b.prototype.whenDOMReady=function(){var t=this;var d=new Promise(function(r,c){if(!t._oFCL||t._oFCL.bIsDestroyed){c('FlexibleColumnLayout reference missing. Please make sure FlexibleColumnLayoutSemanticHelper is properly initialized.');}if(t._oFCL.getDomRef()){r();}else{var D={onAfterRendering:function(){t._oFCL.removeEventDelegate(D);r();}};t._oFCL.addEventDelegate(D);}});return d;};
return b;},true);
sap.ui.predefine('sap/f/GridContainer',["./GridContainerRenderer","./GridContainerSettings","./GridContainerUtils","./GridNavigationMatrix","./delegate/GridContainerItemNavigation","./library","./dnd/GridKeyboardDragAndDrop","sap/base/strings/capitalize","sap/ui/base/ManagedObjectObserver","sap/ui/core/Control","sap/ui/core/Core","sap/ui/core/ResizeHandler","sap/ui/Device","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery"],function(G,a,b,c,d,l,e,f,M,C,g,R,D,K,q){"use strict";var o={"sap.f.Card":function(m){return m.getCardHeader()||m.getCardContent();},"sap.ui.integration.widgets.Card":function(m){return m.getCardHeader()||m.getCardContent();},"sap.m.GenericTile":function(){return true;}};
function h(m){var n=m.getLayoutData();return n?n.getColumns():1;}
function i(m){var n=m.getLayoutData();return n?n.getActualRows():1;}
function j(m){var n=m.getLayoutData();return n?n.hasAutoHeight():true;}
var k=C.extend("sap.f.GridContainer",{metadata:{library:"sap.f",interfaces:["sap.f.dnd.IGridDroppable"],properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:""},minHeight:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"2rem"},containerQuery:{type:"boolean",group:"Behavior",defaultValue:false},snapToRow:{type:"boolean",group:"Appearance",defaultValue:false},allowDenseFill:{type:"boolean",group:"Appearance",defaultValue:false},inlineBlockLayout:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Control",multiple:true,singularName:"item",dnd:true},layout:{type:"sap.f.GridContainerSettings",multiple:false},layoutXS:{type:"sap.f.GridContainerSettings",multiple:false},layoutS:{type:"sap.f.GridContainerSettings",multiple:false},layoutM:{type:"sap.f.GridContainerSettings",multiple:false},layoutL:{type:"sap.f.GridContainerSettings",multiple:false},layoutXL:{type:"sap.f.GridContainerSettings",multiple:false},_defaultLayout:{type:"sap.f.GridContainerSettings",multiple:false,visibility:"hidden"}},events:{layoutChange:{parameters:{layout:{type:"string"}}},columnsChange:{parameters:{columns:{type:"int"}}},borderReached:{parameters:{event:{type:"jQuery.Event"},direction:{type:"sap.f.NavigationDirection"},row:{type:"int"},column:{type:"int"}}}},dnd:{draggable:false,droppable:true}}});
k.prototype.bUseExtendedChangeDetection=true;
k.prototype.getActiveLayoutSettings=function(){var s=this.getAggregation(this._sActiveLayout);if(!s&&this._sActiveLayout==="layoutXS"){s=this.getAggregation("layoutS");}if(!s){s=this.getAggregation("layout")||this.getAggregation("_defaultLayout");}return s;};
k.prototype._onBeforeItemRendering=function(){var m=this.getParent();if(m._resizeListeners[this.getId()]){R.deregister(m._resizeListeners[this.getId()]);delete m._resizeListeners[this.getId()];}m._reflectItemVisibilityToWrapper(this);};
k.prototype._onAfterItemRendering=function(){var m=this.getParent();m._checkOwnVisualFocus(this);m._resizeListeners[this.getId()]=R.register(this,m._resizeItemHandler);m._setItemNavigationItems();m._applyItemAutoRows(this);if(this.getAriaRoleDescription){var L=this.getDomRef().parentElement,A=this.getAriaRoleDescription();if(L.classList.contains("sapFGridContainerItemWrapper")){if(A){L.setAttribute("aria-roledescription",A);}else{L.removeAttribute("aria-roledescription");}}}};
k.prototype._reflectItemVisibilityToWrapper=function(I){var m=b.getItemWrapper(I),$;if(!m){return;}$=q(m);if(I.getVisible()&&$.hasClass("sapFGridContainerInvisiblePlaceholder")){$.removeClass("sapFGridContainerInvisiblePlaceholder");}else if(!I.getVisible()&&!$.hasClass("sapFGridContainerInvisiblePlaceholder")){$.addClass("sapFGridContainerInvisiblePlaceholder");}};
k.prototype._onItemChange=function(m){if(m.name!=="items"||!m.child){return;}if(m.mutation==="insert"){m.child.addEventDelegate(this._itemDelegate,m.child);}else if(m.mutation==="remove"){m.child.removeEventDelegate(this._itemDelegate,m.child);}};
k.prototype._deregisterResizeListeners=function(){var m,n;for(m in this._resizeListeners){n=this._resizeListeners[m];R.deregister(n);}delete this._resizeListeners;D.resize.detachHandler(this._resizeDeviceHandler);};
k.prototype._setItemNavigationItems=function(){if(!this._isRenderingFinished){return;}var t=this,w=[];if(!t._oItemNavigation){t._oItemNavigation=new d().setCycling(false).setDisabledModifiers({sapnext:["alt","meta","ctrl"],sapprevious:["alt","meta","ctrl"]}).setFocusedIndex(0);t.addDelegate(this._oItemNavigation);}t.$().children().map(function(I,W){if(W.getAttribute("class").indexOf("sapFGridContainerItemWrapper")>-1){w.push(W);}});t._oItemNavigation.setRootDomRef(t.getDomRef());t._oItemNavigation.setItemDomRefs(w);};
k.prototype._detectActiveLayout=function(){var w=(this.getContainerQuery()&&this.getDomRef())?this._getComputedWidth():D.resize.width,r=D.media.getCurrentRange("GridContainerRangeSet",w),L="layout"+r.name,O=this.getActiveLayoutSettings(),s=false;if(!w){return false;}if(this._sActiveLayout!==L){this.addStyleClass("sapFGridContainer"+f(L));if(this._sActiveLayout){this.removeStyleClass("sapFGridContainer"+f(this._sActiveLayout));}this._sActiveLayout=L;s=O!==this.getActiveLayoutSettings();this.fireLayoutChange({layout:this._sActiveLayout});}return s;};
k.prototype._detectColumnsChange=function(){var s=this.getActiveLayoutSettings(),w=this.$().innerWidth(),m;if(!s){return;}m=s.getComputedColumnsCount(w);if(this._iColumns!==m){this.fireColumnsChange({columns:m});this._iColumns=m;}};
k.prototype._getActiveGridStyles=function(){var s=this.getActiveLayoutSettings(),m=s.getColumns()||"auto-fill",n=s.getColumnSize(),p=s.getMinColumnSize(),r=s.getMaxColumnSize(),S={"grid-gap":s.getGap()};if(p&&r){S["grid-template-columns"]="repeat("+m+", minmax("+p+", "+r+"))";}else{S["grid-template-columns"]="repeat("+m+", "+n+")";}if(this.getInlineBlockLayout()){S["grid-auto-rows"]="min-content";}else{S["grid-auto-rows"]=s.getRowSize();}return S;};
k.prototype.init=function(){this._oRb=g.getLibraryResourceBundle("sap.f");this.setAggregation("_defaultLayout",new a());this._initRangeSet();this._resizeListeners={};this._oItemNavigation=null;this._itemDelegate={onBeforeRendering:this._onBeforeItemRendering,onAfterRendering:this._onAfterItemRendering};this._itemsObserver=new M(this._onItemChange.bind(this));this._itemsObserver.observe(this,{aggregations:["items"]});this._resizeHandler=this._resize.bind(this);this._resizeDeviceHandler=this._resizeDevice.bind(this);D.resize.attachHandler(this._resizeDeviceHandler);this._resizeItemHandler=this._resizeItem.bind(this);};
k.prototype.insertItem=function(I,m){this.insertAggregation("items",I,m,true);if(!this.getDomRef()||!I.getVisible()){this.invalidate();return this;}var r=g.createRenderManager(),w=this._createItemWrapper(I),n=this._getItemAt(m+1),p=this.getDomRef();if(n){p.insertBefore(w,b.getItemWrapper(n));}else{p.insertBefore(w,p.lastChild);}r.render(I,w);r.destroy();return this;};
k.prototype.removeItem=function(I){var r=this.removeAggregation("items",I,true),m=this.getDomRef(),n=r.getDomRef();if(!m||!n){this.invalidate();return r;}m.removeChild(n.parentElement);return r;};
k.prototype.onBeforeRendering=function(){this._detectActiveLayout();var r=this._resizeListeners[this.getId()];if(r){R.deregister(r);}this._isRenderingFinished=false;this._lastGridWidth=null;this._lastViewportWidth=null;};
k.prototype.onAfterRendering=function(){this._resizeListeners[this.getId()]=R.register(this.getDomRef(),this._resizeHandler);this._isRenderingFinished=true;this._setItemNavigationItems();this._applyLayout(true);if(this.getItems().length===1&&this._forceFocus){this.focusItem(0);this._forceFocus=false;}};
k.prototype.exit=function(){this._deregisterResizeListeners();if(this._itemsObserver){this._itemsObserver.disconnect();delete this._itemsObserver;}if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;this._oItemNavigation=null;}this._forceFocus=null;if(this._checkColumnsTimeout){clearTimeout(this._checkColumnsTimeout);this._checkColumnsTimeout=null;}};
k.prototype._initRangeSet=function(){if(!D.media.hasRangeSet("GridContainerRangeSet")){D.media.initRangeSet("GridContainerRangeSet",[375,600,1024,1440],"px",["XS","S","M","L","XL"]);}};
k.prototype._resize=function(){if(!this._isWidthChanged()){return;}var s=this._detectActiveLayout();this._applyLayout(s);};
k.prototype._resizeDevice=function(){if(!this.getContainerQuery()){this._resize();}};
k.prototype._isWidthChanged=function(){var m=this._getComputedWidth(),v=D.resize.width;if(this._lastGridWidth===m&&this._lastViewportWidth===v){return false;}this._lastGridWidth=m;this._lastViewportWidth=v;return true;};
k.prototype._getComputedWidth=function(){if(!this.getDomRef()){return null;}return this.getDomRef().getBoundingClientRect().width;};
k.prototype._resizeItem=function(E){this._applyItemAutoRows(E.control);};
k.prototype._applyLayout=function(s){if(!this._isRenderingFinished){return;}if(s){this.$().css(this._getActiveGridStyles());this.getItems().forEach(this._applyItemAutoRows.bind(this));}this._checkColumns();};
k.prototype._checkColumns=function(){if(this._checkColumnsTimeout){clearTimeout(this._checkColumnsTimeout);this._checkColumnsTimeout=null;}this._checkColumnsTimeout=setTimeout(function(){this._detectColumnsChange();this._enforceMaxColumns();}.bind(this),0);};
k.prototype._applyItemAutoRows=function(I){if(!this._isRenderingFinished){return;}if(this.getInlineBlockLayout()){return;}if(j(I)){var $=I.$(),s=this.getActiveLayoutSettings(),H=I.getDomRef()?I.getDomRef().getBoundingClientRect().height:0,r=s.calculateRowsForItem(Math.round(H));if(!r){return;}$.parent().css({'grid-row':'span '+Math.max(r,i(I))});}};
k.prototype._enforceMaxColumns=function(){var s=this.getActiveLayoutSettings(),m;if(!s){return;}m=s.getComputedColumnsCount(this.$().innerWidth());if(!m){return;}this.getItems().forEach(function(I){I.$().parent().css("grid-column","span "+Math.min(h(I),m));});};
k.prototype._getItemAt=function(I){var m=this.getItems(),t;if(I<0){I=0;}if(m.length&&m[I]){t=m[I];}return t;};
k.prototype._createItemWrapper=function(I){var s=G.getStylesForItemWrapper(I,this),S=s.styles,m=s.classes,w=document.createElement("div");w.setAttribute("tabindex","0");S.forEach(function(v,n){w.style.setProperty(n,v);});m.forEach(function(v){w.classList.add(v);});return w;};
k.prototype.onItemNavigationBorderReached=function(p){this.fireEvent("borderReached",p);};
["onkeypress","onkeyup","onkeydown","onsapenter","onsapselect","onsapspace"].forEach(function(n){k.prototype[n]=function(E){if(!this._isItemWrapper(E.target)){return;}if(n==="onsapspace"){E.preventDefault();}var I=q(E.target.firstChild).control()[0];if(I){var F=I.getFocusDomRef(),m=q(F).control()[0];if(m&&m[n]){m[n].call(m,E);}}};});
k.prototype._checkOwnVisualFocus=function(m){var n=m.getMetadata().getName(),F;if(o[n]&&o[n](m)){F=m.getFocusDomRef();F.setAttribute("tabindex",-1);F.tabIndex=-1;b.getItemWrapper(m).classList.add("sapFGridContainerItemWrapperNoVisualFocus");}};
k.prototype._moveItem=function(E){if(!this._isItemWrapper(E.target)){return;}var I=q(E.target.firstElementChild).control(0),L=this.getItems().length,m=this.indexOfItem(I),n=-1,p,r=[];switch(E.keyCode){case K.ARROW_RIGHT:n=g.getConfiguration().getRTL()?m-1:m+1;if(n>=0&&n<L){p=b.createConfig(this,this.getItems()[n]);p.dropPosition="After";r=[p];}break;case K.ARROW_LEFT:n=g.getConfiguration().getRTL()?m+1:m-1;if(n>=0&&n<L){p=b.createConfig(this,this.getItems()[n]);p.dropPosition="Before";r=[p];}break;case K.ARROW_UP:r=b.findDropTargetsAbove(this,I);r.forEach(function(p){p.dropPosition="Before";});break;case K.ARROW_DOWN:r=b.findDropTargetsBelow(this,I);r.forEach(function(p){p.dropPosition=(this.indexOfItem(p.item)!==-1)?"After":"Before";}.bind(this));break;default:break;}E.stopPropagation();e.fireDnD(I,r,E);this._setItemNavigationItems();};
k.prototype.onsapincreasemodifiers=k.prototype._moveItem;k.prototype.onsapdecreasemodifiers=k.prototype._moveItem;
k.prototype.focusItem=function(I){var m,n=this._oItemNavigation;this._forceFocus=true;this._setItemNavigationItems();m=n.getItemDomRefs();if(m[I]){n.setFocusedIndex(I);m[I].focus();}};
k.prototype.focusItemByDirection=function(s,r,m){this._oItemNavigation.focusItemByDirection(this,s,r,m);};
k.prototype.getNavigationMatrix=function(){if(!g.isThemeApplied()){return null;}var m=window.getComputedStyle(this.getDomRef()),n=m.gridTemplateRows.split(/\s+/),p=m.gridTemplateColumns.split(/\s+/),L=this.getActiveLayoutSettings();var I=this.getItems().reduce(function(A,r){if(r.getVisible()){A.push(b.getItemWrapper(r));}return A;},[]);return c.create(this.getDomRef(),I,{gap:L.getGapInPx(),rows:n,columns:p});};
k.prototype._isItemWrapper=function(E){return E.classList.contains("sapFGridContainerItemWrapper");};
return k;});
sap.ui.predefine('sap/f/GridContainerItemLayoutData',['sap/ui/core/LayoutData'],function(L){"use strict";
var G=L.extend("sap.f.GridContainerItemLayoutData",{metadata:{library:"sap.f",properties:{columns:{type:"int",group:"Misc",defaultValue:1},minRows:{type:"int",group:"Misc"},rows:{type:"int",group:"Misc"}}}});
G.prototype.hasAutoHeight=function(){return!this.getRows();};
G.prototype.getActualRows=function(){return Math.max(this.getRows()||1,this.getMinRows()||1);};
return G;});
sap.ui.predefine('sap/f/GridContainerRenderer',[],function(){"use strict";var G={apiVersion:2};
G.render=function(r,c){var i=c.getId(),I=c.getItems(),t=c.getTooltip_AsString();r.openStart("div",c).class("sapFGridContainer");this.setGridStyles(r,c._getActiveGridStyles());r.accessibilityState(c,{role:"list",roledescription:c._oRb.getText("GRIDCONTAINER_ROLEDESCRIPTION")});if(c.getSnapToRow()){r.class("sapFGridContainerSnapToRow");}if(c.getAllowDenseFill()){r.class("sapFGridContainerDenseFill");}if(c.getWidth()){r.style("width",c.getWidth());}if(c.getMinHeight()){r.style("min-height",c.getMinHeight());}if(t){r.attr("title",t);}r.openEnd();this.renderDummyArea(r,i,"before");I.forEach(function(o,a){this.renderItem(r,o,c,a);}.bind(this));this.renderDummyArea(r,i,"after");r.close("div");};
G.setGridStyles=function(r,s){for(var n in s){r.style(n,s[n]);}};
G.renderItem=function(r,i,c,I){var s=this.getStylesForItemWrapper(i,c),S=s.styles,C=s.classes,a={role:"listitem",labelledby:i.getId()};if(i.getAriaRoleDescription){a.roledescription=i.getAriaRoleDescription();}r.openStart("div",c.getId()+"-item-"+I).attr("tabindex","0").accessibilityState(c,a);S.forEach(function(v,k){r.style(k,v);});C.forEach(function(v){r.class(v);});r.openEnd();r.renderControl(i);r.close("div");};
G.getStylesForItemWrapper=function(i,c){var s=new Map(),C=["sapFGridContainerItemWrapper"],l=i.getLayoutData(),I,t;if(l){I=l.getColumns();t=c.getActiveLayoutSettings().getColumns();if(I&&t){I=Math.min(I,t);}if(I){s.set("grid-column","span "+I);}if(c.getInlineBlockLayout()){s.set("grid-row","span 1");}else if(l.getRows()||l.getMinRows()){s.set("grid-row","span "+l.getActualRows());}if(!l.hasAutoHeight()){C.push("sapFGridContainerItemFixedRows");}}if(!i.getVisible()){C.push("sapFGridContainerInvisiblePlaceholder");}return{styles:s,classes:C};};
G.renderDummyArea=function(r,c,a){r.openStart("div",c+"-"+a).class("sapFGridContainerDummyArea").attr("tabindex","-1").openEnd().close("div");};
return G;},true);
sap.ui.predefine('sap/f/GridContainerSettings',["sap/ui/base/ManagedObject","sap/ui/dom/units/Rem","sap/base/Log"],function(M,R,L){"use strict";
function c(C){if(C===null||C===undefined){return C;}if(C===0||C==="0"){return 0;}var m=C.match(/^(\d+(\.\d+)?)(px|rem)$/),v;if(m){if(m[3]==="px"){v=parseFloat(m[1]);}else{v=R.toPx(parseFloat(m[1]));}}else{L.error("Css size '"+C+"' is not supported for some features in GridContainer. Only 'px' and 'rem' are supported.");v=NaN;}return Math.ceil(v);}
var G=M.extend("sap.f.GridContainerSettings",{metadata:{library:"sap.f",properties:{columns:{type:"int"},columnSize:{type:"sap.ui.core.CSSSize",defaultValue:"80px"},minColumnSize:{type:"sap.ui.core.CSSSize"},maxColumnSize:{type:"sap.ui.core.CSSSize"},rowSize:{type:"sap.ui.core.CSSSize",defaultValue:"80px"},gap:{type:"sap.ui.core.CSSSize",defaultValue:"16px"}}}});
G.prototype.getColumnSizeInPx=function(){return c(this.getColumnSize());};
G.prototype.getRowSizeInPx=function(){return c(this.getRowSize());};
G.prototype.getGapInPx=function(){return c(this.getGap());};
G.prototype.getComputedColumnsCount=function(g){if(this.getColumns()){return this.getColumns();}var i=this.getGapInPx(),C=this.getColumnSizeInPx();return Math.floor((g+i)/(C+i));};
G.prototype.calculateRowsForItem=function(i){var g=this.getGapInPx(),r=this.getRowSizeInPx();return Math.ceil((i+g)/(r+g));};
return G;});
sap.ui.predefine('sap/f/GridContainerUtils',["sap/base/Log","sap/ui/core/InvisibleRenderer"],function(L,I){"use strict";return{findDropTargetsAbove:function(g,i){return this._findDropTargets(g,i,this._isAbove);},findDropTargetsBelow:function(g,i){return this._findDropTargets(g,i,this._isBelow);},getItemWrapper:function(i){var o=i.getDomRef(),a;if(o){return o.parentElement;}a=document.getElementById(I.createInvisiblePlaceholderId(i));if(a){return a.parentElement;}return null;},createConfig:function(g,i){return{grid:g,item:i};},_findDropTargets:function(g,i,m){var t=[],o=this.getItemWrapper(i),c=g.getItems().filter(function(a){return m(o,this.getItemWrapper(a));}.bind(this)),C=this.createConfig(g,this._findClosest(i,c),i,m);if(C.item){t.push(C);}else{t=Array.from(document.querySelectorAll(".sapFGridContainer")).filter(function(a){return m(o,a);}).map(function(g){var n=jQuery(g).control(0);var a=this.createConfig(n,this._findClosest(i,n.getItems()),i,m);a.distFromItemToGrid=this._getDistance(i,n,m);return a;}.bind(this)).sort(function(a,b){return a.distFromItemToGrid-b.distFromItemToGrid;});}return t;},_findClosest:function(i,c,m){var C=null,f=Number.POSITIVE_INFINITY;c.forEach(function(o){var d=this._getDistance(i,o,m);if(d<f){C=o;f=d;}}.bind(this));return C;},_getDistance:function(a,b,m){var r=a.getDomRef().getBoundingClientRect(),R=b.getDomRef().getBoundingClientRect();var c={x:R.left};if(m===this._isAbove){c.y=R.top+R.height;}else{c.y=R.top;}var d={x:c.x+R.width,y:c.y};var e={x:r.left+r.width/2,y:r.top+r.height/2};var n=(d.x-c.x)*(d.x-c.x)+(d.y-c.y)*(d.y-c.y);var C=((e.x-c.x)*(d.x-c.x)+(e.y-c.y)*(d.y-c.y))/n;var P={};if(C<0){P.x=c.x;P.y=c.y;}else if(C>1){P.x=d.x;P.y=d.y;}else{P.x=c.x+C*(d.x-c.x);P.y=c.y+C*(d.y-c.y);}var D=(P.x-e.x),f=(P.y-e.y),g=D*D+f*f;if(g>Number.MAX_SAFE_INTEGER){L.warning("Maximum safe integer value exceeded.",g,"GridContainerUtils");}return g;},_isAbove:function(a,b){var y=a.getBoundingClientRect().top,Y=b.getBoundingClientRect().top;return Y-y<0;},_isBelow:function(a,b){var y=a.getBoundingClientRect().top,Y=b.getBoundingClientRect().top;return Y-y>0;}};});
sap.ui.predefine('sap/f/GridList',["./delegate/GridItemNavigation","./GridListRenderer","./GridNavigationMatrix","./library","sap/m/ListBase","sap/ui/base/ManagedObjectObserver","sap/ui/core/Core","sap/ui/Device","sap/ui/layout/cssgrid/GridLayoutDelegate","sap/ui/layout/cssgrid/GridLayoutBase"],function(G,a,b,l,L,M,C,D,c,d){"use strict";var N=l.NavigationDirection;
var e=L.extend("sap.f.GridList",{metadata:{library:"sap.f",interfaces:["sap.ui.layout.cssgrid.IGridConfigurable","sap.f.dnd.IGridDroppable"],aggregations:{customLayout:{type:"sap.ui.layout.cssgrid.GridLayoutBase",multiple:false}},events:{borderReached:{parameters:{event:{type:"jQuery.Event"},direction:{type:"sap.f.NavigationDirection"},row:{type:"int"},column:{type:"int"}}}}}});
e.prototype.init=function(){L.prototype.init.apply(this,arguments);this._oItemDelegate={onAfterRendering:this._onAfterItemRendering};this._addGridLayoutDelegate();this._oGridObserver=new M(e.prototype._onGridChange.bind(this));this._oGridObserver.observe(this,{aggregations:["items"]});};
e.prototype.exit=function(){this._removeGridLayoutDelegate();if(this._oGridObserver){this._oGridObserver.disconnect();this._oGridObserver=null;}L.prototype.exit.apply(this,arguments);};
e.prototype.onAfterPageLoaded=function(){L.prototype.onAfterPageLoaded.apply(this,arguments);if(this._oItemNavigation){this._oItemNavigation.resetFocusPosition();}};
e.prototype.onItemNavigationBorderReached=function(p){var g=this.getGrowingInfo();if(p.direction===N.Down&&g&&g.actual!==g.total){return;}this.fireEvent("borderReached",p);};
e.prototype.getGridDomRefs=function(){return[this.getItemsContainerDomRef()];};
e.prototype.focusItemByDirection=function(s,r,i){this._oItemNavigation.focusItemByDirection(this,s,r,i);};
e.prototype.getNavigationMatrix=function(){if(!C.isThemeApplied()){return null;}var i=this.getItems().reduce(function(A,I){if(I.getVisible()){A.push(I.getDomRef());}return A;},[]);return b.create(this.getItemsContainerDomRef(),i,this._getActiveLayoutSizes());};
e.prototype.getGridLayoutConfiguration=e.prototype.getCustomLayout;
e.prototype._startItemNavigation=function(i){if(!D.system.desktop){return;}if(!this._oItemNavigation){this._oItemNavigation=new G();this._oItemNavigation.setCycling(false).setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]}).setFocusedIndex(0);this.addDelegate(this._oItemNavigation);this._setItemNavigationTabIndex(0);}L.prototype._startItemNavigation.apply(this,arguments);};
e.prototype._addGridLayoutDelegate=function(){if(!this.oGridLayoutDelegate){this.oGridLayoutDelegate=new c();this.addEventDelegate(this.oGridLayoutDelegate,this);}};
e.prototype._removeGridLayoutDelegate=function(){if(this.oGridLayoutDelegate){this.removeEventDelegate(this.oGridLayoutDelegate);this.oGridLayoutDelegate.destroy();this.oGridLayoutDelegate=null;}};
e.prototype._onGridChange=function(o){var f;if(o.name!=="items"||!o.child){return;}if(o.mutation==="insert"){f=!o.child.isA("sap.ui.core.HTML");o.child.addDelegate(this._oItemDelegate,f,o.child);}else if(o.mutation==="remove"){o.child.removeEventDelegate(this._oItemDelegate,o.child);}};
e.prototype._onAfterItemRendering=function(){d.setItemStyles(this);};
e.prototype.updateItems=function(){L.prototype.updateItems.apply(this,arguments);this.invalidate();};
e.prototype.onLayoutDataChange=function(E){d.setItemStyles(E.srcControl);};
e.prototype._getActiveLayoutSizes=function(){var g=this.getItemsContainerDomRef(),m=window.getComputedStyle(g);return{gap:parseFloat(m.rowGap),rows:m.gridTemplateRows.split(/\s+/),columns:m.gridTemplateColumns.split(/\s+/)};};
return e;});
sap.ui.predefine('sap/f/GridListItem',["sap/m/ListItemBase","./GridListItemRenderer"],function(L){"use strict";
var G=L.extend("sap.f.GridListItem",{metadata:{library:"sap.f",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}}}});
G.prototype.getContentAnnouncement=function(){return this.getContent().map(function(c){return L.getAccessibilityText(c);}).join(" ").trim();};
return G;});
sap.ui.predefine('sap/f/GridListItemRenderer',["sap/m/ListItemBaseRenderer","sap/ui/core/Renderer","sap/m/library"],function(L,R,l){"use strict";var a=l.ListType;var b=l.ListMode;var M=-1;var G=R.extend(L);G.apiVersion=2;
G.renderLIAttributes=function(r,o){r.class("sapFGLI");};
G.renderContentFormer=function(r,o){this.renderHighlight(r,o);};
G.renderLIContentWrapper=function(r,o){r.openStart("div").class("sapFGLIWrapper").openEnd();this.renderToolbar(r,o);L.renderLIContentWrapper.apply(this,arguments);r.close("div");};
G.renderContentLatter=function(r,o){};
G.renderToolbar=function(r,o){var m=o.getMode(),i=m===b.Delete,t=o.getType();if(!o.getCounter()&&(m===""||m===b.None||m===b.SingleSelectMaster)&&(t===a.Inactive||t===a.Active)){return;}r.openStart("div",o.getId()+"-gridListItemToolbar");r.class("sapFGLIToolbar");r.openEnd();if(!i){this.renderMode(r,o,M);}this.renderToolbarSpacer(r);L.renderContentLatter.apply(this,arguments);r.close("div");};
G.renderLIContent=function(r,o){o.getContent().forEach(r.renderControl,r);};
G.renderToolbarSpacer=function(r){r.openStart("div").class("sapFGLIToolbarSpacer").openEnd().close("div");};
return G;},true);
sap.ui.predefine('sap/f/GridListRenderer',["sap/ui/core/Renderer","sap/m/ListBaseRenderer"],function(R,L){"use strict";var G=R.extend(L);G.apiVersion=2;
G.getNoDataAriaRole=function(){return"option";};
G.renderContainerAttributes=function(r,c){L.renderContainerAttributes.apply(this,arguments);r.class("sapFGridList");};
G.renderListStartAttributes=function(r,c){L.renderListStartAttributes.apply(this,arguments);this.renderGridAttributes(r,c);};
G.renderGridAttributes=function(r,c){var g=c.getGridLayoutConfiguration();if(g){g.addGridStyles(r);}else{r.class("sapFGridListDefault");}if(c.isGrouped()){r.class("sapFGridListGroup");}};
return G;},true);
sap.ui.predefine('sap/f/GridNavigationMatrix',[],function(){"use strict";return{EMPTY_CELL:false,create:function(g,i,l){var m=Array.from(new Array(l.rows.length),function(){return new Array(l.columns.length).fill(this.EMPTY_CELL);}.bind(this));i.forEach(function(I){var p=this._getPosition(g,I,l);this._addToMatrix(m,p,I);}.bind(this));return m;},_getPosition:function(g,i,l){var G=g.getBoundingClientRect(),I=i.getBoundingClientRect(),o=this._getGridRow(G,I,l),a=this._getGridCol(G,I,l);return{xFrom:o.start,xTo:o.end,yFrom:a.start,yTo:a.end};},_getGridRow:function(g,I,l){var s=-1,e=0,S=0,i,t=I.top-g.top,b=t+I.height;for(i=0;i<l.rows.length;i++){S+=parseFloat(l.rows[i]);if(s===-1&&t<S){s=i;}S+=l.gap;if(b<S){e=i+1;break;}}return{start:s,end:e};},_getGridCol:function(g,I,l){var s=-1,e=0,S=0,i,L=I.left-g.left,r=L+I.width;for(i=0;i<l.columns.length;i++){S+=parseFloat(l.columns[i]);if(s===-1&&L<S){s=i;}S+=l.gap;if(r<=S){e=i+1;break;}}return{start:s,end:e};},_addToMatrix:function(m,p,d){var r,c;for(r=p.xFrom;r<p.xTo;r++){for(c=p.yFrom;c<p.yTo;c++){m[r][c]=d;}}}};});
sap.ui.predefine('sap/f/IllustratedMessage',["sap/m/IllustratedMessage","sap/m/IllustratedMessageRenderer","./library"],function(s,I){"use strict";
var a=s.extend("sap.f.IllustratedMessage",{
metadata:{library:"sap.f",deprecated:true,properties:{}},
renderer:I
});
return a;});
sap.ui.predefine('sap/f/Illustration',["sap/m/Illustration","sap/m/IllustrationRenderer","./library"],function(s,I){"use strict";
var a=s.extend("sap.f.Illustration",{
metadata:{library:"sap.f",deprecated:true,properties:{}},
renderer:I
});
return a;});
sap.ui.predefine('sap/f/IllustrationPool',["sap/m/IllustrationPool"],function(I){"use strict";var I=I;return I;},true);
sap.ui.predefine('sap/f/PlanningCalendarInCardLegend',['sap/m/PlanningCalendarLegend','sap/ui/unified/CalendarLegendItem','./PlanningCalendarInCardLegendRenderer'],function(P,C,a){"use strict";
var b=P.extend("sap.f.PlanningCalendarInCardLegend",{metadata:{library:"sap.m",properties:{visibleLegendItemsCount:{type:"int",group:"Data",defaultValue:2}}}});
b.prototype.exit=function(){P.prototype.exit.call(this,arguments);if(this._oItemsLink){this._oItemsLink.destroy();this._oItemsLink=null;}};
b.prototype._getMoreItemsText=function(i){if(!this._oItemsLink){this._oItemsLink=new sap.ui.unified.CalendarLegendItem({text:"More ("+i+")"});}return this._oItemsLink;};
return b;});
sap.ui.predefine('sap/f/PlanningCalendarInCardLegendRenderer',['sap/m/PlanningCalendarLegendRenderer','sap/ui/core/Renderer'],function(P,R){"use strict";var a=R.extend(P);a.apiVersion=2;
a.renderItemsHeader=function(r,l){};
a.renderAppointmentsItemsHeader=function(r,l){};
a.renderAdditionalContent=function(r,l){};
a.renderAdditionalItems=function(r,l){var A=l.getAppointmentItems(),v=l.getVisibleLegendItemsCount(),b,i;if(l.getItems().length>=v){b=0;}else if(l.getItems().length+l.getAppointmentItems().length>v){b=v-l.getItems().length;}else{b=l.getAppointmentItems().length;}for(i=0;i<b;i++){this.renderLegendItem(r,"sapUiCalLegDayType"+l._getItemType(A[i],A).slice(4),A[i],["sapUiUnifiedLegendSquareColor","sapMPlanCalLegendAppCircle"]);}if(l.getItems().length+l.getAppointmentItems().length>v){this.renderLegendItem(r,"sapUiCalLegMoreText",l._getMoreItemsText(l.getItems().length+l.getAppointmentItems().length-v),[]);}};
a.defineItemsLength=function(l,c){var v=l.getVisibleLegendItemsCount();if(c>=v){return v;}else{return c;}};
return a;},true);
sap.ui.predefine('sap/f/ProductSwitch',["sap/ui/core/Core","sap/ui/core/Control",'sap/ui/core/delegate/ItemNavigation',"sap/f/GridContainer","sap/f/GridContainerSettings","sap/f/ProductSwitchItem","sap/f/ProductSwitchRenderer"],function(C,a,I,G,b,P,c){"use strict";
var d=a.extend("sap.f.ProductSwitch",{metadata:{library:"sap.f",aggregations:{_gridContainer:{type:"sap.f.GridContainer",visibility:"hidden",multiple:false},items:{type:"sap.f.ProductSwitchItem",multiple:true,singularName:"item",forwarding:{getter:"_getGridContainer",aggregation:"items"}}},associations:{selectedItem:{type:"sap.f.ProductSwitchItem",multiple:false}},events:{change:{parameters:{itemPressed:{type:"sap.f.ProductSwitchItem"}}}}}});
d.COLUMNS={THREE_COLUMNS:3,FOUR_COLUMNS:4};
d.prototype.init=function(){this._oCurrentSelectedItem=null;};
d.prototype.exit=function(){this._oCurrentSelectedItem=null;this._destroyItemNavigation();};
d.prototype._destroyItemNavigation=function(){if(this._oItemNavigation){this.removeEventDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}};
d.prototype.onAfterRendering=function(){var D,e=[];if(!this._oItemNavigation){this._oItemNavigation=new I(null,null);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});this.addEventDelegate(this._oItemNavigation);}D=this.getDomRef();this._oItemNavigation.setRootDomRef(D);e=this.getItems().map(function(i){return i.getDomRef();});this._oItemNavigation.setItemDomRefs(e);};
d.prototype._gridContainerItemsUpdate=function(){var l=this._getGridContainer().getLayout();l.setColumns(this.getItems().length<=6?d.COLUMNS.THREE_COLUMNS:d.COLUMNS.FOUR_COLUMNS);};
d.prototype._changeLayoutHandler=function(e){var E=e.getParameter("layout"),i=E==="layoutS"||E==="layoutXS";this._getGridContainer().toggleStyleClass("sapFProductSwitch-Popover-CTX",!i);};
d.prototype._getGridContainer=function(){var g=this.getAggregation("_gridContainer");if(!g){g=new G({layoutChange:this._changeLayoutHandler.bind(this)}).setLayout(new b({columnSize:"11.25rem",rowSize:"7rem",gap:"0.5rem",columns:4})).setLayoutM(new b({columnSize:"11.25rem",rowSize:"7rem",gap:"0.5rem",columns:3})).setLayoutS(new b({columnSize:"100%",rowSize:"5rem",gap:"0",columns:1}));this.setAggregation("_gridContainer",g);}return g;};
d.prototype._onItemPress=function(e){this.setSelectedItem(e.oSource);this.fireChange({itemPressed:e.oSource});};
d.prototype._setSelection=function(i){if(this._oCurrentSelectedItem){this._oCurrentSelectedItem.removeStyleClass("sapFPSItemSelected");this._oCurrentSelectedItem.$().removeAttr("aria-checked");}this._oCurrentSelectedItem=i;if(this._oCurrentSelectedItem){this._oCurrentSelectedItem.addStyleClass("sapFPSItemSelected");this._oCurrentSelectedItem.$().attr("aria-checked","true");}};
d.prototype.setSelectedItem=function(i){if(typeof i==="string"){i=C.byId(i);}if(!(i instanceof P)&&i!==null){return this;}this._setSelection(i);return this.setAssociation("selectedItem",i,true);};
d.prototype.addItem=function(i){this.addAggregation("items",i);if(i){i.attachEvent("_itemPress",this._onItemPress,this);}this._gridContainerItemsUpdate();return this;};
d.prototype.insertItem=function(i,e){this.insertAggregation("items",i,e);if(i){i.attachEvent("_itemPress",this._onItemPress,this);}this._gridContainerItemsUpdate();return this;};
d.prototype.removeItem=function(i){var r=this.removeAggregation("items",i).detachEvent("_itemPress",this._onItemPress,this);this._gridContainerItemsUpdate();return r;};
d.prototype.removeAllItems=function(){var i=this.getItems(),r;i.forEach(function(o){o.detachEvent("_itemPress",this._onItemPress,this);},this);r=this.removeAllAggregation("items");this._gridContainerItemsUpdate();return r;};
d.prototype.destroyItems=function(){var i=this.getItems(),D;i.forEach(function(o){o.detachEvent("_itemPress",this._onItemPress,this);},this);D=this.destroyAggregation("items");this._gridContainerItemsUpdate();return D;};
d.prototype._getItemsCount=function(){return this.getItems().length;};
d.prototype._getItemPosition=function(i){var e=this.getItems(),f;e.forEach(function(o,g){if(o===i){f=g+1;}});return f;};
return d;});
sap.ui.predefine('sap/f/ProductSwitchItem',["sap/ui/core/Control","sap/ui/core/Icon","sap/ui/core/library","sap/m/Text","sap/ui/events/KeyCodes","sap/f/ProductSwitchItemRenderer"],function(C,I,l,T,K,P){"use strict";var a=l.TextAlign;
var b=C.extend("sap.f.ProductSwitchItem",{metadata:{library:"sap.f",properties:{src:{type:"sap.ui.core.URI",defaultValue:null},title:{type:"string",defaultValue:null},subTitle:{type:"string",defaultValue:null},targetSrc:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},target:{type:"string",group:"Behavior",defaultValue:null}},aggregations:{_icon:{type:"sap.ui.core.Icon",visibility:"hidden",multiple:false},_title:{type:"sap.m.Text",visibility:"hidden",multiple:false}}}});
b.prototype.init=function(){this._bSpaceEnterPressed=false;this._bEscapeShiftKeyPress=false;};
b.prototype.setTitle=function(t){this.setProperty("title",t);this._getTitle().setText(t);return this;};
b.prototype.setSrc=function(s){this.setProperty("src",s);this._getIcon().setSrc(s);return this;};
b.prototype.setSubTitle=function(s){this.setProperty("subTitle",s);this._getTitle().setMaxLines(s?1:2);return this;};
b.prototype._getIcon=function(){var i=this.getAggregation("_icon");if(!i){i=new I();if(this.getSrc()){i.setSrc(this.getSrc());}this.setAggregation("_icon",i);}return i;};
b.prototype._getTitle=function(){var t=this.getAggregation("_title");if(!t){t=new T({text:this.getTitle(),maxLines:2,textAlign:a.Initial}).addStyleClass("sapFPSItemMainTitle").addStyleClass("sapFPSItemTitle");this.setAggregation("_title",t);}return t;};
b.prototype._getProductSwitch=function(){return this.getParent().getParent();};
b.prototype.onkeyup=function(e){if((e.keyCode===K.SPACE&&!this._bEscapeShiftKeyPress)){this.fireEvent("_itemPress");}if(e.keyCode===K.SPACE||e.keyCode===K.ENTER){this._bSpaceEnterPressed=false;this._bEscapeShiftKeyPress=false;}};
b.prototype.ontap=function(){this.fireEvent("_itemPress");};
b.prototype.onkeydown=function(e){if((e.keyCode===K.ESCAPE||e.keyCode===K.SHIFT)&&this._bSpaceEnterPressed){this._bEscapeShiftKeyPress=true;}if(e.keyCode===K.SPACE||e.keyCode===K.ENTER){this._bSpaceEnterPressed=true;if(e.keyCode===K.ENTER&&!this._bEscapeShiftKeyPress){this.fireEvent("_itemPress");}e.preventDefault();}};
return b;});
sap.ui.predefine('sap/f/ProductSwitchItemRenderer',[],function(){"use strict";var P={apiVersion:2};
P.render=function(r,c){var p=c._getProductSwitch(),a={role:"menuitemradio"};if(p){a.setsize=p._getItemsCount();a.posinset=p._getItemPosition(c);a.checked=c.getId()===p.getSelectedItem()?"true":undefined;}r.openStart("div",c);r.class("sapFPSItemContainer");r.attr("tabindex",0);r.accessibilityState(c,a);r.openEnd();r.openStart("span");r.class("sapFPSItemIconPlaceholder");r.class("sapUiTinyMarginBottom");r.openEnd();if(c.getSrc()){r.renderControl(c._getIcon());}r.close("span");r.openStart("div");r.class("sapFPSItemTextSection");r.openEnd();if(c.getTitle()){r.renderControl(c._getTitle());}if(c.getSubTitle()){r.openStart("div");r.class("sapFPSItemSubTitle");r.class("sapFPSItemTitle");r.openEnd();r.text(c.getSubTitle());r.close("div");}r.close("div");r.close("div");};
return P;},true);
sap.ui.predefine('sap/f/ProductSwitchRenderer',["sap/ui/core/Core"],function(C){"use strict";return{apiVersion:2,render:function(r,c){var R=C.getLibraryResourceBundle("sap.f");r.openStart("div",c);r.attr("role","menu");r.attr("aria-label",R.getText("PRODUCTSWITCH_CONTAINER_LABEL"));r.openEnd();r.renderControl(c._getGridContainer());r.close("div");}};},true);
sap.ui.predefine('sap/f/SearchManager',['sap/ui/core/Element','sap/ui/base/ManagedObjectObserver','./shellBar/Search'],function(E,M,S){"use strict";var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
var a=E.extend("sap.f.SearchManager",{metadata:{library:"sap.f",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},placeholder:{type:"string",group:"Misc",defaultValue:null},maxLength:{type:"int",group:"Behavior",defaultValue:0},enabled:{type:"boolean",group:"Behavior",defaultValue:true},enableSuggestions:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{suggestionItems:{type:"sap.m.SuggestionItem",multiple:true,forwarding:{getter:"_getSearchField",aggregation:"suggestionItems"},singularName:"suggestionItem"}},events:{search:{parameters:{query:{type:"string"},clearButtonPressed:{type:"boolean"}}},liveChange:{parameters:{newValue:{type:"string"}}},suggest:{parameters:{suggestValue:{type:"string"}}}}}});
a.prototype.init=function(){this.setProperty("placeholder",r.getText("FACETFILTER_SEARCH"),true);this._oConfigObserver=new M(this._synchronizePropertiesWithConfig.bind(this));this._oConfigObserver.observe(this,{properties:Object.keys(this.getMetadata().getProperties())});this._initShellBarManagedSearch();};
a.prototype._synchronizePropertiesWithConfig=function(){var s=this._oSearch._getSearchField(),o=s.getMetadata(),c=this.getMetadata(),k,n;Object.keys(c.getAllProperties()).forEach(function(p){k=o.hasProperty(p);if(k){n=c.getProperty(p).get(this);o.getProperty(p).set(s,n);}},this);};
a.prototype._initShellBarManagedSearch=function(){if(!this._oSearch){this._oSearch=new S({search:this._onSearch.bind(this),liveChange:this._onLiveChange.bind(this),suggest:this._onSuggest.bind(this)});}};
a.prototype.exit=function(){if(this._oConfigObserver){this._oConfigObserver.disconnect();this._oConfigObserver=null;}if(this._oSearch){this._oSearch.destroy();}};
a.prototype._onLiveChange=function(e){var n=e.getParameters(),b=e.getParameter("newValue");n.id=this.getId();this.setProperty("value",b,true);this.fireLiveChange(n);};
a.prototype._onSearch=function(e){var n=e.getParameters();n.id=this.getId();this.fireSearch(n);};
a.prototype._onSuggest=function(e){var n=e.getParameters();n.id=this.getId();this.fireSuggest(n);};
a.prototype.suggest=function(s){this._getSearchField().suggest(s);};
a.prototype._getSearchField=function(){return this._oSearch._getSearchField();};
return a;});
sap.ui.predefine('sap/f/ShellBar',['sap/f/library',"sap/ui/core/Control","./shellBar/Factory","./shellBar/AdditionalContentSupport","./shellBar/ResponsiveHandler","./shellBar/Accessibility","sap/m/BarInPageEnabler","sap/m/BadgeCustomData","sap/m/Button","./ShellBarRenderer"],function(l,C,F,A,R,a,B,b,c){"use strict";var d=l.AvatarSize;
var S=C.extend("sap.f.ShellBar",{metadata:{library:"sap.f",interfaces:["sap.f.IShellBar","sap.m.IBar","sap.tnt.IToolHeader"],properties:{title:{type:"string",group:"Appearance",defaultValue:""},secondTitle:{type:"string",group:"Appearance",defaultValue:""},homeIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},homeIconTooltip:{type:"string",group:"Appearance",defaultValue:""},showMenuButton:{type:"boolean",group:"Appearance",defaultValue:false},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},showCopilot:{type:"boolean",group:"Appearance",defaultValue:false},showSearch:{type:"boolean",group:"Appearance",defaultValue:false},showNotifications:{type:"boolean",group:"Appearance",defaultValue:false},showProductSwitcher:{type:"boolean",group:"Appearance",defaultValue:false},notificationsNumber:{type:"string",group:"Appearance",defaultValue:""}},aggregations:{menu:{type:"sap.m.Menu",multiple:false,forwarding:{getter:"_getMenu",aggregation:"menu"}},searchManager:{type:"sap.f.SearchManager",multiple:false},profile:{type:"sap.m.Avatar",multiple:false},additionalContent:{type:"sap.f.IShellBar",multiple:true,singularName:"additionalContent"},_overflowToolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"},_additionalBox:{type:"sap.m.HBox",multiple:false,visibility:"hidden"}},events:{homeIconPressed:{parameters:{icon:{type:"sap.m.Image"}}},menuButtonPressed:{parameters:{button:{type:"sap.m.Button"}}},navButtonPressed:{parameters:{button:{type:"sap.m.Button"}}},copilotPressed:{parameters:{image:{type:"sap.m.Image"}}},searchButtonPressed:{parameters:{button:{type:"sap.m.Button"}}},notificationsPressed:{parameters:{button:{type:"sap.m.Button"}}},productSwitcherPressed:{parameters:{button:{type:"sap.m.Button"}}},avatarPressed:{parameters:{avatar:{type:"sap.m.Avatar"}}}}}});
A.apply(S.prototype);
S.prototype.init=function(){this._oFactory=new F(this);this._bOTBUpdateNeeded=true;this._bLeftBoxUpdateNeeded=true;this._bRightBoxUpdateNeeded=true;this._oOverflowToolbar=this._oFactory.getOverflowToolbar();this._oAdditionalBox=this._oFactory.getAdditionalBox();this._aControls=[];this._aAdditionalContent=[];this.setAggregation("_overflowToolbar",this._oOverflowToolbar);this.setAggregation("_additionalBox",this._oAdditionalBox);this._oToolbarSpacer=this._oFactory.getToolbarSpacer();this._oResponsiveHandler=new R(this);this._oAcc=new a(this);};
S.prototype.onBeforeRendering=function(){this._assignControls();};
S.prototype.exit=function(){this._aLeftControls=[];this._aRightControls=[];this._aControls=[];this._oResponsiveHandler.exit();this._oFactory.destroy();this._oAcc.exit();};
S.prototype.setHomeIcon=function(s){if(s){if(!this._oHomeIcon){this._oHomeIcon=this._oFactory.getHomeIcon();}this._oHomeIcon.setSrc(s);}else{this._oHomeIcon=null;}this._bLeftBoxUpdateNeeded=true;return this.setProperty("homeIcon",s);};
S.prototype.setProfile=function(o){this.validateAggregation("profile",o,false);if(o){o.setDisplaySize(d.XS);o.setTooltip(this._oAcc.getEntityTooltip("PROFILE"));o.attachPress(function(){this.fireEvent("avatarPressed",{avatar:o});},this);o.addStyleClass("sapFShellBarProfile");}return this.setAggregation("profile",o);};
S.prototype.setHomeIconTooltip=function(t){var D=this._oAcc.getEntityTooltip("LOGO");if(!this._oHomeIcon){this._oHomeIcon=this._oFactory.getHomeIcon();}if(t){this._oHomeIcon.setTooltip(t);}else{this._oHomeIcon.setTooltip(D);}return this.setProperty("homeIconTooltip",t,true);};
S.prototype.setTitle=function(t){this._sTitle=t;if(!t){this._oPrimaryTitle=null;this._oMegaMenu=null;}else{if(!this._oMegaMenu){this._oMegaMenu=this._oFactory.getMegaMenu();}this._oMegaMenu.setText(t);if(!this._oPrimaryTitle){this._oPrimaryTitle=this._oFactory.getPrimaryTitle();}this._oPrimaryTitle.setText(t);}this._bLeftBoxUpdateNeeded=true;return this.setProperty("title",t);};
S.prototype.setSecondTitle=function(t){if(t){if(!this._oSecondTitle){this._oSecondTitle=this._oFactory.getSecondTitle();}this._oSecondTitle.setText(t);}else{this._oSecondTitle=null;}this._bLeftBoxUpdateNeeded=true;return this.setProperty("secondTitle",t);};
S.prototype.setShowCopilot=function(s){if(s){if(!this._oCopilot){this._oCopilot=this._oFactory.getCopilot();}}else{this._oCopilot=null;}this._bOTBUpdateNeeded=true;this._bLeftBoxUpdateNeeded=true;this._bRightBoxUpdateNeeded=true;return this.setProperty("showCopilot",s);};
S.prototype.setShowSearch=function(s){if(s){if(!this._oSearch){this._oSearch=this._oFactory.getSearch();}}else{this._oSearch=null;}this._bOTBUpdateNeeded=true;return this.setProperty("showSearch",s);};
S.prototype.setSearchManager=function(o){this.setAggregation("searchManager",o);if(o){if(!this._oManagedSearch){this._oManagedSearch=this._oFactory.getManagedSearch();}}else{this._oManagedSearch=null;}this._bOTBUpdateNeeded=true;return this;};
S.prototype.setShowNotifications=function(s){var o=this;if(s){if(!this._oNotifications){this._oNotifications=this._oFactory.getNotifications();this._oNotifications._onBeforeEnterOverflow=function(){var O=this.getParent()._getOverflowButton().getBadgeCustomData();this._bInOverflow=true;O&&O.setVisible(this.getBadgeCustomData().getVisible());};this._oNotifications._onAfterExitOverflow=function(){var O=this.getParent()._getOverflowButton().getBadgeCustomData();this._bInOverflow=false;O&&O.setVisible(false);};this._oNotifications.onBadgeUpdate=function(v,e){c.prototype.onBadgeUpdate.apply(this,arguments);if(!this._bInOverflow){o._oAcc.updateNotificationsNumber(v);}else{o._oAcc.updateNotificationsNumber("");}};}}else{this._oNotifications=null;}this._bOTBUpdateNeeded=true;return this.setProperty("showNotifications",s);};
S.prototype.setShowProductSwitcher=function(s){if(s){if(!this._oProductSwitcher){this._oProductSwitcher=this._oFactory.getProductSwitcher();}}else{this._oProductSwitcher=null;}this._bRightBoxUpdateNeeded=true;return this.setProperty("showProductSwitcher",s);};
S.prototype.setShowNavButton=function(s){if(s){if(!this._oNavButton){this._oNavButton=this._oFactory.getNavButton();}}else{this._oNavButton=null;}this._bLeftBoxUpdateNeeded=true;return this.setProperty("showNavButton",s);};
S.prototype.setShowMenuButton=function(s){if(s){if(!this._oMenuButton){this._oMenuButton=this._oFactory.getMenuButton();}}else{this._oMenuButton=null;}this._bLeftBoxUpdateNeeded=true;return this.setProperty("showMenuButton",s);};
S.prototype.setNotificationsNumber=function(n){if(this.getShowNotifications()){this._updateNotificationsIndicators(n);}return this.setProperty("notificationsNumber",n,true);};
S.prototype._addDataToControl=function(o){o.addStyleClass("sapFShellBarItem");if(this._aControls.indexOf(o)===-1){this._aControls.push(o);}return o;};
S.prototype._assignControls=function(){if(!this._bOTBUpdateNeeded&&!this._bLeftBoxUpdateNeeded&&!this._bRightBoxUpdateNeeded){return;}if(this._bLeftBoxUpdateNeeded){this._aLeftControls=[];if(this._oNavButton){this.addControlToCollection(this._oNavButton,this._aLeftControls);}if(this._oMenuButton){this.addControlToCollection(this._oMenuButton,this._aLeftControls);}if(this._oHomeIcon){this.addControlToCollection(this._oHomeIcon,this._aLeftControls);}this._assignControlsToAdditionalBox();this._aLeftControls.push(this._oAdditionalBox);}if(this._oCopilot){this._addDataToControl(this._oCopilot);}if(this._bRightBoxUpdateNeeded||this._bOTBUpdateNeeded){this._aRightControls=[];if(this._bOTBUpdateNeeded){this._assignControlsToOverflowToolbar();}this._aRightControls.push(this._oOverflowToolbar);}this._bLeftBoxUpdateNeeded=false;this._bRightBoxUpdateNeeded=false;this._bOTBUpdateNeeded=false;};
S.prototype._assignControlsToAdditionalBox=function(){this._oAdditionalBox.removeAllItems();this._oTitleControl=null;if(this.getShowMenuButton()){if(this._oPrimaryTitle){this.addControlToCollection(this._oPrimaryTitle,this._oAdditionalBox);this._oTitleControl=this._oPrimaryTitle;}}else if(this._oMegaMenu){if(this._oMegaMenu.getMenu()&&this._oMegaMenu.getMenu().getItems().length){this.addControlToCollection(this._oMegaMenu,this._oAdditionalBox);this._oTitleControl=this._oMegaMenu;}else if(this._oPrimaryTitle){this.addControlToCollection(this._oPrimaryTitle,this._oAdditionalBox);this._oTitleControl=this._oPrimaryTitle;}}if(this._oSecondTitle){this.addControlToCollection(this._oSecondTitle,this._oAdditionalBox);}return this._oAdditionalBox;};
S.prototype._assignControlsToOverflowToolbar=function(){var e;if(!this._oOverflowToolbar){return;}this._oOverflowToolbar.removeAllContent();this.addControlToCollection(this._oToolbarSpacer,this._oOverflowToolbar);if(this._oManagedSearch){this.addControlToCollection(this._oManagedSearch,this._oOverflowToolbar);}if(this._oSearch){this.addControlToCollection(this._oSearch,this._oOverflowToolbar);}if(this._oNotifications){this.addControlToCollection(this._oNotifications,this._oOverflowToolbar);}e=this.getAdditionalContent();if(e){e.forEach(function(o){this.addControlToCollection(o,this._oOverflowToolbar);},this);}this._bOTBUpdateNeeded=false;return this._oOverflowToolbar;};
S.prototype.addControlToCollection=function(o,e){var f;if(Array.isArray(e)){f="push";}else{f=e===this._oAdditionalBox?"addItem":"addContent";}this._addDataToControl(o);e[f](o);};
S.prototype._updateNotificationsIndicators=function(n){var o;if(!this.getShowNotifications()){return;}o=this._oOverflowToolbar._getOverflowButton();this._addOrUpdateBadges(o,n);if(!this._oNotifications._bInOverflow){this._oOverflowToolbar._getOverflowButton().getBadgeCustomData().setVisible(false);}this._addOrUpdateBadges(this._oNotifications,n);};
S.prototype._addOrUpdateBadges=function(o,D){if(o.getBadgeCustomData()){o.getBadgeCustomData().setValue(D);}else{o.addCustomData(new b({value:D,animation:"Update"}));}};
S.prototype._getMenu=function(){if(!this._oMegaMenu){this._oMegaMenu=this._oFactory.getMegaMenu();}return this._oMegaMenu;};
S.prototype.onThemeChanged=function(){this._oResponsiveHandler._handleResize();};
S.prototype._getOverflowToolbar=function(){return this._oOverflowToolbar;};
S.prototype.getContext=B.prototype.getContext;S.prototype.isContextSensitive=B.prototype.isContextSensitive;S.prototype.setHTMLTag=B.prototype.setHTMLTag;S.prototype.getHTMLTag=B.prototype.getHTMLTag;S.prototype.applyTagAndContextClassFor=B.prototype.applyTagAndContextClassFor;S.prototype._applyContextClassFor=B.prototype._applyContextClassFor;S.prototype._applyTag=B.prototype._applyTag;S.prototype._getContextOptions=B.prototype._getContextOptions;S.prototype._setRootAccessibilityRole=B.prototype._setRootAccessibilityRole;S.prototype._getRootAccessibilityRole=B.prototype._getRootAccessibilityRole;S.prototype._setRootAriaLevel=B.prototype._setRootAriaLevel;S.prototype._getRootAriaLevel=B.prototype._getRootAriaLevel;return S;});
sap.ui.predefine('sap/f/ShellBarRenderer',[],function(){"use strict";return{apiVersion:2,render:function(r,c){var a=c._oAcc,R=a.getRootAttributes(),t=c.getTitle(),A=c.getProfile(),b=t&&!c.getShowMenuButton();r.openStart("div",c);r.class("sapFShellBar");if(c.getShowNotifications()){r.class("sapFShellBarNotifications");}if(c.getShowCopilot()){r.class("sapFShellBarCopilot");}r.accessibilityState({role:R.role,label:R.label});r.openEnd();if(b){r.openStart("div",c.getId()+"-titleHidden").class("sapFShellBarTitleHidden").attr("role","heading").attr("aria-level","1").openEnd();r.text(t).close("div");}if(c._aLeftControls&&c._aLeftControls.length){r.openStart("div").class("sapFShellBarOLHB").openEnd();c._aLeftControls.forEach(r.renderControl,r);r.close("div");}if(c._oCopilot){r.renderControl(c._oCopilot);}if(c._aRightControls&&c._aRightControls.length){r.openStart("div").class("sapFShellBarORHB").openEnd();c._aRightControls.forEach(r.renderControl,r);r.close("div");}if(A){r.renderControl(A);}if(c._oProductSwitcher){r.renderControl(c._oProductSwitcher);}r.close("div");},shouldAddIBarContext:function(){return false;}};},true);
sap.ui.predefine('sap/f/cards/BaseHeader',["sap/ui/core/Control","sap/ui/core/IntervalTrigger","sap/ui/core/format/DateFormat","sap/ui/core/date/UniversalDate","sap/m/Text"],function(C,I,D,U,T){"use strict";var a=60000;
var B=C.extend("sap.f.cards.BaseHeader",{metadata:{library:"sap.f","abstract":true,properties:{dataTimestamp:{type:"string",defaultValue:""},dataTimestampUpdating:{type:"boolean",defaultValue:false,visibility:"hidden"}},aggregations:{_dataTimestamp:{type:"sap.m.Text",multiple:false,visibility:"hidden"},toolbar:{type:"sap.ui.core.Control",multiple:false},_error:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}}}});
B.prototype.exit=function(){this._removeTimestampListener();};
B.prototype.onBeforeRendering=function(){var t=this.getToolbar();if(t){t.addStyleClass("sapFCardHeaderToolbar");}};
B.prototype.setDataTimestamp=function(d){var o=this.getDataTimestamp();if(o&&!d){this.destroyAggregation("_dataTimestamp");this._removeTimestampListener();}this.setProperty("dataTimestamp",d);if(d){this._updateDataTimestamp();this._addTimestampListener();}return this;};
B.prototype.setDataTimestampUpdating=function(d){var t=this._createDataTimestamp();this.setProperty("dataTimestampUpdating",d);if(d){t.setText("updating...");t.addStyleClass("sapFCardDataTimestampUpdating");this._removeTimestampListener();}else{t.removeStyleClass("sapFCardDataTimestampUpdating");}return this;};
B.prototype._createDataTimestamp=function(){var d=this.getAggregation("_dataTimestamp");if(!d){d=new T({wrapping:false,textAlign:"End"});d.addStyleClass("sapFCardDataTimestamp");this.setAggregation("_dataTimestamp",d);}return d;};
B.prototype._updateDataTimestamp=function(){var d=this._createDataTimestamp(),s=this.getDataTimestamp(),o,u,f;if(!s){d.setText("");return;}o=D.getDateTimeInstance({relative:true});u=new U(s);f=o.format(u);if(u.getTime()+59000>(new Date()).getTime()){f="now";}d.setText(f);d.removeStyleClass("sapFCardDataTimestampUpdating");};
B.prototype._addTimestampListener=function(){B.getTimestampIntervalTrigger().addListener(this._updateDataTimestamp,this);this._bHasTimestampListener=true;};
B.prototype._removeTimestampListener=function(){if(!this._bHasTimestampListener){return;}B.getTimestampIntervalTrigger().removeListener(this._updateDataTimestamp,this);this._bHasTimestampListener=false;};
B.getTimestampIntervalTrigger=function(){if(!B._oTimestampIntervalTrigger){B._oTimestampIntervalTrigger=new I(a);}return B._oTimestampIntervalTrigger;};
B.prototype.getAriaRole=function(){return this.hasListeners("press")?"button":"heading";};
B.prototype.getAriaHeadingLevel=function(){return this.hasListeners("press")?undefined:"3";};
B.prototype.getAriaRoleDescription=function(){return this.hasListeners("press")?this._oRb.getText("ARIA_ROLEDESCRIPTION_INTERACTIVE_CARD_HEADER"):this._oRb.getText("ARIA_ROLEDESCRIPTION_CARD_HEADER");};
return B;});
sap.ui.predefine('sap/f/cards/Header',["./BaseHeader","sap/m/library","sap/f/library","sap/m/Text","sap/m/Avatar","sap/f/cards/HeaderRenderer","sap/ui/core/Core","sap/ui/core/InvisibleText"],function(B,l,a,T,A,H,C,I){"use strict";var b=l.AvatarShape;var c=l.AvatarColor;
var d=B.extend("sap.f.cards.Header",{
metadata:{library:"sap.f",interfaces:["sap.f.cards.IHeader"],properties:{title:{type:"string",defaultValue:""},subtitle:{type:"string",defaultValue:""},statusText:{type:"string",defaultValue:""},iconDisplayShape:{type:"sap.m.AvatarShape",defaultValue:b.Circle},iconSrc:{type:"sap.ui.core.URI",defaultValue:""},iconInitials:{type:"string",defaultValue:""},iconAlt:{type:"string",defaultValue:""},iconBackgroundColor:{type:"sap.m.AvatarColor",defaultValue:c.Transparent}},aggregations:{_title:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_subtitle:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_avatar:{type:"sap.m.Avatar",multiple:false,visibility:"hidden"}},events:{press:{}}},
renderer:H
});
d.prototype.init=function(){B.prototype.init.apply(this,arguments);this._oRb=C.getLibraryResourceBundle("sap.f");this.data("sap-ui-fastnavgroup","true",true);this._oAriaAvatarText=new I({id:this.getId()+"-ariaAvatarText"});this._oAriaAvatarText.setText(this._oRb.getText("ARIA_HEADER_AVATAR_TEXT"));};
d.prototype.exit=function(){B.prototype.exit.apply(this,arguments);if(this._oAriaAvatarText){this._oAriaAvatarText.destroy();this._oAriaAvatarText=null;}this._oRb=null;};
d.prototype._getTitle=function(){var t=this.getAggregation("_title");if(!t){t=new T({maxLines:3}).addStyleClass("sapFCardTitle");this.setAggregation("_title",t);}return t;};
d.prototype._getSubtitle=function(){var s=this.getAggregation("_subtitle");if(!s){s=new T({maxLines:2}).addStyleClass("sapFCardSubtitle");this.setAggregation("_subtitle",s);}return s;};
d.prototype._getAvatar=function(){var o=this.getAggregation("_avatar");if(!o){o=new A().addStyleClass("sapFCardIcon");this.setAggregation("_avatar",o);}return o;};
d.prototype.onBeforeRendering=function(){B.prototype.onBeforeRendering.apply(this,arguments);var o=this._getAvatar();this._getTitle().setText(this.getTitle());this._getSubtitle().setText(this.getSubtitle());o.setDisplayShape(this.getIconDisplayShape());o.setSrc(this.getIconSrc());o.setInitials(this.getIconInitials());o.setTooltip(this.getIconAlt());o.setBackgroundColor(this.getIconBackgroundColor());};
d.prototype._getAriaLabelledBy=function(){var s="",t="",S="",e="",f="",i;if(this.getParent()&&this.getParent()._ariaText){s=this.getParent()._ariaText.getId();}if(this.getTitle()){t=this._getTitle().getId();}if(this.getSubtitle()){S=this._getSubtitle().getId();}if(this.getStatusText()){e=this.getId()+"-status";}if(this.getIconSrc()||this.getIconInitials()){f=this.getId()+"-ariaAvatarText";}i=s+" "+t+" "+S+" "+e+" "+f;return i.replace(/ {2,}/g,' ').trim();};
d.prototype.ontap=function(e){var s=e.srcControl;if(s&&s.getId().indexOf("overflowButton")>-1){return;}this.firePress();};
d.prototype.onsapselect=function(){this.firePress();};
d.prototype.isLoading=function(){return false;};
d.prototype.attachPress=function(){var m=Array.prototype.slice.apply(arguments);m.unshift("press");B.prototype.attachEvent.apply(this,m);this.invalidate();return this;};
d.prototype.detachPress=function(){var m=Array.prototype.slice.apply(arguments);m.unshift("press");B.prototype.detachEvent.apply(this,m);this.invalidate();return this;};
d.prototype._isInsideGridContainer=function(){var p=this.getParent();if(!p){return false;}p=p.getParent();if(!p){return false;}return p.isA("sap.f.GridContainer");};
return d;});
sap.ui.predefine('sap/f/cards/HeaderRenderer',[],function(){"use strict";var H={apiVersion:2};
H.render=function(r,h){var b=h.mBindingInfos,s=h.getStatusText(),t=h.getAggregation("_title"),S=h.getAggregation("_subtitle"),a=h.getSubtitle()||b.subtitle,A=h.getAggregation("_avatar"),d=h.getAggregation("_dataTimestamp"),c=h.getDataTimestamp()||b.dataTimestamp,l=h.isLoading(),e=h.getAggregation("_error"),T=h.getToolbar(),f=h._isInsideGridContainer()?"-1":"0";r.openStart("div",h).attr("tabindex",f).class("sapFCardHeader");if(l){r.class("sapFCardHeaderLoading");}if(h.hasListeners("press")){r.class("sapFCardClickable");}if(e){r.class("sapFCardHeaderError");}r.accessibilityState(h,{role:h.getAriaRole(),labelledby:{value:h._getAriaLabelledBy(),append:true},roledescription:{value:h.getAriaRoleDescription(),append:true},level:{value:h.getAriaHeadingLevel()}});r.openEnd();r.openStart("div").class("sapFCardHeaderWrapper").openEnd();if(e){r.renderControl(e);r.close("div");r.close("div");return;}if(h.getIconSrc()||h.getIconInitials()||b.iconSrc){r.openStart("div").class("sapFCardHeaderImage").openEnd();if(b.iconSrc&&b.iconSrc.binding&&!b.iconSrc.binding.getValue()){A.addStyleClass("sapFCardHeaderItemBinded");}r.renderControl(A);r.renderControl(h._oAriaAvatarText);r.close("div");}r.openStart("div").class("sapFCardHeaderText").openEnd();if(h.getTitle()||b.title){r.openStart("div").class("sapFCardHeaderTextFirstLine").openEnd();if(b.title){t.addStyleClass("sapFCardHeaderItemBinded");}r.renderControl(t);if(s!==undefined){r.openStart("span",h.getId()+"-status").class("sapFCardStatus");if(b.statusText){r.class("sapFCardHeaderItemBinded");}r.openEnd().text(s).close("span");}r.close("div");if(a||c){r.openStart("div").class("sapFCardHeaderTextSecondLine");if(c){r.class("sapFCardHeaderLineIncludesDataTimestamp");}r.openEnd();if(a){if(b.subtitle){S.addStyleClass("sapFCardHeaderItemBinded");}r.renderControl(S);}if(c){r.renderControl(d);}r.close("div");}}r.close("div");r.close("div");if(T){r.openStart("div").class("sapFCardHeaderToolbarCont").openEnd();r.renderControl(T);r.close("div");}r.close("div");};
return H;},true);
sap.ui.predefine('sap/f/cards/NumericHeader',["./BaseHeader","./NumericIndicators","sap/m/Text","sap/f/cards/NumericHeaderRenderer","sap/ui/core/Core"],function(B,N,T,a,C){"use strict";
var b=B.extend("sap.f.cards.NumericHeader",{
metadata:{library:"sap.f",interfaces:["sap.f.cards.IHeader"],properties:{title:{"type":"string",group:"Appearance"},subtitle:{"type":"string",group:"Appearance"},statusText:{type:"string",defaultValue:""},unitOfMeasurement:{"type":"string",group:"Data"},number:{"type":"string",group:"Data"},scale:{"type":"string",group:"Data"},trend:{"type":"sap.m.DeviationIndicator",group:"Appearance",defaultValue:"None"},state:{"type":"sap.m.ValueColor",group:"Appearance",defaultValue:"Neutral"},details:{"type":"string",group:"Appearance"},sideIndicatorsAlignment:{"type":"sap.f.cards.NumericHeaderSideIndicatorsAlignment",group:"Appearance",defaultValue:"Begin"}},aggregations:{sideIndicators:{type:"sap.f.cards.NumericSideIndicator",multiple:true,forwarding:{getter:"_getNumericIndicators",aggregation:"sideIndicators"}},_title:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_subtitle:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_unitOfMeasurement:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_details:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_numericIndicators:{type:"sap.f.cards.NumericIndicators",multiple:false,visibility:"hidden"}},events:{press:{}}},
renderer:a
});
b.prototype.init=function(){B.prototype.init.apply(this,arguments);this._oRb=C.getLibraryResourceBundle("sap.f");this.data("sap-ui-fastnavgroup","true",true);};
b.prototype.exit=function(){B.prototype.exit.apply(this,arguments);this._oRb=null;};
b.prototype.setTitle=function(v){this.setProperty("title",v,true);this._getTitle().setText(v);return this;};
b.prototype.setSubtitle=function(v){this.setProperty("subtitle",v,true);this._getSubtitle().setText(v);return this;};
b.prototype.setUnitOfMeasurement=function(v){this.setProperty("unitOfMeasurement",v,true);this._getUnitOfMeasurement().setText(v);return this;};
b.prototype.setDetails=function(v){this.setProperty("details",v,true);this._getDetails().setText(v);return this;};
b.prototype.setNumber=function(v){this.setProperty("number",v);this._getNumericIndicators().setNumber(v);return this;};
b.prototype.setScale=function(v){this.setProperty("scale",v,true);this._getNumericIndicators().setScale(v);return this;};
b.prototype.setTrend=function(v){this.setProperty("trend",v,true);this._getNumericIndicators().setTrend(v);return this;};
b.prototype.setState=function(v){this.setProperty("state",v,true);this._getNumericIndicators().setState(v);return this;};
b.prototype.setSideIndicatorsAlignment=function(v){this.setProperty("sideIndicatorsAlignment",v,true);this._getNumericIndicators().setSideIndicatorsAlignment(v);return this;};
b.prototype._getTitle=function(){var c=this.getAggregation("_title");if(!c){c=new T({id:this.getId()+"-title",wrapping:true,maxLines:3});this.setAggregation("_title",c);}return c;};
b.prototype._getSubtitle=function(){var c=this.getAggregation("_subtitle");if(!c){c=new T({id:this.getId()+"-subtitle",wrapping:true,maxLines:2});this.setAggregation("_subtitle",c);}return c;};
b.prototype._getUnitOfMeasurement=function(){var c=this.getAggregation("_unitOfMeasurement");if(!c){c=new T({id:this.getId()+"-unitOfMeasurement",wrapping:false});this.setAggregation("_unitOfMeasurement",c);}return c;};
b.prototype._getDetails=function(){var c=this.getAggregation("_details");if(!c){c=new T({id:this.getId()+"-details",wrapping:false});this.setAggregation("_details",c);}return c;};
b.prototype._getNumericIndicators=function(){var c=this.getAggregation("_numericIndicators");if(!c){c=new N();this.setAggregation("_numericIndicators",c);}return c;};
b.prototype.ontap=function(e){var s=e.srcControl;if(s&&s.getId().indexOf("overflowButton")>-1){return;}this.firePress();};
b.prototype.onsapselect=function(){this.firePress();};
b.prototype._getAriaLabelledBy=function(){var c="",t="",s="",S="",u=this._getUnitOfMeasurement().getId(),m="",d=this._getSideIndicatorIds(),D="",i;if(this.getParent()&&this.getParent()._ariaText){c=this.getParent()._ariaText.getId();}if(this.getTitle()){t=this._getTitle().getId();}if(this.getSubtitle()){s=this._getSubtitle().getId();}if(this.getStatusText()){S=this.getId()+"-status";}if(this.getDetails()){D=this._getDetails().getId();}if(this.getNumber()||this.getScale()){m=this._getNumericIndicators()._getMainIndicator().getId();}i=c+" "+t+" "+s+" "+S+" "+u+" "+m+" "+d+" "+D;return i.replace(/ {2,}/g,' ').trim();};
b.prototype._getSideIndicatorIds=function(){return this.getSideIndicators().map(function(s){return s.getId();}).join(" ");};
b.prototype.isLoading=function(){return false;};
b.prototype.attachPress=function(){var m=Array.prototype.slice.apply(arguments);m.unshift("press");B.prototype.attachEvent.apply(this,m);this.invalidate();return this;};
b.prototype.detachPress=function(){var m=Array.prototype.slice.apply(arguments);m.unshift("press");B.prototype.detachEvent.apply(this,m);this.invalidate();return this;};
b.prototype._isInsideGridContainer=function(){var p=this.getParent();if(!p){return false;}p=p.getParent();if(!p){return false;}return p.isA("sap.f.GridContainer");};
return b;});
sap.ui.predefine('sap/f/cards/NumericHeaderRenderer',[],function(){"use strict";var N={apiVersion:2};
N.render=function(r,n){var l=n.isLoading(),e=n.getAggregation("_error"),t=n._isInsideGridContainer()?"-1":"0";r.openStart("div",n).class("sapFCardHeader").class("sapFCardNumericHeader").attr("tabindex",t);if(l){r.class("sapFCardHeaderLoading");}if(n.hasListeners("press")){r.class("sapFCardClickable");}if(e){r.class("sapFCardHeaderError");}r.accessibilityState(n,{role:n.getAriaRole(),labelledby:{value:n._getAriaLabelledBy(),append:true},roledescription:{value:n.getAriaRoleDescription(),append:true},level:{value:n.getAriaHeadingLevel()}});r.openEnd();r.openStart("div").class("sapFCardHeaderContent").openEnd();if(e){r.renderControl(e);}else{N.renderHeaderText(r,n);N.renderIndicators(r,n);N.renderDetails(r,n);}r.close("div");if(!e){N.renderToolbar(r,n);}r.close("div");};
N.renderToolbar=function(r,n){var t=n.getToolbar();if(t){r.openStart("div").class("sapFCardHeaderToolbarCont").openEnd();r.renderControl(t);r.close("div");}};
N.renderHeaderText=function(r,n){var t=n.getAggregation("_title"),s=n.getStatusText(),b=n.mBindingInfos;r.openStart("div").class("sapFCardHeaderText").openEnd();r.openStart("div").class("sapFCardHeaderTextFirstLine").openEnd();if(t){if(b.title){t.addStyleClass("sapFCardHeaderItemBinded");}t.addStyleClass("sapFCardTitle");r.renderControl(t);}if(s){r.openStart("span",n.getId()+'-status').class("sapFCardStatus");if(b.statusText){r.class("sapFCardHeaderItemBinded");}r.openEnd().text(s).close("span");}r.close("div");N.renderSubtitle(r,n);r.close("div");};
N.renderSubtitle=function(r,n){var b=n.mBindingInfos,s=n.getAggregation("_subtitle"),u=n.getAggregation("_unitOfMeasurement"),h=s&&s.getText()||b&&b.subtitle,H=u&&u.getText()||b&&b.unitOfMeasurement;if(h||H){r.openStart("div").class("sapFCardSubtitle");if(h&&u){r.class("sapFCardSubtitleAndUnit");}r.openEnd();if(s){if(b.subtitle){s.addStyleClass("sapFCardHeaderItemBinded");}r.renderControl(s);}if(u){u.addStyleClass("sapFCardHeaderUnitOfMeasurement");if(b.unitOfMeasurement){u.addStyleClass("sapFCardHeaderItemBinded");}r.renderControl(u);}r.close("div");}};
N.renderIndicators=function(r,n){if(!n.getNumber()&&n.getSideIndicators().length===0){return;}var o=n._getNumericIndicators(),m=o._getMainIndicator();if(n.isBound("scale")||n.isBound("number")||n.isBound("trend")||n.isBound("state")){m.addStyleClass("sapFCardHeaderItemBinded");}else{m.removeStyleClass("sapFCardHeaderItemBinded");}r.renderControl(o);};
N.renderDetails=function(r,n){var b=n.mBindingInfos,d=n.getAggregation("_details"),h=n.getDetails()||b.details,D=n.getAggregation("_dataTimestamp"),H=n.getDataTimestamp()||b.dataTimestamp;if(!h&&!H){return;}r.openStart("div").class("sapFCardHeaderDetailsWrapper");if(H){r.class("sapFCardHeaderLineIncludesDataTimestamp");}r.openEnd();if(h){if(b.details){d.addStyleClass("sapFCardHeaderItemBinded");}d.addStyleClass("sapFCardHeaderDetails");r.renderControl(d);}if(H){r.renderControl(D);}r.close("div");};
return N;},true);
sap.ui.predefine('sap/f/cards/NumericIndicators',["./NumericIndicatorsRenderer","sap/ui/core/Control","sap/m/NumericContent"],function(N,C,a){"use strict";
var b=C.extend("sap.f.cards.NumericIndicators",{
metadata:{library:"sap.f",properties:{number:{"type":"string",group:"Data"},numberSize:{"type":"string",group:"Appearance",defaultValue:"L"},scale:{"type":"string",group:"Data"},trend:{"type":"sap.m.DeviationIndicator",group:"Appearance",defaultValue:"None"},state:{"type":"sap.m.ValueColor",group:"Appearance",defaultValue:"Neutral"},sideIndicatorsAlignment:{"type":"sap.f.cards.NumericHeaderSideIndicatorsAlignment",group:"Appearance",defaultValue:"Begin"}},aggregations:{sideIndicators:{type:"sap.f.cards.NumericSideIndicator",multiple:true},_mainIndicator:{type:"sap.m.NumericContent",multiple:false,visibility:"hidden"}}},
renderer:N
});
b.prototype.setNumber=function(v){this.setProperty("number",v);this._getMainIndicator().setValue(v);return this;};
b.prototype.setScale=function(v){this.setProperty("scale",v,true);this._getMainIndicator().setScale(v);return this;};
b.prototype.setTrend=function(v){this.setProperty("trend",v,true);this._getMainIndicator().setIndicator(v);return this;};
b.prototype.setState=function(v){this.setProperty("state",v,true);this._getMainIndicator().setValueColor(v);return this;};
b.prototype._getMainIndicator=function(){var c=this.getAggregation("_mainIndicator");if(!c){c=new a({id:this.getId()+"-mainIndicator",withMargin:false,nullifyValue:false,animateTextChange:false,truncateValueTo:100});this.setAggregation("_mainIndicator",c);}return c;};
return b;});
sap.ui.predefine('sap/f/cards/NumericIndicatorsRenderer',[],function(){"use strict";var N={apiVersion:2};
N.render=function(r,n){var m=n.getAggregation("_mainIndicator"),s=n.getSideIndicators();r.openStart("div",n).class("sapFCardNumericIndicators").class("sapFCardNumericIndicatorsSideAlign"+n.getSideIndicatorsAlignment());if(n.getNumberSize()==="S"){r.class("sapMTileSmallPhone");}r.openEnd();if(m){r.openStart("div").class("sapFCardNumericIndicatorsMain").openEnd().renderControl(m).close("div");r.openStart("div").class("sapFCardNumericIndicatorsGap").openEnd().close("div");}if(s.length!==0){r.openStart("div").class("sapFCardNumericIndicatorsSide").openEnd();s.forEach(function(i){r.renderControl(i);});r.close("div");}r.close("div");};
return N;});
sap.ui.predefine('sap/f/cards/NumericSideIndicator',["sap/ui/core/Control","sap/m/Text","sap/f/cards/NumericSideIndicatorRenderer"],function(C,T,N){"use strict";
var a=C.extend("sap.f.cards.NumericSideIndicator",{
metadata:{library:"sap.f",properties:{title:{"type":"string",group:"Appearance"},number:{"type":"string",group:"Data"},unit:{"type":"string",group:"Data"},state:{"type":"sap.m.ValueColor",group:"Appearance",defaultValue:"None"}},aggregations:{_title:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_number:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_unit:{type:"sap.m.Text",multiple:false,visibility:"hidden"}}},
renderer:N
});
a.prototype.setTitle=function(v){this.setProperty("title",v,true);this._getTitle().setText(v);return this;};
a.prototype.setNumber=function(v){this.setProperty("number",v,true);this._getNumber().setText(v);return this;};
a.prototype.setUnit=function(v){this.setProperty("unit",v,true);this._getUnit().setText(v);return this;};
a.prototype._getTitle=function(){var c=this.getAggregation("_title");if(!c){c=new T({id:this.getId()+"-title",wrapping:false});this.setAggregation("_title",c);}return c;};
a.prototype._getNumber=function(){var c=this.getAggregation("_number");if(!c){c=new T({id:this.getId()+"-number"});this.setAggregation("_number",c);}return c;};
a.prototype._getUnit=function(){var c=this.getAggregation("_unit");if(!c){c=new T({id:this.getId()+"-unit"});this.setAggregation("_unit",c);}return c;};
return a;});
sap.ui.predefine('sap/f/cards/NumericSideIndicatorRenderer',[],function(){"use strict";var N={apiVersion:2};
N.render=function(r,n){var b=n.mBindingInfos;r.openStart("div",n).class("sapFCardHeaderSideIndicator").class("sapFCardHeaderSideIndicatorState"+n.getState());if(b.title||b.number||b.unit){r.class("sapFCardHeaderItemBinded");}r.openEnd();var t=n.getAggregation("_title");if(t){t.addStyleClass("sapFCardHeaderSITitle");r.renderControl(t);}r.openStart("div").class("sapFCardHeaderSINumber");if(b.title||b.number||b.unit||b.state){r.class("sapFCardHeaderItemBinded");}r.openEnd();var o=n.getAggregation("_number");if(o){r.renderControl(o);}var u=n.getAggregation("_unit");if(u){r.renderControl(u);}r.close("div");r.close("div");};
return N;},true);
sap.ui.predefine('sap/f/cards/loading/GenericPlaceholder',["sap/ui/core/Control","sap/ui/core/Core"],function(C,a){"use strict";
var G=C.extend("sap.f.cards.loading.GenericPlaceholder",{
metadata:{library:"sap.f"},
renderer:{apiVersion:2,render:function(r,c){var R=a.getLibraryResourceBundle("sap.ui.core"),t=R.getText("BUSY_TEXT");r.openStart("div",c).class("sapFCardContentPlaceholder").class("sapFCardContentGenericPlaceholder").attr("tabindex","0").attr("title",t);r.accessibilityState(c,{role:"progressbar",valuemin:"0",valuemax:"100"});r.openEnd();r.openStart("div").class("sapFCardLoadingShimmer").openEnd();this.renderSVG(r);r.close("div");r.close("div");},renderSVG:function(r){r.openStart("svg").attr("height","100%").attr("xmlns","http://www.w3.org/2000/svg").attr("version","1.1").attr("viewBox","0 0 144 144").class("sapFCardSVG").openEnd();r.openStart("g").openEnd();r.openStart("path").attr("d","M0,0v144h144V0H0z M36.4,114h-8.8V87.8h8.8V114z M50.3,114h-9.2V80.8h9.2V114z M64.1,114h-9.2V99.9h9.2V114z M66.9,64.9 c0,1.6-0.8,2.4-2.2,2.4H26.8c-1.6,0-2.4-0.8-2.4-2.4V26.4c0-1.6,0.8-2.4,2.4-2.4h37.9c1.5,0,2.2,0.8,2.2,2.4V64.9z M119.6,117.6 c0,1.6-0.8,2.4-2.2,2.4H79.1c-1.6,0-2.4-0.8-2.4-2.4V79.1c0-1.6,0.8-2.4,2.4-2.4h38.2c1.5,0,2.2,0.8,2.2,2.4V117.6z M119.6,64.7 c0,0.6-0.2,1.2-0.7,1.8c-0.4,0.6-1,0.8-1.6,0.8H79.1c-0.6,0-1.2-0.3-1.7-0.8c-0.5-0.6-0.8-1.2-0.8-1.8V26.4c0-0.6,0.3-1.2,0.8-1.7 c0.6-0.5,1.2-0.8,1.8-0.8h38.1c1.5,0,2.2,0.8,2.2,2.4V64.7z").openEnd().close("path");r.openStart("path").attr("d","M92.3,104.8l-6.6-5.1l-4.5,6l9.6,7.3c0.2,0.4,0.9,0.7,2.1,0.9c1.4,0,2.5-0.6,3.4-1.7L114,87l-6.2-4.3L92.3,104.8z").openEnd().close("path");r.openStart("rect").attr("x","32.8").attr("y","43.1").attr("width","25.9").attr("height","5.2").openEnd().close("rect");r.openStart("rect").attr("x","32.8").attr("y","52.5").attr("width","25.9").attr("height","5.2").openEnd().close("rect");r.openStart("path").attr("d","M115.9,27.2H81c-0.8,0-1.1,0.4-1.1,1.1v34.9c0,0.6,0.4,0.9,1.1,0.9h34.9c0.6,0,0.9-0.3,0.9-0.9V28.3 C116.8,27.6,116.5,27.2,115.9,27.2z M93.8,35.3c1.2-0.9,2.7-1.4,4.4-1.4c1.9,0,3.4,0.5,4.5,1.6c1.1,1.1,1.7,2.7,1.7,4.8 c0,1.9-0.7,3.3-2,4.2s-2.7,1.4-4.2,1.4c-1.8,0-3.2-0.5-4.4-1.5c-1.2-1-1.8-2.6-1.8-4.7C92.1,37.8,92.7,36.3,93.8,35.3z M108.8,59.6 H87.4v-5.8c0-1.6,0.3-2.9,1-3.8c0.7-0.9,1.6-1.7,2.6-2.2c1.1-0.5,2.2-0.8,3.4-0.9c1.2-0.1,2.3-0.2,3.3-0.2h1.1 c2.6,0,4.9,0.4,6.9,1.3c2,0.9,3,2.8,3,5.8V59.6z").openEnd().close("path");r.openStart("rect").attr("x","32.8").attr("y","33.8").attr("width","25.9").attr("height","5.1").openEnd().close("rect");r.close("g");r.close("svg");}}
});
return G;});
sap.ui.predefine('sap/f/cards/loading/ListPlaceholder',["sap/ui/core/Control","sap/ui/core/Core"],function(C,a){"use strict";
var L=C.extend("sap.f.cards.loading.ListPlaceholder",{
metadata:{library:"sap.f",properties:{maxItems:{type:"int",group:"Misc"},item:{type:"any"},itemHeight:{type:"sap.ui.core.CSSSize"}}},
renderer:{apiVersion:2,render:function(r,c){var m=c.getMaxItems(),I=c.getItem(),R=a.getLibraryResourceBundle("sap.ui.core"),t=R.getText("BUSY_TEXT");r.openStart("div",c).class("sapFCardContentPlaceholder").class("sapFCardContentListPlaceholder").attr("tabindex","0").attr("title",t);r.accessibilityState(c,{role:"progressbar",valuemin:"0",valuemax:"100"});r.openEnd();for(var i=0;i<m;i++){r.openStart("div").class("sapFCardListPlaceholderItem").style("height",c.getItemHeight()).openEnd();if(I&&I.icon){r.openStart("div").class("sapFCardListPlaceholderImg").class("sapFCardLoadingShimmer").openEnd().close("div");}r.openStart("div").class("sapFCardListPlaceholderRows").openEnd();if(I){this.renderTitleAndDescription(r,I);this.renderAttributes(r,I);if(I.chart){this.renderRow(r);}if(I.actionsStrip){this.renderRow(r);}}r.close("div");r.close("div");}r.close("div");},renderTitleAndDescription:function(r,i){if(i.attributes&&i.title&&i.description){this.renderRow(r,true);return;}if(i.title){this.renderRow(r);}if(i.description){this.renderRow(r);}},renderRow:function(r,c){r.openStart("div").class("sapFCardListPlaceholderRow").class("sapFCardLoadingShimmer");if(c){r.class("sapFCardListPlaceholderRowCombined");}r.openEnd().close("div");},renderAttributes:function(r,I){if(!I.attributes){return;}var A=I.attributes.length/2+1;for(var j=0;j<A;j++){r.openStart("div").class("sapFCardListPlaceholderRow").openEnd();var b=j===A-1?1:2;for(var i=0;i<b;i++){r.openStart("div").class("sapFCardListPlaceholderAttr").class("sapFCardLoadingShimmer").openEnd().close("div");}r.close("div");}}}
});
return L;});
sap.ui.predefine('sap/f/changeHandler/MoveDynamicPageTitleActions',[],function(){"use strict";var M={};var A="actions";
M.applyChange=function(c,C,p){var m=p.modifier;var v=p.view;var a=p.appComponent;var o=c.getDefinition().content.movedElements[0];var t=o.targetIndex;var b;var O;return Promise.resolve().then(m.bySelector.bind(m,o.selector,a,v)).then(function(e){b=e;return m.getAggregation(C,A);}).then(function(B){var P;B.some(function(d,i){if(m.getId(d)===m.getId(b)){O=i;P=Promise.resolve().then(m.removeAggregation.bind(m,C,A,d)).then(m.insertAggregation.bind(m,C,"dependents",d,undefined,v));return true;}return false;});return P.then(function(){c.setRevertData({index:O,sourceParent:m.getSelector(C,a),aggregation:A});return m.insertAggregation(C,A,b,t,v);});});};
M.revertChange=function(c,C,p){var m=p.modifier;var v=p.view;var a=p.appComponent;var o=c.getDefinition().content.movedElements[0];var r=c.getRevertData();var b;var t;var s;b=m.bySelector(o.selector,a,v);t=r?r.index:o.targetIndex;s=o.sourceIndex;return Promise.resolve().then(m.removeAggregation.bind(m,C,A,b,t,v)).then(m.insertAggregation.bind(m,C,A,b,s,v));};
M.completeChangeContent=function(c,s,p){var m=p.modifier,a=p.appComponent,C=c.getDefinition();C.content={movedElements:[],targetAggregation:s.target.aggregation,targetContainer:s.selector};s.movedElements.forEach(function(e){var E=e.element||m.bySelector(e.id,a);C.content.movedElements.push({selector:m.getSelector(E,a),sourceIndex:e.sourceIndex,targetIndex:e.targetIndex});});};
M.getCondenserInfo=function(c){var C=c.getContent();var r=c.getRevertData();return{affectedControl:C.movedElements[0].selector,classification:sap.ui.fl.condenser.Classification.Move,sourceContainer:r.sourceParent,targetContainer:C.targetContainer,sourceIndex:r.index,sourceAggregation:r.aggregation,targetAggregation:C.targetAggregation,setTargetIndex:function(c,n){c.getContent().movedElements[0].targetIndex=n;},getTargetIndex:function(c){return c.getContent().movedElements[0].targetIndex;}};};
return M;},true);
sap.ui.predefine('sap/f/delegate/GridContainerItemNavigation',["sap/ui/core/delegate/ItemNavigation","./GridItemNavigation","sap/ui/dom/containsOrEquals"],function(I,G,c){"use strict";
function d(C){if(C.onfocusin){C.onfocusin();}}
var a=G.extend("sap.f.delegate.GridContainerItemNavigation",{
constructor:function(){G.apply(this,arguments);this.attachEvent(I.Events.FocusLeave,this._onFocusLeave,this);},
metadata:{library:"sap.f",properties:{},events:{}}
});
a.prototype._onFocusLeave=function(e){var b=this.getFocusedDomRef();this.getItemDomRefs().forEach(function(i,f){if(b===i){var n=f++;this.setFocusedIndex(n);}}.bind(this));this._bFocusLeft=true;};
a.prototype.forwardTab=function(f){var i=this._getRootDomRefId()+"-"+(f?"after":"before");document.getElementById(i).focus();};
a.prototype._getRootDomRefId=function(f){return this.getRootDomRef().getAttribute("id");};
a.prototype.onsaptabnext=function(e){var n=this.getItemDomRefs(),l=this.getFocusedIndex(),L=jQuery(n[l]),T=[];var A=L.find(":sapTabbable");A.map(function(i,b){if(b.className.indexOf("DummyArea")===-1){T.push(b);}});var t=jQuery(T),f=t.length===1?0:t.length-1;if(f===-1||(t.control(f)&&t.control(f).getId()===e.target.id)){this._lastFocusedElement=e.target;this.forwardTab(true);}};
a.prototype.onsaptabprevious=function(e){if(!e.target.classList.contains("sapFGridContainerItemWrapper")){this._lastFocusedElement=e.target;return;}var t=e.target.id;if(t===(this._getRootDomRefId()+"-nodata")){this.forwardTab(false);}this._lastFocusedElement=null;this.forwardTab(false);};
a.prototype.onmousedown=function(e){this._bIsMouseDown=true;I.prototype.onmousedown.call(this,e);};
a.prototype.onmouseup=function(e){var $=jQuery(e.target).closest('.sapFGridContainerItemWrapperNoVisualFocus'),C;if($.length){C=$.children().eq(0).control()[0];if(C&&C.getFocusDomRef()===document.activeElement){this._lastFocusedElement=null;$.trigger("focus");d(C);}}this._bIsMouseDown=false;};
a.prototype.ondragend=function(){this._bIsMouseDown=false;};
a.prototype.ondrop=function(){this._bIsMouseDown=false;};
a.prototype.onfocusin=function(e){G.prototype.onfocusin.call(this,e);var $=jQuery(e.target).closest('.sapFGridContainerItemWrapperNoVisualFocus'),C,n,l,L;if($.length){C=$.children().eq(0).control()[0];if(C){d(C);if(!this._bIsMouseDown&&C.getFocusDomRef()===e.target){this._lastFocusedElement=null;$.trigger("focus");return;}}}if(e.target.classList.contains("sapFGridContainerItemWrapper")){this._lastFocusedElement=null;}if(this._bFocusLeft&&!this._bIsMouseDown){n=this.getItemDomRefs();l=this.getFocusedIndex();L=this._lastFocusedElement||n[l];if(!c(L,e.target)){L.focus();}}this._bFocusLeft=false;};
a.prototype.focusItem=function(i,e){var o,b,f;if(i===this.iFocusedIndex&&this.aItemDomRefs[this.iFocusedIndex]===document.activeElement){this.fireEvent(I.Events.FocusAgain,{index:i,event:e});return;}this.fireEvent(I.Events.BeforeFocus,{index:i,event:e});this.setFocusedIndex(i);this.bISetFocus=true;if(e&&jQuery(this.aItemDomRefs[this.iFocusedIndex]).data("sap.INRoot")){o=jQuery(this.aItemDomRefs[this.iFocusedIndex]).data("sap.INRoot");o._sFocusEvent=e.type;}if(!this._bIsMouseDown&&this.aItemDomRefs.length){this.aItemDomRefs[this.iFocusedIndex].focus();b=jQuery(this.aItemDomRefs[this.iFocusedIndex].firstChild).control()[0];if(b){f=b.getFocusDomRef();if(f){this.scrollIntoViewIfNeeded(f);}}}this.fireEvent(I.Events.AfterFocus,{index:i,event:e});};
a.prototype.scrollIntoViewIfNeeded=function(e){var p=e.parentElement,C,E;while(p&&p.offsetWidth>=p.scrollWidth&&p.offsetHeight>=p.scrollHeight){p=p.parentElement;}if(!p){return;}p=p.parentElement;if(!p){return;}C=p.getBoundingClientRect();E=e.getBoundingClientRect();if(E.top<C.top||E.bottom>C.bottom||E.right>C.right||E.left<C.left){e.scrollIntoView();}};
return a;});
sap.ui.predefine('sap/f/delegate/GridItemNavigation',["sap/ui/core/delegate/ItemNavigation","sap/ui/events/KeyCodes","sap/base/Log","sap/f/library"],function(I,K,L,l){"use strict";var N=l.NavigationDirection;
var G=I.extend("sap.f.delegate.GridItemNavigation",{metadata:{library:"sap.f",properties:{},events:{}}});
G.prototype.resetFocusPosition=function(){this._mCurrentPosition=null;};
G.prototype.onfocusin=function(e){I.prototype.onfocusin.call(this,e);var m=this._getGridInstance().getNavigationMatrix();if(m&&e.target===this.oDomRef){this._mCurrentPosition=this._findPositionInMatrix(m,this.getItemDomRefs().indexOf(this.iFocusedIndex));}};
G.prototype.onsapfocusleave=function(e){I.prototype.onsapfocusleave.call(this,e);if(e.target===this.oDomRef){this.resetFocusPosition();}};
G.prototype.ontap=function(e){this.resetFocusPosition();};
G.prototype.onsapnext=function(e){this._moveFocus(e);};
G.prototype.onsapprevious=function(e){this._moveFocus(e);};
G.prototype._moveFocus=function(e){var i=this.getItemDomRefs(),c=e.target,m,s;if(i.indexOf(e.target)===-1){return;}e.preventDefault();m=this._getGridInstance().getNavigationMatrix();if(!m){return;}s=this._findPositionInMatrix(m,c);if(!this._mCurrentPosition){this._mCurrentPosition={column:s.column,row:s.row};}switch(e.keyCode){case K.ARROW_DOWN:this._moveFocusDown(s,m,c,e);break;case K.ARROW_RIGHT:this._moveFocusRight(s,m,c,e);break;case K.ARROW_UP:this._moveFocusUp(s,m,c,e);break;case K.ARROW_LEFT:this._moveFocusLeft(s,m,c,e);break;default:break;}L.info("Grid matrix position: ("+s.row+", "+s.column+")");};
G.prototype._moveFocusDown=function(s,m,c,e){var i=this.getItemDomRefs(),n;s.column=this._mCurrentPosition.column;while(s.row<m.length&&(m[s.row][s.column]===c||m[s.row][s.column]===false)){s.row+=1;}if(s.row>=m.length){this._onBorderReached(e);return;}n=m[s.row][s.column];if(n){this._mCurrentPosition=s;this.focusItem(i.indexOf(n),e);}else{this._onBorderReached(e);}};
G.prototype._moveFocusRight=function(s,m,c,e){var i=this.getItemDomRefs(),n;s.row=this._mCurrentPosition.row;while(s.column<m[s.row].length&&(m[s.row][s.column]===c||m[s.row][s.column]===false)){s.column+=1;}if(s.column>=m[s.row].length){this._onBorderReached(e);return;}n=m[s.row][s.column];if(n){this._mCurrentPosition=s;this.focusItem(i.indexOf(n),e);}else{this._onBorderReached(e);}};
G.prototype._moveFocusUp=function(s,m,c,e){var i=this.getItemDomRefs(),n;s.column=this._mCurrentPosition.column;while(s.row>=0&&(m[s.row][s.column]===c||m[s.row][s.column]===false)){s.row-=1;}if(s.row<0){this._onBorderReached(e);return;}n=m[s.row][s.column];if(n){while(s.row>0&&m[s.row-1][s.column]===n){s.row-=1;}this._mCurrentPosition=s;this.focusItem(i.indexOf(n),e);}else{this._onBorderReached(e);}};
G.prototype._moveFocusLeft=function(s,m,c,e){var i=this.getItemDomRefs(),n;s.row=this._mCurrentPosition.row;while(s.column>=0&&(m[s.row][s.column]===c||m[s.row][s.column]===false)){s.column-=1;}if(s.column<0){this._onBorderReached(e);return;}n=m[s.row][s.column];if(n){while(s.column>0&&m[s.row][s.column-1]===n){s.column-=1;}this._mCurrentPosition=s;this.focusItem(i.indexOf(n),e);}else{this._onBorderReached(e);}};
G.prototype._findPositionInMatrix=function(m,i){var M=null;m.some(function(a,c){var r=a.indexOf(i);if(r!==-1){M={};M.row=c;M.column=r;return true;}return false;});return M;};
G.prototype._onBorderReached=function(e){var d;switch(e.keyCode){case K.ARROW_RIGHT:d=N.Right;break;case K.ARROW_LEFT:d=N.Left;break;case K.ARROW_DOWN:d=N.Down;break;case K.ARROW_UP:d=N.Up;break;}this._getGridInstance().onItemNavigationBorderReached({event:e,row:this._mCurrentPosition.row,column:this._mCurrentPosition.column,direction:d});};
G.prototype.focusItemByDirection=function(g,d,r,c){var C,m=g.getNavigationMatrix(),R,i,a;switch(d){case N.Right:i=r;a=-1;R=m[r];if(R){do{C=R[++a];}while(!C);}break;case N.Left:i=r;a=m[0].length;R=m[r];if(R){do{C=R[--a];}while(!C);}if(C){while(a>0&&m[r][a-1]===C){a--;}}break;case N.Down:i=-1;a=c;while(!C&&m[++i]&&m[i][c]!==undefined){C=m[i][c];}break;case N.Up:i=m.length;a=c;while(!C&&m[--i]&&m[i][c]!==undefined){C=m[i][c];}if(C){while(i>0&&m[i-1][c]===C){i--;}}break;default:break;}if(!C){return;}this._mCurrentPosition={column:a,row:i};C.focus();};
G.prototype._getGridInstance=function(){return jQuery(this.oDomRef).control(0);};
return G;});
sap.ui.predefine('sap/f/dnd/GridDragOver',['sap/ui/base/Object',"sap/ui/thirdparty/jquery","sap/base/Log"],function(B,q,L){"use strict";
var G=B.extend("sap.f.dnd.GridDragOver",{
_iTimeoutBeforeDrop:200,
_$indicator:q("<div class='sapUiDnDGridIndicator'></div>"),
constructor:function(){this._oDragControlDelegate={ondragend:this.scheduleEndDrag};this._oDropContainerDelegate={ondragleave:this._onDragLeave,onBeforeRendering:this._onDropContainerBeforeRendering,onAfterRendering:this._onDropContainerAfterRendering};},
destroy:function(){this._oDragEndDelegate=null;}
});
G.prototype.setCurrentContext=function(d,D,t,c){if(this._oDragControl===d&&this._oDropContainer===D&&this._sTargetAggregation===t){return this;}if(this._oDragControl&&this._oDragControl!==d){this.endDrag();}this._oDragControl=d;this._oDragContainer=d.getParent();this._oDropContainer=D;this._sTargetAggregation=t;this._oCoreDragSession=c;this._mDragItemDimensions=this._getDimensions(d);this._bIsInSameContainer=this._oDragContainer===this._oDropContainer;if(this._bIsInSameContainer){this._iDragFromIndex=D.indexOfAggregation(t,d);}else{this._iDragFromIndex=null;}D.getAggregation(t).forEach(function(C){C.addStyleClass("sapUiDnDGridControl");});this._attachEventDelegates();this._hideCoreDefaultIndicator();return this;};
G.prototype.handleDragOver=function(d){if(this._shouldFreeze(d.pageX,d.pageY)){return;}this._hideCoreDefaultIndicator();var D=this._calculateDropPosition(d);if(!D){return;}if(this._timeoutOnSamePosition(D)){if(D.targetControl===this._oDragControl){return;}this._hideDraggedItem();this._showIndicator(D,d);this._freezeCurrentPosition(d.pageX,d.pageY);}};
G.prototype.getSuggestedDropPosition=function(){return this._mLastDropPosition;};
G.prototype.setDropIndicatorSize=function(I){if(!I){this._mDropIndicatorSize=null;return;}if(!I.rows||!I.columns){L.error("Custom indicator size for grid drag and drop is not valid. It must be an object with rows and columns properties: '{rows: <int>, columns: <int>}'.");this._mDropIndicatorSize=null;return;}this._mDropIndicatorSize=I;};
G.prototype.scheduleEndDrag=function(){if(!this._isDragActive()){return;}var b=this._oDropContainer.getBindingInfo(this._sTargetAggregation);if(b&&b.template){setTimeout(this.endDrag.bind(this),0);}else{this.endDrag();}};
G.prototype.endDrag=function(){if(!this._isDragActive()){return;}this._hideIndicator();this._showDraggedItem();this._removeEventDelegates();this._resetCoreDefaultIndicator();this._mDropIndicatorSize=null;this._oDragControl=null;this._oDropContainer=null;this._sTargetAggregation=null;this._iDragFromIndex=null;this._iDropPositionHoldStart=null;this._mLastDropPosition=null;this._mFreezePosition=null;this._oCoreDragSession=null;};
G.prototype._isDragActive=function(){return this._oDragControl&&this._oDropContainer;};
G.prototype._showIndicator=function(d,D){var o=this._oDropContainer,a=o.getDomRefForSetting(this._sTargetAggregation)||o.getDomRef(),t=d.targetControl,T=o.indexOfAggregation(this._sTargetAggregation,t),$,b,s;if(t){$=this._findContainingGridItem(t);b=$||t.$();}if(this._mDropIndicatorSize){s={"grid-row-start":"span "+this._mDropIndicatorSize.rows,"grid-column-start":"span "+this._mDropIndicatorSize.columns};}else{s={"grid-column-start":this._mDragItemDimensions.columnsSpan,"grid-row-start":this._mDragItemDimensions.rowsSpan};}if(s){this._$indicator.css(s);}if(b&&d.position=="Before"){this._$indicator.insertBefore(b);}else if(b){this._$indicator.insertAfter(b);T+=1;}else{a.appendChild(this._$indicator[0]);}this._$indicator.show();this._iDragFromIndex=T;};
G.prototype._hideIndicator=function(){this._$indicator.detach();this._$indicator.attr("style","");};
G.prototype._hideDraggedItem=function(){this._oDragControl.$().hide();var $=this._findContainingGridItem(this._oDragControl);if($&&this._bIsInSameContainer){$.hide();}};
G.prototype._showDraggedItem=function(){if(this._oDragControl.getDomRef()){this._oDragControl.$().show();}var $=this._findContainingGridItem(this._oDragControl);if($){$.show();}};
G.prototype._hideCoreDefaultIndicator=function(){var c=this._oCoreDragSession.getIndicator(),s={visibility:"hidden",position:"relative"};this._oCoreDragSession.setIndicatorConfig(s);if(c){q(c).css(s);}};
G.prototype._resetCoreDefaultIndicator=function(){var c=this._oCoreDragSession.getIndicator(),s={visibility:"visible",position:"absolute"};this._oCoreDragSession.setIndicatorConfig(s);if(c){q(c).css(s);}};
G.prototype._timeoutOnSamePosition=function(d){if(!this._mLastDropPosition||d.targetControl!==this._mLastDropPosition.targetControl||d.position!=this._mLastDropPosition.position){this._iDropPositionHoldStart=Date.now();this._mLastDropPosition=d;return false;}return Date.now()-this._iDropPositionHoldStart>this._iTimeoutBeforeDrop;};
G.prototype._shouldFreeze=function(p,P){var t=20;return this._mFreezePosition&&Math.abs(this._mFreezePosition.pageX-p)<t&&Math.abs(this._mFreezePosition.pageY-P)<t;};
G.prototype._freezeCurrentPosition=function(p,P){this._mFreezePosition={pageX:p,pageY:P};};
G.prototype._calculateDropPosition=function(d){var $=this._findItemFromPoint(d.pageX,d.pageY),c,t,b;if(!$){c=this._findClosestItem(d.pageX,d.pageY);}if(c){$=c.target;}if(c&&c.direction==="Left"){b="After";}if(!$){$=this._getLastItem();b="After";}if(!$){return{targetControl:null,position:"After"};}if($.hasClass("sapUiDnDGridIndicator")){return null;}t=$.control(0,true);if(!b){b=this._calculateDropBeforeOrAfter(t,d);}return{targetControl:t,position:b};};
G.prototype._calculateDropBeforeOrAfter=function(t,d){var D=this._getDimensions(t),c=D.rect;if(this._oDragControl===t){return"Before";}if((this._mDragItemDimensions.rect.width*1.5)<c.width){var p=window.pageXOffset,m={left:c.left+p,width:c.width},C=d.pageX-m.left;return C<m.width*0.5?"Before":"After";}if(this._iDragFromIndex===null){return"Before";}var T=this._oDropContainer.indexOfAggregation(this._sTargetAggregation,t);if(this._iDragFromIndex>T){return"Before";}return"After";};
G.prototype._getDimensions=function(c){var $=this._findContainingGridItem(c);if($){return{rect:$[0].getBoundingClientRect(),columnsSpan:$.css("grid-column-start"),rowsSpan:$.css("grid-row-start")};}return{rect:c.getDomRef().getBoundingClientRect(),columnsSpan:"span 1",rowsSpan:"span 1"};};
G.prototype._findContainingGridItem=function(c){var $=c.$(),d=$.parent().css("display");if(d==="grid"||d==="inline-grid"){return $;}d=$.parent().parent().css("display");if(d==="grid"||d==="inline-grid"){return $.parent();}return null;};
G.prototype._getLastItem=function(){var I=this._oDropContainer.getAggregation(this._sTargetAggregation),$;if(I&&I.length){$=I[I.length-1].$();}return $;};
G.prototype._findItemFromPoint=function(p,P){var o=document.elementFromPoint(p-window.pageXOffset,P-window.pageYOffset),$=q(o).closest(".sapUiDnDGridControl, .sapUiDnDGridIndicator");if($.hasClass("sapUiDnDGridIndicator")){return $;}if($.hasClass("sapUiDnDGridControl")){return $;}return null;};
G.prototype._findClosestItem=function(p,P){var I=sap.ui.getCore().getConfiguration().getRTL(),a=I?-1:1,s=80*a,S=20,$,d,t=0,x=p-s;while(!$&&x>0&&t<4){$=this._findItemFromPoint(x,P);x-=s;t++;}if($){d="Left";}if(!$&&P-S>0){$=this._findItemFromPoint(p,P-20);d="Top";}return{target:$,direction:d};};
G.prototype._removeEventDelegates=function(){if(this._oDropContainer){this._oDropContainer.removeEventDelegate(this._oDropContainerDelegate);}if(this._oDragControl){this._oDragControl.removeEventDelegate(this._oDragControlDelegate);}};
G.prototype._attachEventDelegates=function(){this._removeEventDelegates();this._oDragControl.addEventDelegate(this._oDragControlDelegate,this);this._oDropContainer.addEventDelegate(this._oDropContainerDelegate,this);};
G.prototype._onDragLeave=function(e){var E=document.elementFromPoint(e.pageX-window.pageXOffset,e.pageY-window.pageYOffset),I=this._oDropContainer.getDomRef().contains(E);if(!I){this.scheduleEndDrag();}};
G.prototype._onDropContainerBeforeRendering=function(){if(!this._isDragActive()){return;}this._hideIndicator();};
G.prototype._onDropContainerAfterRendering=function(){if(!this._isDragActive()){return;}this._hideDraggedItem();if(this._mLastDropPosition){this._showIndicator(this._mLastDropPosition);}};
var i;
G.getInstance=function(){if(!i){i=new G();}return i;};
return G;});
sap.ui.predefine('sap/f/dnd/GridDropInfo',["sap/ui/core/library","sap/ui/core/dnd/DropInfo","sap/f/dnd/GridDragOver","sap/base/Log"],function(c,D,G,L){"use strict";
var a=D.extend("sap.f.dnd.GridDropInfo",{metadata:{library:"sap.f",interfaces:["sap.ui.core.dnd.IDropInfo"],properties:{dropIndicatorSize:{type:"function",invalidate:false,parameters:{draggedControl:{type:"sap.ui.core.Control"}}}},events:{}}});
a.prototype.isDroppable=function(C,e){if(!this._shouldEnhance()){return D.prototype.isDroppable.apply(this,arguments);}if(!this.getEnabled()){return false;}if(!C||!e){return false;}var d=this.getDropTarget();if(!d){return false;}var A=d.getDomRefForSetting(this.getTargetAggregation());if(A&&A.contains(e.target)){e.setMark("DragWithin",this.getTargetAggregation());return true;}if(!A&&d===C){return true;}return false;};
a.prototype.fireDragEnter=function(e){if(!this._shouldEnhance()||this._isKeyboardEvent(e)){return D.prototype.fireDragEnter.apply(this,arguments);}if(!e||!e.dragSession||!e.dragSession.getDragControl()){return null;}var g=G.getInstance(),d=e.dragSession.getDragControl();if(this.getDropIndicatorSize()){g.setDropIndicatorSize(this.getDropIndicatorSize()(d));}g.setCurrentContext(e.dragSession.getDragControl(),this.getDropTarget(),this.getTargetAggregation(),e.dragSession);var m=g.getSuggestedDropPosition();var b=this.fireEvent("dragEnter",{dragSession:e.dragSession,browserEvent:e.originalEvent,target:m?m.targetControl:null},true);if(b){g.handleDragOver(e);}return b;};
a.prototype.fireDragOver=function(e){if(!this._shouldEnhance()||this._isKeyboardEvent(e)){return D.prototype.fireDragOver.apply(this,arguments);}if(!e||!e.dragSession||!e.dragSession.getDragControl()){return null;}var d=this._suggestDropPosition(e);if(d&&e.dragSession&&d.targetControl){e.dragSession.setDropControl(d.targetControl);}return this.fireEvent("dragOver",{dragSession:e.dragSession,browserEvent:e.originalEvent,target:d?d.targetControl:null,dropPosition:d?d.position:null});};
a.prototype.fireDrop=function(e){if(!this._shouldEnhance()||this._isKeyboardEvent(e)){return D.prototype.fireDrop.apply(this,arguments);}if(!e||!e.dragSession||!e.dragSession.getDragControl()){return null;}var d=e.dragSession,g=G.getInstance(),m;g.setCurrentContext(d.getDragControl(),this.getDropTarget(),this.getTargetAggregation(),d);m=g.getSuggestedDropPosition();this.fireEvent("drop",{dragSession:e.dragSession,browserEvent:e.originalEvent,dropPosition:m?m.position:null,draggedControl:d.getDragControl(),droppedControl:m?m.targetControl:null});g.scheduleEndDrag();};
a.prototype._shouldEnhance=function(){if(this._bShouldEnhance===undefined){if(!this.getParent().isA("sap.f.dnd.IGridDroppable")){L.error("The control which uses 'sap.f.dnd.GridDropInfo' has to implement 'sap.f.dnd.IGridDroppable'.","sap.f.dnd.GridDropInfo");this._bShouldEnhance=false;return this._bShouldEnhance;}this._bShouldEnhance=this.getDropPosition()===c.dnd.DropPosition.Between&&this.getDropLayout()===c.dnd.DropLayout.Horizontal;}return this._bShouldEnhance;};
a.prototype._isKeyboardEvent=function(e){return e.originalEvent.type==="keydown";};
a.prototype._suggestDropPosition=function(d){if(!d.dragSession||!d.dragSession.getDragControl()){return null;}var g=G.getInstance();g.setCurrentContext(d.dragSession.getDragControl(),this.getDropTarget(),this.getTargetAggregation(),d.dragSession);g.handleDragOver(d);return g.getSuggestedDropPosition();};
return a;});
sap.ui.predefine('sap/f/dnd/GridKeyboardDragAndDrop',["sap/ui/thirdparty/jquery"],function(q){"use strict";var G={};
function c(e,d,D,s){return{setIndicatorConfig:q.noop,getDragControl:function(){return d;},getDropControl:function(){return D;},getDropPosition:function(){return s;}};}
function g(C){var p=C.getParent(),s=(C.getDragDropConfig)?C.getDragDropConfig():[],P=(p&&p.getDragDropConfig)?p.getDragDropConfig():[];return s.concat(P);}
function a(d){var D=g(d);return D.filter(function(o){return o.isDraggable(d);});}
function b(d,D,e){var f=g(d);D=D||[];return f.filter(function(o){return!o.isA("sap.ui.core.dnd.IDragInfo");}).concat(D).filter(function(o){if(!o.isDroppable(d,e)){return false;}var s=o.getGroupName();if(!s){return true;}return D.some(function(h){return h.getGroupName()==s;});});}
G._filterDragInfos=function(v,e){return v.filter(function(d){return d.fireDragStart(e);});};
G._filterDropInfos=function(v,e){return v.filter(function(d){return d.fireDragEnter(e);});};
G._fireDrop=function(d,e){d.forEach(function(D){D.fireDrop(e);});};
G.fireDnD=function(d,C,e){var v=a(d);if(!v.length){return;}for(var i=0;i<C.length;i++){e.dragSession=c(e,d,C[i].item,C[i].dropPosition);v=e.isMarked("NonDraggable")?[]:this._filterDragInfos(v,e);if(!v.length){continue;}var V=b(C[i].grid,v,e);V=this._filterDropInfos(V,e);if(V.length>0){this._fireDrop(V,e);break;}}};
return G;},true);
sap.ui.predefine('sap/f/flexibility/Avatar.flexibility',["sap/ui/thirdparty/jquery","sap/m/flexibility/Avatar.flexibility"],function(q,a){"use strict";return q.extend(a,{});},true);
sap.ui.predefine('sap/f/flexibility/DynamicPageTitle.flexibility',["sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton","sap/f/changeHandler/MoveDynamicPageTitleActions"],function(C,S,M){"use strict";return{"hideControl":"default","unhideControl":"default","combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}},"moveActions":{"changeHandler":M},"moveControls":"default"};},true);
sap.ui.predefine('sap/f/library',["sap/ui/base/DataType","sap/m/AvatarShape","sap/m/AvatarSize","sap/m/AvatarType","sap/m/AvatarColor","sap/m/AvatarImageFitType","sap/m/IllustratedMessageType","sap/m/IllustratedMessageSize","sap/m/library","sap/ui/Global","sap/ui/core/library","sap/ui/layout/library"],function(D,A,a,b,c,d,I,e){"use strict";sap.ui.getCore().initLibrary({name:"sap.f",version:"1.98.0",dependencies:["sap.ui.core","sap.m","sap.ui.layout"],designtime:"sap/f/designtime/library.designtime",interfaces:["sap.f.cards.IHeader","sap.f.ICard","sap.f.IShellBar","sap.f.IDynamicPageStickyContent","sap.f.dnd.IGridDroppable"],types:["sap.f.AvatarImageFitType","sap.f.AvatarShape","sap.f.AvatarSize","sap.f.AvatarType","sap.f.AvatarColor","sap.f.AvatarGroupType","sap.f.cards.HeaderPosition","sap.f.cards.NumericHeaderSideIndicatorsAlignment","sap.f.DynamicPageTitleArea","sap.f.DynamicPageTitleShrinkRatio","sap.f.IllustratedMessageSize","sap.f.IllustratedMessageType","sap.f.LayoutType"],controls:["sap.f.Avatar","sap.f.AvatarGroup","sap.f.AvatarGroupItem","sap.f.cards.Header","sap.f.cards.NumericHeader","sap.f.cards.NumericIndicators","sap.f.cards.NumericSideIndicator","sap.f.CalendarInCard","sap.f.Card","sap.f.GridContainer","sap.f.DynamicPage","sap.f.DynamicPageHeader","sap.f.DynamicPageTitle","sap.f.IllustratedMessage","sap.f.FlexibleColumnLayout","sap.f.semantic.SemanticPage","sap.f.GridList","sap.f.GridListItem","sap.f.PlanningCalendarInCardLegend","sap.f.ProductSwitch","sap.f.ProductSwitchItem","sap.f.ShellBar","sap.f.Illustration"],elements:["sap.f.DynamicPageAccessibleLandmarkInfo","sap.f.GridContainerItemLayoutData","sap.f.FlexibleColumnLayoutAccessibleLandmarkInfo","sap.f.semantic.AddAction","sap.f.semantic.CloseAction","sap.f.semantic.CopyAction","sap.f.semantic.DeleteAction","sap.f.semantic.DiscussInJamAction","sap.f.semantic.EditAction","sap.f.semantic.ExitFullScreenAction","sap.f.semantic.FavoriteAction","sap.f.semantic.FlagAction","sap.f.semantic.FooterMainAction","sap.f.semantic.FullScreenAction","sap.f.semantic.MainAction","sap.f.semantic.MessagesIndicator","sap.f.semantic.NegativeAction","sap.f.semantic.PositiveAction","sap.f.semantic.PrintAction","sap.f.semantic.SemanticButton","sap.f.semantic.SemanticControl","sap.f.semantic.SemanticToggleButton","sap.f.semantic.SendEmailAction","sap.f.semantic.SendMessageAction","sap.f.semantic.ShareInJamAction","sap.f.semantic.TitleMainAction","sap.f.SearchManager"],extensions:{flChangeHandlers:{"sap.f.Avatar":"sap/f/flexibility/Avatar","sap.f.DynamicPageHeader":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.f.DynamicPageTitle":"sap/f/flexibility/DynamicPageTitle","sap.f.semantic.SemanticPage":{"moveControls":"default"}},"sap.ui.support":{publicRules:true,internalRules:true}}});var t=sap.f;t.DynamicPageTitleArea={Begin:"Begin",Middle:"Middle"};t.DynamicPageTitleShrinkRatio=D.createType('sap.f.DynamicPageTitleShrinkRatio',{isValid:function(v){return/^(([0-9]\d*)(\.\d)?:([0-9]\d*)(\.\d)?:([0-9]\d*)(\.\d)?)$/.test(v);}},D.getType('string'));t.LayoutType={OneColumn:"OneColumn",TwoColumnsBeginExpanded:"TwoColumnsBeginExpanded",TwoColumnsMidExpanded:"TwoColumnsMidExpanded",MidColumnFullScreen:"MidColumnFullScreen",ThreeColumnsMidExpanded:"ThreeColumnsMidExpanded",ThreeColumnsEndExpanded:"ThreeColumnsEndExpanded",ThreeColumnsMidExpandedEndHidden:"ThreeColumnsMidExpandedEndHidden",ThreeColumnsBeginExpandedEndHidden:"ThreeColumnsBeginExpandedEndHidden",EndColumnFullScreen:"EndColumnFullScreen"};sap.ui.lazyRequire("sap.f.routing.Router");sap.ui.lazyRequire("sap.f.routing.Target");sap.ui.lazyRequire("sap.f.routing.TargetHandler");sap.ui.lazyRequire("sap.f.routing.Targets");t.AvatarShape=A;t.AvatarSize=a;t.AvatarType=b;t.AvatarColor=c;t.AvatarImageFitType=d;t.AvatarGroupType={Group:"Group",Individual:"Individual"};t.cards.HeaderPosition={Top:"Top",Bottom:"Bottom"};t.cards.NumericHeaderSideIndicatorsAlignment={Begin:"Begin",End:"End"};t.NavigationDirection={Up:"Up",Down:"Down",Left:"Left",Right:"Right"};t.IllustratedMessageType=I;t.IllustratedMessageSize=e;return t;});
sap.ui.predefine('sap/f/routing/Router',['sap/ui/core/routing/Router','./TargetHandler','./Targets'],function(R,T,a){"use strict";
var M=R.extend("sap.f.routing.Router",{
constructor:function(){this._oTargetHandler=new T();R.prototype.constructor.apply(this,arguments);},
destroy:function(){R.prototype.destroy.apply(this,arguments);this._oTargetHandler.destroy();this._oTargetHandler=null;},
getTargetHandler:function(){return this._oTargetHandler;},
_createTargets:function(c,t){return new a({views:this._oViews,config:c,targets:t,targetHandler:this._oTargetHandler});},
fireRouteMatched:function(A){var r=this.getRoute(A.name),t;if(r._oTarget){t=r._oTarget._oOptions;this._oTargetHandler.addNavigation({navigationIdentifier:A.name,transition:t.transition,transitionParameters:t.transitionParameters,eventData:A.arguments,targetControl:A.targetControl,view:A.view,layout:r._oConfig.layout});}return R.prototype.fireRouteMatched.apply(this,arguments);},
fireRoutePatternMatched:function(A){var r=A.name,l;if(this._oTargets&&this._oTargets._oLastDisplayedTarget){l=this._oTargets._getLevel(this._oTargets._oLastDisplayedTarget);}this._oTargetHandler.navigate({navigationIdentifier:r,level:l,askHistory:true});return R.prototype.fireRoutePatternMatched.apply(this,arguments);}
});
return M;});
sap.ui.predefine('sap/f/routing/Target',['sap/ui/core/routing/Target','sap/f/FlexibleColumnLayout','./async/Target'],function(T,F,a){"use strict";
var M=T.extend("sap.f.routing.Target",{
constructor:function(o,v,p,t){this._oTargetHandler=t;T.prototype.constructor.apply(this,arguments);var b=a;this._super={};for(var f in b){this._super[f]=this[f];this[f]=b[f];}},
_beforePlacingViewIntoContainer:function(A){var c=A.container;var r=A.data&&A.data.routeConfig;if(c instanceof F&&r&&r.layout){c.setLayout(r.layout);}T.prototype._beforePlacingViewIntoContainer.apply(this,arguments);}
});
return M;});
sap.ui.predefine('sap/f/routing/TargetHandler',['sap/m/InstanceManager','sap/f/FlexibleColumnLayout','sap/ui/base/Object','sap/ui/core/routing/History',"sap/base/Log"],function(I,F,B,H,L){"use strict";
var T=B.extend("sap.f.routing.TargetHandler",{constructor:function(c){this._aQueue=[];this._oNavigationOrderPromise=Promise.resolve();if(c===undefined){this._bCloseDialogs=true;}else{this._bCloseDialogs=!!c;}}});
T.prototype.setCloseDialogs=function(c){this._bCloseDialogs=!!c;return this;};
T.prototype.getCloseDialogs=function(){return this._bCloseDialogs;};
T.prototype.addNavigation=function(p){this._aQueue.push(p);};
T.prototype.navigate=function(d){var r=this._createResultingNavigations(d.navigationIdentifier),c=false,b=this._getDirection(d),n;while(r.length){n=this._applyNavigationResult(r.shift().oParams,b);c=c||n;}if(c){this._closeDialogs();}};
T.prototype._chainNavigation=function(n,N){var p=this._oNavigationOrderPromise.then(n);this._oNavigationOrderPromise=p.catch(function(e){L.error("The following error occurred while displaying routing target with name '"+N+"': "+e);});return p;};
T.prototype._getDirection=function(d){var t=d.level,h=H.getInstance(),b=false;if(d.direction==="Backwards"){b=true;}else if(isNaN(t)||isNaN(this._iCurrentLevel)||t===this._iCurrentLevel){if(d.askHistory){b=h.getDirection()==="Backwards";}}else{b=t<this._iCurrentLevel;}this._iCurrentLevel=t;return b;};
T.prototype._createResultingNavigations=function(n){var i,c,C,o,r=[],R;while(this._aQueue.length){c=this._aQueue.shift();C=c.targetControl;o={oContainer:C,oParams:c,placeholderConfig:c.placeholderConfig};if(!a(C)){continue;}for(i=0;i<r.length;i++){R=r[i];if(R.oContainer!==C){continue;}}r.push(o);}return r;};
T.prototype._applyNavigationResult=function(p,b){var t=p.targetControl,A=p.eventData,s=p.placeholderShown?"show":(p.transition||""),o=p.transitionParameters,v=p.view.getId(),c,i=t instanceof F,S=false,P=p.placeholderConfig;if(i){c=[t.getCurrentBeginColumnPage(),t.getCurrentMidColumnPage(),t.getCurrentEndColumnPage()];S=c.some(function(C){return C&&C.getId()===v;});}if(S){if(P.autoClose){t.hidePlaceholder(P);}L.info("navigation to view with id: "+v+" is skipped since it already is displayed by its targetControl","sap.f.routing.TargetHandler");return false;}L.info("navigation to view with id: "+v+" the targetControl is "+t.getId()+" backwards is "+b);if(b){t._safeBackToPage(v,s,A,o);}else{t.to(v,s,A,o);}if(P.autoClose){t.hidePlaceholder(P);}return true;};
T.prototype._closeDialogs=function(){if(!this._bCloseDialogs){return;}if(I.hasOpenPopover()){I.closeAllPopovers();}if(I.hasOpenDialog()){I.closeAllDialogs();}if(I.hasOpenLightBox()){I.closeAllLightBoxes();}};
function a(c){return c&&c.isA(["sap.m.NavContainer","sap.m.SplitContainer","sap.f.FlexibleColumnLayout"]);}
T.prototype.showPlaceholder=function(s){var c=s.container,n=true,o;if(s.object&&!(s.object instanceof Promise)){o=s.object;}if(s.container&&typeof s.container.needPlaceholder==="function"){n=s.container.needPlaceholder(s.aggregation,o);}if(n){return c.showPlaceholder(s);}else{return Promise.resolve();}};
return T;});
sap.ui.predefine('sap/f/routing/Targets',['sap/ui/core/routing/Targets','./TargetHandler','./Target','./async/Targets'],function(T,a,b,c){"use strict";
var M=T.extend("sap.f.routing.Targets",{
constructor:function(o){o.config._async=true;if(o.targetHandler){this._oTargetHandler=o.targetHandler;}else{this._oTargetHandler=new a();this._bHasOwnTargetHandler=true;}T.prototype.constructor.apply(this,arguments);var d=c;this._super={};for(var f in d){this._super[f]=this[f];this[f]=d[f];}},
destroy:function(){T.prototype.destroy.apply(this,arguments);if(this._bHasOwnTargetHandler){this._oTargetHandler.destroy();}this._oTargetHandler=null;},
getTargetHandler:function(){return this._oTargetHandler;},
_constructTarget:function(o,p){return new b(o,this.getViews(),p,this._oTargetHandler);},
_getLevel:function(t){var l;do{l=t._oOptions.hasOwnProperty("level")?t._oOptions.level:t._oOptions.viewLevel;if(l!==undefined){return l;}t=t._oParent;}while(t);return l;}
});
return M;});
sap.ui.predefine('sap/f/routing/async/Target',[],function(){"use strict";return{_place:function(d){var p=this._super._place.apply(this,arguments),r=d&&d.routeConfig||{},t=this;return this._oTargetHandler._chainNavigation(function(){return p.then(function(v){t._oTargetHandler.addNavigation({navigationIdentifier:t._oOptions._name,transition:t._oOptions.transition,transitionParameters:t._oOptions.transitionParameters,eventData:d,targetControl:v.control,view:v.view,layout:r.layout,placeholderConfig:v.placeholderConfig});return v;});},this._oOptions._name);},showPlaceholder:function(s){return this._oTargetHandler.showPlaceholder(s);},hidePlaceholder:function(s){}};},true);
sap.ui.predefine('sap/f/routing/async/Targets',[],function(){"use strict";return{display:function(){var l,n;this._oLastDisplayedTarget=null;var p=this._super.display.apply(this,arguments);return p.then(function(v){if(this._oLastDisplayedTarget){l=this._getLevel(this._oLastDisplayedTarget);n=this._oLastDisplayedTarget._oOptions._name;}this._oTargetHandler.navigate({level:l,navigationIdentifier:n});return v;}.bind(this));},_displaySingleTarget:function(t){var T=this.getTarget(t.name);return this._super._displaySingleTarget.apply(this,arguments).then(function(v){if(T){this._oLastDisplayedTarget=T;}return v;}.bind(this));}};},true);
sap.ui.predefine('sap/f/semantic/AddAction',['sap/f/semantic/SemanticButton'],function(S){"use strict";
var A=S.extend("sap.f.semantic.AddAction",{metadata:{library:"sap.f"}});
return A;});
sap.ui.predefine('sap/f/semantic/CloseAction',['./SemanticButton'],function(S){"use strict";
var C=S.extend("sap.f.semantic.CloseAction",{metadata:{library:"sap.f"}});
return C;});
sap.ui.predefine('sap/f/semantic/CopyAction',['./SemanticButton'],function(S){"use strict";
var C=S.extend("sap.f.semantic.CopyAction",{metadata:{library:"sap.f"}});
return C;});
sap.ui.predefine('sap/f/semantic/DeleteAction',['sap/f/semantic/SemanticButton'],function(S){"use strict";
var D=S.extend("sap.f.semantic.DeleteAction",{metadata:{library:"sap.f"}});
return D;});
sap.ui.predefine('sap/f/semantic/DiscussInJamAction',['sap/f/semantic/SemanticButton'],function(S){"use strict";
var D=S.extend("sap.f.semantic.DiscussInJamAction",{metadata:{library:"sap.f"}});
return D;});
sap.ui.predefine('sap/f/semantic/EditAction',['./SemanticButton'],function(S){"use strict";
var E=S.extend("sap.f.semantic.EditAction",{metadata:{library:"sap.f"}});
return E;});
sap.ui.predefine('sap/f/semantic/ExitFullScreenAction',['./SemanticButton'],function(S){"use strict";
var E=S.extend("sap.f.semantic.ExitFullScreenAction",{metadata:{library:"sap.f"}});
return E;});
sap.ui.predefine('sap/f/semantic/FavoriteAction',['./SemanticToggleButton'],function(S){"use strict";
var F=S.extend("sap.f.semantic.FavoriteAction",{metadata:{library:"sap.f"}});
return F;});
sap.ui.predefine('sap/f/semantic/FlagAction',['./SemanticToggleButton'],function(S){"use strict";
var F=S.extend("sap.f.semantic.FlagAction",{metadata:{library:"sap.f"}});
return F;});
sap.ui.predefine('sap/f/semantic/FooterMainAction',["./MainAction"],function(M){"use strict";
var F=M.extend("sap.f.semantic.FooterMainAction",{metadata:{library:"sap.f"}});
return F;});
sap.ui.predefine('sap/f/semantic/FullScreenAction',['./SemanticButton'],function(S){"use strict";
var F=S.extend("sap.f.semantic.FullScreenAction",{metadata:{library:"sap.f"}});
return F;});
sap.ui.predefine('sap/f/semantic/MainAction',['sap/f/semantic/SemanticButton'],function(S){"use strict";
var M=S.extend("sap.f.semantic.MainAction",{metadata:{library:"sap.f","abstract":true,properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return M;});
sap.ui.predefine('sap/f/semantic/MessagesIndicator',['./SemanticButton'],function(S){"use strict";
var M=S.extend("sap.f.semantic.MessagesIndicator",{metadata:{library:"sap.f"}});
return M;});
sap.ui.predefine('sap/f/semantic/NegativeAction',['sap/f/semantic/SemanticButton'],function(S){"use strict";
var N=S.extend("sap.f.semantic.NegativeAction",{metadata:{library:"sap.f",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return N;});
sap.ui.predefine('sap/f/semantic/PositiveAction',['sap/f/semantic/SemanticButton'],function(S){"use strict";
var P=S.extend("sap.f.semantic.PositiveAction",{metadata:{library:"sap.f",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return P;});
sap.ui.predefine('sap/f/semantic/PrintAction',['sap/f/semantic/SemanticButton'],function(S){"use strict";
var P=S.extend("sap.f.semantic.PrintAction",{metadata:{library:"sap.f"}});
return P;});
sap.ui.predefine('sap/f/semantic/SemanticButton',["sap/m/semantic/SemanticButton","sap/f/semantic/SemanticConfiguration"],function(M,S){"use strict";
var a=M.extend("sap.f.semantic.SemanticButton",{metadata:{library:"sap.f","abstract":true}});
a.prototype._getConfiguration=function(){return S.getConfiguration(this.getMetadata().getName());};
return a;});
sap.ui.predefine('sap/f/semantic/SemanticConfiguration',["sap/ui/base/Object","sap/ui/core/IconPool","sap/m/library","sap/m/OverflowToolbarLayoutData","sap/ui/core/InvisibleText"],function(B,I,m,O,a){"use strict";var b=m.OverflowToolbarPriority;var c=m.ButtonType;
var S=B.extend("sap.f.semantic.SemanticConfiguration",{getInterface:function(){return this;}});
S._Placement={titleText:"titleText",titleIcon:"titleIcon",footerLeft:"footerLeft",footerRight:"footerRight",shareMenu:"shareMenu"};
S.isKnownSemanticType=function(t){return S.getConfiguration(t)!==null;};
S.getConfiguration=function(t){return S._oTypeConfigs[t]||null;};
S.getSettings=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].getSettings();}return null;};
S.getConstraints=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].constraints||null;}return null;};
S.getPlacement=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].placement;}return null;};
S.getOrder=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].order;}return null;};
S.shouldBePreprocessed=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].needPreprocesing||false;}return false;};
S.isMainAction=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].mainAction||false;}return false;};
S.isNavigationAction=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].navigation||false;}return false;};
S._oTypeConfigs=(function(){var t={},o=sap.ui.getCore().getLibraryResourceBundle("sap.f");t["sap.f.semantic.TitleMainAction"]={placement:S._Placement.titleText,order:0,mainAction:true,getSettings:function(){return{type:c.Emphasized,layoutData:new O({priority:b.NeverOverflow})};}};t["sap.f.semantic.EditAction"]={placement:S._Placement.titleText,order:1,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_EDIT"),tooltip:o.getText("SEMANTIC_CONTROL_EDIT"),type:c.Transparent};}};t["sap.f.semantic.DeleteAction"]={placement:S._Placement.titleText,order:2,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_DELETE"),type:c.Transparent};}};t["sap.f.semantic.CopyAction"]={placement:S._Placement.titleText,order:3,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_COPY"),type:c.Transparent};}};t["sap.f.semantic.AddAction"]={placement:S._Placement.titleText,order:4,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_ADD"),tooltip:o.getText("SEMANTIC_CONTROL_ADD"),type:c.Transparent};}};t["sap.f.semantic.FavoriteAction"]={placement:S._Placement.titleIcon,order:0,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("favorite"),text:o.getText("SEMANTIC_CONTROL_FAVORITE"),type:c.Transparent};}};t["sap.f.semantic.FlagAction"]={placement:S._Placement.titleIcon,order:1,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("flag"),text:o.getText("SEMANTIC_CONTROL_FLAG"),type:c.Transparent};}};t["sap.f.semantic.FullScreenAction"]={placement:S._Placement.titleIcon,order:0,constraints:"IconOnly",navigation:true,getSettings:function(){return{icon:I.getIconURI("full-screen"),tooltip:o.getText("SEMANTIC_CONTROL_FULL_SCREEN"),layoutData:new O({priority:b.NeverOverflow}),type:c.Transparent};}};t["sap.f.semantic.ExitFullScreenAction"]={placement:S._Placement.titleIcon,order:1,constraints:"IconOnly",navigation:true,getSettings:function(){return{icon:I.getIconURI("exit-full-screen"),tooltip:o.getText("SEMANTIC_CONTROL_EXIT_FULL_SCREEN"),layoutData:new O({priority:b.NeverOverflow}),type:c.Transparent};}};t["sap.f.semantic.CloseAction"]={placement:S._Placement.titleIcon,order:2,constraints:"IconOnly",navigation:true,getSettings:function(){return{icon:I.getIconURI("decline"),tooltip:o.getText("SEMANTIC_CONTROL_CLOSE"),layoutData:new O({priority:b.NeverOverflow}),type:c.Transparent};}};t["sap.f.semantic.MessagesIndicator"]={placement:S._Placement.footerLeft,order:0,mainAction:false,getSettings:function(){var T=a.getStaticId("sap.f","SEMANTIC_CONTROL_MESSAGES_INDICATOR");return{icon:I.getIconURI("message-popup"),text:{path:"message>/",formatter:function(M){return M.length||0;}},tooltip:o.getText("SEMANTIC_CONTROL_MESSAGES_INDICATOR"),ariaLabelledBy:T,type:c.Emphasized,visible:{path:"message>/",formatter:function(M){return M&&M.length>0;}},models:{message:sap.ui.getCore().getMessageManager().getMessageModel()},layoutData:new O({priority:b.NeverOverflow})};}};t["sap.m.DraftIndicator"]={placement:S._Placement.footerRight,order:0,needPreprocesing:true,mainAction:false,getSettings:function(){return{layoutData:new O({shrinkable:false})};}};t["sap.f.semantic.FooterMainAction"]={placement:S._Placement.footerRight,order:1,mainAction:true,getSettings:function(){return{type:c.Emphasized,text:o.getText("SEMANTIC_CONTROL_SAVE"),layoutData:new O({priority:b.NeverOverflow})};}};t["sap.f.semantic.PositiveAction"]={placement:S._Placement.footerRight,order:2,mainAction:false,getSettings:function(){return{type:c.Accept,text:o.getText("SEMANTIC_CONTROL_ACCEPT"),layoutData:new O({priority:b.NeverOverflow})};}};t["sap.f.semantic.NegativeAction"]={placement:S._Placement.footerRight,order:3,mainAction:false,getSettings:function(){return{type:c.Reject,text:o.getText("SEMANTIC_CONTROL_REJECT"),layoutData:new O({priority:b.NeverOverflow})};}};t["sap.f.semantic.SendEmailAction"]={placement:S._Placement.shareMenu,order:0,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("email"),text:o.getText("SEMANTIC_CONTROL_SEND_EMAIL"),type:c.Transparent};}};t["sap.f.semantic.DiscussInJamAction"]={placement:S._Placement.shareMenu,order:1,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("discussion-2"),text:o.getText("SEMANTIC_CONTROL_DISCUSS_IN_JAM"),type:c.Transparent};}};t["sap.f.semantic.ShareInJamAction"]={placement:S._Placement.shareMenu,order:2,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("share-2"),text:o.getText("SEMANTIC_CONTROL_SHARE_IN_JAM"),type:c.Transparent};}};t["sap.f.semantic.SendMessageAction"]={placement:S._Placement.shareMenu,order:3,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("discussion"),text:o.getText("SEMANTIC_CONTROL_SEND_MESSAGE"),type:c.Transparent};}};t["saveAsTileAction"]={placement:S._Placement.shareMenu,order:4,constraints:"IconOnly"};t["sap.f.semantic.PrintAction"]={placement:S._Placement.shareMenu,order:5,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("print"),text:o.getText("SEMANTIC_CONTROL_PRINT"),type:c.Transparent};}};return t;})();return S;});
sap.ui.predefine('sap/f/semantic/SemanticContainer',["sap/ui/base/EventProvider","./SemanticConfiguration","sap/base/Log"],function(E,S,L){"use strict";
var a=E.extend("sap.f.semantic.SemanticContainer",{
constructor:function(c,p){if(!c){L.error("SemanticContainer :: missing argument - container reference",this);return;}E.apply(this,arguments);this._oContainer=c;this._oParent=p;},
getInterface:function(){return this;}
});
a.prototype._getContainer=function(){return this._oContainer;};
a.prototype._getParent=function(){return this._oParent;};
a.prototype._shouldBePreprocessed=function(c){var t=(c._getType&&c._getType())||c.getMetadata().getName();return S.shouldBePreprocessed(t);};
a.prototype._getControlOrder=function(c){var t=(c._getType&&c._getType())||c.getMetadata().getName();return S.getOrder(t);};
a.prototype._getConstraints=function(c){return S.getConstraints(c.getMetadata().getName());};
a.prototype._getControl=function(c){return c._getControl?c._getControl():c;};
a.prototype._isMainAction=function(c){return S.isMainAction(c.getMetadata().getName());};
a.prototype._isNavigationAction=function(c){return S.isNavigationAction(c.getMetadata().getName());};
a.prototype._callContainerAggregationMethod=function(m){return this._getContainer()[m].apply(this._getContainer(),Array.prototype.slice.call(arguments).slice(1));};
a.prototype._sortControlByOrder=function(c,C){return this._getControlOrder(c)-this._getControlOrder(C);};
a.prototype.destroy=function(){this._oParent=null;this._oContainer=null;};
return a;});
sap.ui.predefine('sap/f/semantic/SemanticControl',["sap/ui/thirdparty/jquery","sap/ui/core/Element","./SemanticConfiguration"],function(q,E,S){"use strict";
var a=E.extend("sap.f.semantic.SemanticControl",{metadata:{library:"sap.f","abstract":true,properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true}},aggregations:{_control:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}}}});
a.prototype.setProperty=function(k,v,s){E.prototype.setProperty.call(this,k,v,true);this._applyProperty(k,v,s);return this;};
a.prototype.updateAggregation=function(n){this._getControl().updateAggregation(n);};
a.prototype.refreshAggregation=function(n){this._getControl().refreshAggregation(n);};
a.prototype.setAggregation=function(A,o,s){if(A==='_control'){return E.prototype.setAggregation.call(this,A,o,s);}return this._getControl().setAggregation(A,o,s);};
a.prototype.getAggregation=function(A,d){if(A==='_control'){return E.prototype.getAggregation.call(this,A,d);}return this._getControl().getAggregation(A,d);};
a.prototype.indexOfAggregation=function(A,o){return this._getControl().indexOfAggregation(A,o);};
a.prototype.insertAggregation=function(A,o,i,s){return this._getControl().insertAggregation(A,o,i,s);};
a.prototype.addAggregation=function(A,o,s){return this._getControl().addAggregation(A,o,s);};
a.prototype.removeAggregation=function(A,o,s){return this._getControl().removeAggregation(A,o,s);};
a.prototype.removeAllAggregation=function(A,s){return this._getControl().removeAllAggregation(A,s);};
a.prototype.destroyAggregation=function(A,s){return this._getControl().destroyAggregation(A,s);};
a.prototype.bindAggregation=function(n,b){return this._getControl().bindAggregation(n,b);};
a.prototype.unbindAggregation=function(n,s){return this._getControl().unbindAggregation(n,s);};
a.prototype.clone=function(i,l){var C=E.prototype.clone.apply(this,arguments);var p=this._getControl().clone(i,l);C.setAggregation('_control',p);return C;};
a.prototype.destroy=function(){var r=E.prototype.destroy.apply(this,arguments);if(this.getAggregation("_control")){this.getAggregation("_control").destroy();}return r;};
a.prototype.getDomRef=function(s){return this._getControl().getDomRef(s);};
a.prototype.addEventDelegate=function(d,t){q.each(d,function(e,C){if(typeof C==='function'){d[e]=function(o){o.srcControl=this;C.call(t,o);}.bind(this);}}.bind(this));this._getControl().addEventDelegate(d,t);return this;};
a.prototype.removeEventDelegate=function(d){this._getControl().removeEventDelegate(d);return this;};
a.prototype._getConfiguration=function(){return S.getConfiguration(this.getMetadata().getName());};
a.prototype._applyProperty=function(k,v,s){var C=this._getControl(),b;if(C){b="set"+c(k);this._getControl()[b](v,s);}};
function c(n){return n.charAt(0).toUpperCase()+n.slice(1);}
return a;});
sap.ui.predefine('sap/f/semantic/SemanticFooter',["sap/m/ToolbarSpacer","sap/m/library","./SemanticContainer"],function(T,m,S){"use strict";var B=m.ButtonType;
var a=S.extend("sap.f.semantic.SemanticFooter",{constructor:function(c,p){S.call(this,c,p);this._aCustomContent=[];this._aSemanticLeftContent=[];this._aSemanticRightContent=[];this._iSemanticLeftContentCount=1;this._fnParentSubstitute=function(){return this._oParent;}.bind(this);this._insertSpacer();}});
a.mPlacementMethodMap={footerLeft:"LeftContent",footerRight:"RightContent"};
a.prototype.addCustomAction=function(c){c.setType(B.Transparent);this._callContainerAggregationMethod("addContent",c);this._aCustomContent.push(c);return this;};
a.prototype.insertCustomAction=function(c,i){var C=this._getCustomContentInsertIndex(i);c.setType(B.Transparent);this._callContainerAggregationMethod("insertContent",c,C);this._aCustomContent.splice(i,0,c);return this;};
a.prototype.getCustomActions=function(){return this._aCustomContent;};
a.prototype.indexOfCustomAction=function(c){return this._aCustomContent.indexOf(c);};
a.prototype.removeCustomAction=function(c){var r=this._callContainerAggregationMethod("removeContent",c);this._aCustomContent.splice(this._aCustomContent.indexOf(c),1);return r;};
a.prototype.removeAllCustomActions=function(){var r=[];this._aCustomContent.forEach(function(c){var R=this._callContainerAggregationMethod("removeContent",c);if(R){r.push(c);}},this);this._aCustomContent=[];return r;};
a.prototype.destroyCustomActions=function(){this.removeAllCustomActions(true).forEach(function(c){c.destroy();});return this;};
a.prototype.addContent=function(s,p){this["_insertSemantic"+a.mPlacementMethodMap[p]].call(this,s);return this;};
a.prototype.removeContent=function(s,p){this["_removeSemantic"+a.mPlacementMethodMap[p]].call(this,s);return this;};
a.prototype.destroy=function(){this._aCustomContent=null;this._aSemanticLeftContent=null;this._aSemanticRightContent=null;this._oSpacer=null;return S.prototype.destroy.call(this);};
a.prototype._insertSemanticLeftContent=function(s){var c=this._getControl(s),C=this._getControlOrder(s),i=this._getSemanticLeftContentInsertIndex(C);this._callContainerAggregationMethod("insertContent",c,i);this._iSemanticLeftContentCount++;this._aSemanticLeftContent.push(s);return this;};
a.prototype._insertSemanticRightContent=function(s){var c=this._getControl(s);this._aSemanticRightContent.push(s);this._callContainerAggregationMethod("insertContent",c,this._getSemanticRightContentInsertIndex(s));if(this._shouldBePreprocessed(s)){this._preProcessControl(c);}return this;};
a.prototype._removeSemanticLeftContent=function(s){var c=this._getControl(s);this._callContainerAggregationMethod("removeContent",c);this._iSemanticLeftContentCount--;this._aSemanticLeftContent.splice(this._aSemanticLeftContent.indexOf(c),1);return s;};
a.prototype._removeSemanticRightContent=function(s){var c=this._getControl(s);this._callContainerAggregationMethod("removeContent",c);this._aSemanticRightContent.splice(this._aSemanticRightContent.indexOf(s),1);this._postProcessControl(c);return s;};
a.prototype._getSemanticLeftContentInsertIndex=function(c){return this._iSemanticLeftContentCount>1?c:0;};
a.prototype._getSemanticRightContentInsertIndex=function(s){this._aSemanticRightContent.sort(this._sortControlByOrder.bind(this));return this._iSemanticLeftContentCount+this._aSemanticRightContent.indexOf(s);};
a.prototype._getCustomContentInsertIndex=function(i){return i+this._iSemanticLeftContentCount+this._aSemanticRightContent.length;};
a.prototype._insertSpacer=function(){this._callContainerAggregationMethod("addContent",this._getSpacer());return this;};
a.prototype._getSpacer=function(){if(!this._oSpacer){this._oSpacer=new T();}return this._oSpacer;};
a.prototype._preProcessControl=function(c){if(!(typeof c._fnOriginalGetParent==="function")){c._fnOriginalGetParent=c.getParent;c.getParent=this._fnParentSubstitute;}};
a.prototype._postProcessControl=function(c){if(c._fnOriginalGetParent){c.getParent=c._fnOriginalGetParent;delete c._fnOriginalGetParent;}};
return a;});
sap.ui.predefine('sap/f/semantic/SemanticPage',["sap/ui/core/Control","sap/f/library","sap/f/DynamicPage","sap/f/DynamicPageTitle","sap/f/DynamicPageHeader","sap/m/OverflowToolbar","sap/m/ActionSheet","./SemanticTitle","./SemanticFooter","./SemanticShareMenu","./SemanticConfiguration","./SemanticPageRenderer"],function(C,l,D,a,b,O,A,S,c,d,e,f){"use strict";var g=l.DynamicPageTitleArea;
var h=C.extend("sap.f.semantic.SemanticPage",{metadata:{library:"sap.f",properties:{headerExpanded:{type:"boolean",group:"Behavior",defaultValue:true},headerPinnable:{type:"boolean",group:"Behavior",defaultValue:true},preserveHeaderStateOnScroll:{type:"boolean",group:"Behavior",defaultValue:false},toggleHeaderOnTitleClick:{type:"boolean",group:"Behavior",defaultValue:true},showFooter:{type:"boolean",group:"Behavior",defaultValue:false},titlePrimaryArea:{type:"sap.f.DynamicPageTitleArea",group:"Appearance",defaultValue:g.Begin,deprecated:true},titleAreaShrinkRatio:{type:"sap.f.DynamicPageTitleShrinkRatio",group:"Appearance",defaultValue:"1:1.6:1.6"},fitContent:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"content",aggregations:{titleHeading:{type:"sap.ui.core.Control",multiple:false,defaultValue:null,forwarding:{getter:"_getTitle",aggregation:"heading"}},titleExpandedHeading:{type:"sap.ui.core.Control",multiple:false,defaultValue:null,forwarding:{getter:"_getTitle",aggregation:"expandedHeading"}},titleSnappedHeading:{type:"sap.ui.core.Control",multiple:false,defaultValue:null,forwarding:{getter:"_getTitle",aggregation:"snappedHeading"}},titleBreadcrumbs:{type:"sap.m.IBreadcrumbs",multiple:false,defaultValue:null,forwarding:{getter:"_getTitle",aggregation:"breadcrumbs"}},titleSnappedOnMobile:{type:"sap.m.Title",multiple:false,forwarding:{getter:"_getTitle",aggregation:"snappedTitleOnMobile"}},titleSnappedContent:{type:"sap.ui.core.Control",multiple:true,forwarding:{getter:"_getTitle",aggregation:"snappedContent"}},titleExpandedContent:{type:"sap.ui.core.Control",multiple:true,forwarding:{getter:"_getTitle",aggregation:"expandedContent"}},titleContent:{type:"sap.ui.core.Control",multiple:true,forwarding:{getter:"_getTitle",aggregation:"content"}},titleMainAction:{type:"sap.f.semantic.TitleMainAction",multiple:false},editAction:{type:"sap.f.semantic.EditAction",multiple:false},deleteAction:{type:"sap.f.semantic.DeleteAction",multiple:false},copyAction:{type:"sap.f.semantic.CopyAction",multiple:false},addAction:{type:"sap.f.semantic.AddAction",multiple:false},flagAction:{type:"sap.f.semantic.FlagAction",multiple:false},favoriteAction:{type:"sap.f.semantic.FavoriteAction",multiple:false},fullScreenAction:{type:"sap.f.semantic.FullScreenAction",multiple:false},exitFullScreenAction:{type:"sap.f.semantic.ExitFullScreenAction",multiple:false},closeAction:{type:"sap.f.semantic.CloseAction",multiple:false},titleCustomTextActions:{type:"sap.m.Button",multiple:true},titleCustomIconActions:{type:"sap.m.OverflowToolbarButton",multiple:true},headerContent:{type:"sap.ui.core.Control",multiple:true,forwarding:{getter:"_getHeader",aggregation:"content"}},content:{type:"sap.ui.core.Control",multiple:false},footerMainAction:{type:"sap.f.semantic.FooterMainAction",multiple:false},messagesIndicator:{type:"sap.f.semantic.MessagesIndicator",multiple:false},draftIndicator:{type:"sap.m.DraftIndicator",multiple:false},positiveAction:{type:"sap.f.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.f.semantic.NegativeAction",multiple:false},footerCustomActions:{type:"sap.m.Button",multiple:true},discussInJamAction:{type:"sap.f.semantic.DiscussInJamAction",multiple:false},saveAsTileAction:{type:"sap.m.Button",multiple:false},shareInJamAction:{type:"sap.f.semantic.ShareInJamAction",multiple:false},sendMessageAction:{type:"sap.f.semantic.SendMessageAction",multiple:false},sendEmailAction:{type:"sap.f.semantic.SendEmailAction",multiple:false},printAction:{type:"sap.f.semantic.PrintAction",multiple:false},customShareActions:{type:"sap.m.Button",multiple:true},landmarkInfo:{type:"sap.f.DynamicPageAccessibleLandmarkInfo",multiple:false,forwarding:{getter:"_getPage",aggregation:"landmarkInfo"}},_dynamicPage:{type:"sap.f.DynamicPage",multiple:false,visibility:"hidden"}},dnd:{draggable:false,droppable:true},designtime:"sap/f/designtime/SemanticPage.designtime"}});
h._EVENTS={SHARE_MENU_CONTENT_CHANGED:"_shareMenuContentChanged"};h._SAVE_AS_TILE_ACTION="saveAsTileAction";h.CONTENT_PADDING_CLASSES_TO_FORWARD={"sapUiNoContentPadding":true,"sapUiContentPadding":true,"sapUiResponsiveContentPadding":true};h.ARIA_ROLE_DESCRIPTION="SEMANTIC_PAGE_ROLE_DESCRIPTION";
h.prototype.init=function(){this._bSPBeingDestroyed=false;this._initDynamicPage();this._attachShareMenuButtonChange();this._fnActionSubstituteParentFunction=function(){return this;}.bind(this);};
h.prototype.exit=function(){this._bSPBeingDestroyed=true;this._cleanMemory();};
h.prototype.setHeaderExpanded=function(H){this._getPage().setHeaderExpanded(H);return this;};
h.prototype.getHeaderExpanded=function(){return this._getPage().getHeaderExpanded();};
h.prototype.setHeaderPinnable=function(H){var o=this._getPage(),i=o.getHeader();i.setPinnable(H);return this.setProperty("headerPinnable",i.getPinnable(),true);};
h.prototype.setPreserveHeaderStateOnScroll=function(p){var o=this._getPage();o.setPreserveHeaderStateOnScroll(p);return this.setProperty("preserveHeaderStateOnScroll",o.getPreserveHeaderStateOnScroll(),true);};
h.prototype.setToggleHeaderOnTitleClick=function(t){this._getPage().setToggleHeaderOnTitleClick(t);return this.setProperty("toggleHeaderOnTitleClick",t,true);};
h.prototype.setShowFooter=function(s){this._getPage().setShowFooter(s);return this.setProperty("showFooter",s,true);};
h.prototype.setTitlePrimaryArea=function(p){var o=this._getTitle();o.setPrimaryArea(p);return this.setProperty("titlePrimaryArea",o.getPrimaryArea(),true);};
h.prototype.setTitleAreaShrinkRatio=function(s){var o=this._getTitle();o.setAreaShrinkRatio(s);return this.setProperty("titleAreaShrinkRatio",o.getAreaShrinkRatio(),true);};
h.prototype.setFitContent=function(F){this._getPage().setFitContent(F);return this.setProperty("fitContent",F,true);};
h.prototype.addStyleClass=function(s,i){var o=this.getAggregation("_dynamicPage");if(h.CONTENT_PADDING_CLASSES_TO_FORWARD[s]){o.addStyleClass(s,true);}return C.prototype.addStyleClass.call(this,s,i);};
h.prototype.removeStyleClass=function(s,i){var o=this.getAggregation("_dynamicPage");if(h.CONTENT_PADDING_CLASSES_TO_FORWARD[s]){o.removeStyleClass(s,true);}return C.prototype.removeStyleClass.call(this,s,i);};
h.prototype.setAggregation=function(s,o,i){var j=this.mAggregations[s],t,p;if(j===o){return this;}o=this.validateAggregation(s,o,false);if(s===h._SAVE_AS_TILE_ACTION){t=h._SAVE_AS_TILE_ACTION;}else{t=this.getMetadata().getManagedAggregation(s).type;}if(e.isKnownSemanticType(t)){p=e.getPlacement(t);if(j){this._onRemoveAggregation(j,t);this._getSemanticContainer(p).removeContent(j,p);}if(o){o._getType=function(){return t;};this._getSemanticContainer(p).addContent(o,p);this._onAddAggregation(o,t);}return C.prototype.setAggregation.call(this,s,o,true);}return C.prototype.setAggregation.call(this,s,o,i);};
h.prototype.destroyAggregation=function(s,i){var o=this.getMetadata().getAggregations()[s],j,p,t;if(s===h._SAVE_AS_TILE_ACTION){t=h._SAVE_AS_TILE_ACTION;}else{t=o&&o.type;}if(t&&e.isKnownSemanticType(t)){j=C.prototype.getAggregation.call(this,s);if(j){p=e.getPlacement(t);this._onRemoveAggregation(j,t);!this._bSPBeingDestroyed&&this._getSemanticContainer(p).removeContent(j,p);}}return C.prototype.destroyAggregation.call(this,s,i);};
h.prototype.onBeforeRendering=function(){var s=this._getShareMenu(),v=s._getVisibleActions(),V=v.length;s._getShareMenuButton().setVisible(V>1);if(V===1){this._showSingleVisibleAction();}if(this._iVisibleShareMenuAction===1&V>1){this._hideSingleVisibleAction();this._iVisibleShareMenuAction=V;}};
h.prototype._addShareMenuSingleAction=function(v){if(v){var i=e.isKnownSemanticType(v.getMetadata().getName());v._bIsSingleAction=true;this._getSemanticTitle().addContent(v,i?e._Placement.titleIcon:e._Placement.titleText);this._iVisibleShareMenuAction=1;this._oSingleVisibleAction=v;}};
["getContent","setContent","destroyContent"].forEach(function(m){var i=/^(set|destroy)/.test(m);h.prototype[m]=function(o){var j=this._getPage();var r=j[m].apply(j,arguments);return i?this:r;};},this);["addTitleCustomTextAction","insertTitleCustomTextAction","indexOfTitleCustomTextAction","removeTitleCustomTextAction","removeAllTitleCustomTextActions","destroyTitleCustomTextActions","getTitleCustomTextActions"].forEach(function(m){var i=/^(add|insert|destroy)/.test(m);h.prototype[m]=function(){var s=this._getSemanticTitle(),j=m.replace(/TitleCustomTextAction?/,"CustomTextAction"),r;r=s[j].apply(s,arguments);return i?this:r;};},this);["addTitleCustomIconAction","insertTitleCustomIconAction","indexOfTitleCustomIconAction","removeTitleCustomIconAction","removeAllTitleCustomIconActions","destroyTitleCustomIconActions","getTitleCustomIconActions"].forEach(function(m){var i=/^(add|insert|destroy)/.test(m);h.prototype[m]=function(){var s=this._getSemanticTitle(),j=m.replace(/TitleCustomIconAction?/,"CustomIconAction"),r;r=s[j].apply(s,arguments);return i?this:r;};},this);["addFooterCustomAction","insertFooterCustomAction","indexOfFooterCustomAction","removeFooterCustomAction","removeAllFooterCustomActions","destroyFooterCustomActions","getFooterCustomActions"].forEach(function(m){var i=/^(add|insert|destroy)/.test(m);h.prototype[m]=function(){var s=this._getSemanticFooter(),j=m.replace(/FooterCustomAction?/,"CustomAction"),r;r=s[j].apply(s,arguments);return i?this:r;};},this);["addCustomShareAction","insertCustomShareAction","indexOfCustomShareAction","removeCustomShareAction","removeAllCustomShareActions","destroyCustomShareActions","getCustomShareActions"].forEach(function(m){var i=/^(add|insert|destroy)/.test(m);h.prototype[m]=function(){var s=this._getShareMenu(),j=m.replace(/CustomShareAction?/,"CustomAction"),r;r=s[j].apply(s,arguments);return i?this:r;};},this);
h.prototype._onAddAggregation=function(o,t){if(t===h._SAVE_AS_TILE_ACTION){this._replaceParent(o);}};
h.prototype._onRemoveAggregation=function(o,t){if(t===h._SAVE_AS_TILE_ACTION){this._restoreParent(o);}if(o._getType){delete o._getType;}};
h.prototype._replaceParent=function(o){if(o._fnOriginalGetParent){return;}o._fnOriginalGetParent=o.getParent;o.getParent=this._fnActionSubstituteParentFunction;};
h.prototype._restoreParent=function(o){if(o&&o._fnOriginalGetParent){o.getParent=o._fnOriginalGetParent;}};
h.prototype._attachShareMenuButtonChange=function(){this.attachEvent(h._EVENTS.SHARE_MENU_CONTENT_CHANGED,this._onShareMenuContentChanged,this);};
h.prototype._onShareMenuContentChanged=function(E){var s=E.getParameter("bEmpty"),o=this._getSemanticTitle(),i=this._getShareMenu(),j=i._getShareMenuButton();if(!j.getParent()){o.addContent(j,"shareIcon");return;}j.setVisible(!s);};
h.prototype._getPage=function(){if(!this.getAggregation("_dynamicPage")){this._initDynamicPage();}return this.getAggregation("_dynamicPage");};
h.prototype._initDynamicPage=function(){var o=new D(this.getId()+"-page",{title:this._getTitle(),header:this._getHeader(),footer:this._getFooter()}),s=sap.ui.getCore().getLibraryResourceBundle("sap.f").getText(h.ARIA_ROLE_DESCRIPTION);o._setAriaRoleDescription(s);this.setAggregation("_dynamicPage",o,true);};
h.prototype._getTitle=function(){if(!this._oDynamicPageTitle){this._oDynamicPageTitle=this._getSemanticTitle()._getContainer();}return this._oDynamicPageTitle;};
h.prototype._getHeader=function(){if(!this._oDynamicPageHeader){this._oDynamicPageHeader=new b(this.getId()+"-pageHeader");}return this._oDynamicPageHeader;};
h.prototype._getFooter=function(){if(!this._oDynamicPageFooter){this._oDynamicPageFooter=this._getSemanticFooter()._getContainer();}return this._oDynamicPageFooter;};
h.prototype._getSemanticTitle=function(){if(!this._oSemanticTitle){this._oSemanticTitle=new S(new a(this.getId()+"-pageTitle"),this);}return this._oSemanticTitle;};
h.prototype._getShareMenu=function(){if(!this._oShareMenu){this._oShareMenu=new d(this._getActionSheet(),this);this.addDependent(this._oShareMenu._oContainer);this._oShareMenu.attachEvent("_visibleActionsChanged",this._onShareMenuActionsChanged.bind(this));}return this._oShareMenu;};
h.prototype._onShareMenuActionsChanged=function(E){var v=E.getParameter("visibleActionsCount");if(this._iVisibleShareMenuAction!==v){if(v===1){this._showSingleVisibleAction();}if(v!==1){this._hideSingleVisibleAction();}}this._iVisibleShareMenuAction=v;};
h.prototype._showSingleVisibleAction=function(){var s=this._getShareMenu(),v=s._getVisibleActions(),i=s._aShareMenuActions.concat(s._aCustomShareActions),o;if(v.length===1){o=i.filter(function(j){return(j._getControl&&j._getControl()===v[0])||j===v[0];})[0];this._addShareMenuSingleAction(o);}};
h.prototype._hideSingleVisibleAction=function(){var p=e._Placement.shareMenu,s=this._getSemanticContainer(p),i;if(this._oSingleVisibleAction){i=e.isKnownSemanticType(this._oSingleVisibleAction.getMetadata().getName());this._oSingleVisibleAction._bIsSingleAction=false;this._getSemanticTitle().removeContent(this._oSingleVisibleAction,i?e._Placement.titleIcon:e._Placement.titleText);i?s.addContent(this._oSingleVisibleAction):s.insertCustomAction(this._oSingleVisibleAction,0);this._onAddAggregation(this._oSingleVisibleAction,p);this._oSingleVisibleAction=null;}};
h.prototype._getActionSheet=function(){if(!this._oActionSheet){this._oActionSheet=new A(this.getId()+"-shareMenu");}return this._oActionSheet;};
h.prototype._getSemanticFooter=function(){if(!this._oSemanticFooter){this._oSemanticFooter=new c(this._getOverflowToolbar(),this);}return this._oSemanticFooter;};
h.prototype._getOverflowToolbar=function(){if(!this._oOverflowToolbar){this._oOverflowToolbar=new O(this.getId()+"-pageFooter");}return this._oOverflowToolbar;};
h.prototype._getSemanticContainer=function(p){var P=e._Placement;if(p===P.titleText||p===P.titleIcon){return this._getSemanticTitle();}else if(p===P.footerLeft||p===P.footerRight){return this._getSemanticFooter();}else if(p===P.shareMenu){return this._getShareMenu();}return null;};
h.prototype._cleanMemory=function(){if(this._oShareMenu){this._oShareMenu.destroy();this._oShareMenu=null;}if(this._oActionSheet){this._oActionSheet.destroy();this._oActionSheet=null;}if(this._oSemanticTitle){this._oSemanticTitle.destroy();this._oSemanticTitle=null;}if(this._oDynamicPageTitle){this._oDynamicPageTitle.destroy();this._oDynamicPageTitle=null;}if(this._oDynamicPageHeader){this._oDynamicPageHeader.destroy();this._oDynamicPageHeader=null;}if(this._oSemanticFooter){this._oSemanticFooter.destroy();this._oSemanticFooter=null;}if(this._oDynamicPageFooter){this._oDynamicPageFooter.destroy();this._oDynamicPageFooter=null;}if(this._oOverflowToolbar){this._oOverflowToolbar.destroy();this._oOverflowToolbar=null;}};
return h;});
sap.ui.predefine('sap/f/semantic/SemanticPageRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,s){r.openStart("div",s);r.class("sapFSemanticPage");r.openEnd();r.renderControl(s._getPage());r.close("div");};
return S;},true);
sap.ui.predefine('sap/f/semantic/SemanticShareMenu',["sap/ui/core/IconPool","sap/ui/base/EventProvider","sap/ui/base/ManagedObjectObserver","sap/ui/core/library","sap/m/library","sap/m/OverflowToolbarButton","sap/m/OverflowToolbarLayoutData","./SemanticContainer"],function(I,E,M,c,m,O,a,S){"use strict";var B=m.ButtonType;var A=c.aria.HasPopup;
var b=S.extend("sap.f.semantic.SemanticShareMenu",{constructor:function(C,p){S.call(this,C,p);this._aShareMenuActions=[];this._aCustomShareActions=[];this._oObserver=new M(b.prototype._onShareMenuButtonChanges.bind(this));this._onShareButtonClickRef=this._onShareButtonClick.bind(this);this._setMode(b._Mode.initial);}});
b._Mode={initial:"initial",menu:"menu"};
b.prototype.addCustomAction=function(C){this._onControlAdded(C);this._oObserver.observe(C,{properties:["visible"]});this._callContainerAggregationMethod("insertButton",C,this._getCustomActionInsertIndex());this._aCustomShareActions.push(C);return this;};
b.prototype.insertCustomAction=function(C,i){if(this._aCustomShareActions.indexOf(C)<0){this._onControlAdded(C);this._oObserver.observe(C,{properties:["visible"]});this._aCustomShareActions.splice(i,0,C);}this._callContainerAggregationMethod("insertButton",C,this._getCustomActionInsertIndex(i));return this;};
b.prototype.getCustomActions=function(){return this._aCustomShareActions;};
b.prototype.indexOfCustomAction=function(C){return this._aCustomShareActions.indexOf(C);};
b.prototype.removeCustomAction=function(C){var r=this._callContainerAggregationMethod("removeButton",C);this._oObserver.unobserve(C,{properties:["visible"]});this._aCustomShareActions.splice(this._aCustomShareActions.indexOf(C),1);this._onControlRemoved();return r;};
b.prototype.removeAllCustomActions=function(){var r=[];this._aCustomShareActions.forEach(function(C){var R=this._callContainerAggregationMethod("removeButton",C);if(R){r.push(C);}},this);this._aCustomShareActions=[];this._onControlRemoved();return r;};
b.prototype.destroyCustomActions=function(){this.removeAllCustomActions(true).forEach(function(C){C.destroy();});return this;};
b.prototype.addContent=function(s){var C=this._getControl(s);if(this._aShareMenuActions.indexOf(s)<0){this._onControlAdded(C);this._oObserver.observe(C,{properties:["visible"]});this._aShareMenuActions.push(s);}this._preProcessOverflowToolbarButton(C);this._callContainerAggregationMethod("insertButton",C,this._getSemanticActionInsertIndex(s));return this;};
b.prototype.removeContent=function(s){var C=this._getControl(s);this._oObserver.unobserve(C,{properties:["visible"]});this._callContainerAggregationMethod("removeButton",C);this._aShareMenuActions.splice(this._aShareMenuActions.indexOf(s),1);this._postProcessOverflowToolbarButton(s);this._onControlRemoved();return this;};
b.prototype.destroy=function(){if(this._oShareMenuBtn){this._oShareMenuBtn.destroy();}this._oShareMenuBtn=null;this._aShareMenuActions=null;this._aCustomShareActions=null;return S.prototype.destroy.call(this);};
b.prototype.exit=function(){this._oObserver.disconnect();this._oObserver=null;};
b.prototype._getMode=function(){return this._mode;};
b.prototype._setMode=function(s){if(this._getMode()===s){return this;}if(s===b._Mode.initial){if(this._getMode()){this._fireContentChanged(true);}this._mode=b._Mode.initial;return this;}if(s===b._Mode.menu){this._mode=b._Mode.menu;this._fireContentChanged(false);}return this;};
b.prototype._fireContentChanged=function(e){E.prototype.fireEvent.call(this._getParent(),"_shareMenuContentChanged",{"bEmpty":e});};
b.prototype._onShareButtonClick=function(){var C=this._getContainer();C.openBy(this._oShareMenuBtn);};
b.prototype._getVisibleActions=function(){var d=this._aShareMenuActions.concat(this._aCustomShareActions),v=d.map(function(o){return this._getControl(o);},this).filter(function(o){return o.getVisible();});return v;};
b.prototype._onShareMenuButtonChanges=function(){var v=this._getVisibleActions();this._getShareMenuButton().setVisible(v.length>1);this.fireEvent("_visibleActionsChanged",{"visibleActionsCount":v.length});};
b.prototype._getShareMenuButton=function(){var C=this._getContainer();if(!this._oShareMenuBtn){this._oShareMenuBtn=new O(C.getId()+"-shareButton",{ariaHasPopup:A.Menu,icon:I.getIconURI("action"),tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.f").getText("SEMANTIC_CONTROL_ACTION_SHARE"),layoutData:new a({closeOverflowOnInteraction:false}),text:sap.ui.getCore().getLibraryResourceBundle("sap.f").getText("SEMANTIC_CONTROL_ACTION_SHARE"),type:B.Transparent,press:this._onShareButtonClickRef});}return this._oShareMenuBtn;};
b.prototype._getCustomActionInsertIndex=function(i){var C=this._aCustomShareActions.length;if(i===undefined){return this._aShareMenuActions.length+C;}i=i>=C?C:i;i+=this._aShareMenuActions.length;return i;};
b.prototype._getSemanticActionInsertIndex=function(s){this._aShareMenuActions.sort(this._sortControlByOrder.bind(this));return this._aShareMenuActions.indexOf(s);};
b.prototype._onControlAdded=function(C){if(this._isInitialMode()){this._setMode(b._Mode.menu,C);}};
b.prototype._onControlRemoved=function(){var i=this._aShareMenuActions.length,C=this._aCustomShareActions.length,e=(i+C)===0;if(this._isMenuMode()&&e){this._setMode(b._Mode.initial);}};
b.prototype._preProcessOverflowToolbarButton=function(o){if(o instanceof O){o._bInOverflow=true;}};
b.prototype._postProcessOverflowToolbarButton=function(o){if(o instanceof O){delete o._bInOverflow;}};
b.prototype._isInitialMode=function(){return this._getMode()===b._Mode.initial;};
b.prototype._isMenuMode=function(){return this._getMode()===b._Mode.menu;};
return b;});
sap.ui.predefine('sap/f/semantic/SemanticTitle',["sap/m/library","./SemanticContainer"],function(m,S){"use strict";var B=m.ButtonType;
var a=S.extend("sap.f.semantic.SemanticTitle",{constructor:function(c,p){S.call(this,c,p);this._iMainActionCount=0;this._aSemanticTextActions=[];this._aSemanticSimpleIconActions=[];this._aSemanticNavIconActions=[];this._aCustomTextActions=[];this._aCustomIconActions=[];}});
a.mPlacementMethodMap={titleText:"TextContent",titleIcon:"IconContent",shareIcon:"ShareContent"};
a.prototype.addContent=function(s,p){this["_insertSemantic"+a.mPlacementMethodMap[p]].call(this,s);return this;};
a.prototype.removeContent=function(s,p){this["_removeSemantic"+a.mPlacementMethodMap[p]].call(this,s);return this;};
a.prototype.destroy=function(){this._aSemanticSimpleIconActions=null;this._aSemanticTextActions=null;this._aCustomTextActions=null;this._aCustomIconActions=null;this._aSemanticNavIconActions=null;return S.prototype.destroy.call(this);};
a.prototype.addCustomTextAction=function(c){c.setType(B.Transparent);this._callContainerAggregationMethod("insertAction",c,this._getCustomTextActionInsertIndex());this._aCustomTextActions.push(c);return this;};
a.prototype.insertCustomTextAction=function(c,i){c.setType(B.Transparent);this._callContainerAggregationMethod("insertAction",c,this._getCustomTextActionInsertIndex(i));this._aCustomTextActions.splice(i,0,c);return this;};
a.prototype.indexOfCustomTextAction=function(c){return this._aCustomTextActions.indexOf(c);};
a.prototype.removeCustomTextAction=function(c){var i=this._aCustomTextActions.indexOf(c),r=this._callContainerAggregationMethod("removeAction",c);this._aCustomTextActions.splice(i,1);return r;};
a.prototype.removeAllCustomTextActions=function(){var r=[];this._aCustomTextActions.forEach(function(c){var R=this._callContainerAggregationMethod("removeAction",c);if(R){r.push(c);}},this);this._aCustomTextActions=[];return r;};
a.prototype.destroyCustomTextActions=function(){this.removeAllCustomTextActions().forEach(function(c){c.destroy();});return this;};
a.prototype.getCustomTextActions=function(){return this._aCustomTextActions;};
a.prototype.addCustomIconAction=function(c){c.setType(B.Transparent);this._callContainerAggregationMethod("insertAction",c,this._getCustomIconActionInsertIndex());this._aCustomIconActions.push(c);return this;};
a.prototype.insertCustomIconAction=function(c,i){c.setType(B.Transparent);this._callContainerAggregationMethod("insertAction",c,this._getCustomIconActionInsertIndex(i));this._aCustomIconActions.splice(i,0,c);return this;};
a.prototype.indexOfCustomIconAction=function(c){return this._aCustomIconActions.indexOf(c);};
a.prototype.removeCustomIconAction=function(c){var i=this._aCustomIconActions.indexOf(c),r=this._callContainerAggregationMethod("removeAction",c);this._aCustomIconActions.splice(i,1);return r;};
a.prototype.removeAllCustomIconActions=function(){var r=[];this._aCustomIconActions.forEach(function(c){var R=this._callContainerAggregationMethod("removeAction",c);if(R){r.push(c);}},this);this._aCustomIconActions=[];return r;};
a.prototype.destroyCustomIconActions=function(){this.removeAllCustomIconActions().forEach(function(c){c.destroy();});return this;};
a.prototype.getCustomIconActions=function(){return this._aCustomIconActions;};
a.prototype._insertSemanticTextContent=function(s){var c=this._getControl(s),i=this._isMainAction(s),I;if(s._bIsSingleAction){c._bInOverflow=false;}if(this._aSemanticTextActions.indexOf(s)<0){this._aSemanticTextActions.push(s);}if(i){this._iMainActionCount++;I=this._getSemanticTextMainActionInsertIndex();}else{I=this._getSemanticTextActionInsertIndex(s);}this._callContainerAggregationMethod("insertAction",c,I);return this;};
a.prototype._removeSemanticTextContent=function(s){var c=this._getControl(s),C=this._aSemanticTextActions.indexOf(s),i=this._isMainAction(s);if(i){this._iMainActionCount--;}this._aSemanticTextActions.splice(C,1);this._callContainerAggregationMethod("removeAction",c);return this;};
a.prototype._insertSemanticIconContent=function(s){var c=this._getControl(s),C,i;if(s._bIsSingleAction){c._bInOverflow=false;}if(this._isNavigationAction(s)){this._aSemanticNavIconActions.push(s);i=this._getSemanticNavIconActionInsertIndex(s);C="insertNavigationAction";}else{if(this._aSemanticSimpleIconActions.indexOf(s)<0){this._aSemanticSimpleIconActions.push(s);}i=this._getSemanticSimpleIconActionInsertIndex(s);C="insertAction";}this._callContainerAggregationMethod(C,c,i);return this;};
a.prototype._removeSemanticIconContent=function(s){var c=this._getControl(s),C,i;if(this._isNavigationAction(s)){i=this._aSemanticNavIconActions.indexOf(s);this._aSemanticNavIconActions.splice(i,1);C="removeNavigationAction";}else{i=this._aSemanticTextActions.indexOf(s);this._aSemanticSimpleIconActions.splice(i,1);C="removeAction";}this._callContainerAggregationMethod(C,c);return this;};
a.prototype._insertSemanticShareContent=function(s){var c=this._getControl(s),i=this._getSemanticShareMenuInsertIndex();this._callContainerAggregationMethod("insertAction",c,i);return this;};
a.prototype._removeSemanticShareContent=function(s){var c=this._getControl(s);this._callContainerAggregationMethod("removeAction",c);return this;};
a.prototype._getSemanticTextMainActionInsertIndex=function(){return 0;};
a.prototype._getCustomTextActionInsertIndex=function(i){var c=this._aCustomTextActions.length;if(i===undefined){return this._iMainActionCount+c;}i=i>=c?c:i;i+=this._iMainActionCount;return i;};
a.prototype._getSemanticTextActionInsertIndex=function(s){this._aSemanticTextActions.sort(this._sortControlByOrder.bind(this));return this._getCustomTextActionInsertIndex()+this._aSemanticTextActions.indexOf(s)-this._iMainActionCount;};
a.prototype._getCustomIconActionInsertIndex=function(i){var c=this._aCustomIconActions.length,p=this._aCustomTextActions.length+this._aSemanticTextActions.length;if(i===undefined){return p+c;}i=i>=c?c:i;i+=p;return i;};
a.prototype._getSemanticSimpleIconActionInsertIndex=function(s){this._aSemanticSimpleIconActions.sort(this._sortControlByOrder.bind(this));return this._getCustomIconActionInsertIndex()+this._aSemanticSimpleIconActions.indexOf(s);};
a.prototype._getSemanticNavIconActionInsertIndex=function(s){this._aSemanticNavIconActions.sort(this._sortControlByOrder.bind(this));return this._aSemanticNavIconActions.indexOf(s);};
a.prototype._getSemanticShareMenuInsertIndex=function(){return this._callContainerAggregationMethod("getActions").length;};
a.prototype._getContainerBar=function(){var c=this._getContainer();if(c){return c.getAggregation("_overflowToolbar");}return null;};
return a;});
sap.ui.predefine('sap/f/semantic/SemanticToggleButton',["sap/m/semantic/SemanticToggleButton","sap/f/semantic/SemanticConfiguration"],function(M,S){"use strict";
var a=M.extend("sap.f.semantic.SemanticToggleButton",{metadata:{library:"sap.f","abstract":true}});
a.prototype._getConfiguration=function(){return S.getConfiguration(this.getMetadata().getName());};
return a;});
sap.ui.predefine('sap/f/semantic/SendEmailAction',['sap/f/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.f.semantic.SendEmailAction",{metadata:{library:"sap.f"}});
return a;});
sap.ui.predefine('sap/f/semantic/SendMessageAction',['sap/f/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.f.semantic.SendMessageAction",{metadata:{library:"sap.f"}});
return a;});
sap.ui.predefine('sap/f/semantic/ShareInJamAction',['sap/f/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.f.semantic.ShareInJamAction",{metadata:{library:"sap.f"}});
return a;});
sap.ui.predefine('sap/f/semantic/TitleMainAction',["./MainAction"],function(M){"use strict";
var T=M.extend("sap.f.semantic.TitleMainAction",{metadata:{library:"sap.f"}});
return T;});
sap.ui.predefine('sap/f/shellBar/Accessibility',['sap/ui/core/library',"sap/ui/core/Core"],function(c,C){"use strict";var A=c.aria.HasPopup;var a=function(o){if(o){this._oControl=o;this._oControl.addDelegate(this._controlDelegate,false,this);}this.oRb=C.getLibraryResourceBundle("sap.f");};a.AriaHasPopup={MENU:A.Menu,PRODUCTS:A.Menu,PROFILE:A.Menu,NOTIFICATIONS:A.Dialog};a.prototype._controlDelegate={onBeforeRendering:function(){this.attachDelegates();}};
a.prototype.attachDelegates=function(){var o=this._oControl.getProfile();this._oDelegateSecondTitle={onAfterRendering:this.onAfterRenderingSecondTitle};this._oDelegateSearch={onAfterRendering:this.onAfterRenderingSearch};this._oDelegateAvatar={onAfterRendering:this.onAfterRenderingAvatar};this._oDelegateProducts={onAfterRendering:this.onAfterRenderingProducts};this._oDelegateNavButton={onAfterRendering:this.onAfterRenderingNavButton};this._oDelegateMenuButton={onAfterRendering:this.onAfterRenderingMenuButton};if(this._oControl._oSecondTitle){this._oControl._oSecondTitle.addDelegate(this._oDelegateSecondTitle,false,this);}if(this._oControl._oSearch){this._oControl._oSearch.addDelegate(this._oDelegateSearch,false,this);}if(o){o.addDelegate(this._oDelegateAvatar,false,this);}if(this._oControl._oProductSwitcher){this._oControl._oProductSwitcher.addDelegate(this._oDelegateProducts,false,this);}if(this._oControl._oNavButton){this._oControl._oNavButton.addDelegate(this._oDelegateNavButton,false,this);}if(this._oControl._oMenuButton){this._oControl._oMenuButton.addDelegate(this._oDelegateMenuButton,false,this);}};
a.prototype.getRootAttributes=function(){return{role:"banner",label:this.oRb.getText("SHELLBAR_CONTAINER_LABEL")};};
a.prototype.getCoPilotAttributes=function(){return{role:"button",label:this.oRb.getText("SHELLBAR_COPILOT_TOOLTIP")};};
a.prototype.getEntityTooltip=function(e){return this.oRb.getText("SHELLBAR_"+e+"_TOOLTIP")||"";};
a.prototype.updateNotificationsNumber=function(n){var t=this.getEntityTooltip("NOTIFICATIONS"),s=n?n+" "+t:t;this._oControl._oNotifications.setTooltip(s);};
a.prototype.onAfterRenderingSecondTitle=function(){var $=this._oControl._oSecondTitle.$();$.attr("role","heading");$.attr("aria-level","2");};
a.prototype.onAfterRenderingSearch=function(){this._oControl._oSearch.$().attr("aria-label",this.getEntityTooltip("SEARCH"));};
a.prototype.onAfterRenderingAvatar=function(){var $=this._oControl.getProfile().$();$.attr("aria-label",this.getEntityTooltip("PROFILE"));$.attr("aria-haspopup","menu");};
a.prototype.onAfterRenderingProducts=function(){var $=this._oControl._oProductSwitcher.$();$.attr("aria-label",this.getEntityTooltip("PRODUCTS"));};
a.prototype.onAfterRenderingNavButton=function(){this._oControl._oNavButton.$().attr("aria-label",this.getEntityTooltip("BACK"));};
a.prototype.onAfterRenderingMenuButton=function(){var $=this._oControl._oMenuButton.$();$.attr("aria-label",this.getEntityTooltip("MENU"));};
a.prototype.exit=function(){var o=this._oControl.getProfile();if(this._oControl){this._oControl.removeDelegate(this._controlDelegate);}if(this._oControl._oSecondTitle){this._oControl._oSecondTitle.removeDelegate(this._oDelegateSecondTitle);}if(this._oControl._oSearch){this._oControl._oSearch.removeDelegate(this._oDelegateSearch);}if(o){o.removeDelegate(this._oDelegateAvatar);}if(this._oControl._oProductSwitcher){this._oControl._oProductSwitcher.removeDelegate(this._oDelegateProducts);}if(this._oControl._oNavButton){this._oControl._oNavButton.removeDelegate(this._oDelegateNavButton);}if(this._oControl._oMenuButton){this._oControl._oMenuButton.removeDelegate(this._oDelegateMenuButton);}};
return a;});
sap.ui.predefine('sap/f/shellBar/AdditionalContentSupport',["sap/m/OverflowToolbarLayoutData","sap/base/Log","sap/m/library"],function(O,L,l){"use strict";var a=l.OverflowToolbarPriority;var A=function(){if(!this.isA("sap.ui.core.Element")){return;}this._prepareNewAdditionalControl=function(c){if(!c.getLayoutData()){c.setLayoutData(new O({priority:a.Low}));}return c;};this.addAdditionalContent=function(c){this.validateAggregation("additionalContent",c,true);if(this.indexOfAdditionalContent(c)!==-1){L.warning("Object"+c+" is already added to ShellBar");return this;}this._aAdditionalContent.push(this._prepareNewAdditionalControl(c));this._updateParent();return this;};this.insertAdditionalContent=function(c,i){this.validateAggregation("additionalContent",c,true);if(this.indexOfAdditionalContent(c)!==-1){L.warning("Object"+c+" is already added to ShellBar");return this;}this._aAdditionalContent.splice(i,0,c);this._updateParent();return this;};this.indexOfAdditionalContent=function(c){for(var i=0;i<this._aAdditionalContent.length;i++){if(this._aAdditionalContent[i]===c){return i;}}return-1;};this.removeAdditionalContent=function(o){var c,i,_=o;if(typeof(_)==="string"){for(i=0;i<this._aAdditionalContent.length;i++){if(this._aAdditionalContent[i]&&this._aAdditionalContent[i].getId()===_){_=i;break;}else if(i===this._aAdditionalContent.length-1){_=-1;}}}if(typeof(_)==="object"){for(i=0;i<this._aAdditionalContent.length;i++){if(this._aAdditionalContent[i]===_){_=i;break;}else if(i===this._aAdditionalContent.length-1){_=-1;}}}if(typeof(_)==="number"){if(_<0||_>=this._aAdditionalContent.length){L.warning("ShellBar.removeAggregation AdditionalContent called with invalid parameter for "+"non-existing object:, "+o);return null;}else{c=this._aAdditionalContent[_];this._aAdditionalContent.splice(_,1);c.setParent(null);this._updateParent();return c;}}else{return null;}};this.removeAllAdditionalContent=function(){var c,C=this._aAdditionalContent,i;if(!C){return[];}this._aAdditionalContent=[];for(i=0;i<C.length;i++){c=C[i];c.setParent(null);}this._updateParent();return C;};this.destroyAdditionalContent=function(){this._aAdditionalContent.forEach(this._destroyAllAdditionalContent,this);this._aAdditionalContent=[];this._updateParent();return this;};this._destroyAllAdditionalContent=function(c){return c.destroy();};this.getAdditionalContent=function(){return this._aAdditionalContent;};this._updateParent=function(){this._bOTBUpdateNeeded=true;this.invalidate();};};return A;});
sap.ui.predefine('sap/f/shellBar/CoPilot',["sap/ui/core/Control","sap/ui/core/Configuration","sap/f/shellBar/CoPilotRenderer"],function(C,a,b){"use strict";
var c=C.extend("sap.f.shellBar.CoPilot",{
metadata:{library:"sap.f",events:{press:{}}},
renderer:b
});
c.prototype.ontap=function(e){e.setMarked();this.firePress({});};
c.prototype.getAnimation=function(){return sap.ui.getCore().getConfiguration().getAnimationMode()!==a.AnimationMode.none;};
return c;});
sap.ui.predefine('sap/f/shellBar/CoPilotRenderer',['./Accessibility'],function(A){"use strict";var C={};
C.render=function(r,c){var a=new A(),o=a.getCoPilotAttributes(),t=c.getTooltip();r.write("<div");r.writeAttribute("tabindex","0");if(t){r.writeAttributeEscaped("title",t);}r.writeAccessibilityState({role:o.role,label:o.label});r.writeControlData(c);r.addClass("CPImage");r.writeStyles();r.writeClasses();r.write(">");if(c.getAnimation()){r.write('<svg focusable="false" alt="'+t+'" role="presentation" version="1.1" width="48" height="48" viewBox="-150 -150 300 300" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"><defs><linearGradient id="grad1" x1="0%" x2="100%" y1="100%" y2="0%"><stop class="color1 opacity7" offset="0%"/><stop class="color2 opacity7" offset="80%"/></linearGradient><linearGradient id="grad2" x1="0%" x2="100%" y1="100%" y2="0%"><stop class="color1 opacity36" offset="0%"/><stop class="color2 opacity36" offset="80%"/></linearGradient><linearGradient id="grad3" x1="0%" x2="100%" y1="100%" y2="0%"><stop class="color1 opacity2" offset="0%"/><stop class="color2 opacity2" offset="80%"/></linearGradient><mask id="innerCircle"><circle cx="0" cy="0" r="120" fill="white" /><circle cx="0" cy="0" r="76" fill="black" /></mask>'+'<path id="path" d="M 102 0 C 102 17.85 86.87 29.53 77.94 44.99 C 69.01 60.46 66.46 79.4 51 88.33 C 35.53 97.26 17.85 90 5.51000e-15 90 C -17.85 90 -35.53 97.26 -50.99 88.33 C -66.46 79.4 -69.01 60.46 -77.94 45 C -86.87 29.53 -102 17.85 -102 1.24000e-14 C -102 -17.85 -86.87 -29.53 -77.94 -44.99 C -69.01 -60.46 -66.46 -79.4 -51 -88.33 C -35.53 -97.26 -17.85 -89.99 -1.65000e-14 -90 C 17.85 -90 35.53 -97.26 50.99 -88.33 C 66.46 -79.4 69.01 -60.46 77.94 -45 C 86.87 -29.53 102 -17.85 102 0 Z M 97.27 0 C 98.58 17.55 94.29 34.2 84.09 48.54 C 74.21 62.42 58.47 67.23 43.57 75.46 C 28.94 83.54 16.64 93.54 5.81000e-15 95 C -17.27 96.5 -33.78 93.13 -48.19 83.47 C -62.26 74.04 -68.01 58.82 -76.14 43.96 C -84.09 29.4 -92 16.48 -93.8 1.14000e-14 C -95.7 -17.53 -94.76 -34.35 -86.34 -49.84 C -77.83 -65.5 -64.53 -76.31 -48.31 -83.67 C -32.81 -90.7 -17 -88.78 -1.63000e-14 -89 C 17.21 -89.21 34.09 -93.47 49 -84.87 C 63.91 -76.28 68.61 -59.49 77.12 -44.53 C 85.58 -29.66 95.99 -17.05 97.27 0 Z" dur="30s" repeatCount="indefinite"/><animateTransform attributeName="transform" type="scale" values="1;1.05;1.05;1.02;1" dur="0.15s" begin="click_area.mousedown" repeatCount="1" additive="sum"/></path></defs><g mask="url(#innerCircle)"><g fill="url(#grad3)" transform="rotate(54)"><use xlink:href="#path"><animateTransform id="animate1" attributeName="transform" type="rotate" from="54" to="416" dur="15s" repeatCount="indefinite"/></use></g><g fill="url(#grad2)" transform="rotate(74)"><use xlink:href="#path" /></g><g fill="url(#grad1)" transform="rotate(90)"><use xlink:href="#path"><animateTransform id="animate2" attributeName="transform" type="rotate" from="90" to="450" dur="30s" repeatCount="indefinite"/></use></g></g><circle cx="0" cy="0" r="76" fill="transparent" id="click_area"/>');}else{r.write('<svg focusable="false" alt="'+t+'" role="presentation" version="1.1" width="48" height="48" viewBox="-150 -150 300 300" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"><defs><linearGradient id="grad1" x1="0%" x2="100%" y1="100%" y2="0%"><stop class="color1 opacity7" offset="0%"/><stop class="color2 opacity7" offset="80%"/></linearGradient><linearGradient id="grad2" x1="0%" x2="100%" y1="100%" y2="0%"><stop class="color1 opacity36" offset="0%"/><stop class="color2 opacity36" offset="80%"/></linearGradient><linearGradient id="grad3" x1="0%" x2="100%" y1="100%" y2="0%"><stop class="color1 opacity2" offset="0%"/><stop class="color2 opacity2" offset="80%"/></linearGradient><mask id="innerCircle"><circle cx="0" cy="0" r="120" fill="white" /><circle cx="0" cy="0" r="76" fill="black" /></mask><path id="path" d="M 98.1584 0 C 98.3156 17.3952 89.0511 31.3348 79.5494 45.9279 C 70.339 60.0814 60.6163 71.2177 46.1724 79.9729 C 31.4266 88.9178 17.2493 94.3909 5.77261e-15 94.2739 C -17.1547 94.1581 -30.8225 87.6907 -45.7979 79.3244 C -61.0143 70.8266 -73.5583 62.554 -83.0507 47.9493 C -92.6677 33.1579 -98.4872 17.5705 -97.1793 1.19010e-14 C -95.9465 -16.9777 -84.488 -29.0862 -76.1351 -43.9566 C -67.6795 -59.0155 -63.8629 -76.1085 -49.262 -85.3243 C -34.502 -94.6464 -17.4328 -93.0037 -1.69174e-14 -92.0939 C 16.8967 -91.214 31.8608 -89.0341 46.4198 -80.4014 C 60.872 -71.8326 69.6003 -59.5351 78.6792 -45.4254 C 88.0511 -30.9104 98.015 -17.2766 98.1584 0 Z"/></defs><g mask="url(#innerCircle)"><g fill="url(#grad3)" transform="rotate(54)"><use xlink:href="#path"/></g><g fill="url(#grad2)" transform="rotate(74)"><use xlink:href="#path" /></g><g fill="url(#grad1)" transform="rotate(90)"><use xlink:href="#path"/></g></g><circle cx="0" cy="0" r="76" fill="transparent" id="click_area"/>');}r.write("</div>");};
return C;},true);
sap.ui.predefine('sap/f/shellBar/ControlSpacer',['sap/ui/core/Control','sap/f/shellBar/ControlSpacerRenderer'],function(C,a){"use strict";
var b=C.extend("sap.f.shellBar.ControlSpacer",{
metadata:{library:"sap.f",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:''}}},
renderer:a
});
b.prototype.setWidth=function(w){if(this.$().length){this.$().width(w);}return this.setProperty("width",w,true);};
return b;});
sap.ui.predefine('sap/f/shellBar/ControlSpacerRenderer',[],function(){"use strict";var C={apiVersion:2};
C.render=function(r,c){r.openStart("div",c);r.class("sapMTBSpacer");r.style("width",c.getWidth());r.openEnd().close("div");};
return C;},true);
sap.ui.predefine('sap/f/shellBar/Factory',["sap/m/Title","sap/m/Image","sap/m/MenuButton","sap/m/OverflowToolbar","sap/m/OverflowToolbarButton","sap/m/ToolbarSpacer","sap/m/OverflowToolbarLayoutData","sap/m/FlexItemData","./CoPilot","./Accessibility","sap/m/library","sap/ui/core/library","sap/m/HBox"],function(T,I,M,O,a,b,c,F,C,A,l,d,H){"use strict";var e=l.OverflowToolbarPriority;var f=l.ToolbarDesign;var B=l.ButtonType;var g=d.TitleLevel;var h=function(o){this._oContext=o;this._oControls={};this._oAcc=new A();};
h.prototype.getOverflowToolbar=function(){var o=this._oAcc;if(!this._oControls.oOverflowToolbar){this._oControls.oOverflowToolbar=new O({design:f.Transparent,style:"Clear"}).addStyleClass("sapFShellBarOTB").setLayoutData(new F({growFactor:1,shrinkFactor:1,minWidth:"0px",maxWidth:"100%"}))._setEnableAccessibilty(false);this._oControls.oOverflowToolbar._getOverflowButton().addStyleClass("sapFShellBarItem sapFShellBarOverflowButton");}this._oControls.oOverflowToolbar._getOverflowButton()._updateBadgeInvisibleText=function(v){this._getBadgeInvisibleText().setText(v+o.getEntityTooltip("NOTIFICATIONS"));};return this._oControls.oOverflowToolbar;};
h.prototype.getAdditionalBox=function(){if(!this._oControls.oAdditionalBox){this._oControls.oAdditionalBox=new H({alignItems:"Center"}).addStyleClass("sapFShellBarOAHB");}return this._oControls.oAdditionalBox;};
h.prototype.getToolbarSpacer=function(){if(!this._oControls.oToolbarSpacer){this._oControls.oToolbarSpacer=new b();}return this._oControls.oToolbarSpacer;};
h.prototype.getSecondTitle=function(){if(!this._oControls.oSecondTitle){this._oControls.oSecondTitle=new T({titleStyle:g.H6}).addStyleClass("sapFShellBarSecondTitle").setLayoutData(new F({shrinkFactor:2,minWidth:"1px"}));}return this._oControls.oSecondTitle;};
h.prototype.getHomeIcon=function(){if(!this._oControls.oHomeIcon){this._oControls.oHomeIcon=new I({densityAware:false,tooltip:this._oAcc.getEntityTooltip("LOGO"),press:function(){this._oContext.fireEvent("homeIconPressed",{icon:this._oControls.oHomeIcon});}.bind(this)}).addStyleClass("sapFShellBarHomeIcon");}return this._oControls.oHomeIcon;};
h.prototype.getMegaMenu=function(){if(!this._oControls.oMegaMenu){this._oControls.oMegaMenu=new M({type:B.Transparent,iconDensityAware:false,layoutData:new F({shrinkFactor:0,minWidth:"0px",maxWidth:"100%"})}).addStyleClass("sapFSHMegaMenu");}return this._oControls.oMegaMenu;};
h.prototype.getPrimaryTitle=function(){if(!this._oControls.oPrimaryTitle){this._oControls.oPrimaryTitle=new T({titleStyle:g.H6,level:g.H1}).setLayoutData(new F({shrinkFactor:0,minWidth:"0px",maxWidth:"100%"})).addStyleClass("sapFShellBarPrimaryTitle");}return this._oControls.oPrimaryTitle;};
h.prototype.getCopilot=function(){if(!this._oControls.oCopilot){this._oControls.oCopilot=new C({tooltip:this._oAcc.getEntityTooltip("COPILOT"),press:function(){this._oContext.fireEvent("copilotPressed",{image:this._oControls.oCopilot});}.bind(this)});}return this._oControls.oCopilot;};
h.prototype.getSearch=function(){if(!this._oControls.oSearch){this._oControls.oSearch=new a({text:"Search",icon:"sap-icon://search",type:B.Transparent,tooltip:this._oAcc.getEntityTooltip("SEARCH"),press:function(){this._oContext.fireEvent("searchButtonPressed",{button:this._oControls.oSearch});}.bind(this)}).setLayoutData(new c({priority:e.Low}));}return this._oControls.oSearch;};
h.prototype.getManagedSearch=function(){if(!this._oControls.oManagedSearch){this._oControls.oManagedSearch=this._oContext.getSearchManager()._oSearch;}return this._oControls.oManagedSearch;};
h.prototype.getNavButton=function(){if(!this._oControls.oNavButton){this._oControls.oNavButton=new a({icon:"sap-icon://nav-back",type:B.Transparent,tooltip:this._oAcc.getEntityTooltip("BACK"),press:function(){this._oContext.fireEvent("navButtonPressed",{button:this._oControls.oNavButton});}.bind(this)});}return this._oControls.oNavButton;};
h.prototype.getMenuButton=function(){if(!this._oControls.oMenuButton){this._oControls.oMenuButton=new a({ariaHasPopup:A.AriaHasPopup.MENU,icon:"sap-icon://menu2",type:B.Transparent,tooltip:this._oAcc.getEntityTooltip("MENU"),press:function(){this._oContext.fireEvent("menuButtonPressed",{button:this._oControls.oMenuButton});}.bind(this)});}return this._oControls.oMenuButton;};
h.prototype.getNotifications=function(){var o=this._oAcc;if(!this._oControls.oNotifications){this._oControls.oNotifications=new a({ariaHasPopup:A.AriaHasPopup.NOTIFICATIONS,text:"Notifications",icon:"sap-icon://bell",type:B.Transparent,tooltip:o.getEntityTooltip("NOTIFICATIONS"),press:function(){this._oContext.fireEvent("notificationsPressed",{button:this._oControls.oNotifications});}.bind(this)}).addStyleClass("sapFButtonNotifications").setLayoutData(new c({priority:e.Low}));this._oControls.oNotifications._updateBadgeInvisibleText=function(v){this._getBadgeInvisibleText().setText(v+o.getEntityTooltip("NOTIFICATIONS"));};}return this._oControls.oNotifications;};
h.prototype.getProductSwitcher=function(){if(!this._oControls.oProductSwitcher){this._oControls.oProductSwitcher=new a({ariaHasPopup:A.AriaHasPopup.PRODUCTS,text:"My products",icon:"sap-icon://grid",type:B.Transparent,tooltip:this._oAcc.getEntityTooltip("PRODUCTS"),press:function(){this._oContext.fireEvent("productSwitcherPressed",{button:this._oControls.oProductSwitcher});}.bind(this)}).addStyleClass("sapFShellBarGridButton").addStyleClass("sapFShellBarItem");}return this._oControls.oProductSwitcher;};
h.prototype.destroy=function(){Object.keys(this._oControls).forEach(function(k){var o=this._oControls[k];if(o){o.destroy();}}.bind(this));};
return h;});
sap.ui.predefine('sap/f/shellBar/ResponsiveHandler',["sap/m/OverflowToolbarLayoutData","sap/ui/Device","sap/ui/core/ResizeHandler","sap/ui/dom/units/Rem","sap/m/library"],function(O,D,R,a,l){"use strict";var b=l.OverflowToolbarPriority;var M=12;var c=function(C){this._oControl=C;this._oDelegate={onAfterRendering:this.onAfterRendering,onBeforeRendering:this.onBeforeRendering};this._oControl.addDelegate(this._oDelegate,false,this);this.sCurrentRange="";this._bAttachedManagedSearchHandler=false;this._oControl._iResizeHandlerId=R.register(this._oControl,this._handleResize.bind(this));this._iMinSearchWidth=a.toPx(M);};
c.prototype.onAfterRendering=function(){var p=D.media.getCurrentRange("Std",this._oControl.$().outerWidth(true)).name==="Phone";this._oButton=this._oControl._oMegaMenu&&this._oControl._oMegaMenu.getAggregation("_button");this._oDomRef=this._oControl.getDomRef();this.bIsMegaMenuConfigured=this._oControl._oTitleControl&&this._oControl._oTitleControl===this._oControl._oMegaMenu;if(this._oControl._oManagedSearch&&!this._bAttachedManagedSearchHandler){this._oControl._oManagedSearch.attachEvent("_updateVisualState",this._switchOpenStateOnSearch,this);this._bAttachedManagedSearchHandler=true;}if(p){this._transformTitleControlMobile();}this._handleResize();};
c.prototype.exit=function(){if(this._oControl._iResizeHandlerId){R.deregister(this._oControl._iResizeHandlerId);this._oControl._iResizeHandlerId=null;}};
c.prototype._handleResize=function(){if(!this._oDomRef){return;}var C=this._oControl.$(),w=C.outerWidth(),o=D.media.getCurrentRange("Std",w),p;this.sCurrentRange=o.name;if(o){p=this.sCurrentRange==="Phone";C.toggleClass("sapFShellBarSizeDesktop",this.sCurrentRange==="Desktop");C.toggleClass("sapFShellBarSizeTablet",this.sCurrentRange==="Tablet");C.toggleClass("sapFShellBarSizePhone",p);}if(this._oControl._oManagedSearch&&this._oControl._oManagedSearch.getIsOpen()){setTimeout(this._adaptSearch.bind(this),100);}else{this._oControl._bSearchPlaceHolder=false;}if(this._iPreviousWidth===w){return;}this._iPreviousWidth=w;if(!this._oControl._oNavButton&&!this._oControl._oMenuButton&&!this._oControl._oHomeIcon&&!this._oControl._oMegaMenu&&!this._oControl._oSecondTitle&&!this._oControl._oManagedSearch&&!this._oControl._oCopilot){return;}if(p&&!this.bWasInPhoneRange){this._transformToPhoneState();}else if(!p&&this.bWasInPhoneRange){this._transformToRegularState();}};
c.prototype._switchOpenStateOnSearch=function(){var s=this._oControl._oManagedSearch;if(!s){return;}if(this.bWasInPhoneRange){this._transformToPhoneState();}else{this._transformToRegularState();}this._oControl.toggleStyleClass("sapFShellBarSearchIsOpen",s.getIsOpen());};
c.prototype._transformToPhoneState=function(){var s=this._oControl._oManagedSearch,o=this._oControl._getOverflowToolbar().getContent(),S=this._oControl._oToolbarSpacer;if(this._oControl._oSecondTitle){this._oControl._oSecondTitle.setVisible(false);}this._transformTitleControlMobile();if(!this._bControlsLayoutDataCached){this._cacheControlsLayoutData();this._bControlsLayoutDataCached=true;}o.forEach(function(C){if(C===S){return;}C.setLayoutData(new O({priority:b.AlwaysOverflow}));});this.bWasInPhoneRange=true;if(s){s.setPhoneMode(true);if(s.getIsOpen()){this._toggleAllControlsExceptSearch(true);this._bSearchWasOpen=true;}else if(this._bSearchWasOpen){this._toggleAllControlsExceptSearch(false);this._bSearchWasOpen=false;}}this._oControl.invalidate();};
c.prototype._transformToRegularState=function(){var s=this._oControl._oManagedSearch;this._toggleAllControlsExceptSearch(false);if(this._oControl._oSecondTitle){this._oControl._oSecondTitle.setVisible(true);}if(this._oControl._oHomeIcon){if(this._oControl._oMegaMenu){this._oControl._oMegaMenu.setText(this._oControl._sTitle).setIcon("");}if(this._oControl._oPrimaryTitle){this._oControl._oPrimaryTitle.setText(this._oControl._sTitle);}if(this.bIsMegaMenuConfigured){this._oControl._oHomeIcon.setVisible(true);}}if(this._bControlsLayoutDataCached){this._restoreControlsLayoutData();this._bControlsLayoutDataCached=false;}this.bWasInPhoneRange=false;if(s){s.setPhoneMode(false);this._oControl._bSearchPlaceHolder=false;}this._oControl.invalidate();};
c.prototype._transformTitleControlMobile=function(){var C;if(!this._oControl._oHomeIcon){return this.bIsMegaMenuConfigured?this._oControl._oMegaMenu.setText(this._oControl.getTitle()).setIcon(""):false;}C=this.bIsMegaMenuConfigured&&this._oControl._oHomeIcon.getVisible()||!this.bIsMegaMenuConfigured&&!this._oControl._oHomeIcon.getVisible();if(this._oControl._oMegaMenu){this._oControl._oMegaMenu.setText("").setIcon(this._oControl.getHomeIcon());}if(this._oControl._oPrimaryTitle){this._oControl._oPrimaryTitle.setText("");}if(C){this._oControl._oHomeIcon.setVisible(!this.bIsMegaMenuConfigured);this._oControl.invalidate();}};
c.prototype._adaptSearch=function(){var s=this._oControl._oManagedSearch,S;if(!s||this.sCurrentRange==="Phone"){return;}S=s.$().width();if(this._oControl._bSearchPlaceHolder){if(S>=this._iMinSearchWidth){this._oControl._bSearchPlaceHolder=false;this._toggleAllControlsExceptSearch(false);}}else if(S<this._iMinSearchWidth){this._oControl._bSearchPlaceHolder=true;this._toggleAllControlsExceptSearch(true);}else if(s.hasStyleClass("sapFShellBarSearchOpenTick")){s.removeStyleClass("sapFShellBarSearchOpenTick");this._adaptSearch();}return this;};
c.prototype._toggleAllControlsExceptSearch=function(s){var S=this._oControl._oManagedSearch;this._oControl.toggleStyleClass("sapFShellBarFullSearch",s);S&&S.toggleStyleClass("sapFShellBarSearchFullWidth",s);};
c.prototype._cacheControlsLayoutData=function(){var o=this._oControl._getOverflowToolbar().getContent();this._oCachedLayoutData={};o.forEach(function(C){this._oCachedLayoutData[C.getId()]=C.getLayoutData();},this);};
c.prototype._restoreControlsLayoutData=function(){var o=this._oControl._getOverflowToolbar().getContent();o.forEach(function(C){var L=this._oCachedLayoutData[C.getId()];if(L){C.setLayoutData(L);}},this);};
return c;});
sap.ui.predefine('sap/f/shellBar/Search',['sap/ui/core/Control','sap/f/shellBar/SearchRenderer','sap/m/SearchField','sap/m/OverflowToolbarButton',"sap/m/OverflowToolbarLayoutData","sap/m/Button","sap/ui/events/KeyCodes","./Accessibility","sap/m/library"],function(C,S,a,O,b,B,K,A,l){"use strict";var c=l.ButtonType;var d=l.OverflowToolbarPriority;
var e=C.extend("sap.f.shellBar.Search",{
metadata:{interfaces:["sap.m.IOverflowToolbarContent"],library:"sap.f",properties:{isOpen:{type:"boolean",defaultValue:false},phoneMode:{type:"boolean",defaultValue:false},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null}},aggregations:{_searchField:{type:"sap.m.SearchField",multiple:false},_searchButton:{type:"sap.m.OverflowToolbarButton",multiple:false},_cancelButton:{type:"sap.m.Button",multiple:false}},events:{search:{parameters:{query:{type:"string"},clearButtonPressed:{type:"boolean"}}},liveChange:{parameters:{newValue:{type:"string"}}},suggest:{parameters:{suggestValue:{type:"string"}}}}},
renderer:S
});
e.prototype.init=function(){this._sOldValue="";this._shouldFocusSearch=false;this._layoutDataWhenOpen=new b({priority:d.NeverOverflow});this._layoutDataWhenClosed=new b({priority:d.Low});this._oAcc=new A();};
e.prototype.onBeforeRendering=function(){this._switchOpenStateOnSearch();};
e.prototype.onAfterRendering=function(){setTimeout(function(){if(this._shouldFocusSearch){this._getSearchField().getFocusDomRef().focus();this._shouldFocusSearch=false;}}.bind(this),0);};
e.prototype.exit=function(){if(this._layoutDataWhenOpen){this._layoutDataWhenOpen.destroy();}if(this._layoutDataWhenClosed){this._layoutDataWhenClosed.destroy();}};
e.prototype._getSearchField=function(){var s=this.getAggregation("_searchField");if(!s){s=new a({showSearchButton:false,search:this._onSearch.bind(this),liveChange:this._onLiveChange.bind(this),suggest:this._onSuggest.bind(this)});this.setAggregation("_searchField",s);}return s;};
e.prototype._getSearchButton=function(){var s=this.getAggregation("_searchButton");if(!s){s=new O({text:"Search",icon:"sap-icon://search",type:c.Transparent,press:this._onPressSearchButtonHandler.bind(this),tooltip:this._oAcc.getEntityTooltip("SEARCH")});this.setAggregation("_searchButton",s);}return s;};
e.prototype._getCancelButton=function(){var o=this.getAggregation("_cancelButton");if(!o){o=new B({text:"Cancel",type:c.Transparent,press:this._onPressCancelButtonHandler.bind(this)});o.addStyleClass("sapFShellBarSearchCancelButton");this.setAggregation("_cancelButton",o);}return o;};
e.prototype.toggleVisibilityOfSearchField=function(){var i=this.getIsOpen();this.setIsOpen(!i);this._shouldFocusSearch=!i;this.fireEvent("_updateVisualState",{isOpen:!i});};
e.prototype._switchOpenStateOnSearch=function(){var L;if(this.getIsOpen()){L=this._layoutDataWhenOpen;}else if(!this._bInOverflow){L=this._layoutDataWhenClosed;}if(!L||this.getLayoutData()===L){return;}this.toggleStyleClass("sapFShellBarSearchOpenTick",this.getIsOpen());this.setLayoutData(L);};
e.prototype._onPressSearchButtonHandler=function(){var s=this._getSearchField();if(s.getValue()&&this.getIsOpen()){this.fireSearch({query:s.getValue(),clearButtonPressed:false});}else{this.toggleVisibilityOfSearchField();}};
e.prototype._onPressCancelButtonHandler=function(){this.toggleVisibilityOfSearchField();};
e.prototype._onSearch=function(E){var n=E.getParameters();n.id=this.getId();if(E.getParameter("clearButtonPressed")){this._shouldCloseOnNextEscape=false;}this.fireSearch(n);};
e.prototype._onLiveChange=function(E){var n=E.getParameters();delete n.refreshButtonPressed;delete n.suggestionItem;n.id=this.getId();this._shouldCloseOnNextEscape=!n.newValue;this.fireLiveChange(n);};
e.prototype._onSuggest=function(E){var n=E.getParameters();n.id=this.getId();this.fireSuggest(n);};
e.prototype.onkeyup=function(E){var s=this._getSearchField();if(E.keyCode===K.ESCAPE){if(s._oSuggest&&s._oSuggest.isOpen()){return;}if(this._shouldCloseOnNextEscape){this._shouldCloseOnNextEscape=false;return;}this.toggleVisibilityOfSearchField();}};
e.prototype._onBeforeEnterOverflow=function(){var s=this._getSearchButton();this._bInOverflow=true;s._bInOverflow=true;s.addStyleClass("sapFShellBarSearchOverflowToolbar");this._switchOpenStateOnSearch();};
e.prototype._onAfterExitOverflow=function(){var s=this._getSearchButton();this._bInOverflow=false;s._bInOverflow=false;s.removeStyleClass("sapFShellBarSearchOverflowToolbar");};
e.prototype.getOverflowToolbarConfig=function(){var o={canOverflow:true};o.onBeforeEnterOverflow=this._onBeforeEnterOverflow.bind(this);o.onAfterExitOverflow=this._onAfterExitOverflow.bind(this);return o;};
return e;});
sap.ui.predefine('sap/f/shellBar/SearchRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,s){var o=s._getSearchField(),c=s._getCancelButton(),a=s._getSearchButton(),i=s.getIsOpen(),p=s.getPhoneMode();r.openStart("div",s);if(i){r.class("sapFShellBarSearch");}if(p){r.class("sapFShellBarSearchFullWidth");}r.openEnd();r.openStart("div");r.class("sapFShellBarSearchWrap");r.openEnd();if(i){r.renderControl(o);}r.renderControl(a);if(i){r.renderControl(c);}r.close("div");r.close("div");};
return S;},true);
sap.ui.require.preload({
	"sap/f/manifest.json":'{"_version":"1.21.0","sap.app":{"id":"sap.f","type":"library","embeds":[],"applicationVersion":{"version":"1.98.0"},"title":"SAPUI5 library with Fiori controls.","description":"SAPUI5 library with Fiori controls.","ach":"CA-UI5-CTR","resources":"resources.json","offline":true},"sap.ui":{"technology":"UI5","supportedThemes":["base","sap_hcb"]},"sap.ui5":{"dependencies":{"minUI5Version":"1.98","libs":{"sap.ui.core":{"minVersion":"1.98.0"},"sap.ui.layout":{"minVersion":"1.98.0"},"sap.m":{"minVersion":"1.98.0"}}},"library":{"i18n":{"bundleUrl":"messagebundle.properties","supportedLocales":["","ar","bg","ca","cs","cy","da","de","el","en","en-GB","en-US-sappsd","en-US-saprigi","en-US-saptrc","es","es-MX","et","fi","fr","fr-CA","hi","hr","hu","id","it","iw","ja","kk","ko","lt","lv","ms","nl","no","pl","pt","pt-PT","ro","ru","sh","sk","sl","sv","th","tr","uk","vi","zh-CN","zh-TW"]},"content":{"controls":["sap.f.Avatar","sap.f.AvatarGroup","sap.f.AvatarGroupItem","sap.f.cards.Header","sap.f.cards.NumericHeader","sap.f.cards.NumericIndicators","sap.f.cards.NumericSideIndicator","sap.f.CalendarInCard","sap.f.Card","sap.f.GridContainer","sap.f.DynamicPage","sap.f.DynamicPageHeader","sap.f.DynamicPageTitle","sap.f.IllustratedMessage","sap.f.FlexibleColumnLayout","sap.f.semantic.SemanticPage","sap.f.GridList","sap.f.GridListItem","sap.f.PlanningCalendarInCardLegend","sap.f.ProductSwitch","sap.f.ProductSwitchItem","sap.f.ShellBar","sap.f.Illustration"],"elements":["sap.f.DynamicPageAccessibleLandmarkInfo","sap.f.GridContainerItemLayoutData","sap.f.FlexibleColumnLayoutAccessibleLandmarkInfo","sap.f.semantic.AddAction","sap.f.semantic.CloseAction","sap.f.semantic.CopyAction","sap.f.semantic.DeleteAction","sap.f.semantic.DiscussInJamAction","sap.f.semantic.EditAction","sap.f.semantic.ExitFullScreenAction","sap.f.semantic.FavoriteAction","sap.f.semantic.FlagAction","sap.f.semantic.FooterMainAction","sap.f.semantic.FullScreenAction","sap.f.semantic.MainAction","sap.f.semantic.MessagesIndicator","sap.f.semantic.NegativeAction","sap.f.semantic.PositiveAction","sap.f.semantic.PrintAction","sap.f.semantic.SemanticButton","sap.f.semantic.SemanticControl","sap.f.semantic.SemanticToggleButton","sap.f.semantic.SendEmailAction","sap.f.semantic.SendMessageAction","sap.f.semantic.ShareInJamAction","sap.f.semantic.TitleMainAction","sap.f.SearchManager"],"types":["sap.f.AvatarImageFitType","sap.f.AvatarShape","sap.f.AvatarSize","sap.f.AvatarType","sap.f.AvatarColor","sap.f.AvatarGroupType","sap.f.cards.HeaderPosition","sap.f.cards.NumericHeaderSideIndicatorsAlignment","sap.f.DynamicPageTitleArea","sap.f.DynamicPageTitleShrinkRatio","sap.f.IllustratedMessageSize","sap.f.IllustratedMessageType","sap.f.LayoutType"],"interfaces":["sap.f.cards.IHeader","sap.f.ICard","sap.f.IShellBar","sap.f.IDynamicPageStickyContent","sap.f.dnd.IGridDroppable"]}}}}'
},"sap/f/library-preload"
);
//# sourceMappingURL=library-preload.js.map