//@ui5-bundle sap/m/library-preload.js
/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/m/ColumnHeaderPopover',['sap/ui/core/Control','sap/m/Toolbar','sap/m/Button','sap/m/ResponsivePopover','sap/m/ToolbarSpacer','sap/ui/dom/containsOrEquals'],function(C,T,B,R,a,c){"use strict";
var b=C.extend("sap.m.ColumnHeaderPopover",{
metadata:{library:"sap.m",properties:{},aggregations:{items:{type:"sap.m.ColumnPopoverItem",multiple:true,singularName:"item",bindable:true},_popover:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"}},defaultAggregation:"items",associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}},
renderer:null
});
b.prototype.init=function(){this._bPopoverCreated=false;this._oShownCustomContent=null;var t=this;this._minWidthDelegate=function(){this.$().css("min-width",t.minWidth);};};
b.prototype.exit=function(){if(this._oToolbar){this._oToolbar.destroy();this._oToolbar=null;}this._closeBtn=null;this._spacer=null;this._aButtons=null;this._oShownCustomContent=null;};
b.prototype._createPopover=function(){var t=this;this._oShownCustomContent=null;var o=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s=o.getText("COLUMNHEADERPOPOVER_CLOSE_BUTTON");var p=new R(this.getId()+"-popover",{showArrow:false,showHeader:false,placement:"Bottom",verticalScrolling:true,horizontalScrolling:false,ariaLabelledBy:this.getAriaLabelledBy(),beforeClose:function(e){if(t._oShownCustomContent){t._oShownCustomContent.setVisible(false);t._oShownCustomContent=null;}t._cleanSelection();}});p._oControl.addDelegate({"onAfterRendering":this._minWidthDelegate},p._oControl);this.setAggregation("_popover",p);var d=new T(this.getId()+"-tb");this._spacer=new a();this._closeBtn=new B(d.getId()+"-closeBtn",{type:"Transparent",icon:"sap-icon://decline",tooltip:s,press:[p.close,p]});d.addContent(this._spacer);d.addContent(this._closeBtn);p.addContent(d);this._oToolbar=d;};
b.prototype._cleanSelection=function(o){var d=this._aButtons;if(d){d.forEach(function(e){if((!o||e!==o)&&e.getPressed&&e.getPressed()){e.setPressed(false);}});}};
b.prototype.openBy=function(o){if(!this._bPopoverCreated){this._createPopover();this._bPopoverCreated=true;}else{this._oToolbar.removeContent(this._spacer);this._oToolbar.removeContent(this._closeBtn);this._oToolbar.destroyContent();}var p=this.getAggregation("_popover");var d=[];var I=this.getItems();var m=5;for(var i=0;(i<I.length)&&(d.length<m);i++){var e=I[i];if(e.getVisible()){var f=e._createButton(this._oToolbar.getId()+"-btn_"+i,this);f._sContentId=e._sContentId;d.push(f);this._oToolbar.insertContent(f,i);}}if(d.length===0){return;}this._aButtons=d;this._oToolbar.addContent(this._spacer);this._oToolbar.addContent(this._closeBtn);if(!this._bAppendedToUIArea&&!this.getParent()){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.addContent(this,true);this._bAppendedToUIArea=true;}var O=o.getFocusDomRef();if(O){p.setOffsetY(-O.clientHeight);this.minWidth=O.clientWidth;}p.openBy(o);};
b.prototype.invalidate=function(o){var p=this.getAggregation("_popover");if(o===p){C.prototype.invalidate.apply(this,arguments);}return this;};
b.prototype.addAriaLabelledBy=function(i){var r=this.getAggregation("_popover");if(r){r.addAriaLabelledBy(i);}return this.addAssociation("ariaLabelledBy",i);};
b.prototype.removeAriaLabelledBy=function(o){var r=this.getAggregation("_popover");if(r){r.removeAriaLabelledBy(o);}return this.removeAssociation("ariaLabelledBy",o);};
b.prototype.removeAllAssociation=function(A,s){if(A==="ariaLabelledBy"){var r=this.getAggregation("_popover");if(r){r.removeAllAssociation(A,s);}}return C.prototype.removeAllAssociation.apply(this,arguments);};
return b;});
sap.ui.predefine('sap/m/ColumnPopoverActionItem',['./ColumnPopoverItem','sap/m/Button'],function(C,B){"use strict";
var a=C.extend("sap.m.ColumnPopoverActionItem",{metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null}},events:{press:{}}}});
a.prototype._createButton=function(i,c){return new B(i,{icon:this.getIcon(),type:"Transparent",tooltip:this.getText(),visible:this.getVisible(),press:[function(e){if(c._oShownCustomContent){c._oShownCustomContent.setVisible(false);c._oShownCustomContent=null;c._cleanSelection(this);}var p=c.getAggregation("_popover");p.close();this.firePress();},this]});};
return a;});
sap.ui.predefine('sap/m/ColumnPopoverCustomItem',['./ColumnPopoverItem','sap/m/ToggleButton'],function(C,T){"use strict";
var a=C.extend("sap.m.ColumnPopoverCustomItem",{metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:false,singularName:"content"}},events:{beforeShowContent:{}}}});
a.prototype._createButton=function(i,c){var p=c.getAggregation("_popover");var o=this.getContent();if(o){o.setVisible(false);this._sContentId=o.sId;}p.addContent(o);var t=this;return new T(i,{icon:this.getIcon(),type:"Transparent",tooltip:this.getText(),visible:this.getVisible(),press:function(){if(c._oShownCustomContent){c._oShownCustomContent.setVisible(false);}if(this.getPressed()){c._cleanSelection(this);t.fireBeforeShowContent();if(o){o.setVisible(true);c._oShownCustomContent=o;}}else if(o){o.setVisible(false);c._oShownCustomContent=null;}}});};
return a;});
sap.ui.predefine('sap/m/ColumnPopoverItem',['sap/ui/core/Element'],function(E){"use strict";
var C=E.extend("sap.m.ColumnPopoverItem",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Misc",defaultValue:true}}}});
C.prototype._createButton=function(){throw new Error('Abstract function _create Button must be implemented in your Item (that extends this abstract object).');};
return C;});
sap.ui.predefine('sap/m/ColumnPopoverSelectListItem',['sap/ui/core/Core','./ColumnPopoverItem','sap/m/ToggleButton','sap/m/Button','sap/m/StandardListItem','sap/m/List'],function(C,a,T,B,S,L){"use strict";
var b=a.extend("sap.m.ColumnPopoverSelectListItem",{
library:"sap.m",
metadata:{properties:{label:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null}},events:{action:{parameters:{property:{type:"string"}}}},aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:true}}}
});
b.prototype._createButton=function(I,c){var t=this.getLabel(),d=this.getItems(),e=this;if(d.length>1){var p=c.getAggregation("_popover");var l=new L();for(var i=0;i<d.length;i++){var o=new S({title:d[i].getText(),type:"Active"});l.addItem(o);o.data("key",d[i].getKey());}l.attachEvent("itemPress",function(E){p.close();var o=E.getParameter("listItem");e.fireAction({property:o.data("key")});});l.setVisible(false);p.addContent(l);return new T(I,{icon:this.getIcon(),type:"Transparent",tooltip:t,visible:this.getVisible(),press:function(){if(c._oShownCustomContent){c._oShownCustomContent.setVisible(false);}if(this.getPressed()){c._cleanSelection(this);if(l){l.setVisible(true);c._oShownCustomContent=l;}}else if(l){l.setVisible(false);c._oShownCustomContent=null;}}});}else{return new B(I,{icon:this.getIcon(),type:"Transparent",tooltip:t,visible:this.getVisible(),press:function(){var p=c.getAggregation("_popover");if(c._oShownCustomContent){c._oShownCustomContent.setVisible(false);c._oShownCustomContent=null;c._cleanSelection(this);}p.close();e.fireAction({property:d[0]?d[0].getKey():null});}});}};
return b;});
sap.ui.predefine('sap/m/ColumnPopoverSortItem',['sap/ui/core/Core','./ColumnPopoverItem','sap/m/ToggleButton','sap/m/Button','sap/m/StandardListItem','sap/m/List'],function(C,a,T,B,S,L){"use strict";
var b=a.extend("sap.m.ColumnPopoverSortItem",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Misc",defaultValue:null}},events:{sort:{parameters:{property:{type:"string"}}}},aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:true}}}});
b.prototype._createButton=function(I,c){var o=C.getLibraryResourceBundle("sap.m"),s=o.getText("COLUMNHEADERPOPOVER_SORT_BUTTON"),d=this.getItems(),t=this;if(d.length>1){var p=c.getAggregation("_popover");var l=new L();for(var i=0;i<d.length;i++){var e=new S({title:d[i].getText(),type:"Active"});l.addItem(e);e.data("key",d[i].getKey());}l.attachEvent("itemPress",function(E){p.close();var e=E.getParameter("listItem");t.fireSort({property:e.data("key")});});l.setVisible(false);p.addContent(l);return new T(I,{icon:"sap-icon://sort",type:"Transparent",tooltip:s,visible:this.getVisible(),press:function(){if(c._oShownCustomContent){c._oShownCustomContent.setVisible(false);}if(this.getPressed()){c._cleanSelection(this);if(l){l.setVisible(true);c._oShownCustomContent=l;}}else if(l){l.setVisible(false);c._oShownCustomContent=null;}}});}else{return new B(I,{icon:"sap-icon://sort",type:"Transparent",tooltip:s,visible:this.getVisible(),press:function(){var p=c.getAggregation("_popover");if(c._oShownCustomContent){c._oShownCustomContent.setVisible(false);c._oShownCustomContent=null;c._cleanSelection(this);}p.close();t.fireSort({property:d[0]?d[0].getKey():null});}});}};
return b;});
sap.ui.predefine('sap/m/CustomTreeItem',['./TreeItemBase','./ListItemBase','./library',"./CustomTreeItemRenderer"],function(T,L,l,C){"use strict";
var a=T.extend("sap.m.CustomTreeItem",{metadata:{library:"sap.m",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}}}});
a.prototype.getContentAnnouncement=function(){return this.getContent().map(function(c){return L.getAccessibilityText(c);}).join(" ").trim();};
return a;});
sap.ui.predefine('sap/m/CustomTreeItemRenderer',['./TreeItemBaseRenderer','sap/ui/core/Renderer'],function(T,R){"use strict";var C=R.extend(T);C.apiVersion=2;
C.renderLIAttributes=function(r,l){r.class("sapMCTI");T.renderLIAttributes.apply(this,arguments);};
C.renderLIContent=function(r,l){l.getContent().forEach(function(c){r.renderControl(c);});};
return C;},true);
sap.ui.predefine('sap/m/OverflowToolbarAssociativePopoverRenderer',['./PopoverRenderer','sap/ui/core/Renderer'],function(P,R){"use strict";var O=R.extend(P);O.apiVersion=2;return O;},true);
sap.ui.predefine('sap/m/P13nAnyFilterItem',['./library','sap/m/P13nFilterItem'],function(l,P){"use strict";
var a=P.extend("sap.m.P13nAnyFilterItem",{metadata:{library:"sap.m",properties:{value1:{type:"any",group:"Misc",defaultValue:null},value2:{type:"any",group:"Misc",defaultValue:null}}}});
return a;});
sap.ui.predefine('sap/m/P13nColumnsItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nColumnsItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string",group:"Misc"},index:{type:"int",group:"Appearance"},visible:{type:"boolean",group:"Appearance"},width:{type:"string",group:"Misc"},total:{type:"boolean"}}}});
return P;});
sap.ui.predefine('sap/m/P13nColumnsPanel',['sap/ui/core/library','sap/ui/model/ChangeReason','sap/ui/model/json/JSONModel','sap/ui/model/BindingMode','sap/ui/core/IconPool','./library','./Table','./Column','./ColumnListItem','./P13nPanel','./P13nColumnsItem','./SearchField','./Text','./Button','./OverflowToolbar','./OverflowToolbarLayoutData','./OverflowToolbarButton','./ToolbarSpacer',"sap/ui/thirdparty/jquery"],function(C,c,J,B,I,l,T,d,e,P,f,S,g,h,O,i,j,k,q){"use strict";var m=l.OverflowToolbarPriority;var n=l.ButtonType;var o=l.ToolbarDesign;var L=l.ListType;var p=l.ListMode;var r=l.P13nPanelType;var s=l.Sticky;
var t=P.extend("sap.m.P13nColumnsPanel",{
metadata:{deprecated:true,library:"sap.m",properties:{visibleItemsThreshold:{type:"int",group:"Behavior",defaultValue:-1}},aggregations:{columnsItems:{type:"sap.m.P13nColumnsItem",multiple:true,singularName:"columnsItem",bindable:"bindable"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"}},events:{addColumnsItem:{deprecated:true,parameters:{newItem:{type:"sap.m.P13nColumnsItem"}}},changeColumnsItems:{parameters:{newItems:{type:"sap.m.P13nColumnsItem[]"},existingItems:{type:"sap.m.P13nColumnsItem[]"},items:{type:"object[]"}}},setData:{deprecated:true}}},
renderer:{apiVersion:2,render:function(R,a){R.openStart("div",a);R.class("sapMP13nColumnsPanel");R.openEnd();a.getAggregation("content").forEach(function(b){R.renderControl(b);});R.close("div");}}
});
t.prototype.init=function(){this._iLiveChangeTimer=0;this._iSearchTimer=0;this._bIgnoreUpdateInternalModel=false;this._bUpdateInternalModel=true;this._bTableItemsChanged=false;var M=new J({items:[],columnKeyOfMarkedItem:undefined,isMoveDownButtonEnabled:undefined,isMoveUpButtonEnabled:undefined,showOnlySelectedItems:undefined,countOfSelectedItems:0,countOfItems:0});M.setDefaultBindingMode(B.TwoWay);M.setSizeLimit(1000);this.setModel(M,"$sapmP13nColumnsPanel");this.setType(r.columns);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("COLUMSPANEL_TITLE"));this._createTable();this._oTable.setHeaderToolbar(this._createToolbar());this.addAggregation("content",this._oTable);};
t.prototype.reInitialize=function(){};
t.prototype.onBeforeRendering=function(){this._updateInternalModel();if(!this._getInternalModel().getProperty("/columnKeyOfMarkedItem")){this._setColumnKeyOfMarkedItem(this._getColumnKeyByTableItem(this._getVisibleTableItems()[0]));}this._switchMarkedTableItemTo(this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem")));this._updateControlLogic();};
t.prototype.getOkPayload=function(){this._updateInternalModel();var M=this._getInternalModel().getProperty("/items");return{tableItems:M.map(function(a){return{columnKey:a.columnKey,index:a.persistentIndex===-1?undefined:a.persistentIndex,visible:a.persistentSelected,width:a.width};}),tableItemsChanged:this._bTableItemsChanged,selectedItems:M.filter(function(a){return a.persistentSelected;}).map(function(a){return{columnKey:a.columnKey};})};};
t.prototype.getResetPayload=function(){return{oPanel:this};};
t.prototype.exit=function(){this._getToolbar().destroy();this._oTable.destroy();this._oTable=null;if(this._getInternalModel()){this._getInternalModel().destroy();}window.clearTimeout(this._iLiveChangeTimer);window.clearTimeout(this._iSearchTimer);};
t.prototype.addItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("items",a);return this;};
t.prototype.insertItem=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("items",a,b);return this;};
t.prototype.removeItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}a=this.removeAggregation("items",a);return a;};
t.prototype.removeAllItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("items");};
t.prototype.destroyItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("items");return this;};
t.prototype.addColumnsItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("columnsItems",a);return this;};
t.prototype.insertColumnsItem=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("columnsItems",a,b);return this;};
t.prototype.updateColumnsItems=function(R){this.updateAggregation("columnsItems");if(R===c.Change&&!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}};
t.prototype.removeColumnsItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("columnsItems",a);};
t.prototype.removeAllColumnsItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("columnsItems");};
t.prototype.destroyColumnsItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("columnsItems");return this;};
t.prototype.onBeforeNavigationFrom=function(){var M=this._getSelectedModelItems();var v=this.getVisibleItemsThreshold();return!(M&&v!==-1&&M.length>v);};
t.prototype._notifyChange=function(){this._bTableItemsChanged=true;var a=this.getChangeNotifier();if(a){a(this);}};
t.prototype._scrollToSelectedItem=function(a){if(!a){return;}sap.ui.getCore().applyChanges();};
t.prototype._getInternalModel=function(){return this.getModel("$sapmP13nColumnsPanel");};
t.prototype._createTable=function(){this._oTable=new T({mode:p.MultiSelect,rememberSelections:false,sticky:[s.ColumnHeaders,s.HeaderToolbar],itemPress:q.proxy(this._onItemPressed,this),selectionChange:q.proxy(this._onSelectionChange,this),columns:[new d({vAlign:C.VerticalAlign.Middle,header:new g({text:{parts:[{path:'/countOfSelectedItems'},{path:'/countOfItems'}],formatter:function(a,b){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText('COLUMNSPANEL_SELECT_ALL_WITH_COUNTER',[a,b]);}}})})],items:{path:"/items",templateShareable:false,template:new e({cells:[new g({text:"{text}"})],visible:"{visible}",selected:"{persistentSelected}",tooltip:"{tooltip}",type:L.Active})}});this._oTable.setModel(this._getInternalModel());};
t.prototype._createToolbar=function(){var a=this;var R=sap.ui.getCore().getLibraryResourceBundle("sap.m");var b=new O(this.getId()+"-toolbar",{design:o.Auto,content:[new k(),new S(this.getId()+"-searchField",{liveChange:function(E){var v=E.getSource().getValue(),D=(v?300:0);window.clearTimeout(a._iSearchTimer);if(D){a._iSearchTimer=window.setTimeout(function(){a._onExecuteSearch();},D);}else{a._onExecuteSearch();}},search:q.proxy(this._onExecuteSearch,this),layoutData:new i({minWidth:"12.5rem",maxWidth:"23.077rem",shrinkable:true,moveToOverflow:false,stayInOverflow:false})}),new h(this.getId()+"-showSelected",{text:{path:'/showOnlySelectedItems',formatter:function(u){return u?R.getText('COLUMNSPANEL_SHOW_ALL'):R.getText('COLUMNSPANEL_SHOW_SELECTED');}},type:n.Transparent,press:q.proxy(this._onSwitchButtonShowSelected,this),layoutData:new i({moveToOverflow:true,priority:m.High})}),new j({icon:I.getIconURI("collapse-group"),text:R.getText('COLUMNSPANEL_MOVE_TO_TOP'),tooltip:R.getText('COLUMNSPANEL_MOVE_TO_TOP'),type:n.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:q.proxy(this.onPressButtonMoveToTop,this),layoutData:new i({moveToOverflow:true,priority:m.Low,group:2})}),new j({icon:I.getIconURI("navigation-up-arrow"),text:R.getText('COLUMNSPANEL_MOVE_UP'),tooltip:R.getText('COLUMNSPANEL_MOVE_UP'),type:n.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:q.proxy(this.onPressButtonMoveUp,this),layoutData:new i({moveToOverflow:true,priority:m.High,group:1})}),new j({icon:I.getIconURI("navigation-down-arrow"),text:R.getText('COLUMNSPANEL_MOVE_DOWN'),tooltip:R.getText('COLUMNSPANEL_MOVE_DOWN'),type:n.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:q.proxy(this.onPressButtonMoveDown,this),layoutData:new i({moveToOverflow:true,priority:m.High,group:1})}),new j({icon:I.getIconURI("expand-group"),text:R.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),tooltip:R.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),type:n.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:q.proxy(this.onPressButtonMoveToBottom,this),layoutData:new i({moveToOverflow:true,priority:m.Low,group:2})})]});b.setModel(this._getInternalModel());return b;};
t.prototype.onPressButtonMoveToTop=function(){this._moveMarkedTableItem(this._getMarkedTableItem(),this._getVisibleTableItems()[0]);};
t.prototype.onPressButtonMoveUp=function(){var v=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),v[v.indexOf(this._getMarkedTableItem())-1]);};
t.prototype.onPressButtonMoveDown=function(){var v=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),v[v.indexOf(this._getMarkedTableItem())+1]);};
t.prototype.onPressButtonMoveToBottom=function(){var v=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),v[v.length-1]);};
t.prototype._onSwitchButtonShowSelected=function(){this._getInternalModel().setProperty("/showOnlySelectedItems",!this._getInternalModel().getProperty("/showOnlySelectedItems"));this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();};
t.prototype._onExecuteSearch=function(){this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._updateControlLogic();};
t.prototype._switchVisibilityOfUnselectedModelItems=function(){var b=this._isFilteredByShowSelected();var M=this._getInternalModel().getProperty("/items");M.forEach(function(a){if(a.persistentSelected){a.visible=true;return;}a.visible=!b;});this._getInternalModel().setProperty("/items",M);};
t.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
t.prototype._moveMarkedTableItem=function(a,b){var M=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(a));var u=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(b));var v=this._getModelItemIndexByColumnKey(M.columnKey);var w=this._getModelItemIndexByColumnKey(u.columnKey);this._moveModelItems(v,w);this._checkButtonFocus(w);this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();this._fireChangeColumnsItems();this._fireSetData();this._notifyChange();};
t.prototype._checkButtonFocus=function(a){var M=this._oTable.getItems().length-1;if(a===0||a===M){sap.ui.getCore().byId(this.getId()+"-showSelected").focus();}};
t.prototype._moveModelItems=function(a,b){var M=this._getInternalModel().getProperty("/items");if(a<0||b<0||a>M.length-1||b>M.length-1){return false;}this._removeStyleOfMarkedTableItem();var u=M.splice(a,1);M.splice(b,0,u[0]);this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._switchMarkedTableItemTo(this._getMarkedTableItem());return true;};
t.prototype._getModelItemByColumnKey=function(a){var M=this._getInternalModel().getProperty("/items").filter(function(b){return b.columnKey===a;});return M[0];};
t.prototype._updateCounts=function(M){var a=0;var b=0;M.forEach(function(u){a++;if(u.persistentSelected){b++;}});this._getInternalModel().setProperty("/countOfItems",a);this._getInternalModel().setProperty("/countOfSelectedItems",b);};
t.prototype._sortModelItemsByPersistentIndex=function(M){var u;var v;try{v=sap.ui.getCore().getConfiguration().getLocale().toString();if(typeof window.Intl!=='undefined'){u=window.Intl.Collator(v,{numeric:true});}}catch(E){}M.forEach(function(a,b){a.localIndex=b;});M.sort(function(a,b){if(a.persistentSelected===true&&(b.persistentSelected===false||b.persistentSelected===undefined)){return-1;}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&b.persistentSelected===true){return 1;}else if(a.persistentSelected===true&&b.persistentSelected===true){if(a.persistentIndex>-1&&a.persistentIndex<b.persistentIndex){return-1;}else if(b.persistentIndex>-1&&a.persistentIndex>b.persistentIndex){return 1;}else{return a.localIndex-b.localIndex;}}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&(b.persistentSelected===false||b.persistentSelected===undefined)){return u?u.compare(a.text,b.text):a.text.localeCompare(b.text,v,{numeric:true});}});M.forEach(function(a){delete a.localIndex;});};
t.prototype._getColumnKeyByTableItem=function(a){var b=this._oTable.indexOfItem(a);if(b<0){return null;}return this._oTable.getBinding("items").getContexts(undefined,undefined,undefined,true)[b].getObject().columnKey;};
t.prototype._getModelItemIndexByColumnKey=function(a){var b=-1;this._getInternalModel().getProperty("/items").some(function(M,u){if(M.columnKey===a){b=u;return true;}});return b;};
t.prototype._getSelectedModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return M.persistentSelected;});};
t.prototype._getVisibleTableItems=function(){return this._oTable.getItems().filter(function(a){return a.getVisible();});};
t.prototype._getTableItemByColumnKey=function(a){var b=this._oTable.getBinding("items").getContexts(undefined,undefined,undefined,true);var u=this._oTable.getItems().filter(function(v,w){return b[w].getObject().columnKey===a;});return u[0];};
t.prototype._getToolbar=function(){return sap.ui.getCore().byId(this.getId()+"-toolbar")||null;};
t.prototype._getSearchField=function(){return sap.ui.getCore().byId(this.getId()+"-searchField")||null;};
t.prototype._getSearchText=function(){var a=this._getSearchField();return a?a.getValue():"";};
t.prototype._isFilteredBySearchText=function(){return!!this._getSearchText().length;};
t.prototype._isFilteredByShowSelected=function(){return this._getInternalModel().getData().showOnlySelectedItems;};
t.prototype._updateControlLogic=function(){var b=this._isFilteredBySearchText();var a=this._isFilteredByShowSelected();var v=this._getVisibleTableItems();this._getInternalModel().setProperty("/isMoveUpButtonEnabled",v.indexOf(this._getMarkedTableItem())>0);this._getInternalModel().setProperty("/isMoveDownButtonEnabled",v.indexOf(this._getMarkedTableItem())>-1&&v.indexOf(this._getMarkedTableItem())<v.length-1);var u=sap.ui.getCore().byId(this._oTable.getId()+'-sa');if(u){u.setEnabled(!b&&!a);}};
t.prototype._updateModelItemsPersistentIndex=function(M){var a=-1;M.forEach(function(b){b.persistentIndex=-1;if(b.persistentSelected){a++;b.persistentIndex=a;}});};
t.prototype._fireSetData=function(){this._bIgnoreUpdateInternalModel=true;this.fireSetData();this._bIgnoreUpdateInternalModel=false;};
t.prototype._fireChangeColumnsItems=function(){this._bIgnoreUpdateInternalModel=true;var M=this._getInternalModel().getProperty("/items");var E={newItems:[],existingItems:[],items:M.map(function(a){return{columnKey:a.columnKey,visible:a.persistentSelected,index:a.persistentIndex===-1?undefined:a.persistentIndex,width:a.width,total:a.total};})};M.forEach(function(a){var b=this._getColumnsItemByColumnKey(a.columnKey);if(b){b.setVisible(a.persistentSelected);b.setIndex(a.persistentIndex===-1?undefined:a.persistentIndex);if(a.width!==undefined){b.setWidth(a.width);}if(a.total!==undefined){b.setTotal(a.total);}E.existingItems.push(b);}else{E.newItems.push(new f({columnKey:a.columnKey,visible:a.persistentSelected,index:a.persistentIndex===-1?undefined:a.persistentIndex,width:a.width,total:a.total}));}},this);this.fireChangeColumnsItems(E);this._bIgnoreUpdateInternalModel=false;};
t.prototype._getColumnsItemByColumnKey=function(a){var b=this.getColumnsItems().filter(function(u){return u.getColumnKey()===a;});return b[0];};
t.prototype._getMarkedTableItem=function(){return this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem"));};
t.prototype._setColumnKeyOfMarkedItem=function(a){this._getInternalModel().setProperty("/columnKeyOfMarkedItem",a);};
t.prototype._onItemPressed=function(E){this._switchMarkedTableItemTo(E.getParameter('listItem'));this._updateControlLogic();};
t.prototype._onSelectionChange=function(E){if(!E.getParameter("selectAll")&&E.getParameter("listItems").length===1){this._switchMarkedTableItemTo(E.getParameter("listItem"));}this._selectTableItem();};
t.prototype._selectTableItem=function(){this._updateControlLogic();var M=this._getInternalModel().getProperty("/items");this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._fireChangeColumnsItems();this._fireSetData();this._notifyChange();var v=this.getValidationExecutor();if(v){v();}};
t.prototype._switchMarkedTableItemTo=function(a){this._removeStyleOfMarkedTableItem();var b=this._getColumnKeyByTableItem(a);if(b){this._setColumnKeyOfMarkedItem(b);a.addStyleClass("sapMP13nColumnsPanelItemSelected");}};
t.prototype._removeStyleOfMarkedTableItem=function(){if(this._getMarkedTableItem()){this._getMarkedTableItem().removeStyleClass("sapMP13nColumnsPanelItemSelected");}};
t.prototype._filterModelItemsBySearchText=function(){var a=this._getSearchText();a=a.replace(/(^\s+)|(\s+$)/g,'');a=a.replace(/[-\/\\^$*+?.()|[\]{}]/g,'\\$&');var R=new RegExp(a,'igm');if(!R){return;}this._getVisibleModelItems().forEach(function(M){M.visible=false;if(typeof M.text==="string"&&M.text.match(R)){M.visible=true;}if(typeof M.tooltip==="string"&&M.tooltip.match(R)){M.visible=true;}});this._getInternalModel().refresh();};
t.prototype._updateInternalModel=function(){if(!this._bUpdateInternalModel){return;}this._bUpdateInternalModel=false;this._removeStyleOfMarkedTableItem();var M=this._getInternalModel().getProperty("/items");this._getInternalModel().setProperty("/items",this.getItems().map(function(b){return{columnKey:b.getColumnKey(),visible:true,text:b.getText(),tooltip:b.getTooltip(),persistentIndex:-1,persistentSelected:b.getVisible(),width:undefined,total:undefined};},this));this.getColumnsItems().forEach(function(b){var u=this._getModelItemByColumnKey(b.getColumnKey());if(!u){return;}if(b.getIndex()!==undefined){u.persistentIndex=b.getIndex();}if(b.getVisible()!==undefined){u.persistentSelected=b.getVisible();}if(b.getWidth()!==undefined){u.width=b.getWidth();}if(b.getTotal()!==undefined){u.total=b.getTotal();}},this);this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();var a=this._getInternalModel().getProperty("/items");this._sortModelItemsByPersistentIndex(a);this._updateCounts(a);this._getInternalModel().setProperty("/items",a);this._switchMarkedTableItemTo(this._getMarkedTableItem());if(q(a).not(M).length!==0||q(M).not(a).length!==0){this._bTableItemsChanged=true;}};
return t;});
sap.ui.predefine('sap/m/P13nConditionPanel',['./library','sap/ui/core/library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/Device','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','sap/ui/core/Item','sap/ui/core/ListItem','sap/ui/model/odata/type/Boolean','sap/ui/model/type/String','sap/ui/model/odata/type/String','sap/ui/model/type/Date','sap/ui/model/type/Time','sap/ui/model/odata/type/DateTime','sap/ui/model/type/Float','sap/ui/layout/library','sap/ui/layout/Grid','sap/ui/layout/GridData','sap/ui/layout/HorizontalLayout','./Button','./OverflowToolbar','./OverflowToolbarLayoutData','./ToolbarSpacer','./Text','./SearchField','./CheckBox','./ComboBox','./Select','./Label','./Input','./DatePicker','./TimePicker','./DateTimePicker','sap/base/Log','sap/ui/thirdparty/jquery','./P13nOperationsHelper','sap/m/P13nConditionPanelRenderer'],function(a,c,C,I,D,b,R,d,L,B,S,e,f,T,g,F,h,G,k,H,m,O,o,q,r,s,t,u,v,x,y,z,A,E,J,Q,P,K){"use strict";var V=c.ValueState;var M=a.ButtonType;var N=a.ToolbarDesign;var U=c.TextAlign;var W=a.OverflowToolbarPriority;var X=a.P13nConditionOperation;
var Y=C.extend("sap.m.P13nConditionPanel",{
metadata:{library:"sap.m",properties:{maxConditions:{type:"string",group:"Misc",defaultValue:'-1'},exclude:{type:"boolean",group:"Misc",defaultValue:false},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},autoAddNewRow:{type:"boolean",group:"Misc",defaultValue:false},disableFirstRemoveIcon:{type:"boolean",group:"Misc",defaultValue:false},alwaysShowAddIcon:{type:"boolean",group:"Misc",defaultValue:true},usePrevConditionSetting:{type:"boolean",group:"Misc",defaultValue:true},autoReduceKeyFieldItems:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null},showLabel:{type:"boolean",group:"Misc",defaultValue:false},displayFormat:{type:"string",group:"Misc",defaultValue:null},validationExecutor:{type:"object",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"}},events:{dataChange:{}}},
renderer:K.renderer
});
Y.prototype.setConditions=function(j){if(!j){J.error("sap.m.P13nConditionPanel : aCondition is not defined");}if(this._bIgnoreSetConditions){return;}this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;for(var i=0;i<j.length;i++){this._addCondition2Map(j[i]);}this._clearConditions();this._fillConditions();};
Y.prototype.removeAllConditions=function(){this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;this._clearConditions();this._fillConditions();};
Y.prototype.addCondition=function(i){if(this._bIgnoreSetConditions){return;}i.index=this._iConditions;this._addCondition2Map(i);this._addCondition(i);};
Y.prototype.insertCondition=function(i,j){if(this._bIgnoreSetConditions){return;}if(j!==undefined){i.index=j;}this._addCondition2Map(i);this._addCondition(i);};
Y.prototype.removeCondition=function(i){this._clearConditions();if(typeof i=="string"){this._removeConditionFromMap(i);}if(typeof i=="object"){this._removeConditionFromMap(i.key);}this._fillConditions();};
Y.prototype._addCondition2Map=function(i){if(!i.key){i.key="condition_"+this._iConditions;if(this.getExclude()){i.key="x"+i.key;}}this._iConditions++;this._oConditionsMap[i.key]=i;this._aConditionKeys.push(i.key);};
Y.prototype._removeConditionFromMap=function(j){this._iConditions--;delete this._oConditionsMap[j];var i=this._aConditionKeys.indexOf(j);if(i>=0){this._aConditionKeys.splice(i,1);}};
Y.prototype.getConditions=function(){var i;var j=[];if(this._oConditionsMap){for(var l in this._oConditionsMap){i=this._oConditionsMap[l];var n=i.value;if(!n){n=this._getFormatedConditionText(i.operation,i.value1,i.value2,i.exclude,i.keyField,i.showIfGrouped);}if(!i._oGrid||i._oGrid.select.getSelected()){j.push({"key":l,"text":n,"exclude":i.exclude,"operation":i.operation,"keyField":i.keyField,"value1":i.value1,"value2":this._hasSecondValue(i.operation)?i.value2:null,"showIfGrouped":i.showIfGrouped});}}}return j;};
Y.prototype.setOperations=function(i,j){j=j||"default";this._oTypeOperations[j]=i;this._updateAllOperations();};
Y.prototype.setValues=function(i,j){j=j||"default";this._oTypeValues[j]=i;};
Y.prototype.addOperation=function(i,j){j=j||"default";this._oTypeOperations[j].push(i);this._updateAllOperations();};
Y.prototype.removeAllOperations=function(i){i=i||"default";this._oTypeOperations[i]=[];this._updateAllOperations();};
Y.prototype.getOperations=function(i){i=i||"default";return this._oTypeOperations[i];};
Y.prototype.setKeyFields=function(i){this._aKeyFields=i;this._aKeyFields.forEach(function(j){Y._createKeyFieldTypeInstance(j);},this);this._updateKeyFieldItems(this._oConditionsGrid,true);this._updateAllConditionsEnableStates();this._createAndUpdateAllKeyFields();this._updateAllOperations();};
Y.prototype.addKeyField=function(i){this._aKeyFields.push(i);Y._createKeyFieldTypeInstance(i);this._updateKeyFieldItems(this._oConditionsGrid,true,true);this._updateAllConditionsEnableStates();this._createAndUpdateAllKeyFields();this._updateAllOperations();};
Y._createKeyFieldTypeInstance=function(i){var j;if(!i.typeInstance){switch(i.type){case"boolean":i.typeInstance=new B();break;case"numc":if(!(i.formatSettings&&i.formatSettings.isDigitSequence)){J.error("sap.m.P13nConditionPanel","NUMC type support requires isDigitSequence==true!");i.formatSettings=Object.assign({},i.formatSettings,{isDigitSequence:true});}j=i.formatSettings;if(i.maxLength){j=Object.assign({},j,{maxLength:i.maxLength});}if(!j.maxLength){J.error("sap.m.P13nConditionPanel","NUMC type suppport requires maxLength!");}i.typeInstance=new e({},j);break;case"date":i.typeInstance=new f(Object.assign({},i.formatSettings,{strictParsing:true}),{});break;case"time":i.typeInstance=new T(Object.assign({},i.formatSettings,{strictParsing:true}),{});break;case"datetime":i.typeInstance=new g(Object.assign({},i.formatSettings,{strictParsing:true}),{displayFormat:"Date"});var n=i.typeInstance;if(!n.oFormat){n.formatValue(new Date(),"string");}if(n.oFormat){n.oFormat.oFormatOptions.UTC=false;}break;case"numeric":if(i.precision||i.scale){j={};if(i.precision){j["maxIntegerDigits"]=parseInt(i.precision);}if(i.scale){j["maxFractionDigits"]=parseInt(i.scale);}}i.typeInstance=new F(j);break;default:var l=i.formatSettings;if(i.maxLength){l=Object.assign({},l,{maxLength:i.maxLength});}i.typeInstance=new S({},l);break;}}};
Y.prototype.removeAllKeyFields=function(){this._aKeyFields=[];this._updateKeyFieldItems(this._oConditionsGrid,true);};
Y.prototype.getKeyFields=function(){return this._aKeyFields;};
Y.prototype.setAlwaysShowAddIcon=function(i){this.setProperty("alwaysShowAddIcon",i);if(this._oConditionsGrid){this._oConditionsGrid.toggleStyleClass("conditionRootGrid",this.getLayoutMode()!=="Desktop");}return this;};
Y.prototype.setLayoutMode=function(l){this.setProperty("layoutMode",l);if(this._oConditionsGrid){this._oConditionsGrid.toggleStyleClass("conditionRootGrid",l!=="Desktop");}this._updateConditionFieldSpans(l);this._clearConditions();this._fillConditions();return this;};
Y.prototype.setContainerQuery=function(i){this._unregisterResizeHandler();this.setProperty("containerQuery",i);this._registerResizeHandler();this._clearConditions();this._fillConditions();return this;};
Y.prototype._updateConditionFieldSpans=function(i){if(this._aConditionsFields){var j=i==="Desktop";if(j){this._aConditionsFields[2].SpanFilter="L3 M3 S3";this._aConditionsFields[4].SpanFilter="L2 M2 S2";this._aConditionsFields[5].SpanFilter="L3 M3 S3";this._aConditionsFields[6].SpanFilter="L2 M2 S2";this._aConditionsFields[7].SpanFilter="L1 M1 S1";}var l=i==="Tablet";if(l){this._aConditionsFields[2].SpanFilter="L5 M5 S5";this._aConditionsFields[4].SpanFilter="L5 M5 S5";this._aConditionsFields[5].SpanFilter="L10 M10 S10";this._aConditionsFields[6].SpanFilter="L10 M10 S10";this._aConditionsFields[7].SpanFilter="L1 M1 S1";}}};
Y.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sFromLabelText=this._oRb.getText("CONDITIONPANEL_LABELFROM");this._sToLabelText=this._oRb.getText("CONDITIONPANEL_LABELTO");this._sValueLabelText=this._oRb.getText("CONDITIONPANEL_LABELVALUE");this._sShowIfGroupedLabelText=this._oRb.getText("CONDITIONPANEL_LABELGROUPING");this._sValidationDialogFieldMessage=this._oRb.getText("CONDITIONPANEL_FIELDMESSAGE");this._oOperationsHelper=new P();this._oTypeOperations={"default":[]};this._oTypeValues={"default":[]};this._aKeyFields=[];this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;this._sLayoutMode="Desktop";this._sConditionType="Filter";this._sAddRemoveIconTooltip="FILTER";this._iBreakPointTablet=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD].points[0];this._iBreakPointDesktop=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD].points[1];this._oConditionsGrid=new G({width:"100%",defaultSpan:"L12 M12 S12",hSpacing:0,vSpacing:0}).toggleStyleClass("conditionRootGrid",this.getLayoutMode()!=="Desktop");this._oConditionsGrid.addStyleClass("sapUiRespGridOverflowHidden");this._iFirstConditionIndex=0;this._iConditionPageSize=10;this._oInvisibleTextField=new b({text:this._oRb.getText("CONDITIONPANEL_FIELD_LABEL")});this._oInvisibleTextOperatorInputValue=new b({text:this._oRb.getText("CONDITIONPANEL_FIELD_VALUE_ARIA_LABEL")});this._oInvisibleTextOperator=new b({text:this._oRb.getText("CONDITIONPANEL_OPERATOR_ARIA_LABEL")});this._oInvisibleTextOperatorAddButton=new b({text:this._oRb.getText("CONDITIONPANEL_ADD_SCREENREADER_DESCRIPTION")});this.addAggregation("content",this._oInvisibleTextField);this.addAggregation("content",this._oInvisibleTextOperatorInputValue);this.addAggregation("content",this._oInvisibleTextOperator);this.addAggregation("content",this._oInvisibleTextOperatorAddButton);this.addAggregation("content",this._oConditionsGrid);this._registerResizeHandler();this._aConditionsFields=this._createConditionsFields();this._oButtonGroupSpan={"SpanFilter":"L2 M2 S2","SpanSort":D.system.phone?"L2 M2 S4":"L2 M2 S3","SpanGroup":"L2 M2 S3"};this._updateConditionFieldSpans(this.getLayoutMode());this._fillConditions();};
Y.prototype._createPaginatorToolbar=function(){this._bPaginatorButtonsVisible=false;var i=this;this._oPrevButton=new m({icon:I.getIconURI("navigation-left-arrow"),tooltip:this._oRb.getText("WIZARD_FINISH"),visible:true,press:function(j){i._iFirstConditionIndex=Math.max(0,i._iFirstConditionIndex-i._iConditionPageSize);i._clearConditions();i._fillConditions();},layoutData:new o({priority:W.NeverOverflow})});this._oNextButton=new m({icon:I.getIconURI("navigation-right-arrow"),tooltip:this._oRb.getText("WIZARD_NEXT"),visible:true,press:function(j){i._iFirstConditionIndex+=i._iConditionPageSize;i._clearConditions();i._fillConditions();},layoutData:new o({priority:W.NeverOverflow})});this._oRemoveAllButton=new m({text:this._oRb.getText("CONDITIONPANEL_REMOVE_ALL"),visible:true,press:function(j){i._aConditionKeys.forEach(function(l,n){if(n>=0){this.fireDataChange({key:l,index:n,operation:"remove",newData:null});}},i);this._iFirstConditionIndex=0;i.removeAllConditions();},layoutData:new o({priority:W.Low})});this._oAddButton=new m({icon:I.getIconURI("add"),visible:true,press:function(j){var l=i._createConditionRow(i._oConditionsGrid,undefined,null,0);i._changeField(l);setTimeout(function(){l.keyField.focus();});i._updatePaginatorToolbar();},layoutData:new o({priority:W.Low}),ariaDescribedBy:this._oInvisibleTextOperatorAddButton});this._oHeaderText=new r({wrapping:false,layoutData:new o({priority:W.NeverOverflow})});this._oPageText=new r({wrapping:false,textAlign:U.Center,layoutData:new o({priority:W.NeverOverflow})});this._oFilterField=new s({width:"12rem",layoutData:new o({priority:W.High})});this._oPaginatorToolbar=new O({height:"3rem",design:N.Transparent,content:[this._oHeaderText,new q(),this._oFilterField,this._oPrevButton,this._oPageText,this._oNextButton,this._oRemoveAllButton,this._oAddButton]});};
Y.prototype._updatePaginatorToolbar=function(){if(this._sConditionType!=="Filter"||this.getMaxConditions()!=="-1"){return;}var i=this._aConditionKeys.length;var p=1+Math.floor(Math.max(0,i-1)/this._iConditionPageSize);var j=1+Math.floor(this._iFirstConditionIndex/this._iConditionPageSize);var l=this.getParent();if(!this._oPaginatorToolbar){if(i>this._iConditionPageSize){this._createPaginatorToolbar();this.insertAggregation("content",this._oPaginatorToolbar,0);this._onGridResize();}else{if(l&&l.setHeaderText){if(this._sOrgHeaderText==undefined){this._sOrgHeaderText=l.getHeaderText();}l.setHeaderText(this._sOrgHeaderText+(i>0?" ("+i+")":""));}return;}}this._oPrevButton.setEnabled(this._iFirstConditionIndex>0);this._oNextButton.setEnabled(this._iFirstConditionIndex+this._iConditionPageSize<i);if(l&&l.setHeaderToolbar){if(!l.getHeaderToolbar()){this.removeAggregation("content",this._oPaginatorToolbar);l.setHeaderToolbar(this._oPaginatorToolbar);l.attachExpand(function(Z){this._setToolbarElementVisibility(Z.getSource().getExpanded()&&this._bPaginatorButtonsVisible);}.bind(this));}}if(l&&l.setHeaderText){if(this._sOrgHeaderText==undefined){this._sOrgHeaderText=l.getHeaderText();}var n=this._sOrgHeaderText+(i>0?" ("+i+")":"");l.setHeaderText(n);this._oHeaderText.setText(n);}else{this._oHeaderText.setText(i+" Conditions");}this._oPageText.setText(j+"/"+p);this._bPaginatorButtonsVisible=this._bPaginatorButtonsVisible||p>1;this._setToolbarElementVisibility(this._bPaginatorButtonsVisible);if(j>p){this._iFirstConditionIndex-=Math.max(0,this._iConditionPageSize);this._clearConditions();this._fillConditions();}var w=0;this._oConditionsGrid.getContent().forEach(function(Z){if(Z.select.getSelected()){w++;}},this);if(p==j&&(i-this._iFirstConditionIndex)>w){this._clearConditions();this._fillConditions();}};
Y.prototype._setToolbarElementVisibility=function(i){this._oPrevButton.setVisible(i);this._oNextButton.setVisible(i);this._oPageText.setVisible(i);this._oFilterField.setVisible(false);this._oAddButton.setVisible(i);this._oRemoveAllButton.setVisible(i);};
Y.prototype.exit=function(){this._clearConditions();this._unregisterResizeHandler();this._aConditionsFields=null;this._aKeys=null;this._aKeyFields=null;this._oTypeOperations=null;this._oRb=null;this._sFromLabelText=null;this._sToLabelText=null;this._sValueLabelText=null;this._sValidationDialogFieldMessage=null;this._oConditionsMap=null;this._aConditionKeys=[];};
Y.prototype._clearConditions=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){for(var l in this._aConditionsFields){var n=this._aConditionsFields[l];if(j[n["ID"]]&&j.getContent().indexOf(j[n["ID"]])===-1){j[n["ID"]].destroy();}}},this);this._oConditionsGrid.destroyContent();};
Y.prototype._fillConditions=function(){var j,l;var i=0,p=this._getMaxConditionsAsNumber(),n=this._aConditionKeys.length;if(this._oConditionsMap){var w=this._sConditionType!=="Filter"||this.getMaxConditions()!=="-1"?9999:this._iConditionPageSize;n=Math.min(n,Math.min(p,this._iFirstConditionIndex+w));for(i=this._iFirstConditionIndex;i<n;i++){l=this._aConditionKeys[i];j=this._oConditionsMap[l];this._createConditionRow(this._oConditionsGrid,j,l);}}this._updatePaginatorToolbar();if((this.getAutoAddNewRow()||this._oConditionsGrid.getContent().length===0)&&this._oConditionsGrid.getContent().length<p){this._createConditionRow(this._oConditionsGrid);}};
Y.prototype._addCondition=function(j){var i=0;var l=this._getMaxConditionsAsNumber();if(this._oConditionsMap){for(var n in this._oConditionsMap){if(i<l&&j===this._oConditionsMap[n]){this._createConditionRow(this._oConditionsGrid,j,n,i);}i++;}}this._updatePaginatorToolbar();};
Y.prototype._getMaxConditionsAsNumber=function(){return this.getMaxConditions()==="-1"?9999:parseInt(this.getMaxConditions());};
Y.prototype.onAfterRendering=function(){if(this.getLayoutMode()){this._sLayoutMode=this.getLayoutMode();return;}};
Y.prototype._handleMediaChange=function(p){this._sLayoutMode=p.name;this._updateLayout(p);};
Y.prototype._unregisterResizeHandler=function(){if(this._sContainerResizeListener){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;}D.media.detachHandler(this._handleMediaChange,this,D.media.RANGESETS.SAP_STANDARD);};
Y.prototype._registerResizeHandler=function(){if(this.getContainerQuery()){this._sContainerResizeListener=R.register(this._oConditionsGrid,this._onGridResize.bind(this));this._onGridResize();}else{D.media.attachHandler(this._handleMediaChange,this,D.media.RANGESETS.SAP_STANDARD);}};
Y.prototype._getKeyFromConditionGrid=function(i){var j=i.data("_key");if(!j){j=this._createConditionKey();}return j;};
Y.prototype._createConditionKey=function(){var i=0;var j;do{j="condition_"+i;if(this.getExclude()){j="x"+j;}i++;}while(this._oConditionsMap[j]);return j;};
Y.prototype._createConditionRow=function(i,j,l,p,n){var w,Z=this;if(p===undefined){p=i.getContent().length;}var $=new G({width:"100%",defaultSpan:"L12 M12 S12",hSpacing:1,vSpacing:0,containerQuery:this.getContainerQuery()}).data("_key",l);$.addStyleClass("sapUiRespGridOverflowHidden");for(var _ in this._aConditionsFields){var a1;var b1=this._aConditionsFields[_];switch(b1["Control"]){case"CheckBox":a1=new t({enabled:false,layoutData:new k({span:b1["Span"+this._sConditionType]})});this._setLayoutVisible(a1,false);if(b1["ID"]==="showIfGrouped"){a1.setEnabled(true);a1.setText(b1["Label"]);a1.attachSelect(function(){Z._changeField($);});a1.setSelected(j?j.showIfGrouped:true);}else{if(j){a1.setSelected(true);a1.setEnabled(true);}}break;case"ComboBox":if(b1["ID"]==="keyField"){a1=new u({width:"100%",ariaLabelledBy:this._oInvisibleTextField});var c1=a1.setSelectedKey.bind(a1);a1.setSelectedKey=function(l){c1(l);var o1=Z.getValidationExecutor();if(o1){o1();}};var d1=a1.setSelectedItem.bind(a1);a1.setSelectedItem=function(o1){d1(o1);var p1=Z.getValidationExecutor();if(p1){p1();}};a1.setLayoutData(new k({span:b1["Span"+this._sConditionType]}));this._fillKeyFieldListItems(a1,this._aKeyFields);if(a1.attachSelectionChange){a1.attachSelectionChange(function(o1){var p1=Z.getValidationExecutor();if(p1){p1();}Z._handleSelectionChangeOnKeyField(i,$);});}if(a1.attachChange){a1.attachChange(function(o1){$.keyField.close();Z._handleChangeOnKeyField(i,$);});}if(a1.setSelectedItem){if(j){a1.setSelectedKey(j.keyField);this._aKeyFields.forEach(function(e1,o1){var p1=e1.key;if(p1===undefined){p1=e1;}if(j.keyField===p1){a1.setSelectedItem(a1.getItems()[o1]);}},this);}else{if(this.getUsePrevConditionSetting()&&!this.getAutoReduceKeyFieldItems()){if(p>0&&!l&&n){w=i.getContent()[p-1];if(w.keyField.getSelectedKey()){a1.setSelectedKey(w.keyField.getSelectedKey());}else{if(!a1.getSelectedItem()&&a1.getItems().length>0){a1.setSelectedItem(a1.getItems()[0]);}}}else{this._aKeyFields.some(function(e1,o1){if(e1.isDefault){a1.setSelectedItem(a1.getItems()[o1]);return true;}if(!a1.getSelectedItem()&&e1.type!=="boolean"){a1.setSelectedItem(a1.getItems()[o1]);}},this);if(!a1.getSelectedItem()&&a1.getItems().length>0){a1.setSelectedItem(a1.getItems()[0]);}}}else{this._aKeyFields.forEach(function(e1,o1){if(e1.isDefault){a1.setSelectedItem(a1.getItems()[o1]);}},this);}}}}if(b1["ID"]==="operation"){a1=new v({width:"100%",ariaLabelledBy:this._oInvisibleTextOperator,layoutData:new k({span:b1["Span"+this._sConditionType]})});a1.attachChange(function(){Z._handleChangeOnOperationField(i,$);});$[b1["ID"]]=a1;this._updateOperationItems(i,$);if(j){var e1=this._getCurrentKeyFieldItem($.keyField),f1=this._getRelevantOperations(e1),g1=this.getCurrentOparation(j);f1.some(function(o1){if(g1===o1){a1.setSelectedKey(o1);return true;}},this);}else{if(this.getUsePrevConditionSetting()){if(p>0&&l===null){var w=i.getContent()[p-1];a1.setSelectedKey(w.operation.getSelectedKey());}}}}if(a1.getSelectedItem&&a1.getSelectedItem()&&a1.getMetadata()._sUIDToken!=="box"){a1.setTooltip(a1.getSelectedItem().getTooltip()||a1.getSelectedItem().getText());}break;case"TextField":var h1=this._getCurrentKeyFieldItem($.keyField);a1=this._createValueField(h1,b1,$);a1.oTargetGrid=i;if(j&&j[b1["ID"]]!==undefined){var i1=j[b1["ID"]];if(a1 instanceof v){if(typeof i1==="boolean"){a1.setSelectedIndex(i1?2:1);}}else if(i1!==null&&$.oType){if(typeof i1==="string"&&$.oType.getName()==="sap.ui.comp.odata.type.StringDate"){a1.setValue(i1);}else{if(typeof i1==="string"&&["String","sap.ui.model.odata.type.String","sap.ui.model.odata.type.Decimal"].indexOf($.oType.getName())==-1){try{i1=$.oType.parseValue(i1,"string");a1.setValue($.oType.formatValue(i1,"string"));}catch(j1){J.error("sap.m.P13nConditionPanel","Value '"+i1+"' does not have the expected type format for "+$.oType.getName()+".parseValue()");}}else{a1.setValue($.oType.formatValue(i1,"string"));}}}else{a1.setValue(i1);}}break;case"Label":a1=new x({text:b1["Text"]+":",visible:this.getShowLabel(),layoutData:new k({span:b1["Span"+this._sConditionType]})}).addStyleClass("conditionLabel");a1.oTargetGrid=i;break;}$[b1["ID"]]=a1;$.addContent(a1);}this._addButtons($,i);i.insertContent($,p);this._updateOperationItems(i,$);this._changeOperationValueFields(i,$);this._updateAllConditionsEnableStates();this._updateConditionButtons(i);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(i,false);}if(this._sLayoutMode){this._updateLayout({name:this._sLayoutMode});}if(j){var k1=this._getFormatedConditionText(j.operation,j.value1,j.value2,j.exclude,j.keyField,j.showIfGrouped);j._oGrid=$;j.value=k1;this._oConditionsMap[l]=j;}var l1=$.operation.getSelectedKey();if(l1==="BT"&&$.value1.setMinDate&&$.value2.setMaxDate){var m1=$.value1.getDateValue();var n1=$.value2.getDateValue();this._updateMinMaxDate($,m1,n1);}else{this._updateMinMaxDate($,null,null);}return $;};
Y.prototype._handleRemoveCondition=function(i,j){var l=i.getContent().indexOf(j);this._removeCondition(i,j);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(i,false);}if(l>=0){l=Math.min(l,i.getContent().length-1);var j=i.getContent()[l];setTimeout(function(){j.remove.focus();});}this._updatePaginatorToolbar();};
Y.prototype._handleAddCondition=function(i,j,l){var p=i.getContent().indexOf(j);var n=this._createConditionRow(i,undefined,null,p+1,l);this._changeField(n);setTimeout(function(){if(n.keyField.getVisible()){n.keyField.focus();return;}if(n.operation.getVisible()){n.operation.focus();}});this._updatePaginatorToolbar();};
Y.prototype._getCurrentKeyFieldItem=function(i){if(i.getSelectedKey&&i.getSelectedKey()){var j=i.getSelectedKey();var l=this._aKeyFields;for(var n in l){var p=l[n];if(p.key===j){return p;}}}return null;};
Y.prototype._createValueField=function(j,n,p){var w;var Z;var $=this;var _={value:n["Value"],width:"100%",placeholder:n["Label"],change:function(i){$._validateAndFormatFieldValue(i);$._changeField(p,i);},layoutData:new k({span:n["Span"+this._sConditionType]})};if(j&&j.typeInstance){var a1=j.typeInstance;Z=this._findConfig(a1,"ctrl");if(Z==="DateTimePicker"&&a1.getMetadata().getName()==="sap.ui.model.odata.type.DateTime"){if(!(a1.oConstraints&&a1.oConstraints.isDateOnly)){J.error("sap.m.P13nConditionPanel","sap.ui.model.odata.type.DateTime without displayFormat = Date is not supported!");a1.oConstraints=Object.assign({},a1.oConstraints,{isDateOnly:true});}Z="DatePicker";}p.oType=a1;if(Z=="select"){var b1=[];var c1=j.values||this._oTypeValues[Z]||["",a1.formatValue(false,"string"),a1.formatValue(true,"string")];c1.forEach(function(i,e1){b1.push(new d({key:e1.toString(),text:i.toString()}));});_={width:"100%",items:b1,change:function(){$._changeField(p);$._makeFieldValid(w,true);},layoutData:new k({span:n["Span"+this._sConditionType]})};w=new v(_);}else if(Z=="TimePicker"){if(a1.oFormatOptions&&a1.oFormatOptions.style){_.displayFormat=a1.oFormatOptions.style;}w=new A(_);}else if(Z=="DateTimePicker"){if(a1.oFormatOptions&&a1.oFormatOptions.style){_.displayFormat=a1.oFormatOptions.style;}w=new E(_);}else if(Z==="DatePicker"){if(a1.oFormatOptions){_.displayFormat=a1.oFormatOptions.style||a1.oFormatOptions.pattern;if(a1.isA("sap.ui.comp.odata.type.StringDate")){_.valueFormat="yyyyMMdd";}}w=new z(_);}else{w=new y(_);if(this._fSuggestCallback){j=this._getCurrentKeyFieldItem(p.keyField);if(j&&j.key){var d1=this._fSuggestCallback(w,j.key);if(d1){w._oSuggestProvider=d1;}}}}}else{p.oType=null;w=new y(_);}if(Z!=="boolean"&&Z!=="enum"&&w){w.onpaste=function(e1){var f1;if(window.clipboardData){f1=window.clipboardData.getData("Text");}else{f1=e1.originalEvent.clipboardData.getData('text/plain');}var p=e1.srcControl.getParent();var g1=f1.split(/\r\n|\r|\n/g);if(g1&&g1[g1.length-1].trim()===""){g1.pop();}var h1=p.operation;var op=h1.getSelectedKey();if(g1&&g1.length>1&&op!=="BT"){setTimeout(function(){var i1=g1?g1.length:0;var j1=$._getCurrentKeyFieldItem(p.keyField);var h1=p.operation;for(var i=0;i<i1;i++){if($._aConditionKeys.length>=$._getMaxConditionsAsNumber()){break;}var k1=g1[i].trim();if(k1){var l1;if(j1.typeInstance){try{l1=j1.typeInstance.parseValue(k1,"string");j1.typeInstance.validateValue(l1);}catch(m1){J.error("sap.m.P13nConditionPanel.onPaste","not able to parse value "+k1+" with type "+j1.typeInstance.getName());k1="";l1=null;}if(!l1){continue;}}var n1={"oOperation":h1.getSelectedKey(),"oKeyField":j1.key,"oPastedValue":l1},o1=$._getConditions(n1);$._addCondition2Map(o1);$.fireDataChange({key:o1.key,index:o1.index,operation:"add",newData:o1});}}$._clearConditions();$._fillConditions();},0);}};}if(j&&j.maxLength&&w.setMaxLength){var l=-1;if(typeof j.maxLength==="string"){l=parseInt(j.maxLength);}if(typeof j.maxLength==="number"){l=j.maxLength;}if(l>0&&(!w.getShowSuggestion||!w.getShowSuggestion())){w.setMaxLength(l);}}return w;};
Y.prototype._getConditions=function(i){return{"index":this._iConditions,"key":this._createConditionKey(),"exclude":this.getExclude(),"operation":i.oOperation,"keyField":i.oKeyField,"value1":i.oPastedValue,"value2":null};};
Y.prototype._fillOperationListItems=function(i,j,l){var n,p;if(l==="_STRING_"){l="";}if(l==="_TIME_"||l==="_DATETIME_"){l="_DATE_";}if(l==="_BOOLEAN_"||l==="_NUMC_"){l="";}i.destroyItems();j.forEach(function(w){p="CONDITIONPANEL_OPTION"+l+w;if(l&&this._oRb.hasText(p)){n=this._oRb.getText(p);}else{n=this._oRb.getText("CONDITIONPANEL_OPTION"+w);}i.addItem(new L({key:w,text:n,tooltip:n}));}.bind(this));};
Y.prototype._fillKeyFieldListItems=function(i,j){i.destroyItems();for(var l in j){var n=j[l];i.addItem(new L({key:n.key,text:n.text,tooltip:n.tooltip?n.tooltip:n.text}));}i.setEditable(i.getItems().length>1);};
Y.prototype._handleChangeOnOperationField=function(i,j){this._changeOperationValueFields(i,j);this._changeField(j);};
Y.prototype._handleSelectionChangeOnKeyField=function(i,j){if(this._sConditionType==="Filter"){this._updateOperationItems(i,j);this._createAndUpdateValueFields(i,j);this._changeOperationValueFields(i,j);}this._changeField(j);};
Y.prototype._handleChangeOnKeyField=function(i,j){if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(i,false,false,j.keyField);}};
Y.prototype._createAndUpdateAllKeyFields=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){this._createAndUpdateValueFields(this._oConditionsGrid,j);this._changeOperationValueFields(this._oConditionsGrid,j);},this);};
Y.prototype._createAndUpdateValueFields=function(i,j){var l=this._getCurrentKeyFieldItem(j.keyField);var n=function(j,p,w){var Z=p.getValue?p.getValue():"";var $=j.indexOfContent(p);j.removeContent(p);if(p._oSuggestProvider){p._oSuggestProvider.destroy();p._oSuggestProvider=null;}p.destroy();var _=this._aConditionsFields[w];p=this._createValueField(l,_,j);j[_["ID"]]=p;j.insertContent(p,$===-1?j.indexOfContent(j.operation)+1:$);var a1,b1;if(j.oType&&Z){try{a1=j.oType.parseValue(Z,"string");j.oType.validateValue(a1);b1=j.oType.formatValue(a1,"string");p.setValue(b1);}catch(c1){var d1=c1.message;this._makeFieldValid(p,false,d1);p.setValue(Z);}}};n.bind(this)(j,j.value1,5);n.bind(this)(j,j.value2,6);};
Y.prototype._updateAllOperations=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){this._updateOperationItems(this._oConditionsGrid,j);this._changeOperationValueFields(this._oConditionsGrid,j);},this);};
Y.prototype._updateOperationItems=function(i,j){var l=this._getCurrentKeyFieldItem(j.keyField);var n=l&&l.type||"";var p=j.operation;var w=p.getSelectedItem();var Z=this._getRelevantOperations(l);this._fillOperationListItems(p,Z,n?"_"+n.toUpperCase()+"_":"");if(w&&p.getItemByKey(w.getKey())){p.setSelectedKey(w.getKey());}else{p.setSelectedItem(p.getItems()[0]);}this._sConditionType="Filter";if(Z[0]===X.Ascending||Z[0]===X.Descending){this._sConditionType="Sort";}if(Z[0]===X.GroupAscending||Z[0]===X.GroupDescending){this._sConditionType="Group";}this._adjustValue1Span(j);};
Y.prototype._updateKeyFieldItems=function(l,p,w,Z){var n=l.getContent().length;var i;var $={};if(!p){for(i=0;i<n;i++){var _=l.getContent()[i].keyField;var a1=_.getSelectedKey();if(a1!=null&&a1!==""){$[a1]=true;}}}for(i=0;i<n;i++){var _=l.getContent()[i].keyField;var b1=l.getContent()[i].select;var c1=_.getSelectedKey();var j=0;var d1=this._aKeyFields;if(_!==Z){if(w){j=d1.length-1;}else{_.destroyItems();}for(j;j<d1.length;j++){var e1=d1[j];if(e1.key==null||e1.key===""||!$[e1.key]||e1.key===c1){_.addItem(new L({key:e1.key,text:e1.text,tooltip:e1.tooltip?e1.tooltip:e1.text}));}}_.setEditable(_.getItems().length>1);}if(c1){_.setSelectedKey(c1);}else if(_.getItems().length>0){_.setSelectedItem(_.getItems()[0]);}if(!b1.getSelected()){this._aKeyFields.some(function(f1,g1){if(f1.isDefault){_.setSelectedItem(_.getItems()[g1]);return true;}if(!_.getSelectedItem()){if(f1.type!=="boolean"){_.setSelectedItem(_.getItems()[g1]);}}},this);}if(_.getSelectedItem()){_.setTooltip(_.getSelectedItem().getTooltip()||_.getSelectedItem().getText());}}};
Y.prototype._changeOperationValueFields=function(i,j){var l=j.operation;var n=l.getSelectedKey();var p=j.value1;var w=j.value2;var Z=j.showIfGrouped;if(!n){return;}if(this._hasSecondValue(n)){if(p.setPlaceholder&&p.getPlaceholder()!==this._sFromLabelText){p.setPlaceholder(this._sFromLabelText);}if(!p.getVisible()){p.setVisible(true);j.insertContent(p,j.getContent().length-1);}if(w.setPlaceholder&&w.getPlaceholder()!==this._sToLabelText){w.setPlaceholder(this._sToLabelText);}if(!w.getVisible()){w.setVisible(true);j.insertContent(w,j.getContent().length-this._getSecondValueNegativeIndex());}}else{if(n===X.GroupAscending||n===X.GroupDescending){if(p.getVisible()){p.setVisible(false);j.removeContent(p);}if(w.getVisible()){w.setVisible(false);j.removeContent(w);}if(l.getVisible()){l.setVisible(false);j.removeContent(l);}Z.setVisible(this._getMaxConditionsAsNumber()!=1);this._setLayoutVisible(Z,this._getMaxConditionsAsNumber()!=1);}else{if(this._hasNoValues(n)){if(p.getVisible()){p.setVisible(false);j.removeContent(p);}if(w.getVisible()){w.setVisible(false);j.removeContent(w);}j.removeContent(Z);}else{if(p.setPlaceholder&&p.getPlaceholder()!==this._sValueLabelText){p.setPlaceholder(this._sValueLabelText);}if(!p.getVisible()){p.setVisible(true);j.insertContent(p,j.getContent().length-1);}if(w.getVisible()){w.setVisible(false);j.removeContent(w);}}}}this._adjustValue1Span(j);};
Y.prototype._adjustValue1Span=function(i){if(this._sConditionType==="Filter"&&i.value1&&i.operation){var j=i.operation;var n=this._aConditionsFields[5]["Span"+this._sConditionType];if(j.getSelectedKey()!=="BT"){n="L5 M10 S10";}var l=i.value1.getLayoutData();if(l.getSpan()!==n){l.setSpan(n);}}};
Y.prototype._getIndexOfCondition=function(i){var j=-1;i.getParent().getContent().some(function(l){if(l.select.getSelected()){j++;}return(l===i);},this);return j+this._iFirstConditionIndex;};
Y.prototype._makeFieldValid=function(i,j,l){if(j){i.setValueState(V.None);i.setValueStateText("");}else{i.setValueState(V.Warning);i.setValueStateText(l?l:this._sValidationDialogFieldMessage);}};
Y.prototype._validateAndFormatFieldValue=function(i){var j=i.oSource;var l=j.getParent();var n;if(j.getDateValue&&i){n=i.getParameter("value");var p=i.getParameter("valid");this._makeFieldValid(j,p);return;}else{n=j.getValue&&j.getValue();}if(!l){return;}if(this.getDisplayFormat()==="UpperCase"&&n){n=n.toUpperCase();j.setValue(n);}if(l.oType&&n){try{var w=l.oType.parseValue(n,"string");l.oType.validateValue(w);this._makeFieldValid(j,true);n=l.oType.formatValue(w,"string");j.setValue(n);}catch(Z){var $=Z.message;this._makeFieldValid(j,false,$);}}else{this._makeFieldValid(j,true);}};
Y.prototype._updateMinMaxDate=function(i,j,l){if(i.value1.setMinDate&&i.value2.setMaxDate){if(i.value1&&i.value1.setMaxDate){i.value1.setMaxDate(l instanceof Date?l:null);}if(i.value2&&i.value2.setMinDate){i.value2.setMinDate(j instanceof Date?j:null);}}};
Y.prototype._changeField=function(i,j){var l=i.keyField.getSelectedKey();if(i.keyField.getSelectedItem()){i.keyField.setTooltip(i.keyField.getSelectedItem().getTooltip()||i.keyField.getSelectedItem().getText());}else{i.keyField.setTooltip(null);}var n=i.operation.getSelectedKey();if(i.operation.getSelectedItem()){i.operation.setTooltip(i.operation.getSelectedItem().getTooltip()||i.operation.getSelectedItem().getText());}else{i.operation.setTooltip(null);}var p=function(j1,k1){var f1;var l1;if(j1.getDateValue&&!(j1.isA("sap.m.TimePicker"))&&k1.getName()!=="sap.ui.comp.odata.type.StringDate"){l1=j1.getDateValue();if(k1&&l1){if((j&&j.getParameter("valid"))||j1.isValidValue()){f1=k1.formatValue(l1,"string");}else{f1="";}}}else{f1=this._getValueTextFromField(j1);l1=f1;if(k1&&k1.getName()==="sap.ui.comp.odata.type.StringDate"){f1=k1.formatValue(l1,"string");}else if(k1&&f1){try{l1=k1.parseValue(f1,"string");k1.validateValue(l1);}catch(m1){J.error("sap.m.P13nConditionPanel","not able to parse value "+f1+" with type "+k1.getName());f1="";}}}return[l1,f1];}.bind(this);var w=p(i.value1,i.oType);var Z=w[0],$=w[1];w=p(i.value2,i.oType);var _=w[0],a1=w[1];if(this._hasSecondValue(n)){this._updateMinMaxDate(i,Z,_);}else{this._updateMinMaxDate(i,null,null);}var b1=this._getCurrentKeyFieldItem(i.keyField);if(b1&&b1.type==="numc"){if([X.Contains,X.EndsWith].indexOf(n)!=-1){Z=i.oType.formatValue(Z,"string");}}var c1=i.showIfGrouped.getSelected();var d1=this.getExclude();var e1=i.select;var f1="";var g1;if(l===""||l==null){l=null;g1=this._getKeyFromConditionGrid(i);this._removeConditionFromMap(g1);this._enableCondition(i,false);var h1=this._getIndexOfCondition(i);if(e1.getSelected()){e1.setSelected(false);e1.setEnabled(false);this._bIgnoreSetConditions=true;this.fireDataChange({key:g1,index:h1,operation:"remove",newData:null});this._bIgnoreSetConditions=false;}return;}this._enableCondition(i,true);f1=this._getFormatedConditionText(n,$,a1,d1,l,c1);var i1={"value":f1,"exclude":d1,"operation":n,"keyField":l,"value1":Z,"value2":this._hasSecondValue(n)?_:null,"showIfGrouped":c1};g1=this._getKeyFromConditionGrid(i);if(f1!==""){e1.setSelected(true);e1.setEnabled(true);var n="update";if(!this._oConditionsMap[g1]){n="add";}this._oConditionsMap[g1]=i1;if(n==="add"){this._aConditionKeys.splice(this._getIndexOfCondition(i),0,g1);}i.data("_key",g1);this.fireDataChange({key:g1,index:this._getIndexOfCondition(i),operation:n,newData:i1});}else if(this._oConditionsMap[g1]!==undefined){this._removeConditionFromMap(g1);i.data("_key",null);var h1=this._getIndexOfCondition(i);if(e1.getSelected()){e1.setSelected(false);e1.setEnabled(false);this._bIgnoreSetConditions=true;this.fireDataChange({key:g1,index:h1,operation:"remove",newData:null});this._bIgnoreSetConditions=false;}}this._updatePaginatorToolbar();};
Y.prototype._getValueTextFromField=function(i){if(i instanceof v){return i.getSelectedItem()?i.getSelectedItem().getText():"";}return i.getValue();};
Y.prototype._updateAllConditionsEnableStates=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){var l=this._getCurrentKeyFieldItem(j.keyField);var n=l&&l.key!==undefined?l.key:l;var p=n!==""&&n!==null;this._enableCondition(j,p);},this);};
Y.prototype._enableCondition=function(i,j){i.operation.setEnabled(j);i.value1.setEnabled(j);i.value2.setEnabled(j);i.showIfGrouped.setEnabled(j);};
Y.prototype._removeCondition=function(i,j){var l=this._getKeyFromConditionGrid(j);var n=-1;if(j.select.getSelected()){n=this._getIndexOfCondition(j);}this._removeConditionFromMap(l);j.destroy();if(i.getContent().length<1){this._createConditionRow(i);}else{this._updateConditionButtons(i);}if(n>=0){this.fireDataChange({key:l,index:n,operation:"remove",newData:null});}};
Y.prototype._updateConditionButtons=function(j){var l=this._getMaxConditionsAsNumber();var n=j.getContent().length;for(var i=0;i<n;i++){var p=j.getContent()[i].add;if((this.getAlwaysShowAddIcon()&&(n<l))||(i===n-1&&i<l-1)){p.removeStyleClass("displayNone");}else{p.addStyleClass("displayNone");}var w=j.getContent()[i].remove;if(l===1||(i===0&&n===1&&this.getDisableFirstRemoveIcon())){w.addStyleClass("displayNone");}else{w.removeStyleClass("displayNone");}}};
Y.prototype.validateConditions=function(){var j=this;var l=function(n){var p=true;for(var i=0;i<n.length;i++){var w=n[i];var Z=j._checkCondition(w,i===n.length-1);p=p&&Z;}return p;};return l(this._oConditionsGrid.getContent());};
Y.prototype.removeValidationErrors=function(){this._oConditionsGrid.getContent().forEach(function(i){var j=i.value1;var l=i.value2;j.setValueState(V.None);j.setValueStateText("");l.setValueState(V.None);l.setValueStateText("");},this);};
Y.prototype.removeInvalidConditions=function(){var i=[];this._oConditionsGrid.getContent().forEach(function(j){if(j.value1.getValueState()!==V.None||j.value2.getValueState()!==V.None){i.push(j);}},this);i.forEach(function(j){this._removeCondition(this._oConditionsGrid,j);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(this._oConditionsGrid,false);}},this);};
Y.prototype._checkCondition=function(i,j){var l=true;var n=i.value1;var p=i.value2;var w=n&&(n.getVisible()&&!this._getValueTextFromField(n));var Z=n&&n.getVisible()&&n.getValueState?n.getValueState():V.None;var $=p&&(p.getVisible()&&!this._getValueTextFromField(p));var _=p&&p.getVisible()&&p.getValueState?p.getValueState():V.None;var a1=i.operation.getSelectedKey();if(this._hasSecondValue(a1)){if(!w?$:!$){if(w){n.setValueState(V.Warning);n.setValueStateText(this._sValidationDialogFieldMessage);}if($){p.setValueState(V.Warning);p.setValueStateText(this._sValidationDialogFieldMessage);}l=false;}else if(Z!==V.None||_!==V.None){l=false;}else{n.setValueState(V.None);n.setValueStateText("");p.setValueState(V.None);p.setValueStateText("");}}if((n.getVisible()&&n.getValueState&&n.getValueState()!==V.None)||(p.getVisible()&&p.getValueState&&p.getValueState()!==V.None)){l=false;}return l;};
Y.prototype._getFormatedConditionText=function(j,l,n,p,w,Z){var $=Y.getFormatedConditionText(j,l,n,p);if(!$){switch(j){case X.Initial:$="=''";break;case X.NotEmpty:$="!''";break;case X.Ascending:$="ascending";break;case X.GroupAscending:$="ascending";$+=" showIfGrouped:"+Z;break;case X.Descending:$="descending";break;case X.GroupDescending:$="descending";$+=" showIfGrouped:"+Z;break;case X.Total:$="total";break;case X.Average:$="average";break;case X.Minimum:$="minimum";break;case X.Maximum:$="maximum";break;}if(p&&$!==""){$="!("+$+")";}}if(this._aKeyFields&&this._aKeyFields.length>1){var _=null;for(var i=0;i<this._aKeyFields.length;i++){var a1=this._aKeyFields[i];if(typeof a1!=="string"){if(a1.key===w&&a1.text){_=a1.text;}}}if(_&&$!==""){$=_+": "+$;}}return $;};
Y._oConditionMap={"EQ":"=$0","GT":">$0","GE":">=$0","LT":"<$0","LE":"<=$0","Contains":"*$0*","StartsWith":"$0*","EndsWith":"*$0","BT":"$0...$1","Empty":"<$r>"};(function(){var _=sap.ui.getCore().getLibraryResourceBundle("sap.m");Y._oConditionMap[X.Empty]=Y._oConditionMap[X.Empty].replace("$r",_.getText("CONDITIONPANEL_OPTIONEmpty"));})();
Y._templateReplace=function(i,j){return i.replace(/\$\d/g,function(l){return j[parseInt(l.substr(1))];});};
Y.getFormatedConditionText=function(i,j,l,n){var p="";switch(i){case X.Empty:p=Y._templateReplace(Y._oConditionMap[i],[]);break;case X.EQ:case X.GT:case X.GE:case X.LT:case X.LE:case X.Contains:case X.StartsWith:case X.EndsWith:if(j!==""&&j!==undefined&&j!==null){p=Y._templateReplace(Y._oConditionMap[i],[j]);}break;case X.BT:if(j!==""&&j!==undefined&&j!==null){if(l!==""&&l!==undefined&&l!==null){p=Y._templateReplace(Y._oConditionMap[i],[j,l]);}}break;default:break;}if(n&&p!==""){p="!("+p+")";}return p;};
Y.prototype._updateLayout=function(j){if(!this._oConditionsGrid){return;}var l=this._oConditionsGrid.getContent();var n=this._aConditionsFields.length;var p=n;if(j.name==="Tablet"){p=5;}if(j.name==="Phone"){p=3;}if(this._sConditionType==="Filter"){for(var i=0;i<l.length;i++){var w=l[i];w.ButtonContainer.removeStyleClass("floatRight");w.removeContent(w.ButtonContainer);w.insertContent(w.ButtonContainer,p);if(!this.getAlwaysShowAddIcon()){if(p!==n){w.ButtonContainer.removeContent(w.add);w.addContent(w.add);}else{w.removeContent(w.add);w.ButtonContainer.addContent(w.add);}}}}};
Y.prototype._onGridResize=function(){var w;if(this._oPaginatorToolbar&&this._oConditionsGrid&&this._oConditionsGrid.getContent().length>0){var i=this._oConditionsGrid.getContent()[0];if(i.remove&&i.remove.$().position()){w=0;if(this._oPaginatorToolbar.getParent()&&this._oPaginatorToolbar.getParent().getExpandable&&this._oPaginatorToolbar.getParent().getExpandable()){w=48-4;}var j=i.remove.$().position().left-w+i.remove.$().width();this._oPaginatorToolbar.setWidth(j+"px");}}var l=this._oConditionsGrid.getDomRef();if(!l){return;}if(!Q(l).is(":visible")){return;}w=l.clientWidth;var n={};if(w<=this._iBreakPointTablet){n.name="Phone";}else if((w>this._iBreakPointTablet)&&(w<=this._iBreakPointDesktop)){n.name="Tablet";}else{n.name="Desktop";}if(n.name==="Phone"&&this._sLayoutMode!==n.name){this._updateLayout(n);this._sLayoutMode=n.name;}if(n.name==="Tablet"&&this._sLayoutMode!==n.name){this._updateLayout(n);this._sLayoutMode=n.name;}if(n.name==="Desktop"&&this._sLayoutMode!==n.name){this._updateLayout(n);this._sLayoutMode=n.name;}};
Y.prototype._findConfig=function(i,j){if(typeof i==="object"){i=i.getMetadata().getName();}var l;while(i&&!(l=this._getConfig(i,j))){i=this._getParentType(i);}return l;};
Y.prototype._getConfig=function(i,j){var l=this._mOpsForType[i];if(l){return l[j];}};
Y.prototype._getParentType=function(i){return this._mTypes[i];};
Y.prototype._getRelevantOperations=function(i){var j,l=i&&i.type&&this.getOperations(i.type);if(i&&i.operations){j=i.operations;}else if(Array.isArray(l)&&l.length>0){j=l;}else{j=this.getOperations("default");}return j;};
Y.prototype._addButtons=function(i,j){var l=this;var n=new H({layoutData:new k({span:this.getLayoutMode()==="Desktop"?"L2 M2 S2":this._oButtonGroupSpan["Span"+this._sConditionType]})}).addStyleClass("floatRight");i.addContent(n);i["ButtonContainer"]=n;var p=new m({type:M.Transparent,icon:I.getIconURI("decline"),tooltip:this._oRb.getText("CONDITIONPANEL_REMOVE"+(this._sAddRemoveIconTooltipKey?"_"+this._sAddRemoveIconTooltipKey:"")+"_TOOLTIP"),press:function(){l._handleRemoveCondition(this.oTargetGrid,i);},layoutData:new k({span:this.getLayoutMode()==="Desktop"?"L1 M1 S1":"L1 M2 S2"})});p.oTargetGrid=j;n.addContent(p);i["remove"]=p;var w=new m({type:M.Transparent,icon:I.getIconURI("add"),tooltip:this._oRb.getText("CONDITIONPANEL_ADD"+(this._sAddRemoveIconTooltipKey?"_"+this._sAddRemoveIconTooltipKey:"")+"_TOOLTIP"),press:function(){l._handleAddCondition(this.oTargetGrid,i,true);},layoutData:new k({span:this.getLayoutMode()==="Desktop"?"L1 M1 S1":"L1 M10 S10"})});w.oTargetGrid=j;w.addStyleClass("conditionAddBtnFloatRight");n.addContent(w);i["add"]=w;};
Y.prototype.getCurrentOparation=function(i){return i.operation;};
Y.prototype.setSuggestCallback=function(i){this._fSuggestCallback=i;};
Y.prototype._hasSecondValue=function(i){return i===X.BT;};
Y.prototype._getSecondValueNegativeIndex=function(){return 1;};
Y.prototype._createConditionsFields=function(){return[{"ID":"select","Label":"","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"CheckBox","Value":""},{"ID":"keyFieldLabel","Text":"Sort By","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"Label"},{"ID":"keyField","Label":"","SpanFilter":"L3 M5 S10","SpanSort":"L5 M5 S12","SpanGroup":"L4 M4 S12","Control":"ComboBox"},{"ID":"operationLabel","Text":"Sort Order","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"Label"},{"ID":"operation","Label":"","SpanFilter":"L2 M5 S10","SpanSort":D.system.phone?"L5 M5 S8":"L5 M5 S9","SpanGroup":"L2 M5 S10","Control":"ComboBox"},{"ID":"value1","Label":this._sFromLabelText,"SpanFilter":"L3 M10 S10","SpanSort":"L3 M10 S10","SpanGroup":"L3 M10 S10","Control":"TextField","Value":""},{"ID":"value2","Label":this._sToLabelText,"SpanFilter":"L2 M10 S10","SpanSort":"L2 M10 S10","SpanGroup":"L2 M10 S10","Control":"TextField","Value":""},{"ID":"showIfGrouped","Label":this._sShowIfGroupedLabelText,"SpanFilter":"L1 M10 S10","SpanSort":"L1 M10 S10","SpanGroup":"L3 M4 S9","Control":"CheckBox","Value":"false"}];};
Y.prototype._hasNoValues=function(i){return i===X.Empty||i===X.Initial||i===X.Ascending||i===X.Descending||i===X.Total||i===X.Average||i===X.Minimum||i===X.Maximum;};
Y.prototype._setLayoutVisible=function(i,j){var l;if(i.getLayoutData===undefined){return;}l=i.getLayoutData&&i.getLayoutData();if(l&&(l.getMetadata&&l.getMetadata().getName()==="sap.ui.layout.GridData")){l.setVisibleXL(j);l.setVisibleL(j);l.setVisibleM(j);l.setVisibleS(j);}else{i.setLayoutData(new k({visibleXL:j,visibleL:j,visibleM:j,visibleS:j}));}i.setVisible(j);};
Y.prototype._mTypes={"base":undefined,"string":"base","numeric":"base","date":"base","time":"base","boolean":"base","int":"numeric","float":"numeric","sap.ui.model.type.Boolean":"boolean","sap.ui.model.type.Date":"date","sap.ui.model.type.FileSize":"string","sap.ui.model.type.Float":"float","sap.ui.model.type.Integer":"int","sap.ui.model.type.String":"string","sap.ui.model.type.Time":"time","sap.ui.comp.odata.type.StringDate":"date","sap.ui.model.odata.type.Boolean":"boolean","sap.ui.model.odata.type.Byte":"int","sap.ui.model.odata.type.Date":"date","sap.ui.model.odata.type.DateTime":"datetime","sap.ui.model.odata.type.DateTimeOffset":"datetime","sap.ui.model.odata.type.Decimal":"float","sap.ui.model.odata.type.Double":"float","sap.ui.model.odata.type.Single":"float","sap.ui.model.odata.type.Guid":"string","sap.ui.model.odata.type.Int16":"int","sap.ui.model.odata.type.Int32":"int","sap.ui.model.odata.type.Int64":"int","sap.ui.model.odata.type.Raw":"string","sap.ui.model.odata.type.SByte":"int","sap.ui.model.odata.type.String":"string","sap.ui.model.odata.type.Time":"time","sap.ui.model.odata.type.TimeOfDay":"time","Edm.Boolean":"sap.ui.model.odata.type.Boolean","Edm.Byte":"sap.ui.model.odata.type.Byte","Edm.Date":"sap.ui.model.odata.type.Date","Edm.DateTime":"sap.ui.model.odata.type.DateTime","Edm.DateTimeOffset":"sap.ui.model.odata.type.DateTimeOffset","Edm.Decimal":"sap.ui.model.odata.type.Decimal","Edm.Double":"sap.ui.model.odata.type.Double","Edm.Single":"sap.ui.model.odata.type.Single","Edm.Guid":"sap.ui.model.odata.type.Guid","Edm.Int16":"sap.ui.model.odata.type.Int16","Edm.Int32":"sap.ui.model.odata.type.Int32","Edm.Int64":"sap.ui.model.odata.type.Int64","Edm.SByte":"sap.ui.model.odata.type.SByte","Edm.String":"sap.ui.model.odata.type.String","Edm.Time":"sap.ui.model.odata.type.Time","Edm.TimeOfDay":"sap.ui.model.odata.type.TimeOfDay"};Y.prototype._mOpsForType={"base":{ctrl:"input"},"string":{ctrl:"input"},"date":{ctrl:"DatePicker"},"datetime":{ctrl:"DateTimePicker"},"numeric":{ctrl:"input"},"time":{ctrl:"TimePicker"},"boolean":{ctrl:"select"}};return Y;});
sap.ui.predefine('sap/m/P13nDialog',['./Dialog','./library','sap/ui/core/EnabledPropagator','./DialogRenderer','sap/ui/core/library','sap/ui/Device','./Bar','./Button','./Title','sap/m/OverflowToolbarLayoutData','sap/ui/base/ManagedObjectObserver',"sap/ui/thirdparty/jquery","sap/base/Log","sap/base/util/isEmptyObject"],function(D,l,E,a,c,b,B,d,T,O,M,q,L,e){"use strict";var f=l.OverflowToolbarPriority;var g=l.ListType;var P=l.P13nPanelType;var h=l.ListMode;var j=c.MessageType;var k=l.ButtonType;var m=l.BackgroundDesign;var N;var n;var p={apiVersion:2,render:function(r,C){a.render.apply(this,arguments);var i=C._getVisiblePanelID();var s=C.getVisiblePanel();if(i&&s){r.openStart("div",i);r.openEnd();r.renderControl(s);r.close("div");}}};
var o=D.extend("sap.m.P13nDialog",{
metadata:{deprecated:true,library:"sap.m",properties:{initialVisiblePanelType:{type:"string",group:"Misc",defaultValue:null},showReset:{type:"boolean",group:"Appearance",defaultValue:false},showResetEnabled:{type:"boolean",group:"Appearance",defaultValue:false},validationExecutor:{type:"object",group:"Misc",defaultValue:null}},aggregations:{panels:{type:"sap.m.P13nPanel",multiple:true,singularName:"panel",bindable:"bindable"}},events:{ok:{},cancel:{},reset:{}}},
renderer:p
});
E.apply(o.prototype,[true]);
o.prototype.init=function(i){this.addStyleClass("sapMP13nDialog");D.prototype.init.apply(this,arguments);this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._mValidationListener={};this._createDialog();this._bTabBarUsed=true;this._mVisibleNavigationItems={};this._bNavigationControlsPromiseResolved=false;this._oNavigationControlsPromise=this._requestRequiredNavigationControls();this._oObserver=new M(_.bind(this));this._oObserver.observe(this,{properties:["showReset","showResetEnabled"],aggregations:["panels"]});};
o.prototype.setShowResetEnabled=function(i){return this.setProperty("showResetEnabled",i,true);};
o.prototype._createDialog=function(){if(b.system.phone){var t=this;this.setStretch(true);this.setVerticalScrolling(false);this.setHorizontalScrolling(false);this.setCustomHeader(new B(this.getId()+"-phoneHeader",{contentLeft:new d(this.getId()+"-backToList",{visible:false,type:k.Back,press:function(){t._backToList();}}),contentMiddle:new T(this.getId()+"-phoneTitle",{text:this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS"),level:"H2"})}));this.addButton(this._createOKButton());this.addButton(this._createCancelButton());this.addButton(this._createResetButton());}else{this.setHorizontalScrolling(false);this.setContentWidth("65rem");this.setContentHeight("40rem");this.setDraggable(true);this.setResizable(true);this.setTitle(this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS"));this.addButton(this._createOKButton());this.addButton(this._createCancelButton());this.addButton(this._createResetButton());}};
o.prototype._showValidationDialog=function(C,F,v){var w=[];var i=[];this._prepareMessages(F,v,w,i);var t=this;return new Promise(function(r){sap.ui.require(["sap/m/MessageBox"],function(s){var u="";if(i.length){i.forEach(function(x,I,y){u=(y.length>1?"• ":"")+x.messageText+"\n"+u;});s.show(u,{icon:s.Icon.ERROR,title:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_TITLE_ERROR"),actions:[s.Action.CLOSE],styleClass:t.$().closest(".sapUiSizeCompact").length?"sapUiSizeCompact":""});}else if(w.length){w.forEach(function(x,I,y){u=(y.length>1?"• ":"")+x.messageText+"\n"+u;});u=u+sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_MESSAGE_QUESTION");s.show(u,{icon:s.Icon.WARNING,title:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_TITLE"),actions:[sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_FIX"),s.Action.IGNORE],onClose:function(A){if(A===s.Action.IGNORE){C();}},styleClass:t.$().closest(".sapUiSizeCompact").length?"sapUiSizeCompact":""});}r();});});};
o.prototype._prepareMessages=function(F,v,w,r){if(!F.length&&!v.length){return;}F.forEach(function(s){switch(s){case P.filter:v.push({messageType:j.Warning,messageText:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_MESSAGE")});break;case P.columns:v.push({messageType:j.Warning,messageText:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VISIBLE_ITEMS_THRESHOLD_MESSAGE")});break;default:L.error("Panel type '"+s+"' is not supported jet.");}});var u=v.filter(function(s,I,t){for(var i=++I;i<t.length;i++){if(s.messageText===t[i].messageText){return false;}}return true;});u.forEach(function(i){if(i.messageType===j.Warning){w.push(i);}else if(i.messageType===j.Error){r.push(i);}});};
o.prototype._mapPanelToNavigationItem=function(i){if(!i){return null;}return b.system.phone?new n(i.getId()+"-navItem",{type:g.Navigation,title:i.getTitle()}):new n(i.getId()+"-navItem",{text:i.getTitle()});};
o.prototype._switchPanel=function(i){var r=this._getPanelByNavigationItem(i);this.setVerticalScrolling(r.getVerticalScrolling());if(b.system.phone){var s=this._getNavigationControl();if(s){s.setVisible(false);r.beforeNavigationTo();r.setVisible(true);this.getCustomHeader().getContentMiddle()[0].setText(r.getTitle());this.getCustomHeader().getContentLeft()[0].setVisible(true);}}else{this.getPanels().forEach(function(t){if(t===r){t.beforeNavigationTo();t.setVisible(true);}else{t.setVisible(false);}},this);}this.invalidate();this.rerender();};
o.prototype._backToList=function(){var i=this._getNavigationControl();if(i){i.setVisible(true);var r=this.getVisiblePanel();r.setVisible(false);this._updateDialogTitle();this.getCustomHeader().getContentLeft()[0].setVisible(false);}};
o.prototype.getVisiblePanel=function(){var i=null;this.getPanels().some(function(r){if(r.getVisible()){i=r;return true;}});return i;};
o.prototype._getVisiblePanelID=function(){var i=this.getVisiblePanel();if(i){return this.getId()+"-panel_"+i.getId();}return null;};
o.prototype._getPanelByNavigationItem=function(r){for(var i=0,s=this.getPanels(),t=s.length;i<t;i++){if(this._getNavigationItemByPanel(s[i])===r){return s[i];}}return null;};
o.prototype._getNavigationItemByPanel=function(i){return i?i.data("sapMP13nDialogNavigationItem"):null;};
o.prototype.onAfterRendering=function(){D.prototype.onAfterRendering.apply(this,arguments);var C=q(this.getFocusDomRef()).find(".sapMDialogScrollCont");var i=this._getVisiblePanelID();if(i&&C){var $=q(document.getElementById(i));$.appendTo(q(C));}};
o.prototype._updateDialogTitle=function(){var i=this.getVisiblePanel();var t=this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS");if(!this._isNavigationControlExpected()&&i){switch(i.getType()){case P.filter:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_FILTER");break;case P.sort:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_SORT");break;case P.group:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_GROUP");break;case P.columns:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_COLUMNS");break;case P.dimeasure:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_DIMEASURE");break;default:t=i.getTitleLarge()||this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS");}}if(b.system.phone){this.getCustomHeader().getContentMiddle()[0].setText(t);}else{this.setTitle(t);}};
o.prototype._registerValidationListener=function(i,C){if(this.getPanels().indexOf(i)&&C&&this._mValidationListener[i.getType()]===undefined){this._mValidationListener[i.getType()]=C;}};
o.prototype._callValidationExecutor=function(){var v=this.getValidationExecutor();if(v&&!e(this._mValidationListener)){var t=this;v(this._getPayloadOfPanels()).then(function(V){var r=t._distributeValidationResult(V);for(var s in t._mValidationListener){var C=t._mValidationListener[s];C(r[s]||[]);}});}};
o.prototype._distributeValidationResult=function(r){var i={};r.forEach(function(R){R.panelTypes.forEach(function(t){if(i[t]===undefined){i[t]=[];}i[t].push({columnKey:R.columnKey,messageType:R.messageType,messageText:R.messageText});});});return i;};
o.prototype._createOKButton=function(){var t=this;return new d(this.getId()+"-ok",{type:k.Emphasized,text:this._oResourceBundle.getText("P13NDIALOG_OK"),layoutData:new O({priority:f.NeverOverflow}),press:function(){t.setBusy(true);var i=t._getPayloadOfPanels();var F=function(){t.setBusy(false);t.fireOk({payload:i});};var r=[];var C=function(){t.getPanels().forEach(function(s){if(r.indexOf(s.getType())>-1){s.onAfterNavigationFrom();}});F();};t.getPanels().forEach(function(s){if(!s.onBeforeNavigationFrom()){r.push(s.getType());}});var v=[];var V=t.getValidationExecutor();if(V){V(i).then(function(v){if(r.length||v.length){t.setBusy(false);t._showValidationDialog(C,r,v);}else{F();}});}else{if(r.length||v.length){t.setBusy(false);t._showValidationDialog(C,r,v);}else{F();}}}});};
o.prototype._createCancelButton=function(){var t=this;return new d(this.getId()+"-cancel",{text:this._oResourceBundle.getText("P13NDIALOG_CANCEL"),layoutData:new O({priority:f.NeverOverflow}),press:function(){t.fireCancel();}});};
o.prototype._createResetButton=function(){var t=this;return new d(this.getId()+"-reset",{text:this._oResourceBundle.getText("P13NDIALOG_RESET"),layoutData:new O({priority:f.NeverOverflow}),visible:this.getShowReset(),enabled:this.getShowResetEnabled(),press:function(){sap.ui.getCore().byId(t.getId()+"-ok").focus();t.setShowResetEnabled(false);var i={};t.getPanels().forEach(function(r){i[r.getType()]=r.getResetPayload();});t.fireReset({payload:i});}});};
o.prototype._getPayloadOfPanels=function(){var i={};this.getPanels().forEach(function(r){i[r.getType()]=r.getOkPayload();});return i;};
o.prototype.exit=function(){D.prototype.exit.apply(this,arguments);this._oObserver.disconnect();this._oObserver=undefined;this._bTabBarUsed=false;this._mValidationListener={};this._mVisibleNavigationItems={};this._oNavigationControlsPromise=null;};
o.prototype._isInstanceOf=function(i,s){var C=sap.ui.require(s);return i&&typeof C==='function'&&(i instanceof C);};
function _(C){if(this._isInstanceOf(C.object,"sap/m/P13nDialog")){var i;switch(C.name){case"panels":var r=C.child?[C.child]:C.children;r.forEach(function(s){switch(C.mutation){case"insert":this._mVisibleNavigationItems[s.sId]=s.getVisible();s.setVisible(false);s.beforeNavigationTo();this._oObserver.observe(s,{properties:["title"]});s.setValidationExecutor(q.proxy(this._callValidationExecutor,this));s.setValidationListener(q.proxy(this._registerValidationListener,this));break;case"remove":delete this._mVisibleNavigationItems[s.sId];this._oObserver.unobserve(s);s.setValidationExecutor();s.setValidationListener();break;default:L.error("Mutation '"+C.mutation+"' is not supported jet.");}},this);if(this._bNavigationControlsPromiseResolved){this._updateDialog();}else{this._oNavigationControlsPromise.then(function(){this._updateDialog();}.bind(this));}break;case"showReset":i=this.getButtons();if(i.length>1){i[2].setVisible(C.current);}break;case"showResetEnabled":i=this.getButtons();if(i.length>1){i[2].setEnabled(C.current);i[2].invalidate();}break;default:L.error("The property or aggregation '"+C.name+"' has not been registered.");}}else if(this._isInstanceOf(C.object,"sap/m/P13nPanel")){if(C.name==="title"){var I=this._getNavigationItemByPanel(C.object);if(I){if(b.system.phone){I.setTitle(C.current);}else{I.setText(C.current);}}}}}
o.prototype._isNavigationControlExpected=function(){return this._getCountOfVisibleNavigationItems()>1;};
o.prototype._getCountOfVisibleNavigationItems=function(){var C=0;for(var i in this._mVisibleNavigationItems){C=this._mVisibleNavigationItems[i]?C+1:C;}return C;};
o.prototype._isNavigationControlExists=function(){return b.system.phone?this.getContent().length>0:(!!this.getSubHeader()&&this.getSubHeader().getContentLeft().length>0);};
o.prototype._getNavigationControl=function(){if(!this._isNavigationControlExists()){this._createNavigationControl();}return b.system.phone?this.getContent()[0]:this.getSubHeader().getContentLeft()[0];};
o.prototype._setVisibleOfNavigationControl=function(v){if(!this._isNavigationControlExists()){return;}return b.system.phone?this.getContent()[0].setVisible(v):this.getSubHeader().setVisible(v);};
o.prototype._createNavigationControl=function(){if(b.system.phone){this.addContent(new N(this.getId()+"-navigationItems",{mode:h.None,itemPress:function(i){this._switchPanel(i.getParameter("listItem"));}.bind(this)}));}else{this.setSubHeader(new B(this.getId()+"-navigationBar",{contentLeft:new N(this.getId()+"-navigationItems",{backgroundDesign:m.Transparent,expandable:false,select:function(i){this._switchPanel(i.getParameter("item"));}.bind(this)})}));}return this._getNavigationControl();};
o.prototype._updateDialog=function(){var i=this._getNavigationControl();i.destroyItems();var I=this._determineInitialVisiblePanel();this.getPanels().forEach(function(r){var s=this._mapPanelToNavigationItem(r);r.data("sapMP13nDialogNavigationItem",s);i.addItem(s);var v=b.system.phone?this._mVisibleNavigationItems[r.sId]&&this._getCountOfVisibleNavigationItems()===1:this._mVisibleNavigationItems[r.sId]&&I===r.sId;r.setVisible(v);if(v){this.setVerticalScrolling(r.getVerticalScrolling());}s.setVisible(this._mVisibleNavigationItems[r.sId]);if(v&&i.setSelectedItem){i.setSelectedItem(s);}}.bind(this));this._updateDialogTitle();this._setVisibleOfNavigationControl(this._isNavigationControlExpected());};
o.prototype._determineInitialVisiblePanel=function(){if(this.getInitialVisiblePanelType()){for(var i=0;i<this.getPanels().length;i++){if(this.getPanels()[i].getType()==this.getInitialVisiblePanelType()){return this.getPanels()[i].sId;}}}var I;this.getPanels().some(function(r){if(this._mVisibleNavigationItems[r.sId]){I=r.sId;return true;}}.bind(this));return I;};
o.prototype._requestRequiredNavigationControls=function(){var s=b.system.phone?"sap/m/List":"sap/m/IconTabBar";var i=b.system.phone?"sap/m/StandardListItem":"sap/m/IconTabFilter";N=sap.ui.require(s);n=sap.ui.require(i);if(N&&n){this._bNavigationControlsPromiseResolved=true;return Promise.resolve();}if(!this._oNavigationControlsPromise){this._oNavigationControlsPromise=new Promise(function(r){sap.ui.require([s,i],function(t,u){N=t;n=u;this._bNavigationControlsPromiseResolved=true;return r();}.bind(this));}.bind(this));}return this._oNavigationControlsPromise;};
return o;});
sap.ui.predefine('sap/m/P13nDimMeasureItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nDimMeasureItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string"},index:{type:"int",defaultValue:-1},visible:{type:"boolean"},role:{type:"string"}}}});
return P;});
sap.ui.predefine('sap/m/P13nDimMeasurePanel',['./library','./P13nPanel','./P13nDimMeasureItem','./SearchField','./Table','./Column','./ColumnListItem','./ScrollContainer','./Text','./Select','./ComboBox','./Button','./OverflowToolbar','./OverflowToolbarLayoutData','./OverflowToolbarButton','./ToolbarSpacer','sap/ui/core/library','sap/ui/model/ChangeReason','sap/ui/model/json/JSONModel','sap/ui/model/BindingMode','sap/ui/core/ResizeHandler','sap/ui/core/Item','sap/ui/core/InvisibleText','sap/ui/core/IconPool',"sap/ui/thirdparty/jquery"],function(l,P,c,S,T,C,d,e,f,g,h,B,O,i,j,k,m,n,J,o,R,I,p,q,Q){"use strict";var r=l.OverflowToolbarPriority;var s=l.ButtonType;var t=l.ToolbarDesign;var L=l.ListType;var u=l.ListMode;var v=l.P13nPanelType;
var w=P.extend("sap.m.P13nDimMeasurePanel",{
metadata:{library:"sap.m",properties:{chartTypeKey:{type:"string",defaultValue:""}},aggregations:{dimMeasureItems:{type:"sap.m.P13nDimMeasureItem",multiple:true,singularName:"dimMeasureItem",bindable:"bindable"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},availableChartTypes:{type:"sap.ui.core.Item",multiple:true,singularName:"availableChartType"}},events:{changeDimMeasureItems:{},changeChartType:{}}},
renderer:{apiVersion:2,render:function(a,b){a.openStart("div",b);a.class("sapMP13nColumnsPanel");a.openEnd();b.getAggregation("content").forEach(function(x){a.renderControl(x);});a.close("div");}}
});
w.prototype.init=function(){var a=this;this._iLiveChangeTimer=0;this._iSearchTimer=0;this._bIgnoreUpdateInternalModel=false;this._bUpdateInternalModel=true;this._bOnAfterRenderingFirstTimeExecuted=false;var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.oAvailableRoleTypes={Dimension:[{key:"category",text:b.getText('COLUMNSPANEL_CHARTROLE_CATEGORY')},{key:"category2",text:b.getText('COLUMNSPANEL_CHARTROLE_CATEGORY2')},{key:"series",text:b.getText('COLUMNSPANEL_CHARTROLE_SERIES')}],Measure:[{key:"axis1",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS1')},{key:"axis2",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS2')},{key:"axis3",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS3')},{key:"axis4",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS4')}]};var M=new J({availableChartTypes:[],selectedChartTypeKey:null,items:[],columnKeyOfMarkedItem:undefined,isMoveDownButtonEnabled:undefined,isMoveUpButtonEnabled:undefined,showOnlySelectedItems:undefined,countOfSelectedItems:0,countOfItems:0});M.setDefaultBindingMode(o.TwoWay);M.setSizeLimit(1000);this.setModel(M,"$sapmP13nDimMeasurePanel");this.setType(v.dimeasure);this.setTitle(b.getText("CHARTPANEL_TITLE"));this._createTable();this._createToolbar();this.setVerticalScrolling(false);var x=new e({horizontal:false,vertical:true,content:[this._oTable],width:'100%',height:'100%'});this.addAggregation("content",x);this._fnHandleResize=function(){var y=false,z,A;if(a.getParent){var $=null,D,H;var E=a.getParent();var F=a._getToolbar();if(E&&E.$){$=E.$("cont");if($.children().length>0&&F.$().length>0){z=x.$()[0].clientHeight;D=$.children()[0].clientHeight;H=F?F.$()[0].clientHeight:0;A=D-H;if(z!==A){x.setHeight(A+'px');y=true;}}}}return y;};this._sContainerResizeListener=R.register(x,this._fnHandleResize);};
w.prototype.onBeforeRendering=function(){this._updateInternalModel();if(!this._getInternalModel().getProperty("/columnKeyOfMarkedItem")){this._setColumnKeyOfMarkedItem(this._getColumnKeyByTableItem(this._getVisibleTableItems()[0]));}this._switchMarkedTableItemTo(this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem")));this._updateControlLogic();};
w.prototype.onAfterRendering=function(){var a=this;if(!this._bOnAfterRenderingFirstTimeExecuted){this._bOnAfterRenderingFirstTimeExecuted=true;window.clearTimeout(this._iLiveChangeTimer);this._iLiveChangeTimer=window.setTimeout(function(){a._fnHandleResize();a._getToolbar()._resetAndInvalidateToolbar();},0);}};
w.prototype.getOkPayload=function(){this._updateInternalModel();this._getInternalModel().getProperty("/items").forEach(function(M){if(this._getDimMeasureItemByColumnKey(M.columnKey)){return;}if(!M.persistentSelected){return;}this.addAggregation("dimMeasureItems",new c({columnKey:M.columnKey,visible:M.persistentSelected,index:M.persistentIndex===-1?undefined:M.persistentIndex,role:M.role}));},this);return{dimMeasureItems:this.getDimMeasureItems(),chartTypeKey:this.getChartTypeKey()};};
w.prototype.exit=function(){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;this._getToolbar().destroy();this._oTable.destroy();this._oTable=null;if(this._getInternalModel()){this._getInternalModel().destroy();}if(this.oInvisibleChartTypeText){this.oInvisibleChartTypeText.destroy();this.oInvisibleChartTypeText=null;}window.clearTimeout(this._iLiveChangeTimer);window.clearTimeout(this._iSearchTimer);};
w.prototype.addItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("items",a);return this;};
w.prototype.insertItem=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("items",a,b);return this;};
w.prototype.removeItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}a=this.removeAggregation("items",a);return a;};
w.prototype.removeAllItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("items");};
w.prototype.destroyItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("items");return this;};
w.prototype.addDimMeasureItem=function(D){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("dimMeasureItems",D);return this;};
w.prototype.insertDimMeasureItem=function(D,a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("dimMeasureItems",D,a);return this;};
w.prototype.updateDimMeasureItems=function(a){this.updateAggregation("dimMeasureItems");if(a===n.Change&&!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}};
w.prototype.removeDimMeasureItem=function(D){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("dimMeasureItems",D);};
w.prototype.removeAllDimMeasureItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("dimMeasureItems");};
w.prototype.destroyDimMeasureItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("dimMeasureItems");return this;};
w.prototype.setChartTypeKey=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.setProperty("chartTypeKey",a);return this;};
w.prototype.addAvailableChartType=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("availableChartTypes",a);return this;};
w.prototype.insertAvailableChartType=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("availableChartTypes",a,b);return this;};
w.prototype.removeAvailableChartType=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("availableChartTypes",a);};
w.prototype.removeAllAvailableChartType=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("availableChartTypes");};
w.prototype.destroyAvailableChartType=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("availableChartTypes");return this;};
w.prototype._notifyChange=function(){var a=this.getChangeNotifier();if(a){a(this);}};
w.prototype._scrollToSelectedItem=function(a){if(!a){return;}sap.ui.getCore().applyChanges();if(a.getDomRef()){a.focus();}};
w.prototype._getInternalModel=function(){return this.getModel("$sapmP13nDimMeasurePanel");};
w.prototype._createTable=function(){var a=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTable=new T({mode:u.MultiSelect,rememberSelections:false,itemPress:Q.proxy(this._onItemPressed,this),selectionChange:Q.proxy(this._onSelectionChange,this),columns:[new C({vAlign:m.VerticalAlign.Middle,header:new f({text:{parts:[{path:'/countOfSelectedItems'},{path:'/countOfItems'}],formatter:function(b,x){return a.getText('COLUMNSPANEL_SELECT_ALL_WITH_COUNTER',[b,x]);}}})}),new C({vAlign:m.VerticalAlign.Middle,header:new f({text:a.getText('COLUMNSPANEL_COLUMN_TYPE')})}),new C({vAlign:m.VerticalAlign.Middle,header:new f({text:a.getText('COLUMNSPANEL_COLUMN_ROLE')})})],items:{path:"/items",templateShareable:false,template:new d({cells:[new f({text:"{text}"}),new f({text:{path:'',formatter:function(M){if(M.aggregationRole==="Dimension"){return a.getText('COLUMNSPANEL_TYPE_DIMENSION');}if(M.aggregationRole==="Measure"){return a.getText('COLUMNSPANEL_TYPE_MEASURE');}}}}),new g({selectedKey:"{role}",items:{path:'availableRoleTypes',factory:function(b,x){var A=x.getObject();return new I({key:A.key,text:A.text});}},change:Q.proxy(this._onRoleChange,this)})],visible:"{visible}",selected:"{persistentSelected}",tooltip:"{tooltip}",type:L.Active})}});this._oTable.setModel(this._getInternalModel());};
w.prototype._createToolbar=function(){var a=this;var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");var x=new p({text:b.getText('COLUMNSPANEL_CHARTTYPE')});this.oInvisibleChartTypeText=x;var y=new h({placeholder:x.getText(),selectedKey:{path:'/selectedChartTypeKey'},ariaLabelledBy:x,items:{path:'/availableChartTypes',templateShareable:false,template:new I({key:"{key}",text:"{text}"})},selectionChange:Q.proxy(this._onChartTypeChange,this),layoutData:new i({moveToOverflow:false,stayInOverflow:false})});var z=new O(this.getId()+"-toolbar",{design:t.Auto,content:[x,y,new k(),new S(this.getId()+"-searchField",{liveChange:function(E){var V=E.getSource().getValue(),D=(V?300:0);window.clearTimeout(a._iSearchTimer);if(D){a._iSearchTimer=window.setTimeout(function(){a._onExecuteSearch();},D);}else{a._onExecuteSearch();}},search:Q.proxy(this._onExecuteSearch,this),layoutData:new i({minWidth:"12.5rem",maxWidth:"23.077rem",shrinkable:true,moveToOverflow:false,stayInOverflow:false})}),new B({text:{path:'/showOnlySelectedItems',formatter:function(A){return A?b.getText('COLUMNSPANEL_SHOW_ALL'):b.getText('COLUMNSPANEL_SHOW_SELECTED');}},tooltip:{path:'/showOnlySelectedItems',formatter:function(A){return A?b.getText('COLUMNSPANEL_SHOW_ALL'):b.getText('COLUMNSPANEL_SHOW_SELECTED');}},type:s.Transparent,press:Q.proxy(this._onSwitchButtonShowSelected,this),layoutData:new i({moveToOverflow:true,priority:r.High})}),new j({icon:q.getIconURI("collapse-group"),text:b.getText('COLUMNSPANEL_MOVE_TO_TOP'),tooltip:b.getText('COLUMNSPANEL_MOVE_TO_TOP'),type:s.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:Q.proxy(this.onPressButtonMoveToTop,this),layoutData:new i({moveToOverflow:true,priority:r.Low,group:2})}),new j({icon:q.getIconURI("navigation-up-arrow"),text:b.getText('COLUMNSPANEL_MOVE_UP'),tooltip:b.getText('COLUMNSPANEL_MOVE_UP'),type:s.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:Q.proxy(this.onPressButtonMoveUp,this),layoutData:new i({moveToOverflow:true,priority:r.High,group:1})}),new j({icon:q.getIconURI("navigation-down-arrow"),text:b.getText('COLUMNSPANEL_MOVE_DOWN'),tooltip:b.getText('COLUMNSPANEL_MOVE_DOWN'),type:s.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:Q.proxy(this.onPressButtonMoveDown,this),layoutData:new i({moveToOverflow:true,priority:r.High,group:1})}),new j({icon:q.getIconURI("expand-group"),text:b.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),tooltip:b.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),type:s.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:Q.proxy(this.onPressButtonMoveToBottom,this),layoutData:new i({moveToOverflow:true,priority:r.Low,group:2})})]});z.setModel(this._getInternalModel());this.addAggregation("content",z);};
w.prototype.onPressButtonMoveToTop=function(){this._moveMarkedTableItem(this._getMarkedTableItem(),this._getVisibleTableItems()[0]);};
w.prototype.onPressButtonMoveUp=function(){var V=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),V[V.indexOf(this._getMarkedTableItem())-1]);};
w.prototype.onPressButtonMoveDown=function(){var V=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),V[V.indexOf(this._getMarkedTableItem())+1]);};
w.prototype.onPressButtonMoveToBottom=function(){var V=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),V[V.length-1]);};
w.prototype._onSwitchButtonShowSelected=function(){this._getInternalModel().setProperty("/showOnlySelectedItems",!this._getInternalModel().getProperty("/showOnlySelectedItems"));this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();this._fnHandleResize();};
w.prototype._onExecuteSearch=function(){this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._updateControlLogic();};
w.prototype._switchVisibilityOfUnselectedModelItems=function(){var b=this._isFilteredByShowSelected();var M=this._getInternalModel().getProperty("/items");M.forEach(function(a){if(a.persistentSelected){a.visible=true;return;}a.visible=!b;});this._getInternalModel().setProperty("/items",M);};
w.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
w.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
w.prototype._moveMarkedTableItem=function(a,b){var M=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(a));var x=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(b));var y=this._getModelItemIndexByColumnKey(M.columnKey);var z=this._getModelItemIndexByColumnKey(x.columnKey);this._moveModelItems(y,z);this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();this._fireChangeDimMeasureItems();this._notifyChange();};
w.prototype._moveModelItems=function(a,b){var M=this._getInternalModel().getProperty("/items");if(a<0||b<0||a>M.length-1||b>M.length-1){return false;}this._removeStyleOfMarkedTableItem();var x=M.splice(a,1);M.splice(b,0,x[0]);this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._switchMarkedTableItemTo(this._getMarkedTableItem());return true;};
w.prototype._getModelItemByColumnKey=function(a){var M=this._getInternalModel().getProperty("/items").filter(function(b){return b.columnKey===a;});return M[0];};
w.prototype._updateCounts=function(M){var a=0;var b=0;M.forEach(function(x){a++;if(x.persistentSelected){b++;}});this._getInternalModel().setProperty("/countOfItems",a);this._getInternalModel().setProperty("/countOfSelectedItems",b);};
w.prototype._sortModelItemsByPersistentIndex=function(M){var x;var y=sap.ui.getCore().getConfiguration().getLocale().toString();try{if(typeof window.Intl!=='undefined'){x=window.Intl.Collator(y,{numeric:true});}}catch(E){}M.forEach(function(a,b){a.localIndex=b;});M.sort(function(a,b){if(a.persistentSelected===true&&(b.persistentSelected===false||b.persistentSelected===undefined)){return-1;}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&b.persistentSelected===true){return 1;}else if(a.persistentSelected===true&&b.persistentSelected===true){if(a.persistentIndex>-1&&a.persistentIndex<b.persistentIndex){return-1;}else if(b.persistentIndex>-1&&a.persistentIndex>b.persistentIndex){return 1;}else{return a.localIndex-b.localIndex;}}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&(b.persistentSelected===false||b.persistentSelected===undefined)){return x?x.compare(a.text,b.text):a.text.localeCompare(b.text,y,{numeric:true});}});M.forEach(function(a){delete a.localIndex;});};
w.prototype._getColumnKeyByTableItem=function(a){var b=this._oTable.indexOfItem(a);if(b<0){return null;}return this._oTable.getBinding("items").getContexts(undefined,undefined,undefined,true)[b].getObject().columnKey;};
w.prototype._getModelItemIndexByColumnKey=function(a){var b=-1;this._getInternalModel().getData().items.some(function(M,x){if(M.columnKey===a){b=x;return true;}});return b;};
w.prototype._getSelectedModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return M.persistentSelected;});};
w.prototype._getVisibleTableItems=function(){return this._oTable.getItems().filter(function(a){return a.getVisible();});};
w.prototype._getTableItemByColumnKey=function(a){var b=this._oTable.getBinding("items").getContexts();var x=this._oTable.getItems().filter(function(y,z){return b[z].getObject().columnKey===a;});return x[0];};
w.prototype._getToolbar=function(){return sap.ui.getCore().byId(this.getId()+"-toolbar")||null;};
w.prototype._getSearchField=function(){return sap.ui.getCore().byId(this.getId()+"-searchField")||null;};
w.prototype._getSearchText=function(){var a=this._getSearchField();return a?a.getValue():"";};
w.prototype._isFilteredBySearchText=function(){return!!this._getSearchText().length;};
w.prototype._isFilteredByShowSelected=function(){return this._getInternalModel().getData().showOnlySelectedItems;};
w.prototype._updateControlLogic=function(){var b=this._isFilteredBySearchText();var a=this._isFilteredByShowSelected();var V=this._getVisibleTableItems();this._getInternalModel().setProperty("/isMoveUpButtonEnabled",V.indexOf(this._getMarkedTableItem())>0);this._getInternalModel().setProperty("/isMoveDownButtonEnabled",V.indexOf(this._getMarkedTableItem())>-1&&V.indexOf(this._getMarkedTableItem())<V.length-1);var x=sap.ui.getCore().byId(this._oTable.getId()+'-sa');if(x){x.setEnabled(!b&&!a);}};
w.prototype._updateModelItemsPersistentIndex=function(M){var a=-1;M.forEach(function(b){b.persistentIndex=-1;if(b.persistentSelected){a++;b.persistentIndex=a;}});};
w.prototype._fireChangeDimMeasureItems=function(){this._bIgnoreUpdateInternalModel=true;this.fireChangeDimMeasureItems({items:this._getInternalModel().getProperty("/items").map(function(M){return{columnKey:M.columnKey,visible:M.persistentSelected,index:M.persistentIndex===-1?undefined:M.persistentIndex,role:M.role};})});this._bIgnoreUpdateInternalModel=false;};
w.prototype._fireChangeChartType=function(){this._bIgnoreUpdateInternalModel=true;this.fireChangeChartType({chartTypeKey:this._getInternalModel().getProperty("/selectedChartTypeKey")});this._bIgnoreUpdateInternalModel=false;};
w.prototype._getDimMeasureItemByColumnKey=function(a){var D=this.getDimMeasureItems().filter(function(b){return b.getColumnKey()===a;});return D[0];};
w.prototype._getMarkedTableItem=function(){return this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem"));};
w.prototype._setColumnKeyOfMarkedItem=function(a){this._getInternalModel().setProperty("/columnKeyOfMarkedItem",a);};
w.prototype._onItemPressed=function(E){this._switchMarkedTableItemTo(E.getParameter('listItem'));this._updateControlLogic();};
w.prototype._onChartTypeChange=function(E){this._fireChangeChartType();this._notifyChange();};
w.prototype._onRoleChange=function(E){this._fireChangeDimMeasureItems();this._notifyChange();};
w.prototype._onSelectionChange=function(E){if(!E.getParameter("selectAll")&&E.getParameter("listItems").length===1){this._switchMarkedTableItemTo(E.getParameter("listItem"));}this._selectTableItem();};
w.prototype._selectTableItem=function(){this._updateControlLogic();var M=this._getInternalModel().getProperty("/items");this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._fireChangeDimMeasureItems();this._notifyChange();};
w.prototype._switchMarkedTableItemTo=function(a){this._removeStyleOfMarkedTableItem();var b=this._getColumnKeyByTableItem(a);if(b){this._setColumnKeyOfMarkedItem(b);a.addStyleClass("sapMP13nColumnsPanelItemSelected");}};
w.prototype._removeStyleOfMarkedTableItem=function(){if(this._getMarkedTableItem()){this._getMarkedTableItem().removeStyleClass("sapMP13nColumnsPanelItemSelected");}};
w.prototype._filterModelItemsBySearchText=function(){var a=this._getSearchText();a=a.replace(/(^\s+)|(\s+$)/g,'');a=a.replace(/[-\/\\^$*+?.()|[\]{}]/g,'\\$&');var b=new RegExp(a,'igm');if(!b){return;}this._getVisibleModelItems().forEach(function(M){var x=this._getTableItemByColumnKey(M.columnKey);var y=x.getCells();M.visible=false;if(y[0]&&y[0].getText().match(b)){M.visible=true;}if(y[1]&&y[1].getText().match(b)){M.visible=true;}if(y[2]&&y[2].getSelectedItem()&&y[2].getSelectedItem().getText().match(b)){M.visible=true;}if(M.tooltip&&M.tooltip.match(b)){M.visible=true;}},this);this._getInternalModel().refresh();};
w.prototype._updateInternalModel=function(){if(!this._bUpdateInternalModel){return;}this._bUpdateInternalModel=false;this._removeStyleOfMarkedTableItem();this._getInternalModel().setProperty("/items",this.getItems().map(function(a){return{columnKey:a.getColumnKey(),visible:true,text:a.getText(),tooltip:a.getTooltip(),aggregationRole:a.getAggregationRole(),availableRoleTypes:this.oAvailableRoleTypes[a.getAggregationRole()],role:a.getRole(),persistentIndex:-1,persistentSelected:undefined};},this));this._getInternalModel().setProperty("/selectedChartTypeKey",this.getChartTypeKey());this._getInternalModel().setProperty("/availableChartTypes",this.getAvailableChartTypes().map(function(a){return{key:a.getKey(),text:a.getText()};},this));this.getDimMeasureItems().forEach(function(D){var a=this._getModelItemByColumnKey(D.getColumnKey());if(!a){return;}if(D.getIndex()!==undefined){a.persistentIndex=D.getIndex();}if(D.getVisible()!==undefined){a.persistentSelected=D.getVisible();}if(D.getRole()!==undefined){a.role=D.getRole();}},this);this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();var M=this._getInternalModel().getProperty("/items");this._sortModelItemsByPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._switchMarkedTableItemTo(this._getMarkedTableItem());};
return w;});
sap.ui.predefine('sap/m/P13nFilterItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nFilterItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},value1:{type:"string",group:"Misc",defaultValue:null},value2:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null},exclude:{type:"boolean",group:"Misc",defaultValue:false}}}});
P.prototype.setOperation=function(o){return this.setProperty("operation",o,true);};
P.prototype.setColumnKey=function(k){return this.setProperty("columnKey",k,true);};
P.prototype.setValue1=function(v){return this.setProperty("value1",v,true);};
P.prototype.setValue2=function(v){return this.setProperty("value2",v,true);};
P.prototype.setExclude=function(e){return this.setProperty("exclude",e,true);};
return P;});
sap.ui.predefine('sap/m/P13nFilterPanel',['./P13nConditionPanel','./P13nPanel','./library','sap/m/Panel','./P13nFilterItem','./P13nOperationsHelper','sap/m/P13nFilterPanelRenderer'],function(P,a,l,b,c,d,e){"use strict";var f=l.P13nPanelType;var g=l.P13nConditionOperation;
var h=a.extend("sap.m.P13nFilterPanel",{
metadata:{library:"sap.m",properties:{maxIncludes:{type:"string",group:"Misc",defaultValue:'-1'},maxExcludes:{type:"string",group:"Misc",defaultValue:'-1'},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null},enableEmptyOperations:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},filterItems:{type:"sap.m.P13nFilterItem",multiple:true,singularName:"filterItem",bindable:"bindable"},messageStrip:{type:"sap.m.MessageStrip",multiple:false}},events:{addFilterItem:{},removeFilterItem:{},updateFilterItem:{},filterItemChanged:{parameters:{reason:{type:"string"},key:{type:"string"},index:{type:"int"},itemData:{type:"object"}}}}},
renderer:e.renderer
});
h.prototype.setConditions=function(C){var I=[];var E=[];if(C.length){for(var i=0;i<C.length;i++){var o=C[i];if(!o.exclude){I.push(o);}else{E.push(o);}}}this._oIncludeFilterPanel.setConditions(I);this._oExcludeFilterPanel.setConditions(E);if(E.length>0){this._oExcludePanel.setExpanded(true);}return this;};
h.prototype.getConditions=function(){var i=this._oIncludeFilterPanel.getConditions();var E=this._oExcludeFilterPanel.getConditions();return i.concat(E);};
h.prototype.setContainerQuery=function(C){this.setProperty("containerQuery",C);this._oIncludeFilterPanel.setContainerQuery(C);this._oExcludeFilterPanel.setContainerQuery(C);return this;};
h.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oIncludeFilterPanel.setLayoutMode(m);this._oExcludeFilterPanel.setLayoutMode(m);return this;};
h.prototype.validateConditions=function(){return this._oIncludeFilterPanel.validateConditions()&&this._oExcludeFilterPanel.validateConditions();};
h.prototype.removeInvalidConditions=function(){this._oIncludeFilterPanel.removeInvalidConditions();this._oExcludeFilterPanel.removeInvalidConditions();};
h.prototype.removeValidationErrors=function(){this._oIncludeFilterPanel.removeValidationErrors();this._oExcludeFilterPanel.removeValidationErrors();};
h.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
h.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
h.prototype.setIncludeOperations=function(o,t){t=t||"default";this._aIncludeOperations[t]=o;if(this._oIncludeFilterPanel){this._oIncludeFilterPanel.setOperations(this._aIncludeOperations[t],t);}};
h.prototype.getIncludeOperations=function(t){if(this._oIncludeFilterPanel){return this._oIncludeFilterPanel.getOperations(t);}};
h.prototype.setExcludeOperations=function(o,t){t=t||"default";this._aExcludeOperations[t]=o;if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setOperations(this._aExcludeOperations[t],t);}};
h.prototype.getExcludeOperations=function(t){if(this._oExcludeFilterPanel){return this._oExcludeFilterPanel.getOperations(t);}};
h.prototype.setKeyFields=function(k,K){this._aKeyFields=k;if(this._oIncludeFilterPanel){k.some(function(o){if(o.isDefault){this._oIncludeFilterPanel.setAutoAddNewRow(true);}}.bind(this));this._oIncludeFilterPanel.setKeyFields(k);}if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setKeyFields((Array.isArray(K)&&K.length>0)?K:k);}};
h.prototype.getKeyFields=function(){return this._aKeyFields;};
h.prototype.setMaxIncludes=function(m){this.setProperty("maxIncludes",m);if(this._oIncludeFilterPanel){this._oIncludeFilterPanel.setMaxConditions(m);}this._updatePanel();return this;};
h.prototype.setMaxExcludes=function(m){this.setProperty("maxExcludes",m);if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setMaxConditions(m);}this._updatePanel();return this;};
h.prototype._updatePanel=function(){var m=this.getMaxIncludes()==="-1"?1000:parseInt(this.getMaxIncludes());var M=this.getMaxExcludes()==="-1"?1000:parseInt(this.getMaxExcludes());if(m>0){if(M<=0){this._oIncludePanel.setHeaderText(null);this._oIncludePanel.setExpandable(false);this._oIncludePanel.addStyleClass("panelTopMargin");this._oIncludePanel.addStyleClass("panelNoHeader");}}if(M===0){this._oExcludePanel.setHeaderText(null);this._oExcludePanel.setExpandable(false);this._oExcludePanel.addStyleClass("panelNoHeader");}};
h.prototype.init=function(){this.setType(f.filter);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("FILTERPANEL_TITLE"));this._aKeyFields=[];this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._aIncludeOperations={};this._aExcludeOperations={};this._oIncludePanel=new b({expanded:true,expandable:true,headerText:this._oRb.getText("FILTERPANEL_INCLUDES"),width:"auto"}).addStyleClass("sapMFilterPadding");this._oIncludeFilterPanel=new P({maxConditions:this.getMaxIncludes(),alwaysShowAddIcon:false,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oIncludeFilterPanel._sAddRemoveIconTooltipKey="FILTER";this._oIncludePanel.addContent(this._oIncludeFilterPanel);this.addAggregation("content",this._oIncludePanel);this._oExcludePanel=new b({expanded:false,expandable:true,headerText:this._oRb.getText("FILTERPANEL_EXCLUDES"),width:"auto"}).addStyleClass("sapMFilterPadding");this._oExcludeFilterPanel=new P({exclude:true,maxConditions:this.getMaxExcludes(),alwaysShowAddIcon:false,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oExcludeFilterPanel._sAddRemoveIconTooltipKey="FILTER";if(!this._oOperationsHelper){this._oOperationsHelper=new d();}this._updateOperations();var t;for(t in this._aExcludeOperations){this._oExcludeFilterPanel.setOperations(this._aExcludeOperations[t],t);}for(t in this._aIncludeOperations){this._oIncludeFilterPanel.setOperations(this._aIncludeOperations[t],t);}this._oExcludePanel.addContent(this._oExcludeFilterPanel);this.addAggregation("content",this._oExcludePanel);this._updatePanel();};
h.prototype.exit=function(){var i=function(o){if(o&&o.destroy){o.destroy();}return null;};this._oOperationsHelper=i(this._oOperationsHelper);this._aKeyFields=i(this._aKeyFields);this._aIncludeOperations=i(this._aIncludeOperations);this._aExcludeOperations=i(this._aExcludeOperations);this._oRb=i(this._oRb);};
h.prototype.onBeforeRendering=function(){var k=[],K,m,E=this.getEnableEmptyOperations();if(this._bUpdateRequired){this._bUpdateRequired=false;var M=this.getMessageStrip();if(M){M.addStyleClass("sapUiResponsiveMargin");this.insertAggregation("content",M,0);}K=[];m=(this.getBindingInfo("items")||{}).model;var G=function(n,o,i){var B=i.getBinding(n),j=i.getMetadata(),p=j.hasProperty(n)?j.getProperty(n).get(i):j.getAggregation(n).get(i),v;if(B&&o){v=o.getObject()[B.getPath()];if(n==="text"){return v||v===""?v:p;}else{return v;}}return p;};this.getItems().forEach(function(i){var o=i.getBindingContext(m),F,n,j;if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}K.push(F={key:i.getColumnKey(),text:G("text",o,i),tooltip:G("tooltip",o,i),maxLength:G("maxLength",o,i),type:G("type",o,i),typeInstance:G("typeInstance",o,i),formatSettings:G("formatSettings",o,i),precision:G("precision",o,i),scale:G("scale",o,i),isDefault:G("isDefault",o,i),values:G("values",o,i)});if(E){n=i.getNullable();j={};Object.keys(F).forEach(function(s){j[s]=F[s];});k.push(j);this._enhanceFieldOperationsWithEmpty(j,n,true);this._enhanceFieldOperationsWithEmpty(F,n);this._modifyFieldOperationsBasedOnMaxLength(j);}this._modifyFieldOperationsBasedOnMaxLength(F);},this);this.setKeyFields(K,k);var C=[];m=(this.getBindingInfo("filterItems")||{}).model;this.getFilterItems().forEach(function(F){var o=F.getBindingContext(m);if(F.getBinding("key")&&o){o.getObject()[F.getBinding("key").getPath()]=F.getKey();}C.push({key:F.getKey(),keyField:G("columnKey",o,F),operation:G("operation",o,F),value1:G("value1",o,F),value2:G("value2",o,F),exclude:G("exclude",o,F)});});this.setConditions(C);}};
h.prototype._updateOperations=function(){this._oOperationsHelper.getIncludeTypes().forEach(function(t){this.setIncludeOperations(this._oOperationsHelper.getIncludeOperationsByType(t),t);}.bind(this));this._oOperationsHelper.getExcludeTypes().forEach(function(t){this.setExcludeOperations(this._oOperationsHelper.getExcludeOperationsByType(t),t);}.bind(this));};
h.prototype._enableEnhancedExcludeOperations=function(){if(this._oOperationsHelper){this._oOperationsHelper.setUseExcludeOperationsExtended();}this._updateOperations();};
h.prototype._modifyFieldOperationsBasedOnMaxLength=function(F){var o;if(F.maxLength===1||F.maxLength==="1"){o=F.operations?F.operations:this._oIncludeFilterPanel.getOperations(F.type);F.operations=[];o.forEach(function(O){if([g.Contains,g.StartsWith,g.EndsWith].indexOf(O)===-1){F.operations.push(O);}},this);}};
h.prototype._enhanceFieldOperationsWithEmpty=function(F,n,E){var o,O;if(["string","stringdate"].indexOf(F.type)>-1||(["date","datetime"].indexOf(F.type)>-1&&n)){o=this[E?"_oExcludeFilterPanel":"_oIncludeFilterPanel"];O=o.getOperations(F.type);if(!O){O=o.getOperations();}if(!Array.isArray(F.operations)){F.operations=[];}O.forEach(function(s){F.operations.push(s);});if(F.operations.indexOf(g.Empty)===-1){F.operations.push(g.Empty);}}};
h.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
h.prototype.removeItem=function(i){var r=a.prototype.removeItem.apply(this,arguments);this._bUpdateRequired=true;return r;};
h.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
h.prototype.addFilterItem=function(F){this.addAggregation("filterItems",F,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
h.prototype.insertFilterItem=function(F,i){this.insertAggregation("filterItems",F,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
h.prototype.updateFilterItems=function(r){this.updateAggregation("filterItems");if(r==="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;this.invalidate();}};
h.prototype.setMessageStrip=function(m){this.setAggregation("messageStrip",m,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
h.prototype.updateMessageStrip=function(r){this.updateAggregation("messageStrip");if(r==="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
h.prototype.removeFilterItem=function(F){F=this.removeAggregation("filterItems",F,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return F;};
h.prototype.removeAllFilterItems=function(){var F=this.removeAllAggregation("filterItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return F;};
h.prototype.destroyFilterItems=function(){this.destroyAggregation("filterItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
h.prototype._handleDataChange=function(){var t=this;return function(E){var n=E.getParameter("newData");var o=E.getParameter("operation");var k=E.getParameter("key");var C=E.getParameter("index");var F;var I=-1;var j=E.getSource()===t._oExcludeFilterPanel;t.getFilterItems().some(function(m,i){if((!m.getExclude()&&!j)||(m.getExclude()&&j)){C--;}I=i;return C<0;},this);switch(o){case"update":F=t.getFilterItems()[I];if(F){F.setExclude(n.exclude);F.setColumnKey(n.keyField);F.setOperation(n.operation);F.setValue1(n.value1);F.setValue2(n.value2);}t.fireUpdateFilterItem({key:k,index:I,filterItemData:F});t.fireFilterItemChanged({reason:"updated",key:k,index:I,itemData:{columnKey:n.keyField,operation:n.operation,exclude:n.exclude,value1:n.value1,value2:n.value2}});break;case"add":if(C>=0){I++;}F=new c({columnKey:n.keyField,exclude:n.exclude,operation:n.operation});F.setValue1(n.value1);F.setValue2(n.value2);t._bIgnoreBindCalls=true;t.fireAddFilterItem({key:k,index:I,filterItemData:F});t.fireFilterItemChanged({reason:"added",key:k,index:I,itemData:{columnKey:n.keyField,operation:n.operation,exclude:n.exclude,value1:n.value1,value2:n.value2}});t._bIgnoreBindCalls=false;break;case"remove":t._bIgnoreBindCalls=true;t.fireRemoveFilterItem({key:k,index:I});t.fireFilterItemChanged({reason:"removed",key:k,index:I});t._bIgnoreBindCalls=false;break;default:throw"Operation'"+o+"' is not supported yet";}t._notifyChange();};};
h.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return h;});
sap.ui.predefine('sap/m/P13nGroupItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nGroupItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null},showIfGrouped:{type:"boolean",group:"Misc",defaultValue:false}}}});
P.prototype.setColumnKey=function(v){return this.setProperty("columnKey",v,true);};
P.prototype.setOperation=function(v){return this.setProperty("operation",v,true);};
P.prototype.setShowIfGrouped=function(v){return this.setProperty("showIfGrouped",v,true);};
return P;});
sap.ui.predefine('sap/m/P13nGroupPanel',['./library','./P13nConditionPanel','./P13nPanel','./P13nGroupItem',"sap/ui/thirdparty/jquery"],function(l,P,a,c,q){"use strict";var d=l.P13nPanelType;var e=l.P13nConditionOperation;
var f=a.extend("sap.m.P13nGroupPanel",{
metadata:{deprecated:true,library:"sap.m",properties:{maxGroups:{type:"string",group:"Misc",defaultValue:'-1'},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},groupItems:{type:"sap.m.P13nGroupItem",multiple:true,singularName:"groupItem",bindable:"bindable"}},events:{addGroupItem:{parameters:{}},removeGroupItem:{},updateGroupItem:{}}},
renderer:{apiVersion:2,render:function(r,C){r.openStart("section",C);r.class("sapMGroupPanel");r.openEnd();r.openStart("div");r.class("sapMGroupPanelContent");r.class("sapMGroupPanelBG");r.openEnd();C.getAggregation("content").forEach(function(o){r.renderControl(o);});r.close("div");r.close("section");}}
});
f.prototype.setMaxGroups=function(m){this.setProperty("maxGroups",m);if(this._oGroupPanel){this._oGroupPanel.setMaxConditions(m);}return this;};
f.prototype._getConditions=function(){return this._oGroupPanel.getConditions();};
f.prototype.setContainerQuery=function(b){this.setProperty("containerQuery",b);this._oGroupPanel.setContainerQuery(b);return this;};
f.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oGroupPanel.setLayoutMode(m);return this;};
f.prototype.validateConditions=function(){return this._oGroupPanel.validateConditions();};
f.prototype.removeInvalidConditions=function(){this._oGroupPanel.removeInvalidConditions();};
f.prototype.removeValidationErrors=function(){this._oGroupPanel.removeValidationErrors();};
f.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
f.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
f.prototype.setOperations=function(o){this._aOperations=o;if(this._oGroupPanel){this._oGroupPanel.setOperations(this._aOperations);}};
f.prototype.init=function(){this.setType(d.group);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("GROUPPANEL_TITLE"));this._aKeyFields=[];if(!this._aOperations){this.setOperations([e.GroupAscending,e.GroupDescending]);}this._oGroupPanel=new P({maxConditions:this.getMaxGroups(),autoReduceKeyFieldItems:true,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange(),validationExecutor:q.proxy(this._callValidationExecutor,this)});this._oGroupPanel.setOperations(this._aOperations);this._oGroupPanel._sAddRemoveIconTooltipKey="GROUP";this.addAggregation("content",this._oGroupPanel);};
f.prototype.exit=function(){var b=function(o){if(o&&o.destroy){o.destroy();}return null;};this._aKeyFields=b(this._aKeyFields);this._aOperations=b(this._aOperations);};
f.prototype.onBeforeRendering=function(){if(this._bUpdateRequired){this._bUpdateRequired=false;var k=[];var m=(this.getBindingInfo("items")||{}).model;this.getItems().forEach(function(i){var o=i.getBindingContext(m);if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}k.push({key:i.getColumnKey(),text:i.getText(),tooltip:i.getTooltip()});});k.splice(0,0,{key:null,text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_SELECTION_NONE")});this._oGroupPanel.setKeyFields(k);var C=[];m=(this.getBindingInfo("groupItems")||{}).model;this.getGroupItems().forEach(function(g){var o=g.getBindingContext(m);if(g.getBinding("key")){o.getObject()[g.getBinding("key").getPath()]=g.getKey();}C.push({key:g.getKey(),keyField:g.getColumnKey(),operation:g.getOperation(),showIfGrouped:g.getShowIfGrouped()});});this._oGroupPanel.setConditions(C);}};
f.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.removeItem=function(i){var r=a.prototype.removeItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return r;};
f.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.addGroupItem=function(g){this.addAggregation("groupItems",g,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.insertGroupItem=function(g,i){this.insertAggregation("groupItems",g,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.updateGroupItems=function(r){this.updateAggregation("groupItems");if(r==="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;this.invalidate();}};
f.prototype.removeGroupItem=function(g){g=this.removeAggregation("groupItems",g,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return g;};
f.prototype.removeAllGroupItems=function(){var g=this.removeAllAggregation("groupItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return g;};
f.prototype.destroyGroupItems=function(){this.destroyAggregation("groupItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype._handleDataChange=function(){var t=this;return function(E){var n=E.getParameter("newData");var o=E.getParameter("operation");var k=E.getParameter("key");var i=E.getParameter("index");var g;if(o==="update"){g=t.getGroupItems()[i];if(g){g.setColumnKey(n.keyField);g.setOperation(n.operation);g.setShowIfGrouped(n.showIfGrouped);}t.fireUpdateGroupItem({key:k,index:i,groupItemData:g});t._notifyChange();}if(o==="add"){g=new c({key:k,columnKey:n.keyField,operation:n.operation,showIfGrouped:n.showIfGrouped});t._bIgnoreBindCalls=true;t.fireAddGroupItem({key:k,index:i,groupItemData:g});t._bIgnoreBindCalls=false;t._notifyChange();}if(o==="remove"){t._bIgnoreBindCalls=true;t.fireRemoveGroupItem({key:k,index:i});t._bIgnoreBindCalls=false;t._notifyChange();}};};
f.prototype.getOkPayload=function(){if(!this.getModel()){return null;}var s=[];this._oGroupPanel._oConditionsGrid.getContent().forEach(function(C){var o=C.keyField;s.push(o.getSelectedKey());});return{selectedColumnKeys:s};};
f.prototype._callValidationExecutor=function(){var v=this.getValidationExecutor();if(v){v();}};
f.prototype._updateValidationResult=function(v){this._oGroupPanel._oConditionsGrid.getContent().forEach(function(C){var o=C.keyField;o.setValueStateText("");o.setValueState("None");var s=o.getSelectedKey();v.forEach(function(r){if(r.columnKey===s){o.setValueStateText(r.messageText);o.setValueState(r.messageType);}});});};
f.prototype.setValidationListener=function(L){this.setProperty("validationListener",L);if(L){L(this,q.proxy(this._updateValidationResult,this));}return this;};
f.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return f;});
sap.ui.predefine('sap/m/P13nItem',['./library','sap/ui/core/Element'],function(l,E){"use strict";
var P=E.extend("sap.m.P13nItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:""},visible:{type:"boolean",group:"Misc",defaultValue:null},type:{type:"string",group:"Misc",defaultValue:"text"},typeInstance:{type:"object",group:"Misc",defaultValue:null,since:"1.56"},precision:{type:"string",group:"Misc",defaultValue:null},formatSettings:{type:"object",group:"Misc",defaultValue:null,since:"1.52"},scale:{type:"string",group:"Misc",defaultValue:null},maxLength:{type:"string",group:"Misc",defaultValue:null},width:{type:"string",group:"Misc",defaultValue:null},isDefault:{type:"boolean",group:"Misc",defaultValue:false},values:{type:"string[]",group:"Misc",defaultValue:null},role:{type:"string",defaultValue:null},aggregationRole:{type:"string",defaultValue:null},href:{type:"string",defaultValue:null},target:{type:"string",defaultValue:null},press:{type:"object",defaultValue:null},description:{type:"string",defaultValue:null},nullable:{type:"boolean",group:"Misc",defaultValue:false}}}});
return P;});
sap.ui.predefine('sap/m/P13nOperationsHelper',["./library"],function(l){"use strict";var P=function(){this.init();};var O=l.P13nConditionOperation;P.prototype.oIncludeOperations={"default":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"string":[O.Contains,O.EQ,O.BT,O.StartsWith,O.EndsWith,O.LT,O.LE,O.GT,O.GE],"date":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"time":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"datetime":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"numeric":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"numc":[O.Contains,O.EQ,O.BT,O.EndsWith,O.LT,O.LE,O.GT,O.GE],"boolean":[O.EQ]};P.prototype.oExcludeOperationsDefault={"default":[O.EQ]};P.prototype.oExcludeOperationsExtended={"default":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"string":[O.Contains,O.EQ,O.BT,O.StartsWith,O.EndsWith,O.LT,O.LE,O.GT,O.GE],"date":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"time":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"datetime":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"numeric":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"numc":[O.Contains,O.EQ,O.BT,O.EndsWith,O.LT,O.LE,O.GT,O.GE],"boolean":[O.EQ]};
P.prototype.init=function(){this.oExcludeOperations=this.oExcludeOperationsDefault;};
P.prototype.setUseExcludeOperationsExtended=function(){this.oExcludeOperations=this.oExcludeOperationsExtended;};
P.prototype.getIncludeOperationsByType=function(t){if(!t){t="default";}return this.oIncludeOperations[t].map(function(o){return o;});};
P.prototype.getExcludeOperationsByType=function(t){if(!t){t="default";}return this.oExcludeOperations[t].map(function(o){return o;});};
P.prototype.getIncludeTypes=function(){return Object.keys(this.oIncludeOperations);};
P.prototype.getExcludeTypes=function(){return Object.keys(this.oExcludeOperations);};
return P;},true);
sap.ui.predefine('sap/m/P13nPanel',['./library','sap/ui/core/Control'],function(l,C){"use strict";
var P=C.extend("sap.m.P13nPanel",{
metadata:{"abstract":true,library:"sap.m",interfaces:["sap.m.p13n.IContent"],properties:{title:{type:"string",group:"Appearance",defaultValue:null},titleLarge:{type:"string",group:"Appearance",defaultValue:null},type:{type:"string",group:"Misc",defaultValue:null},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},validationExecutor:{type:"object",group:"Misc",defaultValue:null},validationListener:{type:"object",group:"Misc",defaultValue:null},changeNotifier:{type:"object",group:"Misc",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.P13nItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{beforeNavigationTo:{}}},
renderer:{apiVersion:2,render:function(r,c){r.openStart("span",c);r.class("sapMP13nPanel");r.openEnd();r.close("span");}}
});
P.prototype.getOkPayload=function(){return{};};
P.prototype.getResetPayload=function(){return{};};
P.prototype.beforeNavigationTo=function(){this.fireBeforeNavigationTo();};
P.prototype.onBeforeNavigationFrom=function(){return true;};
P.prototype.onAfterNavigationFrom=function(){};
return P;});
sap.ui.predefine('sap/m/P13nSelectionItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nSelectionItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string",defaultValue:undefined},selected:{type:"boolean",defaultValue:false}}}});
return P;});
sap.ui.predefine('sap/m/P13nSelectionPanel',['./library','./ColumnListItem','./P13nPanel','./SearchField','./Text','./Table','./Column','./ScrollContainer','./P13nSelectionItem','./VBox','./Link','./OverflowToolbar','./OverflowToolbarLayoutData','./ToolbarSpacer','sap/ui/core/library','sap/ui/model/ChangeReason','sap/ui/model/json/JSONModel','sap/ui/model/BindingMode','sap/ui/core/ResizeHandler',"sap/ui/thirdparty/jquery"],function(l,C,P,S,T,a,b,c,d,V,L,O,e,f,g,h,J,B,R,q){"use strict";var i=l.ToolbarDesign;var j=l.ListType;var k=l.ListMode;var m=l.P13nPanelType;
var n=P.extend("sap.m.P13nSelectionPanel",{
metadata:{library:"sap.m",aggregations:{selectionItems:{type:"sap.m.P13nSelectionItem",multiple:true,singularName:"selectionItem",bindable:"bindable"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"}},events:{changeSelectionItems:{parameters:{items:{type:"object[]"}}}}},
renderer:{apiVersion:2,render:function(r,o){r.openStart("div",o);r.class("sapMP13nColumnsPanel");r.openEnd();o.getAggregation("content").forEach(function(p){r.renderControl(p);});r.close("div");}}
});
n.prototype.init=function(){this._iLiveChangeTimer=0;this._iSearchTimer=0;this._bIgnoreUpdateInternalModel=false;this._bUpdateInternalModel=true;this._bOnAfterRenderingFirstTimeExecuted=false;var M=new J({items:[],countOfSelectedItems:0,countOfItems:0});M.setDefaultBindingMode(B.TwoWay);M.setSizeLimit(1000);this.setModel(M,"$sapmP13nSelectionPanel");this.setType(m.selection);this._createTable();this._createToolbar();this.setVerticalScrolling(false);var s=new c({horizontal:false,vertical:true,content:[this._oTable],width:'100%',height:'100%'});this.addAggregation("content",s);var t=this;this._fnHandleResize=function(){var o=false,p,r;if(t.getParent){var $=null,u,H;var v=t.getParent();var w=t._getToolbar();if(v&&v.$){$=v.$("cont");if($.children().length>0&&w.$().length>0){p=s.$()[0].clientHeight;u=$.children()[0].clientHeight;H=w?w.$()[0].clientHeight:0;r=u-H;if(p!==r){s.setHeight(r+'px');o=true;}}}}return o;};this._sContainerResizeListener=R.register(s,this._fnHandleResize);};
n.prototype.onBeforeRendering=function(){this._updateInternalModel();};
n.prototype.onAfterRendering=function(){var t=this;if(!this._bOnAfterRenderingFirstTimeExecuted){this._bOnAfterRenderingFirstTimeExecuted=true;window.clearTimeout(this._iLiveChangeTimer);this._iLiveChangeTimer=window.setTimeout(function(){t._fnHandleResize();},0);}};
n.prototype.getOkPayload=function(){this._updateInternalModel();var M=this._getInternalModel().getProperty("/items");return{selectionItems:M.map(function(o){return{columnKey:o.columnKey,selected:o.persistentSelected};})};};
n.prototype.exit=function(){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;this._getToolbar().destroy();this._oTable.destroy();this._oTable=null;if(this._getInternalModel()){this._getInternalModel().destroy();}window.clearTimeout(this._iLiveChangeTimer);window.clearTimeout(this._iSearchTimer);};
n.prototype.addItem=function(I){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("items",I);return this;};
n.prototype.insertItem=function(I,o){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("items",I,o);return this;};
n.prototype.removeItem=function(I){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}I=this.removeAggregation("items",I);return I;};
n.prototype.removeAllItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("items");};
n.prototype.destroyItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("items");return this;};
n.prototype.addSelectionItem=function(s){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("selectionItems",s);return this;};
n.prototype.insertSelectionItem=function(s,I){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("selectionItems",s,I);return this;};
n.prototype.updateSelectionItems=function(r){this.updateAggregation("selectionItems");if(r===h.Change&&!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}};
n.prototype.removeSelectionItem=function(s){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("selectionItems",s);};
n.prototype.removeAllSelectionItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("selectionItems");};
n.prototype.destroySelectionItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("selectionItems");return this;};
n.prototype.onBeforeNavigationFrom=function(){return true;};
n.prototype._notifyChange=function(){var o=this.getChangeNotifier();if(o){o(this);}};
n.prototype._getInternalModel=function(){return this.getModel("$sapmP13nSelectionPanel");};
n.prototype._createTable=function(){var t=this;this._oTable=new a({mode:k.MultiSelect,rememberSelections:false,selectionChange:q.proxy(this._onSelectionChange,this),columns:[new b({vAlign:g.VerticalAlign.Middle,header:new T({text:{parts:[{path:'/countOfSelectedItems'},{path:'/countOfItems'}],formatter:function(o,p){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText('COLUMNSPANEL_SELECT_ALL_WITH_COUNTER',[o,p]);}}})})],items:{path:"/items",templateShareable:false,template:new C({cells:new V({items:[new L({href:"{href}",text:"{text}",target:"{target}",wrapping:true,enabled:{path:'href',formatter:function(v){if(!v){this.addStyleClass("sapUiCompSmartLink");}return!!v;}},press:function(E){var H=E.getSource().getHref();var I=t.getItems().filter(function(o){return o.getHref()===H&&!!o.getPress();});if(!I.length){return;}var p=I[0].getPress();p(E);}}),new T({wrapping:true,visible:{path:'description',formatter:function(D){return!!D;}},text:"{description}"})]}),visible:"{visible}",selected:"{persistentSelected}",tooltip:"{tooltip}",type:j.Active})}});this._oTable.setModel(this._getInternalModel());};
n.prototype._createToolbar=function(){var t=this;var o=new O(this.getId()+"-toolbar",{design:i.Auto,content:[new f(),new S(this.getId()+"-searchField",{liveChange:function(E){var v=E.getSource().getValue(),D=(v?300:0);window.clearTimeout(t._iSearchTimer);if(D){t._iSearchTimer=window.setTimeout(function(){t._onExecuteSearch();},D);}else{t._onExecuteSearch();}},search:q.proxy(this._onExecuteSearch,this),layoutData:new e({minWidth:"12.5rem",maxWidth:"23.077rem",shrinkable:true,moveToOverflow:false,stayInOverflow:false})})]});o.setModel(this._getInternalModel());this.addAggregation("content",o);};
n.prototype._onExecuteSearch=function(){this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._updateControlLogic();};
n.prototype._switchVisibilityOfUnselectedModelItems=function(){var s=this._isFilteredByShowSelected();var M=this._getInternalModel().getProperty("/items");M.forEach(function(o){if(o.persistentSelected){o.visible=true;return;}o.visible=!s;});this._getInternalModel().setProperty("/items",M);};
n.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
n.prototype._getModelItemByColumnKey=function(s){var M=this._getInternalModel().getProperty("/items").filter(function(o){return o.columnKey===s;});return M[0];};
n.prototype._updateCounts=function(M){var o=0;var p=0;M.forEach(function(r){o++;if(r.persistentSelected){p++;}});this._getInternalModel().setProperty("/countOfItems",o);this._getInternalModel().setProperty("/countOfSelectedItems",p);};
n.prototype._getToolbar=function(){return sap.ui.getCore().byId(this.getId()+"-toolbar")||null;};
n.prototype._getSearchField=function(){return sap.ui.getCore().byId(this.getId()+"-searchField")||null;};
n.prototype._getSearchText=function(){var s=this._getSearchField();return s?s.getValue():"";};
n.prototype._isFilteredBySearchText=function(){return!!this._getSearchText().length;};
n.prototype._isFilteredByShowSelected=function(){return false;};
n.prototype._updateControlLogic=function(){var I=this._isFilteredBySearchText();var s=this._isFilteredByShowSelected();var t=sap.ui.getCore().byId(this._oTable.getId()+'-sa');if(t){t.setEnabled(!I&&!s);}};
n.prototype._fireChangeSelectionItems=function(){this._bIgnoreUpdateInternalModel=true;var M=this._getInternalModel().getProperty("/items");this.fireChangeSelectionItems({items:M.map(function(o){return{columnKey:o.columnKey,selected:o.persistentSelected};})});this._bIgnoreUpdateInternalModel=false;};
n.prototype._onSelectionChange=function(){this._selectTableItem();};
n.prototype._selectTableItem=function(){var M=this._getInternalModel().getProperty("/items");this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._fireChangeSelectionItems();this._notifyChange();};
n.prototype._filterModelItemsBySearchText=function(){var s=this._getSearchText();s=s.replace(/(^\s+)|(\s+$)/g,'');s=s.replace(/[-\/\\^$*+?.()|[\]{}]/g,'\\$&');var r=new RegExp(s,'igm');this._getVisibleModelItems().forEach(function(M){M.visible=false;if(M.text&&M.text.match(r)){M.visible=true;}if(M.tooltip&&M.tooltip.match(r)){M.visible=true;}});this._getInternalModel().refresh();};
n.prototype._updateInternalModel=function(){if(!this._bUpdateInternalModel){return;}this._bUpdateInternalModel=false;this._getInternalModel().setProperty("/items",this.getItems().map(function(I){return{columnKey:I.getColumnKey(),visible:true,text:I.getText(),tooltip:I.getTooltip(),href:I.getHref(),target:I.getTarget(),persistentSelected:I.getVisible(),description:I.getDescription()};},this));this.getSelectionItems().forEach(function(s){var o=this._getModelItemByColumnKey(s.getColumnKey());if(!o){return;}if(s.getSelected()!==undefined){o.persistentSelected=s.getSelected();}},this);this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();var M=this._getInternalModel().getProperty("/items");this._updateCounts(M);this._getInternalModel().setProperty("/items",M);};
return n;});
sap.ui.predefine('sap/m/P13nSortItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nSortItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null}}}});
P.prototype.setColumnKey=function(v){return this.setProperty("columnKey",v,true);};
P.prototype.setOperation=function(v){return this.setProperty("operation",v,true);};
return P;});
sap.ui.predefine('sap/m/P13nSortPanel',['./library','./P13nConditionPanel','./P13nPanel','./P13nSortItem'],function(l,P,a,c){"use strict";var d=l.P13nPanelType;var e=l.P13nConditionOperation;
var f=a.extend("sap.m.P13nSortPanel",{
metadata:{deprecated:true,library:"sap.m",properties:{containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},sortItems:{type:"sap.m.P13nSortItem",multiple:true,singularName:"sortItem",bindable:"bindable"}},events:{addSortItem:{},removeSortItem:{},updateSortItem:{}}},
renderer:{apiVersion:2,render:function(r,C){r.openStart("section",C);r.class("sapMSortPanel");r.openEnd();r.openStart("div");r.class("sapMSortPanelContent");r.class("sapMSortPanelBG");r.openEnd();C.getAggregation("content").forEach(function(o){r.renderControl(o);});r.close("div");r.close("section");}}
});
f.prototype._getConditions=function(){return this._oSortPanel.getConditions();};
f.prototype.setContainerQuery=function(b){this.setProperty("containerQuery",b);this._oSortPanel.setContainerQuery(b);return this;};
f.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oSortPanel.setLayoutMode(m);return this;};
f.prototype.validateConditions=function(){return this._oSortPanel.validateConditions();};
f.prototype.removeInvalidConditions=function(){this._oSortPanel.removeInvalidConditions();};
f.prototype.removeValidationErrors=function(){this._oSortPanel.removeValidationErrors();};
f.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
f.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
f.prototype.setOperations=function(o){this._aOperations=o;if(this._oSortPanel){this._oSortPanel.setOperations(this._aOperations);}return this;};
f.prototype.init=function(){this.setType(d.sort);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SORTPANEL_TITLE"));this._aKeyFields=[];if(!this._aOperations){this.setOperations([e.Ascending,e.Descending]);}this._oSortPanel=new P({autoReduceKeyFieldItems:true,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oSortPanel.setOperations(this._aOperations);this._oSortPanel._sAddRemoveIconTooltipKey="SORT";this.addAggregation("content",this._oSortPanel);};
f.prototype.exit=function(){var b=function(o){if(o&&o.destroy){o.destroy();}return null;};this._aKeyFields=b(this._aKeyFields);this._aOperations=b(this._aOperations);};
f.prototype.onBeforeRendering=function(){if(this._bUpdateRequired){this._bUpdateRequired=false;var k=[];var m=(this.getBindingInfo("items")||{}).model;this.getItems().forEach(function(i){var o=i.getBindingContext(m);if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}k.push({key:i.getColumnKey(),text:i.getText(),tooltip:i.getTooltip()});});k.splice(0,0,{key:null,text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_SELECTION_NONE")});this._oSortPanel.setKeyFields(k);var C=[];m=(this.getBindingInfo("sortItems")||{}).model;this.getSortItems().forEach(function(s){var o=s.getBindingContext(m);if(s.getBinding("key")){o.getObject()[s.getBinding("key").getPath()]=s.getKey();}C.push({key:s.getKey(),keyField:s.getColumnKey(),operation:s.getOperation()});});this._oSortPanel.setConditions(C);}};
f.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.removeItem=function(i){var r=a.prototype.removeItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return r;};
f.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.addSortItem=function(s){this.addAggregation("sortItems",s,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.insertSortItem=function(s,i){this.insertAggregation("sortItems",s,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.updateSortItems=function(r){this.updateAggregation("sortItems");if(r==="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;this.invalidate();}};
f.prototype.removeSortItem=function(s){s=this.removeAggregation("sortItems",s,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return s;};
f.prototype.removeAllSortItems=function(){var s=this.removeAllAggregation("sortItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return s;};
f.prototype.destroySortItems=function(){this.destroyAggregation("sortItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype._handleDataChange=function(){var t=this;return function(E){var n=E.getParameter("newData");var o=E.getParameter("operation");var k=E.getParameter("key");var i=E.getParameter("index");var s;if(o==="update"){s=t.getSortItems()[i];if(s){s.setColumnKey(n.keyField);s.setOperation(n.operation);}t.fireUpdateSortItem({key:k,index:i,sortItemData:s});t._notifyChange();}if(o==="add"){s=new c({key:k,columnKey:n.keyField,operation:n.operation});t._bIgnoreBindCalls=true;t.fireAddSortItem({key:k,index:i,sortItemData:s});t._bIgnoreBindCalls=false;t._notifyChange();}if(o==="remove"){t._bIgnoreBindCalls=true;t.fireRemoveSortItem({key:k,index:i});t._bIgnoreBindCalls=false;t._notifyChange();}};};
f.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return f;});
sap.ui.predefine('sap/m/QuickView',["./library","sap/ui/Device","sap/ui/core/IconPool","./QuickViewBase","./ResponsivePopover","./NavContainer","./Page","./Bar","./Button"],function(l,D,I,Q,R,N,P,B,a){"use strict";var b=l.PlacementType;
var c=Q.extend("sap.m.QuickView",{
metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Misc",defaultValue:b.Right},width:{type:'sap.ui.core.CSSSize',group:'Dimension',defaultValue:'320px'}},aggregations:{},designtime:"sap/m/designtime/QuickView.designtime",events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}}}},
renderer:{apiVersion:2,render:function(){}}
});
c.prototype.init=function(){var n={pages:[new P()],navigate:this._navigate.bind(this),afterNavigate:this._afterNavigate.bind(this)};this._oNavContainer=new N(n);var t=this;this._oPopover=new R(this.getId()+'-quickView',{placement:this.getPlacement(),content:[this._oNavContainer],contentWidth:this.getWidth(),showHeader:false,showCloseButton:false,afterOpen:function(e){t._afterOpen(e);t.fireAfterOpen({openBy:e.getParameter("openBy")});},afterClose:function(e){t.fireAfterClose({openBy:e.getParameter("openBy"),origin:t.getCloseButton()});},beforeOpen:function(e){t.fireBeforeOpen({openBy:e.getParameter("openBy")});},beforeClose:function(e){t.fireBeforeClose({openBy:e.getParameter("openBy"),origin:t.getCloseButton()});t._bRendered=false;}});this._oPopover.addStyleClass("sapMQuickView");var p=this._oPopover.getAggregation("_popup");p.addEventDelegate({onBeforeRendering:this._initializeQuickView,onAfterRendering:this._setLinkWidth,onkeydown:this._onPopupKeyDown},this);var t=this;var s=p._fnAdjustPositionAndArrow;if(s){p._fnAdjustPositionAndArrow=function(){s.apply(p,arguments);t._adjustContainerHeight();};}this._bItemsChanged=true;};
c.prototype._initializeQuickView=function(){this._bRendered=true;if(this._bItemsChanged){this._clearContainerHeight();this._initPages();var p=this._oNavContainer.getCurrentPage();if(p){var h=p.getCustomHeader();if(h&&h.getContentMiddle()[0]){this._oPopover.addAriaLabelledBy(h.getContentMiddle()[0].getId());}}var d=this.getAggregation("pages");if(!d&&D.system.phone){this._addEmptyPage();}this._bItemsChanged=false;}};
c.prototype.exit=function(){this._bRendered=false;this._bItemsChanged=true;if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}};
c.prototype.invalidate=function(){};
c.prototype._createPage=function(q){return q._createPage();};
c.prototype._onPopupKeyDown=function(e){this._processKeyboard(e);};
c.prototype._afterOpen=function(e){if(D.system.phone){this._restoreFocus();}};
c.prototype._addEmptyPage=function(){var p=new P({customHeader:new B().addStyleClass("sapMQuickViewHeader")});var t=this;var C=p.getCustomHeader();C.addContentRight(new a({icon:I.getIconURI("decline"),press:function(){t._oPopover.close();}}));p.addStyleClass('sapMQuickViewPage');this._oNavContainer.addPage(p);};
c.prototype._clearContainerHeight=function(){var p=this._oPopover.getAggregation("_popup");var $=p.$().find('.sapMPopoverCont');if($[0]&&$[0].style.height){$[0].style.height='';}};
c.prototype._adjustContainerHeight=function(){if(this.getPages().length<=1){return;}var p=this._oPopover.getAggregation("_popup");var $=p.$().find('.sapMPopoverCont');if($[0]&&!$[0].style.height){$[0].style.height=$.height()+'px';}};
c.prototype._setLinkWidth=function(){this._oPopover.$().find(".sapMLnk").css("width","auto");};
c.prototype.getCloseButton=function(){if(!D.system.phone){return undefined;}var p=this._oNavContainer.getCurrentPage();var o=p.getCustomHeader().getContentRight()[0];return o;};
c.prototype.setPlacement=function(p){this.setProperty("placement",p,true);this._oPopover.setPlacement(p);return this;};
c.prototype.setWidth=function(w){if(this._oPopover){this._oPopover.setContentWidth(w);this.setProperty('width',w,true);}return this;};
c.prototype.openBy=function(C){this._bItemsChanged=true;this._oPopover.openBy(C);return this;};
c.prototype.close=function(){this._oPopover.close();return this;};
c.prototype.getDomRef=function(s){return this._oPopover&&this._oPopover.getAggregation("_popup").getDomRef(s);};
["addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getBusyIndicatorDelay","setBusyIndicatorDelay","getVisible","setVisible","getFieldGroupIds","setFieldGroupIds","getBusy","setBusy","setTooltip","getTooltip"].forEach(function(n){c.prototype[n]=function(){if(this._oPopover&&this._oPopover[n]){var r=this._oPopover.getAggregation("_popup")[n].apply(this._oPopover.getAggregation("_popup"),arguments);return r===this._oPopover.getAggregation("_popup")?this:r;}};});["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(f){c.prototype[f]=function(){var n=Array.prototype.slice.call(arguments),r;if(["setModel","bindAggregation"].indexOf(f)===-1){n.push(true);}r=Q.prototype[f].apply(this,n);this._bItemsChanged=true;if(this._oPopover){if(arguments[0]!=="pages"){this._oPopover[f].apply(this._oPopover,arguments);}if(this._bRendered){this._initializeQuickView();}}if(["removeAggregation","removeAllAggregation"].indexOf(f)!==-1){return r;}return this;};});return c;});
sap.ui.predefine('sap/m/QuickViewBase',["./library","sap/ui/core/Control","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Focusable"],function(l,C,K,q){"use strict";
var Q=C.extend("sap.m.QuickViewBase",{
metadata:{library:"sap.m",properties:{},defaultAggregation:"pages",aggregations:{pages:{type:"sap.m.QuickViewPage",multiple:true,singularName:"page",bindable:"bindable"}},events:{navigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"},navOrigin:{type:"sap.ui.core.Control"}}},afterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"},isTopPage:{type:"boolean"},navOrigin:{type:"sap.ui.core.Control"}}}}},
renderer:{apiVersion:2,render:function(){}}
});
Q.prototype.navigateBack=function(){if(!this._oNavContainer.currentPageIsTopPage()){this._setNavOrigin(null);this._oNavContainer.back();}};
Q.prototype.getNavContainer=function(){return this._oNavContainer;};
Q.prototype._initPages=function(){var n=this._oNavContainer;n.destroyPages();n.init();var p=this.getAggregation("pages");if(!p){return;}var I=this.getId();for(var i=0;i<p.length;i++){var o=p[i];o._oPage=null;var N={hasBackButton:i>0,popover:this._oPopover,navContainer:n,quickViewId:I,quickView:this};o.setNavContext(N);var P=this._createPage(o);this._oNavContainer.addPage(P);}};
Q.prototype._processKeyboard=function(e){if(e.shiftKey&&e.which===K.ENTER){this.navigateBack();e.preventDefault();}};
Q.prototype._createPage=function(o){return o;};
Q.prototype._navigate=function(e){var t=e.getParameter('to');var f=e.getParameter('from');var T=e.getParameter('toId');var F=e.getParameter('fromId');var i=q(document.getElementById(F)).index();var a=q(document.getElementById(T)).index();if(a==-1||a>i){t.addStyleClass('sapMNavItemOffset');}else{f.addStyleClass('sapMNavItemOffset');}f.$().parents('.sapMPanelContent').scrollTop(0);var p=e.getParameters();if(this._navOrigin){p.navOrigin=this._navOrigin;}this.fireNavigate(p);};
Q.prototype._afterNavigate=function(e){var t=e.getParameter('to');var f=e.getParameter('from');var T=e.getParameter('toId');var F=e.getParameter('fromId');var i=q(document.getElementById(F)).index();var a=q(document.getElementById(T)).index();if(a>i){t.removeStyleClass('sapMNavItemOffset');}else{f.removeStyleClass('sapMNavItemOffset');}var p=e.getParameters();p.isTopPage=this._oNavContainer.currentPageIsTopPage();if(this._navOrigin){p.navOrigin=this._navOrigin;}this.fireAfterNavigate(p);this._setLinkWidth();setTimeout(this._restoreFocus.bind(this),0);};
Q.prototype._restoreFocus=function(){var p=this._oNavContainer.getCurrentPage();var f=this._oNavContainer._mFocusObject[p.getId()];if(!f){var c=p.getContent();if(c&&c.length>1){f=c[1].$().firstFocusableDomRef();}}if(f){f.focus();}};
Q.prototype._setLinkWidth=function(){};
Q.prototype._setNavOrigin=function(c){this._navOrigin=c;};
return Q;});
sap.ui.predefine('sap/m/QuickViewCard',["./library","./QuickViewBase","./NavContainer","./Page","./ScrollContainer","./QuickViewCardRenderer"],function(l,Q,N,P,S,a){"use strict";
var b=Q.extend("sap.m.QuickViewCard",{metadata:{library:"sap.m",properties:{showVerticalScrollBar:{type:"boolean",group:"Behavior",defaultValue:true}},designtime:"sap/m/designtime/QuickViewCard.designtime"}});
b.prototype.init=function(){var n={pages:[new P()],navigate:this._navigate.bind(this),afterNavigate:this._afterNavigate.bind(this)};this._oNavContainer=new N(n);};
b.prototype.onBeforeRendering=function(){this._initPages();};
b.prototype.onAfterRendering=function(){this._setLinkWidth();};
b.prototype.exit=function(){if(this._oNavContainer){this._oNavContainer.destroy();}};
b.prototype.onkeydown=function(e){this._processKeyboard(e);};
b.prototype._createPage=function(q){var c=q._createPageContent();q._mPageContent=null;var C=new S(this.getId()+'-'+q.getPageId(),{horizontal:false,vertical:false});if(c.header){C.addContent(c.header);}C.addContent(c.form);C.addStyleClass('sapMQuickViewPage');return C;};
b.prototype._setLinkWidth=function(){this.$().find(".sapMLnk").css("width","auto");};
return b;});
sap.ui.predefine('sap/m/QuickViewGroupElement',["./library","sap/ui/core/Element","./Link","./Text","sap/ui/core/CustomData"],function(l,E,L,T,C){"use strict";var G=l.QuickViewGroupElementType;
var a=E.extend("sap.m.QuickViewGroupElement",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true},label:{type:"string",group:"Misc",defaultValue:""},value:{type:"string",group:"Misc",defaultValue:""},url:{type:"string",group:"Misc",defaultValue:""},target:{type:"string",group:"Misc",defaultValue:"_blank"},type:{type:"sap.m.QuickViewGroupElementType",group:"Misc",defaultValue:G.text},pageLinkId:{type:"string",group:"Misc",defaultValue:""},emailSubject:{type:"string",group:"Misc",defaultValue:""}}}});
a.prototype._getGroupElementValue=function(q){if(!this.getValue()){return null;}switch(this.getType()){case G.email:var h="mailto:"+this.getValue();var s=this.getEmailSubject();if(s){h+='?subject='+s;}return new L({href:h,text:this.getValue(),wrapping:true});case G.phone:case G.mobile:return new L({href:"tel:"+this.getValue(),text:this.getValue()});case G.link:return new L({href:this.getUrl(),text:this.getValue(),target:this.getTarget()});case G.pageLink:var b=this.getPageLinkId();if(q){b=q+'-'+b;}return new L({text:this.getValue(),customData:[new C({key:"pageNumber",value:b})]});default:return new T({text:this.getValue()});}};
a.prototype.setProperty=function(){E.prototype.setProperty.apply(this,arguments);var g=this.getParent();if(!g){return this;}var p=g.getParent();if(p){p._updatePage();}return this;};
a.prototype.getQuickViewBase=function(){var p=this.getParent();if(p&&p.getQuickViewBase){return p.getQuickViewBase();}return null;};
return a;});
sap.ui.predefine('sap/m/QuickViewPage',["./library","sap/ui/core/Core","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/layout/form/SimpleForm","sap/ui/layout/VerticalLayout","sap/ui/layout/HorizontalLayout","sap/m/Avatar","sap/m/Page","sap/m/Button","sap/m/Bar","sap/m/Title","sap/m/Link","sap/m/Text","sap/m/Label","sap/m/HBox","sap/ui/core/Icon","sap/ui/core/Title","sap/ui/core/CustomData","sap/ui/core/library","sap/ui/layout/library","sap/ui/Device","sap/ui/layout/form/ResponsiveGridLayout","./QuickViewPageRenderer","sap/base/Log","sap/base/security/encodeURL","sap/ui/dom/jquery/Focusable"],function(l,C,a,I,S,V,H,A,P,B,b,T,L,c,d,e,f,g,h,i,m,D,R,Q,n,o){"use strict";var U=l.URLHelper;var p=m.form.SimpleFormLayout;var q=i.TitleLevel;var r=l.QuickViewGroupElementType;var s=l.ButtonType;var t=l.AvatarShape;var u=C.getLibraryResourceBundle('sap.m');
var v=a.extend("sap.m.QuickViewPage",{
metadata:{library:"sap.m",properties:{pageId:{type:"string",group:"Misc",defaultValue:""},header:{type:"string",group:"Misc",defaultValue:""},title:{type:"string",group:"Misc",defaultValue:""},titleUrl:{type:"string",group:"Misc",defaultValue:""},crossAppNavCallback:{type:"object",group:"Misc"},description:{type:"string",group:"Misc",defaultValue:""},icon:{type:"string",group:"Misc",defaultValue:"",deprecated:true},fallbackIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null,deprecated:true}},defaultAggregation:"groups",aggregations:{groups:{type:"sap.m.QuickViewGroup",multiple:true,singularName:"group",bindable:"bindable"},avatar:{type:"sap.m.Avatar",multiple:false,bindable:"bindable"}}},
renderer:Q
});
v.prototype.init=function(){var G=sap.ushell&&sap.ushell.Container&&sap.ushell.Container.getService;if(G){this.oCrossAppNavigator=G("CrossApplicationNavigation");}};
v.prototype.exit=function(){if(this._oPage){this._oPage.destroy();this._oPage=null;}else{this._destroyPageContent();}this._mNavContext=null;};
v.prototype.onBeforeRendering=function(){this._destroyPageContent();this._createPageContent();};
v.prototype.getPageContent=function(){return this._mPageContent;};
v.prototype.setNavContext=function(j){this._mNavContext=j;};
v.prototype.getNavContext=function(){return this._mNavContext;};
v.prototype.setPageTitleControl=function(j){this._oPageTitle=j;};
v.prototype.getPageTitleControl=function(){return this._oPageTitle;};
v.prototype._createPage=function(){var j=this._createPageContent();var N=this.getNavContext();var k;if(this._oPage){k=this._oPage;k.destroyContent();k.setCustomHeader(new b());}else{k=this._oPage=new P(N.quickViewId+'-'+this.getPageId(),{customHeader:new b()});k.addEventDelegate({onAfterRendering:this.onAfterRenderingPage},this);}if(this.getHeader()===""&&N.quickView.getPages().length===1&&!D.system.phone){k.setShowHeader(false);k.addStyleClass('sapMQuickViewPageWithoutHeader');}if(j.header){k.addContent(j.header);}k.addContent(j.form);var w=k.getCustomHeader();w.addContentMiddle(new T({text:this.getHeader()}).addStyleClass("sapMQuickViewTitle"));if(N.hasBackButton){w.addContentLeft(new B({type:s.Back,tooltip:u.getText("PAGE_NAVBUTTON_TEXT"),press:function(){if(N.navContainer){N.quickView._setNavOrigin(null);N.navContainer.back();}}}));}if(N.popover&&D.system.phone){w.addContentRight(new B({icon:I.getIconURI("decline"),press:function(){N.popover.close();}}));}k.addStyleClass('sapMQuickViewPage');return k;};
v.prototype.onAfterRenderingPage=function(){var j=this.getParent(),k=j instanceof a&&j.isA('sap.m.QuickView');if(k&&!this._oPage.$().firstFocusableDomRef()){this._oPage.$('cont').attr('tabindex',0);}if(this._bItemsChanged){var N=this.getNavContext();if(N){N.quickView._restoreFocus();}this._bItemsChanged=false;}};
v.prototype._createPageContent=function(){var F=this._createForm();var j=this._getPageHeaderContent();var k=this.getPageTitleControl();if(j&&k){F.addAriaLabelledBy(k);}this._mPageContent={form:F,header:j};return this._mPageContent;};
v.prototype._createForm=function(){var G=this.getAggregation("groups"),F=new S({maxContainerCols:1,editable:false,layout:p.ResponsiveGridLayout});if(G){for(var j=0;j<G.length;j++){if(G[j].getVisible()){this._renderGroup(G[j],F);}}}return F;};
v.prototype._getPageHeaderContent=function(){var j=this._getAvatar(),k=new V(),w=new H(),x=this.getIcon(),y=this.getTitle(),z=this.getDescription(),E=this.getTitleUrl();if(!j&&!x&&!y&&!z){return null;}if(j){w.addContent(j);}var F;if(E){F=new L({text:y,href:E,target:"_blank"});}else if(this.getCrossAppNavCallback()){F=new L({text:y});F.attachPress(this._crossApplicationNavigation.bind(this));}else{F=new T({text:y,level:q.H3});}this.setPageTitleControl(F);var G=new c({text:z});k.addContent(F);k.addContent(G);w.addContent(k);return w;};
v.prototype._renderGroup=function(G,F){var E=G.getAggregation("elements");var j,w,x;if(G.getHeading()){F.addContent(new g({text:G.getHeading(),level:q.H4}));}if(!E){return;}var N=this.getNavContext();for(var k=0;k<E.length;k++){j=E[k];if(!j.getVisible()){continue;}x=new d({text:j.getLabel()});var y;if(N){y=N.quickViewId;}w=j._getGroupElementValue(y);F.addContent(x);if(!w){F.addContent(new c({text:""}));continue;}x.setLabelFor(w.getId());if(j.getType()==r.pageLink){w.attachPress(this._attachPressLink(this));}if(j.getType()==r.mobile&&!D.system.desktop){var z=new f({src:I.getIconURI("post"),tooltip:u.getText("QUICKVIEW_SEND_SMS"),decorative:false,customData:[new h({key:"phoneNumber",value:j.getValue()})],press:this._mobilePress});var J=new e({items:[w,z]});F.addContent(J);}else{F.addContent(w);}}};
v.prototype._crossApplicationNavigation=function(){if(this.getCrossAppNavCallback()&&this.oCrossAppNavigator){var j=this.getCrossAppNavCallback();if(typeof j=="function"){var k=j();var w=this.oCrossAppNavigator.hrefForExternal({target:{semanticObject:k.target.semanticObject,action:k.target.action},params:k.params});U.redirect(w);}}else if(this.getTitleUrl()){U.redirect(this.getTitleUrl(),true);}};
v.prototype._destroyPageContent=function(){if(!this._mPageContent){return;}if(this._mPageContent.form){this._mPageContent.form.destroy();}if(this._mPageContent.header){this._mPageContent.header.destroy();}this._mPageContent=null;};
v.prototype._attachPressLink=function(j){var N=j.getNavContext();return function(E){E.preventDefault();var k=this.getCustomData()[0].getValue();if(N.navContainer&&k){N.quickView._setNavOrigin(this);N.navContainer.to(k);}};};
v.prototype._mobilePress=function(){var j="sms://"+o(this.getCustomData()[0].getValue());window.location.replace(j);};
v.prototype._updatePage=function(){var N=this.getNavContext();if(N&&N.quickView._bRendered){this._bItemsChanged=true;N.popover.focus();if(N.quickView.indexOfPage(this)==0){N.quickView._clearContainerHeight();}this._createPage();N.popover.$().css('display','block');N.quickView._adjustContainerHeight();N.quickView._restoreFocus();}};
["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(F){v.prototype[F]=function(){var j=a.prototype[F].apply(this,arguments);this._updatePage();if(["removeAggregation","removeAllAggregation"].indexOf(F)!==-1){return j;}return this;};});
v.prototype.setProperty=function(){a.prototype.setProperty.apply(this,arguments);this._updatePage();return this;};
v.prototype.getQuickViewBase=function(){var j=this.getParent();if(j&&j.isA("sap.m.QuickViewBase")){return j;}return null;};
v.prototype._getAvatar=function(){var j=null,k=this.getIcon();if(this.getAvatar()){j=this.getAvatar().clone(null,null,{cloneBindings:false,cloneChildren:true});this._checkAvatarProperties(j);}else if(k){j=new A({displayShape:t.Square,fallbackIcon:this.getFallbackIcon(),src:k});}if(j){if(this.getTitleUrl()&&!j.hasListeners("press")){j.attachPress(this._crossApplicationNavigation.bind(this));}j.addStyleClass("sapMQuickViewThumbnail");}return j;};
v.prototype._checkAvatarProperties=function(j){var k=j.getMetadata().getPropertyDefaults();if(j.getDisplaySize()!==k["displaySize"]){n.warning("'displaySize' property of avatar shouldn't be used in sap.m.QuickViewPage");}if(j.getCustomDisplaySize()!==k["customDisplaySize"]){n.warning("'customDisplaySize' property of avatar shouldn't be used in sap.m.QuickViewPage");}if(j.getCustomFontSize()!==k["customFontSize"]){n.warning("'customFontSize' property of avatar shouldn't be used in sap.m.QuickViewPage");}if(j.getDetailBox()){n.warning("'detailBox' aggregation of avatar shouldn't be used in sap.m.QuickViewPage");}};
return v;});
sap.ui.predefine('sap/m/p13n/AbstractContainer',["sap/ui/core/Control","sap/m/Page"],function(C,P){"use strict";
var A=C.extend("sap.m.p13n.AbstractContainer",{
metadata:{library:"sap.m",defaultAggregation:"views",properties:{defaultView:{type:"string"}},aggregations:{header:{type:"sap.m.IBar",multiple:false,forwarding:{idSuffix:"-AbstractContainer",aggregation:"customHeader",forwardBinding:true}},subHeader:{type:"sap.m.IBar",multiple:false,forwarding:{idSuffix:"-AbstractContainer",aggregation:"subHeader",forwardBinding:true}},footer:{type:"sap.m.IBar",multiple:false,forwarding:{idSuffix:"-AbstractContainer",aggregation:"footer",forwardBinding:true}},views:{type:"sap.m.p13n.AbstractContainerItem",multiple:true},_content:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{beforeViewSwitch:{allowPreventDefault:true,parameters:{source:{type:"string"},target:{type:"string"}}},afterViewSwitch:{allowPreventDefault:true,parameters:{source:{type:"string"},target:{type:"string"}}}}},
renderer:{apiVersion:2,render:function(r,c){r.openStart("div",c);r.style("height","100%");r.openEnd();r.renderControl(c.getAggregation("_content"));r.close("div");}}
});
A.prototype.init=function(){C.prototype.init.apply(this,arguments);this.addStyleClass("sapMAbstractContainer");this._initializeContent();};
A.prototype.applySettings=function(){C.prototype.applySettings.apply(this,arguments);this.switchView(this.getDefaultView());return this;};
A.prototype._initializeContent=function(){this.oLayout=new P(this.getId()+"-AbstractContainer");this.setAggregation("_content",this.oLayout);};
A.prototype.removeView=function(c,s){var o=typeof c=="string"?this.getView(c):c;o=this.removeAggregation("views",o,s);if(o&&o.getKey()===this.getCurrentViewKey()){this.switchView();}return this;};
A.prototype.addView=function(c){if(c&&c.getContent()&&!c.getContent().hasStyleClass("sapUiMAbstractContainerContent")){c.getContent().addStyleClass("sapUiMAbstractContainerContent");}this.addAggregation("views",c);return this;};
A.prototype.getCurrentViewKey=function(){return this._sCurrentView?this._sCurrentView:this.getDefaultView();};
A.prototype.getCurrentViewContent=function(){return this.getView(this.getCurrentViewKey()).getContent();};
A.prototype.switchView=function(k){var n=this.getView(k);if(!n){n=this.getViews()[0];if(!n){return;}}if(!this.fireBeforeViewSwitch({source:c,target:k})){this._bPrevented=true;return;}this._bPrevented=false;var c=this.getCurrentViewKey();this._sCurrentView=n.getKey();this.oLayout.removeAllContent();this.oLayout.addContent(n.getContent());this.fireAfterViewSwitch({source:c,target:k});};
A.prototype.getView=function(k){return this.getViews().find(function(v){if(v.getKey()===k){return v;}});};
A.prototype.getViewMap=function(){return this.getViews().map(function(o){return{key:o.getKey(),content:o.getContent()};});};
A.prototype.exit=function(){C.prototype.exit.apply(this,arguments);this._sCurrentView=null;this.oResourceBundle=null;};
return A;});
sap.ui.predefine('sap/m/p13n/BasePanel',['sap/ui/model/json/JSONModel','sap/m/VBox','sap/ui/core/Control','sap/m/Column','sap/m/Text','sap/ui/model/Filter',"sap/m/Table","sap/m/OverflowToolbar","sap/m/SearchField","sap/m/ToolbarSpacer","sap/m/OverflowToolbarButton","sap/m/OverflowToolbarLayoutData","sap/base/util/merge","sap/ui/core/dnd/DragDropInfo"],function(J,V,C,a,T,F,b,O,S,c,d,e,m,D){"use strict";
var B=C.extend("sap.m.p13n.BasePanel",{
metadata:{library:"sap.m",interfaces:["sap.m.p13n.IContent"],associations:{},properties:{title:{type:"string"},enableReorder:{type:"boolean",defaultValue:true}},aggregations:{messageStrip:{type:"sap.m.MessageStrip",multiple:false},_content:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_template:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{change:{reason:{type:"string"},item:{type:"object"}}}},
renderer:{apiVersion:2,render:function(r,o){r.openStart("div",o);r.style("height","100%");r.openEnd();r.renderControl(o.getAggregation("_content"));r.close("div");}}
});
B.prototype.P13N_MODEL="$p13n";B.prototype.CHANGE_REASON_ADD="Add";B.prototype.CHANGE_REASON_REMOVE="Remove";B.prototype.CHANGE_REASON_MOVE="Move";B.prototype.CHANGE_REASON_SELECTALL="SelectAll";B.prototype.CHANGE_REASON_DESELECTALL="DeselectAll";B.prototype.PRESENCE_ATTRIBUTE="visible";
B.prototype.init=function(){C.prototype.init.apply(this,arguments);this._oP13nModel=new J({});this._oP13nModel.setSizeLimit(10000);this.setModel(this._oP13nModel,this.P13N_MODEL);this._oListControl=this._createInnerListControl();this._bFocusOnRearrange=true;this._setInnerLayout();this._oListControl.setMultiSelectMode("ClearAll");};
B.prototype._setInnerLayout=function(){this.setAggregation("_content",new V({items:[this._oListControl]}));};
B.prototype.setP13nData=function(p){this._getP13nModel().setProperty("/items",m([],p));return this;};
B.prototype.getP13nData=function(o){var i=m([],this._getP13nModel().getProperty("/items"));if(o){i=i.filter(function(I){return I[this.PRESENCE_ATTRIBUTE];}.bind(this));}return i;};
B.prototype.setMessageStrip=function(s){if(!s){this.getAggregation("_content").removeItem(this._oMessageStrip);this._oMessageStrip=null;}else{s.addStyleClass("sapUiSmallMargin");if(this._oMessageStrip){this._oMessageStrip.destroy();}this._oMessageStrip=s;this.getAggregation("_content").insertItem(s,0);}return this;};
B.prototype.getMessageStrip=function(){return this._oMessageStrip;};
B.prototype.setEnableReorder=function(E){var t=this.getAggregation("_template");if(E){this._addHover(t);}else if(t&&t.aDelegates&&t.aDelegates.length>0){t.removeEventDelegate(t.aDelegates[0].oDelegate);}this._getDragDropConfig().setEnabled(E);this._setMoveButtonVisibility(E);this.setProperty("enableReorder",E);return this;};
B.prototype._getDragDropConfig=function(){if(!this._oDragDropInfo){this._oDragDropInfo=new D({enabled:false,sourceAggregation:"items",targetAggregation:"items",dropPosition:"Between",drop:[this._onRearrange,this]});}return this._oDragDropInfo;};
B.prototype._getMoveTopButton=function(){if(!this._oMoveTopBtn){this._oMoveTopBtn=new d(this.getId()+"-moveTopBtn",{type:"Transparent",tooltip:this._getResourceText("p13n.MOVE_TO_TOP"),icon:"sap-icon://collapse-group",press:[this._onPressButtonMoveToTop,this],visible:false});this.addDependent(this._oMoveTopBtn);}return this._oMoveTopBtn;};
B.prototype._getMoveUpButton=function(){if(!this._oMoveUpButton){this._oMoveUpButton=new d(this.getId()+"-moveUpBtn",{type:"Transparent",tooltip:this._getResourceText("p13n.MOVE_UP"),icon:"sap-icon://navigation-up-arrow",press:[this._onPressButtonMoveUp,this],visible:false});this.addDependent(this._oMoveUpButton);}return this._oMoveUpButton;};
B.prototype._getMoveDownButton=function(){if(!this._oMoveDownButton){this._oMoveDownButton=new d(this.getId()+"-moveDownpBtn",{type:"Transparent",tooltip:this._getResourceText("p13n.MOVE_DOWN"),icon:"sap-icon://navigation-down-arrow",press:[this._onPressButtonMoveDown,this],visible:false});this.addDependent(this._oMoveDownButton);}return this._oMoveDownButton;};
B.prototype._getMoveBottomButton=function(){if(!this._oMoveBottomButton){this._oMoveBottomButton=new d(this.getId()+"-moveBottomBtn",{type:"Transparent",tooltip:this._getResourceText("p13n.MOVE_TO_BOTTOM"),icon:"sap-icon://expand-group",press:[this._onPressButtonMoveToBottom,this],visible:false});this.addDependent(this._oMoveBottomButton);}return this._oMoveBottomButton;};
B.prototype._createInnerListControl=function(){return new b(this.getId()+"-innerP13nList",Object.assign(this._getListControlConfig(),{headerToolbar:new O({content:[this._getSearchField(),new c(),this._getMoveTopButton(),this._getMoveUpButton(),this._getMoveDownButton(),this._getMoveBottomButton()]})}));};
B.prototype._addHover=function(r){if(r&&r.aDelegates.length<1){r.addEventDelegate({onmouseover:this._hoverHandler.bind(this),onfocusin:this._focusHandler.bind(this)});}};
B.prototype._focusHandler=function(E){if(!this.getEnableReorder()){return;}var h=sap.ui.getCore().byId(E.currentTarget.id);this._handleActivated(h);};
B.prototype._hoverHandler=function(E){if(this._oSelectedItem&&!this._oSelectedItem.bIsDestroyed){return;}if(!this.getEnableReorder()){return;}var h=sap.ui.getCore().byId(E.currentTarget.id);this._handleActivated(h);};
B.prototype._handleActivated=function(h){this._oHoveredItem=h;};
B.prototype._getListControlConfig=function(){return{mode:"MultiSelect",rememberSelections:true,itemPress:[this._onItemPressed,this],selectionChange:[this._onSelectionChange,this],sticky:["HeaderToolbar","ColumnHeaders","InfoToolbar"],dragDropConfig:this._getDragDropConfig()};};
B.prototype._getSearchField=function(){if(!this._oSearchField){this._oSearchField=new S(this.getId()+"-searchField",{liveChange:[this._onSearchFieldLiveChange,this],width:"100%",layoutData:new e({shrinkable:true,moveToOverflow:true,priority:"High",maxWidth:"16rem"})});}return this._oSearchField;};
B.prototype._setTemplate=function(t){t.setType("Active");this.setAggregation("_template",t);if(t){if(this.getEnableReorder()){this._addHover(t);}this._oSelectionBindingInfo=t.getBindingInfo("selected");if(this._oSelectionBindingInfo&&this._oSelectionBindingInfo.parts){this._oSelectionBindingInfo={parts:this._oSelectionBindingInfo.parts};}}this._bindListItems();return this;};
B.prototype._setPanelColumns=function(v){var f;if(v instanceof Array){f=v;}else{f=[v];}this._addTableColumns(f);};
B.prototype._getP13nModel=function(){return this.getModel(this.P13N_MODEL);};
B.prototype._getResourceText=function(t,v){this.oResourceBundle=this.oResourceBundle?this.oResourceBundle:sap.ui.getCore().getLibraryResourceBundle("sap.m");return t?this.oResourceBundle.getText(t,v):this.oResourceBundle;};
B.prototype._addTableColumns=function(f){var r=this._oListControl.removeAllColumns();r.forEach(function(R){R.destroy();});f.forEach(function(v){var o;if(typeof v=="string"){o=new a({header:new T({text:v})});}else{o=v;}this._oListControl.addColumn(o);},this);};
B.prototype._bindListItems=function(f){var t=this.getAggregation("_template");if(t){this._oListControl.bindItems(Object.assign({path:this.P13N_MODEL+">/items",key:"name",templateShareable:false,template:this.getAggregation("_template").clone()},f));}};
B.prototype._onSelectionChange=function(E){var l=E.getParameter("listItems");var s=E.getParameter("selectAll");var f=!s&&l.length>1;l.forEach(function(t){this._selectTableItem(t,s||f);},this);if(s||f){this.fireChange({reason:s?this.CHANGE_REASON_SELECTALL:this.CHANGE_REASON_DESELECTALL,item:undefined});}if(f){this._getMoveTopButton().setEnabled(false);this._getMoveUpButton().setEnabled(false);this._getMoveDownButton().setEnabled(false);this._getMoveBottomButton().setEnabled(false);}};
B.prototype._onItemPressed=function(E){var t=E.getParameter('listItem');this._oSelectedItem=t;var o=t.getBindingContext(this.P13N_MODEL);if(this.getEnableReorder()&&o&&o.getProperty(this.PRESENCE_ATTRIBUTE)){this._handleActivated(t);this._updateEnableOfMoveButtons(t,true);}};
B.prototype._onSearchFieldLiveChange=function(E){this._oListControl.getBinding("items").filter(new F("label","Contains",E.getSource().getValue()));};
B.prototype._onPressButtonMoveToTop=function(){this._moveSelectedItem(0);};
B.prototype._onPressButtonMoveUp=function(){this._moveSelectedItem("Up");};
B.prototype._onPressButtonMoveDown=function(){this._moveSelectedItem("Down");};
B.prototype._onPressButtonMoveToBottom=function(){var i=this._oListControl.getItems().length-1;this._moveSelectedItem(i);};
B.prototype._setMoveButtonVisibility=function(v){this._getMoveTopButton().setVisible(v);this._getMoveUpButton().setVisible(v);this._getMoveDownButton().setVisible(v);this._getMoveBottomButton().setVisible(v);};
B.prototype._filterBySelected=function(s,l){l.getBinding("items").filter(s?new F(this.PRESENCE_ATTRIBUTE,"EQ",true):[]);};
B.prototype._selectTableItem=function(t,s){this._updateEnableOfMoveButtons(t,s?false:true);this._oSelectedItem=t;if(!s){var i=this._getP13nModel().getProperty(this._oSelectedItem.getBindingContext(this.P13N_MODEL).sPath);this.fireChange({reason:i[this.PRESENCE_ATTRIBUTE]?this.CHANGE_REASON_ADD:this.CHANGE_REASON_REMOVE,item:i});}};
B.prototype._moveSelectedItem=function(n){var s=this._oSelectedItem;var i=this._oListControl.indexOfItem(s);if(i<0){return;}var N=(typeof n=="number")?n:i+(n=="Up"?-1:1);this._moveTableItem(s,N);};
B.prototype._getModelEntry=function(i){return i.getBindingContext(this.P13N_MODEL).getObject();};
B.prototype._moveTableItem=function(i,n){var I=this._oListControl.getItems();var f=this._getP13nModel().getProperty("/items");var o=f.indexOf(this._getModelEntry(i));n=(n<=0)?0:Math.min(n,I.length-1);n=f.indexOf(this._getModelEntry(I[n]));if(n==o){return;}f.splice(n,0,f.splice(o,1)[0]);this._getP13nModel().setProperty("/items",f);this._oSelectedItem=this._oListControl.getItems()[n];this._updateEnableOfMoveButtons(this._oSelectedItem,this._bFocusOnRearrange);this._handleActivated(this._oSelectedItem);this.fireChange({reason:this.CHANGE_REASON_MOVE,item:this._getModelEntry(i)});};
B.prototype._onRearrange=function(E){var o=E.getParameter("draggedControl");var f=E.getParameter("droppedControl");var s=E.getParameter("dropPosition");var i=this._oListControl.indexOfItem(o);var g=this._oListControl.indexOfItem(f);var A=g+(s=="Before"?0:1)+(i<g?-1:0);this._moveTableItem(o,A);};
B.prototype._updateEnableOfMoveButtons=function(t,f){var i=this._oListControl.getItems().indexOf(t);var u=true,g=true;if(i==0){u=false;}if(i==this._oListControl.getItems().length-1){g=false;}this._getMoveTopButton().setEnabled(u);this._getMoveUpButton().setEnabled(u);this._getMoveDownButton().setEnabled(g);this._getMoveBottomButton().setEnabled(g);if(f){t.focus();}};
B.prototype.exit=function(){C.prototype.exit.apply(this,arguments);this._bFocusOnRearrange=null;this._oHoveredItem=null;this._oSelectionBindingInfo=null;this._oSelectedItem=null;this._oListControl=null;this._oMoveTopBtn=null;this._oMoveUpButton=null;this._oMoveDownButton=null;this._oMoveBottomButton=null;this._oSearchField=null;};
return B;});
sap.ui.predefine('sap/m/p13n/Container',["sap/m/p13n/AbstractContainer","sap/m/Bar","sap/m/Button","sap/m/List","sap/m/IconTabBar","sap/m/IconTabFilter","sap/m/p13n/AbstractContainerItem","sap/ui/Device","sap/m/library","sap/m/StandardListItem","sap/m/CustomListItem","sap/ui/core/Control"],function(A,B,a,L,I,b,C,D,l,S,c,d){"use strict";var e=l.ButtonType;var f=l.ListType;
var g=A.extend("sap.m.p13n.Container",{
metadata:{library:"sap.m",properties:{listLayout:{type:"boolean",defaultValue:false}}},
renderer:{apiVersion:2}
});
g.prototype.DEFAULT_KEY="$default";
g.prototype.init=function(){A.prototype.init.apply(this,arguments);this.addStyleClass("sapMP13nContainer");this.setListLayout(D.system.phone);};
g.prototype.setListLayout=function(h){this.setProperty("listLayout",h);this._getTabBar().removeAllItems();this._getNavigationList().removeAllItems();var H;if(h){this._getTabBar().setVisible(false);this._getNavigationList();this.switchView(this.DEFAULT_KEY);H=this._getNavBackBtn();}else{this._getTabBar().setVisible(true);var v=this.getViews();if(v.length>1){this.switchView(v[1].getKey());}H=this._getTabBar();}var o=this.getHeader();if(!o){var i=new B({contentLeft:[H]});this.setHeader(i);}else{o.removeAllContentLeft();o.addContentLeft(H);}this.getViews().forEach(function(V){this._addToNavigator(V);}.bind(this));return this;};
g.prototype.switchView=function(k){A.prototype.switchView.apply(this,arguments);if(this._bPrevented){return;}var p=this.getParent();if(p&&p.isA("sap.ui.core.Control")){p.focus();p.invalidate();var h=p.getDependents();if(h){h.forEach(function(o){if(o&&o.isA("sap.ui.core.Control")){o.invalidate();}});}}this.oLayout.setShowHeader(k!==this.DEFAULT_KEY);this._getTabBar().setSelectedKey(k);this._getNavBackBtn().setVisible(k!==this.DEFAULT_KEY);this._getNavBackBtn().setText((this.getView(k)&&this.getView(k).getText())||k);};
g.prototype.addView=function(o){A.prototype.addView.apply(this,arguments);this._addToNavigator(o);return this;};
g.prototype.removeView=function(o){A.prototype.removeView.apply(this,arguments);this._removeFromNavigator(o);};
g.prototype.addSeparator=function(){if(!this.getProperty("listLayout")){return;}var i=this._getNavigationList().getItems();var o=i[i.length-1];o.addStyleClass("sapMMenuDivider");return this;};
g.prototype._getTabBar=function(){if(!this._oTabBar){this._oTabBar=new I({expandable:false,expanded:true,select:function(E){this.switchView(E.getParameter("key"));}.bind(this)});this.addDependent(this._oTabBar);}return this._oTabBar;};
g.prototype._getNavigationList=function(){if(!this._oNavigationList){this._oNavigationList=new L({itemPress:function(E){var i=E.getParameter("listItem");this.switchView(i._key);}.bind(this)}).addStyleClass("p13nContainerDefaultList");this.addDependent(this._oNavigationList);}if(!this.getView(this.DEFAULT_KEY)){var o=new C({key:this.DEFAULT_KEY,content:this._oNavigationList});this.addView(o);}return this._oNavigationList;};
g.prototype._getNavBackBtn=function(){if(!this._oNavBackBtn){this._oNavBackBtn=new a({type:e.Back,press:function(E){this.switchView(this.DEFAULT_KEY);}.bind(this)});this.addDependent(this._oNavBackBtn);}return this._oNavBackBtn;};
g.prototype._addToNavigator=function(o){var k=o.getKey(),t=o.getText(),i=o.getIcon();if(k==this.DEFAULT_KEY){return;}if(this.getListLayout()){this.getView(this.DEFAULT_KEY);var h=new S({type:f.Navigation,icon:i,title:t});h._key=k;this._getNavigationList().addItem(h);}else{this._getTabBar().addItem(new b({key:k,text:t||k}));}};
g.prototype._removeFromNavigator=function(o){var k=o.getKey();if(k==this.DEFAULT_KEY){return;}if(this.getListLayout()){var i=this._getNavigationList().getItems().find(function(h){return h._key===k;});this._getNavigationList().removeItem(i);}else{var t=this._getTabBar().getItems().find(function(t){return t.getKey()===k;});this._getTabBar().removeItem(t);}};
g.prototype.exit=function(){A.prototype.exit.apply(this,arguments);if(this._oTabBar){this._oTabBar.destroy();this._oTabBar=null;}if(this._oNavigationList){this._oNavigationList.destroy();this._oNavigationList=null;}this._oNavBackBtn=null;};
return g;});
sap.ui.predefine('sap/m/p13n/GroupPanel',["./QueryPanel","sap/m/HBox","sap/m/CheckBox","sap/ui/layout/Grid"],function(Q,H,C,G){"use strict";
var a=Q.extend("sap.m.p13n.GroupPanel",{
metadata:{properties:{enableShowField:{type:"boolean",defaultValue:false}}},
renderer:{apiVersion:2}
});
a.prototype.PRESENCE_ATTRIBUTE="grouped";a.prototype.CHANGE_REASON_SHOWIFGROUPED="showifgrouped";
a.prototype._createQueryRowGrid=function(i){var k=i.name;var s=this._createKeySelect(k);var g=new G({containerQuery:true,defaultSpan:this.getEnableShowField()?"XL4 L4 M4 S4":"XL6 L6 M6 S6",content:[s]}).addStyleClass("sapUiTinyMargin");if(this.getEnableShowField()){var c=this._createCheckBox(i);g.addContent(c);}return g;};
a.prototype._createCheckBox=function(i){var k=i.name;var c=new H({alignItems:"Center",items:[new C({enabled:k?true:false,selected:i.hasOwnProperty("showIfGrouped")?i.showIfGrouped:true,select:function(e){var p=e.getSource().getParent().getParent().getParent().getParent().getParent().getParent();var k=e.oSource.getParent().getParent().getContent()[0].getSelectedItem().getKey();this._changeShowIfGrouped(k,e.getParameter("selected"));p.fireChange({reason:"change",item:{name:k,grouped:true,showIfGrouped:e.getParameter("selected")}});}.bind(this),text:this._getResourceText("p13n.GROUP_CHECKBOX")})]});return c;};
a.prototype._changeShowIfGrouped=function(k,s){var i=this._getP13nModel().getProperty("/items").filter(function(I){return I.name===k;});i[0].showIfGrouped=s;this.fireChange({reason:this.CHANGE_REASON_SHOWIFGROUPED,item:i[0]});};
a.prototype._selectKey=function(e){Q.prototype._selectKey.apply(this,arguments);var l=e.getSource().getParent().getParent();var n=e.getParameter("selectedItem").getKey();l.getContent()[0].getContent()[1].getItems()[0].setEnabled(n!==this.NONE_KEY);};
return a;});
sap.ui.predefine('sap/m/p13n/Popup',["sap/ui/core/Control","sap/m/Button","sap/m/Bar","sap/m/Title","sap/m/MessageBox","sap/ui/Device","sap/m/Dialog","sap/m/ResponsivePopover","sap/m/p13n/Container","sap/m/p13n/AbstractContainerItem","sap/m/library"],function(C,B,a,T,M,D,b,R,c,A,l){"use strict";var P=l.P13nPopupMode;
var d=C.extend("sap.m.p13n.Popup",{
metadata:{properties:{title:{type:"string"},mode:{type:"sap.m.P13nPopupMode",defaultValue:P.Dialog},warningText:{type:"string"},reset:{type:"function"}},aggregations:{panels:{type:"sap.m.p13n.IContent",multiple:true},additionalButtons:{type:"sap.m.Button",multiple:true}},events:{close:{reason:{type:"string"}}}},
renderer:{apiVersion:2,render:function(r,o){r.openStart("div",o);r.style("height","100%");r.openEnd();r.renderControl(o.getAggregation("_content"));r.close("div");}}
});
d.prototype.init=function(){C.prototype.init.apply(this,arguments);this._aPanels=[];};
d.prototype.isOpen=function(){return!!this._bIsOpen;};
d.prototype.setMode=function(m){this.setProperty("mode",m);if(this._oPopup){this._oPopup.removeAllContent();this._oPopup.destroy();var p=this._createContainer();this.addDependent(p);this._oPopup=p;}return this;};
d.prototype.open=function(s,S){if(!s){throw new Error("Please provide a source control!");}if(!this._oPopup){var p=this._createContainer(S);this.addDependent(p);this._oPopup=p;}if(this.getMode()==="Dialog"){this._oPopup.open();}else{this._oPopup.openBy(s);}this._bIsOpen=true;};
d.prototype.addPanel=function(p){this._getContainer().addView(new A({key:p.getId(),text:p.getTitle(),content:p}));this._aPanels.push(p);return this;};
d.prototype.removePanel=function(p){this._aPanels.splice(this._aPanels.indexOf(p),1);this._getContainer().removeView(this._getContainer().getView(p.getId()));return this;};
d.prototype.getPanels=function(){return this._aPanels;};
d.prototype._createContainer=function(m){m=m?m:{};return this["_create"+this.getMode()].call(this,m);};
d.prototype._createResponsivePopover=function(m){var p=new R(this.getId()+"-responsivePopover",{title:this.getTitle(),horizontalScrolling:m.hasOwnProperty("horizontalScrolling")?m.horizontalScrolling:false,verticalScrolling:false,contentWidth:m.contentWidth?m.contentWidth:"30rem",resizable:m.hasOwnProperty("resizable")?m.resizable:true,contentHeight:m.contentHeight?m.contentHeight:"35rem",placement:m.placement?m.placement:"Bottom",content:this._getContainer()});p.setCustomHeader(this._createTitle());return p;};
d.prototype._createDialog=function(m){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");var o=new b(this.getId()+"-dialog",{title:this.getTitle(),horizontalScrolling:m.hasOwnProperty("horizontalScrolling")?m.horizontalScrolling:false,verticalScrolling:false,contentWidth:m.contentWidth?m.contentWidth:"40rem",contentHeight:m.contentHeight?m.contentHeight:"55rem",draggable:true,resizable:true,stretch:D.system.phone,content:this._getContainer(),buttons:[new B(this.getId()+"-confirmBtn",{text:m.confirm&&m.confirm.text?m.confirm.text:r.getText("p13n.POPUP_OK"),type:"Emphasized",press:function(){this._onClose(o,"Ok");}.bind(this)}),new B(this.getId()+"-cancelBtn",{text:r.getText("p13n.POPUP_CANCEL"),press:function(){this._onClose(o,"Cancel");}.bind(this)})]});o.setCustomHeader(this._createTitle());this.getAdditionalButtons().forEach(function(e){o.addButton(e);});return o;};
d.prototype._createTitle=function(){var r=this.getReset();var t=this.getTitle();var w=this.getWarningText();var o;if(r){o=new a({contentLeft:[new T({text:t})]});o.addContentRight(new B(this.getId()+"-resetBtn",{text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("p13n.POPUP_RESET"),press:function(e){var f=e.getSource().getParent().getParent();var g=f.getParent();var s=w;M.warning(s,{actions:[M.Action.OK,M.Action.CANCEL],emphasizedAction:M.Action.OK,onClose:function(h){if(h===M.Action.OK){f.getButtons()[0].focus();r(g);}}});}}));}return o;};
d.prototype._getContainer=function(s){if(!this._oContainer){this._oContainer=new c();}if(this._oContainer.getViews().length>1){this._oContainer.switchView(this._oContainer.getViews()[1].getKey());}return this._oContainer;};
d.prototype._onClose=function(o,r){o.close();this._bIsOpen=false;this.fireClose({reason:r});};
d.prototype.exit=function(){if(this._oPopup){this._oPopup.destroy();}this._aPanels=null;};
return d;});
sap.ui.predefine('sap/m/p13n/QueryPanel',["sap/ui/layout/Grid","./BasePanel","sap/ui/core/Item","sap/m/CustomListItem","sap/m/Select","sap/m/List","sap/m/HBox","sap/m/library","sap/m/Button"],function(G,B,I,C,S,L,H,l,a){"use strict";
var Q=B.extend("sap.m.p13n.QueryPanel",{
metadata:{library:"sap.m",properties:{queryLimit:{type:"int",defaultValue:-1}}},
renderer:{apiVersion:2}
});
var b=l.ListType;var F=l.FlexJustifyContent;var c=l.ButtonType;Q.prototype.NONE_KEY="$_none";
Q.prototype.init=function(){B.prototype.init.apply(this,arguments);this._bFocusOnRearrange=false;this.setEnableReorder(true);this.addStyleClass("sapMP13nQueryPanel");};
Q.prototype.setP13nData=function(p){B.prototype.setP13nData.apply(this,arguments);this._oListControl.removeAllItems();if(p instanceof Array){p.forEach(function(i){if(i[this.PRESENCE_ATTRIBUTE]){this._addQueryRow(i);}}.bind(this));this._addQueryRow();}return this;};
Q.prototype._moveTableItem=function(i,n){B.prototype._moveTableItem.apply(this,arguments);this._updateEnableOfMoveButtons(i,false);this._oListControl.removeItem(i);this._oListControl.insertItem(i,n);};
Q.prototype._updateEnableOfMoveButtons=function(t,f){B.prototype._updateEnableOfMoveButtons.apply(this,arguments);if(this._oListControl.getItems().indexOf(t)===(this._oListControl.getItems().length-2)){this._getMoveDownButton().setEnabled(false);}};
Q.prototype._createInnerListControl=function(){return new L(this.getId()+"-innerP13nList",{itemPress:[this._onItemPressed,this],dragDropConfig:this._getDragDropConfig()});};
Q.prototype._getModelEntry=function(r){var k=r.getContent()[0].getContent()[0]._key;var f=this._getP13nModel().getProperty("/items").find(function(o){return o.name==k;});return f;};
Q.prototype._getAvailableItems=function(k){var i=this._getP13nModel().getProperty("/items");var A=[new I({key:this.NONE_KEY,text:this._getResourceText("p13n.QUERY_NONE"),enabled:!k})];i.forEach(function(n,d){A.push(new I({key:n.name,text:n.label,enabled:{path:this.P13N_MODEL+">/items/"+d+"/"+this.PRESENCE_ATTRIBUTE,formatter:function(q){return!q;}}}));}.bind(this));return A;};
Q.prototype._getMoveDownButton=function(){var m=B.prototype._getMoveDownButton.apply(this,arguments);m.setIcon("sap-icon://navigation-down-arrow");return m;};
Q.prototype._getMoveUpButton=function(){var m=B.prototype._getMoveUpButton.apply(this,arguments);m.setIcon("sap-icon://navigation-up-arrow");return m;};
Q.prototype._addQueryRow=function(i){if(this.getQueryLimit()>-1&&this.getQueryLimit()===this._oListControl.getItems().length){return;}i=i?i:{name:null};var q=this._createQueryRowGrid(i);var r=new C({type:b.Active,content:[q]});if(this.getEnableReorder()&&(this.getQueryLimit()===-1||this.getQueryLimit()>1)){this._addHover(r);}r.getContent()[0].getContent()[0]._key=i.name;this._oListControl.addItem(r);var s=!!i.name;var R=this._createRemoveButton(s);r.getContent()[0].addContent(R);return r;};
Q.prototype._createQueryRowGrid=function(i){var s=this._createKeySelect(i.name);return new G({containerQuery:true,defaultSpan:"XL6 L6 M6 S6",content:[s]}).addStyleClass("sapUiTinyMargin");};
Q.prototype._handleActivated=function(h){var q=h.getContent()[0];if(q){var i=q.getContent().length-1;var o=h.getContent()[0].getContent()[i];if(h&&o.getItems().length<2){o.insertItem(this._getMoveUpButton(),0);o.insertItem(this._getMoveDownButton(),1);this._updateEnableOfMoveButtons(h,false);}}};
Q.prototype._createKeySelect=function(k){var K=new S({width:"14rem",items:this._getAvailableItems(k),selectedKey:k,change:this._selectKey.bind(this)});return K;};
Q.prototype._selectKey=function(e){var o=e.getSource().getParent().getParent();var i=this._oListControl.getItems().length-1==this._oListControl.getItems().indexOf(o);var n=e.getParameter("selectedItem").getKey();var O=e.getSource()._key;var d=o.getContent()[0].getContent()[o.getContent()[0].getContent().length-1];d.setVisible(n!==this.NONE_KEY);if(O){this._updatePresence(O,false,undefined);}e.getSource()._key=n;this._updatePresence(n,true,this._oListControl.getItems().indexOf(o));if(n!==this.NONE_KEY&&i){this._addQueryRow();var s=e.getSource();var N=s.getItemByKey(this.NONE_KEY);N.setEnabled(false);}};
Q.prototype._createRemoveButton=function(v){var r=new H({justifyContent:F.End,width:"100%",visible:v,items:[new a({type:c.Transparent,icon:"sap-icon://decline",press:function(e){var R=e.getSource().getParent().getParent().getParent();this._oListControl.removeItem(R);this._updatePresence(R.getContent()[0].getContent()[0]._key,false,undefined);if(this._oListControl.getItems().length===0){this._addQueryRow();}else{var i=this._oListControl.getItems().length-1;this._oListControl.getItems()[i].getContent()[0].getContent()[0].focus();}}.bind(this)})]});return r;};
Q.prototype._moveSelectedItem=function(){this._oSelectedItem=this._getMoveUpButton().getParent().getParent().getParent();B.prototype._moveSelectedItem.apply(this,arguments);};
Q.prototype._updatePresence=function(k,A,n){var i=this._getP13nModel().getProperty("/items");var r=i.filter(function(d){return d.name===k;});if(r[0]){r[0][this.PRESENCE_ATTRIBUTE]=A;}if(n!==undefined){var o=i.indexOf(r[0]);i.splice(n,0,i.splice(o,1)[0]);}this._getP13nModel().setProperty("/items",i);this.fireChange({reason:A?this.CHANGE_REASON_ADD:this.CHANGE_REASON_REMOVE,item:r[0]});};
return Q;});
sap.ui.predefine('sap/m/p13n/SelectionPanel',["./BasePanel","sap/m/Label","sap/m/ColumnListItem","sap/m/HBox","sap/m/VBox","sap/ui/core/Icon","sap/m/Text","sap/m/Column","sap/m/Table","sap/m/library","sap/m/ToolbarSpacer","sap/m/Button","sap/m/OverflowToolbar","sap/ui/model/Filter"],function(B,L,C,H,V,I,T,a,b,l,c,d,O,F){"use strict";var e=l.ListKeyboardMode;var f=l.FlexJustifyContent;var g=l.ListType;
var S=B.extend("sap.m.p13n.SelectionPanel",{
metadata:{library:"sap.m",properties:{showHeader:{type:"boolean",defaultValue:false},enableCount:{type:"boolean",defaultValue:false},fieldColumn:{type:"string",defaultValue:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("p13n.DEFAULT_DESCRIPTION")},activeColumn:{type:"string",defaultValue:""},itemFactory:{type:"function"}}},
renderer:{apiVersion:2}
});
S.prototype.applySettings=function(){B.prototype.applySettings.apply(this,arguments);this._setTemplate(this._getListTemplate());this.addStyleClass("sapMSelectionPanel");this._aInitializedFields=[];this._bShowFactory=false;this.addStyleClass("SelectionPanelHover");this._displayColumns();this.setEnableReorder(true);};
S.prototype.setItemFactory=function(i){this.setProperty("itemFactory",i);this._oListControl.setGrowing(!!i);return this;};
S.prototype._getListTemplate=function(){return new C({selected:"{"+this.P13N_MODEL+">"+this.PRESENCE_ATTRIBUTE+"}",type:g.Active,cells:[new V({items:[new L({wrapping:true,required:"{"+this.P13N_MODEL+">required}",tooltip:"{"+this.P13N_MODEL+">tooltip}",text:"{"+this.P13N_MODEL+">label}"})]}),new H({justifyContent:f.Center,items:[new I({src:"sap-icon://circle-task-2",size:"0.5rem",color:sap.ui.core.IconColor.Neutral,visible:{path:this.P13N_MODEL+">active",formatter:function(h){if(h){return true;}else{return false;}}}})]})]});};
S.prototype.setShowHeader=function(s){if(s){var h=this._getResourceText("p13n.SHOW_SELECTED");var i=this._getResourceText("p13n.SHOW_ALL");this._oListControl.setHeaderToolbar(new O({content:[this._getSearchField(),new c(),new d({press:function(E){this._bShowSelected=E.getSource().getText()==h;this._filterList(this._bShowSelected,this._sSearch);E.getSource().setText(this._bShowSelected?i:h);}.bind(this),text:h})]}));}this.setProperty("showHeader",s);return this;};
S.prototype.getSelectedFields=function(){var s=[];this._loopItems(this._oListControl,function(i,k){if(i.getSelected()){s.push(k);}});return s;};
S.prototype._filterList=function(s,h){var o=[],i=[];if(s){i=new F(this.PRESENCE_ATTRIBUTE,"EQ",true);}if(h){o=new F("label","Contains",h);}this._oListControl.getBinding("items").filter(new F([].concat(i,o),true));};
S.prototype._onSearchFieldLiveChange=function(E){this._sSearch=E.getSource().getValue();this._filterList(this._bShowSelected,this._sSearch);};
S.prototype._handleActivated=function(h){this._removeMoveButtons();if(this._oHoveredItem&&this._oHoveredItem.getBindingContextPath()){var v=!!this._getP13nModel().getProperty(this._oHoveredItem.getBindingContextPath()).active;var o=this._oHoveredItem.getCells()[1].getItems()[0];o.setVisible(v);}var i=h.getCells()[1].getItems()[0];i.setVisible(false);this._oHoveredItem=h;this._updateEnableOfMoveButtons(h,false);this._addMoveButtons(h);};
S.prototype._removeMoveButtons=function(){var m=this._getMoveButtonContainer();if(m){m.removeItem(this._getMoveTopButton());m.removeItem(this._getMoveUpButton());m.removeItem(this._getMoveDownButton());m.removeItem(this._getMoveBottomButton());}};
S.prototype._getMoveButtonContainer=function(){if(this._oMoveBottomButton&&this._oMoveBottomButton.getParent()&&this._oMoveBottomButton.getParent().isA("sap.m.FlexBox")){return this._oMoveBottomButton.getParent();}};
S.prototype.showFactory=function(s){this._bShowFactory=s;this._displayColumns();if(s){this.removeStyleClass("SelectionPanelHover");this._oListControl.setKeyboardMode(e.Edit);this._addFactoryControl();}else{this.addStyleClass("SelectionPanelHover");this._oListControl.setKeyboardMode(e.Navigation);this._removeFactoryControl();}};
S.prototype._loopItems=function(o,i){o.getItems().forEach(function(h){var p=h.getBindingContextPath();var k=this._getP13nModel().getProperty(p).name;i.call(this,h,k);}.bind(this));};
S.prototype.setP13nData=function(){this._oListControl.removeSelections();B.prototype.setP13nData.apply(this,arguments);this._updateCount();};
S.prototype._updateCount=function(){this._getP13nModel().setProperty("/selectedItems",this._oListControl.getSelectedContexts(true).length);};
S.prototype._selectTableItem=function(t,s){B.prototype._selectTableItem.apply(this,arguments);this._updateCount();};
S.prototype._removeFactoryControl=function(){this._oListControl.getItems().forEach(function(i){var o=i.getCells()[0];if(o.getItems().length>1){o.removeItem(o.getItems()[1]);}});this.removeStyleClass("sapUiMDCAFLabelMarkingList");return this._aInitializedFields;};
S.prototype._moveSelectedItem=function(){this._oSelectedItem=this._getMoveButtonContainer().getParent();B.prototype._moveSelectedItem.apply(this,arguments);};
S.prototype._getShowFactory=function(){return this._bShowFactory;};
S.prototype._displayColumns=function(){var h=[this.getFieldColumn()];if(!this._bShowFactory){h.push(new a({width:"30%",hAlign:"Center",vAlign:"Middle",header:new T({text:this.getActiveColumn()})}));}this._setPanelColumns(h);};
S.prototype._setPanelColumns=function(h){this._sText=h[0];var E=this.getEnableCount();if(E){var o=new a({header:new T({text:{parts:[{path:this.P13N_MODEL+'>/selectedItems'},{path:this.P13N_MODEL+'>/items'}],formatter:function(s,A){return this._sText+" "+this._getResourceText('p13n.HEADER_COUNT',[s,A instanceof Array?A.length:0]);}.bind(this)}})});h[0]=o;}B.prototype._setPanelColumns.apply(this,arguments);};
S.prototype._addFactoryControl=function(o){this._oListControl.getItems().forEach(function(i){var h=i.getBindingContext(this.P13N_MODEL);var j=this.getItemFactory().call(this,h);var k=i.getCells()[0];k.addItem(j);}.bind(this));this.addStyleClass("sapUiMDCAFLabelMarkingList");};
S.prototype._createInnerListControl=function(){return new b(this.getId()+"-innerSelectionPanelTable",Object.assign({growing:false,growingThreshold:25,growingScrollToLoad:true,updateStarted:function(){this._removeMoveButtons();this._removeFactoryControl();}.bind(this),updateFinished:function(){if(this._getShowFactory()){this._addFactoryControl();}}.bind(this)},this._getListControlConfig()));};
S.prototype.filterContent=function(h){if(this._oListControl.getBinding("items")){this._oListControl.getBinding("items").filter(h,true);}};
S.prototype._addMoveButtons=function(i){var t=i;if(!t){return;}var h=this._getP13nModel().getProperty(t.getBindingContextPath())[this.PRESENCE_ATTRIBUTE];if(h){t.getCells()[1].addItem(this._getMoveTopButton());t.getCells()[1].addItem(this._getMoveUpButton());t.getCells()[1].addItem(this._getMoveDownButton());t.getCells()[1].addItem(this._getMoveBottomButton());}};
S.prototype.exit=function(){B.prototype.exit.apply(this,arguments);this._aInitializedFields=null;this._oHoveredItem=null;this._bShowFactory=null;this._sSearch=null;this._bShowSelected=null;};
return S;});
sap.ui.predefine('sap/m/p13n/SortPanel',["./QueryPanel","sap/m/Text","sap/m/SegmentedButton","sap/m/SegmentedButtonItem","sap/ui/layout/Grid","sap/ui/layout/GridData"],function(Q,T,S,a,G,b){"use strict";
var c=Q.extend("sap.m.p13n.SortPanel",{renderer:{apiVersion:2}});
c.prototype.PRESENCE_ATTRIBUTE="sorted";c.prototype.CHANGE_REASON_SORTORDER="sortorder";
c.prototype._createRemoveButton=function(){var r=Q.prototype._createRemoveButton.apply(this,arguments);r.setLayoutData(new b({span:"XL3 L3 M3 S4"}));return r;};
c.prototype._createOrderSwitch=function(k,d){var s=new S({enabled:k?true:false,layoutData:new b({span:"XL2 L2 M2 S4"}),items:[new a({key:"asc",icon:"sap-icon://sort-ascending"}),new a({key:"desc",icon:"sap-icon://sort-descending"})],select:function(e){var f=e.getParameter("key");var t=e.getSource().getParent().getContent()[2];t.setText(this._getSortOrderText(f==="desc"));var k=e.oSource.getParent().getContent()[0].getSelectedItem().getKey();this._changeOrder(k,f=="desc");}.bind(this)});s.setSelectedItem(d?s.getItems()[1]:s.getItems()[0]);return s;};
c.prototype._createSortOrderText=function(d){return new T({layoutData:new b({span:"XL3 L3 M3 S3",visibleS:false}),text:this._getSortOrderText(d)}).addStyleClass("sapUiTinyMarginTop");};
c.prototype._createQueryRowGrid=function(i){var s=this._createKeySelect(i.name);var o=this._createOrderSwitch(i.name,i.descending);var d=this._createSortOrderText(i.descending);return new G({containerQuery:true,defaultSpan:"XL4 L4 M4 S4",content:[s,o,d]}).addStyleClass("sapUiTinyMargin");};
c.prototype._selectKey=function(e){Q.prototype._selectKey.apply(this,arguments);var l=e.getSource().getParent().getParent();var n=e.getParameter("selectedItem").getKey();l.getContent()[0].getContent()[1].setEnabled(n!==this.NONE_KEY);var d=l.getContent()[0].getContent()[1].getSelectedKey()==="desc";this._changeOrder(n,d);};
c.prototype._getSortOrderText=function(d){return d?this._getResourceText("p13n.SORT_DESCENDING"):this._getResourceText("p13n.SORT_ASCENDING");};
c.prototype._changeOrder=function(k,d){var i=this._getP13nModel().getProperty("/items").filter(function(I){return I.name===k;});i[0].descending=d;this.fireChange({reason:this.CHANGE_REASON_SORTORDER,item:i[0]});};
return c;});
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/m/AccButton',['./Button','./AccButtonRenderer'],function(B,A){"use strict";
var a=B.extend("sap.m.AccButton",{metadata:{library:"sap.m",properties:{"tabIndex":{type:"string",defaultValue:null,bindable:"bindable"},"ariaHidden":{type:"string",defaultValue:null,bindable:"bindable"},"ariaHaspopup":{type:"string",defaultValue:null,bindable:"bindable"}}}});
return a;});
sap.ui.predefine('sap/m/AccButtonRenderer',["./ButtonRenderer","sap/ui/core/Renderer"],function(B,R){"use strict";var A=R.extend(B);A.apiVersion=2;
A.renderAccessibilityAttributes=function(r,c){if(c.getTabIndex()){r.attr("tabindex",c.getTabIndex());}if(c.getAriaHidden()){r.attr("aria-hidden",c.getAriaHidden());}if(c.getAriaHaspopup()){r.attr("aria-haspopup",c.getAriaHaspopup());}};
return A;},true);
sap.ui.predefine('sap/m/ActionListItem',['./ListItemBase','./library','./ActionListItemRenderer'],function(L,l,A){"use strict";var a=l.ListMode;var b=l.ListType;
var c=L.extend("sap.m.ActionListItem",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
c.prototype.init=function(){this.setType(b.Active);L.prototype.init.apply(this,arguments);};
c.prototype.getMode=function(){return a.None;};
c.prototype.onsapspace=c.prototype.onsapenter;
c.prototype.getContentAnnouncement=function(){return this.getText();};
return c;});
sap.ui.predefine('sap/m/ActionListItemRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer"],function(L,R){"use strict";var A=R.extend(L);A.apiVersion=2;
A.renderLIAttributes=function(r,l){r.class("sapMALI");};
A.renderLIContent=function(r,l){var t=l.getText();if(t){r.openStart("div").class("sapMALIText").openEnd();r.text(t);r.close("div");}};
return A;},true);
sap.ui.predefine('sap/m/ActionSelect',['./Select','sap/ui/core/InvisibleText','sap/ui/Device','sap/ui/core/Core','./ActionSelectRenderer'],function(S,I,D,C,A){"use strict";
var a=S.extend("sap.m.ActionSelect",{metadata:{library:"sap.m",associations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button"}}}});
a.prototype.init=function(){S.prototype.init.call(this);this.getList().addEventDelegate({onfocusin:this.onfocusinList},this);};
a.prototype.hasContent=function(){return S.prototype.hasContent.call(this)||!!this.getButtons().length;};
a.prototype.addContentToFlex=function(){var s=this.getSimpleFixFlex();this.getButtons().forEach(function(b){s.addFlexContent(C.byId(b));});};
a.prototype._onBeforeRenderingPopover=function(){S.prototype._onBeforeRenderingPopover.call(this);var p=this.getPicker();p&&p._setAriaRoleApplication(true);this._updateTutorMessage();};
a.prototype.onAfterRenderingPicker=function(){S.prototype.onAfterRenderingPicker.call(this);var p=this.getPicker(),r=this.getRenderer();p.addStyleClass(r.CSS_CLASS+"Picker");p.addStyleClass(r.ACTION_SELECT_CSS_CLASS+"Picker");p.addStyleClass(r.ACTION_SELECT_CSS_CLASS+"Picker-CTX");};
a.prototype.createPickerCloseButton=function(){};
a.prototype.removeButton=function(b){var s=this.getSimpleFixFlex();if(s){if(typeof b==="number"){b=this.getButtons()[b];}s.removeFlexContent(b);}return this.removeAssociation("buttons",b);};
a.prototype.removeAllButtons=function(){var s=this.getSimpleFixFlex();if(s){this.getButtons().forEach(function(b){s.removeFlexContent(C.byId(b));});}return this.removeAllAssociation("buttons");};
a.prototype.onsaptabprevious=function(e){var b=this.getButtons(),p=this.getPicker(),i;this._bProcessChange=false;if(e.isMarked()||!this.getEnabled()){return;}e.setMarked();if(p&&p.isOpen()&&b.length>0){for(i=b.length-1;i>=0;i--){if(C.byId(b[i]).getEnabled()){C.byId(b[i]).focus();e.preventDefault();break;}}}};
a.prototype.onsaptabnext=function(e){var b=this.getButtons(),p=this.getPicker(),i;this._bProcessChange=false;if(e.isMarked()||!this.getEnabled()){return;}e.setMarked();if(p&&p.isOpen()&&b.length>0){for(i=0;i<b.length;i++){if(C.byId(b[i]).getEnabled()){C.byId(b[i]).focus();e.preventDefault();break;}}}};
a.prototype.onsapfocusleave=function(e){var b=this.getButtons();var k=(b.indexOf(e.relatedControlId)===-1);if(k){S.prototype.onsapfocusleave.apply(this,arguments);}this._toggleListFocusIndication(true);};
a.prototype.onfocusinList=function(e){if(document.activeElement!==this.getList().getDomRef()&&!D.system.phone){this.focus();}};
a.prototype.onfocusin=function(){S.prototype.onfocusin.apply(this,arguments);this._toggleListFocusIndication(false);};
a.prototype._toggleListFocusIndication=function(r){var s=this.getSelectedItem();if(this.isOpen()&&s){s.$().toggleClass("sapMActionSelectItemWithoutFocus",r);}};
a.prototype._updateTutorMessage=function(){var p=this.getPicker(),b=p.getAriaLabelledBy(),h=!!this.getButtons().length,t;if(!this._sTutorMessageId){this._sTutorMessageId=this._getTutorMessageId();this._oTutorMessageText=new I(this._sTutorMessageId,{text:C.getLibraryResourceBundle("sap.m").getText("ACTION_SELECT_TUTOR_MESSAGE")}).toStatic();}t=(b.indexOf(this._sTutorMessageId)===-1);if(t&&h){p.addAriaLabelledBy(this._sTutorMessageId);}else{if(!h){p.removeAriaLabelledBy(this._sTutorMessageId);}}};
a.prototype._getTutorMessageId=function(){return this.getId()+"-tutorMessage";};
a.prototype.exit=function(){S.prototype.exit.call(this);if(this._oTutorMessageText){this._oTutorMessageText.destroy();this._oTutorMessageText=null;}};
return a;});
sap.ui.predefine('sap/m/ActionSelectRenderer',['sap/ui/core/Renderer','./SelectRenderer'],function(R,S){"use strict";var A=R.extend(S);A.ACTION_SELECT_CSS_CLASS="sapMActionSelect";A.apiVersion=2;
A.addClass=function(r,a){r.class(A.ACTION_SELECT_CSS_CLASS);};
return A;},true);
sap.ui.predefine('sap/m/ActionSheet',['./Dialog','./Popover','./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/core/InvisibleText','sap/ui/Device','./ActionSheetRenderer','./Button',"sap/ui/thirdparty/jquery"],function(D,P,l,C,I,a,b,A,B,q){"use strict";var c=l.ButtonType;var d=l.DialogType;var e=l.PlacementType;
var f=C.extend("sap.m.ActionSheet",{metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Appearance",defaultValue:e.Bottom},showCancelButton:{type:"boolean",group:"Appearance",defaultValue:true},cancelButtonText:{type:"string",group:"Appearance",defaultValue:null},title:{type:"string",group:"Appearance",defaultValue:null}},aggregations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button"},_cancelButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_invisibleAriaTexts:{type:"sap.ui.core.InvisibleText",multiple:true,visibility:"hidden"}},defaultAggregation:"buttons",events:{cancelButtonTap:{deprecated:true},beforeOpen:{},afterOpen:{},beforeClose:{parameters:{origin:{type:"sap.m.Button"}}},afterClose:{parameters:{origin:{type:"sap.m.Button"}}},cancelButtonPress:{}},designtime:"sap/m/designtime/ActionSheet.designtime"}});
f.prototype.init=function(){this._fnOrientationChange=this._orientationChange.bind(this);this._actionSelected=null;};
f.prototype.exit=function(){b.resize.detachHandler(this._fnOrientationChange);if(this._parent){this._parent.destroy();this._parent=null;}if(this._oCancelButton){this._oCancelButton.destroy();this._oCancelButton=null;}this._clearItemNavigation();};
f.prototype._clearItemNavigation=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
f.prototype._setItemNavigation=function(){var g=this._getAllButtons(),h=[],o=this.getDomRef();if(o){this._oItemNavigation.setRootDomRef(o);for(var i=0;i<g.length;i++){if(g[i].getEnabled()&&g[i].getVisible()){h.push(g[i].getFocusDomRef());}}if(this._oCancelButton){h.push(this._oCancelButton.getFocusDomRef());}this._oItemNavigation.setItemDomRefs(h);this._oItemNavigation.setSelectedIndex(0);this._oItemNavigation.setPageSize(5);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});}};
f.prototype.onmousedown=function(E){if(E.srcControl.isA("sap.m.Button")&&this.getButtons().indexOf(E.srcControl)!==-1){this._actionSelected=E.srcControl;}};
f.prototype.onBeforeRendering=function(){var t,p;this._clearItemNavigation();t=this.getTitle();if(this._parent&&!this.isPropertyInitial("title")&&this._parent.getTitle()!==t){if(b.system.phone){this._parent.setTitle(t);this._parent.setShowHeader(!!t);}if(t){this._parent.addStyleClass("sapMActionSheetDialogWithTitle");}else{this._parent.removeStyleClass("sapMActionSheetDialogWithTitle");}}p=this.getPlacement();if(this._parent&&!b.system.phone&&!this.isPropertyInitial("placement")&&this._parent.setPlacement()!==p){this._parent.setPlacement(p);}};
f.prototype.onAfterRendering=function(){this._oItemNavigation=new I();this._oItemNavigation.setCycling(false);this.addDelegate(this._oItemNavigation);this._setItemNavigation();};
f.prototype.sapfocusleave=function(){this.close();};
f.prototype.openBy=function(o){var t=this;if(!this._parent){var O=this.getParent();if(O){this.setParent(null);}if(!b.system.phone){this._parent=new P({placement:this.getPlacement(),showHeader:false,content:[this],beforeOpen:function(){t.fireBeforeOpen();},afterOpen:function(){t.focus();t.fireAfterOpen();},beforeClose:function(){t.fireBeforeClose();},afterClose:function(){if(t.getShowCancelButton()){t.fireCancelButtonTap();t.fireCancelButtonPress();}t._onAfterClose(t._actionSelected);t._actionSelected=null;},ariaLabelledBy:this.getPopupHiddenLabelId()||undefined}).addStyleClass("sapMActionSheetPopover");this._parent._setAriaRoleApplication(true);}else{this._parent=new D({title:this.getTitle(),type:d.Standard,content:[this],beforeOpen:function(){t.fireBeforeOpen();},afterOpen:function(){t.focus();t.fireAfterOpen();},beforeClose:function(E){t.fireBeforeClose({origin:E.getParameter("origin")});},afterClose:function(E){t._actionSelected=E.getParameter("origin");t._onAfterClose(t._actionSelected);t._actionSelected=null;b.resize.detachHandler(t._fnOrientationChange);}}).addStyleClass("sapMActionSheetDialog");if(this.getTitle()){this._parent.addStyleClass("sapMActionSheetDialogWithTitle");}else{this._parent.addAriaLabelledBy(this.getPopupHiddenLabelId()||undefined);}if(!b.system.phone){this._parent.setBeginButton(this._getCancelButton());}if(b.system.phone){this._parent.oPopup.setModal(true);this._parent._setDimensions=function(){D.prototype._setDimensions.apply(this);this.$("cont").css("max-height","");};this._parent._adjustScrollingPane=function(){var h=this.$().height();this.$("cont").css("max-height",h);if(this._oScroller){this._oScroller.refresh();}};}}if(O){O.addDependent(this._parent);}}if(!b.system.phone){this._parent.openBy(o);}else{this._parent.open();b.resize.attachHandler(this._fnOrientationChange);}};
f.prototype.close=function(){if(this._parent){this._parent.close();}};
f.prototype.isOpen=function(){return!!this._parent&&this._parent.isOpen();};
f.prototype._createCancelButton=function(){if(!this._oCancelButton){var s=(this.getCancelButtonText())?this.getCancelButtonText():sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACTIONSHEET_CANCELBUTTON_TEXT"),t=this;this._oCancelButton=new B(this.getId()+'-cancelBtn',{text:s,type:c.Reject,press:function(){if(b.system.phone&&t._parent){t._parent._oCloseTrigger=this;}t.close();t.fireCancelButtonTap();t.fireCancelButtonPress();}}).addStyleClass("sapMActionSheetButton sapMActionSheetCancelButton sapMBtnTransparent sapMBtnInverted");if(b.system.phone){this.setAggregation("_cancelButton",this._oCancelButton,true);}}return this;};
f.prototype._getCancelButton=function(){if(b.system.phone&&this.getShowCancelButton()){this._createCancelButton();return this._oCancelButton;}return null;};
f.prototype.setCancelButtonText=function(t){this.setProperty("cancelButtonText",t,true);if(this._oCancelButton){this._oCancelButton.setText(t);}return this;};
f.prototype._preProcessActionButton=function(o){var t=o.getType();if(t!==c.Accept&&t!==c.Reject){o.setType(c.Transparent);}o.addStyleClass("sapMBtnInverted");if(!o.getIcon()){o.addStyleClass("sapMActionSheetButtonNoIcon");}o.addStyleClass("sapMActionSheetButton");this._parent&&this._parent.invalidate();return this;};
f.prototype._buttonSelected=function(){if(b.system.phone&&this._parent){this._parent._oCloseTrigger=this;}this.close();};
f.prototype._orientationChange=function(){this._parent._adjustScrollingPane();};
f.prototype._addAriaHiddenTexts=function(o){var s=o.getId(),i;if(sap.ui.getCore().getConfiguration().getAccessibility()){i=new a(s+"-actionSheetHiddenText");this.addAggregation("_invisibleAriaTexts",i,false);o.addAriaDescribedBy(i.getId());}};
f.prototype._removeAriaHiddenTexts=function(o){o.getAriaDescribedBy().forEach(function(i){var g=sap.ui.getCore().byId(i);if(g instanceof a&&i.indexOf("actionSheetHiddenText")>-1){this.removeAggregation("_invisibleAriaTexts",g,false);o.removeAriaDescribedBy(g);g.destroy();}},this);};
f.prototype.addButton=function(o){this.addAggregation("buttons",o,false);this._addAriaHiddenTexts(o);this._preProcessActionButton(o);o.attachPress(this._buttonSelected,this);return this;};
f.prototype.insertButton=function(o,i){this.insertAggregation("buttons",o,i,false);this._addAriaHiddenTexts(o);this._preProcessActionButton(o);o.attachPress(this._buttonSelected,this);return this;};
f.prototype.removeButton=function(o){var r=this.removeAggregation("buttons",o,false);if(r){r.detachPress(this._buttonSelected,this);this._removeAriaHiddenTexts(r);}return r;};
f.prototype.removeAllButtons=function(){var r=this.removeAllAggregation("buttons",false),t=this;q.each(r,function(i,o){o.detachPress(t._buttonSelected,t);t._removeAriaHiddenTexts(o);});return r;};
f.prototype.clone=function(){var g=this.getButtons();for(var i=0;i<g.length;i++){g[i].detachPress(this._buttonSelected,this);}var o=C.prototype.clone.apply(this,arguments);for(var j=0;j<g.length;j++){g[j].attachPress(this._buttonSelected,this);}return o;};
f.prototype._getAllButtons=function(){return this.getButtons();};
f.prototype.getPopupHiddenLabelId=function(){return a.getStaticId("sap.m","ACTIONSHEET_AVAILABLE_ACTIONS");};
f.prototype._applyContextualSettings=function(){C.prototype._applyContextualSettings.call(this);};
f.prototype._onAfterClose=function(o){this.fireAfterClose({origin:o});};
return f;});
sap.ui.predefine('sap/m/ActionSheetRenderer',["sap/ui/Device"],function(D){"use strict";var A={apiVersion:2};
A.render=function(r,c){var a=c._getAllButtons(),I=c.getAggregation("_invisibleAriaTexts"),R=sap.ui.getCore().getLibraryResourceBundle('sap.m'),b=a.length,d=sap.ui.getCore().getConfiguration().getAccessibility(),v=a.filter(function(B){return B.getVisible();}).length,C,i,m,B,V=1,g=function(o){return I.filter(function(e){return e.getId().indexOf(o.getId())>-1;})[0];};for(i=0;i<b;i++){B=a[i];if(B.getIcon()&&B.getVisible()){m=true;}}r.openStart("div",c);r.class("sapMActionSheet");if(m){r.class("sapMActionSheetMixedButtons");}var t=c.getTooltip_AsString();if(t){r.attr("title",t);}d&&r.attr("role","presentation");r.openEnd();for(i=0;i<b;i++){B=a[i];r.renderControl(a[i]);if(d&&B.getVisible()){C=g(B);if(C){C.setText(R.getText('ACTIONSHEET_BUTTON_INDEX',[V,v]));r.renderControl(C);}V++;}}if(D.system.phone&&c.getShowCancelButton()){r.renderControl(c._getCancelButton());}r.close("div");};
return A;},true);
sap.ui.predefine('sap/m/App',['./NavContainer','./library','./AppRenderer','sap/ui/base/DataType',"sap/ui/util/Mobile","sap/base/Log","sap/ui/thirdparty/jquery"],function(N,l,A,D,M,L,q){"use strict";
var a=N.extend("sap.m.App",{metadata:{library:"sap.m",properties:{homeIcon:{type:"any",group:"Misc",defaultValue:null},backgroundColor:{type:"string",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1},mobileWebAppCapable:{type:"boolean",group:"Appearance",defaultValue:true},isTopLevel:{type:"boolean",group:"Behavior",defaultValue:true}},events:{orientationChange:{deprecated:true,parameters:{landscape:{type:"boolean"}}}}}});
a.prototype.init=function(){N.prototype.init.apply(this,arguments);this.addStyleClass("sapMApp");M.init({viewport:!this._debugZoomAndScroll,statusBar:"default",hideBrowser:true,preventScroll:!this._debugZoomAndScroll,rootId:this.getId()});q(window).on("resize",q.proxy(this._handleOrientationChange,this));};
a.prototype.onBeforeRendering=function(){if(N.prototype.onBeforeRendering){N.prototype.onBeforeRendering.apply(this,arguments);}M.init({homeIcon:this.getHomeIcon(),mobileWebAppCapable:this.getMobileWebAppCapable()});};
a.prototype.onAfterRendering=function(){if(N.prototype.onAfterRendering){N.prototype.onAfterRendering.apply(this,arguments);}if(this.getIsTopLevel()){this._adjustParentsHeight();}};
a.prototype._adjustParentsHeight=function(){if(!this.getDomRef()){return;}var r=this.getDomRef().parentNode;while(r&&r!==document.documentElement){var $=q(r);if($.attr("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}};
a.prototype.exit=function(){q(window).off("resize",this._handleOrientationChange);if(this._sInitTimer){clearTimeout(this._sInitTimer);}};
a.prototype._handleOrientationChange=function(){var $=q(window);var i=$.width()>$.height();if(this._oldIsLandscape!==i){this.fireOrientationChange({landscape:i});this._oldIsLandscape=i;}};
a.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){L.warning("Invalid value "+o+" for App.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}this.$("BG").css("opacity",o);return this.setProperty("backgroundOpacity",o,true);};
return a;});
sap.ui.predefine('sap/m/AppRenderer',['./NavContainerRenderer','sap/ui/core/Renderer','sap/m/library'],function(N,R,l){"use strict";var B=l.BackgroundHelper;var A=R.extend(N);A.apiVersion=2;
A.renderAttributes=function(r,c){B.addBackgroundColorStyles(r,c.getBackgroundColor(),c.getBackgroundImage());};
A.renderBeforeContent=function(r,c){B.renderBackgroundImageTag(r,c,"sapMAppBG",c.getBackgroundImage(),c.getBackgroundRepeat(),c.getBackgroundOpacity());};
return A;},true);
sap.ui.predefine('sap/m/AssociativeOverflowToolbar',['sap/base/Log','./OverflowToolbar','./OverflowToolbarRenderer','sap/ui/Device'],function(L,O,a,D){"use strict";
var A=O.extend("sap.m.AssociativeOverflowToolbar",{
metadata:{associations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}}},
renderer:a
});
A.prototype.getContent=function(){var b=this.getAssociation("content")||[];var c=[];b.forEach(function(d){var C=sap.ui.getCore().byId(d);if(C){c.push(C);}});return c;};
A.prototype.insertContent=function(c,I){var s=c.getId(),b=this.getAssociation("content").filter(function(d){return d!==s;});var i;if(I<0){i=0;}else if(I>b.length){i=b.length;}else{i=I;}if(i!==I){L.warning("AssociativeOverflowToolbar.insertContent: index '"+I+"' out of range [0,"+b.length+"], forced to "+i);}b.splice(i,0,s);this.removeAllAssociation("content");b.forEach(function(d){this.addAssociation("content",d);},this);return this;};
A.prototype.exit=function(){O.prototype.exit.apply(this,arguments);return this._callToolbarMethod('destroyContent',[true]);};
A.prototype.indexOfContent=function(c){var b=this.getAssociation("content")||[];return b.indexOf(c.getId());};
A.prototype._handleResize=function(){if(D.system.phone){this._resetAndInvalidateToolbar();}else{this._bControlsInfoCached=false;O.prototype._handleResize.apply(this,arguments);}};
A.prototype._callToolbarMethod=function(f,b){switch(f){case'addContent':return this.addAssociation("content",b[0]);case'getContent':return this.getContent();case'insertContent':return this.insertContent(b[0],b[1]);case'removeContent':return sap.ui.getCore().byId(this.removeAssociation("content",b[0],b[1],b[2]))||null;case'destroyContent':this.removeAllAssociation("content",b[0]);return this;case'removeAllContent':return this.removeAllAssociation("content",b[0]).map(function(c){return sap.ui.getCore().byId(c);});default:return O.prototype._callToolbarMethod.call(this,f,b);}};
return A;});
sap.ui.predefine('sap/m/Avatar',["sap/ui/core/Control","sap/ui/core/IconPool","./AvatarRenderer","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/core/Icon","./library"],function(C,I,A,K,L,a,l){"use strict";var b=l.AvatarType;var c=l.AvatarImageFitType;var d=l.AvatarColor;var e=l.AvatarSize;var f=l.AvatarShape;var g=Object.keys(d).filter(function(s){return s.indexOf("Accent")!==-1;});
var h=C.extend("sap.m.Avatar",{metadata:{library:"sap.m",properties:{src:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},initials:{type:"string",group:"Data",defaultValue:null},displayShape:{type:"sap.m.AvatarShape",group:"Appearance",defaultValue:f.Circle},displaySize:{type:"sap.m.AvatarSize",group:"Appearance",defaultValue:e.S},customDisplaySize:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"3rem"},customFontSize:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"1.125rem"},imageFitType:{type:"sap.m.AvatarImageFitType",group:"Appearance",defaultValue:c.Cover},fallbackIcon:{type:"string",group:"Data",defaultValue:null},backgroundColor:{type:"sap.m.AvatarColor",group:"Appearance",defaultValue:d.Accent6},showBorder:{type:"boolean",group:"Appearance",defaultValue:false},badgeIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},badgeTooltip:{type:"string",group:"Data",defaultValue:null},decorative:{type:"boolean",group:"Accessibility",defaultValue:false}},aggregations:{detailBox:{type:'sap.m.LightBox',multiple:false,bindable:"bindable"},_badge:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_icon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{}},dnd:{draggable:true,droppable:false},designtime:"sap/m/designtime/Avatar.designtime"}});
h.DEFAULT_CIRCLE_PLACEHOLDER="sap-icon://person-placeholder";h.DEFAULT_SQUARE_PLACEHOLDER="sap-icon://product";h.AVATAR_BADGE_TOOLTIP={"sap-icon://zoom-in":sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("AVATAR_TOOLTIP_ZOOMIN"),"sap-icon://camera":sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("AVATAR_TOOLTIP_CAMERA"),"sap-icon://edit":sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("AVATAR_TOOLTIP_EDIT")};
h.prototype.init=function(){this._sActualType=null;this._bIsDefaultIcon=true;this._sImageFallbackType=null;this._sPickedRandomColor=null;this._badgeRef=null;};
h.prototype.exit=function(){if(this._fnLightBoxOpen){this._fnLightBoxOpen=null;}if(this._badgeRef){this._badgeRef.destroy();}this._sPickedRandomColor=null;};
h.prototype.setDetailBox=function(o){var i=this.getDetailBox();if(o){if(o===i){return this;}if(i){this.detachPress(this._fnLightBoxOpen,i);}this._fnLightBoxOpen=o.open;this.attachPress(this._fnLightBoxOpen,o);}else if(this._fnLightBoxOpen){this.detachPress(this._fnLightBoxOpen,i);this._fnLightBoxOpen=null;}return this.setAggregation("detailBox",o);};
h.prototype.clone=function(){var o=C.prototype.clone.apply(this,arguments),i=o.getDetailBox();if(i){o.detachPress(this._fnLightBoxOpen,this.getDetailBox());o._fnLightBoxOpen=i.open;o.attachPress(o._fnLightBoxOpen,i);}return o;};
h.prototype.attachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);C.prototype.attachEvent.apply(this,arguments);if(this.hasListeners("press")){this.$().attr("tabindex","0");this.$().attr("role","button");}return this;};
h.prototype.detachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);C.prototype.detachEvent.apply(this,arguments);if(!this.hasListeners("press")){this.$().removeAttr("tabindex");this.$().attr("role","img");}return this;};
h.prototype.ontap=function(){this.firePress({});};
h.prototype.onkeydown=function(E){if(E.which===K.SHIFT||E.which===K.ESCAPE){this._bShouldInterupt=this._bSpacePressed;}if(E.which===K.SPACE){this._bSpacePressed=true;E.preventDefault();}if(E.which===K.ENTER){this.firePress({});}};
h.prototype.onkeyup=function(E){if(E.which===K.SPACE){if(!this._bShouldInterupt){this.firePress({});}this._bShouldInterupt=false;this._bSpacePressed=false;E.stopPropagation();}};
h.prototype._areInitialsValid=function(i){var v=/^[a-zA-Z]{1,2}$/;if(!v.test(i)){L.warning("Initials should consist of only 1 or 2 latin letters",this);this._sActualType=b.Icon;this._bIsDefaultIcon=true;return false;}return true;};
h.prototype._validateSrc=function(s){if(I.isIconURI(s)){this._sActualType=b.Icon;this._bIsDefaultIcon=I.getIconInfo(s)?false:true;}else{this._bIsDefaultIcon=true;this._sActualType=b.Image;this.preloadedImage=new window.Image();this.preloadedImage.src=s;this.preloadedImage.onload=this._onImageLoad.bind(this);this.preloadedImage.onerror=this._onImageError.bind(this);}return this;};
h.prototype._getDisplayIcon=function(s){return I.isIconURI(s)&&I.getIconInfo(s)?I.createControlByURI({src:s}):null;};
h.prototype._getActualDisplayType=function(){var s=this.getSrc(),i=this.getInitials();if(s){this._validateSrc(s);}else if(i&&this._areInitialsValid(i)){this._sActualType=b.Initials;}else{L.warning("No src and initials were provided",this);this._sActualType=b.Icon;this._bIsDefaultIcon=true;}return this._sActualType;};
h.prototype._getImageFallbackType=function(){var i=this.getInitials();this._sImageFallbackType=i&&this._areInitialsValid(i)?b.Initials:b.Icon;return this._sImageFallbackType;};
h.prototype._getDefaultIconPath=function(D){var s=null,F=this.getFallbackIcon();if(F&&I.isIconURI(F)){s=F;}else if(D===f.Circle){s=h.DEFAULT_CIRCLE_PLACEHOLDER;}else if(D===f.Square){s=h.DEFAULT_SQUARE_PLACEHOLDER;}return s;};
h.prototype._getIcon=function(){var s=this.getSrc(),i=this.getAggregation("_icon"),D=this.getDisplayShape();if(this._bIsDefaultIcon){s=this._getDefaultIconPath(D);}if(!i){i=I.createControlByURI({alt:"Image placeholder",src:s});this.setAggregation("_icon",i);}else if(i.getSrc()!==s){i.setSrc(s);}return i;};
h.prototype._getDefaultTooltip=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("AVATAR_TOOLTIP");};
h.prototype._getBadgeIconSource=function(){var B;if(this.getDetailBox()){B="sap-icon://zoom-in";}else if(this.getBadgeIcon()!==""){if(this._getDisplayIcon(this.getBadgeIcon())){B=this.getBadgeIcon();}else{L.warning("No valid Icon URI source for badge affordance was provided");}}return B;};
h.prototype._getBadgeTooltip=function(){var B=this._getDefaultTooltip(),s=this.getBadgeIcon();if(this.getBadgeTooltip()){B=this.getBadgeTooltip();}else if(s&&h.AVATAR_BADGE_TOOLTIP[this.getBadgeIcon()]){B=h.AVATAR_BADGE_TOOLTIP[s];}return B;};
h.prototype._getBadge=function(){var B=this._getBadgeIconSource(),s=this._getBadgeTooltip();if(!B){return;}if(!this._badgeRef){this.setAggregation("_badge",new a({src:B,tooltip:s}));}this._badgeRef=this.getAggregation("_badge");return this._badgeRef;};
h.prototype._onImageLoad=function(){delete this.preloadedImage;};
h.prototype._onImageError=function(){var F=this._getImageFallbackType();this.$().removeClass("sapFAvatarImage").addClass("sapFAvatar"+F);delete this.preloadedImage;};
h.prototype._getActualBackgroundColor=function(){var B=this.getBackgroundColor();if(B===d.Random){if(this._sPickedRandomColor){return this._sPickedRandomColor;}B=this._sPickedRandomColor=d[g[g.length*Math.random()<<0]];}else{this._sPickedRandomColor=null;}return B;};
return h;});
sap.ui.predefine('sap/m/AvatarColor',[],function(){"use strict";var A={Accent1:"Accent1",Accent2:"Accent2",Accent3:"Accent3",Accent4:"Accent4",Accent5:"Accent5",Accent6:"Accent6",Accent7:"Accent7",Accent8:"Accent8",Accent9:"Accent9",Accent10:"Accent10",Random:"Random",Transparent:"Transparent",TileIcon:"TileIcon",Placeholder:"Placeholder"};return A;});
sap.ui.predefine('sap/m/AvatarImageFitType',[],function(){"use strict";var A={Cover:"Cover",Contain:"Contain"};return A;});
sap.ui.predefine('sap/m/AvatarRenderer',["sap/m/library","sap/base/security/encodeCSS"],function(l,e){"use strict";var A=l.AvatarSize;var a=l.AvatarType;var b={apiVersion:2};
b.render=function(r,o){var i=o.getInitials(),s=o._getActualDisplayType(),I=o._getImageFallbackType(),d=o.getDisplaySize(),D=o.getDisplayShape(),c=o.getImageFitType(),C=o.getCustomDisplaySize(),f=o.getCustomFontSize(),S=o.getSrc(),g="sapFAvatar",t=o.getTooltip_AsString(),L=o.getAriaLabelledBy(),h=o.getAriaDescribedBy(),B=o.hasListeners("press")?o._getBadge():null,j=o._getDefaultTooltip();r.openStart("span",o);r.class(g);r.class("sapFAvatarColor"+o._getActualBackgroundColor());r.class(g+d);r.class(g+s);r.class(g+D);if(o.hasListeners("press")){r.class("sapMPointer");r.class(g+"Focusable");r.attr("role","button");r.attr("tabindex",0);}else if(o.getDecorative()){r.attr("role","presentation");r.attr("aria-hidden","true");}else{r.attr("role","img");}if(o.getShowBorder()){r.class("sapFAvatarBorder");}if(d===A.Custom){r.style("width",C);r.style("height",C);r.style("font-size",f);}if(t){r.attr("title",t);r.attr("aria-label",t);}else if(i){r.attr("aria-label",j+" "+i);}else{r.attr("aria-label",j);}if(L&&L.length>0){r.attr("aria-labelledby",L.join(" "));}if(h&&h.length>0){r.attr("aria-describedby",h.join(" "));}r.openEnd();if(s===a.Icon||I===a.Icon){r.renderControl(o._getIcon().addStyleClass(g+"TypeIcon"));}else if(s===a.Initials||I===a.Initials){r.openStart("span");r.class(g+"InitialsHolder");r.openEnd();r.text(i);r.close("span");}if(s===a.Image){r.openStart("span");r.class(g+"ImageHolder");r.class(g+s+c);r.style("background-image","url('"+e(S)+"')");r.openEnd();r.close("span");}if(B){r.openStart("div");r.class(g+"BadgeIconActiveArea");if(C){r.style("font-size",C);}r.openEnd();r.openStart("span");r.class(g+"BadgeIcon");r.openEnd();r.renderControl(B);r.close("span");r.close("div");}r.close("span");};
return b;},true);
sap.ui.predefine('sap/m/AvatarShape',[],function(){"use strict";var A={Circle:"Circle",Square:"Square"};return A;});
sap.ui.predefine('sap/m/AvatarSize',[],function(){"use strict";var A={XS:"XS",S:"S",M:"M",L:"L",XL:"XL",Custom:"Custom"};return A;});
sap.ui.predefine('sap/m/AvatarType',[],function(){"use strict";var A={Icon:"Icon",Image:"Image",Initials:"Initials"};return A;});
sap.ui.predefine('sap/m/BadgeCustomData',['sap/ui/core/CustomData','sap/base/Log','sap/m/library'],function(C,L,l){"use strict";var B=l.BadgeAnimationType;
var a=C.extend("sap.m.BadgeCustomData",{metadata:{properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true},animation:{type:"sap.m.BadgeAnimationType",group:"Appearance",defaultValue:B.Full}}}});
a.prototype.init=function(){var p=this.getParent();if(p&&!p.isA("sap.m.IBadge")){L.warning("BadgeCustomData must be attached only to controls, which implement sap.m.IBadge");}};
a.prototype.setValue=function(v){if(this.getValue()===v){return this;}if(v===null||v===undefined){v="";}var p=this.getParent();v=v.toString();C.prototype.setValue.call(this,v);if(p){p.updateBadgeValue(v);}return this;};
a.prototype.setVisible=function(v){if(this.getVisible()===v){return this;}this.setProperty("visible",v,true);var p=this.getParent();if(p){p.updateBadgeVisibility(v);}return this;};
a.prototype.setAnimation=function(A){if(this.getAnimation()===A){return this;}this.setProperty("animation",A,true);var p=this.getParent();if(p){p.updateBadgeAnimation(A);}return this;};
a.prototype.setKey=function(){return this;};
return a;});
sap.ui.predefine('sap/m/BadgeEnabler',['sap/m/BadgeCustomData','sap/base/Log','sap/m/library'],function(B,L,l){"use strict";var I="sapMBadge";var a={topLeft:"sapMBadgeTopLeft",topRight:"sapMBadgeTopRight",inline:"sapMBadgeInline"};var b=l.BadgeState;var c=l.BadgeStyle;var d=["","undefined","null",false];var e=function(){this.initBadgeEnablement=function(C,o){var D=o?o:this;this._oBadgeConfig=C||{};D.addEventDelegate({onAfterRendering:f},this);};function _(C,o){if(C.suffix){return o.$(C.suffix);}if(C.selector){return o.$().find(C.selector).first();}}function f(){this._isBadgeAttached=false;if(!this.getBadgeCustomData()||!this.getBadgeCustomData().getVisible()){return false;}j.call(this);if(!Object.keys(this._oBadgeConfig).length){return this;}return this;}function g(){var o=h.call(this);o.removeClass("sapMBadgeAnimationUpdate");o.removeClass("sapMBadgeAnimationAdd");o.width();o.addClass("sapMBadgeAnimationRemove");o.on("animationend",function(){o.css("display","none");o.off();});o.removeAttr("aria-label");this._isBadgeAttached=false;m.call(this,"",b["Disappear"]);return this;}function h(){return this.$(I);}function i(){return this.getId()+"-"+I;}function j(){var o,s=i.call(this),p=h.call(this),q=typeof this.badgeValueFormatter==="function"&&this.badgeValueFormatter,v=n(q?q.call(this,this.getBadgeCustomData().getValue()):this.getBadgeCustomData().getValue())||"",S=this._oBadgeConfig.style?this._oBadgeConfig.style:c.Default,A=this.getBadgeCustomData().getAnimation();this._oBadgeContainer=this._oBadgeConfig&&this._oBadgeConfig.selector?_(this._oBadgeConfig.selector,this):this.$();if(p.length){p.remove();}o=jQuery('<div></div>').addClass(I+"Indicator");o.addClass(I+S);o.attr("id",s);o.attr("data-badge",v);o.attr("aria-label",k.call(this));o.appendTo(this._oBadgeContainer);o.addClass("sapMBadgeAnimationAdd");this._isBadgeAttached=true;this._oBadgeContainer.addClass(I);if(this._oBadgeConfig.position){this._oBadgeContainer.addClass(a[this._oBadgeConfig.position]);}if(this._oBadgeConfig.accentColor){this._oBadgeContainer.addClass(I+this._oBadgeConfig.accentColor);}this._oBadgeContainer.addClass(this.getBadgeAnimationClass(this.getBadgeCustomData().getAnimation()));this._badgeAnimaionType=A;m.call(this,v,b["Appear"]);}this.updateBadgeValue=function(v){var o=typeof this.badgeValueFormatter==="function"&&this.badgeValueFormatter,p;v=n((o?o.call(this,v):v))||"";if(!this.getBadgeCustomData().getVisible()){return false;}p=h.call(this);p.removeClass("sapMBadgeAnimationUpdate");p.attr("data-badge",v);p.attr("aria-label",k.call(this));p.width();p.addClass("sapMBadgeAnimationUpdate");m.call(this,v,b["Updated"]);};function k(){var A=this.getAriaLabelBadgeText;return A&&typeof A==="function"&&A.call(this);}function m(v,s){if(this.onBadgeUpdate&&typeof this.onBadgeUpdate==="function"){var o=i.call(this);return this.onBadgeUpdate(v,s,o);}}function n(v){return d.indexOf(v)===-1&&v;}this.addCustomData=function(C){if(C.isA("sap.m.BadgeCustomData")){this.removeAggregation("customData",this._oBadgeCustomData,true);this._oBadgeCustomData=C;this.addAggregation("customData",C,true);return this.updateBadgeVisibility(C.getVisible());}return this.addAggregation("customData",C);};this.insertCustomData=function(C){if(C.isA("sap.m.BadgeCustomData")){this.removeAggregation("customData",this._oBadgeCustomData,true);this._oBadgeCustomData=C;this.addAggregation("customData",C,true);return this.updateBadgeVisibility(C.getVisible());}return this.insertAggregation("customData",C);};this.getBadgeCustomData=function(){var o=this.getCustomData().filter(function(p){return p instanceof B;});return o.length?o[0]:undefined;};this.getBadgeAnimationClass=function(A){return I+"AnimationType"+A;};this.removeBadgeCustomData=function(){var o;o=this._oBadgeCustomData;this._oBadgeCustomData=null;return this.removeAggregation("customData",o,true);};this.setBadgeAccentColor=function(v){if(!this._oBadgeContainer){return false;}this._oBadgeContainer.removeClass(I+this._oBadgeConfig.accentColor);this._oBadgeContainer.addClass(I+v);this._oBadgeConfig.accentColor=v;};this.setBadgePosition=function(v){if(!this._oBadgeContainer){return false;}this._oBadgeContainer.removeClass(I+this._oBadgeConfig.position);this._oBadgeContainer.addClass(a[v]);this._oBadgeConfig.position=v;};this.updateBadgeVisibility=function(v){return v?j.call(this):g.call(this);};this._renderBadge=function(){f.call(this);};this.updateBadgeAnimation=function(A){if(this._oBadgeContainer){this._badgeAnimaionType&&this._oBadgeContainer.removeClass(this.getBadgeAnimationClass(this._badgeAnimaionType));this._oBadgeContainer.addClass(this.getBadgeAnimationClass(A));}this._badgeAnimaionType=A;};};return e;});
sap.ui.predefine('sap/m/Bar',['./BarInPageEnabler','./library','sap/ui/core/Control','sap/ui/core/ResizeHandler','sap/ui/Device','./BarRenderer',"sap/ui/thirdparty/jquery"],function(B,l,C,R,D,a,q){"use strict";var b=l.BarDesign;var T=l.TitleAlignment;
var c=C.extend("sap.m.Bar",{metadata:{interfaces:["sap.m.IBar"],library:"sap.m",properties:{enableFlexBox:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},translucent:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},design:{type:"sap.m.BarDesign",group:"Appearance",defaultValue:b.Auto},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:T.None}},aggregations:{contentLeft:{type:"sap.ui.core.Control",multiple:true,singularName:"contentLeft"},contentMiddle:{type:"sap.ui.core.Control",multiple:true,singularName:"contentMiddle"},contentRight:{type:"sap.ui.core.Control",multiple:true,singularName:"contentRight"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},designtime:"sap/m/designtime/Bar.designtime",dnd:{draggable:false,droppable:true}}});
c.prototype.onBeforeRendering=function(){var s=this.getTitleAlignment(),A;this._removeAllListeners();for(A in T){if(A!==s){this.removeStyleClass("sapMBarTitleAlign"+A);}else{this.addStyleClass("sapMBarTitleAlign"+A);}}};
c.prototype.onAfterRendering=function(){this._handleResize();};
c.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);this._sPrevTitleAlignmentClass="";};
c.prototype.exit=function(){this._removeAllListeners();if(this._oflexBox){this._oflexBox.destroy();this._oflexBox=null;}this._$MidBarPlaceHolder=null;this._$RightBar=null;this._$LeftBar=null;};
c._aResizeHandlers=["_sResizeListenerId","_sResizeListenerIdMid","_sResizeListenerIdRight","_sResizeListenerIdLeft"];
c.prototype._removeAllListeners=function(){var t=this;c._aResizeHandlers.forEach(function(i){t._removeListenerFailsave(i);});};
c.prototype._removeListenerFailsave=function(L){if(this[L]){R.deregister(this[L]);this[L]=null;}};
c.prototype._handleResize=function(){this._removeAllListeners();var e=!!this.getContentLeft().length,f=!!this.getContentMiddle().length||(this._oflexBox&&!!this._oflexBox.getItems().length),g=!!this.getContentRight().length;if(!this.getVisible()){return;}if(!e&&!f&&!g){return;}this._$LeftBar=this.$("BarLeft");this._$RightBar=this.$("BarRight");this._$MidBarPlaceHolder=this.$("BarPH");this._updatePosition(e,f,g);this._sResizeListenerId=R.register(this.getDomRef(),q.proxy(this._handleResize,this));if(this.getEnableFlexBox()){return;}if(e){this._sResizeListenerIdLeft=R.register(this._$LeftBar[0],q.proxy(this._handleResize,this));}if(f){this._sResizeListenerIdMid=R.register(this._$MidBarPlaceHolder[0],q.proxy(this._handleResize,this));}if(g){this._sResizeListenerIdRight=R.register(this._$RightBar[0],q.proxy(this._handleResize,this));}};
c.prototype._updatePosition=function(e,f,g){if(!e&&!g&&f){return;}if(e&&!f&&!g){return;}if(!e&&!f&&g){return;}var i=this.$().outerWidth(true);this._$RightBar.css({width:""});this._$LeftBar.css({width:""});this._$MidBarPlaceHolder.css({position:"",width:"",visibility:"hidden"});var r=this._$RightBar.outerWidth(true);if(r>i){if(e){this._$LeftBar.css({width:"0px"});}if(f){this._$MidBarPlaceHolder.css({width:"0px"});}this._$RightBar.css({width:i+"px"});return;}var L=this._getBarContainerWidth(this._$LeftBar);if(i<(L+r)){L=i-r;this._$LeftBar.css({width:L+"px"});this._$MidBarPlaceHolder.css({width:"0px"});return;}this._$MidBarPlaceHolder.css(this._getMidBarCss(r,i,L));};
c.prototype._getMidBarCss=function(r,i,L){var m=this._$MidBarPlaceHolder.outerWidth(true),e=sap.ui.getCore().getConfiguration().getRTL(),s=e?"right":"left",f=e?"left":"right",M={visibility:""},g=this.getContentLeft().filter(function(v){return v.getVisible();}),h=this.getContentRight().filter(function(v){return v.getVisible();}),j=g.length?0:parseInt(this._$LeftBar.css('padding-'+s)),k=h.length?0:parseInt(this._$RightBar.css('padding-'+f));if(this.getEnableFlexBox()){m=i-L-r-parseInt(this._$MidBarPlaceHolder.css('margin-left'))-parseInt(this._$MidBarPlaceHolder.css('margin-right'));M.position="absolute";M.width=m+j+k+"px";M[s]=L-j;return M;}var S=i-L-r,n=(i/2)-(m/2),o=L>n,p=(i/2)+(m/2),t=(i-r)<p,u=this.getTitleAlignment();if((u!==T.None&&u!==T.Center)||(S>0&&(o||t))){M.position="absolute";M.width=S+j+k+"px";M[s]=L-j;}return M;};
c.prototype._getBarContainerWidth=function($){var i,e=0,f=$.children(),g=0;if(D.browser.webkit||D.browser.firefox){for(i=0;i<f.length;i++){g+=q(f[i]).outerWidth(true);}e=$.outerWidth(true);}else{var o;for(i=0;i<f.length;i++){o=window.getComputedStyle(f[i]);if(o.width=="auto"){g+=q(f[i]).width()+1;}else{g+=parseFloat(o.width);}g+=parseFloat(o.marginLeft);g+=parseFloat(o.marginRight);g+=parseFloat(o.paddingLeft);g+=parseFloat(o.paddingRight);}var h=window.getComputedStyle($[0]);e+=parseFloat(h.width);e+=parseFloat(h.marginLeft);e+=parseFloat(h.marginRight);e+=parseFloat(h.paddingLeft);e+=parseFloat(h.paddingRight);}if(e<g){e=g;}return e;};
var d=B.extend("sap.m.BarInAnyContentEnabler",{});
d.mContexts={dialogFooter:{contextClass:"sapMFooter-CTX",tag:"Footer"}};
d.prototype.getContext=function(){var p=B.prototype.getContext.call();for(var k in d.mContexts){p[k]=d.mContexts[k];}return p;};
c.prototype.getContext=d.prototype.getContext;c.prototype.isContextSensitive=d.prototype.isContextSensitive;c.prototype.setHTMLTag=d.prototype.setHTMLTag;c.prototype.getHTMLTag=d.prototype.getHTMLTag;c.prototype.applyTagAndContextClassFor=d.prototype.applyTagAndContextClassFor;c.prototype._applyContextClassFor=d.prototype._applyContextClassFor;c.prototype._applyTag=d.prototype._applyTag;c.prototype._getContextOptions=d.prototype._getContextOptions;c.prototype._setRootAccessibilityRole=d.prototype._setRootAccessibilityRole;c.prototype._getRootAccessibilityRole=d.prototype._getRootAccessibilityRole;c.prototype._setRootAriaLevel=d.prototype._setRootAriaLevel;c.prototype._getRootAriaLevel=d.prototype._getRootAriaLevel;return c;});
sap.ui.predefine('sap/m/BarInPageEnabler',['sap/ui/base/Object','sap/m/library',"sap/base/Log"],function(O,l,L){"use strict";var I=l.IBarHTMLTag;var c={footer:{contextClass:"sapMFooter-CTX sapContrast sapContrastPlus",tag:"Footer",internalAriaLabel:"BAR_ARIA_DESCRIPTION_FOOTER"},header:{contextClass:"sapMHeader-CTX",tag:"Header",internalAriaLabel:"BAR_ARIA_DESCRIPTION_HEADER"},subheader:{contextClass:"sapMSubHeader-CTX",tag:"Header",internalAriaLabel:"BAR_ARIA_DESCRIPTION_SUBHEADER"}};var a="sapMIBar";
var B=O.extend("sap.m.BarInPageEnabler",{
isContextSensitive:function(){return this.getDesign&&this.getDesign()==="Auto";},
setHTMLTag:function(n){if(n===this.sTag){return this;}this.sTag=n;return this;},
getHTMLTag:function(){if(!this.hasOwnProperty("sTag")){this.sTag=I.Div;}return this.sTag;},
getContext:function(){return c;},
_getRootAccessibilityRole:function(){var r=this._sRootAccessibilityRole||"toolbar";return r;},
_setRootAccessibilityRole:function(r){this._sRootAccessibilityRole=r;return this;},
_getRootAriaLevel:function(){var A=this.sAriaLevel;return A;},
_setRootAriaLevel:function(s){this.sAriaLevel=s;return this;},
applyTagAndContextClassFor:function(C){this._applyTag(C);return this._applyContextClassFor(C);},
_applyContextClassFor:function(C){var o=this._getContextOptions(C);if(!o){return this;}if(!this.isContextSensitive){L.error("The bar control you are using does not implement all the members of the IBar interface",this);return this;}if(!this.getRenderer().shouldAddIBarContext()){this.addStyleClass(a+"-CTX");}if(this.isContextSensitive()){this.addStyleClass(o.contextClass);}return this;},
_applyTag:function(C){var o=this._getContextOptions(C);if(!o){return this;}if(!this.setHTMLTag){L.error("The bar control you are using does not implement all the members of the IBar interface",this);return this;}this.setHTMLTag(o.tag);return this;},
_getContextOptions:function(C){var o;if(this.getContext){o=this.getContext();}else{o=c;}var b=o[C];if(!b){L.error("The context "+C+" is not known",this);return null;}return b;},
render:function(r,C){var t=C.getHTMLTag().toLowerCase();r.openStart(t,C);r.class(a);if(this.shouldAddIBarContext(C)){r.class(a+"-CTX");}B.renderTooltip(r,C);this.decorateRootElement(r,C);r.openEnd();this.renderBarContent(r,C);r.close(t);}
});
B.renderTooltip=function(r,C){var t=C.getTooltip_AsString();if(t){r.attr("title",t);}};
B.addChildClassTo=function(C){C.addStyleClass("sapMBarChild");};
return B;});
sap.ui.predefine('sap/m/BarRenderer',['./BarInPageEnabler','sap/ui/Device',"sap/base/Log",'sap/m/HBox'],function(B,D,L,H){"use strict";var a={apiVersion:2};a.render=B.prototype.render;
a.decorateRootElement=function(r,c){r.class("sapMBar");r.class(this.getContext(c));r.accessibilityState(c,{"role":c._getRootAccessibilityRole(),"level":c._getRootAriaLevel()});if(c.getTranslucent()&&D.support.touch){r.class("sapMBarTranslucent");}r.class("sapMBar-CTX");};
a.shouldAddIBarContext=function(){return true;};
a.renderBarContent=function(r,c){r.openStart("div",c.getId()+"-BarLeft");r.class("sapMBarLeft");r.class("sapMBarContainer");w("left",r,c);r.openEnd();this.renderAllControls(c.getContentLeft(),r,c);r.close("div");r.openStart("div",c.getId()+"-BarMiddle");r.class("sapMBarMiddle");r.openEnd();if(c.getEnableFlexBox()){c._oflexBox=c._oflexBox||new H(c.getId()+"-BarPH",{alignItems:"Center"}).addStyleClass("sapMBarPH").setParent(c,null,true);var C=!!c.getContentLeft().length,b=!!c.getContentMiddle().length,d=!!c.getContentRight().length;if(b&&!C&&!d){c._oflexBox.addStyleClass("sapMBarFlexBoxWidth100");}c.getContentMiddle().forEach(function(m){c._oflexBox.addItem(m);});r.renderControl(c._oflexBox);}else{r.openStart("div",c.getId()+"-BarPH");r.class("sapMBarPH");r.class("sapMBarContainer");w("middle",r,c);r.openEnd();this.renderAllControls(c.getContentMiddle(),r,c);r.close("div");}r.close("div");r.openStart("div",c.getId()+"-BarRight");r.class("sapMBarRight");r.class("sapMBarContainer");if(sap.ui.getCore().getConfiguration().getRTL()){r.class("sapMRTL");}w("right",r,c);r.openEnd();this.renderAllControls(c.getContentRight(),r,c);r.close("div");};
a.renderAllControls=function(c,r,b){c.forEach(function(C){B.addChildClassTo(C,b);r.renderControl(C);});};
a._mContexts={Header:"sapMHeader-CTX",SubHeader:"sapMSubHeader-CTX",Footer:"sapMFooter-CTX",Default:"sapMContent-CTX"};
a.getContext=function(c){var d=c.getDesign(),C=a._mContexts;return C[d]||C.Default;};
function w(A,r,c){var C=!!c.getContentLeft().length,b=!!c.getContentMiddle().length,d=!!c.getContentRight().length;switch(A.toLowerCase()){case"left":if(C&&!b&&!d){r.style("width","100%");}break;case"middle":if(b&&!C&&!d){r.style("width","100%");}break;case"right":if(d&&!C&&!b){r.style("width","100%");}break;default:L.error("Cannot determine which of the three content aggregations is alone");}}
return a;},true);
sap.ui.predefine('sap/m/Breadcrumbs',["sap/ui/core/Control","sap/ui/util/openWindow","sap/m/Text","sap/m/Link","sap/m/Select","sap/ui/core/Item","sap/ui/core/delegate/ItemNavigation","sap/ui/core/ResizeHandler","sap/ui/core/IconPool","sap/ui/Device","sap/m/library","./BreadcrumbsRenderer",'sap/ui/base/ManagedObject','sap/ui/core/InvisibleText'],function(C,o,T,L,S,I,a,R,b,D,l,B,M,c){"use strict";var d=l.SelectType,e=l.BreadcrumbsSeparatorStyle;
var f=C.extend("sap.m.Breadcrumbs",{metadata:{library:"sap.m",interfaces:["sap.m.IBreadcrumbs"],designtime:"sap/m/designtime/Breadcrumbs.designtime",properties:{currentLocationText:{type:"string",group:"Behavior",defaultValue:null},separatorStyle:{type:"sap.m.BreadcrumbsSeparatorStyle",group:"Appearance",defaultValue:e.Slash}},aggregations:{links:{type:"sap.m.Link",multiple:true,singularName:"link"},_currentLocation:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_select:{type:"sap.m.Select",multiple:false,visibility:"hidden"}},defaultAggregation:"links",associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}}});
f.STYLE_MAPPER={Slash:"/",BackSlash:"\\",DoubleSlash:"//",DoubleBackSlash:"\\\\",GreaterThan:">",DoubleGreaterThan:">>"};
f.prototype.init=function(){this._sSeparatorSymbol=f.STYLE_MAPPER[this.getSeparatorStyle()];this._getInvisibleText();};
f.prototype.onBeforeRendering=function(){this.bRenderingPhase=true;if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._bControlsInfoCached){this._updateSelect(true);}};
f.prototype.onAfterRendering=function(){if(!this._sResizeListenerId){this._sResizeListenerId=R.register(this,this._handleScreenResize.bind(this));}if(!this._bControlsInfoCached){this._updateSelect(true);return;}this._configureKeyboardHandling();this.bRenderingPhase=false;};
f.prototype.onThemeChanged=function(){this._resetControl();};
f.prototype.exit=function(){this._resetControl();this._destroyItemNavigation();if(this._oInvisibleText){this._oInvisibleText.destroy();this._oInvisibleText=null;}};
f.PAGEUP_AND_PAGEDOWN_JUMP_SIZE=5;
f.prototype._getAugmentedId=function(s){return this.getId()+"-"+s;};
f.prototype._getInvisibleText=function(){var A=B._getResourceBundleText("BREADCRUMB_LABEL");if(!this._oInvisibleText){this._oInvisibleText=new c({id:this.getId()+"-InvisibleText"});this._oInvisibleText.setText(A).toStatic();}return this._oInvisibleText;};
f.prototype._getSelect=function(){if(!this.getAggregation("_select")){this.setAggregation("_select",this._decorateSelect(new S({id:this._getAugmentedId("select"),change:this._selectChangeHandler.bind(this),forceSelection:false,autoAdjustWidth:true,icon:b.getIconURI("slim-arrow-down"),type:d.IconOnly,tooltip:B._getResourceBundleText("BREADCRUMB_SELECT_TOOLTIP")})),true);}return this.getAggregation("_select");};
f.prototype._getCurrentLocation=function(){if(!this.getAggregation("_currentLocation")){var i=new T({id:this._getAugmentedId("currentText"),text:this.getCurrentLocationText(),wrapping:false}).addStyleClass("sapMBreadcrumbsCurrentLocation");i.addEventDelegate({onAfterRendering:function(){i.$().attr("aria-current","page");i.$().attr("tabindex",0);}});this.setAggregation("_currentLocation",i).addStyleClass("sapMBreadcrumbsCurrentLocation");}return this.getAggregation("_currentLocation");};
function g(A,i){var j=Array.prototype.slice.apply(i);j.unshift(A);return j;}
f.prototype.insertLink=function(i,j){var r=this.insertAggregation.apply(this,g("links",arguments));this._registerControlListener(i);this._resetControl();return r;};
f.prototype.addLink=function(i){var r=this.addAggregation.apply(this,g("links",arguments));this._registerControlListener(i);this._resetControl();return r;};
f.prototype.removeLink=function(O){var r=this.removeAggregation.apply(this,g("links",arguments));this._deregisterControlListener(r);this._resetControl();return r;};
f.prototype.removeAllLinks=function(){var i=this.getAggregation("links",[]);var r=this.removeAllAggregation.apply(this,g("links",arguments));i.forEach(this._deregisterControlListener,this);this._resetControl();return r;};
f.prototype.destroyLinks=function(){var i=this.getAggregation("links",[]);var r=this.destroyAggregation.apply(this,g("links",arguments));i.forEach(this._deregisterControlListener,this);this._resetControl();return r;};
f.prototype._decorateSelect=function(s){s.getPicker().attachAfterOpen(this._removeItemNavigation,this).attachBeforeClose(this._restoreItemNavigation,this);s._onBeforeOpenDialog=this._onSelectBeforeOpenDialog.bind(this);s._onBeforeOpenPopover=this._onSelectBeforeOpenPopover.bind(this);s.onsapescape=this._onSelectEscPress.bind(this);return s;};
f.prototype._removeItemNavigation=function(){this.removeDelegate(this._getItemNavigation());};
f.prototype._onSelectBeforeOpenDialog=function(){var s=this._getSelect();if(this.getCurrentLocationText()&&D.system.phone){s.setSelectedIndex(0);}else{s.setSelectedItem(null);}S.prototype._onBeforeOpenDialog.call(s);this._removeItemNavigation();};
f.prototype._onSelectBeforeOpenPopover=function(){this._getSelect().setSelectedItem(null);this._removeItemNavigation();};
f.prototype._restoreItemNavigation=function(){this.addDelegate(this._getItemNavigation());};
f.prototype._onSelectEscPress=function(){this._getSelect().close();};
f.prototype._createSelectItem=function(i){return new I({key:i.getId(),text:M.escapeSettingsValue(i.getText())});};
f.prototype._selectChangeHandler=function(E){var i,s,j,k=E.getParameter("selectedItem");if(!k){return;}if(!this._getSelect().isOpen()){return;}i=sap.ui.getCore().byId(k.getKey());if(!(i instanceof L)){return;}s=i.getHref();j=i.getTarget();i.firePress();if(s){if(j){o(s,j);}else{window.location.href=s;}}};
f.prototype._getItemsForMobile=function(){var i=this.getLinks().filter(function(j){return j.getVisible();});if(this.getCurrentLocationText()){i.push(this._getCurrentLocation());}return i;};
f.prototype._updateSelect=function(i){var s=this._getSelect(),j,k=this._getControlDistribution();if(!this._bControlDistributionCached||i){s.destroyItems();j=D.system.phone?this._getItemsForMobile():k.aControlsForSelect;j.map(this._createSelectItem).reverse().forEach(s.insertItem,s);this._bControlDistributionCached=true;this.invalidate(this);}s.setVisible(!!k.aControlsForSelect.length);if(!this._sResizeListenerId&&!this.bRenderingPhase){this._sResizeListenerId=R.register(this,this._handleScreenResize.bind(this));}};
f.prototype._getControlsForBreadcrumbTrail=function(){var v;if(this._bControlDistributionCached&&this._oDistributedControls){return this._oDistributedControls.aControlsForBreadcrumbTrail;}v=this.getLinks().filter(function(i){return i.getVisible();});if(this.getCurrentLocationText()){return v.concat([this._getCurrentLocation()]);}return v;};
f.prototype._getControlInfo=function(i){return{id:i.getId(),control:i,width:h(i.$().parent()),bCanOverflow:i instanceof L};};
f.prototype._getControlDistribution=function(m){m=m||this._iContainerSize;this._iContainerSize=m;this._oDistributedControls=this._determineControlDistribution(m);return this._oDistributedControls;};
f.prototype._getSelectWidth=function(){return this._getSelect().getVisible()&&this._iSelectWidth||0;};
f.prototype._determineControlDistribution=function(m){var i,j,k=this._getControlsInfo().aControlInfo,s=this._getSelectWidth(),n=[],p=[],u=s;for(i=k.length-1;i>=0;i--){j=k[i];u+=j.width;if(k.length-1===i){p.push(j.control);continue;}if(i===0){u-=s;}if(u>m&&j.bCanOverflow){n.unshift(j.control);}else{p.unshift(j.control);}}return{aControlsForBreadcrumbTrail:p,aControlsForSelect:n};};
f.prototype._getControlsInfo=function(){if(!this._bControlsInfoCached){this._iSelectWidth=h(this._getSelect().$().parent())||0;this._aControlInfo=this._getControlsForBreadcrumbTrail().map(this._getControlInfo);this._iContainerSize=Math.ceil(h(this.$()));this._bControlsInfoCached=true;}return{aControlInfo:this._aControlInfo,iSelectWidth:this._iSelectWidth,iContentSize:this._iContainerSize};};
f.prototype._handleScreenResize=function(E){var i,j,k;if(E.size.width===E.oldSize.width||E.size.width===0){return this;}i=this._oDistributedControls.aControlsForBreadcrumbTrail.length;j=this._getControlDistribution(Math.ceil(h(this.$())));k=j.aControlsForBreadcrumbTrail.length;if(i!==k){this._updateSelect(true);}return this;};
f.prototype._getItemsToNavigate=function(){var i=this._getControlsForBreadcrumbTrail().slice(),s=this._getSelect();if(s.getVisible()){i.unshift(s);}return i;};
f.prototype._getItemNavigation=function(){if(!this._itemNavigation){this._itemNavigation=new a();}return this._itemNavigation;};
f.prototype._destroyItemNavigation=function(){if(this._itemNavigation){this.removeEventDelegate(this._itemNavigation);this._itemNavigation.destroy();this._itemNavigation=null;}};
f.prototype._configureKeyboardHandling=function(){var i=this._getItemNavigation(),s=-1,j=this._getItemsToNavigate(),n=[];if(j.length===0){return;}j.forEach(function(k,m){if(m===0){k.$().attr("tabindex","0");}k.$().attr("tabindex","-1");n.push(k.getFocusDomRef());});this.addDelegate(i);i.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"],saphome:["alt"],sapend:["alt"]});i.setCycling(false);i.setPageSize(f.PAGEUP_AND_PAGEDOWN_JUMP_SIZE);i.setRootDomRef(this.getDomRef());i.setItemDomRefs(n);i.setSelectedIndex(s);return this;};
f.prototype._registerControlListener=function(i){if(i){i.attachEvent("_change",this._resetControl,this);}};
f.prototype._deregisterControlListener=function(i){if(i){i.detachEvent("_change",this._resetControl,this);}};
f.prototype.setCurrentLocationText=function(t){var i=this._getCurrentLocation(),r=this.setProperty("currentLocationText",t,true);if(i.getText()!==t){i.setText(t);this._resetControl();}return r;};
f.prototype.setSeparatorStyle=function(s){this.setProperty("separatorStyle",s);var i=f.STYLE_MAPPER[this.getSeparatorStyle()];if(i){this._sSeparatorSymbol=i;}return this;};
f.prototype._resetControl=function(){this._aControlInfo=null;this._iContainerSize=null;this._bControlsInfoCached=null;this._bControlDistributionCached=null;this._oDistributedControls=null;if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this.removeDelegate(this._getItemNavigation());this.invalidate(this);return this;};
function h($){var m;if($.length){m=$.outerWidth(true)-$.outerWidth();return $.get(0).getBoundingClientRect().width+m;}}
return f;});
sap.ui.predefine('sap/m/BreadcrumbsRenderer',["sap/m/Text"],function(T){"use strict";var B={apiVersion:2};var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
B.render=function(R,c){var C=c._getControlsForBreadcrumbTrail(),s=c._getSelect(),S=c._sSeparatorSymbol,d=c._getInvisibleText().getId(),a=c.getAriaLabelledBy().slice();R.openStart("nav",c);R.class("sapMBreadcrumbs");a.push(d);R.accessibilityState(null,{labelledby:{value:a.join(" "),append:true}});R.openEnd();R.openStart("ol");R.openEnd();if(s.getVisible()){this._renderControlInListItem(R,s,S,false,"sapMBreadcrumbsSelectItem");}C.forEach(function(o){this._renderControlInListItem(R,o,S,o instanceof T);},this);R.close("ol");R.close("nav");};
B._renderControlInListItem=function(R,c,s,S,a){R.openStart("li");R.class("sapMBreadcrumbsItem");R.class(a);R.openEnd();R.renderControl(c);if(!S){R.openStart("span").class("sapMBreadcrumbsSeparator").openEnd().text(s).close("span");}R.close("li");};
B._getResourceBundleText=function(t){return r.getText(t);};
return B;},true);
sap.ui.predefine('sap/m/BusyDialog',['./library','sap/ui/core/Control','sap/m/Dialog','sap/m/BusyIndicator','sap/m/Label','sap/m/Button',"sap/base/Log",'sap/ui/core/Core','sap/ui/core/InvisibleText'],function(l,C,D,B,L,a,b,c,I){"use strict";var T=l.TitleAlignment;
var d=C.extend("sap.m.BusyDialog",{
metadata:{library:"sap.m",properties:{text:{type:"string",group:"Appearance",defaultValue:''},title:{type:"string",group:"Appearance",defaultValue:''},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:''},customIconRotationSpeed:{type:"int",group:"Appearance",defaultValue:1000},customIconDensityAware:{type:"boolean",defaultValue:true},customIconWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},customIconHeight:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},cancelButtonText:{type:"string",group:"Misc",defaultValue:''},showCancelButton:{type:"boolean",group:"Appearance",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:T.Auto}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{close:{parameters:{cancelPressed:{type:"boolean"}}}},designtime:"sap/m/designtime/BusyDialog.designtime"},
renderer:{apiVersion:2,render:function(r,o){}}
});
d.prototype.init=function(){this._busyIndicator=new B(this.getId()+'-busyInd',{visible:true});this._oDialog=new D(this.getId()+'-Dialog',{content:this._busyIndicator,titleAlignment:this.getTitleAlignment(),showHeader:false,afterClose:this._fnCloseHandler.bind(this),initialFocus:this._busyIndicator.getId()+'-busyIndicator'}).addStyleClass('sapMBusyDialog');this._oDialog.close=function(){};this._oDialog.addEventDelegate({onBeforeRendering:function(){var t=this.getText(),e=this.getTitle(),s=this.getShowCancelButton()||this.getCancelButtonText();if(!t&&!e&&!s){this._oDialog.addStyleClass('sapMBusyDialog-Light');}else{this._oDialog.removeStyleClass('sapMBusyDialog-Light');}}},this);this._oDialog.oPopup.onsapescape=function(e){this.close(true);}.bind(this);};
d.prototype.exit=function(){if(this._iOpenTimer){clearTimeout(this._iOpenTimer);this._iOpenTimer=null;}this._busyIndicator.destroy();this._busyIndicator=null;if(this._cancelButton){this._cancelButton.destroy();this._cancelButton=null;}if(this._oLabel){this._oLabel.destroy();this._oLabel=null;}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}};
d.prototype.open=function(){var A=this.getAriaLabelledBy();b.debug("sap.m.BusyDialog.open called at "+new Date().getTime());if(A&&A.length){if(!this._oDialog._$dialog){var t=this;A.forEach(function(i){t._oDialog.addAriaLabelledBy(i);});}}else if(!this._oDialog.getShowHeader()){this._oDialog.addAriaLabelledBy(I.getStaticId("sap.m","BUSYDIALOG_TITLE"));}else{this._oDialog.removeAriaLabelledBy(I.getStaticId("sap.m","BUSYDIALOG_TITLE"));}if(!document.body||!c.isInitialized()){this._iOpenTimer=setTimeout(function(){this.open();}.bind(this),50);}else{this._oDialog.open();}return this;};
d.prototype.close=function(i){this._isClosedFromUserInteraction=i;if(this._iOpenTimer){clearTimeout(this._iOpenTimer);this._iOpenTimer=null;}D.prototype.close.call(this._oDialog);return this;};
d.prototype._fnCloseHandler=function(){this.fireClose({cancelPressed:this._isClosedFromUserInteraction||false});};
d.prototype.setTitle=function(t){this.setProperty('title',t,true);this._oDialog.setTitle(t).setShowHeader(!!t);return this;};
d.prototype.setTitleAlignment=function(A){this.setProperty("titleAlignment",A,true);if(this._oDialog){this._oDialog.setTitleAlignment(A);}return this;};
d.prototype.setTooltip=function(t){this._oDialog.setTooltip(t);return this;};
d.prototype.getTooltip=function(){return this._oDialog.getTooltip();};
d.prototype.setText=function(t){this.setProperty('text',t,true);if(!this._oLabel){if(t){this._oLabel=new L(this.getId()+'-TextLabel',{text:t}).addStyleClass('sapMBusyDialogLabel');this._oDialog.insertAggregation('content',this._oLabel,0);this._oDialog.addAriaLabelledBy(this._oLabel.getId());}}else{if(t){this._oLabel.setText(t).setVisible(true);}else{this._oLabel.setVisible(false);}}return this;};
d.prototype.setCustomIcon=function(i){this.setProperty("customIcon",i,true);this._busyIndicator.setCustomIcon(i);return this;};
d.prototype.setCustomIconRotationSpeed=function(s){this.setProperty("customIconRotationSpeed",s,true);this._busyIndicator.setCustomIconRotationSpeed(s);return this;};
d.prototype.setCustomIconDensityAware=function(i){this.setProperty("customIconDensityAware",i,true);this._busyIndicator.setCustomIconDensityAware(i);return this;};
d.prototype.setCustomIconWidth=function(w){this.setProperty("customIconWidth",w,true);this._busyIndicator.setCustomIconWidth(w);return this;};
d.prototype.setCustomIconHeight=function(h){this.setProperty("customIconHeight",h,true);this._busyIndicator.setCustomIconHeight(h);return this;};
d.prototype.setShowCancelButton=function(i){this.setProperty("showCancelButton",i,false);if(i){this._oDialog.setEndButton(this._getCancelButton());}else{this._destroyTheCancelButton();}return this;};
d.prototype.setCancelButtonText=function(t){this.setProperty("cancelButtonText",t,false);if(t){this._getCancelButton().setText(t);this._oDialog.setEndButton(this._getCancelButton());}else{this._destroyTheCancelButton();}return this;};
d.prototype.getDomRef=function(){return this._oDialog&&this._oDialog.getDomRef();};
["addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass"].forEach(function(A){d.prototype[A]=function(){if(this._oDialog&&this._oDialog[A]){this._oDialog[A].apply(this._oDialog,arguments);return this;}};});
d.prototype._destroyTheCancelButton=function(){this._oDialog.destroyEndButton();this._cancelButton=null;};
d.prototype._getCancelButton=function(){var e=this.getCancelButtonText();e=e?e:c.getLibraryResourceBundle("sap.m").getText("BUSYDIALOG_CANCELBUTTON_TEXT");return this._cancelButton?this._cancelButton:this._cancelButton=new a(this.getId()+'busyCancelBtn',{text:e,press:function(){this.close(true);}.bind(this)});};
return d;});
sap.ui.predefine('sap/m/BusyIndicator',['./library','sap/ui/core/Control','sap/ui/core/library','sap/m/Image','sap/m/Label',"./BusyIndicatorRenderer"],function(l,C,c,I,L,B){"use strict";var T=c.TextDirection;
var a=C.extend("sap.m.BusyIndicator",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Data",defaultValue:""},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},customIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:""},customIconRotationSpeed:{type:"int",group:"Appearance",defaultValue:1000},customIconDensityAware:{type:"boolean",defaultValue:true},customIconWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},customIconHeight:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},size:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:"1rem"},design:{type:"string",group:"Appearance",defaultValue:"auto",deprecated:true}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}}});
a.prototype.init=function(){this.setBusyIndicatorDelay(0);};
a.prototype.onBeforeRendering=function(){if(this.getCustomIcon()){this.setBusy(false);}else{this.setBusy(true,"busy-area");}if(this._busyLabel){this._busyLabel.setTextDirection(this.getTextDirection());}if(this._iconImage){this._iconImage.setDensityAware(this.getCustomIconDensityAware());this._iconImage.setSrc(this.getCustomIcon());this._iconImage.setWidth(this.getCustomIconWidth());this._iconImage.setHeight(this.getCustomIconHeight());}else if(!this._iconImage&&this.getCustomIcon()){this._createCustomIcon(this.getCustomIcon()).addStyleClass("sapMBsyIndIcon");}if(this._busyLabel){this._busyLabel.setText(this.getText());this._busyLabel.setTextDirection(this.getTextDirection());}else if(!this._busyLabel&&this.getText()){this._createLabel(this.getText());}};
a.prototype.onAfterRendering=function(){this._setRotationSpeed();};
a.prototype.exit=function(){if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}if(this._busyLabel){this._busyLabel.destroy();this._busyLabel=null;}};
a.prototype._createCustomIcon=function(i){this._iconImage=new I(this.getId()+"-icon",{src:i,width:this.getCustomIconWidth(),height:this.getCustomIconHeight(),densityAware:this.getCustomIconDensityAware()});return this._iconImage;};
a.prototype._createLabel=function(t){this._busyLabel=new L(this.getId()+"-label",{labelFor:this.getId(),text:t,textAlign:"Center",textDirection:this.getTextDirection()});return this._busyLabel;};
a.prototype._setRotationSpeed=function(){if(!this._iconImage){return;}var i=this.getCustomIconRotationSpeed();if(i===this.getMetadata().getProperty("customIconRotationSpeed").getDefaultValue()){return;}i=Math.max(0,i);var $=this._iconImage.$();var r=i+"ms";$.css("animation-duration",r);$.css("display","none");setTimeout(function(){$.css("display","inline");},0);};
return a;});
sap.ui.predefine('sap/m/BusyIndicatorRenderer',[],function(){"use strict";var B={apiVersion:2};
B.render=function(r,b){var t=b.getTooltip_AsString();r.openStart("div",b).class("sapMBusyIndicator");r.style("font-size",b.getSize());r.accessibilityState(b);if(t){r.attr("title",t);}r.openEnd();if(b.getCustomIcon()){r.renderControl(b._iconImage);}else{r.openStart("div",b.getId()+"-busy-area");r.class("sapMBusyIndicatorBusyArea").openEnd().close("div");}if(b._busyLabel){r.renderControl(b._busyLabel);}r.close("div");};
return B;},true);
sap.ui.predefine('sap/m/Button',["./library","sap/ui/core/Control","sap/ui/core/ShortcutHintsMixin","sap/ui/core/EnabledPropagator","sap/ui/core/IconPool","sap/ui/Device","sap/ui/core/ContextMenuSupport","sap/ui/core/library","./ButtonRenderer","sap/ui/events/KeyCodes","sap/ui/core/LabelEnablement","sap/m/BadgeEnabler","sap/ui/core/InvisibleText","sap/base/Log"],function(l,C,S,E,I,D,a,c,B,K,L,b,d,e){"use strict";var T=c.TextDirection;var f=l.ButtonType;var g=l.ButtonAccessibilityType;var h=l.BadgeState;var A=c.aria.HasPopup;var i=1,j=9999;
var k=C.extend("sap.m.Button",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:""},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:f.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},iconFirst:{type:"boolean",group:"Appearance",defaultValue:true},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},ariaHasPopup:{type:"sap.ui.core.aria.HasPopup",group:"Accessibility",defaultValue:A.None}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tap:{deprecated:true},press:{}},designtime:"sap/m/designtime/Button.designtime",dnd:{draggable:true,droppable:false}}});
E.call(k.prototype);a.apply(k.prototype);b.call(k.prototype);
k.prototype.init=function(){this._onmouseenter=this._onmouseenter.bind(this);this._buttonPressed=false;S.addConfig(this,{event:"press",position:"0 0",addAccessibilityLabel:true},this);this.initBadgeEnablement({position:"topRight",selector:{suffix:"inner"}});this._oBadgeData={value:"",state:""};this._badgeMinValue=i;this._badgeMaxValue=j;};
k.prototype.badgeValueFormatter=function(v){var V=parseInt(v),o=this.getBadgeCustomData(),m=o.getVisible();if(isNaN(V)){return false;}if(V<this._badgeMinValue){m&&o.setVisible(false);}else{!m&&o.setVisible(true);if(V>this._badgeMaxValue&&v.indexOf("+")===-1){v=this._badgeMaxValue<1000?this._badgeMaxValue+"+":"999+";}}return v;};
k.prototype.setBadgeMinValue=function(m){var v=this.getBadgeCustomData().getValue();if(m&&!isNaN(m)&&m>=i&&m!=this._badgeMinValue&&m<=this._badgeMaxValue){this._badgeMinValue=m;this.badgeValueFormatter(v);this.invalidate();}else{e.warning("minValue is not valid (it is is less than minimum allowed badge value ["+i+"] or greater than maximum badge value ["+this._badgeMaxValue+"])",this);}return this;};
k.prototype.setBadgeMaxValue=function(m){if(m&&!isNaN(m)&&m<=j&&m!=this._badgeMaxValue&&m>=this._badgeMinValue){this._badgeMaxValue=m;this.invalidate();}else{e.warning("maxValue is not valid (it is is greater than than maximum allowed badge value ["+j+"] or less than minimum badge value ["+this._badgeMinValue+"])",this);}return this;};
k.prototype.onBadgeUpdate=function(v,s){if(this._oBadgeData.value!==v||this._oBadgeData.state!==s){if(s===h.Disappear){v="";}this._updateBadgeInvisibleText(v);this._oBadgeData={value:v,state:s};}};
k.prototype._updateBadgeInvisibleText=function(v){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s,p;v=v.toString().trim();p=v.indexOf("+");if(p!==-1){s=r.getText("BUTTON_BADGE_MORE_THAN_ITEMS",v.substr(0,p));}else{switch(v){case"":s="";break;case"1":s=r.getText("BUTTON_BADGE_ONE_ITEM",v);break;default:s=r.getText("BUTTON_BADGE_MANY_ITEMS",v);}}this._getBadgeInvisibleText().setText(s);};
k.prototype._getBadgeInvisibleText=function(){if(!this._oBadgeInvisibleText){this._oBadgeInvisibleText=new d(this.getId()+"-badge").toStatic();}return this._oBadgeInvisibleText;};
k.prototype.exit=function(){if(this._image){this._image.destroy();}if(this._iconBtn){this._iconBtn.destroy();}if(this._oBadgeInvisibleText){this._oBadgeInvisibleText.destroy();this._oBadgeData=null;}this._bFocused=null;this.$().off("mouseenter",this._onmouseenter);};
k.prototype.setType=function(s){this.setProperty("type",s,false);switch(s){case f.Critical:this._sTypeIconURI="sap-icon://alert";break;case f.Negative:this._sTypeIconURI="sap-icon://error";break;case f.Success:this._sTypeIconURI="sap-icon://sys-enter-2";break;case f.Neutral:this._sTypeIconURI="sap-icon://information";break;case f.Back:case f.Up:this._sTypeIconURI="sap-icon://nav-back";break;default:this._sTypeIconURI=null;}return this;};
k.prototype.onBeforeRendering=function(){this._bRenderActive=this._bActive;this.$().off("mouseenter",this._onmouseenter);};
k.prototype.onAfterRendering=function(){if(this._bRenderActive){this._activeButton();this._bRenderActive=this._bActive;}if(this._bFocused){this._toggleLiveChangeAnnouncement("polite");}this.$().on("mouseenter",this._onmouseenter);};
k.prototype.ontouchstart=function(o){o.setMarked();if(this._bRenderActive){delete this._bRenderActive;}if(o.targetTouches.length===1){this._buttonPressed=true;this._activeButton();}if(this.getEnabled()&&this.getVisible()){if((D.browser.safari||D.browser.firefox)&&(o.originalEvent&&o.originalEvent.type==="mousedown")){this._setButtonFocus();}this._sTouchStartTargetId=o.target.id.replace(this.getId(),'');}else{this._sTouchStartTargetId='';}};
k.prototype.ontouchend=function(o){var s;this._buttonPressed=o.originalEvent&&o.originalEvent.buttons&1;this._inactiveButton();if(this._bRenderActive){delete this._bRenderActive;this.ontap(o,true);}s=o.target.id.replace(this.getId(),'');if(this._buttonPressed===0&&((this._sTouchStartTargetId==="-BDI-content"&&(s==='-content'||s==='-inner'||s==='-img'))||(this._sTouchStartTargetId==="-content"&&(s==='-inner'||s==='-img'))||(this._sTouchStartTargetId==='-img'&&s!=='-img'))){this.ontap(o,true);}this._sTouchStartTargetId='';};
k.prototype.ontouchcancel=function(){this._buttonPressed=false;this._sTouchStartTargetId='';this._inactiveButton();};
k.prototype.ontap=function(o,F){o.setMarked();delete this._bRenderActive;if(this.bFromTouchEnd){return;}if(this.getEnabled()&&this.getVisible()){if((o.originalEvent&&o.originalEvent.type==="touchend")){this.focus();}this.fireTap({});this.firePress({});}this.bFromTouchEnd=F;if(this.bFromTouchEnd){setTimeout(function(){delete this.bFromTouchEnd;}.bind(this),0);}};
k.prototype.onkeydown=function(o){if(o.which===K.SPACE||o.which===K.ENTER||o.which===K.ESCAPE||o.which===K.SHIFT){if(o.which===K.SPACE||o.which===K.ENTER){o.setMarked();this._activeButton();}if(o.which===K.ENTER){this.firePress({});}if(o.which===K.SPACE){this._bPressedSpace=true;}if(this._bPressedSpace){if(o.which===K.SHIFT||o.which===K.ESCAPE){this._bPressedEscapeOrShift=true;this._inactiveButton();}}}else{if(this._bPressedSpace){o.preventDefault();}}};
k.prototype.onkeyup=function(o){if(o.which===K.ENTER){o.setMarked();this._inactiveButton();}if(o.which===K.SPACE){if(!this._bPressedEscapeOrShift){o.setMarked();this._inactiveButton();this.firePress({});}else{this._bPressedEscapeOrShift=false;}this._bPressedSpace=false;}if(o.which===K.ESCAPE){this._bPressedSpace=false;}};
k.prototype._onmouseenter=function(o){if(this._buttonPressed&&o.originalEvent&&o.originalEvent.buttons&1){this._activeButton();}};
k.prototype.onfocusin=function(){this._bFocused=true;this._toggleLiveChangeAnnouncement("polite");};
k.prototype.onfocusout=function(){this._buttonPressed=false;this._bFocused=false;this._sTouchStartTargetId='';this._inactiveButton();this._toggleLiveChangeAnnouncement("off");};
k.prototype._toggleLiveChangeAnnouncement=function(v){if(this._getText()){this.$("BDI-content").attr("aria-live",v);}else if(this._getAppliedIcon()){this.$("tooltip").attr("aria-live",v);}};
k.prototype._activeButton=function(){if(!this._isUnstyled()){this.$("inner").addClass("sapMBtnActive");}this._bActive=this.getEnabled();if(this._bActive){if(this._getAppliedIcon()&&this.getActiveIcon()&&this._image){this._image.setSrc(this.getActiveIcon());}}};
k.prototype._inactiveButton=function(){if(!this._isUnstyled()){this.$("inner").removeClass("sapMBtnActive");}this._bActive=false;if(this.getEnabled()){if(this._getAppliedIcon()&&this.getActiveIcon()&&this._image){this._image.setSrc(this._getAppliedIcon());}}};
k.prototype._isHoverable=function(){return this.getEnabled()&&D.system.desktop;};
k.prototype._getImage=function(s,m,n,o){var p=I.isIconURI(m),q;if(this._image instanceof sap.m.Image&&p||this._image instanceof sap.ui.core.Icon&&!p){this._image.destroy();this._image=undefined;}q=this.getIconFirst();if(this._image){this._image.setSrc(m);if(this._image instanceof sap.m.Image){this._image.setActiveSrc(n);this._image.setDensityAware(o);}}else{this._image=I.createControlByURI({id:s,src:m,activeSrc:n,densityAware:o,useIconTooltip:false},sap.m.Image).addStyleClass("sapMBtnCustomIcon").setParent(this,null,true);}this._image.addStyleClass("sapMBtnIcon");this._image.toggleStyleClass("sapMBtnIconLeft",q);this._image.toggleStyleClass("sapMBtnIconRight",!q);return this._image;};
k.prototype._getInternalIconBtn=function(s,m){var o=this._iconBtn;if(o){o.setSrc(m);}else{o=I.createControlByURI({id:s,src:m,useIconTooltip:false},sap.m.Image).setParent(this,null,true);}o.addStyleClass("sapMBtnIcon");o.addStyleClass("sapMBtnIconLeft");this._iconBtn=o;return this._iconBtn;};
k.prototype._isUnstyled=function(){var u=false;if(this.getType()===f.Unstyled){u=true;}return u;};
k.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("inner");};
k.prototype._getText=function(){return this.getText();};
k.prototype._getTooltip=function(){var t,o;t=this.getTooltip_AsString();if(!t&&!this._getText()){o=I.getIconInfo(this._getAppliedIcon());if(o){t=o.text?o.text:o.name;}}return t;};
k.prototype._getAppliedIcon=function(){return this.getIcon()||this._sTypeIconURI;};
k.prototype.getAccessibilityInfo=function(){var s=this._getText()||this.getTooltip_AsString();if(!s&&this._getAppliedIcon()){var o=I.getIconInfo(this._getAppliedIcon());if(o){s=o.text||o.name;}}return{role:"button",type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_BUTTON"),description:s,focusable:this.getEnabled(),enabled:this.getEnabled()};};
k.prototype._setButtonFocus=function(){setTimeout(function(){this.focus();}.bind(this),0);};
k.prototype._determineSelfReferencePresence=function(){var m=this.getAriaLabelledBy(),n=m.indexOf(this.getId())!==-1,H=L.getReferencingLabels(this).length>0,p=this.getParent(),o=!!(p&&p.enhanceAccessibilityState);return!n&&this._getText()&&(m.length>0||H||o);};
k.prototype._determineAccessibilityType=function(){var H=this.getAriaLabelledBy().length>0,m=this.getAriaDescribedBy().length>0,n=L.getReferencingLabels(this).length>0,o=this.getType()!==f.Default,p=H||n,q=m||o||(this._oBadgeData&&this._oBadgeData.value!==""&&this._oBadgeData.State!==h.Disappear),s;if(!p&&!q){s=g.Default;}else if(p&&!q){s=g.Labelled;}else if(!p&&q){s=g.Described;}else if(p&&q){s=g.Combined;}return s;};
k.prototype._getTitleAttribute=function(s){return this.getTooltip();};
return k;});
sap.ui.predefine('sap/m/ButtonRenderer',['sap/ui/core/library','sap/ui/core/IconPool','sap/ui/core/ShortcutHintsMixin','sap/m/library','sap/ui/core/InvisibleText'],function(c,I,S,l,a){"use strict";var B=l.ButtonType;var b=l.ButtonAccessibilityType;var T=c.TextDirection;var d=l.BadgeState;var A=c.aria.HasPopup;var e={apiVersion:2};
e.render=function(R,o){var s=o.getId();var t=o.getType();var E=o.getEnabled();var w=o.getWidth();var f=o._getTooltip();var g=o._getText();var h=o.getTextDirection();var i=(h===T.Inherit);var j=I.getIconURI("nav-back");var M;R.openStart("button",o);R.class("sapMBtnBase");if(!o._isUnstyled()){R.class("sapMBtn");if((t===B.Back||t===B.Up)&&o._getAppliedIcon()&&!g){R.class("sapMBtnBack");}}var k=e.generateAccProps(o);if(this.renderAccessibilityAttributes){this.renderAccessibilityAttributes(R,o,k);}R.accessibilityState(o,k);if(!E){R.attr("disabled","disabled");if(!o._isUnstyled()){R.class("sapMBtnDisabled");}}else{switch(t){case B.Accept:case B.Reject:case B.Emphasized:case B.Attention:R.class("sapMBtnInverted");break;default:break;}}if(f&&!S.isDOMIDRegistered(s)){R.attr("title",f);}if(w!=""||w.toLowerCase()==="auto"){R.style("width",w);if(o._getAppliedIcon()&&g){M="4rem";}else{M="2.25rem";}R.style("min-width",M);}r(o,R);R.openEnd();R.openStart("span",s+"-inner");if(!o._isUnstyled()){R.class("sapMBtnInner");}if(o._isHoverable()){R.class("sapMBtnHoverable");}if(E){R.class("sapMFocusable");}if(!o._isUnstyled()){if(g){R.class("sapMBtnText");}if(t===B.Back||t===B.Up){R.class("sapMBtnBack");}if(o._getAppliedIcon()){if(o.getIconFirst()){R.class("sapMBtnIconFirst");}else{R.class("sapMBtnIconLast");}}}if(this.renderButtonAttributes){this.renderButtonAttributes(R,o);}if(!o._isUnstyled()&&t!==""){R.class("sapMBtn"+t);}r(o,R);R.openEnd();if(t===B.Back||t===B.Up){this.writeInternalIconPoolHtml(R,o,j);}if(o.getIconFirst()&&o._getAppliedIcon()){this.writeImgHtml(R,o);}if(g){R.openStart("span",s+"-content");R.class("sapMBtnContent");if(h!==T.Inherit){R.attr("dir",h.toLowerCase());}R.openEnd();if(i){R.openStart("bdi",s+"-BDI-content");R.openEnd();}R.text(g);if(i){R.close("bdi");}R.close("span");}if(!o.getIconFirst()&&o._getAppliedIcon()){this.writeImgHtml(R,o);}R.close("span");if(f){R.openStart("span",s+"-tooltip");R.class("sapUiInvisibleText");R.openEnd();R.text(f);R.close("span");}R.close("button");};
e.writeImgHtml=function(R,o){var t=o.getType(),h=o.getIcon(),i=(t===B.Back)||(t===B.Up);if(!h&&i){return;}R.renderControl(o._getImage(o.getId()+"-img",o._getAppliedIcon(),o.getActiveIcon(),o.getIconDensityAware()));};
e.writeInternalIconPoolHtml=function(R,o,u){R.renderControl(o._getInternalIconBtn((o.getId()+"-iconBtn"),u));};
function r(o,R){if(o._bExcludeFromTabChain){R.attr("tabindex",-1);}}
var m={Accept:"BUTTON_ARIA_TYPE_ACCEPT",Reject:"BUTTON_ARIA_TYPE_REJECT",Attention:"BUTTON_ARIA_TYPE_ATTENTION",Emphasized:"BUTTON_ARIA_TYPE_EMPHASIZED",Critical:"BUTTON_ARIA_TYPE_CRITICAL",Negative:"BUTTON_ARIA_TYPE_NEGATIVE",Success:"BUTTON_ARIA_TYPE_SUCCESS"};
e.getButtonTypeAriaLabelId=function(t){return a.getStaticId("sap.m",m[t]);};
e.getBadgeTextId=function(o){return o._oBadgeData&&o._oBadgeData.value!==""&&o._oBadgeData.state!==d.Disappear?o._getBadgeInvisibleText().getId():"";};
e.generateAccProps=function(o){var t=o._getText(),h=o.getAriaHasPopup(),f;if(t){f=e.generateTextButtonAccProps(o);}else{f=e.generateIconOnlyButtonAccProps(o);}f["disabled"]=null;f["haspopup"]=(h===A.None)?null:h.toLowerCase();return f;};
e.generateIconOnlyButtonAccProps=function(o){var t=e.getButtonTypeAriaLabelId(o.getType()),s=this.getBadgeTextId(o),f=o._getTooltip(),g=o.getId()+"-tooltip",h=o._determineAccessibilityType(),i={},D;switch(h){case b.Default:i["label"]={value:f,append:true};break;case b.Described:i["label"]={value:f,append:true};D=(t+" "+s).trim();D&&(i["describedby"]={value:D,append:true});break;case b.Labelled:i["describedby"]={value:g,append:true};break;case b.Combined:i["describedby"]={value:(g+" "+t+" "+s).trim(),append:true};break;default:break;}return i;};
e.generateTextButtonAccProps=function(o){var s=o.getId(),t=e.getButtonTypeAriaLabelId(o.getType()),f=this.getBadgeTextId(o),g=o._getTooltip()?s+"-tooltip":"",i=s+"-content",h=o._determineAccessibilityType(),p=o._determineSelfReferencePresence(),j={},D;switch(h){case b.Default:g&&(j["describedby"]={value:g,append:true});break;case b.Described:D=(g+" "+t+" "+f).trim();D&&(j["describedby"]={value:D,append:true});break;case b.Labelled:p&&(j["labelledby"]={value:i,append:true});g&&(j["describedby"]={value:g,append:true});break;case b.Combined:D=(g+" "+t+" "+f).trim();D&&(j["describedby"]={value:D,append:true});p&&(j["labelledby"]={value:i,append:true});break;default:break;}return j;};
return e;},true);
sap.ui.predefine('sap/m/Carousel',["./library","sap/ui/core/Core","sap/ui/core/Control","sap/ui/Device","sap/ui/core/ResizeHandler","sap/ui/core/library","sap/m/MessagePage","./CarouselRenderer","./CarouselLayout","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/events/F6Navigation","sap/ui/thirdparty/jquery","sap/ui/thirdparty/mobify-carousel","sap/ui/core/IconPool"],function(l,C,a,D,R,c,M,b,d,K,L,F,q){"use strict";var B=c.BusyIndicatorSize;var I=l.ImageHelper;var e=l.CarouselArrowsPlacement;var P=l.PlacementType;
var f=a.extend("sap.m.Carousel",{metadata:{library:"sap.m",designtime:"sap/m/designtime/Carousel.designtime",properties:{height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},loop:{type:"boolean",group:"Misc",defaultValue:false},showPageIndicator:{type:"boolean",group:"Appearance",defaultValue:true},pageIndicatorPlacement:{type:"sap.m.PlacementType",group:"Appearance",defaultValue:P.Bottom},showBusyIndicator:{type:"boolean",group:"Appearance",defaultValue:true,deprecated:true},arrowsPlacement:{type:"sap.m.CarouselArrowsPlacement",group:"Appearance",defaultValue:e.Content}},defaultAggregation:"pages",aggregations:{pages:{type:"sap.ui.core.Control",multiple:true,singularName:"page"},customLayout:{type:"sap.m.CarouselLayout",multiple:false}},associations:{activePage:{type:"sap.ui.core.Control",multiple:false}},events:{loadPage:{deprecated:true,parameters:{pageId:{type:"string"}}},unloadPage:{deprecated:true,parameters:{pageId:{type:"string"}}},pageChanged:{parameters:{oldActivePageId:{type:"string"},newActivePageId:{type:"string"},activePages:{type:"array"}}},beforePageChanged:{parameters:{activePages:{type:"array"}}}}}});
f._INNER_SELECTOR=".sapMCrslInner";f._PAGE_INDICATOR_SELECTOR=".sapMCrslBulleted";f._PAGE_INDICATOR_ARROWS_SELECTOR=".sapMCrslIndicatorArrow";f._CONTROLS=".sapMCrslControls";f._ITEM_SELECTOR=".sapMCrslItem";f._LEFTMOST_CLASS="sapMCrslLeftmost";f._RIGHTMOST_CLASS="sapMCrslRightmost";f._LATERAL_CLASSES="sapMCrslLeftmost sapMCrslRightmost";f._MODIFIERNUMBERFORKEYBOARDHANDLING=10;f._BULLETS_TO_NUMBERS_THRESHOLD=9;f._PREVIOUS_CLASS_ARROW="sapMCrslPrev";f._NEXT_CLASS_ARROW="sapMCrslNext";
f.prototype.init=function(){this._fnAdjustAfterResize=function(){var $=this.$().find(f._INNER_SELECTOR);this._oMobifyCarousel.resize($);if(this.getPages().length>1){this._setWidthOfPages(this._getNumberOfItemsToShow());}}.bind(this);this._aOrderOfFocusedElements=[];this._aAllActivePages=[];this._aAllActivePagesIndexes=[];this._onBeforePageChangedRef=this._onBeforePageChanged.bind(this);this._onAfterPageChangedRef=this._onAfterPageChanged.bind(this);this.data("sap-ui-fastnavgroup","true",true);this._oRb=C.getLibraryResourceBundle("sap.m");};
f.prototype.exit=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.destroy();delete this._oMobifyCarousel;}if(this._oArrowLeft){this._oArrowLeft.destroy();delete this._oArrowLeft;}if(this._oArrowRight){this._oArrowRight.destroy();delete this._oArrowRight;}if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this.oMessagePage){this.oMessagePage.destroy();this.oMessagePage=null;}this.$().off('afterSlide');this._fnAdjustAfterResize=null;this._$InnerDiv=null;this._aOrderOfFocusedElements=null;this._aAllActivePages=null;this._aAllActivePagesIndexes=null;};
f.prototype.ontouchstart=function(E){if(this._oMobifyCarousel){if(E.target instanceof HTMLImageElement){E.preventDefault();}this._oMobifyCarousel.touchstart(E);}};
f.prototype.ontouchmove=function(E){if(this._oMobifyCarousel){this._oMobifyCarousel.touchmove(E);}};
f.prototype.ontouchend=function(E){if(this._oMobifyCarousel){if(this._oMobifyCarousel.hasActiveTransition()){this._oMobifyCarousel.onTransitionComplete();}this._oMobifyCarousel.touchend(E);}};
f.prototype.onBeforeRendering=function(){var A=this.getActivePage();if(!A&&this.getPages().length>0){this.setAssociation("activePage",this.getPages()[0].getId(),true);}if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this.$().off('beforeSlide',this._onBeforePageChangedRef);this.$().off('afterSlide',this._onAfterPageChangedRef);return this;};
f.prototype._getNumberOfItemsToShow=function(){var p=this.getPages().length,o=this.getCustomLayout(),n=1;if(o&&o.isA("sap.m.CarouselLayout")){n=Math.max(o.getVisiblePagesCount(),1);}if(n>1&&p<n){return p;}return n;};
f.prototype.onAfterRendering=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.unbind();setTimeout(function(){if(this._oMobifyCarousel){this._oMobifyCarousel.onTransitionComplete();}}.bind(this),0);}var n=this._getNumberOfItemsToShow();this.$().carousel(undefined,{numberOfItemsToShow:n});this._oMobifyCarousel=this.getDomRef()._carousel;this._oMobifyCarousel.setLoop(this.getLoop());this._oMobifyCarousel.setRTL(C.getConfiguration().getRTL());if(n>1){this._setWidthOfPages(n);}var A=this.getActivePage();if(A){this._updateActivePages(A);var i=this._getPageNumber(A);if(isNaN(i)||i==0){if(this.getPages().length>0){this.setAssociation("activePage",this.getPages()[0].getId(),true);this._adjustHUDVisibility(1);}}else{if(C.isThemeApplied()){this._moveToPage(i+1);}else{C.attachThemeChanged(this._handleThemeLoad,this);}if(this.getParent()&&this.getParent().isA("sap.zen.commons.layout.PositionContainer")){if(this._isCarouselUsedWithCommonsLayout===undefined){setTimeout(this["invalidate"].bind(this),0);this._isCarouselUsedWithCommonsLayout=true;}}}}this.$().on('beforeSlide',this._onBeforePageChangedRef);this.$().on('afterSlide',this._onAfterPageChangedRef);this._$InnerDiv=this.$().find(f._INNER_SELECTOR)[0];this._sResizeListenerId=R.register(this._$InnerDiv,this._fnAdjustAfterResize);var p=this.getParent();while(p){if(p.isA("sap.m.IconTabBar")){var t=this;p.attachExpand(function(E){var g=E.getParameter('expand');if(g&&i>0){t._moveToPage(i+1);}});break;}p=p.getParent();}};
f.prototype._onBeforePageChanged=function(E,p,n){if(E.target!==this.getDomRef()){return;}var N=this.getPages()[n-1].getId();this._updateActivePages(N);this.fireBeforePageChanged({activePages:this._aAllActivePagesIndexes});};
f.prototype._onAfterPageChanged=function(E,p,n){var h=this.getPages().length>0;if(E.target!==this.getDomRef()){return;}if(h&&n>0){this._changePage(p,n);}};
f.prototype._setWidthOfPages=function(n){var $=this.$().find(".sapMCrslItem"),i;if(!$.length){return;}i=this._calculatePagesWidth(n);$.each(function(g,p){p.style.width=i+"%";});};
f.prototype._calculatePagesWidth=function(n){var w=this.$().width(),s=this.getDomRef().querySelector(".sapMCrslFluid .sapMCrslItem"),m=parseFloat(window.getComputedStyle(s).marginRight),i=(w-(m*(n-1)))/n,g=(i/w)*100;return g;};
f.prototype._handleThemeLoad=function(){var A=this.getActivePage();if(A){var i=this._getPageNumber(A);if(i>0){this._moveToPage(i+1);}}C.detachThemeChanged(this._handleThemeLoad,this);};
f.prototype._moveToPage=function(i){this._oMobifyCarousel.changeAnimation('sapMCrslNoTransition');this._oMobifyCarousel.move(i);this._changePage(undefined,i);};
f.prototype._changePage=function(o,n){this._adjustHUDVisibility(n);var O=this.getActivePage();if(o){O=this.getPages()[o-1].getId();}var N=this.getPages()[n-1].getId();this.setAssociation("activePage",N,true);var t=this._getPageIndicatorText(n);L.debug("sap.m.Carousel: firing pageChanged event: old page: "+O+", new page: "+N);if(!D.system.desktop){q(document.activeElement).trigger("blur");}if(this._oMobifyCarousel&&this._oMobifyCarousel.getShouldFireEvent()){this.firePageChanged({oldActivePageId:O,newActivePageId:N,activePages:this._aAllActivePagesIndexes});}this.$('slide-number').text(t);};
f.prototype._getPageIndicatorText=function(n){return this._oRb.getText("CAROUSEL_PAGE_INDICATOR_TEXT",[n,this.getPages().length-this._getNumberOfItemsToShow()+1]);};
f.prototype._adjustHUDVisibility=function(n){var N=this._getNumberOfItemsToShow();if(D.system.desktop&&!this.getLoop()&&this.getPages().length>1){var h=this.$('hud');h.removeClass(f._LATERAL_CLASSES);if(n===1){h.addClass(f._LEFTMOST_CLASS);this._focusCarouselContainer(h,f._PREVIOUS_CLASS_ARROW);}if((n+N-1)===this.getPages().length){h.addClass(f._RIGHTMOST_CLASS);this._focusCarouselContainer(h,f._NEXT_CLASS_ARROW);}}};
f.prototype._focusCarouselContainer=function(h,A){if(h.find('.'+A)[0]===document.activeElement){this.focus();}};
f.prototype.setActivePage=function(p){var s=null;if(typeof(p)=='string'){s=p;}else if(p instanceof a){s=p.getId();}if(s){if(s===this.getActivePage()){return this;}var i=this._getPageNumber(s);if(!isNaN(i)){if(this._oMobifyCarousel){this._oMobifyCarousel.setShouldFireEvent(true);this._oMobifyCarousel.move(i+1);}}}this.setAssociation("activePage",s,true);return this;};
f.prototype._getNavigationArrow=function(s){if(!this["_oArrow"+s]){this["_oArrow"+s]=I.getImageControl(this.getId()+"-arrowScroll"+s,this["_oArrow"+s],this,{src:"sap-icon://slim-arrow-"+s.toLowerCase(),useIconTooltip:false});}return this["_oArrow"+s];};
f.prototype._getErrorPage=function(){if(!this.oMessagePage){this.oMessagePage=new M({text:this._oRb.getText("CAROUSEL_ERROR_MESSAGE"),description:"",icon:"sap-icon://document",showHeader:false});}return this.oMessagePage;};
f.prototype.previous=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.setShouldFireEvent(true);this._oMobifyCarousel.prev();}else{L.warning("Unable to execute sap.m.Carousel.previous: carousel must be rendered first.");}return this;};
f.prototype.next=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.setShouldFireEvent(true);this._oMobifyCarousel.next();}else{L.warning("Unable to execute sap.m.Carousel.next: carousel must be rendered first.");}return this;};
f.prototype._getPageNumber=function(p){var i,r;for(i=0;i<this.getPages().length;i++){if(this.getPages()[i].getId()==p){r=i;break;}}return r;};
f.prototype.onsaptabprevious=function(E){this._bDirection=false;this._fnOnTabPress(E);};
f.prototype.onsaptabnext=function(E){this._bDirection=true;this._fnOnTabPress(E);};
f.prototype.onfocusin=function(E){this.saveLastFocusReference(E);this._bDirection=undefined;};
f.prototype.onsapskipforward=function(E){E.preventDefault();this._handleGroupNavigation(E,false);};
f.prototype.onsapskipback=function(E){E.preventDefault();this._handleGroupNavigation(E,true);};
f.prototype.onkeydown=function(E){if(E.keyCode==K.F7){this._handleF7Key(E);return;}if(E.target!=this.getDomRef()){return;}switch(E.keyCode){case 189:case K.NUMPAD_MINUS:this._fnSkipToIndex(E,-1);break;case K.PLUS:case K.NUMPAD_PLUS:this._fnSkipToIndex(E,1);break;}};
f.prototype.onsapescape=function(E){var g;if(E.target===this.$()[0]&&this._lastActivePageNumber){g=this._lastActivePageNumber+1;this._oMobifyCarousel.move(g);this._changePage(undefined,g);}};
f.prototype.onsapright=function(E){this._fnSkipToIndex(E,1);};
f.prototype.onsapup=function(E){this._fnSkipToIndex(E,-1);};
f.prototype.onsapleft=function(E){this._fnSkipToIndex(E,-1);};
f.prototype.onsapdown=function(E){this._fnSkipToIndex(E,1);};
f.prototype.onsaphome=function(E){this._fnSkipToIndex(E,0);};
f.prototype.onsapend=function(E){this._fnSkipToIndex(E,this.getPages().length);};
f.prototype.onsaprightmodifiers=function(E){if(E.ctrlKey){this._fnSkipToIndex(E,f._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
f.prototype.onsapupmodifiers=function(E){if(E.ctrlKey){this._fnSkipToIndex(E,f._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
f.prototype.onsappageup=function(E){this._fnSkipToIndex(E,f._MODIFIERNUMBERFORKEYBOARDHANDLING);};
f.prototype.onsapleftmodifiers=function(E){if(E.ctrlKey){this._fnSkipToIndex(E,-f._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
f.prototype.onsapdownmodifiers=function(E){if(E.ctrlKey){this._fnSkipToIndex(E,-f._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
f.prototype.onsappagedown=function(E){this._fnSkipToIndex(E,-f._MODIFIERNUMBERFORKEYBOARDHANDLING);};
f.prototype._fnOnTabPress=function(E){if(E.target===this.$()[0]){this._lastActivePageNumber=this._getPageNumber(this.getActivePage());}};
f.prototype._handleGroupNavigation=function(E,s){var o=q.Event("keydown");E.preventDefault();this.$().trigger("focus");o.target=E.target;o.key='F6';o.shiftKey=s;F.handleF6GroupNavigation(o);};
f.prototype.saveLastFocusReference=function(E){var o=q(E.target).closest(".sapMCrsPage").control(0),s;if(this._bDirection===undefined){return;}if(this._lastFocusablePageElement===undefined){this._lastFocusablePageElement={};}if(o){s=o.getId();this._lastFocusablePageElement[s]=E.target;this._updateFocusedPagesOrder(s);}};
f.prototype._getActivePageLastFocusedElement=function(){if(this._lastFocusablePageElement){return this._lastFocusablePageElement[this._getLastFocusedActivePage()];}};
f.prototype._updateFocusedPagesOrder=function(s){var i=this._aOrderOfFocusedElements.indexOf(s);if(i>-1){this._aOrderOfFocusedElements.splice(0,0,this._aOrderOfFocusedElements.splice(i,1)[0]);}else{this._aOrderOfFocusedElements.unshift(s);}};
f.prototype._updateActivePages=function(n){var N=this._getPageNumber(n),g=this._getNumberOfItemsToShow(),h=N+g,A=this.getPages();if(h>A.length){h=A.length-g;}this._aAllActivePages=[];this._aAllActivePagesIndexes=[];for(var i=N;i<h;i++){this._aAllActivePages.push(A[i].getId());this._aAllActivePagesIndexes.push(i);}};
f.prototype._getLastFocusedActivePage=function(){for(var i=0;i<this._aOrderOfFocusedElements.length;i++){var p=this._aOrderOfFocusedElements[i];if(this._aAllActivePages.indexOf(p)>-1){return p;}}return this.getActivePage();};
f.prototype._fnSkipToIndex=function(E,n){var g=n;if(E.target!==this.getDomRef()){return;}E.preventDefault();if(this._oMobifyCarousel.hasActiveTransition()){this._oMobifyCarousel.onTransitionComplete();}this._oMobifyCarousel.setShouldFireEvent(true);if(n!==0){g=this._getPageNumber(this.getActivePage())+1+n;}this._oMobifyCarousel.move(g);};
f.prototype._handleF7Key=function(E){var A=this._getActivePageLastFocusedElement();if(E.target===this.$()[0]&&A){A.focus();}else{this.$().trigger("focus");}};
f.prototype.setShowBusyIndicator=function(){L.warning("sap.m.Carousel: Deprecated function 'setShowBusyIndicator' called. Does nothing.");return this;};
f.prototype.getShowBusyIndicator=function(){L.warning("sap.m.Carousel: Deprecated function 'getShowBusyIndicator' called. Does nothing.");return false;};
f.prototype.setBusyIndicatorSize=function(s){if(!(s in B)){s=B.Medium;}return a.prototype.setBusyIndicatorSize.call(this,s);};
return f;});
sap.ui.predefine('sap/m/CarouselLayout',["sap/ui/base/ManagedObject"],function(M){"use strict";
var C=M.extend("sap.m.CarouselLayout",{metadata:{library:"sap.m",properties:{visiblePagesCount:{type:"int",group:"Misc",defaultValue:1}}}});
return C;});
sap.ui.predefine('sap/m/CarouselRenderer',["sap/m/library","sap/base/strings/capitalize","sap/ui/core/Core","sap/ui/Device"],function(l,c,C,D){"use strict";var a=l.CarouselArrowsPlacement;var P=l.PlacementType;var r=C.getLibraryResourceBundle("sap.m");var b={apiVersion:2};b._BULLETS_TO_NUMBERS_THRESHOLD=9;
b.render=function(R,o){var p=o.getPages(),i=p.length,s=o.getPageIndicatorPlacement(),A=o.getArrowsPlacement(),I=o._getPageNumber(o.getActivePage());this._renderOpeningDiv(R,o);if(s===P.Top){this._renderPageIndicatorAndArrows(R,o,{iPageCount:i,iIndex:I,sArrowsPlacement:A,bBottom:false,bShowPageIndicator:o.getShowPageIndicator()});}this._renderInnerDiv(R,o,p,s);if(D.system.desktop&&i>o._getNumberOfItemsToShow()&&A===a.Content){this._renderHudArrows(R,o);}if(s===P.Bottom){this._renderPageIndicatorAndArrows(R,o,{iPageCount:i,iIndex:I,sArrowsPlacement:A,bBottom:true,bShowPageIndicator:o.getShowPageIndicator()});}R.close("div");};
b._renderOpeningDiv=function(R,o){var t=o.getTooltip_AsString();R.openStart("div",o).class("sapMCrsl").class("sapMCrslFluid").style("width",o.getWidth()).style("height",o.getHeight()).attr("data-sap-ui-customfastnavgroup",true).attr("tabindex",0).accessibilityState(o,{role:"listbox"});if(t){R.attr("title",t);}R.openEnd();};
b._renderInnerDiv=function(R,o,p,s){R.openStart("div").class("sapMCrslInner");if(p.length>1&&(o.getShowPageIndicator()||o.getArrowsPlacement()===a.PageIndicator)){if(s===P.Bottom){R.class("sapMCrslBottomOffset");if(o.getArrowsPlacement()===a.PageIndicator){R.class("sapMCrslBottomArrowsOffset");}}else{R.class("sapMCrslTopOffset");if(o.getArrowsPlacement()===a.PageIndicator){R.class("sapMCrslTopArrowsOffset");}}}R.openEnd();var f=function(d,i,A){R.openStart("div",o.getId()+"-"+d.getId()+"-slide").class("sapMCrslItem").accessibilityState(d,{role:"option",posinset:i+1,setsize:A.length}).openEnd();b._renderPageInScrollContainer(R,o,d);R.close("div");};if(p.length){p.forEach(f);}else{R.renderControl(o._getErrorPage());}R.close("div");};
b._renderPageIndicatorAndArrows=function(R,o,s){var p=s.iPageCount,S=D.system.desktop&&s.sArrowsPlacement===a.PageIndicator,I=o.getId(),O=[],n=o._getNumberOfItemsToShow(),d=1;if(p<=o._getNumberOfItemsToShow()){return;}if(!s.bShowPageIndicator&&!S){return;}if(s.bBottom){O.push("sapMCrslControlsBottom");}else{O.push("sapMCrslControlsTop");}if(S){R.openStart("div").class("sapMCrslControls");O.forEach(function(e){R.class(e);});R.openEnd();R.openStart("div").class("sapMCrslControlsContainer");O.forEach(function(e){R.class(e);});R.openEnd();}else{R.openStart("div").class("sapMCrslControlsNoArrows");O.forEach(function(e){R.class(e);});R.openEnd();}if(S){this._renderArrow(R,o,"previous");}R.openStart("div",I+"-pageIndicator");if(!s.bShowPageIndicator){R.style("opacity","0");}if(p<b._BULLETS_TO_NUMBERS_THRESHOLD){R.class("sapMCrslBulleted").openEnd();for(var i=1;i<=p-n+1;i++){R.openStart("span").attr("data-slide",d).accessibilityState({role:"img",label:r.getText("CAROUSEL_POSITION",[i,p])}).openEnd().text(i).close("span");d++;}}else{R.class("sapMCrslNumeric").openEnd();var t=r.getText("CAROUSEL_PAGE_INDICATOR_TEXT",[s.iIndex+1,p-n+1]);R.openStart("span",I+"-"+"slide-number").openEnd().text(t).close("span");}R.close("div");if(S){this._renderArrow(R,o,"next");}if(!S){R.close("div");}if(S){R.close("div").close("div");}};
b._renderHudArrows=function(R,o){var A;if(o.getShowPageIndicator()){if(o.getPageIndicatorPlacement()===P.Top){A="sapMCrslHudTop";}else if(o.getPageIndicatorPlacement()===P.Bottom){A="sapMCrslHudBottom";}}else{A="sapMCrslHudMiddle";}R.openStart("div",o.getId()+"-hud").class("sapMCrslHud").class(A).openEnd();this._renderArrow(R,o,"previous");this._renderArrow(R,o,"next");R.close("div");};
b._renderArrow=function(R,o,d){var s=d.slice(0,4);R.openStart("a").class("sapMCrsl"+c(s)).attr("tabindex","-1").attr("data-slide",s).attr("title",r.getText("PAGINGBUTTON_"+d.toUpperCase())).openEnd();R.openStart("div").class("sapMCrslArrowInner").openEnd();R.renderControl(o._getNavigationArrow(d==="previous"?"Left":"Right"));R.close("div").close("a");};
b._renderPageInScrollContainer=function(R,o,p){R.openStart("div").class("sapMScrollCont").class("sapMScrollContH").style("width","100%").style("height","100%").openEnd();R.openStart("div").class("sapMScrollContScroll").openEnd();R.openStart("div").class("sapMCrslItemTable").openEnd();R.openStart("div").class("sapMCrslItemTableCell");if(p.isA("sap.m.Image")){var i="sapMCrslImgNoArrows",s=D.system.desktop&&o.getArrowsPlacement()===a.PageIndicator;if(s){i="sapMCrslImg";}R.class(i);}R.openEnd();R.renderControl(p.addStyleClass("sapMCrsPage"));R.close("div");R.close("div");R.close("div");R.close("div");};
return b;},true);
sap.ui.predefine('sap/m/CheckBox',['./Label','./library','sap/ui/Device','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/library','./CheckBoxRenderer',"sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes",'sap/ui/core/LabelEnablement','sap/ui/core/message/MessageMixin'],function(L,l,D,C,E,c,a,q,K,b,M){"use strict";var V=c.ValueState;var T=c.TextAlign;var d=c.TextDirection;
var e=C.extend("sap.m.CheckBox",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.ui.core.ISemanticFormContent"],library:"sap.m",properties:{selected:{type:"boolean",group:"Data",defaultValue:false},partiallySelected:{type:"boolean",group:"Data",defaultValue:false},enabled:{type:"boolean",group:"Behavior",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Appearance",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:d.Inherit},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},useEntireWidth:{type:"boolean",group:"Appearance",defaultValue:false},activeHandling:{type:"boolean",group:"Misc",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:V.None},valueStateText:{type:"string",group:"Misc",defaultValue:null,visibility:"hidden"},displayOnly:{type:"boolean",group:"Behavior",defaultValue:false},wrapping:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{_label:{type:"sap.m.Label",group:"Behavior",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{parameters:{selected:{type:"boolean"}}}},dnd:{draggable:true,droppable:false},designtime:"sap/m/designtime/CheckBox.designtime"}});
E.call(e.prototype);M.call(e.prototype);
e.prototype.init=function(){this._handleReferencingLabels();};
e.prototype.exit=function(){this._oLabel=null;delete this._iTabIndex;};
e.prototype.setText=function(t){var o=this._getLabel();this.setProperty("text",t);o.setText(t);return this;};
e.prototype.setWidth=function(w){this.setProperty("width",w,true);this._setWidth();return this;};
e.prototype.setUseEntireWidth=function(u){this.setProperty("useEntireWidth",u,true);this._setWidth();return this;};
e.prototype.setTextDirection=function(s){var o=this._getLabel();this.setProperty("textDirection",s);o.setTextDirection(s);return this;};
e.prototype.setTextAlign=function(A){var o=this._getLabel();this.setProperty("textAlign",A);o.setTextAlign(A);return this;};
e.prototype.setValueStateText=function(t){return this.setProperty("valueStateText",t);};
e.prototype.setWrapping=function(w){var o=this._getLabel();this.setProperty("wrapping",w);o.setWrapping(w);return this;};
e.prototype.getFormattedState=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m");return this.getSelected()?B.getText("ACC_CTR_STATE_CHECKED"):B.getText("ACC_CTR_STATE_NOT_CHECKED");};
e.prototype.getFormFormattedValue=function(){return this.getFormattedState();};
e.prototype.getFormValueProperty=function(){return"selected";};
e.prototype.ontouchstart=function(o){o.originalEvent._sapui_handledByControl=true;};
e.prototype.ontap=function(o){var s;if(this.getEnabled()&&this.getEditable()&&!this.getDisplayOnly()){this.$().trigger("focus");s=this._getSelectedState();this.setSelected(s);this.setPartiallySelected(false);this.fireSelect({selected:s});o&&o.setMarked();}};
e.prototype.onkeyup=function(o){if(o&&o.which===K.SPACE&&!o.shiftKey){this.ontap(o);o.preventDefault();}};
e.prototype.onsapspace=function(o){o.preventDefault();};
e.prototype.onsapenter=function(o){this.ontap(o);};
e.prototype.setTabIndex=function(t){this._iTabIndex=t;this.$("CbBg").attr("tabindex",t);return this;};
e.prototype.getTabIndex=function(){if(this.hasOwnProperty("_iTabIndex")){return this._iTabIndex;}return(this.getEnabled()&&!this.getDisplayOnly())?0:-1;};
e.prototype._getLabel=function(){if(!this._oLabel){this._oLabel=new L(this.getId()+"-label").addStyleClass("sapMCbLabel");this.setAggregation("_label",this._oLabel,true);}return this.getAggregation("_label");};
e.prototype._setWidth=function(){var o=this._getLabel(),$=this.$(),w=this.getWidth();if(this.getUseEntireWidth()){o.setWidth("");$.outerWidth(w);}else{$.outerWidth("");o.setWidth(w);}};
e.prototype._getSelectedState=function(){var s=this.getSelected(),p=this.getPartiallySelected();return(s===p)||(!s&&p);};
e.prototype._getAriaChecked=function(){var s=this.getSelected();if(this.getPartiallySelected()&&s){return"mixed";}return s;};
e.prototype._fnLabelTapHandler=function(){this.$().trigger("focus");};
e.prototype._handleReferencingLabels=function(){var f=b.getReferencingLabels(this),t=this;if(f.length>0){f.forEach(function(s){sap.ui.getCore().byId(s).addEventDelegate({ontap:function(){t._fnLabelTapHandler();}});});}};
e.prototype.getAccessibilityInfo=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m"),t=this.getText();return{role:"checkbox",type:B.getText("ACC_CTR_TYPE_CHECKBOX"),description:(t?t+" ":"")+this.getFormattedState(),focusable:this.getEnabled()&&!this.getDisplayOnly(),enabled:this.getEnabled(),editable:this.getEditable()};};
e.prototype.getFormDoNotAdjustWidth=function(){return this.getText()?false:true;};
return e;});
sap.ui.predefine('sap/m/CheckBoxRenderer',['sap/ui/core/library','sap/ui/core/ValueStateSupport','sap/ui/Device'],function(c,V,D){"use strict";var a=c.ValueState;var C={apiVersion:2};
C.render=function(r,o){var i=o.getId(),e=o.getEnabled(),d=o.getDisplayOnly(),E=o.getEditable(),I=e&&!d,b=e&&d,f=o.getAggregation("_label"),v=o.getValueState(),g=a.Error===v,h=a.Warning===v,j=a.Success===v,k=a.Information===v,u=o.getUseEntireWidth(),l=E&&e;r.openStart("div",o);r.class("sapMCb");if(!E){r.class("sapMCbRo");}if(b){r.class("sapMCbDisplayOnly");}if(!e){r.class("sapMCbBgDis");}if(o.getText()){r.class("sapMCbHasLabel");}if(o.getWrapping()){r.class("sapMCbWrapped");}if(l){if(g){r.class("sapMCbErr");}else if(h){r.class("sapMCbWarn");}else if(j){r.class("sapMCbSucc");}else if(k){r.class("sapMCbInfo");}}if(u){r.style("width",o.getWidth());}var t=this.getTooltipText(o);if(t){r.attr("title",t);}if(I){r.attr("tabindex",o.getTabIndex());}r.accessibilityState(o,{role:"checkbox",selected:null,checked:o._getAriaChecked(),describedby:t&&l?i+"-Descr":undefined});if(b){r.attr("aria-readonly",true);}r.openEnd();r.openStart("div",o.getId()+"-CbBg");r.class("sapMCbBg");if(I&&E&&D.system.desktop){r.class("sapMCbHoverable");}if(!o.getActiveHandling()){r.class("sapMCbActiveStateOff");}r.class("sapMCbMark");if(o.getSelected()){r.class("sapMCbMarkChecked");}if(o.getPartiallySelected()){r.class("sapMCbMarkPartiallyChecked");}r.openEnd();r.voidStart("input",o.getId()+"-CB");r.attr("type","CheckBox");if(o.getSelected()){r.attr("checked","checked");}if(o.getName()){r.attr("name",o.getName());}if(!e){r.attr("disabled","disabled");}if(!E){r.attr("readonly","readonly");}r.voidEnd();r.close("div");r.renderControl(f);if(t&&sap.ui.getCore().getConfiguration().getAccessibility()&&l){r.openStart("span",i+"-Descr");r.class("sapUiHidden");r.openEnd();r.text(t);r.close("span");}r.close("div");};
C.getTooltipText=function(o){var v=o.getProperty("valueStateText"),t=o.getTooltip_AsString(),e=o.getEnabled(),E=o.getEditable();if(v){return(t?t+" - ":"")+v;}else if(E&&e){return V.enrichTooltip(o,t);}return t;};
return C;},true);
sap.ui.predefine('sap/m/ColorPalette',['sap/ui/core/Control','sap/ui/Device','sap/ui/base/DataType','sap/ui/core/library','sap/ui/core/delegate/ItemNavigation','./Button','./Dialog','./library','./ColorPaletteRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/unified/library","sap/ui/unified/ColorPickerDisplayMode","sap/ui/unified/ColorPicker"],function(C,D,a,c,I,B,b,l,d,e,K,q,u,f,g){"use strict";var h=c.CSSColor;var i=u.ColorPickerMode;var j=l.ButtonType;var k=a.getType("boolean");var m="sapMColorPaletteSquare";var S=5;var M=2;var n=15;var L=sap.ui.getCore().getLibraryResourceBundle("sap.m");
var o=C.extend("sap.m.ColorPalette",{metadata:{library:"sap.m",properties:{colors:{type:"sap.ui.core.CSSColor[]",group:"Appearance",defaultValue:["gold","darkorange","indianred","darkmagenta","cornflowerblue","deepskyblue","darkcyan","olivedrab","darkslategray","azure","white","lightgray","darkgray","dimgray","black"]}},aggregations:{_defaultColorButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_moreColorsButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{colorSelect:{parameters:{"value":{type:"sap.ui.core.CSSColor"},"defaultAction":{type:"boolean"}}},liveChange:{parameters:{r:{type:"int"},g:{type:"int"},b:{type:"int"},h:{type:"int"},s:{type:"int"},v:{type:"int"},l:{type:"int"},hex:{type:"string"},alpha:{type:"string"}}}}}});
o.prototype.init=function(){this._oDefaultColor=null;this._bShowDefaultColorButton=false;this._bShowMoreColorsButton=false;this._bShowRecentColorsSection=false;this._oDisplayMode=f.Default;this._oMoreColorsDialog=null;this._oPaletteColorItemNavigation=null;this._oRecentColorItemNavigation=null;this._recentColors=[];};
o.prototype.exit=function(){if(this._oMoreColorsDialog){this._oMoreColorsDialog.destroy();delete this._oMoreColorsDialog;}if(this._oPaletteColorItemNavigation){this.removeDelegate(this._oPaletteColorItemNavigation);this._oPaletteColorItemNavigation.destroy();delete this._oPaletteColorItemNavigation;}if(this._oRecentColorItemNavigation){this.removeDelegate(this._oRecentColorItemNavigation);this._oRecentColorItemNavigation.destroy();delete this._oRecentColorItemNavigation;}};
o.prototype.setColors=function(r){r=this.validateProperty("colors",r);if(r.length<M||r.length>n){throw new Error("Cannot set property 'colors' - array must has minimum 2 and maximum 15 elements");}return this.setProperty("colors",r);};
o.prototype._setDisplayMode=function(r){var s=this._getColorPicker();s.setDisplayMode(r);this._oDisplayMode=r;return this;};
o.prototype._getDisplayMode=function(){return this._oDisplayMode;};
o.prototype._getColorPicker=function(){return this._ensureMoreColorsDialog()._oColorPicker;};
o.prototype.ontap=function(E){var t=q(E.target),s,$;$=t.closest("."+m);if(!$.length){return;}s=$.attr("data-sap-ui-color");this._fireColorSelect(s,false,E);};
o.prototype.onsaptabnext=o.prototype.onsaptabprevious=function(E){var r=this._getElementInfo(E.target);if(r.bIsMoreColorsButton){this.fireEvent("_colorNotSelected",{_originalEvent:E});return;}if(r.bIsDefaultColorButton){this._fireColorSelect(this._getDefaultColor(),true,E);return;}o.prototype.ontap.apply(this,arguments);};o.prototype.onsapenter=o.prototype.ontap;
o.prototype.onsapspace=function(E){E.preventDefault();};
o.prototype.onkeyup=function(E){if(E.which===K.SPACE){E.preventDefault();o.prototype.ontap.apply(this,arguments);}};
o.prototype.onAfterRendering=function(){this._ensureItemNavigation();};
o.prototype.pushToRecentColors=function(s){var r=this._recentColors.indexOf(s);if(r>-1){this._recentColors.splice(r,1);}else if(this._recentColors.length===5){this._recentColors.pop();}this._recentColors.unshift(s);this.invalidate();};
o.prototype.setColorPickerSelectedColor=function(r){if(!h.isValid(r)){throw new Error("Cannot set the selected color - invalid value: "+r);}this._getColorPicker().setColorString(r);return this;};
o.prototype._createDefaultColorButton=function(){return new B(this.getId()+"-btnDefaultColor",{width:"100%",type:j.Transparent,text:L.getText("COLOR_PALETTE_DEFAULT_COLOR"),visible:this._getShowDefaultColorButton(),press:function(E){this._fireColorSelect(this._getDefaultColor(),true,E);}.bind(this)});};
o.prototype._getDefaultColor=function(){return this._oDefaultColor;};
o.prototype._setDefaultColor=function(r){if(!h.isValid(r)){throw new Error("Cannot set internal property '_defaultColor' - invalid value: "+r);}this._oDefaultColor=r;return this;};
o.prototype._getShowDefaultColorButton=function(){return this._bShowDefaultColorButton;};
o.prototype._setShowDefaultColorButton=function(v){if(!k.isValid(v)){throw new Error("Cannot set internal property 'showDefaultColorButton' - invalid value: "+v);}this._bShowDefaultColorButton=v;if(v&&!this._getDefaultColorButton()){this.setAggregation("_defaultColorButton",this._createDefaultColorButton());}if(this._getDefaultColorButton()){this._getDefaultColorButton().setVisible(v);}return this;};
o.prototype._getDefaultColorButton=function(){return this.getAggregation("_defaultColorButton");};
o.prototype._createMoreColorsButton=function(){return new B(this.getId()+"-btnMoreColors",{width:"100%",type:j.Transparent,text:L.getText("COLOR_PALETTE_MORE_COLORS"),visible:this._getShowMoreColorsButton(),press:this._openColorPicker.bind(this)});};
o.prototype._getShowMoreColorsButton=function(){return this._bShowMoreColorsButton;};
o.prototype._getShowRecentColorsSection=function(){return this._bShowRecentColorsSection;};
o.prototype._getRecentColors=function(){return this._recentColors;};
o.prototype._setShowRecentColorsSection=function(v){if(!k.isValid(v)){throw new Error("Cannot set internal property 'showRecentColorsSection' - invalid value: "+v);}this._bShowRecentColorsSection=v;return this;};
o.prototype._setShowMoreColorsButton=function(v){if(!k.isValid(v)){throw new Error("Cannot set internal property 'showMoreColorsButton' - invalid value: "+v);}this._bShowMoreColorsButton=v;if(v&&!this._getMoreColorsButton()){this.setAggregation("_moreColorsButton",this._createMoreColorsButton());}if(this._getMoreColorsButton()){this._getMoreColorsButton().setVisible(v);}return this;};
o.prototype._getMoreColorsButton=function(){return this.getAggregation("_moreColorsButton");};
o.prototype._openColorPicker=function(){this.fireEvent("_beforeOpenColorPicker");this._ensureMoreColorsDialog().open();};
o.prototype._ensureMoreColorsDialog=function(){if(!this._oMoreColorsDialog){this._oMoreColorsDialog=this._createMoreColorsDialog();}return this._oMoreColorsDialog;};
o.prototype._createMoreColorsDialog=function(){var r=new b(this.getId()+"-moreColorsDialog",{stretch:!!D.system.phone,title:L.getText("COLOR_PALETTE_MORE_COLORS_TITLE")}).addStyleClass("CPDialog");r.addContent(r._oColorPicker=new g({mode:i.HSL,displayMode:this._oDisplayMode,liveChange:function(E){this.fireLiveChange(E.getParameters());}.bind(this)}));r.setBeginButton(new B({text:L.getText("COLOR_PALETTE_MORE_COLORS_CONFIRM"),press:function(E){r.close();if(r._oColorPicker.getColorString()){this._fireColorSelect(r._oColorPicker.getColorString(),false,E);}}.bind(this)}));r.setEndButton(new B({text:L.getText("COLOR_PALETTE_MORE_COLORS_CANCEL"),press:function(){r.close();}}));return r;};
o.prototype._focusFirstElement=function(){var F=this._getShowDefaultColorButton()?this._getDefaultColorButton().getDomRef():this._getAllPaletteColorSwatches()[0];F.focus();};
o.prototype._fireColorSelect=function(r,s,O){this.fireColorSelect({value:r,defaultAction:s,_originalEvent:O});this.pushToRecentColors(r);};
o.prototype._ensureItemNavigation=function(){var P=[],r=[];if(!this._oPaletteColorItemNavigation){this._oPaletteColorItemNavigation=new p(this);this._oPaletteColorItemNavigation.setColumns(S);this._oPaletteColorItemNavigation.setCycling(false);this.addDelegate(this._oPaletteColorItemNavigation);this._oPaletteColorItemNavigation.attachEvent(I.Events.BorderReached,this._onSwatchContainerBorderReached,this);}if(!this._oRecentColorItemNavigation){this._oRecentColorItemNavigation=new p(this);this._oRecentColorItemNavigation.setColumns(S);this._oRecentColorItemNavigation.setCycling(false);this.addDelegate(this._oRecentColorItemNavigation);this._oRecentColorItemNavigation.attachEvent(I.Events.BorderReached,this._onSwatchContainerBorderReached,this);}P=P.concat(this._getAllPaletteColorSwatches());r=r.concat(this._getAllRecentColorSwatches());r=r.slice(0,this._getRecentColors().length);this._oPaletteColorItemNavigation.setRootDomRef(this.getDomRef("swatchCont-paletteColor"));this._oPaletteColorItemNavigation.setItemDomRefs(P);this._oRecentColorItemNavigation.setRootDomRef(this.getDomRef("swatchCont-recentColors"));this._oRecentColorItemNavigation.setItemDomRefs(r);};
o.prototype._onSwatchContainerBorderReached=function(E){var N,s,H=["saphome","sapend"].indexOf(E.getParameter("event").type)>-1,r=this._getAllRecentColorSwatches()[0]?this._getElementInfo(E.mParameters.event.target).bIsRecentColorSwatch:false;if(E.getParameter(p.BorderReachedDirection)===p.BorderReachedDirectionForward){if(this._getShowMoreColorsButton()&&!r){N=this._getMoreColorsButton();}else if(!H&&this._bShowRecentColorsSection&&!r&&this._getRecentColors().length>0){N=this._getAllRecentColorSwatches()[0];}else if(!H&&this._getShowDefaultColorButton()){N=this._getDefaultColorButton();}else if(!H){N=this._getAllPaletteColorSwatches()[0];}}else{if(this._getShowDefaultColorButton()&&!r){N=this._getDefaultColorButton();}else if(!H&&this._bShowRecentColorsSection&&!r&&this._getRecentColors().length>0){N=this._getAllRecentColorSwatches()[0];}else if(!H&&this._getShowMoreColorsButton()){N=this._getMoreColorsButton();}else if(!H&&!this._getShowDefaultColorButton()){s=this._getAllPaletteColorSwatches();N=s[s.length-1];}else if(!H){s=this._getAllPaletteColorSwatches();N=s[this._oPaletteColorItemNavigation._getIndexOfTheFirstItemInLastRow()];}}if(N){N.focus();}return N;};
o.prototype.onsapnext=function(E){var N,r=this._getElementInfo(E.target);if(!(r.bIsDefaultColorButton||r.bIsMoreColorsButton)){return;}E.preventDefault();E.stopImmediatePropagation(true);if(r.bIsDefaultColorButton){N=this._getAllPaletteColorSwatches()[0];}else if(this._getRecentColors().length>0&&!r.bIsRecentColorSwatch&&this._bShowRecentColorsSection){N=this._getAllRecentColorSwatches()[0];}else{N=this._getShowDefaultColorButton()?this._getDefaultColorButton():this._getAllPaletteColorSwatches()[0];}N.focus();};
o.prototype.onsapprevious=function(E){var N,F=this._getElementInfo(E.target),A;if(!(F.bIsDefaultColorButton||F.bIsMoreColorsButton||E.target===this._getAllRecentColorSwatches()[0])){return;}E.preventDefault();E.stopImmediatePropagation(true);A=this._getAllPaletteColorSwatches();if(F.bIsMoreColorsButton||(!F.bIsMoreColorsButton&&this.bIsRecentColorSwatch)){N=E.keyCode===K.ARROW_UP?A[this._oPaletteColorItemNavigation._getIndexOfTheFirstItemInLastRow()]:A[A.length-1];}else if(F.bIsRecentColorSwatch&&!this._bShowMoreColorsButton&&!this._bShowDefaultColorButton){A=this._getAllPaletteColorSwatches();N=A[this._oPaletteColorItemNavigation._getIndexOfTheFirstItemInLastRow()];}else if(this._getRecentColors().length>0&&!F.bIsRecentColorSwatch&&this._bShowRecentColorsSection){N=this._getAllRecentColorSwatches()[0];}else if(this._getShowMoreColorsButton()){N=this._getMoreColorsButton();}else{N=A[this._oPaletteColorItemNavigation._getIndexOfTheFirstItemInLastRow()];}N.focus();};
o.prototype.onsaphome=function(E){var r=this._getElementInfo(E.target);if(!r.bIsMoreColorsButton){return;}if(this._getShowDefaultColorButton()){this._getDefaultColorButton().focus();}E.preventDefault();E.stopImmediatePropagation(true);};
o.prototype.onsapend=function(E){var r=this._getElementInfo(E.target);if(!r.bIsDefaultColorButton){return;}if(this._getShowMoreColorsButton()){this._getMoreColorsButton().focus();}E.preventDefault();E.stopImmediatePropagation(true);};
o.prototype._getAllPaletteColorSwatches=function(){return this.$().find("."+m).get().slice(0,this.getColors().length);};
o.prototype._getAllRecentColorSwatches=function(){return this.$().find("."+m).get().slice(this.getColors().length);};
o.prototype._getElementInfo=function(E){var r=this._getShowDefaultColorButton()&&e(E,this._getDefaultColorButton().getDomRef()),s=!r&&this._getShowMoreColorsButton()&&e(E,this._getMoreColorsButton().getDomRef()),t=this._getAllRecentColorSwatches().indexOf(E)>-1,v=this._getAllPaletteColorSwatches().indexOf(E)>-1;return{bIsDefaultColorButton:r,bIsMoreColorsButton:s,bIsASwatch:v,bIsRecentColorSwatch:t};};
var p=I.extend("sap.m.ItemNavigationHomeEnd",{constructor:function(){I.apply(this,arguments);this.setHomeEndColumnMode(true);this.fireEvent=function(N,E){var s;if(N===I.Events.BorderReached){s=p.BorderReachedDirectionBackward;if(["sapnext","sapend"].indexOf(E.event.type)>-1){s=p.BorderReachedDirectionForward;}E[p.BorderReachedDirection]=s;}I.prototype.fireEvent.apply(this,arguments);};}});
p.BorderReachedDirection="direction";p.BorderReachedDirectionForward="BorderReachedDirectionForward";p.BorderReachedDirectionBackward="BorderReachedDirectionBackward";
p.prototype.getColumns=function(){return this.iColumns;};
p.prototype.onsapprevious=function(E){var r=e(this.getRootDomRef(),E.target),A=E.keyCode===K.ARROW_UP&&this.getFocusedIndex()===0;if(!r){return;}if(!A){I.prototype.onsapprevious.apply(this,arguments);return;}E.preventDefault();this.fireEvent(I.Events.BorderReached,{index:0,event:E});};
p.prototype.onsapnext=function(E){var r=e(this.getRootDomRef(),E.target),s,t,v;if(!r){return;}if(E.keyCode!==K.ARROW_DOWN){I.prototype.onsapnext.apply(this,arguments);return;}t=this.getFocusedIndex();v=this._getItemInfo(t);if(v.bIsLastItem&&v.bIsInTheLastColumn){E.preventDefault();this.fireEvent(I.Events.BorderReached,{index:t,event:E});return;}if(v.bNextRowExists&&!v.bItemSameColumnNextRowExists){E.preventDefault();s=this.getItemDomRefs();s[s.length-1].focus();return;}I.prototype.onsapnext.apply(this,arguments);};
p.prototype.onsaphome=function(E){var r=e(this.getRootDomRef(),E.target),s;if(!r){return;}s=this._getItemInfo(this.getFocusedIndex());if(!s.bIsInTheFirstColumn){I.prototype.onsaphome.apply(this,arguments);return;}E.preventDefault();if(s.bIsFirstItem){this.fireEvent(I.Events.BorderReached,{index:0,event:E});}else{this.getItemDomRefs()[0].focus();}};
p.prototype.onsapend=function(E){var r=e(this.getRootDomRef(),E.target),s;if(!r){return;}s=this._getItemInfo(this.getFocusedIndex());if(!(s.bIsLastItem||s.bIsInTheLastColumn)){I.prototype.onsapend.apply(this,arguments);return;}E.preventDefault();if(s.bIsLastItem){this.fireEvent(I.Events.BorderReached,{index:this.getItemDomRefs().length-1,event:E});}else{this.getItemDomRefs()[this.getItemDomRefs().length-1].focus();}};
p.prototype._getItemInfo=function(r){var s=this.getItemDomRefs().length,t=r===(s-1),v=s>this.getColumns()?this.getColumns():s,w=r%this.getColumns()===0,x=(r+1)%v===0,y=Math.floor(r/this.getColumns())+1,N,z;N=y*this.getColumns()<s;z=N&&(r+this.getColumns())<s;return{bIsFirstItem:r===0,bIsLastItem:t,bIsInTheLastColumn:x,bIsInTheFirstColumn:w,bNextRowExists:N,bItemSameColumnNextRowExists:z};};
p.prototype._getIndexOfTheFirstItemInLastRow=function(){return Math.floor((this.getItemDomRefs().length-1)/this.getColumns())*this.getColumns();};
o.prototype._ItemNavigation=p;o.prototype._ColorsHelper={RGB_TO_NAMED_COLORS_MAP:{"#FFB200":"gold","#FF8C00":"darkorange","#CD5C5C":"indianred","#8B008B":"darkmagenta","#6495ED":"cornflowerblue","#00BFFF":"deepskyblue","#008B8B":"darkcyan","#6B8E23":"olivedrab","#2F4F4F":"darkslategray","#F0FFFF":"azure","#FFFFFF":"white","#D3D3D3":"lightgray","#A9A9A9":"darkgray","#696969":"dimgray","#000000":"black"},NAME_COLORS_TO_RGB_MAP:{"gold":"#FFB200","darkorange":"#FF8C00","indianred":"#CD5C5C","darkmagenta":"#8B008B","cornflowerblue":"#6495ED","deepskyblue":"#00BFFF","darkcyan":"#008B8B","olivedrab":"#6B8E23","darkslategray":"#2F4F4F","azure":"#F0FFFF","white":"#FFFFFF","lightgray":"#D3D3D3","darkgray":"#A9A9A9","dimgray":"#696969","black":"#000000"},getNamedColor:function(s){var H="";if(!s||s.toLowerCase().indexOf("hsl")!==-1){return undefined;}if(s.indexOf("#")===-1){return this.NAME_COLORS_TO_RGB_MAP[s.toLowerCase()]?s.toLowerCase():undefined;}if(s.length===4){H=["#",s[1],s[1],s[2],s[2],s[3],s[3]].join("");}else{H=s;}H=H.toUpperCase();return this.RGB_TO_NAMED_COLORS_MAP[H];}};return o;});
sap.ui.predefine('sap/m/ColorPalettePopover',['sap/ui/core/Control','sap/ui/Device','sap/ui/unified/ColorPickerDisplayMode','./Button','./ResponsivePopover','./ColorPalette','./library'],function(C,D,a,B,R,b,l){"use strict";var P=l.PlacementType;
var c=C.extend("sap.m.ColorPalettePopover",{
metadata:{library:"sap.m",publicMethods:["openBy","close"],properties:{defaultColor:{type:"sap.ui.core.CSSColor",group:"Appearance",defaultValue:null},colors:{type:"sap.ui.core.CSSColor[]",group:"Appearance",defaultValue:["gold","darkorange","indianred","darkmagenta","cornflowerblue","deepskyblue","darkcyan","olivedrab","darkslategray","azure","white","lightgray","darkgray","dimgray","black"]},showDefaultColorButton:{type:"boolean",group:"Appearance",defaultValue:true},showMoreColorsButton:{type:"boolean",group:"Appearance",defaultValue:true},showRecentColorsSection:{type:"boolean",group:"Appearance",defaultValue:true},displayMode:{type:"sap.ui.unified.ColorPickerDisplayMode",group:"Appearance",defaultValue:a.Default}},events:{colorSelect:{parameters:{"value":{type:"sap.ui.core.CSSColor"},"defaultAction":{type:"boolean"}}},liveChange:{parameters:{r:{type:"int"},g:{type:"int"},b:{type:"int"},h:{type:"int"},s:{type:"int"},v:{type:"int"},l:{type:"int"},hex:{type:"string"},alpha:{type:"string"}}}}},
renderer:{apiVersion:2}
});
var L=sap.ui.getCore().getLibraryResourceBundle("sap.m");var F={COLOR_PALETTE_PROPS:{colors:"setColors",defaultColor:"_setDefaultColor",showDefaultColorButton:"_setShowDefaultColorButton",showMoreColorsButton:"_setShowMoreColorsButton",showRecentColorsSection:"_setShowRecentColorsSection",displayMode:"_setDisplayMode"},POPOVER_METHODS:{getDomRef:"",close:"",openBy:""}};
c.prototype.init=function(){this._oPopover=null;this._bPopoverDestroying=null;};
c.prototype.exit=function(){this._bPopoverDestroying=true;if(this._oPopover){this._oPopover.removeDelegate(this._oPopover._onAfterRenderingDelegate);this._oPopover.destroy();this._oPopover=null;}};
c.prototype.setColorPickerSelectedColor=function(d){this._getPalette().setColorPickerSelectedColor(d);return this;};
c.prototype._getPalette=function(){return this._ensurePopover().getContent()[0];};
c.prototype._ensurePopover=function(){if(!this._oPopover){this._oPopover=this._createPopover();}return this._oPopover;};
c.prototype._createPopover=function(){var p,o=this._createColorPalette(),d;p=new R(this.getId()+"-colorPalettePopover",{showHeader:D.system.phone,placement:P.VerticalPreferredBottom,showArrow:false,showCloseButton:false,title:L.getText("COLOR_PALETTE_TITLE"),content:o,afterOpen:o._focusFirstElement.bind(o)}).addStyleClass("sapMColorPaletteContainer");if(D.system.phone){p.setEndButton(new B({text:L.getText("COLOR_PALETTE_CANCEL"),press:function(){p.close();}}));}o.attachEvent("_beforeOpenColorPicker",function(){p.close();});o.attachEvent("_colorNotSelected",function(e){this._handleNextOrPreviousUponPaletteClose(e);p.close();}.bind(this));o.attachEvent("colorSelect",function(e){this._handleNextOrPreviousUponPaletteClose(e);p.close();this.fireColorSelect({"value":e.getParameter("value"),"defaultAction":e.getParameter("defaultAction")});}.bind(this));d={onAfterRendering:function(){var $=this.$();$.attr("aria-modal","true");$.attr("aria-label",this.getTitle());}};p.addEventDelegate(d,p);p._onAfterRenderingDelegate=d;return p;};
c.prototype._createColorPalette=function(){var o=new b(this.getId()+"-palette",{liveChange:function(e){this.fireLiveChange(e.getParameters());}.bind(this)});o._setShowDefaultColorButton(this.getShowDefaultColorButton());o._setShowMoreColorsButton(this.getShowMoreColorsButton());o._setShowRecentColorsSection(this.getShowRecentColorsSection());return o;};
c.prototype._handleNextOrPreviousUponPaletteClose=function(e){var o=e.getParameter("_originalEvent");if(!o){return;}if(o.type==="saptabnext"||o.type==="saptabprevious"){o.stopPropagation();o.preventDefault();}};
c.prototype.setProperty=function(p,v,s){var t;if(F.COLOR_PALETTE_PROPS[p]!==undefined){t=F.COLOR_PALETTE_PROPS[p]||p;b.prototype[t].call(this._getPalette(),v);}return C.prototype.setProperty.apply(this,arguments);};
Object.keys(F.POPOVER_METHODS).forEach(function(s){var t=F.COLOR_PALETTE_PROPS[s]||s;c.prototype[s]=function(){if(this._bPopoverDestroying){return null;}var p=this._ensurePopover();return p[t].apply(p,arguments);};});return c;});
sap.ui.predefine('sap/m/ColorPaletteRenderer',['sap/ui/Device'],function(D){"use strict";var C={apiVersion:2};var l=sap.ui.getCore().getLibraryResourceBundle("sap.m");
C.render=function(r,c){r.openStart("div",c);r.class("sapMColorPalette");r.openEnd();if(c._getShowDefaultColorButton()){this.renderDefaultColorButton(r,c);this.renderSeparator(r);}this.renderSwatches(r,c);if(c._getShowMoreColorsButton()){this.renderSeparator(r);this.renderMoreColorsButton(r,c);if(D.system.phone){this.renderSeparator(r);}}if(c._getShowRecentColorsSection()){if(!c._getShowMoreColorsButton()||!D.system.phone){this.renderSeparator(r);}this.renderRecentColorsSection(r,c);if(D.system.phone){this.renderSeparator(r);}}r.close("div");};
C.renderSwatches=function(r,c){var s=c.getColors();r.openStart("div",c.getId()+"-swatchCont-paletteColor");r.class("sapMColorPaletteContent");r.accessibilityState(c,{"role":"region","label":l.getText("COLOR_PALETTE_SWATCH_CONTAINER_TITLE")});r.openEnd();s.forEach(function(a,i){this.renderSquare(r,c,a,i,false);},this);r.close("div");};
C.renderSquare=function(r,c,s,i,I){var n=c._ColorsHelper.getNamedColor(s),a=(n===undefined)?l.getText("COLOR_PALETTE_PREDEFINED_COLOR_CUSTOM"):l.getText("COLOR_PALETTE_PREDEFINED_COLOR_"+n.toUpperCase()),b=I?l.getText("COLOR_PALETTE_RECENT_COLOR",[i+1,a]):l.getText("COLOR_PALETTE_PREDEFINED_COLOR",[i+1,a]);r.openStart("div");r.class("sapMColorPaletteSquare");if(I&&s===""){r.class("sapMRecentColorSquareDisabled");}r.attr("data-sap-ui-color",s);r.attr("tabindex","-1");r.attr("title",b);r.accessibilityState(c,{"role":"button","label":b});r.openEnd();r.openStart("div");r.style("background-color",s);r.openEnd();r.close("div");r.close("div");};
C.renderSeparator=function(r){r.openStart("div");r.class("sapMColorPaletteSeparator");r.openEnd();r.voidStart("hr");r.voidEnd();r.close("div");};
C.renderDefaultColorButton=function(r,c){r.renderControl(c._getDefaultColorButton());};
C.renderMoreColorsButton=function(r,c){r.renderControl(c._getMoreColorsButton());};
C.renderRecentColorsSection=function(r,c){var s,R=c._getRecentColors(),a=5,b=l.getText("COLOR_PALETTE_SWATCH_RECENT_COLOR_CONTAINER_TITLE");r.openStart("div",c.getId()+"-swatchCont-recentColors");r.class("sapMColorPaletteContent");r.attr("role","region");r.attr("aria-label",b);r.openEnd();for(var i=0;i<a;i++){if(R[i]){s=R[i];}else{s="";}this.renderSquare(r,c,s,i,true);}r.close("div");};
return C;},true);
sap.ui.predefine('sap/m/Column',['./library','sap/ui/core/Element','sap/ui/core/Renderer','sap/ui/core/library','sap/ui/Device',"sap/ui/thirdparty/jquery"],function(l,E,R,c,D,q){"use strict";var P=l.PopinDisplay;var V=c.VerticalAlign;var T=c.TextAlign;var S=c.SortOrder;
var C=E.extend("sap.m.Column",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},hAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin},vAlign:{type:"sap.ui.core.VerticalAlign",group:"Appearance",defaultValue:V.Inherit},styleClass:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},minScreenWidth:{type:"string",group:"Behavior",defaultValue:null},demandPopin:{type:"boolean",group:"Behavior",defaultValue:false},popinHAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin,deprecated:true},popinDisplay:{type:"sap.m.PopinDisplay",group:"Appearance",defaultValue:P.Block},mergeDuplicates:{type:"boolean",group:"Behavior",defaultValue:false},mergeFunctionName:{type:"string",group:"Misc",defaultValue:'getText'},sortIndicator:{type:"sap.ui.core.SortOrder",group:"Appearance",defaultValue:S.None},importance:{type:"sap.ui.core.Priority",group:"Behavior",defaultValue:"None"},autoPopinWidth:{type:"float",group:"Behavior",defaultValue:8}},defaultAggregation:"header",aggregations:{header:{type:"sap.ui.core.Control",multiple:false},footer:{type:"sap.ui.core.Control",multiple:false}},associations:{columnHeaderMenu:{type:"sap.ui.core.IColumnHeaderMenu",multiple:false,visibility:"hidden"}},designtime:"sap/m/designtime/Column.designtime"}});
C.prototype._index=-1;C.prototype._screen="";C.prototype._media=null;C.prototype._bForcedColumn=false;
C.prototype.exit=function(){this._clearMedia();};
C.prototype.getTable=function(){var p=this.getParent();if(p&&p.isA("sap.m.Table")){return p;}};
C.prototype.informTable=function(e,p,v){var t=this.getTable();if(t){var m="onColumn"+e;if(t[m]){t[m](this,p,v);}}};
C.prototype.ontouchstart=function(e){this._bTouchStartMarked=e.isMarked();};
C.prototype.ontap=function(e){if(!this._bTouchStartMarked&&!e.isMarked()){this.informTable("Press");}};
C.prototype.onsapspace=function(e){if(e.srcControl===this){this.informTable("Press");e.preventDefault();}};
C.prototype.onsapenter=C.prototype.onsapspace;
C.prototype.invalidate=function(){var p=this.getParent();if(!p||!p.bOutput){return;}E.prototype.invalidate.apply(this,arguments);};
C.prototype._clearMedia=function(){if(this._media&&this._minWidth){this._detachMediaContainerWidthChange(this._notifyResize,this,this.getId());D.media.removeRangeSet(this.getId());this._media=null;}};
C.prototype._addMedia=function(){delete this._bShouldAddMedia;if(this._minWidth){D.media.initRangeSet(this.getId(),[parseFloat(this._minWidth)]);this._attachMediaContainerWidthChange(this._notifyResize,this,this.getId());this._media=this._getCurrentMediaContainerRange(this.getId());if(this._media){this._media.matches=!!this._media.from;}}};
C.prototype._notifyResize=function(m){if(this._media.from===m.from){return;}this._media=m;this._media.matches=!!m.from;setTimeout(function(){if(!this.getVisible()){return;}this.fireEvent("media",this);this.informTable("Resize");}.bind(this),0);};
C.prototype._validateMinWidth=function(w){if(!w){return;}if(Object.prototype.toString.call(w)!="[object String]"){throw new Error('expected string for property "minScreenWidth" of '+this);}if(Object.keys(l.ScreenSizes).indexOf(w.toLowerCase())!=-1){return;}if(!/^\d+(\.\d+)?(px|em|rem)$/i.test(w)){throw new Error('invalid CSS size("px", "em", "rem" required) or sap.m.ScreenSize enumeration for property "minScreenWidth" of '+this);}};
C.prototype._isWidthPredefined=function(w){var t=this,u=w.replace(/[^a-z]/ig,""),b=parseFloat(l.BaseFontSize)||16;q.each(l.ScreenSizes,function(s,a){if(u!="px"){a/=b;}if(a+u==w){t._minWidth=this+"px";t._screen=s;return false;}});if(this._minWidth){return true;}if(u=="px"){this._minWidth=w;}else{this._minWidth=parseFloat(w)*b+"px";}};
C.prototype.getCssAlign=function(a){a=a||this.getHAlign();if(a===T.Begin||a===T.End||a===T.Initial){a=R.getTextAlign(a);}return a.toLowerCase();};
C.prototype.getStyleClass=function(r){var a=this.getProperty("styleClass");if(!r){return a;}if(this._screen&&(!this.getDemandPopin()||!window.matchMedia)){a+=" sapMSize-"+this._screen;}else if(this._media&&!this._media.matches){a+=" sapMListTblNone";}return a.trim();};
C.prototype.setIndex=function(n){this._index=+n;};
C.prototype.getIndex=function(){return this._index;};
C.prototype.setOrder=function(n){this._order=+n;};
C.prototype.getOrder=function(){return this.hasOwnProperty("_order")?this._order:this.getInitialOrder();};
C.prototype.setInitialOrder=function(n){this._initialOrder=+n;};
C.prototype.getInitialOrder=function(){if(this.hasOwnProperty("_initialOrder")){return this._initialOrder;}var t=this.getTable();if(!t){return-1;}return t.indexOfColumn(this);};
C.prototype.setDisplay=function(t,d){if(!t||this._index<0){return;}var i=this._index+1,p=this.getParent(),a=d&&!this.isHidden()?"table-cell":"none",h=t.querySelector("tr > th:nth-child("+i+")"),b=t.querySelectorAll("tr > td:nth-child("+i+")"),e=b.length;h.style.display=a;h.setAttribute("aria-hidden",!d);for(i=0;i<e;i++){b[i].style.display=a;b[i].setAttribute("aria-hidden",!d);}if(p&&p.setTableHeaderVisibility){setTimeout(function(){p.setTableHeaderVisibility(d);},0);}};
C.prototype.setVisible=function(v){if(v==this.getVisible()){return this;}var p=this.getParent(),t=p&&p.getTableDomRef&&p.getTableDomRef(),s=t&&this._index>=0&&!p.getAutoPopinMode()&&!this._bForcedColumn;if(s){this.setProperty("visible",v,s);this.setDisplay(t,v);}else{this.setProperty("visible",v);}return this;};
C.prototype._setMinScreenWidth=function(w){this._clearMedia();this._minWidth=0;this._screen="";if(w){w=w.toLowerCase();var a=l.ScreenSizes[w];if(a){this._screen=w;this._minWidth=a+"px";}else{this._isWidthPredefined(w);}var p=this.getTable();if(p&&p.isActive()){this._addMedia();}else{this._bShouldAddMedia=true;}}};
C.prototype.setMinScreenWidth=function(w){w=w||"";if(w==this.getMinScreenWidth()){return this;}this._validateMinWidth(w);this._setMinScreenWidth(w);return this.setProperty("minScreenWidth",w);};
C.prototype.setDemandPopin=function(v){if(v==this.getDemandPopin()){return this;}if(!this.getMinScreenWidth()){return this.setProperty("demandPopin",v,true);}return this.setProperty("demandPopin",v);};
C.prototype.setSortIndicator=function(s){this.setProperty("sortIndicator",s,true);this.$().attr("aria-sort",this.getSortIndicator().toLowerCase());return this;};
C.prototype.isPopin=function(){if(!this.getDemandPopin()){return false;}var t=this.getTable();if(t){var h=t.getHiddenInPopin()||[];var H=h.some(function(i){return this.getImportance()===i;},this);if(H){return false;}}if(this._media){return!this._media.matches;}return false;};
C.prototype.isHidden=function(){if(this._media){return!this._media.matches;}if(this._screen&&this._minWidth){return parseFloat(this._minWidth)>window.innerWidth;}return false;};
C.prototype.setLastValue=function(v){if(this.getMergeDuplicates()){this._lastValue=v;}return this;};
C.prototype.clearLastValue=function(){return this.setLastValue(NaN);};
C.prototype.getLastValue=function(){return this._lastValue;};
C.prototype.onItemsRemoved=function(){this.clearLastValue();};
C.prototype.getFocusDomRef=function(){var p=this.getParent();if(p&&(p.bActiveHeaders||p.bFocusableHeaders||this.getAssociation("columnHeaderMenu"))){var o=this.getDomRef();if(o){return o.firstChild;}}return E.prototype.getFocusDomRef.apply(this,arguments);};
C.prototype.getCalculatedMinScreenWidth=function(){return parseInt(this._minWidth)||0;};
C.prototype.setForcedColumn=function(f){if(this._bForcedColumn==f){return;}this._bForcedColumn=f;this._setMinScreenWidth(f?"":this.getMinScreenWidth());};
C.prototype.getColumnHeaderMenu=function(){return sap.ui.getCore().byId(this.getAssociation("columnHeaderMenu"));};
return C;});
sap.ui.predefine('sap/m/ColumnListItem',["sap/ui/core/Element","sap/ui/core/library","./library","./ListItemBase","./ColumnListItemRenderer","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Selectors"],function(E,c,l,L,C,q){"use strict";var a=l.ListType;var V=c.VerticalAlign;
var b=L.extend("sap.m.ColumnListItem",{metadata:{library:"sap.m",properties:{vAlign:{type:"sap.ui.core.VerticalAlign",group:"Appearance",defaultValue:V.Inherit}},defaultAggregation:"cells",aggregations:{cells:{type:"sap.ui.core.Control",multiple:true,singularName:"cell",bindable:"bindable"}}}});
var T=E.extend("sap.m.TablePopin",{
ontap:function(e){if(e.isMarked()||L.detectTextSelection(this.getDomRef())){return e.stopImmediatePropagation(true);}if(e.srcControl===this||!q(e.target).is(":sapFocusable")){this.getParent().focus();}},
_onMouseEnter:function(){var $=q(this),d=$.prev();if(!d.length||!d.hasClass("sapMLIBHoverable")||d.hasClass("sapMPopinHovered")){return;}d.addClass("sapMPopinHovered");},
_onMouseLeave:function(){var $=q(this),d=$.prev();if(!d.length||!d.hasClass("sapMLIBHoverable")||!d.hasClass("sapMPopinHovered")){return;}d.removeClass("sapMPopinHovered");}
});
b.prototype.TagName="tr";b.prototype._bAnnounceNotSelected=true;
b.prototype.init=function(){L.prototype.init.call(this);this._bNeedsTypeColumn=false;this._aClonedHeaders=[];};
b.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.call(this);this._checkTypeColumn();var p=this.hasPopin();if(p){this.$Popin().on("mouseenter",p._onMouseEnter).on("mouseleave",p._onMouseLeave);}};
b.prototype.exit=function(){L.prototype.exit.call(this);this._checkTypeColumn(false);this._destroyClonedHeaders();if(this._oPopin){this._oPopin.destroy(true);this._oPopin=null;}};
b.prototype.setVisible=function(v){L.prototype.setVisible.call(this,v);if(!v&&this.hasPopin()){this.removePopin();}return this;};
b.prototype.getTable=function(){var p=this.getParent();if(p&&p.isA("sap.m.Table")){return p;}};
b.prototype.getPopin=function(){if(!this._oPopin){this._oPopin=new T({id:this.getId()+"-sub"}).addDelegate({ontouchstart:this.ontouchstart,ontouchmove:this.ontouchmove,ontap:this.ontap,ontouchend:this.ontouchend,ontouchcancel:this.ontouchcancel,onsaptabnext:this.onsaptabnext,onsaptabprevious:this.onsaptabprevious,onsapup:this.onsapup,onsapdown:this.onsapdown,oncontextmenu:this.oncontextmenu},this).setParent(this,null,true);}return this._oPopin;};
b.prototype.$Popin=function(){return this.$("sub");};
b.prototype.hasPopin=function(){return this._oPopin;};
b.prototype.removePopin=function(){this._oPopin&&this.$Popin().remove();};
b.prototype.getTabbables=function(){return this.$().add(this.$Popin()).find(":sapTabbable");};
b.prototype.getAccessibilityType=function(B){return B.getText("ACC_CTR_TYPE_ROW");};
b.prototype.getContentAnnouncement=function(B){var t=this.getTable();if(!t){return;}var o=[],d=this.getCells(),e=t.getColumns(true);e.sort(function(f,g){var i=f.getIndex(),h=g.getIndex(),I=i-h;if(I==0){return 0;}if(i<0){return 1;}if(h<0){return-1;}return I;}).forEach(function(f){var g=d[f.getInitialOrder()];if(!g||!f.getVisible()||(f.isHidden()&&!f.isPopin())){return;}var h=f.getHeader();if(h&&h.getVisible()){o.push(L.getAccessibilityText(h)+" "+L.getAccessibilityText(g,true));}else{o.push(L.getAccessibilityText(g,true));}});return o.join(" . ").trim();};
b.prototype.updateSelectedDOM=function(s,t){L.prototype.updateSelectedDOM.apply(this,arguments);if(this.hasPopin()){this.$Popin().attr("aria-selected",s);}};
b.prototype.onfocusin=function(e){if(e.isMarked()){return;}if(e.srcControl===this){this.$().children(".sapMListTblCellDup").find(":sapTabbable").attr("tabindex",-1);}L.prototype.onfocusin.apply(this,arguments);};
b.prototype._checkTypeColumn=function(n){if(n==undefined){n=this._needsTypeColumn();}if(this._bNeedsTypeColumn!=n){this._bNeedsTypeColumn=n;this.informList("TypeColumnChange",n);}};
b.prototype._needsTypeColumn=function(){var t=this.getType();return this.getVisible()&&(t==a.Detail||t==a.Navigation||t==a.DetailAndActive);};
b.prototype._addClonedHeader=function(h){return this._aClonedHeaders.push(h);};
b.prototype._destroyClonedHeaders=function(){if(this._aClonedHeaders.length){this._aClonedHeaders.forEach(function(o){o.destroy("KeepDom");});this._aClonedHeaders=[];}};
b.prototype._activeHandlingInheritor=function(){this._toggleActiveClass(true);};
b.prototype._inactiveHandlingInheritor=function(){this._toggleActiveClass(false);};
b.prototype._toggleActiveClass=function(s){if(this.hasPopin()){this.$Popin().toggleClass("sapMLIBActive",s);}};
return b;});
sap.ui.predefine('sap/m/ColumnListItemRenderer',["sap/ui/core/Renderer","sap/ui/core/library","sap/ui/core/Core","sap/ui/Device","sap/base/Log","./library","./ListItemBaseRenderer"],function(R,c,C,D,L,l,a){"use strict";var P=l.PopinDisplay;var V=c.VerticalAlign;var b=R.extend(a);b.apiVersion=2;
b.render=function(r,o){var t=o.getTable();if(!t){return;}a.render.apply(this,arguments);if(o.getVisible()&&t.hasPopin()){this.renderPopin(r,o,t);}};
b.renderHighlight=function(r,o){r.openStart("td");r.class("sapMListTblHighlightCell");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderHighlight.apply(this,arguments);r.close("td");};
b.renderNavigated=function(r,o){r.openStart("td");r.class("sapMListTblNavigatedCell");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderNavigated.apply(this,arguments);r.close("td");};
b.renderType=function(r,o){r.openStart("td");r.class("sapMListTblNavCol");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderType.apply(this,arguments);r.close("td");};
b.renderModeContent=function(r,o){r.openStart("td");r.class("sapMListTblSelCol");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderModeContent.apply(this,arguments);r.close("td");};
b.renderCounter=function(r,o){};
b.getAriaRole=function(o){return"";};
b.renderLIAttributes=function(r,o){r.class("sapMListTblRow");var A=o.getVAlign();if(A!=V.Inherit){r.class("sapMListTblRow"+A);}var t=o.getTable();if(t&&t.getAlternateRowColors()){var p=t.indexOfItem(o);if(p%2==0){r.class("sapMListTblRowAlternate");}}};
b.renderLIContentWrapper=function(r,o){var t=o.getTable();if(!t){return;}var d=t.getColumns(true),e=o.getCells();o._destroyClonedHeaders();d.forEach(function(f,i){var h,g=true,j=e[f.getInitialOrder()];if(!f.getVisible()||!j||f.isPopin()){f.setIndex(-1);return;}r.openStart("td",o.getId()+"_cell"+i);r.class("sapMListTblCell");r.attr("data-sap-ui-column",f.getId());if(f){var s=f.getStyleClass(true).split(" ");s&&s.forEach(function(u){r.class(u);});h=f.getHeader();if(h){r.attr("headers",f.getId());}if(!t.hasPopin()&&f.getMergeDuplicates()){var F=f.getMergeFunctionName(),k=F.split("#"),m=k[1],n=k[0];if(typeof j[n]!="function"){L.warning("mergeFunctionName property is defined on "+f+" but this is not function of "+j);}else if(t._bRendering||!j.bOutput){var p=f.getLastValue(),q=j[n](m);if(p===q){g=C.getConfiguration().getAccessibility();j.addStyleClass("sapMListTblCellDupCnt");r.class("sapMListTblCellDup");}else{f.setLastValue(q);}}else if(j.hasStyleClass("sapMListTblCellDupCnt")){r.class("sapMListTblCellDup");}}f.getVAlign()!="Inherit"&&r.style("vertical-align",f.getVAlign().toLowerCase());r.style("text-align",f.getCssAlign());if(f.isHidden()){r.style("display","none");r.attr("aria-hidden","true");}}r.openEnd();if(g){this.applyAriaLabelledBy(h,j);r.renderControl(j);}r.close("td");},this);};
b.renderDummyCell=function(r,t){r.openStart("td");r.class("sapMListTblDummyCell");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();r.close("td");};
b.applyAriaLabelledBy=function(h,o){if(h&&h.getText&&h.getVisible()&&o.getAriaLabelledBy&&(o.getAriaLabelledBy()||[]).indexOf(h.getId())==-1){o.addAriaLabelledBy(h);}};
b.renderPopin=function(r,o,t){o.removePopin();r.openStart("tr",o.getPopin());r.class("sapMListTblSubRow");r.attr("tabindex","-1");if(o.isSelectable()){r.attr("aria-selected",o.getSelected());}r.openEnd();this.renderHighlight(r,o);r.openStart("td",o.getId()+"-subcell");r.class("sapMListTblSubRowCell");r.attr("colspan",t.shouldRenderDummyColumn()?t.getColSpan()+1:t.getColSpan());var p=t.getPopinLayout();r.attr("aria-labelledby",this.getAriaAnnouncement(null,"TABLE_POPIN_ROLE_DESCRIPTION"));r.openEnd();r.openStart("div");r.class("sapMListTblSubCnt");r.class("sapMListTblSubCnt"+p);r.openEnd();var d=o.getCells(),e=t.getColumns(true);e.forEach(function(f){if(!f.getVisible()||!f.isPopin()){return;}var g=d[f.getInitialOrder()],h=f.getHeader();if(!h&&!g){return;}var s=f.getStyleClass().split(" "),i=f.getPopinDisplay();r.openStart("div");r.class("sapMListTblSubCntRow");if(i==P.Inline){r.class("sapMListTblSubCntRowInline");}s&&s.forEach(function(j){r.class(j);});r.openEnd();if(h&&i!=P.WithoutHeader){r.openStart("div").class("sapMListTblSubCntHdr").openEnd();h=h.clone();f.addDependent(h);o._addClonedHeader(h);r.renderControl(h);r.openStart("span").class("sapMListTblSubCntSpr");r.attr("data-popin-colon",C.getLibraryResourceBundle("sap.m").getText("TABLE_POPIN_LABEL_COLON"));r.openEnd().close("span");r.close("div");}if(g){r.openStart("div");r.class("sapMListTblSubCntVal");r.class("sapMListTblSubCntVal"+i);r.openEnd();this.applyAriaLabelledBy(h,g);r.renderControl(g);r.close("div");}r.close("div");},this);r.close("div");r.close("td");this.renderNavigated(r,o);r.close("tr");};
b.addLegacyOutlineClass=function(r,o){var t=o.isA("sap.m.Table")?o:o.getTable();if(t&&!t.hasPopin()&&t.shouldRenderDummyColumn()){r.class("sapMTableRowCustomFocus");}};
b.renderContentLatter=function(r,o){var t=o.getTable();if(t&&t.shouldRenderDummyColumn()){if(!t.hasPopin()){a.renderContentLatter.apply(this,arguments);b.renderDummyCell(r,t);}else{b.renderDummyCell(r,t);a.renderContentLatter.apply(this,arguments);}}else{a.renderContentLatter.apply(this,arguments);}};
return b;},true);
sap.ui.predefine('sap/m/ComboBox',['./ComboBoxTextField','./ComboBoxBase','./List','./library','sap/ui/Device','sap/ui/core/Item','./ComboBoxRenderer',"sap/ui/dom/containsOrEquals","sap/m/inputUtils/scrollToItem","sap/m/inputUtils/inputsDefaultFilter","sap/m/inputUtils/typeAhead","sap/m/inputUtils/filterItems","sap/m/inputUtils/ListHelpers","sap/m/inputUtils/itemsVisibilityHandler","sap/m/inputUtils/selectionRange","sap/m/inputUtils/calculateSelectionStart","sap/ui/events/KeyCodes","sap/ui/core/Core","sap/base/Log","sap/ui/dom/jquery/control"],function(C,a,L,l,D,I,b,c,s,i,t,f,d,g,h,j,K,k,m,q){"use strict";var n=l.ListMode;
var o=a.extend("sap.m.ComboBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ComboBox.designtime",properties:{selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},filterSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false}},events:{change:{parameters:{value:{type:"string"},itemPressed:{type:"boolean"}}},selectionChange:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}},dnd:{draggable:false,droppable:true}}});
function S(e){var p=this.getSelectedItem(),r=d.getListItem(p),u=p&&r&&r.getDomRef(),v=u&&u.offsetTop,w=u&&u.offsetHeight,P=this.getPicker(),x=P.getDomRef("cont"),y=x.clientHeight;if(p&&((v+w)>(y))){if(!e){this._getList().$().css("visibility","hidden");}else{x.scrollTop=v-w/2;this._getList().$().css("visibility","visible");}}}
o.prototype._getSelectedItemText=function(v){v=v||this.getSelectedItem();if(!v){v=this.getDefaultSelectedItem();}if(v){return v.getText();}return"";};
o.prototype.setSelectedIndex=function(e,_){var p;_=_||this.getItems();e=(e>_.length-1)?_.length-1:Math.max(0,e);p=_[e];if(p){this.setSelection(p);}};
o.prototype.revertSelection=function(){var p,P=this.getPickerTextField();this.setSelectedItem(this._oSelectedItemBeforeOpen);this.setValue(this._sValueBeforeOpen);if(this.getSelectedItem()===null){p=this._sValueBeforeOpen;}else{p=this._oSelectedItemBeforeOpen.getText();}P&&P.setValue(p);};
o.prototype._filterStartsWithItems=function(e,M){var p=e.toLowerCase();var r=this.getItems(),F=r.filter(function(u){return u[M]&&u[M]().toLowerCase().startsWith(p);});return F;};
o.prototype.setSelection=function(v){var e=this._getList(),p,r;this.setAssociation("selectedItem",v);this._setPropertyProtected("selectedItemId",(v instanceof I)?v.getId():v,true);if(typeof v==="string"){v=k.byId(v);}if(e){p=d.getListItem(v);if(p){e.setSelectedItem(p,true);}else{e.removeSelections(true);}}r=v?v.getKey():"";this._setPropertyProtected("selectedKey",r);};
o.prototype.isSelectionSynchronized=function(){var v=this.getSelectedItem();return this.getSelectedKey()===(v&&v.getKey());};
o.prototype.isItemSelected=function(v){return v&&(v.getId()===this.getAssociation("selectedItem"));};
o.prototype.setAssociation=function(A,e,p){var r=this._getList();if(r&&(A==="selectedItem")){if(!(e instanceof I)){e=this.findItem("id",e);}r.setSelectedItem(d.getListItem(e),true);}return a.prototype.setAssociation.apply(this,arguments);};
o.prototype.removeAllAssociation=function(A,e){var p=this._getList();if(p&&(A==="selectedItem")){L.prototype.removeAllAssociation.apply(p,arguments);}return a.prototype.removeAllAssociation.apply(this,arguments);};
o.prototype.init=function(){a.prototype.init.apply(this,arguments);this.bOpenValueStateMessage=true;this._sValueBeforeOpen="";this._sInputValueBeforeOpen="";this._oSelectedItemBeforeOpen=null;if(D.system.phone){this.attachEvent("_change",this.onPropertyChange,this);}this.setLastFocusedListItem(null);};
o.prototype.onBeforeRendering=function(){a.prototype.onBeforeRendering.apply(this,arguments);var e=this.getItems();if(this.getRecreateItems()){d.fillList(e,this._getList(),this._mapItemToListItem.bind(this));this.setRecreateItems(false);}this.synchronizeSelection();if(!this.isOpen()&&document.activeElement===this.getFocusDomRef()&&this.getEnabled()){this.addStyleClass("sapMFocus");}if(this.getSelectedItem()&&e.indexOf(this.getSelectedItem())===-1){var v=this.getValue();this.clearSelection();this.setValue(v);}};
o.prototype.exit=function(){a.prototype.exit.apply(this,arguments);this._oSelectedItemBeforeOpen=null;this.setLastFocusedListItem(null);};
o.prototype.onBeforeRenderingPicker=function(){var O=this["onBeforeRendering"+this.getPickerType()];O&&O.call(this);};
o.prototype.onBeforeRenderingDropdown=function(){var p=this.getPicker(),w=(this.$().outerWidth()/parseFloat(l.BaseFontSize))+"rem";if(p){p.setContentMinWidth(w);}};
o.prototype.onBeforeRenderingList=function(){if(this.bProcessingLoadItemsEvent){var e=this._getList(),F=this.getFocusDomRef();if(e){e.setBusy(true);}if(F){F.setAttribute("aria-busy","true");}}};
o.prototype.onAfterRenderingPicker=function(){var O=this["onAfterRendering"+this.getPickerType()];O&&O.call(this);S.call(this,false);};
o.prototype.onAfterRenderingList=function(){var e=this.getSelectedItem(),p=d.getListItem(e);if(this.bProcessingLoadItemsEvent&&(this.getItems().length===0)){return;}var r=this._getList(),F=this.getFocusDomRef();this.highlightList(this._sInputValueBeforeOpen);if(e){r.setSelectedItem(p);this.setLastFocusedListItem(p);}if(r){r.setBusy(false);}if(F){F.removeAttribute("aria-busy");}};
o.prototype.filterItems=function(v){return f(this,this.getItems(),v,true,this.getFilterSecondaryValues(),this.fnFilter||i);};
o.prototype._mapItemToListItem=function(e){var p=d.createListItemFromCoreItem(e,this.getShowSecondaryValues());if(e.isA("sap.ui.core.Item")){this.setSelectable(e,e.getEnabled());}if(e.isA("sap.ui.core.SeparatorItem")){p.addAriaLabelledBy(this._getGroupHeaderInvisibleText().getId());}p.addStyleClass(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"NonInteractiveItem");return p;};
o.prototype.oninput=function(e){a.prototype.oninput.apply(this,arguments);this.syncPickerContent();if(e.isMarked("invalid")){return;}this.loadItems(function(){this.handleInputValidation(e);},{name:"input",busyIndicator:false});if(this.bProcessingLoadItemsEvent&&(this.getPickerType()==="Dropdown")){this.open();}if(this.getLastFocusedListItem()){this.getLastFocusedListItem().removeStyleClass("sapMLIBFocused");this.setLastFocusedListItem(null);}this.addStyleClass("sapMFocus");this._getList().removeStyleClass("sapMListFocus");if(this._getItemsShownWithFilter()){this.toggleIconPressedStyle(true);}};
o.prototype.handleInputValidation=function(e){var v,p,F,r,u=this.getSelectedItem(),V=e.target.value,E=V==="",w=e.srcControl,T=(this.getPickerType()==="Dropdown"),x=d.getListItem(u),y=this.filterItems(V);if(E&&!this.bOpenedByKeyboardOrButton&&!this.isPickerDialog()){v=this.getItems();}else{v=y.items;g(this.getItems(),y);}F=v[0];r=v.some(function(z){return z.getKey()===this.getSelectedKey();},this);p=this.intersectItems(this._filterStartsWithItems(V,'getText'),v);if(F&&this.getSelectedKey()&&!r){this.setSelection(null);}if(!E&&w&&w._bDoTypeAhead){this.handleTypeAhead(w,v,V);}else if(!E&&p[0]&&V===p[0].getText()){this.setSelection(p[0]);}else{this.setSelection(null);}if(u!==this.getSelectedItem()){this.fireSelectionChange({selectedItem:this.getSelectedItem()});x=d.getListItem(this.getSelectedItem());}this._sInputValueBeforeOpen=V;if(this.isOpen()){setTimeout(function(){this.highlightList(V);}.bind(this));}if(F){if(E&&!this.bOpenedByKeyboardOrButton){this.close();}else if(T){this.open();s(x,this.getPicker());}}else if(this.isOpen()){if(T&&!this.bOpenedByKeyboardOrButton){this.close();}}else{this.clearFilter();}};
o.prototype.handleTypeAhead=function(e,p,v){var r,u=this.getFilterSecondaryValues(),M=t(v,e,p,function(w){r=[w.getText()];if(u){r.push(w.getAdditionalText());}return r;});this.setSelection(M[0]);this.addStyleClass("sapMFocus");this._getList().removeStyleClass("sapMListFocus");};
o.prototype.onSelectionChange=function(e){var p=d.getItemByListItem(this.getItems(),e.getParameter("listItem")),P=this.getChangeEventParams(),r=(p!==this.getSelectedItem());p&&this.updateDomValue(p.getText());this.setSelection(p);this.fireSelectionChange({selectedItem:this.getSelectedItem()});if(r){P.itemPressed=true;this.onChange(null,P);}};
o.prototype.onItemPress=function(e){var p=e.getParameter("listItem"),T=p.getTitle(),P=this.getChangeEventParams(),r=(p!==d.getListItem(this.getSelectedItem()));if(p.isA("sap.m.GroupHeaderListItem")){return;}this.setLastFocusedListItem(p);this.updateDomValue(T);if(!r){P.itemPressed=true;this.onChange(null,P);}this._setPropertyProtected("value",T,true);if(this.getPickerType()==="Dropdown"&&!this.isPlatformTablet()){this.selectText(this.getValue().length,this.getValue().length);}this.close();};
o.prototype.onBeforeOpen=function(){a.prototype.onBeforeOpen.apply(this,arguments);var p=this["onBeforeOpen"+this.getPickerType()],e=this.getFocusDomRef();this.setProperty("open",true);if(this.hasLoadItemsEventListeners()&&!this.bProcessingLoadItemsEvent){this.loadItems();}if(e){e.setAttribute("aria-controls",this.getPicker().getId());}this.addContent();p&&p.call(this);};
o.prototype.onBeforeOpenDialog=function(){var p=this.getPickerTextField();this._oSelectedItemBeforeOpen=this.getSelectedItem();this._sValueBeforeOpen=this.getValue();this.getSelectedItem()&&g(this.getItems(),this.filterItems(""));p.setValue(this._sValueBeforeOpen);};
o.prototype.onAfterOpen=function(){var e=this.getSelectedItem(),p=h(this.getFocusDomRef()),T=this.isPlatformTablet();this.closeValueStateMessage();S.call(this,true);if(!T&&e&&p.start===p.end&&p.start>1){setTimeout(function(){this.selectText(0,p.end);}.bind(this),0);}};
o.prototype.onBeforeClose=function(){a.prototype.onBeforeClose.apply(this,arguments);var e=this.getFocusDomRef();this.setProperty("open",false);if(e){e.removeAttribute("aria-controls");}if(document.activeElement===e){this.updateFocusOnClose();}this.toggleIconPressedStyle(false);};
o.prototype.onAfterClose=function(){this.clearFilter();this._sInputValueBeforeOpen="";if(this.isPickerDialog()){a.prototype.closeValueStateMessage.apply(this,arguments);}};
o.prototype.onItemChange=function(e){var p=this.getAssociation("selectedItem"),N=e.getParameter("newValue"),P=e.getParameter("name");if(p===e.getParameter("id")){switch(P){case"text":if(!this.isBound("value")){this.setValue(N);}break;case"key":if(!this.isBound("selectedKey")){this.setSelectedKey(N);}break;}}return a.prototype.onItemChange.call(this,e,this.getShowSecondaryValues());};
o.prototype.onkeydown=function(e){var p=e.srcControl;a.prototype.onkeydown.apply(p,arguments);if(!p.getEnabled()||!p.getEditable()){return;}var r=K;p._bDoTypeAhead=!D.os.android&&(e.which!==r.BACKSPACE)&&(e.which!==r.DELETE);};
o.prototype.oncut=function(e){var p=e.srcControl;a.prototype.oncut.apply(p,arguments);p._bDoTypeAhead=false;};
o.prototype.onsapenter=function(e){var p=e.srcControl,r=p.getSelectedItem();if(r&&this.getFilterSecondaryValues()){p.updateDomValue(r.getText());}a.prototype.onsapenter.apply(p,arguments);if(!p.getEnabled()||!p.getEditable()){return;}if(p.isOpen()&&!this.isComposingCharacter()){p.close();}};
["onsapup","onsapdown","onsappageup","onsappagedown","onsaphome","onsapend"].forEach(function(N){o.prototype[N]=function(e){this.handleListNavigation(e,N);};});
o.prototype.handleListNavigation=function(e,N){var p=e.srcControl;if(!p.getEnabled()||!p.getEditable()){return;}e.preventDefault();this.loadItems(function(){this.syncPickerContent();if(!this.isOpen()){this.handleInlineListNavigation(N);}else{var r=this._getSuggestionsPopover();r&&r.handleListNavigation(this,e,N);}e.setMarked();});};
o.prototype.handleInlineListNavigation=function(N){var e=this.getItems(),p=d.getSelectableItems(e),r=this.getSelectedItem(),u;switch(N){case"onsapdown":u=p.indexOf(r)+1;break;case"onsapup":u=r?p.indexOf(r)-1:p.length-1;break;case"onsapend":u=p.length-1;break;case"onsaphome":u=0;break;case"onsappagedown":u=Math.min(p.length-1,p.indexOf(r)+10);break;case"onsappageup":u=Math.max(0,p.indexOf(r)-10);break;}this.handleSelectionFromList(p[u]);};
o.prototype.handleSelectionFromList=function(e){if(!e){return;}var p=this.getFocusDomRef(),T=p.value.substring(0,p.selectionStart),r=this.getSelectedItem(),u=this.getLastFocusedListItem(),v,w,x,y;if(e.isA("sap.m.StandardListItem")||e.isA("sap.m.GroupHeaderListItem")){v=e;e=d.getItemByListItem(this.getItems(),e);}else{v=d.getListItem(e);}this.setSelection(e);this.setLastFocusedListItem(v);if(e.isA("sap.ui.core.SeparatorItem")){this.setSelectedItem(null);this.updateDomValue(T);this.fireSelectionChange({selectedItem:null});this._getGroupHeaderInvisibleText().setText(this._oRb.getText("LIST_ITEM_GROUP_HEADER")+" "+e.getText());return;}if(e!==r){w=e.getText();y=u&&u.isA("sap.m.GroupHeaderListItem");x=j(h(p,y),w,T,y);this.updateDomValue(w);this.fireSelectionChange({selectedItem:e});e=this.getSelectedItem();this.selectText(x,p.value.length);}};
o.prototype.setLastFocusedListItem=function(e){this._oLastFocusedListItem=e;};
o.prototype.getLastFocusedListItem=function(){return this._oLastFocusedListItem;};
o.prototype.onsapshow=function(e){var p,r,E=this.getEditable(),u;a.prototype.onsapshow.apply(this,arguments);this.syncPickerContent();if(!this.getValue()&&E){p=d.getSelectableItems(this.getItems());r=p[0];if(r){u=d.getListItem(r);if(this.isOpen()){this._getSuggestionsPopover().updateFocus(this,u);this.setLastFocusedListItem(u);}else{this.addStyleClass("sapMFocus");}this.setSelection(r);this.updateDomValue(r.getText());this.fireSelectionChange({selectedItem:r});setTimeout(function(){this.selectText(0,r.getText().length);}.bind(this),0);}}};
o.prototype.onsaphide=o.prototype.onsapshow;
o.prototype.ontap=function(e){if(!this.getEnabled()){return;}this.updateFocusOnClose();};
o.prototype.updateFocusOnClose=function(){var e=this.getFocusDomRef(),p=this._getSuggestionsPopover();this.setLastFocusedListItem(null);if(p){p.setValueStateActiveState(false);p.updateFocus(this);}e.removeAttribute("aria-activedescendant");};
o.prototype.onmouseup=function(){if(this.getPickerType()==="Dropdown"&&document.activeElement===this.getFocusDomRef()&&!this.getSelectedText()){this.selectText(0,this.getValue().length);}};
o.prototype.onfocusin=function(e){var p=this.getPickerType()==="Dropdown";if(this._bIsBeingDestroyed){return;}if(e.target===this.getOpenArea()){this.bOpenValueStateMessage=false;if(p&&!this.isPlatformTablet()){this.focus();}}else{if(!this.isOpen()&&this.bOpenValueStateMessage&&this.shouldValueStateMessageBeOpened()){this.openValueStateMessage();}this.bOpenValueStateMessage=true;}if(this.getEnabled()&&(!this.isOpen()||!this.getSelectedItem()||!this._getList().hasStyleClass("sapMListFocus"))){this.addStyleClass("sapMFocus");}};
o.prototype.onsapfocusleave=function(e){var T,p,r,F,u=this.getSelectedItem();if(u&&this.getFilterSecondaryValues()){this.updateDomValue(u.getText());}a.prototype.onsapfocusleave.apply(this,arguments);if(this.isPickerDialog()){return;}p=this.getPicker();if(!e.relatedControlId||!p){return;}T=this.isPlatformTablet();r=k.byId(e.relatedControlId);F=r&&r.getFocusDomRef();if(c(p.getFocusDomRef(),F)&&!T&&!(this._getSuggestionsPopover().getValueStateActiveState())){this.focus();}};
o.prototype.synchronizeSelection=function(){if(this.isSelectionSynchronized()){return;}var e=this.getSelectedKey(),v=this.getItemByKey(""+e);if(v&&(e!=="")){this.setAssociation("selectedItem",v,true);this._setPropertyProtected("selectedItemId",v.getId(),true);this.setValue(v.getText());this._sValue=this.getValue();}};
o.prototype.configPicker=function(p){var r=this.getRenderer(),e=r.CSS_CLASS_COMBOBOXBASE;p.setHorizontalScrolling(false).addStyleClass(e+"Picker").addStyleClass(e+"Picker-CTX").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this);};
o.prototype._configureList=function(e){var r=this.getRenderer();if(!e){return;}e.setMode(n.SingleSelectMaster).addStyleClass(r.CSS_CLASS_COMBOBOXBASE+"List").addStyleClass(r.CSS_CLASS_COMBOBOX+"List");e.attachSelectionChange(this.onSelectionChange,this).attachItemPress(this.onItemPress,this);e.addEventDelegate({onBeforeRendering:this.onBeforeRenderingList,onAfterRendering:this.onAfterRenderingList},this);};
o.prototype.getDefaultSelectedItem=function(){return null;};
o.prototype.getChangeEventParams=function(){return{itemPressed:false};};
o.prototype.clearSelection=function(){this.setAssociation("selectedItem",null);this.setSelectedItemId("");this.setSelectedKey("");};
o.prototype.selectText=function(e,p){a.prototype.selectText.apply(this,arguments);return this;};
o.prototype.clone=function(e){var p=a.prototype.clone.apply(this,arguments),r=this._getList();p.setAssociation("selectedItem",null);if(!this.isBound("items")&&r){p.syncPickerContent();p.setSelectedIndex(this.indexOfItem(this.getSelectedItem()));}return p;};
o.prototype.open=function(){this.syncPickerContent();a.prototype.open.call(this);this._getSuggestionsPopover()&&this._getSuggestionsPopover().updateFocus(this,d.getListItem(this.getSelectedItem()));return this;};
o.prototype.syncPickerContent=function(){var p,P=this.getPicker(),e=this.getInputForwardableProperties();if(!P){var r,G;P=this.createPicker(this.getPickerType());p=this.getPickerTextField();d.fillList(this.getItems(),this._getList(),this._mapItemToListItem.bind(this));g(this.getItems(),this.filterItems(""));if(p){e.forEach(function(u){u=u.charAt(0).toUpperCase()+u.slice(1);r="set"+u;G="get"+u;if(p[r]){p[r](this[G]());}},this);}this._getSuggestionsPopover().updateValueState(this.getValueState(),this.getValueStateText(),this.getShowValueStateMessage());}this.synchronizeSelection();return P;};
o.prototype.findAggregatedObjects=function(){var e=this._getList();if(e){return L.prototype.findAggregatedObjects.apply(e,arguments);}return[];};
o.prototype.setSelectedItem=function(v){if(typeof v==="string"){this.setAssociation("selectedItem",v,true);v=k.byId(v);}if(!(v instanceof I)&&v!==null){return this;}if(!v){v=this.getDefaultSelectedItem();}this.setSelection(v);this.setValue(this._getSelectedItemText(v));return this;};
o.prototype.setSelectedItemId=function(v){v=this.validateProperty("selectedItemId",v);if(!v){v=this.getDefaultSelectedItem();}this.setSelection(v);v=this.getSelectedItem();this.setValue(this._getSelectedItemText(v));return this;};
o.prototype.setSelectedKey=function(e){e=this.validateProperty("selectedKey",e);var p=(e===""),r=this.isBound("selectedKey")&&this.isBound("value")&&this.getBindingInfo("selectedKey").skipModelUpdate;if(p){this.setSelection(null);if(!r){this.setValue("");}return this;}var u=this.getItemByKey(e);if(u){this.setSelection(u);if(!r){this.setValue(this._getSelectedItemText(u));}return this;}this._sValue=this.getValue();return this._setPropertyProtected("selectedKey",e);};
o.prototype._setPropertyProtected=function(p,v,r){try{return this.setProperty(p,v,r);}catch(e){m.warning("setSelectedKey update failed due to exception. Loggable in support mode log",null,null,function(){return{exception:e};});}};
o.prototype.getSelectedItem=function(){var v=this.getAssociation("selectedItem");return(v===null)?null:k.byId(v)||null;};
o.prototype._decoratePopupInput=function(e){a.prototype._decoratePopupInput.apply(this,arguments);if(!e||!e.isA(["sap.m.InputBase"])){return;}e.addEventDelegate({onsapenter:function(){var T=e.getValue();this.updateDomValue(T);this.onChange();if(T){this.updateDomValue(T);this.onChange();this.close();}}},this);e.attachChange(this._handleInnerInputChange.bind(this));return e;};
o.prototype._handleInnerInputChange=function(e){if(e.getParameter("value")===""){this.clearSelection();this.clearFilter();}};
o.prototype.applyShowItemsFilters=function(){var p,P;this.syncPickerContent();p=this.getPicker();P=function(){p.detachBeforeOpen(P,this);p=null;g(this.getItems(),this.filterItems(this.getValue()||"_"));};p.attachBeforeOpen(P,this);};
o.prototype.showItems=function(F){var e,p,r=Array.prototype.slice.call(arguments),u=this.fnFilter,v=function(){this.setFilterFunction(F||function(){return true;});p=this.filterItems(this.getValue()||"_");g(this.getItems(),p);this.setFilterFunction(u);e=p.items;if(e&&e.length){a.prototype.showItems.apply(this,r);}}.bind(this);this.attachLoadItems(v);this.loadItems(v);};
o.prototype._getFormattedValueStateText=function(){if(this.isOpen()){return this._getSuggestionsPopover()._getValueStateHeader().getFormattedText();}else{return C.prototype.getFormattedValueStateText.call(this);}};
o.prototype.handleClearIconPress=function(e){if(!(this.getEnabled()&&this.getEditable())){return;}if(this.getValue()!==""){this.clearSelection();this.setProperty("effectiveShowClearIcon",false);}};
return o;});
sap.ui.predefine('sap/m/ComboBoxBase',['./ComboBoxTextField','./ComboBoxBaseRenderer','./SuggestionsPopover','sap/ui/base/ManagedObjectObserver','sap/ui/core/SeparatorItem','sap/ui/core/InvisibleText','sap/ui/base/ManagedObject','sap/base/Log','./library','sap/ui/Device',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/base/security/encodeXML","sap/base/strings/escapeRegExp","sap/m/inputUtils/forwardItemProperties","sap/m/inputUtils/highlightDOMElements","sap/m/inputUtils/ListHelpers","sap/ui/core/IconPool","sap/ui/core/Core"],function(C,a,S,M,b,I,c,L,l,D,d,K,q,e,f,g,h,j,k,m){"use strict";var P=l.PlacementType;var n=["value","enabled","name","placeholder","editable","textAlign","textDirection","valueState","valueStateText"];
var o=C.extend("sap.m.ComboBoxBase",{
metadata:{library:"sap.m","abstract":true,defaultAggregation:"items",properties:{showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false},open:{type:"boolean",defaultValue:false,hidden:true},showClearIcon:{type:"boolean",defaultValue:false},effectiveShowClearIcon:{type:"boolean",defaultValue:false,visibility:"hidden"}},aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"},picker:{type:"sap.ui.core.PopupInterface",multiple:false,visibility:"hidden"}},events:{loadItems:{}},dnd:{draggable:false,droppable:true}},
renderer:a
});
o.prototype.oncompositionend=function(E){C.prototype.oncompositionend.apply(this,arguments);if(!D.browser.firefox){this.handleInputValidation(E,this.isComposingCharacter());}};
o.prototype.shouldShowClearIcon=function(){return this.getProperty("effectiveShowClearIcon")&&!!this.getValue()&&this.getEditable()&&this.getEnabled();};
o.prototype.updateItems=function(r){this.bItemsUpdated=false;this.destroyItems();this.updateAggregation("items");this.bItemsUpdated=true;if(this.hasLoadItemsEventListeners()){if(this.isOpen()){j.fillList(this.getItems(),this._getList(),this._mapItemToListItem.bind(this));this.setRecreateItems(false);}this.onItemsLoaded();}};
o.prototype.setFilterFunction=function(F){if(F===null||F===undefined){this.fnFilter=null;return this;}if(typeof(F)!=="function"){L.warning("Passed filter is not a function and the default implementation will be used");}else{this.fnFilter=F;}return this;};
o.prototype.highlightList=function(v){var i=[];i=this._getList().$().find('.sapMSLIInfo, .sapMSLITitleOnly');h(i,v);};
o.prototype._decoratePopupInput=function(i){if(i){this.setTextFieldHandler(i);i.setShowClearIcon(this.getShowClearIcon());}return i;};
o.prototype.setTextFieldHandler=function(t){var i=this,T=t._handleEvent;t._handleEvent=function(E){T.apply(this,arguments);if(/keydown|keyup|sapdown|sapup|saphome|sapend|sappagedown|sappageup|input/.test(E.type)){i._handleEvent(E);}};};
o.prototype.refreshItems=function(){this.bItemsUpdated=false;this.refreshAggregation("items");};
o.prototype.loadItems=function(i,O){var p=typeof i==="function";if(this.hasLoadItemsEventListeners()&&(this.getItems().length===0)){this._bOnItemsLoadedScheduled=false;if(p){O=q.extend({action:i,busyIndicator:true,busyIndicatorDelay:300},O);this.aMessageQueue.push(O);if((this.iLoadItemsEventInitialProcessingTimeoutID===-1)&&(O.busyIndicator)){this.iLoadItemsEventInitialProcessingTimeoutID=setTimeout(function r(){this.setInternalBusyIndicatorDelay(0);this.setInternalBusyIndicator(true);}.bind(this),O.busyIndicatorDelay);}}if(!this.bProcessingLoadItemsEvent){this.bProcessingLoadItemsEvent=true;this.fireLoadItems();}}else if(p){i.call(this);}};
o.prototype.onItemsLoaded=function(){this.bProcessingLoadItemsEvent=false;clearTimeout(this.iLoadItemsEventInitialProcessingTimeoutID);if(this.bInitialBusyIndicatorState!==this.getBusy()){this.setInternalBusyIndicator(this.bInitialBusyIndicatorState);}if(this.iInitialBusyIndicatorDelay!==this.getBusyIndicatorDelay()){this.setInternalBusyIndicatorDelay(this.iInitialBusyIndicatorDelay);}for(var i=0,p,N,r;i<this.aMessageQueue.length;i++){p=this.aMessageQueue.shift();i--;r=(i+1)===this.aMessageQueue.length;N=r?null:this.aMessageQueue[i+1];if(typeof p.action==="function"){if((p.name==="input")&&!r&&(N.name==="input")){continue;}p.action.call(this);}}};
o.prototype.hasLoadItemsEventListeners=function(){return this.hasListeners("loadItems");};
o.prototype._scheduleOnItemsLoadedOnce=function(){if(!this._bOnItemsLoadedScheduled&&!this.isBound("items")&&this.hasLoadItemsEventListeners()&&this.bProcessingLoadItemsEvent){this._bOnItemsLoadedScheduled=true;setTimeout(this.onItemsLoaded.bind(this),0);}};
o.prototype.getPickerInvisibleTextId=function(){return I.getStaticId("sap.m","COMBOBOX_AVAILABLE_OPTIONS");};
o.prototype._getGroupHeaderInvisibleText=function(){if(!this._oGroupHeaderInvisibleText){this._oGroupHeaderInvisibleText=new I();this._oGroupHeaderInvisibleText.toStatic();}return this._oGroupHeaderInvisibleText;};
o.prototype._isListInSuggestMode=function(){return this._getList().getItems().some(function(i){return!i.getVisible()&&j.getItemByListItem(this.getItems(),i).getEnabled();},this);};
o.prototype.getSelectable=function(i){return i._bSelectable;};
o.prototype._setItemsShownWithFilter=function(v){this._bItemsShownWithFilter=v;};
o.prototype._getItemsShownWithFilter=function(){return this._bItemsShownWithFilter;};
o.prototype._getClearIcon=function(){if(this._oClearIcon){return this._oClearIcon;}this._oClearIcon=this.addEndIcon({src:k.getIconURI("decline"),noTabStop:true,visible:false,alt:this._oRb.getText("INPUT_CLEAR_ICON_ALT"),useIconTooltip:false,decorative:false,press:this.handleClearIconPress.bind(this)},0);this._oClearIcon.addStyleClass("sapMComboBoxBaseClearIcon");return this._oClearIcon;};
o.prototype.handleClearIconPress=function(E){};
o.prototype.onkeyup=function(E){if(!this.getEnabled()||!this.getEditable()){return;}this.getShowClearIcon()&&this.setProperty("effectiveShowClearIcon",!!this.getValue());};
o.prototype.setValue=function(v){C.prototype.setValue.apply(this,arguments);this.setProperty("effectiveShowClearIcon",!!v);return this;};
o.prototype.init=function(){C.prototype.init.apply(this,arguments);this._oRb=m.getLibraryResourceBundle("sap.m");this.setPickerType(D.system.phone?"Dialog":"Dropdown");this._setItemsShownWithFilter(false);this.bItemsUpdated=false;this.bOpenedByKeyboardOrButton=false;this._bShouldClosePicker=false;this.bProcessingLoadItemsEvent=false;this.iLoadItemsEventInitialProcessingTimeoutID=-1;this.aMessageQueue=[];this.bInitialBusyIndicatorState=this.getBusy();this.iInitialBusyIndicatorDelay=this.getBusyIndicatorDelay();this._bOnItemsLoadedScheduled=false;this._bDoTypeAhead=true;this.getArrowIcon().addEventDelegate({onmousedown:function(E){this._bShouldClosePicker=this.isOpen();}},this);this.getArrowIcon().attachPress(this._handlePopupOpenAndItemsLoad.bind(this,true,this));this.fnFilter=null;var i=new M(function(p){var s=p.mutation;var r=p.child;var E={"remove":"detachEvent","insert":"attachEvent"};var t={"remove":"handleItemRemoval","insert":"handleItemInsertion"};if(!r[E[s]]||!this[t[s]]){return;}r[E[s]]("_change",this.onItemChange,this);this.setRecreateItems(true);this[t[s]](r);}.bind(this));i.observe(this,{aggregations:["items"]});};
o.prototype.handleItemRemoval=function(i){};
o.prototype.handleItemInsertion=function(i){};
o.prototype.setRecreateItems=function(r){this._bRecreateItems=r;};
o.prototype.getRecreateItems=function(){return this._bRecreateItems;};
o.prototype.onBeforeRendering=function(){var s=this.isOpen(),v=s?this._getSuggestionsPopover()._getValueStateHeader().getText():null,V=s?this._getSuggestionsPopover()._getValueStateHeader().getValueState():null;C.prototype.onBeforeRendering.apply(this,arguments);if(s&&((this.getValueStateText()&&v!==this.getValueStateText())||(this.getValueState()!==V)||this.getFormattedValueStateText())){this._updateSuggestionsPopoverValueState();}if(this.getShowClearIcon()){this._getClearIcon().setVisible(this.shouldShowClearIcon());}else if(this._oClearIcon){this._getClearIcon().setVisible(false);}};
o.prototype._handlePopupOpenAndItemsLoad=function(O,i){var p;if(!this.getEnabled()||!this.getEditable()){return;}if(O&&this._getItemsShownWithFilter()){this._bShouldClosePicker=false;this.toggleIconPressedStyle(true);this.bOpenedByKeyboardOrButton=false;this.clearFilter();this._setItemsShownWithFilter(false);return;}if(this._bShouldClosePicker){this._bShouldClosePicker=false;this.close();return;}this.loadItems();this.bOpenedByKeyboardOrButton=O;if(this.isPlatformTablet()){this.syncPickerContent();p=this.getPicker();p.setInitialFocus(p);}if(i){p=this.getPicker();p&&p.setInitialFocus(i);}this.open();};
o.prototype.exit=function(){C.prototype.exit.apply(this,arguments);this._oRb=null;if(this._getGroupHeaderInvisibleText()){this._getGroupHeaderInvisibleText().destroy();this._oGroupHeaderInvisibleText=null;}if(this._oSuggestionPopover){this._oSuggestionPopover.destroy();this._oSuggestionPopover=null;}clearTimeout(this.iLoadItemsEventInitialProcessingTimeoutID);this.aMessageQueue=null;this.fnFilter=null;};
o.prototype.onsapshow=function(E){if(!this.getEnabled()||!this.getEditable()){return;}E.setMarked();if(E.keyCode===K.F4){this.onF4(E);}if(this._getItemsShownWithFilter()){this.loadItems(this._handlePopupOpenAndItemsLoad.bind(this,true));return;}if(this.isOpen()){this.close();return;}this.selectText(0,this.getValue().length);this.loadItems();this.bOpenedByKeyboardOrButton=true;this.open();};
o.prototype.onF4=function(E){E.preventDefault();};
o.prototype.onsapescape=function(E){if(this.getEnabled()&&this.getEditable()&&this.isOpen()){E.setMarked();E.preventDefault();this.close();}else{C.prototype.onsapescape.apply(this,arguments);}};
o.prototype.onsaphide=o.prototype.onsapshow;
o.prototype.onsapfocusleave=function(E){if(!E.relatedControlId){C.prototype.onsapfocusleave.apply(this,arguments);return;}var r=sap.ui.getCore().byId(E.relatedControlId);if(r===this){return;}var p=this.getPicker(),F=r&&r.getFocusDomRef();if(p&&d(p.getFocusDomRef(),F)){return;}C.prototype.onsapfocusleave.apply(this,arguments);};
o.prototype.getPopupAnchorDomRef=function(){return this.getDomRef();};
o.prototype.addContent=function(p){};
o.prototype.getList=function(){L.warning("[Warning]:","You are attempting to use deprecated method 'getList()', please refer to SAP note 2746748.",this);return this._getList();};
o.prototype._getList=function(){var i=this._oSuggestionPopover&&this._oSuggestionPopover.getItemsContainer();if(this.bIsDestroyed||!i){return null;}return i;};
o.prototype.setPickerType=function(p){this._sPickerType=p;};
o.prototype.getPickerType=function(){return this._sPickerType;};
o.prototype._updateSuggestionsPopoverValueState=function(){var s=this._getSuggestionsPopover();if(!s){return;}var v=this.getValueState(),N=this.getValueState()!==s._getValueStateHeader().getValueState(),i=this.getFormattedValueStateText(),V=this.getValueStateText(),p=i||N;if(s.isOpen()&&!p){this.setFormattedValueStateText(s._getValueStateHeader().getFormattedText());}s.updateValueState(v,(i||V),this.getShowValueStateMessage());};
o.prototype.shouldValueStateMessageBeOpened=function(){var s=C.prototype.shouldValueStateMessageBeOpened.apply(this,arguments);return(s&&!this.isOpen());};
o.prototype.onPropertyChange=function(i,p){var N=i.getParameter("newValue"),s=i.getParameter("name"),r="set"+s.charAt(0).toUpperCase()+s.slice(1),t=(p&&p.srcControl)||this.getPickerTextField();if(this.getInputForwardableProperties().indexOf(s)>-1&&t&&(typeof t[r]==="function")){t[r](N);}};
o.prototype.getInputForwardableProperties=function(){return n;};
o.prototype.isPickerDialog=function(){return this.getPickerType()==="Dialog";};
o.prototype.isPlatformTablet=function(){var N=!D.system.combi,t=D.system.tablet&&N;return t;};
o.prototype.getDropdownSettings=function(){return{showArrow:false,placement:P.VerticalPreferredBottom,offsetX:0,offsetY:0,bounce:false,ariaLabelledBy:this.getPickerInvisibleTextId()||undefined};};
o.prototype._configureList=function(){};
o.prototype.createPicker=function(p){var i=this.getAggregation("picker");if(i){return i;}this._oSuggestionPopover=this._createSuggestionsPopover();i=this._oSuggestionPopover.getPopover();this.setAggregation("picker",i,true);this.configPicker(i);return i;};
o.prototype.configPicker=function(p){};
o.prototype._hasShowSelectedButton=function(){return false;};
o.prototype._createSuggestionsPopover=function(){var s=new S(this);s.decorateParent(this);s.createSuggestionPopup(this,{showSelectedButton:this._hasShowSelectedButton()});this._decoratePopupInput(s.getInput());s.initContent(this.getId());this.forwardEventHandlersToSuggPopover(s);this._configureList(s.getItemsContainer());return s;};
o.prototype.forwardEventHandlersToSuggPopover=function(s){s.setOkPressHandler(this._handleOkPress.bind(this));s.setCancelPressHandler(this._handleCancelPress.bind(this));s.setInputLabels(this.getLabels.bind(this));};
o.prototype._handleOkPress=function(){var t=this,T=t.getPickerTextField();t.updateDomValue(T.getValue());t.onChange();t.close();};
o.prototype._handleCancelPress=function(){this.close();this.revertSelection();};
o.prototype.setSelectable=function(i,s){if(this.indexOfItem(i)<0){return;}i._bSelectable=s;var p=j.getListItem(i);if(p){p.setVisible(s);}};
o.prototype.onBeforeOpen=function(){this._updateSuggestionsPopoverValueState();if(!this._getItemsShownWithFilter()){this.toggleIconPressedStyle(true);}};
o.prototype.onBeforeClose=function(){this.bOpenedByKeyboardOrButton=false;this._setItemsShownWithFilter(false);this._updateSuggestionsPopoverValueState();};
o.prototype.getPicker=function(){var p=this.getAggregation("picker");if(p&&!p.bIsDestroyed&&!this.bIsDestroyed){return p;}return null;};
o.prototype._getSuggestionsPopover=function(){return this._oSuggestionPopover;};
o.prototype.getValueStateLinks=function(){var H=this.getPicker()&&this.getPicker().getCustomHeader()&&typeof this.getPicker().getCustomHeader().getFormattedText==="function",F=H&&this.getPicker().getCustomHeader().getFormattedText(),v=F&&F.getControls();return v||[];};
o.prototype.getPickerTextField=function(){var s=this._getSuggestionsPopover();return s?s.getInput():null;};
o.prototype.getPickerTitle=function(){var p=this.getPicker(),H=p&&p.getCustomHeader();if(this.isPickerDialog()&&H){return H.getContentMiddle()[0];}return null;};
o.prototype.revertSelection=function(){};
o.prototype.hasContent=function(){return this.getItems().length>0;};
o.prototype.syncPickerContent=function(){};
o.prototype.open=function(){var p=this.getPicker();if(p){p.open();}return this;};
o.prototype.getVisibleItems=function(){return j.getVisibleItems(this.getItems());};
o.prototype.isItemSelected=function(){};
o.prototype.getKeys=function(p){p=p||this.getItems();for(var i=0,r=[];i<p.length;i++){r[i]=p[i].getKey();}return r;};
o.prototype.findItem=function(p,v){var s="get"+p.charAt(0).toUpperCase()+p.slice(1);for(var i=0,r=this.getItems();i<r.length;i++){if(r[i][s]()===v){return r[i];}}return null;};
o.prototype.getItemByText=function(t){return this.findItem("text",t);};
o.prototype.clearFilter=function(){this.getItems().forEach(function(i){var p=j.getListItem(i);if(p){p.setVisible(i.getEnabled()&&this.getSelectable(i));}},this);};
o.prototype.onItemChange=function(i,s){g({item:i.getSource(),propName:i.getParameter("name"),propValue:i.getParameter("newValue")},s);};
o.prototype.clearSelection=function(){};
o.prototype.setInternalBusyIndicator=function(B){this.bInitialBusyIndicatorState=this.getBusy();return this.setBusy.apply(this,arguments);};
o.prototype.setInternalBusyIndicatorDelay=function(i){this.iInitialBusyIndicatorDelay=this.getBusyIndicatorDelay();return this.setBusyIndicatorDelay.apply(this,arguments);};
o.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
o.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
o.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
o.prototype.getEnabledItems=function(i){return j.getEnabledItems(i||this.getItems());};
o.prototype.getItemByKey=function(s){return this.findItem("key",s);};
o.prototype.addItemGroup=function(G,H,s){H=H||new b({text:c.escapeSettingsValue(G.text)||c.escapeSettingsValue(G.key)});this.addAggregation("items",H,s);if(this._getList()&&H.isA("sap.ui.core.SeparatorItem")){this._getList().addItem(this._mapItemToListItem(H));}return H;};
o.prototype.isOpen=function(){var p=this.getPicker();return!!(p&&p.isOpen());};
o.prototype.close=function(){var p=this.getPicker();if(p){p.close();}return this;};
o.prototype.intersectItems=function(i,O){return i.filter(function(p){return O.map(function(r){return r.getId();}).indexOf(p.getId())!==-1;});};
o.prototype.showItems=function(F){var i=this.fnFilter,p=function(){if(!this.getItems().length){return;}this.detachLoadItems(p);this.setFilterFunction(F||function(){return true;});this.applyShowItemsFilters();this._handlePopupOpenAndItemsLoad(false,this);this.setFilterFunction(i);}.bind(this);if(!this.getEnabled()||!this.getEditable()){return;}this._setItemsShownWithFilter(true);this.attachLoadItems(p);this.loadItems(p);};
o.prototype.applyShowItemsFilters=function(){};
return o;});
sap.ui.predefine('sap/m/ComboBoxBaseRenderer',['./ComboBoxTextFieldRenderer','sap/ui/core/Renderer','sap/ui/core/Core'],function(C,R,a){"use strict";var b=R.extend(C);b.apiVersion=2;b.CSS_CLASS_COMBOBOXBASE="sapMComboBoxBase";
b.getAccessibilityState=function(c){var A=C.getAccessibilityState.call(this,c),l=c._getList();if(l){A.controls=l.getId();}return A;};
b.addOuterClasses=function(r,c){C.addOuterClasses.apply(this,arguments);var d=b.CSS_CLASS_COMBOBOXBASE;r.class(d);if(!c.getEnabled()){r.class(d+"Disabled");}if(!c.getEditable()){r.class(d+"Readonly");}};
b.addButtonClasses=function(r,c){C.addButtonClasses.apply(this,arguments);r.class(b.CSS_CLASS_COMBOBOXBASE+"Arrow");};
return b;},true);
sap.ui.predefine('sap/m/ComboBoxRenderer',['./ComboBoxBaseRenderer','sap/ui/core/Renderer','sap/m/inputUtils/ListHelpers'],function(C,R,L){"use strict";var a=R.extend(C);a.apiVersion=2;a.CSS_CLASS_COMBOBOX="sapMComboBox";
a.addOuterClasses=function(r,c){C.addOuterClasses.apply(this,arguments);r.class(a.CSS_CLASS_COMBOBOX);};
a.addInnerClasses=function(r,c){C.addInnerClasses.apply(this,arguments);r.class(a.CSS_CLASS_COMBOBOX+"Inner");};
a.addButtonClasses=function(r,c){C.addButtonClasses.apply(this,arguments);r.class(a.CSS_CLASS_COMBOBOX+"Arrow");};
a.addPlaceholderClasses=function(r,c){C.addPlaceholderClasses.apply(this,arguments);r.class(a.CSS_CLASS_COMBOBOX+"Placeholder");};
a.writeInnerAttributes=function(r,c){var o=c.isOpen(),i,s,l;var S=c._getSuggestionsPopover();C.writeInnerAttributes.apply(this,arguments);r.attr("aria-expanded",o);if(!S){return;}var f=S.getFocusedListItem();var v=S.getValueStateActiveState();if(!o||(!f&&!v)){return;}if(v){r.attr("aria-activedescendant",c._getFormattedValueStateText().getId());return;}i=(f.isA("sap.m.GroupHeaderListItem")||f.isA("sap.ui.core.SeparatorItem"));s=c.getSelectedItem();l=s&&L.getListItem(s);f=i?f:l;if(f){r.attr("aria-activedescendant",f.getId());}};
return a;},true);
sap.ui.predefine('sap/m/ComboBoxTextField',['./InputBase','./library','sap/ui/core/InvisibleText','sap/ui/core/library','sap/ui/Device','sap/ui/core/LabelEnablement',"./ComboBoxTextFieldRenderer"],function(I,l,a,c,D,L,C){"use strict";
var b=I.extend("sap.m.ComboBoxTextField",{metadata:{library:"sap.m",properties:{maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},showButton:{type:"boolean",group:"Appearance",defaultValue:true}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
b.prototype.init=function(){I.prototype.init.apply(this,arguments);this._oArrowIcon=this.addEndIcon({id:this.getId()+"-arrow",src:"sap-icon://slim-arrow-down",noTabStop:true,alt:r.getText("COMBOBOX_BUTTON"),decorative:false});};
b.prototype.getArrowIcon=function(){return this._oArrowIcon;};
b.prototype.getIcon=b.prototype.getArrowIcon;
b.prototype.toggleIconPressedStyle=function(s){this.toggleStyleClass(I.ICON_PRESSED_CSS_CLASS,s);};
b.prototype.onBeforeRendering=function(){I.prototype.onBeforeRendering.apply(this,arguments);var R=L.getReferencingLabels(this)||[],i=this.getArrowIcon();i.setVisible(this.getShowButton());R.forEach(function(s){if(i.getAriaLabelledBy().indexOf(s)===-1){i.addAssociation("ariaLabelledBy",s,true);}},this);};
b.prototype.getOpenArea=function(){var d=this.getArrowIcon().getDomRef();return d?d.parentNode:d;};
b.prototype.onsapenter=function(e){I.prototype.onsapenter.apply(this,arguments);if(!this.getEnabled()||!this.getEditable()){return;}this._bCheckDomValue&&e.setMarked();var v=this.getValue(),V=v.length;this.setValue(v);this.selectText(V,V);};
b.prototype.getValue=function(){var d=this.getFocusDomRef();if(d){return d.value;}return this.getProperty("value");};
b.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef();};
b.prototype.getAccessibilityInfo=function(){var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.type=r.getText("ACC_CTR_TYPE_COMBO");return i;};
b.prototype.exit=function(){I.prototype.exit.apply(this,arguments);this._oArrowIcon=null;};
return b;});
sap.ui.predefine('sap/m/ComboBoxTextFieldRenderer',['./InputBaseRenderer','sap/ui/core/Renderer','sap/ui/core/LabelEnablement','sap/ui/Device'],function(I,R,L,D){"use strict";var C=R.extend(I);C.apiVersion=2;C.CSS_CLASS_COMBOBOXTEXTFIELD="sapMComboBoxTextField";
C.writeInnerAttributes=function(r,c){r.attr("role","combobox");r.attr("aria-haspopup","listbox");r.attr("aria-autocomplete","both");r.attr("aria-expanded","false");r.attr("autocomplete","off");r.attr("autocorrect","off");r.attr("autocapitalize","off");r.attr("type","text");};
C.getAriaRole=function(){};
C.addOuterStyles=function(r,c){r.style("max-width",c.getMaxWidth());};
return C;},true);
sap.ui.predefine('sap/m/CustomDynamicDateOption',['sap/m/DynamicDateOption'],function(D){"use strict";
var C=D.extend("sap.m.CustomDynamicDateOption",{metadata:{library:"sap.m",properties:{getText:{type:"function"},getValueHelpUITypes:{type:"function"},createValueHelpUI:{type:"function"},validateValueHelpUI:{type:"function"},getValueHelpOutput:{type:"function"},getGroup:{type:"function"},getGroupHeader:{type:"function"},format:{type:"function"},parse:{type:"function"},toDates:{type:"function"},enhanceFormattedValue:{type:"function"}}}});
function c(s){return s.charAt(0).toUpperCase()+s.slice(1);}
["getText","getValueHelpUITypes","createValueHelpUI","getValueHelpOutput","validateValueHelpUI","getGroup","getGroupHeader","format","parse","toDates","enhanceFormattedValue"].forEach(function(f){C.prototype[f]=function(){var g="get"+c(f);var a=this[g]();return a?a.apply(this,arguments):D.prototype[f].apply(this,arguments);};});
C.prototype.getGroupHeader=function(){if((this.getGroup()<7&&this.getGroup()>-1)||!this.getGetGroupHeader()){return D.prototype.getGroupHeader.apply(this,arguments);}else{return this.getGetGroupHeader().apply(this,arguments);}};
return C;});
sap.ui.predefine('sap/m/CustomListItem',['./ListItemBase','./library','./CustomListItemRenderer'],function(L,l,C){"use strict";
var a=L.extend("sap.m.CustomListItem",{metadata:{library:"sap.m",defaultAggregation:"content",properties:{accDescription:{tpye:"string",group:"Behavior"}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}},designtime:"sap/m/designtime/CustomListItem.designtime"}});
a.prototype.setAccDescription=function(A){this.setProperty("accDescription",A,true);return this;};
a.prototype.getContentAnnouncement=function(){var A=this.getAccDescription();if(A){return A;}return this.getContent().map(function(c){return L.getAccessibilityText(c);}).join(" ").trim();};
return a;});
sap.ui.predefine('sap/m/CustomListItemRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer"],function(L,R){"use strict";var C=R.extend(L);C.apiVersion=2;
C.renderLIAttributes=function(r,l){r.class("sapMCLI");};
C.renderLIContent=function(r,l){l.getContent().forEach(r.renderControl,r);};
return C;},true);
sap.ui.predefine('sap/m/CustomTile',['./Tile','./library','./CustomTileRenderer'],function(T,l,C){"use strict";
var a=T.extend("sap.m.CustomTile",{metadata:{library:"sap.m",deprecated:true,designtime:"sap/m/designtime/CustomTile.designtime",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:false}}}});
return a;});
sap.ui.predefine('sap/m/CustomTileRenderer',['./TileRenderer','sap/ui/core/Renderer'],function(T,R){"use strict";var C=R.extend(T);C.apiVersion=2;
C.render=function(r,c){var t,v;r.openStart("div",c).attr("tabindex","0");r.class("sapMCustomTile");if(c._invisible){r.style("visibility","hidden");}if(c.getParent()instanceof sap.m.TileContainer){t=c.getParent();v=t._getVisibleTiles();r.accessibilityState(c,{role:"option",posinset:t._indexOfVisibleTile(c,v)+1,setsize:v.length});}r.openEnd();r.openStart("div",c.getId()+"-remove").class("sapMTCRemove").openEnd().close("div");r.openStart("div").class("sapMCustomTileContent").openEnd();this._renderContent(r,c);r.close("div").close("div");};
C._renderContent=function(r,t){r.renderControl(t.getContent());};
return C;},true);
sap.ui.predefine('sap/m/DatePicker',['sap/ui/thirdparty/jquery','sap/ui/Device',"sap/ui/core/Element",'./InputBase','./DateTimeField','./Button','./ResponsivePopover',"./ValueStateHeader",'sap/ui/core/date/UniversalDate','./library','sap/ui/core/Control','sap/ui/core/library',"./DatePickerRenderer","sap/base/util/deepEqual","sap/base/assert","sap/base/Log","sap/ui/core/IconPool","./InstanceManager","sap/ui/unified/Calendar","sap/ui/unified/DateRange",'sap/ui/unified/DateTypeRange',"sap/ui/unified/calendar/CustomMonthPicker","sap/ui/unified/calendar/CustomYearPicker","sap/ui/core/LabelEnablement","sap/ui/unified/library","sap/ui/dom/jquery/cursorPos"],function(q,D,E,I,a,B,R,V,U,l,C,c,b,d,e,L,f,g,h,j,k,m,n,o,u){"use strict";var p=c.CalendarType;var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
var s=a.extend("sap.m.DatePicker",{metadata:{library:"sap.m",properties:{displayFormatType:{type:"string",group:"Appearance",defaultValue:""},secondaryCalendarType:{type:"sap.ui.core.CalendarType",group:"Appearance",defaultValue:null},minDate:{type:"object",group:"Misc",defaultValue:null},maxDate:{type:"object",group:"Misc",defaultValue:null},showFooter:{type:"boolean",group:"Misc",defaultValue:false},showCurrentDateButton:{type:"boolean",group:"Behavior",defaultValue:false},hideInput:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{specialDates:{type:"sap.ui.core.Element",multiple:true,singularName:"specialDate"},_popup:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"}},associations:{legend:{type:"sap.ui.core.Control",multiple:false}},events:{navigate:{parameters:{dateRange:{type:"sap.ui.unified.DateRange"},afterPopupOpened:{type:"boolean"}}}},designtime:"sap/m/designtime/DatePicker.designtime",dnd:{draggable:false,droppable:true}}});
s.prototype.init=function(){a.prototype.init.apply(this,arguments);this._bIntervalSelection=false;this._bOnlyCalendar=true;this._bValid=true;this._oMinDate=new Date(1,0,1);this._oMinDate.setFullYear(1);this._oMaxDate=new Date(9999,11,31,23,59,59,999);var i=this.addEndIcon({id:this.getId()+"-icon",src:this.getIconSrc(),noTabStop:true,tooltip:r.getText("OPEN_PICKER_TEXT")});this._bShouldClosePicker=false;i.addEventDelegate({onmousedown:function(A){this._bShouldClosePicker=!!this.isOpen();}},this);i.attachPress(function(){this.toggleOpen(this._bShouldClosePicker);},this);};
s.prototype.isValidValue=function(){return this._bValid;};
s.prototype.isOpen=function(){return this._oPopup&&this._oPopup.isOpen();};
s.prototype.toggleOpen=function(O){if(this.getEditable()&&this.getEnabled()){if(O){t.call(this);}else{_.call(this);}}};
s.prototype.getIconSrc=function(){return f.getIconURI("appointment-2");};
s.prototype.exit=function(){I.prototype.exit.apply(this,arguments);if(this._oPopup){if(this._oPopup.isOpen()){this._oPopup.close();}delete this._oPopup;}if(this._getCalendar()){if(this._oCalendarAfterRenderDelegate){this._getCalendar().removeDelegate(this._oCalendarAfterRenderDelegate);}this._getCalendar().destroy();delete this._getCalendar();}if(this._iInvalidateCalendar){clearTimeout(this._iInvalidateCalendar);}this._sUsedDisplayPattern=undefined;this._sUsedDisplayCalendarType=undefined;this._oDisplayFormat=undefined;this._sUsedValuePattern=undefined;this._sUsedValueCalendarType=undefined;this._oValueFormat=undefined;};
s.prototype.invalidate=function(O){if(!O||O!=this._getCalendar()){C.prototype.invalidate.apply(this,arguments);this._iInvalidateCalendar=setTimeout(z.bind(this),0);}};
s.prototype.onBeforeRendering=function(){a.prototype.onBeforeRendering.apply(this,arguments);this._checkMinMaxDate();var i=this._getValueHelpIcon();if(i){i.setProperty("visible",this.getEditable(),true);}};
s.prototype.setDisplayFormat=function(i){this.setProperty("displayFormat",i);if(this._oCalendar){this._oCalendar.removeDelegate(this._oCalendarAfterRenderDelegate);this._oCalendar.destroy();this._oCalendar=null;this._createPopupContent();}return this;};
s.prototype.setWidth=function(W){return I.prototype.setWidth.call(this,W||"100%");};
s.prototype.getWidth=function(W){return this.getProperty("width")||"100%";};
s.prototype.applyFocusInfo=function(F){this._bFocusNoPopup=true;if(!D.support.touch||D.system.desktop){I.prototype.applyFocusInfo.apply(this,arguments);}};
s.prototype.onfocusin=function(i){if(!q(i.target).hasClass("sapUiIcon")){a.prototype.onfocusin.apply(this,arguments);}this._bFocusNoPopup=undefined;};
s.prototype.onsapshow=function(i){this.toggleOpen(this.isOpen());i.preventDefault();};
s.prototype.onsaphide=s.prototype.onsapshow;
s.prototype.onsappageup=function(i){var A=this._getCalendarConstructor().getMetadata().getName();i.preventDefault();if(A!="sap.ui.unified.Calendar"){return;}this._increaseDate(1,"day");};
s.prototype.onsappageupmodifiers=function(i){var A=this._getCalendarConstructor().getMetadata().getName();i.preventDefault();if(!i.ctrlKey&&i.shiftKey){if(A=="sap.ui.unified.internal.CustomYearPicker"){return;}this._increaseDate(1,"month");}else{this._increaseDate(1,"year");}};
s.prototype.onsappagedown=function(i){var A=this._getCalendarConstructor().getMetadata().getName();i.preventDefault();if(A!="sap.ui.unified.Calendar"){return;}this._increaseDate(-1,"day");};
s.prototype.onsappagedownmodifiers=function(i){var A=this._getCalendarConstructor().getMetadata().getName();i.preventDefault();if(!i.ctrlKey&&i.shiftKey){if(A=="sap.ui.unified.internal.CustomYearPicker"){return;}this._increaseDate(-1,"month");}else{this._increaseDate(-1,"year");}};
s.prototype.onkeypress=function(i){if(!i.charCode||i.metaKey||i.ctrlKey){return;}var F=this._getFormatter(true);var A=String.fromCharCode(i.charCode);if(A&&F.sAllowedCharacters&&F.sAllowedCharacters.indexOf(A)<0){i.preventDefault();}};
s.prototype._getValueHelpIcon=function(){var i=this.getAggregation("_endIcon");return i&&i[0];};
s.prototype._dateValidation=function(i){this._bValid=true;if(i&&(i.getTime()<this._oMinDate.getTime()||i.getTime()>this._oMaxDate.getTime())){this._bValid=false;e(this._bValid,"Date must be in valid range");}this.setProperty("dateValue",i);return i;};
s.prototype.setMinDate=function(i){if(!this._isValidDate(i)){throw new Error("Date must be a JavaScript date object; "+this);}if(d(this.getMinDate(),i)){return this;}if(i){var Y=i.getFullYear();if(Y<1||Y>9999){throw new Error("Date must be between 0001-01-01 and 9999-12-31; "+this);}this._oMinDate=new Date(i.getTime());var A=this.getDateValue();if(A&&A.getTime()<i.getTime()){this._bValid=false;this._bOutOfAllowedRange=true;L.warning("DateValue not in valid date range",this);}}else{this._oMinDate=new Date(1,0,1);this._oMinDate.setFullYear(1);}this.setProperty("minDate",i);if(this._getCalendar()){this._getCalendar().setMinDate(i);}this._oMinDate.setHours(0,0,0,0);return this;};
s.prototype.setMaxDate=function(i){if(!this._isValidDate(i)){throw new Error("Date must be a JavaScript date object; "+this);}if(d(this.getMaxDate(),i)){return this;}if(i){var Y=i.getFullYear();if(Y<1||Y>9999){throw new Error("Date must be between 0001-01-01 and 9999-12-31; "+this);}this._oMaxDate=new Date(i.getTime());var A=this.getDateValue();if(A&&A.getTime()>i.getTime()){this._bValid=false;this._bOutOfAllowedRange=true;L.warning("DateValue not in valid date",this);}}else{this._oMaxDate=new Date(9999,11,31,23,59,59,999);}this.setProperty("maxDate",i);if(this._getCalendar()){this._getCalendar().setMaxDate(i);}this._oMaxDate.setHours(23,59,59,999);return this;};
s.prototype.setCurrentDateButton=function(S){var i=this._getCalendar();i&&i.setCurrentDateButton(S);return this.setProperty("showCurrentDateButton",S);};
s.prototype._checkMinMaxDate=function(){if(this._oMinDate.getTime()>this._oMaxDate.getTime()){L.warning("minDate > MaxDate -> dates switched",this);var M=new Date(this._oMinDate.getTime());var i=new Date(this._oMaxDate.getTime());this._oMinDate=new Date(i.getTime());this._oMaxDate=new Date(M.getTime());this.setProperty("minDate",i,true);this.setProperty("maxDate",M,true);if(this._getCalendar()){this._getCalendar().setMinDate(i);this._getCalendar().setMaxDate(M);}}var A=this.getDateValue();if(A&&(A.getTime()<this._oMinDate.getTime()||A.getTime()>this._oMaxDate.getTime())){this._bValid=false;L.error("dateValue "+A.toString()+"(value="+this.getValue()+") does not match "+"min/max date range("+this._oMinDate.toString()+" - "+this._oMaxDate.toString()+"). App. "+"developers should take care to maintain dateValue/value accordingly.",this);}};
s.prototype.getDisplayFormatType=function(){return this.getProperty("displayFormatType");};
s.prototype._handleDateValidation=function(i){this._bValid=true;if(!i||i.getTime()<this._oMinDate.getTime()||i.getTime()>this._oMaxDate.getTime()){this._bValid=false;L.warning("Value can not be converted to a valid date",this);}var A=this._formatValue(i,true);if(A!==this.getValue()){this.setLastValue(A);}this.setProperty("value",A);this.setProperty("dateValue",i);};
s.prototype.setDisplayFormatType=function(i){if(i){var F=false;for(var T in p){if(T==i){F=true;break;}}if(!F){throw new Error(i+" is not a valid calendar type"+this);}}this.setProperty("displayFormatType",i,true);this.setDisplayFormat(this.getDisplayFormat());return this;};
s.prototype.setSecondaryCalendarType=function(i){this._bSecondaryCalendarTypeSet=true;this.setProperty("secondaryCalendarType",i,true);if(this._getCalendar()){this._getCalendar().setSecondaryCalendarType(i);}return this;};
s.prototype.setShowFooter=function(F){var P=this._oPopup,i=this._getCalendar();this.setProperty("showFooter",F);if(!P||!i){return this;}P._getButtonFooter().setVisible(F);return this;};
s.prototype.addSpecialDate=function(S){y.call(this,S);this.addAggregation("specialDates",S,true);z.call(this);return this;};
s.prototype.insertSpecialDate=function(S,i){y.call(this,S);this.insertAggregation("specialDates",S,i,true);z.call(this);return this;};
s.prototype.removeSpecialDate=function(S){var i=this.removeAggregation("specialDates",S,true);z.call(this);return i;};
s.prototype.removeAllSpecialDates=function(){var i=this.removeAllAggregation("specialDates",true);z.call(this);return i;};
s.prototype.destroySpecialDates=function(){this.destroyAggregation("specialDates",true);z.call(this);return this;};
s.prototype.setLegend=function(i){this.setAssociation("legend",i,true);var A=this.getLegend();if(A){var F=sap.ui.require("sap/ui/unified/CalendarLegend");i=sap.ui.getCore().byId(A);if(i&&!(typeof F=="function"&&i instanceof F)){throw new Error(i+" is not an sap.ui.unified.CalendarLegend. "+this);}}if(this._getCalendar()){this._getCalendar().setLegend(A);}return this;};
s.prototype.onChange=function(i){if(!this.getEditable()||!this.getEnabled()){return;}var A=this._$input.val(),O=this._formatValue(this.getDateValue()),F;if(A==O&&this._bValid){return;}if(this.getShowFooter()&&this._oPopup&&!A){this._oPopup.getBeginButton().setEnabled(false);}this._bValid=true;if(A!=""){F=this._parseValue(A,true);if(!F||F.getTime()<this._oMinDate.getTime()||F.getTime()>this._oMaxDate.getTime()){this._bValid=false;F=undefined;}else{A=this._formatValue(F);}}if(this.getDomRef()&&(this._$input.val()!==A)){this._$input.val(A);this._curpos=this._$input.cursorPos();}if(F){A=this._formatValue(F,true);}if(this.getLastValue()!==A||(F&&this.getDateValue()&&F.getFullYear()!==this.getDateValue().getFullYear())){this.setLastValue(A);this.setProperty("value",A,true);var N=this.getValue();if(this._bValid&&A==N){this.setProperty("dateValue",F,true);}A=N;if(this.isOpen()){if(this._bValid){F=this.getDateValue();}this._getCalendar().focusDate(F);var S=this._oDateRange.getStartDate();if((!S&&F)||(S&&F&&S.getTime()!=F.getTime())){this._oDateRange.setStartDate(new Date(F.getTime()));}else if(S&&!F){this._oDateRange.setStartDate(undefined);}}this.fireChangeEvent(A,{valid:this._bValid});}};
s.prototype._getInputValue=function(i){i=(typeof i=="undefined")?this._$input.val():i.toString();var A=this._parseValue(i,true);i=this._formatValue(A,true);return i;};
s.prototype.updateDomValue=function(i){if(this.isActive()&&(this._$input.val()!==i)){this._bCheckDomValue=true;i=(typeof i=="undefined")?this._$input.val():i.toString();this._curpos=this._$input.cursorPos();var A=this._parseValue(i,true);i=this._formatValue(A);this._$input.val(i);if(document.activeElement===this._$input[0]){this._$input.cursorPos(this._curpos);}}return this;};
function _(i){this._createPopup();this._createPopupContent();var A;var F=this.getBinding("value");if(F&&F.oType&&F.oType.oOutputFormat){A=F.oType.oOutputFormat.oFormatOptions.calendarType;}else if(F&&F.oType&&F.oType.oFormat){A=F.oType.oFormat.oFormatOptions.calendarType;}if(!A){A=this.getDisplayFormatType();}if(A){this._getCalendar().setPrimaryCalendarType(A);}var G=this._bValid?this._formatValue(this.getDateValue()):this.getValue();if(G!=this._$input.val()){this.onChange();}this._fillDateRange();this._openPopup(i);this.fireNavigate({dateRange:this._getVisibleDatesRange(this._getCalendar()),afterPopupOpened:true});}
s.prototype._createPopup=function(){var T="";if(!this._oPopup){this._oPopup=new R(this.getId()+"-RP",{showCloseButton:false,showArrow:false,showHeader:false,placement:l.PlacementType.VerticalPreferedBottom,contentWidth:this.$().closest(".sapUiSizeCompact").length>0?"18rem":"21rem",beginButton:new B({type:l.ButtonType.Emphasized,text:r.getText("DATEPICKER_SELECTION_CONFIRM"),press:this._handleOKButton.bind(this)}),afterOpen:v.bind(this),afterClose:w.bind(this)}).addStyleClass("sapMRPCalendar");if(this.getShowFooter()){this._oPopup.addStyleClass("sapMLandscapePadding");}this._oPopup._getPopup().setAutoClose(true);if(D.system.phone){T=o.getReferencingLabels(this).concat(this.getAriaLabelledBy()).reduce(function(A,i){var F=E.registry.get(i);return A+" "+(F.getText?F.getText():"");},"").trim();this._oPopup.setTitle(T);this._oPopup.setShowHeader(true);this._oPopup.setShowCloseButton(true);}else{this._oPopup._getPopup().setDurations(0,0);this._oPopup.setEndButton(new B({text:r.getText("DATEPICKER_SELECTION_CANCEL"),press:this._handleCancelButton.bind(this)}));}this.setAggregation("_popup",this._oPopup,true);}};
s.prototype._openPopup=function(i){if(!this._oPopup){return;}if(!i){i=this.getDomRef();}this._oPopup._getPopup().setAutoCloseAreas([i]);this._oPopup.openBy(i||this);};
s.prototype.openBy=function(i){_.call(this,i);};
s.prototype._getVisibleDatesRange=function(i){var A=i._getVisibleDays();return new j({startDate:A[0].toLocalJSDate(),endDate:A[A.length-1].toLocalJSDate()});};
s.prototype._createPopupContent=function(){var i=this._getCalendarConstructor();if(!this._getCalendar()){this._oCalendar=new i(this.getId()+"-cal",{intervalSelection:this._bIntervalSelection,minDate:this.getMinDate(),maxDate:this.getMaxDate(),legend:this.getLegend(),startDateChange:function(){this.fireNavigate({dateRange:this._getVisibleDatesRange(this._getCalendar())});}.bind(this)});this._oCalendar.setShowCurrentDateButton(this.getShowCurrentDateButton());this._oDateRange=new j();this._getCalendar().addSelectedDate(this._oDateRange);this._getCalendar()._setSpecialDatesControlOrigin(this);this._getCalendar().attachCancel(t,this);this._getCalendar().setPopupMode(true);if(this.$().closest(".sapUiSizeCompact").length>0){this._getCalendar().addStyleClass("sapUiSizeCompact");}if(this._bSecondaryCalendarTypeSet){this._getCalendar().setSecondaryCalendarType(this.getSecondaryCalendarType());}if(this._bOnlyCalendar){this._getCalendar().attachSelect(this._handleCalendarSelect,this);this._getCalendar().attachEvent("_renderMonth",x,this);this._oPopup._getButtonFooter().setVisible(this.getShowFooter());this._getCalendar()._bSkipCancelButtonRendering=true;if(!this._oPopup.getContent().length){var H=this._getValueStateHeader();this._oPopup.addContent(this._getValueStateHeader());H.setPopup(this._oPopup._oControl);}this._oPopup.addContent(this._getCalendar());if(!this.getDateValue()){this._oPopup.getBeginButton().setEnabled(false);}}this._attachAfterRenderingDelegate();}};
s.prototype._attachAfterRenderingDelegate=function(){this._oCalendarAfterRenderDelegate={onAfterRendering:function(){var P=this._oPopup&&this._oPopup._getPopup();P&&P._oLastPosition&&P._applyPosition(P._oLastPosition);if(this._oPopup.isOpen()){this._oCalendar.focus();}}.bind(this)};this._oCalendar.addDelegate(this._oCalendarAfterRenderDelegate);};
s.prototype._getCalendarConstructor=function(){var P=this._getFormatter(true).aFormatArray.map(function(A){return A.type.toLowerCase();}),i=P.indexOf("day")>=0,M=P.indexOf("month")>=0||P.indexOf("monthstandalone")>=0,Y=P.indexOf("year")>=0;if(i&&M&&Y){return h;}else if(M&&Y){return m;}else if(Y){return n;}else{L.warning("Not valid date pattern! Default Calendar constructor function is returned",this);return h;}};
s.prototype._fillDateRange=function(){var i=this.getDateValue();if(i&&i.getTime()>=this._oMinDate.getTime()&&i.getTime()<=this._oMaxDate.getTime()){this._getCalendar().focusDate(new Date(i.getTime()));if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!=i.getTime()){this._oDateRange.setStartDate(new Date(i.getTime()));}}else{var A=this.getInitialFocusedDateValue();var F=A?A:new Date();var M=this._oMaxDate.getTime();if(F.getTime()<this._oMinDate.getTime()||F.getTime()>M){F=this._oMinDate;}this._getCalendar().focusDate(F);if(this._oDateRange.getStartDate()){this._oDateRange.setStartDate(undefined);}}};
s.prototype.getAccessibilityInfo=function(){var i=this.getRenderer();var A=I.prototype.getAccessibilityInfo.apply(this,arguments);var F=this.getValue()||"";if(this._bValid){var G=this.getDateValue();if(G){F=this._formatValue(G);}}A.type=r.getText("ACC_CTR_TYPE_DATEINPUT");A.description=[F,i.getLabelledByAnnouncement(this),i.getDescribedByAnnouncement(this)].join(" ").trim();return A;};
s.prototype._selectDate=function(){var i=this.getDateValue(),A=this._getSelectedDate(),F="";if(!d(A,i)){this.setDateValue(new Date(A.getTime()));F=this.getValue();this.fireChangeEvent(F,{valid:true});this._focusInput();}else if(!this._bValid){F=this._formatValue(A);if(F!=this._$input.val()){this._bValid=true;if(this.getDomRef()){this._$input.val(F);this.setLastValue(F);}F=this._formatValue(A,true);this.setProperty("value",F,true);this.fireChangeEvent(F,{valid:true});this._focusInput();}}else if(D.system.desktop||!D.support.touch){this.focus();}this._oPopup.close();};
s.prototype._handleCalendarSelect=function(){if(this.getShowFooter()){this._oPopup.getBeginButton().setEnabled(true);return;}this._selectDate();};
s.prototype._focusInput=function(){if(this.getDomRef()&&(D.system.desktop||!D.support.touch)){this._curpos=this._$input.val().length;this._$input.cursorPos(this._curpos);}return this;};
s.prototype._getCalendar=function(){return this._oCalendar;};
s.prototype._getSelectedDate=function(){var S=this._getCalendar().getSelectedDates(),i;if(S.length>0){i=S[0].getStartDate();}return i;};
s.prototype._handleOKButton=function(){this._selectDate();};
s.prototype._handleCancelButton=function(){if(!this.getDateValue()){this._oPopup.getBeginButton().setEnabled(false);}this._oPopup.close();};
function t(i){if(this.isOpen()){this._oPopup.close();if((D.system.desktop||!D.support.touch)){this.focus();}}}
s.prototype._increaseDate=function(N,i){var O=this.getDateValue();var A=this._$input.cursorPos();if(O&&this.getEditable()&&this.getEnabled()){var F;var G=this.getBinding("value");if(G&&G.oType&&G.oType.oOutputFormat){F=G.oType.oOutputFormat.oFormatOptions.calendarType;}else if(G&&G.oType&&G.oType.oFormat){F=G.oType.oFormat.oFormatOptions.calendarType;}if(!F){F=this.getDisplayFormatType();}var H=U.getInstance(new Date(O.getTime()),F);O=U.getInstance(new Date(O.getTime()),F);switch(i){case"day":H.setDate(H.getDate()+N);break;case"month":H.setMonth(H.getMonth()+N);var M=(O.getMonth()+N)%12;if(M<0){M=12+M;}while(H.getMonth()!=M){H.setDate(H.getDate()-1);}break;case"year":H.setFullYear(H.getFullYear()+N);while(H.getMonth()!=O.getMonth()){H.setDate(H.getDate()-1);}break;default:break;}if(H.getTime()<this._oMinDate.getTime()){H=new U(this._oMinDate.getTime());}else if(H.getTime()>this._oMaxDate.getTime()){H=new U(this._oMaxDate.getTime());}if(!d(this.getDateValue(),H.getJSDate())){this.setDateValue(new Date(H.getTime()));this._curpos=A;this._$input.cursorPos(this._curpos);var J=this.getValue();this.fireChangeEvent(J,{valid:true});}}};
s.prototype._getSpecialDates=function(){var A=this.getSpecialDates();for(var i=0;i<A.length;i++){var N=A[i].getSecondaryType()===u.CalendarDayType.NonWorking&&A[i].getType()!==u.CalendarDayType.NonWorking;if(N){var F=new k();F.setType(A[i].getSecondaryType());F.setStartDate(A[i].getStartDate());if(A[i].getEndDate()){F.setEndDate(A[i].getEndDate());}A.push(F);}}return A;};
function v(){this.addStyleClass(I.ICON_PRESSED_CSS_CLASS);this._renderedDays=this._getCalendar().$("-Month0-days").find(".sapUiCalItem").length;this.$("inner").attr("aria-owns",this.getId()+"-cal");this.$("inner").attr("aria-expanded",true);g.addPopoverInstance(this._oPopup);this._oCalendar.focus();}
function w(){if(!this.getDateValue()){this._oPopup.getBeginButton().setEnabled(false);}this.removeStyleClass(I.ICON_PRESSED_CSS_CLASS);this.$("inner").attr("aria-expanded",false);this._getCalendar()._closePickers();g.removePopoverInstance(this._oPopup);}
function x(i){var A=i.getParameter("days"),P=this._oPopup._getPopup();if(A>this._renderedDays){this._renderedDays=A;P._applyPosition(P._oLastPosition);}}
function y(S){var k=sap.ui.require("sap/ui/unified/DateTypeRange");if(S&&!(k&&S instanceof k)){throw new Error(S+"is not valid for aggregation \"specialDates\" of "+this);}}
function z(){if(this.isOpen()){this._getCalendar()._bDateRangeChanged=false;this._getCalendar().invalidate();}}
return s;});
sap.ui.predefine('sap/m/DatePickerRenderer',['sap/ui/core/Renderer','./InputBaseRenderer','sap/ui/core/library'],function(R,I,c){"use strict";var D=R.extend(I);D.apiVersion=2;
D.writeInnerValue=function(r,d){if(d._bValid||d._bOutOfAllowedRange){r.attr("value",d._formatValue(d.getDateValue()));}else{r.attr("value",d.getValue());}};
D.writeInnerAttributes=function(r,d){r.attr("type","text");if(d._bMobile){r.attr("readonly","readonly");}};
D.getAriaRole=function(d){return"combobox";};
D.getAccessibilityState=function(d){var a=I.getAccessibilityState.apply(this,arguments);a["roledescription"]=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_DATEINPUT");a["autocomplete"]="none";a["haspopup"]=c.aria.HasPopup.Grid.toLowerCase();a["expanded"]=false;a["disabled"]=null;if(d._bMobile&&d.getEnabled()&&d.getEditable()){a["readonly"]=false;}return a;};
D.addOuterClasses=function(r,C){if(C.getHideInput()){r.class("sapMDatePickerHiddenInput");}I.addOuterClasses.apply(this,arguments);};
return D;},true);
sap.ui.predefine('sap/m/DateRangeSelection',['sap/ui/Device','./DatePicker','./library','sap/ui/core/LocaleData','sap/ui/core/format/DateFormat','sap/ui/core/date/UniversalDate','./DateRangeSelectionRenderer',"sap/ui/unified/calendar/CustomMonthPicker","sap/ui/unified/calendar/CustomYearPicker","sap/base/util/deepEqual","sap/base/Log","sap/base/assert","sap/ui/dom/jquery/cursorPos"],function(D,a,l,L,b,U,c,C,d,f,g,h){"use strict";
var j=a.extend("sap.m.DateRangeSelection",{metadata:{library:"sap.m",properties:{delimiter:{type:"string",group:"Misc",defaultValue:'-'},secondDateValue:{type:"object",group:"Data",defaultValue:null},from:{type:"object",group:"Misc",defaultValue:null,deprecated:true},to:{type:"object",group:"Misc",defaultValue:null,deprecated:true}},designtime:"sap/m/designtime/DateRangeSelection.designtime",dnd:{draggable:false,droppable:true}}});
var H=String.fromCharCode(45),E=String.fromCharCode(8211),k=String.fromCharCode(8212);
j.prototype.init=function(){a.prototype.init.apply(this,arguments);this._bIntervalSelection=true;};
j.prototype._createPopupContent=function(){a.prototype._createPopupContent.apply(this,arguments);var e=this._getCalendar();if(e instanceof C){e._getMonthPicker().setIntervalSelection(true);}if(e instanceof d){e._getYearPicker().setIntervalSelection(true);}this._getCalendar().attachWeekNumberSelect(this._handleWeekSelect,this);this._getCalendar().getSelectedDates()[0].setStartDate(this._oDateRange.getStartDate());this._getCalendar().getSelectedDates()[0].setEndDate(this._oDateRange.getEndDate());};
j.prototype.onkeypress=function(e){if(!e.charCode||e.metaKey||e.ctrlKey){return;}var F=r.call(this);var i=q.call(this);var A=F.sAllowedCharacters+i+" ";var v=String.fromCharCode(e.charCode);if(v&&F.sAllowedCharacters&&A.indexOf(v)<0){e.preventDefault();}};
j.prototype._getPlaceholder=function(){var P=this.getPlaceholder(),B,e,i,v;if(!P){B=this.getBinding("value");i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();v=L.getInstance(i);if(B&&B.getType()instanceof sap.ui.model.type.DateInterval){e=B.getType();if(e.oFormatOptions&&e.oFormatOptions.format){P=v.getCustomDateTimePattern(e.oFormatOptions.format);}else{P=v.getDatePattern("medium");}}else{P=this.getDisplayFormat();if(!P){P="medium";}if(this._checkStyle(P)){P=v.getDatePattern(P);}}var w=q.call(this);if(w&&w!==""){P=P+" "+w+" "+P;}}return P;};
j.prototype.setValue=function(v){if(v!==this.getValue()){this.setLastValue(v);}else{return this;}this.setProperty("value",v);this._bValid=true;var e=[undefined,undefined];if(v){e=this._parseValue(v);if(!o.call(this,e[0],e[1])[0]){this._bValid=false;g.warning("Value can not be converted to a valid dates",this);}}this.setProperty("dateValue",_(e[0]));this.setProperty("secondDateValue",_(e[1]));if(this.getDomRef()){var O=this._formatValue(e[0],e[1]);if(this._$input.val()!==O){this._$input.val(O);this._curpos=this._$input.cursorPos();}}return this;};
function _(B){return(typeof B==='number')?new Date(B):B;}
function m(B){return(B&&B.getTime)?B.getTime():B;}
j.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);g.warning("Property valueFormat is not supported in sap.m.DateRangeSelection control.",this);return this;};
j.prototype.setDisplayFormat=function(e){a.prototype.setDisplayFormat.apply(this,arguments);var O=this._formatValue(this.getDateValue(),this.getSecondDateValue());this.setProperty("value",O,true);if(this.getDomRef()&&(this._$input.val()!==O)){this._$input.val(O);this._curpos=this._$input.cursorPos();}return this;};
j.prototype.setFrom=function(F){this.setDateValue(F);return this;};
j.prototype.getFrom=function(){return this.getDateValue();};
j.prototype.setTo=function(T){this.setSecondDateValue(T);return this;};
j.prototype.getTo=function(){return this.getSecondDateValue();};
j.prototype.setDateValue=function(e){if(!this._isValidDate(e)){throw new Error("Date must be a JavaScript date object; "+this);}if(f(this.getDateValue(),e)){return this;}a.prototype._dateValidation.call(this,e);this._syncDateObjectsToValue(e,this.getSecondDateValue());return this;};
j.prototype.setSecondDateValue=function(S){if(!this._isValidDate(S)){throw new Error("Date must be a JavaScript date object; "+this);}if(f(this.getSecondDateValue(),S)){return this;}this._bValid=true;if(S&&(S.getTime()<this._oMinDate.getTime()||S.getTime()>this._oMaxDate.getTime())){this._bValid=false;h(this._bValid,"Date must be in valid range");}this.setProperty("secondDateValue",S);this._syncDateObjectsToValue(this.getDateValue(),S);return this;};
j.prototype.setMinDate=function(e){a.prototype.setMinDate.apply(this,arguments);if(e){var S=this.getSecondDateValue();if(S&&S.getTime()<this._oMinDate.getTime()){g.warning("SecondDateValue not in valid date range",this);}}return this;};
j.prototype.setMaxDate=function(e){a.prototype.setMaxDate.apply(this,arguments);if(e){var S=this.getSecondDateValue();if(S&&S.getTime()>this._oMaxDate.getTime()){g.warning("SecondDateValue not in valid date range",this);}}return this;};
j.prototype._checkMinMaxDate=function(){a.prototype._checkMinMaxDate.apply(this,arguments);var S=this.getSecondDateValue();if(S&&(S.getTime()<this._oMinDate.getTime()||S.getTime()>this._oMaxDate.getTime())){g.error("secondDateValue "+S.toString()+"(value="+this.getValue()+") does not match "+"min/max date range("+this._oMinDate.toString()+" - "+this._oMaxDate.toString()+"). App. "+"developers should take care to maintain secondDateValue/value accordingly.",this);}};
j.prototype._parseValue=function(v){var F;var i=[];var w,x;var B=this.getBinding("value");if(B&&B.getType()instanceof sap.ui.model.type.DateInterval){try{i=B.getType().parseValue(v,"string");}catch(e){return[undefined,undefined];}if(B.getType().oFormatOptions&&B.getType().oFormatOptions.UTC){i=i.map(function(A){return new Date(A.getUTCFullYear(),A.getUTCMonth(),A.getUTCDate(),A.getUTCHours(),A.getUTCMinutes(),A.getUTCSeconds());});}return i;}var y=q.call(this);if(y&&v){v=v.trim();v=u(v,[y," "]);i=this._splitValueByDelimiter(v,y);if(i.length===2){if(i[0].slice(i[0].length-1,i[0].length)==" "){i[0]=i[0].slice(0,i[0].length-1);}if(i[1].slice(0,1)==" "){i[1]=i[1].slice(1);}}else{i=v.split(" "+y+" ");}if(v.indexOf(y)===-1){var z=v.split(" ");if(z.length===2){i=z;}}}if(v&&i.length<=2){F=r.call(this);if((!y||y==="")||i.length===1){w=F.parse(v);}else if(i.length===2){w=F.parse(i[0]);x=F.parse(i[1]);if(!w||!x){w=undefined;x=undefined;}}}return[w,x];};
j.prototype._splitValueByDelimiter=function(v,e){var w=[H,E,k],i;if(e){if(w.indexOf(e)===-1){return v.split(e);}}for(i=0;i<w.length;i++){if(v.indexOf(w[i])>0){return v.split(w[i]);}}return v?v.split(" "):[];};
j.prototype._formatValue=function(e,S){var v="",i=q.call(this),F,B,w,x;w=e;x=S;if(w){B=this.getBinding("value");if(B&&B.getType()instanceof sap.ui.model.type.DateInterval){if(B.getType().oFormatOptions&&B.getType().oFormatOptions.source&&B.getType().oFormatOptions.source.pattern==="timestamp"){v=B.getType().formatValue([m(e),m(S)],"string");}else{if(B.getType().oFormatOptions&&B.getType().oFormatOptions.UTC){w=new Date(Date.UTC(e.getFullYear(),e.getMonth(),e.getDate(),e.getHours(),e.getMinutes(),e.getSeconds()));if(S){x=new Date(Date.UTC(S.getFullYear(),S.getMonth(),S.getDate(),S.getHours(),S.getMinutes(),S.getSeconds()));}}v=B.getType().formatValue([w,x],"string");}}else{F=r.call(this);if(i&&i!==""&&x){v=F.format(w)+" "+i+" "+F.format(x);}else{v=F.format(w);}}}return v;};
j.prototype.onChange=function(){if(!this.getEditable()||!this.getEnabled()){return;}var v=this._$input.val();var e=[undefined,undefined];if(this.getShowFooter()&&this._oPopup&&!v){this._oPopup.getBeginButton().setEnabled(false);}this._bValid=true;if(v!=""){e=this._parseValue(v);e[1]&&e[1].setHours(23,59,59,999);e=o.call(this,e[0],e[1]);if(e[0]){v=this._formatValue(e[0],e[1]);}else{this._bValid=false;}}if(v!==this.getLastValue()){if(this.getDomRef()&&(this._$input.val()!==v)){this._$input.val(v);this._curpos=this._$input.cursorPos();}this.setLastValue(v);this.setProperty("value",v,true);if(this._bValid){this.setProperty("dateValue",_(e[0]),true);this.setProperty("secondDateValue",_(e[1]),true);}if(this._oPopup&&this._oPopup.isOpen()){var S=this.getDateValue();if(S){if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!==S.getTime()){this._oDateRange.setStartDate(new Date(S.getTime()));this._getCalendar().focusDate(S);}}else{if(this._oDateRange.getStartDate()){this._oDateRange.setStartDate(undefined);}}var i=this.getSecondDateValue();if(i){if(!this._oDateRange.getEndDate()||this._oDateRange.getEndDate().getTime()!==i.getTime()){this._oDateRange.setEndDate(new Date(i.getTime()));this._getCalendar().focusDate(i);}}else{if(this._oDateRange.getEndDate()){this._oDateRange.setEndDate(undefined);}}}n.call(this,this._bValid);}};
j.prototype._getInputValue=function(v){v=(typeof v=="undefined")?this._$input.val():v.toString();if(!v){return"";}var e=this._parseValue(v);v=this._formatValue(e[0],e[1]);return v;};
j.prototype.updateDomValue=function(v){this._bCheckDomValue=true;v=(typeof v=="undefined")?this._$input.val():v.toString();this._curpos=this._$input.cursorPos();var e=this._parseValue(v);v=this._formatValue(e[0],e[1]);if(this.isActive()&&(this._$input.val()!==v)){this._$input.val(v);this._$input.cursorPos(this._curpos);}return this;};
j.prototype._fillDateRange=function(){a.prototype._fillDateRange.apply(this,arguments);var e=this.getSecondDateValue();if(e&&e.getTime()>=this._oMinDate.getTime()&&e.getTime()<=this._oMaxDate.getTime()){if(!this._oDateRange.getEndDate()||this._oDateRange.getEndDate().getTime()!==e.getTime()){this._oDateRange.setEndDate(new Date(e.getTime()));}}else{if(this._oDateRange.getEndDate()){this._oDateRange.setEndDate(undefined);}}};
j.prototype._selectDate=function(){var S=this._getCalendar().getSelectedDates();if(S.length>0){var e=S[0].getStartDate();var i=S[0].getEndDate();if(e&&i){var v=this.getDateValue();var w=this.getSecondDateValue();i.setHours(23,59,59,999);var V;if(!f(e,v)||!f(i,w)){if(f(i,w)){this.setDateValue(e);}else{this.setProperty("dateValue",e,true);this.setSecondDateValue(i);}V=this.getValue();n.call(this,true);if(D.system.desktop||!D.support.touch){this._curpos=V.length;this._$input.cursorPos(this._curpos);}}else if(!this._bValid){V=this._formatValue(e,i);if(V!=this._$input.val()){this._bValid=true;if(this.getDomRef()){this._$input.val(V);}n.call(this,true);}}this._oDateRange.setStartDate(this._getCalendar().getSelectedDates()[0].getStartDate());this._oDateRange.setEndDate(this._getCalendar().getSelectedDates()[0].getEndDate());this._oPopup.close();}}};
j.prototype._handleCalendarSelect=function(){var S=this._getCalendar().getSelectedDates(),e=S[0].getStartDate(),i=S[0].getEndDate();if(this.getShowFooter()){this._oPopup.getBeginButton().setEnabled(!!(e&&i));return;}this._selectDate();};
j.prototype._handleWeekSelect=function(e){var S=e.getParameter("weekDays"),i=S.getStartDate(),v=S.getEndDate();if(this.getShowFooter()){this._oPopup.getBeginButton().setEnabled(!!(i&&v));return;}this._getCalendar().getSelectedDates()[0].setStartDate(i);this._getCalendar().getSelectedDates()[0].setEndDate(v);this._oDateRange.setStartDate(i);this._oDateRange.setEndDate(v);this._selectDate();};
j.prototype.getAccessibilityInfo=function(){var R=this.getRenderer();var i=a.prototype.getAccessibilityInfo.apply(this,arguments);var v=this.getValue()||"";if(this._bValid){var e=this.getDateValue();if(e){v=this._formatValue(e,this.getSecondDateValue());}}i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_DATERANGEINPUT");i.description=[v,R.getLabelledByAnnouncement(this),R.getDescribedByAnnouncement(this)].join(" ").trim();return i;};
j.prototype._syncDateObjectsToValue=function(e,S){var v=this._formatValue(e,S);if(v!==this.getValue()){this.setLastValue(v);}this.setProperty("value",v);if(this.getDomRef()){var O=this._formatValue(e,S);if(this._$input.val()!==O){this._$input.val(O);this._curpos=this._$input.cursorPos();}}};
function n(v){this.fireChangeEvent(this.getValue(),{from:this.getDateValue(),to:this.getSecondDateValue(),valid:v});}
function o(e,S){var F,i;if(e&&e.getTime){F=e.getTime();}else if(typeof e==='number'){F=e;}if(S&&S.getTime){i=S.getTime();}else if(typeof S==='number'){i=S;}if(e&&S&&F>i){var T=e;e=S;S=T;}if((e&&(F<this._oMinDate.getTime()||F>this._oMaxDate.getTime()))||(S&&(i<this._oMinDate.getTime()||i>this._oMaxDate.getTime()))){return[undefined,undefined];}else{return[e,S];}}
j.prototype._increaseDate=function(N,e){var v=this._$input.val(),i=this._parseValue(v),F=i[0],S=i[1],w=r.call(this),x=q.call(this),y,z,A,V,B,G,I;if(!F||!this.getEditable()||!this.getEnabled()){return;}if(!o.call(this,F,S)[0]){g.warning("Value can not be converted to a valid dates or dates are outside of the min/max range",this);this._bValid=false;n.call(this,this._bValid);return;}v=u(v,[x," "]);y=this._$input.cursorPos();z=F?w.format(F).length:0;A=S?w.format(S).length:0;V=v.length;B=y<=z+1;G=y>=V-A-1&&y<=V;if(B&&F){I=p.call(this,F,N,e);if(!f(this.getDateValue(),I.getJSDate())){this.setDateValue(new Date(I.getTime()));this._curpos=y;this._$input.cursorPos(this._curpos);this.fireChangeEvent(this.getValue(),{valid:this._bValid});}}else if(G&&S){I=p.call(this,S,N,e);if(!f(this.getSecondDateValue(),I.getJSDate())){this.setSecondDateValue(new Date(I.getTime()));this._curpos=y;this._$input.cursorPos(this._curpos);this.fireChangeEvent(this.getValue(),{valid:this._bValid});}}};
function p(O,N,e){var B=this.getBinding("value"),i,M,v,w;if(B&&B.oType&&B.oType.oOutputFormat){i=B.oType.oOutputFormat.oFormatOptions.calendarType;}else if(B&&B.oType&&B.oType.oFormat){i=B.oType.oFormat.oFormatOptions.calendarType;}if(!i){i=this.getDisplayFormatType();}v=U.getInstance(new Date(O.getTime()),i);w=v.getMonth();switch(e){case"day":v.setDate(v.getDate()+N);break;case"month":v.setMonth(v.getMonth()+N);M=(w+N)%12;if(M<0){M=12+M;}while(v.getMonth()!=M){v.setDate(v.getDate()-1);}break;case"year":v.setFullYear(v.getFullYear()+N);while(v.getMonth()!=w){v.setDate(v.getDate()-1);}break;default:break;}if(v.getTime()<this._oMinDate.getTime()){v=new U(this._oMinDate.getTime());}else if(v.getTime()>this._oMaxDate.getTime()){v=new U(this._oMaxDate.getTime());}return v;}
function q(){var e=this.getDelimiter();if(!e){if(!this._sLocaleDelimiter){var i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var v=L.getInstance(i);var P=v.getIntervalPattern();var I=P.indexOf("{0}")+3;var w=P.indexOf("{1}");e=P.slice(I,w);if(e.length>1){if(e.slice(0,1)==" "){e=e.slice(1);}if(e.slice(e.length-1,e.length)==" "){e=e.slice(0,e.length-1);}}this._sLocaleDelimiter=e;}else{e=this._sLocaleDelimiter;}}return e;}
function r(){var P=(this.getDisplayFormat()||"medium");var F;var e=this.getDisplayFormatType();if(P==this._sUsedDisplayPattern&&e==this._sUsedDisplayCalendarType){F=this._oDisplayFormat;}else{if(this._checkStyle(P)){F=b.getInstance({style:P,strictParsing:true,calendarType:e});}else{F=b.getInstance({pattern:P,strictParsing:true,calendarType:e});}this._sUsedDisplayPattern=P;this._sUsedDisplayCalendarType=e;this._oDisplayFormat=F;}return F;}
function s(v,e){return v&&e&&v.lastIndexOf(e)===v.length-e.length;}
function t(v,S){return v&&S&&v.indexOf(S)===0;}
function u(v,P){var i=0,T=P;if(!T){T=[" "];}while(i<T.length){if(s(v,T[i])){v=v.substring(0,v.length-T[i].length);i=0;continue;}i++;}i=0;while(i<T.length){if(t(v,T[i])){v=v.substring(T[i].length);i=0;continue;}i++;}return v;}
return j;});
sap.ui.predefine('sap/m/DateRangeSelectionRenderer',['sap/ui/core/Renderer','./DatePickerRenderer'],function(R,D){"use strict";var a=R.extend(D);a.apiVersion=2;
a.writeInnerValue=function(r,c){if(c._bValid){r.attr("value",c._formatValue(c.getDateValue(),c.getSecondDateValue()));}else{r.attr("value",c.getValue());}};
a.getAccessibilityState=function(d){var A=D.getAccessibilityState.apply(this,arguments);A["roledescription"]=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_DATERANGEINPUT");return A;};
return a;},true);
sap.ui.predefine('sap/m/DateTimeField',['sap/ui/model/type/Date','sap/ui/model/odata/type/ODataType','sap/ui/model/odata/type/DateTimeBase','./InputBase','./ValueStateHeader','sap/ui/core/Core','sap/ui/core/LocaleData','sap/ui/core/library','sap/ui/core/format/DateFormat','./DateTimeFieldRenderer',"sap/base/util/deepEqual","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos"],function(S,O,D,I,V,C,L,c,a,b,d,f,q){"use strict";var g=c.CalendarType;var h=c.ValueState;
var i=I.extend("sap.m.DateTimeField",{metadata:{"abstract":true,library:"sap.m",properties:{displayFormat:{type:"string",group:"Appearance",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},dateValue:{type:"object",group:"Data",defaultValue:null},initialFocusedDateValue:{type:"object",group:"Data",defaultValue:null}}}});
i.prototype.setValue=function(v){v=this.validateProperty("value",v);var o=this.getValue();if(v===o){return this;}else{this.setLastValue(v);}this.setProperty("value",v);this._bValid=true;var e;if(v){e=this._parseValue(v);if(!e||e.getTime()<this._oMinDate.getTime()||e.getTime()>this._oMaxDate.getTime()){this._bValid=false;f.warning("Value can not be converted to a valid date",this);}}this.setProperty("dateValue",e);if(this.getDomRef()){var s;if(e){s=this._formatValue(e);}else{s=v;}if(this._$input.val()!==s){this._$input.val(s);this._curpos=this._$input.cursorPos();}}return this;};
i.prototype.setDateValue=function(o){if(!this._isValidDate(o)){throw new Error("Date must be a JavaScript date object; "+this);}if(d(this.getDateValue(),o)){return this;}o=this._dateValidation(o);var v=this._formatValue(o,true);if(v!==this.getValue()){this.setLastValue(v);}this.setProperty("value",v);if(this.getDomRef()){var s=this._formatValue(o);if(this._$input.val()!==s){this._$input.val(s);this._curpos=this._$input.cursorPos();}}return this;};
i.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);var s=this.getValue();if(s){this._handleDateValidation(this._parseValue(s));}return this;};
i.prototype.setDisplayFormat=function(s){this.setProperty("displayFormat",s,true);this.updateDomValue(this._formatValue(this.getDateValue()));this.setPlaceholder(this._getPlaceholder());return this;};
i.prototype.getDisplayFormatType=function(){return null;};
i.prototype.onfocusin=function(e){if(!q(e.target).hasClass("sapUiIcon")){this.addStyleClass("sapMFocus");}if(!q(e.target).hasClass("sapMInputBaseIconContainer")&&!(this._oPopup&&this._oPopup.isOpen())){this.openValueStateMessage();}else if(this._oValueStateHeader){this._oValueStateHeader.setVisible(this.getValueState()!==h.None);}};
i.prototype._getValueStateHeader=function(){var v;if(!this._oValueStateHeader){v=this.getValueState();this._oValueStateHeader=new V({text:this._getTextForPickerValueStateContent(),valueState:v,visible:v!==h.None});}return this._oValueStateHeader;};
i.prototype._dateValidation=function(o){this._bValid=true;this.setProperty("dateValue",o);return o;};
i.prototype._handleDateValidation=function(o){this._bValid=true;this.setProperty("dateValue",o);};
i.prototype._getPlaceholder=function(){var p=this.getPlaceholder();if(!p){p=this._getDisplayFormatPattern();if(!p){p=this._getDefaultDisplayStyle();}if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}}return p;};
i.prototype._getLocaleBasedPattern=function(p){return L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getDatePattern(p);};
i.prototype._parseValue=function(v,j){var B=this.getBinding("value"),o=B&&B.getType&&B.getType(),F=this._getFormatter(j),k,l,m;if(o&&this._isSupportedBindingType(o)){try{m=o.parseValue(v,"string");if(typeof(m)==="string"&&o instanceof D){m=D.prototype.parseValue.call(o,v,"string");}k=o.oFormatOptions;if(k&&k.source&&k.source.pattern=="timestamp"){m=new Date(m);}else if(k&&k.source&&typeof k.source.pattern==="string"){m=o.oInputFormat.parse(v);}}catch(e){}if(m&&((o.oFormatOptions&&this._isFormatOptionsUTC(o.oFormatOptions))||(o.oConstraints&&o.oConstraints.isDateOnly))){l=new Date(m.getUTCFullYear(),m.getUTCMonth(),m.getUTCDate(),m.getUTCHours(),m.getUTCMinutes(),m.getUTCSeconds(),m.getUTCMilliseconds());l.setFullYear(m.getUTCFullYear());m=l;}return m;}return F.parse(v);};
i.prototype._formatValue=function(o,v){if(!o){return"";}var B=this.getBinding("value"),e=B&&B.getType&&B.getType(),F,j;if(e&&this._isSupportedBindingType(e)){if((e.oFormatOptions&&e.oFormatOptions.UTC)||(e.oConstraints&&e.oConstraints.isDateOnly)){j=new Date(Date.UTC(o.getFullYear(),o.getMonth(),o.getDate(),o.getHours(),o.getMinutes(),o.getSeconds(),o.getMilliseconds()));j.setUTCFullYear(o.getFullYear());o=j;}F=e.oFormatOptions;if(F&&F.source&&F.source.pattern=="timestamp"){o=o.getTime();}else if(e.oOutputFormat){return e.oOutputFormat.format(o);}return e.formatValue(o,"string");}return this._getFormatter(!v).format(o);};
i.prototype._isSupportedBindingType=function(B){return B.isA(["sap.ui.model.type.Date","sap.ui.model.odata.type.DateTime","sap.ui.model.odata.type.DateTimeOffset"]);};
i.prototype._isFormatOptionsUTC=function(B){return(B.UTC||(B.source&&B.source.UTC));};
i.prototype._getDefaultDisplayStyle=function(){return"medium";};
i.prototype._getDefaultValueStyle=function(){return"short";};
i.prototype._getFormatter=function(e){var p=this._getBoundValueTypePattern(),r=false,F,B=this.getBinding("value"),s;if(B&&B.oType&&B.oType.oOutputFormat){r=!!B.oType.oOutputFormat.oFormatOptions.relative;s=B.oType.oOutputFormat.oFormatOptions.calendarType;}if(!p){if(e){p=(this.getDisplayFormat()||this._getDefaultDisplayStyle());s=this.getDisplayFormatType();}else{p=(this.getValueFormat()||this._getDefaultValueStyle());s=g.Gregorian;}}if(!s){s=sap.ui.getCore().getConfiguration().getCalendarType();}if(e){if(p===this._sUsedDisplayPattern&&s===this._sUsedDisplayCalendarType){F=this._oDisplayFormat;}}else{if(p===this._sUsedValuePattern&&s===this._sUsedValueCalendarType){F=this._oValueFormat;}}if(F){return F;}return this._getFormatterInstance(F,p,r,s,e);};
i.prototype._getFormatterInstance=function(F,p,r,s,e){if(this._checkStyle(p)){F=this._getFormatInstance({style:p,strictParsing:true,relative:r,calendarType:s},e);}else{F=this._getFormatInstance({pattern:p,strictParsing:true,relative:r,calendarType:s},e);}if(e){this._sUsedDisplayPattern=p;this._sUsedDisplayCalendarType=s;this._oDisplayFormat=F;}else{this._sUsedValuePattern=p;this._sUsedValueCalendarType=s;this._oValueFormat=F;}return F;};
i.prototype._getFormatInstance=function(A,e){return a.getInstance(A);};
i.prototype._checkStyle=function(p){return(p==="short"||p==="medium"||p==="long"||p==="full");};
i.prototype._getDisplayFormatPattern=function(){var p=this._getBoundValueTypePattern();if(p){return p;}p=this.getDisplayFormat();if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}return p;};
i.prototype._getBoundValueTypePattern=function(){var B=this.getBinding("value"),o=B&&B.getType&&B.getType();if(o instanceof S){return o.getOutputPattern();}if(o instanceof O&&o.oFormat){return o.oFormat.oFormatOptions.pattern;}return undefined;};
i.prototype._isValidDate=function(o){return!o||Object.prototype.toString.call(o)==="[object Date]";};
i.prototype._getTextForPickerValueStateContent=function(){return this.getValueStateText()||this._getDefaultTextForPickerValueStateContent();};
i.prototype._getDefaultTextForPickerValueStateContent=function(){var v=this.getValueState(),r,t;if(v===h.None){t="";}else{r=C.getLibraryResourceBundle("sap.ui.core");t=r.getText("VALUE_STATE_"+v.toUpperCase());}return t;};
return i;});
sap.ui.predefine('sap/m/DateTimeFieldRenderer',['sap/ui/core/Renderer','./InputBaseRenderer'],function(R,I){"use strict";var D=R.extend(I);D.apiVersion=2;return D;},true);
sap.ui.predefine('sap/m/DateTimeInput',["sap/ui/thirdparty/jquery",'sap/ui/core/Control','./library','./DatePicker','./DateTimePicker','./TimePicker','sap/ui/model/type/Date','sap/ui/model/type/Time','sap/ui/model/type/DateTime','sap/ui/model/odata/type/ODataType','sap/ui/core/library','sap/ui/Device',"./DateTimeInputRenderer"],function(q,C,l,D,a,T,b,c,d,O,e,f,g){"use strict";var h=l.DateTimeInputType;var j=e.TextDirection;var k=e.TextAlign;var V=e.ValueState;
var m=C.extend("sap.m.DateTimeInput",{metadata:{library:"sap.m",deprecated:true,designtime:"sap/m/designtime/DateTimeInput.designtime",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},enabled:{type:"boolean",group:"Behavior",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:V.None},valueStateText:{type:"string",group:"Misc",defaultValue:null},showValueStateMessage:{type:"boolean",group:"Misc",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:k.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:j.Inherit},type:{type:"sap.m.DateTimeInputType",group:"Data",defaultValue:h.Date},displayFormat:{type:"string",group:"Appearance",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},dateValue:{type:"object",group:"Data",defaultValue:null}},aggregations:{_picker:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"string"},dateValue:{type:"object"},valid:{type:"boolean"}}}}}});
!(function(P,$,i){var r=l.getLocaleData();q.extend(P,{_types:{Date:{valueFormat:r.getDatePattern("short"),displayFormat:r.getDatePattern("medium")},Time:{valueFormat:r.getTimePattern("short"),displayFormat:r.getTimePattern("short")},DateTime:{valueFormat:r.getDateTimePattern("short"),displayFormat:r.getDateTimePattern("short")}}});["Time","Date"].forEach(function(t,s){["valueFormat","displayFormat"].forEach(function(F){var u=P._types;u.DateTime[F]=u.DateTime[F].replace("{"+s+"}",u[t][F]);});});}(m.prototype,q,f));
m.prototype.init=function(){this.setType(h.Date);};
m.prototype.onBeforeRendering=function(){o.call(this);};
m.prototype.getFocusDomRef=function(){var P=_.call(this);return P.getFocusDomRef();};
m.prototype.getIdForLabel=function(){var P=_.call(this);return P.getIdForLabel();};
function n(t){var P;switch(t){case h.DateTime:P=new a(this.getId()+"-Picker");break;case h.Time:P=new T(this.getId()+"-Picker",{localeId:sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()});break;default:P=new D(this.getId()+"-Picker");break;}P.setDisplayFormat(this.getDisplayFormat()||this._types[t].displayFormat);P.setValueFormat(this.getValueFormat()||this._types[t].valueFormat);if(this.getDateValue()){P.setDateValue(this.getDateValue());}P.setEnabled(this.getEnabled());P.setEditable(this.getEditable());P.setValueState(this.getValueState());P.setValueStateText(this.getValueStateText());P.setShowValueStateMessage(this.getShowValueStateMessage());P.setName(this.getName());P.setPlaceholder(this.getPlaceholder());P.setTextAlign(this.getTextAlign());P.setTextDirection(this.getTextDirection());P.setWidth("100%");P.attachChange(p,this);var A=this.getAriaLabelledBy();for(var i=0;i<A.length;i++){P.addAriaLabelledBy(A[i]);}return P;}
m.prototype.setType=function(t){if(t==this.getType()&&_.call(this)){return this;}this.destroyAggregation("_picker");var P=n.call(this,t);this.setAggregation("_picker",P);this.setProperty("type",t);return this;};
m.prototype.setWidth=function(w){this.setProperty("width",w);if(this.getDomRef()){w=this.getWidth();this.$().css("width",w);}return this;};
m.prototype.setValue=function(v){o.call(this);v=this.validateProperty("value",v);if(v.toLowerCase()=="now"){return this.setDateValue(new Date());}if(v===this.getValue()){return this;}this.setProperty("value",v,true);var P=_.call(this);P.setValue(v);var i=P.getDateValue();this.setProperty("dateValue",i,true);return this;};
m.prototype.setDateValue=function(i){if(!this._isValidDate(i)){throw new Error("Date must be a JavaScript date object; "+this);}o.call(this);this.setProperty("dateValue",i,true);var P=_.call(this);P.setDateValue(i);var v=P.getValue();this.setProperty("value",v,true);return this;};
m.prototype.setDisplayFormat=function(s){this.setProperty("displayFormat",s,true);var P=_.call(this);P.setDisplayFormat(s||this._types[this.getType()].displayFormat);return this;};
m.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);var P=_.call(this);P.setValueFormat(v||this._types[this.getType()].ValueFormat);return this;};
m.prototype.setEnabled=function(E){this.setProperty("enabled",E,true);var P=_.call(this);P.setEnabled(E);return this;};
m.prototype.setEditable=function(E){this.setProperty("editable",E,true);var P=_.call(this);P.setEditable(E);return this;};
m.prototype.setValueState=function(v){this.setProperty("valueState",v,true);var P=_.call(this);P.setValueState(v);return this;};
m.prototype.setValueStateText=function(v){this.setProperty("valueStateText",v,true);var P=_.call(this);P.setValueStateText(v);return this;};
m.prototype.setShowValueStateMessage=function(s){this.setProperty("showValueStateMessage",s,true);var P=_.call(this);P.setShowValueStateMessage(s);return this;};
m.prototype.setName=function(N){this.setProperty("name",N,true);var P=_.call(this);P.setName(N);return this;};
m.prototype.setPlaceholder=function(P){this.setProperty("placeholder",P,true);var i=_.call(this);i.setPlaceholder(P);return this;};
m.prototype.setTextAlign=function(t){this.setProperty("textAlign",t,true);var P=_.call(this);P.setTextAlign(t);return this;};
m.prototype.setTextDirection=function(t){this.setProperty("textDirection",t,true);var P=_.call(this);P.setTextDirection(t);return this;};
m.prototype.addAriaLabelledBy=function(i){this.addAssociation("ariaLabelledBy",i,true);var P=_.call(this);P.addAriaLabelledBy(i);return this;};
m.prototype.removeAriaLabelledBy=function(i){this.removeAssociation("ariaLabelledBy",i,true);var P=_.call(this);P.removeAriaLabelledBy(i);return this;};
m.prototype.removeAllAriaLabelledBy=function(){this.removeAssociation("ariaLabelledBy",true);var P=_.call(this);P.removeAllAriaLabelledBy();return this;};
m.prototype.getAccessibilityInfo=function(){var P=_.call(this);return P&&P.getAccessibilityInfo?P.getAccessibilityInfo():null;};
m.prototype._getPickerByTypeAndPattern=function(t,i,r){var R=/[DdYyMLWwGQUur]/,s=/[HhKkmsa]/,u=s.test(r),v=R.test(r),w=u&&!v,x=v&&!u,y=v&&u,N,z;switch(t){case h.Time:case h.Date:case h.DateTime:if(w&&i.getMetadata().getName()!=="sap.m.TimePicker"){N=h.Time;}else if(x&&i.getMetadata().getName()!=="sap.m.DatePicker"){N=h.Date;}else if(y&&i.getMetadata().getName()!=="sap.m.DateTimePicker"){N=h.DateTime;}break;default:{throw"Invalid type: "+t+". Expected is one of the sap.m.DateTimeInputType";}}if(N){this.destroyAggregation("_picker");z=n.call(this,N);this.setAggregation("_picker",z);}return z||i;};
m.prototype._getBoundValueTypePattern=function(){var B=this.getBinding("value"),i=B&&B.getType()&&B.getType();if(i instanceof b||i instanceof c||i instanceof d){return i.getOutputPattern();}if(i instanceof O&&i.oFormat){return i.oFormat.oFormatOptions.pattern;}return undefined;};
function _(){return this.getAggregation("_picker");}
m.prototype._isValidDate=function(i){return!i||Object.prototype.toString.call(i)==="[object Date]";};
function o(){if(this._getBoundValueTypePattern()){var P=this._getBoundValueTypePattern();var i=_.call(this);i=this._getPickerByTypeAndPattern(this.getType(),i,P);if(i.getValueFormat()!=P){i.setValueFormat(P);}if(i.getDisplayFormat()!=P){i.setDisplayFormat(P);}}}
function p(E){var v=E.getParameter("value");var i;var r=E.getParameter("valid");this.setProperty("value",v,true);if(r){i=E.oSource.getDateValue();this.setProperty("dateValue",i,true);}this.fireChange({value:v,newValue:v,valid:r,dateValue:i,newDateValue:i});}
return m;});
sap.ui.predefine('sap/m/DateTimeInputRenderer',[],function(){"use strict";var D={apiVersion:2};
D.render=function(r,c){r.openStart("div",c);r.class("sapMDTI");var w=c.getWidth();if(w){r.style("width",w);}r.openEnd();var p=c.getAggregation("_picker");if(p){r.renderControl(p);}r.close("div");};
return D;},true);
sap.ui.predefine('sap/m/DateTimePicker',["sap/ui/thirdparty/jquery",'./InputBase','./DatePicker','sap/ui/model/type/Date','sap/ui/unified/DateRange','./library','sap/ui/core/Control','sap/ui/Device','sap/ui/core/format/DateFormat','sap/ui/core/LocaleData','./TimePickerClocks','./DateTimePickerRenderer','./SegmentedButton','./SegmentedButtonItem','./ResponsivePopover','./Button',"sap/ui/events/KeyCodes","sap/ui/core/IconPool"],function(q,I,D,a,b,l,C,c,d,L,T,e,S,f,R,B,K,g){"use strict";var P=l.PlacementType,h=l.ButtonType,k="Phone";
var m=D.extend("sap.m.DateTimePicker",{metadata:{library:"sap.m",properties:{minutesStep:{type:"int",group:"Misc",defaultValue:1},secondsStep:{type:"int",group:"Misc",defaultValue:1},showCurrentTimeButton:{type:"boolean",group:"Behavior",defaultValue:false}},designtime:"sap/m/designtime/DateTimePicker.designtime",dnd:{draggable:false,droppable:true}}});
var n={Short:"short",Medium:"medium",Long:"long",Full:"full"};
var o=C.extend("sap.m.internal.DateTimePickerPopup",{
metadata:{library:"sap.m",aggregations:{_switcher:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},calendar:{type:"sap.ui.core.Control",multiple:false},clocks:{type:"sap.ui.core.Control",multiple:false}}},
renderer:{apiVersion:2,render:function(i,j){i.openStart("div",j);i.class("sapMDateTimePopupCont").class("sapMTimePickerDropDown");i.openEnd();var v=j.getAggregation("_switcher");if(v){i.openStart("div");i.class("sapMTimePickerSwitch");i.openEnd();i.renderControl(v);i.close("div");}var w=j.getCalendar();if(w){i.renderControl(w);}i.openStart("div");i.class("sapMTimePickerSep");i.openEnd();i.close("div");var x=j.getClocks();if(x){i.renderControl(x);}i.close("div");}},
init:function(){},
onBeforeRendering:function(){var i=this.getAggregation("_switcher");if(!i){var j=sap.ui.getCore().getLibraryResourceBundle("sap.m");var v=j.getText("DATETIMEPICKER_DATE");var w=j.getText("DATETIMEPICKER_TIME");i=new S(this.getId()+"-Switch",{selectedKey:"Cal",items:[new f(this.getId()+"-Switch-Cal",{key:"Cal",text:v}),new f(this.getId()+"-Switch-Clk",{key:"Clk",text:w})]});i.attachSelect(this._handleSelect,this);this.setAggregation("_switcher",i,true);}if(c.system.phone||q('html').hasClass("sapUiMedia-Std-Phone")){i.setVisible(true);i.setSelectedKey("Cal");}else{i.setVisible(false);}},
onAfterRendering:function(){if(c.system.phone||q('html').hasClass("sapUiMedia-Std-Phone")){var i=this.getAggregation("_switcher");var j=i.getSelectedKey();this._switchVisibility(j);}},
_handleSelect:function(E){var i=E.getParameter("key");this._switchVisibility(i);if(i==="Clk"){this.getClocks()._focusActiveButton();}},
_switchVisibility:function(i){var j=this.getCalendar(),v=this.getClocks();if(!j||!v){return;}if(i==="Cal"){j.$().css("display","");v.$().css("display","none");j.getFocusDomRef()&&j.getFocusDomRef().focus();}else{j.$().css("display","none");v.$().css("display","");}},
switchToTime:function(){var i=this.getAggregation("_switcher");if(i&&i.getVisible()){i.setSelectedKey("Clk");this._switchVisibility("Clk");}},
getSpecialDates:function(){return this._oDateTimePicker.getSpecialDates();},
onkeydown:function(E){var i=E.keyCode===K.TAB&&!E.shiftKey;var j=E.keyCode===K.TAB&&E.shiftKey;if(i){if(E.target.classList.contains('sapUiCalHeadToday')||(E.target.classList.contains('sapUiCalHeadBLast')&&!this._oDateTimePicker._oCalendar.getShowCurrentDateButton())){this.getAggregation('clocks').getDomRef().children[0].children[0].focus();}}if(j&&E.target.classList.contains('sapUiCalItem')){var v=this.oParent.getAggregation("footer").getAggregation("content").length-1;this.oParent.getAggregation("footer").getAggregation("content")[v].focus();}}
});
m.prototype.init=function(){D.prototype.init.apply(this,arguments);this._bOnlyCalendar=false;};
m.prototype.getIconSrc=function(){return g.getIconURI("date-time");};
m.prototype.exit=function(){D.prototype.exit.apply(this,arguments);if(this._oClocks){this._oClocks.destroy();delete this._oClocks;}this._oPopupContent=undefined;c.media.detachHandler(this._handleWindowResize,this);};
m.prototype.setDisplayFormat=function(i){D.prototype.setDisplayFormat.apply(this,arguments);if(this._oClocks){this._oClocks.setValueFormat(t.call(this));this._oClocks.setDisplayFormat(t.call(this));}return this;};
m.prototype.setMinutesStep=function(M){this.setProperty('minutesStep',M,true);if(this._oClocks){this._oClocks.setMinutesStep(M);}return this;};
m.prototype._getDefaultValueStyle=function(){return n.Medium;};
m.prototype.setMinDate=function(i){D.prototype.setMinDate.call(this,i);if(i){this._oMinDate.setHours(i.getHours(),i.getMinutes(),i.getSeconds());}return this;};
m.prototype.setMaxDate=function(i){D.prototype.setMaxDate.call(this,i);if(i){this._oMaxDate.setHours(i.getHours(),i.getMinutes(),i.getSeconds());}return this;};
m.prototype.setSecondsStep=function(i){this.setProperty('secondsStep',i,true);if(this._oClocks){this._oClocks.setSecondsStep(i);}return this;};
m.prototype.setShowCurrentTimeButton=function(i){var j=this._oClocks;j&&j.setShowCurrentTimeButton(i);return this.setProperty("showCurrentTimeButton",i);};
m.prototype._getFormatInstance=function(A,i){var M=q.extend({},A);var j=-1;if(M.style){j=M.style.indexOf("/");}if(i){var v=q.extend({},M);if(j>0){v.style=v.style.substr(0,j);}this._oDisplayFormatDate=d.getInstance(v);}return d.getDateTimeInstance(M);};
m.prototype._checkStyle=function(v){if(D.prototype._checkStyle.apply(this,arguments)){return true;}else if(v.indexOf("/")>0){var w=[n.Short,n.Medium,n.Long,n.Long];var x=false;for(var i=0;i<w.length;i++){var y=w[i];for(var j=0;j<w.length;j++){var z=w[j];if(v==y+"/"+z){x=true;break;}}if(x){break;}}return x;}return false;};
m.prototype._parseValue=function(v,i){var j=D.prototype._parseValue.apply(this,arguments);if(i&&!j){j=this._oDisplayFormatDate.parse(v);if(j){var O=this.getDateValue();if(!O){O=new Date();}j.setHours(O.getHours());j.setMinutes(O.getMinutes());j.setSeconds(O.getSeconds());j.setMilliseconds(O.getMilliseconds());}}return j;};
m.prototype._getLocaleBasedPattern=function(i){var j=L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()),v=i.indexOf("/");if(v>0){return j.getCombinedDateTimePattern(i.substr(0,v),i.substr(v+1));}else{return j.getCombinedDateTimePattern(i,i);}};
m.prototype._createPopup=function(){var i,j,v,O,w,x;if(!this._oPopup){v=sap.ui.getCore().getLibraryResourceBundle("sap.m");O=v.getText("TIMEPICKER_SET");w=v.getText("TIMEPICKER_CANCEL");this._oPopupContent=new o(this.getId()+"-PC");this._oPopupContent._oDateTimePicker=this;this._oOKButton=new B(this.getId()+"-OK",{text:O,type:h.Emphasized,press:_.bind(this)});var H=this._getValueStateHeader();this._oPopup=new R(this.getId()+"-RP",{showCloseButton:false,showHeader:false,placement:P.VerticalPreferedBottom,beginButton:this._oOKButton,content:[H,this._oPopupContent],afterOpen:r.bind(this),afterClose:s.bind(this)});H.setPopup(this._oPopup._oControl);if(c.system.phone){i=this.$("inner").attr("aria-labelledby");j=i?document.getElementById(i).getAttribute("aria-label"):"";this._oPopup.setTitle(j);this._oPopup.setShowHeader(true);this._oPopup.setShowCloseButton(true);}else{this._oPopup._getPopup().setDurations(0,0);this._oPopup.setEndButton(new B(this.getId()+"-Cancel",{text:w,press:p.bind(this)}));}this._oPopup.addStyleClass("sapMDateTimePopup");x=this._oPopup.getAggregation("_popup");if(x.setShowArrow){x.setShowArrow(false);}this.setAggregation("_popup",this._oPopup,true);}};
m.prototype._openPopup=function(i){if(!this._oPopup){return;}if(!i){i=this.getDomRef();}this.addStyleClass(I.ICON_PRESSED_CSS_CLASS);var j=this._oPopup.getAggregation("_popup");j.oPopup.setAutoCloseAreas([i]);this._oPopup.openBy(i||this);};
m.prototype._createPopupContent=function(){var N=!this._oCalendar;D.prototype._createPopupContent.apply(this,arguments);if(N){this._oPopupContent.setCalendar(this._oCalendar);this._oCalendar.attachSelect(u,this);}if(!this._oClocks){this._oClocks=new T(this.getId()+"-Clocks",{minutesStep:this.getMinutesStep(),secondsStep:this.getSecondsStep(),valueFormat:t.call(this),displayFormat:t.call(this),localeId:this.getLocaleId(),showCurrentTimeButton:this.getShowCurrentTimeButton()});this._oPopupContent.setClocks(this._oClocks);}};
m.prototype._attachAfterRenderingDelegate=function(){};
m.prototype._selectFocusedDateValue=function(i){var j=this._oCalendar;j.removeAllSelectedDates();j.addSelectedDate(i);return this;};
m.prototype._fillDateRange=function(){var i=this.getDateValue(),j=true;if(i){i=new Date(i.getTime());this._oOKButton.setEnabled(true);}else{j=false;i=this.getInitialFocusedDateValue();if(!i){i=new Date();this._oCalendar.removeAllSelectedDates();}var M=this._oMaxDate.getTime();if(i.getTime()<this._oMinDate.getTime()||i.getTime()>M){i=this._oMinDate;}this._oOKButton.setEnabled(false);}this._oCalendar.focusDate(i);if(j){if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!=i.getTime()){this._oDateRange.setStartDate(i);}}this._oClocks._setTimeValues(i);};
m.prototype._getSelectedDate=function(){var i=D.prototype._getSelectedDate.apply(this,arguments);if(i){var j=this._oClocks.getTimeValues();var v=this._oClocks._getDisplayFormatPattern();if(v.search("h")>=0||v.search("H")>=0){i.setHours(j.getHours());}if(v.search("m")>=0){i.setMinutes(j.getMinutes());}if(v.search("s")>=0){i.setSeconds(j.getSeconds());}if(i.getTime()<this._oMinDate.getTime()){i=new Date(this._oMinDate.getTime());}else if(i.getTime()>this._oMaxDate.getTime()){i=new Date(this._oMaxDate.getTime());}}return i;};
m.prototype.getLocaleId=function(){return sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();};
m.prototype.getAccessibilityInfo=function(){var i=D.prototype.getAccessibilityInfo.apply(this,arguments);i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_DATETIMEINPUT");return i;};
function _(E){this._handleCalendarSelect();}
function p(E){this.onsaphide(E);if(!this.getDateValue()){this._oCalendar.removeAllSelectedDates();}}
m.prototype._handleWindowResize=function(i){var j=this.getAggregation("_popup").getContent()[1].getAggregation("_switcher"),v=this.getAggregation("_popup").getContent()[1].getCalendar(),w=this.getAggregation("_popup").getContent()[1].getClocks();if(i.name===k){j.setVisible(true);this.getAggregation("_popup").getContent()[1]._switchVisibility(j.getSelectedKey());}else{j.setVisible(false);w.$().css("display","");v.$().css("display","");}};
function r(E){this.$("inner").attr("aria-expanded",true);this._oCalendar.focus();c.media.attachHandler(this._handleWindowResize,this);}
function s(){this.removeStyleClass(I.ICON_PRESSED_CSS_CLASS);this.$("inner").attr("aria-expanded",false);this._oCalendar._closePickers();c.media.detachHandler(this._handleWindowResize,this);}
function t(){var i=this.getDisplayFormat();var j;var v=this.getBinding("value");if(v&&v.oType&&(v.oType instanceof a)){i=v.oType.getOutputPattern();}else if(v&&v.oType&&v.oType.oFormat){i=v.oType.oFormat.oFormatOptions.pattern;}else{i=this.getDisplayFormat();}if(!i){i=n.Medium;}var w=i.indexOf("/");if(w>0&&this._checkStyle(i)){i=i.substr(w+1);}if(i==n.Short||i==n.Medium||i==n.Long||i==n.Full){var x=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var y=L.getInstance(x);j=y.getTimePattern(i);}else{j=i;}return j;}
function u(E){var i={onAfterRendering:function(){this._oPopupContent.getCalendar().getAggregation("month")[0].removeEventDelegate(i,this);this._oOKButton.setEnabled(true);this._oPopupContent.switchToTime();this._oPopupContent.getClocks()._focusActiveButton();}};this._oPopupContent.getCalendar().getAggregation("month")[0].addEventDelegate(i,this);}
return m;});
sap.ui.predefine('sap/m/DateTimePickerRenderer',['sap/ui/core/Renderer','./DatePickerRenderer','./InputBaseRenderer','sap/ui/core/library'],function(R,D,I,c){"use strict";var a=R.extend(D);a.apiVersion=2;
a.getDescribedByAnnouncement=function(d){var b=I.getDescribedByAnnouncement.apply(this,arguments);return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("DATETIMEPICKER_TYPE")+" "+b;};
a.getAccessibilityState=function(d){var A=D.getAccessibilityState.apply(this,arguments);A["haspopup"]=c.aria.HasPopup.Dialog.toLowerCase();return A;};
return a;},true);
sap.ui.predefine('sap/m/Dialog',["./Bar","./InstanceManager","./AssociativeOverflowToolbar","./ToolbarSpacer","./Title","./library","sap/m/Image","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/core/Popup","sap/ui/core/delegate/ScrollEnablement","sap/ui/core/RenderManager","sap/ui/core/InvisibleText","sap/ui/core/ResizeHandler","sap/ui/core/theming/Parameters","sap/ui/core/util/ResponsivePaddingsEnablement","sap/ui/Device","sap/ui/core/library","sap/ui/events/KeyCodes","./TitlePropagationSupport","./DialogRenderer","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/core/Core","sap/ui/core/Configuration","sap/ui/dom/units/Rem","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Focusable"],function(B,I,A,T,a,l,b,C,c,P,S,R,d,f,g,h,D,j,K,k,m,L,q,n,o,p){"use strict";var O=j.OpenState;var r=l.DialogType;var s=l.DialogRoleType;var V=j.ValueState;var t=j.TitleLevel;var u=l.TitleAlignment;var v=n.getConfiguration().getAnimationMode();var U=v!==o.AnimationMode.none&&v!==o.AnimationMode.minimal;var w=U?300:10;var x=17;var y=p.toPx(1);var H=5;var z=g.get({name:"_sap_m_Dialog_VerticalMargin",callback:function(e){z=parseFloat(e);}});if(z){z=parseFloat(z);}else{z=3;}
var E=C.extend("sap.m.Dialog",{metadata:{interfaces:["sap.ui.core.PopupInterface"],library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},title:{type:"string",group:"Appearance",defaultValue:null},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},type:{type:"sap.m.DialogType",group:"Appearance",defaultValue:r.Standard},state:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:V.None},stretchOnPhone:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},stretch:{type:"boolean",group:"Appearance",defaultValue:false},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},horizontalScrolling:{type:"boolean",group:"Behavior",defaultValue:true},verticalScrolling:{type:"boolean",group:"Behavior",defaultValue:true},resizable:{type:"boolean",group:"Behavior",defaultValue:false},draggable:{type:"boolean",group:"Behavior",defaultValue:false},escapeHandler:{type:"function",group:"Behavior",defaultValue:null},role:{type:"sap.m.DialogRoleType",group:"Data",defaultValue:s.Dialog,visibility:"hidden"},closeOnNavigation:{type:"boolean",group:"Behavior",defaultValue:true},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:u.Auto}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},subHeader:{type:"sap.m.IBar",multiple:false},customHeader:{type:"sap.m.IBar",multiple:false},beginButton:{type:"sap.m.Button",multiple:false},endButton:{type:"sap.m.Button",multiple:false},buttons:{type:"sap.m.Button",multiple:true,singularName:"button"},_header:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_icon:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_toolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"},_valueState:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}},associations:{leftButton:{type:"sap.m.Button",multiple:false,deprecated:true},rightButton:{type:"sap.m.Button",multiple:false,deprecated:true},initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{beforeOpen:{},afterOpen:{},beforeClose:{parameters:{origin:{type:"sap.m.Button"}}},afterClose:{parameters:{origin:{type:"sap.m.Button"}}}},designtime:"sap/m/designtime/Dialog.designtime"}});
h.call(E.prototype,{header:{suffix:"header"},subHeader:{selector:".sapMDialogSubHeader .sapMIBar"},content:{selector:".sapMDialogScrollCont"},footer:{suffix:"footer"}});k.call(E.prototype,"content",function(){return this._headerTitle?this._headerTitle.getId():false;});E._bPaddingByDefault=(n.getConfiguration().getCompatibilityVersion("sapMDialogWithPadding").compareTo("1.16")<0);
E._initIcons=function(){if(E._mIcons){return;}E._mIcons={};E._mIcons[V.Success]=c.getIconURI("sys-enter-2");E._mIcons[V.Warning]=c.getIconURI("alert");E._mIcons[V.Error]=c.getIconURI("error");E._mIcons[V.Information]=c.getIconURI("information");};
E.prototype.init=function(){var e=this;this._oManuallySetSize=null;this._oManuallySetPosition=null;this._bRTL=n.getConfiguration().getRTL();this._scrollContentList=["sap.m.NavContainer","sap.m.Page","sap.m.ScrollContainer","sap.m.SplitContainer","sap.m.MultiInput","sap.m.SimpleFixFlex"];this.oPopup=new P();this.oPopup.setShadow(true);this.oPopup.setNavigationMode("SCOPE");this.oPopup.setModal(true);this.oPopup.setAnimations(q.proxy(this._openAnimation,this),q.proxy(this._closeAnimation,this));this.oPopup._applyPosition=function(i,G){e._setDimensions();e._adjustScrollingPane();if(e._oManuallySetPosition){i.at={left:e._oManuallySetPosition.x,top:e._oManuallySetPosition.y};}else{i.at=e._calcPosition();}e._deregisterContentResizeHandler();P.prototype._applyPosition.call(this,i);e._registerContentResizeHandler();};if(E._bPaddingByDefault){this.addStyleClass("sapUiPopupWithPadding");}this._initTitlePropagationSupport();this._initResponsivePaddingsEnablement();};
E.prototype.onBeforeRendering=function(){var e=this._getAnyHeader();if(!E._bPaddingByDefault&&this.hasStyleClass("sapUiPopupWithPadding")){L.warning("Usage of CSS class 'sapUiPopupWithPadding' is deprecated. Use 'sapUiContentPadding' instead",null,"sap.m.Dialog");}if(this._hasSingleScrollableContent()){this.setVerticalScrolling(false);this.setHorizontalScrolling(false);L.info("VerticalScrolling and horizontalScrolling in sap.m.Dialog with ID "+this.getId()+" has been disabled because there's scrollable content inside");}else if(!this._oScroller){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:this.getHorizontalScrolling(),vertical:this.getVerticalScrolling()});}if(this._oScroller){this._oScroller.setVertical(this.getVerticalScrolling());this._oScroller.setHorizontal(this.getHorizontalScrolling());}this._createToolbarButtons();if(n.getConfiguration().getAccessibility()&&this.getState()!=V.None){var i=new d({text:this.getValueStateString(this.getState())});this.setAggregation("_valueState",i);this.addAriaLabelledBy(i.getId());}if(e&&e.setTitleAlignment){e.setProperty("titleAlignment",this.getTitleAlignment(),true);}if(e&&this._getTitles(e).length===0){e._setRootAccessibilityRole("heading");e._setRootAriaLevel("2");}};
E.prototype.onAfterRendering=function(){this._$scrollPane=this.$("scroll");this._$content=this.$("cont");this._$dialog=this.$();if(this.isOpen()){this._setInitialFocus();}};
E.prototype.exit=function(){I.removeDialogInstance(this);this._deregisterContentResizeHandler();this._deregisterResizeHandler();if(this.oPopup){this.oPopup.detachOpened(this._handleOpened,this);this.oPopup.detachClosed(this._handleClosed,this);this.oPopup.destroy();this.oPopup=null;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._header){this._header.destroy();this._header=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}if(this._toolbarSpacer){this._toolbarSpacer.destroy();this._toolbarSpacer=null;}};
E.prototype.open=function(){var e=this.oPopup;e.setInitialFocusId(this.getId());var i=e.getOpenState();switch(i){case O.OPEN:case O.OPENING:return this;case O.CLOSING:this._bOpenAfterClose=true;break;default:}this._oCloseTrigger=null;this.fireBeforeOpen();e.attachOpened(this._handleOpened,this);this._iLastWidthAndHeightWithScroll=null;e.setContent(this);e.open();this._registerResizeHandler();I.addDialogInstance(this);return this;};
E.prototype.close=function(){this._bOpenAfterClose=false;this.$().removeClass('sapDialogDisableTransition');this._deregisterResizeHandler();var e=this.oPopup;var i=this.oPopup.getOpenState();if(!(i===O.CLOSED||i===O.CLOSING)){l.closeKeyboard();this.fireBeforeClose({origin:this._oCloseTrigger});e.attachClosed(this._handleClosed,this);this._bDisableRepositioning=false;this._oManuallySetPosition=null;this._oManuallySetSize=null;e.close();this._deregisterContentResizeHandler();}return this;};
E.prototype.isOpen=function(){return!!this.oPopup&&this.oPopup.isOpen();};
E.prototype.setIcon=function(i){this._bHasCustomIcon=true;return this.setProperty("icon",i);};
E.prototype.setState=function(e){var i;this.setProperty("state",e);if(this._bHasCustomIcon){return this;}if(e===V.None){i="";}else{E._initIcons();i=E._mIcons[e];}this.setProperty("icon",i);return this;};
E.prototype._handleOpened=function(){this.oPopup.detachOpened(this._handleOpened,this);this._setInitialFocus();this.fireAfterOpen();};
E.prototype._handleClosed=function(){if(!this.oPopup){return;}this.oPopup.detachClosed(this._handleClosed,this);if(this.getDomRef()){R.preserveContent(this.getDomRef());this.$().remove();}I.removeDialogInstance(this);this.fireAfterClose({origin:this._oCloseTrigger});if(this._bOpenAfterClose){this._bOpenAfterClose=false;this.open();}};
E.prototype.onfocusin=function(e){var i=e.target;if(i.id===this.getId()+"-firstfe"){var G=this.$("footer").lastFocusableDomRef()||this.$("cont").lastFocusableDomRef()||(this.getSubHeader()&&this.getSubHeader().$().firstFocusableDomRef())||(this._getAnyHeader()&&this._getAnyHeader().$().lastFocusableDomRef());if(G){G.focus();}}else if(i.id===this.getId()+"-lastfe"){var J=this._getFocusableHeader()||(this._getAnyHeader()&&this._getAnyHeader().$().firstFocusableDomRef())||(this.getSubHeader()&&this.getSubHeader().$().firstFocusableDomRef())||this.$("cont").firstFocusableDomRef()||this.$("footer").firstFocusableDomRef();if(J){J.focus();}}};
E.prototype._getPromiseWrapper=function(){var e=this;return{reject:function(){e.currentPromise.reject();},resolve:function(){e.currentPromise.resolve();}};};
E.prototype.onsapescape=function(e){var i=this.getEscapeHandler(),G={},J=this;if(this._isSpaceOrEnterPressed){return;}if(e.originalEvent&&e.originalEvent._sapui_handledByControl){return;}this._oCloseTrigger=null;if(typeof i==='function'){new Promise(function(M,N){G.resolve=M;G.reject=N;J.currentPromise=G;i(J._getPromiseWrapper());}).then(function(M){J.close();}).catch(function(){L.info("Disallow dialog closing");});}else{this.close();}e.stopPropagation();};
E.prototype.onkeyup=function(e){if(this._isSpaceOrEnter(e)){this._isSpaceOrEnterPressed=false;}};
E.prototype.onkeydown=function(e){if(this._isSpaceOrEnter(e)){this._isSpaceOrEnterPressed=true;}this._handleKeyboardDragResize(e);};
E.prototype._handleKeyboardDragResize=function(e){if(e.target!==this._getFocusableHeader()||[K.ARROW_LEFT,K.ARROW_RIGHT,K.ARROW_UP,K.ARROW_DOWN].indexOf(e.keyCode)===-1){return;}if((!this.getResizable()&&e.shiftKey)||(!this.getDraggable()&&!e.shiftKey)){return;}var $=this._$dialog,i=this.getDomRef().getBoundingClientRect(),G={left:i.x,top:i.y},J=this._getAreaDimensions(),M=$.width(),N=$.height(),Q=$.outerHeight(true),W=e.shiftKey,X,Y;this._bDisableRepositioning=true;$.addClass('sapDialogDisableTransition');if(W){this._oManuallySetSize=true;this.$('cont').height('').width('');}switch(e.keyCode){case K.ARROW_LEFT:if(W){M-=y;}else{G.left-=y;}break;case K.ARROW_RIGHT:if(W){M+=y;}else{G.left+=y;}break;case K.ARROW_UP:if(W){N-=y;}else{G.top-=y;}break;case K.ARROW_DOWN:if(W){N+=y;}else{G.top+=y;}break;}if(W){Y=J.bottom-G.top-Q+N;if(e.keyCode===K.ARROW_DOWN){Y-=y;}X={width:Math.min(M,J.right-G.left),height:Math.min(N,Y)};}else{X={left:Math.min(Math.max(J.left,G.left),J.right-M),top:Math.min(Math.max(J.top,G.top),J.bottom-Q)};}$.css(X);};
E.prototype._isSpaceOrEnter=function(e){var i=e.which||e.keyCode;return i==K.SPACE||i==K.ENTER;};
E.prototype._openAnimation=function($,i,e){$.addClass("sapMDialogOpen");setTimeout(e,w);};
E.prototype._closeAnimation=function($,i,e){$.removeClass("sapMDialogOpen");setTimeout(e,w);};
E.prototype._setDimensions=function(){var $=this.$(),e=this.getStretch(),i=this.getStretchOnPhone()&&D.system.phone,M=this.getType()===r.Message,G={};if(!e){if(!this._oManuallySetSize){G.width=this.getContentWidth()||undefined;G.height=this.getContentHeight()||undefined;}else{G.width=this._oManuallySetSize.width;G.height=this._oManuallySetSize.height;}}if(G.width=='auto'){G.width=undefined;}if(G.height=='auto'){G.height=undefined;}if((e&&!M)||(i)){this.$().addClass('sapMDialogStretched');}$.css(G);if(!this._oManuallySetSize&&!this._bDisableRepositioning){this._positionDialog();}if(window.navigator.userAgent.toLowerCase().indexOf("chrome")!==-1&&this.getStretch()){$.find('> footer').css({bottom:'0.001px'});}};
E.prototype._adjustScrollingPane=function(){if(this._oScroller){this._oScroller.refresh();}};
E.prototype._onResize=function(){var $=this.$(),e=this.$('cont'),i=this.getContentWidth(),M=this._calcMaxSizes().maxWidth;if(this._oManuallySetSize){e.css({width:'auto'});return;}if(D.system.desktop&&!D.browser.chrome){var G=e.width()+"x"+e.height(),J=$.css("min-width")!==$.css("width");if(G!==this._iLastWidthAndHeightWithScroll&&J){if(this._hasVerticalScrollbar()&&(!i||i=='auto')&&!this.getStretch()&&e.width()<M){$.addClass("sapMDialogVerticalScrollIncluded");e.css({"padding-right":x});this._iLastWidthAndHeightWithScroll=G;}else{$.removeClass("sapMDialogVerticalScrollIncluded");e.css({"padding-right":""});this._iLastWidthAndHeightWithScroll=null;}}}if(!this._oManuallySetSize&&!this._bDisableRepositioning){this._positionDialog();}};
E.prototype._hasVerticalScrollbar=function(){var $=this.$('cont');return $[0].clientHeight<$[0].scrollHeight;};
E.prototype._positionDialog=function(){var $=this.$();$.css(this._calcMaxSizes());$.css(this._calcPosition());};
E.prototype._calcPosition=function(){var e=this._getAreaDimensions(),$=this.$(),i,G,J;if(D.system.phone&&this.getStretch()){i=0;G=0;}else if(this.getStretch()){i=this._percentOfSize(e.width,H);G=this._percentOfSize(e.height,z);}else{i=(e.width-$.outerWidth())/2;G=(e.height-$.outerHeight())/2;}J={top:Math.round(e.top+G)};J[this._bRTL?"right":"left"]=Math.round(e.left+i);return J;};
E.prototype._calcMaxSizes=function(){var e=this._getAreaDimensions(),$=this.$(),i=$.find(".sapMDialogTitle").height()||0,G=$.find(".sapMDialogSubHeader").height()||0,J=$.find("footer").height()||0,M=i+G+J,N,Q;if(D.system.phone&&this.getStretch()){Q=e.width;N=e.height-M;}else{Q=this._percentOfSize(e.width,100-2*H);N=this._percentOfSize(e.height,100-2*z)-M;}if(N<parseInt($.css("min-height"))){L.error("Height of Within Area is not enough to fit dialog");}if(Q<parseInt($.css("min-width"))){L.error("Width of Within Area is not enough to fit dialog");}return{maxWidth:Math.floor(Q),maxHeight:Math.floor(N)};};
E.prototype._getAreaDimensions=function(){var W=P.getWithinAreaDomRef(),e;if(W===window){e={left:0,top:0,width:W.innerWidth,height:W.innerHeight};}else{var i=W.getBoundingClientRect(),$=q(W);e={left:i.left+parseFloat($.css("border-left-width")),top:i.top+parseFloat($.css("border-top-width")),width:W.clientWidth,height:W.clientHeight};}e.right=e.left+e.width;e.bottom=e.top+e.height;return e;};
E.prototype._percentOfSize=function(i,e){return Math.round(i*e/100);};
E.prototype._createHeader=function(){if(!this._header){this._header=new B(this.getId()+"-header",{titleAlignment:this.getTitleAlignment()});this.setAggregation("_header",this._header);}};
E.prototype._applyTitleToHeader=function(){var e=this.getProperty("title");if(this._headerTitle){this._headerTitle.setText(e);}else{this._headerTitle=new a(this.getId()+"-title",{text:e,level:t.H2}).addStyleClass("sapMDialogTitle");this._header.addContentMiddle(this._headerTitle);}};
E.prototype._hasSingleScrollableContent=function(){var e=this.getContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA(this._scrollContentList)){return true;}return false;};
E.prototype._getFocusDomRef=function(){var i=this.getInitialFocus();if(i){return document.getElementById(i);}return this._getFocusableHeader()||this._getFirstFocusableContentSubHeader()||this._getFirstFocusableContentElement()||this._getFirstVisibleButtonDomRef()||this.getDomRef();};
E.prototype._getFirstVisibleButtonDomRef=function(){var e=this.getBeginButton(),G=this.getEndButton(),J=this.getButtons(),M;if(e&&e.getVisible()){M=e.getDomRef();}else if(G&&G.getVisible()){M=G.getDomRef();}else if(J&&J.length>0){for(var i=0;i<J.length;i++){if(J[i].getVisible()){M=J[i].getDomRef();break;}}}return M;};
E.prototype._getFocusableHeader=function(){if(!this._isDraggableOrResizable()){return null;}return this.$().find('header.sapMDialogTitle')[0];};
E.prototype._getFirstFocusableContentSubHeader=function(){var $=this.$().find('.sapMDialogSubHeader');return $.firstFocusableDomRef();};
E.prototype._getFirstFocusableContentElement=function(){var $=this.$("cont");return $.firstFocusableDomRef();};
E.prototype._setInitialFocus=function(){var e=this._getFocusDomRef(),i;if(e&&e.id){i=n.byId(e.id);}if(i){if(i.getVisible&&!i.getVisible()){this.focus();return;}e=i.getFocusDomRef();}if(!e){this.setInitialFocus("");e=this._getFocusDomRef();}if(!this.getInitialFocus()){this.setAssociation('initialFocus',e?e.id:this.getId(),true);}if(D.system.desktop||(e&&!/input|textarea|select/i.test(e.tagName))){if(e){e.focus();}}else{this.focus();}};
E.prototype.getScrollDelegate=function(){return this._oScroller;};
E.prototype._isToolbarEmpty=function(){var e=this._oToolbar.getContent().filter(function(i){return i.getMetadata().getName()!=='sap.m.ToolbarSpacer';});return e.length===0;};
E.prototype._getAnyHeader=function(){var e=this.getCustomHeader();if(e){return e;}else{var i=this.getShowHeader();if(!i){return null;}this._createHeader();this._applyTitleToHeader();this._applyIconToHeader();return this._header;}};
E.prototype._deregisterResizeHandler=function(){var W=P.getWithinAreaDomRef();if(W===window){D.resize.detachHandler(this._onResize,this);}else{f.deregister(this._withinResizeListenerId);this._withinResizeListenerId=null;}};
E.prototype._registerResizeHandler=function(){var W=P.getWithinAreaDomRef();if(W===window){D.resize.attachHandler(this._onResize,this);}else{this._withinResizeListenerId=f.register(W,this._onResize.bind(this));}this._onResize();};
E.prototype._deregisterContentResizeHandler=function(){if(this._sContentResizeListenerId){f.deregister(this._sContentResizeListenerId);this._sContentResizeListenerId=null;}};
E.prototype._registerContentResizeHandler=function(){if(!this._sContentResizeListenerId){this._sContentResizeListenerId=f.register(this.getDomRef("scrollCont"),q.proxy(this._onResize,this));}this._onResize();};
E.prototype._attachHandler=function(e){var i=this;if(!this._oButtonDelegate){this._oButtonDelegate={ontap:function(){i._oCloseTrigger=this;},onkeyup:function(){i._oCloseTrigger=this;},onkeydown:function(){i._oCloseTrigger=this;}};}if(e){e.addDelegate(this._oButtonDelegate,true,e);}};
E.prototype._createToolbarButtons=function(){var e=this._getToolbar();var i=this.getButtons();var G=this.getBeginButton();var J=this.getEndButton(),M=this,N=[G,J];N.forEach(function(Q){if(Q&&M._oButtonDelegate){Q.removeDelegate(M._oButtonDelegate);}});e.removeAllContent();if(!("_toolbarSpacer"in this)){this._toolbarSpacer=new T();}e.addContent(this._toolbarSpacer);N.forEach(function(Q){M._attachHandler(Q);});if(i&&i.length){i.forEach(function(Q){e.addContent(Q);});}else{if(G){e.addContent(G);}if(J){e.addContent(J);}}};
E.prototype._getToolbar=function(){if(!this._oToolbar){this._oToolbar=new A(this.getId()+"-footer").addStyleClass("sapMTBNoBorders");this._oToolbar.addDelegate({onAfterRendering:function(){if(this.getType()===r.Message){this.$("footer").removeClass("sapContrast sapContrastPlus");}}},false,this);this.setAggregation("_toolbar",this._oToolbar);}return this._oToolbar;};
E.prototype.getValueStateString=function(e){var i=n.getLibraryResourceBundle("sap.m");switch(e){case(V.Success):return i.getText("LIST_ITEM_STATE_SUCCESS");case(V.Warning):return i.getText("LIST_ITEM_STATE_WARNING");case(V.Error):return i.getText("LIST_ITEM_STATE_ERROR");case(V.Information):return i.getText("LIST_ITEM_STATE_INFORMATION");default:return"";}};
E.prototype._isDraggableOrResizable=function(){return!this.getStretch()&&(this.getDraggable()||this.getResizable());};
E.prototype.setSubHeader=function(e){this.setAggregation("subHeader",e);if(e){e.setVisible=function(i){e.setProperty("visible",i);this.invalidate();}.bind(this);}return this;};
E.prototype.setLeftButton=function(e){if(typeof e==="string"){e=n.byId(e);}this.setBeginButton(e);return this.setAssociation("leftButton",e);};
E.prototype.setRightButton=function(e){if(typeof e==="string"){e=n.byId(e);}this.setEndButton(e);return this.setAssociation("rightButton",e);};
E.prototype.getLeftButton=function(){var e=this.getBeginButton();return e?e.getId():null;};
E.prototype.getRightButton=function(){var e=this.getEndButton();return e?e.getId():null;};
E.prototype.setBeginButton=function(e){if(e&&e.isA("sap.m.Button")){e.addStyleClass("sapMDialogBeginButton");}return this.setAggregation("beginButton",e);};
E.prototype.setEndButton=function(e){if(e&&e.isA("sap.m.Button")){e.addStyleClass("sapMDialogEndButton");}return this.setAggregation("endButton",e);};
E.prototype.getAggregation=function(e,i,G){var J=C.prototype.getAggregation.apply(this,Array.prototype.slice.call(arguments,0,2));if(e==='buttons'&&J&&J.length===0){this.getBeginButton()&&J.push(this.getBeginButton());this.getEndButton()&&J.push(this.getEndButton());}return J;};
E.prototype.getAriaLabelledBy=function(){var e=this._getAnyHeader(),i=this.getAssociation("ariaLabelledBy",[]).slice();var G=this.getSubHeader();if(G){var J=this._getTitles(G);if(J.length){i=J.map(function(N){return N.getId();}).concat(i);}}if(e){var M=this._getTitles(e);if(M.length){i=M.map(function(N){return N.getId();}).concat(i);}else{i.unshift(e.getId());}}return i;};
E.prototype._applyIconToHeader=function(){var i=this.getIcon();if(!i){if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}return;}if(!this._iconImage){this._iconImage=c.createControlByURI({id:this.getId()+"-icon",src:i,useIconTooltip:false},b).addStyleClass("sapMDialogIcon");this._header.insertAggregation("contentMiddle",this._iconImage,0);}this._iconImage.setSrc(i);};
E.prototype.setInitialFocus=function(i){return this.setAssociation("initialFocus",i,true);};
E.prototype.invalidate=function(e){if(this.isOpen()){C.prototype.invalidate.call(this,e);}};
function F(e){var $=q(e);var i=$.control(0);if($.parents('.sapMDialogSection').length){return false;}if(!i||i.getMetadata().getInterfaces().indexOf("sap.m.IBar")>-1){return true;}return $.hasClass('sapMDialogTitle');}
if(D.system.desktop){E.prototype.ondblclick=function(e){if(F(e.target)){var $=this.$('cont');this._bDisableRepositioning=false;this._oManuallySetPosition=null;this._oManuallySetSize=null;this.oPopup&&this.oPopup._applyPosition(this.oPopup._oLastPosition,true);$.css({height:'100%'});}};E.prototype.onmousedown=function(e){if(e.which===3){return;}if(!this._isDraggableOrResizable()){return;}var i;var G=this;var $=q(document);var J=q(e.target);var M=J.hasClass('sapMDialogResizeHandler')&&this.getResizable();var N=function(e1){i=i?clearTimeout(i):setTimeout(function(){e1();},0);};var Q=this._getAreaDimensions();var W=this.getDomRef().getBoundingClientRect();var X={x:e.clientX,y:e.clientY,width:G._$dialog.width(),height:G._$dialog.height(),outerHeight:G._$dialog.outerHeight(),position:{x:W.x,y:W.y}};var Y;function Z(){var e1=G.$(),f1=G.$('cont'),g1,h1;$.off("mouseup",Z);$.off("mousemove",Y);if(M){G._$dialog.removeClass('sapMDialogResizing');g1=parseInt(e1.height());h1=parseInt(e1.css("border-top-width"))+parseInt(e1.css("border-bottom-width"));f1.height(g1+h1);}}if(F(e.target)&&this.getDraggable()||M){G._bDisableRepositioning=true;G._$dialog.addClass('sapDialogDisableTransition');}if(F(e.target)&&this.getDraggable()){Y=function(e1){e1.preventDefault();if(e1.buttons===0){Z();return;}N(function(){G._bDisableRepositioning=true;G._oManuallySetPosition={x:Math.max(Q.left,Math.min(e1.clientX-e.clientX+X.position.x,Q.right-X.width)),y:Math.max(Q.top,Math.min(e1.clientY-e.clientY+X.position.y,Q.bottom-X.outerHeight))};G._$dialog.css({top:G._oManuallySetPosition.y,left:G._oManuallySetPosition.x,right:G._bRTL?"":undefined});});};}else if(M){G._$dialog.addClass('sapMDialogResizing');var _={};var a1=parseInt(G._$dialog.css('min-width'));var b1=X.x+X.width-a1;var c1=J.width()-e.offsetX;var d1=J.height()-e.offsetY;Y=function(e1){N(function(){G._bDisableRepositioning=true;G.$('cont').height('').width('');if(e1.clientY+d1>Q.bottom){e1.clientY=Q.bottom-d1;}if(e1.clientX+c1>Q.right){e1.clientX=Q.right-c1;}G._oManuallySetSize={width:X.width+e1.clientX-X.x,height:X.height+e1.clientY-X.y};if(G._bRTL){_.left=Math.min(Math.max(e1.clientX,0),b1);G._oManuallySetSize.width=X.width+X.x-Math.max(e1.clientX,0);}_.width=G._oManuallySetSize.width;_.height=G._oManuallySetSize.height;G._$dialog.css(_);});};}else{return;}$.on("mousemove",Y);$.on("mouseup",Z);e.stopPropagation();};}
E.prototype._applyContextualSettings=function(){C.prototype._applyContextualSettings.call(this);};
E.prototype._getTitles=function(e){return e.findAggregatedObjects(true,function(i){return i.isA("sap.m.Title");});};
return E;});
sap.ui.predefine('sap/m/DialogRenderer',["sap/m/library","sap/ui/Device","sap/ui/core/library"],function(l,D,c){"use strict";var a=l.DialogType;var b=l.DialogRoleType;var V=c.ValueState;var d={apiVersion:2};d._mStateClasses={};d._mStateClasses[V.None]="";d._mStateClasses[V.Success]="sapMDialogSuccess";d._mStateClasses[V.Warning]="sapMDialogWarning";d._mStateClasses[V.Error]="sapMDialogError";d._mStateClasses[V.Information]="sapMDialogInformation";
d.render=function(r,o){var i=o.getId(),h=o._getAnyHeader(),s=o.getSubHeader(),B=o.getBeginButton(),e=o.getEndButton(),S=o.getState(),f=o.getStretch(),g=o.getStretchOnPhone()&&D.system.phone,v=o.getAggregation("_valueState");r.openStart("div",o).style("width",o.getContentWidth()).style("height",o.getContentHeight()).class("sapMDialog").class("sapMDialog-CTX").class("sapMPopup-CTX");if(o.isOpen()){r.class("sapMDialogOpen");}if(window.devicePixelRatio>1){r.class("sapMDialogHighPixelDensity");}if(o._bDisableRepositioning){r.class("sapMDialogTouched");}if(f||g){r.class("sapMDialogStretched");}r.class(d._mStateClasses[S]);var n=!o._oToolbar&&!B&&!e;var E=o._oToolbar&&o._isToolbarEmpty()&&!B&&!e;var H=o._oToolbar&&!o._oToolbar.getVisible();if(n||E||H){r.class("sapMDialog-NoFooter");}if(!h){r.class("sapMDialog-NoHeader");}var R=o.getProperty("role");if(S===V.Error||S===V.Warning){R=b.AlertDialog;}r.accessibilityState(o,{role:R,modal:true});if(s&&s.getVisible()){r.class("sapMDialogWithSubHeader");if(s.getDesign()==l.ToolbarDesign.Info){r.class("sapMDialogSubHeaderInfoBar");}}if(o.getType()===a.Message){r.class("sapMMessageDialog");}if(!o.getVerticalScrolling()){r.class("sapMDialogVerScrollDisabled");}if(!o.getHorizontalScrolling()){r.class("sapMDialogHorScrollDisabled");}if(D.system.phone){r.class("sapMDialogPhone");}if(o.getDraggable()&&!f){r.class("sapMDialogDraggable");}if(l._bSizeCompact){r.class("sapUiSizeCompact");}var t=o.getTooltip_AsString();if(t){r.attr("title",t);}r.attr("tabindex","-1");r.openEnd();if(D.system.desktop){if(o.getResizable()&&!f){r.icon("sap-icon://resize-corner",["sapMDialogResizeHandler"],{"title":""});}r.openStart("span",i+"-firstfe").class("sapMDialogFirstFE").attr("tabindex","0").openEnd().close("span");}if(h){h._applyContextClassFor("header");r.openStart("header").class("sapMDialogTitle");if(o._isDraggableOrResizable()){r.attr("tabindex",0);}r.openEnd().renderControl(h).close("header");}if(s&&s.getVisible()){s._applyContextClassFor("subheader");r.openStart("header").class("sapMDialogSubHeader").openEnd().renderControl(s).close("header");}if(v){r.renderControl(v);}r.openStart("section",i+"-cont").class("sapMDialogSection").openEnd();r.openStart("div",i+"-scroll").class("sapMDialogScroll").openEnd();r.openStart("div",i+"-scrollCont").class("sapMDialogScrollCont");if(o.getStretch()||o.getContentHeight()){r.class("sapMDialogStretchContent");}r.openEnd();o.getContent().forEach(r.renderControl,r);r.close("div").close("div").close("section");if(!n&&!E&&!H){o._oToolbar._applyContextClassFor("footer");r.openStart("footer").class("sapMDialogFooter").openEnd().renderControl(o._oToolbar).close("footer");}if(D.system.desktop){r.openStart("span",i+"-lastfe").class("sapMDialogLastFE").attr("tabindex","0").openEnd().close("span");}r.close("div");};
return d;},true);
sap.ui.predefine('sap/m/DisplayListItem',["sap/ui/core/library","./library","./ListItemBase","./DisplayListItemRenderer"],function(c,l,L,D){"use strict";var T=c.TextDirection;
var a=L.extend("sap.m.DisplayListItem",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Misc",defaultValue:null},value:{type:"string",group:"Data",defaultValue:null},valueTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}}}});
a.prototype.getContentAnnouncement=function(){return this.getLabel()+" "+this.getValue();};
return a;});
sap.ui.predefine('sap/m/DisplayListItemRenderer',["sap/ui/core/library","sap/ui/core/Renderer","./ListItemBaseRenderer"],function(c,R,L){"use strict";var T=c.TextDirection;var D=R.extend(L);D.apiVersion=2;
D.renderLIAttributes=function(r,l){r.class("sapMDLI");};
D.renderLIContent=function(r,l){var s=l.getLabel();if(s){r.openStart("label");r.attr("for",l.getId()+"-value");r.class("sapMDLILabel");r.openEnd();r.text(s);r.close("label");}var v=l.getValue();if(v){r.openStart("div",l.getId()+"-value");r.class("sapMDLIValue");var V=l.getValueTextDirection();if(V!=T.Inherit){r.attr("dir",V.toLowerCase());}r.openEnd();r.text(v);r.close("div");}};
return D;},true);
sap.ui.predefine('sap/m/DraftIndicator',["sap/ui/core/Control","sap/m/Label","sap/m/library","./DraftIndicatorRenderer"],function(C,L,l,D){"use strict";var a=l.DraftIndicatorState;
var b=C.extend("sap.m.DraftIndicator",{metadata:{library:"sap.m",designtime:"sap/m/designtime/DraftIndicator.designtime",properties:{state:{type:"sap.m.DraftIndicatorState",group:"Behavior",defaultValue:a.Clear},minDisplayTime:{type:"int",group:"Behavior",defaultValue:1500}},aggregations:{_label:{type:"sap.m.Label",multiple:false,visibility:"hidden"}}}});
var B=sap.ui.getCore().getLibraryResourceBundle("sap.m");b._oTEXTS={};b._oTEXTS[a.Saving]=B.getText("DRAFT_INDICATOR_SAVING_DRAFT");b._oTEXTS[a.Saved]=B.getText("DRAFT_INDICATOR_DRAFT_SAVED");b._oTEXTS[a.Clear]="";
b.prototype.init=function(){this.aQueue=[];this.iDelayedCallId=null;};
b.prototype.exit=function(){this._resetDraftTimer();};
b.prototype.setState=function(s){this.setProperty("state",s);this._addToQueue(s);if(s===a.Saving){this._addToQueue(a.Clear);}return this;};
b.prototype._getLabel=function(){var c=this.getAggregation('_label');if(!c){var c=new L({id:this.getId()+"-label"});this.setAggregation('_label',c,true);c=this.getAggregation('_label');}return c;};
b.prototype.showDraftSaving=function(){this._addToQueue(a.Saving);this._addToQueue(a.Clear);};
b.prototype.showDraftSaved=function(){this._addToQueue(a.Saved);};
b.prototype.clearDraftState=function(){this._addToQueue(a.Clear);};
b.prototype._addToQueue=function(s){this.aQueue.push(s);this._processQueue();};
b.prototype._processQueue=function(){if(this.iDelayedCallId){return;}var n=this.aQueue.shift();var t=this.getMinDisplayTime();if(!n){return;}this._applyState(n);if(n===a.Clear){this._proceed();return;}this.iDelayedCallId=setTimeout(this._proceed.bind(this),t);};
b.prototype._proceed=function(){this._resetDraftTimer();this._processQueue();};
b.prototype._applyState=function(s){this._getLabel().setText(b._oTEXTS[s]);};
b.prototype._resetDraftTimer=function(){clearTimeout(this.iDelayedCallId);this.iDelayedCallId=null;};
return b;});
sap.ui.predefine('sap/m/DraftIndicatorRenderer',[],function(){"use strict";var D={apiVersion:2};
D.render=function(r,c){r.openStart("div",c);r.class("sapMDraftIndicator");r.openEnd();var l=c._getLabel();r.renderControl(l);r.close("div");};
return D;},true);
sap.ui.predefine('sap/m/DynamicDate',['sap/m/DynamicDateUtil','sap/ui/model/SimpleType','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/ValidateException','sap/base/util/each'],function(D,S,F,P,V,e){"use strict";
var a=S.extend("sap.m.DynamicDate",{constructor:function(){this.sName="DynamicDate";S.apply(this,arguments);}});
a.prototype.formatValue=function(v){var r={};if(!v){return;}r.operator=v.operator;r.values=v.values.slice(0);var b=D.getOption(v.operator).getValueTypes();r.values=r.values.map(function(v,i){if(b[i]==="date"){return t.parse(v);}return v;},this);return r;};
a.prototype.parseValue=function(v){var r={},b;if(!v){return;}if(v.operator==="PARSEERROR"){throw new P(v.values[0]);}r.operator=v.operator;r.values=v.values.slice(0);b=D.getOption(v.operator).getValueTypes();r.values=r.values.map(function(v,i){if(b[i]==="date"){return t.format(v);}return v;},this);return r;};
a.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),m=sap.ui.getCore().getLibraryResourceBundle("sap.m"),c=[],M=[],o=D.getOption(v.operator),d=o.toDates(this.formatValue(v)).map(function(u){return u.getTime();});if(d[0]===d[1]){d.length=1;}d.forEach(function(T,i){var E="DynamicDate.Invalid"+(i===0?"Start":"End");e(this.oConstraints,function(C,f){switch(C){case"minimum":if(T<f){c.push("minimum");M.push(m.getText(E,[new Date(T).toDateString()]));M.push(b.getText("Date.Minimum",[new Date(f).toDateString()]));}break;case"maximum":if(T>f){c.push("maximum");M.push(m.getText(E,[new Date(T).toDateString()]));M.push(b.getText("Date.Maximum",[new Date(f).toDateString()]));}break;}});},this);if(c.length>0){throw new V(this.combineMessages(M),c);}}};
var t={format:function(v){if(v instanceof Date){return v.getTime();}return null;},parse:function(v){if(isNaN(v)){throw new F("Cannot format date: "+v+" is not a valid Timestamp");}else if(typeof(v)!=="number"){v=parseInt(v);}v=new Date(v);return v;}};return a;});
sap.ui.predefine('sap/m/DynamicDateFormat',['sap/ui/core/format/DateFormat','sap/ui/core/format/NumberFormat','sap/ui/core/Locale','sap/ui/core/LocaleData',"sap/base/Log","sap/base/util/deepExtend","sap/base/util/isEmptyObject","sap/ui/core/date/UniversalDateUtils","./library"],function(D,N,L,a,b,d,c,U,l){"use strict";var e=function(){throw new Error();};var _=sap.ui.getCore().getLibraryResourceBundle("sap.m");var g={};var h={};var p={"DATE":["date"],"DATERANGE":["date","date"],"LASTDAYS":["int"],"LASTWEEKS":["int"],"LASTMONTHS":["int"],"LASTQUARTERS":["int"],"LASTYEARS":["int"],"NEXTDAYS":["int"],"NEXTWEEKS":["int"],"NEXTMONTHS":["int"],"NEXTQUARTERS":["int"],"NEXTYEARS":["int"],"FROM":["date"],"TO":["date"],"SPECIFICMONTH":["month"],"TODAYFROMTO":["int","int"]};var s=Object.keys(l.StandardDynamicDateRangeKeys);for(var i=0;i<s.length;i++){var k=s[i];var P=_.getText("DYNAMIC_DATE_"+k.toUpperCase()+"_FORMAT");var S=P.split('{').map(function(f){var C=f.indexOf('}');if(C!==-1){return f.slice(C+1);}return f;});g[k]=S;var m=[];var n=P.indexOf('{');var o=-1;var q=-1;while(n!==-1){o=P.indexOf('}');q=parseInt(P.slice(n+1,o-o-1));m.push(q);P=P.slice(o+1);n=P.indexOf('{');}h[k]=m;}
e.getInstance=function(f,j){return this.createInstance(f,j);};
e.oDefaultDynamicDateFormat={"date":{},"month":{pattern:"MMMM"},"int":{}};
e.createInstance=function(F,j){var r=Object.create(this.prototype);if(F instanceof L){j=F;F=undefined;}if(!j){j=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();}r.oLocale=j;r.oLocaleData=a.getInstance(j);r.oOriginalFormatOptions=d({},e.oDefaultDynamicDateFormat,F);r._dateFormatter=D.getInstance(r.oOriginalFormatOptions["date"]);[r._dateFormatter].concat(r._dateFormatter.aFallbackFormats).forEach(function(f){f.parseRelative=function(){return null;};});r._monthFormatter=D.getInstance(r.oOriginalFormatOptions["month"]);r._numberFormatter=N.getInstance(r.oOriginalFormatOptions["int"]);r._resourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");return r;};
e.prototype.format=function(O){var k=O.operator;var m=O.values.slice(0);if(k==="SPECIFICMONTH"){var f=new Date();f.setMonth(m[0]);m[0]=this._monthFormatter.format(f);}else if(k==="LASTDAYS"&&m[0]===1){k="YESTERDAY";m=[];}else if(k==="NEXTDAYS"&&m[0]===1){k="TOMORROW";m=[];}else if((k==="LASTDAYS"||k==="NEXTDAYS")&&m[0]===0){k="TODAY";m=[];}var F=m.map(function(j){if(j instanceof Date){return this._dateFormatter.format(j);}if(typeof(j)==="number"){return this._numberFormatter.format(j);}else{return j.toString();}},this);return this._resourceBundle.getText("DYNAMIC_DATE_"+k.toUpperCase()+"_FORMAT",F);};
e.prototype.parse=function(v,k){var r;var S=g[k];var R="^"+S.join("(.*)")+"$";if(k==="TODAYFROMTO"){R=R.replace("+","\\+");}var f=new RegExp(R,"i");var t=v.match(f);if(t){r={};r.values=[];for(var j=0;j<h[k].length;j++){var I=h[k][j];var T=p[k][I];var V;var C=t[j+1];switch(T){case"date":V=this._dateFormatter.parse(C);break;case"month":var M=[0,1,2,3,4,5,6,7,8,9,10,11].map(function(i){var w=new Date();w.setMonth(i);return this._monthFormatter.format(w);},this);var u=M.indexOf(C);V=u!==-1?u:null;break;case"int":V=this._numberFormatter.parse(C);break;case"string":V=C;break;default:break;}if(!V){r=null;break;}r.values[I]=V;}if(r){r.operator=k;return r;}}};
return e;});
sap.ui.predefine('sap/m/DynamicDateOption',['sap/ui/core/Element','./Label','./StepInput','sap/ui/unified/Calendar','sap/ui/unified/DateRange','sap/ui/unified/calendar/MonthPicker'],function(E,L,S,C,D,M){"use strict";
var a=E.extend("sap.m.DynamicDateOption",{metadata:{library:"sap.m",properties:{key:{type:"string"},valueTypes:{type:"string[]",multiple:true}}}});
a.prototype.getText=function(c){return this.getKey();};
a.prototype.getValueHelpUITypes=function(c){throw new Error("Need implementation for method getValueHelpUITypes. Option: "+this.getKey());};
a.prototype.createValueHelpUI=function(c,f){var v=c.getValue();var p=this.getValueHelpUITypes(c);var b=[];var I;if(!c.aControlsByParameters){c.aControlsByParameters={};}c.aControlsByParameters[this.getKey()]=[];for(var i=0;i<p.length;i++){if(p[i].getText()){b.push(new L({text:p[i].getText(),width:"100%"}));}I=this._createControl(i,p[i].getType(),v,f);b.push(I);c.aControlsByParameters[this.getKey()].push(I);}return b;};
a.prototype.validateValueHelpUI=function(c){var p=this.getValueHelpUITypes();for(var i=0;i<p.length;i++){var I=c.aControlsByParameters[this.getKey()][i];switch(p[i].getType()){case"int":if(I._isLessThanMin(I.getValue())||I._isMoreThanMax(I.getValue())){return false;}break;case"month":case"date":case"daterange":if(!I.getSelectedDates()||I.getSelectedDates().length==0){return false;}break;}}return true;};
a.prototype.getValueHelpOutput=function(c){var p=this.getValueHelpUITypes(),r={},o;r.operator=this.getKey();r.values=[];for(var i=0;i<p.length;i++){var I=c.aControlsByParameters[this.getKey()][i];switch(p[i].getType()){case"int":o=I.getValue();break;case"month":case"date":if(!I.getSelectedDates().length){return null;}o=I.getSelectedDates()[0].getStartDate();break;case"daterange":if(!I.getSelectedDates().length){return null;}var e=I.getSelectedDates()[0].getEndDate()||I.getSelectedDates()[0].getStartDate();o=[I.getSelectedDates()[0].getStartDate(),e];break;}if(Array.isArray(o)){r.values=Array.prototype.concat.apply(r.values,o);}else{o&&r.values.push(o);}}return r;};
a.prototype.getGroup=function(){return 0;};
a.prototype.getGroupHeader=function(){var g=(this.getGroup()>-1&&this.getGroup()<7)?this.getGroup():0;return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("DDR_OPTIONS_GROUP_"+g);};
a.prototype.format=function(v){throw new Error("Need implementation for method format. Option: "+this.getKey());};
a.prototype.parse=function(v){throw new Error("Need implementation for method parse. Option: "+this.getKey());};
a.prototype.toDates=function(v){throw new Error("Need implementation for method toDates. Option: "+this.getKey());};
a.prototype.enhanceFormattedValue=function(){return false;};
a.prototype._createControl=function(i,u,v,c){var I;switch(u){case"int":I=this._createIntegerControl(v,i,c);break;case"date":I=this._createDateControl(v,i,c);break;case"daterange":I=this._createDateRangeControl(v,i,c);break;case"month":I=this._createMonthControl(v,i,c);break;}return I;};
a.prototype._createIntegerControl=function(v,i,c){var o=new S({width:"120px"});if(v&&this.getKey()===v.operator){o.setValue(v.values[i]);}if(c instanceof Function){o.attachChange(function(){c(this);},this);}return o;};
a.prototype._createDateControl=function(v,i,c){var o=new C({width:"100%"});if(v&&this.getKey()===v.operator){o.addSelectedDate(new D({startDate:v.values[i]}));}if(c instanceof Function){o.attachSelect(function(){c(this);},this);}return o;};
a.prototype._createDateRangeControl=function(v,i,c){var o=new C({intervalSelection:true,width:"100%"});if(v&&this.getKey()===v.operator){o.addSelectedDate(new D({startDate:v.values[i],endDate:v.values[i+1]}));}if(c instanceof Function){o.attachSelect(function(){c(this);},this);}return o;};
a.prototype._createMonthControl=function(v,i,c){var o=new M(),d=new Date(),m=(v&&this.getKey()===v.operator)?v.values[i]:d.getMonth();o.setMonth(m);o.addSelectedDate(new D({startDate:d}));if(c instanceof Function){o.attachSelect(function(){c(this);},this);}return o;};
return a;});
sap.ui.predefine('sap/m/DynamicDateRange',['sap/ui/core/InvisibleText','sap/ui/core/Element','sap/ui/core/Control','sap/ui/core/ListItem','sap/ui/core/library',"sap/ui/core/Renderer",'sap/ui/core/message/MessageMixin','sap/m/DynamicDateFormat','sap/m/DynamicDateUtil','sap/ui/core/IconPool','sap/ui/core/Icon',"sap/ui/core/LabelEnablement",'sap/ui/core/format/DateFormat','sap/ui/base/ManagedObjectObserver','sap/ui/Device','./Label','./GroupHeaderListItem','./StandardListItem','./StandardListItemRenderer','./Button','./List','./Input','./InputRenderer','./Toolbar','./ResponsivePopover','./Page','./NavContainer','./DynamicDateRangeRenderer','./StandardDynamicDateOption','sap/ui/dom/jquery/Focusable','./library'],function(I,E,C,L,c,R,M,D,d,e,f,g,h,i,j,k,G,S,l,B,m,n,p,T,q,P,N,r,s,F,t){"use strict";var V=c.ValueState,u=t.ToolbarDesign,v=t.ToolbarStyle,w=t.ListType,x=t.ListMode,y=t.ListSeparators,z=sap.ui.getCore().getLibraryResourceBundle("sap.m");
var A=C.extend("sap.m.DynamicDateRange",{
metadata:{library:"sap.m",properties:{value:{type:"object"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:V.None},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueStateText:{type:"string",group:"Misc",defaultValue:null},required:{type:"boolean",group:"Misc",defaultValue:false},enableGroupHeaders:{type:"boolean",group:"Behavior",defaultValue:true},formatter:{type:"object"},options:{type:"string[]",group:"Behavior",defaultValue:["DATE","TODAY","YESTERDAY","TOMORROW","FIRSTDAYWEEK","LASTDAYWEEK","FIRSTDAYMONTH","LASTDAYMONTH","FIRSTDAYQUARTER","LASTDAYQUARTER","FIRSTDAYYEAR","LASTDAYYEAR","DATERANGE","FROM","TO","YEARTODATE","DATETOYEAR","LASTDAYS","LASTWEEKS","LASTMONTHS","LASTQUARTERS","LASTYEARS","NEXTDAYS","NEXTWEEKS","NEXTMONTHS","NEXTQUARTERS","NEXTYEARS","TODAYFROMTO","THISWEEK","LASTWEEK","NEXTWEEK","SPECIFICMONTH","THISMONTH","LASTMONTH","NEXTMONTH","THISQUARTER","LASTQUARTER","NEXTQUARTER","QUARTER1","QUARTER2","QUARTER3","QUARTER4","THISYEAR","LASTYEAR","NEXTYEAR"]}},aggregations:{_input:{type:"sap.m.Input",multiple:false,visibility:"hidden"},_popup:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{change:{parameters:{value:{type:"object"},valid:{type:"boolean"}}}}},
renderer:r
});
M.call(A.prototype);
A.prototype.init=function(){this._oInput=new J(this.getId()+"-input",{showValueHelp:true,valueHelpIconSrc:e.getIconURI("sap-icon://check-availability"),valueHelpRequest:this._toggleOpen.bind(this),showSuggestion:true,suggest:this._handleSuggest.bind(this)});this._oListItemDelegate=undefined;this._onBeforeInputRenderingDelegate={onBeforeRendering:function(){this._oInput._getValueHelpIcon().setVisible(true);}};this._oInput._getValueHelpIcon().setTooltip(z.getText("INPUT_VALUEHELP_BUTTON"));this._oInput.addDelegate(this._onBeforeInputRenderingDelegate,this);this.setAggregation("_input",this._oInput,false);this._oInput._setControlOrigin(this);this._oInput.attachChange(this._handleInputChange,this);this.oValueObserver=new i(function(){delete this.oBoundValueFormatter;}.bind(this));this.oValueObserver.observe(this,{bindings:["value"]});};
A.prototype.exit=function(){this._oInput.removeDelegate(this._onBeforeInputRenderingDelegate);this._onBeforeInputRenderingDelegate=undefined;this.oValueObserver.destroy();this._infoDatesFooter=undefined;this.aInputControls=undefined;this._removeAllListItemDelegates();};
A.prototype._removeAllListItemDelegates=function(){if(this._oOptionsList){this._oOptionsList.getItems().forEach(function(o){o.removeDelegate(this._oListItemDelegate);},this);}};
A.prototype.onBeforeRendering=function(){this._updateInputValue(this.getValue());this._oInput.setEditable(this.getEditable());this._oInput.setEnabled(this.getEnabled());this._oInput.setRequired(this.getRequired());this._oInput.setName(this.getName());this._oInput.setWidth(this.getWidth());this._oInput.setPlaceholder(this.getPlaceholder());this._oInput.setValueState(this.getValueState());this._oInput.setValueStateText(this.getValueStateText());};
A.prototype.setValue=function(o){o=this._substitudeValue(o);this.setProperty("value",o);this._updateInputValue(o);return this;};
A.prototype._toggleOpen=function(){if(this._oPopup&&this._oPopup.isOpen()){this._closePopup();}else{this.open();}};
A.prototype.open=function(){if(this.getEditable()&&this.getEnabled()){this._createPopup();this._createPopupContent();if(!this._oListItemDelegate){this._oListItemDelegate={onsapshow:this._closePopup.bind(this),onsaphide:this._closePopup.bind(this)};}this._removeAllListItemDelegates();this._oOptionsList.destroyAggregation("items");this._collectValueHelpItems(this._getOptions(),true).map(function(o){if(typeof(o)==="string"){return this._createHeaderListItem(o);}return this._createListItem(o);},this).forEach(function(o){o.addDelegate(this._oListItemDelegate,this);this._oOptionsList.addItem(o);},this);this._oNavContainer.to(this._oNavContainer.getPages()[0]);this._openPopup();}};
A.prototype.addOption=function(a){var o=this.getOptions();if(o.indexOf(a)===-1){o.push(a);}this.setOptions(o);};
A.prototype.getFocusDomRef=function(){return this.getAggregation("_input")&&this.getAggregation("_input").getFocusDomRef();};
A.prototype._updateInputValue=function(o){var a;if(o&&o.operator!=="PARSEERROR"){a=this._enhanceInputValue(this._formatValue(o),o);this._oInput.setValue(a);}};
A.prototype._handleSuggest=function(o){if(this._oPopup&&this._oPopup.isOpen()){this._closePopup();}var Q=o.getParameter("suggestValue");this._oInput.removeAllSuggestionItems();var a=this._getOptions().filter(function(O){var U={operator:O.getKey(),values:[]},W=O.getValueHelpUITypes(this);if(W.length&&W[0].getType()){return false;}var X=d.getOption(U.operator).format(U,this._getFormatter()).toLowerCase();var Y=X.indexOf(Q.toLowerCase());return Y===0||(Y>0&&X[Y-1]===" ");},this);this._collectValueHelpItems(a,true).forEach(function(O){if(O.getKey){var U={operator:O.getKey(),values:[]};this._addSuggestionItem(U);}else{this._addSuggestionGroupItem(O);}},this);var b=Q.match(/\d+/);if(!b){return;}a=this._getOptions().filter(function(O){return O.getValueHelpUITypes(this).length===1&&O.getValueHelpUITypes(this)[0].getType()==="int";},this);this._collectValueHelpItems(a,false).forEach(function(O){if(O.getKey){var U={operator:O.getKey(),values:[parseInt(b[0])]};this._addSuggestionItem(U);}else{this._addSuggestionGroupItem(O);}},this);};
A.prototype._getOptions=function(){var O=this.getOptions();var a=O.map(function(b){return d.getOption(b);},this);return a.filter(function(o){return!!o;});};
A.prototype._getDatesLabelFormatter=function(){if(!this._oDatesLabelFormatter){var o=Object.create(this._getFormatter()._dateFormatter.oFormatOptions);o.interval=true;this._oDatesLabelFormatter=h.getInstance(o);}return this._oDatesLabelFormatter;};
A.prototype._destroyInputControls=function(){if(!this.aInputControls){return;}this.aInputControls.forEach(function(o){o.destroy();});this.aInputControls=undefined;};
A.prototype._addSuggestionItem=function(o){var a=d.toDates(o);var b=new L({text:d.getOption(o.operator).format(o,this._getFormatter()),additionalText:this._getDatesLabelFormatter().format(a)});this._oInput.addSuggestionItem(b);};
A.prototype._addSuggestionGroupItem=function(a){this._oInput.addSuggestionItemGroup({text:a});};
A.prototype._handleInputChange=function(o){var a=o.getParameter("value");var b=this._parseValue(this._stripValue(a));var O=this.getValue();var Q=a.trim()===""||!!b;if(!Q){this.setValue({operator:"PARSEERROR",values:[z.getText("DDR_WRONG_VALUE"),a]});}else{this.setValue(b);}this.fireChange({value:this.getValue(),prevValue:O,valid:Q});};
A.prototype._enhanceInputValue=function(a,o){if(d.getOption(o.operator).enhanceFormattedValue()||(o.operator==="LASTDAYS"&&o.values[0]<=1)||(o.operator==="NEXTDAYS"&&o.values[0]<=1)){return a+" ("+this._toDatesString(o)+")";}return a;};
A.prototype._stripValue=function(a){var o=a.indexOf("(");var b=a.lastIndexOf(")");var O=a;if(o!==-1&&b!==-1&&o<b){O=a.slice(0,o)+a.slice(b+1);O=O.trim();}return O;};
A.prototype._toDatesString=function(o){return this._getDatesLabelFormatter().format(d.toDates(o));};
A.prototype._createPopup=function(){if(!this._oPopup){this._oPopup=new q(this.getId()+"-RP",{contentHeight:'470px',contentWidth:_(this.getDomRef())?'272px':'320px',showCloseButton:false,showArrow:false,showHeader:false,placement:t.PlacementType.VerticalPreferedBottom,ariaLabelledBy:[I.getStaticId("sap.m","INPUT_AVALIABLE_VALUES")]});this._oPopup.addStyleClass("sapMDDRPopover");if(j.system.phone){this._oPopup.addStyleClass("sapUiNoContentPadding");}else{this._oPopup._oControl._getSingleNavContent=function(){return null;};}this._oPopup.attachAfterOpen(function(){var o=this._oNavContainer.getPages()[0];this._applyNavContainerPageFocus(o);this.invalidate();},this);this._oPopup.attachAfterClose(function(){this._setFooterVisibility(false);this.invalidate();},this);this._oPopup.setBeginButton(new B({type:t.ButtonType.Emphasized,text:z.getText("DYNAMIC_DATE_RANGE_CONFIRM"),press:this._applyValue.bind(this)}));this._oPopup.setEndButton(new B({text:z.getText("DYNAMIC_DATE_RANGE_CANCEL"),press:this._closePopup.bind(this)}));this._setFooterVisibility(false);this._oPopup._getPopup().setAutoClose(true);this.setAggregation("_popup",this._oPopup,true);}};
A.prototype._collectValueHelpItems=function(o,O){var Q;var U;var W=[];var X=o;var Y=d.getStandardKeys();X.sort(function(a,b){var Z=a.getGroup()-b.getGroup();if(Z){return Z;}return Y.indexOf(a.getKey())-Y.indexOf(b.getKey());});if(O){X=X.reduce(function(a,b){if(s.LastXKeys.indexOf(b.getKey())!==-1){if(Q){return a;}Q=true;}if(s.NextXKeys.indexOf(b.getKey())!==-1){if(U){return a;}U=true;}a.push(b);return a;},[]);}if(this.getEnableGroupHeaders()){X=X.reduce(function(a,b){var Z=b.getGroupHeader();if(W.indexOf(Z)===-1){W.push(Z);a.push(Z);}a.push(b);return a;},[]);}return X;};
A.prototype._createListItem=function(o){var b=this._isFixedOption(o);return new K(this.getId()+"-option-"+o.getKey(),{type:b?w.Active:w.Navigation,title:o.getText(this),wrapping:true,optionKey:o.getKey(),press:this._handleOptionPress.bind(this)});};
A.prototype._createHeaderListItem=function(a){var o=new G();o.setTitle(a);o._bGroupHeader=true;return o;};
A.prototype._handleOptionPress=function(o){var O=o.getSource().getOptionKey(),a=d.getOption(O);this._oSelectedOption=a;if(this._isFixedOption(a)){this._applyValue();}else{var b=this._createInfoDatesFooter();this._destroyInputControls();this.aInputControls=a.createValueHelpUI(this,this._updateInternalControls.bind(this));var Q=this._oNavContainer.getPages()[1];Q.removeAllContent();this.aInputControls.forEach(function(U){Q.addContent(U);});Q.setFooter(b);Q.setTitle(a.getText(this));this._setFooterVisibility(true);this._updateInternalControls(a);this._oNavContainer.to(Q);}};
A.prototype._isFixedOption=function(o){return!o.getValueHelpUITypes(this).length;};
A.prototype._createInfoDatesFooter=function(){this._infoDatesFooter=new T({design:u.Info,style:v.Clear,content:[new k({text:z.getText("DDR_INFO_DATES_EMPTY_HINT")})]});return this._infoDatesFooter;};
A.prototype._getDatesLabel=function(){return this._infoDatesFooter.getContent()[0];};
A.prototype._updateDatesLabel=function(){var o=this._oSelectedOption.getValueHelpOutput(this),a,b;if(!o||!o.operator||!d.getOption(o.operator)){return;}a=d.toDates(o);if(a){b=this._getDatesLabelFormatter().format(a);this._getDatesLabel().setText(z.getText("DDR_INFO_DATES",[b]));}};
A.prototype._setApplyButtonEnabled=function(b){if(!this._oPopup){return;}var a=this._oPopup.getBeginButton();if(a.getVisible()){a.setEnabled(b);}};
A.prototype._updateInternalControls=function(o){var b=o.validateValueHelpUI(this);if(b){this._updateDatesLabel();}this._setApplyButtonEnabled(b);};
A.prototype._setFooterVisibility=function(b){var o;if(!this._oPopup){return;}o=this._oPopup.getAggregation("_popup");if(j.system.phone){this._oPopup.getBeginButton().setVisible(b);}else{o.getFooter().setVisible(b);}o.invalidate();return this;};
A.prototype._createPopupContent=function(){var o=new P({showHeader:false,showNavButton:false}),a=new P({showHeader:true,showNavButton:true}).addStyleClass("sapMDynamicDateRangePopover");a.attachNavButtonPress(function(){this._setFooterVisibility(false);this._oNavContainer.back();},this);if(j.system.phone){o.setShowHeader(true);o.setTitle(this._getOptionsPageTitleText());}if(!this._oOptionsList){this._oOptionsList=new m({showSeparators:y.None,mode:x.None});}if(!this._oNavContainer){this._oNavContainer=new N({autoFocus:false});this._oNavContainer.addPage(o);this._oNavContainer.setInitialPage(o);this._oNavContainer.addPage(a);this._oNavContainer.attachAfterNavigate(this._navContainerAfterNavigate,this);this._oPopup.addContent(this._oNavContainer);}this._oNavContainer.getPages()[0].removeAllContent();this._oNavContainer.getPages()[0].addContent(this._oOptionsList);return this._oOptionsList;};
A.prototype._applyNavContainerPageFocus=function(o){var a=this.getValue(),O=this._oNavContainer.getPages()[0],b;if(o===O&&a){b=this._oOptionsList.getItems().find(function(Q){return Q.isA("sap.m.DynamicDateRangeListItem")&&(Q.getOptionKey()===a.operator);});}if(!b){b=jQuery(o.getDomRef().querySelector("section")).firstFocusableDomRef();}b.focus();this._reApplyFocusToElement(o,a);};
A.prototype._reApplyFocusToElement=function(o,a){};
A.prototype._getOptionsPageTitleText=function(){return g.getReferencingLabels(this).concat(this.getAriaLabelledBy()).reduce(function(a,b){var o=E.registry.get(b);return a+" "+(o.getText?o.getText():"");},"").trim();};
A.prototype._navContainerAfterNavigate=function(o){var O=this._oNavContainer.getPages()[1],a=o.getParameters()["to"];if(a===O){this.aInputControls.forEach(function(b){if(jQuery(b.getDomRef()).firstFocusableDomRef()){b.addAriaLabelledBy(a.getAggregation("_internalHeader"));if(!this._isCalendarBasedControl(b)&&b.addAriaDescribedBy){b.addAriaDescribedBy(a.getFooter().getContent()[0]);}}},this);}if(this._oPopup&&this._oPopup.isOpen()){this._applyNavContainerPageFocus(a);}else{this.focus();}};
A.prototype._isCalendarBasedControl=function(o){return o.isA("sap.ui.unified.Calendar")||o.isA("sap.ui.unified.calendar.CustomMonthPicker")||o.isA("sap.ui.unified.calendar.MonthPicker")||o.isA("sap.ui.unified.calendar.YearPicker")||o.isA("sap.ui.unified.calendar.YearRangePicker")||o.isA("sap.ui.unified.calendar.Month");};
A.prototype._openPopup=function(){if(!this._oPopup){return;}this._oPopup._getPopup().setAutoCloseAreas([this._oInput.getDomRef()]);this._oPopup.openBy(this._oInput);};
A.prototype._applyValue=function(){this._oOutput=this._oSelectedOption.getValueHelpOutput(this);var a=this.getValue();this.setValue(this._oOutput);this.fireChange({prevValue:a,value:this.getValue(),valid:true});this._closePopup();};
A.prototype._closePopup=function(){this._setFooterVisibility(false);this._oNavContainer.to(this._oNavContainer.getPages()[0]);this._oPopup.close();};
A.prototype._getFormatter=function(){var o=this.getFormatter(),b;if(o){return o;}if(this.oBoundValueFormatter){return this.oBoundValueFormatter;}b=this.getBinding("value");if(b&&b.getType()){this.oBoundValueFormatter=D.getInstance(b.getType().oFormatOptions);return this.oBoundValueFormatter;}if(!this.oDefaultFormatter){this.oDefaultFormatter=D.getInstance();}return this.oDefaultFormatter;};
A.prototype._formatValue=function(o){return d.getOption(o.operator).format(o,this._getFormatter());};
A.prototype._parseValue=function(a){var b=d.parse(a,this._getFormatter(),this.getOptions()).filter(function(o){return this.getOptions().indexOf(o.operator)!==-1;},this);return b.length?b[0]:null;};
A.prototype._substitudeValue=function(o){var a,b,O;if(!o||!o.operator||!o.values){return o;}a=o.operator;b=o.values;if(a==="LASTDAYS"&&b[0]===1){O={operator:"YESTERDAY",values:[]};}else if(a==="NEXTDAYS"&&b[0]===1){O={operator:"TOMORROW",values:[]};}else if((a==="LASTDAYS"||a==="NEXTDAYS")&&b[0]===0){O={operator:"TODAY",values:[]};}return O?O:o;};
var H=R.extend(p);H.apiVersion=2;
H.getAriaRole=function(o){return"combobox";};
H.writeInnerAttributes=function(o,a){o.attr("type","text");};
H.getAccessibilityState=function(o){var a=p.getAccessibilityState(o),b=o._getControlOrigin(),O=b.getAriaLabelledBy(),Q=g.getReferencingLabels(b),U=b.getAriaDescribedBy().join(" "),W;W=Q.concat(O).join(" ");if(U){a.describedby=U;}if(W){a.labelledby=W;}a.roledescription=z.getText("ACC_CTR_TYPE_DYNAMIC_DATE_RANGE");a.role=this.getAriaRole();a.expanded=b._oPopup?b._oPopup.isOpen():false;a.haspopup=c.aria.HasPopup.ListBox.toLowerCase();a.autocomplete="list";a.controls=b._oPopup&&b._oPopup.getDomRef()?b._oPopup.getDomRef().id:undefined;return a;};
var J=n.extend("sap.m.internal.DynamicDateRangeInput",{
metadata:{library:"sap.m"},
renderer:H
});
J.prototype._setControlOrigin=function(o){this._oOriginControl=o;return this._oOriginControl;};
J.prototype._getControlOrigin=function(){return this._oOriginControl;};
J.prototype.preventChangeOnFocusLeave=function(o){return this.bFocusoutDueRendering;};
J.prototype.shouldSuggetionsPopoverOpenOnMobile=function(o){var b=o.srcControl instanceof f;return this.isMobileDevice()&&this.getEditable()&&this.getEnabled()&&this.getShowSuggestion()&&!b&&(!this._bClearButtonPressed);};
var K=S.extend("sap.m.DynamicDateRangeListItem",{
metadata:{library:"sap.m",properties:{optionKey:{type:"string",group:"Misc",defaultValue:null}}},
renderer:l
});
K.prototype.getNavigationControl=function(){var o=S.prototype.getNavigationControl.apply(this,arguments),b=["SPECIFICMONTH","DATE","DATERANGE","FROM","TO"].includes(this.getOptionKey()),a=b?e.getIconURI("appointment-2"):e.getIconURI("slim-arrow-right");if(b){o.addStyleClass("sapMDDRDateOption");}o.setSrc(a);return o;};
function _(o){var a=o;while(a&&a.classList){if(a.classList.contains("sapUiSizeCompact")){return true;}a=a.parentNode;}return false;}
return A;});
sap.ui.predefine('sap/m/DynamicDateRangeRenderer',["sap/m/InputBaseRenderer",'sap/ui/core/Renderer'],function(I,R){"use strict";var D={apiVersion:2};
D.render=function(r,c){r.openStart("div",c);r.class("sapMDynamicDateRange");r.openEnd();r.renderControl(c._oInput);r.close("div");};
return D;});
sap.ui.predefine('sap/m/DynamicDateUtil',["./StandardDynamicDateOption","sap/base/Log","./library"],function(S,L,l){"use strict";var a=["DATE","TODAY","YESTERDAY","TOMORROW","FIRSTDAYWEEK","LASTDAYWEEK","FIRSTDAYMONTH","LASTDAYMONTH","FIRSTDAYQUARTER","LASTDAYQUARTER","FIRSTDAYYEAR","LASTDAYYEAR","DATERANGE","FROM","TO","YEARTODATE","DATETOYEAR","LASTDAYS","LASTWEEKS","LASTMONTHS","LASTQUARTERS","LASTYEARS","NEXTDAYS","NEXTWEEKS","NEXTMONTHS","NEXTQUARTERS","NEXTYEARS","TODAYFROMTO","THISWEEK","LASTWEEK","NEXTWEEK","SPECIFICMONTH","THISMONTH","LASTMONTH","NEXTMONTH","THISQUARTER","LASTQUARTER","NEXTQUARTER","QUARTER1","QUARTER2","QUARTER3","QUARTER4","THISYEAR","LASTYEAR","NEXTYEAR"];var D={_options:{"TODAY":new S({key:"TODAY",valueTypes:[]}),"YESTERDAY":new S({key:"YESTERDAY",valueTypes:[]}),"TOMORROW":new S({key:"TOMORROW",valueTypes:[]}),"FIRSTDAYWEEK":new S({key:"FIRSTDAYWEEK",valueTypes:[]}),"LASTDAYWEEK":new S({key:"LASTDAYWEEK",valueTypes:[]}),"FIRSTDAYMONTH":new S({key:"FIRSTDAYMONTH",valueTypes:[]}),"LASTDAYMONTH":new S({key:"LASTDAYMONTH",valueTypes:[]}),"FIRSTDAYQUARTER":new S({key:"FIRSTDAYQUARTER",valueTypes:[]}),"LASTDAYQUARTER":new S({key:"LASTDAYQUARTER",valueTypes:[]}),"FIRSTDAYYEAR":new S({key:"FIRSTDAYYEAR",valueTypes:[]}),"LASTDAYYEAR":new S({key:"LASTDAYYEAR",valueTypes:[]}),"THISWEEK":new S({key:"THISWEEK",valueTypes:[]}),"THISMONTH":new S({key:"THISMONTH",valueTypes:[]}),"THISQUARTER":new S({key:"THISQUARTER",valueTypes:[]}),"THISYEAR":new S({key:"THISYEAR",valueTypes:[]}),"LASTWEEK":new S({key:"LASTWEEK",valueTypes:[]}),"LASTMONTH":new S({key:"LASTMONTH",valueTypes:[]}),"LASTQUARTER":new S({key:"LASTQUARTER",valueTypes:[]}),"LASTYEAR":new S({key:"LASTYEAR",valueTypes:[]}),"NEXTWEEK":new S({key:"NEXTWEEK",valueTypes:[]}),"NEXTMONTH":new S({key:"NEXTMONTH",valueTypes:[]}),"NEXTQUARTER":new S({key:"NEXTQUARTER",valueTypes:[]}),"NEXTYEAR":new S({key:"NEXTYEAR",valueTypes:[]}),"LASTDAYS":new S({key:"LASTDAYS",valueTypes:["int"]}),"LASTWEEKS":new S({key:"LASTWEEKS",valueTypes:["int"]}),"LASTMONTHS":new S({key:"LASTMONTHS",valueTypes:["int"]}),"LASTQUARTERS":new S({key:"LASTQUARTERS",valueTypes:["int"]}),"LASTYEARS":new S({key:"LASTYEARS",valueTypes:["int"]}),"NEXTDAYS":new S({key:"NEXTDAYS",valueTypes:["int"]}),"NEXTWEEKS":new S({key:"NEXTWEEKS",valueTypes:["int"]}),"NEXTMONTHS":new S({key:"NEXTMONTHS",valueTypes:["int"]}),"NEXTQUARTERS":new S({key:"NEXTQUARTERS",valueTypes:["int"]}),"NEXTYEARS":new S({key:"NEXTYEARS",valueTypes:["int"]}),"FROM":new S({key:"FROM",valueTypes:["date"]}),"TO":new S({key:"TO",valueTypes:["date"]}),"YEARTODATE":new S({key:"YEARTODATE",valueTypes:[]}),"DATETOYEAR":new S({key:"DATETOYEAR",valueTypes:[]}),"TODAYFROMTO":new S({key:"TODAYFROMTO",valueTypes:["int","int"]}),"QUARTER1":new S({key:"QUARTER1",valueTypes:[]}),"QUARTER2":new S({key:"QUARTER2",valueTypes:[]}),"QUARTER3":new S({key:"QUARTER3",valueTypes:[]}),"QUARTER4":new S({key:"QUARTER4",valueTypes:[]}),"SPECIFICMONTH":new S({key:"SPECIFICMONTH",valueTypes:["int"]}),"DATERANGE":new S({key:"DATERANGE",valueTypes:["date","date"]}),"DATE":new S({key:"DATE",valueTypes:["date"]})},_allKeys:a.slice(0)};
D.addOption=function(o){if(!o||!o.getKey()){return;}var k=o.getKey();D._options[k]=o;if(D._allKeys.indexOf(k)===-1){D._allKeys.push(k);}};
D.getAllOptionKeys=function(){return D._allKeys.slice(0);};
D.getOption=function(k){return D._options[k];};
D.getStandardKeys=function(){return a.slice(0);};
D.parse=function(v,f,o){if(typeof v!=='string'){L.error("DynamicDateFormat can only parse a String.");return[];}var r=[],R,s=D.getStandardKeys();o=o||Object.keys(D._options);var O=o.sort(function(k,K){return s.indexOf(k)-s.indexOf(K);}).map(function(k){return D._options[k];});for(var i=0;i<O.length;i++){R=O[i]&&O[i].parse(v.trim(),f);if(R){R.operator=O[i].getKey();r.push(R);}}return r;};
D.toDates=function(v){var k=v.operator;return D._options[k].toDates(v);};
return D;},true);
sap.ui.predefine('sap/m/DynamicDateValueHelpUIType',['sap/ui/core/Element'],function(E){"use strict";
var D=E.extend("sap.m.DynamicDateValueHelpUIType",{metadata:{library:"sap.m",properties:{type:{type:"string"},text:{type:"string"},additionalText:{type:"string"},options:{type:"string[]",multiple:true,defaultValue:null}}}});
return D;});
sap.ui.predefine('sap/m/ExpandableText',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/library','sap/ui/Device','sap/ui/base/ManagedObject','sap/m/Link','sap/m/Text','sap/m/Button','sap/m/ResponsivePopover','sap/m/HyphenationSupport',"./ExpandableTextRenderer"],function(l,C,a,c,D,M,L,T,B,R,H,E){"use strict";var r=C.getLibraryResourceBundle("sap.m");var b=r.getText("EXPANDABLE_TEXT_SHOW_MORE");var d=r.getText("EXPANDABLE_TEXT_SHOW_LESS");var e=r.getText("MSGBOX_CLOSE");var f=c.TextAlign;var g=c.TextDirection;var A=c.aria.HasPopup;var W=l.WrappingType;var P=l.PlacementType;var h=l.ExpandableTextOverflowMode;var i=l.EmptyIndicatorMode;
function j(t){return t.replace(/ {2,}/g,' ').replace(/\t{2,}/g,' ');}
var k=a.extend("sap.m.ExpandableText",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.m.IHyphenation"],library:"sap.m",properties:{text:{type:"string",defaultValue:'',bindable:"bindable"},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:f.Begin},renderWhitespace:{type:"boolean",group:"Appearance",defaultValue:false},overflowMode:{type:"sap.m.ExpandableTextOverflowMode",group:"Appearance",defaultValue:h.InPlace},maxCharacters:{type:"int",group:"Appearance",defaultValue:100},expanded:{type:"boolean",group:"Appearance",defaultValue:false,visibility:"hidden"},emptyIndicatorMode:{type:"sap.m.EmptyIndicatorMode",group:"Appearance",defaultValue:i.Off}},aggregations:{_showMoreLink:{type:'sap.m.Link',multiple:false,visibility:"hidden"}},designtime:"sap/m/designtime/ExpandableText.designtime"}});
k.prototype.getText=function(n){var t=this.getProperty("text");if(n){return t.replace(/\r\n|\n\r|\r/g,"\n");}return t;};
k.prototype.getTextDomRef=function(){if(!this.getVisible()){return null;}return this.getDomRef("string");};
k.prototype._isExpandable=function(){var t=this.getText();if(!this.getRenderWhitespace()){t=j(t);}return t.length>this._getMaxCharacters()+b.length;};
k.prototype._getMaxCharacters=function(){return Math.max(0,this.getMaxCharacters());};
k.prototype._getDisplayedText=function(){var t=this.getText(true);if(this.getProperty("expanded")||!this._isExpandable()){return t;}if(!this.getRenderWhitespace()){t=j(t);}return t.substring(0,this._getMaxCharacters());};
k.prototype._getShowMoreLink=function(){var s=this.getAggregation('_showMoreLink');if(!s){s=new L(this.getId()+'-showMoreLink',{text:this.getProperty("expanded")?d:b,press:function(o){var t,m,p;if(this.getOverflowMode()===h.InPlace){m=!this.getProperty("expanded");s.setText(m?d:b);this.setProperty("expanded",m);}else{t=new T({text:M.escapeSettingsValue(this.getText()),textDirection:this.getTextDirection(),wrappingType:this.getWrappingType(),textAlign:this.getTextAlign(),renderWhitespace:this.getRenderWhitespace()}).addStyleClass("sapUiSmallMargin").addStyleClass("sapMExTextPopover");p=this._oPopover;if(p&&p.isOpen()){p.close();return;}if(!p){p=this._oPopover=new R({showHeader:false,placement:P.HorizontalPreferredRight,beforeClose:this._onPopoverBeforeClose.bind(this)});if(D.system.phone){p.setEndButton(new B({text:e,press:function(){p.close();}}));}this.addDependent(p);}s.setText(d);s.rerender();p.removeAllAriaLabelledBy();p.destroyContent();p.addAriaLabelledBy(t);p.addContent(t);p.openBy(o.getSource());}}.bind(this)});this.setAggregation("_showMoreLink",s,true);}s.setAriaHasPopup(this.getOverflowMode()===h.InPlace?A.None:A.Dialog);return s;};
k.prototype._onPopoverBeforeClose=function(){this._getShowMoreLink().setText(b);};
k.prototype.exit=function(){if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}};
k.prototype.getAccessibilityInfo=function(){return{description:this.getText()};};
k.prototype.getTextsToBeHyphenated=function(){return{"main":this._getDisplayedText(true)};};
k.prototype.getDomRefsForHyphenatedTexts=function(){return{"main":this.getTextDomRef()};};
H.mixInto(k.prototype);return k;});
sap.ui.predefine('sap/m/ExpandableTextRenderer',['sap/ui/core/Core','sap/ui/core/Renderer','sap/ui/core/library','sap/m/HyphenationSupport','./library'],function(C,R,c,H,m){"use strict";var T=c.TextDirection;var W=m.WrappingType;var E=m.EmptyIndicatorMode;var r=C.getLibraryResourceBundle("sap.m");var a={apiVersion:2};
a.render=function(o,t){var d=t._getDisplayedText(),s=t.getTextDirection(),b=t.getTooltip_AsString(),w=t.getWrappingType(),e=t.getTextAlign(),f=t.getRenderWhitespace(),g=t._isExpandable(),h=t.getProperty("expanded"),i=h?" ":"... ";o.openStart("div",t);o.class("sapMExText");o.class("sapUiSelectable");if(w!==W.Hyphenated){if(d&&d.length>0&&!/\s/.test(d)){o.class("sapMExTextBreakWord");}}o.attr("dir",s!==T.Inherit?s.toLowerCase():"auto");if(b){o.attr("title",b);}if(e){e=R.getTextAlign(e,s);if(e){o.style("text-align",e);}}if(f){o.class("sapMExTextRenderWhitespaceWrap");}H.writeHyphenationClass(o,t);o.openEnd();o.openStart("span",t.getId()+"-string");o.class("sapMExTextString");o.openEnd();a.renderText(o,t);o.close("span");if(g){o.openStart("span");o.class("sapMExTextEllipsis");o.openEnd();o.unsafeHtml(i);o.close("span");o.renderControl(t._getShowMoreLink());}o.close("div");};
a.renderText=function(o,t){if(t.getEmptyIndicatorMode()!==E.Off&&!t.getText()){this.renderEmptyIndicator(o,t);}else{o.text(H.getTextForRender(t,"main"));}};
a.renderEmptyIndicator=function(o,t){o.openStart("span");o.class("sapMEmptyIndicator");if(t.getEmptyIndicatorMode()===E.Auto){o.class("sapMEmptyIndicatorAuto");}o.openEnd();o.openStart("span");o.attr("aria-hidden",true);o.openEnd();o.text(r.getText("EMPTY_INDICATOR"));o.close("span");o.openStart("span");o.class("sapUiPseudoInvisibleText");o.openEnd();o.text(r.getText("EMPTY_INDICATOR_TEXT"));o.close("span");o.close("span");};
return a;},true);
sap.ui.predefine('sap/m/FacetFilter',['./NavContainer','./library','sap/ui/core/Control','sap/ui/core/CustomData','sap/ui/core/IconPool','sap/ui/core/delegate/ItemNavigation','sap/ui/core/InvisibleText','sap/ui/core/IntervalTrigger','sap/ui/Device','sap/ui/core/Icon','sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/model/json/JSONModel','./FacetFilterRenderer',"sap/ui/events/KeyCodes","sap/base/assert","sap/base/Log","sap/ui/events/jquery/EventSimulation","sap/ui/thirdparty/jquery","sap/m/Button","sap/m/ToolbarSpacer","sap/m/OverflowToolbar","sap/m/Text","sap/m/Toolbar","sap/m/Popover","sap/m/SearchField","sap/m/Bar","sap/m/Dialog","sap/m/List","sap/m/StandardListItem","sap/m/CheckBox","sap/m/Page","sap/ui/dom/jquery/scrollRightRTL","sap/ui/dom/jquery/scrollLeftRTL","sap/ui/dom/jquery/Selectors"],function(N,l,C,a,I,b,c,d,D,e,F,f,J,g,K,h,L,E,q,B,T,O,m,n,P,S,o,p,r,s,t,u){"use strict";var v=l.ToolbarDesign;var w=l.ListType;var x=l.ListMode;var y=l.FacetFilterListDataType;var z=l.ButtonType;var A=l.PlacementType;var G=l.FacetFilterType;var H=500;
var M=C.extend("sap.m.FacetFilter",{metadata:{interfaces:["sap.ui.core.IShrinkable"],library:"sap.m",properties:{showPersonalization:{type:"boolean",group:"Appearance",defaultValue:false},type:{type:"sap.m.FacetFilterType",group:"Appearance",defaultValue:G.Simple},liveSearch:{type:"boolean",group:"Behavior",defaultValue:true},showSummaryBar:{type:"boolean",group:"Behavior",defaultValue:false},showReset:{type:"boolean",group:"Behavior",defaultValue:true},showPopoverOKButton:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"lists",aggregations:{lists:{type:"sap.m.FacetFilterList",multiple:true,singularName:"list"},buttons:{type:"sap.m.Button",multiple:true,singularName:"button",visibility:"hidden"},removeFacetIcons:{type:"sap.ui.core.Icon",multiple:true,singularName:"removeFacetIcon",visibility:"hidden"},popover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"},addFacetButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},dialog:{type:"sap.m.Dialog",multiple:false,visibility:"hidden"},summaryBar:{type:"sap.m.Toolbar",multiple:false,visibility:"hidden"},resetButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},arrowLeft:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},arrowRight:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},events:{reset:{},confirm:{}}}});
M.SCROLL_STEP=264;
M.prototype.setType=function(i){var j,k;if(D.system.phone){this.setProperty("type",G.Light);k=true;}else{this.setProperty("type",i);k=(i===G.Light);}j=this._getSummaryBar();j.setActive(k);if(i===G.Light){if(this.getShowReset()){this._addResetToSummary(j);}else{this._removeResetFromSummary(j);}}return this;};
M.prototype.setShowReset=function(V){this.setProperty("showReset",V);var i=this._getSummaryBar();if(V){if(this.getShowSummaryBar()||this.getType()===G.Light){this._addResetToSummary(i);}}else{if(this.getShowSummaryBar()||this.getType()===G.Light){this._removeResetFromSummary(i);}}return this;};
M.prototype.setShowSummaryBar=function(V){this.setProperty("showSummaryBar",V);if(V){var i=this._getSummaryBar();if(this.getShowReset()){this._addResetToSummary(i);}else{this._removeResetFromSummary(i);}i.setActive(this.getType()===G.Light);}return this;};
M.prototype.setLiveSearch=function(V){this.setProperty("liveSearch",V);if(this._displayedList){var i=this._displayedList;var j=sap.ui.getCore().byId(i.getAssociation("search"));j.detachLiveChange(i._handleSearchEvent,i);if(V){j.attachLiveChange(i._handleSearchEvent,i);}}return this;};
M.prototype.getLists=function(){var i=this.getAggregation("lists");if(!i){i=[];}if(this._displayedList){i.splice(this._listAggrIndex,0,this._displayedList);}i.forEach(function(j){if(!j.hasListeners("listItemsChange")){j.attachEvent("listItemsChange",_.bind(this));}}.bind(this));return i;};
function _(i){var j=i.getSource();if(this._oAllCheckBoxBar){this._oAllCheckBoxBar.setVisible(Boolean(j.getItems(true).length));}}
M.prototype.removeAggregation=function(){var i=C.prototype.removeAggregation.apply(this,arguments);if(arguments[0]==="lists"){this._removeList(i);}return i;};
M.prototype.openFilterDialog=function(){var i=this._getFacetDialog();var j=this._getFacetDialogNavContainer();i.addContent(j);this.getLists().forEach(function(k){if(k.getMode()===x.MultiSelect){k._preserveOriginalActiveState();}});i.setInitialFocus(j.getPages()[0].getContent()[0].getItems()[0]);i.open();return this;};
M.prototype.init=function(){this._pageSize=5;this._invalidateFlag=false;this._lastCategoryFocusIndex=0;this._aDomRefs=null;this._previousTarget=null;this._addTarget=null;this._aRows=null;this._bundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.data("sap-ui-fastnavgroup","true",true);this._buttons={};this._aOwnedLabels=[];this._removeFacetIcons={};this._listAggrIndex=-1;this._displayedList=null;this._lastScrolling=false;this._bPreviousScrollForward=false;this._bPreviousScrollBack=false;this._popoverClosing=false;this._getAddFacetButton();this.setAggregation("resetButton",this._createResetButton());if(E.touchEventMode==="ON"&&!D.system.phone){this._enableTouchSupport();}if(D.system.phone){this.setType(G.Light);}};
M.prototype.exit=function(){var i;d.removeListener(this._checkOverflow,this);if(this.oItemNavigation){this.removeDelegate(this.oItemNavigation);this.oItemNavigation.destroy();}if(this._aOwnedLabels){this._aOwnedLabels.forEach(function(j){i=sap.ui.getCore().byId(j);if(i){i.destroy();}});this._aOwnedLabels=null;}if(this._oAllCheckBoxBar){this._oAllCheckBoxBar=undefined;}};
M.prototype.onBeforeRendering=function(){if(this.getShowSummaryBar()||this.getType()===G.Light){var i=this._getSummaryBar();var j=i.getContent()[0];j.setText(this._getSummaryText());}d.removeListener(this._checkOverflow,this);};
M.prototype.onAfterRendering=function(){var i=this.getShowSummaryBar(),j=this.getType(),k=this._getSummaryBar().$();if(j!==G.Light&&!D.system.phone){d.addListener(this._checkOverflow,this);}if(j!==G.Light){this._startItemNavigation();this.addDelegate(this.oItemNavigation);}if(j===G.Light){k.attr("aria-roledescription",this._bundle.getText("FACETFILTER_ACTIVE_TITLE"));k.attr("role","group");}else if(i){k.attr("aria-roledescription",this._bundle.getText("FACETFILTER_TITLE"));}};
M.prototype._startItemNavigation=function(){var j=this.getDomRef(),R=j.getElementsByClassName("sapMFFHead"),k=[];if(R.length>0){for(var i=0;i<R[0].childNodes.length;i++){if(R[0].childNodes[i].id.indexOf("ff")<0&&R[0].childNodes[i].id.indexOf("icon")<0&&R[0].childNodes[i].id.indexOf("add")<0){k.push(R[0].childNodes[i]);}if(R[0].childNodes[i].id.indexOf("add")>=0){k.push(R[0].childNodes[i]);}}}if(k!=""){this._aDomRefs=k;}if(!this.oItemNavigation){this.oItemNavigation=new b();}this._aRows=R;for(var i=0;i<this.$().find(":sapTabbable").length;i++){if(this.$().find(":sapTabbable")[i].id.indexOf("add")>=0){this._addTarget=this.$().find(":sapTabbable")[i];break;}}this.oItemNavigation.setRootDomRef(j);if(this._invalidateFlag==true){this.oItemNavigation.setFocusedIndex(-1);this.focus();this._invalidateFlag=false;}this.oItemNavigation.setItemDomRefs(k);this.oItemNavigation.setCycling(false);this.oItemNavigation.setPageSize(this._pageSize);};
M.prototype.onsapdelete=function(i){var j,Q;if(this.getType()===G.Light){return;}if(!this.getShowPersonalization()){return;}j=sap.ui.getCore().byId(i.target.id);if(!j){return;}Q=sap.ui.getCore().byId(j.getAssociation("list"));if(!Q){return;}if(!Q.getShowRemoveFacetIcon()){return;}Q.removeSelections(true);Q.setSelectedKeys();Q.setProperty("active",false,true);this.invalidate();var $=this.$().find(":sapTabbable");q($[$.length-1]).trigger("focus");var R=this.oItemNavigation.getFocusedIndex();q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(R+1);this.focus();if(this.oItemNavigation.getFocusedIndex()==0){for(var k=0;k<this.$().find(":sapTabbable").length-1;k++){if($[k].id.indexOf("add")>=0){q($[k]).trigger("focus");}}}};
M.prototype.onsaptabnext=function(j){if(this.getType()===G.Light){return;}this._previousTarget=j.target;if(j.target.parentNode.className=="sapMFFHead"){for(var i=0;i<this.$().find(":sapTabbable").length;i++){if(this.$().find(":sapTabbable")[i].parentNode.className=="sapMFFResetDiv"){q(this.$().find(":sapTabbable")[i]).trigger("focus");this._invalidateFlag=false;j.preventDefault();j.setMarked();return;}}}this._lastCategoryFocusIndex=this.oItemNavigation.getFocusedIndex();if(this._invalidateFlag==true){this.oItemNavigation.setFocusedIndex(-1);this.focus();this._invalidateFlag=false;}};
M.prototype.onsaptabprevious=function(i){if(this.getType()===G.Light){return;}if(i.target.parentNode.className=="sapMFFResetDiv"&&this._previousTarget==null){q(this.$().find(":sapTabbable")[0]).trigger("focus");i.preventDefault();i.setMarked();return;}if(i.target.parentNode.className=="sapMFFResetDiv"&&this._previousTarget!=null&&this._previousTarget.id!=i.target.id){q(this._previousTarget).trigger("focus");i.preventDefault();i.setMarked();return;}if(i.target.id.indexOf("add")>=0||i.target.parentNode.className=="sapMFFHead"){this._previousTarget=i.target;q(this.$().find(":sapTabbable")[0]).trigger("focus");}};
M.prototype.onsapend=function(i){if(this.getType()===G.Light){return;}if(this._addTarget!=null){q(this._addTarget).trigger("focus");i.preventDefault();i.setMarked();}else{q(this._aRows[this._aRows.length-1]).trigger("focus");i.preventDefault();i.setMarked();}this._previousTarget=i.target;};
M.prototype.onsaphome=function(i){if(this.getType()===G.Light){return;}q(this._aRows[0]).trigger("focus");i.preventDefault();i.setMarked();this._previousTarget=i.target;};
M.prototype.onsappageup=function(i){this._previousTarget=i.target;};
M.prototype.onsappagedown=function(i){this._previousTarget=i.target;};
M.prototype.onsapincreasemodifiers=function(i){if(this.getType()===G.Light){return;}if(i.which==K.ARROW_RIGHT){this._previousTarget=i.target;var j=this.oItemNavigation.getFocusedIndex()-1;var k=j+this._pageSize;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(k);this.focus();}};
M.prototype.onsapdecreasemodifiers=function(i){if(this.getType()===G.Light){return;}var j=0;if(i.which==K.ARROW_LEFT){this._previousTarget=i.target;j=this.oItemNavigation.getFocusedIndex()+1;var k=j-this._pageSize;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(k);this.focus();}};
M.prototype.onsapdownmodifiers=function(i){if(this.getType()===G.Light){return;}this._previousTarget=i.target;var j=0;j=this.oItemNavigation.getFocusedIndex()-1;var k=j+this._pageSize;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(k);this.focus();};
M.prototype.onsapupmodifiers=function(i){if(this.getType()===G.Light){return;}this._previousTarget=i.target;var j=0;j=this.oItemNavigation.getFocusedIndex();if(j!=0){j=j+1;}var k=j-this._pageSize;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(k);this.focus();};
M.prototype.onsapexpand=function(i){if(this.getType()===G.Light){return;}this._previousTarget=i.target;var j=this.oItemNavigation.getFocusedIndex()+1;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(j);this.focus();};
M.prototype.onsapcollapse=function(i){if(this.getType()===G.Light){return;}this._previousTarget=i.target;var j=this.oItemNavigation.getFocusedIndex()-1;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(j);this.focus();};
M.prototype.onsapdown=function(i){if(this.getType()===G.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).trigger("focus");i.preventDefault();i.setMarked();return;}};
M.prototype.onsapup=function(i){if(this.getType()===G.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).trigger("focus");i.preventDefault();i.setMarked();}};
M.prototype.onsapleft=function(i){if(this.getType()===G.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).trigger("focus");i.preventDefault();i.setMarked();}var j=this.oItemNavigation.aItemDomRefs,k=this.oItemNavigation.getFocusedIndex(),Q=k-1>=0?k-1:k,R=q(j[Q]).control(0),U=this._calculateScrollIntoView(R);this._scroll(U,H);};
M.prototype.onsapright=function(i){if(this.getType()===G.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).trigger("focus");i.preventDefault();i.setMarked();}var j=this.oItemNavigation.aItemDomRefs,k=this.oItemNavigation.getFocusedIndex(),Q=j.length>k+1?k+1:k,R=q(j[Q]).control(0),U=this._calculateScrollIntoView(R);this._scroll(U,H);};
M.prototype.onsapescape=function(i){if(this.getType()===G.Light){return;}if(i.target.parentNode.className=="sapMFFResetDiv"){return;}var j=this._lastCategoryFocusIndex;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(j);this.focus();};
M.prototype._getPopover=function(){var i=this.getAggregation("popover");if(!i){var j=this;i=new P({placement:A.Bottom,beforeOpen:function(Q){if(j._displayedList){j._displayedList._bSearchEventDefaultBehavior&&j._displayedList._setSearchValue("");}this.setCustomHeader(j._createFilterItemsSearchFieldBar(j._displayedList));var R=this.getSubHeader();if(!R){this.setSubHeader(j._createSelectAllCheckboxBar(j._displayedList));}k(j._displayedList);},beforeClose:function(){j._popoverClosing=true;},afterClose:function(Q){this._popoverClosing=false;j._handlePopoverAfterClose();},horizontalScrolling:false});this.setAggregation("popover",i,true);i.setContentWidth("30%");i.addStyleClass("sapMFFPop");var k=function(Q){if(!Q){return;}var R=j._getFacetRemoveIcon(Q);if(R){R._bTouchStarted=false;}};}if(this.getShowPopoverOKButton()){this._addOKButtonToPopover(i);}else{i.destroyAggregation("footer");}return i;};
M.prototype._handlePopoverAfterClose=function(){var i=this.getAggregation("popover"),j=this._displayedList;if(!i){return;}var k=this._getFacetRemoveIcon(j);if(k&&k._bTouchStarted){return;}this._restoreListFromDisplayContainer(i);this._displayRemoveIcon(false,j);j._fireListCloseEvent();this._fireConfirmEvent();this.destroyAggregation("popover");if(this._oOpenPopoverDeferred){setTimeout(function(){this._oOpenPopoverDeferred.resolve();this._oOpenPopoverDeferred=undefined;}.bind(this),0);}};
M.prototype._fireConfirmEvent=function(){this.fireEvent('confirm');};
M.prototype._openPopover=function(i,j){var k;if(!i.isOpen()){var Q=sap.ui.getCore().byId(j.getAssociation("list"));h(Q,"The facet filter button should be associated with a list.");k=!Q.fireListOpen({});this._moveListToDisplayContainer(Q,i);i.openBy(j);if(Q.getShowRemoveFacetIcon()){this._displayRemoveIcon(true,Q);}if(Q.getWordWrap()){i.setContentWidth("30%");}if(!k){Q._applySearch();}}return this;};
M.prototype._getAddFacetButton=function(){var i=this.getAggregation("addFacetButton");if(!i){i=new B(this.getId()+"-add",{icon:I.getIconURI("add-filter"),type:z.Transparent,tooltip:this._bundle.getText("FACETFILTER_ADDFACET"),press:function(j){this.openFilterDialog();}.bind(this)});this.setAggregation("addFacetButton",i,true);}return i;};
M.prototype._getButtonForList=function(i){if(this._buttons[i.getId()]){this._setButtonText(i);return this._buttons[i.getId()];}var j=this;var k=new B({type:z.Transparent,press:function(Q){var R=this;var U=function(){var V=j._getPopover();j._openPopover(V,R);};if(i.getMode()===x.MultiSelect){i._preserveOriginalActiveState();}var V=j._getPopover();if(V.isOpen()){setTimeout(function(){if(V.isOpen()){return;}j._oOpenPopoverDeferred=q.Deferred();j._oOpenPopoverDeferred.promise().done(U);},100);}else{setTimeout(U.bind(this),100);}}});this._buttons[i.getId()]=k;this.addAggregation("buttons",k);k.setAssociation("list",i.getId(),true);this._setButtonText(i);return k;};
M.prototype._setButtonText=function(i){var j=this._buttons[i.getId()];if(i._iAllItemsCount===undefined&&i.getMaxItemsCount()||!i._bSearchEventDefaultBehavior){i._iAllItemsCount=i.getMaxItemsCount();}if(j){var k="";var Q=Object.getOwnPropertyNames(i._oSelectedKeys);var R=Q.length;if(R===1){var U=i._oSelectedKeys[Q[0]];k=this._bundle.getText("FACETFILTER_ITEM_SELECTION",[i.getTitle(),U]);}else if(R>0&&R===(i._iAllItemsCount?i._iAllItemsCount:0)){k=this._bundle.getText("FACETFILTER_ALL_SELECTED",[i.getTitle()]);}else if(R>0){k=this._bundle.getText("FACETFILTER_ITEM_SELECTION",[i.getTitle(),R]);}else{k=i.getTitle();}j.setText(k);}};
M.prototype._getFacetRemoveIcon=function(i){var j=this,k=this._removeFacetIcons[i.getId()];if(!k){k=new e({src:I.getIconURI("decline"),tooltip:this._bundle.getText("FACETFILTER_REMOVE"),press:function(){k._bPressed=true;}});k.addDelegate({ontouchstart:function(){k._bTouchStarted=true;k._bPressed=false;},ontouchend:function(){j._displayRemoveIcon(false,i);k._bTouchStarted=false;setTimeout(Q.bind(this),100);}},true);var Q=function(){if(k._bPressed){i.removeSelections(true);i.setSelectedKeys();i.setProperty("active",false,true);}j._handlePopoverAfterClose();};k.setAssociation("list",i.getId(),true);k.addStyleClass("sapMFFLRemoveIcon");this._removeFacetIcons[i.getId()]=k;this.addAggregation("removeFacetIcons",k);this._displayRemoveIcon(false,i);}return k;};
M.prototype._displayRemoveIcon=function(i,j){if(this.getShowPersonalization()){var k=this._removeFacetIcons[j.getId()];if(i){k.removeStyleClass("sapMFFLHiddenRemoveIcon");k.addStyleClass("sapMFFLVisibleRemoveIcon");}else{k.removeStyleClass("sapMFFLVisibleRemoveIcon");k.addStyleClass("sapMFFLHiddenRemoveIcon");}}};
M.prototype._getFacetDialogNavContainer=function(){var i=new N({autoFocus:false});var j=this._createFacetPage();i.addPage(j);i.setInitialPage(j);i.attachAfterNavigate(function(k){var Q=k.getParameters()["to"];var R=k.getParameters()['from'];if(R===j){var U=(this._displayedList.getMode()===x.MultiSelect)?Q.getContent(0)[1].getItems()[0]:Q.getContent(0)[0].getItems()[0];if(U){U.focus();}else if(Q.getContent()[1]){Q.getContent()[1].focus();}}if(Q===j){R.destroySubHeader();h(this._displayedList===null,"Filter items list should have been placed back in the FacetFilter aggregation before page content is destroyed.");R.destroyContent();this._selectedFacetItem.invalidate();Q.invalidate();this._selectedFacetItem.focus();this._selectedFacetItem=null;}}.bind(this));return i;};
M.prototype._createFacetPage=function(){var i=this._createFacetList();var j=new S({width:"100%",tooltip:this._bundle.getText("FACETFILTER_SEARCH"),liveChange:function(Q){var R=i.getBinding("items");if(R){var U=new F("text",f.Contains,Q.getParameters()["newValue"]);R.filter([U]);}}});var k=new u({enableScrolling:true,title:this._bundle.getText("FACETFILTER_TITLE"),subHeader:new o({contentMiddle:j}),content:[i]});return k;};
M.prototype._createFilterItemsPage=function(){var i=new u({showNavButton:true,enableScrolling:true,navButtonPress:function(j){var k=j.getSource().getParent();this._navFromFilterItemsPage(k);}.bind(this)});return i;};
M.prototype._getFilterItemsPage=function(i){var j=i.getPages()[1];if(j){i.removePage(j);j.destroy();}var k=this._createFilterItemsPage();i.addPage(k);return k;};
M.prototype._createFilterItemsSearchFieldBar=function(i){var j=true;if(i.getDataType()!=y.String){j=false;}var k=new S({value:i._getSearchValue(),width:"100%",enabled:j,tooltip:this._bundle.getText("FACETFILTER_SEARCH"),search:function(R){this._displayedList._handleSearchEvent(R);}.bind(this)});if(this.getLiveSearch()){k.attachLiveChange(i._handleSearchEvent,i);}var Q=new o({contentMiddle:k});i.setAssociation("search",k);return Q;};
M.prototype._getFacetDialog=function(){var i=this.getAggregation("dialog");if(!i){var j=this;i=new p({showHeader:false,stretch:D.system.phone?true:false,afterClose:function(){j._invalidateFlag=true;var k=this.getContent()[0];var Q=k.getPages()[1];if(k.getCurrentPage()===Q){var R=j._restoreListFromDisplayContainer(Q);if(R.getMode()===x.MultiSelect){R._updateActiveState();j._bCheckForAddListBtn=true;}R._fireListCloseEvent();R._bSearchEventDefaultBehavior&&R._search("");}this.destroyAggregation("content",true);j.invalidate();},beginButton:new B({text:this._bundle.getText("FACETFILTER_ACCEPT"),tooltip:this._bundle.getText("FACETFILTER_ACCEPT"),press:function(){j._closeDialog();}}),contentHeight:"500px",ariaLabelledBy:[c.getStaticId("sap.m","FACETFILTER_AVAILABLE_FILTER_NAMES")]});i.addStyleClass("sapMFFDialog");i.onsapentermodifiers=function(k){if(k.shiftKey&&!k.ctrlKey&&!k.altKey){var Q=this.getContent()[0];j._navFromFilterItemsPage(Q);}};this.setAggregation("dialog",i,true);}return i;};
M.prototype._closeDialog=function(){var i=this.getAggregation("dialog");if(i&&i.isOpen()){i.close();this._fireConfirmEvent();}};
M.prototype._closePopover=function(){var i=this.getAggregation("popover");if(i&&i.isOpen()){i.close();}};
M.prototype._createFacetList=function(){var j=this._oFacetList=new r({mode:x.None,items:{path:"/items",template:new s({title:"{text}",counter:"{count}",type:w.Navigation,customData:[new a({key:"index",value:"{index}"})]})}});var k=this._getMapFacetLists();var Q=new J({items:k});if(k.length>100){Q.setSizeLimit(k.length);}var R=this;j.attachUpdateFinished(function(){for(var i=0;i<j.getItems().length;i++){var U=this.getItems()[i];U.detachPress(R._handleFacetListItemPress,R);U.attachPress(R._handleFacetListItemPress,R);}});j.setModel(Q);return j;};
M.prototype.refreshFacetList=function(){this._oFacetList.getModel().setData({items:this._getMapFacetLists()});return this;};
M.prototype._getMapFacetLists=function(){return this.getLists().map(function(i,j){return{text:i.getTitle(),count:i.getAllCount(),index:j};});};
M.prototype._createSelectAllCheckboxBar=function(i){if(!i.getMultiSelect()){return null;}var j=i.getActive()&&i.getItems().length>0&&Object.getOwnPropertyNames(i._oSelectedKeys).length===i.getItems().length;var k=new t(i.getId()+"-selectAll",{text:this._bundle.getText("FACETFILTER_CHECKBOX_ALL"),tooltip:this._bundle.getText("FACETFILTER_CHECKBOX_ALL"),selected:j,select:function(R){k.setSelected(R.getParameter("selected"));i._handleSelectAllClick(R.getParameter("selected"));}});i.setAssociation("allcheckbox",k);var Q=new o({visible:Boolean(i.getItems(true).length)});Q.addEventDelegate({ontap:function(R){if(R.srcControl===this){i._handleSelectAllClick(k.getSelected());}}},Q);Q.addContentLeft(k);Q.addStyleClass("sapMFFCheckbar");this._oAllCheckBoxBar=Q;return Q;};
M.prototype._handleFacetListItemPress=function(i){this._navToFilterItemsPage(i.getSource());};
M.prototype._navToFilterItemsPage=function(i){this._selectedFacetItem=i;var j=this.getAggregation("dialog").getContent()[0];var k=i.getCustomData();h(k.length===1,"There should be exactly one custom data for the original facet list item index");var Q=k[0].getValue();var R=this.getLists()[Q];this._listIndexAgg=this.indexOfAggregation("lists",R);if(this._listIndexAgg==Q){var U=this._getFilterItemsPage(j);R.fireListOpen({});this._moveListToDisplayContainer(R,U);U.setSubHeader(this._createFilterItemsSearchFieldBar(R));var V=this._createSelectAllCheckboxBar(R);if(V){U.insertContent(V,0);}U.setTitle(R.getTitle());j.to(U);}};
M.prototype._navFromFilterItemsPage=function(i){var j=i.getPages()[1];var k=this._restoreListFromDisplayContainer(j);if(k.getMode()===x.MultiSelect){k._updateActiveState();}k._fireListCloseEvent();k._bSearchEventDefaultBehavior&&k._search("");this._selectedFacetItem.setCounter(k.getAllCount());i.backToTop();};
M.prototype._moveListToDisplayContainer=function(i,j){this._listAggrIndex=this.indexOfAggregation("lists",i);h(this._listAggrIndex>-1,"The lists index should be valid.");C.prototype.removeAggregation.call(this,"lists",i,true);j.addAggregation("content",i,false);i.setAssociation("facetFilter",this,true);this._displayedList=i;};
M.prototype._restoreListFromDisplayContainer=function(i){var j=i.removeAggregation("content",this._displayedList,true);this.insertAggregation("lists",j,this._listAggrIndex,j.getActive());this._listAggrIndex=-1;this._displayedList=null;return j;};
M.prototype._getSequencedLists=function(){var k=-1;var Q=[];var R=this.getLists();if(R.length>0){for(var i=0;i<R.length;i++){if(R[i].getActive()){if(R[i].getSequence()<-1){R[i].setSequence(-1);}else if(R[i].getSequence()>k){k=R[i].getSequence();}Q.push(R[i]);}else if(!R[i].getRetainListSequence()){R[i].setSequence(-1);}}for(var j=0;j<Q.length;j++){if(Q[j].getSequence()<=-1){k+=1;Q[j].setSequence(k);}}if(Q.length>1){Q.sort(function(U,V){return U.getSequence()-V.getSequence();});}}return Q;};
M.prototype._getSummaryBar=function(){var i=this.getAggregation("summaryBar"),j=this.getType();if(!i){var k=new m({maxLines:1});i=new n({content:[k],active:j===G.Light?true:false,design:v.Info,ariaLabelledBy:k,press:function(Q){this.openFilterDialog();}.bind(this)});i._setRootAccessibilityRole("group");this.setAggregation("summaryBar",i);}return i;};
M.prototype._handleReset=function(){this.fireReset();this.invalidate();};
M.prototype._createResetButton=function(){var j=new B({type:z.Transparent,icon:I.getIconURI("undo"),tooltip:this._bundle.getText("FACETFILTER_RESET"),press:function(k){this._invalidateFlag=true;if(this._popoverClosing){setTimeout(this._handleReset.bind(this),P.prototype._getAnimationDuration());}else{this._handleReset();}var Q=this.getLists();for(var i=0;i<Q.length;i++){Q[i]._setSearchValue("");Q[i]._applySearch();var R=Q[i].getItems()[0];if(R){R.focus();}}}.bind(this)});return j;};
M.prototype._addOKButtonToPopover=function(i){var j=i.getFooter(),k;if(!j){k=new B({text:this._bundle.getText("FACETFILTER_ACCEPT"),tooltip:this._bundle.getText("FACETFILTER_ACCEPT"),press:function(){this._closePopover();}.bind(this)});j=new O({content:[new T(),k]});i.setFooter(j);}};
M.prototype._getSummaryText=function(){var k=", ";var Q=" ";var R="";var U=true;var V=this.getLists();if(V.length>0){for(var i=0;i<V.length;i++){var W=V[i];if(W.getActive()){var X=this._getSelectedItemsText(W);var Y="";for(var j=0;j<X.length;j++){Y=Y+X[j]+k;}if(Y){Y=Y.substring(0,Y.lastIndexOf(k)).trim();if(U){R=this._bundle.getText("FACETFILTER_INFOBAR_FILTERED_BY",[W.getTitle(),Y]);U=false;}else{R=R+Q+this._bundle.getText("FACETFILTER_INFOBAR_AND")+Q+this._bundle.getText("FACETFILTER_INFOBAR_AFTER_AND",[W.getTitle(),Y]);}}}}}if(!R){R=this._bundle.getText("FACETFILTER_INFOBAR_NO_FILTERS");}return R;};
M.prototype._getSelectedItemsText=function(i){var j=i.getSelectedItems().map(function(k){return k.getText();});i._oSelectedKeys&&Object.getOwnPropertyNames(i._oSelectedKeys).forEach(function(k){j.indexOf(i._oSelectedKeys[k])===-1&&j.push(i._oSelectedKeys[k]);});return j;};
M.prototype._addResetToSummary=function(i){if(i.getContent().length===1){i.addContent(new T({width:""}));var j=this._createResetButton();i.addContent(j);j.addStyleClass("sapUiSizeCompact");j.addStyleClass("sapMFFRefresh");j.addStyleClass("sapMFFBtnHoverable");}};
M.prototype._removeResetFromSummary=function(i){if(i.getContent().length===3){var j=i.removeAggregation("content",1);j.destroy();var k=i.removeAggregation("content",1);k.destroy();}};
M.prototype._removeList=function(i){if(i){var j=this._buttons[i.getId()];if(j){this.removeAggregation("buttons",j);j.destroy();}var R=this._removeFacetIcons[i.getId()];if(R){this.removeAggregation("removeIcons",R);R.destroy();}delete this._buttons[i.getId()];delete this._removeFacetIcons[i.getId()];}};
M.prototype._calculateScrollIntoView=function(i){var j=this.$("head").width(),k=0;if(!j||!i){return k;}var $=i.$(),Q=$.outerWidth(true),R=$.position().left,U=R+Q;if(U>j){k=U-j;}else if(R<0){k=R;}return k;};
M.prototype._getScrollingArrow=function(j){var k=null;var Q={src:"sap-icon://navigation-"+j+"-arrow"};if(j==="left"){k=this.getAggregation("arrowLeft");if(!k){Q.id=this.getId()+"-arrowScrollLeft";k=I.createControlByURI(Q);var R=["sapMPointer","sapMFFArrowScroll","sapMFFArrowScrollLeft"];for(var i=0;i<R.length;i++){k.addStyleClass(R[i]);k.setTooltip(this._bundle.getText("FACETFILTER_PREVIOUS"));}this.setAggregation("arrowLeft",k);}}else if(j==="right"){k=this.getAggregation("arrowRight");if(!k){Q.id=this.getId()+"-arrowScrollRight";k=I.createControlByURI(Q);var U=["sapMPointer","sapMFFArrowScroll","sapMFFArrowScrollRight"];for(var i=0;i<U.length;i++){k.addStyleClass(U[i]);k.setTooltip(this._bundle.getText("FACETFILTER_NEXT"));}this.setAggregation("arrowRight",k);}}else{L.error("Scrolling arrow name "+j+" is not valid");}return k;};
M.prototype._checkOverflow=function(){var i=this.getDomRef("head"),$=q(i),j=this.$(),k=false,Q=false,R=false,U=null,V=null,W=null;if(i){U=i.scrollLeft;V=i.scrollWidth;W=i.clientWidth;if(V>W){if(V-W==1){V=W;}else{R=true;}}j.toggleClass("sapMFFScrolling",R);j.toggleClass("sapMFFNoScrolling",!R);this._lastScrolling=R;if(!this._bRtl){k=U>0;Q=(V>W)&&(V>U+W);}else{Q=$.scrollLeftRTL()>0;k=$.scrollRightRTL()>0;}if((Q!=this._bPreviousScrollForward)||(k!=this._bPreviousScrollBack)){j.toggleClass("sapMFFNoScrollBack",!k);j.toggleClass("sapMFFNoScrollForward",!Q);}}};
M.prototype.onclick=function(i){var j=i.target,k=this.getId();if(!j.id){j=j.parentElement;}if(!j.id){return;}i.preventDefault();if(j.id==k+"-arrowScrollLeft"){j.tabIndex=-1;j.focus();this._scroll(-M.SCROLL_STEP,H);}else if(j.id==k+"-arrowScrollRight"){j.tabIndex=-1;j.focus();this._scroll(M.SCROLL_STEP,H);}};
M.prototype._scroll=function(i,j){var k=this.getDomRef("head");var Q=k.scrollLeft;if(this._bRtl){i=-i;}var R=Q+i;q(k).stop(true,true).animate({scrollLeft:R},j);};
M.prototype._enableTouchSupport=function(){var i=function(Q){var R=this.getType();if(R===G.Light){return;}Q.preventDefault();if(this._iInertiaIntervalId){window.clearInterval(this._iInertiaIntervalId);}this.startScrollX=this.getDomRef("head").scrollLeft;this.startTouchX=Q.touches[0].pageX;this._bTouchNotMoved=true;this._lastMoveTime=new Date().getTime();}.bind(this);var j=function(Q){var R=this.getType();if(R===G.Light){return;}var U=Q.touches[0].pageX-this.startTouchX;var V=this.getDomRef("head");var W=V.scrollLeft;var X=this.startScrollX-U;V.scrollLeft=X;this._bTouchNotMoved=false;var Y=new Date().getTime()-this._lastMoveTime;this._lastMoveTime=new Date().getTime();if(Y>0){this._velocity=(X-W)/Y;}Q.preventDefault();}.bind(this);var k=function(Q){var R=this.getType();if(R===G.Light){return;}if(this._bTouchNotMoved===false){Q.preventDefault();var U=this.getDomRef("head");var V=50;var W=Math.abs(this._velocity/10);this._iInertiaIntervalId=window.setInterval(function(){this._velocity=this._velocity*0.80;var X=this._velocity*V;U.scrollLeft=U.scrollLeft+X;if(Math.abs(this._velocity)<W){window.clearInterval(this._iInertiaIntervalId);this._iInertiaIntervalId=undefined;}}.bind(this),V);}else if(this._bTouchNotMoved===true){this.onclick(Q);Q.preventDefault();}this._bTouchNotMoved=undefined;this._lastMoveTime=undefined;}.bind(this);this.addEventDelegate({ontouchstart:i},this);this.addEventDelegate({ontouchend:k},this);this.addEventDelegate({ontouchmove:j},this);};
return M;});
sap.ui.predefine('sap/m/FacetFilterItem',['./ListItemBase','./library','./FacetFilterItemRenderer'],function(L,l,F){"use strict";
var a=L.extend("sap.m.FacetFilterItem",{metadata:{library:"sap.m",properties:{key:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},count:{type:"int",group:"Misc",defaultValue:null,deprecated:true}}}});
a.prototype.setCount=function(c){this.setProperty("count",c);this.setProperty("counter",c);return this;};
a.prototype.setCounter=function(c){this.setProperty("count",c);this.setProperty("counter",c);return this;};
a.prototype.init=function(){this.attachEvent("_change",this._itemTextChange);L.prototype.init.apply(this);this.addStyleClass("sapMFFLI");};
a.prototype.exit=function(){L.prototype.exit.apply(this);this.detachEvent("_change",this._itemTextChange);};
a.prototype._itemTextChange=function(e){if(e.getParameter("name")==="text"){this.informList("TextChange",e.getParameter("newValue"));}};
return a;});
sap.ui.predefine('sap/m/FacetFilterItemRenderer',['./ListItemBaseRenderer','sap/ui/core/Renderer'],function(L,R){"use strict";var F=R.extend(L);F.apiVersion=2;
F.renderLIContent=function(r,c){r.openStart("div",c);if(c.getParent()&&c.getParent().getWordWrap()){r.class("sapMFFLITitleWrap");}else{r.class("sapMFFLITitle");}r.openEnd();r.text(c.getText());r.close("div");};
return F;},true);
sap.ui.predefine('sap/m/FacetFilterList',['./List','./library','sap/ui/model/ChangeReason','sap/ui/model/Filter','./FacetFilterListRenderer','./FacetFilterItem',"sap/base/Log","sap/ui/model/FilterOperator","sap/ui/model/FilterType"],function(L,l,C,F,a,b,c,d,e){"use strict";var f=l.ListMode;var g=l.FacetFilterListDataType;
var h=L.extend("sap.m.FacetFilterList",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},wordWrap:{type:"boolean",group:"Appearance",defaultValue:false},multiSelect:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true},active:{type:"boolean",group:"Behavior",defaultValue:true},enableCaseInsensitiveSearch:{type:"boolean",group:"Behavior",defaultValue:false,deprecated:false},allCount:{type:"int",group:"Appearance",defaultValue:null},sequence:{type:"int",group:"Behavior",defaultValue:-1},key:{type:"string",group:"Identification",defaultValue:null},showRemoveFacetIcon:{type:"boolean",group:"Misc",defaultValue:true},retainListSequence:{type:"boolean",group:"Misc",defaultValue:false},dataType:{type:"sap.m.FacetFilterListDataType",group:"Misc",defaultValue:g.String}},events:{listOpen:{allowPreventDefault:true},listClose:{parameters:{selectedItems:{type:"sap.m.FacetFilterItem[]"},allSelected:{type:"boolean"},selectedKeys:{type:"object"}}},search:{allowPreventDefault:true,parameters:{term:{type:"string"}}}}}});
h.prototype.setTitle=function(t){this.setProperty("title",t,true);this._updateFacetFilterButtonText();return this;};
h.prototype.setMultiSelect=function(v){this.setProperty("multiSelect",v,true);var m=v?f.MultiSelect:f.SingleSelectMaster;this.setMode(m);return this;};
h.prototype.setMode=function(m){if(m===f.MultiSelect||m===f.SingleSelectMaster){L.prototype.setMode.call(this,m);this.setProperty("multiSelect",m===f.MultiSelect?true:false,true);}return this;};
h.prototype._applySearch=function(){var s=this._getSearchValue();if(s===null){return;}this._bSearchEventDefaultBehavior&&this._search(s,true);this._updateSelectAllCheckBox();};
h.prototype.getSelectedItems=function(){var s=[];var o={};var i=L.prototype.getSelectedItems.apply(this,arguments);i.forEach(function(I){s.push(new b({text:I.getText(),key:I.getKey(),selected:true}));o[I.getKey()]=true;});var S=this.getSelectedKeys();var j=Object.getOwnPropertyNames(S);if(i.length<j.length){j.forEach(function(k){if(!o[k]){s.push(new b({text:S[k],key:k,selected:true}));}});}return s;};
h.prototype.getSelectedItem=function(){var i=L.prototype.getSelectedItem.apply(this,arguments);var s=Object.getOwnPropertyNames(this.getSelectedKeys());if(!i&&s.length>0){i=new b({text:this.getSelectedKeys()[s[0]],key:s[0],selected:true});}return i;};
h.prototype.removeSelections=function(A){if(this._allowRemoveSelections){A?this.setSelectedKeys():L.prototype.removeSelections.call(this,A);}return this;};
h.prototype.getSelectedKeys=function(){var r={};var k=this._oSelectedKeys;Object.getOwnPropertyNames(k).forEach(function(i){r[i]=k[i];});return r;};
h.prototype.setSelectedKeys=function(k){this._oSelectedKeys={};var K=false;k&&Object.getOwnPropertyNames(k).forEach(function(i){this._addSelectedKey(i,k[i]);K=true;},this);if(K){if(this.getMode()===f.MultiSelect){this.setActive(true);}this._selectItemsByKeys();}else{L.prototype.removeSelections.call(this);}};
h.prototype._getNonGroupItems=function(){var i=[];this.getItems().forEach(function(I){if(I.getMode()!==f.None){i.push(I);}});return i;};
h.prototype.removeSelectedKey=function(k,t){if(this._removeSelectedKey(k,t)){this._getNonGroupItems().forEach(function(i){var I=i.getKey()||i.getText();k===I&&i.setSelected(false);});}};
h.prototype.removeSelectedKeys=function(){this._oSelectedKeys={};L.prototype.removeSelections.call(this,true);};
h.prototype.removeItem=function(i){var I=L.prototype.removeItem.apply(this,arguments);if(!this._filtering){I&&I.getSelected()&&this.removeSelectedKey(I.getKey(),I.getText());return I;}};
h.prototype.init=function(){this._firstTime=true;this._bSearchEventDefaultBehavior=true;this._saveBindInfo;this._oSelectedKeys={};L.prototype.init.call(this);this.setMode(f.MultiSelect);this.setIncludeItemInSelection(true);this.setGrowing(true);this.setRememberSelections(false);this._searchValue="";this.attachUpdateFinished(function(E){var u=E.getParameter("reason");u=u?u.toLowerCase():u;if(u==="change"){var B=this.getBinding("items"),m=B?B.getModel():null;if(m&&m.getProperty(B.getPath())){this._iAllItemsCount=m.getProperty(B.getPath()).length||0;}this._oSelectedKeys={};this._getNonGroupItems().forEach(function(i){if(i.getSelected()){this._addSelectedKey(i.getKey(),i.getText());}},this);}if(u!==C.Filter.toLowerCase()){this._selectItemsByKeys();}this._updateFacetFilterButtonText();this._updateSelectAllCheckBox();});this._allowRemoveSelections=true;this._bOriginalActiveState;this._iAllItemsCount;};
h.prototype._resetItemsBinding=function(){if(this.isBound("items")){this._setSearchValue("");this._allowRemoveSelections=false;L.prototype._resetItemsBinding.apply(this,arguments);this._allowRemoveSelections=true;}};
h.prototype._fireListCloseEvent=function(){var s=this.getSelectedItems();var S=this.getSelectedKeys();var A=this.isAllSelectableSelected();this._firstTime=true;this.fireListClose({selectedItems:s,selectedKeys:S,allSelected:A});};
h.prototype._updateActiveState=function(){var o=sap.ui.getCore().byId(this.getAssociation("allcheckbox"));if(Object.getOwnPropertyNames(this._oSelectedKeys).length>0||(o&&o.getSelected())){this.setActive(true);}};
h.prototype._handleSearchEvent=function(E){var s=E.getParameters()["query"];if(s===undefined){s=E.getParameters()["newValue"];}this._bSearchEventDefaultBehavior=this.fireSearch({term:s,clearButtonPressed:E.getParameters()["clearButtonPressed"]});this._bSearchEventDefaultBehavior?this._search(s):this._setSearchValue(s);this._updateSelectAllCheckBox();};
h.prototype._search=function(s,i){var j,B,u,U,p,o,P,k,n=0,m=this.getBinding("items"),q=this.getBindingInfo("items");function r(M){return M instanceof sap.ui.model.odata.ODataModel||M instanceof sap.ui.model.odata.v2.ODataModel||M instanceof sap.ui.model.odata.v4.ODataModel;}if(i||(s!==this._searchValue)){this._searchValue=s;if(q&&q.binding){j=q.binding.aFilters;if(j.length>0){n=j[0].aFilters.length;if(this._firstTime){this._saveBindInfo=j[0].aFilters[0][0];this._firstTime=false;}}}if(m){if(s||n>0){k=q.template?q.template:q.factory();B=k.getBindingInfo("text").parts;p=B[0].path;if(p||p===""){u=[];B.forEach(function(t){u.push(new F(t.path,d.Contains,s));});if(this.getEnableCaseInsensitiveSearch()&&r(m.getModel())){u.forEach(function(t){t.bCaseSensitive=false;});}P=new F(u,false);if(n>1){o=new F([P,this._saveBindInfo],true);}else{if(this._saveBindInfo>""&&U.sPath!=this._saveBindInfo.sPath){o=new F([P,this._saveBindInfo],true);}else{if(s==""){o=[];}else{o=new F([P],true);}}}m.filter(o,e.Control);}}else{m.filter([],e.Control);}}else{c.warning("No filtering performed","The list must be defined with a binding for search to work",this);}}};
h.prototype._getSearchValue=function(){return this._searchValue;};
h.prototype._updateSelectAllCheckBox=function(){var i=this._getNonGroupItems(),I=i.length,o,A,s;function j(k){return k.getSelected();}if(this.getMultiSelect()){o=sap.ui.getCore().byId(this.getAssociation("allcheckbox"));A=I>0&&I===i.filter(j).length;s=this.getActive()&&A;o&&o.setSelected(s);}};
h.prototype._addSelectedKey=function(k,t){if(!k&&!t){c.error("Both sKey and sText are not defined. At least one must be defined.");return;}if(this.getMode()===f.SingleSelectMaster){this.removeSelectedKeys();}if(!k){k=t;}this._oSelectedKeys[k]=t||k;};
h.prototype._removeSelectedKey=function(k,t){if(!k&&!t){c.error("Both sKey and sText are not defined. At least one must be defined.");return false;}if(!k){k=t;}delete this._oSelectedKeys[k];return true;};
h.prototype._setSearchValue=function(v){this._searchValue=v;};
h.prototype._isItemSelected=function(i){return!!(this._oSelectedKeys[i&&(i.getKey()||i.getText())]);};
h.prototype._updateFacetFilterButtonText=function(){if(this.getParent()&&this.getParent()._setButtonText){this.getParent()._setButtonText(this);}};
h.prototype._selectItemsByKeys=function(){this._getNonGroupItems().forEach(function(i){i.setSelected(this._isItemSelected(i));},this);this._updateFacetFilterButtonText();};
h.prototype._handleSelectAllClick=function(s){var A,i,I=this._getNonGroupItems(),j=I.length;I.forEach(function(o){if(s){this._addSelectedKey(o.getKey(),o.getText());}else{this._removeSelectedKey(o.getKey(),o.getText());}o.setSelected(s,true);},this);function k(o){return o.getSelected();}if(this.getMode()===f.MultiSelect){i=j>0&&j===I.filter(k).length;A=this._getOriginalActiveState()||(s&&i);this.setActive(A);}setTimeout(this._updateSelectAllCheckBox.bind(this),0);};
h.prototype.onItemTextChange=function(i,n){var k=i.getKey();if(this._oSelectedKeys[k]&&n&&!this._filtering){this._oSelectedKeys[k]=n;}};
h.prototype.onItemSelectedChange=function(i,s){var A;if(s){this._addSelectedKey(i.getKey(),i.getText());}else{this._removeSelectedKey(i.getKey(),i.getText());}L.prototype.onItemSelectedChange.apply(this,arguments);if(this.getMode()===f.MultiSelect){A=this._getOriginalActiveState()||s||this.getSelectedItems().length>1;this.setActive(A);}!this.getDomRef()&&this.getParent()&&this.getParent().getDomRef()&&this.getParent().invalidate();setTimeout(this._updateSelectAllCheckBox.bind(this),0);};
h.prototype.updateItems=function(r){var p=document.activeElement;this._filtering=r===C.Filter;L.prototype.updateItems.apply(this,arguments);this._filtering=false;if(p&&p.getAttribute("id")!==document.activeElement.getAttribute("id")){this.focus();}if(!this.getGrowing()||r===C.Filter){this._selectItemsByKeys();}};
h.prototype._getOriginalActiveState=function(){return this._bOriginalActiveState;};
h.prototype._preserveOriginalActiveState=function(){this._bOriginalActiveState=this.getActive();};
h.prototype._showBusyIndicator=function(){L.prototype._showBusyIndicator.apply(this,arguments);this.fireEvent("listItemsChange");};
h.prototype._hideBusyIndicator=function(){L.prototype._hideBusyIndicator.apply(this,arguments);this.fireEvent("listItemsChange");};
return h;});
sap.ui.predefine('sap/m/FacetFilterListRenderer',['./ListRenderer','sap/ui/core/Renderer'],function(L,R){"use strict";var F=R.extend(L);F.apiVersion=2;return F;},true);
sap.ui.predefine('sap/m/FacetFilterRenderer',["sap/m/library","sap/ui/Device","sap/ui/core/InvisibleText"],function(l,D,I){"use strict";var F=l.FacetFilterType;var a={apiVersion:2};
a.render=function(r,c){if(c.getType()===F.Light||c.getShowSummaryBar()){a.renderSummaryBar(r,c);}else{a.renderSimpleFlow(r,c);}};
a.renderSimpleFlow=function(r,c){r.openStart("div",c);r.class("sapMFF");r.accessibilityState({role:"toolbar",roledescription:c._bundle.getText("FACETFILTER_TITLE")});if(c._lastScrolling){r.class("sapMFFScrolling");}else{r.class("sapMFFNoScrolling");}if(c.getShowReset()){r.class("sapMFFResetSpacer");}r.openEnd();if(D.system.desktop){r.renderControl(c._getScrollingArrow("left"));}r.openStart("div",c.getId()+"-head");r.class("sapMFFHead");r.openEnd();a.renderFacetFilterListButtons(c,r);if(c.getShowPersonalization()){a.renderAddFilterButton(c,r);}r.close("div");if(D.system.desktop){r.renderControl(c._getScrollingArrow("right"));}if(c.getShowReset()){r.openStart("div");r.class("sapMFFResetDiv");r.openEnd();r.renderControl(c.getAggregation("resetButton"));r.close("div");}r.close("div");};
a.renderSummaryBar=function(r,c){r.openStart("div",c);r.class("sapMFF");r.openEnd();r.renderControl(c.getAggregation("summaryBar"));r.close("div");};
a.getAriaAnnouncement=function(k,b){return I.getStaticId("sap.m",b||"FACETFILTER_"+k.toUpperCase());};
a.renderFacetFilterListButtons=function(c,r){var L=c._getSequencedLists(),b=L.length,s=c.getShowPersonalization(),A=s&&(c.getType()===F.Simple),f=A?b+1:b,B,i;for(i=0;i<b;i++){var d=L[i].getItems().length>0,e=L[i].getActive(),g=c._bCheckForAddListBtn&&(d||e);if(!c._bCheckForAddListBtn||g){B=c._getButtonForList(L[i]);a.addPositionInfoForButton(c,B,i+1,f);if(s){B.addAriaDescribedBy(a.getAriaAnnouncement("ARIA_REMOVE"));}r.renderControl(B);if(s){r.renderControl(c._getFacetRemoveIcon(L[i]));}}}return this;};
a.renderAddFilterButton=function(c,r){var A=c.getAggregation("addFacetButton"),b=c._getSequencedLists().length+1;a.addPositionInfoForButton(c,A,b,b);r.renderControl(A);return this;};
a.addPositionInfoForButton=function(c,b,p,s){var S=a.createStaticPositioningLabel(c,p,s);a.clearOldPositioningLabels(c,b);b.addAriaDescribedBy(S);return this;};
a.clearOldPositioningLabels=function(c,b){var o=b.removeAllAriaDescribedBy(),r=this.getAriaAnnouncement("ARIA_REMOVE"),i;o.forEach(function(s){if(r===s){return;}i=sap.ui.getCore().byId(s);i&&i.destroy();});return this;};
a.createStaticPositioningLabel=function(c,p,s){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),f=r.getText("FACETFILTER_ARIA_FACET_FILTER"),P=r.getText("FACETFILTERLIST_ARIA_POSITION",[p,s]),S=new I({text:f+" "+P}).toStatic();c._aOwnedLabels.push(S.getId());return S;};
return a;},true);
sap.ui.predefine('sap/m/FeedContent',['./library','sap/ui/core/Control','sap/m/Text','sap/ui/Device','./FeedContentRenderer',"sap/ui/events/KeyCodes"],function(l,C,T,D,F,K){"use strict";var S=l.Size;
var a=C.extend("sap.m.FeedContent",{metadata:{library:"sap.m",properties:{"size":{type:"sap.m.Size",group:"Misc",defaultValue:S.Auto,deprecated:true},"contentText":{type:"string",group:"Misc",defaultValue:null},"subheader":{type:"string",group:"Misc",defaultValue:null},"value":{type:"string",group:"Misc",defaultValue:null},"valueColor":{type:"sap.m.ValueColor",group:"Misc",defaultValue:null},"truncateValueTo":{type:"int",group:"Misc",defaultValue:4}},defaultAggregation:"_contentTextAgr",aggregations:{"_contentTextAgr":{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{"press":{}}}});
a.prototype.init=function(){this._oContentText=new T(this.getId()+"-content-text",{maxLines:2});this._oContentText.cacheLineHeight=false;this.setAggregation("_contentTextAgr",this._oContentText,true);this.setTooltip("{AltText}");};
a.prototype.onBeforeRendering=function(){this.$().off("mouseenter");this.$().off("mouseleave");};
a.prototype.onAfterRendering=function(){this.$().on("mouseenter",this._addTooltip.bind(this));this.$().on("mouseleave",this._removeTooltip.bind(this));};
a.prototype.exit=function(){this._oContentText=null;};
a.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
a.prototype._removeTooltip=function(){this.$().attr("title",null);};
a.prototype.getAltText=function(){var A="";var i=true;if(this.getAggregation("_contentTextAgr").getText()){A+=this.getAggregation("_contentTextAgr").getText();i=false;}if(this.getSubheader()){if(i){A+=""+this.getSubheader();}else{A+="\n"+this.getSubheader();}i=false;}if(this.getValue()){if(i){A+=""+this.getValue();}else{A+="\n"+this.getValue();}}return A;};
a.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var s=this.getAltText();if(typeof t==="string"||t instanceof String){s=t.split("{AltText}").join(s).split("((AltText))").join(s);return s;}if(t){return t;}else{return"";}};
a.prototype.setContentText=function(t){this._oContentText.setText(t);return this;};
a.prototype.ontap=function(e){if(D.browser.msie){this.$().trigger("focus");}this.firePress();};
a.prototype.onkeydown=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
a.prototype.attachEvent=function(e,d,f,b){C.prototype.attachEvent.call(this,e,d,f,b);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");}return this;};
a.prototype.detachEvent=function(e,f,b){C.prototype.detachEvent.call(this,e,f,b);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");}return this;};
return a;});
sap.ui.predefine('sap/m/FeedContentRenderer',[],function(){"use strict";var F={apiVersion:2};
F.render=function(r,c){var s=c.getSubheader();var v=c.getValue();var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}r.openStart("div",c);r.attr("role","presentation");r.attr("aria-label",t);r.class("sapMFC");if(c.hasListeners("press")){r.attr("tabindex","0");r.class("sapMPointer");}r.openEnd();if(v){r.openStart("div",c.getId()+"-value");r.class("sapMFCValue");r.class(c.getValueColor());r.openEnd();var C=c.getTruncateValueTo();if(v.length>=C&&(v[C-1]==="."||v[C-1]===",")){r.text(v.substring(0,C-1));}else if(v){r.text(v.substring(0,C));}else{r.text("");}r.close("div");}r.openStart("div");r.class("sapMFCCTxt");r.openEnd();r.renderControl(c._oContentText);r.close("div");r.openStart("div",c.getId()+"-subheader");r.class("sapMFCSbh");r.openEnd();r.text(s);r.close("div");r.close("div");};
return F;},true);
sap.ui.predefine('sap/m/FeedInput',["./library","sap/ui/core/Control","sap/ui/core/IconPool","sap/m/TextArea","sap/m/Button","./FeedInputRenderer","sap/ui/thirdparty/jquery","sap/base/security/URLListValidator","sap/base/security/sanitizeHTML","sap/m/Avatar","sap/m/AvatarShape","sap/m/AvatarSize"],function(l,C,I,T,B,F,q,U,s,A,a,b){"use strict";var c=l.ButtonType;var M=15,d=2,e=0;
var f=C.extend("sap.m.FeedInput",{metadata:{library:"sap.m",designtime:"sap/m/designtime/FeedInput.designtime",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},rows:{type:"int",group:"Appearance",defaultValue:2},showExceededText:{type:"boolean",group:"Behavior",defaultValue:false},maxLength:{type:"int",group:"Behavior",defaultValue:0},growing:{type:"boolean",group:"Behavior",defaultValue:false},growingMaxLines:{type:"int",group:"Behavior",defaultValue:0},placeholder:{type:"string",group:"Appearance",defaultValue:"Post something here"},value:{type:"string",group:"Data",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},iconDisplayShape:{type:"sap.m.AvatarShape",defaultValue:a.Circle},iconInitials:{type:"string",defaultValue:""},iconSize:{type:"sap.m.AvatarSize",defaultValue:b.M},showIcon:{type:"boolean",group:"Behavior",defaultValue:true},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},buttonTooltip:{type:"sap.ui.core.TooltipBase",group:"Accessibility",defaultValue:"Submit"},ariaLabelForPicture:{type:"string",group:"Accessibility",defaultValue:null}},aggregations:{_avatar:{type:"sap.m.Avatar",multiple:false,visibility:"hidden"}},events:{post:{parameters:{value:{type:"string"}}}}}});
var _={ATTRIBS:{'style':1,'class':1,'a::href':1,'a::target':1},ELEMENTS:{'a':{cssClass:'sapMLnk'},'abbr':1,'blockquote':1,'br':1,'cite':1,'code':1,'em':1,'h1':{cssClass:'sapMTitle sapMTitleStyleH1'},'h2':{cssClass:'sapMTitle sapMTitleStyleH2'},'h3':{cssClass:'sapMTitle sapMTitleStyleH3'},'h4':{cssClass:'sapMTitle sapMTitleStyleH4'},'h5':{cssClass:'sapMTitle sapMTitleStyleH5'},'h6':{cssClass:'sapMTitle sapMTitleStyleH6'},'p':1,'pre':1,'strong':1,'span':1,'u':1,'dl':1,'dt':1,'dd':1,'ol':1,'ul':1,'li':1}};f.prototype._renderingRules=_;
function S(t,g){var h,v,j=t==="a";var k=this._renderingRules.ELEMENTS[t].cssClass||"";for(var i=0;i<g.length;i+=2){h=g[i];v=g[i+1];if(!this._renderingRules.ATTRIBS[h]&&!this._renderingRules.ATTRIBS[t+"::"+h]){g[i+1]=null;continue;}if(h=="href"){if(!U.validate(v)){g[i+1]="#";j=false;}}if(h=="target"){j=false;}if(k&&h.toLowerCase()=="class"){g[i+1]=k+" "+v;k="";}}if(j){g.push("target");g.push("_blank");}if(k){g.push("class");g.push(k);}return g;}
function p(t,g){return S.call(this,t,g);}
f.prototype._sanitizeHTML=function(t){return s(t,{tagPolicy:p.bind(this),uriRewriter:function(u){if(U.validate(u)){return u;}}});};
f.prototype.init=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setProperty("placeholder",o.getText("FEEDINPUT_PLACEHOLDER"),true);this.setProperty("buttonTooltip",o.getText("FEEDINPUT_SUBMIT"),true);};
f.prototype.exit=function(){if(this._oTextArea){this._oTextArea.destroy();}if(this._oButton){this._oButton.destroy();}if(this.oAvatar){this.oAvatar.destroy();}};
f.prototype.setRows=function(r){var m=this.getProperty("growingMaxLines");if(r>M){r=M;}else if(r<d){r=d;}if(r>m&&m!==0){this.setProperty("growingMaxLines",r,true);this._getTextArea().setGrowingMaxLines(r);}this.setProperty("rows",r,true);this._getTextArea().setRows(r);return this;};
f.prototype.setShowExceededText=function(v){this.setProperty("showExceededText",v,true);this._getTextArea().setShowExceededText(v);return this;};
f.prototype.setMaxLength=function(m){this.setProperty("maxLength",m,true);this._getTextArea().setMaxLength(m);return this;};
f.prototype.setGrowing=function(g){this.setProperty("growing",g,true);this._getTextArea().setGrowing(g);return this;};
f.prototype.setGrowingMaxLines=function(m){var r=this.getProperty("rows");if(m!==e){if(m<r){m=r;}else if(m>M){m=M;}}this.setProperty("growingMaxLines",m,true);this._getTextArea().setGrowingMaxLines(m);return this;};
f.prototype.setValue=function(v){this.setProperty("value",v,true);this._getTextArea().setValue(v);this._enablePostButton();return this;};
f.prototype.setPlaceholder=function(v){this.setProperty("placeholder",v,true);this._getTextArea().setPlaceholder(v);return this;};
f.prototype.setEnabled=function(E){this.setProperty("enabled",E,true);if(this.getDomRef("outerContainer")){if(E){this.getDomRef("outerContainer").classList.remove("sapMFeedInDisabled");}else{this.getDomRef("outerContainer").classList.add("sapMFeedInDisabled");}}this._getTextArea().setEnabled(E);this._enablePostButton();return this;};
f.prototype.setButtonTooltip=function(v){this.setProperty("buttonTooltip",v,true);this._getPostButton().setTooltip(v);return this;};
f.prototype._getTextArea=function(){var t=this;if(!this._oTextArea){this._oTextArea=new T(this.getId()+"-textArea",{value:this.getValue(),maxLength:this.getMaxLength(),placeholder:this.getPlaceholder(),growing:this.getGrowing(),growingMaxLines:this.getGrowingMaxLines(),showExceededText:this.getShowExceededText(),rows:this.getRows(),liveChange:q.proxy(function(E){var v=E.getParameter("value");this.setProperty("value",v,true);this._enablePostButton();},this)});this._oTextArea.setParent(this);this._oTextArea.addEventDelegate({onAfterRendering:function(){t.$("counterContainer").empty();t.$("counterContainer").html(t._oTextArea.getAggregation("_counter").$());}});}return this._oTextArea;};
f.prototype._getPostButton=function(){if(!this._oButton){this._oButton=new B(this.getId()+"-button",{enabled:false,type:c.Default,icon:"sap-icon://feeder-arrow",tooltip:this.getButtonTooltip(),press:q.proxy(function(){this._oTextArea.focus();this.firePost({value:this._sanitizeHTML(this.getValue())});this.setValue(null);},this)});this._oButton.setParent(this);}return this._oButton;};
f.prototype._enablePostButton=function(){var P=this._isControlEnabled();var o=this._getPostButton();o.setEnabled(P);};
f.prototype._isControlEnabled=function(){var v=this.getValue();return this.getEnabled()&&(typeof v==="string"||v instanceof String)&&v.trim().length>0;};
f.prototype._getAvatar=function(){var i=this.getIcon();var g=this.getId()+'-icon';this.oAvatar=this.getAggregation("_avatar");if(!this.oAvatar){this.oAvatar=new A({id:g,src:i,displayShape:this.getIconDisplayShape(),initials:this.getIconInitials(),displaySize:this.getIconSize()}).addStyleClass("sapMFeedInImage");if(i){this.oAvatar.addStyleClass("sapMFeedInImageBgColor");}}else{this.oAvatar.setSrc(i).setDisplayShape(this.getIconDisplayShape()).setInitials(this.getIconInitials()).setDisplaySize(this.getIconSize());}this.setAggregation("_avatar",this.oAvatar);return this.oAvatar;};
return f;});
sap.ui.predefine('sap/m/FeedInputRenderer',[],function(){"use strict";var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");var F={apiVersion:2};
F.render=function(R,c){var m=c.getId();R.openStart("div",c);R.class("sapMFeedInBase");R.attr("role","group");R.attr("aria-label",r.getText("FEED_INPUT_ARIA_LABEL"));R.openEnd();R.openStart("div",m+"-outerContainer");R.class("sapMFeedIn");if(!c.getShowIcon()){R.class("sapMFeedInNoIcon");}if(!c.getEnabled()){R.class("sapMFeedInDisabled");}R.openEnd();if(c.getShowIcon()){this._addImage(R,c,m);}R.openStart("div",m+"-container");R.class("sapMFeedInContainer");R.openEnd();var t=c._getTextArea();R.renderControl(t);R.renderControl(c._getPostButton());R.close("div");R.close("div");R.openStart("div",m+"-counterContainer");R.class("sapMFeedInCounter");R.openEnd();R.close("div");R.close("div");};
F._addImage=function(R,c,m){R.openStart("figure",m+'-figure').class("sapMFeedInFigure");if(!c.getIcon()){R.class("sapMFeedListItemIsDefaultIcon");}R.openEnd();R.renderControl(c._getAvatar());R.close("figure");};
return F;},true);
sap.ui.predefine('sap/m/FeedListItem',["./ListItemBase","./Link","./library","./FormattedText","sap/ui/core/IconPool","sap/m/Button","sap/ui/Device","./FeedListItemRenderer","sap/m/Avatar","sap/m/AvatarShape","sap/m/AvatarSize"],function(L,a,l,F,I,B,D,b,A,c,d){"use strict";var e=l.ListType;var f=l.LinkConversion;var g=l.ButtonType;
var h=L.extend("sap.m.FeedListItem",{metadata:{library:"sap.m",designtime:"sap/m/designtime/FeedListItem.designtime",properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},iconDisplayShape:{type:"sap.m.AvatarShape",defaultValue:c.Circle},iconInitials:{type:"string",defaultValue:""},iconSize:{type:"sap.m.AvatarSize",defaultValue:d.S},activeIcon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},sender:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Data",defaultValue:null},moreLabel:{type:"string",group:"Data",defaultValue:null},lessLabel:{type:"string",group:"Data",defaultValue:null},info:{type:"string",group:"Data",defaultValue:null},timestamp:{type:"string",group:"Data",defaultValue:null},senderActive:{type:"boolean",group:"Behavior",defaultValue:true},iconActive:{type:"boolean",group:"Behavior",defaultValue:true},iconDensityAware:{type:"boolean",defaultValue:true},showIcon:{type:"boolean",group:"Behavior",defaultValue:true},convertLinksToAnchorTags:{type:"sap.m.LinkConversion",group:"Behavior",defaultValue:f.None},convertedLinksDefaultTarget:{type:"string",group:"Behavior",defaultValue:"_blank"},maxCharacters:{type:"int",group:"Behavior",defaultValue:null}},defaultAggregation:"actions",aggregations:{actions:{type:"sap.m.FeedListItemAction",multiple:true},_text:{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"},_actionSheet:{type:"sap.m.ActionSheet",multiple:false,visibility:"hidden"},_actionButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_avatar:{type:"sap.m.Avatar",multiple:false,visibility:"hidden"}},events:{senderPress:{parameters:{domRef:{type:"string"},getDomRef:{type:"function"}}},iconPress:{parameters:{domRef:{type:"string"},getDomRef:{type:"function"}}}}}});
h._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");h._nMaxCharactersMobile=300;h._nMaxCharactersDesktop=500;h._sTextShowMore=h._oRb.getText("TEXT_SHOW_MORE");h._sTextShowLess=h._oRb.getText("TEXT_SHOW_LESS");
h.prototype.init=function(){L.prototype.init.apply(this);this.setAggregation("_text",new F(this.getId()+"-formattedText"),true);this.setAggregation("_actionButton",new B({id:this.getId()+"-actionButton",type:g.Transparent,icon:"sap-icon://overflow",press:[this._onActionButtonPress,this]}),true);};
h.prototype._onActionButtonPress=function(){sap.ui.require(["sap/m/ActionSheet"],this._openActionSheet.bind(this));};
h.prototype._openActionSheet=function(j){var o=this.getAggregation("_actionSheet");var k=this.getActions();var m;if(!(o&&o instanceof j)){o=new j({id:this.getId()+"-actionSheet",beforeOpen:[this._onBeforeOpenActionSheet,this]});this.setAggregation("_actionSheet",o,true);}o.destroyAggregation("buttons",true);for(var i=0;i<k.length;i++){m=k[i];o.addButton(new B({icon:m.getIcon(),text:m.getText(),visible:m.getVisible(),enabled:m.getEnabled(),press:m.firePress.bind(m,{"item":this})}));}o.openBy(this.getAggregation("_actionButton"));};
h.prototype._onBeforeOpenActionSheet=function(i){var o,t;if(D.system.phone){return;}t=sap.ui.getCore().getConfiguration().getTheme();o=i.getSource().getParent();o.removeStyleClass("sapContrast sapContrastPlus");if(t==="sap_belize"){o.addStyleClass("sapContrast");}else if(t==="sap_belize_plus"){o.addStyleClass("sapContrastPlus");}};
h.prototype.invalidate=function(){L.prototype.invalidate.apply(this,arguments);var m=h._sTextShowMore;if(this.getMoreLabel()){m=this.getMoreLabel();}delete this._bTextExpanded;if(this._oLinkExpandCollapse){this._oLinkExpandCollapse.setProperty("text",m,true);}};
h.prototype.onBeforeRendering=function(){this.$("realtext").find('a[target="_blank"]').off("click");var o=this.getAggregation("_text");o.setProperty("convertLinksToAnchorTags",this.getConvertLinksToAnchorTags(),true);o.setProperty("convertedLinksDefaultTarget",this.getConvertedLinksDefaultTarget(),true);if(this.getConvertLinksToAnchorTags()===f.None){o.setHtmlText(this.getText());}else{o.setProperty("htmlText",this.getText(),true);}this._sFullText=o._getDisplayHtml().replace(/\n/g,"<br>");this._sShortText=this._getCollapsedText();if(this._sShortText){this._sShortText=this._sShortText.replace(/<br>/g," ");}this._bEmptyTagsInShortTextCleared=false;};
h.prototype.onAfterRendering=function(){if(document.getElementById(this.getAggregation("_actionButton"))){document.getElementById(this.getAggregation("_actionButton").getId()).setAttribute("aria-haspopup","menu");}if(this._checkTextIsExpandable()&&!this._bTextExpanded){this._clearEmptyTagsInCollapsedText();}var r=this.$("realtext");F.prototype.onAfterRendering.apply({$:function(){return r;}});};
h.prototype.exit=function(){this.$("realtext").find('a[target="_blank"]').off("click");if(this._oLinkControl){this._oLinkControl.destroy();}if(this.oAvatar){this.oAvatar.destroy();}if(this._oLinkExpandCollapse){this._oLinkExpandCollapse.destroy();}L.prototype.exit.apply(this);};
h.prototype.ontap=function(E){if(E.srcControl){if((!this.getIconActive()&&this.oAvatar&&E.srcControl.getId()===this.oAvatar.getId())||(!this.getSenderActive()&&this._oLinkControl&&E.srcControl.getId()===this._oLinkControl.getId())||(!this.oAvatar||(E.srcControl.getId()!==this.oAvatar.getId())&&(!this._oLinkControl||(E.srcControl.getId()!==this._oLinkControl.getId()))&&(!this._oLinkExpandCollapse||(E.srcControl.getId()!==this._oLinkExpandCollapse.getId())))){L.prototype.ontap.apply(this,[E]);}}};
h.prototype.onfocusin=function(E){var i=E.srcControl,o=i.getDomRef(),p=this.getParent().getAccessbilityPosition(i);if(i instanceof sap.m.FeedListItem){o.setAttribute("aria-posinset",p.posInset);o.setAttribute("aria-setsize",p.setSize);}};
h.prototype._getAvatar=function(){var i=this.getIcon();var s=this.getId()+'-icon';this.oAvatar=this.getAggregation("_avatar");this.oAvatar=this.oAvatar||new A(s);this.oAvatar.applySettings({src:i,displayShape:this.getIconDisplayShape(),initials:this.getIconInitials(),displaySize:this.getIconSize(),ariaLabelledBy:this.getSender()});var t=this;if(this.getIconActive()){this.oAvatar.addStyleClass("sapMFeedListItemImage");if(!this.oAvatar.hasListeners("press")){this.oAvatar.attachPress(function(){t.fireIconPress({domRef:this.getDomRef(),getDomRef:this.getDomRef.bind(this)});});}}else{this.oAvatar.addStyleClass("sapMFeedListItemImageInactive");}this.setAggregation("_avatar",this.oAvatar);return this.oAvatar;};
h.prototype._getLinkSender=function(w){if(!this._oLinkControl){var t=this;this._oLinkControl=new a({press:function(){t.fireSenderPress({domRef:this.getDomRef(),getDomRef:this.getDomRef.bind(this)});}});this._oLinkControl.setParent(this,null,true);}if(w){this._oLinkControl.setProperty("text",this.getSender()+h._oRb.getText("COLON"),true);}else{this._oLinkControl.setProperty("text",this.getSender(),true);}this._oLinkControl.setProperty("enabled",this.getSenderActive(),true);return this._oLinkControl;};
h.prototype._activeHandlingInheritor=function(){var s=this.getActiveIcon();if(this.oAvatar&&s){this.oAvatar.setSrc(s);}};
h.prototype._inactiveHandlingInheritor=function(){var s=this.getIcon()?this.getIcon():I.getIconURI("person-placeholder");if(this.oAvatar){this.oAvatar.setSrc(s);}};
h.prototype._getCollapsedText=function(){this._nMaxCollapsedLength=this.getMaxCharacters();if(this._nMaxCollapsedLength===0){if(D.system.phone){this._nMaxCollapsedLength=h._nMaxCharactersMobile;}else{this._nMaxCollapsedLength=h._nMaxCharactersDesktop;}}var p=this._convertHtmlToPlainText(this._sFullText);var t=null;if(p&&p.length>this._nMaxCollapsedLength){var C=p.substring(0,this._nMaxCollapsedLength);var n=C.lastIndexOf(" ");if(n>0){C=C.substr(0,n);}if(p.length===this._sFullText.length){t=C;}else{t=this._convertPlainToHtmlText(C);}}return t;};
h.prototype._clearEmptyTagsInCollapsedText=function(){var r;if(this._bEmptyTagsInShortTextCleared){return;}this._bEmptyTagsInShortTextCleared=true;do{r=this.$("realtext").find(":empty").remove();}while(r.length>0);this._sShortText=this.$("realtext").html();};
h.prototype._toggleTextExpanded=function(){var $=this.$("realtext");var i=this.$("threeDots");var m=h._sTextShowMore;var s=h._sTextShowLess;if(this.getMoreLabel()){m=this.getMoreLabel();}if(this.getLessLabel()){s=this.getLessLabel();}if(this._bTextExpanded){$.html(this._sShortText.replace(/&#xa;/g,"<br>"));i.text(" ... ");this._oLinkExpandCollapse.setText(m);this._bTextExpanded=false;this._clearEmptyTagsInCollapsedText();}else{$.html(this._sFullText.replace(/&#xa;/g,"<br>"));i.text("  ");this._oLinkExpandCollapse.setText(s);this._bTextExpanded=true;}};
h.prototype._getLinkExpandCollapse=function(){var m=h._sTextShowMore;if(this.getMoreLabel()){m=this.getMoreLabel();}if(!this._oLinkExpandCollapse){this._oLinkExpandCollapse=new a({text:m,press:[this._toggleTextExpanded,this]});this._bTextExpanded=false;this._oLinkExpandCollapse.setParent(this,null,true);}return this._oLinkExpandCollapse;};
h.prototype._convertHtmlToPlainText=function(i){var r=/(<([^>]+)>)/ig;return i.replace(r,"");};
h.prototype._convertPlainToHtmlText=function(j){var s=this._sFullText;var r=/(<([^>]+)>)/ig;var E=s.split(r);var t="";for(var i=0;i<E.length;i++){if(E[i].length===0){continue;}if(j.length>0&&E[i].indexOf(j.trim())!==-1){E[i]=j;}if(/^<.+>$/.test(E[i])){t=t+E[i];E[i+1]="";continue;}if(j.indexOf(E[i].trim())===-1){continue;}else{j=j.replace(E[i],"");}t=t+E[i];}return t;};
h.prototype._checkTextIsExpandable=function(){return this._sShortText!==null;};
h.prototype.setType=function(t){if(this.getType()!==t){if(t===e.Navigation){this.setProperty("type",e.Active);}else{this.setProperty("type",t);}}return this;};
return h;});
sap.ui.predefine('sap/m/FeedListItemAction',["sap/ui/core/Element"],function(E){"use strict";
var F=E.extend("sap.m.FeedListItemAction",{metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:""},key:{type:"string",group:"Misc",defaultValue:""},visible:{type:"boolean",group:"Appearance",defaultValue:true},enabled:{type:"boolean",group:"Appearance",defaultValue:true}},events:{press:{}}}});
return F;});
sap.ui.predefine('sap/m/FeedListItemRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer","sap/ui/Device"],function(L,R,D){"use strict";var F=R.extend(L);F.apiVersion=2;
F.renderLIAttributes=function(r,c){r.class("sapMFeedListItemTitleDiv");r.class("sapMFeedListShowSeparatorsAll");};
F.renderLIContent=function(r,c){var m=c.getId(),i=D.system.phone;r.openStart('div');r.class('sapMFeedListItem');r.openEnd();if(c.getShowIcon()){this._writeAvatarControl(r,c,m);}if(c.getActions().length>0){r.openStart("div",m+"-action-button");r.class('sapMFeedListItemActionButton');r.openEnd();r.renderControl(c.getAggregation("_actionButton"));r.close("div");}if(i){r.openStart('div').class("sapMFeedListItemHeader").class("sapUiSelectable");if(c.getShowIcon()){r.class("sapMFeedListItemHasFigure");}if(c.getSender()&&c.getTimestamp()){r.class('sapMFeedListItemFullHeight');}r.openEnd();if(c.getSender()){r.openStart('p',m+'-name').class("sapMFeedListItemTextName").class("sapUiSelectable").openEnd();r.renderControl(c._getLinkSender(false));r.close('p');}if(c.getTimestamp()){r.openStart('p',m+'-timestamp').class("sapMFeedListItemTimestamp").class("sapUiSelectable").openEnd();r.text(c.getTimestamp());r.close('p');}r.close('div');r.openStart('div').class("sapMFeedListItemText").class("sapUiSelectable").openEnd();this._writeText(r,c,m,i);if(c._checkTextIsExpandable()){this._writeCollapsedText(r,c,m);}else{r.unsafeHtml(c._sFullText);r.close('span');}r.close('div');if(c.getInfo()){r.openStart('p').class("sapMFeedListItemFooter").class("sapUiSelectable").openEnd();if(c.getInfo()){r.openStart('span',m+'-info').class("sapMFeedListItemInfo").class("sapUiSelectable").openEnd();r.text(c.getInfo());r.close('span');}r.close('p');}}else{r.openStart('div').class("sapMFeedListItemText");if(c.getShowIcon()){r.class('sapMFeedListItemHasFigure');}r.openEnd();r.openStart('div',m+'-text').class("sapMFeedListItemTextText").class("sapUiSelectable").openEnd();if(c.getSender()){r.openStart('span',m+'-name').class("sapMFeedListItemTextName").class("sapUiSelectable").openEnd();r.renderControl(c._getLinkSender(true));r.close('span');}this._writeText(r,c,m,i);if(c._checkTextIsExpandable()){this._writeCollapsedText(r,c,m);}else{r.unsafeHtml(c._sFullText);r.close('span');}r.close('div');if(c.getInfo()||c.getTimestamp()){r.openStart('p').class("sapMFeedListItemFooter").class("sapUiSelectable").openEnd();if(!sap.ui.getCore().getConfiguration().getRTL()){if(c.getInfo()){this._writeInfo(r,c,m);if(c.getTimestamp()){r.openStart("span").openEnd();r.text("\u00a0\u00a0\u00B7\u00a0\u00a0");r.close("span");}}if(c.getTimestamp()){this._writeTimestamp(r,c,m);}}else{if(c.getTimestamp()){this._writeTimestamp(r,c,m);}if(c.getInfo()){if(c.getTimestamp()){r.openStart("span").openEnd();r.text("\u00a0\u00a0\u00B7\u00a0\u00a0");r.close("span");}this._writeInfo(r,c,m);}}r.close('p');}r.close('div');}r.close('div');};
F._writeAvatarControl=function(r,c,i){r.openStart('figure',i+'-figure');r.class('sapMFeedListItemFigure');if(!c.getIcon()){r.class('sapMFeedListItemIsDefaultIcon');}r.openEnd();r.renderControl(c._getAvatar());r.close('figure');};
F._writeCollapsedText=function(r,c,i){if(c._bTextExpanded){r.unsafeHtml(c._sFullText);r.close('span');r.openStart('span',i+'-threeDots').class("sapMFeedListItemTextString").openEnd();r.text(" ");r.close('span');}else{r.unsafeHtml(c._sShortText);r.close('span');r.openStart('span',i+'-threeDots').class("sapMFeedListItemTextString").openEnd();r.text(" ... ");r.close('span');}var l=c._getLinkExpandCollapse();l.addStyleClass("sapMFeedListItemLinkExpandCollapse");r.renderControl(l);};
F._writeTimestamp=function(r,c,i){r.openStart('span',i+'-timestamp');r.class('sapMFeedListItemTimestampText');r.class('sapUiSelectable');if(c.getUnread()){r.class('sapMFeedListItem-Unread');}r.openEnd();r.text(c.getTimestamp());r.close('span');};
F._writeInfo=function(r,c,i){r.openStart('span',i+'-info');r.class('sapMFeedListItemInfoText');r.class('sapUiSelectable');if(c.getUnread()){r.class('sapMFeedListItem-Unread');}r.openEnd();r.text(c.getInfo());r.close('span');};
F._writeText=function(r,c,i,I){r.openStart('span',i+'-realtext');r.class(I?'sapMFeedListItemText':'sapMFeedListItemTextString');r.class('sapMFeedListItemText');r.class('sapUiSelectable');if(c.getUnread()){r.class('sapMFeedListItem-Unread');}r.openEnd();};
return F;},true);
sap.ui.predefine('sap/m/Fiori20Adapter',['sap/ui/base/Object','sap/ui/base/EventProvider','sap/ui/base/ManagedObjectObserver','sap/ui/Device',"sap/base/Log","sap/ui/thirdparty/jquery"],function(B,E,M,D,L,q){"use strict";var e=new E(),i,c,C;
var H=B.extend("HeaderAdapter",{constructor:function(o,A){if(!o||!A){L.error("Cannot initialize: Invalid arguments.");return;}this._oHeader=o;this._oStyledPage=null;this._oTitleInfo=null;this._oSubTitleInfo=null;this._oBackButtonInfo=null;this._oAdaptOptions=A;}});
H.prototype.adapt=function(){var s=this._oAdaptOptions.bStylePage,k=this._oAdaptOptions.bCollapseHeader;if(s){this._toggleStyle("sapF2Adapted",true,true);}this._adaptTitle();this._adaptBackButton();if(k){this._collapseHeader();}return this.getAdaptedContent();};
H.prototype.getAdaptedContent=function(){return{oTitleInfo:this._oTitleInfo,oSubTitleInfo:this._oSubTitleInfo,oBackButtonInfo:this._oBackButtonInfo,oStyledPage:this._oStyledPage};};
H.prototype._adaptTitle=function(){if(!H._isAdaptableHeader(this._oHeader)||this._oAdaptOptions.bMoveTitle!==true){return false;}this._oTitleInfo=this._detectTitle();this._oSubTitleInfo=this._detectSubTitle();var s=!!this._oTitleInfo||!!this._oSubTitleInfo;if(this._oTitleInfo){this._oTitleInfo.oControl.toggleStyleClass("sapF2AdaptedTitle",true);}return s;};
H.prototype._adaptBackButton=function(){if(!H._isAdaptableHeader(this._oHeader)||this._oAdaptOptions.bHideBackButton!==true){return false;}var k,l=false;this._oBackButtonInfo=this._detectBackButton();if(this._oBackButtonInfo){k=this._oBackButtonInfo.oControl.getVisible();this._oBackButtonInfo.oControl.toggleStyleClass("sapF2AdaptedNavigation",k);l=true;}return l;};
H.prototype._toggleStyle=function(s,A,S){var p=this._oHeader.getParent();if(!p){return;}this._oStyledPage=p;if(A===true){p.addStyleClass(s,S);}else if(A===false){p.removeStyleClass(s,S);}else if(A===undefined){p.hasStyleClass(s)?p.removeStyleClass(s,S):p.addStyleClass(s,S);}};
H._isAdaptableHeader=function(o){if(!o||!f(o,"sap/m/Bar")){return false;}var p=o.getParent();return p&&(f(p,"sap/m/Page")||f(p,"sap/m/MessagePage")||f(p,"sap/uxap/ObjectPageHeader"));};
H.prototype._detectTitle=function(){var t;if(H._isAdaptableHeader(this._oHeader)){var m=this._oHeader.getContentMiddle();if(m.length===1&&a(m[0])){var T=m[0];t={id:T.getId(),text:T.getText(),oControl:T,sChangeEventId:"_change",sPropertyName:"text"};}}return t;};
H.prototype._detectSubTitle=function(p){if(f(p,"sap/uxap/ObjectPageHeader")){var o=p.getHeaderTitle();if(o){return{id:o.getId(),text:o.getObjectTitle(),oControl:o,sChangeEventId:"_titleChange",sPropertyName:"objectTitle"};}}};
H.prototype._detectBackButton=function(){var k,o;if(H._isAdaptableHeader(this._oHeader)){k=this._oHeader.getContentLeft();if(k.length>0&&f(k[0],"sap/m/Button")&&(k[0].getType()==="Back"||k[0].getType()==="Up"||k[0].getIcon()==="sap-icon://nav-back")){o=k[0];return{id:o.getId(),oControl:o,sChangeEventId:"_change",sPropertyName:"visible"};}}};
H.prototype._collapseHeader=function(){var t=this._oTitleInfo,k=this._oBackButtonInfo,l,m,n,o,p,r,A;if(H._isAdaptableHeader(this._oHeader)){l=this._oHeader.getContentLeft();m=this._oHeader.getContentMiddle();n=this._oHeader.getContentRight();o=(l.length===1)&&(h(l[0])||k);p=(m.length===1)&&(h(m[0])||t);r=(n.length===1)&&h(n[0]);A=(l.length===0||o)&&(m.length===0||p)&&((n.length===0)||r);this._toggleStyle("sapF2CollapsedHeader",A,true);}};
var F=B.extend("sap.m.Fiori20Adapter",{});
F.attachViewChange=function(l,o){e.attachEvent("adaptedViewChange",l,o);};
F.detachViewChange=function(l,o){e.detachEvent("adaptedViewChange",l,o);};
F.traverse=function(o,A){i={aViewTitles:{},aViewSubTitles:{},aViewBackButtons:{}};c={};C=null;this._doBFS([{oNode:o,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}};
F._doBFS=function(Q){var n=Q.shift();if(!n){return;}var N=n.oNode,A=n.oAdaptOptions,s=A.iSearchDepth;A=this._applyRules(A,N);if(!this._isAdaptationRequired(N,A)||(s<=0)){return;}var I=this._isTopNavigableView(N);if(I){this._setAsCurrentlyAdaptedTopViewId(N.getId());}var o=this._processNode(N,A);var k=this._getNodeChildren(N),l=q.extend({},A,{iSearchDepth:this._updateSearchDepth(s,N)});if(o){var t=!!o.oTitleInfo,m=!!o.oBackButton,p=!!o.oStyledPage;l=q.extend(l,{bMoveTitle:A.bMoveTitle&&!t,bHideBackButton:A.bHideBackButton&&!m,bStylePage:A.bStylePage&&!p});}k.forEach(function(r){if(r){Q.push({oNode:r,oAdaptOptions:l});}});this._doBFS(Q);};
F._processNode=function(o,A){this._attachDefferedAdaptationListeners(o,A);if(H._isAdaptableHeader(o)){return this._adaptHeader(o,A);}if(o.getParent()&&f(o.getParent(),"sap/m/NavContainer")){return this._getCachedViewInfoToMerge(o.getId());}};
F._attachDefferedAdaptationListeners=function(o,A){this._attachAdaptableContentChange(o,A);this._attachNavigablePageChange(o,A);if(f(o,"sap/m/Page")||f(o,"sap/ui/core/mvc/XMLView")){this._observeAddAggregation(o,"content",A);}if(f(o,"sap/m/NavContainer")){this._observeRemoveAggregation(o,"pages",A);}if((A.bLateAdaptation===true)&&f(o,"sap/m/Bar")){this._observeAddAggregation(o,"contentLeft",A,o);this._observeAddAggregation(o,"contentMiddle",A,o);this._observeAddAggregation(o,"contentRight",A,o);}if(f(o,"sap/ui/core/ComponentContainer")){var k=o.getComponentInstance();if(!k&&o.getName()&&!o.getDomRef()){var t=this;var l={onBeforeRendering:function(){o.removeEventDelegate(l);t._doBFS([{oNode:o.getComponentInstance(),oAdaptOptions:A}]);if(t._getCurrentlyAdaptedTopViewId()){t._fireViewChange(t._getCurrentlyAdaptedTopViewId(),A);}}};o.addEventDelegate(l,this);}}};
F._checkHasListener=function(o,s){var k=c[o.getId()];return k&&k[s];};
F._setHasListener=function(o,s,l){var k=c[o.getId()];if(!k){k={};c[o.getId()]=k;}k[s]=l;};
F._attachAdaptableContentChange=function(o,A){if(typeof o._getAdaptableContent!=="function"){return;}if(this._checkHasListener(o,"_adaptableContentChange")){return;}var O=this._getCurrentlyAdaptedTopViewId();var k=function(l){var m=l.getParameter("adaptableContent");this._setAsCurrentlyAdaptedTopViewId(O);this._doBFS([{oNode:m,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}}.bind(this);o.attachEvent("_adaptableContentChange",k);this._setHasListener(o,"_adaptableContentChange",k);};
F._attachNavigablePageChange=function(o,A){if(!f(o,"sap/m/NavContainer")){return;}if(this._checkHasListener(o,"navigate")){return;}var O=function(k){var n=k.getParameter("to");A=this._applyRules(A,n);this._doBFS([{oNode:n,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}}.bind(this);o.attachNavigate(O);this._setHasListener(o,"navigate",O);};
F._observeAddAggregation=function(o,A,k,l){if(this._checkHasListener(o,A)){return;}var O=this._getCurrentlyAdaptedTopViewId(),m=function(p){var s=p.mutation,r=p.object;if((s==="add")||(s==="insert")){this._setAsCurrentlyAdaptedTopViewId(O);this._doBFS([{oNode:l?l:r,oAdaptOptions:k}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),k);}}}.bind(this),n=new M(m);n.observe(o,{aggregations:[A]});this._setHasListener(o,A,n);};
F._observeRemoveAggregation=function(o,A,k){if(this._checkHasListener(o,A)){return;}var O=new M(this._onRemoveAggregation.bind(this));O.observe(o,{aggregations:[A]});this._setHasListener(o,A,O);};
F._removeFromMergeInfo=function(m,o){Object.keys(m).forEach(function(k){var l=m[k];if((l.oControl===o)||j(l.oControl,o)){this._detachAllListeners(l.oControl);delete m[k];}},this);};
F._detachAllListeners=function(o){var k=c[o.getId()];if(!k){return;}Object.keys(k).forEach(function(s){var l=k[s];if(l instanceof M){l.disconnect();}else{o.detachEvent(s,l);}delete k[s];});};
F._onRemoveAggregation=function(o){var m=o.mutation,r;if(m==="remove"){r=o.child;this._detachAllListeners(r);this._removeFromMergeInfo(i.aViewTitles,r);this._removeFromMergeInfo(i.aViewSubTitles,r);this._removeFromMergeInfo(i.aViewBackButtons,r);}};
F._getNodeChildren=function(o){if(typeof o._getAdaptableContent==="function"){var k=[o._getAdaptableContent()];if(f(o,"sap/m/Page")){k=k.concat(o.getContent());}return k;}if(f(o,"sap/m/SplitContainer")){return[].concat(o.getAggregation("_navMaster"),o.getAggregation("_navDetail"));}if(f(o,"sap/uxap/ObjectPageLayout")){return[o.getHeaderTitle()];}if(f(o,"sap/ui/core/ComponentContainer")){return[o.getComponentInstance()];}if(f(o,"sap/ui/core/UIComponent")){return[o.getAggregation("rootControl")];}return o.findAggregatedObjects(false,g);};
F._updateSearchDepth=function(s,o){if(f(o,"sap/ui/core/mvc/View")||f(o,"sap/ui/core/Component")||f(o,"sap/ui/core/ComponentContainer")){return s;}return s-1;};
F._getTotalCachedInfoToMerge=function(v){var V=sap.ui.getCore().byId(v),o=this._getCachedViewInfoToMerge(v),k,l,s,S,m,p,n;if(!D.system.phone&&this._isTopSplitContainerSubView(V)){p=V.getParent();m=p&&p.getParent();if(m){k=m._oMasterNav&&(m._oMasterNav.getId()===p.getId());l=m._oDetailNav&&(m._oDetailNav.getId()===p.getId());}}if(k){s=m.getCurrentDetailPage();S=s&&s.getId();n=this._getCachedViewInfoToMerge(S);o=this._mergeSplitViewInfos(o,n);}if(l){s=m.getCurrentMasterPage();S=s&&s.getId();n=this._getCachedViewInfoToMerge(S);o=this._mergeSplitViewInfos(n,o);}o.sViewId=(k||l)?m.getId():v;return o;};
F._isTopSplitContainerSubView=function(o){var p=o&&o.getParent();return this._isTopmostNavContainer(p)&&f(p.getParent(),"sap/m/SplitContainer");};
F._mergeSplitViewInfos=function(m,o){q.each(m,function(k,v){m[k]=v||o[k];});return m;};
F._getCachedViewInfoToMerge=function(v){var o=(i.aViewBackButtons[v])?i.aViewBackButtons[v].oControl:undefined;return{oTitleInfo:i.aViewTitles[v],oSubTitleInfo:i.aViewSubTitles[v],oBackButton:o};};
F._applyRules=function(A,o){var p=o.getParent();if(f(p,"sap/m/SplitContainer")){var I=D.system.phone,m=A.bMoveTitle,k=A.bHideBackButton;if(m){m=I;}if(k&&!D.system.phone){k='initialPage';}return q.extend({},A,{bMoveTitle:m,bHideBackButton:k});}if(f(p,"sap/m/NavContainer")){if(A.bHideBackButton==='initialPage'){var l=p._getActualInitialPage()&&(p._getActualInitialPage().getId()===o.getId());return q.extend({},A,{bHideBackButton:l});}}if((A.bMoveTitle===false)||(A.bHideBackButton===false)){return q.extend({},A,{bCollapseHeader:false});}return A;};
F._getCurrentlyAdaptedTopViewId=function(){return C;};
F._setAsCurrentlyAdaptedTopViewId=function(v){C=v;};
F._isTopNavigableView=function(n){var p=n.getParent();return p&&this._isTopmostNavContainer(p);};
F._isTopmostNavContainer=function(o){var k,n=o;while(n){if(f(n,"sap/m/NavContainer")){k=n;}n=n.getParent();}return k&&(k.getId()===o.getId());};
F._adaptHeader=function(o,A){if(!o||!A){return;}var k=new H(o,A),l=k.adapt();var t=this._getCurrentlyAdaptedTopViewId();if(l.oTitleInfo){i.aViewTitles[t]=l.oTitleInfo;this._registerTextChangeListener(i.aViewTitles,t,A);}if(l.oSubTitleInfo){i.aViewSubTitles[t]=l.oSubTitleInfo;this._registerTextChangeListener(i.aViewSubTitles,t,A);}if(l.oBackButtonInfo){if(l.oBackButtonInfo.oControl.getVisible()){i.aViewBackButtons[t]=l.oBackButtonInfo;}this._registerVisibilityChangeListener(l.oBackButtonInfo,i.aViewBackButtons,t,A);}return l;};
F._registerTextChangeListener=function(t,v,A){var T=t[v];if(T&&T.oControl&&T.sChangeEventId){if(this._checkHasListener(T.oControl,T.sChangeEventId)){return;}var k=function(o){var T=t[v];if(o.getParameter("name")!==T.sPropertyName){return;}T.text=o.getParameter("newValue");this._fireViewChange(v,A);}.bind(this);T.oControl.attachEvent(T.sChangeEventId,k);this._setHasListener(T.oControl,T.sChangeEventId,k);}};
F._registerVisibilityChangeListener=function(o,k,v,A){var V;if(o&&o.oControl&&o.sChangeEventId){if(this._checkHasListener(o.oControl,o.sChangeEventId)){return;}var l=function(m){if(m.getParameter("name")!==o.sPropertyName){return;}V=m.getParameter("newValue");if(!V){q.each(k,function(I,n){if(n.oControl.getId()===o.oControl.getId()){delete k[I];}});}var p=o.oControl.getParent();if(H._isAdaptableHeader(p)){F._adaptHeader(p,A);this._fireViewChange(v,A);}}.bind(this);o.oControl.attachEvent(o.sChangeEventId,l);this._setHasListener(o.oControl,o.sChangeEventId,l);}};
F._fireViewChange=function(v,A){var t=this._getTotalCachedInfoToMerge(v);t.oAdaptOptions=A;e.fireEvent("adaptedViewChange",t);};
F._isAdaptationRequired=function(n,A){if(!n||this._isNonAdaptableControl(n)){return false;}for(var o in A){if(A.hasOwnProperty(o)&&((A[o]===true)||(A[o]==="initialPage"))){return true;}}return false;};
F._isNonAdaptableControl=function(o){return b(o);};
function a(o){return d(o,["sap/m/Label","sap/m/Text","sap/m/Title"]);}
function b(o){return d(o,["sap/m/List","sap/m/Table","sap/ui/table/Table","sap/ui/table/TreeTable"]);}
function d(o,t){if(!o||!t){return;}return t.some(function(T){return f(o,T);});}
function f(o,t){var T=sap.ui.require(t);return T&&(o instanceof T);}
function g(o){return o&&(o.sParentAggregationName!=="dependents");}
function h(o){return o&&(typeof o.getVisible==="function")&&(o.getVisible()===false);}
function j(o,r){var p=o&&o.getParent();while(p){if(p===r){return true;}p=p.getParent();}return false;}
return F;});
sap.ui.predefine('sap/m/FlexBox',['./FlexBoxStylingHelper','./FlexItemData','./library','sap/ui/base/ManagedObjectObserver','sap/ui/core/Control','sap/ui/core/InvisibleRenderer','./FlexBoxRenderer','sap/ui/thirdparty/jquery'],function(F,a,l,M,C,I,b,q){"use strict";var B=l.BackgroundDesign;var c=l.FlexAlignContent;var d=l.FlexWrap;var e=l.FlexAlignItems;var f=l.FlexJustifyContent;var g=l.FlexRendertype;var h=l.FlexDirection;
var i=C.extend("sap.m.FlexBox",{metadata:{library:"sap.m",properties:{height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},displayInline:{type:"boolean",group:"Appearance",defaultValue:false},direction:{type:"sap.m.FlexDirection",group:"Appearance",defaultValue:h.Row},fitContainer:{type:"boolean",group:"Appearance",defaultValue:false},renderType:{type:"sap.m.FlexRendertype",group:"Misc",defaultValue:g.Div},justifyContent:{type:"sap.m.FlexJustifyContent",group:"Appearance",defaultValue:f.Start},alignItems:{type:"sap.m.FlexAlignItems",group:"Appearance",defaultValue:e.Stretch},wrap:{type:"sap.m.FlexWrap",group:"Appearance",defaultValue:d.NoWrap},alignContent:{type:"sap.m.FlexAlignContent",group:"Appearance",defaultValue:c.Stretch},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Transparent}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Control",multiple:true,singularName:"item"}},designtime:"sap/m/designtime/FlexBox.designtime",dnd:{draggable:false,droppable:true}}});
i.prototype.init=function(){this._oItemDelegate={onAfterRendering:this._onAfterItemRendering};this._oItemsObserver=new M(this._onItemsChange.bind(this));this._oItemsObserver.observe(this,{aggregations:["items"]});};
i.prototype.exit=function(){if(this._oItemsObserver){this._oItemsObserver.disconnect();this._oItemsObserver=null;}};
i.prototype._onItemsChange=function(o){if(o.name==="items"&&o.child){if(o.mutation==="insert"){this._onItemInserted(o.child);}else if(o.mutation==="remove"){this._onItemRemoved(o.child);}}else if(o.name==="visible"){this._onItemVisibilityChange(o);}};
i.prototype._onItemInserted=function(o){if(o&&!(o instanceof i)){this._oItemsObserver.observe(o,{properties:["visible"]});if(this.getRenderType()===g.Bare){o.addEventDelegate(this._oItemDelegate,o);}}};
i.prototype._onItemRemoved=function(o){if(o&&!(o instanceof i)){this._oItemsObserver.unobserve(o,{properties:["visible"]});if(this.getRenderType()===g.Bare){o.removeEventDelegate(this._oItemDelegate,o);}}};
i.prototype._onItemVisibilityChange=function(o){var j=o.object,$;if(this.getRenderType()!==g.List&&this.getRenderType()!==g.Div){return;}if(j.getLayoutData()){$=q(document.getElementById(j.getLayoutData().getId()));}else{$=q(document.getElementById(I.createInvisiblePlaceholderId(j))).parent();}if(o.current){$.removeClass("sapUiHiddenPlaceholder").removeAttr("aria-hidden");}else{$.addClass("sapUiHiddenPlaceholder").attr("aria-hidden","true");}};
i.prototype._onAfterItemRendering=function(){var L=this.getLayoutData();if(L instanceof a){F.setFlexItemStyles(null,L);}};
i.prototype.setRenderType=function(v){var o=this.getRenderType(),j=this.getItems();if(v===o){return this;}this.setProperty("renderType",v);if(o==="Bare"){j.forEach(this._onItemRemoved,this);}if(v==="Bare"){j.forEach(this._onItemInserted,this);}return this;};
i.prototype.getAccessibilityInfo=function(){return{children:this.getItems()};};
return i;});
sap.ui.predefine('sap/m/FlexBoxRenderer',["./FlexBoxStylingHelper","sap/m/library","sap/base/Log","sap/m/FlexItemData"],function(F,l,L,a){"use strict";var b=l.FlexDirection;var c=l.FlexRendertype;var d={apiVersion:2};
d.render=function(r,f){var e=f.getRenderType()===c.List?"ul":"div";r.openStart(e,f);var p=f.getParent();if(p&&p.isA("sap.m.FlexBox")){if(!f.hasStyleClass("sapMFlexItem")){r.class("sapMFlexItem");}var o=f.getLayoutData();if(o&&o.isA("sap.m.FlexItemData")){F.setFlexItemStyles(r,o);}}else if(f.getFitContainer()){r.class("sapMFlexBoxFit");}r.class("sapMFlexBox");if(f.getDisplayInline()){r.class("sapMFlexBoxInline");}if(f.getDirection()===b.Column||f.getDirection()===b.ColumnReverse){r.class("sapMVBox");}else{r.class("sapMHBox");}if(f.getDirection()===b.RowReverse||f.getDirection()===b.ColumnReverse){r.class("sapMFlexBoxReverse");}r.class("sapMFlexBoxJustify"+f.getJustifyContent());r.class("sapMFlexBoxAlignItems"+f.getAlignItems());r.class("sapMFlexBoxWrap"+f.getWrap());r.class("sapMFlexBoxAlignContent"+f.getAlignContent());var B="sapMFlexBoxBG"+f.getBackgroundDesign();if(!f.hasStyleClass(B)){r.class(B);}r.style("height",f.getHeight());r.style("width",f.getWidth());var t=f.getTooltip_AsString();if(t){r.attr("title",t);}r.openEnd();d.renderItems(f,r);r.close(e);};
d.renderItems=function(f,r){var C=f.getItems(),w="";for(var i=0;i<C.length;i++){if(C[i].isA("sap.m.FlexBox")||f.getRenderType()===c.Bare){w="";}else if(f.getRenderType()===c.List){w="li";}else{w="div";}d.renderItem(C[i],w,r);}};
d.renderItem=function(i,w,r){var o=i.getLayoutData();if(w&&!o){i.setAggregation("layoutData",new a(),true);o=i.getLayoutData();}if(!(o instanceof a)){if(o){L.warning(o+" set on "+i+" is not of type sap.m.FlexItemData");}if(w){r.openStart(w);}}else{if(w){r.openStart(w,o.getId());}if(o.getStyleClass()){d.addItemClass(o.getStyleClass(),i,w,r);}d.addItemClass("sapMFlexItemAlign"+o.getAlignSelf(),i,w,r);d.addItemClass("sapMFlexBoxBG"+o.getBackgroundDesign(),i,w,r);if(w){F.setFlexItemStyles(r,o);}}d.addItemClass("sapMFlexItem",i,w,r);if(w){if(i.isA("sap.m.ScrollContainer")){r.class("sapMFlexBoxScroll");}if(!i.getVisible()){r.class("sapUiHiddenPlaceholder");}r.openEnd();}r.renderControl(i);if(w){r.close(w);}};
d.addItemClass=function(C,i,w,r){if(w){r.class(C);}else{i.addStyleClass(C);}};
return d;},true);
sap.ui.predefine('sap/m/FlexBoxStylingHelper',["sap/base/strings/hyphenate"],function(h){"use strict";var F={};
F.setFlexItemStyles=function(r,l){r=r||null;var o=''+l.getOrder(),g=''+l.getGrowFactor(),s=''+l.getShrinkFactor(),b=l.getBaseSize().toLowerCase(),m=l.getMinHeight(),M=l.getMaxHeight(),a=l.getMinWidth(),c=l.getMaxWidth();if(typeof o!=='undefined'){F.setStyle(r,l,"order",o);}if(typeof g!=='undefined'){F.setStyle(r,l,"flex-grow",g);}if(typeof s!=='undefined'){F.setStyle(r,l,"flex-shrink",s);}if(typeof b!=='undefined'){F.setStyle(r,l,"flex-basis",b);}if(typeof m!=='undefined'){F.setStyle(r,l,"min-height",m);}if(typeof M!=='undefined'){F.setStyle(r,l,"max-height",M);}if(typeof a!=='undefined'){F.setStyle(r,l,"min-width",a);}if(typeof c!=='undefined'){F.setStyle(r,l,"max-width",c);}};
F.setStyle=function(r,l,p,v){if(typeof(v)==="string"){v=h(v);}else if(typeof(v)==="number"){v=v.toString();}F.writeStyle(r,l,p,v);};
F.writeStyle=function(r,l,p,v){if(r){if(v==="0"||v){r.style(p,v);}}else{if(l.$().length){if(v!=="0"&&!v){l.$().css(p,null);}else{l.$().css(p,v);}}else{if(l.getParent()){if(v!=="0"&&!v){l.getParent().$().css(p,null);}else{l.getParent().$().css(p,v);}}}}};
return F;},true);
sap.ui.predefine('sap/m/FlexItemData',["./FlexBoxStylingHelper","./library","sap/ui/core/LayoutData"],function(F,l,L){"use strict";var B=l.BackgroundDesign;var a=l.FlexAlignSelf;
var b=L.extend("sap.m.FlexItemData",{metadata:{library:"sap.m",properties:{alignSelf:{type:"sap.m.FlexAlignSelf",group:"Misc",defaultValue:a.Auto},order:{type:"int",group:"Misc",defaultValue:0},growFactor:{type:"float",group:"Misc",defaultValue:0},shrinkFactor:{type:"float",group:"Misc",defaultValue:1},baseSize:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:"auto"},minHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:""},minWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:""},styleClass:{type:"string",group:"Misc",defaultValue:""},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Transparent}}}});
b.prototype.setAlignSelf=function(v){var o=this.getAlignSelf();this.setProperty("alignSelf",v,true);this.$().removeClass("sapMFlexItemAlign"+o).addClass("sapMFlexItemAlign"+this.getAlignSelf());return this;};
b.prototype.setOrder=function(v){this.setProperty("order",v,true);F.setStyle(null,this,"order",this.getOrder());return this;};
b.prototype.setGrowFactor=function(v){this.setProperty("growFactor",v,true);F.setStyle(null,this,"flex-grow",this.getGrowFactor());return this;};
b.prototype.setShrinkFactor=function(v){this.setProperty("shrinkFactor",v,true);F.setStyle(null,this,"flex-shrink",this.getShrinkFactor());return this;};
b.prototype.setBaseSize=function(v){this.setProperty("baseSize",v,true);F.setStyle(null,this,"flex-basis",this.getBaseSize());return this;};
b.prototype.setMinHeight=function(v){this.setProperty("minHeight",v,true);this.$().css("min-height",this.getMinHeight());return this;};
b.prototype.setMaxHeight=function(v){this.setProperty("maxHeight",v,true);this.$().css("max-height",this.getMaxHeight());return this;};
b.prototype.setMinWidth=function(v){this.setProperty("minWidth",v,true);this.$().css("min-width",this.getMinWidth());return this;};
b.prototype.setMaxWidth=function(v){this.setProperty("maxWidth",v,true);this.$().css("max-width",this.getMaxWidth());return this;};
b.prototype.setBackgroundDesign=function(v){var o=this.getBackgroundDesign();this.setProperty("backgroundDesign",v,true);this.$().removeClass("sapMFlexBoxBG"+o).addClass("sapMFlexBoxBG"+this.getBackgroundDesign());return this;};
b.prototype.setStyleClass=function(v){var o=this.getStyleClass();this.setProperty("styleClass",v,true);this.$().removeClass(o).addClass(this.getStyleClass());return this;};
b.prototype.getDomRef=function(s){var p,i=L.prototype.getDomRef.call(this,s);if(i){return i;}p=this.getParent();if(!p){return null;}return p.getDomRef(s);};
return b;});
sap.ui.predefine('sap/m/FormattedText',['./library','sap/ui/core/library','sap/ui/core/Control','./FormattedTextAnchorGenerator','./FormattedTextRenderer',"sap/base/Log","sap/base/security/URLListValidator","sap/base/security/sanitizeHTML"],function(l,c,C,F,a,L,U,s){"use strict";var b=l.LinkConversion,T=c.TextDirection,d=c.TextAlign;
var e=C.extend("sap.m.FormattedText",{metadata:{library:"sap.m",properties:{htmlText:{type:"string",group:"Misc",defaultValue:""},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},convertLinksToAnchorTags:{type:"sap.m.LinkConversion",group:"Behavior",defaultValue:b.None},convertedLinksDefaultTarget:{type:"string",group:"Behavior",defaultValue:"_blank"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:d.Begin}},aggregations:{controls:{type:"sap.m.Link",multiple:true,singularName:"control"}}}});
var _={ATTRIBS:{'style':1,'class':1,'a::href':1,'a::target':1,'dir':1},ELEMENTS:{'a':{cssClass:'sapMLnk'},'abbr':1,'bdi':1,'blockquote':1,'br':1,'cite':1,'code':1,'em':1,'h1':{cssClass:'sapMTitle sapMTitleStyleH1'},'h2':{cssClass:'sapMTitle sapMTitleStyleH2'},'h3':{cssClass:'sapMTitle sapMTitleStyleH3'},'h4':{cssClass:'sapMTitle sapMTitleStyleH4'},'h5':{cssClass:'sapMTitle sapMTitleStyleH5'},'h6':{cssClass:'sapMTitle sapMTitleStyleH6'},'p':1,'pre':1,'strong':1,'span':1,'u':1,'dl':1,'dt':1,'dd':1,'ol':1,'ul':1,'li':1}},f={ATTRIBS:{'a::href':1,'a::target':1},ELEMENTS:{'a':{cssClass:'sapMLnk'},'br':1,'em':1,'strong':1,'u':1}};e.prototype._renderingRules=_;
e.prototype.init=function(){};
function S(t,h){var w;var j,v,k=t==="a";var m=this._renderingRules.ELEMENTS[t].cssClass||"";for(var i=0;i<h.length;i+=2){j=h[i];v=h[i+1];if(!this._renderingRules.ATTRIBS[j]&&!this._renderingRules.ATTRIBS[t+"::"+j]){w='FormattedText: <'+t+'> with attribute ['+j+'="'+v+'"] is not allowed';L.warning(w,this);h[i+1]=null;continue;}if(j=="href"){if(!U.validate(v)){L.warning("FormattedText: incorrect href attribute:"+v,this);h[i+1]="#";k=false;}}if(j=="target"){k=false;}if(m&&j.toLowerCase()=="class"){h[i+1]=m+" "+v;m="";}}if(k){h.push("target");h.push("_blank");}if(m){h.push("class");h.push(m);}return h;}
function p(t,h){if(this._renderingRules.ELEMENTS[t]){return S.call(this,t,h);}else{var w='<'+t+'> is not allowed';L.warning(w,this);}}
function g(t){return s(t,{tagPolicy:p.bind(this),uriRewriter:function(u){if(U.validate(u)){return u;}}});}
function o(E){var n=window.open();n.opener=null;n.location=E.currentTarget.href;E.preventDefault();}
e.prototype.onAfterRendering=function(){this.$().find('a[target="_blank"]').on("click",o);};
e.prototype.onBeforeRendering=function(){this.$().find('a[target="_blank"]').off("click",o);};
e.prototype._getDisplayHtml=function(){var t=this.getHtmlText(),A=this.getConvertLinksToAnchorTags();if(A===b.None){return t;}t=F.generateAnchors(t,A,this.getConvertedLinksDefaultTarget());return g.call(this,t);};
e.prototype.setHtmlText=function(t){return this.setProperty("htmlText",g.call(this,t));};
e.prototype._setUseLimitedRenderingRules=function(h){this._renderingRules=h?f:_;};
return e;});
sap.ui.predefine('sap/m/FormattedTextAnchorGenerator',["sap/ui/base/Object","sap/m/library","sap/base/security/URLListValidator"],function(B,l,U){"use strict";var L=l.LinkConversion;
var A=B.extend("sap.m.FormattedTextAnchorGenerator",{getInterface:function(){return this;}});
var c=/(\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;()$]*[-A-Z0-9+&@#\/%=~_|])/gim;var W=/(www\.[^\s><]+(\b|$))/gim;var d="//";var D=/<(?:"[^"]*"['"]*|'[^']*'['"]*|[^'">])+(?!\/\s\*)>/gim;var E=/<a[^>]*>([^<]+)<\/a>/gim;var e=[D,E];
A.generateAnchors=function(t,s,T){if(s===L.ProtocolOnly){t=A._createAnchors(t,c,T);}if(s===L.All){t=A._createAnchors(t,c,T);t=A._createAnchors(t,W,T,d);}return t;};
A._createPositionObject=function(i,a){return{iStartPos:i,iEndPos:i+a};};
A._isNested=function(f,s){return f.iStartPos<s.iStartPos&&f.iEndPos>s.iEndPos;};
A._isAllowed=function(a,C){return a.some(function(o){return A._isNested(o,C);});};
A._shouldBeProcessed=function(u,C,a){return U.validate(u)&&!A._isAllowed(a,C);};
A._scanForEntitiesToSkip=function(r,t){var a=[],C;while((C=r.exec(t))!==null){a.push(A._createPositionObject(C.index,C[0].length));}return a;};
A._getEntitiesToSkipWhileSearchingForLinks=function(t){return e.map(function(s){return A._scanForEntitiesToSkip(s,t);}).reduce(function(a,b){return a.concat(b);});};
A._createAnchors=function(t,r,T,p){var a=A._getEntitiesToSkipWhileSearchingForLinks(t),C;p=p||'';C=function(P){var o=A._createPositionObject(arguments[3],P.length);if(!A._shouldBeProcessed(P,o,a)){return P;}return"<a href=\""+p+P+"\" target=\""+T+"\">"+P+"</a>";};return t.replace(r,C);};
return A;});
sap.ui.predefine('sap/m/FormattedTextRenderer',["sap/base/Log","sap/ui/core/library"],function(L,c){"use strict";var F={apiVersion:2};var T=c.TextDirection;var a=c.TextAlign;
F.render=function(r,C){var w=C.getWidth(),h=C.getHeight(),t=C.getTextDirection(),s=C.getTextAlign(),b=C.getAggregation("controls"),d=C._getDisplayHtml(),R=[],n='',S=0;r.openStart("div",C);r.class("sapMFT");if(w){r.class("sapMFTOverflowWidth");}if(h){r.class("sapMFTOverflowHeight");}if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}if(s&&s!=a.Initial){r.style("text-align",s.toLowerCase());}if(C.getTooltip_AsString()){r.attr("title",C.getTooltip_AsString());}r.style("width",w||null);r.style("height",h||null);r.openEnd();while(d!==''&&d!==n){n=d.replace(/(?:\%\%(\d+))/,_);}if(d!==''){try{r.unsafeHtml(d);}catch(e){r.text(d);}}r.close("div");function _(m,i,p){var M=m.length;try{r.unsafeHtml(d.substr(0,p));}catch(e){r.text(d.substr(0,p));}S+=p;if(b&&b[i]!==undefined){if(R[i]===undefined){r.renderControl(b[i]);R[i]=S;}else{L.error("Control with index '"+i+"' ("+m+", htmlText@"+S+") is already rendered (htmlText@"+R[i]+")!",'sap.m.FormattedText:',C.getId());}}else{r.text(m);L.error("Missing control for placeholder '"+m+"' (htmlText@"+S+")!",'sap.m.FormattedText:',C.getId());}d=d.substr(p+M);S+=M;}};
return F;},true);
sap.ui.predefine('sap/m/GenericTag',["sap/ui/core/Control","sap/ui/events/KeyCodes",'./library',"sap/ui/core/library","sap/ui/core/Icon","./GenericTagRenderer"],function(C,K,l,c,I){"use strict";var G=l.GenericTagDesign,a=l.GenericTagValueState,V=c.ValueState,b={Error:"sap-icon://message-error",Warning:"sap-icon://message-warning",Success:"sap-icon://message-success",Information:"sap-icon://hint"};
var d=C.extend("sap.m.GenericTag",{metadata:{library:"sap.m",interfaces:["sap.m.IOverflowToolbarContent","sap.m.IOverflowToolbarFlexibleContent"],properties:{text:{type:"string",defaultValue:""},status:{type:"sap.ui.core.ValueState",defaultValue:V.None},design:{type:"sap.m.GenericTagDesign",defaultValue:G.Full},valueState:{type:"sap.m.GenericTagValueState",defaultValue:a.None}},defaultAggregation:"value",associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},aggregations:{value:{type:"sap.m.ObjectNumber",multiple:false},_statusIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_errorIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},events:{press:{}}}});
d.CLASSNAME_OVERFLOW_TOOLBAR="sapMGenericTagOverflowToolbar";
d.prototype.setStatus=function(s){this.setProperty("status",s,false);this._getStatusIcon().setSrc(s!==V.None?b[s]:null);return this;};
d.prototype.setValue=function(v){var p=this.getValue();if(p){v.detachEvent("_change",this._fireValueChanged,this);}this.setAggregation("value",v);v.attachEvent("_change",this._fireValueChanged,this);this._fireValueChanged();return this;};
d.prototype._fireValueChanged=function(){this.fireEvent("_valueChanged");};
d.prototype._getStatusIcon=function(){var s=this.getAggregation("_statusIcon");if(!s){s=new I(this.getId()+"-statusIcon").addStyleClass("sapMGenericTagIcon");this.setAggregation("_statusIcon",s);}return s;};
d.prototype._getErrorIcon=function(){var e=this.getAggregation("_errorIcon");if(!e){e=new I(this.getId()+"-errorIcon",{src:b[V.Error]}).addStyleClass("sapMGenericTagErrorIcon");this.setAggregation("_errorIcon",e);}return e;};
d.prototype.ontouchstart=function(){this._toggleActiveGenericTag(true);};
d.prototype.ontouchend=function(){this._toggleActiveGenericTag(false);};
d.prototype.ontouchcancel=function(){this._toggleActiveGenericTag(false);};
d.prototype.onkeydown=function(e){if(e.which===K.SPACE||e.which===K.ENTER){this._toggleActiveGenericTag(true);}if(e.which===K.SHIFT||e.which===K.ESCAPE){this._bShouldInterupt=this._bSpacePressed;}if(e.which===K.SPACE){this._bSpacePressed=true;e.preventDefault();}if(e.which===K.ENTER){this.firePress();}};
d.prototype.onkeyup=function(e){if(e.which===K.SPACE||e.which===K.ENTER){this._toggleActiveGenericTag(false);}if(e.which===K.SPACE){if(!this._bShouldInterupt){this.firePress();}this._bShouldInterupt=false;this._bSpacePressed=false;}};
d.prototype.onclick=function(){this.firePress();};
d.prototype.onfocusout=function(){this._toggleActiveGenericTag(false);};
d.prototype._toggleActiveGenericTag=function(t){this.toggleStyleClass("sapMGenericTagActive",t);};
d.prototype._onBeforeEnterOverflow=function(o){o.addStyleClass(d.CLASSNAME_OVERFLOW_TOOLBAR);};
d.prototype._onAfterExitOverflow=function(o){o.removeStyleClass(d.CLASSNAME_OVERFLOW_TOOLBAR);};
d.prototype.getOverflowToolbarConfig=function(){var o={canOverflow:true,invalidationEvents:["_valueChanged"]};o.onBeforeEnterOverflow=this._onBeforeEnterOverflow;o.onAfterExitOverflow=this._onAfterExitOverflow;return o;};
return d;});
sap.ui.predefine('sap/m/GenericTagRenderer',["./library","sap/ui/core/library"],function(l,c){"use strict";var G=l.GenericTagDesign,a=l.GenericTagValueState,V=c.ValueState,C=sap.ui.getCore(),b={apiVersion:2};
b.render=function(r,o){var L=this._getAriaLabelledBy(o),R=C.getLibraryResourceBundle("sap.m"),t=o.getTooltip_AsString();r.openStart("div",o);r.class("sapMGenericTag");r.attr("tabindex",0);r.class("sapMGenericTag"+o.getStatus());r.accessibilityState(o,{role:"button",roledescription:R.getText("GENERICTAG_ROLEDESCRIPTION"),labelledby:L.join(" ")});if(t){r.attr("title",t);}r.openEnd();r.openStart("div");r.class("sapMGenericTagWrap");r.openEnd();this.renderElements(r,o);r.close("div");r.close("div");};
b.renderElements=function(r,o){var s=o.getDesign()===G.StatusIconHidden,S=o.getValueState()===a.Error,v=o.getValue();if(!s&&o.getStatus()!==V.None){r.renderControl(o._getStatusIcon());}this.renderText(r,o);if(S){r.renderControl(o._getErrorIcon());}else if(v){r.renderControl(v.addStyleClass("sapMGenericTagValue"));}this.renderHiddenARIAElement(r,o);};
b.renderText=function(r,o){r.openStart("span",o.getId()+"-text");r.class("sapMGenericTagText");r.openEnd();r.text(o.getText());r.close("span");};
b.renderHiddenARIAElement=function(r,o){if(o.getStatus()===V.None){return;}r.openStart("span",o.getId()+"-status");r.class("sapUiInvisibleText");r.attr("aria-hidden","true");r.openEnd();r.text(this._getGenericTagStatusText(o));r.close("span");};
b._getAriaLabelledBy=function(o){var L=o.getAriaLabelledBy().slice(),i=o.getId(),t=this._getTagValueId(o);if(o.getStatus()!==V.None){L.push(i+"-status");}L.push(i+"-text");L.push(o.getValueState()===a.Error?i+"-errorIcon":t);return L;};
b._getGenericTagStatusText=function(o){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),A;switch(o.getStatus()){case V.Error:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_ERROR");break;case V.Warning:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_WARNING");break;case V.Success:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_SUCCESS");break;case V.Information:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_INFORMATION");break;default:}return A;};
b._getTagValueId=function(o){var v=o.getValue();return v?v.getId():"";};
return b;},true);
sap.ui.predefine('sap/m/GenericTile',['./library','sap/ui/core/Control','sap/m/Text','sap/ui/core/HTML','sap/ui/core/Icon','sap/ui/core/IconPool','sap/m/Button','sap/m/GenericTileRenderer','sap/m/GenericTileLineModeRenderer','sap/m/Image','sap/ui/Device','sap/ui/core/ResizeHandler',"sap/base/strings/camelize","sap/base/util/deepEqual","sap/ui/events/PseudoEvents","sap/ui/thirdparty/jquery"],function(l,C,T,H,I,a,B,G,L,b,D,R,c,d,P,q){"use strict";var e=l.GenericTileScope,f=l.LoadState,F=l.FrameType,S=l.Size,g=l.GenericTileMode,h=l.TileSizeBehavior,W=l.WrappingType,U=l.URLHelper;var j="GenericTileDeviceSet";var m={};
var n=C.extend("sap.m.GenericTile",{
metadata:{library:"sap.m",properties:{mode:{type:"sap.m.GenericTileMode",group:"Appearance",defaultValue:g.ContentMode},header:{type:"string",group:"Appearance",defaultValue:null},subheader:{type:"string",group:"Appearance",defaultValue:null},failedText:{type:"string",group:"Appearance",defaultValue:null},size:{type:"sap.m.Size",group:"Misc",defaultValue:S.Auto,deprecated:true},frameType:{type:"sap.m.FrameType",group:"Misc",defaultValue:F.OneByOne},systemInfo:{type:"string",group:"Misc",defaultValue:null},appShortcut:{type:"string",group:"Misc",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},headerImage:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},state:{type:"sap.m.LoadState",group:"Misc",defaultValue:f.Loaded},imageDescription:{type:"string",group:"Accessibility",defaultValue:null},scope:{type:"sap.m.GenericTileScope",group:"Misc",defaultValue:e.Display},sizeBehavior:{type:"sap.m.TileSizeBehavior",defaultValue:h.Responsive},ariaLabel:{type:"string",group:"Accessibility",defaultValue:null},ariaRole:{type:"string",group:"Accessibility",defaultValue:null},ariaRoleDescription:{type:"string",group:"Accessibility",defaultValue:null},url:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},enableNavigationButton:{type:"boolean",group:"Misc",defaultValue:false},pressEnabled:{type:"boolean",group:"Misc",defaultValue:true},navigationButtonText:{type:"string",group:"Misc",defaultValue:null},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal},width:{type:"sap.ui.core.CSSSize",group:"Appearance"},additionalTooltip:{type:"string",group:"Accessibility",defaultValue:null},tileIcon:{type:"sap.ui.core.URI",multiple:false},backgroundColor:{type:"sap.ui.core.CSSColor",group:"Appearance"},valueColor:{type:"sap.m.ValueColor",group:"Appearance",defaultValue:"None"}},defaultAggregation:"tileContent",aggregations:{tileContent:{type:"sap.m.TileContent",multiple:true,bindable:"bindable"},icon:{type:"sap.ui.core.Control",multiple:false,deprecated:true},actionButtons:{type:"sap.m.Button",multiple:true,bindable:"bindable"},_titleText:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_failedMessageText:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_tileIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_tileIconImage:{type:"sap.m.Image",multiple:false,visibility:"hidden"}},events:{press:{parameters:{scope:{type:"sap.m.GenericTileScope"},action:{type:"string"},domRef:{type:"any"}}}}},
renderer:{apiVersion:2,render:function(r,o){if(o.getMode()===g.LineMode){L.render(r,o);}else{G.render(r,o);}}}
});
n._Action={Press:"Press",Remove:"Remove"};n.LINEMODE_SIBLING_PROPERTIES=["state","subheader","header","scope"];
n.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(!D.media.hasRangeSet(j)){D.media.initRangeSet(j,[450],"px",["small","large"]);}this._oTitle=new T(this.getId()+"-title");this._oTitle.addStyleClass("sapMGTTitle");this._oTitle.cacheLineHeight=false;this.setAggregation("_titleText",this._oTitle,true);this._oAppShortcut=new T(this.getId()+"-appShortcut");this._oAppShortcut.cacheLineHeight=false;this.addDependent(this._oAppShortcut);this._oSystemInfo=new T(this.getId()+"-systemInfo");this._oSystemInfo.cacheLineHeight=false;this.addDependent(this._oSystemInfo);this._oSubTitle=new T(this.getId()+"-subTitle");this._oSubTitle.cacheLineHeight=false;this.addDependent(this._oSubTitle);this._sFailedToLoad=this._oRb.getText("INFOTILE_CANNOT_LOAD_TILE");this._sLoading=this._oRb.getText("INFOTILE_LOADING");this._oFailedText=new T(this.getId()+"-failed-txt",{maxLines:2});this._oFailedText.cacheLineHeight=false;this._oFailedText.addStyleClass("sapMGTFailed");this.setAggregation("_failedMessageText",this._oFailedText,true);this._oWarningIcon=new I(this.getId()+"-warn-icon",{src:"sap-icon://notification",size:"1.375rem"});this._oWarningIcon.addStyleClass("sapMGTFtrFldIcnMrk");this._oBusy=new H(this.getId()+"-overlay");this._oBusy.setBusyIndicatorDelay(0);this._bTilePress=true;this._bThemeApplied=true;if(!sap.ui.getCore().isInitialized()){this._bThemeApplied=false;sap.ui.getCore().attachInit(this._handleCoreInitialized.bind(this));}else{this._handleCoreInitialized();}this._oNavigateAction=new B(this.getId()+"-navigateAction");this._oNavigateAction._bExcludeFromTabChain=true;this.addDependent(this._oNavigateAction);};
n.prototype.setWrappingType=function(w){this.setProperty("wrappingType",w,true);this._oTitle.setWrappingType(w);this._oFailedText.setWrappingType(w);this._oSubTitle.setWrappingType(w);this._oAppShortcut.setWrappingType(w);this._oSystemInfo.setWrappingType(w);return this;};
n.prototype.setSubheader=function(s){this.setProperty("subheader",s);this._oSubTitle.setText(s);return this;};
n.prototype.setAppShortcut=function(A){this.setProperty("appShortcut",A);this._oAppShortcut.setText(A);return this;};
n.prototype.setSystemInfo=function(s){this.setProperty("systemInfo",s);this._oSystemInfo.setText(s);return this;};
n.prototype._handleCoreInitialized=function(){this._bThemeApplied=sap.ui.getCore().isThemeApplied();if(!this._bThemeApplied){sap.ui.getCore().attachThemeChanged(this._handleThemeApplied,this);}};
n.prototype._handleThemeApplied=function(){this._bThemeApplied=true;this._oTitle.clampHeight();sap.ui.getCore().detachThemeChanged(this._handleThemeApplied,this);};
n.prototype._initScopeContent=function(t){if(!this.getState||this.getState()!==f.Disabled){this._oMoreIcon=this._oMoreIcon||a.createControlByURI({id:this.getId()+"-action-more",size:"1rem",useIconTooltip:false,src:"sap-icon://overflow"}).addStyleClass("sapMPointer").addStyleClass(t+"MoreIcon");this._oRemoveButton=this._oRemoveButton||new B({id:this.getId()+"-action-remove",icon:"sap-icon://decline",tooltip:this._oRb.getText("GENERICTILE_REMOVEBUTTON_TEXT")}).addStyleClass("sapUiSizeCompact").addStyleClass(t+"RemoveButton");this._oRemoveButton._bExcludeFromTabChain=true;switch(this.getScope()){case e.Actions:this._oMoreIcon.setVisible(true);this._oRemoveButton.setVisible(true);break;case e.ActionMore:this._oMoreIcon.setVisible(true);this._oRemoveButton.setVisible(false);break;case e.ActionRemove:this._oRemoveButton.setVisible(true);this._oMoreIcon.setVisible(false);break;default:}}};
n.prototype._isSmall=function(){return this.getSizeBehavior()===h.Small||window.matchMedia("(max-width: 374px)").matches;};
n.prototype.exit=function(){if(this._sParentResizeListenerId){R.deregister(this._sResizeListenerId);this._sParentResizeListenerId=null;}D.media.detachHandler(this._handleMediaChange,this,j);if(this._$RootNode){this._$RootNode.off(this._getAnimationEvents());this._$RootNode=null;}this._clearAnimationUpdateQueue();this._oWarningIcon.destroy();if(this._oImage){this._oImage.destroy();}this._oBusy.destroy();if(this._oMoreIcon){this._oMoreIcon.destroy();}if(this._oRemoveButton){this._oRemoveButton.destroy();}if(this._oNavigateAction){this._oNavigateAction.destroy();}};
n.prototype.onBeforeRendering=function(){var s=!!this.getSubheader();if(this.getMode()===g.HeaderMode||this.getMode()===g.IconMode){this._applyHeaderMode(s);}else{this._applyContentMode(s);}var t=this.getTileContent().length;for(var i=0;i<t;i++){this.getTileContent()[i].setProperty("disabled",this.getState()===f.Disabled,true);}this._initScopeContent("sapMGT");this._generateFailedText();this.$().off("mouseenter");this.$().off("mouseleave");if(this._sParentResizeListenerId){R.deregister(this._sResizeListenerId);this._sParentResizeListenerId=null;}D.media.detachHandler(this._handleMediaChange,this,j);if(this._$RootNode){this._$RootNode.off(this._getAnimationEvents());}if(this.getFrameType()===F.Auto){this.setProperty("frameType",F.OneByOne,true);}if(this._isNavigateActionEnabled()){var k=this.getNavigationButtonText()?this.getNavigationButtonText():this._oRb.getText("ACTION_READ_MORE");this._oNavigateAction.setText(k);this._oNavigateAction.detachPress(this._navigateEventHandler,this);}};
n.prototype.onAfterRendering=function(){this._setupResizeClassHandler();this.$().on("mouseenter",this._updateAriaAndTitle.bind(this));this.$().on("mouseleave",this._removeTooltipFromControl.bind(this));var M=this.getMode();var s=this._isScreenLarge();if(M===g.LineMode){var $=this.$().parent();if(s){this._updateHoverStyle(true);if(this.getParent()instanceof C){this._sParentResizeListenerId=R.register(this.getParent(),this._handleResize.bind(this));}else{this._sParentResizeListenerId=R.register($,this._handleResize.bind(this));}}}if(M===g.LineMode&&this._bUpdateLineTileSiblings){this._updateLineTileSiblings();this._bUpdateLineTileSiblings=false;}if(M===g.LineMode){D.media.attachHandler(this._handleMediaChange,this,j);}if(this._isNavigateActionEnabled()){this._oNavigateAction.attachPress(this._navigateEventHandler,this);}this.onDragComplete();};
n.prototype.onDragComplete=function(){if(this.hasStyleClass("sapMGTPressActive")){this.removeStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}if(this.getMode()===g.LineMode){this.removeStyleClass("sapMGTLineModePress");}}};
n.prototype._handleResize=function(){if(this.getMode()===g.LineMode&&this._isScreenLarge()&&this.getParent()){this._queueAnimationEnd();}};
n.prototype._setupResizeClassHandler=function(){var i=function(){if(this.getSizeBehavior()===h.Small||window.matchMedia("(max-width: 374px)").matches){this.$().addClass("sapMTileSmallPhone");}else{this.$().removeClass("sapMTileSmallPhone");}}.bind(this);q(window).on("resize",i);i();};
n.prototype._isCompact=function(){return q("body").hasClass("sapUiSizeCompact")||this.$().is(".sapUiSizeCompact")||this.$().closest(".sapUiSizeCompact").length>0;};
n.prototype._calculateStyleData=function(){this.$("lineBreak").remove();if(!this._isScreenLarge()||!this.getDomRef()||this.$().is(":hidden")){return null;}var $=this.$(),E=this.$("endMarker"),s=this.$("startMarker");if(E.length===0||s.length===0){return null;}var k=this._getLineCount(),o,r,t=Math.ceil(L._getCSSPixelValue(this,"margin-top")),u,A=this.$().parent().innerWidth(),v=Math.ceil(L._getCSSPixelValue(this,"min-height")),w=L._getCSSPixelValue(this,"line-height"),x=this.$().is(":not(:first-child)")&&k>1,y=q("<span><br></span>"),i=0,z=sap.ui.getCore().getConfiguration().getRTL(),J=E.position();if(x){y.attr("id",this.getId()+"-lineBreak");$.prepend(y);k=this._getLineCount();J=E.position();}var K={rtl:z,lineBreak:x,startOffset:s.offset(),endOffset:E.offset(),availableWidth:A,lines:[]};var M;if(D.browser.msie||D.browser.edge){M=y.find("br").position();}else{M=y.position();}var N=M;if(!(D.browser.mozilla||D.browser.msie||D.browser.edge)&&M.left<J.left){N=J;}K.positionLeft=x?M.left:$.position().left;K.positionRight=x?$.width()-N.left:K.availableWidth-$.position().left;if(!x&&k>1){K.positionRight=s.parent().innerWidth()-(s.position().left+s.width());}for(i;i<k;i++){if(x&&i===0){continue;}if(k===1){o=z?K.availableWidth-K.positionLeft:K.positionLeft;u=$.width();}else if(i===k-1){o=0;u=z?$.width()-J.left:J.left;}else if(x&&i===1){o=0;u=A;}else{o=0;u=A;}r=i*w+t;K.lines.push({offset:{x:o,y:r},width:u,height:v});}return K;};
n.prototype._getStyleData=function(){var s=this._calculateStyleData();if(!d(this._oStyleData,s)){delete this._oStyleData;this._oStyleData=s;return true;}return false;};
n.prototype._getAnimationEvents=function(){return"transitionend.sapMGT$id animationend.sapMGT$id".replace(/\$id/g,c(this.getId()));};
n.prototype._updateHoverStyle=function(i){if(!this._getStyleData()&&!i){return;}this._clearAnimationUpdateQueue();this._cHoverStyleUpdates=-1;this._oAnimationEndCallIds={};if(this._oStyleData&&this._oStyleData.lineBreak&&this.getUIArea()){this._$RootNode=q(this.getUIArea().getRootNode());this._$RootNode.on(this._getAnimationEvents(),this._queueAnimationEnd.bind(this));}this._queueAnimationEnd();};
n.prototype._queueAnimationEnd=function(E){if(E){var t=q(E.target);if(t.is(".sapMGT, .sapMGT *")){return false;}}if(typeof this._cHoverStyleUpdates!=="number"){this._cHoverStyleUpdates=-1;}if(!this._oAnimationEndCallIds){this._oAnimationEndCallIds={};}this._cHoverStyleUpdates++;this._oAnimationEndCallIds[this._cHoverStyleUpdates]=setTimeout(this._handleAnimationEnd.bind(this,this._cHoverStyleUpdates),10);};
n.prototype._handleAnimationEnd=function(i){delete this._oAnimationEndCallIds[i];if(this._cHoverStyleUpdates===i){this._getStyleData();L._updateHoverStyle.call(this);}};
n.prototype._clearAnimationUpdateQueue=function(){for(var k in this._oAnimationEndCallIds){clearTimeout(this._oAnimationEndCallIds[k]);delete this._oAnimationEndCallIds[k];}};
n.prototype._getLineCount=function(){var o=this.getDomRef().getBoundingClientRect(),i=L._getCSSPixelValue(this,"line-height");return Math.round(o.height/i);};
n.prototype.getBoundingRects=function(){var o=this.$().offset();return[{offset:{x:o.left,y:o.top},width:this.$().outerWidth(),height:this.$().height()}];};
n.prototype._updateLineTileSiblings=function(){var o=this.getParent();if(this.getMode()===g.LineMode&&this._isScreenLarge()&&o){var i=o.indexOfAggregation(this.sParentAggregationName,this);var s=o.getAggregation(this.sParentAggregationName).splice(i+1);for(i=0;i<s.length;i++){var k=s[i];if(k instanceof n&&k.getMode()===g.LineMode){k._updateHoverStyle();}}}};
n.prototype.ontouchstart=function(){this.addStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").addClass("sapMGTPressActive");}if(this.getMode()===g.LineMode){this.addStyleClass("sapMGTLineModePress");}};
n.prototype.ontouchcancel=function(){this.removeStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}};
n.prototype.ontouchend=function(){this.removeStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}if(this.getMode()===g.LineMode){this.removeStyleClass("sapMGTLineModePress");}};
n.prototype.ontap=function(i){if(!_(i,this)){var o;if(this._bTilePress&&this.getState()!==f.Disabled){this.$().trigger("focus");o=this._getEventParams(i);if(!(this.isInActionRemoveScope()&&o.action===n._Action.Press)){this.firePress(o);}i.preventDefault();}}};
var p=false;
n.prototype.onkeydown=function(i){if(!_(i,this)){p=(i.keyCode===16||i.keyCode===27)?true:false;var k=m[i.keyCode];if(!k){m[i.keyCode]=true;if(m[32]||m[13]){i.preventDefault();}}if(P.events.sapselect.fnCheck(i)&&this.getState()!==f.Disabled){this.addStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").addClass("sapMGTPressActive");}i.preventDefault();}}};
n.prototype._updateAriaLabel=function(){var A=this._getAriaText(),t=this.$(),i=false;if(t.attr("aria-label")!==A){t.attr("aria-label",A);i=true;}return i;};
n.prototype.onkeyup=function(i){if(!_(i,this)){var k=m[i.keyCode];if(k){delete m[i.keyCode];}var o,r=false,s=this.getScope(),A=s===e.Actions||s===e.ActionRemove;if(A&&(P.events.sapdelete.fnCheck(i)||P.events.sapbackspace.fnCheck(i))){o={scope:s,action:n._Action.Remove,domRef:this._oRemoveButton.getPopupAnchorDomRef()};r=true;}if(m[16]&&i.keyCode!==16&&this.getState()!==f.Disabled){p===false;}if((P.events.sapselect.fnCheck(i)||p)&&this.getState()!==f.Disabled){this.removeStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}o=this._getEventParams(i);r=true;}if(!p&&r){this.firePress(o);i.preventDefault();}this._updateAriaLabel();}};
n.prototype.setProperty=function(s){C.prototype.setProperty.apply(this,arguments);if(this.getMode()===g.LineMode&&n.LINEMODE_SIBLING_PROPERTIES.indexOf(s)!==-1){this._bUpdateLineTileSiblings=true;}return this;};
n.prototype.getHeader=function(){return this._oTitle.getText();};
n.prototype.setHeader=function(t){this.setProperty("header",t);this._oTitle.setText(t);return this;};
n.prototype.setHeaderImage=function(u){var v=!d(this.getHeaderImage(),u);if(v){if(this._oImage){this._oImage.destroy();this._oImage=undefined;}if(u){this._oImage=a.createControlByURI({id:this.getId()+"-icon-image",src:u},b);this._oImage.addStyleClass("sapMGTHdrIconImage");}}return this.setProperty("headerImage",u);};
n.prototype._applyHeaderMode=function(s){var i=this.getFrameType();if(this._isIconMode()){this._oTitle.setProperty("maxLines",2,true);}else if(i===F.TwoByOne&&this.getMode()===g.ActionMode){this._oTitle.setProperty("maxLines",2,true);}else if(i===F.OneByHalf||i===F.TwoByHalf){this._oTitle.setProperty("maxLines",2,true);}else{if(s){this._oTitle.setProperty("maxLines",4,true);}else{this._oTitle.setProperty("maxLines",5,true);}}this._changeTileContentContentVisibility(false);};
n.prototype._applyContentMode=function(s){var k=this.getFrameType();var t=this.getTileContent();var o=false;if(k===F.TwoByHalf||k===F.OneByHalf){if(t.length){for(var i=0;i<t.length;i++){var r=t[i].getAggregation('content');if(r!==null){if((k===F.OneByHalf&&r.getMetadata().getName()==="sap.m.ImageContent")){o=true;this._oTitle.setProperty("maxLines",2,true);break;}else{this._oTitle.setProperty("maxLines",1,true);break;}}this._oTitle.setProperty("maxLines",2,true);}}else{this._oTitle.setProperty("maxLines",2,true);}}else if(k===F.TwoByOne&&this.getMode()===g.ActionMode){if(s){this._oTitle.setProperty("maxLines",1,true);}else{this._oTitle.setProperty("maxLines",2,true);}}else if(s){this._oTitle.setProperty("maxLines",2,true);}else{this._oTitle.setProperty("maxLines",3,true);}this._changeTileContentContentVisibility(true,k,o);};
n.prototype._changeTileContentContentVisibility=function(v,k,o){var t;t=this.getTileContent();for(var i=0;i<t.length;i++){if(k==F.OneByHalf&&o){t[i].setRenderContent(false);}else{t[i].setRenderContent(v);}}};
n.prototype._getHeaderAriaAndTooltipText=function(){var t="";var i=true;if(this.getHeader()){t+=this.getHeader();i=false;}if(this.getSubheader()){t+=(i?"":"\n")+this.getSubheader();i=false;}if(this.getImageDescription()){t+=(i?"":"\n")+this.getImageDescription();}return t;};
n.prototype._getContentAriaAndTooltipText=function(){var t="";var k=true;var o=this.getTileContent();var A=this.getAdditionalTooltip();if(!this._isInActionScope()&&this.getMode()===g.ContentMode){for(var i=0;i<o.length;i++){if(typeof o[i]._getAriaAndTooltipText==="function"){t+=(k?"":"\n")+o[i]._getAriaAndTooltipText();}else if(o[i].getTooltip_AsString()){t+=(k?"":"\n")+o[i].getTooltip_AsString();}k=false;}}if(A){t+=(k?"":"\n")+A;}return t;};
n.prototype._getAriaAndTooltipText=function(){var A=(this.getTooltip_AsString()&&!this._isTooltipSuppressed())?this.getTooltip_AsString():(this._getHeaderAriaAndTooltipText()+"\n"+this._getContentAriaAndTooltipText());switch(this.getState()){case f.Disabled:return"";case f.Loading:return A+"\n"+this._sLoading;case f.Failed:return A+"\n"+this._oFailedText.getText();default:if(A.trim().length===0){return"";}else{return A;}}};
n.prototype._getAriaText=function(){var A=this.getTooltip_Text();var s=this.getAriaLabel();if(!A||this._isTooltipSuppressed()){A=this._getAriaAndTooltipText();}if(this._isInActionScope()){A=this._oRb.getText("GENERICTILE_ACTIONS_ARIA_TEXT")+" "+A;}if(s){A=s+" "+A;}return A;};
n.prototype._getTooltipText=function(){var t=this.getTooltip_Text();if(this._isTooltipSuppressed()===true){t=null;}return t;};
n.prototype._checkFooter=function(t,i){var s=i.getState();var A=this._isInActionScope()||this._bShowActionsView===true;var k=this.getFrameType();var o=t.getAggregation('content');if(this._isIconMode()){t.setRenderFooter(false);}else if(s===f.Failed||A&&s!==f.Disabled){t.setRenderFooter(false);}else if(k===F.TwoByHalf&&(o!==null||this.getSubheader())){t.setRenderFooter(false);}else if(k===F.OneByHalf&&((o!==null&&o.getMetadata().getName()!=="sap.m.ImageContent")||this.getSubheader())){t.setRenderFooter(false);}else{t.setRenderFooter(true);return true;}};
n.prototype._isInActionScope=function(){return this.getScope()===e.Actions||this.getScope()===e.ActionMore||this.getScope()===e.ActionRemove;};
n.prototype.isInActionRemoveScope=function(){return this.getScope()===e.ActionRemove;};
n.prototype._generateFailedText=function(){var s=this.getFailedText();var i=s?s:this._sFailedToLoad;this._oFailedText.setProperty("text",i,true);this._oFailedText.setAggregation("tooltip",i,true);};
n.prototype._isTooltipSuppressed=function(){var t=this.getTooltip_Text();if(t&&t.length>0&&t.trim().length===0){return true;}else{return false;}};
n.prototype._isHeaderTextTruncated=function(){var o,M,$,w;if(this.getMode()===g.LineMode){$=this.$("hdr-text");if($.length>0){w=Math.ceil($[0].getBoundingClientRect().width);return($[0]&&w<$[0].scrollWidth);}else{return false;}}else{o=this.getAggregation("_titleText").getDomRef("inner");M=this.getAggregation("_titleText").getClampHeight(o);return(M<o.scrollHeight);}};
n.prototype._isSubheaderTextTruncated=function(){var s;if(this.getMode()===g.LineMode){s=this.$("subHdr-text");}else{s=this.$("subTitle");}if(s.length>0){var w=Math.ceil(s[0].getBoundingClientRect().width);return(s[0]&&w<s[0].scrollWidth);}else{return false;}};
n.prototype._setTooltipFromControl=function(){var t=this._getAriaAndTooltipText();if(t&&!this._getTooltipText()&&!this._isTooltipSuppressed()){this.$().attr("title",t.trim());this._bTooltipFromControl=true;}};
n.prototype._updateAriaAndTitle=function(){var A=this._getAriaAndTooltipText();var s=this._getAriaText();var t=this.$();if(t.attr("title")!==A){t.attr("aria-label",s);}if(this._isInActionScope()){t.find('*:not(.sapMGTRemoveButton)').removeAttr("aria-label").removeAttr("title").off("mouseenter");}else{t.find('*').removeAttr("aria-label").removeAttr("title").off("mouseenter");}this._setTooltipFromControl();};
n.prototype._removeTooltipFromControl=function(){if(this._bTooltipFromControl){this.$().removeAttr("title");this._bTooltipFromControl=false;}};
n.prototype._isScreenLarge=function(){return this._getCurrentMediaContainerRange(j).name==="large";};
n.prototype._getEventParams=function(E){var o,A=n._Action.Press,s=this.getScope(),i=this.getDomRef();if((s===e.Actions||e.ActionRemove)&&E.target.id.indexOf("-action-remove")>-1){A=n._Action.Remove;i=this._oRemoveButton.getPopupAnchorDomRef();}else if(s===e.Actions||s===e.ActionMore){i=this._oMoreIcon.getDomRef();}o={scope:s,action:A,domRef:i};return o;};
n.prototype._handleMediaChange=function(){this._bUpdateLineTileSiblings=true;this.invalidate();};
n.prototype.setPressEnabled=function(v){this._bTilePress=v;this.setProperty("pressEnabled",v);return this;};
n.prototype.showActionsView=function(v){if(this._bShowActionsView!==v){this._bShowActionsView=v;this.invalidate();}};
n.prototype._generateIconAggregation=function(i){var A="";this._oIcon=a.createControlByURI({size:this.getFrameType()===F.OneByOne?"2rem":"1.25rem",useIconTooltip:false,src:i});if(!this._oIcon){this._oIcon=a.createControlByURI({height:this.getFrameType()===F.OneByOne?"2rem":"1.25rem",width:this.getFrameType()===F.OneByOne?"2rem":"1.25rem",useIconTooltip:false,src:i},b).addStyleClass("sapMPointer").addStyleClass("sapMGTTileIcon");}this._oIcon.addStyleClass("sapMPointer").addStyleClass("sapMGTTileIcon");if(this._oIcon instanceof b){A="_tileIconImage";}else if(this._oIcon instanceof I){A="_tileIcon";}if(A){this.setAggregation(A,this._oIcon);}return A;};
n.prototype._isIconMode=function(){if(this.getMode()===g.IconMode&&(this.getFrameType()===F.OneByOne||this.getFrameType()===F.TwoByHalf)&&this.getBackgroundColor()&&this.getTileIcon()){return true;}else{return false;}};
n.prototype._isNavigateActionEnabled=function(){return this.getMode()===g.ArticleMode&&this.getUrl()&&this.getEnableNavigationButton();};
n.prototype._isActionMode=function(){return this.getFrameType()===F.TwoByOne&&this.getMode()===g.ActionMode&&this.getActionButtons().length;};
n.prototype._getNavigateAction=function(){return this._oNavigateAction;};
n.prototype._navigateEventHandler=function(E){E.preventDefault();var u=E.getSource().getParent().getUrl();U.redirect(u,true);};
function _(i,t){var k=false,o=false;if(t._isActionMode()){var A=document.querySelector("#"+t.getId()+"-actionButtons");k=A&&A!==i.target&&A.contains(i.target);}if(t._isNavigateActionEnabled()){var N=document.querySelector("#"+t.getId()+"-navigateActionContainer");o=N&&N!==i.target&&N.contains(i.target);}return k||o;}
return n;});
sap.ui.predefine('sap/m/GenericTileLineModeRenderer',["sap/m/library","sap/base/security/encodeCSS","sap/ui/thirdparty/jquery"],function(l,e,q){"use strict";var G=l.GenericTileScope;var L=l.LoadState;var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");var a={apiVersion:2};
a.render=function(R,c){var t=c._getTooltipText(),i=c._isScreenLarge(),A=c._getAriaText(),s=c.getScope(),S,I=false,h=c.hasListeners("press"),b=c.getState(),d=c.getAriaRoleDescription(),f=c.getAriaRole();var g=c.getUrl()&&!c._isInActionScope()&&b!==L.Disabled;this._bRTL=sap.ui.getCore().getConfiguration().getRTL();if(s===G.Actions){if(b!==L.Disabled){S=e("sapMGTScopeActions");}}else if(s===G.ActionMore||s===G.ActionRemove){I=true;if(b!==L.Disabled){S=e("sapMGTScopeSingleAction");}}else{S=e("sapMGTScopeDisplay");}if(g){R.openStart("a",c);R.attr("href",c.getUrl());R.attr("rel","noopener noreferrer");R.attr("draggable","false");}else{R.openStart("span",c);}R.attr("aria-label",A);if(d){R.attr("aria-roledescription",d);}else{R.attr("aria-roledescription",r.getText("GENERIC_TILE_ROLE_DESCRIPTION"));}if(f){R.attr("role",f);}else if(!g){R.attr("role",h?"button":"presentation");}else{R.attr("role","link");}R.class("sapMGT");R.class(S);if(s===G.ActionMore){R.style("padding-right","2.25rem");}R.class("sapMGTLineMode");this._writeDirection(R);if(t){R.attr("title",t);}if(b!==L.Disabled){if(!c.isInActionRemoveScope()){R.class("sapMPointer");R.style("pointer-events","auto");}R.attr("tabindex","0");}else{R.class("sapMGTDisabled");}if(b===L.Failed){R.class("sapMGTFailed");}R.openEnd();if(c.getState()!==L.Disabled){this._renderFocusDiv(R,c);}if(i){R.openStart("div",c.getId()+"-startMarker");R.class("sapMGTStartMarker");R.openEnd();R.close("div");this._renderFailedIcon(R,c);this._renderHeader(R,c);if(c.getSubheader()){this._renderSubheader(R,c);}R.openStart("div",c.getId()+"-endMarker");R.class("sapMGTEndMarker");R.openEnd();if(c._isInActionScope()){this._renderActionsScope(R,c,I);}R.close("div");R.openStart("div",c.getId()+"-styleHelper");R.class("sapMGTStyleHelper");R.openEnd();R.close("div");}else{R.openStart("div",c.getId()+"-touchArea");R.class("sapMGTTouchArea");R.openEnd();this._renderFailedIcon(R,c);R.openStart("span",c.getId()+"-lineModeHelpContainer");R.class("sapMGTLineModeHelpContainer");R.openEnd();this._renderHeader(R,c);if(c.getSubheader()){this._renderSubheader(R,c);}R.close("span");if(c._isInActionScope()){this._renderActionsScope(R,c,I);}R.close("div");}if(g){R.close("a");}else{R.close("span");}};
a._writeDirection=function(R){if(this._bRTL){R.attr("dir","rtl");}};
a._renderFailedIcon=function(R,c){if(c.getState()===L.Failed){if(c._isCompact()){c._oWarningIcon.setSize("1.25rem");}else{c._oWarningIcon.setSize("1.375rem");}R.renderControl(c._oWarningIcon.addStyleClass("sapMGTLineModeFailedIcon"));}};
a._renderHeader=function(R,c){R.openStart("span",c.getId()+"-hdr-text");this._writeDirection(R);R.class("sapMGTHdrTxt");R.openEnd();R.text(c._oTitle.getText());R.close("span");};
a._renderSubheader=function(R,c){R.openStart("span",c.getId()+"-subHdr-text");this._writeDirection(R);R.class("sapMGTSubHdrTxt");R.openEnd();R.text(c._oSubTitle.getText());R.close("span");};
a._renderActionsScope=function(R,c,i){if(c.getState()!==L.Disabled){R.openStart("span",c.getId()+"-actions");R.class("sapMGTActionsContainer");if(i){R.class("sapMGTScopeSingleActionContainer");}R.openEnd();R.renderControl(c._oMoreIcon);R.renderControl(c._oRemoveButton);R.close("span");}};
a._updateHoverStyle=function(){var s=this.$("styleHelper");s.empty();if(!this._oStyleData||this.$().is(":hidden")){return;}if(this._oStyleData.rtl){s.css("right",-this._oStyleData.positionRight);}else{s.css("left",-this._oStyleData.positionLeft);}this._oStyleData.lines.forEach(function(o){var R=q("<div class='sapMGTLineStyleHelper'><div class='sapMGTLineStyleHelperInner'></div></div>");if(this._oStyleData.rtl){R.css("right",o.offset.x+"px");}else{R.css("left",o.offset.x+"px");}R.css({top:o.offset.y+"px",width:o.width+"px"});s.append(R);},this);};
a._renderFocusDiv=function(R,c){R.openStart("div",c.getId()+"-focus");R.class("sapMGTFocusDiv");R.openEnd();R.close("div");};
a._getCSSPixelValue=function(o,p){var O=o instanceof q?o:o.$(),m=(O.css(p)||"").match(/([^a-zA-Z\%]*)(.*)/),v=parseFloat(m[1]),u=m[2];return(u==="px")?v:v*16;};
return a;},true);
sap.ui.predefine('sap/m/GenericTileRenderer',["sap/m/library","sap/base/security/encodeCSS"],function(l,e){"use strict";var G=l.GenericTileMode;var L=l.LoadState;var f=l.FrameType;var V=l.ValueColor;var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");var a={apiVersion:2};
a.render=function(R,c){var t=c._getTooltipText();var A=c._getAriaText();var h=c.getHeaderImage();var H=c.hasListeners("press");var s=c.getState();var S=e("sapMGTState"+s);var b;var d=c.getFrameType();var g=c.getAriaRoleDescription();var j=c.getAriaRole();var k=d===f.OneByHalf||d===f.TwoByHalf;var m=c.getUrl()&&!c._isInActionScope()&&s!==L.Disabled&&!c._isNavigateActionEnabled()&&!c._isActionMode();if(c._isInActionScope()){b=e("sapMGTScopeActions");}else{b=e("sapMGTScopeDisplay");}if(m){R.openStart("a",c);R.attr("href",c.getUrl());R.attr("rel","noopener noreferrer");R.attr("draggable","false");}else{R.openStart("div",c);}if(t&&s!==L.Loading){R.attr("title",t);}R.class("sapMGT");R.class(S);R.class(b);if(!c._isInActionScope()&&c._bShowActionsView){R.class("sapMGTScopeActions");}if(c._isIconMode()){if(d===f.OneByOne){var C="sapMGTOneByOne";}else if(d===f.TwoByHalf){var C="TwoByHalf";}}R.class(c._isIconMode()?C:d);var I=c.getMode()===G.ArticleMode,n=c.getMode()===G.ActionMode;if(n){R.class("sapMGTActionMode");}if(I){R.class("sapMGTArticleMode");}if(c._isIconMode()){R.class("sapMGTIconMode");}if(!I&&!n&&d===f.OneByOne&&c.getSystemInfo()||c.getAppShortcut()){R.class("tileWithAppInfo");}if(c._isIconMode()){if(d===f.TwoByHalf){R.class("sapMGTTwoByHalf");}else{R.style("background-color",c.getBackgroundColor());}}if(j){R.attr("role",j);}else if(!m){R.attr("role",H?"button":"presentation");}else{R.attr("role","link");}if(s===L.Loaded){R.attr("aria-label",A);}if(g){R.attr("aria-roledescription",g);}else{R.attr("aria-roledescription",r.getText("GENERIC_TILE_ROLE_DESCRIPTION"));}if(s!==L.Disabled){if(!c.isInActionRemoveScope()&&c.getPressEnabled()){R.class("sapMPointer");}if(!c.getPressEnabled()){R.class("sapMAutoPointer");}R.attr("tabindex","0");}if(c.getWidth()){R.style("width",c.getWidth());}if(c.getBackgroundImage()){R.style("background-image","url('"+e(c.getBackgroundImage())+"')");R.class("sapMGTBackgroundImage");}if(c.getMode()===G.HeaderMode){R.class("sapMGTHeaderMode");}R.openEnd();var T=c.getTileContent();var o=T.length;var p=false;var q=false;if(s===L.Loading){if(c._isIconMode()){if(d===f.OneByOne){R.openStart("div").class("sapMGTContentShimmerPlaceholderItemOneByOne");R.class("sapMGTContentShimmerPlaceholderWithDescriptionOneByOne");R.openEnd();R.openStart("div").class("sapMGTContentShimmerPlaceholderRowsOneByOne").openEnd();R.openStart("div").class("sapMGTContentShimmerPlaceholderIconOneByOne").class("sapMGTLoadingShimmer").openEnd().close("div");R.openStart("div").class("sapMGTContentShimmerPlaceholderItemTextOneByOne").class("sapMGTLoadingShimmer").openEnd().close("div");}else{R.openStart("div").class("sapMGTContentShimmerPlaceholderItemTwoByHalf");R.class("sapMGTContentShimmerPlaceholderWithDescriptionTwoByHalf");R.openEnd();R.openStart("div").class("sapMGTContentShimmerPlaceholderRowsTwoByHalf").openEnd();R.openStart("div").class("sapMGTContentShimmerPlaceholderIconTwoByHalf").class("sapMGTLoadingShimmer").openEnd().close("div");R.openStart("div").class("sapMGTContentShimmerPlaceholderItemTextTwoByHalf").class("sapMGTLoadingShimmer").openEnd().close("div");}R.close("div");R.close("div");}else{R.openStart("div").class("sapMGTContentShimmerPlaceholderItem");R.class("sapMGTContentShimmerPlaceholderWithDescription");R.openEnd();R.openStart("div").class("sapMGTContentShimmerPlaceholderRows").openEnd();R.openStart("div").class("sapMGTContentShimmerPlaceholderItemHeader").class("sapMGTLoadingShimmer").openEnd().close("div");R.openStart("div").class("sapMGTContentShimmerPlaceholderItemText").class("sapMGTLoadingShimmer").openEnd().close("div");if(!k){R.openStart("div").class("sapMGTContentShimmerPlaceholderItemBox").class("sapMGTLoadingShimmer").openEnd().close("div");R.openStart("div").class("sapMGTContentShimmerPlaceholderItemTextFooter").class("sapMGTLoadingShimmer").openEnd().close("div");}R.close("div");R.close("div");}}else{if(this._isValueColorValid(c.getValueColor())){R.openStart("div");R.class("sapMGTCriticalBorder");R.class(c.getValueColor());R.openEnd();R.close("div");}if(c._isIconMode()){R.openStart("div");if(d===f.OneByOne){R.class("sapMGTOneByOneIcon");}else{R.class("sapMGTTwoByHalfIcon");R.style("background-color",c.getBackgroundColor());}R.openEnd();if(c.getTileIcon()){var u=c._generateIconAggregation(c.getTileIcon());if(u){R.renderControl(c.getAggregation(u));}}R.close("div");}R.openStart("div");R.class("sapMGTHdrContent");if(c._isIconMode()){if(d===f.OneByOne){var C="sapMGTOneByOne";}else if(d===f.TwoByHalf){var C="TwoByHalf";}}R.class(c._isIconMode()?C:d);if(t){R.attr("title",t);}R.openEnd();if(h){c._oImage.removeStyleClass(V.None);if(this._sPreviousStyleClass){c._oImage.removeStyleClass(this._sPreviousStyleClass);}this._sPreviousStyleClass=this._isValueColorValid(c.getValueColor())?c.getValueColor():V.None;c._oImage.addStyleClass(this._sPreviousStyleClass);R.renderControl(c._oImage);}this._renderHeader(R,c);for(var i=0;i<o;i++){p=c._checkFooter(T[i],c)&&T[i].getFooter();if(T[i].getAggregation("content")!==null){if(d===f.OneByHalf&&T[i].getAggregation("content").getMetadata()._sClassName==="sap.m.ImageContent"){q=false;}else{q=true;break;}}}if(!(k&&q)){if(c.getSubheader()&&(!c._isIconMode())){this._renderSubheader(R,c);}}R.close("div");if(!c._isIconMode()){R.openStart("div",c.getId()+"-content");R.class("sapMGTContent");if(p&&d===f.OneByOne&&(c.getSystemInfo()||c.getAppShortcut())){R.class("appInfoWithFooter");}else{R.class("appInfoWithoutFooter");}R.openEnd();for(var i=0;i<o;i++){R.renderControl(T[i]);}R.close("div");}if(!I&&!n&&!c._isIconMode()&&(d===f.OneByOne&&(c.getSystemInfo()||c.getAppShortcut()))){R.openStart("div",c.getId()+"-tInfo");R.class("sapMGTTInfoContainer");R.openEnd();R.openStart("div");R.class("sapMGTTInfo");R.openEnd();if(c.getAppShortcut()){R.openStart("div",c.getId()+"-appShortcut");R.class("sapMGTAppShortcutText").openEnd();R.renderControl(c._oAppShortcut);R.close("div");}if(c.getSystemInfo()){R.openStart("div",c.getId()+"-sytemInfo");R.class("sapMGTSystemInfoText").openEnd();R.renderControl(c._oSystemInfo);R.close("div");}R.close("div");R.close("div");}}if(s!==L.Loaded&&s!==L.Loading){this._renderStateOverlay(R,c,t);}if(s!==L.Disabled){this._renderHoverOverlay(R,c);this._renderFocusDiv(R,c);}if(c._isInActionScope()){this._renderActionsScope(R,c);}if(m){R.close("a");}else{R.close("div");}};
a._renderFocusDiv=function(R,c){R.openStart("div",c.getId()+"-focus");R.class("sapMGTFocusDiv");if(c._isIconMode()){if(c.getFrameType()===f.OneByOne){R.style("border-radius","1rem");}else{R.style("border-radius","0.75rem");}}R.openEnd();R.close("div");};
a._renderStateOverlay=function(R,c,t){var s=c.getState();R.openStart("div",c.getId()+"-overlay");R.class("sapMGTOverlay");if(t){R.attr("title",t);}R.openEnd();switch(s){case L.Loading:c._oBusy.setBusy(s==L.Loading);R.renderControl(c._oBusy);break;case L.Failed:R.openStart("div",c.getId()+"-failed-ftr");R.class("sapMGenericTileFtrFld");R.openEnd();R.openStart("div",c.getId()+"-failed-icon");R.class("sapMGenericTileFtrFldIcn");R.openEnd();R.renderControl(c._oWarningIcon);R.close("div");if(!c._isInActionScope()&&!c._bShowActionsView){R.openStart("div",c.getId()+"-failed-text");R.class("sapMGenericTileFtrFldTxt");R.openEnd();R.renderControl(c.getAggregation("_failedMessageText"));R.close("div");}R.close("div");break;default:}R.close("div");};
a._renderActionsScope=function(R,c){if(c.getState()!==L.Disabled){R.renderControl(c._oRemoveButton);R.renderControl(c._oMoreIcon);}};
a._renderHoverOverlay=function(R,c){R.openStart("div",c.getId()+"-hover-overlay");if(c.getBackgroundImage()){R.class("sapMGTWithImageHoverOverlay");}else{R.class("sapMGTWithoutImageHoverOverlay");if(c._isIconMode()){if(c.getFrameType()===f.OneByOne){R.style("border-radius","1rem");}else{R.style("border-radius","0.75rem");}}}R.openEnd();R.close("div");};
a._renderHeader=function(R,c){R.openStart("div",c.getId()+"-hdr-text");R.class("sapMGTHdrTxt");if(c._isActionMode()&&this._isValueColorValid(c.getValueColor())){R.class("sapMGTCriticalHdrTxt");R.class(c.getValueColor());}R.openEnd();R.renderControl(c._oTitle);R.close("div");};
a._renderSubheader=function(R,c){R.openStart("div",c.getId()+"-subHdr-text");R.class("sapMGTSubHdrTxt");R.openEnd();R.renderControl(c._oSubTitle);R.close("div");};
a._isValueColorValid=function(v){if(v==V.Good||v==V.Error||v==V.Neutral||v==V.Critical){return true;}return false;};
return a;},true);
sap.ui.predefine('sap/m/GroupHeaderListItem',["sap/ui/core/library","./library","./ListItemBase","./GroupHeaderListItemRenderer"],function(c,l,L,G){"use strict";var a=l.ListMode;var T=c.TextDirection;
var b=L.extend("sap.m.GroupHeaderListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data",defaultValue:null},count:{type:"string",group:"Data",defaultValue:null},upperCase:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}}}});
b.prototype.getMode=function(){return a.None;};
b.prototype.shouldClearLastValue=function(){return true;};
b.prototype.getTable=function(){var p=this.getParent();if(p&&p.isA("sap.m.Table")){return p;}};
b.prototype.onBeforeRendering=function(){var t=this.getTable();if(t){t.getColumns().forEach(function(C){C.clearLastValue();});this.TagName="tr";}};
b.prototype.getAccessibilityType=function(B){var t=this.getTable()?"ROW":"OPTION";return B.getText("LIST_ITEM_GROUP_HEADER")+" "+B.getText("ACC_CTR_TYPE_"+t);};
b.prototype.getContentAnnouncement=function(){return this.getTitle();};
b.prototype.getGroupAnnouncement=function(){};
return b;});
sap.ui.predefine('sap/m/GroupHeaderListItemRenderer',["sap/ui/core/library","sap/ui/core/Renderer","./ListItemBaseRenderer","./ColumnListItemRenderer"],function(c,R,L,C){"use strict";var T=c.TextDirection;var G=R.extend(L);G.apiVersion=2;
G.renderType=function(r,l){var b=l.getTable()?C:L;b.renderType.apply(this,arguments);};
G.renderNavigated=function(r,l){var b=l.getTable()?C:L;b.renderNavigated.apply(this,arguments);};
G.renderContentLatter=C.renderContentLatter;
G.renderCounter=function(r,l){};
G.renderLIAttributes=function(r,l){r.class("sapMGHLI");if(l.getUpperCase()){r.class("sapMGHLIUpperCase");}};
G.renderLIContentWrapper=function(r,l){var t=l.getTable();if(t){r.openStart("td");r.class("sapMGHLICell");r.attr("colspan",t.getColSpan());r.openEnd();}L.renderLIContentWrapper.apply(this,arguments);if(t){r.close("td");}};
G.renderLIContent=function(r,l){var t=l.getTitleTextDirection();r.openStart("span");r.class("sapMGHLITitle");if(t!=T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();r.text(l.getTitle());r.close("span");var i=l.getCount()||l.getCounter();if(i){r.openStart("span");r.class("sapMGHLICounter");r.openEnd();r.text(" ("+i+")");r.close("span");}};
G.addLegacyOutlineClass=function(r,l){var b=l.getTable()?C:L;b.addLegacyOutlineClass.apply(this,arguments);};
G.getAriaRole=function(l){if(l.getTable()){return"row";}return L.getAriaRole.apply(this,arguments);};
return G;},true);
sap.ui.predefine('sap/m/GrowingEnablement',['sap/ui/base/Object','sap/ui/core/format/NumberFormat','sap/m/library','sap/ui/model/ChangeReason','sap/ui/base/ManagedObjectMetadata','sap/ui/core/HTML','sap/m/CustomListItem',"sap/base/security/encodeXML"],function(B,N,l,C,M,H,a,e){"use strict";var L=l.ListType;var b=l.ListGrowingDirection;
var G=B.extend("sap.m.GrowingEnablement",{
constructor:function(c){B.apply(this);this._oControl=c;this._oControl.bUseExtendedChangeDetection=true;this._oControl.addDelegate(this);var r=this._oControl.getItems(true).length;this._iRenderedDataItems=r;this._iLimit=r;this._bLoading=false;this._sGroupingPath="";this._bDataRequested=false;this._oContainerDomRef=null;this._iLastItemsCount=0;this._iTriggerTimer=0;this._aChunk=[];this._oRM=null;},
destroy:function(){if(this._oTrigger){this._oTrigger.destroy();this._oTrigger=null;}if(this._oScrollDelegate){this._oScrollDelegate.setGrowingList(null);this._oScrollDelegate=null;}if(this._oRM){this._oRM.destroy();this._oRM=null;}this._oControl.$("triggerList").remove();this._oControl.bUseExtendedChangeDetection=false;this._oControl.removeDelegate(this);this._oContainerDomRef=null;this._oControl=null;},
render:function(r){r.openStart("div",this._oControl.getId()+"-triggerList");r.class("sapMListUl").class("sapMGrowingList");r.style("display","none");r.openEnd();r.renderControl(this._getTrigger());r.close("div");},
onAfterRendering:function(){var c=this._oControl;if(c.getGrowingScrollToLoad()){var s=l.getScrollDelegate(c);if(s){this._oScrollDelegate=s;s.setGrowingList(this.onScrollToLoad.bind(this),c.getGrowingDirection(),this._updateTrigger.bind(this,false));}}else if(this._oScrollDelegate){this._oScrollDelegate.setGrowingList(null);this._oScrollDelegate=null;}if(!this._bLoading){this._updateTriggerDelayed(false);}},
setTriggerText:function(t){this._oControl.$("triggerText").text(t);},
reset:function(){this._iLimit=0;var o=this._oControl.getBindingInfo("items");this._oControl.oExtendedChangeDetectionConfig=(!o||!o.template)?null:{replace:true};},
shouldReset:function(c){var m=C;return c==m.Sort||c==m.Filter||c==m.Context;},
getInfo:function(){return{total:this._oControl.getMaxItemsCount(),actual:this._iRenderedDataItems};},
onScrollToLoad:function(){var t=this._oControl.getDomRef("triggerList");if(this._bLoading||!t||t.style.display!="none"){return;}if(this._oControl.getGrowingDirection()==b.Upwards){var s=this._oScrollDelegate;this._oScrollPosition={left:s.getScrollLeft(),top:s.getScrollHeight()};}this.requestNewPage();},
requestNewPage:function(){if(!this._oControl||this._bLoading){return;}var o=this._oControl.getBinding("items");if(o&&!o.isLengthFinal()||this._iLimit<this._oControl.getMaxItemsCount()){if(this._oControl.getMetadata().hasProperty("enableBusyIndicator")){this._bParentEnableBusyIndicator=this._oControl.getEnableBusyIndicator();this._oControl.setEnableBusyIndicator(false);}this._iLimit+=this._oControl.getGrowingThreshold();this._updateTriggerDelayed(true);this.updateItems("Growing");}},
_onBeforePageLoaded:function(c){this._bLoading=true;this._oControl.onBeforePageLoaded(this.getInfo(),c);},
_onAfterPageLoaded:function(c){this._bLoading=false;this._updateTriggerDelayed(false);this._oControl.onAfterPageLoaded(this.getInfo(),c);if(this._oControl.setEnableBusyIndicator){this._oControl.setEnableBusyIndicator(this._bParentEnableBusyIndicator);}},
_getTrigger:function(){var t=this._oControl.getId()+"-trigger",T=this._oControl.getGrowingTriggerText();T=T||sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LOAD_MORE_DATA");this._oControl.addNavSection(t);if(this._oTrigger){this.setTriggerText(T);return this._oTrigger;}this._oTrigger=new a({id:t,busyIndicatorDelay:0,type:L.Active,content:new H({content:'<div class="sapMGrowingListTrigger">'+'<div class="sapMSLIDiv sapMGrowingListTriggerText">'+'<span class="sapMSLITitle" id="'+t+'Text">'+e(T)+'</span>'+'</div>'+'<div class="sapMGrowingListDescription sapMSLIDescription" id="'+t+'Info"></div>'+'</div>'})}).setParent(this._oControl,null,true).attachPress(this.requestNewPage,this).addDelegate({onsapenter:function(E){this.requestNewPage();E.preventDefault();},onsapspace:function(E){this.requestNewPage();E.preventDefault();},onAfterRendering:function(E){var $=this._oTrigger.$();$.removeAttr("aria-selected");$.attr({"tabindex":0,"role":"button","aria-labelledby":t+"Text"+" "+t+"Info"});}},this);this._oTrigger.getList=function(){};this._oTrigger.TagName="div";return this._oTrigger;},
_getListItemInfo:function(){return("[ "+this._iRenderedDataItems+" / "+N.getFloatInstance().format(this._oControl.getMaxItemsCount())+" ]");},
_getGroupingPath:function(o){var s=o.aSorters||[];var S=s[0]||{};return(S.fnGroup)?S.sPath||"":"";},
_getDomIndex:function(i){if(typeof i!="number"){return i;}if(this._oControl.hasPopin&&this._oControl.hasPopin()){return(i*2);}return i;},
_getHasScrollbars:function(){if(!this._oScrollDelegate){return false;}if(this._getDomIndex(this._iRenderedDataItems)>(window.innerHeight/32)){return true;}return this._oScrollDelegate.getMaxScrollTop()>this._oControl.getDomRef("triggerList").clientHeight;},
destroyListItems:function(s){this._oControl.destroyItems(s);this._iRenderedDataItems=0;this._aChunk=[];},
addListItem:function(c,o,s){var d=this._oControl,f=o.binding,i=this.createListItem(c,o);if(f.isGrouped()){var I=d.getItems(true),g=I[I.length-1],m=o.model,h=f.getGroup(i.getBindingContext(m));if(g&&g.isGroupHeader()){d.removeAggregation("items",g,true);this._fnAppendGroupItem=this.appendGroupItem.bind(this,h,g,s);g=I[I.length-1];}if(!g||h.key!==f.getGroup(g.getBindingContext(m)).key){var j=(o.groupHeaderFactory)?o.groupHeaderFactory(h):null;if(d.getGrowingDirection()==b.Upwards){this.applyPendingGroupItem();this._fnAppendGroupItem=this.appendGroupItem.bind(this,h,j,s);}else{this.appendGroupItem(h,j,s);}}}d.addAggregation("items",i,s);if(s){this._aChunk.push(i);}},
applyPendingGroupItem:function(){if(this._fnAppendGroupItem){this._fnAppendGroupItem();this._fnAppendGroupItem=undefined;}},
appendGroupItem:function(g,o,s){o=this._oControl.addItemGroup(g,o,s);if(s){this._aChunk.push(o);}},
createListItem:function(c,o){this._iRenderedDataItems++;return G.createItem(c,o);},
updateItemsBindingContext:function(d,m){if(!d.length){return;}var I=this._oControl.getItems(true);for(var i=0,c=0,o;i<I.length;i++){o=I[i];if(!o.isGroupHeader()){o.setBindingContext(d[c++],m);}}},
applyChunk:function(I,d){this.applyPendingGroupItem();var c=this._aChunk.length;if(!c||!this._oControl.shouldRenderItems()){return;}if(this._oControl.getGrowingDirection()==b.Upwards){this._aChunk.reverse();if(I===true){I=0;}else if(typeof I=="number"){I=this._iRenderedDataItems-c-I;}}d=d||this._oContainerDomRef;this._oRM=this._oRM||sap.ui.getCore().createRenderManager();for(var i=0;i<c;i++){this._oRM.renderControl(this._aChunk[i]);}this._oRM.flush(d,false,this._getDomIndex(I));this._aChunk=[];},
addListItems:function(c,o,s){for(var i=0;i<c.length;i++){this.addListItem(c[i],o,s);}},
rebuildListItems:function(c,o,s){this.destroyListItems(s);this.addListItems(c,o,s);if(s){var h=this._oContainerDomRef.contains(document.activeElement);this.applyChunk(false);h&&this._oControl.focus();}else{this.applyPendingGroupItem();}},
insertListItem:function(c,o,i){var I=this.createListItem(c,o);this._oControl.insertAggregation("items",I,i,true);this._aChunk.push(I);},
deleteListItem:function(i){this._oControl.getItems(true)[i].destroy(true);this._iRenderedDataItems--;},
refreshItems:function(c){if(!this._bDataRequested){this._bDataRequested=true;this._onBeforePageLoaded(c);}if(!this._iLimit||this.shouldReset(c)||!this._oControl.getItems(true).length){this._iLimit=this._oControl.getGrowingThreshold();}this._oControl.getBinding("items").getContexts(0,this._iLimit);},
updateItems:function(c){var o=this._oControl,d=o.getBinding("items"),f=o.getBindingInfo("items"),I=o.getItems(true);if(!this._iLimit||this.shouldReset(c)||!I.length){this._iLimit=o.getGrowingThreshold();}if(this._bDataRequested){this._bDataRequested=false;}else{this._onBeforePageLoaded(c);}var g=d.getContexts(0,this._iLimit)||[];if(g.dataRequested){this._bDataRequested=true;if(g.diff&&!g.diff.length){return;}}this._oContainerDomRef=o.getItemsContainerDomRef();var D=g.diff,F=false,v;if(!g.length){this.destroyListItems();}else if(!this._oContainerDomRef){this.rebuildListItems(g,f);}else if(!D||!I.length&&D.length){this.rebuildListItems(g,f,o.shouldGrowingSuppressInvalidation());}else if(d.isGrouped()||o.checkGrowingFromScratch()){if(this._sGroupingPath!=this._getGroupingPath(d)){F=true;}else{for(var i=0;i<D.length;i++){var h=D[i],j=g[h.index];if(h.type=="delete"||h.type=="replace"){F=true;break;}else if(h.index!=this._iRenderedDataItems){F=true;break;}else{this.addListItem(j,f,true);v=true;}}}}else{if(this._sGroupingPath){o.removeGroupHeaders(true);}v=-1;var k=-1;for(var i=0;i<D.length;i++){var h=D[i],m=h.index,j=g[m];if(h.type=="delete"){if(v!=-1){this.applyChunk(v);k=-1;v=-1;}this.deleteListItem(m);}else if(h.type=="insert"){if(v==-1){v=m;}else if(k>-1&&m!=k+1){this.applyChunk(v);v=m;}this.insertListItem(j,f,m);k=m;}}}if(F){this.rebuildListItems(g,f,true);}else if(this._oContainerDomRef&&D){this.updateItemsBindingContext(g,f.model);this.applyChunk(v);}this._oContainerDomRef=null;this._sGroupingPath=this._getGroupingPath(d);if(!this._bDataRequested){this._onAfterPageLoaded(c);}},
_updateTriggerDelayed:function(c){if(this._oControl.getGrowingScrollToLoad()){this._iTriggerTimer&&window.cancelAnimationFrame(this._iTriggerTimer);this._iTriggerTimer=window.requestAnimationFrame(this._updateTrigger.bind(this,c));}else{this._updateTrigger(c);}},
_updateTrigger:function(c){var t=this._oTrigger,o=this._oControl,v=o&&o.getVisibleItems().length>0;if(!t||!o||!v||!o.shouldRenderItems()||!o.getDomRef()){return;}var d=o.getBinding("items");if(!d){return;}t.setBusy(c);t.$().toggleClass("sapMGrowingListBusyIndicatorVisible",c);if(c){t.setActive(false);o.$("triggerList").css("display","");}else{var i=o.getItems(true),I=i.length,f=d.getLength()||0,g=d.isLengthFinal(),h=o.getGrowingScrollToLoad(),T=t.getDomRef();if(T&&T.contains(document.activeElement)){(i[this._iLastItemsCount]||o).focus();}if(!I||!this._iLimit||!f||(g&&this._iLimit>=f)||(h&&this._getHasScrollbars())){o.$("triggerList").css("display","none");o.$("listUl").removeClass("sapMListHasGrowing");}else{if(g){o.$("triggerInfo").css("display","block").text(this._getListItemInfo());}o.$("triggerList").css("display","");o.$("listUl").addClass("sapMListHasGrowing");t.$().removeClass("sapMGrowingListBusyIndicatorVisible");if(o.isA("sap.m.Table")&&!o.hasPopin()){this.adaptTriggerButtonWidth(o,T);}}this._iLastItemsCount=this._oControl.getItems(true).length;if(h&&this._oScrollPosition===undefined&&o.getGrowingDirection()==b.Upwards){this._oScrollPosition={left:0,top:0};}if(I>0&&this._oScrollPosition){var s=this._oScrollDelegate,S=this._oScrollPosition;s.scrollTo(S.left,s.getScrollHeight()-S.top);this._oScrollPosition=null;}}},
adaptTriggerButtonWidth:function(c,t){if(c.shouldRenderDummyColumn()&&c.$("listUl").hasClass("sapMListHasGrowing")){if(!t){t=this._oTrigger.getDomRef();}window.requestAnimationFrame(function(){if(c.bIsDestroyed){return;}var s=Array.from(c.getDomRef("tblHeader").childNodes).slice(0,-1).map(function(d){var w=d.getAttribute("data-sap-width");if(!w||!w.includes("%")){return d.getBoundingClientRect().width+"px";}else{return w;}}).join(" + ");t.style.width="calc("+s+" + 1px)";t.classList.add("sapMGrowingListDummyColumn");});}}
});
G.createItem=function(c,o,i){var I=o.factory(M.uid(i?i:"clone"),c);return I.setBindingContext(c,o.model);};
return G;});
sap.ui.predefine('sap/m/GrowingList',['./List','./library','./GrowingListRenderer'],function(L,l,G){"use strict";
var a=L.extend("sap.m.GrowingList",{metadata:{deprecated:true,library:"sap.m",properties:{threshold:{type:"int",group:"Misc",defaultValue:20},triggerText:{type:"string",group:"Appearance",defaultValue:null},scrollToLoad:{type:"boolean",group:"Behavior",defaultValue:false}}}});
a.prototype._isIncompatible=function(){return sap.ui.getCore().getConfiguration().getCompatibilityVersion("sapMGrowingList").compareTo("1.16")>=0;};
a.prototype.init=function(){L.prototype.init.call(this);if(!this._isIncompatible()){this.setGrowing();}};
a.prototype.setGrowing=function(){return L.prototype.setGrowing.call(this,true);};
!(function(g,o){["Threshold","TriggerText","ScrollToLoad"].forEach(function(p){g["set"+p]=o["setGrowing"+p];g["get"+p]=o["getGrowing"+p];});}(a.prototype,L.prototype));return a;});
sap.ui.predefine('sap/m/GrowingListRenderer',['./ListRenderer','sap/ui/core/Renderer',"sap/base/Log"],function(L,R,a){"use strict";var G=R.extend(L);G.apiVersion=2;
G.render=function(r,c){if(c._isIncompatible()){a.warning("Does not render sap.m.GrowingList#"+c.getId()+" when compatibility version is 1.16 or higher. Instead use sap.m.List/Table control with growing feature!");}else{L.render.call(this,r,c);}};
return G;},true);
sap.ui.predefine('sap/m/HBox',['./FlexBox','./library','./HBoxRenderer'],function(F,l,H){"use strict";
var a=F.extend("sap.m.HBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/HBox.designtime"}});
return a;});
sap.ui.predefine('sap/m/HBoxRenderer',['./FlexBoxRenderer'],function(F){"use strict";var H={apiVersion:2};
H.render=function(r,c){F.render.apply(this,[r,c]);};
return H;},true);
sap.ui.predefine('sap/m/HeaderContainer',['./library','./Button','./ScrollContainer','sap/ui/core/Core','sap/ui/core/Control','sap/ui/Device','sap/m/HeaderContainerItemNavigator','sap/ui/core/delegate/ItemNavigation','sap/ui/core/library','sap/ui/core/IntervalTrigger','sap/ui/core/Icon','./HeaderContainerRenderer',"sap/base/Log","sap/ui/events/KeyCodes","sap/ui/events/PseudoEvents","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control","sap/ui/dom/jquery/scrollLeftRTL","sap/ui/dom/jquery/scrollRightRTL","sap/ui/dom/jquery/Selectors"],function(l,B,S,C,a,D,H,I,c,b,d,e,L,K,P,q){"use strict";var O=c.Orientation;
var f=a.extend("sap.m.HeaderContainerItemContainer",{
metadata:{defaultAggregation:"item",properties:{position:{type:"int",defaultValue:null},setSize:{type:"int",defaultValue:null},ariaLabelledBy:{type:"string",defaultValue:null}},aggregations:{item:{type:"sap.ui.core.Control",multiple:false}}},
renderer:{apiVersion:2,render:function(r,o){var i=o.getAggregation("item");if(!i||!i.getVisible()){return;}r.openStart("div",o);r.class("sapMHdrCntrItemCntr");r.class("sapMHrdrCntrInner");r.attr("aria-setsize",o.getSetSize());r.attr("aria-posinset",o.getPosition());r.attr("role","listitem");if(o.getAriaLabelledBy()){r.attr("aria-labelledby",o.getAriaLabelledBy());}r.openEnd();r.renderControl(i);r.close("div");}}
});
var g=a.extend("sap.m.HeaderContainer",{metadata:{interfaces:["sap.m.ObjectHeaderContainer"],library:"sap.m",properties:{scrollStep:{type:"int",defaultValue:300,group:"Behavior"},scrollStepByItem:{type:"int",defaultValue:1,group:"Behavior"},scrollTime:{type:"int",defaultValue:500,group:"Behavior"},showOverflowItem:{type:"boolean",defaultValue:true,group:"Behavior"},showDividers:{type:"boolean",defaultValue:true,group:"Appearance"},orientation:{type:"sap.ui.core.Orientation",defaultValue:O.Horizontal,group:"Appearance"},backgroundDesign:{type:"sap.m.BackgroundDesign",defaultValue:l.BackgroundDesign.Transparent,group:"Appearance"},width:{type:"sap.ui.core.CSSSize",group:"Appearance"},height:{type:"sap.ui.core.CSSSize",group:"Appearance"}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true},_scrollContainer:{type:"sap.m.ScrollContainer",multiple:false,visibility:"hidden"},_prevButton:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_nextButton:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{scroll:{}}}});
g.prototype.init=function(){this._aItemEnd=[];this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oScrollCntr=new S(this.getId()+"-scrl-cntnr",{width:"100%",height:"100%",horizontal:!D.system.desktop});this.setAggregation("_scrollContainer",this._oScrollCntr,true);if(D.system.desktop){this._oArrowPrev=new B({id:this.getId()+"-scrl-prev-button",type:l.ButtonType.Transparent,tooltip:this._oRb.getText("HEADERCONTAINER_BUTTON_PREV_SECTION"),press:function(E){E.cancelBubble();this._scroll(this._getScrollValue(false),this.getScrollTime());}.bind(this)}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrLeft");this._oArrowPrev._bExcludeFromTabChain=true;this.setAggregation("_prevButton",this._oArrowPrev,true);this._oArrowNext=new B({id:this.getId()+"-scrl-next-button",type:l.ButtonType.Transparent,tooltip:this._oRb.getText("HEADERCONTAINER_BUTTON_NEXT_SECTION"),press:function(E){E.cancelBubble();this._scroll(this._getScrollValue(true),this.getScrollTime());}.bind(this)}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrRight");this._oArrowNext._bExcludeFromTabChain=true;this.setAggregation("_nextButton",this._oArrowNext,true);}else if(D.system.phone||D.system.tablet){this._oArrowPrev=new d({id:this.getId()+"-scrl-prev-button"}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrLeft");this.setAggregation("_prevButton",this._oArrowPrev,true);this._oArrowNext=new d({id:this.getId()+"-scrl-next-button"}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrRight");this.setAggregation("_nextButton",this._oArrowNext,true);}this._oScrollCntr.addDelegate({onAfterRendering:function(){if(D.system.desktop){var F=this._oScrollCntr.getDomRef("scroll");var o=this._oScrollCntr.$("scroll");var h=o.find(".sapMHrdrCntrInner").attr("tabindex","0");F.setAttribute("role","list");if(!this._oItemNavigation){this._oItemNavigation=new H();this.addDelegate(this._oItemNavigation);this._oItemNavigation.attachEvent(I.Events.BorderReached,this._handleBorderReached,this);this._oItemNavigation.attachEvent(I.Events.AfterFocus,this._handleAfterFocus,this);this._oItemNavigation.attachEvent(I.Events.BeforeFocus,this._handleBeforeFocus,this);if(D.browser.msie||D.browser.edge){this._oItemNavigation.attachEvent(I.Events.FocusAgain,this._handleFocusAgain,this);}}this._oItemNavigation.setRootDomRef(F);this._oItemNavigation.setItemDomRefs(h);this._oItemNavigation.setTabIndex0();this._oItemNavigation.setCycling(false);this._handleMobileScrolling();}}.bind(this)});b.addListener(this._checkOverflow,this);};
g.prototype.onBeforeRendering=function(){var i=this.getOrientation()===O.Horizontal,s=i?"sap-icon://slim-arrow-left":"sap-icon://slim-arrow-up",h=i?"sap-icon://slim-arrow-right":"sap-icon://slim-arrow-down";if(!this.getHeight()){L.warning("No height provided",this);}if(!this.getWidth()){L.warning("No width provided",this);}if(D.system.desktop){this._oArrowPrev.setProperty("icon",s,true);this._oArrowNext.setProperty("icon",h,true);}else if(D.system.phone||D.system.tablet){this._oArrowPrev.setProperty("src",s,true);this._oArrowNext.setProperty("src",h,true);}this.getContent();};
g.prototype.onAfterRendering=function(){this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._checkOverflow();};
g.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}b.removeListener(this._checkOverflow,this);};
g.prototype.onsaptabnext=function(E){var F=this.$().find(":focusable");var t=F.index(E.target);var n=F.eq(t+1).get(0);var o=this._getParentCell(E.target);var T;if(n){T=this._getParentCell(n);}if((o&&T&&o.id!==T.id)||(n&&n.id===this.getId()+"-after")||(n&&n.id===this.getId()+"-scrl-prev-button")||(n&&n.id===this.getId()+"-scrl-next-button")){var h=F.last().get(0);if(h){this._bIgnoreFocusIn=true;h.focus();}}};
g.prototype.onsaptabprevious=function(E){this.$().find(".sapMHdrCntrItemCntr").css("border-color","");var F=this.$().find(":focusable");var t=F.index(E.target);var p=F.eq(t-1).get(0);var o=this._getParentCell(E.target);var T;if(p){T=this._getParentCell(p);}if(!T||o&&o.id!==T.id){var s=this.$().attr("tabindex");this.$().attr("tabindex","0");this.$().trigger("focus");if(!s){this.$().removeAttr("tabindex");}else{this.$().attr("tabindex",s);}}};
g.prototype.setOrientation=function(v){this.setProperty("orientation",v);if(v===O.Horizontal&&!D.system.desktop){this._oScrollCntr.setHorizontal(true);this._oScrollCntr.setVertical(false);}else if(!D.system.desktop){this._oScrollCntr.setHorizontal(false);this._oScrollCntr.setVertical(true);}return this;};
g.prototype.validateAggregation=function(A,o,m){return this._callSuperMethod("validateAggregation",A,o,m);};
g.prototype.getAggregation=function(A,o,s){return this._callSuperMethod("getAggregation",A,o,s);};
g.prototype.setAggregation=function(A,o,s){return this._callSuperMethod("setAggregation",A,o,s);};
g.prototype.indexOfAggregation=function(A,o){return this._callSuperMethod("indexOfAggregation",A,o);};
g.prototype.insertAggregation=function(A,o,i,s){return this._callSuperMethod("insertAggregation",A,o,i,s);};
g.prototype.addAggregation=function(A,o,s){return this._callSuperMethod("addAggregation",A,o,s);};
g.prototype.removeAggregation=function(A,o,s){return this._callSuperMethod("removeAggregation",A,o,s);};
g.prototype.removeAllAggregation=function(A,s){return this._callSuperMethod("removeAllAggregation",A,s);};
g.prototype.destroyAggregation=function(A,s){return this._callSuperMethod("destroyAggregation",A,s);};
g.prototype.onkeydown=function(E){var h=this.getOrientation()===O.Horizontal,$=this.$("prev-button-container"),i=this.$("next-button-container"),s,j=0,k=this._filterVisibleItems();if(E.which===K.ARROW_RIGHT&&h){s=k[E.srcControl.mProperties.position-1].$().parent().outerWidth(true);if(s<this._getSize($.is(":visible"))){this._scroll((s-j),this.getScrollTime());}}else if(E.which===K.ARROW_LEFT&&h){s=k[E.srcControl.mProperties.position-1].$().parent().outerWidth(true);if(s<this._getSize(i.is(":visible"))){if(!i.is(":visible")){var m=10;if(s+m<this._getSize(true)){j=i.width()+m;}else{j=i.width();}}this._scroll(-(s-j),this.getScrollTime());}}if(E.which===K.ARROW_DOWN&&!h){s=k[E.srcControl.mProperties.position-1].$().parent().outerHeight(true);if(s<this._getSize($.is(":visible"))){this._scroll((s-j),this.getScrollTime());}}else if(E.which===K.ARROW_UP&&!h){s=k[E.srcControl.mProperties.position-1].$().parent().outerHeight(true);if(s<this._getSize(i.is(":visible"))){if(!i.is(":visible")){var m=10;if(s+m<this._getSize(true)){j=i.height()+m;}else{j=i.wheightidth();}}this._scroll(-(s-j),this.getScrollTime());}}};
g.prototype._setScrollInProcess=function(v){this.bScrollInProcess=v;};
g.prototype._scroll=function(i,h){this._setScrollInProcess(true);this.fireScroll();setTimeout(this._setScrollInProcess.bind(this,false),h+300);if(this.getOrientation()===O.Horizontal){this._hScroll(i,h);}else{this._vScroll(i,h);}};
g.prototype._vScroll=function(h,i){var o=this._oScrollCntr.getDomRef(),s=o.scrollTop,j=o.scrollHeight,k=s+h,m=o.clientHeight,p=parseFloat(this.$("scroll-area").css("padding-top")),r;if(k<=0){r=this._calculateRemainingScrolling(h,i,s);this.$("scroll-area").css("transition","padding "+r+"s");this.$().removeClass("sapMHrdrTopPadding");}else if(k+m+p>=j){r=this._calculateRemainingScrolling(h,i,j-m-s);this.$("scroll-area").css("transition","padding "+r+"s");if(m+h>j&&m!==j){this.$().removeClass("sapMHrdrBottomPadding");this.$().addClass("sapMHrdrTopPadding");}else{this.$().removeClass("sapMHrdrBottomPadding");}}else{this.$("scroll-area").css("transition","padding "+i/1000+"s");}this._oScrollCntr.scrollTo(0,k,i);};
g.prototype._hScroll=function(h,i){var o=this._oScrollCntr.getDomRef();var s,j,k,m,p,r;if(!this._bRtl){j=o.scrollLeft;m=o.scrollWidth;k=o.clientWidth+(D.browser.msie?1:0);s=j+h;p=parseFloat(this.$("scroll-area").css("padding-left"));if(s<=0){r=this._calculateRemainingScrolling(h,i,j);this.$("scroll-area").css("transition","padding "+r+"s");this.$().removeClass("sapMHrdrLeftPadding");}else if(s+o.clientWidth+p>=m){r=this._calculateRemainingScrolling(h,i,m-k-j);this.$("scroll-area").css("transition","padding "+r+"s");if(k+h>m&&k!==m){this.$().removeClass("sapMHrdrRightPadding");this.$().addClass("sapMHrdrLeftPadding");}else{this.$().removeClass("sapMHrdrRightPadding");}}else{this.$("scroll-area").css("transition","padding "+i/1000+"s");}this._oScrollCntr.scrollTo(s,0,i);}else{s=q(o).scrollRightRTL()+h;this._oScrollCntr.scrollTo((s>0)?s:0,0,i);}};
g.prototype._collectItemSize=function(){var s=0,h=this._filterVisibleItems(),F=this.getOrientation()===O.Horizontal?"outerWidth":"outerHeight";this._aItemEnd=[];h.forEach(function(o,i){s+=o.$().parent()[F](true);this._aItemEnd[i]=s;},this);};
g.prototype._getScrollValue=function(F){if(!this._oScrollCntr){return 0;}var h=this.getOrientation()===O.Horizontal,$=this._oScrollCntr.$(),j=this.$("prev-button-container"),m=this.$("next-button-container"),s=h?$[0].scrollLeft:$[0].scrollTop,t=0,n=0,o,p=this._filterVisibleItems();var G=function(k){var n=0,u=0;var v=10;if(this._bRtl&&h){if(!j.is(":visible")){u=j.width();}if(!m.is(":visible")){u=m.width();}}for(var i=0;i<p.length&&i<k;i++){n+=r(p[i]);}return n!==0?n+v-u:0;}.bind(this);var r=function(k){return h?k.$().parent().outerWidth(true):k.$().parent().outerHeight(true);};var E=function(){var n=this._getSize(true),M,A=0;for(var i=t;i<p.length;i++){if(!p[i].$().is(":visible")){M=r(p[i])+G(i)-n-s;for(var k=t;k<p.length&&k<i;k++){if(o+A>M){break;}t++;A+=r(p[k]);}o+=A;break;}}}.bind(this);if(this.getScrollStepByItem()>0){s=h&&this._bRtl?$.scrollRightRTL():s;for(var i=0;i<p.length;i++){n+=r(p[i]);if(n>=s){t=i;break;}}t=(F?1:-1)*this.getScrollStepByItem()+t;if(t<0){t=0;}if(t>=p.length){t=p.length-1;}o=G(t)-s;if(F&&!this.getShowOverflowItem()){E();}return o;}return F?this.getScrollStep():-this.getScrollStep();};
g.prototype._calculateRemainingScrolling=function(h,i,j){return Math.abs(j*i/(1000*h));};
g.prototype._checkOverflow=function(){if(this.getOrientation()===O.Horizontal){this._checkHOverflow();}else{this._checkVOverflow();}};
g.prototype._filterVisibleItems=function(){return this.getContent().filter(function(i){return i.getVisible();});};
g.prototype._getFirstItemOffset=function(t){var F=this._filterVisibleItems()[0],$=F&&F.$(),h=$&&$.parent(),i=h&&h[0]&&h[0][t];return i||0;};
g.prototype._checkVOverflow=function(){var o=this._oScrollCntr.getDomRef(),h,$;if(o){var F=this._getFirstItemOffset("offsetTop");var s=Math.ceil(o.scrollTop);var i=false;var j=false;var r=o.scrollHeight;var k=o.offsetHeight;if(Math.abs(r-k)===1){r=k;}if(s>F){i=true;}if((r>k)&&(s+k<r)){j=true;}j=this._checkForOverflowItem(j);$=this.$("prev-button-container");h=$.is(":visible");if(h&&!i){$.hide();this.$().removeClass("sapMHrdrTopPadding");}if(!h&&i){$.show();this.$().addClass("sapMHrdrTopPadding");}$=this.$("next-button-container");var m=$.is(":visible");if(m&&!j){$.hide();this.$().removeClass("sapMHrdrBottomPadding");}if(!m&&j){$.show();this.$().addClass("sapMHrdrBottomPadding");}}};
g.prototype._handleMobileScrolling=function(){if(C.isMobile()){var $=this.$("scrl-cntnr-scroll"),i=this.getOrientation()===O.Horizontal,p=i?"clientX":"clientY",h=0,t=this,s=false;$.on("touchstart",function(E){s=true;h=E.targetTouches[0][p];});$.on("touchmove",function(E){if(s){var j=E.targetTouches[0][p],k=h-j,o=t._oScrollCntr.getDomRef();i?o.scrollLeft+=k:o.scrollTop+=k;h=j;E.preventDefault();}});$.on("touchend",function(){s=false;});}};
g.prototype._checkHOverflow=function(){var o=this._oScrollCntr.getDomRef(),$;if(o){var F=this._getFirstItemOffset("offsetLeft");var s=Math.ceil(o.scrollLeft);var h=false;var i=false;var r=o.scrollWidth;var j=o.offsetWidth;if(Math.abs(r-j)===1){r=j;}if(this._bRtl){var k=q(o).scrollLeftRTL();if(k>((D.browser.msie||D.browser.edge)?1:0)){i=true;}}else if(s>F){h=true;}if(r-5>j){if(this._bRtl){if(q(o).scrollRightRTL()>1){h=true;}}else if(s+j<r){i=true;}}$=this.$("prev-button-container");i=this._checkForOverflowItem(i);var m=$.is(":visible");if(m&&!h){$.hide();this.$().removeClass("sapMHrdrLeftPadding");}if(!m&&h){$.show();this.$().addClass("sapMHrdrLeftPadding");}$=this.$("next-button-container");var n=$.is(":visible");if(n&&!i){$.hide();this.$().removeClass("sapMHrdrRightPadding");}if(!n&&i){$.show();this.$().addClass("sapMHrdrRightPadding");}}};
g.prototype._getSize=function(A){var $=this._oScrollCntr.$(),h=this.getOrientation()===O.Horizontal,i=this.$("next-button-container"),j=!i.is(":visible")&&A,F=h?"width":"height";return $[F]()-(j?i[F]():0);};
g.prototype._checkForOverflowItem=function(s){if(this._oScrollCntr&&!this.getShowOverflowItem()){var $=this._oScrollCntr.$(),h=this.getOrientation()===O.Horizontal,j=!h?$[0].scrollTop:(this._bRtl?$.scrollRightRTL():$[0].scrollLeft),F=h?"width":"height",k=this._getSize(s),m=this._filterVisibleItems();this._collectItemSize();this._aItemEnd.forEach(function(E,i){var n=m[i].$(),o=n.parent(),v=n.is(":visible");if(s&&E>j+k){if(i===0||this._aItemEnd[i-1]<=j){o.css(F,"auto");n.show();}else if(v){o[F](o[F]());n.hide();s=true;}}else{if(!v){o.css(F,"auto");n.show();}}},this);}return s;};
g.prototype._handleBorderReached=function(E){if(D.browser.msie&&this.bScrollInProcess){return;}var i=E.getParameter("index");if(i===0){this._scroll(this._getScrollValue(false),this.getScrollTime());}else if(i===this._filterVisibleItems().length-1){this._scroll(this._getScrollValue(true),this.getScrollTime());}};
g.prototype._handleAfterFocus=function(E){var s=E.getParameter("event");if((D.browser.msie||D.browser.edge)&&s.type==="mousedown"&&s.srcControl instanceof sap.m.Input){s.srcControl.focus();}if(D.browser.msie&&this.bScrollInProcess){return;}var i=E.getParameter("index");if(i===0){this._scroll(this._getScrollValue(false),this.getScrollTime());}else if(i===this._filterVisibleItems().length-1){this._scroll(this._getScrollValue(true),this.getScrollTime());}};
g.prototype._handleFocusAgain=function(E){var s=E.getParameter("event");if((D.browser.msie||D.browser.edge)&&s.type==="mousedown"&&s.srcControl instanceof sap.m.Input){s.srcControl.focus();}E.getParameter("event").preventDefault();};
g.prototype._handleBeforeFocus=function(E){var o=E.getParameter("event");if(q(o.target).hasClass("sapMHdrCntrItemCntr")||q(o.target).hasClass("sapMScrollContScroll")||P.events.sapprevious.fnCheck(o)||P.events.sapnext.fnCheck(o)){this.$().find(".sapMHdrCntrItemCntr").css("border-color","");}else{this.$().find(".sapMHdrCntrItemCntr").css("border-color","transparent");}};
g.prototype._unWrapHeaderContainerItemContainer=function(w){if(w instanceof f){w=w.getItem();}else if(Array.isArray(w)){for(var i=0;i<w.length;i++){if(w[i]instanceof f){w[i]=w[i].getItem();}}}return w;};
g._AGGREGATION_FUNCTIONS=["validateAggregation","getAggregation","setAggregation","indexOfAggregation","removeAggregation"];g._AGGREGATION_FUNCTIONS_FOR_INSERT=["insertAggregation","addAggregation"];
g.prototype._callSuperMethod=function(F,A){var h=Array.prototype.slice.call(arguments);if(A==="content"){var o=h[2];h[1]="content";if(o instanceof a){if(g._AGGREGATION_FUNCTIONS.indexOf(F)>-1&&o.getParent()instanceof f){h[2]=o.getParent();}else if(g._AGGREGATION_FUNCTIONS_FOR_INSERT.indexOf(F)>-1){h[2]=new f({item:o});}}var j=[];this._oScrollCntr.getContent().forEach(function(o,s){if(!o.getItem()){j.push(s);}});for(var i=0;i<j.length;i++){this._oScrollCntr.removeContent(j[i]);}var r=this._oScrollCntr[F].apply(this._oScrollCntr,h.slice(1));if(F!=="removeAllAggregation"){var k=this._oScrollCntr.getContent();var m=this.getAriaLabelledBy();var p=1;var v=k.filter(function(s){return s.getItem().getVisible();}).length;for(var i=0;i<k.length;i++){var n=k[i];if(n.getItem().getVisible()){n.setVisible(true);n.setPosition(p);n.setSetSize(v);n.setAriaLabelledBy(m[i]);p++;}else{n.setVisible(false);}}}return this._unWrapHeaderContainerItemContainer(r);}else{return a.prototype[F].apply(this,h.slice(1));}};
g.prototype._callMethodInManagedObject=function(){throw new TypeError("Method no longer exists: HeaderContainer.prototype._callMethodInManagedObject");};
g.prototype._getParentCell=function(o){return q(o).parents(".sapMHrdrCntrInner").andSelf(".sapMHrdrCntrInner").get(0);};
g.prototype.onfocusin=function(E){if(this._bIgnoreFocusIn){this._bIgnoreFocusIn=false;return;}if(E.target.id===this.getId()+"-after"){this._restoreLastFocused();}};
g.prototype._restoreLastFocused=function(){if(!this._oItemNavigation){return;}var n=this._oItemNavigation.getItemDomRefs();var i=this._oItemNavigation.getFocusedIndex();var $=q(n[i]);var r=$.control(0)||{};var t=r.getTabbables?r.getTabbables():$.find(":sapTabbable");t.eq(-1).add($).eq(-1).trigger("focus");};
return g;});
sap.ui.predefine('sap/m/HeaderContainerItemNavigator',["sap/ui/core/delegate/ItemNavigation","sap/base/assert","sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes"],function(I,a,c,K){"use strict";
var H=I.extend("sap.m.HeaderContainerItemNavigator");
H.prototype.focusItem=function(i,e){if(e.type==="mousedown"){var f=this.aItemDomRefs[i].focus;this.aItemDomRefs[i].focus=function(){};this._callParent("focusItem",arguments);this.aItemDomRefs[i].focus=f;return;}this._callParent("focusItem",arguments);};
H.prototype._callParent=function(f,A){if(typeof I.prototype[f]==="function"){I.prototype[f].apply(this,A);}};
H.prototype.onsaphome=function(e){if(this._skipNavigation(e)){return;}this._callParent("onsaphome",arguments);};
H.prototype.onsapend=function(e){if(this._skipNavigation(e)){return;}this._callParent("onsapend",arguments);};
H.prototype.onsapnext=function(e){if(this._skipNavigation(e)){return;}this._callParent("onsapnext",arguments);};
H.prototype.onsapprevious=function(e){if(this._skipNavigation(e,true,false)){return;}this._callParent("onsapprevious",arguments);};
H.prototype._skipNavigation=function(e){return Array.prototype.indexOf.call(this.aItemDomRefs,e.target)===-1;};
return H;});
sap.ui.predefine('sap/m/HeaderContainerRenderer',['sap/ui/core/library'],function(c){"use strict";var O=c.Orientation;var H={apiVersion:2};
H.render=function(r,C){var t=C.getTooltip_AsString();var o=C.getOrientation();var b="sapMHdrCntrBG"+C.getBackgroundDesign();r.openStart("div",C);if(t){r.attr("title",t);}r.class("sapMHdrCntr");r.class(o);if(C.getShowDividers()){r.class("sapMHrdrCntrDvdrs");}if(C.getHeight()){r.style("height",C.getHeight());}else{r.style("height",(C.getOrientation()===O.Horizontal)?"auto":"100%");}if(C.getWidth()){r.style("width",C.getWidth());}else{r.style("width",(C.getOrientation()===O.Horizontal)?"100%":"auto");}r.openEnd();r.openStart("div",C.getId()+"-scroll-area");r.class("sapMHdrCntrCntr");r.class(o);r.class(b);r.openEnd();r.renderControl(C.getAggregation("_scrollContainer"));r.close("div");var B=C.getAggregation("_prevButton");if(B){r.openStart("div",C.getId()+"-prev-button-container");r.class("sapMHdrCntrBtnCntr");r.class("sapMHdrCntrLeft");r.class(o);r.openEnd();r.renderControl(B);r.close("div");}B=C.getAggregation("_nextButton");if(B){r.openStart("div",C.getId()+"-next-button-container");r.class("sapMHdrCntrBtnCntr");r.class("sapMHdrCntrRight");r.class(o);r.openEnd();r.renderControl(B);r.close("div");}r.openStart("div",C.getId()+"-after");r.attr("tabindex","0");r.openEnd().close("div");r.close("div");};
return H;},true);
sap.ui.predefine('sap/m/HyphenationSupport',["sap/ui/core/Core","./library","sap/ui/core/hyphenation/Hyphenation","sap/base/Log"],function(C,l,H,L){"use strict";var W=l.WrappingType;
function i(o){if(!o.isA("sap.m.IHyphenation")){L.error("[UI5 Hyphenation] The given control does not implement interface sap.m.IHyphenation and can not use HyphenationSupport mixin.");return false;}return true;}
function a(o,k){var t=o.getTextsToBeHyphenated();if(typeof t!=="object"){L.error("[UI5 Hyphenation] The result of getTextsToBeHyphenated method is not a map object.",o.getId());return false;}if(Object.keys(t).indexOf(k)<0){L.error("[UI5 Hyphenation] The key "+k+" is not found in the result of getTextsToBeHyphenated method.",o.getId());return false;}return true;}
function s(D,n){n=n||"";var f=D.childNodes;if(f.length===1&&f[0].nodeType===window.Node.TEXT_NODE){f[0].nodeValue=n;}else{D.textContent=n;}}
function d(t,T){var D=[];Object.keys(t).forEach(function(k){if(!(k in T&&t[k]===T[k])){D.push(k);}});return D;}
function b(){var f=C.getConfiguration().getHyphenation(),o=H.getInstance();if(f==="native"||f==="disable"){return false;}if(f==="thirdparty"){return true;}return o.isLanguageSupported()&&!o.canUseNativeHyphenation()&&o.canUseThirdPartyHyphenation();}
function c(o){var f=C.getConfiguration().getHyphenation();if(f==='disable'){return false;}if(o.getWrapping&&!o.getWrapping()&&o.getWrappingType()===W.Hyphenated){L.warning("[UI5 Hyphenation] The property wrappingType=Hyphenated will not take effect unless wrapping=true.",o.getId());}return(!o.getWrapping||o.getWrapping())&&o.getWrappingType()===W.Hyphenated;}
function h(o){if(!c(o)||!b()){o._mHyphenatedTexts={};o._mUnhyphenatedTexts={};return;}var t=o.getTextsToBeHyphenated(),f=d(t,o._mUnhyphenatedTexts);if(f.length>0){o._mUnhyphenatedTexts=t;f.forEach(function(k){delete o._mHyphenatedTexts[k];});var g=H.getInstance();if(!g.isLanguageInitialized()){g.initialize().then(function(){var D=o.isActive()?o.getDomRefsForHyphenatedTexts():null,n=false;f.forEach(function(k){o._mHyphenatedTexts[k]=g.hyphenate(t[k]);if(D&&k in D){s(D[k],o._mHyphenatedTexts[k]);}else{n=true;}});if(n){o.invalidate();}});}else{f.forEach(function(k){o._mHyphenatedTexts[k]=g.hyphenate(t[k]);});}}}
var e={};
e.mixInto=function(o){if(!i(o)){return;}var I=o.init;o.init=function(f){var r=I.apply(this,arguments);this._mHyphenatedTexts={};this._mUnhyphenatedTexts={};return r;};var O=o.onBeforeRendering;o.onBeforeRendering=function(){var r=O.apply(this,arguments);h(this);return r;};};
e.writeHyphenationClass=function(r,o){if(!i(o)){return;}if(c(o)&&!b()){r.class("sapUiHyphenation");}};
e.getTextForRender=function(o,k){if(!i(o)){return null;}if(!a(o,k)){return null;}var t=o.getTextsToBeHyphenated();if(c(o)&&b()){if(t[k]!==o._mUnhyphenatedTexts[k]){h(o);}if(k in o._mHyphenatedTexts){return o._mHyphenatedTexts[k];}}return t[k];};
return e;});
sap.ui.predefine('sap/m/IconTabBar',['./library',"sap/ui/core/Core",'sap/ui/core/Control','./IconTabBarRenderer','./IconTabHeader',"sap/ui/core/util/ResponsivePaddingsEnablement","sap/ui/thirdparty/jquery"],function(l,C,a,I,b,R,q){"use strict";var c=l.IconTabHeaderMode;var B=l.BackgroundDesign;var d=l.IconTabDensityMode;var T=l.TabsOverflowMode;
var e=a.extend("sap.m.IconTabBar",{metadata:{interfaces:["sap.m.ObjectHeaderContainer","sap.f.IDynamicPageStickyContent"],library:"sap.m",properties:{showSelection:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},expandable:{type:"boolean",group:"Misc",defaultValue:true},expanded:{type:"boolean",group:"Misc",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:null},upperCase:{type:"boolean",group:"Appearance",defaultValue:false},stretchContentHeight:{type:"boolean",group:"Appearance",defaultValue:false},applyContentPadding:{type:"boolean",group:"Appearance",defaultValue:true},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Solid},headerMode:{type:"sap.m.IconTabHeaderMode",group:"Appearance",defaultValue:c.Standard},showOverflowSelectList:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},headerBackgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Solid},enableTabReordering:{type:"boolean",group:"Behavior",defaultValue:false},maxNestingLevel:{type:"int",group:"Behavior",defaultValue:0},tabDensityMode:{type:"sap.m.IconTabDensityMode",group:"Appearance",defaultValue:d.Cozy},ariaTexts:{type:"object",group:"Accessibility",defaultValue:null},tabsOverflowMode:{type:"sap.m.TabsOverflowMode",group:"Behavior",defaultValue:T.End}},aggregations:{items:{type:"sap.m.IconTab",multiple:true,singularName:"item",forwarding:{getter:"_getIconTabHeader",aggregation:"items",forwardBinding:true}},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},_header:{type:"sap.m.IconTabHeader",multiple:false,visibility:"hidden"}},events:{select:{parameters:{item:{type:"sap.m.IconTabFilter"},key:{type:"string"},previousKey:{type:"string"},selectedItem:{type:"sap.m.IconTabFilter"},selectedKey:{type:"string"}}},expand:{parameters:{expand:{type:"boolean"},collapse:{type:"boolean"}}}},designtime:"sap/m/designtime/IconTabBar.designtime"}});
R.call(e.prototype,{header:{selector:".sapMITH"},content:{suffix:"content"}});e._CLASSES_TO_COPY=["sapUiResponsiveContentPadding","sapUiNoContentPadding","sapUiContentPadding"];
e.prototype.init=function(){this._initResponsivePaddingsEnablement();};
e.prototype.setExpanded=function(E){this.setProperty("expanded",E,true);if(this.$().length){this._toggleExpandCollapse(E);}return this;};
e.prototype.setHeaderMode=function(m){this.setProperty("headerMode",m,true);this._getIconTabHeader().setMode(m);return this;};
e.prototype.setTabDensityMode=function(m){this.setProperty("tabDensityMode",m);this._getIconTabHeader().setTabDensityMode(m);return this;};
e.prototype.setHeaderBackgroundDesign=function(h){this.setProperty("headerBackgroundDesign",h,true);this._getIconTabHeader().setBackgroundDesign(h);return this;};
e.prototype.setEnableTabReordering=function(v){this.setProperty("enableTabReordering",v,true);this._getIconTabHeader().setEnableTabReordering(v);return this;};
e.prototype.setAriaTexts=function(A){this.setProperty("ariaTexts",A,true);this._getIconTabHeader().setAriaTexts(A);return this;};
e.prototype.addStyleClass=function(s,S){var i=this._getIconTabHeader();if(e._CLASSES_TO_COPY.indexOf(s)!==-1){i.addStyleClass(s,true);}return a.prototype.addStyleClass.apply(this,arguments);};
e.prototype.removeStyleClass=function(s,S){var i=this._getIconTabHeader();if(e._CLASSES_TO_COPY.indexOf(s)!==-1){i.removeStyleClass(s,true);}return a.prototype.removeStyleClass.apply(this,arguments);};
e.prototype._rerenderContent=function(o){var $=this.$("content");if(o&&($.length>0)){var r=C.createRenderManager();for(var i=0;i<o.length;i++){r.renderControl(o[i]);}r.flush($[0]);r.destroy();}};
e.prototype._toggleExpandCollapse=function(E){var $=this.$("content");var s=this._getIconTabHeader().oSelectedItem;if(E===undefined){E=!this.getExpanded();}if(s){s.$().toggleClass("sapMITBSelected",E);s.$().attr({'aria-expanded':E});if(E){s.$().attr({'aria-selected':E});}else{s.$().removeAttr('aria-selected');}}this._iAnimationCounter=(this._iAnimationCounter===undefined?1:++this._iAnimationCounter);if(E){if(s){if(this.$("content").children().length===0){var S=s.getContent();if(S.length>0){this._rerenderContent(S);}else{this._rerenderContent(this.getContent());}}$.stop(true,true).slideDown('400',q.proxy(this.onTransitionEnded,this,E));this.$("containerContent").toggleClass("sapMITBContentClosed",!E);}}else{this.$("contentArrow").hide();$.stop(true,true).slideUp('400',q.proxy(this.onTransitionEnded,this,E));}if(!E||s){this.setProperty("expanded",E,true);}this.fireExpand({expand:E,collapse:!E});return this;};
e.prototype.onTransitionEnded=function(E){var $=this.$("content"),f=this.$("containerContent"),g=this.$("contentArrow");if(this._iAnimationCounter===1){f.toggleClass("sapMITBContentClosed",!E);if(E){g.show();$.css("display","block");}else{g.hide();$.css("display","none");}}this._iAnimationCounter=(this._iAnimationCounter>0?--this._iAnimationCounter:0);return this;};
e.prototype._getIconTabHeader=function(){var o=this.getAggregation("_header");if(!o){o=new b(this.getId()+"--header",{});this.setAggregation("_header",o,true);}return o;};
e.prototype._getStickyContent=function(){return this._getIconTabHeader();};
e.prototype._returnStickyContent=function(){if(this.bIsDestroyed){return;}this._getStickyContent().$().prependTo(this.$());};
e.prototype._setStickySubheaderSticked=function(i){this._bStickyContentSticked=i;};
e.prototype._getStickySubheaderSticked=function(){return this._bStickyContentSticked;};
e.prototype.onBeforeRendering=function(){var i=this._getIconTabHeader(),$=i.$();i.setMaxNestingLevel(this.getMaxNestingLevel());i.setTabsOverflowMode(this.getTabsOverflowMode());if(this._bStickyContentSticked&&$){delete this._bStickyContentSticked;this._getIconTabHeader().$().remove();}};
e.prototype.setShowSelection=function(v){this._getIconTabHeader().setShowSelection(v);return this;};
e.prototype.getShowSelection=function(){return this._getIconTabHeader().getShowSelection();};
e.prototype.setSelectedKey=function(v){this._getIconTabHeader().setSelectedKey(v);return this;};
e.prototype.getSelectedKey=function(){return this._getIconTabHeader().getSelectedKey();};
e.prototype.setSelectedItem=function(i,A){return this._getIconTabHeader().setSelectedItem(i,A);};
return e;});
sap.ui.predefine('sap/m/IconTabBarDragAndDropUtil',['sap/ui/core/dnd/DragInfo','sap/ui/core/dnd/DropInfo',"sap/ui/events/KeyCodes",'sap/ui/core/library'],function(D,a,K,c){"use strict";var b=c.dnd.DropPosition;var I="Before",d="insertBefore",e="insertAfter",i,f="IconTabReorder",g="Forward",h="Backward";var j={_insertControl:function(i,o,k,l){var $=o.$(),m=k.$(),n=[],p=[];if(o._getNestedLevel()>1&&k._getNestedLevel()>1){n=o._getRootTab()._getSelectList().getItems().filter(function(q){return o._getRealTab()._isParentOf(q._getRealTab());});p=k._getRootTab()._getSelectList().getItems().filter(function(q){return k._getRealTab()._isParentOf(q._getRealTab());});}if(l){var O=o._getRootTab().getParent()._getOverflow()._getSelectList().getItems();n=O.filter(function(q){return o._getRealTab()._isParentOf(q._getRealTab());});p=O.filter(function(q){return k._getRealTab()._isParentOf(q._getRealTab());});}if(i===e){$.insertAfter(m);}else{$.insertBefore(m);}n.reverse().forEach(function(C){C.$().insertAfter($);});p.reverse().forEach(function(C){C.$().insertAfter(m);});},handleDrop:function(C,s,o,k,l,m){var B=C.indexOfItem(o),n=C.indexOfItem(k),A=0,r=sap.ui.getCore().getConfiguration().getRTL(),p=s===I,q=k._getNestedLevel()-1;if(o._isParentOf(k)){return;}if(q===m&&s===b.On){return;}if(r&&!l){if(p){A=B<n?n:n+1;i=e;}else{A=B<n?n-1:n;i=d;}}else{if(p){A=B<n?n-1:n;i=d;}else{A=B<n?n:n+1;i=e;}}if(C.isA("sap.m.IconTabFilter")||!o.getParent().isA("sap.m.IconTabHeader")){if(p){A=n;}else{A=n+1;}}j._insertControl(i,o,k);if(s===b.On){if(k===o){return;}A=C.getAggregation("items").length;}j._handleConfigurationAfterDragAndDrop.call(C,o,A);},_updateAccessibilityInfo:function(){var o=this.getItems(),A=1,k;o.forEach(function(l){k=l.getDomRef();if(k&&k.getAttribute("aria-posinset")!==null){k.setAttribute("aria-posinset",A++);}});},_handleConfigurationAfterDragAndDrop:function(o,k){var l=[],m=this.isA("sap.m.IconTabHeader")?this:this._getIconTabHeader();if(this.isA("sap.m.IconTabBarSelectList")){l=this.getItems().filter(function(p){return o._getRealTab()._isParentOf(p._getRealTab());});}m._setPreserveSelection(true);this.removeAggregation('items',o,true);this.insertAggregation('items',o,k,true);l.forEach(function(p){this.removeAggregation('items',p,true);}.bind(this));var n=1+this.indexOfAggregation('items',o);l.reverse().forEach(function(p){this.insertAggregation('items',p,n,true);}.bind(this));m._setPreserveSelection(false);j._updateAccessibilityInfo.call(this);},_decreaseDropIndex:function(B,k){var p=B-1;while(p>=0&&(k[B]._getRealTab()._getNestedLevel()!==k[p]._getRealTab()._getNestedLevel()||!k[p].getVisible()||(!k[B].$().hasClass("sapMITBFilterHidden")&&k[p].$().hasClass("sapMITBFilterHidden")))){p--;}if(p<0){i=e;return B;}i=d;return p;},_increaseDropIndex:function(B,k,m){var n=B+1;while(n<k.length&&(k[B]._getRealTab()._getNestedLevel()!==k[n]._getRealTab()._getNestedLevel()||!k[n].getVisible())){n++;}if(n>m){i=d;return B;}i=e;return n;},moveItem:function(o,k,m){var l=this.getItems(),B=this.indexOfItem(o),r=sap.ui.getCore().getConfiguration().getRTL(),n,p;if(this.isA("sap.m.IconTabFilter")){l=this._getRealTab().getItems();}switch(k){case K.HOME:n=0;i=d;break;case K.END:n=l.length-1;i=e;break;case K.ARROW_LEFT:if(r){p=j.preventDragBetweenSubItems(o,g,this);n=j._increaseDropIndex(B,l,m);}else{p=j.preventDragBetweenSubItems(o,h,this);n=j._decreaseDropIndex(B,l);}break;case K.ARROW_RIGHT:if(r){p=j.preventDragBetweenSubItems(o,h,this);n=j._decreaseDropIndex(B,l);}else{p=j.preventDragBetweenSubItems(o,g,this);n=j._increaseDropIndex(B,l,m);}break;case K.ARROW_DOWN:p=j.preventDragBetweenSubItems(o,g,this);n=j._increaseDropIndex(B,l,m);break;case K.ARROW_UP:p=j.preventDragBetweenSubItems(o,h,this);n=j._decreaseDropIndex(B,l);break;default:return false;}if(p){return false;}if(!this.isA("sap.m.IconTabFilter")){var q=l[n];j._insertControl(i,o,q,this._oTabFilter&&this._oTabFilter._bIsOverflow);}j._handleConfigurationAfterDragAndDrop.call(this,o,n);return true;},setDragDropAggregations:function(k,s,o){var l=k._oIconTabHeader?k._oIconTabHeader:k;var m=l.getId();k.addDragDropConfig(new D({sourceAggregation:"items",groupName:f+m}));k.addDragDropConfig(new a({targetAggregation:"items",dropPosition:o,dropLayout:s,drop:k._handleDragAndDrop.bind(k),groupName:f+m}));},preventDragBetweenSubItems:function(o,s,C){var p=false;if(C.isA("sap.m.IconTabBarSelectList")){var r=o._getRealTab(),P=r.getParent(),k=P.getItems();if((k.indexOf(r)===0&&s===h)||(k.indexOf(r)+1===k.length&&s===g)||k.length===1){p=true;}}return p;}};return j;});
sap.ui.predefine('sap/m/IconTabBarRenderer',[],function(){"use strict";var I={apiVersion:2};I._aAllIconColors=['sapMITBFilterCritical','sapMITBFilterPositive','sapMITBFilterNegative','sapMITBFilterDefault'];
I.render=function(r,i){var c=i.getContent(),h=i._getIconTabHeader();r.openStart("div",i).class("sapMITB");if(i.getStretchContentHeight()){r.class("sapMITBStretch");}if(!i.getApplyContentPadding()){r.class("sapMITBNoContentPadding");}r.class("sapMITBBackgroundDesign"+i.getBackgroundDesign()).openEnd();if(!i._bHideHeader){r.renderControl(h);}r.openStart("div",i.getId()+"-containerContent").class("sapMITBContainerContent");if(!i.getExpanded()){r.class("sapMITBContentClosed");}r.openEnd();r.openStart("div",i.getId()+"-content").class("sapMITBContent").attr("role","tabpanel");if(!i.getExpanded()){r.style("display","none");}if(h.oSelectedItem){r.accessibilityState({labelledby:h.oSelectedItem.getId()});}r.openEnd();if(i.getExpanded()){if(h.oSelectedItem&&h.oSelectedItem.getContent()){var C=h.oSelectedItem.getContent();if(C.length>0){c=C;}}c.forEach(function(o){r.renderControl(o);});}r.close("div").close("div").close("div");};
return I;},true);
sap.ui.predefine('sap/m/IconTabBarSelectList',["./library","./IconTabBarDragAndDropUtil","./IconTabBarSelectListRenderer","sap/ui/core/Control","sap/ui/core/delegate/ItemNavigation","sap/ui/core/theming/Parameters","sap/ui/core/library","sap/ui/thirdparty/jquery"],function(l,I,a,C,b,P,c,q){"use strict";var D=c.dnd.DropPosition;
var d=C.extend("sap.m.IconTabBarSelectList",{metadata:{library:"sap.m",aggregations:{items:{type:"sap.m.IconTab",multiple:true,singularName:"item",dnd:true}},events:{selectionChange:{parameters:{selectedItem:{type:"sap.m.IconTabFilter"}}}}}});
d.prototype.init=function(){this._oItemNavigation=new b();this._oItemNavigation.setCycling(false);this.addEventDelegate(this._oItemNavigation);this._oItemNavigation.setPageSize(10);this._oIconTabHeader=null;this._oTabFilter=null;};
d.prototype.exit=function(){this._oItemNavigation.destroy();this._oItemNavigation=null;this._oIconTabHeader=null;this._oTabFilter=null;};
d.prototype.onBeforeRendering=function(){if(!this._oIconTabHeader){return;}this.destroyDragDropConfig();this._setsDragAndConfiguration();};
d.prototype.onAfterRendering=function(){this._initItemNavigation();this.getItems().forEach(function(i){if(i._onAfterParentRendering){i._onAfterParentRendering();}});};
d.prototype._setsDragAndConfiguration=function(){if(this._oIconTabHeader.getEnableTabReordering()&&!this.getDragDropConfig().length){I.setDragDropAggregations(this,"Vertical",this._oIconTabHeader._getDropPosition());}};
d.prototype._initItemNavigation=function(){var e=this.getItems(),f=[],p=this._oIconTabHeader.oSelectedItem,s=-1,o,i;for(i=0;i<e.length;i++){o=e[i];if(o.isA("sap.m.IconTabFilter")){var g=o._getAllSubFiltersDomRefs();f=f.concat(o.getDomRef(),g);}if(p&&this.getSelectedItem()&&this.getSelectedItem()._getRealTab()===p){s=i;}}if(p&&f.indexOf(p.getDomRef())!==-1){s=f.indexOf(p.getDomRef());}this._oItemNavigation.setRootDomRef(this.getDomRef()).setItemDomRefs(f).setSelectedIndex(s);};
d.prototype.getVisibleItems=function(){return this.getItems().filter(function(i){return i.getVisible();});};
d.prototype.getVisibleTabFilters=function(){return this.getVisibleItems().filter(function(i){return i.isA("sap.m.IconTabFilter");});};
d.prototype.setSelectedItem=function(i){this._selectedItem=i;};
d.prototype.getSelectedItem=function(){return this._selectedItem;};
d.prototype._getIconTabHeader=function(){return this._oIconTabHeader;};
d.prototype._getParams=function(){var p=Object.assign({"_sap_m_IconTabBar_SelectListItem_PaddingLeft":"0.5rem","_sap_m_IconTabBar_SelectListItem_PaddingLeftAdditional":"0"},P.get({name:["_sap_m_IconTabBar_SelectListItem_PaddingLeft","_sap_m_IconTabBar_SelectListItem_PaddingLeftAdditional"],callback:this.invalidate.bind(this)}));return{fNestedItemPaddingLeft:Number.parseFloat(p["_sap_m_IconTabBar_SelectListItem_PaddingLeft"]),fAdditionalPadding:Number.parseFloat(p["_sap_m_IconTabBar_SelectListItem_PaddingLeftAdditional"])};};
d.prototype._checkTextOnly=function(){return this.getItems().every(function(i){return i.isA('sap.m.IconTabSeparator')||!i.getIcon();});};
d.prototype.ontap=function(e){var t=e.srcControl;if(!t){return;}if(!t.isA("sap.m.IconTabFilter")){return;}if(this._oIconTabHeader._isUnselectable(t)){return;}e.preventDefault();if(t!=this.getSelectedItem()){this.fireSelectionChange({selectedItem:t});}};
d.prototype.onsapenter=d.prototype.ontap;d.prototype.onsapspace=d.prototype.ontap;
d.prototype.checkIconOnly=function(){this._bIconOnly=this.getVisibleTabFilters().every(function(i){return!i.getText()&&!i.getCount();});return this._bIconOnly;};
d.prototype._handleDragAndDrop=function(e){var s=e.getParameter("dropPosition"),o=e.getParameter("draggedControl"),f=e.getParameter("droppedControl"),g=f._getRealTab().getParent(),h=this._oIconTabHeader.getMaxNestingLevel();if(this._oTabFilter._isOverflow()){g=this._oIconTabHeader;}if(s===D.On){g=f._getRealTab();}I.handleDrop(g,s,o._getRealTab(),f._getRealTab(),true,h);this._oIconTabHeader._setItemsForStrip();this._oIconTabHeader._initItemNavigation();this._oTabFilter._setSelectListItems();this._initItemNavigation();f._getRealTab().getParent().$().trigger("focus");};
d.prototype.ondragrearranging=function(e){if(!this._oIconTabHeader.getEnableTabReordering()){return;}var t=e.srcControl,k=e.keyCode,i=this.indexOfItem(t),o=this;I.moveItem.call(o,t,k,o.getItems().length-1);this._initItemNavigation();t.$().trigger("focus");if(i===this.indexOfItem(t)){return;}o=t._getRealTab().getParent();if(this._oTabFilter._isOverflow()&&t._getRealTab()._getNestedLevel()===1){this._oIconTabHeader._moveTab(t._getRealTab(),k,this._oIconTabHeader.getItems().length-1);}else{I.moveItem.call(o,t._getRealTab(),k,o.getItems().length-1);}};
d.prototype.onsaphomemodifiers=d.prototype.ondragrearranging;d.prototype.onsapendmodifiers=d.prototype.ondragrearranging;d.prototype.onsapincreasemodifiers=d.prototype.ondragrearranging;d.prototype.onsapdecreasemodifiers=d.prototype.ondragrearranging;return d;});
sap.ui.predefine('sap/m/IconTabBarSelectListRenderer',["sap/ui/core/library"],function(c){"use strict";var I=c.IconColor;var a={apiVersion:2};
a.render=function(r,s){var p=s._getParams(),i=s.getVisibleItems(),o=s._oIconTabHeader,t=s._checkTextOnly(),T=o.getVisibleTabFilters().length,n=p.fNestedItemPaddingLeft,e=false;var h=i.filter(function(b){return b.isA("sap.m.IconTabFilter");}).some(function(b){return b.getIconColor()!==I.Default;});s.checkIconOnly();var A=p.fAdditionalPadding;if(h&&A){n+=A;e=true;}this.renderList(r,i,s,o,t,n,e,T);};
a.renderList=function(r,b,s,o,t,p,e,S){if(!b.length){return;}r.openStart("ul",s).attr("role","menu").class("sapMITBSelectList");if(t){r.class("sapMITBSelectListTextOnly");}r.openEnd();for(var i=0;i<b.length;i++){var d=b[i],f;if(o&&d.isA("sap.m.IconTabFilter")){f=o.getVisibleTabFilters().indexOf(d._getRealTab());}if(d.isA("sap.m.IconTabFilter")&&d._getRootTab()._getSelectList()===s){f=i;S=b.length;}var l=d._getNestedLevel()-2;if(e){l++;}if(s._bIsOverflow){l++;}d.renderInSelectList(r,s,f,S,p*l);}r.close("ul");};
return a;},true);
sap.ui.predefine('sap/m/IconTabFilter',["./library","./AccButton","./IconTabFilterExpandButtonBadge","sap/ui/core/library","sap/ui/core/Core","sap/ui/core/Item","sap/ui/core/Renderer","sap/ui/core/IconPool",'sap/ui/core/InvisibleMessage','sap/ui/Device',"sap/m/BadgeCustomData","sap/m/Button","sap/m/ResponsivePopover","sap/m/IconTabBarSelectList","sap/m/BadgeEnabler"],function(l,A,I,c,C,a,R,b,d,D,B,e,f,g,h){"use strict";var T=c.TextAlign;var j=c.TextDirection;var k=l.ButtonType;var P=l.PlacementType;var m=l.ImageHelper;var n=l.IconTabFilterDesign;var o=l.BadgeStyle;var p=l.BadgeState;var q=c.IconColor;var r=c.aria.HasPopup;var s=3000;var t=c.InvisibleMessageMode;var u=-8;
var v=a.extend("sap.m.IconTabFilter",{metadata:{interfaces:["sap.m.IconTab","sap.ui.core.PopupInterface","sap.m.IBadge"],library:"sap.m",designtime:"sap/m/designtime/IconTabFilter.designtime",properties:{count:{type:"string",group:"Data",defaultValue:''},showAll:{type:"boolean",group:"Misc",defaultValue:false},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:''},iconColor:{type:"sap.ui.core.IconColor",group:"Appearance",defaultValue:q.Default},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},visible:{type:"boolean",group:"Behavior",defaultValue:true},design:{type:"sap.m.IconTabFilterDesign",group:"Appearance",defaultValue:n.Vertical}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},items:{type:"sap.m.IconTab",multiple:true,singularName:"item"},_expandButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_expandButtonBadge:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}}}});
h.call(v.prototype);var w=C.getLibraryResourceBundle("sap.m");v._aAllIconColors=['sapMITBFilterCritical','sapMITBFilterPositive','sapMITBFilterNegative','sapMITBFilterDefault','sapMITBFilterNeutral'];
v.prototype._getImageControl=function(i,x,y){var z={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};if(z.src){this._oImageControl=m.getImageControl(this.getId()+"-icon",this._oImageControl,x,z,i,y);}else if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}return this._oImageControl;};
v.prototype.init=function(){this._oDragEventDelegate={onlongdragover:this._handleOnLongDragOver,ondragover:this._handleOnDragOver,ondragleave:this._handleOnDragLeave,ondrop:this._handleOnDrop};this.initBadgeEnablement({style:o.Attention,selector:{selector:".sapMITBBadgeHolder"}});this._oCloneInList=null;this.setAggregation("_expandButtonBadge",new I());};
v.prototype.exit=function(E){if(this._oImageControl){this._oImageControl.destroy();}if(a.prototype.exit){a.prototype.exit.call(this,E);}if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}if(this._oExpandButton){this._oExpandButton.removeEventDelegate(this._oDragEventDelegate);this._oExpandButton.destroy();this._oExpandButton=null;}this.removeEventDelegate(this._oDragEventDelegate);this._oDragEventDelegate=null;if(this._iHideBadgeTimeout){clearTimeout(this._iHideBadgeTimeout);}};
v.prototype.invalidate=function(){var i=this.getParent(),x,O;if(!i){return;}x=i.getParent();if(!(x instanceof sap.m.IconTabBar)){i.invalidate();return;}O=x.getParent();if(O instanceof sap.m.ObjectHeader){O.invalidate();}else{x.invalidate();}};
v.prototype.setProperty=function(i,V,S){switch(i){case'textDirection':case'text':case'count':case'showAll':case'icon':case'iconColor':case'iconDensityAware':case'design':if(this.getProperty(i)===V){return this;}a.prototype.setProperty.call(this,i,V,true);if(!S){var x=this.getParent();if(x instanceof sap.m.IconTabHeader){x.invalidate();}}break;default:a.prototype.setProperty.apply(this,arguments);break;}return this;};
v.prototype._getNonEmptyKey=function(){var K=this.getKey();if(K){return K;}return this.getId();};
v.prototype._getRealTab=function(){return this._oRealItem||this;};
v.prototype._getRootTab=function(){var i=this._getRealTab(),x=i.getParent();while(x&&x.isA("sap.m.IconTabFilter")){i=x;x=x.getParent();}return i;};
v.prototype._getNestedLevel=function(){var i=this._getRealTab().getParent(),L;for(L=1;i&&i.isA("sap.m.IconTabFilter");L++){i=i.getParent();}return L;};
v.prototype.render=function(i,V,x){if(!this.getVisible()){return;}var y=this.getParent(),z=y.getParent();if(y.getEnableTabReordering()){this._prepareDragEventDelegate();}var H=y._isInsideIconTabBar(),E={role:"tab"},F=this.getId(),G=this.getCount(),J=this.getText(),K=this.getIcon(),L=this.getIconColor(),M=this.getEnabled(),S=this._shouldReadIconColor(),N=this.getDesign()===n.Horizontal,O=y._bTextOnly,Q=y._bInLine||y.isInlineMode(),U=this.getShowAll(),W=this.getTextDirection();if(this._isOverflow()){E.role="button";}if(H){E.controls=z.getId()+"-content";}if(this.getItems().length){E.roledescription=w.getText("ICONTABFILTER_SPLIT_TAB");}if(J.length||G!==""||K){var X=[];if(G!==""&&!Q){X.push(F+"-count");}if(J.length){X.push(F+"-text");}if(K){X.push(F+"-icon");}if(S){X.push(F+"-iconColor");}E.labelledby=X.join(" ");}if(V!==undefined&&x!==undefined){Object.assign(E,{posinset:V+1,setsize:x});}i.openStart("div",this).accessibilityState(E).class("sapMITBItem");if(!G){i.class("sapMITBItemNoCount");}if(N){i.class("sapMITBHorizontal");}else{i.class("sapMITBVertical");}if(U){i.class("sapMITBAll");}else{i.class("sapMITBFilter");}if(!U&&M){i.class("sapMITBFilter"+L);}if(y._isUnselectable(this)){i.class("sapMITHUnselectable");}if(this.getItems().length>0){i.class("sapMITBFilterWithItems");}if(!M){i.class("sapMITBDisabled").attr("aria-disabled",true);}if(!this._isOverflow()){i.attr("aria-selected",false);}var Y=this.getTooltip_AsString();if(Y){i.attr("title",Y);}if(this._isOverflow()||this.getItems().length){i.attr("aria-haspopup","menu");}i.openEnd();if(S){this._renderIconColorDescription(i);}i.openStart("div").class("sapMITBFilterWrapper").openEnd();if(!Q){i.openStart("div",F+"-tab").class("sapMITBTab").openEnd();if(!U||!K){var Z=["sapMITBFilterIcon","sapMITBBadgeHolder"];if(M){Z.push("sapMITBFilter"+L);}i.renderControl(this._getImageControl(Z,y,v._aAllIconColors));}if(!U&&!K&&!O){i.openStart("span").class("sapMITBFilterNoIcon").openEnd().close("span");}if(N&&!U){i.close("div");i.openStart("div").class("sapMITBHorizontalWrapper").openEnd();}i.openStart("span",F+"-count").class("sapMITBCount");if(U||(!K&&!J.length)){i.class("sapMITBBadgeHolder");}i.openEnd();if(G===""&&N){i.unsafeHtml("&nbsp;");}else{i.text(G);}i.close("span");if(!N){i.close("div");}}if(J.length){i.openStart("div",F+"-text").class("sapMITBText");if(!K&&!U){i.class("sapMITBBadgeHolder");}if(H&&z.getUpperCase()){i.class("sapMITBTextUpperCase");}i.openEnd();if(Q&&K){this._renderIcon(i);}i.openStart("span").class("sapMITHTextContent").attr("dir",W!==j.Inherit?W.toLowerCase():"auto");i.openEnd().text(y._getDisplayText(this)).close("span");if(this._isOverflow()||this.getItems().length&&y._isUnselectable(this)){i.openStart("span",this.getId()+"-expandButton").class("sapMITHShowSubItemsIcon").openEnd();i.icon(b.getIconURI("slim-arrow-down"),null,{"title":null,"aria-hidden":true});i.close("span");}i.close("div");}if(!Q&&N){i.close("div");}i.openStart("div").class("sapMITBContentArrow").openEnd().close("div");i.close("div");if(this.getItems().length&&!y._isUnselectable(this)){i.openStart("span").accessibilityState({role:"separator"}).openEnd().close("span");i.renderControl(this._getExpandButton());}i.renderControl(this.getAggregation("_expandButtonBadge"));if(this.getItems().length){this._updateExpandButtonBadge();}i.close("div");};
v.prototype.renderInSelectList=function(i,S,x,y,z){if(!this.getVisible()){return;}var E=S._bIconOnly,F=true,G=S._oIconTabHeader,H=this.getIconColor(),J=this.getEnabled();if(G){F=S._checkTextOnly();}i.openStart("li",this).class("sapMITBSelectItem").attr("tabindex","-1").attr("role","menuitem");if(z){i.style("padding-left",z+"rem");}if(x!==undefined&&y!==undefined){i.attr("aria-posinset",x+1);i.attr("aria-setsize",y);i.attr("aria-level",this._getNestedLevel());}var K=this.getTooltip_AsString();if(K){i.attr("title",K);}if(G._isUnselectable(this)){i.class("sapMITHUnselectable");}if(!J){i.class("sapMITBDisabled").attr("aria-disabled",true);}if(S.getSelectedItem()==this){i.class("sapMITBSelectItemSelected");i.attr("aria-selected",true);}if(J){i.class("sapMITBFilter"+H);}var L=this.getId(),M=this._shouldReadIconColor(),N=[];if(!E){N.push(L+"-text");}if(!F&&this.getIcon()){N.push(L+"-icon");}if(M){N.push(L+"-iconColor");}i.accessibilityState({labelledby:N.join(" ")}).openEnd();if(M){this._renderIconColorDescription(i);}if(!F){this._renderIcon(i,E);}if(!E){this._renderText(i);}i.close("li");};
v.prototype._onAfterParentRendering=function(){this._renderBadge();d.getInstance();};
v.prototype._renderIcon=function(i,x){var y=this.getIcon();if(y){var z=b.getIconInfo(y),E=["sapMITBSelectItemIcon"];if(z&&!z.suppressMirroring){E.push("sapUiIconMirrorInRTL");}if(x){E.push("sapMITBBadgeHolder");}if(this._getIconTabHeader().isInlineMode()){E.push("sapMITBInlineIcon");}i.icon(y,E,{id:this.getId()+"-icon","aria-hidden":true});}else{i.openStart("span").class("sapUiIcon").openEnd().close("span");}};
v.prototype._renderIconColorDescription=function(i){i.openStart("div",this.getId()+"-iconColor").style("display","none").openEnd().text(w.getText("ICONTABBAR_ICONCOLOR_"+this.getIconColor().toUpperCase())).close("div");};
v.prototype._renderText=function(i){var x=this.getText(),y=this.getCount(),z=C.getConfiguration().getRTL(),E=this.getTextDirection();i.openStart("span",this.getId()+"-text").attr("dir",E!==j.Inherit?E.toLowerCase():"auto").class("sapMText").class("sapMTextNoWrap").class("sapMITBText").class("sapMITBBadgeHolder");var F=R.getTextAlign(T.Begin,E);if(F){i.style("text-align",F);}if(y){if(z){x='('+y+') '+x;}else{x+=' ('+y+')';}}i.openEnd().text(x).close("span");};
v.prototype._getSelectList=function(){if(!this._oSelectList){this._oSelectList=new g({selectionChange:function(E){var i=E.getParameter("selectedItem");this._oIconTabHeader.setSelectedItem(i._getRealTab());this._oTabFilter._closePopover();}});this._oSelectList._oIconTabHeader=this.getParent();this._oSelectList._oTabFilter=this;this._oSelectList._bIsOverflow=this._isOverflow();}return this._oSelectList;};
v.prototype._prepareDragEventDelegate=function(){if(this.getEnabled()){this.addEventDelegate(this._oDragEventDelegate,this);}else{this.removeEventDelegate(this._oDragEventDelegate);}};
v.prototype._updateTabCountText=function(){if(!this._isOverflow()){return;}var i=this._getIconTabHeader()._getItemsForOverflow(this._bIsStartOverflow,true).filter(function(x){return x.isA("sap.m.IconTabFilter");}).length;this.setText("+"+i);};
v.prototype._getExpandButton=function(){this._oExpandButton=this.getAggregation("_expandButton");if(!this._oExpandButton){this._oExpandButton=new A(this.getId()+"-expandButton",{type:k.Transparent,icon:b.getIconURI("slim-arrow-down"),tooltip:w.getText("ICONTABHEADER_OVERFLOW_MORE"),tabIndex:"-1",ariaHasPopup:r.Menu,press:this._expandButtonPress.bind(this)}).addStyleClass("sapMITBFilterExpandBtn");this.setAggregation("_expandButton",this._oExpandButton);}return this._oExpandButton;};
v.prototype._updateExpandButtonBadge=function(){var E=this.getAggregation("_expandButtonBadge"),H=E.getBadgeCustomData()&&E.getBadgeCustomData().getVisible(),i=this._hasChildWithBadge();if(i&&!H){E.addCustomData(new B({visible:true}));}else if(!i&&H){E.getBadgeCustomData().setVisible(false);}};
v.prototype._hasChildWithBadge=function(){var i=this._isOverflow()?this._getIconTabHeader()._getItemsForOverflow(this._bIsStartOverflow):this._getAllSubItems();return i.some(function(x){return x.isA("sap.m.IBadge")&&x.getBadgeCustomData()&&x.getBadgeCustomData().getVisible();});};
v.prototype._expandButtonPress=function(){if(!this.getEnabled()){return;}this.$().trigger("focus");if(!this._oPopover){this._oPopover=new f({showArrow:false,showHeader:false,offsetY:0,offsetX:0,placement:P.VerticalPreferredBottom}).addStyleClass("sapMITBFilterPopover");this._oPopover.attachBeforeClose(function(){this._getSelectList().destroyItems();},this);if(D.system.phone){this._oPopover._oControl.addButton(this._createPopoverCloseButton());}if(this._getIconTabHeader()._isInsideToolHeader()){this._oPopover.addStyleClass("sapMITBFilterPopoverInToolHeader");this._oPopover.setOffsetY(u);if(!D.system.phone){this._oPopover.addEventDelegate({onAfterRendering:function(E){this._oPopover.getDomRef().style.minWidth=this.$().outerWidth(true)+"px";}.bind(this)});}}this.addDependent(this._oPopover);this._oPopover._oControl._adaptPositionParams=function(){var i=this.$().parents().hasClass("sapUiSizeCompact");this._arrowOffset=0;if(i){this._offsets=["0 0","0 0","0 4","0 0"];}else{this._offsets=["0 0","0 0","0 5","0 0"];}this._atPositions=["end top","end top","end bottom","begin top"];this._myPositions=["end bottom","begin top","end top","end top"];};}var H=this._setSelectListItems();var S=this._getSelectList();this._oPopover.removeAllContent();if(this.getItems().length||this._isOverflow()){this._oPopover.addContent(S);this._oPopover.setInitialFocus(H?S.getSelectedItem():S.getVisibleTabFilters()[0]);this._oPopover.openBy(this);}};
v.prototype._getAllSubItems=function(){var i=[];this._getRealTab().getItems().forEach(function(x){if(x.isA("sap.m.IconTabFilter")){i=i.concat(x,x._getAllSubItems());}else{i=i.concat(x);}});return i;};
v.prototype._getAllSubFilters=function(){return this._getAllSubItems().filter(function(i){return i.isA("sap.m.IconTabFilter");});};
v.prototype._getAllSubFiltersDomRefs=function(){return this._getAllSubFilters().filter(function(S){return Boolean(S._getRealTab().getDomRef());}).map(function(S){return S._getRealTab().getDomRef();});};
v.prototype._getFirstAvailableSubFilter=function(){var x=this._getAllSubFilters();for(var i=0;i<x.length;i++){var y=x[i];if(y.getContent().length&&y.getVisible()){return y;}}return this;};
v.prototype._isParentOf=function(x){var y=this._getAllSubFilters();for(var i=0;i<y.length;i++){if(y[i]._getRealTab()===x){return true;}}return false;};
v.prototype._createPopoverCloseButton=function(){return new e({text:w.getText("SELECT_CANCEL_BUTTON"),press:this._closePopover.bind(this)});};
v.prototype._closePopover=function(){if(this._oPopover){this._oPopover.close();this._oPopover.removeAllContent();}if(this._isOverflow()&&this.getParent().oSelectedItem){(this.getParent()._oSelectedRootItem||this.getParent().oSelectedItem._getRootTab()).$().trigger("focus");}};
v.prototype._handleOnDragOver=function(E){if(this._isDropPossible(E)){this.getDomRef().classList.add("sapMITHDragOver");E.preventDefault();}};
v.prototype._handleOnLongDragOver=function(E){if(this._isDropPossible(E)){if(this._oPopover&&this._oPopover.isOpen()){return;}this._expandButtonPress();}};
v.prototype._handleOnDrop=function(){this.getDomRef().classList.remove("sapMITHDragOver");};
v.prototype._handleOnDragLeave=function(){this.getDomRef().classList.remove("sapMITHDragOver");};
v.prototype._isDropPossible=function(E){var i=this._getIconTabHeader(),x=E.dragSession.getDragControl()._getRealTab(),S=i.oSelectedItem;if(i!==x._getIconTabHeader()){return false;}if(x===this||x._isParentOf(this)){return false;}if(!this._isOverflow()&&!i.getMaxNestingLevel()){return false;}if(this._isOverflow()&&S&&(S===x||S._getRootTab()===x)){return false;}return true;};
v.prototype._setSelectListItems=function(){var x=this.getParent(),S=this._getSelectList(),y=this._getAllSubItems(),z=x.oSelectedItem,H=false,E,L,F,i,G;if(this._isOverflow()){y=x._getItemsForOverflow(this._bIsStartOverflow);}S.destroyItems();S.setSelectedItem(null);for(i=0;i<y.length;i++){E=y[i];L=E.clone(undefined,undefined,{cloneChildren:false,cloneBindings:true});E._oCloneInList=L;F=E.getCustomData();for(G=0;G<F.length;G++){L.addCustomData(F[G].clone());}L._oRealItem=E;S.addItem(L);if(E.isA("sap.m.IconTabSeparator")){continue;}if(L._getRealTab()===z){S.setSelectedItem(L);H=true;continue;}if(L._getRealTab()._isParentOf(z)){S.setSelectedItem(z._getRealTab());H=true;}}return H;};
v.prototype._isOverflow=function(){return this._bIsOverflow||this._bIsStartOverflow;};
v.prototype._getIconTabHeader=function(){return this._getRootTab().getParent();};
v.prototype.onsapdown=function(E){if(!this.getEnabled()){return;}if(this._isOverflow()||((this._getNestedLevel()===1&&this._getRealTab()===this)&&this._getRealTab().getItems().length!==0)){E.stopImmediatePropagation();this._expandButtonPress();}};
v.prototype._startBadgeHiding=function(){if(this._iHideBadgeTimeout){return;}this._iHideBadgeTimeout=setTimeout(this._hideBadge.bind(this),s);if(this._getRootTab()!==this){this._getRootTab()._updateExpandButtonBadge();}};
v.prototype._hideBadge=function(){var i=this.getBadgeCustomData();if(!i){return;}i.setVisible(false);if(this._getRootTab()!==this){this._getRootTab()._updateExpandButtonBadge();}if(this._oCloneInList&&!this._oCloneInList.bIsDestroyed&&this._oCloneInList.getBadgeCustomData()){this._oCloneInList.getBadgeCustomData().setVisible(false);this._oCloneInList=null;}if(this._isInOverflow()){this._getIconTabHeader()._getOverflow()._updateExpandButtonBadge();}if(this._isInStartOverflow()){this._getIconTabHeader()._getStartOverflow()._updateExpandButtonBadge();}this._iHideBadgeTimeout=null;};
v.prototype._isInOverflow=function(){return!this._bIsOverflow&&this._getIconTabHeader()._getItemsInStrip().indexOf(this._getRealTab())===-1;};
v.prototype._isInStartOverflow=function(){return!this._bIsStartOverflow&&this._getIconTabHeader()._getItemsInStrip().indexOf(this._getRealTab())===-1;};
v.prototype.onBadgeUpdate=function(V,S,i){var x=this.getDomRef(),y=this._getIconTabHeader(),z,E,F,G,O,H,J,K;if(!y){return;}if(x){F=x.getAttribute("aria-labelledby")||"";switch(S){case p.Appear:F=i+" "+F;break;case p.Disappear:F=F.replace(i,"").trim();break;}x.setAttribute("aria-labelledby",F);}if(!y._isRendered()){return;}z=this._getRootTab();if(z._isInOverflow()){O=this._getIconTabHeader()._getOverflow();O._updateExpandButtonBadge();}if(z._isInStartOverflow()){H=this._getIconTabHeader()._getStartOverflow();H._updateExpandButtonBadge();}else if(z!==this){z._updateExpandButtonBadge();}if(S!==p.Appear){return;}this._enableMotion();if((this._isInOverflow()||this._isInStartOverflow())&&this._oCloneInList){this._oCloneInList.addCustomData(new B());}E=d.getInstance();G=this.getText();if(z._isInOverflow()){J="ICONTABFILTER_SUB_ITEM_BADGE";K=[G,O.getText()];}if(z._isInStartOverflow()){J="ICONTABFILTER_SUB_ITEM_BADGE";K=[G,H.getText()];}else{if(z!==this){J="ICONTABFILTER_SUB_ITEM_BADGE";K=[G,z.getText()];}else{J="ICONTABFILTER_BADGE_MSG";K=G;}}E.announce(w.getText(J,K),t.Assertive);};
v.prototype.getAriaLabelBadgeText=function(){return w.getText("ICONTABFILTER_BADGE");};
v.prototype._enableMotion=function(){if(this._getRealTab()._isInOverflow()||this._getRealTab()._isInStartOverflow()){if(this._oCloneInList&&this._oCloneInList.getDomRef()){this._oCloneInList.getDomRef().classList.add("sapMITBFilterBadgeMotion");}}else if(this.getDomRef()){this.getDomRef().classList.add("sapMITBFilterBadgeMotion");}};
v.prototype._shouldReadIconColor=function(){var i=this.getIconColor();return this.getEnabled()&&(i==="Positive"||i==="Critical"||i==="Negative"||i==="Neutral");};
return v;});
sap.ui.predefine('sap/m/IconTabFilterExpandButtonBadge',["./BadgeEnabler","sap/ui/core/Control","sap/ui/core/Core"],function(B,C,a){"use strict";var r=a.getLibraryResourceBundle("sap.m");
var I=C.extend("sap.m.IconTabFilterExpandButtonBadge",{
metadata:{library:"sap.m",interfaces:["sap.m.IBadge"]},
renderer:{apiVersion:2,render:function(R,c){R.openStart("div",c).class("sapMITFExpandButtonBadge").openEnd().close("div");}}
});
B.call(I.prototype);
I.prototype.init=function(){this.initBadgeEnablement({style:"Attention"});};
I.prototype.getAriaLabelBadgeText=function(){return r.getText("ICONTABFILTER_SUB_ITEMS_BADGES");};
I.prototype.onBadgeUpdate=function(){var p=this.getParent();p.onBadgeUpdate.apply(p,arguments);};
return I;});
sap.ui.predefine('sap/m/IconTabHeader',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/delegate/ItemNavigation',"sap/ui/core/InvisibleText",'sap/ui/core/ResizeHandler','sap/ui/Device','sap/m/Button','sap/m/IconTabFilter','sap/m/IconTabSeparator','sap/m/IconTabBarDragAndDropUtil','sap/ui/core/library','sap/m/IconTabHeaderRenderer',"sap/ui/thirdparty/jquery","sap/base/Log","sap/ui/events/KeyCodes"],function(l,C,a,E,I,b,R,D,B,c,d,e,f,g,q,L,K){"use strict";var h=f.dnd.DropPosition;var k=l.BackgroundDesign;var m=l.IconTabHeaderMode;var n=l.IconTabDensityMode;var T=l.TabsOverflowMode;
var o=a.extend("sap.m.IconTabHeader",{metadata:{library:"sap.m",properties:{showSelection:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},selectedKey:{type:"string",group:"Data",defaultValue:null},visible:{type:"boolean",group:"Behavior",defaultValue:true},mode:{type:"sap.m.IconTabHeaderMode",group:"Appearance",defaultValue:m.Standard},showOverflowSelectList:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:k.Solid},enableTabReordering:{type:"boolean",group:"Behavior",defaultValue:false},maxNestingLevel:{type:"int",group:"Behavior",defaultValue:0},tabDensityMode:{type:"sap.m.IconTabDensityMode",group:"Appearance",defaultValue:n.Cozy},ariaTexts:{type:"object",group:"Accessibility",defaultValue:null},tabsOverflowMode:{type:"sap.m.TabsOverflowMode",group:"Behavior",defaultValue:T.End}},aggregations:{items:{type:"sap.m.IconTab",multiple:true,singularName:"item",dnd:{draggable:true,droppable:true,layout:"Horizontal"}},_overflow:{type:"sap.m.IconTabFilter",multiple:false,visibility:"hidden"},_startOverflow:{type:"sap.m.IconTabFilter",multiple:false,visibility:"hidden"}},events:{select:{parameters:{item:{type:"sap.m.IconTabFilter"},key:{type:"string"},previousKey:{type:"string"}}}}}});
var r=C.getLibraryResourceBundle("sap.m");E.apply(o.prototype,[true]);
o.prototype.init=function(){this._bFireSelectEvent=false;this._aTabKeys=[];this._oAriaHeadText=null;this._bIsRendered=false;};
o.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._aTabKeys){this._aTabKeys=null;}if(this._oOverflow){this._oOverflow.removeEventDelegate(this._oOverflowEventDelegate);this._oOverflowEventDelegate=null;this._oOverflow=null;}if(this._oStartOverflow){this._oStartOverflow.removeEventDelegate(this._oStartOverflowEventDelegate);this._oStartOverflowEventDelegate=null;this._oStartOverflow=null;}if(this._oAriaHeadText){this._oAriaHeadText.destroy();this._oAriaHeadText=null;}this._bRtl=null;};
o.prototype.onBeforeRendering=function(){this._bIsRendered=false;this._bRtl=C.getConfiguration().getRTL();if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._updateSelection();this.destroyDragDropConfig();this._setsDragAndDropConfigurations();};
o.prototype.onAfterRendering=function(){this._applyTabDensityMode();if(this.oSelectedItem){this._applySelectionToFilters();this.oSelectedItem._hideBadge();}if(C.isThemeApplied()){this._setItemsForStrip();}else{C.attachThemeChanged(this._handleThemeLoad,this);}this._initItemNavigation();this._sResizeListenerId=R.register(this.getDomRef(),q.proxy(this._fnResize,this));this.getItems().forEach(function(i){if(i._onAfterParentRendering){i._onAfterParentRendering();}});this._bIsRendered=true;};
o.prototype._isRendered=function(){return this._bIsRendered;};
o.prototype._getSelectList=function(){return this._getOverflow()._getSelectList();};
o.prototype._getOverflow=function(){var O=this.getAggregation("_overflow");if(!O){O=new c({id:this.getId()+'-overflow',text:r.getText("ICONTABHEADER_OVERFLOW_MORE")});O._bIsOverflow=true;this._oOverflowEventDelegate={onsapnext:O.onsapdown};O.addEventDelegate(this._oOverflowEventDelegate,O);this.setAggregation("_overflow",O);this._oOverflow=O;}return O;};
o.prototype._getStartOverflow=function(){var s=this.getAggregation("_startOverflow");if(!s){s=new c({id:this.getId()+'-startOverflow',text:r.getText("ICONTABHEADER_OVERFLOW_MORE")});s._bIsStartOverflow=true;this._oStartOverflowEventDelegate={onsapprevious:s.onsapdown};s.addEventDelegate(this._oStartOverflowEventDelegate,s);this.setAggregation("_startOverflow",s);this._oStartOverflow=s;}return s;};
o.prototype._getInvisibleHeadText=function(){var A=this.getAriaTexts()||{};if(!this._oAriaHeadText){this._oAriaHeadText=new b({id:this.getId()+"-ariaHeadText"});}this._oAriaHeadText.setText(A.headerDescription);return this._oAriaHeadText;};
o.prototype._onItemNavigationFocusLeave=function(){if(!this.oSelectedItem){return;}var j=this.getItems();var p=-1;var s;for(var i=0;i<j.length;i++){s=j[i];if(s instanceof c==false){continue;}p++;if((this.oSelectedItem._getRootTab()||this.oSelectedItem)===s){break;}}this._oItemNavigation.setFocusedIndex(p);};
o.prototype.getTabFilters=function(){var t=[];this.getItems().forEach(function(i){if(i instanceof c){t.push(i);}});return t;};
o.prototype._setsDragAndDropConfigurations=function(){if(this.getEnableTabReordering()&&!this.getDragDropConfig().length){e.setDragDropAggregations(this,"Horizontal",this._getDropPosition());}};
o.prototype._getDropPosition=function(){return this.getMaxNestingLevel()===0?h.Between:h.OnOrBetween;};
o.prototype.setSelectedKey=function(s){var j=this.getTabFilters(),p=this._isInsideIconTabBar(),S,A=true;if(j.length>0){s=s||j[0]._getNonEmptyKey();}if(this.$().length){for(var i=0;i<j.length;i++){if(j[i]._getNonEmptyKey()===s){this.setSelectedItem(j[i],A);S=true;break;}}if(!S&&!p&&s){this.setSelectedItem(null);}}this.setProperty("selectedKey",s,true);return this;};
o.prototype.setSelectedItem=function(i,A){if(!i){if(this.oSelectedItem){this._removeSelectionFromFilters();this.oSelectedItem=null;}return this;}if(this._isUnselectable(i)){return this;}var p=this.getParent();var j=this._isInsideIconTabBar();var P=this.getSelectedKey();var s=false;if(i.getContent().length===0&&this.oSelectedItem&&this.oSelectedItem.getContent().length===0){s=true;}if(this.oSelectedItem&&this.oSelectedItem.getVisible()&&(!A&&j&&p.getExpandable()||this.oSelectedItem!==i)){this._removeSelectionFromFilters();}if(i.getVisible()){if(this.oSelectedItem===i){if(!A&&j&&p.getExpandable()){p._toggleExpandCollapse();}}else{if(j){p.$("content").attr('aria-labelledby',i.sId);}this.oSelectedItem=i;this._applySelectionToFilters();this.setProperty("selectedKey",this.oSelectedItem._getNonEmptyKey(),true);if(j&&(p.getExpandable()||p.getExpanded())){var S=this.oSelectedItem.getContent();if(S.length>0){p._rerenderContent(S);}else{if(!s){p._rerenderContent(p.getContent());}}if(!A&&p.getExpandable()&&!p.getExpanded()){p._toggleExpandCollapse(true);}}}}this.oSelectedItem=i;var t=this.oSelectedItem._getNonEmptyKey();this.setProperty("selectedKey",t,true);if(j){p.setProperty("selectedKey",t,true);}if(j){A=A&&!p._bFireSelectEvent;}else{A=A&&!this._bFireSelectEvent;}if(!A){if(j){p.fireSelect({selectedItem:this.oSelectedItem,selectedKey:t,item:this.oSelectedItem,key:t,previousKey:P});}else{this.fireSelect({selectedItem:this.oSelectedItem,selectedKey:t,item:this.oSelectedItem,key:t,previousKey:P});}}this.oSelectedItem._startBadgeHiding();var u=this.oSelectedItem._getRootTab().getDomRef();if(!u||u.classList.contains("sapMITBFilterHidden")||this.getTabsOverflowMode()===T.End){this._setItemsForStrip();}return this;};
o.prototype.getVisibleTabFilters=function(){return this.getTabFilters().filter(function(F){return F.getVisible();});};
o.prototype._initItemNavigation=function(){var t=[],s=-1,S=this.oSelectedItem&&this.oSelectedItem._getRootTab();if(this.$().hasClass("sapMITHStartOverflowList")){var i=this._getStartOverflow().getFocusDomRef();i.setAttribute("tabindex","-1");t.push(i);}this.getTabFilters().forEach(function(j){var p=this.getFocusDomRef(j);if(!p){return;}p.setAttribute("tabindex","-1");t.push(p);if(j===S||j===this.oSelectedItem){s=t.indexOf(p);}}.bind(this));if(this.$().hasClass("sapMITHEndOverflowList")){var O=this._getOverflow().getFocusDomRef();O.setAttribute("tabindex","-1");t.push(O);}if(!this._oItemNavigation){this._oItemNavigation=new I().setCycling(false).attachEvent(I.Events.FocusLeave,this._onItemNavigationFocusLeave,this).setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});this.addDelegate(this._oItemNavigation);}this._oItemNavigation.setRootDomRef(this.getDomRef()).setItemDomRefs(t).setPageSize(t.length).setSelectedIndex(s);};
o.prototype.onThemeChanged=function(){this._applyTabDensityMode();};
o.prototype._applyTabDensityMode=function(){var t=this.getTabDensityMode();this.$().removeClass("sapUiSizeCompact");switch(t){case n.Compact:this.$().addClass("sapUiSizeCompact");break;case n.Inherit:if(this.$().closest(".sapUiSizeCompact").length){this.$().addClass("sapUiSizeCompact");}break;}};
o.prototype._handleThemeLoad=function(){setTimeout(this._setItemsForStrip.bind(this),350);C.detachThemeChanged(this._handleThemeLoad,this);};
o.prototype.destroyItems=function(){this.oSelectedItem=null;this._aTabKeys=[];this.destroyAggregation("items");return this;};
o.prototype.addItem=function(i){if(!(i instanceof d)){var s=i.getKey();if(this._aTabKeys.indexOf(s)!==-1){L.warning("sap.m.IconTabHeader: duplicate key '"+s+"' inside the IconTabFilter. Please use unique keys.");}this._aTabKeys.push(s);}this.addAggregation("items",i);this._invalidateParentIconTabBar();return this;};
o.prototype.insertItem=function(i,j){if(!(i instanceof d)){var s=i.getKey();if(this._aTabKeys.indexOf(s)!==-1){L.warning("sap.m.IconTabHeader: duplicate key '"+s+"' inside the IconTabFilter. Please use unique keys.");}this._aTabKeys.push(s);}this.insertAggregation("items",i,j);this._invalidateParentIconTabBar();};
o.prototype.removeAllItems=function(){var i=this.removeAllAggregation("items");this._aTabKeys=[];this.oSelectedItem=null;this._invalidateParentIconTabBar();return i;};
o.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(i&&!(i instanceof d)){var s=i.getKey();this._aTabKeys.splice(this._aTabKeys.indexOf(s),1);}if(this.oSelectedItem===i){this.oSelectedItem=null;}this._invalidateParentIconTabBar();return i;};
o.prototype.updateAggregation=function(){this.oSelectedItem=null;a.prototype.updateAggregation.apply(this,arguments);this.invalidate();};
o.prototype.removeAggregation=function(A,O,s){var i=this.getTabFilters();var j=a.prototype.removeAggregation.apply(this,arguments);if(s){return j;}if(!this._getPreserveSelection()&&j&&j==this.oSelectedItem&&A=='items'){var p=(i?Array.prototype.indexOf.call(i,j):-1);i=this.getTabFilters();p=Math.max(0,Math.min(p,i.length-1));var S=i[p];if(S){this.setSelectedItem(S,true);}else{var t=this.getParent();if(this._isInsideIconTabBar()&&t.getExpanded()){t.$("content").children().remove();}}}return j;};
o.prototype.removeAllAggregation=function(A,s){if(A=='items'){var i=this.getParent();if(this._isInsideIconTabBar()&&i.getExpanded()){i.$("content").children().remove();}}return a.prototype.removeAllAggregation.apply(this,arguments);};
o.prototype._getPreserveSelection=function(){return this._bPreserveSelection;};
o.prototype._setPreserveSelection=function(p){this._bPreserveSelection=p;};
o.prototype._getDisplayText=function(i){var t=i.getText();if(this.isInlineMode()){var s=i.getCount();if(s){if(this._bRtl){t='('+s+') '+t;}else{t+=' ('+s+')';}}}return t;};
o.prototype.isInlineMode=function(){return this.getMode()===m.Inline;};
o.prototype._checkTextOnly=function(){this._bTextOnly=this.getItems().every(function(i){return i instanceof d||!i.getIcon();});return this._bTextOnly;};
o.prototype._checkNoText=function(j){if(j.length>0){for(var i=0;i<j.length;i++){if(!(j[i]instanceof d)){if(j[i].getText().length>0){return false;}}}}return true;};
o.prototype._checkInLine=function(j){var p;if(j.length>0){for(var i=0;i<j.length;i++){p=j[i];if(!(p instanceof d)){if(p.getIcon()||p.getCount()){this._bInLine=false;return false;}}}}this._bInLine=true;return true;};
o.prototype._getItemsInStrip=function(){return this.getItems().filter(function(i){var j=i.getDomRef();return j&&!j.classList.contains("sapMITBFilterHidden");});};
o.prototype._setItemsForStrip=function(){var t=this.getVisibleTabFilters();if(!C.isThemeApplied()||!t.length){return;}var i=this.getDomRef("head");if(!i){return;}var s=this._getStartOverflow(),O=this._getOverflow(),j=this.getItems().filter(function(v){return v.getDomRef();}).map(function(v){return v.getDomRef();}),S=(this.oSelectedItem&&this.oSelectedItem.getVisible())?this.oSelectedItem:t[0],p=(S._getRootTab()||S).getDomRef();if(!j.length||!p){return;}s.$().removeClass("sapMITHOverflowVisible");O.$().removeClass("sapMITHOverflowVisible");this.$().removeClass("sapMITHStartOverflowList");this.$().removeClass("sapMITHEndOverflowList");j.forEach(function(v){v.classList.remove("sapMITBFilterHidden");});var u=j.reduce(function(v,w){return v+q(w).outerWidth(true);},0),H=u>i.offsetWidth;if(!H){return;}switch(this.getTabsOverflowMode()){case T.StartAndEnd:this._updateStartAndEndOverflow(j,p);break;case T.End:default:this._updateEndOverflow(j,p);break;}};
o.prototype._updateEndOverflow=function(j,s){var O=this._getOverflow(),t=this.getDomRef("head"),p,u,S,i;O.$().addClass("sapMITHOverflowVisible");this.$().addClass("sapMITHEndOverflowList");p=t.offsetWidth;S=this._getSelectedItemIndexAndSize(j,s);u=this._findLastVisibleItem(j,p,S.width);for(i=u+1;i<j.length;i++){j[i].classList.add("sapMITBFilterHidden");}O._updateExpandButtonBadge();};
o.prototype._updateStartAndEndOverflow=function(j,s){var S=this._getStartOverflow(),O=this._getOverflow(),t=this.getDomRef("head"),p=t.offsetWidth,u=this._getSelectedItemIndexAndSize(j,s),H=this._hasStartOverflow(p,j,u),v=this._hasEndOverflow(p,j,u),F,w,i;if(!H){O.$().addClass("sapMITHOverflowVisible");this.$().addClass("sapMITHEndOverflowList");p=t.offsetWidth;w=this._findLastVisibleItem(j,p,u.width);for(i=w+1;i<j.length;i++){j[i].classList.add("sapMITBFilterHidden");}O._updateTabCountText();O._updateExpandButtonBadge();return;}if(!v){S.$().addClass("sapMITHOverflowVisible");this.$().addClass("sapMITHStartOverflowList");p=t.offsetWidth;F=this._findFirstVisibleItem(j,p,u.width);for(i=F-1;i>=0;i--){j[i].classList.add("sapMITBFilterHidden");}S._updateTabCountText();S._updateExpandButtonBadge();return;}S.$().addClass("sapMITHOverflowVisible");this.$().addClass("sapMITHStartOverflowList");O.$().addClass("sapMITHOverflowVisible");this.$().addClass("sapMITHEndOverflowList");p=t.offsetWidth;F=this._findFirstVisibleItem(j,p,u.width,u.index-1);w=this._findLastVisibleItem(j,p,u.width,F);for(i=F-1;i>=0;i--){j[i].classList.add("sapMITBFilterHidden");}for(i=w+1;i<j.length;i++){j[i].classList.add("sapMITBFilterHidden");}S._updateExpandButtonBadge();S._updateTabCountText();O._updateTabCountText();O._updateExpandButtonBadge();};
o.prototype._hasStartOverflow=function(t,j,s){if(s.index===0){return false;}var i,p=0;for(i=s.index-1;i>=0;i--){p+=this._getItemSize(j[i]);}var H=t<p+s.width;if(!H){this._getOverflow().$().addClass("sapMITHOverflowVisible");this.$().addClass("sapMITHEndOverflowList");t=this.getDomRef("head").offsetWidth;H=t<p+s.width;this._getOverflow().$().removeClass("sapMITHOverflowVisible");this.$().removeClass("sapMITHEndOverflowList");}return H;};
o.prototype._hasEndOverflow=function(t,j,s){if(s.index>=j.length){return false;}var i,p=0;for(i=s.index;i<j.length;i++){p+=this._getItemSize(j[i]);}var H=t<p+s.width;if(!H){this._getStartOverflow().$().addClass("sapMITHOverflowVisible");this.$().addClass("sapMITHStartOverflowList");t=this.getDomRef("head").offsetWidth;H=t<p+s.width;this._getStartOverflow().$().removeClass("sapMITHOverflowVisible");this.$().removeClass("sapMITHStartOverflowList");}return H;};
o.prototype._getSelectedItemIndexAndSize=function(i,s){var S=i.indexOf(s),j=this._getItemSize(s),p;if(i[S-1]&&i[S-1].classList.contains("sapMITBSep")){p=i[S-1];j+=this._getItemSize(p);}i.splice(S,1);if(p){i.splice(S-1,1);S--;}return{index:S,width:j};};
o.prototype._findFirstVisibleItem=function(i,t,s,S){var j,p,u;if(S===undefined){S=i.length-1;}j=S+1;for(p=S;p>=0;p--){u=this._getItemSize(i[p]);if(t<s+u){break;}s+=u;j=p;}return j;};
o.prototype._findLastVisibleItem=function(i,t,s,S){var j,p,u;S=S||0;j=S-1;for(p=S;p<i.length;p++){u=this._getItemSize(i[p]);if(t<s+u){break;}s+=u;j=p;}var P=i[p-1];if(P&&P.classList.contains("sapMITBSep")){j-=1;}return j;};
o.prototype._getItemSize=function(i){var s=window.getComputedStyle(i),w=i.offsetWidth,M=Number.parseInt(s.marginLeft)+Number.parseInt(s.marginRight);return w+M;};
o.prototype._handleActivation=function(i){var t=i.target.id,j=i.srcControl,s,$=q(i.target);if(j instanceof B){return;}var p=q(document.getElementById(t));if(p.parents()&&Array.prototype.indexOf.call(p.parents(),this.$("content")[0])>-1){}else{if(t){i.preventDefault();if($.hasClass('sapMITBFilterIcon')||$.hasClass('sapMITBCount')||$.hasClass('sapMITBText')||$.hasClass('sapMITBTab')||$.hasClass('sapMITBContentArrow')||$.hasClass('sapMITBSep')||$.hasClass('sapMITBSepIcon')){s=i.srcControl.getId().replace(/-icon$/,"");j=C.byId(s);if(j.getMetadata().isInstanceOf("sap.m.IconTab")&&!(j instanceof d)){if(this._isUnselectable(j)){if(j.getItems().length||j._isOverflow()){j._expandButtonPress();}return;}if((j===this._getOverflow())||(j===this._getStartOverflow())){j._expandButtonPress();return;}this.setSelectedItem(j);}}else if(j.getMetadata().isInstanceOf("sap.m.IconTab")&&!(j instanceof d)){if(this._isUnselectable(j)){if(j.getItems().length||j._isOverflow()){j._expandButtonPress();}return;}if((j===this._getOverflow())||(j===this._getStartOverflow())){j._expandButtonPress();return;}this.setSelectedItem(j);}}else{if(j.getMetadata().isInstanceOf("sap.m.IconTab")&&!(j instanceof d)){if(this._isUnselectable(j)){if(j.getItems().length||j._isOverflow()){j._expandButtonPress();}return;}if((j===this._getOverflow())||(j===this._getStartOverflow())){j._expandButtonPress();return;}this.setSelectedItem(j);}}}};
o.prototype._fnResize=function(){if(this._getOverflow()._oPopover){this._getOverflow()._oPopover.close();}if(this._getStartOverflow()._oPopover){this._getStartOverflow()._oPopover.close();}this._setItemsForStrip();this._initItemNavigation();};
o.prototype._isUnselectable=function(i){var F=i._getRealTab();return!F.getEnabled()||(this._isInsideIconTabBar()&&!this.getParent().getContent().length&&F._getNestedLevel()===1&&F.getItems().length&&!F.getContent().length)||F._isOverflow();};
o.prototype._isInsideIconTabBar=function(){var p=this.getParent();return p instanceof a&&p.isA('sap.m.IconTabBar');};
o.prototype._isInsideToolHeader=function(){var p=this.getParent();return p instanceof a&&p.isA('sap.tnt.ToolHeader');};
o.prototype._invalidateParentIconTabBar=function(){if(this._isInsideIconTabBar()){this.getParent().invalidate();}};
o.prototype.getFocusDomRef=function(F){var t=F||this.oSelectedItem;if(!t){return null;}return t.getDomRef();};
o.prototype.applyFocusInfo=function(F){if(F.focusDomRef){q(F.focusDomRef).trigger("focus");}};
o.prototype._updateSelection=function(){var j=this.getItems(),s=this.getSelectedKey(),i=0,p=this._isInsideIconTabBar(),t=this._isInsideToolHeader();if(!j.length){return;}if(!this.oSelectedItem||s&&s!==this.oSelectedItem._getNonEmptyKey()){if(s){this.oSelectedItem=this._findItemByKey(s);}if(!this.oSelectedItem&&(p||!s)){for(i=0;i<j.length;i++){if(!(j[i]instanceof d)&&j[i].getVisible()){this.oSelectedItem=j[i];break;}}}}if(!t&&this.oSelectedItem&&!this.oSelectedItem.getVisible()){for(i=0;i<j.length;i++){if(!(j[i]instanceof d)&&j[i].getVisible()){this.oSelectedItem=j[i];break;}}}if(!this.oSelectedItem){return;}if(this._isUnselectable(this.oSelectedItem)){this.setSelectedItem(this.oSelectedItem._getFirstAvailableSubFilter(),true);return;}this.setProperty("selectedKey",this.oSelectedItem._getNonEmptyKey(),true);};
o.prototype._findItemByKey=function(s){var t=this.getTabFilters(),S;for(var i=0;i<t.length;i++){if(t[i]._getNonEmptyKey()===s){return t[i];}S=t[i]._getAllSubFilters();for(var j=0;j<S.length;j++){if(S[j]._getNonEmptyKey()===s){return S[j];}}}};
o.prototype._applySelectionToFilters=function(){if(this._isInsideIconTabBar()&&!this.getParent().getExpanded()){return;}this.oSelectedItem.$().addClass("sapMITBSelected").attr({'aria-selected':true});if(this.oSelectedItem._getNestedLevel()!==1){var s=this.oSelectedItem._getRootTab();s.$().addClass("sapMITBSelected").attr({"aria-selected":true});}};
o.prototype._removeSelectionFromFilters=function(){this.oSelectedItem.$().removeClass("sapMITBSelected").attr({'aria-selected':false});if(this.oSelectedItem._getNestedLevel()!==1){var s=this.oSelectedItem._getRootTab();s.$().removeClass("sapMITBSelected").attr({"aria-selected":false});}};
o.prototype._getItemsForOverflow=function(i,t){var j=this._getItemsInStrip(),p=this.getTabsOverflowMode()===T.StartAndEnd,s,u=this.getItems(),v=[];if(p){s=u.indexOf(j[0]);u=i?u.slice(0,s):u.slice(s,u.length);}u.forEach(function(w){if(!D.system.phone&&j.indexOf(w)>-1){return;}v.push(w);if(w.isA("sap.m.IconTabFilter")&&!t){w._getAllSubItems().forEach(function(S){v.push(S);});}});return v;};
o.prototype.ontouchstart=function(i){var t=i.targetTouches[0];this._iActiveTouch=t.identifier;};
o.prototype.ontouchend=function(i){if(this._iActiveTouch===undefined){return;}var M=0;var j=1;var p;if(i.which===p||i.which===M||i.which===j){this._handleActivation(i);}this._iActiveTouch=undefined;};
o.prototype.ontouchcancel=o.prototype.ontouchend;
o.prototype.onkeydown=function(i){switch(i.which){case K.ENTER:this._handleActivation(i);i.preventDefault();break;case K.SPACE:i.preventDefault();break;}};
o.prototype.onkeyup=function(i){if(i.which===K.SPACE){this._handleActivation(i);}};
o.prototype._handleDragAndDrop=function(i){var j=i.getParameter("dropPosition"),p=i.getParameter("draggedControl"),s=i.getParameter("droppedControl"),t=this,u=this.getMaxNestingLevel();if(j===h.On){t=s._getRealTab();}e.handleDrop(t,j,p._getRealTab(),s,false,u);if(p._getNestedLevel()>1){p._getRootTab()._closePopover();}this._setItemsForStrip();this._initItemNavigation();this._getOverflow()._setSelectListItems();this._getStartOverflow()._setSelectListItems();this._getSelectList()._initItemNavigation();p._getRealTab().$().trigger("focus");if(j===h.On){s._getRealTab().$().trigger("focus");}};
o.prototype._moveTab=function(t,i,M){e.moveItem.call(this,t,i,M);this._setItemsForStrip();this._initItemNavigation();};
o.prototype.ondragrearranging=function(i){if(!this.getEnableTabReordering()){return;}var t=i.srcControl,j=this.indexOfItem(this._getItemsInStrip().pop());this._moveTab(t,i.keyCode,j);t.$().trigger("focus");};
o.prototype.onsaphomemodifiers=o.prototype.ondragrearranging;o.prototype.onsapendmodifiers=o.prototype.ondragrearranging;o.prototype.onsapincreasemodifiers=o.prototype.ondragrearranging;o.prototype.onsapdecreasemodifiers=o.prototype.ondragrearranging;return o;});
sap.ui.predefine('sap/m/IconTabHeaderRenderer',['./library'],function(l){"use strict";var I={apiVersion:2};var T=l.TabsOverflowMode;
I.render=function(r,c){if(!c.getVisible()){return;}var s=c.getId(),a=c.getItems(),v=c.getVisibleTabFilters().length,V=0,t=c._checkTextOnly(),n=c._checkNoText(a),b=c._checkInLine(a)||c.isInlineMode();var o=c.getParent(),u=o&&o.isA('sap.m.IconTabBar')&&o.getUpperCase(),A=c.getAriaTexts()||{};r.openStart("div",c).class("sapMITH").class("sapContrastPlus").class("sapMITHBackgroundDesign"+c.getBackgroundDesign());if(u){r.class("sapMITBTextUpperCase");}if(t){r.class("sapMITBTextOnly");}if(n){r.class("sapMITBNoText");}if(b){r.class("sapMITBInLine");r.class("sapMITBTextOnly");}r.accessibilityState(c,{role:"navigation"});if(A.headerLabel){r.accessibilityState(c,{label:A.headerLabel});}r.openEnd();if(a.length&&c.getTabsOverflowMode()===T.StartAndEnd){r.openStart("div").class("sapMITHStartOverflow").openEnd();c._getStartOverflow().render(r);r.close("div");}if(A.headerDescription){r.renderControl(c._getInvisibleHeadText());}r.openStart("div",s+"-head").class("sapMITBHead");r.accessibilityState({role:"tablist",orientation:"horizontal"});if(A.headerDescription){r.accessibilityState({describedby:c._getInvisibleHeadText().getId()});}r.openEnd();for(var i=0;i<a.length;i++){var d=a[i];d.render(r,V,v);if(d.isA("sap.m.IconTabFilter")){if(d.getVisible()){V++;}}}r.close("div");if(a.length){r.openStart("div").class("sapMITHEndOverflow").openEnd();c._getOverflow().render(r);r.close("div");}r.close("div");};
return I;},true);
sap.ui.predefine('sap/m/IconTabSeparator',["./library","sap/ui/core/Core","sap/ui/core/Element","sap/ui/core/Item","sap/m/IconTabFilter"],function(l,C,E,I,a){"use strict";var b=l.ImageHelper;
var c=E.extend("sap.m.IconTabSeparator",{metadata:{interfaces:["sap.m.IconTab"],library:"sap.m",designtime:"sap/m/designtime/IconTabSeparator.designtime",properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:''},visible:{type:"boolean",group:"Behavior",defaultValue:true},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}}}});
c.prototype._getImageControl=function(d,p){var P={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};this._oImageControl=b.getImageControl(this.getId()+"-icon",this._oImageControl,p,P,d);return this._oImageControl;};
c.prototype.exit=function(e){if(this._oImageControl){this._oImageControl.destroy();}E.prototype.exit.call(this,e);};
c.prototype._getRealTab=function(){return a.prototype._getRealTab.call(this);};
c.prototype._getNestedLevel=function(){return a.prototype._getNestedLevel.call(this);};
c.prototype.render=function(r){if(!this.getVisible()){return;}var i=this.getIcon(),o=this.getParent(),R=C.getLibraryResourceBundle('sap.m'),A={};if(i){A.role="img";A.label=R.getText("ICONTABBAR_NEXTSTEP");}else{A.role="separator";}r.openStart("div",this).accessibilityState(A).class("sapMITBItem").class("sapMITBSep");if(!i){r.class("sapMITBSepLine");}r.openEnd();if(i){r.renderControl(this._getImageControl(["sapMITBSepIcon"],o));}r.close("div");};
c.prototype.renderInSelectList=function(r,s,i,S,p){if(!this.getVisible()){return;}var d=this.getIcon(),o=s._oIconTabHeader,R=C.getLibraryResourceBundle('sap.m'),A={};if(d){A.role="img";A.label=R.getText("ICONTABBAR_NEXTSTEP");}else{A.role="separator";}r.openStart("li",this).class("sapMITBSelectItem").class("sapMITBSep").accessibilityState(A);if(p&&!d){r.style("padding-left",p+"rem");}if(!d){r.class("sapMITBSepLine");}r.openEnd();if(d){r.renderControl(this._getImageControl(["sapMITBSepIcon"],o));}r.close("li");};
return c;});
sap.ui.predefine('sap/m/IllustratedMessage',["./library","sap/m/Text","sap/m/Title","sap/m/FormattedText","sap/m/Illustration","sap/ui/core/Control","sap/ui/core/Core",'sap/ui/core/library',"sap/ui/core/ResizeHandler","sap/ui/thirdparty/jquery","./IllustratedMessageRenderer"],function(l,T,a,F,I,C,b,c,R,q,d){"use strict";var e=l.IllustratedMessageSize;var f=l.IllustratedMessageType;var g=c.TextAlign;
var h=C.extend("sap.m.IllustratedMessage",{metadata:{library:"sap.m",properties:{description:{type:"string",group:"Misc",defaultValue:""},enableFormattedText:{type:"boolean",group:"Appearance",defaultValue:false},illustrationSize:{type:"sap.m.IllustratedMessageSize",group:"Appearance",defaultValue:e.Auto},illustrationType:{type:"string",group:"Appearance",defaultValue:f.NoSearchResults},title:{type:"string",group:"Misc",defaultValue:""}},aggregations:{additionalContent:{type:"sap.m.Button",multiple:true},_formattedText:{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"},_illustration:{type:"sap.m.Illustration",visibility:"hidden",multiple:false},_text:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_title:{type:"sap.m.Title",multiple:false,visibility:"hidden"}},dnd:{draggable:false,droppable:true}}});
h.ORIGINAL_TEXTS={UnableToLoad:"UnableToLoad",UnableToUpload:"UnableToUpload",NoActivities:"NoActivities",BeforeSearch:"BeforeSearch",NoSearchResults:"NoSearchResults",NoEntries:"NoEntries",NoData:"NoData",NoNotifications:"NoNotifications",BalloonSky:"BalloonSky",SuccessScreen:"SuccessScreen",NoMail:"NoMail",NoSavedItems:"NoSavedItems",NoTasks:"NoTasks"};h.FALLBACK_TEXTS={ReloadScreen:h.ORIGINAL_TEXTS.UnableToLoad,Connection:h.ORIGINAL_TEXTS.UnableToLoad,ErrorScreen:h.ORIGINAL_TEXTS.UnableToUpload,EmptyCalendar:h.ORIGINAL_TEXTS.NoActivities,SearchEarth:h.ORIGINAL_TEXTS.BeforeSearch,SearchFolder:h.ORIGINAL_TEXTS.NoSearchResults,EmptyList:h.ORIGINAL_TEXTS.NoEntries,Tent:h.ORIGINAL_TEXTS.NoData,SleepingBell:h.ORIGINAL_TEXTS.NoNotifications,SimpleBalloon:h.ORIGINAL_TEXTS.BalloonSky,SimpleBell:h.ORIGINAL_TEXTS.NoNotifications,SimpleCalendar:h.ORIGINAL_TEXTS.NoActivities,SimpleCheckmark:h.ORIGINAL_TEXTS.SuccessScreen,SimpleConnection:h.ORIGINAL_TEXTS.UnableToLoad,SimpleEmptyDoc:h.ORIGINAL_TEXTS.NoData,SimpleEmptyList:h.ORIGINAL_TEXTS.NoEntries,SimpleError:h.ORIGINAL_TEXTS.UnableToUpload,SimpleMagnifier:h.ORIGINAL_TEXTS.BeforeSearch,SimpleMail:h.ORIGINAL_TEXTS.NoMail,SimpleNoSavedItems:h.ORIGINAL_TEXTS.NoSavedItems,SimpleNotFoundMagnifier:h.ORIGINAL_TEXTS.NoSearchResults,SimpleReload:h.ORIGINAL_TEXTS.UnableToLoad,SimpleTask:h.ORIGINAL_TEXTS.NoTasks};h.PREPENDS={DESCRIPTION:"IllustratedMessage_DESCRIPTION_",TITLE:"IllustratedMessage_TITLE_"};h.BREAK_POINTS={DIALOG:679,SPOT:319,BASE:259};h.MEDIA={BASE:"sapFIllustratedMessage-Base",SPOT:"sapFIllustratedMessage-Spot",DIALOG:"sapFIllustratedMessage-Dialog",SCENE:"sapFIllustratedMessage-Scene"};h.RESIZE_HANDLER_ID={CONTENT:"_sContentResizeHandlerId"};
h.prototype.init=function(){this._updateInternalIllustrationSetAndType(this.getIllustrationType());};
h.prototype.onBeforeRendering=function(){this._detachResizeHandlers();};
h.prototype.onAfterRendering=function(){this._updateDomSize();this._attachResizeHandlers();this._preventWidowWords(this._getTitle().getDomRef());this._preventWidowWords(this._getDescription().getDomRef());};
h.prototype.exit=function(){this._detachResizeHandlers();};
h.prototype.setIllustrationType=function(v){if(this.getIllustrationType()===v){return this;}this._updateInternalIllustrationSetAndType(v);return this.setProperty("illustrationType",v);};
h.prototype._getDefaultDescription=function(){return this._findDefaultText(h.PREPENDS.DESCRIPTION);};
h.prototype._getDefaultTitle=function(){return this._findDefaultText(h.PREPENDS.TITLE);};
h.prototype._findDefaultText=function(p){var B=this._getResourceBundle();return B.getText(p+this._sIllustrationType,null,true)||B.getText(p+this._sIllustrationType.substr(0,this._sIllustrationType.indexOf('_v')),null,true)||B.getText(p+h.FALLBACK_TEXTS[this._sIllustrationType],null,true);};
h.prototype._getDescription=function(){return this.getEnableFormattedText()?this._getFormattedText():this._getText();};
h.prototype._getFormattedText=function(){var D=this.getDescription(),o=this.getAggregation("_formattedText");if(!o){o=new F({textAlign:g.Center});this.setAggregation("_formattedText",o);}if(D){o.setHtmlText(D);}else{o.setHtmlText(this._getDefaultDescription());}return o;};
h.prototype._getIllustration=function(){var i=this.getAggregation("_illustration");if(!i){i=new I();this.setAggregation("_illustration",i);}return i;};
h.prototype._getResourceBundle=function(){return b.getLibraryResourceBundle("sap.m");};
h.prototype._getText=function(){var D=this.getDescription(),t=this.getAggregation("_text");if(!t){t=new T({textAlign:g.Center});this.setAggregation("_text",t);}if(D){t.setText(D);}else{t.setText(this._getDefaultDescription());}return t;};
h.prototype._getTitle=function(){var t=this.getTitle(),o=this.getAggregation("_title");if(!o){o=new a({wrapping:true});this.setAggregation("_title",o);}if(t){o.setText(t);}else{o.setText(this._getDefaultTitle());}return o;};
h.prototype._preventWidowWords=function(D){var $,s,H=window.HTMLElement;if(!(H&&D instanceof H)){return;}$=q(D);s=$.html();s=s.replace(/ ([^ ]*)$/,'&nbsp;$1');$.html(s);};
h.prototype._updateDomSize=function(){var D=this.getDomRef(),s;if(D){s=this.getIllustrationSize();if(s===e.Auto){this._updateMedia(D.getBoundingClientRect().width);}else{this._updateMediaStyle(h.MEDIA[s.toUpperCase()]);}}};
h.prototype._updateInternalIllustrationSetAndType=function(v){var V=v.split("-");this._sIllustrationSet=V[0];this._sIllustrationType=V[1];};
h.prototype._onResize=function(E){var i=E.size.width;this._updateMedia(i);};
h.prototype._updateMedia=function(w){if(!w){return;}if(w<=h.BREAK_POINTS.BASE){this._updateMediaStyle(h.MEDIA.BASE);}else if(w<=h.BREAK_POINTS.SPOT){this._updateMediaStyle(h.MEDIA.SPOT);}else if(w<=h.BREAK_POINTS.DIALOG){this._updateMediaStyle(h.MEDIA.DIALOG);}else{this._updateMediaStyle(h.MEDIA.SCENE);}};
h.prototype._updateMediaStyle=function(s){Object.keys(h.MEDIA).forEach(function(m){var E=s===h.MEDIA[m],i=m.charAt(0)+m.slice(1).toLowerCase();this.toggleStyleClass(h.MEDIA[m],E);if(E&&s!==h.MEDIA.BASE){this._getIllustration().setSet(this._sIllustrationSet,true).setMedia(i,true).setType(this._sIllustrationType);}},this);};
h.prototype._attachResizeHandlers=function(){var i=this.getIllustrationSize();if(this.getDomRef()&&i===e.Auto){this._registerResizeHandler(h.RESIZE_HANDLER_ID.CONTENT,this,this._onResize.bind(this));}};
h.prototype._detachResizeHandlers=function(){this._deRegisterResizeHandler(h.RESIZE_HANDLER_ID.CONTENT);};
h.prototype._registerResizeHandler=function(H,o,i){if(!this[H]){this[H]=R.register(o,i);}};
h.prototype._deRegisterResizeHandler=function(H){if(this[H]){R.deregister(this[H]);this[H]=null;}};
h.prototype.getAccessibilityReferences=function(){return{title:this._getTitle().getId(),description:this._getDescription().getId()};};
return h;});
sap.ui.predefine('sap/m/IllustratedMessageRenderer',[],function(){"use strict";var I={apiVersion:2};
I.render=function(r,i){var o=i._getIllustration(),a=i._getTitle(),b=i._getDescription(),c=i.getAdditionalContent();r.openStart("figure",i);r.class("sapFIllustratedMessage");r.openEnd();r.renderControl(o);r.openStart("figcaption").openEnd();r.renderControl(a);r.renderControl(b.addStyleClass("sapFIllustratedMessageDescription"));r.close("figcaption");r.openStart("div");r.class("sapFIllustratedMessageAdditionalContent");r.openEnd();c.forEach(function(C){r.renderControl(C);});r.close("div");r.close("figure");};
return I;},true);
sap.ui.predefine('sap/m/IllustratedMessageSize',[],function(){"use strict";var I={Auto:"Auto",Base:"Base",Spot:"Spot",Dialog:"Dialog",Scene:"Scene"};return I;});
sap.ui.predefine('sap/m/IllustratedMessageType',[],function(){"use strict";var I={BeforeSearch:"sapIllus-BeforeSearch",NoActivities:"sapIllus-NoActivities",NoData:"sapIllus-NoData",NoMail:"sapIllus-NoMail",NoMailV1:"sapIllus-NoMail_v1",NoEntries:"sapIllus-NoEntries",NoNotifications:"sapIllus-NoNotifications",NoSavedItems:"sapIllus-NoSavedItems",NoSavedItemsV1:"sapIllus-NoSavedItems_v1",NoSearchResults:"sapIllus-NoSearchResults",NoTasks:"sapIllus-NoTasks",NoTasksV1:"sapIllus-NoTasks_v1",UnableToLoad:"sapIllus-UnableToLoad",UnableToUpload:"sapIllus-UnableToUpload",AddColumn:"sapIllus-AddColumn",AddPeople:"sapIllus-AddPeople",BalloonSky:"sapIllus-BalloonSky",Connection:"sapIllus-Connection",EmptyCalendar:"sapIllus-EmptyCalendar",EmptyList:"sapIllus-EmptyList",EmptyPlanningCalendar:"sapIllus-EmptyPlanningCalendar",ErrorScreen:"sapIllus-ErrorScreen",FilterTable:"sapIllus-FilterTable",GroupTable:"sapIllus-GroupTable",NoFilterResults:"sapIllus-NoFilterResults",PageNotFound:"sapIllus-PageNotFound",ReloadScreen:"sapIllus-ReloadScreen",ResizeColumn:"sapIllus-ResizeColumn",SearchEarth:"sapIllus-SearchEarth",SearchFolder:"sapIllus-SearchFolder",SimpleBalloon:"sapIllus-SimpleBalloon",SimpleBell:"sapIllus-SimpleBell",SimpleCalendar:"sapIllus-SimpleCalendar",SimpleCheckmark:"sapIllus-SimpleCheckmark",SimpleConnection:"sapIllus-SimpleConnection",SimpleEmptyDoc:"sapIllus-SimpleEmptyDoc",SimpleEmptyList:"sapIllus-SimpleEmptyList",SimpleError:"sapIllus-SimpleError",SimpleMagnifier:"sapIllus-SimpleMagnifier",SimpleMail:"sapIllus-SimpleMail",SimpleNoSavedItems:"sapIllus-SimpleNoSavedItems",SimpleNotFoundMagnifier:"sapIllus-SimpleNotFoundMagnifier",SimpleReload:"sapIllus-SimpleReload",SimpleTask:"sapIllus-SimpleTask",SleepingBell:"sapIllus-SleepingBell",SortColumn:"sapIllus-SortColumn",SuccessScreen:"sapIllus-SuccessScreen",Tent:"sapIllus-Tent",UploadCollection:"sapIllus-UploadCollection"};return I;});
sap.ui.predefine('sap/m/Illustration',["sap/base/Log","sap/ui/core/Control","./IllustrationRenderer","./IllustrationPool"],function(L,C,I,a){"use strict";
var b=C.extend("sap.m.Illustration",{metadata:{library:"sap.m",properties:{set:{type:"string",defaultValue:null},media:{type:"string",defaultValue:null},type:{type:"string",defaultValue:null}},dnd:{draggable:true,droppable:false}}});
b.CAN_NOT_BUILD_SYMBOL_MSG="Some of the Control's properties are missing. Can't build Symbol ID. No SVG will be displayed.";
b.prototype.init=function(){this._sId=this.getId();};
b.prototype.onBeforeRendering=function(){this._buildSymbolId();if(this._sSymbolId){a.loadAsset(this._sSymbolId,this._sId);}else{L.warning(b.CAN_NOT_BUILD_SYMBOL_MSG);}};
b.prototype._buildSymbolId=function(){var s=this.getSet(),m=this.getMedia(),t=this.getType();this._sSymbolId="";if(s&&m&&t){this._sSymbolId=s+"-"+m+"-"+t;}};
return b;});
sap.ui.predefine('sap/m/IllustrationPool',["sap/base/Log","./library",'sap/ui/core/Core',"sap/ui/thirdparty/jquery"],function(L,l,C,q){"use strict";var S='sap-ui-illustration-pool',a='-Patterns',b='sapIllus',c=sap.ui.require.toUrl("sap/m/themes/base/illustrations/"),d=Object.keys(l.IllustratedMessageType);var s=Object.create(null);s[b]={sPath:c,aSymbols:d,bIsPending:false};var e=[],A=Object.create(null),o=Object.create(null),r=Object.create(null);var I={};
I.loadAsset=function(f,i){var g;if(f===""){L.error("ID of the asset can not be blank/empty.");return;}if(i){r[i]=f;}if(A[f]){L.info("The asset with ID '"+f+"' is either loaded or being loaded.");if(i&&o[f]){I._updateDOMPool();}return;}g=f.split("-")[0];if(!s[g]){L.error("The illustration set '"+g+"' is not registered. Please register it before requiring one of its assets.");return;}A[f]=true;I._requireSVG(g,f,i);};
I.loadRestOfTheAssets=function(i){var f;if(!s[i]){throw new Error("The illustration set '"+i+"' is not registered. Please register it before requiring rest of its assets.");}f=s[i].aSymbols;if(Array.isArray(f)){f.forEach(function(g){I.loadAsset(i+"-Spot-"+g);I.loadAsset(i+"-Dialog-"+g);I.loadAsset(i+"-Scene-"+g);});}};
I.registerIllustrationSet=function(f,g){var n=f.setFamily,p=f.setURI;if(s[n]){if(s[n].bIsPending){L.warning("Illustration Set is currently being loaded.");}else{L.warning("Illustration Set already registered.");}return;}if(p.substr(p.length-1)!=="/"){p+="/";}s[n]=Object.create(null);s[n].sPath=p;s[n].bIsPending=true;I._loadMetadata(n,p,g);};
I._addAssetToDOMPool=function(h,i){I._getDOMPool().insertAdjacentHTML("beforeend",h);if(i){e.push(i);}};
I._getDOMPool=function(){var D=document.getElementById(S);if(D===null){D=document.createElement("div");D.id=S;C.getStaticAreaRef().appendChild(D);I.loadAsset(b+a);}return D;};
I._loadMetadata=function(n,p,f){var m=p+"metadata.json";return new Promise(function(R){q.ajax(m,{type:"GET",dataType:"json",success:function(M){L.info("Metadata for illustration set ("+n+") successfully loaded");I._metadataLoaded(n,M,f);R(M);},error:function(j,g){if(g!=="abort"){L.error("Metadata from: "+m+" file path could not be loaded");delete s[n];R();}}});});};
I._metadataLoaded=function(n,m,f){var g=m.symbols,h=m.requireCustomPatterns;s[n].aSymbols=g;if(h){I.loadAsset(n+a);}if(f){I.loadRestOfTheAssets(n);}s[n].bIsPending=false;};
I._removeAssetFromDOMPool=function(i){var D=document.getElementById(S),f;if(D!==null){f=document.getElementById(i);if(f!==null){D.removeChild(f);e.splice(e.indexOf(i),1);}}};
I._requireSVG=function(f,i,g){return new Promise(function(R){q.ajax(s[f].sPath+i+".svg",{type:"GET",dataType:"html",success:function(h){if(i.indexOf(a)===-1){o[i]=h;if(g){I._updateDOMPool();}}else{I._addAssetToDOMPool(h);}R(h);},error:function(j,h){if(h!=="abort"){delete A[i];L.error(i+" asset could not be loaded");R();}}});});};
I._updateDOMPool=function(){var f=Object.create(null),g=Object.create(null),h,j;for(var k in r){h=r[k];j=e.indexOf(h);if(j===-1){g[h]=true;}else{f[h]=true;}}for(var i=0;i<e.length;i++){h=e[i];if(!f[h]){I._removeAssetFromDOMPool(h);i--;}}for(var m in g){h=o[m];if(h){I._addAssetToDOMPool(h,m);}}};
return I;},true);
sap.ui.predefine('sap/m/IllustrationRenderer',["sap/ui/Device"],function(D){"use strict";var I={apiVersion:2};
I.render=function(r,i){var s=i._sSymbolId;r.openStart("svg",i);r.class("sapFIllustration");r.openEnd();r.openStart("use");r.attr('href',"#"+s);r.openEnd();r.close("use");r.close("svg");};
return I;},true);
sap.ui.predefine('sap/m/Image',['./library','sap/ui/core/Control','sap/ui/base/DataType','./ImageRenderer',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/base/security/encodeCSS","sap/ui/core/library"],function(l,C,D,I,K,q,e,c){"use strict";var a=l.ImageMode;var A=c.aria.HasPopup;
var b=C.extend("sap.m.Image",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/Image.designtime",properties:{src:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},decorative:{type:"boolean",group:"Accessibility",defaultValue:true},alt:{type:"string",group:"Accessibility",defaultValue:null},useMap:{type:"string",group:"Misc",defaultValue:null},densityAware:{type:"boolean",group:"Misc",defaultValue:false},activeSrc:{type:"sap.ui.core.URI",group:"Data",defaultValue:""},mode:{type:"sap.m.ImageMode",group:"Misc",defaultValue:"Image"},backgroundSize:{type:"string",group:"Appearance",defaultValue:"cover"},backgroundPosition:{type:"string",group:"Appearance",defaultValue:"initial"},backgroundRepeat:{type:"string",group:"Appearance",defaultValue:"no-repeat"},lazyLoading:{type:"boolean",defaultValue:false},ariaHasPopup:{type:"sap.ui.core.aria.HasPopup",group:"Accessibility",defaultValue:A.None}},aggregations:{detailBox:{type:'sap.m.LightBox',multiple:false,bindable:"bindable"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDetails:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDetails"}},events:{tap:{},press:{},load:{},error:{}},dnd:{draggable:true,droppable:false}}});
b._currentDevicePixelRatio=(function(){var r=(window.devicePixelRatio===undefined?1:window.devicePixelRatio);if(r<=1){r=1;}else{r*=2;r=Math.round(r);r/=2;}if(r>2){r=2;}return r;}());
b.prototype.onload=function(E){var w,h;if(!this._defaultEventTriggered){this._defaultEventTriggered=true;}this._bVersion2Tried=false;var d=this.$(),o=d[0];if(this.getMode()===a.Background){d.css("background-image","url(\""+e(this._oImage.src)+"\")");}if(!this._isWidthOrHeightSet()){if(this._iLoadImageDensity>1){w=Math.round(o.getBoundingClientRect().width);h=Math.round(o.getBoundingClientRect().height);if((w===o.naturalWidth)&&(h===o.naturalHeight)){d.width(w/this._iLoadImageDensity);}}}d.removeClass("sapMNoImg");this.fireLoad();};
b.prototype.onerror=function(E){if(!this._defaultEventTriggered){this._defaultEventTriggered=true;}var $=this.$(),m=this.getMode(),s=(m===a.Image)?this._getDomImg().attr("src"):this._oImage.src,d=b._currentDevicePixelRatio,f=this._isActiveState?this.getActiveSrc():this.getSrc();$.addClass("sapMNoImg");if(!s||this._iLoadImageDensity===1){if(this.getAlt()&&!this.getDecorative()){$.removeClass("sapMNoImg");}this.fireError();return;}if(d===2||d<1){this._iLoadImageDensity=1;this._updateDomSrc(this._generateSrcByDensity(f,1));}else if(d===1.5){if(this._bVersion2Tried){setTimeout(q.proxy(function(){this._iLoadImageDensity=1;this._updateDomSrc(this._generateSrcByDensity(f,1));},this),0);}else{setTimeout(q.proxy(function(){this._iLoadImageDensity=2;this._updateDomSrc(this._generateSrcByDensity(f,2));this._bVersion2Tried=true;},this),0);}}};
b.prototype.setDetailBox=function(L){var o=this.getDetailBox();if(L){if(L===o){return this;}if(o){this.detachPress(this._fnLightBoxOpen,o);}this._fnLightBoxOpen=L.open;this.attachPress(this._fnLightBoxOpen,L);}else if(this._fnLightBoxOpen){this.detachPress(this._fnLightBoxOpen,o);this._fnLightBoxOpen=null;}return this.setAggregation("detailBox",L);};
b.prototype.clone=function(){var o=C.prototype.clone.apply(this,arguments),d=o.getDetailBox();if(d){o.detachPress(this._fnLightBoxOpen,this.getDetailBox());o._fnLightBoxOpen=d.open;o.attachPress(o._fnLightBoxOpen,d);}return o;};
b.prototype.onBeforeRendering=function(){this._defaultEventTriggered=false;if(this.getMode()==a.Image){var d=this.getDetailBox()?this.$().find(".sapMImg"):this.$();d.off("load").off("error");}};
b.prototype.onAfterRendering=function(){var d=this.getDetailBox()?this.$().find(".sapMImg"):this.$(),m=this.getMode(),o;if(m===a.Image){d.on("load",q.proxy(this.onload,this));d.on("error",q.proxy(this.onerror,this));o=d[0];}if(m===a.Background){o=this._oImage;}if(o&&o.complete&&!this._defaultEventTriggered){if(o.naturalWidth>0){this.onload({});}else{this.onerror({});}}};
b.prototype.exit=function(){if(this._oImage){q(this._oImage).off("load",this.onload).off("error",this.onerror);this._oImage=null;}else{this.$().off("load",this.onload).off("error",this.onerror);}if(this._fnLightBoxOpen){this._fnLightBoxOpen=null;}};
b.prototype.ontouchstart=function(E){if(E.srcControl.mEventRegistry["press"]||E.srcControl.mEventRegistry["tap"]){E.setMarked();}if(E.targetTouches.length===1&&this.getActiveSrc()){this._updateDomSrc(this._getDensityAwareActiveSrc());this._isActiveState=true;}};
b.prototype.ontouchend=function(E){if(E.targetTouches.length===0&&this.getActiveSrc()){this._isActiveState=false;this._updateDomSrc(this._getDensityAwareSrc());this.$().removeClass("sapMNoImg");}};
b.prototype.attachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);C.prototype.attachEvent.apply(this,arguments);if(this.hasListeners("press")){this.$().attr("tabindex","0");this.$().attr("role","button");}return this;};
b.prototype.detachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);C.prototype.detachEvent.apply(this,arguments);if(!this.hasListeners("press")){this.$().removeAttr("tabindex");if(this.getDecorative()){this.$().attr("role","presentation");}else{this.$().removeAttr("role");}}return this;};
b.prototype.ontap=function(E){this.fireTap({});this.firePress({});};
b.prototype.onkeyup=function(E){if(E.which===K.SPACE||E.which===K.ENTER){this.firePress({});E.stopPropagation();}};
b.prototype.onsapspace=function(E){E.preventDefault();};
b.prototype._updateDomSrc=function(s){var d=this.$(),m=this.getMode();if(d.length){if(m===a.Image){this._getDomImg().attr("src",s);}else{d.addClass("sapMNoImg");q(this._oImage).attr("src",s);}}};
b.prototype._getDomImg=function(){var d=this.$();return this.getDetailBox()?d.children("img"):d;};
b.prototype._preLoadImage=function(s){if(this.getMode()!==a.Background){return;}var $=q(this._oImage);if(!this._oImage){this._oImage=new window.Image();$=q(this._oImage);$.on("load",q.proxy(this.onload,this)).on("error",q.proxy(this.onerror,this));}this._oImage.src=s;};
b.prototype._isWidthOrHeightSet=function(){return(this.getWidth()&&this.getWidth()!=='')||(this.getHeight()&&this.getHeight()!=='');};
b.prototype._getDensityAwareSrc=function(){var s=this.getSrc(),f=this.getDensityAware(),d=f?b._currentDevicePixelRatio:1;this._iLoadImageDensity=d;return this._generateSrcByDensity(s,d);};
b.prototype._getDensityAwareActiveSrc=function(){var s=this.getActiveSrc(),f=this.getDensityAware(),d=f?b._currentDevicePixelRatio:1;this._iLoadImageDensity=d;return this._generateSrcByDensity(s,d);};
b.prototype._generateSrcByDensity=function(s,d){if(!s){return"";}if(this._isDataUri(s)){this._iLoadImageDensity=1;return s;}if(d===1){return s;}var L=s.lastIndexOf("."),f=s.lastIndexOf("/"),N=s.substring(0,L),E=s.substring(L);if(L===-1||(f>L)){return s+"@"+d;}N=N+"@"+d;return N+E;};
b.prototype._isDataUri=function(s){return s?s.indexOf("data:")===0:false;};
b.prototype._isValidBackgroundSizeValue=function(v){v=n(v);return i(v.split(" "),["auto","cover","contain","initial"])||D.getType("sap.ui.core.CSSSizeShortHand").isValid(v);};
b.prototype._isValidBackgroundPositionValue=function(v){v=n(v);return i(v.split(" "),["left","right","top","center","bottom","initial"])||D.getType("sap.ui.core.CSSSizeShortHand").isValid(v);};
b.prototype.getAccessibilityInfo=function(){var h=this.hasListeners("press");if(this.getDecorative()&&!this.getUseMap()&&!h){return null;}return{role:h?"button":"img",type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText(h?"ACC_CTR_TYPE_BUTTON":"ACC_CTR_TYPE_IMAGE"),description:this.getAlt()||this.getTooltip_AsString()||"",focusable:h};};
b.prototype.getFocusDomRef=function(){return this.getDomRef("inner")||this.getDomRef();};
b.prototype.getFormDoNotAdjustWidth=function(){return true;};
function i(t,r){function d(T){return r.indexOf(T)<0;}return t&&r&&!t.some(d);}
function n(v){var w=/\s+/g;return v==null?"":String(v).trim().replace(w," ");}
return b;});
sap.ui.predefine('sap/m/ImageContent',['./library','sap/ui/core/Control','sap/m/Image','sap/ui/core/IconPool','sap/ui/Device','./ImageContentRenderer',"sap/ui/events/KeyCodes"],function(l,C,I,a,D,b,K){"use strict";
var c=C.extend("sap.m.ImageContent",{metadata:{library:"sap.m",properties:{src:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},description:{type:"string",group:"Accessibility",defaultValue:null}},defaultAggregation:"_content",aggregations:{_content:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{press:{}}}});
c.prototype.onBeforeRendering=function(){var i,u,d;i=this.getAggregation("_content");u=this.getSrc();d=this.getDescription();if(!i||u!==i.getSrc()||d!==i.getAlt()){if(i){i.destroy();i=null;}i=a.createControlByURI({id:this.getId()+"-icon-image",src:u,alt:d,decorative:true},I);this.setAggregation("_content",i,true);this._setPointerOnImage();}if(d){this.setTooltip(d.trim());}};
c.prototype._setPointerOnImage=function(){var i=this.getAggregation("_content");if(i&&this.hasListeners("press")){i.addStyleClass("sapMPointer");}else if(i&&i.hasStyleClass("sapMPointer")){i.removeStyleClass("sapMPointer");}};
c.prototype.ontap=function(e){if(D.browser.msie){this.$().trigger("focus");}this.firePress();};
c.prototype.onkeydown=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
c.prototype.attachEvent=function(e,d,f,g){C.prototype.attachEvent.call(this,e,d,f,g);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnImage();}return this;};
c.prototype.detachEvent=function(e,f,d){C.prototype.detachEvent.call(this,e,f,d);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnImage();}return this;};
c.prototype.getAltText=function(){var o=this.getAggregation("_content");if(o&&o.getAlt()!==""){return o.getAlt();}else if(o&&o.getAccessibilityInfo()){return o.getAccessibilityInfo().description;}else{return"";}};
return c;});
sap.ui.predefine('sap/m/ImageContentRenderer',[],function(){"use strict";var I={apiVersion:2};
I.render=function(r,c){r.openStart("div",c);r.class("sapMImageContent");var t=c.getTooltip_AsString();if(t){r.attr("title",t);}if(c.hasListeners("press")){r.class("sapMPointer");r.attr("tabindex","0");}r.openEnd();var C=c.getAggregation("_content");if(C){C.addStyleClass("sapMImageContentImageIcon");r.renderControl(C);}r.close("div");};
return I;},true);
sap.ui.predefine('sap/m/ImageRenderer',['sap/m/library',"sap/base/security/encodeCSS","sap/ui/core/library"],function(l,e,c){"use strict";var I=l.ImageMode;var A=c.aria.HasPopup;var a={apiVersion:2};
a.render=function(r,i){var m=i.getMode(),b=i.getAlt(),t=i.getTooltip_AsString(),h=i.hasListeners("press"),L=i.getDetailBox(),u=i.getUseMap(),d=i.getAriaLabelledBy(),D=i.getAriaDescribedBy(),f=i.getAriaDetails(),g=m===I.Image,j=i.getLazyLoading(),s=i.getAriaHasPopup();if(L){r.openStart("span",i);r.class("sapMLightBoxImage");r.openEnd();r.openStart("span").class("sapMLightBoxMagnifyingGlass").openEnd().close("span");}if(g){r.voidStart("img",!L?i:i.getId()+"-inner");if(j){r.attr("loading","lazy");}}else{r.openStart("span",!L?i:i.getId()+"-inner");}if(!i.getDecorative()){if(d&&d.length>0){r.attr("aria-labelledby",d.join(" "));}if(D&&D.length>0){r.attr("aria-describedby",D.join(" "));}if(f&&f.length>0){r.attr("aria-details",f.join(" "));}}if(g){r.attr("src",i._getDensityAwareSrc());}else{i._preLoadImage(i._getDensityAwareSrc());if(i._isValidBackgroundSizeValue(i.getBackgroundSize())){r.style("background-size",i.getBackgroundSize());}if(i._isValidBackgroundPositionValue(i.getBackgroundPosition())){r.style("background-position",i.getBackgroundPosition());}r.style("background-repeat",e(i.getBackgroundRepeat()));}r.class("sapMImg");if(i.hasListeners("press")||i.hasListeners("tap")){r.class("sapMPointer");}if(u||!i.getDecorative()||h){r.class("sapMImgFocusable");}if(u){if(!(u.startsWith("#"))){u="#"+u;}r.attr("usemap",u);}if(i.getDecorative()&&!u&&!h){r.attr("role","presentation");r.attr("aria-hidden","true");r.attr("alt","");}else if(b||t){r.attr("alt",b||t);}if(b||t){r.attr("aria-label",b||t);}if(t){r.attr("title",t);}if(s!==A.None){r.attr("aria-haspopup",s.toLowerCase());}if(h){r.attr("role","button");r.attr("tabindex",0);}r.style("width",i.getWidth());r.style("height",i.getHeight());g?r.voidEnd():r.openEnd().close("span");if(L){r.close("span");}};
return a;},true);
sap.ui.predefine('sap/m/Input',['./InputBase','./Popover','sap/ui/core/Item','./ColumnListItem','./GroupHeaderListItem','./StandardListItem','sap/ui/core/SeparatorItem','./List','./Table','./library','sap/ui/core/IconPool','sap/ui/Device','./SuggestionsPopover','./Toolbar','./ToolbarSpacer','./Button',"sap/ui/core/ResizeHandler","sap/ui/dom/containsOrEquals","sap/base/assert","sap/base/util/deepEqual","sap/m/inputUtils/wordStartsWithValue","sap/m/inputUtils/inputsDefaultFilter","sap/m/inputUtils/highlightDOMElements","sap/m/inputUtils/typeAhead","sap/ui/events/KeyCodes","sap/m/inputUtils/filterItems","sap/m/inputUtils/ListHelpers","sap/m/inputUtils/calculateSelectionStart","sap/m/inputUtils/selectionRange","./InputRenderer","sap/ui/base/ManagedObject","sap/ui/base/ManagedObjectObserver","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/selectText"],function(I,P,a,C,G,S,b,L,T,l,c,D,d,e,f,B,R,g,h,j,w,k,m,t,K,n,o,p,s,q,M,r,Q){"use strict";var u=l.ListType;var v=l.InputTextFormatMode;var x=l.InputType;var y=l.ListMode;var z=l.ListSeparators;
var A=I.extend("sap.m.Input",{metadata:{library:"sap.m",properties:{type:{type:"sap.m.InputType",group:"Data",defaultValue:x.Text},maxLength:{type:"int",group:"Behavior",defaultValue:0},dateFormat:{type:"string",group:"Misc",defaultValue:'YYYY-MM-dd',deprecated:true},showValueHelp:{type:"boolean",group:"Behavior",defaultValue:false},valueHelpIconSrc:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:"sap-icon://value-help"},showSuggestion:{type:"boolean",group:"Behavior",defaultValue:false},valueHelpOnly:{type:"boolean",group:"Behavior",defaultValue:false},filterSuggests:{type:"boolean",group:"Behavior",defaultValue:true},maxSuggestionWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},startSuggestion:{type:"int",group:"Behavior",defaultValue:1},showTableSuggestionValueHelp:{type:"boolean",group:"Behavior",defaultValue:true},description:{type:"string",group:"Misc",defaultValue:null},fieldWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'50%'},valueLiveUpdate:{type:"boolean",group:"Behavior",defaultValue:false},selectedKey:{type:"string",group:"Data",defaultValue:""},textFormatMode:{type:"sap.m.InputTextFormatMode",group:"Misc",defaultValue:v.Value},textFormatter:{type:"any",group:"Misc",defaultValue:""},suggestionRowValidator:{type:"any",group:"Misc",defaultValue:""},enableSuggestionsHighlighting:{type:"boolean",group:"Behavior",defaultValue:true},enableTableAutoPopinMode:{type:"boolean",group:"Behavior",defaultValue:false},autocomplete:{type:"boolean",group:"Behavior",defaultValue:true},showClearIcon:{type:"boolean",defaultValue:false},effectiveShowClearIcon:{type:"boolean",defaultValue:false,visibility:"hidden"},separateSuggestions:{type:"boolean",defaultValue:false,visibility:"hidden"}},defaultAggregation:"suggestionItems",aggregations:{suggestionItems:{type:"sap.ui.core.Item",multiple:true,singularName:"suggestionItem"},suggestionColumns:{type:"sap.m.Column",multiple:true,singularName:"suggestionColumn",bindable:"bindable",forwarding:{getter:"_getSuggestionsTable",aggregation:"columns"}},suggestionRows:{type:"sap.m.ColumnListItem",altTypes:["sap.m.GroupHeaderListItem"],multiple:true,singularName:"suggestionRow",bindable:"bindable",forwarding:{getter:"_getSuggestionsTable",aggregation:"items"}},_suggestionPopup:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_valueHelpIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false},selectedRow:{type:"sap.m.ColumnListItem",multiple:false}},events:{liveChange:{parameters:{value:{type:"string"},escPressed:{type:"boolean"},previousValue:{type:"string"}}},valueHelpRequest:{parameters:{fromSuggestions:{type:"boolean"}}},suggest:{parameters:{suggestValue:{type:"string"},suggestionColumns:{type:"sap.m.ListBase"}}},suggestionItemSelected:{parameters:{selectedItem:{type:"sap.ui.core.Item"},selectedRow:{type:"sap.m.ColumnListItem"}}},submit:{parameters:{value:{type:"string"}}}},designtime:"sap/m/designtime/Input.designtime"}});
c.insertFontFaceStyle();
A._DEFAULTFILTER_TABULAR=function(V,E){var F=E.getCells(),i=0;for(;i<F.length;i++){if(F[i].getText){if(w(F[i].getText(),V)){return true;}}}return false;};
A._DEFAULTRESULT_TABULAR=function(E){if(!E||E.isA("sap.m.GroupHeaderListItem")){return"";}var F=E.getCells(),i=0;for(;i<F.length;i++){if(F[i].getText){return F[i].getText();}}return"";};
A.prototype.init=function(){I.prototype.init.call(this);this._iSetCount=0;this._sProposedItemText=null;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(this.getId().indexOf("popup-input")===-1){this._createSuggestionsPopover();}this._setTypedInValue("");this._bClearButtonPressed=false;this._bAfterOpenFinisihed=false;};
A.prototype.exit=function(){I.prototype.exit.call(this);this._deregisterEvents();this.cancelPendingSuggest();if(this._iRefreshListTimeout){clearTimeout(this._iRefreshListTimeout);this._iRefreshListTimeout=null;}this._destroySuggestionsTable();if(this._getSuggestionsPopover()){this._oSuggestionPopup=null;this._oSuggPopover.destroy();this._oSuggPopover=null;}this.$().off("click");};
A.prototype.onBeforeRendering=function(){var i=this.getSelectedKey(),E=this.getShowValueHelp()&&this.getEnabled()&&this.getEditable(),F=this.getProperty("effectiveShowClearIcon")&&this.getEnabled()&&this.getEditable(),H=this._oValueHelpIcon,J=this._getSuggestionsPopover(),N=J&&this._isSuggestionsPopoverOpen(),O=J&&J.getInput(),V=N?J._getValueStateHeader().getText():null,U=N?J._getValueStateHeader().getValueState():"";I.prototype.onBeforeRendering.call(this);if(this.getShowClearIcon()){this._getClearIcon().setProperty("visible",F);}else if(this._oClearButton){this._getClearIcon().setProperty("visible",false);}this._deregisterEvents();if(i&&!this.getSelectedItem()&&this.getSuggestionItemByKey(i)){this.setSelectedKey(i);}if(this.getShowSuggestion()){if(this.getShowTableSuggestionValueHelp()){this._addShowMoreButton();}else{this._removeShowMoreButton();}if(O){O.setType(this.getType());}}if(E){H=this._getValueHelpIcon();H.setProperty("visible",true,true);}else if(H){H.setProperty("visible",false,true);}if(!this.getWidth()){this.setProperty("width","100%",true);}if(this._hasTabularSuggestions()){this._getSuggestionsTable().setAutoPopinMode(this.getEnableTableAutoPopinMode());this._getSuggestionsTable().setContextualWidth(this.getEnableTableAutoPopinMode()?"Auto":"Inherit");}if(N&&((this.getValueStateText()&&V!==this.getValueStateText())||(this.getValueState()!==U)||(this.getFormattedValueStateText()))){this._updateSuggestionsPopoverValueState();}};
A.prototype._getDisplayText=function(i){var E=this.getTextFormatter();if(E){return E(i);}var F=i.getText(),H=i.getKey(),J=this.getTextFormatMode();switch(J){case v.Key:return H;case v.ValueKey:return F+' ('+H+')';case v.KeyValue:return'('+H+') '+F;default:return F;}};
A.prototype._onValueUpdated=function(i){if(this._bSelectingItem||i===this._sSelectedValue){return;}var E=this.getSelectedKey(),H,F=this._getSuggestionsPopover(),J=F&&F.getItemsContainer();if(E===''){return;}if(this._hasTabularSuggestions()){H=this._getSuggestionsTable()&&!!this._getSuggestionsTable().getSelectedItem();}else{H=J&&!!J.getSelectedItem();}if(H){return;}this.setProperty("selectedKey",'',true);this.setAssociation("selectedRow",null,true);this.setAssociation("selectedItem",null,true);this.fireSuggestionItemSelected({selectedItem:null,selectedRow:null});};
A.prototype.setSelectionItem=function(i,E){this._bSelectingItem=true;if(!i){this.setAssociation("selectedItem",null,true);this.setValue('');return;}var F=this._iSetCount,N;this.setAssociation("selectedItem",i,true);this.setProperty("selectedKey",i.getKey(),true);if(E){this.fireSuggestionItemSelected({selectedItem:i});}if(F!==this._iSetCount){N=this.getValue();}else{N=this._getDisplayText(i);}this._sSelectedValue=N;this.updateInputField(N);if(this.bIsDestroyed){return;}if(!(this.isMobileDevice()&&this instanceof sap.m.MultiInput)){this._closeSuggestionPopup();}this._bSelectingItem=false;this._resetTypeAhead();};
A.prototype.addSuggestionRowGroup=function(i,H,E){H=H||new G({title:M.escapeSettingsValue(i.text)||M.escapeSettingsValue(i.key)});this._createSuggestionPopupContent(true);this.addAggregation("suggestionRows",H,E);return H;};
A.prototype.addSuggestionItemGroup=function(i,H,E){H=H||new b({text:M.escapeSettingsValue(i.text)||M.escapeSettingsValue(i.key)});this._createSuggestionPopupContent(false);this.addAggregation("suggestionItems",H,E);return H;};
A.prototype.setSelectedItem=function(i){if(typeof i==="string"){i=sap.ui.getCore().byId(i);}if(i!==null&&!(i instanceof a)){return this;}this.setSelectionItem(i);return this;};
A.prototype.setSelectedKey=function(i){i=this.validateProperty("selectedKey",i);this.setProperty("selectedKey",i,true);if(this._hasTabularSuggestions()){return this;}if(!i){this.setSelectionItem();return this;}var E=this.getSuggestionItemByKey(i);this.setSelectionItem(E);return this;};
A.prototype.getSuggestionItemByKey=function(E){var F=this.getSuggestionItems()||[],H,i;for(i=0;i<F.length;i++){H=F[i];if(H.getKey()===E){return H;}}};
A.prototype._getFormattedValueStateText=function(){var i=this._isSuggestionsPopoverOpen(),V=i?this._getSuggestionsPopover()._getValueStateHeader().getFormattedText():null;if(i&&V){return V;}else{return I.prototype.getFormattedValueStateText.call(this);}};
A.prototype.setSelectionRow=function(i,E){if(!i){this.setAssociation("selectedRow",null,true);return;}this._bSelectingItem=true;var F,H=this.getSuggestionRowValidator();if(H){F=H(i);if(!(F instanceof a)){F=null;}}var J=this._iSetCount,N="",O;this.setAssociation("selectedRow",i,true);if(F){N=F.getKey();}this.setProperty("selectedKey",N,true);if(E){this.fireSuggestionItemSelected({selectedRow:i});}if(J!==this._iSetCount){O=this.getValue();}else{if(F){O=this._getDisplayText(F);}else{O=this._getRowResultFunction()(i);}}this._sSelectedValue=O;this.updateInputField(O);if(this.bIsDestroyed){return;}if(!(this.isMobileDevice()&&this instanceof sap.m.MultiInput&&this._isMultiLineMode)){this.setSelectionUpdatedFromList(false);this._closeSuggestionPopup();}this._bSelectingItem=false;};
A.prototype.setSelectedRow=function(i){if(typeof i==="string"){i=sap.ui.getCore().byId(i);}if(i!==null&&!(i instanceof C)){return this;}this.setSelectionRow(i);return this;};
A.prototype._getValueHelpIcon=function(){var i=this,E=this.getValueHelpIconSrc();if(!this._oValueHelpIcon){this._oValueHelpIcon=this.addEndIcon({id:this.getId()+"-vhi",src:E,useIconTooltip:false,alt:this._oRb.getText("INPUT_VALUEHELP_BUTTON"),decorative:false,noTabStop:true,press:function(F){if(!i.getValueHelpOnly()){var H=this.getParent(),$;if(D.support.touch){$=H.$('inner');$.attr('readonly','readonly');H.focus();$.removeAttr('readonly');}else{H.focus();}i.bValueHelpRequested=true;i._fireValueHelpRequest(false);}}});}else if(this._oValueHelpIcon.getSrc()!==E){this._oValueHelpIcon.setSrc(E);}return this._oValueHelpIcon;};
A.prototype._getClearIcon=function(){var i=this;if(this._oClearButton){return this._oClearButton;}this._oClearButton=this.addEndIcon({src:c.getIconURI("decline"),noTabStop:true,visible:false,alt:this._oRb.getText("INPUT_CLEAR_ICON_ALT"),useIconTooltip:false,decorative:false,press:function(){if(i.getValue()!==""){i.fireChange({value:""});i.fireLiveChange({value:""});i.setValue("");i._bClearButtonPressed=true;setTimeout(function(){if(D.system.desktop){i.focus();i._closeSuggestionPopup();}},0);}}},0);return this._oClearButton;};
A.prototype._fireValueHelpRequest=function(F){var i="";if(this.getShowSuggestion()&&!this.isMobileDevice()){i=this._getTypedInValue()||"";}else{i=this.getDOMValue();}this.fireValueHelpRequest({fromSuggestions:F,_userInputValue:i});};
A.prototype._fireValueHelpRequestForValueHelpOnly=function(){if(this.getEnabled()&&this.getEditable()&&this.getShowValueHelp()&&this.getValueHelpOnly()){if(D.system.phone){this.focus();}this._fireValueHelpRequest(false);}};
A.prototype.ontap=function(E){I.prototype.ontap.call(this,E);if(this.isValueHelpOnlyOpener(E.target)){this._fireValueHelpRequestForValueHelpOnly();}if(this.shouldSuggetionsPopoverOpenOnMobile(E)){this._openSuggestionsPopover();}this._bClearButtonPressed=false;};
A.prototype.shouldSuggetionsPopoverOpenOnMobile=function(E){return this.isMobileDevice()&&this.getEditable()&&this.getEnabled()&&this.getShowSuggestion()&&(!this._bClearButtonPressed)&&E.target.id!==this.getId()+"-vhi";};
A.prototype.setFilterFunction=function(F){if(F===null||F===undefined){this._fnFilter=k;return this;}h(typeof(F)==="function","Input.setFilterFunction: first argument fnFilter must be a function on "+this);this._fnFilter=F;return this;};
A.prototype._getFilterFunction=function(F){if(typeof this._fnFilter==="function"&&!F){return this._fnFilter;}return!this._hasTabularSuggestions()?k:A._DEFAULTFILTER_TABULAR;};
A.prototype.setRowResultFunction=function(F){var i;if(F===null||F===undefined){this._fnRowResultFilter=A._DEFAULTRESULT_TABULAR;return this;}h(typeof(F)==="function","Input.setRowResultFunction: first argument fnFilter must be a function on "+this);this._fnRowResultFilter=F;i=this.getSelectedRow();if(i){this.setSelectedRow(i);}return this;};
A.prototype._getRowResultFunction=function(F){if(typeof this._fnRowResultFilter==="function"&&!F){return this._fnRowResultFilter;}return A._DEFAULTRESULT_TABULAR;};
A.prototype.closeSuggestions=function(){this._closeSuggestionPopup();};
A.prototype._doSelect=function(i,E){if(D.support.touch){return;}var F=this._$input[0];if(F){var $=this._$input;F.focus();$.selectText(i?i:0,E?E:$.val().length);}return this;};
A.prototype._isIncrementalType=function(){var i=this.getType();if(i==="Number"||i==="Date"||i==="Datetime"||i==="Month"||i==="Time"||i==="Week"){return true;}return false;};
A.prototype.onsapescape=function(E){if(this._isSuggestionsPopoverOpen()){E.originalEvent._sapui_handledByControl=true;this.setSelectionUpdatedFromList(false);this._closeSuggestionPopup();if(this._getTypedInValue()!==this.getValue()){this.setValue(this._getTypedInValue());}return;}if(this.getValueLiveUpdate()){this.setProperty("value",this.getLastValue(),true);}if(I.prototype.onsapescape){I.prototype.onsapescape.apply(this,arguments);}};
A.prototype.onsapenter=function(E){var i=this._isSuggestionsPopoverOpen(),F=!this.hasStyleClass("sapMFocus")&&i,H=this._hasTabularSuggestions()?this.getSuggestionRows():this.getSuggestionItems(),V,J;this.cancelPendingSuggest();F&&this.setSelectionUpdatedFromList(true);if(this.getShowSuggestion()&&this._bDoTypeAhead&&i){J=this._getSuggestionsPopover().getItemsContainer().getSelectedItem();if(this._hasTabularSuggestions()){J&&this.setSelectionRow(J,true);}else{J&&this.setSelectionItem(o.getItemByListItem(H,J),true);}}if(i&&!this.isComposingCharacter()){this._closeSuggestionPopup();V=this.getDOMValue()?this.getDOMValue().length:null;this.selectText(V,V);}!F&&I.prototype.onsapenter.apply(this,arguments);if(this.getEnabled()&&this.getEditable()&&!(this.getValueHelpOnly()&&this.getShowValueHelp())){this.fireSubmit({value:this.getValue()});}if(!this.isMobileDevice()){this._resetTypeAhead();}};
A.prototype.onsapfocusleave=function(E){var i=this._getSuggestionsPopover(),F=i&&i.getPopover(),H=F&&F.isA("sap.m.Popover"),J=E.relatedControlId&&sap.ui.getCore().byId(E.relatedControlId),N=J&&J.getFocusDomRef(),O=F&&N&&g(F.getDomRef(),N);if(H){if(O&&!i.getValueStateActiveState()){this._bPopupHasFocus=true;if(D.system.desktop&&j(F.getFocusDomRef(),N)||J.isA("sap.m.GroupHeaderListItem")){this.focus();}}else{if(this.getDOMValue()===this._sSelectedSuggViaKeyboard){this._sSelectedSuggViaKeyboard=null;}}}if(!O){I.prototype.onsapfocusleave.apply(this,arguments);}this.bValueHelpRequested=false;};
A.prototype.onsaptabnext=function(){if(!this.isMobileDevice()&&this._sProposedItemText&&!this._bAfterOpenFinisihed){var i=this.getSuggestionItems().filter(function(E){return E.getText()===this._sProposedItemText;}.bind(this))[0];if(i){this.setSelectionItem(i,true);this.selectText(0,0);}}};
A.prototype.onmousedown=function(E){if(this._isSuggestionsPopoverOpen()){E.stopPropagation();}};
["onsapup","onsapdown","onsappageup","onsappagedown","onsaphome","onsapend"].forEach(function(N){A.prototype[N]=function(E){if((N==="onsapup"||N==="onsapdown")&&this.isComposingCharacter()){return;}if(this.getShowSuggestion()){this._getSuggestionsPopover().handleListNavigation(this,E);if(this._isIncrementalType()){E.setMarked();}this.setSelectionUpdatedFromList(true);}};});
A.prototype.setSelectionUpdatedFromList=function(U){this._bSelectionUpdatedFromList=U;};
A.prototype.getSelectionUpdatedFromList=function(){return this._bSelectionUpdatedFromList;};
A.prototype.updateSelectionFromList=function(i){if(this._hasTabularSuggestions()&&(this.getSelectedRow()!==i)){this.setSelectionRow(i,true);}else{var N=o.getItemByListItem(this.getSuggestionItems(),i);N&&(this.getSelectedItem()!==N.getId())&&this.setSelectionItem(N,true);}this.setSelectionUpdatedFromList(false);};
A.prototype._deregisterEvents=function(){this._deregisterPopupResize();if(this.isMobileDevice()&&this._getSuggestionsPopover()&&this._getSuggestionsPopover().getPopover()){this.$().off("click");}};
A.prototype.updateSuggestionItems=function(){this._bSuspendInvalidate=true;this.updateAggregation("suggestionItems");this._synchronizeSuggestions();this._bSuspendInvalidate=false;return this;};
A.prototype.invalidate=function(){if(!this._bSuspendInvalidate){I.prototype.invalidate.apply(this,arguments);}};
A.prototype.cancelPendingSuggest=function(){if(this._iSuggestDelay){clearTimeout(this._iSuggestDelay);this._iSuggestDelay=null;}};
A.prototype._triggerSuggest=function(V){var i=this._getSuggestionsPopover().getItemsContainer();this.cancelPendingSuggest();this._bShouldRefreshListItems=true;if(!V){V="";}if(V.length>=this.getStartSuggestion()){this._iSuggestDelay=setTimeout(function(){if(this._sPrevSuggValue!==V){this._bBindingUpdated=false;this.fireSuggest({suggestValue:V});if(!this._bBindingUpdated){this._refreshItemsDelayed();}this._sPrevSuggValue=V;}}.bind(this),300);}else if(this.isMobileDevice()){if(i instanceof T){i.addStyleClass("sapMInputSuggestionTableHidden");}else if(i&&i.destroyItems){i.destroyItems();}}else if(this._isSuggestionsPopoverOpen()){setTimeout(function(){var N=this.getDOMValue()||'';if(N.length<this.getStartSuggestion()){this._closeSuggestionPopup();}}.bind(this),0);}};
A.prototype._shouldTriggerSuggest=function(){return!this._bPopupHasFocus&&!this.getStartSuggestion()&&!this.getValue()&&this.getShowSuggestion();};
A.prototype.setShowTableSuggestionValueHelp=function(V){var i=this._getSuggestionsPopover();this.setProperty("showTableSuggestionValueHelp",V,true);if(!i.getPopover()){return this;}if(V){this._addShowMoreButton();}else{this._removeShowMoreButton();}return this;};
A.prototype.onchange=function(E){if(this.getShowValueHelp()||this.getShowSuggestion()||this.getProperty("effectiveShowClearIcon")){return;}this.onChange(E);};
A.prototype.oninput=function(E){I.prototype.oninput.call(this,E);if(E.isMarked("invalid")){return;}var V=this.getDOMValue(),i,F,H;if(this.getValueLiveUpdate()){this.setProperty("value",V,true);this._onValueUpdated(V);}this.fireLiveChange({value:V,newValue:V});this.addStyleClass("sapMFocus");if(this.getShowSuggestion()&&!this.isMobileDevice()){i=this._getSuggestionsPopover();F=i.getItemsContainer();this._triggerSuggest(V);if(F&&!i.getValueStateActiveState()){H=F&&F.getSelectedItem();F.removeStyleClass("sapMListFocus");H&&H.removeStyleClass("sapMLIBFocused");}else if(i.getValueStateActiveState()&&document.activeElement.tagName!=="A"){i._getValueStateHeader().removeStyleClass("sapMPseudoFocus");}}this._handleTypeAhead(this);};
A.prototype.onkeydown=function(E){this._bDoTypeAhead=!D.os.android&&this.getAutocomplete()&&(E.which!==K.BACKSPACE)&&(E.which!==K.DELETE);};
A.prototype.onkeyup=function(E){var V=this.getValue();var i=this.getLastValue();if([K.BACKSPACE,K.DELETE].indexOf(E.which)!==-1&&!V){this.getShowSuggestion()&&this.setSelectedKey(null);(i!==V)&&this.setLastValue(i);}this.getShowClearIcon()&&this.setProperty("effectiveShowClearIcon",!!V);};
A.prototype.getValue=function(){return this.getDomRef("inner")&&this._$input?this.getDOMValue():this.getProperty("value");};
A.prototype._refreshItemsDelayed=function(){clearTimeout(this._iRefreshListTimeout);this._iRefreshListTimeout=setTimeout(this._refreshListItems.bind(this),0);};
A.prototype._clearSuggestionPopupItems=function(){var i=this._getSuggestionsPopover().getItemsContainer();if(!i){return;}if(i instanceof T){i.removeSelections(true);}else{i.destroyItems();}};
A.prototype._hideSuggestionPopup=function(){var i=this._getSuggestionsPopover(),E=i.getPopover(),F=i.getItemsContainer();if(!this.isMobileDevice()){if(this._isSuggestionsPopoverOpen()){this._sCloseTimer=setTimeout(function(){this.cancelPendingSuggest();if(this._getTypedInValue()){this.setDOMValue(this._getTypedInValue());}E.close();}.bind(this),0);}}else if(this._hasTabularSuggestions()&&F){F.addStyleClass("sapMInputSuggestionTableHidden");}this.$("SuggDescr").text("");this.$("inner").removeAttr("aria-activedescendant");};
A.prototype._openSuggestionPopup=function(O){if(!this.isMobileDevice()){if(this._sCloseTimer){clearTimeout(this._sCloseTimer);this._sCloseTimer=null;}if(!this._isSuggestionsPopoverOpen()&&!this._sOpenTimer&&O!==false&&this.getShowSuggestion()){this._sOpenTimer=setTimeout(function(){this._sOpenTimer=null;this._getSuggestionsPopover()&&this._openSuggestionsPopover();}.bind(this),0);}}};
A.prototype._applySuggestionAcc=function(N){var i="",E=this._oRb;setTimeout(function(){if(N===1){i=E.getText("INPUT_SUGGESTIONS_ONE_HIT");}else if(N>1){i=E.getText("INPUT_SUGGESTIONS_MORE_HITS",N);}else{i=E.getText("INPUT_SUGGESTIONS_NO_HIT");}this.$("SuggDescr").text(i);}.bind(this),0);};
A.prototype._refreshListItems=function(){var i=this.getShowSuggestion(),E=this._bDoTypeAhead?this._getTypedInValue():(this.getDOMValue()||""),F,H;if(!i||!this._bShouldRefreshListItems||!this.getDomRef()||(!this.isMobileDevice()&&!this.$().hasClass("sapMInputFocused"))){return null;}this._clearSuggestionPopupItems();if(E.length<this.getStartSuggestion()){this._hideSuggestionPopup();return false;}F=this._getFilteredSuggestionItems(E);H=F.items.length;if(H>0&&!this.getValueHelpOnly()){this._openSuggestionPopup(this.getValue().length>=this.getStartSuggestion());}else{this._hideSuggestionPopup();}this._applySuggestionAcc(H);};
A.prototype.addSuggestionItem=function(i){this.addAggregation("suggestionItems",i,true);this._synchronizeSuggestions();this._createSuggestionPopupContent();return this;};
A.prototype.insertSuggestionItem=function(i,E){this.insertAggregation("suggestionItems",E,i,true);this._synchronizeSuggestions();this._createSuggestionPopupContent();return this;};
A.prototype.removeSuggestionItem=function(i){var E=this.removeAggregation("suggestionItems",i,true);this._synchronizeSuggestions();return E;};
A.prototype.removeAllSuggestionItems=function(){var i=this.removeAllAggregation("suggestionItems",true);this._synchronizeSuggestions();return i;};
A.prototype.destroySuggestionItems=function(){this.destroyAggregation("suggestionItems",true);this._synchronizeSuggestions();return this;};
A.prototype.bindAggregation=function(){if(arguments[0]==="suggestionRows"||arguments[0]==="suggestionColumns"||arguments[0]==="suggestionItems"){this._createSuggestionPopupContent(arguments[0]==="suggestionRows"||arguments[0]==="suggestionColumns");this._bBindingUpdated=true;}return I.prototype.bindAggregation.apply(this,arguments);};
A.prototype._closeSuggestionPopup=function(){this._bShouldRefreshListItems=false;this.cancelPendingSuggest();this._isSuggestionsPopoverOpen()&&this._getSuggestionsPopover().getPopover().close();if(!this.isMobileDevice()&&this.$().hasClass("sapMInputFocused")){this.openValueStateMessage();}this.$("SuggDescr").text("");this.$("inner").removeAttr("aria-activedescendant");this._sPrevSuggValue=null;};
A.prototype._synchronizeSuggestions=function(){var i=this._getSuggestionsPopover(),E=i&&i.getInput(),F=E&&E.getFocusDomRef();if(document.activeElement===this.getFocusDomRef()||document.activeElement===F){this._bShouldRefreshListItems=true;this._refreshItemsDelayed();}if(!this.getDomRef()||this._isSuggestionsPopoverOpen()){return;}this._synchronizeSelection();};
A.prototype._synchronizeSelection=function(){var i=this.getSelectedKey();if(!i){return;}if(this.getValue()&&!this.getSelectedItem()&&!this.getSelectedRow()){return;}this.setSelectedKey(i);};
A.prototype.onfocusin=function(E){I.prototype.onfocusin.apply(this,arguments);this.addStyleClass("sapMInputFocused");if(!this.isMobileDevice()&&this._isSuggestionsPopoverOpen()){this.closeValueStateMessage();}if(this._shouldTriggerSuggest()){this._triggerSuggest(this.getValue());}this._bPopupHasFocus=undefined;this._sPrevSuggValue=null;};
A.prototype.oncompositionend=function(E){I.prototype.oncompositionend.apply(this,arguments);if(!D.browser.firefox){this._handleTypeAhead(this);}};
A.prototype._handleTypeAhead=function(i){var V=this.getValue();this._setTypedInValue(V);i._sProposedItemText=null;if(!this._bDoTypeAhead||V===""||V.length<this.getStartSuggestion()||document.activeElement!==this.getFocusDomRef()){return;}var H=i._hasTabularSuggestions(),E=H?i.getSuggestionRows():i.getSuggestionItems(),F=function(N){if(!N){return"";}return H?i._getRowResultFunction()(N):N.getText();};var J=t(V,this,E,function(N){return this._formatTypedAheadValue(F(N));}.bind(this));i._sProposedItemText=F(J[0]);};
A.prototype._resetTypeAhead=function(i){i=i||this;i._sProposedItemText=null;this._setTypedInValue('');};
A.prototype.onsapright=function(){var V=this.getValue();if(!this.getAutocomplete()){return;}if(this._getTypedInValue()!==V){this._setTypedInValue(V);this.fireLiveChange({value:V,newValue:V});}};
A.prototype._formatTypedAheadValue=function(N){var i=this._getTypedInValue();if(N.toLowerCase().indexOf(i.toLowerCase())===0){return i.concat(N.substring(i.length,N.length));}else{return N;}};
A.prototype.onsapshow=function(E){if(!this.getEnabled()||!this.getEditable()||!this.getShowValueHelp()){return;}this.bValueHelpRequested=true;this._fireValueHelpRequest(false);E.preventDefault();E.stopPropagation();};
A.prototype.onsaphide=A.prototype.onsapshow;
A.prototype.onsapselect=function(E){this._fireValueHelpRequestForValueHelpOnly();};
A.prototype.onfocusout=function(E){I.prototype.onfocusout.apply(this,arguments);this.removeStyleClass("sapMInputFocused");this.$("SuggDescr").text("");};
A.prototype._hasTabularSuggestions=function(){return!!(this.getAggregation("suggestionColumns")&&this.getAggregation("suggestionColumns").length);};
A.prototype._getSuggestionsTable=function(){if(this._bIsBeingDestroyed){return null;}if(!this._oSuggestionsTable){this._oSuggestionsTable=this._createSuggestionsTable();}return this._oSuggestionsTable;};
A.prototype._destroySuggestionsTable=function(){if(this._oSuggestionsTable){this._oSuggestionsTable.destroy();this._oSuggestionsTable=null;}};
A.prototype._createSuggestionsTable=function(){var i;var E=new T(this.getId()+"-popup-table",{mode:y.SingleSelectMaster,showNoData:false,showSeparators:this.getProperty("separateSuggestions")?z.Inner:z.None,width:"100%",enableBusyIndicator:false,rememberSelections:false,itemPress:function(F){if(D.system.desktop){this.focus();}var H=F.getParameter("listItem");this.setSelectionRow(H,true);}.bind(this),sticky:[l.Sticky.ColumnHeaders]});E.addEventDelegate({onAfterRendering:function(){var F;if(!this.getEnableSuggestionsHighlighting()){return;}F=E.$().find('tbody .sapMLabel');m(F,this._getTypedInValue());}},this);if(this.isMobileDevice()){E.addStyleClass("sapMInputSuggestionTableHidden");}E.updateItems=function(){T.prototype.updateItems.apply(this,arguments);this._refreshItemsDelayed();return this;};i=new r(function(F){var H=F.mutation;var J=F.child;var N=F.name==="items";switch(H){case"insert":if(N){J.setType(u.Active);this._createSuggestionPopupContent(true);this._synchronizeSuggestions();}break;case"remove":if(N){this._synchronizeSuggestions();}break;default:break;}}.bind(this));i.observe(E,{aggregations:["items","columns"]});return E;};
A.prototype.clone=function(){var i=I.prototype.clone.apply(this,arguments);i.setRowResultFunction(this._fnRowResultFilter);i.setValue(this.getValue());return i;};
A.prototype.setValue=function(V){this._iSetCount++;I.prototype.setValue.call(this,V);this._onValueUpdated(V);this._setTypedInValue("");this.setProperty("effectiveShowClearIcon",!!V);return this;};
A.prototype.setDOMValue=function(i){this._$input.val(i);};
A.prototype.getDOMValue=function(){return this._$input.val();};
A.prototype._getInputValue=function(){var V=I.prototype._getInputValue.apply(this,arguments);if(this.getMaxLength()>0){V=V.substring(0,this.getMaxLength());}return V;};
A.prototype.setMaxLength=function(i){i=this.validateProperty("maxLength",i);this.setProperty("maxLength",i);this.updateDomValue(this.getProperty("value"));return this;};
A.prototype.updateInputField=function(N){if(this._isSuggestionsPopoverOpen()&&this.isMobileDevice()){this._getSuggestionsPopover().getInput().setValue(N)._doSelect();}else{N=this._getInputValue(N);this.setDOMValue(N);this.onChange(null,null,N);}};
A.prototype.getAccessibilityInfo=function(){var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.description=((i.description||"")+" "+this.getDescription()).trim();return i;};
A.prototype.preventChangeOnFocusLeave=function(E){return this.bFocusoutDueRendering||this.bValueHelpRequested;};
A.prototype._getShowMoreButton=function(){return this._getSuggestionsPopover().getShowMoreButton();};
A.prototype._getShowMoreButtonPress=function(){var i,E=this._getTypedInValue();if(this.getShowTableSuggestionValueHelp()){if(E){i=E;this.updateDomValue(i);this._resetTypeAhead();this._setTypedInValue(i);}this._fireValueHelpRequest(true);this._closeSuggestionPopup();}};
A.prototype._addShowMoreButton=function(){var i=this._getSuggestionsPopover();var E=i&&i.getPopover();if(!E||!this._hasTabularSuggestions()||this._getShowMoreButton()){return;}var F=new B({text:this._oRb.getText("INPUT_SUGGESTIONS_SHOW_ALL"),press:this._getShowMoreButtonPress.bind(this)});if(E.isA("sap.m.Dialog")){i.setShowMoreButton(F);}else{i.setShowMoreButton(new e({content:[new f(),F]}));}};
A.prototype._removeShowMoreButton=function(){var i=this._getSuggestionsPopover();var E=i&&i.getPopover();if(E&&this._hasTabularSuggestions()&&this._getShowMoreButton()){i.removeShowMoreButton();}};
A.prototype._hasShowSelectedButton=function(){return false;};
A.prototype._createSuggestionPopupContent=function(i){var E=this._getSuggestionsPopover();var F=E.getItemsContainer();if(F&&((F.isA("sap.m.Table")&&!i)||(F.isA("sap.m.List")&&i))){F.destroy();F=null;this._destroySuggestionsTable();}if(this._bIsBeingDestroyed||!E||F){return;}E.initContent(this.getId(),i?this._getSuggestionsTable():null);if(!this._hasTabularSuggestions()&&!i){this._decorateSuggestionsPopoverList(E.getItemsContainer());}else{this._decorateSuggestionsPopoverTable();}};
A.prototype._decorateSuggestionsPopoverList=function(i){if(!i||!i.isA("sap.m.List")){return;}i.addEventDelegate({onAfterRendering:function(){var E,F;if(!this.getEnableSuggestionsHighlighting()){return;}E=i.$().find('.sapMSLIInfo, .sapMSLITitleOnly');F=this._bDoTypeAhead?this._getTypedInValue():this.getValue();F=(F||"").toLowerCase();m(E,F);}},this);i.attachItemPress(function(E){if(D.system.desktop){this.focus();}var F=E.getParameter("listItem");if(!F.isA("sap.m.GroupHeaderListItem")){this.setSelectionItem(o.getItemByListItem(this.getSuggestionItems(),F),true);}},this);};
A.prototype._decorateSuggestionsPopoverTable=function(){if(this.getShowTableSuggestionValueHelp()){this._addShowMoreButton();}};
A.prototype._decoratePopupInput=function(i){if(!i){return;}i.setValueLiveUpdate(true);i.setValueState(this.getValueState());i.setShowValueHelp(this.getShowValueHelp());i.attachValueHelpRequest(function(){this.fireValueHelpRequest({fromSuggestions:true});this._getSuggestionsPopover().iPopupListSelectedIndex=-1;this._closeSuggestionPopup();}.bind(this));i.attachLiveChange(function(E){var V=E.getParameter("newValue");this.setDOMValue(this._getInputValue(this._getSuggestionsPopover().getInput().getValue()));this._triggerSuggest(V);this.fireLiveChange({value:V,newValue:V});}.bind(this));i._handleTypeAhead=function(){A.prototype._handleTypeAhead.call(i,this);}.bind(this);i._resetTypeAhead=function(){A.prototype._resetTypeAhead.call(i,this);}.bind(this);i.addEventDelegate({onsapenter:function(){this.setValue(this._sProposedItemText);}},this);return i;};
A.prototype.forwardEventHandlersToSuggPopover=function(i){i.setOkPressHandler(this._closeSuggestionPopup.bind(this));i.setCancelPressHandler(this._closeSuggestionPopup.bind(this));};
A.prototype._getSuggestionsPopover=function(){return this._oSuggPopover;};
A.prototype._createSuggestionsPopover=function(){var i=this._oSuggPopover=new d(this);i.decorateParent(this);i.setInputLabels(this.getLabels.bind(this));this._createSuggestionsPopoverPopup();this.forwardEventHandlersToSuggPopover(i);i.attachEvent(d.M_EVENTS.SELECTION_CHANGE,function(E){var F=E.getParameter("newItem"),N=this.calculateNewValue(F),H=F&&F.isA("sap.m.GroupHeaderListItem"),J=this.getFocusDomRef(),O=J&&J.value.substring(0,J.selectionStart),U=E.getParameter("previousItem"),V=U&&U.isA("sap.m.GroupHeaderListItem"),W=p(s(J,V),N,O,V);if(!F||H){this.setDOMValue(O);}else{this.setDOMValue(N);W=(W===0&&N.indexOf(O)===0)?O.length:W;this._doSelect(W);}this._sSelectedSuggViaKeyboard=N;},this);if(this.getShowTableSuggestionValueHelp()){this._addShowMoreButton();}return this._oSuggPopover;};
A.prototype.calculateNewValue=function(i){if(!i||(i&&i.isA("sap.m.GroupHeaderListItem"))){return"";}if(i.isA("sap.m.ColumnListItem")){return this._getInputValue(this._getRowResultFunction()(i));}if(i.isA("sap.m.StandardListItem")){return this._getInputValue(i.getTitle());}};
A.prototype._createSuggestionsPopoverPopup=function(){var i=this._getSuggestionsPopover();var E;i.createSuggestionPopup(this,{showSelectedButton:this._hasShowSelectedButton()});this._decoratePopupInput(i.getInput());E=i.getPopover();E.attachBeforeOpen(function(){this._updateSuggestionsPopoverValueState();},this);E.attachBeforeClose(function(){this._updateSuggestionsPopoverValueState();},this);if(this.isMobileDevice()){E.attachBeforeClose(function(){this.setDOMValue(this._getInputValue(i.getInput().getValue()));this.onChange();},this).attachAfterClose(function(){var F=i.getItemsContainer();if(!F){return;}if(T&&!(F instanceof T)){F.destroyItems();}else{F.removeSelections(true);}}).attachAfterOpen(function(){this._triggerSuggest(this.getValue());this._refreshListItems();},this).attachBeforeOpen(function(){var F=i.getInput();["placeholder","maxLength","value","showClearIcon","effectiveShowClearIcon"].forEach(function(H){F.setProperty(H,this.getProperty(H));},this);},this);}else{E.attachAfterClose(function(){var F=this._getSuggestionsPopover().getItemsContainer();var H=F&&F.getSelectedItem();var J=this.getDomRef();if(this.getSelectionUpdatedFromList()){this.updateSelectionFromList(H);}if(!F){return;}this._bAfterOpenFinisihed=false;if(F instanceof T){H&&H.removeStyleClass("sapMLIBFocused");F.removeSelections(true);}else{F.destroyItems();}this._deregisterPopupResize();if(J&&J.contains(document.activeElement)){this.addStyleClass("sapMFocus");}},this).attachBeforeOpen(function(){i._sPopoverContentWidth=this.getMaxSuggestionWidth();i.resizePopup(this);this._registerPopupResize();this._bAfterOpenFinisihed=false;},this).attachAfterOpen(function(){this._bAfterOpenFinisihed=true;},this);}this.setAggregation("_suggestionPopup",E);this._oSuggestionPopup=E;};
A.prototype._registerPopupResize=function(){var i=this._getSuggestionsPopover();this._sPopupResizeHandler=R.register(this,i.resizePopup.bind(i,this));};
A.prototype._deregisterPopupResize=function(){if(this._sPopupResizeHandler){this._sPopupResizeHandler=R.deregister(this._sPopupResizeHandler);}};
A.prototype.showItems=function(F){var i,E,H=this._getFilterFunction();if(!this.getEnabled()||!this.getEditable()||this.getValueHelpOnly()){return;}this.setFilterFunction(F||function(){return true;});this._clearSuggestionPopupItems();i=this._getFilteredSuggestionItems(this.getDOMValue());E=i.items.length;if(E>0){this._openSuggestionPopup();}else{this._hideSuggestionPopup();}this._applySuggestionAcc(E);this.setFilterFunction(H);};
A.prototype.shouldValueStateMessageBeOpened=function(){var i=I.prototype.shouldValueStateMessageBeOpened.apply(this,arguments);if(!i||this._isSuggestionsPopoverOpen()){return false;}return true;};
A.prototype._isSuggestionsPopoverOpen=function(){return this._getSuggestionsPopover()&&this._getSuggestionsPopover().isOpen();};
A.prototype.isMobileDevice=function(){return D.system.phone;};
A.prototype._openSuggestionsPopover=function(){this.closeValueStateMessage();this._updateSuggestionsPopoverValueState();this._getSuggestionsPopover().getPopover().open();};
A.prototype._updateSuggestionsPopoverValueState=function(){var i=this._getSuggestionsPopover(),V=this.getValueState(),N=this.getValueState()!==i._getValueStateHeader().getValueState(),E=this.getFormattedValueStateText(),F=this.getValueStateText();if(!i){return;}if(this._isSuggestionsPopoverOpen()&&!E&&!N){this.setFormattedValueStateText(i._getValueStateHeader().getFormattedText());}i.updateValueState(V,(E||F),this.getShowValueStateMessage());if(this.isMobileDevice()){i.getInput().setValueState(V);}};
A.prototype.setShowValueHelp=function(i){var E=this._getSuggestionsPopover()&&this._getSuggestionsPopover().getInput();this.setProperty("showValueHelp",i);if(E){E.setShowValueHelp(i);}return this;};
A.prototype.isValueHelpOnlyOpener=function(i){return true;};
A.prototype._getFilteredSuggestionItems=function(V){var F,i=this._getSuggestionsPopover().getItemsContainer();if(this._hasTabularSuggestions()){if(this.isMobileDevice()&&i){i.removeStyleClass("sapMInputSuggestionTableHidden");}F=this.filterTabularItems(this.getSuggestionRows(),V);}else{F=n(this,this.getSuggestionItems(),V,this.getFilterSuggests(),true,this._getFilterFunction());this._mapItems(F);}return F;};
A.prototype.filterTabularItems=function(i,V){var E,F=this.getFilterSuggests(),H=[],J=[],N=false,O=this._getFilterFunction();i.forEach(function(U){if(U.isA("sap.m.GroupHeaderListItem")){J.push({header:U,visible:false});}else{E=!F||O(V,U);U.setVisible(E);E&&H.push(U);if(!N&&E&&this._sProposedItemText===this._getRowResultFunction()(U)){U.setSelected(true);N=true;}if(J.length&&E){J[J.length-1].visible=true;}}},this);J.forEach(function(U){U.header.setVisible(U.visible);});this._getSuggestionsTable().invalidate();return{items:H,groups:J};};
A.prototype._mapItems=function(F){var i=this.getSuggestionItems(),E=F.items,H=F.groups,J=H.map(function(W){return W.header;}),N=false,O=this._getSuggestionsPopover().getItemsContainer(),U,V;i.filter(function(W){return(E.indexOf(W)>-1)||(J.indexOf(W)>-1);}).map(function(W){U=o.createListItemFromCoreItem(W,true);O.addItem(U);if(!N&&this._sProposedItemText===W.getText()){U.setSelected(true);N=true;}return W;},this).filter(function(W){return J.indexOf(W)>-1;}).forEach(function(W){V=J.indexOf(W);if(V>-1){U=o.getListItem(W);U&&U.setVisible(H[V].visible);}});};
A.prototype._setTypedInValue=function(V){this._sTypedInValue=V;return this;};
A.prototype._getTypedInValue=function(){return this._sTypedInValue;};
A.prototype._setSeparateSuggestions=function(V){var i=this._getSuggestionsTable();this.setProperty("separateSuggestions",V);if(i){i.setShowSeparators(V?z.Inner:z.None);}return this;};
return A;});
sap.ui.predefine('sap/m/InputBase',['./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','./delegate/ValueStateMessage','sap/ui/core/message/MessageMixin','sap/ui/core/InvisibleMessage','sap/ui/core/library','sap/ui/Device','./InputBaseRenderer','sap/base/Log',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos","sap/ui/dom/jquery/getSelectedText","sap/ui/dom/jquery/selectText"],function(l,C,E,I,V,M,a,c,D,b,d,K,q){"use strict";var T=c.TextDirection;var f=c.TextAlign;var g=c.ValueState;
var h=C.extend("sap.m.InputBase",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:g.None},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueStateText:{type:"string",group:"Misc",defaultValue:null},showValueStateMessage:{type:"boolean",group:"Misc",defaultValue:true},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:f.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},required:{type:"boolean",group:"Misc",defaultValue:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{change:{parameters:{value:{type:"string"}}}},aggregations:{formattedValueStateText:{type:"sap.m.FormattedText",multiple:false,defaultValue:null},_invisibleFormattedValueStateText:{type:"sap.m.FormattedText",multiple:false,visibility:"hidden",defaultValue:null},_endIcon:{type:"sap.ui.core.Icon",multiple:true,visibility:"hidden"},_beginIcon:{type:"sap.ui.core.Icon",multiple:true,visibility:"hidden"}},designtime:"sap/m/designtime/InputBase.designtime"}});
E.call(h.prototype);I.insertFontFaceStyle();M.call(h.prototype);h.ICON_PRESSED_CSS_CLASS="sapMInputBaseIconPressed";h.ICON_CSS_CLASS="sapMInputBaseIcon";h.prototype.bShowLabelAsPlaceholder=!D.support.input.placeholder;
h.prototype._getPlaceholder=function(){return this.getPlaceholder()||"";};
h.prototype._getInputValue=function(v){return(v===undefined)?(this.$("inner").val()||""):v.toString();};
h.prototype._getInputElementTagName=function(){if(!this._sInputTagElementName){this._sInputTagElementName=this._$input&&this._$input.get(0)&&this._$input.get(0).tagName;}return this._sInputTagElementName;};
h.prototype.init=function(){this.setLastValue("");this.bRenderingPhase=false;this._oValueStateMessage=new V(this);this._bIsComposingCharacter=false;this.setLastValueStateText("");this.setErrorMessageAnnouncementState(false);this.fnCloseValueStateOnClick=function(){this.closeValueStateMessage();};};
h.prototype.oncompositionstart=function(){this._bIsComposingCharacter=true;};
h.prototype.oncompositionend=function(e){this._bIsComposingCharacter=false;if(!D.browser.firefox){this._bCheckDomValue=true;}};
h.prototype.isComposingCharacter=function(){return this._bIsComposingCharacter;};
h.prototype.onBeforeRendering=function(){var F=this.getFocusDomRef();var o=this.getFormattedValueStateText();var e;if(!this._oInvisibleMessage){this._oInvisibleMessage=a.getInstance();}if(this._bCheckDomValue&&!this.bRenderingPhase){if(this.isActive()){this._sDomValue=this._getInputValue();}else{this._bCheckDomValue=false;}}if(!o){e=false;}else{var i=this.getAggregation("_invisibleFormattedValueStateText");e=o.getHtmlText()!==(i&&i.getHtmlText());}if(this.getValueState()===g.Error&&F){var v=e||this.getValueStateText()!==this.getLastValueStateText();this.setErrorMessageAnnouncementState(!F.hasAttribute('aria-invalid')||v);}if(e){i&&i.destroy();this.setAggregation("_invisibleFormattedValueStateText",o.clone());}this.bRenderingPhase=true;};
h.prototype.onAfterRendering=function(){var v=this.getValueState();var i=this.getFocusDomRef()===document.activeElement;var e=v===g.None;var s=document.getElementById(this.getValueStateMessageId()+'-sr');if(this._bCheckDomValue&&this._sDomValue!==this._getInputValue()){this.$("inner").val(this._sDomValue);}if(this.getErrorMessageAnnouncementState()&&this.hasStyleClass("sapMFocus")){s&&this._oInvisibleMessage.announce(s.textContent);this.setErrorMessageAnnouncementState(false);}this.$("message").text(this.getValueStateText());this._bCheckDomValue=false;this.bRenderingPhase=false;if(i){this[e?"closeValueStateMessage":"openValueStateMessage"]();}if(this.getAggregation("_invisibleFormattedValueStateText")){this.getAggregation("_invisibleFormattedValueStateText").getControls().forEach(function(o){o.getDomRef()&&o.getDomRef().setAttribute("tabindex",-1);});}this.setLastValueStateText(this.getValueStateText());};
h.prototype.exit=function(){if(this._oValueStateMessage){this._oValueStateMessage.destroy();}if(this.oInvisibleMessage){this.oInvisibleMessage.destroy();this.oInvisibleMessage=null;}this._oValueStateMessage=null;};
h.prototype.ontouchstart=function(e){e.setMarked();};
h.prototype.onfocusin=function(e){this.addStyleClass("sapMFocus");this.openValueStateMessage();};
h.prototype.onfocusout=function(e){this.removeStyleClass("sapMFocus");if(!this._bClickOnValueStateLink(e)){this.closeValueStateMessage();}};
h.prototype.onsapfocusleave=function(e){if(!this.preventChangeOnFocusLeave(e)){this.onChange(e);}};
h.prototype.preventChangeOnFocusLeave=function(e){return this.bFocusoutDueRendering;};
h.prototype.getChangeEventParams=function(){return{};};
h.prototype.ontap=function(e){return;};
h.prototype.onChange=function(e,p,n){p=p||this.getChangeEventParams();if(this.getDomRef()&&(!this.getEditable()||!this.getEnabled())){return;}var v=this._getInputValue(n);if(v!==this.getLastValue()){this.setValue(v);v=this.getValue();this.setLastValue(v);this.fireChangeEvent(v,p);return true;}else{this._bCheckDomValue=false;}};
h.prototype.fireChangeEvent=function(v,p){var o=q.extend({value:v,newValue:v},p);this.fireChange(o);};
h.prototype.onValueRevertedByEscape=function(v,p){this.fireEvent("liveChange",{value:v,escPressed:true,previousValue:p,newValue:v});};
h.prototype.onsapenter=function(e){if(D.browser.safari&&this.isComposingCharacter()){e.setMarked("invalid");return;}this.onChange(e);};
h.prototype.onsapescape=function(e){var v=this._getInputValue();if(v!==this.getLastValue()){e.setMarked();e.preventDefault();this.updateDomValue(this.getLastValue());this.onValueRevertedByEscape(this.getLastValue(),v);}};
h.prototype.oninput=function(e){this._bCheckDomValue=true;};
h.prototype.onkeydown=function(e){if(this.getDomRef("inner")&&this.getDomRef("inner").getAttribute("readonly")&&e.keyCode==K.BACKSPACE){e.preventDefault();}};
h.prototype.oncut=function(e){};
h.prototype.selectText=function(s,S){this.$("inner").selectText(s,S);return this;};
h.prototype.getSelectedText=function(){return this.$("inner").getSelectedText();};
h.prototype.setProperty=function(p,v,s){if(p=="value"){this._bCheckDomValue=false;}return C.prototype.setProperty.apply(this,arguments);};
h.prototype.getFocusInfo=function(){var F=C.prototype.getFocusInfo.call(this),o=this.getFocusDomRef();q.extend(F,{cursorPos:0,selectionStart:0,selectionEnd:0});if(o){F.cursorPos=q(o).cursorPos();try{F.selectionStart=o.selectionStart;F.selectionEnd=o.selectionEnd;}catch(e){}}return F;};
h.prototype.applyFocusInfo=function(F){C.prototype.applyFocusInfo.call(this,F);this.$("inner").cursorPos(F.cursorPos);this.selectText(F.selectionStart,F.selectionEnd);return this;};
h.prototype.updateDomValue=function(v){var i=this.getFocusDomRef();if(!this.isActive()){return this;}v=this._getInputValue(v);this._bCheckDomValue=true;if(this._bPreferUserInteraction){this.handleInputValueConcurrency(v);}else{i.value=v;}return this;};
h.prototype._aValueStateLinks=function(){if(this.getFormattedValueStateText()&&this.getFormattedValueStateText().getHtmlText()&&this.getFormattedValueStateText().getControls().length){return this.getFormattedValueStateText().getControls();}else{return[];}};
h.prototype._bClickOnValueStateLink=function(e){var v=this._aValueStateLinks();return v.some(function(L){return e.relatedTarget===L.getDomRef();});};
h.prototype._attachValueStateLinkPress=function(){this._aValueStateLinks().forEach(function(L){L.attachPress(this.fnCloseValueStateOnClick,this);},this);};
h.prototype._detachValueStateLinkPress=function(){this._aValueStateLinks().forEach(function(L){L.detachPress(this.fnCloseValueStateOnClick,this);},this);};
h.prototype.handleInputValueConcurrency=function(v){var i=this.getFocusDomRef(),s=i&&this._getInputValue(),e=this.getProperty("value"),j=document.activeElement===i,B=this.isBound("value")&&this.getBindingInfo("value").skipModelUpdate;if(j&&B&&s&&(e!==s)){return this;}i.value=v;if(j&&B&&!s){i.select();}};
h.prototype._setPreferUserInteraction=function(p){this._bPreferUserInteraction=p;};
h.prototype.closeValueStateMessage=function(){setTimeout(function(){if(this._oValueStateMessage){this._detachValueStateLinkPress();this._oValueStateMessage.close();}}.bind(this),0);};
h.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef("content");};
h.prototype.getPopupAnchorDomRef=function(){return this.getDomRef();};
h.prototype.iOpenMessagePopupDuration=0;
h.prototype.getValueStateMessageId=function(){return this.getId()+"-message";};
h.prototype.getErrorMessageAnnouncementState=function(){return this._bErrorStateShouldBeAnnounced;};
h.prototype.setErrorMessageAnnouncementState=function(A){this._bErrorStateShouldBeAnnounced=A;};
h.prototype.setLastValueStateText=function(v){this._sLastValueStateText=v;};
h.prototype.getLastValueStateText=function(){return this._sLastValueStateText;};
h.prototype.getLabels=function(){var L=this.getAriaLabelledBy().map(function(s){return sap.ui.getCore().byId(s);});var o=sap.ui.require("sap/ui/core/LabelEnablement");if(o){L=L.concat(o.getReferencingLabels(this).map(function(s){return sap.ui.getCore().byId(s);}));}return L;};
h.prototype.openValueStateMessage=function(){if(this._oValueStateMessage&&this.shouldValueStateMessageBeOpened()){setTimeout(function(){if(!this.bIsDestroyed){this._detachValueStateLinkPress();this._attachValueStateLinkPress();this._oValueStateMessage.open();}}.bind(this),0);}};
h.prototype.shouldValueStateMessageBeOpened=function(){return(this.getValueState()!==g.None)&&this.getEditable()&&this.getEnabled()&&this.getShowValueStateMessage();};
h.prototype._calculateIconsSpace=function(){var e=this.getAggregation("_endIcon")||[],B=this.getAggregation("_beginIcon")||[],i=e.concat(B),j,k;return i.reduce(function(A,o){j=o&&o.getDomRef()?parseFloat(getComputedStyle(o.getDomRef()).marginRight):0;k=o&&o.getDomRef()?o.getDomRef().offsetWidth:0;return A+k+j;},0);};
h.prototype.setValue=function(v){v=this.validateProperty("value",v);v=this._getInputValue(v);this.updateDomValue(v);if(v!==this.getProperty("value")){this.setLastValue(v);}this.setProperty("value",v,true);return this;};
h.prototype.getFocusDomRef=function(){return this.getDomRef("inner");};
h.prototype.getIdForLabel=function(){return this.getId()+"-inner";};
h.prototype.getAccessibilityInfo=function(){var r=this.getRequired()?'Required':'',R=this.getRenderer();return{role:R.getAriaRole(this),type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_INPUT"),description:[this.getValueDescriptionInfo(),R.getLabelledByAnnouncement(this),R.getDescribedByAnnouncement(this),r].join(" ").trim(),focusable:this.getEnabled(),enabled:this.getEnabled(),editable:this.getEnabled()&&this.getEditable()};};
h.prototype.getValueDescriptionInfo=function(){return this.getValue()||sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("INPUTBASE_VALUE_EMPTY");};
h.prototype._addIcon=function(i,o,p){if(["begin","end"].indexOf(i)===-1){d.error('icon position is not "begin", neither "end", please check again the passed setting');return null;}var e=I.createControlByURI(o).addStyleClass(h.ICON_CSS_CLASS);if(p!==undefined){this.insertAggregation("_"+i+"Icon",e,p);}else{this.addAggregation("_"+i+"Icon",e);}return e;};
h.prototype.addBeginIcon=function(i){return this._addIcon("begin",i);};
h.prototype.addEndIcon=function(i,p){return this._addIcon("end",i,p);};
Object.defineProperty(h.prototype,"_$input",{get:function(){return this.$("inner");}});
h.prototype.setLastValue=function(v){this._lastValue=v;return this;};
h.prototype.getLastValue=function(){return this._lastValue;};
return h;});
sap.ui.predefine('sap/m/InputBaseRenderer',['sap/ui/core/Renderer','sap/ui/core/Core','sap/ui/core/library','sap/ui/core/ValueStateSupport','sap/ui/core/LabelEnablement','sap/ui/Device'],function(R,C,c,V,L,D){"use strict";var T=c.TextDirection;var a=c.ValueState;var I={apiVersion:2};
I.render=function(r,o){var v=o.getValueState(),t=o.getTextDirection(),s=R.getTextAlign(o.getTextAlign(),t),A=sap.ui.getCore().getConfiguration().getAccessibility(),b=o.getAggregation("_beginIcon")||[],e=o.getAggregation("_endIcon")||[],d,f;r.openStart("div",o);this.addOuterStyles(r,o);this.addControlWidth(r,o);r.class("sapMInputBase");this.addPaddingClass(r,o);this.addCursorClass(r,o);this.addOuterClasses(r,o);if(!o.getEnabled()){r.class("sapMInputBaseDisabled");}if(!o.getEditable()){r.class("sapMInputBaseReadonly");}if(v!==a.None&&o.getEditable()&&o.getEnabled()){r.class("sapMInputBaseState");}if(b.length){d=b.filter(function(i){return i.getVisible();});d.length&&r.class("sapMInputBaseHasBeginIcons");}if(e.length){f=e.filter(function(i){return i.getVisible();});f.length&&r.class("sapMInputBaseHasEndIcons");}this.writeOuterAttributes(r,o);var g=o.getTooltip_AsString();if(g){r.attr("title",g);}r.openEnd();r.openStart("div",o.getId()+"-content");r.class("sapMInputBaseContentWrapper");if(!o.getEnabled()){r.class("sapMInputBaseDisabledWrapper");}else if(!o.getEditable()){r.class("sapMInputBaseReadonlyWrapper");}if(v!==a.None&&o.getEditable()&&o.getEnabled()){this.addValueStateClasses(r,o);}this.addWrapperStyles(r,o);r.openEnd();if(b.length){this.writeIcons(r,b);}this.prependInnerContent(r,o);this.openInputTag(r,o);if(o.getName()){r.attr("name",o.getName());}if(!o.bShowLabelAsPlaceholder&&o._getPlaceholder()){r.attr("placeholder",o._getPlaceholder());}if(o.getMaxLength&&o.getMaxLength()>0){r.attr("maxlength",o.getMaxLength());}if(!o.getEnabled()){r.attr("disabled","disabled");}else if(!o.getEditable()){r.attr("readonly","readonly");}if(t!=T.Inherit){r.attr("dir",t.toLowerCase());}this.writeInnerValue(r,o);if(A){this.writeAccessibilityState(r,o);}if(D.browser.mozilla){if(g){r.attr("x-moz-errormessage",g);}else{r.attr("x-moz-errormessage"," ");}}this.writeInnerAttributes(r,o);r.class("sapMInputBaseInner");this.addInnerClasses(r,o);r.style("text-align",s);this.addInnerStyles(r,o);this.endInputTag(r,o);this.writeInnerContent(r,o);this.closeInputTag(r,o);if(e.length){this.writeIcons(r,e);}r.close("div");this.writeDecorations(r,o);if(A){this.renderAriaLabelledBy(r,o);this.renderAriaDescribedBy(r,o);this.renderValueStateAccDom(r,o);}r.close("div");};
I.getAriaRole=function(o){return"textbox";};
I.getAriaLabelledBy=function(o){if(this.getLabelledByAnnouncement(o)){return o.getId()+"-labelledby";}};
I.getLabelledByAnnouncement=function(o){return"";};
I.renderAriaLabelledBy=function(r,o){var A=this.getLabelledByAnnouncement(o);if(A){r.openStart("span",o.getId()+"-labelledby").attr("aria-hidden","true").class("sapUiInvisibleText").openEnd().text(A.trim()).close("span");}};
I.getAriaDescribedBy=function(o){if(this.getDescribedByAnnouncement(o)){return o.getId()+"-describedby";}};
I.getDescribedByAnnouncement=function(o){return"";};
I.renderAriaDescribedBy=function(r,o){var A=this.getDescribedByAnnouncement(o);if(A){r.openStart("span",o.getId()+"-describedby").attr("aria-hidden","true").class("sapUiInvisibleText").openEnd().text(A.trim()).close("span");}};
I.renderValueStateAccDom=function(r,o){var v=o.getValueState();if(v===a.None||!o.getEditable()||!o.getEnabled()){return;}var f=o.getAggregation("_invisibleFormattedValueStateText");var s;s=C.getLibraryResourceBundle("sap.m").getText("INPUTBASE_VALUE_STATE_"+v.toUpperCase());r.openStart("div",o.getValueStateMessageId()+"-sr").class("sapUiPseudoInvisibleText");r.openEnd().text(s).text(" ");if(f){r.renderControl(f);}else{r.text(o.getValueStateText()||V.getAdditionalText(o));}r.close("div");};
I.getAccessibilityState=function(o){var A=this.getAriaLabelledBy(o),s=this.getAriaDescribedBy(o),r=this.getAriaRole(o),v=o.getValueStateMessageId()+"-sr",m={};if(r){m.role=r;}if(o.getValueState()===a.Error&&o.getEditable()&&o.getEnabled()){m.invalid=true;m.errormessage=v;}else if(o.getValueState()!==a.None&&o.getEditable()&&o.getEnabled()){s=s?v+" "+s:v;}if(A){m.labelledby={value:A.trim(),append:true};}if(s){m.describedby={value:s.trim(),append:true};}m.disabled=null;m.readonly=null;return m;};
I.writeAccessibilityState=function(r,o){r.accessibilityState(o,this.getAccessibilityState(o));};
I.openInputTag=function(r,o){r.voidStart("input",o.getId()+"-"+this.getInnerSuffix());};
I.endInputTag=function(r,o){r.voidEnd();};
I.writeInnerValue=function(r,o){r.attr("value",o.getValue());};
I.addCursorClass=function(r,o){};
I.addPaddingClass=function(r,o){r.class("sapMInputBaseHeightMargin");};
I.addOuterStyles=function(r,o){};
I.addControlWidth=function(r,o){if(!o.getProperty('width')){r.class("sapMInputBaseNoWidth");}r.style("width",o.getWidth());};
I.addOuterClasses=function(r,o){};
I.writeOuterAttributes=function(r,o){};
I.addInnerStyles=function(r,o){};
I.addWrapperStyles=function(r,o){r.style("width","100%");};
I.addInnerClasses=function(r,o){};
I.writeInnerAttributes=function(r,o){};
I.prependInnerContent=function(r,o){};
I.writeInnerContent=function(r,o){};
I.writeIcons=function(r,i){r.openStart("div").attr("tabindex","-1").class("sapMInputBaseIconContainer").openEnd();i.forEach(r.renderControl,r);r.close("div");};
I.writeDecorations=function(r,o){};
I.closeInputTag=function(r,o){};
I.addPlaceholderStyles=function(r,o){};
I.addPlaceholderClasses=function(r,o){};
I.addValueStateClasses=function(r,o){r.class("sapMInputBaseContentWrapperState");r.class("sapMInputBaseContentWrapper"+o.getValueState());};
I.getInnerSuffix=function(){return"inner";};
return I;},true);
sap.ui.predefine('sap/m/InputListItem',["sap/ui/core/library","./library","./ListItemBase","./InputListItemRenderer"],function(c,l,L,I){"use strict";var T=c.TextDirection;
var a=L.extend("sap.m.InputListItem",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Misc",defaultValue:null},labelTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}},designtime:"sap/m/designtime/InputListItem.designtime"}});
a.prototype.getContentAnnouncement=function(){var A=this.getLabel()+" . ";this.getContent().forEach(function(C){A+=L.getAccessibilityText(C)+" ";});return A.trim();};
return a;});
sap.ui.predefine('sap/m/InputListItemRenderer',["sap/ui/core/library","sap/ui/core/Renderer","./ListItemBaseRenderer"],function(c,R,L){"use strict";var T=c.TextDirection;var I=R.extend(L);I.apiVersion=2;
I.renderLIAttributes=function(r,l){r.class("sapMILI");};
I.renderLIContent=function(r,l){var s=l.getLabel();var i=l.getId()+"-label";if(s){r.openStart("span",i);r.class("sapMILILabel");var a=l.getLabelTextDirection();if(a!==T.Inherit){r.attr("dir",a.toLowerCase());}r.openEnd();r.text(s);r.close("span");}r.openStart("div").class("sapMILIDiv").class("sapMILI-CTX").openEnd();l.getContent().forEach(function(C){if(C.addAriaLabelledBy&&C.getAriaLabelledBy().indexOf(i)===-1){C.addAriaLabelledBy(i);}r.renderControl(C);});r.close("div");};
return I;},true);
sap.ui.predefine('sap/m/InputRenderer',['sap/ui/core/InvisibleText','sap/ui/core/Renderer','./InputBaseRenderer','sap/m/library'],function(I,R,a,l){"use strict";var b=l.InputType;var c=R.extend(a);c.apiVersion=2;
c.addOuterClasses=function(r,C){r.class("sapMInput");if(C.getDescription()){r.class("sapMInputWithDescription");}};
c.writeInnerAttributes=function(r,C){var s=C.getShowSuggestion();r.attr("type",C.getType().toLowerCase());if(C.getType()==b.Number){r.attr("step","any");}if(C.getType()==b.Number&&sap.ui.getCore().getConfiguration().getRTL()){r.attr("dir","ltr").style("text-align","right");}if(s||C.getShowValueStateMessage()){r.attr("autocomplete","off");}if((!C.getEnabled()&&C.getType()=="Password")||(C.getShowSuggestion()&&C.isMobileDevice())||(C.getValueHelpOnly()&&C.getEnabled()&&C.getEditable()&&C.getShowValueHelp())){r.attr("readonly","readonly");}};
c.addInnerClasses=function(r,C){};
c.writeDescription=function(r,C){r.openStart("div").class("sapMInputDescriptionWrapper").style("width","calc(100% - "+C.getFieldWidth()+")").openEnd();r.openStart("span",C.getId()+"-descr").class("sapMInputDescriptionText").openEnd().text(C.getDescription()).close("span");r.close("div");};
c.writeDecorations=function(r,C){if(C.getDescription()){this.writeDescription(r,C);}if(sap.ui.getCore().getConfiguration().getAccessibility()){if(C.getShowSuggestion()&&C.getEnabled()&&C.getEditable()){r.openStart("span",C.getId()+"-SuggDescr").class("sapUiPseudoInvisibleText").attr("role","status").attr("aria-live","polite").openEnd().close("span");}}};
c.addWrapperStyles=function(r,C){r.style("width",C.getDescription()?C.getFieldWidth():"100%");};
c.getAriaDescribedBy=function(C){var A=a.getAriaDescribedBy.apply(this,arguments);function d(s){A=A?A+" "+s:s;}if(C.getDescription()){d(C.getId()+"-descr");}if(C.getShowValueHelp()&&C.getEnabled()&&C.getEditable()){d(I.getStaticId("sap.m","INPUT_VALUEHELP"));if(C.getValueHelpOnly()){d(I.getStaticId("sap.m","INPUT_DISABLED"));}}return A;};
c.getAriaRole=function(C){return"";};
c.getAccessibilityState=function(C){var s=C.getShowSuggestion();var A=a.getAccessibilityState.apply(this,arguments);if(s){A["haspopup"]="listbox";}return A;};
return c;},true);
sap.ui.predefine('sap/m/InstanceManager',["sap/base/assert","sap/base/Log","sap/ui/thirdparty/jquery"],function(a,L,q){"use strict";var I={};var r={},e=[];var p="_POPOVER_",d="_DIALOG_",l="_LIGHTBOX_";
I.addInstance=function(c,i){a(c,"In sap.m.InstanceManager.addInstance method, the parameter sCategoryId can't be null or empty string");a(i instanceof Object,"In sap.m.InstanceManager.addInstance method, the parameter oInstance should be an object");if(!r[c]){r[c]=[];}if(r[c].indexOf(i)===-1){r[c].push(i);}return this;};
I.removeInstance=function(c,o){var C=r[c],i;a(c,"In sap.m.InstanceManager.removeInstance method, the parameter sCategoryId can't be null or empty string");a(o instanceof Object,"In sap.m.InstanceManager.removeInstance method, the parameter oInstance should be an object");if(!C){return null;}i=C.indexOf(o);return(i===-1)?null:C.splice(i,1);};
I.getInstancesByCategoryId=function(c){a(c,"In sap.m.InstanceManager.getInstancesByCategoryId method, the parameter sCategoryId can't be null or empty string");return r[c]||e;};
I.isInstanceManaged=function(c,i){a(c,"In sap.m.InstanceManager.isInstanceManaged method, the parameter sCategoryId can't be null or empty string");a(i instanceof Object,"In sap.m.InstanceManager.isInstanceManaged method, the parameter oInstance should be an object");var C=r[c];if(!C||!i){return false;}return C.indexOf(i)!==-1;};
I.isCategoryEmpty=function(c){a(c,"In sap.m.InstanceManager.isCategoryEmpty method, the parameter sCategoryId can't be null or empty string");var C=r[c];return!C||C.length===0;};
I.addPopoverInstance=function(P){if(typeof P.close==="function"){I.addInstance(p,P);}else{L.warning("In method addPopoverInstance: the parameter doesn't have a close method and can't be managed.");}return this;};
I.addDialogInstance=function(D){if(typeof D.close==="function"){I.addInstance(d,D);}else{L.warning("In method addDialogInstance: the parameter doesn't have a close method and can't be managed.");}return this;};
I.addLightBoxInstance=function(o){if(typeof o.close==="function"){I.addInstance(l,o);}else{L.warning("In method addLightBoxInstance: the parameter doesn't have a close method and can't be managed.");}return this;};
I.removePopoverInstance=function(P){return I.removeInstance(p,P);};
I.removeDialogInstance=function(D){return I.removeInstance(d,D);};
I.removeLightBoxInstance=function(o){return I.removeInstance(l,o);};
I.hasOpenPopover=function(){return!I.isCategoryEmpty(p);};
I.hasOpenDialog=function(){return!I.isCategoryEmpty(d);};
I.hasOpenLightBox=function(){return!I.isCategoryEmpty(l);};
I.isDialogOpen=function(D){return I.isInstanceManaged(d,D);};
I.isPopoverOpen=function(P){return I.isInstanceManaged(p,P);};
I.isLightBoxOpen=function(o){return I.isInstanceManaged(l,o);};
I.getOpenPopovers=function(){return I.getInstancesByCategoryId(p);};
I.getOpenDialogs=function(){return I.getInstancesByCategoryId(d);};
I.getOpenLightBoxes=function(){return I.getInstancesByCategoryId(l);};
I.closeAllPopovers=function(){var b=I.getOpenPopovers(),i;for(i=0;i<b.length;i++){b[i].close();}return this;};
I.closeAllDialogs=function(c){var D,b=[],f=I.getOpenDialogs(),g,i;for(i=0;i<f.length;i++){g=f[i];if(!g.getCloseOnNavigation()){continue;}if(c){D=new q.Deferred().done();b.push(D);g.attachEvent("afterClose",(function(h){return function(){h.resolve();};}(D)));}g.close();}if(c){q.when.apply(this,b).then(c);}return this;};
I.closeAllLightBoxes=function(){var i=I.getOpenLightBoxes(),b=i.length,c;for(c=0;c<b;c+=1){i[c].close();}return this;};
return I;},true);
sap.ui.predefine('sap/m/Label',['./library','sap/ui/core/Control','sap/ui/core/LabelEnablement','sap/m/HyphenationSupport','sap/ui/core/library','./LabelRenderer'],function(l,C,L,H,c,a){"use strict";var T=c.TextDirection;var b=c.TextAlign;var d=l.LabelDesign;var V=c.VerticalAlign;var W=l.WrappingType;
var e=C.extend("sap.m.Label",{metadata:{interfaces:["sap.ui.core.Label","sap.ui.core.IShrinkable","sap.m.IOverflowToolbarContent","sap.m.IHyphenation"],library:"sap.m",properties:{design:{type:"sap.m.LabelDesign",group:"Appearance",defaultValue:d.Standard},text:{type:"string",group:"Misc",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:b.Begin},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},required:{type:"boolean",group:"Misc",defaultValue:false},displayOnly:{type:"boolean",group:"Appearance",defaultValue:false},wrapping:{type:"boolean",group:"Appearance",defaultValue:false},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal},vAlign:{type:"sap.ui.core.VerticalAlign",group:"Appearance",defaultValue:V.Inherit},showColon:{type:"boolean",group:"Appearance",defaultValue:false}},associations:{labelFor:{type:"sap.ui.core.Control",multiple:false}},designtime:"sap/m/designtime/Label.designtime"}});
e.prototype.getAccessibilityInfo=function(){var D=this.getText();if(this.isRequired()){D+=" *";}return{description:D};};
e.prototype.getOverflowToolbarConfig=function(){var o={canOverflow:true,propsUnrelatedToSize:["design","required","displayOnly"]};function g(f){var h=f&&f.getLayoutData();if(i(h,"sap/m/OverflowToolbarLayoutData")){return h.getGroup();}}o.onBeforeEnterOverflow=function(f){var I=false,t,s,h,j,k;t=f.getParent();if(!i(t,"sap/m/OverflowToolbar")){return;}s=f.getLabelFor();h=s&&sap.ui.getCore().byId(s);if(!h||(t.indexOfContent(h)<0)){return;}j=g(f);k=g(h);I=j&&(j===k);f.toggleStyleClass("sapMLabelMediumMarginTop",I,true);};o.onAfterExitOverflow=function(f){f.toggleStyleClass("sapMLabelMediumMarginTop",false,true);};return o;};
e.prototype.getTextsToBeHyphenated=function(){return{"main":this.getText()};};
e.prototype.getDomRefsForHyphenatedTexts=function(){return{"main":this.$("bdi")[0]};};
L.enrich(e.prototype);H.mixInto(e.prototype);
function i(o,m){if(o&&m){var f=sap.ui.require(m);return(typeof f==='function')&&(o instanceof f);}}
return e;});
sap.ui.predefine('sap/m/LabelRenderer',['sap/ui/core/Core','sap/ui/core/Renderer','sap/m/library','sap/ui/core/library','sap/m/HyphenationSupport',"sap/ui/core/LabelEnablement"],function(C,R,l,c,H,L){"use strict";var T=c.TextDirection;var V=c.VerticalAlign;var a=l.LabelDesign;var b={apiVersion:2};
b.render=function(d,o){var r=b,t=o.getTextDirection(),s=o.getTextAlign(),w=o.getWidth(),e=o.getText(),f=o.getTooltip_AsString(),g=o.getLabelForRendering(),h=g?"label":"span",D=o.isDisplayOnly(),v=o.getVAlign();d.openStart(h,o);d.class("sapMLabel");d.class("sapUiSelectable");if(o.isWrapping()){d.class("sapMLabelWrapped");}if(o.getDesign()==a.Bold){d.style("font-weight","bold");}if(o.isRequired()){d.class("sapMLabelRequired");}if(o.getShowColon()){d.class("sapMLabelShowColon");}if(g){L.writeLabelForAttribute(d,o);d.accessibilityState({label:o.getText()});}else if(o.getParent()instanceof sap.m.Toolbar){d.class("sapMLabelTBHeader");}if(t!==T.Inherit){d.attr("dir",t.toLowerCase());}if(w){d.style("width",w);}else{d.class("sapMLabelMaxWidth");}if(s){s=r.getTextAlign(s,t);if(s){d.style("text-align",s);}}if(e==""){d.class("sapMLabelNoText");}if(D){d.class("sapMLabelDisplayOnly");}if(v!=V.Inherit){d.style("vertical-align",v.toLowerCase());}H.writeHyphenationClass(d,o);if(f){d.attr("title",f);}d.openEnd();d.openStart("span",o.getId()+"-text");d.class("sapMLabelTextWrapper");d.openEnd();d.openStart("bdi",o.getId()+"-bdi");if(t!==T.Inherit){d.attr("dir",t.toLowerCase());}d.openEnd();if(e){e=H.getTextForRender(o,"main");d.text(e);}d.close("bdi");d.close("span");d.openStart("span");d.class("sapMLabelColonAndRequired");d.attr("data-colon",C.getLibraryResourceBundle("sap.m").getText("LABEL_COLON"));d.openEnd();d.close("span");d.close(h);};
b.getTextAlign=R.getTextAlign;return b;},true);
sap.ui.predefine('sap/m/LightBox',["./library","sap/ui/core/Control","sap/ui/core/Popup","sap/ui/core/Core","sap/m/Text","sap/m/Button","sap/ui/core/ResizeHandler","sap/ui/Device","sap/ui/core/Icon","sap/ui/layout/VerticalLayout","./InstanceManager","sap/ui/core/InvisibleText","sap/ui/core/library","./LightBoxRenderer","sap/m/BusyIndicator","sap/ui/thirdparty/jquery","sap/ui/dom/units/Rem"],function(l,C,P,a,T,B,R,D,I,V,b,c,d,L,e,q,f){"use strict";var g=l.ButtonType;var h=l.LightBoxLoadingStates;var O=d.OpenState;var i=d.TextAlign;
var j=C.extend("sap.m.LightBox",{metadata:{library:"sap.m",interfaces:["sap.ui.core.PopupInterface"],aggregations:{imageContent:{type:"sap.m.LightBoxItem",multiple:true,bindable:"bindable"},_closeButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_verticalLayout:{type:"sap.ui.layout.VerticalLayout",multiple:false,visibility:"hidden"},_invisiblePopupText:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"},_busy:{type:"sap.m.BusyIndicator",multiple:false,visibility:"hidden"}},defaultAggregation:"imageContent",events:{},designtime:"sap/m/designtime/LightBox.designtime"}});
j.prototype.init=function(){this._createPopup();this._iWidth=0;this._iHeight=0;this._isRendering=true;this._iResizeListenerId=null;this._$lightBox=null;this._oRB=a.getLibraryResourceBundle("sap.m");this.setAggregation("_invisiblePopupText",new c());};
j.prototype.onBeforeRendering=function(){var o=this._getImageContent(),n=o._getNativeImage(),s=o.getImageSrc(),S=o._getImageState(),k=this._oRB.getText("LIGHTBOX_ARIA_ENLARGED",[o.getTitle(),o.getSubtitle()]),E=this._oRB.getText("LIGHTBOX_IMAGE_ERROR"),m=this._oRB.getText("LIGHTBOX_IMAGE_ERROR_DETAILS");this._createErrorControls();if(n.getAttribute("src")!==s){n.src=s;}if(this._iResizeListenerId){D.resize.detachHandler(this._fnResizeListener);R.deregister(this._iResizeListenerId);this._iResizeListenerId=null;}switch(S){case h.Loading:if(!this._iTimeoutId){this._iTimeoutId=setTimeout(function(){o._setImageState(h.TimeOutError);},10000);}break;case h.Loaded:clearTimeout(this._iTimeoutId);this._calculateSizes(n);break;case h.Error:clearTimeout(this._iTimeoutId);k+=" "+E+" "+m;break;default:break;}if(o){this.getAggregation("_invisiblePopupText").setText(k);}this._isRendering=true;};
j.prototype.onAfterRendering=function(){this._isRendering=false;this._$lightBox=this.$();if(!this._iResizeListenerId){this._fnResizeListener=this._onResize.bind(this);D.resize.attachHandler(this._fnResizeListener);this._iResizeListenerId=R.register(this,this._fnResizeListener);}};
j.prototype.forceInvalidate=C.prototype.invalidate;
j.prototype.invalidate=function(o){var k=this._getImageContent();if(this.isOpen()){if(k&&k.getImageSrc()){this.forceInvalidate(o);}else{this.close();}}return this;};
j.prototype.exit=function(){if(this._oPopup){this._oPopup.detachOpened(this._fnPopupOpened,this);this._oPopup.detachClosed(this._fnPopupClosed,this);this._oPopup.destroy();this._oPopup=null;}if(this._iResizeListenerId){D.resize.detachHandler(this._fnResizeListener);R.deregister(this._iResizeListenerId);this._iResizeListenerId=null;}b.removeLightBoxInstance(this);};
j.prototype.open=function(){var o=this._getImageContent();this._oPopup.setContent(this);if(o&&o.getImageSrc()){this._oPopup.open(300,"center center","center center",document.body,null);b.addLightBoxInstance(this);}return this;};
j.prototype.isOpen=function(){if(this._oPopup&&this._oPopup.isOpen()){return true;}return false;};
j.prototype.close=function(){if(this._iResizeListenerId){D.resize.detachHandler(this._fnResizeListener);R.deregister(this._iResizeListenerId);this._iResizeListenerId=null;}this._oPopup.close();b.removeLightBoxInstance(this);return this;};
j.prototype._getCloseButton=function(){var o=this.getAggregation("_closeButton");if(!o){o=new B({id:this.getId()+"-closeButton",text:this._oRB.getText("LIGHTBOX_CLOSE_BUTTON"),type:g.Transparent,press:this.close.bind(this)});this.setAggregation("_closeButton",o,true);}return o;};
j.prototype._getBusyIndicator=function(){var o=this.getAggregation("_busy");if(!o){o=new e();this.setAggregation("_busy",o,true);}return o;};
j.prototype._imageStateChanged=function(n){var E=n===h.Loaded||n===h.Error;if(E&&!this._isRendering){this.rerender();}};
j.prototype._createPopup=function(){this._oPopup=new P(this,true,true);this._oPopup.attachOpened(this._fnPopupOpened,this);this._oPopup.attachClosed(this._fnPopupClosed,this);};
j.prototype._fnPopupOpened=function(){this._onResize();q("#sap-ui-blocklayer-popup").on("click",function(){this.close();}.bind(this));};
j.prototype._fnPopupClosed=function(){q("#sap-ui-blocklayer-popup").off("click");};
j.prototype._createErrorControls=function(){var E,s,t,S,o;if(this.getAggregation("_verticalLayout")){return;}if(this._getImageContent()._getImageState()===h.TimeOutError){E=this._oRB.getText("LIGHTBOX_IMAGE_TIMED_OUT");s=this._oRB.getText("LIGHTBOX_IMAGE_TIMED_OUT_DETAILS");}else{E=this._oRB.getText("LIGHTBOX_IMAGE_ERROR");s=this._oRB.getText("LIGHTBOX_IMAGE_ERROR_DETAILS");}t=new T({text:E,textAlign:i.Center}).addStyleClass("sapMLightBoxErrorTitle");S=new T({text:s,textAlign:i.Center}).addStyleClass("sapMLightBoxErrorSubtitle");o=new I({src:"sap-icon://picture"}).addStyleClass("sapMLightBoxErrorIcon");this.setAggregation("_verticalLayout",new V({content:[o,t,S]}).addStyleClass("sapMLightBoxVerticalLayout"));};
j.prototype._onResize=function(){var m=this._calculateOffset()/2+"px",t=m,v=m,M="",k="",o=this._getImageContent(),n=this.getDomRef(),p,r,s=this._calculateOffset();if(o._getImageState()===h.Loaded){this._calculateSizes(o._getNativeImage());p=this._iWidth;r=this._iHeight;this._$lightBox.width(p);this._$lightBox.height(r);}else{p=n.clientWidth;r=n.clientHeight;}if(window.innerWidth>p+s){v="50%";k=Math.round(-p/2);}if(window.innerHeight>r+s){t="50%";M=Math.round(-r/2);}this._$lightBox.css({"top":t,"margin-top":M,"left":v,"margin-left":k});};
j.prototype._calculateSizes=function(n){var F=this._calculateFooterHeightInPx(),k=288-F,o=this._getImageContent().getAggregation("_image"),H;this._setImageSize(o,n.naturalWidth,n.naturalHeight);this._calculateAndSetLightBoxSize(o);H=this._pxToNumber(o.getHeight());this.toggleStyleClass("sapMLightBoxMinSize",H<k);this._isBusy=false;};
j.prototype._calculateFooterHeightInPx=function(){var k=this.$().parents().hasClass("sapUiSizeCompact"),s=this._getImageContent().getSubtitle(),F=3;if(k&&!s){F-=0.5;}if(s){F+=0.5;}return f.toPx(F);};
j.prototype._calculateAndSetLightBoxSize=function(o){var k,m,n=20*16,p=18*16,F=this._calculateFooterHeightInPx();k=this._pxToNumber(o.getHeight());m=this._pxToNumber(o.getWidth());this._iWidth=Math.max(n,m);this._iHeight=Math.max(p,k+F);this._bIsLightBoxBiggerThanMinDimensions=(m>=n)&&(k>=(p-F));};
j.prototype._setImageSize=function(o,w,H){var F=this._calculateFooterHeightInPx(),k=this._getDimensions(w,H,F);o.setWidth(k.width+"px");o.setHeight(k.height+"px");};
j.prototype._getDimensions=function(k,m,F){var n=20*16,o=18*16,$=q(window),w=$.height(),W=$.width(),M=this._calculateOffset(),A=Math.max(W-M,n),p=Math.max(w-M,o),s;p-=F;if(m<=p){if(k<=A){}else{m*=A/k;k=A;}}else if(k<=A){k*=p/m;m=p;}else{s=Math.max(k/A,m/p);k/=s;m/=s;}return{width:Math.round(k),height:Math.round(m)};};
j.prototype._pxToNumber=function(s){return(s.substring(0,(s.length-2)))*1;};
j.prototype._getImageContent=function(){var k=this.getAggregation("imageContent");return k&&k[0];};
j.prototype._calculateOffset=function(){if(D.system.desktop){return 4*16;}if(D.system.tablet){return 2*16;}if(D.system.phone&&D.resize.width>320){return 1*16;}return 0;};
j.prototype.onsapescape=function(E){var o=this._oPopup.getOpenState();if(o!==O.CLOSED||o!==O.CLOSING){this.close();E.stopPropagation();}};
return j;});
sap.ui.predefine('sap/m/LightBoxItem',["./library","sap/ui/core/library","sap/ui/core/Element","sap/m/Image","sap/m/Title","sap/m/Label"],function(l,c,E,I,T,L){"use strict";var a=l.LightBoxLoadingStates;var O=c.OpenState;var b=c.TitleLevel;
var d=E.extend("sap.m.LightBoxItem",{metadata:{library:"sap.m",properties:{imageSrc:{type:"sap.ui.core.URI",group:"Appearance",multiple:false,defaultValue:""},alt:{type:"string",group:"Appearance",multiple:false,defaultValue:""},title:{type:"string",group:"Appearance",multiple:false,defaultValue:""},subtitle:{type:"string",group:"Appearance",multiple:false,defaultValue:""}},aggregations:{_image:{type:"sap.m.Image",multiple:false,visibility:"hidden"},_title:{type:"sap.m.Title",multiple:false,visibility:"hidden"},_subtitle:{type:"sap.m.Label",multiple:false,visibility:"hidden"}}}});
d.prototype.init=function(){this._createNativeImage();this.setAggregation("_image",new I({decorative:false,densityAware:false}),true);this.setAggregation("_title",new T({level:b.H2,wrapping:false}),true);this.setAggregation("_subtitle",new L({wrapping:false}),true);};
d.prototype._createNativeImage=function(){var t=this;this._sImageState=a.Loading;this._oImage=new window.Image();this._oImage.onload=function(){if(this.complete&&t._sImageState===a.Loading){t._setImageState(a.Loaded);}};this._oImage.onerror=function(){t._setImageState(a.Error);};};
d.prototype.exit=function(){this._oImage=null;};
d.prototype._setImageState=function(i){if(i!==this._sImageState){this._sImageState=i;if(this.getParent()){this.getParent()._imageStateChanged(i);}}};
d.prototype._getImageState=function(){return this._sImageState;};
d.prototype._getNativeImage=function(){return this._oImage;};
d.prototype.setImageSrc=function(i){var o=this.getAggregation("_image"),e=this.getParent();if(this.getImageSrc()===i){return this;}this._sImageState=a.Loading;if(e&&e._oPopup.getOpenState()===O.OPEN){this._oImage.src=i;}this.setProperty("imageSrc",i,false);o.setSrc(i);return this;};
d.prototype.setAlt=function(e){var i=this.getAggregation("_image");this.setProperty("alt",e,false);i.setAlt(e);return this;};
d.prototype.setTitle=function(t){var o=this.getAggregation("_title");this.setProperty("title",t,false);o.setText(t);return this;};
d.prototype.setSubtitle=function(s){var S=this.getAggregation("_subtitle");this.setProperty("subtitle",s,false);S.setText(s);return this;};
return d;});
sap.ui.predefine('sap/m/LightBoxRenderer',["sap/m/library"],function(l){"use strict";var L=l.LightBoxLoadingStates;var a={apiVersion:2};
a.render=function(r,c){var o=c._getImageContent();var i=o._getImageState();var I=c.getAggregation("_invisiblePopupText");r.openStart("div",c).class("sapMLightBox").attr("tabindex","-1").accessibilityState({role:"dialog",modal:true,labelledby:I&&I.getId()});if(o.getSubtitle()){r.class("sapMLightBoxTwoLines");}if(c._bIsLightBoxBiggerThanMinDimensions){r.class("sapMLightBoxTopCornersRadius");}if(i!==L.Error){r.style("width",c._iWidth+"px");r.style("height",c._iHeight+"px");}else{r.class("sapMLightBoxError");}r.openEnd();r.renderControl(I);if(i===L.Loading){this.renderBusyState(r,c);}else if(i===L.TimeOutError||i===L.Error){this.renderError(r,c);}else{this.renderImage(r,c);}this.renderFooter(r,c,o);r.close("div");c._isRendering=false;};
a.renderImage=function(r,c){var o=c._getImageContent();r.openStart("div",o);if(o.getSubtitle()){r.class("sapMLightBoxImageContainerTwoLines");}else{r.class("sapMLightBoxImageContainer");}r.openEnd();r.renderControl(o.getAggregation("_image"));r.close("div");};
a.renderError=function(r,c){var o=c._getImageContent();r.openStart("div");if(o&&o.getSubtitle()){r.class("sapMLightBoxErrorContainerTwoLines");}else{r.class("sapMLightBoxErrorContainer");}r.openEnd();r.renderControl(c.getAggregation("_verticalLayout"));r.close("div");};
a.renderBusyState=function(r,c){r.renderControl(c._getBusyIndicator());};
a.renderFooter=function(r,c,i){var t=i.getAggregation("_title"),s=i.getAggregation("_subtitle");r.openStart("div").class("sapMLightBoxFooter").class("sapContrast").class("sapContrastPlus");if(i.getSubtitle()){r.class("sapMLightBoxFooterTwoLines");}r.openEnd();r.openStart("div").class("sapMLightBoxTitleSection").openEnd();if(t){r.renderControl(t.addStyleClass("sapMLightBoxTitle"));}if(s&&s.getText()){r.renderControl(s.addStyleClass("sapMLightBoxSubtitle"));}r.close("div");r.renderControl(c._getCloseButton());r.close("div");};
return a;},true);
sap.ui.predefine('sap/m/Link',["./library","sap/ui/core/Control","sap/ui/core/InvisibleText","sap/ui/core/EnabledPropagator","sap/ui/core/LabelEnablement","sap/ui/core/library","sap/ui/Device","./LinkRenderer","sap/ui/events/KeyCodes","sap/base/Log","sap/base/security/URLListValidator"],function(l,C,I,E,L,c,D,a,K,b,U){"use strict";var T=c.TextDirection;var d=c.TextAlign;var A=c.aria.HasPopup;var e=l.EmptyIndicatorMode;
var f=C.extend("sap.m.Link",{metadata:{interfaces:["sap.ui.core.IShrinkable","sap.ui.core.IFormContent","sap.ui.core.ITitleContent"],library:"sap.m",designtime:"sap/m/designtime/Link.designtime",properties:{text:{type:"string",group:"Data",defaultValue:''},enabled:{type:"boolean",group:"Behavior",defaultValue:true},target:{type:"string",group:"Behavior",defaultValue:null},rel:{type:"string",group:"Behavior",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},href:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},validateUrl:{type:"boolean",group:"Data",defaultValue:false},wrapping:{type:"boolean",group:"Appearance",defaultValue:false},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:d.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},subtle:{type:"boolean",group:"Behavior",defaultValue:false},emphasized:{type:"boolean",group:"Behavior",defaultValue:false},ariaHasPopup:{type:"sap.ui.core.aria.HasPopup",group:"Accessibility",defaultValue:A.None},emptyIndicatorMode:{type:"sap.m.EmptyIndicatorMode",group:"Appearance",defaultValue:e.Off}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{allowPreventDefault:true,parameters:{ctrlKey:{type:"boolean"},metaKey:{type:"boolean"}}}},dnd:{draggable:true,droppable:false}}});
E.call(f.prototype);
f.prototype.onBeforeRendering=function(){};
f.prototype.onkeydown=function(o){if(o.which===K.SPACE||o.which===K.SHIFT||o.which===K.ESCAPE){if(o.which===K.SPACE){if(this.getEnabled()||this.getHref()){o.setMarked();o.preventDefault();this._bPressedSpace=true;}}if(this._bPressedSpace&&(o.which===K.ESCAPE||o.which===K.SHIFT)){this._bPressedEscapeOrShift=true;}}else{if(this._bPressedSpace){o.preventDefault();}}};
f.prototype.onkeyup=function(o){if(o.which===K.SPACE){if(!this._bPressedEscapeOrShift){this._handlePress(o);if(this.getHref()&&!o.isDefaultPrevented()){o.preventDefault();o.setMarked();var g=document.createEvent('MouseEvents');g.initEvent('click',false,true);this.getDomRef().dispatchEvent(g);}}else{this._bPressedEscapeOrShift=false;}this._bPressedSpace=false;}};
f.prototype._handlePress=function(o){if(this.getEnabled()){o.setMarked();if(!this.firePress({ctrlKey:!!o.ctrlKey,metaKey:!!o.metaKey})||!this.getHref()){o.preventDefault();}}else{o.preventDefault();}};
f.prototype.onsapenter=f.prototype._handlePress;if(D.support.touch){f.prototype.ontap=f.prototype._handlePress;}else{f.prototype.onclick=f.prototype._handlePress;}
f.prototype.ontouchstart=function(o){if(this.getEnabled()){o.setMarked();}};
f.prototype.setSubtle=function(s){this.setProperty("subtle",s);if(s&&!f.prototype._sAriaLinkSubtleId){f.prototype._sAriaLinkSubtleId=I.getStaticId("sap.m","LINK_SUBTLE");}return this;};
f.prototype.setEmphasized=function(g){this.setProperty("emphasized",g);if(g&&!f.prototype._sAriaLinkEmphasizedId){f.prototype._sAriaLinkEmphasizedId=I.getStaticId("sap.m","LINK_EMPHASIZED");}return this;};
f.prototype._isHrefValid=function(u){return this.getValidateUrl()?U.validate(u):true;};
f.prototype.getAccessibilityInfo=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s=this.getEmphasized()?r.getText("LINK_EMPHASIZED"):"",S=this.getSubtle()?r.getText("LINK_SUBTLE"):"",t=this.getText(),g=t;if(t){s&&(g+=" "+s);S&&(g+=" "+S);}return{role:"link",type:t?r.getText("ACC_CTR_TYPE_LINK"):undefined,description:g,focusable:this.getEnabled(),enabled:this.getEnabled()};};
f.prototype.getFormDoNotAdjustWidth=function(){return true;};
f.prototype._getTabindex=function(){return(this.getText()&&this.getEnabled())?"0":"-1";};
f.prototype._determineSelfReferencePresence=function(){var g=this.getAriaLabelledBy(),h=g.indexOf(this.getId())!==-1,H=L.getReferencingLabels(this).length>0,p=this.getParent(),i=!!(p&&p.enhanceAccessibilityState);return!h&&(g.length>0||H||i);};
return f;});
sap.ui.predefine('sap/m/LinkRenderer',["sap/ui/core/Renderer","sap/ui/core/library","sap/ui/util/defaultLinkTypes",'./library','sap/ui/core/Core'],function(R,c,d,m,C){"use strict";var T=c.TextDirection;var A=c.aria.HasPopup;var L={apiVersion:2};var E=m.EmptyIndicatorMode;var r=C.getLibraryResourceBundle("sap.m");
L.render=function(o,a){var t=a.getTextDirection(),s=R.getTextAlign(a.getTextAlign(),t),S=a._determineSelfReferencePresence(),h=a.getAriaHasPopup(),H=a.getHref(),b=d(a.getRel(),a.getTarget()),e={labelledby:S?{value:a.getId(),append:true}:undefined,haspopup:(h===A.None)?null:h.toLowerCase()},i=H&&a._isHrefValid(H),f=a.getEnabled(),g="";o.openStart("a",a);o.class("sapMLnk");if(a.getSubtle()){o.class("sapMLnkSubtle");g+=a._sAriaLinkSubtleId;}if(a.getEmphasized()){o.class("sapMLnkEmphasized");g+=" "+a._sAriaLinkEmphasizedId;}e.describedby=g?{value:g.trim(),append:true}:undefined;if(!f){o.class("sapMLnkDsbl");o.attr("aria-disabled","true");}o.attr("tabindex",a._getTabindex());if(a.getWrapping()){o.class("sapMLnkWrapping");}if(a.getTooltip_AsString()){o.attr("title",a.getTooltip_AsString());}if(i&&f){o.attr("href",H);}else if(a.getText()){o.attr("href","");}if(a.getTarget()){o.attr("target",a.getTarget());}if(b){o.attr("rel",b);}if(a.getWidth()){o.style("width",a.getWidth());}else{o.class("sapMLnkMaxWidth");}if(s){o.style("text-align",s);}if(t!==T.Inherit){o.attr("dir",t.toLowerCase());}a.getDragDropConfig().forEach(function(D){if(!D.getEnabled()){o.attr("draggable",false);}});o.accessibilityState(a,e);o.openEnd();if(this.writeText){this.writeText(o,a);}else{this.renderText(o,a);}o.close("a");};
L.renderText=function(o,a){var t=a.getText();if(a.getEmptyIndicatorMode()!==E.Off&&!a.getText()){this.renderEmptyIndicator(o,a);}else{o.text(t);}};
L.renderEmptyIndicator=function(o,l){o.openStart("span");o.class("sapMEmptyIndicator");o.class("sapMLnkDsbl");if(l.getEmptyIndicatorMode()===E.Auto){o.class("sapMEmptyIndicatorAuto");}o.openEnd();o.openStart("span");o.attr("aria-hidden",true);o.openEnd();o.text(r.getText("EMPTY_INDICATOR"));o.close("span");o.openStart("span");o.class("sapUiPseudoInvisibleText");o.openEnd();o.text(r.getText("EMPTY_INDICATOR_TEXT"));o.close("span");o.close("span");};
return L;},true);
sap.ui.predefine('sap/m/List',["./library","./ListBase","./ListRenderer"],function(l,L,a){"use strict";var B=l.BackgroundDesign;
var b=L.extend("sap.m.List",{metadata:{library:"sap.m",properties:{backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Solid}}}});
return b;});
sap.ui.predefine('sap/m/ListBase',["sap/ui/events/KeyCodes","sap/ui/Device","sap/ui/core/Core","sap/ui/core/Control","sap/ui/core/InvisibleText","sap/ui/core/LabelEnablement","sap/ui/core/delegate/ItemNavigation","./library","./InstanceManager","./GrowingEnablement","./GroupHeaderListItem","./ListItemBase","./ListBaseRenderer","sap/base/strings/capitalize","sap/ui/thirdparty/jquery","sap/base/Log","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Selectors","sap/ui/dom/jquery/Aria"],function(K,D,C,a,I,L,b,l,c,G,d,f,g,h,q,j){"use strict";var k=l.ListType;var m=l.ListKeyboardMode;var n=l.ListGrowingDirection;var S=l.SwipeDirection;var o=l.ListSeparators;var p=l.ListMode;var r=l.ListHeaderDesign;var s=l.Sticky;var M=l.MultiSelectMode;
var t=a.extend("sap.m.ListBase",{metadata:{library:"sap.m",dnd:true,properties:{inset:{type:"boolean",group:"Appearance",defaultValue:false},headerText:{type:"string",group:"Misc",defaultValue:null},headerDesign:{type:"sap.m.ListHeaderDesign",group:"Appearance",defaultValue:r.Standard,deprecated:true},footerText:{type:"string",group:"Misc",defaultValue:null},mode:{type:"sap.m.ListMode",group:"Behavior",defaultValue:p.None},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},includeItemInSelection:{type:"boolean",group:"Behavior",defaultValue:false},showUnread:{type:"boolean",group:"Misc",defaultValue:false},noDataText:{type:"string",group:"Misc",defaultValue:null},showNoData:{type:"boolean",group:"Misc",defaultValue:true},enableBusyIndicator:{type:"boolean",group:"Behavior",defaultValue:true},modeAnimationOn:{type:"boolean",group:"Misc",defaultValue:true},showSeparators:{type:"sap.m.ListSeparators",group:"Appearance",defaultValue:o.All},swipeDirection:{type:"sap.m.SwipeDirection",group:"Misc",defaultValue:S.Both},growing:{type:"boolean",group:"Behavior",defaultValue:false},growingThreshold:{type:"int",group:"Misc",defaultValue:20},growingTriggerText:{type:"string",group:"Appearance",defaultValue:null},growingScrollToLoad:{type:"boolean",group:"Behavior",defaultValue:false},growingDirection:{type:"sap.m.ListGrowingDirection",group:"Behavior",defaultValue:n.Downwards},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:true},keyboardMode:{type:"sap.m.ListKeyboardMode",group:"Behavior",defaultValue:m.Navigation},sticky:{type:"sap.m.Sticky[]",group:"Appearance"},multiSelectMode:{type:"sap.m.MultiSelectMode",group:"Behavior",defaultValue:M.Default}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ListItemBase",multiple:true,singularName:"item",bindable:"bindable",selector:"#{id} .sapMListItems",dnd:true},swipeContent:{type:"sap.ui.core.Control",multiple:false},headerToolbar:{type:"sap.m.Toolbar",multiple:false},infoToolbar:{type:"sap.m.Toolbar",multiple:false},contextMenu:{type:"sap.ui.core.IContextMenu",multiple:false},_messageStrip:{type:"sap.m.MessageStrip",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{deprecated:true,parameters:{listItem:{type:"sap.m.ListItemBase"}}},selectionChange:{parameters:{listItem:{type:"sap.m.ListItemBase"},listItems:{type:"sap.m.ListItemBase[]"},selected:{type:"boolean"},selectAll:{type:"boolean"}}},"delete":{parameters:{listItem:{type:"sap.m.ListItemBase"}}},swipe:{allowPreventDefault:true,parameters:{listItem:{type:"sap.m.ListItemBase"},swipeContent:{type:"sap.ui.core.Control"},srcControl:{type:"sap.ui.core.Control"},swipeDirection:{type:"sap.m.SwipeDirection"}}},growingStarted:{deprecated:true,parameters:{actual:{type:"int"},total:{type:"int"}}},growingFinished:{deprecated:true,parameters:{actual:{type:"int"},total:{type:"int"}}},updateStarted:{parameters:{reason:{type:"string"},actual:{type:"int"},total:{type:"int"}}},updateFinished:{parameters:{reason:{type:"string"},actual:{type:"int"},total:{type:"int"}}},itemPress:{parameters:{listItem:{type:"sap.m.ListItemBase"},srcControl:{type:"sap.ui.core.Control"}}},beforeOpenContextMenu:{allowPreventDefault:true,parameters:{listItem:{type:"sap.m.ListItemBase"}}}},designtime:"sap/m/designtime/ListBase.designtime"}});
t.prototype.bAnnounceDetails=true;
t.getInvisibleText=function(){if(!this.oInvisibleText){this.oInvisibleText=new I().toStatic();}return this.oInvisibleText;};
t.prototype.sNavItemClass="sapMLIB";
t.prototype.init=function(){this._aNavSections=[];this._aSelectedPaths=[];this._iItemNeedsHighlight=0;this._iItemNeedsNavigated=0;this._bItemsBeingBound=false;this._bSkippedInvalidationOnRebind=false;this.data("sap-ui-fastnavgroup","true",true);};
t.prototype.onBeforeRendering=function(){this._bRendering=true;this._bActiveItem=false;this._aNavSections=[];this._removeSwipeContent();};
t.prototype.onAfterRendering=function(){this._bRendering=false;this._sLastMode=this.getMode();if(D.system.desktop){this._startItemNavigation(true);}};
t.prototype.exit=function(){this._oSelectedItem=null;this._aNavSections=[];this._aSelectedPaths=[];this._destroyGrowingDelegate();this._destroyItemNavigation();};
t.prototype.refreshItems=function(R){if(this._oGrowingDelegate){this._oGrowingDelegate.refreshItems(R);}else{if(!this._bReceivingData){this._updateStarted(R);this._bReceivingData=true;}this.refreshAggregation("items");}};
t.prototype.updateItems=function(R,e){if(e&&e.detailedReason==="AddVirtualContext"){u(this);return;}else if(e&&e.detailedReason==="RemoveVirtualContext"){v(this);return;}if(this._bSkippedInvalidationOnRebind&&this.getBinding("items").getLength()===0){this.invalidate();}if(this._oGrowingDelegate){this._oGrowingDelegate.updateItems(R);}else{if(this._bReceivingData){this._bReceivingData=false;}else{this._updateStarted(R);}this.updateAggregation("items");this._updateFinished();}this._bSkippedInvalidationOnRebind=false;};
function u(e){var B=e.getBinding("items");var i=e.getBindingInfo("items");var x=e.getGrowing()?e.getGrowingThreshold():i.length;var y=e.getGrowing()||!i.startIndex?0:i.startIndex;var V=B.getContexts(y,x)[0];v(e);e._oVirtualItem=G.createItem(V,i,"virtual");e.addAggregation("dependents",e._oVirtualItem,true);}
function v(e){if(e._oVirtualItem){e._oVirtualItem.destroy();delete e._oVirtualItem;}}
t.prototype.setBindingContext=function(e,i){var x=(this.getBindingInfo("items")||{}).model;if(x===i){this._resetItemsBinding();}return a.prototype.setBindingContext.apply(this,arguments);};
t.prototype.bindAggregation=function(N){this._bItemsBeingBound=N==="items";v(this);a.prototype.bindAggregation.apply(this,arguments);this._bItemsBeingBound=false;return this;};
t.prototype._bindAggregation=function(N,B){function e(B,E,H){B.events=B.events||{};if(!B.events[E]){B.events[E]=H;}else{var O=B.events[E];B.events[E]=function(){H.apply(this,arguments);O.apply(this,arguments);};}}if(N==="items"){this._resetItemsBinding();e(B,"dataRequested",this._onBindingDataRequestedListener.bind(this));e(B,"dataReceived",this._onBindingDataReceivedListener.bind(this));}a.prototype._bindAggregation.call(this,N,B);};
t.prototype._onBindingDataRequestedListener=function(e){this._showBusyIndicator();if(this._dataReceivedHandlerId!=null){clearTimeout(this._dataReceivedHandlerId);delete this._dataReceivedHandlerId;}};
t.prototype._onBindingDataReceivedListener=function(e){if(this._dataReceivedHandlerId!=null){clearTimeout(this._dataReceivedHandlerId);delete this._dataReceivedHandlerId;}this._dataReceivedHandlerId=setTimeout(function(){this._hideBusyIndicator();delete this._dataReceivedHandlerId;}.bind(this),0);};
t.prototype.destroyItems=function(e){if(!this.getItems(true).length){return this;}this._oSelectedItem=null;this.destroyAggregation("items","KeepDom");if(!e){if(this._bItemsBeingBound){this._bSkippedInvalidationOnRebind=true;}else{this.invalidate();}}return this;};
t.prototype.removeAllItems=function(A){this._oSelectedItem=null;return this.removeAllAggregation("items");};
t.prototype.removeItem=function(i){var e=this.removeAggregation("items",i);if(e&&e===this._oSelectedItem){this._oSelectedItem=null;}return e;};
t.prototype.getItems=function(R){if(R){return this.mAggregations["items"]||[];}return this.getAggregation("items",[]);};
t.prototype.getId=function(e){var i=this.sId;return e?i+"-"+e:i;};
t.prototype.setGrowing=function(e){e=!!e;if(this.getGrowing()!=e){this.setProperty("growing",e,!e);if(e){this._oGrowingDelegate=new G(this);}else if(this._oGrowingDelegate){this._oGrowingDelegate.destroy();this._oGrowingDelegate=null;}}return this;};
t.prototype.setGrowingThreshold=function(T){return this.setProperty("growingThreshold",T,true);};
t.prototype.setEnableBusyIndicator=function(e){this.setProperty("enableBusyIndicator",e,true);if(!this.getEnableBusyIndicator()){this._hideBusyIndicator();}return this;};
t.prototype.setNoDataText=function(N){this.setProperty("noDataText",N,true);this.$("nodata-text").text(this.getNoDataText());return this;};
t.prototype.getNoDataText=function(e){if(e&&this._bBusy){return"";}var N=this.getProperty("noDataText");N=N||C.getLibraryResourceBundle("sap.m").getText("LIST_NO_DATA");return N;};
t.prototype.getSelectedItem=function(){var e=this.getItems(true);for(var i=0;i<e.length;i++){if(e[i].getSelected()){return e[i];}}return null;};
t.prototype.setSelectedItem=function(e,i,F){if(this.indexOfItem(e)<0){j.warning("setSelectedItem is called without valid ListItem parameter on "+this);return;}if(this._bSelectionMode){e.setSelected((i===undefined)?true:!!i);F&&this._fireSelectionChangeEvent([e]);}};
t.prototype.getSelectedItems=function(){return this.getItems(true).filter(function(i){return i.getSelected();});};
t.prototype.setSelectedItemById=function(i,e){var x=C.byId(i);return this.setSelectedItem(x,e);};
t.prototype.getSelectedContexts=function(A){var B=this.getBindingInfo("items"),e=(B||{}).model,i=this.getModel(e);if(!B||!i){return[];}if(A&&this.getRememberSelections()){return this._aSelectedPaths.map(function(P){return i.getContext(P);});}return this.getSelectedItems().map(function(x){return x.getBindingContext(e);});};
t.prototype.removeSelections=function(A,F,e){var i=[];this._oSelectedItem=null;A&&(this._aSelectedPaths=[]);this.getItems(true).forEach(function(x){if(!x.getSelected()){return;}if(e&&x.isSelectedBoundTwoWay()){return;}x.setSelected(false,true);i.push(x);!A&&this._updateSelectedPaths(x);},this);if(F&&i.length){this._fireSelectionChangeEvent(i);}return this;};
t.prototype.selectAll=function(F){if(this.getMode()!="MultiSelect"||this.getMultiSelectMode()==M.ClearAll){return this;}var e=[];this.getItems(true).forEach(function(i){if(!i.getSelected()){i.setSelected(true,true);e.push(i);this._updateSelectedPaths(i);}},this);if(F&&e.length){this._fireSelectionChangeEvent(e,F);}return this;};
t.prototype.getLastMode=function(e){return this._sLastMode;};
t.prototype.setMode=function(e){e=this.validateProperty("mode",e);var O=this.getMode();if(O==e){return this;}this._bSelectionMode=e.indexOf("Select")>-1;if(!this._bSelectionMode){this.removeSelections(true);}else{var i=this.getSelectedItems();if(i.length>1){this.removeSelections(true);}else if(O===p.MultiSelect){this._oSelectedItem=i[0];}}return this.setProperty("mode",e);};
t.prototype.getGrowingInfo=function(){return this._oGrowingDelegate?this._oGrowingDelegate.getInfo():null;};
t.prototype.setRememberSelections=function(R){this.setProperty("rememberSelections",R,true);!this.getRememberSelections()&&(this._aSelectedPaths=[]);return this;};
t.prototype.setSelectedContextPaths=function(e){this._aSelectedPaths=e||[];};
t.prototype.getSelectedContextPaths=function(A){if(!A||(A&&this.getRememberSelections())){return this._aSelectedPaths.slice(0);}return this.getSelectedItems().map(function(i){return i.getBindingContextPath();});};
t.prototype.isAllSelectableSelected=function(){if(this.getMode()!=p.MultiSelect){return false;}var i=this.getItems(true),e=this.getSelectedItems().length,x=i.filter(function(y){return y.isSelectable();}).length;return(i.length>0)&&(e==x);};
t.prototype.getVisibleItems=function(){return this.getItems(true).filter(function(i){return i.getVisible();});};
t.prototype.getActiveItem=function(){return this._bActiveItem;};
t.prototype.onItemDOMUpdate=function(e){if(!this._bRendering&&this.bOutput){this._startItemNavigation(true);}var V=this.getVisibleItems().length>0;if(!V&&!this._bInvalidatedForNoData){this.invalidate();this._bInvalidatedForNoData=true;}else if(V&&this._bInvalidatedForNoData){this.invalidate();this._bInvalidatedForNoData=false;}};
t.prototype.onItemActiveChange=function(e,A){this._bActiveItem=A;};
t.prototype.onItemHighlightChange=function(i,N){this._iItemNeedsHighlight+=(N?1:-1);if(this._iItemNeedsHighlight==1&&N){this.$("listUl").addClass("sapMListHighlight");}else if(this._iItemNeedsHighlight==0){this.$("listUl").removeClass("sapMListHighlight");}};
t.prototype.onItemNavigatedChange=function(i,N){this._iItemNeedsNavigated+=(N?1:-1);if(this._iItemNeedsNavigated==1&&N){this.$("listUl").addClass("sapMListNavigated");}else if(this._iItemNeedsNavigated==0){this.$("listUl").removeClass("sapMListNavigated");}};
t.prototype.onItemSelectedChange=function(e,i){if(this.getMode()==p.MultiSelect){this._updateSelectedPaths(e,i);return;}if(i){this._aSelectedPaths=[];this._oSelectedItem&&this._oSelectedItem.setSelected(false,true);this._oSelectedItem=e;}else if(this._oSelectedItem===e){this._oSelectedItem=null;}this._updateSelectedPaths(e,i);};
t.prototype.getItemsContainerDomRef=function(){return this.getDomRef("listUl");};
t.prototype.getStickyFocusOffset=function(){return 0;};
t.prototype.checkGrowingFromScratch=function(){};
t.prototype.onBeforePageLoaded=function(e,i){this._fireUpdateStarted(i,e);this.fireGrowingStarted(e);};
t.prototype.onAfterPageLoaded=function(e,i){this._fireUpdateFinished(e);this.fireGrowingFinished(e);};
t.prototype.addNavSection=function(i){this._aNavSections.push(i);return i;};
t.prototype.getMaxItemsCount=function(){var B=this.getBinding("items");if(B&&B.getLength){return B.getLength()||0;}return this.getItems(true).length;};
t.prototype.shouldRenderItems=function(){return true;};
t.prototype.shouldGrowingSuppressInvalidation=function(){return true;};
t.prototype._resetItemsBinding=function(){if(this.isBound("items")){this._bUpdating=false;this._bReceivingData=false;this.removeSelections(true,false,true);this._oGrowingDelegate&&this._oGrowingDelegate.reset();this._hideBusyIndicator();if(this._oItemNavigation){this._oItemNavigation.iFocusedIndex=-1;}}};
t.prototype._updateStarted=function(R){if(!this._bReceivingData&&!this._bUpdating){this._bUpdating=true;this._fireUpdateStarted(R);}};
t.prototype._fireUpdateStarted=function(R,i){this._sUpdateReason=h(R||"Refresh");this.fireUpdateStarted({reason:this._sUpdateReason,actual:i?i.actual:this.getItems(true).length,total:i?i.total:this.getMaxItemsCount()});};
t.prototype.onThemeChanged=function(){if(this._oGrowingDelegate){this._oGrowingDelegate._updateTrigger();}};
t.prototype._updateFinished=function(){if(!this._bReceivingData&&this._bUpdating){this._fireUpdateFinished();this._bUpdating=false;}};
t.prototype._fireUpdateFinished=function(i){this._hideBusyIndicator();setTimeout(function(){this._bItemNavigationInvalidated=true;this.fireUpdateFinished({reason:this._sUpdateReason,actual:i?i.actual:this.getItems(true).length,total:i?i.total:this.getMaxItemsCount()});}.bind(this),0);};
t.prototype._showBusyIndicator=function(){if(this.getEnableBusyIndicator()&&!this.getBusy()&&!this._bBusy){this._bBusy=true;this._sBusyTimer=setTimeout(function(){this.$("nodata-text").text("");}.bind(this),this.getBusyIndicatorDelay());this.setBusy(true,"listUl");}};
t.prototype._hideBusyIndicator=function(){if(this._bBusy){this._bBusy=false;this.setBusy(false,"listUl");clearTimeout(this._sBusyTimer);if(!this.getItems(true).length){this.$("nodata-text").text(this.getNoDataText());}}};
t.prototype.setBusy=function(B,e){if(this.getBusy()==B){return this;}a.prototype.setBusy.apply(this,arguments);if(!B||!window.IntersectionObserver){clearTimeout(this._iBusyTimer);return this;}this._iBusyTimer=setTimeout(function(){var i=this.getDomRef(e);var A=this.getDomRef("busyIndicator");var x=l.getScrollDelegate(this,true);if(!i||!A||!x){return;}var y=new window.IntersectionObserver(function(E){y.disconnect();var z=E.pop();var R=z.intersectionRatio;if(R<=0||R>=1){return;}var F=A.firstChild.style;if(z.intersectionRect.height>=z.rootBounds.height){F.position="sticky";}else{F.top=((z.boundingClientRect.top<0?1-R:0)+(R/2))*100+"%";}},{root:x.getContainerDomRef()});y.observe(i);}.bind(this),this.getBusyIndicatorDelay());return this;};
t.prototype.onItemBindingContextSet=function(i){if(!this._bSelectionMode||!this.getRememberSelections()||!this.isBound("items")){return;}if(i.isSelectedBoundTwoWay()){return;}var P=i.getBindingContextPath();if(P){var e=(this._aSelectedPaths.indexOf(P)>-1);i.setSelected(e);}};
t.prototype.onItemInserted=function(i,e){if(e){this.onItemSelectedChange(i,true);}if(!this._bSelectionMode||!this._aSelectedPaths.length||!this.getRememberSelections()||!this.isBound("items")||i.isSelectedBoundTwoWay()||i.getSelected()){return;}var P=i.getBindingContextPath();if(P&&this._aSelectedPaths.indexOf(P)>-1){i.setSelected(true);}};
t.prototype.onItemSelect=function(e,x){var y=this.getMode();if(this._mRangeSelection){if(!this._mRangeSelection.selected){this._fireSelectionChangeEvent([e]);this._mRangeSelection.index=this.getVisibleItems().indexOf(e);this._mRangeSelection.selected=x;return;}if(!x){e.setSelected(true);return;}var z=this.indexOfItem(e),A=this.getItems(),B,E,F=[],H;if(z<this._mRangeSelection.index){B=this._mRangeSelection.index-z;H=-1;}else{B=z-this._mRangeSelection.index;H=1;}for(var i=1;i<=B;i++){E=A[this._mRangeSelection.index+(i*H)];if(E.isSelectable()&&E.getVisible()&&!E.getSelected()){E.setSelected(true);F.push(E);}else if(E===e){F.push(E);}}this._fireSelectionChangeEvent(F);return;}if(y===p.MultiSelect){this._fireSelectionChangeEvent([e]);}else if(this._bSelectionMode&&x){this._fireSelectionChangeEvent([e]);}};
t.prototype._fireSelectionChangeEvent=function(e,i){var x=e&&e[0];if(!x){return;}this.fireSelectionChange({listItem:x,listItems:e,selected:x.getSelected(),selectAll:!!i});if(this.getGrowing()){this._bSelectAll=i;}this.fireSelect({listItem:x});};
t.prototype.onItemDelete=function(e){this.fireDelete({listItem:e});};
t.prototype.onItemPress=function(e,i){if(e.getType()==k.Inactive){return;}setTimeout(function(){this.fireItemPress({listItem:e,srcControl:i});}.bind(this),0);};
t.prototype.onItemKeyDown=function(i,e){if(!e.shiftKey||e.ctrlKey||e.altKey||e.metaKey||this.getMode()!==p.MultiSelect||!i.isSelectable()||e.which===K.F6){if(this._mRangeSelection){this._mRangeSelection=null;}return;}var V=this.getVisibleItems(),H=V.some(function(x){return!!x.getSelected();});if(!H){return;}if(!this._mRangeSelection){this._mRangeSelection={index:this.indexOfItem(i),selected:i.getSelected()};}};
t.prototype.onItemKeyUp=function(i,e){if(e.which===K.SHIFT){this._mRangeSelection=null;}};
t.prototype._updateSelectedPaths=function(i,e){if(!this.getRememberSelections()||!this.isBound("items")){return;}var P=i.getBindingContextPath();if(!P){return;}e=(e===undefined)?i.getSelected():e;var x=this._aSelectedPaths.indexOf(P);if(e){x<0&&this._aSelectedPaths.push(P);}else{x>-1&&this._aSelectedPaths.splice(x,1);}};
t.prototype._destroyGrowingDelegate=function(){if(this._oGrowingDelegate){this._oGrowingDelegate.destroy();this._oGrowingDelegate=null;}};
t.prototype._destroyItemNavigation=function(){if(this._oItemNavigation){this.removeEventDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}};
t.prototype._getTouchBlocker=function(){return this.$().children();};
t.prototype._getSwipeContainer=function(){if(!this._$swipeContainer){this._$swipeContainer=q("<div>",{"id":this.getId("swp"),"class":"sapMListSwp"});}return this._$swipeContainer;};
t.prototype._setSwipePosition=function(){if(this._isSwipeActive){return this._getSwipeContainer().css("top",this._swipedItem.$().position().top);}};
t.prototype._renderSwipeContent=function(){var $=this._swipedItem.$(),e=this._getSwipeContainer();this.$().prepend(e.css({top:$.position().top,height:$.outerHeight(true)}));if(this._bRerenderSwipeContent){this._bRerenderSwipeContent=false;var i=C.createRenderManager();i.render(this.getSwipeContent(),e.empty()[0]);i.destroy();}return this;};
t.prototype._swipeIn=function(){var i=this,$=i._getTouchBlocker(),x=i._getSwipeContainer();i._isSwipeActive=true;i._renderSwipeContent();c.addPopoverInstance(i);window.document.activeElement.blur();q(window).on("resize.swp",function(){i._setSwipePosition();});$.css("pointer-events","none").on("touchstart.swp mousedown.swp",function(e){if(!x[0].firstChild.contains(e.target)){e.preventDefault();e.stopPropagation();}});x.on("webkitAnimationEnd animationend",function(){q(this).off("webkitAnimationEnd animationend");x.css("opacity",1).trigger("focus");$.parent().on("touchend.swp touchcancel.swp mouseup.swp",function(e){if(!x[0].firstChild.contains(e.target)){i.swipeOut();}});}).removeClass("sapMListSwpOutAnim").addClass("sapMListSwpInAnim");};
t.prototype._onSwipeOut=function(e){this._getSwipeContainer().css("opacity",0).remove();q(window).off("resize.swp");this._getTouchBlocker().css("pointer-events","auto").off("touchstart.swp mousedown.swp");if(typeof e=="function"){e.call(this,this._swipedItem,this.getSwipeContent());}this._isSwipeActive=false;c.removePopoverInstance(this);};
t.prototype.swipeOut=function(e){if(!this._isSwipeActive){return this;}var i=this,$=this._getSwipeContainer();this._getTouchBlocker().parent().off("touchend.swp touchend.swp touchcancel.swp mouseup.swp");$.on("webkitAnimationEnd animationend",function(){q(this).off("webkitAnimationEnd animationend");i._onSwipeOut(e);}).removeClass("sapMListSwpInAnim").addClass("sapMListSwpOutAnim");return this;};
t.prototype._removeSwipeContent=function(){if(this._isSwipeActive){this.swipeOut()._onSwipeOut();}};
t.prototype.close=t.prototype._removeSwipeContent;
t.prototype._onSwipe=function(e,i){var x=this.getSwipeContent(),y=e.srcControl;if(x&&y&&!this._isSwipeActive&&this!==y&&!this._eventHandledByControl&&D.support.touch){for(var z=y;z&&!(z instanceof f);z=z.oParent);if(z instanceof f){this._swipedItem=z;this.fireSwipe({listItem:this._swipedItem,swipeContent:x,srcControl:y,swipeDirection:i},true)&&this._swipeIn();}}};
t.prototype.ontouchstart=function(e){this._eventHandledByControl=e.isMarked();};
t.prototype.onswipeleft=function(e){var R=C.getConfiguration().getRTL();var i=R?S.EndToBegin:S.BeginToEnd;var x=this.getSwipeDirection();if(x===S.LeftToRight){x=S.BeginToEnd;}else if(x===S.RightToLeft){x=S.EndToBegin;}if(x!=i){if(x==S.Both){x=R?S.BeginToEnd:S.EndToBegin;}this._onSwipe(e,x);}};
t.prototype.onswiperight=function(e){var R=C.getConfiguration().getRTL();var i=R?S.BeginToEnd:S.EndToBegin;var x=this.getSwipeDirection();if(x===S.LeftToRight){x=S.BeginToEnd;}else if(x===S.RightToLeft){x=S.EndToBegin;}if(x!=i){if(x==S.Both){x=R?S.EndToBegin:S.BeginToEnd;}this._onSwipe(e,x);}};
t.prototype.setSwipeDirection=function(e){return this.setProperty("swipeDirection",e,true);};
t.prototype.getSwipedItem=function(){return(this._isSwipeActive?this._swipedItem:null);};
t.prototype.setSwipeContent=function(e){this._bRerenderSwipeContent=true;this.toggleStyleClass("sapMListSwipable",!!e);return this.setAggregation("swipeContent",e,!this._isSwipeActive);};
t.prototype.invalidate=function(O){if(O&&O===this.getSwipeContent()){this._bRerenderSwipeContent=true;this._isSwipeActive&&this._renderSwipeContent();return;}return a.prototype.invalidate.apply(this,arguments);};
t.prototype.addItemGroup=function(e,H,i){if(!H){H=new d();H.setTitle(e.text||e.key);}H._bGroupHeader=true;this.addAggregation("items",H,i);return H;};
t.prototype.removeGroupHeaders=function(e){this.getItems(true).forEach(function(i){if(i.isGroupHeader()){i.destroy(e);}});};
t.prototype.getAccessibilityType=function(){return C.getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_LIST");};
t.prototype.getAccessibilityStates=function(){if(!this.getItems(true).length){return"";}var e="",i=p,x=this.getMode(),B=C.getLibraryResourceBundle("sap.m");if(L.isRequired(this)){e+=B.getText("LIST_REQUIRED")+" ";}if(x==i.MultiSelect){e+=B.getText("LIST_MULTISELECTABLE")+" . ";}else if(x==i.Delete){e+=B.getText("LIST_DELETABLE")+" . ";}else if(x!=i.None){e+=B.getText("LIST_SELECTABLE")+" . ";}if(this.isGrouped()){e+=B.getText("LIST_GROUPED")+" . ";}return e;};
t.prototype.getAccessibilityInfo=function(){return{description:this.getAccessibilityStates().trim(),focusable:true};};
t.prototype.getAccessbilityPosition=function(i){var e=0,x=this.getVisibleItems(),P=x.indexOf(i)+1,B=this.getBinding("items");if(this.getGrowing()&&this.getGrowingScrollToLoad()&&B&&B.isLengthFinal()){e=B.getLength();if(B.isGrouped()){e+=x.filter(function(i){return i.isGroupHeader()&&i.getVisible();}).length;}}else{e=x.length;}return{setSize:e,posInset:P};};
t.prototype.onItemFocusIn=function(i,F){this._handleStickyItemFocus(i.getDomRef());if(i!==F||!C.getConfiguration().getAccessibility()){return;}var e=i.getDomRef(),P=this.getAccessbilityPosition(i);if(!i.getContentAnnouncement){this.getNavigationRoot().setAttribute("aria-activedescendant",e.id);e.setAttribute("aria-posinset",P.posInset);e.setAttribute("aria-setsize",P.setSize);}else{var A=i.getAccessibilityInfo(),B=C.getLibraryResourceBundle("sap.m"),x=A.type+" . ";if(!D.browser.chrome||this.isA("sap.m.Table")){x+=B.getText("LIST_ITEM_POSITION",[P.posInset,P.setSize])+" . ";}else{e.setAttribute("aria-posinset",P.posInset);e.setAttribute("aria-setsize",P.setSize);}x+=A.description;this.updateInvisibleText(x,e);return x;}};
t.prototype.updateInvisibleText=function(T,i,P){var e=t.getInvisibleText(),F=q(i||document.activeElement);if(this.bAnnounceDetails){this.bAnnounceDetails=false;T=this.getAccessibilityInfo().description+" "+T;}e.setText(T.trim());F.addAriaLabelledBy(e.getId(),P);};
t.prototype.getNavigationRoot=function(){return this.getDomRef("listUl");};
t.prototype.getFocusDomRef=function(){return this.getNavigationRoot();};
t.prototype._startItemNavigation=function(i){if(!D.system.desktop){return;}var e=this.getDomRef();if(!this.getShowNoData()&&!this.getVisibleItems().length&&e){e.classList.add("sapMListPreventFocus");this._destroyItemNavigation();return;}if(e){e.classList.remove("sapMListPreventFocus");}var x=this.getKeyboardMode(),y=m;if(x==y.Edit&&!this.getItems(true).length){return;}var N=this.getNavigationRoot();var T=(x==y.Edit)?-1:0;if(i&&N&&!N.contains(document.activeElement)){this._bItemNavigationInvalidated=true;if(!N.getAttribute("tabindex")){N.tabIndex=T;}return;}if(!this._oItemNavigation){this._oItemNavigation=new b();this._oItemNavigation.setCycling(false);this.addDelegate(this._oItemNavigation);this._setItemNavigationTabIndex(T);this._oItemNavigation.setTableMode(true,true).setColumns(1);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});}this._oItemNavigation.setPageSize(this.getGrowingThreshold());this._oItemNavigation.setRootDomRef(N);this.setNavigationItems(this._oItemNavigation,N);this._bItemNavigationInvalidated=false;};
t.prototype.setNavigationItems=function(i,N){var e=q(N).children(".sapMLIB").get();i.setItemDomRefs(e);if(i.getFocusedIndex()==-1){if(this.getGrowing()&&this.getGrowingDirection()==n.Upwards){i.setFocusedIndex(e.length-1);}else{i.setFocusedIndex(0);}}};
t.prototype.getItemNavigation=function(){return this._oItemNavigation;};
t.prototype._setItemNavigationTabIndex=function(T){if(this._oItemNavigation){this._oItemNavigation.iActiveTabIndex=T;this._oItemNavigation.iTabIndex=T;}};
t.prototype.setKeyboardMode=function(e){this.setProperty("keyboardMode",e,true);if(this.isActive()){var T=(e==m.Edit)?-1:0;this.$("nodata").prop("tabIndex",~T);this.$("listUl").prop("tabIndex",T);this.$("after").prop("tabIndex",T);this._setItemNavigationTabIndex(T);}return this;};
t.prototype.setItemFocusable=function(e){if(!this._oItemNavigation){return;}var i=this._oItemNavigation.getItemDomRefs();var x=i.indexOf(e.getDomRef());if(x>=0){this._oItemNavigation.setFocusedIndex(x);}};
t.prototype.forwardTab=function(F){this._bIgnoreFocusIn=true;this.$(F?"after":"before").trigger("focus");};
t.prototype.onsaptabnext=function(e){if(e.isMarked()||this.getKeyboardMode()==m.Edit){return;}if(e.target.id==this.getId("nodata")){this.forwardTab(true);e.setMarked();}};
t.prototype.onsaptabprevious=function(e){if(e.isMarked()||this.getKeyboardMode()==m.Edit){return;}var T=e.target.id;if(T==this.getId("nodata")){this.forwardTab(false);}else if(T==this.getId("trigger")){this.focusPrevious();e.preventDefault();}};
t.prototype._navToSection=function(F){var T;var i=0;var e=F?1:-1;var x=this._aNavSections.length;this._aNavSections.some(function(z,A){var B=(z?window.document.getElementById(z):null);if(B&&B.contains(document.activeElement)){i=A;return true;}});var y=this.getItemsContainerDomRef();var $=q(document.getElementById(this._aNavSections[i]));if($[0]===y&&this._oItemNavigation){$.data("redirect",this._oItemNavigation.getFocusedIndex());}this._aNavSections.some(function(){i=(i+e+x)%x;T=q(document.getElementById(this._aNavSections[i]));if(T[0]===y&&this._oItemNavigation){var R=T.data("redirect");var z=this._oItemNavigation.getItemDomRefs();var A=z[R]||y.children[0];T=q(A);}if(T.is(":focusable")){T.trigger("focus");return true;}},this);return T;};
t.prototype.onsapshow=function(e){if(e.isMarked()||e.which==K.F4||e.target.id!=this.getId("trigger")&&!q(e.target).hasClass(this.sNavItemClass)){return;}if(this._navToSection(true)){e.preventDefault();e.setMarked();}};
t.prototype.onsaphide=function(e){if(e.isMarked()||e.target.id!=this.getId("trigger")&&!q(e.target).hasClass(this.sNavItemClass)){return;}if(this._navToSection(false)){e.preventDefault();e.setMarked();}};
t.prototype.onkeydown=function(e){var i=(e.which==K.A)&&(e.metaKey||e.ctrlKey);if(e.isMarked()||!i||!q(e.target).hasClass(this.sNavItemClass)){return;}var x=this.getMultiSelectMode();var y=i&&e.shiftKey&&x==M.ClearAll;if(y){e.preventDefault();e.setMarked();this.removeSelections(false,true);return;}e.preventDefault();if(this.getMode()!==p.MultiSelect||x===M.ClearAll){return;}if(this.isAllSelectableSelected()){this.removeSelections(false,true);}else{this.selectAll(true);}e.setMarked();};
t.prototype.onmousedown=function(e){if(this._bItemNavigationInvalidated){this._startItemNavigation();}if(e.shiftKey&&this._mRangeSelection&&e.srcControl.getId().includes("-selectMulti")){e.preventDefault();}};
t.prototype.focusPrevious=function(){if(!this._oItemNavigation){return;}var N=this._oItemNavigation.getItemDomRefs();var i=this._oItemNavigation.getFocusedIndex();var $=q(N[i]);var R=$.control(0)||{};var T=R.getTabbables?R.getTabbables():$.find(":sapTabbable");var F=T.eq(-1).add($).eq(-1);this.bAnnounceDetails=true;F.trigger("focus");};
t.prototype.onfocusin=function(e){if(this._bIgnoreFocusIn){this._bIgnoreFocusIn=false;e.stopImmediatePropagation(true);return;}if(this._bItemNavigationInvalidated){this._startItemNavigation();}var T=e.target;if(T.id==this.getId("nodata")){this.updateInvisibleText(this.getNoDataText(),T);}if(e.isMarked()||!this._oItemNavigation||this.getKeyboardMode()==m.Edit||T.id!=this.getId("after")){return;}this.focusPrevious();e.setMarked();};
t.prototype.onsapfocusleave=function(e){if(this._oItemNavigation&&!this.bAnnounceDetails&&!this.getNavigationRoot().contains(document.activeElement)){this.bAnnounceDetails=true;}};
t.prototype.onItemArrowUpDown=function(e,E){var i=this.getItems(true),x=i.indexOf(e)+(E.type=="sapup"?-1:1),y=i[x];if(y&&y.isGroupHeader()){y=i[x+(E.type=="sapup"?-1:1)];}if(!y){return;}var T=y.getTabbables(),F=e.getTabbables().index(E.target),$=T.eq(T[F]?F:-1);$[0]?$.trigger("focus"):y.focus();E.preventDefault();E.setMarked();};
t.prototype.onItemContextMenu=function(e,E){var i=this.getContextMenu();if(!i){return;}var x=this.fireBeforeOpenContextMenu({listItem:e,column:C.byId(q(E.target).closest(".sapMListTblCell",this.getNavigationRoot()).attr("data-sap-ui-column"))});if(x){E.setMarked();E.preventDefault();var B,y=this.getBindingInfo("items");if(y){B=e.getBindingContext(y.model);i.setBindingContext(B,y.model);}i.openAsContextMenu(E,e);}};
t.prototype.onItemUpDownModifiers=function(i,e,x){if(!this._mRangeSelection){return;}var V=this.getVisibleItems(),y=V.indexOf(i),z=V[y+x];if(!z){if(this._mRangeSelection){this._mRangeSelection=null;}e.setMarked();return;}var A=z.getSelected();if(this._mRangeSelection.direction===undefined){this._mRangeSelection.direction=x;}else if(this._mRangeSelection.direction!==x){if(this._mRangeSelection.index!==V.indexOf(i)){z=i;A=z.getSelected();if(this._mRangeSelection.selected&&A){this.setSelectedItem(z,false,true);return;}}else{this._mRangeSelection.direction=x;}}if(this._mRangeSelection.selected!==A&&z.isSelectable()){this.setSelectedItem(z,this._mRangeSelection.selected,true);}};
t.prototype.isGrouped=function(){var B=this.getBinding("items");return B&&B.isGrouped();};
t.prototype.setContextMenu=function(e){this.setAggregation("contextMenu",e,true);return this;};
t.prototype.destroyContextMenu=function(){this.destroyAggregation("contextMenu",true);return this;};
t.prototype.getStickyStyleValue=function(){var e=this.getSticky();if(!e||!e.length){this._iStickyValue=0;return this._iStickyValue;}var i=0,H=this.getHeaderText(),x=this.getHeaderToolbar(),y=H||(x&&x.getVisible()),z=this.getInfoToolbar(),A=z&&z.getVisible(),B=false;if(this.isA("sap.m.Table")){B=this.getColumns().some(function(E){return E.getVisible()&&E.getHeader();});}e.forEach(function(E){if(E===s.HeaderToolbar&&y){i+=1;}else if(E===s.InfoToolbar&&A){i+=2;}else if(E===s.ColumnHeaders&&B){i+=4;}});this._iStickyValue=i;return this._iStickyValue;};
t.prototype._handleStickyItemFocus=function(i){if(!this._iStickyValue){return;}var e=l.getScrollDelegate(this,true);if(!e){return;}var T=0,x=0,y=0,z=0,H=0,A=0,B=this.getStickyFocusOffset();if(this._iStickyValue&4){var E=this.getDomRef("tblHeader").firstChild;var F=E.getBoundingClientRect();x=parseInt(F.bottom);T=parseInt(F.height);}if(this._iStickyValue&2){var J=this.getDomRef().querySelector(".sapMListInfoTBarContainer");if(J){var N=J.getBoundingClientRect();z=parseInt(N.bottom);y=parseInt(N.height);}}if(this._iStickyValue&1){var O=this.getDomRef().querySelector(".sapMListHdr");if(O){var P=O.getBoundingClientRect();A=parseInt(P.bottom);H=parseInt(P.height);}}var Q=Math.round(i.getBoundingClientRect().top);if(x>Q||z>Q||A>Q){window.requestAnimationFrame(function(){e.scrollToElement(i,0,[0,-T-y-H-B]);});}};
t.prototype.setHeaderToolbar=function(H){return this._setToolbar("headerToolbar",H);};
t.prototype.setInfoToolbar=function(i){return this._setToolbar("infoToolbar",i);};
t.prototype.scrollToIndex=function(i){return new Promise(function(e,x){var y,z;z=l.getScrollDelegate(this,true);if(!z){return x();}y=w(this,i);if(!y){return x();}setTimeout(function(){z.scrollToElement(y.getDomRef(),null,[0,this._getStickyAreaHeight()*-1]);return e();}.bind(this),0);}.bind(this));};
t.prototype.requestItems=function(i){if(i<=0||!this.getGrowing()||!this._oGrowingDelegate){throw new Error("The prerequisites to use 'requestItems' are not met. Please read the documentation for more details.");}if(i!=null){var O=this.getGrowingThreshold();this.setGrowingThreshold(i);this._oGrowingDelegate.requestNewPage();this.setGrowingThreshold(O);}else{this._oGrowingDelegate.requestNewPage();}};
function w(e,i){var x=e.getVisibleItems();var R=x.length;if(typeof i!=='number'||i<-1){i=0;}if(i>=R||i===-1){i=R-1;}return x[i];}
t.prototype._setFocus=function(i,F){return new Promise(function(e,x){var y=w(this,i);if(!y){return x();}if(F===true){var $=y.getTabbables();if($.length){$[0].focus();return e();}}y.focus();return e();}.bind(this));};
t.prototype._getStickyAreaHeight=function(){var e=this.getSticky();if(!(e&&e.length)){return 0;}return e.reduce(function(i,x){var y,z;switch(x){case s.HeaderToolbar:y=this.getHeaderToolbar();z=y&&y.getDomRef()||this.getDomRef("header");break;case s.InfoToolbar:y=this.getInfoToolbar();z=y&&y.getDomRef();break;case s.ColumnHeaders:z=this.getDomRef("tblHeader");break;default:}return i+(z?z.offsetHeight:0);}.bind(this),0);};
t.prototype._setToolbar=function(A,T){var O=this.getAggregation(A);if(O){O.detachEvent("_change",this._onToolbarPropertyChanged,this);}this.setAggregation(A,T);if(T){T.attachEvent("_change",this._onToolbarPropertyChanged,this);}return this;};
t.prototype._onToolbarPropertyChanged=function(e){if(e.getParameter("name")!=="visible"){return;}var O=this._iStickyValue,N=this.getStickyStyleValue();if(O!==N){var i=this.getDomRef();if(i){var x=i.classList;x.toggle("sapMSticky",!!N);x.remove("sapMSticky"+O);x.toggle("sapMSticky"+N,!!N);}}};
return t;});
sap.ui.predefine('sap/m/ListBaseRenderer',["sap/m/library","sap/ui/Device","sap/ui/core/InvisibleText","./ListItemBaseRenderer"],function(l,D,I,L){"use strict";var a=l.ListGrowingDirection;var b=l.ListKeyboardMode;var T=l.ToolbarDesign;var c={apiVersion:2};c.ModeOrder={None:0,Delete:1,MultiSelect:-1,SingleSelect:1,SingleSelectLeft:-1,SingleSelectMaster:0};
c.render=function(r,C){r.openStart("div",C);r.class("sapMList");if(C.getInset()){r.class("sapMListInsetBG");}r.style("width",C.getWidth());if(C.getBackgroundDesign){r.class("sapMListBG"+C.getBackgroundDesign());}var t=C.getTooltip_AsString();if(t){r.attr("title",t);}var s=C.getStickyStyleValue();if(s){r.class("sapMSticky");r.class("sapMSticky"+s);}this.renderContainerAttributes(r,C);r.openEnd();r.renderControl(C.getAggregation("_messageStrip"));var h=C.getHeaderText();var H=C.getHeaderToolbar();if(H){H.setDesign(T.Transparent,true);H.addStyleClass("sapMListHdr");H.addStyleClass("sapMListHdrTBar");H.addStyleClass("sapMTBHeader-CTX");r.renderControl(H);}else if(h){r.openStart("header",C.getId("header"));r.class("sapMListHdr").class("sapMListHdrText").openEnd();r.text(h);r.close("header");}var o=C.getInfoToolbar();if(o){o.setDesign(T.Info,true);o.addStyleClass("sapMListInfoTBar");r.openStart("div").class("sapMListInfoTBarContainer").openEnd();r.renderControl(o);r.close("div");}var d=C.getItems(),S=C.getShowNoData(),R=C.shouldRenderItems()&&d.length,e=C.getKeyboardMode()==b.Edit?-1:0,u=C.getGrowingDirection()==a.Upwards&&C.getGrowing();if(u){this.renderGrowing(r,C);}this.renderDummyArea(r,C,"before",-1);this.renderListStartAttributes(r,C);r.class("sapMListUl");if(C._iItemNeedsHighlight){r.class("sapMListHighlight");}if(R||S){r.attr("tabindex",e);}r.class("sapMListShowSeparators"+C.getShowSeparators());r.class("sapMListMode"+C.getMode());if(C._iItemNeedsNavigated){r.class("sapMListNavigated");}r.openEnd();this.renderListHeadAttributes(r,C);if(R){if(u){d.reverse();}for(var i=0;i<d.length;i++){r.renderControl(d[i]);}}var v=C.getVisibleItems().length>0;if(S&&(!R||!v)){this.renderNoData(r,C);}this.renderListEndAttributes(r,C);this.renderDummyArea(r,C,"after",e);if(!u){this.renderGrowing(r,C);}if(C.getFooterText()){r.openStart("footer",C.getId("footer")).class("sapMListFtr").openEnd();r.text(C.getFooterText());r.close("footer");}r.close("div");};
c.renderContainerAttributes=function(r,C){};
c.renderListHeadAttributes=function(r,C){};
c.renderListStartAttributes=function(r,C){r.openStart("ul",C.getId("listUl"));r.class("sapMListItems");C.addNavSection(C.getId("listUl"));r.accessibilityState(C,this.getAccessibilityState(C));};
c.getAriaRole=function(C){return"listbox";};
c.getNoDataAriaRole=function(){return null;};
c.getAriaLabelledBy=function(C){var h=C.getHeaderToolbar();if(h){var t=h.getTitleControl();if(t){var s=t.getId();if(C.getAriaLabelledBy().indexOf(s)===-1){return s;}}}else if(C.getHeaderText()){return C.getId("header");}};
c.getAriaDescribedBy=function(C){if(C.getFooterText()){return C.getId("footer");}};
c.getAccessibilityState=function(C){var r=this.getAriaRole(C);return{role:r,multiselectable:(r&&C._bSelectionMode)?C.getMode()=="MultiSelect":undefined,labelledby:{value:this.getAriaLabelledBy(C),append:true},describedby:{value:this.getAriaDescribedBy(C),append:true}};};
c.renderListEndAttributes=function(r,C){r.close("ul");};
c.renderNoData=function(r,C){r.openStart("li",C.getId("nodata"));r.attr("tabindex",C.getKeyboardMode()==b.Navigation?-1:0);var A=this.getNoDataAriaRole();if(A){r.attr("role",A);}r.class("sapMLIB").class("sapMListNoData").class("sapMLIBTypeInactive");L.addFocusableClasses.call(L,r);r.openEnd();r.openStart("div",C.getId("nodata-text")).class("sapMListNoDataText").openEnd();r.text(C.getNoDataText(true));r.close("div");r.close("li");};
c.renderDummyArea=function(r,C,A,t){r.openStart("div",C.getId(A)).attr("tabindex",t);if(D.system.desktop){r.class("sapMListDummyArea");if(A=="after"){r.class("sapMListDummyAreaSticky");}}r.openEnd().close("div");};
c.renderGrowing=function(r,C){var g=C._oGrowingDelegate;if(g){g.render(r);}};
c.getAriaAnnouncement=function(B){return I.getStaticId("sap.m",B);};
return c;},true);
sap.ui.predefine('sap/m/ListItemBase',["sap/ui/base/DataType","sap/ui/events/KeyCodes","sap/ui/model/BindingMode","sap/ui/Device","sap/ui/core/library","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/core/Icon","sap/ui/core/InvisibleText","sap/ui/core/theming/Parameters","./library","./Button","./CheckBox","./RadioButton","./ListItemBaseRenderer","sap/base/strings/capitalize","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Selectors"],function(D,K,B,a,c,C,I,b,d,T,l,e,f,R,L,g,q){"use strict";var h=l.ListKeyboardMode;var i=l.ListMode;var j=l.ListType;var k=l.ButtonType;var M=c.MessageType;
var m=C.extend("sap.m.ListItemBase",{metadata:{library:"sap.m",properties:{type:{type:"sap.m.ListType",group:"Misc",defaultValue:j.Inactive},visible:{type:"boolean",group:"Appearance",defaultValue:true},unread:{type:"boolean",group:"Misc",defaultValue:false},selected:{type:"boolean",defaultValue:false},counter:{type:"int",group:"Misc",defaultValue:null},highlight:{type:"string",group:"Appearance",defaultValue:"None"},highlightText:{type:"string",group:"Misc",defaultValue:""},navigated:{type:"boolean",group:"Appearance",defaultValue:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tap:{deprecated:true},detailTap:{deprecated:true},press:{},detailPress:{}},designtime:"sap/m/designtime/ListItemBase.designtime"}});
m.getAccessibilityText=function(o,n){var p=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(!o||!o.getVisible||!o.getVisible()){return n?p.getText("CONTROL_EMPTY"):"";}var A;if(o.getAccessibilityInfo){A=o.getAccessibilityInfo();}if(!A||!o.getAccessibilityInfo){A=this.getDefaultAccessibilityInfo(o.getDomRef());}A=q.extend({type:"",description:"",children:[]},A);var t=A.type+" "+A.description+" ",s=o.getTooltip_AsString();if(A.enabled===false){t+=p.getText("CONTROL_DISABLED")+" ";}if(A.editable===false){t+=p.getText("CONTROL_READONLY")+" ";}if(!A.type&&s&&t.indexOf(s)==-1){t=s+" "+t;}A.children.forEach(function(r){t+=m.getAccessibilityText(r)+" ";});t=t.trim();if(n&&!t){t=p.getText("CONTROL_EMPTY");}return t;};
m.getDefaultAccessibilityInfo=function(o){if(!o){return null;}var t=[],N=window.Node,n=window.NodeFilter,p=document.createTreeWalker(o,n.SHOW_TEXT+n.SHOW_ELEMENT);while(p.nextNode()){var r=p.currentNode;if(r.nodeType===N.TEXT_NODE){var s=(r.nodeValue||"").trim();if(s){t.push(s);}}}return{description:t.join(" ")};};
m.prototype.DetailIconURI=I.getIconURI("edit");m.prototype.NavigationIconURI=I.getIconURI("slim-arrow-right");m.prototype.TagName="li";
m.prototype.init=function(){this._active=false;this._bGroupHeader=false;this._bNeedsHighlight=false;this._bNeedsNavigated=false;};
m.prototype.onAfterRendering=function(){this.informList("DOMUpdate",true);this._checkHighlight();this._checkNavigated();};
m.prototype.invalidate=function(){if(!this.bOutput){return;}C.prototype.invalidate.apply(this,arguments);};
m.prototype.getBindingContextPath=function(s){var o=this.getList();if(o&&!s){s=(o.getBindingInfo("items")||{}).model;}var n=this.getBindingContext(s);if(n){return n.getPath();}};
m.prototype.isSelectedBoundTwoWay=function(){var o=this.getBinding("selected");if(o&&o.getBindingMode()==B.TwoWay){return true;}};
m.prototype.getList=function(){var p=this.getParent();if(p&&p.isA("sap.m.ListBase")){return p;}};
m.prototype.getListProperty=function(p,F){var o=this.getList();if(o){p=g(p);return o["get"+p]();}return F;};
m.prototype.informList=function(E,p,P){var o=this.getList();if(o){var s="onItem"+E;if(o[s]){o[s](this,p,P);}}};
m.prototype.informSelectedChange=function(s){var o=this.getList();if(o){o.onItemSelectedChange(this,s);this.bSelectedDelayed=undefined;}else{this.bSelectedDelayed=s;}};
m.prototype.getAccessibilityType=function(o){return o.getText("ACC_CTR_TYPE_OPTION");};
m.prototype.getGroupAnnouncement=function(){return this.$().prevAll(".sapMGHLI:first").text();};
m.prototype.getAccessibilityDescription=function(o){var O=[],t=this.getType(),H=this.getHighlight(),s=this.getTooltip_AsString();if(this.getSelected()){O.push(o.getText("LIST_ITEM_SELECTED"));}if(H!==M.None){var n=this.getHighlightText();if(H in M&&!n){n=o.getText("LIST_ITEM_STATE_"+H.toUpperCase());}O.push(n);}if(this.getUnread()&&this.getListProperty("showUnread")){O.push(o.getText("LIST_ITEM_UNREAD"));}if(this.getCounter()){O.push(o.getText("LIST_ITEM_COUNTER",this.getCounter()));}if(t==j.Navigation){O.push(o.getText("LIST_ITEM_NAVIGATION"));}else{if(t==j.Detail||t==j.DetailAndActive){O.push(o.getText("LIST_ITEM_DETAIL"));}if(t==j.Active||t==j.DetailAndActive){O.push(o.getText("LIST_ITEM_ACTIVE"));}}var G=this.getGroupAnnouncement()||"";if(G){O.push(G);}if(this.getContentAnnouncement){O.push((this.getContentAnnouncement(o)||"").trim());}if(s){O.push(s);}if(this._bAnnounceNotSelected&&this.isSelectable()&&!this.getSelected()){O.push(o.getText("LIST_ITEM_NOT_SELECTED"));}return O.join(" . ");};
m.prototype.getAccessibilityInfo=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{type:this.getAccessibilityType(o),description:this.getAccessibilityDescription(o),focusable:true};};
m.prototype.getMode=function(){return this.getListProperty("mode","");};
m.prototype.updateAccessibilityState=function(A){var t=this.$();if(!t.length){return;}var $=t.parent().children(".sapMLIB");t.attr(q.extend({"aria-setsize":$.length,"aria-posinset":$.index(t)+1},A));};
m.prototype.getDeleteControl=function(n){if(!n||this._oDeleteControl){return this._oDeleteControl;}if(!this.DeleteIconURI){m.prototype.DeleteIconURI=I.getIconURI(T.get({name:"_sap_m_ListItemBase_DeleteIcon"})||"decline");}this._oDeleteControl=new e({id:this.getId()+"-imgDel",icon:this.DeleteIconURI,type:k.Transparent,tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LIST_ITEM_DELETE")}).addStyleClass("sapMLIBIconDel sapMLIBSelectD").setParent(this,null,true).attachPress(function(E){this.informList("Delete");},this);this._oDeleteControl._bExcludeFromTabChain=true;this._oDeleteControl.useEnabledPropagator(false);return this._oDeleteControl;};
m.prototype.onThemeChanged=function(){m.prototype.DeleteIconURI=I.getIconURI(T.get({name:"_sap_m_ListItemBase_DeleteIcon"}));if(this._oDeleteControl){this._oDeleteControl.setIcon(this.DeleteIconURI);}};
m.prototype.getDetailControl=function(n){if(!n||this._oDetailControl){return this._oDetailControl;}this._oDetailControl=new e({id:this.getId()+"-imgDet",icon:this.DetailIconURI,type:k.Transparent,tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LIST_ITEM_EDIT")}).addStyleClass("sapMLIBType sapMLIBIconDet").setParent(this,null,true).attachPress(function(){this.fireDetailTap();this.fireDetailPress();},this);this._oDetailControl._bExcludeFromTabChain=true;this._oDetailControl.useEnabledPropagator(false);return this._oDetailControl;};
m.prototype.getNavigationControl=function(n){if(!n||this._oNavigationControl){return this._oNavigationControl;}this._oNavigationControl=new b({id:this.getId()+"-imgNav",src:this.NavigationIconURI,useIconTooltip:false,noTabStop:true}).setParent(this,null,true).addStyleClass("sapMLIBType sapMLIBImgNav");return this._oNavigationControl;};
m.prototype.getSingleSelectControl=function(n){if(!n||this._oSingleSelectControl){n&&this._oSingleSelectControl.setSelected(this.getSelected());return this._oSingleSelectControl;}this._oSingleSelectControl=new R({id:this.getId()+"-selectSingle",groupName:this.getListProperty("id")+"_selectGroup",activeHandling:false,selected:this.getSelected(),ariaLabelledBy:d.getStaticId("sap.m","LIST_ITEM_SELECTION")}).addStyleClass("sapMLIBSelectS").setParent(this,null,true).setTabIndex(-1).attachSelect(function(E){var s=E.getParameter("selected");this.setSelected(s);this.informList("Select",s);},this);this._oSingleSelectControl.useEnabledPropagator(false);return this._oSingleSelectControl;};
m.prototype.getMultiSelectControl=function(n){if(!n||this._oMultiSelectControl){n&&this._oMultiSelectControl.setSelected(this.getSelected());return this._oMultiSelectControl;}this._oMultiSelectControl=new f({id:this.getId()+"-selectMulti",activeHandling:false,selected:this.getSelected(),ariaLabelledBy:d.getStaticId("sap.m","LIST_ITEM_SELECTION")}).addStyleClass("sapMLIBSelectM").setParent(this,null,true).setTabIndex(-1).addEventDelegate({onkeydown:function(E){this.informList("KeyDown",E);},onkeyup:function(E){this.informList("KeyUp",E);}},this).attachSelect(function(E){var s=E.getParameter("selected");this.setSelected(s);this.informList("Select",s);},this);this._oMultiSelectControl.useEnabledPropagator(false);return this._oMultiSelectControl;};
m.prototype.getModeControl=function(n){var s=this.getMode();if(!s||s==i.None){return;}if(s==i.Delete){return this.getDeleteControl(n);}if(s==i.MultiSelect){return this.getMultiSelectControl(n);}return this.getSingleSelectControl(n);};
m.prototype.getTypeControl=function(n){var t=this.getType();if(t==j.Detail||t==j.DetailAndActive){return this.getDetailControl(n);}if(t==j.Navigation){return this.getNavigationControl(n);}};
m.prototype.destroyControls=function(n){n.forEach(function(s){s="_o"+s+"Control";if(this[s]){this[s].destroy("KeepDom");this[s]=null;}},this);};
m.prototype.isActionable=function(){return this.isIncludedIntoSelection()||(this.getType()!=j.Inactive&&this.getType()!=j.Detail);};
m.prototype.exit=function(){this._oLastFocused=null;this._checkHighlight(false);this._checkNavigated(false);this.setActive(false);this.destroyControls(["Delete","SingleSelect","MultiSelect","Detail","Navigation"]);};
m.prototype.setHighlight=function(v){if(v==null){v=M.None;}else if(!D.getType("sap.ui.core.MessageType").isValid(v)&&!D.getType("sap.ui.core.IndicationColor").isValid(v)){throw new Error('"'+v+'" is not a value of the enums sap.ui.core.MessageType or sap.ui.core.IndicationColor for property "highlight" of '+this);}return this.setProperty("highlight",v);};
m.prototype.isSelectable=function(){var s=this.getMode();return!(s==i.None||s==i.Delete);};
m.prototype.getSelected=function(){if(this.isSelectable()){return this.getProperty("selected");}return false;};
m.prototype.isSelected=m.prototype.getSelected;
m.prototype.setSelected=function(s,n){s=this.validateProperty("selected",s);if(!this.isSelectable()||s==this.getSelected()){return this;}if(!n){this.informSelectedChange(s);}var S=this.getModeControl();if(S){S.setSelected(s);}this.updateSelectedDOM(s,this.$());this.setProperty("selected",s,true);return this;};
m.prototype.updateSelectedDOM=function(s,t){t.toggleClass("sapMLIBSelected",s);t.attr("aria-selected",s);};
m.prototype.setParent=function(p){C.prototype.setParent.apply(this,arguments);if(!p){this._bGroupHeader=false;return;}this.informList("Inserted",this.bSelectedDelayed);return this;};
m.prototype.setBindingContext=function(){C.prototype.setBindingContext.apply(this,arguments);this.informList("BindingContextSet");return this;};
m.prototype.isGroupHeader=function(){return this._bGroupHeader;};
m.prototype.isIncludedIntoSelection=function(){if(!this.isSelectable()){return false;}var s=this.getMode();return s==i.SingleSelectMaster||(this.getListProperty("includeItemInSelection")&&(s==i.SingleSelectLeft||s==i.SingleSelect||s==i.MultiSelect));};
m.prototype._checkHighlight=function(n){if(n==undefined){n=(this.getVisible()&&this.getHighlight()!=M.None);}if(this._bNeedsHighlight!=n){this._bNeedsHighlight=n;this.informList("HighlightChange",n);}};
m.prototype._checkNavigated=function(n){if(n==undefined){n=(this.getVisible()&&this.getNavigated());}if(this._bNeedsNavigated!=n){this._bNeedsNavigated=n;this.informList("NavigatedChange",n);}};
m.prototype.hasActiveType=function(){var t=this.getType();return(t==j.Active||t==j.Navigation||t==j.DetailAndActive);};
m.prototype.setActive=function(A){if(A==this._active){return this;}if(A&&this.getListProperty("activeItem")){return this;}var t=this.$();this._active=A;this._activeHandling(t);if(this.getType()==j.Navigation){this._activeHandlingNav(t);}if(A){this._activeHandlingInheritor(t);}else{this._inactiveHandlingInheritor(t);}this.informList("ActiveChange",A);};
m.detectTextSelection=function(o){var s=window.getSelection(),t=s.toString().replace("\n","");return t&&q.contains(o,s.focusNode);};
m.prototype.ontap=function(E){if(this._eventHandledByControl){return E.setMarked();}if(m.detectTextSelection(this.getDomRef())){return;}if(this.isIncludedIntoSelection()){if(this.getMode()==i.MultiSelect){this.setSelected(!this.getSelected());this.informList("Select",this.getSelected());}else if(!this.getSelected()){this.setSelected(true);this.informList("Select",true);}}else if(this.hasActiveType()){window.clearTimeout(this._timeoutIdStart);window.clearTimeout(this._timeoutIdEnd);this.setActive(true);if(a.os.ios){this.focus();}setTimeout(function(){this.setActive(false);}.bind(this),180);setTimeout(function(){this.fireTap();this.firePress();}.bind(this),0);}this.informList("Press",E.srcControl);};
m.prototype.ontouchstart=function(E){this._eventHandledByControl=E.isMarked();var t=E.targetTouches[0];this._touchedY=t.clientY;this._touchedX=t.clientX;if(this._eventHandledByControl||E.touches.length!=1||!this.hasActiveType()){if(this.getListProperty("includeItemInSelection")&&this.getList()._mRangeSelection){E.preventDefault();}return;}this._timeoutIdStart=setTimeout(function(){this.setActive(true);}.bind(this),100);};
m.prototype.ontouchmove=function(E){if((this._active||this._timeoutIdStart)&&(Math.abs(this._touchedY-E.targetTouches[0].clientY)>10||Math.abs(this._touchedX-E.targetTouches[0].clientX)>10)){clearTimeout(this._timeoutIdStart);this._timeoutIdStart=null;this._timeoutIdEnd=null;this.setActive(false);}};
m.prototype.ontouchend=function(E){if(this.hasActiveType()){this._timeoutIdEnd=setTimeout(function(){this.setActive(false);}.bind(this),100);}};
m.prototype.ontouchcancel=m.prototype.ontouchend;m.prototype.ondragend=m.prototype.ontouchend;
m.prototype._activeHandlingNav=function(){};
m.prototype._activeHandlingInheritor=function(){};
m.prototype._inactiveHandlingInheritor=function(){};
m.prototype._activeHandling=function(t){t.toggleClass("sapMLIBActive",this._active);if(a.system.desktop&&this.isActionable()){t.toggleClass("sapMLIBHoverable",!this._active);}};
m.prototype.onsapspace=function(E){if(E.srcControl!==this){return;}E.preventDefault();if(E.isMarked()||!this.isSelectable()){return;}if(this.getMode()==i.MultiSelect){this.setSelected(!this.getSelected());this.informList("Select",this.getSelected());}else if(!this.getSelected()){this.setSelected(true);this.informList("Select",true);}E.setMarked();};
m.prototype.onsapenter=function(E){var o=this.getList();if(E.isMarked()||!o){return;}if(E.srcControl!==this&&o.getKeyboardMode()==h.Edit){o.setKeyboardMode(h.Navigation);this._switchFocus(E);return;}if(E.srcControl!==this){return;}if(this.isIncludedIntoSelection()){this.onsapspace(E);}else if(this.hasActiveType()){E.setMarked();this.setActive(true);setTimeout(function(){this.setActive(false);}.bind(this),180);setTimeout(function(){this.fireTap();this.firePress();}.bind(this),0);}o.onItemPress(this,E.srcControl);};
m.prototype.onsapdelete=function(E){if(E.isMarked()||E.srcControl!==this||this.getMode()!=i.Delete){return;}this.informList("Delete");E.preventDefault();E.setMarked();};
m.prototype._switchFocus=function(E){var o=this.getList();if(!o){return;}var t=this.getTabbables();if(E.srcControl!==this){o._iLastFocusPosOfItem=t.index(E.target);this.focus();}else if(t.length){var F=o._iLastFocusPosOfItem||0;F=t[F]?F:-1;t.eq(F).trigger("focus");}E.preventDefault();E.setMarked();};
m.prototype.onkeydown=function(E){if(E.isMarked()){return;}if(E.which==K.F7){this._switchFocus(E);return;}if(E.which==K.F2){if(E.srcControl===this&&this.getType().indexOf("Detail")==0&&this.hasListeners("detailPress")||this.hasListeners("detailTap")){this.fireDetailTap();this.fireDetailPress();E.preventDefault();E.setMarked();}else{var o=this.getList();if(o){this.$().prop("tabIndex",-1);o.setKeyboardMode(o.getKeyboardMode()==h.Edit?h.Navigation:h.Edit);this._switchFocus(E);}}}if(E.srcControl!==this){return;}this.informList("KeyDown",E);};
m.prototype.onkeyup=function(E){if(E.isMarked()||E.srcControl!==this){return;}this.informList("KeyUp",E);};
m.prototype.onsapupmodifiers=function(E){if(E.isMarked()||E.srcControl!==this){return;}this.informList("UpDownModifiers",E,-1);};
m.prototype.onsapdownmodifiers=function(E){if(E.isMarked()||E.srcControl!==this){return;}this.informList("UpDownModifiers",E,1);};
m.prototype.getTabbables=function(){return this.$().find(":sapTabbable");};
m.prototype.onsaptabnext=function(E){var o=this.getList();if(!o||E.isMarked()||o.getKeyboardMode()==h.Edit){return;}var n=this.getTabbables().get(-1)||this.getDomRef();if(E.target===n){o.forwardTab(true);E.setMarked();}};
m.prototype.onsaptabprevious=function(E){var o=this.getList();if(!o||E.isMarked()||o.getKeyboardMode()==h.Edit){return;}if(E.target===this.getDomRef()){o.forwardTab(false);E.setMarked();}};
m.prototype.onfocusin=function(E){var o=this.getList();if(!o||E.isMarked()){return;}this.informList("FocusIn",E.srcControl);E.setMarked();if(E.srcControl===this){return;}if(o.getKeyboardMode()==h.Edit||!q(E.target).is(":sapFocusable")){return;}setTimeout(o["setItemFocusable"].bind(o,this),0);};
m.prototype.onsapup=function(E){if(E.isMarked()||E.srcControl===this||this.getListProperty("keyboardMode")===h.Navigation){return;}this.informList("ArrowUpDown",E);};
m.prototype.oncontextmenu=function(E){if(this._bGroupHeader){return;}if(q(document.activeElement).is(":focusable")&&document.activeElement!==this.getDomRef()&&E.srcControl!==this.getModeControl()){return;}this.informList("ContextMenu",E);};
m.prototype.onsapdown=m.prototype.onsapup;return m;});
sap.ui.predefine('sap/m/ListItemBaseRenderer',["./library","sap/ui/core/Core","sap/ui/Device","sap/ui/core/InvisibleText","sap/ui/core/InvisibleRenderer"],function(l,C,D,I,a){"use strict";var L=l.ListType;var b=l.ListMode;var c={apiVersion:2};
c.renderInvisible=function(r,o){a.render(r,o,o.TagName);};
c.renderHighlight=function(r,o){var h=o.getHighlight();if(h=="None"){return;}r.openStart("div");r.class("sapMLIBHighlight");r.class("sapMLIBHighlight"+h);r.openEnd();r.close("div");};
c.isModeMatched=function(m,o){var O=(sap.ui.require("sap/m/ListBaseRenderer")||{}).ModeOrder||{};return O[m]==o;};
c.renderMode=function(r,o,O){var m=o.getMode();if(!this.isModeMatched(m,O)){return;}var M=o.getModeControl(true);if(M){this.renderModeContent(r,o,M);}};
c.renderModeContent=function(r,o,m){this.decorateMode(m,o);r.renderControl(m);};
c.decorateMode=function(m,o){m.removeStyleClass("sapMLIBSelectAnimation sapMLIBUnselectAnimation");if(!C.getConfiguration().getAnimation()||!o.getListProperty("modeAnimationOn")){return;}var M=o.getMode(),s=o.getListProperty("lastMode");if(!s||s==M){return;}if(M==b.None){m.addStyleClass("sapMLIBUnselectAnimation");}else{m.addStyleClass("sapMLIBSelectAnimation");}};
c.renderCounter=function(r,o){var i=o.getCounter();if(i){this.renderCounterContent(r,o,i);}};
c.renderCounterContent=function(r,o,i){r.openStart("div",o.getId()+"-counter");r.attr("aria-label",C.getLibraryResourceBundle("sap.m").getText("LIST_ITEM_COUNTER",i));r.class("sapMLIBCounter");r.openEnd();r.text(i);r.close("div");};
c.renderType=function(r,o){var t=o.getTypeControl(true);if(t){r.renderControl(t);}};
c.openItemTag=function(r,o){r.openStart(o.TagName,o);};
c.closeItemTag=function(r,o){r.close(o.TagName);};
c.renderTabIndex=function(r,o){r.attr("tabindex","-1");};
c.renderTooltip=function(r,o){var t=o.getTooltip_AsString();if(t){r.attr("title",t);}};
c.addFocusableClasses=function(r,o){if(D.system.desktop){r.class("sapMLIBFocusable");this.addLegacyOutlineClass(r,o);}};
c.addLegacyOutlineClass=function(r,o){};
c.getAriaAnnouncement=function(k,B){return I.getStaticId("sap.m",B||"LIST_ITEM_"+k.toUpperCase());};
c.getAriaRole=function(o){return"option";};
c.getAriaLabelledBy=function(o){if(!o.getContentAnnouncement&&o.getAriaLabelledBy().length){return o.getId();}};
c.getAriaDescribedBy=function(o){if(o.getContentAnnouncement){return"";}var d=[],t=o.getType();if(o.getListProperty("showUnread")&&o.getUnread()){d.push(this.getAriaAnnouncement("unread"));}if(o.getMode()==b.Delete){d.push(this.getAriaAnnouncement("delete"));}if(t==L.Navigation){d.push(this.getAriaAnnouncement("navigation"));}else{if(t==L.Detail||t==L.DetailAndActive){d.push(this.getAriaAnnouncement("detail"));}if(t==L.Active||t==L.DetailAndActive){d.push(this.getAriaAnnouncement("active"));}}return d.join(" ");};
c.getAccessibilityState=function(o){var A=this.getAriaLabelledBy(o),s=this.getAriaDescribedBy(o),m={role:this.getAriaRole(o)};if(o.isSelectable()){m.selected=o.getProperty("selected");}if(A){m.labelledby={value:A.trim(),append:true};}if(s){m.describedby={value:s.trim(),append:true};}if(o.getNavigated()){m.current=true;}return m;};
c.renderLIContent=function(r,o){};
c.renderLIAttributes=function(r,o){};
c.renderContentFormer=function(r,o){this.renderHighlight(r,o);this.renderMode(r,o,-1);};
c.renderContentLatter=function(r,o){this.renderCounter(r,o);this.renderType(r,o);this.renderMode(r,o,1);this.renderNavigated(r,o);};
c.renderLIContentWrapper=function(r,o){r.openStart("div",o.getId()+"-content").class("sapMLIBContent").openEnd();this.renderLIContent(r,o);r.close("div");};
c.renderNavigated=function(r,o){if(!o.getNavigated()){return;}r.openStart("div");r.class("sapMLIBNavigated");r.openEnd();r.close("div");};
c.render=function(r,o){if(!o.getVisible()){this.renderInvisible(r,o);return false;}this.openItemTag(r,o);r.class("sapMLIB");r.class("sapMLIB-CTX");r.class("sapMLIBShowSeparator");r.class("sapMLIBType"+o.getType());if(D.system.desktop&&o.isActionable()){r.class("sapMLIBActionable");r.class("sapMLIBHoverable");}if(o.getSelected()){r.class("sapMLIBSelected");}if(o.getListProperty("showUnread")&&o.getUnread()){r.class("sapMLIBUnread");}this.addFocusableClasses(r,o);this.renderTooltip(r,o);this.renderTabIndex(r,o);if(C.getConfiguration().getAccessibility()){r.accessibilityState(o,this.getAccessibilityState(o));}this.renderLIAttributes(r,o);r.openEnd();this.renderContentFormer(r,o);this.renderLIContentWrapper(r,o);this.renderContentLatter(r,o);this.closeItemTag(r,o);};
return c;},true);
sap.ui.predefine('sap/m/ListRenderer',["sap/ui/core/Renderer","./ListBaseRenderer"],function(R,L){"use strict";var a=R.extend(L);a.apiVersion=2;
a.getNoDataAriaRole=function(){return"option";};
return a;},true);
sap.ui.predefine('sap/m/MaskEnabler',['sap/ui/core/Control','./InputBase','sap/ui/Device','sap/ui/core/library','sap/ui/core/IconPool',"sap/ui/events/KeyCodes","sap/base/Log","sap/ui/thirdparty/jquery","sap/m/MaskInputRule","sap/ui/dom/jquery/cursorPos"],function(C,I,D,c,a,K,L,q,M){"use strict";var T=c.TextDirection;var b=function(){var E='^';this.init=b.init=function(){I.prototype.init.call(this);this._iCaretTimeoutId=null;this._iUserInputStartPosition=null;this._iMaskLength=null;this._sOldInputValue=null;this._oRules=null;this._oTempValue=null;this._bSkipSetupMaskVariables=null;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._setDefaultRules();this._setupMaskVariables();};this.exit=b.exit=function(){this._iCaretTimeoutId=null;this._iUserInputStartPosition=null;this._iMaskLength=null;this._sOldInputValue=null;this._oRules=null;this._oTempValue=null;this._bSkipSetupMaskVariables=null;};this.onBeforeRendering=function(){if(this._isMaskEnabled()){var v=this._validateDependencies();if(v){L.warning("Invalid mask input: "+v);}}I.prototype.onBeforeRendering.apply(this,arguments);this.getShowClearIcon&&this.getShowClearIcon()&&this._getClearIcon().setVisible(this.getProperty("effectiveShowClearIcon"));};this.onAfterRendering=function(){I.prototype.onAfterRendering.apply(this,arguments);};this.onfocusin=b.onfocusin=function(o){this._sOldInputValue=this._getInputValue();I.prototype.onfocusin.apply(this,arguments);if(this._isMaskEnabled()){if(!this._oTempValue.differsFromOriginal()||!this._isValidInput(this._sOldInputValue)){this._applyMask();}this._positionCaret(true);}};this.onfocusout=function(o){if(this._isMaskEnabled()){this.bFocusoutDueRendering=this.bRenderingPhase;this.removeStyleClass("sapMFocus");q(document).off('.sapMIBtouchstart');if(this.bRenderingPhase){return;}this.closeValueStateMessage();this._inputCompletedHandler();}else{this._inputCompletedHandlerNoMask();I.prototype.onfocusout.apply(this,arguments);}};this.oninput=function(o){if(this._isChromeOnAndroid()){this._onInputForAndroidHandler(o);return;}I.prototype.oninput.apply(this,arguments);if(this._isMaskEnabled()){this._applyMask();this._positionCaret(false);}};this.onkeypress=function(o){if(this._isMaskEnabled()){this._keyPressHandler(o);}if(this.getDOMValue()!==""){this._setClearIconVisibility();}};this.onkeydown=b.onkeydown=function(o){if(this._isMaskEnabled()){var k=this._parseKeyBoardEvent(o);I.prototype.onkeydown.apply(this,arguments);this._keyDownHandler(o,k);if(this.getDOMValue()!==""){this._setClearIconVisibility();}}else{var k=this._parseKeyBoardEvent(o);if(k.bEnter){this._inputCompletedHandlerNoMask();}I.prototype.onkeydown.apply(this,arguments);}};this.onsapenter=function(o){};this.onsapfocusleave=function(o){};this.onsapescape=function(o){if(this._oTempValue._aContent.join("")!==this._oTempValue._aInitial.join("")){I.prototype.onsapescape.call(this,o);}};this._setClearIconVisibility=function(s){var f=s!==undefined?s:!this._isValueEmpty();if(this.getShowClearIcon&&this.getShowClearIcon()){this.setProperty("effectiveShowClearIcon",f);this._getClearIcon().setVisible(this.getProperty("effectiveShowClearIcon"));}};this._getClearIcon=function(){if(this._oClearButton){return this._oClearButton;}this._oClearButton=this.addEndIcon({src:a.getIconURI("decline"),noTabStop:true,visible:false,alt:this._oRb.getText("INPUT_CLEAR_ICON_ALT"),useIconTooltip:false,press:function(){if(!this._isValueEmpty()){this.fireChange({value:""});this.setValue("");this.setProperty("effectiveShowClearIcon",false);this._getClearIcon().setVisible(false);setTimeout(function(){if(D.system.desktop){this.focus();}},0);}}.bind(this)});return this._oClearButton;};this._isValueEmpty=function(){var v=this.getDOMValue(),p=this._oTempValue._aInitial.join('');return v==p;};this.getDOMValue=function(){return this._$input.val();};this.setValue=b.setValue=function(v){v=this.validateProperty('value',v);I.prototype.setValue.call(this,v);this._sOldInputValue=v;if(this._isMaskEnabled()){if(!this._oTempValue){this._setupMaskVariables();}if(this._oTempValue._aInitial.join('')!==v){this._applyRules(v);}}this._setClearIconVisibility(v!=="");return this;};this.addAggregation=function(A,o,s){if(A==="rules"){if(!this._validateRegexAgainstPlaceHolderSymbol(o)){return this;}this._removeRuleWithSymbol(o.getMaskFormatSymbol());C.prototype.addAggregation.apply(this,arguments);if(!this._bSkipSetupMaskVariables){this._setupMaskVariables();}return this;}return C.prototype.addAggregation.apply(this,arguments);};this.insertAggregation=function(A,o,i,s){if(A==="rules"){if(!this._validateRegexAgainstPlaceHolderSymbol(o)){return this;}this._removeRuleWithSymbol(o.getMaskFormatSymbol());C.prototype.insertAggregation.apply(this,arguments);this._setupMaskVariables();return this;}return C.prototype.insertAggregation.apply(this,arguments);};this._validateRegexAgainstPlaceHolderSymbol=function(r){if(new RegExp(r.getRegex()).test(this.getPlaceholderSymbol())){L.error("Rejecting input mask rule because it includes the currently set placeholder symbol.");return false;}return true;};this.setPlaceholderSymbol=function(s){var S;if(!/^.$/i.test(s)){L.error("Invalid placeholder symbol string given");return this;}S=this.getRules().some(function(r){return new RegExp(r.getRegex()).test(s);});if(S){L.error("Rejecting placeholder symbol because it is included as a regex in an existing mask input rule.");}else{this.setProperty("placeholderSymbol",s);this._setupMaskVariables();}return this;};this.setMask=function(m){if(!m){var s="Setting an empty mask is pointless. Make sure you set it with a non-empty value.";L.warning(s);return this;}this.setProperty("mask",m,true);this._setupMaskVariables();return this;};this._isCharAllowed=function(s,i){return this._oRules.applyCharAt(s,i);};this._feedReplaceChar=function(s,p,f){return s;};this._inputCompletedHandlerNoMask=function(){var v=this._getInputValue();if(this._sOldInputValue!==v){I.prototype.setValue.call(this,this._getAlteredUserInputValue?this._getAlteredUserInputValue(v):v);this._sOldInputValue=v;if(this.onChange&&!this.onChange({value:v})){this.fireChangeEvent(v);}}};var d=function(f){this._aInitial=f.slice(0);this._aContent=f;};d.prototype.setCharAt=function(s,p){this._aContent[p]=s;};d.prototype.charAt=function(p){return this._aContent[p];};d.prototype.toString=function(){return this._aContent.join('');};d.prototype.differsFromOriginal=function(){return this.differsFrom(this._aInitial);};d.prototype.differsFrom=function(v){var i=0;if(v.length!==this._aContent.length){return true;}for(;i<v.length;i++){if(v[i]!==this._aContent[i]){return true;}}return false;};d.prototype.getSize=function(){return this._aContent.length;};var e=function(r){this._aRules=r;};e.prototype.nextTo=function(i){if(typeof i==="undefined"){i=-1;}do{i++;}while(i<this._aRules.length&&!this._aRules[i]);return i;};e.prototype.previousTo=function(i){do{i--;}while(!this._aRules[i]&&i>0);return i;};e.prototype.hasRuleAt=function(i){return!!this._aRules[i];};e.prototype.applyCharAt=function(s,i){return this._aRules[i].test(s);};this._setDefaultRules=function(){this._bSkipSetupMaskVariables=true;this.addRule(new M({maskFormatSymbol:"a",regex:"[A-Za-z]"}),true);this.addRule(new M({maskFormatSymbol:"9",regex:"[0-9]"}),true);this._bSkipSetupMaskVariables=false;};this._validateDependencies=function(){var p=this.getPlaceholderSymbol(),r=this.getRules(),m=[],f=[];if(!this.getMask()){f.push("Empty mask");}if(r.length){m=[];r.every(function(R){var s=R.getMaskFormatSymbol(),g=s!==p,h;h=!m.some(function(S){return s===S;});m.push(s);if(!g){f.push("Placeholder symbol is the  same as the existing rule's mask format symbol");}if(!h){f.push("Duplicated rule's maskFormatSymbol ["+s+"]");}return g&&h;});}return f.length?f.join(". "):null;};this._removeRuleWithSymbol=function(s){var S=this._findRuleBySymbol(s,this.getRules());if(S){this.removeAggregation('rules',S.oRule);S.oRule.destroy();}};this._findRuleBySymbol=function(m,r){var R=null;if(typeof m!=="string"||m.length!==1){L.error(m+" is not a valid mask rule symbol");return null;}q.each(r,function(i,o){if(o.getMaskFormatSymbol()===m){R={oRule:o,iIndex:i};return false;}});return R;};this._getTextSelection=function(){var _=q(this.getFocusDomRef());if(!_&&(_.length===0||_.is(":hidden"))){return{};}return{iFrom:_[0].selectionStart,iTo:_[0].selectionEnd,bHasSelection:(_[0].selectionEnd-_[0].selectionStart!==0)};};this._setCursorPosition=function(p){if(p<0){p=0;}q(this.getFocusDomRef()).cursorPos(p);return this;};this._getCursorPosition=function(){return q(this.getFocusDomRef()).cursorPos();};this._setupMaskVariables=function(){var r=this.getRules(),m=this.getMask(),s=this._getSkipIndexes(m),f=this._getMaskArray(m,s),p=this.getPlaceholderSymbol(),i=this._buildMaskValueArray(f,p,r,s),t=this._buildRules(f,r,s);this._oTempValue=new d(i);this._iMaskLength=t.length;this._oRules=new e(t);this._iUserInputStartPosition=this._oRules.nextTo();};this._getMaskArray=function(m,s){var l=Array.isArray(s)?s.length:0,f=(m)?m.split(""):[],i;for(i=0;i<l;i++){f.splice(s[i],1);}return f;};this._getSkipIndexes=function(m){var l=(m)?m.length:0,i,s=[],p=0,f=false;for(i=0;i<l;i++){if(m[i]===E&&!f){s.push(i-p);f=true;p++;}else{f=false;}}return s;};this._applyMask=function(){var m=this._getInputValue();if(!this.getEditable()){return;}this._applyAndUpdate(m);};this._resetTempValue=function(f,t){var i,p=this.getPlaceholderSymbol();if(typeof f==="undefined"||f===null){f=0;t=this._oTempValue.getSize()-1;}for(i=f;i<=t;i++){if(this._oRules.hasRuleAt(i)){this._oTempValue.setCharAt(p,i);}}};this._applyAndUpdate=function(m){this._applyRules(m);this.updateDomValue(this._oTempValue.toString());};this._findFirstPlaceholderPosition=function(){return this._oTempValue.toString().indexOf(this.getPlaceholderSymbol());};this._applyRules=function(i){var s,f=0,m,p=this.getPlaceholderSymbol(),g;if(this._oTempValue.toString()===i){return;}for(m=0;m<this._iMaskLength;m++){if(this._oRules.hasRuleAt(m)){this._oTempValue.setCharAt(p,m);g=false;if(i.length){do{s=i.charAt(f);f++;if(this._oRules.applyCharAt(s,m)){this._oTempValue.setCharAt(s,m);g=true;}}while(!g&&(f<i.length));}if(!g){this._resetTempValue(m+1,this._iMaskLength-1);break;}}else{if(this._oTempValue.charAt(m)===i.charAt(f)){f++;}}}};this._keyPressHandler=function(o,k){var s,p,f;if(!this.getEditable()){return;}k=k||this._parseKeyBoardEvent(o);if(k.bCtrlKey||k.bAltKey||k.bMetaKey||k.bBeforeSpace){return;}s=this._getTextSelection();if(!k.bEnter&&!k.bShiftLeftOrRightArrow&&!k.bHome&&!k.bEnd&&!(k.bShift&&k.bDelete)&&!(k.bCtrlKey&&k.bInsert)&&!(k.bShift&&k.bInsert)){if(s.bHasSelection){this._resetTempValue(s.iFrom,s.iTo-1);this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(Math.max(this._iUserInputStartPosition,s.iFrom));}p=this._oRules.nextTo(s.iFrom-1);if(p<this._iMaskLength){f=this._feedReplaceChar(k.sChar,p,this._getInputValue());this._feedNextString(f,p);}o.preventDefault();}};this.oncut=function(o){var s=this._getTextSelection(),m=this._getMinBrowserDelay(),B=s.iFrom,i=s.iTo;I.prototype.oncut(o);if(!s.bHasSelection||!this._isMaskEnabled()){return;}i=i-1;this._resetTempValue(B,i);setTimeout(function u(v,p,O){this._oTempValue._aContent=O;this.updateDomValue(v);setTimeout(this._setCursorPosition.bind(this,p),m);}.bind(this,this._oTempValue.toString(),Math.max(this._iUserInputStartPosition,B),this._oTempValue._aContent.slice(0)),m);};this._keyDownHandler=function(o,k){var s,S,i,n,k=k||this._parseKeyBoardEvent(o);if(!this.getEditable()){return;}if(!k.bShift&&(k.bArrowRight||k.bArrowLeft)){i=this._getCursorPosition();S=this._getTextSelection();s=this._determineArrowKeyDirection(k,S);if(this._isRtlMode()&&S.bHasSelection){n=this._determineRtlCaretPositionFromSelection(s);}else{n=this._oRules[s](i);}if(this._isWebkitProblematicCase()){n=this._fixWebkitBorderPositions(n,s);}this._setCursorPosition(n);o.preventDefault();}else if(k.bEscape){this._applyAndUpdate(this._sOldInputValue);this._positionCaret(true);o.preventDefault();}else if(k.bEnter){this._inputCompletedHandler(o);}else if((k.bCtrlKey&&k.bInsert)||(k.bShift&&k.bInsert)){I.prototype.onkeydown.apply(this,arguments);}else if((!k.bShift&&k.bDelete)||k.bBackspace){this._revertKey(k);o.preventDefault();}else if(this._isChromeOnAndroid()){this._oKeyDownStateAndroid={sValue:this._oTempValue.toString(),iCursorPosition:this._getCursorPosition(),oSelection:this._getTextSelection()};}};this._revertKey=function(k,s){s=s||this._getTextSelection();var B=s.iFrom,i=s.iTo;if(!s.bHasSelection){if(k.bBackspace){B=this._oRules.previousTo(B);}}if(k.bBackspace||(k.bDelete&&s.bHasSelection)){i=i-1;}this._resetTempValue(B,i);this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(Math.max(this._iUserInputStartPosition,B));};this._feedNextString=function(n,p){var N,A=false,f=n.split(""),s;while(f.length){s=f.splice(0,1)[0];if(this._oRules.applyCharAt(s,p)){A=true;this._oTempValue.setCharAt(s,p);p=this._oRules.nextTo(p);}}if(A){N=p;this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(N);}};this._inputCompletedHandler=function(){var n=this._getInputValue(),t,v,f,g;if(this._oTempValue.differsFrom(n)){this._applyAndUpdate(n);}t=this._oTempValue.differsFromOriginal();v=t?this._oTempValue.toString():"";f=!this._sOldInputValue||!this.getValue();g=!n;if(f&&(g||!t)){this.updateDomValue("");return;}if(this._sOldInputValue!==this._oTempValue.toString()){I.prototype.setValue.call(this,this._getAlteredUserInputValue?this._getAlteredUserInputValue(v):v);this._sOldInputValue=v;if(this.onChange&&!this.onChange({value:v})){this.fireChangeEvent(v);}}};this._buildMaskValueArray=function(m,p,r,s){return m.map(function(f,i){var n=s.indexOf(i)===-1,R=this._findRuleBySymbol(f,r);return(n&&R)?p:f;},this);};this._buildRules=function(m,r,s){var t=[],S,l=m.length,i=0;for(;i<l;i++){if(s.indexOf(i)===-1){S=this._findRuleBySymbol(m[i],r);t.push(S?new RegExp(S.oRule.getRegex()):null);}else{t.push(null);}}return t;};this._parseKeyBoardEvent=function(o){var p=o.which||o.keyCode,k=K,A=p===k.ARROW_RIGHT,f=p===k.ARROW_LEFT,s=o.shiftKey;return{iCode:p,sChar:String.fromCharCode(p),bCtrlKey:o.ctrlKey,bAltKey:o.altKey,bMetaKey:o.metaKey,bShift:s,bInsert:p===K.INSERT,bBackspace:p===k.BACKSPACE,bDelete:p===k.DELETE,bEscape:p===k.ESCAPE,bEnter:p===k.ENTER,bIphoneEscape:(D.system.phone&&D.os.ios&&p===127),bArrowRight:A,bArrowLeft:f,bHome:p===K.HOME,bEnd:p===K.END,bShiftLeftOrRightArrow:s&&(f||A),bBeforeSpace:p<k.SPACE};};this._positionCaret=function(s){var m=this.getMask(),i=this._getMinBrowserDelay(),f;clearTimeout(this._iCaretTimeoutId);f=this._findFirstPlaceholderPosition();if(f<0){f=m.length;}this._iCaretTimeoutId=setTimeout(function(){if(this.getFocusDomRef()!==document.activeElement){return;}if(s&&(f===(m.length))){this.selectText(0,f);}else{this._setCursorPosition(f);}}.bind(this),i);this._setClearIconVisibility();};this._getMinBrowserDelay=function(){return 4;};this._isValidInput=function(s){var l=s.length,i=0,f;for(;i<l;i++){f=s[i];if(this._oRules.hasRuleAt(i)&&(!this._oRules.applyCharAt(f,i)&&f!==this.getPlaceholderSymbol())){return false;}if(!this._oRules.hasRuleAt(i)&&f!==this._oTempValue.charAt(i)){return false;}}return true;};this._isRtlChar=function(s){var l='A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02B8\u0300-\u0590\u0800-\u1FFF'+'\u2C00-\uFB1C\uFDFE-\uFE6F\uFEFD-\uFFFF',r='\u0591-\u07FF\uFB1D-\uFDFD\uFE70-\uFEFC',f=new RegExp('^[^'+l+']*['+r+']');return f.test(s);};this._fixWebkitBorderPositions=function(i,s){var t=this._oTempValue.toString().length;if(s==='nextTo'){if(i===0||i===t||i===1){i=0;}else if(i===t+1){i=1;}}else{if(i===0||i===t-1){i=t;}else if(i===-1||i===t){i=t-1;}}return i;};this._containsRtlChars=function(){var t=this._oTempValue.toString(),f=false;for(var i=0;i<t.length;i++){f=this._isRtlChar(t[i]);}return f;};this._isRtlMode=function(){return sap.ui.getCore().getConfiguration().getRTL()||(this.getTextDirection()===T.RTL);};this._isWebkitProblematicCase=function(){return D.browser.webkit&&this._isRtlMode()&&!this._containsRtlChars();};this._determineArrowKeyDirection=function(k,s){var f;if(!this._isRtlMode()||!this._containsRtlChars()||s.bHasSelection){if(k.bArrowRight){f='nextTo';}else{f='previousTo';}}else{if(k.bArrowRight){f='previousTo';}else{f='nextTo';}}return f;};this._determineRtlCaretPositionFromSelection=function(s,w){var n,S=this._getTextSelection();if(w){if(s==='nextTo'){if(!this._containsRtlChars()){n=S.iFrom;}else{n=S.iTo;}}else{if(!this._containsRtlChars()){n=S.iTo;}else{n=S.iFrom;}}}else{if(s==='nextTo'){if(!this._containsRtlChars()){n=S.iTo;}else{n=S.iFrom;}}else{if(!this._containsRtlChars()){n=S.iFrom;}else{n=S.iTo;}}}return n;};this._onInputForAndroidHandler=function(o){var k;if(!this._oKeyDownStateAndroid){return;}k=this._buildKeyboardEventInfo(this._oKeyDownStateAndroid.sValue,this._getInputValue(),this._oKeyDownStateAndroid.oSelection);this.updateDomValue(this._oKeyDownStateAndroid.sValue);setTimeout(function(i,f,g){this._setCursorPosition(f.iCursorPosition);if(g.bBackspace){this._revertKey(g,f.oSelection);if(f.oSelection.bHasSelection&&g.sChar){this._keyPressHandler(i,g);}}else{this._keyPressHandler(i,g);}}.bind(this,o,this._oKeyDownStateAndroid,k),0);delete this._oKeyDownStateAndroid;o.preventDefault();};this._buildKeyboardEventInfo=function(o,n,O){var N="",i,r={},f;if(!o&&!n){return{};}if(o&&n&&n.length<o.length){r.bBackspace=true;}for(i=0;i<n.length;i++){f=O.bHasSelection&&O.iFrom===i;if(f||o[i]!==n[i]){N=n[i];break;}}r.sChar=N;return r;};this._isChromeOnAndroid=function(){return D.browser.chrome&&D.os.android;};};return b;},true);
sap.ui.predefine('sap/m/MaskInput',['./InputBase','./MaskEnabler','./MaskInputRenderer'],function(I,M,a){"use strict";
var b=I.extend("sap.m.MaskInput",{metadata:{library:"sap.m",properties:{placeholderSymbol:{type:"string",group:"Misc",defaultValue:"_"},mask:{type:"string",group:"Misc",defaultValue:null},showClearIcon:{type:"boolean",defaultValue:false},effectiveShowClearIcon:{type:"boolean",defaultValue:false,visibility:"hidden"}},aggregations:{rules:{type:"sap.m.MaskInputRule",multiple:true,singularName:"rule"}},dnd:{draggable:false,droppable:true}}});
M.call(b.prototype);
b.prototype._isMaskEnabled=function(){return true;};
return b;});
sap.ui.predefine('sap/m/MaskInputRenderer',['sap/ui/core/Renderer','./InputBaseRenderer'],function(R,I){"use strict";var M=R.extend(I);M.apiVersion=2;
M.getLabelledByAnnouncement=function(c){var m=c.getMask(),p=c.getPlaceholder()||"",r,s,a="";if(m&&m.length){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");s=r.getText("MASKINPUT_SCREENREADER_TAG");if(p){p=" "+p+" ";}a=s+p;return a;}return I.getLabelledByAnnouncement.apply(this,arguments);};
M.getDescribedByAnnouncement=function(c){var m=c.getMask(),s=c.getPlaceholderSymbol(),r,a="";if(m.length&&s){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");a=r.getText("MASKINPUT_SCREENREADER_DESCRIPTION",[s,m]);return a.trim();}return I.getDescribedByAnnouncement.apply(this,arguments);};
return M;},true);
sap.ui.predefine('sap/m/MaskInputRule',['sap/ui/core/Element',"sap/base/Log"],function(E,L){"use strict";
var M=E.extend("sap.m.MaskInputRule",{metadata:{library:"sap.m",properties:{maskFormatSymbol:{type:"string",group:"Misc",defaultValue:"*"},regex:{type:"string",group:"Misc",defaultValue:"[a-zA-Z0-9]"}}}});
M.prototype.setMaskFormatSymbol=function(n){var i=v.call(this,n);if(i){this.setProperty("maskFormatSymbol",n);}return this;};
M.prototype.setRegex=function(n){var i=a.call(this,n);if(i){this.setProperty("regex",n);}return this;};
M.prototype.toString=function(){return this.getMaskFormatSymbol()+":"+this.getRegex();};
function v(n){if(/^.$/i.test(n)){return true;}L.error("The mask format symbol '"+n+"' is not valid");return false;}
function a(r){if(/.+/i.test(r)){return true;}L.error("The regex value '"+r+"' is not valid");return false;}
return M;});
sap.ui.predefine('sap/m/Menu',['./library','sap/ui/core/Control','./Button','./Dialog','./NavContainer','./List','./Page','./MenuListItem','sap/ui/unified/Menu','sap/ui/unified/MenuItem','sap/ui/Device','sap/ui/core/EnabledPropagator',"sap/ui/thirdparty/jquery","sap/ui/core/Popup"],function(l,C,B,D,N,L,P,M,U,a,b,E,q,c){"use strict";var d=c.Dock;var e=l.ListType;var f=l.ListMode;
var g=C.extend("sap.m.Menu",{
metadata:{interfaces:["sap.ui.core.IContextMenu"],library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MenuItem",multiple:true,singularName:"item",bindable:"bindable"},_dialog:{type:"sap.m.Dialog",multiple:false,visibility:"hidden"},_menu:{type:"sap.ui.unified.Menu",multiple:false,visibility:"hidden"}},events:{itemSelected:{parameters:{item:{type:"sap.m.MenuItem"}}},closed:{}}},
renderer:null
});
E.call(g.prototype);g.UNIFIED_MENU_ITEMS_ID_SUFFIX='-unifiedmenu';g.UNFIFIED_MENU_ITEMS_PROPS=a.getMetadata().getAllProperties();g.LIST_ITEMS_ID_SUFFIX='-menuinnerlist';g.MENU_LIST_ITEMS_PROPS=M.getMetadata().getAllProperties();
g.prototype.init=function(){if(b.system.phone){this._initDialog();}this._bIsInitialized=false;};
g.prototype.exit=function(){if(this._navContainerId){this._navContainerId=null;}if(this._bIsInitialized){this._bIsInitialized=null;}if(this._getMenu()&&this._getMenu().getPopup()){this._getMenu().getPopup().detachClosed(this._menuClosed,this);}};
g.prototype.invalidate=function(){};
g.prototype.setTitle=function(t){var n=this._getNavContainer();this.setProperty("title",t,true);if(n&&n.getPages().length){n.getPages()[0].setTitle(t);}return this;};
g.prototype.openBy=function(o,w,s,i,O){if(b.system.phone){this._openDialog();}else{if(!this._bIsInitialized){this._initAllMenuItems();this._bIsInitialized=true;}if(!s){s=d.BeginTop;}if(!i){i=d.BeginBottom;}if(!O){O="0 -2";}this._getMenu().open(w,o,s,i,o,O);}};
g.prototype.close=function(){if(b.system.phone){this._getDialog()&&this._getDialog().close();}else{this._getVisualParent()&&this._getVisualParent().close();}};
g.prototype._initDialog=function(){var o=new D({showHeader:false,stretch:true,content:this._initNavContainer(),buttons:[this._initCloseButton()]});o.addStyleClass("sapMRespMenuDialog");o.addStyleClass("sapUiNoContentPadding");this.setAggregation("_dialog",o,true);o.attachAfterClose(this._menuClosed,this);};
g.prototype._getDialog=function(){return this.getAggregation("_dialog");};
g.prototype._openDialog=function(){if(!this._bIsInitialized){this._initAllPages();this._bIsInitialized=true;}this._getNavContainer().to(this._getNavContainer().getPages()[0]);this._getDialog().open();};
g.prototype._initAllMenuItems=function(){this._initMenuForItems(this.getItems());};
g.prototype._setCustomEnhanceAccStateFunction=function(i){this._fnEnhanceUnifiedMenuAccState=i;};
g.prototype._initMenuForItems=function(i,p){var m=new U();m._setCustomEnhanceAccStateFunction(this._fnEnhanceUnifiedMenuAccState);m.isCozy=this._isMenuCozy.bind(this,m);this.addStyleClass('sapMMenu');m.aCustomStyleClasses=this.aCustomStyleClasses;m.mCustomStyleClassMap=this.mCustomStyleClassMap;i.forEach(function(I){this._addVisualMenuItemFromItem(I,m);}.bind(this));if(p){p.setSubmenu(m);}else{m.getPopup().attachClosed(this._menuClosed,this);this.setAggregation('_menu',m,true);}m.attachItemSelect(this._handleMenuItemSelect,this);};
g.prototype._menuClosed=function(){this.fireClosed();};
g.prototype._getMenu=function(){return this.getAggregation("_menu");};
g.prototype._initCloseButton=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");return new B({text:r.getText("MENU_CLOSE"),press:h.bind(this)});};
function h(){this._getDialog().close();}
g.prototype._initNavContainer=function(){var n=new N();this._navContainerId=n.getId();return n;};
g.prototype._getNavContainer=function(){return sap.ui.getCore().byId(this._navContainerId);};
g.prototype._initAllPages=function(){this._initPageForParent(this);};
g.prototype._initPageForParent=function(p){var i=p.getItems(),k=p instanceof g,s=k?p.getTitle():p.getText(),o=new L({mode:f.None}),m=new P({title:s,showNavButton:!k,content:o});if(!k){this._setBackButtonTooltipForPageWithParent(p,m);}m.attachNavButtonPress(function(){this._getNavContainer().back();},this);this._getNavContainer().addPage(m);i.forEach(function(I){this._addListItemFromItem(I,m);},this);this._updateListInset(o);o.attachEvent("itemPress",this._handleListItemPress,this);return m;};
g.prototype._handleListItemPress=function(o){var i=o.getParameter("listItem"),m=sap.ui.getCore().byId(i.getMenuItem()),p=m._getVisualChild();if(p){this._getNavContainer().to(p);}else{this._getDialog().close();this.fireItemSelected({item:m});}m.firePress();};
g.prototype._setBackButtonTooltipForPageWithParent=function(p,o){var i=p.getParent(),r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s;s=i instanceof g?i.getTitle():i.getText();s=r.getText("MENU_PAGE_BACK_BUTTON")+" "+s;o.setNavButtonTooltip(s);};
g.prototype._createMenuListItemFromItem=function(i){return new M({id:this._generateListItemId(i.getId()),type:i.getEnabled()?e.Active:e.Inactive,icon:i.getIcon(),title:i.getText(),startsSection:i.getStartsSection(),menuItem:i,tooltip:i.getTooltip(),visible:i.getVisible(),enabled:i.getEnabled()});};
g.prototype._createVisualMenuItemFromItem=function(I){var u=new a({id:this._generateUnifiedMenuItemId(I.getId()),icon:I.getIcon(),text:I.getText(),startsSection:I.getStartsSection(),tooltip:I.getTooltip(),visible:I.getVisible(),enabled:I.getEnabled()}),i,k=I.getCustomData();for(i=0;i<k.length;i++){I._addCustomData(u,k[i]);}return u;};
g.prototype._addVisualMenuItemFromItem=function(i,m,I){var o=this._createVisualMenuItemFromItem(i);i._setVisualParent(m);i._setVisualControl(o);var k=['aggregationChanged','propertyChanged'];k.forEach(function(s){var n='_on'+s.slice(0,1).toUpperCase()+s.slice(1);i.attachEvent(s,this[n],this);},this);if(i.getItems().length!==0){this._initMenuForItems(i.getItems(),o);i._setVisualChild(i.getItems()[0]._getVisualParent());}if(I===undefined){m.addItem(o);}else{m.insertItem(o,I);}};
g.prototype._addListItemFromItem=function(i,p,I){var m=this._createMenuListItemFromItem(i),o=p.getContent()[0];i._setVisualParent(p);i._setVisualControl(m);var k=['aggregationChanged','propertyChanged'];k.forEach(function(s){var n='_on'+s.slice(0,1).toUpperCase()+s.slice(1);i.attachEvent(s,this[n],this);},this);if(i.getItems().length!==0){this._initPageForParent(i);i._setVisualChild(i.getItems()[0]._getVisualParent());}if(I===undefined){o.addItem(m);}else{o.insertItem(m,I);}o.rerender();};
g.prototype._connectVisualItem=function(i,o,I){if(!o||sap.ui.getCore().byId(i._getVisualControl())){return;}if(b.system.phone){this._addListItemFromItem(i,o,I);var k=o.getContent()[0];this._updateListInset(k);}else{this._addVisualMenuItemFromItem(i,o,I);}};
g.prototype._updateListInset=function(o){var H=false,I="sapMListIcons",k=o.getItems();for(var i=0;i<k.length;i++){if(k[i].getIcon()){H=true;break;}}if(H){o.addStyleClass(I);}else{o.removeStyleClass(I);}};
g.prototype._handleMenuItemSelect=function(o){var u=o.getParameter("item"),m;if(!u){return;}m=this._findMenuItemByUnfdMenuItem(u);if(m&&!m.getItems().length){this.fireItemSelected({item:m});}if(m){m.firePress();}};
g.prototype._generateListItemId=function(m){return m+g.LIST_ITEMS_ID_SUFFIX;};
g.prototype._generateUnifiedMenuItemId=function(m){return m+g.UNIFIED_MENU_ITEMS_ID_SUFFIX;};
g.prototype._findMenuItemByUnfdMenuItem=function(u){var k=[],o=u,I,m,i;do{k.push(o.getId());o=o.getParent().getParent();}while(o instanceof a);I=this.getItems();do{m=k.pop();for(i=0;i<I.length;i++){if(I[i]._getVisualControl()===m){if(k.length===0){return I[i];}else{I=I[i].getItems();break;}}}}while(k.length);return null;};
g.prototype._isMenuCozy=function(m){if(!m.bCozySupported){return false;}if(m.hasStyleClass("sapUiSizeCozy")){return true;}if(j(m.oOpenerRef)){return true;}return false;};
function j(r){if(!r){return false;}r=r.$?r.$():q(r);var $=r.closest(".sapUiSizeCompact,.sapUiSizeCondensed,.sapUiSizeCozy");return(!$.hasClass("sapUiSizeCompact")&&!$.hasClass("sapUiSizeCondensed"))||$.hasClass("sapUiSizeCozy");}
g.prototype.addAggregation=function(A,o,s){C.prototype.addAggregation.apply(this,arguments);if(A==="items"){this._connectVisualItem(o,this._getVisualParent());}return this;};
g.prototype.insertAggregation=function(A,o,i,s){C.prototype.insertAggregation.apply(this,arguments);if(A==="items"){this._connectVisualItem(o,this._getVisualParent(),i);}return this;};
g.prototype.removeAggregation=function(A,o,s){var i=C.prototype.removeAggregation.apply(this,arguments);if(A==="items"){this._removeVisualItem(i);}return i;};
g.prototype.removeAllAggregation=function(A,s){var I=C.prototype.removeAllAggregation.apply(this,arguments);if(A==="items"){for(var i=0;i<I.length;i++){this._removeVisualItem(I[i]);}}return I;};
g.prototype._removeVisualItem=function(i,p){var v=sap.ui.getCore().byId(i._getVisualControl()),m;if(v){m=v.getParent();m.removeItem(v);if(b.system.phone){this._removeSubPageForItem(i);if(m.getItems().length===0){if(p){p._setVisualChild(null);sap.ui.getCore().byId(p._getVisualControl()).rerender();}}if(m){m.rerender();}}}};
g.prototype.destroyAggregation=function(A,s){if(A==="items"){for(var i=0;i<this.getItems().length;i++){this._removeVisualItem(this.getItems()[i]);}}return C.prototype.destroyAggregation.apply(this,arguments);};
g.prototype._removeSubPageForItem=function(I,s){var S;if(!s){for(var i=0;i<I.getItems().length;i++){this._removeSubPageForItem(I.getItems()[i]);}}if(I._getVisualChild()){S=sap.ui.getCore().byId(I._getVisualChild());if(this._getNavContainer()&&S){this._getNavContainer().removePage(S);}!!S&&S.destroy();}};
g.prototype._getVisualParent=function(){var n=this._getNavContainer(),m=this._getMenu();if(n&&n.getPages().length){return n.getPages()[0];}else{return m;}};
g.prototype._onPropertyChanged=function(o){var p=o.getParameter("propertyKey"),i=o.getParameter("propertyValue"),t=b.system.phone?g.MENU_LIST_ITEMS_PROPS:g.UNFIFIED_MENU_ITEMS_PROPS,G=b.system.phone?this._generateListItemId:this._generateUnifiedMenuItemId,T;if(b.system.phone&&p==='text'){p='title';}if(!t[p]){return;}T=G(o.getSource().getId());if(T){sap.ui.getCore().byId(T).setProperty(p,i);if(b.system.phone&&this._getDialog().isOpen()){this._getDialog().close();}}};
g.prototype._onAggregationChanged=function(o){var A=o.getParameter("aggregationName");switch(A){case'items':this._onItemsAggregationChanged(o);break;case'tooltip':this._onTooltipAggregationChanged(o);break;}};
g.prototype._onTooltipAggregationChanged=function(o){var v=o.getSource()._getVisualControl(),m=o.getParameter("methodName"),i=o.getParameter("methodParams"),V;if(!v){return;}V=sap.ui.getCore().byId(v);if(m==="set"){V.setTooltip(i.item);}if(m==="destroy"){V.destroyTooltip();}};
g.prototype._onItemsAggregationChanged=function(o){var I=o.getSource(),m=o.getParameter("methodName"),k=o.getParameter("methodParams"),n;if(m==="add"||m==="insert"){if(m==="insert"){n=k.index;}this._addOrInsertItem(I,k.item,n);}if(m==="remove"){this._removeVisualItem(k.item,I);}if(m==="removeall"){for(var i=0;i<k.items.length;i++){this._removeVisualItem(k.items[i],I);}}if(m==="destroy"){this._destroyItem(I);}};
g.prototype._addOrInsertItem=function(p,n,i){var o;if(p._getVisualChild()){this._connectVisualItem(n,sap.ui.getCore().byId(p._getVisualChild()),i);}else{if(b.system.phone){this._initPageForParent(p);p._setVisualChild(p.getItems()[0]._getVisualParent());o=sap.ui.getCore().byId(p._getVisualControl());o.rerender();}else{this._initMenuForItems(p.getItems(),sap.ui.getCore().byId(p._getVisualControl()));p._setVisualChild(p.getItems()[0]._getVisualParent());}}};
g.prototype._destroyItem=function(i){var v=sap.ui.getCore().byId(i._getVisualControl());if(v&&v.setMenuItem){v.setMenuItem(null);}this._removeSubPageForItem(i,true);i._setVisualChild(null);if(v&&v.setMenuItem){v.rerender();v.setMenuItem(i);}};
g.prototype.getDomRefId=function(){if(b.system.phone){return this._getDialog().getId();}else{return this._getMenu().getId();}};
g.prototype.openAsContextMenu=function(o,O){if(b.system.phone){this._openDialog();}else{if(!this._bIsInitialized){this._initAllMenuItems();this._bIsInitialized=true;}this._getMenu().openAsContextMenu(o,O);}};
["addStyleClass","removeStyleClass","toggleStyleClass"].forEach(function(m){g.prototype[m]=function(s,S){var o=this._getDialog();C.prototype[m].apply(this,arguments);if(o){o[m].apply(o,arguments);}return this;};});return g;});
sap.ui.predefine('sap/m/MenuButton',['./library','sap/ui/core/Control','./Button','./SplitButton','sap/ui/Device','sap/ui/core/EnabledPropagator','sap/ui/core/library','sap/ui/core/Popup','sap/ui/core/LabelEnablement',"./MenuButtonRenderer","sap/ui/events/KeyCodes"],function(l,C,B,S,D,E,c,P,L,M,K){"use strict";var a=l.MenuButtonMode;var T=c.TextDirection;var b=l.ButtonType;var d=P.Dock;var n=["buttonMode","useDefaultActionOnly","width","menuPosition"];
var e=C.extend("sap.m.MenuButton",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:b.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},buttonMode:{type:"sap.m.MenuButtonMode",group:"Misc",defaultValue:a.Regular},menuPosition:{type:"sap.ui.core.Popup.Dock",group:"Misc",defaultValue:d.BeginBottom},useDefaultActionOnly:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{menu:{type:"sap.m.Menu",multiple:false,singularName:"menu"},_button:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{defaultAction:{},beforeMenuOpen:{}},defaultAggregation:"menu",designtime:"sap/m/designtime/MenuButton.designtime",dnd:{draggable:true,droppable:false}}});
E.call(e.prototype);
e.prototype.init=function(){this._initButtonControl();};
e.prototype.exit=function(){if(this._sDefaultText){this._sDefaultText=null;}if(this._sDefaultIcon){this._sDefaultIcon=null;}if(this._iInitialTextBtnContentWidth){this._iInitialTextBtnContentWidth=null;}if(this._lastActionItemId){this._lastActionItemId=null;}if(this.getMenu()){this.getMenu().detachClosed(this._menuClosed,this);}};
e.prototype.onBeforeRendering=function(){if(!this._sDefaultText){this._sDefaultText=this.getText();}if(!this._sDefaultIcon){this._sDefaultIcon=this.getIcon();}this._updateButtonControl();this._attachMenuEvents();};
e.prototype._needsWidth=function(){return this._isSplitButton()&&this.getWidth()==="";};
e.prototype._getTextBtnContentDomRef=function(){return this._getButtonControl()._getTextButton().getDomRef("content");};
e.prototype.onAfterRendering=function(){if(this._needsWidth()&&sap.ui.getCore().isThemeApplied()&&this._getTextBtnContentDomRef()&&this._getInitialTextBtnWidth()>0){this._getTextBtnContentDomRef().style.width=this._getInitialTextBtnWidth()+'px';}if(this._activeButton){this._activeButton.$().attr("aria-expanded","false");this._activeButton=null;}};
e.prototype.onThemeChanged=function(o){if(this._needsWidth()&&this.getDomRef()&&!this._iInitialTextBtnContentWidth&&this._getTextBtnContentDomRef()&&this._getInitialTextBtnWidth()>0){this._getTextBtnContentDomRef().style.width=this._getInitialTextBtnWidth()+'px';}};
e.prototype._getInitialTextBtnWidth=function(){if(!this._iInitialTextBtnContentWidth){this._iInitialTextBtnContentWidth=Math.ceil(this._getTextBtnContentDomRef().getBoundingClientRect().width);}return this._iInitialTextBtnContentWidth;};
e.prototype.setButtonMode=function(m){var t=this.getTooltip(),o,f;C.prototype.setProperty.call(this,"buttonMode",m,true);this._getButtonControl().destroy();this._initButtonControl();o=this._getButtonControl();f=o.getMetadata().getAllProperties();for(var k in this.mProperties){if(this.mProperties.hasOwnProperty(k)&&n.indexOf(k)<0&&f.hasOwnProperty(k)){o.setProperty(k,this.mProperties[k],true);}}if(t){o.setTooltip(t);}if(!this._isSplitButton()&&this._sDefaultText){this.setText(this._sDefaultText);}else if(!this.getUseDefaultActionOnly()&&this._getLastSelectedItem()){this.setText(sap.ui.getCore().byId(this._getLastSelectedItem()).getText());}if(!this._isSplitButton()&&this._sDefaultIcon){this.setIcon(this._sDefaultIcon);}else if(!this.getUseDefaultActionOnly()&&this._getLastSelectedItem()){this.setIcon(sap.ui.getCore().byId(this._getLastSelectedItem()).getIcon());}this.invalidate();return this;};
e.prototype._initButton=function(){var o=new B(this.getId()+"-internalBtn",{width:"100%",ariaHasPopup:c.aria.HasPopup.Menu});o.attachPress(this._handleButtonPress,this);o.onkeydown=this.handleKeydown;return o;};
e.prototype._initSplitButton=function(){var o=new S(this.getId()+"-internalSplitBtn",{width:"100%"});o.attachPress(this._handleActionPress,this);o.attachArrowPress(this._handleButtonPress,this);o._getArrowButton().onkeydown=this.handleKeydown;return o;};
e.prototype._initButtonControl=function(){var o;if(this._isSplitButton()){o=this._initSplitButton();}else{o=this._initButton();}this.setAggregation("_button",o,true);};
e.prototype._updateButtonControl=function(){this._getButtonControl().setText(this.getText());};
e.prototype._getButtonControl=function(){return this.getAggregation("_button");};
e.prototype._handleButtonPress=function(w){var m=this.getMenu(),o={zero:"0 0",plus2_right:"0 +2",minus2_right:"0 -2",plus2_left:"+2 0",minus2_left:"-2 0"};this._isSplitButton()&&this.fireBeforeMenuOpen();if(!m){return;}if(this._bPopupOpen){this.getMenu().close();this._bPopupOpen=false;return;}if(!m.getTitle()){m.setTitle(this.getText());}var p=[this,w];switch(this.getMenuPosition()){case d.BeginTop:p.push(d.BeginBottom,d.BeginTop,o.plus2_right);break;case d.BeginCenter:p.push(d.BeginCenter,d.BeginCenter,o.zero);break;case d.LeftTop:p.push(d.RightBottom,d.LeftBottom,o.plus2_left);break;case d.LeftCenter:p.push(d.RightCenter,d.LeftCenter,o.plus2_left);break;case d.LeftBottom:p.push(d.RightTop,d.LeftTop,o.plus2_left);break;case d.CenterTop:p.push(d.CenterBottom,d.CenterTop,o.plus2_left);break;case d.CenterCenter:p.push(d.CenterCenter,d.CenterCenter,o.zero);break;case d.CenterBottom:p.push(d.CenterTop,d.CenterBottom,o.minus2_right);break;case d.RightTop:p.push(d.LeftBottom,d.RightBottom,o.minus2_left);break;case d.RightCenter:p.push(d.LeftCenter,d.RightCenter,o.minus2_left);break;case d.RightBottom:p.push(d.LeftTop,d.RightTop,o.minus2_left);break;case d.EndTop:p.push(d.EndBottom,d.EndTop,o.plus2_right);break;case d.EndCenter:p.push(d.EndCenter,d.EndCenter,o.zero);break;case d.EndBottom:p.push(d.EndTop,d.EndBottom,o.minus2_right);break;case d.BeginBottom:default:p.push(d.BeginTop,d.BeginBottom,o.minus2_right);break;}m.openBy.apply(m,p);if(this.getMenu()){this._bPopupOpen=true;}this._writeAriaAttributes();if(this._isSplitButton()&&!D.system.phone){this._getButtonControl().setArrowState(true);}};
e.prototype._handleActionPress=function(){var s=this._getLastSelectedItem(),o;if(!this.getUseDefaultActionOnly()&&s){o=sap.ui.getCore().byId(s);this.getMenu().fireItemSelected({item:o});}else{this.fireDefaultAction();}};
e.prototype._menuClosed=function(){var o=this._getButtonControl(),O=o;this._bPopupOpen=false;if(this._isSplitButton()){o.setArrowState(false);O=o._getArrowButton();}O.$().removeAttr("aria-controls");O.$().attr("aria-expanded","false");};
e.prototype._menuItemSelected=function(o){var m=o.getParameter("item");this.fireEvent("_menuItemSelected",{item:m});this._bPopupOpen=false;if(!this._isSplitButton()||this.getUseDefaultActionOnly()||!m){return;}this._lastActionItemId=m.getId();!!this._sDefaultText&&this.setText(m.getText());!!this._sDefaultIcon&&this.setIcon(m.getIcon());};
e.prototype._getLastSelectedItem=function(){return this._lastActionItemId;};
e.prototype._attachMenuEvents=function(){if(this.getMenu()){this.getMenu().attachClosed(this._menuClosed,this);this.getMenu().attachItemSelected(this._menuItemSelected,this);}};
e.prototype._isSplitButton=function(){return this.getButtonMode()===a.Split;};
e.prototype.setProperty=function(p,v,s){function i(t){var f=[b.Up,b.Back,b.Unstyled];return f.indexOf(t)!==-1;}if(p==="type"&&i(v)){return this;}if(p==='text'){this._sDefaultText=v;}switch(p){case'activeIcon':case'iconDensityAware':case'textDirection':case'visible':case'enabled':this._getButtonControl().setProperty(p,v);break;}return C.prototype.setProperty.apply(this,arguments);};
e.prototype.setTooltip=function(t){this._getButtonControl().setTooltip(t);return C.prototype.setTooltip.apply(this,arguments);};
e.prototype.setText=function(v){C.prototype.setProperty.call(this,'text',v);this._getButtonControl().setText(v);return this;};
e.prototype.setType=function(v){C.prototype.setProperty.call(this,'type',v);this._getButtonControl().setType(v);return this;};
e.prototype.setIcon=function(v){C.prototype.setProperty.call(this,'icon',v);this._getButtonControl().setIcon(v);return this;};
e.prototype.addAriaLabelledBy=function(A){this.getAggregation("_button").addAssociation("ariaLabelledBy",A);return C.prototype.addAssociation.call(this,"ariaLabelledBy",A);};
e.prototype.addAriaDescribedBy=function(A){this.getAggregation("_button").addAssociation("ariaDescribedBy",A);return C.prototype.addAssociation.call(this,"ariaDescribedBy",A);};
e.prototype.removeAriaLabelledBy=function(A){this.getAggregation("_button").removeAssociation("ariaLabelledBy",A);return C.prototype.removeAssociation.call(this,"ariaLabelledBy",A);};
e.prototype.removeAriaDescribedBy=function(A){this.getAggregation("_button").removeAssociation("ariaDescribedBy",A);return C.prototype.removeAssociation.call(this,"ariaDescribedBy",A);};
e.prototype.removeAllAriaLabelledBy=function(A){this.getAggregation("_button").removeAllAssociation("ariaLabelledBy");return C.prototype.removeAllAssociation.call(this,"ariaLabelledBy");};
e.prototype.removeAllAriaDescribedBy=function(){this.getAggregation("_button").removeAllAssociation("ariaDescribedBy");return C.prototype.removeAllAssociation.call(this,"ariaDescribedBy");};
e.prototype.getFocusDomRef=function(){return this._getButtonControl().getDomRef();};
e.prototype.onsapup=function(o){this.openMenuByKeyboard();o.stopPropagation();};
e.prototype.onsapdown=function(o){this.openMenuByKeyboard();o.stopPropagation();};
e.prototype.onsapupmodifiers=function(o){this.openMenuByKeyboard();o.stopPropagation();};
e.prototype.onsapdownmodifiers=function(o){this.openMenuByKeyboard();o.stopPropagation();};
e.prototype.onsapshow=function(o){this.openMenuByKeyboard();!!o&&o.preventDefault();};
e.prototype.ontouchstart=function(){this._bPopupOpen=this.getMenu()&&this.getMenu()._getMenu()&&this.getMenu()._getMenu().getPopup().isOpen();};
e.prototype.handleKeydown=function(o){if((o.keyCode===K.ENTER||o.keyCode===K.TAB)&&this._bPopupOpen){this.getMenu().close();this._bPopupOpen=false;}B.prototype.onkeydown.call(this,o);};
e.prototype.openMenuByKeyboard=function(){if(!this._isSplitButton()){this._handleButtonPress(true);}};
e.prototype._writeAriaAttributes=function(){var o=this._getButtonControl(),O=this._isSplitButton()?o._getArrowButton():o,m=this.getMenu();if(m){O.$().attr("aria-controls",m.getDomRefId());O.$().attr("aria-expanded","true");}};
e.prototype.getIdForLabel=function(){return this.getId()+"-internalBtn";};
e.prototype._ensureBackwardsReference=function(){var i=this._getButtonControl(),I=i.getAriaLabelledBy(),r=L.getReferencingLabels(this);r.forEach(function(s){if(I&&I.indexOf(s)===-1){i.addAriaLabelledBy(s);}});return this;};
return e;});
sap.ui.predefine('sap/m/MenuButtonRenderer',[],function(){"use strict";var M={apiVersion:2};M.CSS_CLASS="sapMMenuBtn";
M.render=function(r,m){var w=m.getWidth();r.openStart("div",m);r.class(M.CSS_CLASS).class(M.CSS_CLASS+m.getButtonMode());if(w!=""){r.style("width",w);}r.openEnd();m._ensureBackwardsReference();r.renderControl(m._getButtonControl());m._activeButton=m._isSplitButton()?m._getButtonControl()._getArrowButton():m._getButtonControl();r.close("div");};
return M;},true);
sap.ui.predefine('sap/m/MenuItem',['./library','sap/ui/core/Item','sap/ui/base/ManagedObjectObserver'],function(l,I,M){"use strict";
var a=I.extend("sap.m.MenuItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},startsSection:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MenuItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{press:{},propertyChanged:{parameters:{propertyKey:{type:"string"},propertyValue:{type:"any"}}},aggregationChanged:{parameters:{aggregationName:{type:"string"},methodName:{type:"string"},methodParams:{type:"object"}}}}}});
a.UNIFIED_MENU_ITEMS_ID_SUFFIX='-unifiedmenu';
a.prototype.exit=function(){if(this._sVisualChild){this._sVisualChild=null;}if(this._sVisualParent){this._sVisualParent=null;}if(this._sVisualControl){this._sVisualControl=null;}};
a.prototype.setProperty=function(p,P){I.prototype.setProperty.apply(this,arguments);this.fireEvent("propertyChanged",{propertyKey:p,propertyValue:P});};
a.prototype.setAggregation=function(A,o,s){I.prototype.setAggregation.apply(this,arguments);this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"set",methodParams:{item:o}});return this;};
a.prototype.addAggregation=function(A,o,s){var v=this._getVisualControl(),V;I.prototype.addAggregation.apply(this,arguments);if(A==='customData'&&v){V=sap.ui.getCore().byId(v);this._addCustomData(V,o);}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"add",methodParams:{item:o}});return this;};
a.prototype.insertAggregation=function(A,o,i,s){var v=this._getVisualControl(),V;I.prototype.insertAggregation.apply(this,arguments);if(A==='customData'&&v){V=sap.ui.getCore().byId(v);V.insertCustomData(o.clone(a.UNIFIED_MENU_ITEMS_ID_SUFFIX),i);this._observeCustomDataChanges(o);}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"insert",methodParams:{item:o,index:i}});return this;};
a.prototype.removeAggregation=function(A,o,s){var O=I.prototype.removeAggregation.apply(this,arguments);if(A==="customData"){if(this.getCustomData().length===1){this._disconnectAndDestroyCustomDataObserver();}else if(o&&this._oCustomDataObserver){this._oCustomDataObserver.unobserve(o,{properties:["value"]});}}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"remove",methodParams:{item:O}});return O;};
a.prototype.removeAllAggregation=function(A,s){var o=I.prototype.removeAllAggregation.apply(this,arguments);if(A==='customData'){this._disconnectAndDestroyCustomDataObserver();}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"removeall",methodParams:{items:o}});return o;};
a.prototype.destroyAggregation=function(A,s){if(A==='customData'){this._disconnectAndDestroyCustomDataObserver();}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"destroy"});return I.prototype.destroyAggregation.apply(this,arguments);};
a.prototype.destroy=function(){var v=sap.ui.getCore().byId(this._getVisualControl());if(v){v.destroy();}return I.prototype.destroy.apply(this,arguments);};
a.prototype._addCustomData=function(v,c){v.addCustomData(c.clone(a.UNIFIED_MENU_ITEMS_ID_SUFFIX,undefined,{bCloneChildren:false,bCloneBindings:true}));this._observeCustomDataChanges(c);};
a.prototype._observeCustomDataChanges=function(c){this._getCustomDataObserver().observe(c,{properties:["value"]});};
a.prototype._customDataObserverCallbackFunction=function(c){sap.ui.getCore().byId(c.object.getId()+"-"+a.UNIFIED_MENU_ITEMS_ID_SUFFIX).setValue(c.current);};
a.prototype._getCustomDataObserver=function(){if(!this._oCustomDataObserver){this._oCustomDataObserver=new M(this._customDataObserverCallbackFunction);}return this._oCustomDataObserver;};
a.prototype._disconnectAndDestroyCustomDataObserver=function(){if(this._oCustomDataObserver){this._oCustomDataObserver.disconnect();this._oCustomDataObserver.destroy();this._oCustomDataObserver=null;}};
a.prototype._setVisualChild=function(c){this._setInternalRef(c,"_sVisualChild");};
a.prototype._setVisualParent=function(c){this._setInternalRef(c,"_sVisualParent");};
a.prototype._setVisualControl=function(c){this._setInternalRef(c,"_sVisualControl");};
a.prototype._setInternalRef=function(c,i){if(!c||typeof c==="string"){this[i]=c;}else if(c.getId){this[i]=c.getId();}};
a.prototype._getVisualChild=function(){return this._sVisualChild;};
a.prototype._getVisualParent=function(){return this._sVisualParent;};
a.prototype._getVisualControl=function(){return this._sVisualControl;};
return a;});
sap.ui.predefine('sap/m/MenuListItem',['./ListItemBase','./library','sap/ui/core/IconPool','sap/ui/core/library','./MenuListItemRenderer'],function(L,l,I,c,M){"use strict";var T=c.TextDirection;var a=l.ListType;
var b=L.extend("sap.m.MenuListItem",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Misc",defaultValue:true},title:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},startsSection:{type:"boolean",group:"Behavior",defaultValue:false}},associations:{menuItem:{type:"sap.m.MenuItem",multiple:false}}}});
b.prototype.exit=function(){if(this._image){this._image.destroy();}if(this._imageRightArrow){this._imageRightArrow.destroy();}L.prototype.exit.apply(this,arguments);};
b.prototype._getImage=function(i,s,S,d){var o=this._image;if(o){o.setSrc(S);if(o instanceof sap.m.Image){o.setDensityAware(d);}}else{o=I.createControlByURI({id:i,src:S,densityAware:d,useIconTooltip:false},sap.m.Image).setParent(this,null,true);}if(o instanceof sap.m.Image){o.addStyleClass(s,true);}else{o.addStyleClass(s+"Icon",true);}this._image=o;return this._image;};
b.prototype._getIconArrowRight=function(){if(!this._imageRightArrow){this._imageRightArrow=I.createControlByURI({id:this.getId()+"-arrowRight",src:"sap-icon://slim-arrow-right",useIconTooltip:false},sap.m.Image).setParent(this,null,true);this._imageRightArrow.addStyleClass("sapMMenuLIArrowRightIcon",true);}return this._imageRightArrow;};
b.prototype._hasSubItems=function(){return!!(this.getMenuItem()&&sap.ui.getCore().byId(this.getMenuItem()).getItems().length);};
b.prototype.setProperty=function(p,P){L.prototype.setProperty.apply(this,arguments);this.fireEvent("propertyChanged",{propertyKey:p,propertyValue:P});if(p==="enabled"){this.setType(P?a.Active:a.Inactive);}};
return b;});
sap.ui.predefine('sap/m/MenuListItemRenderer',['./ListItemBaseRenderer','sap/ui/core/Renderer','sap/m/library','sap/ui/core/library'],function(L,R,l,c){"use strict";var T=c.TextDirection;var a=l.ListType;var M=R.extend(L);M.apiVersion=2;
M.openItemTag=function(r,o){if(o.getStartsSection()){r.openStart("li");r.attr("role","separator");r.class("sapUiMnuDiv");r.openEnd();r.openStart("div");r.class("sapUiMnuDivL");r.openEnd();r.close("div");r.voidStart("hr").voidEnd();r.openStart("div");r.class("sapUiMnuDivR");r.openEnd();r.close("div");r.close("li");}L.openItemTag(r,o);};
M.renderLIAttributes=function(r,o){r.class("sapMSLI");if(o.getIcon()){r.class("sapMSLIIcon");}if(o.getType()==a.Detail||o.getType()==a.DetailAndActive){r.class("sapMSLIDetail");}if(o._hasSubItems()){r.class("sapMMenuLIHasChildren");}if(!o.getEnabled()){r.class("sapMMLIDisabled");}};
M.renderLIContent=function(r,o){var t=o.getTitleTextDirection();if(o.getIcon()){r.renderControl(o._getImage((o.getId()+"-img"),"sapMMenuLIImgThumb",o.getIcon(),o.getIconDensityAware()));}r.openStart("div");r.class("sapMSLIDiv");r.class("sapMSLITitleDiv");r.openEnd();if(o._bNoFlex){r.openStart("div");r.class("sapMLIBNoFlex");r.openEnd();}r.openStart("div");r.class("sapMSLITitleOnly");if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();r.text(o.getTitle());r.close("div");if(o._bNoFlex){r.close('div');}r.close("div");if(o._hasSubItems()){r.renderControl(o._getIconArrowRight());}};
return M;},true);
sap.ui.predefine('sap/m/MessageBox',['./Button','./Dialog','./Text','./FormattedText','./Link','./VBox','sap/ui/core/IconPool','sap/ui/core/ElementMetadata','sap/ui/core/library','sap/ui/core/Control','sap/m/library',"sap/ui/thirdparty/jquery"],function(B,D,T,F,L,V,I,E,c,C,l,q){"use strict";var a=l.DialogType;var b=l.DialogRoleType;var d=c.TextDirection;var e=l.ButtonType;var f=l.TitleAlignment;var M={};M.Action={OK:"OK",CANCEL:"CANCEL",YES:"YES",NO:"NO",ABORT:"ABORT",RETRY:"RETRY",IGNORE:"IGNORE",CLOSE:"CLOSE",DELETE:"DELETE"};M.Icon={NONE:undefined,INFORMATION:"INFORMATION",WARNING:"WARNING",ERROR:"ERROR",SUCCESS:"SUCCESS",QUESTION:"QUESTION"};(function(){var A=M.Action,g=M.Icon;var _=function(){if(M._rb!==sap.ui.getCore().getLibraryResourceBundle("sap.m")){M._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");}};
M.show=function(m,o){var h,j,v,r=null,k=[],i,s,t,n,p,u,w,x={id:E.uid("mbox"),initialFocus:null,textDirection:d.Inherit,verticalScrolling:true,horizontalScrolling:true,details:"",contentWidth:null},y={"INFORMATION":"sapMMessageBoxInfo","WARNING":"sapMMessageBoxWarning","ERROR":"sapMMessageBoxError","SUCCESS":"sapMMessageBoxSuccess","QUESTION":"sapMMessageBoxQuestion","STANDARD":"sapMMessageBoxStandard"},z={"INFORMATION":I.getIconURI("information"),"WARNING":I.getIconURI("alert"),"ERROR":I.getIconURI("error"),"SUCCESS":I.getIconURI("sys-enter-2"),"QUESTION":I.getIconURI("sys-help-2")};_();if(typeof o==="string"||arguments.length>2){s=arguments[1];t=arguments[2];n=arguments[3];p=arguments[4];u=arguments[5];w=arguments[6];o={icon:s,title:t,actions:n,onClose:p,id:u,styleClass:w};}if(o&&o.hasOwnProperty("details")){x.icon=g.INFORMATION;x.emphasizedAction=A.OK;x.actions=[A.OK,A.CANCEL];o=q.extend({},x,o);}o=q.extend({},x,o);if(typeof o.actions!=="undefined"&&!Array.isArray(o.actions)){if(o.emphasizedAction!==null){o.emphasizedAction=o.actions;}o.actions=[o.actions];}if(!o.actions||o.actions.length===0){o.emphasizedAction=A.OK;o.actions=[A.OK];}function G(O,H){var P;if(M.Action.hasOwnProperty(O)){P=M._rb.getText("MSGBOX_"+O);}var Q=new B({id:E.uid("mbox-btn-"),text:P||O,type:H,press:function(){r=O;h.close();}});return Q;}var H;for(i=0;i<o.actions.length;i++){H=o.emphasizedAction===o.actions[i]?e.Emphasized:e.Default;k.push(G(o.actions[i],H));}function J(o,j){var O,S,P=new V({items:[j]});if(!o.details){return P;}if(typeof o.details=='object'){o.details="<pre>"+JSON.stringify(o.details,null,'\t').replace(/{/gi,"&#x007B;")+"</pre>";}O=new F().setVisible(false).setHtmlText(o.details);S=new L({text:M._rb.getText("MSGBOX_LINK_TITLE"),press:function(){var Q=h.getInitialFocus();h.addAriaLabelledBy(O);O.setVisible(true);S.setVisible(false);h._setInitialFocus();if(!Q||Q===S.getId()){k[0].focus();}}});S.addStyleClass("sapMMessageBoxLinkText");O.addStyleClass("sapMMessageBoxDetails");P.addItem(S);P.addItem(O);return P;}function K(){if(typeof o.onClose==="function"){o.onClose(r);}h.detachAfterClose(K);h.destroy();}function N(){var i=0;var O=null;if(o.initialFocus){if(o.initialFocus instanceof C){O=o.initialFocus;}if(typeof o.initialFocus==="string"){for(i=0;i<k.length;i++){if(M.Action.hasOwnProperty(o.initialFocus)){if(M._rb.getText("MSGBOX_"+o.initialFocus).toLowerCase()===k[i].getText().toLowerCase()){O=k[i];break;}}else{if(o.initialFocus.toLowerCase()===k[i].getText().toLowerCase()){O=k[i];break;}}}}}return O;}if(typeof(m)==="string"){v=new T({textDirection:o.textDirection}).setText(m).addStyleClass("sapMMsgBoxText");j=v;}else if(m instanceof C){v=m.addStyleClass("sapMMsgBoxText");}if(o&&o.hasOwnProperty("details")&&o.details!==""){v=J(o,v);}h=new D({id:o.id,type:a.Message,title:o.title,titleAlignment:f.Auto,content:v,icon:z[o.icon],initialFocus:N(),verticalScrolling:o.verticalScrolling,horizontalScrolling:o.horizontalScrolling,afterClose:K,buttons:k,ariaLabelledBy:j?j.getId():undefined,contentWidth:o.contentWidth,closeOnNavigation:o.closeOnNavigation}).addStyleClass("sapMMessageBox");h.setProperty("role",b.AlertDialog);if(y[o.icon]){h.addStyleClass(y[o.icon]);}else{h.addStyleClass(y.STANDARD);}if(o.styleClass){h.addStyleClass(o.styleClass);}h.open();};
M.alert=function(m,o){_();var h={icon:g.NONE,title:M._rb.getText("MSGBOX_TITLE_ALERT"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("alert"),initialFocus:null},i,t,s,S;if(typeof o==="function"||arguments.length>2){i=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:i,title:t,id:s,styleClass:S};}o=q.extend({},h,o);return M.show(m,o);};
M.confirm=function(m,o){_();var h={icon:g.QUESTION,title:M._rb.getText("MSGBOX_TITLE_CONFIRM"),emphasizedAction:o&&o.actions?null:A.OK,actions:[A.OK,A.CANCEL],id:E.uid("confirm"),initialFocus:null},i,t,s,S;if(typeof o==="function"||arguments.length>2){i=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:i,title:t,id:s,styleClass:S};}o=q.extend({},h,o);return M.show(m,o);};
M.error=function(m,o){_();var h={icon:g.ERROR,title:M._rb.getText("MSGBOX_TITLE_ERROR"),emphasizedAction:null,actions:A.CLOSE,id:E.uid("error"),initialFocus:null};o=q.extend({},h,o);return M.show(m,o);};
M.information=function(m,o){_();var h={icon:g.INFORMATION,title:M._rb.getText("MSGBOX_TITLE_INFO"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("info"),initialFocus:null};o=q.extend({},h,o);return M.show(m,o);};
M.warning=function(m,o){_();var h={icon:g.WARNING,title:M._rb.getText("MSGBOX_TITLE_WARNING"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("warning"),initialFocus:null};o=q.extend({},h,o);return M.show(m,o);};
M.success=function(m,o){_();var h={icon:g.SUCCESS,title:M._rb.getText("MSGBOX_TITLE_SUCCESS"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("success"),initialFocus:null};o=q.extend({},h,o);return M.show(m,o);};
}());return M;},true);
sap.ui.predefine('sap/m/MessageItem',["./library","sap/ui/core/Item","sap/ui/core/library","sap/base/Log","sap/base/security/sanitizeHTML"],function(l,I,c,L,s){"use strict";var M=c.MessageType;
var a=I.extend("sap.m.MessageItem",{metadata:{library:"sap.m",properties:{type:{type:"sap.ui.core.MessageType",group:"Appearance",defaultValue:M.Error},title:{type:"string",group:"Appearance",defaultValue:""},subtitle:{type:"string",group:"Misc",defaultValue:null},description:{type:"string",group:"Appearance",defaultValue:""},markupDescription:{type:"boolean",group:"Appearance",defaultValue:false},longtextUrl:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},counter:{type:"int",group:"Misc",defaultValue:null},groupName:{type:"string",group:"Misc",defaultValue:""},activeTitle:{type:"boolean",group:"Misc",defaultValue:false}},defaultAggregation:"link",aggregations:{link:{type:"sap.m.Link",multiple:false,singularName:"link"}}}});
a.prototype.setProperty=function(p,v,S){var P=this.getParent(),t=this.getType().toLowerCase(),b=["description","type","groupName"],u=function(n,i){if(i._oMessagePopoverItem.getId()===this.getId()&&i.getMetadata().getProperty(n)){i.setProperty(n,v);}};if(b.indexOf(p)===-1&&P&&("_bItemsChanged"in P)&&!P._bItemsChanged){P._oLists&&P._oLists.all&&P._oLists.all.getItems&&P._oLists.all.getItems().forEach(u.bind(this,p));P._oLists&&P._oLists[t]&&P._oLists[t].getItems&&P._oLists[t].getItems().forEach(u.bind(this,p));}if(typeof this._updatePropertiesFn==="function"){this._updatePropertiesFn();}return I.prototype.setProperty.apply(this,arguments);};
a.prototype._updateProperties=function(b){this._updatePropertiesFn=b;};
a.prototype.setType=function(t){if(t===M.None){t=M.Information;L.warning("The provided None type is handled and rendered as Information type");}return this.setProperty("type",t,true);};
return a;});
sap.ui.predefine('sap/m/MessageListItem',["sap/ui/core/library","sap/ui/core/InvisibleText","./library",'./StandardListItem','./Link',"./MessageListItemRenderer"],function(c,I,l,S,L,M){"use strict";var a=c.MessageType;
var b=S.extend("sap.m.MessageListItem",{metadata:{library:"sap.m",properties:{activeTitle:{type:"boolean",group:"Misc",defaultValue:false},messageType:{type:"sap.ui.core.MessageType",group:"Appearance",defaultValue:a.Error}},aggregations:{link:{type:"sap.m.Link",group:"Misc",multiple:false},linkAriaDescribedBy:{type:"sap.ui.core.Control",group:"Misc",multiple:false}},events:{activeTitlePress:{}}}});
b.prototype.onBeforeRendering=function(){S.prototype.onBeforeRendering.apply(this,arguments);var o=this.getLink(),d;if(!o&&this.getActiveTitle()){o=new L({press:[this.fireActiveTitlePress,this]});this.setLink(o);}if(o&&!o.getAriaDescribedBy().length){d=this._getLinkAriaDescribedBy();o.setProperty("text",this.getTitle(),true);o.addAssociation('ariaDescribedBy',d.getId(),true);this.setAggregation("linkAriaDescribedBy",d,true);}};
b.prototype._getLinkAriaDescribedBy=function(){var A=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("MESSAGE_VIEW_LINK_FOCUS_TEXT",[this.getMessageType()]);return new I(this.getId()+"-link",{text:A});};
b.prototype.onkeydown=function(e){if(this.getActiveTitle()&&e.altKey&&e.key==='Enter'){this.fireActiveTitlePress(this);}};
b.prototype.getContentAnnouncement=function(B){var A=S.prototype.getContentAnnouncement.apply(this,arguments),s,m;if(this.getActiveTitle()){m=B.getText("MESSAGEVIEW_BUTTON_TOOLTIP_"+this.getMessageType().toUpperCase());s=B.getText("MESSAGE_LIST_ITEM_FOCUS_TEXT",[m]);A+=" ".concat(s);}return A;};
return b;});
sap.ui.predefine('sap/m/MessageListItemRenderer',["./StandardListItemRenderer","sap/ui/core/Renderer"],function(S,R){"use strict";var M=R.extend(S);M.apiVersion=2;
M.renderTitle=function(r,c){if(c.getActiveTitle()){r.renderControl(c.getLink());r.renderControl(c.getLinkAriaDescribedBy());}else{S.renderTitle.apply(this,arguments);}};
return M;},true);
sap.ui.predefine('sap/m/MessagePage',['./library','sap/ui/core/library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/base/ManagedObject','sap/m/Text','sap/m/Image','sap/m/Button','sap/m/Title','sap/m/Bar','sap/m/FormattedText','./MessagePageRenderer',"sap/ui/thirdparty/jquery"],function(l,c,C,I,M,T,a,B,b,d,F,e,q){"use strict";var f=c.TextAlign;var g=c.TextDirection;var h=l.ButtonType;var i=l.BarDesign;var j=c.TitleLevel;
var k=C.extend("sap.m.MessagePage",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:"No matching items found."},description:{type:"string",group:"Misc",defaultValue:"Check the filter settings."},title:{type:"string",group:"Misc",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:j.Auto},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:"sap-icon://documents"},iconAlt:{type:"string",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},enableFormattedText:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{customText:{type:"sap.m.Link",multiple:false},customDescription:{type:"sap.m.Link",multiple:false},buttons:{type:"sap.m.Button",multiple:true},_internalHeader:{type:"sap.m.Bar",multiple:false,visibility:"hidden"},_formattedText:{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"},_text:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_description:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{navButtonPress:{}},designtime:"sap/m/designtime/MessagePage.designtime"}});
k.ARIA_ROLE_DESCRIPTION="MESSAGE_PAGE_ROLE_DESCRIPTION";
k.prototype.init=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTitle=null;this._oNavButton=new B(this.getId()+"-navButton",{type:h.Back,press:q.proxy(function(){this.fireNavButtonPress();},this)});this.setAggregation("_internalHeader",new d(this.getId()+"-intHeader",{design:i.Header}));this.setProperty("text",o.getText("MESSAGE_PAGE_TEXT"),true);this.setProperty("description",o.getText("MESSAGE_PAGE_DESCRIPTION"),true);this._sAriaRoleDescription=o.getText(k.ARIA_ROLE_DESCRIPTION);};
k.prototype.exit=function(){if(this._oNavButton){this._oNavButton.destroy();this._oNavButton=null;}if(this._oIconControl){this._oIconControl.destroy();this._oIconControl=null;}};
k.prototype.setTitle=function(t){this.setProperty("title",t,true);this._getTitle().setText(t);return this;};
k.prototype.setTitleLevel=function(t){this.setProperty("titleLevel",t,true);this._getTitle().setLevel(t);return this;};
k.prototype.setText=function(t){this.setProperty("text",t,true);var o=this.getAggregation("_text");o&&o.setText(t);return this;};
k.prototype.setDescription=function(D){this.setProperty("description",D,true);var o=this.getAggregation("_formattedText"),m=this.getAggregation("_description");o&&o.setHtmlText(D);m&&m.setText(D);return this;};
k.prototype.setShowNavButton=function(s){this.setProperty("showNavButton",s,true);var H=this._getInternalHeader();if(s){H.addContentLeft(this._oNavButton);}else{H.removeAllContentLeft();}return this;};
k.prototype.setIcon=function(s){var v=this.getIcon()||"";s=s||"";if(v!==s){var S=!!v&&!!s&&I.isIconURI(s)===I.isIconURI(v);this.setProperty("icon",s,S);if(S&&this._oIconControl){this._oIconControl.setSrc(s);}}return this;};
k.prototype.setEnableFormattedText=function(E){var o;if(E){o=this._getFormattedText();o.setHtmlText(this.getDescription());}return this.setProperty("enableFormattedText",E);};
k.prototype._getIconControl=function(){if(this._oIconControl){this._oIconControl.destroy();this._oIconControl=null;}this._oIconControl=I.createControlByURI({id:this.getId()+"-pageIcon",src:this.getIcon(),height:"8rem",width:"8rem",useIconTooltip:true,decorative:false,alt:this.getIconAlt()},a).addStyleClass("sapMMessagePageIcon");return this._oIconControl;};
k.prototype._getText=function(){if(this.getAggregation("customText")){return this.getAggregation("customText");}if(!this.getAggregation("_text")){var t=new T(this.getId()+"-text",{id:this.getId()+"-customText",text:M.escapeSettingsValue(this.getText()),textAlign:f.Center,textDirection:this.getTextDirection()});this.setAggregation("_text",t);}return this.getAggregation("_text");};
k.prototype._getTitle=function(){if(!this._oTitle){this._oTitle=new b(this.getId()+"-title",{level:this.getTitleLevel()});this._getInternalHeader().addContentMiddle(this._oTitle);}return this._oTitle;};
k.prototype._getDescription=function(){if(this.getAggregation("customDescription")){return this.getAggregation("customDescription");}if(this.getEnableFormattedText()){return this._getFormattedText();}if(!this.getAggregation("_description")){var D=new T(this.getId()+"-description",{id:this.getId()+"-customDescription",text:M.escapeSettingsValue(this.getDescription()),textAlign:f.Center,textDirection:this.getTextDirection()});this.setAggregation("_description",D);}return this.getAggregation("_description");};
k.prototype._getAnyHeader=function(){return this._getInternalHeader();};
k.prototype._getInternalHeader=function(){return this.getAggregation("_internalHeader");};
k.prototype._getFormattedText=function(){var o=this.getAggregation("_formattedText");if(!o){o=new F(this.getId()+"-formattedText");this.setAggregation("_formattedText",o);}return o;};
return k;});
sap.ui.predefine('sap/m/MessagePageRenderer',['sap/ui/core/library'],function(c){"use strict";var T=c.TextDirection;var M={apiVersion:2};
M.render=function(r,m){this.startOpeningDiv(r,m);this.renderHeader(r,m);this.startInnerDivs(r);this.renderContent(r,m);this.endInnerDivs(r);this.endOpeningDiv(r);};
M.startOpeningDiv=function(r,m){r.openStart("div",m);r.attr("aria-roledescription",m._sAriaRoleDescription);r.class("sapMMessagePage");if(m.getTextDirection()!==T.Inherit){r.attr("dir",m.getTextDirection().toLowerCase());}r.openEnd();};
M.renderHeader=function(r,m){if(m.getShowHeader()){r.renderControl(m.getAggregation("_internalHeader"));}};
M.startInnerDivs=function(r){r.openStart("div");r.class("sapMMessagePageInner");r.openEnd();r.openStart("div");r.class("sapMMessagePageContentWrapper");r.openEnd();};
M.renderContent=function(r,m){if(m.getIcon()){r.renderControl(m._getIconControl());}r.renderControl(m._getText().addStyleClass("sapMMessagePageMainText"));r.renderControl(m._getDescription().addStyleClass("sapMMessagePageDescription"));this.renderButtons(r,m);};
M.renderButtons=function(r,m){var b=m.getButtons();if(b.length>0){r.openStart("div");r.class("sapMMessagePageButtonsWrapper");r.openEnd();for(var i=0;i<b.length;i++){r.renderControl(b[i]);}r.close("div");}};
M.endInnerDivs=function(r){r.close("div");r.close("div");};
M.endOpeningDiv=function(r){r.close("div");};
return M;},true);
sap.ui.predefine('sap/m/MessagePopover',["./ResponsivePopover","./Button","./Toolbar","./Bar","sap/ui/core/Control","sap/ui/core/IconPool","./semantic/SemanticPage","./Popover","./MessageView","sap/ui/Device","./MessagePopoverRenderer","sap/base/Log","sap/ui/base/ManagedObjectObserver","sap/ui/thirdparty/jquery"],function(R,B,T,a,C,I,S,P,M,D,b,L,c,q){"use strict";
var d=C.extend("sap.m.MessagePopover",{metadata:{library:"sap.m",properties:{asyncDescriptionHandler:{type:"any",group:"Behavior",defaultValue:null},asyncURLHandler:{type:"any",group:"Behavior",defaultValue:null},placement:{type:"sap.m.VerticalPlacementType",group:"Behavior",defaultValue:"Vertical"},initiallyExpanded:{type:"boolean",group:"Behavior",defaultValue:true},groupItems:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MessageItem",altTypes:["sap.m.MessagePopoverItem"],multiple:true,singularName:"item"},headerButton:{type:"sap.m.Button",multiple:false,forwarding:{idSuffix:"-messageView",aggregation:"headerButton"}}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},itemSelect:{parameters:{item:{type:"sap.m.MessagePopoverItem"},messageTypeFilter:{type:"sap.ui.core.MessageType"}}},listSelect:{parameters:{messageTypeFilter:{type:"sap.ui.core.MessageType"}}},longtextLoaded:{},urlValidated:{},activeTitlePress:{parameters:{item:{type:"sap.m.MessageItem"}}}}}});
function e(n){return n.charAt(0).toUpperCase()+n.slice(1);}
var f="sapMMsgPopover",g="320px",h="440px",i={back:I.getIconURI("nav-back"),close:I.getIconURI("decline"),information:I.getIconURI("message-information"),warning:I.getIconURI("message-warning"),error:I.getIconURI("message-error"),success:I.getIconURI("message-success")},A=["asyncDescriptionHandler","asyncURLHandler"],j={asyncDescriptionHandler:function(k){var l=k.item.getLongtextUrl();if(l){q.ajax({type:"GET",url:l,success:function(m){k.item.setDescription(m);k.promise.resolve();},error:function(){var E="A request has failed for long text data. URL: "+l;L.error(E);k.promise.reject(E);}});}}};
d.setDefaultHandlers=function(m){A.forEach(function(F){if(m.hasOwnProperty(F)){j[F]=m[F];}});};
d.prototype.init=function(){var t=this;var p;this._oOpenByControl=null;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oMessageView=this._initMessageView();this._oMessageView.addEventDelegate({onBeforeRendering:function(){var s=t._oMessageView._oSegmentedButton.getVisible(),k=!t.getInitiallyExpanded()||s;t._oMessageView._oSegmentedButton.setVisible(k);t._oMessageView._listPage.setShowHeader(true);}});this._insertCloseBtn(this._oMessageView._oListHeader);this._insertCloseBtn(this._oMessageView._oDetailsHeader);this._oMessageView._oSegmentedButton.attachEvent("select",this._onSegButtonSelect,this);this._oPopover=new R(this.getId()+"-messagePopover",{showHeader:false,contentWidth:h,contentHeight:g,placement:this.getPlacement(),showCloseButton:false,verticalScrolling:false,horizontalScrolling:false,modal:false,afterOpen:function(E){t.fireAfterOpen({openBy:E.getParameter("openBy")});},afterClose:function(E){t._oMessageView._navContainer.backToTop();t.fireAfterClose({openBy:E.getParameter("openBy")});},beforeOpen:function(E){t.fireBeforeOpen({openBy:E.getParameter("openBy")});},beforeClose:function(E){t.fireBeforeClose({openBy:E.getParameter("openBy")});}}).addStyleClass(f);this._oPopover._setAriaModal(false);this._oPopover.addContent(this._oMessageView);this._oPopover.addAssociation("ariaLabelledBy",this.getId()+"-messageView-HeadingDescr",true);p=this._oPopover.getAggregation("_popup");p.oPopup.setAutoClose(false);p.addEventDelegate({onBeforeRendering:this.onBeforeRenderingPopover,onAfterRendering:this.onAfterRenderingPopover},this);if(D.system.phone){this._oPopover.setBeginButton(new B({text:this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE"),press:this.close.bind(this)}));}A.forEach(function(F){if(j.hasOwnProperty(F)){this['set'+e(F)](j[F]);}},this);this._observeItems();};
d.prototype._observeItems=function(){var o=new c(function(k){var m=k.mutation;var l=k.child;switch(m){case"insert":l.attachEvent("_change",this.invalidate,this);break;case"remove":l.detachEvent("_change",this.invalidate,this);break;default:break;}}.bind(this));o.observe(this,{aggregations:["items"]});};
d.prototype.onBeforeRendering=function(){if(this.getDependents().indexOf(this._oPopover)===-1){this.addDependent(this._oPopover);}this._oPopover.setPlacement(this.getPlacement());};
d.prototype.onBeforeRenderingPopover=function(){if(this._oMessageView&&this._bItemsChanged){var k=this.getItems();var t=this;this._oMessageView.destroyItems();k.forEach(function(l){l._updateProperties(function(){t._bItemsChanged=true;});this._oMessageView.addItem(l.clone("","",{cloneChildren:true,cloneBinding:true}));},this);this._bItemsChanged=false;}this._setInitialFocus();if(this._oOpenByControl&&!this._oOpenByControl.getVisible()){this._oPopover.close();}this._syncMessageView();};
d.prototype.onAfterRenderingPopover=function(){if(this._oPopover._oControl._sFocusControlId){this._oPopover._oControl._sFocusControlId=null;}};
d.prototype.exit=function(){this._oResourceBundle=null;this._oOpenByControl=null;if(this._oMessageView){this._oMessageView.destroy();this._oMessageView=null;}if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}};
d.prototype.openBy=function(o){var r=this._oPopover.getAggregation("_popup"),p=o.getParent();this._oOpenByControl=o;if(r instanceof P){if((p instanceof T||p instanceof a||p instanceof S)){r._minDimensions={width:400,height:128};r.setShowArrow(false);r.setResizable(true);}else{r.setShowArrow(true);}}if(this._oPopover){this._restoreExpansionDefaults();this._oPopover.openBy(o);}return this;};
d.prototype.close=function(){if(this._oPopover){this._oPopover.close();}return this;};
d.prototype.isOpen=function(){return this._oPopover?this._oPopover.isOpen():false;};
d.prototype.toggle=function(o){if(this.isOpen()){this.close();}else{this.openBy(o);}return this;};
d.prototype.getDomRef=function(s){return this._oPopover&&this._oPopover.getAggregation("_popup").getDomRef(s);};
d.prototype._initMessageView=function(){var t=this,m;m=new M(this.getId()+"-messageView",{activeTitlePress:function(E){if(D.system.phone){t.close();}t.fireActiveTitlePress({item:E.getParameter("item")});},listSelect:function(E){t.fireListSelect({messageTypeFilter:E.getParameter('messageTypeFilter')});},itemSelect:function(E){t.fireItemSelect({messageTypeFilter:E.getParameter('messageTypeFilter'),item:E.getParameter('item')});},longtextLoaded:function(){t.fireLongtextLoaded();},urlValidated:function(){t.fireUrlValidated();}});m._makeAutomaticBinding=function(){var k=t.getItems();if(!t.getBindingInfo("items")&&!k.length){this._bindToMessageModel();}};return m;};
d.prototype._onSegButtonSelect=function(){if(this.isOpen()&&!this.getInitiallyExpanded()&&this._oPopover.hasStyleClass(f+"-init")){this._expandMsgPopover();}};
d.prototype._restoreExpansionDefaults=function(){if(this._oMessageView&&!this.getInitiallyExpanded()&&this.getItems().length!=1){this._collapseMsgPopover();this._oMessageView._oSegmentedButton.setSelectedButton("none");}else{this._expandMsgPopover();}};
d.prototype._expandMsgPopover=function(){var s,H=g,s=this._oPopover.$("cont").css("height");if(this.getInitiallyExpanded()&&s!=="0px"){H=parseFloat(s)?s:H;}this._oPopover.setContentHeight(H).removeStyleClass(f+"-init");};
d.prototype._collapseMsgPopover=function(){this._oPopover.addStyleClass(f+"-init").setContentHeight("auto");};
d.prototype._insertCloseBtn=function(o){var s=this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE"),k=new B({icon:i["close"],visible:!D.system.phone,tooltip:s,press:this.close.bind(this)}).addStyleClass(f+"CloseBtn");o.insertContent(k,3,true);};
d.prototype._setInitialFocus=function(){if(this._oMessageView&&this._oMessageView._isListPage()&&this.getInitiallyExpanded()){this._oPopover.setInitialFocus(this._oMessageView._oLists[this._sCurrentList||'all']);}};
d.prototype._syncMessageView=function(){if(this._oMessageView){this._oMessageView.setProperty('asyncDescriptionHandler',this.getAsyncDescriptionHandler(),true);this._oMessageView.setProperty('asyncURLHandler',this.getAsyncURLHandler(),true);this._oMessageView.setProperty("groupItems",this.getGroupItems(),false);}};
d.prototype.setModel=function(m,n){if(this._oMessageView){this._oMessageView.setModel(m,n);}return C.prototype.setModel.apply(this,arguments);};
d.prototype.navigateBack=function(){if(this._oMessageView){this._oMessageView.navigateBack();}};
["invalidate","addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getBusyIndicatorDelay","setBusyIndicatorDelay","getVisible","setVisible","getBusy","setBusy"].forEach(function(n){d.prototype[n]=function(){if(this._oPopover&&this._oPopover[n]){var p=this._oPopover;var r=p[n].apply(p,arguments);return r===p?this:r;}};});["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(F){d.prototype["_"+F+"Old"]=d.prototype[F];d.prototype[F]=function(){var r=d.prototype["_"+F+"Old"].apply(this,arguments);this._bItemsChanged=true;if(this._oPopover){this._oPopover.invalidate();}if(["removeAggregation","removeAllAggregation"].indexOf(F)!==-1){return r;}return this;};});return d;});
sap.ui.predefine('sap/m/MessagePopoverItem',["./library","./MessageItem"],function(l,M){"use strict";
var a=M.extend("sap.m.MessagePopoverItem",{metadata:{deprecated:true}});
return a;});
sap.ui.predefine('sap/m/MessagePopoverRenderer',[],function(){"use strict";var M={apiVersion:2};
M.render=function(r,c){};
return M;},true);
sap.ui.predefine('sap/m/MessageStrip',["./library","sap/ui/core/Control","./MessageStripUtilities","./Text","./Link","./FormattedText","sap/ui/core/library","./MessageStripRenderer","sap/base/Log","sap/m/Button","sap/ui/core/Core","sap/ui/core/InvisibleText"],function(l,C,M,T,L,F,c,a,b,B,d,I){"use strict";var e=c.MessageType;var f=l.ButtonType;
var g=C.extend("sap.m.MessageStrip",{metadata:{library:"sap.m",designtime:"sap/m/designtime/MessageStrip.designtime",properties:{text:{type:"string",group:"Appearance",defaultValue:""},type:{type:"sap.ui.core.MessageType",group:"Appearance",defaultValue:e.Information},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},showIcon:{type:"boolean",group:"Appearance",defaultValue:false},showCloseButton:{type:"boolean",group:"Appearance",defaultValue:false},enableFormattedText:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"link",aggregations:{link:{type:"sap.m.Link",multiple:false,singularName:"link"},_formattedText:{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"},_text:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_closeButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{close:{}},dnd:{draggable:true,droppable:false}}});
g.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);this.setAggregation("_text",new T());this._initCloseButton();};
g.prototype.onBeforeRendering=function(){this._normalizeType(this.getType());this._setButtonAriaLabelledBy(this.getType());};
g.prototype.setText=function(t){var o=this.getAggregation("_formattedText");if(o){o.setHtmlText(t);}this.getAggregation("_text").setText(t);return this.setProperty("text",t);};
g.prototype.close=function(){var h=function(){this.setVisible(false);this.fireClose();}.bind(this);if(!d.getConfiguration().getAnimation()){h();return;}M.closeTransitionWithCSS.call(this,h);};
g.prototype.setEnableFormattedText=function(E){var o=this.getAggregation("_formattedText");if(E){if(!o){o=new F();o._setUseLimitedRenderingRules(true);this.setAggregation("_formattedText",o);}o.setHtmlText(this.getText());}return this.setProperty("enableFormattedText",E);};
g.prototype.setAggregation=function(n,o,s){if(n==="link"&&o instanceof L){var i=this.getId()+"-info"+" "+this.getId()+"-content",A=o.getAriaDescribedBy();if(!A.includes(i)){o.addAriaDescribedBy(i);}}C.prototype.setAggregation.call(this,n,o,s);return this;};
a.getAccessibilityState=function(){var A=M.getAccessibilityState.call(this),o=this.getLink(),r=d.getLibraryResourceBundle("sap.m");if(!o){A.labelledby=this.getId();}A.roledescription=r.getText("MESSAGE_STRIP_ARIA_ROLE_DESCRIPTION");return A;};
g.prototype.ontouchmove=function(E){E.setMarked();};
g.prototype._normalizeType=function(t){if(t===e.None){b.warning(M.MESSAGES.TYPE_NOT_SUPPORTED);this.setProperty("type",e.Information,true);}};
g.prototype._initCloseButton=function(){var r=d.getLibraryResourceBundle("sap.m"),o=this.getAggregation("_closeButton");if(!o){var h=new B({type:f.Transparent,tooltip:r.getText("MESSAGE_STRIP_TITLE"),icon:"sap-icon://decline",press:this.close.bind(this)}).addStyleClass(M.CLASSES.CLOSE_BUTTON).addStyleClass("sapUiSizeCompact");this.setAggregation("_closeButton",h);this._setButtonAriaLabelledBy(this.getType());}};
g.prototype._setButtonAriaLabelledBy=function(t){var o=this.getAggregation("_closeButton"),r=d.getLibraryResourceBundle("sap.m"),s=r.getText("MESSAGE_STRIP_"+t.toUpperCase()+"_CLOSE_BUTTON");if(!this._oInvisibleText){this._oInvisibleText=new I({text:s}).toStatic();}else{this._oInvisibleText.setText(s);}if(o){o.removeAllAssociation("ariaLabelledBy",true);o.addAssociation("ariaLabelledBy",this._oInvisibleText.getId(),true);}};
g.prototype.exit=function(){if(this._oInvisibleText){this._oInvisibleText.destroy();this._oInvisibleText=null;}};
return g;});
sap.ui.predefine('sap/m/MessageStripRenderer',["./MessageStripUtilities","sap/ui/core/IconPool"],function(M,I){"use strict";var a={apiVersion:2};
a.render=function(r,c){this.startMessageStrip(r,c);this.renderAriaTypeText(r,c);if(c.getShowIcon()){this.renderIcon(r,c);}this.renderTextAndLink(r,c);if(c.getShowCloseButton()){this.renderCloseButton(r,c);}this.endMessageStrip(r);};
a.startMessageStrip=function(r,c){r.openStart("div",c);r.class(M.CLASSES.ROOT);r.class(M.CLASSES.ROOT+c.getType());r.attr(M.ATTRIBUTES.CLOSABLE,c.getShowCloseButton());r.accessibilityState(c,this.getAccessibilityState.call(c));r.openEnd();};
a.renderAriaTypeText=function(r,c){r.openStart("span",c.getId()+"-info");r.class("sapUiPseudoInvisibleText");r.openEnd();r.text(M.getAriaTypeText.call(c));r.close("span");};
a.renderIcon=function(r,c){r.openStart("div");r.class(M.CLASSES.ICON);r.openEnd();r.icon(M.getIconURI.call(c),null,{"title":null,"aria-hidden":true});r.close("div");};
a.renderTextAndLink=function(r,c){var f=c.getAggregation("_formattedText");r.openStart("div",c.getId()+"-content");r.class(M.CLASSES.MESSAGE);r.openEnd();if(c.getEnableFormattedText()&&f){r.renderControl(f);}else{r.renderControl(c.getAggregation("_text"));}r.renderControl(c.getLink());r.close("div");};
a.renderCloseButton=function(r,c){r.renderControl(c.getAggregation("_closeButton"));};
a.endMessageStrip=function(r){r.close("div");};
return a;},true);
sap.ui.predefine('sap/m/MessageStripUtilities',['sap/ui/core/IconPool'],function(I){"use strict";var M={};M.MESSAGES={TYPE_NOT_SUPPORTED:"Value 'sap.ui.core.MessageType.None' for property 'type' is not supported. "+"Defaulting to 'sap.ui.core.MessageType.Information'"};M.CLASSES={ROOT:"sapMMsgStrip",ICON:"sapMMsgStripIcon",MESSAGE:"sapMMsgStripMessage",CLOSE_BUTTON:"sapMMsgStripCloseButton",CLOSING_TRANSITION:"sapMMsgStripClosing"};M.ATTRIBUTES={CLOSABLE:"data-sap-ui-ms-closable"};M.RESOURCE_BUNDLE=sap.ui.getCore().getLibraryResourceBundle("sap.m");
M.getIconURI=function(){var t=this.getType(),c=this.getCustomIcon(),i;var o={"Error":"error","Warning":"alert","Success":"sys-enter-2","Information":"information"};i=I.getIconURI(o[t]);return c||i;};
M.getAriaTypeText=function(){var b="MESSAGE_STRIP_"+this.getType().toUpperCase(),a=M.RESOURCE_BUNDLE.getText(b);if(this.getShowCloseButton()){a+=" "+M.RESOURCE_BUNDLE.getText("MESSAGE_STRIP_CLOSABLE");}return a;};
M.isMSCloseButtonPressed=function(t){return t.className.indexOf(M.CLASSES.CLOSE_BUTTON)!==-1||t.parentNode.className.indexOf(M.CLASSES.CLOSE_BUTTON)!==-1;};
M.closeTransitionWithCSS=function(c){this.$().addClass(M.CLASSES.CLOSING_TRANSITION).one("webkitTransitionEnd transitionend",c);};
M.getAccessibilityState=function(){return{role:"note",live:"assertive"};};
return M;});
sap.ui.predefine('sap/m/MessageToast',['./InstanceManager','sap/ui/core/Popup','sap/ui/core/library','sap/ui/core/Control','sap/ui/Device',"sap/base/Log","sap/ui/thirdparty/jquery"],function(I,P,c,C,D,L,q){"use strict";var a=c.Dock;var d=c.CSSSize;var M={};var O="0 -64",e="sapMMessageToast",E="sapUiSelectable",B="sapContrast",f="sapContrastPlus";M._mSettings={duration:3000,width:"15em",my:"center bottom",at:"center bottom",of:document.defaultView,offset:"0 0",collision:"fit fit",onClose:null,animationTimingFunction:"ease",animationDuration:1000,autoClose:true,closeOnBrowserNavigation:true};M._aPopups=[];M._iOpenedPopups=0;M._bBoundedEvents=false;
M._validateSettings=function(s){M._isFiniteInteger(s.duration);M._validateWidth(s.width);M._validateDockPosition(s.my);M._validateDockPosition(s.at);M._validateOf(s.of);M._validateOffset(s.offset);M._validateCollision(s.collision);M._validateOnClose(s.onClose);M._validateAutoClose(s.autoClose);M._validateAnimationTimingFunction(s.animationTimingFunction);M._isFiniteInteger(s.animationDuration);};
M._isFiniteInteger=function(N){if(typeof N!=="number"||!isFinite(N)||!(Math.floor(N)===N)||N<=0){L.error('"iNumber" needs to be a finite positive nonzero integer on '+M+"._isFiniteInteger");}};
M._validateWidth=function(w){if(!d.isValid(w)){L.error(w+' is not of type '+'"sap.ui.core.CSSSize" for property "width" on '+M+"._validateWidth");}};
M._validateDockPosition=function(s){if(!a.isValid(s)){L.error('"'+s+'"'+' is not of type '+'"sap.ui.core.Popup.Dock" on '+M+"._validateDockPosition");}};
M._validateOf=function(v){if(!(v instanceof q)&&!(v&&v.nodeType===1)&&!(v instanceof C)&&v!==window){L.error('"of" needs to be an instance of sap.ui.core.Control or an Element or a jQuery object or the window on '+M+"._validateOf");}};
M._validateOffset=function(o){if(typeof o!=="string"){L.error(o+' is of type '+typeof o+', expected "string" for property "offset" on '+M+"._validateOffset");}};
M._validateCollision=function(s){var r=/^(fit|flip|none|flipfit|flipflip|flip flip|flip fit|fitflip|fitfit|fit fit|fit flip)$/i;if(!r.test(s)){L.error('"collision" needs to be a single value “fit”, “flip”, or “none”, or a pair for horizontal and vertical e.g. "fit flip”, "fit none", "flipfit" on '+M+"._validateOffset");}};
M._validateOnClose=function(b){if(typeof b!=="function"&&b!==null){L.error('"onClose" should be a function or null on '+M+"._validateOnClose");}};
M._validateAutoClose=function(b){if(typeof b!=="boolean"){L.error('"autoClose" should be a boolean on '+M+"._validateAutoClose");}};
M._validateAnimationTimingFunction=function(t){var r=/^(ease|linear|ease-in|ease-out|ease-in-out)$/i;if(!r.test(t)){L.error('"animationTimingFunction" should be a string, expected values: '+"ease, linear, ease-in, ease-out, ease-in-out on "+M+"._validateAnimationTimingFunction");}};
function h(o){for(var p=["my","at","of","offset"],i=0;i<p.length;i++){if(o[p[i]]!==undefined){return false;}}return true;}
function g(s){var m=document.createElement("div");m.className=e+" "+E+" "+B+" "+f;if(sap.ui.getCore().getConfiguration().getAccessibility()){m.setAttribute("role","alert");}m.style.width=s.width;m.appendChild(document.createTextNode(s.message));return m;}
function n(o){if(o){if(h(o)){o.offset=O;}if(o.of&&o.of.nodeType===9){o.of=document.defaultView;}}else{o={offset:O};}return o;}
M._handleResizeEvent=function(){if(D.system.phone||D.system.tablet){M._resetPosition(M._aPopups);}setTimeout(M["_applyPositions"].bind(M,M._aPopups),0);};
M._handleMouseDownEvent=function(o){var i=o.target.hasAttribute("class")&&o.target.getAttribute("class").indexOf(e)!==-1;if(i||o.isMarked("delayedMouseEvent")){return;}M._aPopups.forEach(function(p){p&&p.__bAutoClose&&p.close();});};
M._resetPosition=function(p){for(var i=0,m;i<p.length;i++){m=p[i]&&p[i].getContent();if(m){m.style.visibility="hidden";m.style.left=0;}}};
M._applyPositions=function(p){for(var i=0,o,m;i<p.length;i++){o=p[i];if(o){m=o._oPosition;if(D.system.phone||D.system.tablet){setTimeout(M["_applyPosition"].bind(M,o,m),0);}else{o.setPosition(m.my,m.at,m.of,m.offset);}}}};
M._applyPosition=function(p,m){m=m||p._oPosition;var o=p.getContent();p.setPosition(m.my,m.at,m.of,m.offset);o.style.visibility="visible";};
M._setCloseAnimation=function(m,i,b,s){var j="opacity "+s.animationTimingFunction+" "+s.animationDuration+"ms",t="webkitTransitionEnd."+e+" transitionend."+e;if(sap.ui.getCore().getConfiguration().getAnimation()&&s.animationDuration>0){m[0].style.webkitTransition=j;m[0].style.transition=j;m[0].style.opacity=0;m.on(t,function k(){m.off(t);b();});}else{b();}};
M.show=function(m,o){var t=M,s=q.extend({},M._mSettings,{message:m}),p=new P(),i,b,j="mousedown."+e+" touchstart."+e,k,l;o=n(o);q.extend(s,o);M._validateSettings(s);b=g(s);i=M._aPopups.push(p)-1;p.setContent(b);p.setPosition(s.my,s.at,s.of,s.offset,s.collision);p.setAnimations(function x($,v,w){w();},function x($,v,w){t._setCloseAnimation($,v,w,s);});p.setShadow(false);p.__bAutoClose=s.autoClose;if(s.closeOnBrowserNavigation){I.addPopoverInstance(p);}if(!M._bBoundedEvents){q(window).on("resize."+e,M._handleResizeEvent.bind(M));q(document).on(j,M._handleMouseDownEvent.bind(M));M._bBoundedEvents=true;}p.open();M._iOpenedPopups++;function r(){I.removePopoverInstance(t._aPopups[i]);q(t._aPopups[i].getContent()).remove();t._aPopups[i].detachClosed(r);t._aPopups[i].destroy();t._aPopups[i]=null;t._iOpenedPopups--;if(t._iOpenedPopups===0){t._aPopups=[];q(window).off("resize."+e);q(document).off(j);t._bBoundedEvents=false;}if(typeof s.onClose==="function"){s.onClose.call(t);}}p.attachClosed(r);k=setTimeout(p["close"].bind(p),s.duration);function u(){clearTimeout(k);k=null;function v(){l=setTimeout(p["close"].bind(p),s.duration);p.getContent().removeEventListener("mouseleave",v);}p.getContent().addEventListener("mouseleave",v);clearTimeout(l);l=null;}p.getContent().addEventListener("touchstart",u);p.getContent().addEventListener("mouseover",u);if(D.system.desktop){p.getContent().addEventListener("mouseleave",function(){k=setTimeout(p["close"].bind(p),s.duration);});}};
M.toString=function(){return"sap.m.MessageToast";};
return M;},true);
sap.ui.predefine('sap/m/MessageView',["sap/ui/thirdparty/jquery","sap/ui/core/Control","sap/ui/core/CustomData","sap/ui/core/IconPool","sap/ui/core/HTML","sap/ui/core/Icon","./Button","./Toolbar","./ToolbarSpacer","./List","./MessageListItem","./library","./Text","./SegmentedButton","./Page","./NavContainer","./Link","./MessageItem","./GroupHeaderListItem","sap/ui/core/library","sap/ui/base/ManagedObject","./MessageViewRenderer","sap/ui/events/KeyCodes","sap/base/Log","sap/base/security/URLListValidator","sap/ui/thirdparty/caja-html-sanitizer"],function(q,C,a,I,H,b,B,T,c,L,M,l,d,S,P,N,e,f,G,g,h,j,K,k,U){"use strict";var V=g.ValueState;var m=g.MessageType;var n=l.ListType;
var o=C.extend("sap.m.MessageView",{metadata:{library:"sap.m",properties:{asyncDescriptionHandler:{type:"any",group:"Behavior",defaultValue:null},asyncURLHandler:{type:"any",group:"Behavior",defaultValue:null},groupItems:{type:"boolean",group:"Behavior",defaultValue:false},showDetailsPageHeader:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MessageItem",multiple:true,singularName:"item"},headerButton:{type:"sap.m.Button",multiple:false},_navContainer:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}},deprecated:true},itemSelect:{parameters:{item:{type:"sap.m.MessageItem"},messageTypeFilter:{type:"sap.ui.core.MessageType"}}},listSelect:{parameters:{messageTypeFilter:{type:"sap.ui.core.MessageType"}}},longtextLoaded:{},urlValidated:{},activeTitlePress:{parameters:{item:{type:"sap.m.MessageItem"}}}}}});
var p="sapMMsgView";var r={back:I.getIconURI("nav-back"),close:I.getIconURI("decline"),information:I.getIconURI("information"),warning:I.getIconURI("alert"),error:I.getIconURI("error"),success:I.getIconURI("sys-enter-2")};var s=["all","error","warning","success","information"];var A=["asyncDescriptionHandler","asyncURLHandler"];var D={asyncDescriptionHandler:function(i){var t=i.item.getLongtextUrl();if(t){q.ajax({type:"GET",url:t,success:function(u){i.item.setDescription(u);i.promise.resolve();},error:function(){var E="A request has failed for long text data. URL: "+t;k.error(E);i.promise.reject(E);}});}}};
o.setDefaultHandlers=function(i){A.forEach(function(F){if(i.hasOwnProperty(F)){D[F]=i[F];}});};
o.prototype.init=function(){var t=this;this._bHasHeaderButton=false;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._createNavigationPages();this._createLists();A.forEach(function(F){if(D.hasOwnProperty(F)){t.setProperty(F,D[F]);}});};
o.prototype._afterNavigate=function(){setTimeout(this["_restoreFocus"].bind(this),0);setTimeout(this["_restoreItemsType"].bind(this),0);};
o.prototype._restoreFocus=function(){if(this._isListPage()&&this.getItems().length){this._oLists[this._sCurrentList||'all'].focus();}else if(this._oBackButton){this._oBackButton.focus();}};
o.prototype._restoreItemsType=function(){if(this._isListPage()&&this.getItems().length>1){var t=this;this._oLists[this._sCurrentList||'all'].getItems().forEach(function(i){if(i.isA("sap.m.MessageListItem")){t._setItemType(i);}});}};
o.prototype._setItemType=function(i){var t,u=i.getActiveTitle();if(!i.getTitle()||!i.getDescription()){if(u){t=".sapMSLITitleOnly a";}else{t=".sapMSLITitleOnly";}}else if(u){t=".sapMSLITitle a";}else{t=".sapMSLITitle";}var v=i.getDomRef().querySelector(t);if(v.offsetWidth<v.scrollWidth){i.setType(n.Navigation);if(this.getItems().length===1){this._fnHandleForwardNavigation(i,"show");}}};
o.prototype.onBeforeRendering=function(){var i,t,u=this.getItems();this._clearLists();this._detailsPage.setShowHeader(this.getShowDetailsPageHeader());if(this.getGroupItems()){i=this._groupItems(u);this._fillGroupedLists(i);}else{this._fillLists(u);}var v=this.getHeaderButton();if(v){this._bHasHeaderButton=true;this._oListHeader.insertContent(v,2);}this._clearSegmentedButton();this._fillSegmentedButton();this._fnFilterList(this._getCurrentMessageTypeFilter()||"all");t=this._oLists.all.getItems().filter(function(w){return w.isA("sap.m.MessageListItem");});if(t.length===1&&t[0].getType()===n.Navigation){this._fnHandleForwardNavigation(t[0],"show");this._navContainer._pageStack[this._navContainer._pageStack.length-1].transition="slide";}this._makeAutomaticBinding();};
o.prototype._fillGroupedLists=function(i){var t=Object.keys(i),u=t.indexOf(""),v;if(u!==-1){v=i[""];this._fillLists(v);delete i[""];t.splice(u,1);}t.forEach(function(w){this._fillListsWithGroups(w,i[w]);},this);};
o.prototype._fillListsWithGroups=function(i,t){var u=new G({title:i});this._oLists["all"].addAggregation("items",u,true);["error","warning","success","information"].forEach(function(v){if(this._hasGroupItemsOfType(t,v)){this._oLists[v].addAggregation("items",u.clone(),true);}},this);this._fillLists(t);};
o.prototype._hasGroupItemsOfType=function(i,t){return i.some(function(u){return u.getType().toLowerCase()===t;});};
o.prototype.exit=function(){if(this._oLists){this._destroyLists();}if(this._oMessageItemTemplate){this._oMessageItemTemplate.destroy();}this._oResourceBundle=null;this._oListHeader=null;this._oDetailsHeader=null;this._oSegmentedButton=null;this._oBackButton=null;this._navContainer=null;this._listPage=null;this._detailsPage=null;this._sCurrentList=null;};
o.prototype._makeAutomaticBinding=function(){var i=this.getItems();if(!this.getBindingInfo("items")&&!i.length){this._bindToMessageModel();}};
o.prototype._bindToMessageModel=function(){var t=this;this.setModel(sap.ui.getCore().getMessageManager().getMessageModel(),"message");this._oMessageItemTemplate=new f({type:"{message>type}",title:"{message>message}",description:"{message>description}",longtextUrl:"{message>longtextUrl}"});this.bindAggregation("items",{path:"message>/",template:t._oMessageItemTemplate});};
o.prototype._groupItems=function(i){var t={},u;i.forEach(function(v){u=v.getGroupName();t[u]=t[u]||[];t[u].push(v);});return t;};
o.prototype._onkeypress=function(E){if(E.shiftKey&&E.keyCode==K.ENTER){this.navigateBack();}};
o.prototype._getListHeader=function(){return this._oListHeader||this._createListHeader();};
o.prototype._getDetailsHeader=function(){return this._oDetailsHeader||this._createDetailsHeader();};
o.prototype._createListHeader=function(){var i=this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE");var t=this.getId()+"-CloseBtnDescr";var u=new H(t,{content:"<span id=\""+t+"\" class=\"sapMMsgViewHiddenContainer\">"+i+"</span>"});var v=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_HEADING");var w=this.getId()+"-HeadingDescr";var x=new H(w,{content:"<span id=\""+w+"\" class=\"sapMMsgViewHiddenContainer\" role=\"heading\">"+v+"</span>"});this._oSegmentedButton=new S(this.getId()+"-segmented",{}).addStyleClass("sapMSegmentedButtonNoAutoWidth");this._oListHeader=new T({content:[this._oSegmentedButton,new c(),u,x]});return this._oListHeader;};
o.prototype._createDetailsHeader=function(){var i=this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE");var t=this.getId()+"-CloseBtnDetDescr";var u=new H(t,{content:"<span id=\""+t+"\" class=\"sapMMsgViewHiddenContainer\">"+i+"</span>"});var v=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_BACK_BUTTON_TOOLTIP");var w=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_BACK_BUTTON");var x=this.getId()+"-BackBtnDetDescr";var y=new H(x,{content:"<span id=\""+x+"\" class=\"sapMMsgViewHiddenContainer\">"+w+"</span>"});this._oBackButton=new B({icon:r["back"],press:this.navigateBack.bind(this),ariaLabelledBy:y,tooltip:v}).addStyleClass(p+"BackBtn");this._oDetailsHeader=new T({content:[this._oBackButton,new c(),u,y]});return this._oDetailsHeader;};
o.prototype._createNavigationPages=function(){this._listPage=new P(this.getId()+"listPage",{customHeader:this._getListHeader()});this._detailsPage=new P(this.getId()+"-detailsPage",{customHeader:this._getDetailsHeader()}).addStyleClass("sapMMsgViewDetailsPage");this._detailsPage.addEventDelegate({onclick:function(E){var t=E.target;if(t.nodeName.toUpperCase()==="A"&&(t.className.indexOf("sapMMsgViewItemDisabledLink")!==-1||t.className.indexOf("sapMMsgViewItemPendingLink")!==-1)){E.preventDefault();}}});this._navContainer=new N(this.getId()+"-navContainer",{initialPage:this.getId()+"listPage",pages:[this._listPage,this._detailsPage],afterNavigate:this._afterNavigate.bind(this)});this.setAggregation("_navContainer",this._navContainer);return this;};
o.prototype._createLists=function(){this._oLists={};s.forEach(function(i){this._oLists[i]=new L({itemPress:this._fnHandleItemPress.bind(this),visible:false});this._listPage.addAggregation("content",this._oLists[i],true);},this);return this;};
o.prototype._clearLists=function(){s.forEach(function(i){if(this._oLists[i]){this._oLists[i].destroyAggregation("items",true);}},this);return this;};
o.prototype._destroyLists=function(){s.forEach(function(i){this._oLists[i]=null;},this);this._oLists=null;};
o.prototype._fillLists=function(i){i.forEach(function(t){var u=this._mapItemToListItem(t),v=this._mapItemToListItem(t);this._oLists["all"].addAggregation("items",u,true);this._oLists[t.getType().toLowerCase()].addAggregation("items",v,true);},this);};
o.prototype._mapItemToListItem=function(i){if(!i){return null;}var t=i.getType(),u=this,v=this._getItemType(i),w=new M({title:h.escapeSettingsValue(i.getTitle()),description:h.escapeSettingsValue(i.getSubtitle()),counter:i.getCounter(),icon:this._mapIcon(t),infoState:this._mapInfoState(t),info:"\r",type:v,messageType:i.getType(),activeTitle:i.getActiveTitle(),activeTitlePress:function(){u.fireActiveTitlePress({item:i});}}).addStyleClass(p+"Item").addStyleClass(p+"Item"+t).toggleStyleClass(p+"ItemActive",i.getActiveTitle());if(v!==n.Navigation){w.addEventDelegate({onAfterRendering:function(){u._setItemType(w);}},this);}w._oMessageItem=i;return w;};
o.prototype._mapInfoState=function(t){if(!t){return null;}switch(t){case m.Warning:return V.Warning;case m.Error:return V.Error;case m.Success:return V.Success;case m.Information:case m.None:return V.None;default:k.warning("The provided MessageType is not mapped to a specific ValueState",t);return null;}};
o.prototype._mapIcon=function(i){if(!i){return null;}return r[i.toLowerCase()];};
o.prototype._getItemType=function(i){return(i.getDescription()||i.getMarkupDescription()||i.getLongtextUrl())?n.Navigation:n.Inactive;};
o.prototype._clearSegmentedButton=function(){if(this._oSegmentedButton){this._oSegmentedButton.destroyAggregation("buttons",true);}return this;};
o.prototype._fillSegmentedButton=function(){var t=this;var i=function(w){return function(){t._fnFilterList(w);};};s.forEach(function(w){var x=this._oLists[w],y=w=="all"?"MESSAGEPOPOVER_ALL":"MESSAGEVIEW_BUTTON_TOOLTIP_"+w.toUpperCase(),z=x.getItems().filter(function(F){return(F instanceof M);}).length,E;if(z>0){E=new B(this.getId()+"-"+w,{text:w=="all"?this._oResourceBundle.getText(y):z,tooltip:this._oResourceBundle.getText(y),icon:r[w],press:i(w)}).addStyleClass(p+"Btn"+w.charAt(0).toUpperCase()+w.slice(1));this._oSegmentedButton.addButton(E,true);}},this);var u=this._oSegmentedButton.getButtons().length>2;this._oSegmentedButton.setVisible(u);if(!u){this._oSegmentedButton.setSelectedButton(this._oSegmentedButton.getButtons()[0]);this._fnFilterList('all');}var v=u||this._bHasHeaderButton;this._listPage.setShowHeader(v);return this;};
o.prototype._setIcon=function(i,t){this._previousIconTypeClass=p+"DescIcon"+i.getType();this._oMessageIcon=new b({src:t.getIcon()}).addStyleClass(p+"DescIcon").addStyleClass(this._previousIconTypeClass);this._detailsPage.addContent(this._oMessageIcon);};
o.prototype._setTitle=function(i,t){var u=i.getActiveTitle(),v,w=this,x=h.escapeSettingsValue(i.getTitle()),y=this.getId()+"MessageTitleText";if(u){v=new e(y,{text:x,ariaDescribedBy:t.getId()+"-link",press:function(){w.fireActiveTitlePress({item:i});}});}else{v=new d(y,{text:x});}v.addStyleClass("sapMMsgViewTitleText");this._detailsPage.addAggregation("content",v);};
o.prototype._setDescription=function(i){var t=i.getLink();var u=i.getDescription();if(i.getMarkupDescription()){var v=this._getTagPolicy();u=html.sanitizeWithPolicy(u,v);}this._oLastSelectedItem=i;if(i.getMarkupDescription()){this._oMessageDescriptionText=new H(this.getId()+"MarkupDescription",{content:"<div class='sapMMsgViewDescriptionText'>"+h.escapeSettingsValue(u)+"</div>"});}else{this._oMessageDescriptionText=new d(this.getId()+"MessageDescriptionText",{text:h.escapeSettingsValue(u)}).addStyleClass("sapMMsgViewDescriptionText");}this._detailsPage.addContent(this._oMessageDescriptionText);if(t){var w=this._createLinkCopy(t);this._detailsPage.addContent(w);w.addStyleClass("sapMMsgViewDescriptionLink");}};
o.prototype._createLinkCopy=function(i){var t,u=i.clone("","",{cloneChildren:false,cloneBindings:false}),v=i.getCustomData()||[];t=Object.keys(i.getMetadata().getProperties());t.forEach(function(w){u.setProperty(w,i.getProperty(w));});u.destroyCustomData();v.forEach(function(w){var x=new a({key:w.getKey(),value:w.getValue()});u.addCustomData(x);});return u;};
o.prototype._iNextValidationTaskId=0;
o.prototype._validateURL=function(u){if(U.validate(u)){return u;}k.warning("You have entered invalid URL");return"";};
o.prototype._queueValidation=function(i){var t=this.getAsyncURLHandler();var v=++this._iNextValidationTaskId;var u={};var w=new Promise(function(x,y){u.resolve=x;u.reject=y;var z={url:i,id:v,promise:u};t(z);});w.id=v;return w;};
o.prototype._getTagPolicy=function(){var t=this,i;var u=html.makeTagPolicy(this._validateURL());return function O(v,w){var x,y=false;if(v.toUpperCase()==="A"){for(i=0;i<w.length;){if(w[i]==="href"){y=true;x=w[i+1];w.splice(0,2);continue;}i+=2;}}w=u(v,w);if(y&&typeof t.getAsyncURLHandler()==="function"){w=w||[];var z="sapMMsgViewItemDisabledLink sapMMsgViewItemPendingLink";var E=w.indexOf("class");if(E>-1){w[E+1]+=z;}else{w.unshift(z);w.unshift("class");}var F=w.indexOf("id");if(F>-1){w.splice(F+1,1);w.splice(F,1);}var J=t._queueValidation(x);w.push("href");w.push(x);w.push("target");w.push("_blank");w.push("id");w.push("sap-ui-"+t.getId()+"-link-under-validation-"+J.id);J.then(function(Q){var $=q(document.getElementById("sap-ui-"+t.getId()+"-link-under-validation-"+Q.id));if(Q.allowed){k.info("Allow link "+x);}else{k.info("Disallow link "+x);}$.removeClass("sapMMsgViewItemPendingLink");$.toggleClass("sapMMsgViewItemDisabledLink",!Q.allowed);t.fireUrlValidated();}).catch(function(){k.warning("Async URL validation could not be performed.");});}return w;};};
o.prototype._fnHandleForwardNavigation=function(i,t){var u=i._oMessageItem,v=this._detailsPage.getContent()||[],w=this.getAsyncDescriptionHandler();this._previousIconTypeClass=this._previousIconTypeClass||"";this.fireItemSelect({item:u,messageTypeFilter:this._getCurrentMessageTypeFilter()});this._clearDetailsPage.call(this,v);if(typeof w==="function"&&u.getLongtextUrl()){u.setMarkupDescription(true);var x={};var y=new Promise(function(E,F){x.resolve=E;x.reject=F;});var z=function(){this._detailsPage.setBusy(false);this._navigateToDetails.call(this,u,i,t,true);}.bind(this);y.then(z).catch(function(){k.warning("Async description loading could not be performed.");z();});this._navContainer.to(this._detailsPage);this._detailsPage.setBusy(true);w({promise:x,item:u});}else{this._navigateToDetails.call(this,u,i,t,false);}this._listPage.$().attr("aria-hidden","true");};
o.prototype._fnHandleItemPress=function(E){this._fnHandleForwardNavigation(E.getParameter("listItem"),"slide");};
o.prototype._navigateToDetails=function(i,t,u,v){this._setTitle(i,t);this._setDescription(i);this._setIcon(i,t);this._detailsPage.invalidate();this.fireLongtextLoaded();if(!v){this._navContainer.to(this._detailsPage,u);}};
o.prototype._clearDetailsPage=function(i){i.forEach(function(t){t.destroy();},this);};
o.prototype.navigateBack=function(){this._listPage.$().removeAttr("aria-hidden");this._navContainer.back();};
o.prototype._fnFilterList=function(i){s.forEach(function(t){if(t!=i&&this._oLists[t].getVisible()){this._oLists[t].setVisible(false);}},this);this._sCurrentList=i;this._oLists[i].setVisible(true);this.fireListSelect({messageTypeFilter:this._getCurrentMessageTypeFilter()});};
o.prototype._getCurrentMessageTypeFilter=function(){return this._sCurrentList=="all"?"":this._sCurrentList;};
o.prototype._isListPage=function(){return this._navContainer.getCurrentPage()==this._listPage;};
return o;});
sap.ui.predefine('sap/m/MessageViewRenderer',["sap/ui/core/Core"],function(C){"use strict";var M={apiVersion:2};var a="sapMMsgView";
M.render=function(r,c){var R=C.getLibraryResourceBundle("sap.m");r.openStart("div",c);r.class(a);r.accessibilityState(c,{role:"region",label:R.getText("MESSAGE_VIEW_ARIA_LABEL")});r.openEnd();r.renderControl(c._navContainer);r.close("div");};
return M;},true);
sap.ui.predefine('sap/m/MultiComboBox',['./InputBase','./ComboBoxTextField','./ComboBoxBase','./Tokenizer','./Token','./List','./StandardListItem','./Popover','./GroupHeaderListItem','./CheckBox','./Toolbar','./library','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','sap/ui/core/Item','sap/ui/core/SeparatorItem','sap/ui/core/ResizeHandler','./MultiComboBoxRenderer',"sap/ui/dom/containsOrEquals","sap/m/inputUtils/completeTextSelected","sap/m/inputUtils/inputsDefaultFilter","sap/m/inputUtils/typeAhead","sap/m/inputUtils/ListHelpers","sap/m/inputUtils/filterItems","sap/m/inputUtils/itemsVisibilityHandler","sap/m/inputUtils/selectionRange","sap/m/inputUtils/calculateSelectionStart","sap/m/inputUtils/forwardItemPropertiesToToken","sap/m/inputUtils/getTokenByItem","sap/ui/events/KeyCodes","sap/base/util/deepEqual","sap/base/assert","sap/base/Log","sap/ui/core/Core",'sap/ui/core/InvisibleText',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos","sap/ui/dom/jquery/control"],function(I,C,a,T,b,L,S,P,G,c,d,l,E,e,f,D,g,h,R,M,j,k,m,t,n,o,p,s,q,r,u,K,v,w,x,y,z,Q){"use strict";var A=l.ListMode;var V=f.ValueState;var O=f.OpenState;var B=l.TokenizerRenderMode;
var F=a.extend("sap.m.MultiComboBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/MultiComboBox.designtime",properties:{selectedKeys:{type:"string[]",group:"Data",defaultValue:[]},hasSelection:{type:"boolean",visibility:"hidden",defaultValue:false},showSelectAll:{type:"boolean",defaultValue:false}},associations:{selectedItems:{type:"sap.ui.core.Item",multiple:true,singularName:"selectedItem"}},aggregations:{tokenizer:{type:"sap.m.Tokenizer",multiple:false,visibility:"hidden"}},events:{selectionChange:{parameters:{changedItem:{type:"sap.ui.core.Item"},changedItems:{type:"sap.ui.core.Item[]"},selected:{type:"boolean"},selectAll:{type:"boolean"}}},selectionFinish:{parameters:{selectedItems:{type:"sap.ui.core.Item[]"}}}},dnd:{draggable:false,droppable:true}}});
e.insertFontFaceStyle();E.apply(F.prototype,[true]);
F.prototype.clone=function(i){var H=a.prototype.clone.apply(this,arguments),J=this._getList();if(J){H.syncPickerContent();}return H;};
F.prototype.open=function(){if(!this.isOpen()){this._bPickerIsOpening=true;}this.syncPickerContent();return a.prototype.open.apply(this,arguments);};
F.prototype.onsapend=function(i){if(i.isMarked("forwardFocusToParent")){this.focus();}};
F.prototype.onsaphome=function(i){if(!this.getFocusDomRef().selectionStart&&this._hasTokens()){T.prototype.onsaphome.apply(this.getAggregation("tokenizer"),arguments);}i.setMarked();};
F.prototype.onsapdown=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();this.syncPickerContent();if(!this.isOpen()){this._oTraversalItem=this._getNextTraversalItem();if(this._oTraversalItem&&!this.isFocusInTokenizer()&&!this.isComposingCharacter()){this.updateDomValue(this._oTraversalItem.getText());this.selectText(0,this.getValue().length);}return;}setTimeout(this.handleDownEvent.bind(this,i),0);};
F.prototype.onsapup=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();this.syncPickerContent();if(this.isFocusInTokenizer()||this.isOpen()){return;}this._oTraversalItem=this._getPreviousTraversalItem();if(this._oTraversalItem){this.updateDomValue(this._oTraversalItem.getText());this.selectText(0,this.getValue().length);}};
F.prototype.handleDownEvent=function(i){if(!this.isOpen()){return;}var H=i.srcControl,J=H&&H.getDomRef(),N=j(this.getDomRef(),J),U=this.getPicker().getCustomHeader(),W=U&&U.getDomRef();i.setMarked();i.preventDefault();if(N&&this.getValueState()!=V.None){this._handleFormattedTextNav();return;}if((N||j(W,J))&&this.getShowSelectAll()){this.focusSelectAll();return;}this.focusFirstItemInList();};
F.prototype.handleEndEvent=function(i){i.setMarked();i.preventDefault();var H=n.getVisibleItems(this.getItems()),J=H.length&&n.getListItem(H[H.length-1]);J&&J.focus();};
F.prototype.handleHomeEvent=function(i){i.setMarked();i.preventDefault();if(this.getValueState()!==V.None){this._handleFormattedTextNav();i.stopPropagation(true);return;}if(this.getShowSelectAll()){this.focusSelectAll();i.stopPropagation(true);return;}this.focusFirstItemInList();};
F.prototype.focusFirstItemInList=function(){var i=n.getVisibleItems(this.getItems()),H=i.length&&n.getListItem(i[0]);H&&H.focus();};
F.prototype.isFocusInTokenizer=function(){return Q.contains(this.getAggregation("tokenizer").getFocusDomRef(),document.activeElement);};
F.prototype.onsapshow=function(i){i.preventDefault();this._handleItemToFocus();a.prototype.onsapshow.apply(this,arguments);};
F.prototype._handlePopupOpenAndItemsLoad=function(){this._handleItemToFocus();a.prototype._handlePopupOpenAndItemsLoad.apply(this,arguments);};
F.prototype._valueStateNavDelegate=function(i,H){return{onsapdown:this.handleDownEvent,onsapup:this.focus,onsapend:this.handleEndEvent,onfocusout:function(J){i.removeStyleClass("sapMFocusable");if(!i.getDomRef().contains(J.relatedTarget)){H.forEach(function(N){N.getDomRef().setAttribute("tabindex","-1");});}},onsapshow:this.close,onsaphide:this.close};};
F.prototype._closePickerDelegate={onsaptabnext:function(){this.close();setTimeout(function(){this.closeValueStateMessage();}.bind(this),0);}};F.prototype._formattedTextLinksNav={onsapup:this.focus,onsapdown:this.handleDownEvent};
F.prototype._handleFormattedTextNav=function(){var i=this.getPicker().getCustomHeader(),H=this.getValueStateLinks(),J=H?H[H.length-1]:null,N=H?H[0]:null;if(!i.getDomRef()||i.getDomRef()===document.activeElement){return;}if(!this.oValueStateNavDelegate){this.oValueStateNavDelegate=this._valueStateNavDelegate(i,H);i.addEventDelegate(this.oValueStateNavDelegate,this);}i.getDomRef().setAttribute("tabindex","-1");i.addStyleClass("sapMFocusable");i.focus();H.forEach(function(U){U.getDomRef().setAttribute("tabindex","0");U.addEventDelegate(this._formattedTextLinksNav,this);},this);this.oMoveFocusBackToVSHeader=!this.oMoveFocusBackToVSHeader?{onsaptabprevious:function(U){U.preventDefault();i.focus();i.addStyleClass("sapMFocusable");}}:this.oMoveFocusBackToVSHeader;J&&J.addEventDelegate(this._closePickerDelegate,this);N&&N.addEventDelegate(this.oMoveFocusBackToVSHeader,this);};
F.prototype.onsaphide=function(i){this.onsapshow(i);};
F.prototype._selectItemByKey=function(H){var J,N,U,i,W,X,Y=this.isOpen();if(!this.getEnabled()||!this.getEditable()){return;}if(H){H.setMarked();}J=this._getUnselectedItems(Y?"":this.getValue());for(i=0;i<J.length;i++){X=!(J[i].getKey()===undefined||J[i].getKey()===null)&&!J[i].isA("sap.ui.core.SeparatorItem");if(J[i].getText().toUpperCase()===this.getValue().toUpperCase()&&X){U=J[i];W=true;break;}}if(W){N={item:U,id:U.getId(),key:U.getKey(),fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true,listItemUpdated:false};this._bPreventValueRemove=false;if(this.getValue()===""||(typeof this.getValue()==="string"&&U.getText().toLowerCase().startsWith(this.getValue().toLowerCase()))){if(n.getListItem(U).isSelected()){this.setValue('');}else{this.setSelection(N);}}}else{this._bPreventValueRemove=true;}if(H){this.close();}};
F.prototype.onsapenter=function(i){var H=this.getAggregation("tokenizer");I.prototype.onsapenter.apply(this,arguments);this._showAlreadySelectedVisualEffect();if(this.getValue()){this._selectItemByKey(i);}if(!this.getEditable()&&H.getHiddenTokensCount()&&i.target===this.getFocusDomRef()){H._togglePopup(H.getTokensPopup());}};
F.prototype.onsaptabnext=function(i){var H=this.getValue();if(H){var J=this._getUnselectedItemsStartingText(H);if(J.length===1){this._selectItemByKey(i);}else{this._showWrongValueVisualEffect();}}};
F.prototype.onsaptabprevious=F.prototype.onsaptabnext;
F.prototype.onsapfocusleave=function(i){var H=this.isPlatformTablet(),J=y.byId(i.relatedControlId),N=J&&J.getFocusDomRef(),U=this.getValue(),W=this.getPicker(),X=this.getAggregation("tokenizer");if(!this._bPickerIsOpening&&(!W||!W.getFocusDomRef()||!N||!Q.contains(W.getFocusDomRef(),N))){this.setValue(null);if(U){this.fireChangeEvent("",{value:U});}if(!Q.contains(this.getDomRef(),document.activeElement)){X.setRenderMode(B.Narrow);}}if(W&&N){if(v(W.getFocusDomRef(),N)&&!H&&!this.isPickerDialog()){this.focus();}}};
F.prototype.onfocusin=function(i){var H=this.getPicker();var J=false;var N=H&&H.getFocusDomRef();var U=(H&&H.oPopup.getOpenState())||O.CLOSED;var W=U===O.CLOSING||U===O.CLOSED;var X=this.getPickerType()==="Dropdown";var Y=this.getAggregation("tokenizer");if(X){J=N&&Q.contains(N,i.relatedTarget);}if(this.getEditable()&&i.target===this.getDomRef("inner")){Y.setRenderMode(B.Loose);}if(i.target===this.getFocusDomRef()){Y.hasOneTruncatedToken()&&Y.setFirstTokenTruncated(false);this.getEnabled()&&this.addStyleClass("sapMFocus");!W&&J&&this.handleInputValidation(i,false);}if(i.target===this.getOpenArea()&&X&&!this.isPlatformTablet()){this.focus();}if(!this.isOpen()&&this.shouldValueStateMessageBeOpened()){this.openValueStateMessage();}};
F.prototype._handleItemTap=function(i){var H=Q(i.target).control(0);if(!H.isA("sap.m.CheckBox")&&!H.isA("sap.m.GroupHeaderListItem")){this._bCheckBoxClicked=false;}};
F.prototype._handleItemPress=function(i){if(this.isOpen()&&this._isListInSuggestMode()&&this.getPicker().oPopup.getOpenState()!==O.CLOSING){this.clearFilter();var H=this._getLastSelectedItem();if(H){n.getListItem(H).focus();}}};
F.prototype._handleSelectionLiveChange=function(i){if(i.getParameter("selectAll")){return;}var H=i.getParameter("listItem");var J=i.getParameter("listItems");var N=J&&J[J.length-1]||H;var U=this.isPickerDialog()?this.getPickerTextField():this;var W=this._getIsClick()&&!!N;var X=i.getParameter("selected");var Y=n.getItemByListItem(this.getItems(),H);var Z;if(J&&J.length){Z=[];J.forEach(function(_){if(_.getType()==="Active"){Z.push(n.getItemByListItem(this.getItems(),_));}},this);}if(H.getType()==="Inactive"){return;}w(Y,"The corresponding mapped item was not found on "+this);if(!Y){return;}var $={item:Y,items:Z,id:Y.getId(),key:Y.getKey(),selectAll:false,fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:true};if(X){this.fireChangeEvent(Y.getText());this.setSelection($);}else{this.fireChangeEvent(Y.getText());this.removeSelection($);}if(this._bCheckBoxClicked){U.setValue(this._sOldInput);if(W&&this.isOpen()&&this.getPicker().oPopup.getOpenState()!==O.CLOSING){N.focus();this._setIsClick(false);}}else{this._bCheckBoxClicked=true;this.setValue("");this.close();}};
F.prototype.onkeydown=function(i){var H=this.getEditable(),J=this.getAggregation("tokenizer"),N=J.getTokens().length;a.prototype.onkeydown.apply(this,arguments);if(!this.getEnabled()){return;}if((i.ctrlKey||i.metaKey)&&i.which===K.I&&N){i.preventDefault();if(H){this._togglePopover();}else{this._handleIndicatorPress();}return;}this._bIsPasteEvent=(i.ctrlKey||i.metaKey)&&(i.which===K.V);if(this.getValue().length===0&&(i.ctrlKey||i.metaKey)&&(i.which===K.A)&&this._hasTokens()){J.focus();J.selectAllTokens(true);i.preventDefault();}if(this.isPickerDialog()){this._sOldValue=this.getPickerTextField().getValue();this._iOldCursorPos=Q(this.getFocusDomRef()).cursorPos();}this._bDoTypeAhead=!D.os.android&&(i.which!==K.BACKSPACE)&&(i.which!==K.DELETE);};
F.prototype.oninput=function(i){a.prototype.oninput.apply(this,arguments);var H=i.srcControl,J=this.isPickerDialog(),N=J?this.getPickerTextField():this,U=N.getValueState();if(U===V.Error&&this._bAlreadySelected){N.setValueState(this._sInitialValueState);N.setValueStateText(this._sInitialValueStateText);this._bAlreadySelected=false;}if(!this.getEnabled()||!this.getEditable()){return;}this.syncPickerContent();this.handleInputValidation(i,this.isComposingCharacter());if(this._bIsPasteEvent){H.updateDomValue(this._sOldValue||i.target.value||"");return;}if(this.isOpen()){setTimeout(this.highlightList.bind(this,this._sOldInput));}if(this._getItemsShownWithFilter()){this.toggleIconPressedStyle(true);}};
F.prototype.filterItems=function(i){return o(this,i.items,i.value,true,false,this.fnFilter||m);};
F.prototype.onkeyup=function(i){a.prototype.onkeyup.apply(this,arguments);if(!this.getEnabled()||!this.getEditable()){return;}this._sOldValue=this.getValue();this._iOldCursorPos=Q(this.getFocusDomRef()).cursorPos();};
F.prototype._showWrongValueVisualEffect=function(){var i=this._getSuggestionsPopover();var H=this._sInitialValueStateText;var J=this._sInitialValueState;var N=H||this._oRbC.getText("VALUE_STATE_ERROR");var U=this;if(J===V.Error){return;}if(i){i.updateValueState(V.Error,N,true);setTimeout(i.updateValueState.bind(i,U.getValueState(),N,true),1000);}if(!this.isPickerDialog()){this.setValueState(V.Error);this.setValueStateText(this.getValueStateText()||N);setTimeout(this["setValueState"].bind(this,J||V.Error),1000);}this._syncInputWidth(this.getAggregation("tokenizer"));};
F.prototype._showAlreadySelectedVisualEffect=function(){var i=this._oRb.getText("VALUE_STATE_ERROR_ALREADY_SELECTED");if(!this.getValue()){return;}var H=!!this.getSelectedItems().filter(function(J){return J.getText().toLowerCase()===this.getValue().toLowerCase();},this).length;var N=this.getItems().filter(function(J){return J.getText().toLowerCase()===this.getValue().toLowerCase();},this).length;if(H){this._sInitialValueState=this.getValueState();this._sInitialValueStateText=this.getValueStateText();this.setValueStateText(i);this._bAlreadySelected=true;this.setValueState("Error");return;}else if(N){return;}else{this._showWrongValueVisualEffect();}};
F.prototype._hasShowSelectedButton=function(){return true;};
F.prototype.forwardEventHandlersToSuggPopover=function(i){a.prototype.forwardEventHandlersToSuggPopover.apply(this,arguments);i.setShowSelectedPressHandler(this._filterSelectedItems.bind(this));};
F.prototype.configPicker=function(i){var H=this.getRenderer(),J=H.CSS_CLASS_MULTICOMBOBOX;i.setHorizontalScrolling(false).addStyleClass(H.CSS_CLASS_COMBOBOXBASE+"Picker").addStyleClass(J+"Picker").addStyleClass(J+"Picker-CTX").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this);};
F.prototype._configureList=function(i){var H=10;if(!i){return;}i.setMode(A.MultiSelect);i.setIncludeItemInSelection(true);i.setGrowingThreshold(H);i.attachBrowserEvent("tap",this._handleItemTap,this).attachSelectionChange(this._handleSelectionLiveChange,this).attachItemPress(this._handleItemPress,this);i.addEventDelegate({onAfterRendering:this.onAfterRenderingList,onfocusin:this.onFocusinList},this);this.getShowSelectAll()&&this.createSelectAllHeaderToolbar(i);};
F.prototype._decoratePopupInput=function(i){a.prototype._decoratePopupInput.apply(this,arguments);if(!i||!i.isA(["sap.m.InputBase"])){return;}i.attachSubmit(function(H){var J=i.getValue();if(J){this.setValue(J);this._selectItemByKey();this.setValue(this._sOldInput);this.close();}}.bind(this));i.addEventDelegate({onfocusout:this._handleInputFocusOut},this);i.attachChange(this._handleInnerInputChange.bind(this));return i;};
F.prototype._handleInnerInputChange=function(i){if(i.getParameter("value")===""){this._sOldInput="";this.clearFilter();}};
F.prototype.onBeforeRendering=function(){var i=this.getEditable();var H=this.getAggregation("tokenizer");var J=this.getItems();a.prototype.onBeforeRendering.apply(this,arguments);this._bInitialSelectedKeysSettersCompleted=true;H.setEnabled(this.getEnabled());H.setEditable(i);this._updatePopoverBasedOnEditMode(i);if(!J.length){this._clearTokenizer();}if(this._getList()){this.syncPickerContent(true);}this.toggleSelectAllVisibility(this.getShowSelectAll());if(this._sOldInput&&J.length&&this.isOpen()){p(this.getItems(),this.filterItems({value:this._sOldInput,items:J}));setTimeout(this.highlightList.bind(this,this._sOldInput));}this._deregisterResizeHandler();this._synchronizeSelectedItemAndKey();this.setProperty("hasSelection",!!this.getSelectedItems().length,true);if(!this._bAlreadySelected){this._sInitialValueStateText=this.getValueStateText();}if(this.getValueState()!==V.Error){this._sInitialValueState=this.getValueState();}};
F.prototype.syncPickerContent=function(i){var H,J,N=this.getPicker();if(!N){N=this.createPicker(this.getPickerType());this._updateSuggestionsPopoverValueState();i=true;}if(i){J=this._getList();H=this.getEditable()?this.getItems():this.getSelectedItems();this._synchronizeSelectedItemAndKey();J.destroyItems();this._clearTokenizer();this._fillList(H);if(J.getItemNavigation()){this._iFocusedIndex=J.getItemNavigation().getFocusedIndex();}}return N;};
F.prototype._registerResizeHandler=function(){w(!this._iResizeHandlerId,"Resize handler already registered");this._iResizeHandlerId=R.register(this,this._onResize.bind(this));};
F.prototype._deregisterResizeHandler=function(){if(this._iResizeHandlerId){R.deregister(this._iResizeHandlerId);this._iResizeHandlerId=null;}};
F.prototype._onResize=function(){var i=this.getAggregation("tokenizer");i.setMaxWidth(this._calculateSpaceForTokenizer());this._syncInputWidth(i);this._handleNMoreAccessibility();};
F.prototype.onAfterRenderingPicker=function(){var i=this["_onAfterRendering"+this.getPickerType()];if(i){i.call(this);}};
F.prototype.onBeforeOpen=function(){a.prototype.onBeforeOpen.apply(this,arguments);var i=this["_onBeforeOpen"+this.getPickerType()];this.addContent();this._aInitiallySelectedItems=this.getSelectedItems();this._synchronizeSelectedItemAndKey();if(i){i.call(this);}};
F.prototype.onAfterOpen=function(){var i=this.getFocusDomRef(),H=this.getValueStateLinks();i&&this.getFocusDomRef().setAttribute("aria-expanded","true");this._bPickerIsOpening=false;if(!this.isPlatformTablet()){this.getPicker().setInitialFocus(this);}H.forEach(function(J){J.addDelegate({onAfterRendering:function(){if(this.getFocusDomRef()){this.getFocusDomRef().setAttribute("tabindex","-1");}}},J);});this.closeValueStateMessage();};
F.prototype.onBeforeClose=function(){a.prototype.onBeforeClose.apply(this,arguments);};
F.prototype.onAfterClose=function(){var U=!Q.contains(this.getDomRef(),document.activeElement)||this.isPickerDialog(),i=this.getFocusDomRef();i&&this.getFocusDomRef().setAttribute("aria-expanded","false");this.toggleIconPressedStyle(false);this.clearFilter();!this.isComposingCharacter()&&!this._bPreventValueRemove&&this.setValue("");this._sOldValue="";this._sOldInput="";this._getSuggestionsPopover()._sTypedInValue="";if(this.isPickerDialog()){this.getPickerTextField().setValue("");this.getFilterSelectedButton()&&this.getFilterSelectedButton().setPressed(false);}this.fireSelectionFinish({selectedItems:this.getSelectedItems()});this.getAggregation("tokenizer").setRenderMode(U?B.Narrow:B.Loose);if(this.getValueState()==V.Error&&document.activeElement===this.getFocusDomRef()){this.selectText(0,this.getValue().length);}};
F.prototype._onBeforeOpenDialog=function(){};
F.prototype._onBeforeOpenDropdown=function(){var i=this.getPicker(),H=this.getDomRef(),W;if(H&&i){W=(H.offsetWidth/parseFloat(l.BaseFontSize))+"rem";i.setContentMinWidth(W);}};
F.prototype.getFilterSelectedButton=function(){return this._getSuggestionsPopover().getFilterSelectedButton();};
F.prototype._filterSelectedItems=function(i,H){var J=i.oSource,N,U,W=this.getPickerTextField()?this.getPickerTextField().getValue():"",X=(J&&J.getPressed&&J.getPressed())||H,Y=n.getVisibleItems(this.getItems()),Z=this.getItems(),$=this.getSelectedItems(),_=null;if(X){Y.forEach(function(a1){U=$.indexOf(a1)>-1?true:false;N=n.getListItem(a1);if(!N){return;}if(N.isA("sap.m.GroupHeaderListItem")){N.setVisible(false);_=N;}else{N.setVisible(U);if(U&&_){_.setVisible(true);}}},this);}else{p(this.getItems(),this.filterItems({value:W,items:Z}));}this.manageSelectAllCheckBoxState();};
F.prototype.revertSelection=function(){this.setSelectedItems(this._aInitiallySelectedItems);};
F.prototype.setSelection=function(i){var H=this._getList(),N;if(i.item&&this.isItemSelected(i.item)){return;}if(!i.item){return;}if(!i.items||!i.items.length||i.selectAll){N=[i.item];}else{N=i.items;}N.forEach(function(J){if(!i.listItemUpdated&&n.getListItem(J)&&H){H.setSelectedItem(n.getListItem(J),true);}var U=new b({key:J.getKey()});U.setText(J.getText());J.data(n.CSS_CLASS+"Token",U);this.getAggregation("tokenizer").addToken(U);this.addAssociation("selectedItems",J,i.suppressInvalidate);var W=this.getSelectedKeys();var X=this.getKeys([J])[0];if(X===""||W.indexOf(X)===-1){W.push(X);this.setProperty("selectedKeys",W,i.suppressInvalidate);}if(i.fireChangeEvent){this.fireSelectionChange({changedItem:i.item,changedItems:i.items,selectAll:i.selectAll,selected:true});}},this);if(!this.getProperty("hasSelection")&&this.getSelectedItems().length){this.setProperty("hasSelection",true);}this.setValue('');if(i.fireFinishEvent){if(!this.isOpen()){this.fireSelectionFinish({selectedItems:this.getSelectedItems()});}}};
F.prototype.removeSelection=function(i){var H,J,N;if(i.item&&!this.isItemSelected(i.item)){return;}if(!i.item){return;}if(!i.items||!i.items.length||i.selectAll){H=[i.item];}else{H=i.items;}H.forEach(function(U){this.removeAssociation("selectedItems",U,i.suppressInvalidate);J=this.getSelectedKeys();N=J.indexOf(U.getKey());J.splice(N,1);this.setProperty("selectedKeys",J,i.suppressInvalidate);if(!i.listItemUpdated&&n.getListItem(U)){var W=n.getListItem(U);this._getList().setSelectedItem(W,false);}if(!i.tokenUpdated){var X=u(U);U.data(n.CSS_CLASS+"Token",null);this.getAggregation("tokenizer").removeToken(X);}if(i.fireChangeEvent){this.fireSelectionChange({changedItem:i.item,changedItems:i.items,selectAll:i.selectAll,selected:false});}},this);if(this.getProperty("hasSelection")&&!this.getSelectedItems().length){this.setProperty("hasSelection",false);}if(i.fireFinishEvent){if(!this.isOpen()){this.fireSelectionFinish({selectedItems:this.getSelectedItems()});}}};
F.prototype._synchronizeSelectedItemAndKey=function(){var H=this.getSelectedKeys();var J=this.getKeys(this.getSelectedItems());if(!H.length){x.info("Info: _synchronizeSelectedItemAndKey() the MultiComboBox control does not contain any item on ",this);return;}for(var i=0,N=null,U=null,W=H.length;i<W;i++){N=H[i];if(J.indexOf(N)>-1){continue;}U=this.getItemByKey(""+N);if(U){this.setSelection({item:U,id:U.getId(),key:U.getKey(),fireChangeEvent:false,suppressInvalidate:true,listItemUpdated:false});}}};
F.prototype.updateItems=function(i){var H=function(X){return X&&X.getKey&&X.getKey();},J,N=this.getSelectedItems().map(H),U=this.getSelectedKeys();var W=a.prototype.updateItems.apply(this,arguments);N=this.getSelectedItems().map(H).filter(function(X){return N.indexOf(X)>-1;});J=U.concat(N);this.setSelectedKeys(J);return W;};
F.prototype._getSelectedItemsOf=function(H){for(var i=0,J=H.length,N=[];i<J;i++){if(n.getListItem(H[i]).isSelected()){N.push(H[i]);}}return N;};
F.prototype._getLastSelectedItem=function(){var i=this.getAggregation("tokenizer").getTokens();var H=i.length?i[i.length-1]:null;if(!H){return null;}return this._getItemByToken(H);};
F.prototype._getFocusedListItem=function(){if(!document.activeElement){return null;}var i=y.byId(document.activeElement.id);if(this._getList()&&j(this._getList().getFocusDomRef(),i.getFocusDomRef())){return i;}return null;};
F.prototype._getFocusedItem=function(){return n.getItemByListItem(this.getItems(),this._getFocusedListItem());};
F.prototype._hasTokens=function(){return this.getAggregation("tokenizer").getTokens().length>0;};
F.prototype._decorateListItem=function(i){i.addDelegate({onkeydown:function(H){if((H.ctrlKey||H.metaKey)&&H.which==K.A){H.setMarked();H.preventDefault();var J=n.getSelectableItems(this.getItems());var N=this._getSelectedItemsOf(J);if(N.length!==J.length){J.forEach(function(U){this.setSelection({item:U,items:J,selectAll:true,id:U.getId(),key:U.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:false});},this);}else{J.forEach(function(U){this.removeSelection({item:U,items:J,selectAll:true,id:U.getId(),key:U.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:false});},this);}}},onmousedown:function(H){this._setIsClick(true);},onkeyup:function(H){var J=null;if(H.which==K.SPACE&&this.isOpen()&&this._isListInSuggestMode()){this.open();J=this._getLastSelectedItem();if(J){n.getListItem(J).focus();}return;}}},true,this);i.addEventDelegate({onsapbackspace:function(H){H.preventDefault();},onsapshow:function(H){H.setMarked();this.close();},onsaphide:function(H){this.onsapshow(H);},onsapenter:function(H){H.setMarked();this.close();},onsaphome:this.handleHomeEvent.bind(this),onsapend:this.handleEndEvent.bind(this),onsapup:function(H){H.setMarked();H.preventDefault();var J=n.getVisibleItems(this.getItems());var N=J[0];var U=Q(document.activeElement).control()[0];if(U!==n.getListItem(N)){return;}if(this.getShowSelectAll()){this.focusSelectAll();}else if(this.getValueState()!==V.None){this._handleFormattedTextNav();}else{this.focus();}H.stopPropagation(true);},onfocusin:function(H){this.addStyleClass(this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"Focused");},onfocusout:function(H){this.removeStyleClass(this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"Focused");},onsapfocusleave:function(H){var J=this.getAggregation("picker");var N=y.byId(H.relatedControlId);if(J&&N&&v(J.getFocusDomRef(),N.getFocusDomRef())){if(H.srcControl){H.srcControl.focus();}}},onsaptabnext:function(){this.getPicker().close();},onsaptabprevious:function(){this.getPicker().close();}},this);if(D.support.touch){i.addEventDelegate({ontouchstart:function(H){H.setMark("cancelAutoClose");}});}};
F.prototype._handleInputFocusOut=function(){var i=this.isPickerDialog()?this.getPickerTextField():this,U=this._sOldInput||this._sOldValue||"";i.updateDomValue(U);this._bIsPasteEvent=null;};
F.prototype.onItemChange=function(i){var H=a.prototype.onItemChange.call(this,i,this.getShowSecondaryValues());var J=i.getParameters();r({item:i.getSource(),propName:J.name,propValue:J.newValue});return H;};
F.prototype._handleIndicatorPress=function(){var i,H=this.getAggregation("tokenizer");if(this.getEditable()){this.syncPickerContent();this._filterSelectedItems({},true);this.focus();i=this.getPicker();i.open();}else{H._togglePopup(H.getTokensPopup());}if(this.isPickerDialog()){this.getFilterSelectedButton().setPressed(true);this.bOpenedByKeyboardOrButton=true;}};
F.prototype._togglePopover=function(){var i=this.getPicker();if(!i){i=this.syncPickerContent(true);}if(i.isOpen()){i.close();}else{i.open();}};
F.prototype._createTokenizer=function(){var i=new T({renderMode:B.Narrow}).attachTokenDelete(this._handleTokenDelete,this);i.getTokensPopup().attachAfterOpen(function(){if(i.hasOneTruncatedToken()){i.setFirstTokenTruncated(false);}}).attachAfterClose(function(){var H=i.getTokens();if(H.length===1&&!H[0].getTruncated()){i.setFirstTokenTruncated(true);}});i.addEventDelegate({onAfterRendering:this._onAfterRenderingTokenizer},this);return i;};
F.prototype._onAfterRenderingTokenizer=function(){var i=this.getAggregation("tokenizer");if(this.getEditable()){i.addStyleClass("sapMTokenizerIndicatorDisabled");}else{i.removeStyleClass("sapMTokenizerIndicatorDisabled");}setTimeout(this._syncInputWidth.bind(this,i),0);setTimeout(this._handleNMoreAccessibility.bind(this),0);setTimeout(i["scrollToEnd"].bind(i),0);};
F.prototype._handleTokenDelete=function(i){var H=i.getParameter("tokens");var J=this.getSelectedItems();this._removeSelection(H);if(J.length!==n.getSelectableItems(this.getItems())){!this.isPickerDialog()&&!this.isFocusInTokenizer()&&this.focus();this.fireChangeEvent("");}};
F.prototype._removeSelection=function(i){var H=this.getAggregation("tokenizer");i.forEach(function(J){var N=(J&&this._getItemByToken(J));if(!this.getEditable()||!this.getEnabled()||!N||!this.isItemSelected(N)||!N.getEnabled()||!J.getEditable()){return;}this.removeSelection({item:N,id:N.getId(),key:N.getKey(),tokenUpdated:true,fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true});J.destroy();if(this.getSelectedItems().length>0){var i=H.getTokens();i[i.length-1].focus();}else{this.focus();}},this);};
F.prototype.onAfterRenderingList=function(){var i=document.activeElement===this.getFocusDomRef();var H=this._getList();var J=H?H.getVisibleItems():[];if(this.getEditable()&&!i&&J[this._iFocusedIndex]){J[this._iFocusedIndex].focus();this._iFocusedIndex=null;}this.manageSelectAllCheckBoxState();};
F.prototype.onFocusinList=function(){var i=this._getList();if(this._bListItemNavigationInvalidated&&this._getList().getItemNavigation()){i.getItemNavigation().setSelectedIndex(this._iInitialItemFocus);this._bListItemNavigationInvalidated=false;}this._getSuggestionsPopover().updateListDataAttributes(i);};
F.prototype.onAfterRendering=function(){var i=this.getAggregation("tokenizer");a.prototype.onAfterRendering.apply(this,arguments);this._registerResizeHandler();setTimeout(function(){i.setMaxWidth(this._calculateSpaceForTokenizer());}.bind(this),0);};
F.prototype.onfocusout=function(i){this.isOpen()&&this._handleInputFocusOut();this.removeStyleClass("sapMFocus");if(this.getValueState()===V.Error&&this.getValueStateText()===this._oRb.getText("VALUE_STATE_ERROR_ALREADY_SELECTED")){this.setValueState(this._sInitialValueState);this.setValueStateText(this._sInitialValueStateText);}a.prototype.onfocusout.apply(this,arguments);};
F.prototype.onpaste=function(i){var H;var J=false;var N=this.getSelectedItems();if(window.clipboardData){H=window.clipboardData.getData("Text");}else{H=i.originalEvent.clipboardData.getData('text/plain');}var U=H.split(/\r\n|\r|\n/g);if(U&&U.length>0){n.getSelectableItems(this.getItems()).filter(function(W){return N.indexOf(W)===-1;}).forEach(function(W){if(U.indexOf(W.getText())>-1){J=true;this.setSelection({item:W,id:W.getId(),key:W.getKey(),fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true,listItemUpdated:false});}},this);}if(J){i.stopPropagation();i.preventDefault();}};
F.prototype.onsapbackspace=function(i){var H=this.getAggregation("tokenizer");var J=H.getTokens();var N=J.filter(function(U){return U.getSelected();});if(!this.getEnabled()||!this.getEditable()){i.preventDefault();return;}if(this.getCursorPosition()>0||this.getValue().length>0){return;}if(N.length>0){this._removeAllTokens();return;}if(document.activeElement===this.getFocusDomRef()){J[J.length-1]&&J[J.length-1].focus();}i.preventDefault();};
F.prototype._removeAllTokens=function(){var i=this.getAggregation("tokenizer");var H=i.getTokens().filter(function(J){return J.getSelected();});if(!H.length){return;}this._removeSelection(H);this.fireChangeEvent("");this.invalidate();};
F.prototype.onsapdelete=F.prototype.onsapbackspace;
F.prototype.onsapnext=function(i){var H=this.getAggregation("tokenizer");if(i.isMarked()){return;}var J=Q(document.activeElement).control()[0];if(!J){return;}if(J===H||H.$().find(J.$()).length>0&&this.getEditable()){H.scrollToEnd();this.focus();}};
F.prototype.onsapprevious=function(i){if(this.getCursorPosition()===0&&!k(this.getFocusDomRef())){if(i.srcControl===this){T.prototype.onsapprevious.apply(this.getAggregation("tokenizer"),arguments);}}};
F.prototype.onclick=function(i){var H=this.getEditable(),J=this.getEnabled(),N=i.target.className.indexOf("sapMTokenizerIndicator")>-1;if(H&&J&&N){i.preventDefault();this._handleIndicatorPress();}};
F.prototype.ontap=function(i){a.prototype.ontap.apply(this,arguments);var H=this.getOpenArea();if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();if(this.isPickerDialog()&&H.contains(i.target)){this.open();}};
F.prototype.getOpenArea=function(){if(this.isPickerDialog()){return this.getDomRef();}else{return a.prototype.getOpenArea.apply(this,arguments);}};
F.prototype._getItemsStartingWithPerTerm=function(i,H){var J=[],N=H?n.getEnabledItems(this.getItems()):n.getSelectableItems(this.getItems()),U=this.fnFilter?this.fnFilter:m;N.forEach(function(W){if(U(i,W)){J.push(W);}},this);return J;};
F.prototype._getItemsStartingWith=function(i,H){var J=[],N=H?n.getEnabledItems(this.getItems()):n.getSelectableItems(this.getItems());N.forEach(function(U){if(typeof i==="string"&&i!==""&&U.getText().toLowerCase().startsWith(i.toLowerCase())){J.push(U);}},this);return J;};
F.prototype._getUnselectedItemsStartingText=function(i){var H=[];this._getUnselectedItems().forEach(function(J){if(typeof i==="string"&&i!==""&&J.getText().toLowerCase().startsWith(i.toLowerCase())){H.push(J);}},this);return H;};
F.prototype.getCursorPosition=function(){return this._$input.cursorPos();};
F.prototype._selectPreviousItemsOf=function(i){var H;do{H=true;var J=this._getPreviousVisibleItemOf(i);if(J){var N=n.getListItem(J);if(N){H=n.getListItem(J).getSelected();}}this.setSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:true,suppressInvalidate:true});i=J;}while(!H);};
F.prototype._getNextVisibleItemOf=function(i){var H=n.getSelectableItems(this.getItems());var J=H.indexOf(i)+1;if(J<=0||J>H.length-1){return null;}return H[J];};
F.prototype._getPreviousVisibleItemOf=function(i){var H=n.getSelectableItems(this.getItems());var J=H.indexOf(i)-1;if(J<0){return null;}return H[J];};
F.prototype._getNextUnselectedItemOf=function(i){var H=this._getUnselectedItems();var J=H.indexOf(i)+1;if(J<=0||J>H.length-1){return null;}return H[J];};
F.prototype._getPreviousUnselectedItemOf=function(i){var H=this._getUnselectedItems();var J=H.indexOf(i)-1;if(J<0){return null;}return H[J];};
F.prototype._getNextTraversalItem=function(){var i=this.getValue();var H=i?this._getItemsStartingWithPerTerm(i):[];var J=this._getUnselectedItems();if(H.indexOf(this._oTraversalItem)>-1&&this._oTraversalItem.getText()===this.getValue()){return this._getNextUnselectedItemOf(this._oTraversalItem);}if(H.length&&H[0].getText()===this.getValue()){return this._getNextUnselectedItemOf(H[0]);}return H.length?H[0]:J[0];};
F.prototype._getPreviousTraversalItem=function(){var i=this.getValue();var H=i?this._getItemsStartingWithPerTerm(i):[];if(H.indexOf(this._oTraversalItem)>-1&&this._oTraversalItem.getText()===this.getValue()){return this._getPreviousUnselectedItemOf(this._oTraversalItem);}if(H.length&&H[H.length-1].getText()===this.getValue()){return this._getPreviousUnselectedItemOf(H[H.length-1]);}if(H.length){return H[H.length-1];}else{var J=this._getUnselectedItems();if(J.length>0){return J[J.length-1];}else{return null;}}};
F.prototype.setSelectedItems=function(i){this.removeAllSelectedItems();if(!i||!i.length){return this;}if(!Array.isArray(i)){x.warning("Warning: setSelectedItems() has to be an array of sap.ui.core.Item instances or of valid sap.ui.core.Item IDs",this);return this;}i.forEach(function(H){if(!(H instanceof g)&&(typeof H!=="string")){x.warning("Warning: setSelectedItems() has to be an array of sap.ui.core.Item instances or of valid sap.ui.core.Item IDs",this);return;}if(typeof H==="string"){H=y.byId(H);}this.setSelection({item:H?H:null,id:H?H.getId():"",key:H?H.getKey():"",suppressInvalidate:true});},this);return this;};
F.prototype.addSelectedItem=function(i){if(!i){return this;}if(typeof i==="string"){i=y.byId(i);}this.setSelection({item:i?i:null,id:i?i.getId():"",key:i?i.getKey():"",fireChangeEvent:false,suppressInvalidate:true});return this;};
F.prototype.removeSelectedItem=function(i){if(!i){return null;}if(typeof i==="string"){i=y.byId(i);}if(!this.isItemSelected(i)){return null;}this.removeSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:false,suppressInvalidate:true});return i;};
F.prototype.removeAllSelectedItems=function(){var i=[];var H=this.getAssociation("selectedItems",[]);H.forEach(function(J){var N=this.removeSelectedItem(J);if(N){i.push(N.getId());}},this);return i;};
F.prototype.removeSelectedKeys=function(i){var H,J=[];if(!i||!i.length||!Array.isArray(i)){return J;}i.forEach(function(N){H=this.getItemByKey(N);if(H){this.removeSelection({item:H?H:null,id:H?H.getId():"",key:H?H.getKey():"",fireChangeEvent:false,suppressInvalidate:true});J.push(H);}},this);return J;};
F.prototype.setSelectedKeys=function(i){if(this._bInitialSelectedKeysSettersCompleted){this.setProperty("selectedKeys",[],true);this.removeAllSelectedItems();}this.addSelectedKeys(i);this._bInitialSelectedKeysSettersCompleted=true;return this;};
F.prototype.addSelectedKeys=function(i){var H,J=[];i=this.validateProperty("selectedKeys",i);i.forEach(function(N){var U=this.getItemByKey(N);if(U){this.addSelectedItem(U);}else if(N!=null){J.push(N);}},this);if(J.length>0){H=this.getProperty("selectedKeys").filter(function(N){return J.indexOf(N)===-1;});J=H.concat(J);this.setProperty("selectedKeys",J,true);}return this;};
F.prototype._getUnselectedItems=function(){var i=Q(n.getSelectableItems(this.getItems())).not(this.getSelectedItems()).get();if(!this.isOpen()){return i.filter(function(H){return!H.isA("sap.ui.core.SeparatorItem");});}return i;};
F.prototype.getSelectedItems=function(){var i=[],H=this.getAssociation("selectedItems")||[];H.forEach(function(J){var N=y.byId(J);if(N){i.push(N);}},this);return i;};
F.prototype.getWidth=function(){return this.getProperty("width")||"100%";};
F.prototype._updatePopoverBasedOnEditMode=function(i){var H=this._getList(),J=this._getSuggestionsPopover();if(H&&i!==this._bPrevEditable&&i){J.addContent(H);}this._bPrevEditable=i;};
F.prototype._mapItemToListItem=function(i){var H,J,N,U=this.getRenderer();if(!i){return null;}H=n.createListItemFromCoreItem(i,this.getShowSecondaryValues());this._decorateListItem(H);if(i.isA("sap.ui.core.SeparatorItem")){return H;}J=U.CSS_CLASS_MULTICOMBOBOX+"Item";N=(this.isItemSelected(i))?J+"Selected":"";H.addStyleClass(J+" "+N);if(N){var W=new b({key:i.getKey()});W.setText(i.getText());i.data(n.CSS_CLASS+"Token",W);this.getAggregation("tokenizer").addToken(W,true);}this.setSelectable(i,i.getEnabled());return H;};
F.prototype.setSelectable=function(i,H){a.prototype.setSelectable.call(this,i,H);var J=u(i);if(J){J.setVisible(H);}};
F.prototype._fillList=function(){var H=this._getList();var J=this.getEditable()?this.getItems():this.getSelectedItems();if(!H){return;}H.destroyItems();if(!this._oListItemEnterEventDelegate){this._oListItemEnterEventDelegate={onsapenter:function(W){if(W.srcControl.isSelected()){W.setMarked();}}};}for(var i=0,N,U=J.length;i<U;i++){N=this._mapItemToListItem(J[i]);N.addDelegate(this._oListItemEnterEventDelegate,true,this,true);this._getList().addAggregation("items",N,true);if(this.isItemSelected(J[i])){this._getList().setSelectedItem(N,true);}}};
F.prototype.handleInputValidation=function(i,H){var J=i.target.value,N=this.isValueValid(J),U,W,X;var Y=i.srcControl;if(!N&&J!==""&&!H){this._handleFieldValidationState(Y);return;}X=this._getItemsStartingWith(J,true);if(!H||this._bIsPasteEvent){this._handleTypeAhead(J,X,Y);}U=this.getItems();if(this.isPickerDialog()){W=this.getFilterSelectedButton();if(W!=null&&W.getPressed()){W.setPressed(false);}}p(this.getItems(),this.filterItems({value:J,items:U}));this.manageSelectAllCheckBoxState();this._sOldInput=J;if((!this.getValue()||!N)&&!this.bOpenedByKeyboardOrButton&&!this.isPickerDialog()){this.close();}else{this.open();}};
F.prototype.isValueValid=function(i){var H=this._getItemsStartingWith(i,true);var J=this._getItemsStartingWithPerTerm(i,true);return H.length||J.length;};
F.prototype._handleTypeAhead=function(i,H,J){var N,U;if(!this._bDoTypeAhead){return;}N=this.getSelectedItems();U=H.filter(function(W){return N.indexOf(W)===-1;});t(i,J,U);};
F.prototype._handleFieldValidationState=function(i){if(this._sOldInput&&this.isValueValid(this._sOldInput)){i.updateDomValue(this._sOldInput);}else if(this._sOldValue&&this.isValueValid(this._sOldValue)){i.updateDomValue(this._sOldValue);}else{i.updateDomValue("");i.setProperty("effectiveShowClearIcon",false);}if(this._iOldCursorPos){Q(i.getFocusDomRef()).cursorPos(this._iOldCursorPos);}this._showWrongValueVisualEffect();};
F.prototype.init=function(){a.prototype.init.apply(this,arguments);this._bInitialSelectedKeysSettersCompleted=false;this._bListItemNavigationInvalidated=false;this._iInitialItemFocus=-1;this._bCheckBoxClicked=true;this._bPreventValueRemove=false;this._oTokenizer=this._createTokenizer();this.setAggregation("tokenizer",this._oTokenizer);this._aInitiallySelectedItems=[];this._oRbC=y.getLibraryResourceBundle("sap.ui.core");this._fillList();};
F.prototype.handleItemRemoval=function(i){this.removeSelection({item:i,id:i?i.getId():"",key:i?i.getKey():"",fireChangeEvent:false,suppressInvalidate:true,listItemUpdated:true});};
F.prototype.isItemSelected=function(i){return this.getSelectedItems().indexOf(i)>-1;};
F.prototype._clearTokenizer=function(){this.getAggregation("tokenizer").destroyTokens();};
F.prototype.exit=function(){a.prototype.exit.apply(this,arguments);this._deregisterResizeHandler();if(this._oTokenizer){this._oTokenizer.destroy();this._oTokenizer=null;}this._oRbC=null;this._oListItemEnterEventDelegate=null;this.oValueStateNavDelegate=null;this._sInitialValueState=null;};
F.prototype.destroyItems=function(){this.setProperty("selectedKeys",[]);this._clearTokenizer();return this.destroyAggregation("items");};
F.prototype._getItemByToken=function(i){return n.getItemBy(this.getItems(),i,"Token");};
F.prototype._getItemByValue=function(H){var J=n.getSelectableItems(this.getItems());for(var i=0;i<J.length;i++){if(J[i].getText().toLowerCase()===H.toLowerCase()){return J[i];}}};
F.prototype._handleItemToFocus=function(){if(this.isOpen()){return;}this.syncPickerContent();var i,H,J=y.byId(document.activeElement.id),N=this.getSelectedItems(),U=n.getSelectableItems(this.getItems()),W=this._getList(),X=W&&W.getItemNavigation(),Y=this.getValue(),Z=this.getPicker();if(J&&J.isA("sap.m.Token")){H=this._getItemByToken(J);}else if(Y){H=this._getItemByValue(Y);}if(!H){H=N.length?n.getItemByListItem(this.getItems(),this._getList().getSelectedItems()[0]):U[0];}i=n.getVisibleItems(this.getItems()).indexOf(H);if(X){X.setSelectedIndex(i);}else{this._bListItemNavigationInvalidated=true;this._iInitialItemFocus=i;}if(!H){Z.setInitialFocus(this);}else{Z.setInitialFocus(W);}};
F.prototype.getAccessibilityInfo=function(){var i=this.getSelectedItems().map(function(J){return J.getText();}).join(" ");var H=a.prototype.getAccessibilityInfo.apply(this,arguments);H.type=y.getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_MULTICOMBO");H.description=(this.getValueDescriptionInfo()+" "+i).trim();return H;};
F.prototype.getValueDescriptionInfo=function(){if(this.getValue()){return this.getValue();}return this._hasTokens()?"":sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("INPUTBASE_VALUE_EMPTY");};
F.prototype._setIsClick=function(i){this._bIsClick=i;};
F.prototype._getIsClick=function(){return this._bIsClick;};
F.prototype._calculateSpaceForTokenizer=function(){if(this.getDomRef()){var i,H=this.getDomRef().getBoundingClientRect().width,J=this._calculateIconsSpace(),N=this.$().find(".sapMInputBaseInner"),U=["min-width","padding-right","padding-left"],W=U.reduce(function(X,Y){return X+(parseInt(N.css(Y))||0);},0);i=H-(J+W);i=i<0?0:i;return i+"px";}else{return null;}};
F.prototype._syncInputWidth=function(i){var H=this.getDomRef('inner'),J,N;if(!H||(i&&!i.getDomRef())){return;}N=parseFloat(i.getDomRef().getBoundingClientRect().width.toFixed(2));J=this._calculateIconsSpace();H.style.width='calc(100% - '+parseFloat(J+N)+"px)";};
F.prototype._handleNMoreAccessibility=function(){var i=z.getStaticId("sap.m","MULTICOMBOBOX_OPEN_NMORE_POPOVER"),H=this.getAggregation("tokenizer"),J=this.getFocusDomRef(),N=(J&&J.getAttribute("aria-describedby")),U=N?N.split(" "):[],W=U.indexOf(i),X=this.getEnabled(),Y=!this.getEditable()&&H&&H.getHiddenTokensCount();if(Y&&W===-1){U.push(i);X&&this.getFocusDomRef().setAttribute("aria-keyshortcuts","Enter");}else if(W!==-1&&!Y){U.splice(W,1);this.getFocusDomRef().removeAttribute("aria-keyshortcuts");}if(J&&U.length){J.setAttribute("aria-describedby",U.join(" ").trim());}};
F.prototype.applyShowItemsFilters=function(){this.syncPickerContent();p(this.getItems(),this.filterItems({value:this.getValue()||"_",items:this.getItems()}));this.manageSelectAllCheckBoxState();};
F.prototype.showItems=function(i){var H=true,J=this.fnFilter;if(typeof i==="function"){this.syncPickerContent();this.setFilterFunction(i||function(){return true;});H=this.filterItems({value:this.getValue()||"_",items:this.getItems()}).items.length>0;this.setFilterFunction(J);}if(H){a.prototype.showItems.apply(this,arguments);}};
F.prototype.createSelectAllHeaderToolbar=function(i){i=i||this._getList();if(!i||i.getHeaderToolbar()){return;}var H=new c({select:function(J){var N=J.getSource(),U=n.getSelectableItems(this.getItems()),W=this._getSelectedItemsOf(U);if(J.getParameter("selected")){var X=U.filter(function(Y){return W.indexOf(Y)===-1;});X.forEach(function(Y){this.setSelection({item:Y,items:X,selectAll:true,id:Y.getId(),key:Y.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:false});},this);}else{W.forEach(function(Y){this.removeSelection({item:Y,items:W,selectAll:true,id:Y.getId(),key:Y.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:false});},this);}N.focus();}.bind(this)});H.addEventDelegate(this._selectAllDelegate(),this);i.setHeaderToolbar(new d({content:H}).addStyleClass("sapMMultiComboBoxSelectAll")).setSticky(["HeaderToolbar"]);this.attachSelectionChange(this.manageSelectAllCheckBoxState.bind(this));};
F.prototype.manageSelectAllCheckBoxState=function(){var i=this.getSelectAllCheckbox();if(!i){return;}var H=this.getItems(),J=this.getSelectedItems(),N=n.getSelectableItems(H).filter(function(U){return J.indexOf(U)>-1;}).length===n.getSelectableItems(H).length;i.setText(this._oRb.getText("MULTICOMBOBOX_SELECT_ALL_CHECKBOX",[J.length,n.getAllSelectableItems(H).length])).setSelected(N);};
F.prototype.getSelectAllToolbar=function(){var i=this._getList();return i&&i.getHeaderToolbar();};
F.prototype.getSelectAllCheckbox=function(){var i=this.getSelectAllToolbar();return i&&i.getContent()[0];};
F.prototype._selectAllDelegate=function(){return{onsapdown:this.handleDownEvent,onsapup:function(i){i.preventDefault();if(this.getValueState()!==V.None){this._handleFormattedTextNav();return;}this.getFocusDomRef().focus();},onsaphome:this.handleHomeEvent,onsapend:this.handleEndEvent,onfocusin:function(){var i=this.getRenderer(),H=this.getSelectAllToolbar();H&&H.addStyleClass(i.CSS_CLASS_MULTICOMBOBOX+"SelectAllFocused");},onfocusout:function(){var i=this.getRenderer(),H=this.getSelectAllToolbar();H&&H.removeStyleClass(i.CSS_CLASS_MULTICOMBOBOX+"SelectAllFocused");},onsapshow:this.close,onsaphide:this.close};};
F.prototype.focusSelectAll=function(){var i=this.getSelectAllCheckbox();i&&i.focus();};
F.prototype.toggleSelectAllVisibility=function(i){var H=this.getSelectAllToolbar();if(H){H.setVisible(i);return;}i&&this.createSelectAllHeaderToolbar();};
F.prototype.handleClearIconPress=function(){if(!(this.getEnabled()&&this.getEditable())){return;}if(this.getValue()!==""){this.setValue("");this._sOldInput="";this.setProperty("effectiveShowClearIcon",false);}};
return F;});
sap.ui.predefine('sap/m/MultiComboBoxRenderer',['./ComboBoxBaseRenderer','./ComboBoxTextFieldRenderer','sap/ui/core/Renderer','sap/ui/core/Core'],function(C,a,R,b){"use strict";var M=R.extend(C);M.apiVersion=2;M.CSS_CLASS_MULTICOMBOBOX="sapMMultiComboBox";
M.addOuterClasses=function(r,c){C.addOuterClasses.apply(this,arguments);r.class(M.CSS_CLASS_MULTICOMBOBOX);if(c.getProperty("hasSelection")){r.class("sapMMultiComboBoxHasToken");}};
M.getAriaDescribedBy=function(c){var A=a.getAriaDescribedBy.apply(this,arguments),t=c.getAggregation("tokenizer"),i=t&&t.getTokensInfoId();return(A||"")+" "+i;};
M.getAccessibilityState=function(c){var A=C.getAccessibilityState.apply(this,arguments),r=b.getLibraryResourceBundle("sap.m");A.roledescription=r.getText("MULTICOMBOBOX_ARIA_ROLE_DESCRIPTION");return A;};
M.prependInnerContent=function(r,c){r.renderControl(c.getAggregation("tokenizer"));};
return M;},true);
sap.ui.predefine('sap/m/MultiEditField',["sap/ui/core/XMLComposite","./library","sap/ui/core/Item"],function(X,l,I){"use strict";
var M=X.extend("sap.m.MultiEditField",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{selectedItem:{type:"sap.ui.core.Item",group:"Data",defaultValue:null,invalidate:true},showValueHelp:{type:"boolean",group:"Behavior",defaultValue:true,invalidate:true},nullable:{type:"boolean",group:"Behavior",defaultValue:true,invalidate:true},required:{type:"boolean",group:"Behavior",defaultValue:false,invalidate:true}},aggregations:{items:{type:"sap.ui.core.Item",multiple:true,bindable:"bindable"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}}}});
M.prototype.init=function(){if(!M.prototype._oRb){M.prototype._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");}var k=new I({key:"keep",text:"< "+this._oRb.getText("MULTI_EDIT_KEEP_TEXT")+" >"}),b=new I({key:"blank",text:"< "+this._oRb.getText("MULTI_EDIT_BLANK_TEXT")+" >"}),n=new I({key:"new",text:"< "+this._oRb.getText("MULTI_EDIT_NEW_TEXT")+" >"});this._getKeepAll=function(){return k;};this._getBlank=function(){return b;};this._getValueHelp=function(){return n;};this.byId("select").getParent=this.getParent.bind(this);this._oLastSelectedItem=this._getKeepAll();};
M.prototype.onBeforeRendering=function(){this.insertAggregation("items",this._getKeepAll(),0,true);if(this.getNullable()){this.insertAggregation("items",this._getBlank(),1,true);}else{this.removeAggregation("items",this._getBlank(),true);}if(this.getShowValueHelp()){this.insertAggregation("items",this._getValueHelp(),this.getNullable()?2:1,true);}else{this.removeAggregation("items",this._getValueHelp(),true);}var s=this.getSelectedItem();if(s){s=this._getInternalItem(s);this.byId("select").setSelectedItem(s);}};
M.prototype.setSelectedItem=function(s){var i=this._getExternalItem(s)||s;var o;if(i&&this.indexOfItem(i)>=0&&!this._isSpecialValueItem(i)){o=this._getInternalItem(s);if(o){this.byId("select").setSelectedItem(o);}this._oLastSelectedItem=i;return this.setProperty("selectedItem",i);}return this;};
M.prototype.exit=function(){this._getKeepAll().destroy();this._getBlank().destroy();this._getValueHelp().destroy();var i=this.byId("itemTemplate");if(i){i.destroy();}};
M.prototype.getFormDoNotAdjustWidth=function(){return true;};
M.prototype.isBlankSelected=function(){return this._getExternalItem(this.byId("select").getSelectedItem())===this._getBlank();};
M.prototype.isKeepExistingSelected=function(){return this._getExternalItem(this.byId("select").getSelectedItem())===this._getKeepAll();};
M.prototype._isSpecialValueItem=function(i){return i===this._getKeepAll()||i===this._getBlank()||i===this._getValueHelp();};
M.prototype._handleSelectionChange=function(e){var i=this._getExternalItem(e.getParameter("selectedItem"));if(i&&!this._isSpecialValueItem(i)){this.fireChange({selectedItem:i});}else if(i===this._getValueHelp()){this.fireEvent("_valueHelpRequest");}if(i!==this._getValueHelp()){this._oLastSelectedItem=i;this.setProperty("selectedItem",i,true);}};
M.prototype.resetSelection=function(){this.byId("select").setSelectedItem(this._getInternalItem(this._oLastSelectedItem));};
M.prototype._getExternalItem=function(i){var a=this.byId("select").indexOfItem(i);if(a>=0){return this.getItems()[a];}return null;};
M.prototype._getInternalItem=function(i){var a=this.indexOfItem(i);if(a>=0){return this.byId("select").getItems()[a];}return null;};
M.prototype._getInternalDomRef=function(){var s=this.byId("select");return s&&s.getDomRef();};
M.prototype._getInternalUIArea=function(){return this.byId("select").getUIArea();};
return M;});
sap.ui.predefine('sap/m/MultiInput',['./Input','./Tokenizer','./Token','./library','sap/ui/core/EnabledPropagator','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectMetadata','sap/ui/base/ManagedObjectObserver','sap/ui/Device','./Popover','./List','./Title','./Bar','./Toolbar','./StandardListItem','sap/ui/core/ResizeHandler','sap/ui/core/IconPool','./MultiInputRenderer',"sap/ui/dom/containsOrEquals","sap/m/inputUtils/completeTextSelected","sap/ui/events/KeyCodes",'sap/ui/core/InvisibleText',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos","sap/ui/dom/jquery/control"],function(I,T,a,l,E,M,b,c,D,P,L,d,B,f,S,R,g,h,j,k,K,m,q){"use strict";var n=l.TokenizerRenderMode;
var o=I.extend("sap.m.MultiInput",{metadata:{interfaces:["sap.ui.core.ISemanticFormContent"],library:"sap.m",designtime:"sap/m/designtime/MultiInput.designtime",properties:{enableMultiLineMode:{type:"boolean",group:"Behavior",defaultValue:false,deprecated:true},maxTokens:{type:"int",group:"Behavior"},_semanticFormValue:{type:"string",group:"Behavior",defaultValue:"",visibility:"hidden"}},aggregations:{tokens:{type:"sap.m.Token",multiple:true,singularName:"token"},tokenizer:{type:"sap.m.Tokenizer",multiple:false,visibility:"hidden"}},events:{tokenChange:{parameters:{type:{type:"string"},token:{type:"sap.m.Token"},tokens:{type:"sap.m.Token[]"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}},deprecated:true},tokenUpdate:{allowPreventDefault:true,parameters:{type:{type:"string"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}}},dnd:{draggable:false,droppable:true}}});
E.apply(o.prototype,[true]);var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
o.prototype.init=function(){var t=this;this._bShowListWithTokens=false;I.prototype.init.call(this);this._getClearIcon();this._bIsValidating=false;var e=new T({renderMode:n.Narrow,tokenDelete:this._tokenDelete.bind(this)});e.updateTokens=function(){this.destroyTokens();this.updateAggregation("tokens");};this.setAggregation("tokenizer",e);e.getTokensPopup().attachBeforeOpen(this._onBeforeOpenTokensPicker.bind(this)).attachAfterClose(this._onAfterCloseTokensPicker.bind(this))._getPopup().setAutoCloseAreas([e,this]);this.setAggregation("tokenizer",e);this._oTokenizerObserver=new c(function(C){var s=C.mutation;var i=C.child;switch(s){case"insert":i.attachEvent("_change",this.invalidate,this);this.fireTokenChange({type:sap.m.Tokenizer.TokenChangeType.Added,token:i,tokens:[i],removedTokens:[]});break;case"remove":var p=C.object.getTokens().length?sap.m.Tokenizer.TokenChangeType.Removed:sap.m.Tokenizer.TokenChangeType.RemovedAll;i.detachEvent("_change",this.invalidate,this);this.fireTokenChange({type:p,token:i,removedTokens:[i]});break;default:break;}this.updateFormValueProperty();this.invalidate();}.bind(this));this._oTokenizerObserver.observe(e,{aggregations:["tokens"]});this._bShowListWithTokens=false;this._bIsValidating=false;e.addEventDelegate({onThemeChanged:this._handleInnerVisibility.bind(this),onAfterRendering:function(){if(this.isMobileDevice()&&this.getEditable()){e.addStyleClass("sapMTokenizerIndicatorDisabled");}else{e.removeStyleClass("sapMTokenizerIndicatorDisabled");}this._syncInputWidth(e);this._handleInnerVisibility();this._handleNMoreAccessibility();this._registerTokenizerResizeHandler();}.bind(this)},this);this._aTokenValidators=[];this.setShowValueHelp(true);this.setShowSuggestion(true);this._getSuggestionsPopover().getPopover().attachBeforeOpen(function(){if(t.isMobileDevice()!==true){return;}var i=e._getTokensList();e._fillTokensList(i);this.addContent(i);t._manageListsVisibility(!!e.getTokens().length);}).attachAfterOpen(function(){var N=t.getTokens().length?r.getText("MULTIINPUT_NAVIGATION_POPUP_AND_TOKENS"):r.getText("MULTIINPUT_NAVIGATION_POPUP");t._oInvisibleMessage.announce(N);});this.attachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.attachLiveChange(this._onLiveChange,this);this.attachValueHelpRequest(this._onValueHelpRequested,this);this._getValueHelpIcon().setProperty("visible",true,true);this._onResize=this._onResize.bind(this);};
o.prototype.exit=function(){this._deregisterResizeHandler();this._deregisterTokenizerResizeHandler();this._oTokenizerObserver.disconnect();this._oTokenizerObserver.destroy();this._oTokenizerObserver=null;I.prototype.exit.call(this);};
o.prototype.onAfterRendering=function(){var t=this.getAggregation("tokenizer");this._bTokenIsValidated=false;t.setMaxWidth(this._calculateSpaceForTokenizer());t.scrollToEnd();this._registerResizeHandler();I.prototype.onAfterRendering.apply(this,arguments);};
o.prototype._tokenDelete=function(e){if(!this.getEditable()||!this.getEnabled()){return;}this._deleteTokens(e.getParameter("tokens"),e.getParameters());};
o.prototype._deleteTokens=function(e,O){var t=this.getAggregation("tokenizer");var i=0;var p=O.keyCode===K.BACKSPACE;var s=e[e.length-1];var F=e[0];i=this.getTokens().indexOf(p?F:s);t.focusToken(i,O,function(){this.focus();}.bind(this));this.fireTokenUpdate({type:T.TokenUpdateType.Removed,addedTokens:[],removedTokens:e});e.filter(function(u){return this.getEditable()&&this.getEnabled()&&u.getEditable();}.bind(this)).forEach(function(u){u.destroy();});if(this.getTokens().length===0){t.getTokensPopup().close();}if(!O.keyCode){this.focus();}};
o.prototype._handleInnerVisibility=function(){var H=!!this.getAggregation("tokenizer").getHiddenTokensCount();this._setValueVisible(!H);};
o.prototype.oninput=function(e){this.setProperty("selectedKey",'',true);I.prototype.oninput.call(this,e);if(e.isMarked("invalid")||!this.getEditable()){return;}this._setValueVisible(true);this._manageListsVisibility(false);this.getAggregation("tokenizer").getTokensPopup().close();};
o.prototype._registerResizeHandler=function(){if(!this._iResizeHandlerId){this._iResizeHandlerId=R.register(this,this._onResize);}};
o.prototype._deregisterResizeHandler=function(){if(this._iResizeHandlerId){R.deregister(this._iResizeHandlerId);this._iResizeHandlerId=null;}};
o.prototype._registerTokenizerResizeHandler=function(){if(!this._iTokenizerResizeHandler){this._iTokenizerResizeHandler=R.register(this.getAggregation("tokenizer"),this._onResize);}};
o.prototype._deregisterTokenizerResizeHandler=function(){if(this._iTokenizerResizeHandler){R.deregister(this._iTokenizerResizeHandler);this._iTokenizerResizeHandler=null;}};
o.prototype._onResize=function(){this.getAggregation("tokenizer").setMaxWidth(this._calculateSpaceForTokenizer());};
o.prototype._onSuggestionItemSelected=function(e){var t=this.getAggregation("tokenizer"),i=null,p=null,O=t.getTokens().length;if(this.getMaxTokens()&&O>=this.getMaxTokens()||this._bValueHelpOpen){return;}if(this._hasTabularSuggestions()){i=e.getParameter("selectedRow");}else{i=e.getParameter("selectedItem");if(i){p=new a({text:M.escapeSettingsValue(i.getText()),key:M.escapeSettingsValue(i.getKey())});}}if(i&&!this._bTokenIsAdded){var s=this.getValue();this.addValidateToken({text:s,token:p,suggestionObject:i,validationCallback:this._validationCallback.bind(this,O)});}if(this.isMobileDevice()){var N=t.getTokens().length;if(O<N){this.setValue("");}if(this._getSuggestionsList()instanceof sap.m.Table){this._getSuggestionsList().addStyleClass("sapMInputSuggestionTableHidden");}else{this._getSuggestionsList().destroyItems();}var u=this.getAggregation("tokenizer").getScrollDelegate();if(u){u.scrollTo(0,0,0);}this._getSuggestionsPopover().getInput().focus();}this._bTokenIsAdded=false;};
o.prototype._onValueHelpRequested=function(){this._bValueHelpOpen=true;};
o.prototype._onLiveChange=function(e){var C=this.getAggregation("tokenizer").getTokens().every(function(t){return t.getSelected();});if(!C){return;}this.removeAllTokens();};
o.prototype._setValueVisible=function(v){var V=v?"1":"0";this.$("inner").css("opacity",V);};
o.prototype.onmousedown=function(e){if(e.target==this.getDomRef('content')){e.preventDefault();e.stopPropagation();}};
o.prototype.openMultiLine=function(){};
o.prototype.closeMultiLine=function(){};
o.prototype.showItems=function(){I.prototype.showItems.apply(this,arguments);this._manageListsVisibility(false);};
o.prototype.onBeforeRendering=function(){var t=this.getAggregation("tokenizer");var e=t._getTokensList();I.prototype.onBeforeRendering.apply(this,arguments);this._hideTokensOverLimit();t.setEnabled(this.getEnabled());t._fillTokensList(e);};
o.prototype._hideTokensOverLimit=function(){if(!this.getMaxTokens()){return;}this.getTokens().forEach(function(t,i){if(i>=this.getMaxTokens()){return t.setVisible(false);}return t.setVisible(true);},this);};
o.prototype.onsapnext=function(e){var t=this.getAggregation("tokenizer");if(e.isMarked()){return;}var F=q(document.activeElement).control()[0];if(!F){return;}if(t===F||t.$().find(F.$()).length>0){t.scrollToEnd();this.$().find("input").trigger("focus");}};
o.prototype.onsapbackspace=function(e){var v=this.getValue();var i=this.getFocusDomRef()===document.activeElement;var t=this.getTokens();var p=t[t.length-1];if(!this.getEnabled()||!this.getEditable()){e.preventDefault();return;}if(v===""&&i&&p&&e.srcControl===this){var A=t.filter(function(s){return s.getSelected();}).length===t.length;if(A){return this._deleteTokens(t,{keyCode:K.BACKSPACE});}p.focus();e.preventDefault();}};
o.prototype.onsapdelete=function(e){if(!this.getEditable()){return;}if(this.getValue()&&!k(this.getFocusDomRef())){return;}if(e.isMarked("forwardFocusToParent")){this.focus();}};
o.prototype.onkeydown=function(e){var t=this.getAggregation("tokenizer");I.prototype.onkeydown.apply(this,arguments);if(!this.getEnabled()){return;}if(e.which===K.TAB){t.selectAllTokens(false);}if((e.ctrlKey||e.metaKey)&&e.which===K.A&&t.getTokens().length>0){t.focus();t.selectAllTokens(true);e.preventDefault();}if((e.ctrlKey||e.metaKey)&&(e.which===K.C||e.which===K.INSERT)){t._copy();}if(((e.ctrlKey||e.metaKey)&&e.which===K.X)||(e.shiftKey&&e.which===K.DELETE)){if(this.getEditable()){t._cut();}else{t._copy();}}if((e.ctrlKey||e.metaKey)&&e.which===K.I&&t.getTokens().length){t._togglePopup(t.getTokensPopup());e.preventDefault();}};
o.prototype.onpaste=function(e){var O,i,s,A=[];if(this.getValueHelpOnly()){return;}O=e.originalEvent.clipboardData.getData('text/plain');s=O.split(/\r\n|\r|\n/g);if(s.length<=1){return;}setTimeout(function(){if(s){if(this.fireEvent("_validateOnPaste",{texts:s},true)){var p="";for(i=0;i<s.length;i++){if(s[i]){var t=this._convertTextToToken(s[i],true);if(this._addUniqueToken(t)){A.push(t);}else{p=s[i];}}}this.updateDomValue(p);if(A.length>0){this.fireTokenUpdate({addedTokens:A,removedTokens:[],type:T.TokenUpdateType.Added});this.fireTokenChange({addedTokens:A,removedTokens:[],type:T.TokenChangeType.TokensChanged});}}if(A.length){this.cancelPendingSuggest();}}}.bind(this),0);};
o.prototype._validationCallback=function(O,v){var N=this.getAggregation("tokenizer").getTokens().length;var s=this._getSuggestionsPopover();this._bIsValidating=false;if(v){this.setValue("");this._bTokenIsValidated=true;if(this.isMobileDevice()&&s&&s.getInput()&&(O<N)){s.getInput().setValue("");}}};
o.prototype.onsapprevious=function(e){if(this._getIsSuggestionPopupOpen()){return;}if(this._$input.cursorPos()===0){if(e.srcControl===this){T.prototype.onsapprevious.apply(this.getAggregation("tokenizer"),arguments);}}if(e.keyCode===K.ARROW_UP){e.preventDefault();}};
o.prototype.onsaphome=function(e){if(!this.getFocusDomRef().selectionStart){T.prototype.onsaphome.apply(this.getAggregation("tokenizer"),arguments);}I.prototype.onsaphome.apply(this,arguments);};
o.prototype.onsapend=function(e){if(e.isMarked("forwardFocusToParent")){this.focus();}I.prototype.onsapend.apply(this,arguments);};
o.prototype.onsapenter=function(e){var s=this.getDOMValue();I.prototype.onsapenter.apply(this,arguments);var v=true,t=this.getAggregation("tokenizer");if(this._getIsSuggestionPopupOpen()){if(this._hasTabularSuggestions()){v=!this._getSuggestionsTable().getSelectedItem();}else{v=!this._getSuggestionsList().getSelectedItem();}}if(v){this._validateCurrentText();}if(e&&e.setMarked&&(this._bTokenIsValidated||s)){e.setMarked();}if(!this.getEditable()&&t.getHiddenTokensCount()&&e.target===this.getFocusDomRef()){t._togglePopup(t.getTokensPopup());}this.focus();};
o.prototype.onsapfocusleave=function(e){var p=this._getSuggestionsPopoverPopup(),t=this.getAggregation("tokenizer"),s=t.getTokensPopup(),N=false,i=false,u=this.getDomRef()&&j(this.getDomRef(),document.activeElement),v,F;if(p&&p.isA("sap.m.Popover")){if(e.relatedControlId){v=sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef();N=j(p.getFocusDomRef(),v);i=j(t.getFocusDomRef(),v);if(s){F=j(s.getFocusDomRef(),v);}}}I.prototype.onsapfocusleave.apply(this,arguments);if(this._bIsValidating||this._bValueHelpOpen){return;}if(!this.isMobileDevice()&&!N&&e.relatedControlId!==this.getId()&&!i){this._validateCurrentText(true);}if(!this.isMobileDevice()&&this.getEditable()){if(u||N){return;}}if(!F&&!i){s.isOpen()&&!this.isMobileDevice()&&t._togglePopup(s);t.setRenderMode(n.Narrow);}this._handleInnerVisibility();};
o.prototype.ontap=function(e){var t=this.getAggregation("tokenizer");if(document.activeElement===this._$input[0]||document.activeElement===t.getDomRef()){t.selectAllTokens(false);}if(e&&e.isMarked("tokenDeletePress")){return;}I.prototype.ontap.apply(this,arguments);};
o.prototype.onfocusin=function(e){var t=this.getAggregation("tokenizer");this._deregisterTokenizerResizeHandler();this._bValueHelpOpen=false;if(e.target===this.getFocusDomRef()){I.prototype.onfocusin.apply(this,arguments);if(t.hasOneTruncatedToken()&&this.getEnabled()&&this.getEditable()){t.getTokens()[0].setSelected(false);!this.isMobileDevice()&&t.setFirstTokenTruncated(false);}}if(!this.isMobileDevice()&&this.getEditable()&&e.target===this.getDomRef("inner")&&!(this._getIsSuggestionPopupOpen())){t.setRenderMode(n.Loose);this._setValueVisible(true);}this._registerResizeHandler();};
o.prototype.onsapescape=function(e){var t=this.getAggregation("tokenizer"),p=t.getTokensPopup();this.getAggregation("tokenizer").selectAllTokens(false);this.selectText(0,0);if(p.isOpen()){t._togglePopup(p);}I.prototype.onsapescape.apply(this,arguments);};
o.prototype._getIsSuggestionPopupOpen=function(){var s=this._getSuggestionsPopover(),e=this._getSuggestionsPopoverPopup();return s&&e&&e.isOpen();};
o.prototype.setEditable=function(e){var t=this.getAggregation("tokenizer");e=this.validateProperty("editable",e);if(e===this.getEditable()){return this;}if(I.prototype.setEditable){I.prototype.setEditable.apply(this,arguments);}t.setEditable(e);return this;};
o.prototype._findItem=function(t,e,p,G){if(!t){return;}if(!(e&&e.length)){return;}t=t.toLowerCase();var s=e.length;for(var i=0;i<s;i++){var u=e[i];var v=G(u);if(!v){continue;}v=v.toLowerCase();if(v===t){return u;}if(!p&&v.indexOf(t)===0){return u;}}};
o.prototype._getSuggestionItem=function(t,e){var p=null;var s=null;if(this._hasTabularSuggestions()){p=this.getSuggestionRows();s=this._findItem(t,p,e,function(u){var v=u.getCells();var w=null;if(v){var i;for(i=0;i<v.length;i++){if(v[i].getText){w=v[i].getText();break;}}}return w;});}else{p=this.getSuggestionItems();s=this._findItem(t,p,e,function(s){return s.getText();});}return s;};
o.prototype.clone=function(){var C;this.detachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.detachLiveChange(this._onLiveChange,this);this.detachValueHelpRequest(this._onValueHelpRequested,this);C=I.prototype.clone.apply(this,arguments);this.attachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.attachLiveChange(this._onLiveChange,this);this.attachValueHelpRequest(this._onValueHelpRequested,this);return C;};
o.getMetadata().forwardAggregation("tokens",{getter:function(){return this.getAggregation("tokenizer");},aggregation:"tokens",forwardBinding:true});
o.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("content");};
o.prototype.setTokens=function(t){if(!Array.isArray(t)){return;}this.removeAllTokens();t.forEach(function(e){b.addAPIParentInfoBegin(e,this,"tokens");},this);t.forEach(function(e){this.addToken(e);},this);t.forEach(function(e){b.addAPIParentInfoEnd(e);},this);this.fireTokenChange({type:sap.m.Tokenizer.TokenChangeType.TokensChanged,addedTokens:t,removedTokens:[]});return this;};
o.TokenChangeType={Added:"added",Removed:"removed",RemovedAll:"removedAll",TokensChanged:"tokensChanged"};o.WaitForAsyncValidation="sap.m.MultiInput.WaitForAsyncValidation";o.prototype.getDomRefForValueStateMessage=o.prototype.getPopupAnchorDomRef;
o.prototype.updateInputField=function(N){I.prototype.updateInputField.call(this,N);var s=this._getSuggestionsPopover();this.setDOMValue('');if(s.getInput()){s.getInput().setDOMValue('');}};
o.prototype.onChange=function(e,p,N){p=p||this.getChangeEventParams();if(!this.getEditable()||!this.getEnabled()){return;}var v=this._getInputValue(N);if(v===this.getLastValue()){this._bCheckDomValue=false;return;}if(!this._bTokenIsValidated){this.setValue(v);v=this.getValue();this.setLastValue(v);}this.fireChangeEvent(v,p);return true;};
o.prototype.getAccessibilityInfo=function(){var t=this.getTokens().map(function(e){return e.getText();}).join(" ");var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.type=r.getText("ACC_CTR_TYPE_MULTIINPUT");i.description=(this.getValueDescriptionInfo()+" "+t).trim();return i;};
o.prototype.getValueDescriptionInfo=function(){var t=this.getTokens().length;var s=this.getDescription()||"";var v=this.getValue();if(v){return v;}if(t>0){return s;}else{return s?s:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("INPUTBASE_VALUE_EMPTY");}};
o.prototype._decoratePopupInput=function(p){I.prototype._decoratePopupInput.apply(this,arguments);var t=this;if(!p){return;}p.addEventDelegate({oninput:t._manageListsVisibility.bind(t,false),onsapenter:function(e){if(p.getValue()){t._closeSuggestionPopup();}t._validateCurrentText();t._setValueVisible(false);t.onChange(e,null,p.getValue());}});return p;};
o.prototype._hasShowSelectedButton=function(){return true;};
o.prototype.forwardEventHandlersToSuggPopover=function(s){I.prototype.forwardEventHandlersToSuggPopover.apply(this,arguments);s.setShowSelectedPressHandler(this._handleShowSelectedPress.bind(this));};
o.prototype._handleShowSelectedPress=function(e){this._bShowListWithTokens=e.getSource().getPressed();this._manageListsVisibility(this._bShowListWithTokens);};
o.prototype._onBeforeOpenTokensPicker=function(){var t=this.getAggregation("tokenizer"),p=t.getTokensPopup(),e=this.getDomRef(),i=this.getEditable(),C,s;this._setValueVisible(false);this._manageListsVisibility(true);if(e&&p){C=parseInt(p.getContentWidth());s=isNaN(C)||e.offsetWidth>C?e.offsetWidth:C;s=((t.getTokens().length===1)||!i)?"auto":(s/parseFloat(l.BaseFontSize))+"rem";p.setContentWidth(s);}};
o.prototype._onAfterCloseTokensPicker=function(){if(document.activeElement!==this.getDomRef("inner")){this.getAggregation("tokenizer").setRenderMode(n.Narrow);}};
o.prototype.getDialogTitle=function(){var p=this._getSuggestionsPopoverPopup(),H=p&&p.getCustomHeader();if(H){return H.getContentMiddle()[0];}return null;};
o.prototype._updatePickerHeaderTitle=function(){var e,i;i=this.getLabels();if(i.length){e=i[0];if(e&&(typeof e.getText==="function")){this.getDialogTitle().setText(e.getText());}}else{this.getDialogTitle().setText(r.getText("COMBOBOX_PICKER_TITLE"));}};
o.prototype._getSuggestionsList=function(){var s=this._getSuggestionsPopover();return s&&s.getItemsContainer();};
o.prototype._getSuggestionsPopoverPopup=function(){return this._oSuggestionPopup;};
o.prototype._manageListsVisibility=function(s){if(!this.isMobileDevice()){return;}this.getAggregation("tokenizer")._getTokensList().setVisible(s);this._getSuggestionsList()&&this._getSuggestionsList().setVisible(!s);this._getSuggestionsPopover().getFilterSelectedButton().setPressed(s);};
o.prototype._handleNMoreAccessibility=function(){var i=m.getStaticId("sap.m","MULTICOMBOBOX_OPEN_NMORE_POPOVER"),F=this.getFocusDomRef(),A=(F&&F.getAttribute("aria-describedby")),e=A?A.split(" "):[],N=e.indexOf(i),p=this.getEnabled(),s=!this.getEditable()&&this.getAggregation("tokenizer").getHiddenTokensCount();if(s&&N===-1){e.push(i);p&&this.getFocusDomRef().setAttribute("aria-keyshortcuts","Enter");}else if(N!==-1&&!s){e.splice(N,1);this.getFocusDomRef().removeAttribute("aria-keyshortcuts");}if(F&&e.length){F.setAttribute("aria-describedby",e.join(" ").trim());}};
o.prototype._calculateSpaceForTokenizer=function(){var e=this.getDomRef();if(e){var s,i=this.$().find(".sapMInputDescriptionWrapper"),p=this.$().find(".sapMInputBaseInner"),C=e.offsetWidth||0,t=i.width()||0,u=this._calculateIconsSpace(),v=["min-width","padding-right","padding-left"],w=v.reduce(function(A,x){return A+(parseInt(p.css(x))||0);},0);s=C-(u+w+t);s=s<0?0:s;return s+"px";}else{return null;}};
o.prototype._syncInputWidth=function(t){var F=this.getDomRef('inner'),s,i;if(!F||(t&&!t.getDomRef())){return;}s=this._calculateIconsSpace();i=t.getDomRef().scrollWidth;F.style.width='calc(100% - '+Math.floor(s+i)+"px";};
o.prototype.isValueHelpOnlyOpener=function(t){return[this._$input[0],this._getValueHelpIcon().getDomRef()].indexOf(t)>-1;};
o.prototype._shouldTriggerSuggest=function(){var s=I.prototype._shouldTriggerSuggest.apply(this,arguments);return s&&!this._bShowListWithTokens;};
o.prototype.addValidator=function(v){if(typeof(v)==="function"){this._aTokenValidators.push(v);}};
o.prototype.removeValidator=function(v){var i=this._aTokenValidators.indexOf(v);if(i!==-1){this._aTokenValidators.splice(i,1);}};
o.prototype.removeAllValidators=function(){this._aTokenValidators=[];};
o.prototype.getValidators=function(){return this._aTokenValidators;};
o.prototype.addValidateToken=function(p,v){var t=this._validateToken(p,v),A=this._addUniqueToken(t,p.validationCallback);if(A){this.fireTokenUpdate({addedTokens:[t],removedTokens:[],type:T.TokenUpdateType.Added});this.fireTokenChange({addedTokens:[t],removedTokens:[],type:T.TokenChangeType.TokensChanged});}};
o.prototype._validateToken=function(p,v){var t=p.token,V=p.validationCallback,s=p.suggestionObject,e=t&&t.getText(),u=e?e:p.text,w;v=v?v:this._aTokenValidators;w=v.length;if(!w){if(!t&&V){V(false);}return t;}for(var i=0;i<w;i++){t=v[i]({text:u,suggestedToken:t,suggestionObject:s,asyncCallback:this._getAsyncValidationCallback(v,i,u,s,V)});if(!t){if(V){V(false);}return null;}if(t===o.WaitForAsyncValidation){return null;}}return t;};
o.prototype._addUniqueToken=function(t,v){if(!t){return false;}var e=!this._tokenExists(t);e&&this.addToken(t);if(v){v(e);}return e;};
o.prototype._tokenExists=function(t){var e=this.getTokens(),p=e.length,s=t&&t.getKey();if(!s){return false;}for(var i=0;i<p;i++){if(e[i].getKey()===s){return true;}}return false;};
o.prototype._convertTextToToken=function(t,C){var e=this.getAggregation("tokenizer"),O=e.getTokens().length,i=this._configureTokenOptions(t,false,C),v=i.text,p=i.item,s=i.token;if(!v){return null;}return this._validateToken({text:v,token:s,suggestionObject:p,validationCallback:this._validationCallback.bind(this,O)});};
o.prototype._validateCurrentText=function(e){var t=this.getAggregation("tokenizer"),O=t.getTokens().length,i=this._configureTokenOptions(this.getValue(),e),v=i.text,p=i.item,s=i.token;if(!v){return null;}if(p){this._bTokenIsAdded=true;}if(!this.getMaxTokens()||this.getTokens().length<this.getMaxTokens()){this._bIsValidating=true;this.addValidateToken({text:v,token:s,suggestionObject:p,validationCallback:this._validationCallback.bind(this,O)});}};
o.prototype._configureTokenOptions=function(v,e,p){var i,t;if(v&&this.getEditable()){v=v.trim();}if(v&&(e||p||this._getIsSuggestionPopupOpen())){if(this._hasTabularSuggestions()){i=this._getSuggestionsTable().getSelectedItem();}else{i=this._getSuggestionItem(v,e);}}if(i&&i.getText&&i.getKey){t=new a({text:M.escapeSettingsValue(i.getText()),key:i.getKey()});}return{text:v,item:i,token:t};};
o.prototype._getAsyncValidationCallback=function(v,V,i,s,e){var t=this;return function(p){if(p){p=t.addValidateToken({text:i,token:p,suggestionObject:s,validationCallback:e},v.slice(V+1));}else{e&&e(false);}};};
o.prototype.getFormFormattedValue=function(){return this.getTokens().map(function(t){return t.getText();}).join(", ");};
o.prototype.getFormValueProperty=function(){return"_semanticFormValue";};
o.prototype.updateFormValueProperty=function(){this.setProperty("_semanticFormValue",this.getFormFormattedValue(),true);};
return o;});
sap.ui.predefine('sap/m/MultiInputRenderer',['./InputRenderer','sap/ui/core/Renderer',"sap/ui/core/Core"],function(I,R,C){"use strict";var M=R.extend(I);M.apiVersion=2;
M.prependInnerContent=function(r,c){r.renderControl(c.getAggregation("tokenizer"));};
M.addOuterClasses=function(r,c){I.addOuterClasses.apply(this,arguments);r.class("sapMMultiInput");if(c.getTokens().length>0){r.class("sapMMultiInputHasTokens");}};
M.getAriaDescribedBy=function(c){var a=I.getAriaDescribedBy.apply(this,arguments),i=c.getAggregation("tokenizer")&&c.getAggregation("tokenizer").getTokensInfoId();if(a){a=a+" "+i;}else{a=i;}return a;};
M.getAccessibilityState=function(c){var a=I.getAccessibilityState.apply(this,arguments),r=C.getLibraryResourceBundle("sap.m");a.roledescription=r.getText("MULTIINPUT_ARIA_ROLE_DESCRIPTION");return a;};
return M;},true);
sap.ui.predefine('sap/m/NavContainer',['./library','sap/ui/core/Control','sap/ui/core/RenderManager','sap/ui/Device','./NavContainerRenderer',"sap/ui/thirdparty/jquery","sap/base/Log","sap/ui/dom/jquery/Focusable"],function(a,C,R,D,N,q,L){"use strict";
var b=C.extend("sap.m.NavContainer",{metadata:{interfaces:["sap.ui.core.IPlaceholderSupport"],library:"sap.m",properties:{autoFocus:{type:"boolean",group:"Behavior",defaultValue:true},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},visible:{type:"boolean",group:"Appearance",defaultValue:true},defaultTransitionName:{type:"string",group:"Appearance",defaultValue:"slide"}},defaultAggregation:"pages",aggregations:{pages:{type:"sap.ui.core.Control",multiple:true,singularName:"page"}},associations:{initialPage:{type:"sap.ui.core.Control",multiple:false}},events:{navigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}}}}});
var p={"onAfterRendering":function(){if(this._placeholder){this._placeholder.show(this);}}};var u=sap.ui.getCore().getConfiguration().getAnimation(),g=function(d){return u?d:0;},h=function(c){return!!(c&&c.getParent());},s=function(P,d){if(h(P)){P.$().css({'-webkit-animation-direction':d,'animation-direction':d});}};b.TransitionDirection={BACK:"back",TO:"to"};
b.prototype.init=function(){this._pageStack=[];this._aQueue=[];this._mVisitedPages={};this._mFocusObject={};this._iTransitionsCompleted=0;this._bNeverRendered=true;this._bNavigating=false;this._bRenderingInProgress=false;};
b.prototype.exit=function(){this._mFocusObject=null;this._placeholder=undefined;};
b.prototype.onBeforeRendering=function(){var c=this.getCurrentPage();if(this._bNeverRendered&&c){var d=c.getId();if(!this._mVisitedPages[d]){this._mVisitedPages[d]=true;var n={from:null,fromId:null,to:c,toId:d,firstTime:true,isTo:false,isBack:false,isBackToPage:false,isBackToTop:false,direction:"initial"};var e=q.Event("BeforeFirstShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};c._handleEvent(e);e=q.Event("BeforeShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};c._handleEvent(e);}}};
b.prototype.onAfterRendering=function(){var c=this.getCurrentPage(),f,n,d,e;if(this._bNeverRendered&&c){this._bNeverRendered=false;delete this._bNeverRendered;d=c.getId();if(!this._isInsideAPopup()&&this.getAutoFocus()){f=b._applyAutoFocusTo(d);if(f){this._mFocusObject[d]=f;}}n={from:null,fromId:null,to:c,toId:d,firstTime:true,isTo:false,isBack:false,isBackToTop:false,isBackToPage:false,direction:"initial"};e=q.Event("AfterShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};c._handleEvent(e);}};
b.prototype._getActualInitialPage=function(){var c=this.getInitialPage();if(c){var d=sap.ui.getCore().byId(c);if(d){return d;}else{L.error("NavContainer: control with ID '"+c+"' was set as 'initialPage' but was not found as a DIRECT child of this NavContainer (number of current children: "+this.getPages().length+").");}}var e=this.getPages();return(e.length>0?e[0]:null);};
b.prototype.getPage=function(c){var P=this.getPages();for(var i=0;i<P.length;i++){if(P[i]&&(P[i].getId()==c)){return P[i];}}return null;};
b.prototype._ensurePageStackInitialized=function(d){if(this._pageStack.length===0){var c=this._getActualInitialPage();if(c){this._pageStack.push({id:c.getId(),isInitial:true,data:d||{}});}}return this._pageStack;};
b.prototype.getCurrentPage=function(){var c=this._ensurePageStackInitialized();if(c.length>=1){return this.getPage(c[c.length-1].id);}else{L.warning(this+": page stack is empty but should have been initialized - application failed to provide a page to display");return undefined;}};
b.prototype.getPreviousPage=function(){var c=this._ensurePageStackInitialized();if(c.length>1){return this.getPage(c[c.length-2].id);}else if(c.length==1){return undefined;}else{L.warning(this+": page stack is empty but should have been initialized - application failed to provide a page to display");}};
b.prototype.currentPageIsTopPage=function(){var c=this._ensurePageStackInitialized();return(c.length===1);};
b.prototype.insertPreviousPage=function(c,t,d){var e=this._ensurePageStackInitialized();if(this._pageStack.length>0){var i=e.length-1;var f={id:c,transition:t,data:d};if(i===0){f.isInitial=true;delete e[e.length-1].isInitial;}e.splice(i,0,f);}else{L.warning(this+": insertPreviousPage called with empty page stack; ignoring");}return this;};
b._applyAutoFocusTo=function(i){var f=q(document.getElementById(i)).firstFocusableDomRef();if(f){f.focus();}return f;};
b.prototype._applyAutoFocus=function(n){var P=n.toId,d,c=n.isBack||n.isBackToPage||n.isBackToTop;if(!n.bFocusInsideFromPage){return;}if(c){d=this._mFocusObject!=null?this._mFocusObject[P]:null;if(d){d.focus();}else{b._applyAutoFocusTo(P);}}else if(n.isTo){b._applyAutoFocusTo(P);}};
b.prototype._afterNavigation=function(n,d,B){var e=q.Event("AfterShow",n);e.data=d||{};e.backData=B||{};e.srcControl=this;n.to._handleEvent(e);e=q.Event("AfterHide",n);e.srcControl=this;n.from._handleEvent(e);if(this.getAutoFocus()){this._applyAutoFocus(n);}this.fireAfterNavigate(n);this._dequeueNavigation();};
b.prototype._afterTransitionCallback=function(n,d,B){this._iTransitionsCompleted++;this._bNavigating=false;this._afterNavigation(n,d,B);L.info(this+": _afterTransitionCallback called, to: "+n.toId);if(n.to.hasStyleClass("sapMNavItemHidden")){L.warning(this.toString()+": target page '"+n.toId+"' still has CSS class 'sapMNavItemHidden' after transition. This should not be the case, please check the preceding log statements.");n.to.removeStyleClass("sapMNavItemHidden");}};
b.prototype._dequeueNavigation=function(){var n=this._aQueue.shift();if(typeof n==="function"){n();}};
b.prototype._isInPageStack=function(c){return this._pageStack.some(function(P){return P.id===c;});};
b.prototype._safeBackToPage=function(c,t,d,T){var o;if(!this.getPage(c)){return this;}o=this.getCurrentPage();if(o&&o.getId()===c){return this;}if(this._isInPageStack(c)){return this.backToPage(c,d,T);}else{d=d||{};d.safeBackToPage=true;return this.to(c,t,d,T);}};
b.prototype._isFocusInControl=function(c){return q(document.activeElement).closest(c.$()).length>0;};
b.prototype.to=function(c,t,d,T,f){if(c instanceof C){c=c.getId();}if(typeof(t)!=="string"){T=d;d=t;}t=t||this.getDefaultTransitionName();T=T||{};d=d||{};var F={id:c,transition:t,data:d};this._ensurePageStackInitialized(d);if(this._bNavigating){L.info(this.toString()+": Cannot navigate to page "+c+" because another navigation is already in progress. - navigation will be executed after the previous one");this._aQueue.push(q.proxy(function(){this.to(c,t,d,T,true);},this));return this;}if(this._bNeverRendered){this._oToDataBeforeRendering=d;}var o=this.getCurrentPage();if(o&&(o.getId()===c)){L.warning(this.toString()+": Cannot navigate to page "+c+" because this is the current page.");if(f){this._dequeueNavigation();}if(this._pageStack.length===1){this._pageStack[0].transition=F.transition;}return this;}var e=this.getPage(c);if(e){if(!o){L.warning("Navigation triggered to page with ID '"+c+"', but the current page is not known/aggregated by "+this);return this;}var n={from:o,fromId:o.getId(),to:e,toId:c,firstTime:!this._mVisitedPages[c],isTo:true,isBack:false,isBackToTop:false,isBackToPage:false,direction:"to",bFocusInsideFromPage:this._isFocusInControl(o)};if(n.bFocusInsideFromPage){this._mFocusObject[o.getId()]=document.activeElement;}var i=this.fireNavigate(n);if(i){a.closeKeyboard();var E=q.Event("BeforeHide",n);E.srcControl=this;o._handleEvent(E);if(!this._mVisitedPages[c]){E=q.Event("BeforeFirstShow",n);E.srcControl=this;E.data=d||{};E.backData={};e._handleEvent(E);}E=q.Event("BeforeShow",n);E.srcControl=this;E.data=d||{};E.backData={};e._handleEvent(E);this._pageStack.push(F);L.info(this.toString()+": navigating to page '"+c+"': "+e.toString());this._mVisitedPages[c]=true;if(!this.getDomRef()){L.info("'Hidden' 'to' navigation in not-rendered NavContainer "+this.toString());if(this._bRenderingInProgress){setTimeout(this.invalidate.bind(this),0);}return this;}var j;if(!(j=e.getDomRef())||j.parentNode!=this.getDomRef()||R.isPreservedContent(j)){e.addStyleClass("sapMNavItemRendering");L.debug("Rendering 'to' page '"+e.toString()+"' for 'to' navigation");var r=sap.ui.getCore().createRenderManager();r.render(e,this.getDomRef());r.destroy();e.addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemRendering");}var k=b.transitions[t]||b.transitions["slide"];var l=this._iTransitionsCompleted;var m=this;window.setTimeout(function(){if(m&&(m._iTransitionsCompleted<l+1)){L.warning("Transition '"+t+"' 'to' was triggered five seconds ago, but has not yet invoked the end-of-transition callback.");}},g(5000));this._bNavigating=true;var v=(d.safeBackToPage||T.safeBackToPage)?"back":"to";this._cacheTransitionInfo(t,v);k[v].call(this,o,e,q.proxy(function(){this._afterTransitionCallback(n,d);},this),T);}else{L.info("Navigation to page with ID '"+c+"' has been aborted by the application");}}else{L.warning("Navigation triggered to page with ID '"+c+"', but this page is not known/aggregated by "+this);}return this;};
b.prototype.back=function(c,t){this._backTo("back",c,t);return this;};
b.prototype.backToPage=function(c,d,t){this._backTo("backToPage",d,t,c);return this;};
b.prototype.backToTop=function(c,t){this._backTo("backToTop",c,t);return this;};
b.prototype._backTo=function(t,c,T,r){if(this._bNavigating){L.warning(this.toString()+": Cannot navigate back because another navigation is already in progress. - navigation will be executed after the previous one");this._aQueue.push(q.proxy(function(){this._backTo(t,c,T,r);},this));return this;}if(this._pageStack.length<=1){if(this._pageStack.length===1&&!this._pageStack[0].isInitial){throw new Error("Initial page not found on the stack. How did this happen?");}this._aQueue=[];return this;}else{if(r instanceof C){r=r.getId();}var f=this._pageStack[this._pageStack.length-1];var d=f.transition;var F=this.getPage(f.id);var o;var e;if(t==="backToTop"){o=this._getActualInitialPage();e=null;}else if(t==="backToPage"){var i=this._findClosestPreviousPageInfo(r);if(!i){L.error(this.toString()+": Cannot navigate backToPage('"+r+"') because target page was not found among the previous pages.");return this;}o=sap.ui.getCore().byId(i.id);if(!o){L.error(this.toString()+": Cannot navigate backToPage('"+r+"') because target page does not exist anymore.");return this;}e=i.data;}else{o=this.getPreviousPage();e=this._pageStack[this._pageStack.length-2].data;}if(!o){L.error("NavContainer back navigation: target page is not defined or not aggregated by this NavContainer. Aborting navigation.");return;}var j=o.getId();c=c||{};T=T||{};var n={from:F,fromId:F.getId(),to:o,toId:j,firstTime:!this._mVisitedPages[j],isTo:false,isBack:(t==="back"),isBackToPage:(t==="backToPage"),isBackToTop:(t==="backToTop"),direction:t,bFocusInsideFromPage:this._isFocusInControl(F)};var k=this.fireNavigate(n);if(k){a.closeKeyboard();var E=q.Event("BeforeHide",n);E.srcControl=this;F._handleEvent(E);if(!this._mVisitedPages[j]){E=q.Event("BeforeFirstShow",n);E.srcControl=this;E.backData=c||{};E.data={};o._handleEvent(E);}E=q.Event("BeforeShow",n);E.srcControl=this;E.backData=c||{};E.data=e||{};o._handleEvent(E);this._pageStack.pop();L.info(this.toString()+": navigating back to page "+o.toString());this._mVisitedPages[j]=true;if(t==="backToTop"){this._pageStack=[];L.info(this.toString()+": navigating back to top");this.getCurrentPage();}else if(t==="backToPage"){var P=[],l;while(this._pageStack[this._pageStack.length-1].id!==r){l=this._pageStack.pop();P.push(l.id);}L.info(this.toString()+": navigating back to specific page "+o.toString()+" across the pages: "+P.join(", "));}if(!this.getDomRef()){L.info("'Hidden' back navigation in not-rendered NavContainer "+this.toString());this._afterNavigation(n,e,c);return this;}var m=b.transitions[d]||b.transitions["slide"];var v=this._iTransitionsCompleted;var w=this;window.setTimeout(function(){if(w&&(w._iTransitionsCompleted<v+1)){L.warning("Transition '"+d+"' 'back' was triggered five seconds ago, but has not yet invoked the end-of-transition callback.");}},g(5000));this._bNavigating=true;var x;if(!(x=o.getDomRef())||x.parentNode!=this.getDomRef()||R.isPreservedContent(x)){o.addStyleClass("sapMNavItemRendering");L.debug("Rendering 'to' page '"+o.toString()+"' for back navigation");var y=sap.ui.getCore().createRenderManager();var z=this.$().children().index(F.getDomRef());y.renderControl(o);y.flush(this.getDomRef(),false,z);y.destroy();o.addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemRendering");}if(F.getId()===o.getId()){L.info("Transition is skipped when navigating back to the same page instance"+o.toString());this._afterTransitionCallback(n,e,c);return this;}this._cacheTransitionInfo(d,b.TransitionDirection.BACK);m.back.call(this,F,o,q.proxy(function(){this._afterTransitionCallback(n,e,c);},this),T);}}return this;};
b.prototype._findClosestPreviousPageInfo=function(r){for(var i=this._pageStack.length-2;i>=0;i--){var c=this._pageStack[i];if(c.id===r){return c;}}return null;};
b.prototype._cacheTransitionInfo=function(t,T){this._sTransitionName=t;this._sTransitionDirection=T;};
b.prototype._fadeTransition=function(f,t,c){this.oFromPage=f;this.oToPage=t;this.fCallback=c;this._fadeOutAnimation();};
b.prototype._fadeOutAnimation=function(){var t=this,f=this.oFromPage,T=this.oToPage;T.addStyleClass("sapMNavItemTransparent");if(this._sTransitionName==="slide"){if(this._sTransitionDirection===b.TransitionDirection.TO){T.addStyleClass("sapMNavItemSlideLeft");f.addStyleClass("sapMNavItemSlideRight");}else{T.addStyleClass("sapMNavItemSlideRight");f.addStyleClass("sapMNavItemSlideLeft");}}T.removeStyleClass("sapMNavItemHidden");f.addStyleClass("sapMNavItemOpaque");window.setTimeout(function(){f.$().on("webkitTransitionEnd transitionend",t._fadeOutAnimationEnd.bind(t));t.bTransition1EndPending=true;f.addStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemOpaque").addStyleClass("sapMNavItemTransparent");window.setTimeout(function(){if(t.bTransition1EndPending){t._fadeOutAnimationEnd();}},g(150));},g(10));};
b.prototype._fadeOutAnimationEnd=function(e){var f=this.oFromPage;if(e&&e.originalEvent&&e.originalEvent.propertyName!=="opacity"){return;}this.bTransition1EndPending=false;q(f.$()).off("webkitTransitionEnd transitionend");f.removeStyleClass("sapMNavItemSlideLeft").removeStyleClass("sapMNavItemSlideRight");this._fadeInAnimation();};
b.prototype._fadeInAnimation=function(){var t=this,T=this.oToPage;window.setTimeout(function(){T.$().on("webkitTransitionEnd transitionend",t._fadeInAnimationEnd.bind(t));t.bTransition2EndPending=true;T.addStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemTransparent").addStyleClass("sapMNavItemOpaque");window.setTimeout(function(){if(t.bTransition2EndPending){t._fadeInAnimationEnd();}},g(150));},g(10));};
b.prototype._fadeInAnimationEnd=function(e){var t=this.oToPage,f=this.oFromPage;if(e&&e.originalEvent&&e.originalEvent.propertyName!=="opacity"){return;}this.bTransition2EndPending=false;if(h(f)){f.addStyleClass("sapMNavItemHidden");f.removeStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemTransparent");}q(t.$()).off("webkitTransitionEnd transitionend");if(h(t)){t.removeStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemOpaque").removeStyleClass("sapMNavItemSlideLeft").removeStyleClass("sapMNavItemSlideRight");}this.fCallback();};
b.prototype._baseSlideAnimation=function(f,t,c){var F=false,T=true,i=this._sTransitionDirection===b.TransitionDirection.BACK,A=i?"reverse":"normal",d=i?"sapMNavItemSlideCenterToLeft":"sapMNavItemSlideRightToCenter",e=!i?"sapMNavItemSlideCenterToLeft":"sapMNavItemSlideRightToCenter",j=function(){q(this).off("webkitAnimationEnd animationend");if(!F){F=true;return F;}T=false;s(t,"");s(f,"");if(h(t)){t.removeStyleClass(d);}if(h(f)){f.removeStyleClass(e).addStyleClass("sapMNavItemHidden");}c();};f.$().on("webkitAnimationEnd animationend",j);t.$().on("webkitAnimationEnd animationend",j);s(t,A);s(f,A);f.addStyleClass(e);t.addStyleClass(d).removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){if(T){F=true;j.apply(f.$().add(t.$()));}},g(400));};
b.transitions=b.transitions||{};b.transitions["show"]={to:function(f,t,c){t.removeStyleClass("sapMNavItemHidden");f&&f.addStyleClass("sapMNavItemHidden");c();},back:function(f,t,c){t.removeStyleClass("sapMNavItemHidden");f&&f.addStyleClass("sapMNavItemHidden");c();}};b.transitions["baseSlide"]={to:b.prototype._baseSlideAnimation,back:b.prototype._baseSlideAnimation};b.transitions["slide"]={to:b.prototype._fadeTransition,back:b.prototype._fadeTransition};b.transitions["fade"]={to:b.prototype._fadeTransition,back:b.prototype._fadeTransition};b.transitions["flip"]={to:function(f,t,c){var d=this;window.setTimeout(function(){d.$().addClass("sapMNavFlip");t.addStyleClass("sapMNavItemFlipNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).off("webkitTransitionEnd transitionend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemFlipping");}if(h(f)){f.removeStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemFlipPrevious");}d.$().removeClass("sapMNavFlip");c();}};f.$().on("webkitTransitionEnd transitionend",A);t.$().on("webkitTransitionEnd transitionend",A);t.addStyleClass("sapMNavItemFlipping").removeStyleClass("sapMNavItemFlipNext");f.addStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemFlipPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(600));},g(60));},0);},back:function(f,t,c){var d=this;d.$().addClass("sapMNavFlip");t.addStyleClass("sapMNavItemFlipPrevious");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).off("webkitTransitionEnd transitionend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemFlipping");}if(h(f)){f.removeStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemFlipNext");}d.$().removeClass("sapMNavFlip");c();}};f.$().on("webkitTransitionEnd transitionend",A);t.$().on("webkitTransitionEnd transitionend",A);t.addStyleClass("sapMNavItemFlipping").removeStyleClass("sapMNavItemFlipPrevious");f.addStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemFlipNext");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(600));},g(60));}};b.transitions["door"]={to:function(f,t,c){var d=this;window.setTimeout(function(){d.$().addClass("sapMNavDoor");t.addStyleClass("sapMNavItemDoorInNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).off("webkitAnimationEnd animationend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemDooring").removeStyleClass("sapMNavItemDoorInNext");}if(h(f)){f.removeStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemDoorInPrevious");}d.$().removeClass("sapMNavDoor");c();}};f.$().on("webkitAnimationEnd animationend",A);t.$().on("webkitAnimationEnd animationend",A);t.addStyleClass("sapMNavItemDooring");f.addStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemDoorInPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(1000));},g(60));},0);},back:function(f,t,c){var d=this;d.$().addClass("sapMNavDoor");t.addStyleClass("sapMNavItemDoorOutNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).off("webkitAnimationEnd animationend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemDooring").removeStyleClass("sapMNavItemDoorOutNext");}if(h(f)){f.removeStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemDoorOutPrevious");}d.$().removeClass("sapMNavDoor");c();}};f.$().on("webkitAnimationEnd animationend",A);t.$().on("webkitAnimationEnd animationend",A);t.addStyleClass("sapMNavItemDooring");f.addStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemDoorOutPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(1000));},g(60));}};
b.prototype.addCustomTransition=function(n,t,B){if(b.transitions[n]){L.warning("Transition with name "+n+" already exists in "+this+". It is now being replaced by custom transition.");}b.transitions[n]={to:t,back:B};return this;};
b.addCustomTransition=b.prototype.addCustomTransition;
b.prototype.invalidate=function(S){if(S==this){}else if(S instanceof C){var I=false,P=this.getPages(),l=P.length;for(var i=0;i<l;i++){if(P[i]===S){I=true;break;}}if((!I||S===this.getCurrentPage())&&!this._isInsideAPopup()){C.prototype.invalidate.call(this,S);}}else{C.prototype.invalidate.call(this,S);}};
b.prototype._isInsideAPopup=function(){var S;S=function(c){if(!c){return false;}if(c.getMetadata().isInstanceOf("sap.ui.core.PopupInterface")){return true;}return S(c.getParent());};return S(this);};
b.prototype.removePage=function(P){var o;if(typeof(P)=="number"){o=this.getPages()[P];}else if(typeof(P)=="string"){o=sap.ui.getCore().byId(P);}else{o=P;}o=this.removeAggregation("pages",o,o!==this.getCurrentPage());this._onPageRemoved(o);return o;};
b.prototype._onPageRemoved=function(P){if(!P){return;}P.$().remove();P.removeStyleClass("sapMNavItemHidden");P.removeStyleClass("sapMNavItem");var S=this._ensurePageStackInitialized();this._pageStack=S.filter(function(o){return P.getId()!==o.id;});};
b.prototype.removeAllPages=function(){var P=this.removeAllAggregation("pages");for(var i=0;i<P.length;i++){this._onPageRemoved(P[i]);}return P;};
b.prototype.addPage=function(P){var c=this.getPages();if(c.indexOf(P)>-1){return this;}this.addAggregation("pages",P,true);P.addStyleClass("sapMNavItem");var i=c.length;if(i===0&&this.getPages().length===1){this._fireAdaptableContentChange(P);if(this.getDomRef()){this._ensurePageStackInitialized();this.rerender();}}return this;};
b.prototype.insertPage=function(P,i){var c=this.getPages().length;this.insertAggregation("pages",P,i,true);P.addStyleClass("sapMNavItem");if(c===0&&this.getPages().length===1){this._fireAdaptableContentChange(P);if(this.getDomRef()){this._ensurePageStackInitialized();this.rerender();}}return this;};
b.prototype.showPlaceholder=function(S){var c;if(!sap.ui.getCore().getConfiguration().getPlaceholder()){return;}if(this._placeholder){this.hidePlaceholder();}if(S&&S.placeholder){this._placeholder=S.placeholder;c=this._placeholder._load();}else{c=Promise.resolve();}if(this.getDomRef()&&this._placeholder){this._placeholder.show(this);}this.addEventDelegate(p,this);return c;};
b.prototype.hidePlaceholder=function(){if(this._placeholder){this._placeholder.hide();this.removeEventDelegate(p);}};
b.prototype.needPlaceholder=function(A,o){return!o||(this.getCurrentPage()!==o);};
b.prototype._getAdaptableContent=function(){return this.getCurrentPage();};
b.prototype._fireAdaptableContentChange=function(P){if(P&&this.mEventRegistry["_adaptableContentChange"]){this.fireEvent("_adaptableContentChange",{"parent":this,"adaptableContent":P});}};
return b;});
sap.ui.predefine('sap/m/NavContainerRenderer',["sap/ui/core/InvisibleRenderer"],function(I){"use strict";var N={apiVersion:2};
N.render=function(r,c){c._bRenderingInProgress=true;if(!c.getVisible()){I.render(r,c,"div");return false;}var h=c.getHeight(),t=c.getTooltip_AsString(),C=c.getCurrentPage();r.openStart("div",c);r.class("sapMNav");r.style("width",c.getWidth());if(h&&h!="100%"){r.style("height",h);}if(this.renderAttributes){this.renderAttributes(r,c);}if(t){r.attr("title",t);}r.openEnd();if(this.renderBeforeContent){this.renderBeforeContent(r,c);}c.getPages().forEach(function(p){if(p===C){C.removeStyleClass("sapMNavItemHidden");r.renderControl(C);}else{r.cleanupControlWithoutRendering(p);}});r.close("div");c._bRenderingInProgress=false;};
return N;},true);
sap.ui.predefine('sap/m/NewsContent',['./library','sap/ui/core/Control','sap/m/Text','sap/m/FormattedText','sap/ui/Device','./NewsContentRenderer',"sap/ui/events/KeyCodes"],function(l,C,T,F,D,N,K){"use strict";
var a=C.extend("sap.m.NewsContent",{metadata:{library:"sap.m",designtime:"sap/m/designtime/NewsContent.designtime",properties:{"size":{type:"sap.m.Size",group:"Misc",defaultValue:"Auto",deprecated:true},"contentText":{type:"string",group:"Misc",defaultValue:null},"subheader":{type:"string",group:"Misc",defaultValue:null}},defaultAggregation:"_contentText",aggregations:{"_contentText":{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"},"_subHeaderText":{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"}},events:{"press":{}}}});
a.prototype.init=function(){this._oContentText=new F(this.getId()+"-content-text");this._oSubHeaderText=new F(this.getId()+"-subheader-text");this.setAggregation("_contentText",this._oContentText,true);this.setAggregation("_subHeaderText",this._oSubHeaderText,true);this.setTooltip("{AltText}");};
a.prototype.onBeforeRendering=function(){this._setPointerOnContentText();this.$().off("mouseenter");this.$().off("mouseleave");};
a.prototype.onAfterRendering=function(){this.$().on("mouseenter",this._addTooltip.bind(this));this.$().on("mouseleave",this._removeTooltip.bind(this));};
a.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
a.prototype._removeTooltip=function(){this.$().attr("title",null);};
a.prototype._setPointerOnContentText=function(){var t=this.getAggregation("_contentText");if(t&&this.hasListeners("press")){t.addStyleClass("sapMPointer");}else if(t&&t.hasStyleClass("sapMPointer")){t.removeStyleClass("sapMPointer");}};
a.prototype.getAltText=function(){var A="";var i=true;if(this.getContentText()){A+=this.getContentText();i=false;}if(this.getSubheader()){if(i){A+=""+this.getSubheader();}else{A+="\n"+this.getSubheader();}}return A;};
a.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var s=this.getAltText();if(typeof t==="string"||t instanceof String){s=t.split("{AltText}").join(s).split("((AltText))").join(s);return s;}if(t){return t;}else{return"";}};
a.prototype.setContentText=function(t){this._oContentText.setHtmlText(t);return this.setProperty("contentText",t,true);};
a.prototype.setSubheader=function(t){this._oSubHeaderText.setHtmlText(t);return this.setProperty("subheader",t,true);};
a.prototype.ontap=function(e){if(D.browser.msie){this.$().trigger("focus");}this.firePress();};
a.prototype.onkeydown=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
a.prototype.attachEvent=function(e,d,f,b){C.prototype.attachEvent.call(this,e,d,f,b);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnContentText();}return this;};
a.prototype.detachEvent=function(e,f,b){C.prototype.detachEvent.call(this,e,f,b);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnContentText();}return this;};
return a;});
sap.ui.predefine('sap/m/NewsContentRenderer',[],function(){"use strict";var N={apiVersion:2};
N.render=function(r,c){var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}r.openStart("div",c);r.attr("role","presentation");r.attr("aria-label",t);r.class("sapMNwC");if(c.hasListeners("press")){r.class("sapMPointer");r.attr("tabindex","0");}r.openEnd();r.openStart("div");r.class("sapMNwCCTxt");r.openEnd();r.renderControl(c._oContentText);r.close("div");r.openStart("div",c.getId()+"-subheader");r.class("sapMNwCSbh");r.openEnd();r.renderControl(c._oSubHeaderText);r.close("div");r.close("div");};
return N;},true);
sap.ui.predefine('sap/m/NotificationList',["./ListBase","./NotificationListRenderer"],function(L,N){'use strict';
var a=L.extend('sap.m.NotificationList',{metadata:{library:'sap.m'}});
a.prototype.onItemFocusIn=function(){};
return a;});
sap.ui.predefine('sap/m/NotificationListBase',['./library','sap/ui/core/Core','sap/ui/core/Element','sap/ui/Device','./ListItemBase','./Button','./ToolbarSeparator','sap/m/OverflowToolbar','sap/m/OverflowToolbarLayoutData','sap/ui/core/IconPool','sap/ui/core/Icon','sap/ui/core/library'],function(l,C,E,D,L,B,T,O,a,I,b,c){'use strict';var P=c.Priority;var d=l.ButtonType;var e=l.OverflowToolbarPriority;var r=C.getLibraryResourceBundle('sap.m'),f=r.getText('NOTIFICATION_LIST_ITEM_CLOSE'),g=r.getText('NOTIFICATION_LIST_GROUP_CLOSE');
var N=L.extend('sap.m.NotificationListBase',{
metadata:{library:'sap.m',"abstract":true,properties:{priority:{type:'sap.ui.core.Priority',group:'Appearance',defaultValue:P.None},title:{type:'string',group:'Appearance',defaultValue:''},datetime:{type:'string',group:'Appearance',defaultValue:''},showButtons:{type:'boolean',group:'Behavior',defaultValue:true},showCloseButton:{type:'boolean',group:'Behavior',defaultValue:true},authorName:{type:'string',group:'Appearance',defaultValue:''},authorPicture:{type:'sap.ui.core.URI'}},aggregations:{buttons:{type:'sap.m.Button',multiple:true},_closeButton:{type:'sap.m.Button',multiple:false,visibility:"hidden"},_overflowToolbar:{type:'sap.m.OverflowToolbar',multiple:false,visibility:"hidden"},_priorityIcon:{type:'sap.ui.core.Icon',multiple:false,visibility:"hidden"}},events:{close:{}}},
renderer:null
});
N.prototype._activeHandling=function(){};
N.prototype.updateSelectedDOM=function(){};
N.prototype.getAccessibilityText=function(){return'';};
N.prototype.getButtons=function(){var h=this._getCloseButton(),t=this._getToolbarSeparator();return this._getOverflowToolbar().getContent().filter(function(i){return i!==h&&i!==t;},this);};
N.prototype.addButton=function(o){var h=this._getOverflowToolbar(),i=h.getContent().length;if(D.system.phone){i-=2;}h.insertContent(o,i);this.invalidate();return this;};
N.prototype.insertButton=function(o,i){this._getOverflowToolbar().insertContent(o,i);this.invalidate();return this;};
N.prototype.removeButton=function(o){var h=this._getOverflowToolbar().removeContent(o.getId());this.invalidate();return h;};
N.prototype.removeAllButtons=function(){var o=this._getOverflowToolbar(),h=this.getButtons();h.forEach(function(i){o.removeContent(i.getId());});this.invalidate();return this;};
N.prototype.destroyButtons=function(){var h=this.getButtons();h.forEach(function(i){i.destroy();});this.invalidate();return this;};
N.prototype.clone=function(){var h=L.prototype.clone.apply(this,arguments);h.destroyAggregation('_overflowToolbar');var o=this.getAggregation('_overflowToolbar');if(o){h.setAggregation("_overflowToolbar",o.clone(),true);}return h;};
N.prototype._getOverflowToolbar=function(){var o=this.getAggregation('_overflowToolbar'),t,h;if(!o){o=new O(this.getId()+'-overflowToolbar',{});this.setAggregation("_overflowToolbar",o,true);if(D.system.phone){h=this._getCloseButton();h.setLayoutData(new a({priority:e.AlwaysOverflow}));t=new T();t.setLayoutData(new a({priority:e.AlwaysOverflow}));o.addContent(t);o.addContent(h);}}return o;};
N.prototype._getCloseButton=function(){var h,o,i,j;if(D.system.phone){o=this._getOverflowToolbar();i=o.getContent();if(o&&i.length){j=i.length-1;h=i[j];}}else{h=this.getAggregation("_closeButton");}if(!h){if(D.system.phone){h=new B(this.getId()+'-closeButtonOverflow',{text:this.isA("sap.m.NotificationListItem")?f:g,type:d.Default,press:function(){this.close();}.bind(this)});}else{h=new B(this.getId()+'-closeButtonX',{icon:I.getIconURI('decline'),type:d.Transparent,tooltip:this.isA("sap.m.NotificationListItem")?f:g,press:function(){this.close();}.bind(this)});this.setAggregation("_closeButton",h);}}return h;};
N.prototype._getToolbarSeparator=function(){if(!D.system.phone){return null;}var t,o=this._getOverflowToolbar(),h=o.getContent(),i;if(o&&h.length){i=h.length-2;t=h[i];}return t;};
N.prototype.exit=function(){};
N.prototype._hasActionButtons=function(){return this.getShowButtons()&&this.getButtons().length;};
N.prototype._shouldRenderCloseButton=function(){return!D.system.phone&&this.getShowCloseButton();};
N.prototype._shouldRenderOverflowToolbar=function(){var h=this._hasActionButtons();if(D.system.phone){return h||this.getShowCloseButton();}return h;};
N.prototype.onBeforeRendering=function(){var h=this.getButtons(),j,k;if(D.system.phone){this._updatePhoneButtons();return;}j=h.length>1?e.AlwaysOverflow:e.NeverOverflow;for(var i=0;i<h.length;i++){k=h[i];k.setLayoutData(new a({priority:i===0?j:e.AlwaysOverflow}));}};
N.prototype._updatePhoneButtons=function(){var h=this._getCloseButton(),i=this.isA("sap.m.NotificationListGroup"),j=i?g:f,k=i&&this.getCollapsed(),m=!k&&this._hasActionButtons(),s=this.getShowCloseButton(),t=this._getToolbarSeparator(),p;this.getButtons().forEach(function(n){if(m){p=e.AlwaysOverflow;n.removeStyleClass('sapMNLIBHiddenButton');}else{p=e.NeverOverflow;n.addStyleClass('sapMNLIBHiddenButton');}n.setLayoutData(new a({priority:p}));});if(!s){h.setVisible(false);t.setVisible(false);return;}h.setVisible(true);if(m){h.setText(j);h.setTooltip('');h.setType(d.Default);h.setIcon('');h.setLayoutData(new a({priority:e.AlwaysOverflow}));t.setVisible(true);}else{h.setText('');h.setTooltip(j);h.setType(d.Transparent);h.setIcon(I.getIconURI('decline'));h.setLayoutData(new a({priority:e.NeverOverflow}));t.setVisible(false);}};
N.prototype.close=function(){var p=this.getParent();this.fireClose();var h=!!this.getParent();if(!h&&p&&p instanceof E){var i={onAfterRendering:function(){p.focus();p.removeEventDelegate(i);}};p.addEventDelegate(i);}};
N.prototype._getPriorityIcon=function(){var p=this.getAggregation('_priorityIcon');if(!p){p=new b({src:'sap-icon://message-error',useIconTooltip:false});this.setAggregation("_priorityIcon",p,true);}return p;};
return N;});
sap.ui.predefine('sap/m/NotificationListGroup',['./library','sap/ui/core/Core','./NotificationListBase','sap/ui/core/InvisibleText','./ListItemBase','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','sap/m/Button','./NotificationListGroupRenderer',"sap/ui/events/KeyCodes"],function(l,C,N,I,L,a,c,D,B,b,K){'use strict';var P=c.Priority;var d=l.ButtonType;var R=C.getLibraryResourceBundle('sap.m'),E=R.getText('NOTIFICATION_LIST_GROUP_EXPAND'),e=R.getText('NOTIFICATION_LIST_GROUP_COLLAPSE'),f=R.getText('NOTIFICATION_LIST_GROUP_READ'),U=R.getText('NOTIFICATION_LIST_GROUP_UNREAD'),g='sap-icon://slim-arrow-right',h='sap-icon://slim-arrow-down';var m=D.system.desktop?400:100;
var i=N.extend('sap.m.NotificationListGroup',{metadata:{library:'sap.m',properties:{collapsed:{type:'boolean',group:'Behavior',defaultValue:false},autoPriority:{type:'boolean',group:'Behavior',defaultValue:true},showEmptyGroup:{type:'boolean',group:'Behavior',defaultValue:false},enableCollapseButtonWhenEmpty:{type:'boolean',group:'Behavior',defaultValue:false},showItemsCounter:{type:'boolean',group:'Behavior',defaultValue:true},authorName:{type:'string',group:'Appearance',defaultValue:'',deprecated:true},authorPicture:{type:'sap.ui.core.URI',multiple:false,deprecated:true},datetime:{type:'string',group:'Appearance',defaultValue:'',deprecated:true}},defaultAggregation:'items',aggregations:{items:{type:'sap.m.NotificationListItem',multiple:true,singularName:'item'},_collapseButton:{type:'sap.m.Button',multiple:false,visibility:"hidden"}},events:{onCollapse:{parameters:{collapsed:{type:'boolean'}}}}}});
i.prototype._getCollapseButton=function(){var k=this.getAggregation('_collapseButton'),n=this.getCollapsed();if(!k){k=new B(this.getId()+'-collapseButton',{type:d.Transparent,press:function(){var o=!this.getCollapsed();this.setCollapsed(o);this.fireOnCollapse({collapsed:o});this.getAggregation("_collapseButton").focus();}.bind(this)});this.setAggregation("_collapseButton",k,true);}k.setIcon(n?g:h);k.setTooltip(n?E:e);return k;};
i.prototype.init=function(){this._groupTitleInvisibleText=new I({id:this.getId()+"-invisibleGroupTitleText"});};
i.prototype.exit=function(){N.prototype.exit.apply(this,arguments);if(this._groupTitleInvisibleText){this._groupTitleInvisibleText.destroy();this._groupTitleInvisibleText=null;}};
i.prototype.getVisibleItems=function(){var v=this.getItems().filter(function(k){return k.getVisible();});return v;};
i.prototype._getVisibleItemsCount=function(){return this.getVisibleItems().length;};
i.prototype._getGroupTitleInvisibleText=function(){var r=this.getUnread()?U:f,p,k=this.getPriority(),n,o=[r];if(k!==P.None){p=R.getText('NOTIFICATION_LIST_GROUP_PRIORITY',k);o.push(p);}if(this.getShowItemsCounter()){n=R.getText("LIST_ITEM_COUNTER",[this._getVisibleItemsCount()]);o.push(n);}return this._groupTitleInvisibleText.setText(o.join(' '));};
i.prototype.getPriority=function(){if(!this.getAutoPriority()){return this.getProperty('priority');}var n=this.getAggregation('items');var p=P.None;if(n){n.forEach(function(k){p=j(p,k.getPriority());});}else{p=this.getProperty('priority');}return p;};
function j(k,s){if(k==s){return k;}if((k=='None')){return s;}if((k=='Low')&&(s!='None')){return s;}if((k=='Medium')&&(s!='None'&&s!='Low')){return s;}return k;}
i.prototype.onBeforeRendering=function(){N.prototype.onBeforeRendering.apply(this,arguments);this._getCollapseButton().setVisible(this.getEnableCollapseButtonWhenEmpty()||this._getVisibleItemsCount()>0);};
i.prototype._isMaxNumberReached=function(){return this.getItems().length>m;};
i.prototype._getMaxNumberReachedMsg=function(){return{title:R.getText('NOTIFICATION_LIST_GROUP_MAX_NOTIFICATIONS_TITLE',this.getItems().length-m),description:R.getText('NOTIFICATION_LIST_GROUP_MAX_NOTIFICATIONS_BODY')};};
return i;});
sap.ui.predefine('sap/m/NotificationListGroupRenderer',["sap/ui/core/library","sap/ui/core/InvisibleRenderer","sap/ui/Device"],function(c,I,D){'use strict';var N={apiVersion:2};var P=c.Priority;
N.render=function(r,a){if(!a.getVisible()){I.render(r,a,a.TagName);return false;}if(!a.getItems().length&&!a.getShowEmptyGroup()){I.render(r,a,a.TagName);return false;}var i=a.getCollapsed(),p=a.getPriority(),s=a.getShowItemsCounter(),b=a.getUnread(),v=a._getVisibleItemsCount(),m,C=a.getId(),g=C+'-groupTitle',d=C+'-invisibleGroupTitleText',A=g+' '+d;r.openStart('li',a).class('sapMLIB').class('sapMNLIB').class('sapMNLGroup');if(i){r.class('sapMNLGroupCollapsed');}if(b){r.class('sapMNLGroupUnread');}r.attr('tabindex','0');r.accessibilityState(a,{role:"listitem",expanded:!a.getCollapsed(),labelledby:{value:A}});r.openEnd();r.openStart('div').class('sapMNLGroupHeader').openEnd();r.openStart('div').class('sapMNLIItem').class('sapMNLGroupCollapseButton').openEnd();r.renderControl(a._getCollapseButton());r.close('div');if(p!==P.None){r.openStart('div').class('sapMNLIBPriority').class('sapMNLIBPriority'+p).openEnd();r.renderControl(a._getPriorityIcon());r.close('div');}r.openStart('div',C+'-groupTitle').class('sapMNLIItem').class('sapMNLGroupTitle').openEnd();r.text(a.getTitle());r.close('div');if(s){r.openStart('div').class('sapMNLGroupCount').openEnd();r.text('('+v+')');r.close('div');}r.openStart('div').class('sapMNLGroupHeaderSpacer').openEnd().close('div');r.openStart('div').class('sapMNLIItem').class('sapMNLIActions');if(!a._shouldRenderOverflowToolbar()||(i&&!D.system.phone)){r.style('display','none');}r.openEnd();if(a._shouldRenderOverflowToolbar()){r.renderControl(a._getOverflowToolbar());}r.close('div');if(a._shouldRenderCloseButton()){r.openStart('div').class('sapMNLIItem').class('sapMNLICloseBtn').openEnd();r.renderControl(a._getCloseButton());r.close('div');}r.renderControl(a._getGroupTitleInvisibleText());r.close('div');r.openStart('ul').class('sapMNLGroupChildren').attr('role','list').openEnd();a.getItems().forEach(function(e){r.renderControl(e);});if(a._isMaxNumberReached()){m=a._getMaxNumberReachedMsg();r.openStart('div').class('sapMNLGroupMaxNotifications').openEnd();r.openStart('div').class('sapMNLGroupMNTitle').openEnd();r.text(m.title);r.close('div');r.openStart('div').class('sapMNLGroupMNDescription').openEnd();r.text(m.description);r.close('div');r.close('div');}r.close('ul');r.close('li');};
return N;},true);
sap.ui.predefine('sap/m/NotificationListItem',['./library','sap/ui/core/Core','./NotificationListBase','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','sap/ui/core/library','sap/m/Link','sap/m/Avatar',"sap/ui/events/KeyCodes",'./NotificationListItemRenderer'],function(l,C,N,I,R,c,L,A,K,a){'use strict';var b=C.getLibraryResourceBundle('sap.m'),E=b.getText('NOTIFICATION_LIST_ITEM_SHOW_MORE'),d=b.getText('NOTIFICATION_LIST_ITEM_SHOW_LESS'),e=b.getText('NOTIFICATION_LIST_ITEM_READ'),U=b.getText('NOTIFICATION_LIST_ITEM_UNREAD');var m=44;var f=l.AvatarSize;var g=l.AvatarColor;var P=c.Priority;
var h=N.extend('sap.m.NotificationListItem',{metadata:{library:'sap.m',properties:{description:{type:'string',group:'Appearance',defaultValue:''},authorInitials:{type:"string",group:"Data",defaultValue:null},truncate:{type:'boolean',group:'Appearance',defaultValue:true},hideShowMoreButton:{type:'boolean',group:'Appearance',defaultValue:false},authorAvatarColor:{type:"sap.m.AvatarColor",group:"Appearance",defaultValue:g.Accent6}},aggregations:{processingMessage:{type:'sap.m.MessageStrip',multiple:false},_showMoreButton:{type:'sap.m.Link',multiple:false,visibility:"hidden"}}}});
h.prototype.init=function(){this.setType('Active');this._footerIvisibleText=new I({id:this.getId()+"-invisibleFooterText"});};
h.prototype._getAuthorAvatar=function(){if(this.getAuthorInitials()||this.getAuthorPicture()){if(!this._avatar){this._avatar=new A({displaySize:f.XS});}this._avatar.setInitials(this.getAuthorInitials());this._avatar.setSrc(this.getAuthorPicture());this._avatar.setBackgroundColor(this.getAuthorAvatarColor());return this._avatar;}};
h.prototype.onBeforeRendering=function(){N.prototype.onBeforeRendering.call(this);if(this._resizeListenerId){R.deregister(this._resizeListenerId);this._resizeListenerId=null;}};
h.prototype.onAfterRendering=function(){if(this.getHideShowMoreButton()){return;}this._updateShowMoreButtonVisibility();if(this.getDomRef()){this._resizeListenerId=R.register(this.getDomRef(),this._onResize.bind(this));}};
h.prototype.onkeydown=function(i){if(i.target!==this.getDomRef()){return;}var n=this.getParent(),v,j;if(!n||!n.isA('sap.m.NotificationListGroup')){return;}v=n.getVisibleItems();j=v.indexOf(this);switch(i.which){case K.ARROW_UP:if(j===0){return;}var p=j-1;v[p].focus();break;case K.ARROW_DOWN:var k=j+1;if(k===v.length){return;}v[k].focus();break;}};
h.prototype.exit=function(){N.prototype.exit.apply(this,arguments);if(this._resizeListenerId){R.deregister(this._resizeListenerId);this._resizeListenerId=null;}if(this._footerIvisibleText){this._footerIvisibleText.destroy();this._footerIvisibleText=null;}if(this._avatar){this._avatar.destroy();this._avatar=null;}};
h.prototype._onResize=function(){this._updateShowMoreButtonVisibility();};
h.prototype._updateShowMoreButtonVisibility=function(){var $=this.$(),t=$.find('.sapMNLITitleText')[0],i=$.find('.sapMNLIDescription')[0],j;if($.length>0){j=t.scrollHeight>m||i.scrollHeight>m;}this._getShowMoreButton().setVisible(j);};
h.prototype._getShowMoreButton=function(){var s=this.getAggregation('_showMoreButton');if(!s){s=new L(this.getId()+'-showMoreButton',{text:this.getTruncate()?E:d,press:function(){var t=!this.getTruncate();this._getShowMoreButton().setText(t?E:d);this.setTruncate(t);}.bind(this)});this.setAggregation("_showMoreButton",s,true);}return s;};
h.prototype._getFooterInvisibleText=function(){var r=this.getUnread()?U:e,i=this.getAuthorName(),j=this.getDatetime(),p=this.getPriority(),k=[r];if(i){i=b.getText('NOTIFICATION_LIST_ITEM_CREATED_BY');k.push(i);k.push(this.getAuthorName());}if(j){k.push(b.getText('NOTIFICATION_LIST_ITEM_DATETIME',[j]));}if(p!==P.None){k.push(b.getText('NOTIFICATION_LIST_ITEM_PRIORITY',[p]));}return this._footerIvisibleText.setText(k.join(' '));};
return h;});
sap.ui.predefine('sap/m/NotificationListItemRenderer',["sap/ui/core/library","sap/ui/core/InvisibleRenderer"],function(c,I){'use strict';var P=c.Priority;var N={apiVersion:2};
N.render=function(r,a){if(!a.getVisible()){I.render(r,a,a.TagName);return false;}var t=a.getTruncate(),b=a.getAuthorName(),d=a.getDatetime(),e=a._getAuthorAvatar(),p=a.getPriority(),i=a.getUnread(),C=a.getId(),f=C+'-invisibleFooterText',A='';if(a.getTitle()){A+=' '+C+'-title';}if(a.getDescription()){A+=' '+C+'-descr';}A+=' '+f;r.openStart('li',a).class('sapMLIB').class('sapMNLIB').class('sapMNLI');if(i){r.class('sapMNLIUnread');}if(!e){r.class('sapMNLINoAvatar');}r.attr('tabindex','0');r.accessibilityState(a,{role:"listitem",labelledby:{value:A}});r.openEnd();r.renderControl(a.getProcessingMessage());r.openStart('div').class('sapMNLIMain').openEnd();r.openStart('div').attr('aria-hidden','true').class('sapMNLIItem').class('sapMNLIItemAC').openEnd();if(a._shouldRenderOverflowToolbar()){r.openStart('div').class('sapMNLIItem').class('sapMNLIActions').openEnd();r.renderControl(a._getOverflowToolbar());r.close('div');}if(a._shouldRenderCloseButton()){r.openStart('div').class('sapMNLIItem').class('sapMNLICloseBtn').openEnd();r.renderControl(a._getCloseButton());r.close('div');}r.close('div');r.openStart('div').class('sapMNLIContent').openEnd();r.openStart('div').class('sapMNLITitle').openEnd();if(p!==P.None){r.openStart('div').class('sapMNLIBPriority').class('sapMNLIBPriority'+p).openEnd();r.renderControl(a._getPriorityIcon());r.close('div');}r.openStart('div',C+'-title').class('sapMNLITitleText');if(t){r.class('sapMNLIItemTextLineClamp');}r.openEnd();r.text(a.getTitle());r.close('div');r.close('div');r.openStart('div',C+'-descr').class('sapMNLIDescription');if(!a.getDescription()){r.class('sapMNLIDescriptionNoText');}if(t){r.class('sapMNLIItemTextLineClamp');}r.openEnd();r.text(a.getDescription());r.close('div');r.openStart('div').class('sapMNLIFooter').openEnd();r.openStart('div').class('sapMNLIFooterItem').openEnd();r.text(b);r.close('div');if(b&&d){r.openStart('div').class('sapMNLIFooterItem').class('sapMNLIFooterBullet').openEnd();r.text('·');r.close('div');}r.openStart('div').class('sapMNLIFooterItem').openEnd();r.text(d);r.close('div');if(!a.getHideShowMoreButton()){r.openStart('div').class('sapMNLIShowMore').attr('aria-hidden','true').openEnd();r.renderControl(a._getShowMoreButton());r.close('div');}r.renderControl(a._getFooterInvisibleText());r.close('div');r.close('div');r.openStart('div').class('sapMNLIImage').openEnd();if(e){r.renderControl(e);}r.close('div');r.close('div');r.close('li');};
return N;},true);
sap.ui.predefine('sap/m/NotificationListRenderer',['sap/ui/core/Renderer','./ListBaseRenderer'],function(R,L){"use strict";var N=R.extend(L);N.apiVersion=2;
N.getAriaRole=function(c){return"list";};
return N;},true);
sap.ui.predefine('sap/m/NumericContent',["./library","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/core/ResizeHandler","sap/m/Image","./NumericContentRenderer","sap/ui/events/KeyCodes","sap/base/util/deepEqual"],function(l,C,I,R,a,N,K,d){"use strict";var L={"ar":4,"ar_eg":4,"ar_sa":4,"bg":4,"ca":6,"cs":4,"da":4,"de":8,"de-de":8,"de_at":8,"de_ch":8,"el":4,"el_cy":4,"en":4,"en_au":4,"en_gb":4,"en_hk":4,"en_ie":4,"en_in":4,"en_nz":4,"en_pg":4,"en_sg":4,"en_us":4,"en_za":4,"es":6,"es_ar":4,"es_bo":4,"es_cl":4,"es_co":4,"es_mx":6,"es_pe":4,"es_uy":4,"es_ve":4,"et":4,"fa":4,"fi":4,"fr":4,"fr_be":4,"fr_ca":4,"fr_ch":4,"fr_lu":4,"he":4,"hi":4,"hr":4,"hu":4,"id":4,"it":8,"it_ch":8,"ja":6,"kk":4,"ko":6,"lt":4,"lv":4,"ms":4,"nb":4,"nl":4,"nl_be":4,"pl":4,"pt":4,"pt_pt":4,"ro":4,"ru":4,"ru_ua":4,"sk":4,"sl":4,"sr":4,"sv":4,"th":4,"tr":4,"uk":4,"vi":4,"zh_cn":6,"zh_hk":6,"zh_sg":6,"zh_tw":6};var D=l.DeviationIndicator,V=l.ValueColor;
var b=C.extend("sap.m.NumericContent",{metadata:{library:"sap.m",properties:{"animateTextChange":{type:"boolean",group:"Behavior",defaultValue:true},"formatterValue":{type:"boolean",group:"Data",defaultValue:false},"icon":{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},"iconDescription":{type:"string",group:"Accessibility",defaultValue:null},"indicator":{type:"sap.m.DeviationIndicator",group:"Appearance",defaultValue:"None"},"nullifyValue":{type:"boolean",group:"Behavior",defaultValue:true},"scale":{type:"string",group:"Appearance",defaultValue:null},"size":{type:"sap.m.Size",group:"Appearance",defaultValue:"Auto",deprecated:true},"truncateValueTo":{type:"int",group:"Appearance"},"value":{type:"string",group:"Data",defaultValue:null},"valueColor":{type:"sap.m.ValueColor",group:"Appearance",defaultValue:"Neutral"},"width":{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},"withMargin":{type:"boolean",group:"Appearance",defaultValue:true},"state":{type:"sap.m.LoadState",group:"Behavior",defaultValue:"Loaded"},"adaptiveFontSize":{type:"boolean",group:"Appearance",defaultValue:true}},events:{"press":{}}}});
b.prototype.init=function(){this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setTooltip("{AltText}");sap.ui.getCore().attachInit(this._registerResizeHandler.bind(this));};
b.prototype._getParentTile=function(){var p=this.getParent();while(p){if(p.isA("sap.m.GenericTile")){return p;}p=p.getParent();}return null;};
b.prototype._getMaxDigitsData=function(){var f=null,s=sap.ui.getCore().getConfiguration().getLanguage().toLowerCase(),m=L[s]||4;if(this.getAdaptiveFontSize()){switch(m){case 6:f="sapMNCMediumFontSize";break;case 8:f="sapMNCSmallFontSize";break;default:f="sapMNCLargeFontSize";break;}}else{f="sapMNCLargeFontSize";m=4;}return{fontClass:f,maxLength:m};};
b.prototype._registerResizeHandler=function(){R.register(this,this.invalidate.bind(this));};
b.prototype.onBeforeRendering=function(){this.$().off("mouseenter");this.$().off("mouseleave");this._iMaxLength=null;};
b.prototype.onAfterRendering=function(){this.$().on("mouseenter",this._addTooltip.bind(this));this.$().on("mouseleave",this._removeTooltip.bind(this));if(!sap.ui.getCore().isThemeApplied()){sap.ui.getCore().attachThemeChanged(this._checkIfIconFits,this);}else{this._checkIfIconFits();}};
b.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
b.prototype._checkIfIconFits=function(){var p=this._getParentTile();if(p&&(p.isA("sap.m.GenericTile")||p.isA("sap.m.SlideTile"))){p._setupResizeClassHandler();}var i=this.getDomRef("icon-image");if(i){var v=this.getDomRef("value-inner"),o=this.getDomRef("indicator"),w=this.getDomRef("value");var f=i?i.getBoundingClientRect().width:0,c=v?v.getBoundingClientRect().width:0,e=o?o.getBoundingClientRect().width:0,W=w.getBoundingClientRect().width;i.style.display=(f+c+e)>W?"none":"";}};
b.prototype._removeTooltip=function(){this.$().attr("title",null);};
b.prototype.exit=function(){if(this._oIcon){this._oIcon.destroy();}if(this._oIndicatorIcon){this._oIndicatorIcon.destroy();}};
b.prototype.getAltText=function(){var v=this.getValue();var s=this.getScale();var e;var A="";if(this.getNullifyValue()){e="0";}else{e="";}if(this.getIconDescription()){A=A.concat(this.getIconDescription());A=A.concat("\n");}if(v){A=A.concat(v+s);}else{A=A.concat(e);}if(this.getIndicator()&&this.getIndicator()!==D.None){A=A.concat("\n");A=A.concat(this._rb.getText(("NUMERICCONTENT_DEVIATION_"+this.getIndicator()).toUpperCase()));}if(this.getValueColor()!==V.None){var m=this._rb.getText(("SEMANTIC_COLOR_"+this.getValueColor()).toUpperCase());A=A.concat("\n");A=A.concat(m);}return A;};
b.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var T=this.getAltText();if(typeof t==="string"||t instanceof String){T=t.split("{AltText}").join(T).split("((AltText))").join(T);return T;}if(t){return t;}else{return"";}};
b.prototype.setIcon=function(u){var v=!d(this.getIcon(),u);if(v){if(this._oIcon){this._oIcon.destroy();this._oIcon=undefined;}if(u){this._oIcon=I.createControlByURI({id:this.getId()+"-icon-image",src:u},a);}}this._setPointerOnIcon();return this.setProperty("icon",u);};
b.prototype.setIndicator=function(s){var S="sap-icon://"+(s?s.toLowerCase():"none");if(this._oIndicatorIcon){this._oIndicatorIcon.setSrc(S);}else{this._oIndicatorIcon=I.createControlByURI({id:this.getId()+"-icon-indicator",size:"0.875rem",src:S},a);this._oIndicatorIcon.addStyleClass("sapMNCIndIcon");}return this.setProperty("indicator",s);};
b.prototype._setPointerOnIcon=function(){if(this._oIcon&&this.hasListeners("press")){this._oIcon.addStyleClass("sapMPointer");}else if(this._oIcon&&this._oIcon.hasStyleClass("sapMPointer")){this._oIcon.removeStyleClass("sapMPointer");}};
b.prototype.ontap=function(e){this.$().trigger("focus");this.firePress();e.preventDefault();};
b.prototype.onkeyup=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
b.prototype.onkeydown=function(e){if(e.which===K.SPACE){e.preventDefault();}};
b.prototype.attachEvent=function(e,c,f,g){C.prototype.attachEvent.call(this,e,c,f,g);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnIcon();}return this;};
b.prototype.detachEvent=function(e,f,c){C.prototype.detachEvent.call(this,e,f,c);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnIcon();}return this;};
b.prototype._parseFormattedValue=function(v){var t=v.replace(String.fromCharCode(8206),"").replace(String.fromCharCode(8207),"");return{scale:t.replace(/[+-., \d]*(.*)$/g,"$1").trim().replace(/\.$/,""),value:t.replace(/([+-., \d]*).*$/g,"$1").trim()};};
return b;});
sap.ui.predefine('sap/m/NumericContentRenderer',["sap/m/library"],function(l){"use strict";var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");var D=l.DeviationIndicator,L=l.LoadState,V=l.ValueColor;var N={apiVersion:2};
N.render=function(R,c){var s=c.getState();var w=c.getWithMargin();var W=w?"":"WithoutMargin";R.openStart("div",c);var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}R.attr("aria-label",t);R.attr("role","img");R.attr("aria-roledescription",r.getText("NUMERIC_CONTENT_ROLE_DESCRIPTION"));if(s===L.Failed||s===L.Loading){R.attr("aria-disabled","true");}if(c.getAnimateTextChange()){R.class("sapMNCAnimation");}if(c.getWidth()){R.style("width",c.getSize());}R.class("sapMNC");R.class(W);if(c.hasListeners("press")){R.attr("tabindex",0);R.class("sapMPointer");}R.openEnd();R.openStart("div");R.class("sapMNCInner");R.class(W);R.openEnd();this._renderValue(R,c,W);R.close("div");R.close("div");};
N._prepareAndRenderIcon=function(R,c,i,n){if(i){var s,C=c.getState();for(s in L){if(L.hasOwnProperty(s)&&s!==C){i.removeStyleClass(s);}else if(L.hasOwnProperty(s)&&s===C){i.addStyleClass(s);}}i.addStyleClass("sapMNCIconImage");var S={sapMNCLargeFontSize:false,sapMNCMediumFontSize:false,sapMNCSmallFontSize:false};S[n]=true;Object.keys(S).forEach(function(k){i.toggleStyleClass(k,S[k]);});R.renderControl(i);}};
N._renderScaleAndIndicator=function(R,c,w,v,s,n){var i=D.None!==c.getIndicator()&&v!=="";var S=s&&v;if(i||S){var a=c.getState();var C=c.getValueColor();R.openStart("div",c.getId()+"-indicator");R.class("sapMNCIndScale");R.class(w);R.class(a);R.class(a);if(n){R.class(n);}R.openEnd();R.renderControl(c._oIndicatorIcon);if(S){R.openStart("div",c.getId()+"-scale");R.class("sapMNCScale");R.class(a);R.class(C);R.openEnd();R.text(s);R.close("div");}R.close("div");}};
N._renderValue=function(R,c,w){var v=c.getValue();var s=c.getScale();if(c.getFormatterValue()){var f=c._parseFormattedValue(v);s=f.scale;v=f.value;}var e=c.getNullifyValue()?"0":"";R.openStart("div",c.getId()+"-value");R.class("sapMNCValue");R.class(w);if(c.getValueColor()===V.None){R.class("Neutral");}else{R.class(c.getValueColor());}R.class(c.getState());R.openEnd();if(c.getState()===L.Loading){R.openStart("div").class("sapMNCContentShimmerPlaceholderItem");R.openEnd();R.openStart("div").class("sapMNCContentShimmerPlaceholderRows").openEnd();R.openStart("div").class("sapMNCContentShimmerPlaceholderItemHeader").class("sapMNCLoadingShimmer").openEnd().close("div");R.close("div");R.close("div");R.close("div");}else{var m=c._getMaxDigitsData();this._prepareAndRenderIcon(R,c,c._oIcon,m.fontClass);var C=c.getTruncateValueTo()||m.maxLength;R.openStart("span",c.getId()+"-value-inner");if(m.fontClass){R.class(m.fontClass);}R.openEnd();if(v.length>=C&&(v[C-1]==="."||v[C-1]===",")){R.text(v.substring(0,C-1));}else{R.text(v?v.substring(0,C):e);}R.close("span");this._renderScaleAndIndicator(R,c,w,v,s,m.fontClass);R.close("div");}};
return N;},true);
sap.ui.predefine('sap/m/NumericInput',["./InputBase","./Input","./NumericInputRenderer","./library","sap/ui/core/format/NumberFormat","sap/ui/Device","sap/ui/events/KeyCodes","sap/ui/dom/jquery/cursorPos"],function(I,a,N,l,b,D,K){"use strict";var c=l.InputType;
var d=a.extend("sap.m.NumericInput",{metadata:{library:"sap.m"}});
d.prototype.onBeforeRendering=function(){I.prototype.onBeforeRendering.call(this);this.setWidth("100%");this._deregisterEvents();};
d.prototype.setValue=function(v){a.prototype.setValue.apply(this,arguments);if(this.getDomRef()){this.getDomRef("inner").setAttribute("aria-valuenow",v);}return this;};
d.prototype.setType=function(t){return a.prototype.setType.call(this,c.Number);};
d.prototype.onkeydown=function(e){var t,C,p;a.prototype.onkeydown.apply(this,arguments);if(!D.system.desktop||e.ctrlKey||e.metaKey||(e.originalEvent.key&&e.originalEvent.key.length!==1)){return;}C=this._$input.cursorPos();if(e.which===K.NUMPAD_COMMA){e.preventDefault();t=this.getValue().substring(0,C)+this._getNumberFormat().oFormatOptions.decimalSeparator+this.getValue().substring(C);p=this._getNumberFormat().parse(t);if(p||p===0){this.setDOMValue(t);}return;}t=this.getValue().substring(0,C)+e.originalEvent.key+this.getValue().substring(C);p=this._getNumberFormat().parse(t);if(!i(e.which)||(!p&&p!==0)){e.preventDefault();}};
var n=[[K.A,K.Z],[K.OPEN_BRACKET,K.OPEN_BRACKET],[K.PIPE,K.SEMICOLON],[K.GREAT_ACCENT,K.BACKSLASH]];
function i(k){return Object.values(K).includes(k)&&!n.some(function(r){return k>=r[0]&&k<=r[1];});}
d.prototype._getNumberFormat=function(){if(!this._oNumberFormat){this._oNumberFormat=b.getFloatInstance();}return this._oNumberFormat;};
return d;});
sap.ui.predefine('sap/m/NumericInputRenderer',["sap/ui/core/Renderer","./InputRenderer","sap/ui/Device","sap/ui/core/LabelEnablement"],function(R,I,D,L){"use strict";var N=R.extend(I);N.apiVersion=2;
N.writeInnerAttributes=function(r,c){var s=c.getParent(),a=this.getAccessibilityState(c);r.attr("type",D.system.desktop?"text":"number");if(sap.ui.getCore().getConfiguration().getRTL()){r.attr("dir","ltr");}a.disabled=null;if(N._isStepInput(s)){r.accessibilityState(s,a);}};
N.getAccessibilityState=function(n){var a=I.getAccessibilityState(n),m,M,f,d,s,A,r,b,c,S=n.getParent(),v=n.getValue();if(!N._isStepInput(S)){return a;}m=S._getMin();M=S._getMax();f=S.getValue();d=S.getDescription();A=S.getAriaLabelledBy();r=L.getReferencingLabels(S);b=S.getAriaDescribedBy().join(" ");a.valuenow=f;if(D.system.desktop&&v){a.valuetext=v;}if(d){s=S._getInput().getId()+"-descr";if(A.indexOf(s)===-1){A.push(s);}}c=r.concat(A).join(" ");if(typeof m==="number"){a.valuemin=m;}if(typeof M==="number"){a.valuemax=M;}if(!S.getEditable()){a.readonly=true;}if(b){a.describedby=b;}if(c){a.labelledby=c;}return a;};
N._isStepInput=function(c){return c&&c.getMetadata().getName()==="sap.m.StepInput";};
return N;});
sap.ui.predefine('sap/m/ObjectAttribute',['./library','sap/ui/core/Control','sap/ui/core/library','sap/m/Text','sap/ui/events/KeyCodes','./ObjectAttributeRenderer','sap/base/Log','sap/ui/base/ManagedObjectObserver','sap/ui/core/Core'],function(l,C,c,T,K,O,L,M,a){"use strict";var b=c.TextDirection;var E=l.EmptyIndicatorMode;var A=c.aria.HasPopup;
var d=C.extend("sap.m.ObjectAttribute",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectAttribute.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},active:{type:"boolean",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:b.Inherit},ariaHasPopup:{type:"sap.ui.core.aria.HasPopup",group:"Accessibility",defaultValue:A.None}},aggregations:{customContent:{type:"sap.ui.core.Control",multiple:false},_textControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{press:{parameters:{domRef:{type:"string"}}}},dnd:{draggable:true,droppable:false}}});
d.prototype.init=function(){this.setAggregation('_textControl',new T());};
d.prototype.exit=function(){if(this._oCustomContentObserver){this._oCustomContentObserver.disconnect();this._oCustomContentObserver=null;}if(this._oCustomContentCloning){this._oCustomContentCloning.destroy();}};
d.prototype._getUpdatedTextControl=function(){var o=this._oCustomContentCloning||this.getAggregation('_textControl'),t=this.getTitle(),s=this.getAggregation('customContent')?this.getAggregation('customContent').getText():this.getText(),e=this.getTextDirection(),p=this.getParent(),P=sap.ui.getCore().getConfiguration().getRTL(),m,w=true,f='',g=sap.ui.getCore(),r;this._bEmptyIndicatorMode=this._isEmptyIndicatorMode();if(e===b.LTR&&P){f='\u200e';}if(e===b.RTL&&!P){f='\u200f';}s=f+s+f;if(t){r=t;if(g.getConfiguration().getLocale().getLanguage().toLowerCase()==="fr"){r+=" ";}r+=": "+s;}else{r=s;}if(this._bEmptyIndicatorMode){this.getAggregation('_textControl').setProperty("emptyIndicatorMode",E.On,true);}o.setProperty('text',r,true);o.setProperty('textDirection',e,true);if(p instanceof sap.m.ObjectListItem){w=false;m=O.MAX_LINES.SINGLE_LINE;}this._setControlWrapping(o,w,m);return o;};
d.prototype._isEmptyIndicatorMode=function(){var o=this.getAggregation('customContent');return o&&o.getEmptyIndicatorMode()!==E.Off&&!o.getText();};
d.prototype._setControlWrapping=function(o,w,m){if(o.isA("sap.m.Link")){o.setProperty('wrapping',w,true);}if(o.isA("sap.m.Text")){o.setProperty('maxLines',m,true);}};
d.prototype.ontap=function(e){var t=e.target;t=t.id?t:t.parentElement;if(this._isSimulatedLink()&&(t.id===this.getId()+"-text")){this.firePress({domRef:this.getDomRef()});}};
d.prototype.onsapenter=function(e){if(this._isSimulatedLink()){this.firePress({domRef:this.getDomRef()});e.setMarked();}};
d.prototype.onsapspace=function(e){e.preventDefault();};
d.prototype.onkeyup=function(e){if(e.which===K.SPACE){this.onsapenter(e);}};
d.prototype._isEmpty=function(){if(this.getAggregation('customContent')&&!(this.getAggregation('customContent').isA("sap.m.Link")||this.getAggregation('customContent').isA("sap.m.Text"))){L.warning("Only sap.m.Link or sap.m.Text are allowed in \"sap.m.ObjectAttribute.customContent\" aggregation");return true;}return!(this.getText().trim()||this.getTitle().trim());};
d.prototype.ontouchstart=function(e){if(this._isSimulatedLink()){e.originalEvent._sapui_handledByControl=true;}};
d.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("text");};
d.prototype._isSimulatedLink=function(){return(this.getActive()&&this.getText()!=="")&&!this.getAggregation('customContent');};
d.prototype.setCustomContent=function(o){var e=this.getCustomContent();if(this._oCustomContentCloning){this._oCustomContentCloning.destroy();}this._oCustomContentCloning=o&&o.clone();if(!this._oCustomContentObserver){this._oCustomContentObserver=new M(function(){this.invalidate();}.bind(this));}if(e){this._oCustomContentObserver.unobserve(e);}o&&this._oCustomContentObserver.observe(o,{properties:true});return this.setAggregation('customContent',o);};
d.prototype._isClickable=function(){return(this.getActive()&&this.getText()!=="")||(this.getAggregation('customContent')&&this.getAggregation('customContent').isA('sap.m.Link'));};
return d;});
sap.ui.predefine('sap/m/ObjectAttributeRenderer',["sap/ui/core/library"],function(c){"use strict";var T=c.TextDirection;var A=c.aria.HasPopup;var O={apiVersion:2,MAX_LINES:{SINGLE_LINE:1}};
O.render=function(r,o){var p=o.getParent(),t=o.getTooltip_AsString(),s=o.getTextDirection();r.openStart("div",o);if(o._isEmpty()){r.class("sapMObjectAttributeDiv");r.class("sapUiHidden");r.openEnd();r.close("div");return;}r.class("sapMObjectAttributeDiv");if(s!==T.Inherit){r.attr("dir",s.toLowerCase());}if(o._isClickable()){r.class("sapMObjectAttributeActive");if(!o.getTitle()&&o.getText()){r.class("sapMObjectAttributeTextOnly");}}if(t){r.attr("title",t);}r.openEnd();if(o._isClickable()||p instanceof sap.m.ObjectHeader){this.renderActiveTitle(r,o);this.renderActiveText(r,o,p);}else{r.renderControl(o._getUpdatedTextControl());if(o._bEmptyIndicatorMode){r.renderControl(o.getAggregation("_textControl"));}}r.close("div");};
O.renderActiveTitle=function(r,o){var C,R=o.getTextDirection()===T.Inherit;if(!o.getProperty("title")){return;}C=": ";r.openStart("span",o.getId()+"-title");r.class("sapMObjectAttributeTitle");r.openEnd();if(R){r.openStart("bdi");r.openEnd();}r.text(o.getProperty("title"));if(R){r.close("bdi");}r.close("span");r.openStart("span",o.getId()+"-colon");r.class("sapMObjectAttributeColon");r.openEnd();if(sap.ui.getCore().getConfiguration().getLocale().getLanguage().toLowerCase()==="fr"){C=" "+C;}r.text(C);r.close("span");};
O.renderActiveText=function(r,o,p){var a=o.getAggregation("customContent"),R=o.getTextDirection()===T.Inherit,s=(o.getAriaHasPopup()===A.None)?"":o.getAriaHasPopup().toLowerCase();r.openStart("span",o.getId()+"-text");r.class("sapMObjectAttributeText");if(a&&a.isA("sap.m.Link")){a.setAriaHasPopup(o.getAriaHasPopup());}else{r.attr("tabindex","0");r.attr("role","link");if(s){r.attr("aria-haspopup",s);}}r.openEnd();if(a&&p){if((p instanceof sap.m.ObjectHeader)&&!o.getParent().getResponsive()){o._setControlWrapping(a,true);}else{o._setControlWrapping(a,false,O.MAX_LINES.SINGLE_LINE);}r.renderControl(a);}else{if(R){r.openStart("bdi");r.openEnd();}r.text(o.getProperty("text"));if(R){r.close("bdi");}}r.close("span");};
return O;},true);
sap.ui.predefine('sap/m/ObjectHeader',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/core/util/ResponsivePaddingsEnablement','sap/ui/Device','sap/m/Text','sap/ui/events/KeyCodes','./ObjectHeaderRenderer','./ObjectMarker','./ObjectNumber',"sap/ui/thirdparty/jquery"],function(l,C,I,c,R,D,T,K,O,a,b,q){"use strict";var B=l.BackgroundDesign;var d=c.TextAlign;var e=l.ImageHelper;var f=l.ObjectMarkerType;var g=c.TitleLevel;var h=c.TextDirection;var V=c.ValueState;var j=l.ObjectHeaderPictureShape;
var k=C.extend("sap.m.ObjectHeader",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectHeader.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},intro:{type:"string",group:"Misc",defaultValue:null},introActive:{type:"boolean",group:"Misc",defaultValue:null},titleActive:{type:"boolean",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconActive:{type:"boolean",group:"Misc",defaultValue:null},iconAlt:{type:"string",group:"Accessibility",defaultValue:null},iconTooltip:{type:"string",group:"Accessibility",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},imageShape:{type:"sap.m.ObjectHeaderPictureShape",group:"Appearance",defaultValue:j.Square},markFavorite:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},markFlagged:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},showMarkers:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},showTitleSelector:{type:"boolean",group:"Misc",defaultValue:false},numberState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},condensed:{type:"boolean",group:"Appearance",defaultValue:false},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance"},responsive:{type:"boolean",group:"Behavior",defaultValue:false},fullScreenOptimized:{type:"boolean",group:"Appearance",defaultValue:false},titleHref:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},titleTarget:{type:"string",group:"Behavior",defaultValue:null},introHref:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},introTarget:{type:"string",group:"Behavior",defaultValue:null},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:h.Inherit},introTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:h.Inherit},numberTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:h.Inherit},titleSelectorTooltip:{type:"string",group:"Misc",defaultValue:"Options"},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:g.H1}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},firstStatus:{type:"sap.m.ObjectStatus",multiple:false,deprecated:true},secondStatus:{type:"sap.m.ObjectStatus",multiple:false,deprecated:true},statuses:{type:"sap.ui.core.Control",multiple:true,singularName:"status"},_objectNumber:{type:"sap.m.ObjectNumber",multiple:false,visibility:"hidden"},additionalNumbers:{type:"sap.m.ObjectNumber",multiple:true,singularName:"additionalNumber"},headerContainer:{type:"sap.m.ObjectHeaderContainer",multiple:false},markers:{type:"sap.m.ObjectMarker",multiple:true,singularName:"marker"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{titlePress:{parameters:{domRef:{type:"object"}}},introPress:{parameters:{domRef:{type:"object"}}},iconPress:{parameters:{domRef:{type:"object"}}},titleSelectorPress:{parameters:{domRef:{type:"object"}}}},dnd:{draggable:false,droppable:true}}});
k._getResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m");};
R.call(k.prototype,{header:{selector:".sapMOH, .sapMOHR"}});
k.prototype.init=function(){this._oTitleArrowIcon=I.createControlByURI({id:this.getId()+"-titleArrow",src:I.getIconURI("arrow-down"),decorative:false,visible:false,tooltip:k._getResourceBundle().getText("OH_SELECT_ARROW_TOOLTIP"),size:"1.375rem",press:function(E){}});this._fNumberWidth=undefined;this._titleText=new T(this.getId()+"-titleText");this._titleText.setMaxLines(3);this._initResponsivePaddingsEnablement();};
k.prototype.insertAttribute=function(A,i){var r=this.insertAggregation("attributes",A,i);this._registerControlListener(A);return r;};
k.prototype.addAttribute=function(A){var r=this.addAggregation("attributes",A);this._registerControlListener(A);return r;};
k.prototype.removeAttribute=function(A){var r=this.removeAggregation("attributes",A);this._deregisterControlListener(r);return r;};
k.prototype.removeAllAttributes=function(){var A=this.removeAllAggregation("attributes");A.forEach(this._deregisterControlListener,this);return A;};
k.prototype.destroyAttributes=function(){var A=this.getAggregation("attributes");if(A!==null){A.forEach(this._deregisterControlListener,this);}return this.destroyAggregation("attributes");};
k.prototype.insertStatus=function(s,i){var r=this.insertAggregation("statuses",s,i);this._registerControlListener(s);return r;};
k.prototype.addStatus=function(s){var r=this.addAggregation("statuses",s);this._registerControlListener(s);return r;};
k.prototype.removeStatus=function(s){var r=this.removeAggregation("statuses",s);this._deregisterControlListener(r);return r;};
k.prototype.removeAllStatuses=function(){var s=this.removeAllAggregation("statuses");s.forEach(this._deregisterControlListener,this);return s;};
k.prototype.destroyStatuses=function(){var s=this.getAggregation("statuses");if(s!==null){s.forEach(this._deregisterControlListener,this);}return this.destroyAggregation("statuses");};
k.prototype._registerControlListener=function(o){if(o){o.attachEvent("_change",this.invalidate,this);}};
k.prototype._deregisterControlListener=function(o){if(o){o.detachEvent("_change",this.invalidate,this);}};
k.prototype.setCondensed=function(i){this.setProperty("condensed",i);if(this.getCondensed()){this._oTitleArrowIcon.setSize("1rem");}else{this._oTitleArrowIcon.setSize("1.375rem");}return this;};
k.prototype.setNumber=function(n){this.setProperty("number",n);this._getObjectNumber().setNumber(n);return this;};
k.prototype.setNumberUnit=function(u){this.setProperty("numberUnit",u);this._getObjectNumber().setUnit(u);return this;};
k.prototype.setNumberState=function(s){this.setProperty("numberState",s);this._getObjectNumber().setState(s);return this;};
k.prototype.setTitleSelectorTooltip=function(t){this.setProperty("titleSelectorTooltip",t);this._oTitleArrowIcon.setTooltip(t);return this;};
k.prototype.setMarkFavorite=function(m){return this._setOldMarkers(f.Favorite,m);};
k.prototype.setMarkFlagged=function(m){return this._setOldMarkers(f.Flagged,m);};
k.prototype.setShowMarkers=function(m){var M,A=this.getMarkers(),i;this.setProperty("showMarkers",m);for(i=0;i<A.length;i++){M=A[i].getType();if((M===f.Flagged&&this.getMarkFlagged())||(M===f.Favorite&&this.getMarkFavorite())){A[i].setVisible(m);}}return this;};
k.prototype._setOldMarkers=function(m,M){var A=this.getMarkers(),H=false,i,o={Flagged:"-flag",Favorite:"-favorite"};this.setProperty("mark"+m,M,false);if(!this.getShowMarkers()){M=false;}for(i=0;i<A.length;i++){if(A[i].getType()===m){H=true;A[i].setVisible(M);break;}}if(!H){this.insertAggregation("markers",new a({id:this.getId()+o[m],type:m,visible:M}));}return this;};
k.prototype._getVisibleMarkers=function(){var A=this.getMarkers(),v=[],i;for(i=0;i<A.length;i++){if(A[i].getVisible()){v.push(A[i]);}}return v;};
k.prototype._getObjectNumber=function(){var o=this.getAggregation("_objectNumber");if(!o){o=new b(this.getId()+"-number",{emphasized:false});this.setAggregation("_objectNumber",o,true);}return o;};
k.prototype.getFocusDomRef=function(){if(this.getResponsive()){return this.$("txt")[0];}else{return this.$("title")[0];}};
k.prototype.ontap=function(E){var s=E.target.id;if(this.getIntroActive()&&s===this.getId()+"-intro"){if(!this.getIntroHref()){this.fireIntroPress({domRef:window.document.getElementById(s)});}}else if(!this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-title"||q(E.target).parent().attr('id')===this.getId()+"-title"||s===this.getId()+"-titleText-inner")){if(!this.getTitleHref()){E.preventDefault();s=this.getId()+"-title";this.fireTitlePress({domRef:window.document.getElementById(s)});}}else if(this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-txt"||q(E.target).parent().attr('id')===this.getId()+"-txt")){if(!this.getTitleHref()){E.preventDefault();s=this.getId()+"-txt";this.fireTitlePress({domRef:window.document.getElementById(s)});}}else if(E.target.classList.contains("sapUiIconTitle")){this.fireTitleSelectorPress({domRef:E.target.parentElement});}else if(s.indexOf(this.getId())!==-1){E.setMarked();E.preventDefault();}};
k.prototype._handleSpaceOrEnter=function(E){var s=E.target.id;E.setMarked();if(!this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-title"||q(E.target).parent().attr('id')===this.getId()+"-title"||s===this.getId()+"-titleText-inner")){s=this.getId()+"-title";if(!this.getTitleHref()){E.preventDefault();this.fireTitlePress({domRef:(s?window.document.getElementById(s):null)});}else{if(E.type==="sapspace"){this._linkClick(E,s);}}}else if(this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-txt"||q(E.target).parent().attr('id')===this.getId()+"-txt")){s=this.getId()+"-txt";if(!this.getTitleHref()){E.preventDefault();this.fireTitlePress({domRef:(s?window.document.getElementById(s):null)});}else{if(E.type==="sapspace"){this._linkClick(E,s);}}}else if(this.getIntroActive()&&s===this.getId()+"-intro"){if(!this.getIntroHref()){this.fireIntroPress({domRef:(s?window.document.getElementById(s):null)});}}else if(s===this.getId()+"-titleArrow"){this.fireTitleSelectorPress({domRef:(s?window.document.getElementById(s):null)});}};
k.prototype.onkeyup=function(E){if(E.which===K.SPACE){this._handleSpaceOrEnter(E);}};
k.prototype.onsapenter=k.prototype._handleSpaceOrEnter;
k.prototype._linkClick=function(E,s){E.setMarked();var o=document.createEvent('MouseEvents');o.initEvent('click',false,true);((s?window.document.getElementById(s):null)).dispatchEvent(o);};
k.prototype._onOrientationChange=function(){var i=this.getId();if(D.system.tablet&&this.getFullScreenOptimized()&&(this._hasAttributes()||this._hasStatus())){this._rerenderStates();}if(D.system.phone){if(D.orientation.portrait){if(this.getTitle().length>50){this._rerenderTitle(50);}if(this.getIcon()){q(document.getElementById(i+"-titlediv")).removeClass("sapMOHRTitleIcon");q(document.getElementById(i+"-titleIcon")).addClass("sapMOHRHideIcon");}}else{if(D.orientation.landscape){if(this.getTitle().length>80){this._rerenderTitle(80);}if(this.getIcon()){q(document.getElementById(i+"-titlediv")).addClass("sapMOHRTitleIcon");q(document.getElementById(i+"-titleIcon")).removeClass("sapMOHRHideIcon");}}}this._adjustNumberDiv();}this._adjustIntroDiv();};
k.prototype._rerenderTitle=function(n){var r=sap.ui.getCore().createRenderManager();this.getRenderer()._rerenderTitle(r,this,n);r.destroy();};
k.prototype._rerenderStates=function(){var r=sap.ui.getCore().createRenderManager();this.getRenderer()._rerenderResponsiveStates(r,this);r.destroy();};
k.prototype.exit=function(){if(!D.system.phone){this._detachMediaContainerWidthChange(this._rerenderOHR,this,D.media.RANGESETS.SAP_STANDARD);}if(D.system.tablet||D.system.phone){D.orientation.detachHandler(this._onOrientationChange,this);}if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=undefined;}if(this._oTitleArrowIcon){this._oTitleArrowIcon.destroy();this._oTitleArrowIcon=undefined;}if(this._titleText){this._titleText.destroy();this._titleText=undefined;}if(this._introText){this._introText.destroy();this._introText=undefined;}};
k.prototype._getImageControl=function(){var i=this.getId()+"-img";var s="2.5rem";var p=q.extend({src:this.getIcon(),tooltip:this.getIconTooltip(),alt:this.getIconAlt()||k._getResourceBundle().getText("OH_ARIA_ICON"),useIconTooltip:false,densityAware:this.getIconDensityAware(),decorative:false},I.isIconURI(this.getIcon())?{size:s}:{});if(this.getIconActive()){p.press=function(E){this.fireIconPress({domRef:E.getSource().getDomRef()});}.bind(this);p.decorative=false;}this._oImageControl=e.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
k.prototype.onBeforeRendering=function(){if(D.system.tablet||D.system.phone){D.orientation.detachHandler(this._onOrientationChange,this);}if(!D.system.phone){this._detachMediaContainerWidthChange(this._rerenderOHR,this,D.media.RANGESETS.SAP_STANDARD);}if(this._introText){this._introText.destroy();this._introText=undefined;}};
k.prototype.onAfterRendering=function(){var o=this.getAggregation("_objectNumber");var p=sap.ui.getCore().getConfiguration().getRTL();var $=this.$("titleArrow");$.attr("role","button");if(this.getResponsive()){this._adjustIntroDiv();if(o&&o.getNumber()){if(D.system.desktop&&q('html').hasClass("sapUiMedia-Std-Desktop")&&this.getFullScreenOptimized()&&this._iCountVisAttrStat>=1&&this._iCountVisAttrStat<=3){o.setTextAlign(p?d.Right:d.Left);}else{o.setTextAlign(p?d.Left:d.Right);}}this._adjustNumberDiv();if(D.system.tablet||D.system.phone){D.orientation.attachHandler(this._onOrientationChange,this);}if(!D.system.phone){this._attachMediaContainerWidthChange(this._rerenderOHR,this,D.media.RANGESETS.SAP_STANDARD);}}else{var t=p?d.Left:d.Right;if(o&&o.getNumber()){o.setTextAlign(t);}if(this.getAdditionalNumbers()){this._setTextAlignANum(t);}}};
k.prototype._rerenderOHR=function(){this.invalidate();};
k.prototype._adjustNumberDiv=function(){var i=this.getId();var o=this.getAggregation("_objectNumber");var p=sap.ui.getCore().getConfiguration().getRTL();if(o&&o.getNumber()){var $=q(document.getElementById(i+"-number"));var m=q(document.getElementById(i+"-titlediv"));if(this._isMediaSize("Phone")){if($.hasClass("sapMObjectNumberBelowTitle")){o.setTextAlign(p?d.Left:d.Right);$.removeClass("sapMObjectNumberBelowTitle");m.removeClass("sapMOHRTitleDivFull");}var n=$.parent().width()*0.4;if($.outerWidth()>n){o.setTextAlign(p?d.Right:d.Left);$.addClass("sapMObjectNumberBelowTitle");m.addClass("sapMOHRTitleDivFull");}}}};
k.prototype._adjustIntroDiv=function(){var i=this.getId();var $=q(document.getElementById(i+"-txt"));var m=q(document.getElementById(i+"-titleArrow"));var n=q(document.getElementById(i+"-intro"));if(n.parent().hasClass("sapMOHRIntroMargin")){n.parent().removeClass("sapMOHRIntroMargin");}if(m.height()!==null&&($.height()<m.height())){n.parent().addClass("sapMOHRIntroMargin");}};
k._escapeId=function(i){return i?"#"+i.replace(/(:|\.)/g,'\\$1'):"";};
k.prototype._hasBottomContent=function(){return(this._hasAttributes()||this._hasStatus()||this._hasMarkers());};
k.prototype._hasIcon=function(){return!!this.getIcon().trim();};
k.prototype._hasAttributes=function(){var m=this.getAttributes();if(m&&m.length>0){for(var i=0;i<m.length;i++){if(!m[i]._isEmpty()){return true;}}}return false;};
k.prototype._hasStatus=function(){var H=((this.getFirstStatus()&&!this.getFirstStatus()._isEmpty())||(this.getSecondStatus()&&!this.getSecondStatus()._isEmpty()));if(!H&&this.getStatuses()&&this.getStatuses().length>0){var s=this.getStatuses();for(var i=0;i<s.length;i++){if(s[i]instanceof sap.m.ObjectStatus&&!s[i]._isEmpty()){H=true;break;}else if(s[i]instanceof sap.m.ProgressIndicator){H=true;break;}}}return H;};
k.prototype._hasMarkers=function(){var m=this.getMarkers(),H=this.getShowMarkers()&&(this.getMarkFavorite()||this.getMarkFlagged()),i=m&&m.length;return(H||i);};
k.prototype._getDefaultBackgroundDesign=function(){if(this.getCondensed()){return B.Solid;}else{if(this.getResponsive()){return B.Translucent;}else{return B.Transparent;}}};
k.prototype._getBackground=function(){if(this.getBackgroundDesign()===undefined){return this._getDefaultBackgroundDesign();}else{return this.getBackgroundDesign();}};
k.prototype._setTextAlignANum=function(t){var n=this.getAdditionalNumbers();for(var i=0;i<n.length;i++){n[i].setTextAlign(t);}};
k.prototype._isMediaSize=function(r){return this._getCurrentMediaContainerRange(D.media.RANGESETS.SAP_STANDARD).name===r;};
return k;});
sap.ui.predefine('sap/m/ObjectHeaderRenderer',['sap/ui/core/Control','sap/ui/core/library','sap/m/library','sap/ui/Device',"sap/base/Log",'sap/m/Link','sap/m/Text',"sap/ui/thirdparty/jquery","sap/ui/util/defaultLinkTypes"],function(C,c,l,D,L,a,T,q,d){"use strict";var b=c.TextDirection;var B=l.BackgroundDesign;var e=c.TitleLevel;var O={apiVersion:2};
O._isEmptyObject=function(o){if(!o){return true;}if((!o._isEmpty||!o._isEmpty())&&(!o.getVisible||o.getVisible())){return false;}return true;};
O._isEmptyArray=function(A){if(A){for(var i=0;i<A.length;i++){if(!O._isEmptyObject(A[i])){return false;}}}return true;};
O._isEmptyRow=function(o,r){return O._isEmptyObject(o)&&O._isEmptyArray(r);};
O._renderObjects=function(r,o,f){for(var i=0;i<o.length;i++){if(o[i]instanceof C){this._renderChildControl(r,f,o[i]);}}};
O._computeChildControlsToBeRendered=function(o){o.__controlsToBeRendered={};var f=o.getAttributes();for(var i=0;i<f.length;i++){o.__controlsToBeRendered[f[i].getId()]=f[i];}f=o.getStatuses();for(var i=0;i<f.length;i++){o.__controlsToBeRendered[f[i].getId()]=f[i];}var g=o.getFirstStatus();if(g){o.__controlsToBeRendered[g.getId()]=g;}g=o.getSecondStatus();if(g){o.__controlsToBeRendered[g.getId()]=g;}g=o.getAggregation("_objectNumber");if(g){o.__controlsToBeRendered[g.getId()]=g;}};
O._cleanupNotRenderedChildControls=function(r,o){for(var i in o.__controlsToBeRendered){r.cleanupControlWithoutRendering(o.__controlsToBeRendered[i]);}delete o.__controlsToBeRendered;};
O._getMarkers=function(o){return o._getVisibleMarkers();};
O._renderIntro=function(r,o,i,I){if(o.getIntroActive()){o._introText=new a(o.getId()+"-intro");o._introText.setText(o.getIntro());o._introText.setHref(o.getIntroHref());o._introText.setTarget(o.getIntroTarget());o._introText.press=o.introPress;}else{o._introText=new T(o.getId()+"-intro");o._introText.setText(o.getIntro());o._introText.setMaxLines(3);}o._introText.setTextDirection(o.getIntroTextDirection());r.openStart("div");r.class(i);if(o.getIntroActive()){r.class(I);}r.openEnd();this._renderChildControl(r,o,o._introText);r.close("div");};
O._renderAttribute=function(r,o,A,f){r.openStart("div");r.class("sapMOHAttr");if(f){r.style("width","100%");}r.openEnd();this._renderChildControl(r,o,A);r.close("div");};
O._getVisibleStatuses=function(o){var v=[];if(o.getFirstStatus()&&o.getFirstStatus().getVisible()){v.push([o.getFirstStatus()]);}if(o.getSecondStatus()&&o.getSecondStatus().getVisible()){v.push([o.getSecondStatus()]);}if(o.getStatuses()){var s=o.getStatuses();for(var i=0;i<s.length;i++){if(!s[i].getVisible||s[i].getVisible()){if((s[i]instanceof sap.m.ObjectStatus&&!s[i]._isEmpty())||s[i]instanceof sap.m.ProgressIndicator){v.push([s[i]]);}else{L.warning("Only sap.m.ObjectStatus or sap.m.ProgressIndicator are allowed in \"sap.m.ObjectHeader.statuses\" aggregation."+" Current object is "+s[i].constructor.getMetadata().getName()+" with id \""+s[i].getId()+"\"");}}}}return v;};
O._getVisibleAttribsAndStatuses=function(o){var r=[],A=o.getAttributes(),v=[];for(var j=0;j<A.length;j++){if(A[j].getVisible()&&!A[j]._isEmpty()){v.push(A[j]);}}var V=this._getVisibleStatuses(o);r[0]=v;r[1]=V;return r;};
O._renderRow=function(r,o,f,R){if(O._isEmptyRow(f,R)){return;}r.openStart("div");r.class("sapMOHAttrRow");r.openEnd();if(!O._isEmptyObject(f)){this._renderAttribute(r,o,f,O._isEmptyArray(R));}else if(O._isEmptyObject(f)&&!O._isEmptyArray(R)){if(R[0]instanceof sap.m.ProgressIndicator){r.openStart("div");r.class("sapMOHAttr");r.openEnd();r.close("div");}}if(!O._isEmptyArray(R)){r.openStart("div");if(R[0]instanceof sap.m.ProgressIndicator){r.class("sapMOHStatusFixedWidth");}else if(R[0]instanceof sap.m.ObjectMarker){r.class("sapMOHStatusFixedWidth");r.class("sapMObjStatusMarker");}else{r.class("sapMOHStatus");}r.openEnd();O._renderObjects(r,R,o);r.close("div");}r.close("div");};
O._renderAttributesAndStatuses=function(r,o){var A=o.getAttributes();var v=[];for(var j=0;j<A.length;j++){if(A[j].getVisible()){v.push(A[j]);}}var i=v.length;var m=[];var M=O._getMarkers(o);if(!o.getResponsive()&&!O._isEmptyArray(M)){m.push(M);}var V=this._getVisibleStatuses(o);m=m.concat(V);var f=m.length;var n=i>f?i:f;if(!o.getResponsive()){for(var g=0;g<n;g++){this._renderRow(r,o,v[g],m[g]);}}};
O._renderNumber=function(r,o){var n=o.getAdditionalNumbers();if(!o.getNumber()&&(n&&!n.length)){return;}r.openStart("div",o.getId()+"-numberdiv");r.class("sapMOHNumberDiv");r.openEnd();var f=o.getAggregation("_objectNumber");if(f&&f.getNumber()){f.setTextDirection(o.getNumberTextDirection());this._renderChildControl(r,o,f);}r.close("div");if(!o.getCondensed()){this._renderAdditionalNumbers(r,o);}};
O._renderAdditionalNumbers=function(r,o){var n=o.getAdditionalNumbers();if(n&&!n.length){return;}if(n.length===1){r.openStart("div");r.class("additionalOHNumberSeparatorDiv");r.openEnd();r.close("div");}for(var i=0;i<n.length;i++){r.openStart("div",o.getId()+"-additionalNumber"+i);r.class("sapMOHNumberDiv");r.class("additionalOHNumberDiv");if(n.length===1){r.class("sapMOHOnlyANumber");}r.openEnd();n[i].setTextDirection(o.getNumberTextDirection());this._renderChildControl(r,o,n[i]);r.close("div");}};
O._renderTitle=function(r,o){o._oTitleArrowIcon.setVisible(o.getShowTitleSelector());if(o.getShowTitleSelector()&&o._oTitleArrowIcon.getVisible()){r.openStart("div");r.class("sapMOHTitleAndArrow");r.openEnd();}if(o.getTitle()){var t=(o.getTitleLevel()===e.Auto)?e.H1:o.getTitleLevel();t=t.toLowerCase();o._titleText.setText(o.getTitle());o._titleText.setTextDirection(o.getTitleTextDirection());if(o.getTitleActive()){r.openStart("a",o.getId()+"-title");if(o.getTitleHref()){r.attr("href",o.getTitleHref());if(o.getTitleTarget()){r.attr("target",o.getTitleTarget());r.attr("rel",d('',o.getTitleTarget()));}}r.accessibilityState({role:"link"});}else{r.openStart("div",o.getId()+"-title");}r.class("sapMOHTitle");if(o.getTitleActive()){r.attr("tabindex","0");r.class("sapMOHTitleActive");}if(o.getShowTitleSelector()){r.class("sapMOHTitleFollowArrow");}r.openEnd();r.openStart(t);r.openEnd();this._renderChildControl(r,o,o._titleText);r.close(t);if(o.getTitleActive()){r.close("a");}else{r.close("div");}}if(o.getShowTitleSelector()){r.openStart("span");r.class("sapMOHTitleArrow");r.openEnd();this._renderChildControl(r,o,o._oTitleArrowIcon);r.close("span");}if(o.getShowTitleSelector()&&o._oTitleArrowIcon.getVisible()){r.close("div");}};
O._renderFullTitle=function(r,o){var n=o.getAdditionalNumbers();if(!o.getNumber()&&(n&&!n.length)){r.class("sapMOHTitleDivFull");}};
O._renderFullOH=function(r,o){if(o.getIntro()){this._renderIntro(r,o,"sapMOHIntro","sapMOHIntroActive");}r.openStart("div");r.class("sapMOHTopRow");r.openEnd();r.openStart("div",o.getId()+"-titlediv");r.class("sapMOHTitleDiv");if(o._hasIcon()){r.class("sapMOHTitleIcon");}this._renderFullTitle(r,o);r.openEnd();if(o._hasIcon()){r.openStart("div");r.class("sapMOHIcon");r.class('sapMOHIcon'+o.getImageShape());if(o.getIconActive()){r.class("sapMPointer");}r.openEnd();this._renderChildControl(r,o,o._getImageControl());r.close("div");}this._renderTitle(r,o);r.close("div");this._renderNumber(r,o);r.openStart("div");r.class("sapMOHDivider");r.openEnd();r.close("div");r.close("div");if(o._hasBottomContent()){r.openStart("div");r.class("sapMOHBottomRow");r.openEnd();this._renderAttributesAndStatuses(r,o);r.openStart("div");r.class("sapMOHDivider");r.openEnd();r.close("div");r.close("div");}};
O._renderCondensedOH=function(r,o){r.openStart("div",o.getId()+"-titlediv");r.class("sapMOHTitleDiv");this._renderFullTitle(r,o);r.openEnd();this._renderTitle(r,o);r.close("div");this._renderNumber(r,o);var f=o.getAttributes()[0];if(f&&!f._isEmpty()){this._renderAttribute(r,o,f);}};
O.render=function(r,o){if(o.getResponsive()){this._renderResponsive(r,o);return;}this._computeChildControlsToBeRendered(o);var f=o.getCondensed();r.openStart("div",o);r.openEnd();r.openStart("div");r.class("sapMOH");if(o._getBackground()!==B.Transparent){r.class("sapContrastPlus");}if(f){r.class("sapMOHC");}r.class("sapMOHBg"+o._getBackground());var t=o.getTooltip_AsString();if(t){r.attr("title",t);}var A={role:"region"};if(o.getTitle()){A.labelledby={value:o.getId()+"-titleText-inner",append:true};}r.accessibilityState(o,A);r.openEnd();if(f){this._renderCondensedOH(r,o);}else{this._renderFullOH(r,o);}r.openStart("div");r.class("sapMOHLastDivider");r.openEnd();r.close("div");r.close("div");r.close("div");this._cleanupNotRenderedChildControls(r,o);};
O._renderChildControl=function(r,o,f){r.renderControl(f);if(!o.getResponsive()&&o.__controlsToBeRendered){o.__controlsToBeRendered[f.getId()]=undefined;}};
O._renderResponsive=function(r,o){var s=this._hasResponsiveStates(o),t=this._hasResponsiveTabs(o),h=o.getHeaderContainer();r.openStart("div",o);r.class("sapMOHROuter");var f=o.getTooltip_AsString();if(f){r.attr("title",f);}r.accessibilityState({role:"region",labelledby:{value:o.getId()+"-txt",append:true}});r.openEnd();r.openStart("div");r.class("sapMOHR");if(o._getBackground()!==B.Transparent){r.class("sapContrastPlus");}if(t){r.class("sapMOHRNoBorder");}r.class("sapMOHRBg"+o._getBackground());r.openEnd();r.openStart("div");if(D.system.desktop&&o._isMediaSize("Desktop")&&o.getFullScreenOptimized()&&o._iCountVisAttrStat>=1&&o._iCountVisAttrStat<=3){r.class("sapMOHRStatesOneOrThree");}r.openEnd();this._renderResponsiveTitleBlock(r,o);if(s){this._renderResponsiveStates(r,o);}r.close("div");if(t){this._renderResponsiveTabs(r,o);}r.close("div");if(h&&h instanceof sap.m.IconTabBar){this._renderChildControl(r,o,h);}r.close("div");if(!o.getTitle()){if(!o.getBinding("title")){L.warning("The title shouldn't be empty!");}}};
O._renderResponsiveTitleBlock=function(r,o){r.openStart("div",o.getId()+"-titlenumdiv");r.class("sapMOHRTitleNumberDiv");r.openEnd();r.openStart("div",o.getId()+"-titlediv");r.class("sapMOHRTitleDiv");if(o._hasIcon()){if(D.system.phone||o._isMediaSize("Phone")){if(D.orientation.landscape||(o._isMediaSize("Phone")&&!D.system.phone)){r.class("sapMOHRTitleIcon");}}else{r.class("sapMOHRTitleIcon");}}if(!o.getNumber()){r.class("sapMOHRTitleDivFull");}r.openEnd();this._renderResponsiveTitle(r,o);if(o._hasIcon()){r.openStart("div",o.getId()+"-titleIcon");r.class("sapMOHRIcon");r.class('sapMOHRIcon'+o.getImageShape());if((D.system.phone&&D.orientation.portrait)){r.class("sapMOHRHideIcon");}if(o.getIconActive()){r.class("sapMPointer");}r.openEnd();this._renderChildControl(r,o,o._getImageControl());r.close("div");}r.close("div");this._renderResponsiveNumber(r,o);r.close("div");};
O._renderResponsiveStates=function(r,o){r.openStart("div",o.getId()+"-states");r.class("sapMOHRStates");r.openEnd();this._renderResponsiveRow(r,o);r.close("div");};
O._renderResponsiveRow=function(r,o){var v=[];v=this._getVisibleAttribsAndStatuses(o);var V=v[0].concat(v[1]),i=v[0].length,f=V.length,R=1,s='';if(f===0){return;}if(D.system.desktop){if(!o.getFullScreenOptimized()){if(f>=1&&f<=4){R=2;s='sapMOHRTwoCols';}if(f>=5){R=3;s='sapMOHRThreeCols';}}else{if(f>=1&&f<=3){R=1;s='sapMOHROneCols';}if(f>=4){R=4;s='sapMOHRFourCols';}}}if((D.system.tablet&&!D.system.desktop)||(D.system.desktop&&o._isMediaSize("Tablet"))){if(!o.getFullScreenOptimized()||(D.orientation.portrait&&o.getFullScreenOptimized())){R=2;s='sapMOHRTwoCols';}else{if(o.getFullScreenOptimized()&&(D.orientation.landscape||(D.system.desktop&&o._isMediaSize("Tablet")))){if(f>=1&&f<=2){R=2;s='sapMOHRTwoCols';}if(f>=3){R=3;s='sapMOHRThreeCols';}}}}if(D.system.phone||(D.system.desktop&&o._isMediaSize("Phone"))){R=1;s='sapMOHROneCols';}this._renderResponsiveStatesColumn(r,o,R,V,i,s);};
O._renderResponsiveStatesColumn=function(r,o,R,v,f,s){var g=Math.floor(v.length/R);var h=v.length%R;var j=0;var k=1;for(var i=0;i<v.length;i++){if(j==0){r.openStart("div");r.class("sapMOHRStatesCont"+k);r.class(s);r.openEnd();}if(i<f){this._renderResponsiveAttribute(r,o,v[i]);}else{this._renderResponsiveStatus(r,o,v[i]);}j++;if((j==g&&k>h)||(j==(g+1)&&k<=h)||i==v.length-1){r.close("div");j=0;k++;}}};
O._renderResponsiveAttribute=function(r,o,A){r.openStart("div");r.class("sapMOHRAttr");r.openEnd();this._renderChildControl(r,o,A);r.close("div");};
O._renderResponsiveStatus=function(r,o,s){r.openStart("div");r.class("sapMOHRStatus");r.openEnd();this._renderChildControl(r,o,s[0]);r.close("div");};
O._renderResponsiveMarkers=function(r,o){var m=[],t=o.getTitleTextDirection(),p=sap.ui.getCore().getConfiguration().getRTL();m=o._getVisibleMarkers();r.openStart("span",o.getId()+"-markers");r.class("sapMObjStatusMarker");if((t===b.LTR&&p)||(t===b.RTL&&!p)){r.class("sapMObjStatusMarkerOpposite");}r.openEnd();for(var i=0;i<m.length;i++){this._renderChildControl(r,o,m[i]);}r.close("span");};
O._renderResponsiveNumber=function(r,o){var f=o.getAggregation("_objectNumber");if(f&&f.getNumber()){f.setTextDirection(o.getNumberTextDirection());this._renderChildControl(r,o,f);}};
O._hasResponsiveStates=function(o){var A=o.getAttributes(),v=[];if(!(o._hasAttributes()||o._hasStatus())){o._iCountVisAttrStat=0;return false;}for(var j=0;j<A.length;j++){if(A[j].getVisible()){v.push(A[j]);}}var V=this._getVisibleStatuses(o);o._iCountVisAttrStat=v.length+V.length;return!!(v.length+V.length);};
O._hasResponsiveTabs=function(o){var h=o.getHeaderContainer(),i;if(h){if(h instanceof sap.m.IconTabBar){i=h._getIconTabHeader();if(i.getVisible()){o._iCountVisTabs=i.getItems().length;return!!i.getItems().length;}}else if(h.getMetadata().getName()==="sap.m.HeaderContainer"){return!!h.getContent().length;}else if(h.getMetadata().getName()==="sap.suite.ui.commons.HeaderContainer"){return!!h.getItems().length;}}return false;};
O._renderResponsiveTabs=function(r,o){var h=o.getHeaderContainer(),i;r.openStart("div");r.class("sapMOHRTabs");if(h instanceof sap.m.IconTabBar){r.class("sapMOHRTabsITB");}r.openEnd();if(h){if(h instanceof sap.m.IconTabBar){i=h._getIconTabHeader();this._renderChildControl(r,o,i);h._bHideHeader=true;}else if(h.getMetadata().getName()==="sap.m.HeaderContainer"||h.getMetadata().getName()==="sap.suite.ui.commons.HeaderContainer"){this._renderChildControl(r,o,h);}else{L.warning("The control "+h+" is not supported for aggregation \"headerContainer\"");}}r.close("div");};
O._renderResponsiveTitle=function(r,o){var n;o._oTitleArrowIcon.setVisible(o.getShowTitleSelector());r.openStart("div",o.getId()+"-title");r.class("sapMOHRTitle");if(o.getTitle().length&&o.getTitleActive()){r.class("sapMOHRTitleActive");}if(o.getShowTitleSelector()){r.class("sapMOHRTitleFollowArrow");}r.openEnd();if((D.system.phone&&D.orientation.portrait)){n=50;}else{n=80;}r.openStart("div",o.getId()+"-title-arrow");r.style("display","inline-block");r.openEnd();this._renderResponsiveTitleAndArrow(r,o,n);r.close("div");if(o.getIntro()){this._renderIntro(r,o,"sapMOHRIntro","sapMOHRIntroActive");}r.close("div");};
O._rerenderTitle=function(r,o,n){var i=o.getId();this._renderResponsiveTitleAndArrow(r,o,n);r.flush(q(document.getElementById(i+"-title-arrow")));};
O._renderResponsiveTitleAndArrow=function(r,o,n){var s,E='',t=o.getTitleTextDirection();var m=!!o._getVisibleMarkers().length;var f=(o.getTitleLevel()===e.Auto)?e.H1:o.getTitleLevel();f=f.toLowerCase();r.openStart(f);r.openEnd();r.openStart("span");r.class("sapMOHRTitleTextContainer");if(t!=b.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();if(o.getTitle().length&&o.getTitleActive()){r.openStart("a",o.getId()+"-txt");if(o.getTitleHref()){r.attr("href",o.getTitleHref());if(o.getTitleTarget()){r.attr("target",o.getTitleTarget());r.attr("rel",d('',o.getTitleTarget()));}}r.attr("tabindex","0");r.accessibilityState({role:"link"});}else{r.openStart("span",o.getId()+"-txt");}r.class("sapMOHRTitleText");r.openEnd();r.openStart("span",o.getId()+"-titletxtwrap");r.class("sapMOHRTitleTextWrappable");r.openEnd();if(o.getTitle().length>n){s=o.getTitle().substr(0,n).trim();E='...';}else{s=o.getTitle();}if(m){var g=s.substr(s.lastIndexOf(" ")+1);var h=s.substr(0,s.lastIndexOf(" ")+1);if(g.length===1){g=s;h='';}r.text(h);r.close("span");r.text(g);r.text(E);if(o.getTitleActive()){r.close("a");}else{r.close("span");}this._renderResponsiveMarkers(r,o);r.close("span");}else{if(!E){r.text(s);}else{r.text(s+E);}if(o.getTitleActive()){r.close("span");r.close("a");r.close("span");}else{r.close("span");r.close("span");r.close("span");}}if(o.getShowTitleSelector()){r.openStart("span");r.class("sapMOHRTitleArrow");r.openEnd();this._renderChildControl(r,o,o._oTitleArrowIcon);r.close("span");}r.close(f);};
O._rerenderResponsiveStates=function(r,o){var i=o.getId(),v=this._getVisibleAttribsAndStatuses(o),V=v[0].concat(v[1]),f=v[0].length,g=V.length,R=1,s='';if(g===0){return;}if(D.orientation.portrait){R=2;s='sapMOHRTwoCols';}else{if(g>=1&&g<=2){R=2;s='sapMOHRTwoCols';}if(g>=3){R=3;s='sapMOHRThreeCols';}}this._renderResponsiveStatesColumn(r,o,R,V,f,s);r.flush(q(document.getElementById(i+"-states"))[0]);};
return O;},true);
sap.ui.predefine('sap/m/ObjectIdentifier',['./library','./Link','./Text','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/InvisibleText','sap/ui/core/library','sap/ui/Device','sap/ui/base/ManagedObject','./ObjectIdentifierRenderer',"sap/ui/events/KeyCodes"],function(l,L,T,C,I,a,c,D,M,O,K){"use strict";var b=c.TextDirection;var E=l.EmptyIndicatorMode;
var d=C.extend("sap.m.ObjectIdentifier",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectIdentifier.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},badgeNotes:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},badgePeople:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},badgeAttachments:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},visible:{type:"boolean",group:"Appearance",defaultValue:true},titleActive:{type:"boolean",group:"Misc",defaultValue:false},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:b.Inherit},emptyIndicatorMode:{type:"sap.m.EmptyIndicatorMode",group:"Appearance",defaultValue:E.Off}},aggregations:{_titleControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_textControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{titlePress:{parameters:{domRef:{type:"object"}}}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},dnd:{draggable:true,droppable:false}}});
d.prototype.init=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(sap.ui.getCore().getConfiguration().getAccessibility()){d.OI_ARIA_ROLE=o.getText("OI_ARIA_ROLE");}};
d.prototype.exit=function(){if(this._attachmentsIcon){this._attachmentsIcon.destroy();this._attachmentsIcon=null;}if(this._peopleIcon){this._peopleIcon.destroy();this._peopleIcon=null;}if(this._notesIcon){this._notesIcon.destroy();this._notesIcon=null;}};
d.prototype._getAttachmentsIcon=function(){if(!this._attachmentsIcon){this._attachmentsIcon=this._getIcon(I.getIconURI("attachment"),this.getId()+"-attachments");}return this._attachmentsIcon;};
d.prototype._getPeopleIcon=function(){if(!this._peopleIcon){this._peopleIcon=this._getIcon(I.getIconURI("group"),this.getId()+"-people");}return this._peopleIcon;};
d.prototype._getNotesIcon=function(){if(!this._notesIcon){this._notesIcon=this._getIcon(I.getIconURI("notes"),this.getId()+"-notes");}return this._notesIcon;};
d.prototype._getIcon=function(u,i){var s=D.system.phone?"1em":"1em";var o;o=this._icon||I.createControlByURI({src:u,id:i+"-icon",size:s,useIconTooltip:false},sap.m.Image);o.setSrc(u);return o;};
d.prototype._getTitleControl=function(){var t=this.getAggregation("_titleControl"),i=this.getId(),s=M.escapeSettingsValue(this.getProperty("title"));if(!t){if(this.getProperty("titleActive")){t=new L({id:i+"-link",text:s,ariaLabelledBy:a.getStaticId("sap.m","OI_ARIA_ROLE")});t.addAssociation("ariaLabelledBy",i+"-text",true);}else{t=new T({id:i+"-txt",text:s});}this.setAggregation("_titleControl",t,true);}return t;};
d.prototype._getTextControl=function(){var t=this.getAggregation("_textControl");if(!t){t=new T({text:M.escapeSettingsValue(this.getProperty("text"))});this.setAggregation("_textControl",t,true);}t.setTextDirection(this.getTextDirection());return t;};
d.prototype.setTitle=function(t){if(t){this._getTitleControl().setProperty("text",t);}return this.setProperty("title",t);};
d.prototype.setText=function(t){if(t){this._getTextControl().setProperty("text",t);}return this.setProperty("text",t);};
d.prototype.setTitleActive=function(v){var p=this.getTitleActive();this.setProperty("titleActive",v);if(p!=v){this.destroyAggregation("_titleControl");this._getTitleControl();}return this;};
d.prototype._handlePress=function(e){var o=e.target;if(this.getTitleActive()&&this.$("title")[0].firstChild==o){this.fireTitlePress({domRef:o});e.setMarked();}};
d.prototype.onsapenter=function(e){d.prototype._handlePress.apply(this,arguments);};
d.prototype.onkeyup=function(e){if(e&&e.which===K.SPACE){d.prototype._handlePress.apply(this,arguments);}};
d.prototype.ontap=function(e){d.prototype._handlePress.apply(this,arguments);};
d.prototype.addAssociation=function(A,i,s){var t=this.getAggregation("_titleControl");if(A==="ariaLabelledBy"){if(this.getTitleActive()&&t instanceof sap.m.Link){t.addAssociation("ariaLabelledBy",i,true);}}return C.prototype.addAssociation.apply(this,arguments);};
d.prototype.removeAssociation=function(A,o,s){var t=this.getAggregation("_titleControl");if(A==="ariaLabelledBy"){if(this.getTitleActive()&&t instanceof sap.m.Link){t.removeAssociation("ariaLabelledBy",o,true);}}return C.prototype.removeAssociation.apply(this,arguments);};
d.prototype.getAccessibilityInfo=function(){var t=this.getAggregation("_titleControl")?this.getAggregation("_titleControl").getAccessibilityInfo():{type:"",description:""},o=(d.OI_ARIA_ROLE+" "+(t.type||"")).trim();if(this.getTitle()||this.getText()){t.type=o;}t.description=t.description+" "+this.getText();return t;};
d.prototype._hasTopRow=function(){return this.getTitle()||this.getBadgeNotes()||this.getBadgePeople()||this.getBadgeAttachments();};
return d;});
sap.ui.predefine('sap/m/ObjectIdentifierRenderer',['./library','sap/ui/core/Core'],function(l,C){"use strict";var O={apiVersion:2};var E=l.EmptyIndicatorMode;var r=C.getLibraryResourceBundle("sap.m");
O.render=function(R,o){var t;if(!o.getVisible()){return;}R.openStart("div",o);R.class("sapMObjectIdentifier");t=o.getTooltip_AsString();if(t){R.attr("title",t);}R.openEnd();R.openStart("div");R.class("sapMObjectIdentifierTopRow");if(!o._hasTopRow()){R.style("display","none");}R.openEnd();R.openStart("div",o.getId()+"-title");R.class("sapMObjectIdentifierTitle");R.openEnd();if(o.getTitle()){R.renderControl(o._getTitleControl());}R.close("div");R.openStart("div");R.class("sapMObjectIdentifierIcons");R.openEnd();if(o.getBadgeAttachments()){R.openStart("span");R.class("sapMObjectIdentifierIconSpan");R.openEnd();R.renderControl(o._getAttachmentsIcon());R.close("span");}if(o.getBadgeNotes()){R.openStart("span");R.class("sapMObjectIdentifierIconSpan");R.openEnd();R.renderControl(o._getNotesIcon());R.close("span");}if(o.getBadgePeople()){R.openStart("span");R.class("sapMObjectIdentifierIconSpan");R.openEnd();R.renderControl(o._getPeopleIcon());R.close("span");}R.close("div");R.close("div");if(o.getEmptyIndicatorMode()!==E.Off&&!o.getText()){this.renderEmptyIndicator(R,o);}else{R.openStart("div",o.getId()+"-text");R.class("sapMObjectIdentifierText");if(o.getProperty("text")&&o.getProperty("title")){R.class("sapMObjectIdentifierTextBellow");}R.openEnd();if(o.getText()){R.renderControl(o._getTextControl());}R.close("div");}R.close("div");};
O.renderEmptyIndicator=function(R,o){R.openStart("span");R.class("sapMEmptyIndicator");if(o.getEmptyIndicatorMode()===E.Auto){R.class("sapMEmptyIndicatorAuto");}R.openEnd();R.openStart("span");R.attr("aria-hidden",true);R.openEnd();R.text(r.getText("EMPTY_INDICATOR"));R.close("span");R.openStart("span");R.class("sapUiPseudoInvisibleText");R.openEnd();R.text(r.getText("EMPTY_INDICATOR_TEXT"));R.close("span");R.close("span");};
return O;},true);
sap.ui.predefine('sap/m/ObjectListItem',['sap/ui/base/ManagedObjectObserver','./ListItemBase','./library','sap/ui/core/IconPool','sap/m/ObjectNumber','sap/ui/core/library','./ObjectMarker','./Text','./ObjectListItemRenderer'],function(M,L,l,I,O,c,a,T,b){"use strict";var d=l.ObjectMarkerType;var e=l.ImageHelper;var f=c.TextAlign;var g=c.TextDirection;var V=c.ValueState;
var h=L.extend("sap.m.ObjectListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},intro:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},markFavorite:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},markFlagged:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},showMarkers:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},numberState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},introTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},numberTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},markLocked:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},firstStatus:{type:"sap.m.ObjectStatus",multiple:false},secondStatus:{type:"sap.m.ObjectStatus",multiple:false},markers:{type:"sap.m.ObjectMarker",multiple:true,singularName:"marker"},_objectNumber:{type:"sap.m.ObjectNumber",multiple:false,visibility:"hidden"}},designtime:"sap/m/designtime/ObjectListItem.designtime",dnd:{draggable:true,droppable:true}}});
h.prototype.init=function(E){this._generateObjectNumber();this._observerObjectItemChanges=this._observerObjectItemChanges.bind(this);this._oItemsObservers={};};
h.prototype.exit=function(E){if(this._oImageControl){this._oImageControl.destroy();}if(this._oTitleText){this._oTitleText.destroy();this._oTitleText=undefined;}L.prototype.exit.apply(this);};
h.prototype.onAfterRendering=function(){var o=this.getAggregation("_objectNumber"),p=sap.ui.getCore().getConfiguration().getRTL(),t=p?f.Left:f.Right;if(o&&o.getNumber()){o.setTextAlign(t);}};
h.prototype._generateObjectNumber=function(){var n=this.getNumber(),N=this.getNumberUnit(),s=this.getNumberState(),t=this.getNumberTextDirection();this.setAggregation("_objectNumber",new O(this.getId()+"-ObjectNumber",{number:n,unit:N,state:s,textDirection:t}),true);};
h.prototype._hasAttributes=function(){var j=this.getAttributes();if(j.length>0){for(var i=0;i<j.length;i++){if(!j[i]._isEmpty()){return true;}}}return false;};
h.prototype._hasStatus=function(){return((this.getFirstStatus()&&!this.getFirstStatus()._isEmpty())||(this.getSecondStatus()&&!this.getSecondStatus()._isEmpty()));};
h.prototype._hasBottomContent=function(){return(this._hasAttributes()||this._hasStatus()||this.getShowMarkers()||this.getMarkLocked()||this._getVisibleMarkers().length>0);};
h.prototype._getVisibleAttributes=function(){var A=this.getAttributes();var v=[];for(var i=0;i<A.length;i++){if(A[i].getVisible()){v.push(A[i]);}}return v;};
h.prototype.addAttribute=function(o){this._startObservingItem(o);return L.prototype.addAggregation.call(this,"attributes",o);};
h.prototype.insertAttribute=function(o,i){this._startObservingItem(o);return L.prototype.insertAggregation.call(this,"attributes",o,i);};
h.prototype.removeAttribute=function(o){var i=L.prototype.removeAggregation.call(this,"attributes",o);this._stopObservingItem(i);return i;};
h.prototype.removeAllAttributes=function(){var j=L.prototype.removeAllAggregation.call(this,"attributes");for(var i=0;i<j.length;i++){this._stopObservingItem(j[i]);}return j;};
h.prototype.destroyAttributes=function(){this.getAttributes().forEach(function(A){this._stopObservingItem(A);},this);return L.prototype.destroyAggregation.call(this,"attributes");};
h.prototype._getVisibleMarkers=function(){var A=this.getMarkers();var v=[];for(var i=0;i<A.length;i++){if(A[i].getVisible()){v.push(A[i]);}}return v;};
h.prototype._getImageControl=function(){var i=this.getId()+'-img';var s="2.5rem";var p;if(I.isIconURI(this.getIcon())){p={src:this.getIcon(),height:s,width:s,size:s,useIconTooltip:false,densityAware:this.getIconDensityAware()};}else{p={src:this.getIcon(),useIconTooltip:false,densityAware:this.getIconDensityAware()};}var C=['sapMObjLIcon'];this._oImageControl=e.getImageControl(i,this._oImageControl,this,p,C);return this._oImageControl;};
h.prototype._activeHandlingInheritor=function(){var A=this.getActiveIcon();if(this._oImageControl&&A){this._oImageControl.setSrc(A);}};
h.prototype._inactiveHandlingInheritor=function(){var s=this.getIcon();if(this._oImageControl){this._oImageControl.setSrc(s);}};
h.prototype.setNumber=function(n){this.setProperty('number',n,true);this.getAggregation("_objectNumber").setNumber(n);return this;};
h.prototype.setNumberUnit=function(n){this.setProperty('numberUnit',n,true);this.getAggregation('_objectNumber').setUnit(n);return this;};
h.prototype.setNumberTextDirection=function(t){this.setProperty('numberTextDirection',t,true);this.getAggregation("_objectNumber").setTextDirection(t);return this;};
h.prototype.setNumberState=function(v){this.setProperty('numberState',v,true);this.getAggregation("_objectNumber").setState(v);return this;};
h.prototype.setMarkFavorite=function(m){return this._setOldMarkers(d.Favorite,m);};
h.prototype.setMarkFlagged=function(m){return this._setOldMarkers(d.Flagged,m);};
h.prototype.setMarkLocked=function(m){return this._setOldMarkers(d.Locked,m);};
h.prototype.setShowMarkers=function(m){var s;var A=this.getMarkers();this.setProperty("showMarkers",m,false);for(var i=0;i<A.length;i++){s=A[i].getType();if((s===d.Flagged&&this.getMarkFlagged())||(s===d.Favorite&&this.getMarkFavorite())||(s===d.Locked&&this.getMarkLocked())){A[i].setVisible(m);}}return this;};
h.prototype.addMarker=function(o){this._startObservingItem(o);return L.prototype.addAggregation.call(this,"markers",o);};
h.prototype.insertMarker=function(o,i){this._startObservingItem(o);return L.prototype.insertAggregation.call(this,"markers",o,i);};
h.prototype.removeMarker=function(o){var i=L.prototype.removeAggregation.call(this,"markers",o);this._stopObservingItem(i);return i;};
h.prototype.removeAllMarkers=function(){var j=L.prototype.removeAllAggregation.call(this,"markers");for(var i=0;i<j.length;i++){this._stopObservingItem(j[i]);}return j;};
h.prototype.destroyMarkers=function(){this.getMarkers().forEach(function(m){this._stopObservingItem(m);},this);return L.prototype.destroyAggregation.call(this,"markers");};
h.prototype._observerObjectItemChanges=function(C){if(C.current!==C.old){this.invalidate();}};
h.prototype._startObservingItem=function(i){var o=new M(this._observerObjectItemChanges);this._oItemsObservers[i.getId()]=o;o.observe(i,{properties:true});return this;};
h.prototype._stopObservingItem=function(i){var s=i.getId();this._oItemsObservers[s].disconnect();delete this._oItemsObservers[s];return this;};
h.prototype._setOldMarkers=function(m,j){var A=this.getMarkers();var H=false;var o={Flagged:"-flag",Favorite:"-favorite",Locked:"-lock"};this.setProperty("mark"+m,j,false);if(!this.getShowMarkers()){j=false;}for(var i=0;i<A.length;i++){if(A[i].getType()===m){H=true;A[i].setVisible(j);break;}}if(!H){this.insertAggregation("markers",new a({id:this.getId()+o[m],type:m,visible:j}));}return this;};
h.prototype._getTitleText=function(){if(!this._oTitleText){this._oTitleText=new T(this.getId()+"-titleText",{maxLines:2});this._oTitleText.setParent(this,null,true);}return this._oTitleText;};
return h;});
sap.ui.predefine('sap/m/ObjectListItemRenderer',['./ListItemBaseRenderer','sap/ui/core/Renderer','sap/ui/core/library','sap/ui/Device'],function(L,R,c,D){"use strict";var T=c.TextDirection;var O=R.extend(L);O.apiVersion=2;
O.renderAttributeStatus=function(r,l,a,s){if(!a&&!s||(a&&a._isEmpty()&&s&&s._isEmpty())){return;}r.openStart("div");r.class("sapMObjLAttrRow");r.openEnd();if(a&&!a._isEmpty()){r.openStart("div");r.class("sapMObjLAttrDiv");if(s&&(!s._isEmpty())){if(s instanceof Array){r.class("sapMObjAttrWithMarker");}}if(!s||s._isEmpty()){r.style("width","100%");}r.openEnd();r.renderControl(a);r.close("div");}if(s&&!s._isEmpty()){r.openStart("div");r.class("sapMObjLStatusDiv");if(s instanceof Array&&s.length>0){r.class("sapMObjStatusMarker");}if(!a||a._isEmpty()){r.style("width","100%");}r.openEnd();if(s instanceof Array){while(s.length>0){r.renderControl(s.shift());}}else{r.renderControl(s);}r.close("div");}r.close("div");};
O.renderLIAttributes=function(r,l){r.class("sapMObjLItem");r.class("sapMObjLListModeDiv");};
O.renderLIContent=function(r,l){var o=l.getAggregation("_objectNumber"),t=l.getTitleTextDirection(),i=l.getIntroTextDirection();if(l.getIntro()){r.openStart("div",l.getId()+"-intro");r.class("sapMObjLIntro");r.openEnd();r.openStart("span");if(i!==T.Inherit){r.attr("dir",i.toLowerCase());}r.openEnd();r.text(l.getIntro());r.close("span");r.close("div");}r.openStart("div");r.class("sapMObjLTopRow");r.openEnd();if(l.getIcon()){r.openStart("div");r.class("sapMObjLIconDiv");r.openEnd();r.renderControl(l._getImageControl());r.close("div");}r.openStart("div");r.class("sapMObjLNumberDiv");r.openEnd();if(o&&o.getNumber()){o.setTextDirection(l.getNumberTextDirection());r.renderControl(o);}r.close("div");r.openStart("div");r.style("display","-webkit-box");r.style("overflow","hidden");r.openEnd();var a=l._getTitleText();if(a){a.setTextDirection(t);a.setText(l.getTitle());a.addStyleClass("sapMObjLTitle");r.renderControl(a);}r.close("div");r.close("div");r.openStart("div");r.style("clear","both");r.openEnd();r.close("div");if(l._hasBottomContent()){r.openStart("div");r.class("sapMObjLBottomRow");r.openEnd();var A=l._getVisibleAttributes();var s=[];var m=l._getVisibleMarkers();m._isEmpty=function(){return!(m.length);};if(!m._isEmpty()){s.push(m);}s.push(l.getFirstStatus());s.push(l.getSecondStatus());while(A.length>0){this.renderAttributeStatus(r,l,A.shift(),s.shift());}while(s.length>0){this.renderAttributeStatus(r,l,null,s.shift());}r.close("div");}};
O.getAriaLabelledBy=function(l){var a=[],f=l.getFirstStatus(),s=l.getSecondStatus();if(l.getIntro()){a.push(l.getId()+"-intro");}if(l.getTitle()){a.push(l.getId()+"-titleText");}if(l.getNumber()){a.push(l.getId()+"-ObjectNumber");}if(l.getAttributes()){l.getAttributes().forEach(function(b){if(!b._isEmpty()){a.push(b.getId());}});}if(f&&!f._isEmpty()){a.push(f.getId());}if(s&&!s._isEmpty()){a.push(s.getId());}if(l.getMarkers()){l.getMarkers().forEach(function(m){a.push(m.getId()+"-text");});}return a.join(" ");};
return O;},true);
sap.ui.predefine('sap/m/ObjectMarker',["sap/ui/core/Control","sap/ui/core/Renderer","sap/ui/Device","sap/m/library","sap/ui/core/library","sap/ui/core/Icon","sap/m/TextRenderer","sap/m/Text","sap/m/LinkRenderer","sap/m/Link","./ObjectMarkerRenderer"],function(C,R,D,l,c,I,T,a,L,b,O){"use strict";var d=c.TextAlign;var e=l.ObjectMarkerVisibility;
var f=C.extend("sap.m.ObjectMarker",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectMarker.designtime",properties:{type:{type:"sap.m.ObjectMarkerType",group:"Misc"},visibility:{type:"sap.m.ObjectMarkerVisibility",group:"Misc"},additionalInfo:{type:"string",group:"Misc",defaultValue:""}},aggregations:{_innerControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{type:{type:"sap.m.ObjectMarkerType"}}},dnd:{draggable:true,droppable:false}}});
f.M_PREDEFINED_TYPES={Flagged:{icon:{src:"sap-icon://flag",visibility:{small:true,large:true}},text:{value:"OM_FLAG",visibility:{small:false,large:false}}},Favorite:{icon:{src:"sap-icon://favorite",visibility:{small:true,large:true}},text:{value:"OM_FAVORITE",visibility:{small:false,large:false}}},Draft:{icon:{src:"sap-icon://request",visibility:{small:false,large:false}},text:{value:"OM_DRAFT",visibility:{small:true,large:true}}},Locked:{icon:{src:"sap-icon://private",visibility:{small:true,large:true}},text:{value:"OM_LOCKED",visibility:{small:false,large:true}}},Unsaved:{icon:{src:"sap-icon://user-edit",visibility:{small:true,large:true}},text:{value:"OM_UNSAVED",visibility:{small:false,large:true}}},LockedBy:{icon:{src:"sap-icon://private",visibility:{small:true,large:true}},text:{value:"OM_LOCKED_BY",visibility:{small:false,large:true}}},UnsavedBy:{icon:{src:"sap-icon://user-edit",visibility:{small:true,large:true}},text:{value:"OM_UNSAVED_BY",visibility:{small:false,large:true}}}};
f.prototype.init=function(){D.media.initRangeSet("DeviceSet",[600],"px",["small","large"]);};
f.prototype.onAfterRendering=function(){this._attachMediaContainerWidthChange(this._handleMediaChange,this,"DeviceSet");};
f.prototype.onBeforeRendering=function(){this._cleanup();this._adjustControl(true);};
f.prototype.exit=function(){this._cleanup();};
f.prototype.attachPress=function(){var o=this._getInnerControl();Array.prototype.unshift.apply(arguments,["press"]);C.prototype.attachEvent.apply(this,arguments);if(this.hasListeners("press")&&o&&o instanceof h){o.destroy();this.setAggregation("_innerControl",this._createCustomLink(),true);this._adjustControl();}return this;};
f.prototype.detachPress=function(){var o=this._getInnerControl();Array.prototype.unshift.apply(arguments,["press"]);C.prototype.detachEvent.apply(this,arguments);if(!this.hasListeners("press")&&o&&o instanceof j){o.destroy();this.setAggregation("_innerControl",this._createCustomText(),true);this._adjustControl();}return this;};
f.prototype._cleanup=function(){this._detachMediaContainerWidthChange(this._handleMediaChange,this,"DeviceSet");};
f.prototype._handleMediaChange=function(){this._adjustControl();};
f.prototype._adjustControl=function(s){var t=f.M_PREDEFINED_TYPES[this.getType()],o=this._getInnerControl(),k=o&&o._getIconAggregation(),A=this.getAdditionalInfo(),m=this._isIconVisible(),n=this._isTextVisible(),p=m&&!n,q=this.getType(),r;if(!o){return false;}if(t){r=this._getMarkerText(t,q,A);}if(m){o.setIcon(t.icon.src,s);k.setDecorative(!p);if(n){k.setAlt(r);}k.setUseIconTooltip(false);this.addStyleClass("sapMObjectMarkerIcon");}else{o.setIcon(null,s);this.removeStyleClass("sapMObjectMarkerIcon");}if(n){o.setAggregation("tooltip",null,s);o.setText(r,s);this.addStyleClass("sapMObjectMarkerText");}else{if(k){o.setAggregation("tooltip",r,s);}o.setText(null,s);this.removeStyleClass("sapMObjectMarkerText");}o.removeAllAssociation("ariaLabelledBy",s);o.removeAllAssociation("ariaDescribedBy",s);this.getAriaLabelledBy().forEach(function(u){o.addAssociation("ariaLabelledBy",u,s);});this.getAriaDescribedBy().forEach(function(u){o.addAssociation("ariaDescribedBy",u,s);});return true;};
f.prototype._getMarkerText=function(t,s,A){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");switch(s){case"LockedBy":return(A==="")?r.getText('OM_LOCKED_BY_ANOTHER_USER'):r.getText('OM_LOCKED_BY',[A]);case"UnsavedBy":return(A==="")?r.getText('OM_UNSAVED_BY_ANOTHER_USER'):r.getText('OM_UNSAVED_BY',[A]);default:return(A==="")?r.getText(t.text.value):r.getText(t.text.value)+" "+A;}};
f.prototype._isIconVisible=function(){var t=f.M_PREDEFINED_TYPES[this.getType()],v=this.getVisibility(),s=this._getDeviceType(),k=t&&t.icon.visibility[s]||false;return v===e.IconOnly||v===e.IconAndText||(v!==e.TextOnly&&k);};
f.prototype._isTextVisible=function(){var t=f.M_PREDEFINED_TYPES[this.getType()],v=this.getVisibility(),s=this._getDeviceType(),k=t&&t.text.visibility[s]||false;return v===e.TextOnly||v===e.IconAndText||(v!==e.IconOnly&&k);};
f.prototype._getDeviceType=function(){return this._getCurrentMediaContainerRange("DeviceSet").name.toLowerCase();};
f.prototype._getInnerControl=function(){var o=this.getAggregation("_innerControl");if(!o&&this.getType()){o=this._createInnerControl();this.setAggregation("_innerControl",o,true);this._adjustControl(true);}return o;};
f.prototype._createInnerControl=function(){if(this.hasListeners("press")){return this._createCustomLink();}else{return this._createCustomText();}};
f.prototype._createCustomLink=function(){var o=new j(this.getId()+"-link",{wrapping:true});o.attachPress(function(E){this.firePress({type:this.getType()});},this);return o;};
f.prototype._createCustomText=function(){return new h(this.getId()+"-text",{textAlign:d.Initial});};
["getAccessibilityInfo"].map(function(F){var k=/^add/.test(F);f.prototype[F]=function(){var o=this._getInnerControl(),r;if(o&&o[F]){r=o[F].apply(o,arguments);}return k?this:r;};});var g=R.extend(T);g.apiVersion=2;
g.renderText=function(r,o){r.renderControl(o._getIconAggregation());T.renderText(r,o);};
var h=a.extend("sap.m.internal.ObjectMarkerCustomText",{
metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null}},aggregations:{_iconControl:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}}},
renderer:g
});
h.prototype.setIcon=function(s,S){var o=this._getIconAggregation();this.setProperty("icon",s,S);o.setSrc(s);return this;};
h.prototype._getIconAggregation=function(){var o=this.getAggregation("_iconControl");if(!o){o=new I();this.setAggregation("_iconControl",o,true);}return o;};
var i=R.extend(L);i.apiVersion=2;
i.renderText=function(r,o){r.renderControl(o._getIconAggregation());L.renderText(r,o);};
var j=b.extend("sap.m.internal.ObjectMarkerCustomLink",{
metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null}},aggregations:{_iconControl:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}}},
renderer:i
});
j.prototype.setIcon=function(s,S){var o=this._getIconAggregation();this.setProperty("icon",s,S);o.setSrc(s);return this;};
j.prototype._getTabindex=function(){return"0";};
j.prototype._getIconAggregation=function(){var o=this.getAggregation("_iconControl");if(!o){o=new I();this.setAggregation("_iconControl",o,true);}return o;};
j.prototype._determineSelfReferencePresence=function(){if(this.getIcon()&&!this.getText()){return false;}else{return b.prototype._determineSelfReferencePresence.apply(this,arguments);}};
return f;});
sap.ui.predefine('sap/m/ObjectMarkerRenderer',[],function(){"use strict";var O={apiVersion:2};
O.render=function(r,c){r.openStart("span",c);r.class("sapMObjectMarker");r.openEnd();r.renderControl(c._getInnerControl());r.close("span");};
return O;},true);
sap.ui.predefine('sap/m/ObjectNumber',['./library','sap/ui/core/Control','sap/ui/core/Renderer','sap/ui/core/library',"sap/ui/core/LabelEnablement","sap/ui/events/KeyCodes",'./ObjectNumberRenderer'],function(l,C,R,c,L,K,O){"use strict";var T=c.TextAlign;var a=c.TextDirection;var V=c.ValueState;var E=l.EmptyIndicatorMode;
var b=C.extend("sap.m.ObjectNumber",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/ObjectNumber.designtime",properties:{number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null,deprecated:true},emphasized:{type:"boolean",group:"Appearance",defaultValue:true},state:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},unit:{type:"string",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:a.Inherit},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin},active:{type:"boolean",group:"Misc",defaultValue:false},inverted:{type:"boolean",group:"Misc",defaultValue:false},emptyIndicatorMode:{type:"sap.m.EmptyIndicatorMode",group:"Appearance",defaultValue:E.Off}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{press:{}},dnd:{draggable:true,droppable:false}}});
b.prototype._getStateText=function(){var s=this.getState(),r=sap.ui.getCore().getLibraryResourceBundle("sap.m");return r.getText("OBJECTNUMBER_ARIA_VALUE_STATE_"+s.toUpperCase(),[],true);};
b.prototype.getAccessibilityInfo=function(){var s="";if(this.getState()!==V.None){s=this._getStateText();}return{description:(this.getNumber()+" "+this.getUnit()+" "+s).trim()};};
b.prototype.ontap=function(e){if(this._isClickable(e)){this.firePress();}};
b.prototype.ontouchstart=function(e){if(this._isClickable(e)){e.setMarked();}};
b.prototype._activeState=function(){this.addStyleClass("sapMObjectNumberPressed");};
b.prototype._inactiveState=function(){this.removeStyleClass("sapMObjectNumberPressed");};
b.prototype.onkeydown=function(e){if(e.which===K.SPACE||e.which===K.ENTER){e.setMarked();this._activeState();if(e.which===K.ENTER){this.firePress();}else{e.preventDefault();this._bPressedSpace=true;}}else if(this._bPressedSpace){if(e.which===K.SHIFT||e.which===K.ESCAPE){this._bPressedEscapeOrShift=true;this._inactiveState();}else{e.preventDefault();}}};
b.prototype.onkeyup=function(e){if(e.which===K.ENTER){e.setMarked();this._inactiveState();}else if(e.which===K.SPACE){if(!this._bPressedEscapeOrShift){e.setMarked();this.firePress();this._inactiveState();}else{this._bPressedEscapeOrShift=false;}this._bPressedSpace=false;}else if(e.which===K.ESCAPE){this._bPressedSpace=false;}};
b.prototype._isActive=function(){return this.getActive()&&(this.getNumber().trim()||this.getUnit().trim());};
b.prototype._isClickable=function(e){var s=e.target.id;return this._isActive()&&(s===this.getId()+"-link"||s===this.getId()+"-number"||s===this.getId()+"-unit");};
b.prototype._hasExternalLabelling=function(){return this.getAriaLabelledBy().length>0||L.getReferencingLabels(this).length>0;};
b.prototype._generateSelfLabellingIds=function(){var i=this.getId(),r="";if(this.getNumber()){r+=i+"-number ";}if(this.getUnit()){r+=i+"-unit ";}if(this.getEmphasized()){r+=i+"-emphasized ";}if(this.getState()!==V.None){r+=i+"-state";}return r.trim();};
return b;});
sap.ui.predefine('sap/m/ObjectNumberRenderer',['sap/ui/core/Renderer','sap/ui/core/library','./library','sap/ui/core/Core'],function(R,c,l,C){"use strict";var V=c.ValueState;var T=c.TextDirection;var _='sapMObjectNumberStatus';var E=l.EmptyIndicatorMode;var r=C.getLibraryResourceBundle("sap.m");var O={apiVersion:2};
O.render=function(o,a){var t=a.getTooltip_AsString(),s=a.getTextDirection(),b=a.getTextAlign(),A={role:"group",roledescription:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("OBJECTNUMBER_NAME")};o.openStart("div",a);o.class("sapMObjectNumber");if(a._isActive()){o.class("sapMObjectNumberActive");o.attr("tabindex","0");A.role="button";}o.class(_+a.getState());if(a.getEmphasized()){o.class("sapMObjectNumberEmph");}if(a.getInverted()){o.class("sapMObjectNumberInverted");}if(t){o.attr("title",t);}if(s!==T.Inherit){o.attr("dir",s.toLowerCase());}b=R.getTextAlign(b,s);if(b){o.style("text-align",b);}if(a._hasExternalLabelling()){A["labelledby"]={value:a._generateSelfLabellingIds(),append:true};}o.accessibilityState(a,A);o.openEnd();o.openStart("span",a.getId()+"-inner");o.class("sapMObjectNumberInner");o.openEnd();if(a.getEmptyIndicatorMode()!==E.Off&&!a.getNumber()){this.renderEmptyIndicator(o,a);}else{this.renderText(o,a);this.renderUnit(o,a);}o.close("span");this.renderEmphasizedInfoElement(o,a);this.renderHiddenARIAElement(o,a);o.close("div");};
O.renderText=function(o,a){var u=a.getUnit()||a.getNumberUnit();o.openStart("span",a.getId()+"-number");o.class("sapMObjectNumberText");o.openEnd();o.text(a.getNumber());if(u!==""){o.text(" ");}o.close("span");};
O.renderUnit=function(o,a){var u=a.getUnit()||a.getNumberUnit();if(u!==""){o.openStart("span",a.getId()+"-unit");o.class("sapMObjectNumberUnit");o.openEnd();o.text(u);o.close("span");}};
O.renderEmphasizedInfoElement=function(o,a){if(!a.getEmphasized()||!a.getNumber()){return;}o.openStart("span",a.getId()+"-emphasized");o.class("sapUiPseudoInvisibleText");o.openEnd();o.text(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("OBJECTNUMBER_EMPHASIZED"));o.close("span");};
O.renderHiddenARIAElement=function(o,a){if(a.getState()==V.None){return;}o.openStart("span",a.getId()+"-state");o.class("sapUiPseudoInvisibleText");o.openEnd();o.text(a._getStateText());o.close("span");};
O.renderEmptyIndicator=function(o,a){o.openStart("span");o.class("sapMEmptyIndicator");if(a.getEmptyIndicatorMode()===E.Auto){o.class("sapMEmptyIndicatorAuto");}o.openEnd();o.openStart("span");o.attr("aria-hidden",true);o.openEnd();o.text(r.getText("EMPTY_INDICATOR"));o.close("span");o.openStart("span");o.class("sapUiPseudoInvisibleText");o.openEnd();o.text(r.getText("EMPTY_INDICATOR_TEXT"));o.close("span");o.close("span");};
return O;},true);
sap.ui.predefine('sap/m/ObjectStatus',['./library','sap/ui/core/Control','sap/ui/core/ValueStateSupport','sap/ui/core/IndicationColorSupport','sap/ui/core/library','sap/ui/base/DataType','sap/ui/core/InvisibleText','./ObjectStatusRenderer'],function(l,C,V,I,c,D,a,O){"use strict";var b=l.ImageHelper;var T=c.TextDirection;var d=c.ValueState;var E=l.EmptyIndicatorMode;
var e=C.extend("sap.m.ObjectStatus",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/ObjectStatus.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},active:{type:"boolean",group:"Misc",defaultValue:false},state:{type:"string",group:"Misc",defaultValue:d.None},inverted:{type:"boolean",group:"Misc",defaultValue:false},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},emptyIndicatorMode:{type:"sap.m.EmptyIndicatorMode",group:"Appearance",defaultValue:E.Off}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{press:{}},dnd:{draggable:true,droppable:false}}});
e.prototype._getStateText=function(s){var S;if(s!==d.None){S=V.getAdditionalText(s)?V.getAdditionalText(s):I.getAdditionalText(s);}return S;};
e.prototype.exit=function(){if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}};
e.prototype._getImageControl=function(){var i=this.getId()+'-icon',f=!this.getText()&&!this.getTitle(),p={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};if(f){p.decorative=false;p.alt=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("OBJECT_STATUS_ICON");}this._oImageControl=b.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
e.prototype.setState=function(v){if(v==null){v=d.None;}else if(!D.getType("sap.ui.core.ValueState").isValid(v)&&!D.getType("sap.ui.core.IndicationColor").isValid(v)){throw new Error('"'+v+'" is not a value of the enums sap.ui.core.ValueState or sap.ui.core.IndicationColor for property "state" of '+this);}return this.setProperty("state",v);};
e.prototype.ontap=function(o){if(this._isClickable(o)){this.firePress();}};
e.prototype.onsapenter=function(o){if(this._isActive()){this.firePress();o.setMarked();}};
e.prototype.onsapspace=function(o){this.onsapenter(o);};
e.prototype._isActive=function(){return this.getActive()&&(this.getText().trim()||this.getIcon().trim());};
e.prototype._isEmpty=function(){return!(this.getText().trim()||this.getIcon().trim()||this.getTitle().trim());};
e.prototype.ontouchstart=function(o){if(this._isClickable(o)){o.setMarked();}};
e.prototype.getAccessibilityInfo=function(){var s=V.getAdditionalText(this.getState()),f;if(this.getState()!=d.None){s=(s!==null)?s:I.getAdditionalText(this.getState());}f=((this.getTitle()||"")+" "+(this.getText()||"")+" "+(s!==null?s:"")+" "+(this.getTooltip()||"")).trim();return{description:f+(f?" "+sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("OBJECT_STATUS"):"")};};
e.prototype._isClickable=function(o){var s=o.target.id;return this._isActive()&&(s===this.getId()+"-link"||s===this.getId()+"-text"||s===this.getId()+"-statusIcon"||s===this.getId()+"-icon");};
return e;});
sap.ui.predefine('sap/m/ObjectStatusRenderer',['sap/ui/core/ValueStateSupport','sap/ui/core/IndicationColorSupport','sap/ui/core/InvisibleText','sap/ui/core/library','./library','sap/ui/core/Core'],function(V,I,a,c,l,C){"use strict";var T=c.TextDirection;var E=l.EmptyIndicatorMode;var r=C.getLibraryResourceBundle("sap.m");var O={apiVersion:2};
O.render=function(R,o){R.openStart("div",o);if(o._isEmpty()&&o.getEmptyIndicatorMode()===E.Off){R.style("display","none");R.openEnd();}else{var s=o.getState(),S=o._getStateText(s),i=o.getInverted(),t=o.getTextDirection(),b=sap.ui.getCore(),p=b.getConfiguration().getRTL(),A={roledescription:b.getLibraryResourceBundle("sap.m").getText("OBJECT_STATUS")},d=o.getTooltip_AsString();if(t===T.Inherit){t=p?T.RTL:T.LTR;}if(d){R.attr("title",d);}R.class("sapMObjStatus");R.class("sapMObjStatus"+s);if(i){R.class("sapMObjStatusInverted");}if(o._isActive()){R.class("sapMObjStatusActive");R.attr("tabindex","0");A.role="button";}else{A.role="group";}var e=d&&o.getAriaDescribedBy().length,f;if(e){f=o.getId()+"-tooltip";A["describedby"]={value:f,append:true};}R.accessibilityState(o,A);R.openEnd();if(e){R.openStart("span",f);R.class("sapUiInvisibleText");R.openEnd();R.text(d);R.close("span");}if(o.getTitle()){R.openStart("span",o.getId()+"-title");R.class("sapMObjStatusTitle");if(t){R.attr("dir",t.toLowerCase());}R.attr("data-colon",C.getLibraryResourceBundle("sap.m").getText("LABEL_COLON"));R.openEnd();R.text(o.getTitle());R.close("span");}if(o._isActive()){R.openStart("span",o.getId()+"-link");R.class("sapMObjStatusLink");R.openEnd();}if(o.getIcon()){R.openStart("span",o.getId()+"-statusIcon");R.class("sapMObjStatusIcon");if(!o.getText()){R.class("sapMObjStatusIconOnly");}R.openEnd();R.renderControl(o._getImageControl());R.close("span");}if(o.getText()){R.openStart("span",o.getId()+"-text");R.class("sapMObjStatusText");if(t){R.attr("dir",t.toLowerCase());}R.openEnd();R.text(o.getText());R.close("span");}else if(o.getEmptyIndicatorMode()!==E.Off&&!o.getText()){this.renderEmptyIndicator(R,o);}if(o._isActive()){R.close("span");}if(S){R.openStart("span",o.getId()+"-state");R.class("sapUiPseudoInvisibleText");R.openEnd();R.text(S);R.close("span");}}R.close("div");};
O.renderEmptyIndicator=function(R,o){R.openStart("span");R.class("sapMEmptyIndicator");if(o.getEmptyIndicatorMode()===E.Auto){R.class("sapMEmptyIndicatorAuto");}R.openEnd();R.openStart("span");R.attr("aria-hidden",true);R.openEnd();R.text(r.getText("EMPTY_INDICATOR"));R.close("span");R.openStart("span");R.class("sapUiPseudoInvisibleText");R.openEnd();R.text(r.getText("EMPTY_INDICATOR_TEXT"));R.close("span");R.close("span");};
return O;},true);
sap.ui.predefine('sap/m/OverflowToolbar',["sap/ui/core/library","./library","sap/ui/core/Control","sap/m/ToggleButton","sap/ui/core/InvisibleText","sap/m/Toolbar","sap/m/ToolbarSpacer","sap/m/OverflowToolbarLayoutData","sap/m/OverflowToolbarAssociativePopover","sap/m/OverflowToolbarAssociativePopoverControls",'sap/ui/core/ResizeHandler',"sap/ui/core/IconPool",'sap/ui/core/theming/Parameters','sap/ui/dom/units/Rem',"sap/ui/Device","./OverflowToolbarRenderer","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Focusable"],function(c,l,C,T,I,a,b,O,d,e,R,f,P,D,g,h,L,q){"use strict";var j=l.PlacementType;var B=l.ButtonType;var A=c.aria.HasPopup;var k=l.OverflowToolbarPriority;
var m=a.extend("sap.m.OverflowToolbar",{metadata:{properties:{asyncMode:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{_overflowButton:{type:"sap.m.ToggleButton",multiple:false,visibility:"hidden"},_popover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"}},designtime:"sap/m/designtime/OverflowToolbar.designtime"}});
m.ARIA_ROLE_DESCRIPTION="OVERFLOW_TOOLBAR_ROLE_DESCRIPTION";m.CONTENT_SIZE_TOLERANCE=1;
m.prototype._callToolbarMethod=function(F,i){return a.prototype[F].apply(this,i);};
m.prototype.init=function(){this._callToolbarMethod("init",arguments);this._iPreviousToolbarWidth=null;this._bOverflowButtonNeeded=false;this._bListenForControlPropertyChanges=false;this._bListenForInvalidationEvents=false;this._bControlsInfoCached=false;this._bSkipOptimization=false;this._aControlSizes={};this._iFrameRequest=null;this._iOverflowToolbarButtonSize=0;this._oOverflowToolbarButtonClone=null;this._aMovableControls=[];this._aToolbarOnlyControls=[];this._aPopoverOnlyControls=[];this._aAllCollections=[this._aMovableControls,this._aToolbarOnlyControls,this._aPopoverOnlyControls];this.addStyleClass("sapMOTB");this._sAriaRoleDescription=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText(m.ARIA_ROLE_DESCRIPTION);this._fnMediaChangeRef=this._fnMediaChange.bind(this);g.media.attachHandler(this._fnMediaChangeRef);};
m.prototype.exit=function(){var p=this.getAggregation("_popover");if(p){p.destroy();}if(this._oOverflowToolbarButtonClone){this._oOverflowToolbarButtonClone.destroy();}if(this._iFrameRequest){window.cancelAnimationFrame(this._iFrameRequest);this._iFrameRequest=null;}g.media.detachHandler(this._fnMediaChangeRef);};
m.prototype.setAsyncMode=function(v){return this.setProperty("asyncMode",v,true);};
m.prototype.onAfterRendering=function(){this._bInvalidatedAndNotRendered=false;if(this._bContentVisibilityChanged){this._bControlsInfoCached=false;this._bContentVisibilityChanged=false;}if(this.getAsyncMode()){this._doLayoutAsync().then(this._applyFocus.bind(this));}else{this._doLayout();this._applyFocus();}};
m.prototype.onsapfocusleave=function(){this._resetChildControlFocusInfo();};
m.prototype.setWidth=function(w){this.setProperty("width",w);this._bResized=true;return this;};
m.prototype._doLayout=function(){var o=sap.ui.getCore(),w;if(!o.isThemeApplied()){L.debug("OverflowToolbar: theme not applied yet, skipping calculations",this);return;}this._recalculateOverflowButtonSize();w=this.$().is(":visible")?this.$().width():0;this._bListenForControlPropertyChanges=false;this._bListenForInvalidationEvents=false;this._deregisterToolbarResize();if(w>0){if(!this._isControlsInfoCached()||(this._bNeedUpdateOnControlsCachedSizes&&this._bResized)){this._cacheControlsInfo();}if(this._iPreviousToolbarWidth!==w){this._iPreviousToolbarWidth=w;this._setControlsOverflowAndShrinking(w);this.fireEvent("_controlWidthChanged");}}this._registerToolbarResize();this._bListenForControlPropertyChanges=true;this._bListenForInvalidationEvents=true;this._bResized=false;};
m.prototype._doLayoutAsync=function(){return new Promise(function(r,i){this._iFrameRequest=window.requestAnimationFrame(function(){this._doLayout();r();}.bind(this));}.bind(this));};
m.prototype._applyFocus=function(){var F,$=this.$().lastFocusableDomRef();if(this.sFocusedChildControlId){F=sap.ui.getCore().byId(this.sFocusedChildControlId);}if(F&&F.getDomRef()){F.focus();}else if(this._bControlWasFocused){this._getOverflowButton().focus();this._bControlWasFocused=false;this._bOverflowButtonWasFocused=true;}else if(this._bOverflowButtonWasFocused&&!this._getOverflowButtonNeeded()){$&&$.focus();this._bOverflowButtonWasFocused=false;}};
m.prototype._preserveChildControlFocusInfo=function(){var s=sap.ui.getCore().getCurrentFocusedControlId();if(this._getControlsIds().indexOf(s)!==-1){this._bControlWasFocused=true;this.sFocusedChildControlId=s;}else if(s===this._getOverflowButton().getId()){this._bOverflowButtonWasFocused=true;this.sFocusedChildControlId="";}};
m.prototype._resetChildControlFocusInfo=function(){this._bControlWasFocused=false;this._bOverflowButtonWasFocused=false;this.sFocusedChildControlId="";};
m.prototype._registerToolbarResize=function(){if(a.isRelativeWidth(this.getWidth())){var r=this._handleResize.bind(this);this._sResizeListenerId=R.register(this,r);}};
m.prototype._deregisterToolbarResize=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId="";}};
m.prototype._handleResize=function(){this._bResized=true;if(this._bInvalidatedAndNotRendered){return;}this._callDoLayout();};
m.prototype._fnMediaChange=function(){this._bControlsInfoCached=false;this._iPreviousToolbarWidth=null;this._callDoLayout();};
m.prototype._callDoLayout=function(){if(this.getAsyncMode()){this._doLayoutAsync();}else{this._doLayout();}};
m.prototype._cacheControlsInfo=function(){var v,H,i=parseInt(this.$().css("padding-right"))||0,r=parseInt(this.$().css("padding-left"))||0;this._iOldContentSize=this._iContentSize;this._iContentSize=0;this._bNeedUpdateOnControlsCachedSizes=false;this.getContent().forEach(this._updateControlsCachedSizes,this);if(g.system.phone){this._iContentSize-=1;}if(this._aPopoverOnlyControls.length){v=this._aPopoverOnlyControls.filter(function(o){return o.getVisible();});H=(v.length>0);if(H){this._iContentSize+=this._getOverflowButtonSize();}}this._bControlsInfoCached=true;if(this._iOldContentSize!==this._iContentSize){this.fireEvent("_contentSizeChange",{contentSize:this._iContentSize+i+r+1});}};
m.prototype._updateControlsCachedSizes=function(o){var p,i,w;p=this._getControlPriority(o);i=this._calculateControlSize(o);this._aControlSizes[o.getId()]=i;w=a.getOrigWidth(o.getId());if(w&&a.isRelativeWidth(w)){this._bNeedUpdateOnControlsCachedSizes=true;}if(p!==k.AlwaysOverflow){this._iContentSize+=i;}};
m.prototype._calculateControlSize=function(o){return this._getOptimalControlWidth(o,this._aControlSizes[o.getId()]);};
m.prototype._isControlsInfoCached=function(){return this._bControlsInfoCached;};
m.prototype._flushButtonsToPopover=function(){this._aButtonsToMoveToPopover.forEach(this._moveButtonToPopover,this);};
m.prototype._invalidateIfHashChanged=function(H){if(typeof H==="undefined"||this._getPopover()._getContentIdsHash()!==H){this._preserveChildControlFocusInfo();this.invalidate();}};
m.prototype._addOverflowButton=function(){if(!this._getOverflowButtonNeeded()){this._iCurrentContentSize+=this._getOverflowButtonSize();this._setOverflowButtonNeeded(true);}};
m.prototype._aggregateMovableControls=function(){var G={},i=[],n,p,s,o,r;this._aMovableControls.forEach(function(t){n=m._getControlGroup(t);p=m._oPriorityOrder;if(n){s=this._getControlPriority(t);o=this._getControlIndex(t);G[n]=G[n]||[];r=G[n];r.unshift(t);if(!r._priority||p[r._priority]<p[s]){r._priority=s;}if(!r._index||r._index<o){r._index=o;}}else{i.push(t);}},this);Object.keys(G).forEach(function(t){i.push(G[t]);});return i;};
m.prototype._extractControlsToMoveToOverflow=function(n,t){var i,M;for(i=0;i<n.length;i++){M=n[i];if(M.length){M.forEach(this._addToPopoverArrAndUpdateContentSize,this);}else{this._addToPopoverArrAndUpdateContentSize(M);}if(this._getControlPriority(M)!==k.Disappear){this._addOverflowButton();}if(this._iCurrentContentSize<=t){break;}}};
m.prototype._addToPopoverArrAndUpdateContentSize=function(o){this._aButtonsToMoveToPopover.unshift(o);this._iCurrentContentSize-=this._aControlSizes[o.getId()];};
m.prototype._sortByPriorityAndIndex=function(v,i){var p=m._oPriorityOrder,s=this._getControlPriority(v),n=this._getControlPriority(i),o=p[s]-p[n];if(o!==0){return o;}else{return this._getControlIndex(i)-this._getControlIndex(v);}};
m.prototype._setControlsOverflowAndShrinking=function(t){var i;this._iCurrentContentSize=this._iContentSize;this._aButtonsToMoveToPopover=[];if(this._bSkipOptimization){this._bSkipOptimization=false;}else{i=this._getPopover()._getContentIdsHash();}this._resetToolbar();this._collectPopoverOnlyControls();this._markControlsWithShrinkableLayoutData();if(this._iCurrentContentSize<=(t+m.CONTENT_SIZE_TOLERANCE)){this._flushButtonsToPopover();this._invalidateIfHashChanged(i);return;}this._moveControlsToPopover(t);this._flushButtonsToPopover();if(this._iCurrentContentSize>t){this._checkContents();}this._invalidateIfHashChanged(i);};
m.prototype._markControlsWithShrinkableLayoutData=function(){this.getContent().forEach(this._markControlWithShrinkableLayoutData,this);};
m.prototype._collectPopoverOnlyControls=function(){var p=this._aPopoverOnlyControls.length,i,o;if(p){for(i=p-1;i>=0;i--){o=this._aPopoverOnlyControls[i];if(o.getVisible()){this._aButtonsToMoveToPopover.unshift(o);}}if(this._aButtonsToMoveToPopover.length>0){this._setOverflowButtonNeeded(true);}}};
m.prototype._moveControlsToPopover=function(t){var i=[];if(this._aMovableControls.length){i=this._aggregateMovableControls();i.sort(this._sortByPriorityAndIndex.bind(this));this._extractControlsToMoveToOverflow(i,t);}};
m.prototype._markControlWithShrinkableLayoutData=function(o){var w,i;o.removeStyleClass(a.shrinkClass);w=a.getOrigWidth(o.getId());if(!a.isRelativeWidth(w)){return;}i=o.getLayoutData();if(i&&i.isA("sap.m.ToolbarLayoutData")&&i.getShrinkable()){o.addStyleClass(a.shrinkClass);}};
m.prototype._resetToolbar=function(){this._getPopover().close();this._getPopover()._getAllContent().forEach(this._restoreButtonInToolbar,this);this._setOverflowButtonNeeded(false);this.getContent().forEach(this._removeShrinkingClass);};
m.prototype._removeShrinkingClass=function(o){o.removeStyleClass(a.shrinkClass);};
m.prototype._moveButtonToPopover=function(o){this._getPopover().addAssociatedContent(o);};
m.prototype._restoreButtonInToolbar=function(v){if(typeof v==="object"){v=v.getId();}this._getPopover().removeAssociatedContent(v);};
m.prototype._resetAndInvalidateToolbar=function(H){if(this._bIsBeingDestroyed){return;}this._resetToolbar();this._bControlsInfoCached=false;this._iPreviousToolbarWidth=null;if(H){this._bSkipOptimization=true;}if(this.$().length){this._preserveChildControlFocusInfo();this.invalidate();}};
m.prototype.invalidate=function(){this._bInvalidatedAndNotRendered=true;C.prototype.invalidate.apply(this,arguments);};
m.prototype._getVisibleContent=function(){var t=this.getContent(),p=this._getPopover()._getAllContent();return t.filter(function(o){return p.indexOf(o)===-1;});};
m.prototype._getVisibleAndNonOverflowContent=function(){return this._getVisibleContent().filter(function(o){return o.getVisible();});};
m.prototype._getToggleButton=function(i){return new T({ariaHasPopup:A.Menu,id:this.getId()+i,icon:f.getIconURI("overflow"),press:this._overflowButtonPressed.bind(this),ariaLabelledBy:I.getStaticId("sap.ui.core","Icon.overflow"),type:B.Transparent});};
m.prototype._getOverflowButton=function(){var o;if(!this.getAggregation("_overflowButton")){o=this._getToggleButton("-overflowButton");this.setAggregation("_overflowButton",o,true);}return this.getAggregation("_overflowButton");};
m.prototype._getOverflowButtonClone=function(){if(!this._oOverflowToolbarButtonClone){this._oOverflowToolbarButtonClone=this._getToggleButton("-overflowButtonClone").addStyleClass("sapMTBHiddenElement");}return this._oOverflowToolbarButtonClone;};
m.prototype._overflowButtonPressed=function(E){var p=this._getPopover(),s=this._getBestPopoverPlacement();if(p.getPlacement()!==s){p.setPlacement(s);}if(p.isOpen()){p.close();}else{p.openBy(E.getSource());}};
m.prototype._getPopover=function(){var p;if(!this.getAggregation("_popover")){p=new d(this.getId()+"-popover",{showHeader:false,showArrow:false,modal:false,horizontalScrolling:g.system.phone?false:true,contentWidth:g.system.phone?"100%":"auto",offsetY:this._detireminePopoverVerticalOffset(),ariaLabelledBy:I.getStaticId("sap.m","INPUT_AVALIABLE_VALUES")});p._adaptPositionParams=function(){d.prototype._adaptPositionParams.call(this);this._myPositions=["end top","begin center","end bottom","end center"];this._atPositions=["end bottom","end center","end top","begin center"];};if(g.system.phone){p.attachBeforeOpen(this._shiftPopupShadow,this);}p.attachAfterClose(this._popOverClosedHandler,this);this.setAggregation("_popover",p,true);}return this.getAggregation("_popover");};
m.prototype._shiftPopupShadow=function(){var p=this._getPopover(),s=p.getCurrentPosition();if(s===j.Bottom){p.addStyleClass("sapMOTAPopoverNoShadowTop");p.removeStyleClass("sapMOTAPopoverNoShadowBottom");}else if(s===j.Top){p.addStyleClass("sapMOTAPopoverNoShadowBottom");p.removeStyleClass("sapMOTAPopoverNoShadowTop");}};
m.prototype._popOverClosedHandler=function(){this._getOverflowButton().setPressed(false);if(q(document.activeElement).control(0)){return;}this._getOverflowButton().focus();};
m.prototype._getOverflowButtonNeeded=function(){return this._bOverflowButtonNeeded;};
m.prototype._setOverflowButtonNeeded=function(v){if(this._bOverflowButtonNeeded!==v){this._bOverflowButtonNeeded=v;}return this;};
m.prototype._updateContentInfoInControlsCollections=function(){this.getContent().forEach(function(o){if(o){this._removeContentFromControlsCollections(o);this._moveControlInSuitableCollection(o,this._getControlPriority(o));}},this);};
m.prototype._moveControlInSuitableCollection=function(o,p){var i=p!==k.NeverOverflow,n=p===k.AlwaysOverflow;if(e.supportsControl(o)&&n){this._aPopoverOnlyControls.push(o);}else{if(e.supportsControl(o)&&i&&o.getVisible()){this._aMovableControls.push(o);}else{this._aToolbarOnlyControls.push(o);}}};
m.prototype._removeContentFromControlsCollections=function(o){var i,n,p;for(i=0;i<this._aAllCollections.length;i++){n=this._aAllCollections[i];p=n.indexOf(o);if(p!==-1){n.splice(p,1);}}};
m.prototype._clearAllControlsCollections=function(){this._aMovableControls=[];this._aToolbarOnlyControls=[];this._aPopoverOnlyControls=[];this._aAllCollections=[this._aMovableControls,this._aToolbarOnlyControls,this._aPopoverOnlyControls];};
m.prototype.onLayoutDataChange=function(E){this._resetAndInvalidateToolbar(true);E&&this._updateContentInfoInControlsCollections();};
m.prototype.addContent=function(o){this._registerControlListener(o);this._resetAndInvalidateToolbar(false);if(o){this._moveControlInSuitableCollection(o,this._getControlPriority(o));}this._informNewFlexibleContentAdded(o);return this._callToolbarMethod("addContent",arguments);};
m.prototype.insertContent=function(o,i){this._registerControlListener(o);this._resetAndInvalidateToolbar(false);if(o){this._moveControlInSuitableCollection(o,this._getControlPriority(o));}this._informNewFlexibleContentAdded(o);return this._callToolbarMethod("insertContent",arguments);};
m.prototype.removeContent=function(){var v=this._callToolbarMethod("removeContent",arguments);if(v){this._getPopover().removeAssociatedContent(v.getId());}this._resetAndInvalidateToolbar(false);this._deregisterControlListener(v);this._removeContentFromControlsCollections(v);return v;};
m.prototype.removeAllContent=function(){var i=this._callToolbarMethod("removeAllContent",arguments);i.forEach(this._deregisterControlListener,this);i.forEach(this._removeContentFromControlsCollections,this);this._resetAndInvalidateToolbar(false);this._clearAllControlsCollections();return i;};
m.prototype.destroyContent=function(){this._resetAndInvalidateToolbar(false);setTimeout(function(){this._resetAndInvalidateToolbar(false);}.bind(this),0);this._clearAllControlsCollections();return this._callToolbarMethod("destroyContent",arguments);};
m.prototype._informNewFlexibleContentAdded=function(o){if(o&&o.isA("sap.m.IOverflowToolbarFlexibleContent")){this.fireEvent("_contentSizeChange",{contentSize:null});}};
m.prototype._registerControlListener=function(o){var i;if(o){o.attachEvent("_change",this._onContentPropertyChangedOverflowToolbar,this);if(o.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")>-1){i=o.getOverflowToolbarConfig().invalidationEvents;if(i&&Array.isArray(i)){i.forEach(function(E){o.attachEvent(E,this._onInvalidationEventFired,this);},this);}}}};
m.prototype._deregisterControlListener=function(o){var i;if(o){o.detachEvent("_change",this._onContentPropertyChangedOverflowToolbar,this);if(o.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")>-1){i=o.getOverflowToolbarConfig().invalidationEvents;if(i&&Array.isArray(i)){i.forEach(function(E){o.detachEvent(E,this._onInvalidationEventFired,this);},this);}}}};
m.prototype._onContentPropertyChangedOverflowToolbar=function(E){var s=E.getSource(),o,p;this._updateContentInfoInControlsCollections();if(!this._bListenForControlPropertyChanges){return;}o=e.getControlConfig(s);p=E.getParameter("name");if(p!=='visible'&&!s.getVisible()){return;}if(typeof o!=="undefined"&&o.noInvalidationProps.indexOf(p)!==-1){return;}if(p==="visible"){this._bContentVisibilityChanged=true;}if(s.isA("sap.m.IOverflowToolbarFlexibleContent")&&s.getVisible()){this.fireEvent("_contentSizeChange",{contentSize:null});}this._resetAndInvalidateToolbar(true);};
m.prototype._onInvalidationEventFired=function(E){var s=E.getSource();if(!this._bListenForInvalidationEvents){return;}if(s.isA("sap.m.IOverflowToolbarFlexibleContent")){this.fireEvent("_contentSizeChange",{contentSize:null});}this._resetAndInvalidateToolbar(true);};
m.prototype._getOverflowButtonSize=function(){return this._iOverflowToolbarButtonSize;};
m.prototype._getBestPopoverPlacement=function(){var H=this.getHTMLTag();if(H==="Footer"){return j.Top;}else if(H==="Header"){return j.Bottom;}return j.Vertical;};
m.prototype._getControlsIds=function(){return this.getContent().map(function(i){return i.getId();});};
m.prototype._getControlIndex=function(v){return v.length?v._index:this.indexOfContent(v);};
m.prototype._getOptimalControlWidth=function(o,i){var n,p=o.getLayoutData(),s=p&&p.isA("sap.m.ToolbarLayoutData")?p.getShrinkable():false,M=s?this._getMinWidthOfShrinkableControl(o):0,v=o.getVisible(),S;if(o.isA("sap.m.ToolbarSpacer")){S=parseInt(o.$().css('width'));M=(o.getWidth()&&S)?S:0;n=m._getOptimalWidthOfShrinkableControl(o,M);}else if(s&&M>0&&v){n=m._getOptimalWidthOfShrinkableControl(o,M);}else{n=v?m._getControlWidth(o):0;}if(n===null){n=typeof i!=="undefined"?i:0;}return n;};
m.prototype._getMinWidthOfShrinkableControl=function(o){var M=o.$().css("min-width"),i=parseInt(M),r=a.isRelativeWidth(M);if(r){return(i*this.$().width())/100;}else{return i;}};
m.prototype._getControlPriority=function(v){var i,o,p,G;if(v.length){return v._priority;}i=v.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")>-1;G=i&&v.getOverflowToolbarConfig().getCustomImportance;if(i&&typeof G==="function"){return G();}o=v.getLayoutData&&v.getLayoutData();if(o&&o instanceof O){if(o.getMoveToOverflow()===false){return k.NeverOverflow;}if(o.getStayInOverflow()===true){return k.AlwaysOverflow;}p=o.getPriority();if(p===k.Never){return k.NeverOverflow;}if(p===k.Always){return k.AlwaysOverflow;}return p;}return k.High;};
m._getControlMargins=function(o){return o.$().outerWidth(true)-o.$().outerWidth();};
m._getOptimalWidthOfShrinkableControl=function(o,M){return M+m._getControlMargins(o);};
m._getControlWidth=function(o){var i=o&&o.getDomRef();if(i&&o.$().is(":visible")){return Math.round(i.getBoundingClientRect().width+m._getControlMargins(o));}return null;};
m._getControlGroup=function(o){var i=o.getLayoutData();if(i instanceof O){return i.getGroup();}};
m._oPriorityOrder=(function(){var p={};p[k.Disappear]=1;p[k.Low]=2;p["Medium"]=3;p[k.High]=4;return p;})();
m.prototype._detireminePopoverVerticalOffset=function(){return this.$().parents().hasClass('sapUiSizeCompact')?2:3;};
m.prototype._recalculateOverflowButtonSize=function(){var o=this._getOverflowButtonClone().$(),i;if(!this._getOverflowButtonSize()&&o.width()>0){i=o.outerWidth(true);this._iOverflowToolbarButtonSize=i?i:0;}};
m.prototype.onThemeChanged=function(){this._resetAndInvalidateToolbar();this._iOverflowToolbarButtonSize=0;this._recalculateOverflowButtonSize();for(var i in this._aControlSizes){if(this._aControlSizes.hasOwnProperty(i)){this._aControlSizes[i]=0;}}};
m.prototype.closeOverflow=function(){this._getPopover().close();};
return m;});
sap.ui.predefine('sap/m/OverflowToolbarAssociativePopover',['./Popover','./OverflowToolbarAssociativePopoverControls','./OverflowToolbarAssociativePopoverRenderer','./OverflowToolbarLayoutData','sap/m/library'],function(P,O,a,b,l){"use strict";var c=l.PlacementType;var d=l.OverflowToolbarPriority;
var e=P.extend("sap.m._overflowToolbarHelpers.OverflowToolbarAssociativePopover",{
metadata:{library:"sap.m",associations:{associatedContent:{type:"sap.ui.core.Control",multiple:true}}},
renderer:a
});
e.prototype.init=function(){P.prototype.init.apply(this,arguments);this.oControlsManager=new O();};
e.prototype.onBeforeRendering=function(){P.prototype.onBeforeRendering.apply(this,arguments);this.addStyleClass("sapMOTAPopover");this.addStyleClass("sapMOverflowToolbarMenu-CTX");};
e.prototype.addAssociatedContent=function(o){this.addAssociation("associatedContent",o,true);this._preProcessControl(o);return this;};
e.prototype.removeAssociatedContent=function(o){var r=this.removeAssociation("associatedContent",o,true),f;if(r){f=sap.ui.getCore().byId(r);if(f){this._postProcessControl(f);}}return r;};
e.prototype._preProcessControl=function(o){var f=O.getControlConfig(o),A;f.listenForEvents.forEach(function(E){A="attach"+C(E);if(o[A]){o[A](this._closeOnInteraction.bind(this,o));}else{o.attachEvent(E,this._closeOnInteraction.bind(this,o));}},this);if(typeof f.preProcess==="function"){f.preProcess.call(this.oControlsManager,o);}var L=o.getLayoutData();if(L instanceof b&&L.getPriority()===d.Disappear){o.addStyleClass("sapMOTAPHidden");}return this;};
e.prototype._postProcessControl=function(o){var f=O.getControlConfig(o),D;f.listenForEvents.forEach(function(E){D="detach"+C(E);if(o[D]){o[D](this._closeOnInteraction,this);}else{o.detachEvent(E,this._closeOnInteraction,this);}},this);if(typeof f.postProcess==="function"){f.postProcess.call(this.oControlsManager,o);}o.removeStyleClass("sapMOTAPHidden");o.$().remove();return this;};
e.prototype._closeOnInteraction=function(o){var L=o.getLayoutData();if(!L||!(L instanceof b)||L.getCloseOverflowOnInteraction()){this.close();}};
e.prototype._getContentIdsHash=function(){return this._getAllContent().join(".");};
e.prototype._recalculateMargins=function(s,p){if(s!==c.Top){return P.prototype._recalculateMargins.apply(this,arguments);}p._fMarginBottom=p._fDocumentHeight-p._$parent.offset().top+this._arrowOffset+p._fOffsetY;return p;};
e.prototype._getAllContent=function(){var A=this.getAssociatedContent().map(function(i){return sap.ui.getCore().byId(i);});if(this.getPlacement()===c.Top){A.reverse();}return this.getContent().concat(A);};
e.prototype.getCurrentPosition=function(){if(!this._oCalcedPos){this._calcPlacement();}return this._oCalcedPos;};
function C(n){return n.substring(0,1).toUpperCase()+n.substring(1);}
return e;});
sap.ui.predefine('sap/m/OverflowToolbarAssociativePopoverControls',['sap/ui/base/Object','./OverflowToolbarButton','./OverflowToolbarToggleButton','./ToggleButton','./Button','sap/m/library',"sap/base/Log"],function(B,O,a,T,b,l,L){"use strict";var c=l.ButtonType;
var d=B.extend("sap.m._overflowToolbarHelpers.OverflowToolbarAssociativePopoverControls",{
constructor:function(){this._mControlsCache={};},
getInterface:function(){return this;}
});
d.prototype._preProcessSapMButton=function(o){var e=o.getType();this._mControlsCache[o.getId()]={buttonType:e};if(e===c.Default){o.setProperty("type",c.Transparent,true);}o.attachEvent("_change",this._onSapMButtonUpdated,this);};
d.prototype._postProcessSapMButton=function(o){var p=this._mControlsCache[o.getId()];if(o.getType()!==p.buttonType){o.setProperty("type",p.buttonType,true);}o.detachEvent("_change",this._onSapMButtonUpdated,this);};
d.prototype._onSapMButtonUpdated=function(e){var p=e.getParameter("name"),o=e.getSource(),s=o.getId();if(typeof this._mControlsCache[s]==="undefined"){return;}if(p==="type"){this._mControlsCache[s]["buttonType"]=o.getType();}};
d.prototype._preProcessSapMOverflowToolbarButton=function(o){this._preProcessSapMButton(o);o._bInOverflow=true;};
d.prototype._postProcessSapMOverflowToolbarButton=function(o){delete o._bInOverflow;this._postProcessSapMButton(o);};
d.prototype._preProcessSapMToggleButton=function(o){this._preProcessSapMButton(o);};
d.prototype._postProcessSapMToggleButton=function(o){this._postProcessSapMButton(o);};
d.prototype._preProcessSapMOverflowToolbarToggleButton=function(o){this._preProcessSapMToggleButton(o);o._bInOverflow=true;};
d.prototype._postProcessSapMOverflowToolbarToggleButton=function(o){delete o._bInOverflow;this._postProcessSapMToggleButton(o);};
d._mSupportedControls={"sap.m.Button":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled"]},"sap.m.MenuButton":{canOverflow:true,listenForEvents:["defaultAction","_menuItemSelected"],noInvalidationProps:["enabled","text","icon"]},"sap.m.OverflowToolbarButton":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","type"]},"sap.m.OverflowToolbarToggleButton":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","type","pressed"]},"sap.m.CheckBox":{canOverflow:true,listenForEvents:["select"],noInvalidationProps:["enabled","selected"]},"sap.m.ToggleButton":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","pressed"]},"sap.m.ComboBox":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled","value","selectedItemId","selectedKey","open"]},"sap.m.SearchField":{canOverflow:true,listenForEvents:["search"],noInvalidationProps:["enabled","value","selectOnFocus"]},"sap.m.Input":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled","value"]},"sap.m.DateTimeInput":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue"]},"sap.m.DatePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat","displayFormatType","secondaryCalendarType","minDate","maxDate"]},"sap.m.DateTimePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat","displayFormatType","secondaryCalendarType","minDate","maxDate"]},"sap.m.TimePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat"]},"sap.m.RadioButton":{canOverflow:false,listenForEvents:[],noInvalidationProps:["enabled","selected"]},"sap.m.Slider":{canOverflow:false,listenForEvents:[],noInvalidationProps:["enabled","value"]},"sap.m.IconTabHeader":{canOverflow:false,listenForEvents:[],noInvalidationProps:["selectedKey"]},"sap.ui.comp.smartfield.SmartField":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","valueState","showValueHelp","contextEditable","clientSideMandatoryCheck","mandatory","name","placeholder","showSuggestion","tooltipLabel"]},"sap.ui.comp.smartfield.SmartLabel":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled"]}};
d.getControlConfig=function(o){var e;if(o.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")!==-1){if(typeof o.getOverflowToolbarConfig!=="function"){L.error("Required method getOverflowToolbarConfig not implemented by: "+o.getMetadata().getName());return;}e=o.getOverflowToolbarConfig();if(typeof e!=="object"){L.error("Method getOverflowToolbarConfig implemented, but does not return an object in: "+o.getMetadata().getName());return;}return{canOverflow:!!e.canOverflow,listenForEvents:Array.isArray(e.autoCloseEvents)?e.autoCloseEvents:[],noInvalidationProps:Array.isArray(e.propsUnrelatedToSize)?e.propsUnrelatedToSize:[],preProcess:e.onBeforeEnterOverflow,postProcess:e.onAfterExitOverflow};}var s=d.getControlClass(o);e=d._mSupportedControls[s];if(e===undefined){return;}var p="_preProcess"+s.split(".").map(C).join("");if(typeof d.prototype[p]==="function"){e.preProcess=d.prototype[p];}var P="_postProcess"+s.split(".").map(C).join("");if(typeof d.prototype[P]==="function"){e.postProcess=d.prototype[P];}return e;};
d.supportsControl=function(o){var e=d.getControlConfig(o);return typeof e!=="undefined"&&e.canOverflow;};
d.getControlClass=function(o){if(o instanceof O){return"sap.m.OverflowToolbarButton";}else if(o instanceof a){return"sap.m.OverflowToolbarToggleButton";}else if(o instanceof T){return"sap.m.ToggleButton";}else if(o instanceof b){return"sap.m.Button";}return o.getMetadata().getName();};
function C(n){return n.substring(0,1).toUpperCase()+n.substr(1);}
return d;});
sap.ui.predefine('sap/m/OverflowToolbarButton',['sap/m/Button','sap/m/ButtonRenderer'],function(B,a){"use strict";
var O=B.extend("sap.m.OverflowToolbarButton",{
metadata:{interfaces:["sap.f.IShellBar","sap.m.IOverflowToolbarContent"]},
renderer:a
});
O.prototype._getText=function(){if(this._bInOverflow){return B.prototype._getText.call(this);}return"";};
O.prototype._getTooltip=function(){var t=B.prototype._getTooltip.call(this);if(this._bInOverflow){return this._getText()===t?"":t;}return t;};
O.prototype._onBeforeEnterOverflow=function(){this._bInOverflow=true;};
O.prototype._onAfterExitOverflow=function(){this._bInOverflow=false;};
O.prototype.getOverflowToolbarConfig=function(){var c={canOverflow:true,propsUnrelatedToSize:["enabled","type"],autoCloseEvents:["press"]};c.onBeforeEnterOverflow=this._onBeforeEnterOverflow.bind(this);c.onAfterExitOverflow=this._onAfterExitOverflow.bind(this);return c;};
return O;});
sap.ui.predefine('sap/m/OverflowToolbarLayoutData',['sap/m/ToolbarLayoutData','sap/m/library',"sap/base/Log"],function(T,l,L){"use strict";var O=l.OverflowToolbarPriority;
var a=T.extend("sap.m.OverflowToolbarLayoutData",{metadata:{properties:{moveToOverflow:{type:"boolean",defaultValue:true,deprecated:true},stayInOverflow:{type:"boolean",defaultValue:false,deprecated:true},priority:{type:"sap.m.OverflowToolbarPriority",group:"Behavior",defaultValue:O.High},group:{type:"int",group:"Behavior",defaultValue:0},closeOverflowOnInteraction:{type:"boolean",group:"Behavior",defaultValue:true}}}});
a.prototype.invalidate=function(){var c=this.getPriority(),i=c===O.AlwaysOverflow||c===O.NeverOverflow;if(this.getGroup()&&i){L.error("It is not allowed to set AlwaysOverflow or NeverOverflow to a group items.");}return T.prototype.invalidate.call(this);};
a.prototype.setPriority=function(p){var r;if(this.getPriority()===p){return this;}if(this.isInvalidateSuppressed()){r=this.setProperty("priority",p,true);this.invalidate();}else{r=this.setProperty("priority",p);}return r;};
return a;});
sap.ui.predefine('sap/m/OverflowToolbarRenderer',["./library",'sap/ui/core/Renderer','./ToolbarRenderer',"sap/m/BarInPageEnabler"],function(l,R,T,B){"use strict";var O=l.OverflowToolbarPriority;var a=R.extend(T);a.apiVersion=2;
a.renderBarContent=function(r,t){var h=false,H;t._getVisibleContent().forEach(function(c){B.addChildClassTo(c,t);if(t._getControlPriority(c)!==O.AlwaysOverflow){r.renderControl(c);}else{h=h||c.getVisible();}});if(h||t._getOverflowButtonNeeded()){a.renderOverflowButton(r,t);}H=t.getContent().some(function(c){return c.getVisible();});if(H){a.renderOverflowButtonClone(r,t);}};
a.renderOverflowButton=function(r,t){var o=t._getOverflowButton();B.addChildClassTo(o,t);r.renderControl(o);};
a.renderOverflowButtonClone=function(r,t){var o=t._getOverflowButtonClone();B.addChildClassTo(o,t);r.renderControl(o);};
return a;},true);
sap.ui.predefine('sap/m/OverflowToolbarToggleButton',['sap/m/ToggleButton','sap/m/ToggleButtonRenderer'],function(T,a){"use strict";
var O=T.extend("sap.m.OverflowToolbarToggleButton",{renderer:a});
O.prototype._getText=function(){return this._bInOverflow?T.prototype._getText.call(this):"";};
return O;});
sap.ui.predefine('sap/m/P13nConditionPanelRenderer',['sap/ui/core/Renderer'],function(R){"use strict";return R.extend("sap.m.P13nConditionPanelRenderer",{renderer:{apiVersion:2,render:function(r,c){r.openStart("section",c);r.class("sapMConditionPanel");r.openEnd();r.openStart("div");r.class("sapMConditionPanelContent");r.class("sapMConditionPanelBG");r.openEnd();c.getAggregation("content").forEach(function(C){r.renderControl(C);});r.close("div");r.close("section");}}});},true);
sap.ui.predefine('sap/m/P13nFilterPanelRenderer',['sap/ui/core/Renderer'],function(R){"use strict";return R.extend("sap.m.P13nFilterPanelRenderer",{renderer:{apiVersion:2,render:function(r,c){r.openStart("section",c);r.class("sapMFilterPanel");r.openEnd();r.openStart("div");r.class("sapMFilterPanelContent");r.class("sapMFilterPanelBG");r.openEnd();c.getAggregation("content").forEach(function(C){r.renderControl(C);});r.close("div");r.close("section");}}});},true);
sap.ui.predefine('sap/m/PDFViewer',["./library","sap/ui/core/Control","sap/ui/Device","sap/m/PDFViewerRenderManager","sap/m/MessageBox","sap/m/PDFViewerRenderer","sap/base/Log","sap/base/assert","sap/ui/thirdparty/jquery"],function(l,C,D,P,M,a,L,b,q){"use strict";var c=l.PDFViewerDisplayType;
var d=C.extend("sap.m.PDFViewer",{metadata:{library:"sap.m",properties:{height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},source:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},errorMessage:{type:"string",group:"Misc",defaultValue:null,deprecated:true},errorPlaceholderMessage:{type:"string",group:"Misc",defaultValue:null},popupHeaderTitle:{type:"string",group:"Misc",defaultValue:null,deprecated:true},title:{type:"string",group:"Misc",defaultValue:null},showDownloadButton:{type:"boolean",group:"Misc",defaultValue:true},displayType:{type:"sap.m.PDFViewerDisplayType",group:"Misc",defaultValue:c.Auto}},aggregations:{errorPlaceholder:{type:"sap.ui.core.Control",multiple:false},popupButtons:{type:"sap.m.Button",multiple:true,singularName:"popupButton"}},events:{loaded:{},error:{parameters:{target:{type:"any",defaultValue:null}}},sourceValidationFailed:{}}}});
d.prototype.init=function(){this._objectsRegister={};this._bIsPopupOpen=false;this._initPopupControl();this._initPopupDownloadButtonControl();this._initPlaceholderMessagePageControl();this._initToolbarDownloadButtonControl();this._initOverflowToolbarControl();this._initControlState();};
d.prototype._initControlState=function(){this._bRenderPdfContent=true;};
d.prototype.setWidth=function(w){this.setProperty("width",w,true);var o=this.$();if(o===null){return this;}o.css("width",this._getRenderWidth());return this;};
d.prototype.setHeight=function(h){this.setProperty("height",h,true);var o=this.$();if(o===null){return this;}o.css("height",this._getRenderHeight());return this;};
d.prototype.onBeforeRendering=function(){try{var i=this._getIframeDOMElement();i.off();}catch(e){L.info(e);}};
d.prototype.onAfterRendering=function(){var i=function(){var I=this._getIframeDOMElement();I.on("load",this._onLoadListener.bind(this));I.on("error",this._onErrorListener.bind(this));}.bind(this);try{this.setBusy(true);i();}catch(e){L.error(e);this.setBusy(false);}};
d.prototype._fireErrorEvent=function(e){this._renderErrorState();this.fireError({target:e||null});};
d.prototype._renderErrorState=function(){var o=this._objectsRegister.getToolbarDownloadButtonControl();o.setEnabled(false);var o=this._objectsRegister.getPopupDownloadButtonControl();o.setEnabled(false);this.setBusy(false);this._bRenderPdfContent=false;C.prototype.invalidate.call(this);};
d.prototype._fireLoadedEvent=function(){this._bRenderPdfContent=true;this.setBusy(false);try{this._getIframeDOMElement().removeClass("sapMPDFViewerLoading");}catch(e){L.fatal("Iframe not founded in loaded event");L.fatal(e);}this.fireEvent("loaded");};
d.prototype._onLoadListener=function(e){try{var t=q(e.target),f=true;var s="application/pdf";try{var E=t[0].contentWindow.document.embeds;f=!!E&&E.length===1;if(f){s=E[0].attributes.getNamedItem("type").value;}}catch(g){if(!D.browser.firefox&&this.fireEvent("sourceValidationFailed",{},true)){this._showMessageBox();return;}}if(f&&a._isSupportedMimeType(s)&&a._isPdfPluginEnabled()){this._fireLoadedEvent();}else{this._fireErrorEvent(e.target);}}catch(g){L.fatal(false,"Fatal error during the handling of load event happened.");L.fatal(false,g.message);}};
d.prototype._onErrorListener=function(){this._fireErrorEvent();};
d.prototype.downloadPDF=function(){var w=window.open(this.getSource());w.opener=null;w.focus();};
d.prototype._onSourceValidationErrorMessageBoxCloseListener=function(o){if(o===M.Action.CANCEL){this._renderErrorState();}else{this._fireLoadedEvent();}};
d.prototype._onAfterPopupClose=function(e){var p=this._objectsRegister.getPopup();p.removeAllContent();this._bIsPopupOpen=false;};
d.prototype._shouldRenderPdfContent=function(){return a._isPdfPluginEnabled()&&this._bRenderPdfContent&&this._isSourceValidToDisplay();};
d.prototype._isSourceValidToDisplay=function(){var s=this.getSource();return s!==null&&s!==""&&typeof s!=="undefined";};
d.prototype.invalidate=function(o){this._initControlState();C.prototype.invalidate.call(this,o);};
d.prototype.open=function(){if(!this._isSourceValidToDisplay()){b(false,"The PDF file cannot be opened with the given source. Given source: "+this.getSource());return;}else if(!a._isPdfPluginEnabled()){L.warning("The PDF plug-in is not available on this device.");}if(this._isEmbeddedModeAllowed()){this._openOnDesktop();}else{this._openOnMobile();}};
d.prototype._openOnDesktop=function(){var p=this._objectsRegister.getPopup();if(this._bIsPopupOpen){return;}this._initControlState();this._preparePopup(p);p.addContent(this);this._bIsPopupOpen=true;p.open();};
d.prototype._openOnMobile=function(){var w=window.open(this.getSource());w.opener=null;w.focus();};
d.prototype._getIframeDOMElement=function(){var i=this.$("iframe");if(i.length===0){throw Error("Underlying iframe was not found in DOM.");}if(i.length>1){L.fatal("Initialization of iframe fails. Reason: the control somehow renders multiple iframes");}return i;};
d.prototype._isEmbeddedModeAllowed=function(){return this._isDisplayTypeAuto()?D.system.desktop:this._isDisplayTypeEmbedded();};
d.prototype._isDisplayTypeAuto=function(){return this.getDisplayType()===c.Auto;};
d.prototype._isDisplayTypeEmbedded=function(){return this.getDisplayType()===c.Embedded;};
d.prototype._isDisplayTypeLink=function(){return this.getDisplayType()===c.Link;};
d.prototype._isDisplayDownloadButton=function(){return this.getShowDownloadButton()||this._isDisplayTypeLink()||(this._isDisplayTypeAuto()&&!this._isEmbeddedModeAllowed());};
d.prototype._getLibraryResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m");};
d.prototype._getMessagePageErrorMessage=function(){return this.getErrorPlaceholderMessage()?this.getErrorPlaceholderMessage():this._getLibraryResourceBundle().getText("PDF_VIEWER_PLACEHOLDER_ERROR_TEXT");};
d.prototype._getRenderWidth=function(){return this._bIsPopupOpen?'100%':this.getWidth();};
d.prototype._getRenderHeight=function(){if(this._bIsPopupOpen){return'100%';}if(!this._isEmbeddedModeAllowed()){return'auto';}return this.getHeight();};
d.prototype._showMessageBox=function(){M.show(this._getLibraryResourceBundle().getText("PDF_VIEWER_SOURCE_VALIDATION_MESSAGE_TEXT"),{icon:M.Icon.WARNING,title:this._getLibraryResourceBundle().getText("PDF_VIEWER_SOURCE_VALIDATION_MESSAGE_HEADER"),actions:[M.Action.OK,M.Action.CANCEL],defaultAction:M.Action.CANCEL,id:this.getId()+"-validationErrorSourceMessageBox",styleClass:"sapUiSizeCompact",contentWidth:'100px',onClose:this._onSourceValidationErrorMessageBoxCloseListener.bind(this)});};
d.prototype.exit=function(){q.each(this._objectsRegister,function(I,g){var o=g(true);if(o){o.destroy();}});try{var i=this._getIframeDOMElement();i.off();}catch(e){L.info(e);}};
P.extendPdfViewer(d);return d;});
sap.ui.predefine('sap/m/PDFViewerRenderManager',["sap/m/library","sap/m/Dialog","sap/m/Button","sap/m/MessagePage","sap/m/OverflowToolbar","sap/m/OverflowToolbarButton","sap/m/Title","sap/m/ToolbarSpacer","sap/m/OverflowToolbarLayoutData"],function(l,D,B,M,O,a,T,b,c){"use strict";var d=l.OverflowToolbarPriority;var e=l.ButtonType;var p={extendPdfViewer:function(P){P.prototype._initPopupControl=function(){var t=this;var o={contentHeight:"100%",contentWidth:"100%",horizontalScrolling:false,verticalScrolling:false,showHeader:true,buttons:[],afterClose:t._onAfterPopupClose.bind(t)},s=t.getId()+"-popup",f=s+"-popupCloseButton",C="getPopupCloseButton",g="getPopup";this._objectsRegister[C]=function(){var h=new B(f,{text:'',press:function(){t._objectsRegister.getPopup().close();}});t._objectsRegister[C]=function(){return h;};return h;};this._objectsRegister[g]=function(i){if(i===true){return null;}var h=new D(s,o);h.addStyleClass("sapUiContentPadding");t._objectsRegister[g]=function(){return h;};return h;};};P.prototype._preparePopup=function(o){var f=this.getPopupButtons().slice(),C=this._objectsRegister.getPopupCloseButton(),g=this._objectsRegister.getPopupDownloadButtonControl();C.setText(this._getLibraryResourceBundle().getText("PDF_VIEWER_POPUP_CLOSE_BUTTON"));if(this.getShowDownloadButton()){f.push(g);}f.push(C);o.removeAllButtons();f.forEach(function(h){o.addButton(h);});o.setShowHeader(true);if(this.getPopupHeaderTitle()){o.setTitle(this.getPopupHeaderTitle());}if(this.getTitle()){o.setTitle(this.getTitle());}};P.prototype._initPlaceholderMessagePageControl=function(){var t=this,s="getPlaceholderMessagePageControl";this._objectsRegister[s]=function(){var m=new M({showHeader:false,text:t._getMessagePageErrorMessage(),description:""});t._objectsRegister[s]=function(){m.setText(t._getMessagePageErrorMessage());return m;};return m;};};P.prototype._initOverflowToolbarControl=function(){var t=this,o=this.getId()+"-overflowToolbar",s=o+"-title",f="getOverflowToolbarControl";this._objectsRegister[f]=function(i){if(i===true){return null;}var g=new O(o,{}),h=new T(s,{text:t.getTitle()}),j=t._objectsRegister.getToolbarDownloadButtonControl();function k(){if(t._isDisplayDownloadButton()){g.addContent(j);}else{g.removeContent(j);}j.setEnabled(t._bRenderPdfContent);h.setText(t.getTitle());}g.addStyleClass("sapUiTinyMarginBottom");g.addContent(h);g.addContent(new b());k();j.setLayoutData(new c({priority:d.NeverOverflow}));t._objectsRegister[f]=function(i){if(!i){k();}return g;};return g;};};P.prototype._initToolbarDownloadButtonControl=function(){var t=this,s=this.getId()+"-toolbarDownloadButton",f="getToolbarDownloadButtonControl";this._objectsRegister[f]=function(i){if(i){return null;}var o=new a(s,{type:e.Transparent,icon:"sap-icon://download"});o.attachPress(t.downloadPDF.bind(t));o.setEnabled(t._bRenderPdfContent);t._objectsRegister[f]=function(){o.setEnabled(t._bRenderPdfContent);return o;};return o;};};P.prototype._initPopupDownloadButtonControl=function(){var t=this,s=this.getId()+"-popupDownloadButton",f="getPopupDownloadButtonControl";this._objectsRegister[f]=function(){var o=new B(s,{text:t._getLibraryResourceBundle().getText("PDF_VIEWER_DOWNLOAD_TEXT"),type:e.Emphasized});o.attachPress(t.downloadPDF.bind(t));o.setEnabled(t._bRenderPdfContent);t._objectsRegister[f]=function(){o.setEnabled(t._bRenderPdfContent);return o;};return o;};};}};return p;},true);
sap.ui.predefine('sap/m/PDFViewerRenderer',['sap/ui/Device',"sap/base/Log","sap/base/security/URLListValidator"],function(D,L,U){"use strict";
function s(c){return(!!c.getTitle()||c._isDisplayDownloadButton())&&!c._bIsPopupOpen;}
var a=Object.freeze(["application/pdf","application/x-google-chrome-pdf"]);var P={apiVersion:2};
P._isSupportedMimeType=function(m){var f=a.indexOf(m);return f>-1;};
P._isPdfPluginEnabled=function(){var i=true;if(D.browser.firefox){return i;}var m=navigator.mimeTypes;i=a.some(function(A){var M=m.namedItem(A);return M!==null;});return i;};
P.render=function(r,c){r.openStart("div",c);r.style("width",c._getRenderWidth());r.style("height",c._getRenderHeight());this._writeAccessibilityTags(r,c);r.openEnd();if(s(c)){r.renderControl(c._objectsRegister.getOverflowToolbarControl());}if(c._isEmbeddedModeAllowed()){this.renderPdfContent(r,c);}r.close("div");};
P._writeAccessibilityTags=function(r,c){r.attr("role","document");r.attr("aria-label",c._getLibraryResourceBundle().getText("PDF_VIEWER_ACCESSIBILITY_LABEL"));};
P.renderPdfContent=function(r,c){if(c._shouldRenderPdfContent()){r.openStart("iframe",c.getId()+"-iframe");var p=c.getSource();var C=c.getSource().indexOf("#");if(C>-1){p=p.substr(0,C);}if(!(D.browser.safari&&p.startsWith("blob:"))){p+="#view=FitH";}if(!U.validate(p)){p=encodeURI(p);}if(U.validate(p)){r.attr("src",p);}else{c._fireErrorEvent();}r.class("sapMPDFViewerContent");r.class("sapMPDFViewerLoading");if(s(c)){r.class("sapMPDFViewerReducedContent");}r.openEnd();r.close("iframe");}else{this.renderErrorContent(r,c);if(!P._isPdfPluginEnabled()){L.warning("The PDF plug-in is not available on this device.");c.fireEvent("error",{},true);}}};
P.renderErrorContent=function(r,c){var e=c.getErrorPlaceholder()?c.getErrorPlaceholder():c._objectsRegister.getPlaceholderMessagePageControl();r.openStart("div");r.class("sapMPDFViewerError");if(!c._bIsPopupOpen){r.class("sapMPDFViewerEmbeddedContent");}r.openEnd();r.renderControl(e);r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/Page',["./library","sap/ui/core/Control","sap/ui/core/delegate/ScrollEnablement","sap/m/Title","sap/m/Button","sap/m/Bar","sap/ui/core/ContextMenuSupport","sap/ui/core/util/ResponsivePaddingsEnablement","sap/ui/core/library","sap/ui/Device","sap/ui/core/Element","./TitlePropagationSupport","./PageRenderer","sap/ui/thirdparty/jquery"],function(l,C,S,T,B,a,b,R,c,D,E,d,P,q){"use strict";var A=c.AccessibleLandmarkRole;var e=l.ButtonType;var f=l.PageBackgroundDesign;var g=c.TitleLevel;var h=l.TitleAlignment;var i="div";var H="header";var F="footer";
var j=C.extend("sap.m.Page",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:g.Auto},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},showSubHeader:{type:"boolean",group:"Appearance",defaultValue:true},navButtonText:{type:"string",group:"Misc",defaultValue:null,deprecated:true},navButtonTooltip:{type:"string",group:"Misc",defaultValue:null},enableScrolling:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null,deprecated:true},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:f.Standard},navButtonType:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:e.Back,deprecated:true},showFooter:{type:"boolean",group:"Appearance",defaultValue:true},contentOnlyBusy:{type:"boolean",group:"Appearance",defaultValue:false},floatingFooter:{type:"boolean",group:"Appearance",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:h.Auto}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.m.IBar",multiple:false},footer:{type:"sap.m.IBar",multiple:false},subHeader:{type:"sap.m.IBar",multiple:false},headerContent:{type:"sap.ui.core.Control",multiple:true,singularName:"headerContent",forwarding:{getter:"_getInternalHeader",aggregation:"contentRight"}},landmarkInfo:{type:"sap.m.PageAccessibleLandmarkInfo",multiple:false},_internalHeader:{type:"sap.m.IBar",multiple:false,visibility:"hidden"}},events:{navButtonTap:{deprecated:true},navButtonPress:{}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/Page.designtime"}});
b.apply(j.prototype);R.call(j.prototype,{header:{suffix:"intHeader"},subHeader:{selector:".sapMPageSubHeader .sapMIBar"},content:{suffix:"cont"},footer:{selector:".sapMPageFooter:not(.sapMPageFloatingFooter) .sapMIBar"},floatingFooter:{selector:".sapMPageFloatingFooter.sapMPageFooter"}});d.call(j.prototype,"content",function(){return this._headerTitle?this._headerTitle.getId():false;});j.FOOTER_ANIMATION_DURATION=350;
j.prototype.init=function(){this._initTitlePropagationSupport();this._initResponsivePaddingsEnablement();};
j.prototype._hasScrolling=function(){return this.getEnableScrolling();};
j.prototype.onBeforeRendering=function(){var o=this.getCustomHeader()||this.getAggregation("_internalHeader");if(this._oScroller&&!this._hasScrolling()){this._oScroller.destroy();this._oScroller=null;}else if(this._hasScrolling()&&!this._oScroller){this._oScroller=new S(this,null,{scrollContainerId:this.getId()+"-cont",horizontal:false,vertical:true});}if(this._headerTitle){this._headerTitle.setLevel(this.getTitleLevel());}this._ensureNavButton();if(o&&o.setTitleAlignment){o.setProperty("titleAlignment",this.getTitleAlignment(),true);}};
j.prototype.onAfterRendering=function(){this.$().toggleClass("sapMPageBusyCoversAll",!this.getContentOnlyBusy());this._sBusySection=this.getContentOnlyBusy()?'cont':null;};
j.prototype.exit=function(){if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}if(this._navBtn){this._navBtn.destroy();this._navBtn=null;}if(this._appIcon){this._appIcon.destroy();this._appIcon=null;}};
j.prototype.setBackgroundDesign=function(s){var k=this.getBackgroundDesign();this.setProperty("backgroundDesign",s,true);this.$().removeClass("sapMPageBg"+k).addClass("sapMPageBg"+this.getBackgroundDesign());return this;};
j.prototype.setTitle=function(t){var w=!this._headerTitle;this._headerTitle=this._headerTitle||new T(this.getId()+"-title",{level:this.getTitleLevel()});this._headerTitle.setText(t);if(w){this._updateHeaderContent(this._headerTitle,"middle",0);}this.setProperty("title",t,true);return this;};
j.prototype._ensureNavButton=function(){if(!this.getShowNavButton()){return;}var s=this.getNavButtonTooltip()||sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PAGE_NAVBUTTON_TEXT");if(!this._navBtn){this._navBtn=new B(this.getId()+"-navButton",{press:function(){this.fireNavButtonPress();this.fireNavButtonTap();}.bind(this)});}this._navBtn.setType(this.getNavButtonType());this._navBtn.setTooltip(s);};
j.prototype.setShowNavButton=function(s){var o=!!this.getShowNavButton();if(s===o){return this;}this.setProperty("showNavButton",s,true);if(s){this._ensureNavButton();if(this._appIcon){this._updateHeaderContent(this._appIcon,"left",-1);}this._updateHeaderContent(this._navBtn,"left",0);}else if(this._navBtn){this._updateHeaderContent(this._navBtn,"left",-1);}return this;};
j.prototype.setShowFooter=function(s){if(this.getDomRef()){(s)?this.$().addClass("sapMPageWithFooter"):this.$().removeClass("sapMPageWithFooter");}var $=q(this.getDomRef()).find(".sapMPageFooter").last(),u=sap.ui.getCore().getConfiguration().getAnimation();if(!this.getFloatingFooter()){this.setProperty("showFooter",s);return this;}this.setProperty("showFooter",s,true);$.removeClass("sapUiHidden");$.toggleClass("sapMPageFooterControlShow",s);$.toggleClass("sapMPageFooterControlHide",!s);if(s){return this;}if(u){setTimeout(function(){$.toggleClass("sapUiHidden",!s);},j.FOOTER_ANIMATION_DURATION);}else{$.toggleClass("sapUiHidden",!s);}return this;};
j.prototype._updateHeaderContent=function(o,s,k){var I=this._getInternalHeader();if(I){switch(s){case"left":if(k==-1){if(I.getContentLeft()){I.removeContentLeft(o);}}else{if(I.indexOfContentLeft(o)!=k){I.insertContentLeft(o,k);I.invalidate();}}break;case"middle":if(k==-1){if(I.getContentMiddle()){I.removeContentMiddle(o);}}else{if(I.indexOfContentMiddle(o)!=k){I.insertContentMiddle(o,k);I.invalidate();}}break;case"right":if(k==-1){if(I.getContentRight()){I.removeContentRight(o);}}else{if(I.indexOfContentRight(o)!=k){I.insertContentRight(o,k);I.invalidate();}}break;default:break;}}};
j.prototype._getInternalHeader=function(){var I=this.getAggregation("_internalHeader");if(!I){this.setAggregation("_internalHeader",new a(this.getId()+"-intHeader",{titleAlignment:this.getTitleAlignment()}),true);I=this.getAggregation("_internalHeader");if(this.getShowNavButton()&&this._navBtn){this._updateHeaderContent(this._navBtn,"left",0);}if(this.getTitle()&&this._headerTitle){this._updateHeaderContent(this._headerTitle,"middle",0);}}return I;};
j.prototype._getAnyHeader=function(){var o=this.getCustomHeader();if(o){return o.addStyleClass("sapMPageHeader");}return this._getInternalHeader().addStyleClass("sapMPageHeader");};
j.prototype.getScrollDelegate=function(){return this._oScroller;};
j.prototype._formatLandmarkInfo=function(L,p){if(L){var r=L["get"+p+"Role"]()||"",s=L["get"+p+"Label"]()||"";if(r===A.None){r='';}return{role:r.toLowerCase(),label:s};}return{};};
j.prototype._getHeaderTag=function(L){if(L&&L.getHeaderRole()!==A.None){return i;}return H;};
j.prototype._getSubHeaderTag=function(L){if(L&&L.getSubHeaderRole()!==A.None){return i;}return H;};
j.prototype._getFooterTag=function(L){if(L&&L.getFooterRole()!==A.None){return i;}return F;};
j.prototype.scrollTo=function(y,t){if(this._oScroller){this._oScroller.scrollTo(0,y,t);}return this;};
j.prototype.scrollToElement=function(o,t,O){if(o instanceof E){o=o.getDomRef();}if(this._oScroller){this._oScroller.scrollToElement(o,t,O);}return this;};
j.prototype.setCustomHeader=function(o){this.setAggregation("customHeader",o);this.toggleStyleClass("sapFShellBar-CTX",o&&o.isA("sap.f.ShellBar"));if(o&&this.mEventRegistry["_adaptableContentChange"]){this.fireEvent("_adaptableContentChange",{"parent":this,"adaptableContent":o});}return this;};
j.prototype._getAdaptableContent=function(){return this._getAnyHeader();};
return j;});
sap.ui.predefine('sap/m/PageAccessibleLandmarkInfo',['sap/ui/core/Element','./library'],function(E,l){"use strict";
var P=E.extend("sap.m.PageAccessibleLandmarkInfo",{metadata:{library:"sap.m",properties:{rootRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},rootLabel:{type:"string",defaultValue:null},contentRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Main"},contentLabel:{type:"string",defaultValue:null},headerRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},headerLabel:{type:"string",defaultValue:null},subHeaderRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"None"},subHeaderLabel:{type:"string",defaultValue:null},footerRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},footerLabel:{type:"string",defaultValue:null}}}});
return P;});
sap.ui.predefine('sap/m/PageRenderer',["sap/m/library","sap/ui/Device"],function(a,D){"use strict";var P={apiVersion:2};
P.render=function(r,p){var h=null,f=p.getFooter(),s=p.getShowFooter(),S=null,l=this._isLightHeader(p),L=p.getLandmarkInfo();if(p.getShowHeader()){h=p._getAnyHeader();}if(p.getShowSubHeader()){S=p.getSubHeader();}r.openStart("div",p).class("sapMPage").class("sapMPageBg"+p.getBackgroundDesign());if(h){r.class("sapMPageWithHeader");}if(S){r.class("sapMPageWithSubHeader");}if(f&&s){r.class("sapMPageWithFooter");}if(!p.getContentOnlyBusy()){r.class("sapMPageBusyCoversAll");}if(p.getFloatingFooter()){r.class("sapMPageWithFloatingFooter");}r.accessibilityState(p,p._formatLandmarkInfo(L,"Root"));r.openEnd();if(h){this.renderHeader(r,p,h,L,l);}if(S){this.renderSubHeader(r,p,S,L,l);}this.renderChildControls(r,p,L);if(f){this.renderFooter(r,p,f,L);}r.close("div");};
P.renderBarControl=function(r,p,b,o){if(!b){return;}b._applyContextClassFor(o.context.toLowerCase());b.addStyleClass(o.styleClass||"");r.renderControl(b);};
P.renderHeader=function(r,p,h,l,L){var H=p._getHeaderTag(l);r.openStart(H).class("sapMPageHeader").accessibilityState(p,p._formatLandmarkInfo(l,"Header")).openEnd();this.renderBarControl(r,p,h,{context:"header",styleClass:L?"":"sapContrastPlus"});r.close(H);};
P.renderSubHeader=function(r,p,s,l,L){var S=p._getSubHeaderTag(l);r.openStart(S).class("sapMPageSubHeader").accessibilityState(p,p._formatLandmarkInfo(l,"SubHeader"));if(s.getDesign()==a.ToolbarDesign.Info){r.class("sapMPageSubHeaderInfoBar");}r.openEnd();this.renderBarControl(r,p,s,{context:"subHeader",styleClass:L?"":"sapContrastPlus"});r.close(S);};
P.renderChildControls=function(r,p,L){r.openStart("section",p.getId()+"-cont");r.accessibilityState(p,p._formatLandmarkInfo(L,"Content"));if(D.browser.firefox){r.attr("tabindex","-1");}if(p.getEnableScrolling()){r.class("sapMPageEnableScrolling");}r.openEnd();var c=p.getContent();var l=c.length;for(var i=0;i<l;i++){r.renderControl(c[i]);}r.close("section");};
P.renderFooter=function(r,p,f,l){var F=p._getFooterTag(l);r.openStart(F).class("sapMPageFooter");if(!p.getShowFooter()){r.class("sapUiHidden");}if(p.getFloatingFooter()){r.class("sapMPageFloatingFooter");}r.accessibilityState(p,p._formatLandmarkInfo(l,"Footer")).openEnd();this.renderBarControl(r,p,f,{context:"footer"});r.close(F);};
P._isLightHeader=function(p){var c=p,o=p.getParent(),s,C;while(o){s=(o&&o.getMetadata().getName())||"";C=c.getMetadata().getName();if(((s==="sap.m.Popover"||s==="sap.m.Dialog")&&C==="sap.m.NavContainer")||((s==="sap.ui.comp.smartvariants.SmartVariantManagement"||s==="sap.ui.comp.smartvariants.SmartVariantManagementUi2"||s==="sap.ui.comp.variants.VariantManagement"||s==="sap.ui.fl.variants.VariantManagement")&&C==="sap.m.ResponsivePopover")){return true;}if(o&&["sap.m.SplitApp","sap.m.SplitContainer"].indexOf(s)>-1&&C==="sap.m.NavContainer"&&/\-Master$/.test(c.getId())){return true;}c=o;o=c.getParent();}return false;};
return P;},true);
sap.ui.predefine('sap/m/PagingButton',['./Button','sap/ui/core/Control','sap/ui/core/IconPool','./PagingButtonRenderer',"sap/base/Log"],function(B,C,I,P,L){"use strict";
var a=C.extend("sap.m.PagingButton",{metadata:{library:"sap.m",properties:{count:{type:"int",group:"Data",defaultValue:1},position:{type:"int",group:"Data",defaultValue:1},nextButtonTooltip:{type:"string",group:"Appearance",defaultValue:""},previousButtonTooltip:{type:"string",group:"Appearance",defaultValue:""}},aggregations:{previousButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},nextButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{positionChange:{parameters:{newPosition:{type:"int"},oldPosition:{type:"int"}}}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
a.prototype.init=function(){this._attachPressEvents();};
a.prototype.onBeforeRendering=function(){this._enforceValidPosition(this.getPosition());this._updateButtonState();};
a.prototype._getNextButton=function(){if(!this.getAggregation("nextButton")){this.setAggregation("nextButton",new B({tooltip:this.getNextButtonTooltip()||r.getText("PAGINGBUTTON_NEXT"),icon:I.getIconURI("slim-arrow-down"),enabled:false,id:this.getId()+"-nextButton"}));}return this.getAggregation("nextButton");};
a.prototype._getPreviousButton=function(){if(!this.getAggregation("previousButton")){this.setAggregation("previousButton",new B({tooltip:this.getPreviousButtonTooltip()||r.getText("PAGINGBUTTON_PREVIOUS"),icon:I.getIconURI("slim-arrow-up"),enabled:false,id:this.getId()+"-previousButton"}));}return this.getAggregation("previousButton");};
a.prototype._attachPressEvents=function(){this._getPreviousButton().attachPress(this._handlePositionChange.bind(this,false));this._getNextButton().attachPress(this._handlePositionChange.bind(this,true));};
a.prototype._handlePositionChange=function(i){var o=this.getPosition(),n=i?o+1:o-1;this.setPosition(n);this.firePositionChange({newPosition:n,oldPosition:o});this._updateButtonState();return this;};
a.prototype._updateButtonState=function(){var t=this.getCount(),c=this.getPosition();this._getPreviousButton().setEnabled(c>1);this._getNextButton().setEnabled(c<t);return this;};
a.prototype.setPosition=function(p){return this._validateProperty("position",p);};
a.prototype.setCount=function(c){return this._validateProperty("count",c);};
a.prototype.setPreviousButtonTooltip=function(t){this._getPreviousButton().setTooltip(t);return this.setProperty("previousButtonTooltip",t,true);};
a.prototype.setNextButtonTooltip=function(t){this._getNextButton().setTooltip(t);return this.setProperty("nextButtonTooltip",t,true);};
a.prototype._validateProperty=function(p,v){if(v<1){L.warning("Property '"+p+"' must be greater or equal to 1",this);return this;}return this.setProperty(p,v);};
a.prototype._enforceValidPosition=function(p){var c=this.getCount();if(p>c){L.warning("Property position must be less or equal to the total count");this.setPosition(c);}return this;};
return a;});
sap.ui.predefine('sap/m/PagingButtonRenderer',[],function(){"use strict";var P={apiVersion:2};
P.render=function(r,c){var n=c._getNextButton(),p=c._getPreviousButton();r.openStart("div",c);r.class("sapMPagingButton");r.openEnd();r.renderControl(p);r.renderControl(n);r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/Panel',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/Device','./PanelRenderer','sap/m/Button'],function(l,C,I,D,P,B){"use strict";var a=l.PanelAccessibleRole;var b=l.BackgroundDesign;var c=l.ButtonType;
var d=C.extend("sap.m.Panel",{metadata:{library:"sap.m",properties:{headerText:{type:"string",group:"Data",defaultValue:""},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"auto"},expandable:{type:"boolean",group:"Appearance",defaultValue:false},expanded:{type:"boolean",group:"Appearance",defaultValue:false},expandAnimation:{type:"boolean",group:"Behavior",defaultValue:true},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:b.Translucent},accessibleRole:{type:"sap.m.PanelAccessibleRole",group:"Accessibility",defaultValue:a.Form}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},headerToolbar:{type:"sap.m.Toolbar",multiple:false},infoToolbar:{type:"sap.m.Toolbar",multiple:false}},events:{expand:{parameters:{expand:{type:"boolean"},triggeredByInteraction:{type:"boolean"}}}},dnd:{draggable:true,droppable:true},designtime:"sap/m/designtime/Panel.designtime"}});
d.prototype.init=function(){this._bInteractiveExpand=false;this.data("sap-ui-fastnavgroup","true",true);};
d.prototype.onThemeChanged=function(){this._setContentHeight();};
d.prototype.setExpanded=function(e){var t=this;if(e===this.getExpanded()){return this;}this.setProperty("expanded",e,true);if(!this.getExpandable()){return this;}this._toggleExpandCollapse(function(){t.invalidate();});this._toggleButtonIcon(e);this.fireExpand({expand:e,triggeredByInteraction:this._bInteractiveExpand});this._bInteractiveExpand=false;return this;};
d.prototype.onBeforeRendering=function(){if(this.getExpandable()&&!this._oExpandButton){this._oExpandButton=this._createExpandButton();}if(sap.ui.getCore().getConfiguration().getAccessibility()){this.$().attr("role",this.getAccessibleRole().toLowerCase());}};
d.prototype.onAfterRendering=function(){var $=this.$(),p=this.getDomRef("content"),h,o=this.getDomRef();if(o){o.style.width=this.getWidth();h=this.getHeight();o.style.height=h;if(parseFloat(h)!=0){o.querySelector(".sapMPanelContent").style.height=h;}}this._setContentHeight();if(this.getExpandable()){this.getHeaderToolbar()&&p&&this._oExpandButton.$().attr("aria-controls",p.id);if(!this.getExpanded()){$.children(".sapMPanelExpandablePart").css("display","none");}}};
d.prototype.ontap=function(e){var o=this.getDomRef(),w=o&&o.querySelector(".sapMPanelWrappingDiv");if(!this.getExpandable()||this.getHeaderToolbar()||!w){return;}if(w.contains(e.target)){this._bInteractiveExpand=true;this.setExpanded(!this.getExpanded());}};
d.prototype.onsapspace=function(e){this.ontap(e);};
d.prototype.onsapenter=function(e){this.ontap(e);};
d.prototype.exit=function(){if(this._oExpandButton){this._oExpandButton.destroy();this._oExpandButton=null;}};
d.prototype._createExpandButton=function(){var t=this,i=this.getExpanded()?I.getIconURI("slim-arrow-down"):I.getIconURI("slim-arrow-right"),T=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PANEL_ICON"),o;if(!this.getHeaderToolbar()){return I.createControlByURI({src:i,tooltip:T});}o=new B(this.getId()+"-expandButton",{icon:i,tooltip:T,type:c.Transparent,press:function(){t._bInteractiveExpand=true;t.setExpanded(!t.getExpanded());}}).addEventDelegate({onAfterRendering:function(){o.$().attr("aria-expanded",this.getExpanded());}.bind(this)},this);this.addDependent(o);return o;};
d.prototype._toggleButtonIcon=function(i){var s=i?I.getIconURI("slim-arrow-down"):I.getIconURI("slim-arrow-right");if(!this._oExpandButton){return;}if(this.getHeaderToolbar()){this._oExpandButton.setIcon(s);}else{this._oExpandButton.setSrc(s);}};
d.prototype._setContentHeight=function(){var A,t=this.getDomRef(),p=t&&t.querySelector(".sapMPanelContent");if(this.getHeight()==="auto"||!p){return;}A='calc('+"100%"+' - '+p.offsetTop+'px)';p.style.height=A;};
d.prototype._toggleExpandCollapse=function(A){var o={complete:A};if(!this.getExpandAnimation()){o.duration=0;}this.$().children(".sapMPanelExpandablePart").slideToggle(o);};
d.prototype._getLabellingElementId=function(){var h=this.getHeaderToolbar(),H=this.getHeaderText(),i=null;if(h){i=h.getTitleId();}else if(H){i=this.getId()+"-header";}return i;};
return d;});
sap.ui.predefine('sap/m/PanelRenderer',["sap/m/library","sap/ui/Device"],function(l,D){"use strict";var T=l.ToolbarDesign;var P={apiVersion:2};
P.render=function(r,c){this.startPanel(r,c);this.renderHeader(r,c);this.renderContent(r,c);this.endPanel(r);};
P.startPanel=function(r,c){var i=c.getExpandable(),a={role:c.getAccessibleRole().toLowerCase()};r.openStart("div",c);r.class("sapMPanel");if(i){r.class("sapMPanelExpandable");}r.style("width",c.getWidth());r.style("height",c.getHeight());if(c.getHeaderToolbar()||!i){a.labelledby=c._getLabellingElementId();}r.accessibilityState(c,a);r.openEnd();};
P.renderHeader=function(r,c){var i=c.getExpandable(),I=c.getExpanded(),h=c.getHeaderToolbar(),H,s=h?"header":"div";if(i){r.openStart(s);if(h){H="sapMPanelWrappingDivTb";}else{H="sapMPanelWrappingDiv";this.writeHeaderAccessibility(r,c);}r.class(H);if(I){r.class(H+"Expanded");}r.openEnd();if(i){r.renderControl(c._oExpandButton);}}var a=c.getHeaderText();if(h){h.setDesign(T.Transparent,true);h.addStyleClass("sapMPanelHeaderTB");r.renderControl(h);}else if(a||i){r.openStart("h2",c.getId()+"-header");r.class("sapMPanelHdr");r.openEnd();r.text(a);r.close("h2");}if(i){r.close(s);}var o=c.getInfoToolbar();if(o){o.setDesign(T.Info,true);o.addStyleClass("sapMPanelInfoTB");if(i){r.openStart("div");r.class("sapMPanelExpandablePart");r.openEnd();r.renderControl(o);r.close("div");}else{r.renderControl(o);}}};
P.writeHeaderAccessibility=function(r,c){r.attr('tabindex',0);r.attr('role','button');r.attr('aria-expanded',c.getExpanded());r.attr('aria-controls',c.getId()+"-content");};
P.renderContent=function(r,c){this.startContent(r,c);this.renderChildren(r,c.getContent());this.endContent(r);};
P.startContent=function(r,c){r.openStart("div",c.getId()+"-content");r.class("sapMPanelContent");r.class("sapMPanelBG"+c.getBackgroundDesign());if(c.getExpandable()){r.class("sapMPanelExpandablePart");}if(D.browser.firefox){r.attr('tabindex','-1');}r.openEnd();};
P.renderChildren=function(r,c){c.forEach(r.renderControl,r);};
P.endContent=function(r){r.close("div");};
P.endPanel=function(r){r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendar',['sap/m/delegate/DateNavigation','sap/ui/core/Control','sap/ui/base/ManagedObjectObserver','sap/ui/unified/library','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/DatesRow','sap/ui/unified/calendar/OneMonthDatesRow','sap/ui/unified/calendar/MonthsRow','sap/ui/unified/calendar/TimesRow','sap/ui/unified/DateRange','sap/ui/unified/DateTypeRange','sap/ui/unified/CalendarAppointment','sap/ui/unified/CalendarRow','sap/ui/unified/CalendarRowRenderer','sap/ui/Device','sap/ui/core/Core','sap/ui/core/Element','sap/ui/core/Renderer','sap/ui/core/ResizeHandler','sap/ui/core/InvisibleText','sap/ui/core/Item','sap/ui/core/dnd/DragInfo','sap/ui/core/dnd/DropInfo','sap/ui/core/dnd/DragDropInfo','sap/ui/core/format/DateFormat','sap/m/Select','sap/m/Button','sap/m/OverflowToolbar','sap/m/Toolbar','sap/m/Table','sap/m/Column','sap/m/ColumnListItem','sap/m/ColumnListItemRenderer','sap/m/SegmentedButtonItem','sap/m/StandardListItem','sap/m/StandardListItemRenderer','sap/m/PlanningCalendarHeader','sap/m/PlanningCalendarRow','sap/m/PlanningCalendarRenderer','sap/m/PlanningCalendarView','sap/m/CheckBox','sap/m/library',"sap/base/util/deepEqual","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(D,C,M,u,a,b,c,O,d,T,e,f,g,h,k,l,m,E,R,n,I,o,p,q,r,s,S,B,t,v,w,y,z,A,F,G,H,P,J,K,L,N,Q,U,V,W){"use strict";var X=Q.Sticky;var Y=u.CalendarDayType;var Z=Q.ListMode;var $=Q.ToolbarDesign;var _=Q.PlanningCalendarBuiltInView;var a1=Q.ScreenSize;var b1=u.CalendarAppointmentVisualization;var c1=u.GroupAppointmentsMode;var d1=u.CalendarIntervalType;var e1=u.CalendarAppointmentHeight;var f1=u.CalendarAppointmentRoundWidth;var g1="DragDropConfig";var h1="ResizeConfig";var i1="CreateConfig";var j1="-CLI";
var k1=C.extend("sap.m.PlanningCalendar",{
metadata:{library:"sap.m",properties:{startDate:{type:"object",group:"Data"},viewKey:{type:"string",group:"Appearance",defaultValue:d1.Hour},singleSelection:{type:"boolean",group:"Misc",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},showIntervalHeaders:{type:"boolean",group:"Appearance",defaultValue:true},showEmptyIntervalHeaders:{type:"boolean",group:"Appearance",defaultValue:true},showRowHeaders:{type:"boolean",group:"Appearance",defaultValue:true},noDataText:{type:"string",group:"Misc",defaultValue:null},groupAppointmentsMode:{type:"sap.ui.unified.GroupAppointmentsMode",group:"Appearance",defaultValue:c1.Collapsed},appointmentsReducedHeight:{type:"boolean",group:"Appearance",defaultValue:false},appointmentHeight:{type:"sap.ui.unified.CalendarAppointmentHeight",group:"Appearance",defaultValue:e1.Regular},appointmentRoundWidth:{type:"sap.ui.unified.CalendarAppointmentRoundWidth",group:"Appearance",defaultValue:f1.None},appointmentsVisualization:{type:"sap.ui.unified.CalendarAppointmentVisualization",group:"Appearance",defaultValue:b1.Standard},minDate:{type:"object",group:"Misc",defaultValue:null},maxDate:{type:"object",group:"Misc",defaultValue:null},showDayNamesLine:{type:"boolean",group:"Appearance",defaultValue:false},showWeekNumbers:{type:"boolean",group:"Appearance",defaultValue:false},builtInViews:{type:"string[]",group:"Appearance",defaultValue:[]},stickyHeader:{type:"boolean",group:"Appearance",defaultValue:false},firstDayOfWeek:{type:"int",group:"Appearance",defaultValue:-1},multipleAppointmentsSelection:{type:"boolean",group:"Data",defaultValue:false}},aggregations:{rows:{type:"sap.m.PlanningCalendarRow",multiple:true,singularName:"row"},views:{type:"sap.m.PlanningCalendarView",multiple:true,singularName:"view"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},toolbarContent:{type:"sap.ui.core.Control",multiple:true,singularName:"toolbarContent",forwarding:{getter:"_getHeader",aggregation:"actions"},forwardBinding:true},table:{type:"sap.m.Table",multiple:false,visibility:"hidden"},header:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.ui.unified.CalendarLegend",multiple:false}},events:{appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"},multiSelect:{type:"boolean"},domRefId:{type:"string"}}},intervalSelect:{parameters:{startDate:{type:"object"},endDate:{type:"object"},subInterval:{type:"boolean"},row:{type:"sap.m.PlanningCalendarRow"}}},rowSelectionChange:{parameters:{rows:{type:"sap.m.PlanningCalendarRow[]"}}},startDateChange:{},viewChange:{},rowHeaderClick:{parameters:{headerId:{type:"string"},row:{type:"sap.m.PlanningCalendarRow"}}}},designtime:"sap/m/designtime/PlanningCalendar.designtime"},
constructor:function(i,j){C.prototype.constructor.apply(this,arguments);if(typeof i!=="string"){j=i;}if(j&&typeof j.customAppointmentsSorterCallback==="function"){this._fnCustomSortedAppointments=j.customAppointmentsSorterCallback;}}
});
var l1=["_oTimesRow","_oDatesRow","_oMonthsRow","_oWeeksRow","_oOneMonthsRow"],m1={};m1[d1.Day]={sInstanceName:"_oDatesRow",sIdSuffix:"-DatesRow",oClass:c};m1[d1.Week]={sInstanceName:"_oWeeksRow",sIdSuffix:"-WeeksRow",oClass:c};m1[d1.OneMonth]={sInstanceName:"_oOneMonthsRow",sIdSuffix:"-OneMonthsRow",oClass:O};var n1=a1.Desktop;var o1=[_.Hour,_.Day,_.Month,_.Week,_.OneMonth];var p1={PHONE:"600",TABLET:"1024"};var q1={MONTH:"month",MONTH_PICKER:"monthPicker",YEAR_PICKER:"yearPicker",YEAR_RANGE_PICKER:"yearRangePicker"};var r1={onAfterRendering:function(){this.setProperty("_currentPicker",q1.MONTH);this.removeDelegate(r1);}};var s1={onAfterRendering:function(){this.setProperty("_currentPicker",q1.MONTH_PICKER);this.removeDelegate(s1);}};var t1={onAfterRendering:function(){this.setProperty("_currentPicker",q1.YEAR_PICKER);this.removeDelegate(t1);}};var u1=["sap.ui.unified.calendar.TimesRow","sap.ui.unified.calendar.DatesRow","sap.ui.unified.calendar.MonthsRow","sap.ui.unified.calendar.OneMonthDatesRow"];
var v1=C.extend("sap.m._PlanningCalendarInternalHeader",{
metadata:{aggregations:{"toolbar":{type:"sap.m.Toolbar",multiple:false},"allCheckBox":{type:"sap.m.CheckBox",multiple:false}}},
renderer:{apiVersion:2,render:function(i,j){i.openStart("div",j);i.class("sapMPlanCalHead");i.openEnd();var x=j.getToolbar();if(x){i.renderControl(x);}var W1=j.getAllCheckBox();if(W1){i.renderControl(W1);}i.close("div");}}
});
k1.prototype.init=function(){this._dateNav=new D();this._iBreakPointTablet=l.media._predefinedRangeSets[l.media.RANGESETS.SAP_STANDARD_EXTENDED].points[0];this._iBreakPointDesktop=l.media._predefinedRangeSets[l.media.RANGESETS.SAP_STANDARD_EXTENDED].points[1];this._iBreakPointLargeDesktop=l.media._predefinedRangeSets[l.media.RANGESETS.SAP_STANDARD_EXTENDED].points[2];if(l.system.phone||W('html').hasClass("sapUiMedia-Std-Phone")){this._iSize=0;this._iSizeScreen=0;}else if((l.system.tablet||W('html').hasClass("sapUiMedia-Std-Tablet"))&&!(l.system.desktop||W('html').hasClass("sapUiMedia-Std-Desktop"))){this._iSize=1;this._iSizeScreen=1;}else{this._iSize=2;this._iSizeScreen=2;}this.addStyleClass("sapMSize"+this._iSize);this.setAggregation("header",this._createHeader());this._attachHeaderEvents();this._oRB=m.getLibraryResourceBundle("sap.m");var i=this.getId();this._oIntervalTypeSelect=this._getHeader()._getOrCreateViewSwitch();this._oIntervalTypeSelect.attachEvent("selectionChange",w1,this);this._oTodayButton=this._getHeader()._getTodayButton();this._oCalendarHeader=new v1(i+"-CalHead",{});this._oCalendarHeader.isRelative=this.isRelative.bind(this);this._oCalendarHeader._getRelativeInfo=this._getRelativeInfo.bind(this);this._oInfoToolbar=new v(i+"-InfoToolbar",{height:"auto",design:$.Transparent,content:[this._oCalendarHeader,this._oTimesRow],ariaLabelledBy:I.getStaticId("sap.m","PC_INTERVAL_TOOLBAR")});var j=new w(i+"-Table",{sticky:[],infoToolbar:this._oInfoToolbar,mode:Z.SingleSelectMaster,columns:[new y({styleClass:"sapMPlanCalRowHead"}),new y({width:"80%",styleClass:"sapMPlanCalAppRow",minScreenWidth:n1,demandPopin:true})],ariaLabelledBy:i+"-Descr"});j.attachEvent("selectionChange",M1,this);j.addDelegate({onBeforeRendering:function(){if(this._rowHeaderClickEvent){this._rowHeaderClickEvent.off();}},onAfterRendering:function(){this._rowHeaderClickEvent=j.$().find(".sapMPlanCalRowHead > div.sapMLIB").on("click",function(x){var W1=W(x.currentTarget).control(0),X1=I1(W1.getParent()),Y1=W1.getId();this.fireRowHeaderClick({headerId:Y1,row:X1});}.bind(this));this._adjustColumnHeadersTopOffset();}},false,this);j.getStickyFocusOffset=V1.bind(this);this.setAggregation("table",j,true);this.setStartDate(new Date());this._resizeProxy=A1.bind(this);this._fnCustomSortedAppointments=undefined;this.iWidth=0;};
k1.prototype.exit=function(){if(this._sResizeListener){n.deregister(this._sResizeListener);this._sResizeListener=undefined;}l.orientation.detachHandler(this._updateStickyHeader,this);if(this._sUpdateCurrentTime){clearTimeout(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}var i=this.getAggregation("table");i.removeAllItems();l1.forEach(function(x){if(this[x]){this[x]._oPlanningCalendar=undefined;this[x].destroy();this[x]=undefined;}},this);if(this._oViews){for(var j in this._oViews){this._oViews[j].destroy();}}if(this._oSelectAllCheckBox){this._oSelectAllCheckBox.destroy();}if(this._rowHeaderClickEvent){this._rowHeaderClickEvent.off();this._rowHeaderClickEvent=null;}};
k1.prototype.onBeforeRendering=function(){this._bBeforeRendering=true;this._adjustViewKey();P1.call(this);if(this._sUpdateCurrentTime){clearTimeout(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}this._updatePickerSelection();this._updateHeaderButtons();l.orientation.detachHandler(this._updateStickyHeader,this);this._bBeforeRendering=undefined;this._toggleStickyClasses();};
k1.prototype.attachEvent=function(i,j,x,W1){C.prototype.attachEvent.call(this,i,j,x,W1);if(this.hasListeners("intervalSelect")){l1.forEach(function(X1){if(this[X1]){this[X1]._setAriaRole("button");}},this);}return this;};
k1.prototype.detachEvent=function(i,j,x){C.prototype.detachEvent.call(this,i,j,x);if(!this.hasListeners("intervalSelect")){l1.forEach(function(W1){if(this[W1]){this[W1]._setAriaRole("gridcell");}},this);}return this;};
k1.prototype._createHeader=function(){var i=new P(this.getId()+"-Header");i._getRelativeInfo=this._getRelativeInfo.bind(this);i.getAggregation("_actionsToolbar").addAriaLabelledBy(I.getStaticId("sap.m","PC_FUNCTIONS_TOOLBAR"));i.getAggregation("_navigationToolbar").addAriaLabelledBy(I.getStaticId("sap.m","PC_INTERVAL_SELECTION_TOOLBAR"));return i;};
k1.prototype._attachHeaderEvents=function(){var i=this._getHeader();i.attachEvent("pressPrevious",this._handlePressArrow,this);i.attachEvent("pressToday",this._handleTodayPress,this);i.attachEvent("pressNext",this._handlePressArrow,this);i.attachEvent("dateSelect",this._handleDateSelect,this);return this;};
k1.prototype._handlePressArrow=function(i){this._applyArrowsLogic(i.getId()==="pressPrevious");};
k1.prototype._applyArrowsLogic=function(i){if(i){this._dateNav.previous();}else{this._dateNav.next();}if(this.getMinDate()&&this._dateNav.getStart().getTime()<=this.getMinDate().getTime()){this._dateNav.setStart(this.getMinDate());this._dateNav.setCurrent(this.getMinDate());}if(this.getMaxDate()&&this._dateNav.getEnd().getTime()>=this.getMaxDate().getTime()){this._dateNav.setStart(this.getMaxDate());this._dateNav.setCurrent(this.getMaxDate());}var j=this._getRowInstanceByViewKey(this.getViewKey());this.setStartDate(this._dateNav.getStart());j.displayDate(this._dateNav.getCurrent());this._updatePickerSelection();this.fireStartDateChange();};
k1.prototype._formatPickerText=function(){var i=this._getFirstAndLastRangeDate(),j=a._createLocalDate(i.oStartDate,true),x=a._createLocalDate(i.oEndDate,true),W1=this.getViewKey(),X1=d1[W1]?d1[W1]:this._getView(W1).getIntervalType(),Y1=m.getConfiguration().getRTL(),Z1,$1,_1,a2;switch(X1){case d1.Hour:Z1=s.getDateInstance({format:"yMMMMd"});_1=Z1.format(j);if(j.getDate()!==x.getDate()){a2=Z1.format(x);}break;case d1.Day:case d1.Week:var b2=this._getView(W1).getIntervalLabelFormatter();if(this.isRelative()){var c2=this.calcIntervalOffset(this.getStartDate());var d2=this.calcIntervalOffset(this.getEndDate())-this.calcIntervalOffset(this.getStartDate());_1=b2?b2(c2):c2;a2=b2?b2(c2+d2-1):c2+d2;}else{Z1=s.getDateInstance({format:"yMMMMd"});_1=Z1.format(j);a2=Z1.format(x);}break;case d1.OneMonth:case"OneMonth":Z1=s.getDateInstance({format:"yMMMM"});_1=Z1.format(j);break;case d1.Month:Z1=s.getDateInstance({format:"y"});_1=Z1.format(j);if(j.getFullYear()!==x.getFullYear()){a2=Z1.format(x);}break;default:throw new Error("Unknown IntervalType: "+W1+"; "+this);}if(!Y1){$1=_1;if(a2){$1+=" - "+a2;}}else{if(a2){$1=a2+" - "+_1;}else{$1=_1;}}return $1;};
k1.prototype._getFirstAndLastRangeDate=function(){var i=a._createUniversalUTCDate(this.getStartDate(),"Gregorian",true),j=a._createUniversalUTCDate(this._dateNav.getEnd(),"Gregorian",true);return{oStartDate:i,oEndDate:j};};
k1.prototype._getHeader=function(){return this.getAggregation("header");};
k1.prototype._toggleStickyClasses=function(){this.toggleStyleClass("sapMPCSticky",this.getStickyHeader());return this;};
k1.prototype._adjustColumnHeadersTopOffset=function(){var i=this.getStickyHeader(),j=this.getDomRef().querySelector(".sapMListInfoTBarContainer"),x;switch(i){case true:x=this._getHeader().$().outerHeight()+"px";break;default:x="auto";break;}j.style.top=x;return this;};
k1.prototype.getEndDate=function(){return this._dateNav.getEnd();};
k1.prototype.getVisibleIntervalsCount=function(){var i=this.getViewKey();if((i===d1.OneMonth||i==="OneMonth")&&this._iSize<2){var j=a.getFirstDateOfWeek(this.getStartDate()),x=a.getFirstDateOfWeek(this._dateNav.getEnd()),W1=new Date(x.getTime());W1.setDate(W1.getDate()+6);return((W1.getTime()-j.getTime())/86400000)+1;}else{return this._getIntervals(this._getView(this.getViewKey()));}};
k1.prototype._setAriaRole=function(i){if(this.hasListeners("intervalSelect")){i._setAriaRole("button");}else{i._setAriaRole("gridcell");}};
k1.prototype._updateTodayButtonState=function(){if(!this._oTodayButton){return;}if(this.isRelative()){this._oTodayButton.setEnabled(false);return;}this._oTodayButton.setEnabled(!this._dateMatchesVisibleRange(new Date(),this.getViewKey()));};
k1.prototype._dateMatchesVisibleRange=function(i,j){var x=this._getView(j,!this._bBeforeRendering);if(!x){return false;}var W1=x.getIntervalType(),X1=m1[W1],Y1=X1?this[X1.sInstanceName]:null,Z1=false;if(Y1&&j==="One Month"){return a._isSameMonthAndYear(b.fromLocalJSDate(this.getStartDate()),b.fromLocalJSDate(i));}else if(Y1&&j==="Week"){var $1=Y1.getDays(),_1=b.fromLocalJSDate(i),a2=b.fromLocalJSDate(this.getStartDate()),b2=b.fromLocalJSDate(this.getStartDate());b2.setDate(b2.getDate()+$1);return _1.isSameOrAfter(a2)&&_1.isBefore(b2);}return Z1;};
k1.prototype.onAfterRendering=function(i){i.size={width:this.getDomRef().offsetWidth};A1.call(this,i,true);if(!this._sResizeListener){this._sResizeListener=n.register(this,this._resizeProxy);}if(l.system.phone&&this.getStickyHeader()){l.orientation.attachHandler(this._updateStickyHeader,this);}this._updateCurrentTimeVisualization(false);if(this.getHeight()){var j=this.getDomRef().querySelector("table");if(this.getHeight().indexOf("%")>-1){j.style.height=this.getHeight();return;}var x=this.$().height()-this._oInfoToolbar.$().height()+"px";j.style.height=x;}this._adjustColumnHeadersTopOffset();};
k1.prototype.onThemeChanged=function(){if(this.getDomRef()){this._adjustColumnHeadersTopOffset();}};
k1.prototype.addToolbarContent=function(i){if(i&&i.isA("sap.m.Title")){this._observeHeaderTitleText(i);this._getHeader().setTitle(i.getText());i.setVisible(false);}this.addAggregation("toolbarContent",i);return this;};
k1.prototype.insertToolbarContent=function(i,j){if(i&&i.isA("sap.m.Title")){this._observeHeaderTitleText(i);this._getHeader().setTitle(i.getText());i.setVisible(false);}this.insertAggregation("toolbarContent",i,j);return this;};
k1.prototype.removeToolbarContent=function(i){var j;if(i&&i.isA("sap.m.Title")){this._getHeader().setTitle("");this._disconnectAndDestroyHeaderObserver();}else{j=this.removeAggregation("toolbarContent",i);}return j;};
k1.prototype.removeAllToolbarContent=function(){var i=this.removeAllAggregation("toolbarContent");this._getHeader().setTitle("");this._disconnectAndDestroyHeaderObserver();return i;};
k1.prototype.destroyToolbarContent=function(){var i=this.destroyAggregation("toolbarContent");this._getHeader().setTitle("");this._disconnectAndDestroyHeaderObserver();return i;};
k1.prototype._getHeaderObserver=function(){if(!this._oHeaderObserver){this._oHeaderObserver=new M(this._handleTitleTextChange.bind(this));}return this._oHeaderObserver;};
k1.prototype._observeHeaderTitleText=function(i){this._getHeaderObserver().observe(i,{properties:["text"]});};
k1.prototype._handleTitleTextChange=function(i){this._getHeader().setTitle(i.current);};
k1.prototype._disconnectAndDestroyHeaderObserver=function(){if(this._oHeaderObserver){this._oHeaderObserver.disconnect();this._oHeaderObserver.destroy();this._oHeaderObserver=null;}};
k1.prototype.setStartDate=function(i){var j;if(!i){j=new Date();}else{a._checkJSDateObject(i);j=new Date(i.getTime());}j=this._shiftStartDate(j);if(U(j,this.getStartDate())){this._updateTodayButtonState();return this;}var x=j.getFullYear();a._checkYearInValidRange(x);var W1=this.getMinDate();if(W1&&W1.getTime()>j.getTime()){V.warning("StartDate < minDate -> StartDate set to minDate",this);j=new Date(W1.getTime());}else{var X1=this.getMaxDate();if(X1&&X1.getTime()<j.getTime()){V.warning("StartDate > maxDate -> StartDate set to minDate",this);if(W1){j=new Date(W1.getTime());}else{j=new Date(1,0,1);j.setFullYear(1);}}}this.setProperty("startDate",j,true);this._dateNav.setStart(j);this._dateNav.setCurrent(j);this._getHeader().setStartDate(j);l1.forEach(function(Y1){if(this[Y1]){this[Y1].setStartDate(new Date(j.getTime()));}},this);if((this.getViewKey()===_.OneMonth||this.getViewKey()==="OneMonth")&&this._oOneMonthsRow.getMode()<2&&this._oOneMonthsRow.getSelectedDates().length){this._setRowsStartDate(this._oOneMonthsRow.getSelectedDates()[0].getStartDate());}else{this._setRowsStartDate(new Date(j.getTime()));}if(this.getViewKey()===_.Week||this.getViewKey()===_.OneMonth||this.getViewKey()==="OneMonth"){this._updateTodayButtonState();}if(this.getDomRef()){this._updateCurrentTimeVisualization(false);this._updatePickerSelection();}this._updateHeaderButtons();return this;};
k1.prototype.setMinDate=function(i){if(U(i,this.getMinDate())){return this;}var j=this.getMaxDate(),x=this._getHeader();if(i){a._checkJSDateObject(i);var W1=i.getFullYear();a._checkYearInValidRange(W1);this.setProperty("minDate",i,true);this._bNoStartDateChange=true;x.getAggregation("_calendarPicker").setMinDate(new Date(i.getTime()));x.getAggregation("_monthPicker").setMinDate(new Date(i.getTime()));x.getAggregation("_yearPicker").setMinDate(new Date(i.getTime()));if(j&&j.getTime()<i.getTime()){V.warning("minDate > maxDate -> maxDate set to end of the month",this);j=new Date(i.getTime());j.setMonth(j.getMonth()+1,0);j.setHours(23);j.setMinutes(59);j.setSeconds(59);j.setMilliseconds(0);this.setMaxDate(j);}this._bNoStartDateChange=undefined;var X1=this.getStartDate();if(X1&&X1.getTime()<i.getTime()){V.warning("StartDate < minDate -> StartDate set to minDate",this);X1=new Date(i.getTime());this.setStartDate(X1);x.setPickerText(this._formatPickerText());}}else{this.setProperty("minDate",undefined,true);x.getAggregation("_calendarPicker").setMinDate();x.getAggregation("_monthPicker").setMinDate();x.getAggregation("_yearPicker").setMinDate();}var Y1=new Date();if(i&&Y1.getTime()<i.getTime()){this._oTodayButton.setVisible(false);}else if(!j||Y1.getTime()<j.getTime()){this._oTodayButton.setVisible(true);}return this;};
k1.prototype.setMaxDate=function(i){if(U(i,this.getMaxDate())){return this;}var j=this.getMinDate(),x=this._getHeader();if(i){a._checkJSDateObject(i);var W1=i.getFullYear();a._checkYearInValidRange(W1);this.setProperty("maxDate",i,true);this._bNoStartDateChange=true;x.getAggregation("_calendarPicker").setMaxDate(new Date(i.getTime()));x.getAggregation("_monthPicker").setMaxDate(new Date(i.getTime()));x.getAggregation("_yearPicker").setMaxDate(new Date(i.getTime()));if(j&&j.getTime()>i.getTime()){V.warning("maxDate < minDate -> maxDate set to begin of the month",this);j=new Date(i.getTime());j.setDate(1);j.setHours(0);j.setMinutes(0);j.setSeconds(0);j.setMilliseconds(0);this.setMinDate(j);}this._bNoStartDateChange=undefined;var X1=this.getStartDate();if(X1&&X1.getTime()>i.getTime()){V.warning("StartDate > maxDate -> StartDate set to minDate",this);if(j){X1=new Date(j.getTime());}else{X1=new Date(1,0,1);X1.setFullYear(1);}this.setStartDate(X1);x.setPickerText(this._formatPickerText());}}else{this.setProperty("maxDate",undefined,true);x.getAggregation("_calendarPicker").setMaxDate();x.getAggregation("_monthPicker").setMaxDate();x.getAggregation("_yearPicker").setMaxDate();}var Y1=new Date();if(i&&Y1.getTime()>i.getTime()){this._oTodayButton.setVisible(false);}else if(!j||Y1.getTime()>j.getTime()){this._oTodayButton.setVisible(true);}return this;};
k1.prototype.removeIntervalInstanceFromInfoToolbar=function(){var i=this._oInfoToolbar.getContent();i.forEach(function(j){if(j.isA(u1)){this._oInfoToolbar.removeContent(j);}}.bind(this));};
k1.prototype.isRelative=function(){var i=this._getView(this.getViewKey(),true);if(!i){return false;}return i.getRelative();};
k1.prototype.setViewKey=function(j){var x,W1,X1,Y1=this.getViewKey(),Z1=this._getHeader(),$1;this.setProperty("viewKey",j,true);this._oIntervalTypeSelect.setSelectedKey(j);this.removeIntervalInstanceFromInfoToolbar();var _1=this.getStartDate();var a2=this.getMinDate();var b2=this.getMaxDate();var c2=this._getView(j,!this._bBeforeRendering);var d2;if(!c2){this._bCheckView=true;this.invalidate();}else{var e2=c2.getIntervalType();var f2=c2.getIntervalSize();var g2=this._getIntervals(c2);this._bCheckView=false;this._dateNav.setUnit(e2);this._dateNav.setStep(g2*f2);this._dateNav.setCurrent(undefined);switch(e2){case d1.Hour:if(!this._oTimesRow){this._oTimesRow=new T(this.getId()+"-TimesRow",{startDate:new Date(_1.getTime()),items:g2,legend:this.getLegend()});this._setAriaRole(this._oTimesRow);this._oTimesRow._setLegendControlOrigin(this);this._oTimesRow.attachEvent("focus",this._handleFocus,this);this._oTimesRow.attachEvent("select",this._handleCalendarSelect,this);this._oTimesRow._oPlanningCalendar=this;this._oTimesRow._getSpecialDates=function(){return this._oPlanningCalendar._getSpecialDates();};this._oTimesRow.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};}else if(this._oTimesRow.getItems()!==g2){this._oTimesRow.setItems(g2);this._dateNav.setStep(g2*f2);}this._insertInterval(this._oTimesRow);d2=Z1.getAggregation("_calendarPicker")?Z1.getAggregation("_calendarPicker"):Z1._oPopup.getContent()[0];d2.addDelegate(r1,d2);Z1.setAssociation("currentPicker",d2);break;case d1.Day:case d1.Week:case d1.OneMonth:case"OneMonth":X1=m1[e2];x=this[X1.sInstanceName];if(!x){x=new X1.oClass(this.getId()+X1.sIdSuffix,{startDate:new Date(_1.getTime()),days:g2,showDayNamesLine:this.getShowDayNamesLine(),legend:this.getLegend(),showWeekNumbers:this.getShowWeekNumbers()});x.isRelative=this.isRelative.bind(this);x._getRelativeInfo=this._getRelativeInfo.bind(this);this._setAriaRole(x);x.attachEvent("select",this._handleCalendarSelect,this);x.attachEvent("focus",this._handleFocus,this);if(j===_.OneMonth||j==="OneMonth"){x._setRowsStartDate=this._setRowsStartDate.bind(this);}x._oPlanningCalendar=this;x._getSpecialDates=function(){return this._oPlanningCalendar._getSpecialDates();};x.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};}else if(x.getDays()!==g2){x.setDays(g2);this._dateNav.setStep(g2*f2);}this._insertInterval(x);this[X1.sInstanceName]=x;if((e2===d1.OneMonth||e2==="OneMonth")){d2=Z1.getAggregation("_monthPicker")?Z1.getAggregation("_monthPicker"):Z1._oPopup.getContent()[0];Z1.setAssociation("currentPicker",d2);d2.addDelegate(s1,d2);}else if(this.isRelative()){var h2=Z1.getAggregation("_indexPicker");d2=h2?h2:Z1._oPopup.getContent()[0];if(h2){var c2=this._getView(j);var i2=Math.round(this.calcIntervalOffset(_1));h2.setFormatter(this._getRelativeInfo().intervalLabelFormatter);h2.setPeriodSize(x.getDays());h2.setSelectedIndex(i2);}else{var c2=this._getView(j);d2.setFormatter(c2.getIntervalLabelFormatter());d2.setPeriodSize(x.getDays());var i2=Math.round(this.calcIntervalOffset(_1));d2.setSelectedIndex(i2);}Z1.setAssociation("currentPicker",d2);}else{d2=Z1.getAggregation("_calendarPicker")?Z1.getAggregation("_calendarPicker"):Z1._oPopup.getContent()[0];Z1.setAssociation("currentPicker",d2);d2.addDelegate(r1,d2);}break;case d1.Month:if(!this._oMonthsRow){this._oMonthsRow=new d(this.getId()+"-MonthsRow",{startDate:new Date(_1.getTime()),months:g2,legend:this.getLegend()});this._setAriaRole(this._oMonthsRow);this._oMonthsRow._setLegendControlOrigin(this);this._oMonthsRow.attachEvent("focus",this._handleFocus,this);this._oMonthsRow.attachEvent("select",this._handleCalendarSelect,this);this._oMonthsRow._oPlanningCalendar=this;this._oMonthsRow._getSpecialDates=function(){return this._oPlanningCalendar._getSpecialDates();};this._oMonthsRow.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};}else if(this._oMonthsRow.setMonths()!==g2){this._oMonthsRow.setMonths(g2);this._dateNav.setStep(g2*f2);}this._insertInterval(this._oMonthsRow);d2=Z1.getAggregation("_yearPicker")?Z1.getAggregation("_yearPicker"):Z1._oPopup.getContent()[0];Z1.setAssociation("currentPicker",d2);d2.addDelegate(t1,d2);break;default:throw new Error("Unknown IntervalType: "+e2+"; "+this);}var j2=this.getAggregation("table").getInfoToolbar().getContent()[1];if(j2.setFirstDayOfWeek){j2.setFirstDayOfWeek(this.getFirstDayOfWeek());}var k2=this.getRows();for(var i=0;i<k2.length;i++){var l2=k2[i];var m2=L1(l2);m2.setIntervalType(e2);m2.setIntervals(g2);m2.setIntervalSize(f2);m2.setShowSubIntervals(c2.getShowSubIntervals());}if(this.getDomRef()){this._updateCurrentTimeVisualization(false);y1.call(this,this.getShowWeekNumbers(),this._viewAllowsWeekNumbers(j));z1.call(this,this.getShowDayNamesLine(),!!x);}this._updatePickerSelection();}if(j===_.Week||j===_.OneMonth||j===_.Month||j==="OneMonth"){W1=this.getStartDate();this.setStartDate(new Date(W1.getTime()));if(W1.getTime()!==this.getStartDate().getTime()){this.fireStartDateChange();}}if(this._oOneMonthsRow&&(j===_.OneMonth||j==="OneMonth")){this._oOneMonthsRow.setMode(this._iSize);this._oOldStartDate=new Date(this.getStartDate().getTime());this._adjustSelectedDate(b.fromLocalJSDate(W1));if(this._iSize<2){this._setRowsStartDate(W1);}}else if(this._oOneMonthsRow&&(Y1===_.OneMonth||Y1==="OneMonth")&&this._oOneMonthsRow.getSelectedDates().length){$1=this._oOneMonthsRow.getSelectedDates()[0].getStartDate();if($1){$1.setHours(this._oOldStartDate.getHours());$1.setMinutes(this._oOldStartDate.getMinutes());$1.setSeconds(this._oOldStartDate.getSeconds());$1.setMilliseconds(this._oOldStartDate.getMilliseconds());this.setStartDate($1);}}if(a2){Z1.getAggregation("_calendarPicker")&&Z1.getAggregation("_calendarPicker").setMinDate(new Date(a2.getTime()));Z1.getAggregation("_yearPicker")&&Z1.getAggregation("_yearPicker").setMinDate(new Date(a2.getTime()));Z1.getAggregation("_monthPicker")&&Z1.getAggregation("_monthPicker").setMinDate(new Date(a2.getTime()));}if(b2){Z1.getAggregation("_calendarPicker")&&Z1.getAggregation("_calendarPicker").setMaxDate(new Date(b2.getTime()));Z1.getAggregation("_yearPicker")&&Z1.getAggregation("_yearPicker").setMaxDate(new Date(b2.getTime()));Z1.getAggregation("_monthPicker")&&Z1.getAggregation("_monthPicker").setMaxDate(new Date(b2.getTime()));}this._updateTodayButtonState();return this;};
k1.prototype.setFirstDayOfWeek=function(i){if(i<-1||i>6){V.error(""+i+" is not a valid value to the property firstDayOfWeek. Valid values are from -1 to 6.");return;}var j=this._getHeader().getAssociation("currentPicker"),x=m.byId(j),W1=this.getViewKey(),X1=this._dateNav,Y1=X1.getStart(),Z1=this.getStartDate().getDay(),$1=W1===_.OneMonth&&this._iSize<2,_1=i,a2,b2,c2;x.setFirstDayOfWeek(i);if(W1===_.Week||$1){a2=this.getAggregation("table").getInfoToolbar().getContent()[1];if(i===-1){b2=a.getFirstDateOfWeek(a._createUniversalUTCDate(Y1,undefined,true));c2=a._createLocalDate(b2,true);_1=c2.getDay();}a2.setFirstDayOfWeek(i);if(!$1){Y1.setDate(Y1.getDate()-Z1+_1);a2.setStartDate(Y1);}this.getRows().forEach(function(a2){this._updateRowTimeline(a2);}.bind(this));}return this.setProperty("firstDayOfWeek",i);};
k1.prototype._handleFocus=function(i){var j=i.getParameter("date"),x=i.getParameter("restoreOldDate");if(x){return;}this.shiftToDate(j,i.getParameter("otherMonth"));this._addMonthFocusDelegate(this._getRowInstanceByViewKey(this.getViewKey()));};
k1.prototype.shiftToDate=function(i,j){var x=this._getRowInstanceByViewKey(this.getViewKey()),W1,X1;this._dateNav.toDate(i);W1=this._dateNav.getStart();X1=this._dateNav.getCurrent();if(this._dateNav.getCurrent()>this._dateNav.getEnd()){W1=new Date(this._dateNav.getStart());W1.setDate(W1.getDate()+1);}if((this.getMaxDate()&&this.getMaxDate()<i)||(this.getMinDate()&&this.getMinDate()>i)){return;}if(j){this.fireStartDateChange();}if(x&&!(x.getMode&&x.getMode()<2&&!j)){this.setStartDate(W1);x.setStartDate(W1);x.setDate(X1);this._addMonthFocusDelegate(x);}};
k1.prototype._addMonthFocusDelegate=function(i){var j={onAfterRendering:function(){this._oItemNavigation.focusItem(this._oItemNavigation.getFocusedIndex());this.removeDelegate(j);}};i.addDelegate(j,i);};
k1.prototype._shiftStartDate=function(i){if(this.getViewKey()===_.Week){var j=a.getFirstDateOfWeek(a._createUniversalUTCDate(i,undefined,true)),x=a._createLocalDate(j,true);if(this.getFirstDayOfWeek()>-1){x.setDate(x.getDate()-x.getDay()+this.getFirstDayOfWeek());}if(x.getTime()>i.getTime()){x.setDate(x.getDate()-7);}i.setTime(x.getTime());}if((this.getViewKey()===_.OneMonth||this.getViewKey()===_.Month||this.getViewKey()==="OneMonth")){var W1=a.getFirstDateOfMonth(a._createUniversalUTCDate(i,undefined,true));i.setTime(a._createLocalDate(W1,true).getTime());}return i;};
k1.prototype._updatePickerSelection=function(){var i=this._getFirstAndLastRangeDate(),j=this._getHeader().getAssociation("currentPicker"),x=m.byId(j),W1;W1=new e({startDate:a._createLocalDate(i.oStartDate,true),endDate:a._createLocalDate(i.oEndDate,true)});if(this.isRelative()){x.setStartIndex(this.calcIntervalOffset(i.oStartDate));}else{x.destroySelectedDates();x.addSelectedDate(W1);}this._getHeader().setPickerText(this._formatPickerText());this._updateTodayButtonState();};
k1.prototype._adjustSelectedDate=function(i){var j=i.toLocalJSDate();if(this._oOneMonthsRow.getMode&&this._oOneMonthsRow.getMode()<2){this._oOneMonthsRow.removeAllSelectedDates();this._oOneMonthsRow.addSelectedDate(new e({startDate:j}));this._oOneMonthsRow.selectDate(j);}};
k1.prototype._insertInterval=function(i){if(this._iSizeScreen>1){this._oInfoToolbar.addContent(i);}else{this._oInfoToolbar.insertContent(i,1);}};
k1.prototype._viewAllowsWeekNumbers=function(i){var j=this._getView(i).getIntervalType(),x=m1[j];return!!x&&!!x.oClass.prototype.setShowWeekNumbers;};
k1.prototype._viewAllowsDayNamesLine=function(i){var j=this._getView(i).getIntervalType(),x=m1[j];return!!x&&!!x.oClass.prototype.setShowDayNamesLine;};
k1.prototype._getRowInstanceByViewKey=function(i){var j=this._getView(i).getIntervalType(),x=m1[j],W1;if(x){W1=this[x.sInstanceName];}if(j===d1.Month){W1=this._oMonthsRow;}if(j===d1.Hour){W1=this._oTimesRow;}return W1;};
k1.prototype.setShowWeekNumbers=function(i){this.setProperty("showWeekNumbers",i,true);this._getViews().forEach(function(j){var x=j.getKey(),W1=this._viewAllowsWeekNumbers(x),X1=this._getRowInstanceByViewKey(x);if(X1&&W1){X1.setShowWeekNumbers(i);}if(this.getDomRef()&&this.getViewKey()===x){y1.call(this,i,W1);}},this);return this;};
k1.prototype.setShowIntervalHeaders=function(j){this.setProperty("showIntervalHeaders",j,true);var x=this.getRows();for(var i=0;i<x.length;i++){var W1=x[i];L1(W1).setShowIntervalHeaders(j);}return this;};
k1.prototype.setShowEmptyIntervalHeaders=function(j){this.setProperty("showEmptyIntervalHeaders",j,true);var x=this.getRows();for(var i=0;i<x.length;i++){var W1=x[i];L1(W1).setShowEmptyIntervalHeaders(j);}return this;};
k1.prototype.setGroupAppointmentsMode=function(j){this.setProperty("groupAppointmentsMode",j,true);var x=this.getRows();for(var i=0;i<x.length;i++){var W1=x[i];L1(W1).setGroupAppointmentsMode(j);}return this;};
k1.prototype.setAppointmentsReducedHeight=function(j){this.setProperty("appointmentsReducedHeight",j,true);var x=this.getRows();for(var i=0;i<x.length;i++){var W1=x[i];L1(W1).setAppointmentsReducedHeight(j);}return this;};
k1.prototype.setAppointmentHeight=function(j){var x=this.getRows(),i;this.setProperty("appointmentHeight",j);for(i=0;i<x.length;i++){var W1=x[i];L1(W1).setAppointmentHeight(j);}return this;};
k1.prototype.setAppointmentRoundWidth=function(j){var x=this.getRows(),i;this.setProperty("appointmentRoundWidth",j);for(i=0;i<x.length;i++){var W1=x[i];L1(W1).setAppointmentRoundWidth(j);}return this;};
k1.prototype.setAppointmentsVisualization=function(j){this.setProperty("appointmentsVisualization",j,true);var x=this.getRows();for(var i=0;i<x.length;i++){var W1=x[i];L1(W1).setAppointmentsVisualization(j);}return this;};
k1.prototype.setShowRowHeaders=function(i){this.setProperty("showRowHeaders",i,true);var j=this.getAggregation("table");j.getColumns()[0].setVisible(i);this._toggleAppointmentsColumnPopinState(i);this.$().toggleClass("sapMPlanCalNoHead",!i);T1.call(this);this._setSelectionMode.call(this);return this;};
k1.prototype.setShowDayNamesLine=function(i){var j,x,W1,X1=!!this.getDomRef(),Y1=this.getViewKey();for(j in m1){x=m1[j].sInstanceName;if(this[x]){W1=this[x];W1.setShowDayNamesLine(i);if(X1&&j===Y1){z1.call(this,i,true);}}}return this.setProperty("showDayNamesLine",i,false);};
k1.prototype.setStickyHeader=function(i){if(this.getStickyHeader()===i){return this;}this.setProperty("stickyHeader",i,true);if(l.system.phone){if(i){l.orientation.attachHandler(this._updateStickyHeader,this);}else{l.orientation.detachHandler(this._updateStickyHeader,this);}}this._updateStickyHeader();return this;};
k1.prototype._updateStickyHeader=function(){var i=[],j=this.getStickyHeader(),x=(this.getViewKey()===_.OneMonth||this.getViewKey()==="OneMonth")&&this._iSize<2,W1=j&&!l.system.phone&&!x,X1=j&&!(l.system.phone&&l.orientation.landscape)&&!x;if(W1){i.push(X.HeaderToolbar);}if(this._oInfoToolbar&&X1){i.push(X.InfoToolbar);}this.getAggregation("table").setSticky(i);};
k1.prototype._adjustViewKey=function(){if((!this._oTimesRow&&!this._oDatesRow&&!this._oMonthsRow&&!this._oWeeksRow&&!this._oOneMonthsRow)||this._bCheckView){this.setViewKey(this.getViewKey());this._bCheckView=undefined;}};
k1.prototype.addView=function(i){this.addAggregation("views",i);if(i.getKey()===this.getViewKey()){this._adjustViewKey();}return this;};
k1.prototype.insertView=function(i,j){this.insertAggregation("views",i,j);if(i.getKey()===this.getViewKey()){this._adjustViewKey();}return this;};
k1.prototype.addRow=function(i){this.addAggregation("rows",i);this.getAggregation("table").addItem(this._createPlanningCalendarListItem(i));return this;};
k1.prototype.insertRow=function(i,j){this.insertAggregation("rows",i,j);this.getAggregation("table").insertItem(this._createPlanningCalendarListItem(i),j,true);return this;};
k1.prototype.removeRow=function(i){var j=this.removeAggregation("rows",i,true),x=this.getAggregation("table");x.removeItem(J1(j),true);this._handleRowRemoval(j);S1.call(this);this._setSelectionMode.call(this);return j;};
k1.prototype.removeAllRows=function(){var i=this.removeAllAggregation("rows",true),j=this.getAggregation("table");j.removeAllItems(true);i.forEach(this._handleRowRemoval,this);S1.call(this);this._setSelectionMode.call(this);return i;};
k1.prototype.destroyRows=function(){var i;var j=this.getAggregation("table");j.destroyItems(true);i=this.destroyAggregation("rows");S1.call(this);this._setSelectionMode.call(this);return i;};
k1.prototype.setSingleSelection=function(i){this.setProperty("singleSelection",i,true);T1.call(this);this._setSelectionMode.call(this);if(i){this.selectAllRows(false);}else{S1.call(this);}this.$().toggleClass("sapMPlanCalMultiSel",!i);return this;};
k1.prototype.setNoDataText=function(i){this.setProperty("noDataText",i,true);var j=this.getAggregation("table");j.setNoDataText(i);return this;};
k1.prototype.setLegend=function(j){this.setAssociation("legend",j,true);var x=this.getRows(),W1=this.getLegend()&&m.byId(this.getLegend()),X1;for(var i=0;i<x.length;i++){var Y1=x[i];L1(Y1).setLegend(j);}l1.forEach(function(Z1){if(this[Z1]){this[Z1].setLegend(j);}},this);if(W1){X1=new M(function(Z1){this.invalidate();}.bind(this));X1.observe(W1,{destroy:true});}return this;};
k1.prototype.addAriaLabelledBy=function(i){this.addAssociation("ariaLabelledBy",i,true);var j=this.getAggregation("table");j.addAriaLabelledBy(i);return this;};
k1.prototype.removeAriaLabelledBy=function(i){this.removeAssociation("ariaLabelledBy",i,true);var j=this.getAggregation("table");j.removeAriaLabelledBy(i);return this;};
k1.prototype.removeAllAriaLabelledBy=function(){this.removeAllAssociation("ariaLabelledBy",true);var i=this.getAggregation("table");i.removeAllAriaLabelledBy();i.addAriaLabelledBy(this.getId()+"-Descr");return this;};
k1.prototype.invalidate=function(i){var j=i&&i instanceof e;if(!this._bIsBeingDestroyed&&(this._bDateRangeChanged||j)){if(this.getDomRef()){var x=this.getViewKey();var W1=this._getView(x);var X1=W1.getIntervalType();switch(X1){case d1.Hour:if(this._oTimesRow){this._oTimesRow.invalidate(arguments);}break;case d1.Day:if(this._oDatesRow){this._oDatesRow.invalidate(arguments);}break;case d1.Month:if(this._oMonthsRow){this._oMonthsRow.invalidate(arguments);}break;case d1.OneMonth:case"OneMonth":if(this._oOneMonthsRow){this._oOneMonthsRow.invalidate(arguments);}break;case d1.Week:if(this._oWeeksRow){this._oWeeksRow.invalidate(arguments);}break;default:throw new Error("Unknown IntervalType: "+X1+"; "+this);}}this._bDateRangeChanged=undefined;}else{if(i&&i instanceof sap.m.PlanningCalendarView){this._bCheckView=true;}C.prototype.invalidate.apply(this,arguments);}};
k1.prototype.addSpecialDate=function(i){this._bDateRangeChanged=true;return C.prototype.addAggregation.call(this,"specialDates",i);};
k1.prototype.insertSpecialDate=function(i,j){this._bDateRangeChanged=true;return C.prototype.insertAggregation.call(this,"specialDates",i,j);};
k1.prototype.removeSpecialDate=function(i){this._bDateRangeChanged=true;return C.prototype.removeAggregation.call(this,"specialDates",i);};
k1.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=true;return this.removeAllAggregation("specialDates");};
k1.prototype.destroySpecialDates=function(){this._bDateRangeChanged=true;return this.destroyAggregation("specialDates");};
k1.prototype.removeAllViews=function(){this._bCheckView=true;var i=this.removeAllAggregation("views"),j=this.getBuiltInViews();if(j.length){this.setViewKey(j[0]);}else{this.setViewKey(o1[0]);}return i;};
k1.prototype.destroyViews=function(){this._bCheckView=true;var i=this.destroyAggregation("views"),j=this.getBuiltInViews();if(j.length){this.setViewKey(j[0]);}else{this.setViewKey(o1[0]);}return i;};
k1.prototype.getSelectedRows=function(){return this.getRows().filter(function(i){return i.getSelected();});};
k1.prototype.selectAllRows=function(j){var x=this.getRows();if(!(j&&this.getSingleSelection())){for(var i=0;i<x.length;i++){var W1=x[i];W1.setSelected(j);}if(this._oSelectAllCheckBox){this._oSelectAllCheckBox.setSelected(j);}}return this;};
k1.prototype.onsaphomemodifiers=function(i){if((i.metaKey||i.ctrlKey)&&!i.altKey&&!i.shiftKey){var j=this.getRows();var x=j[0];var W1=new W.Event("saphome");W1._bPlanningCalendar=true;L1(x).onsaphome(W1);i.preventDefault();i.stopPropagation();}};
k1.prototype.onsapendmodifiers=function(i){if((i.metaKey||i.ctrlKey)&&!i.altKey&&!i.shiftKey){var j=this.getRows();var x=j[j.length-1];var W1=new W.Event("sapend");W1._bPlanningCalendar=true;L1(x).onsapend(W1);i.preventDefault();i.stopPropagation();}};
k1.prototype.setBuiltInViews=function(i){this.setProperty("builtInViews",i);this.setViewKey(this._getViews()[0].getKey());return this;};
k1.prototype.removeView=function(i){var j=this.removeAggregation("views",i);if(!this.getViews().length){this.setViewKey(this._getViews()[0].getKey());}return j;};
k1.prototype._getIntervals=function(i){var j=0;switch(this._iSize){case 0:j=i.getIntervalsS();break;case 1:j=i.getIntervalsM();break;default:j=i.getIntervalsL();break;}return j;};
k1.prototype._getView=function(j,x){var W1=this._getViews();var X1;for(var i=0;i<W1.length;i++){X1=W1[i];if(X1.getKey()!=j){X1=undefined;}else{break;}}if(!X1&&!x){throw new Error("PlanningCalendarView with key "+j+" not assigned "+this);}return X1;};
k1.prototype._changeStartDate=function(i){if(this._bNoStartDateChange){return;}this.setStartDate(new Date(i.getTime()));this._updatePickerSelection();this.fireStartDateChange();};
k1.prototype._updateCurrentTimeVisualization=function(j){if(this._sUpdateCurrentTime){clearTimeout(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}if(j){var x=this.getRows();for(var i=0;i<x.length;i++){var W1=x[i];L1(W1).updateCurrentTimeVisualization();}}var X1=new Date();var Y1=this.getStartDate();var Z1=this.getViewKey();var $1=this._getView(Z1);var _1=$1.getIntervalType();var a2=this._getIntervals($1);var b2=0;var c2=0;var d2=0;switch(_1){case d1.Hour:b2=60000;c2=Y1.getTime()-3600000;d2=Y1.getTime()+a2*3600000;break;case d1.Day:case d1.Week:case d1.OneMonth:case"OneMonth":b2=1800000;c2=Y1.getTime()-3600000;d2=Y1.getTime()+a2*86400000;break;default:b2=-1;break;}if(X1.getTime()<=d2&&X1.getTime()>=c2&&b2>0){this._sUpdateCurrentTime=setTimeout(this['_updateCurrentTimeVisualization'].bind(this,true),b2);}};
function w1(i){this.setViewKey(i.getParameter("item").getKey());this.fireViewChange();}
k1.prototype._handleTodayPress=function(i){var j=new Date(),x,W1=this.getViewKey(),X1={onAfterRendering:function(){this._focusDate(b.fromLocalJSDate(new Date()));this.removeDelegate(X1);}};if(W1===_.OneMonth||W1==="OneMonth"){x=a.getFirstDateOfMonth(a._createUniversalUTCDate(j,undefined,true));this._adjustSelectedDate(b.fromLocalJSDate(j));j=a._createLocalDate(x,true);}if(W1===_.Week){x=this.getStartDate();j.setHours(x.getHours());j.setMinutes(x.getMinutes());j.setSeconds(x.getSeconds());}this.setStartDate(j);this._dateNav.setCurrent(j);if(W1===_.Week){this._oWeeksRow.addDelegate(X1,this._oWeeksRow);}else if(W1===_.OneMonth||W1==="OneMonth"){this._oOneMonthsRow.addDelegate(X1,this._oOneMonthsRow);}this._updatePickerSelection();this.fireStartDateChange();};
k1.prototype._handleStartDateChange=function(i){var j=i.oSource.getStartDate();if(this._getView(this.getViewKey()).getIntervalType()!==d1.Hour){var x=this.getStartDate();j.setHours(x.getHours());j.setMinutes(x.getMinutes());j.setSeconds(x.getSeconds());}this._changeStartDate(j);};
k1.prototype._handleDateSelect=function(i){var j,x=this.getStartDate();if(this.isRelative()){j=new Date(this.getMinDate().getTime());j.setDate(j.getDate()+i.getSource()._oIndexPicker.getSelectedIndex()*this._getView(this.getViewKey()).getIntervalSize());}else{j=i.getSource().getStartDate();}if(this._getView(this.getViewKey()).getIntervalType()===d1.Hour){j.setHours(x.getHours());j.setMinutes(x.getMinutes());j.setSeconds(x.getSeconds());}if(x.getTime()!==j.getTime()){this._changeStartDate(j);this._dateNav.setCurrent(j);var W1=this.getViewKey(),X1=this._getView(W1),Y1=X1.getIntervalType(),Z1;if(Y1==="Hour"){Y1="Time";}else if(Y1==="Day"){Y1="Date";}else if(Y1==="One Month"){Y1="OneMonth";}Z1="_o"+Y1+"sRow";if(this[Z1]){this[Z1].displayDate(j);}}};
k1.prototype._handleCalendarSelect=function(i){var j=i.getSource().getSelectedDates();if(!j.length){return;}var x=new Date(j[0].getStartDate());var W1=a._createUniversalUTCDate(x,undefined,true);var X1=this.getViewKey();var Y1=this._getView(X1);var Z1=Y1.getIntervalType();if((Z1!==d1.OneMonth&&Z1!=="OneMonth")||this._iSize>1){j[0].setStartDate();}switch(Z1){case d1.Hour:W1.setUTCHours(W1.getUTCHours()+1);break;case d1.Day:case d1.Week:W1.setUTCDate(W1.getUTCDate()+1);break;case d1.OneMonth:case"OneMonth":if(this._iSize<2){var $1=new Date(x.getTime());if(a.monthsDiffer(this.getStartDate(),x)){this.setStartDate(x);this._getHeader().setPickerText(this._formatPickerText());}this._setRowsStartDate($1);this._oOneMonthsRow._focusDate(b.fromLocalJSDate($1),true);}else if(a._isNextMonth(x,this.getStartDate())){this.shiftToDate(x);this._addMonthFocusDelegate(this._getRowInstanceByViewKey(this.getViewKey()));return;}W1.setUTCDate(W1.getUTCDate()+1);break;case d1.Month:W1.setUTCMonth(W1.getUTCMonth()+1);break;default:throw new Error("Unknown IntervalType: "+Z1+"; "+this);}W1.setUTCMilliseconds(W1.getUTCMilliseconds()-1);W1=a._createLocalDate(W1,true);this._formatPickerText();this.fireIntervalSelect({startDate:x,endDate:W1,subInterval:false,row:undefined});};
function x1(i){var j=i.getParameter("startDate");var x=this.getViewKey();var W1=this._getView(x);var X1=W1.getIntervalType();if((X1===d1.OneMonth||X1==="OneMonth")&&a._isNextMonth(j,this.getStartDate())){this.shiftToDate(j);this._addMonthFocusDelegate(this._getRowInstanceByViewKey(this.getViewKey()));return;}var Y1=i.getParameter("endDate");var Z1=i.getParameter("subInterval");var $1=I1(i.oSource.getParent());this._formatPickerText();this.fireIntervalSelect({startDate:j,endDate:Y1,subInterval:Z1,row:$1});}
k1.prototype._applyContextualSettings=function(i){return C.prototype._applyContextualSettings.call(this,i);};
function y1(i,j){this.$().toggleClass("sapMPlanCalWithWeekNumbers",i&&j);}
function z1(i,j){this.$().toggleClass("sapMPlanCalWithDayNamesLine",i&&j);}
function A1(j,x){if(j.size.width<=0){return;}if(Math.abs(this.iWidth-j.size.width)<15){return;}this.iWidth=j.size.width;this._applyContextualSettings({contextualWidth:this.iWidth});var W1=this.getRows();var X1;var i=0;var Y1;var Z1=this._iSize;N1.call(this,j.size.width);if(Z1!=this._iSize){O1.call(this,this._iSize);var $1=this.getViewKey();var _1=this._getView($1);var a2=_1.getIntervalType();var b2=_1.getIntervalSize();var c2=this._getIntervals(_1);for(i=0;i<W1.length;i++){X1=W1[i];var d2=L1(X1);if(c2!=d2.getIntervals()){d2.setIntervals(c2);}else{d2.handleResize();}}switch(a2){case d1.Hour:if(this._oTimesRow&&this._oTimesRow.getItems()!=c2){this._oTimesRow.setItems(c2);this._dateNav.setStep(c2*b2);}break;case d1.Day:if(this._oDatesRow&&this._oDatesRow.getDays()!=c2){this._oDatesRow.setDays(c2);this._dateNav.setStep(c2*b2);}break;case d1.Month:if(this._oMonthsRow&&this._oMonthsRow.getMonths()!=c2){this._oMonthsRow.setMonths(c2);this._dateNav.setStep(c2*b2);}break;case d1.Week:if(this._oWeeksRow&&this._oWeeksRow.getDays()!=c2){this._oWeeksRow.setDays(c2);this._dateNav.setStep(c2*b2);}break;case d1.OneMonth:case"OneMonth":if(this._oOneMonthsRow&&this._oOneMonthsRow.getDays()!=c2){this._oOneMonthsRow.setDays(c2);this._dateNav.setStep(c2*b2);if(this._iSize>1){this._setRowsStartDate(new Date(this.getStartDate().getTime()));}}break;default:throw new Error("Unknown IntervalType: "+a2+"; "+this);}T1.call(this);this._updatePickerSelection();}else if(!x){for(i=0;i<W1.length;i++){X1=W1[i];L1(X1).handleResize();}}if(this._oOneMonthsRow&&(this.getViewKey()===d1.OneMonth||this.getViewKey()==="OneMonth")){Y1=(this._getSelectedDates().length&&this._getSelectedDates()[0].getStartDate())?this._getSelectedDates()[0].getStartDate():this.getStartDate();this._oOneMonthsRow.setMode(this._iSize);this._adjustSelectedDate(b.fromLocalJSDate(Y1));}if(this.getStickyHeader()){this._adjustColumnHeadersTopOffset();this._updateStickyHeader();}}
function B1(x){var W1=x.getParameter("appointment"),X1=x.getParameter("multiSelect")||this.getMultipleAppointmentsSelection(),Y1=x.getParameter("appointments"),Z1=x.getParameter("domRefId"),$1,_1,a2,b2,c2,i,j;if(!X1){_1=this.getRows();for(i=0;i<_1.length;i++){a2=_1[i];if(x.oSource!=L1(a2)){b2=a2.getAppointments();for(j=0;j<b2.length;j++){c2=b2[j];c2.setSelected(false);}}}}$1={appointment:W1,appointments:Y1,multiSelect:X1,domRefId:Z1};this.fireAppointmentSelect($1);}
k1.prototype._setRowsStartDate=function(j){var x=this.getRows(),W1,i;for(i=0;i<x.length;i++){W1=x[i];L1(W1).setStartDate(j);}};
k1.prototype._toggleAppointmentsColumnPopinState=function(i){var j=this.getAggregation("table"),x=j.getColumns()[1];x.setDemandPopin(i);x.setMinScreenWidth(i?n1:"");};
k1.prototype._getViews=function(){var i=this.getViews(),j=this.getBuiltInViews(),x,W1=[],X1=_,Y1=d1;if(!this._oViews){this._oViews={};}if(j.length){W1=j;}else{W1=i.length?[]:o1;}x=W1.map(function($1){switch($1){case X1.Hour:if(!this._oViews[X1.Hour]){this._oViews[X1.Hour]=new L(this.getId()+"-HourView",{key:X1.Hour,intervalType:Y1.Hour,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_HOURS"),intervalsS:6,intervalsM:6,intervalsL:12});}return this._oViews[X1.Hour];case X1.Day:if(!this._oViews[X1.Day]){this._oViews[X1.Day]=new L(this.getId()+"-DayView",{key:X1.Day,intervalType:Y1.Day,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_DAYS"),intervalsS:7,intervalsM:7,intervalsL:14});}return this._oViews[X1.Day];case X1.Month:if(!this._oViews[X1.Month]){this._oViews[X1.Month]=new L(this.getId()+"-MonthView",{key:X1.Month,intervalType:Y1.Month,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_MONTHS"),intervalsS:3,intervalsM:6,intervalsL:12});}return this._oViews[X1.Month];case X1.Week:if(!this._oViews[X1.Week]){this._oViews[X1.Week]=new L(this.getId()+"-WeekView",{key:X1.Week,intervalType:Y1.Week,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_WEEK"),intervalsS:7,intervalsM:7,intervalsL:7});}return this._oViews[X1.Week];case X1.OneMonth:case"OneMonth":if(!this._oViews[X1.OneMonth]){this._oViews[X1.OneMonth]=new L(this.getId()+"-OneMonthView",{key:X1.OneMonth,intervalType:Y1.OneMonth,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_ONE_MONTH"),intervalsS:1,intervalsM:1,intervalsL:31});}return this._oViews[X1.OneMonth];default:V.error("Cannot get PlanningCalendar views. Invalid view key "+$1);break;}},this);for(var Z1 in this._oViews){if(W1.indexOf(Z1)<0){this._oViews[Z1].destroy();delete this._oViews[Z1];}}if(i.length){x=x.concat(i);}return x;};
k1.prototype.getSelectedAppointments=function(){var i=[];this.getRows().filter(function(j){i.push.apply(i,L1(j).aSelectedAppointments);});return i;};
k1.prototype.setCustomAppointmentsSorterCallback=function(i){if(typeof i==="function"||i===null||i===undefined){this.getRows().forEach(function(j){L1(j)._setCustomAppointmentsSorterCallback(i);});this._fnCustomSortedAppointments=i;}else{V.warning("Your custom sort function won't be used, but the old one will be preserved.",this);}return this;};
k1.prototype.setWidth=function(i){var j=this.getStartDate();this.getRows().forEach(function(x){L1(x).setStartDate(j);});return this.setProperty("width",i);};
k1.prototype.setMultipleAppointmentsSelection=function(i){this.getRows().forEach(function(j){L1(j).setMultipleAppointmentsSelection(i);});return this.setProperty("multipleAppointmentsSelection",i);};
k1.prototype.getCustomAppointmentsSorterCallback=function(){return this._fnCustomSortedAppointments;};
k1.prototype._onRowDeselectAppointment=function(){var x=this.getRows();for(var i=0;i<x.length;i++){var W1=L1(x[i]).aSelectedAppointments;for(var j=0;j<W1.length;j++){var X1=m.byId(W1[j]);if(X1){X1.setProperty("selected",false,true);X1.$().removeClass("sapUiCalendarAppSel");}}L1(x[i]).aSelectedAppointments=[];}};
k1.prototype._updateRowTimeline=function(i){var j=L1(i),x,W1,X1,Y1,Z1,$1=(this.getViewKey()===_.OneMonth||this.getViewKey()==="OneMonth")&&this._iSize<2,_1=this.getStartDate();j.setNonWorkingDays(i.getNonWorkingDays());j.setNonWorkingHours(i.getNonWorkingHours());if($1&&this._oOneMonthsRow&&this._oOneMonthsRow.getSelectedDates().length){_1=this._oOneMonthsRow.getSelectedDates()[0].getStartDate();}j.setStartDate(_1);j.setShowIntervalHeaders(this.getShowIntervalHeaders());j.setShowEmptyIntervalHeaders(this.getShowEmptyIntervalHeaders());j.setGroupAppointmentsMode(this.getGroupAppointmentsMode());j.setAppointmentsReducedHeight(this.getAppointmentsReducedHeight());j.setAppointmentRoundWidth(this.getAppointmentRoundWidth());j.setLegend(this.getLegend());j.setAppointmentsVisualization(this.getAppointmentsVisualization());j.setAppointmentHeight(this.getAppointmentHeight());j.attachEvent("select",B1,this);j.attachEvent("startDateChange",this._handleStartDateChange,this);j.attachEvent("leaveRow",R1,this);j.attachEvent("intervalSelect",x1,this);S1.call(this);if(U1.call(this)){x=this.getViewKey();W1=this._getView(x);X1=W1.getIntervalType();Z1=W1.getIntervalSize();Y1=this._getIntervals(W1);j.setIntervalType(X1);j.setIntervals(Y1);j.setIntervalSize(Z1);j.setShowSubIntervals(W1.getShowSubIntervals());}this._setSelectionMode.call(this);if(this._fnCustomSortedAppointments){j._setCustomAppointmentsSorterCallback(this._fnCustomSortedAppointments);}};
k1.prototype._observeRowChanges=function(i){var j=J1(i),x=K1(i),W1=L1(i);var X1={destroy:function(){j.destroy();},change:{title:function(Y1){x.setProperty(Y1.name,Y1.current);},icon:function(Y1){if(x.setIcon){x.setIcon(Y1.current);}else{x.setProperty(Y1.name,Y1.current);}},text:function(Y1){W1.toggleStyleClass("sapMPlanCalRowLarge",!!Y1.current);x.setProperty("description",Y1.current);},enableAppointmentsDragAndDrop:function(Y1){this._enableAppointmentsDragAndDrop(i);}.bind(this),enableAppointmentsResize:function(Y1){this._enableAppointmentsResize(i);}.bind(this),enableAppointmentsCreate:function(Y1){this._enableAppointmentsCreate(i);}.bind(this),nonWorkingDays:function(Y1){W1.setProperty(Y1.name,Y1.current);},nonWorkingHours:function(Y1){W1.setProperty(Y1.name,Y1.current);},selected:function(Y1){S1.call(this);j.setProperty(Y1.name,Y1.current);}.bind(this),tooltip:function(Y1){if(Y1.mutation==="insert"){x.setTooltip(Y1.child);}else if(Y1.mutation==="remove"){x.setTooltip();}},intervalHeaders:function(Y1){W1.invalidate();},appointments:function(Y1){W1.invalidate();}}};new M(function(Y1){if(Y1.type==="destroy"){X1.destroy();}else if(X1.change[Y1.name]){X1.change[Y1.name](Y1);}}).observe(i,{properties:["icon","text","title","nonWorkingDays","nonWorkingHours","selected","enableAppointmentsDragAndDrop","enableAppointmentsResize","enableAppointmentsCreate"],aggregations:["tooltip","appointments","intervalHeaders","headerContent"],destroy:true});i.invalidate=function(Y1){if(!Y1||!(Y1 instanceof g)){E.prototype.invalidate.apply(this,arguments);}else if(j){W1.invalidate(Y1);}};i.applyFocusInfo=function(Y1){W1.applyFocusInfo(Y1);return this;};};
k1.prototype._createPlanningCalendarListItem=function(i){var j,x,W1;if(i.getHeaderContent().length||i.getBindingInfo("headerContent")){x=i._getPlanningCalendarCustomRowHeader();}else{x=new C1(i.getId()+"-Head",{icon:i.getIcon(),description:i.getText(),title:i.getTitle(),tooltip:i.getTooltip(),iconDensityAware:false});}W1=new E1(i.getId()+"-CalRow",{checkResize:false,updateCurrentTime:false,ariaLabelledBy:x.getId()});W1._getRelativeInfo=this._getRelativeInfo.bind(this);W1.getAppointments=function(){return i.getAppointments();};W1.getIntervalHeaders=function(){return i.getIntervalHeaders();};W1.setAssociation("row",i.getId());j=new G1(i.getId()+j1,{cells:[x,W1]});this._updateRowTimeline(i);this._observeRowChanges(i);this._enableAppointmentsDragAndDrop(i);this._enableAppointmentsResize(i);this._enableAppointmentsCreate(i);return j;};
k1.prototype._handleRowRemoval=function(i){var j=L1(i);j.detachEvent("select",B1,this);j.detachEvent("startDateChange",this._handleStartDateChange,this);j.detachEvent("leaveRow",R1,this);j.detachEvent("intervalSelect",x1,this);if(this._fnCustomSortedAppointments){j._fnCustomSortedAppointments=undefined;}J1(i).destroy();};
var C1=G.extend("sap.m._PlanningCalendarRowHeader",{
renderer:{apiVersion:2,renderTabIndex:function(i,j){},getAriaRole:function(i,j){}},
TagName:"div"
});
C1.prototype.isSelectable=function(){return false;};
var D1=R.extend(k);D1.apiVersion=2;
D1.getLegendItems=function(i){var j=[],x,W1=i.getLegend();if(W1){x=m.byId(W1);if(x){j=x.getAppointmentItems?x.getAppointmentItems():x.getItems();}else{V.error("PlanningCalendarLegend with id '"+W1+"' does not exist!",i);}}return j;};
D1.renderBeforeAppointments=function(j,x){var W1=I1(x.getParent()),X1;if(!W1.getEnableAppointmentsDragAndDrop()&&!W1.getEnableAppointmentsResize()&&!W1.getEnableAppointmentsCreate()||x._isOneMonthsRowOnSmallSizes()){return;}X1=x.getAggregation("_intervalPlaceholders");j.openStart("div");j.class("sapUiCalendarRowAppsOverlay");j.openEnd();if(X1){for(var i=0;i<X1.length;i++){var Y1=X1[i];Y1.setWidth(100/X1.length+"%");j.renderControl(Y1);}}j.close("div");};
D1.renderResizeHandle=function(i,j,x){if(!I1(j.getParent()).getEnableAppointmentsResize()||j._isOneMonthsRowOnSmallSizes()||(x._aAppointments&&x._aAppointments.length>0)){return;}i.openStart("span");i.class("sapUiCalendarAppResizeHandle");i.openEnd();i.close("span");};
D1.writeCustomAttributes=function(i,j){if(I1(j.getParent()).getEnableAppointmentsCreate()){i.attr("draggable","true");}};
D1.renderInterval=function(j,x,W1,X1,Y1,Z1,$1,_1,a2,b2,c2,d2,e2){var f2=x.getIntervalType(),g2;if(x._getRelativeInfo().bIsRelative){var h2=[];return k.renderInterval(j,x,W1,X1,Y1,h2,$1,_1,a2,b2,c2,d2,e2,g2);}if(f2===d1.Day||f2===d1.Week||f2===d1.OneMonth||f2==="OneMonth"){var i2=I1(x.getParent()),j2=i2.getParent(),k2=function(u2){return u2.getType()===Y.NonWorking;},l2=i2._getSpecialDates().filter(k2),m2=j2._getSpecialDates().filter(k2),n2=x.getStartDate(),o2,p2,q2,r2;if(m2&&l2){o2=m2.concat(l2);}else if(l2){o2=l2;}if(o2&&o2.length){var s2=function(u2){return u2===p2.getDay();};p2=new Date(n2.getTime());p2.setHours(0,0,0);p2.setDate(n2.getDate()+W1);for(var i=0;i<o2.length;i++){if(o2[i].getStartDate()){q2=new Date(o2[i].getStartDate().getTime());}if(o2[i].getEndDate()){r2=new Date(o2[i].getEndDate().getTime());}else{r2=new Date(o2[i].getStartDate().getTime());r2.setHours(23,59,59);}if(p2.getTime()>=q2.getTime()&&p2.getTime()<=r2.getTime()){var t2=Z1.some(s2);if(!t2){g2="sapUiCalendarRowAppsNoWork";}}}}}k.renderInterval(j,x,W1,X1,Y1,Z1,$1,_1,a2,b2,c2,d2,e2,g2);};
var E1=h.extend("sap.m._PlanningCalendarRowTimeline",{
metadata:{aggregations:{intervalHeaders:{type:"sap.ui.unified.CalendarAppointment",multiple:true},_intervalPlaceholders:{type:"sap.m._PlanningCalendarIntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}}},associations:{row:{type:"sap.m.PlanningCalendarRow",multiple:false}},dnd:true},
renderer:D1
});
E1.prototype._updatePlaceholders=function(){var j=this.getProperty("intervals");if(this.getIntervalType()===d1.Hour){j*=2;}this.removeAllAggregation("_intervalPlaceholders");for(var i=0;i<j;i++){this.addAggregation("_intervalPlaceholders",new F1());}};
E1.prototype._getRelativeInfo=function(){};
E1.prototype.onBeforeRendering=function(){h.prototype.onBeforeRendering.call(this);this._updatePlaceholders();};
E1.prototype.onmousedown=function(i){var j=i.target.classList;this._isResizeHandleMouseDownTarget=j.contains("sapUiCalendarAppResizeHandle");this._isRowAppsIntervalMouseDownTarget=j.contains("sapUiCalendarRowAppsInt");};
E1.prototype._isResizingPerformed=function(){return this._isResizeHandleMouseDownTarget;};
E1.prototype._isDraggingPerformed=function(){return!this._isResizeHandleMouseDownTarget&&!this._isRowAppsIntervalMouseDownTarget;};
E1.prototype._isCreatingPerformed=function(){return this._isRowAppsIntervalMouseDownTarget;};
var F1=C.extend("sap.m._PlanningCalendarIntervalPlaceholder",{
metadata:{properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null}}},
renderer:function(i,j){i.openStart("div",j);i.style("width",j.getWidth());i.class("sapUiCalendarRowAppsPlaceholder");i.openEnd();i.close("div");}
});
var G1=z.extend("sap.m.internal.PlanningCalendarRowListItem",{
metadata:{library:"sap.m"},
renderer:A
});
G1.prototype.getHeader=function(){return this.getCells()[0];};
G1.prototype.getTimeline=function(){return this.getCells()[1];};
G1.prototype.getCustomData=function(){return I1(this).getCustomData();};
k1.prototype._getSelectedDates=function(){var i=this.getViewKey(),j=this._getView(i),x=j.getIntervalType(),W1=m1[x];return this[W1.sInstanceName].getSelectedDates();};
k1.prototype._enableAppointmentsDragAndDrop=function(i){var j=L1(i),x;if(i.getEnableAppointmentsDragAndDrop()){x=i.getDragDropConfig().some(function(W1){return W1.getGroupName()===g1;});if(!x){this._addDragDropInfo(i,L1(i));}}else{i.getDragDropConfig().forEach(function(W1){if(W1.getGroupName()===g1){i.removeDragDropConfig(W1);W1.destroy();}});j.getDragDropConfig().forEach(function(W1){if(W1.getGroupName()===g1){j.removeDragDropConfig(W1);W1.destroy();}});}};
k1.prototype._enableAppointmentsResize=function(i){var j=i.getEnableAppointmentsResize(),x=this._getConfigFromDragDropConfigAggregation(i.getAggregation("dragDropConfig"),h1),W1;if(j&&!x){W1=this._createResizeConfig(i);i.addAggregation("dragDropConfig",W1,true);}if(!j&&x){i.removeAggregation("dragDropConfig",x,true);x.destroy();}};
k1.prototype._enableAppointmentsCreate=function(i){var j=i.getEnableAppointmentsCreate(),x=L1(i),W1=this._getConfigFromDragDropConfigAggregation(x.getAggregation("dragDropConfig"),i1),X1;if(j&&!W1){X1=this._createAppointmentsCreateConfig(i);x.addAggregation("dragDropConfig",X1,true);}if(!j&&W1){x.removeAggregation("dragDropConfig",W1,true);W1.destroy();}};
k1.prototype._addDragDropInfo=function(i,j){i.addDragDropConfig(new p({groupName:g1,sourceAggregation:"appointments",dragStart:function(x){var W1=function(){var X1=W(".sapUiCalendarRowAppsOverlay");setTimeout(function(){X1.addClass("sapUiCalendarRowAppsOverlayDragging");},0);W(document).one("dragend",function(){X1.removeClass("sapUiCalendarRowAppsOverlayDragging");});};if(j._isOneMonthsRowOnSmallSizes()||!j._isDraggingPerformed()){x.preventDefault();return;}W1();}}));j.addDragDropConfig(new q({groupName:g1,targetAggregation:"_intervalPlaceholders",dragEnter:function(x){var W1=x.getParameter("dragSession"),X1=W1.getDragControl(),Y1=j.getIntervalType(),Z1=j.getStartDate(),$1=j.indexOfAggregation("_intervalPlaceholders",W1.getDropControl()),_1=j.getId(),a2,b2=function(){var d2=W(W1.getIndicator()),e2=W1.getDropControl().getDomRef().getBoundingClientRect(),f2=m.byId(_1).getDomRef().getBoundingClientRect(),g2=W1.getDragControl().$().outerWidth(),h2=m.getConfiguration().getRTL(),i2=h2?Math.ceil(e2.right)-f2.left:f2.right-Math.ceil(e2.left);d2.css("min-width",(g2<i2)?g2:i2).css(h2?"border-left-width":"border-right-width",(g2>i2)?"0":"").css("margin-left",h2?-(d2.outerWidth()-parseFloat(d2.context.style.width)):"");};if(i.hasListeners("appointmentDragEnter")){if(Y1===d1.Hour){a2=this._calcNewHoursAppPos(Z1,X1.getStartDate(),X1.getEndDate(),$1);}else if(Y1===d1.Day||Y1===d1.Week||((Y1===d1.OneMonth||Y1==="OneMonth")&&!j._isOneMonthsRowOnSmallSizes())){a2=this._calcNewDaysAppPos(Z1,X1.getStartDate(),X1.getEndDate(),$1);}else if(Y1===d1.Month){a2=this._calcNewMonthsAppPos(Z1,X1.getStartDate(),X1.getEndDate(),$1);}var c2=i.fireAppointmentDragEnter({appointment:X1,startDate:a2.startDate,endDate:a2.endDate,calendarRow:I1(j.getParent())});if(!c2){x.preventDefault();return;}}else if(L1(X1.getParent())!==j){x.preventDefault();return;}if(j.getIntervalType()!==d1.Hour){return;}if(!W1.getIndicator()){setTimeout(b2,0);}else{b2();}}.bind(this),drop:function(x){var W1=x.getParameter("dragSession"),X1=W1.getDragControl(),Y1=j.getIntervalType(),Z1=j.getStartDate(),$1=j.indexOfAggregation("_intervalPlaceholders",W1.getDropControl()),_1,a2=x.getParameter("browserEvent"),b2=(a2.metaKey||a2.ctrlKey);if(Y1===d1.Hour){_1=this._calcNewHoursAppPos(Z1,X1.getStartDate(),X1.getEndDate(),$1);}else if(Y1===d1.Day||Y1===d1.Week||((Y1===d1.OneMonth||Y1==="OneMonth")&&!j._isOneMonthsRowOnSmallSizes())){_1=this._calcNewDaysAppPos(Z1,X1.getStartDate(),X1.getEndDate(),$1);}else if(Y1===d1.Month){_1=this._calcNewMonthsAppPos(Z1,X1.getStartDate(),X1.getEndDate(),$1);}j.$().find(".sapUiCalendarRowAppsOverlay").removeClass("sapUiCalendarRowAppsOverlayDragging");if(X1.getStartDate().getTime()===_1.startDate.getTime()&&X1.getParent()===I1(j.getParent())){return;}i.fireAppointmentDrop({appointment:X1,startDate:_1.startDate,endDate:_1.endDate,calendarRow:I1(j.getParent()),copy:b2});}.bind(this)}));};
k1.prototype._calcNewHoursAppPos=function(i,j,x,W1){var X1=a._createUniversalUTCDate(i,null,true),Y1=a._createUniversalUTCDate(j,null,true),Z1=a._createUniversalUTCDate(x,null,true),$1=new Date(X1.setUTCMinutes(0,0,0)+(W1*30*60*1000));return{startDate:a._createLocalDate($1,true),endDate:a._createLocalDate(new Date($1.getTime()+Z1.getTime()-Y1.getTime()),true)};};
k1.prototype._calcNewDaysAppPos=function(i,j,x,W1){var X1=a._createUniversalUTCDate(i,null,true),Y1=a._createUniversalUTCDate(j,null,true),Z1=a._createUniversalUTCDate(x,null,true),$1=Z1.getTime()-Y1.getTime();Y1.setUTCFullYear(X1.getUTCFullYear(),X1.getUTCMonth(),X1.getUTCDate()+W1);Z1=new Date(Y1.getTime()+$1);return{startDate:a._createLocalDate(Y1,true),endDate:a._createLocalDate(Z1,true)};};
k1.prototype._calcNewMonthsAppPos=function(i,j,x,W1){var X1=a._createUniversalUTCDate(i,null,true),Y1=a._createUniversalUTCDate(j,null,true),Z1=a._createUniversalUTCDate(x,null,true),$1=Z1.getTime()-Y1.getTime();Y1.setUTCFullYear(X1.getUTCFullYear(),X1.getUTCMonth()+W1);Z1=new Date(Y1.getTime()+$1);return{startDate:a._createLocalDate(Y1,true),endDate:a._createLocalDate(Z1,true)};};
k1.prototype._createResizeConfig=function(i){var j=L1(i),x=new r({sourceAggregation:"appointments",targetAggregation:"_intervalPlaceholders",targetElement:L1(i),dragStart:function(W1){if(!i.getEnableAppointmentsResize()||j._isOneMonthsRowOnSmallSizes()||!j._isResizingPerformed()){W1.preventDefault();return;}var X1=W1.getParameter("dragSession"),Y1=j.$().find(".sapUiCalendarRowAppsOverlay"),Z1=W(X1.getIndicator()),$1=X1.getDragControl().$();Z1.addClass("sapUiDnDIndicatorHide");setTimeout(function(){Y1.addClass("sapUiCalendarRowAppsOverlayDragging");},0);W(document).one("dragend",function(){Y1.removeClass("sapUiCalendarRowAppsOverlayDragging");Z1.removeClass("sapUiDnDIndicatorHide");$1.css({width:"auto","min-width":"auto","z-index":"auto",opacity:1});});W1.getParameter("browserEvent").dataTransfer.setDragImage(H1(),0,0);},dragEnter:function(W1){var X1=W1.getParameter("dragSession"),Y1=this.getTargetElement(),Z1=function(){var c2=W(X1.getIndicator());c2.addClass("sapUiDnDIndicatorHide");},$1=X1.getDropControl().getDomRef().getBoundingClientRect(),_1=m.byId(Y1).getDomRef().getBoundingClientRect(),a2={width:$1.left+$1.width-(X1.getDragControl().$().position().left+_1.left),"z-index":1,opacity:0.8},b2=a2.width;if($1.width>0){while(b2<=0){b2+=$1.width;}while(b2>$1.width){b2-=$1.width;}}a2["min-width"]=b2;X1.getDragControl().$().css(a2);if(!X1.getIndicator()){setTimeout(Z1,0);}else{Z1();}},drop:function(W1){var j=L1(i),X1=W1.getParameter("dragSession"),Y1=X1.getDragControl(),Z1=j.getIntervalType(),$1=j.getStartDate(),_1=j.indexOfAggregation("_intervalPlaceholders",X1.getDropControl()),a2;if(Z1===d1.Hour){a2=this._calcResizeNewHoursAppPos($1,Y1.getStartDate(),Y1.getEndDate(),_1);}else if(Z1===d1.Day||Z1===d1.Week||((Z1===d1.OneMonth||Z1==="OneMonth")&&!j._isOneMonthsRowOnSmallSizes())){a2=this._calcResizeNewDaysAppPos($1,Y1.getStartDate(),Y1.getEndDate(),_1);}else if(Z1===d1.Month){a2=this._calcResizeNewMonthsAppPos($1,Y1.getStartDate(),Y1.getEndDate(),_1);}j.$().find(".sapUiCalendarRowAppsOverlay").removeClass("sapUiCalendarRowAppsOverlayDragging");W(X1.getIndicator()).removeClass("sapUiDnDIndicatorHide");Y1.$().css({width:"auto","min-width":"auto","z-index":"auto",opacity:1});if(Y1.getEndDate().getTime()===a2.endDate.getTime()){return;}i.fireAppointmentResize({appointment:Y1,startDate:a2.startDate,endDate:a2.endDate,calendarRow:i});}.bind(this)});x.setProperty("groupName",h1);return x;};
k1.prototype._calcResizeNewHoursAppPos=function(i,j,x,W1){var X1=a._createUniversalUTCDate(new Date(i.getTime()),null,true),Y1=30*60*1000,Z1=a._createUniversalUTCDate(j,null,true),$1=new Date(X1.setUTCMinutes(0,0,0)+((W1+1)*Y1));if($1.getTime()<=Z1.getTime()){$1=new Date(Z1.getTime()+Y1);}return{startDate:a._createLocalDate(Z1,true),endDate:a._createLocalDate($1,true)};};
k1.prototype._calcResizeNewDaysAppPos=function(i,j,x,W1){var X1=a._createUniversalUTCDate(i,null,true),Y1=a._createUniversalUTCDate(j,null,true),Z1=new Date(X1.setUTCDate(X1.getUTCDate()+W1+1)),$1={};$1.startDate=a._createLocalDate(Y1);$1.startDateTime=a._createLocalDate(Y1,true);$1.endDate=a._createLocalDate(Z1);if($1.endDate<=$1.startDate){$1.endDate=a._createLocalDate(new Date(Z1.setUTCDate(Y1.getUTCDate()+1)));}return{startDate:$1.startDateTime,endDate:$1.endDate};};
k1.prototype._calcResizeNewMonthsAppPos=function(i,j,x,W1){var X1=a._createUniversalUTCDate(i,null,true),Y1=a._createUniversalUTCDate(j,null,true),Z1=new Date(X1.setUTCMonth(X1.getUTCMonth()+W1+1,1));if(a._monthsBetween(Y1,Z1,true)<0){Z1=new Date(Z1.setUTCFullYear(Y1.getUTCFullYear(),Y1.getUTCMonth()+1,1));}return{startDate:a._createLocalDate(Y1,true),endDate:a._createLocalDate(Z1)};};
k1.prototype._calcCreateNewAppHours=function(i,j,x){var W1=a._createUniversalUTCDate(i,null,true),X1=30*60*1000,Y1=(j<=x)?j:x,Z1=(j<=x)?x+1:j,$1=new Date(W1.setUTCMinutes(0,0,0)),_1=new Date($1.getTime()+Y1*X1),a2=new Date($1.getTime()+Z1*X1);return{startDate:a._createLocalDate(_1,true),endDate:a._createLocalDate(a2,true)};};
k1.prototype._calcCreateNewAppDays=function(i,j,x){var W1=a._createUniversalUTCDate(i,null,true),X1=(j<=x)?j:x,Y1=(j<=x)?x+1:j,Z1=new Date(W1.getTime()),$1=new Date(W1.getTime());return{startDate:a._createLocalDate(new Date(Z1.setUTCDate(Z1.getUTCDate()+X1))),endDate:a._createLocalDate(new Date($1.setUTCDate($1.getUTCDate()+Y1)))};};
k1.prototype._calcCreateNewAppMonths=function(i,j,x){var W1=a._createUniversalUTCDate(i,null,true),X1=(j<=x)?j:x,Y1=(j<=x)?x+1:j,Z1=new Date(W1.getTime()),$1=new Date(W1.getTime());return{startDate:a._createLocalDate(new Date(Z1.setUTCMonth(Z1.getUTCMonth()+X1,1))),endDate:a._createLocalDate(new Date($1.setUTCMonth($1.getUTCMonth()+Y1,1)))};};
k1.prototype._getConfigFromDragDropConfigAggregation=function(j,x){var W1=j,X1=W1&&W1.length;for(var i=0;i<X1;i++){if(W1[i].getGroupName()===x){return W1[i];}}return null;};
k1.prototype._createAppointmentsCreateConfig=function(i){var j=L1(i),x=new r({targetAggregation:"_intervalPlaceholders",dragStart:function(W1){if(!i.getEnableAppointmentsCreate()||j._isOneMonthsRowOnSmallSizes()||!j._isCreatingPerformed()){W1.preventDefault();return;}var X1=W1.getParameter("dragSession"),Y1=j.$().find(".sapUiCalendarRowAppsOverlay"),Z1=W(X1.getIndicator());setTimeout(function(){Y1.addClass("sapUiCalendarRowAppsOverlayDragging");},0);W(document).one("dragend",function(){Y1.removeClass("sapUiCalendarRowAppsOverlayDragging");Z1.html("");Z1.removeClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");});W1.getParameter("browserEvent").dataTransfer.setDragImage(H1(),0,0);},dragEnter:function(W1){var X1=W1.getParameter("dragSession"),Y1=X1.getDropControl().getDomRef().getBoundingClientRect(),Z1=function(){var _1=W(X1.getIndicator());_1.addClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");};var $1=X1.getData("text")?parseFloat(X1.getData("text").split("|")[0]):0;if($1){if($1<=Y1.left){X1.setIndicatorConfig({left:$1,width:Math.max((Y1.left+Y1.width-$1),Y1.width)});}else{X1.setIndicatorConfig({left:Y1.left,width:$1-Y1.left});}}else{X1.setData("text",Y1.left+"|"+j.indexOfAggregation("_intervalPlaceholders",X1.getDropControl()));}if(!X1.getIndicator()){setTimeout(Z1,0);}else{Z1();}},drop:function(W1){var X1=W1.getParameter("dragSession"),Y1=W(X1.getIndicator()),Z1=j.getIntervalType(),$1=L1(i).getStartDate(),_1=parseInt(X1.getData("text").split("|")[1]),a2=j.indexOfAggregation("_intervalPlaceholders",X1.getDropControl()),b2;if(Z1===d1.Hour){b2=this._calcCreateNewAppHours($1,_1,a2);}else if(Z1===d1.Day||Z1===d1.Week||((Z1===d1.OneMonth||Z1==="OneMonth")&&!j._isOneMonthsRowOnSmallSizes())){b2=this._calcCreateNewAppDays($1,_1,a2);}else if(Z1===d1.Month){b2=this._calcCreateNewAppMonths($1,_1,a2);}i.fireAppointmentCreate({startDate:b2.startDate,endDate:b2.endDate,calendarRow:i});Y1.html("");Y1.removeClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");}.bind(this)});x.setProperty("groupName",i1);return x;};
k1.prototype._updateHeaderButtons=function(){var i=this.getViewKey(),j=this._getView(i,true),x=j&&j.getIntervalType(),W1=new Date(this._dateNav.getStart().getTime()),X1=new Date(this._dateNav.getEnd().getTime()),Y1=this.getMinDate()?new Date(this.getMinDate().getTime()):undefined,Z1=this.getMaxDate()?new Date(this.getMaxDate().getTime()):undefined;if(x!=="Hour"){Y1&&Y1.setHours(0,0,0,0);Z1&&Z1.setHours(23,59,59,999);W1.setHours(0,0,0,0);X1.setHours(23,59,59,999);}this._getHeader()._oPrevBtn.setEnabled(!Y1||W1.getTime()>Y1.getTime());this._getHeader()._oNextBtn.setEnabled(!Z1||X1.getTime()<Z1.getTime());};
k1.prototype._getSpecialDates=function(){var j=this.getSpecialDates();for(var i=0;i<j.length;i++){var x=j[i].getSecondaryType()===u.CalendarDayType.NonWorking&&j[i].getType()!==u.CalendarDayType.NonWorking;if(x){var W1=new f();W1.setType(u.CalendarDayType.NonWorking);W1.setStartDate(j[i].getStartDate());if(j[i].getEndDate()){W1.setEndDate(j[i].getEndDate());}j.push(W1);}}return j;};
function H1(){var i=W("<span></span>").addClass("sapUiCalAppResizeGhost");i.appendTo(document.body);setTimeout(function(){i.remove();},0);return i.get(0);}
function I1(i){var j=i.getId();return m.byId(j.substring(0,j.indexOf(j1)));}
function J1(i){return m.byId(i.getId()+j1);}
function K1(i){var j=J1(i);return j?j.getHeader():null;}
function L1(i){var j=J1(i);return j?j.getTimeline():null;}
function M1(j){var x=[];var W1=this.getRows();for(var i=0;i<W1.length;i++){var X1=W1[i];var Y1=J1(X1);var Z1=Y1.getSelected();if(X1.getSelected()!=Z1){X1.setProperty("selected",Z1,true);x.push(X1);}}if(!this.getSingleSelection()){S1.call(this);}if(x.length>0){this.fireRowSelectionChange({rows:x});}}
function N1(i){if(i<this._iBreakPointTablet){this._iSize=0;}else if(i<this._iBreakPointDesktop){this._iSize=1;}else{this._iSize=2;}if(i<p1.PHONE){this._iSizeScreen=0;}else if(i<p1.TABLET){this._iSizeScreen=1;}else{this._iSizeScreen=2;}}
function O1(j){var x='sapMSize'+j,i,W1;for(i=0;i<3;i++){W1='sapMSize'+i;if(W1===x){this.addStyleClass(W1);}else{this.removeStyleClass(W1);}}}
function P1(){var j=this._getViews();this._oIntervalTypeSelect.destroyItems();var i;var x;for(i=0;i<j.length;i++){var W1=j[i];x=new F(this.getId()+"-"+i,{key:W1.getKey(),text:W1.getDescription(),tooltip:W1.getTooltip()});this._oIntervalTypeSelect.addItem(x);}if(this._oIntervalTypeSelect.getItems().length>4){this._getHeader()._convertViewSwitchToSelect();}else{this._getHeader()._convertViewSwitchToSegmentedButton();}this._oIntervalTypeSelect.setVisible(!(j.length===1));}
function Q1(i){var j=i.getParameter("selected");var x=this.getRows();if(j){x=this.getRows().filter(function(W1){return!W1.getSelected();});}this.selectAllRows(j);this.fireRowSelectionChange({rows:x});}
function R1(j){var x=j.oSource;var W1=j.getParameter("type");var X1=this.getRows();var Y1;var Z1;var $1;var _1;var i=0;var a2=0;var b2;for(i=0;i<X1.length;i++){Y1=X1[i];if(L1(Y1)==x){a2=i;break;}}switch(W1){case"sapup":$1=x.getFocusedAppointment();_1=$1.getStartDate();if(a2>0){a2--;}Z1=X1[a2];L1(Z1).focusNearestAppointment(_1);break;case"sapdown":$1=x.getFocusedAppointment();_1=$1.getStartDate();if(a2<X1.length-1){a2++;}Z1=X1[a2];L1(Z1).focusNearestAppointment(_1);break;case"saphome":if(a2>0){Z1=X1[0];b2=new W.Event(W1);b2._bPlanningCalendar=true;L1(Z1).onsaphome(b2);}break;case"sapend":if(a2<X1.length-1){Z1=X1[X1.length-1];b2=new W.Event(W1);b2._bPlanningCalendar=true;L1(Z1).onsapend(b2);}break;default:break;}}
function S1(){if(this._oSelectAllCheckBox){var i=this.getRows();var j=this.getSelectedRows();if(i.length==j.length&&j.length>0){this._oSelectAllCheckBox.setSelected(true);}else{this._oSelectAllCheckBox.setSelected(false);}}}
function T1(){if(this.getSingleSelection()){if(this._oCalendarHeader.getAllCheckBox()){this._oCalendarHeader.setAllCheckBox();}else if(this._oInfoToolbar.getContent().length>2){this._oInfoToolbar.removeContent(this._oSelectAllCheckBox);}}else{if(!this._oSelectAllCheckBox){this._oSelectAllCheckBox=new N(this.getId()+"-All",{text:this._oRB.getText("COLUMNSPANEL_SELECT_ALL")});this._oSelectAllCheckBox.attachEvent("select",Q1,this);}if(this._iSizeScreen<2||!this.getShowRowHeaders()){var i=this._oInfoToolbar.indexOfContent(this._oSelectAllCheckBox);if(this._iSizeScreen<2){if(i<this._oInfoToolbar.getContent().length-1){this._oInfoToolbar.addContent(this._oSelectAllCheckBox);}}else if(i<0||i>1){if(i>1){this._oInfoToolbar.removeContent(this._oSelectAllCheckBox);}this._oInfoToolbar.insertContent(this._oSelectAllCheckBox,1);}}else{this._oCalendarHeader.setAllCheckBox(this._oSelectAllCheckBox);}}}
k1.prototype._setSelectionMode=function(){var i=this.getAggregation("table");var j=i.getMode();var x;if(this.getSingleSelection()){if(!this.getShowRowHeaders()&&this.getRows().length==1){x=Z.None;}else{x=Z.SingleSelectMaster;}}else{x=Z.MultiSelect;}if(j!=x){i.setMode(x);}};
k1.prototype.calcIntervalOffset=function(i){var j=Date.UTC(i.getFullYear(),i.getMonth(),i.getDate());var x=this.getMinDate()||i;var W1=Date.UTC(x.getFullYear(),x.getMonth(),x.getDate());return Math.round((j-W1)/1000/60/60/24/this._getView(this.getViewKey()).getIntervalSize());};
k1.prototype._getDateFromIndex=function(i){var j=new Date(this.getMinDate());j.setDate(j.getDate()+i*this._getView(this.getViewKey()).getIntervalSize());return j;};
k1.prototype._getRelativeInfo=function(){var i={},j=this._getView(this.getViewKey(),true);i.iIntervalSize=j.getIntervalSize();i.bIsRelative=j.getRelative();i.oMinDate=this.getMinDate();i._getDateFromIndex=this._getDateFromIndex.bind(this);i.intervalLabelFormatter=j.getIntervalLabelFormatter()?j.getIntervalLabelFormatter():function(x){return x;};i._getIndexFromDate=this.calcIntervalOffset.bind(this);return i;};
function U1(){return this._oTimesRow||this._oDatesRow||this._oMonthsRow||this._oWeeksRow||this._oOneMonthsRow;}
function V1(){if(!this._getHeader()){return 0;}var i=this._getHeader().getDomRef(),j=0,x;if(i){x=i.getBoundingClientRect();j=parseInt(x.height);}return j;}
return k1;});
sap.ui.predefine('sap/m/PlanningCalendarHeader',['sap/ui/core/Element','sap/ui/core/Control','./library','./Toolbar','./AssociativeOverflowToolbar','./Button','./Popover','./Title','./ToolbarSpacer','./SegmentedButton','sap/ui/unified/Calendar','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CustomMonthPicker','sap/ui/unified/calendar/CustomYearPicker','sap/ui/unified/calendar/IndexPicker','sap/ui/core/format/DateFormat','sap/ui/core/IconPool','sap/ui/core/InvisibleText','sap/ui/core/library',"./PlanningCalendarHeaderRenderer"],function(E,C,l,T,A,B,P,a,b,S,c,d,e,f,I,D,g,h,j,k){"use strict";var m=l.ToolbarDesign;
var n=C.extend("sap.m.PlanningCalendarHeader",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:""},startDate:{type:"object",group:"Data"},pickerText:{type:"string",group:"Data"}},aggregations:{actions:{type:"sap.ui.core.Control",multiple:true,singularName:"action"},_actionsToolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"},_navigationToolbar:{type:"sap.m.Toolbar",multiple:false,visibility:"hidden"},_calendarPicker:{type:"sap.ui.unified.Calendar",multiple:false,visibility:"hidden"},_monthPicker:{type:"sap.ui.unified.internal.CustomMonthPicker",multiple:false,visibility:"hidden"},_yearPicker:{type:"sap.ui.unified.internal.CustomYearPicker",multiple:false,visibility:"hidden"},_indexPicker:{type:"sap.ui.unified.calendar.IndexPicker",multiple:false,visibility:"hidden"}},events:{pressPrevious:{},pressToday:{},pressNext:{},dateSelect:{},cancel:{},viewChange:{}},associations:{currentPicker:{type:"sap.ui.core.Control",multiple:false}}}});
var R=3;
n.prototype.init=function(){var o=this.getId(),N=o+"-NavToolbar",r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),p,i,M,y;this.setAggregation("_actionsToolbar",new A(o+"-ActionsToolbar",{design:m.Transparent}).addStyleClass("sapMPCHeadActionsToolbar").addContent(this._getOrCreateTitleControl()).addContent(this._getOrCreateToolbarSpacer()).addContent(this._getOrCreateViewSwitch()));this._oPrevBtn=new B(N+"-PrevBtn",{icon:g.getIconURI('slim-arrow-left'),tooltip:r.getText("PCH_NAVIGATE_BACKWARDS"),press:function(){this.firePressPrevious();}.bind(this)});this._oTodayBtn=new B(N+"-TodayBtn",{text:r.getText("PLANNINGCALENDAR_TODAY"),ariaLabelledBy:h.getStaticId("sap.m","PCH_NAVIGATE_TO_TODAY"),press:function(){this.firePressToday();}.bind(this)});this._oNextBtn=new B(N+"-NextBtn",{icon:g.getIconURI('slim-arrow-right'),tooltip:r.getText("PCH_NAVIGATE_FORWARD"),press:function(){this.firePressNext();}.bind(this)});i=new c(o+"-Cal",{ariaLabelledBy:h.getStaticId("sap.m","PCH_RANGE_PICKER")});i.attachEvent("select",this._handlePickerDateSelect,this);i.attachEvent("cancel",this._handlePickerCancelEvent,this);i.setPopupMode(true);this.setAggregation("_calendarPicker",i);this._oCalendarAfterRenderDelegate={onAfterRendering:function(){if(this._oPopup&&this._oPopup.isOpen()){i.focus();}}.bind(this)};i.addDelegate(this._oCalendarAfterRenderDelegate);this._oCalendar=i;this.setAssociation("currentPicker",i);M=new e(o+"-MonthCal",{ariaLabelledBy:h.getStaticId("sap.m","PCH_RANGE_PICKER")});M.attachEvent("select",this._handlePickerDateSelect,this);M.attachEvent("cancel",this._handlePickerCancelEvent,this);M.setPopupMode(true);this.setAggregation("_monthPicker",M);this._oMonthPicker=M;y=new f(o+"-YearCal",{ariaLabelledBy:h.getStaticId("sap.m","PCH_RANGE_PICKER")});y.attachEvent("select",this._handlePickerDateSelect,this);y.attachEvent("cancel",this._handlePickerCancelEvent,this);y.setPopupMode(true);this.setAggregation("_yearPicker",y);this._oYearPicker=y;var q=new I(o+"-IndexPicker");q.attachEvent("select",this._handleIndexPickerSelect,this);this.setAggregation("_indexPicker",q);this._oIndexPicker=q;this._oPickerBtn=new B(N+"-PickerBtn",{text:this.getPickerText(),ariaHasPopup:j.aria.HasPopup.Dialog,ariaLabelledBy:h.getStaticId("sap.m","PCH_SELECT_RANGE"),press:function(){if(this.fireEvent("_pickerButtonPress",{},true)){var s=this.getStartDate()||new Date(),t=this.getAssociation("currentPicker");p=E.registry.get(t);if(p.displayDate){p.displayDate(s);}this._openCalendarPickerPopup(p);}}.bind(this)});this.setAggregation("_navigationToolbar",new T(N,{design:m.Transparent,content:[this._oPrevBtn,this._oTodayBtn,this._oNextBtn,this._oPickerBtn]}).addStyleClass("sapMPCHeadNavToolbar"));};
n.prototype.exit=function(){this._getActionsToolbar().removeAllContent();if(this._oTitle){this._oTitle.destroy();this._oTitle=null;}if(this._oToolbarSpacer){this._oToolbarSpacer.destroy();this._oToolbarSpacer=null;}if(this._oViewSwitch){this._oViewSwitch.destroy();this._oViewSwitch=null;}if(this._oPopup){if(this._oCalendarAfterRenderDelegate){this._oCalendar.removeDelegate(this._oCalendarAfterRenderDelegate);}this._oPopup.destroy();this._oPopup=null;}if(this._oPrevBtn){this._oPrevBtn.destroy();this._oPrevBtn=null;}if(this._oNextBtn){this._oNextBtn.destroy();this._oNextBtn=null;}};
n.prototype.onBeforeRendering=function(){var v=!!this.getActions().length||!!this.getTitle()||this._getOrCreateViewSwitch().getItems().length>1;this._getActionsToolbar().setProperty("visible",v,true);};
n.prototype.setTitle=function(t){this._getOrCreateTitleControl().setText(t).setVisible(!!t);return this.setProperty("title",t);};
n.prototype.addAction=function(o){if(!o){return this;}this._getActionsToolbar().addContent(o);return this.addAggregation("actions",o);};
n.prototype.insertAction=function(o,i){if(!o){return this;}this._getActionsToolbar().insertContent(o,i+R);return this.insertAggregation("actions",o,i);};
n.prototype.removeAction=function(o){if(!o){return this;}this._getActionsToolbar().removeContent(o);return this.removeAggregation("actions",o);};
n.prototype.removeAllActions=function(){var o=this._getActionsToolbar(),p=o.getContent();for(var i=R;i<p.length;i++){o.removeContent(p[i]);}return this.removeAllAggregation("actions");};
n.prototype.destroyActions=function(){var o=this._getActionsToolbar(),p=o.getContent(),r;for(var i=R;i<p.length;i++){r=o.removeContent(p[i]);r.destroy();}return this;};
n.prototype.setPickerText=function(t){this.setProperty("pickerText",t);this._oPickerBtn.setText(t);return this;};
n.prototype._getOrCreateTitleControl=function(){if(!this._oTitle){this._oTitle=new a(this.getId()+"-Title",{visible:false});}return this._oTitle;};
n.prototype._getOrCreateToolbarSpacer=function(){if(!this._oToolbarSpacer){this._oToolbarSpacer=new b(this.getId()+"-Spacer");}return this._oToolbarSpacer;};
n.prototype._getOrCreateViewSwitch=function(){if(!this._oViewSwitch){this._oViewSwitch=new S(this.getId()+"-ViewSwitch",{ariaLabelledBy:h.getStaticId("sap.m","PCH_VIEW_SWITCH")});this._oViewSwitch.attachEvent("selectionChange",this._handleViewSwitchChange,this);this.addDependent(this._oViewSwitch);}return this._oViewSwitch;};
n.prototype._convertViewSwitchToSelect=function(){this._oViewSwitch._bForcedSelectMode=true;this._oViewSwitch._toSelectMode();};
n.prototype._convertViewSwitchToSegmentedButton=function(){this._oViewSwitch._bForcedSelectMode=false;this._oViewSwitch._toNormalMode();};
n.prototype._getTodayButton=function(){return this._oTodayBtn;};
n.prototype._handlePickerDateSelect=function(){var s=this.getAssociation("currentPicker"),p=E.registry.get(s),o=p.getSelectedDates()[0].getStartDate();this.setStartDate(o);this._closeCalendarPickerPopup();this.fireDateSelect();};
n.prototype._handleIndexPickerSelect=function(o){var s=this._oIndexPicker.getSelectedIndex();var i=new Date(this._oCalendar.getMinDate());var r=this._getRelativeInfo();i.setDate(i.getDate()+s*r.iIntervalSize);this.setStartDate(i);this._closeCalendarPickerPopup();this.fireDateSelect();};
n.prototype._handleViewSwitchChange=function(o){this.fireViewChange(o.getParameters());};
n.prototype._openCalendarPickerPopup=function(p){var i,o;if(!this._oPopup){this._oPopup=this._createPopup();}i=this._oPopup.getContent();if(i.length){o=this._oPopup.getContent()[0];if(o.isA("sap.ui.unified.internal.CustomYearPicker")){this.setAggregation("_yearPicker",this._oPopup.removeAllContent()[0]);}else if(o.isA("sap.ui.unified.internal.CustomMonthPicker")){this.setAggregation("_monthPicker",this._oPopup.removeAllContent()[0]);}else if(o.isA("sap.ui.unified.calendar.IndexPicker")){this.setAggregation("_indexPicker",this._oPopup.removeAllContent()[0]);}else if(p!==o){this.setAggregation("_calendarPicker",this._oPopup.removeAllContent()[0]);}}this._oPopup.addContent(p);this._oPopup.attachAfterOpen(function(){var $=this._oPopup.$();var O=Math.floor(($.width()-this._oPickerBtn.$().width())/2);this._oPopup.setOffsetX(sap.ui.getCore().getConfiguration().getRTL()?O:-O);var q=this._oPickerBtn.$().height();this._oPopup.setOffsetY(this._oPopup._getCalculatedPlacement()==="Top"?q:-q);this._oPopup.getContent()[0].focus();},this);this._oPopup.openBy(this._oPickerBtn.getDomRef());};
n.prototype._createPopup=function(){var p=new P({placement:"VerticalPreferredBottom",showHeader:false,showArrow:false,verticalScrolling:false});p.oPopup.setDurations(0,0);p.addDelegate({onsapescape:this.onsapescape},this);this._oPopup=p;return this._oPopup;};
n.prototype.onsapescape=function(){if(this._oPopup){this._closeCalendarPickerPopup();if(this._oPickerBtn.getDomRef()){this._oPickerBtn.getDomRef().focus();}}};
n.prototype._closeCalendarPickerPopup=function(){if(this._oPopup&&this._oPopup.isOpen()){this._oPopup.close();}};
n.prototype._handlePickerCancelEvent=function(){var p=this._oPickerBtn.getDomRef();this.fireCancel();this._closeCalendarPickerPopup();p&&p.focus();};
n.prototype._getActionsToolbar=function(){return this.getAggregation("_actionsToolbar");};
n.prototype._getNavigationToolbar=function(){return this.getAggregation("_navigationToolbar");};
return n;});
sap.ui.predefine('sap/m/PlanningCalendarHeaderRenderer',[],function(){"use strict";var P={apiVersion:2};
P.render=function(r,h){var a=h.getAggregation("_actionsToolbar"),n=h.getAggregation("_navigationToolbar");r.openStart("div",h);r.class("sapMPCHead");r.openEnd();if(a){r.renderControl(a);}if(n){r.renderControl(n);}r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendarLegend',['sap/ui/unified/CalendarLegend','sap/ui/unified/CalendarAppointment','sap/ui/core/Core','./PlanningCalendarLegendRenderer'],function(C,a,b,P){"use strict";
var c=C.extend("sap.m.PlanningCalendarLegend",{metadata:{library:"sap.m",properties:{itemsHeader:{type:"string",group:"Appearance"},appointmentItemsHeader:{type:"string",group:"Appearance"}},aggregations:{appointmentItems:{type:"sap.ui.unified.CalendarLegendItem",multiple:true,singularName:"appointmentItem"}},designtime:"sap/m/designtime/PlanningCalendarLegend.designtime"}});
c._COLUMN_WIDTH_DEFAULT="auto";
c.prototype.init=function(){C.prototype.init.call(this);this.setProperty("columnWidth",c._COLUMN_WIDTH_DEFAULT);this.addStyleClass("sapMPlanCalLegend");};
c.prototype.setColumnWidth=function(w){if(w==undefined){w=c._COLUMN_WIDTH_DEFAULT;}return this.setProperty("columnWidth",w);};
c.findLegendItemForItem=function(l,s){var L=l?l.getAppointmentItems():null,d=l?l.getItems():null,A=s instanceof a,I=A?L:d,o=A?s.getType():s.type,e,f,i;if(I&&I.length){for(i=0;i<I.length;i++){e=I[i];if(e.getType()===o){f=e.getText();break;}}}if(!f){f=o;}return f;};
c.prototype._getItemsHeader=function(){var i=this.getItemsHeader();if(i==undefined){return b.getLibraryResourceBundle('sap.m').getText("PLANNING_CALENDAR_LEGEND_ITEMS_HEADER");}return i;};
c.prototype._getAppointmentItemsHeader=function(){var A=this.getAppointmentItemsHeader();if(A==undefined){return b.getLibraryResourceBundle('sap.m').getText("PLANNING_CALENDAR_LEGEND_APPOINTMENT_ITEMS_HEADER");}return A;};
return c;});
sap.ui.predefine('sap/m/PlanningCalendarLegendRenderer',['sap/ui/unified/CalendarLegendRenderer','sap/ui/core/Renderer'],function(C,R){"use strict";var P=R.extend(C);P.apiVersion=2;
P.renderItemsHeader=function(r,l){var i=l._getItemsHeader();if(i&&(l.getItems().length||l.getStandardItems().length)){this._renderItemsHeader(r,i);}};
P.renderAppointmentsItemsHeader=function(r,l){var a=l._getAppointmentItemsHeader();if(a&&l.getAppointmentItems().length){this._renderItemsHeader(r,a);}else if(l.getAppointmentItems().length&&(l.getItems().length||l.getStandardItems().length)){r.voidStart("hr");r.voidEnd();}};
P._renderItemsHeader=function(r,h){r.openStart("div");r.class("sapMPlanCalLegendHeader");r.attr("role","heading");r.attr("aria-level","3");r.openEnd();r.text(h);r.close("div");r.voidStart("hr");r.voidEnd();};
P.renderAdditionalContent=function(r,l){var a=l.getAppointmentItems(),i,c;this.renderAppointmentsItemsHeader(r,l);r.openStart("div");r.class("sapUiUnifiedLegendItems");c=l.getColumnWidth();r.style("column-width",c);r.style("-moz-column-width",c);r.style("-webkit-column-width",c);r.openEnd();for(i=0;i<a.length;i++){this.renderLegendItem(r,"sapUiCalLegDayType"+l._getItemType(a[i],a).slice(4),a[i],["sapUiUnifiedLegendSquareColor","sapMPlanCalLegendAppCircle"]);}r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendarRenderer',['sap/ui/unified/library'],function(l){"use strict";var C=l.CalendarAppointmentRoundWidth;var P={apiVersion:2};
P.render=function(r,p){var i=p.getId();var t=p.getTooltip_AsString();var h=p._getHeader();r.openStart("div",p);r.class("sapMPlanCal");r.accessibilityState({role:"region",roledescription:p._oRB.getText("PLANNINGCALENDAR"),labelledby:{value:h.getId()+"-Title",append:true}});this.addAdditionalClasses(r,p);switch(p.getAppointmentRoundWidth()){case C.HalfColumn:r.class("sapUiCalendarAppHalfColumnRounding");break;}if(!p.getSingleSelection()){r.class("sapMPlanCalMultiSel");}if(!p.getShowRowHeaders()){r.class("sapMPlanCalNoHead");}if(p.getShowWeekNumbers()&&p._viewAllowsWeekNumbers(p.getViewKey())){r.class("sapMPlanCalWithWeekNumbers");}if(p.getShowDayNamesLine()&&p._viewAllowsDayNamesLine(p.getViewKey())){r.class("sapMPlanCalWithDayNamesLine");}if(t){r.attr('title',t);}var w=p.getWidth();if(w){r.style("width",w);}var H=p.getHeight();if(H){r.style("height",H);}r.accessibilityState(p);r.openEnd();r.renderControl(h);var T=p.getAggregation("table");r.renderControl(T);var a=p._oRB.getText("PLANNINGCALENDAR");r.openStart("span",i+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(a);r.close("span");a=p._oRB.getText("PLANNINGCALENDAR_VIEW");r.openStart("span",i+"-SelDescr");r.class("sapUiInvisibleText");r.openEnd();r.text(a);r.close("span");r.close("div");};
P.addAdditionalClasses=function(){};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendarRow',['sap/ui/core/Core','sap/ui/core/Element','sap/m/CustomListItem','sap/ui/unified/DateTypeRange','sap/ui/unified/library'],function(C,E,a,D,u){"use strict";
var P=E.extend("sap.m.PlanningCalendarRow",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data"},text:{type:"string",group:"Data"},icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},nonWorkingDays:{type:"int[]",group:"Misc",defaultValue:null},nonWorkingHours:{type:"int[]",group:"Misc",defaultValue:null},selected:{type:"boolean",group:"Data",defaultValue:false},key:{type:"string",group:"Data",defaultValue:null},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsResize:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsCreate:{type:"boolean",group:"Misc",defaultValue:false},noAppointmentsText:{type:"string",group:"Misc",defaultValue:null}},aggregations:{appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",dnd:{draggable:true}},intervalHeaders:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"intervalHeader"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},headerContent:{type:"sap.ui.core.Control",multiple:true,singularName:"headerContent",forwarding:{getter:"_getPlanningCalendarCustomRowHeader",aggregation:"content"},forwardBinding:true}},events:{appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},calendarRow:{type:"sap.m.PlanningCalendarRow"},copy:{type:"boolean"}}},appointmentDragEnter:{allowPreventDefault:true,parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},calendarRow:{type:"sap.m.PlanningCalendarRow"}}},appointmentResize:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"}}},appointmentCreate:{parameters:{startDate:{type:"object"},endDate:{type:"object"},calendarRow:{type:"sap.m.PlanningCalendarRow"}}}}}});
P.prototype.exit=function(){if(this.oRowHeader){this.oRowHeader.destroy();}};
P.prototype._getPlanningCalendarCustomRowHeader=function(){if(!this.oRowHeader){this.oRowHeader=new a(this.getId()+"-CustomHead",{accDescription:C.getLibraryResourceBundle("sap.m").getText("PC_CUSTOM_ROW_HEADER_CONTENT_DESC")});}return this.oRowHeader;};
P.prototype._getSpecialDates=function(){var s=this.getSpecialDates();for(var i=0;i<s.length;i++){var n=s[i].getSecondaryType()===u.CalendarDayType.NonWorking&&s[i].getType()!==u.CalendarDayType.NonWorking;if(n){var b=new D();b.setType(u.CalendarDayType.NonWorking);b.setStartDate(s[i].getStartDate());if(s[i].getEndDate()){b.setEndDate(s[i].getEndDate());}s.push(b);}}return s;};
return P;});
sap.ui.predefine('sap/m/PlanningCalendarView',['sap/ui/core/Element','./library','sap/ui/unified/library'],function(E,l,u){"use strict";var C=u.CalendarIntervalType;var a=u.CalendarAppointmentHeight;
var P=E.extend("sap.m.PlanningCalendarView",{metadata:{library:"sap.m",properties:{key:{type:"string",group:"Data",defaultValue:null},intervalType:{type:"sap.ui.unified.CalendarIntervalType",group:"Appearance",defaultValue:C.Hour},intervalSize:{type:"int",group:"Appearance",defaultValue:1},intervalLabelFormatter:{type:"object",group:"Appearance"},relative:{type:"boolean",group:"Appearance",defaultValue:false},description:{type:"string",group:"Data"},intervalsS:{type:"int",group:"Appearance",defaultValue:6},intervalsM:{type:"int",group:"Appearance",defaultValue:8},intervalsL:{type:"int",group:"Appearance",defaultValue:12},showSubIntervals:{type:"boolean",group:"Appearance",defaultValue:false},appointmentHeight:{type:"sap.ui.unified.CalendarAppointmentHeight",group:"Appearance",defaultValue:a.Regular}}}});
return P;});
sap.ui.predefine('sap/m/Popover',['./Bar','./Button','./InstanceManager','./library','./Title','sap/ui/core/Control','sap/ui/core/Popup','sap/ui/core/delegate/ScrollEnablement','sap/ui/core/theming/Parameters','sap/ui/Device',"sap/ui/core/util/ResponsivePaddingsEnablement",'sap/ui/core/library','sap/ui/core/Element','sap/ui/core/ResizeHandler','./PopoverRenderer',"sap/ui/dom/containsOrEquals","sap/ui/thirdparty/jquery","sap/ui/dom/getScrollbarSize","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/dom/jquery/Focusable","sap/ui/dom/jquery/rect","sap/ui/dom/jquery/control"],function(B,a,I,l,T,C,P,S,b,D,R,c,E,d,f,g,q,h,K,L){"use strict";var i=l.PopupHelper;var O=c.OpenState;var j=l.PlacementType;var k=l.TitleAlignment;
var m=C.extend("sap.m.Popover",{metadata:{interfaces:["sap.ui.core.PopupInterface"],library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Behavior",defaultValue:j.Right},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},title:{type:"string",group:"Appearance",defaultValue:null},modal:{type:"boolean",group:"Behavior",defaultValue:false},offsetX:{type:"int",group:"Appearance",defaultValue:0},offsetY:{type:"int",group:"Appearance",defaultValue:0},showArrow:{type:"boolean",group:"Appearance",defaultValue:true},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},contentMinWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:""},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},enableScrolling:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},horizontalScrolling:{type:"boolean",group:"Misc",defaultValue:true},bounce:{type:"boolean",group:"Behavior",defaultValue:null,deprecated:true},resizable:{type:"boolean",group:"Dimension",defaultValue:false},ariaModal:{type:"boolean",group:"Misc",defaultValue:true,visibility:"hidden"},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:k.Auto},ariaRoleApplication:{type:"boolean",group:"Misc",defaultValue:false,visibility:"hidden"}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.ui.core.Control",multiple:false},subHeader:{type:"sap.ui.core.Control",multiple:false},footer:{type:"sap.ui.core.Control",multiple:false},_internalHeader:{type:"sap.m.Bar",multiple:false,visibility:"hidden"},beginButton:{type:"sap.ui.core.Control",multiple:false},endButton:{type:"sap.ui.core.Control",multiple:false}},associations:{leftButton:{type:"sap.m.Button",multiple:false,deprecated:true},rightButton:{type:"sap.m.Button",multiple:false,deprecated:true},initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}}},designtime:"sap/m/designtime/Popover.designtime"}});
m._bIOS7=D.os.ios&&D.os.version>=7&&D.os.version<8&&D.browser.name==="sf";R.call(m.prototype,{header:{suffix:"intHeader"},subHeader:{selector:".sapMPopoverSubHeader .sapMIBar"},content:{suffix:"cont"},footer:{selector:".sapMPopoverFooter .sapMIBar"}});
m.prototype.init=function(){this._arrowOffsetThreshold=4;this._marginTopInit=false;this._marginTop=48;this._marginLeft=10;this._marginRight=10;this._marginBottom=10;this._minDimensions={width:100,height:32};this._initialWindowDimensions={};this.oPopup=new P();this.oPopup.setShadow(true);this.oPopup.setAutoClose(true);this.oPopup.setAnimations(q.proxy(this._openAnimation,this),q.proxy(this._closeAnimation,this));this._placements=[j.Top,j.Right,j.Bottom,j.Left,j.Vertical,j.Horizontal,j.Auto,j.VerticalPreferedTop,j.VerticalPreferedBottom,j.HorizontalPreferedLeft,j.HorizontalPreferedRight,j.VerticalPreferredTop,j.VerticalPreferredBottom,j.HorizontalPreferredLeft,j.HorizontalPreferredRight,j.PreferredRightOrFlip,j.PreferredLeftOrFlip,j.PreferredTopOrFlip,j.PreferredBottomOrFlip];this._myPositions=["center bottom","begin center","center top","end center"];this._atPositions=["center top","end center","center bottom","begin center"];this._offsets=["0 -18","18 0","0 18","-18 0"];this._arrowOffset=18;this._followOfTolerance=32;this._scrollContentList=["sap.m.NavContainer","sap.m.Page","sap.m.ScrollContainer"];this._fnAdjustPositionAndArrow=q.proxy(this._adjustPositionAndArrow,this);this._fnOrientationChange=q.proxy(this._onOrientationChange,this);this._fnFollowOf=q.proxy(function(e){var o=e.lastOfRect,r=e.currentOfRect;if(!D.system.desktop||(Math.abs(o.top-r.top)<=this._followOfTolerance&&Math.abs(o.left-r.left)<=this._followOfTolerance)||(Math.abs(o.top+o.height-r.top-r.height)<=this._followOfTolerance&&Math.abs(o.left+o.width-r.left-r.width)<=this._followOfTolerance)){this.oPopup._applyPosition(this.oPopup._oLastPosition,true);}else{this.close();}},this);this.setFollowOf(true);this._initResponsivePaddingsEnablement();this._oRestoreFocusDelegate={onBeforeRendering:function(){var A=q(document.activeElement),o=A.control(0);this._sFocusControlId=o&&o.getId();},onAfterRendering:function(){if(this._sFocusControlId&&!g(this.getDomRef(),document.activeElement)){sap.ui.getCore().byId(this._sFocusControlId).focus();}}};var t=this;this.oPopup._applyPosition=function(p,F){var e=this.getOpenState(),o;if(e===O.CLOSING||e===O.CLOSED){return;}if(F){t._storeScrollPosition();}t._clearCSSStyles();var n=t._placements.indexOf(t.getPlacement());if(n>3&&!t._bPosCalced){t._calcPlacement();return;}t._bPosCalced=false;if(t._oOpenBy instanceof E){p.of=t._getOpenByDomRef();}if(!p.of){L.warning("sap.m.Popover: in function applyPosition, the openBy element doesn't have any DOM output. "+t);return;}if(!g(document.documentElement,p.of)&&p.of.id){o=q(document.getElementById(p.of.id));if(o){p.of=o;}else{L.warning("sap.m.Popover: in function applyPosition, the openBy element's DOM is already detached from DOM tree and can't be found again by the same id. "+t);return;}}var r=q(p.of).rect();var $=q(t.getWithinAreaDomRef());if(F&&$.height()==t._initialWindowDimensions.height&&(r.top+r.height<=0||r.top>=$.height()||r.left+r.width<=0||r.left>=$.width())){t.close();return;}var s=t.getDomRef("scroll");if(!D.system.desktop){q(window).scrollLeft(0);}t._deregisterContentResizeHandler();P.prototype._applyPosition.call(this,p);t._fnAdjustPositionAndArrow();t._restoreScrollPosition();t._registerContentResizeHandler(s);};this.oPopup.close=function(e){var n=typeof e==="boolean";var o=t.oPopup.getOpenState();var p=t._oOpenBy&&t._oOpenBy.getDomRef&&!!t._oOpenBy.getDomRef();if(e!==true&&(this.touchEnabled||!(this._isFocusInsidePopup()&&p))&&this.isOpen()&&!(o===O.CLOSED||o===O.CLOSING)){t.fireBeforeClose({openBy:t._oOpenBy});}t._deregisterContentResizeHandler();P.prototype.close.apply(this,n?[]:arguments);t.removeDelegate(t._oRestoreFocusDelegate);};};
m.prototype.getWithinAreaDomRef=function(){return P.getWithinAreaDomRef();};
m.prototype.onBeforeRendering=function(){var n,p,$,H=this.getHorizontalScrolling(),v=this.getVerticalScrolling(),e=!H||this.isPropertyInitial("horizontalScrolling"),V=!v||this.isPropertyInitial("verticalScrolling"),o=this.getCustomHeader()||this._internalHeader;if(this.hasStyleClass("sapUiPopupWithPadding")){L.warning("Usage of CSS class 'sapUiPopupWithPadding' is deprecated. Use 'sapUiContentPadding' instead",null,"sap.m.Popover");}if(!this._initialWindowDimensions.width||!this._initialWindowDimensions.height){$=q(this.getWithinAreaDomRef());this._initialWindowDimensions={width:$.width(),height:$.height()};}this._hasSingleScrollableContent();if(!H&&!v){this._forceDisableScrolling=true;}else if(e&&V&&this._singleScrollableContent){this._forceDisableScrolling=true;L.info("VerticalScrolling and horizontalScrolling in sap.m.Popover with ID "+this.getId()+" has been disabled because there's scrollable content inside");}else{this._forceDisableScrolling=false;}if(!this._forceDisableScrolling){if(!this._oScroller){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:H,vertical:v});}else{this._oScroller.setHorizontal(H);this._oScroller.setVertical(v);}}if(this._bContentChanged){this._bContentChanged=false;n=this._getSingleNavContent();p=this._getSinglePageContent();if(n&&!this.getModal()&&!D.system.phone&&!q.sap.simulateMobileOnDesktop){n.attachEvent("afterNavigate",function(r){var s=this.getDomRef();if(s){var F=this.$().firstFocusableDomRef()||s;F.focus();}},this);}if(n||p){p=p||n.getCurrentPage();if(p&&p._getAnyHeader){this.addStyleClass("sapMPopoverWithHeaderCont");}if(n){n.attachEvent("navigate",function(r){var s=r.getParameter("to");if(s instanceof C&&s.isA("sap.m.Page")){this.$().toggleClass("sapMPopoverWithHeaderCont",!!s._getAnyHeader());}},this);}}}this._setHeaderTitle();if(!D.system.desktop){this.setResizable(false);}if(o&&o.getTitleAlignment){o.setProperty("titleAlignment",this.getTitleAlignment(),true);}};
m.prototype.onAfterRendering=function(){var $,e,n;if(!this._marginTopInit&&this.getShowArrow()){this._marginTop=2;if(this._oOpenBy){$=q(this._getOpenByDomRef());if(!($.closest("header.sapMIBar").length>0)){e=$.closest(".sapMPage");if(e.length>0){n=e.children("header.sapMIBar");if(n.length>0){this._marginTop+=n.outerHeight();}}}this._marginTopInit=true;}}};
m.prototype.exit=function(){this._deregisterContentResizeHandler();D.resize.detachHandler(this._fnOrientationChange);I.removePopoverInstance(this);this.removeDelegate(this._oRestoreFocusDelegate);this._oRestoreFocusDelegate=null;if(this.oPopup){this.oPopup.detachClosed(this._handleClosed,this);this.oPopup.destroy();this.oPopup=null;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._internalHeader){this._internalHeader.destroy();this._internalHeader=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}};
m.prototype.openBy=function(o,s){var p=this.oPopup,e=this.oPopup.getOpenState(),F=this._getInitialFocusId(),n,r,t,u;n=(o.getDomRef&&o.getDomRef())||o;u=q(n).closest(".sapUiSizeCompact");t=b.get({name:"_sap_m_Popover_ForceCompactArrowOffset"})||"true";t=t==="true";this._bSizeCompact=l._bSizeCompact||!!u.length||this.hasStyleClass("sapUiSizeCompact");this._bUseCompactArrow=this._bSizeCompact||t;this._adaptPositionParams();if(e===O.OPEN||e===O.OPENING){if(this._oOpenBy===o){return this;}else{var v=function(){p.detachClosed(v,this);this.openBy(o);};p.attachClosed(v,this);this._oPreviousFocus=null;this.close();return this;}}if(!o){return this;}if(D.support.touch){D.resize.attachHandler(this._fnOrientationChange);}if(!this._oOpenBy||o!==this._oOpenBy){this._oOpenBy=o;}this.fireBeforeOpen({openBy:this._oOpenBy});p.attachOpened(this._handleOpened,this);p.attachClosed(this._handleClosed,this);p.setInitialFocusId(F);r=this._placements.indexOf(this.getPlacement());if(r>-1){n=this._getOpenByDomRef();if(!n){L.error("sap.m.Popover id = "+this.getId()+": is opened by a control which isn't rendered yet.");return this;}p.setAutoCloseAreas([o]);p.setContent(this);if(r<=3){p.setPosition(this._myPositions[r],this._atPositions[r],n,this._calcOffset(this._offsets[r]),"fit");}else{p._oPosition.of=n;}var w=this;var x=function(){if(p.bIsDestroyed){return;}if(p.getOpenState()===O.CLOSING){if(w._sOpenTimeout){clearTimeout(w._sOpenTimeout);w._sOpenTimeout=null;}w._sOpenTimeout=setTimeout(x,150);}else{w._oPreviousFocus=P.getCurrentFocusInfo();p.open();w.addDelegate(w._oRestoreFocusDelegate,w);if(!s){I.addPopoverInstance(w);}}};x();}else{L.error(this.getPlacement()+"is not a valid value! It can only be top, right, bottom or left");}return this;};
m.prototype.close=function(){var e=this.oPopup.getOpenState(),s,A;if(e===O.CLOSED||e===O.CLOSING){return this;}this.fireBeforeClose({openBy:this._oOpenBy});this.oPopup.close(true);if(this._oPreviousFocus){A=document.activeElement||{};s=(this._oPreviousFocus.sFocusId===sap.ui.getCore().getCurrentFocusedControlId())||(this._oPreviousFocus.sFocusId===A.id);if(!s){P.applyFocusInfo(this._oPreviousFocus);this._oPreviousFocus=null;}}return this;};
m.prototype.isOpen=function(){return this.oPopup&&this.oPopup.isOpen();};
m.prototype.setFollowOf=function(v){if(v){this.oPopup.setFollowOf(this._fnFollowOf);}else{this.oPopup.setFollowOf(false);}return this;};
m.prototype._clearCSSStyles=function(){if(!this.getDomRef()){return;}var s=this.getDomRef().style,$=this.$("cont"),e=$.children(".sapMPopoverScroll"),o=$[0].style,n=e[0].style,p=this.getContentWidth(),r=this.getContentHeight(),t=this.$("arrow"),w,W,u=q(this.getWithinAreaDomRef());if(p.indexOf("%")>0){w=u.width();p=i.calcPercentageSize(p,w);}if(r.indexOf("%")>0){W=u.height();r=i.calcPercentageSize(r,W);}o.width=p||"";o.height=r||"";o.maxWidth="";o.maxHeight="";s.left="";s.right="";s.top="";s.bottom="";s.width="";s.height="";s.overflow="";n.width="";n.display="";t.removeClass("sapMPopoverArrRight sapMPopoverArrLeft sapMPopoverArrDown sapMPopoverArrUp sapMPopoverCrossArr sapMPopoverFooterAlignArr sapMPopoverHeaderAlignArr sapContrast sapContrastPlus");t.css({left:"",top:""});};
m.prototype._onOrientationChange=function(){var e=(this.oPopup&&this.oPopup.getOpenState())||{};if(e!==O.OPEN){return;}this.oPopup._applyPosition(this.oPopup._oLastPosition,true);this._includeScrollWidth();};
m.prototype._includeScrollWidth=function(){var s=this.getContentWidth(),$=this.$(),M=Math.floor(window.innerWidth*0.9),e=this.$('cont');if(!e[0]){return;}if(D.system.desktop&&!D.browser.chrome){var H=e[0].clientHeight<e[0].scrollHeight;if(H&&(!s||s==='auto')&&e.width()<M){$.addClass("sapMPopoverVerticalScrollIncluded");}else{$.removeClass("sapMPopoverVerticalScrollIncluded");}}};
m.prototype._handleOpened=function(){var t=this;this.oPopup.detachOpened(this._handleOpened,this);this._repositionOffset();if(!D.support.touch){setTimeout(function(){!t.bIsDestroyed&&D.resize.attachHandler(t._fnOrientationChange);},0);}var F=this._getInitialFocusId(),o=sap.ui.getCore().byId(F),e=(F?window.document.getElementById(F):null);if(o&&o.getFocusDomRef()){o.getFocusDomRef().focus();}else if(!o&&e){e.focus();}this.fireAfterOpen({openBy:this._oOpenBy});};
m.prototype._handleClosed=function(){this.oPopup.detachClosed(this._handleClosed,this);D.resize.detachHandler(this._fnOrientationChange);I.removePopoverInstance(this);if(!this.oPopup._bModal&&!D.system.desktop&&document.activeElement&&!q(document.activeElement).is(":visible")){document.activeElement.blur();}this.fireAfterClose({openBy:this._oOpenBy});};
m.prototype.onfocusin=function(e){var s=e.target,$=this.$(),F=this.getId()+"-firstfe",M=this.getId()+"-middlefe",n=this.getId()+"-lastfe";if(s.id===F){var o=$.lastFocusableDomRef();if(o){o.focus();}else{document.getElementById(M).focus();}}else if(s.id===n){var p=$.firstFocusableDomRef();if(p){p.focus();}else{document.getElementById(M).focus();}}};
m.prototype.onkeydown=function(e){var o=K,n=e.which||e.keyCode,A=e.altKey;this._isSpacePressed=this._isSpacePressed||o.SPACE===n;if((!this._isSpacePressed&&n===o.ESCAPE)||(A&&n===o.F4)){if(e.originalEvent&&e.originalEvent._sapui_handledByControl){return;}this.close();e.stopPropagation();e.preventDefault();}};
m.prototype.onkeyup=function(e){var o=K,n=e.which||e.keyCode;if(o.SPACE===n){this._isSpacePressed=false;}};
m.prototype.onmousedown=function(o){var r=sap.ui.getCore().getConfiguration().getRTL();if(!o.target.classList||!o.target.classList.contains("sapMPopoverResizeHandle")){return;}var $=q(document);var n=this.$();var t=this;n.addClass('sapMPopoverResizing');o.preventDefault();o.stopPropagation();var p={x:o.pageX,y:o.pageY,width:n.width(),height:n.height()};$.on("mousemove.sapMPopover",function(e){var w,s;if(r){w=p.width+p.x-e.pageX;s=p.height+(p.y-e.pageY);}else{w=p.width+e.pageX-p.x;s=p.height+(p.y-e.pageY);}t.setContentWidth(Math.max(w,t._minDimensions.width)+'px');t.setContentHeight(Math.max(s,t._minDimensions.height)+'px');});$.on("mouseup.sapMPopover",function(){n.removeClass("sapMPopoverResizing");$.off("mouseup.sapMPopover, mousemove.sapMPopover");});};
m.prototype._hasSingleNavContent=function(){return!!this._getSingleNavContent();};
m.prototype._getSingleNavContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA("sap.m.NavContainer")){return e[0];}else{return null;}};
m.prototype._getSinglePageContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA("sap.m.Page")){return e[0];}else{return null;}};
m.prototype._hasSinglePageContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA("sap.m.Page")){return true;}else{return false;}};
m.prototype._hasSingleScrollableContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA(this._scrollContentList)){this._singleScrollableContent=true;}else{this._singleScrollableContent=false;}};
m.prototype._getOffsetX=function(){var F=this.getPlacement(),e=0;if(this._bHorizontalFlip){var p=this._getOpenByDomRef();var H=p!==undefined;var n=H?p.getBoundingClientRect().width:0;e=F===j.PreferredRightOrFlip?Math.abs(n):-Math.abs(n);}var r=sap.ui.getCore().getConfiguration().getRTL();var o=e*(r?-1:1)+this.getOffsetX()*(r?-1:1);return o;};
m.prototype._getOffsetY=function(){var F=this.getPlacement(),e=0;if(this._bVerticalFlip){var p=this._getOpenByDomRef();var H=p!==undefined;var n=H?p.getBoundingClientRect().height:0;e=F==="PreferredTopOrFlip"?-Math.abs(n):Math.abs(n);}return e+this.getOffsetY();};
m.prototype._calcOffset=function(o){var e=this._getOffsetX(),n=this._getOffsetY();var p=o.split(" ");var o=(parseInt(p[0])+e)+" "+(parseInt(p[1])+n);return o;};
m.prototype._calcPlacement=function(){var p=this.getPlacement();var o=this._getOpenByDomRef();switch(p){case j.Auto:this._calcAuto();break;case j.Vertical:case j.VerticalPreferedTop:case j.VerticalPreferredTop:case j.VerticalPreferedBottom:case j.VerticalPreferredBottom:case j.PreferredTopOrFlip:case j.PreferredBottomOrFlip:this._calcVertical();break;case j.Horizontal:case j.HorizontalPreferedLeft:case j.HorizontalPreferredLeft:case j.HorizontalPreferedRight:case j.HorizontalPreferredRight:case j.PreferredRightOrFlip:case j.PreferredLeftOrFlip:this._calcHorizontal();break;}this._bPosCalced=true;var e=this._placements.indexOf(this._oCalcedPos);this.oPopup.setPosition(this._myPositions[e],this._atPositions[e],o,this._calcOffset(this._offsets[e]),"fit");};
m.prototype._getDocHeight=function(){var e=document.body,n=document.documentElement,w=this.getWithinAreaDomRef(),o=(w!==window)?q(w).offset():{top:0};return o.top+Math.max(e.scrollHeight,e.offsetHeight,n.clientHeight,n.offsetHeight);};
m.prototype._calcVertical=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=this.getPlacement()===j.VerticalPreferedTop||this.getPlacement()===j.VerticalPreferredTop;var e=this.getPlacement()===j.VerticalPreferedBottom||this.getPlacement()===j.VerticalPreferredBottom;var n=this.getPlacement()===j.PreferredTopOrFlip;var o=this.getPlacement()===j.PreferredBottomOrFlip;var r=H?$[0].getBoundingClientRect().top:0;var s=H?$[0].getBoundingClientRect().height:0;var t=this._getOffsetY();var u=r-this._marginTop+t;var v=this.$().outerHeight();var w=this._getDocHeight()-($.offset().top+s+this._marginBottom+t);if(p&&u>v+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=j.Top;}else if(n){if(u>v+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=j.Top;}else{this._bVerticalFlip=true;this._oCalcedPos=j.Bottom;}}else if(e&&w>v+this._arrowOffset){this._oCalcedPos=j.Bottom;this._bVerticalFlip=false;}else if(o){if(w>v+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=j.Bottom;}else{this._bVerticalFlip=true;this._oCalcedPos=j.Top;}}else if(u>w){this._oCalcedPos=j.Top;}else{this._oCalcedPos=j.Bottom;}};
m.prototype._calcHorizontal=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=this.getPlacement()===j.HorizontalPreferedLeft||this.getPlacement()===j.HorizontalPreferredLeft;var e=this.getPlacement()===j.HorizontalPreferedRight||this.getPlacement()===j.HorizontalPreferredRight;var n=H?$[0].getBoundingClientRect().left:0;var o=H?$[0].getBoundingClientRect().width:0;var r=this._getOffsetX();var s=n-this._marginLeft+r;var t=n+o;var u=q(this.getWithinAreaDomRef());var v=u.width()-t-this._marginRight-r;var w=this.$().outerWidth();var x=this.getPlacement()===j.PreferredLeftOrFlip;var y=this.getPlacement()===j.PreferredRightOrFlip;var z=sap.ui.getCore().getConfiguration().getRTL();if(p&&s>w+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=z?j.Right:j.Left;}else if(x){if(s>w+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=z?j.Right:j.Left;}else{this._bHorizontalFlip=true;this._oCalcedPos=z?j.Left:j.Right;}}else if(e&&v>w+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=z?j.Left:j.Right;}else if(y){if(v>w+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=z?j.Left:j.Right;}else{this._bHorizontalFlip=true;this._oCalcedPos=z?j.Right:j.Left;}}else if(s>v){this._oCalcedPos=z?j.Right:j.Left;}else{this._oCalcedPos=z?j.Left:j.Right;}};
m.prototype._calcAuto=function(){var $=q(this.getWithinAreaDomRef());if($.width()>$.height()){if(this._checkHorizontal()){this._calcHorizontal();}else if(this._checkVertical()){this._calcVertical();}else{this._calcBestPos();}}else{if(this._checkVertical()){this._calcVertical();}else if(this._checkHorizontal()){this._calcHorizontal();}else{this._calcBestPos();}}};
m.prototype._checkHorizontal=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=H?$[0].getBoundingClientRect().left:0;var e=H?$[0].getBoundingClientRect().width:0;var o=this._getOffsetX();var n=p-this._marginLeft+o;var r=p+e;var s=q(this.getWithinAreaDomRef());var t=s.width()-r-this._marginRight-o;var u=this.$();var w=u.outerWidth()+this._arrowOffset;if((w<=n)||(w<=t)){return true;}};
m.prototype._checkVertical=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=H?$[0].getBoundingClientRect().top:0;var e=H?$[0].getBoundingClientRect().height:0;var o=this._getOffsetY();var t=p-this._marginTop+o;var n=this._getDocHeight()-$.offset().top-e-this._marginBottom-o;var r=this.$();var s=r.outerHeight()+this._arrowOffset;if((s<=t)||(s<=n)){return true;}};
m.prototype._calcBestPos=function(){var $=this.$();var H=$.outerHeight();var w=$.outerWidth();var r=sap.ui.getCore().getConfiguration().getRTL();var e=q(this._getOpenByDomRef());var n=e[0]!==undefined;var p=n?e[0].getBoundingClientRect().left:0;var o=n?e[0].getBoundingClientRect().top:0;var s=n?e[0].getBoundingClientRect().width:0;var t=n?e[0].getBoundingClientRect().height:0;var u=this._getOffsetX();var v=this._getOffsetY();var x=o-this._marginTop+v;var y=this._getDocHeight()-e.offset().top-t-this._marginBottom-v;var z=p-this._marginLeft+u;var A=p+s;var F=q(this.getWithinAreaDomRef());var G=F.width()-A-this._marginRight-u;var J=H*w;var M;var N;if((F.height()-this._marginTop-this._marginBottom)>=H){M=H;}else{M=F.height()-this._marginTop-this._marginBottom;}if((F.width()-this._marginLeft-this._marginRight)>=w){N=w;}else{N=F.width()-this._marginLeft-this._marginRight;}var Q=(M*(z))/J;var U=(M*(G))/J;var V=(N*(x))/J;var W=(N*(y))/J;var X=Math.max(Q,U);var Y=Math.max(V,W);if(X>Y){if(X===Q){this._oCalcedPos=r?j.Right:j.Left;}else if(X===U){this._oCalcedPos=r?j.Left:j.Right;}}else if(Y>X){if(Y===V){this._oCalcedPos=j.Top;}else if(Y===W){this._oCalcedPos=j.Bottom;}}else if(Y===X){if(F.height()>F.width()){if(Y===V){this._oCalcedPos=j.Top;}else if(Y===W){this._oCalcedPos=j.Bottom;}}else{if(X===Q){this._oCalcedPos=r?j.Right:j.Left;}else if(X===U){this._oCalcedPos=r?j.Left:j.Right;}}}};
m.outerWidth=function(e,n){if(typeof window.SVGElement!=="undefined"&&e instanceof window.SVGElement){return e.getBoundingClientRect().width;}return q(e).outerWidth(!!n);};
m.outerHeight=function(e,n){if(typeof window.SVGElement!=="undefined"&&e instanceof window.SVGElement){return e.getBoundingClientRect().height;}return q(e).outerHeight(!!n);};
m.prototype._getPositionParams=function($,e,n,o){var p=window.getComputedStyle($[0]),r=window.getComputedStyle(n[0]),s=q(window),t=this.getDomRef().clientHeight!==this.getDomRef().scrollHeight?h().width:0,u=q(this.getWithinAreaDomRef()),w=(u[0]!==window)?u.offset():{top:0,left:0},v={};v._$popover=$;v._$parent=q(this._getOpenByDomRef());v._$arrow=e;v._$content=n;v._$scrollArea=o;v._$header=$.children(".sapMPopoverHeader");v._$subHeader=$.children(".sapMPopoverSubHeader");v._$footer=$.children(".sapMPopoverFooter");v._fWindowTop=s.scrollTop();v._fWindowRight=s.width();v._fWindowBottom=(m._bIOS7&&D.orientation.landscape&&window.innerHeight)?window.innerHeight:s.height();v._fWindowLeft=s.scrollLeft();v._fWindowWidth=window.innerWidth;v._fWindowHeight=window.innerHeight;v._fWithinAreaWidth=Math.min(u.outerWidth(),v._fWindowWidth);v._fWithinAreaHeight=Math.min(u.outerHeight(),v._fWindowHeight);v._fDocumentWidth=v._fWindowLeft+v._fWindowRight;v._fDocumentHeight=v._fWindowTop+v._fWindowBottom;v._fArrowHeight=e.outerHeight(true);v._fPopoverWidth=m.outerWidth($[0]);v._fPopoverInnerWidth=v._$scrollArea?(v._$scrollArea.width()+t):0;v._fPopoverHeight=m.outerHeight($[0]);v._fHeaderHeight=v._$header.length>0?v._$header.outerHeight(true):0;v._fSubHeaderHeight=v._$subHeader.length>0?v._$subHeader.outerHeight(true):0;v._fFooterHeight=v._$footer.length>0?v._$footer.outerHeight(true):0;v._fPopoverOffset=$.offset();v._fPopoverOffsetX=this._getOffsetX();v._fPopoverOffsetY=this._getOffsetY();v._fPopoverMarginTop=v._fWindowTop+this._marginTop+w.top;v._fPopoverMarginLeft=v._fWindowLeft+this._marginLeft+w.left;v._fPopoverMarginRight=v._fWindowWidth-w.left-v._fWithinAreaWidth+this._marginRight;v._fPopoverMarginBottom=v._fWindowHeight-w.top-v._fWithinAreaHeight+this._marginBottom;v._fPopoverBorderTop=parseFloat(p.borderTopWidth);v._fPopoverBorderRight=parseFloat(p.borderRightWidth);v._fPopoverBorderBottom=parseFloat(p.borderBottomWidth);v._fPopoverBorderLeft=parseFloat(p.borderLeftWidth);v._fContentMarginTop=parseFloat(r.marginTop);v._fContentMarginBottom=parseFloat(r.marginBottom);return v;};
m.prototype._recalculateMargins=function(s,p){var n;var r=sap.ui.getCore().getConfiguration().getRTL();switch(s){case j.Left:if(r){p._fPopoverMarginLeft=p._$parent.offset().left+m.outerWidth(p._$parent[0],false)+this._arrowOffset-p._fPopoverOffsetX;}else{p._fPopoverMarginRight=p._fWindowWidth-p._$parent.offset().left+this._arrowOffset-p._fPopoverOffsetX;}break;case j.Right:if(r){p._fPopoverMarginRight=p._fWindowWidth-m.outerWidth(p._$parent[0],false)-p._$parent.offset().left+this._arrowOffset;}else{p._fPopoverMarginLeft=p._$parent.offset().left+m.outerWidth(p._$parent[0],false)+this._arrowOffset+p._fPopoverOffsetX;}break;case j.Top:n=p._fWindowHeight-p._$parent.offset().top+this._arrowOffset-p._fPopoverOffsetY;p._fPopoverMarginBottom=n>p._fPopoverMarginBottom?n:p._fPopoverMarginBottom;break;case j.Bottom:p._fPopoverMarginTop=p._$parent.offset().top+m.outerHeight(p._$parent[0],false)+this._arrowOffset+p._fPopoverOffsetY;break;}return p;};
m.prototype._getPopoverPositionCss=function(p){var e,r,t,n,o=p._fDocumentWidth-p._fPopoverOffset.left-p._fPopoverWidth,s=p._fDocumentHeight-p._fPopoverOffset.top-p._fPopoverHeight,u=(p._fDocumentWidth-p._fPopoverMarginRight-p._fPopoverMarginLeft)<p._fPopoverWidth,v=(p._fDocumentHeight-p._fPopoverMarginTop-p._fPopoverMarginBottom)<p._fPopoverHeight,w=p._fPopoverOffset.left<p._fPopoverMarginLeft,x=this.getVerticalScrolling()&&(p._fPopoverWidth!==p._fPopoverInnerWidth)?h().width:0,y=o<(p._fPopoverMarginRight+x),z=p._fPopoverOffset.top<p._fPopoverMarginTop,A=s<p._fPopoverMarginBottom,F=sap.ui.getCore().getConfiguration().getRTL();if(u){e=p._fPopoverMarginLeft;r=p._fPopoverMarginRight;}else{if(w){e=p._fPopoverMarginLeft;if(F){r="";}}else if(y){r=p._fPopoverMarginRight;e="";}}if(v){t=p._fPopoverMarginTop;n=p._fPopoverMarginBottom;}else{if(z){t=p._fPopoverMarginTop;}else if(A){n=p._fPopoverMarginBottom;t="";}}var G={top:t,bottom:n-p._fWindowTop,left:e,right:typeof r==="number"?r-p._fWindowLeft:r};return G;};
m.prototype._getContentDimensionsCss=function(p){var o={},A=p._$content.height(),M=this._getMaxContentWidth(p),e=this._getMaxContentHeight(p);e=Math.max(e,0);o["max-width"]=M+"px";if(this.getContentHeight()||(A>e)){o["height"]=Math.min(e,A)+"px";}else{o["height"]="";o["max-height"]=e+"px";}return o;};
m.prototype._getMaxContentWidth=function(p){var e=p._fPopoverBorderLeft+p._fPopoverBorderRight;return p._fDocumentWidth-p._fPopoverMarginLeft-p._fPopoverMarginRight-e;};
m.prototype._getMaxContentHeight=function(p){var e=p._fHeaderHeight+p._fSubHeaderHeight+p._fFooterHeight+p._fContentMarginTop+p._fContentMarginBottom+p._fPopoverBorderTop+p._fPopoverBorderBottom;return p._fDocumentHeight-p._fPopoverMarginTop-p._fPopoverMarginBottom-e;};
m.prototype._isHorizontalScrollbarNeeded=function(p){return this.getHorizontalScrolling()&&(p._$scrollArea.outerWidth(true)<=p._$content.width());};
m.prototype._getArrowOffsetCss=function(s,p){var e,r=sap.ui.getCore().getConfiguration().getRTL();p._fPopoverWidth=p._$popover.outerWidth();p._fPopoverHeight=p._$popover.outerHeight();if(s===j.Left||s===j.Right){e=p._$parent.offset().top-p._$popover.offset().top-p._fPopoverBorderTop+p._fPopoverOffsetY+0.5*(m.outerHeight(p._$parent[0],false)-p._$arrow.outerHeight(false));e=Math.max(e,this._arrowOffsetThreshold);e=Math.min(e,p._fPopoverHeight-this._arrowOffsetThreshold-p._$arrow.outerHeight());return{"top":e};}else if(s===j.Top||s===j.Bottom){if(r){e=p._$popover.offset().left+m.outerWidth(p._$popover[0],false)-(p._$parent.offset().left+m.outerWidth(p._$parent[0],false))+p._fPopoverBorderRight+p._fPopoverOffsetX+0.5*(m.outerWidth(p._$parent[0],false)-p._$arrow.outerWidth(false));e=Math.max(e,this._arrowOffsetThreshold);e=Math.min(e,p._fPopoverWidth-this._arrowOffsetThreshold-p._$arrow.outerWidth(false));return{"right":e};}else{e=p._$parent.offset().left-p._$popover.offset().left-p._fPopoverBorderLeft+p._fPopoverOffsetX+0.5*(m.outerWidth(p._$parent[0],false)-p._$arrow.outerWidth(false));e=Math.max(e,this._arrowOffsetThreshold);e=Math.min(e,p._fPopoverWidth-this._arrowOffsetThreshold-p._$arrow.outerWidth(false));return{"left":e};}}};
m.prototype._getArrowPositionCssClass=function(s){switch(s){case j.Left:return"sapMPopoverArrRight";case j.Right:return"sapMPopoverArrLeft";case j.Top:return"sapMPopoverArrDown";case j.Bottom:return"sapMPopoverArrUp";}};
m.prototype._getArrowStyleCssClass=function(p){var A=p._$arrow.position(),F=p._$footer.position(),n=this._getSingleNavContent(),o=this._getSinglePageContent(),e=0;if(n||o){o=o||n.getCurrentPage();if(o){e=o._getAnyHeader().$().outerHeight();}}if((A.top+p._fArrowHeight)<(p._fHeaderHeight+p._fSubHeaderHeight)||((A.top+p._fArrowHeight)<e)){return"sapMPopoverHeaderAlignArr";}else if((A.top<(p._fHeaderHeight+p._fSubHeaderHeight))||(A.top<e)||(p._$footer.length&&((A.top+p._fArrowHeight)>F.top)&&(A.top<F.top))){return"sapMPopoverCrossArr";}else if(p._$footer.length&&(A.top>F.top)){return"sapMPopoverFooterAlignArr";}};
m.prototype._getCalculatedPlacement=function(){return this._oCalcedPos||this.getPlacement();};
m.prototype._adjustPositionAndArrow=function(){var e=this.oPopup.getOpenState();if(!(e===O.OPEN||e===O.OPENING)){return;}this._beforeAdjustPositionAndArrowHook();var $=this.$(),n=this.$("arrow"),o=this.$("cont"),p=this.$("scroll"),s=this._getCalculatedPlacement(),r=this._getPositionParams($,n,o,p);r=this._recalculateMargins(s,r);var t=this._getPopoverPositionCss(r),u=this._getContentDimensionsCss(r),H=this._isHorizontalScrollbarNeeded(r);$.css(t);o.css(u);if(H){p.css("display","block");}if(this.getShowArrow()){var A=this._getArrowOffsetCss(s,r),v=this._getArrowPositionCssClass(s),w,U;n.removeAttr("style");n.css(A);n.addClass(v);if(s===j.Top&&r._$footer&&r._$footer.length){U=true;}if(s===j.Left||s===j.Right){w=this._getArrowStyleCssClass(r);if(w){n.addClass(w);if(w==="sapMPopoverFooterAlignArr"){U=true;}}}if(U){n.addClass("sapContrast sapContrastPlus");}$.css("overflow","visible");}this._afterAdjustPositionAndArrowHook();};
m.prototype._adaptPositionParams=function(){if(this.getShowArrow()){this._marginLeft=10;this._marginRight=10;this._marginBottom=10;this._arrowOffset=18;this._offsets=["0 -18","18 0","0 18","-18 0"];if(this._bUseCompactArrow){this._arrowOffset=9;this._offsets=["0 -9","9 0","0 9","-9 0"];}this._myPositions=["center bottom","begin center","center top","end center"];this._atPositions=["center top","end center","center bottom","begin center"];}else{this._marginTop=0;this._marginLeft=0;this._marginRight=0;this._marginBottom=0;this._arrowOffset=0;this._offsets=["0 0","0 0","0 0","0 0"];this._myPositions=["begin bottom","begin center","begin top","end center"];this._atPositions=["begin top","end center","begin bottom","begin center"];}};
m.prototype._afterAdjustPositionAndArrowHook=function(){};
m.prototype._beforeAdjustPositionAndArrowHook=function(){};
m.prototype._isPopupElement=function(o){var p=this._getOpenByDomRef();return!!(q(o).closest(sap.ui.getCore().getStaticAreaRef()).length)||!!(q(o).closest(p).length);};
m.prototype._getAnyHeader=function(){if(this.getCustomHeader()){return this.getCustomHeader();}else{if(this.getShowHeader()){this._createInternalHeader();return this._internalHeader;}}};
m.prototype._createInternalHeader=function(){if(!this._internalHeader){var t=this;this._internalHeader=new B(this.getId()+"-intHeader",{titleAlignment:this.getTitleAlignment()});this.setAggregation("_internalHeader",this._internalHeader);this._internalHeader.addEventDelegate({onAfterRendering:function(){t._restoreFocus();}});return true;}else{return false;}};
m.prototype._animation=function(A,r){var t=null;var e=function(){r.off("webkitTransitionEnd transitionend");clearTimeout(t);setTimeout(function(){A();});};r.on("webkitTransitionEnd transitionend",e);t=setTimeout(e,this._getAnimationDuration());};
m.prototype._getAnimationDuration=function(){return 300;};
m.prototype._openAnimation=function(r,e,o){var t=this;setTimeout(function(){r.css("display","block");t._includeScrollWidth();t._animation(function(){if(!t.oPopup||t.oPopup.getOpenState()!==O.OPENING){return;}o();},r);},D.browser.firefox?50:0);};
m.prototype._closeAnimation=function(r,e,n){r.addClass("sapMPopoverTransparent");this._animation(function(){n();r.removeClass("sapMPopoverTransparent");},r);};
m.prototype._getInitialFocusId=function(){return this.getInitialFocus()||this._getFirstVisibleButtonId()||this._getFirstFocusableContentElementId()||this.getId();};
m.prototype._getFirstVisibleButtonId=function(){var o=this.getBeginButton(),e=this.getEndButton(),s="";if(o&&o.getVisible()&&o.getEnabled()){s=o.getId();}else if(e&&e.getVisible()&&e.getEnabled()){s=e.getId();}return s;};
m.prototype._getFirstFocusableContentElementId=function(){var r="";var $=this.$("cont");var F=$.firstFocusableDomRef();if(F){r=F.id;}return r;};
m.prototype._restoreFocus=function(){if(this.isOpen()){var F=this._getInitialFocusId(),o=sap.ui.getCore().byId(F),e=(F?window.document.getElementById(F):null);if(o&&o.getFocusDomRef()){o.getFocusDomRef().focus();}else if(!o&&e){e.focus();}}};
m.prototype._registerContentResizeHandler=function(s){if(!this._sResizeListenerId){this._sResizeListenerId=d.register(s||this.getDomRef("scroll"),this._fnOrientationChange);}};
m.prototype._deregisterContentResizeHandler=function(){if(this._sResizeListenerId){d.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
m.prototype._storeScrollPosition=function(){var $=this.$("cont");if($.length>0){this._oScrollPosDesktop={x:$.scrollLeft(),y:$.scrollTop()};}};
m.prototype._restoreScrollPosition=function(){if(!this._oScrollPosDesktop){return;}var $=this.$("cont");if($.length>0){$.scrollLeft(this._oScrollPosDesktop.x).scrollTop(this._oScrollPosDesktop.y);this._oScrollPosDesktop=null;}};
m.prototype._repositionOffset=function(){var e=this.oPopup.getOpenState(),o,p;if(!(e===O.OPEN)){return this;}o=this.oPopup._oLastPosition;p=this._placements.indexOf(this.getPlacement());if(p===-1){return this;}if(p<4){o.offset=this._calcOffset(this._offsets[p]);this.oPopup._applyPosition(o);}else{this._calcPlacement();}return this;};
m.prototype._getOpenByDomRef=function(){if(!this._oOpenBy){return null;}if(this._oOpenBy instanceof E){return(this._oOpenBy.getPopupAnchorDomRef&&this._oOpenBy.getPopupAnchorDomRef())||this._oOpenBy.getFocusDomRef();}else{return this._oOpenBy;}};
m.prototype._getAccessibilityOptions=function(){var A,e={},H=this._getAnyHeader(),o=this.getCustomHeader();e.role="dialog";e.modal=this.getProperty("ariaModal");if(!this.getShowHeader()||!H||!H.getVisible()){return e;}var n=o?o.getId():this.getHeaderTitle().getId();A=Array.prototype.concat(n,this.getAssociation("ariaLabelledBy",[]));e.labelledby=A.join(' ');return e;};
m.prototype._setHeaderTitle=function(){if(!this._headerTitle){this._headerTitle=new T(this.getId()+"-title",{text:this.getTitle(),level:"H2"});this._createInternalHeader();this._internalHeader.addContentMiddle(this._headerTitle);return;}if(this._headerTitle.getText()!==this.getTitle()){this._headerTitle.setText(this.getTitle());}};
m.prototype.getHeaderTitle=function(){return this._headerTitle;};
m.prototype.setPlacement=function(p){this.setProperty("placement",p,true);this._bVerticalFlip=false;this._bHorizontalFlip=false;var e=this._placements.indexOf(p);if(e<=3){this._oCalcedPos=p;}return this;};
m.prototype.setBeginButton=function(o){var e=this.getBeginButton();if(e===o){return this;}this._createInternalHeader();this._beginButton=o;if(o){if(e){this._internalHeader.removeAggregation("contentLeft",e,true);}this._internalHeader.addAggregation("contentLeft",o);}else{this._internalHeader.removeContentLeft(e);}return this;};
m.prototype.setEndButton=function(o){var e=this.getEndButton();if(e===o){return this;}this._createInternalHeader();this._endButton=o;if(o){if(e){this._internalHeader.removeAggregation("contentRight",e,true);}this._internalHeader.insertAggregation("contentRight",o,1,true);this._internalHeader.invalidate();}else{this._internalHeader.removeContentRight(e);}return this;};
m.prototype.setLeftButton=function(v){if(!(v instanceof a)){v=sap.ui.getCore().byId(v);}this.setBeginButton(v);return this.setAssociation("leftButton",v);};
m.prototype.setRightButton=function(v){if(!(v instanceof a)){v=sap.ui.getCore().byId(v);}this.setEndButton(v);return this.setAssociation("rightButton",v);};
m.prototype.setModal=function(M,s){if(M===this.getModal()){return this;}this.oPopup.setModal(M,("sapMPopoverBLayer "+(s||"")).trim());this.setProperty("modal",M,true);return this;};
m.prototype.setEnableScrolling=function(v){this.setHorizontalScrolling(v);this.setVerticalScrolling(v);this.setProperty("enableScrolling",v);return this;};
m.prototype._setAriaModal=function(v){return this.setProperty("ariaModal",v);};
m.prototype.getScrollDelegate=function(){return this._oScroller;};
m.prototype._setAriaRoleApplication=function(v){return this.setProperty("ariaRoleApplication",v);};
m.prototype.setAggregation=function(A,o,s){if(A==="beginButton"||A==="endButton"){var F="set"+A.charAt(0).toUpperCase()+A.slice(1);return this[F](o);}else{return C.prototype.setAggregation.apply(this,arguments);}};
m.prototype.getAggregation=function(A,o){if(A==="beginButton"||A==="endButton"){var s=this["_"+A];return s||o||null;}else{return C.prototype.getAggregation.apply(this,arguments);}};
m.prototype.destroyAggregation=function(A,s){var o=q(document.activeElement).control(0);if(A==="beginButton"||A==="endButton"){var e=this["_"+A];if(e){e.destroy();this["_"+A]=null;}}else{C.prototype.destroyAggregation.apply(this,arguments);}o&&o.getDomRef()?o.focus():this.focus();return this;};
m.prototype.invalidate=function(o){if(this.isOpen()){C.prototype.invalidate.apply(this,arguments);}return this;};
m.prototype.addAggregation=function(A,o,s){if(A==="content"){this._bContentChanged=true;}C.prototype.addAggregation.apply(this,arguments);};
m.prototype._getAllContent=function(){return this.getContent();};
m.prototype._applyContextualSettings=function(){C.prototype._applyContextualSettings.call(this);};
return m;});
sap.ui.predefine('sap/m/PopoverRenderer',['sap/ui/Device','sap/m/library',"sap/ui/dom/getScrollbarSize","sap/ui/core/IconPool"],function(D,l,g,I){"use strict";var P=l.PlacementType;var a={apiVersion:2};
a.render=function(r,c){r.openStart("div",c);var C=this.generateRootClasses(c);C.forEach(function(s){r.class(s);});if(!c.getHorizontalScrolling()){r.class("sapMPopoverHorScrollDisabled");}if(!c.getVerticalScrolling()){r.class("sapMPopoverVerScrollDisabled");}var t=c.getTooltip_AsString();if(t){r.attr("title",t);}r.attr("tabindex","-1").accessibilityState(c,c._getAccessibilityOptions()).openEnd();if(c.getResizable()){r.icon("sap-icon://resize-corner",["sapMPopoverResizeHandle"],{"title":""});}this.renderContent(r,c);r.close("div");};
a.isButtonFooter=function(f){if(f instanceof sap.m.Bar){var c=f.getContentLeft(),C=f.getContentRight(),b=f.getContentMiddle(),L=(!c||c.length===0),r=(!C||C.length===0),m=false;if(b&&b.length===2){if((b[0]instanceof sap.m.Button)&&(b[1]instanceof sap.m.Button)){m=true;}}return L&&r&&m;}else{return false;}};
a.renderContent=function(r,c){var h=c._getAnyHeader(),s=c.getId(),i=0,b=c._getAllContent(),f=c.getFooter(),S=c.getSubHeader(),C=c.getContentWidth(),d=c.getContentMinWidth(),e=c.getContentHeight();if(D.system.desktop){r.openStart("span",c.getId()+"-firstfe").class("sapMPopoverHiddenFocusable").attr("tabindex","0").openEnd().close("span");}if(h){r.openStart("header").class("sapMPopoverHeader").openEnd();if(h._applyContextClassFor){h._applyContextClassFor("header");}r.renderControl(h);r.close("header");}if(S){r.openStart("header").class("sapMPopoverSubHeader").openEnd();if(S._applyContextClassFor){S._applyContextClassFor("subheader");}r.renderControl(S);r.close("header");}r.openStart("div",s+"-cont");if(C){r.style("width",C);}if(d){r.style("min-width",d);}if(e){r.style("height",e);}r.class("sapMPopoverCont");if(sap.ui.getCore().getConfiguration().getAccessibility()&&c.getProperty("ariaRoleApplication")){r.attr("role","application");}r.openEnd();r.openStart("div",c.getId()+"-scroll").class("sapMPopoverScroll");if(!c.getHorizontalScrolling()){r.style(sap.ui.getCore().getConfiguration().getRTL()?"margin-left":"margin-right",g().width+"px");}r.openEnd();for(i=0;i<b.length;i++){r.renderControl(b[i]);}r.close("div");r.close("div");if(f){r.openStart("footer").class("sapMPopoverFooter");if(this.isButtonFooter(f)){r.class("sapMPopoverSpecialFooter");}r.openEnd();if(f._applyContextClassFor){f._applyContextClassFor("footer");f.addStyleClass("sapMTBNoBorders");}r.renderControl(f);r.close("footer");}if(c.getShowArrow()){r.openStart("span",s+"-arrow").class("sapMPopoverArr").openEnd().close("span");}if(D.system.desktop){r.openStart("span",c.getId()+"-middlefe").class("sapMPopoverHiddenFocusable").attr("tabindex","-1").openEnd().close("span");r.openStart("span",c.getId()+"-lastfe").class("sapMPopoverHiddenFocusable").attr("tabindex","0").openEnd().close("span");}};
a.generateRootClasses=function(c){var C=["sapMPopover"],s=c.getSubHeader(),f=c.getFooter(),v=c.getVerticalScrolling()&&!c._forceDisableScrolling,h=c.getHorizontalScrolling()&&!c._forceDisableScrolling,H=c._getAnyHeader();if(H){C.push("sapMPopoverWithBar");}else{C.push("sapMPopoverWithoutBar");}if(s){C.push("sapMPopoverWithSubHeader");}else{C.push("sapMPopoverWithoutSubHeader");}if(c._hasSingleNavContent()){C.push("sapMPopoverNav");}if(c._hasSinglePageContent()){C.push("sapMPopoverPage");}if(f){C.push("sapMPopoverWithFooter");}else{C.push("sapMPopoverWithoutFooter");}if(c.getPlacement()===P.Top){C.push("sapMPopoverPlacedTop");}if(!v){C.push("sapMPopoverVerScrollDisabled");}if(!h){C.push("sapMPopoverHorScrollDisabled");}C.push("sapMPopup-CTX");if(c._bSizeCompact){C.push("sapUiSizeCompact");}return C.concat(c.aCustomStyleClasses);};
return a;},true);
sap.ui.predefine('sap/m/ProgressIndicator',['./library','sap/ui/core/Control',"sap/ui/Device",'sap/ui/core/Icon','sap/ui/core/ResizeHandler','sap/ui/core/ValueStateSupport','sap/ui/core/library','./ProgressIndicatorRenderer',"sap/base/Log","sap/m/Popover","sap/m/Text"],function(l,C,D,I,R,V,c,P,L,a,T){"use strict";var b=c.TextDirection;var d=c.ValueState;var e=l.PlacementType;
var f=C.extend("sap.m.ProgressIndicator",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},state:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:d.None},displayValue:{type:"string",group:"Appearance",defaultValue:null},percentValue:{type:"float",group:"Data",defaultValue:0},showValue:{type:"boolean",group:"Appearance",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:b.Inherit},displayOnly:{type:"boolean",group:"Behavior",defaultValue:false},displayAnimation:{type:"boolean",group:"Behavior",defaultValue:true}},aggregations:{_popover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},designtime:"sap/m/designtime/ProgressIndicator.designtime"}});
f.RESIZE_HANDLER_ID={SELF:"_sResizeHandlerId"};var u=sap.ui.getCore().getConfiguration().getAnimation();
f.prototype.init=function(){this._bIEBrowser=D.browser.internet_explorer;};
f.prototype.onBeforeRendering=function(){this._deRegisterResizeHandler(f.RESIZE_HANDLER_ID.SELF);};
f.prototype.onAfterRendering=function(){this._updateHoverableScenario();this._registerResizeHandler(f.RESIZE_HANDLER_ID.SELF,this,this._onResize.bind(this));};
f.prototype.exit=function(){if(this._oPopoverText){this._oPopoverText.destroy();this._oPopoverText=null;}this._deRegisterResizeHandler(f.RESIZE_HANDLER_ID.SELF);};
f.prototype._registerResizeHandler=function(h,o,H){if(!this[h]){this[h]=R.register(o,H);}};
f.prototype._deRegisterResizeHandler=function(h){if(this[h]){R.deregister(this[h]);this[h]=null;}};
f.prototype._onResize=function(E){this._updateHoverableScenario();};
f.prototype.ontouchstart=function(E){if(this._isHoverable()){E.setMarked();}};
f.prototype.ontap=function(E){var p;if(this._isHoverable()){p=this._getPopover();if(p.isOpen()){p.close();}else{p.openBy(this);}}};
f.prototype._updateHoverableScenario=function(){var o=this.$(this.getPercentValue()>50?"textLeft":"textRight")[0],O=o&&o.offsetWidth,s=o&&o.scrollWidth;if(this._bIEBrowser){O+=1;}this.toggleStyleClass("sapMPIHoverable",this.getDisplayValue()!==""&&O<s);};
f.prototype._isHoverable=function(){return this.hasStyleClass("sapMPIHoverable");};
f.prototype._getPopover=function(){var p;if(!this.getAggregation("_popover")){this._oPopoverText=new T({text:this.getDisplayValue()});p=new a(this.getId()+"-popover",{showHeader:false,placement:e.Bottom,content:[this._oPopoverText,new I({src:"sap-icon://decline",press:this._onPopoverCloseIconPress.bind(this)})]}).addStyleClass('sapMPIPopover');this.setAggregation("_popover",p,true);}return this.getAggregation("_popover");};
f.prototype._onPopoverCloseIconPress=function(){this._getPopover().close();};
f.prototype.setDisplayValue=function(s){this.setProperty("displayValue",s);if(this._oPopoverText){this._oPopoverText.setText(s);}return this;};
f.prototype.setPercentValue=function(p){var t=this,$,g,h=this.$(),A,o=p;p=parseFloat(p);if(!i(p)){if(p>100){p=100;}else if(p<0){p=0;}else{L.warning(this+": percentValue ("+o+") is not a valid number! The provided value will not be set!");return this;}L.warning(this+": percentValue ("+o+") is not correct! Setting the percentValue to "+p);}if(this.getPercentValue()!==p){g=this.getPercentValue()-p;this.setProperty("percentValue",p,true);if(!h.length){return this;}["sapMPIValueMax","sapMPIValueMin","sapMPIValueNormal","sapMPIValueGreaterHalf"].forEach(function(s){h.removeClass(s);});h.addClass(this._getCSSClassByPercentValue(p).join(" "));h.addClass("sapMPIAnimate").attr("aria-valuenow",p).attr("aria-valuetext",this._getAriaValueText({fPercent:p}));A=u&&this.getDisplayAnimation()?Math.abs(g)*20:0;$=this.$("bar");$.stop();$.animate({"flex-basis":p+"%"},A,"linear",function(){t._setText.apply(t);t.$().removeClass("sapMPIAnimate");});}return this;};
f.prototype._setText=function(){this.$().toggleClass("sapMPIValueGreaterHalf",this.getPercentValue()>50);return this;};
f.prototype._getCSSClassByPercentValue=function(p){if(p===100){return["sapMPIValueMax","sapMPIValueGreaterHalf"];}if(p===0){return["sapMPIValueMin"];}if(p<=50){return["sapMPIValueNormal"];}return["sapMPIValueNormal","sapMPIValueGreaterHalf"];};
f.prototype._getAriaValueText=function(p){p.sText=p.sText||this.getDisplayValue();p.fPercent=p.fPercent||this.getPercentValue();p.sStateText=p.sStateText||this._getStateText();var A=p.sText||p.fPercent+"%";if(p.sStateText){A+=" "+p.sStateText;}return A;};
f.prototype._getStateText=function(){return this.getEnabled()?V.getAdditionalText(this.getState()):"";};
f.prototype.getAccessibilityInfo=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s=this.getDisplayValue(),g=s?s:B.getText("ACC_CTR_STATE_PROGRESS",[this.getPercentValue()]);return{role:"progressbar",type:B.getText("ACC_CTR_TYPE_PROGRESS"),description:g,focusable:this.getEnabled(),enabled:this.getEnabled()};};
function i(v){return!isNaN(v)&&v>=0&&v<=100;}
return f;});
sap.ui.predefine('sap/m/ProgressIndicatorRenderer',["sap/ui/core/library"],function(c){"use strict";var V=c.ValueState;var P={apiVersion:2};
P.render=function(r,C){var p=C.getPercentValue(),w=C.getWidth(),h=C.getHeight(),a=C._getCSSClassByPercentValue(p),t=C.getDisplayValue(),s=C.getShowValue(),S=C.getState(),T=C.getTextDirection().toLowerCase(),b=C.getId(),e=C.getEnabled();r.openStart("div",C);r.class("sapMPI");r.style("width",w);a.forEach(function(d){r.class(d);});r.style("height",h);if(C.getEnabled()){r.attr('tabindex','-1');}else{r.class("sapMPIBarDisabled");}if(C.getDisplayOnly()){r.class("sapMPIDisplayOnly");}r.accessibilityState(C,{role:"progressbar",valuemin:0,valuenow:p,valuemax:100,valuetext:C._getAriaValueText({sText:t,fPercent:p})});if(C.getTooltip_AsString()){r.attr("title",C.getTooltip_AsString());}r.openEnd();r.openStart("div",b+"-bar");r.class("sapMPIBar");if(e){switch(S){case V.Warning:r.class("sapMPIBarCritical");break;case V.Error:r.class("sapMPIBarNegative");break;case V.Success:r.class("sapMPIBarPositive");break;case V.Information:r.class("sapMPIBarInformation");break;default:r.class("sapMPIBarNeutral");break;}}else{r.class("sapMPIBarNeutral");}r.style("flex-basis",p+"%");r.openEnd();P._renderDisplayText(r,T,"Left",b);if(s){r.text(t);}r.close("span");r.close("div");r.openStart("div",b+"-remainingBar");r.class("sapMPIBarRemaining");r.openEnd();P._renderDisplayText(r,T,"Right",b);if(s){r.text(t);}r.close("span");r.close("div");r.close("div");};
P._renderDisplayText=function(r,t,T,C){r.openStart("span",C+"-text"+T);r.class("sapMPIText");r.class("sapMPIText"+T);if(t!=="inherit"){r.attr("dir",t);}r.openEnd();};
return P;},true);
sap.ui.predefine('sap/m/PullToRefresh',["sap/ui/thirdparty/jquery",'./library','sap/ui/core/Control','sap/ui/Device','./PullToRefreshRenderer',"sap/ui/events/KeyCodes","sap/base/security/encodeXML","sap/ui/core/InvisibleText","sap/m/BusyIndicator"],function(q,l,C,D,P,K,e,I,B){"use strict";var a=l.ImageHelper;
var b=C.extend("sap.m.PullToRefresh",{metadata:{library:"sap.m",properties:{description:{type:"string",group:"Misc",defaultValue:null},showIcon:{type:"boolean",group:"Appearance",defaultValue:false},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}},events:{refresh:{}}}});
b.ARIA_F5_REFRESH="PULL_TO_REFRESH_ARIA_F5";
b.prototype.init=function(){this._bTouchMode=D.support.touch&&!D.system.combi||q.sap.simulateMobileOnDesktop;this._iState=0;this._sAriaF5Text=I.getStaticId("sap.m",b.ARIA_F5_REFRESH);};
b.prototype._loadBI=function(){if(this.getVisible()&&!this._oBusyIndicator){this._oBusyIndicator=new B({size:"1.7rem",design:"auto"});this._oBusyIndicator.setParent(this);}};
b.prototype._getAriaDescribedByReferences=function(){var t=this.getTooltip_AsString(),d=this._sAriaF5Text,T;if(t){T=I.getStaticId("sap.m",t);d+=' '+T;}return d;};
b.prototype.onBeforeRendering=function(){this._loadBI();if(this._bTouchMode){q(window).off("resize.sapMP2R",this.calculateTopTrigger);var p=this.getParent();this._oScroller=p&&p.getScrollDelegate?p.getScrollDelegate():null;if(this._oScroller){this._oScroller.setBounce(true);this._oScroller.setPullDown(this.getVisible()?this:null);}}};
b.prototype.calculateTopTrigger=function(){this._iTopTrigger=1;if(this._oDomRef&&this._oDomRef.parentNode&&this._oDomRef.parentNode.parentNode&&this._oDomRef.parentNode.parentNode.offsetHeight<this._oDomRef.offsetHeight*1.5){this._iTopTrigger=this.getDomRef("T").offsetTop;}};
b.prototype.onAfterRendering=function(){this._oDomRef=this.getDomRef();if(this._bTouchMode){if(this._oScroller){this._oScroller.refresh();}if(this.getVisible()&&this._oScroller&&this._oScroller._bIScroll){q(window).on("resize.sapMP2R",q.proxy(this.calculateTopTrigger,this));this.calculateTopTrigger();}}};
b.prototype.exit=function(){if(this._bTouchMode&&this._oScroller&&this._oScroller._bIScroll){q(window).off("resize.sapMP2R",this.calculateTopTrigger);}if(this._oScroller){this._oScroller.setPullDown(null);this._oScroller=null;}if(this._oCustomImage){this._oCustomImage.destroy();this._oCustomImage=null;}if(this._oBusyIndicator){this._oBusyIndicator.destroy();this._oBusyIndicator=null;}};
b.prototype.doScrollMove=function(){if(!this._oScroller){return;}var d=this._oDomRef;var _=this._oScroller._scroller;if(_.y>-this._iTopTrigger&&this._iState<1){this.setState(1);_.minScrollY=0;}else if(_.y<-this._iTopTrigger&&this._iState===1){this.setState(0);_.minScrollY=-d.offsetHeight;}};
b.prototype.doPull=function(p){if(this._bTouchMode&&this._iState<2){this.setState(p>=-1?1:0);}};
b.prototype.doRefresh=function(){this.setState(0);};
b.prototype.doScrollEnd=function(){if(this._iState===1){this.setState(2);this.fireRefresh();}};
b.prototype.setState=function(s){if(this._iState===s){return;}this._iState=s;if(!this._oDomRef){return;}var $=this.$();var c=$.find(".sapMPullDownText");var r=this._getRB();switch(s){case 0:$.toggleClass("sapMFlip",false).toggleClass("sapMLoading",false);c.html(r.getText(this._bTouchMode?"PULL2REFRESH_PULLDOWN":"PULL2REFRESH_REFRESH"));$.removeAttr("aria-live");$.find(".sapMPullDownInfo").html(e(this.getDescription()));break;case 1:$.toggleClass("sapMFlip",true);c.html(r.getText("PULL2REFRESH_RELEASE"));$.removeAttr("aria-live");break;case 2:$.toggleClass("sapMFlip",false).toggleClass("sapMLoading",true);this._oBusyIndicator.setVisible(true);c.html(r.getText("PULL2REFRESH_LOADING"));$.attr("aria-live","assertive");$.find(".sapMPullDownInfo").html(this._bTouchMode?r.getText("PULL2REFRESH_LOADING_LONG"):"");break;}};
b.prototype.getCustomIconImage=function(){var p={src:this.getCustomIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};var c=['sapMPullDownCIImg'];this._oCustomImage=a.getImageControl(null,this._oCustomImage,this,p,c);return this._oCustomImage;};
b.prototype.onclick=function(){if(!this._bTouchMode){this.setState(2);this.fireRefresh();}};
b.prototype.onkeydown=function(c){if(c.which===K.F5){this.onclick();c.stopPropagation();c.preventDefault();}};
b.prototype.onsapenter=function(E){if(this._iState<1){this.setState(2);this.fireRefresh();}};
b.prototype.onsapspace=function(E){E.preventDefault();if(this._iState<1){this.setState(2);this.fireRefresh();}};
b.prototype.hide=function(){this.setState(0);if(this._oScroller){this._oScroller.refresh();}};
b.prototype.setVisible=function(v){if(this.getVisible()===v){return this;}if(this._oDomRef&&this._oScroller&&this._oScroller._oControl){this._oScroller._oControl.invalidate();}return this.setProperty("visible",v);};
b.prototype._getRB=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m");};
return b;});
sap.ui.predefine('sap/m/PullToRefreshRenderer',['sap/ui/core/IconPool'],function(I){"use strict";I.insertFontFaceStyle();var P={apiVersion:2};
P.writeAccessibilityState=function(r,c){var a={role:"button",controls:c.getParent().sId+"-cont",keyshortcuts:"F5",describedby:c._getAriaDescribedByReferences()};r.accessibilityState(c,a);};
P.render=function(r,c){var s=c.getShowIcon();var C=c.getCustomIcon();var t=c.getTooltip_AsString();var R=c._getRB();r.openStart("div",c);r.class("sapMPullDown");r.class(!c._bTouchMode?"sapMPullDownNontouch":"sapMPullDownTouch");if(s&&!C){r.class("sapMPullDownLogo");}if(t){r.attr("title",t);}r.attr("tabindex",0);this.writeAccessibilityState(r,c);r.openEnd();if(s&&C){var o=c.getCustomIconImage();if(o){r.openStart("div").class("sapMPullDownCI").openEnd();r.renderControl(o);r.close("div");}}r.openStart("span").class("sapMPullDownIcon").openEnd().close("span");r.openStart("span").class("sapMPullDownBusy").openEnd();r.renderControl(c._oBusyIndicator);r.close("span");r.openStart("span",c.getId()+"-T");r.class("sapMPullDownText");r.attr("aria-live","assertive");r.openEnd();r.text(R.getText(c._bTouchMode?"PULL2REFRESH_PULLDOWN":"PULL2REFRESH_REFRESH"));r.close("span");r.openStart("span",c.getId()+"-I");r.class("sapMPullDownInfo");r.openEnd();r.text(c.getDescription());r.close("span");r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/QuickViewCardRenderer',["sap/ui/core/Core"],function(C){"use strict";var Q={apiVersion:2};
Q.render=function(r,q){r.openStart("div",q).class("sapMQuickViewCard").accessibilityState({label:{value:C.getLibraryResourceBundle("sap.m").getText("ARIA_ROLEDESCRIPTION_CARD"),append:true}});if(!q.getShowVerticalScrollBar()){r.class("sapMQuickViewCardNoScroll");}r.openEnd();r.renderControl(q.getNavContainer());r.close("div");};
return Q;},true);
sap.ui.predefine('sap/m/QuickViewGroup',["./library","sap/ui/core/Element"],function(l,E){"use strict";
var G=E.extend("sap.m.QuickViewGroup",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true},heading:{type:"string",group:"Misc",defaultValue:""}},defaultAggregation:"elements",aggregations:{elements:{type:"sap.m.QuickViewGroupElement",multiple:true,singularName:"element",bindable:"bindable"}}}});
["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(f){G.prototype[f]=function(){var r=E.prototype[f].apply(this,arguments);var p=this.getParent();if(p){p._updatePage();}if(["removeAggregation","removeAllAggregation"].indexOf(f)!==-1){return r;}return this;};});
G.prototype.setProperty=function(){E.prototype.setProperty.apply(this,arguments);var p=this.getParent();if(p){p._updatePage();}return this;};
G.prototype.getQuickViewBase=function(){var p=this.getParent();if(p&&p.getQuickViewBase){return p.getQuickViewBase();}return null;};
return G;});
sap.ui.predefine('sap/m/QuickViewPageRenderer',[],function(){"use strict";var Q={apiVersion:2};
Q.render=function(r,q){var p=q.getPageContent();r.openStart("div",q).class("sapMQuickViewPage").openEnd();if(p.header){r.renderControl(p.header);}r.renderControl(p.form);r.close("div");};
return Q;},true);
sap.ui.predefine('sap/m/RadioButton',['./library','sap/ui/core/Control','sap/ui/core/Core','sap/ui/core/EnabledPropagator','sap/ui/core/message/MessageMixin','sap/m/RadioButtonGroup','sap/m/Label','sap/ui/core/library','sap/base/strings/capitalize','./RadioButtonRenderer'],function(l,C,a,E,M,R,L,c,b,d){"use strict";var T=c.TextAlign;var V=c.ValueState;var e=c.TextDirection;
var f=C.extend("sap.m.RadioButton",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},selected:{type:"boolean",group:"Data",defaultValue:false},groupName:{type:"string",group:"Behavior",defaultValue:'sapMRbDefaultGroup'},text:{type:"string",group:"Appearance",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:e.Inherit},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},useEntireWidth:{type:"boolean",group:"Appearance",defaultValue:false},activeHandling:{type:"boolean",group:"Appearance",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:V.None},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin},editableParent:{type:"boolean",group:"Behavior",defaultValue:true,visibility:"hidden"},valueStateText:{type:"string",group:"Misc",defaultValue:null,visibility:"hidden"}},events:{select:{parameters:{selected:{type:"boolean"}}}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},dnd:{draggable:true,droppable:false},designtime:"sap/m/designtime/RadioButton.designtime"}});
E.call(f.prototype);M.call(f.prototype);f.prototype._groupNames={};var K={HOME:"first",END:"last",NEXT:"next",PREV:"prev"};
f.prototype.onBeforeRendering=function(){this._updateGroupName(this.getGroupName());this._updateLabelProperties();};
f.prototype.exit=function(){var g=this.getGroupName(),h=this._groupNames[g],G=h&&h.indexOf(this);this._iTabIndex=null;if(this._oLabel){this._oLabel.destroy();this._oLabel=null;}if(G>=-1){h.splice(G,1);}};
f.prototype.ontap=function(o){if(!this.getEnabled()||!this.getEditable()){return;}var p=this.getParent();if(p instanceof R&&(!p.getEnabled()||!p.getEditable())){return;}o&&o.setMarked();this.applyFocusInfo();if(!this.getSelected()){this.setSelected(true);var t=this;setTimeout(function(){t.fireSelect({selected:true});},0);}};
f.prototype.setGroupName=function(g){this._updateGroupName(g,this.getGroupName());this.setProperty("groupName",g);return this;};
f.prototype.setSelected=function(s){var g=this.getGroupName(),h=this._groupNames[g],j=h&&h.length;this.setProperty("selected",s);this._updateGroupName(g);if(s&&g){for(var i=0;i<j;i++){var o=h[i];if(o instanceof f&&o!==this&&o.getSelected()){o.fireSelect({selected:false});o.setSelected(false);}}}return this;};
f.prototype.ontouchstart=function(o){o.setMarked();if(this.getEnabled()&&this.getActiveHandling()){this.addStyleClass("sapMRbBTouched");}};
f.prototype.ontouchend=function(){this.removeStyleClass("sapMRbBTouched");};
f.prototype.onsapnext=function(o){this._keyboardHandler(K.NEXT,true);o.setMarked();return this;};
f.prototype.onsapnextmodifiers=function(o){this._keyboardHandler(K.NEXT,!o.ctrlKey);o.setMarked();return this;};
f.prototype.onsapprevious=function(o){this._keyboardHandler(K.PREV,true);o.setMarked();return this;};
f.prototype.onsappreviousmodifiers=function(o){this._keyboardHandler(K.PREV,!o.ctrlKey);o.setMarked();return this;};
f.prototype.onsaphome=function(o){this._keyboardHandler(K.HOME,true);o.setMarked();return this;};
f.prototype.onsaphomemodifiers=function(o){this._keyboardHandler(K.HOME,!o.ctrlKey);o.setMarked();return this;};
f.prototype.onsapend=function(o){this._keyboardHandler(K.END,true);o.setMarked();return this;};
f.prototype.onsapendmodifiers=function(o){this._keyboardHandler(K.END,!o.ctrlKey);o.setMarked();return this;};
f.prototype._keyboardHandler=function(p,s){if(this.getParent()instanceof R){return;}var n=this._getNextFocusItem(p);n.focus();if(s&&!n.getSelected()&&n.getEditable()&&n.getEnabled()){n.setSelected(true);setTimeout(function(){n.fireSelect({selected:true});},0);}};
f.prototype.getAccessibilityInfo=function(){var B=a.getLibraryResourceBundle("sap.m");return{role:"radio",type:B.getText("ACC_CTR_TYPE_RADIO"),description:(this.getText()||"")+(this.getSelected()?(" "+B.getText("ACC_CTR_STATE_CHECKED")):(" "+B.getText("ACC_CTR_STATE_NOT_CHECKED"))),enabled:this.getEnabled(),editable:this.getEditable()};};
f.prototype.getFormDoNotAdjustWidth=function(){return this.getText()?false:true;};
f.prototype._getNextFocusItem=function(n){var v=this._groupNames[this.getGroupName()].filter(function(r){return(r.getDomRef()&&r.getEnabled());});var B=v.indexOf(this),i=B,g=v.length;switch(n){case K.NEXT:i=B===g-1?B:B+1;break;case K.PREV:i=B===0?0:i-1;break;case K.HOME:i=0;break;case K.END:i=g-1;break;}return v[i]||this;};
f.prototype.onsapselect=function(o){o.preventDefault();this.ontap(o);};
f.prototype.setTabIndex=function(t){var F=this.getFocusDomRef();this._iTabIndex=t;if(F){F.setAttribute("tabindex",t);}return this;};
f.prototype.setValueStateText=function(t){return this.setProperty("valueStateText",t);};
f.prototype._updateLabelProperties=function(){var o=this._getLabel();var t=this.getText();var u=this.getUseEntireWidth();this.toggleStyleClass("sapMRbHasLabel",!!t);o.setText(t).setWidth(!u?this.getWidth():"auto").setTextDirection(this.getTextDirection()).setTextAlign(this.getTextAlign());};
f.prototype._getLabel=function(){if(!this._oLabel){this._oLabel=new L(this.getId()+"-label");this._oLabel.addStyleClass("sapMRbBLabel").setParent(this,null,true);}return this._oLabel;};
f.prototype._updateGroupName=function(n,o){var N=this._groupNames[n],O=this._groupNames[o];if(O&&O.indexOf(this)!==-1){O.splice(O.indexOf(this),1);}if(!N){N=this._groupNames[n]=[];}if(N.indexOf(this)===-1){N.push(this);}};
["editableParent"].forEach(function(p){f.prototype["_set"+b(p)]=function(v){return this.setProperty(p,v,true);};});return f;});
sap.ui.predefine('sap/m/RadioButtonGroup',['./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/core/library','./RadioButtonGroupRenderer',"sap/base/Log"],function(l,C,I,c,R,L){"use strict";var T=c.TextDirection;var V=c.ValueState;
var a=C.extend("sap.m.RadioButtonGroup",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/RadioButtonGroup.designtime",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},columns:{type:"int",group:"Appearance",defaultValue:1},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:V.None},selectedIndex:{type:"int",group:"Data",defaultValue:0},enabled:{type:"boolean",group:"Behavior",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},defaultAggregation:"buttons",aggregations:{buttons:{type:"sap.m.RadioButton",multiple:true,singularName:"button",bindable:"bindable"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{parameters:{selectedIndex:{type:"int"}}}}}});
a.prototype.exit=function(){this.destroyButtons();if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
a.prototype.onBeforeRendering=function(){var b=this.getButtons();var e=this.getEditable();b.forEach(function(r){r._setEditableParent(e);});if(this.aRBs){var v=this.getValueState();this.aRBs.forEach(function(r){r.setValueState(v);});}};
a.prototype.onAfterRendering=function(){this._initItemNavigation();};
a.prototype._initItemNavigation=function(){var d=[];var h=false;var r=this.getEnabled();for(var i=0;i<this.aRBs.length;i++){d.push(this.aRBs[i].getDomRef());h=h||this.aRBs[i].getEnabled();}if(!h||!r){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}return;}if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.AfterFocus,this._handleAfterFocus,this);this.addDelegate(this._oItemNavigation);}this._oItemNavigation.setRootDomRef(this.getDomRef());this._oItemNavigation.setItemDomRefs(d);this._oItemNavigation.setCycling(true);this._oItemNavigation.setColumns(this.getColumns());this._oItemNavigation.setSelectedIndex(this._getSelectedIndexInRange());this._oItemNavigation.setFocusedIndex(this._getSelectedIndexInRange());this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});};
a.prototype.setSelectedIndex=function(s){var i=this.getSelectedIndex();var h=document.activeElement&&document.activeElement.parentNode&&document.activeElement.parentNode.parentNode===this.getDomRef();var b=!!(this.aRBs&&this.aRBs[s]);if(s<-1){L.warning("Invalid index, will not be changed");return this;}this.setProperty("selectedIndex",s,true);if(!isNaN(i)&&this.aRBs&&this.aRBs[i]){this.aRBs[i].setSelected(false);}if(this.aRBs&&this.aRBs[s]){this.aRBs[s].setSelected(true);}if(this._oItemNavigation){this._oItemNavigation.setSelectedIndex(s);this._oItemNavigation.setFocusedIndex(s);}if(b&&h){this.aRBs[s].getDomRef().focus();}return this;};
a.prototype.setSelectedButton=function(s){if(!s){return this.setSelectedIndex(-1);}var b=this.getButtons();for(var i=0;i<b.length;i++){if(s.getId()==b[i].getId()){return this.setSelectedIndex(i);}}return this;};
a.prototype.getSelectedButton=function(){return this.getButtons()[this.getSelectedIndex()];};
a.prototype.addButton=function(b){if(!this._bUpdateButtons&&this.getSelectedIndex()===undefined){this.setSelectedIndex(0);}if(!this.aRBs){this.aRBs=[];}var i=this.aRBs.length;this.aRBs[i]=this._createRadioButton(b,i);this.addAggregation("buttons",this.aRBs[i]);return this;};
a.prototype.insertButton=function(b,d){if(!this.aRBs){this.aRBs=[];}var e=this.aRBs.length,m=this.getButtons().length;d=Math.max(Math.min(d,m),0);if(!this._bUpdateButtons){if(this.getSelectedIndex()===undefined||e==0){this.setSelectedIndex(0);}else if(this.getSelectedIndex()>=d){this.setProperty("selectedIndex",this.getSelectedIndex()+1,true);}}if(d>=e){this.aRBs[d]=this._createRadioButton(b,d);}else{for(var i=(e);i>d;i--){this.aRBs[i]=this.aRBs[i-1];if((i-1)==d){this.aRBs[i-1]=this._createRadioButton(b,d);}}}this.insertAggregation("buttons",b,d);return this;};
a.prototype._createRadioButton=function(b,i){if(this.iIDCount==undefined){this.iIDCount=0;}else{this.iIDCount++;}b.setValueState(this.getValueState());b.setGroupName(this.getId());if(i==this.getSelectedIndex()){b.setSelected(true);}b.attachEvent("select",this._handleRBSelect,this);return b;};
a.prototype.removeButton=function(e){var i=e;if(typeof(e)=="string"){e=sap.ui.getCore().byId(e);}if(typeof(e)=="object"){i=this.indexOfButton(e);}var b=this.removeAggregation("buttons",i);if(!this.aRBs){this.aRBs=[];}if(!this.aRBs[i]){return null;}this.aRBs.splice(i,1);if(!this._bUpdateButtons){if(this.aRBs.length==0){this.setSelectedIndex(-1);}else if(this.getSelectedIndex()==i){this.setSelectedIndex(0);}else{if(this.getSelectedIndex()>i){this.setProperty("selectedIndex",this.getSelectedIndex()-1,true);}}}return b;};
a.prototype.removeAllButtons=function(){if(!this._bUpdateButtons){this.setSelectedIndex(-1);}this.aRBs=[];return this.removeAllAggregation("buttons");};
a.prototype.destroyButtons=function(){this.destroyAggregation("buttons");if(this.aRBs){while(this.aRBs.length>0){this.aRBs[0].destroy();this.aRBs.splice(0,1);}}return this;};
a.prototype.updateButtons=function(){this._bUpdateButtons=true;this.updateAggregation("buttons");this._bUpdateButtons=undefined;};
a.prototype.clone=function(){var b=this.getButtons();var i=0;for(i=0;i<b.length;i++){b[i].detachEvent("select",this._handleRBSelect,this);}var o=C.prototype.clone.apply(this,arguments);for(i=0;i<b.length;i++){b[i].attachEvent("select",this._handleRBSelect,this);}return o;};
a.prototype._handleRBSelect=function(o){for(var i=0;i<this.aRBs.length;i++){if(this.aRBs[i].getId()==o.getParameter("id")&&o.getParameter("selected")){this.setSelectedIndex(i);this.fireSelect({selectedIndex:i});break;}}};
a.prototype._handleAfterFocus=function(o){var i=o.getParameter("index");var e=o.getParameter("event");if(e.keyCode===undefined){return;}if(i!=this.getSelectedIndex()&&!(e.ctrlKey||e.metaKey)&&this.aRBs[i].getEditable()&&this.aRBs[i].getEnabled()&&this.getEditable()&&this.getEnabled()){this.setSelectedIndex(i);this.fireSelect({selectedIndex:i});}};
a.prototype._getSelectedIndexInRange=function(o){var i=this.getButtons().length,b=this.getSelectedIndex();if(b>=-1&&b<i){return b;}return-1;};
return a;});
sap.ui.predefine('sap/m/RadioButtonGroupRenderer',["sap/ui/core/library","sap/ui/core/Core"],function(a,C){"use strict";var T=a.TextDirection;var R={apiVersion:2};
R.render=function(r,o){if(!o.aRBs){return;}var v=o.aRBs.filter(function(B){return B.getVisible();});var b=o.getColumns();var s=o.getTextDirection();var g=C.getConfiguration().getRTL();r.openStart("div",o).class("sapMRbG");if(b>1){if(b==v.length){r.class("sapMRbG1Row");}else{r.class("sapMRbGTab");}}if(o.getWidth()){r.style("width",o.getWidth());}if(o.getTooltip_AsString()){r.attr("title",o.getTooltip_AsString());}if(!g&&s!=T.Inherit){r.attr("dir",s.toLowerCase());}r.accessibilityState(o,{role:"radiogroup"});r.openEnd();for(var c=0;c<b;c++){if(b>1&&b!=v.length){r.openStart("div").class("sapMRbGCol").openEnd();}for(var i=c;i<v.length;i=i+b){r.renderControl(v[i]);}if(b>1&&b!=v.length){r.close("div");}}if(b>1&&b!=v.length){r.openStart("div").class("sapMRbGDummy").openEnd().close("div");}r.close("div");};
return R;},true);
sap.ui.predefine('sap/m/RadioButtonRenderer',["sap/ui/core/Core","sap/ui/core/ValueStateSupport","sap/ui/core/library","sap/ui/Device"],function(C,V,c,D){"use strict";var a=c.ValueState;var R={apiVersion:2};
R.render=function(r,o){this.addWOuterDivStyles(r,o);this.addInnerDivStyles(r,o);this.renderSvg(r,o);this.renderInput(r,o);this.closeDiv(r);r.renderControl(o._oLabel);this.renderTooltip(r,o);this.closeDiv(r);};
R.addWOuterDivStyles=function(r,o){var i=o.getId(),e=o.getEnabled(),n=!o.getProperty("editableParent"),N=!o.getEditable()||n,v=o.getValueState();r.openStart("div",o).class("sapMRb");if(o.getUseEntireWidth()){r.style("width",o.getWidth());}var t=this.getTooltipText(o);if(t){r.attr("title",t);}r.accessibilityState(o,{role:"radio",readonly:null,selected:null,checked:o.getSelected(),disabled:N?true:undefined,labelledby:{value:i+"-label",append:true},describedby:{value:(t?i+"-Descr":undefined),append:true}});if(o.getSelected()){r.class("sapMRbSel");}if(!e){r.class("sapMRbDis");}if(N){r.class("sapMRbRo");}if(!this.isButtonReadOnly(o)){this.addValueStateClass(r,v);}if(e){r.attr("tabindex",o.hasOwnProperty("_iTabIndex")?o._iTabIndex:0);}r.openEnd();};
R.addInnerDivStyles=function(r,o){r.openStart("div").class("sapMRbB");if(!this.isButtonReadOnly(o)&&D.system.desktop){r.class("sapMRbHoverable");}r.openEnd();};
R.renderSvg=function(r,o){r.openStart("svg").attr("xmlns","http://www.w3.org/2000/svg").attr("version","1.0").accessibilityState({role:"presentation"}).class("sapMRbSvg").openEnd();r.openStart("circle",o.getId()+"-Button").attr("stroke","black").attr("r","50%").attr("stroke-width","2").attr("fill","none").class("sapMRbBOut").openEnd().close("circle");r.openStart("circle").attr("r","22%").attr("stroke-width","10").class("sapMRbBInn").openEnd().close("circle");r.close("svg");};
R.renderInput=function(r,o){r.voidStart("input",o.getId()+"-RB").attr("type","radio").attr("tabindex","-1").attr("name",o.getGroupName());if(o.getSelected()){r.attr("checked","checked");}if(this.isButtonReadOnly(o)){r.attr("readonly","readonly");r.attr("disabled","disabled");}r.voidEnd();};
R.renderTooltip=function(r,o){var t=this.getTooltipText(o);if(t&&C.getConfiguration().getAccessibility()){r.openStart("span",o.getId()+"-Descr").style("display","none").openEnd().text(t).close("span");}};
R.isButtonReadOnly=function(r){var e=r.getEnabled(),n=!r.getProperty("editableParent"),N=!r.getEditable()||n;return!e||N;};
R.closeDiv=function(r){r.close("div");};
R.getTooltipText=function(r){var v=r.getProperty("valueStateText"),t=r.getTooltip_AsString();if(v){return(t?t+" - ":"")+v;}else{return V.enrichTooltip(r,t);}};
R.addValueStateClass=function(r,v){switch(v){case a.Error:r.class("sapMRbErr");break;case a.Warning:r.class("sapMRbWarn");break;case a.Success:r.class("sapMRbSucc");break;case a.Information:r.class("sapMRbInfo");break;default:break;}};
return R;},true);
sap.ui.predefine('sap/m/RangeSlider',["sap/ui/core/InvisibleText","sap/base/Log","./Slider","./SliderTooltip","./SliderUtilities","./RangeSliderRenderer","sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes"],function(I,l,S,a,b,R,q,K){"use strict";
var c=S.extend("sap.m.RangeSlider",{metadata:{library:"sap.m",properties:{value2:{type:"float",group:"Data",defaultValue:100},range:{type:"float[]",group:"Data",defaultValue:[0,100]}},designtime:"sap/m/designtime/RangeSlider.designtime"}});
c.prototype.init=function(){var s,e,r;S.prototype.init.call(this,arguments);this._bInitialRangeChecks=true;this._aInitialFocusRange=this.getRange();this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');this._ariaUpdateDelay=[];s=new I({text:this._oResourceBundle.getText("RANGE_SLIDER_LEFT_HANDLE")});e=new I({text:this._oResourceBundle.getText("RANGE_SLIDER_RIGHT_HANDLE")});r=new I({text:this._oResourceBundle.getText("RANGE_SLIDER_RANGE_HANDLE")});this.destroyAggregation("_handlesLabels",true);this.addAggregation("_handlesLabels",s);this.addAggregation("_handlesLabels",e);this.addAggregation("_handlesLabels",r);this._mHandleTooltip={start:{handle:null,tooltip:null,label:s},end:{handle:null,tooltip:null,label:e}};};
c.prototype.exit=function(){S.prototype.exit.apply(this,arguments);this._oResourceBundle=null;this._aInitialFocusRange=null;this._liveChangeLastValue=null;this._mHandleTooltip.start.handle=null;this._mHandleTooltip.start.tooltip=null;this._mHandleTooltip.start.label=null;this._mHandleTooltip.end.handle=null;this._mHandleTooltip.end.tooltip=null;this._mHandleTooltip.end.label=null;this._ariaUpdateDelay=null;};
c.prototype.onBeforeRendering=function(){this._bRTL=sap.ui.getCore().getConfiguration().getRTL();var r=this.getRange();if(this.getShowAdvancedTooltip()){this.initAndSyncTooltips(["leftTooltip","rightTooltip"]);this._storeTooltipsMetadata();}this._bInitialRangeChecks=false;this._iDecimalPrecision=this.getDecimalPrecisionOfNumber(this.getStep());this.setRange(r);this._validateProperties();this._syncScaleUsage();};
c.prototype.onAfterRendering=function(){S.prototype.onAfterRendering.apply(this,arguments);var r=this.getRange();this._mHandleTooltip.start.handle=this.getDomRef("handle1");this._mHandleTooltip.end.handle=this.getDomRef("handle2");this._recalculateStyles();this._updateHandle(this._mHandleTooltip.start.handle,r[0]);this._updateHandle(this._mHandleTooltip.end.handle,r[1]);if(this.getShowAdvancedTooltip()&&(r[0]>r[1])){this._swapTooltips(r);}};
c.prototype._storeTooltipsMetadata=function(){var t=this.getUsedTooltips();if(!this._mHandleTooltip.start.tooltip){this._mHandleTooltip.start.tooltip=t[0];}if(!this._mHandleTooltip.end.tooltip){this._mHandleTooltip.end.tooltip=t[1];}this._mHandleTooltip.bTooltipsSwapped=false;};
c.prototype._recalculateRange=function(){var h,s,e,p,d=this._bRTL?"right":"left";h=[parseFloat(this._mHandleTooltip.start.handle.style[d]),parseFloat(this._mHandleTooltip.end.handle.style[d])];s=Math.min.apply(Math,h)+"%";e=(100-Math.max.apply(Math,h))+"%";p=this.getDomRef("progress");if(this._bRTL){p.style.left=e;p.style.right=s;}else{p.style.left=s;p.style.right=e;}};
c.prototype.getClosestHandleDomRef=function(e){var h=this._mHandleTooltip.start.handle,H=this._mHandleTooltip.end.handle,p=Math.abs(e.pageX-h.offsetLeft-this._fSliderPaddingLeft-this._fSliderOffsetLeft),C=Math.abs(e.clientX-H.offsetLeft-this._fSliderPaddingLeft-this._fSliderOffsetLeft);return p>C?H:h;};
c.prototype._getIndexOfHandle=function(h){if(h&&h.getAttribute&&h.getAttribute("data-range-val")==="start"){return 0;}else if(h&&h.getAttribute&&h.getAttribute("data-range-val")==="end"){return 1;}else{return-1;}};
c.prototype._getHandleForTooltip=function(t){var h=t===this._mHandleTooltip.start.tooltip?this._mHandleTooltip.start.handle:this._mHandleTooltip.end.handle;return h;};
c.prototype._updateHandle=function(h,v){var t=(this._mHandleTooltip.start.handle===h)?this._mHandleTooltip.start.tooltip:this._mHandleTooltip.end.tooltip,r=this.getRange(),i=this._getIndexOfHandle(h),p=this._getPercentOfValue(v);r[i]=v;this._updateRangePropertyDependencies(r);this._updateHandleDom(h,r,i,v,p);if(this.getShowAdvancedTooltip()){this._updateTooltipContent(t,v);this._adjustTooltipsContainer();}this._recalculateRange();};
c.prototype._updateHandleDom=function(h,r,i,v,p){var m,C=this.getRenderer().CSS_CLASS,f=this.getDomRef("input");if(this.getName()){f.setAttribute(h.getAttribute("data-range-val"),this.toFixed(r[i],this._iDecimalPrecision));f.setAttribute("value",this.getValue());}if(this._bRTL){h.style.right=p+"%";}else{h.style.left=p+"%";}if(this.getShowHandleTooltip()&&!this.getShowAdvancedTooltip()){h.title=this._formatValueByCustomElement(v);}m=r[0]===r[1];this.$("handle1").toggleClass(C+"HandleOverlap",m);this.$("handle2").toggleClass(C+"HandleOverlap",m);clearTimeout(this._ariaUpdateDelay[i]);this._ariaUpdateDelay[i]=setTimeout(this["_updateHandleAria"].bind(this,h,v),100);};
c.prototype._updateHandleAria=function(h,v){var r=this.getRange(),p=this.getDomRef("progress"),n=this.toFixed(v,this._iDecimalPrecision),s=this._formatValueByCustomElement(n),f=this.getValue(),d=this.getValue2(),V=Math.abs(d-f);r[0]=this.toFixed(r[0],this._iDecimalPrecision);r[1]=this.toFixed(r[1],this._iDecimalPrecision);this._updateHandlesAriaLabels();this._updateHandleAriaAttributeValues(h,v,s);if(p){p.setAttribute("aria-valuetext",this._oResourceBundle.getText('RANGE_SLIDER_RANGE_ANNOUNCEMENT',r.map(this._formatValueByCustomElement,this)));p.setAttribute("aria-valuenow",V);}};
c.prototype._updateHandlesAriaLabels=function(){var r=this.getRange(),t=this._mHandleTooltip.start.label;if((r[0]>r[1]&&!this._mHandleTooltip.bAriaHandlesSwapped)||(r[0]<r[1]&&this._mHandleTooltip.bAriaHandlesSwapped)){this._mHandleTooltip.start.label=this._mHandleTooltip.end.label;this._mHandleTooltip.end.label=t;if(this._mHandleTooltip.start.handle){this._mHandleTooltip.start.handle.setAttribute("aria-labelledby",this._mHandleTooltip.start.label.getId());}if(this._mHandleTooltip.end.handle){this._mHandleTooltip.end.handle.setAttribute("aria-labelledby",this._mHandleTooltip.end.label.getId());}this._mHandleTooltip.bAriaHandlesSwapped=!this._mHandleTooltip.bAriaHandlesSwapped;}};
c.prototype._setAriaControls=function(){if(!this.getShowAdvancedTooltip()){return;}if(!this._mHandleTooltip.start.handle.getAttribute('aria-controls')&&this._mHandleTooltip.start.tooltip){this._mHandleTooltip.start.handle.setAttribute('aria-controls',this._mHandleTooltip.start.tooltip.getId());}if(!this._mHandleTooltip.end.handle.getAttribute('aria-controls')&&this._mHandleTooltip.end.tooltip){this._mHandleTooltip.end.handle.setAttribute('aria-controls',this._mHandleTooltip.end.tooltip.getId());}};
c.prototype._updateTooltipContent=function(t,n){var N=this.toFixed(n,this._iDecimalPrecision);t.setValue(parseFloat(N));};
c.prototype._swapTooltips=function(r){var t=this._mHandleTooltip.start.tooltip;if((r[0]>=r[1]&&!this._mHandleTooltip.bTooltipsSwapped)||(r[0]<=r[1]&&this._mHandleTooltip.bTooltipsSwapped)){this._mHandleTooltip.start.tooltip=this._mHandleTooltip.end.tooltip;this._mHandleTooltip.end.tooltip=t;this._updateTooltipContent(this._mHandleTooltip.start.tooltip,r[0]);this._updateTooltipContent(this._mHandleTooltip.end.tooltip,r[1]);if(this.getInputsAsTooltips()){this._mHandleTooltip.start.handle.setAttribute("aria-controls",this._mHandleTooltip.start.tooltip.getId());this._mHandleTooltip.end.handle.setAttribute("aria-controls",this._mHandleTooltip.end.tooltip.getId());}this._mHandleTooltip.bTooltipsSwapped=!this._mHandleTooltip.bTooltipsSwapped;}};
c.prototype._adjustTooltipsContainer=function(){var t=this.getAggregation("_tooltipContainer");if(!t.getDomRef()){return;}t.repositionTooltips(this.getMin(),this.getMax());this._swapTooltips(this.getRange());};
c.prototype.getUsedTooltips=function(){var C=this.getCustomTooltips(),d=this.getAggregation("_defaultTooltips")||[];return C.length>1?C:d;};
c.prototype.handleTooltipChange=function(e){this.updateTooltipsPositionAndState(e.getSource(),Number(e.getParameter("value")));};
c.prototype.updateTooltipsPositionAndState=function(t,v){var h,A,T=this._mHandleTooltip.bTooltipsSwapped;v=this._adjustRangeValue(v);h=this._mHandleTooltip.start.tooltip===t?this._mHandleTooltip.start.handle:this._mHandleTooltip.end.handle;this._updateHandle(h,v);if(T!==this._mHandleTooltip.bTooltipsSwapped){A=this._mHandleTooltip.start.tooltip!==t?this._mHandleTooltip.start.tooltip:this._mHandleTooltip.end.tooltip;A.focus();}this._fireChangeAndLiveChange({range:this.getRange()});this.updateAdvancedTooltipDom();};
c.prototype._updateDOMAfterSetters=function(v,r,h){var p,H;if(this.getDomRef()){p=this._getPercentOfValue(v);H=h===1?this._mHandleTooltip.end:this._mHandleTooltip.start;this._updateHandleDom(H.handle,r,h,v,p);if(this.getShowAdvancedTooltip()){this._updateTooltipContent(H.tooltip,v);}return true;}return false;};
c.prototype.setRange=function(r){r=r.map(this._adjustRangeValue,this);this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[0],r,0)&&this._updateDOMAfterSetters(r[1],r,1)){this._recalculateRange();}return this;};
c.prototype.setStep=function(s){this._validateProperties();this._iDecimalPrecision=this.getDecimalPrecisionOfNumber(s);return this.setProperty("step",s);};
c.prototype.setValue=function(v){var r=this.getRange();if(typeof v!=="number"||!isFinite(v)){return this;}v=this._adjustRangeValue(v);r[0]=v;this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[0],r,0)){this._recalculateRange();}return this;};
c.prototype.setValue2=function(v){var r=this.getRange();v=this._adjustRangeValue(v);r[1]=v;this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[1],r,1)){this._recalculateRange();}return this;};
c.prototype._updateRangePropertyDependencies=function(r){var d=Array.isArray(r)?r.slice():[],D=this._iDecimalPrecision?this._iDecimalPrecision:0,n=Number(d[0].toFixed(D)),N=Number(d[1].toFixed(D));if(this.getProperty("value")!==n){this.setProperty("value",n,true);d[0]=n;}if(this.getProperty("value2")!==N){this.setProperty("value2",N,true);d[1]=N;}this.setProperty("range",d,true);};
c.prototype._calculateHandlePosition=function(v){var m=this.getMax(),M=this.getMin(),n;n=((v-this._fSliderPaddingLeft-this._fSliderOffsetLeft)/this._fSliderWidth)*(m-M)+M;if(this._bRTL){n=this._convertValueToRtlMode(n);}return this._adjustRangeValue(n);};
c.prototype._adjustRangeValue=function(v){var m=this.getMax(),M=this.getMin(),s=this.getStep(),f;if(this._bInitialRangeChecks){return v;}f=Math.abs((v-M)%s);if(f!==0){v=f*2>=s?v+s-f:v-f;}if(v<M){l.warning("Warning: "+"Min value ("+v+") not in the range: ["+M+","+m+"]",this);v=M;}else if(v>m){l.warning("Warning: "+"Max value ("+v+") not in the range: ["+M+","+m+"]",this);v=m;}return v;};
c.prototype.ontouchstart=function(e){var t=e.targetTouches[0],C=this.getRenderer().CSS_CLASS,E="."+C,m,M,v,h,r,H,f,F,T,p,d,g;if(!this.getEnabled()){return;}e.setMarked();if(e.target.className.indexOf("sapMInput")===-1){e.preventDefault();}this._recalculateStyles();if(["number","text"].indexOf(e.target.type)>-1){return;}v=this._calculateHandlePosition(t.pageX);r=this.getRange();h=[this._mHandleTooltip.start.handle,this._mHandleTooltip.end.handle];H=this._getIndexOfHandle(e.target);f=h.reduce(function(A,o){return Math.abs(A-o.offsetLeft);},0);m=Math.min.apply(Math,r);M=Math.max.apply(Math,r);g=this.$("handle1").outerWidth()/2;T=Math.abs(this.getMin())+Math.abs(this.getMax());p=((g*100)/this.$("inner").outerWidth());d=(p/100)*T;if(v<m||v<m+d||v>M||v>(M-d)||f<=b.CONSTANTS.RANGE_MOVEMENT_THRESHOLD){h=[this.getClosestHandleDomRef(t)];this._updateHandle(h[0],v);this.fireLiveChange({range:r});}else if(H!==-1){h=[this.getDomRef(H===0?"handle1":"handle2")];}q(document).on("touchend"+E+" touchcancel"+E+" mouseup"+E,this._ontouchend.bind(this,h)).on("touchmove"+E+(e.originalEvent.type!=="touchstart"?" mousemove"+E:""),this._ontouchmove.bind(this,v,this.getRange(),h));h.map(function(o){if(o.className.indexOf(C+"HandlePressed")===-1){o.className+=" "+C+"HandlePressed";}});F=h.length===1?h[0]:this.getDomRef("progress");setTimeout(F["focus"].bind(F),0);};
c.prototype._ontouchmove=function(f,d,h,e){var o,r,g,j,p=e.targetTouches?e.targetTouches[0].pageX:e.pageX,m=this.getMax(),M=this.getMin(),k=[],n=[];e.preventDefault();e.setMarked();if(e.isMarked("delayedMouseEvent")||!this.getEnabled()||e.button){return;}o=this._calculateHandlePosition(p)-f;for(var i=0;i<d.length;i++){k[i]=d[i]+o;}n=this._getNormalizedRange(this.getRange(),d,h);r=k.every(function(v,s){return v===n[s];});g=k.every(function(v){return(v>=M&&v<=m);});j=n.indexOf(M)>-1||n.indexOf(m)>-1;if(!r){if((h.length===1)||g||!j){h.map(function(H){this._updateHandle(H,d[this._getIndexOfHandle(H)]+o);},this);}this.getShowAdvancedTooltip()&&this._adjustTooltipsContainer();n=this._getNormalizedRange(this.getRange(),d,h);}this._triggerLiveChange();this.setRange(n);};
c.prototype.updateAdvancedTooltipDom=function(){this.getAggregation("_tooltipContainer").repositionTooltips(this.getMin(),this.getMax());};
c.prototype._triggerLiveChange=function(){var f,r=this.getRange();this._liveChangeLastValue=this._liveChangeLastValue||[];f=r.some(function(v,i){return v!==this._liveChangeLastValue[i];},this);if(f){this._liveChangeLastValue=r.slice();this.fireLiveChange({range:r});}};
c.prototype._getNormalizedRange=function(r,d,h){var m=this.getMax(),M=this.getMin(),s=Math.abs(d[0]-d[1]),e=[],i,o;for(i=0;i<r.length;i++){e[i]=(r[i]<M?M:r[i]);e[i]=(r[i]>m?m:e[i]);if(h.length===2){if(e[0]==M){e[1]=e[0]+s;}else{o=Math.abs(i-1);e[o]=(e[i]<=M?e[i]+s:e[o]);e[o]=(e[i]>=m?e[i]-s:e[o]);}}}return e;};
c.prototype._ontouchend=function(h,e){var n=this.getRange(),C=this.getRenderer().CSS_CLASS;e.setMarked();h&&h.map(function(H){H.className=H.className.replace(new RegExp(" ?"+C+"HandlePressed","gi"),"");});q(document).off("."+C);this._recalculateRange();if(this._aInitialFocusRange[0]!==n[0]||this._aInitialFocusRange[1]!==n[1]){this._aInitialFocusRange=Array.prototype.slice.call(n);this.fireChange({range:n});}if(this.getShowAdvancedTooltip()){this._updateTooltipContent(this._mHandleTooltip.start.tooltip,n[0]);this._updateTooltipContent(this._mHandleTooltip.end.tooltip,n[1]);}};
c.prototype.onfocusin=function(e){var t=this.getAggregation("_tooltipContainer");if(this.getShowAdvancedTooltip()){t.show(this);this._adjustTooltipsContainer();this._setAriaControls();}if(document.activeElement!==this.getFocusDomRef()){this._aInitialFocusRange=this.getRange();}};
c.prototype.getFocusDomRef=function(){return this.getDomRef("progress");};
c.prototype._updateSliderValues=function(o,h){var r=this.getRange(),m=this.getMax(),M=this.getMin(),f=Math.max.apply(null,r),d=Math.min.apply(null,r),i=this._getIndexOfHandle(h),O=o<0?-1:1,H=i>-1?[h]:[this._mHandleTooltip.start.handle,this._mHandleTooltip.end.handle];if(H.length===1){d=f=r[i];}if(f+o>m){o=O*(Math.abs(m)-Math.abs(f));}else if(d+o<M){o=Math.abs(d)-Math.abs(M);o=o<0?o:O*o;}H.map(function(C){this._updateHandle(C,r[this._getIndexOfHandle(C)]+o);},this);};
c.prototype.onkeydown=function(e){var f=this.getInputsAsTooltips(),s=this.getShowAdvancedTooltip(),F=e.keyCode===b.CONSTANTS.F2_KEYCODE,d=(e.target===this._mHandleTooltip.start.handle),t=q(e.target).hasClass(b.CONSTANTS.HANDLE_CLASS);if(F&&s&&f&&t){this._mHandleTooltip[d?"start":"end"].tooltip.focus();}if(e.keyCode===K.SPACE){e.preventDefault();}};
c.prototype.onsapincrease=function(e){e.preventDefault();e.setMarked();if(this.getEnabled()){this._updateSliderValues(this.getStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapplus=c.prototype.onsapincrease;
c.prototype.onsapincreasemodifiers=function(e){if(e.altKey){return;}e.preventDefault();e.stopPropagation();e.setMarked();if(this.getEnabled()){this._updateSliderValues(this._getLongStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsappageup=c.prototype.onsapincreasemodifiers;
c.prototype.onsapdecrease=function(e){e.preventDefault();e.setMarked();if(this.getEnabled()){this._updateSliderValues(-1*this.getStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapminus=c.prototype.onsapdecrease;
c.prototype.onsapdecreasemodifiers=function(e){if(e.altKey){return;}e.preventDefault();e.stopPropagation();e.setMarked();if(this.getEnabled()){this._updateSliderValues(-1*this._getLongStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsappagedown=c.prototype.onsapdecreasemodifiers;
c.prototype.onsaphome=function(e){var h=0,r,H,m;e.setMarked();e.preventDefault();h=this._getIndexOfHandle(e.target);r=this.getRange()[h];m=this.getMin();if(this.getEnabled()&&(r!==m)){H=(h===1?this._mHandleTooltip.end:this._mHandleTooltip.start);this._updateHandle(H.handle,m);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapend=function(e){e.setMarked();e.preventDefault();if(this.getEnabled()){this._updateSliderValues(this.getMax(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapescape=function(){this.setRange(this._aInitialFocusRange);this._fireChangeAndLiveChange({range:this.getRange()});};
return c;});
sap.ui.predefine('sap/m/RangeSliderRenderer',["sap/ui/core/Renderer","./SliderRenderer","sap/ui/core/InvisibleText"],function(R,S,I){"use strict";var a=R.extend(S);a.apiVersion=2;
a.renderHandles=function(r,c,s){this.renderHandle(r,c,{id:c.getId()+"-handle1",position:"start",forwardedLabels:s});this.renderHandle(r,c,{id:c.getId()+"-handle2",position:"end",forwardedLabels:s});r.renderControl(c._mHandleTooltip.start.label);r.renderControl(c._mHandleTooltip.end.label);r.renderControl(c.getAggregation("_handlesLabels")[2]);};
a.renderHandle=function(r,c,o){var v,b=c.getRange(),e=c.getEnabled(),d=sap.ui.getCore().getConfiguration().getRTL();r.openStart("span",o&&o.id);if(o&&(o.position!==undefined)){v=b[o.position==="start"?0:1];r.attr("data-range-val",o.position);r.attr("aria-labelledby",(o.forwardedLabels+" "+c._mHandleTooltip[o.position].label.getId()).trim());if(c.getInputsAsTooltips()){r.attr("aria-describedby",I.getStaticId("sap.m","SLIDER_INPUT_TOOLTIP"));e&&r.attr("aria-keyshortcuts","F2");}}if(c.getShowHandleTooltip()&&!c.getShowAdvancedTooltip()){this.writeHandleTooltip(r,c);}r.class(S.CSS_CLASS+"Handle");if(o&&(o.id!==undefined)&&o.id===(c.getId()+"-handle1")){r.style(d?"right":"left",b[0]);}if(o&&(o.id!==undefined)&&o.id===(c.getId()+"-handle2")){r.style(d?"right":"left",b[1]);}this.writeAccessibilityState(r,c,v);if(e){r.attr("tabindex","0");}r.openEnd().close("span");};
a.writeAccessibilityState=function(r,s,v){var n=s._isElementsFormatterNotNumerical(v),b=s._formatValueByCustomElement(v),V;if(s._getUsedScale()&&!n){V=b;}else{V=s.toFixed(v);}r.accessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuenow:V});if(n){r.accessibilityState(s,{valuetext:b});}};
a.renderStartLabel=function(r,c){r.openStart("div").class(S.CSS_CLASS+"RangeLabel").openEnd().text(c.getMin()).close("div");};
a.renderEndLabel=function(r,c){r.openStart("div").class(S.CSS_CLASS+"RangeLabel").style("width",c._getMaxTooltipWidth()+"px").openEnd().text(c.getMax()).close("div");};
a.renderLabels=function(r,c){if(!c.getEnableTickmarks()){r.openStart("div").class(S.CSS_CLASS+"Labels").openEnd();this.renderStartLabel(r,c);this.renderEndLabel(r,c);r.close("div");}};
a.renderProgressIndicator=function(r,s,f){var b=s.getRange();b[0]=s.toFixed(b[0],s._iDecimalPrecision);b[1]=s.toFixed(b[1],s._iDecimalPrecision);var v=Math.abs(b[1]-b[0]);r.openStart("div",s.getId()+"-progress");if(s.getEnabled()){r.attr("tabindex","0");}this.addProgressIndicatorClass(r,s);r.style("width",s._sProgressValue);r.accessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuenow:v,valuetext:s._oResourceBundle.getText('RANGE_SLIDER_RANGE_ANNOUNCEMENT',b.map(s._formatValueByCustomElement,s)),labelledby:(f+" "+s.getAggregation("_handlesLabels")[2].getId()).trim()}).openEnd().close("div");};
a.addClass=function(r,s){S.addClass(r,s);r.class("sapMRangeSlider");};
return a;},true);
sap.ui.predefine('sap/m/RatingIndicator',['./library','sap/ui/core/Control','sap/ui/core/theming/Parameters','./RatingIndicatorRenderer',"sap/ui/events/KeyCodes","sap/base/Log","sap/ui/thirdparty/jquery"],function(l,C,P,R,K,L,q){"use strict";var a=l.RatingIndicatorVisualMode;
var b=C.extend("sap.m.RatingIndicator",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},maxValue:{type:"int",group:"Behavior",defaultValue:5},value:{type:"float",group:"Behavior",defaultValue:0,bindable:"bindable"},iconSize:{type:"sap.ui.core.CSSSize",group:"Behavior",defaultValue:null},iconSelected:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},iconUnselected:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},iconHovered:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},visualMode:{type:"sap.m.RatingIndicatorVisualMode",group:"Behavior",defaultValue:a.Half},displayOnly:{type:"boolean",group:"Behavior",defaultValue:false},editable:{type:"boolean",group:"Behavior",defaultValue:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"int"}}},liveChange:{parameters:{value:{type:"float"}}}},designtime:"sap/m/designtime/RatingIndicator.designtime"}});
b.sizeMapppings={};b.iconPaddingMappings={};b.paddingValueMappping={};
b.prototype.init=function(){this.allowTextSelection(false);this._iIconCounter=0;this._fHoverValue=0;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');};
b.prototype.setValue=function(v){var V=typeof v!=="string"?v:Number(v);V=this.validateProperty("value",V);if(V<0){return this;}if(isNaN(V)){L.warning('Ignored new rating value "'+v+'" because it is NAN');}else if(this.$().length&&(V>this.getMaxValue())){L.warning('Ignored new rating value "'+V+'" because it is out  of range (0-'+this.getMaxValue()+')');}else{V=this._roundValueToVisualMode(V);this.setProperty("value",V);this._fHoverValue=V;}return this;};
b.prototype.onThemeChanged=function(e){this.invalidate();};
b.prototype.onBeforeRendering=function(){var v=this.getValue();var m=this.getMaxValue();if(v>m){this.setValue(m);L.warning("Set value to maxValue because value is > maxValue ("+v+" > "+m+").");}else if(v<0){this.setValue(0);L.warning("Set value to 0 because value is < 0 ("+v+" < 0).");}var i=this.getIconSize();if(i){this._setRegularSizes(i);}else if(this.getDisplayOnly()){this._setDisplayOnlySizes();}else{this._setContentDensitySizes();}};
b.prototype._setDisplayOnlySizes=function(){var i="sapUiRIIconSizeDisplayOnly",I="sapUiRIIconPaddingDisplayOnly";if(b.sizeMapppings[i]&&b.paddingValueMappping[I]){this._iPxIconSize=b.sizeMapppings[i];this._iPxPaddingSize=b.paddingValueMappping[I];return;}var p=Object.assign({"sapUiRIIconSizeDisplayOnly":"1rem","sapUiRIIconPaddingDisplayOnly":"0.125rem"},P.get({name:[i,I],callback:function(m){this.setIconAndPaddingSizes(i,I,m[i],m[I]);}.bind(this)}));this.setIconAndPaddingSizes(i,I,p[i],p[I]);};
b.prototype._setContentDensitySizes=function(){var d=this._getDensityMode();var s="sapUiRIIconSize"+d;var p="sapUiRIIconPadding"+d;if(b.sizeMapppings[s]&&b.paddingValueMappping[p]){this._iPxIconSize=b.sizeMapppings[s];this._iPxPaddingSize=b.paddingValueMappping[p];return;}var m=P.get({name:[s,p],callback:function(c){this.setIconAndPaddingSizes(s,p,c[s],c[p]);}.bind(this)});if(m){this.setIconAndPaddingSizes(s,p,m[s],m[p]);}};
b.prototype._setRegularSizes=function(i){b.sizeMapppings[i]=b.sizeMapppings[i]||this._toPx(i);var p=b.sizeMapppings[i];b.iconPaddingMappings[p]=b.iconPaddingMappings[p]||"sapUiRIIconPadding"+this._getIconSizeLabel(p);var s=b.iconPaddingMappings[p];if(b.paddingValueMappping[s]){this._iPxIconSize=b.sizeMapppings[i];this._iPxPaddingSize=b.paddingValueMappping[s];return;}var c=P.get({name:s,callback:function(d){this.setIconAndPaddingSizes(i,s,b.sizeMapppings[i],d);}.bind(this)});if(c){this.setIconAndPaddingSizes(i,s,b.sizeMapppings[i],c);}};
b.prototype.setIconAndPaddingSizes=function(s,p,S,c){b.sizeMapppings[s]=this._toPx(S);b.paddingValueMappping[p]=this._toPx(c);this._iPxIconSize=b.sizeMapppings[s];this._iPxPaddingSize=b.paddingValueMappping[p];};
b.prototype.onAfterRendering=function(){this._updateAriaValues();};
b.prototype.exit=function(){this._iIconCounter=null;this._fStartValue=null;this._iPxIconSize=null;this._iPxPaddingSize=null;this._fHoverValue=null;this._oResourceBundle=null;};
b.prototype._getDensityMode=function(){var d=[{name:"Cozy",style:"sapUiSizeCozy"},{name:"Compact",style:"sapUiSizeCompact"},{name:"Condensed",style:"sapUiSizeCondensed"}],D,s,i;for(i in d){D=d[i].style;if(q("html").hasClass(D)||q("."+D).length>0){s=d[i].name;}}return s||d[0].name;};
b.prototype._getIconSizeLabel=function(p){switch(true){case(p>=32):return"L";case(p>=22):return"M";case(p>=16):return"S";case(p>=12):return"XS";default:return"M";}};
b.prototype._toPx=function(c){var s=Math.round(c),S;if(isNaN(s)){if(RegExp("^(auto|0)$|^[+-\.]?[0-9].?([0-9]+)?(px|em|rem|ex|%|in|cm|mm|pt|pc)$").test(c)){S=q('<div>&nbsp;</div>').css({"display":"none","width":c,"margin":0,"padding":0,"height":"auto","line-height":1,"border":0,"overflow":"hidden"}).appendTo(sap.ui.getCore().getStaticAreaRef());s=S.width();S.remove();}else{return false;}}return Math.round(s);};
b.prototype._updateUI=function(v,h){var s=this.$("sel"),u=this.$("unsel-wrapper"),H=this.$("hov"),i=this._iPxIconSize,I=this._iPxPaddingSize,c="px",S=this.getMaxValue(),d=v*i+(Math.round(v)-1)*I,w=S*(i+I)-I;this._fHoverValue=v;if(d<0){d=0;}this._updateAriaValues(v);u.width((w-d)+c);if(h){H.width(d+c);s.hide();H.show();}else{s.width(d+c);H.hide();s.show();}L.debug("Updated rating UI with value "+v+" and hover mode "+h);};
b.prototype._updateAriaValues=function(n){var $=this.$();var v;if(n===undefined){v=this.getValue();}else{v=n;}var m=this.getMaxValue();$.attr("aria-valuenow",v);$.attr("aria-valuemax",m);var V=this._oResourceBundle.getText("RATING_VALUEARIATEXT",[v,m]);$.attr("aria-valuetext",V);};
b.prototype._calculateSelectedValue=function(e){var s=-1.0,p=0.0,c=this.$(),f=(c.innerWidth()-c.width())/2,E,r=sap.ui.getCore().getConfiguration().getRTL();if(e.targetTouches){E=e.targetTouches[0];}else{E=e;}if(!E||!E.pageX){E=e;if((!E||!E.pageX)&&e.changedTouches){E=e.changedTouches[0];}}if(!E.pageX){return parseFloat(s);}if(E.pageX<c.offset().left){s=0;}else if((E.pageX-c.offset().left)>c.innerWidth()-f){s=this.getMaxValue();}else{p=(E.pageX-c.offset().left-f)/c.width();s=p*this.getMaxValue();}if(r){s=this.getMaxValue()-s;}return this._roundValueToVisualMode(s,true);};
b.prototype._roundValueToVisualMode=function(v,i){if(i){if(v<0.25){v=0;}else if(v<this.getMaxValue()-0.4){v+=0.4;}v=Math.round(v);}else{if(this.getVisualMode()===a.Full){v=Math.round(v);}else if(this.getVisualMode()===a.Half){v=Math.round(v*2)/2;}}return parseFloat(v);};
b.prototype._getIncreasedValue=function(){var m=this.getMaxValue(),v=this.getValue()+this._getValueChangeStep();if(v>m){v=m;}return v;};
b.prototype._getDecreasedValue=function(){var v=this.getValue()-this._getValueChangeStep();if(v<0){v=0;}return v;};
b.prototype._getValueChangeStep=function(){var v=this.getVisualMode(),s;switch(v){case a.Full:s=1;break;case a.Half:if(this.getValue()%1===0.5){s=0.5;}else{s=1;}break;default:L.warning("VisualMode not supported",v);}return s;};
b.prototype.ontouchstart=function(e){if(e.which==2||e.which==3||!this.getEnabled()||this.getDisplayOnly()||!this.getEditable()){return;}e.setMarked();if(!this._touchEndProxy){this._touchEndProxy=q.proxy(this._ontouchend,this);}if(!this._touchMoveProxy){this._touchMoveProxy=q.proxy(this._ontouchmove,this);}q(document).on("touchend.sapMRI touchcancel.sapMRI mouseup.sapMRI",this._touchEndProxy);q(document).on("touchmove.sapMRI mousemove.sapMRI",this._touchMoveProxy);this._fStartValue=this.getValue();var v=this._calculateSelectedValue(e);if(v>=0&&v<=this.getMaxValue()){this._updateUI(v,true);if(this._fStartValue!==v){this.fireLiveChange({value:v});}}};
b.prototype._ontouchmove=function(e){if(e.isMarked("delayedMouseEvent")){return;}e.preventDefault();if(this.getEnabled()){var v=this._calculateSelectedValue(e);if(v>=0&&v<=this.getMaxValue()){this._updateUI(v,true);if(this._fStartValue!==v){this.fireLiveChange({value:v});}}}};
b.prototype._ontouchend=function(e){if(e.isMarked("delayedMouseEvent")){return;}if(this.getEnabled()){var v=this._calculateSelectedValue(e);if(this.getValue()===1&&v===1){v=0;}this.setProperty("value",v,true);this._updateUI(v,false);if(this._fStartValue!==v){this.fireLiveChange({value:v});this.fireChange({value:v});}q(document).off("touchend.sapMRI touchcancel.sapMRI mouseup.sapMRI",this._touchEndProxy);q(document).off("touchmove.sapMRI mousemove.sapMRI",this._touchMoveProxy);delete this._fStartValue;}};
b.prototype.ontouchcancel=b.prototype.ontouchend;
b.prototype.onsapincrease=function(e){var v=this._getIncreasedValue();this._handleKeyboardValueChange(e,v);};
b.prototype.onsapdecrease=function(e){var v=this._getDecreasedValue();this._handleKeyboardValueChange(e,v);};
b.prototype.onsaphome=function(e){var v=0;this._handleKeyboardValueChange(e,v);};
b.prototype.onsapend=function(e){var v=this.getMaxValue();this._handleKeyboardValueChange(e,v);};
b.prototype.onsapselect=function(e){var v;if(this.getValue()===this.getMaxValue()){v=0;}else{v=this._getIncreasedValue();}this._handleKeyboardValueChange(e,v);};
b.prototype.onkeyup=function(e){var m=this.getMaxValue();if(!this.getEnabled()||this.getDisplayOnly()||!this.getEditable()){return false;}switch(e.which){case K.DIGIT_0:case K.NUMPAD_0:this.setValue(0);break;case K.DIGIT_1:case K.NUMPAD_1:this.setValue(1);break;case K.DIGIT_2:case K.NUMPAD_2:this.setValue(Math.min(2,m));break;case K.DIGIT_3:case K.NUMPAD_3:this.setValue(Math.min(3,m));break;case K.DIGIT_4:case K.NUMPAD_4:this.setValue(Math.min(4,m));break;case K.DIGIT_5:case K.NUMPAD_5:this.setValue(Math.min(5,m));break;case K.DIGIT_6:case K.NUMPAD_6:this.setValue(Math.min(6,m));break;case K.DIGIT_7:case K.NUMPAD_7:this.setValue(Math.min(7,m));break;case K.DIGIT_8:case K.NUMPAD_8:this.setValue(Math.min(8,m));break;case K.DIGIT_9:case K.NUMPAD_9:this.setValue(Math.min(9,m));break;}};
b.prototype._handleKeyboardValueChange=function(e,v){if(!this.getEnabled()||this.getDisplayOnly()||!this.getEditable()){return;}if(v!==this.getValue()){this.setValue(v);this.fireLiveChange({value:v});this.fireChange({value:v});}if(e){e.preventDefault();e.stopPropagation();}};
b.prototype.getAccessibilityInfo=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{role:"slider",type:B.getText("ACC_CTR_TYPE_RATING"),description:B.getText("ACC_CTR_STATE_RATING",[this.getValue(),this.getMaxValue()]),focusable:this.getEnabled()&&!this.getDisplayOnly(),enabled:this.getEnabled(),editable:this.getEditable()};};
return b;});
sap.ui.predefine('sap/m/RatingIndicatorRenderer',["sap/ui/core/IconPool","sap/ui/Device","sap/ui/core/Core"],function(I,D,C){"use strict";var R={apiVersion:2},s="px";
R.render=function(r,c){var t=this;this.initSharedState(c);this.renderControlContainer(r,c,function(){t.renderSelectedItems(r,c);t.renderUnselectedItems(r,c);t.renderHoverItems(r,c);t.renderSelectorDiv(r,c);});};
R.renderControlContainer=function(r,c,i){var e=c.getEnabled(),E=c.getEditable(),d=c.getDisplayOnly();r.openStart("div",c);r.style("width",this._iWidth+"px");r.style("height",this._iHeight+"px");if(e&&!d){r.attr("tabindex","0");r.class("sapMPointer");if(!E){r.class("sapMRIReadOnly");}}else{r.attr("tabindex","-1");e?r.class("sapMRIDisplayOnly"):r.class("sapMRIDisabled");}r.class("sapMRI");r.class("sapUiRatingIndicator"+c._getIconSizeLabel(this._fIconSize));this.writeTooltip(r,c);this.writeAccessibility(r,c);r.openEnd();i();r.close("div");};
R.initSharedState=function(c){var r=c._roundValueToVisualMode(c.getValue()),i=c._iPxIconSize,f=c._iPxPaddingSize,S=r*i+(Math.round(r)-1)*f;if(S<0){S=0;}this._bUseGradient=D.browser.chrome||D.browser.safari;this._sLabelID=c.getId()+"-ariaLabel";this._iSymbolCount=c.getMaxValue();this._iWidth=this._iSymbolCount*(i+f)-f;this._iHeight=i;this._iSelectedWidth=S;this._fIconSize=i;};
R.writeTooltip=function(r,c){var t=c.getTooltip_AsString();if(t){r.attr("title",t);}};
R.writeAccessibility=function(r,c){var o=C.getLibraryResourceBundle("sap.m");r.accessibilityState(c,{role:"slider",orientation:"horizontal",valuemin:0,disabled:!c.getEnabled()||c.getDisplayOnly(),roledescription:o.getText("RATING_INDICATOR_ARIA_ROLEDESCRIPTION")});};
R.renderSelectedItems=function(r,c){r.openStart("div",c.getId()+"-sel");r.class("sapMRISel");if(this._bUseGradient){r.class("sapMRIGrd");}r.style("width",this._iSelectedWidth+s);r.openEnd();for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("SELECTED",r,c);}r.close("div");};
R.renderUnselectedItems=function(r,c){r.openStart("div",c.getId()+"-unsel-wrapper");r.class("sapMRIUnselWrapper");r.style("width",this._iWidth-this._iSelectedWidth+s);r.openEnd();r.openStart("div",c.getId()+"-unsel");r.class("sapMRIUnsel");if(this._bUseGradient&&(c.getEnabled()||!c.getDisplayOnly())){r.class("sapMRIGrd");}r.openEnd();for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("UNSELECTED",r,c);}r.close("div");r.close("div");};
R.renderHoverItems=function(r,c){if(c.getEnabled()||!c.getDisplayOnly()){r.openStart("div",c.getId()+"-hov");r.class("sapMRIHov");r.openEnd();for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("HOVERED",r,c);}r.close("div");}};
R.renderSelectorDiv=function(r,c){r.openStart("div",c.getId()+"-selector");r.class("sapMRISelector");r.openEnd();r.close("div");};
R.renderIcon=function(i,r,c){var a=this.getIconURI(i,c),t=this.getIconTag(a),b=I.isIconURI(a),S=this._fIconSize+s;if(t==="img"){r.voidStart(t);}else{r.openStart(t);}if(i==="UNSELECTED"&&!c.getEditable()){i="READONLY";}r.class("sapUiIcon");r.class(this.getIconClass(i));r.style("width",S);r.style("height",S);r.style("line-height",S);r.style("font-size",S);if(!b){r.attr("src",a);}if(t==="img"){r.voidEnd();}else{r.openEnd();if(b){r.text(I.getIconInfo(a).content);}r.close(t);}};
R.getIconClass=function(i){switch(i){case"SELECTED":return"sapMRIIconSel";case"UNSELECTED":return"sapMRIIconUnsel";case"HOVERED":return"sapMRIIconHov";case"READONLY":return"sapMRIIconReadOnly";}};
R.getIconURI=function(S,c){if(sap.ui.getCore().getConfiguration().getTheme()==="sap_hcb"){if(S==="UNSELECTED"&&(c.getEnabled()&&!c.getDisplayOnly())){return I.getIconURI("unfavorite");}return I.getIconURI("favorite");}switch(S){case"SELECTED":return c.getIconSelected()||I.getIconURI("favorite");case"UNSELECTED":if(c.getEditable()&&!c.getDisplayOnly()){return c.getIconUnselected()||I.getIconURI("unfavorite");}else{return c.getIconUnselected()||I.getIconURI("favorite");}case"HOVERED":return c.getIconHovered()||I.getIconURI("favorite");}};
R.getIconTag=function(i){if(I.isIconURI(i)){return"span";}return"img";};
return R;},true);
sap.ui.predefine('sap/m/ResponsivePopover',['./Dialog','./Popover','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/Device','./ResponsivePopoverRenderer','./Toolbar','./ToolbarSpacer','./Button',"sap/ui/thirdparty/jquery"],function(D,P,l,C,I,a,R,T,b,B,q){"use strict";var c=l.DialogType;var d=l.PlacementType;var e=l.TitleAlignment;
var f=C.extend("sap.m.ResponsivePopover",{metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Misc",defaultValue:d.Right},showHeader:{type:"boolean",group:"Misc",defaultValue:true},title:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},modal:{type:"boolean",group:"Misc",defaultValue:null},offsetX:{type:"int",group:"Misc",defaultValue:null},offsetY:{type:"int",group:"Misc",defaultValue:null},showArrow:{type:"boolean",group:"Appearance",defaultValue:true},contentWidth:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},contentHeight:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},horizontalScrolling:{type:"boolean",group:"Misc",defaultValue:true},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},showCloseButton:{type:"boolean",group:"Misc",defaultValue:true},resizable:{type:"boolean",group:"Dimension",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:e.Auto}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.m.IBar",multiple:false},subHeader:{type:"sap.m.IBar",multiple:false},beginButton:{type:"sap.m.Button",multiple:false},endButton:{type:"sap.m.Button",multiple:false},_popup:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}}}}});
f.prototype.init=function(){var t=this;this._bAppendedToUIArea=false;var s={resizable:t.getResizable(),titleAlignment:t.getTitleAlignment(),beforeOpen:function(E){t.fireBeforeOpen({openBy:E.getParameter('openBy')});},afterOpen:function(E){t.fireAfterOpen({openBy:E.getParameter('openBy')});},beforeClose:function(E){t.fireBeforeClose({openBy:E.getParameter('openBy'),origin:E.getParameter('origin')});},afterClose:function(E){t.fireAfterClose({openBy:E.getParameter('openBy'),origin:E.getParameter('origin')});}};if(a.system.phone){this._aNotSupportedProperties=["placement","modal","offsetX","offsetY","showCloseButton"];s.stretch=true;s.type=c.Standard;s.titleAlignment=this.getTitleAlignment();this._oControl=new D(this.getId()+"-dialog",s);}else{this._aNotSupportedProperties=["icon","showCloseButton"];this._oControl=new P(this.getId()+"-popover",s);}this.setAggregation("_popup",this._oControl);this._oControl.addStyleClass("sapMResponsivePopover");this._oDelegate={onBeforeRendering:function(){var S=this.getShowCloseButton(),h=this._oControl._getAnyHeader(),n,p,r;if(!S||!a.system.phone){this._removeCloseButton(h);return;}if(!this._bContentChanged){return;}this._bContentChanged=false;if(h){this._insertCloseButton(h);}else{n=this._getSingleNavContent();if(!n){return;}p=n.getCurrentPage();r=this._getRealPage(p);if(r&&(h=r._getAnyHeader())){this._insertCloseButton(h);}n.attachEvent("navigate",this._fnOnNavigate,this);}if(this._oControl&&this._oControl.setTitleAlignment){this._oControl.setTitleAlignment(this.getTitleAlignment());}}};this._oPageDelegate={onAfterShow:function(){var r=t._getRealPage(this),h;if(r&&(h=r._getAnyHeader())){t._insertCloseButton(h);}}};this._fnOnNavigate=function(E){var p=E.getParameter("to");if(p){p.addEventDelegate(this._oPageDelegate,p);}};this._oControl.addEventDelegate(this._oDelegate,this);this._oControl._removeChild=function(o,A,S){var p,i;if((A==="content")&&(o instanceof sap.m.NavContainer)){p=o.getPages();for(i=0;i<p.length;i++){p[i].removeEventDelegate(t._oPageDelegate);}o.detachEvent("navigate",t._fnOnNavigate,t);}C.prototype._removeChild.apply(this,arguments);};};
f.prototype.openBy=function(p){if(!this._bAppendedToUIArea&&!this.getParent()){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.addContent(this,true);this._bAppendedToUIArea=true;}if(a.system.phone){return this._oControl.open();}else{return this._oControl.openBy(p);}};
f.prototype.exit=function(){if(this._oCloseButton){this._oCloseButton.destroy();this._oCloseButton=null;}if(this._oControl){this._oControl.removeEventDelegate(this._oDelegate);this._oControl.destroy();this._oControl=null;}};
f.prototype._getCloseButton=function(){if(!this._oCloseButton){var t=this;this._oCloseButton=new B(this.getId()+"-closeButton",{icon:I.getIconURI("decline"),press:function(){t._oControl._oCloseTrigger=this;t.close();}});}return this._oCloseButton;};
f.prototype.addContent=function(o){this._bContentChanged=true;this.addAggregation("content",o);return this;};
f.prototype.clone=function(){var o=C.prototype.clone.apply(this,arguments),g=this.getAggregation('_popup').getContent();for(var i=0;i<g.length;i++){o.addContent(g[i].clone());}return o;};
f.prototype._getSingleNavContent=function(){var g=this.getContent();while(g.length===1&&g[0]instanceof sap.ui.core.mvc.View){g=g[0].getContent();}if(g.length===1&&g[0]instanceof sap.m.NavContainer){return g[0];}else{return null;}};
f.prototype._getRealPage=function(p){var r=p,g;while(r){if(r instanceof sap.m.Page){return r;}if(r instanceof sap.ui.core.mvc.View){g=r.getContent();if(g.length===1){r=g[0];continue;}}r=null;}return r;};
f.prototype._insertCloseButton=function(h){var o=this._getCloseButton(),i;if(h&&h.addContentRight){i=h.getAggregation("contentRight",[]).length;h.insertAggregation("contentRight",o,i);}};
f.prototype._removeCloseButton=function(h){var o=this._getCloseButton();if(h){h.removeAggregation("contentRight",o);}};
f.prototype._firstLetterUpperCase=function(v){return v.charAt(0).toUpperCase()+v.slice(1);};
f.prototype._lastIndexOfUpperCaseLetter=function(v){var i,s;for(i=v.length-1;i>=0;i--){s=v.charAt(i);if(s===s.toUpperCase()){return i;}}return-1;};
f.prototype.setProperty=function(p,v,s){C.prototype.setProperty.call(this,p,v,true);var S="set"+this._firstLetterUpperCase(p);if(this._aNotSupportedProperties.indexOf(p)===-1&&S in this._oControl){this._oControl[S](v);}return this;};
f.prototype.setModel=function(m,n){this._oControl.setModel(m,n);return C.prototype.setModel.call(this,m,n);};
f.prototype._createButtonFooter=function(){if(this._oFooter){return this._oFooter;}this._oFooter=new T(this.getId()+"-footer",{content:[new b()]});return this._oFooter;};
f.prototype._getButtonFooter=function(){return a.system.phone?this._oControl._getToolbar():this._oControl.getFooter();};
f.prototype._getPopup=function(){return this._oControl.oPopup;};
f.prototype._setButton=function(p,o){if(this._oControl instanceof P){var g="get"+this._firstLetterUpperCase(p)+"Button",O=this[g](),F=this._createButtonFooter(),s="_o"+this._firstLetterUpperCase(p)+"Button",i=(p.toLowerCase()==="begin"?0:1),h=(p.toLowerCase()==="begin"?"getEndButton":"getBeginButton");if(O){F.removeContent(O);}if(o){if(!F.getParent()){this._oControl.setFooter(F);}F.insertContent(o,i+1);}else{var j=this[h]();if(!j){F.destroy();this._oFooter=null;}}this[s]=o;return this;}else{var A=p.toLowerCase()+"Button";return this.setAggregation(A,o);}};
f.prototype._getButton=function(p){if(this._oControl instanceof P){var s="_o"+this._firstLetterUpperCase(p)+"Button";return this[s];}else{var g="get"+this._firstLetterUpperCase(p)+"Button";return this._oControl[g]();}};
f.prototype.setBeginButton=function(o){this._oControl.setBeginButton(o);return this._setButton("begin",o);};
f.prototype.setEndButton=function(o){this._oControl.setEndButton(o);return this._setButton("end",o);};
f.prototype.setShowCloseButton=function(s){var h=this._oControl._getAnyHeader();if(s){this._insertCloseButton(h);}else{this._removeCloseButton(h);}this.setProperty("showCloseButton",s,true);return this;};
f.prototype.getBeginButton=function(){return this._getButton("begin");};
f.prototype.getEndButton=function(){return this._getButton("end");};
["bindAggregation","validateAggregation","setAggregation","getAggregation","indexOfAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation","setAssociation","getAssociation","addAssociation","removeAssociation","removeAllAssociation"].forEach(function(n){f.prototype[n]=function(){var L=this._lastIndexOfUpperCaseLetter(n),m,r;if(typeof arguments[0]==="string"){if(L!==-1){m=n.substring(0,L)+this._firstLetterUpperCase(arguments[0]);if(this._oControl&&this._oControl[m]){r=this._oControl[m].apply(this._oControl,Array.prototype.slice.call(arguments,1));return r===this._oControl?this:r;}else{return C.prototype[n].apply(this,arguments);}}}r=this._oControl[n].apply(this._oControl,arguments);return r===this._oControl?this:r;};});["invalidate","close","isOpen","addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getDomRef","setBusy","getBusy","setBusyIndicatorDelay","getBusyIndicatorDelay","addEventDelegate","removeEventDelegate","_setAriaModal","_setAriaRoleApplication"].forEach(function(n){f.prototype[n]=function(){if(this._oControl&&this._oControl[n]){if(n==="invalidate"&&arguments[0]===this._oControl){return C.prototype.invalidate.apply(this,arguments);}var r=this._oControl[n].apply(this._oControl,arguments);return r===this._oControl?this:r;}};});
f.prototype._applyContextualSettings=function(){C.prototype._applyContextualSettings.call(this);};
return f;});
sap.ui.predefine('sap/m/ResponsivePopoverRenderer',[],function(){"use strict";var R={apiVersion:2};
R.render=function(r,c){};
return R;},true);
sap.ui.predefine('sap/m/ResponsiveScale',['./library','./SliderUtilities','sap/ui/core/Element'],function(l,S,E){"use strict";
var a=E.extend("sap.m.ResponsiveScale",{metadata:{interfaces:["sap.m.IScale"],library:"sap.m",properties:{tickmarksBetweenLabels:{type:"int",group:"Appearance",defaultValue:0}}}});
a.prototype.calcNumberOfTickmarks=function(s,f,t){var m=Math.floor(s/f)+1;m=t&&(m>t)?this._runStepsOptimization(t,m-1):m;return Math.floor(m);};
a.prototype._runStepsOptimization=function(t,m){var s=m/t;while((t>1)&&(s%1!==0)){t--;s=m/t;}return t;};
a.prototype.getHiddenTickmarksLabels=function(s,t,o,L){var j,c,h=new Array(t),i=Math.ceil(1/(o/L)),C=function(p){return p<<1;};if(i===1){return h;}i--;i|=i>>1;i|=i>>2;i|=i>>4;i|=i>>8;i|=i>>16;i++;i=i>>1;j=C(i);while(i){c=i;while(c<((t/2)+j)){h[c]=true;h[t-c-1]=true;c+=j;}i=i>>1;j=C(i);}return h;};
a.prototype.handleResize=function(e){var L,o,O,h,s,$=e.control.$(),t=$.find(".sapMSliderTick"),i=$.find(".sapMSliderTickmarks").width(),b=(i/t.length)>=S.CONSTANTS.TICKMARKS.MIN_SIZE.SMALL;t.css("visibility",b?'':'hidden');L=$.find(".sapMSliderTickLabel");o=parseFloat(L[1].style.left);O=i*o/100;h=this.getHiddenTickmarksLabels(i,L.length,O,S.CONSTANTS.TICKMARKS.MIN_SIZE.WITH_LABEL);L.each(function(I,c){s=c.nextSibling||c.previousSibling||{style:{visibility:null}};if(h[I]&&!b){c.style.display="none";s.style.visibility='hidden';}else{c.style.display="";s.style.visibility='';}});};
return a;});
sap.ui.predefine('sap/m/ScrollBar',['sap/ui/core/Control',"./ScrollBarRenderer"],function(C,S){"use strict";
var a=C.extend("sap.m.ScrollBar",{metadata:{library:"sap.m",properties:{scrollPosition:{type:"int",group:"Behavior",defaultValue:0},contentSize:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},events:{scroll:{}}}});
a.prototype.init=function(){this._onScrollHandler=this._onscroll.bind(this);};
a.prototype.onBeforeRendering=function(){if(this._$ScrollRef&&this._$ScrollRef.length){this._$ScrollRef.off("scroll",this._onScrollHandler);this._$ScrollRef=null;}};
a.prototype.onAfterRendering=function(){this._$ScrollRef=this.$("sb");this._$ScrollRef.on("scroll",this._onScrollHandler);this._setScrollPosition(this.getScrollPosition());};
a.prototype.onThemeChanged=function(){this.invalidate();};
a.prototype.setScrollPosition=function(s){var p=Math.round(Math.max(s,0));this._setScrollPosition(p);return this.setProperty("scrollPosition",p,true);};
a.prototype.setContentSize=function(c){var s=this.$("sbcnt");if(s.length){s.height(c);}return this.setProperty("contentSize",c);};
a.prototype._onscroll=function(e){var s=Math.abs(Math.round(this._$ScrollRef.scrollTop()));this.setProperty("scrollPosition",s,true);this.fireScroll({pos:s});e.preventDefault();e.stopPropagation();return false;};
a.prototype._setScrollPosition=function(s){if(this._$ScrollRef&&this._$ScrollRef.length){this._$ScrollRef.scrollTop(s);}};
return a;});
sap.ui.predefine('sap/m/ScrollBarRenderer',['sap/ui/Device',"sap/ui/dom/getScrollbarSize"],function(D,g){"use strict";var S={apiVersion:2};
S.render=function(r,c){var s="sapMScrollBarTouch",C=c.getContentSize(),a=c.getId(),d=D.support.touch;r.openStart("div",c);r.class("sapMScrollBarOuterDiv");if(d){r.class(s);}r.openEnd();r.openStart("div",a+"-sb");r.class("sapMScrollBarInnerDiv");r.openEnd();r.openStart("div",a+"-sbcnt");r.style("width","0.75rem");r.style("height",C);r.openEnd();r.close("div");r.close("div");r.openStart("div");r.openEnd();r.openStart("span",a+"-ffsize");r.class("sapMScrollBarDistantSpan");r.openEnd();r.close("span");r.close("div");r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/ScrollContainer',["./library","sap/ui/core/Control","sap/ui/core/delegate/ScrollEnablement","sap/ui/core/Element","./ScrollContainerRenderer","sap/ui/dom/denormalizeScrollBeginRTL"],function(l,C,S,E,a,d){"use strict";
var b=C.extend("sap.m.ScrollContainer",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},horizontal:{type:"boolean",group:"Behavior",defaultValue:true},vertical:{type:"boolean",group:"Behavior",defaultValue:false},focusable:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/ScrollContainer.designtime"}});
b.prototype.init=function(){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:true,vertical:false});};
b.prototype.onBeforeRendering=function(){this._oScroller.setHorizontal(this.getHorizontal());this._oScroller.setVertical(this.getVertical());};
b.prototype.exit=function(){if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}};
b.prototype.getScrollDelegate=function(){return this._oScroller;};
b.prototype.scrollTo=function(x,y,t){if(this._oScroller){var D=this.getDomRef();if(D){if(sap.ui.getCore().getConfiguration().getRTL()){x=d(x,D);}this._oScroller.scrollTo(x,y,t);}else{this._oScroller._scrollX=x;this._oScroller._scrollY=y;}}return this;};
b.prototype.scrollToElement=function(e,t){if(e instanceof E){e=e.getDomRef();}if(this._oScroller){this._oScroller.scrollToElement(e,t);}return this;};
return b;});
sap.ui.predefine('sap/m/ScrollContainerRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,c){r.openStart("div",c).style("width",c.getWidth()).style("height",c.getHeight());if(c.getVertical()){if(!c.getHorizontal()){r.class("sapMScrollContV");}else{r.class("sapMScrollContVH");}}else{r.class("sapMScrollContH");}r.class("sapMScrollCont");var t=c.getTooltip_AsString();if(t){r.attr("title",t);}if(c.getFocusable()){r.attr("tabindex","0");}r.openEnd();r.openStart("div",c.getId()+"-scroll").class("sapMScrollContScroll").openEnd();var C=c.getContent(),l=C.length;for(var i=0;i<l;i++){r.renderControl(C[i]);}r.close("div");r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/SearchField',['./library','sap/ui/core/Control','sap/ui/core/Core','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','./Suggest','sap/ui/Device','./SearchFieldRenderer',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos"],function(l,C,a,E,I,S,D,b,K,q){"use strict";
var c=C.extend("sap.m.SearchField",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.f.IShellBar"],library:"sap.m",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},visible:{type:"boolean",group:"Appearance",defaultValue:true},maxLength:{type:"int",group:"Behavior",defaultValue:0},placeholder:{type:"string",group:"Misc",defaultValue:null},showMagnifier:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},showRefreshButton:{type:"boolean",group:"Behavior",defaultValue:false},refreshButtonTooltip:{type:"string",group:"Misc",defaultValue:null},showSearchButton:{type:"boolean",group:"Behavior",defaultValue:true},enableSuggestions:{type:"boolean",group:"Behavior",defaultValue:false},selectOnFocus:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},defaultAggregation:"suggestionItems",designtime:"sap/m/designtime/SearchField.designtime",aggregations:{suggestionItems:{type:"sap.m.SuggestionItem",multiple:true,singularName:"suggestionItem"}},events:{search:{parameters:{query:{type:"string"},suggestionItem:{type:"sap.m.SuggestionItem"},refreshButtonPressed:{type:"boolean"},clearButtonPressed:{type:"boolean"}}},change:{parameters:{value:{type:"string"}}},liveChange:{parameters:{newValue:{type:"string"}}},suggest:{parameters:{suggestValue:{type:"string"}}}}}});
E.call(c.prototype);I.insertFontFaceStyle();
c.prototype.init=function(){this._lastValue="";};
c.prototype.getFocusDomRef=function(){return this.getInputElement();};
c.prototype.getFocusInfo=function(){var F=C.prototype.getFocusInfo.call(this),i=this.getDomRef("I");if(i){q.extend(F,{cursorPos:q(i).cursorPos()});}return F;};
c.prototype.applyFocusInfo=function(F){C.prototype.applyFocusInfo.call(this,F);if("cursorPos"in F){this.$("I").cursorPos(F.cursorPos);}return this;};
c.prototype.getWidth=function(){return this.getProperty("width")||"100%";};
c.prototype.getInputElement=function(){return this.getDomRef("I");};
c.prototype.onBeforeRendering=function(){this._unregisterEventListeners();this._updateTranslations();u(this);};
c.prototype.onAfterRendering=function(){this._lastValue=this.getValue();this._setToolTips();var i=this.getInputElement();this._resetElement=this.getDomRef("reset");q(i).on("input",this.onInput.bind(this)).on("search",this.onSearch.bind(this)).on("change",this.onChange.bind(this)).on("focus",this.onFocus.bind(this)).on("blur",this.onBlur.bind(this));q(this.getDomRef("F")).on("click",this.onFormClick.bind(this)).on("submit",function(e){e.preventDefault();});if(D.system.desktop||D.system.combi){this.$().on("touchstart mousedown",this.onButtonPress.bind(this));if(D.browser.firefox){this.$().find(".sapMSFB").on("mouseup mouseout",function(e){q(e.target).removeClass("sapMSFBA");});}}if(!a.isThemeApplied()){a.attachThemeChanged(this._handleThemeLoad,this);}};
c.prototype._handleThemeLoad=function(){if(this._oSuggest){this._oSuggest.setPopoverMinWidth();}a.detachThemeChanged(this._handleThemeLoad,this);};
c.prototype._updateTranslations=function(){var r=a.getLibraryResourceBundle("sap.m");b.oSearchFieldToolTips={SEARCH_BUTTON_TOOLTIP:r.getText("SEARCHFIELD_SEARCH_BUTTON_TOOLTIP"),RESET_BUTTON_TOOLTIP:r.getText("SEARCHFIELD_RESET_BUTTON_TOOLTIP"),REFRESH_BUTTON_TOOLTIP:r.getText("SEARCHFIELD_REFRESH_BUTTON_TOOLTIP")};};
c.prototype.clear=function(O){var v=O&&O.value||"";if(!this.getInputElement()||this.getValue()===v){return;}this._updateValue(v);u(this);this.fireLiveChange({newValue:v});this._fireChangeEvent();this.fireSearch({query:v,refreshButtonPressed:false,clearButtonPressed:!!(O&&O.clearButton)});};
c.prototype.exit=function(){this._unregisterEventListeners();if(this._oSuggest){this._oSuggest.destroy(true);this._oSuggest=null;}};
c.prototype.onButtonPress=function(e){if(e.originalEvent.button===2){return;}var i=this.getInputElement();if(document.activeElement===i&&e.target!==i){e.preventDefault();}if(D.browser.firefox){var g=q(e.target);if(g.hasClass("sapMSFB")){g.addClass("sapMSFBA");}}};
c.prototype.ontouchstart=function(e){this._oTouchStartTarget=e.target;};
c.prototype.ontouchend=function(e){if(e.originalEvent.button===2){return;}var g=e.target,v=true,i=this.getInputElement();if(this._oTouchStartTarget){v=this._oTouchStartTarget===g;this._oTouchStartTarget=null;}if(g.id==this.getId()+"-reset"&&v){d(this);this._bSuggestionSuppressed=true;var h=!this.getValue();var j=document.activeElement;if((D.system.desktop||h||/(INPUT|TEXTAREA)/i.test(j.tagName)||j===this._resetElement)&&(j!==i)){i.focus();}this.clear({clearButton:true});}else if(g.id==this.getId()+"-search"&&v){d(this);if(D.system.desktop&&!this.getShowRefreshButton()&&(document.activeElement!==i)){i.focus();}this._fireChangeEvent();this.fireSearch({query:this.getValue(),refreshButtonPressed:!!(this.getShowRefreshButton()&&!this.hasStyleClass("sapMFocus")),clearButtonPressed:false});}else{this.onmouseup(e);}};
c.prototype.onmouseup=function(e){if(D.system.phone&&this.getEnabled()&&e.target.tagName=="INPUT"&&document.activeElement===e.target&&!f(this)){this.onFocus(e);}};
c.prototype.onFormClick=function(e){if(this.getEnabled()&&e.target.tagName=="FORM"){this.getInputElement().focus();}};
c.prototype.onSearch=function(e){var v=this.getInputElement().value;this._updateValue(v);this._fireChangeEvent();this.fireSearch({query:v,refreshButtonPressed:false,clearButtonPressed:false});if(!D.system.desktop){this._blur();}};
c.prototype._blur=function(){var t=this;window.setTimeout(function(){var i=t.getInputElement();if(i){i.blur();}},13);};
c.prototype.onChange=function(e){this._fireChangeEvent();};
c.prototype.onsapfocusleave=function(e){this._fireChangeEvent();};
c.prototype._fireChangeEvent=function(){var v=this.getInputElement().value;if(this._lastValue===v){return;}this._lastValue=v;this.fireChange({value:v});};
c.prototype.onInput=function(){var v=this.getInputElement().value;this._updateValue(v);this.fireLiveChange({newValue:v});if(this.getEnableSuggestions()){if(this._iSuggestDelay){clearTimeout(this._iSuggestDelay);}this._iSuggestDelay=setTimeout(function(){this.fireSuggest({suggestValue:v});u(this);this._iSuggestDelay=null;}.bind(this),400);}};
c.prototype.onkeydown=function(e){var g;var h;var v;switch(e.which){case K.F5:case K.ENTER:this.$("search").toggleClass("sapMSFBA",true);e.stopPropagation();e.preventDefault();if(f(this)){d(this);if((g=this._oSuggest.getSelected())>=0){h=this.getSuggestionItems()[g];this._updateValue(h.getSuggestionText());}}this._fireChangeEvent();this.fireSearch({query:this.getValue(),suggestionItem:h,refreshButtonPressed:this.getShowRefreshButton()&&e.which===K.F5,clearButtonPressed:false});break;case K.ESCAPE:if(f(this)){d(this);e.setMarked();}else{v=this.getValue();if(v===this._sOriginalValue){this._sOriginalValue="";}this.clear({value:this._sOriginalValue});if(v!==this.getValue()){e.setMarked();}}e.preventDefault();break;}};
c.prototype.onkeyup=function(e){if(e.which===K.F5||e.which===K.ENTER){this.$("search").toggleClass("sapMSFBA",false);}};
c.prototype.onFocus=function(e){this.addStyleClass("sapMFocus");this._sOriginalValue=this.getValue();if(this.getEnableSuggestions()){if(!this._bSuggestionSuppressed){this.fireSuggest({suggestValue:this.getValue()});}else{this._bSuggestionSuppressed=false;}}this._setToolTips(e.type);};
c.prototype.onBlur=function(e){this.removeStyleClass("sapMFocus");if(this._bSuggestionSuppressed){this._bSuggestionSuppressed=false;}this._setToolTips(e.type);};
c.prototype._setToolTips=function(t){var $=this.$("search"),e=this.$("reset");if(this.getShowRefreshButton()){if(t==="focus"){$.attr("title",b.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP);}else if(t==="blur"){var r=this.getRefreshButtonTooltip(),T=r===""?b.oSearchFieldToolTips.REFRESH_BUTTON_TOOLTIP:r;if(T){$.attr("title",T);}}}if(this.getValue()===""){e.attr("title",b.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP);}else{e.attr("title",b.oSearchFieldToolTips.RESET_BUTTON_TOOLTIP);}};
c.prototype._updateValue=function(v){v=v||"";var i=this.getInputElement();if(i){if(i.value!==v){i.value=v;}var $=this.$();if($.hasClass("sapMSFVal")==!v){$.toggleClass("sapMSFVal",!!v);}}this.setProperty("value",v,true);this._setToolTips();return this;};
c.prototype._unregisterEventListeners=function(){var i=this.getInputElement();if(i){this.$().find(".sapMSFB").off();this.$().off();q(this.getDomRef("F")).off();q(i).off();}};
c.prototype.onsapshow=function(e){if(this.getEnableSuggestions()){if(f(this)){d(this);}else{this.fireSuggest({suggestValue:this.getValue()});}}};
c.prototype.onsaphide=function(e){this.suggest(false);};
function s(e,g,i,r){var h;if(f(e)){h=e._oSuggest.setSelected(i,r);if(h>=0){e._updateValue(e.getSuggestionItems()[h].getSuggestionText());}g.preventDefault();}}
c.prototype.onsapdown=function(e){s(this,e,1,true);};
c.prototype.onsapup=function(e){s(this,e,-1,true);};
c.prototype.onsaphome=function(e){s(this,e,0,false);};
c.prototype.onsapend=function(e){var L=this.getSuggestionItems().length-1;s(this,e,L,false);};
c.prototype.onsappagedown=function(e){s(this,e,10,true);};
c.prototype.onsappageup=function(e){s(this,e,-10,true);};
c.prototype._applySuggestionAcc=function(){var A="",n=this.getSuggestionItems().length,r=a.getLibraryResourceBundle("sap.m");if(n===1){A=r.getText("INPUT_SUGGESTIONS_ONE_HIT");}else if(n>1){A=r.getText("INPUT_SUGGESTIONS_MORE_HITS",n);}else{A=r.getText("INPUT_SUGGESTIONS_NO_HIT");}this.$("SuggDescr").text(A);};
c.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("F");};
function d(e){e._oSuggest&&e._oSuggest.close();}
function o(e){if(e.getEnableSuggestions()){if(!e._oSuggest){e._oSuggest=new S(e);}e._oSuggest.open();}}
function f(e){return e._oSuggest&&e._oSuggest.isOpen();}
c.prototype.suggest=function(e){if(this.getEnableSuggestions()){e=e===undefined||!!e;if(e&&(this.getSuggestionItems().length||D.system.phone)){o(this);}else{d(this);}}return this;};
function u(e){e._oSuggest&&e._oSuggest.update();}
return c;});
sap.ui.predefine('sap/m/SearchFieldRenderer',["sap/ui/Device","sap/ui/core/Core","sap/ui/core/InvisibleText","sap/ui/core/library"],function(D,C,I,c){"use strict";var H=c.aria.HasPopup;var S={apiVersion:2};
S.render=function(r,s){if(!s.getVisible()){return;}var p=s.getPlaceholder()||C.getLibraryResourceBundle("sap.m").getText("FACETFILTER_SEARCH",true),v=s.getValue(),w=s.getProperty("width"),i=s.getId(),b=s.getShowRefreshButton(),a=s.getShowSearchButton(),A={describedby:{value:S._getDescribedBy(s),append:true}},t,R=s.getRefreshButtonTooltip(),d;r.openStart("div",s).class("sapMSF");if(w){r.style("width",w);}if(v){r.class("sapMSFVal");}if(!s.getEnabled()){r.class("sapMSFDisabled");}r.openEnd();r.openStart('form',i+"-F").class('sapMSFF');if(!a){r.class("sapMSFNS");}else if(b){r.class('sapMSFReload');}r.openEnd();r.voidStart('input',i+"-I").class("sapMSFI").attr("type","search").attr("autocomplete","off");if(s.getEnableSuggestions()){r.attr("aria-haspopup",H.ListBox.toLowerCase());}if(D.browser.safari){r.attr("autocorrect","off");}var T=s.getTooltip_AsString();if(T){r.attr("title",T);}if(s.getEnableSuggestions()&&D.system.phone){r.attr("inputmode","none");}if(!s.getEnabled()){r.attr("disabled","disabled");}if(p){r.attr("placeholder",p);}if(s.getMaxLength()){r.attr("maxLength",s.getMaxLength());}r.attr("value",v);A.disabled=null;r.accessibilityState(s,A);r.voidEnd();if(s.getEnabled()){r.openStart("div",i+"-reset").class("sapMSFR").class("sapMSFB").attr("aria-hidden",true);d=v===""?this.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP:this.oSearchFieldToolTips.RESET_BUTTON_TOOLTIP;r.attr("title",d);if(D.browser.firefox){r.class("sapMSFBF");}if(!a){r.class("sapMSFNS");}r.openEnd().close("div");if(a){r.openStart("div",i+"-search").class("sapMSFS").class("sapMSFB").attr("aria-hidden",true);if(D.browser.firefox){r.class("sapMSFBF");}if(b){t=R===""?this.oSearchFieldToolTips.REFRESH_BUTTON_TOOLTIP:R;}else{t=this.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP;}r.attr("title",t).openEnd().close("div");}}r.close("form");if(s.getEnableSuggestions()){r.openStart("span",i+"-SuggDescr").class("sapUiPseudoInvisibleText").attr("role","status").attr("aria-live","polite").openEnd().close("span");}r.close("div");};
S._getDescribedBy=function(s){var d=I.getStaticId("sap.m","SEARCHFIELD_ARIA_DESCRIBEDBY");if(s.getEnabled()&&s.getShowRefreshButton()){d+=" "+I.getStaticId("sap.m","SEARCHFIELD_ARIA_F5");}return d;};
return S;},true);
sap.ui.predefine('sap/m/SegmentedButton',['./library','./Button','./Select','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/delegate/ItemNavigation','sap/ui/core/ResizeHandler','sap/ui/core/ListItem','sap/ui/core/IconPool','./SegmentedButtonRenderer'],function(l,B,S,C,E,I,R,L,a,c){"use strict";
var d=C.extend("sap.m.SegmentedButton",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.m.IOverflowToolbarContent"],library:"sap.m",designtime:"sap/m/designtime/SegmentedButton.designtime",publicMethods:["createButton"],properties:{width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:"",bindable:"bindable"}},defaultAggregation:"buttons",aggregations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button",deprecated:true},items:{type:"sap.m.SegmentedButtonItem",multiple:true,singularName:"item",bindable:"bindable"},_select:{type:"sap.m.Select",multiple:false,visibility:"hidden"}},associations:{selectedButton:{deprecated:true,type:"sap.m.Button",multiple:false},selectedItem:{type:"sap.m.SegmentedButtonItem",multiple:false},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{deprecated:true,parameters:{button:{type:"sap.m.Button"},id:{type:"string"},key:{type:"string"}}},selectionChange:{parameters:{item:{type:"sap.m.SegmentedButtonItem"}}}},dnd:{draggable:true,droppable:false}}});
E.call(d.prototype);
d.prototype.init=function(){this._aWidths=[];this._oItemNavigation=new I();this._oItemNavigation.setCycling(false);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});this.addDelegate(this._oItemNavigation);this.removeButton=function(b){var r=d.prototype.removeButton.call(this,b);this.setSelectedButton(this.getButtons()[0]);this._fireChangeEvent();return r;};};
d.prototype.onBeforeRendering=function(){var b=this._getVisibleButtons();this._bCustomButtonWidth=b.some(function(o){return o.getWidth();});if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this.setSelectedKey(this.getProperty("selectedKey"));if(!this.getSelectedButton()){this._selectDefaultButton();}};
d.prototype.onAfterRendering=function(){var b=this._getVisibleButtons(),p;if(!this._sResizeListenerId){p=this.getDomRef().parentNode;if(p){this._sResizeListenerId=R.register(p,this._handleContainerResize.bind(this));}}this._setItemNavigation();this._aWidths=this._getRenderedButtonWidths(b);this._updateWidth();};
d.prototype._handleContainerResize=function(){var b=this._getVisibleButtons();this._clearAutoWidthAppliedToControl();this._aWidths=this._getRenderedButtonWidths(b);this._updateWidth();};
d.prototype._clearAutoWidthAppliedToControl=function(){var b=this._getVisibleButtons(),e=b.length,o,i=0;if(!this.getWidth()){this.$().css("width","");}while(i<e){o=b[i];if(!o.getWidth()){o.$().css("width","");}i++;}};
d.prototype._getRenderedButtonWidths=function(b){return b.map(function(o){var e=o.getDomRef();return e&&e.getBoundingClientRect?e.getBoundingClientRect().width:o.$().outerWidth();});};
d.prototype._getButtonWidth=function(b){var e=b.length,w,n=0,s=0,f=0,p,P,i=0;if(this._bCustomButtonWidth){while(i<e){w=b[i].getWidth();if(w){if(w.indexOf("%")!==-1){s+=parseInt(w.slice(0,-1));}else{f+=parseInt(w.slice(0,-2));}}else{n++;}i++;}if(n===0){return false;}p=(100-s)/n;P=(f/n);if(p<0){p=0;}if(P<0){P=0;}if(P>0){return"calc("+p+"% - "+P+"px)";}else{return p+"%";}}else{return(100/e)+"%";}};
d.prototype._updateWidth=function(){if(this.$().length===0||this.hasStyleClass("sapMSegmentedButtonNoAutoWidth")){return;}var s=this.getWidth(),b=this._getVisibleButtons(),e=b.length,m=(this._aWidths.length>0)?Math.max.apply(Math,this._aWidths):0,f=(100/e),p=this.$().parent().innerWidth(),w=this._getButtonWidth(b),g,o,i;if(!s){if((m*e)>p){this.addStyleClass("sapMSegBFit");}else if(m>0){this.$().width((m*e)+1);this.removeStyleClass("sapMSegBFit");}i=0;while(i<e){o=b[i];o.$().css("width",o.getWidth()?o.getWidth():w);i++;}}else if(s&&!this._bCustomButtonWidth){i=0;while(i<e){b[i].$().css("width",f+"%");i++;}}g=Math.floor(this.getDomRef().getBoundingClientRect().width);if(this._previousWidth!==undefined&&g!==this._previousWidth&&!this._bInOverflow){this.fireEvent("_containerWidthChanged");}this._previousWidth=g;};
d.prototype.exit=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}this._bCustomButtonWidth=null;this._aWidths=null;};
d.prototype._setItemNavigation=function(){var b,D=this.getDomRef();if(D){this._oItemNavigation.setRootDomRef(D);b=this.$().find(".sapMSegBBtn:not(.sapMSegBBtnDis)");this._oItemNavigation.setItemDomRefs(b);this._focusSelectedButton();}};
d.prototype.getOverflowToolbarConfig=function(){return{canOverflow:true,listenForEvents:["select"],autoCloseEvents:["select"],propsUnrelatedToSize:["enabled","selectedKey"],invalidationEvents:["_containerWidthChanged"],onBeforeEnterOverflow:this._onBeforeEnterOverflow,onAfterExitOverflow:this._onAfterExitOverflow};};
d.prototype._onBeforeEnterOverflow=function(o){o._toSelectMode();};
d.prototype._onAfterExitOverflow=function(o){if(o._bForcedSelectMode){o._toSelectMode();}else{o._toNormalMode();}};
d.prototype.getFormDoNotAdjustWidth=function(){return true;};
d.prototype.createButton=function(t,u,e,T){var b=new B();if(t!==null){b.setText(t);}if(u!==null){b.setIcon(u);}if(e||e===undefined){b.setEnabled(true);}else{b.setEnabled(false);}if(T){b.setTextDirection(T);}this.addButton(b);return b;};
(function(){
d.prototype.addButton=function(b){if(b){p(b,this);this.addAggregation('buttons',b);this._syncSelect();this._fireChangeEvent();}return this;};
d.prototype.insertButton=function(b,i){if(b){p(b,this);this.insertAggregation('buttons',b,i);this._syncSelect();this._fireChangeEvent();}return this;};
function p(b,P){b.attachPress(function(e){P._buttonPressed(e);});b.attachEvent("_change",P._syncSelect,P);b.attachEvent("_change",P._fireChangeEvent,P);var o=B.prototype.setEnabled;b.setEnabled=function(e){b.$().toggleClass("sapMSegBBtnDis",!e).toggleClass("sapMFocusable",e);o.apply(b,arguments);};b.setVisible=function(v){B.prototype.setVisible.apply(this,arguments);P.invalidate();};}
})();
d.prototype.getSelectedKey=function(){var b=this.getButtons(),e=this.getItems(),s=this.getSelectedButton(),i=0;if(e.length>0){for(;i<b.length;i++){if(b[i]&&b[i].getId()===s){this.setProperty("selectedKey",e[i].getKey(),true);return e[i].getKey();}}}return"";};
d.prototype.setSelectedKey=function(k){var b=this.getButtons(),e=this.getItems(),i=0;if(!k){this.setProperty("selectedKey",k,true);return this;}if(e.length>0&&b.length>0){for(;i<e.length;i++){if(e[i]&&e[i].getKey()===k){this.setSelectedItem(e[i]);break;}}}this.setProperty("selectedKey",k,true);return this;};
d.prototype.removeButton=function(b){var r=this.removeAggregation("buttons",b);if(r){delete r.setEnabled;r.detachEvent("_change",this._syncSelect,this);r.detachEvent("_change",this._fireChangeEvent,this);this._syncSelect();}return r;};
d.prototype.removeAllButtons=function(){var b=this.getButtons();if(b){for(var i=0;i<b.length;i++){var o=b[i];if(o){delete o.setEnabled;this.removeAggregation("buttons",o);o.detachEvent("_change",this._syncSelect,this);o.detachEvent("_change",this._fireChangeEvent,this);}}this._syncSelect();}return b;};
d.prototype.addItem=function(i){this.addAggregation("items",i);this.addButton(i.oButton);return this;};
d.prototype.removeItem=function(i){var r;if(i!==null&&i!==undefined){r=this.removeAggregation("items",i);this.removeButton(i.oButton);}if(i&&i instanceof sap.m.SegmentedButtonItem&&this.getSelectedButton()===i.oButton.getId()){this.setSelectedKey("");this.setSelectedButton("");this.setSelectedItem("");}this.setSelectedItem(this.getItems()[0]);return r;};
d.prototype.insertItem=function(i,b){this.insertAggregation("items",i,b);this.insertButton(i.oButton,b);return this;};
d.prototype.removeAllItems=function(s){var r=this.removeAllAggregation("items",s);this.removeAllButtons();this.setSelectedKey("");this.setSelectedButton("");this.setSelectedItem("");return r;};
d.prototype._buttonPressed=function(e){var b=e.getSource(),i;if(this.getSelectedButton()!==b.getId()){this.getButtons().forEach(function(o){o.$().removeClass("sapMSegBBtnSel");o.$().attr("aria-selected",false);});i=this.getItems().filter(function(o){return o.oButton===b;})[0];b.$().addClass("sapMSegBBtnSel");b.$().attr("aria-selected",true);this.setAssociation('selectedButton',b,true);this.setProperty("selectedKey",this.getSelectedKey(),true);this.setAssociation('selectedItem',i,true);this.fireSelectionChange({item:i});this.fireSelect({button:b,id:b.getId(),key:this.getSelectedKey()});}};
d.prototype._selectDefaultButton=function(){var b=this._getVisibleButtons();if(b.length>0){this.setAssociation('selectedButton',b[0],true);if(this.getItems().length>0){this.setAssociation('selectedItem',this.getItems()[0],true);}}};
d.prototype.setSelectedButton=function(b){var s=this.getSelectedButton(),e=this.getButtons();this.setAssociation("selectedButton",b);if(s!==this.getSelectedButton()){if(!this.getSelectedButton()&&e.length>1){this._selectDefaultButton();}this._focusSelectedButton();}this._syncSelect();return this;};
d.prototype.setSelectedItem=function(i){var o=typeof i==="string"&&i!==""?sap.ui.getCore().byId(i):i,b=o instanceof sap.m.SegmentedButtonItem,v=b?o.oButton:i;this.setAssociation("selectedItem",i,true);this.setSelectedButton(v);return this;};
d.prototype._focusSelectedButton=function(){var b=this.getButtons(),s=this.getSelectedButton(),i=0;for(;i<b.length;i++){if(b[i]&&b[i].getId()===s){this._oItemNavigation&&this._oItemNavigation.setFocusedIndex(i);break;}}};
d.prototype.onsappagedown=function(e){this._oItemNavigation.onsapend(e);};
d.prototype.onsappageup=function(e){this._oItemNavigation.onsaphome(e);};
d.prototype.onsapspace=function(e){e.preventDefault();};
d.prototype._fnSelectFormFactory=function(){return new S(this.getId()+"-select").attachChange(this._selectChangeHandler,this).addStyleClass("sapMSegBSelectWrapper");};
d.prototype._selectChangeHandler=function(e){var s=e.getParameter("selectedItem"),n=parseInt(s.getKey()),b=this.getButtons()[n],f=b.getId();b.firePress();this.setSelectedButton(f);};
d.prototype._fireChangeEvent=function(){this.fireEvent("_change");};
d.prototype._syncSelect=function(){var k=0,s=0,b,e,o=this.getAggregation("_select");if(!o){return;}o.destroyItems();this._getVisibleButtons().forEach(function(f){b=f.getText();e=f.getIcon();o.addItem(new L({key:k.toString(),icon:e?e:"",text:b?b:f.getTooltip_AsString(),enabled:f.getEnabled()}));if(f.getId()===this.getSelectedButton()){s=k;}k++;},this);o.setSelectedKey(s.toString());};
d.prototype.getAccessibilityInfo=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s=this.getItems().find(function(i){return i.getId()===this.getSelectedItem();}.bind(this));return{role:"listbox",type:r.getText("SEGMENTEDBUTTON_NAME"),description:s.oButton.getAccessibilityInfo().description,focusable:this.getEnabled()};};
d.prototype._toSelectMode=function(){this._bInOverflow=true;this.addStyleClass("sapMSegBSelectWrapper");if(!this.getAggregation("_select")){this.setAggregation("_select",this._fnSelectFormFactory(),true);}this._syncSelect();this._syncAriaAssociations();};
d.prototype._toNormalMode=function(){delete this._bInOverflow;this.removeStyleClass("sapMSegBSelectWrapper");};
d.prototype._syncAriaAssociations=function(){var s=this.getAggregation("_select");this.getAriaLabelledBy().forEach(function(o){if(s.getAriaLabelledBy().indexOf(o)===-1){s.addAriaLabelledBy(o);}});this.getAriaDescribedBy().forEach(function(D){if(s.getAriaLabelledBy().indexOf(D)===-1){s.addAriaLabelledBy(D);}});};
d.prototype._overwriteImageOnload=function(i){var t=this;if(i.onload===sap.m.Image.prototype.onload){i.onload=function(){if(sap.m.Image.prototype.onload){sap.m.Image.prototype.onload.apply(this,arguments);}window.setTimeout(function(){t._updateWidth();},20);};}};
d.prototype._getIconAriaLabel=function(i){var o=a.getIconInfo(i.getSrc()),r="";if(o){r=o.text?o.text:o.name;}return r;};
d.prototype._getVisibleButtons=function(){return this.getButtons().filter(function(b){return b.getVisible();});};
d.prototype.clone=function(){var s=this.getSelectedButton(),e=this.removeAllAggregation("buttons"),o=C.prototype.clone.apply(this,arguments),f=e.map(function(b){return b.getId();}).indexOf(s),i;if(f>-1){o.setSelectedButton(o.getButtons()[f]);}for(i=0;i<e.length;i++){this.addAggregation("buttons",e[i]);}return o;};
return d;});
sap.ui.predefine('sap/m/SegmentedButtonItem',['./library','sap/ui/core/Item','sap/m/Button','sap/ui/core/CustomStyleClassSupport'],function(l,I,B,C){"use strict";
var S=I.extend("sap.m.SegmentedButtonItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},events:{press:{}}}});
C.apply(S.prototype);
S.prototype.init=function(){var b=new B(this.getId()+"-button");this.aCustomStyleClasses;this.mCustomStyleClassMap;b.aCustomStyleClasses=this.aCustomStyleClasses;b.mCustomStyleClassMap=this.mCustomStyleClassMap;b.getCustomData=this.getCustomData.bind(this);b.getLayoutData=this.getLayoutData.bind(this);b.firePress=function(){this.firePress();B.prototype.firePress.call(b);}.bind(this);this.getDomRef=b.getDomRef.bind(b);this.oButton=b;};
S.prototype.exit=function(){if(this.oButton){this.oButton.destroy();this.oButton=null;}};
S.prototype.setText=function(v){this.setProperty("text",v,true);if(this.oButton){this.oButton.setText(this.getText());}return this;};
S.prototype.setIcon=function(v){this.setProperty("icon",v,true);if(this.oButton){this.oButton.setIcon(this.getIcon());}return this;};
S.prototype.setEnabled=function(v){this.setProperty("enabled",v,true);if(this.oButton){this.oButton.setEnabled(this.getEnabled());}return this;};
S.prototype.setTextDirection=function(v){this.setProperty("textDirection",v,true);if(this.oButton){this.oButton.setTextDirection(this.getTextDirection());}return this;};
S.prototype.setVisible=function(v){this.setProperty("visible",v,true);if(this.oButton){this.oButton.setVisible(v);}return this;};
S.prototype.setWidth=function(v){this.setProperty("width",v,true);if(this.oButton){this.oButton.setWidth(this.getWidth());}return this;};
S.prototype.setTooltip=function(v){this.setAggregation("tooltip",v,true);if(this.oButton){this.oButton.setTooltip(v);}return this;};
return S;});
sap.ui.predefine('sap/m/SegmentedButtonRenderer',["sap/ui/core/library","sap/ui/core/InvisibleRenderer","sap/ui/core/InvisibleText"],function(c,I,a){"use strict";var T=c.TextDirection;var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");var S={apiVersion:2};
S.render=function(R,C){var b=C.getButtons(),v=b.filter(function(B){return B.getVisible();}),V=0,s=C.getSelectedButton(),B,t,d,e;if(C._bInOverflow){R.openStart("div",C);R.openEnd();R.renderControl(C.getAggregation("_select"));R.close("div");return;}R.openStart("ul",C);if(S._addAllIconsClass(b)){R.class("sapMSegBIcons");}R.class("sapMSegB");R.style('width',C.getWidth());t=C.getTooltip_AsString();if(t){R.attr("title",t);}R.accessibilityState(C,{role:"listbox",multiselectable:true,roledescription:r.getText("SEGMENTEDBUTTON_NAME"),describedby:{value:a.getStaticId("sap.m","SEGMENTEDBUTTON_SELECTION"),append:true}});R.openEnd();for(var i=0;i<b.length;i++){B=b[i];if(B.getVisible()){var f=B.getText(),o=B.getIcon(),g=B.getTooltip_AsString(),h="",k;++V;if(o){k=B._getImage((B.getId()+"-img"),o);if(k instanceof sap.m.Image){C._overwriteImageOnload(k);}}R.openStart("li",B);R.class("sapMSegBBtn");if(B.getId()===v[v.length-1].getId()){R.class("sapMSegBtnLastVisibleButton");}if(B.aCustomStyleClasses!==undefined&&B.aCustomStyleClasses instanceof Array){for(var j=0;j<B.aCustomStyleClasses.length;j++){R.class(B.aCustomStyleClasses[j]);}}if(B.getEnabled()){R.class("sapMSegBBtnFocusable");}else{R.class("sapMSegBBtnDis");}if(s===B.getId()){R.class("sapMSegBBtnSel");}if(o&&f!==''){R.class("sapMSegBBtnMixed");}d=B.getWidth();R.style('width',d);R.attr("tabindex",B.getEnabled()?"0":"-1");e=B.getTextDirection();if(e!==T.Inherit){R.attr("dir",e.toLowerCase());}if(k&&!f){h=C._getIconAriaLabel(k);g=g||h;}if(g){R.attr("title",g);}R.accessibilityState(B,{role:"option",roledescription:r.getText("SEGMENTEDBUTTON_BUTTONS_NAME"),label:f?"":g,posinset:V,setsize:v.length,selected:s===B.getId()});R.openEnd();R.openStart("div");R.class("sapMSegBBtnInnerWrapper");R.openEnd();R.openStart("div");R.class("sapMSegBBtnInner");R.openEnd();if(o&&k){R.renderControl(k);}if(f!==''){R.text(f);}R.close("div");R.close("div");R.close("li");}else{I.render(R,B,"li");}}R.close("ul");};
S._addAllIconsClass=function(b){for(var i=0;i<b.length;i++){if(!b[i].getIcon()){return false;}}return true;};
return S;},true);
sap.ui.predefine('sap/m/Select',['./Dialog','./Popover','./SelectList','./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/LabelEnablement','sap/ui/core/Icon','sap/ui/core/IconPool','./Button','./Bar','./Title','./delegate/ValueStateMessage','sap/ui/core/message/MessageMixin','sap/ui/core/library','sap/ui/core/Item','sap/ui/Device','sap/ui/core/InvisibleText','./SelectRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes",'./Text','sap/m/SimpleFixFlex','sap/base/Log','sap/ui/core/ValueStateSupport',"sap/ui/core/InvisibleMessage"],function(D,P,S,l,C,a,E,L,I,b,B,c,T,V,M,d,f,g,h,j,k,K,m,n,o,p,q){"use strict";var r=l.SelectListKeyboardNavigationMode;var s=l.PlacementType;var t=d.ValueState;var u=d.TextDirection;var v=d.TextAlign;var w=l.SelectType;var x=d.InvisibleMessageMode;
var y=a.extend("sap.m.Select",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.m.IOverflowToolbarContent","sap.f.IShellBar","sap.ui.core.ISemanticFormContent"],library:"sap.m",properties:{name:{type:"string",group:"Misc",defaultValue:""},enabled:{type:"boolean",group:"Behavior",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},type:{type:"sap.m.SelectType",group:"Appearance",defaultValue:w.Default},autoAdjustWidth:{type:"boolean",group:"Appearance",defaultValue:false},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:v.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:u.Inherit},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:t.None},valueStateText:{type:"string",group:"Misc",defaultValue:""},showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false},resetOnMissingKey:{type:"boolean",group:"Behavior",defaultValue:false},forceSelection:{type:"boolean",group:"Behavior",defaultValue:true},wrapItemsText:{type:"boolean",group:"Behavior",defaultValue:false},columnRatio:{type:"sap.m.SelectColumnRatio",group:"Appearance",defaultValue:"3:2"},required:{type:"boolean",group:"Misc",defaultValue:false}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable",forwarding:{getter:"getList",aggregation:"items"}},picker:{type:"sap.ui.core.PopupInterface",multiple:false,visibility:"hidden"},_valueIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_pickerHeader:{type:"sap.m.Bar",multiple:false,visibility:"hidden"},_pickerValueStateContent:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{selectedItem:{type:"sap.ui.core.Item"},previousSelectedItem:{type:"sap.ui.core.Item"}}}},designtime:"sap/m/designtime/Select.designtime"}});
b.insertFontFaceStyle();E.apply(y.prototype,[true]);M.call(y.prototype);
function H(i){if(this._isIconOnly()&&!this.isOpen()){return;}if(i){this.setSelection(i);this.setValue(i.getText());this.scrollToItem(i);}}
y.prototype._attachHiddenSelectHandlers=function(){var e=this._getHiddenSelect();e.on("focus",this._addFocusClass.bind(this));e.on("blur",this._removeFocusClass.bind(this));};
y.prototype.focus=function(){this._getHiddenSelect().trigger("focus");a.prototype.focus.call(this,arguments);};
y.prototype._addFocusClass=function(){this.$().addClass("sapMSltFocused");};
y.prototype._removeFocusClass=function(){this.$().removeClass("sapMSltFocused");};
y.prototype._detachHiddenSelectHandlers=function(){var e=this._getHiddenSelect();if(e){e.off("focus");e.off("blur");}};
y.prototype._getHiddenSelect=function(){return this.$("hiddenSelect");};
y.prototype._getHiddenInput=function(){return this.$("hiddenInput");};
y.prototype._announceValueStateText=function(){var e=this._getValueStateText();if(this._oInvisibleMessage){this._oInvisibleMessage.announce(e,x.Polite);}};
y.prototype._getValueStateText=function(){var e=this.getValueState(),i,z;if(e===t.None){return"";}i=C.getLibraryResourceBundle("sap.m").getText("INPUTBASE_VALUE_STATE_"+e.toUpperCase());z=i+" "+(this.getValueStateText()||p.getAdditionalText(this));return z;};
y.prototype._isFocused=function(){return this.getFocusDomRef()===document.activeElement;};
y.prototype._isIconOnly=function(){return this.getType()===w.IconOnly;};
y.prototype._handleFocusout=function(e){this._bFocusoutDueRendering=this.bRenderingPhase;if(this._bFocusoutDueRendering){this._bProcessChange=false;return;}if(this._bProcessChange){if(!this.isOpen()||e.target===this.getAggregation("picker")){this._checkSelectionChange();}else{this._revertSelection();}this._bProcessChange=false;}else{this._bProcessChange=true;}};
y.prototype._checkSelectionChange=function(){var i=this.getSelectedItem();if(this._oSelectionOnFocus!==i){this.fireChange({selectedItem:i,previousSelectedItem:this._oSelectionOnFocus});}};
y.prototype._revertSelection=function(){var i=this.getSelectedItem();if(this._oSelectionOnFocus!==i){this.setSelection(this._oSelectionOnFocus);this.setValue(this._getSelectedItemText());}};
y.prototype._getSelectedItemText=function(i){i=i||this.getSelectedItem();if(!i){i=this.getDefaultSelectedItem();}if(i){return i.getText();}return"";};
y.prototype.getOverflowToolbarConfig=function(){var e=["enabled","selectedKey"];if(!this.getAutoAdjustWidth()||this._bIsInOverflow){e.push("selectedItemId");}var i={canOverflow:true,autoCloseEvents:["change"],invalidationEvents:["_itemTextChange"],propsUnrelatedToSize:e};i.onBeforeEnterOverflow=function(z){var A=z.getParent();if(!A.isA("sap.m.OverflowToolbar")){return;}z._prevSelectType=z.getType();z._bIsInOverflow=true;if(z.getType()!==w.Default){z.setProperty("type",w.Default,true);}};i.onAfterExitOverflow=function(z){var A=z.getParent();if(!A.isA("sap.m.OverflowToolbar")){return;}z._bIsInOverflow=false;if(z.getType()!==z._prevSelectType){z.setProperty("type",z._prevSelectType,true);}};return i;};
y.prototype.getList=function(){if(this._bIsBeingDestroyed){return null;}return this._oList;};
y.prototype.findFirstEnabledItem=function(i){var e=this.getList();return e?e.findFirstEnabledItem(i):null;};
y.prototype.findLastEnabledItem=function(i){var e=this.getList();return e?e.findLastEnabledItem(i):null;};
y.prototype.setSelectedIndex=function(i,_){var e;_=_||this.getItems();i=(i>_.length-1)?_.length-1:Math.max(0,i);e=_[i];if(e){this.setSelection(e);}};
y.prototype.scrollToItem=function(i){var e=this.getPicker().getDomRef(),z=i&&i.getDomRef();if(!e||!z){return;}var A=e.querySelector('.sapUiSimpleFixFlexFlexContent'),F=e.querySelector('.sapMSltPickerValueState'),G=F?F.clientHeight:0,J=A.scrollTop,N=z.offsetTop-G,O=A.clientHeight,Q=z.offsetHeight;if(J>N){A.scrollTop=N;}else if((N+Q)>(J+O)){A.scrollTop=Math.ceil(N+Q-O);}};
y.prototype.setValue=function(e){var i=this.getDomRef(),z=i&&i.querySelector(".sapMSelectListItemText"),F=!this.isOpen()&&this._isFocused()&&this._oInvisibleMessage;if(z){z.textContent=e;}this._setHiddenSelectValue();this._getValueIcon();if(F){this._oInvisibleMessage.announce(e,x.Assertive);}};
y.prototype._setHiddenSelectValue=function(){var e=this._getHiddenSelect(),i=this._getHiddenInput(),z=this.getSelectedKey(),A=this._getSelectedItemText();i.attr("value",z||"");e.text(A);};
y.prototype._getValueIcon=function(){if(this._bIsBeingDestroyed){return null;}var e=this.getAggregation("_valueIcon"),i=this.getSelectedItem(),z=!!(i&&i.getIcon&&i.getIcon()),A=z?i.getIcon():"sap-icon://pull-down";if(!e){e=new I(this.getId()+"-labelIcon",{src:A,visible:false});this.setAggregation("_valueIcon",e,true);}if(e.getVisible()!==z){e.setVisible(z);e.toggleStyleClass("sapMSelectListItemIcon",z);}if(z&&i.getIcon()!==e.getSrc()){e.setSrc(A);}return e;};
y.prototype._isShadowListRequired=function(){if(this.getAutoAdjustWidth()){return false;}else if(this.getWidth()==="auto"){return true;}return false;};
y.prototype._handleAriaActiveDescendant=function(i){var e=this.getFocusDomRef(),z=i&&i.getDomRef(),A="aria-activedescendant";if(!e){return;}if(z&&this.isOpen()){e.setAttribute(A,i.getId());}else{e.removeAttribute(A);}};
y.prototype.updateItems=function(R){S.prototype.updateItems.apply(this,arguments);this._oSelectionOnFocus=this.getSelectedItem();};
y.prototype.refreshItems=function(){S.prototype.refreshItems.apply(this,arguments);};
y.prototype.onBeforeOpen=function(e){var i=this["_onBeforeOpen"+this.getPickerType()],z=this.getRenderer().CSS_CLASS;this.addStyleClass(z+"Pressed");this.addStyleClass(z+"Expanded");this.closeValueStateMessage();this.addContent();this.addContentToFlex();i&&i.call(this);};
y.prototype.onAfterOpen=function(e){var i=this.getFocusDomRef(),z=null;if(!i){return;}z=this.getSelectedItem();i.setAttribute("aria-expanded","true");i.setAttribute("aria-controls",this.getList().getId());if(z){i.setAttribute("aria-activedescendant",z.getId());this.scrollToItem(z);}};
y.prototype.onBeforeClose=function(e){var i=this.getFocusDomRef(),z=this.getRenderer().CSS_CLASS;if(i){i.removeAttribute("aria-controls");i.removeAttribute("aria-activedescendant");if(this.shouldValueStateMessageBeOpened()&&(document.activeElement===i)){this.openValueStateMessage();}}this.removeStyleClass(z+"Expanded");};
y.prototype.onAfterClose=function(e){var i=this.getFocusDomRef(),z=this.getRenderer().CSS_CLASS,A=z+"Pressed";if(i){i.setAttribute("aria-expanded","false");i.removeAttribute("aria-activedescendant");}this.removeStyleClass(A);};
y.prototype.getPicker=function(){if(this._bIsBeingDestroyed){return null;}return this.createPicker(this.getPickerType());};
y.prototype.getValueStateTextInvisibleText=function(){if(this._bIsBeingDestroyed){return null;}if(!this._oValueStateTextInvisibleText){this._oValueStateTextInvisibleText=new h({id:this.getId()+"-valueStateText-InvisibleText"});this._oValueStateTextInvisibleText.toStatic();}return this._oValueStateTextInvisibleText;};
y.prototype.getSimpleFixFlex=function(){if(this._bIsBeingDestroyed){return null;}else if(this.oSimpleFixFlex){return this.oSimpleFixFlex;}this.oSimpleFixFlex=new n({id:this.getPickerValueStateContentId(),fixContent:this._getPickerValueStateContent().addStyleClass(this.getRenderer().CSS_CLASS+"PickerValueState"),flexContent:this.createList()});return this.oSimpleFixFlex;};
y.prototype.setPickerType=function(e){this._sPickerType=e;};
y.prototype.getPickerType=function(){return this._sPickerType;};
y.prototype._getPickerValueStateContent=function(){if(!this.getAggregation("_pickerValueStateContent")){this.setAggregation("_pickerValueStateContent",new m({wrapping:true,text:this._getTextForPickerValueStateContent()}));}return this.getAggregation("_pickerValueStateContent");};
y.prototype._updatePickerValueStateContentText=function(){var e=this.getPicker(),i=e&&e.getContent()[0].getFixContent(),z;if(i){z=this._getTextForPickerValueStateContent();i.setText(z);}};
y.prototype._getTextForPickerValueStateContent=function(){var e=this.getValueStateText(),i;if(e){i=e;}else{i=this._getDefaultTextForPickerValueStateContent();}return i;};
y.prototype._getDefaultTextForPickerValueStateContent=function(){var e=this.getValueState(),R,i;if(e===t.None){i="";}else{R=C.getLibraryResourceBundle("sap.ui.core");i=R.getText("VALUE_STATE_"+e.toUpperCase());}return i;};
y.prototype._updatePickerValueStateContentStyles=function(){var e=this.getValueState(),i=t,z=this.getRenderer().CSS_CLASS,A=z+"Picker",F=A+e+"State",G=A+"WithSubHeader",J=this.getPicker(),N=J&&J.getContent()[0].getFixContent();if(N){this._removeValueStateClassesForPickerValueStateContent(J);N.addStyleClass(F);if(e!==i.None){J.addStyleClass(G);}else{J.removeStyleClass(G);}}};
y.prototype._removeValueStateClassesForPickerValueStateContent=function(e){var i=t,z=this.getRenderer().CSS_CLASS,A=z+"Picker",F=e.getContent()[0].getFixContent();Object.keys(i).forEach(function(G){var O=A+G+"State";F.removeStyleClass(O);});};
y.prototype._createPopover=function(){var e=this;var i=new P({showArrow:false,showHeader:false,placement:s.VerticalPreferredBottom,offsetX:0,offsetY:0,initialFocus:this,ariaLabelledBy:this._getPickerHiddenLabelId()});i.addEventDelegate({ontouchstart:function(z){var A=this.getDomRef("cont");if((z.target===A)||(z.srcControl instanceof f)){e._bProcessChange=false;}}},i);this._decoratePopover(i);return i;};
y.prototype._decoratePopover=function(e){var i=this;e.open=function(){return this.openBy(i);};};
y.prototype._onBeforeRenderingPopover=function(){var e=this.getPicker(),W=this.$().outerWidth()+"px";if(e){e.setContentMinWidth(W);}};
y.prototype._createDialog=function(){var e=this,i=this._getPickerHeader(),z=new D({stretch:true,ariaLabelledBy:this._getPickerHiddenLabelId(),customHeader:i,beforeOpen:function(){e.updatePickerHeaderTitle();}});return z;};
y.prototype._getPickerTitle=function(){var e=this.getPicker(),i=e&&e.getCustomHeader();if(i){return i.getContentMiddle()[0];}return null;};
y.prototype._getPickerHeader=function(){var i=b.getIconURI("decline"),R;if(!this.getAggregation("_pickerHeader")){R=C.getLibraryResourceBundle("sap.m");this.setAggregation("_pickerHeader",new c({titleAlignment:l.TitleAlignment.Auto,contentMiddle:new T({text:R.getText("SELECT_PICKER_TITLE_TEXT")}),contentRight:new B({icon:i,press:this.close.bind(this)})}));}return this.getAggregation("_pickerHeader");};
y.prototype._getPickerHiddenLabelId=function(){return h.getStaticId("sap.m","INPUT_AVALIABLE_VALUES");};
y.prototype.getPickerValueStateContentId=function(){return this.getId()+"-valueStateText";};
y.prototype.updatePickerHeaderTitle=function(){var e=this.getPicker();if(!e){return;}var i=this.getLabels();if(i.length){var z=i[0],A=this._getPickerTitle();if(z&&(typeof z.getText==="function")){A&&A.setText(z.getText());}}};
y.prototype._onBeforeOpenDialog=function(){};
y.prototype.init=function(){this.setPickerType(g.system.phone?"Dialog":"Popover");this.createPicker(this.getPickerType());this._oSelectionOnFocus=null;this.bRenderingPhase=false;this._bFocusoutDueRendering=false;this._bProcessChange=false;this.sTypedChars="";this.iTypingTimeoutID=-1;this._oValueStateMessage=new V(this);this._bValueStateMessageOpened=false;this._sAriaRoleDescription=C.getLibraryResourceBundle("sap.m").getText("SELECT_ROLE_DESCRIPTION");this._oInvisibleMessage=null;};
y.prototype.onBeforeRendering=function(){if(!this._oInvisibleMessage){this._oInvisibleMessage=q.getInstance();}this.bRenderingPhase=true;this.synchronizeSelection({forceSelection:this.getForceSelection()});this._updatePickerValueStateContentText();this._updatePickerValueStateContentStyles();this._detachHiddenSelectHandlers();if(this._isIconOnly()){this.setAutoAdjustWidth(true);}};
y.prototype.onAfterRendering=function(){this.bRenderingPhase=false;this._setHiddenSelectValue();this._attachHiddenSelectHandlers();};
y.prototype.exit=function(){var e=this.getValueStateMessage(),i=this._getValueIcon();this._oSelectionOnFocus=null;if(this._oValueStateTextInvisibleText){this._oValueStateTextInvisibleText.destroy();this._oValueStateTextInvisibleText=null;}if(e){this.closeValueStateMessage();e.destroy();}if(i){i.destroy();}this._oValueStateMessage=null;this._bValueStateMessageOpened=false;};
y.prototype.ontouchstart=function(e){e.setMarked();if(this.getEnabled()&&this.getEditable()){this.addStyleClass(this.getRenderer().CSS_CLASS+"Pressed");this.focus();}};
y.prototype.ontouchend=function(e){e.setMarked();if(this.getEnabled()&&this.getEditable()&&!this.isOpen()&&this.isOpenArea(e.target)){this.removeStyleClass(this.getRenderer().CSS_CLASS+"Pressed");}};
y.prototype.ontap=function(e){var i=this.getRenderer().CSS_CLASS;e.setMarked();if(!this.getEnabled()||!this.getEditable()){return;}if(this.isOpenArea(e.target)){if(this.isOpen()){this.close();this.removeStyleClass(i+"Pressed");return;}if(g.system.phone){this.focus();}this.open();}if(this.isOpen()){this.addStyleClass(i+"Pressed");}};
y.prototype.onSelectionChange=function(e){var i=e.getParameter("selectedItem"),z=this.getSelectedItem();this.close();this.setSelection(i);this.fireChange({selectedItem:i,previousSelectedItem:z});this.setValue(this._getSelectedItemText());};
y.prototype.onkeypress=function(e){if(!this.getEditable()){return;}e.setMarked();var i=String.fromCharCode(e.which),z;this.sTypedChars+=i;z=(/^(.)\1+$/i).test(this.sTypedChars)?i:this.sTypedChars;clearTimeout(this.iTypingTimeoutID);this.iTypingTimeoutID=setTimeout(function(){this.sTypedChars="";this.iTypingTimeoutID=-1;}.bind(this),1000);H.call(this,this.searchNextItemByText(z));};
y.prototype.onsapshow=function(e){if(!this.getEditable()){return;}e.setMarked();if(e.which===K.F4){e.preventDefault();}this.toggleOpenState();};
y.prototype.onsaphide=y.prototype.onsapshow;
y.prototype.onmousedown=function(e){e.preventDefault();this._getHiddenSelect().trigger("focus");};
y.prototype.onsapescape=function(e){if(!this.getEditable()||this._bSpaceDown){return;}if(this.isOpen()){e.setMarked();this.close();this._revertSelection();}};
y.prototype.onsapenter=function(e){e.preventDefault();if(!this.getEditable()){return;}if(this.isOpen()){e.setMarked();}this.close();this._checkSelectionChange();};
y.prototype.onkeydown=function(e){if(e.which===K.SPACE){this._bSpaceDown=true;}if([K.ARROW_DOWN,K.ARROW_UP,K.SPACE].indexOf(e.which)>-1){e.preventDefault();}if(e.which===K.SHIFT||e.which===K.ESCAPE){this._bSupressNextAction=this._bSpaceDown;}};
y.prototype.onkeyup=function(e){if(!this.getEditable()){return;}if(e.which===K.SPACE){if(!e.shiftKey&&!this._bSupressNextAction){e.setMarked();if(this.isOpen()){this._checkSelectionChange();}this.toggleOpenState();}this._bSpaceDown=false;this._bSupressNextAction=false;}};
y.prototype.onsapdown=function(e){if(!this.getEditable()){return;}e.setMarked();e.preventDefault();var N,i=this.getSelectableItems();N=i[i.indexOf(this.getSelectedItem())+1];H.call(this,N);};
y.prototype.onsapup=function(e){if(!this.getEditable()){return;}e.setMarked();e.preventDefault();var i,z=this.getSelectableItems();i=z[z.indexOf(this.getSelectedItem())-1];H.call(this,i);};
y.prototype.onsaphome=function(e){if(!this.getEditable()){return;}e.setMarked();e.preventDefault();var F=this.getSelectableItems()[0];H.call(this,F);};
y.prototype.onsapend=function(e){if(!this.getEditable()){return;}e.setMarked();e.preventDefault();var i=this.findLastEnabledItem(this.getSelectableItems());H.call(this,i);};
y.prototype.onsappagedown=function(e){if(!this.getEditable()){return;}e.setMarked();e.preventDefault();var i=this.getSelectableItems(),z=this.getSelectedItem();this.setSelectedIndex(i.indexOf(z)+10,i);z=this.getSelectedItem();if(z){this.setValue(z.getText());}this.scrollToItem(z);};
y.prototype.onsappageup=function(e){if(!this.getEditable()){return;}e.setMarked();e.preventDefault();var i=this.getSelectableItems(),z=this.getSelectedItem();this.setSelectedIndex(i.indexOf(z)-10,i);z=this.getSelectedItem();if(z){this.setValue(z.getText());}this.scrollToItem(z);};
y.prototype.onsaptabnext=function(e){if(this.isOpen()){this.close();this._checkSelectionChange();}};
y.prototype.onsaptabprevious=y.prototype.onsaptabnext;
y.prototype.onfocusin=function(e){if(!this._bFocusoutDueRendering&&!this._bProcessChange){this._oSelectionOnFocus=this.getSelectedItem();}this._bProcessChange=true;setTimeout(function(){if(!this.isOpen()&&this.shouldValueStateMessageBeOpened()&&(document.activeElement===this.getFocusDomRef())){this.openValueStateMessage();}}.bind(this),100);};
y.prototype.onfocusout=function(e){this._handleFocusout(e);if(this.bRenderingPhase){return;}this.closeValueStateMessage();};
y.prototype.onsapfocusleave=function(e){var i=this.getAggregation("picker");if(!e.relatedControlId||!i){return;}var z=C.byId(e.relatedControlId),F=z&&z.getFocusDomRef();if(g.system.desktop&&k(i.getFocusDomRef(),F)){this.focus();}};
y.prototype.getFocusDomRef=function(){return this._getHiddenSelect()[0];};
y.prototype.getPopupAnchorDomRef=function(){return this.getDomRef();};
y.prototype.setSelection=function(i){var e=this.getList(),z;if(e){e.setSelection(i);}this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",(i instanceof f)?i.getId():i,true);if(typeof i==="string"){i=C.byId(i);}z=i?i.getKey():"";this.setProperty("selectedKey",z,true);this._handleAriaActiveDescendant(i);};
y.prototype.setColumnRatio=function(R){var e=this.getList();this.setProperty("columnRatio",R,true);if(e&&this.getShowSecondaryValues()){e.setProperty("_columnRatio",this.getColumnRatio());}return this;};
y.prototype.isSelectionSynchronized=function(){return S.prototype.isSelectionSynchronized.apply(this,arguments);};
y.prototype.synchronizeSelection=function(){S.prototype.synchronizeSelection.apply(this,arguments);};
y.prototype.addContent=function(e){};
y.prototype.addContentToFlex=function(){};
y.prototype.createPicker=function(e){var i=this.getAggregation("picker"),z=this.getRenderer().CSS_CLASS;if(i){return i;}i=this["_create"+e]();this.setAggregation("picker",i,true);i.setHorizontalScrolling(false).setVerticalScrolling(false).addStyleClass(z+"Picker").addStyleClass(z+"Picker-CTX").addStyleClass("sapUiNoContentPadding").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this).addContent(this.getSimpleFixFlex());return i;};
y.prototype.searchNextItemByText=function(e){var z=this.getItems(),A=this.getSelectedIndex(),F=z.splice(A+1,z.length-A),G=z.splice(0,z.length-1);z=F.concat(G);for(var i=0,J;i<z.length;i++){J=z[i];var N=typeof e==="string"&&e!=="";if(J.getEnabled()&&!(J instanceof sap.ui.core.SeparatorItem)&&J.getText().toLowerCase().startsWith(e.toLowerCase())&&N){return J;}}return null;};
y.prototype.createList=function(){var e=r,i=g.system.phone?e.Delimited:e.None;this._oList=new S({width:"100%",keyboardNavigationMode:i,hideDisabledItems:true}).addStyleClass(this.getRenderer().CSS_CLASS+"List-CTX").addEventDelegate({ontap:function(z){var A=z.srcControl;if(A.getEnabled()){this._checkSelectionChange();this.close();}}},this).addEventDelegate({onAfterRendering:this.onAfterRenderingList},this).attachSelectionChange(this.onSelectionChange,this);this._oList.setProperty("_tabIndex","-1");this._oList.toggleStyleClass("sapMSelectListWrappedItems",this.getWrapItemsText());return this._oList;};
y.prototype.setWrapItemsText=function(W){var e=this.getPicker();if(this._oList){this._oList.toggleStyleClass("sapMSelectListWrappedItems",W);}if(e&&this.getPickerType()==="Popover"){e.toggleStyleClass("sapMPickerWrappedItems",W);}return this.setProperty("wrapItemsText",W,true);};
y.prototype.hasContent=function(){return this.getItems().length>0;};
y.prototype.onBeforeRenderingPicker=function(){var O=this["_onBeforeRendering"+this.getPickerType()];O&&O.call(this);};
y.prototype.onAfterRenderingPicker=function(){var O=this["_onAfterRendering"+this.getPickerType()];O&&O.call(this);};
y.prototype.onAfterRenderingList=function(){};
y.prototype.open=function(){var e=this.getPicker();this.focus();if(e){e.open();}return this;};
y.prototype.toggleOpenState=function(){if(this.isOpen()){this.close();}else{this.open();}return this;};
y.prototype.getVisibleItems=function(){var e=this.getList();return e?e.getVisibleItems():[];};
y.prototype.isItemSelected=function(i){return i&&(i.getId()===this.getAssociation("selectedItem"));};
y.prototype.getSelectedIndex=function(){var e=this.getSelectedItem();return e?this.indexOfItem(this.getSelectedItem()):-1;};
y.prototype.getDefaultSelectedItem=function(i){return this.getForceSelection()?this.findFirstEnabledItem():null;};
y.prototype.getSelectableItems=function(){var e=this.getList();if(!e){return[];}return e.getSelectableItems();};
y.prototype.getOpenArea=function(){return this.getDomRef();};
y.prototype.isOpenArea=function(e){var O=this.getOpenArea();return O&&O.contains(e);};
y.prototype.getFormFormattedValue=function(){var i=this.getSelectedItem();return i?i.getText():"";};
y.prototype.getFormValueProperty=function(){return"selectedKey";};
y.prototype.findItem=function(e,i){var z=this.getList();return z?z.findItem(e,i):null;};
y.prototype.clearSelection=function(){this.setSelection(null);};
y.prototype.onItemChange=function(e){var i=this.getAssociation("selectedItem"),z=e.getParameter("id"),A=e.getParameter("name"),N=e.getParameter("newValue"),O,F,G,J;if(A==="key"&&!this.isBound("selectedKey")){F=this.getSelectedKey();G=this.getItemByKey(N);if(N===F&&i!==z&&G&&z===G.getId()){this.setSelection(G);return;}O=e.getParameter("oldValue");if(i===z&&F===O&&!this.getItemByKey(O)){this.setSelectedKey(N);return;}J=this.getItemByKey(F);if(i===z&&N!==F&&J){this.setSelection(J);return;}}if(A==="text"&&i===z){this.fireEvent("_itemTextChange");this.setValue(N);}};
y.prototype.fireChange=function(e){this._oSelectionOnFocus=e.selectedItem;return this.fireEvent("change",e);};
y.prototype.addAggregation=function(A,O,e){if(A==="items"&&!e&&!this.isInvalidateSuppressed()){this.invalidate(O);}return a.prototype.addAggregation.apply(this,arguments);};
y.prototype.destroyAggregation=function(A,e){if(A==="items"&&!e&&!this.isInvalidateSuppressed()){this.invalidate();}return a.prototype.destroyAggregation.apply(this,arguments);};
y.prototype.setAssociation=function(A,i,e){var z=this.getList();if(z&&(A==="selectedItem")){S.prototype.setAssociation.apply(z,arguments);}return a.prototype.setAssociation.apply(this,arguments);};
y.prototype.setProperty=function(i,z,A){var F=this.getList();if((i==="selectedKey")||(i==="selectedItemId")){F&&S.prototype.setProperty.apply(F,arguments);}try{a.prototype.setProperty.apply(this,arguments);}catch(e){o.warning('Update failed due to exception. Loggable in support mode log',null,null,function(){return{exception:e};});}return this;};
y.prototype.removeAllAssociation=function(A,e){var i=this.getList();if(i&&(A==="selectedItem")){S.prototype.removeAllAssociation.apply(i,arguments);}return a.prototype.removeAllAssociation.apply(this,arguments);};
y.prototype.clone=function(){var e=a.prototype.clone.apply(this,arguments),i=this.getSelectedItem(),z=this.getSelectedKey();if(!this.isBound("selectedKey")&&!e.isSelectionSynchronized()){if(i&&(z==="")){e.setSelectedIndex(this.indexOfItem(i));}else{e.setSelectedKey(z);}}return e;};
y.prototype._updatePickerAriaLabelledBy=function(e){var i=this.getPicker(),z;if(!i){return;}z=this.getValueStateTextInvisibleText().getId();if(e===t.None){i.removeAriaLabelledBy(z);}else{i.addAriaLabelledBy(z);}};
y.prototype.getLabels=function(){var e=this.getAriaLabelledBy().concat(L.getReferencingLabels(this));e=e.filter(function(i,z){return e.indexOf(i)===z;}).map(function(i){return C.byId(i);});return e;};
y.prototype.getDomRefForValueStateMessage=function(){return this.getFocusDomRef();};
y.prototype.getValueStateMessageId=function(){return this.getId()+"-message";};
y.prototype.getValueStateMessage=function(){return this._oValueStateMessage;};
y.prototype.openValueStateMessage=function(){var e=this.getValueStateMessage();if(e&&!this._bValueStateMessageOpened){this._bValueStateMessageOpened=true;e.open();}};
y.prototype.closeValueStateMessage=function(){var e=this.getValueStateMessage();if(e&&this._bValueStateMessageOpened){this._bValueStateMessageOpened=false;e.close();}};
y.prototype.shouldValueStateMessageBeOpened=function(){return!this._isIconOnly()&&(this.getValueState()!==t.None)&&this.getEnabled()&&this.getEditable()&&!this._bValueStateMessageOpened;};
y.prototype.setShowSecondaryValues=function(A){var e=!this._isShadowListRequired();this.setProperty("showSecondaryValues",A,e);var i=this.getList(),z=A?this.getColumnRatio():null;if(i){i.setShowSecondaryValues(A);i.setProperty("_columnRatio",z);}return this;};
y.prototype.addItem=function(i){this.addAggregation("items",i);if(i){i.attachEvent("_change",this.onItemChange,this);}return this;};
y.prototype.insertItem=function(i,e){this.insertAggregation("items",i,e);if(i){i.attachEvent("_change",this.onItemChange,this);}return this;};
y.prototype.findAggregatedObjects=function(){var e=this.getList();if(e){return S.prototype.findAggregatedObjects.apply(e,arguments);}return[];};
y.prototype.getItems=function(){var e=this.getList();return e?e.getItems():[];};
y.prototype.setSelectedItem=function(i){if(typeof i==="string"){this.setAssociation("selectedItem",i,true);i=C.byId(i);}if(!(i instanceof f)&&i!==null){return this;}if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText(i));this._oSelectionOnFocus=i;return this;};
y.prototype.setSelectedItemId=function(i){i=this.validateProperty("selectedItemId",i);if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText());this._oSelectionOnFocus=this.getSelectedItem();return this;};
y.prototype._isKeyAvailable=function(e){var A=this._oList.getItems().map(function(i){return i.getKey();});return A.indexOf(e)>-1;};
y.prototype.setSelectedKey=function(e){e=this.validateProperty("selectedKey",e);var i=(e==="");if(!i&&!this._isKeyAvailable(e)&&this.getResetOnMissingKey()){i=true;}if(!this.getForceSelection()&&i){this.setSelection(null);this.setValue("");return this.setProperty("selectedKey",e);}var z=this.getItemByKey(e);if(z||i){if(!z&&i){z=this.getDefaultSelectedItem();}this.setSelection(z);this.setValue(this._getSelectedItemText(z));this._oSelectionOnFocus=z;return this;}return this.setProperty("selectedKey",e);};
y.prototype.setValueState=function(e){var O=this.getValueState();if(e===O){return this;}this.setProperty("valueState",e);this._updatePickerAriaLabelledBy(e);if(this._isFocused()){this._announceValueStateText();}var i=this.getDomRefForValueState();if(!i){return this;}if(!this.isOpen()&&this.shouldValueStateMessageBeOpened()&&document.activeElement===i){this.openValueStateMessage();}else{this.closeValueStateMessage();}this._updatePickerValueStateContentText();this._updatePickerValueStateContentStyles();return this;};
y.prototype.setValueStateText=function(e){var i=this.getValueStateTextInvisibleText();this.setProperty("valueStateText",e);if(i){i.setText(e);}if(this.getDomRefForValueState()){this._updatePickerValueStateContentText();this._updatePickerValueStateContentStyles();}if(this._isFocused()){this._announceValueStateText();}return this;};
y.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
y.prototype.getSelectedItem=function(){var e=this.getAssociation("selectedItem");return(e===null)?null:C.byId(e)||null;};
y.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
y.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
y.prototype.getEnabledItems=function(i){var e=this.getList();return e?e.getEnabledItems(i):[];};
y.prototype.getItemByKey=function(e){var i=this.getList();return i?i.getItemByKey(e):null;};
y.prototype.removeItem=function(i){var e;i=this.removeAggregation("items",i);if(this.getItems().length===0){this.clearSelection();}else if(this.isItemSelected(i)){e=this.findFirstEnabledItem();if(e){this.setSelection(e);}}this.setValue(this._getSelectedItemText());if(i){i.detachEvent("_change",this.onItemChange,this);}return i;};
y.prototype.removeAllItems=function(){var e=this.removeAllAggregation("items");this.setValue("");if(this._isShadowListRequired()){this.$().find(".sapMSelectListItemBase").remove();}for(var i=0;i<e.length;i++){e[i].detachEvent("_change",this.onItemChange,this);}return e;};
y.prototype.destroyItems=function(){this.destroyAggregation("items");this.setValue("");if(this._isShadowListRequired()){this.$().find(".sapMSelectListItemBase").remove();}return this;};
y.prototype.isOpen=function(){var e=this.getAggregation("picker");return!!(e&&e.isOpen());};
y.prototype.close=function(){var e=this.getAggregation("picker");if(e){e.close();}return this;};
y.prototype.getDomRefForValueState=function(){return this.getFocusDomRef();};
y.prototype._isRequired=function(){return this.getRequired()||L.isRequired(this);};
y.prototype.getAccessibilityInfo=function(){var e=[],i="",R=C.getLibraryResourceBundle("sap.m"),z=this._isIconOnly(),A={role:this.getRenderer().getAriaRole(this),focusable:this.getEnabled(),enabled:this.getEnabled(),readonly:z?undefined:this.getEnabled()&&!this.getEditable()};if(z){var F=this.getTooltip_AsString();if(!F){var G=b.getIconInfo(this.getIcon());F=G&&G.text?G.text:"";}A.type=R.getText("ACC_CTR_TYPE_BUTTON");e.push(F);}else if(this.getType()==="Default"){A.type=R.getText("SELECT_ROLE_DESCRIPTION");e.push(this._getSelectedItemText());}if(this._isRequired()){e.push(R.getText("SELECT_REQUIRED"));}i=e.join(" ").trim();if(i){A.description=i;}return A;};
y.prototype.getIdForLabel=function(){return this.getId()+"-hiddenSelect";};
return y;});
sap.ui.predefine('sap/m/SelectDialog',["sap/ui/thirdparty/jquery",'./Button','./Dialog','./List','./SearchField','./library','./SelectDialogBase','sap/ui/core/InvisibleText','sap/ui/Device','sap/m/Toolbar','sap/m/Text','sap/m/BusyIndicator','sap/m/Bar','sap/m/Title',"sap/base/Log"],function(q,B,D,L,S,l,a,I,b,T,c,d,e,f,g){"use strict";var h=l.ListMode;var i=l.ButtonType;var j=l.TitleAlignment;
var k=a.extend("sap.m.SelectDialog",{
metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},noDataText:{type:"string",group:"Appearance",defaultValue:null},multiSelect:{type:"boolean",group:"Dimension",defaultValue:false},growingThreshold:{type:"int",group:"Misc",defaultValue:null},growing:{type:"boolean",group:"Behavior",defaultValue:true},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:false},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},showClearButton:{type:"boolean",group:"Behavior",defaultValue:false},confirmButtonText:{type:"string",group:"Appearance"},draggable:{type:"boolean",group:"Behavior",defaultValue:false},resizable:{type:"boolean",group:"Behavior",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:j.Auto}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ListItemBase",multiple:true,singularName:"item",forwarding:{idSuffix:"-list",aggregation:"items",forwardBinding:true}},_dialog:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{confirm:{parameters:{selectedItem:{type:"sap.m.StandardListItem"},selectedItems:{type:"sap.m.StandardListItem[]"},selectedContexts:{type:"object[]"}}},search:{parameters:{value:{type:"string"},itemsBinding:{type:"any"},clearButtonPressed:{type:"boolean"}}},liveChange:{parameters:{value:{type:"string"},itemsBinding:{type:"any"}}},cancel:{}}},
renderer:{apiVersion:2,render:function(){}}
});
k.prototype.init=function(){var t=this,m=0;this._bAppendedToUIArea=false;this._bInitBusy=false;this._bFirstRender=true;this._bAfterCloseAttached=false;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oList=new L(this.getId()+"-list",{growing:t.getGrowing(),growingScrollToLoad:t.getGrowing(),mode:h.SingleSelectMaster,sticky:[l.Sticky.InfoToolbar],infoToolbar:new T({visible:false,active:false,content:[new c({text:this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[0])})]}),selectionChange:this._selectionChange.bind(this),updateStarted:this._updateStarted.bind(this),updateFinished:this._updateFinished.bind(this)});this._oList.getInfoToolbar().addEventDelegate({onAfterRendering:function(){t._oList.getInfoToolbar().$().attr('aria-live','polite');}});this._list=this._oList;this._oBusyIndicator=new d(this.getId()+"-busyIndicator").addStyleClass("sapMSelectDialogBusyIndicator",true);this._oSearchField=new S(this.getId()+"-searchField",{width:"100%",ariaLabelledBy:I.getStaticId("sap.m","SELECTDIALOG_SEARCH"),liveChange:function(E){var v=E.getSource().getValue(),n=(v?300:0);clearTimeout(m);if(n){m=setTimeout(function(){t._executeSearch(v,false,"liveChange");},n);}else{t._executeSearch(v,false,"liveChange");}},search:function(E){var v=E.getSource().getValue(),n=E.getParameters().clearButtonPressed;t._executeSearch(v,n,"search");}});this._searchField=this._oSearchField;this._oSubHeader=new e(this.getId()+"-subHeader",{contentMiddle:[this._oSearchField]});var C=new e(this.getId()+"-dialog-header",{titleAlignment:this.getTitleAlignment(),contentMiddle:[new f(this.getId()+"-dialog-title",{level:"H2"})]});this._oDialog=new D(this.getId()+"-dialog",{customHeader:C,titleAlignment:this.getTitleAlignment(),stretch:b.system.phone,contentHeight:"2000px",subHeader:this._oSubHeader,content:[this._oBusyIndicator,this._oList],leftButton:this._getCancelButton(),draggable:this.getDraggable()&&b.system.desktop,resizable:this.getResizable()&&b.system.desktop,escapeHandler:function(p){t._onCancel();p.resolve();}}).addStyleClass("sapMSelectDialog");this._dialog=this._oDialog;this.setAggregation("_dialog",this._oDialog);this._sSearchFieldValue="";this._iListUpdateRequested=0;};
k.prototype.setGrowing=function(v){this._oList.setGrowing(v);this._oList.setGrowingScrollToLoad(v);this.setProperty("growing",v,true);return this;};
k.prototype.setDraggable=function(v){this._setInteractionProperty(v,"draggable",this._oDialog.setDraggable);return this;};
k.prototype.setResizable=function(v){this._setInteractionProperty(v,"resizable",this._oDialog.setResizable);return this;};
k.prototype._setInteractionProperty=function(v,p,C){this.setProperty(p,v,true);if(!b.system.desktop&&v){g.warning(p+" property works only on desktop devices!");return;}if(b.system.desktop&&this._oDialog){C.call(this._oDialog,v);}};
k.prototype.setBusy=function(){this._oDialog.setBusy.apply(this._oDialog,arguments);return this;};
k.prototype.getBusy=function(){return this._oDialog.getBusy.apply(this._oDialog,arguments);};
k.prototype.setBusyIndicatorDelay=function(v){this._oList.setBusyIndicatorDelay(v);this._oDialog.setBusyIndicatorDelay(v);this.setProperty("busyIndicatorDelay",v,true);return this;};
k.prototype.exit=function(){this._oList=null;this._oSearchField=null;this._oSubHeader=null;this._oClearButton=null;this._oBusyIndicator=null;this._sSearchFieldValue=null;this._iListUpdateRequested=0;this._bInitBusy=false;this._bFirstRender=false;if(this._bAppendedToUIArea){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.removeContent(this,true);}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oOkButton){this._oOkButton.destroy();this._oOkButton=null;}this._oSelectedItem=null;this._aSelectedItems=null;this._list=null;this._searchField=null;this._dialog=null;};
k.prototype.onAfterRendering=function(){if(this._bInitBusy&&this._bFirstRender){this._setBusy(true);this._bInitBusy=false;}return this;};
k.prototype.invalidate=function(){if(this._oDialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._oDialog.invalidate(arguments);}else{a.prototype.invalidate.apply(this,arguments);}return this;};
k.prototype.open=function(s){if((!this.getParent()||!this.getUIArea())&&!this._bAppendedToUIArea){var o=sap.ui.getCore().getStaticAreaRef();o=sap.ui.getCore().getUIArea(o);o.addContent(this,true);this._bAppendedToUIArea=true;}this._oSearchField.setValue(s);this._sSearchFieldValue=s||"";this._setInitialFocus();this._oDialog.open();if(this._bInitBusy){this._setBusy(true);}this._updateSelectionIndicator();this._aInitiallySelectedContextPaths=this._oList.getSelectedContextPaths();return this;};
k.prototype.setGrowingThreshold=function(v){this._oList.setGrowingThreshold(v);this.setProperty("growingThreshold",v,true);return this;};
k.prototype.setMultiSelect=function(m){this.setProperty("multiSelect",m,true);if(m){this._oList.setMode(h.MultiSelect);this._oList.setIncludeItemInSelection(true);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.setBeginButton(this._getOkButton());}else{this._oList.setMode(h.SingleSelectMaster);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.destroyBeginButton();delete this._oOkButton;}return this;};
k.prototype.setTitle=function(t){this.setProperty("title",t,true);this._oDialog.getCustomHeader().getAggregation("contentMiddle")[0].setText(t);return this;};
k.prototype.setTitleAlignment=function(A){this.setProperty("titleAlignment",A,true);if(this._oDialog){this._oDialog.setTitleAlignment(A);}return this;};
k.prototype.setConfirmButtonText=function(t){this.setProperty("confirmButtonText",t,true);this._oOkButton&&this._oOkButton.setText(t||this._oRb.getText("SELECT_CONFIRM_BUTTON"));return this;};
k.prototype.setNoDataText=function(n){this._oList.setNoDataText(n);return this;};
k.prototype.getNoDataText=function(){return this._oList.getNoDataText();};
k.prototype.getContentWidth=function(){return this._oDialog.getContentWidth();};
k.prototype.setContentWidth=function(w){this._oDialog.setContentWidth(w);return this;};
k.prototype.getContentHeight=function(){return this._oDialog.getContentHeight();};
k.prototype.setShowClearButton=function(v){this.setProperty("showClearButton",v,true);if(v){var C=this._oDialog.getCustomHeader();C.addContentRight(this._getClearButton());}if(this._oClearButton){this._oClearButton.setVisible(v);}return this;};
k.prototype.setContentHeight=function(H){this._oDialog.setContentHeight(H);return this;};
k.prototype.addStyleClass=function(){this._oDialog.addStyleClass.apply(this._oDialog,arguments);return this;};
k.prototype.removeStyleClass=function(){this._oDialog.removeStyleClass.apply(this._oDialog,arguments);return this;};
k.prototype.toggleStyleClass=function(){this._oDialog.toggleStyleClass.apply(this._oDialog,arguments);return this;};
k.prototype.hasStyleClass=function(){return this._oDialog.hasStyleClass.apply(this._oDialog,arguments);};
k.prototype.getDomRef=function(){if(this._oDialog){return this._oDialog.getDomRef.apply(this._oDialog,arguments);}else{return null;}};
k.prototype.clearSelection=function(){this._removeSelection();this._updateSelectionIndicator();this._oDialog.focus();return this;};
k.prototype.setModel=function(m,M){this._setBusy(false);this._bInitBusy=false;this._iListUpdateRequested+=1;this._oList.setModel(m,M);a.prototype.setModel.apply(this,arguments);this._updateSelectionIndicator();return this;};
k.prototype.setBindingContext=function(C,m){this._oList.setBindingContext(C,m);a.prototype.setBindingContext.apply(this,arguments);return this;};
k.prototype._executeSearch=function(v,C,E){var o=this._oList,m=(o?o.getBinding("items"):undefined),s=(this._sSearchFieldValue!==v);if(this._oDialog.isOpen()&&((s&&E==="liveChange")||E==="search")){this._sSearchFieldValue=v;if(m){this._iListUpdateRequested+=1;if(E==="search"){this.fireSearch({value:v,itemsBinding:m,clearButtonPressed:C});}else if(E==="liveChange"){this.fireLiveChange({value:v,itemsBinding:m});}}else{if(E==="search"){this.fireSearch({value:v,clearButtonPressed:C});}else if(E==="liveChange"){this.fireLiveChange({value:v});}}}return this;};
k.prototype._setBusy=function(m){if(this._iListUpdateRequested){if(m){this._oList.addStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','inline-block');}else{this._oList.removeStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','none');}}};
k.prototype._updateStarted=function(E){this.fireUpdateStarted(E.getParameters());if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){if(this._oDialog.isOpen()&&this._iListUpdateRequested){this._setBusy(true);}else{this._bInitBusy=true;}}};
k.prototype._updateFinished=function(E){this.fireUpdateFinished(E.getParameters());this._updateSelectionIndicator();if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){this._setBusy(false);this._bInitBusy=false;}this._iListUpdateRequested=0;this._oList.getItems().forEach(function(o){o.addEventDelegate(this._getListItemsEventDelegates());},this);};
k.prototype._getOkButton=function(){var t=this,o=null;o=function(){t._sSearchFieldValue=null;var m=t._oList.getBinding("items");if(m&&m.aFilters&&m.aFilters.length){t._oList.setGrowing(false);m.filter([]);t._oList.setGrowing(t.getGrowing());}t._oSelectedItem=t._oList.getSelectedItem();t._aSelectedItems=t._oList.getSelectedItems();t._oDialog.detachAfterClose(o);t._fireConfirmAndUpdateSelection();};if(!this._oOkButton){this._oOkButton=new B(this.getId()+"-ok",{type:i.Emphasized,text:this.getConfirmButtonText()||this._oRb.getText("SELECT_CONFIRM_BUTTON"),press:function(){t._oDialog.attachAfterClose(o);t._oDialog.close();}});}return this._oOkButton;};
k.prototype._getCancelButton=function(){var t=this;if(!this._oCancelButton){this._oCancelButton=new B(this.getId()+"-cancel",{text:this._oRb.getText("MSGBOX_CANCEL"),press:function(E){t._onCancel();}});}return this._oCancelButton;};
k.prototype._getClearButton=function(){if(!this._oClearButton){this._oClearButton=new B(this.getId()+"-clear",{text:this._oRb.getText("SELECTDIALOG_CLEARBUTTON"),press:this.clearSelection.bind(this)});}return this._oClearButton;};
k.prototype._onCancel=function(E){var t=this,A=null;A=function(){t._oSelectedItem=null;t._aSelectedItems=[];t._sSearchFieldValue=null;t._oDialog.detachAfterClose(A);t._resetSelection();t.fireCancel();};this._oDialog.attachAfterClose(A);this._oDialog.close();};
k.prototype._updateSelectionIndicator=function(){var s=this._oList.getSelectedContextPaths(true).length,o=this._oList.getInfoToolbar(),v=!!s&&this.getMultiSelect();if(this.getShowClearButton()&&this._oClearButton){this._oClearButton.setEnabled(s>0);}if(o.getVisible()!==v){o.setVisible(v);if(v){this._oDialog.addAriaLabelledBy(o);o.rerender();}else{this._oDialog.removeAriaLabelledBy(o);}}o.getContent()[0].setText(this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[s]));};
k.prototype._fireConfirmAndUpdateSelection=function(){var p={selectedItem:this._oSelectedItem,selectedItems:this._aSelectedItems};Object.defineProperty(p,"selectedContexts",{get:this._oList.getSelectedContexts.bind(this._oList,true)});this.fireConfirm(p);this._updateSelection();};
k.prototype._selectionChange=function(E){if(E.getParameters){this.fireSelectionChange(E.getParameters());}if(!this._oDialog){return;}if(this.getMultiSelect()){this._updateSelectionIndicator();return;}if(!this._bAfterCloseAttached){this._oDialog.attachEventOnce("afterClose",this._resetAfterClose,this);this._bAfterCloseAttached=true;}this._oDialog.close();};
k.prototype._resetAfterClose=function(){this._oSelectedItem=this._oList.getSelectedItem();this._aSelectedItems=this._oList.getSelectedItems();this._bAfterCloseAttached=false;this._fireConfirmAndUpdateSelection();};
k.prototype._updateSelection=function(){if(!this.getRememberSelections()&&!this.bIsDestroyed){this._removeSelection();}};
k.prototype._removeSelection=function(){this._oList.removeSelections(true);delete this._oSelectedItem;delete this._aSelectedItems;};
k.prototype._resetSelection=function(){if(!this.bIsDestroyed){this._oList.removeSelections(true);this._oList.setSelectedContextPaths(this._aInitiallySelectedContextPaths);this._oList.getItems().forEach(function(o){var p=o.getBindingContextPath();if(p&&this._aInitiallySelectedContextPaths.indexOf(p)>-1){o.setSelected(true);}},this);}};
k.prototype._getListItemsEventDelegates=function(){var E=function(o){var m=q(o.target).closest(".sapMLIB").control()[0];if(m._eventHandledByControl){return;}if(o&&o.isDefaultPrevented&&o.isMarked&&(o.isDefaultPrevented()||o.isMarked("preventSelectionChange"))){return;}if(o&&o.srcControl.isA("sap.m.GroupHeaderListItem")){return;}this._selectionChange(o);}.bind(this);return{ontap:E,onsapselect:E};};
return k;});
sap.ui.predefine('sap/m/SelectDialogBase',['sap/ui/Device','sap/ui/core/Control'],function(D,C){"use strict";
var S=C.extend("sap.m.SelectDialogBase",{
metadata:{library:"sap.m","abstract":true,properties:{},aggregations:{},events:{updateStarted:{parameters:{reason:{type:"string"},actual:{type:"int"},total:{type:"int"}}},updateFinished:{parameters:{reason:{type:"string"},actual:{type:"int"},total:{type:"int"}}},selectionChange:{parameters:{listItem:{type:"sap.m.ListItemBase"},listItems:{type:"sap.m.ListItemBase[]"},selected:{type:"boolean"},selectAll:{type:"boolean"}}}}},
renderer:{apiVersion:2,render:function(){}}
});
S.prototype._setInitialFocus=function(){if(!D.system.desktop){return;}var i=this._oSearchField;if(this.getItems().length){i=this.getItems()[0];}this._oDialog.setInitialFocus(i);};
return S;});
sap.ui.predefine('sap/m/SelectList',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/core/Item','./SelectListRenderer','sap/base/Log',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(l,C,a,I,b,S,L,q){"use strict";var t=l.touch;var c=l.SelectListKeyboardNavigationMode;
var d=a.extend("sap.m.SelectList",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false},_columnRatio:{type:"sap.m.SelectColumnRatio",group:"Appearance",visibility:"hidden"},_tabIndex:{type:"string",group:"Misc",visibility:"hidden",defaultValue:""},keyboardNavigationMode:{type:"sap.m.SelectListKeyboardNavigationMode",group:"Behavior",defaultValue:c.Delimited},hideDisabledItems:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{selectionChange:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}},itemPress:{parameters:{item:{type:"sap.ui.core.Item"}}}}}});
d.prototype._setSelectedIndex=function(i,_){var o;_=_||this.getItems();i=(i>_.length-1)?_.length-1:Math.max(0,i);o=_[i];if(o){this.setSelection(o);}};
d.prototype.updateItems=function(r,e){this.bItemsUpdated=false;this.destroyItems();this.updateAggregation("items");this.bItemsUpdated=true;if(e&&(e.detailedReason==="AddVirtualContext"||e.detailedReason==="RemoveVirtualContext")){this._bHasVirtualContext=true;return;}this._bHasVirtualContext=false;this.synchronizeSelection({forceSelection:false});setTimeout(this.synchronizeSelection.bind(this),0);};
d.prototype.refreshItems=function(){this.bItemsUpdated=false;this.refreshAggregation("items");};
d.prototype._activateItem=function(i){if(i instanceof b&&i&&i.getEnabled()){this.fireItemPress({item:i});if(this.getSelectedItem()!==i){this.setSelection(i);this.fireSelectionChange({selectedItem:i});}}};
d.prototype._queryEnabledItemsDomRefs=function(){return this.getItems().reduce(function(r,i){if(i.getEnabled()&&!(i.isA("sap.ui.core.SeparatorItem"))){r.push(i.getDomRef());}return r;},[]);};
d.prototype._handleARIAActivedescendant=function(){var A=q(document.activeElement).control(0),D=this.getDomRef();if(A&&D){D.setAttribute("aria-activedescendant",A.getId());}};
d.prototype.init=function(){this._iStartTimeout=0;this._iActiveTouchId=0;this._fStartX=0;this._fStartY=0;this._oItemNavigation=null;this._$ItemPressed=null;};
d.prototype.onBeforeRendering=function(){this.synchronizeSelection({forceSelection:false});};
d.prototype.onAfterRendering=function(){if(this.getKeyboardNavigationMode()===c.None){this.destroyItemNavigation();}else{this.createItemNavigation();}};
d.prototype.exit=function(){this.destroyItemNavigation();this._$ItemPressed=null;};
d.prototype.ontouchstart=function(e){if(t.countContained(e.touches,this.getId())>1||!this.getEnabled()){return;}e.setMarked();var T=e.targetTouches[0];this._iActiveTouchId=T.identifier;this._fStartX=T.pageX;this._fStartY=T.pageY;this._iStartTimeout=setTimeout(function(){var i=e.srcControl.$();if(i){i.addClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=i;}}.bind(this),100);};
d.prototype.ontouchmove=function(e){var T=null;if(!this.getEnabled()){return;}T=t.find(e.changedTouches,this._iActiveTouchId);if(T&&((Math.abs(T.pageX-this._fStartX)>10)||(Math.abs(T.pageY-this._fStartY)>10))){clearTimeout(this._iStartTimeout);if(this._$ItemPressed){this._$ItemPressed.removeClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=null;}}};
d.prototype.ontouchend=function(e){var T=null;if(!this.getEnabled()){return;}e.setMarked();T=t.find(e.changedTouches,this._iActiveTouchId);if(T){setTimeout(function(){if(this._$ItemPressed){this._$ItemPressed.removeClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=null;}this._iStartTimeout=null;}.bind(this),100);}};
d.prototype.ontouchcancel=d.prototype.ontouchend;
d.prototype.ontap=function(e){if(this.getEnabled()){e.setMarked();this._activateItem(e.srcControl);}};
d.prototype.onsapselect=function(e){if(this.getEnabled()){e.setMarked();e.preventDefault();this._activateItem(e.srcControl);}};
d.prototype.onAfterFocus=function(o){this._handleARIAActivedescendant();};
d.prototype.findFirstEnabledItem=function(e){e=e||this.getItems();for(var i=0;i<e.length;i++){if(e[i].getEnabled()){return e[i];}}return null;};
d.prototype.setSelection=function(i){this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",(i instanceof b)?i.getId():i);if(typeof i==="string"){i=C.byId(i);}this.setProperty("selectedKey",i?i.getKey():"",true);return this;};
d.prototype.synchronizeSelection=function(o){var k=this.getSelectedKey(),i=this.getItemByKey(""+k),f=true;if(o){f=!!o.forceSelection;}if(this.isSelectionSynchronized({selectedKey:k,firstItemWithKey:i,forceSelection:f})){return;}if(i&&(k!=="")){this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",i.getId(),true);}else if(f&&!this._bHasVirtualContext&&this.getDefaultSelectedItem()&&(!this.isBound("items")||this.bItemsUpdated)){try{this.setSelection(this.getDefaultSelectedItem());}catch(e){L.warning('Update failed due to exception. Loggable in support mode log',null,null,function(){return{exception:e};});}}};
d.prototype.isSelectionSynchronized=function(o){var s=this.getSelectedItem(),e,f,F;if(o){e=o.selectedKey;f=o.firstItemWithKey;F=o.forceSelection;}else{e=this.getSelectedKey();f=this.getItemByKey(e);F=this.getForceSelection();}if(F){if(!s){return false;}if(e===""&&s.getKey()===""){return true;}return e===s.getKey()&&s===f;}else{if(s===null&&e===""){return true;}if(e===""){return false;}return e===(s&&s.getKey())&&s===f;}};
d.prototype.getForceSelection=function(){return false;};
d.prototype.findLastEnabledItem=function(i){i=i||this.getItems();return this.findFirstEnabledItem(i.reverse());};
d.prototype.getVisibleItems=function(){for(var i=0,o,e=this.getItems(),v=[];i<e.length;i++){o=e[i];if(o.bVisible||(o.bVisible===undefined)){v.push(o);}}return v;};
d.prototype._getColumnsPercentages=function(){var r=this.getProperty("_columnRatio"),R,T,f;if(!r){return null;}R=r.split(":").map(function(n){return parseInt(n);});T=R[0]+R[1];f=Math.round(R[0]/T*100);return{firstColumn:f+"%",secondColumn:100-f+"%"};};
d.prototype.getSelectableItems=function(){return this.getEnabledItems(this.getVisibleItems()).filter(function(i){return!(i.isA("sap.ui.core.SeparatorItem"));});};
d.prototype.findItem=function(p,v){var m="get"+p.charAt(0).toUpperCase()+p.slice(1);for(var i=0,e=this.getItems();i<e.length;i++){if(e[i][m]()===v){return e[i];}}return null;};
d.prototype.getItemByText=function(T){return this.findItem("text",T);};
d.prototype.isItemSelected=function(i){return i&&(i.getId()===this.getAssociation("selectedItem"));};
d.prototype._getNonSeparatorItemsCount=function(){return this.getEnabledItems().filter(function(i){return!(i.isA("sap.ui.core.SeparatorItem"));}).length;};
d.prototype.getDefaultSelectedItem=function(i){return null;};
d.prototype.clearSelection=function(){this.setSelection(null);};
d.prototype.createItemNavigation=function(){var D;if(!this._oItemNavigation){this._oItemNavigation=new I(null,null,!this.getEnabled());this._oItemNavigation.attachEvent(I.Events.AfterFocus,this.onAfterFocus,this);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});this.addEventDelegate(this._oItemNavigation);}D=this.getDomRef();this._oItemNavigation.setRootDomRef(D);this._oItemNavigation.setItemDomRefs(this._queryEnabledItemsDomRefs(D));this._oItemNavigation.setCycling(false);this._oItemNavigation.setSelectedIndex(this.indexOfItem(this.getSelectedItem()));this._oItemNavigation.setPageSize(10);};
d.prototype.destroyItemNavigation=function(){if(this._oItemNavigation){this.removeEventDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}};
d.prototype.getItemNavigation=function(){return this._oItemNavigation;};
d.prototype.setSelectedItem=function(i){if(typeof i==="string"){this.setAssociation("selectedItem",i,true);i=C.byId(i);}if(!(i instanceof b)&&i!==null){return this;}if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);return this;};
d.prototype.setSelectedItemId=function(i){i=this.validateProperty("selectedItemId",i);this.setSelection(i);return this;};
d.prototype.setSelectedKey=function(k){k=this.validateProperty("selectedKey",k);var i=this.getItemByKey(k);if(i||(k==="")){if(!i&&k===""){i=this.getDefaultSelectedItem();}this.setSelection(i);return this;}return this.setProperty("selectedKey",k);};
d.prototype.getSelectedItem=function(){var s=this.getAssociation("selectedItem");return(s===null)?null:C.byId(s)||null;};
d.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
d.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
d.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
d.prototype.getEnabledItems=function(i){i=i||this.getItems();return i.filter(function(o){return o.getEnabled();});};
d.prototype.getItemByKey=function(k){return this.findItem("key",k);};
d.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(this.getItems().length===0){this.clearSelection();}else if(this.isItemSelected(i)){this.setSelection(this.getDefaultSelectedItem());}return i;};
d.prototype.removeAllItems=function(){var i=this.removeAllAggregation("items",true);this.$().children("li").remove();return i;};
d.prototype.destroyItems=function(){this.destroyAggregation("items",true);return this;};
d.prototype.setNoDataText=function(){};
return d;});
sap.ui.predefine('sap/m/SelectListRenderer',["sap/ui/core/Element","sap/ui/core/library","sap/ui/core/Icon","sap/ui/core/IconPool","sap/ui/Device"],function(E,c,I,a,D){"use strict";var T=c.TextDirection;var S={apiVersion:2};S.CSS_CLASS="sapMSelectList";
S.render=function(r,l){this.writeOpenListTag(r,l,{elementData:true});this.renderItems(r,l);this.writeCloseListTag(r,l);};
S.writeOpenListTag=function(r,l,s){var C=S.CSS_CLASS,t=l.getProperty("_tabIndex");if(s.elementData){r.openStart("ul",l);}else{r.openStart("ul");}r.class(C);if(l.getShowSecondaryValues()){r.class(C+"TableLayout");}if(!l.getEnabled()){r.class(C+"Disabled");}if(t){r.attr("tabindex",t);}r.style("width",l.getWidth());this.writeAccessibilityState(r,l);r.openEnd();};
S.writeCloseListTag=function(r,l){r.close("ul");};
S.renderItems=function(r,l){var s=l._getNonSeparatorItemsCount(),b=l.getHideDisabledItems()?l.getEnabledItems():l.getItems(),o=l.getSelectedItem(),C=1,d,f;for(var i=0;i<b.length;i++){f=i===0&&!o;d={selected:o===b[i],setsize:s,elementData:true};if(!(b[i]instanceof sap.ui.core.SeparatorItem)&&b[i].getEnabled()){d.posinset=C++;}this.renderItem(r,l,b[i],d,f);}};
S.renderDirAttr=function(r,t){if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}};
S.renderItem=function(r,l,i,s,f){if(!(i instanceof E)){return;}var e=i.getEnabled(),o=l.getSelectedItem(),C=S.CSS_CLASS,t=i.getTooltip_AsString(),b=i.getTextDirection(),d=l.getShowSecondaryValues(),g;r.openStart("li",s.elementData?i:null);if(!d){this.renderDirAttr(r,b);}if(i.getIcon&&i.getIcon()){r.class("sapMSelectListItemWithIcon");}if(i instanceof sap.ui.core.SeparatorItem){r.class(C+"SeparatorItem");if(d){r.class(C+"Row");}}else{r.class(C+"ItemBase");if(d){r.class(C+"Row");}else{r.class(C+"Item");}if(i.bVisible===false){r.class(C+"ItemBaseInvisible");}if(!e){r.class(C+"ItemBaseDisabled");}if(e&&D.system.desktop){r.class(C+"ItemBaseHoverable");}if(i===o||f){r.class(C+"ItemBaseSelected");}if(e){r.attr("tabindex","0");}}if(t){r.attr("title",t);}this.writeItemAccessibilityState.apply(this,arguments);r.openEnd();if(d){g=l._getColumnsPercentages();r.openStart("span");r.class(C+"Cell");r.class(C+"FirstCell");if(g){r.style("width",g.firstColumn);}r.attr("disabled","disabled");this.renderDirAttr(r,b);r.openEnd();this._renderIcon(r,i);r.text(i.getText());r.close("span");r.openStart("span");r.class(C+"Cell");r.class(C+"LastCell");if(g){r.style("width",g.secondColumn);}r.attr("disabled","disabled");r.openEnd();if(typeof i.getAdditionalText==="function"){r.text(i.getAdditionalText());}r.close("span");}else{this._renderIcon(r,i);r.text(i.getText());}r.close("li");};
S.writeAccessibilityState=function(r,l){r.accessibilityState(l,{role:"listbox"});};
S.writeItemAccessibilityState=function(r,l,i,s){var R=(i.isA("sap.ui.core.SeparatorItem"))?"separator":"option";var d;if(!i.getText()&&i.getIcon&&i.getIcon()){var o=a.getIconInfo(i.getIcon());if(o){d=o.text||o.name;}}r.accessibilityState(i,{role:R,selected:s.selected,setsize:s.setsize,posinset:s.posinset,label:d});};
S._renderIcon=function(r,i){if(i.getIcon&&i.getIcon()){r.icon(i.getIcon(),S.CSS_CLASS+"ItemIcon",{id:i.getId()+"-icon"});}};
return S;},true);
sap.ui.predefine('sap/m/SelectRenderer',['sap/ui/core/Renderer','sap/ui/core/IconPool','sap/m/library','sap/ui/Device','sap/ui/core/library'],function(R,I,l,D,c){"use strict";var T=c.TextDirection;var V=c.ValueState;var S=l.SelectType;var a={apiVersion:2};a.CSS_CLASS="sapMSlt";
a.render=function(r,s){var t=s.getType(),A=s.getAutoAdjustWidth(),e=s.getEditable(),E=s.getEnabled(),C=s.getWidth(),w=C.indexOf("%")>-1,b=A||C==="auto"||w,d=a.CSS_CLASS,f=E&&e;r.openStart("div",s);this.addClass(r,s);r.class(d);r.class(d+s.getType());if(!E){r.class(d+"Disabled");}else if(!e){r.class(d+"Readonly");}if(b&&(t===S.Default)){r.class(d+"MinWidth");}if(A){r.class(d+"AutoAdjustedWidth");}else{r.style("width",C);}if(s.getIcon()){r.class(d+"WithIcon");}if(f&&D.system.desktop){r.class(d+"Hoverable");}r.class(d+"WithArrow");if(s.getValueState()!==V.None&&f){this.addValueStateClasses(r,s);}r.style("max-width",s.getMaxWidth());if(E){r.attr("tabindex","-1");}r.openEnd();this.renderFocusElement(r,s);this.renderHiddenInput(r,s);this.renderLabel(r,s);switch(t){case S.Default:this.renderArrow(r,s);break;case S.IconOnly:this.renderIcon(r,s);break;}var L=s.getList();if(s._isShadowListRequired()&&L){this.renderShadowList(r,L);}this.renderAccessibilityDomNodes(r,s);r.close("div");};
a.renderFocusElement=function(r,s){var o=s.getSelectedItem(),t=s.getTooltip_AsString(),b=s.getType();r.openStart("div",s.getId()+"-hiddenSelect");this.writeAccessibilityState(r,s);r.class("sapUiPseudoInvisibleText");r.class(a.CSS_CLASS+"HiddenSelect");if(s.getEnabled()){r.attr("tabindex","0");}if(t){r.attr("title",t);}else if(b===S.IconOnly){var i=I.getIconInfo(s.getIcon());if(i){r.attr("title",i.text);}}r.openEnd();if(o){r.text(o.getText());}r.close('div');};
a.renderHiddenInput=function(r,s){r.voidStart("input",s.getId()+"-hiddenInput");r.attr("name",s.getName());r.attr("value",s.getSelectedKey());r.attr("aria-readonly","true");r.attr("tabindex","-1");r.attr("aria-hidden","true");r.attr("type","hidden");r.class("sapUiPseudoInvisibleText");r.voidEnd();};
a.renderLabel=function(r,s){var o=s.getSelectedItem(),t=s.getTextDirection(),b=R.getTextAlign(s.getTextAlign(),t),C=a.CSS_CLASS,e=s.getEnabled()&&s.getEditable(),d=s.getTooltip_AsString();r.openStart("span",s.getId()+"-label");r.attr("aria-hidden",true);r.class(C+"Label");if(d){r.attr("title",d);}if(s.getValueState()!==V.None&&e){r.class(C+"LabelState");r.class(C+"Label"+s.getValueState());}if(s.getType()===S.IconOnly){r.class("sapUiPseudoInvisibleText");}if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.style("text-align",b);r.openEnd();if(s.getType()!==S.IconOnly){r.renderControl(s._getValueIcon());r.openStart("span",s.getId()+"-labelText");r.class("sapMSelectListItemText");r.openEnd();r.text(o&&o.getParent()?o.getText():null);r.close("span");}r.close("span");};
a.renderArrow=function(r,s){var C=a.CSS_CLASS,t=s.getTooltip_AsString();r.openStart("span",s.getId()+"-arrow");r.attr("aria-hidden",true);r.class(C+"Arrow");if(s.getValueState()!==V.None){r.class(C+"ArrowState");}if(t){r.attr("title",t);}r.openEnd().close("span");};
a.renderIcon=function(r,s){var t=s.getTooltip_AsString(),i=I.getIconInfo(s.getIcon()),b=i&&i.text;r.icon(s.getIcon(),a.CSS_CLASS+"Icon",{id:s.getId()+"-icon",title:t||b||null});};
a.renderShadowList=function(r,L){var o=L.getRenderer();o.writeOpenListTag(r,L,{elementData:false});this.renderShadowItems(r,L);o.writeCloseListTag(r,L);};
a.renderShadowItems=function(r,L){var o=L.getRenderer(),b=L.getSelectableItems(),s=b.length,d=L.getSelectedItem();for(var i=0;i<s;i++){o.renderItem(r,L,b[i],{selected:d===b[i],setsize:s,posinset:i+1,elementData:false});}};
a.addClass=function(r,s){};
a.addValueStateClasses=function(r,s){r.class(a.CSS_CLASS+"State");r.class(a.CSS_CLASS+s.getValueState());};
a.getAriaRole=function(s){switch(s.getType()){case S.Default:return"combobox";case S.IconOnly:return"button";}};
a.writeAccessibilityState=function(r,s){var v=s.getValueState(),o=s.getSelectedItem(),i=s.getType()===S.IconOnly,b=s._getValueIcon(),e=s.getEnabled()&&s.getEditable(),L=[],A=[],d,f,g,h;s.getLabels().forEach(function(k){if(k&&k.getId){L.push(k.getId());}});if(s.isOpen()&&o&&o.getDomRef()){g=o.getId();}if(o&&!o.getText()&&o.getIcon&&o.getIcon()){var j=I.getIconInfo(o.getIcon());if(j){h=j.text||j.name;}}if(v!==V.None&&e){f=s.getValueStateMessageId()+"-sr";}if(h&&b){A.push(b.getId());}if(L.length){A=A.concat(L);}d={value:A.join(" "),append:true};r.accessibilityState(null,{role:this.getAriaRole(s),roledescription:s._sAriaRoleDescription,readonly:i?undefined:s.getEnabled()&&!s.getEditable(),required:s._isRequired()||undefined,disabled:!s.getEnabled()||undefined,expanded:s.isOpen(),invalid:(s.getValueState()===V.Error&&e)?true:undefined,labelledby:(i||d.value==="")?undefined:d,describedby:f,activedescendant:g,haspopup:s.getEditable()?"listbox":undefined});};
a.renderAccessibilityDomNodes=function(r,C){var v=C.getValueState(),s,e=C.getEnabled()&&C.getEditable();if(v===V.None||!e){return;}s=C._getValueStateText();r.openStart("div",C.getValueStateMessageId()+"-sr").class("sapUiPseudoInvisibleText").attr("aria-hidden",true).openEnd().text(s).close("div");};
return a;},true);
sap.ui.predefine('sap/m/SelectionDetails',['./library','sap/ui/core/Control','sap/m/Button','sap/ui/base/Interface','sap/ui/Device','sap/ui/core/library','./SelectionDetailsRenderer',"sap/base/util/uid","sap/ui/thirdparty/jquery"],function(l,C,B,I,D,a,S,u,q){"use strict";
var b=C.extend("sap.m.SelectionDetails",{metadata:{library:"sap.m",defaultAggregation:"items",aggregations:{"items":{type:"sap.m.SelectionDetailsItem",multiple:true,bindable:"bindable"},"actions":{type:"sap.ui.core.Item",multiple:true},"actionGroups":{type:"sap.ui.core.Item",multiple:true},"_popover":{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"},"_button":{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{beforeOpen:{},beforeClose:{},navigate:{parameters:{item:{type:"sap.m.SelectionDetailsItem"},direction:{type:"string"},content:{type:"sap.ui.core.Control"}}},actionPress:{parameters:{action:{type:"sap.ui.core.Item"},items:{type:"sap.m.SelectionDetailsItem"},level:{type:"sap.m.SelectionDetailsActionLevel"}}}}}});
b._MAX_ACTIONGROUPS=5;b._POPOVER_MAX_HEIGHT=500;
b.prototype.init=function(){this._bWrapLabels=false;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setAggregation("_button",new B({id:this.getId()+"-button",type:l.ButtonType.Transparent,press:[this._onToolbarButtonPress,this]}),true);this._oItemFactory=null;};
b.prototype.onBeforeRendering=function(){this._updateButton();};
b.prototype.onAfterRendering=function(){document.getElementById(this.getAggregation("_button").getId()).setAttribute("aria-haspopup","dialog");};
b.prototype.exit=function(){this.detachSelectionHandler();this._oItemFactory=null;this._oChangeHandler=null;};
b.prototype.isOpen=function(){var p=this.getAggregation("_popover");return p?p.isOpen():false;};
b.prototype.isEnabled=function(){return this.getItems().length>0;};
b.prototype.close=function(){var p=this.getAggregation("_popover");if(p){p.close();}return this;};
b.prototype.navTo=function(t,c){if(this.isOpen()){sap.ui.require(["sap/m/Page","sap/m/Toolbar","sap/m/ToolbarSpacer","sap/m/Title"],this._handleNavLazy.bind(this,t,c));}return this;};
b.prototype.getWrapLabels=function(){return this._bWrapLabels;};
b.prototype.setWrapLabels=function(w){var p=this.getAggregation("_popover");this._bWrapLabels=w;if(p&&p.isOpen()){p.invalidate();}return this;};
b.prototype.setPopoverModal=function(m){this._getPopover().setModal(m);return this;};
b.prototype._handleNavLazy=function(p,c,P,T,d,e,B){var s=this.getId()+"-page-for-"+c.getId()+"-uid-"+u();this._setPopoverHeight(b._POPOVER_MAX_HEIGHT);var o=new P(s,{customHeader:this._getPageToolbar(T,d,e,true,p),content:[c]});this._oNavContainer.addPage(o);this._oNavContainer.to(s);};
b.prototype._getPageToolbar=function(T,c,d,s,p){var t=new T({design:l.ToolbarDesign.Transparent}).addStyleClass("sapMSDPageHeader");if(s){var o=new B({icon:"sap-icon://nav-back",press:this._onBackButtonPress.bind(this)});t.addAggregation("content",o,true);}var e=new c();var f=new d({text:p,titleStyle:a.TitleLevel.H5});t.addAggregation("content",e,true);t.addAggregation("content",f,true);t.addAggregation("content",e.clone(),true);if(D.system.phone){t.addAggregation("content",this._getCloseButton(),true);}return t;};
b.prototype._setPopoverHeight=function(h){if(!D.system.phone){var p=this._getPopover(),P=p.$("cont"),m=this._getMaxPopoverHeight();h=Math.min(b._POPOVER_MAX_HEIGHT,h);p._oControl._deregisterContentResizeHandler();P.animate({"height":Math.min(h,m)},sap.ui.getCore().getConfiguration().getAnimation()?100:0,function(){p.setProperty("contentHeight",h+"px",true);p._oControl._registerContentResizeHandler();});}};
b.prototype._getMaxPopoverHeight=function(){var r=this._getPopover(),R=r.$(),o,v,p;if(!R.length){return 0;}o=R.offset().top;v=D.resize.height;p=r._oControl;p._adaptPositionParams();return v-o-p._marginBottom;};
b.prototype._onBackButtonPress=function(){var c=this._oNavContainer.getCurrentPage().getContent()[0];this._oNavContainer.attachEventOnce("afterNavigate",function(){this.fireNavigate({item:this._oItemForNavigation,direction:"back",content:c});},this);this._oNavContainer.back();if(this._oNavContainer.getCurrentPage()===this._oInitialPage){this._setPopoverHeight(this._getInitialPageHeight());}};
b.prototype._getCloseButton=function(){return new B({icon:"sap-icon://decline",press:this.close.bind(this)});};
b.prototype._aFacadeMethods=["addCustomData","getCustomData","indexOfCustomData","insertCustomData","removeCustomData","removeAllCustomData","destroyCustomData","data","addEventDelegate","removeEventDelegate","close","isOpen","isEnabled","attachBeforeOpen","detachBeforeOpen","attachBeforeClose","detachBeforeClose","attachNavigate","detachNavigate","attachActionPress","detachActionPress","addAction","removeAction","removeAllActions","addActionGroup","removeActionGroup","removeAllActionGroups","navTo","getWrapLabels","setWrapLabels"];
b.prototype.getFacade=function(){var f=new I(this,b.prototype._aFacadeMethods,true);f.getItems=this._getItemFacades.bind(this);this.getFacade=function(){return f;};return f;};
b.prototype._getItemFacades=function(){var c=this.getItems();var d=[];for(var i=0;i<c.length;i++){d.push(c[i].getFacade());}return d;};
b.prototype._updateButton=function(){var t,c,o=this.getAggregation("_button"),e;if(this._oSelectionData&&this._oSelectionData.length>=0){c=this._oSelectionData.length;}else{c=this.getItems().length;}if(c>0){t=this._oRb.getText("SELECTIONDETAILS_BUTTON_TEXT_WITH_NUMBER",[c]);e=true;}else{t=this._oRb.getText("SELECTIONDETAILS_BUTTON_TEXT");e=false;}o.setText(t);o.setEnabled(e);o.setTooltip(t);};
b.prototype._onToolbarButtonPress=function(){sap.ui.require(['sap/m/NavContainer','sap/m/ResponsivePopover','sap/m/Page',"sap/m/Toolbar",'sap/m/OverflowToolbar','sap/m/ToolbarSpacer','sap/m/Button','sap/m/List','sap/m/StandardListItem','sap/ui/layout/FixFlex','sap/m/ScrollContainer',"sap/m/Title"],this._handlePressLazy.bind(this));};
b.prototype._handlePressLazy=function(N,R,P,T,O,c,B,L,d,F,e,f){var p=this._getPopover(N,R,T,c,P,L,F,e,f);if(this._oItemFactory){this._callFactory();}this.fireBeforeOpen();this._addMainListItems();this._addActionGroupListItems(d);this._addListActions(O,c,B);this._oNavContainer.setProperty("defaultTransitionName","show",true);this._oNavContainer.to(this._oInitialPage);this._oNavContainer.setProperty("defaultTransitionName","slide",true);p.openBy(this.getAggregation("_button"));p.invalidate();};
b.prototype._callFactory=function(){var f=this._oItemFactory.factory,d=this._oItemFactory.data,s=this._oSelectionData,r;this.fireEvent("beforeUpdate",{items:this.getItems()});this.destroyAggregation("items",true);for(var i=0;i<s.length;i++){r=f(s[i].displayData,s[i].data,s[i].context,d,s[i].shapeString);if(r){r._sMarkerShapeString=s[i].shapeString;this.addAggregation("items",r,true);}}this.fireEvent("afterUpdate",{items:this.getItems()});};
b.prototype._getInitialPage=function(P,T,c,d){if(!this._oInitialPage){this._oInitialPage=new P(this.getId()+"-page",{showHeader:false,enableScrolling:false});if(D.system.phone){this._oInitialPage.setProperty("showHeader",true,true);this._oInitialPage.setAggregation("customHeader",this._getPageToolbar(T,c,d),true);}}return this._oInitialPage;};
b.prototype._getNavContainer=function(N){if(!this._oNavContainer){this._oNavContainer=new N(this.getId()+"-nav-container");}return this._oNavContainer;};
b.prototype._getPopover=function(N,R,T,c,P,L,F,d,e){var p=this.getAggregation("_popover"),n,o,m,A,M;if(!p){p=new R({id:this.getId()+"-popover",placement:l.PlacementType.Bottom,showHeader:false,contentWidth:"25rem",contentHeight:"500px",beforeClose:this.fireBeforeClose.bind(this)}).addStyleClass("sapMSD");p.setProperty=this._setPopoverProperty;o=this._getInitialPage(P,T,c,e);A=this._getActionGroupList(L);n=this._getNavContainer(N);M=this._getMainList(L);m=this._createMainContainer(F);m.setAggregation("flexContent",M,true);m.addAggregation("fixContent",A,true);o.addAggregation("content",m,true);n.addPage(o);p.addAggregation("content",n,true);if(!D.system.phone){p.addEventDelegate({onAfterRendering:this._updatePopoverContentHeight.bind(this)});}p.addEventDelegate({onBeforeRendering:function(){this.getWrapLabels()?p.addStyleClass("sapMSDWrapLabels"):p.removeStyleClass("sapMSDWrapLabels");}.bind(this)});this.setAggregation("_popover",p,true);}return p;};
b.prototype._setPopoverProperty=function(p,v){var P=this._oControl.getMetadata().getProperty(p);if(P&&p==="modal"&&this._oControl.setModal){this._oControl.setModal(v);}else{this._oControl.setProperty.apply(this._oControl,arguments);}return C.prototype.setProperty.apply(this,arguments);};
b.prototype._updatePopoverContentHeight=function(){var c=this._getInitialPageHeight(),p=this._getPopover();if(D.browser.edge&&this._oMainList.getDomRef()&&this._oMainList.getDomRef().getBoundingClientRect().height===0){p.setContentHeight(b._POPOVER_MAX_HEIGHT+"px");return;}if(this._oNavContainer.getCurrentPage()===this._oInitialPage&&c<b._POPOVER_MAX_HEIGHT){p.setProperty("contentHeight",c+"px",true);}else{p.setProperty("contentHeight",b._POPOVER_MAX_HEIGHT+"px",true);}};
b.prototype._getInitialPageHeight=function(){var f=this._oInitialPage&&this._oInitialPage.getFooter(),L=this._oMainList.$().outerHeight(),A=this._oActionGroupList.$().outerHeight(),t=f&&f.$().outerHeight()||0;return L+A+t;};
b.prototype._createMainContainer=function(F){return new F(this.getId()+"-mainContainer",{fixFirst:false,minFlexSize:-1});};
b.prototype._getMainList=function(L){if(!this._oMainList){this._oMainList=new L(this.getId()+"-list");}return this._oMainList;};
b.prototype._addMainListItems=function(){var i,c,L;this._oMainList.removeAllAggregation("items",true);c=this.getItems();for(i=0;i<c.length;i++){if(!c[i].hasListeners("_navigate")){c[i].attachEvent("_navigate",this._onNavigate,this);}if(!c[i].hasListeners("_actionPress")){c[i].attachEvent("_actionPress",this._onActionPress,this);}L=c[i]._getListItem();this._oMainList.addAggregation("items",L,true);}};
b.prototype._getActionGroupList=function(L){if(!this._oActionGroupList){this._oActionGroupList=new L(this.getId()+"-actionGroupList",{showNoData:false});}return this._oActionGroupList;};
b.prototype._addActionGroupListItems=function(c){this._oActionGroupList.destroyAggregation("items",true);var A=this.getActionGroups(),s,i,d=Math.min(b._MAX_ACTIONGROUPS,A.length);for(i=0;i<d;i++){s=new c(this.getId()+"-actionGroup-"+i,{title:A[i].getText(),type:l.ListType.Navigation,press:[{action:A[i],level:l.SelectionDetailsActionLevel.Group},this._onActionPress,this]});if(i===0){s.addStyleClass("sapMSDFirstActionGroup");}this._oActionGroupList.addAggregation("items",s,true);}};
b.prototype._addListActions=function(O,T,B){var o,i,A,c,t;this._oInitialPage.destroyAggregation("footer",true);if(!this.getActions().length){return;}t=new O(this.getId()+"-action-toolbar").addStyleClass("sapContrast sapContrastPlus");this._oInitialPage.setAggregation("footer",t,true);t.addAggregation("content",new T(),true);A=this.getActions();for(i=0;i<A.length;i++){c=A[i];o=new B(this.getId()+"-action-"+i,{text:c.getText(),enabled:c.getEnabled(),press:[{action:c,level:l.SelectionDetailsActionLevel.List},this._onActionPress,this]});t.addAggregation("content",o,true);}};
b.prototype._onActionPress=function(e,d){this.fireActionPress({action:d&&d.action||e.getParameter("action"),items:e.getParameter("items")||this.getItems(),level:d&&d.level||e.getParameter("level")});};
b.prototype._onNavigate=function(e){this._oItemForNavigation=e.getSource();this.fireNavigate({item:e.getSource(),direction:"to"});};
b.prototype._handleSelectionChange=function(e){var E=e.getParameter("data");if(Array.isArray(E)){this._oSelectionData=E;this._updateButton();}};
b.prototype.registerSelectionDetailsItemFactory=function(d,f){if(typeof(d)==="function"){f=d;d=undefined;}if(typeof f==="function"){this._oItemFactory={factory:f,data:d};}return this;};
b.prototype.attachSelectionHandler=function(e,c){if(!this._oChangeHandler&&typeof e==="string"&&c&&typeof c.attachEvent==="function"){this._oChangeHandler={eventId:e,listener:c};c.attachEvent(e,this._handleSelectionChange,this);}return this;};
b.prototype.detachSelectionHandler=function(){if(this._oChangeHandler){this._oChangeHandler.listener.detachEvent(this._oChangeHandler.eventId,this._handleSelectionChange,this);this._oChangeHandler=null;}return this;};
return b;});
sap.ui.predefine('sap/m/SelectionDetailsItem',["sap/ui/core/Element","sap/m/ListItemBase","./library","sap/m/Button","sap/m/OverflowToolbar","sap/m/ToolbarSpacer","sap/ui/base/Interface","./SelectionDetailsListItemRenderer"],function(E,L,l,B,O,T,I,S){"use strict";
var a=L.extend("sap.m.SelectionDetailsListItem",{renderer:S});
a.prototype.onBeforeRendering=function(){var t;if(this._getParentElement().getEnableNav()){t=l.ListType.Navigation;}else{t=l.ListType.Inactive;}this.setProperty("type",t,true);};
var b=E.extend("sap.m.SelectionDetailsItem",{metadata:{library:"sap.m",properties:{enableNav:{type:"boolean",defaultValue:false,group:"Behavior"}},aggregations:{lines:{type:"sap.m.SelectionDetailsItemLine",multiple:true,bindable:"bindable"},actions:{type:"sap.ui.core.Item",multiple:true},_overflowToolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"}}}});
b.prototype.exit=function(){if(this._oListItem){this._oListItem.destroy();this._oListItem=null;}};
b.prototype._aFacadeMethods=["addCustomData","getCustomData","indexOfCustomData","insertCustomData","removeCustomData","removeAllCustomData","destroyCustomData","data","addEventDelegate","removeEventDelegate","setEnableNav","getEnableNav","addAction","removeAction"];
b.prototype.getFacade=function(){var f=new I(this,b.prototype._aFacadeMethods);this.getFacade=function(){return f;};return f;};
b.prototype._getListItem=function(){if(!this._oListItem){this._oListItem=new a({press:[this._onSelectionDetailsListItemPress,this]});this._oListItem._getParentElement=function(){return this;}.bind(this);this._addOverflowToolbar();}return this._oListItem;};
b.prototype._onSelectionDetailsListItemPress=function(){this.fireEvent("_navigate");};
b.prototype._addOverflowToolbar=function(){var c=this.getActions(),i,o;this.destroyAggregation("_overflowToolbar");if(c.length===0){return;}var t=new O(this.getId()+"-action-toolbar");this.setAggregation("_overflowToolbar",t,true);t.addAggregation("content",new T(),true);for(i=0;i<c.length;i++){o=new B(this.getId()+"-action-"+i,{text:c[i].getText(),type:l.ButtonType.Transparent,enabled:c[i].getEnabled(),press:[c[i],this._onActionPress,this]});t.addAggregation("content",o,true);}};
b.prototype._onActionPress=function(e,A){this.fireEvent("_actionPress",{action:A,items:[this],level:l.SelectionDetailsActionLevel.Item});};
return b;});
sap.ui.predefine('sap/m/SelectionDetailsItemLine',["sap/ui/core/Element","sap/base/Log","sap/base/util/isPlainObject","sap/ui/thirdparty/jquery"],function(E,L,i,q){"use strict";
var S=E.extend("sap.m.SelectionDetailsItemLine",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Data"},value:{type:"any",group:"Data"},displayValue:{type:"string",defaultValue:null,group:"Data"},unit:{type:"string",defaultValue:null,group:"Data"},lineMarker:{type:"string",defaultValue:null,group:"Data"}}}});
S.prototype._getValueToRender=function(){var v="",V=this.getValue();if(typeof V==="string"||V instanceof String){v=V;}else if(typeof V==="number"){v=V.toString();}else if(i(V)){if(V.day&&V.day.length>0){v=V.day;}if(V.time&&V.time.length>0){v=(v.length>0)?V.time+" "+v:V.time;}}else{L.warning("Value '"+V+"' is not supported. Expected type is a string, number or a plain object, including date and time properties of type string.");}return v;};
return S;});
sap.ui.predefine('sap/m/SelectionDetailsListItemRenderer',["sap/ui/core/Renderer","sap/m/ListItemBaseRenderer"],function(R,L){"use strict";var T={"svg":{attributes:["width","height","focusable","preserveAspectRatio"]},"path":{attributes:["d","fill","transform","stroke","stroke-width"]},"line":{attributes:["x1","x2","y1","y2","stroke-width","stroke","stroke-dasharray","stroke-linecap"]}};
function e(d,c){var i;if(!d){return true;}for(i=0;i<d.length;i++){if(!c(d[i])){return false;}}return true;}
function a(n){if(n.nodeType!==window.Node.ELEMENT_NODE){return true;}var t=n.tagName.toLowerCase(),o=T[t],b;if(!o){return false;}b=e(n.attributes,function(c){if(c.value===""){return true;}var A=c.name.toLowerCase();return o.attributes.indexOf(A)>=0;});if(!b){return false;}if(!o.allowTextContenet&&n.textContent.trim().length>0){return false;}return e(n.childNodes,a);}
var S=R.extend(L);S.apiVersion=2;
S.renderLIAttributes=function(r,c){r.class("sapMSDItem");};
S.renderLIContent=function(r,c){var l=c._getParentElement().getLines();r.openStart("div");r.class("sapMSDItemLines");r.openEnd();for(var i=0;i<l.length;i++){this.renderLine(r,c,l[i]);}r.close("div");L.renderType(r,c);};
S._isValidSvg=function(d){try{var p=new DOMParser(),D=p.parseFromString(d,"text/html");var n=D.body.childNodes;if(n.length===0){return false;}return e(n,a);}catch(b){return false;}};
S.renderLine=function(r,c,l){var u=l.getUnit().trim(),v=l._getValueToRender(),d=l.getDisplayValue(),s=l.getLineMarker();r.openStart("div");r.class("sapMSDItemLine");r.openEnd();r.openStart("div");r.class("sapMSDItemLineMarkerContainer");r.openEnd();if(s&&S._isValidSvg(s)){r.unsafeHtml(s);}r.close("div");r.openStart("div");r.class("sapMSDItemLineLabel");r.openEnd();r.text(l.getLabel());r.close("div");r.openStart("div");r.class("sapMSDItemLineValue");if(u){r.class("sapMSDItemLineBold");}r.openEnd();if(d){r.text(d);}else{r.text(v);}if(u){r.openStart("span");r.class("sapMSDItemLineUnit");r.openEnd();r.text("\u00a0");r.text(u);r.close("span");}r.close("div");r.close("div");};
S.renderType=function(r,c){var t=c._getParentElement().getAggregation("_overflowToolbar");if(t){r.openStart("div");r.class("sapMSDItemActions");r.openEnd();r.renderControl(t);r.close("div");}};
return S;},true);
sap.ui.predefine('sap/m/SelectionDetailsRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,c){var b=c.getAggregation("_button");r.openStart("div",c);r.openEnd();r.renderControl(b);r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/Shell',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/library','sap/m/ShellRenderer',"sap/ui/util/Mobile","sap/base/Log","sap/ui/core/theming/Parameters"],function(l,C,a,c,S,M,L,T){"use strict";var b=c.TitleLevel;
var d=a.extend("sap.m.Shell",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},logo:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},showLogout:{type:"boolean",group:"Behavior",defaultValue:true},headerRightText:{type:"string",group:"Data",defaultValue:null},appWidthLimited:{type:"boolean",group:"Appearance",defaultValue:true},backgroundColor:{type:"sap.ui.core.CSSColor",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1},homeIcon:{type:"object",group:"Misc",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:b.H1}},defaultAggregation:"app",aggregations:{app:{type:"sap.ui.core.Control",multiple:false}},events:{logout:{}}}});
d.prototype.init=function(){C.attachThemeChanged(function(){var $=this.$("hdr"),i=this._getImageSrc();if($.length&&i){this._getImage().setSrc(i);this._getImage().rerender();}},this);M.init({statusBar:"default",hideBrowser:true});};
d.prototype.onBeforeRendering=function(){var i=this._getImageSrc();if(i){this._getImage().setSrc(i);}};
d.prototype.onAfterRendering=function(){var r=this.getDomRef().parentNode;if(r&&!r._sapui5_heightFixed){r._sapui5_heightFixed=true;while(r&&r!==document.documentElement){if(r.getAttribute("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}}this.$("content").css("height","");};
d.prototype.exit=function(){if(this.oImg){this.oImg.destroy();}};
d.prototype.ontap=function(e){if(e.target.className&&e.target.className.indexOf&&e.target.className.indexOf("sapMShellHeaderLogout")>-1){this.fireLogout();}};
d.prototype.setTitle=function(t){this.$("hdrTxt").text(t);this.setProperty("title",t,true);return this;};
d.prototype.setHeaderRightText=function(t){this.setProperty("headerRightText",t,true);if(!t){t="";}this.$("hdrRightTxt").text(t).css("display",(t?"inline":"none"));return this;};
d.prototype.setAppWidthLimited=function(e){this.$().toggleClass("sapMShellAppWidthLimited",e);this.setProperty("appWidthLimited",e,true);return this;};
d.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){L.warning("Invalid value "+o+" for Shell.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}this.$("BG").css("opacity",o);return this.setProperty("backgroundOpacity",o,true);};
d.prototype.setHomeIcon=function(i){this.setProperty("homeIcon",i,true);M.setIcons(i);return this;};
d.prototype._getImage=function(){if(!this.oImg){this.oImg=new sap.m.Image(this.getId()+"-logo",{decorative:false,alt:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SHELL_ARIA_LOGO")});this.oImg.addStyleClass("sapMShellLogoImg");}return this.oImg;};
d.prototype._getImageSrc=function(){return this.getLogo()?this.getLogo():T._getThemeImage();};
return d;});
sap.ui.predefine('sap/m/ShellRenderer',['sap/ui/core/library','sap/m/library'],function(c,l){"use strict";var B=l.BackgroundHelper;var T=c.TitleLevel;var S={apiVersion:2};
S.render=function(r,C){var t=(C.getTitleLevel()===T.Auto)?T.H1:C.getTitleLevel();t=t.toLowerCase();r.openStart("div",C);r.class("sapMShell");if(C.getAppWidthLimited()){r.class("sapMShellAppWidthLimited");}B.addBackgroundColorStyles(r,C.getBackgroundColor(),C.getBackgroundImage(),"sapMShellGlobalOuterBackground");var s=C.getTooltip_AsString();if(s){r.attr("title",s);}r.openEnd();B.renderBackgroundImageTag(r,C,["sapContrastPlus","sapMShellBG","sapUiGlobalBackgroundImageForce"],C.getBackgroundImage(),C.getBackgroundRepeat(),C.getBackgroundOpacity());r.openStart("div");r.class("sapMShellBrandingBar");r.openEnd();r.close("div");r.openStart("div");r.class("sapMShellCentralBox");r.openEnd();var e="",a="";if(!C.getBackgroundImage()){e="sapMShellBackgroundColorOnlyIfDefault";a="sapUiGlobalBackgroundImageOnlyIfDefault";}r.openStart("header",C.getId()+"-hdr");r.class("sapMShellHeader");r.class(e);r.openEnd();r.openStart("div");r.class(a);r.openEnd();r.close("div");S.renderLogoImage(r,C);if(C.getTitle()){r.openStart(t,C.getId()+"-hdrTxt");r.class("sapMShellHeaderText");r.openEnd();r.text(C.getTitle());r.close(t);}r.openStart("span");r.class("sapMShellHeaderRight");r.openEnd();r.openStart("span",C.getId()+"-hdrRightTxt");if(!C.getHeaderRightText()){r.style("display","none");}r.class("sapMShellHeaderRightText");r.openEnd();r.text(C.getHeaderRightText());r.close("span");if(C.getShowLogout()){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");r.openStart("a",C.getId()+"-logout");r.attr("tabindex","0");r.attr("role","button");r.class("sapMShellHeaderLogout");r.openEnd();r.text(b.getText("SHELL_LOGOUT"));r.close("a");}r.close("span");r.close("header");r.openStart("div",C.getId()+"-content");r.attr("data-sap-ui-root-content","true");r.class("sapMShellContent");r.class("sapMShellGlobalInnerBackground");r.openEnd();r.renderControl(C.getApp());r.close("div");r.close("div");r.close("div");};
S.renderLogoImage=function(r,C){if(C._getImageSrc()){r.openStart("div");r.class("sapMShellLogo");r.openEnd();r.renderControl(C._getImage());r.close("div");}};
return S;},true);
sap.ui.predefine('sap/m/SimpleFixFlex',['sap/ui/core/Control','sap/ui/core/ResizeHandler','sap/base/Log','./SimpleFixFlexRenderer'],function(C,R,L){"use strict";
var S=C.extend("sap.m.SimpleFixFlex",{metadata:{library:"sap.m",aggregations:{fixContent:{type:"sap.ui.core.Control",multiple:false},flexContent:{type:"sap.ui.core.Control",multiple:true}},properties:{fitParent:{type:"boolean",group:"Appearance",defaultValue:true}}}});
S.FIX_AREA_CHARACTER_COUNT_RECOMMENDATION=200;S.FIX_AREA_CHARACTERS_ABOVE_RECOMMENDED_WARNING="It is recommended to use less than "+S.FIX_AREA_CHARACTER_COUNT_RECOMMENDATION+" characters as a value state text.";
S.prototype.onBeforeRendering=function(){this._deregisterFixContentResizeHandler();var f=this.getFixContent();if(f&&f.isA("sap.m.Text")&&f.getText().length>S.FIX_AREA_CHARACTER_COUNT_RECOMMENDATION){L.warning(S.FIX_AREA_CHARACTERS_ABOVE_RECOMMENDED_WARNING,"",this.getId());}};
S.prototype.onAfterRendering=function(){if(this.getFitParent()){this._registerFixContentResizeHandler();}};
S.prototype._registerFixContentResizeHandler=function(){var f=this.getFixContent();if(!this._sResizeListenerId&&f&&f.getDomRef()){this._sResizeListenerId=R.register(f.getDomRef(),this._onFixContentResize.bind(this));this._onFixContentResize();}};
S.prototype._deregisterFixContentResizeHandler=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
S.prototype._onFixContentResize=function(){var $=this.$(),a=this.getFixContent().$(),f=a.get(0);if(!f||!f.clientHeight){return null;}$.css("padding-top",f.clientHeight);a.addClass("sapUiSimpleFixFlexFixedWrap");};
S.prototype.exit=function(){this._deregisterFixContentResizeHandler();};
return S;});
sap.ui.predefine('sap/m/SimpleFixFlexRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,c){var f=c.getFixContent();r.openStart('div',c);r.class('sapUiSimpleFixFlex');r.openEnd();if(f){r.renderControl(f.addStyleClass('sapUiSimpleFixFlexFixed'));}this.renderFlexContentContainer(r,c);r.close('div');};
S.renderFlexContentContainer=function(r,c){var f=c.getFlexContent();r.openStart('div',c.getId()+"-flexContentContainer");r.class('sapUiSimpleFixFlexFlexContentContainer');r.openEnd();if(f){r.openStart('div');r.class('sapUiSimpleFixFlexFlexContent');r.openEnd();f.forEach(function(c){r.renderControl(c);});r.close('div');}r.close('div');};
return S;},true);
sap.ui.predefine('sap/m/SinglePlanningCalendar',['./library','./PlanningCalendarHeader','./SegmentedButtonItem',"./SinglePlanningCalendarWeekView",'./SinglePlanningCalendarGrid','./SinglePlanningCalendarMonthGrid','./SinglePlanningCalendarRenderer','sap/base/Log','sap/ui/core/Control','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','sap/ui/core/format/DateFormat','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/DateRange','sap/ui/unified/DateTypeRange','sap/ui/unified/library','sap/ui/base/ManagedObjectObserver',"sap/ui/thirdparty/jquery"],function(l,P,S,a,b,c,d,L,C,I,R,D,e,f,g,h,u,M,q){"use strict";var j=l.PlanningCalendarStickyMode;var H="_sHeaderResizeHandlerId";var k=4;var m="--item";
var n=C.extend("sap.m.SinglePlanningCalendar",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:""},startDate:{type:"object",group:"Data"},startHour:{type:"int",group:"Data",defaultValue:0},endHour:{type:"int",group:"Data",defaultValue:24},fullDay:{type:"boolean",group:"Data",defaultValue:true},stickyMode:{type:"sap.m.PlanningCalendarStickyMode",group:"Behavior",defaultValue:j.None},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsResize:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsCreate:{type:"boolean",group:"Misc",defaultValue:false},firstDayOfWeek:{type:"int",group:"Appearance",defaultValue:-1}},aggregations:{actions:{type:"sap.ui.core.Control",multiple:true,singularName:"action",forwarding:{getter:"_getHeader",aggregation:"actions"}},appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",forwarding:{getter:"_getCurrentGrid",aggregation:"appointments"}},views:{type:"sap.m.SinglePlanningCalendarView",multiple:true,singularName:"view"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate",forwarding:{getter:"_getCurrentGrid",aggregation:"specialDates"}},_header:{type:"sap.m.PlanningCalendarHeader",multiple:false,visibility:"hidden"},_grid:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_mvgrid:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{selectedView:{type:"sap.m.SinglePlanningCalendarView",multiple:false},legend:{type:"sap.m.PlanningCalendarLegend",multiple:false}},events:{appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"}}},appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},copy:{type:"boolean"}}},appointmentResize:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"}}},appointmentCreate:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},headerDateSelect:{parameters:{date:{type:"object"}}},startDateChange:{parameters:{date:{type:"object"}}},cellPress:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},moreLinkPress:{parameters:{date:{type:"object"}}},viewChange:{}}}});
n.prototype.init=function(){var o=this.getId();this._oRB=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oDefaultView=new a({key:"DEFAULT_INNER_WEEK_VIEW_CREATED_FROM_CONTROL",title:""});this.setAssociation("selectedView",this._oDefaultView);this.setAggregation("_header",this._createHeader());this.setAggregation("_grid",new b(o+"-Grid"));this.setAggregation("_mvgrid",new c(o+"-GridMV"));this._attachHeaderEvents();this._attachGridEvents();this._attachDelegates();this.setStartDate(new Date());};
n.prototype.onBeforeRendering=function(){this._toggleStickyClasses();};
n.prototype.onAfterRendering=function(){var o=this._getHeader();this._adjustColumnHeadersTopOffset();this.toggleStyleClass("sapMSinglePCActionsHidden",!o._getActionsToolbar().getVisible());this._registerResizeHandler(H,o,this._onHeaderResize.bind(this));};
n.prototype.exit=function(){if(this._oDefaultView){this._oDefaultView.destroy();this._oDefaultView=null;}if(this._afterRenderFocusCell){this.removeDelegate(this._afterRenderFocusCell);this._afterRenderFocusCell=null;}this._deRegisterResizeHandler(H);};
n.prototype._onHeaderResize=function(E){if(E.oldSize.height===E.size.height){return this;}this.toggleStyleClass("sapMSinglePCActionsHidden",!this._getHeader()._getActionsToolbar().getVisible());this._adjustColumnHeadersTopOffset();return this;};
n.prototype.setTitle=function(t){this._getHeader().setTitle(t);return this.setProperty("title",t);};
n.prototype.setStartDate=function(o){this.setProperty("startDate",o);this._alignColumns();return this;};
n.prototype.setStartHour=function(i){this.getAggregation("_grid").setStartHour(i);this.setProperty("startHour",i);return this;};
n.prototype.setEndHour=function(i){this.getAggregation("_grid").setEndHour(i);this.setProperty("endHour",i);return this;};
n.prototype.setFullDay=function(F){this.getAggregation("_grid").setFullDay(F);this.setProperty("fullDay",F);return this;};
n.prototype.setEnableAppointmentsDragAndDrop=function(E){this.getAggregation("_grid").setEnableAppointmentsDragAndDrop(E);this.getAggregation("_mvgrid").setEnableAppointmentsDragAndDrop(E);return this.setProperty("enableAppointmentsDragAndDrop",E,true);};
n.prototype.setEnableAppointmentsResize=function(E){this.getAggregation("_grid").setEnableAppointmentsResize(E);return this.setProperty("enableAppointmentsResize",E,true);};
n.prototype.setEnableAppointmentsCreate=function(E){this.getAggregation("_grid").setEnableAppointmentsCreate(E);return this.setProperty("enableAppointmentsCreate",E,true);};
n.prototype._toggleStickyClasses=function(){var s=this.getStickyMode();this.toggleStyleClass("sapMSinglePCStickyAll",s===j.All);this.toggleStyleClass("sapMSinglePCStickyNavBarAndColHeaders",s===j.NavBarAndColHeaders);return this;};
n.prototype._adjustColumnHeadersTopOffset=function(){var s=this.getStickyMode(),G=this.getAggregation("_grid"),o=G&&G._getColumnHeaders(),t;if(!o||!o.getDomRef()){return this;}switch(s){case j.All:t=this._getHeader().$().outerHeight();break;case j.NavBarAndColHeaders:t=this._getHeader()._getNavigationToolbar().$().outerHeight();break;default:t="auto";break;}o.$().css("top",t);o._setTopPosition(t);return this;};
n.prototype.addView=function(v){var V,o=this._getHeader(),s=v.getId()+m,i;if(!v){return this;}if(this._isViewKeyExisting(v.getKey())){L.error("There is an existing view with the same key.",this);return this;}this.addAggregation("views",v);V=o._getOrCreateViewSwitch();i=new S(s,{key:v.getKey(),text:v.getTitle()});V.addItem(i);this._observeViewTitle(v);if(this._getSelectedView().getKey()===this._oDefaultView.getKey()){this.setAssociation("selectedView",v);}this._alignView();if(this.getViews().length>k){o._convertViewSwitchToSelect();}return this;};
n.prototype.insertView=function(v,p){var V,o=this._getHeader(),s=v.getId()+m,i;if(!v){return this;}if(this._isViewKeyExisting(v.getKey())){L.error("There is an existing view with the same key.",this);return this;}this.insertAggregation("views",v,p);V=o._getOrCreateViewSwitch();i=new S(s,{key:v.getKey(),text:v.getTitle()});V.insertItem(i,p);this._observeViewTitle(v);if(this._getSelectedView().getKey()===this._oDefaultView.getKey()){this.setAssociation("selectedView",v);}this._alignView();if(this.getViews().length>k){o._convertViewSwitchToSelect();}return this;};
n.prototype.removeView=function(v){if(!v){return this;}var o=this._getHeader(),V=o._getOrCreateViewSwitch(),p=V.getItems(),r=this._getSelectedView(),s=v.getKey(),t,i;if(this.getViews().length===1){this._disconnectAndDestroyViewsObserver();}else{this._oViewsObserver.unobserve(v,{properties:["title"]});}for(i=0;i<p.length;i++){t=p[i];if(t.getKey()===s){V.removeItem(t);break;}}this.removeAggregation("views",v);if(s===r.getKey()){this.setAssociation("selectedView",this.getViews()[0]||this._oDefaultView);}this._alignView();if(this.getViews().length<=k){o._convertViewSwitchToSegmentedButton();}return this;};
n.prototype.removeAllViews=function(){var v=this._getHeader()._getOrCreateViewSwitch();this._disconnectAndDestroyViewsObserver();v.removeAllItems();this.setAssociation("selectedView",this._oDefaultView);this._alignView();return this.removeAllAggregation("views");};
n.prototype.destroyViews=function(){var v=this._getHeader()._getOrCreateViewSwitch();this._disconnectAndDestroyViewsObserver();v.destroyItems();this.setAssociation("selectedView",this._oDefaultView);this._alignView();return this.destroyAggregation("views");};
n.prototype._viewsObserverCallbackFunction=function(o){sap.ui.getCore().byId(o.object.getId()+m).setText(o.current);};
n.prototype._getViewsObserver=function(){if(!this._oViewsObserver){this._oViewsObserver=new M(this._viewsObserverCallbackFunction);}return this._oViewsObserver;};
n.prototype._observeViewTitle=function(v){this._getViewsObserver().observe(v,{properties:["title"]});};
n.prototype._disconnectAndDestroyViewsObserver=function(){if(this._oViewsObserver){this._oViewsObserver.disconnect();this._oViewsObserver.destroy();this._oViewsObserver=null;}};
n.prototype.setSelectedView=function(v){if(typeof v==="string"){v=this._getViewById(v);}else if(v.isA("sap.m.SinglePlanningCalendarView")&&!this._isViewKeyExisting(v.getKey())){v=null;}if(!v){L.error("There is no such view.",this);return this;}this._setupNewView(v);this._getHeader()._getOrCreateViewSwitch().setSelectedKey(v.getKey());return this;};
n.prototype.getSelectedAppointments=function(){return this.getAggregation("_grid").getSelectedAppointments();};
n.prototype.setLegend=function(v){var o,s,i;this.setAssociation("legend",v);this.getAggregation("_grid").setAssociation("legend",v);this.getAggregation("_mvgrid").setAssociation("legend",v);s=this.getLegend();if(s){this.getAggregation("_grid")._sLegendId=s;this.getAggregation("_mvgrid")._sLegendId=s;i=sap.ui.getCore().byId(s);}if(i){o=new M(function(p){this.invalidate();}.bind(this));o.observe(i,{destroy:true});}return this;};
n.prototype.setFirstDayOfWeek=function(F){if(F<-1||F>6){L.error(""+F+" is not a valid value to the property firstDayOfWeek. Valid values are from -1 to 6.");return;}this.setProperty("firstDayOfWeek",F);this.getViews().forEach(function(v){v.setFirstDayOfWeek(F);});var o=this._getHeader(),p=o.getAggregation("_calendarPicker")?o.getAggregation("_calendarPicker"):o._oPopup.getContent()[0],s=this._getSelectedView(),i=this.getStartDate()||new Date(),r=s.calculateStartDate(new Date(i.getTime())),t=this.getAggregation("_mvgrid");this.setStartDate(r);t.setFirstDayOfWeek(F);p.setFirstDayOfWeek(F);return this;};
n.prototype._alignView=function(){this._switchViewButtonVisibility();this._alignColumns();return this;};
n.prototype._createHeader=function(){var o=new P(this.getId()+"-Header");o.getAggregation("_actionsToolbar").addAriaLabelledBy(I.getStaticId("sap.m","SPC_ACTIONS_TOOLBAR"));o.getAggregation("_navigationToolbar").addAriaLabelledBy(I.getStaticId("sap.m","SPC_NAVIGATION_TOOLBAR"));return o;};
n.prototype._isViewKeyExisting=function(K){return this.getViews().some(function(v){return v.getKey()===K;});};
n.prototype.getViewByKey=function(K){var v=this.getViews(),i;for(i=0;i<v.length;i++){if(v[i].getKey()===K){return v[i];}}return null;};
n.prototype._getViewById=function(s){var v=this.getViews(),i;for(i=0;i<v.length;i++){if(v[i].getId()===s){return v[i];}}return null;};
n.prototype._getSelectedView=function(){var s,v=this.getViews(),o=sap.ui.getCore().byId(this.getAssociation("selectedView")).getKey();for(var i=0;i<v.length;i++){if(o===v[i].getKey()){s=v[i];break;}}return s||this._oDefaultView;};
n.prototype._switchViewButtonVisibility=function(){var s=this._getHeader()._getOrCreateViewSwitch(),v=s.getItems().length>1;s.setProperty("visible",v);return this;};
n.prototype._attachHeaderEvents=function(){var o=this._getHeader();o.attachEvent("viewChange",this._handleViewChange,this);o.attachEvent("pressPrevious",this._handlePressArrow,this);o.attachEvent("pressToday",this._handlePressToday,this);o.attachEvent("pressNext",this._handlePressArrow,this);o.attachEvent("dateSelect",this._handleCalendarPickerDateSelect,this);return this;};
n.prototype._attachDelegates=function(){this._afterRenderFocusCell={onAfterRendering:function(){if(this._sGridCellFocusSelector){q(this._sGridCellFocusSelector).trigger("focus");this._sGridCellFocusSelector=null;}}.bind(this)};this.getAggregation("_grid").addDelegate(this._afterRenderFocusCell);this.getAggregation("_mvgrid").addDelegate(this._afterRenderFocusCell);};
n.prototype._attachGridEvents=function(){var G=this.getAggregation("_grid"),o=this.getAggregation("_mvgrid");var i=function(E){this.fireHeaderDateSelect({date:E.getSource()._oDate.toLocalJSDate()});};var p=function(E){this.fireAppointmentSelect({appointment:E.getParameter("appointment"),appointments:E.getParameter("appointments")});};var r=function(E){this.fireAppointmentDrop({appointment:E.getParameter("appointment"),startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate"),copy:E.getParameter("copy")});};var s=function(E){this.fireAppointmentResize({appointment:E.getParameter("appointment"),startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate")});};var t=function(E){this.fireAppointmentCreate({startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate")});};var v=function(E){this.fireEvent("cellPress",{startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate")});};var w=function(E){this.fireEvent("moreLinkPress",{date:E.getParameter("date")});};var x=function(E){var G=this.getAggregation("_grid"),F=G._getDateFormatter(),N=this._getSelectedView().getScrollEntityCount()-G._getColumns()+1,z=new Date(E.getParameter("startDate")),A=E.getParameter("fullDay"),B=this.getStartDate();if(E.getParameter("next")){z.setDate(z.getDate()+N);B=new Date(B.setDate(B.getDate()+this._getSelectedView().getScrollEntityCount()));this.setStartDate(B);}else{z.setDate(z.getDate()-N);B=new Date(B.setDate(B.getDate()-this._getSelectedView().getScrollEntityCount()));this.setStartDate(B);}this._sGridCellFocusSelector=A?"[data-sap-start-date='"+F.format(z)+"'].sapMSinglePCBlockersColumn":"[data-sap-start-date='"+F.format(z)+"'].sapMSinglePCRow";};var y=function(E){var z=new Date(E.getParameter("startDate")),A=e.fromLocalJSDate(z),N;A.setDate(A.getDate()+E.getParameter("offset"));N=A.toLocalJSDate();this.setStartDate(N);this._sGridCellFocusSelector="[sap-ui-date='"+A.valueOf()+"'].sapMSPCMonthDay";};G._getColumnHeaders().attachEvent("select",i,this);G.attachEvent("appointmentSelect",p,this);o.attachEvent("appointmentSelect",p,this);G.attachEvent("appointmentDrop",r,this);o.attachEvent("appointmentDrop",r,this);G.attachEvent("appointmentResize",s,this);G.attachEvent("appointmentCreate",t,this);G.attachEvent("cellPress",v,this);o.attachEvent("cellPress",v,this);o.attachEvent("moreLinkPress",w,this);G.attachEvent("borderReached",x,this);o.attachEvent("borderReached",y,this);return this;};
n.prototype._handleViewChange=function(E){var N=E.getParameter("item").getProperty("key"),o=this.getViewByKey(N);this._setupNewView(o);this.fireViewChange();};
n.prototype._handlePressArrow=function(E){this._applyArrowsLogic(E.getId()==="pressPrevious");this._adjustColumnHeadersTopOffset();};
n.prototype._handlePressToday=function(){var s=this._getSelectedView().calculateStartDate(new Date());this.setStartDate(s);this.fireStartDateChange({date:s});this._adjustColumnHeadersTopOffset();};
n.prototype._setupNewView=function(v){var p=this._getCurrentGrid();this.setAssociation("selectedView",v);this._transferAggregations(p);this._alignColumns();this._adjustColumnHeadersTopOffset();};
n.prototype._transferAggregations=function(p){var N=this._getCurrentGrid(),A,s,i;if(p.getId()!==N.getId()){A=p.removeAllAggregation("appointments",true);for(i=0;i<A.length;i++){N.addAggregation("appointments",A[i],true);}s=p.removeAllAggregation("specialDates",true);for(i=0;i<s.length;i++){N.addAggregation("specialDates",s[i],true);}}};
n.prototype._handleCalendarPickerDateSelect=function(){var s=this._getHeader().getStartDate(),o;o=this._getSelectedView().calculateStartDate(new Date(s.getTime()));this.setStartDate(o);if(!this._getSelectedView().isA("sap.m.SinglePlanningCalendarMonthView")){this.getAggregation("_grid")._getColumnHeaders().setDate(s);}this.fireStartDateChange({date:o});this._adjustColumnHeadersTopOffset();};
n.prototype._updateCalendarPickerSelection=function(){var r=this._getFirstAndLastRangeDate(),o=this._getHeader(),i=o.getAggregation("_calendarPicker")?o.getAggregation("_calendarPicker"):o._oPopup.getContent()[0],s;s=new g({startDate:r.oStartDate.toLocalJSDate(),endDate:r.oEndDate.toLocalJSDate()});i.removeAllSelectedDates();i.addSelectedDate(s);};
n.prototype._formatPickerText=function(){var r=this._getFirstAndLastRangeDate(),s=r.oStartDate.toLocalJSDate(),E=r.oEndDate.toLocalJSDate(),F,o;if(this._getSelectedView().isA("sap.m.SinglePlanningCalendarMonthView")){F=D.getDateInstance({format:"yMMMM"});o=F.format(s);}else{F=D.getDateInstance({format:"yMMMMd"});o=F.format(s);if(s.getTime()!==E.getTime()){o+=" - "+F.format(E);}}return o;};
n.prototype._applyArrowsLogic=function(B){var o=e.fromLocalJSDate(this.getStartDate()||new Date()),O=B?-1:1,N=this._getSelectedView().getScrollEntityCount(this.getStartDate(),O),s;if(B){N*=-1;}o.setDate(o.getDate()+N);s=o.toLocalJSDate();this.setStartDate(s);this.fireStartDateChange({date:s});};
n.prototype._getFirstAndLastRangeDate=function(){var s=this._getSelectedView(),o=this._getHeader().getStartDate()||new Date(),i=s.getEntityCount()-1,p,r;p=e.fromLocalJSDate(s.calculateStartDate(new Date(o.getTime())));r=new e(p);r.setDate(p.getDate()+i);return{oStartDate:p,oEndDate:r};};
n.prototype._alignColumns=function(){var o=this._getHeader(),G=this.getAggregation("_grid"),i=this.getAggregation("_mvgrid"),v=this._getSelectedView(),p=this.getStartDate()||new Date(),V=v.calculateStartDate(new Date(p.getTime())),r=e.fromLocalJSDate(V);o.setStartDate(V);o.setPickerText(this._formatPickerText(r));this._updateCalendarPickerSelection();G.setStartDate(V);i.setStartDate(V);G._setColumns(v.getEntityCount());this._setColumnHeaderVisibility();};
n.prototype._setColumnHeaderVisibility=function(){var v;if(this._getSelectedView().isA("sap.m.SinglePlanningCalendarMonthView")){return;}v=!this._getSelectedView().isA("sap.m.SinglePlanningCalendarDayView");this.getAggregation("_grid")._getColumnHeaders().setVisible(v);this.toggleStyleClass("sapMSinglePCHiddenColHeaders",!v);};
n.prototype._getHeader=function(){return this.getAggregation("_header");};
n.prototype._getCurrentGrid=function(){if(this._getSelectedView().isA("sap.m.SinglePlanningCalendarMonthView")){return this.getAggregation("_mvgrid");}else{return this.getAggregation("_grid");}};
n.prototype._registerResizeHandler=function(s,o,i){if(!this[s]){this[s]=R.register(o,i);}return this;};
n.prototype._deRegisterResizeHandler=function(s){if(this[s]){R.deregister(this[s]);this[s]=null;}return this;};
n.prototype._getSpecialDates=function(){var s=this.getSpecialDates();for(var i=0;i<s.length;i++){var N=s[i].getSecondaryType()===u.CalendarDayType.NonWorking&&s[i].getType()!==u.CalendarDayType.NonWorking;if(N){var o=new h();o.setType(u.CalendarDayType.NonWorking);o.setStartDate(s[i].getStartDate());if(s[i].getEndDate()){o.setEndDate(s[i].getEndDate());}s.push(o);}}return s;};
return n;});
sap.ui.predefine('sap/m/SinglePlanningCalendarDayView',['./library','./SinglePlanningCalendarView'],function(l,S){"use strict";
var a=S.extend("sap.m.SinglePlanningCalendarDayView",{metadata:{library:"sap.m"}});
a.prototype.getEntityCount=function(){return 1;};
a.prototype.getScrollEntityCount=function(){return 1;};
a.prototype.calculateStartDate=function(s){return s;};
return a;});
sap.ui.predefine('sap/m/SinglePlanningCalendarGrid',['./SinglePlanningCalendarUtilities','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/core/Locale','sap/ui/core/InvisibleText','sap/ui/core/format/DateFormat','sap/ui/core/date/UniversalDate','sap/ui/core/dnd/DragInfo','sap/ui/core/dnd/DropInfo','sap/ui/core/dnd/DragDropInfo','sap/ui/unified/library','sap/ui/unified/CalendarAppointment','sap/ui/unified/calendar/DatesRow','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/DateTypeRange','sap/ui/events/KeyCodes','./SinglePlanningCalendarGridRenderer','sap/ui/core/delegate/ItemNavigation',"sap/ui/thirdparty/jquery",'./PlanningCalendarLegend'],function(S,C,L,a,I,D,U,b,c,d,u,e,f,g,h,k,K,l,m,q,P){"use strict";var R=4.3125,n=3,B=2.125,o=1.5625,H=3600000/2,O=60*1000,p=0.4375,F=0,r=24;
var s=C.extend("sap.m.SinglePlanningCalendarGrid",{metadata:{library:"sap.m",properties:{startDate:{type:"object",group:"Data"},startHour:{type:"int",group:"Data",defaultValue:0},endHour:{type:"int",group:"Data",defaultValue:24},fullDay:{type:"boolean",group:"Data",defaultValue:true},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsResize:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsCreate:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",dnd:{draggable:true}},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},_columnHeaders:{type:"sap.ui.unified.calendar.DatesRow",multiple:false,visibility:"hidden"},_intervalPlaceholders:{type:"sap.m.SinglePlanningCalendarGrid._internal.IntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}},_blockersPlaceholders:{type:"sap.m.SinglePlanningCalendarGrid._internal.IntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}}},dnd:true,associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.m.PlanningCalendarLegend",multiple:false}},events:{appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"}}},appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},copy:{type:"boolean"}}},appointmentResize:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"}}},appointmentCreate:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},cellPress:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}}}}});
s.prototype.init=function(){var i=new Date(),j=new f(this.getId()+"-columnHeaders",{showDayNamesLine:false,showWeekNumbers:false,startDate:i}).addStyleClass("sapMSinglePCColumnHeader"),w=(60-i.getSeconds())*1000,T=this._getCoreLocaleData().getTimePattern("medium");j._setAriaRole("columnheader");this.setAggregation("_columnHeaders",j);this.setStartDate(i);this._setColumns(7);this._configureBlockersDragAndDrop();this._configureAppointmentsDragAndDrop();this._configureAppointmentsResize();this._configureAppointmentsCreate();this._oUnifiedRB=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");this._oFormatStartEndInfoAria=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY 'at' "+T});this._oFormatAriaFullDayCell=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY"});this._sLegendId=undefined;setTimeout(this._updateRowHeaderAndNowMarker.bind(this),w);};
s.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
s.prototype.onBeforeRendering=function(){var A=this._createAppointmentsMap(this.getAppointments()),i=this.getStartDate(),j=g.fromLocalJSDate(i),w=this._getColumns();this._oVisibleAppointments=this._calculateVisibleAppointments(A.appointments,this.getStartDate(),w);this._oAppointmentsToRender=this._calculateAppointmentsLevelsAndWidth(this._oVisibleAppointments);this._aVisibleBlockers=this._calculateVisibleBlockers(A.blockers,j,w);this._oBlockersToRender=this._calculateBlockersLevelsAndWidth(this._aVisibleBlockers);if(this._iOldColumns!==w||this._oOldStartDate!==i){this._createBlockersDndPlaceholders(i,w);this._createAppointmentsDndPlaceholders(i,w);}};
s.prototype.onmousedown=function(E){var i=E.target.classList;this._isResizeHandleBottomMouseDownTarget=i.contains("sapMSinglePCAppResizeHandleBottom");this._isResizeHandleTopMouseDownTarget=i.contains("sapMSinglePCAppResizeHandleTop");};
s.prototype._isResizingPerformed=function(){return this._isResizeHandleBottomMouseDownTarget||this._isResizeHandleTopMouseDownTarget;};
s.prototype._configureBlockersDragAndDrop=function(){this.addDragDropConfig(new d({sourceAggregation:"appointments",targetAggregation:"_blockersPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsDragAndDrop()){E.preventDefault();return false;}var i=function(){var $=q(".sapMSinglePCOverlay");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");});q(document).one("dragend",function(){$.removeClass("sapMSinglePCOverlayDragging");});};i();}.bind(this),dragEnter:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),w=this.isAllDayAppointment(A.getStartDate(),A.getEndDate()),x=function(){var $=q(i.getIndicator()),y=A.$().outerHeight(),z=A.$().outerWidth(),G=j.$().closest(".sapMSinglePCBlockersColumns").get(0).getBoundingClientRect(),J=j.getDomRef().getBoundingClientRect(),M=(J.left+z)-(G.left+G.width);if(w){$.css("min-height",y);$.css("min-width",Math.min(z,z-M));}else{$.css("min-height",i.getDropControl().$().outerHeight());$.css("min-width",i.getDropControl().$().outerWidth());}};if(!i.getIndicator()){setTimeout(x,0);}else{x();}}.bind(this),drop:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),w=j.getDate().getJSDate(),x,y=E.getParameter("browserEvent"),z=(y.metaKey||y.ctrlKey),G=this.isAllDayAppointment(A.getStartDate(),A.getEndDate());x=new Date(w);if(G){x.setMilliseconds(A.getEndDate().getTime()-A.getStartDate().getTime());}this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");if(G&&A.getStartDate().getTime()===w.getTime()){return;}this.fireAppointmentDrop({appointment:A,startDate:w,endDate:x,copy:z});}.bind(this)}));};
s.prototype._configureAppointmentsDragAndDrop=function(){this.addDragDropConfig(new d({sourceAggregation:"appointments",targetAggregation:"_intervalPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsDragAndDrop()||this._isResizingPerformed()){E.preventDefault();return false;}var i=function(){var $=q(".sapMSinglePCOverlay");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");});q(document).one("dragend",function(){$.removeClass("sapMSinglePCOverlayDragging");});};i();}.bind(this),dragEnter:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),w=this.isAllDayAppointment(A.getStartDate(),A.getEndDate()),x=function(){var $=q(i.getIndicator()),y=A.$().outerHeight(),G=j.$().closest(".sapMSinglePCColumn").get(0).getBoundingClientRect(),z=i.getDropControl().getDomRef().getBoundingClientRect(),J=(z.top+y)-(G.top+G.height);if(w){$.css("min-height",2*i.getDropControl().$().outerHeight());}else{$.css("min-height",Math.min(y,y-J));}};if(!i.getIndicator()){setTimeout(x,0);}else{x();}}.bind(this),drop:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),w=j.getDate().getJSDate(),x,y=E.getParameter("browserEvent"),z=(y.metaKey||y.ctrlKey),G=this.isAllDayAppointment(A.getStartDate(),A.getEndDate());x=new Date(w);if(G){x.setHours(x.getHours()+1);}else{x.setMilliseconds(A.getEndDate().getTime()-A.getStartDate().getTime());}this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");if(!G&&A.getStartDate().getTime()===w.getTime()){return;}this.fireAppointmentDrop({appointment:A,startDate:w,endDate:x,copy:z});}.bind(this)}));};
s.prototype._configureAppointmentsResize=function(){var i=new d({sourceAggregation:"appointments",targetAggregation:"_intervalPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsResize()||!this._isResizingPerformed()){E.preventDefault();return;}var j=E.getParameter("dragSession"),w=j.getDragControl(),x=E.getParameter("browserEvent")&&E.getParameter("browserEvent").target||null;w._sAppointmentPartSuffix=x&&x.id?x.id.replace(w.getId()+"-",""):"";var $=this.$().find(".sapMSinglePCOverlay"),y=q(j.getIndicator()),z=w.$();if(this._isResizeHandleBottomMouseDownTarget){j.setComplexData("bottomHandle","true");}if(this._isResizeHandleTopMouseDownTarget){j.setComplexData("topHandle","true");}y.addClass("sapUiDnDIndicatorHide");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");},0);q(document).one("dragend",function(){var A=j.getComplexData("appointmentStartingBoundaries");$.removeClass("sapMSinglePCOverlayDragging");y.removeClass("sapUiDnDIndicatorHide");z.css({top:A.top,height:A.height,"z-index":"auto",opacity:1});});E.getParameter("browserEvent").dataTransfer.setDragImage(t(),0,0);}.bind(this),dragEnter:function(E){var j=E.getParameter("dragSession"),A=j.getDragControl().$().get(0),w=j.getDropControl().getDomRef(),x=j.getComplexData("appointmentStartingBoundaries"),y=function(){var $=q(j.getIndicator());$.addClass("sapUiDnDIndicatorHide");},T,z,G,V,J;if(!x){x={top:A.offsetTop,bottom:A.offsetTop+A.getBoundingClientRect().height,height:A.getBoundingClientRect().height};j.setComplexData("appointmentStartingBoundaries",x);}V=j.getData("bottomHandle")?x.top:x.bottom;T=Math.min(V,w.offsetTop);z=Math.max(V,w.offsetTop+w.getBoundingClientRect().height);G=z-T;J={top:T,height:G,"z-index":1,opacity:0.8};j.getDragControl().$().css(J);if(!j.getIndicator()){setTimeout(y,0);}else{y();}},drop:function(E){var j=E.getParameter("dragSession"),A=j.getDragControl(),w=this.indexOfAggregation("_intervalPlaceholders",j.getDropControl()),x=j.getComplexData("appointmentStartingBoundaries"),y;y=this._calcResizeNewHoursAppPos(A.getStartDate(),A.getEndDate(),w,j.getComplexData("bottomHandle"));this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");q(j.getIndicator()).removeClass("sapUiDnDIndicatorHide");A.$().css({top:x.top,height:x.height,"z-index":"auto",opacity:1});if(A.getEndDate().getTime()===y.endDate.getTime()&&A.getStartDate().getTime()===y.startDate.getTime()){return;}this.fireAppointmentResize({appointment:A,startDate:y.startDate,endDate:y.endDate});}.bind(this)});this.addDragDropConfig(i);};
s.prototype._configureAppointmentsCreate=function(){this.addDragDropConfig(new d({targetAggregation:"_intervalPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsCreate()){E.preventDefault();return;}var i=E.getParameter("browserEvent");var $=this.$().find(".sapMSinglePCOverlay");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");});q(document).one("dragend",function(){$.removeClass("sapMSinglePCOverlayDragging");q(".sapUiAppCreate").remove();q(".sapUiDnDDragging").removeClass("sapUiDnDDragging");});i.dataTransfer.setDragImage(t(),0,0);var G=E.getParameter("target"),j=G.getAggregation("_intervalPlaceholders"),w=j[0].getDomRef().getBoundingClientRect(),x=w.height,y=Math.floor((w.top-G.getDomRef().getBoundingClientRect().top)/x),z=E.getParameter("dragSession"),A=Math.floor(i.offsetY/x)-y,J,M;if(this._iColumns===1){J=A;}else{var N=64,Q=2,T=Math.floor(j[0].getDomRef().getBoundingClientRect().width)-Q,V=Math.floor(Math.floor((i.offsetX-N))/T),W=j.length/this._iColumns;J=A+((V)*W);}if(J<0){J=0;}M=j[J].getDomRef().getBoundingClientRect();z.setComplexData("startingRectsDropArea",{top:Math.ceil(A*x),left:M.left});z.setComplexData("startingDropDate",j[J].getDate());}.bind(this),dragEnter:function(E){var i=E.getParameter("dragSession"),j=i.getDropControl(),w=j.getDomRef(),x=w.offsetHeight,y=w.offsetTop,z=y,A=w.getBoundingClientRect().left,G=A,J=j.$().parents(".sapMSinglePCColumn").get(0),$=q(".sapUiAppCreate");if(!$.get(0)){$=q("<div></div>").addClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");$.appendTo(J);}q(".sapUiDnDDragging").removeClass("sapUiDnDDragging");if(!i.getComplexData("startingRectsDropArea")){i.setComplexData("startingRectsDropArea",{top:y,left:A});i.setComplexData("startingDropDate",j.getDate());}else{z=i.getComplexData("startingRectsDropArea").top;G=i.getComplexData("startingRectsDropArea").left;}if(A!==G){E.preventDefault();return false;}j.$().closest(".sapMSinglePCColumn").find(".sapMSinglePCAppointments").addClass("sapUiDnDDragging");$.css({top:Math.min(z,y)+2,height:Math.abs(z-y)+x-4,left:3,right:3,"z-index":2});i.setIndicatorConfig({display:"none"});},drop:function(E){var i=E.getParameter("dragSession"),j=i.getDropControl(),T=30*60*1000,w=i.getComplexData("startingDropDate").getTime(),x=j.getDate().getJSDate().getTime(),y=Math.min(w,x),z=Math.max(w,x)+T;this.fireAppointmentCreate({startDate:new Date(y),endDate:new Date(z)});q(".sapUiAppCreate").remove();q(".sapUiDnDDragging").removeClass("sapUiDnDDragging");}.bind(this)}));};
s.prototype._calcResizeNewHoursAppPos=function(A,i,j,w){var M=30*60*1000,x=this.getAggregation("_intervalPlaceholders")[j].getDate().getTime(),y=x+M,V=w?A.getTime():i.getTime(),z=Math.min(V,x),E=Math.max(V,y);return{startDate:new Date(z),endDate:new Date(E)};};
s.prototype._adjustAppointmentsHeightforCompact=function(i,j,w,x){var A,y,z,E,G,J,M,N,Q=this._getRowHeight(),T=0;if(this._oAppointmentsToRender[i]){this._oAppointmentsToRender[i].oAppointmentsList.getIterator().forEach(function(V){A=V.getData();y=this.getDomRef().querySelector("#"+A.getId()+"-"+x+"_"+T);z=A.getStartDate();E=A.getEndDate();M=j.getTime()>z.getTime();N=w.getTime()<E.getTime();G=M?0:this._calculateTopPosition(z);J=N?0:this._calculateBottomPosition(E);y.style["top"]=G+"rem";y.style["bottom"]=J+"rem";y.querySelector(".sapUiCalendarApp").style["minHeight"]=(Q/2-0.1875)+"rem";++T;}.bind(this));}};
s.prototype._adjustBlockersHeightforCompact=function(){var M=this._getBlockersToRender().iMaxlevel,i=(M+1)*this._getBlockerRowHeight(),j=this._getColumns()===1?i+p:i,w=this._getBlockerRowHeight();if(M>0){j=j+0.1875;}this.$().find(".sapMSinglePCBlockersColumns").css("height",j+"rem");this._oBlockersToRender.oBlockersList.getIterator().forEach(function(x){x.getData().$().css("top",(w*x.level+0.0625)+"rem");});};
s.prototype._adjustBlockersHeightforCozy=function(){var M=this._getBlockersToRender()&&this._getBlockersToRender().iMaxlevel,i;if(this._getColumns()===1){i=(M+1)*this._getBlockerRowHeight();this.$().find(".sapMSinglePCBlockersColumns").css("height",(i+p)+"rem");}};
s.prototype.onAfterRendering=function(){var j=this._getColumns(),w=this.getStartDate(),x=this._getRowHeight();if(x===n){for(var i=0;i<j;i++){var y=new g(w.getFullYear(),w.getMonth(),w.getDate()+i),z=this._getDateFormatter().format(y.toLocalJSDate()),A=new U(y.getYear(),y.getMonth(),y.getDate(),this._getVisibleStartHour()),E=new U(y.getYear(),y.getMonth(),y.getDate(),this._getVisibleEndHour(),59,59);this._adjustAppointmentsHeightforCompact(z,A,E,i);}this._adjustBlockersHeightforCompact();}else{this._adjustBlockersHeightforCozy();}this._updateRowHeaderAndNowMarker();_.call(this);};
s.prototype._appFocusHandler=function(E,i){var T=sap.ui.getCore().byId(E.target.id)||this._findSrcControl(E);if(T&&T.isA("sap.ui.unified.CalendarAppointment")){this.fireAppointmentSelect({appointment:undefined,appointments:this._toggleAppointmentSelection(undefined,true)});this._focusCellWithKeyboard(T,i);E.preventDefault();}};
s.prototype._cellFocusHandler=function(E,i){var G=E.target,j=this._getDateFormatter(),w;if(G.classList.contains("sapMSinglePCRow")||G.classList.contains("sapMSinglePCBlockersColumn")){w=j.parse(G.getAttribute("data-sap-start-date"));if(this._isBorderReached(w,i)){this.fireEvent("borderReached",{startDate:w,next:i===K.ARROW_RIGHT,fullDay:G.classList.contains("sapMSinglePCBlockersColumn")});}}};
s.prototype.onsapup=function(E){this._appFocusHandler(E,K.ARROW_UP);};
s.prototype.onsapdown=function(E){this._appFocusHandler(E,K.ARROW_DOWN);};
s.prototype.onsapright=function(E){this._appFocusHandler(E,K.ARROW_RIGHT);this._cellFocusHandler(E,K.ARROW_RIGHT);};
s.prototype.onsapleft=function(E){this._appFocusHandler(E,K.ARROW_LEFT);this._cellFocusHandler(E,K.ARROW_LEFT);};
s.prototype.setStartDate=function(i){this._oOldStartDate=this.getStartDate();this.getAggregation("_columnHeaders").setStartDate(i);return this.setProperty("startDate",i);};
s.prototype.applyFocusInfo=function(w){var V=this._getVisibleBlockers(),x=this._getVisibleAppointments(),y=Object.keys(x),z,i,j;if(this._sSelectedAppointment){this._sSelectedAppointment.focus();return this;}for(i=0;i<V.length;++i){if(V[i].getId()===w.id){V[i].focus();return this;}}for(i=0;i<y.length;++i){z=x[y[i]];for(j=0;j<z.length;++j){if(z[j].getId()===w.id){z[j].focus();return this;}}}return this;};
s.prototype.getSelectedAppointments=function(){return this.getAppointments().filter(function(A){return A.getSelected();});};
s.prototype._toggleAppointmentSelection=function(A,j){var w=[],x=A&&A.getDomRef(),y,z,i;if(j){y=this.getAppointments();for(i=0,z=y.length;i<z;i++){if((!A||y[i].getId()!==A.getId())&&y[i].getSelected()){y[i].setProperty("selected",false);w.push(y[i]);}}}if(A){A.setProperty("selected",!A.getSelected());w.push(A);this._sSelectedAppointment=A.getSelected()&&x?A:undefined;}else{this._sSelectedAppointment=undefined;}return w;};
s.prototype._isBorderReached=function(i,j){var G=g.fromLocalJSDate(this.getStartDate()),w=new g(G.getYear(),G.getMonth(),G.getDate()+this._getColumns()-1),T=g.fromLocalJSDate(i),x=j===K.ARROW_LEFT&&T.isSame(G),y=j===K.ARROW_RIGHT&&T.isSame(w);return x||y;};
s.prototype._focusCellWithKeyboard=function(A,i){var j=this.isAllDayAppointment(A.getStartDate(),A.getEndDate()),w=this._getDateFormatter(),x=new Date(A.getStartDate().getFullYear(),A.getStartDate().getMonth(),A.getStartDate().getDate(),A.getStartDate().getHours()),G=new Date(this.getStartDate().getFullYear(),this.getStartDate().getMonth(),this.getStartDate().getDate(),this.getStartDate().getHours());if(x<G){x=G;}if(this._isBorderReached(x,i)){this.fireEvent("borderReached",{startDate:x,next:i===K.ARROW_RIGHT,fullDay:j});return;}switch(i){case K.ARROW_UP:if(!j){x.setHours(x.getHours()-1);}break;case K.ARROW_DOWN:if(!j){x.setHours(x.getHours()+1);}break;case K.ARROW_LEFT:x.setDate(x.getDate()-1);break;case K.ARROW_RIGHT:x.setDate(x.getDate()+1);break;default:}if(j&&i!==K.ARROW_DOWN){q("[data-sap-start-date='"+w.format(x)+"'].sapMSinglePCBlockersColumn").trigger("focus");}else{q("[data-sap-start-date='"+w.format(x)+"'].sapMSinglePCRow").trigger("focus");}};
s.prototype.ontap=function(E){this._fireSelectionEvent(E);};
s.prototype.onkeydown=function(E){if(E.which===K.SPACE||E.which===K.ENTER){this._fireSelectionEvent(E);E.preventDefault();}};
s.prototype._findSrcControl=function(E){var $=E.target,i=$.parentElement,A;if(!i){return E.srcControl;}else if(i.classList.contains("sapUiCalendarRowApps")){A=i.getAttribute("data-sap-ui-related");}else{A=$.getAttribute("data-sap-ui-related");}return this.getAppointments().find(function(j){return j.sId===A;});};
s.prototype._fireSelectionEvent=function(E){var i=this._findSrcControl(E),G=E.target;if(E.target.classList.contains("sapMSinglePCRow")||E.target.classList.contains("sapMSinglePCBlockersColumn")){this.fireEvent("cellPress",{startDate:this._getDateFormatter().parse(G.getAttribute("data-sap-start-date")),endDate:this._getDateFormatter().parse(G.getAttribute("data-sap-end-date"))});this.fireAppointmentSelect({appointment:undefined,appointments:this._toggleAppointmentSelection(undefined,true)});}else if(i&&i.isA("sap.ui.unified.CalendarAppointment")){if(G.parentElement&&G.parentElement.getAttribute("id")){var T=G.parentElement.getAttribute("id");var j=G.parentElement.getAttribute("data-sap-ui-related");var w=T.replace(j+"-","");i._setAppointmentPartSuffix(w);}this.fireAppointmentSelect({appointment:i,appointments:this._toggleAppointmentSelection(i,!(E.ctrlKey||E.metaKey))});}};
s.prototype._getVisibleStartHour=function(){return(this.getFullDay()||!this.getStartHour())?F:this.getStartHour();};
s.prototype._getVisibleEndHour=function(){return((this.getFullDay()||!this.getEndHour())?r:this.getEndHour())-1;};
s.prototype._isVisibleHour=function(i){var j=this.getStartHour(),E=this.getEndHour();if(!this.getStartHour()){j=F;}if(!this.getEndHour()){E=r;}if(j>E){return j<=i||i<E;}return j<=i&&i<E;};
s.prototype._shouldHideRowHeader=function(i){var j=new Date().getHours(),w=h._areCurrentMinutesLessThan(15)&&j===i,x=h._areCurrentMinutesMoreThan(45)&&j===i-1;return w||x;};
s.prototype._parseDateStringAndHours=function(i,j){var w=this._getDateFormatter().parse(i);if(j){w.setHours(j);}return w;};
s.prototype._getDateFormatter=function(){if(!(this._oDateFormat instanceof D)){this._oDateFormat=D.getDateTimeInstance({pattern:"YYYYMMdd-HHmm"});}return this._oDateFormat;};
s.prototype._formatTimeAsString=function(i){var j=this._getHoursPattern()+":mm",w=D.getDateTimeInstance({pattern:j},new a(this._getCoreLocaleId()));return w.format(i);};
s.prototype._addAMPM=function(i){var A=this._getAMPMFormat();return" "+A.format(i);};
s.prototype._calculateTopPosition=function(i){var j=i.getHours()-this._getVisibleStartHour(),M=i.getMinutes(),w=this._getRowHeight();return(w*j)+(w/60)*M;};
s.prototype._calculateBottomPosition=function(i){var j=this._getVisibleEndHour()+1-i.getHours(),M=i.getMinutes(),w=this._getRowHeight();return(w*j)-(w/60)*M;};
s.prototype._updateRowHeaderAndNowMarker=function(){var i=new Date();this._updateNowMarker(i);this._updateRowHeaders(i);setTimeout(this._updateRowHeaderAndNowMarker.bind(this),O);};
s.prototype._updateNowMarker=function(i){var $=this.$("nowMarker"),j=this.$("nowMarkerText"),w=this.$("nowMarkerAMPM"),x=!this._isVisibleHour(i.getHours());$.toggleClass("sapMSinglePCNowMarkerHidden",x);$.css("top",this._calculateTopPosition(i)+"rem");j.text(this._formatTimeAsString(i));w.text(this._addAMPM(i));j.append(w);};
s.prototype._updateRowHeaders=function(i){var $=this.$(),j=i.getHours(),N=j+1;$.find(".sapMSinglePCRowHeader").removeClass("sapMSinglePCRowHeaderHidden");if(this._shouldHideRowHeader(j)){$.find(".sapMSinglePCRowHeader"+j).addClass("sapMSinglePCRowHeaderHidden");}else if(this._shouldHideRowHeader(N)){$.find(".sapMSinglePCRowHeader"+N).addClass("sapMSinglePCRowHeaderHidden");}};
s.prototype._createAppointmentsMap=function(A){var i=this;return A.reduce(function(M,j){var w=j.getStartDate(),x=j.getEndDate(),y,z,E;if(!w||!x){return M;}if(!i.isAllDayAppointment(w,x)){y=g.fromLocalJSDate(w);z=g.fromLocalJSDate(x);while(y.isSameOrBefore(z)){E=i._getDateFormatter().format(y.toLocalJSDate());if(!M.appointments[E]){M.appointments[E]=[];}M.appointments[E].push(j);y.setDate(y.getDate()+1);}}else{M.blockers.push(j);}return M;},{appointments:{},blockers:[]});};
s.prototype._calculateVisibleAppointments=function(A,j,w){var V={},x,y,z;for(var i=0;i<w;i++){x=new g(j.getFullYear(),j.getMonth(),j.getDate()+i);y=this._getDateFormatter().format(x.toLocalJSDate());z=this._isAppointmentFitInVisibleHours(x);if(A[y]){V[y]=A[y].filter(z,this).sort(this._sortAppointmentsByStartHourCallBack);}}return V;};
s.prototype._isAppointmentFitInVisibleHours=function(i){return function(A){var j=A.getStartDate().getTime(),w=A.getEndDate().getTime(),x=(new U(i.getYear(),i.getMonth(),i.getDate(),this._getVisibleStartHour())).getTime(),y=(new U(i.getYear(),i.getMonth(),i.getDate(),this._getVisibleEndHour(),59,59)).getTime();var z=j<x&&w>y,E=j>=x&&j<y,G=w>x&&w<=y;return z||E||G;};};
s.prototype._calculateAppointmentsLevelsAndWidth=function(V){var i=this;return Object.keys(V).reduce(function(A,j){var M=0,w=new S.list(),x=V[j];x.forEach(function(y){var z=new S.node(y),E=y.getStartDate().getTime();if(w.getSize()===0){w.add(z);return;}w.getIterator().forEach(function(G){var J=true,N=G.getData(),Q=N.getStartDate().getTime(),T=N.getEndDate().getTime(),W=T-Q;if(W<H){T=T+(H-W);}if(E>=Q&&E<T){z.level++;M=Math.max(M,z.level);}if(G.next&&G.next.level===z.level){J=false;}if(E>=T&&J){this.interrupt();}});w.insertAfterLevel(z.level,z);});A[j]={oAppointmentsList:i._calculateAppointmentsWidth(w),iMaxLevel:M};return A;},{});};
s.prototype._calculateAppointmentsWidth=function(A){A.getIterator().forEach(function(i){var j=i.getData(),w=i.level,x=i.level,y=j.getStartDate().getTime(),z=j.getEndDate().getTime(),E=z-y;if(E<H){z=z+(H-E);}new S.iterator(A).forEach(function(G){var J=G.getData(),M=G.level,N=J.getStartDate().getTime(),Q=J.getEndDate().getTime(),T=Q-N;if(T<H){Q=Q+(H-T);}if(x>=M){return;}if(y>=N&&y<Q||z>N&&z<Q||y<=N&&z>=Q){i.width=M-x;this.interrupt();return;}if(w<M){w=M;i.width++;}});});return A;};
s.prototype._calculateVisibleBlockers=function(i,j,w){var x=new g(j.getYear(),j.getMonth(),j.getDate()+w-1),y=this._isBlockerVisible(j,x);return i.filter(y).sort(this._sortAppointmentsByStartHourCallBack);};
s.prototype._isBlockerVisible=function(V,i){return function(A){var j=g.fromLocalJSDate(A.getStartDate()),w=g.fromLocalJSDate(A.getEndDate());var x=j.isBefore(V)&&w.isAfter(i),y=h._isBetween(j,V,i,true),E=h._isBetween(w,V,i,true);return x||y||E;};};
s.prototype._calculateBlockersLevelsAndWidth=function(V){var M=0,i=new S.list();V.forEach(function(j){var w=new S.node(j),x=g.fromLocalJSDate(j.getStartDate()),y=g.fromLocalJSDate(j.getEndDate());w.width=h._daysBetween(y,x);if(i.getSize()===0){i.add(w);return;}i.getIterator().forEach(function(z){var A=true,E=z.getData(),G=g.fromLocalJSDate(E.getStartDate()),J=g.fromLocalJSDate(E.getEndDate());if(x.isSameOrAfter(G)&&x.isSameOrBefore(J)){w.level++;M=Math.max(M,w.level);}if(z.next&&z.next.level===w.level){A=false;}if(x.isSameOrAfter(J)&&A){this.interrupt();}});i.insertAfterLevel(w.level,w);},this);return{oBlockersList:i,iMaxlevel:M};};
s.prototype._sortAppointmentsByStartHourCallBack=function(A,i){return A.getStartDate().getTime()-i.getStartDate().getTime()||i.getEndDate().getTime()-A.getEndDate().getTime();};
s.prototype._getVisibleAppointments=function(){return this._oVisibleAppointments;};
s.prototype._getAppointmentsToRender=function(){return this._oAppointmentsToRender;};
s.prototype._getVisibleBlockers=function(){return this._aVisibleBlockers;};
s.prototype._getBlockersToRender=function(){return this._oBlockersToRender;};
s.prototype._setColumns=function(i){this._iOldColumns=this._iColumns;this._iColumns=i;this.getAggregation("_columnHeaders").setDays(i);this.invalidate();return this;};
s.prototype._getColumns=function(){return this._iColumns;};
s.prototype._getRowHeight=function(){return this._isCompact()?n:R;};
s.prototype._getBlockerRowHeight=function(){return this._isCompact()?o:B;};
s.prototype._isCompact=function(){var i=this.getDomRef();while(i&&i.classList){if(i.classList.contains("sapUiSizeCompact")){return true;}i=i.parentNode;}return false;};
s.prototype._getCoreLocaleId=function(){if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;};
s.prototype._getCoreLocaleData=function(){var i,j;if(!this._oLocaleData){i=this._getCoreLocaleId();j=new a(i);this._oLocaleData=L.getInstance(j);}return this._oLocaleData;};
s.prototype._hasAMPM=function(){var i=this._getCoreLocaleData();return i.getTimePattern("short").search("a")>=0;};
s.prototype._getHoursFormat=function(){var i=this._getCoreLocaleId();if(!this._oHoursFormat||this._oHoursFormat.oLocale.toString()!==i){var j=new a(i),w=this._getHoursPattern();this._oHoursFormat=D.getTimeInstance({pattern:w},j);}return this._oHoursFormat;};
s.prototype._getHoursPattern=function(){return this._hasAMPM()?"h":"H";};
s.prototype._getAMPMFormat=function(){var i=this._getCoreLocaleId(),j=new a(i);if(!this._oAMPMFormat||this._oAMPMFormat.oLocale.toString()!==i){this._oAMPMFormat=D.getTimeInstance({pattern:"a"},j);}return this._oAMPMFormat;};
s.prototype._getColumnHeaders=function(){return this.getAggregation("_columnHeaders");};
s.prototype._getAppointmentAnnouncementInfo=function(A){var i=this._oUnifiedRB.getText("CALENDAR_START_TIME"),E=this._oUnifiedRB.getText("CALENDAR_END_TIME"),j=this._oFormatStartEndInfoAria.format(A.getStartDate()),w=this._oFormatStartEndInfoAria.format(A.getEndDate()),x=i+": "+j+"; "+E+": "+w;return x+"; "+P.findLegendItemForItem(sap.ui.getCore().byId(this._sLegendId),A);};
s.prototype.enhanceAccessibilityState=function(i,A){if(i.getId()===this._getColumnHeaders().getId()){A.labelledby=I.getStaticId("sap.m","PLANNINGCALENDAR_DAYS");}};
s.prototype._getCellStartEndInfo=function(i,E){var j=this._oUnifiedRB.getText("CALENDAR_START_TIME"),w=this._oUnifiedRB.getText("CALENDAR_END_TIME"),x=!E;if(x){return j+": "+this._oFormatAriaFullDayCell.format(i)+"; ";}return j+": "+this._oFormatStartEndInfoAria.format(i)+"; "+w+": "+this._oFormatStartEndInfoAria.format(E);};
s.prototype.isAllDayAppointment=function(A,i){return h._isMidnight(A)&&h._isMidnight(i);};
s.prototype._createBlockersDndPlaceholders=function(j,w){this.destroyAggregation("_blockersPlaceholders");for(var i=0;i<w;i++){var x=new U(j.getFullYear(),j.getMonth(),j.getDate()+i);var y=new v({date:x});this.addAggregation("_blockersPlaceholders",y,true);}};
s.prototype._createAppointmentsDndPlaceholders=function(w,x){var y=this._getVisibleStartHour(),E=this._getVisibleEndHour();this._dndPlaceholdersMap={};this.destroyAggregation("_intervalPlaceholders");for(var i=0;i<x;i++){var z=new g(w.getFullYear(),w.getMonth(),w.getDate()+i);if(!this._dndPlaceholdersMap[z]){this._dndPlaceholdersMap[z]=[];}for(var j=y;j<=E;j++){var A=this._dndPlaceholdersMap[z],Y=z.getYear(),M=z.getMonth(),G=z.getDate();A.push(this._createAppointmentsDndPlaceHolder(new U(Y,M,G,j)));A.push(this._createAppointmentsDndPlaceHolder(new U(Y,M,G,j,30)));}}};
s.prototype._createAppointmentsDndPlaceHolder=function(i){var j=new v({date:i});this.addAggregation("_intervalPlaceholders",j,true);return j;};
s.prototype._getSpecialDates=function(){var j=this.getSpecialDates();for(var i=0;i<j.length;i++){var N=j[i].getSecondaryType()===u.CalendarDayType.NonWorking&&j[i].getType()!==u.CalendarDayType.NonWorking;if(N){var w=new k();w.setType(u.CalendarDayType.NonWorking);w.setStartDate(j[i].getStartDate());if(j[i].getEndDate()){w.setEndDate(j[i].getEndDate());}j.push(w);}}return j;};
function t(){var $=q("<span></span>").addClass("sapUiCalAppResizeGhost");$.appendTo(document.body);setTimeout(function(){$.remove();},0);return $.get(0);}
var v=C.extend("sap.m.SinglePlanningCalendarGrid._internal.IntervalPlaceholder",{
metadata:{library:"sap.m",properties:{date:{type:"object",group:"Data"}}},
renderer:{apiVersion:2,render:function(i,j){i.openStart("div",j).class("sapMSinglePCPlaceholder").openEnd().close("div");}}
});
function _(){var i=this.getDomRef(),j=this.$().find(".sapMSinglePCBlockersColumn").toArray();this._aGridCells=Array.prototype.concat(j);for(var w=0;w<=this._getVisibleEndHour();++w){j=this.$().find("div[data-sap-hour='"+w+"']").toArray();this._aGridCells=this._aGridCells.concat(j);}if(!this._oItemNavigation){this._oItemNavigation=new m();this.addDelegate(this._oItemNavigation);}this._oItemNavigation.setRootDomRef(i);this._oItemNavigation.setItemDomRefs(this._aGridCells);this._oItemNavigation.setCycling(false);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"],saphome:["alt","meta"],sapend:["meta"]});this._oItemNavigation.setTableMode(true,true).setColumns(this._getColumns());this._oItemNavigation.setPageSize(this._aGridCells.length);}
return s;});
sap.ui.predefine('sap/m/SinglePlanningCalendarGridRenderer',['sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate','sap/ui/core/IconPool','sap/ui/core/InvisibleText','./PlanningCalendarLegend','sap/ui/unified/library'],function(C,a,U,I,b,P,u){"use strict";var v=0.125;var A=0.125;var c=0.0625;var d=u.CalendarDayType;var S={apiVersion:2};
S.render=function(r,o){r.openStart("div",o);r.class("sapMSinglePCGrid");r.openEnd();r.renderControl(o.getAggregation("_columnHeaders"));this.renderBlockersContainer(r,o);r.openStart("div");r.attr("role","grid");r.class("sapMSinglePCGridContent");r.openEnd();this.renderRowHeaders(r,o);this.renderNowMarker(r,o);this.renderColumns(r,o);r.close("div");r.close("div");};
S.renderBlockersContainer=function(r,o){var e=o._getColumns(),m=o._getBlockersToRender().iMaxlevel,s=o.getStartDate(),f=(m+1)*o._getBlockerRowHeight()+0.1875,F=o._getDateFormatter(),g=o._getSpecialDates(),h=C.fromLocalJSDate(s),D=o._getColumnHeaders()._getDateTypes(h),t,l;r.openStart("div");r.attr("role","grid");r.class("sapMSinglePCBlockersRow");r.openEnd();r.openStart("div");r.attr("role","row");r.class("sapMSinglePCBlockersColumns");if(g&&o._getColumns()===1){if(D&&D[0]){t=D[0];r.class("sapUiCalItem"+t.type);l=P.findLegendItemForItem(sap.ui.getCore().byId(o._sLegendId),t);}r.class("sapMSpecialDaysInDayView");}r.style("height",f+"rem");r.openEnd();this.renderDndPlaceholders(r,o,o.getAggregation("_blockersPlaceholders"));for(var i=0;i<e;i++){var j=new C(s.getFullYear(),s.getMonth(),s.getDate()+i);r.openStart("div");r.attr("role","gridcell");r.attr("data-sap-start-date",F.format(j.toLocalJSDate()));r.attr("data-sap-end-date",F.format(j.toLocalJSDate()));r.attr("aria-labelledby",b.getStaticId("sap.m","SPC_BLOCKERS")+" "+"fullDay-"+F.format(j.toLocalJSDate())+"-Descr");r.class("sapMSinglePCBlockersColumn");r.attr("tabindex",-1);if(j.isSame(new C())){r.class("sapMSinglePCBlockersColumnToday");}if(a._isWeekend(j,o._getCoreLocaleData())){r.class("sapMSinglePCBlockersColumnWeekend");}r.openEnd();r.openStart("span","fullDay-"+F.format(j.toLocalJSDate())+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getCellStartEndInfo(j.toLocalJSDate()));if(o._sLegendId&&l){r.text(l);}r.close("span");r.close("div");}this.renderBlockers(r,o);r.close("div");r.close("div");};
S.renderBlockers=function(r,o){var t=this,B=o._getBlockersToRender().oBlockersList;r.openStart("div");r.attr("role","list");r.attr("aria-labelledby",b.getStaticId("sap.m","SPC_BLOCKERS"));r.class("sapMSinglePCBlockers");r.class("sapUiCalendarRowVisFilled");r.openEnd();B.getIterator().forEach(function(e){t.renderBlockerAppointment(r,o,e);});r.close("div");};
S.renderBlockerAppointment=function(r,o,B){var g=C.fromLocalJSDate(o.getStartDate()),e=B.getData(),f=C.fromLocalJSDate(e.getStartDate()),h=C.fromLocalJSDate(e.getEndDate()),s=a._daysBetween(f,g),E=a._daysBetween(h,g),i=o._getColumns(),R=o._getBlockerRowHeight(),j=B.level,k=B.width,t=e.getTooltip_AsString(),T=e.getType(),l=e.getColor(),m=e.getTitle(),n=e.getText(),p=e.getIcon(),q=e.getId(),w={role:"listitem",labelledby:{value:b.getStaticId("sap.ui.unified","APPOINTMENT"),append:true},selected:null},x=o.getAriaLabelledBy(),L=s*(100/i),y=(i-E-1)*(100/i),z=sap.ui.getCore().getConfiguration().getRTL(),D;if(x.length>0){w["labelledby"].value=w["labelledby"].value+" "+x.join(" ");}if(m){w["labelledby"].value=w["labelledby"].value+" "+q+"-Title";}w["labelledby"].value=w["labelledby"].value+" "+q+"-Descr";if(n){w["labelledby"].value=w["labelledby"].value+" "+q+"-Text";}if(e.getTentative()){w["labelledby"].value=w["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}if(e.getSelected()){w["labelledby"].value=w["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_SELECTED");}r.openStart("div",e);r.attr("data-sap-level",j);r.attr("data-sap-width",k);r.attr("tabindex",0);if(t){r.attr("title",t);}r.accessibilityState(e,w);r.class("sapMSinglePCAppointmentWrap");r.class("sapUiCalendarRowApps");if(!l&&T!==d.None){r.class("sapUiCalendarApp"+T);}if(l){if(sap.ui.getCore().getConfiguration().getRTL()){r.style("border-right-color",l);}else{r.style("border-left-color",l);}}r.style("top",R*j+0.0625+"rem");r.style(z?"right":"left",Math.max(L,0)+"%");r.style(z?"left":"right",Math.max(y,0)+"%");r.openEnd();r.openStart("div");r.class("sapUiCalendarApp");if(e.getSelected()){r.class("sapUiCalendarAppSel");}if(e.getTentative()){r.class("sapUiCalendarAppTent");}if(p){r.class("sapUiCalendarAppWithIcon");}r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(l){r.style("background-color",e._getCSSColorForBackground(l));}r.openEnd();if(L<0){D=["sapUiCalendarAppArrowIconLeft","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-left",D,{title:null,role:"img"});}if(p){D=["sapUiCalendarAppIcon"];var F={};F["id"]=q+"-Icon";F["title"]=null;F["role"]="img";r.icon(p,D,F);}if(m){r.openStart("span",q+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(m,true);r.close("span");}if(y<0){D=["sapUiCalendarAppArrowIconRight","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-right",D,{title:null,role:"img"});}r.openStart("span",q+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getAppointmentAnnouncementInfo(e));r.close("span");r.close("div");r.close("div");r.close("div");};
S.renderRowHeaders=function(r,o){var s=o._getVisibleStartHour(),e=o._getVisibleEndHour(),f=new Date(),h=o._getHoursFormat(),g=o._getAMPMFormat();r.openStart("div");r.class("sapMSinglePCRowHeaders");r.openEnd();for(var i=s;i<=e;i++){f.setHours(i);r.openStart("span");r.class("sapMSinglePCRowHeader");r.class("sapMSinglePCRowHeader"+i);if(o._shouldHideRowHeader(i)){r.class("sapMSinglePCRowHeaderHidden");}r.openEnd();r.text(h.format(f));if(o._hasAMPM()){r.openStart("span");r.class("sapMSinglePCRowHeaderAMPM");r.openEnd();r.text(" "+g.format(f));r.close("span");}r.close("span");}r.close("div");};
S.renderColumns=function(r,o){var e=o._getColumns(),s=o.getStartDate(),f=o._getAppointmentsToRender();r.openStart("div");r.attr("role","grid");r.attr("aria-labelledby",b.getStaticId("sap.m","SPC_APPOINTMENTS"));r.class("sapMSinglePCColumns");r.openEnd();for(var i=0;i<e;i++){var g=new C(s.getFullYear(),s.getMonth(),s.getDate()+i),F=o._getDateFormatter(),D=F.format(g.toLocalJSDate());r.openStart("div");r.attr("role","row");r.attr("data-sap-day",D);r.class("sapMSinglePCColumn");if(g.isSame(new C())){r.class("sapMSinglePCColumnToday");}if(a._isWeekend(g,o._getCoreLocaleData())){r.class("sapMSinglePCColumnWeekend");}r.openEnd();this.renderDndPlaceholders(r,o,o._dndPlaceholdersMap[g]);this.renderRows(r,o,D);this.renderAppointments(r,o,f[D],g,i);r.close("div");}r.close("div");};
S.renderDndPlaceholders=function(r,o,p){r.openStart("div");r.class("sapMSinglePCOverlay");r.openEnd();p.forEach(r.renderControl,r);r.close("div");};
S.renderRows=function(r,o,D){var s=o._getVisibleStartHour(),e=o._getVisibleEndHour(),f=o._getDateFormatter(),g,h;for(var i=s;i<=e;i++){g=o._parseDateStringAndHours(D,i);h=new Date(g.getFullYear(),g.getMonth(),g.getDate(),g.getHours()+1);r.openStart("div");r.attr("role","gridcell");r.class("sapMSinglePCRow");if(!o._isVisibleHour(i)){r.class("sapMSinglePCNonWorkingRow");}r.attr("data-sap-hour",i);r.attr("data-sap-start-date",f.format(g));r.attr("data-sap-end-date",f.format(h));r.attr("aria-labelledby",f.format(g)+"-Descr");r.attr("tabindex",-1);r.openEnd();r.openStart("span",f.format(g)+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getCellStartEndInfo(g,h));r.close("span");r.close("div");}};
S.renderAppointments=function(r,o,e,f,i){var t=this,g=0;if(e){r.openStart("div");r.attr("role","list");r.class("sapMSinglePCAppointments");r.class("sapUiCalendarRowVisFilled");r.openEnd();e.oAppointmentsList.getIterator().forEach(function(h){var m=e.iMaxLevel,l=h.level,w=h.width,j=h.getData();t.renderAppointment(r,o,m,l,w,j,f,i,g);g++;});r.close("div");}};
S.renderAppointment=function(r,o,m,i,e,f,g,h,j){var G=C.fromLocalJSDate(o.getStartDate()),k=new C(G),R=o._getRowHeight(),l=new U(g.getYear(),g.getMonth(),g.getDate(),o._getVisibleStartHour()),n=new U(g.getYear(),g.getMonth(),g.getDate(),o._getVisibleEndHour(),59,59),p=f.getStartDate(),q=f.getEndDate(),s=C.fromLocalJSDate(p),t=C.fromLocalJSDate(q),T=f.getTooltip_AsString(),w=f.getType(),x=f.getColor(),y=f.getTitle(),z=f.getText(),B=f.getIcon(),D=f.getId(),L=this._getLineClamp(p,q),E={role:"listitem",labelledby:{value:b.getStaticId("sap.ui.unified","APPOINTMENT"),append:true},selected:null},F=o.getAriaLabelledBy(),H=l.getTime()>p.getTime(),J=n.getTime()<q.getTime(),K=H?0:o._calculateTopPosition(p),M=J?0:o._calculateBottomPosition(q),N=100/(m+1),O=f.getParent().getEnableAppointmentsDragAndDrop(),Q,V,W,X,Y;k.setDate(k.getDate()+o._getColumns()-1);Q=a._daysBetween(s,G);V=a._daysBetween(k,t);W=g.isSame(G);X=g.isSame(k);if(F.length>0){E["labelledby"].value=E["labelledby"].value+" "+F.join(" ");}if(y){E["labelledby"].value=E["labelledby"].value+" "+D+"-Title";}E["labelledby"].value=E["labelledby"].value+" "+D+"-Descr";if(z){E["labelledby"].value=E["labelledby"].value+" "+D+"-Text";}if(f.getTentative()){E["labelledby"].value=E["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}if(f.getSelected()){E["labelledby"].value=E["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_SELECTED");}r.openStart("div",f.getId()+"-"+h+"_"+j);r.attr("draggable",O);r.attr("data-sap-ui-draggable",O);r.attr("data-sap-ui-related",f.getId());r.attr("data-sap-level",i);r.attr("data-sap-width",e);r.attr("tabindex",0);if(T){r.attr("title",T);}r.accessibilityState(f,E);r.class("sapMSinglePCAppointmentWrap");r.class("sapUiCalendarRowApps");if(!x&&w!==d.None){r.class("sapUiCalendarApp"+w);}if(x){if(sap.ui.getCore().getConfiguration().getRTL()){r.style("border-right-color",x);}else{r.style("border-left-color",x);}}r.style("top",K+"rem");r.style("bottom",M+"rem");r.style(sap.ui.getCore().getConfiguration().getRTL()?"right":"left",N*i+"%");r.style("width",N*e+"%");r.openEnd();r.openStart("div");r.class("sapUiCalendarApp");r.style("min-height",(R-(v+A+c))/2+"rem");if(f.getSelected()){r.class("sapUiCalendarAppSel");}if(f.getTentative()){r.class("sapUiCalendarAppTent");}if(B){r.class("sapUiCalendarAppWithIcon");}r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(x){r.style("background-color",f._getCSSColorForBackground(x));}r.openEnd();if(W&&Q<0){Y=["sapUiCalendarAppArrowIconLeft","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-left",Y,{title:null,role:"img"});}if(B){Y=["sapUiCalendarAppIcon"];var Z={};Z["id"]=D+"-Icon";Z["title"]=null;Z["role"]="img";r.icon(B,Y,Z);}r.openStart("div");r.class("sapUiCalendarAppTitleWrapper");r.class("sapUiSPCAppLineClamp"+L);r.openEnd();if(y){r.openStart("span",D+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(y,true);r.close("span");}if(z){r.openStart("span",D+"-Text");r.class("sapUiCalendarAppText");r.openEnd();r.text(z,true);r.close("span");}r.close("div");if(X&&V<0){Y=["sapUiCalendarAppArrowIconRight","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-right",Y,{title:null,role:"img"});}r.openStart("span",D+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getAppointmentAnnouncementInfo(f));r.close("span");r.close("div");if(o.getEnableAppointmentsResize()){this.renderResizeHandles(r,!H,!J);}r.close("div");r.close("div");};
S.renderNowMarker=function(r,o){var D=new Date();r.openStart("div",o.getId()+"-nowMarker");r.style("top",o._calculateTopPosition(D)+"rem");r.class("sapMSinglePCNowMarker");if(!o._isVisibleHour(D.getHours())){r.class("sapMSinglePCNowMarkerHidden");}r.openEnd();r.openStart("span",o.getId()+"-nowMarkerText");r.class("sapMSinglePCNowMarkerText");r.openEnd();r.text(o._formatTimeAsString(D));if(o._hasAMPM()){r.openStart("span",o.getId()+"-nowMarkerAMPM");r.class("sapMSinglePCNowMarkerAMPM");r.openEnd();r.text(o._addAMPM(D));r.close("span");}r.close("span");r.close("div");};
S.renderResizeHandles=function(r,R,e){if(e){r.openStart("span");r.class("sapMSinglePCAppResizeHandleBottom");r.openEnd();r.close("span");}if(R){r.openStart("span");r.class("sapMSinglePCAppResizeHandleTop");r.openEnd();r.close("span");}};
S._getLineClamp=function(o,e){var m=a._minutesBetween(o,e);if(m>=51&&m<69){return"2";}else if(m>=69&&m<90){return"3";}else if(m>=90&&m<110){return"4";}else if(m>=110&&m<130){return"5";}else if(m>=130&&m<150){return"6";}else if(m>=150&&m<170){return"7";}else if(m>=170&&m<190){return"8";}else if(m>=190){return"9";}else{return"1";}};
return S;},true);
sap.ui.predefine('sap/m/SinglePlanningCalendarMonthGrid',['sap/ui/core/Control','sap/ui/core/format/DateFormat','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/DateTypeRange','sap/ui/unified/library','sap/ui/core/LocaleData','sap/ui/core/Locale','sap/ui/core/delegate/ItemNavigation','sap/ui/core/dnd/DragDropInfo','sap/ui/core/CustomData','sap/ui/events/KeyCodes','sap/base/Log','sap/ui/core/Core','./Link','./PlanningCalendarLegend','./SinglePlanningCalendarMonthGridRenderer'],function(C,D,c,d,e,u,L,f,I,g,h,K,l,m,n,P,S){"use strict";var A=1.5625;var o=1.5;var p=2.125;var q=1.75;
var r=C.extend("sap.m.SinglePlanningCalendarMonthGrid",{metadata:{library:"sap.m",properties:{startDate:{type:"object",group:"Data"},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false},firstDayOfWeek:{type:"int",group:"Appearance",defaultValue:-1}},aggregations:{appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",dnd:{draggable:true}},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},_appsPlaceholders:{type:"sap.m.SinglePlanningCalendarMonthGrid._internal.IntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}}},dnd:true,associations:{legend:{type:"sap.m.PlanningCalendarLegend",multiple:false}},events:{cellPress:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},moreLinkPress:{parameters:{date:{type:"object"}}},appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},copy:{type:"boolean"}}},appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"}}}}}});
r.prototype.init=function(){this._aLinks=[];this._handleMorePress=this._handleMorePress.bind(this);this._oDateFormat=D.getDateTimeInstance({pattern:"YYYYMMdd"});this._oFormatAriaApp=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY 'at' "+this._getCoreLocaleData().getTimePattern("medium")});this._oFormatAriaFullDayCell=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY"});this.setStartDate(new Date());this._configureAppointmentsDragAndDrop();};
r.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}for(var i=0;i<this._aLinks.length;i++){if(this._aLinks[i]){this._aLinks[i].destroy();}}delete this._aLinks;};
r.prototype.onBeforeRendering=function(){var a=this.getStartDate();this._oAppointmentsToRender=this._calculateAppointmentsNodes(a);this._createAppointmentsDndPlaceholders(a);};
r.prototype.onAfterRendering=function(){this._initItemNavigation();};
r.prototype._getColumns=function(){return 7;};
r.prototype._getRows=function(){return 6;};
r.prototype._getDateFormatter=function(){return this._oDateFormat;};
r.prototype._getAppointmetsForADay=function(a){return this._oAppointmentsToRender.filter(function(b){return b.start.valueOf()===a.valueOf();});};
r.prototype._getPreviousAppointmetsForADay=function(a){return this._oAppointmentsToRender.filter(function(b){return b.start.valueOf()<a.valueOf()&&b.end.valueOf()>=a.valueOf();}).map(function(b){var i={data:b.data,start:b.start,end:b.end,len:b.len,level:b.level,width:b.width};i.width-=d._daysBetween(a,b.start);i.hasPrevious=true;return i;},this);};
r.prototype.ontap=function(E){this._fireSelectionEvent(E);};
r.prototype.onkeydown=function(E){if(E.which===K.SPACE||E.which===K.ENTER){this._fireSelectionEvent(E);E.preventDefault();}};
r.prototype._findSrcControl=function(E){if(!E.target.parentElement||!E.target.parentElement.classList.contains("sapUiCalendarRowApps")){return E.srcControl;}var a=E.target.parentElement.getAttribute("data-sap-ui-related");return this.getAppointments().find(function(b){return b.sId===a;});};
r.prototype._fireSelectionEvent=function(E){var a=this._findSrcControl(E),t=E.target,i=t&&t.classList.contains("sapMSPCMonthDay"),b=t&&t.classList.contains("sapMLnk"),T,j,k;if(a&&a.isA("sap.m.SinglePlanningCalendarMonthGrid")&&i&&!b){T=parseInt(t.getAttribute("sap-ui-date"));j=new Date(T);j=new Date(j.getFullYear(),j.getMonth(),j.getDate());k=new Date(j);k.setDate(k.getDate()+1);this.fireEvent("cellPress",{startDate:j,endDate:k});this.fireAppointmentSelect({appointment:undefined,appointments:this._toggleAppointmentSelection(undefined,true)});}else if(a&&a.isA("sap.ui.unified.CalendarAppointment")){if(t.parentElement&&t.parentElement.getAttribute("id")){var v=t.parentElement.getAttribute("id");var B=t.parentElement.getAttribute("data-sap-ui-related");var w=v.replace(B+"-","");a._setAppointmentPartSuffix(w);}this.fireAppointmentSelect({appointment:a,appointments:this._toggleAppointmentSelection(a,!(E.ctrlKey||E.metaKey))});}};
r.prototype._toggleAppointmentSelection=function(a,R){var b=[],j=a&&a.getDomRef(),k,t,i;if(R){k=this.getAppointments();for(i=0,t=k.length;i<t;i++){if((!a||k[i].getId()!==a.getId())&&k[i].getSelected()){k[i].setProperty("selected",false);b.push(k[i]);}}}if(a){a.setProperty("selected",!a.getSelected());b.push(a);this._sSelectedAppointment=a.getSelected()&&j?a:undefined;}else{this._sSelectedAppointment=undefined;}return b;};
r.prototype._getMoreLink=function(a,b,i){var M=m.getLibraryResourceBundle("sap.m").getText("SPC_MORE_LINK",[a.toString()]),j=new n({text:M,press:this._handleMorePress}).addCustomData(new h({key:"date",value:b.valueOf().toString(),writeToDom:true}));if(this._aLinks[i]){this._aLinks[i].destroy();}this._aLinks[i]=j;return j;};
r.prototype._handleMorePress=function(E){var t=parseInt(E.getSource().getCustomData()[0].getValue()),a=new Date(t);a=new Date(a.getFullYear(),a.getMonth(),a.getDate());this.fireEvent("moreLinkPress",{date:a});};
r.prototype._getCoreLocaleData=function(){var a=m.getConfiguration().getFormatSettings().getFormatLocale().toString(),b=new f(a);return L.getInstance(b);};
r.prototype._getCells=function(){return this._getVisibleDays(this.getStartDate());};
r.prototype._getVerticalLabels=function(){var a=this._getVisibleDays(this.getStartDate()),b=this._getColumns(),R=[],j=m.getConfiguration().getFormatLocale().toString(),k=this._getCoreLocaleData();for(var i=0;i<this._getRows();i++){R.push(d.calculateWeekNumber(a[i*b].toUTCJSDate(),a[i*b].getYear(),j,k));}return R;};
r.prototype._getVisibleDays=function(a){var b,j,k,t,v,F,w,V=[];if(!a){return V;}b=c.fromLocalJSDate(a);j=this.getFirstDayOfWeek();w=j>0?j:this._getCoreLocaleData().getFirstDayOfWeek();F=new c(b);F.setDate(1);v=F.getDay()-w;if(v<0){v=7+v;}if(v>0){F.setDate(1-v);}k=new c(F);for(var i=0;i<this._getColumns()*this._getRows();i++){t=new c(k);V.push(t);k.setDate(k.getDate()+1);}return V;};
r.prototype._getAppointmentsToRender=function(){return this._oAppointmentsToRender;};
r.prototype._calculateAppointmentsNodes=function(t){var v=this._getVisibleDays(t),F=v[0],w=v[v.length-1],x=this.getAppointments().filter(function(a){var b=a.getStartDate()&&a.getEndDate();if(!b){l.warning("Appointment "+a.getId()+" has no start or no end date. It is ignored.");}return b;}).map(function(a){var b=c.fromLocalJSDate(a.getStartDate()),G=c.fromLocalJSDate(a.getEndDate());return{data:a,start:b,end:G,len:d._daysBetween(G,b)};}).filter(function(a){return d._isBetween(a.start,F,w,true)||d._isBetween(a.end,F,w,true)||(d._isBetween(F,a.start,w,true)&&d._isBetween(w,F,a.end,true));}).sort(function G(a,b){return a.start.valueOf()-b.start.valueOf();}),V=[],y,z,E,B,i,j,k;for(i=0;i<v.length;i++){V.push([]);}for(i=0;i<x.length;i++){y=x[i];z=d._daysBetween(y.start,v[0]);E=z+y.len;z=z>0?z:0;E=E<v.length?E:v.length-1;y.width=y.len+1;B=V[z].indexOf(true);if(B===-1){B=V[z].length;}y.level=B;for(j=z;j<=E;j++){V[j][B]=false;for(k=0;k<B;k++){if(V[j][k]===undefined){V[j][k]=true;}}}}this._aAppsLevelsPerDay=V;return x;};
r.prototype._getMoreCountPerCell=function(a){var b=this._aAppsLevelsPerDay[a];var M=this._getMaxAppointments();var j=0;var k=0;if(b.length<=M){return 0;}for(var i=0;i<b.length;i++){if(!b[i]){j++;}if(i<M-1){k++;}}return j-k;};
r.prototype._configureAppointmentsDragAndDrop=function(){this.addDragDropConfig(new g({sourceAggregation:"appointments",targetAggregation:"_appsPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsDragAndDrop()){E.preventDefault();return false;}var H=function(){var O=jQuery(".sapMSinglePCOverlay");setTimeout(function(){O.addClass("sapMSinglePCOverlayDragging");});jQuery(document).one("dragend",function(){O.removeClass("sapMSinglePCOverlayDragging");});};H();}.bind(this),dragEnter:function(E){var a=E.getParameter("dragSession"),b=function(){var i=jQuery(a.getIndicator());i.css("min-height",a.getDropControl().$().outerHeight());i.css("min-width",a.getDropControl().$().outerWidth());};if(!a.getIndicator()){setTimeout(b,0);}else{b();}},drop:function(E){var a=E.getParameter("dragSession"),b=a.getDragControl(),i=a.getDropControl(),j=i.getDate(),k=c.fromLocalJSDate(b.getStartDate()),t=c.fromLocalJSDate(b.getEndDate()),O=d._daysBetween(j,k),v=new c(k),w=new c(t),B=E.getParameter("browserEvent"),x=(B.metaKey||B.ctrlKey);v.setDate(v.getDate()+O);w.setDate(w.getDate()+O);this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");if(k.valueOf()===j.valueOf()){return;}this.fireAppointmentDrop({appointment:b,startDate:v.toLocalJSDate(),endDate:w.toLocalJSDate(),copy:x});}.bind(this)}));};
r.prototype._initItemNavigation=function(){var R=this.getDomRef();this._aGridCells=this.$().find(".sapMSPCMonthDay").toArray();if(!this._oItemNavigation){this._oItemNavigation=new I();this.addDelegate(this._oItemNavigation);this._oItemNavigation.attachEvent(I.Events.BorderReached,this._itemNavigationBorderReached,this);}this._oItemNavigation.setRootDomRef(R);this._oItemNavigation.setItemDomRefs(this._aGridCells);this._oItemNavigation.setCycling(false);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"],saphome:["alt","meta"],sapend:["meta"]});this._oItemNavigation.setTableMode(false).setColumns(this._getColumns(),true);this._oItemNavigation.setPageSize(this._aGridCells.length);};
r.prototype._itemNavigationBorderReached=function(E){var G,F,i=E.getParameter("event"),O;if(i.target.classList.contains("sapMSPCMonthDay")){G=i.target;F=parseInt(G.getAttribute("sap-ui-date"));switch(i.keyCode){case K.ARROW_LEFT:O=-1;break;case K.ARROW_UP:O=-this._getColumns();break;case K.ARROW_RIGHT:O=1;break;case K.ARROW_DOWN:O=this._getColumns();break;default:break;}this.fireEvent("borderReached",{startDate:F,offset:O});}};
r.prototype._createAppointmentsDndPlaceholders=function(a){var b=this._getVisibleDays(a);this.destroyAggregation("_appsPlaceholders");for(var i=0;i<b.length;i++){var j=new s({date:b[i]});this.addAggregation("_appsPlaceholders",j,true);}};
var s=C.extend("sap.m.SinglePlanningCalendarMonthGrid._internal.IntervalPlaceholder",{
metadata:{properties:{date:{type:"object",group:"Data"}}},
renderer:{apiVersion:2,render:function(R,a){R.openStart("div",a).class("sapMSinglePCPlaceholder").openEnd().close("div");}}
});
r.prototype._getCellStartInfo=function(a){var b=m.getLibraryResourceBundle("sap.ui.unified").getText("CALENDAR_START_TIME");return b+": "+this._oFormatAriaFullDayCell.format(a)+"; ";};
r.prototype._getAppointmentAnnouncementInfo=function(a){var U=m.getLibraryResourceBundle("sap.ui.unified"),b=U.getText("CALENDAR_START_TIME"),E=U.getText("CALENDAR_END_TIME"),F=this._oFormatAriaApp.format(a.getStartDate()),i=this._oFormatAriaApp.format(a.getEndDate()),j=b+": "+F+"; "+E+": "+i;return j+"; "+P.findLegendItemForItem(m.byId(this._sLegendId),a);};
r.prototype._getMaxAppointments=function(){return this._isCompact()?4:3;};
r.prototype._getDensitySizes=function(){return this._isCompact()?{appHeight:A,cellHeaderHeight:o}:{appHeight:p,cellHeaderHeight:q};};
r.prototype._isCompact=function(){var a=this.getDomRef()||(this.getParent()&&this.getParent().getDomRef&&this.getParent().getDomRef()||(this.getParent()&&this.getParent().getRootNode&&this.getParent().getRootNode()));while(a&&a.classList){if(a.classList.contains("sapUiSizeCompact")){return true;}a=a.parentNode;}return false;};
r.prototype._getSpecialDates=function(){var a=this.getSpecialDates();for(var i=0;i<a.length;i++){var N=a[i].getSecondaryType()===u.CalendarDayType.NonWorking&&a[i].getType()!==u.CalendarDayType.NonWorking;if(N){var b=new e();b.setType(u.CalendarDayType.NonWorking);b.setStartDate(a[i].getStartDate());if(a[i].getEndDate()){b.setEndDate(a[i].getEndDate());}a.push(b);}}return a;};
r.prototype.applyFocusInfo=function(){this._sSelectedAppointment&&this._sSelectedAppointment.focus();return this;};
return r;});
sap.ui.predefine('sap/m/SinglePlanningCalendarMonthGridRenderer',['sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/Month','sap/ui/core/date/UniversalDate','sap/ui/core/IconPool','./PlanningCalendarLegend','sap/ui/core/InvisibleText','sap/ui/core/Core','sap/ui/unified/library'],function(C,a,M,U,I,P,b,c,u){"use strict";var d=u.CalendarDayType;var S={apiVersion:2};
S.render=function(r,o){var l=o._getCoreLocaleData();var D=o._getDensitySizes();r.openStart("div",o);r.class("sapMSinglePCGrid");r.class("sapMSPCMonthGrid");r.openEnd();this.renderDayNames(r,o,l);r.openStart("div");r.class("sapMSinglePCGridContent");r.openEnd();this.renderCells(r,o,l,D);r.close("div");r.close("div");};
S.renderCells=function(r,o,l,D){var e=o._getCells(),v=o._getVerticalLabels(),f=o._getColumns(),m=[],A=[],g,h,k,p,n=[],q,w,i,j;for(i=0;i<o._getRows();i++){w=0;r.openStart("div");r.attr("role","grid");r.class("sapMSPCMonthWeek");r.openEnd();r.openStart("div");r.class("sapMSPCMonthWeekNumber");r.openEnd();r.text(v[i]);r.close("div");for(j=0;j<f;j++){g=i*f+j;h=e[g];k=o._getAppointmetsForADay(h);p=o._getPreviousAppointmetsForADay(h);n.push(p);q=o._getMoreCountPerCell(g);m.push(q);A.push(k);w=Math.max(w,o._aAppsLevelsPerDay[g].length);}r.openStart("div");r.class("sapMSPCMonthDays");r.class("sapMSPCMonthDaysMax"+w);r.attr("role","row");r.openEnd();for(j=0;j<f;j++){g=i*f+j;h=e[g];this.renderDay(r,o,h,l,m[g],g);}r.openStart("div");r.class("sapMSinglePCBlockers");r.class("sapUiCalendarRowVisFilled");r.attr("role","list");r.openEnd();for(j=0;j<f;j++){g=i*f+j;h=e[g];if(j===0){this.renderAppointments(r,o,n[g],j,m[g],D,i);}this.renderAppointments(r,o,A[g],j,m[g],D,i);}r.close("div");r.close("div");r.close("div");}};
S.renderDay=function(r,o,D,l,m,i){var s=o._getSpecialDates(),e=M.prototype._getDateTypes.call(o,D),f=o._getDateFormatter(),t=D.isSame(C.fromLocalJSDate(new Date())),T,L;r.openStart("div");r.class("sapMSPCMonthDay");if(t){r.class("sapMSPCMonthDayToday");}r.attr("role","gridcell");if(a._isWeekend(D,l)||!a._isSameMonthAndYear(D,C.fromLocalJSDate(o.getStartDate()))){r.class("nonWorkingTimeframe");}if(s){if(e&&e[0]){T=e[0];r.class("sapUiCalendarSpecialDay"+T.type);L=P.findLegendItemForItem(c.byId(o._sLegendId),T);}}r.attr("sap-ui-date",D.valueOf().toString());r.attr("tabindex",-1);r.attr("aria-labelledby",f.format(D.toLocalJSDate())+"-Descr");r.openEnd();this.renderDndPlaceholder(r,o.getAggregation("_appsPlaceholders")[i]);if(t){r.openStart("div");r.class("sapMSPCMonthNowMarker");r.openEnd();}r.openStart("div");r.class("specialDateIndicator");r.openEnd();r.close("div");r.openStart("div");r.class("sapMSPCMonthDayNumber");r.openEnd();r.text(D.getDate());r.close("div");if(m){r.openStart("div");r.class("sapMSPCMonthLnkMore");r.openEnd();r.renderControl(o._getMoreLink(m,D,i));r.close("div");}r.openStart("span",f.format(D.toLocalJSDate())+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getCellStartInfo(D.toLocalJSDate()));if(o._sLegendId&&L){r.text(L);}r.close("span");if(t){r.close("div");}r.close("div");};
S.renderAppointments=function(r,o,e,f,m,D,R){var g=o._getMaxAppointments(),h=m?g-2:g-1;for(var i=0;i<e.length;i++){if(e[i].level<=h){this.renderAppointment(r,o,e[i],f,D,R);}}};
S.renderAppointment=function(r,o,e,i,D,R){var A=e.data,w=e.width,l=e.level,f=o._getColumns(),t=A.getTooltip_AsString(),T=A.getType(),s=A.getColor(),g=A.getTitle(),h=A.getText(),j=A.getIcon(),k=A.getId(),m=A.getParent().getEnableAppointmentsDragAndDrop(),n={role:"listitem",labelledby:{value:b.getStaticId("sap.ui.unified","APPOINTMENT"),append:true},selected:null},p=f-i-w,q=c.getConfiguration().getRTL(),v,B=c.getConfiguration().getTheme().indexOf("_hc")?2:1;p=p<0?0:p;if(g){n["labelledby"].value=n["labelledby"].value+" "+k+"-Title";}n["labelledby"].value=n["labelledby"].value+" "+k+"-Descr";if(h){n["labelledby"].value=n["labelledby"].value+" "+k+"-Text";}if(A.getTentative()){n["labelledby"].value=n["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}if(A.getSelected()){n["labelledby"].value=n["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_SELECTED");}r.openStart("div",A.getId()+"-"+i+"_"+R);r.attr("draggable",m);r.attr("data-sap-ui-draggable",m);r.attr("data-sap-ui-related",A.getId());r.attr("data-sap-level",l);r.attr("data-sap-width",w);r.attr("tabindex",0);if(t){r.attr("title",t);}r.accessibilityState(A,n);r.class("sapMSinglePCAppointmentWrap");r.class("sapUiCalendarRowApps");if(!s&&T!==d.None){r.class("sapUiCalendarApp"+T);}if(s){if(c.getConfiguration().getRTL()){r.style("border-right-color",s);}else{r.style("border-left-color",s);}}r.style(q?"right":"left","calc("+(i*100)/f+"% + "+B+"px)");r.style(q?"left":"right","calc("+(p*100)/f+"% + "+B+"px)");r.style("top",(l*D.appHeight+D.cellHeaderHeight)+"rem");r.openEnd();r.openStart("div");r.class("sapUiCalendarApp");if(A.getSelected()){r.class("sapUiCalendarAppSel");}if(A.getTentative()){r.class("sapUiCalendarAppTent");}if(j){r.class("sapUiCalendarAppWithIcon");}r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(s){r.style("background-color",A._getCSSColorForBackground(s));}r.openEnd();if(e.hasPrevious<0){v=["sapUiCalendarAppArrowIconLeft","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-left",v,{title:null,role:"img"});}if(j){v=["sapUiCalendarAppIcon"];var x={};x["id"]=k+"-Icon";x["title"]=null;x["role"]="img";r.icon(j,v,x);}if(g){r.openStart("span",k+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(g,true);r.close("span");}if(e.hasNext<0){v=["sapUiCalendarAppArrowIconRight","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-right",v,{title:null,role:"img"});}r.openStart("span",k+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getAppointmentAnnouncementInfo(A));r.close("span");r.close("div");r.close("div");r.close("div");};
S.renderDayNames=function(r,o,l){var A=o.getFirstDayOfWeek(),f=A>0?A:l.getFirstDayOfWeek(),s=o.getId(),D,e=c.getConfiguration().getCalendarType(),w=l.getDaysStandAlone("abbreviated",e),W=l.getDaysStandAlone("wide",e),g=new Date(o.getStartDate()),F,h;g.setDate(g.getDate()-g.getDay()+f);F=C.fromLocalJSDate(g);r.openStart("div",s+"-Names");r.class("sapMSPCMonthDayNames");r.openEnd();for(var i=0;i<7;i++){h=(i+f)%7;D=s+"-WH"+h;r.openStart("div",D);r.class("sapUiCalWH");if(i===0){r.class("sapUiCalFirstWDay");}if(a._isWeekend(F,l)){r.class("sapUiCalItemWeekEnd");}F.setDate(F.getDate()+1);r.accessibilityState(null,{role:"columnheader",label:W[h]});r.openEnd();r.text(w[h%7]);r.close("div");}r.close("div");};
S.renderDndPlaceholder=function(r,p){r.openStart("div");r.class("sapMSinglePCOverlay");r.openEnd();r.renderControl(p);r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/SinglePlanningCalendarMonthView',['./library','./SinglePlanningCalendarView','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/CalendarDate'],function(l,S,C,a){"use strict";
var b=S.extend("sap.m.SinglePlanningCalendarMonthView",{metadata:{library:"sap.m"}});
b.prototype.getEntityCount=function(){return 1;};
b.prototype.getScrollEntityCount=function(s,o){var n=a.fromLocalJSDate(s),m=s.getMonth()+o,i=o>0?1:-1;n.setMonth(m);while((m+12)%12!==n.getMonth()){n.setDate(n.getDate()-i);}return Math.abs(C._daysBetween(n,a.fromLocalJSDate(s)));};
b.prototype.calculateStartDate=function(s){var r=C.getFirstDateOfMonth(C._createUTCDate(s,true)).getJSDate();return C._createLocalDate(r,true);};
return b;});
sap.ui.predefine('sap/m/SinglePlanningCalendarRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,c){var h=c._getHeader(),g=c._getCurrentGrid();r.openStart("div",c);r.accessibilityState({role:"region",roledescription:c._oRB.getText("SPC_CONTROL_NAME"),labelledby:{value:h.getId()+"-Title "+g.getId()+"-nowMarkerText",append:true}});r.class("sapMSinglePC");r.openEnd();r.renderControl(h);r.renderControl(g);r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/SinglePlanningCalendarUtilities',[],function(){'use strict';
function A(d){this.data=d;this.level=0;this.width=1;this.prev=null;this.next=null;}
A.prototype.hasNext=function(){return this.next!==null;};
A.prototype.hasPrev=function(){return this.prev!==null;};
A.prototype.getData=function(){return this.data;};
function a(){this.head=null;this.tail=null;this.size=0;this.iterator=new b(this);}
a.prototype.getHeadNode=function(){return this.head;};
a.prototype.getTailNode=function(){return this.tail;};
a.prototype.getSize=function(){return this.size;};
a.prototype.isEmpty=function(){return this.getSize()===0;};
a.prototype.createNewNode=function(d){return new A(d);};
a.prototype.getIterator=function(){return this.iterator;};
a.prototype.indexOf=function(n,c){this.iterator.reset();var C,i=0;while(this.iterator.hasNext()){C=this.iterator.next();if(c(C)){return i;}i++;}return-1;};
a.prototype.add=function(d){var n=d;if(!(d instanceof A)){n=this.createNewNode(d);}if(this.isEmpty()){this.head=this.tail=n;}else{this.tail.next=n;n.prev=this.tail;this.tail=n;}this.size++;return true;};
a.prototype.insertFirst=function(d){if(this.isEmpty()){this.add(d);}else{var n=d;if(!(d instanceof A)){n=this.createNewNode(d);}n.next=this.head;this.head.prev=n;this.head=n;this.size++;return true;}};
a.prototype.insertAt=function(i,d){var c=this.getHeadNode(),p=0,n=d;if(!(d instanceof A)){n=this.createNewNode(d);}if(i<0){return false;}if(i===0){return this.insertFirst(d);}if(i>this.getSize()-1){return this.add(d);}while(p<i){c=c.next;p++;}c.prev.next=n;n.prev=c.prev;c.prev=n;n.next=c;this.size++;return true;};
a.prototype.insertAfterLevel=function(l,n){var i=this.indexOf(n,function(c){var L=c.level===l;if(c.next&&c.next.level===l){L=false;}return L;}),s=this.getSize();if(i+1===s||i===-1){return this.add(n);}else{return this.insertAt(i+1,n);}};
function b(l){this.list=l;this.stopIterationFlag=false;this.currentNode=null;}
b.prototype.next=function(){var c=this.currentNode;if(this.currentNode!==null){this.currentNode=this.currentNode.next;}return c;};
b.prototype.hasNext=function(){return this.currentNode!==null;};
b.prototype.reset=function(){this.currentNode=this.list.getHeadNode();return this;};
b.prototype.forEach=function(c,t){var C;t=t||this;this.reset();while(this.hasNext()&&!this.stopIterationFlag){C=this.next();c.call(t,C);}this.stopIterationFlag=false;};
b.prototype.interrupt=function(){this.stopIterationFlag=true;return this;};
return{iterator:b,node:A,list:a};});
sap.ui.predefine('sap/m/SinglePlanningCalendarView',['./library','sap/base/Log','sap/ui/core/Element'],function(l,L,E){"use strict";
var S=E.extend("sap.m.SinglePlanningCalendarView",{metadata:{library:"sap.m",properties:{key:{type:"string",group:"Data"},title:{type:"string",group:"Appearance"},firstDayOfWeek:{type:"int",group:"Appearance",defaultValue:-1}}}});
S.prototype.getEntityCount=function(){L.warning("This method should be implemented in one of the inherited classes.",this);};
S.prototype.getScrollEntityCount=function(){L.warning("This method should be implemented in one of the inherited classes.",this);};
S.prototype.calculateStartDate=function(d){L.warning("This method should be implemented in one of the inherited classes.",this);};
return S;});
sap.ui.predefine('sap/m/SinglePlanningCalendarWeekView',['./library','./SinglePlanningCalendarView','sap/ui/core/LocaleData','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils'],function(l,S,L,C,a){"use strict";
var b=S.extend("sap.m.SinglePlanningCalendarWeekView",{metadata:{library:"sap.m"}});
b.prototype.getEntityCount=function(){return 7;};
b.prototype.getScrollEntityCount=function(){return 7;};
b.prototype.calculateStartDate=function(s){var c=C.fromLocalJSDate(s),o=a._getFirstDateOfWeek(c),d=o.toLocalJSDate(),O=d.getDay(),r=this.getFirstDayOfWeek(),e;if(r===-1){e=L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale());r=e.getFirstDayOfWeek();}d.setDate(d.getDate()-O+r);return d;};
return b;});
sap.ui.predefine('sap/m/SinglePlanningCalendarWorkWeekView',['./library','./SinglePlanningCalendarView','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/LocaleData'],function(l,S,C,a,L){"use strict";
var b=S.extend("sap.m.SinglePlanningCalendarWorkWeekView",{metadata:{library:"sap.m"}});
b.prototype.getEntityCount=function(){return 5;};
b.prototype.getScrollEntityCount=function(){return 7;};
b.prototype.calculateStartDate=function(s){var c=C.fromLocalJSDate(s),o=a._getFirstDateOfWeek(c),d=this._getFormatSettingsLocaleData();if(o.getDay()===d.getWeekendEnd()){o.setDate(o.getDate()+1);}return o.toLocalJSDate();};
b.prototype._getFormatSettingsLocaleData=function(){return L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale());};
return b;});
sap.ui.predefine('sap/m/SlideTile',['./library','sap/ui/core/Control','sap/m/GenericTile','sap/ui/Device','sap/ui/core/Icon','./SlideTileRenderer',"sap/ui/events/KeyCodes","sap/ui/events/PseudoEvents","sap/ui/thirdparty/jquery"],function(l,C,G,D,I,S,K,P,q){"use strict";var a=l.GenericTileScope;var T=l.TileSizeBehavior;
var b=C.extend("sap.m.SlideTile",{metadata:{library:"sap.m",properties:{displayTime:{type:"int",group:"Appearance",defaultValue:5000},transitionTime:{type:"int",group:"Appearance",defaultValue:500},scope:{type:"sap.m.GenericTileScope",group:"Misc",defaultValue:"Display"},sizeBehavior:{type:"sap.m.TileSizeBehavior",defaultValue:T.Responsive},width:{type:"sap.ui.core.CSSSize",group:"Appearance"},height:{type:"sap.ui.core.CSSSize",group:"Appearance"}},defaultAggregation:"tiles",aggregations:{tiles:{type:"sap.m.GenericTile",multiple:true,singularName:"tile",bindable:"bindable"},_pausePlayIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},events:{press:{parameters:{scope:{type:"sap.m.GenericTileScope"},action:{type:"string"},domRef:{type:"any"}}}}}});
b.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setAggregation("_pausePlayIcon",new I({id:this.getId()+"-pause-play-icon",src:"sap-icon://media-pause",color:"#ffffff",size:"1rem",noTabStop:true}),true);};
b.prototype.onBeforeRendering=function(){G.prototype._initScopeContent.call(this,"sapMST");var A=this.getScope()===a.Actions;for(var i=0;i<this.getTiles().length;i++){this.getTiles()[i].showActionsView(A);}if(this._iCurrentTile>=0){this._iLastTile=this._iCurrentTile;}this._bNeedInvalidate=false;this._stopAnimation();this._sWidth=this._sHeight=undefined;this._iCurrentTile=this._iPreviousTile=undefined;};
b.prototype.onAfterRendering=function(){this._setupResizeClassHandler();var c=this.getTiles().length,s=this.getScope();this._removeGTFocus();this._iCurrAnimationTime=0;this._bAnimationPause=false;if(this._iLastTile>=0&&c>1){this._scrollToTile(this._iLastTile);}else{this._scrollToNextTile();}if(c>1&&s===a.Display){this._startAnimation();}if(s===a.Actions&&this._iCurrentTile>=0&&this._hasNewsContent(this._iCurrentTile)){this.addStyleClass("sapMSTDarkBackground");}var o;for(var i=0;i<this.getTiles().length;i++){var d=this.getTiles()[this._iCurrentTile];if(d&&d._isNavigateActionEnabled()){d._oNavigateAction._bExcludeFromTabChain=false;d._oNavigateAction.invalidate();}o=document.querySelector('span[id$="tileIndicator-'+i+'"]');if(o){o.addEventListener("click",function(e){var f=e.currentTarget.id,g=parseInt(f.substring(f.lastIndexOf("-")+1)),h=this._iCurrentTile>g;if(this._iCurrentTile!==g){this._scrollToNextTile(this._bAnimationPause,h,g);}}.bind(this));}}};
b.prototype.exit=function(){this._stopAnimation();if(this._oMoreIcon){this._oMoreIcon.destroy();}if(this._oRemoveButton){this._oRemoveButton.destroy();}};
b.prototype.ontap=function(e){var s=this.getScope();this.$().trigger("focus");if(s===a.Actions){var p=this._getEventParams(e);this.firePress(p);e.preventDefault();}};
b.prototype.ontouchstart=function(e){if(this.getScope()===a.Display){if(q(e.target).hasClass("sapMSTIconClickTapArea")){this.addStyleClass("sapMSTIconPressed");}else{this.addStyleClass("sapMSTHvr");}}};
b.prototype.ontouchend=function(e){this.removeStyleClass("sapMSTHvr");};
b.prototype.ontouchcancel=function(e){if(this.hasStyleClass("sapMSTIconPressed")){this.removeStyleClass("sapMSTIconPressed");}else{this.removeStyleClass("sapMSTHvr");}};
b.prototype.onkeydown=function(e){if(this.getScope()===a.Display){if(P.events.sapenter.fnCheck(e)){var g=this.getTiles()[this._iCurrentTile];g.onkeydown(e);}}};
b.prototype.onkeyup=function(e){var p;if(this.getScope()===a.Display){if(P.events.sapenter.fnCheck(e)){var g=this.getTiles()[this._iCurrentTile];g.onkeyup(e);return;}if(P.events.sapspace.fnCheck(e)){this._toggleAnimation();}if(e.which===K.B&&this._bAnimationPause){this._scrollToNextTile(true,true);}if(e.which===K.F&&this._bAnimationPause){this._scrollToNextTile(true,false);}}else if(this.getScope()===a.Actions){if(P.events.sapselect.fnCheck(e)){this.firePress(this._getEventParams(e));e.preventDefault();}else if(P.events.sapdelete.fnCheck(e)||P.events.sapbackspace.fnCheck(e)){p={scope:this.getScope(),action:G._Action.Remove,domRef:this._oRemoveButton.getPopupAnchorDomRef()};this.firePress(p);e.preventDefault();}}};
b.prototype.onsapspace=function(e){e.preventDefault();};
b.prototype.onmouseup=function(e){if(this.getScope()===a.Display){if(this.hasStyleClass("sapMSTIconPressed")){this._toggleAnimation();this.removeStyleClass("sapMSTIconPressed");}}};
b.prototype.onmousedown=function(e){if(q(e.target).hasClass("sapMSTIconClickTapArea")){this.addStyleClass("sapMSTIconPressed");}};
b.prototype.setScope=function(v){if(this.getScope()!==v){if(v===a.Actions){this.setProperty("scope",v,true);this._bNeedInvalidate=true;this._stopAnimation(this._bNeedInvalidate);}else{this.setProperty("scope",v);}this._setTilePressState();}return this;};
b.prototype._setupResizeClassHandler=function(){var c=function(){if(this.getSizeBehavior()===T.Small||window.matchMedia("(max-width: 374px)").matches){this.$().addClass("sapMTileSmallPhone");}else{this.$().removeClass("sapMTileSmallPhone");}}.bind(this);q(window).on("resize",c);c();};
b.prototype._isFocusInsideST=function(){return this.$()[0]===document.activeElement||this.$().find(document.activeElement).length;};
b.prototype._removeGTFocus=function(){for(var i=0;i<this.getTiles().length;i++){this.getTiles()[i].$().removeAttr("tabindex");}};
b.prototype._toggleAnimation=function(){if(this.getTiles().length>1){if(this._bAnimationPause){this._startAnimation();}else{this._stopAnimation();}}this._updatePausePlayIcon();};
b.prototype._stopAnimation=function(n){this._iCurrAnimationTime+=Date.now()-this._iStartTime;clearTimeout(this._sTimerId);if(this._iCurrentTile!=undefined){var w=this.$("wrapper-"+this._iCurrentTile);w.stop();}if(this._iPreviousTile!=undefined){var W=this.$("wrapper-"+this._iPreviousTile);W.stop();}this._bAnimationPause=true;if(this._iCurrAnimationTime>this.getDisplayTime()){this._scrollToNextTile(true);}else{if(this.getTiles()[this._iCurrentTile]){this._setAriaDescriptor();}if(n){this.invalidate();}}};
b.prototype._startAnimation=function(){var d=this.getDisplayTime()-this._iCurrAnimationTime;clearTimeout(this._sTimerId);this._sTimerId=setTimeout(function(){this._scrollToNextTile();}.bind(this),d);this._iStartTime=Date.now();this._bAnimationPause=false;};
b.prototype._scrollToTile=function(t){if(t>=0){var w=this.$("wrapper-"+t);var d=sap.ui.getCore().getConfiguration().getRTL()?"right":"left";this._changeSizeTo(t);w.css(d,"0rem");this._iCurrentTile=t;if(this.getTiles()[t]){this._setAriaDescriptor();}this._updateTilesIndicator();}};
b.prototype._scrollToNextTile=function(p,c,n){var t=this._iCurrAnimationTime-this.getDisplayTime(),f,N,w,W,s,d,e,g,h,o;t=this.getTransitionTime()-(t>0?t:0);f=t===this.getTransitionTime();if(f){if(c){N=this._getPreviousTileIndex(this._iCurrentTile);}else{N=this._getNextTileIndex(this._iCurrentTile);}this._iPreviousTile=this._iCurrentTile;this._iCurrentTile=N;}if(n>=0){this._iCurrentTile=n;}W=this.$("wrapper-"+this._iCurrentTile);h=sap.ui.getCore().getConfiguration().getRTL()?"right":"left";var i=this.getTiles()[this._iCurrentTile];if(i&&i._isNavigateActionEnabled()){i._oNavigateAction._bExcludeFromTabChain=false;i._oNavigateAction.invalidate();}if(this._iPreviousTile!=undefined){var j=this.getTiles()[this._iPreviousTile];if(j&&j._isNavigateActionEnabled()){j._oNavigateAction._bExcludeFromTabChain=true;j._oNavigateAction.invalidate();}w=this.$("wrapper-"+this._iPreviousTile);s=w.css("width");d=parseFloat(W.css("width"));e=parseFloat(s);g=e<d;if(g){this._changeSizeTo(this._iCurrentTile);}if(f){W.css(h,s);}o={};if(c){o[h]=s;}else{o[h]="-"+s;}w.animate(o,{duration:t,done:function(){if(!g){this._changeSizeTo(this._iCurrentTile);}w.css(h,"");}.bind(this)});if(c){o[h]="-"+s;W.animate(o,0);}o[h]="0rem";W.animate(o,{duration:t,done:function(){this._iCurrAnimationTime=0;if(this._bNeedInvalidate){this.invalidate();}if(!p){this._startAnimation();}}.bind(this)});}else{this._changeSizeTo(this._iCurrentTile);W.css(h,"0rem");}if(this.getTiles()[this._iCurrentTile]){this._setAriaDescriptor();}this._updateTilesIndicator();};
b.prototype._setAriaDescriptor=function(){var t,s,c,o;s=this.getScope();c=this.getTiles();o=c[this._iCurrentTile];t=o._getAriaText().replace(/\s/g," ");if(s===a.Actions){t=this._oRb.getText("GENERICTILE_ACTIONS_ARIA_TEXT")+"\n"+t;}else if(c.length>1&&s===a.Display){t+="\n"+this._oRb.getText("SLIDETILE_MULTIPLE_CONTENT")+"\n"+this._oRb.getText("SLIDETILE_TOGGLE_SLIDING");if(this._bAnimationPause){t+="\n"+this._oRb.getText("SLIDETILE_SCROLL_BACK")+"\n"+this._oRb.getText("SLIDETILE_SCROLL_FORWARD");}}t+="\n"+this._oRb.getText("SLIDETILE_ACTIVATE");this.$().attr("aria-label",t);};
b.prototype._changeSizeTo=function(t){var o=this.getTiles()[t];if(!o){return;}if(this._sFrameType){this.$().removeClass(this._sFrameType);}if(this._sSize){this.$().removeClass(this._sSize);}this.$().addClass(o.getFrameType()).addClass(o.getSize());this._sFrameType=o.getFrameType();this._sSize=o.getSize();};
b.prototype._getPreviousTileIndex=function(t){if(t>0){return t-1;}else{return this.getTiles().length-1;}};
b.prototype._getNextTileIndex=function(t){if(t+1<this.getTiles().length){return t+1;}else{return 0;}};
b.prototype._updateTilesIndicator=function(){var $;for(var i=0;i<this.getTiles().length;i++){$=this.$("tileIndicator-"+i);if(i===this._iCurrentTile){$.addClass("sapMSTActive");}else{$.removeClass("sapMSTActive");}}};
b.prototype._updatePausePlayIcon=function(){if(this._bAnimationPause){this.getAggregation("_pausePlayIcon").setSrc("sap-icon://media-play");this.$().removeClass("sapMSTPauseIcon");}else{this.getAggregation("_pausePlayIcon").setSrc("sap-icon://media-pause");this.$().addClass("sapMSTPauseIcon");}};
b.prototype._setTilePressState=function(){var t=this.getTiles(),c=this.getScope()===a.Display;for(var i=0;i<t.length;i++){t[i].setPressEnabled(c);}};
b.prototype._hasNewsContent=function(t){var c=this.getTiles()[t].getTileContent();for(var i=0;i<c.length;i++){if(c[i]._getContentType()==="News"){return true;}}return false;};
b.prototype._getEventParams=G.prototype._getEventParams;return b;});
sap.ui.predefine('sap/m/SlideTileRenderer',['./library',"sap/base/security/encodeCSS"],function(l,e){"use strict";var G=l.GenericTileScope;var S={apiVersion:2};
S.render=function(r,c){var t=c.getTooltip_AsString(),s=c.getScope(),a=e("sapMSTScope"+s),L;r.openStart("div",c);if(c.getHeight()){r.style("height",c.getHeight());}if(c.getWidth()){r.style("width",c.getWidth());}r.class("sapMST");r.class(a);if(!this._bAnimationPause){r.class("sapMSTPauseIcon");}if(t){r.attr("title",t);}L=c.getTiles().length;if(L>1){r.attr("tabindex","0");}r.attr("role","presentation");r.openEnd();if(L>1&&s===G.Display){this._renderPausePlayIcon(r,c);this._renderTilesIndicator(r,c);}this._renderTiles(r,c,L);if(s===G.Actions){this._renderActionsScope(r,c);}r.openStart("div",c.getId()+"-focus");r.class("sapMSTFocusDiv");r.openEnd();r.close("div");r.close("div");};
S._renderTiles=function(r,c,L){r.openStart("div");r.class("sapMSTOverflowHidden");r.openEnd();for(var i=0;i<L;i++){r.openStart("div",c.getId()+"-wrapper-"+i);r.class("sapMSTWrapper");if(c.getTiles()[i].getFrameType()==sap.m.FrameType.Stretch&&c.getTiles()[i].getMode()==sap.m.GenericTileMode.ArticleMode){r.class("sapMGTTileStretch");}r.openEnd();r.renderControl(c.getTiles()[i]);r.close("div");}r.close("div");};
S._renderTilesIndicator=function(r,c){var p=c.getTiles().length;r.openStart("div",c.getId()+"-tilesIndicator");r.class("sapMSTBulleted");r.openEnd();for(var i=0;i<p;i++){r.openStart("span",c.getId()+"-tileIndicator-"+i);r.openEnd();r.close("span");}r.close("div");};
S._renderPausePlayIcon=function(r,c){if(c.getTiles().length>1){r.openStart("div");r.class("sapMSTIconClickTapArea");r.openEnd();r.close("div");r.openStart("div");r.class("sapMSTIconDisplayArea");r.openEnd();r.close("div");r.openStart("div");r.class("sapMSTIconNestedArea");r.openEnd();r.renderControl(c.getAggregation("_pausePlayIcon"));r.close("div");}};
S._renderActionsScope=function(r,c){r.renderControl(c._oRemoveButton);r.renderControl(c._oMoreIcon);};
return S;},true);
sap.ui.predefine('sap/m/Slider',['sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/InvisibleText','sap/ui/core/library','sap/ui/core/ResizeHandler','sap/base/Log','./library','./SliderTooltipContainer','./SliderTooltip','./SliderUtilities','./SliderRenderer','./ResponsiveScale',"sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes"],function(C,E,I,c,R,l,a,S,b,d,e,f,q,K){"use strict";var t=a.touch;
var g=C.extend("sap.m.Slider",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},enabled:{type:"boolean",group:"Behavior",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:""},min:{type:"float",group:"Data",defaultValue:0},max:{type:"float",group:"Data",defaultValue:100},step:{type:"float",group:"Data",defaultValue:1},progress:{type:"boolean",group:"Misc",defaultValue:true},value:{type:"float",group:"Data",defaultValue:0},showHandleTooltip:{type:"boolean",group:"Appearance",defaultValue:true},showAdvancedTooltip:{type:"boolean",group:"Appearance",defaultValue:false},inputsAsTooltips:{type:"boolean",group:"Appearance",defaultValue:false},enableTickmarks:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"scale",aggregations:{_tooltipContainer:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},scale:{type:"sap.m.IScale",multiple:false,singularName:"scale"},_defaultScale:{type:"sap.m.ResponsiveScale",multiple:false,visibility:"hidden"},_defaultTooltips:{type:"sap.m.SliderTooltipBase",multiple:true,visibility:"hidden"},customTooltips:{type:"sap.m.SliderTooltipBase",multiple:true},_handlesLabels:{type:"sap.ui.core.InvisibleText",multiple:true,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"float"}}},liveChange:{parameters:{value:{type:"float"}}}},designtime:"sap/m/designtime/Slider.designtime"}});
E.apply(g.prototype,[true]);
g.prototype._getUsedScale=function(){if(!this.getEnableTickmarks()){return;}return this.getAggregation('scale')||this.getAggregation('_defaultScale');};
g.prototype._syncScaleUsage=function(){var h=this.getEnableTickmarks(),u=this.getAggregation('scale'),D=this.getAggregation("_defaultScale");if((D&&!h)||(u&&D)){this.destroyAggregation("_defaultScale",true);}if(h&&!u&&!D){this.setAggregation("_defaultScale",new f(),true);}};
g.prototype._showTooltipsIfNeeded=function(){if(this.getShowAdvancedTooltip()){this.getAggregation("_tooltipContainer").show(this);this.updateAdvancedTooltipDom(this.getValue());}};
g.prototype._convertValueToRtlMode=function(v){return this.getMax()-v+this.getMin();};
g.prototype._recalculateStyles=function(){var s=this.$();this._fSliderWidth=s.width();this._fSliderPaddingLeft=parseFloat(s.css("padding-left"));this._fSliderOffsetLeft=s.offset().left;this._fHandleWidth=this.$("handle").width();};
g.prototype._validateProperties=function(){var m=this.getMin(),M=this.getMax(),s=this.getStep(),h=false,i=false;if(m>=M){h=true;i=true;l.warning("Warning: "+"Property wrong min: "+m+" >= max: "+M+" on ",this);}if(s<=0){l.warning("Warning: "+"The step could not be negative on ",this);}if(s>(M-m)&&!h){i=true;l.warning("Warning: "+"Property wrong step: "+s+" > max: "+M+" - "+"min: "+m+" on ",this);}return i;};
g.prototype._getPercentOfValue=function(v){return d.getPercentOfValue(v,this.getMin(),this.getMax());};
g.prototype._getValueOfPercent=function(p){var m=this.getMin(),v=(p*(this.getMax()-m)/100)+m,n=this.toFixed(v,this.getDecimalPrecisionOfNumber(this.getStep()));return Number(n);};
g.prototype._validateStep=function(s){if(typeof s==="undefined"){return 1;}if(typeof s!=="number"){l.warning('Warning: "iStep" needs to be a number',this);return 0;}if((Math.floor(s)===s)&&isFinite(s)){return s;}l.warning('Warning: "iStep" needs to be a finite interger',this);return 0;};
g.prototype._handleSliderResize=function(o){var s=this._getUsedScale();if(this.getEnableTickmarks()&&s&&s.handleResize){s.handleResize(o);}if(this.getShowAdvancedTooltip()){this._handleTooltipContainerResponsiveness();}};
g.prototype._handleTooltipContainerResponsiveness=function(){this.getAggregation("_tooltipContainer").setWidth(this.$().width()+"px");};
g.prototype.getDecimalPrecisionOfNumber=function(v){if(Math.floor(v)===v){return 0;}var V=v.toString(),i=V.indexOf("."),h=V.indexOf("e-"),j=h!==-1,k=i!==-1;if(j){var m=+V.slice(h+2);if(k){return m+V.slice(i+1,h).length;}return m;}if(k){return V.length-i-1;}return 0;};
g.prototype.toFixed=function(n,D){if(D===undefined){D=this.getDecimalPrecisionOfNumber(n);}if(D>20){D=20;}else if(D<0){D=0;}return n.toFixed(D)+"";};
g.prototype.setDomValue=function(n){var D=this.getDomRef(),s=this._formatValueByCustomElement(n),T=this.getAggregation("_tooltipContainer");if(!D){return;}var p=Math.max(this._getPercentOfValue(+n),0)+"%",h=this.getDomRef("handle");if(this.getName()){this.getDomRef("input").setAttribute("value",s);}if(this.getProgress()){this.getDomRef("progress").style.width=p;}h.style[sap.ui.getCore().getConfiguration().getRTL()?"right":"left"]=p;if(this.getShowAdvancedTooltip()&&T.getDomRef()){this.updateAdvancedTooltipDom(n);}if(this.getShowHandleTooltip()&&!this.getShowAdvancedTooltip()){h.title=s;}this._updateHandleAriaAttributeValues(h,n,s);};
g.prototype._updateHandleAriaAttributeValues=function(h,v,s){if(this._isElementsFormatterNotNumerical(v)){h.setAttribute("aria-valuenow",v);h.setAttribute("aria-valuetext",s);}else{h.setAttribute("aria-valuenow",s);h.removeAttribute("aria-valuetext");}};
g.prototype._formatValueByCustomElement=function(v,p){var s=this._getUsedScale(),T=this.getUsedTooltips()[0],F=""+v;if(p==='slider'){return F;}if(this.getEnableTickmarks()&&s&&s.getLabel){F=""+s.getLabel(v,this);}if(p==='scale'){return F;}if(this.getShowAdvancedTooltip()&&T&&T.getLabel){F=""+T.getLabel(v,this);}return F;};
g.prototype._isElementsFormatterNotNumerical=function(v){var V=this._formatValueByCustomElement(v);return isNaN(V);};
g.prototype.updateAdvancedTooltipDom=function(n){var T=this.getUsedTooltips();this.updateTooltipsPositionAndState(T[0],parseFloat(n));};
g.prototype.getUsedTooltips=function(){var h=this.getCustomTooltips(),D=this.getAggregation("_defaultTooltips")||[];return h.length?h:D;};
g.prototype.updateTooltipsPositionAndState=function(T,v){var o=this.getAggregation("_tooltipContainer");T.setValue(v);o.repositionTooltips(this.getMin(),this.getMax());};
g.prototype.getClosestHandleDomRef=function(){return this.getDomRef("handle");};
g.prototype._increaseValueBy=function(i){var v,n;if(this.getEnabled()){v=this.getValue();this.setValue(v+(i||1));n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}};
g.prototype._decreaseValueBy=function(D){var v,n;if(this.getEnabled()){v=this.getValue();this.setValue(v-(D||1));n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}};
g.prototype._getLongStep=function(){var m=this.getMin(),M=this.getMax(),s=this.getStep(),L=(M-m)/10,i=(M-m)/s;return i>10?L:s;};
g.prototype._fireChangeAndLiveChange=function(p){this.fireChange(p);this.fireLiveChange(p);};
g.prototype.handleTooltipChange=function(o){var n=parseFloat(o.getParameter("value"));this.setValue(n);this._fireChangeAndLiveChange({value:n});};
g.prototype._registerResizeHandler=function(){if(!this._parentResizeHandler){this._parentResizeHandler=R.register(this,this._handleSliderResize.bind(this));}};
g.prototype._deregisterResizeHandler=function(){if(this._parentResizeHandler){R.deregister(this._parentResizeHandler);this._parentResizeHandler=null;}};
g.prototype.init=function(){var s;this._iActiveTouchId=-1;this._bSetValueFirstCall=true;this._fValueBeforeFocus=0;this._parentResizeHandler=null;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTooltipContainer=null;s=new I({text:this._oResourceBundle.getText("SLIDER_HANDLE")});this.addAggregation("_handlesLabels",s);};
g.prototype.exit=function(){if(this._oResourceBundle){this._oResourceBundle=null;}if(this.getAggregation("_defaultTooltips")){this.destroyAggregation("_defaultTooltips");}this._deregisterResizeHandler();};
g.prototype.onBeforeRendering=function(){var h=this._validateProperties();if(!h){this.setValue(this.getValue());this._sProgressValue=Math.max(this._getPercentOfValue(this.getValue()),0)+"%";}if(this.getShowAdvancedTooltip()){this.initAndSyncTooltips(["leftTooltip"]);}this._deregisterResizeHandler();this._syncScaleUsage();};
g.prototype.forwardProperties=function(p,o){p.forEach(function(P){o.setProperty(P,this.getProperty(P),true);},this);};
g.prototype.forwardPropertiesToDefaultTooltips=function(T){var D=this.getAggregation("_defaultTooltips")||[];for(var i=0;i<T;i++){this.forwardProperties(["min","max","step"],D[i]);D[i].setProperty("width",this._getMaxTooltipWidth()+"px",true);D[i].setProperty("editable",this.getInputsAsTooltips(),true);}};
g.prototype.associateCustomTooltips=function(T){this.destroyAggregation("_defaultTooltips",true);this._oTooltipContainer.removeAllAssociation("associatedTooltips",true);for(var i=0;i<T;i++){this._oTooltipContainer.addAssociation("associatedTooltips",this.getCustomTooltips()[i],true);}};
g.prototype.assignDefaultTooltips=function(T){var D=this.getAggregation("_defaultTooltips")||[];if(D.length===0){this._oTooltipContainer.removeAllAssociation("associatedTooltips",true);T.forEach(function(i){this.initDefaultTooltip(i);},this);}this.forwardProperties(["enabled"],this._oTooltipContainer);this.forwardPropertiesToDefaultTooltips(T.length);};
g.prototype.initAndSyncTooltips=function(T){var h=this.getCustomTooltips(),i=h.length,m=T.length;this.initTooltipContainer();if(i<m){this.assignDefaultTooltips(T);}else{if(i>m){l.warning("Warning: More than "+m+" Custom Tooltips are provided. Only the first will be used.");}this.associateCustomTooltips(m);}};
g.prototype.initDefaultTooltip=function(i){var T=new b(this.getId()+"-"+i,{change:this.handleTooltipChange.bind(this)});this.getAggregation("_tooltipContainer").addAssociation("associatedTooltips",T,true);this.addAggregation("_defaultTooltips",T,true);};
g.prototype.initTooltipContainer=function(){if(!this._oTooltipContainer){this._oTooltipContainer=new S();this.setAggregation("_tooltipContainer",this._oTooltipContainer,true);}};
g.prototype._getMaxTooltipWidth=function(){var A=[Math.abs(this.getMin()),Math.abs(this.getMax())],r=A[0]>A[1]?0:1;return((A[r].toString()).length+this.getDecimalPrecisionOfNumber(this.getStep())+1)*d.CONSTANTS.CHARACTER_WIDTH_PX;};
g.prototype.onAfterRendering=function(){if(this.getShowAdvancedTooltip()){this._recalculateStyles();this._handleTooltipContainerResponsiveness();}this._handleSliderResize({control:this});this._registerResizeHandler();};
g.prototype.ontouchstart=function(o){var m=this.getMin(),T=o.targetTouches[0],n,h=this.getRenderer().CSS_CLASS,s="."+h;o.setMarked();if(o.target.className.indexOf("sapMInput")===-1){o.preventDefault();}this.focus();if(t.countContained(o.touches,this.getId())>1||!this.getEnabled()||o.button||(o.srcControl!==this)){return;}this._iActiveTouchId=T.identifier;q(document).on("touchend"+s+" touchcancel"+s+" mouseup"+s,this._ontouchend.bind(this)).on(o.originalEvent.type==="touchstart"?"touchmove"+s:"touchmove"+s+" mousemove"+s,this._ontouchmove.bind(this));var N=this.getClosestHandleDomRef();if(T.target!==N){setTimeout(N["focus"].bind(N),0);}this._recalculateStyles();this._fDiffX=this._fSliderPaddingLeft;this._fInitialValue=this.getValue();this.$("inner").addClass(h+"Pressed");if(T.target===this.getDomRef("handle")){this._fDiffX=(T.pageX-q(N).offset().left)+this._fSliderPaddingLeft-(this._fHandleWidth/2);}else{n=(((T.pageX-this._fSliderPaddingLeft-this._fSliderOffsetLeft)/this._fSliderWidth)*(this.getMax()-m))+m;if(sap.ui.getCore().getConfiguration().getRTL()){n=this._convertValueToRtlMode(n);}this.setValue(n);n=this.getValue();if(this._fInitialValue!==n){this.fireLiveChange({value:n});}}};
g.prototype._ontouchmove=function(o){o.setMarked();o.preventDefault();if(o.isMarked("delayedMouseEvent")||!this.getEnabled()||o.button){return;}var m=this.getMin(),v=this.getValue(),T=t.find(o.changedTouches,this._iActiveTouchId),p=T?T.pageX:o.pageX,n=(((p-this._fDiffX-this._fSliderOffsetLeft)/this._fSliderWidth)*(this.getMax()-m))+m;if(sap.ui.getCore().getConfiguration().getRTL()){n=this._convertValueToRtlMode(n);}this.setValue(n);n=this.getValue();if(v!==n){this.fireLiveChange({value:n});}};
g.prototype._ontouchend=function(o){var h=this.getRenderer().CSS_CLASS,s="."+h;o.setMarked();if(o.isMarked("delayedMouseEvent")||!this.getEnabled()||o.button){return;}q(document).off(s);var v=this.getValue();this.$("inner").removeClass(h+"Pressed");if(this._fInitialValue!==v){this.fireChange({value:v});}};
g.prototype.onfocusin=function(o){this._fValueBeforeFocus=this.getValue();if(this.getShowAdvancedTooltip()){this.getAggregation("_tooltipContainer").show(this);this._setAriaControls();this.updateAdvancedTooltipDom(this.getValue());}};
g.prototype._setAriaControls=function(){var T=this.getUsedTooltips()[0],h=this.getFocusDomRef();if(this.getInputsAsTooltips()&&T&&T.getDomRef()){h.setAttribute("aria-controls",T.getId());}};
g.prototype.onfocusout=function(o){if(!this.getShowAdvancedTooltip()){return;}var s=q.contains(this.getDomRef(),o.relatedTarget),T=q.contains(this.getAggregation("_tooltipContainer").getDomRef(),o.relatedTarget);if(s||T){return;}this.getAggregation("_tooltipContainer").hide();};
g.prototype.onmouseover=function(o){var T,h;if(this.getShowAdvancedTooltip()){this.getAggregation("_tooltipContainer").show(this);h=this.getAggregation("_tooltipContainer");T=q.contains(h.getDomRef(),document.activeElement);this._setAriaControls();if(T){return;}this.updateAdvancedTooltipDom(this.getValue());}};
g.prototype.onmouseout=function(o){if(!this.getShowAdvancedTooltip()){return;}var T=this.getAggregation("_tooltipContainer").getDomRef(),s=this.getDomRef(),h=q.contains(s,document.activeElement),i=q.contains(T,document.activeElement);if(!T||h||i){return;}if(q.contains(this.getDomRef(),o.toElement)||(s===o.toElement)){return;}if(q.contains(this.getAggregation("_tooltipContainer").getDomRef(),o.toElement)){return;}this.getAggregation("_tooltipContainer").hide();};
g.prototype.onkeydown=function(o){var T=this.getUsedTooltips();if(o.keyCode===d.CONSTANTS.F2_KEYCODE&&T[0]&&this.getInputsAsTooltips()){T[0].focus();}if(o.keyCode===K.SPACE){o.preventDefault();}};
g.prototype.onsapincrease=function(o){var v,n;o.preventDefault();o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepUp(1);n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapincreasemodifiers=function(o){if(o.altKey){return;}o.preventDefault();o.stopPropagation();o.setMarked();this._increaseValueBy(this._getLongStep());this._showTooltipsIfNeeded();};
g.prototype.onsapdecrease=function(o){var v,n;o.preventDefault();o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepDown(1);n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapdecreasemodifiers=function(o){if(o.altKey){return;}o.preventDefault();o.stopPropagation();o.setMarked();this._decreaseValueBy(this._getLongStep());this._showTooltipsIfNeeded();};
g.prototype.onsapplus=function(o){var v,n;o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepUp(1);n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapminus=function(o){var v,n;o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepDown(1);n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapescape=function(){this.setValue(this._fValueBeforeFocus);};
g.prototype.onsappageup=g.prototype.onsapincreasemodifiers;g.prototype.onsappagedown=g.prototype.onsapdecreasemodifiers;
g.prototype.onsaphome=function(o){o.setMarked();var m=this.getMin();o.preventDefault();if(this.getEnabled()&&this.getValue()>m){this.setValue(m);this._fireChangeAndLiveChange({value:m});}this._showTooltipsIfNeeded();};
g.prototype.onsapend=function(o){o.setMarked();var m=this.getMax();o.preventDefault();if(this.getEnabled()&&this.getValue()<m){this.setValue(m);this._fireChangeAndLiveChange({value:m});}this._showTooltipsIfNeeded();};
g.prototype.getFocusDomRef=function(){return this.getDomRef("handle");};
g.prototype.stepUp=function(s){return this.setValue(this.getValue()+(this._validateStep(s)*this.getStep()),{snapValue:false});};
g.prototype.stepDown=function(s){return this.setValue(this.getValue()-(this._validateStep(s)*this.getStep()),{snapValue:false});};
g.prototype.setValue=function(n,o){if(this._bSetValueFirstCall){this._bSetValueFirstCall=false;return this.setProperty("value",n,true);}var m=this.getMin(),M=this.getMax(),s=this.getStep(),v=this.getValue(),N,h=true,i;if(o){h=!!o.snapValue;}if(typeof n!=="number"||!isFinite(n)){return this;}i=Math.abs((n-m)%s);if(h&&(i!==0)){n=i*2>=s?n+s-i:n-i;}if(n<m){n=m;}else if(n>M){n=M;}N=this.toFixed(n,this.getDecimalPrecisionOfNumber(s));n=Number(N);this.setProperty("value",n,true);if(v!==this.getValue()){this.setDomValue(N);}return this;};
return g;});
sap.ui.predefine('sap/m/SliderRenderer',['./SliderUtilities',"sap/ui/core/InvisibleText"],function(S,I){"use strict";var a={apiVersion:2};a.CSS_CLASS="sapMSlider";
a.render=function(r,s){var e=s.getEnabled(),t=s.getTooltip_AsString(),C=a.CSS_CLASS,b=s.getAriaLabelledBy().reduce(function(A,i){return A+" "+i;},"");r.openStart("div",s);this.addClass(r,s);if(!e){r.class(C+"Disabled");}r.style("width",s.getWidth());if(t&&s.getShowHandleTooltip()){r.attr("title",s._formatValueByCustomElement(t));}r.openEnd();r.openStart('div',s.getId()+"-inner");this.addInnerClass(r,s);if(!e){r.class(C+"InnerDisabled");}r.openEnd();if(s.getProgress()){this.renderProgressIndicator(r,s,b);}this.renderHandles(r,s,b);r.close("div");if(s.getEnableTickmarks()){this.renderTickmarks(r,s);}this.renderLabels(r,s);if(s.getName()){this.renderInput(r,s);}r.close("div");};
a.renderProgressIndicator=function(r,s){r.openStart("div",s.getId()+"-progress");this.addProgressIndicatorClass(r,s);r.style("width",s._sProgressValue);r.attr("aria-hidden","true");r.openEnd().close("div");};
a.renderHandles=function(r,s,f){this.renderHandle(r,s,{id:s.getId()+"-handle",forwardedLabels:f});};
a.renderHandle=function(r,s,o){var e=s.getEnabled();r.openStart("span",o&&o.id);if(s.getShowHandleTooltip()&&!s.getShowAdvancedTooltip()){this.writeHandleTooltip(r,s);}if(s.getInputsAsTooltips()){r.attr("aria-describedby",I.getStaticId("sap.m","SLIDER_INPUT_TOOLTIP"));e&&r.attr("aria-keyshortcuts","F2");}this.addHandleClass(r,s);r.style(sap.ui.getCore().getConfiguration().getRTL()?"right":"left",s._sProgressValue);this.writeAccessibilityState(r,s,o);if(e){r.attr("tabindex","0");}r.openEnd().close("span");};
a.writeHandleTooltip=function(r,s){r.attr("title",s._formatValueByCustomElement(s.toFixed(s.getValue())));};
a.renderInput=function(r,s){r.voidStart("input",s.getId()+"-input").attr("type","text");r.class(a.CSS_CLASS+"Input");if(!s.getEnabled()){r.attr("disabled");}r.attr("name",s.getName());r.attr("value",s._formatValueByCustomElement(s.toFixed(s.getValue())));r.voidEnd();};
a.writeAccessibilityState=function(r,s,o){var f=s.getValue(),n=s._isElementsFormatterNotNumerical(f),b=s._formatValueByCustomElement(f),v;if(s._getUsedScale()&&!n){v=b;}else{v=s.toFixed(f);}r.accessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuenow:v,labelledby:{value:(o.forwardedLabels+" "+s.getAggregation("_handlesLabels")[0].getId()).trim()}});if(n){r.accessibilityState(s,{valuetext:b});}};
a.renderTickmarks=function(r,s){var i,t,T,l,f,b,c,o=s._getUsedScale();if(!s.getEnableTickmarks()||!o){return;}b=Math.abs(s.getMin()-s.getMax());c=s.getStep();l=o.getTickmarksBetweenLabels();t=o.calcNumberOfTickmarks(b,c,S.CONSTANTS.TICKMARKS.MAX_POSSIBLE);T=s._getPercentOfValue(this._calcTickmarksDistance(t,s.getMin(),s.getMax(),c));r.openStart("ul").class(a.CSS_CLASS+"Tickmarks").openEnd();this.renderTickmarksLabel(r,s,s.getMin());r.openStart("li").class(a.CSS_CLASS+"Tick").style("width",T+"%").openEnd().close("li");for(i=1;i<t-1;i++){if(l&&(i%l===0)){f=i*T;this.renderTickmarksLabel(r,s,s._getValueOfPercent(f));}r.openStart("li").class(a.CSS_CLASS+"Tick").style("width",T+"%").openEnd().close("li");}this.renderTickmarksLabel(r,s,s.getMax());r.openStart("li").class(a.CSS_CLASS+"Tick").style("width","0").openEnd().close("li");r.close("ul");};
a.renderTickmarksLabel=function(r,s,v){var o=s._getPercentOfValue(v);var l=sap.ui.getCore().getConfiguration().getRTL()?"right":"left";var V;v=s.toFixed(v,s.getDecimalPrecisionOfNumber(s.getStep()));V=s._formatValueByCustomElement(v,'scale');r.openStart("li").class(a.CSS_CLASS+"TickLabel").style(l,(o+"%")).openEnd();r.openStart("div").class(a.CSS_CLASS+"Label").openEnd().text(V).close("div");r.close("li");};
a._calcTickmarksDistance=function(t,s,e,f){var b=Math.abs(s-e),m=Math.floor(b/f),i=Math.ceil(m/t);return s+(i*f);};
a.addClass=function(r,s){r.class(a.CSS_CLASS);};
a.addInnerClass=function(r,s){r.class(a.CSS_CLASS+"Inner");};
a.addProgressIndicatorClass=function(r,s){r.class(a.CSS_CLASS+"Progress");};
a.addHandleClass=function(r,s){r.class(a.CSS_CLASS+"Handle");};
a.renderLabels=function(r,s){s.getAggregation("_handlesLabels").forEach(r.renderControl,r);};
return a;},true);
sap.ui.predefine('sap/m/SliderTooltip',['./library','./SliderUtilities','./SliderTooltipBase','sap/ui/core/Control','sap/ui/core/library','sap/ui/core/Core','./delegate/ValueStateMessage','sap/ui/core/ValueStateSupport',"sap/ui/core/InvisibleMessage",'./SliderTooltipRenderer'],function(L,S,a,C,c,b,V,d,I,e){"use strict";var f=c.ValueState;var g=c.InvisibleMessageMode;
var h=a.extend("sap.m.SliderTooltip",{metadata:{library:"sap.m",properties:{value:{type:"float",group:"Data",defaultValue:0,bindable:"bindable"},min:{type:"float",group:"Data",defaultValue:0},max:{type:"float",group:"Data",defaultValue:100},editable:{type:"boolean",defaultValue:false},step:{type:"float",group:"Data",defaultValue:1},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:f.None},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"float"}}}}}});
h.prototype.init=function(){this._oValueStateMessage=new V(this);this._fLastValidValue=0;};
h.prototype.exit=function(){if(this.oInvisibleMessage){this.oInvisibleMessage.destroy();this.oInvisibleMessage=null;}};
h.prototype.onBeforeRendering=function(){a.prototype.setValue.call(this,this.getValue());if(!this.oInvisibleMessage){this.oInvisibleMessage=I.getInstance();}};
h.prototype.onAfterRendering=function(){var A=!this.getEditable()?"add":"remove";if(this.getDomRef()){this.getFocusDomRef().classList[A](S.CONSTANTS.TOOLTIP_CLASS+"NotEditable");}};
h.prototype.getValueStateText=function(){return"";};
h.prototype.getFocusDomRef=function(){return this.getDomRef("input");};
h.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef();};
h.prototype.sliderValueChanged=function(v){if(this.getDomRef()){this.getFocusDomRef().value=v;}this._fLastValidValue=v;this.setValueState(f.None);};
h.prototype.setValueState=function(v){var D=this.getDomRef(),i=this.getFocusDomRef(),E,o;v=this.validateProperty("valueState",v);E=D&&(v===f.Error);o=D&&E;this.setProperty("valueState",v,true);this._oValueStateMessage[o?"open":"close"]();if(i){D.classList[E?"add":"remove"](S.CONSTANTS.TOOLTIP_CLASS+"ErrorState");i[E?"setAttribute":"removeAttribute"]("aria-invalid",E);i[o?"setAttribute":"removeAttribute"]("aria-errormessage",this.getId()+"-message");this._invisibleMessageAnnouncement(v);}return this;};
h.prototype._invisibleMessageAnnouncement=function(v,o){if(v!==f.Error){return;}var r=b.getLibraryResourceBundle("sap.m"),s,i;s=r.getText("INPUTBASE_VALUE_STATE_"+v.toUpperCase());i=s+" "+d.getAdditionalText(this);this.oInvisibleMessage.announce(i,g.Assertive);this._bInvisibleMessageUpdated=true;};
h.prototype.onfocusout=function(E){var v=parseFloat(this.getFocusDomRef().value);this._validateValue(v);if(this._bInvisibleMessageUpdated){document.getElementById(this.oInvisibleMessage.getId()+"-assertive").textContent="";this._bInvisibleMessageUpdated=false;}};
h.prototype.onsapenter=function(E){var v=parseFloat(this.getFocusDomRef().value);this._validateValue(v);};
h.prototype.onsapescape=function(E){this.sliderValueChanged(this._fLastValidValue);this.setValueState(f.None);};
h.prototype._validateValue=function(v){if(this._isValueValid(v)){this.sliderValueChanged(v);this.fireChange({value:v});}else{this.setValueState(f.Error);}};
h.prototype._isValueValid=function(v){return!(isNaN(v)||v<this.getMin()||v>this.getMax());};
return h;});
sap.ui.predefine('sap/m/SliderTooltipBase',['sap/ui/core/Control','./library','./SliderTooltipBaseRenderer'],function(C,L,S){"use strict";
var a=C.extend("sap.m.SliderTooltipBase",{metadata:{library:"sap.m"}});
a.prototype.init=function(){this.fValue=0;};
a.prototype.setValue=function(v){this.fValue=v;this.sliderValueChanged(v);};
a.prototype.getValue=function(){return this.fValue;};
a.prototype.sliderValueChanged=function(v){};
return a;});
sap.ui.predefine('sap/m/SliderTooltipBaseRenderer',['sap/ui/core/Renderer'],function(R){"use strict";var S={apiVersion:2};S.CSS_CLASS="sapMSliderTooltip";
S.render=function(r,c){r.openStart("div",c).openEnd();this.renderTooltipContent(r,c);r.close("div");};
S.renderTooltipContent=function(r,c){};
return S;},true);
sap.ui.predefine('sap/m/SliderTooltipContainer',['./library','./SliderUtilities','sap/ui/core/Control','sap/ui/core/Popup','./SliderTooltipContainerRenderer',"sap/ui/thirdparty/jquery"],function(L,S,C,P,a,q){"use strict";
var b=C.extend("sap.m.SliderTooltipContainer",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"0px"}},associations:{associatedTooltips:{type:"sap.m.SliderTooltipBase",multiple:true}}}});
b.prototype.init=function(){this.oPopup=new P();this.oPopup.setShadow(false);this.oPopup.setAutoClose(false);this._scrollListener=this._getScrollListener();this._bClosedFromOverflow=false;this._bRtl=sap.ui.getCore().getConfiguration().getRTL();};
b.prototype._handleTabNavigation=function(e){var p=this._oParentSlider instanceof sap.m.RangeSlider;e.preventDefault();this[p?"_handleRangeSliderF2":"_handleSliderF2"].apply(this,arguments);};
b.prototype._handleSliderF2=function(){this._oParentSlider.focus();};
b.prototype._handleRangeSliderF2=function(e){var h=this._oParentSlider._getHandleForTooltip(e.srcControl);q(h).trigger("focus");};
b.prototype.onsaptabnext=b.prototype._handleTabNavigation;b.prototype.onsaptabprevious=b.prototype._handleTabNavigation;
b.prototype.onkeydown=function(e){if(e.keyCode===S.CONSTANTS.F2_KEYCODE){this._handleTabNavigation(e);}};
b.prototype.show=function(c){this.oPopup.setContent(this);this._$ParentSlider=c.$();this._oParentSlider=c;this.oPopup.open(0,P.Dock.BeginTop,P.Dock.BeginTop,this._$ParentSlider,'0 -24','flip');document.addEventListener("scroll",this._scrollListener,true);};
b.prototype._getScrollListener=function(){return function(){clearTimeout(this._scrollDebounce);this._scrollDebounce=setTimeout(this.repositionTooltips.bind(this),0);}.bind(this);};
b.prototype.hide=function(){this.oPopup.close();document.removeEventListener("scroll",this._scrollListener,true);};
b.prototype.repositionTooltips=function(){var p=this._oParentSlider instanceof sap.m.RangeSlider,t=this._oParentSlider.getUsedTooltips(),T=this.getAssociatedTooltipsAsControls()[0].$().outerHeight(true);if(this.getDomRef()){this[p?"_positionRangeTooltips":"_positionTooltip"].call(this,t,arguments[0],arguments[1]);this.getDomRef().style["top"]=(this._$ParentSlider.offset().top-T)+"px";this._handleOverflow();}};
b.prototype._positionTooltip=function(t,m,M){var T=this._getTooltipPosition(t[0].getValue(),m,M),A=this._bRtl?"right":"left";if(T){this.getDomRef().children[0].style[A]=T;}};
b.prototype._handleOverflow=function(){var p=this.getDomRef(),s,c;if(p){s=S.getElementScrollableParent(this._$ParentSlider[0].parentNode);c=S.isScrolledIntoView(this._$ParentSlider[0],s);if(!c){this._bClosedFromOverflow=true;this.hide();}}};
b.prototype._positionRangeTooltips=function(t,m,M){var r=this._bRtl,A=r?"right":"left",s=r?"left":"right",R=this._oParentSlider.getRange(),f=S.getPercentOfValue(R[0]>R[1]?R[1]:R[0],m,M),e=S.getPercentOfValue(R[0]>R[1]?R[0]:R[1],m,M),T=this.getAssociatedTooltipsAsControls()[0].$().outerWidth(),i=S.getPercentOfValue(+(t[0].getValue()),m,M),E=S.getPercentOfValue(+(t[1].getValue()),m,M),p=this._oParentSlider.$("progress"),c=this.$("container"),d=this._$ParentSlider.width(),o=false,g=T-S.CONSTANTS.TOOLTIP_SIDE_PADDING,h=(((g+S.CONSTANTS.CHARACTER_WIDTH_PX)/2)/d)*100,j=f-(h)-(h*2-(e-f))/2,k={"min-width":(2*T)+(S.CONSTANTS.TOOLTIP_BORDER*2)+"px"},l;k[A]="calc("+i+"%"+" - "+((T/2)-S.CONSTANTS.HANDLE_HALF_WIDTH)+"px)";k[s]="calc("+(100-E)+"% "+"- "+(T-((T/2)-S.CONSTANTS.HANDLE_HALF_WIDTH-S.CONSTANTS.TOOLTIP_BORDER))+"px)";if(p.outerWidth()<=(T/2)+(T-S.CONSTANTS.HANDLE_HALF_WIDTH)){k[A]="calc("+j+"%"+" + "+S.CONSTANTS.HANDLE_HALF_WIDTH+"px)";o=true;}c.css(k);l=this._$ParentSlider.offset();if((c.offset().left+c.outerWidth())>(l.left+this._$ParentSlider.outerWidth())){k=this[r?"_getStickedToStart":"_getStickedToEnd"].call(this,k,A,s,o);}if((c.offset().left<=l.left)){k=this[r?"_getStickedToEnd":"_getStickedToStart"].call(this,k,A,s,o);}c.css(k);};
b.prototype._getStickedToStart=function(c,A){c[A]="0";return c;};
b.prototype._getStickedToEnd=function(c,A,s,o){var t=this.getAssociatedTooltipsAsControls()[0].$().outerWidth();c[s]="calc(0% - "+(2*S.CONSTANTS.HANDLE_HALF_WIDTH)+"px)";if(o){c[A]="calc(100% - "+(t+(t-2*S.CONSTANTS.HANDLE_HALF_WIDTH))+"px)";}return c;};
b.prototype._getTooltipPosition=function(t,m,M){var p=S.getPercentOfValue(+(t),m,M),T=this.getAssociatedTooltipsAsControls()[0].$().outerWidth(),s=this._$ParentSlider.outerWidth(),f=(100*S.CONSTANTS.SLIDER_SIDE_PADDING)/s,c=((100*T)/s);if(p+f<(c/2)){return"0";}else if(p-f>100-(c/2)){return"calc(100% - "+(T-(S.CONSTANTS.HANDLE_HALF_WIDTH*2))+"px)";}else{return"calc("+p+"% - "+((T/2)-S.CONSTANTS.HANDLE_HALF_WIDTH)+"px)";}};
b.prototype.setWidth=function(w){if(this.getDomRef()){this.$().width(w);}return this.setProperty("width",w,true);};
b.prototype.getAssociatedTooltipsAsControls=function(){var A=this.getAssociation("associatedTooltips")||[];return A.map(function(t){return sap.ui.getCore().byId(t);});};
b.prototype.onmouseout=function(e){var s=q.contains(this._oParentSlider.getDomRef(),document.activeElement),c=q.contains(this.getDomRef(),document.activeElement),t=q.contains(this._oParentSlider.getDomRef(),e.toElement),T=q.contains(this.getDomRef(),e.toElement);if(s||c||t||T){return;}this.hide();};
b.prototype.onfocusout=function(e){if(q.contains(this._$ParentSlider[0],e.relatedTarget)||q.contains(this.getDomRef(),e.relatedTarget)){return;}if(this._bClosedFromOverflow){this._oParentSlider.focus();this._bClosedFromOverflow=false;}this.hide();};
b.prototype.onBeforeRendering=function(){this._bRtl=sap.ui.getCore().getConfiguration().getRTL();};
b.prototype.exit=function(){this._oParentSlider=null;this._$ParentSlider=null;document.removeEventListener("scroll",this._scrollListener,true);};
return b;});
sap.ui.predefine('sap/m/SliderTooltipContainerRenderer',['sap/ui/core/Renderer'],function(R){"use strict";var S={apiVersion:2},C={MAIN_CLASS:"sapMSliderTooltipContainer"};
S.render=function(r,c){var t=c.getAssociatedTooltipsAsControls();r.openStart("div",c).style("width",c.getWidth()).openEnd();r.openStart("div",c.getId()+"-container").style("left","0%").style("right","0%").class(C.MAIN_CLASS);if(!c.getEnabled()){r.class(C.MAIN_CLASS+"Disabled");}r.openEnd();if(t&&t.length){t.forEach(function(T){r.renderControl(T);});}r.close("div").close("div");};
return S;},true);
sap.ui.predefine('sap/m/SliderTooltipRenderer',['sap/ui/core/Renderer',"sap/ui/core/Core"],function(R,C){"use strict";var S={apiVersion:2};S.CSS_CLASS="sapMSliderTooltip";
S.render=function(r,c){r.openStart("div",c).class(S.CSS_CLASS);if(!c.getEditable()){r.class(S.CSS_CLASS+"NonEditableWrapper");}if(c.getWidth()){r.style("width",c.getWidth());}r.openEnd();this.renderTooltipElement(r,c);r.close("div");};
S.renderTooltipElement=function(r,c){var o=C.getLibraryResourceBundle("sap.m");r.voidStart("input",c.getId()+"-input").class(S.CSS_CLASS+"Input");if(!c.getEditable()){r.class(S.CSS_CLASS+"NonEditable");}r.attr("aria-label",o.getText("SLIDER_INPUT_LABEL"));r.accessibilityState(c).attr("tabindex","-1").attr("value",c.getValue()).attr("type","number").attr("step",c.getStep()).voidEnd();};
return S;},true);
sap.ui.predefine('sap/m/SliderUtilities',function(){"use strict";var S={};S.CONSTANTS={CHARACTER_WIDTH_PX:8,F2_KEYCODE:113,RANGE_MOVEMENT_THRESHOLD:32,HANDLE_CLASS:"sapMSliderHandle",RANGE_SLIDER_NAME:"sap.m.RangeSlider",TOOLTIP_CLASS:"sapMSliderTooltip",SLIDER_SIDE_PADDING:17,TOOLTIP_SIDE_PADDING:8,HANDLE_HALF_WIDTH:16,TOOLTIP_BORDER:1,FOLLOW_OF_TOLERANCE:24,TICKMARKS:{MAX_POSSIBLE:101,MIN_SIZE:{SMALL:8,WITH_LABEL:80}}};
S.getPercentOfValue=function(v,m,M){return((v-m)/(M-m))*100;};
S.getElementScrollableParent=function(d){if(!d){return document.body;}if(d.scrollHeight>=d.clientHeight){return d;}return this.getElementScrollableParent(d.parentNode);};
S.isScrolledIntoView=function(e,c){if(!(e||e.getBoundingClientRect)||!(c||c.getBoundingClientRect)){return false;}var C=c.getBoundingClientRect(),o=C.top,E=e.getBoundingClientRect().top,b=(o-this.CONSTANTS.FOLLOW_OF_TOLERANCE)>E,a=(o+C.height-this.CONSTANTS.FOLLOW_OF_TOLERANCE)<E;if(b||a){return false;}return true;};
return S;});
sap.ui.predefine('sap/m/SplitApp',['./SplitContainer','./library','sap/ui/Device','./SplitAppRenderer',"sap/ui/util/Mobile","sap/ui/thirdparty/jquery"],function(S,l,D,a,M,q){"use strict";
var b=S.extend("sap.m.SplitApp",{metadata:{library:"sap.m",properties:{homeIcon:{type:"any",group:"Misc",defaultValue:null}},events:{orientationChange:{deprecated:true,parameters:{landscape:{type:"boolean"}}}},designtime:"sap/m/designtime/SplitApp.designtime"}});
b.prototype.init=function(){if(S.prototype.init){S.prototype.init.apply(this,arguments);}this.addStyleClass("sapMSplitApp");M.init({viewport:!this._debugZoomAndScroll,statusBar:"default",hideBrowser:true,preventScroll:!this._debugZoomAndScroll,rootId:this.getId()});};
b.prototype.onBeforeRendering=function(){if(S.prototype.onBeforeRendering){S.prototype.onBeforeRendering.apply(this,arguments);}M.init({homeIcon:this.getHomeIcon()});};
b.prototype.onAfterRendering=function(){if(S.prototype.onAfterRendering){S.prototype.onAfterRendering.apply(this,arguments);}var r=this.getDomRef().parentNode;while(r&&r!==document.documentElement){var $=q(r);if($.attr("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}};
b.prototype._onOrientationChange=function(){this.fireOrientationChange({landscape:D.orientation.landscape});};
return b;});
sap.ui.predefine('sap/m/SplitAppRenderer',['./SplitContainerRenderer','sap/ui/core/Renderer','sap/m/library'],function(S,R,l){"use strict";var B=l.BackgroundHelper;var a=R.extend(S);a.apiVersion=2;
a.renderAttributes=function(r,c){B.addBackgroundColorStyles(r,c.getBackgroundColor(),c.getBackgroundImage());};
a.renderBeforeContent=function(r,c){B.renderBackgroundImageTag(r,c,"sapMSplitContainerBG",c.getBackgroundImage(),c.getBackgroundRepeat(),c.getBackgroundOpacity());};
return a;},true);
sap.ui.predefine('sap/m/SplitButton',['./library','sap/ui/core/Control','./Button','./ButtonRenderer','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/core/InvisibleText','./SplitButtonRenderer',"sap/ui/events/KeyCodes"],function(l,C,B,a,E,I,c,b,S,K){"use strict";var T=c.TextDirection;var d=l.ButtonType;
var e=C.extend("sap.m.SplitButton",{metadata:{interfaces:["sap.m.IOverflowToolbarContent"],library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:d.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},aggregations:{_textButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_arrowButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{},arrowPress:{}}}});
E.call(e.prototype);
e.prototype.onAfterRendering=function(){var $=this._getTextButton().$(),f=this._getArrowButton().$();$.attr("tabindex","-1");f.attr("tabindex","-1");$.removeAttr("title");f.removeAttr("title");$.removeAttr("aria-describedby");f.removeAttr("aria-describedby");};
e.prototype._handleAction=function(i){if(i){this.fireArrowPress();}else{this.firePress();}};
e.prototype.setArrowState=function(i){var A=this.getAggregation("_arrowButton");if(!A){return;}if(i){A.$().addClass('sapMSBActive');}else{A.$().removeClass('sapMSBActive');}};
e.prototype._getTextButton=function(){var o=this.getAggregation("_textButton");if(!o){o=new B({width:'100%',icon:this.getIcon(),text:this.getText(),press:this._handleAction.bind(this,false)}).addStyleClass('sapMSBText');this.setAggregation("_textButton",o);}return o;};
e.prototype._getArrowButton=function(){var o=this.getAggregation("_arrowButton");if(!o){o=new B({icon:"sap-icon://slim-arrow-down",press:this._handleAction.bind(this,true),tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SPLIT_BUTTON_ARROW_TOOLTIP"),ariaHasPopup:c.aria.HasPopup.Menu}).addStyleClass("sapMSBArrow");this.setAggregation("_arrowButton",o);}return o;};
e.prototype.setProperty=function(p,v,s){if(p==="type"&&(v===d.Up||v===d.Back||v===d.Unstyled)){return this;}var r=C.prototype.setProperty.apply(this,arguments);if(p==="activeIcon"||p==="iconDensityAware"||p==="textDirection"){B.prototype.setProperty.apply(this._getTextButton(),arguments);}else if(p==="text"||p==="type"||p==="icon"){var f="set"+_(p);B.prototype[f].call(this._getTextButton(),v);if(p==="type"){B.prototype[f].call(this._getArrowButton(),v);}}return r;};
function _(t){return t.charAt(0).toUpperCase()+t.slice(1);}
e.prototype.onkeydown=function(o){if(o.which===K.SPACE){o.preventDefault();}this._getTextButton().onkeydown(o);};
e.prototype.onkeyup=function(o){this._getTextButton().onkeyup(o);};
e.prototype.onsapup=function(o){this._getArrowButton().firePress();};
e.prototype.onsapdown=function(o){this._getArrowButton().firePress();};
e.prototype.onsapupmodifiers=function(o){this._getArrowButton().firePress();};
e.prototype.onsapdownmodifiers=function(o){this._getArrowButton().firePress();};
e.prototype.onsapshow=function(o){this._getArrowButton().firePress();o.preventDefault();};
e.prototype.getButtonTypeAriaLabelId=function(){var s=this._getTextButton().getType();return a.getButtonTypeAriaLabelId(s);};
e.prototype.getTitleAttributeValue=function(){var t=this.getTooltip_AsString(),i=I.getIconInfo(this.getIcon()),r;if(t||(i&&i.text&&!this.getText())){r=t||i.text;}return r;};
e.prototype.getOverflowToolbarConfig=function(){var o={canOverflow:true,propsUnrelatedToSize:["enabled","type","icon","activeIcon"],autoCloseEvents:["press"]};return o;};
return e;});
sap.ui.predefine('sap/m/SplitButtonRenderer',["sap/m/library","sap/ui/core/InvisibleText","sap/ui/core/ShortcutHintsMixin"],function(l,I,S){"use strict";var B=l.ButtonType;var a={apiVersion:2};a.CSS_CLASS="sapMSB";
a.render=function(r,b){var w=b.getWidth(),t=b.getType(),e=b.getEnabled(),T=b.getTitleAttributeValue(),s;r.openStart("div",b).class(a.CSS_CLASS);if(b.getIcon()){r.class(a.CSS_CLASS+"HasIcon");}if(t===B.Accept||t===B.Reject||t===B.Emphasized||t===B.Transparent||t===B.Attention||t===B.Neutral||t===B.Critical||t===B.Success||t===B.Negative){r.class(a.CSS_CLASS+t);}this.writeAriaAttributes(r,b);r.attr("tabindex",e?"0":"-1");if(T&&!S.isDOMIDRegistered(b.getId())){r.attr("title",T);}if(w!=""||w.toLowerCase()==="auto"){r.style("width",w);}r.openEnd();r.openStart("div").class("sapMSBInner");if(!e){r.class("sapMSBInnerDisabled");}r.openEnd();r.renderControl(b._getTextButton());r.renderControl(b._getArrowButton());r.close("div");if(T){s=b.getId()+"-tooltip";r.openStart("span",s);r.class("sapUiInvisibleText");r.openEnd();r.text(T);r.close("span");}r.close("div");};
a.writeAriaAttributes=function(r,b){var A={};this.writeAriaRole(b,A);this.writeAriaLabelledBy(b,A);r.accessibilityState(b,A);};
a.writeAriaRole=function(b,A){A["role"]="group";};
a.writeAriaLabelledBy=function(b,A){var s="",o=b.getButtonTypeAriaLabelId(),t=b.getTitleAttributeValue(),T;if(b.getText()){s+=b._getTextButton().getId()+"-content";s+=" ";}if(o){s+=o;s+=" ";}if(t){T=b.getId()+"-tooltip";s+=T+" ";}s+=I.getStaticId("sap.m","SPLIT_BUTTON_DESCRIPTION")+" ";s+=I.getStaticId("sap.m","SPLIT_BUTTON_KEYBOARD_HINT");A["labelledby"]={value:s,append:true};};
return a;},true);
sap.ui.predefine('sap/m/SplitContainer',['./library','sap/ui/base/DataType','sap/ui/core/Control','sap/ui/core/IconPool','sap/m/semantic/SemanticPage','sap/ui/core/InvisibleText','sap/ui/Device','sap/ui/base/ManagedObject','sap/m/NavContainer','sap/m/Popover','sap/m/Button','./SplitContainerRenderer',"sap/ui/dom/containsOrEquals","sap/base/Log","sap/ui/thirdparty/jquery"],function(l,D,C,I,S,a,b,M,N,P,B,c,d,L,q){"use strict";var e=l.ButtonType;var f=l.PlacementType;var g=l.SplitAppMode;
var h=C.extend("sap.m.SplitContainer",{metadata:{library:"sap.m",interfaces:["sap.ui.core.IPlaceholderSupport"],properties:{defaultTransitionNameDetail:{type:"string",group:"Appearance",defaultValue:"slide"},defaultTransitionNameMaster:{type:"string",group:"Appearance",defaultValue:"slide"},mode:{type:"sap.m.SplitAppMode",group:"Appearance",defaultValue:g.ShowHideMode},masterButtonText:{type:"string",group:"Appearance",defaultValue:null},masterButtonTooltip:{type:"string",group:"Appearance",defaultValue:null},backgroundColor:{type:"string",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1}},aggregations:{masterPages:{type:"sap.ui.core.Control",multiple:true,singularName:"masterPage"},detailPages:{type:"sap.ui.core.Control",multiple:true,singularName:"detailPage"},_navMaster:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"},_navDetail:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"},_navPopover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"}},associations:{initialDetail:{type:"sap.ui.core.Control",multiple:false},initialMaster:{type:"sap.ui.core.Control",multiple:false}},events:{masterNavigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterMasterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},masterButton:{},beforeMasterOpen:{},afterMasterOpen:{},beforeMasterClose:{},afterMasterClose:{},detailNavigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterDetailNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}}},designtime:"sap/m/designtime/SplitContainer.designtime"}});
h.prototype.init=function(){var t=this;if(sap.ui.getCore().getConfiguration().getAccessibility()&&!h._sAriaPopupLabelId){h._sAriaPopupLabelId=new a({text:''}).toStatic().getId();}this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._aMasterPages=[];this._aDetailPages=[];if(!b.system.phone){this._oMasterNav=new N(this.getId()+"-Master",{width:"",navigate:function(E){t._handleNavigationEvent(E,false,true);},afterNavigate:function(E){t._handleNavigationEvent(E,true,true);t._updateMasterButtonTooltip();}});this._oDetailNav=new N(this.getId()+"-Detail",{width:"",navigate:function(E){t._handleNavigationEvent(E,false,false);},afterNavigate:function(E){t._handleNavigationEvent(E,true,false);}});this.setAggregation("_navMaster",this._oMasterNav,true);this.setAggregation("_navDetail",this._oDetailNav,true);this._createShowMasterButton();this._oPopOver=new P(this.getId()+"-Popover",{placement:f.Bottom,showHeader:false,contentWidth:"320px",contentHeight:"600px",beforeOpen:function(){t.fireBeforeMasterOpen();},beforeClose:function(){t.fireBeforeMasterClose();},afterOpen:function(){t.fireAfterMasterOpen();t._bMasterisOpen=true;},afterClose:function(){t._afterHideMasterAnimation();}}).addStyleClass("sapMSplitContainerPopover");if(h._sAriaPopupLabelId){this._oPopOver.addAriaLabelledBy(h._sAriaPopupLabelId);}this.setAggregation("_navPopover",this._oPopOver,true);}else{this._oMasterNav=this._oDetailNav=new N({width:"",navigate:function(E){t._handleNavigationEvent(E,false,true);},afterNavigate:function(E){t._handleNavigationEvent(E,true,true);}});this.setAggregation("_navMaster",this._oMasterNav,true);}this._oldIsLandscape=b.orientation.landscape;this._bMasterisOpen=false;var t=this;var p=function(r,n,s){return function(o,A,j){r.apply(t[n],arguments);if(A==="pages"&&t[s]&&t[s].indexOf(o)!==-1){t._removePageFromArray(t[s],o);}};};var m=this._oMasterNav._removeChild;this._oMasterNav._removeChild=p(m,"_oMasterNav","_aMasterPages");if(this._oDetailNav){var i=this._oDetailNav._removeChild;this._oDetailNav._removeChild=p(i,"_oDetailNav","_aDetailPages");}if(b.support.touch){this._fnWindowScroll=this._onWindowScroll.bind(this);window.addEventListener('scroll',this._fnWindowScroll,true);}};
h.prototype.onBeforeRendering=function(){if(this._fnResize){b.resize.detachHandler(this._fnResize);}if(this._bMasterisOpen&&(this._portraitHide()||this._hideMode())){this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");this._bMasterisOpen=false;}this._oMasterNav.setInitialPage(sap.ui.getCore().byId(this.getInitialMaster()));this._oMasterNav.setDefaultTransitionName(this.getDefaultTransitionNameMaster());this._updateMasterButtonTooltip();if(!b.system.phone){this._oDetailNav.setInitialPage(sap.ui.getCore().byId(this.getInitialDetail()));this._updateMasterButtonText();}this._oDetailNav.setDefaultTransitionName(this.getDefaultTransitionNameDetail());};
h.prototype.exit=function(){if(this._fnResize){b.resize.detachHandler(this._fnResize);}delete this._aMasterPages;delete this._aDetailPages;if(this._oShowMasterBtn){this._oShowMasterBtn.destroy();this._oShowMasterBtn=null;}if(b.support.touch){window.removeEventListener('scroll',this._fnWindowScroll);}};
h.prototype.onAfterRendering=function(){if(!b.system.phone&&this._oPopOver&&this._oPopOver.isOpen()){this._oPopOver.close();}if(!this._fnResize){this._fnResize=q.proxy(this._handleResize,this);}b.resize.attachHandler(this._fnResize);setTimeout(function(){this._oMasterNav.removeStyleClass("sapMSplitContainerNoTransition");}.bind(this),0);};
h.prototype.applySettings=function(s,o){C.prototype.applySettings.call(this,s,o);this._updateMasterInitialPage();};
h.prototype.ontouchstart=function(E){if(!b.system.phone){this._bIgnoreSwipe=(E.originalEvent&&E.originalEvent._sapui_handledByControl);}};
h.prototype.ontouchend=function(E){if(!this._bIgnoreSwipe){this._bIgnoreSwipe=this._oScrolledElement&&d(this._oScrolledElement,E.target);}this._oScrolledElement=null;};
h.prototype._onWindowScroll=function(E){this._oScrolledElement=E.srcElement;};
h.prototype.onswiperight=function(E){if(b.support.touch===false){return;}if((b.system.tablet||(b.os.windows&&b.os.version>=8))&&(this._portraitHide()||this._hideMode())&&!this._bIgnoreSwipe&&!this._bDetailNavButton){this.showMaster();}};
h.prototype.ontap=function(E){if(b.system.phone){return;}var i=true,$=q(E.target).closest(".sapMSplitContainerDetail, .sapMSplitContainerMaster"),o=E.srcControl,p=o.getParent(),m=p&&p.isA("sap.m.Button")?p.getMetadata():o.getMetadata();if($.length>0&&$.hasClass("sapMSplitContainerDetail")){i=false;}if(((!this._oldIsLandscape&&this.getMode()=="ShowHideMode")||this.getMode()=="HideMode")&&!i&&!d(this._oShowMasterBtn.getDomRef(),E.target)&&(!m.getEvent("tap")||!m.getEvent("press"))){this.hideMaster();}};
h.prototype.onswipeleft=function(E){if((b.system.tablet||(b.os.windows&&b.os.version>=8))&&(this._portraitHide()||this._hideMode())&&!this._bIgnoreSwipe){this.hideMaster();}};
h.prototype._onMasterButtonTap=function(E){if(b.system.phone){return;}if(!this._oldIsLandscape){if(this.getMode()=="PopoverMode"){if(!this._oPopOver.isOpen()){this._oPopOver.openBy(this._oShowMasterBtn,true);}else{this._oPopOver.close();}}else{this.showMaster();}}else{if(this.getMode()==="HideMode"){this.showMaster();}}};
h.prototype.to=function(p,t,i,T){if(this._oMasterNav.getPage(p)){this._oMasterNav.to(p,t,i,T);}else{this._oDetailNav.to(p,t,i,T);}};
h.prototype.backToPage=function(p,i,t){if(this._oMasterNav.getPage(p)){this._oMasterNav.backToPage(p,i,t);}else{this._oDetailNav.backToPage(p,i,t);}};
h.prototype._safeBackToPage=function(p,t,i,T){if(this._oMasterNav.getPage(p)){this._oMasterNav._safeBackToPage(p,t,i,T);}else{this._oDetailNav._safeBackToPage(p,t,i,T);}};
h.prototype.insertPreviousPage=function(p,t,i){if(this._oMasterNav.getPage(p)){this._oMasterNav.insertPreviousPage(p,t,i);}else{this._oDetailNav.insertPreviousPage(p,t,i);}return this;};
h.prototype.toMaster=function(p,t,i,T){this._oMasterNav.to(p,t,i,T);};
h.prototype.backMaster=function(i,t){this._oMasterNav.back(i,t);};
h.prototype.backMasterToPage=function(p,i,t){this._oMasterNav.backToPage(p,i,t);};
h.prototype.toDetail=function(p,t,i,T){this._oDetailNav.to(p,t,i,T);};
h.prototype.backDetail=function(i,t){this._oDetailNav.back(i,t);};
h.prototype.backDetailToPage=function(p,i,t){this._oDetailNav.backToPage(p,i,t);};
h.prototype.backToTopMaster=function(i,t){this._oMasterNav.backToTop(i,t);};
h.prototype.backToTopDetail=function(i,t){this._oDetailNav.backToTop(i,t);};
h.prototype.addMasterPage=function(p){if(this._hasPageInArray(this._aMasterPages,p)){return;}if(this._oMasterNav===this._oDetailNav&&this._oDetailNav.getPages()&&this._oDetailNav.getPages().indexOf(p)!==-1){this._removePageFromArray(this._aDetailPages,p);}this._oMasterNav.insertPage(p,this._aMasterPages.length);this._aMasterPages.push(p);return this;};
h.prototype.addDetailPage=function(p){var t=this,r=this._getRealPage(p);if(this._hasPageInArray(this._aDetailPages,p)){return;}p.addDelegate({onBeforeShow:function(){if(r){if(!b.system.phone){if(t._needShowMasterButton()){t._setMasterButton(r);}}}}});if(r){r.addDelegate({onBeforeRendering:function(){if(!b.system.phone&&(t._oDetailNav.getCurrentPage()===r)){if(!r.getShowNavButton()&&t._needShowMasterButton()){t._setMasterButton(r,true);}else{t._removeMasterButton(r);}}}});if(!b.system.phone){if(!r._setCustomHeaderInSC){r._setCustomHeaderInSC=r.setCustomHeader;}r.setCustomHeader=function(H){this._setCustomHeaderInSC.apply(this,arguments);if(H&&t._needShowMasterButton()){t._setMasterButton(r);}return this;};if(!r._setShowNavButtonInSC){r._setShowNavButtonInSC=r.setShowNavButton;}r.setShowNavButton=function(s){this._setShowNavButtonInSC.apply(this,arguments);if(!s&&t._needShowMasterButton()){t._setMasterButton(r);}else{t._removeMasterButton(r,true);}return this;};}}if(this._oMasterNav===this._oDetailNav&&this._oMasterNav.getPages()&&this._oMasterNav.getPages().indexOf(p)!==-1){this._removePageFromArray(this._aMasterPages,p);}this._oDetailNav.addPage(p);this._aDetailPages.push(p);return this;};
h.prototype.getMasterPages=function(){return this._aMasterPages.slice();};
h.prototype.getDetailPages=function(){return this._aDetailPages.slice();};
h.prototype.indexOfMasterPage=function(p){return this._indexOfMasterPage(p);};
h.prototype.indexOfDetailPage=function(p){return this._indexOfDetailPage(p);};
h.prototype.insertMasterPage=function(p,i,s){return this._insertPage(this._aMasterPages,"masterPages",p,i,s);};
h.prototype.removeMasterPage=function(p,s){return this._removePage(this._aMasterPages,"masterPages",p,s);};
h.prototype.removeAllMasterPages=function(s){this._aMasterPages=[];return this.removeAllAggregation("masterPages",s);};
h.prototype.insertDetailPage=function(p,i,s){return this._insertPage(this._aDetailPages,"detailPages",p,i,s);};
h.prototype._restoreMethodsInPage=function(p){if(b.system.phone){return;}var r=this._getRealPage(p);if(r){if(r._setCustomHeaderInSC){r.setCustomHeader=r._setCustomHeaderInSC;delete r._setCustomHeaderInSC;}if(r._setShowNavButtonInSC){r.setShowNavButton=r._setShowNavButtonInSC;delete r._setShowNavButtonInSC;}}};
h.prototype.removeDetailPage=function(p,s){this._restoreMethodsInPage(p);return this._removePage(this._aDetailPages,"detailPages",p,s);};
h.prototype.removeAllDetailPages=function(s){var p=this.getDetailPages();for(var i=0;i<p.length;i++){this._restoreMethodsInPage(p[i]);}this._aDetailPages=[];return this.removeAllAggregation("detailPages",s);};
h.prototype.addPage=function(p,m){if(m){return this.addMasterPage(p);}else{return this.addDetailPage(p);}};
h.prototype.showMaster=function(){var _=this._getRealPage(this._oDetailNav.getCurrentPage());function i(){this._oPopOver.detachAfterOpen(i,this);this._bMasterOpening=false;this._bMasterisOpen=true;this.fireAfterMasterOpen();}if(this._portraitPopover()){if(!this._oPopOver.isOpen()){this._oPopOver.attachAfterOpen(i,this);this.fireBeforeMasterOpen();this._oPopOver.openBy(this._oShowMasterBtn,true);this._bMasterOpening=true;}}else if((this._portraitHide()||this._hideMode())&&(!this._bMasterisOpen||this._bMasterClosing)){this._oMasterNav.$().on("webkitTransitionEnd transitionend",this._afterShowMasterAnimation.bind(this));this.fireBeforeMasterOpen();this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",true);this._oMasterNav.getDomRef()&&this._oMasterNav.getDomRef().offsetHeight;this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",false);this._bMasterOpening=true;this._removeMasterButton(_);if(b.browser.webkit){var m=this._oMasterNav;window.setTimeout(function(){m.$().css("box-shadow","none");window.setTimeout(function(){m.$().css("box-shadow","");},50);},0);}}return this;};
h.prototype.hideMaster=function(){if(this._portraitPopover()){if(this._oPopOver.isOpen()){this._oPopOver.close();this._bMasterClosing=true;}}else if((this._portraitHide()||this._hideMode())&&(this._bMasterisOpen||this._oMasterNav.$().hasClass("sapMSplitContainerMasterVisible"))){this._oMasterNav.$().on("webkitTransitionEnd transitionend",this._afterHideMasterAnimation.bind(this));this.fireBeforeMasterClose();this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",false);this._oMasterNav.getDomRef()&&this._oMasterNav.getDomRef().offsetHeight;this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",true);this._bMasterClosing=true;}return this;};
h.prototype._afterShowMasterAnimation=function(){this._oMasterNav.$().off("webkitTransitionEnd transitionend");if(this._portraitHide()||this._hideMode()){this._bMasterOpening=false;this._bMasterisOpen=true;this.fireAfterMasterOpen();}};
h.prototype._afterHideMasterAnimation=function(){this._oMasterNav.$().off("webkitTransitionEnd transitionend");var o=this._getRealPage(this._oDetailNav.getCurrentPage());this._setMasterButton(o);this._bMasterClosing=false;this._bMasterisOpen=false;if(d(this._oMasterNav.getDomRef(),document.activeElement)){document.activeElement.blur();}this.fireAfterMasterClose();};
h.prototype.getCurrentMasterPage=function(){return this._oMasterNav.getCurrentPage();};
h.prototype.getCurrentDetailPage=function(){return this._oDetailNav.getCurrentPage();};
h.prototype.getCurrentPage=function(m){if(m){return this.getCurrentMasterPage();}else{return this.getCurrentDetailPage();}};
h.prototype.getPreviousPage=function(m){if(m){return this._oMasterNav.getPreviousPage();}else{return this._oDetailNav.getPreviousPage();}};
h.prototype.getMasterPage=function(p){return this._oMasterNav.getPage(p);};
h.prototype.getDetailPage=function(p){return this._oDetailNav.getPage(p);};
h.prototype.getPage=function(p,m){if(m){return this.getMasterPage(p);}else{return this.getDetailPage(p);}};
h.prototype.isMasterShown=function(){if(b.system.phone){var o=this._oMasterNav.getCurrentPage();return this._indexOfMasterPage(o)!==-1;}else{var m=this.getMode();switch(m){case g.StretchCompressMode:return true;case g.HideMode:return this._bMasterisOpen;case g.PopoverMode:case g.ShowHideMode:return b.orientation.landscape||this._bMasterisOpen;default:return false;}}};
h.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){L.warning("Invalid value "+o+" for SplitContainer.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}return this.setProperty("backgroundOpacity",o);};
h.prototype.setMode=function(m){var o=this.getMode();if(o===m){return this;}this.setProperty("mode",m,true);if(b.system.phone||!this.getDomRef()){return this;}if(o==="HideMode"&&this._oldIsLandscape){this._removeMasterButton(this._oDetailNav.getCurrentPage());}var i=this.getDomRef();if(m!=="PopoverMode"&&this._oPopOver.getContent().length>0){this._updateMasterPosition("landscape");}else if(m=="PopoverMode"){if(!this._oldIsLandscape){if(this._oPopOver.getContent().length===0){this._updateMasterPosition("popover");}this._setMasterButton(this._oDetailNav.getCurrentPage());}i.classList.remove("sapMSplitContainerShowHide");i.classList.remove("sapMSplitContainerStretchCompress");i.classList.remove("sapMSplitContainerHideMode");i.classList.add("sapMSplitContainerPopover");}if(m=="StretchCompressMode"){i.classList.remove("sapMSplitContainerShowHide");i.classList.remove("sapMSplitContainerPopover");i.classList.remove("sapMSplitContainerHideMode");i.classList.add("sapMSplitContainerStretchCompress");this._removeMasterButton(this._oDetailNav.getCurrentPage());}if(m=="ShowHideMode"){i.classList.remove("sapMSplitContainerPopover");i.classList.remove("sapMSplitContainerStretchCompress");i.classList.remove("sapMSplitContainerHideMode");i.classList.add("sapMSplitContainerShowHide");if(!b.orientation.landscape){this._setMasterButton(this._oDetailNav.getCurrentPage());}}if(m==="HideMode"){i.classList.remove("sapMSplitContainerPopover");i.classList.remove("sapMSplitContainerStretchCompress");i.classList.remove("sapMSplitContainerShowHide");i.classList.add("sapMSplitContainerHideMode");this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",false);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",true);this._bMasterisOpen=false;this._setMasterButton(this._oDetailNav.getCurrentPage());}return this;};
h.prototype._updateMasterInitialPage=function(){if(this.getMode()==="HideMode"&&b.system.phone&&this._aDetailPages){this._oMasterNav.setInitialPage(this.getInitialDetail()?this.getInitialDetail():(this.getInitialMaster()||this._aDetailPages[0]));}};
h.prototype._indexOfMasterPage=function(p){return this._aMasterPages.indexOf(p);};
h.prototype._indexOfDetailPage=function(p){return this._aDetailPages.indexOf(p);};
h.prototype._insertPage=function(p,A,o,j,s){this.insertAggregation(A,o,j,s);var i;if(j<0){i=0;}else if(j>p.length){i=p.length;}else{i=j;}var O=(p?Array.prototype.indexOf.call(p,o):-1);p.splice(i,0,o);if(O!=-1){this._removePageFromArray(p,o);}return this;};
h.prototype._removePage=function(p,A,o,s){var r=this.removeAggregation(A,o,s);if(r){this._removePageFromArray(p,r);}return r;};
h.prototype._removePageFromArray=function(p,o){var i=(p?Array.prototype.indexOf.call(p,o):-1);if(i!=-1){p.splice(i,1);if(p===this._aDetailPages){this._restoreMethodsInPage(o);}}};
h.prototype._handleNavigationEvent=function(E,A,m){var s=(A?"After":"")+(m?"Master":"Detail")+"Navigate",i;s=s.charAt(0).toLowerCase()+s.slice(1);i=this.fireEvent(s,E.mParameters,true);if(!i){E.preventDefault();}};
h.prototype._handleResize=function(){var i=b.orientation.landscape,_=this._oDetailNav.getCurrentPage(),m=this.getMode();if(this._oldIsLandscape!==i){this._oldIsLandscape=i;if(!b.system.phone){this.$().toggleClass("sapMSplitContainerPortrait",!i);if(m==="HideMode"){return;}if(m==="ShowHideMode"){if(i){this.fireBeforeMasterOpen();}else{this.fireBeforeMasterClose();}}if(m==="ShowHideMode"||m==="PopoverMode"){this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",i);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",!i);}if(m==="ShowHideMode"){if(i){this._bMasterisOpen=true;this.fireAfterMasterOpen();}else{this._bMasterisOpen=false;this.fireAfterMasterClose();}}if(m=="PopoverMode"){if(this._oPopOver.isOpen()){this._oPopOver.attachAfterClose(this._handlePopClose,this);this._oPopOver.close();}else{this._handlePopClose();}}_=this._getRealPage(_);if(!this._oldIsLandscape&&m!="StretchCompressMode"){this._setMasterButton(_);}else{this._removeMasterButton(_);}}if(this._onOrientationChange){this._onOrientationChange();}}};
h.prototype._handlePopClose=function(E){this._oPopOver.detachAfterClose(this._handlePopClose,this);if(this._oldIsLandscape){this._updateMasterPosition("landscape");}else{this._updateMasterPosition("popover");}};
h.prototype._getRealPage=function(p){var r=p,i;while(r){if(r instanceof sap.m.Page){return r;}if(r instanceof sap.m.MessagePage){return r;}if(r instanceof S){return r;}if(r instanceof sap.ui.core.mvc.View){i=r.getContent();if(i.length===1){r=i[0];continue;}}else if(r instanceof N){r=r.getCurrentPage();continue;}r=null;}return r;};
h.prototype._updateMasterPosition=function(p){var t=this;if(p=="popover"){this.removeAggregation("_navMaster",this._oMasterNav,true);this._oMasterNav.$().remove();this._oPopOver.addContent(this._oMasterNav);this._bMasterisOpen=false;}if(p=="landscape"){var r=function(){t._oPopOver.removeAggregation("content",t._oMasterNav,false);t.setAggregation("_navMaster",t._oMasterNav,true);var $=t.$();if($[0]){var i=sap.ui.getCore().createRenderManager();i.renderControl(t._oMasterNav.addStyleClass("sapMSplitContainerMaster"));i.flush($[0],false,(t.$("BG")[0])?1:0);i.destroy();}};if(this._oPopOver.isOpen()){var A=function(){this._oPopOver.detachAfterClose(A,this);this._bMasterisOpen=false;r();};this._oPopOver.attachAfterClose(A,this);this._oPopOver.close();}else{r();}}};
h.prototype._portraitHide=function(){if(!this._oldIsLandscape&&!b.system.phone&&this.getMode()==="ShowHideMode"){return true;}else{return false;}};
h.prototype._portraitPopover=function(){if(!this._oldIsLandscape&&!b.system.phone&&this.getMode()==="PopoverMode"){return true;}else{return false;}};
h.prototype._hideMode=function(){return this.getMode()==="HideMode"&&!b.system.phone;};
h.prototype._needShowMasterButton=function(){return(this._portraitHide()||this._hideMode()||this._portraitPopover())&&(!this._bMasterisOpen||this._bMasterClosing);};
h.prototype._updateMasterButtonTooltip=function(){if(!this._oShowMasterBtn){return;}var t=this.getMasterButtonTooltip();if(t){this._oShowMasterBtn.setTooltip(t);return;}var p=this._oMasterNav.getCurrentPage();if(p&&p.getTitle){var T=p.getTitle();if(T){T=T.replace(/[_0-9]+$/,'');t=this._rb.getText('SPLITCONTAINER_NAVBUTTON_TOOLTIP',T);}}if(!t){t=this._rb.getText('SPLITCONTAINER_NAVBUTTON_DEFAULT_TOOLTIP');}this._oShowMasterBtn.setTooltip(t);};
h.prototype._updateMasterButtonText=function(){this._oShowMasterBtn.setText(this.getMasterButtonText()||this._rb.getText("SPLITCONTAINER_NAVBUTTON_TEXT"));};
h.prototype._createShowMasterButton=function(){if(this._oShowMasterBtn&&!this._oShowMasterBtn.bIsDestroyed){return;}this._oShowMasterBtn=new B(this.getId()+"-MasterBtn",{icon:I.getIconURI("menu2"),tooltip:this.getMasterButtonTooltip(),type:e.Default,press:q.proxy(this._onMasterButtonTap,this)}).addStyleClass("sapMSplitContainerMasterBtn");};
h.prototype._setMasterButton=function(p,j,s){if(!p){return;}if(typeof j==='boolean'){s=j;j=undefined;}p=this._getRealPage(p);if(!p){return;}var H=h._getHeaderButtonAggregation(p),k=H.sAggregationName,m=H.aAggregationContent;for(var i=0;i<m.length;i++){if(m[i]instanceof sap.m.Button&&m[i].getVisible()&&(m[i].getType()==e.Back||(m[i].getType()==e.Up&&m[i]!==this._oShowMasterBtn))){this._bDetailNavButton=true;return;}}this._bDetailNavButton=false;var o=p._getAnyHeader();var n=false;for(var i=0;i<m.length;i++){if(m[i]===this._oShowMasterBtn){n=true;}}if(!n){this._createShowMasterButton();this._updateMasterButtonTooltip();this._updateMasterButtonText();this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");if(o){o.insertAggregation(k,this._oShowMasterBtn,0,s);}}else{this._oShowMasterBtn.$().parent().toggleClass("sapMSplitContainerMasterBtnHide",false);this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");this._oShowMasterBtn.$().parent().toggleClass("sapMSplitContainerMasterBtnShow",true);}if(j){j(p);}this.fireMasterButton({show:true});};
h._getHeaderButtonAggregation=function(p){var H=p._getAnyHeader(),A,s;if(!H){return;}if(H.getContentLeft){A=H.getContentLeft();s="contentLeft";}if(H.getContent){A=H.getContent();s="content";}return{aAggregationContent:A,sAggregationName:s};};
h.prototype._removeMasterButton=function(p,j,n){if(!p){return;}var t=this,H=this._oShowMasterBtn.$().is(":hidden"),o;if(typeof j==="boolean"){n=j;j=undefined;}if(!H&&!n){p=this._getRealPage(p);if(!p){return;}o=p._getAnyHeader();if(o){var k=h._getHeaderButtonAggregation(p).aAggregationContent;for(var i=0;i<k.length;i++){if(k[i]===this._oShowMasterBtn){this._oShowMasterBtn.destroy();this._oShowMasterBtn.$().parent().on("webkitAnimationEnd animationend",function(){q(this).off("webkitAnimationEnd animationend");t._oShowMasterBtn.addStyleClass("sapMSplitContainerMasterBtnHidden");if(j){j(p);}});break;}}}this.fireMasterButton({show:false});}else{this._oShowMasterBtn.addStyleClass("sapMSplitContainerMasterBtnHidden");if(j){j(p);}if(!H){this.fireMasterButton({show:false});}}};
h.prototype._callSuperMethod=function(F,A){var i=Array.prototype.slice.call(arguments);if(A==="masterPages"){if(F==="indexOfAggregation"){return this._indexOfMasterPage.apply(this,i.slice(2));}else{return this._callNavContainerMethod(F,this._oMasterNav,i);}}else if(A==="detailPages"){if(F==="indexOfAggregation"){return this._indexOfDetailPage.apply(this,i.slice(2));}else{return this._callNavContainerMethod(F,this._oDetailNav,i);}}else{return C.prototype[F].apply(this,i.slice(1));}};
h.prototype._callNavContainerMethod=function(F,n,A){A[1]="pages";A=A.slice(1);var r=h._mFunctionMapping[F];if(r){A.shift();F=r;}return n[F].apply(n,A);};
h.prototype._hasPageInArray=function(i,p){return i.some(function(A){return p&&(p===A);});};
h.prototype.showPlaceholder=function(s){if(!sap.ui.getCore().getConfiguration().getPlaceholder()){return;}switch(s&&s.aggregation){case"masterPages":return this.getAggregation("_navMaster").showPlaceholder(s);default:return this.getAggregation("_navDetail").showPlaceholder(s);}};
h.prototype.hidePlaceholder=function(s){switch(s.aggregation){case"masterPages":this.getAggregation("_navMaster").hidePlaceholder(s);break;default:this.getAggregation("_navDetail").hidePlaceholder(s);}};
h.prototype.needPlaceholder=function(A,o){var i;switch(A){case"masterPages":i=this.getAggregation("_navMaster");break;default:i=this.getAggregation("_navDetail");}return!o||(i.getCurrentPage()!==o);};
h.prototype.validateAggregation=function(A,o,m){return this._callSuperMethod("validateAggregation",A,o,m);};
h.prototype.setAggregation=function(A,o,s){this._callSuperMethod("setAggregation",A,o,s);return this;};
h.prototype.getAggregation=function(A,o){return this._callSuperMethod("getAggregation",A,o);};
h.prototype.indexOfAggregation=function(A,o){return this._callSuperMethod("indexOfAggregation",A,o);};
h.prototype.insertAggregation=function(A,o,i,s){this._callSuperMethod("insertAggregation",A,o,i,s);return this;};
h.prototype.addAggregation=function(A,o,s){this._callSuperMethod("addAggregation",A,o,s);return this;};
h.prototype.removeAggregation=function(A,o,s){return this._callSuperMethod("removeAggregation",A,o,s);};
h.prototype.removeAllAggregation=function(A,s){return this._callSuperMethod("removeAllAggregation",A,s);};
h.prototype.destroyAggregation=function(A,s){this._callSuperMethod("destroyAggregation",A,s);return this;};
h._mFunctionMapping={"getAggregation":"getPage","addAggregation":"addPage","insertAggregation":"insertPage","removeAggregation":"removePage","removeAllAggregation":"removeAllPages"};return h;});
sap.ui.predefine('sap/m/SplitContainerRenderer',["./library","sap/ui/Device"],function(l,D){"use strict";var S=l.SplitAppMode;var a={apiVersion:2};
a.render=function(r,s){var m=s.getMode(),t=s.getTooltip_AsString();r.openStart("div",s).class("sapMSplitContainer");if(this.renderAttributes){this.renderAttributes(r,s);}if(!D.system.phone){if(D.orientation.portrait){r.class("sapMSplitContainerPortrait");}switch(m){case S.ShowHideMode:r.class("sapMSplitContainerShowHide");break;case S.StretchCompressMode:r.class("sapMSplitContainerStretchCompress");break;case S.PopoverMode:r.class("sapMSplitContainerPopover");break;case S.HideMode:r.class("sapMSplitContainerHideMode");break;default:break;}}if(t){r.attr("title",t);}r.openEnd();if(this.renderBeforeContent){this.renderBeforeContent(r,s);}this.renderMasterAndDetail(r,s,m);r.close("div");};
a.renderMasterAndDetail=function(r,s,m){if(D.system.phone){s._oMasterNav.addStyleClass("sapMSplitContainerMobile");r.renderControl(s._oMasterNav);return;}s._bMasterisOpen=false;if((D.orientation.landscape&&(m!==S.HideMode))||D.orientation.portrait&&(m===S.StretchCompress)){s._oMasterNav.addStyleClass("sapMSplitContainerMasterVisible").removeStyleClass("sapMSplitContainerMasterHidden").removeStyleClass("sapMSplitContainerNoTransition");s._bMasterisOpen=true;}else{s._oMasterNav.addStyleClass("sapMSplitContainerMasterHidden").addStyleClass("sapMSplitContainerNoTransition").removeStyleClass("sapMSplitContainerMasterVisible");}if(m===S.PopoverMode&&D.orientation.portrait){s._oDetailNav.addStyleClass("sapMSplitContainerDetail");r.renderControl(s._oDetailNav);if(s._oPopOver.getContent().length===0){s._oPopOver.addAggregation("content",s._oMasterNav,true);}}else{s._oMasterNav.addStyleClass("sapMSplitContainerMaster");r.renderControl(s._oMasterNav);s._oDetailNav.addStyleClass("sapMSplitContainerDetail");r.renderControl(s._oDetailNav);}};
return a;},true);
sap.ui.predefine('sap/m/StandardDynamicDateOption',['sap/ui/core/library','sap/ui/core/Element','./DynamicDateOption','./Label','./StepInput','./RadioButton','./RadioButtonGroup','sap/ui/unified/Calendar','sap/ui/unified/calendar/MonthPicker','sap/ui/core/format/DateFormat','sap/ui/core/date/UniversalDateUtils','sap/ui/core/date/UniversalDate','sap/m/DynamicDateValueHelpUIType','./library'],function(c,E,D,L,S,R,a,C,M,b,U,d,e,l){"use strict";var V=c.VerticalAlign;
var f=D.extend("sap.m.StandardDynamicDateOption",{metadata:{library:"sap.m"}});
var g=1;var h=6000;var K={"DATE":"DATE","DATERANGE":"DATERANGE","TODAY":"TODAY","YESTERDAY":"YESTERDAY","TOMORROW":"TOMORROW","SPECIFICMONTH":"SPECIFICMONTH","FIRSTDAYWEEK":"FIRSTDAYWEEK","LASTDAYWEEK":"LASTDAYWEEK","FIRSTDAYMONTH":"FIRSTDAYMONTH","LASTDAYMONTH":"LASTDAYMONTH","FIRSTDAYQUARTER":"FIRSTDAYQUARTER","LASTDAYQUARTER":"LASTDAYQUARTER","FIRSTDAYYEAR":"FIRSTDAYYEAR","LASTDAYYEAR":"LASTDAYYEAR","THISWEEK":"THISWEEK","THISMONTH":"THISMONTH","THISQUARTER":"THISQUARTER","THISYEAR":"THISYEAR","LASTWEEK":"LASTWEEK","LASTMONTH":"LASTMONTH","LASTQUARTER":"LASTQUARTER","LASTYEAR":"LASTYEAR","NEXTWEEK":"NEXTWEEK","NEXTMONTH":"NEXTMONTH","NEXTQUARTER":"NEXTQUARTER","NEXTYEAR":"NEXTYEAR","LASTDAYS":"LASTDAYS","LASTWEEKS":"LASTWEEKS","LASTMONTHS":"LASTMONTHS","LASTQUARTERS":"LASTQUARTERS","LASTYEARS":"LASTYEARS","NEXTDAYS":"NEXTDAYS","NEXTWEEKS":"NEXTWEEKS","NEXTMONTHS":"NEXTMONTHS","NEXTQUARTERS":"NEXTQUARTERS","NEXTYEARS":"NEXTYEARS","FROM":"FROM","TO":"TO","YEARTODATE":"YEARTODATE","DATETOYEAR":"DATETOYEAR","TODAYFROMTO":"TODAYFROMTO","QUARTER1":"QUARTER1","QUARTER2":"QUARTER2","QUARTER3":"QUARTER3","QUARTER4":"QUARTER4"};var _={"SingleDates":1,"DateRanges":2,"Weeks":3,"Months":4,"Quarters":5,"Years":6};var j={"DATE":_.SingleDates,"DATERANGE":_.DateRanges,"TODAY":_.SingleDates,"YESTERDAY":_.SingleDates,"TOMORROW":_.SingleDates,"SPECIFICMONTH":_.Months,"FIRSTDAYWEEK":_.SingleDates,"LASTDAYWEEK":_.SingleDates,"FIRSTDAYMONTH":_.SingleDates,"LASTDAYMONTH":_.SingleDates,"FIRSTDAYQUARTER":_.SingleDates,"LASTDAYQUARTER":_.SingleDates,"FIRSTDAYYEAR":_.SingleDates,"LASTDAYYEAR":_.SingleDates,"THISWEEK":_.Weeks,"THISMONTH":_.Months,"THISQUARTER":_.Quarters,"THISYEAR":_.Years,"LASTWEEK":_.Weeks,"LASTMONTH":_.Months,"LASTQUARTER":_.Quarters,"LASTYEAR":_.Years,"NEXTWEEK":_.Weeks,"NEXTMONTH":_.Months,"NEXTQUARTER":_.Quarters,"NEXTYEAR":_.Years,"LASTDAYS":_.DateRanges,"LASTWEEKS":_.DateRanges,"LASTMONTHS":_.DateRanges,"LASTQUARTERS":_.DateRanges,"LASTYEARS":_.DateRanges,"NEXTDAYS":_.DateRanges,"NEXTWEEKS":_.DateRanges,"NEXTMONTHS":_.DateRanges,"NEXTQUARTERS":_.DateRanges,"NEXTYEARS":_.DateRanges,"FROM":_.DateRanges,"TO":_.DateRanges,"YEARTODATE":_.DateRanges,"DATETOYEAR":_.DateRanges,"TODAYFROMTO":_.DateRanges,"QUARTER1":_.Quarters,"QUARTER2":_.Quarters,"QUARTER3":_.Quarters,"QUARTER4":_.Quarters};var k=["LASTDAYS","LASTWEEKS","LASTMONTHS","LASTQUARTERS","LASTYEARS"];var n=["NEXTDAYS","NEXTWEEKS","NEXTMONTHS","NEXTQUARTERS","NEXTYEARS"];f.LastXKeys=k;f.NextXKeys=n;var m=sap.ui.getCore().getLibraryResourceBundle("sap.m");f.Keys=K;
f.prototype.exit=function(){if(this.aValueHelpUITypes){while(this.aValueHelpUITypes.length){this.aValueHelpUITypes.pop().destroy();}delete this.aValueHelpUITypes;}};
f.prototype.getText=function(i){var s=this.getKey();var O=i._getOptions();var p=this.getValueHelpUITypes(i);var q=this._getOptionParams(k,O);var N=this._getOptionParams(n,O);if(q){p.push(q);}if(N){p.push(N);}switch(s){case K.LASTDAYS:case K.LASTWEEKS:case K.LASTMONTHS:case K.LASTQUARTERS:case K.LASTYEARS:case K.NEXTDAYS:case K.NEXTWEEKS:case K.NEXTMONTHS:case K.NEXTQUARTERS:case K.NEXTYEARS:return this._getXPeriodTitle(p[1].getOptions());default:return m.getText("DYNAMIC_DATE_"+s+"_TITLE");}};
f.prototype.getValueHelpUITypes=function(i){var s=this.getKey();if(!this.aValueHelpUITypes){switch(s){case K.TODAY:case K.YESTERDAY:case K.TOMORROW:case K.FIRSTDAYWEEK:case K.LASTDAYWEEK:case K.FIRSTDAYMONTH:case K.LASTDAYMONTH:case K.FIRSTDAYQUARTER:case K.LASTDAYQUARTER:case K.FIRSTDAYYEAR:case K.LASTDAYYEAR:case K.THISWEEK:case K.THISMONTH:case K.THISQUARTER:case K.THISYEAR:case K.LASTWEEK:case K.LASTMONTH:case K.LASTQUARTER:case K.LASTYEAR:case K.NEXTWEEK:case K.NEXTMONTH:case K.NEXTQUARTER:case K.NEXTYEAR:case K.YEARTODATE:case K.DATETOYEAR:case K.QUARTER1:case K.QUARTER2:case K.QUARTER3:case K.QUARTER4:this.aValueHelpUITypes=[];break;case K.DATE:case K.FROM:case K.TO:this.aValueHelpUITypes=[new e({type:"date"})];break;case K.DATERANGE:this.aValueHelpUITypes=[new e({type:"daterange"})];break;case K.SPECIFICMONTH:this.aValueHelpUITypes=[new e({type:"month"})];break;case K.LASTDAYS:case K.LASTWEEKS:case K.LASTMONTHS:case K.LASTQUARTERS:case K.LASTYEARS:case K.NEXTDAYS:case K.NEXTWEEKS:case K.NEXTMONTHS:case K.NEXTQUARTERS:case K.NEXTYEARS:this.aValueHelpUITypes=[new e({text:m.getText("DDR_LASTNEXTX_LABEL"),type:"int"})];break;case K.TODAYFROMTO:this.aValueHelpUITypes=[new e({text:m.getText("DDR_TODAYFROMTO_FROM_LABEL"),type:"int",additionalText:m.getText("DDR_TODAYFROMTO_TO_ADDITIONAL_LABEL")}),new e({text:m.getText("DDR_TODAYFROMTO_TO_LABEL"),type:"int",additionalText:m.getText("DDR_TODAYFROMTO_TO_ADDITIONAL_LABEL")})];break;}}return this.aValueHelpUITypes.slice(0);};
f.prototype.createValueHelpUI=function(i,p){var O=i._getOptions();var v=i.getValue();var P=this.getValueHelpUITypes(i);var q=[];if(!i.aControlsByParameters){i.aControlsByParameters={};}i.aControlsByParameters[this.getKey()]=[];var r=this._getOptionParams(k,O);var N=this._getOptionParams(n,O);if(r){P.push(r);}if(N){P.push(N);}for(var I=0;I<P.length;I++){if(P[I].getOptions()&&P[I].getOptions().length<=1){break;}else if(P[I].getText()){q.push(new L({text:P[I].getText(),width:"100%"}));}var s;switch(P[I].getType()){case"int":s=this._createIntegerControl(v,I,p);if(v&&P[1]&&P[1].getOptions()&&P[1].getOptions().indexOf(v.operator.slice(4).toLowerCase())!==-1){s.setValue(v.values[I]);}break;case"date":s=this._createDateControl(v,I,p);break;case"daterange":s=this._createDateRangeControl(v,I,p);break;case"month":s=this._createMonthControl(v,I,p);break;case"options":s=this._createOptionsControl(v,I,p,P);break;}q.push(s);if(P[I].getAdditionalText()){q.push(new L({vAlign:V.Bottom,text:P[I].getAdditionalText()}).addStyleClass("sapMDDRAdditionalLabel"));}i.aControlsByParameters[this.getKey()].push(s);}return q;};
f.prototype._createIntegerControl=function(v,i,p){var q=D.prototype._createIntegerControl.call(this,v,i,p);var r=this.getKey()==="TODAYFROMTO"?-h:g;var u=!v||this.getKey()!==v.operator;if(this.getKey()==="TODAYFROMTO"&&u){q.setValue(1);}q.setMin(r);q.setMax(h);return q;};
f.prototype._createOptionsControl=function(v,i,p,P){var q=new a({buttons:[P[i].getOptions().map(o)]});if(v){var O=P[i].getOptions().indexOf(v.operator.slice(4).toLowerCase());if(O!==-1){q.setSelectedIndex(O);}}if(p instanceof Function){q.attachSelect(function(){p(this);},this);}return q;};
f.prototype._getOptionParams=function(G,O){if(G.indexOf(this.getKey())!==-1){return new e({text:m.getText("DDR_LASTNEXTX_TIME_PERIODS_LABEL"),type:"options",options:O?O.filter(function(i){return G.indexOf(i.getKey())!==-1;}).map(function(i){return i.getKey().slice(4).toLowerCase();}):[]});}return undefined;};
f.prototype.validateValueHelpUI=function(p){var P=this.getValueHelpUITypes();for(var i=0;i<P.length;i++){var I=p.aControlsByParameters[this.getKey()][i];switch(P[i].getType()){case"int":if(I._isLessThanMin(I.getValue())||I._isMoreThanMax(I.getValue())){return false;}break;case"month":case"date":case"daterange":if(!I.getSelectedDates()||I.getSelectedDates().length==0){return false;}break;case"options":if(I.getSelectedIndex()<0){return false;}break;}}return true;};
f.prototype.getValueHelpOutput=function(p){var O=p._getOptions();var P=this.getValueHelpUITypes(p),r={},v;if(k.indexOf(this.getKey())!==-1&&p.aControlsByParameters[this.getKey()].length>1){r.operator=O.filter(function(s){return k.indexOf(s.getKey())!==-1;})[p.aControlsByParameters[this.getKey()][1].getSelectedIndex()].getKey();}else if(n.indexOf(this.getKey())!==-1&&p.aControlsByParameters[this.getKey()].length>1){r.operator=O.filter(function(s){return n.indexOf(s.getKey())!==-1;})[p.aControlsByParameters[this.getKey()][1].getSelectedIndex()].getKey();}else{r.operator=this.getKey();}r.values=[];for(var i=0;i<P.length;i++){var I=p.aControlsByParameters[this.getKey()][i];switch(P[i].getType()){case"int":v=I.getValue();break;case"month":if(!I.getSelectedDates()||!I.getSelectedDates().length){return null;}v=I.getSelectedDates()[0].getStartDate().getMonth();break;case"date":if(!I.getSelectedDates().length){return null;}v=I.getSelectedDates()[0].getStartDate();break;case"daterange":if(!I.getSelectedDates().length){return null;}var q=I.getSelectedDates()[0].getEndDate()||I.getSelectedDates()[0].getStartDate();v=[I.getSelectedDates()[0].getStartDate(),q];break;}if(Array.isArray(v)){r.values=Array.prototype.concat.apply(r.values,v);}else{v!==null&&v!==undefined&&r.values.push(v);}}return r;};
f.prototype.getGroup=function(){return j[this.getKey()];};
f.prototype.getGroupHeader=function(){return m.getText("DDR_OPTIONS_GROUP_"+j[this.getKey()]);};
f.prototype.format=function(O,F){return F.format(O);};
f.prototype.parse=function(v,F){return F.parse(v,this.getKey());};
f.prototype.toDates=function(v){if(!v){return null;}var s=v.operator;var p=v.values[0]||0;switch(s){case"SPECIFICMONTH":var i=new d();i.setMonth(v.values[0]);i=U.getMonthStartDate(i);return U.getRange(0,"MONTH",i);case"DATE":return U.getRange(0,"DAY",d.getInstance(v.values[0]));case"DATERANGE":var q=d.getInstance(v.values[0]);var r=d.getInstance(v.values[1]);return[U.resetStartTime(q),U.resetEndTime(r)];case"TODAY":return U.ranges.today();case"YESTERDAY":return U.ranges.yesterday();case"TOMORROW":return U.ranges.tomorrow();case"FIRSTDAYWEEK":return U.ranges.firstDayOfWeek();case"LASTDAYWEEK":return U.ranges.lastDayOfWeek();case"FIRSTDAYMONTH":return U.ranges.firstDayOfMonth();case"LASTDAYMONTH":return U.ranges.lastDayOfMonth();case"FIRSTDAYQUARTER":return U.ranges.firstDayOfQuarter();case"LASTDAYQUARTER":return U.ranges.lastDayOfQuarter();case"FIRSTDAYYEAR":return U.ranges.firstDayOfYear();case"LASTDAYYEAR":return U.ranges.lastDayOfYear();case"THISWEEK":return U.ranges.currentWeek();case"THISMONTH":return U.ranges.currentMonth();case"THISQUARTER":return U.ranges.currentQuarter();case"THISYEAR":return U.ranges.currentYear();case"LASTWEEK":return U.ranges.lastWeek();case"LASTMONTH":return U.ranges.lastMonth();case"LASTQUARTER":return U.ranges.lastQuarter();case"LASTYEAR":return U.ranges.lastYear();case"NEXTWEEK":return U.ranges.nextWeek();case"NEXTMONTH":return U.ranges.nextMonth();case"NEXTQUARTER":return U.ranges.nextQuarter();case"NEXTYEAR":return U.ranges.nextYear();case"LASTDAYS":return U.ranges.lastDays(p);case"LASTWEEKS":return U.ranges.lastWeeks(p);case"LASTMONTHS":return U.ranges.lastMonths(p);case"LASTQUARTERS":return U.ranges.lastQuarters(p);case"LASTYEARS":return U.ranges.lastYears(p);case"NEXTDAYS":return U.ranges.nextDays(p);case"NEXTWEEKS":return U.ranges.nextWeeks(p);case"NEXTMONTHS":return U.ranges.nextMonths(p);case"NEXTQUARTERS":return U.ranges.nextQuarters(p);case"NEXTYEARS":return U.ranges.nextYears(p);case"FROM":return[v.values[0],v.values[0]];case"TO":return[v.values[0],v.values[0]];case"YEARTODATE":return U.ranges.yearToDate();case"DATETOYEAR":return U.ranges.dateToYear();case"TODAYFROMTO":if(v.values.length!==2){return[];}var x=v.values[0];var y=v.values[1];var q=x>=0?U.ranges.lastDays(x)[0]:U.ranges.nextDays(-x)[1];var r=y>=0?U.ranges.nextDays(y)[1]:U.ranges.lastDays(-y)[0];if(q.oDate.getTime()>r.oDate.getTime()){r=[q,q=r][0];}return[U.resetStartTime(q),U.resetEndTime(r)];case"QUARTER1":return U.ranges.quarter(1);case"QUARTER2":return U.ranges.quarter(2);case"QUARTER3":return U.ranges.quarter(3);case"QUARTER4":return U.ranges.quarter(4);default:return[];}};
f.prototype.enhanceFormattedValue=function(){switch(this.getKey()){case"TODAY":case"YESTERDAY":case"TOMORROW":case"FIRSTDAYWEEK":case"LASTDAYWEEK":case"FIRSTDAYMONTH":case"LASTDAYMONTH":case"FIRSTDAYQUARTER":case"LASTDAYQUARTER":case"FIRSTDAYYEAR":case"LASTDAYYEAR":case"THISWEEK":case"THISMONTH":case"THISQUARTER":case"THISYEAR":case"LASTWEEK":case"LASTMONTH":case"LASTQUARTER":case"LASTYEAR":case"NEXTWEEK":case"NEXTMONTH":case"NEXTQUARTER":case"NEXTYEAR":case"YEARTODATE":case"DATETOYEAR":case"QUARTER1":case"QUARTER2":case"QUARTER3":case"QUARTER4":return true;default:return false;}};
f.prototype._getXPeriodTitle=function(O){var s,i=this.getKey();if(O.length===1){return m.getText("DYNAMIC_DATE_"+i+"_TITLE");}s=O.map(function(p){return m.getText("DYNAMIC_DATE_"+p.toUpperCase());}).join(" / ");if(i.indexOf("LAST")===0){return m.getText("DYNAMIC_DATE_LASTX_TITLE",s);}if(i.indexOf("NEXT")===0){return m.getText("DYNAMIC_DATE_NEXTX_TITLE",s);}};
function o(O){return new R({text:m.getText("DYNAMIC_DATE_"+O.toUpperCase())});}
return f;});
sap.ui.predefine('sap/m/StandardListItem',["sap/ui/core/library","sap/ui/core/IconPool","sap/ui/core/theming/Parameters","sap/ui/Device","./library","./ListItemBase","./Image","./StandardListItemRenderer","sap/base/Log"],function(c,I,T,D,l,L,a,S,b){"use strict";var d=c.TextDirection;var V=c.ValueState;
var e=L.extend("sap.m.StandardListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},description:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconInset:{type:"boolean",group:"Appearance",defaultValue:true},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},info:{type:"string",group:"Misc",defaultValue:null},infoState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},adaptTitleSize:{type:"boolean",group:"Appearance",defaultValue:true},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:d.Inherit},infoTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:d.Inherit},wrapping:{type:"boolean",group:"Behavior",defaultValue:false},infoStateInverted:{type:"boolean",group:"Appearance",defaultValue:false},wrapCharLimit:{type:"int",group:"Behavior",defaultValue:0}},aggregations:{avatar:{type:'sap.m.Avatar',multiple:false}},designtime:"sap/m/designtime/StandardListItem.designtime"}});
e.prototype.exit=function(){if(this._oImage){this._oImage.destroy("KeepDom");}L.prototype.exit.apply(this,arguments);};
e.prototype.setIcon=function(i){var o=this.getIcon();this.setProperty("icon",i);if(this._oImage&&(!i||I.isIconURI(i)!=I.isIconURI(o))){this._oImage.destroy("KeepDom");this._oImage=undefined;}return this;};
e.prototype.setAvatar=function(A){if(this.getAvatar()===A){return this;}if(A){A.addStyleClass("sapMSLIAvatar");A.setDisplaySize=function(){return this;};}this.setAggregation("avatar",A);return this;};
e.prototype.setWrapCharLimit=function(i){var o=this.getWrapCharLimit();if(o===i){return this;}if(i<0){b.error("The property wrapCharLimit must be 0 or greater than 0 - "+this.getId());return this;}this.setProperty("wrapCharLimit",i);return this;};
e.prototype._getImage=function(){var i=this._oImage;if(i){i.setSrc(this.getIcon());if(i.setDensityAware){i.setDensityAware(this.getIconDensityAware());}}else{i=I.createControlByURI({id:this.getId()+"-img",src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false},a).setParent(this,null,true);}var s=this.getIconInset()?"sapMSLIImg":"sapMSLIImgNoInset";i.addStyleClass(i instanceof a?s:s+"Icon",true);this._oImage=i;return this._oImage;};
e.prototype._getAvatar=function(){var A=this.getAvatar();var s=this.getIconInset()?l.AvatarSize.XS:l.AvatarSize.S;A.setProperty("displaySize",s,true);return A;};
e.prototype._activeHandlingInheritor=function(){if(this._oImage){var A=this.getActiveIcon();A&&this._oImage.setSrc(A);}};
e.prototype._inactiveHandlingInheritor=function(){if(this._oImage){this._oImage.setSrc(this.getIcon());}};
e.prototype.getContentAnnouncement=function(B){var i=this.getInfoState(),t=this.getTitle(),s,f=this.getDescription(),g,o,h,O=[],j=this.getInfo();if(this.getWrapping()){o=this.getDomRef("titleButton");h=this.getDomRef("descriptionButton");t=this._bTitleTextExpanded?t:this._getCollapsedText(t);f=this._bDescriptionTextExpanded?f:this._getCollapsedText(f);O.push(t);if(o){s=o.textContent+" "+B.getText("ACC_CTR_TYPE_BUTTON");s&&O.push(s);}O.push(f);if(h){g=h.textContent+" . "+B.getText("ACC_CTR_TYPE_BUTTON");g&&O.push(g);}}else{t&&O.push(t);f&&O.push(f);}j&&O.push(j);if(i!="None"&&i!=this.getHighlight()){O.push(B.getText("LIST_ITEM_STATE_"+i.toUpperCase()));}return O.join(" . ").trim();};
e.prototype._measureInfoTextWidth=function(t){if(!e._themeInfo){e._themeInfo={};}var B=parseFloat(l.BaseFontSize)||16;if(!e._themeInfo.sFontFamily||t){e._themeInfo.sFontFamily=T.get({name:"sapUiFontFamily"})||"Arial";}if(!e._themeInfo.sFontStyleInfoStateInverted||t){e._themeInfo.sFontStyleInfoStateInverted="bold "+parseFloat(T.get({name:"sapMFontSmallSize"})||"0.75rem")*B+"px "+e._themeInfo.sFontFamily;}if(!e._themeInfo.sFontStyle||t){e._themeInfo.sFontStyle=parseFloat(T.get({name:"sapMFontMediumSize"})||"0.875rem")*B+"px "+e._themeInfo.sFontFamily;}if(!e._oCtx){e._oCtx=document.createElement("canvas").getContext("2d");}e._oCtx.font=e._themeInfo[this.getInfoStateInverted()?"sFontStyleInfoStateInverted":"sFontStyle"];return Math.ceil(e._oCtx.measureText(this.getInfo()).width)/B;};
e.prototype._getInfoTextMinWidth=function(w){if(this.getInfoStateInverted()&&w<=7.5){return w+0.625+"rem";}if(w<=7.5){return w+"rem";}return"7.5rem";};
e.prototype.ontap=function(E){this._checkExpandCollapse(E);return L.prototype.ontap.apply(this,arguments);};
e.prototype.ontouchstart=function(E){var i=E.target&&E.target.id,s=this.getId();if(i===s+"-titleButton"||i===s+"-descriptionButton"){E.setMarked();}return L.prototype.ontouchstart.apply(this,arguments);};
e.prototype.onsapspace=function(E){this._checkExpandCollapse(E,true);if(!E.isMarked()){return L.prototype.onsapspace.apply(this,arguments);}};
e.prototype._checkExpandCollapse=function(E,p){var t=E.target,i=t&&t.id;if(i&&i===this.getId()+"-titleButton"){if(p){E.preventDefault();}E.setMarked();return this._toggleExpandCollapse("title",this._bTitleTextExpanded);}if(i&&i===this.getId()+"-descriptionButton"){if(p){E.preventDefault();}E.setMarked();return this._toggleExpandCollapse("description",this._bDescriptionTextExpanded);}};
e.prototype._toggleExpandCollapse=function(w,t){var o=this.getDomRef(w+"Text"),f=this.getDomRef(w+"ThreeDots"),B=this.getDomRef(w+"Button"),s=w==="title"?this.getTitle():this.getDescription(),r=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(!t){o.textContent=s;f.textContent=" ";B.textContent=r.getText("TEXT_SHOW_LESS");t=true;}else{o.textContent=this._getCollapsedText(s);f.textContent=" ... ";B.textContent=r.getText("TEXT_SHOW_MORE");t=false;}if(w==="title"){this._bTitleTextExpanded=t;}else{this._bDescriptionTextExpanded=t;}};
e.prototype._getCollapsedText=function(t){return t.substr(0,this._getWrapCharLimit());};
e.prototype._getWrapCharLimit=function(){return this.getWrapCharLimit()||(D.system.phone?100:300);};
e.prototype.onThemeChanged=function(E){L.prototype.onThemeChanged.apply(this,arguments);var t=E.theme;if(!this._initialRender){this._initialRender=true;if(!e._themeInfo){e._themeInfo={};}if(!e._themeInfo.sCurrentTheme){e._themeInfo.sCurrentTheme=t;}return;}var i=this.getDomRef("info");if(i){var w;if(e._themeInfo.sCurrentTheme!==t){e._themeInfo.sCurrentTheme=t;w=this._measureInfoTextWidth(true);}else{w=this._measureInfoTextWidth();}i.style.minWidth=this._getInfoTextMinWidth(w);}};
return e;});
sap.ui.predefine('sap/m/StandardListItemRenderer',["sap/ui/core/library","sap/ui/core/Core","sap/ui/core/Renderer","sap/ui/core/IconPool","sap/ui/Device","./library","./ListItemBaseRenderer"],function(c,C,R,I,D,l,L){"use strict";var T=c.TextDirection;var S=R.extend(L);S.apiVersion=2;
S.renderLIAttributes=function(r,o){var i=o.getIcon(),t=o.getTitle();r.class("sapMSLI");if(i&&!I.isIconURI(i)){r.class("sapMSLIThumbnail");}if(!o.getIconInset()){r.class("sapMSLINoIconInset");}if(t&&o.getDescription()){r.class("sapMSLIWithDescription");}if(t&&!o.getAdaptTitleSize()){r.class("sapMSLINoTitleAdapt");}if(t&&o.getWrapping()){r.class("sapMSLIWrapping");}};
S.renderLIContent=function(r,o){var i=o.getInfo(),t=o.getTitle(),d=o.getDescription(),a=o.getAdaptTitleSize(),s=!t&&i;if(o.getAvatar()){r.renderControl(o._getAvatar());}else if(o.getIcon()){r.renderControl(o._getImage());}r.openStart("div").class("sapMSLIDiv");if((!d&&a&&i)||s){r.class("sapMSLIInfoMiddle");}r.openEnd();this.renderTitleWrapper(r,o);if(t&&d){this.renderDescription(r,o);}if(s&&!o.getWrapping()){this.renderInfo(r,o);}r.close("div");};
S.renderTitleWrapper=function(r,o){var t=o.getTitleTextDirection(),s=o.getTitle(),d=o.getDescription(),i=o.getInfo(),w=o.getWrapping(),b=!s&&i;r.openStart("div");if(!b&&d){r.class("sapMSLITitle");}else{r.class("sapMSLITitleOnly");}if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();if(w){this.renderWrapping(r,o,"title");if(s&&i&&!d){this.renderInfo(r,o);}}else{this.renderTitle(r,o);}r.close("div");if(i&&!d&&!w&&!b){this.renderInfo(r,o);}};
S.renderTitle=function(r,o){r.text(o.getTitle());};
S.renderDescription=function(r,o){var w=o.getWrapping(),d=o.getDescription(),i=o.getInfo();r.openStart("div").class("sapMSLIDescription");if(i){r.class("sapMSLIDescriptionAndInfo");}r.openEnd();if(i){r.openStart("div").class("sapMSLIDescriptionText").openEnd();if(w){this.renderWrapping(r,o,"description");this.renderInfo(r,o);}else{r.text(d);}r.close("div");if(!w){this.renderInfo(r,o);}}else if(w){this.renderWrapping(r,o,"description");}else{r.text(d);}r.close("div");};
S.renderInfo=function(r,o){var i=o.getInfoTextDirection(),b=o.getInfoStateInverted();r.openStart("div",o.getId()+"-info");if(i!==T.Inherit){r.attr("dir",i.toLowerCase());}r.class("sapMSLIInfo");r.class("sapMSLIInfo"+o.getInfoState());if(b){r.class("sapMSLIInfoStateInverted");}var w=o._measureInfoTextWidth();r.style("min-width",o._getInfoTextMinWidth(w));r.openEnd();if(o.getWrapping()&&!b){this.renderWrapping(r,o,"info");}else{r.text(o.getInfo());}r.close("div");};
S.renderExpandCollapse=function(r,o,w){var i=o.getId(),t=w=="title"?true:false,b=t?o._bTitleTextExpanded:o._bDescriptionTextExpanded,a=C.getLibraryResourceBundle("sap.m");r.openStart("span",i+"-"+w+"ThreeDots").openEnd();r.text(b?" ":" ... ");r.close("span");r.openStart("span",t?i+"-titleButton":i+"-descriptionButton").class("sapMSLIExpandCollapse");r.attr("tabindex","0").attr("role","button").attr("aria-live","polite");r.openEnd();r.text(a.getText(b?"TEXT_SHOW_LESS":"TEXT_SHOW_MORE"));r.close("span");};
S.renderWrapping=function(r,o,w){var i=o.getId(),m=o._getWrapCharLimit(),t,b;if(w==="title"){t=o.getTitle();b=o._bTitleTextExpanded;}else if(w==="description"){t=o.getDescription();b=o._bDescriptionTextExpanded;}else{t=o.getInfo();}r.openStart("span",i+"-"+w+"Text").attr("aria-live","polite").openEnd();if(!b&&w!=="info"){var s=o._getCollapsedText(t);r.text(s);}else if(w=="title"){this.renderTitle(r,o);}else{r.text(t);}r.close("span");if(t.length>m&&w!=="info"){this.renderExpandCollapse(r,o,w);}};
return S;},true);
sap.ui.predefine('sap/m/StandardTile',['./Tile','./library','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','./StandardTileRenderer'],function(T,l,I,c,D,S){"use strict";var a=l.ImageHelper;var b=l.StandardTileType;var V=c.ValueState;
var d=T.extend("sap.m.StandardTile",{metadata:{library:"sap.m",deprecated:true,properties:{title:{type:"string",group:"Misc",defaultValue:null},info:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},infoState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},type:{type:"sap.m.StandardTileType",group:"Misc",defaultValue:b.None},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}}}});
d.prototype.exit=function(){if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}};
d.prototype.ontap=function(){T.prototype.ontap.apply(this,arguments);};
d.prototype.getIcon=function(){if(!this.getProperty("icon")&&this.getType()==="Create"){return I.getIconURI("add");}else{return this.getProperty("icon");}};
d.prototype._getImage=function(){var i=this.getId()+"-img";var s=D.system.phone?"1.3rem":"2rem";var p={src:this.getIcon(),height:s,width:s,size:s,densityAware:this.getIconDensityAware(),useIconTooltip:false};this._oImageControl=a.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
return d;});
sap.ui.predefine('sap/m/StandardTileRenderer',['./TileRenderer','sap/ui/core/ValueStateSupport','sap/ui/core/Renderer','sap/m/library','sap/ui/core/library'],function(T,V,R,l,c){"use strict";var a=c.ValueState;var S=l.StandardTileType;var b=R.extend(T);b.apiVersion=2;
b._renderContent=function(r,t){var i=t.getInfoState();r.openStart("div");r.class("sapMStdTileTopRow");r.openEnd();if(t.getIcon()){r.openStart("div");r.class("sapMStdTileIconDiv");switch(t.getType()){case S.Monitor:r.class("sapMStdIconMonitor");break;case S.Create:r.class("sapMStdIconCreate");break;}r.openEnd();r.renderControl(t._getImage());r.close("div");}if(t.getNumber()){r.openStart("div");r.class("sapMStdTileNumDiv");r.openEnd();r.openStart("div",t.getId()+"-number");var n=t.getNumber().length;if(n<5){r.class("sapMStdTileNum");}else if(n<8){r.class("sapMStdTileNumM");}else{r.class("sapMStdTileNumS");}r.openEnd();r.text(t.getNumber());r.close("div");if(t.getNumberUnit()){r.openStart("div",t.getId()+"-numberUnit");r.class("sapMStdTileNumUnit");r.openEnd();r.text(t.getNumberUnit());r.close("div");}r.close("div");}r.close("div");r.openStart("div");r.class("sapMStdTileBottomRow");if(t.getType()===S.Monitor){r.class("sapMStdTileMonitorType");}r.openEnd();r.openStart("div",t.getId()+"-title");r.class("sapMStdTileTitle");r.openEnd();if(t.getTitle()){r.text(t.getTitle());}r.close("div");if(t.getInfo()){r.openStart("div",t.getId()+"-info");r.class("sapMStdTileInfo");r.class("sapMStdTileInfo"+i);if(i!=a.None){r.accessibilityState(t,{ariaDescribedBy:{value:t.getId()+"-sapSRH",append:true}});}r.openEnd();if(t.getInfo()){r.text(t.getInfo());}r.close("div");}if(i!=a.None){r.openStart("span",t.getId()+"-sapSRH");r.class("sapUiInvisibleText");r.accessibilityState({hidden:false});r.openEnd();r.text(V.getAdditionalText(i));r.close("span");}r.close("div");};
return b;},true);
sap.ui.predefine('sap/m/StandardTreeItem',['./TreeItemBase','./library','sap/ui/core/IconPool','./Image','./StandardTreeItemRenderer'],function(T,l,I,a,S){"use strict";
var b=T.extend("sap.m.StandardTreeItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null}}}});
b.prototype._getIconControl=function(){var u=this.getIcon();if(this._oIconControl){this._oIconControl.setSrc(u);return this._oIconControl;}this._oIconControl=I.createControlByURI({id:this.getId()+"-icon",src:u,useIconTooltip:false,noTabStop:true},a).setParent(this,null,true).addStyleClass("sapMSTIIcon");return this._oIconControl;};
b.prototype.getContentAnnouncement=function(){return this.getTitle();};
b.prototype.exit=function(){T.prototype.exit.apply(this,arguments);this.destroyControls(["Icon"]);};
b.prototype.setIcon=function(i){var o=this.getIcon();this.setProperty("icon",i);if(this._oIconControl&&(!i||I.isIconURI(i)!=I.isIconURI(o))){this._oIconControl.destroy("KeepDom");this._oIconControl=undefined;}return this;};
return b;});
sap.ui.predefine('sap/m/StandardTreeItemRenderer',["./TreeItemBaseRenderer","sap/ui/core/Renderer"],function(T,R){"use strict";var S=R.extend(T);S.apiVersion=2;
S.renderLIContent=function(r,l){if(l.getIcon()){r.renderControl(l._getIconControl());}r.text(l.getTitle());};
S.renderLIAttributes=function(r,l){T.renderLIAttributes.apply(this,arguments);r.class("sapMSTI");};
return S;},true);
sap.ui.predefine('sap/m/StepInput',["sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/core/message/MessageMixin","sap/ui/core/format/NumberFormat","sap/ui/model/ValidateException","sap/ui/Device","sap/ui/core/library","sap/m/library","./NumericInput","./StepInputRenderer","sap/ui/events/KeyCodes","sap/base/Log"],function(C,I,M,N,V,D,c,l,a,S,K,L){"use strict";var T=c.TextAlign;var b=c.ValueState;var d=l.StepInputValidationMode;var f=l.StepInputStepModeType;
var g=C.extend("sap.m.StepInput",{
metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/StepInput.designtime",properties:{min:{type:"float",group:"Data"},max:{type:"float",group:"Data"},step:{type:"float",group:"Data",defaultValue:1},stepMode:{type:"sap.m.StepInputStepModeType",group:"Data",defaultValue:f.AdditionAndSubtraction},largerStep:{type:"float",group:"Data",defaultValue:2},value:{type:"float",group:"Data",defaultValue:0},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},required:{type:"boolean",group:"Misc",defaultValue:false},width:{type:"sap.ui.core.CSSSize",group:"Dimension"},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:b.None},valueStateText:{type:"string",group:"Misc",defaultValue:null},editable:{type:"boolean",group:"Behavior",defaultValue:true},enabled:{type:"boolean",group:"Behavior",defaultValue:true},displayValuePrecision:{type:"int",group:"Data",defaultValue:0},description:{type:"string",group:"Misc",defaultValue:null},fieldWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'50%'},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.End},validationMode:{type:"sap.m.StepInputValidationMode",group:"Misc",defaultValue:d.FocusOut}},aggregations:{_input:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{change:{parameters:{value:{type:"string"}}}},dnd:{draggable:false,droppable:true}},
constructor:function(i,s){C.prototype.constructor.apply(this,arguments);if(this.getEditable()){this._getOrCreateDecrementButton();this._getOrCreateIncrementButton();}if(typeof i!=="string"){s=i;}if(s&&s.value===undefined){this.setValue(this._getDefaultValue(undefined,s.max,s.min));}}
});
var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");g.STEP_INPUT_INCREASE_BTN_TOOLTIP=o.getText("STEP_INPUT_INCREASE_BTN");g.STEP_INPUT_DECREASE_BTN_TOOLTIP=o.getText("STEP_INPUT_DECREASE_BTN");g.INITIAL_WAIT_TIMEOUT=500;g.ACCELLERATION=0.8;g.MIN_WAIT_TIMEOUT=50;g.INITIAL_SPEED=120;g._TOLERANCE=10;var F=["enabled","editable","name","placeholder","required","valueStateText","description","fieldWidth","textAlign"];M.call(g.prototype);
g.prototype.init=function(){this._iRealPrecision=0;this._attachChange();this._bPaste=false;this._bNeedsVerification=false;this._bValueStatePreset=true;this._onmousewheel=this._onmousewheel.bind(this);window.addEventListener("contextmenu",function(e){if(this._btndown===false&&e.target.className.indexOf("sapMInputBaseIconContainer")!==-1){e.preventDefault();}}.bind(this));};
g.prototype.onBeforeRendering=function(){var m=this._getMin(),e=this._getMax(),v=this._sOriginalValue||this.getValue(),E=this.getEditable();this._iRealPrecision=this._getRealValuePrecision();this._getInput().setValue(this._getFormattedValue(v));this._getInput().setValueState(this.getValueState());this._getInput().setTooltip(this.getTooltip());this._getOrCreateDecrementButton().setVisible(E);this._getOrCreateIncrementButton().setVisible(E);this._disableButtons(v,e,m);this.$().off(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);if(this._bNeedsVerification&&!this._bValueStatePreset){this._verifyValue();this._bNeedsVerification=false;}};
g.prototype.onAfterRendering=function(){this.$().on(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);};
g.prototype.exit=function(){this.$().off(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);this._sOriginalValue=null;};
g.prototype.setProperty=function(p,v,s){C.prototype.setProperty.call(this,p,v,s);if(F.indexOf(p)>-1){this._getInput().setProperty(p,this.getProperty(p),s);}return this;};
g.prototype.setValidationMode=function(v){if(this.getValidationMode()!==v){switch(v){case d.FocusOut:this._detachLiveChange();break;case d.LiveChange:this._attachLiveChange();break;}this.setProperty("validationMode",v);}return this;};
g.prototype.setMin=function(m){if(m!==undefined&&!this._validateOptionalNumberProperty("min",m)){return this;}return this.setProperty("min",m);};
g.prototype.setMax=function(m){if(m!==undefined&&!this._validateOptionalNumberProperty("max",m)){return this;}return this.setProperty("max",m);};
g.prototype._validateOptionalNumberProperty=function(n,v){if(this._isNumericLike(v)){return true;}L.error("The value of property '"+n+"' must be a number");return false;};
g.prototype.setDisplayValuePrecision=function(n){var v,i;if(h(n)){v=parseInt(n);}else{v=0;L.warning(this+": ValuePrecision ("+n+") is not correct. It should be a number between 0 and 20! Setting the default ValuePrecision:0.");}var i=this.setProperty("displayValuePrecision",v);this._getNumberFormatter(true);return i;};
g.prototype._getIncrementButton=function(){var e=this._getInput().getAggregation("_endIcon")||[];var i=null;if(e.length){i=e[e.length-1];}return i;};
g.prototype._getDecrementButton=function(){var e=this._getInput().getAggregation("_beginIcon");return e?e[0]:null;};
g.prototype._createIncrementButton=function(){var i=this._getInput().addEndIcon({src:I.getIconURI("add"),id:this.getId()+"-incrementBtn",noTabStop:true,decorative:false,press:this._handleButtonPress.bind(this,1),tooltip:g.STEP_INPUT_INCREASE_BTN_TOOLTIP});i.getEnabled=function(){return!this._shouldDisableIncrementButton(this._parseNumber(this._getInput().getValue()),this._getMax());}.bind(this);i.$().attr("tabindex","-1");this._attachEvents(i,true);i.addEventDelegate({onAfterRendering:function(){i.$().attr("tabindex","-1");}});return i;};
g.prototype._createDecrementButton=function(){var i=this._getInput().addBeginIcon({src:I.getIconURI("less"),id:this.getId()+"-decrementBtn",noTabStop:true,decorative:false,press:this._handleButtonPress.bind(this,-1),tooltip:g.STEP_INPUT_DECREASE_BTN_TOOLTIP});i.getEnabled=function(){return!this._shouldDisableDecrementButton(this._parseNumber(this._getInput().getValue()),this._getMin());}.bind(this);i.$().attr("tabindex","-1");this._attachEvents(i,false);i.addEventDelegate({onAfterRendering:function(){i.$().attr("tabindex","-1");}});return i;};
g.prototype._getInput=function(){if(!this.getAggregation("_input")){var n=new a({id:this.getId()+"-input",textAlign:this.getTextAlign(),editable:this.getEditable(),enabled:this.getEnabled(),description:this.getDescription(),fieldWidth:this.getFieldWidth(),liveChange:this._inputLiveChangeHandler});this.setAggregation("_input",n);}return this.getAggregation("_input");};
g.prototype._changeValue=function(e){if((this._fTempValue!=this._fOldValue)||e){this.setValue(this._fTempValue);this.fireChange({value:this._fTempValue});}else{this._applyValue(this._fTempValue);this._disableButtons(this._parseNumber(this._getInput().getValue()),this._getMax(),this._getMin());}return this;};
g.prototype._handleButtonPress=function(m){if(!this._bSpinStarted){this._bDelayedEventFire=false;this._changeValueWithStep(m);this._btndown=false;this._changeValue();}else{this._bSpinStarted=false;}this._bNeedsVerification=true;return this;};
g.prototype._changeValueWithStep=function(m){var n,e;if(isNaN(this._fTempValue)||this._fTempValue===undefined){this._fTempValue=this.getValue();}e=this._checkInputValue();this._fTempValue+=e;n=m!==0?this._calculateNewValue(m):this._fTempValue;if(m!==0||e!==0||this._bDelayedEventFire){this._fTempValue=n;}if(this._bDelayedEventFire){this._applyValue(n);this._disableButtons(this._parseNumber(this._getFormattedValue(n)),this._getMax(),this._getMin());this._bNeedsVerification=true;}return this;};
g.prototype._disableButtons=function(v,m,i){if(!this._isNumericLike(v)){return;}var e=this._getIncrementButton(),j=this._getDecrementButton(),s=this._shouldDisableDecrementButton(v,i),k=this._shouldDisableIncrementButton(v,m);j&&j.toggleStyleClass("sapMStepInputIconDisabled",s);e&&e.toggleStyleClass("sapMStepInputIconDisabled",k);return this;};
g.prototype._shouldDisableDecrementButton=function(v,m){var e=this._isNumericLike(m),E=this.getEnabled(),r=e&&m>=v;return E?r:true;};
g.prototype._shouldDisableIncrementButton=function(v,m){var e=this._isNumericLike(m),E=this.getEnabled(),r=e&&m<=v;return E?r:true;};
g.prototype._verifyValue=function(){var m=this._getMin(),e=this._getMax(),v=this._parseNumber(this._getInput().getValue()),i=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core"),B=this.getBinding("value"),j=B&&B.getType&&B.getType(),s=j&&j.oConstraints&&j.oConstraints.maximum,k=j&&j.oConstraints&&j.oConstraints.minimum,n,p=[],H=false,E;if(!this._isNumericLike(v)){return;}E=this;do{H=E.hasListeners("validationError");E=E.getEventingParent();}while(E&&!H);if(this._isMoreThanMax(v)){if(H&&s){return;}n=i.getText("EnterNumberMax",[e]);p.push("maximum");}else if(this._isLessThanMin(v)){if(H&&k){return;}n=i.getText("EnterNumberMin",[m]);p.push("minimum");}else if(this._areFoldChangeRequirementsFulfilled()&&(v%this.getStep()!==0)){n=i.getText("Float.Invalid");}if(n){this.setProperty("valueState",b.Error,true);this._getInput().setValueState(b.Error);this._getInput().setValueStateText(n);if(H){this.fireValidationError({element:this,exception:new V(n,p),id:this.getId(),message:n,property:"value"});}}else{this.setProperty("valueState",b.None,true);this._getInput().setValueState(b.None);}};
g.prototype.setValueState=function(v){this._bValueStatePreset=true;this.setProperty("valueState",v);this._getInput().setValueState(v);return this;};
g.prototype.setValue=function(v){var r;if(isNaN(v)||v===null){v=this._getDefaultValue(undefined,this._getMax(),this._getMin());}else{v=Number(v);}if(!this._validateOptionalNumberProperty("value",v)){return this;}this._sOriginalValue=v;this._applyValue(v);this._disableButtons(this._parseNumber(this._getInput().getValue()),this._getMax(),this._getMin());if(v!==this._fOldValue){this._fOldValue=v;r=this.setProperty("value",v);}else{r=this;}this._iRealPrecision=this._getRealValuePrecision();this._fTempValue=v;this._bValueStatePreset=false;return r;};
g.prototype._getNumberFormatter=function(r){if(!this._formatter||r){this._formatter=N.getFloatInstance({decimals:this.getDisplayValuePrecision()});}return this._formatter;};
g.prototype._getFormattedValue=function(v){var p=this.getDisplayValuePrecision(),i,s;if(v==undefined){v=this.getValue();}if(D.system.desktop){return this._getNumberFormatter().format(v);}if(p<=0){return parseFloat(v).toFixed(0);}s=v.toString().split(".");if(s.length===2){i=s[1].length;if(i>p){return parseFloat(v).toFixed(p);}return s[0]+"."+this._padZeroesRight(s[1],p);}else{return v.toString()+"."+this._padZeroesRight("0",p);}};
g.prototype._padZeroesRight=function(v,p){var r="",e=v.length;for(var i=e;i<p;i++){r=r+"0";}r=v+r;return r;};
g.prototype._checkInputValue=function(){var i=this._getInput().getValue(),e=0;if(i===""){i=this._getDefaultValue(i,this._getMax(),this._getMin()).toString();}if(this.getDisplayValuePrecision()===0){i=Math.round(this._parseNumber(i.toLowerCase().split('e')[0])).toString();}if(this._getFormattedValue(this._fTempValue)!==i){e=this._parseNumber(i)-this._fTempValue;}return e;};
g.prototype.onsappageup=function(e){e.preventDefault();if(this.getEditable()){this._bDelayedEventFire=true;this._changeValueWithStep(this.getLargerStep());}};
g.prototype.onsappagedown=function(e){e.preventDefault();if(this.getEditable()){this._bDelayedEventFire=true;this._changeValueWithStep(-this.getLargerStep());}};
g.prototype.onsappageupmodifiers=function(e){if(this.getEditable()&&this._isNumericLike(this._getMax())&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){this._bDelayedEventFire=true;this._fTempValue=this._parseNumber(this._getInput().getValue());this._changeValueWithStep(this._getMax()-this._fTempValue);}};
g.prototype.onsappagedownmodifiers=function(e){if(this.getEditable()&&this._isNumericLike(this._getMin())&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){this._bDelayedEventFire=true;this._fTempValue=this._parseNumber(this._getInput().getValue());this._changeValueWithStep(-(this._fTempValue-this._getMin()));}};
g.prototype.onsapup=function(e){e.preventDefault();if(this.getEditable()){this._bDelayedEventFire=true;this._changeValueWithStep(1);e.setMarked();}};
g.prototype.onsapdown=function(e){e.preventDefault();if(this.getEditable()){this._bDelayedEventFire=true;this._changeValueWithStep(-1);e.setMarked();}};
g.prototype._onmousewheel=function(e){var i=this.getDomRef().contains(document.activeElement);if(i&&this.getEditable()&&this.getEnabled()){e.preventDefault();var O=e.originalEvent,j=O.detail?(-O.detail>0):(O.wheelDelta>0);this._bDelayedEventFire=true;this._changeValueWithStep((j?1:-1));}};
g.prototype.onkeydown=function(e){var s,m,i;if(!this.getEditable()){return;}if(e.which===K.ENTER&&this._fTempValue!==this.getValue()){e.preventDefault();this._changeValue();return;}this._bPaste=(e.ctrlKey||e.metaKey)&&(e.which===K.V);if(e.which===K.ARROW_UP&&!e.altKey&&e.shiftKey&&(e.ctrlKey||e.metaKey)){m=this._getMax();this._fTempValue=this._parseNumber(this._getInput().getValue());s=(m!==undefined)?m-this._fTempValue:0;}else if(e.which===K.ARROW_DOWN&&!e.altKey&&e.shiftKey&&(e.ctrlKey||e.metaKey)){i=this._getMin();this._fTempValue=this._parseNumber(this._getInput().getValue());s=(i!==undefined)?-(this._fTempValue-i):0;}else if(e.which===K.ARROW_UP&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){s=this.getLargerStep();}else if(e.which===K.ARROW_DOWN&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){s=-this.getLargerStep();}else if(e.which===K.ARROW_UP&&(e.ctrlKey||e.metaKey)){s=1;}else if(e.which===K.ARROW_DOWN&&(e.ctrlKey||e.metaKey)){s=-1;}else if(e.which===K.ARROW_UP&&e.altKey){s=1;}else if(e.which===K.ARROW_DOWN&&e.altKey){s=-1;}if(s!==undefined){e.preventDefault();if(s!==0){this._bDelayedEventFire=true;this._changeValueWithStep(s);}}};
g.prototype.onsapescape=function(e){if(this._fOldValue!==this._fTempValue){this._applyValue(this._fOldValue);this._bNeedsVerification=true;}};
g.prototype._attachLiveChange=function(){this._getInput().attachLiveChange(this._liveChange,this);};
g.prototype._detachLiveChange=function(){this._getInput().detachLiveChange(this._liveChange,this);};
g.prototype._attachChange=function(){this._getInput().attachChange(this._change,this);};
g.prototype._liveChange=function(){this._disableButtons(this._parseNumber(this._getInput().getValue()),this._getMax(),this._getMin());this._verifyValue();};
g.prototype._change=function(e){var O;var n=this._getInput().getValue();var i=this._isLessThanMin(n)||this._isMoreThanMax(n);if(!this._isButtonFocused()){if(!this._btndown||i){O=this._parseNumber(this._getFormattedValue());if(this._fOldValue===undefined){this._fOldValue=O;}this._bDelayedEventFire=false;this._changeValueWithStep(0);this._changeValue();this._bNeedsVerification=true;}else{this._fTempValue=this._parseNumber(this._getInput().getValue());}}};
g.prototype._isMoreThanMax=function(v){return this._isNumericLike(this._getMax())&&this._getMax()<v;};
g.prototype._isLessThanMin=function(v){return this._isNumericLike(this._getMin())&&this._getMin()>v;};
g.prototype._applyValue=function(n){this._getInput().setValue(this._getFormattedValue(n));};
g.prototype._calculateNewValue=function(s,i){if(i===undefined){i=s<0?false:true;}var e=this.getStep(),m=this._getMax(),j=this._getMin(),k=parseFloat(this._getDefaultValue(this._getInput().getValue(),m,j)),n=i?1:-1,p=Math.abs(e)*Math.abs(s),r=k+n*p,v;if(this._areFoldChangeRequirementsFulfilled()){r=v=this._calculateClosestFoldValue(k,p,n);}else{v=this._sumValues(this._fTempValue,p,n,this._iRealPrecision);}if(this._isNumericLike(m)&&r>=m){v=m;}if(this._isNumericLike(j)&&r<=j){v=j;}return v;};
g.prototype._getRealValuePrecision=function(){var s=this.getValue().toString().split("."),e=this.getStep().toString().split("."),i,j;i=(!s[1])?0:s[1].length;j=(!e[1])?0:e[1].length;return(i>j)?i:j;};
g.prototype._getOrCreateDecrementButton=function(){return this._getDecrementButton()||this._createDecrementButton();};
g.prototype._getOrCreateIncrementButton=function(){return this._getIncrementButton()||this._createIncrementButton();};
g.prototype._inputLiveChangeHandler=function(e){var v=this.getParent()._restrictCharsWhenDecimal(e);this.setProperty("value",v?v:e.getParameter("newValue"),true);};
g.prototype._restrictCharsWhenDecimal=function(e){var s=D.system.desktop?this._getNumberFormatter().oFormatOptions.decimalSeparator:".";var i=e.getParameter("value").indexOf(s),j=this.getDisplayValuePrecision(),E=e.getParameter("value"),v;if(i>0&&j>=0){var k=E.split(s)[1],m=k?k.length:0,n=E.split(s)[0],p=j>0?E.substring(E.indexOf(s)+1,E.length):'';if(!this._bPaste){if(m>j){v=n+(j>0?s+p.substr(0,j):'');this._showWrongValueVisualEffect();}}else{if(E.indexOf(s)){v=E.split(s)[0]+(j>0?s+k.substring(0,j):'');}this._bPaste=false;}}else{v=E;}if(this._getInput()._getInputValue()!==v){this._getInput().updateDomValue(v);}return v;};
g.prototype._showWrongValueVisualEffect=function(){var O=this.getValueState(),i=this._getInput();if(O===b.Error){return;}i.setValueState(b.Error);setTimeout(i["setValueState"].bind(i,O),1000);};
g.prototype._getDefaultValue=function(v,m,e){if(v!==""&&v!==undefined){return this._parseNumber(this._getInput().getValue());}if(this._isNumericLike(e)&&e>0){return e;}else if(this._isNumericLike(m)&&m<0){return m;}else{return 0;}};
g.prototype._isNumericLike=function(v){return!isNaN(v)&&v!==null&&v!=="";};
g.prototype._isInteger=function(v){return v===parseInt(v);};
g.prototype._isButtonFocused=function(){return document.activeElement===this._getIncrementButton().getDomRef()||document.activeElement===this._getDecrementButton().getDomRef();};
g.prototype._sumValues=function(v,e,s,p){var P=Math.pow(10,p),i=parseInt((v*P).toFixed(1)),j=parseInt((e*P).toFixed(1));return(i+(s*j))/P;};
g.prototype._areFoldChangeRequirementsFulfilled=function(){return this.getStepMode()===f.Multiple&&this.getDisplayValuePrecision()===0&&this._isInteger(this.getStep())&&this._isInteger(this.getLargerStep());};
g.prototype._calculateClosestFoldValue=function(v,s,i){var r=Math.floor(v),e=s;do{r+=i;e--;}while(r%s!==0&&e);if(r%s!==0){L.error("Wrong next/previous value "+r+" for "+v+", step: "+s+" and sign: "+i,this);}return r;};
function h(v){return(typeof(v)==='number')&&!isNaN(v)&&v>=0&&v<=20;}
g.prototype._calcWaitTimeout=function(){this._speed*=g.ACCELLERATION;this._waitTimeout=((this._waitTimeout-this._speed)<g.MIN_WAIT_TIMEOUT?g.MIN_WAIT_TIMEOUT:(this._waitTimeout-this._speed));return this._waitTimeout;};
g.prototype._spinValues=function(i){this._spinTimeoutId=setTimeout(function(){if(this._btndown){this._bSpinStarted=true;this._bDelayedEventFire=true;this._changeValueWithStep(i?1:-1);this._disableButtons(this._parseNumber(this._getInput().getValue()),this._getMax(),this._getMin());if((this._getIncrementButton().getEnabled()&&i)||(this._getDecrementButton().getEnabled()&&!i)){this._spinValues(i);}}}.bind(this),this._calcWaitTimeout());};
g.prototype._attachEvents=function(B,i){var e={onmousedown:function(E){if(E.button===0&&!this._btndown){this._btndown=true;this._waitTimeout=g.INITIAL_WAIT_TIMEOUT;this._speed=g.INITIAL_SPEED;this._spinValues(i);}}.bind(this),onmouseup:function(E){if(E.button===0){this._bDelayedEventFire=undefined;this._btndown=false;this._stopSpin();}}.bind(this),onmouseout:function(E){if(this._btndown){this._bDelayedEventFire=undefined;this._stopSpin();}}.bind(this),oncontextmenu:function(E){E.stopImmediatePropagation(true);if(E.originalEvent&&E.originalEvent.cancelable){E.preventDefault();}E.stopPropagation();},ontouchend:function(E){if(D.system.phone||D.system.tablet){this._bDelayedEventFire=undefined;this._btndown=false;this._stopSpin();}if(E.originalEvent&&E.originalEvent.cancelable){E.preventDefault();}if(i){this._getIncrementButton().invalidate();}else{this._getDecrementButton().invalidate();}}.bind(this)};B.addDelegate(e,true);};
g.prototype._stopSpin=function(){this._resetSpinValues();if(this._bSpinStarted){this._changeValue();}};
g.prototype._getMin=function(){var B=this.getBinding("value"),e=B&&B.getType&&B.getType(),s=e&&e.oConstraints&&e.oConstraints.minimum;return s?parseFloat(s):this.getMin();};
g.prototype._getMax=function(){var B=this.getBinding("value"),e=B&&B.getType&&B.getType(),s=e&&e.oConstraints&&e.oConstraints.maximum;return s?parseFloat(s):this.getMax();};
g.prototype.getIdForLabel=function(){return this._getInput().getIdForLabel();};
g.prototype.onfocusout=function(e){if(!this._btndown){this._changeValueWithStep(0);if(this._bDelayedEventFire&&(this._fTempValue)!==this._fOldValue){this._bDelayedEventFire=undefined;this._changeValue();}}};
g.prototype.getFocusDomRef=function(){return this.getAggregation("_input").getFocusDomRef();};
g.prototype._resetSpinValues=function(){clearTimeout(this._spinTimeoutId);this._waitTimeout=500;this._speed=120;};
g.prototype.getAccessibilityInfo=function(){return{type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_STEPINPUT"),description:this.getValue()||"",focusable:this.getEnabled(),enabled:this.getEnabled(),editable:this.getEnabled()&&this.getEditable()};};
g.prototype._parseNumber=function(v){if(D.system.desktop){return this._getNumberFormatter().parse(v);}return Number(v);};
return g;});
sap.ui.predefine('sap/m/StepInputRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,c){var i=c._getInput(),w=c.getWidth(),e=c.getEnabled(),E=c.getEditable(),v=c.getValueState();r.openStart("div",c);r.style("width",w);r.class("sapMStepInput");r.class("sapMStepInput-CTX");!e&&r.class("sapMStepInputReadOnly");!E&&r.class("sapMStepInputNotEditable");if(v==="Error"||v==="Warning"){r.class("sapMStepInput"+v);}r.openEnd();r.renderControl(i);r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/Suggest',["./Toolbar","./Button","./Dialog","./Popover","./SuggestionsList","./SuggestionItem","sap/ui/Device","sap/m/library","sap/ui/core/Core","sap/ui/core/InvisibleText"],function(T,B,D,P,S,a,b,l,C,I){"use strict";var c=l.PlacementType;
function d(i){var p=i,e,f,g,u=b.system.phone,s=this;function o(E){var n=E.srcControl;var v;if(n instanceof a){v=n.getSuggestionText();s._suggestionItemTapped=true;e.close();window.setTimeout(function(){i._updateValue(v);i._fireChangeEvent();i.fireSearch({query:v,suggestionItem:n,refreshButtonPressed:false,clearButtonPressed:false});},0);}}function h(){var n,q,r,t,v,w;r=new(sap.ui.require('sap/m/SearchField'))({liveChange:function(E){var x=E.getParameter("newValue");i._updateValue(x);i.fireLiveChange({newValue:x});i.fireSuggest({suggestValue:x});s.update();},search:function(E){if(!E.getParameter("clearButtonPressed")){n.close();}}});w=new B({icon:"sap-icon://decline",press:function(){s._cancelButtonTapped=true;n._oCloseTrigger=true;n.close();i._updateValue(q);}});t=new T({content:[r,w]});v=new B({text:C.getLibraryResourceBundle("sap.m").getText("MSGBOX_OK"),press:function(){n.close();}});n=new D({stretch:true,customHeader:t,content:k(),beginButton:v,beforeClose:function(){i._bSuggestionSuppressed=true;},beforeOpen:function(){q=i.getValue();r._updateValue(q);},afterClose:function(E){if(!s._cancelButtonTapped&&!s._suggestionItemTapped){i._fireChangeEvent();i.fireSearch({query:i.getValue(),refreshButtonPressed:false,clearButtonPressed:false});}}});n.addEventDelegate({ontap:o},i);return n;}function j(){var n=s._oPopover=new P({showArrow:false,showHeader:false,horizontalScrolling:false,placement:c.Vertical,offsetX:0,offsetY:0,initialFocus:p,bounce:false,ariaLabelledBy:I.getStaticId("sap.m","INPUT_AVALIABLE_VALUES"),afterOpen:function(){i._applySuggestionAcc();},beforeClose:function(){i.$("I").removeAttr("aria-activedescendant");i.$("SuggDescr").text("");},content:k()}).addStyleClass("sapMSltPicker").addStyleClass("sapMSltPicker-CTX");n.open=function(){return this.openBy(p);};n.addEventDelegate({onAfterRendering:s.setPopoverMinWidth.bind(s),ontap:o},i);return n;}function k(){if(!f){f=new S({parentInput:p});}return f;}function m(){if(e===undefined){e=u?h():j();}return e;}this.setPopoverMinWidth=function(){var n=s._oPopover.getDomRef();if(n){var w=(i.$().outerWidth()/parseFloat(l.BaseFontSize))+"rem";n.style.minWidth=w;}};this.destroy=function(){if(e){e.close();e.destroy();e=null;}if(f){f.destroy();f=null;}};this.close=function(){if(!u&&this.isOpen()){e.close();}};this.open=function(){if(!this.isOpen()){this.setSelected(-1);this._suggestionItemTapped=false;this._cancelButtonTapped=false;m().open();}};this.update=function(){var f=k();window.clearTimeout(g);if(this.isOpen()){g=window.setTimeout(f.update.bind(f),50);i._applySuggestionAcc();}};this.isOpen=function(){return!!e&&e.isOpen();};this.getSelected=function(){return k().getSelectedItemIndex();};this.setSelected=function(n,r){return k().selectByIndex(n,r);};}
return d;},true);
sap.ui.predefine('sap/m/SuggestionItem',['./library','sap/ui/core/Item','sap/ui/core/IconPool'],function(l,I,a){"use strict";
var S=I.extend("sap.m.SuggestionItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:""},enabled:{type:"boolean",group:"Misc",defaultValue:true,visibility:"hidden"},description:{type:"string",group:"Data",defaultValue:""}}}});
a.insertFontFaceStyle();
function r(R,t,s){var i;if(t){i=t.toUpperCase().indexOf(s.toUpperCase());if(i>-1){R.text(t.slice(0,i));R.openStart("b").openEnd();R.text(t.slice(i,i+s.length));R.close("b");t=t.substring(i+s.length);}R.text(t);}}
S.prototype.render=function(R,i,s,b){var t=i.getText(),c=i.getIcon(),d="",D=i.getDescription(),p=i.getParent(),e=p&&p.getSuggestionItems&&p.getSuggestionItems()||[],f=e.indexOf(i),s=s||"";R.openStart("li",i).class("sapMSuLI").class("sapMSelectListItem").class("sapMSelectListItemBase").class("sapMSelectListItemBaseHoverable");R.accessibilityState({role:"option",posinset:f+1,setsize:e.length,selected:b});if(b){R.class("sapMSelectListItemBaseSelected");if(p){p.$("I").attr("aria-activedescendant",i.getId());}}R.openEnd();if(c){R.icon(c,"sapMSuggestionItemIcon");}if(t){r(R,t,s);d=" ";}if(D){R.text(d);R.openStart("i").openEnd();r(R,D,s);R.close("i");}R.close("li");};
S.prototype.getSuggestionText=function(){return this.getText();};
return S;});
sap.ui.predefine('sap/m/SuggestionsList',['./library','./SuggestionsListRenderer','sap/ui/core/Control'],function(l,S,C){"use strict";
var a=C.extend("sap.m.SuggestionsList",{
metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"}},associations:{parentInput:{type:"sap.ui.core.Control",multiple:false,singularName:"parentInput"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}},
renderer:S
});
a.prototype.init=function(){this._iSelectedItem=-1;};
a.prototype.onBeforeRendering=function(){this.$().off();};
a.prototype.onAfterRendering=function(){this.$().on("mousedown",function(e){e.preventDefault();});};
a.prototype.getItems=function(){try{return sap.ui.getCore().byId(this.getParentInput()).getSuggestionItems();}catch(e){return[];}};
a.prototype.update=function(){var r;var d=this.getDomRef();if(d){r=sap.ui.getCore().createRenderManager();this.getRenderer().renderItems(r,this);r.flush(d);r.destroy();}return this;};
a.prototype.selectByIndex=function(i,r){var b=this.getItems();var c;var d;var e;var p=sap.ui.getCore().byId(this.getParentInput());var f="aria-activedescendant";if(isNaN(parseInt(i))){i=-1;r=false;}if((!b.length)||(r&&i===0)||(!r&&i<0)){c=-1;}else{if(r){if(this._iSelectedItem<0){c=(i<0?b.length:-1)+i;}else{c=this._iSelectedItem+i;}}else{c=i;}c=Math.min(Math.max(c,0),b.length-1);}this._iSelectedItem=c;if(b.length){this.$().children("li").removeClass("sapMSelectListItemBaseSelected").attr("aria-selected","false").eq(c).addClass("sapMSelectListItemBaseSelected").attr("aria-selected","true");}if(p){if(c>=0){d=p.getSuggestionItems()[c];if(d){e=d.getId();this._scrollToItem(d);}}if(e){p.$("I").attr(f,e);}else{p.$("I").removeAttr(f);p.$("SuggDescr").text("");}}return this._iSelectedItem;};
a.prototype._scrollToItem=function(i){var p=this.getParent().$().find(".sapMPopoverCont")[0],P,I,t,b;if(!i||!i.getDomRef()||!p){return;}I=i.getDomRef().getBoundingClientRect();P=p.getBoundingClientRect();t=P.top-I.top;b=I.bottom-P.bottom;if(t>0){p.scrollTop=Math.max(p.scrollTop-t,0);}else if(b>0){p.scrollTop=p.scrollTop+b;}};
a.prototype.getSelectedItemIndex=function(){return this._iSelectedItem;};
return a;});
sap.ui.predefine('sap/m/SuggestionsListRenderer',["sap/ui/core/Core"],function(C){"use strict";var S={apiVersion:2};
S.render=function(r,s){r.openStart("ul",s).class("sapMSuL").class("sapMSelectList").style("width",s.getWidth()).style("max-width",s.getMaxWidth());r.accessibilityState({role:"listbox",multiselectable:false});r.openEnd();this.renderItems(r,s);r.close("ul");};
S.renderItems=function(r,l){var s;var a=l.getSelectedItemIndex();try{s=C.byId(l.getParentInput()).getValue();}catch(e){s="";}l.getItems().forEach(function(i,b){i.render(r,i,s,b===a);});};
return S;});
sap.ui.predefine('sap/m/SuggestionsPopover',['sap/ui/Device','sap/ui/base/EventProvider','sap/ui/core/InvisibleText','sap/ui/core/ValueStateSupport','sap/m/library','sap/ui/core/library','sap/m/Button','sap/m/GroupHeaderListItem','sap/m/List',"sap/m/ValueStateHeader","sap/m/inputUtils/scrollToItem","sap/m/inputUtils/SuggestionsPopoverDialogMixin","sap/m/inputUtils/SuggestionsPopoverPopoverMixin","sap/m/inputUtils/ListHelpers"],function(D,E,I,V,l,c,B,G,L,a,s,S,b,d){"use strict";var e=l.ListMode;var f=l.ListSeparators;var C="sapMSuggestionsPopover",g="sapUiNoContentPadding";var h=c.ValueState;
var j=E.extend("sap.m.SuggestionsPopover",{
constructor:function(){E.apply(this,arguments);this._sPopoverContentWidth=null;this._sOldValueState=h.None;if(D.system.phone){S.apply(j.prototype);}else{b.apply(j.prototype);}},
destroy:function(){this._destroySuggestionPopup();}
});
j.M_EVENTS={SELECTION_CHANGE:"selectionChange"};
j.prototype.isOpen=function(){var p=this.getPopover();return p&&p.isOpen();};
j.prototype.setPopover=function(p){this._oPopover=p;};
j.prototype.getPopover=function(){return this._oPopover;};
j.prototype.destroyPopover=function(){if(this._oPopover){this._oPopover.destroy();}this._oPopover=null;};
j.prototype.setInputLabels=function(i){this._fnInputLabels=i;};
j.prototype.createSuggestionPopup=function(p,o){var P,i=this.getItemsContainer();o=o||[];P=this.createPopover(p,o);this.setPopover(P);P.addStyleClass(C);P.addStyleClass(g);P.addAriaLabelledBy(I.getStaticId("sap.m","INPUT_AVALIABLE_VALUES"));if(i){this.addContent(i);}};
j.prototype.initContent=function(p,o){var i=o,P=this.getPopover();if(!P){return;}if(!i){i=new L(p+"-popup-list",{showNoData:false,mode:e.SingleSelectMaster,rememberSelections:false,width:"100%",showSeparators:f.None,busyIndicatorDelay:0});}this.addContent(i);};
j.prototype._destroySuggestionPopup=function(){this.destroyPopover();this._oValueStateHeader=null;};
j.prototype.addContent=function(o){this.getPopover().addContent(o);};
j.prototype.getItemsContainer=function(){var p=this.getPopover(),i=p&&p.getContent();return i&&i.filter(function(o){return(o.isA("sap.m.List")&&o.getId().indexOf("-popup-list")>-1)||o.isA("sap.m.Table");})[0];};
j.prototype.handleListNavigation=function(p,o){var P=this.getPopover();if(o.isMarked()){return;}if(!p.getEnabled()||!p.getEditable()){return;}if(!P||!P.isOpen()){return;}o.preventDefault();o.stopPropagation();var i=this.getItemsContainer(),v=this._getValueStateHeader(),H=v&&v.getVisible(),F=p.hasStyleClass("sapMFocus"),k=i&&i.getItems().filter(function(q){return q.getVisible&&q.getVisible();}),m=k.indexOf(this.getFocusedListItem()),n;switch(o.type){case"sapdown":n=this.handleArrowDown(k,m,F,H);break;case"sapup":n=this.handleArrowUp(k,m,F,H);break;case"sapend":n=this.handleEnd(k,H);break;case"saphome":n=this.handleHome(k,H);break;case"sappagedown":n=this.handlePageDown(k,m,H);break;case"sappageup":n=this.handlePageUp(k,m,H);break;}this.updateFocus(p,n);if(p.handleSelectionFromList){p.handleSelectionFromList(n);}else{this.handleSelectionFromList(n);}this.updateAriaActiveDescendant(p,n);if(D.system.desktop&&n){s(n,this.getPopover());}};
j.prototype.handleArrowDown=function(i,k,F,H){if(F&&!H){return i[0];}if(!F&&!this.getValueStateActiveState()){if(k===i.length-1){return i[k];}return i[k+1];}if(this.getValueStateActiveState()){this.setValueStateActiveState(false);return i[0];}else{this.setValueStateActiveState(true);}};
j.prototype.handleArrowUp=function(i,k,F,H){if(F){return;}if(k>0){return i[k-1];}if(H){this.setValueStateActiveState(!this.getValueStateActiveState());}};
j.prototype.handleEnd=function(i,H){if(H){this.setValueStateActiveState(false);}return i.length&&i[i.length-1];};
j.prototype.handleHome=function(i,H){if(H){this.setValueStateActiveState(true);return;}return i.length&&i[0];};
j.prototype.handlePageDown=function(i,k,H){if(H){this.setValueStateActiveState(false);}return i[Math.min(i.length-1,k+10)];};
j.prototype.handlePageUp=function(i,k,H){if(k-10>=0){return i[k-10];}if(H){this.setValueStateActiveState(true);return;}return i[0];};
j.prototype.updateFocus=function(p,i){var o=this.getItemsContainer(),P=this.getFocusedListItem(),v=this._getValueStateHeader(),H=v&&v.getVisible();o&&o.removeStyleClass("sapMListFocus");P&&P.removeStyleClass("sapMLIBFocused");p.hasStyleClass("sapMFocus")&&p.removeStyleClass("sapMFocus");H&&v.removeStyleClass("sapMPseudoFocus");if(i){i.addStyleClass("sapMLIBFocused");o.addStyleClass("sapMListFocus");this.updateListDataAttributes(o);}else if(this.getValueStateActiveState()){v.addStyleClass("sapMPseudoFocus");}else{p.addStyleClass("sapMFocus");}};
j.prototype.updateListDataAttributes=function(o){if(!o){return;}var v=o.getVisibleItems();if(!v){return;}v.forEach(function(k){var m=k.getDomRef();if(m&&m.hasAttribute("data-sap-ui-first-suggestion-item")){m.removeAttribute("data-sap-ui-first-suggestion-item");}if(m&&m.hasAttribute("data-sap-ui-last-suggestion-item")){m.removeAttribute("data-sap-ui-last-suggestion-item");}});if(v[0]){var F=v[0].getDomRef();F&&F.setAttribute("data-sap-ui-first-suggestion-item","");}if(v[v.length-1]){var i=v[v.length-1].getDomRef();i&&i.setAttribute("data-sap-ui-last-suggestion-item","");}};
j.prototype.handleSelectionFromList=function(i){var o=this.getItemsContainer(),p=this.getFocusedListItem(),k=i&&i.isA("sap.m.GroupHeaderListItem");if(!i||k){o.removeSelections(true);}else{o.setSelectedItem(i,true);}this.fireEvent(j.M_EVENTS.SELECTION_CHANGE,{previousItem:p,newItem:i});};
j.prototype.updateAriaActiveDescendant=function(p,i){var o=p.getFocusDomRef(),v=this._getValueStateHeader(),F=v&&v.getFormattedText(),k;if(p.hasStyleClass("sapMFocus")){o.removeAttribute("aria-activedescendant");return;}if(i){o.setAttribute("aria-activedescendant",i.getId());return;}if(this.getValueStateActiveState()){k=F?F.getId():v.getId();o.setAttribute("aria-activedescendant",k);}};
j.prototype.getFocusedListItem=function(){var o=this.getItemsContainer(),k=o&&o.getItems()||[];for(var i=0;i<k.length;i++){if(k[i].hasStyleClass("sapMLIBFocused")){return k[i];}}};
j.prototype.setValueStateActiveState=function(A){this.bMessageValueStateActive=A;};
j.prototype.getValueStateActiveState=function(){return this.bMessageValueStateActive;};
j.prototype.updateValueState=function(v,i,k){var m=k&&v!==h.None;i=i||V.getAdditionalText(v);if(!this.getPopover()){return this;}if(this.getInput()){this.getInput().setValueState(v);}var o=this._getValueStateHeader();o.setValueState(v);if(o&&typeof i==="string"){o.setText(i);}else if(o&&typeof i==="object"){o.setFormattedText(i);}if(o){o.setVisible(m);}this._alignValueStateStyles(v);return this;};
j.prototype._handleValueStateLinkNav=function(p,o){if(!this.getValueStateActiveState()||(this.getValueStateActiveState()&&document.activeElement.tagName==="A")){return;}var v=this.getValueStateLinks(),i=v[v.length-1];o.preventDefault();v[0].focus();this._getValueStateHeader().removeStyleClass("sapMPseudoFocus");v.forEach(function(k){k.addDelegate({onsapup:function(o){p.getFocusDomRef().focus();this.handleListNavigation(p,o);},onsapdown:function(o){p.getFocusDomRef().focus();this.handleListNavigation(p,o);}},this);},this);i.addDelegate({onsaptabnext:function(o){this.setValueStateActiveState(false);p.onsapfocusleave(o);this.getPopover().close();setTimeout(function(){p.closeValueStateMessage();},0);}},this);v[0].addDelegate({onsaptabprevious:function(o){o.preventDefault();p.getFocusDomRef().focus();this._getValueStateHeader().addStyleClass("sapMPseudoFocus");p.removeStyleClass("sapMFocus");}},this);};
j.prototype.getValueStateLinks=function(){var H=this._getValueStateHeader(),F=H&&typeof H.getFormattedText==="function"&&H.getFormattedText(),i=F&&typeof F.getControls==="function"&&F.getControls();return i||[];};
j.prototype._alignValueStateStyles=function(v){var p=C+"ValueState",o=C+this._sOldValueState+"State",i=C+v+"State",P=this.getPopover();P.addStyleClass(p);P.removeStyleClass(o);P.addStyleClass(i);this._sOldValueState=v;};
j.prototype.decorateParent=function(p){p.addEventDelegate({onsaptabnext:this._handleValueStateLinkNav.bind(this,p),onsaptabprevious:this._handleValueStateLinkNav.bind(this,p)},this);};
j.prototype.getInput=function(){return null;};
j.prototype.getPickerTitle=function(){return null;};
j.prototype.getOkButton=function(){return null;};
j.prototype.getCancelButton=function(){return null;};
j.prototype.getFilterSelectedButton=function(){return null;};
j.prototype.setOkPressHandler=function(){return null;};
j.prototype.setCancelPressHandler=function(){return null;};
j.prototype.setShowSelectedPressHandler=function(){return null;};
j.prototype.resizePopup=function(){};
j.prototype._getValueStateHeader=function(){return null;};
j.prototype._createValueStateHeader=function(){return null;};
return j;});
sap.ui.predefine('sap/m/Support',["sap/ui/thirdparty/jquery","sap/ui/Device","sap/base/security/encodeXML","sap/base/util/isPlainObject"],function(q,D,e,a){"use strict";var B,b,L,P,T,M,H,l;var S=(function($,d){var c,s,f,g,t=0,m=3000,h=2,j=3,r=1,o={},k={btnStart:"startE2ETrace",selLevel:"logLevelE2ETrace",taContent:"outputE2ETrace",infoText:"Ent-to-End trace is running in the background."+" Navigate to the URL that you would like to trace."+" The result of the trace will be shown in dialog after the trace is terminated.",infoDuration:5000},n={dvLoadedLibs:"LoadedLibs",dvLoadedModules:"LoadedModules"};function p(i,v,G,I,J){i.push("<tr class='sapUiSelectable'><td class='sapUiSupportTechInfoBorder sapUiSelectable'><label class='sapUiSupportLabel sapUiSelectable'>",e(I),"</label><br>");var K=J;if(typeof J==="function"){K=J(i)||"";}i.push(e(K));i.push("</td></tr>");}function u(G,I,J,K,N){p(G,I,J,K,function(G){G.push("<table class='sapMSupportTable' border='0' cellspacing='5' cellpadding='5' width='100%'><tbody>");q.each(N,function(i,v){var O="";if(v!==undefined&&v!==null){if(typeof(v)=="string"||typeof(v)=="boolean"||(Array.isArray(v)&&v.length==1)){O=v;}else if(Array.isArray(v)||a(v)){O=JSON.stringify(v);}}p(G,false,false,i,""+O);});G.push("</tbody></table>");});}function w(G){o={version:G.commonInformation.version,build:G.commonInformation.buildTime,change:G.commonInformation.lastChange,useragent:G.commonInformation.userAgent,docmode:G.commonInformation.documentMode,debug:G.commonInformation.debugMode,bootconfig:G.configurationBootstrap,config:G.configurationComputed,loadedlibs:G.loadedLibraries,modules:G.loadedModules,uriparams:G.URLParameters,appurl:G.commonInformation.applicationHREF};var I=["<table class='sapUiSelectable' border='0' cellspacing='5' cellpadding='5' width='100%'><tbody class='sapUiSelectable'>"];p(I,true,true,"SAPUI5 Version",function(i){i.push(o.version," (built at ",o.build,", last change ",o.change,")");});p(I,true,true,"User Agent",function(i){i.push(o.useragent,(o.docmode?", Document Mode '"+o.docmode+"'":""));});p(I,true,true,"Debug Sources",function(i){i.push((o.debug?"ON":"OFF"));});p(I,true,true,"Application",o.appurl);u(I,true,true,"Configuration (bootstrap)",o.bootconfig);u(I,true,true,"Configuration (computed)",o.config);u(I,true,true,"URI Parameters",o.uriparams);p(I,true,true,"End-to-End Trace",function(i){i.push("<label class='sapUiSupportLabel'>Trace Level:</label>","<select id='"+x(k.selLevel)+"' class='sapUiSupportTxtFld' >","<option value='low'>LOW</option>","<option value='medium' selected>MEDIUM</option>","<option value='high'>HIGH</option>","</select>");i.push("<button id='"+x(k.btnStart)+"' class='sapUiSupportBtn'>Start</button>");i.push("<div class='sapUiSupportDiv'>");i.push("<label class='sapUiSupportLabel'>XML Output:</label>");i.push("<textarea id='"+x(k.taContent)+"' class='sapUiSupportTxtArea sapUiSelectable' readonly ></textarea>");i.push("</div>");});p(I,true,true,"Loaded Libraries",function(J){J.push("<ul class='sapUiSelectable'>");q.each(o.loadedlibs,function(i,v){if(v&&(typeof(v)==="string"||typeof(v)==="boolean")){J.push("<li class='sapUiSelectable'>",i+" "+v,"</li>");}});J.push("</ul>");});p(I,true,true,"Loaded Modules",function(i){i.push("<div class='sapUiSupportDiv sapUiSelectable' id='"+x(n.dvLoadedModules)+"'></div>");});I.push("</tbody></table>");return new H({content:I.join("").replace(/\{/g,"&#123;").replace(/\}/g,"&#125;")});}function x(i){return c.getId()+"-"+i;}function y(v,G){var I="Modules";var J=0,K=[];J=G.length;q.each(G.sort(),function(i,O){K.push(new L({text:" - "+O}).addStyleClass("sapUiSupportPnlLbl"));});var N=new P({expandable:true,expanded:false,headerToolbar:new T({design:l.ToolbarDesign.Transparent,content:[new L({text:I+" ("+J+")",design:l.LabelDesign.Bold})]}),content:K});N.placeAt(x(v),"only");}function z(i){if(c.traceXml){c.$(k.taContent).text(c.traceXml);}if(c.e2eLogLevel){c.$(k.selLevel).val(c.e2eLogLevel);}y(n.dvLoadedModules,o.modules);c.$(k.btnStart).one("tap",function(){c.e2eLogLevel=c.$(k.selLevel).val();c.$(k.btnStart).addClass("sapUiSupportRunningTrace").text("Running...");c.traceXml="";c.$(k.taContent).text("");i.start(c.e2eLogLevel,function(v){c.traceXml=v;});M.show(k.infoText,{duration:k.infoDuration});c.close();});}function A(){if(c){return c;}c=new b({title:"Technical Information",horizontalScrolling:true,verticalScrolling:true,stretch:D.system.phone,buttons:[new B({text:"Close",press:function(){c.close();}})],afterOpen:function(){S.off();},afterClose:function(){S.on();}}).addStyleClass("sapMSupport");return c;}function C(i){if(i.touches){var v=i.touches.length;if(v>j){d.removeEventListener('touchend',E);return;}switch(v){case h:s=Date.now();d.addEventListener('touchend',E);break;case j:if(s){t=Date.now()-s;g=i.touches[v-1].identifier;}break;}}}function E(i){d.removeEventListener('touchend',E);if(t>m&&(i.touches.length===h)&&i.changedTouches.length===r&&i.changedTouches[0].identifier===g){t=0;s=0;F();}}function F(){sap.ui.require(["sap/ui/core/support/ToolsAPI","sap/ui/core/support/trace/E2eTraceLib","sap/ui/core/HTML","sap/m/library","sap/m/Button","sap/m/Dialog","sap/m/Label","sap/m/Panel","sap/m/Toolbar","sap/m/MessageToast"],function(i,v,_,G,I,J,K,N,O,Q){H=_;l=G;B=I;b=J;L=K;P=N;T=O;M=Q;var R=A();R.removeAllAggregation("content");R.addAggregation("content",w(i.getFrameworkInformation()));c.open();z(v);});}return({on:function(){if(!f&&"ontouchstart"in d){f=true;d.addEventListener("touchstart",C);}return this;},off:function(){if(f){f=false;d.removeEventListener("touchstart",C);}return this;},open:function(){F();},isEventRegistered:function(){return f;}}).on();}(q,document));return S;},true);
sap.ui.predefine('sap/m/Switch',['./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/theming/Parameters','sap/ui/events/KeyCodes','./SwitchRenderer',"sap/base/assert"],function(l,C,E,I,P,K,S,a){"use strict";var t=l.touch;var c=l.SwitchType;
var d=C.extend("sap.m.Switch",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.m.IOverflowToolbarContent"],library:"sap.m",properties:{state:{type:"boolean",group:"Misc",defaultValue:false},customTextOn:{type:"string",group:"Misc",defaultValue:""},customTextOff:{type:"string",group:"Misc",defaultValue:""},enabled:{type:"boolean",group:"Data",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:""},type:{type:"sap.m.SwitchType",group:"Appearance",defaultValue:c.Default}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{state:{type:"boolean"}}}},designtime:"sap/m/designtime/Switch.designtime"}});
I.insertFontFaceStyle();E.apply(d.prototype,[true]);
d.prototype._slide=function(i){if(i>d._OFFPOSITION){i=d._OFFPOSITION;}else if(i<d._ONPOSITION){i=d._ONPOSITION;}if(i>this._iNoLabelFix){i=this._iNoLabelFix;}if(this._iCurrentPosition===i){return;}this._iCurrentPosition=i;this.getDomRef("inner").style[sap.ui.getCore().getConfiguration().getRTL()?"right":"left"]=i+"px";this._setTempState(Math.abs(i)<d._SWAPPOINT);};
d.prototype._resetSlide=function(){this.getDomRef("inner").style.cssText="";};
d.prototype._setTempState=function(b){if(this._bTempState===b){return;}this._bTempState=b;this.getDomRef("handle").setAttribute("data-sap-ui-swt",b?this._sOn:this._sOff);};
d.prototype._getInvisibleElement=function(){return this.$("invisible");};
d.prototype.getInvisibleElementId=function(){return this.getId()+"-invisible";};
d.prototype.getInvisibleElementText=function(s){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");var T="";switch(this.getType()){case c.Default:if(s){T=this.getCustomTextOn().trim()||b.getText("SWITCH_ON");}else{T=this.getCustomTextOff().trim()||b.getText("SWITCH_OFF");}break;case c.AcceptReject:if(s){T=b.getText("SWITCH_ARIA_ACCEPT");}else{T=b.getText("SWITCH_ARIA_REJECT");}break;}return T;};
var p=Object.assign({"_sap_m_Switch_OnPosition":-32,"_sap_m_Switch_OffPosition":0},P.get({name:["_sap_m_Switch_OnPosition","_sap_m_Switch_OffPosition"],callback:function(_){d._ONPOSITION=Number(_["_sap_m_Switch_OnPosition"]);d._OFFPOSITION=Number(_["_sap_m_Switch_OffPosition"]);d._SWAPPOINT=Math.abs((d._ONPOSITION-d._OFFPOSITION)/2);}}));d._ONPOSITION=Number(p["_sap_m_Switch_OnPosition"]);d._OFFPOSITION=Number(p["_sap_m_Switch_OffPosition"]);d._SWAPPOINT=Math.abs((d._ONPOSITION-d._OFFPOSITION)/2);
d.prototype.onBeforeRendering=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sOn=this.getCustomTextOn()||r.getText("SWITCH_ON");this._sOff=this.getCustomTextOff()||r.getText("SWITCH_OFF");};
d.prototype.ontouchstart=function(e){var T=e.targetTouches[0],b=this.getRenderer().CSS_CLASS,s=this.$("inner");e.setMarked();if(t.countContained(e.touches,this.getId())>1||!this.getEnabled()||e.button){return;}this._iActiveTouchId=T.identifier;this._bTempState=this.getState();this._iStartPressPosX=T.pageX;this._iPosition=s.position().left;this._bDragging=false;setTimeout(this["focus"].bind(this),0);this.$("switch").addClass(b+"Pressed");this._iNoLabelFix=parseInt(getComputedStyle(this.getDomRef("switch")).outlineOffset);};
d.prototype.ontouchmove=function(e){e.setMarked();e.preventDefault();var T,i,f=t;if(!this.getEnabled()||e.button){return;}a(f.find(e.touches,this._iActiveTouchId),"missing touchend");T=f.find(e.changedTouches,this._iActiveTouchId);if(!T||Math.abs(T.pageX-this._iStartPressPosX)<6){return;}this._bDragging=true;i=((this._iStartPressPosX-T.pageX)*-1)+this._iPosition;if(sap.ui.getCore().getConfiguration().getRTL()){i=-i;}this._slide(i);};
d.prototype.ontouchend=function(e){e.setMarked();var T,f=t;if(!this.getEnabled()||e.button){return;}a(this._iActiveTouchId!==undefined,"expect to already be touching");T=f.find(e.changedTouches,this._iActiveTouchId);if(T){a(!f.find(e.touches,this._iActiveTouchId),"touchend still active");if(!this._updateStateAndNotify()){this.$("switch").removeClass(this.getRenderer().CSS_CLASS+"Pressed");this._resetSlide();}}};
d.prototype.ontouchcancel=d.prototype.ontouchend;
d.prototype._handleSpaceOrEnter=function(e){if(this.getEnabled()){e.setMarked();if(!this._bDragging){this._updateStateAndNotify();}}};
d.prototype.onsapspace=function(e){e.preventDefault();};
d.prototype.onkeyup=function(e){if(e.which===K.SPACE){this._handleSpaceOrEnter(e);}};
d.prototype.onsapenter=d.prototype._handleSpaceOrEnter;
d.prototype._updateStateAndNotify=function(){var s=this.getState(),b;this.setState(this._bDragging?this._bTempState:!s);b=s!==this.getState();if(b){this.fireChange({state:this.getState()});}this._bDragging=false;return b;};
d.prototype.getAccessibilityInfo=function(){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s=this.getState(),D=this.getInvisibleElementText(s);return{role:"switch",type:b.getText("ACC_CTR_TYPE_SWITCH"),description:D,focusable:this.getEnabled(),enabled:this.getEnabled()};};
d.prototype.getOverflowToolbarConfig=function(){return{propsUnrelatedToSize:["enabled","state"]};};
return d;});
sap.ui.predefine('sap/m/SwitchRenderer',["sap/ui/Device","sap/m/library"],function(D,l){"use strict";var S=l.SwitchType;var a={apiVersion:2};a.CSS_CLASS="sapMSwt";
a.render=function(r,s){var b=s.getState(),c=b?s._sOn:s._sOff,t=s.getTooltip_AsString(),e=s.getEnabled(),n=s.getName(),A=sap.ui.getCore().getConfiguration().getAccessibility(),d=sap.ui.getCore().getConfiguration().getAnimation(),C=a.CSS_CLASS;r.openStart("div",s);r.class(C+"Cont");if(!e){r.class(C+"ContDisabled");}if(e){r.attr("tabindex","0");}if(t){r.attr("title",t);}if(A){this.writeAccessibilityState(r,s);}r.openEnd();r.openStart("div",s.getId()+"-switch");r.attr("aria-hidden","true");r.class(C);if(d){r.class(C+"Trans");}r.class(b?C+"On":C+"Off");r.class(C+s.getType());if(D.system.desktop&&e){r.class(C+"Hoverable");}if(!e){r.class(C+"Disabled");}if(s._sOn===" "&&s._sOff===" "){r.class(C+"NoLabel");}r.openEnd();r.openStart("div",s.getId()+"-inner");r.class(C+"Inner");r.openEnd();this.renderText(r,s);this.renderHandle(r,s,c);r.close("div");r.close("div");if(n){this.renderCheckbox(r,s,c);}if(A){this.renderInvisibleElement(r,s,{id:s.getInvisibleElementId(),text:s.getInvisibleElementText(b)});}r.close("div");};
a.renderText=function(r,s){var C=a.CSS_CLASS,d=s.getType()===S.Default;r.openStart("div",s.getId()+"-texton");r.class(C+"Text");r.class(C+"TextOn");r.openEnd();r.openStart("span");r.class(C+"Label");r.class(C+"LabelOn");r.openEnd();if(d){r.text(s._sOn);}r.close("span");r.close("div");r.openStart("div",s.getId()+"-textoff");r.class(C+"Text");r.class(C+"TextOff");r.openEnd();r.openStart("span");r.class(C+"Label");r.class(C+"LabelOff");r.openEnd();if(d){r.text(s._sOff);}r.close("span");r.close("div");};
a.renderHandle=function(r,s,b){var C=a.CSS_CLASS;r.openStart("div",s.getId()+"-handle");r.attr("data-sap-ui-swt",b);r.class(C+"Handle");r.openEnd();r.close("div");};
a.renderCheckbox=function(r,s,b){r.voidStart("input",s.getId()+"-input");r.attr("type","checkbox");r.attr("name",s.getName());r.attr("value",b);if(s.getState()){r.attr("checked","checked");}if(!s.getEnabled()){r.attr("disabled","disabled");}r.voidEnd();};
a.writeAccessibilityState=function(r,s){var A=s.getAriaLabelledBy(),m;if(A){A={value:s.getInvisibleElementId(),append:true};}m={role:"switch",checked:s.getState(),labelledby:A};r.accessibilityState(s,m);};
a.renderInvisibleElement=function(r,s,o){r.openStart("span",o.id);r.attr("aria-hidden","true");r.class("sapUiInvisibleText");r.openEnd();r.text(o.text);r.close("span");};
return a;},true);
sap.ui.predefine('sap/m/TabContainer',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/util/ResponsivePaddingsEnablement','./TabContainerRenderer','./TabStrip','./TabStripItem','./Button','sap/ui/Device'],function(l,C,I,R,T,a,b,B,D){"use strict";var c=l.ButtonType;var P=l.PageBackgroundDesign;
var d=C.extend("sap.m.TabContainer",{
metadata:{library:"sap.m",properties:{showAddNewButton:{type:"boolean",group:"Misc",defaultValue:false},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:P.List}},aggregations:{items:{type:"sap.m.TabContainerItem",multiple:true,singularName:"item",bindable:"bindable"},_addNewButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_tabStrip:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:"sap.m.TabContainerItem",multiple:false}},events:{itemClose:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}},itemSelect:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}},addNewButtonPress:{}},designtime:"sap/m/designtime/TabContainer.designtime",dnd:{draggable:false,droppable:true}},
constructor:function(i,s){var S=[];if(!s&&typeof i==='object'){s=i;}if(s&&Array.isArray(s['items'])){S=s['items'];delete s['items'];}C.prototype.constructor.apply(this,arguments);var o=new a(this.getId()+"--tabstrip",{hasSelect:true,itemSelect:function(e){var f=e.getParameter("item"),g=this._fromTabStripItem(f);this.setSelectedItem(g,e);}.bind(this),itemClose:function(e){var f=e.getParameter("item"),r=this._fromTabStripItem(f);e.preventDefault();if(this.fireItemClose({item:r})){if(!this.getBinding("items")){this.removeItem(r);}}}.bind(this)});this.setAggregation("_tabStrip",o,true);if(s&&s['showAddNewButton']){this.setShowAddNewButton(true);}S.forEach(function(e){this.addItem(e);},this);this.data("sap-ui-fastnavgroup","true",true);}
});
var t={"name":"text","additionalText":"additionalText","icon":"icon","iconTooltip":"iconTooltip","modified":"modified"};R.call(d.prototype,{header:{selector:".sapMTabStripContainer"}});
d.prototype.init=function(){this._initResponsivePaddingsEnablement();};
d.prototype.onBeforeRendering=function(){if(this.getSelectedItem()){return;}this._setDefaultTab();};
d.prototype._getAddNewTabButton=function(){var o=this.getAggregation("_addNewButton");var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(!o){o=new B({type:c.Transparent,tooltip:r.getText("TABCONTAINER_ADD_NEW_TAB"),icon:I.getIconURI("add"),press:function(){this.getParent().getParent().fireAddNewButtonPress();}});o.addStyleClass("sapMTSAddNewTabBtn");this.setAggregation("_addNewButton",o,true);}return o;};
d.prototype._getTabStrip=function(){return this.getAggregation("_tabStrip");};
d.prototype._fromTabStripItem=function(i){var e=this.getItems()||[],f=e.length,g=0;for(;g<f;g++){if(e[g].getId()===i.getKey()){return e[g];}}return null;};
d.prototype._toTabStripItem=function(i){var e=0,k=i,o,f,g=this._getTabStrip();if(!g){return null;}o=g.getItems();f=o.length;if(typeof i==="object"){k=i.getId();}for(;e<f;e++){if(o[e].getKey()===k){return o[e];}}return null;};
d.prototype._getSelectedItemContent=function(){var o=this._getTabStrip(),s=this.getSelectedItem(),S=sap.ui.getCore().byId(s),e=this._toTabStripItem(S);if(o){o.setSelectedItem(e);}return S?S.getContent():null;};
d.prototype._moveToNextItem=function(s){if(!this._getTabStrip()._oItemNavigation){return;}var i=this.getItems().length,e=this._getTabStrip()._oItemNavigation.getFocusedIndex(),n=i===e?--e:e,N=this.getItems()[n],f=function(){if(this._getTabStrip()._oItemNavigation){this._getTabStrip()._oItemNavigation.focusItem(n);}},A=document.activeElement.classList;if(s){this.setSelectedItem(N);this.fireItemSelect({item:N});}if(A.contains('sapMTabStripSelectListItemCloseBtn')||A.contains('sapMTabStripItem')){setTimeout(f.bind(this),0);}};
d.prototype._attachItemPropertyChanged=function(o){o.attachItemPropertyChanged(function(e){var p=e['mParameters'].propertyKey;if(t[p]){p=t[p];var f=this._toTabStripItem(e.getSource());var m="set"+p.substr(0,1).toUpperCase()+p.substr(1);f&&f[m](e['mParameters'].propertyValue);}}.bind(this));};
d.prototype.removeItem=function(i){var o=this._getTabStrip(),e,f;if(typeof i==="undefined"||i===null){return null;}i=this.removeAggregation("items",i);e=i.getId()===this.getSelectedItem();f=this._toTabStripItem(i);if(f.getId()===o.getSelectedItem()){o.removeAllAssociation("selectedItem",true);}o.removeItem(f);this._moveToNextItem(e);return i;};
d.prototype.addAggregation=function(A,o,s){if(A==='items'){this._attachItemPropertyChanged(o);}return C.prototype.addAggregation.call(this,A,o,s);};
d.prototype.insertAggregation=function(A,o,i,s){if(A==='items'){this._attachItemPropertyChanged(o);}return C.prototype.insertAggregation.call(this,A,o,i,s);};
d.prototype.addItem=function(i){this.addAggregation("items",i,false);this._getTabStrip().addItem(new b({key:i.getId(),text:i.getName(),additionalText:i.getAdditionalText(),icon:i.getIcon(),iconTooltip:i.getIconTooltip(),modified:i.getModified(),tooltip:i.getTooltip(),customData:i.getCustomData()}));return this;};
d.prototype.destroyItems=function(){this._getTabStrip().destroyItems();this.setAssociation("selectedItem",null);return this.destroyAggregation("items");};
d.prototype.insertItem=function(i,e){this._getTabStrip().insertItem(new b({key:i.getId(),text:i.getName(),additionalText:i.getAdditionalText(),icon:i.getIcon(),iconTooltip:i.getIconTooltip(),modified:i.getModified(),tooltip:i.getTooltip(),customData:i.getCustomData()}),e);return this.insertAggregation("items",i,e);};
d.prototype.removeAllItems=function(){this._getTabStrip().removeAllItems();this.setSelectedItem(null);return this.removeAllAggregation("items");};
d.prototype.setAddButton=function(o){return this._getTabStrip().setAddButton(o);};
d.prototype.getAddButton=function(){return this._getTabStrip().getAddButton();};
d.prototype.setShowAddNewButton=function(s){this.setProperty("showAddNewButton",s,true);if(D.system.phone){s?this.addStyleClass("sapUiShowAddNewButton"):this.removeStyleClass("sapUiShowAddNewButton");}var o=this._getTabStrip();if(o){o.setAddButton(s?this._getAddNewTabButton():null);}return this;};
d.prototype.setSelectedItem=function(s,e){if(this.fireItemSelect({item:s})){var o=this._getTabStrip();if(s&&o){o.setSelectedItem(this._toTabStripItem(s));this._rerenderContent(s.getContent());}this.setAssociation("selectedItem",s,true);return this;}if(e){e.preventDefault();}return this;};
d.prototype._rerenderContent=function(o){var $=this.$("content"),r;if(!o||($.length<=0)){return;}r=sap.ui.getCore().createRenderManager();for(var i=0;i<o.length;i++){r.renderControl(o[i]);}r.flush($[0]);r.destroy();};
d.prototype._setDefaultTab=function(){var f=this.getItems()[0]||null;this.setSelectedItem(f);return f;};
return d;});
sap.ui.predefine('sap/m/TabContainerItem',['sap/ui/core/Element','sap/ui/core/IconPool','./TabStripItem','./library'],function(E,I,T,l){"use strict";var a=l.ImageHelper;
var b=E.extend("sap.m.TabContainerItem",{metadata:{properties:{name:{type:"string",group:"Misc",defaultValue:""},additionalText:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},iconTooltip:{type:"string",group:"Accessibility",defaultValue:null},key:{type:"string",group:"Data",defaultValue:null},modified:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,defaultValue:null},_image:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{itemPropertyChanged:{parameters:{itemChanged:{type:"sap.m.TabContainerItem"},propertyKey:{type:"string"},propertyValue:{type:"any"}}}},dnd:{draggable:true,droppable:false}}});
b.prototype.setProperty=function(n,v,s){this.fireItemPropertyChanged({itemChanged:this,propertyKey:n,propertyValue:v});return E.prototype.setProperty.call(this,n,v,s);};
b.prototype.setIcon=function(i,s){var p,c=['sapMTabContIcon'],o=this.getAggregation("_image"),d=this.getId()+"-img",D=!!(this.getName()||this.getAdditionalText());if(!i){this.setProperty("icon",i,s);if(o){this.destroyAggregation("_image");}return this;}if(this.getIcon()!==i){this.setProperty("icon",i,s);p={src:i,id:d,decorative:D,tooltip:this.getIconTooltip()};o=a.getImageControl(d,o,undefined,p,c);this.setAggregation("_image",o,s);}return this;};
b.prototype._getImage=function(){return this.getAggregation("_image");};
return b;});
sap.ui.predefine('sap/m/TabContainerRenderer',[],function(){"use strict";var T={apiVersion:2};
T.render=function(r,c){var t=c._getTabStrip(),s=c._getSelectedItemContent();r.openStart("div",c);r.class("sapMTabContainer");r.openEnd();if(t){r.renderControl(t);}r.openStart("div",c.getId()+"-containerContent");r.class("sapMTabContainerContent");if(c.getBackgroundDesign()){r.class("sapMTabContainerContent"+c.getBackgroundDesign());}r.openEnd();r.openStart("div",this.getContentDomId(c));r.class("sapMTabContainerInnerContent");r.accessibilityState(c,this.getTabContentAccAttributes(c));r.openEnd();if(s){s.forEach(function(C){r.renderControl(C);});}r.close("div");r.close("div");r.close("div");};
T.getTabContentAccAttributes=function(c){var s=c.getSelectedItem(),t,a={role:"tabpanel"};if(s){t=c._toTabStripItem(s);if(t){a["aria-labelledby"]=t.getId();}}return a;};
T.getContentDomId=function(c){return c.getId()+"-content";};
return T;},true);
sap.ui.predefine('sap/m/TabStrip',['sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/delegate/ItemNavigation','sap/ui/base/ManagedObject','sap/ui/core/delegate/ScrollEnablement','./AccButton','./TabStripItem','sap/m/Select','sap/m/SelectList','sap/ui/Device','sap/ui/core/Renderer','sap/ui/core/ResizeHandler','sap/m/library','sap/ui/core/Icon','sap/m/Image','sap/m/SelectRenderer','sap/m/SelectListRenderer','./TabStripRenderer',"sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes","sap/ui/dom/jquery/control","sap/ui/dom/jquery/scrollLeftRTL"],function(C,I,a,M,S,A,T,b,c,D,R,d,l,e,f,g,h,i,L,q,K){"use strict";var j=l.SelectType;var B=l.ButtonType;
var k=C.extend("sap.m.TabStrip",{
metadata:{library:"sap.m",properties:{hasSelect:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{items:{type:"sap.m.TabStripItem",multiple:true,singularName:"item"},addButton:{type:"sap.m.Button",multiple:false,singularName:"addButton"},_select:{type:'sap.m.Select',multiple:false,visibility:"hidden"},_rightArrowButton:{type:'sap.m.AccButton',multiple:false,visibility:"hidden"},_leftArrowButton:{type:'sap.m.AccButton',multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:'sap.m.TabStripItem',group:"Misc"}},events:{itemClose:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabStripItem"}}},itemPress:{parameters:{item:{type:"sap.m.TabStripItem"}}},itemSelect:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}}}},
constructor:function(v,s){var H=false;if(!s&&typeof v==='object'){s=v;}if(s){H=s['hasSelect'];delete s['hasSelect'];}M.prototype.constructor.apply(this,arguments);this.setProperty('hasSelect',H,true);}
});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");k.ICON_BUTTONS={LeftArrowButton:"slim-arrow-left",RightArrowButton:"slim-arrow-right",DownArrowButton:D.system.phone?"navigation-down-arrow":"slim-arrow-down",AddButton:"add"};k.SELECT_ITEMS_ID_SUFFIX='-SelectItem';k.SCROLL_SIZE=320;k.MIN_DRAG_OFFSET=D.support.touch?15:5;k.SCROLL_ANIMATION_DURATION=sap.ui.getCore().getConfiguration().getAnimation()?500:0;
k.prototype.init=function(){this._bDoScroll=!D.system.phone;this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._iCurrentScrollLeft=0;this._iMaxOffsetLeft=null;this._scrollable=null;this._oTouchStartX=null;if(!D.system.phone){this._oScroller=new S(this,this.getId()+"-tabs",{horizontal:true,vertical:false,nonTouchScrolling:true});}};
k.prototype.exit=function(){this._bRtl=null;this._iCurrentScrollLeft=null;this._iMaxOffsetLeft=null;this._scrollable=null;this._oTouchStartX=null;if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._sResizeListenerId){d.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._removeItemNavigation();};
k.prototype.onBeforeRendering=function(){if(this._sResizeListenerId){d.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
k.prototype.onAfterRendering=function(){if(this._oScroller){this._oScroller.setIconTabBar(this,q.proxy(this._handleOverflowButtons,this),null);}this._addItemNavigation();if(!D.system.phone){this._oScroller._$Container=this.$("tabsContainer");this._adjustScrolling();if(this.getSelectedItem()){if(!sap.ui.getCore().isThemeApplied()){sap.ui.getCore().attachThemeChanged(this._handleInititalScrollToItem,this);}else{this._handleInititalScrollToItem();}}this._sResizeListenerId=d.register(this.getDomRef(),q.proxy(this._adjustScrolling,this));}else{this.$().toggleClass("sapUiSelectable",this.getItems().length>1);}};
k.prototype._handleInititalScrollToItem=function(){var s=sap.ui.getCore().byId(this.getSelectedItem());if(s&&s.$().length>0){this._scrollIntoView(s,500);}sap.ui.getCore().detachThemeChanged(this._handleInititalScrollToItem,this);};
k.prototype.getFocusDomRef=function(){var t=sap.ui.getCore().byId(this.getSelectedItem());if(!t){return null;}return t.getDomRef();};
k.prototype.applyFocusInfo=function(F){if(F.focusDomRef){q(F.focusDomRef).trigger("focus");}};
k.prototype._addItemNavigation=function(){var H=this.getDomRef("tabsContainer"),s=this.getItems(),t=[];s.forEach(function(u){var v=u.getDomRef();q(v).attr("tabindex","-1");t.push(v);});if(!this._oItemNavigation){this._oItemNavigation=new a();}this._oItemNavigation.setRootDomRef(H);this._oItemNavigation.setItemDomRefs(t);this._oItemNavigation.setCycling(false);this._oItemNavigation.setPageSize(5);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});this.addDelegate(this._oItemNavigation);};
k.prototype._checkScrolling=function(){var t=this.getDomRef("tabs"),s=t&&(t.scrollWidth>this.getDomRef("tabsContainer").offsetWidth);this.$().toggleClass("sapMTSScrollable",s);return s;};
k.prototype.onkeyup=function(E){if(E&&E.keyCode===K.ARROW_LEFT||E.keyCode===K.ARROW_RIGHT){var t=q(E.target).control(0);this._scrollIntoView(t,500);}};
k.prototype._handleOverflowButtons=function(){var t=this.getDomRef("tabs"),s=this.getDomRef("tabsContainer"),u,v,w,x=false,y=false,z=this._checkScrolling();if(z&&!this.getAggregation("_rightArrowButton")&&!this.getAggregation("_leftArrowButton")){this._getLeftArrowButton();this._getRightArrowButton();var E=sap.ui.getCore().createRenderManager();this.getRenderer().renderRightOverflowButtons(E,this,true);this.getRenderer().renderLeftOverflowButtons(E,this,true);E.destroy();}if(z&&t&&s){if(this._bRtl){u=q(s).scrollLeftRTL();}else{u=s.scrollLeft;}v=t.scrollWidth;w=s.clientWidth;if(Math.abs(v-w)===1){v=w;}if(u>0){if(this._bRtl){y=true;}else{x=true;}}if((v>w)&&(u+w<v)){if(this._bRtl){x=true;}else{y=true;}}this.$().toggleClass("sapMTSScrollBack",x).toggleClass("sapMTSScrollForward",y);}else{this.$().toggleClass("sapMTSScrollBack",false).toggleClass("sapMTSScrollForward",false);}};
k.prototype._adjustScrolling=function(){this._iMaxOffsetLeft=Math.abs(this.$("tabsContainer").width()-this.$("tabs").width());this._handleOverflowButtons();};
k.prototype._getLeftArrowButton=function(){return this._getArrowButton("_leftArrowButton",r.getText("TABSTRIP_SCROLL_BACK"),k.ICON_BUTTONS.LeftArrowButton,-k.SCROLL_SIZE);};
k.prototype._getRightArrowButton=function(){return this._getArrowButton("_rightArrowButton",r.getText("TABSTRIP_SCROLL_FORWARD"),k.ICON_BUTTONS.RightArrowButton,k.SCROLL_SIZE);};
k.prototype._getArrowButton=function(s,t,u,v){var w=this.getAggregation(s),x=this;if(!w){w=new A({type:B.Transparent,icon:I.getIconURI(u),tooltip:t,tabIndex:"-1",ariaHidden:"true",press:function(E){x._scroll(v,k.SCROLL_ANIMATION_DURATION);}});this.setAggregation(s,w,true);}return w;};
k.prototype._removeItemNavigation=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
k.prototype._scroll=function(s,t){var u=this.getDomRef("tabsContainer").scrollLeft,v;if(this._bRtl){v=u-s;if(D.browser.firefox){if(v<-this._iMaxOffsetLeft){v=-this._iMaxOffsetLeft;}if(v>0){v=0;}}}else{v=u+s;if(v<0){v=0;}if(v>this._iMaxOffsetLeft){v=this._iMaxOffsetLeft;}}this._oScroller.scrollTo(v,0,t);this._iCurrentScrollLeft=v;};
k.prototype._scrollIntoView=function(s,t){var $=this.$("tabs"),u=s.$(),v=this.$("leftOverflowButtons")?this.$("leftOverflowButtons").width():0,w=this.$("rightOverflowButtons")?this.$("rightOverflowButtons").width():0,x=$.innerWidth()-$.width(),y=u.outerWidth(true),z=u.position().left-x/2,E=this.getDomRef("tabsContainer"),F=E.scrollLeft,G=this.$("tabsContainer").width(),N=F;if(z<v||z+w>G-y){if(this._bRtl&&D.browser.firefox){if(z>v){N+=z+y-G+w;}else{N+=z-v;}}else{if(z<v){N+=z-w;}else{N+=z+y-G+v;}}this._iCurrentScrollLeft=N;this._oScroller.scrollTo(N,0,t);}};
k.prototype._createSelect=function(t){var s,u,v,w={type:j.IconOnly,autoAdjustWidth:true,maxWidth:"2.5rem",icon:I.getIconURI(k.ICON_BUTTONS.DownArrowButton),tooltip:r.getText("TABSTRIP_OPENED_TABS"),change:function(E){u=E.getParameters()['selectedItem'];v=this._findTabStripItemFromSelectItem(u);if(v instanceof T){this._activateItem(v,E);}}.bind(this)};s=new n(w).addStyleClass("sapMTSOverflowSelect");this._addItemsToSelect(s,t);return s;};
k.prototype.onsapselect=function(E){E.setMarked();E.preventDefault();if(E.srcControl instanceof T){this._activateItem(E.srcControl,E);}};
k.prototype.onsapdelete=function(E){var s=q("#"+E.target.id).control(0),t=s.getId()===this.getSelectedItem(),u=function(){this._moveToNextItem(t);};this._removeItem(s,u);};
k.prototype._moveToNextItem=function(s){if(!this._oItemNavigation){return;}var t=this.getItems().length,u=this._oItemNavigation.getFocusedIndex(),N=t===u?--u:u,v=this.getItems()[N],F=function(){if(this._oItemNavigation){this._oItemNavigation.focusItem(N);}};if(s){this.setSelectedItem(v);this.fireItemPress({item:v});}setTimeout(F.bind(this),0);};
k.prototype._activateItem=function(s,E){if(this.fireItemSelect({item:s})){if(!this.getSelectedItem()||this.getSelectedItem()!==s.getId()){this.setSelectedItem(s);}this.fireItemPress({item:s});}else if(E&&!E.isDefaultPrevented()){E.preventDefault();}};
k.prototype.addAggregation=function(s,O,t){if(s==='items'){this._handleItemsAggregation(['addAggregation',O,t],true);}return C.prototype.addAggregation.call(this,s,O,t);};
k.prototype.insertAggregation=function(s,O,t,u){if(s==='items'){this._handleItemsAggregation(['insertAggregation',O,t,u],true);}return C.prototype.insertAggregation.call(this,s,O,t,u);};
k.prototype.removeAggregation=function(s,O,t){if(s==='items'){this._handleItemsAggregation(['removeAggregation',O,t]);}return C.prototype.removeAggregation.call(this,s,O,t);};
k.prototype.removeAllAggregation=function(s,t){if(s==='items'){this._handleItemsAggregation(['removeAllAggregation',null,t]);}return C.prototype.removeAllAggregation.call(this,s,t);};
k.prototype.destroyAggregation=function(s,t){if(s==='items'){this._handleItemsAggregation(['destroyAggregation',t]);}return C.prototype.destroyAggregation.call(this,s,t);};
k.prototype.setSelectedItem=function(s){var N=!D.system.phone;if(!s){return this;}if(s.$().length>0&&N){this._scrollIntoView(s,500);}if(N){this._updateAriaSelectedAttributes(this.getItems(),s);this._updateSelectedItemClasses(s.getId());}if(this.getHasSelect()){var t=this._findSelectItemFromTabStripItem(s);this.getAggregation('_select').setSelectedItem(t);}return this.setAssociation("selectedItem",s,N);};
k.prototype.setProperty=function(P,v,s){var t;t=C.prototype.setProperty.call(this,P,v,s);if(P==='hasSelect'){if(v){if(!this.getAggregation('_select')){t=this.setAggregation('_select',this._createSelect(this.getItems()));}}else{t=this.destroyAggregation('_select');}}return t;};
k.prototype._attachItemEventListeners=function(O){if(O instanceof T){var E=['itemClosePressed','itemPropertyChanged'];E.forEach(function(s){s=s.charAt(0).toUpperCase()+s.slice(1);O['detach'+s](this['_handle'+s]);O['attach'+s](this['_handle'+s].bind(this));},this);}};
k.prototype._detachItemEventListeners=function(O){if(!O||typeof O!=='object'||!(O instanceof T)){var s=this.getItems();s.forEach(function(t){if(typeof t!=='object'||!(t instanceof T)){return;}return this._detachItemEventListeners(t);}.bind(this));}};
k.prototype._handleItemPropertyChanged=function(E){var s=this._findSelectItemFromTabStripItem(E.getSource());var P=E['mParameters'].propertyKey;var t="set"+P.substr(0,1).toUpperCase()+P.substr(1);s[t](E['mParameters'].propertyValue);};
k.prototype._handleItemClosePressed=function(E){this._removeItem(E.getSource());};
k.prototype._removeItem=function(s,t){var u;if(!(s instanceof T)){L.error('Expecting instance of a TabStripSelectItem, given: ',s);}if(s.getId().indexOf(k.SELECT_ITEMS_ID_SUFFIX)!==-1){u=this._findTabStripItemFromSelectItem(s);}else{u=s;}if(this.fireItemClose({item:u})){this.removeAggregation('items',u);this._moveToNextItem(s.getId()===this.getSelectedItem());if(t){t.call(this);}}};
k.prototype._handleItemsAggregation=function(s,t){var u='items',F=s[0],O=s[1],N=[u];s.forEach(function(v,w){if(w>0){N.push(v);}});if(t){this._attachItemEventListeners(O);}else{this._detachItemEventListeners(O);}if(u!=="items"){return this;}if(this.getHasSelect()){this._handleSelectItemsAggregation(N,t,F,O);}return this;};
k.prototype._handleSelectItemsAggregation=function(s,t,F,O){var u=this.getAggregation('_select'),v;if(F==='destroyAggregation'&&!u){return;}if(O===null||typeof O!=='object'){return u[F]['apply'](u,s);}if(t){v=this._createSelectItemFromTabStripItem(O);}else{v=this._findSelectItemFromTabStripItem(O);}s.forEach(function(w,x){if(typeof w==='object'){s[x]=v;}});return u[F]['apply'](u,s);};
k.prototype._addItemsToSelect=function(s,t){t.forEach(function(u){var v=this._createSelectItemFromTabStripItem(u);s.addAggregation('items',v);if(u.getId()===this.getSelectedItem()){s.setSelectedItem(v);}},this);};
k.prototype._createSelectItemFromTabStripItem=function(t){var s;if(!t&&!(t instanceof sap.m.TabContainerItem)){L.error('Expecting instance of "sap.m.TabContainerItem": instead of '+t+' given.');return;}s=new T({id:t.getId()+k.SELECT_ITEMS_ID_SUFFIX,text:t.getText(),additionalText:t.getAdditionalText(),icon:t.getIcon(),iconTooltip:t.getIconTooltip(),modified:t.getModified(),itemClosePressed:function(E){this._handleItemClosePressed(E);}.bind(this)});s.addEventDelegate({ontap:function(E){var u=E.srcControl;if(E.target.id===u.getParent().getId()+"-img"){E.srcControl=u=u.getParent();}if((u instanceof A||u instanceof e)){this.fireItemClosePressed({item:this});}}},s);return s;};
k.prototype._findTabStripItemFromSelectItem=function(t){var s,u=t.getId().replace(k.SELECT_ITEMS_ID_SUFFIX,''),v=this.getItems();for(s=0;s<v.length;s++){if(v[s].getId()===u){return v[s];}}};
k.prototype._findSelectItemFromTabStripItem=function(t){var s,u,v=t.getId()+k.SELECT_ITEMS_ID_SUFFIX;if(this.getHasSelect()){u=this.getAggregation('_select').getItems();for(s=0;s<u.length;s++){if(u[s].getId()===v){return u[s];}}}};
k.prototype._updateAriaSelectedAttributes=function(s,t){var u;s.forEach(function(v){u="false";if(v.$()){if(t&&t.getId()===v.getId()){u="true";}v.$().attr("aria-selected",u);}});};
k.prototype._updateSelectedItemClasses=function(s){if(this.$("tabs")){this.$("tabs").children(".sapMTabStripItemSelected").removeClass("sapMTabStripItemSelected");q("#"+s).addClass("sapMTabStripItemSelected");}};
k.prototype.changeItemState=function(v,s){var $;var t=this.getItems();t.forEach(function(u){if(v===u.getId()){$=q(u.$());if(s===true&&!$.hasClass(T.CSS_CLASS_MODIFIED)){$.addClass(T.CSS_CLASS_MODIFIED);}else{$.removeClass(T.CSS_CLASS_MODIFIED);}}});};
k.prototype.ontouchstart=function(E){var t=q(E.target).control(0);if(t instanceof T||t instanceof A||t instanceof e||t instanceof f||t instanceof n){this._oTouchStartX=E.changedTouches[0].pageX;}};
k.prototype.ontouchend=function(E){var t,s;if(!this._oTouchStartX){return;}t=q(E.target).control(0);if(E.target.id===t.getParent().getId()+"-img"){t=t.getParent();}s=Math.abs(E.changedTouches[0].pageX-this._oTouchStartX);if(s<k.MIN_DRAG_OFFSET){if(t instanceof T){this._activateItem(t,E);}else if(t instanceof A){if(t&&t.getParent&&t.getParent()instanceof T){t=t.getParent();this._removeItem(t);}}else if(t instanceof e){if(t&&t.getParent&&t.getParent().getParent&&t.getParent().getParent()instanceof T){t=t.getParent().getParent();this._removeItem(t);}}this._oTouchStartX=null;}};
k.prototype.destroyItems=function(){this.setAssociation("selectedItem",null);return this.destroyAggregation("items");};
var m=R.extend(g);m.apiVersion=2;
var n=b.extend("sap.m.internal.TabStripSelect",{
metadata:{library:"sap.m"},
renderer:m
});
n.prototype.onAfterRendering=function(){b.prototype.onAfterRendering.apply(this,arguments);this.$().attr("tabindex","-1");};
n.prototype.onAfterRenderingPicker=function(){var P=this.getPicker();b.prototype.onAfterRenderingPicker.call(this);if(D.system.phone){return;}P.setOffsetX(Math.round(sap.ui.getCore().getConfiguration().getRTL()?this.getPicker().$().width()-this.$().width():this.$().width()-this.getPicker().$().width()));P.setOffsetY(this.$().parents().hasClass('sapUiSizeCompact')?2:3);P._calcPlacement();};
n.prototype.createList=function(){this._oList=new p({width:"100%"}).attachSelectionChange(this.onSelectionChange,this).addEventDelegate({ontap:function(E){this.close();}},this);return this._oList;};
n.prototype.setValue=function(v){b.prototype.setValue.apply(this,arguments);this.$("label").toggleClass("sapMTSOverflowSelectLabelModified",this.getSelectedItem()&&this.getSelectedItem().getProperty("modified"));return this;};
n.prototype._getValueIcon=function(){return null;};
var o=R.extend(h);o.apiVersion=2;
o.renderItem=function(s,t,u,v){s.openStart("li",u);s.class(h.CSS_CLASS+"ItemBase");s.class(h.CSS_CLASS+"Item");s.class("sapMTSOverflowSelectListItem");if(u.getProperty("modified")){s.class("sapMTSOverflowSelectListItemModified");}if(D.system.desktop){s.class(h.CSS_CLASS+"ItemBaseHoverable");}if(u===t.getSelectedItem()){s.class(h.CSS_CLASS+"ItemBaseSelected");}s.attr("tabindex",0);this.writeItemAccessibilityState.apply(this,arguments);s.openEnd();s.openStart("div");s.class("sapMSelectListItemText");s.openEnd();if(u.getIcon()){s.renderControl(u._getImage());}s.openStart("div");s.class("sapMTSTexts");s.openEnd();this.renderItemText(s,u.getAdditionalText(),T.CSS_CLASS_TEXT);this.renderItemText(s,u.getText(),T.CSS_CLASS_LABEL);s.close("div");s.close("div");s.renderControl(u.getAggregation('_closeButton'));s.close("li");};
o.renderItemText=function(s,t,u){s.openStart("div");s.class(u);s.openEnd();s.text(t.slice(0,(D.system.phone?t.length:T.DISPLAY_TEXT_MAX_LENGTH)));if(!D.system.phone&&t.length>T.DISPLAY_TEXT_MAX_LENGTH){s.text('...');}s.close("div");};
var p=c.extend("sap.m.internal.TabStripSelectList",{
metadata:{library:"sap.m"},
renderer:o
});
return k;});
sap.ui.predefine('sap/m/TabStripItem',["./library","sap/ui/core/Item","sap/ui/base/ManagedObject","sap/ui/core/IconPool","./AccButton"],function(l,I,M,a,A){"use strict";var B=l.ButtonType;var b=l.ImageHelper;
var T=I.extend("sap.m.TabStripItem",{metadata:{library:"sap.m",properties:{additionalText:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},iconTooltip:{type:"string",group:"Accessibility",defaultValue:null},modified:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{_closeButton:{type:"sap.m.Button",multiple:false},_image:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{itemClosePressed:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabStripItem"}}},itemPropertyChanged:{parameters:{itemChanged:{type:'sap.m.TabStripItem'},propertyKey:{type:"string"},propertyValue:{type:"any"}}}}}});
T.DISPLAY_TEXT_MAX_LENGTH=25;T.CSS_CLASS="sapMTabStripItem";T.CSS_CLASS_LABEL="sapMTabStripItemLabel";T.CSS_CLASS_MODIFIED_SYMBOL="sapMTabStripItemModifiedSymbol";T.CSS_CLASS_TEXT="sapMTabStripItemAddText";T.CSS_CLASS_BUTTON="sapMTabStripItemButton";T.CSS_CLASS_MODIFIED="sapMTabStripItemModified";T.CSS_CLASS_SELECTED="sapMTabStripItemSelected";T.CSS_CLASS_STATE="sapMTabStripSelectListItemModified";T.CSS_CLASS_STATE_INVISIBLE="sapMTabStripSelectListItemModifiedInvisible";T.CSS_CLASS_CLOSE_BUTTON='sapMTabStripSelectListItemCloseBtn';T.CSS_CLASS_CLOSE_BUTTON_INVISIBLE='sapMTabStripSelectListItemCloseBtnInvisible';
T.prototype.init=function(){var o=new A({type:B.Transparent,icon:a.getIconURI("decline"),tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("TABSTRIP_ITEM_CLOSE_BTN"),tabIndex:"-1",ariaHidden:"true"}).addStyleClass(T.CSS_CLASS_CLOSE_BUTTON);this.setAggregation('_closeButton',o);};
T.prototype.setProperty=function(n,v,s){if(n==='modified'){s=true;}M.prototype.setProperty.call(this,n,v,s);if((n==="text"&&this.getAdditionalText()!==""&&this.getAggregation("_image"))||(n==="additionalText"&&this.getText()!==""&&this.getAggregation("_image"))){this.getAggregation("_image").setDecorative(v!=="");}if(this.getParent()&&this.getParent().changeItemState){this.getParent().changeItemState(this.getId(),v);}this.fireItemPropertyChanged({itemChanged:this,propertyKey:n,propertyValue:v});return this;};
T.prototype.setIcon=function(i,s){var p,c=['sapMTabContIcon'],o=this.getAggregation("_image"),d=this.getId()+"-img",D=!!(this.getText()||this.getAdditionalText());if(!i){this.setProperty("icon",i,s);if(o){this.destroyAggregation("_image");}return this;}if(this.getIcon()!==i){this.setProperty("icon",i,s);p={src:i,id:d,decorative:D,tooltip:this.getIconTooltip()};o=b.getImageControl(d,o,undefined,p,c);this.setAggregation("_image",o,s);}return this;};
T.prototype._getImage=function(){return this.getAggregation("_image");};
return T;});
sap.ui.predefine('sap/m/TabStripRenderer',['./TabStripItem','sap/ui/Device','sap/ui/core/InvisibleText',"sap/ui/core/Element"],function(T,D,I,E){"use strict";var a={apiVersion:2};a.LEFT_OVERRFLOW_BTN_CLASS_NAME="sapMTSLeftOverflowButtons";a.RIGHT_OVERRFLOW_BTN_CLASS_NAME="sapMTSRightOverflowButtons";
a.render=function(r,c){if(!c.getVisible()){return;}this.beginTabStrip(r,c);if(!D.system.phone){r.openStart("div",c.getId()+"-leftOverflowButtons");r.class(this.LEFT_OVERRFLOW_BTN_CLASS_NAME);r.openEnd();if(c.getAggregation("_leftArrowButton")){this.renderLeftOverflowButtons(r,c,false);}r.close("div");}this.beginTabsContainer(r,c);this.renderItems(r,c);this.endTabsContainer(r);if(!D.system.phone){r.openStart("div",c.getId()+"-rightOverflowButtons");r.class(this.RIGHT_OVERRFLOW_BTN_CLASS_NAME);r.openEnd();if(c.getAggregation("_rightArrowButton")){this.renderRightOverflowButtons(r,c,false);}r.close("div");}this.renderTouchArea(r,c);this.endTabStrip(r);};
a.renderItems=function(r,c){var i=c.getItems(),s=c.getSelectedItem(),d,S;if(D.system.phone){S=E.registry.get(s);S&&this.renderItem(r,c,S,true);}else{i.forEach(function(o){d=s&&s===o.getId();this.renderItem(r,c,o,d);},this);}};
a.renderItem=function(r,c,i,s){var t=i.getTooltip(),d=g(i),m=i.getModified();r.openStart("div",i);r.class(T.CSS_CLASS);if(m){r.class(T.CSS_CLASS_MODIFIED);}if(s){r.class(T.CSS_CLASS_SELECTED);}if(t){r.attr("title",t);}r.accessibilityState(i,b(i,c,sap.ui.getCore().byId(c.getSelectedItem())));r.openEnd();if(i.getIcon()){r.renderControl(i._getImage());}r.openStart("div");r.class("sapMTSTexts");r.openEnd();r.openStart("div",d+"-addText");r.class(T.CSS_CLASS_TEXT);r.openEnd();this.renderItemText(r,i.getAdditionalText());r.close("div");r.openStart("div",d+"-text");r.class(T.CSS_CLASS_LABEL);r.openEnd();this.renderItemText(r,i.getText());if(m){r.openStart("span",d+"-symbol");r.class(T.CSS_CLASS_MODIFIED_SYMBOL);r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();r.close("span");}r.close("div");r.close("div");this.renderItemCloseButton(r,i);r.close("div");};
a.renderItemText=function(r,i){if(i.length>T.DISPLAY_TEXT_MAX_LENGTH){r.text(i.slice(0,T.DISPLAY_TEXT_MAX_LENGTH));r.text('...');}else{r.text(i);}};
a.renderItemCloseButton=function(r,i){r.openStart("div");r.class("sapMTSItemCloseBtnCnt");r.openEnd();r.renderControl(i.getAggregation("_closeButton"));r.close("div");};
a.beginTabStrip=function(r,c){r.openStart("div");r.class("sapMTabStripContainer");r.openEnd();r.openStart("div",c);r.class("sapMTabStrip");r.class("sapContrastPlus");r.openEnd();};
a.endTabStrip=function(r){r.close("div");r.close("div");};
a.beginTabsContainer=function(r,c){r.openStart("div",c.getId()+"-tabsContainer");r.class("sapMTSTabsContainer");r.openEnd();r.openStart("div",c.getId()+"-tabs");r.class("sapMTSTabs");r.accessibilityState(c,{role:"tablist"});r.openEnd();};
a.endTabsContainer=function(r){r.close("div");r.close("div");};
a.renderLeftOverflowButtons=function(r,c,f){r.renderControl(c.getAggregation("_leftArrowButton"));if(f){r.flush(c.$("leftOverflowButtons")[0]);}};
a.renderRightOverflowButtons=function(r,c,f){r.renderControl(c.getAggregation("_rightArrowButton"));if(f){r.flush(c.$("rightOverflowButtons")[0]);}};
a.renderTouchArea=function(r,c){r.openStart("div",c.getId()+"-touchArea");r.class("sapMTSTouchArea");r.openEnd();r.renderControl(c.getAggregation('_select'));r.renderControl(c.getAddButton());r.close("div");};
function g(i){return i.getId()+"-label";}
function b(i,t,s){var c=t.getItems(),d=c.indexOf(i),o=t.getParent(),A={role:"tab"},e=I.getStaticId("sap.m","TABSTRIP_ITEM_CLOSABLE")+" ";e+=I.getStaticId("sap.m",i.getModified()?"TABSTRIP_ITEM_MODIFIED":"TABSTRIP_ITEM_NOT_MODIFIED");A["describedby"]=e;A["posinset"]=d+1;A["setsize"]=c.length;if(o&&o.getRenderer&&o.getRenderer().getContentDomId){A["controls"]=o.getRenderer().getContentDomId(o);}if(s&&s.getId()===i.getId()){A["selected"]="true";}else{A["selected"]="false";}return A;}
return a;},true);
sap.ui.predefine('sap/m/Table',["sap/ui/core/Core","sap/ui/Device","./library","./ListBase","./ListItemBase","./CheckBox","./TableRenderer","sap/base/Log","sap/ui/base/Object","sap/ui/core/ResizeHandler","sap/ui/core/util/PasteHelper","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/m/ListBaseRenderer","sap/ui/core/Icon","sap/ui/dom/jquery/Selectors"],function(C,D,l,L,a,b,T,c,B,R,P,K,q,d,I){"use strict";var e=l.ListKeyboardMode;var f=l.ListGrowingDirection;var g=l.BackgroundDesign;var h=l.PopinLayout;var S=l.ScreenSizes;
var j=L.extend("sap.m.Table",{metadata:{library:"sap.m",properties:{backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:g.Translucent},fixedLayout:{type:"any",group:"Behavior",defaultValue:true},showOverlay:{type:"boolean",group:"Appearance",defaultValue:false},alternateRowColors:{type:"boolean",group:"Appearance",defaultValue:false},popinLayout:{type:"sap.m.PopinLayout",group:"Appearance",defaultValue:h.Block},contextualWidth:{type:"string",group:"Behavior",defaultValue:"Inherit"},autoPopinMode:{type:"boolean",group:"Behavior",defaultValue:false},hiddenInPopin:{type:"sap.ui.core.Priority[]",group:"Behavior"}},aggregations:{columns:{type:"sap.m.Column",multiple:true,singularName:"column",dnd:{draggable:true,droppable:true,layout:"Horizontal"}}},events:{beforeOpenContextMenu:{allowPreventDefault:true,parameters:{listItem:{type:"sap.m.ColumnListItem"},column:{type:"sap.m.Column"}}},paste:{allowPreventDefault:true,parameters:{data:{type:"string[][]"}}},popinChanged:{parameters:{hasPopin:{type:"boolean"},visibleInPopin:{type:"sap.m.Column[]"},hiddenInPopin:{type:"sap.m.Column[]"}}}},designtime:"sap/m/designtime/Table.designtime"}});
j.prototype.sNavItemClass="sapMListTblRow";
j.prototype.init=function(){this._iItemNeedsColumn=0;L.prototype.init.call(this);};
j.prototype.setContextualWidth=function(w){var o=this.getContextualWidth();if(w==o){return this;}if(typeof w==="number"){this._sContextualWidth=w+"px";this._sContextualWidth=this._sContextualWidth.toLowerCase();}else{var i=w.toLowerCase(),W=S[i];if(W){this._sContextualWidth=W+"px";}else{this._sContextualWidth=w;}}var k=this._validateContextualWidth(this._sContextualWidth);this._iLastContextualWidth=o;if(k){this.setProperty("contextualWidth",w,true);}else{return this;}if(this._iLastContextualWidth.toLowerCase()==="auto"){this._deregisterResizeHandler();}if(this._sContextualWidth.toLowerCase()==="auto"){this._registerResizeHandler();this._applyContextualWidth(this.$().width());}else{this._applyContextualWidth(this._sContextualWidth);}return this;};
j.prototype._validateContextualWidth=function(w){if(!w){return;}if(typeof w!="string"){throw new Error('expected string for property "contextualWidth" of '+this);}if(w.toLowerCase()==="auto"||w.toLowerCase()==="inherit"){return true;}if(!/^\d+(\.\d+)?(px)$/i.test(w)){throw new Error('invalid CSS size("px", "Auto", "auto", Inherit", "inherit" required) or sap.m.ScreenSize enumeration for property "contextualWidth" of '+this);}return true;};
j.prototype._applyContextualWidth=function(w){w=parseFloat(w)||0;if(Math.abs(this._oContextualSettings.contextualWidth-w)<=16){return;}if(w&&this._oContextualSettings.contextualWidth!=w){this._applyContextualSettings({contextualWidth:w});}};
j.prototype._onResize=function(p){this._applyContextualWidth(p.size.width);};
j.prototype._registerResizeHandler=function(){if(!this._iResizeHandlerId){var t=this;window.requestAnimationFrame(function(){t._iResizeHandlerId=R.register(t,t._onResize.bind(t));});}};
j.prototype._deregisterResizeHandler=function(){if(this._iResizeHandlerId){R.deregister(this._iResizeHandlerId);this._iResizeHandlerId=null;}};
j.prototype.onBeforeRendering=function(){L.prototype.onBeforeRendering.call(this);this._bHasDynamicWidthCol=this._hasDynamicWidthColumn();if(this.getAutoPopinMode()){this._configureAutoPopin();}this._applyContextualWidth(this._sContextualWidth);this._ensureColumnsMedia();this._notifyColumns("ItemsRemoved");};
j.prototype._hasDynamicWidthColumn=function(o,s){if(this.getFixedLayout()!="Strict"){return true;}return this.getColumns().some(function(i){if(i.getVisible()&&!i.isPopin()){var w=o&&o==i?s:i.getWidth();return!w||w=="auto";}});};
j.prototype._ensureColumnsMedia=function(){this.getColumns().forEach(function(o){if(o._bShouldAddMedia){o._addMedia();}});};
j.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.call(this);this.updateSelectAllCheckbox();this._renderOverlay();if(this._bFirePopinChanged){this._firePopinChangedEvent();this._bFirePopinChanged=false;}else{var p=this._getPopins();if(this._aPopins&&this.getVisibleItems().length){if(this._aPopins.length!=p.length||!p.every(function(o){return this._aPopins.indexOf(o)>-1;},this)){this._aPopins=p;this._firePopinChangedEvent();}}else if(this._aPopins==null){this._aPopins=p;}}if(this._bCheckLastColumnWidth&&C.isThemeApplied()){window.requestAnimationFrame(this._checkLastColumnWidth.bind(this));}};
j.prototype.setHiddenInPopin=function(p){var o=this.getHiddenInPopin()||[],n=p||[];this.setProperty("hiddenInPopin",p);if(n.length!==o.length){this._bFirePopinChanged=true;}else{this._bFirePopinChanged=!n.every(function(s){return o.includes(s);});}this._aPopins=this._getPopins();return this;};
j.prototype._renderOverlay=function(){var $=this.$(),i=$.find(".sapMTableOverlay"),s=this.getShowOverlay();if(s&&i.length===0){i=q("<div>").addClass("sapUiOverlay sapMTableOverlay").css("z-index","1");$.append(i);}else if(!s){i.remove();}};
j.prototype._checkLastColumnWidth=function(){var $=this.$();var t=this.getTableDomRef();if(!$.length||!t){return;}if($[0].clientWidth<t.clientWidth){$.find(".sapMListTblCell:visible").eq(0).addClass("sapMTableLastColumn").width("");}this._bCheckLastColumnWidth=false;};
j.prototype.setShowOverlay=function(s){this.setProperty("showOverlay",s,true);this._renderOverlay();return this;};
j.prototype.exit=function(){L.prototype.exit.call(this);if(this._selectAllCheckBox){this._selectAllCheckBox.destroy();this._selectAllCheckBox=null;}if(this._clearAllButton){this._clearAllButton.destroy();this._clearAllButton=null;}};
j.prototype.destroyItems=function(){this._notifyColumns("ItemsRemoved");return L.prototype.destroyItems.apply(this,arguments);};
j.prototype.removeAllItems=function(){this._notifyColumns("ItemsRemoved");return L.prototype.removeAllItems.apply(this,arguments);};
j.prototype.removeSelections=function(){L.prototype.removeSelections.apply(this,arguments);this.updateSelectAllCheckbox();return this;};
j.prototype.selectAll=function(){L.prototype.selectAll.apply(this,arguments);this.updateSelectAllCheckbox();return this;};
j.prototype.getColumns=function(s){var i=this.getAggregation("columns",[]);if(s){i.sort(function(k,m){return k.getOrder()-m.getOrder();});}return i;};
j.prototype.setFixedLayout=function(F){if(F==undefined||F=="true"){F=true;}else if(F=="false"){F=false;}if(typeof F=="boolean"||F=="Strict"){return this.setProperty("fixedLayout",F);}throw new Error('"'+F+'" is an invalid value, expected false, true or "Strict" for the property fixedLayout of '+this);};
j.prototype.onBeforePageLoaded=function(){if(this.getAlternateRowColors()){this._sAlternateRowColorsClass=this._getAlternateRowColorsClass();}L.prototype.onBeforePageLoaded.apply(this,arguments);};
j.prototype.onAfterPageLoaded=function(){this.updateSelectAllCheckbox();if(this.getAlternateRowColors()&&this._sAlternateRowColorsClass!=this._getAlternateRowColorsClass()){var $=this.$("tblBody").removeClass(this._sAlternateRowColorsClass);$.addClass(this._getAlternateRowColorsClass());}L.prototype.onAfterPageLoaded.apply(this,arguments);};
j.prototype.shouldRenderItems=function(){return this.getColumns().some(function(o){return o.getVisible();});};
j.prototype.shouldGrowingSuppressInvalidation=function(){if(this.getAutoPopinMode()){return false;}return L.prototype.shouldGrowingSuppressInvalidation.call(this);};
j.prototype.onItemTypeColumnChange=function(i,n){this._iItemNeedsColumn+=(n?1:-1);if(this._iItemNeedsColumn==1&&n){this._setTypeColumnVisibility(true);}else if(this._iItemNeedsColumn==0){this._setTypeColumnVisibility(false);}};
j.prototype.onItemSelectedChange=function(i,s){L.prototype.onItemSelectedChange.apply(this,arguments);setTimeout(function(){this.updateSelectAllCheckbox();}.bind(this),0);};
j.prototype.getTableDomRef=function(){return this.getDomRef("listUl");};
j.prototype.getItemsContainerDomRef=function(){return this.getDomRef("tblBody");};
j.prototype.setNavigationItems=function(i){var H=this.$("tblHeader");var F=this.$("tblFooter");var r=this.$("tblBody").children(".sapMLIB");var k=H.add(r).add(F).get();i.setItemDomRefs(k);if(i.getFocusedIndex()==-1){if(this.getGrowing()&&this.getGrowingDirection()==f.Upwards){i.setFocusedIndex(k.length-1);}else{i.setFocusedIndex(H[0]?1:0);}}};
j.prototype.checkGrowingFromScratch=function(){if(this.hasPopin()){return false;}return this.getColumns().some(function(o){return o.getVisible()&&o.getMergeDuplicates();});};
j.prototype.onColumnPress=function(o){var m=o.getColumnHeaderMenu();m&&m.openBy(o);(this.bActiveHeaders||m)&&this.fireEvent("columnPress",{column:o});};
j.prototype.onColumnResize=function(o){if(!this.hasPopin()&&!this._mutex){var i=this.getColumns().some(function(m){return m.isPopin();});if(!i){o.setDisplay(this.getTableDomRef(),!o.isHidden());this._firePopinChangedEvent();this._oGrowingDelegate&&this._oGrowingDelegate.adaptTriggerButtonWidth(this);return;}}this._dirty=this._getMediaContainerWidth()||window.innerWidth;if(!this._mutex){var k=this._getMediaContainerWidth()||window.innerWidth;this._mutex=true;this._bFirePopinChanged=true;this.rerender();setTimeout(function(){if(this._dirty!=k){this._dirty=0;this._bFirePopinChanged=true;this.rerender();}this._mutex=false;}.bind(this),200);}};
j.prototype.setTableHeaderVisibility=function(i){if(!this.getDomRef()){return;}if(!this.shouldRenderItems()){return this.invalidate();}var $=this.$("tblHeader"),H=!$.hasClass("sapMListTblHeaderNone"),v=$.find(".sapMListTblCell:visible"),k=v.eq(0);if(v.length==1){if(this.getFixedLayout()=="Strict"){this._checkLastColumnWidth();}else{k.width("");}}else{v.each(function(){this.style.width=this.getAttribute("data-sap-width")||"";});}this._colCount=v.length+3+!!d.ModeOrder[this.getMode()];this.$("tblBody").find(".sapMGHLICell").attr("colspan",this.getColSpan());this.$("nodata-text").attr("colspan",this.getColCount());if(this.hasPopin()){this.$("tblBody").find(".sapMListTblSubRowCell").attr("colspan",this.getColSpan());}if(!i&&H){$[0].className="sapMListTblRow sapMLIBFocusable sapMListTblHeader";this._headerHidden=false;}else if(i&&!H&&!v.length){$[0].className="sapMListTblHeaderNone";this._headerHidden=true;}};
j.prototype._setTypeColumnVisibility=function(v){q(this.getTableDomRef()).toggleClass("sapMListTblHasNav",v);};
j.prototype._notifyColumns=function(A,p,v){this.getColumns().forEach(function(o){o["on"+A](p,v);});};
j.prototype._getClearAllButton=function(){if(!this._clearAllButton){this._clearAllButton=new I({id:this.getId()+"-clearSelection",src:"sap-icon://clear-all",decorative:false,press:this.removeSelections.bind(this,false,true,false)}).setParent(this,null,true).addEventDelegate({onAfterRendering:function(){this._clearAllButton.getDomRef().setAttribute("tabindex",-1);}},this);}return this._clearAllButton;};
j.prototype._getSelectAllCheckbox=function(){if(this.bPreventMassSelection){return;}if(!this._selectAllCheckBox){this._selectAllCheckBox=new b({id:this.getId("sa"),activeHandling:false}).addStyleClass("sapMLIBSelectM").setParent(this,null,true).attachSelect(function(){if(this._selectAllCheckBox.getSelected()){this.selectAll(true);}else{this.removeSelections(false,true);}},this).setTabIndex(-1);}this._selectAllCheckBox.useEnabledPropagator(false);return this._selectAllCheckBox;};
j.prototype.updateSelectAllCheckbox=function(){if(this.getMode()!=="MultiSelect"){return;}if(this._selectAllCheckBox&&this.getMultiSelectMode()=="Default"){var i=this.getItems(),s=this.getSelectedItems().length,k=i.filter(function(o){return o.isSelectable();}).length;this._selectAllCheckBox.setSelected(i.length>0&&s==k);}else if(this._clearAllButton){this._clearAllButton.toggleStyleClass("sapMTableDisableClearAll",!this.getSelectedItems().length);}};
j.prototype.enhanceAccessibilityState=function(E,A){if(E==this._clearAllButton){var o=C.getLibraryResourceBundle("sap.m");A.label=o.getText("TABLE_ICON_DESELECT_ALL");}else if(E==this._selectAllCheckBox){var o=C.getLibraryResourceBundle("sap.m");A.label=o.getText("TABLE_CHECKBOX_SELECT_ALL");}};
j.prototype.getColSpan=function(){var i=this.shouldRenderDummyColumn()?3:2;return(this._colCount||1)-i;};
j.prototype.getColCount=function(){return(this._colCount||0);};
j.prototype.shouldRenderDummyColumn=function(){return!this._bHasDynamicWidthCol&&this.shouldRenderItems();};
j.prototype.hasPopin=function(){return!!this._hasPopin;};
j.prototype.isHeaderRowEvent=function(E){var H=this.$("tblHeader");return!!q(E.target).closest(H,this.getTableDomRef()).length;};
j.prototype.isFooterRowEvent=function(E){var F=this.$("tblFooter");return!!q(E.target).closest(F,this.getTableDomRef()).length;};
j.prototype.getAccessibilityType=function(){return C.getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_TABLE");};
j.prototype._setHeaderAnnouncement=function(){var o=C.getLibraryResourceBundle("sap.m"),A=o.getText("ACC_CTR_TYPE_HEADER_ROW")+" ";if(this.isAllSelectableSelected()){A+=o.getText("LIST_ALL_SELECTED");}var H=this._getHiddenInPopin();this.getColumns(true).forEach(function(k,i){if(!k.getVisible()||H.indexOf(k)>-1){return;}var m=k.getHeader();if(m&&m.getVisible()){A+=a.getAccessibilityText(m)+" . ";}});this.updateInvisibleText(A);};
j.prototype._setFooterAnnouncement=function(){var A=C.getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_FOOTER_ROW")+" ";this.getColumns(true).forEach(function(o,i){if(!o.getVisible()){return;}var F=o.getFooter();if(F&&F.getVisible()){var H=o.getHeader();if(H&&H.getVisible()){A+=a.getAccessibilityText(H)+" ";}A+=a.getAccessibilityText(F)+" ";}});this.updateInvisibleText(A);};
j.prototype.onsapspace=function(E){if(E.isMarked()){return;}if(E.target.id==this.getId("tblHeader")){E.preventDefault();var m=this.getMultiSelectMode();if(this._selectAllCheckBox&&m=="Default"){this._selectAllCheckBox.setSelected(!this._selectAllCheckBox.getSelected()).fireSelect();E.setMarked();}else if(this._clearAllButton&&m=="ClearAll"&&!this._clearAllButton.hasStyleClass("sapMTableDisableClearAll")){this._clearAllButton.firePress();E.setMarked();}}};
j.prototype.onsaptabnext=function(E){if(E.isMarked()||this.getKeyboardMode()==e.Edit){return;}var r=q();if(E.target.id==this.getId("nodata")){r=this.$("nodata");}else if(this.isHeaderRowEvent(E)){r=this.$("tblHeader");}else if(this.isFooterRowEvent(E)){r=this.$("tblFooter");}var o=r.find(":sapTabbable").get(-1)||r[0];if(E.target===o){this.forwardTab(true);E.setMarked();}};
j.prototype.onsaptabprevious=function(E){if(E.isMarked()||this.getKeyboardMode()==e.Edit){return;}var t=E.target.id;if(t==this.getId("nodata")||t==this.getId("tblHeader")||t==this.getId("tblFooter")){this.forwardTab(false);}else if(t==this.getId("trigger")){this.focusPrevious();E.preventDefault();}};
j.prototype.focus=function(F){this._oFocusInfo=F;L.prototype.focus.apply(this,arguments);delete this._oFocusInfo;};
j.prototype.getFocusDomRef=function(){var H=this._oFocusInfo&&this._oFocusInfo.targetInfo&&B.isA(this._oFocusInfo.targetInfo,"sap.ui.core.message.Message");if(H){var t=this.$("tblHeader");var v=t.find(".sapMListTblCell:visible");if(v.length){return t[0];}var n=this.$("nodata");if(n.length){return n[0];}}return L.prototype.getFocusDomRef.apply(this,arguments);};
j.prototype.onfocusin=function(E){var t=E.target;if(t.id==this.getId("tblHeader")){if(!this.hasPopin()&&this.shouldRenderDummyColumn()){t.classList.add("sapMTableRowCustomFocus");}this._setHeaderAnnouncement();this._setFirstLastVisibleCells(t);}else if(t.id==this.getId("tblFooter")){this._setFooterAnnouncement();this._setFirstLastVisibleCells(t);}else if(t.id==this.getId("nodata")){this._setFirstLastVisibleCells(t);}L.prototype.onfocusin.call(this,E);};
j.prototype.onThemeChanged=function(){L.prototype.onThemeChanged.call(this);if(this._bCheckLastColumnWidth){this._checkLastColumnWidth();}};
j.prototype._getAlternateRowColorsClass=function(){if(this.isGrouped()){return"sapMListTblAlternateRowColorsGrouped";}if(this.hasPopin()){return"sapMListTblAlternateRowColorsPopin";}return"sapMListTblAlternateRowColors";};
j.prototype.onpaste=function(E){if(E.isMarked()||(/^(input|textarea)$/i.test(E.target.tagName))){return;}var i=P.getPastedDataAs2DArray(E.originalEvent);if(!i||i.length===0||i[0].length===0){return;}this.firePaste({data:i});};
j.prototype.ondragenter=function(E){var o=E.dragSession;if(!o||!o.getDropControl()||!o.getDropControl().isA("sap.m.Column")){return;}o.setIndicatorConfig({height:this.getTableDomRef().clientHeight});};
j.prototype._configureAutoPopin=function(){if(this._mutex){return;}var v=this.getColumns(true).filter(function(o){return o.getVisible();});if(!v.length){return;}var i=this.getItems();var p={High:[],Medium:[],Low:[]};v.forEach(function(o){var s=o.getImportance();if(s==="None"){s="Medium";}p[s].push(o);});var k=Object.values(p);var m=k.find(String)[0];k.reduce(function(t,n){return j._updateAccumulatedWidth(n,m,t);},this._getInitialAccumulatedWidth(i));};
j.prototype._getInitialAccumulatedWidth=function(i){var k=this.getInset()?4:0;var $=this.$(),t=3;if($.closest(".sapUiSizeCompact").length||q(document.body).hasClass("sapUiSizeCompact")){t=2;}else{var m=false;$.find(".sapMTableTH[aria-hidden=true]:not(.sapMListTblHighlightCol):not(.sapMListTblDummyCell):not(.sapMListTblNavigatedCol)").get().forEach(function(o){var w=q(o).width();if(!m&&w>0){t=w/parseFloat(l.BaseFontSize);m=true;}});}var s=d.ModeOrder[this.getMode()]?t:0;var A=i.some(function(o){var n=o.getType();return n==="Detail"||n==="DetailAndActive"||n==="Navigation";})?t:0;return k+s+A+0.65;};
j._updateAccumulatedWidth=function(i,m,A){i.forEach(function(o){var w=o.getWidth();var u=w.replace(/[^a-z]/ig,"");var s=parseFloat(l.BaseFontSize)||16;if(u==="px"){A+=parseFloat((parseFloat(w).toFixed(2)/s).toFixed(2));}else if(u==="em"||u==="rem"){A+=parseFloat(w);}else{A+=o.getAutoPopinWidth();}o.setDemandPopin(o!==m);o.setMinScreenWidth(o!==m?A+"rem":"");});return A;};
j.prototype._getHiddenInPopin=function(){return this._getPopins().filter(function(p){return!p.isPopin();});};
j.prototype._getVisiblePopin=function(){return this._getPopins().filter(function(p){return p.isPopin();});};
j.prototype._getPopins=function(){var v=this.getColumns().filter(function(o){return o.getVisible()&&o.getDemandPopin();});return v.filter(function(V){return V._media&&!V._media.matches;});};
j.prototype._firePopinChangedEvent=function(){this.fireEvent("popinChanged",{hasPopin:this.hasPopin(),visibleInPopin:this._getVisiblePopin(),hiddenInPopin:this._getHiddenInPopin()});};
j.prototype._fireUpdateFinished=function(i){L.prototype._fireUpdateFinished.apply(this,arguments);var v=this.getVisibleItems().length;if(!this._iVisibleItemsLength&&v>0){this._iVisibleItemsLength=v;this._firePopinChangedEvent();}else if(this._iVisibleItemsLength>0&&!v){this._iVisibleItemsLength=v;this._firePopinChangedEvent();}};
j.prototype.onItemFocusIn=function(i,F){L.prototype.onItemFocusIn.apply(this,arguments);if(i!=F||!C.getConfiguration().getAccessibility()){return;}this._setFirstLastVisibleCells(i.getDomRef());};
j.prototype._setFirstLastVisibleCells=function(o){var $=q(o);if(!$.hasClass("sapMTableRowCustomFocus")){return;}$.find(".sapMTblLastVisibleCell").removeClass("sapMTblLastVisibleCell");$.find(".sapMTblFirstVisibleCell").removeClass("sapMTblFirstVisibleCell");for(var F=o.firstChild;F&&!F.clientWidth;F=F.nextSibling){}for(var i=o.lastChild.previousSibling;i&&!i.clientWidth;i=i.previousSibling){}q(F).addClass("sapMTblFirstVisibleCell");q(i).addClass("sapMTblLastVisibleCell");};
return j;});
sap.ui.predefine('sap/m/TablePersoController',['./library','./TablePersoDialog','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectRegistry',"sap/ui/core/syncStyleClass","sap/base/Log","sap/ui/thirdparty/jquery"],function(l,T,M,d,s,L,q){"use strict";var R=l.ResetAllMode;
var e=M.extend("sap.m.TablePersoController",{
constructor:function(i,S){M.apply(this,arguments);},
metadata:{properties:{"contentWidth":{type:"sap.ui.core.CSSSize"},"contentHeight":{type:"sap.ui.core.CSSSize",since:"1.22"},"componentName":{type:"string",since:"1.20.2"},"hasGrouping":{type:"boolean",defaultValue:false,since:"1.22"},"showSelectAll":{type:"boolean",defaultValue:true,since:"1.22"},"showResetAll":{type:"boolean",defaultValue:true,since:"1.22"},"resetAllMode":{type:"sap.m.ResetAllMode",defaultValue:R.Default,since:"1.88"}},aggregations:{"_tablePersoDialog":{type:"sap.m.TablePersoDialog",multiple:false,visibility:"hidden"},"persoService":{type:"Object",multiple:false}},associations:{"table":{type:"sap.m.Table",multiple:false},"tables":{type:"sap.m.Table",multiple:true}},events:{personalizationsDone:{}},library:"sap.m"}
});
d.apply(e,{onDuplicate:function(i,o,n){if(o._sapui_candidateForDestroy){L.debug("destroying dangling template "+o+" when creating new object with same ID");o.destroy();}else{var m="adding TablePersoController with duplicate id '"+i+"'";if(sap.ui.getCore().getConfiguration().getNoDuplicateIds()){L.error(m);throw new Error("Error: "+m);}else{L.warning(m);}}}});
e.prototype.init=function(){this._schemaProperty="_persoSchemaVersion";this._schemaVersion="1.0";this._oPersonalizations=null;this._mDelegateMap={};this._mTablePersMap={};this._mInitialTableStateMap={};this._triggersPersDoneEvent=true;};
e.prototype.setResetAllMode=function(r){if(!this._resetAllModeSet){this.setProperty("resetAllMode",r);this._resetAllModeSet=true;}else{L.warning("resetAllMode of the TablePersoController can only be set once.");}};
e.prototype.exit=function(){this._callFunctionForAllTables(q.proxy(function(t){t.removeDelegate(this._mDelegateMap[t]);t._hasTablePersoController=function(){return false;};},this));delete this._mDelegateMap;delete this._mTablePersMap;delete this._mInitialTableStateMap;};
e.prototype.activate=function(){if(this.getResetAllMode()===R.Default){this._callFunctionForAllTables(this._rememberInitialTableStates);}this._callFunctionForAllTables(this._createAndAddDelegateForTable);return this;};
e.prototype.getTablePersoDialog=function(){return this.getAggregation("_tablePersoDialog");};
e.prototype.applyPersonalizations=function(t){var r=this.getPersoService().getPersData();var a=this;r.done(function(p){if(p){a._adjustTable(p,t);}});r.fail(function(){L.error("Problem reading persisted personalization data.");});if(this.getResetAllMode()===R.ServiceDefault){this._callFunctionForAllTables(this._rememberInitialTableStates);}};
e.prototype._createAndAddDelegateForTable=function(t){if(!this._mDelegateMap[t]){var o={onBeforeRendering:function(){this.applyPersonalizations(t);if(!this.getAggregation("_tablePersoDialog")){this._createTablePersoDialog(t);}}.bind(this)};t.addDelegate(o);o.onBeforeRendering();this._mDelegateMap[t]=o;var a=this;t._hasTablePersoController=function(){return!!a._mDelegateMap[this];};}};
e.prototype._createTablePersoDialog=function(t){var o=new T(t.getId()+"-PersoDialog",{persoDialogFor:t,persoMap:this._getPersoColumnMap(t),columnInfoCallback:this._tableColumnInfo.bind(this),initialColumnState:this._mInitialTableStateMap[t],contentWidth:this.getContentWidth(),contentHeight:this.getContentHeight(),hasGrouping:this.getHasGrouping(),showSelectAll:this.getShowSelectAll(),showResetAll:this.getShowResetAll()});if(this.getResetAllMode()===R.ServiceReset&&this.getPersoService().getResetPersData){o.setShowResetAll(false);this.getPersoService().getResetPersData().done(function(r){if(this._bIsBeingDestroyed){return;}if(r){var c=r.aColumns;c.forEach(function(C){var g=null;if(this.getPersoService().getGroup){var t=sap.ui.getCore().byId(o.getPersoDialogFor());var a=this._mTablePersMap[t][C.id];g=this.getPersoService().getGroup(a);C.group=g;}}.bind(this));o.setInitialColumnState(r.aColumns);o.setShowResetAll(this.getShowResetAll());}}.bind(this));}this.setAggregation("_tablePersoDialog",o);o.attachConfirm(q.proxy(function(){this._oPersonalizations=o.retrievePersonalizations();this._callFunctionForAllTables(this._personalizeTable);this.savePersonalizations();this.firePersonalizationsDone();},this));};
e.prototype._adjustTable=function(D,t){if(D&&D.hasOwnProperty(this._schemaProperty)&&D[this._schemaProperty]===this._schemaVersion){this._oPersonalizations=D;if(t){this._personalizeTable(t);}else{this._callFunctionForAllTables(this._personalizeTable);}}};
e.prototype._personalizeTable=function(t){var p=this._getPersoColumnMap(t);if(p&&this._oPersonalizations){var D=false;for(var c=0,a=this._oPersonalizations.aColumns.length;c<a;c++){var n=this._oPersonalizations.aColumns[c];var o=p[n.id];if(!o){o=sap.ui.getCore().byId(n.id);if(o){L.info("Migrating personalization persistence id of column "+n.id);n.id=p[o];D=true;}}if(o){o.setVisible(n.visible);o.setOrder(n.order);}else{L.warning("Personalization could not be applied to column "+n.id+" - not found!");}}if(D){this.savePersonalizations();}t.invalidate();}};
e.prototype.savePersonalizations=function(){var b=this._oPersonalizations;b[this._schemaProperty]=this._schemaVersion;var w=this.getPersoService().setPersData(b);w.done(function(){});w.fail(function(){L.error("Problem persisting personalization data.");});};
e.prototype.refresh=function(){var r=function(o){this._mTablePersMap={};o.invalidate();};this._callFunctionForAllTables(r);var t=this.getAggregation("_tablePersoDialog");if(t){t.setPersoMap(this._getPersoColumnMap(sap.ui.getCore().byId(t.getPersoDialogFor())));}};
e.prototype.openDialog=function(){var t=this.getAggregation("_tablePersoDialog");if(t){s("sapUiSizeCompact",t.getPersoDialogFor(),t._oDialog);t.open();}else{L.warning("sap.m.TablePersoController: trying to open TablePersoDialog before TablePersoService has been activated.");}};
e.prototype.setContentWidth=function(w){this.setProperty("contentWidth",w,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setContentWidth(w);}return this;};
e.prototype.setContentHeight=function(h){this.setProperty("contentHeight",h,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setContentHeight(h);}return this;};
e.prototype.setHasGrouping=function(h){this.setProperty("hasGrouping",h,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setHasGrouping(h);}return this;};
e.prototype.setShowSelectAll=function(S){this.setProperty("showSelectAll",S,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setShowSelectAll(S);}return this;};
e.prototype.setShowResetAll=function(S){this.setProperty("showResetAll",S,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setShowResetAll(S);}return this;};
e.prototype.setComponentName=function(c){this.setProperty("componentName",c,true);return this;};
e.prototype._getMyComponentName=function(c){if(this.getComponentName()){return this.getComponentName();}if(c===null){return"empty_component";}var m=c.getMetadata();if(c.getMetadata().getStereotype()==="component"){return m._sComponentName;}return this._getMyComponentName(c.getParent());};
e.prototype._callFunctionForAllTables=function(t){var o=sap.ui.getCore().byId(this.getAssociation("table"));if(o){t.call(this,o);}var a=this.getAssociation("tables");if(a){for(var i=0,b=this.getAssociation("tables").length;i<b;i++){o=sap.ui.getCore().byId(this.getAssociation("tables")[i]);t.call(this,o);}}};
e.prototype._isStatic=function(i){var u=sap.ui.getCore().getConfiguration().getUIDPrefix();var r=new RegExp("^"+u);return!r.test(i);};
e.prototype._getPersoColumnMap=function(t){var r=this._mTablePersMap[t];if(!r){r={};var E=function(i){var f=i.lastIndexOf("-");return i.substring(f+1);};var a=E.call(this,t.getId());if(!this._isStatic(a)){L.error("Table "+t.getId()+" must have a static id suffix. Otherwise personalization can not be persisted.");r=null;return null;}var n;var c=this._getMyComponentName(t);var b=this;t.getColumns().forEach(function(N){if(r){var f=N.getId();var g=E.call(b,f);if(!b._isStatic(g)){L.error("Suffix "+g+" of table column "+f+" must be static. Otherwise personalization can not be persisted for its table.");r=null;return null;}n=c+"-"+a+"-"+g;r[N]=n;r[n]=N;}});this._mTablePersMap[t]=r;}return r;};
e.prototype._rememberInitialTableStates=function(t){this._mInitialTableStateMap[t]=this._tableColumnInfo(t,this._getPersoColumnMap(t));};
e.prototype._tableColumnInfo=function(t,p){if(p){var c=t.getColumns(),C=[],P=this.getPersoService();c.forEach(function(o){var a=null;if(P.getCaption){a=P.getCaption(o);}var g=null;if(P.getGroup){g=P.getGroup(o);}if(!a){var b=o.getHeader();if(b.getText&&b.getText()){a=b.getText();}else if(b.getTitle&&b.getTitle()){a=b.getTitle();}if(!a){a=o.getId();L.warning("Please 'getCaption' callback implentation in your TablePersoProvider for column "+o+". Table personalization uses column id as fallback value.");}}C.push({text:a,order:o.getOrder(),visible:o.getVisible(),id:p[o],group:g});});C.sort(function(a,b){return a.order-b.order;});return C;}return null;};
return e;});
sap.ui.predefine('sap/m/TablePersoDialog',['./Text','./Title','./Label','./Column','./Button','./Dialog','./ColumnListItem','./Table','./Toolbar','./Bar','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectRegistry','sap/base/Log','sap/m/library','sap/ui/Device','sap/ui/model/Sorter','sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/model/json/JSONModel','sap/m/CheckBox','sap/m/SearchField','sap/m/ScrollContainer',"sap/ui/thirdparty/jquery"],function(T,a,L,C,B,D,b,c,d,e,M,f,g,l,h,S,F,i,J,j,k,m,q){"use strict";var n=l.ButtonType;var o=l.ListMode;var W=l.WrappingType;
var p=M.extend("sap.m.TablePersoDialog",{
constructor:function(I,s){M.apply(this,arguments);},
metadata:{properties:{"contentWidth":{type:"sap.ui.core.CSSSize"},"contentHeight":{type:"sap.ui.core.CSSSize",since:"1.22"},"persoMap":{type:"object"},"columnInfoCallback":{type:"object",since:"1.22"},"initialColumnState":{type:"object",since:"1.22"},"hasGrouping":{type:"boolean",since:"1.22"},"showSelectAll":{type:"boolean",since:"1.22"},"showResetAll":{type:"boolean",since:"1.22"}},aggregations:{"persoService":{type:"Object",multiple:false,deprecated:true}},associations:{"persoDialogFor":"sap.m.Table"},events:{confirm:{},cancel:{}},library:"sap.m"}
});
f.apply(p,{onDuplicate:function(I,r,s){if(r._sapui_candidateForDestroy){g.debug("destroying dangling template "+r+" when creating new object with same ID");r.destroy();}else{var t="adding TablePersoDialog with duplicate id '"+I+"'";if(sap.ui.getCore().getConfiguration().getNoDuplicateIds()){g.error(t);throw new Error("Error: "+t);}else{g.warning(t);}}}});
p.prototype.init=function(){var t=this,r=0;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oP13nModel=new J();this._oP13nModel.setSizeLimit(Number.MAX_VALUE);this._oColumnItemTemplate=new b(this.getId()+"-cli",{selected:"{Personalization>visible}",type:"Active",cells:[new L({wrapping:true,wrappingType:W.Hyphenated,text:"{Personalization>text}"})],press:function(E){this._oSelectedItem=E.oSource;this._fnUpdateArrowButtons.call(this);}.bind(this)}).addStyleClass("sapMPersoDialogLI");this._oButtonUp=new B(this.getId()+"-buttonUp",{icon:"sap-icon://navigation-up-arrow",enabled:false,tooltip:t._oRb.getText('PERSODIALOG_UP'),press:function(){t._moveItem(-1);}});this._oButtonDown=new B(this.getId()+"-buttonDown",{icon:"sap-icon://navigation-down-arrow",enabled:false,tooltip:t._oRb.getText('PERSODIALOG_DOWN'),press:function(){t._moveItem(1);}});this._fnUpdateArrowButtons=function(){if(this.getHasGrouping()){return;}var u=this._oInnerTable.getModel("Personalization").getProperty("/aColumns");var v,w;if(!this._oSelectedItem){v=false;w=false;}else{var I=u.indexOf(this._oSelectedItem.getBindingContext("Personalization").getObject());v=I>0?true:false;w=I<u.length-1?true:false;}this._updateMarkedItem();t._oButtonUp.setEnabled(v);t._oButtonDown.setEnabled(w);}.bind(this);this._fnAfterDialogOpen=function(){t._fnUpdateArrowButtons.call(t);};this._fnAfterScrollContainerRendering=function(){t._oScrollContainer.$().attr('tabindex','-1');};this._oInnerTable=new c(this.getId()+"-colTable",{noDataText:this._oRb.getText('PERSODIALOG_NO_DATA'),mode:o.MultiSelect,width:"100%",sticky:["ColumnHeaders"],columns:[new C({header:new T({text:this._oRb.getText("PERSODIALOG_SELECT_ALL")})})]});this._oSearchField=new k(this.getId()+"-searchField",{width:"100%",liveChange:function(E){var v=E.getSource().getValue(),u=(v?300:0);clearTimeout(r);if(u){r=setTimeout(function(){t._executeSearch();},u);}else{t._executeSearch();}},search:function(){t._executeSearch();}});this._resetAllButton=new B(this.getId()+"-buttonUndo",{text:this._oRb.getText("VIEWSETTINGS_RESET"),press:function(){this._resetAll();}.bind(this)}).addStyleClass("sapMPersoDialogResetBtn");var H=new e({contentLeft:new a(this.getId()+"-Dialog-title",{text:this._oRb.getText("PERSODIALOG_COLUMNS_TITLE")}),contentRight:this._resetAllButton});var s=new d(this.getId()+"-toolbar",{active:false,content:[this._oSearchField,this._oButtonUp,this._oButtonDown]});this._oDialog=new D(this.getId()+"-Dialog",{title:this._oRb.getText("PERSODIALOG_COLUMNS_TITLE"),customHeader:H,draggable:true,resizable:true,stretch:h.system.phone,horizontalScrolling:false,verticalScrolling:true,initialFocus:(h.system.desktop?this._oInnerTable:null),content:[this._oInnerTable],subHeader:s,leftButton:new B(this.getId()+"-buttonOk",{text:this._oRb.getText("PERSODIALOG_OK"),press:function(){t._oDialog.close();t._oSelectedItem=null;t._oSearchField.setValue("");t.fireConfirm();},type:n.Emphasized}),rightButton:new B(this.getId()+"-buttonCancel",{text:this._oRb.getText("PERSODIALOG_CANCEL"),press:function(){t._oDialog.close();t._oSelectedItem=null;t._oSearchField.setValue("");t.fireCancel();}}),afterOpen:this._fnAfterDialogOpen}).addStyleClass("sapMPersoDialog");this._oDialog.setTitle=function(u){this.setProperty("title",u);this.getCustomHeader().getContentLeft()[0].setText(u);};};
p.prototype._updateMarkedItem=function(){if(!this._oSelectedItem){this._oSelectedItem=this._oInnerTable&&this._oInnerTable.getItems().length>0?this._oInnerTable.getItems()[0]:null;}if(this._oSelectedItem){this._oInnerTable.getItems().forEach(function(I){if(I.hasStyleClass("sapMPersoDialogItemSelected")){I.removeStyleClass("sapMPersoDialogItemSelected");}});this._oSelectedItem.addStyleClass("sapMPersoDialogItemSelected");}};
p.prototype.retrievePersonalizations=function(){return this._oP13nModel.getData();};
p.prototype.open=function(){var s=null;if(this.getHasGrouping()){s=[new S('group',false,true)];}this._readCurrentSettingsFromTable();this._oDialog.setModel(this._oP13nModel,"Personalization");this._oInnerTable.bindAggregation("items",{path:"Personalization>/aColumns",key:"text",sorter:s,template:this._oColumnItemTemplate});if(!this._oInnerTable.getSelectedItem()){var I=this._oInnerTable.getItems();if(this.getHasGrouping()){I=I.filter(function(r){return r.getMetadata().getName()!="sap.m.GroupHeaderListItem";});}if(I.length>0){this._sLastSelectedItemId=I[0].getBindingContext('Personalization').getProperty('id');}}this._fnUpdateArrowButtons.call(this);this._oDialog.open();};
p.prototype.setContentHeight=function(H){H=H?H:"28rem";this.setProperty("contentHeight",H,true);this._oDialog.setContentHeight(H);return this;};
p.prototype.setContentWidth=function(w){w=w?w:"25rem";this.setProperty("contentWidth",w,true);this._oDialog.setContentWidth(w);return this;};
p.prototype.exit=function(){this._oRb=null;this._oP13nModel=null;this._oSelectedItem=null;if(this._oColumnItemTemplate){this._oColumnItemTemplate.destroy();this._oColumnItemTemplate=null;}if(this._oInnerTable){this._oInnerTable.destroy();this._oInnerTable=null;}if(this._oSearchField){this._oSearchField.destroy();this._oSearchField=null;}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oButtonDown){this._oButtonDown.destroy();this._oButtonDown=null;}if(this._oButtonUp){this._oButtonUp.destroy();this._oButtonUp=null;}};
p.prototype._resetAll=function(){if(this.getInitialColumnState()){var I=q.extend(true,[],this.getInitialColumnState()),t=this;var r=this._oInnerTable.getSelectedItem();this._sLastSelectedItemId=r&&r.getBindingContext('Personalization')&&r.getBindingContext('Personalization').getProperty('id');if(this._mColumnCaptions){I.forEach(function(s){s.text=t._mColumnCaptions[s.id];});}this._oP13nModel.getData().aColumns=I;this._oP13nModel.updateBindings();sap.ui.getCore().applyChanges();}};
p.prototype._moveItem=function(r){var s=this._oSelectedItem;if(!s){return;}var I=this._oInnerTable.getItems();var t=this._oInnerTable.getModel("Personalization").getProperty("/aColumns");var O=t.indexOf(s.getBindingContext("Personalization").getObject());var N=O+r;N=t.indexOf(I[N].getBindingContext("Personalization").getObject());if(N==O){return;}t.splice(N,0,t.splice(O,1)[0]);t.forEach(function(u,v){u.order=v;});this._oInnerTable.getModel("Personalization").setProperty("/aColumns",t);this._oSelectedItem=I[N];this._scrollToItem(this._oSelectedItem);this._fnUpdateArrowButtons.call(this);};
p.prototype._scrollToItem=function(I){sap.ui.getCore().applyChanges();if(I.getDomRef()){var N=this._oInnerTable.getItems().indexOf(I);var r=I.getDomRef().getBoundingClientRect();var s=this._oDialog.getDomRef("cont").getBoundingClientRect();var v=s.top;var V=s.bottom;var E=r.top;if(E<v+18){this._oInnerTable.scrollToIndex(N);}else if(E>V-18){this._oInnerTable.scrollToIndex(N);}}};
p.prototype._readCurrentSettingsFromTable=function(){var t=sap.ui.getCore().byId(this.getPersoDialogFor()),r=this,s=this.getColumnInfoCallback().call(this,t,this.getPersoMap());this._oP13nModel.setData({aColumns:s});this._mColumnCaptions={};s.forEach(function(u){r._mColumnCaptions[u.id]=u.text;});};
p.prototype._executeSearch=function(){var v=this._oSearchField.getValue(),r=new F("text",i.Contains,v),s=this._oInnerTable.getBinding("items");s.filter([r]);this._fnUpdateArrowButtons.call(this);return this;};
p.prototype.setHasGrouping=function(H){this.setProperty("hasGrouping",H,true);var r=this._oDialog.getSubHeader();if(!H){if(r.getContent().length===1){r.addContent(this._oButtonDown);r.addContent(this._oButtonUp);}}else{r.removeContent(this._oButtonUp);r.removeContent(this._oButtonDown);}return this;};
p.prototype.setShowSelectAll=function(s){this.setProperty("showSelectAll",s,true);var t=s?this._oRb.getText("PERSODIALOG_SELECT_ALL"):this._oRb.getText("PERSODIALOG_COLUMNS_TITLE");this._oInnerTable.getColumns()[0].setHeader(new T({text:t}));this._oInnerTable.bPreventMassSelection=!s;return this;};
p.prototype.setShowResetAll=function(s){this.setProperty("showResetAll",s,true);this._resetAllButton.setVisible(s);return this;};
return p;});
sap.ui.predefine('sap/m/TablePersoProvider',['sap/ui/base/ManagedObject',"sap/base/Log"],function(M,L){"use strict";
var T=M.extend("sap.m.TablePersoProvider",{
constructor:function(i,s){M.apply(this,arguments);},
metadata:{"abstract":true,library:"sap.m"}
});
T.prototype.init=function(){L.warning("This is the abstract base class for a TablePersoProvider. Do not create instances of this class, but use a concrete sub class instead.");L.debug("TablePersoProvider init");};
T.prototype.getPersData=function(){L.debug("TablePersoProvider getPersData");};
T.prototype.setPersData=function(b){L.debug("TablePersoProvider setPersData");};
T.prototype.delPersData=function(){L.debug("TablePersoProvider delPersData");};
T.prototype.getCaption=function(c){return null;};
T.prototype.getGroup=function(c){return null;};
T.prototype.resetPersData=function(){L.debug("TablePersoProvider resetPersData");};
T.prototype.getResetPersData=function(){L.debug("TablePersoProvider getPersData");};
return T;});
sap.ui.predefine('sap/m/TableRenderer',["sap/ui/core/Renderer","sap/ui/core/Core","sap/ui/core/InvisibleText","./library","./ListBaseRenderer","./ColumnListItemRenderer"],function(R,C,I,l,L,a){"use strict";var b=l.ListKeyboardMode;var M=l.MultiSelectMode;var T=R.extend(L);T.apiVersion=2;var r=C.getConfiguration().getRTL();T.columnAlign={left:r?"flex-end":"flex-start",center:"center",right:r?"flex-start":"flex-end"};
T.renderColumns=function(c,t,d){var i=0,h=0,e=false,f=false,m=t.getMode(),g=L.ModeOrder[m],j="sapMListTbl",k=t.getId("tbl"),n=(d=="Head")?"th":"td",o="t"+d.toLowerCase(),p=t.getColumns(),s=t.shouldRenderDummyColumn(),H,q=function(w,x,A){c.openStart(n,x&&k+x);if(n==="th"){c.class("sapMTableTH");c.attr("role",A?"presentation":"columnheader");c.attr("scope","col");}else if(A){c.attr("role","presentation");}A&&c.attr("aria-hidden","true");c.class(j+w);if(d==="Foot"){if(w==="HighlightCol"){c.class("sapMTableHighlightFooterCell");}else if(w==="NavigatedCol"){c.class("sapMTableNavigatedFooterCell");}}c.openEnd();c.close(n);i++;};if(d=="Head"){var v=p.filter(function(w){return w.getVisible();});var F=p.reduce(function(w,x,O){x.setIndex(-1);x.setInitialOrder(O);x.setForcedColumn(false);return(x.getVisible()&&x.getCalculatedMinScreenWidth()<w.getCalculatedMinScreenWidth())?x:w;},v[0]);var u=p.filter(function(w){return w.getVisible()&&!w.isPopin()&&!w.isHidden();}).length;if(!u&&F){F.setForcedColumn(true);u=1;}H=p.every(function(w){return!w.getHeader()||!w.getHeader().getVisible()||!w.getVisible()||w.isPopin()||w.isHidden();});}c.openStart(o);if(t._hasFooter&&d==="Foot"){c.class("sapMTableTFoot");if(t.hasPopin()){c.class("sapMListTblHasPopin");}}c.openEnd();c.openStart("tr",t.addNavSection(k+d+"er"));c.attr("tabindex",-1);if(H){c.class("sapMListTblHeaderNone");}else{c.class("sapMListTblRow").class("sapMListTbl"+d+"er");c.class("sapMLIBFocusable").class("sapMTableRowCustomFocus");}c.openEnd();q("HighlightCol",d+"Highlight",true);if(g==-1){if(m=="MultiSelect"&&d=="Head"&&!H){c.openStart("th");c.class("sapMTableTH");c.attr("scope","col");c.attr("aria-hidden","true");c.class(j+"SelCol");c.attr("role","presentation");c.openEnd();c.renderControl(t.getMultiSelectMode()==M.Default?t._getSelectAllCheckbox():t._getClearAllButton());c.close("th");i++;}else{q("SelCol","",true);}}t.getColumns(true).forEach(function(w,x){if(!w.getVisible()){return;}if(w.isPopin()){e=true;return;}var y=w.isHidden();if(y){h++;}var z=w["get"+d+"er"](),A=t.getFixedLayout(),B=(u==1&&A!="Strict")?"":w.getWidth(),S=w.getStyleClass(true).split(" "),D=w.getCssAlign();t._bCheckLastColumnWidth=A=="Strict"&&u==1;if(d=="Head"){c.openStart(n,w);c.class("sapMTableTH");c.attr("role","columnheader");c.attr("scope","col");var E=w.getSortIndicator().toLowerCase();E!=="none"&&c.attr("aria-sort",E);}else{c.openStart(n);}S&&S.forEach(function(J){c.class(J);});c.class(j+"Cell");c.class(j+d+"erCell");c.attr("data-sap-ui-column",w.getId());c.attr("data-sap-width",w.getWidth());c.style("width",B);if(D&&d!=="Head"){c.style("text-align",D);}if(y){c.style("display","none");c.attr("aria-hidden","true");}c.openEnd();if(z){if(d==="Head"){c.openStart("div");c.class("sapMColumnHeader");var G=w.getColumnHeaderMenu();if((t.bActiveHeaders||G)&&!z.isA("sap.ui.core.InvisibleText")){c.attr("tabindex",0);c.attr("role","button");c.class("sapMColumnHeaderActive");c.attr("aria-haspopup",G?G.getAriaHasPopupType().toLowerCase():"dialog");}else if(t.bFocusableHeaders){c.attr("tabindex",0);c.class("sapMColumnHeaderFocusable");}if(D){c.style("justify-content",T.columnAlign[D]);c.style("text-align",D);}c.openEnd();c.renderControl(z.addStyleClass("sapMColumnHeaderContent"));c.close("div");}else{c.renderControl(z);}}if(d=="Head"&&!f){f=!!w.getFooter();}c.close(n);w.setIndex(i++);});if(e&&s){q("DummyCell",d+"DummyCell",true);}q("NavCol",d+"Nav",true);if(g==1){q("SelCol","",true);}q("NavigatedCol",d+"Navigated",true);if(!e&&s){q("DummyCell",d+"DummyCell",true);}c.close("tr");c.close(o);if(d==="Head"){t._hasPopin=e;t._colCount=i-h;t._hasFooter=f;t._headerHidden=H;}};
T.renderContainerAttributes=function(c,o){c.attr("role","application").attr("data-sap-ui-pasteregion","true");c.attr("aria-roledescription",C.getLibraryResourceBundle("sap.m").getText("TABLE_CONTAINER_ROLE_DESCRIPTION"));c.class("sapMListTblCnt");c.accessibilityState(o,this.getAccessibilityState(o));};
T.renderListStartAttributes=function(c,o){c.openStart("table",o.getId("listUl"));c.class("sapMListTbl");c.attr("aria-labelledby",o.getAriaLabelledBy().concat(this.getAriaLabelledBy(o),I.getStaticId("sap.m","TABLE_ARIA_LABEL")).join(" "));if(o.getFixedLayout()===false){c.style("table-layout","auto");}if(o._iItemNeedsColumn){c.class("sapMListTblHasNav");}};
T.getAriaRole=function(c){return"";};
T.renderListHeadAttributes=function(c,o){this.renderColumns(c,o,"Head");c.openStart("tbody",o.addNavSection(o.getId("tblBody")));c.class("sapMListItems");c.class("sapMTableTBody");if(o.getAlternateRowColors()){c.class(o._getAlternateRowColorsClass());}if(o.hasPopin()){c.class("sapMListTblHasPopin");}c.openEnd();};
T.renderListEndAttributes=function(c,o){c.close("tbody");o._hasFooter&&this.renderColumns(c,o,"Foot");c.close("table");};
T.renderNoData=function(c,o){c.openStart("tr",o.getId("nodata"));c.attr("tabindex",o.getKeyboardMode()==b.Navigation?-1:0);c.class("sapMLIB").class("sapMListTblRow").class("sapMLIBTypeInactive");a.addFocusableClasses(c,o);if(!o._headerHidden||(!o.getHeaderText()&&!o.getHeaderToolbar())){c.class("sapMLIBShowSeparator");}c.openEnd();var d=!o.hasPopin()&&o.shouldRenderDummyColumn();c.openStart("td",o.getId("nodata-text"));c.attr("colspan",o.getColCount()-d);c.class("sapMListTblCell").class("sapMListTblCellNoData");c.openEnd();if(!o.shouldRenderItems()){c.text(C.getLibraryResourceBundle("sap.m").getText("TABLE_NO_COLUMNS"));}else{c.text(o.getNoDataText(true));}c.close("td");if(d){a.renderDummyCell(c,o);}c.close("tr");};
return T;},true);
sap.ui.predefine('sap/m/TableSelectDialog',['./Button','./Dialog','./SearchField','./Table','./library','./SelectDialogBase','sap/ui/core/InvisibleText','sap/ui/Device','sap/m/Toolbar','sap/m/Text','sap/m/BusyIndicator','sap/m/Bar','sap/m/Title','sap/base/Log'],function(B,D,S,T,l,a,I,b,c,d,e,f,g,L){"use strict";var h=l.ListMode;var j=l.ButtonType;var k=l.TitleAlignment;
var m=a.extend("sap.m.TableSelectDialog",{
metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},noDataText:{type:"string",group:"Appearance",defaultValue:null},multiSelect:{type:"boolean",group:"Dimension",defaultValue:false},growing:{type:"boolean",group:"Behavior",defaultValue:true},growingThreshold:{type:"int",group:"Misc",defaultValue:null},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:false},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},showClearButton:{type:"boolean",group:"Behavior",defaultValue:false},confirmButtonText:{type:"string",group:"Appearance"},draggable:{type:"boolean",group:"Behavior",defaultValue:false},resizable:{type:"boolean",group:"Behavior",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:k.Auto}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ColumnListItem",multiple:true,singularName:"item",bindable:"bindable",forwarding:{idSuffix:"-table",aggregation:"items",forwardBinding:true}},_dialog:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},columns:{type:"sap.m.Column",multiple:true,singularName:"column",bindable:"bindable",forwarding:{idSuffix:"-table",aggregation:"columns",forwardBinding:true}}},events:{confirm:{parameters:{selectedItem:{type:"sap.m.StandardListItem"},selectedItems:{type:"sap.m.StandardListItem[]"},selectedContexts:{type:"string"}}},search:{parameters:{value:{type:"string"},itemsBinding:{type:"any"},clearButtonPressed:{type:"boolean"}}},liveChange:{parameters:{value:{type:"string"},itemsBinding:{type:"any"}}},cancel:{}}},
renderer:{apiVersion:2,render:function(){}}
});
m.prototype.init=function(){var t=this,i=0,r=null;r=function(){t._oSelectedItem=t._oTable.getSelectedItem();t._aSelectedItems=t._oTable.getSelectedItems();t._oDialog.detachAfterClose(r);t._fireConfirmAndUpdateSelection();};this._bAppendedToUIArea=false;this._bInitBusy=false;this._bFirstRender=true;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTable=new T(this.getId()+"-table",{growing:t.getGrowing(),growingScrollToLoad:t.getGrowing(),mode:h.SingleSelectMaster,modeAnimationOn:false,sticky:[l.Sticky.InfoToolbar,l.Sticky.ColumnHeaders],infoToolbar:new c({visible:false,active:false,content:[new d({text:this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[0])})]}),selectionChange:function(E){t.fireSelectionChange(E.getParameters());if(t._oDialog){if(!t.getMultiSelect()){t._oDialog.attachAfterClose(r);t._oDialog.close();}else{t._updateSelectionIndicator();}}},updateStarted:this._updateStarted.bind(this),updateFinished:this._updateFinished.bind(this)});this._oTable.getInfoToolbar().addEventDelegate({onAfterRendering:function(){t._oTable.getInfoToolbar().$().attr('aria-live','polite');}});this._table=this._oTable;this._oBusyIndicator=new e(this.getId()+"-busyIndicator").addStyleClass("sapMTableSelectDialogBusyIndicator",true);this._oSearchField=new S(this.getId()+"-searchField",{width:"100%",ariaLabelledBy:I.getStaticId("sap.m","SELECTDIALOG_SEARCH"),liveChange:function(E){var v=E.getSource().getValue(),n=(v?300:0);clearTimeout(i);if(n){i=setTimeout(function(){t._executeSearch(v,false,"liveChange");},n);}else{t._executeSearch(v,false,"liveChange");}},search:function(E){var v=E.getSource().getValue(),n=E.getParameter("clearButtonPressed");t._executeSearch(v,n,"search");}});this._searchField=this._oSearchField;this._oSubHeader=new f(this.getId()+"-subHeader",{contentMiddle:[this._searchField]});var C=new f(this.getId()+"-dialog-header",{titleAlignment:this.getTitleAlignment(),contentMiddle:[new g(this.getId()+"-dialog-title",{level:"H2"})]});this._oDialog=new D(this.getId()+"-dialog",{customHeader:C,titleAlignment:this.getTitleAlignment(),stretch:b.system.phone,contentHeight:"2000px",subHeader:this._oSubHeader,content:[this._oBusyIndicator,this._oTable],endButton:this._getCancelButton(),draggable:this.getDraggable()&&b.system.desktop,resizable:this.getResizable()&&b.system.desktop,escapeHandler:function(p){t._onCancel();p.resolve();}}).addStyleClass("sapMTableSelectDialog");this._dialog=this._oDialog;this.setAggregation("_dialog",this._oDialog);this._sSearchFieldValue="";this._iTableUpdateRequested=0;this._oDialog.getProperty=function(n){if(n!=="title"){return a.prototype.getProperty.call(this,n);}return this.getCustomHeader().getAggregation("contentMiddle")[0].getText();}.bind(this._oDialog);};
m.prototype.exit=function(){this._oTable=null;this._oSearchField=null;this._oSubHeader=null;this._oClearButton=null;this._oBusyIndicator=null;this._sSearchFieldValue=null;this._iTableUpdateRequested=null;this._bInitBusy=false;this._bFirstRender=false;if(this._bAppendedToUIArea){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.removeContent(this,true);}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oOkButton){this._oOkButton.destroy();this._oOkButton=null;}this._oSelectedItem=null;this._aSelectedItems=null;this._aInitiallySelectedItems=null;this._table=null;this._searchField=null;this._dialog=null;};
m.prototype.onAfterRendering=function(){if(this._bInitBusy&&this._bFirstRender){this._setBusy(true);this._bInitBusy=false;this._bFirstRender=false;}return this;};
m.prototype.invalidate=function(){if(this._oDialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._oDialog.invalidate(arguments);}else{a.prototype.invalidate.apply(this,arguments);}return this;};
m.prototype.open=function(s){if(!this.getParent()&&!this._bAppendedToUIArea){var o=sap.ui.getCore().getStaticAreaRef();o=sap.ui.getCore().getUIArea(o);o.addContent(this,true);this._bAppendedToUIArea=true;}this._oSearchField.setValue(s);this._sSearchFieldValue=s||"";this._setInitialFocus();this._oDialog.open();if(this._bInitBusy){this._setBusy(true);}this._aInitiallySelectedItems=this._oTable.getSelectedItems();this._updateSelectionIndicator();return this;};
m.prototype.setGrowing=function(v){this._oTable.setGrowing(v);this._oTable.setGrowingScrollToLoad(v);this.setProperty("growing",v,true);return this;};
m.prototype.setGrowingThreshold=function(v){this._oTable.setGrowingThreshold(v);this.setProperty("growingThreshold",v,true);return this;};
m.prototype.setDraggable=function(v){this._setInteractionProperty(v,"draggable",this._oDialog.setDraggable);return this;};
m.prototype.setResizable=function(v){this._setInteractionProperty(v,"resizable",this._oDialog.setResizable);return this;};
m.prototype._setInteractionProperty=function(v,p,C){this.setProperty(p,v,true);if(!b.system.desktop&&v){L.warning(p+" property works only on desktop devices!");return;}if(b.system.desktop&&this._oDialog){C.call(this._oDialog,v);}};
m.prototype.setBusy=function(i){this._oSearchField.setEnabled(!i);this._oDialog.setBusy.apply(this._oDialog,arguments);return this;};
m.prototype.getBusy=function(){return this._oDialog.getBusy.apply(this._oDialog,arguments);};
m.prototype.setBusyIndicatorDelay=function(v){this._oTable.setBusyIndicatorDelay(v);this._oDialog.setBusyIndicatorDelay(v);this.setProperty("busyIndicatorDelay",v,true);return this;};
m.prototype.setMultiSelect=function(M){this.setProperty("multiSelect",M,true);if(M){this._oTable.setMode(h.MultiSelect);this._oTable.setIncludeItemInSelection(true);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.setBeginButton(this._getOkButton());}else{this._oTable.setMode(h.SingleSelectMaster);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.destroyBeginButton();delete this._oOkButton;}return this;};
m.prototype.setTitle=function(t){this.setProperty("title",t,true);this._oDialog.getCustomHeader().getAggregation("contentMiddle")[0].setText(t);return this;};
m.prototype.setTitleAlignment=function(A){this.setProperty("titleAlignment",A);if(this._oDialog){this._oDialog.setTitleAlignment(A);}return this;};
m.prototype.setConfirmButtonText=function(t){this.setProperty("confirmButtonText",t,true);this._oOkButton&&this._oOkButton.setText(t||this._oRb.getText("SELECT_CONFIRM_BUTTON"));return this;};
m.prototype.setNoDataText=function(n){this._oTable.setNoDataText(n);return this;};
m.prototype.getNoDataText=function(){return this._oTable.getNoDataText();};
m.prototype.getContentWidth=function(){return this._oDialog.getContentWidth();};
m.prototype.setContentWidth=function(w){this._oDialog.setContentWidth(w);return this;};
m.prototype.getContentHeight=function(){return this._oDialog.getContentHeight();};
m.prototype.setContentHeight=function(H){this._oDialog.setContentHeight(H);return this;};
m.prototype.addStyleClass=function(){this._oDialog.addStyleClass.apply(this._oDialog,arguments);return this;};
m.prototype.removeStyleClass=function(){this._oDialog.removeStyleClass.apply(this._oDialog,arguments);return this;};
m.prototype.toggleStyleClass=function(){this._oDialog.toggleStyleClass.apply(this._oDialog,arguments);return this;};
m.prototype.hasStyleClass=function(){return this._oDialog.hasStyleClass.apply(this._oDialog,arguments);};
m.prototype.getDomRef=function(){if(this._oDialog){return this._oDialog.getDomRef.apply(this._oDialog,arguments);}else{return null;}};
m.prototype.setShowClearButton=function(v){this.setProperty("showClearButton",v,true);if(v){var C=this._oDialog.getCustomHeader();C.addContentRight(this._getClearButton());this._oClearButton.setVisible(v);}else if(this._oClearButton){this._oClearButton.setVisible(v);}return this;};
m.prototype.setModel=function(M,s){this._setBusy(false);this._bInitBusy=false;this._iTableUpdateRequested+=1;this._oTable.setModel(M,s);a.prototype.setModel.apply(this,arguments);this._updateSelectionIndicator();return this;};
m.prototype.setBindingContext=function(C,M){this._oTable.setBindingContext(C,M);a.prototype.setBindingContext.apply(this,arguments);return this;};
m.prototype._executeSearch=function(v,C,E){var t=this._oTable,o=(t?t.getBinding("items"):undefined),s=(this._sSearchFieldValue!==v);if(this._oDialog.isOpen()&&((s&&E==="liveChange")||E==="search")){this._sSearchFieldValue=v;if(o){this._iTableUpdateRequested+=1;if(E==="search"){this.fireSearch({value:v,itemsBinding:o,clearButtonPressed:C});}else if(E==="liveChange"){this.fireLiveChange({value:v,itemsBinding:o});}}else{if(E==="search"){this.fireSearch({value:v,clearButtonPressed:C});}else if(E==="liveChange"){this.fireLiveChange({value:v});}}}return this;};
m.prototype._setBusy=function(i){if(this._iTableUpdateRequested){if(i){this._oSearchField.setEnabled(false);this._oTable.addStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','inline-block');}else{this._oSearchField.setEnabled(true);this._oTable.removeStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','none');}}};
m.prototype._updateStarted=function(E){this.fireUpdateStarted(E.getParameters());if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){if(this._oDialog.isOpen()&&this._iTableUpdateRequested){this._setBusy(true);}else{this._bInitBusy=true;}}};
m.prototype._updateFinished=function(E){this.fireUpdateFinished(E.getParameters());this._updateSelectionIndicator();if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){this._setBusy(false);this._bInitBusy=false;}this._iTableUpdateRequested=0;};
m.prototype._getOkButton=function(){var t=this,o=null;o=function(){t._sSearchFieldValue=null;t._oSelectedItem=t._oTable.getSelectedItem();t._aSelectedItems=t._oTable.getSelectedItems();t._oDialog.detachAfterClose(o);t._fireConfirmAndUpdateSelection();};if(!this._oOkButton){this._oOkButton=new B(this.getId()+"-ok",{type:j.Emphasized,text:this.getConfirmButtonText()||this._oRb.getText("SELECT_CONFIRM_BUTTON"),press:function(){t._oDialog.attachAfterClose(o);t._oDialog.close();}});}return this._oOkButton;};
m.prototype._getCancelButton=function(){var t=this;if(!this._oCancelButton){this._oCancelButton=new B(this.getId()+"-cancel",{text:this._oRb.getText("MSGBOX_CANCEL"),press:function(){t._onCancel();}});}return this._oCancelButton;};
m.prototype._getClearButton=function(){if(!this._oClearButton){this._oClearButton=new B(this.getId()+"-clear",{text:this._oRb.getText("TABLESELECTDIALOG_CLEARBUTTON"),press:function(){this._removeSelection();this._updateSelectionIndicator();this._oDialog.focus();}.bind(this)});}return this._oClearButton;};
m.prototype._onCancel=function(E){var t=this,A=null;A=function(){t._oSelectedItem=null;t._aSelectedItems=[];t._sSearchFieldValue=null;t._oDialog.detachAfterClose(A);t.fireCancel();};t._resetSelection();this._oDialog.attachAfterClose(A);this._oDialog.close();};
m.prototype._updateSelectionIndicator=function(){var s=this._oTable.getSelectedContextPaths(true).length,i=this._oTable.getInfoToolbar();if(this.getShowClearButton()&&this._oClearButton){this._oClearButton.setEnabled(s>0);}i.setVisible(!!s);i.getContent()[0].setText(this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[s]));};
m.prototype._fireConfirmAndUpdateSelection=function(){var p={selectedItem:this._oSelectedItem,selectedItems:this._aSelectedItems};Object.defineProperty(p,"selectedContexts",{get:this._oTable.getSelectedContexts.bind(this._oTable,true)});this.fireConfirm(p);this._updateSelection();};
m.prototype._updateSelection=function(){if(!this.getRememberSelections()&&!this.bIsDestroyed){this._removeSelection();}};
m.prototype._removeSelection=function(){this._oTable.removeSelections(true);delete this._oSelectedItem;delete this._aSelectedItems;};
m.prototype._resetSelection=function(){var i=0;if(!this.bIsDestroyed){var o=this._oTable.getBinding("items");if(o&&o.aFilters&&o.aFilters.length){o.filter([]);}this._oTable.removeSelections();for(;i<this._aInitiallySelectedItems.length;i++){this._oTable.setSelectedItem(this._aInitiallySelectedItems[i]);}}};
return m;});
sap.ui.predefine('sap/m/Text',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/library','sap/ui/Device','sap/m/HyphenationSupport',"./TextRenderer"],function(l,C,a,c,D,H,T){"use strict";var b=c.TextAlign;var d=c.TextDirection;var W=l.WrappingType;var E=l.EmptyIndicatorMode;
var e=a.extend("sap.m.Text",{metadata:{interfaces:["sap.ui.core.IShrinkable","sap.ui.core.IFormContent","sap.ui.core.ISemanticFormContent","sap.m.IHyphenation"],library:"sap.m",properties:{text:{type:"string",defaultValue:'',bindable:"bindable"},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:d.Inherit},wrapping:{type:"boolean",group:"Appearance",defaultValue:true},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:b.Begin},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},maxLines:{type:"int",group:"Appearance",defaultValue:null},renderWhitespace:{type:"boolean",group:"Appearance",defaultValue:false},emptyIndicatorMode:{type:"sap.m.EmptyIndicatorMode",group:"Appearance",defaultValue:E.Off}},designtime:"sap/m/designtime/Text.designtime"}});
e.prototype.normalLineHeight=1.2;e.prototype.cacheLineHeight=true;e.prototype.ellipsis='...';e.hasNativeLineClamp=("webkitLineClamp"in document.documentElement.style);
e.setNodeValue=function(o,n){n=n||"";var f=o.childNodes;if(f.length===1&&f[0].nodeType===window.Node.TEXT_NODE){f[0].nodeValue=n;}else{o.textContent=n;}};
e.prototype.getText=function(n){var t=this.getProperty("text");if(n){return t.replace(/\r\n|\n\r|\r/g,"\n");}return t;};
e.prototype.onAfterRendering=function(){if(this.getVisible()&&this.hasMaxLines()&&!this.canUseNativeLineClamp()){if(C.isThemeApplied()){this.clampHeight();}else{C.attachThemeChanged(this._handleThemeLoad,this);}}};
e.prototype._handleThemeLoad=function(){this.clampHeight();C.detachThemeChanged(this._handleThemeLoad,this);};
e.prototype.hasMaxLines=function(){return(this.getWrapping()&&this.getMaxLines()>1);};
e.prototype.getTextDomRef=function(){if(!this.getVisible()){return null;}if(this.hasMaxLines()){return this.getDomRef("inner");}return this.getDomRef();};
e.prototype.canUseNativeLineClamp=function(){if(!e.hasNativeLineClamp){return false;}if(this.getTextDirection()==d.RTL){return false;}if(this.getTextDirection()==d.Inherit&&C.getConfiguration().getRTL()){return false;}return true;};
e.prototype.getLineHeight=function(o){if(this.cacheLineHeight&&this._fLineHeight){return this._fLineHeight;}o=o||this.getTextDomRef();if(!o){return 0;}var s=window.getComputedStyle(o),L=s.lineHeight,f;if(/px$/i.test(L)){f=parseFloat(L);}else if(/^normal$/i.test(L)){f=parseFloat(s.fontSize)*this.normalLineHeight;}else{f=parseFloat(s.fontSize)*parseFloat(L);}if(!D.browser.firefox){f=Math.floor(f);}if(this.cacheLineHeight&&f){this._fLineHeight=f;}return f;};
e.prototype.getClampHeight=function(o){o=o||this.getTextDomRef();return this.getMaxLines()*this.getLineHeight(o);};
e.prototype.clampHeight=function(o){o=o||this.getTextDomRef();if(!o){return 0;}var m=this.getClampHeight(o);if(m){o.style.maxHeight=m+"px";}return m;};
e.prototype.clampText=function(o,s,i){o=o||this.getTextDomRef();if(!o){return;}var f;var t=this.getText(true);var m=this.getClampHeight(o);s=s||0;i=i||t.length;e.setNodeValue(o,t.slice(0,i));if(o.scrollHeight>m){var S=o.style,h=S.height,g=this.ellipsis,j=g.length;S.height=m+"px";while((i-s)>j){f=(s+i)>>1;e.setNodeValue(o,t.slice(0,f-j)+g);if(o.scrollHeight>m){i=f;}else{s=f;}}if(o.scrollHeight>m&&s>0){f=s;o.textContent=t.slice(0,f-j)+g;}S.height=h;}return f;};
e.prototype.getAccessibilityInfo=function(){return{description:this.getText()};};
e.prototype.getTextsToBeHyphenated=function(){return{"main":this.getText(true)};};
e.prototype.getDomRefsForHyphenatedTexts=function(){return{"main":this.getTextDomRef()};};
H.mixInto(e.prototype);return e;});
sap.ui.predefine('sap/m/TextArea',['./InputBase','./Text','sap/ui/core/ResizeHandler','./library','sap/ui/core/library','sap/ui/events/KeyCodes','sap/ui/Device',"sap/base/security/encodeXML",'./TextAreaRenderer',"sap/ui/thirdparty/jquery"],function(I,T,R,l,c,K,D,a,b,q){"use strict";var W=c.Wrapping;
var d=I.extend("sap.m.TextArea",{metadata:{library:"sap.m",designtime:"sap/m/designtime/TextArea.designtime",properties:{rows:{type:"int",group:"Appearance",defaultValue:2},cols:{type:"int",group:"Appearance",defaultValue:20},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},maxLength:{type:"int",group:"Behavior",defaultValue:0},showExceededText:{type:"boolean",group:"Behavior",defaultValue:false},wrapping:{type:"sap.ui.core.Wrapping",group:"Behavior",defaultValue:W.None},valueLiveUpdate:{type:"boolean",group:"Behavior",defaultValue:false},growing:{type:"boolean",group:"Behavior",defaultValue:false},growingMaxLines:{type:"int",group:"Behavior",defaultValue:0}},aggregations:{_counter:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{liveChange:{parameters:{value:{type:"string"}}}},dnd:{draggable:false,droppable:true}}});
d.prototype.init=function(){var C;I.prototype.init.call(this);this.sResizeListenerId=null;this._bPasteIsTriggered=false;C=new T(this.getId()+'-counter',{}).addStyleClass("sapMTextAreaCounter").setVisible(false);this.setAggregation("_counter",C);};
d.prototype.setShowExceededText=function(v){var C=this.getAggregation("_counter"),V;if(v){if(this.getAriaLabelledBy().indexOf(C.getId())<0){this.addAriaLabelledBy(C.getId());}}else{C=this.getAggregation("_counter");C&&this.removeAriaLabelledBy(C.getId());V=this.getValue();if(this.getMaxLength()){V=V.substring(0,this.getMaxLength());this.setValue(V);}}C.setVisible(v);this.setProperty("showExceededText",v);this._updateMaxLengthAttribute();return this;};
d.prototype.exit=function(){I.prototype.exit.call(this);q(window).off("resize.sapMTextAreaGrowing");this._detachResizeHandler();this._deregisterEvents();};
d.prototype.onBeforeRendering=function(){I.prototype.onBeforeRendering.call(this);var C=this.getAggregation("_counter");if((this.getMaxLength()<=0||!this.getShowExceededText())&&C.getVisible()){C.setVisible(false);}this._detachResizeHandler();if(this.getGrowing()){q(window).on("resize.sapMTextAreaGrowing",this._updateOverflow.bind(this));}else{q(window).off("resize.sapMTextAreaGrowing");}};
d.prototype.onAfterRendering=function(){I.prototype.onAfterRendering.call(this);if(this.getGrowing()){this._sResizeListenerId=R.register(this,this._resizeHandler.bind(this));if(this.getGrowingMaxLines()>0){this._setGrowingMaxHeight();}this._adjustContainerDimensions();}this._updateMaxLengthAttribute();if(!D.support.touch){return;}var t=this.$("inner");if(this._behaviour.INSIDE_SCROLLABLE_WITHOUT_FOCUS){t.on("touchstart",q.proxy(this._onTouchStart,this));t.on("touchmove",q.proxy(this._onTouchMove,this));}else if(this._behaviour.PAGE_NON_SCROLLABLE_AFTER_FOCUS){t.on("touchmove",function(e){if(t.is(":focus")){e.stopPropagation();}});}};
d.prototype._deregisterEvents=function(){this.$("inner").off("touchstart").off("touchmove");};
d.prototype._setGrowingMaxHeight=function(){var h=this.getDomRef('hidden'),C=sap.ui.getCore(),L=C.getLoadedLibraries(),f,m,s;if(!L||!L['sap.m']){C.attachThemeChanged(this._setGrowingMaxHeight.bind(this));return;}C.detachThemeChanged(this._setGrowingMaxHeight);s=window.getComputedStyle(h);f=this._getLineHeight();m=(f*this.getGrowingMaxLines())+parseFloat(s.getPropertyValue("padding-top"))+parseFloat(s.getPropertyValue("border-top-width"))+parseFloat(s.getPropertyValue("border-bottom-width"));if(D.browser.firefox){m+=parseFloat(s.getPropertyValue("padding-bottom"));}h.style.maxHeight=m+"px";};
d.prototype._getLineHeight=function(){var t=this.getFocusDomRef(),s;if(!t){return;}s=window.getComputedStyle(t);return isNaN(parseFloat(s.getPropertyValue("line-height")))?1.4*parseFloat(s.getPropertyValue("font-size")):parseFloat(s.getPropertyValue("line-height"));};
d.prototype._resizeHandler=function(e){this._adjustContainerDimensions();};
d.prototype._detachResizeHandler=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
d.prototype.onsapenter=function(e){e.setMarked();};
d.prototype.onValueRevertedByEscape=function(v){if(this.getValueLiveUpdate()){this.setProperty("value",v,true);v=this.getValue();}this.fireLiveChange({value:v,newValue:v});};
d.prototype.getValue=function(){var t=this.getFocusDomRef();return t?t.value:this.getProperty("value");};
d.prototype.setValue=function(v){I.prototype.setValue.call(this,v);this._handleShowExceededText();if(this.getGrowing()){this._adjustContainerDimensions();}return this;};
d.prototype.onsapnext=function(e){e.setMarked();};
d.prototype.onsapprevious=function(e){e.setMarked();};
d.prototype.oninput=function(e){I.prototype.oninput.call(this,e);if(this._bPasteIsTriggered){this._bPasteIsTriggered=false;this._selectExceededText();}if(e.isMarked("invalid")){return;}var t=this.getFocusDomRef(),v=t.value,s=this.getShowExceededText(),m=this.getMaxLength();if(!s&&m&&v.length>m){v=v.substring(0,m);t.value=v;}if(this.getValueLiveUpdate()){this.setProperty("value",v,true);v=this.getValue();}this._handleShowExceededText();if(this.getGrowing()){this._adjustContainerDimensions();}this.fireLiveChange({value:v,newValue:v});};
d.prototype.onpaste=function(e){if(this.getShowExceededText()){this._bPasteIsTriggered=true;}};
d.prototype._adjustContainerDimensions=function(){var t=this.getFocusDomRef(),h=this.getDomRef("hidden"),H,n;if(!t||!h){return;}h.style.width="";if(this.getGrowing()&&!this.getWidth()&&this.getCols()!==20){h.style.width=(this.getCols()*0.5)+"rem";}H=h.style["min-height"];n=this.getRows()*this._getLineHeight()+"px";if(!H||n!==H){h.style["min-height"]=n;}h.innerHTML=a(t.value)+'&nbsp;';this._updateOverflow();};
d.prototype._updateOverflow=function(){var t=this.getFocusDomRef(),h=this.getDomRef("hidden"),m;if(t){m=parseFloat(window.getComputedStyle(h)["max-height"]);t.style.overflowY=(h.scrollHeight>m)?"auto":"";}};
d.prototype._getInputValue=function(v){v=(v===undefined)?this.$("inner").val()||"":v.toString();if(this.getMaxLength()>0&&!this.getShowExceededText()){v=v.substring(0,this.getMaxLength());}return v.replace(/\r\n/g,"\n");};
d.prototype._selectExceededText=function(){var v=this.getValue().length;if(v>this.getMaxLength()){this.selectText(this.getMaxLength(),v);}};
d.prototype._updateMaxLengthAttribute=function(){var t=this.getFocusDomRef();if(!t){return;}if(this.getShowExceededText()){t.removeAttribute("maxlength");this._handleShowExceededText();}else{this.getMaxLength()&&t.setAttribute("maxlength",this.getMaxLength());}};
d.prototype._handleShowExceededText=function(){var C=this.getAggregation("_counter"),m=this.getMaxLength(),s;if(!this.getDomRef()||!this.getShowExceededText()||!m){return;}s=this._getCounterValue();C.setText(s);};
d.prototype._maxLengthIsExceeded=function(v){var r=false;if(this.getMaxLength()>0&&this.getShowExceededText()&&this.getValue().length>this.getMaxLength()){r=true;}return r;};
d.prototype._getCounterValue=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m"),C=this.getMaxLength()-this.getValue().length,e=(C<0?true:false),m="TEXTAREA_CHARACTER"+(Math.abs(C)===1?"":"S")+"_"+(e?"EXCEEDED":"LEFT");return B.getText(m,[Math.abs(C)]);};
d.prototype._behaviour=(function(o){return{INSIDE_SCROLLABLE_WITHOUT_FOCUS:o.os.ios||o.browser.chrome,PAGE_NON_SCROLLABLE_AFTER_FOCUS:o.os.android};}(D));
d.prototype._onTouchStart=function(e){var t=e.touches[0];this._iStartY=t.pageY;this._iStartX=t.pageX;this._bHorizontalScroll=undefined;e.setMarked("swipestartHandled");};
d.prototype._onTouchMove=function(e){var t=this.getFocusDomRef(),p=e.touches[0].pageY,s=t.scrollTop,f=s<=0,B=s+t.clientHeight>=t.scrollHeight,g=this._iStartY>p,G=this._iStartY<p,o=f&&G||B&&g;if(this._bHorizontalScroll===undefined){this._bHorizontalScroll=Math.abs(this._iStartY-p)<Math.abs(this._iStartX-e.touches[0].pageX);}if(this._bHorizontalScroll||!o){e.setMarked();}};
d.prototype.onkeyup=function(e){if(e.keyCode===K.ENTER){e.setMarked("enterKeyConsumedAsContent");}};
return d;});
sap.ui.predefine('sap/m/TextAreaRenderer',['sap/ui/core/Renderer','./InputBaseRenderer','sap/ui/Device','sap/ui/core/library'],function(R,I,D,c){"use strict";var W=c.Wrapping;var T=R.extend(I);T.apiVersion=2;
T.addOuterClasses=function(r,C){r.class("sapMTextArea");if(C.getShowExceededText()){r.class("sapMTextAreaWithCounter");}if(C.getHeight()){r.class("sapMTextAreaWithHeight");}};
T.addOuterStyles=function(r,C){C.getHeight()&&r.style("height",C.getHeight());};
T.writeDecorations=function(r,C){var o=C.getAggregation("_counter");r.renderControl(o);};
T.openInputTag=function(r,C){r.openStart("textarea",C.getId()+"-"+this.getInnerSuffix());};
T.endInputTag=function(r,C){r.openEnd();};
T.closeInputTag=function(r,C){r.close("textarea");};
T.prependInnerContent=function(r,C){if(C.getGrowing()){r.openStart("div",C.getId()+'-hidden');r.class("sapMTextAreaMirror");r.openEnd().close("div");}};
T.writeInnerValue=function(){};
T.writeInnerContent=function(r,C){var v=C.getValue();r.text(v);};
T.addInnerClasses=function(r,C){r.class("sapMTextAreaInner");if(C.getGrowing()){r.class("sapMTextAreaGrow");}};
T.getAriaRole=function(C){return"";};
T.writeInnerAttributes=function(r,C){if(C.getWrapping()!=W.None){r.attr("wrap",C.getWrapping());}r.attr("rows",C.getRows());r.attr("cols",C.getCols());};
return T;},true);
sap.ui.predefine('sap/m/TextRenderer',['sap/ui/core/Renderer','sap/ui/core/library','sap/m/HyphenationSupport','./library','sap/ui/core/Core'],function(R,c,H,m,C){"use strict";var T=c.TextDirection;var W=m.WrappingType;var E=m.EmptyIndicatorMode;var r=C.getLibraryResourceBundle("sap.m");var a={apiVersion:2};
a.render=function(o,t){var w=t.getWidth(),s=t.getText(true),b=t.getTextDirection(),d=t.getTooltip_AsString(),n=t.getMaxLines(),e=t.getWrapping(),f=t.getWrappingType(),g=t.getTextAlign(),h=t.getRenderWhitespace();o.openStart("span",t);o.class("sapMText");o.class("sapUiSelectable");if(t.hasMaxLines()){o.class("sapMTextMaxLineWrapper");}if(!e||n==1){o.class("sapMTextNoWrap");}else if(e&&f!==W.Hyphenated){if(s&&s.length>0&&!/\s/.test(s)){o.class("sapMTextBreakWord");}}w?o.style("width",w):o.class("sapMTextMaxWidth");o.attr("dir",b!==T.Inherit?b.toLowerCase():"auto");d&&o.attr("title",d);if(g){g=R.getTextAlign(g,b);if(g){o.style("text-align",g);}}if(h){var i=e?"sapMTextRenderWhitespaceWrap":"sapMTextRenderWhitespace";o.class(i);}H.writeHyphenationClass(o,t);o.openEnd();if(t.hasMaxLines()){this.renderMaxLines(o,t);}else{this.renderText(o,t);}o.close("span");};
a.renderMaxLines=function(o,t){o.openStart("span",t.getId()+"-inner");o.class("sapMTextMaxLine");if(t.canUseNativeLineClamp()){o.class("sapMTextLineClamp");o.style("-webkit-line-clamp",t.getMaxLines());}o.openEnd();this.renderText(o,t);o.close("span");};
a.renderText=function(o,t){var s=H.getTextForRender(t,"main");if(t.getEmptyIndicatorMode()!==E.Off&&!t.getText()){this.renderEmptyIndicator(o,t);}else{o.text(s);}};
a.renderEmptyIndicator=function(o,t){o.openStart("span");o.class("sapMEmptyIndicator");if(t.getEmptyIndicatorMode()===E.Auto){o.class("sapMEmptyIndicatorAuto");}o.openEnd();o.openStart("span");o.attr("aria-hidden",true);o.openEnd();o.text(r.getText("EMPTY_INDICATOR"));o.close("span");o.openStart("span");o.class("sapUiPseudoInvisibleText");o.openEnd();o.text(r.getText("EMPTY_INDICATOR_TEXT"));o.close("span");o.close("span");};
return a;},true);
sap.ui.predefine('sap/m/Tile',['./library','sap/ui/core/InvisibleText','sap/ui/core/Control','sap/ui/Device','./TileRenderer',"sap/ui/thirdparty/jquery"],function(l,I,C,D,T,q){"use strict";
var a=C.extend("sap.m.Tile",{metadata:{library:"sap.m",deprecated:true,properties:{removable:{type:"boolean",group:"Misc",defaultValue:true}},events:{press:{}}}});
a.prototype.init=function(){if(D.system.desktop){var o=q.proxy(function(e){if(e.srcControl===this&&!e.isMarked()){this.ontap();e.stopPropagation();}},this);this.onsapspace=o;this.onsapenter=o;}};
a.prototype.onAfterRendering=function(){if(this._rendered&&!this._bIsDragged&&this.getParent()instanceof sap.m.TileContainer){this.setPos(this._posX,this._posY);}this._rendered=true;};
a.prototype.setPos=function(x,y){this._posX=x=Math.floor(x);this._posY=y=Math.floor(y);if(!this._rendered){return;}var o=this.getDomRef();if(!o){return;}if("webkitTransform"in o.style){this.$().css('-webkit-transform','translate3d('+x+'px,'+y+'px,0)');}else if("transform"in o.style){this.$().css('transform','translate3d('+x+'px,'+y+'px,0)');}else if("msTransform"in o.style){this.$().css('msTransform','translate('+x+'px,'+y+'px)');}else if("MozTransform"in o.style){this.$().css('-moz-transform','translate3d('+x+'px,'+y+'px,0)');}if(this._invisible){this.$().css("visibility","");delete this._invisible;}};
a.prototype.setSize=function(w,h){this._width=w;this._height=h;};
a.prototype.isEditable=function(i){var o=this._bIsEditable;if(i===true||i===false){this._bIsEditable=i;}if(o!=i&&this.$()){this.$().attr("aria-describedBy",i?I.getStaticId("sap.m","TILE_REMOVE_BY_DEL_KEY"):null);}return this._bIsEditable;};
a.prototype.isDragged=function(i){if(!this._bIsEditable){return;}if(i===true||i===false){var o=this.$();o.toggleClass("sapMTileDrag",i);this._bIsDragged=i;}return this._bIsDragged;};
a.prototype.ontouchstart=function(e){if(!this.isEditable()&&!this._parentPreventsTapEvent){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",true);this._clientX=e.clientX;this._clientY=e.clientY;}};
a.prototype.ontouchend=function(){if(!this.isEditable()){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",false);}};
Object.defineProperty(a.prototype,"_parentPreventsTapEvent",{get:function(){var p=this.getParent();while(p){if(p._bAvoidChildTapEvent||(p instanceof a&&p.isEditable())){return true;}p=p.getParent();}return false;}});
a.prototype.ontouchmove=function(e){if(!this.isEditable()&&!this._parentPreventsTapEvent){if(Math.abs(e.clientX-this._clientX)>30||Math.abs(e.clientY-this._clientY)>10){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",false);}}};
a.prototype.ontap=function(){if(!this.isEditable()&&!this._parentPreventsTapEvent){this.firePress({});}};
a.prototype.setVisible=function(v){this.setProperty("visible",v);if(!v){this._rendered=false;}if(this.getParent()&&this.getParent()instanceof sap.m.TileContainer){this.getParent().invalidate();}return this;};
a.prototype._setVisible=function(v){this._invisible=!v;return this;};
return a;});
sap.ui.predefine('sap/m/TileContainer',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/Device','sap/ui/core/ResizeHandler','./TileContainerRenderer',"sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Selectors"],function(l,C,I,D,R,T,L,q){"use strict";
var a=C.extend("sap.m.TileContainer",{metadata:{library:"sap.m",deprecated:true,properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},editable:{type:"boolean",group:"Misc",defaultValue:null},allowAdd:{type:"boolean",group:"Misc",defaultValue:null}},defaultAggregation:"tiles",aggregations:{tiles:{type:"sap.m.Tile",multiple:true,singularName:"tile"}},events:{tileMove:{parameters:{tile:{type:"sap.m.Tile"},newIndex:{type:"int"}}},tileDelete:{parameters:{tile:{type:"sap.m.Tile"}}},tileAdd:{}}}});
I.insertFontFaceStyle();a.prototype._bRtl=sap.ui.getCore().getConfiguration().getRTL();
a.prototype.init=function(){this._iCurrentTileStartIndex=0;this._oDim=null;this._iScrollLeft=0;this._iScrollGap=0;if(!D.system.desktop){this._iScrollGap=0;}this.bAllowTextSelection=false;this._oDragSession=null;this._oTouchSession=null;this._bAvoidChildTapEvent=false;this._iEdgeShowStart=D.system.phone?10:20;if(D.system.phone){this._iTriggerScrollOffset=10;}else if(D.system.desktop){this._iTriggerScrollOffset=-40;}else{this._iTriggerScrollOffset=20;}this._iCurrentFocusIndex=-1;if(D.system.desktop||D.system.combi){var o=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var r=this._iCurrentFocusIndex-this._iCurrentFocusIndex%this._iMaxTilesX;var F=this._iCurrentTileStartIndex===this._iCurrentFocusIndex?0:this._iCurrentTileStartIndex;var t=E.ctrlKey?F:r;var m=this._getVisibleTiles()[t];if(m){this._findTile(m.$()).trigger("focus");E.stopPropagation();}this._handleAriaActiveDescendant();}},this),O=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var r=this._iCurrentFocusIndex-this._iCurrentFocusIndex%this._iMaxTilesX;var m=r+this._iMaxTilesX<t.length?r+this._iMaxTilesX-1:t.length-1;var n=this._iCurrentTileStartIndex+this._iMaxTiles<t.length?this._iCurrentTileStartIndex+this._iMaxTiles-1:t.length-1;var p=n===this._iCurrentFocusIndex?t.length-1:n;var s=E.ctrlKey?p:m;if(t.length>0){this._findTile(t[s].$()).trigger("focus");E.stopPropagation();}this._handleAriaActiveDescendant();}},this),f=q.proxy(function(E){var t=this._getVisibleTiles();if(t.length>0){var n=this._iCurrentFocusIndex-this._iMaxTiles>=0?this._iCurrentFocusIndex-this._iMaxTiles:0;var N=t[n];if(N){this._renderTilesInTheSamePage(n,t);this._findTile(N.$()).trigger("focus");E.stopPropagation();}this._handleAriaActiveDescendant();}},this),d=q.proxy(function(E){var t=this._getVisibleTiles(),m=t.length;if(m>0){var n=this._iCurrentFocusIndex+this._iMaxTiles<m?this._iCurrentFocusIndex+this._iMaxTiles:m-1;var N=t[n];if(N){this._renderTilesInTheSamePage(n,t);this._findTile(N.$()).trigger("focus");E.stopPropagation();}this._handleAriaActiveDescendant();}},this),e=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var n=this._iCurrentFocusIndex+1<t.length?this._iCurrentFocusIndex+1:this._iCurrentFocusIndex;if(!E.ctrlKey){var N=t[n];if(N){if(n<this._iCurrentTileStartIndex+this._iMaxTiles){this._findTile(N.$()).trigger("focus");}else{this._renderTilesInTheSamePage(n,t);this.scrollIntoView(N,true,t);var m=this;setTimeout(function(){m._findTile(N.$()).trigger("focus");},400);}}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().trigger("focus");}this._handleAriaActiveDescendant();E.stopPropagation();}},this),g=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var n=this._iCurrentFocusIndex-1>=0?this._iCurrentFocusIndex-1:this._iCurrentFocusIndex;if(!E.ctrlKey){var N=t[n];if(N){if(n>=this._iCurrentTileStartIndex){this._findTile(N.$()).trigger("focus");}else{this._renderTilesInTheSamePage(n,t);this.scrollIntoView(N,true,t);var m=this;setTimeout(function(){m._findTile(N.$()).trigger("focus");},400);}}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().trigger("focus");}this._handleAriaActiveDescendant();E.stopPropagation();}},this),i=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0){var m=this._iCurrentFocusIndex%this._iMaxTiles,n=this._iCurrentFocusIndex+this._iMaxTilesX,M=n%this._iMaxTiles;if(!E.ctrlKey){var N=t[n];if((M>m)&&N){this._findTile(N.$()).trigger("focus");}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().trigger("focus");}this._handleAriaActiveDescendant();E.stopPropagation();}},this),j=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0){var m=this._iCurrentFocusIndex%this._iMaxTiles,n=this._iCurrentFocusIndex-this._iMaxTilesX,M=n%this._iMaxTiles;if(!E.ctrlKey){var N=t[n];if((M<m)&&N){this._findTile(N.$()).trigger("focus");}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().trigger("focus");}this._handleAriaActiveDescendant();E.stopPropagation();}},this),k=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0&&this.getEditable()){var m=t[this._iCurrentFocusIndex];if(m.getRemovable()){this.deleteTile(m);t=this._getVisibleTiles();if(this._iCurrentFocusIndex===t.length){if(t.length!==0){t[this._iCurrentFocusIndex-1].$().trigger("focus");}else{this._findNextTabbable().trigger("focus");}}else{t[this._iCurrentFocusIndex].$().trigger("focus");}this._handleAriaActiveDescendant();}E.stopPropagation();}},this);this.onsaphome=o;this.onsaphomemodifiers=o;this.onsapend=O;this.onsapendmodifiers=O;this.onsapright=this._bRtl?g:e;this.onsaprightmodifiers=this._bRtl?g:e;this.onsapleft=this._bRtl?e:g;this.onsapleftmodifiers=this._bRtl?e:g;this.onsapup=j;this.onsapupmodifiers=j;this.onsapdown=i;this.onsapdownmodifiers=i;this.onsappageup=f;this.onsappagedown=d;this.onsapdelete=k;this.data("sap-ui-fastnavgroup","true",true);}if(D.system.tablet||D.system.phone){this._fnOrientationChange=function(E){if(this.getDomRef()){this._oTileDimensionCalculator.calc();}}.bind(this);}this._oTileDimensionCalculator=new b(this);this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._oPagesInfo=(function(r){var m,n,p,s,P=false,t=r;return{setCurrentPage:function(u){p=m;m=u;},setCount:function(u){s=n;n=u;},setPagerCreated:function(u){P=u;},syncOldToCurrentValues:function(){s=n;p=m;},reset:function(){s=undefined;p=undefined;n=undefined;m=undefined;P=false;},getCurrentPage:function(){return m;},getCount:function(){return n;},getOldCurrentPage:function(){return p;},getOldCount:function(){return s;},isPagerCreated:function(){return P;},currentPageIsLast:function(){return t?(m===0):(m===n-1);},currentPageIsFirst:function(){return t?(m===n-1):(m===0);},oldCurrentPageIsLast:function(){if(isNaN(p)){return false;}return t?(p===0):(p===s-1);},oldCurrentPageIsFirst:function(){if(isNaN(p)){return false;}return t?(p===s-1):(p===0);},currentPageIsLastChanged:function(){return this.currentPageIsLast()!==this.oldCurrentPageIsLast();},currentPageIsFirstChanged:function(){return this.currentPageIsFirst()!==this.oldCurrentPageIsFirst();},currentPageRelativePositionChanged:function(){return this.currentPageIsFirstChanged()||this.currentPageIsLastChanged();},pageCountChanged:function(){return n!==s;},currentPageChanged:function(){return m!==p;}};}(this._bRtl));this._iMaxTiles=1;};
a.prototype._findNextTabbable=function(){var r=this.$();var t=q.merge(q.merge(r.nextAll(),r.parents().nextAll()).find(':sapTabbable').addBack(':sapTabbable'),q.merge(r.parents().prevAll(),r.prevAll()).find(':sapTabbable').addBack(':sapTabbable'));return t.first();};
a.prototype.onBeforeRendering=function(){var t=this.getTiles(),d=t.length;if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._oPagesInfo.reset();for(var i=0;i<d;i++){t[i]._rendered=false;}};
a.prototype.onAfterRendering=function(){var v=[];this._sResizeListenerId=R.register(this.getDomRef().parentElement,q.proxy(this._resize,this));this._oDim=this._calculateDimension();this._applyDimension();this.$().toggleClass("sapMTCEditable",this.getEditable()===true);if(this._bRenderFirstPage){this._bRenderFirstPage=false;v=this._getVisibleTiles();this._updateTileDimensionInfoAndPageSize(v);if(this.getTiles().length===1){this._update(false,v);}else if(this._iMaxTiles!==Infinity&&this._iMaxTiles){this._renderTiles(v,0,this._iMaxTiles-1);}}else{this._update(true);}if(D.system.desktop||D.system.combi){var t=v||this._getVisibleTiles();if(t.length>0&&this._mFocusables&&this._mFocusables[t[0].getId()]){this._mFocusables[t[0].getId()].eq(0).attr('tabindex','0');}}if(D.system.tablet||D.system.phone){D.orientation.attachHandler(this._fnOrientationChange,this);}};
a.prototype.setEditable=function(v){var t=this._getVisibleTiles();this.setProperty("editable",v,true);var e=this.getEditable();this.$().toggleClass("sapMTCEditable",e);for(var i=0;i<t.length;i++){var o=t[i];if(o instanceof sap.m.Tile){o.isEditable(e);}}return this;};
a.prototype.updateTiles=function(){this.destroyTiles();this.updateAggregation('tiles');};
a.prototype._applyDimension=function(){var d=this._getDimension(),$=this.$(),t,o=10,e=this.$("scrl"),s,f,p=this.$("pager").outerHeight();e.css({width:d.outerwidth+"px",height:(d.outerheight-p)+"px"});t=$.position();s=e.position();f=e.outerHeight();if(D.system.phone){o=2;}else if(D.system.desktop){o=0;}this.$("blind").css({top:(s.top+o)+"px",left:(s.left+o)+"px",right:"auto",width:(e.outerWidth()-o)+"px",height:(f-o)+"px"});this.$("rightedge").css({top:(t.top+o)+"px",right:o+"px",left:"auto",height:(f-o)+"px"});this.$("leftedge").css({top:(t.top+o)+"px",left:(t.left+o)+"px",right:"auto",height:(f-o)+"px"});};
a.prototype._resize=function(){if(this._oDragSession){return;}setTimeout(q.proxy(function(){var v=this._getVisibleTiles(),t=v.length,d=this._iCurrentTileStartIndex,o=this._oDim,n,N,e;this._oPagesInfo.reset();this._oDim=this._calculateDimension();this._updateTileDimensionInfoAndPageSize(v);if(o.width!==this._oDim.width||o.height!==this._oDim.height){for(var i=0;i<t;i++){if(v[i]._rendered){v[i]._rendered=false;v[i].$().remove();}}n=this._getPageNumberForTile(d);N=n*this._iMaxTiles;e=N+this._iMaxTiles-1;this._renderTiles(v,N,e);}},this),0);};
a.prototype.exit=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(D.system.tablet||D.system.phone){D.orientation.detachHandler(this._fnOrientationChange,this);}delete this._oPagesInfo;};
a.prototype._update=function(A,v){if(!this.getDomRef()){return;}if(!this.getVisible()){return;}v=v||this._getVisibleTiles();this._oTileDimensionCalculator.calc(v);this._updateTilePositions(v);if(!this._oDragSession){this.scrollIntoView(this._iCurrentTileStartIndex||0,A,v);}};
a.prototype.getPageFirstTileIndex=function(){return this._iCurrentTileStartIndex||0;};
a.prototype.moveTile=function(t,n){if(!isNaN(t)){t=this._getVisibleTiles()[t];}if(!t){L.info("No Tile to move");return this;}this.deleteTile(t);this.insertTile(t,n);return this;};
a.prototype.addTile=function(t){this.insertTile(t,this.getTiles().length);return this;};
a.prototype.insertTile=function(t,i){var d=this,v;t.isEditable(this.getEditable());if(D.system.desktop||D.system.combi){t.addEventDelegate({"onAfterRendering":function(){if(!d._mFocusables){d._mFocusables={};}d._mFocusables[this.getId()]=this.$().find("[tabindex!='-1']").addBack().filter(d._isFocusable);d._mFocusables[this.getId()].attr('tabindex','-1');}},t);var o=function(e){var i=d._getVisibleTiles().indexOf(this),E=Math.floor(i/d._iMaxTiles),p=E-d._oPagesInfo.getCurrentPage();var P=d._iCurrentFocusIndex>=0?d._iCurrentFocusIndex:0;var V=d._getVisibleTiles();var f=V[P];if(f){d._mFocusables[f.getId()].attr("tabindex","-1");d._mFocusables[this.getId()].attr("tabindex","0");}if(p!=0){d.scrollIntoView(i,null,V);}d._handleAriaActiveDescendant();d._iCurrentFocusIndex=i;};t.addEventDelegate({"onfocusin":o},t);}if(this.getDomRef()){this.insertAggregation("tiles",t,i,true);v=this._getVisibleTiles();if(!this._oDragSession){if(t.getVisible()&&(v.length===1||this._getPageNumberForTile(i)<=this._oPagesInfo.getCurrentPage())){this._renderTile(t,i);this._update(false,v);}else{this._oPagesInfo.setCount(Math.ceil(v.length/this._iMaxTiles));this._updatePager();}}else{this._update(false,v);}if(D.system.desktop||D.system.combi){this._updateTilesTabIndex(v);}}else{this.insertAggregation("tiles",t,i);v=this._getVisibleTiles();}if(t.getVisible()){c.call(this,i,v.length,v);h.call(this,v);}return this;};
a.prototype._updateTilesTabIndex=function(v){v=v||this._getVisibleTiles();if(v.length&&v.length>0){for(var i=0;i<v.length;i++){if(v[i].$().attr("tabindex")==="0"){return;}}}v[0].$().attr("tabindex","0");};
a.prototype._isFocusable=function(i,e){var d=!isNaN(q(e).attr("tabindex"));var n=e.nodeName.toLowerCase();if(n==="area"){var m=e.parentNode,f=m.name,g;if(!e.href||!f||m.nodeName.toLowerCase()!=="map"){return false;}g=q("img[usemap='#"+f+"']")[0];return!!g;}return(/input|select|textarea|button|object/.test(n)?!e.disabled:n=="a"?e.href||d:d);};
a.prototype.deleteTile=function(t){var v=this._getVisibleTiles(),d=this._indexOfVisibleTile(t,v);if(this.getDomRef()){v.splice(d,1);this.removeAggregation("tiles",t,true);if(!this._oDragSession){if(t.getDomRef()){t.getDomRef().parentNode.removeChild(t.getDomRef());}if(D.system.desktop||D.system.combi){if(this._mFocusables&&this._mFocusables[t.getId()]){delete this._mFocusables[t.getId()];}}}if(v.length===0){this._oPagesInfo.reset();}else if(t.getVisible()&&d>=0&&this._getPageNumberForTile(d)<=this._oPagesInfo.getCurrentPage()){this._renderTilesInTheSamePage(this._oPagesInfo.getCurrentPage()*this._iMaxTiles,v);}this._update(false);}else{this.removeAggregation("tiles",t,false);v=this._getVisibleTiles();}c.call(this,d,v.length);h.call(this,v);return this;};
a.prototype.removeTile=a.prototype.deleteTile;
a.prototype.removeAllTiles=function(){var t=this.getTiles().length-1;for(var i=t;i>=0;i--){var o=this.getTiles()[i];this.deleteTile(o);}return this;};
a.prototype.destroyTiles=function(){if(this.getDomRef()){var t=this.getTiles();this.removeAllAggregation("tiles",true);this._oPagesInfo.reset();this._update();for(var i=0;i<t.length;i++){var d=t[i];d.destroy();}}else{this.destroyAggregation("tiles",false);}return this;};
a.prototype.rerender=function(){if(!this._oDragSession||this._oDragSession.bDropped){C.prototype.rerender.apply(this);}};
a.prototype.scrollLeft=function(){var s=0,v=this._getVisibleTiles();if(this._bRtl){s=this._iCurrentTileStartIndex+this._iMaxTiles;}else{s=this._iCurrentTileStartIndex-this._iMaxTiles;}this._renderTiles(v,s,s+this._iMaxTiles-1);this.scrollIntoView(s,null,v);};
a.prototype.scrollRight=function(){var s=0,v=this._getVisibleTiles();if(this._bRtl){s=this._iCurrentTileStartIndex-this._iMaxTiles;}else{s=this._iCurrentTileStartIndex+this._iMaxTiles;}this._renderTiles(v,s,s+this._iMaxTiles-1);this.scrollIntoView(s,null,v);};
a.prototype._renderTilesInTheSamePage=function(t,d){var i=this._getPageNumberForTile(t),f=i*this._iMaxTiles,e=f+this._iMaxTiles-1;this._renderTiles(d,f,e);};
a.prototype._renderTiles=function(t,s,e){var n=false,i;for(i=s;i<=e;i++){if(t[i]&&!t[i]._rendered){this._renderTile(t[i],i);n=true;}}if(n){this._update(false,t);if(D.system.desktop||D.system.combi){this._updateTilesTabIndex();}}};
a.prototype.scrollIntoView=function(t,A,v){var i=this._getContentDimension().outerwidth,d=t,e=this.getTiles();if(isNaN(t)){d=this.indexOfAggregation("tiles",t);}if(!e[d]||!e[d].getVisible()){return;}v=v||this._getVisibleTiles();d=this._indexOfVisibleTile(e[d]);if(d>-1){this._renderTilesInTheSamePage(d,v);}this._applyPageStartIndex(d,v);this._oPagesInfo.setCurrentPage(Math.floor(this._iCurrentTileStartIndex/this._iMaxTiles));if(this._bRtl){this._scrollTo((this._oPagesInfo.getCount()-this._oPagesInfo.getCurrentPage())*i,A);}else{this._scrollTo(this._oPagesInfo.getCurrentPage()*i,A);}this._updatePager();};
a.prototype._updateTilePositions=function(v){var d=this._getDimension();if(d.height===0){return;}v=v||this._getVisibleTiles();if(v.length===0){this._oPagesInfo.setCount(0);this._updatePager();return;}this._applyPageStartIndex(this._iCurrentTileStartIndex,v);this._applyDimension();var o=this._getContentDimension();this._oPagesInfo.setCount(Math.ceil(v.length/this._iMaxTiles));var t=this._oTileDimensionCalculator.getLastCalculatedDimension();for(var i=0;i<v.length;i++){if(!v[i]._rendered||v[i].isDragged()){continue;}var p=Math.floor(i/this._iMaxTiles),e=v[i],f=(p*o.outerwidth)+this._iOffsetX+i%this._iMaxTilesX*t.width,g=this._iOffsetY+Math.floor(i/this._iMaxTilesX)*t.height-(p*this._iMaxTilesY*t.height);if(this._bRtl){f=(this._oPagesInfo.getCount()-p)*o.outerwidth-this._iOffsetX-(i%this._iMaxTilesX+1)*t.width;}e.setPos(f,g);e.setSize(t.width,t.height);}};
a.prototype._findTile=function($){if($.hasClass('sapMTile')||$.hasClass('sapMCustomTile')){return $;}else{return $.find('.sapMTile')||$.find('.sapMCustomTile');}};
a.prototype._updatePager=function(){var p,s,S,H,P=false;if(!this._oPagesInfo.pageCountChanged()&&!this._oPagesInfo.currentPageChanged()){return;}p=this.$("pager")[0];s=this.$("leftscroller")[0];S=this.$("rightscroller")[0];if(this._oPagesInfo.getCount()==undefined||this._oPagesInfo.getCount()<=1){p.innerHTML="";S.style.right="-100px";s.style.left="-100px";s.style.display="none";S.style.display="none";this._oPagesInfo.setPagerCreated(false);return;}if(!this._oPagesInfo.isPagerCreated()){H=[""];for(var i=0;i<this._oPagesInfo.getCount();i++){H.push("");}p.innerHTML=H.join("<span></span>");p.style.display="block";p.childNodes[0].className="sapMTCActive";this._oPagesInfo.setPagerCreated(true);P=true;}else if(this._oPagesInfo.pageCountChanged()){if(this._oPagesInfo.getCount()-this._oPagesInfo.getOldCount()<0){p.removeChild(p.lastChild);}else{p.appendChild(document.createElement("span"));}}if(this._oPagesInfo.currentPageChanged()){p.childNodes[this._oPagesInfo.getCurrentPage()].className="sapMTCActive";if(p.childNodes[this._oPagesInfo.getOldCurrentPage()]){p.childNodes[this._oPagesInfo.getOldCurrentPage()].className="";}if(this._oPagesInfo.getCurrentPage()>=1){p.childNodes[0].className="";}}if(D.system.desktop&&(P||this._oPagesInfo.currentPageRelativePositionChanged())){if(this._bRtl){S.style.left="auto";s.style.right="auto";}S.style.right=this._oPagesInfo.currentPageIsLast()?"-100px":"1rem";s.style.left=this._oPagesInfo.currentPageIsFirst()?"-100px":"1rem";S.style.display=this._oPagesInfo.currentPageIsLast()?"none":"block";s.style.display=this._oPagesInfo.currentPageIsFirst()?"none":"block";}this._oPagesInfo.syncOldToCurrentValues();};
a.prototype._getContentDimension=function(){if(!this.getDomRef()){return;}var s=this.$("scrl");return{width:s.width(),height:s.height()-20,outerheight:s.outerHeight()-20,outerwidth:s.outerWidth()};};
a.prototype._getDimension=function(){if(!this._oDim){this._oDim=this._calculateDimension();}return this._oDim;};
a.prototype._calculatePageSize=function(v){var d,t;v=v||this._getVisibleTiles();t=v.length;if(t===0){return;}d=q.extend({},this._getDimension());if(d.height===0){return;}if(D.system.desktop){d.width-=45*2;}var o=this._oTileDimensionCalculator.getLastCalculatedDimension(),p=this.$("pager")[0].offsetHeight,m=Math.max(Math.floor(d.width/o.width),1),M=Math.max(Math.floor((d.height-p)/o.height),1),n=(t<m)?t:m,N=(t/n<M)?Math.ceil(t/n):M;this._iMaxTiles=m*M;this._iMaxTilesX=m;this._iMaxTilesY=M;this._iOffsetX=Math.floor((d.width-(o.width*n))/2);if(D.system.desktop){this._iOffsetX+=45;}this._iOffsetY=Math.floor((d.height-p-(o.height*N))/2);};
a.prototype._getTilesFromPosition=function(x,y){if(!this._getVisibleTiles().length){return[];}x=x+this._iScrollLeft;var t=this._getVisibleTiles(),r=[];for(var i=0;i<t.length;i++){var o=t[i],d={top:o._posY,left:o._posX,width:o._width,height:o._height};if(!t[i].isDragged()&&y>d.top&&y<d.top+d.height&&x>d.left&&x<d.left+d.width){r.push(t[i]);}}return r;};
a.prototype._applyPageStartIndex=function(i,v){var o=this._getDimension();if(o.height===0){return;}v=v||this._getVisibleTiles();this._calculatePageSize(v);var d=v.length;if(i<0){i=0;}else if(i>d-1){i=d-1;}var e=Math.floor(i/this._iMaxTiles||0);this._iCurrentTileStartIndex=e*(this._iMaxTiles||0);L.info("current index "+this._iCurrentTileStartIndex);};
a.prototype._scrollTo=function(s,A){if(A!==false){A=true;}this._applyTranslate(this.$("cnt"),-s,0,A);if(this._bRtl){this._iScrollLeft=s-this._getContentDimension().outerwidth;}else{this._iScrollLeft=s;}};
a.prototype._applyTranslate=function(d,x,y,A){var o=d[0];this.$("cnt").toggleClass("sapMTCAnim",A);if("webkitTransform"in o.style){d.css('-webkit-transform','translate3d('+x+'px,'+y+'px,0)');}else if("MozTransform"in o.style){d.css('-moz-transform','translate('+x+'px,'+y+'px)');}else if("transform"in o.style){d.css('transform','translate3d('+x+'px,'+y+'px,0)');}else if("msTransform"in o.style){d.css('-ms-transform','translate('+x+'px,'+y+'px)');}};
a.prototype._initTouchSession=function(e){if(e.type=="touchstart"){var t=e.targetTouches[0];this._oTouchSession={dStartTime:new Date(),fStartX:t.pageX,fStartY:t.pageY,fDiffX:0,fDiffY:0,oControl:e.srcControl,iOffsetX:t.pageX-e.target.offsetLeft};}else{this._oTouchSession={dStartTime:new Date(),fStartX:e.pageX,fStartY:e.pageY,fDiffX:0,fDiffY:0,oControl:e.srcControl,iOffsetX:e.pageX-e.target.offsetLeft};}};
a.prototype._initDragSession=function(e){while(e.srcControl&&e.srcControl.getParent()!=this){e.srcControl=e.srcControl.getParent();}var i=this.indexOfAggregation("tiles",e.srcControl);if(e.type=="touchstart"){this._oDragSession={oTile:e.srcControl,oTileElement:e.srcControl.$()[0],iOffsetLeft:e.targetTouches[0].pageX-e.srcControl._posX+this._iScrollLeft,iOffsetTop:e.targetTouches[0].pageY-e.srcControl._posY,iIndex:i,iOldIndex:i,iDiffX:e.targetTouches[0].pageX,iDiffY:e.targetTouches[0].pageY};}else{this._oDragSession={oTile:e.srcControl,oTileElement:e.srcControl.$()[0],iOffsetLeft:e.pageX-e.srcControl._posX+this._iScrollLeft,iOffsetTop:e.pageY-e.srcControl._posY,iIndex:i,iOldIndex:i,iDiffX:e.pageX,iDiffY:e.pageY};}};
a.prototype.onclick=function(e){var p=this.$("pager")[0];if(e.target.id==this.getId()+"-leftscroller"||e.target.parentNode.id==this.getId()+"-leftscroller"){this.scrollLeft();}else if(e.target.id==this.getId()+"-rightscroller"||e.target.parentNode.id==this.getId()+"-rightscroller"){this.scrollRight();}else if(e.target==p&&D.system.desktop){if(e.offsetX<p.offsetWidth/2){this.scrollLeft();}else{this.scrollRight();}}};
a.prototype.ontouchstart=function(e){e.setMarked();if(e.targetTouches.length>1||this._oTouchSession){return;}while(e.srcControl&&e.srcControl.getParent()!=this){e.srcControl=e.srcControl.getParent();}if(e.srcControl instanceof sap.m.Tile&&this.getEditable()){if(e.target.className!="sapMTCRemove"){this._initDragSession(e);this._initTouchSession(e);this._oDragSession.oTile.isDragged(true);}else{this._initTouchSession(e);}this._bAvoidChildTapEvent=true;}else{this._initTouchSession(e);}q(document).on("touchmove mousemove",q.proxy(this._onmove,this));q(document).on("touchend touchcancel mouseup",q.proxy(this._onend,this));};
a.prototype._onmove=function(e){if(document.selection&&document.selection.clear){document.selection.clear();}if(e.isMarked("delayedMouseEvent")){return;}if(e.targetTouches&&e.targetTouches.length>1){return;}if(!e.targetTouches){e.targetTouches=[{pageX:e.pageX,pageY:e.pageY}];}var t=this._oTouchSession;t.fDiffX=t.fStartX-e.targetTouches[0].pageX;t.fDiffY=t.fStartY-e.targetTouches[0].pageY;if(this._oDragSession){if(Math.abs(t.fDiffX)>5){if(!this._oDragSession.bStarted){this._oDragSession.bStarted=true;this._onDragStart(e);}else{this._onDrag(e);}this._bAvoidChildTapEvent=true;}}else if(t){var d=this._getContentDimension().outerwidth;var n=-this._iScrollLeft-t.fDiffX;if(n>this._iScrollGap){return;}else if(n<-(((this._oPagesInfo.getCount()-1)*d)+this._iScrollGap)){return;}if(this._bRtl){n=n-d;}var v=this._getVisibleTiles();var i=t.fDiffX>0?1:-1;var g=this._iCurrentTileStartIndex+i*this._iMaxTiles;var G=g+this._iMaxTiles-1;this._renderTiles(v,g,G);this._applyTranslate(this.$("cnt"),n,0,false);}};
a.prototype._onend=function(e){if(e.isMarked("delayedMouseEvent")){return;}q(document).off("touchend touchcancel mouseup",this._onend);q(document).off("touchmove mousemove",this._onmove);if(this._oDragSession){this._onDrop(e);delete this._oTouchSession;return;}if(!this._oTouchSession){return;}var t=this._oTouchSession,d=new Date(),f=(d-t.dStartTime<600),r=this._bRtl?-1:1;if(f){var p=this.$("pager")[0];if(Math.abs(t.fDiffX)>30){this._applyPageStartIndex(this._iCurrentTileStartIndex+((t.fDiffX*r>0?1:-1)*this._iMaxTiles));this._bAvoidChildTapEvent=true;}else if(e.target==p&&!D.system.desktop){if((t.iOffsetX-p.offsetWidth/2)*r<0){this.scrollLeft();}else{this.scrollRight();}this._bAvoidChildTapEvent=true;}else if(e.target.className=="sapMTCRemove"){if(e.type==="touchend"||(e.type==="mouseup"&&e.button===0)){this.fireTileDelete({tile:t.oControl});}}}else{var o=this._getContentDimension();if(Math.abs(t.fDiffX)>o.outerwidth/2){this._applyPageStartIndex(this._iCurrentTileStartIndex+((t.fDiffX*r>0?1:-1)*this._iMaxTiles));this._bAvoidChildTapEvent=true;}}this._update();delete this._oDragSession;delete this._oTouchSession;var g=this;setTimeout(function(){g._bAvoidChildTapEvent=false;},100);};
a.prototype._onDragStart=function(e){this.$().append(this._oDragSession.oTileElement);this._oDragSession.iDiffX=this._oTouchSession.fStartX-this._oTouchSession.fDiffX;this._oDragSession.iDiffY=this._oTouchSession.fStartY-this._oTouchSession.fDiffY;this._oDragSession.oTile.setPos(this._oDragSession.iDiffX-this._oDragSession.iOffsetLeft,this._oDragSession.iDiffY-this._oDragSession.iOffsetTop);this.$("blind").css("display","block");};
a.prototype._onDrag=function(e){if(!this._oTouchSession){clearTimeout(this.iScrollTimer);this._oDragSession=null;this.iScrollTimer=null;this._bTriggerScroll=false;return;}this._oDragSession.iDiffX=this._oTouchSession.fStartX-this._oTouchSession.fDiffX;this._oDragSession.iDiffY=this._oTouchSession.fStartY-this._oTouchSession.fDiffY;var o=this._getContentDimension(),t=this._oDragSession.iDiffY-this._oDragSession.iOffsetTop,i=this._oDragSession.iDiffX-this._oDragSession.iOffsetLeft,m=t+(this._oDragSession.oTileElement.offsetHeight/2),d=i+(this._oDragSession.oTileElement.offsetWidth/2),s=i+this._oDragSession.oTileElement.offsetWidth-this._iTriggerScrollOffset>o.width,S=i<-this._iTriggerScrollOffset,n=o.width-(i+this._oDragSession.oTileElement.offsetWidth),N=i;this._oDragSession.oTile.setPos(i,t);this._oDragSession.oTile.$().css("clip","auto");var r=this.$("rightedge")[0];if(i+this._oDragSession.oTile._width>r.offsetLeft+r.offsetWidth&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1){var f=r.offsetLeft+r.offsetWidth-i-((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2)-2;this._oDragSession.oTile.$().css("clip","rect(-25px,"+f+"px,"+(this._oDragSession.oTile._height+20)+"px,-25px)");}var g=this.$("leftedge")[0];if(i<g.offsetLeft+2+((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2)&&this._oPagesInfo.getCurrentPage()>0){var j=g.offsetLeft+4-i-((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2);this._oDragSession.oTile.$().css("clip","rect(-25px,"+this._oDragSession.oTile._width+"px,"+(this._oDragSession.oTile._height+20)+"px,"+j+"px)");}if(n<this._iEdgeShowStart&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1){var O=(this._iEdgeShowStart-n)/(this._iEdgeShowStart+this._iTriggerScrollOffset);this.$("rightedge").css("opacity",""+O);}else{this.$("rightedge").css("opacity","0.01");}if(N<this._iEdgeShowStart&&this._oPagesInfo.getCurrentPage()>0){var O=(this._iEdgeShowStart-N)/(this._iEdgeShowStart+this._iTriggerScrollOffset);this.$("leftedge").css("opacity",""+O);}else{this.$("leftedge").css("opacity","0.01");}var k;if(this._bRtl){k=s&&this._oPagesInfo.getCurrentPage()>0||S&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1;}else{k=S&&this._oPagesInfo.getCurrentPage()>0||s&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1;}if(k){if(this._bTriggerScroll){S?this.scrollLeft():this.scrollRight();}else{var p=this;if(!this.iScrollTimer){this.iScrollTimer=setInterval(function(){p._bTriggerScroll=true;p._onDrag(e);p._bTriggerScroll=false;},1000);}}return;}else{if(this.iScrollTimer){clearTimeout(this.iScrollTimer);this._bTriggerScroll=false;this.iScrollTimer=null;}}var H=this._getTilesFromPosition(d,m);if(H&&H.length>0){var u=H[0],v={top:u._posY,left:u._posX,width:u._width,height:u._height};var w=this.indexOfAggregation("tiles",u);if(d+this._iScrollLeft<((v.left+v.width)/2)&&(w%this._iMaxTilesX)!=0){w--;}this._oDragSession.iIndex=w;this.moveTile(this._oDragSession.oTile,this._oDragSession.iIndex);}else if(this._oPagesInfo.getCurrentPage()==this._oPagesInfo.getCount()-1){var x=this._getVisibleTiles(),y=x[x.length-1];if(y&&d>y._posX-this._iScrollLeft&&m>y._posY){this._oDragSession.iIndex=x.length-1;this.moveTile(this._oDragSession.oTile,this._oDragSession.iIndex);}}};
a.prototype._onDrop=function(e){if(this._oDragSession){var t=this._oDragSession.oTile,i=this._oDragSession.iIndex;this._oDragSession.oTile.isDragged(false);if(this._oDragSession.iOldIndex!=this._oDragSession.iIndex){this.fireTileMove({tile:t,newIndex:i});}this.$("blind").css("display","block");if(this._oDragSession.bStarted){this._oDragSession.oTile.setPos(this._oDragSession.oTile._posX+this._iScrollLeft,this._oDragSession.oTile._posY);}this._oDragSession.oTile.$().css("clip","auto");this.$("rightedge").css("opacity","0.01");this.$("leftedge").css("opacity","0.01");this.$("cnt").append(this._oDragSession.oTileElement);delete this._oDragSession;this.moveTile(t,i);this.scrollIntoView(t,false);if(D.system.desktop||D.system.combi){this._findTile(t.$()).trigger("focus");}this._handleAriaActiveDescendant();this.$("blind").css("display","none");}};
a.prototype._handleAriaActiveDescendant=function(){var A=q(document.activeElement).control(0);if(A instanceof sap.m.Tile&&A.getParent()===this){this.getDomRef().setAttribute("aria-activedescendant",A.getId());}};
a.prototype._renderTile=function(t,i){var r=sap.ui.getCore().createRenderManager(),o=this.$("cnt")[0];r.renderControl(t);r.flush(o,false,i);r.destroy();};
a.prototype.onThemeChanged=function(){if(this.getDomRef()){this.invalidate();}};
a.prototype._calculateDimension=function(){var d=this.$();if(!d){return;}return{width:d.width(),height:d.height(),outerheight:d.outerHeight(),outerwidth:d.outerWidth()};};
a.prototype._getVisibleTiles=function(){var r=[],t=this.getTiles();for(var i=0,d=t.length;i<d;i++){if(t[i].mProperties["visible"]){r.push(t[i]);}}return r;};
a.prototype._indexOfVisibleTile=function(t,d){var i,e;d=d||this._getVisibleTiles();e=d.length;for(i=0;i<e;i++){if(d[i]===t){return i;}}return-1;};
a.prototype._updateTileDimensionInfoAndPageSize=function(v){v=v||this._getVisibleTiles();this._oTileDimensionCalculator.calc(v);this._calculatePageSize(v);};
a.prototype._getPageNumberForTile=function(t){return Math.floor((t/this._iMaxTiles)||0);};
var b=function(t){this._oDim=null;this._oTileContainer=t;};
b.prototype.calc=function(v){var V,t;if(!this._oTileContainer.getDomRef()){return;}V=v||this._oTileContainer._getVisibleTiles();if(V.length){t=V[0];for(var i=0,d=V.length;i<d;i++){if(V[i]._rendered){t=V[i];break;}}this._oDim={width:Math.round(t.$().outerWidth(true)),height:Math.round(t.$().outerHeight(true))};}return this._oDim;};
b.prototype.getLastCalculatedDimension=function(){return this._oDim;};
function h(v){var t,i,o;v=v||this._getVisibleTiles();t=v.length;for(i=0;i<t;i++){o=v[i];if(o._rendered&&o.getDomRef()){o.getDomRef().setAttribute("aria-setsize",t);}}}
function c(s,e,v){var i,t=null;v=v||this._getVisibleTiles();for(i=s;i<e;i++){t=v[i];if(t){t.$().attr('aria-posinset',this._indexOfVisibleTile(t,v)+1);}}}
return a;});
sap.ui.predefine('sap/m/TileContainerRenderer',[],function(){"use strict";var T={apiVersion:2};T.DEFAULT_TILES_TO_RENDER=1;
T.render=function(r,c){var i=c.getId();r.openStart("div",c).attr("tabindex","-1").style("height",c.getHeight()).style("width",c.getWidth()).class("sapMTC");r.accessibilityState(c,{role:"listbox",multiSelectable:false,activeDescendant:c.getTiles().length>0?c.getTiles()[0].getId():""});r.openEnd();r.openStart("div",i+"-scrl").class("sapMTCScrl").style("height","0");if(!c.bRtl){r.style("overflow","hidden");}r.openEnd();r.openStart("div",i+"-blind").class("sapMTCBlind").openEnd().close("div");r.openStart("div",i+"-cnt").class("sapMTCCnt").class("sapMTCAnim").style("height","0").style("width","0").attr("role","group").openEnd();this.renderTiles(c,r);r.close("div");r.close("div");r.openStart("div",i+"-pager").class("sapMTCPager").openEnd().close("div");r.openStart("div",i+"-leftedge").class("sapMTCEdgeLeft").openEnd().close("div");r.openStart("div",i+"-rightedge").class("sapMTCEdgeRight").openEnd().close("div");r.openStart("div",i+"-leftscroller").class("sapMTCScroller").class("sapMTCLeft").attr("tabindex","-1").openEnd();r.openStart("div").class("sapMTCInner").openEnd().close("div");r.close("div");r.openStart("div",i+"-rightscroller").class("sapMTCScroller").class("sapMTCRight").attr("tabindex","-1").openEnd();r.openStart("div").class("sapMTCInner").openEnd().close("div");r.close("div");r.close("div");};
T.renderTiles=function(t,r){var a=t.getTiles(),i=0,R=0,m;if(!a.length){return;}m=this._getCountOfTilesToRender(t,a);if(m===T.DEFAULT_TILES_TO_RENDER){t._bRenderFirstPage=true;}do{if(a[i]&&a[i].getVisible()){a[i]._setVisible(false);r.renderControl(a[i]);R++;}i++;}while(R!==m&&(i<a.length));};
T._getCountOfTilesToRender=function(t,a){if(t._iMaxTiles){return t._iMaxTiles;}if(a.length>T.DEFAULT_TILES_TO_RENDER){return T.DEFAULT_TILES_TO_RENDER;}return a.length;};
return T;},true);
sap.ui.predefine('sap/m/TileContent',['./library','sap/ui/core/library','sap/ui/core/Control','./TileContentRenderer'],function(l,C,a,T){"use strict";var P=C.Priority;
var b=a.extend("sap.m.TileContent",{metadata:{library:"sap.m",properties:{"footer":{type:"string",group:"Appearance",defaultValue:null},"footerColor":{type:"sap.m.ValueColor",group:"Appearance",defaultValue:"Neutral"},"size":{type:"sap.m.Size",group:"Appearance",defaultValue:"Auto",deprecated:true},"unit":{type:"string",group:"Data",defaultValue:null},"disabled":{type:"boolean",group:"Behavior",defaultValue:false},"frameType":{type:"sap.m.FrameType",group:"Appearance",defaultValue:"Auto"},"priority":{type:"sap.ui.core.Priority",group:"Misc",defaultValue:P.None}},defaultAggregation:"content",aggregations:{"content":{type:"sap.ui.core.Control",multiple:false,bindable:"bindable"}}}});
b.prototype.init=function(){this._bRenderFooter=true;this._bRenderContent=true;};
b.prototype.onBeforeRendering=function(){if(this.getContent()&&this._oDelegate){if(this.getDisabled()){this.getContent().addDelegate(this._oDelegate);}else{this.getContent().removeDelegate(this._oDelegate);}}};
b.prototype.onAfterRendering=function(){var c=this.getContent();if(c){var t=this.$();var d=t.find("*");var s=t.attr("title")||"";var e=c.getTooltip_AsString()||"";if(s===e){s="";}var i='';d.toArray().forEach(function(f){if(f.title){i=i.concat(f.title+" ");}});if(i.trim()!==0){e=e+" "+i;}if(e&&e.trim().length!==0){if(this._getFooterText().trim()!==0){e=e+"\n"+this._getFooterText();}s.trim().length!==0?t.attr("title",s+"\n"+e):t.attr("title",e);}d.removeAttr("title").off("mouseenter");}};
b.prototype._getContentType=function(){if(this.getContent()){var c=this.getContent().getMetadata().getName();if(c==="sap.m.NewsContent"||c==="sap.suite.ui.commons.NewsContent"){return"News";}}};
b.prototype._getFooterText=function(){var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');var f=this.getFooter();var u=this.getUnit();if(u){if(f){if(sap.ui.getCore().getConfiguration().getRTL()){return r.getText('TILECONTENT_FOOTER_TEXT',[f,u]);}else{return r.getText('TILECONTENT_FOOTER_TEXT',[u,f]);}}else{return u;}}else{return f;}};
b.prototype.getAltText=function(){var A="";var i=true;var c=this.getContent();if(c){if(c.getAltText){A+=c.getAltText();i=false;}else if(c.getTooltip_AsString()){A+=c.getTooltip_AsString();i=false;}}if(this.getUnit()){A+=(i?"":"\n")+this.getUnit();i=false;}if(this.getFooter()){A+=(i?"":"\n")+this.getFooter();}return A;};
b.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var A="";if(typeof t==="string"||t instanceof String){return t;}A=this.getAltText();return A?A:"";};
b.prototype.setRenderFooter=function(v){this._bRenderFooter=v;return this;};
b.prototype.setRenderContent=function(v){this._bRenderContent=v;return this;};
b.prototype._getPriorityText=function(p){var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');return r.getText('ACTION_PRIORITY_'+p.toUpperCase());};
return b;});
sap.ui.predefine('sap/m/TileContentRenderer',["./library","sap/base/security/encodeCSS","sap/m/GenericTile","sap/ui/core/library"],function(l,e,G,C){"use strict";var a=l.GenericTileMode,F=l.FrameType,P=C.Priority;var T={apiVersion:2};
T.render=function(r,c){var t=c.getTooltip_AsString();var s=c._getContentType();if(s){s=e(s);}var f=e("sapMFrameType"+c.getFrameType());r.openStart("div",c);r.class("sapMTileCnt");r.class(s);r.class(f);if(t.trim()){r.attr("title",t);}r.openEnd();this._renderContent(r,c);this._renderFooter(r,c);r.close("div");};
T._renderContent=function(r,c){if(!c._bRenderContent){return;}var o=c.getContent(),p=c.getPriority(),t=c.getParent(),i=t instanceof G&&t.getMode()===a.ActionMode&&t.getFrameType()===F.TwoByOne,R=i&&p&&p!==P.None;if(o){if(R){r.openStart("div",c.getId()+"-content-container");r.class("sapMTileContainer");r.openEnd();r.openStart("div",c.getId()+"-priority");r.class("sapMTilePriority");r.class(p);r.openEnd();r.openStart("div",c.getId()+"-priority-content");r.class("sapMTilePriorityCnt");r.openEnd();r.openStart("div",c.getId()+"-priority-border");r.class("sapMTilePriorityBorder");r.openEnd();r.close("div");r.openStart("span",c.getId()+"-priority-value");r.class("sapMTilePriorityValue");r.openEnd();r.text(c._getPriorityText(p));r.close("span");r.close("div");r.close("div");}r.openStart("div",c.getId()+"-content");r.class("sapMTileCntContent");r.openEnd();if(!o.hasStyleClass("sapMTcInnerMarker")){o.addStyleClass("sapMTcInnerMarker");}r.renderControl(o);r.close("div");if(R){r.close("div");}}};
T._renderFooter=function(r,c){if(!c._bRenderFooter){return;}var s="sapMTileCntFooterTextColor"+c.getFooterColor(),f=c._getFooterText(r,c),t=c.getParent();if(t instanceof G&&(t._isNavigateActionEnabled()||t._isActionMode())){r.openStart("div",t.getId()+"-footer-container");r.class("sapMTileFtrCnt");r.openEnd();}r.openStart("div",c.getId()+"-footer-text");r.class("sapMTileCntFtrTxt");r.class(e(s));r.openEnd();r.text(f);r.close("div");if(t instanceof G&&t._isActionMode()){r.openStart("div",t.getId()+"-actionButtons");r.class("sapMGTActionModeContainer");r.openEnd();t.getActionButtons().forEach(function(A){r.renderControl(A);});r.close("div");r.close("div");}else if(t instanceof G&&t._isNavigateActionEnabled()){r.openStart("div",t.getId()+"-navigateActionContainer");r.class("sapMTileNavContainer");r.openEnd();r.renderControl(t._getNavigateAction());r.close("div");r.close("div");}};
return T;},true);
sap.ui.predefine('sap/m/TileRenderer',[],function(){"use strict";var T={apiVersion:2};
T.render=function(r,c){var t,v;r.openStart("div",c);r.attr("tabindex","0");r.class("sapMTile");r.class("sapMPointer");if(c._invisible){r.style("visibility","hidden");}var s=c.getTooltip_AsString();if(s){r.attr("title",s);}if(c.getParent()instanceof sap.m.TileContainer){t=c.getParent();v=t._getVisibleTiles();r.accessibilityState(c,{role:"option",posinset:t._indexOfVisibleTile(c,v)+1,setsize:v.length});}r.openEnd();r.openStart("div",c.getId()+"-remove");r.class(c.getRemovable()?"sapMTCRemove":"sapMTCNoRemove");r.openEnd().close("div");r.openStart("div").class("sapMTileContent").openEnd();this._renderContent(r,c);r.close("div").close("div");};
T._renderContent=function(r,c){};
return T;},true);
sap.ui.predefine('sap/m/TimePicker',['./InputBase','./DateTimeField','./MaskInputRule','./Toolbar','./ToolbarSpacer','./Popover','./ResponsivePopover','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','./TimePickerInternals','./TimePickerClocks','./TimePickerInputs','./MaskEnabler','sap/ui/Device','sap/ui/core/format/DateFormat','sap/ui/core/Locale','sap/m/library','sap/ui/core/LocaleData','./TimePickerRenderer',"sap/ui/events/KeyCodes","sap/base/Log","sap/ui/core/InvisibleText",'./Button',"sap/ui/thirdparty/jquery"],function(I,D,M,T,a,P,R,E,b,c,d,e,f,g,h,L,l,j,k,K,m,n,B,q){"use strict";var o=l.PlacementType,p=l.TimePickerMaskMode,r=l.ButtonType,s=1;
var t=D.extend("sap.m.TimePicker",{metadata:{library:"sap.m",designtime:"sap/m/designtime/TimePicker.designtime",properties:{localeId:{type:"string",group:"Data"},title:{type:"string",group:"Misc",defaultValue:null},minutesStep:{type:"int",group:"Misc",defaultValue:s},secondsStep:{type:"int",group:"Misc",defaultValue:s},placeholderSymbol:{type:"string",group:"Misc",defaultValue:"_"},mask:{type:"string",group:"Misc",defaultValue:null},maskMode:{type:"sap.m.TimePickerMaskMode",group:"Misc",defaultValue:p.On},support2400:{type:"boolean",group:"Misc",defaultValue:false},hideInput:{type:"boolean",group:"Misc",defaultValue:false},showCurrentTimeButton:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{rules:{type:"sap.m.MaskInputRule",multiple:true,singularName:"rule"},_picker:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"},_numPicker:{type:"sap.m.Popover",multiple:false,visibility:"hidden"}},dnd:{draggable:false,droppable:true}}});
b.insertFontFaceStyle();E.call(t.prototype,true);f.call(t.prototype);var u={Short:"short",Medium:"medium",Long:"long"},v={Hour:"hour",Minute:"minute",Second:"second"},w='-';
t.prototype.init=function(){D.prototype.init.apply(this,arguments);f.init.apply(this,arguments);this.setDisplayFormat(y());this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._bValid=false;this._sUsedDisplayPattern=null;this._sUsedValuePattern=null;this._oDisplayFormat=null;this._sValueFormat=null;this._oPopoverKeydownEventDelegate=null;this._rPlaceholderRegEx=new RegExp(w,'g');this._sLastChangeValue=null;var i=this.addEndIcon({id:this.getId()+"-icon",src:this.getIconSrc(),noTabStop:true,title:"",tooltip:this._oResourceBundle.getText("OPEN_PICKER_TEXT")});this._bShouldClosePicker=false;this._bShouldCloseNumericPicker=false;i.addEventDelegate({onmousedown:function(z){this._bShouldClosePicker=this.isOpen();}},this);i.attachPress(function(){this.toggleOpen(this._bShouldClosePicker);},this);this._sMinutes="00";this._sSeconds="00";};
t.prototype.onBeforeRendering=function(){D.prototype.onBeforeRendering.apply(this,arguments);var V=this._getValueHelpIcon();if(V){V.setProperty("visible",this.getEditable(),true);}};
t.prototype.exit=function(){if(this._oTimeSemanticMaskHelper){this._oTimeSemanticMaskHelper.destroy();}f.exit.apply(this,arguments);this._removePickerEvents();this._oResourceBundle=null;this._bValid=false;this._sUsedDisplayPattern=null;this._oDisplayFormat=null;this._oPopoverKeydownEventDelegate=null;this._sUsedValuePattern=null;this._sValueFormat=null;this._sLastChangeValue=null;};
t.prototype.getIconSrc=function(){return b.getIconURI("time-entry-request");};
t.prototype.isOpen=function(){return this._getPicker()&&this._getPicker().isOpen();};
t.prototype.toggleOpen=function(O){if(this.getEditable()&&this.getEnabled()){this[O?"_closePicker":"_openPicker"]();}};
t.prototype.isNumericOpen=function(){return this._getNumericPicker()&&this._getNumericPicker().isOpen();};
t.prototype.toggleNumericOpen=function(O){if(this.getEditable()&&this.getEnabled()){this[O?"_closeNumericPicker":"_openNumericPicker"]();this._openByFocusIn=false;this._openByClick=false;}};
t.prototype.onfocusin=function(i){var z=this._getPicker(),A=this._isIconClicked(i),N=this._getNumericPicker(),O=N&&N.isOpen();if(!this._isMobileDevice()){f.onfocusin.apply(this,arguments);}if(z&&z.isOpen()&&!A){this._closePicker();return;}if(this._openByClick){this._openByClick=false;return;}if(!this._isMobileDevice()){return;}if(!A){this.toggleNumericOpen(O);}this._openByFocusIn=true;};
t.prototype.onclick=function(i){var z=this._isIconClicked(i),A=this._getNumericPicker(),O=A&&A.isOpen();if(this._openByFocusIn){this._openByFocusIn=false;return;}if(!this._isMobileDevice()){return;}if(!z){this.toggleNumericOpen(O);}this._openByClick=true;};
t.prototype._isIconClicked=function(i){return q(i.target).hasClass("sapUiIcon")||q(i.target).hasClass("sapMInputBaseIconContainer")||q(i.target).hasClass("sapUiIconTitle");};
t.prototype.onBeforeOpen=function(){var C=this._getClocks(),i=this.getDateValue(),z=this._$input.val(),F=this._getFormatter(true).oFormatOptions.pattern,A=F.indexOf("HH"),G=F.indexOf("H");var H=this._getFormatter(true).parse(z)||i;var J=this._getFormatter(true).format(H);C.setValue(J);if(this._shouldSetInitialFocusedDateValue()){i=this.getInitialFocusedDateValue();}C._setTimeValues(i,c._isHoursValue24(J,A,G));this.$().addClass(I.ICON_PRESSED_CSS_CLASS);};
t.prototype.onAfterOpen=function(){var C=this._getClocks();if(C){this._handleAriaOnExpandCollapse(true);C.showFirstClock();C._focusActiveButton();}};
t.prototype.onBeforeClose=function(){this._handleAriaOnExpandCollapse(false);};
t.prototype.onAfterClose=function(){this.$().removeClass(I.ICON_PRESSED_CSS_CLASS);this._getClocks().showFirstClock();};
t.prototype._isMobileDevice=function(){return!g.system.desktop&&(g.system.phone||g.system.tablet);};
t.prototype.onBeforeNumericOpen=function(){var i=this._getInputs(),z=this.getDateValue(),A=this._$input.val(),F=this._getFormatter(true).oFormatOptions.pattern,C=F.indexOf("HH"),G=F.indexOf("H");var H=this._getFormatter(true).parse(A)||z;var J=this._getFormatter(true).format(H);i.setValue(J);if(this._shouldSetInitialFocusedDateValue()){z=this.getInitialFocusedDateValue();}i._setTimeValues(z,c._isHoursValue24(J,C,G));};
t.prototype.onAfterNumericOpen=function(){var i=this._getInputs();if(i){this._handleAriaOnExpandCollapse(true);}};
t.prototype.onBeforeNumericClose=function(){this._handleAriaOnExpandCollapse(false);};
t.prototype._getValueHelpIcon=function(){var V=this.getAggregation("_endIcon");return V&&V[0];};
t.prototype._handleInputChange=function(V){var i,z,A,C,F=this.getValueFormat(),G=F.indexOf("HH"),H=F.indexOf("H");V=V||this._$input.val();z=V;A=c._isHoursValue24(z,G,H);C=this.getSupport2400()&&A;this._bValid=true;if(V!==""){i=this._parseValue(A?c._replace24HoursWithZero(V,G,H):V,true);if(C){i.setMinutes(0,0);}if(!i){this._bValid=false;}else{V=this._formatValue(i);if(this.getMaskMode()&&this.getMask()){this._setupMaskVariables();}}}z=C?"24:"+V.replace(/[0-9]/g,"0").slice(0,-3):V;this.updateDomValue(z);if(i){z=V=this._formatValue(i,true);if(C&&i&&i.getHours()===0){z=V=c._replaceZeroHoursWith24(V,G,H);}}this.setProperty("value",z,true);this.setLastValue(V);if(this._bValid){this.setProperty("dateValue",i,true);}this.fireChangeEvent(z,{valid:this._bValid});return true;};
t.prototype.onChange=function(i){var V=i?i.value:null;if(this.getEditable()&&this.getEnabled()){return this._handleInputChange(V);}return false;};
t.prototype.setMinutesStep=function(i){var C=this._getClocks(),z=this._getInputs();i=Math.max(s,i||s);if(C){C.setMinutesStep(i);}if(z){z.setMinutesStep(i);}return this.setProperty("minutesStep",i,true);};
t.prototype.setSecondsStep=function(i){var C=this._getClocks(),z=this._getInputs();i=Math.max(s,i||s);if(C){C.setSecondsStep(i);}if(z){z.setSecondsStep(i);}return this.setProperty("secondsStep",i,true);};
t.prototype.setTitle=function(i){var C=this._getClocks();if(C){C.setLabelText(i);}this.setProperty("title",i,true);return this;};
t.prototype._handleDateValidation=function(i){if(!i){this._bValid=false;m.warning("Value can not be converted to a valid date",this);}else{this._bValid=true;this.setProperty("dateValue",i,true);var V=this._formatValue(i);if(this.isActive()){this.updateDomValue(V);}else{this.setProperty("value",V,true);this.setLastValue(V);this._sLastChangeValue=V;}}};
t.prototype.setSupport2400=function(S){var C=this._getClocks(),i=this._getInputs();this.setProperty("support2400",S,true);if(C){C.setSupport2400(S);}if(i){i.setSupport2400(S);}this._initMask();return this;};
t.prototype.setDisplayFormat=function(i){var C=this._getClocks(),z=this._getInputs();this.setProperty("displayFormat",i,true);this._initMask();if(C){C.setValueFormat(i);C.setDisplayFormat(i);}if(z){z.setValueFormat(i);z.setDisplayFormat(i);}var A=this.getDateValue();if(!A){return this;}var O=this._formatValue(A);this.updateDomValue(O);this.setLastValue(O);return this;};
t.prototype.setValue=function(V){var i,O,F=this.getValueFormat(),z=F.indexOf("HH"),A=F.indexOf("H"),C=this._getClocks(),G=this._getInputs();V=this.validateProperty("value",V);this._initMask();if(this.getValue()!==V){this._sLastChangeValue=V;}f.setValue.call(this,V);if(this.getMask()){this._setupMaskVariables();}this._bValid=true;if(V){i=this._parseValue(c._isHoursValue24(V,z,A)?c._replace24HoursWithZero(V,z,A):V);if(!i){this._bValid=false;m.warning("Value can not be converted to a valid date",this);}}if(this._bValid){this.setProperty("dateValue",i,true);}if(i&&!this.getSupport2400()){O=this._formatValue(i);}else{O=V;}if(C){C.setValue(this._formatValue(i));}if(G){G.setValue(this._formatValue(i));}this.updateDomValue(O);this.setLastValue(O);return this;};
t.prototype.setDateValue=function(i){this._initMask();return D.prototype.setDateValue.apply(this,arguments);};
t.prototype.setTooltip=function(i){var z=this.getDomRef(),A;this._refreshTooltipBaseDelegate(i);this.setAggregation("tooltip",i,true);if(!z){return this;}A=this.getTooltip_AsString();if(A){z.setAttribute("title",A);}else{z.removeAttribute("title");}return this;};
t.prototype.setLocaleId=function(i){var C=this.getValue(),z=this._getClocks(),A=this._getInputs();this.setProperty("localeId",i,true);this._initMask();this._oDisplayFormat=null;this._sValueFormat=null;if(C){this.setValue(C);}if(z){z.setLocaleId(i);}if(A){A.setLocaleId(i);}return this;};
t.prototype.setShowCurrentTimeButton=function(S){var C=this._getClocks(),N=this._getNumericPicker();C&&C.setShowCurrentTimeButton(S);N&&N.getContent()[0].setShowCurrentTimeButton(S);return this.setProperty("showCurrentTimeButton",S);};
t.prototype._getDefaultDisplayStyle=function(){return u.Medium;};
t.prototype._getDefaultValueStyle=function(){return u.Medium;};
t.prototype._getLocale=function(){var i=this.getLocaleId();return i?new L(i):sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();};
t.prototype._getFormatterInstance=function(F,i,z,C,A){var G=this._getLocale();if(i===u.Short||i===u.Medium||i===u.Long){F=h.getTimeInstance({style:i,strictParsing:true,relative:z},G);}else{F=h.getTimeInstance({pattern:i,strictParsing:true,relative:z},G);}if(A){this._sUsedDisplayPattern=i;this._oDisplayFormat=F;}else{this._sUsedValuePattern=i;this._sValueFormat=F;}return F;};
t.prototype._getFormat=function(){var F=this._getDisplayFormatPattern();if(!F){F=u.Medium;}if(Object.keys(u).indexOf(F)!==-1){F=y();}return F;};
t.prototype.onsappageup=function(i){this._increaseTime(1,v.Hour);i.preventDefault();};
t.prototype.onsappageupmodifiers=function(i){if(!(i.ctrlKey||i.metaKey||i.altKey)&&i.shiftKey){this._increaseTime(1,v.Minute);}if(!i.altKey&&i.shiftKey&&(i.ctrlKey||i.metaKey)){this._increaseTime(1,v.Second);}i.preventDefault();};
t.prototype.onsappagedown=function(i){this._increaseTime(-1,v.Hour);i.preventDefault();};
t.prototype.onsappagedownmodifiers=function(i){if(!(i.ctrlKey||i.metaKey||i.altKey)&&i.shiftKey){this._increaseTime(-1,v.Minute);}if(!i.altKey&&i.shiftKey&&(i.ctrlKey||i.metaKey)){this._increaseTime(-1,v.Second);}i.preventDefault();};
t.prototype.onkeydown=function(i){var z=K,A=i.which||i.keyCode,C=i.altKey,F;if(A===z.F4||(C&&(A===z.ARROW_UP||A===z.ARROW_DOWN))){F=this._getPicker()&&this._getPicker().isOpen();if(!F){this._openPicker();}else{this._closePicker();}i.preventDefault();}else if(!this._isMobileDevice()){f.onkeydown.call(this,i);}else{if(A===K.ENTER||A===K.SPACE){this._openNumericPicker();}}};
t.prototype._getPicker=function(){return this.getAggregation("_picker");};
t.prototype._getNumericPicker=function(){return this.getAggregation("_numPicker");};
t.prototype._removePickerEvents=function(){var i,z=this._getPicker();if(z){i=z.getAggregation("_popup");if(typeof this._oPopoverKeydownEventDelegate==='function'){i.removeEventDelegate(this._oPopoverKeydownEventDelegate);}}};
t.prototype.openBy=function(i){this._openPicker(i);};
t.prototype._openPicker=function(i){var z=this._getPicker();if(!z){z=this._createPicker(this._getDisplayFormatPattern());}if(!i){i=this.getDomRef();}z.openBy(i);z.getContent()[0]._sMinutes=this._sMinutes;z.getContent()[0]._sSeconds=this._sSeconds;return z;};
t.prototype._closePicker=function(){var i=this._getPicker();if(i){this._sMinutes=i.getContent()[0]._sMinutes;this._sSeconds=i.getContent()[0]._sSeconds;i.close();}else{m.warning("There is no picker to close.");}return i;};
t.prototype._openNumericPicker=function(){var i=this._getNumericPicker();if(!i){i=this._createNumericPicker(this._getDisplayFormatPattern());}i.open();i.getContent()[0]._sMinutes=this._sMinutes;i.getContent()[0]._sSeconds=this._sSeconds;return i;};
t.prototype._closeNumericPicker=function(){var i=this._getNumericPicker();if(i){this._sMinutes=i.getContent()[0]._sMinutes;this._sSeconds=i.getContent()[0]._sSeconds;i.close();this.getDomRef("inner").select();}else{m.warning("There is no picker to close.");}return i;};
t.prototype._createPicker=function(F){var i=this,z,A,C,G,O,H,J,N=this.getAggregation("_endIcon")[0],Q=this._getLocale().getLanguage(),S,U,V;G=sap.ui.getCore().getLibraryResourceBundle("sap.m");O=G.getText("TIMEPICKER_SET");H=G.getText("TIMEPICKER_CANCEL");J=this._oResourceBundle.getText("TIMEPICKER_SET_TIME");C=new d(this.getId()+"-clocks",{support2400:this.getSupport2400(),displayFormat:F,valueFormat:F,localeId:Q,minutesStep:this.getMinutesStep(),secondsStep:this.getSecondsStep(),showCurrentTimeButton:this.getShowCurrentTimeButton()});C._setAcceptCallback(this._handleOkPress.bind(this));var W=this._getValueStateHeader();A=new R(i.getId()+"-RP",{showCloseButton:false,showHeader:false,horizontalScrolling:false,verticalScrolling:true,title:J,placement:o.VerticalPreferredBottom,contentWidth:"20rem",beginButton:new B(this.getId()+"-OK",{text:O,type:r.Emphasized,press:this._handleOkPress.bind(this)}),endButton:new B(this.getId()+"-Cancel",{text:H,press:this._handleCancelPress.bind(this)}),content:[W,C],ariaLabelledBy:n.getStaticId("sap.m","TIMEPICKER_SET_TIME"),beforeOpen:this.onBeforeOpen.bind(this),beforeClose:this.onBeforeClose.bind(this),afterOpen:this.onAfterOpen.bind(this),afterClose:this.onAfterClose.bind(this)});W.setPopup(A._oControl);z=A.getAggregation("_popup");if(z.setShowArrow){z.setShowArrow(false);}z.oPopup.setAutoCloseAreas([N]);if(g.system.phone){S=this.$("inner").attr("aria-labelledby");U=S&&S.split(" ")[0];V=U?document.getElementById(U).getAttribute("aria-label"):"";if(V){A.setTitle(V);}A.setShowHeader(true);}else{this._oPopoverKeydownEventDelegate={onkeydown:function(X){var Y=K,Z=X.which||X.keyCode,$=X.altKey;if(($&&(Z===Y.ARROW_UP||Z===Y.ARROW_DOWN))||Z===Y.F4){this._handleOkPress(X);this.focus();X.preventDefault();}}};z.addEventDelegate(this._oPopoverKeydownEventDelegate,this);}A.addStyleClass(this.getRenderer().CSS_CLASS+"DropDown");A.open=function(){return this.openBy(i);};this.setAggregation("_picker",A,true);return A;};
t.prototype._createNumericPicker=function(F){var i=this,z,A,O,C,G=this._getLocale().getLanguage();A=sap.ui.getCore().getLibraryResourceBundle("sap.m");O=A.getText("TIMEPICKER_SET");C=A.getText("TIMEPICKER_CANCEL");z=new P(i.getId()+"-NP",{showArrow:false,showHeader:false,horizontalScrolling:false,verticalScrolling:false,placement:o.VerticalPreferredBottom,content:[new e(this.getId()+"-inputs",{support2400:this.getSupport2400(),displayFormat:F,valueFormat:F,localeId:G,minutesStep:this.getMinutesStep(),secondsStep:this.getSecondsStep(),showCurrentTimeButton:this.getShowCurrentTimeButton()})],footer:[new T({content:[new a(),new B(this.getId()+"-NumericOK",{text:O,type:r.Emphasized,press:this._handleNumericOkPress.bind(this)}),new B(this.getId()+"-NumericCancel",{text:C,press:this._handleNumericCancelPress.bind(this)})]})],ariaLabelledBy:n.getStaticId("sap.m","TIMEPICKER_SET_TIME"),beforeOpen:this.onBeforeNumericOpen.bind(this),afterOpen:this.onAfterNumericOpen.bind(this),beforeClose:this.onBeforeNumericClose.bind(this)});z.open=function(){return this.openBy(i);};this.setAggregation("_numPicker",z,true);return z;};
t.prototype._getClocks=function(){var i=this._getPicker();if(!i){return null;}return i.getContent()[1];};
t.prototype._getInputs=function(){var i=this._getNumericPicker();if(!i){return null;}return i.getContent()[0];};
t.prototype._handleOkPress=function(i){var z=this._getClocks().getTimeValues(),V;this._isClockPicker=true;this._isNumericPicker=false;V=this._formatValue(z);this.updateDomValue(V);this._handleInputChange();this._closePicker();};
t.prototype._handleCancelPress=function(i){this._closePicker();};
t.prototype._handleNumericOkPress=function(i){var z=this._getInputs().getTimeValues(),V;this._isClockPicker=false;this._isNumericPicker=true;V=this._formatValue(z);this.updateDomValue(V);this._handleInputChange();this.getDomRef("inner").select();this._closeNumericPicker();};
t.prototype._handleNumericCancelPress=function(i){this._closeNumericPicker();};
t.prototype._getLocaleBasedPattern=function(i){return j.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getTimePattern(i);};
t.prototype._parseValue=function(V,i){if(i){V=this._oTimeSemanticMaskHelper.stripValueOfLeadingSpaces(V);V=V.replace(this._rPlaceholderRegEx,'');}return D.prototype._parseValue.call(this,V,i);};
t.prototype._formatValue=function(i,V){var z=D.prototype._formatValue.apply(this,arguments),F=this.getValueFormat(),A=F.indexOf("HH"),C=F.indexOf("H"),G;if(i){if(!V&&this._oTimeSemanticMaskHelper){z=this._oTimeSemanticMaskHelper.formatValueWithLeadingTrailingSpaces(z);}}if((this._isNumericPicker&&this.isNumericOpen()&&this._getInputs()&&this._getInputs()._getHoursInput()&&this._getInputs()._getHoursInput().getValue()==="24")||(this._isClockPicker&&this.isOpen()&&this._getClocks()&&this._getClocks()._getHoursClock()&&this._getClocks()._getHoursClock().getSelectedValue()===24)){G=true;}if(i&&i.getHours()===0&&this.getSupport2400()&&G){z=c._replaceZeroHoursWith24(z,A,C);}return z;};
t.prototype._handleAriaOnExpandCollapse=function(i){this.getFocusDomRef().setAttribute("aria-expanded",i);};
t.prototype._increaseTime=function(N,U){var O=this.getDateValue(),i,z;if(O&&this.getEditable()&&this.getEnabled()){i=new Date(O.getTime());switch(U){case v.Hour:i.setHours(i.getHours()+N);z=60*60*1000;break;case v.Minute:i.setMinutes(i.getMinutes()+N);z=60*1000;break;case v.Second:z=1000;i.setSeconds(i.getSeconds()+N);}if(N<0&&i.getTime()-O.getTime()!==N*z){i=new Date(O.getTime()+N*z);}this.setDateValue(i);this.fireChangeEvent(this.getValue(),{valid:true});}};
t.prototype._initMask=function(){if(this._oTimeSemanticMaskHelper){this._oTimeSemanticMaskHelper.destroy();}this._oTimeSemanticMaskHelper=new x(this);};
t.prototype._isMaskEnabled=function(){return this.getMaskMode()===p.On&&!this._isMobileDevice();};
t.prototype._shouldSetInitialFocusedDateValue=function(){if(!this._isValidValue()){return true;}return!this.getValue()&&!!this.getInitialFocusedDateValue();};
t.prototype._isValidValue=function(){return this._bValid;};
t.prototype.fireChangeEvent=function(V,i){if(V){V=V.trim();}if(V!==this._sLastChangeValue){this._sLastChangeValue=V;D.prototype.fireChangeEvent.call(this,V,i);}};
var x=function(z){var A=z._getDisplayFormatPattern(),C,F,G=z._getLocale(),i;if(z._checkStyle(A)){C=j.getInstance(G).getTimePattern(A);}else{A=A.replace(/'/g,"");C=A;}this._oTimePicker=z;this.aOriginalAmPmValues=j.getInstance(G).getDayPeriods("abbreviated");this.aAmPmValues=this.aOriginalAmPmValues.slice(0);this.iAmPmValueMaxLength=Math.max(this.aAmPmValues[0].length,this.aAmPmValues[1].length);for(i=0;i<this.aAmPmValues.length;i++){while(this.aAmPmValues[i].length<this.iAmPmValueMaxLength){this.aAmPmValues[i]+=" ";}}this.b24H=A.indexOf("H")!==-1;this.bLeadingZero=A.indexOf("HH")!==-1||A.indexOf("hh")!==-1;this.sLeadingChar=this.bLeadingZero?"0":" ";this.sAlternativeLeadingChar=this.bLeadingZero?" ":"0";this.sLeadingRegexChar=this.bLeadingZero?"0":"\\s";z.setPlaceholderSymbol(w);C=C.replace(/hh/ig,"h").replace(/h/ig,"h9");if(this.b24H){F="["+this.sLeadingRegexChar+"012]";}else{F="["+this.sLeadingRegexChar+"1]";}this._maskRuleHours=new M({maskFormatSymbol:"h",regex:F});z.addRule(this._maskRuleHours);this.iHourNumber1Index=C.indexOf("h9");this.iHourNumber2Index=this.iHourNumber1Index!==-1?this.iHourNumber1Index+1:-1;this.iMinuteNumber1Index=C.indexOf("mm");C=C.replace(/mm/g,"59");this.iSecondNumber1Index=C.indexOf("ss");C=C.replace(/ss/g,"59");this._maskRuleMinSec=new M({maskFormatSymbol:"5",regex:"[0-5]"});z.addRule(this._maskRuleMinSec);this.aAllowedHours=U.call(this,this.b24H,this.sLeadingChar);this.aAllowedMinutesAndSeconds=V.call(this);this.iAmPmChar1Index=C.indexOf("a");this.iAfterAmPmValueIndex=-1;if(this.iAmPmChar1Index!==-1){this.iAfterAmPmValueIndex=this.iAmPmChar1Index+this.iAmPmValueMaxLength;var H=this.iAmPmValueMaxLength-"a".length;this.shiftIndexes(H);var J=65;var N="";var O="";var Q="";for(i=0;i<this.iAmPmValueMaxLength;i++){O="[";if(this.aAmPmValues[0][i]){O+=this.aAmPmValues[0][i];}else{O+="\\s";}if(this.aAmPmValues[1][i]!==this.aAmPmValues[0][i]){if(this.aAmPmValues[1][i]){O+=this.aAmPmValues[1][i];}else{O+="\\s";}}O+="]";Q=String.fromCharCode(J++);N+=Q;this._maskRuleChars=new M({maskFormatSymbol:Q,regex:O});z.addRule(this._maskRuleChars);}C=C.replace(/a/g,N);}z.setMask(C);function S(W,X,Y){var Z=[],$,i;for(i=W;i<=X;i++){$=i.toString();if(i<10){$=Y+$;}Z.push($);}return Z;}function U(W,X){var Y=W?0:1,Z=this._oTimePicker.getSupport2400()?24:23,$=W?Z:12;return S(Y,$,X);}function V(){return S(0,59,"0");}};
x.prototype.replaceChar=function(C,z,A){var F=z-this.iAmPmChar1Index,G,H,J,S,N,O,i;if(z===this.iHourNumber1Index&&this.sAlternativeLeadingChar===C){if(this.aAllowedHours.indexOf(this.sLeadingChar+C)!==-1){return this.sLeadingChar+C;}else{return this.sLeadingChar;}}else if(z===this.iHourNumber1Index&&!this._oTimePicker._isCharAllowed(C,z)&&this.aAllowedHours.indexOf(this.sLeadingChar+C)!==-1){return this.sLeadingChar+C;}else if(z===this.iHourNumber2Index&&A[this.iHourNumber1Index]===w){this._oTimePicker._oTempValue.setCharAt(this.sLeadingChar,this.iHourNumber1Index);return C;}else if(z===this.iHourNumber2Index&&this.aAllowedHours.indexOf(A[this.iHourNumber1Index]+C)===-1){return"";}else if((z===this.iMinuteNumber1Index||z===this.iSecondNumber1Index)&&!this._oTimePicker._isCharAllowed(C,z)&&this.aAllowedMinutesAndSeconds.indexOf("0"+C)!==-1){return"0"+C;}else if(F>=0&&z<this.iAfterAmPmValueIndex){G=A.slice(this.iAmPmChar1Index,z);H=this.aAmPmValues[0].slice(0,F);J=this.aAmPmValues[1].slice(0,F);N=this.aAmPmValues[0].slice(F,this.iAfterAmPmValueIndex);O=this.aAmPmValues[1].slice(F,this.iAfterAmPmValueIndex);S=(H===J);var Q="";for(i=F;i<this.iAmPmValueMaxLength;i++){if(this.aAmPmValues[0][i]===this.aAmPmValues[1][i]){Q+=this.aAmPmValues[0][i];}else{break;}}if(i===this.iAmPmValueMaxLength||i!==F){return Q;}else{if(!S){if(G===H){return N;}else if(G===J){return O;}else{return C;}}else{if(this.aAmPmValues[0][F].toLowerCase()===C.toLowerCase()&&this.aAmPmValues[0]===G+N){return N;}else if(this.aAmPmValues[1][F].toLowerCase()===C.toLowerCase()&&this.aAmPmValues[1]===G+O){return O;}else{return C;}}}}else{return C;}};
x.prototype.formatValueWithLeadingTrailingSpaces=function(i){var z=this._oTimePicker.getMask().length;if(this.aOriginalAmPmValues[0]!==this.aAmPmValues[0]){i=i.replace(this.aOriginalAmPmValues[0],this.aAmPmValues[0]);}if(this.aOriginalAmPmValues[1]!==this.aAmPmValues[1]){i=i.replace(this.aOriginalAmPmValues[1],this.aAmPmValues[1]);}while(z>i.length){i=[i.slice(0,this.iHourNumber1Index)," ",i.slice(this.iHourNumber1Index)].join('');}return i;};
x.prototype.stripValueOfLeadingSpaces=function(i){if(i[this.iHourNumber1Index]===" "){i=[i.slice(0,this.iHourNumber1Index),i.slice(this.iHourNumber1Index+1)].join('');}return i;};
x.prototype.shiftIndexes=function(i){if(this.iAmPmChar1Index<this.iHourNumber1Index){this.iHourNumber1Index+=i;this.iHourNumber2Index+=i;}if(this.iAmPmChar1Index<this.iMinuteNumber1Index){this.iMinuteNumber1Index+=i;}if(this.iAmPmChar1Index<this.iSecondNumber1Index){this.iSecondNumber1Index+=i;}};
x.prototype.destroy=function(){if(this._maskRuleHours){this._maskRuleHours.destroy();this._maskRuleHours=null;}if(this._maskRuleMinSec){this._maskRuleMinSec.destroy();this._maskRuleMinSec=null;}if(this._maskRuleChars){this._maskRuleChars.destroy();this._maskRuleChars=null;}};
t.prototype._feedReplaceChar=function(C,i,z){return this._oTimeSemanticMaskHelper.replaceChar(C,i,z);};
t.prototype._getAlteredUserInputValue=function(V){return V?this._formatValue(this._parseValue(V),true):V;};
t.prototype.getAccessibilityInfo=function(){var i=this.getRenderer();var z=D.prototype.getAccessibilityInfo.apply(this,arguments);var V=this.getValue()||"";if(this._bValid){var A=this.getDateValue();if(A){V=this._formatValue(A);}}q.extend(true,z,{role:i.getAriaRole(this),type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_TIMEINPUT"),description:[V,i.getLabelledByAnnouncement(this),i.getDescribedByAnnouncement(this)].join(" ").trim(),autocomplete:"none",expanded:false,haspopup:true,owns:this.getId()+"-clocks"});return z;};
function y(){var i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),z=j.getInstance(i);return z.getTimePattern(u.Medium);}
t.prototype._revertKey=function(i,S){S=S||this._getTextSelection();var z=S.iFrom,A=S.iTo,C=z,F,G;if(!S.bHasSelection){if(i.bBackspace){C=z=this._oRules.previousTo(z);}else if(i.bDelete){F=this.getPlaceholderSymbol();G=this._oTempValue._aContent.length;while((this._oTempValue._aContent[z]===F||this._oTempValue._aInitial[z]!==F)&&z<G){z++;}A=z;}}if(i.bBackspace||(i.bDelete&&S.bHasSelection)){A=A-1;}this._resetTempValue(z,A);this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(Math.max(this._iUserInputStartPosition,C));};
t._PICKER_CONTENT_HEIGHT="25rem";return t;});
sap.ui.predefine('sap/m/TimePickerClock',["sap/ui/core/Control","sap/ui/core/Configuration","./TimePickerClockRenderer","sap/ui/Device","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery"],function(C,a,T,D,K,q){"use strict";var A=200,b=100,L=1000;
var c=C.extend("sap.m.TimePickerClock",{
metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Misc",defaultValue:true},itemMin:{type:"int",group:"Data",defaultValue:-1},itemMax:{type:"int",group:"Data",defaultValue:-1},innerItems:{type:"boolean",group:"Appearance",defaultValue:false},label:{type:"string",group:"Appearance",defaultValue:null},fractions:{type:"boolean",group:"Appearance",defaultValue:true},lastItemReplacement:{type:"int",group:"Data",defaultValue:-1},prependZero:{type:"boolean",group:"Appearance",defaultValue:false},selectedValue:{type:"int",group:"Data",defaultValue:-1},displayStep:{type:"int",group:"Data",defaultValue:5},valueStep:{type:"int",group:"Data",defaultValue:1},support2400:{type:"boolean",group:"Misc",defaultValue:false}},events:{change:{parameters:{value:{type:"int"},stringValue:{type:"string"},finalChange:{type:"boolean"}}}}},
renderer:T
});
c.prototype.init=function(){this._onMouseWheel=this._onMouseWheel.bind(this);this._iHoveredValue=-1;this._iPrevHoveredValue=-1;};
c.prototype.onBeforeRendering=function(){var d=this.getDomRef();if(d){this._bFocused=d.contains(document.activeElement);this._detachEvents();}if(this.getSupport2400()&&this._get24HoursVisible()===undefined){this._save2400State();}};
c.prototype.onAfterRendering=function(){this._attachEvents();};
c.prototype.exit=function(){this._detachEvents();};
c.prototype.onThemeChanged=function(e){this.invalidate();};
c.prototype.setSelectedValue=function(v){var r=this.getLastItemReplacement(),m=this.getItemMax()*(this.getInnerItems()?2:1);if(!this.getSupport2400()){if(v===0){v=m;}if(v===m&&r!==-1){v=r;}}this.setProperty("selectedValue",v);this.fireChange({value:v,stringValue:this._getStringValue(v),finalChange:false});return this;};
c.prototype.getSelectedValue=function(){var v=this.getProperty("selectedValue"),r=this.getLastItemReplacement(),m=this.getItemMax()*(this.getInnerItems()?2:1);if(this.getSupport2400()&&this._get24HoursVisible()&&v===m&&r!==-1){v=r;}return parseInt(v);};
c.prototype._getStringValue=function(v){var V=v.toString();if(this.getPrependZero()){V=V.padStart(2,"0");}return V;};
c.prototype._save2400State=function(){this._set24HoursVisible(this.getSupport2400()&&this.getSelectedValue()===0?false:true);};
c.prototype._set24HoursVisible=function(i){if(this.getSupport2400()){this._is24HoursVisible=i;this.setLastItemReplacement(i?24:0);}else{this._is24HoursVisible=false;}};
c.prototype._get24HoursVisible=function(){return this.getSupport2400()?this._is24HoursVisible:false;};
c.prototype._markToggleAsSelected=function(i){this._selectToggledElement=i;return this;};
c.prototype._attachEvents=function(){var e=this._getClockCoverContainerDomRef();this.$().on(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onMouseWheel);document.addEventListener("mouseup",q.proxy(this._onMouseOutUp,this),false);if(e){if(D.system.combi||D.system.phone||D.system.tablet){e.addEventListener("touchstart",q.proxy(this._onTouchStart,this),false);e.addEventListener("touchmove",q.proxy(this._onTouchMove,this),false);e.addEventListener("touchend",q.proxy(this._onTouchEnd,this),false);}if(D.system.desktop||D.system.combi){e.addEventListener("mousedown",q.proxy(this._onTouchStart,this),false);e.addEventListener("mousemove",q.proxy(this._onTouchMove,this),false);e.addEventListener("mouseup",q.proxy(this._onTouchEnd,this),false);e.addEventListener("mouseout",q.proxy(this._onMouseOut,this),false);}}};
c.prototype._detachEvents=function(){var e=this._getClockCoverContainerDomRef();this.$().off(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onMouseWheel);document.removeEventListener("mouseup",q.proxy(this._onMouseOutUp,this),false);if(e){if(D.system.combi||D.system.phone||D.system.tablet){e.removeEventListener("touchstart",q.proxy(this._onTouchStart,this),false);e.removeEventListener("touchmove",q.proxy(this._onTouchMove,this),false);e.removeEventListener("touchend",q.proxy(this._onTouchEnd,this),false);}if(D.system.desktop||D.system.combi){e.removeEventListener("mousedown",q.proxy(this._onTouchStart,this),false);e.removeEventListener("mousemove",q.proxy(this._onTouchMove,this),false);e.removeEventListener("mouseup",q.proxy(this._onTouchEnd,this),false);e.removeEventListener("mouseout",q.proxy(this._onMouseOut,this),false);}}};
c.prototype._getClockCoverContainerDomRef=function(){return this.getDomRef("cover");};
c.prototype._onMouseOutUp=function(e){this._mouseOrTouchDown=false;};
c.prototype._onMouseOut=function(e){var i=this.getId(),n=document.getElementById(i+"-"+this._iHoveredValue);n&&n.classList.remove("sapMTPCNumberHover");this._iHoveredValue=-1;this._iPrevHoveredValue=-1;};
c.prototype.modifyValue=function(i){var s=this.getSelectedValue(),r=this.getLastItemReplacement(),I=this.getInnerItems(),m=this.getItemMin(),M=this.getItemMax()*(I?2:1),S=this.getValueStep(),n;if(s%S!==0){n=i?Math.ceil(s/S)*S:Math.floor(s/S)*S;S=Math.abs(s-n);}if(this.getSupport2400()&&!this._get24HoursVisible()){m=0;M=23;r=-1;}if(s===r){s=M;}if(i){s+=S;if(s>M){s=this.getSupport2400()?m:s-M;}}else{s-=S;if(s<m){s=M;}}this.setSelectedValue(s);};
c.prototype._onMouseWheel=function(e){var o=e.originalEvent,i=o.detail?(-o.detail>0):(o.wheelDelta>0);e.preventDefault();if(!this._mouseOrTouchDown){this.modifyValue(i);}};
c.prototype._onTouchStart=function(e){this._cancelTouchOut=false;if(!this.getEnabled()){return;}this._iMovSelectedValue=this.getSelectedValue();this._calculateDimensions();this._x=e.type==="touchstart"?e.touches[0].pageX:e.pageX;this._y=e.type==="touchstart"?e.touches[0].pageY:e.pageY;this._calculatePosition(this._x,this._y);if(this.getSupport2400()&&e.type==="touchstart"&&(this._iSelectedValue===24||this._iSelectedValue===0)){this._resetLongTouch();this._startLongTouch();}this._mouseOrTouchDown=true;};
c.prototype._onTouchMove=function(e){var i,d,n;e.preventDefault();if(this._mouseOrTouchDown){this._x=e.type==="touchmove"?e.touches[0].pageX:e.pageX;this._y=e.type==="touchmove"?e.touches[0].pageY:e.pageY;this._calculatePosition(this._x,this._y);if(this.getEnabled()&&this._iSelectedValue!==-1&&this._iSelectedValue!==this._iMovSelectedValue){this.setSelectedValue(this._iSelectedValue);this._iMovSelectedValue=this._iSelectedValue;if(this.getSupport2400()&&e.type==="touchmove"&&(this._iSelectedValue===24||this._iSelectedValue===0)){this._resetLongTouch();this._startLongTouch();}}}else if(e.type==="mousemove"){if(!this._dimensionParameters){this._calculateDimensions();}this._x=e.pageX;this._y=e.pageY;this._calculatePosition(this._x,this._y);d=this.getDisplayStep();if(d>1){this._iHoveredValue=Math.round(this._iHoveredValue/d)*d;}if(this.getEnabled()&&this._iHoveredValue!==this._iPrevHoveredValue){i=this.getId();n=document.getElementById(i+"-"+this._iPrevHoveredValue);n&&n.classList.remove("sapMTPCNumberHover");this._iPrevHoveredValue=this._iHoveredValue;n=document.getElementById(i+"-"+this._iPrevHoveredValue);n&&n.classList.add("sapMTPCNumberHover");}}};
c.prototype._onTouchEnd=function(e){var o=sap.ui.getCore().getConfiguration().getAnimationMode(),s=o===a.AnimationMode.none||o===a.AnimationMode.minimal;if(!this._mouseOrTouchDown){return;}this._mouseOrTouchDown=false;e.preventDefault();if(!this.getEnabled()||this._iSelectedValue===-1){return;}if(e.type==="touchend"){this._resetLongTouch();}if(!this._cancelTouchOut){this._changeValueAnimation(this._iSelectedValue,s);}};
c.prototype._resetLongTouch=function(){if(this._longTouchId){clearTimeout(this._longTouchId);}};
c.prototype._startLongTouch=function(){this._longTouchId=setTimeout(function(){var v=this._iSelectedValue;this._longTouchId=null;if(v===0||v===24){this._toggle2400();}}.bind(this),L);};
c.prototype._getMaxValue=function(){var i=this.getItemMax();return this.getInnerItems()?i*2:i;};
c.prototype._toggle2400=function(s){var i=this._get24HoursVisible(),v=i?0:24;this._cancelTouchOut=true;this._set24HoursVisible(!i);this.setLastItemReplacement(v);if(!s){this._iMovSelectedValue=v;this.setSelectedValue(v);}return this;};
c.prototype._changeValueAnimation=function(n,s){var o=this._iMovSelectedValue,i=this.getInnerItems(),m=this.getItemMax()*(i?2:1),p,P,d,f=o,l=n,e=1;if(!s){if(f<l){p=l-f;P=m-p;if(P<p){f+=m;e=-1;}}else{p=f-l;P=m-p;if(P<p){l+=m;}else{e=-1;}}if(f===l){d=0;}else{d=Math.ceil(A/Math.abs(f-l));}this._animationInProgress=true;_(this,f,l,e,m,n,d,this.getSupport2400(),this._get24HoursVisible());}else{this.setSelectedValue(n);this.fireChange({value:n,stringValue:this._getStringValue(n),finalChange:true});}};
c.prototype._calculateDimensions=function(){var o=this._getClockCoverContainerDomRef(),r=Math.round(o.offsetHeight/2),d=q('.sapMTPCDot').first().outerHeight(true),n=q('.sapMTPCNumber').first().outerHeight(true),O=o.getBoundingClientRect();this._dimensionParameters={'radius':r,'centerX':r,'centerY':r,'dotHeight':d,'numberHeight':n,'outerMax':r,'outerMin':r-n,'innerMax':r-n-1,'innerMin':r-n*2-1,'offsetX':O.left,'offsetY':O.top};};
c.prototype._calculatePosition=function(x,y){var i=this.getItemMax(),r=this.getLastItemReplacement(),s=this.getValueStep(),d=x-this._dimensionParameters.offsetX+1-this._dimensionParameters.radius,e=y-this._dimensionParameters.offsetY+1-this._dimensionParameters.radius,m=d>=0?0:180,f=(Math.atan(e/d)*180/Math.PI)+90+m,g=360/i*s,I=this.getInnerItems(),R=Math.sqrt(d*d+e*e),F=Math.round((f===0?360:f)/g)*g,h=R<=this._dimensionParameters.outerMax&&R>(I?this._dimensionParameters.outerMin:this._dimensionParameters.innerMin),j=I&&R<=this._dimensionParameters.innerMax&&R>this._dimensionParameters.innerMin,k=R<=this._dimensionParameters.outerMax&&R>this._dimensionParameters.outerMin,l=j,S=this.getSupport2400(),n=this._get24HoursVisible();if(F===0){F=360;}if(j||h){this._iSelectedValue=(F/g)*s;if(j){this._iSelectedValue+=i;}if(S&&!n&&this._iSelectedValue===24){this._iSelectedValue=0;}}else{this._iSelectedValue=-1;}if(l||k){this._iHoveredValue=S&&!n&&this._iSelectedValue===0?24:this._iSelectedValue;}else{this._iHoveredValue=-1;}if(this._iSelectedValue===this._getMaxValue()&&r!==-1){this._iSelectedValue=r;}};
c.prototype._setEnabled=function(e){this.setEnabled(e);if(e){this.$().removeClass("sapMTPDisabled");}else{this.$().addClass("sapMTPDisabled");}return this;};
function _(o,f,l,d,m,n,i,s,I){var e;if(f===l){o._animationInProgress=false;}e=f>m?f-m:f;if(s){if(e===24&&!I){e=0;}else if(e===0&&I){e=24;}}o.setSelectedValue(e);if(f!==l){f+=d;setTimeout(function(){_(o,f,l,d,m,n,i,s,I);},i);}else{setTimeout(function(){o.fireChange({value:n,stringValue:o._getStringValue(n),finalChange:true});},b);}}
return c;});
sap.ui.predefine('sap/m/TimePickerClockRenderer',[],function(){"use strict";var T={apiVersion:2};var C=6;
T.render=function(r,c){var R=c.getLastItemReplacement(),d=c.getDisplayStep(),v=c.getValueStep(),f=c.getFractions(),i=c.getInnerItems(),l=c.getLabel(),L=R!==-1?true:false,I=c.getItemMin(),a=c.getItemMax(),s=c.getSelectedValue(),S=(s>=I&&s<=a)||(!i&&s===R),b=((s>=I+a&&s<a*2)||s===R)&&i,V=[],e=[],g,h,j;for(h=I;h<=a-1;h++){V.push(h);if(i){e.push(h+a);}}V.push(L&&!i?R:a);if(i){e.push(L?R.toString().padStart(2,"0"):c._getMaxValue());}g=360/C/V.length;if(v*g>d){d=v*g;}r.openStart("div",c.getId());r.class("sapMTPClock");if(i){r.class("sapMTPCInner");}r.attr("ondragstart","return false;");r.attr("ondrop","return false;");r.attr("aria-hidden","true");r.openEnd();r.openStart("div");r.class("sapMTPCDial");r.attr("data-label",l);r.openEnd();r.close("div");r.openStart("div");r.openEnd();for(h=1;h<=60;h++){r.openStart("div");r.class("sapMTPCItem");r.class("sapMTPCDeg"+(h*C));j=h/g-1;r.openEnd();if(h%d!==0){if(f){r.openStart("span");r.class("sapMTPCMidDot");r.openEnd();r.close('span');}}else{r.openStart("span");r.class("sapMTPCDot");r.openEnd();r.close('span');r.openStart("span",c.getId()+"-"+(j+1));r.class("sapMTPCNumber");r.openEnd();r.text(V[j]);r.close('span');if(i){r.openStart("span",c.getId()+"-"+(j+a+1));r.class("sapMTPCNumber");if(j===11&&(s===0||s===24)&&c.getSupport2400()&&c._selectToggledElement){r.class("sapMTPCSelected");}r.openEnd();r.text(e[j]);r.close('span');}}r.close('div');}r.close("div");if(S||b){if(s===0){s=c._getMaxValue();}j=s-1;r.openStart("div");r.class("sapMTPCItem");h=b?s-a:s;r.class("sapMTPCDeg"+h*C*g);r.openEnd();r.openStart("div");r.class("sapMTPCMarker");r.openEnd();r.close('div');r.openStart("div");r.class("sapMTPCNumber");if(S){r.class("sapMTPCSelected");r.attr("id",c.getId()+"-selected");}else{r.class("sapMTPCInvisible");}r.openEnd();r.text(V[j]);r.close('div');if(b){r.openStart("div",c.getId()+"-selected");r.class("sapMTPCNumber");r.class("sapMTPCSelected");r.openEnd();r.text(e[j-a]);r.close('div');}r.close("div");}r.openStart("div",c.getId()+"-cover");r.class("sapMTPClockCover");r.openEnd();r.close("div");r.close("div");};
return T;});
sap.ui.predefine('sap/m/TimePickerClocks',["./TimePickerInternals","./TimePickerClock","./ToggleButton","./SegmentedButton","./SegmentedButtonItem","./TimePickerClocksRenderer","./ToggleButtonRenderer","sap/ui/core/Renderer","sap/ui/events/KeyCodes",'sap/ui/Device','sap/ui/core/library',"sap/ui/thirdparty/jquery"],function(T,a,b,S,c,d,e,R,K,D,f,q){"use strict";var g=1000;var h=f.TextDirection;
var i=T.extend("sap.m.TimePickerClocks",{metadata:{aggregations:{_buttons:{type:"sap.m.internal.ToggleSpinButton",multiple:true,visibility:"hidden"},_clocks:{type:"sap.m.TimePickerClock",multiple:true,visibility:"hidden"}}}});
var j=R.extend(e);j.apiVersion=2;
j.render=function(r,B){var s=B.getId(),t=B.getType(),E=B.getEnabled(),w=B.getWidth(),l=B._getTooltip(),m=B._getText(),n=B.getTextDirection(),I=D.browser.internet_explorer||D.browser.edge,o=(n===h.Inherit)&&!I;r.openStart("div",B);r.class("sapMBtnBase");r.class("sapMBtn");var A=this.generateAccProps(B);A["pressed"]=null;A["valuemin"]=B.getMin();A["valuemax"]=B.getMax();A["valuenow"]=parseInt(B.getText());A["label"]=B.getLabel();A["valuetext"]=parseInt(B.getText()).toString()+" "+B.getLabel();A["role"]="spinbutton";r.accessibilityState(B,A);if(!E){r.attr("disabled","disabled");r.class("sapMBtnDisabled");}if(w!=""||w.toLowerCase()==="auto"){r.style("width",w);r.style("min-width","2.25rem");}r.attr("tabindex","0");r.openEnd();r.openStart("span",s+"-inner");r.class("sapMBtnInner");if(B._isHoverable()){r.class("sapMBtnHoverable");}if(E){r.class("sapMFocusable");if(I){r.class("sapMIE");}}if(m){r.class("sapMBtnText");}if(B.getPressed()){r.class("sapMToggleBtnPressed");}if(t!==""){r.class("sapMBtn"+t);}r.openEnd();if(m){r.openStart("span",s+"-content");r.class("sapMBtnContent");if(n!==h.Inherit){r.attr("dir",n.toLowerCase());}r.openEnd();if(o){r.openStart("bdi",s+"-BDI-content");r.openEnd();}r.text(m);if(o){r.close("bdi");}r.close("span");}if(I&&E){r.openStart("span");r.class("sapMBtnFocusDiv");r.openEnd();r.close("span");}r.close("span");if(l){r.openStart("span",s+"-tooltip");r.class("sapUiInvisibleText");r.openEnd();r.text(l);r.close("span");}r.close("div");};
var k=b.extend("sap.m.internal.ToggleSpinButton",{
metadata:{library:"sap.m",properties:{label:{type:"string",defaultValue:""},min:{type:"int",defaultValue:0},max:{type:"int",defaultValue:0}}},
renderer:j
});
i.prototype.init=function(){T.prototype.init.apply(this,arguments);this._activeClock=0;};
i.prototype.onAfterRendering=function(){if(!this._clickAttached){this._attachClickEvent();}this._clockConstraints=this._getClocksConstraints();};
i.prototype.onkeyup=function(E){var l=E.which||E.keyCode;if(l===K.CONTROL){E.preventDefault();if(this._clockIndexes.H===this._getActiveClockIndex()&&this.getSupport2400()&&this._ctrlKeyDown===1){this._getActiveClock()._toggle2400(true)._markToggleAsSelected(false);}this._ctrlKeyDown=0;}else if(l===K.SPACE){this._spaceKeyDown=false;}};
i.prototype.onkeydown=function(E){var l=E.which||E.keyCode,C=E.key,m=this.getAggregation("_clocks"),o=this._getActiveClock(),A=this._getActiveClockIndex(),s=this.getSupport2400(),n=["0","1","2","3","4","5","6","7","8","9",":"],p,H,v,B="",r,I,t,M=0,V=-1,u=E.srcControl&&E.srcControl.getMetadata().getName().indexOf("ToggleSpinButton")===-1?false:true;if(this._clockIndexes.H===A&&s&&l===K.CONTROL&&!this._ctrlKeyDown){E.preventDefault();this._ctrlKeyDown=1;o._toggle2400(true)._markToggleAsSelected(true);}else if(l===K.ENTER){if(!u){return;}if(typeof this._parentAcceptCallback==="function"){this._parentAcceptCallback();}}else if((l===K.ARROW_UP||l===K.ARROW_DOWN)&&!E.altKey&&!E.metaKey){o&&o.getEnabled()&&o.modifyValue(l===K.ARROW_UP);E.preventDefault();}else if((l===K.PAGE_UP||l===K.PAGE_DOWN)&&!E.altKey&&!E.metaKey){E.preventDefault();if(!E.shiftKey&&!E.ctrlKey){o=this._getHoursClock();}else if(E.shiftKey&&!E.ctrlKey){o=this._getMinutesClock();}else{o=this._getSecondsClock();}o&&o.getEnabled()&&o.modifyValue(l===K.PAGE_UP);o&&this._switchClock(this._getClockIndex(o));}else if(l===K.P||l===K.A){E.preventDefault();p=this._getFormatButton();p&&p.setSelectedKey(l===K.P?"pm":"am");}else if(l===K.SPACE&&!this._spaceKeyDown){if(!u){return;}E.preventDefault();this._spaceKeyDown=true;v=o.getSelectedValue();H=o._get24HoursVisible()?24:0;if(this._clockIndexes.H===A&&s&&v!==H&&(v===24||v===0)){o.setSelectedValue(H);}this._kbdBuffer="";this._resetCooldown(true);setTimeout(function(){this._switchNextClock(true);}.bind(this),0);}else if(n.indexOf(C)!==-1){this._exactMatch=null;this._resetCooldown(true);if(C===":"){this._kbdBuffer="";this._resetCooldown(true);this._switchNextClock(true);}else if(this._clockConstraints[A]){B=this._kbdBuffer+C;r=parseInt(B);if(this._clockConstraints[A].step===1){if(r>this._clockConstraints[A].max){m[A].setSelectedValue(parseInt(this._kbdBuffer));this._switchNextClock();this._kbdBuffer=C;A=this._getActiveClockIndex();m[A].setSelectedValue(parseInt(C));this._resetCooldown(true);}else{this._kbdBuffer=B;m[A].setSelectedValue(parseInt(this._kbdBuffer));if(this._kbdBuffer.length===2||parseInt(this._kbdBuffer+"0")>this._clockConstraints[A].max){this._resetCooldown(this._kbdBuffer.length===2?false:true);this._kbdBuffer="";this._switchNextClock();}}}else{for(I=this._clockConstraints[A].min;I<=this._clockConstraints[A].max;I++){if(I%this._clockConstraints[A].step===0){t=I.toString();if(B===t.substr(0,B.length)||r===I){M++;V=M===1?I:-1;if(r===I){this._exactMatch=I;}}}}if(M===1){m[A].setSelectedValue(V);this._exactMatch=null;this._kbdBuffer="";this._resetCooldown(true);this._switchNextClock();}else if(B.length===2){this._exactMatch=null;this._kbdBuffer="";this._resetCooldown(true);}else{this._kbdBuffer=B;}}}}};
i.prototype.setValue=function(v){var H=this._getHoursClock(),F=this._getValueFormatPattern(),I=F.indexOf("HH"),l=F.indexOf("H"),m=H&&H.getSelectedValue()===24,n=T._isHoursValue24(v,I,l),o;if(m&&this._isFormatSupport24()&&!n){v=T._replaceZeroHoursWith24(v,I,l);}v=this.validateProperty("value",v);this.setProperty("value",v,true);if(v){o=this._parseValue(n?T._replace24HoursWithZero(v,I,l):v);}if(o){this._setTimeValues(o,n);}return this;};
i.prototype.getTimeValues=function(){var H=this._getHoursClock(),m=this._getMinutesClock(),s=this._getSecondsClock(),F=this._getFormatButton(),l=null,A=null,o=new Date();if(H){l=parseInt(H.getSelectedValue());}if(F){A=F.getSelectedKey();}if(A==="am"&&l===12){l=0;}else if(A==="pm"&&l!==12){l+=12;}if(l!==null){o.setHours(l.toString());}if(m){o.setMinutes(m.getSelectedValue());}if(s){o.setSeconds(s.getSelectedValue());}return o;};
i.prototype.showFirstClock=function(){this._switchClock(0);return this;};
i.prototype._attachClickEvent=function(){var E=this.getDomRef();E.addEventListener("click",q.proxy(this._focusActiveButton,this),false);this._clickAttached=true;};
i.prototype._focusActiveButton=function(){var B=this.getAggregation("_buttons"),A=this._getActiveClockIndex();B&&B[A]&&B[A].focus();};
i.prototype._setAcceptCallback=function(C){this._parentAcceptCallback=C;};
i.prototype._resetCooldown=function(s){if(g===0){return;}if(this._typeCooldownId){clearTimeout(this._typeCooldownId);}if(s){this._startCooldown();}};
i.prototype._startCooldown=function(){if(g===0){return;}this._typeCooldownId=setTimeout(function(){this._kbdBuffer="";this._typeCooldownId=null;if(this._exactMatch){this._getActiveClock().setSelectedValue(this._exactMatch);this._exactMatch=null;}}.bind(this),g);};
i.prototype._switchNextClock=function(w){var A=this._getActiveClockIndex(),C=this.getAggregation("_clocks"),l=C.length,o=this._getActiveClock(),s=A;if(!C){return;}if(this._clockIndexes.H===A&&this.getSupport2400()){o._save2400State();if(o.getSelectedValue()===24){return;}}do{A++;if(A>=l){A=w?0:l-1;}}while(!o.getEnabled()&&A!==s&&(w||A<l-1));this._ctrlKeyDown=0;if(A!==s&&C[A].getEnabled()){this._switchClock(A);}};
i.prototype._getClocksConstraints=function(){var C=this.getAggregation("_clocks"),s=this.getSupport2400(),l=[],m,M,n,r,I;if(C){for(I=0;I<C.length;I++){m=C[I].getItemMin();M=C[I]._getMaxValue();n=C[I].getValueStep();r=C[I].getLastItemReplacement();if(r!==-1&&r<m){m=r;if(M!==24||!s){M--;}}else if(M===24&&s){m=0;}l[I]={min:m,max:M,step:n,prependZero:C[I].getPrependZero()};}}return l;};
i.prototype._getActiveClockIndex=function(){return this._activeClock||0;};
i.prototype._getActiveClock=function(){var A=this._getActiveClockIndex(),C=this.getAggregation("_clocks");return C&&C[A]?C[A]:null;};
i.prototype._setTimeValues=function(o,H){var l=this._getHoursClock(),m=this._getMinutesClock(),s=this._getSecondsClock(),M=this._getMinutesButton(),n=this._getSecondsButton(),F=this._getFormatButton(),v=this.getValueFormat(),p,A=null;o=o||new Date();if(Object.prototype.toString.call(o)!=="[object Date]"||isNaN(o)){throw new Error("Date must be a JavaScript date object; "+this);}if(!H){var V=this._formatValue(o,true);this.setProperty("value",V,true);p=o.getHours();}else{p=24;}if((v.indexOf("a")!==-1||v==="")&&F){A=p>=12?"pm":"am";p=(p>12)?p-12:p;p=(p===0?12:p);F&&F.setSelectedKey(A);}l&&l.setSelectedValue(p);m&&m.setSelectedValue(o.getMinutes());s&&s.setSelectedValue(o.getSeconds());l&&this.getSupport2400()&&l._save2400State();if(H){m&&m.setSelectedValue(0).setEnabled(false);s&&s.setSelectedValue(0).setEnabled(false);M&&M.setEnabled(false);n&&n.setEnabled(false);}else{m&&m.setEnabled(true);s&&s.setEnabled(true);M&&M.setEnabled(true);n&&n.setEnabled(true);}};
i.prototype._getHoursClock=function(){var C=this.getAggregation("_clocks");return C&&this._clockIndexes&&C[this._clockIndexes.H]?C[this._clockIndexes.H]:null;};
i.prototype._getMinutesClock=function(){var C=this.getAggregation("_clocks");return C&&this._clockIndexes&&C[this._clockIndexes.M]?C[this._clockIndexes.M]:null;};
i.prototype._getSecondsClock=function(){var C=this.getAggregation("_clocks");return C&&this._clockIndexes&&C[this._clockIndexes.S]?C[this._clockIndexes.S]:null;};
i.prototype._getHoursButton=function(){var B=this.getAggregation("_buttons");return B&&this._clockIndexes&&B[this._clockIndexes.H]?B[this._clockIndexes.H]:null;};
i.prototype._getMinutesButton=function(){var B=this.getAggregation("_buttons");return B&&this._clockIndexes&&B[this._clockIndexes.M]?B[this._clockIndexes.M]:null;};
i.prototype._getSecondsButton=function(){var B=this.getAggregation("_buttons");return B&&this._clockIndexes&&B[this._clockIndexes.S]?B[this._clockIndexes.S]:null;};
i.prototype._destroyControls=function(){this.destroyAggregation("_buttons");this.destroyAggregation("_clocks");this.destroyAggregation("_buttonAmPm");};
i.prototype._createControls=function(){var F=this._getDisplayFormatPattern(),I=this.getId(),l=this._isFormatSupport24(),s=this.getSupport2400(),m=0,n=0,o=0,p="",L=-1,r,t,H,B,C,u=0,v,w,x,P=false,V,y;this._clockIndexes={};if(F===undefined){return;}r=F.indexOf("HH");t=F.indexOf("H");if(r!==-1){v=true;P=true;L=(s)?24:0;w=0;x=23;}else if(t!==-1){v=true;L=(s)?24:0;w=0;x=23;}else if(F.indexOf("hh")!==-1){v=true;P=true;w=1;x=12;}else if(F.indexOf("h")!==-1){v=true;w=1;x=12;}if(v){this.addAggregation("_clocks",new a(I+"-clockH",{label:this._oResourceBundle.getText("TIMEPICKER_LBL_HOURS"),selectedValue:m,itemMin:1,itemMax:12,valueStep:1,displayStep:1,innerItems:l,lastItemReplacement:L,prependZero:P,support2400:s}));if(s){x++;}this.addAggregation("_buttons",new k(I+"-btnH",{label:this._oResourceBundle.getText("TIMEPICKER_LBL_HOURS"),min:w,max:x}));this._clockIndexes.H=u++;}if(F.indexOf("m")!==-1){if(F.indexOf("mm")!==-1){L=0;P=true;}else{L=0;P=false;}this.addAggregation("_clocks",new a(I+"-clockM",{label:this._oResourceBundle.getText("TIMEPICKER_LBL_MINUTES"),selectedValue:n,itemMin:1,itemMax:60,valueStep:this.getMinutesStep(),lastItemReplacement:L,prependZero:P}));this.addAggregation("_buttons",new k(I+"-btnM",{label:this._oResourceBundle.getText("TIMEPICKER_LBL_MINUTES"),min:0,max:59}));this._clockIndexes.M=u++;}if(F.indexOf("s")!==-1){if(F.indexOf("ss")!==-1){L=0;P=true;}else{L=0;P=false;}this.addAggregation("_clocks",new a(I+"-clockS",{label:this._oResourceBundle.getText("TIMEPICKER_LBL_SECONDS"),selectedValue:o,itemMin:1,itemMax:60,valueStep:this.getSecondsStep(),lastItemReplacement:L,prependZero:P}));this.addAggregation("_buttons",new k(I+"-btnS",{label:this._oResourceBundle.getText("TIMEPICKER_LBL_SECONDS"),min:0,max:59}));this._clockIndexes.S=u++;}if(F.indexOf("a")!==-1){this.setAggregation("_buttonAmPm",new S(I+"-format",{items:[new c({text:this._sAM,key:"am"}),new c({text:this._sPM,key:"pm"})],selectedKey:p,tooltip:this._oResourceBundle.getText("TIMEPICKER_AMPM_BUTTON_TOOLTIP")}));}if(!this.getAggregation("_nowButton")){this.setAggregation("_nowButton",this._getCurrentTimeButton());}B=this.getAggregation("_buttons");C=this.getAggregation("_clocks");this._clockCount=C.length;this._switchClock(0);for(u=0;u<this._clockCount;u++){this._attachEvents(C[u],B[u]);}V=this.getValue();if(V){H=T._isHoursValue24(V,r,t);y=this._parseValue(H?T._replace24HoursWithZero(V,r,t):V);if(y){this._setTimeValues(y,H);}}};
i.prototype._attachEvents=function(C,B){C.attachChange(function(E){var s=E.getParameter("value"),I=E.getParameter("finalChange"),v=E.getParameter("stringValue"),l=this.getAggregation("_buttons"),m=E.getParameter("id").slice(-1);l[this._clockIndexes[m]]&&l[this._clockIndexes[m]].setText(v).focus();if(!I){if(m==="H"){this._handleHoursChange(E);}return;}if(!this.getSupport2400()||s!==24){setTimeout(function(){this._switchNextClock();}.bind(this),0);}}.bind(this));B.attachPress(function(E){var s=E.getParameter("id").slice(-1),l=this.getAggregation("_clocks");if(l[this._clockIndexes[s]].getEnabled()){this._switchClock(this._clockIndexes[s]);}}.bind(this));B.onfocusin=function(E){var s=E.target.id.slice(-1),l=this.getAggregation("_clocks");if(l[this._clockIndexes[s]].getEnabled()){this._switchClock(this._clockIndexes[s]);}}.bind(this);};
i.prototype._switchClock=function(C){var l=this.getAggregation("_clocks"),B=this.getAggregation("_buttons"),A=this._getActiveClock();if(C!==this._activeClock){A._save2400State();}if(this._activeClock!==undefined){B[this._activeClock].setPressed(false);l[this._activeClock].removeStyleClass("sapMTPCActive");}l[C].addStyleClass("sapMTPCActive");B[C].setPressed(true);B[C].focus();this._activeClock=C;};
i.prototype._getClockIndex=function(C){var s=C.getId().slice(-1);return this._clockIndexes[s];};
i.prototype._handleHoursChange=function(E){var v=parseInt(E.getParameter("value")),m=this._getMinutesClock(),s=this._getSecondsClock(),M=this._getMinutesButton(),o=this._getSecondsButton();if(!this.getSupport2400()){return;}this._ctrlKeyDown=this._ctrlKeyDown?2:0;if(v===24){if(m&&m.getEnabled()){this._sMinutes=m.getSelectedValue();this._setControlValueAndEnabled(m,M,0,false);}if(s&&s.getEnabled()){this._sSeconds=s.getSelectedValue();this._setControlValueAndEnabled(s,o,0,false);}}else{if(m&&!m.getEnabled()){this._setControlValueAndEnabled(m,M,this._sMinutes,true);}if(s&&!s.getEnabled()){this._setControlValueAndEnabled(s,o,parseInt(this._sSeconds),true);}}this._getHoursButton().focus();};
i.prototype._setControlValueAndEnabled=function(C,B,v,E){C.setSelectedValue(parseInt(v));C.setEnabled(E);B.setEnabled(E);};
i.prototype._formatNumberToString=function(n,p,m,r){var N;if(p&&n<10){N=n.toString().padStart(2,"0");}else if(n===m&&r!==""){N=r;}else{N=n.toString();}return N;};
return i;});
sap.ui.predefine('sap/m/TimePickerClocksRenderer',["sap/ui/Device"],function(D){"use strict";var T={apiVersion:2};
T.render=function(r,c){r.openStart("div",c);r.class("sapMTPClocksContainer");r.openEnd();this.renderButtons(r,c);this.renderClocks(r,c);r.close("div");};
T.renderButtons=function(r,c){var b=c.getAggregation("_buttons"),s=c.getAggregation("_buttonAmPm"),S=c._getTimeSeparators(c._getDisplayFormatPattern()),a,i;if(b){if(s){b.push(s);}r.openStart("div");r.class("sapMTPCButtons");r.openEnd();for(i=0;i<b.length;i++){r.renderControl(b[i]);if(i<b.length-1){a=S.shift();if(!a){a=" ";}r.openStart("span");r.attr("aria-hidden","true");r.openEnd();r.text(a);r.close("span");}}r.renderControl(c._getCurrentTimeButton());r.close("div");}};
T.renderClocks=function(r,c){var C=c.getAggregation("_clocks"),i;if(C){r.openStart("div");r.class("sapMTPCClocks");r.attr("role","img");r.attr("aria-label",c._getAriaLabel());r.openEnd();for(i=0;i<C.length;i++){if(i===c._getActiveClock()){C[i].addStyleClass("sapMTPCActive");}r.renderControl(C[i]);}r.close("div");}};
return T;},true);
sap.ui.predefine('sap/m/TimePickerInputs',["./library","sap/ui/core/library","./TimePickerInternals","./Input","./InputRenderer","sap/ui/core/Renderer","./SegmentedButton","./SegmentedButtonItem","sap/ui/core/InvisibleText","sap/ui/events/KeyCodes","./TimePickerInputsRenderer","sap/ui/thirdparty/jquery"],function(l,c,T,I,a,R,S,b,d,K,e,q){"use strict";var f=l.InputType,g=c.TextAlign,h=1000;
var i=T.extend("sap.m.TimePickerInputs",{metadata:{aggregations:{_inputs:{type:"sap.m.Input",multiple:true,visibility:"hidden"},_texts:{type:"sap.ui.core.InvisibleText",multiple:true,visibility:"hidden"}}}});
i.prototype.onAfterRendering=function(){if(!this._clickAttached){this._attachClickEvent();}};
i.prototype._attachClickEvent=function(){var E=this.getDomRef();E.addEventListener("click",q.proxy(this._clickHandler,this),false);this._clickAttached=true;};
i.prototype._clickHandler=function(E){var k=this.getAggregation("_inputs"),A=this._getActiveInput();if(A===-1){A=this._lastActiveInput;}!document.activeElement.classList.contains("sapMSegBBtn")&&k&&k[A]&&k[A].focus();};
i.prototype.onkeydown=function(E){var k=E.which||E.keyCode,m=E.key,p,n=this.getAggregation("_inputs"),A=this._getActiveInput(),s=A>-1&&n[A]?n[A].getId().slice(-1):"",N=["0","1","2","3","4","5","6","7","8","9"],v,B="",o,r=false,t,u;if(m===":"){E.preventDefault();this._kbdBuffer="";this._resetCooldown(true);this._switchNextInput(true);}else if(k===K.ENTER){p=this.getParent().getParent();p&&p._handleNumericOkPress();}else if(k===K.P||k===K.A){E.preventDefault();u=this._getFormatButton();u&&u.setSelectedKey(k===K.P?"pm":"am");}else if((k===K.ARROW_UP||k===K.ARROW_DOWN)&&!E.altKey&&!E.metaKey){E.preventDefault();t=this._getActiveInputObject();t&&t.getEnabled()&&this._keyboardUpdateInput(t,k===K.ARROW_UP?1:-1);if(s==="H"){this._handleHoursChange(t.getValue());}}else if(s!==""&&N.indexOf(m)!==-1){E.preventDefault();B=this._kbdBuffer+m;o=parseInt(B);this._resetCooldown(true);if(o>this._inputsProperties[s].max){v=this._formatNumberToString(parseInt(this._kbdBuffer),this._inputsProperties[s].prependZero,this._inputsProperties[s].max,"");n[A].setValue(v);this._handleHoursChange(v);this._inputsProperties[s].value=v;setTimeout(function(){this._switchNextInput();this._kbdBuffer=m;A=this._getActiveInput();s=n[A].getId().slice(-1);v=this._formatNumberToString(parseInt(m),this._inputsProperties[s].prependZero,this._inputsProperties[s].max,"");n[A].setValue(v);this._inputsProperties[s].value=v;this._resetCooldown(true);}.bind(this),0);}else{this._kbdBuffer=B;v=this._formatNumberToString(parseInt(this._kbdBuffer),this._inputsProperties[s].prependZero,this._inputsProperties[s].max,"");n[A].setValue(v);this._inputsProperties[s].value=v;if(this._kbdBuffer.length===2||parseInt(this._kbdBuffer+"0")>this._inputsProperties[s].max){this._resetCooldown(this._kbdBuffer.length===2?false:true);if(s==="H"){r=this._handleHoursChange(this._kbdBuffer);}this._kbdBuffer="";if(!r||s!=="H"){setTimeout(function(){this._switchNextInput();}.bind(this),0);}}}}else if(k!==K.ARROW_LEFT&&k!==K.ARROW_RIGHT&&k!==K.BACKSPACE&&k!==K.DELETE&&k!==K.TAB){E.preventDefault();}};
i.prototype._keyboardUpdateInput=function(o,D){var s=parseInt(o.getValue()),A=o.getId().slice(-1),m=this._inputsProperties[A].min,M=this._inputsProperties[A].max,k=this._inputsProperties[A].step;s+=D*k;if(s>M){s=M;}else if(s<m){s=m;}o.setValue(this._formatNumberToString(s,this._inputsProperties[A].prependZero,this._inputsProperties[A].max,""));};
i.prototype._resetCooldown=function(s){if(this._typeCooldownId){clearTimeout(this._typeCooldownId);}if(s){this._startCooldown();}};
i.prototype._startCooldown=function(){this._typeCooldownId=setTimeout(function(){var k=this.getAggregation("_inputs");this._kbdBuffer="";this._typeCooldownId=null;k&&k[this._activeInput]&&k[this._activeInput].getDomRef("inner").select();}.bind(this),h);};
i.prototype.setValue=function(v){var H=this._getHoursInput(),F=this._getValueFormatPattern(),k=F.indexOf("HH"),m=F.indexOf("H"),n=H&&H.getValue()==="24",o=T._isHoursValue24(v,k,m),D;if(n&&this._isFormatSupport24()&&!o){v=T._replaceZeroHoursWith24(v,k,m);}v=this.validateProperty("value",v);this.setProperty("value",v,true);if(v){D=this._parseValue(o?T._replace24HoursWithZero(v,k,m):v);}if(D){this._setTimeValues(D,o);}return this;};
i.prototype._switchNextInput=function(w){var A=this._getActiveInput(),k=this.getAggregation("_inputs"),m=k.length,s=A;if(!k){return;}do{A++;if(A>=k.length){A=w?0:m-1;}}while(!k[A].getEnabled()&&A!==s&&(w||A<m-1));if(A!==s&&k[A].getEnabled()){this._switchInput(A);}};
i.prototype.getTimeValues=function(){var H=this._getHoursInput(),m=this._getMinutesInput(),s=this._getSecondsInput(),F=this._getFormatButton(),k=null,A=null,D=new Date();if(H){k=parseInt(H.getValue());}if(F){A=F.getSelectedKey();}if(A==="am"&&k===12){k=0;}else if(A==="pm"&&k!==12){k+=12;}if(k!==null){D.setHours(k.toString());}if(m){D.setMinutes(m.getValue());}if(s){D.setSeconds(s.getValue());}return D;};
i.prototype._getActiveInput=function(){return this._activeInput;};
i.prototype._getActiveInputObject=function(){var A=this._getActiveInput(),k=this.getAggregation("_inputs");return k&&k[A]?k[A]:null;};
i.prototype._setTimeValues=function(D,H){var o=this._getHoursInput(),m=this._getMinutesInput(),s=this._getSecondsInput(),F=this._getFormatButton(),v=this.getValueFormat(),k,A=null;D=D||new Date();if(Object.prototype.toString.call(D)!=="[object Date]"||isNaN(D)){throw new Error("Date must be a JavaScript date object; "+this);}if(!H){var V=this._formatValue(D,true);this.setProperty("value",V,true);k=D.getHours();}else{k=24;}if((v.indexOf("a")!==-1||v==="")&&F){A=k>=12?"pm":"am";k=(k>12)?k-12:k;k=(k===0?12:k);}o&&o.setValue(this._formatNumberToString(k,this._inputsProperties.H.prependZero,this._inputsProperties.H.max,""));m&&m.setValue(this._formatNumberToString(D.getMinutes(),this._inputsProperties.M.prependZero,this._inputsProperties.M.max,""));s&&s.setValue(this._formatNumberToString(D.getSeconds(),this._inputsProperties.S.prependZero,this._inputsProperties.S.max,""));F&&F.setSelectedKey(A);if(H){m&&m.setValue("00").setEnabled(false);s&&s.setValue("00").setEnabled(false);}else{m&&m.setEnabled(true);s&&s.setEnabled(true);}if(o){this._inputsProperties.H.value=k;}if(m){this._inputsProperties.M.value=m.getValue();}if(s){this._inputsProperties.S.value=s.getValue();}};
i.prototype._getHoursInput=function(){var o=this.getAggregation("_inputs");return o&&this._inputIndexes&&o[this._inputIndexes.H]?o[this._inputIndexes.H]:null;};
i.prototype._getMinutesInput=function(){var o=this.getAggregation("_inputs");return o&&this._inputIndexes&&o[this._inputIndexes.M]?o[this._inputIndexes.M]:null;};
i.prototype._getSecondsInput=function(){var o=this.getAggregation("_inputs");return o&&this._inputIndexes&&o[this._inputIndexes.S]?o[this._inputIndexes.S]:null;};
i.prototype._destroyControls=function(){this.destroyAggregation("_inputs");this.destroyAggregation("_buttonAmPm");};
i.prototype._createControls=function(){var F=this._getDisplayFormatPattern(),s=this.getId(),k=this._isFormatSupport24(),m=this.getSupport2400(),n=0,o=0,p=0,r="",t=this.getAggregation("_texts"),M=0,u,v,w=0,H,P=false,x,y,z,V,D;this._inputIndexes={};this._inputsProperties={};if(F===undefined){return;}x=F.indexOf("HH");y=F.indexOf("H");if(!t){this.addAggregation("_texts",new d(s+"-textH",{text:this._oResourceBundle.getText("TIMEPICKER_INPUTS_ENTER_HOURS")}).toStatic());this.addAggregation("_texts",new d(s+"-textM",{text:this._oResourceBundle.getText("TIMEPICKER_INPUTS_ENTER_MINUTES")}).toStatic());this.addAggregation("_texts",new d(s+"-textS",{text:this._oResourceBundle.getText("TIMEPICKER_INPUTS_ENTER_SECONDS")}).toStatic());}if(x!==-1){H=true;P=true;u=(m)?24:23;}else if(y!==-1){H=true;u=(m)?24:23;}else if(F.indexOf("hh")!==-1){H=true;P=true;M=1;u=12;}else if(F.indexOf("h")!==-1){H=true;M=1;u=12;}if(H){this.addAggregation("_inputs",new j(s+"-inputH",{type:f.Number,tooltip:this._oResourceBundle.getText("TIMEPICKER_INPUTS_ENTER_HOURS"),textAlign:g.Center,width:"2.875rem",value:n,ariaLabelledBy:s+"-textH"}));this._inputsProperties.H={min:M,max:u,prependZero:P,step:1,value:n,format24:k};this._inputIndexes.H=w++;}if(F.indexOf("m")!==-1){P=F.indexOf("mm")!==-1;u=59;this.addAggregation("_inputs",new j(s+"-inputM",{type:f.Number,tooltip:this._oResourceBundle.getText("TIMEPICKER_INPUTS_ENTER_MINUTES"),textAlign:g.Center,width:"2.875rem",value:o,ariaLabelledBy:s+"-textM"}));this._inputsProperties.M={min:0,max:u,prependZero:P,step:this.getMinutesStep(),value:o};this._inputIndexes.M=w++;}if(F.indexOf("s")!==-1){P=F.indexOf("ss")!==-1;u=59;this.addAggregation("_inputs",new j(s+"-inputS",{type:f.Number,tooltip:this._oResourceBundle.getText("TIMEPICKER_INPUTS_ENTER_SECONDS"),textAlign:g.Center,width:"2.875rem",value:p,ariaLabelledBy:s+"-textS"}));this._inputsProperties.S={min:0,max:u,prependZero:P,step:this.getSecondsStep(),value:p};this._inputIndexes.S=w++;}if(F.indexOf("a")!==-1){this.setAggregation("_buttonAmPm",new S(s+"-format",{items:[new b({text:this._sAM,key:"am"}),new b({text:this._sPM,key:"pm"})],selectedKey:r,tooltip:this._oResourceBundle.getText("TIMEPICKER_AMPM_BUTTON_TOOLTIP")}));}if(!this.getAggregation("_nowButton")){this.setAggregation("_nowButton",this._getCurrentTimeButton());}v=this.getAggregation("_inputs");this._inputCount=v.length;this._switchInput(0);for(w=0;w<this._inputCount;w++){this._attachEvents(v[w]);}V=this.getValue();if(V){z=T._isHoursValue24(V,x,y);D=this._parseValue(z?T._replace24HoursWithZero(V,x,y):V);if(D){this._setTimeValues(D,z);}}};
i.prototype._attachEvents=function(o){o.onfocusin=function(E){var s=E.currentTarget.id.slice(-1),k=this.getAggregation("_inputs");this._activeInput=this._inputIndexes[s];k[this._activeInput].addStyleClass("sapMFocus");k[this._activeInput].getDomRef("inner").select();}.bind(this);o.onfocusout=function(E){var s=E.currentTarget.id.slice(-1),k=this.getAggregation("_inputs");if(this._inputsProperties[s].value===""){this._inputsProperties[s].value="00";k[this._activeInput].setValue("00");}else if(s!=="H"){k[this._activeInput].setValue(k[this._activeInput].getValue());}if(s==="H"&&!this._inputsProperties[s].format24&&parseInt(this._inputsProperties[s].value)===0){this._inputsProperties[s].value="12";k[this._activeInput].setValue("12");}k[this._activeInput].removeStyleClass("sapMFocus");this._lastActiveInput=this._activeInput;this._activeInput=-1;}.bind(this);o.attachLiveChange(function(E){var A=E.getParameter("id").slice(-1),v=E.getParameter("value");if(v!==this._inputsProperties[A].value.toString()){this._inputsProperties[A].value=v;this._kbdBuffer=v;}}.bind(this));};
i.prototype._switchInput=function(k){var m=this.getAggregation("_inputs");if(k>=this._inputCount){k=0;}m[k].focus();this._activeInput=k;};
i.prototype._handleHoursChange=function(v){var m=this._getMinutesInput(),s=this._getSecondsInput();if(!this.getSupport2400()){return;}if(v==="24"){if(m&&m.getEnabled()){this._sMinutes=m.getValue();m.setEnabled(false).setValue("00");}if(s&&s.getEnabled()){this._sSeconds=s.getValue();s.setEnabled(false).setValue("00");}this._getHoursInput().focus();return true;}else{if(m&&!m.getEnabled()){m.setEnabled(true).setValue(this._sMinutes);}if(s&&!s.getEnabled()){s.setEnabled(true).setValue(this._sSeconds);}this._getHoursInput().focus();return false;}};
var C=R.extend(a);C.apiVersion=2;
C.writeInnerAttributes=function(r,o){a.writeInnerAttributes.call(this,r,o);r.attr("pattern","[0-9]*");r.attr("inputmode","numeric");};
var j=I.extend("sap.m.internal.CustomNumericInput",{renderer:C});
return i;});
sap.ui.predefine('sap/m/TimePickerInputsRenderer',["sap/ui/Device"],function(D){"use strict";var T={apiVersion:2};
T.render=function(r,c){var C=c.getAggregation("_inputs"),s=c.getAggregation("_buttonAmPm"),S=c._getTimeSeparators(c._getDisplayFormatPattern()),a,i;if(C){if(s){C.push(s);}r.openStart("div",c);r.class("sapMTPInputsContainer");r.attr("role","application");r.attr("aria-roledescription",c._getAriaRoleDescription());r.openEnd();for(i=0;i<C.length;i++){r.renderControl(C[i]);if(i<C.length-1){a=S.shift();if(!a){a=" ";}r.openStart("span");r.attr("aria-hidden","true");r.openEnd();r.text(a);r.close("span");}}r.renderControl(c._getCurrentTimeButton());r.close("div");}};
return T;},true);
sap.ui.predefine('sap/m/TimePickerInternals',["sap/ui/core/library","sap/ui/core/Control","sap/ui/model/type/Date","sap/ui/model/odata/type/ODataType","sap/ui/core/format/DateFormat","sap/ui/core/LocaleData","sap/ui/core/Locale","./library","./Button",'./TimePickerInternalsRenderer'],function(c,C,S,O,D,L,a,l,B,T){"use strict";var b=1,d=l.ButtonType,e=c.CalendarType;
var f=C.extend("sap.m.TimePickerInternals",{metadata:{library:"sap.m",properties:{localeId:{type:"string",group:"Data"},displayFormat:{name:"displayFormat",type:"string",group:"Appearance"},minutesStep:{type:"int",group:"Misc",defaultValue:b},secondsStep:{type:"int",group:"Misc",defaultValue:b},value:{type:"string",group:"Data",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},support2400:{type:"boolean",group:"Misc",defaultValue:false},showCurrentTimeButton:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{_buttonAmPm:{type:"sap.m.SegmentedButton",multiple:false,visibility:"hidden"},_nowButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}}}});
f.prototype.init=function(){var o=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),g=L.getInstance(o),p=g.getDayPeriods("abbreviated"),h=g.getTimePattern("medium");this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sAM=p[0];this._sPM=p[1];this._kbdBuffer="";this.setDisplayFormat(h);this._setTimeValues();this._sMinutes;this._sSeconds;this._clickAttached;this._setAriaLabel(this._oResourceBundle.getText("TIMEPICKER_CLOCK_DIAL_LABEL"));this._setAriaRoleDescription(this._oResourceBundle.getText("TIMEPICKER_INPUTS_ROLE_DESCRIPTION"));};
f.prototype.exit=function(){this._destroyControls();this.destroyAggregation("_texts");if(this._oNowButton){this._oNowButton.destroy();this._oNowButton=null;}};
f.prototype.setDisplayFormat=function(F){this.setProperty("displayFormat",F,true);this._destroyControls();this._createControls();return this;};
f.prototype.setLocaleId=function(g){var o,p;g=this.validateProperty("localeId",g);this.setProperty("localeId",g,true);if(g){o=new a(g);p=L.getInstance(o).getDayPeriods("abbreviated");this._sAM=p[0];this._sPM=p[1];this._destroyControls();this._createControls();}return this;};
f.prototype.setSupport2400=function(g){this.setProperty("support2400",g,true);this._destroyControls();this._createControls();return this;};
f.prototype.setMinutesStep=function(v){this.setProperty("minutesStep",v,true);this._destroyControls();this._createControls();return this;};
f.prototype.setSecondsStep=function(v){this.setProperty("secondsStep",v,true);this._destroyControls();this._createControls();return this;};
f.prototype.setShowCurrentTimeButton=function(g){this._getCurrentTimeButton().setVisible(g);return this.setProperty("showCurrentTimeButton",g);};
f.prototype._destroyControls=function(){};
f.prototype._createControls=function(){};
f.prototype._setTimeValues=function(o,h){};
f.prototype._checkStyle=function(p){return(p==="short"||p==="medium"||p==="long"||p==="full");};
f.prototype._getDisplayFormatPattern=function(){var p=this.getDisplayFormat();if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}return p;};
f.prototype._getValueFormatPattern=function(){var p=this._getBoundValueTypePattern()||this.getValueFormat()||"medium";if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}return p;};
f.prototype._getLocaleBasedPattern=function(p){return L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getTimePattern(p);};
f.prototype._getFormatButton=function(){return this.getAggregation("_buttonAmPm");};
f.prototype._parseValue=function(v){return this._getFormatter().parse(v);};
f.prototype._getFormatter=function(){var p=this._getBoundValueTypePattern(),r=false,o=this.getBinding("value"),g;if(o&&o.oType&&o.oType.oOutputFormat){r=!!o.oType.oOutputFormat.oFormatOptions.relative;g=o.oType.oOutputFormat.oFormatOptions.calendarType;}if(!p){p=this.getValueFormat()||"medium";g=e.Gregorian;}if(!g){g=sap.ui.getCore().getConfiguration().getCalendarType();}return this._getFormatterInstance(p,r,g);};
f.prototype._getBoundValueTypePattern=function(){var o=this.getBinding("value"),g=o&&o.getType&&o.getType();if(g instanceof S){return g.getOutputPattern();}if(g instanceof O&&g.oFormat){return g.oFormat.oFormatOptions.pattern;}return undefined;};
f.prototype._getFormatterInstance=function(p,r,g,h){var F;if(this._checkStyle(p)){F=this._getFormatInstance({style:p,strictParsing:true,relative:r,calendarType:g});}else{F=this._getFormatInstance({pattern:p,strictParsing:true,relative:r,calendarType:g});}return F;};
f.prototype._getFormatInstance=function(A,g){return D.getTimeInstance(A);};
f.prototype._formatValue=function(o){if(o){return this._getFormatter().format(o);}return"";};
f.prototype._getTimeSeparators=function(g){var F=sap.ui.core.format.DateFormat.getInstance({pattern:g}).aFormatArray,h=[],p,i;for(i=0;i<F.length;i++){if(F[i].type!=="text"){if(p){h.push("");}else{p=true;}}else{h.push(F[i].value);p=false;}}return h;};
f.prototype._isFormatSupport24=function(){var F=this._getDisplayFormatPattern();return F.indexOf("HH")!==-1||F.indexOf("H")!==-1;};
f.prototype._formatNumberToString=function(n,p,m,r){var N;if(p&&n<10){N="0"+n;}else if(n===m&&r!==""){N=r;}else{N=n.toString();}return N;};
f.prototype._setAriaLabel=function(A){this._sAriaLabel=A;return this;};
f.prototype._getAriaLabel=function(){return this._sAriaLabel;};
f.prototype._setAriaRoleDescription=function(A){this._sAriaRoleDescription=A;return this;};
f.prototype._getAriaRoleDescription=function(){return this._sAriaRoleDescription;};
f._replaceZeroHoursWith24=function(v,i,I){var h=2,g=i;if(i===-1){h=1;g=I;}return v.substr(0,g)+"24"+v.substr(g+h);};
f._replace24HoursWithZero=function(v,i,I){var h=2,g=i;if(i===-1){h=1;g=I;}return v.substr(0,g)+s(0,h)+v.substr(g+2);};
f._isHoursValue24=function(v,i,I){if(i===-1&&I===-1){return false;}var g=i;if(i===-1){g=I;}return v.substr(g,2)==="24";};
f.prototype._getCurrentTimeButton=function(){if(!this._oNowButton){this._oNowButton=new B(this.getId()+"-now",{icon:"sap-icon://present",tooltip:this._oResourceBundle.getText("TIMEPICKER_TOOLTIP_NOW"),type:d.Transparent,visible:false,press:function(){this._setTimeValues(new Date());}.bind(this)}).addStyleClass("sapMTPNow");}return this._oNowButton;};
function s(g,h){var r="";for(var i=0;i<h;i++){r+=g;}return r;}
return f;});
sap.ui.predefine('sap/m/TimePickerInternalsRenderer',[],function(){"use strict";var T={apiVersion:2};return T;},true);
sap.ui.predefine('sap/m/TimePickerRenderer',['sap/ui/core/Renderer','./InputBaseRenderer','sap/ui/core/library'],function(R,I,c){"use strict";var T=R.extend(I);T.apiVersion=2;T.CSS_CLASS="sapMTimePicker";
T.addOuterClasses=function(r,C){r.class(T.CSS_CLASS);if(C.getHideInput()){r.class("sapMTimePickerHiddenInput");}I.addOuterClasses.apply(this,arguments);};
T.writeInnerValue=function(r,C){r.attr("value",C._formatValue(C.getDateValue()));};
T.getAriaRole=function(){return"combobox";};
T.getLabelledByAnnouncement=function(C){return C._getPlaceholder()||"";};
T.getAccessibilityState=function(C){var a=I.getAccessibilityState.apply(this,arguments);a["roledescription"]=C._oResourceBundle.getText("ACC_CTR_TYPE_TIMEINPUT");a["autocomplete"]="none";a["haspopup"]=c.aria.HasPopup.Dialog.toLowerCase();a["expanded"]="false";a["disabled"]=null;a["owns"]=C.getId()+"-clocks";if(C._isMobileDevice()){a["describedby"]=C._oResourceBundle.getText("ACC_CTR_TYPE_TIMEINPUT_MOBILE_DESCRIBEDBY");}return a;};
T.writeInnerAttributes=function(r,C){if(C._isMobileDevice()){r.attr("readonly","readonly");}if(C.getShowValueStateMessage()){r.attr("autocomplete","off");}};
return T;},true);
sap.ui.predefine('sap/m/TimePickerSlider',['sap/ui/core/Control','./TimePickerSliderRenderer','sap/ui/core/IconPool','sap/ui/Device',"sap/ui/events/KeyCodes","sap/m/Button","sap/ui/thirdparty/jquery"],function(C,T,I,D,K,B,q){"use strict";
var a=C.extend("sap.m.TimePickerSlider",{
metadata:{library:"sap.m",properties:{selectedValue:{type:"string",defaultValue:null},isCyclic:{type:"boolean",defaultValue:true},label:{type:"string",defaultValue:null},isExpanded:{type:"boolean",defaultValue:false}},aggregations:{items:{type:"sap.m.VisibleItem",multiple:true,singularName:"item"},_arrowUp:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_arrowDown:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{expanded:{},collapsed:{}}},
renderer:T
});
var S=sap.ui.getCore().getConfiguration().getAnimation()?200:0;var M=50;var L=32;var A=32;
a.prototype.init=function(){this._bIsDrag=null;this._selectionOffset=0;this._mousedown=false;this._dragSession=null;this._iSelectedItemIndex=-1;this._animatingSnap=false;this._iSelectedIndex=-1;this._animating=false;this._intervalId=null;this._maxScrollTop=null;this._minScrollTop=null;this._marginTop=null;this._marginBottom=null;this._bOneTimeValueSelectionAnimation=false;this._bEnabled=true;if(D.system.desktop){this._fnHandleTypeValues=t.call(this);}this._initArrows();};
a.prototype.exit=function(){this._detachEvents();var s=this._getSliderContainerDomRef();if(s){s.stop();}if(this._intervalId){clearInterval(this._intervalId);this._intervalId=null;}};
a.prototype.onBeforeRendering=function(){this._detachEvents();};
a.prototype.onAfterRendering=function(){if(D.system.phone){setTimeout(this._afterExpandCollapse.bind(this),0);}else{this._afterExpandCollapse();}this._attachEvents();};
a.prototype.onThemeChanged=function(e){this.invalidate();};
a.prototype.fireTap=function(e){var s,i,d;if(!this.getIsExpanded()){if(D.system.desktop){this.focus();}else{this.setIsExpanded(true);}}else{s=e.srcElement||e.originalTarget;if(s&&s.tagName.toLowerCase()==="li"){i=q(s).text();d=F.call(this,i);this._iClickedIndex=Array.prototype.slice.call(s.parentElement.children).indexOf(s);this._bOneTimeValueSelectionAnimation=true;this.setSelectedValue(d);this._fireSelectedValueChange(d);}else{this._addSelectionStyle();this.focus();}}};
a.prototype.setSelectedValue=function(v){var i=f(this._getVisibleItems(),function(E){return E.getKey()===v;}),d=this,e,s,g,h;if(i===-1){return this;}if(this.getDomRef()){s=this._getSliderContainerDomRef();g=this._getItemHeightInPx();h=this._getContentRepeat();if(i*g>=this._selectionOffset){e=this._getVisibleItems().length*Math.floor(h/2)+i;}else{e=this._getVisibleItems().length*Math.ceil(h/2)+i;}if(this._bOneTimeValueSelectionAnimation){s.scrollTop((e-this._iClickedIndex+this._iSelectedItemIndex)*g-this._selectionOffset);this._animatingSnap=true;s.animate({scrollTop:e*g-this._selectionOffset},S,'linear',function(){s.clearQueue();d._animatingSnap=false;d._bOneTimeValueSelectionAnimation=false;});}else{s.scrollTop(e*g-this._selectionOffset);}this._removeSelectionStyle();this._iSelectedItemIndex=e;this._addSelectionStyle();}return this.setProperty("selectedValue",v,true);};
a.prototype.setIsExpanded=function(v,s){this.setProperty("isExpanded",v,true);if(!this.getDomRef()){return this;}var $=this.$();if(v){$.addClass("sapMTPSliderExpanded");if(D.system.phone){setTimeout(function(){this._updateDynamicLayout(v);if(!s){this.fireExpanded({ctrl:this});}}.bind(this),0);}else{this._updateDynamicLayout(v);if(!s){this.fireExpanded({ctrl:this});}}}else{this._stopAnimation();if(this._animatingSnap===true){this._animatingSnap=false;this._getSliderContainerDomRef().stop(true);if(this._animatingTargetIndex!==null&&this._animatingTargetIndex!==undefined){this._scrollerSnapped(this._animatingTargetIndex);this._animatingTargetIndex=null;}else if(this._iSelectedIndex!==-1){this._scrollerSnapped(this._iSelectedIndex);}}$.removeClass("sapMTPSliderExpanded");this._updateMargins(v);if(D.system.phone){setTimeout(this._afterExpandCollapse.bind(this),0);}else{this._afterExpandCollapse();}if(!s){this.fireCollapsed({ctrl:this});}}return this;};
a.prototype.onfocusin=function(e){if(D.system.desktop&&!this.getIsExpanded()){this.setIsExpanded(true);}};
a.prototype.onfocusout=function(e){var s=e.relatedTarget?e.relatedTarget.id:null,d=[this.getAggregation("_arrowUp").getId(),this.getAggregation("_arrowDown").getId()];if(s&&d.indexOf(s)!==-1){return;}if(D.system.desktop&&this.getIsExpanded()){this.setIsExpanded(false);}};
a.prototype._onmousewheel=function(e){var O,d,w;e.preventDefault();e.stopPropagation();if(!this.getIsExpanded()||this._intervalId){return false;}O=e.originalEvent;d=O.detail?(-O.detail>0):(O.wheelDelta>0);w=O.detail?(-O.detail/3):(O.wheelDelta/120);if(!w){return false;}this._handleWheelScroll(d,w);};
a.prototype._handleWheelScroll=function(d,w){var r=d?Math.ceil:Math.floor,R;if(!this._aWheelDeltas){this._aWheelDeltas=[];}this._aWheelDeltas.push(w);if(!this._bWheelScrolling){this._bWheelScrolling=true;this._intervalId=setInterval(function(){if(!this._aWheelDeltas.length){clearInterval(this._intervalId);this._intervalId=null;this._bWheelScrolling=false;}else{R=this._aWheelDeltas[0];this._aWheelDeltas=[];R=r(R);if(R){this._offsetSlider(R);}}}.bind(this),150);}return false;};
a.prototype.onsappageup=function(e){if(this.getIsExpanded()){var i=this._getVisibleItems()[0],v=i.getKey();this.setSelectedValue(v);this._fireSelectedValueChange(v);}};
a.prototype.onsappagedown=function(e){if(this.getIsExpanded()){var l=this._getVisibleItems()[this._getVisibleItems().length-1],v=l.getKey();this.setSelectedValue(v);this._fireSelectedValueChange(v);}};
a.prototype.onsapup=function(e){if(this.getIsExpanded()){this._offsetValue(-1);}};
a.prototype.onsapdown=function(e){if(this.getIsExpanded()){this._offsetValue(1);}};
a.prototype.onkeydown=function(e){var k=e.which||e.keyCode,d=K;if(k>=d.NUMPAD_0&&k<=d.NUMPAD_9){k=this._convertNumPadToNumKeyCode(k);}if((k>=d.A&&k<=d.Z)||(k>=d.DIGIT_0&&k<=d.DIGIT_9)){this._fnHandleTypeValues(e.timeStamp,k);}};
a.prototype._getSliderContainerDomRef=function(){return this.$().find(".sapMTimePickerSlider");};
a.prototype._getContentRepeat=function(){var i;if(this.getIsCyclic()){i=Math.ceil(M/this._getVisibleItems().length);i=Math.max(i,3);}else{i=1;}return i;};
a.prototype._getItemHeightInPx=function(){return this.$("content").find("li:not(.TPSliderItemHidden)")[0].getBoundingClientRect().height;};
a.prototype._updateSelectionFrameLayout=function(){var $,i,d,e,s=this.$().offset(),g=s?s.top:0,h=this.$().parents(".sapMTimePickerContainer").offset(),j=h?h.top:0;if(this.getDomRef()){e=this._getItemHeightInPx();$=this.$().find(".sapMTPPickerSelectionFrame");d=g-j;i=(this.$().height()-e+L)/2+d;$.css("top",i);if(D.system.phone){setTimeout(this._afterExpandCollapse.bind(this),0);}else{this._afterExpandCollapse();}}};
a.prototype._updateStepAndValue=function(n,s){var v=0,$,i;for(i=0;i<this.getItems().length;i++){if(i%s!==0&&i!==n){this.getItems()[i].setVisible(false);}else{this.getItems()[i].setVisible(true);v++;}}if(v>2&&v<13&&this.getDomRef()){$=this.$().find(".sapMTimePickerSlider");$.className="";q($).addClass("sapMTimePickerSlider SliderValues"+v.toString());}this.setIsCyclic(v>2);this.setSelectedValue(n.toString());};
a.prototype._updateMargins=function(i){var d=this._getItemHeightInPx(),$,v,V,e,g,h,m,j;if(this.getDomRef()){d=this._getItemHeightInPx();$=this.$().find(".SliderValues3,.SliderValues4,.SliderValues5,.SliderValues6,.SliderValues7,.SliderValues8,.SliderValues9,.SliderValues10,.SliderValues11,.SliderValues12");if(!$.length){return;}if(i){v=this._getVisibleItems().length;V=d*Math.floor(v/2);e=d*Math.ceil(v/2);h=this.$().parents().hasClass('sapUiSizeCompact')?A:0;g=(this.$().height()-d+L)/2;m=g-V-L-h;j=this.$().height()-g-e-h;m=Math.max(m,0);j=Math.max(j,0);}else{m=0;j=0;}$.css("margin-top",m);$.css("margin-bottom",j);}};
a.prototype._updateDynamicLayout=function(i){this._updateMargins(i);this._updateSelectionFrameLayout();};
a.prototype._getSelectionFrameTopOffset=function(){var $=this._getSliderContainerDomRef().find(".sapMTPPickerSelectionFrame"),d=$.offset();return d.top;};
a.prototype._animateScroll=function(s){var $=this._getSliderContainerDomRef(),p=$.scrollTop(),d=25,e=$.height(),g=this.$("content").height(),i=200,h=e+i,j=this._getContentRepeat(),k=this.getIsCyclic(),l=0.9,m=0.05,n=this;this._intervalId=setInterval(function(){n._animating=true;p=p-s*d;if(k){p=n._getUpdatedCycleScrollTop(e,g,p,h,j);}else{if(p>n._maxScrollTop){p=n._maxScrollTop;s=0;}if(p<n._minScrollTop){p=n._minScrollTop;s=0;}}$.scrollTop(p);s*=l;if(Math.abs(s)<m){var r=n._getItemHeightInPx();var O=n._selectionOffset?(n._selectionOffset%r):0;var u=Math.round((p+O)/r)*r-O;clearInterval(n._intervalId);n._intervalId=null;n._animating=null;n._iSelectedIndex=Math.round((p+n._selectionOffset)/r);n._animatingSnap=true;$.animate({scrollTop:u},S,'linear',function(){$.clearQueue();n._animatingSnap=false;if($.css("visibility")==="visible"){n._scrollerSnapped(n._iSelectedIndex);}});}},d);};
a.prototype._stopAnimation=function(){if(this._animating){clearInterval(this._intervalId);this._intervalId=null;this._animating=null;}};
a.prototype._startDrag=function(p){if(!this._dragSession){this._dragSession={};this._dragSession.positions=[];}this._dragSession.pageY=p;this._dragSession.startTop=this._getSliderContainerDomRef().scrollTop();};
a.prototype._doDrag=function(p,d){if(this._dragSession){this._dragSession.offsetY=p-this._dragSession.pageY;this._dragSession.positions.push({pageY:p,timeStamp:d});if(this._dragSession.positions.length>20){this._dragSession.positions.splice(0,10);}if(this._bIsDrag){this._getSliderContainerDomRef().scrollTop(this._dragSession.startTop-this._dragSession.offsetY);}}};
a.prototype._endDrag=function(p,d){if(this._dragSession){var O,e;for(var i=this._dragSession.positions.length-1;i>=0;i--){O=d-this._dragSession.positions[i].timeStamp;e=p-this._dragSession.positions[i].pageY;if(O>100){break;}}var s=(e/O);if(this._animating){clearInterval(this._intervalId);this._intervalId=null;this._animating=null;}this._dragSession=null;this._animateScroll(s);}};
a.prototype._afterExpandCollapse=function(){var s=this.getSelectedValue(),d=this._getSelectionFrameTopOffset(),$=this._getSliderContainerDomRef(),e=$.offset(),i,l,g,h;this._selectionOffset=d-e.top;if(!this.getIsCyclic()){l=this.$("content");h=this._getItemHeightInPx();g=this.$().height();if(this.getIsExpanded()){this._minScrollTop=0;this._marginTop=d-e.top;this._maxScrollTop=h*(this._getVisibleItems().length-1);i=$.height();this._marginBottom=i-this._marginTop-h;if(this._marginBottom<0){this._marginBottom=g-this._marginTop-h;}l.css("margin-top",this._marginTop);l.css("margin-bottom",this._marginBottom);}else{this._marginBottom=g-h;l.css("margin-top",0);l.css("margin-bottom",this._marginBottom);}this._selectionOffset=0;}if(!this.getIsExpanded()){this._selectionOffset=0;}this.$().attr('aria-expanded',this.getIsExpanded());this.setSelectedValue(s);};
a.prototype._getUpdatedCycleScrollTop=function(i,d,e,g,h){var j=d-e-i;while(j<g){e=e-d/h;j=d-e-i;}while(e<g){e=e+d/h;}return e;};
a.prototype._scrollerSnapped=function(i){var s=i,d=this._getVisibleItems().length,n;while(s>=d){s=s-d;}if(!this.getIsCyclic()){s=i;}n=this._getVisibleItems()[s].getKey();this.setSelectedValue(n);this._fireSelectedValueChange(n);};
a.prototype._updateScroll=function(){var s=this.getSelectedValue();if(s!==this._getVisibleItems()[0].getKey()&&this._getSliderContainerDomRef().scrollTop()+(this._selectionOffset?this._selectionOffset:0)===0){this.setSelectedValue(s);this._fireSelectedValueChange(s);}};
a.prototype._addSelectionStyle=function(){var $=this.$("content").find("li:not(.TPSliderItemHidden)"),s=$.eq(this._iSelectedItemIndex).text(),d,e;if(!s){return;}e=s;if(e&&e.length>1&&e.indexOf('0')===0){e=e.substring(1);}$.eq(this._iSelectedItemIndex).addClass("sapMTimePickerItemSelected");d=this.getDomRef("valDescription");if(d.innerHTML!==e){d.innerHTML=e;}};
a.prototype._removeSelectionStyle=function(){var $=this.$("content").find("li:not(.TPSliderItemHidden)");$.eq(this._iSelectedItemIndex).removeClass("sapMTimePickerItemSelected");};
a.prototype._attachEvents=function(){var e=this._getSliderContainerDomRef()[0];if(D.system.combi){e.addEventListener("touchstart",q.proxy(o,this),false);e.addEventListener("touchmove",q.proxy(b,this),false);document.addEventListener("touchend",q.proxy(c,this),false);e.addEventListener("mousedown",q.proxy(o,this),false);document.addEventListener("mousemove",q.proxy(b,this),false);document.addEventListener("mouseup",q.proxy(c,this),false);}else{if(D.system.phone||D.system.tablet){e.addEventListener("touchstart",q.proxy(o,this),false);e.addEventListener("touchmove",q.proxy(b,this),false);document.addEventListener("touchend",q.proxy(c,this),false);}else{e.addEventListener("mousedown",q.proxy(o,this),false);document.addEventListener("mousemove",q.proxy(b,this),false);document.addEventListener("mouseup",q.proxy(c,this),false);}}};
a.prototype._detachEvents=function(){var e=this._getSliderContainerDomRef()[0];if(e==null){return;}if(D.system.combi){e.removeEventListener("touchstart",q.proxy(o,this),false);e.removeEventListener("touchmove",q.proxy(b,this),false);document.removeEventListener("touchend",q.proxy(c,this),false);e.removeEventListener("mousedown",q.proxy(o,this),false);document.removeEventListener("mousemove",q.proxy(b,this),false);document.removeEventListener("mouseup",q.proxy(c,this),false);}else{if(D.system.phone||D.system.tablet){e.removeEventListener("touchstart",q.proxy(o,this),false);e.removeEventListener("touchmove",q.proxy(b,this),false);document.removeEventListener("touchend",q.proxy(c,this),false);}else{e.removeEventListener("mousedown",q.proxy(o,this),false);document.removeEventListener("mousemove",q.proxy(b,this),false);document.removeEventListener("mouseup",q.proxy(c,this),false);}}};
a.prototype._offsetValue=function(i){var s=this._getSliderContainerDomRef(),d,e=this._getItemHeightInPx(),g,h,j=this.getIsCyclic(),k=this;this._stopAnimation();if(this._animatingSnap===true){this._animatingSnap=false;this._getSliderContainerDomRef().stop(true);if(this._animatingTargetIndex!==null){this._scrollerSnapped(this._animatingTargetIndex);this._animatingTargetIndex=null;}else if(this._iSelectedIndex!==-1){this._scrollerSnapped(this._iSelectedIndex);}}h=this._iSelectedItemIndex+i;d=s.scrollTop();g=d+i*e;if(!j){if(h<0||h>=this._getVisibleItems().length){return;}if(g>this._maxScrollTop){g=this._maxScrollTop;}if(g<this._minScrollTop){g=this._minScrollTop;}}this._animatingSnap=true;this._animatingTargetIndex=h;s.animate({scrollTop:g},S,'linear',function(){s.clearQueue();k._animatingSnap=false;k._animatingTargetIndex=null;if(s.css("visibility")==="visible"){k._scrollerSnapped(h);}});};
a.prototype._offsetSlider=function(O){var s=this._getSliderContainerDomRef().scrollTop(),d=this,$=d._getSliderContainerDomRef().height(),e=d.$("content").height(),i=200,g=$+i,h=d._getContentRepeat(),j=d.getIsCyclic(),k=d._getItemHeightInPx();s=s-O*k;if(j){s=d._getUpdatedCycleScrollTop($,e,s,g,h);}else{if(s>d._maxScrollTop){s=d._maxScrollTop;}if(s<d._minScrollTop){s=d._minScrollTop;}}d._getSliderContainerDomRef().scrollTop(s);d._iSelectedIndex=Math.round((s+d._selectionOffset)/k);d._scrollerSnapped(d._iSelectedIndex);};
a.prototype._initArrows=function(){var d=this,e,g,r=sap.ui.getCore().getLibraryResourceBundle("sap.m");e=new B({icon:I.getIconURI("slim-arrow-up"),press:function(E){d._offsetValue(-1);},tooltip:r.getText("TIMEPICKER_TOOLTIP_UP"),type:'Transparent'});e.addEventDelegate({onAfterRendering:function(){e.$().attr("tabindex",-1);}});this.setAggregation("_arrowUp",e);g=new B({icon:I.getIconURI("slim-arrow-down"),press:function(E){d._offsetValue(1);},tooltip:r.getText("TIMEPICKER_TOOLTIP_DOWN"),type:'Transparent'});g.addStyleClass("sapMTimePickerItemArrowDown");g.addEventDelegate({onAfterRendering:function(){g.$().attr("tabindex",-1);}});this.setAggregation("_arrowDown",g);};
a.prototype._convertNumPadToNumKeyCode=function(k){var d=K;if(k>=d.NUMPAD_0&&k<=d.NUMPAD_9){k-=48;}return k;};
function f(d,p){if(d==null){throw new TypeError('findIndex called with null or undefined array');}if(typeof p!=='function'){throw new TypeError('predicate must be a function');}var l=d.length;var e=arguments[1];var v;for(var i=0;i<l;i++){v=d[i];if(p.call(e,v,i,d)){return i;}}return-1;}
var o=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;this._bIsDrag=false;if(!this.getIsExpanded()){return;}this._stopAnimation();this._startDrag(p);if(!D.system.desktop){e.preventDefault();}this._mousedown=true;};var b=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;if(!this._mousedown||!this.getIsExpanded()){return;}if(!this._bIsDrag&&this._dragSession&&this._dragSession.positions.length){var d=this._dragSession.positions.some(function(g){return Math.abs(g.pageY-p)>5;});if(d){this._bIsDrag=true;}}this._doDrag(p,e.timeStamp);this._mousedown=true;};var c=function(e){var p=e.changedTouches&&e.changedTouches.length?e.changedTouches[0].pageY:e.pageY;if(this._bIsDrag===false){this.fireTap(e);this._dragSession=null;}this._bIsDrag=true;if(!this.getIsExpanded()){this._dragSession=null;return;}this._endDrag(p,e.timeStamp);this._mousedown=false;};var F=function(s){var i=this._getVisibleItems();var d=f(i,function(e){return e.getText()===s;});return i[d]?i[d].getKey():'';};var t=function(){var l=-1,i=-1,w=1000,s="",d=function(e,k){var m;if(l+w<e){s="";}else{if(i!==-1){clearTimeout(i);i=-1;}}s+=String.fromCharCode(k).toLowerCase();m=this._getVisibleItems().filter(function(g){return g.getKey().indexOf(s)===0;});if(m.length>1){i=setTimeout(function(){this.setSelectedValue(s);s="";i=-1;}.bind(this),w);}else if(m.length===1){this.setSelectedValue(m[0].getKey());s="";}else{s="";}l=e;};return d;};
a.prototype._getVisibleItems=function(){return this.getItems().filter(function(i){return i.getVisible();});};
a.prototype._setEnabled=function(e){this._bEnabled=e;if(e){this.$().removeClass("sapMTPDisabled");this.$().attr("tabindex",0);}else{this.$().addClass("sapMTPDisabled");this.$().attr("tabindex",-1);}return this;};
a.prototype._getEnabled=function(e){return this._bEnabled;};
a.prototype._fireSelectedValueChange=function(v){this.fireEvent("_selectedValueChange",{value:v});};
return a;});
sap.ui.predefine('sap/m/TimePickerSliderRenderer',[],function(){"use strict";var T={apiVersion:2};
T.render=function(r,c){var i,R,n=c._getContentRepeat(),I=c.getItems(),C=c.getLabel();r.openStart("div",c);r.attr("tabindex","0");r.class("sapMTPColumn");if(c.getIsExpanded()){r.class("sapMTPSliderExpanded");}if(!c.getIsCyclic()){r.class("sapMTimePickerSliderShort");}if(!c._getEnabled()){r.class("sapMTPDisabled");}r.accessibilityState(c,{role:"list",labelledby:{value:c.getId()+"-label",append:true},describedby:{value:c.getId()+"-valDescription",append:true}});r.openEnd();r.openStart("div",c.getId()+"-label");r.class("sapMTimePickerLabel");r.openEnd();r.text(C);r.close("div");r.openStart("div",c.getId()+"-valDescription");r.attr('aria-hidden','false');r.attr('aria-live','assertive');r.class("sapUiInvisibleText");r.openEnd();r.close("div");r.openStart("div");r.class("sapMTimePickerItemArrows");r.openEnd();r.renderControl(c.getAggregation("_arrowUp"));r.close("div");r.openStart("div");r.class("sapMTimePickerSlider");T.addItemValuesCssClass(r,c);r.attr("unselectable","on");r.openEnd();r.openStart("div");r.class("sapMTPPickerSelectionFrame");r.openEnd();r.close("div");r.openStart("ul",c.getId()+"-content");r.attr("unselectable","on");r.openEnd();for(R=1;R<=n;R++){for(i=0;i<I.length;i++){r.openStart("li");r.class("sapMTimePickerItem");if(!I[i].getVisible()){r.class("TPSliderItemHidden");}r.accessibilityState(c);r.attr("unselectable","on");r.openEnd();r.text(I[i].getText());r.close("li");}}r.close("ul");r.close("div");r.openStart("div");r.class("sapMTimePickerItemArrows");r.openEnd();r.renderControl(c.getAggregation("_arrowDown"));r.close("div");r.close("div");};
T.addItemValuesCssClass=function(r,c){var v=c.getItems().filter(function(i){return i.getVisible();}).length;if(v>2&&v<13){r.class("SliderValues"+v.toString());}};
return T;});
sap.ui.predefine('sap/m/TimePickerSliders',['sap/ui/core/library','sap/ui/core/Control','sap/ui/model/type/Date','sap/ui/model/odata/type/ODataType','sap/ui/core/format/DateFormat','./TimePickerSlidersRenderer','./TimePickerSlider','./VisibleItem','sap/ui/core/LocaleData','sap/ui/Device','sap/ui/core/Locale','./TimePickerSlidersRenderer',"sap/ui/thirdparty/jquery"],function(c,C,S,O,D,a,T,V,L,b,d,e,q){"use strict";var f=1,g=c.CalendarType;
var h=C.extend("sap.m.TimePickerSliders",{metadata:{library:"sap.m",properties:{localeId:{type:"string",group:"Data"},displayFormat:{name:"displayFormat",type:"string",group:"Appearance"},labelText:{name:"labelText",type:"string"},minutesStep:{type:"int",group:"Misc",defaultValue:f},secondsStep:{type:"int",group:"Misc",defaultValue:f},width:{type:"sap.ui.core.CSSSize",group:"Appearance"},height:{type:"sap.ui.core.CSSSize",group:"Appearance"},value:{type:"string",group:"Data",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},support2400:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{_columns:{type:"sap.m.TimePickerSlider",multiple:true,visibility:"hidden"}},events:{change:{parameters:{value:{type:"string"}}}}}});
h.prototype.init=function(){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),o=L.getInstance(l),p=o.getDayPeriods("abbreviated"),i=o.getTimePattern("medium");this._fnLayoutChanged=q.proxy(this._onOrientationChanged,this);b.resize.attachHandler(this._fnLayoutChanged);this._sAM=p[0];this._sPM=p[1];this._onSliderExpanded=this._onSliderExpanded.bind(this);this._onSliderCollapsed=this._onSliderCollapsed.bind(this);this.setDisplayFormat(i);this._setTimeValues();this._iMinutes;this._iSeconds;};
h.prototype.exit=function(){this.$().off(b.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);b.resize.detachHandler(this._fnOrientationChanged);};
h.prototype.onAfterRendering=function(){this.$().off(b.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);this.$().on(b.browser.firefox?"DOMMouseScroll":"mousewheel",q.proxy(this._onmousewheel,this));this.$().on('selectstart',F);if(this._getShouldOpenSliderAfterRendering()){if(b.system.desktop){this._getFirstSlider().setIsExpanded(true);}}};
h.prototype.setLocaleId=function(l){var o,p;l=this.validateProperty("localeId",l);this.setProperty("localeId",l,true);if(l){o=new d(l);p=L.getInstance(o).getDayPeriods("abbreviated");this._sAM=p[0];this._sPM=p[1];this._destroyColumns();this._setupLists();}return this;};
h.prototype.setSupport2400=function(i){this.setProperty("support2400",i,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setDisplayFormat=function(i){this.setProperty("displayFormat",i,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setMinutesStep=function(v){v=Math.max(f,v||f);this.setProperty("minutesStep",v,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setSecondsStep=function(v){v=Math.max(f,v||f);this.setProperty("secondsStep",v,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setValue=function(v){var H=this._getHoursSlider(),i=this._getValueFormatPattern(),I=i.indexOf("HH"),j=i.indexOf("H"),k=H&&H.getSelectedValue()==="24",l=h._isHoursValue24(v,I,j);if(k&&this._isFormatSupport24()&&!l){v=h._replaceZeroHoursWith24(v,I,j);}v=this.validateProperty("value",v);this.setProperty("value",v,true);var o;if(v){o=this._parseValue(l?h._replace24HoursWithZero(v,I,j):v);}if(o){this._setTimeValues(o,l);}return this;};
h.prototype.getTimeValues=function(){var H=this._getHoursSlider(),m=this._getMinutesSlider(),o=this._getSecondsSlider(),i=this._getFormatSlider(),j=null,A=null,k=new Date();if(H){j=parseInt(H.getSelectedValue());}if(i){A=i.getSelectedValue();}if(A==="am"&&j===12){j=0;}else if(A==="pm"&&j!==12){j+=12;}if(j!==null){k.setHours(j.toString());}if(m){k.setMinutes(m.getSelectedValue());}if(o){k.setSeconds(o.getSelectedValue());}return k;};
h.prototype.collapseAll=function(){var i=this.getAggregation("_columns");if(i){for(var I=0;I<i.length;I++){if(i[I].getIsExpanded()){i[I].setIsExpanded(false);}}}return this;};
h.prototype.openFirstSlider=function(){var o=this._getFirstSlider();o.setIsExpanded(true);o.focus();return this;};
h.prototype._setTimeValues=function(o,H){var i=this._getHoursSlider(),m=this._getMinutesSlider(),j=this._getSecondsSlider(),k=this._getFormatSlider(),l,A=null;o=o||new Date();if(Object.prototype.toString.call(o)!=="[object Date]"||isNaN(o)){throw new Error("Date must be a JavaScript date object; "+this);}if(!H){var v=this._formatValue(o,true);this.setProperty("value",v,true);l=o.getHours();}else{l=24;}if(k){A=l>=12?"pm":"am";l=(l>12)?l-12:l;l=(l===0?12:l);}i&&i.setSelectedValue(l.toString());m&&m._updateStepAndValue(o.getMinutes(),this.getMinutesStep());j&&j._updateStepAndValue(o.getSeconds(),this.getSecondsStep());k&&k.setSelectedValue(A);if(H){this._disableSlider(m);m&&m.setSelectedValue("0");this._disableSlider(j);j&&j.setSelectedValue("0");}else{this._enableSlider(m);this._enableSlider(j);}};
h.prototype._updateSlidersValues=function(){var i=this.getAggregation("_columns");if(i){for(var I=0;I<i.length;I++){i[I]._updateScroll();}}};
h.prototype.onsaphome=function(E){var n=this._getFirstSlider(),o=this._getCurrentSlider();if(o&&document.activeElement===o.getDomRef()&&this._isSliderEnabled(n)){n.focus();}};
h.prototype.onsapend=function(E){var n=this._getLastSlider(),o=this._getCurrentSlider();if(o&&document.activeElement===o.getDomRef()&&this._isSliderEnabled(n)){n.focus();}};
h.prototype.onsapleft=function(E){var n,o=this._getCurrentSlider(),i=-1,N=-1,j=this.getAggregation("_columns");if(o&&document.activeElement===o.getDomRef()){i=j.indexOf(o);N=i>0?i-1:j.length-1;n=j[N];if(this._isSliderEnabled(n)){n.focus();}}};
h.prototype.onsapright=function(E){var n,o=this._getCurrentSlider(),i=-1,N=-1,j=this.getAggregation("_columns");if(o&&document.activeElement===o.getDomRef()){i=j.indexOf(o);N=i<j.length-1?i+1:0;n=j[N];if(this._isSliderEnabled(n)){n.focus();}}};
h.prototype._onmousewheel=function(E){var i=this._getCurrentSlider();if(i){i._onmousewheel(E);}};
h.prototype._onOrientationChanged=function(){var j=this.getAggregation("_columns");if(!j){return;}for(var i=0;i<j.length;i++){if(j[i].getIsExpanded()){j[i]._updateSelectionFrameLayout();}}};
h.prototype._generatePickerListValues=function(i,t,j,l){var v=[],k;for(var I=i;I<=t;I+=1){if(I<10&&l){k="0"+I.toString();}else{k=I.toString();}var o=new V({key:I.toString(),text:k});if(I%j!==0){o.setVisible(false);}v.push(o);}return v;};
h.prototype._checkStyle=function(p){return(p==="short"||p==="medium"||p==="long"||p==="full");};
h.prototype._getDisplayFormatPattern=function(){var p=this.getDisplayFormat();if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}return p;};
h.prototype._getValueFormatPattern=function(){var p=this._getBoundValueTypePattern()||this.getValueFormat()||"medium";if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}return p;};
h.prototype._getLocaleBasedPattern=function(p){return L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getTimePattern(p);};
h.prototype._destroyColumns=function(){var i=this.getAggregation("_columns");if(i){this.destroyAggregation("_columns");}};
h.prototype._setupLists=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),l=r.getText("TIMEPICKER_LBL_HOURS"),i=r.getText("TIMEPICKER_LBL_MINUTES"),j=r.getText("TIMEPICKER_LBL_SECONDS"),k=r.getText("TIMEPICKER_LBL_AMPM"),m=this.getMinutesStep(),n=this.getSecondsStep(),o=this._getDisplayFormatPattern();if(o===undefined){return;}var H=false,p=false,t,u;if(o.indexOf("HH")!==-1){H=true;t=0;u=this.getSupport2400()?24:23;p=true;}else if(o.indexOf("H")!==-1){H=true;t=0;u=this.getSupport2400()?24:23;}else if(o.indexOf("hh")!==-1){H=true;t=1;u=12;p=true;}else if(o.indexOf("h")!==-1){H=true;t=1;u=12;}if(H){this.addAggregation("_columns",new T(this.getId()+"-listHours",{items:this._generatePickerListValues(t,u,1,p),expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:l}).attachEvent("_selectedValueChange",this._handleHoursChange,this));}if(o.indexOf("m")!==-1){var v=this._generatePickerListValues(0,59,m,true);this.addAggregation("_columns",new T(this.getId()+"-listMins",{items:v,expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:i}));}if(o.indexOf("s")!==-1){var v=this._generatePickerListValues(0,59,n,true);this.addAggregation("_columns",new T(this.getId()+"-listSecs",{items:v,expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:j}));}if(o.indexOf("a")!==-1){this.addAggregation("_columns",new T(this.getId()+"-listFormat",{items:[{key:"am",text:this._sAM},{key:"pm",text:this._sPM}],expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:k,isCyclic:false}).addStyleClass("sapMTimePickerSliderShort"));}var w,x=this.getValue();if(x){w=this._parseValue(x);}if(w){this._setTimeValues(w);}};
h.prototype._getCurrentSlider=function(){var j=this.getAggregation("_columns");if(j){for(var i=0;i<j.length;i++){if(j[i].getIsExpanded()){return j[i];}}}return null;};
h.prototype._getHoursSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listHours")||null;};
h.prototype._getMinutesSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listMins")||null;};
h.prototype._getSecondsSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listSecs")||null;};
h.prototype._getFormatSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listFormat")||null;};
h.prototype._getFirstSlider=function(){return this.getAggregation("_columns")[0]||null;};
h.prototype._getLastSlider=function(){var i=this.getAggregation("_columns");return i[i.length-1]||null;};
h.prototype._parseValue=function(v){return this._getFormatter().parse(v);};
h.prototype._isSliderEnabled=function(o){return o._getEnabled();};
h.prototype._getFormatter=function(){var p=this._getBoundValueTypePattern(),r=false,B=this.getBinding("value"),i;if(B&&B.oType&&B.oType.oOutputFormat){r=!!B.oType.oOutputFormat.oFormatOptions.relative;i=B.oType.oOutputFormat.oFormatOptions.calendarType;}if(!p){p=this.getValueFormat()||"medium";i=g.Gregorian;}if(!i){i=sap.ui.getCore().getConfiguration().getCalendarType();}return this._getFormatterInstance(p,r,i);};
h.prototype._getBoundValueTypePattern=function(){var B=this.getBinding("value"),o=B&&B.getType&&B.getType();if(o instanceof S){return o.getOutputPattern();}if(o instanceof O&&o.oFormat){return o.oFormat.oFormatOptions.pattern;}return undefined;};
h.prototype._getFormatterInstance=function(p,r,i,j){var o;if(this._checkStyle(p)){o=this._getFormatInstance({style:p,strictParsing:true,relative:r,calendarType:i});}else{o=this._getFormatInstance({pattern:p,strictParsing:true,relative:r,calendarType:i});}return o;};
h.prototype._getFormatInstance=function(A,i){return D.getTimeInstance(A);};
h.prototype._formatValue=function(o){if(o){return this._getFormatter().format(o);}return"";};
h.prototype._onSliderExpanded=function(E){var j=this.getAggregation("_columns");for(var i=0;i<j.length;i++){if(j[i]!==E.oSource&&j[i].getIsExpanded()){j[i].setIsExpanded(false);}}};
h.prototype._onSliderCollapsed=function(E){var o=this.getTimeValues();this.setValue(this._formatValue(o,true));this.fireChange({value:this.getValue()});};
h.prototype._getShouldOpenSliderAfterRendering=function(){return this._shouldOpenSliderAfterRendering;};
h.prototype._setShouldOpenSliderAfterRendering=function(i){this._shouldOpenSliderAfterRendering=i;return this;};
h.prototype._isFormatSupport24=function(){var i=this._getDisplayFormatPattern();return i.indexOf("HH")!==-1||i.indexOf("H")!==-1;};
h.prototype._disableSlider=function(o){if(o){o._setEnabled(false);}return this;};
h.prototype._enableSlider=function(o){if(o){o._setEnabled(true);}return this;};
h.prototype._handleHoursChange=function(E){var v=E.getParameter("value"),m=this._getMinutesSlider(),o=this._getSecondsSlider();if(this.getSupport2400()){if(v==="24"){if(m&&m._getEnabled()){this._iMinutes=m.getSelectedValue();this._disableSlider(m);m.setSelectedValue("0");}if(o&&o._getEnabled()){this._iSeconds=o.getSelectedValue();this._disableSlider(o);o.setSelectedValue("0");}}else{if(m&&!m._getEnabled()){this._enableSlider(m);m.setSelectedValue(this._iMinutes);}if(o&&!o._getEnabled()){this._enableSlider(o);o.setSelectedValue(this._iSeconds);}}}};
h._replaceZeroHoursWith24=function(v,i,I){var H=2,j=i;if(i===-1){H=1;j=I;}return v.substr(0,j)+"24"+v.substr(j+H);};
h._replace24HoursWithZero=function(v,i,I){var H=2,j=i;if(i===-1){H=1;j=I;}return v.substr(0,j)+s(0,H)+v.substr(j+2);};
h._isHoursValue24=function(v,i,I){if(i===-1&&I===-1){return false;}var j=i;if(i===-1){j=I;}return v.substr(j,2)==="24";};
function s(j,k){var r="";for(var i=0;i<k;i++){r+=j;}return r;}
function F(){return false;}
return h;});
sap.ui.predefine('sap/m/TimePickerSlidersRenderer',["sap/ui/Device"],function(D){"use strict";var T={apiVersion:2};
T.render=function(r,c){var s=c.getAggregation("_columns"),l=c.getLabelText()||"",R=sap.ui.getCore().getLibraryResourceBundle("sap.m"),S,b=sap.ui.getCore().getConfiguration().getRTL();r.openStart("div",c);r.class("sapMTimePickerContainer");r.style("width",c.getWidth());r.style("height",c.getHeight());r.accessibilityState(c,{label:(l+" "+R.getText("TIMEPICKER_SCREENREADER_TAG")).trim()});r.openEnd();if(!D.system.desktop){r.openStart("div",c.getId()+"-label");r.class("sapMTimePickerContainerLabel");r.openEnd();r.text(l);r.close("div");}if(b){for(S=s.length-1;S>=0;S--){r.renderControl(s[S]);}}else{for(S=0;S<s.length;S++){r.renderControl(s[S]);}}r.close("div");};
return T;},true);
sap.ui.predefine('sap/m/Title',['sap/ui/core/Control','./library','sap/ui/core/library','./TitleRenderer',"sap/m/HyphenationSupport"],function(C,l,c,T,H){"use strict";var a=c.TextDirection;var b=c.TextAlign;var d=c.TitleLevel;var W=l.WrappingType;
var e=C.extend("sap.m.Title",{metadata:{library:"sap.m",interfaces:["sap.ui.core.IShrinkable","sap.m.IHyphenation"],properties:{text:{type:"string",group:"Appearance",defaultValue:null},level:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:d.Auto},titleStyle:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:d.Auto},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:b.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:a.Inherit},wrapping:{type:"boolean",group:"Appearance",defaultValue:false},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.ITitleContent",multiple:false}},associations:{title:{type:"sap.ui.core.Title",multiple:false}},designtime:"sap/m/designtime/Title.designtime"}});
e.prototype._getTitle=function(){var t=this.getTitle();if(t){var o=sap.ui.getCore().byId(t);if(o&&o instanceof sap.ui.core.Title){return o;}}return null;};
e.prototype._onTitleChanged=function(){this.invalidate();};
e.prototype.setTitle=function(t){var f=this;var o=this._getTitle();if(o){o.invalidate=o.__sapui5_title_originvalidate;o.exit=o.__sapui5_title_origexit;delete o.__sapui5_title_origexit;delete o.__sapui5_title_originvalidate;}this.setAssociation("title",t);var n=this._getTitle();if(n){n.__sapui5_title_originvalidate=n.invalidate;n.__sapui5_title_origexit=n.exit;n.exit=function(){f._onTitleChanged();if(this.__sapui5_title_origexit){this.__sapui5_title_origexit.apply(this,arguments);}};n.invalidate=function(){f._onTitleChanged();this.__sapui5_title_originvalidate.apply(this,arguments);};}return this;};
e.prototype.getAccessibilityInfo=function(){var t=this._getTitle()||this;return{role:"heading",description:t.getText(),focusable:false};};
e.prototype.getTextsToBeHyphenated=function(){var t=this._getTitle();return{"main":t?t.getText():this.getText()};};
e.prototype.getDomRefsForHyphenatedTexts=function(){var D;if(!this._getTitle()){D={"main":this.getDomRef("inner")};}return D;};
e.prototype._getAriaLevel=function(){var L=2,f=1;if(this.getTitleStyle()!==d.Auto){L=parseInt(this.getTitleStyle()[f]);}return L;};
H.mixInto(e.prototype);return e;});
sap.ui.predefine('sap/m/TitlePropagationSupport',[],function(){"use strict";return function(a,g){if(!this.isA("sap.ui.core.Element")){return;}this._propagateTitleIdToChildControl=function(){var A=this.getMetadata().getAggregation(a),c=A&&A.get(this),t=g&&g.call(this),i;if(!sap.ui.getCore().getConfiguration().getAccessibility()||!t||!c||c.length===0){return false;}i=c[0];if(i&&i._suggestTitleId&&i.isA(["sap.ui.layout.form.SimpleForm","sap.ui.layout.form.Form","sap.ui.comp.smartform.SmartForm"])){i._suggestTitleId(t);return true;}return false;};this._initTitlePropagationSupport=function(){this.addEventDelegate({onBeforeRendering:this._propagateTitleIdToChildControl.bind(this)});};};});
sap.ui.predefine('sap/m/TitleRenderer',["sap/ui/core/Renderer","sap/ui/core/library","sap/m/HyphenationSupport"],function(R,c,H){"use strict";var T=c.TextDirection;var a=c.TitleLevel;var b={apiVersion:2};
b.render=function(r,t){var A=t._getTitle(),o=t.getContent(),l=(A&&!o?A.getLevel():t.getLevel())||a.Auto,d=l==a.Auto,s=d?"div":l.toLowerCase(),e=!o?H.getTextForRender(t,"main"):"",f=t.getTextDirection(),g=R.getTextAlign(t.getTextAlign(),f),h;r.openStart(s,t);r.class("sapMTitle");r.class("sapMTitleStyle"+t.getTitleStyle());r.class(t.getWrapping()?"sapMTitleWrap":"sapMTitleNoWrap");r.class("sapUiSelectable");var w=t.getWidth();if(!w){r.class("sapMTitleMaxWidth");}else{r.style("width",w);}if(g){r.style("text-align",g);}if(t.getParent()instanceof sap.m.Toolbar){r.class("sapMTitleTB");}h=A&&!o?A.getTooltip_AsString():t.getTooltip_AsString();if(h){r.attr("title",h);}if(d){r.attr("role","heading");r.attr("aria-level",t._getAriaLevel());}if(!o){H.writeHyphenationClass(r,t);}r.openEnd();r.openStart("span",t.getId()+"-inner");r.attr("dir",f!==T.Inherit?f.toLowerCase():"auto");r.openEnd();if(o){r.renderControl(o);}else{r.text(e);}r.close("span");r.close(s);};
return b;},true);
sap.ui.predefine('sap/m/ToggleButton',['./Button','./library','sap/ui/core/EnabledPropagator','./ToggleButtonRenderer',"sap/ui/events/KeyCodes"],function(B,l,E,T,K){"use strict";
var a=B.extend("sap.m.ToggleButton",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ToggleButton.designtime",properties:{pressed:{type:"boolean",group:"Data",defaultValue:false}},events:{press:{parameters:{pressed:{type:"boolean"}}}}}});
E.call(a.prototype);
a.prototype.ontap=function(e){e.setMarked();if(this.getEnabled()){this.setPressed(!this.getPressed());this.firePress({pressed:this.getPressed()});}};
a.prototype.setPressed=function(p){p=!!p;if(p!=this.getPressed()){this.setProperty("pressed",p);this.$().attr("aria-pressed",p);this.$("inner").toggleClass("sapMToggleBtnPressed",p&&!this._isUnstyled());}return this;};
a.prototype.onkeydown=function(e){if(e.which===K.ENTER){this.ontap(e);}};
a.prototype.onkeyup=function(e){if(e.which===K.SPACE||e.which===K.ENTER){e.setMarked();}if(e.which===K.SPACE){this.ontap(e);}};
a.prototype.getAccessibilityInfo=function(){var i=B.prototype.getAccessibilityInfo.apply(this,arguments);if(this.getPressed()){i.description=((i.description||"")+" "+sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_STATE_PRESSED")).trim();}return i;};
return a;});
sap.ui.predefine('sap/m/ToggleButtonRenderer',['./ButtonRenderer','sap/ui/core/Renderer'],function(B,R){"use strict";var T=R.extend(B);T.apiVersion=2;
T.renderAccessibilityAttributes=function(r,t,a){a["pressed"]=t.getPressed();};
T.renderButtonAttributes=function(r,t){if(t.getPressed()&&!t._isUnstyled()){r.class("sapMToggleBtnPressed");}};
return T;},true);
sap.ui.predefine('sap/m/Token',['./library','sap/ui/core/Control','sap/ui/core/library','sap/ui/core/Icon','./TokenRenderer','sap/ui/core/InvisibleText','sap/ui/events/KeyCodes','sap/ui/core/Core'],function(l,C,c,I,T,a,K,b){"use strict";var d=c.TextDirection;
var e=C.extend("sap.m.Token",{metadata:{library:"sap.m",properties:{selected:{type:"boolean",group:"Misc",defaultValue:false},key:{type:"string",group:"Misc",defaultValue:""},text:{type:"string",group:"Misc",defaultValue:""},editable:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:d.Inherit},editableParent:{type:"boolean",group:"Behavior",defaultValue:true,visibility:"hidden"},truncated:{type:"boolean",group:"Appearance",defaultValue:false,visibility:"hidden"},posinset:{type:"int",visibility:"hidden"},setsize:{type:"int",visibility:"hidden"}},aggregations:{deleteIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{"delete":{enableEventBubbling:true},press:{},select:{},deselect:{}}}});
e.prototype.init=function(){var D=new I({id:this.getId()+"-icon",src:"sap-icon://decline",noTabStop:true,press:this._fireDeleteToken.bind(this)});D.addStyleClass("sapMTokenIcon");D.setUseIconTooltip(false);this.setAggregation("deleteIcon",D);};
e.prototype.ontouchstart=function(E){if(E.target.id===this.getId()+"-icon"){E.preventDefault();}};
e.prototype._getTooltip=function(o,E){var t=o.getTooltip_AsString(),D=b.getLibraryResourceBundle("sap.m").getText("TOKEN_ARIA_DELETABLE");if(E&&!t){return D;}return t;};
e.prototype._onTokenPress=function(E){var s=this.getSelected(),f=E.ctrlKey||E.metaKey,n=true;if(f||(E.which===K.SPACE)){n=!s;}this.setSelected(n);this.firePress();if(s!==n){if(n){this.fireSelect();}else{this.fireDeselect();}}if(this.getSelected()){this.focus();}};
e.prototype.ontap=function(E){var D=this.getAggregation("deleteIcon");if(D&&E.target.id===D.getId()){E.setMark("tokenDeletePress",true);return;}E.setMark("tokenTap",this);this._onTokenPress(E);};
e.prototype._fireDeleteToken=function(E,k,B){if(this.getEditable()&&this.getProperty("editableParent")){this.fireDelete({token:this,byKeyboard:k,backspace:B});}E.preventDefault();};
e.prototype.onsapspace=function(E){this._onTokenPress(E);if(E){E.preventDefault();E.stopPropagation();}};
e.prototype.onkeydown=function(E){if((E.ctrlKey||E.metaKey)&&E.which===K.SPACE){this.onsapspace(E);E.preventDefault();}};
e.prototype.getTruncated=function(){return this.getProperty("truncated");};
e.prototype.setTruncated=function(v){return this.setProperty("truncated",v);};
return e;});
sap.ui.predefine('sap/m/TokenRenderer',["sap/ui/core/library","sap/ui/core/InvisibleText"],function(c,I){"use strict";var T=c.TextDirection;var a={apiVersion:2};
a.render=function(r,C){var t=C._getTooltip(C,C.getEditable()&&C.getProperty("editableParent"));var d=C.getAggregation("deleteIcon");var A=[];var o={role:"option"};var p=C.getProperty("posinset");var s=C.getProperty("setsize");r.openStart("div",C).attr("tabindex","-1").class("sapMToken");if(C.getSelected()){r.class("sapMTokenSelected");}if(p!==undefined){r.attr("aria-posinset",C.getProperty("posinset"));}if(s!==undefined){r.attr("aria-setsize",C.getProperty("setsize"));}if(!C.getEditable()){r.class("sapMTokenReadOnly");}if(C.getTruncated()){r.class("sapMTokenTruncated");}if(t){r.attr("title",t);}A.push(I.getStaticId("sap.m","TOKEN_ARIA_LABEL"));if(C.getEditable()&&C.getProperty("editableParent")){A.push(I.getStaticId("sap.m","TOKEN_ARIA_DELETABLE"));}r.attr("aria-selected",C.getSelected());o.describedby={value:A.join(" "),append:true};r.accessibilityState(C,o);r.openEnd();a._renderInnerControl(r,C);if(C.getEditable()&&d){r.renderControl(d);}r.close("div");};
a._renderInnerControl=function(r,C){var t=C.getTextDirection();r.openStart("span").class("sapMTokenText");if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();var b=C.getText();if(b){r.text(b);}r.close("span");};
return a;},true);
sap.ui.predefine('sap/m/Tokenizer',['./library','sap/m/Button','sap/m/List','sap/m/StandardListItem','sap/m/ResponsivePopover','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/delegate/ScrollEnablement','sap/ui/Device','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','./TokenizerRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/core/EnabledPropagator","sap/ui/core/theming/Parameters","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control","sap/ui/dom/jquery/scrollLeftRTL"],function(l,B,L,S,R,C,c,d,D,I,e,T,f,K,g,E,P,q,s){"use strict";var h="sapUiNoContentPadding";var j=l.TokenizerRenderMode;var k=l.PlacementType;var m=l.ListMode;var n=l.ButtonType;
var o=c.extend("sap.m.Tokenizer",{metadata:{library:"sap.m",properties:{editable:{type:"boolean",group:"Misc",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},renderMode:{type:"string",group:"Misc",defaultValue:j.Loose},hiddenTokensCount:{type:"int",group:"Misc",defaultValue:0,visibility:"hidden"}},defaultAggregation:"tokens",aggregations:{tokens:{type:"sap.m.Token",multiple:true,singularName:"token"},_tokensInfo:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tokenChange:{deprecated:true,parameters:{type:{type:"string"},token:{type:"sap.m.Token"},tokens:{type:"sap.m.Token[]"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}},tokenUpdate:{deprecated:true,allowPreventDefault:true,parameters:{type:{type:"string"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}},tokenDelete:{parameters:{tokens:{type:"sap.m.Token[]"},keyCode:{type:"number"}}}}}});
var r=C.getLibraryResourceBundle("sap.m");E.apply(o.prototype,[true]);
o.prototype.init=function(){this.allowTextSelection(false);this._oTokensWidthMap={};this._oIndicator=null;this._oScroller=new d(this,this.getId()+"-scrollContainer",{horizontal:true,vertical:false,nonTouchScrolling:true});this._fFontSizeRatio=1.0;if(C.getConfiguration().getAccessibility()){var a=new I({text:r.getText("TOKENIZER_ARIA_NO_TOKENS")});this.setAggregation("_tokensInfo",a);}this.attachEvent("delete",function(b){var t=b.getSource();var i=this.getSelectedTokens();this.fireTokenChange({type:sap.m.Tokenizer.TokenChangeType.Removed,token:t,tokens:i.length?i:[t],addedTokens:[],removedTokens:i.length?i:[t]});this.fireTokenUpdate({type:sap.m.Tokenizer.TokenChangeType.Removed,addedTokens:[],removedTokens:i.length?i:[t]});this.fireEvent("tokenDelete",{tokens:[t]});},this);};
o.prototype._handleNMoreIndicatorPress=function(){this._togglePopup(this.getTokensPopup());};
o.prototype._getTokensList=function(){if(!this._oTokensList){this._oTokensList=new L({width:"auto",mode:m.Delete}).attachDelete(this._handleListItemDelete,this);}return this._oTokensList;};
o.prototype._setPopoverMode=function(M){var a={},p=this.getTokensPopup();switch(M){case m.Delete:a={showArrow:false,placement:k.VerticalPreferredBottom};break;default:a={showArrow:true,placement:k.Auto};break;}p.setShowArrow(a.showArrow);p.setPlacement(a.placement);this._getTokensList().setMode(M);};
o.prototype._fillTokensList=function(a,F){a.destroyItems();F=F?F:function(){return true;};this.getTokens().filter(F).forEach(function(t){a.addItem(this._mapTokenToListItem(t));},this);};
o.prototype._handleListItemDelete=function(a){var b=a.getParameter("listItem");var i=b&&b.data("tokenId");var t;t=this.getTokens().filter(function(p){return(p.getId()===i)&&p.getEditable();})[0];if(t){this.fireTokenUpdate({addedTokens:[],removedTokens:[t],type:o.TokenUpdateType.Removed});this.fireTokenDelete({tokens:[t]});this._adjustTokensVisibility();}};
o.prototype.getTokensPopup=function(){if(this._oPopup){return this._oPopup;}this._oPopup=new R({showArrow:false,showHeader:D.system.phone,placement:k.Auto,offsetX:0,offsetY:3,horizontalScrolling:false,title:this._getDialogTitle(),content:this._getTokensList()}).attachBeforeOpen(function(){var w=this.getEditable()?120:32,p=this._oPopup,G=function(){var a=this.getDomRef()&&this.getDomRef().parentElement;var b="Cozy";if(!a){return b;}if(a.closest(".sapUiSizeCompact")!==null||document.body.classList.contains("sapUiSizeCompact")){b="Compact";}return b;}.bind(this),i=new Promise(function(a){P.get({name:["_sap_m_Tokenizer_FontSizeRatio"+G()],callback:function(F){var b=parseFloat(F);if(isNaN(b)){a(this._fFontSizeRatio);return;}a(b);}.bind(this)});}.bind(this));if(p.getContent&&!p.getContent().length){p.addContent(this._getTokensList());}this._fillTokensList(this._getTokensList());w+=Object.keys(this._oTokensWidthMap).map(function(a){return this._oTokensWidthMap[a];},this).sort(function(a,b){return a-b;}).pop()||0;i.then(function(a){w+=Math.ceil(w*(1-a));p.setContentWidth(w+"px");});},this);this.addDependent(this._oPopup);this._oPopup.addStyleClass(h);this._oPopup.addStyleClass("sapMTokenizerTokensPopup");if(D.system.phone){this._oPopup.setEndButton(new B({text:r.getText("SUGGESTIONSPOPOVER_CLOSE_BUTTON"),type:n.Emphasized,press:function(){this._oPopup.close();}.bind(this)}));}return this._oPopup;};
o.prototype._getDialogTitle=function(){var a=C.getLibraryResourceBundle("sap.m");var b=this.getAriaLabelledBy().map(function(i){return C.byId(i);});return b.length?b[0].getText():a.getText("COMBOBOX_PICKER_TITLE");};
o.prototype._togglePopup=function(p){var O,a=this.getDomRef(),b=p.isOpen(),i=this.getEditable();this._setPopoverMode(i?m.Delete:m.None);if(b){p.close();}else{O=i||this.hasOneTruncatedToken()?a:this._oIndicator[0];O=O&&O.className.indexOf("sapUiHidden")===-1?O:a;p.openBy(O||a);}};
o.prototype._mapTokenToListItem=function(t){if(!t){return null;}var a=new S({selected:true}).data("tokenId",t.getId());a.setTitle(t.getText());return a;};
o.prototype._getPixelWidth=function(){var M=this.getMaxWidth(),t,a=this.getDomRef(),p;if(!a){return;}p=parseInt(this.$().css("padding-left"));if(M.indexOf("px")===-1){t=a.clientWidth;}else{t=parseInt(this.getMaxWidth());}return t-p;};
o.prototype._adjustTokensVisibility=function(){if(!this.getDomRef()){return;}var t=this._getPixelWidth(),a=this._getVisibleTokens().reverse(),i=a.length,b,F,p,u=-1;a.some(function(v,w){t=t-this._oTokensWidthMap[v.getId()];if(t<0){u=w;return true;}else{F=t;}},this);if(i===1&&u!==-1){this.setFirstTokenTruncated(true);return;}else if(i===1&&a[0].getTruncated()){this.setFirstTokenTruncated(false);}if(u>-1){for(p=0;p<i;p++){if(p>=u){a[p].addStyleClass("sapMHiddenToken");}else{a[p].removeStyleClass("sapMHiddenToken");}}this._handleNMoreIndicator(i-u);b=this._oIndicator.width();if(b>=F){u=u-1;this._handleNMoreIndicator(i-u);a[u].addStyleClass("sapMHiddenToken");}this._setHiddenTokensCount(i-u);}else{this._setHiddenTokensCount(0);this._showAllTokens();}};
o.prototype.setFirstTokenTruncated=function(v){var t=this.getTokens()[0];t&&t.setTruncated(v);if(v){this.addStyleClass("sapMTokenizerOneLongToken");}else{this.removeStyleClass("sapMTokenizerOneLongToken");this.scrollToEnd();}return this;};
o.prototype.hasOneTruncatedToken=function(){return this.getTokens().length===1&&this.getTokens()[0].getTruncated();};
o.prototype._handleNMoreIndicator=function(H){if(!this.getDomRef()){return this;}if(H){var a="MULTIINPUT_SHOW_MORE_TOKENS";if(H===this._getVisibleTokens().length){if(H===1){a="TOKENIZER_SHOW_ALL_ITEM";}else{a="TOKENIZER_SHOW_ALL_ITEMS";}}this._oIndicator.html(r.getText(a,H));}return this;};
o.prototype._getVisibleTokens=function(){return this.getTokens().filter(function(t){return t.getVisible();});};
o.prototype._showAllTokens=function(){this._getVisibleTokens().forEach(function(t){t.removeStyleClass("sapMHiddenToken");});};
o.prototype.getScrollDelegate=function(){return this._oScroller;};
o.prototype.scrollToEnd=function(){var a=this.getDomRef(),b=C.getConfiguration().getRTL(),i,p;if(!this.getDomRef()){return;}p=this.$().find(".sapMTokenizerScrollContainer")[0];i=p.scrollWidth;if(b){i*=-1;}a.scrollLeft=i;};
o.prototype._registerResizeHandler=function(){if(!this._sResizeHandlerId){this._sResizeHandlerId=e.register(this.getDomRef(),this._handleResize.bind(this));}};
o.prototype._handleResize=function(){this._useCollapsedMode(this.getRenderMode());this.scrollToEnd();};
o.prototype.setPixelWidth=function(a){if(typeof a!=="number"){g.warning("Tokenizer.setPixelWidth called with invalid parameter. Expected parameter of type number.");return;}this.setWidth(a+"px");if(this._oScroller){this._oScroller.refresh();}};
o.prototype.scrollToStart=function(){var a=this.getDomRef();if(!a){return;}a.scrollLeft=0;};
o.prototype.getScrollWidth=function(){if(!this.getDomRef()){return 0;}return this.$().children(".sapMTokenizerScrollContainer")[0].scrollWidth;};
o.prototype.onBeforeRendering=function(){var t=this.getTokens();if(t.length!==1){this.setFirstTokenTruncated(false);}t.forEach(function(a,i){a.setProperty("editableParent",this.getEditable()&&this.getEnabled(),true);a.setProperty("posinset",i+1,true);a.setProperty("setsize",t.length,true);},this);this._setTokensAria();};
o.prototype.onAfterRendering=function(){var a=this.getRenderMode();this._oIndicator=this.$().find(".sapMTokenizerIndicator");if(C.isThemeApplied()){this._storeTokensSizes();}this._useCollapsedMode(a);this._registerResizeHandler();if(a===j.Loose){this.scrollToEnd();}};
o.prototype.onThemeChanged=function(){this._storeTokensSizes();this._useCollapsedMode(this.getRenderMode());};
o.prototype._storeTokensSizes=function(){var t=this.getTokens();t.forEach(function(a){if(a.getDomRef()&&!a.$().hasClass("sapMHiddenToken")&&!a.getTruncated()){this._oTokensWidthMap[a.getId()]=a.$().outerWidth(true);}},this);};
o.prototype._useCollapsedMode=function(a){var t=this._getVisibleTokens();if(!t.length){return;}if(a===j.Narrow){this._adjustTokensVisibility();}else{this._setHiddenTokensCount(0);this._showAllTokens();}};
o.prototype.onsapfocusleave=function(a){if(document.activeElement===this.getDomRef()||!this._checkFocus()){this._changeAllTokensSelection(false);this._oSelectionOrigin=null;}};
o.prototype.onsapbackspace=function(a){var b=this.getSelectedTokens();var F=this.getTokens().filter(function(t){return t.getFocusDomRef()===document.activeElement;})[0];var i=b.length?b:[F];a.preventDefault();return this.fireTokenDelete({tokens:i,keyCode:a.which});};
o.prototype.onsapdelete=o.prototype.onsapbackspace;
o.prototype.onkeydown=function(a){var b;if(!this.getEnabled()){return;}if(a.which===K.TAB){this._changeAllTokensSelection(false);}if((a.ctrlKey||a.metaKey)&&a.which===K.A){b=this.getSelectedTokens().length<this._getVisibleTokens().length;if(this._getVisibleTokens().length>0){this.focus();this._changeAllTokensSelection(b);a.preventDefault();a.stopPropagation();}}if((a.ctrlKey||a.metaKey)&&(a.which===K.C||a.which===K.INSERT)){this._copy();}if(((a.ctrlKey||a.metaKey)&&a.which===K.X)||(a.shiftKey&&a.which===K.DELETE)){if(this.getEditable()){this._cut();}else{this._copy();}}};
o.prototype.onsappreviousmodifiers=function(a){this.onsapprevious(a);};
o.prototype.onsapnextmodifiers=function(a){this.onsapnext(a);};
o.prototype.onsaphomemodifiers=function(a){this._selectRange(false);};
o.prototype.onsapendmodifiers=function(a){this._selectRange(true);};
o.prototype._selectRange=function(F){var a={},t=this._getVisibleTokens(),b=q(document.activeElement).control()[0],p=t.indexOf(b);if(!b||!b.isA("sap.m.Token")){return;}if(F){a.start=p;a.end=t.length-1;}else{a.start=0;a.end=p;}if(a.start<a.end){for(var i=a.start;i<=a.end;i++){t[i].setSelected(true);}}};
o.prototype._copy=function(){this._fillClipboard("copy");};
o.prototype._fillClipboard=function(a){var b=this.getSelectedTokens();var t=b.map(function(p){return p.getText();}).join("\r\n");var i=function(p){if(p.clipboardData){p.clipboardData.setData('text/plain',t);}else{p.originalEvent.clipboardData.setData('text/plain',t);}p.preventDefault();};document.addEventListener(a,i);document.execCommand(a);document.removeEventListener(a,i);};
o.prototype._cut=function(){var a=this.getSelectedTokens();this._fillClipboard("cut");this.fireTokenChange({type:sap.m.Tokenizer.TokenChangeType.Removed,token:a,tokens:a,addedTokens:[],removedTokens:a});this.fireTokenUpdate({type:sap.m.Tokenizer.TokenChangeType.Removed,addedTokens:[],removedTokens:a});this.fireTokenDelete({tokens:a});};
o.prototype._ensureTokenVisible=function(t){if(!t||!t.getDomRef()||!this.getDomRef()){return;}var i=this.$().offset().left,a=this.$().width(),b=t.$().offset().left,p=C.getConfiguration().getRTL(),u=p?parseInt(t.$().css("margin-left")):parseInt(t.$().css("margin-right")),v=parseInt(t.$().css("border-left-width"))+parseInt(t.$().css("border-right-width")),w=t.$().width()+u+v,x=p?this.$().scrollLeftRTL():this.$().scrollLeft(),y=x-i+b,z=x+(b-i+w-a);if(this._getVisibleTokens().indexOf(t)===0){this.$().scrollLeft(0);return;}if(b<i){p?this.$().scrollLeftRTL(y):this.$().scrollLeft(y);}if(b-i+w>a){p?this.$().scrollLeftRTL(z):this.$().scrollLeft(z);}};
o.prototype.ontap=function(a){var b=a.shiftKey,p=(a.ctrlKey||a.metaKey),t=a.getMark("tokenTap"),u=a.getMark("tokenDeletePress"),v=this._getVisibleTokens(),F,w,x,M,y;if(u||!t||(!b&&p)){this._oSelectionOrigin=null;return;}if(!b){this._oSelectionOrigin=t;this._changeAllTokensSelection(false,t,true);}F=t;if(this._oSelectionOrigin){F=this._oSelectionOrigin;}else{this._oSelectionOrigin=F;}if(t&&this.hasOneTruncatedToken()){this._handleNMoreIndicatorPress();return;}w=this.indexOfToken(F);x=this.indexOfToken(t);M=Math.min(w,x);y=Math.max(w,x);v.forEach(function(z,i){if(i>=M&&i<=y){z.setSelected(true);}else if(!p){z.setSelected(false);}});};
o.prototype.onsapprevious=function(a){var t=this._getVisibleTokens(),i=t.length;if(i===0){return;}var F=q(document.activeElement).control()[0];var b=F?t.indexOf(F):-1;if(b===0){a.setMarked("forwardFocusToParent");return;}var p,u;if(b>0){p=t[b-1];this._ensureTokenVisible(p);p.focus();}else{p=t[t.length-1];this._ensureTokenVisible(p);p.focus({preventScroll:true});}if(a.shiftKey){u=t[b];p.setSelected(true);u.setSelected(true);}a.setMarked();a.preventDefault();};
o.prototype.onsapnext=function(a){var t=this._getVisibleTokens(),i=t.length;if(i===0){return;}var F=q(document.activeElement).control()[0];var b=F?t.indexOf(F):-1;var N=t[b+1];this._ensureTokenVisible(N);if(b<i-1){var p=t[b];N.focus();if(a.shiftKey){N.setSelected(true);p.setSelected(true);}}else{a.setMarked("forwardFocusToParent");return;}a.setMarked();a.preventDefault();};
o.prototype.addValidator=function(v){g.warning("[Warning]:","You are attempting to use deprecated method 'addValidator()', please use MultiInput.prototype.addValidator instead.",this);};
o.prototype.removeValidator=function(v){g.warning("[Warning]:","You are attempting to use deprecated method 'addValidator()', please use MultiInput.prototype.addValidator instead.",this);};
o.prototype.removeAllValidators=function(){g.warning("[Warning]:","You are attempting to use deprecated method 'addValidator()', please use MultiInput.prototype.addValidator instead.",this);};
o.prototype.addValidateToken=function(p){g.warning("[Warning]:","You are attempting to use deprecated method 'addValidator()', please use MultiInput.prototype.addValidator instead.",this);};
o.prototype._parseString=function(a){return a.split(/\r\n|\r|\n/g);};
o.prototype._checkFocus=function(){return this.getDomRef()&&f(this.getDomRef(),document.activeElement);};
o.prototype.selectAllTokens=function(b){if(b===undefined){b=true;}this._changeAllTokensSelection(b);return this;};
o.prototype._changeAllTokensSelection=function(b,t,a){var i=this._getVisibleTokens();i.filter(function(p){return p!==t;}).forEach(function(p){p.setSelected(b);});if(!a){this._doSelect();}return this;};
o.prototype.getSelectedTokens=function(){return this._getVisibleTokens().filter(function(t){return t.getSelected();});};
o.prototype.onsaphome=function(a){var A=this.getTokens().filter(function(t){return t.getDomRef()&&!t.getDomRef().classList.contains("sapMHiddenToken");});A.length&&A[0].focus();this.scrollToStart();a.preventDefault();};
o.prototype.onsapend=function(a){var t=this._getVisibleTokens(),b=t[t.length-1];if(b.getDomRef()!==document.activeElement){b.focus();this.scrollToEnd();a.stopPropagation();}else{a.setMarked("forwardFocusToParent");}a.preventDefault();};
o.prototype.onclick=function(a){var F;if(!this.getEnabled()){return;}F=!this.hasStyleClass("sapMTokenizerIndicatorDisabled")&&a.target.classList.contains("sapMTokenizerIndicator");if(F){this._handleNMoreIndicatorPress();}};
o.prototype.ontouchstart=function(a){a.setMarked();if(D.browser.chrome&&window.getSelection()){window.getSelection().removeAllRanges();}};
o.prototype.exit=function(){this._deregisterResizeHandler();if(this._oTokensList){this._oTokensList.destroy();this._oTokensList=null;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._oPopup){this._oPopup.destroy();this._oPopup=null;}this._oTokensWidthMap=null;this._oIndicator=null;this._aTokenValidators=null;};
o.prototype._deregisterResizeHandler=function(){if(this._sResizeHandlerId){e.deregister(this._sResizeHandlerId);delete this._sResizeHandlerId;}};
o.prototype._setTokensAria=function(){var t=this._getVisibleTokens().length;var i;var a="";var b="";var p={0:"TOKENIZER_ARIA_NO_TOKENS",1:"TOKENIZER_ARIA_CONTAIN_ONE_TOKEN"};if(C.getConfiguration().getAccessibility()){i=this.getAggregation("_tokensInfo");b=p[t]?p[t]:"TOKENIZER_ARIA_CONTAIN_SEVERAL_TOKENS";a=r.getText(b,t);i.setText(a);}};
o.prototype._doSelect=function(){if(this._checkFocus()&&this._bCopyToClipboardSupport){var F=document.activeElement;var a=window.getSelection();a.removeAllRanges();if(this.getSelectedTokens().length){var b=document.createRange();b.selectNodeContents(this.getDomRef("clip"));a.addRange(b);}if(window.clipboardData&&F.id===this.getId()+"-clip"&&this.getDomRef()){this.getDomRef().focus();}}};
o.prototype._setHiddenTokensCount=function(i){i=this.validateProperty("hiddenTokensCount",i);return this.setProperty("hiddenTokensCount",i);};
o.prototype.getHiddenTokensCount=function(){return this.getProperty("hiddenTokensCount");};
o.prototype.getTokensInfoId=function(){return this.getAggregation("_tokensInfo").getId();};
o.prototype._handleBackspace=function(i,F){var t=this.getTokens();if(t[i-1]){return t[i-1].focus();}return F();};
o.prototype._handleDelete=function(i,F){var t=this.getTokens();if(t[i+1]){return t[i+1].focus();}return F();};
o.prototype.focusToken=function(i,O,F){var t=this.getTokens();var b=O.keyCode;var a=O.keyCode===K.BACKSPACE;if(t.length===0){return;}if(!b){return;}if(a){return this._handleBackspace(i,F);}return this._handleDelete(i,F);};
o.TokenChangeType={Added:"added",Removed:"removed",RemovedAll:"removedAll",TokensChanged:"tokensChanged"};o.TokenUpdateType={Added:"added",Removed:"removed"};return o;});
sap.ui.predefine('sap/m/TokenizerRenderer',['sap/ui/Device','sap/ui/core/InvisibleText'],function(D,I){"use strict";var T={apiVersion:2};
T.render=function(r,c){if(c.getParent()&&(c.getParent()instanceof sap.m.MultiInput||c.getParent()instanceof sap.m.MultiComboBox)){r.openStart("div",c);}else{r.openStart("div",c).attr("tabindex","0");}r.class("sapMTokenizer");if(!c.getEditable()){r.class("sapMTokenizerReadonly");}if(!c.getEnabled()){r.class("sapMTokenizerDisabled");}var t=c.getTokens();if(!t.length){r.class("sapMTokenizerEmpty");r.attr("aria-hidden","true");}r.style("max-width",c.getMaxWidth());var p=c.getWidth();if(p){r.style("width",p);}var a={role:"listbox"};a.labelledby={value:I.getStaticId("sap.m","TOKENIZER_ARIA_LABEL"),append:true};r.accessibilityState(c,a);r.openEnd();r.renderControl(c.getAggregation("_tokensInfo"));c._bCopyToClipboardSupport=false;if((D.system.desktop||D.system.combi)&&t.length){r.openStart("div",c.getId()+"-clip").class("sapMTokenizerClip");if(window.clipboardData){r.attr("contenteditable","true");r.attr("tabindex","-1");}r.openEnd();r.unsafeHtml("&nbsp");r.close("div");c._bCopyToClipboardSupport=true;}r.openStart("div",c.getId()+"-scrollContainer");r.class("sapMTokenizerScrollContainer");if(c.getHiddenTokensCount()===c.getTokens().length){r.class("sapMTokenizerScrollContainerNoVisibleTokens");}r.openEnd();T._renderTokens(r,c);r.close("div");T._renderIndicator(r,c);r.close("div");};
T._renderTokens=function(r,c){var i=0,t=c.getTokens(),l=t.length;for(i=0;i<l;i++){r.renderControl(t[i]);}};
T._renderIndicator=function(r,c){r.openStart("span");r.class("sapMTokenizerIndicator");if(c.getHiddenTokensCount()===0){r.class("sapUiHidden");}r.openEnd().close("span");};
return T;},true);
sap.ui.predefine('sap/m/Toolbar',['./BarInPageEnabler','./ToolbarLayoutData','./ToolbarSpacer','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator',"sap/ui/events/KeyCodes",'./ToolbarRenderer',"sap/ui/core/library"],function(B,T,a,l,C,E,K,b,c){"use strict";var d=l.ToolbarDesign,e=l.ToolbarStyle;
var f=C.extend("sap.m.Toolbar",{metadata:{interfaces:["sap.ui.core.Toolbar","sap.m.IBar"],library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},active:{type:"boolean",group:"Behavior",defaultValue:false},enabled:{type:"boolean",group:"Behavior",defaultValue:true},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:''},design:{type:"sap.m.ToolbarDesign",group:"Appearance",defaultValue:d.Auto},style:{type:"sap.m.ToolbarStyle",group:"Appearance",defaultValue:e.Standard},ariaHasPopup:{type:"string",group:"Accessibility",defaultValue:null}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{parameters:{srcControl:{type:"sap.ui.core.Control"}}}},designtime:"sap/m/designtime/Toolbar.designtime"}});
E.call(f.prototype);f.shrinkClass="sapMTBShrinkItem";
f.isRelativeWidth=function(w){return/^([-+]?\d+%|auto|inherit|)$/i.test(w);};
f.getOrigWidth=function(i){var o=sap.ui.getCore().byId(i);if(!o||!o.getWidth){return"";}return o.getWidth();};
f.checkShrinkable=function(o,s){if(o instanceof a){return this.isRelativeWidth(o.getWidth());}s=s||this.shrinkClass;o.removeStyleClass(s);var w=this.getOrigWidth(o.getId());if(!this.isRelativeWidth(w)){return;}var L=o.getLayoutData();if(L instanceof T){return L.getShrinkable()&&o.addStyleClass(s);}if(w.indexOf("%")>0||o.getMetadata().isInstanceOf("sap.ui.core.IShrinkable")){return o.addStyleClass(s);}var D=o.getDomRef();if(D&&(D.firstChild||{}).nodeType==3){return o.addStyleClass(s);}};
f.prototype._setEnableAccessibilty=function(g){var F=g?"true":"false",r=g?"toolbar":"none";this.data("sap-ui-fastnavgroup",F,g);this._setRootAccessibilityRole(r);return this;};
f.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);this._oContentDelegate={onAfterRendering:this._onAfterContentRendering};};
f.prototype.onAfterRendering=function(){this._checkContents();};
f.prototype.onLayoutDataChange=function(){this.rerender();};
f.prototype.addContent=function(o){this.addAggregation("content",o);this._onContentInserted(o);return this;};
f.prototype.insertContent=function(o,i){this.insertAggregation("content",o,i);this._onContentInserted(o);return this;};
f.prototype.removeContent=function(v){v=this.removeAggregation("content",v);this._onContentRemoved(v);return v;};
f.prototype.removeAllContent=function(){var g=this.removeAllAggregation("content")||[];g.forEach(this._onContentRemoved,this);return g;};
f.prototype.ontap=function(o){if(this.getActive()&&!o.isMarked()){o.setMarked();this.firePress({srcControl:o.srcControl});}};
f.prototype.onsapenter=function(o){if(this.getActive()&&o.srcControl===this&&!o.isMarked()){o.setMarked();this.firePress({srcControl:this});}};
f.prototype.onsapspace=function(o){if(o.srcControl===this){o.preventDefault();}};
f.prototype.onkeyup=function(o){if(o.which===K.SPACE){this.onsapenter(o);}};
f.prototype.ontouchstart=function(o){this.getActive()&&o.setMarked();};
f.prototype._checkContents=function(){this.getContent().forEach(function(o){f.checkShrinkable(o);});};
f.prototype._onContentInserted=function(o){if(o){o.attachEvent("_change",this._onContentPropertyChanged,this);o.addEventDelegate(this._oContentDelegate,o);}};
f.prototype._onContentRemoved=function(o){if(o){o.detachEvent("_change",this._onContentPropertyChanged,this);o.removeEventDelegate(this._oContentDelegate,o);}};
f.prototype._onAfterContentRendering=function(){var L=this.getLayoutData();if(L instanceof T){L.applyProperties();}};
f.prototype._onContentPropertyChanged=function(o){if(o.getParameter("name")!="width"){return;}var g=o.getSource();var p=g.getWidth().indexOf("%")>0;g.toggleStyleClass(f.shrinkClass,p);};
f.prototype._getAccessibilityRole=function(){var r=this._getRootAccessibilityRole();if(this.getActive()){r="button";}return r;};
f.prototype.setDesign=function(D,s){if(!s){return this.setProperty("design",D);}this._sAutoDesign=this.validateProperty("design",D);return this;};
f.prototype.getActiveDesign=function(){var D=this.getDesign();if(D!=d.Auto){return D;}return this._sAutoDesign||D;};
f.prototype.getTitleControl=function(){var g=sap.ui.require("sap/m/Title");if(!g){return;}var h=this.getContent();for(var i=0;i<h.length;i++){var o=h[i];if(o instanceof g&&o.getVisible()){return o;}}};
f.prototype.getTitleId=function(){var t=this.getTitleControl();return t?t.getId():"";};
f.prototype.isContextSensitive=B.prototype.isContextSensitive;f.prototype.setHTMLTag=B.prototype.setHTMLTag;f.prototype.getHTMLTag=B.prototype.getHTMLTag;f.prototype.applyTagAndContextClassFor=B.prototype.applyTagAndContextClassFor;f.prototype._applyContextClassFor=B.prototype._applyContextClassFor;f.prototype._applyTag=B.prototype._applyTag;f.prototype._getContextOptions=B.prototype._getContextOptions;f.prototype._setRootAccessibilityRole=B.prototype._setRootAccessibilityRole;f.prototype._getRootAccessibilityRole=B.prototype._getRootAccessibilityRole;f.prototype._setRootAriaLevel=B.prototype._setRootAriaLevel;f.prototype._getRootAriaLevel=B.prototype._getRootAriaLevel;return f;});
sap.ui.predefine('sap/m/ToolbarLayoutData',['./library','sap/ui/core/LayoutData'],function(l,L){"use strict";
var T=L.extend("sap.m.ToolbarLayoutData",{metadata:{library:"sap.m",properties:{shrinkable:{type:"boolean",group:"Behavior",defaultValue:false},minWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}}}});
T.prototype.getParentStyle=function(){var p=this.getParent();if(!p||!p.getDomRef){return{};}var d=p.getDomRef();return d?d.style:{};};
T.prototype.applyProperties=function(){var s=this.getParentStyle();s.minWidth=this.getMinWidth();s.maxWidth=this.getMaxWidth();return this;};
return T;});
sap.ui.predefine('sap/m/ToolbarRenderer',['./BarInPageEnabler'],function(B){"use strict";var T={apiVersion:2};T.render=B.prototype.render;
T.writeAccessibilityState=function(r,t){var a={role:t._getAccessibilityRole()};if(!t.getAriaLabelledBy().length){a.labelledby=t.getTitleId();}if(t.getActive()){a.haspopup=t.getAriaHasPopup();}if(t._sAriaRoleDescription){a.roledescription=t._sAriaRoleDescription;}r.accessibilityState(t,a);};
T.decorateRootElement=function(r,t){this.writeAccessibilityState(r,t);r.class("sapMTB");r.class("sapMTBNewFlex");if(t.getActive()){r.class("sapMTBActive");r.attr("tabindex","0");}else{r.class("sapMTBInactive");}r.class("sapMTB"+t.getStyle());r.class("sapMTB-"+t.getActiveDesign()+"-CTX");r.style("width",t.getWidth());r.style("height",t.getHeight());};
T.renderBarContent=function(r,t){t.getContent().forEach(function(c){B.addChildClassTo(c,t);r.renderControl(c);});};
T.shouldAddIBarContext=function(c){return false;};
return T;},true);
sap.ui.predefine('sap/m/ToolbarSeparator',['./library','sap/ui/core/Control','./ToolbarSeparatorRenderer'],function(l,C,T){"use strict";
var a=C.extend("sap.m.ToolbarSeparator",{metadata:{library:"sap.m",interfaces:["sap.m.IOverflowToolbarContent"]}});
a.CLASSNAME_OVERFLOW_TOOLBAR="sapMTBSeparatorOverflowToolbar";
a.prototype._onBeforeEnterOverflow=function(c){c.addStyleClass(a.CLASSNAME_OVERFLOW_TOOLBAR);};
a.prototype._onAfterExitOverflow=function(c){c.removeStyleClass(a.CLASSNAME_OVERFLOW_TOOLBAR);};
a.prototype.getOverflowToolbarConfig=function(){var c={canOverflow:true};c.onBeforeEnterOverflow=this._onBeforeEnterOverflow;c.onAfterExitOverflow=this._onAfterExitOverflow;return c;};
return a;});
sap.ui.predefine('sap/m/ToolbarSeparatorRenderer',[],function(){"use strict";var T={apiVersion:2};
T.render=function(r,c){r.openStart("div",c);r.class("sapMTBSeparator");r.accessibilityState(c,{role:"separator"});r.openEnd();r.close("div");};
return T;},true);
sap.ui.predefine('sap/m/ToolbarSpacer',['./library','sap/ui/core/Control','./ToolbarSpacerRenderer',"sap/base/Log"],function(l,C,T,L){"use strict";
var a=C.extend("sap.m.ToolbarSpacer",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:''}}}});
a.prototype.setLayoutData=function(o){if(o&&o.isA("sap.m.ToolbarLayoutData")){L.warning("sap.m.ToolbarLayoutData should not be set in the layoutData aggregation of sap.m.ToolbarSpacer");return this;}return this.setAggregation("layoutData",o);};
return a;});
sap.ui.predefine('sap/m/ToolbarSpacerRenderer',[],function(){"use strict";var T={apiVersion:2};T.flexClass="sapMTBSpacerFlex";
T.render=function(r,c){r.openStart("div",c);r.class("sapMTBSpacer");var w=c.getWidth();if(w){r.style("width",w);}else{r.class(T.flexClass);}r.openEnd().close("div");};
return T;},true);
sap.ui.predefine('sap/m/Tree',['./ListBase','./library','sap/ui/model/ClientTreeBindingAdapter','sap/ui/model/TreeBindingCompatibilityAdapter','./TreeRenderer',"sap/base/Log","sap/base/assert"],function(L,l,C,T,a,b,c){"use strict";
var d=L.extend("sap.m.Tree",{metadata:{library:"sap.m",events:{toggleOpenState:{parameters:{itemIndex:{type:"int"},itemContext:{type:"object"},expanded:{type:"boolean"}}}}}});
d.prototype.isTreeBinding=function(n){return(n=="items");};
d.prototype.getBinding=function(n){n=n||"items";var B=L.prototype.getBinding.call(this,n);if(B&&n==="items"&&!B.getLength){if(B.isA("sap.ui.model.odata.v2.ODataTreeBinding")){B.applyAdapterInterface();}else if(B.isA("sap.ui.model.ClientTreeBinding")){C.apply(B);}else if(B.isA("sap.ui.model.odata.ODataTreeBinding")){T(B,this);}else{b.error("TreeBinding is not supported for the "+this);}}return B;};
d.prototype.updateAggregation=function(n){if(n!="items"){return L.prototype.updateAggregation.apply(this,arguments);}var B=this.getBindingInfo("items"),o=this.getBinding("items"),f=B.factory,e;function u(g,e){var h=g.getItems()||[],j,k;if(h.length>e.length){for(var i=e.length;i<h.length;i++){g.removeItem(h[i]);h[i].destroy("KeepDom");}}for(var i=0;i<e.length;i++){j=e[i];k=h[i];if(k){k.setBindingContext(j,B.model);}else{k=f(g.getId()+"-"+i,j);k.setBindingContext(j,B.model);g.addItem(k);}}}e=o.getContexts(0);if(!B.template){this.destroyItems();}u(this,e);};
d.prototype.validateAggregation=function(A,o,m){var r=L.prototype.validateAggregation.apply(this,arguments);if(A==="items"&&!o.isA("sap.m.TreeItemBase")){throw new Error(o+" is not a valid items aggregation of "+this+". Items aggregation in Tree control only supports TreeItemBase-based objects, e.g. StandardTreeItem.");}return r;};
d.prototype.invalidate=function(){L.prototype.invalidate.apply(this,arguments);this._bInvalidated=true;};
d.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.apply(this,arguments);this._bInvalidated=false;};
d.prototype._updateDeepestLevel=function(i){if(i.getLevel()+1>this.getDeepestLevel()){this._iDeepestLevel=i.getLevel()+1;}};
d.prototype.onItemExpanderPressed=function(i,e){var I=this.indexOfItem(i);var B=this.getBindingInfo("items");var o=i&&i.getBindingContext(B.model);if(B&&o){var E=i.getExpanded();var f;this._updateDeepestLevel(i);var g=this.getBinding("items");if(e==undefined){g.toggleIndex(I);}else if(e){g.expand(I);}else{g.collapse(I);}f=g.isExpanded(I);if(E!==f&&!i.isLeaf()){this.fireToggleOpenState({itemIndex:I,itemContext:o,expanded:f});}}};
d.prototype.setGrowing=function(v){b.error("Growing feature of "+this+" is not supported!");return this;};
d.prototype.setGrowingThreshold=function(v){b.error("GrowingThreshold of "+this+" is not supported!");return this;};
d.prototype.setGrowingTriggerText=function(v){b.error("GrowingTriggerText of "+this+" is not supported!");return this;};
d.prototype.setGrowingScrollToLoad=function(v){b.error("GrowingScrollToLoad of "+this+" is not supported!");return this;};
d.prototype.setGrowingDirection=function(v){b.error("GrowingDirection of "+this+" is not supported!");return this;};
d.prototype.expandToLevel=function(i){var B=this.getBinding("items");c(B&&B.expandToLevel,"Tree.expandToLevel is not supported with your current Binding. Please check if you are running on an ODataModel V2.");if(B&&B.expandToLevel&&B.getNumberOfExpandedLevels){if(B.getNumberOfExpandedLevels()>i){B.collapseToLevel(0);}B.expandToLevel(i);}return this;};
d.prototype.getNumberOfExpandedLevel=function(){return this.getBinding("items").getNumberOfExpandedLevels();};
d.prototype.getDeepestLevel=function(){if(this._iDeepestLevel===undefined){this._iDeepestLevel=this.getNumberOfExpandedLevel();}return this._iDeepestLevel;};
d.prototype.collapseAll=function(){var B=this.getBinding("items");c(B&&B.expandToLevel,"Tree.collapseAll is not supported with your current Binding. Please check if you are running on an ODataModel V2.");if(B){B.collapseToLevel(0);}return this;};
d.prototype._sortHelper=function(p){var i=[];if(typeof p==="number"){i.push(p);}else if(Array.isArray(p)){i=p.sort().reverse();}return i;};
d.prototype._removeLeaf=function(s){var I=null,e,f=[];for(var i=0;i<s.length;i++){e=s[i];I=this.getItems()[e];if(I&&!I.isLeaf()){f.push(e);}}return f;};
d.prototype._preExpand=function(p){var i=this._sortHelper(p);i=this._removeLeaf(i);return i;};
d.prototype.expand=function(p){var B=this.getBinding("items");if(B&&B.expand){var I=this._preExpand(p),o;if(I.length>0){for(var i=0;i<I.length-1;i++){o=this.getItems()[I[i]];this._updateDeepestLevel(o);B.expand(I[i],true);}o=this.getItems()[I[I.length-1]];this._updateDeepestLevel(o);B.expand(I[I.length-1],false);}}return this;};
d.prototype.collapse=function(p){var B=this.getBinding("items");if(B&&B.collapse){var I=this._preExpand(p);for(var i=0;i<I.length-1;i++){B.collapse(I[i],true);}B.collapse(I[I.length-1],false);}return this;};
d.prototype.getAccessibilityType=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_TREE");};
d.prototype.getAccessbilityPosition=function(i){var s,p,n=i.getItemNodeContext();if(n.parent){s=n.parent.children.length;}if(n.positionInParent!=undefined){p=n.positionInParent+1;}return{setSize:s,posInset:p};};
d.prototype.onItemLongDragOver=function(i){var I=this.indexOfItem(i),B=this.getBinding("items"),o=this.getBindingInfo("items"),e=i&&i.getBindingContext(o.model);if(i){this._updateDeepestLevel(i);if(!i.isLeaf()){B.expand(I);this.fireToggleOpenState({itemIndex:I,itemContext:e,expanded:B.isExpanded(I)});}}};
d.prototype.isGrouped=function(){return false;};
return d;});
sap.ui.predefine('sap/m/TreeItemBase',['./ListItemBase','./library','sap/ui/core/IconPool','sap/ui/core/Icon','./TreeItemBaseRenderer','sap/ui/events/KeyCodes'],function(L,l,I,a,T,K){"use strict";var b=l.ListMode;
var c=L.extend("sap.m.TreeItemBase",{metadata:{library:"sap.m"}});
c.prototype.ExpandedIconURI=I.getIconURI("navigation-down-arrow");c.prototype.CollapsedIconURI=I.getIconURI("navigation-right-arrow");
c.prototype.getTree=function(){var p=this.getParent();if(p&&p.isA("sap.m.Tree")){return p;}};
c.prototype.getList=c.prototype.getTree;c.prototype.informTree=c.prototype.informList;
c.prototype.getItemNodeContext=function(){var t=this.getTree();var n=null;var B=t?t.getBinding("items"):null;if(t&&B){B=t.getBinding("items");n=B.getNodeByIndex(t.indexOfItem(this));}return n;};
c.prototype.getParentNode=function(){if(this.isTopLevel()){return;}var t=this.getTree(),n=this.getLevel(),p=null,i=t.indexOfItem(this)-1,d=t.getItems(),e;while(i>=0){e=d[i].getLevel();if(e===n-1){p=d[i];break;}i--;}return p;};
c.prototype.getParentNodeContext=function(){return this.getItemNodeContext().parent;};
c.prototype.isLeaf=function(){var t=this.getTree(),n=this.getItemNodeContext();return n?!t.getBinding("items").nodeHasChildren(n):false;};
c.prototype.isTopLevel=function(){return(this.getLevel()===0);};
c.prototype.getLevel=function(){return(this.getItemNodeContext()||{}).level;};
c.prototype.getExpanded=function(){var t=this.getTree();if(!t){return false;}var i=t.indexOfItem(this);var B=t.getBinding("items");return(B&&B.isExpanded(i));};
c.prototype.setSelected=function(s){L.prototype.setSelected.apply(this,arguments);var t=this.getTree();var B=t?t.getBinding("items"):null;var i=-1;if(t&&B){i=t.indexOfItem(this);if(t.getMode()===b.SingleSelect){B.setSelectedIndex(i);}if(t.getMode()===b.MultiSelect){if(s){B.addSelectionInterval(i,i);}else{B.removeSelectionInterval(i,i);}}}return this;};
c.prototype._getExpanderControl=function(){var s=this.CollapsedIconURI,B=sap.ui.getCore().getLibraryResourceBundle("sap.m"),i=B.getText("TREE_ITEM_EXPAND_NODE");if(this.getExpanded()){s=this.ExpandedIconURI;i=B.getText("TREE_ITEM_COLLAPSE_NODE");}if(this._oExpanderControl){this._oExpanderControl.setSrc(s);this._oExpanderControl.setTooltip(i);return this._oExpanderControl;}this._oExpanderControl=new a({id:this.getId()+"-expander",src:s,tooltip:i,noTabStop:true}).setParent(this,null,true).addStyleClass("sapMTreeItemBaseExpander").attachPress(function(e){this.informTree("ExpanderPressed");},this);return this._oExpanderControl;};
c.prototype.invalidate=function(){L.prototype.invalidate.apply(this,arguments);this._bInvalidated=true;};
c.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.apply(this,arguments);this._bInvalidated=false;};
c.prototype.setBindingContext=function(){L.prototype.setBindingContext.apply(this,arguments);this.invalidate();return this;};
c.prototype._getPadding=function(){var t=this.getTree(),n=this.getLevel(),i=0,d;if(t){d=t.getDeepestLevel();}if(d<n){t._iDeepestLevel=n;d=t._iDeepestLevel;}if(d<2){i=n*1.5;}else if(d===2){i=n*1;}else if(d<6){i=n*0.5;}else{i=n*0.25;}return i;};
c.prototype.onsapplus=function(e){this.informTree("ExpanderPressed",true);};
c.prototype.onsapminus=function(e){this.informTree("ExpanderPressed",false);};
c.prototype.onsapright=function(e){if(e.srcControl!==this||this.isLeaf()){return;}if(!this.getExpanded()){this.informTree("ExpanderPressed",true);}else{e.keyCode=K.ARROW_DOWN;}};
c.prototype.onsapleft=function(e){if(e.srcControl!==this||this.isTopLevel()&&!this.getExpanded()){return;}if(!this.isLeaf()){if(this.getExpanded()){this.informTree("ExpanderPressed",false);}else{this.getParentNode().focus();}}else{this.getParentNode().focus();}};
c.prototype.onsapbackspace=function(e){if(e.srcControl!==this){return;}if(!this.isTopLevel()){this.getParentNode().focus();}};
c.prototype.getAccessibilityType=function(B){return B.getText("ACC_CTR_TYPE_TREEITEM");};
c.prototype.exit=function(){L.prototype.exit.apply(this,arguments);this.destroyControls(["Expander"]);};
c.prototype.onlongdragover=function(e){this.informTree("LongDragOver");};
return c;});
sap.ui.predefine('sap/m/TreeItemBaseRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer"],function(L,R){"use strict";var T=R.extend(L);T.apiVersion=2;
T.renderLIAttributes=function(r,l){r.class("sapMTreeItemBase");if(!l.isTopLevel()){r.class("sapMTreeItemBaseChildren");}if(l.isLeaf()){r.class("sapMTreeItemBaseLeaf");}else{r.attr("aria-expanded",l.getExpanded());}var i=l._getPadding();if(sap.ui.getCore().getConfiguration().getRTL()){r.style("padding-right",i+"rem");}else{r.style("padding-left",i+"rem");}};
T.renderContentFormer=function(r,l){this.renderHighlight(r,l);this.renderExpander(r,l);this.renderMode(r,l,-1);};
T.renderExpander=function(r,l){var e=l._getExpanderControl();if(e){r.renderControl(e);}};
T.getAriaRole=function(l){return"treeitem";};
T.getAccessibilityState=function(l){var a=L.getAccessibilityState.call(this,l);a.level=l.getLevel()+1;if(!l.isLeaf()){a.expanded=l.getExpanded();}return a;};
return T;},true);
sap.ui.predefine('sap/m/TreeRenderer',['sap/ui/core/Renderer','./ListBaseRenderer'],function(R,L){"use strict";var T=R.extend(L);T.apiVersion=2;
T.getAriaRole=function(c){return"tree";};
return T;},true);
sap.ui.predefine('sap/m/UploadCollection',["./library","sap/m/library","sap/m/MessageBox","sap/m/Dialog","sap/ui/core/Control","sap/ui/core/Icon","sap/ui/core/IconPool","sap/m/Image","sap/m/Text","sap/m/Title","sap/m/Button","sap/m/List","sap/m/BusyIndicator","sap/m/StandardListItem","sap/ui/unified/FileUploaderParameter","sap/ui/unified/FileUploader","sap/ui/core/format/FileSizeFormat","sap/m/OverflowToolbar","sap/m/ToolbarSpacer","sap/m/ObjectAttribute","sap/m/UploadCollectionItem","sap/m/UploadCollectionParameter","sap/m/UploadCollectionToolbarPlaceholder","sap/ui/core/HTML","sap/m/CustomListItem","sap/ui/core/ResizeHandler","sap/ui/Device","./UploadCollectionRenderer","sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/dom/jquery/selectText"],function(L,M,a,D,C,I,b,c,T,d,B,f,g,S,F,h,k,O,l,m,U,n,o,H,p,R,q,r,Q,K,s){"use strict";
var t=C.extend("sap.m.UploadCollection",{
constructor:function(i,j){var u;if(j&&j.instantUpload!==undefined){if(j.instantUpload===false){u=j.instantUpload;}delete j.instantUpload;}else if(i&&i.instantUpload!==undefined){if(i.instantUpload===false){u=i.instantUpload;}delete i.instantUpload;}if(j&&j.mode===L.ListMode.MultiSelect&&u===false){j.mode=L.ListMode.None;s.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Upload Pending scenario. Value has been resetted to 'None'");}else if(i&&i.mode===L.ListMode.MultiSelect&&u===false){i.mode=L.ListMode.None;s.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Upload Pending scenario. Value has been resetted to 'None'");}try{C.apply(this,arguments);if(u===false){this.bInstantUpload=u;this._oFormatDecimal=k.getInstance({binaryFilesize:true,maxFractionDigits:1,maxIntegerDigits:4});}}catch(e){this.destroy();throw e;}},
metadata:{library:"sap.m",properties:{fileType:{type:"string[]",group:"Data",defaultValue:null},maximumFilenameLength:{type:"int",group:"Data",defaultValue:null},maximumFileSize:{type:"float",group:"Data",defaultValue:null},mimeType:{type:"string[]",group:"Data",defaultValue:null},multiple:{type:"boolean",group:"Behavior",defaultValue:false},noDataText:{type:"string",group:"Appearance",defaultValue:null},noDataDescription:{type:"string",group:"Appearance",defaultValue:null},sameFilenameAllowed:{type:"boolean",group:"Behavior",defaultValue:false},showSeparators:{type:"sap.m.ListSeparators",group:"Appearance",defaultValue:"All"},uploadEnabled:{type:"boolean",group:"Behavior",defaultValue:true},uploadUrl:{type:"string",group:"Data",defaultValue:"../../../upload"},instantUpload:{type:"boolean",group:"Behavior",defaultValue:true},numberOfAttachmentsText:{type:"string",group:"Appearance",defaultValue:null},mode:{type:"sap.m.ListMode",group:"Behavior",defaultValue:"None"},uploadButtonInvisible:{type:"boolean",group:"Appearance",defaultValue:false},terminationEnabled:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.UploadCollectionItem",multiple:true,singularName:"item",bindable:"bindable"},headerParameters:{type:"sap.m.UploadCollectionParameter",multiple:true,singularName:"headerParameter"},parameters:{type:"sap.m.UploadCollectionParameter",multiple:true,singularName:"parameter"},toolbar:{type:"sap.m.OverflowToolbar",multiple:false},infoToolbar:{type:"sap.m.Toolbar",multiple:false,forwarding:{idSuffix:"-list",aggregation:"infoToolbar"}},_list:{type:"sap.m.List",multiple:false,visibility:"hidden"},_noDataIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_dragDropIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_dragDropText:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{change:{parameters:{documentId:{type:"string"},files:{type:"object[]"}}},fileDeleted:{parameters:{documentId:{type:"string"},item:{type:"sap.m.UploadCollectionItem"}}},filenameLengthExceed:{parameters:{documentId:{type:"string"},files:{type:"object[]"}}},fileRenamed:{parameters:{documentId:{type:"string"},fileName:{type:"string"},item:{type:"sap.m.UploadCollectionItem"}}},fileSizeExceed:{parameters:{documentId:{type:"string"},fileSize:{type:"string"},files:{type:"object[]"}}},typeMissmatch:{parameters:{documentId:{type:"string"},fileType:{type:"string"},mimeType:{type:"string"},files:{type:"object[]"}}},uploadComplete:{parameters:{readyStateXHR:{type:"string"},response:{type:"string"},status:{type:"string"},files:{type:"object[]"}}},uploadTerminated:{parameters:{fileName:{type:"string"},getHeaderParameter:{type:"function",parameters:{headerParameterName:{type:"string"}}}}},beforeUploadStarts:{parameters:{fileName:{type:"string"},addHeaderParameter:{type:"function",parameters:{headerParameter:{type:"sap.m.UploadCollectionParameter"}}},getHeaderParameter:{type:"function",parameters:{headerParameterName:{type:"string"}}}}},selectionChange:{parameters:{selectedItem:{type:"sap.m.UploadCollectionItem"},selectedItems:{type:"sap.m.UploadCollectionItem[]"},selected:{type:"boolean"}}}}}
});
t._uploadingStatus="uploading";t._displayStatus="display";t._toBeDeletedStatus="toBeDeleted";t._pendingUploadStatus="pendingUploadStatus";t._placeholderCamera="sap-icon://card";t._markerMargin=8;if(q.system.phone){t._resizeTimeoutInterval=500;}else{t._resizeTimeoutInterval=100;}
t.prototype.init=function(){t.prototype._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._headerParamConst={requestIdName:"requestId"+Q.now(),fileNameRequestIdName:"fileNameRequestId"+Q.now(),acceptLanguage:"accept-language"};this._requestIdValue=0;this._iFUCounter=0;var N=this.getNoDataText()+" "+this.getNoDataDescription();this._oList=new f(this.getId()+"-list",{selectionChange:[this._handleSelectionChange,this],noDataText:N});this.setAggregation("_list",this._oList,true);this._oList.addStyleClass("sapMUCList");this.setAggregation("_noDataIcon",new I(this.getId()+"-no-data-icon",{src:"sap-icon://document",size:"6rem",noTabStop:true}),true);this.setAggregation("_dragDropIcon",new I(this.getId()+"-drag-drop-icon",{src:"sap-icon://upload-to-cloud",size:"4rem",noTabStop:true}),true);this.setAggregation("_dragDropText",new T(this.getId()+"-drag-drop-text",{text:this._oRb.getText("UPLOADCOLLECTION_DRAG_FILE_INDICATOR")}),true);this._iUploadStartCallCounter=0;this.aItems=[];this._aDeletedItemForPendingUpload=[];this._aFileUploadersForPendingUpload=[];this._aFilesFromDragAndDropForPendingUpload=[];this._iFileUploaderPH=null;this._oListEventDelegate=null;this._oItemToUpdate=null;this._sReziseHandlerId=null;this.oInvisibleText=new sap.ui.core.InvisibleText().toStatic();};
t.prototype.setFileType=function(e){if(!e){return this;}if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change fileType at runtime.");}else{var j=e.length;for(var i=0;i<j;i++){e[i]=e[i].toLowerCase();}if(this.getFileType()!==e){this.setProperty("fileType",e,true);this._getFileUploader().setFileType(e);}}return this;};
t.prototype.setMaximumFilenameLength=function(i){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change maximumFilenameLength at runtime.");}else if(this.getMaximumFilenameLength()!==i){this.setProperty("maximumFilenameLength",i,true);this._getFileUploader().setMaximumFilenameLength(i);}return this;};
t.prototype.setMaximumFileSize=function(i){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change maximumFileSize at runtime.");}else if(this.getMaximumFileSize()!==i){this.setProperty("maximumFileSize",i,true);this._getFileUploader().setMaximumFileSize(i);}return this;};
t.prototype.setMimeType=function(e){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change mimeType at runtime.");}else if(this.getMimeType()!==e){this.setProperty("mimeType",e,true);this._getFileUploader().setMimeType(e);}return this;};
t.prototype.setMultiple=function(e){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change multiple at runtime.");}else if(this.getMultiple()!==e){this.setProperty("multiple",e);this._getFileUploader().setMultiple(e);}return this;};
t.prototype.setShowSeparators=function(e){if(this.getShowSeparators()!==e){this.setProperty("showSeparators",e);this._oList.setShowSeparators(e);}return this;};
t.prototype.setUploadEnabled=function(u){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change uploadEnabled at runtime.");}else if(this.getUploadEnabled()!==u){this.setProperty("uploadEnabled",u);this._getFileUploader().setEnabled(u);}return this;};
t.prototype.setUploadUrl=function(u){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change uploadUrl at runtime.");}else if(this.getUploadUrl()!==u){this.setProperty("uploadUrl",u);this._getFileUploader().setUploadUrl(u);}return this;};
t.prototype.setInstantUpload=function(){s.error("It is not supported to change the behavior at runtime.");return this;};
t.prototype.setMode=function(e){if(e===L.ListMode.Delete){this._oList.setMode(L.ListMode.None);s.info("sap.m.ListMode.Delete is not supported by UploadCollection. Value has been resetted to 'None'");}else if(e===L.ListMode.MultiSelect&&!this.getInstantUpload()){this._oList.setMode(L.ListMode.None);s.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Pending Upload. Value has been resetted to 'None'");}else{this._oList.setMode(e);}return this;};
t.prototype.getMode=function(){return this._oList.getMode();};
t.prototype.getToolbar=function(){return this._oHeaderToolbar;};
t.prototype.getNoDataText=function(){var N=this.getProperty("noDataText");N=N||this._oRb.getText("UPLOADCOLLECTION_NO_DATA_TEXT");return N;};
t.prototype.getNoDataDescription=function(){var N=this.getProperty("noDataDescription");N=N||this._oRb.getText("UPLOADCOLLECTION_NO_DATA_DESCRIPTION");return N;};
t.prototype.setNoDataText=function(N){this.setProperty("noDataText",N,true);this.$().find("#"+this.getId()+"-no-data-text").text(N);var e=N+" "+this.getNoDataDescription();this._oList.setNoDataText(e);return this;};
t.prototype.setNoDataDescription=function(N){this.setProperty("noDataDescription",N,true);var e=this.getNoDataText()+" "+N;this._oList.setNoDataText(e);if(this.getUploadEnabled()&&this._oList.getItems().length==0){this.rerender();}return this;};
t.prototype.setUploadButtonInvisible=function(u){if(this.getUploadButtonInvisible()===u){return this;}this.setProperty("uploadButtonInvisible",u,true);if(this.getInstantUpload()){this._getFileUploader().setVisible(!u);}else{this._setFileUploaderVisibility(u);}if(this._bDragDropEnabled){this._unbindDragEnterLeave();this._bDragDropEnabled=false;}else{this._bindDragEnterLeave();}return this;};
t.prototype.getInternalRequestHeaderNames=function(){return[this._headerParamConst.fileNameRequestIdName,this._headerParamConst.requestIdName];};
t.prototype.upload=function(){if(this.getInstantUpload()){s.error("Not a valid API call. 'instantUpload' should be set to 'false'.");}var e=this._aFileUploadersForPendingUpload.length;for(var i=0;i<e;i++){this._iUploadStartCallCounter=0;if(this._aFileUploadersForPendingUpload[i].getValue()){this._aFileUploadersForPendingUpload[i].upload();}}if(this._aFilesFromDragAndDropForPendingUpload.length>0){this._oFileUploader._sendFilesFromDragAndDrop(this._aFilesFromDragAndDropForPendingUpload);this._aFilesFromDragAndDropForPendingUpload=[];}};
t.prototype.getSelectedItems=function(){var e=this._oList.getSelectedItems();return this._getUploadCollectionItemsByListItems(e);};
t.prototype.getSelectedItem=function(){var e=this._oList.getSelectedItem();if(e){return this._getUploadCollectionItemByListItem(e);}return null;};
t.prototype.setSelectedItemById=function(i,e){this._oList.setSelectedItemById(i+"-cli",e);this._setSelectedForItems([this._getUploadCollectionItemById(i)],e);return this;};
t.prototype.setSelectedItem=function(u,e){return this.setSelectedItemById(u.getId(),e);};
t.prototype.selectAll=function(){var e=this._oList.selectAll();if(e.getItems().length!==this.getItems().length){s.info("Internal 'List' and external 'UploadCollection' are not in sync.");}this._setSelectedForItems(this.getItems(),true);return this;};
t.prototype.downloadItem=function(u,e){if(!this.getInstantUpload()){s.info("Download is not possible on Pending Upload mode");return false;}else{return u.download(e);}};
t.prototype.openFileDialog=function(i){if(this._oFileUploader){if(i){if(!this._oFileUploader.getMultiple()){this._oItemToUpdate=i;this._oFileUploader.$().find("input[type=file]").trigger("click");}else{s.warning("Version Upload cannot be used in multiple upload mode");}}else{this._oFileUploader.$().find("input[type=file]").trigger("click");}}return this;};
t.prototype.removeAggregation=function(A,v,e){var i,j,u;if(!this.getInstantUpload()&&A==="items"&&v){i=v._internalFileIdWithinDragDropArray;if(i){j=this._aFilesFromDragAndDropForPendingUpload.indexOf(i);if(j!==-1){this._aFilesFromDragAndDropForPendingUpload.splice(j,1);}}else if(typeof v==="number"){u=this.getItems();this._aDeletedItemForPendingUpload.push(u[v]);}else{this._aDeletedItemForPendingUpload.push(v);}}return C.prototype.removeAggregation.apply(this,arguments);};
t.prototype.removeAllAggregation=function(A,e){if(!this.getInstantUpload()&&A==="items"){if(this._aFileUploadersForPendingUpload){for(var i=0;i<this._aFileUploadersForPendingUpload.length;i++){this._aFileUploadersForPendingUpload[i].destroy();this._aFileUploadersForPendingUpload[i]=null;}this._aFileUploadersForPendingUpload=[];}}return C.prototype.removeAllAggregation.apply(this,arguments);};
t.prototype.onBeforeRendering=function(){this._RenderManager=this._RenderManager||sap.ui.getCore().createRenderManager();var i,e;if(this._oListEventDelegate){this._oList.removeEventDelegate(this._oListEventDelegate);this._oListEventDelegate=null;}this._deregisterSizeHandler();this._unbindDragEnterLeave();j.bind(this)();if(!this.getInstantUpload()){this.aItems=this.getItems();this._getListHeader(this.aItems.length);this._clearList();this._fillList(this.aItems);this._oList.setHeaderToolbar(this._oHeaderToolbar);return;}if(this.aItems.length>0){e=this.aItems.length;var u=[];for(i=0;i<e;i++){if(this.aItems[i]&&this.aItems[i]._status===t._uploadingStatus){u.push(this.aItems[i]);}else if(this.aItems[i]&&this.aItems[i]._status!==t._uploadingStatus&&this.aItems[i]._percentUploaded===100&&this.getItems().length===0){u.push(this.aItems[i]);}}if(u.length!==0){this.aItems=[];this.aItems=this.getItems();this.aItems=u.concat(this.aItems);}else{this.aItems=this.getItems();}}else{this.aItems=this.getItems();}this._getListHeader(this.aItems.length);this._clearList();this._fillList(this.aItems);this._oList.setAggregation("headerToolbar",this._oHeaderToolbar,true);if(this.sErrorState!=="Error"){if(this.getUploadEnabled()!==this._oFileUploader.getEnabled()){this._oFileUploader.setEnabled(this.getUploadEnabled());}}else{this._oFileUploader.setEnabled(false);}if(this.sDeletedItemId){Q(document.activeElement).trigger("blur");}function j(){if(this.bInstantUpload===false){this.setProperty("instantUpload",this.bInstantUpload,true);delete this.bInstantUpload;}}};
t.prototype.onAfterRendering=function(){this._bindDragEnterLeave();if(this.getInstantUpload()){if(this.aItems||(this.aItems===this.getItems())){if(this.editModeItem){var $=Q(document.getElementById(this.editModeItem+"-ta_editFileName-inner"));if($){var i=this.editModeItem;if(!q.os.ios){$.on("focus",function(){$.selectText(0,$.val().length);});}$.trigger("focus");this.oInvisibleText.setText("");sap.ui.getCore().byId(this.editModeItem+"-cli").removeAllAriaLabelledBy();sap.ui.getCore().byId(this.editModeItem+"-cli").addAriaLabelledBy(this.oInvisibleText.getId());this._oListEventDelegate={onclick:function(e){this._handleClick(e,i);}.bind(this)};this._oList.addDelegate(this._oListEventDelegate);}}else if(this.sFocusId){this._setFocusToLineItem(this.sFocusId);this.sFocusId=null;}else if(this.sDeletedItemId){this._setFocusAfterDeletion();}}}else if(this.sFocusId){this._setFocusToLineItem(this.sFocusId);this.sFocusId=null;}};
t.prototype.exit=function(){var i,P,e;this._unbindDragEnterLeave();if(this._$RootNode){this._$RootNode=null;}if(this._oFileUploader){this._oFileUploader.destroy();this._oFileUploader=null;}if(this._oHeaderToolbar){this._oHeaderToolbar.destroy();this._oHeaderToolbar=null;}if(this._oNumberOfAttachmentsTitle){this._oNumberOfAttachmentsTitle.destroy();this._oNumberOfAttachmentsTitle=null;}if(this._RenderManager){this._RenderManager.destroy();}if(this._aFileUploadersForPendingUpload){P=this._aFileUploadersForPendingUpload.length;for(i=0;i<P;i++){this._aFileUploadersForPendingUpload[i].destroy();this._aFileUploadersForPendingUpload[i]=null;}this._aFileUploadersForPendingUpload=null;}if(this.aItems&&this.aItems.length>0){for(i=0;i<this.aItems.length;i++){if(this.aItems[i]._status===t._uploadingStatus){e=this.aItems.splice(i,1)[0];if(e.destroy){e.destroy();}}}}this._deregisterSizeHandler();if(this.oInvisibleText){this.oInvisibleText.destroy();}};
t.prototype._bindDragEnterLeave=function(){this._bDragDropEnabled=this._isDragAndDropAllowed();if(!this._bDragDropEnabled){return;}if(!this._oDragDropHandler){this._oDragDropHandler={dragEnterUIArea:this._onDragEnterUIArea.bind(this),dragLeaveUIArea:this._onDragLeaveUIArea.bind(this),dragOverUIArea:this._onDragOverUIArea.bind(this),dropOnUIArea:this._onDropOnUIArea.bind(this),dragEnterUploadCollection:this._onDragEnterUploadCollection.bind(this),dragLeaveUploadCollection:this._onDragLeaveUploadCollection.bind(this),dragOverUploadCollection:this._onDragOverUploadCollection.bind(this),dropOnUploadCollection:this._onDropOnUploadCollection.bind(this)};}this._$RootNode=Q(document.body);this._$RootNode.on("dragenter",this._oDragDropHandler.dragEnterUIArea);this._$RootNode.on("dragleave",this._oDragDropHandler.dragLeaveUIArea);this._$RootNode.on("dragover",this._oDragDropHandler.dragOverUIArea);this._$RootNode.on("drop",this._oDragDropHandler.dropOnUIArea);this._$DragDropArea=this.$("drag-drop-area");this.$().on("dragenter",this._oDragDropHandler.dragEnterUploadCollection);this.$().on("dragleave",this._oDragDropHandler.dragLeaveUploadCollection);this.$().on("dragover",this._oDragDropHandler.dragOverUploadCollection);this.$().on("drop",this._oDragDropHandler.dropOnUploadCollection);};
t.prototype._unbindDragEnterLeave=function(){if(!this._bDragDropEnabled&&!this._oDragDropHandler){return;}if(this._$RootNode){this._$RootNode.off("dragenter",this._oDragDropHandler.dragEnterUIArea);this._$RootNode.off("dragleave",this._oDragDropHandler.dragLeaveUIArea);this._$RootNode.off("dragover",this._oDragDropHandler.dragOverUIArea);this._$RootNode.off("drop",this._oDragDropHandler.dropOnUIArea);}this.$().off("dragenter",this._oDragDropHandler.dragEnterUploadCollection);this.$().off("dragleave",this._oDragDropHandler.dragLeaveUploadCollection);this.$().off("dragover",this._oDragDropHandler.dragOverUploadCollection);this.$().off("drop",this._oDragDropHandler.dropOnUploadCollection);};
t.prototype._onDragEnterUIArea=function(e){if(!this._checkForFiles(e)){return;}this._oLastEnterUIArea=e.target;this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");this._adjustDragDropIcon();};
t.prototype._onDragOverUIArea=function(e){e.preventDefault();if(!this._checkForFiles(e)){return;}this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");};
t.prototype._onDragLeaveUIArea=function(e){if(this._oLastEnterUIArea===e.target){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");}};
t.prototype._onDropOnUIArea=function(e){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");};
t.prototype._onDragEnterUploadCollection=function(e){if(!this._checkForFiles(e)){return;}if(e.target===this._$DragDropArea[0]){this._$DragDropArea.addClass("sapMUCDropIndicator");this._adjustDragDropIcon();this.getAggregation("_dragDropText").setText(this._oRb.getText("UPLOADCOLLECTION_DROP_FILE_INDICATOR"));}};
t.prototype._onDragOverUploadCollection=function(e){e.preventDefault();e.originalEvent.dataTransfer.dropEffect="copy";};
t.prototype._onDragLeaveUploadCollection=function(e){if(e.target===this._$DragDropArea[0]){this._$DragDropArea.removeClass("sapMUCDropIndicator");this.getAggregation("_dragDropText").setText(this._oRb.getText("UPLOADCOLLECTION_DRAG_FILE_INDICATOR"));}};
t.prototype._checkForFiles=function(e){var j=e.originalEvent.dataTransfer.types;if(j){for(var i=0;i<j.length;i++){if(j[i]==="Files"){return true;}}}return false;};
t.prototype._isDragAndDropAllowed=function(){return this.getUploadEnabled()&&!this.getUploadButtonInvisible();};
t.prototype._onDropOnUploadCollection=function(e){if(!this._checkForFiles(e)){e.preventDefault();return;}if(e.target===this._$DragDropArea[0]){e.preventDefault();this._$DragDropArea.removeClass("sapMUCDropIndicator");this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");this.getAggregation("_dragDropText").setText(this._oRb.getText("UPLOADCOLLECTION_DRAG_FILE_INDICATOR"));var j=e.originalEvent.dataTransfer.files;if(j.length>1&&!this.getMultiple()){var u=this._oRb.getText("UPLOADCOLLECTION_MULTIPLE_FALSE");a.error(u);return;}if(!this._oFileUploader._areFilesAllowed(j)){return;}if(!this.getInstantUpload()){for(var i=0;i<j.length;i++){this._oFileUploader.fireChange({files:[j[i]],fromDragDrop:true});this._aFilesFromDragAndDropForPendingUpload.push(j[i]);}}else{this._oFileUploader.fireChange({files:j});this._oFileUploader._sendFilesFromDragAndDrop(j);}}};
t.prototype._adjustDragDropIcon=function(){if(this._$DragDropArea[0].offsetHeight<160){this.getAggregation("_dragDropIcon").$().hide();}};
t.prototype._deregisterSizeHandler=function(){q.orientation.detachHandler(this._onResize,this);R.deregister(this._sReziseHandlerId);};
t.prototype._hideFileUploaders=function(){var e,i;if(!this.getInstantUpload()){e=this._oHeaderToolbar.getContent().length;if(this._aFileUploadersForPendingUpload.length){for(i=0;i<e;i++){if(this._oHeaderToolbar.getContent()[i]instanceof h){if(i===this._iFileUploaderPH&&this._bFocusFileUploader){this._oHeaderToolbar.getContent()[i].$().find("button").trigger("focus");}else{this._oHeaderToolbar.getContent()[i].$().hide();}}}}}};
t.prototype._truncateFileName=function(e){if(!e){return;}if(e._status==="Edit"){e._oListItem.$().find(".sapMUCObjectMarkerContainer").attr("style","display: none");return;}var j=0;var u=e.getMarkers();var v;for(var i=0;i<u.length;i++){j=j+u[i].$().width()+t._markerMargin;}if(j>0){var $=e._oFileNameLink.$();if($){v="max-width: calc(100% - "+j+"px)";if($.attr("style")!==v){$.attr("style",v);}}}};
t.prototype._getListHeader=function(e){var u,i,j;this._setNumberOfAttachmentsTitle(e);if(!this._oHeaderToolbar){if(this._oFileUploader&&!this.getInstantUpload()){this._oFileUploader.destroy();}u=this._getFileUploader();this._oHeaderToolbar=this.getAggregation("toolbar");if(!this._oHeaderToolbar){this._oHeaderToolbar=new O(this.getId()+"-toolbar",{content:[this._oNumberOfAttachmentsTitle,new l(),u]}).addEventDelegate({onAfterRendering:this._hideFileUploaders},this);this._iFileUploaderPH=2;}else{this._oHeaderToolbar.addEventDelegate({onAfterRendering:this._hideFileUploaders},this);this._iFileUploaderPH=this._getFileUploaderPlaceHolderPosition(this._oHeaderToolbar);if(this._oHeaderToolbar&&this._iFileUploaderPH>-1){this._setFileUploaderInToolbar(u);}else{s.info("A place holder of type 'sap.m.UploadCollectionPlaceholder' needs to be provided.");}}}else if(!this.getInstantUpload()){var P=this._aFileUploadersForPendingUpload.length;for(i=P-1;i>=0;i--){if(this._aFileUploadersForPendingUpload[i].getId()===this._oFileUploader.getId()){u=this._getFileUploader();var v=this.getAggregation("headerParameters");var w=this._requestIdValue.toString();if(v){for(j=0;j<v.length;j++){u.addHeaderParameter(new F({name:v[j].getProperty("name"),value:v[j].getProperty("value")}));}u.addHeaderParameter(new F({name:this._headerParamConst.requestIdName,value:w}));}this._oHeaderToolbar.insertAggregation("content",u,this._iFileUploaderPH,true);break;}}}};
t.prototype._getFileUploaderPlaceHolderPosition=function(e){for(var i=0;i<e.getContent().length;i++){if(e.getContent()[i]instanceof o){return i;}}return-1;};
t.prototype._setFileUploaderInToolbar=function(e){this._oHeaderToolbar.getContent()[this._iFileUploaderPH].setVisible(false);this._oHeaderToolbar.insertContent(e,this._iFileUploaderPH);};
t.prototype._mapItemToListItem=function(i){if(!i||(this._oItemToUpdate&&i.getId()===this._oItemToUpdate.getId())){return null;}var e,j,u,v,w,x,$,y,z;e=i.getId();j=i._status;u=i.getFileName();if(j===t._uploadingStatus){v=new g({id:e+"-ia_indicator"});v.addStyleClass("sapMUCloadingIcon");}else{z=this._createIcon(i,e,u);}x=e+"-container";$=Q(document.getElementById(x));if($){$.remove();$=null;}y=new H(x,{content:"<span class='sapMUCTextButtonContainer'></span>",afterRendering:this._renderContent.bind(this,i,x)});w=new p(e+"-cli",{content:[v,z,y],selected:i.getSelected()});w._oUploadCollectionItem=i;w._status=j;w.addStyleClass("sapMUCItem");w.setTooltip(i.getTooltip_Text());i._oListItem=w;return w;};
t.prototype._renderContent=function(e,u){var v,i,A,w,x,P,y,z,E,G,J;P=e._percentUploaded;y=e.getAllAttributes();z=e.getStatuses();J=e.getMarkers();v=e.getId();A=y.length;w=z.length;x=J.length;G=e._status;E=this._RenderManager;E.openStart("div");E.class("sapMUCTextContainer");if(G==="Edit"){E.class("sapMUCEditMode");}E.openEnd();E.renderControl(this._getFileNameControl(e));if(G===t._uploadingStatus){E.renderControl(this._createProgressLabel(e,P));}else{if(x>0){E.openStart("div");E.class("sapMUCObjectMarkerContainer");E.openEnd();for(i=0;i<x;i++){E.renderControl(J[i].addStyleClass("sapMUCObjectMarker"));}E.close("div");}if(A>0){E.openStart("div");E.class("sapMUCAttrContainer");E.attr("tabindex","-1");E.openEnd();for(i=0;i<A;i++){y[i].addStyleClass("sapMUCAttr");E.renderControl(y[i]);if((i+1)<A){E.openStart("div");E.class("sapMUCSeparator");E.openEnd();E.unsafeHtml("&nbsp&#x00B7&#160");E.close("div");}}E.close("div");}if(w>0){E.openStart("div");E.class("sapMUCStatusContainer");E.attr("tabindex","-1");E.openEnd();for(i=0;i<w;i++){z[i].detachBrowserEvent("hover");z[i].setTooltip(z[i].getTitle()+":"+z[i].getText());E.renderControl(z[i]);for(var j=i+1;j<w;j++){if(!z[i].getVisible()){break;}else if(z[j]&&z[j].getVisible()){E.openStart("div");E.class("sapMUCSeparator");E.openEnd();E.unsafeHtml("&nbsp&#x00B7&#160");E.close("div");break;}}}E.close("div");}}E.close("div");this._renderButtons(E,e,G,v);E.flush(Q(document.getElementById(u))[0],true);this._truncateFileName(e);this._sReziseHandlerId=R.register(this,this._onResize.bind(this));q.orientation.attachHandler(this._onResize,this);};
t.prototype._renderButtons=function(e,j,u,v){var w,x;w=this._getButtons(j,u,v);if(w){x=w.length;}if(x>0){e.openStart("div");e.class("sapMUCButtonContainer");e.openEnd();for(var i=0;i<x;i++){if((i+1)<x){w[i].addStyleClass("sapMUCFirstButton");}e.renderControl(w[i]);}e.close("div");}};
t.prototype._getFileNameControl=function(i){var e,j,u,v,w,x,y,V,z,A,E;v=i.getFileName();w=i.getId();x=i._status;if(x!=="Edit"){e=i._getFileNameLink?i._getFileNameLink():i._getControl("sap.m.Link",{id:w+"-ta_filenameHL",press:[i,this._onItemPressed,this]},"FileNameLink");e.setEnabled(this._getItemPressEnabled(i));e.addStyleClass("sapMUCFileName");e.setModel(i.getModel());e.setText(v);i._oFileNameLink=e;return e;}else{j=t._splitFilename(v);y=this.getMaximumFilenameLength();V="None";z=false;u=j.name;if(i.errorState==="Error"){z=true;V="Error";u=i.changedFileName;if(u.length===0){E=this._oRb.getText("UPLOADCOLLECTION_TYPE_FILENAME");}else{E=this._oRb.getText("UPLOADCOLLECTION_EXISTS");}}A=i._getFileNameEditBox?i._getFileNameEditBox():i._getControl("sap.m.Input",{id:w+"-ta_editFileName",type:L.InputType.Text},"FileNameEditBox");A.addStyleClass("sapMUCEditBox");A.setModel(i.getModel());A.setValue(u);A.setValueState(V);A.setFieldWidth("75%");A.setValueStateText(E);A.setDescription(j.extension);A.setShowValueStateMessage(z);if((y-j.extension.length)>0){A.setProperty("maxLength",y-j.extension.length,true);}return A;}};
t.prototype._getItemPressEnabled=function(i){return i._getPressEnabled()&&this.sErrorState!=="Error";};
t.prototype._onItemPressed=function(e,i){if(i.hasListeners("press")){i.firePress();}else if(this.sErrorState!=="Error"&&i._hasUrl()){this._triggerLink(e,i);}};
t.prototype._createProgressLabel=function(i,e){var P,j=i.getId();P=i._getProgressLabel?i._getProgressLabel():i._getControl("sap.m.Label",{id:j+"-ta_progress"},"ProgressLabel").addStyleClass("sapMUCProgress");P.setText(this._oRb.getText("UPLOADCOLLECTION_UPLOADING",[e]));return P;};
t.prototype._createIcon=function(i,e,j){var u,v,w,x;u=i.getThumbnailUrl();if(u){w=b.createControlByURI({id:e+"-ia_imageHL",src:this._getThumbnail(u,j),decorative:false},c).addStyleClass("sapMUCItemImage sapMUCItemIcon");w.setAlt(this._getAriaLabelForPicture(i));}else{v=this._getThumbnail(undefined,j);w=new I(e+"-ia_iconHL",{src:v,decorative:false,useIconTooltip:false});w.setAlt(this._getAriaLabelForPicture(i));if(this.sErrorState!=="Error"&&i._hasUrl()){x="sapMUCItemIcon";}else{x="sapMUCItemIconInactive";}if(v===t._placeholderCamera){if(this.sErrorState!=="Error"&&i._hasUrl()){x=x+" sapMUCItemPlaceholder";}else{x=x+" sapMUCItemPlaceholderInactive";}}w.addStyleClass(x);}if(this._getItemPressEnabled(i)){w.attachPress(i,this._onItemPressed,this);}return w;};
t.prototype._getButtons=function(i,e,j){var u,v,w,x,y,E,z;u=[];if(!this.getInstantUpload()){x="deleteButton";y=this._createDeleteButton(j,x,i,this.sErrorState);u.push(y);return u;}if(e==="Edit"){v=i._getOkButton?i._getOkButton():i._getControl("sap.m.Button",{id:j+"-okButton",text:this._oRb.getText("UPLOADCOLLECTION_RENAMEBUTTON_TEXT"),type:L.ButtonType.Transparent},"OkButton").addStyleClass("sapMUCOkBtn");w=i._getCancelButton?i._getCancelButton():i._getControl("sap.m.Button",{id:j+"-cancelButton",text:this._oRb.getText("UPLOADCOLLECTION_CANCELBUTTON_TEXT"),type:L.ButtonType.Transparent},"CancelButton").addStyleClass("sapMUCCancelBtn");u.push(v);u.push(w);}else if(e===t._uploadingStatus){x="terminateButton";y=this._createDeleteButton(j,x,i,this.sErrorState);u.push(y);}else{E=i.getEnableEdit();if(this.sErrorState==="Error"){E=false;}if(i.getVisibleEdit()){z=i._getEditButton?i._getEditButton():i._getControl("sap.m.Button",{id:j+"-editButton",icon:"sap-icon://edit",type:L.ButtonType.Standard,tooltip:this._oRb.getText("UPLOADCOLLECTION_EDITBUTTON_TEXT"),press:[i,this._handleEdit,this]},"EditButton").addStyleClass("sapMUCEditBtn");z.setEnabled(E);z.setVisible(i.getVisibleEdit());u.push(z);}x="deleteButton";if(i.getVisibleDelete()){y=this._createDeleteButton(j,x,i,this.sErrorState);u.push(y);}}return u;};
t.prototype._createDeleteButton=function(i,e,j,u){var E,v,G,w,x,V,P;E=j.getEnableDelete();if(u==="Error"){E=false;}if(e==="deleteButton"){G="DeleteButton";x=j._getDeleteButton;w=this._oRb.getText("UPLOADCOLLECTION_DELETEBUTTON_TEXT");V=j.getVisibleDelete();P=[this,this._handleDelete,this];}else{G="TerminateButton";x=j._getTerminateButton;w=this._oRb.getText("UPLOADCOLLECTION_TERMINATEBUTTON_TEXT");V=this.getTerminationEnabled();P=[j,this._handleTerminate,this];}v=x?x():j._getControl("sap.m.Button",{id:i+"-"+e,icon:"sap-icon://decline",type:L.ButtonType.Standard,press:P},G).addStyleClass("sapMUCDeleteBtn");v.setVisible(V);v.setEnabled(E);v.setTooltip(w);return v;};
t.prototype._fillList=function(i){var e=this,j=i.length-1,u=this.getBinding("items"),G=false,v,w=this.getBindingInfo("items")?this.getBindingInfo("items").model:undefined,x=this.getBindingInfo("items")?this.getBindingInfo("items").groupHeaderFactory:null;var y=function(A){return A.getBindingContext(w)?u.getGroup(A.getBindingContext(w)):null;};var z=function(A){return y(A)&&y(A).key;};Q.each(i,function(A,E){if(u&&u.isGrouped()&&E){if(!G||v!==z(E)){if(x){e._oList.addItemGroup(y(E),x(y(E)),true);}else if(y(E)){e._oList.addItemGroup(y(E),null,true);}G=true;v=z(E);}}if(!E._status||!E.getVisibleEdit()){E._status=t._displayStatus;}else if(e.getInstantUpload()&&e._oItemForDelete&&e._oItemForDelete._status===t._toBeDeletedStatus&&E.getDocumentId()===e._oItemForDelete.documentId){return false;}if(!E._percentUploaded&&E._status===t._uploadingStatus){E._percentUploaded=0;}var J=e._mapItemToListItem(E);if(J){if(A===0&&j===0){J.addStyleClass("sapMUCListSingleItem");}else if(A===0){J.addStyleClass("sapMUCListFirstItem");}else if(A===j){J.addStyleClass("sapMUCListLastItem");}else{J.addStyleClass("sapMUCListItem");}e._oList.addAggregation("items",J,true);E.attachEvent("selected",e._handleItemSetSelected,e);}return true;});};
t.prototype._clearList=function(){if(this._oList){this._oList.destroyAggregation("items",true);}};
t.prototype._setNumberOfAttachmentsTitle=function(e){var i=e||0;var j;if(this._oItemToUpdate){i--;}if(this.getNumberOfAttachmentsText()){j=this.getNumberOfAttachmentsText();}else{j=this._oRb.getText("UPLOADCOLLECTION_ATTACHMENTS",[i]);}if(!this._oNumberOfAttachmentsTitle){this._oNumberOfAttachmentsTitle=new d(this.getId()+"-numberOfAttachmentsTitle",{text:j});}else{this._oNumberOfAttachmentsTitle.setText(j);}};
t.prototype._setFileUploaderVisibility=function(u){var e=this._oHeaderToolbar.getContent();if(e){var P=e[this._iFileUploaderPH];if(P instanceof h){P.setVisible(!u);}}};
t.prototype._handleDelete=function(e){var P=e.getParameters();var j=this.getItems();var u=P.id.split("-deleteButton")[0];var v;var w;var x="";var y;var z;for(var i=0;i<j.length;i++){if(j[i].sId===u){w=i;v={documentId:j[i].getDocumentId(),_iLineNumber:w};break;}}if(j[w].hasListeners("deletePress")){j[w].fireDeletePress();return;}this.sDeletedItemId=u;if(Q(document.getElementById(this.sId)).hasClass("sapUiSizeCompact")){x="sapUiSizeCompact";}if(this.editModeItem){this._handleOk(e,this.editModeItem,true);if(this.sErrorState==="Error"){return;}}if(j[w]&&j[w].getEnableDelete()){y=j[w].getFileName();if(!y){z=this._oRb.getText("UPLOADCOLLECTION_DELETE_WITHOUT_FILENAME_TEXT");}else{z=this._oRb.getText("UPLOADCOLLECTION_DELETE_TEXT",y);}this._oItemForDelete=v;a.show(z,{title:this._oRb.getText("UPLOADCOLLECTION_DELETE_TITLE"),actions:[a.Action.OK,a.Action.CANCEL],onClose:this._onCloseMessageBoxDeleteItem.bind(this),dialogId:"messageBoxDeleteFile",styleClass:x});}};
t.prototype._onCloseMessageBoxDeleteItem=function(e){var j=this.getItems();var u;if(this.getInstantUpload()){for(var i=0;i<j.length;i++){if(j[i].getDocumentId()===this._oItemForDelete.documentId){u=j[i];}}}else{u=j[this._oItemForDelete._iLineNumber];}if(e===a.Action.OK){this._oItemForDelete._status=t._toBeDeletedStatus;if(this.getInstantUpload()){this.fireFileDeleted({documentId:this._oItemForDelete.documentId,item:u});this._oItemForDelete=null;}else{if(this.aItems.length===1){if(!this.getUploadButtonInvisible()){this.sFocusId=this._oFileUploader.$().find(":button")[0].id;}}else if(this._oItemForDelete._iLineNumber<this.aItems.length-1){this.sFocusId=this.aItems[this._oItemForDelete._iLineNumber+1].getId()+"-cli";}else{this.sFocusId=this.aItems[0].getId()+"-cli";}this._aDeletedItemForPendingUpload.push(u);this.aItems.splice(this._oItemForDelete._iLineNumber,1);this.removeAggregation("items",u,false);}}};
t.prototype._handleTerminate=function(e,j){var u,v;u=new f({items:[new S({icon:this._getIconFromFilename(j.getFileName())})]});u.getItems()[0].setTitle(j.getFileName());v=new D({id:this.getId()+"deleteDialog",title:this._oRb.getText("UPLOADCOLLECTION_TERMINATE_TITLE"),content:[new T({text:this._oRb.getText("UPLOADCOLLECTION_TERMINATE_TEXT")}),u],buttons:[new B({text:this._oRb.getText("UPLOADCOLLECTION_OKBUTTON_TEXT"),press:[w,this]}),new B({text:this._oRb.getText("UPLOADCOLLECTION_CANCELBUTTON_TEXT"),press:function(){v.close();}})],afterClose:function(){v.destroy();}}).open();function w(){var A=false;for(var i=0;i<this.aItems.length;i++){if(this.aItems[i]._status===t._uploadingStatus&&this.aItems[i]._requestIdName===j._requestIdName){this.aItems[i]._status=t._toBeDeletedStatus;this._oItemForDelete=this.aItems[i];A=true;break;}else if(j.getFileName()===this.aItems[i].getFileName()&&this.aItems[i]._status===t._displayStatus){this.aItems[i]._status=t._toBeDeletedStatus;this._oItemForDelete=this.aItems[i];this.fireFileDeleted({documentId:this.aItems[i].getDocumentId(),item:this.aItems[i]});break;}}if(A){this._getFileUploader().abort(this._headerParamConst.fileNameRequestIdName,this._encodeToAscii(j.getFileName())+this._oItemForDelete._requestIdName);}v.close();this.invalidate();}};
t.prototype._handleEdit=function(e,j){var i,u=j.getId(),v=this.aItems.length;if(this.editModeItem){this._handleOk(e,this.editModeItem,false);}if(this.sErrorState!=="Error"){for(i=0;i<v;i++){if(this.aItems[i].getId()===u){this.aItems[i]._status="Edit";break;}}j._status="Edit";this.editModeItem=e.getSource().getId().split("-editButton")[0];this.invalidate();}};
t.prototype._handleClick=function(e,i){var $=Q(e.target).closest("button");var j="";if($.length){j=$.prop("id");}if(j.lastIndexOf("editButton")===-1){if(j.lastIndexOf("cancelButton")!==-1){this._handleCancel(e,i);}else if(e.target.id.lastIndexOf("ia_imageHL")<0&&e.target.id.lastIndexOf("ia_iconHL")<0&&e.target.id.lastIndexOf("deleteButton")<0&&e.target.id.lastIndexOf("ta_editFileName-inner")<0){if(e.target.id.lastIndexOf("cli")>0){this.sFocusId=e.target.id;}this._handleOk(e,i,true);}}};
t.prototype._handleOk=function(e,i,j){var E=document.getElementById(i+"-ta_editFileName-inner");var N;var u=t._findById(i,this.aItems);var v=u.getProperty("fileName");var w=t._splitFilename(v);var x=sap.ui.getCore().byId(i+"-ta_editFileName");var y=u.errorState;var z=u.changedFileName;if(E!==null){N=E.value.replace(/^\s+/,"");}this.sFocusId=i+"-cli";if(!N||N.length===0){if(E!==null){this._setErrorStateOnItem(this,u,N,z,y);}return;}u._status=t._displayStatus;if(w.name===N){this._removeErrorStateFromItem(this,u);if(j){this.invalidate();}return;}if(this.getSameFilenameAllowed()){this._removeErrorStateFromItem(this,u);this._oItemForRename=u;this._onEditItemOk.bind(this)(N+w.extension);return;}if(t._checkDoubleFileName(N+w.extension,this.aItems)){x.setProperty("valueState","Error",true);this._setErrorStateOnItem(this,u,N,z,y);}else{x.setProperty("valueState","None",true);u.changedFileName=null;this._removeErrorStateFromItem(this,u);if(j){this.invalidate();}this._oItemForRename=u;this._onEditItemOk.bind(this)(N+w.extension);}};
t.prototype._setErrorStateOnItem=function(e,i,N,j,E){i._status="Edit";i.errorState="Error";e.sErrorState="Error";i.changedFileName=N;if(E!=="Error"||j!==N){e.invalidate();}};
t.prototype._removeErrorStateFromItem=function(e,i){i.errorState=null;e.sErrorState=null;e.editModeItem=null;};
t.prototype._onEditItemOk=function(N){if(this._oItemForRename){this._oItemForRename.setFileName(N);this.fireFileRenamed({documentId:this._oItemForRename.getProperty("documentId"),fileName:N,item:this._oItemForRename});}delete this._oItemForRename;};
t.prototype._handleCancel=function(e,i){var j=t._findById(i,this.aItems);j._status=t._displayStatus;j.errorState=null;j.changedFileName=j._getFileNameEditBox().getValue();this.sFocusId=this.editModeItem+"-cli";this.sErrorState=null;this.editModeItem=null;this.invalidate();};
t.prototype._onChange=function(e){if(e){var j,u=e.getParameter("files").length,i,v,w,x,A;if(u===0){return;}this._oFileUploader.removeAllAggregation("headerParameters",true);this.removeAllAggregation("headerParameters",true);this._oFileUploader.removeAllAggregation("parameters",true);this.removeAllAggregation("parameters",true);this.fireChange({getParameter:function(z){if(z){return e.getParameter(z);}return null;},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:e.getParameter("files")});var P=this.getAggregation("parameters");if(P){Q.each(P,function(z,E){var G=new F({name:E.getProperty("name"),value:E.getProperty("value")});this._oFileUploader.addParameter(G);}.bind(this));}if(!this.getInstantUpload()){this._bFocusFileUploader=true;w=t._pendingUploadStatus;}else{w=t._uploadingStatus;}this._requestIdValue++;j=this._requestIdValue.toString();var y=this.getAggregation("headerParameters");if(!this.getInstantUpload()){this._aFileUploadersForPendingUpload.push(this._oFileUploader);}for(i=0;i<u;i++){v=new U();v.setFileName(e.getParameter("files")[i].name);if(e.getParameter("fromDragDrop")){v._internalFileIdWithinDragDropArray=e.getParameter("files")[i];}v._status=w;v._internalFileIndexWithinFileUploader=i+1;v._requestIdName=j;if(!this.getInstantUpload()){v.setAssociation("fileUploader",this._oFileUploader,true);x=this._oFormatDecimal.format(e.getParameter("files")[i].size);A=new m({text:x});v.insertAggregation("attributes",A,true);this.insertItem(v);}else{v._percentUploaded=0;}this.aItems.unshift(v);}if(y){Q.each(y,function(z,E){this._oFileUploader.addHeaderParameter(new F({name:E.getProperty("name"),value:E.getProperty("value")}));}.bind(this));}this._oFileUploader.addHeaderParameter(new F({name:this._headerParamConst.requestIdName,value:j}));}};
t.prototype._onFilenameLengthExceed=function(e){var i={name:e.getParameter("fileName")};var j=[i];this.fireFilenameLengthExceed({getParameter:function(P){if(P){return e.getParameter(P);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:j});};
t.prototype._onFileSizeExceed=function(e){var i={name:e.getParameter("fileName"),fileSize:e.getParameter("fileSize")};this.fireFileSizeExceed({getParameter:function(P){if(P){return e.getParameter(P);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:[i]});};
t.prototype._onTypeMissmatch=function(e){var i={name:e.getParameter("fileName"),fileType:e.getParameter("fileType"),mimeType:e.getParameter("mimeType")};var j=[i];this.fireTypeMissmatch({getParameter:function(P){if(P){return e.getParameter(P);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:j});};
t.prototype._onUploadTerminated=function(e){var i;var j=this._getRequestId(e);var u=e.getParameter("fileName");var v=this.aItems.length;for(i=0;i<v;i++){if(this.aItems[i]&&this.aItems[i].getFileName()===u&&this.aItems[i]._requestIdName===j&&(this.aItems[i]._status===t._uploadingStatus||this.aItems[i]._status===t._toBeDeletedStatus)){if(this.getItems()&&this.getItems()[i]===this.aItems[i]){this.removeItem(i);}this.aItems.splice(i,1);break;}}this.fireUploadTerminated({fileName:u,getHeaderParameter:this._getHeaderParameterWithinEvent.bind(e)});};
t.prototype._onUploadComplete=function(e){if(e){var i,j=this._getRequestId(e),u=e.getParameter("fileName"),v=e.getParameter("id"),w,x,y,z=A();w=this.aItems.length;y=[t._uploadingStatus,t._pendingUploadStatus];for(i=0;i<w;i++){if((!j||this.aItems[i]._requestIdName===j)&&this.aItems[i].getProperty("fileName")===u&&(y.indexOf(this.aItems[i]._status)>=0)){if(z&&this.aItems[i]._status!==t._pendingUploadStatus){this.aItems[i]._percentUploaded=100;this.aItems[i]._status=t._displayStatus;}x=this.aItems.splice(i,1)[0];if(x.destroy){x.destroy();}this._oItemToUpdate=null;break;}}for(i=0;i<this._aFileUploadersForPendingUpload.length;i++){if(this._aFileUploadersForPendingUpload[i].getId()===v){this._aFileUploadersForPendingUpload[i].clear();break;}}this.fireUploadComplete({getParameter:e.getParameter,getParameters:e.getParameters,mParameters:e.getParameters(),files:[{fileName:e.getParameter("fileName")||u,responseRaw:e.getParameter("responseRaw"),reponse:e.getParameter("response"),response:e.getParameter("response"),status:e.getParameter("status"),headers:e.getParameter("headers")}]});}this.invalidate();function A(){var E=e.getParameter("status").toString()||"200";return E[0]==="2"||E[0]==="3";}};
t.prototype._onUploadProgress=function(e){if(!e||!this.getInstantUpload()){return;}var u=e.getParameter("fileName"),P,j=Math.round(e.getParameter("loaded")/e.getParameter("total")*100),v=this._getRequestId(e),w=this.aItems.length,x,$,y;if(j===100){P=this._oRb.getText("UPLOADCOLLECTION_UPLOAD_COMPLETED");}else{P=this._oRb.getText("UPLOADCOLLECTION_UPLOADING",[j]);}for(var i=0;i<w;i++){y=this.aItems[i];if(y.getProperty("fileName")===u&&y._requestIdName===v&&y._status===t._uploadingStatus){x=y._getProgressLabel?y._getProgressLabel():y._getControl("sap.m.Label",{id:y.getId()+"-ta_progress"},"ProgressLabel");if(x){x.setText(P);x.rerender();y._percentUploaded=j;$=y.$("ia_indicator");if(j===100){$.attr("aria-label",P);}else{$.attr("aria-valuenow",j);}break;}}}};
t.prototype._getRequestId=function(e){var i;i=e.getParameter("requestHeaders");if(!i){return null;}for(var j=0;j<i.length;j++){if(i[j].name===this._headerParamConst.requestIdName){return i[j].value;}}return null;};
t.prototype._getFileUploader=function(){var u=this.getInstantUpload();if(!u||!this._oFileUploader){var e=this.getInstantUpload()?this._oRb.getText("UPLOADCOLLECTION_UPLOAD"):this._oRb.getText("UPLOADCOLLECTION_ADD");this._iFUCounter=this._iFUCounter+1;this._oFileUploader=new h(this.getId()+"-"+this._iFUCounter+"-uploader",{buttonOnly:true,buttonText:e,iconOnly:false,enabled:this.getUploadEnabled(),fileType:this.getFileType(),icon:"",iconFirst:false,style:"Transparent",maximumFilenameLength:this.getMaximumFilenameLength(),maximumFileSize:this.getMaximumFileSize(),mimeType:this.getMimeType(),multiple:this.getMultiple(),name:"uploadCollection",uploadOnChange:u,sameFilenameAllowed:true,uploadUrl:this.getUploadUrl(),useMultipart:false,sendXHR:true,change:[this._onChange,this],filenameLengthExceed:[this._onFilenameLengthExceed,this],fileSizeExceed:[this._onFileSizeExceed,this],typeMissmatch:[this._onTypeMissmatch,this],uploadAborted:[this._onUploadTerminated,this],uploadComplete:[this._onUploadComplete,this],uploadProgress:[this._onUploadProgress,this],uploadStart:[this._onUploadStart,this],visible:!this.getUploadButtonInvisible()});}return this._oFileUploader;};
t.prototype._onUploadStart=function(e){var j,i,u,v,P,w,G;this._iUploadStartCallCounter++;P=e.getParameter("requestHeaders").length;for(i=0;i<P;i++){if(e.getParameter("requestHeaders")[i].name===this._headerParamConst.requestIdName){u=e.getParameter("requestHeaders")[i].value;break;}}w=e.getParameter("fileName");j={name:this._headerParamConst.fileNameRequestIdName,value:this._encodeToAscii(w)+u};e.getParameter("requestHeaders").push(j);v={name:this._headerParamConst.acceptLanguage,value:sap.ui.getCore().getConfiguration().getLanguage()};e.getParameter("requestHeaders").push(v);for(i=0;i<this._aDeletedItemForPendingUpload.length;i++){if(this._aDeletedItemForPendingUpload[i].getAssociation("fileUploader")===e.oSource.sId&&this._aDeletedItemForPendingUpload[i].getFileName()===w&&this._aDeletedItemForPendingUpload[i]._internalFileIndexWithinFileUploader===this._iUploadStartCallCounter){e.getSource().abort(this._headerParamConst.fileNameRequestIdName,this._encodeToAscii(w)+u);return;}}this.fireBeforeUploadStarts({fileName:w,addHeaderParameter:x,getHeaderParameter:y.bind(this)});if(Array.isArray(G)){for(i=0;i<G.length;i++){if(e.getParameter("requestHeaders")[i].name===G[i].getName()){e.getParameter("requestHeaders")[i].value=G[i].getValue();}}}else if(G instanceof n){for(i=0;i<e.getParameter("requestHeaders").length;i++){if(e.getParameter("requestHeaders")[i].name===G.getName()){e.getParameter("requestHeaders")[i].value=G.getValue();break;}}}function x(z){var j={name:z.getName(),value:z.getValue()};e.getParameter("requestHeaders").push(j);}function y(z){G=this._getHeaderParameterWithinEvent.bind(e)(z);return G;}};
t.prototype._getIconFromFilename=function(e){var i=t._splitFilename(e).extension;if(typeof i==="string"){i=i.toLowerCase();}switch(i){case".bmp":case".jpg":case".jpeg":case".png":return t._placeholderCamera;case".csv":case".xls":case".xlsx":return"sap-icon://excel-attachment";case".doc":case".docx":case".odt":return"sap-icon://doc-attachment";case".pdf":return"sap-icon://pdf-attachment";case".ppt":case".pptx":return"sap-icon://ppt-attachment";case".txt":return"sap-icon://document-text";default:return"sap-icon://document";}};
t.prototype._getThumbnail=function(e,i){if(e){return e;}else{return this._getIconFromFilename(i);}};
t.prototype._triggerLink=function(e,i){if(this.editModeItem){this._handleOk(e,this.editModeItem,true);if(this.sErrorState==="Error"){return;}this.sFocusId=e.getParameter("id");}M.URLHelper.redirect(i.getProperty("url"),true);};
t.prototype.onkeydown=function(e){switch(e.keyCode){case K.F2:this._handleF2(e);break;case K.ESCAPE:this._handleESC(e);break;case K.DELETE:this._handleDEL(e);break;case K.ENTER:this._handleENTER(e);break;default:return;}e.setMarked();};
t.prototype._setFocusAfterDeletion=function(){var i=this.aItems.length;var e;if(i===0){this._oFileUploader.focus();}else{var j=this.sDeletedItemId.split("-").pop();if(j<=i-1){e=this.sDeletedItemId+"-cli";}else{e=this.aItems[this.aItems.length-1].sId+"-cli";}this._setFocusToLineItem(e);}this.sDeletedItemId=null;};
t.prototype._setFocusToLineItem=function(i){Q(document.getElementById(i)).trigger("focus");};
t.prototype._handleENTER=function(e){var i,j,u,v;if(this.editModeItem){i=e.target.id.split(this.editModeItem).pop();}else{i=e.target.id.split("-").pop();}switch(i){case"-ta_editFileName-inner":case"-okButton":this._handleOk(e,this.editModeItem,true);break;case"-cancelButton":e.preventDefault();this._handleCancel(e,this.editModeItem);break;case"-ia_iconHL":case"-ia_imageHL":v=this.editModeItem.split("-").pop();M.URLHelper.redirect(this.aItems[v].getProperty("url"),true);break;case"ia_iconHL":case"ia_imageHL":case"cli":j=e.target.id.split(i)[0]+"ta_filenameHL";u=sap.ui.getCore().byId(j);if(u.getEnabled()){v=e.target.id.split("-")[2];M.URLHelper.redirect(this.aItems[v].getProperty("url"),true);}break;default:break;}};
t.prototype._handleDEL=function(e){if(!this.editModeItem){var i=e.target.id.slice(0,-4),j=sap.ui.getCore().byId(i),u=j&&j._getDeleteButton&&j._getDeleteButton();if(u){u.firePress();}}};
t.prototype._handleESC=function(e){if(this.editModeItem){this.sFocusId=this.editModeItem+"-cli";this.aItems[this.editModeItem.split("-").pop()]._status=t._displayStatus;this._handleCancel(e,this.editModeItem);}};
t.prototype._handleF2=function(e){var i=sap.ui.getCore().byId(e.target.id);if(i!==undefined){if(i._status===t._displayStatus){var j=Q(document.getElementById(e.target.id));var u=j.find("[id$='-editButton']");var E=sap.ui.getCore().byId(u[0].id);if(E.getEnabled()){if(this.editModeItem){this._handleClick(e,this.editModeItem);}if(this.sErrorState!=="Error"){E.firePress();}}}else{this._handleClick(e,this.editModeItem);}}else if(e.target.id.search(this.editModeItem)===0){this._handleOk(e,this.editModeItem,true);}};
t._checkDoubleFileName=function(e,j){if(j.length===0||!e){return false;}var u=j.length;e=e.replace(/^\s+/,"");for(var i=0;i<u;i++){if(e===j[i].getProperty("fileName")){return true;}}return false;};
t._splitFilename=function(e){var i={};var N=e.split(".");if(N.length===1){i.extension="";i.name=N.pop();return i;}i.extension="."+N.pop();i.name=N.join(".");return i;};
t.prototype._getAriaLabelForPicture=function(i){var e;e=(i.getAriaLabelForPicture()||i.getFileName());return e;};
t.prototype._getHeaderParameterWithinEvent=function(e){var u=[];var j=this.getParameter("requestHeaders");var P=j.length;var i;if(j&&e){for(i=0;i<P;i++){if(j[i].name===e){return new n({name:j[i].name,value:j[i].value});}}return null;}else if(j){for(i=0;i<P;i++){u.push(new n({name:j[i].name,value:j[i].value}));}return u;}};
t.prototype._encodeToAscii=function(v){var e="";for(var i=0;i<v.length;i++){e=e+v.charCodeAt(i);}return e;};
t.prototype._onResize=function(){var e=this._oList.getItems();for(var i=0;i<e.length;i++){var j=e[i];setTimeout(function(){var u=this._truncateFileName.bind(this);if(typeof u==="string"||u instanceof String){u=this[u];}u.apply(this,[j._oUploadCollectionItem]||[]);}.bind(this),t._resizeTimeoutInterval);}};
t.prototype._getUploadCollectionItemByListItem=function(e){var A=this.getItems();for(var i=0;i<A.length;i++){if(A[i].getId()===e.getId().replace("-cli","")){return A[i];}}return null;};
t.prototype._getUploadCollectionItemById=function(u){var A=this.getItems();for(var i=0;i<A.length;i++){if(A[i].getId()===u){return A[i];}}return null;};
t.prototype._getUploadCollectionItemsByListItems=function(e){var u=[];var v=this.getItems();if(e){for(var i=0;i<e.length;i++){for(var j=0;j<v.length;j++){if(e[i].getId().replace("-cli","")===v[j].getId()){u.push(v[j]);break;}}}return u;}return null;};
t.prototype._setSelectedForItems=function(u,e){if(this.getMode()!==L.ListMode.MultiSelect&&e){var v=this.getItems();for(var j=0;j<v.length;j++){v[j].setSelected(false);}}for(var i=0;i<u.length;i++){u[i].setSelected(e);}};
t.prototype._handleItemSetSelected=function(e){var i=e.getSource();if(i instanceof U){var j=this._getListItemById(i.getId()+"-cli");if(j){j.setSelected(i.getSelected());}}};
t.prototype._handleSelectionChange=function(e){var i=e.getParameter("listItem");var j=e.getParameter("selected");var u=this._getUploadCollectionItemsByListItems(e.getParameter("listItems"));var v=this._getUploadCollectionItemByListItem(i);if(v&&i&&u){this.fireSelectionChange({selectedItem:v,selectedItems:u,selected:j});v.setSelected(i.getSelected());}};
t.prototype._getListItemById=function(e){var i=this._oList.getItems();return t._findById(e,i);};
t._findById=function(e,j){for(var i=0;i<j.length;i++){if(j[i].getId()===e){return j[i];}}return null;};
return t;});
sap.ui.predefine('sap/m/UploadCollectionItem',["./library","sap/ui/core/Element","sap/m/ObjectAttribute","sap/ui/core/util/File","sap/ui/Device","sap/base/Log","sap/base/util/ObjectPath","sap/ui/thirdparty/jquery"],function(l,E,O,F,D,L,a,q){"use strict";
var U=E.extend("sap.m.UploadCollectionItem",{metadata:{library:"sap.m",properties:{contributor:{type:"string",group:"Data",defaultValue:null,deprecated:true},documentId:{type:"string",group:"Misc",defaultValue:null},fileName:{type:"string",group:"Misc",defaultValue:null},fileSize:{type:"float",group:"Misc",defaultValue:null,deprecated:true},mimeType:{type:"string",group:"Misc",defaultValue:null},thumbnailUrl:{type:"string",group:"Misc",defaultValue:null},uploadedDate:{type:"string",group:"Misc",defaultValue:null,deprecated:true},url:{type:"string",group:"Misc",defaultValue:null},enableEdit:{type:"boolean",group:"Behavior",defaultValue:true},enableDelete:{type:"boolean",group:"Behavior",defaultValue:true},visibleEdit:{type:"boolean",group:"Behavior",defaultValue:true},visibleDelete:{type:"boolean",group:"Behavior",defaultValue:true},ariaLabelForPicture:{type:"string",group:"Accessibility",defaultValue:null},selected:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,bindable:"bindable"},_propertyAttributes:{type:"sap.m.ObjectAttribute",multiple:true,visibility:"hidden"},statuses:{type:"sap.m.ObjectStatus",multiple:true,bindable:"bindable"},markers:{type:"sap.m.ObjectMarker",multiple:true,bindable:"bindable"}},associations:{fileUploader:{type:"sap.ui.unified.FileUploader",multiple:false}},events:{press:{},deletePress:{}}}});
U.prototype.init=function(){this._mDeprecatedProperties={};this._aManagedInstances=[];};
U.prototype.exit=function(){for(var i=0;i<this._aManagedInstances.length;i++){this._aManagedInstances[i].destroy();}};
U.prototype.setContributor=function(c){if(this.getContributor()!==c){this.setProperty("contributor",c,true);this._updateDeprecatedProperties();}return this;};
U.prototype.setUploadedDate=function(u){if(this.getUploadedDate()!==u){this.setProperty("uploadedDate",u,true);this._updateDeprecatedProperties();}return this;};
U.prototype.setFileSize=function(f){if(this.getFileSize()!==f){this.setProperty("fileSize",f,true);this._updateDeprecatedProperties();}return this;};
U.prototype.setSelected=function(s){if(this.getSelected()!==s){this.setProperty("selected",s,true);this.fireEvent("selected");}return this;};
U.prototype.download=function(b){if(D.browser.name==="sf"){b=false;}if(!this.getUrl()){L.warning("Items to download do not have a URL.");return false;}else if(b){var f=this.getFileName();var o=this._splitFileName(f,false);var d=null;var x=new window.XMLHttpRequest();x.open("GET",this.getUrl());if(o.extension!=="csv"){x.responseType="blob";}x.onload=function(){var s=o.extension;f=o.name;d=x.response;F.save(d,f,s,this.getMimeType(),'utf-8');}.bind(this);x.send();return true;}else{l.URLHelper.redirect(this.getUrl(),true);return true;}};
U.prototype._splitFileName=function(f,w){var r={};var R=/(?:\.([^.]+))?$/;var b=R.exec(f);r.name=f.slice(0,f.indexOf(b[0]));if(w){r.extension=b[0];}else{r.extension=b[1];}return r;};
U.prototype._updateDeprecatedProperties=function(){var p=["uploadedDate","contributor","fileSize"];this.removeAllAggregation("_propertyAttributes",true);q.each(p,function(i,n){var v=this.getProperty(n),A=this._mDeprecatedProperties[n];if(v){if(!A){A=new O({active:false});this._mDeprecatedProperties[n]=A;this.addAggregation("_propertyAttributes",A,true);A.setText(v);}else{A.setText(v);this.addAggregation("_propertyAttributes",A,true);}}else if(A){A.destroy();delete this._mDeprecatedProperties[n];}}.bind(this));this.invalidate();};
U.prototype.getAllAttributes=function(){return this.getAggregation("_propertyAttributes",[]).concat(this.getAttributes());};
U.prototype._getControl=function(n,s,g){var c=a.get(n||""),i=new c(s);this._aManagedInstances.push(i);if(g){this["_get"+g]=function(){return i;};}return i;};
U.prototype._getPressEnabled=function(){return this.hasListeners("press")||this._hasUrl();};
U.prototype._hasUrl=function(){var u=this.getUrl();return u!=null&&!!u.trim();};
return U;});
sap.ui.predefine('sap/m/UploadCollectionParameter',['./library','sap/ui/core/Element'],function(l,E){"use strict";
var U=E.extend("sap.m.UploadCollectionParameter",{metadata:{library:"sap.m",properties:{name:{type:"string",group:"Data",defaultValue:null},value:{type:"string",group:"Data",defaultValue:null}}}});
return U;});
sap.ui.predefine('sap/m/UploadCollectionRenderer',['./ListItemBaseRenderer'],function(L){"use strict";var U={apiVersion:2};
U.render=function(r,c){r.openStart("div",c);r.class("sapMUC");r.openEnd();this.renderDragDropOverlay(r,c);this.renderList(r,c);r.close("div");};
U.renderNoData=function(r,c){var u=c.getParent();r.openStart("li",u._oList.getId("nodata"));r.attr("tabindex","0");L.addFocusableClasses.call(L,r);r.class("sapMLIB");r.class("sapMUCNoDataPage");r.openEnd();r.renderControl(u.getAggregation("_noDataIcon"));r.openStart("div",u.getId()+"-no-data-text");r.class("sapMUCNoDataText");r.openEnd();r.text(u.getNoDataText());r.close("div");if(u.getUploadEnabled()){r.openStart("div",u.getId()+"-no-data-description");r.class("sapMUCNoDataDescription");r.openEnd();r.text(u.getNoDataDescription());r.close("div");}r.close("li");};
U.renderDragDropOverlay=function(r,c){r.openStart("div",c.getId()+"-drag-drop-area");r.class("sapMUCDragDropOverlay");r.class("sapMUCDragDropOverlayHide");r.openEnd();r.openStart("div");r.class("sapMUCDragDropIndicator");r.openEnd();r.renderControl(c.getAggregation("_dragDropIcon"));r.renderControl(c.getAggregation("_dragDropText"));r.close("div");r.close("div");};
U.renderList=function(r,c){var o=c._oList.getRenderer().renderNoData;c._oList.getRenderer().renderNoData=this.renderNoData;r.renderControl(c._oList);c._oList.getRenderer().renderNoData=o;};
return U;},true);
sap.ui.predefine('sap/m/UploadCollectionToolbarPlaceholder',['./library','sap/ui/core/Control'],function(l,C){"use strict";
var U=C.extend("sap.m.UploadCollectionToolbarPlaceholder",{
metadata:{library:"sap.m",properties:{}},
renderer:null
});
return U;});
sap.ui.predefine('sap/m/VBox',['./FlexBox','./library',"./VBoxRenderer"],function(F,l,V){"use strict";var a=l.FlexDirection;
var b=F.extend("sap.m.VBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/VBox.designtime"}});
b.prototype.init=function(){this.setDirection(a.Column);F.prototype.init.apply(this,arguments);};
return b;});
sap.ui.predefine('sap/m/VBoxRenderer',['./FlexBoxRenderer'],function(F){"use strict";var V={apiVersion:2};
V.render=function(r,c){F.render.apply(this,[r,c]);};
return V;},true);
sap.ui.predefine('sap/m/ValueStateHeader',["./library","sap/ui/core/library","sap/ui/Device","sap/ui/core/Core","sap/ui/core/Control"],function(l,c,D,C,a){"use strict";var V=c.ValueState;
var b=a.extend("sap.m.ValueStateHeader",{
metadata:{library:"sap.m",properties:{text:{type:"string",defaultValue:""},valueState:{type:"sap.ui.core.ValueState",defaultValue:V.None}},aggregations:{formattedText:{type:"sap.m.FormattedText",multiple:false}},associations:{popup:{type:"sap.ui.core.Popup",multiple:false}}},
renderer:{apiVersion:2,render:function(r,o){var m={None:"",Error:"sapMValueStateHeaderError",Warning:"sapMValueStateHeaderWarning",Success:"sapMValueStateHeaderSuccess",Information:"sapMValueStateHeaderInformation"};r.openStart("div",o).class("sapMValueStateHeaderRoot").class(m[o.getValueState()]).openEnd();r.openStart("span",o.getId()+"-inner").class("sapMValueStateHeaderText").openEnd();if(o.getFormattedText()){r.renderControl(o.getFormattedText());}else{r.text(o.getText());}r.close("span");r.close("div");}}
});
b.prototype._fnOrientationChange=function(){var p=this._getAssociatedPopupObject(),h=this.getDomRef();if(h&&p&&p.isA("sap.m.Dialog")){h.style.width=p.getDomRef().getBoundingClientRect().width+"px";}};
b.prototype.init=function(){D.orientation.attachHandler(this._fnOrientationChange,this);};
b.prototype.exit=function(){D.orientation.detachHandler(this._fnOrientationChange,this);};
b.prototype.setPopup=function(p){var t=this;var r=false;var P=(typeof p==="string")?C.byId(p):p;this.setAssociation("popup",P);if(P.isA("sap.m.Dialog")){return this;}P._afterAdjustPositionAndArrowHook=function(){var d=t.getDomRef();if(!d){return;}d.style.width=P.getDomRef().getBoundingClientRect().width+"px";d.style.height="auto";if(!r){r=true;setTimeout(function(){P._fnOrientationChange();},0);}};return this;};
b.prototype._getAssociatedPopupObject=function(){return C.byId(this.getPopup());};
b.prototype.onAfterRendering=function(){var p=this._getAssociatedPopupObject();if(p){if(p.isA("sap.m.Popover")){setTimeout(function(){p._fnOrientationChange();},0);}}};
return b;},true);
sap.ui.predefine('sap/m/ViewSettingsCustomItem',['./ViewSettingsItem','./library'],function(V,l){"use strict";
var a=V.extend("sap.m.ViewSettingsCustomItem",{metadata:{library:"sap.m",properties:{filterCount:{type:"int",group:"Behavior",defaultValue:0}},aggregations:{customControl:{type:"sap.ui.core.Control",multiple:false}}}});
a.prototype.init=function(){this.attachEvent("modelContextChange",function(){this._control&&this._control.setModel(this.getModel());}.bind(this));};
a.prototype.exit=function(){if(this._control&&!this._control.getParent()){this._control.destroy();delete this._control;}};
a.prototype.setCustomControl=function(c){this._control=c;return this;};
a.prototype.getCustomControl=function(){return this._control;};
a.prototype.setFilterCount=function(v){this.setProperty("filterCount",v,true);return this;};
a.prototype.setSelected=function(v){this.setProperty("selected",v,true);return this;};
a.prototype.clone=function(i,L,o){var c=V.prototype.clone.apply(this,arguments);c._control=this._control.clone();return c;};
return a;});
sap.ui.predefine('sap/m/ViewSettingsCustomTab',['./library','sap/ui/core/Item','sap/ui/core/IconPool'],function(l,I){"use strict";
var V=I.extend("sap.m.ViewSettingsCustomTab",{metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:"sap-icon://competitor"},title:{type:"string",defaultValue:""}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}}}});
V.prototype.init=function(){this._aTabContents=[];};
V.prototype.exit=function(){this._aTabContents.forEach(function(c,i){c.destroy();delete this._aTabContents[i];},this);};
return V;});
sap.ui.predefine('sap/m/ViewSettingsDialog',['./library','sap/ui/core/Control','sap/ui/core/IconPool','./Toolbar','./CheckBox','./SearchField','./List','./StandardListItem','./Dialog','./Button','./ToggleButton','./Title','./NavContainer','./Bar','./SegmentedButton','./Page','./ViewSettingsItem','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectObserver','sap/ui/base/EventProvider','sap/ui/Device','sap/ui/core/InvisibleText','./ViewSettingsDialogRenderer',"sap/m/GroupHeaderListItem","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Focusable"],function(l,C,I,T,a,S,L,b,D,B,c,d,N,e,f,P,V,M,g,E,h,m,n,G,o,q){"use strict";var p=l.ListMode;var r=l.ListType;var s=l.StringFilterOperator;var t=l.TitleAlignment;var u=l.ButtonType;var v="-list-item";
var w=C.extend("sap.m.ViewSettingsDialog",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Behavior",defaultValue:null},sortDescending:{type:"boolean",group:"Behavior",defaultValue:false},groupDescending:{type:"boolean",group:"Behavior",defaultValue:false},filterSearchOperator:{type:"sap.m.StringFilterOperator",group:"Behavior",defaultValue:s.StartsWith},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:t.Auto}},aggregations:{sortItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"sortItem",bindable:"bindable"},groupItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"groupItem",bindable:"bindable"},filterItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"filterItem",bindable:"bindable"},presetFilterItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"presetFilterItem",bindable:"bindable"},customTabs:{type:"sap.m.ViewSettingsCustomTab",multiple:true,singularName:"customTab",bindable:"bindable"}},associations:{selectedSortItem:{type:"sap.m.ViewSettingsItem",multiple:false},selectedGroupItem:{type:"sap.m.ViewSettingsItem",multiple:false},selectedPresetFilterItem:{type:"sap.m.ViewSettingsItem",multiple:false}},events:{confirm:{parameters:{sortItem:{type:"sap.m.ViewSettingsItem"},sortDescending:{type:"boolean"},groupItem:{type:"sap.m.ViewSettingsItem"},groupDescending:{type:"boolean"},presetFilterItem:{type:"sap.m.ViewSettingsItem"},filterItems:{type:"sap.m.ViewSettingsItem[]"},filterKeys:{type:"object",deprecated:true},filterCompoundKeys:{type:"object"},filterString:{type:"string"}}},cancel:{},resetFilters:{},reset:{},filterDetailPageOpened:{parameters:{parentFilterItem:{type:"sap.m.ViewSettingsFilterItem"}}}}}});
w.prototype.init=function(){var j=this.getId();this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sDialogWidth="350px";this._sDialogHeight="434px";this._bAppendedToUIArea=false;this._showSubHeader=false;this._filterDetailList=undefined;this._vContentPage=-1;this._oContentItem=null;this._oPreviousState={};this._sCustomTabsButtonsIdPrefix='-custom-button-';this._sTitleLabelId=j+"-title";this._sFilterDetailTitleLabelId=j+"-detailtitle";this._oFiltersSelectedOnly={};this._oKeylessFilters={};this._aggregationToListItems("sortItems",{text:{listProp:"title"},selected:{}},{tooltip:{}},{type:r.Active},{mode:p.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(k){var U=k.getParameter('listItem'),W=this.getSortItems(),X=this._getVSItem(U),i;X.setProperty('selected',k.getParameter('selected'),true,false);this.setAssociation('selectedSortItem',X,true);for(i=0;i<W.length;i++){if(X!==W[i]){W[i].setProperty('selected',false,true,false);}}this._checkResetStatus();}.bind(this)});};
w.prototype.exit=function(){this._rb=null;this._sDialogWidth=null;this._sDialogHeight=null;this._bAppendedToUIArea=null;this._showSubHeader=null;this._vContentPage=null;this._oContentItem=null;this._oPreviousState=null;this._sortContent=null;this._groupContent=null;this._filterContent=null;this._sCustomTabsButtonsIdPrefix=null;this._fnFilterSearchCallback=null;this._oKeylessFilters=null;if(this._bAppendedToUIArea&&this._dialog){var i=sap.ui.getCore().getStaticAreaRef();i=sap.ui.getCore().getUIArea(i);i.removeContent(this._dialog,true);}if(this._dialog){this._dialog.destroy();this._dialog=null;}if(this._navContainer){this._navContainer.destroy();this._navContainer=null;}if(this._titleLabel){this._titleLabel.destroy();this._titleLabel=null;}if(this._page1){this._page1.destroy();this._page1=null;}if(this._header){this._header.destroy();this._header=null;}if(this._resetButton){this._resetButton.destroy();this._resetButton=null;}if(this._subHeader){this._subHeader.destroy();this._subHeader=null;}if(this._segmentedButton){this._segmentedButton.destroy();this._segmentedButton=null;}if(this._sortButton){this._sortButton.destroy();this._sortButton=null;}if(this._groupButton){this._groupButton.destroy();this._groupButton=null;}if(this._filterButton){this._filterButton.destroy();this._filterButton=null;}if(this._sortList){this._sortList.destroy();this._sortList=null;}if(this._ariaSortListInvisibleText){this._ariaSortListInvisibleText.destroy();this._ariaSortListInvisibleText=null;}if(this._sortOrderList){this._sortOrderList.destroy();this._sortOrderList=null;this._ariaSortOrderInvisibleText.destroy();this._ariaSortOrderInvisibleText=null;}if(this._oGroupingNoneItem){this._oGroupingNoneItem.destroy();this._oGroupingNoneItem=null;}if(this._groupList){this._groupList.destroy();this._groupList=null;this._ariaGroupListInvisibleText.destroy();this._ariaGroupListInvisibleText=null;}if(this._groupOrderList){this._groupOrderList.destroy();this._groupOrderList=null;this._ariaGroupOrderInvisibleText.destroy();this._ariaGroupOrderInvisibleText=null;}if(this._presetFilterList){this._presetFilterList.destroy();this._presetFilterList=null;}if(this._filterList){this._filterList.destroy();this._filterList=null;}if(this._ariaFilterByInvisibleText){this._ariaFilterByInvisibleText.destroy();this._ariaFilterByInvisibleText=null;}if(this._page2){this._page2.destroy();this._page2=null;}if(this._detailTitleLabel){this._detailTitleLabel.destroy();this._detailTitleLabel=null;}if(this._filterDetailList){this._filterDetailList.destroy();this._filterDetailList=null;}if(this._oStringFilter){this._oStringFilter=null;}if(this._oSelectedFilterKeys){this._oSelectedFilterKeys=null;}};
w.prototype._aggregationToListItems=function(i,j,k,U,W){var X=this._getListType(i),Y="_"+X+"List";if(!this.mToList){this.mToList={};}this.mToList[X]={"itemPropertyMap":j,"itemAggregationMap":k,"listItemOptions":U,"listOptions":W,"listName":Y};};
w.prototype._getListType=function(i){return i.replace('Items','');};
w.prototype._createList=function(i){var j=this.getId()+"-"+i+"list",k=new L(j,this.mToList[i].listOptions),U=this._createGroupHeaderItem(i);k.addItem(U);this[this.mToList[i].listName]=k;return k;};
w.prototype._createGroupHeaderItem=function(i){return new G({title:this._rb.getText("VIEWSETTINGS_"+i.toUpperCase()+"_OBJECT")});};
w.prototype._getList=function(i){if(!this.mToList||!this.mToList[i]){return;}return this[this.mToList[i].listName];};
w.prototype._createListItem=function(i,j){var k=this.mToList[i].listItemOptions,U=this.mToList[i].itemPropertyMap,W=this.mToList[i].itemAggregationMap,X,Y;for(var Z in U){if(U.hasOwnProperty(Z)){X=U[Z].listProp||Z;k[X]=this._createListItemPropertyValue(i,Z,j);}}for(var $ in W){if(W.hasOwnProperty($)){k[$]=j.getAggregation($);}}Y=new b(k).data('item',j);return Y;};
w.prototype._createListItemPropertyValue=function(i,j,k){var U=k.getMetadata().getAllProperties()[j].get(k),W=this.mToList[i].itemPropertyMap[j].fn;return W?W(U):U;};
w.prototype._getListItem=function(i,j){var k=this._getList(i).getItems().filter(function(U){return U.data('item')===j;});return k.length?k[0]:null;};
w.prototype._getVSItem=function(i){return i.data('item');};
w.prototype.addCustomTab=function(i){var j=i.getId();if(j==='sort'||j==='filter'||j==='group'){throw'Id "'+j+'" is reserved and cannot be used as custom tab id.';}this.addAggregation('customTabs',i);return this;};
w.prototype.invalidate=function(){if(this._dialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._dialog.invalidate(arguments);}};
w.prototype.addStyleClass=function(){var i=this._getDialog();i.addStyleClass.apply(i,arguments);return this;};
w.prototype.removeStyleClass=function(){var i=this._getDialog();i.removeStyleClass.apply(i,arguments);return this;};
w.prototype.toggleStyleClass=function(){var i=this._getDialog();i.toggleStyleClass.apply(i,arguments);return this;};
w.prototype.hasStyleClass=function(){var i=this._getDialog();return i.hasStyleClass.apply(i,arguments);};
w.prototype.getDomRef=function(){if(this._dialog){return this._dialog.getDomRef.apply(this._dialog,arguments);}else{return null;}};
w.prototype.setTitle=function(i){this._getTitleLabel().setText(i);this.setProperty("title",i);return this;};
w.prototype.setTitleAlignment=function(i){this.setProperty("titleAlignment",i);if(this._page1){this._page1.setTitleAlignment(i);}if(this._page2){this._page2.setTitleAlignment(i);}return this;};
w.prototype.addAggregation=function(i,j,k){C.prototype.addAggregation.apply(this,arguments);var U=this._getListType(i);if(this.mToList[U]){var W=this._createListItem(U,j);var X=this._getList(U);if(!X){X=this._createList(U);}else if(!X.getItems().length){X.addItem(this._createGroupHeaderItem(U));}X.addItem(W);this._attachItemPropertyChange(U,j);}else{this._attachItemEventHandlers(i,j);}if(i==="filterItems"){this._observeItem(j);}return this;};
w.prototype.insertAggregation=function(i,j,k,U){C.prototype.insertAggregation.apply(this,arguments);var W=this._getListType(i);if(this.mToList[W]){var X=this._createListItem(W,j);var Y=this._getList(W);if(!Y){Y=this._createList(W);Y.insertItem(X,k);}else if(!Y.getItems().length){Y.addItem(this._createGroupHeaderItem(W));Y.insertItem(X,k+1);}else{Y.insertItem(X,k);}this._attachItemPropertyChange(W,j);}else{this._attachItemEventHandlers(i,j);}if(i==="filterItems"){this._observeItem(j);}return this;};
w.prototype.removeAggregation=function(i,j,k){F.call(this,i,j);var U=C.prototype.removeAggregation.apply(this,arguments);var W=this._getListType(i);if(this.mToList[W]){var X=this._getListItem(W,U);var Y=this._getList(W);var Z=Y.removeItem(X);Z.destroy();this._detachItemPropertyChange(U);}if(i==="filterItems"){this._unobserveItem(U);if(!this.getFilterItems().length){this._disconnectAndDestroyFilterItemsObserver();}}return U;};
w.prototype.removeAllAggregation=function(i,j){F.call(this);var k=C.prototype.removeAllAggregation.apply(this,arguments);var U=this._getListType(i);if(this.mToList[U]){var W=this._getList(U);if(W){var X=W.removeAllItems();X.forEach(function(Y){Y.destroy();});}k.forEach(function(Y){this._detachItemPropertyChange(Y);},this);}if(i==="filterItems"){this._disconnectAndDestroyFilterItemsObserver();}return k;};
w.prototype.destroyAggregation=function(i,j){F.call(this);C.prototype.destroyAggregation.apply(this,arguments);var k=this._getListType(i);if(this.mToList[k]){var U=this._getList(k);if(U){U.destroyItems();}}if(i==="filterItems"){this._disconnectAndDestroyFilterItemsObserver();}return this;};
w.prototype._detachItemPropertyChange=function(i){delete E.getEventList(i)["itemPropertyChanged"];};
w.prototype._attachItemPropertyChange=function(i,j){j.attachEvent('itemPropertyChanged',function _(k){var U,W,X,Y,Z,$;U=this._getListItem(i,j);W=k.getParameter('propertyKey');if(!this.mToList[i].itemPropertyMap[W]){return;}X=this.mToList[i].itemPropertyMap[W].listProp||W;Y=k.getParameter('propertyValue');Z=this.mToList[i].itemPropertyMap[W].fn;$=Z?Z(Y):Y;U.getMetadata().getAllProperties()[X].set(U,$);},this);};
w.prototype._getFilterItemsObserver=function(){if(!this._oFilterItemsObserver){this._oFilterItemsObserver=new g(function(){if(this._oSelectedFilterKeys){this.setSelectedFilterCompoundKeys(this._oSelectedFilterKeys);}}.bind(this));}return this._oFilterItemsObserver;};
w.prototype._observeItem=function(i){this._getFilterItemsObserver().observe(i,{aggregations:["items"]});};
w.prototype._unobserveItem=function(i){this._getFilterItemsObserver().unobserve(i,{aggregations:["items"]});};
w.prototype._disconnectAndDestroyFilterItemsObserver=function(){if(this._oFilterItemsObserver){this._oFilterItemsObserver.disconnect();this._oFilterItemsObserver.destroy();this._oFilterItemsObserver=null;}};
w.prototype._attachItemEventHandlers=function(i,j){if(i!=='groupItems'&&i!=='filterItems'){return this;}var k=i.replace('Items','');k=k.charAt(0).toUpperCase()+k.slice(1);j.attachEvent('itemPropertyChanged',function(i,U){if(i==='filterItems'&&U.getParameter('changedItem').getParent().getMetadata().getName()==='sap.m.ViewSettingsFilterItem'){if(U.getParameter('propertyKey')!=='selected'){if(this._vContentPage===3&&this._oContentItem){this._setFilterDetailTitle(this._oContentItem);this._initFilterDetailItems(this._oContentItem);}}else{if(this._filterDetailList){var W=this._filterDetailList.getItems();W.forEach(function(X){if(X.data('item').getId()===U.getParameter('changedItem').getId()){X.setSelected(U.getParameter('propertyValue'));}});this._updateSelectAllCheckBoxState();}}this._updateFilterCounters();}else{if(typeof this['_init'+k+'Content']==='function'){this['_init'+k+'Content']();}if(typeof this['_init'+k+'Items']==='function'){if(U.getParameter("propertyKey")==="selected"&&U.getParameter("propertyValue")===true){this.setAssociation("selectedGroupItem",U.getParameter("changedItem"),true);}this['_init'+k+'Items']();}}}.bind(this,i));j.attachEvent('filterDetailItemsAggregationChange',function(U){if(this._vContentPage===3&&this._oContentItem){this._setFilterDetailTitle(this._oContentItem);this._initFilterDetailItems(this._oContentItem);}}.bind(this));return this;};
w.prototype._setFilterDetailTitle=function(i){var j=this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY")+" "+i.getText();this._getDetailTitleLabel().setText(j);this._toggleDialogTitle(this._sFilterDetailTitleLabelId);};
w.prototype._toggleDialogTitle=function(i){var j=this._getDialog(),k=j.getAriaLabelledBy(),U=[this._sTitleLabelId,this._sFilterDetailTitleLabelId];if(U.indexOf(i)===-1&&k.indexOf(i)>-1){return this;}for(var W in U){j.removeAriaLabelledBy(U[W]);}j.addAriaLabelledBy(i);return this;};
w.prototype.updateAggregation=function(i){C.prototype.updateAggregation.apply(this,arguments);if(i!=='groupItems'&&i!=='filterItems'){return this;}var j=i.replace('Items','');j=j.charAt(0).toUpperCase()+j.slice(1);if(typeof this['_init'+j+'Content']==='function'){this['_init'+j+'Content']();}if(typeof this['_init'+j+'Items']==='function'){this['_init'+j+'Items']();}};
w.prototype.addSortItem=function(i){this.addAggregation("sortItems",i);if(i.getSelected()){this.setSelectedSortItem(i);}return this;};
w.prototype.addGroupItem=function(i){this.addAggregation("groupItems",i);if(i.getSelected()){this.setSelectedGroupItem(i);}return this;};
w.prototype.addPresetFilterItem=function(i){this.addAggregation("presetFilterItems",i);if(i.getSelected()){this.setSelectedPresetFilterItem(i);}return this;};
w.prototype.setSelectedSortItem=function(j){var k=this.getSortItems(),i=0,U=z(j,k,"Could not set selected sort item. Item is not found: '"+j+"'");if(!U||A(U)){for(i=0;i<k.length;i++){if(!U||k[i].getId()!==U.getId()){k[i].setProperty('selected',false,true);}}if(U&&U.getProperty('selected')!==true){U.setProperty('selected',true,true);}if(this._getDialog().isOpen()){this._updateListSelection(this._sortList,U);}this.setAssociation("selectedSortItem",U,true);}return this;};
w.prototype.setSelectedGroupItem=function(j){var k=this.getGroupItems(),i=0,U=z(j,k,"Could not set selected group item. Item is not found: '"+j+"'");if(!U&&!j){U=this._oGroupingNoneItem;}if(A(U)){for(i=0;i<k.length;i++){k[i].setProperty('selected',false,true);}U.setProperty('selected',true,true);if(this._getDialog().isOpen()){this._updateListSelection(this._groupList,U);}this.setAssociation("selectedGroupItem",U,true);}return this;};
w.prototype.setSelectedPresetFilterItem=function(j){var k=this.getPresetFilterItems(),i=0,U=z(j,k,"Could not set selected preset filter item. Item is not found: '"+j+"'");if(A(U)||U===null){for(i=0;i<k.length;i++){k[i].setProperty('selected',false,true);}if(U!==null){U.setProperty('selected',true,true);}this._clearSelectedFilters();this.setAssociation("selectedPresetFilterItem",U,true);}return this;};
w.prototype.open=function(i){if(!this.getParent()&&!this._bAppendedToUIArea){var j=sap.ui.getCore().getStaticAreaRef();j=sap.ui.getCore().getUIArea(j);j.addContent(this._getDialog(),true);this._bAppendedToUIArea=true;}if(i&&this._vContentPage===3){setTimeout(this._getNavContainer()["to"].bind(this._getNavContainer(),this._getPage1().getId(),"show"),0);}this._initDialogContent(i);this._oPreviousState={sortItem:sap.ui.getCore().byId(this.getSelectedSortItem()),sortDescending:this.getSortDescending(),groupItem:sap.ui.getCore().byId(this.getSelectedGroupItem()),groupDescending:this.getGroupDescending(),presetFilterItem:sap.ui.getCore().byId(this.getSelectedPresetFilterItem()),filterKeys:this.getSelectedFilterKeys(),filterCompoundKeys:this.getSelectedFilterCompoundKeys(),navPage:this._getNavContainer().getCurrentPage(),contentPage:this._vContentPage,contentItem:this._oContentItem};if(!this._oInitialState){this._oInitialState={sortItem:this.getSelectedSortItem(),sortDescending:this.getSortDescending(),groupItem:this.getSelectedGroupItem(),groupDescending:this.getGroupDescending(),presetFilterItem:this.getSelectedPresetFilterItem()};}if(h.system.desktop){this._getDialog().attachEventOnce("afterOpen",function(){var k=this._getNavContainer().getCurrentPage(),$;if(k){$=k.$("cont").firstFocusableDomRef();if($){if(q($).hasClass('sapMListUl')){var U=q($).find('.sapMLIB');U.length&&U[0].focus();return;}$.focus();}}},this);}this._checkResetStatus();this._getDialog().open();return this;};
w.prototype.getSelectedFilterItems=function(){var k=[],U=this.getFilterItems(),W,X=true,i=0,j;for(;i<U.length;i++){if(U[i]instanceof sap.m.ViewSettingsCustomItem){if(U[i].getSelected()){k.push(U[i]);}}else if(U[i]instanceof sap.m.ViewSettingsFilterItem){W=U[i].getItems();X=U[i].getMultiSelect();for(j=0;j<W.length;j++){if(W[j].getSelected()){k.push(W[j]);if(!X){break;}}}}}return k;};
w.prototype.getSelectedFilterString=function(){var k="",U,W=this.getSelectedPresetFilterItem(),X=this.getFilterItems(),Y,Z=true,i=0,j;if(W){k=this._rb.getText("VIEWSETTINGS_FILTERTEXT").concat(" "+sap.ui.getCore().byId(W).getText());}else{for(;i<X.length;i++){if(X[i]instanceof sap.m.ViewSettingsCustomItem){if(X[i].getSelected()){k+=X[i].getText()+", ";}}else if(X[i]instanceof sap.m.ViewSettingsFilterItem){Y=X[i].getItems();Z=X[i].getMultiSelect();U="";for(j=0;j<Y.length;j++){if(Y[j].getSelected()){U+=Y[j].getText()+", ";if(!Z){break;}}}U=U.substring(0,U.length-2);if(U){U=" ("+U+")";k+=X[i].getText()+U+", ";}}}k=k.substring(0,k.length-2);if(k){k=this._rb.getText("VIEWSETTINGS_FILTERTEXT").concat(" "+k);}}return k;};
w.prototype.getSelectedFilterKeys=function(){var j={},k=this.getSelectedFilterItems(),i=0;for(;i<k.length;i++){j[k[i].getKey()]=k[i].getSelected();}return j;};
w.prototype.getSelectedFilterCompoundKeys=function(){var j={},k=this.getSelectedFilterItems(),i,U,W,X;this._oKeylessFilters={};for(i=0;i<k.length;i++){X=k[i];if(X instanceof sap.m.ViewSettingsCustomItem){U=X.getKey();j[U]=X.getSelected();}else{U=X.getKey();W=X.getParent().getKey();if(!j[W]){j[W]={};}j[W][U]=X.getSelected();if(U===""){if(!this._oKeylessFilters[W]){this._oKeylessFilters[W]={};}this._oKeylessFilters[W][X.getText()]=true;}}}return j;};
w.prototype.setSelectedFilterKeys=function(U){var W=this.getFilterItems(),X={},Y,Z,i,j,k;if(Object.keys(U).length){this._clearPresetFilter();}for(var $ in U){Y=null;if(U.hasOwnProperty($)){for(i=0;i<W.length;i++){if(W[i]instanceof sap.m.ViewSettingsCustomItem){if(W[i].getKey()===$){Y=W[i];W[i].setProperty('selected',U[$],true);}}else if(W[i]instanceof sap.m.ViewSettingsFilterItem){X=W[i].getItems();Z=W[i].getMultiSelect();for(j=0;j<X.length;j++){if(X[j].getKey()===$){Y=X[j];if(!Z){for(k=0;k<X.length;k++){X[k].setProperty('selected',false,true);}}break;}}}if(Y){break;}}if(Y===null){o.warning('Cannot set state for key "'+$+'" because there is no filter with these keys');continue;}Y.setProperty('selected',U[$],true);}}return this;};
w.prototype.setSelectedFilterCompoundKeys=function(i){var j=this.getFilterItems(),k,U,W,X,Y,Z,$,_,a1,b1;this._oSelectedFilterKeys=i;if(Object.keys(i).length){this._clearPresetFilter();for(k in i){X=null;for(b1=0;b1<j.length;b1++){U=j[b1].getKey();if(U===k){X=j[b1];break;}}if(X instanceof sap.m.ViewSettingsCustomItem){X.setProperty('selected',i[k],true);}else if(X instanceof sap.m.ViewSettingsFilterItem){Y=i[k];Z=X.getItems();$=X.getMultiSelect();a1=false;for(b1=0;b1<Z.length;b1++){U=Z[b1].getKey();W=Z[b1].getText();if((U!==""&&Y[U])||(U===""&&this._oKeylessFilters[k]&&this._oKeylessFilters[k][W])){_=a1?false:Y[U];}else{_=false;}Z[b1].setProperty("selected",_,true);if(_&&!$){a1=true;}}}}}return this;};
w.prototype._checkForInnerCustomItems=function(j){for(var i=0;i<j.length;i++){if(j[i].isA("sap.m.ViewSettingsCustomItem")){return true;}}return false;};
w.prototype._checkForCustomItems=function(){var i=this.getSortItems(),j=this.getGroupItems(),k=this.getFilterItems(),U=this.getPresetFilterItems();return this.getAggregation("customTabs").length||i.length&&this._checkForInnerCustomItems(i)||j.length&&this._checkForInnerCustomItems(j)||k.length&&this._checkForInnerCustomItems(k)||U.length&&this._checkForInnerCustomItems(U);};
w.prototype._checkResetStatus=function(){var i=false,j=this.getSelectedFilterItems();if(this._checkForCustomItems()){i=true;}else{if(this._oInitialState){if(j.length>0){i=true;}if(this._oInitialState.sortItem!==this.getSelectedSortItem()||this._oInitialState.sortDescending!==this.getSortDescending()){i=true;}if((this._oInitialState.groupItem&&this._oInitialState.groupItem!==this.getSelectedGroupItem())||this._oInitialState.groupDescending!==this.getGroupDescending()){i=true;}if(this._oInitialState.presetFilterItem!==undefined&&this.getSelectedPresetFilterItem()!==null){i=true;}}}if(this._resetButton){this._resetButton.setEnabled(i);}if(this._detailResetButton){this._detailResetButton.setEnabled(i);}};
w.prototype._globalReset=function(){this.clearFilters();this.setSelectedSortItem(sap.ui.getCore().byId(this._oInitialState.sortItem));this.setSortDescending(this._oInitialState.sortDescending);this._updateListSelection(this._sortOrderList,this._oInitialState.sortDescending);this._oInitialState.groupItem!==undefined&&this.setSelectedGroupItem(sap.ui.getCore().byId(this._oInitialState.groupItem));this.setGroupDescending(this._oInitialState.groupDescending);this._updateListSelection(this._groupOrderList,this._oInitialState.groupDescending);this._checkResetStatus();this.fireReset();};
w.prototype._getDialog=function(){var i=this;if(this._dialog===undefined){this._dialog=new D(this.getId()+"-dialog",{ariaLabelledBy:this._sTitleLabelId,showHeader:false,stretch:h.system.phone,verticalScrolling:true,horizontalScrolling:false,contentWidth:this._sDialogWidth,contentHeight:this._sDialogHeight,content:this._getNavContainer(),titleAlignment:this.getTitleAlignment(),beginButton:new B(this.getId()+"-acceptbutton",{text:this._rb.getText("VIEWSETTINGS_ACCEPT"),type:u.Emphasized}).attachPress(this._onConfirm,this),endButton:new B(this.getId()+"-cancelbutton",{text:this._rb.getText("VIEWSETTINGS_CANCEL")}).attachPress(this._onCancel,this)}).addStyleClass("sapMVSD");this.addDependent(this._dialog);var j=this._dialog.onsapescape;this._dialog.onsapescape=function(k){if(j){j.call(i._dialog,k);}i._onCancel();};this._dialog.onsapentermodifiers=function(k){if(k.shiftKey&&!k.ctrlKey&&!k.altKey){i._pressBackButton();}};}return this._dialog;};
w.prototype._getNavContainer=function(){if(this._navContainer===undefined){this._navContainer=new N(this.getId()+'-navcontainer',{pages:[]});}return this._navContainer;};
w.prototype._getTitleLabel=function(){if(this._titleLabel===undefined){this._titleLabel=new d(this._sTitleLabelId,{text:this._rb.getText("VIEWSETTINGS_TITLE")}).addStyleClass("sapMVSDTitle");}return this._titleLabel;};
w.prototype._getResetButton=function(){if(!this._resetButton){this._resetButton=new B(this.getId()+"-resetbutton",{press:function(){this._globalReset();}.bind(this),text:this._rb.getText("VIEWSETTINGS_RESET")});}return this._resetButton;};
w.prototype._getDetailResetButton=function(){if(this._detailResetButton===undefined){this._detailResetButton=new B(this.getId()+"-detailresetbutton",{press:function(){this._globalReset();}.bind(this),text:this._rb.getText("VIEWSETTINGS_RESET")});}return this._detailResetButton;};
w.prototype._getDetailTitleLabel=function(){if(this._detailTitleLabel===undefined){this._detailTitleLabel=new d(this.getId()+"-detailtitle",{text:this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY")}).addStyleClass("sapMVSDTitle");}return this._detailTitleLabel;};
w.prototype._getHeader=function(){if(this._header===undefined){this._header=new e({titleAlignment:this.getTitleAlignment(),contentMiddle:[this._getTitleLabel()]}).addStyleClass("sapMVSDBar");}return this._header;};
w.prototype._getSubHeader=function(){if(this._subHeader===undefined){this._subHeader=new e({contentLeft:[this._getSegmentedButton()]}).addStyleClass("sapMVSDBar");}return this._subHeader;};
w.prototype._getSegmentedButton=function(){var j=this,k=this.getCustomTabs(),U=k.length,i=0;if(this._segmentedButton===undefined){this._segmentedButton=new f({select:function(W){var X=W.getParameter('id');if(X===j.getId()+"-sortbutton"){j._switchToPage(0);}else if(X===j.getId()+"-groupbutton"){j._switchToPage(1);}else if(X===j.getId()+"-filterbutton"){j._switchToPage(2);}else{for(i=0;i<U;i++){var Y=k[i],Z=j.getId()+j._sCustomTabsButtonsIdPrefix+Y.getId();if(!j._isEmptyTab(Y)&&X===Z){j._switchToPage(Y.getId());break;}}}o.info('press event segmented: '+W.getParameter('id'));}}).addStyleClass("sapMVSDSeg");this._segmentedButton._bPreventWidthRecalculationOnAfterRendering=true;}return this._segmentedButton;};
w.prototype._getSortButton=function(){if(this._sortButton===undefined){this._sortButton=new B(this.getId()+"-sortbutton",{icon:I.getIconURI("sort"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_SORT")});}return this._sortButton;};
w.prototype._getGroupButton=function(){if(this._groupButton===undefined){this._groupButton=new B(this.getId()+"-groupbutton",{icon:I.getIconURI("group-2"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_GROUP")});}return this._groupButton;};
w.prototype._getFilterButton=function(){if(this._filterButton===undefined){this._filterButton=new B(this.getId()+"-filterbutton",{icon:I.getIconURI("filter"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_FILTER")});}return this._filterButton;};
w.prototype._getPage1=function(i){if(this._page1===undefined&&!i){this._page1=new P(this.getId()+'-page1',{title:this._rb.getText("VIEWSETTINGS_TITLE"),titleAlignment:this.getTitleAlignment(),customHeader:this._getHeader()});this._getNavContainer().addPage(this._page1);}return this._page1;};
w.prototype._getPage2=function(){var i,j,k,U=this.getTitleAlignment();if(this._page2===undefined){j=new B(this.getId()+"-backbutton",{icon:I.getIconURI("nav-back"),press:[this._pressBackButton,this]});k=this._getDetailResetButton();i=new e({titleAlignment:U,contentLeft:[j],contentMiddle:[this._getDetailTitleLabel()],contentRight:[k]}).addStyleClass("sapMVSDBar");this._page2=new P(this.getId()+'-page2',{title:this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY"),titleAlignment:U,customHeader:i});this._getNavContainer().addPage(this._page2);}return this._page2;};
w.prototype._initFilterDetailItems=function(k){if(!(k instanceof sap.m.ViewSettingsFilterItem)){return;}var U;var W=k.getMultiSelect();var X=k.getItems();var Y=this;if(this._filterDetailList){this._filterDetailList.destroy();}this._getPage2().removeAllAggregation('content');this._filterDetailList=new L({mode:(W?p.MultiSelect:p.SingleSelectLeft),includeItemInSelection:true,selectionChange:function(Z){var $,_=Z.getParameter("listItems"),a1,i=0,b1;Y._clearPresetFilter();if(W){this._updateSelectAllCheckBoxState();}if(_.length>1&&W){a1=k.getItems();for(;i<a1.length;i++){for(var j=0;j<_.length;j++){if(a1[i].getKey()===_[j].getCustomData()[0].getValue().getKey()){a1[i].setProperty('selected',_[j].getSelected(),true);}}}}else{$=Z.getParameter("listItem").data("item");if(!k.getMultiSelect()){a1=k.getItems();for(;i<a1.length;i++){if(a1[i].getId()!==$.getId()){a1[i].setProperty('selected',false,true);}}}b1=Z.getParameter("listItem").getSelected();if($.getProperty('selected')!==b1){$.setProperty('selected',b1,true);}}this._checkResetStatus();}.bind(this),ariaLabelledBy:this._sFilterDetailTitleLabelId});for(var i=0;i<X.length;i++){U=new b({title:M.escapeSettingsValue(X[i].getText()),type:r.Active,selected:X[i].getSelected(),tooltip:X[i].getTooltip()}).data("item",X[i]);this._filterDetailList.addItem(U);}this._filterSearchField=this._getFilterSearchField(this._filterDetailList);this._showOnlySelectedButton=this._getShowOnlySelectedButton();this._searchBar=new T({content:[this._filterSearchField.addStyleClass('sapMVSDFilterSearchField').addStyleClass('sapMTBShrinkItem'),this._showOnlySelectedButton]});this._getPage2().addContent(this._searchBar);this._getPage2().getCustomHeader().addStyleClass('sapMVSDBarWithSearch');if(W){this._selectAllCheckBox=this._createSelectAllCheckbox(X,this._filterDetailList);if(this._filterDetailList.getItems().length===0){this._selectAllCheckBox.setEnabled(false);}this._filterDetailList.setHeaderToolbar(new T({content:[this._selectAllCheckBox]}).addStyleClass('sapMVSDFilterHeaderToolbar'));}this._setFilterDetailItemsVisibility(this._filterDetailList,true);this._getPage2().addContent(this._filterDetailList);};
w.prototype._initSortContent=function(){if(this._sortContent){return;}this._vContentPage=-1;this._ariaSortOrderInvisibleText=new m(this.getId()+"-sortOrderLabel",{text:this._rb.getText("VIEWSETTINGS_SORT_DIRECTION")});this._sortOrderList=new L(this.getId()+"-sortorderlist",{mode:p.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(i){this.setProperty('sortDescending',i.getParameter("listItem").data("item"),true);this._checkResetStatus();}.bind(this),ariaLabelledBy:this._ariaSortOrderInvisibleText});this._sortOrderList.addItem(new G({title:this._rb.getText("VIEWSETTINGS_SORT_BY")}));this._sortOrderList.addItem(new b({title:this._rb.getText("VIEWSETTINGS_ASCENDING_ITEM")}).data("item",false).setSelected(true));this._sortOrderList.addItem(new b({title:this._rb.getText("VIEWSETTINGS_DESCENDING_ITEM")}).data("item",true));this._ariaSortListInvisibleText=new m(this.getId()+"-sortListLabel",{text:this._rb.getText("VIEWSETTINGS_TITLE_SORT")});this._sortList.addAriaLabelledBy(this._ariaSortListInvisibleText);this._sortContent=[this._ariaSortOrderInvisibleText,this._sortOrderList,this._ariaSortListInvisibleText,this._sortList];};
w.prototype._initGroupItems=function(){var i,j,k=this.getGroupItems(),U=this._rb.getText("VIEWSETTINGS_GROUP_OBJECT");this._groupList.destroyItems();if(k.length){this._groupList.addItem(new G({title:U}));k.forEach(function(W){i=new b({id:W.getId()+v,title:M.escapeSettingsValue(W.getText()),type:r.Active,selected:W.getSelected(),tooltip:W.getTooltip()}).data("item",W);this._groupList.addItem(i);},this);if(!this._oGroupingNoneItem||this._oGroupingNoneItem.bIsDestroyed){j=!!this.getSelectedGroupItem();this._oGroupingNoneItem=new V({text:this._rb.getText("VIEWSETTINGS_NONE_ITEM"),selected:!j,itemPropertyChanged:function(){this._initGroupContent();this._initGroupItems();}.bind(this)});!j&&this.setAssociation("selectedGroupItem",this._oGroupingNoneItem,true);}i=new b({id:this._oGroupingNoneItem.getId()+v,title:this._oGroupingNoneItem.getText(),type:r.Active,selected:this._oGroupingNoneItem.getSelected()}).data("item",this._oGroupingNoneItem);this._groupList.addItem(i);}};
w.prototype._initGroupContent=function(){var i=this._rb.getText("VIEWSETTINGS_GROUP_BY");if(this._groupContent){return;}this._vContentPage=-1;this._ariaGroupOrderInvisibleText=new m(this.getId()+"-groupOrderLabel",{text:this._rb.getText("VIEWSETTINGS_GROUP_DIRECTION")});this._groupOrderList=new L(this.getId()+"-grouporderlist",{mode:p.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(j){this.setProperty('groupDescending',j.getParameter("listItem").data("item"),true);this._checkResetStatus();}.bind(this),ariaLabelledBy:this._ariaGroupOrderInvisibleText});this._groupOrderList.addItem(new G({title:i}));this._groupOrderList.addItem(new b({title:this._rb.getText("VIEWSETTINGS_ASCENDING_ITEM")}).data("item",false).setSelected(true));this._groupOrderList.addItem(new b({title:this._rb.getText("VIEWSETTINGS_DESCENDING_ITEM")}).data("item",true));this._ariaGroupListInvisibleText=new m(this.getId()+"-groupListLabel",{text:this._rb.getText("VIEWSETTINGS_TITLE_GROUP")});this._groupList=new L(this.getId()+"-grouplist",{mode:p.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(j){var k=j.getParameter("listItem").data("item");this.setSelectedGroupItem(k);this._checkResetStatus();}.bind(this),ariaLabelledBy:this._ariaGroupListInvisibleText});this._groupContent=[this._ariaGroupOrderInvisibleText,this._groupOrderList,this._ariaGroupListInvisibleText,this._groupList];};
w.prototype._initFilterItems=function(){var i,j,k,U=this,W=this._rb.getText("VIEWSETTINGS_FILTER_BY");this._presetFilterList.destroyItems();i=this.getPresetFilterItems();if(i.length){i.forEach(function(X){k=new b({id:X.getId()+v,title:M.escapeSettingsValue(X.getText()),type:r.Active,selected:X.getSelected(),tooltip:X.getTooltip()}).data("item",X);this._presetFilterList.addItem(k);},this);}if(i.length){k=new b({id:this._presetFilterList.getId()+"-none"+v,title:this._rb.getText("VIEWSETTINGS_NONE_ITEM_FILTER"),selected:!!this.getSelectedPresetFilterItem()});this._presetFilterList.addItem(k);}this._filterList.destroyItems();j=this.getFilterItems();this._filterList.addItem(new G({title:W}));if(j.length){j.forEach(function(X){k=new b({id:X.getId()+v,title:M.escapeSettingsValue(X.getText()),type:r.Active,tooltip:X.getTooltip(),press:(function(X){return function(Y){if(U._navContainer.getCurrentPage().getId()!==U.getId()+'-page2'){U._switchToPage(3,X);U._prevSelectedFilterItem=this;setTimeout(U._navContainer["to"].bind(U._navContainer,U.getId()+'-page2',"slide"),0);}if(h.system.desktop&&U._filterDetailList&&U._filterDetailList.getItems()[0]){U._getNavContainer().attachEventOnce("afterNavigate",function(){U._filterDetailList.getItems()[0].focus();});}};}(X))}).data("item",X);this._filterList.addItem(k);},this);}};
w.prototype._initFilterContent=function(){if(this._filterContent){return;}this._vContentPage=-1;this._ariaFilterByInvisibleText=new m(this.getId()+"-filterByLabel",{text:this._rb.getText("VIEWSETTINGS_TITLE_FILTER")});this._presetFilterList=new L(this.getId()+"-predefinedfilterlist",{mode:p.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(i){var j=i.getParameter("listItem").data("item");if(j){j.setProperty('selected',i.getParameter("listItem").getSelected(),true);}this.setAssociation("selectedPresetFilterItem",j,true);this._clearSelectedFilters();this._checkResetStatus();}.bind(this)});this._filterList=new L(this.getId()+"-filterlist",{ariaLabelledBy:this._ariaFilterByInvisibleText});this._filterContent=[this._ariaFilterByInvisibleText,this._presetFilterList,this._filterList];};
w.prototype._initDialogContent=function(i){var j=!!this.getSortItems().length,k=!!this.getGroupItems().length,U=!!this.getPresetFilterItems().length,W=!!this.getFilterItems().length;if(j){this._initSortContent();}if(k){this._initGroupContent();this._initGroupItems();}if(U||W){this._initFilterContent();this._initFilterItems();}this._updateDialogState(i);this._updateListSelections();};
w.prototype._getTabButton=function(i,j){var k=j+i.getId(),U=sap.ui.getCore().byId(k);if(U){return U;}else{return new B({id:k,icon:i.getIcon(),tooltip:i.getTooltip()});}};
w.prototype._updateDialogState=function(i){var j=!!this.getSortItems().length,k=!!this.getGroupItems().length,U=!!this.getPresetFilterItems().length,W=!!this.getFilterItems().length,X=!!this.getCustomTabs().length,Y=this._getSegmentedButton(),Z=null,$=false,_={"sort":0,"group":1,"filter":2};Y.removeAllButtons();if(this._filterContent){this._presetFilterList.setVisible(true);this._filterList.setVisible(true);}if(j){Y.addButton(this._getSortButton());}if(U||W){Y.addButton(this._getFilterButton());if(!U){this._presetFilterList.setVisible(false);}if(!W){this._filterList.setVisible(false);}}if(k){Y.addButton(this._getGroupButton());}if(X){this.getCustomTabs().forEach(function(b1){if(!this._isEmptyTab(b1)){var c1=this.getId()+this._sCustomTabsButtonsIdPrefix,d1=this._getTabButton(b1,c1);Y.addButton(d1);}}.bind(this));}this._showSubHeader=this._hasSubHeader();if(i===undefined&&this._vContentPage!==-1){i=this._vContentPage;switch(i){case 0:i='sort';break;case 1:i='group';break;case 2:i='filter';break;}}if(i===this._vContentPage&&this._vContentPage===3){this._vContentPage=-1;this._switchToPage(3,this._oContentItem);}else{i=this._determineValidPageId(i);for(var a1 in _){if(i===a1){$=true;Z=this.getId()+'-'+i+'button';i=_[a1];break;}}if(!$){Z=this.getId()+this._sCustomTabsButtonsIdPrefix+i;}this._getSegmentedButton().setSelectedButton(Z);this._switchToPage(i);if(this._getNavContainer().getCurrentPage()!==this._getPage1()){this._getNavContainer().to(this._getPage1().getId());}}};
w.prototype._determineValidPageId=function(i){var j='sort',k=false,U=[];U=this._fetchValidPagesIds();if(U.length){j=U[0];}else{o.warning('No available pages to load - missing items.');}if(!i){i=j;}else{U.filter(function(W){if(W===i){k=true;return false;}return true;});if(!k){i=j;}}return i;};
w.prototype._fetchValidPagesIds=function(){var i,j=this.getCustomTabs(),k=j.length,U=[];var W=['sort','filter','group'];W.forEach(function(Y){if(this._isValidPredefinedPageId(Y)){U.push(Y);}},this);for(i=0;i<k;i++){var X=j[i];if(!this._isEmptyTab(X)){U.push(X.getId());}}return U;};
w.prototype._isEmptyTab=function(i){return!(i.getContent().length||this._vContentPage===i.getId()&&this._getPage1().getContent().length);};
w.prototype._isValidPredefinedPageId=function(i){if(!i){o.warning('Missing mandatory parameter.');return false;}var j=false;switch(i){case'sort':j=!!this.getSortItems().length;break;case'filter':j=!!this.getFilterItems().length||!!this.getPresetFilterItems().length;break;case'group':j=!!this.getGroupItems().length;break;}return j;};
w.prototype._pressBackButton=function(){var i=this;if(this._vContentPage===3){this._updateFilterCounters();this._getNavContainer().attachEvent("afterNavigate",function(){if(i._prevSelectedFilterItem){i._prevSelectedFilterItem.focus();}});setTimeout(this._getNavContainer()['back'].bind(this._getNavContainer()),0);this._switchToPage(2);this._segmentedButton.setSelectedButton(this._filterButton);}};
w.prototype.setModel=function(i,j){if(this._vContentPage===3&&this._oContentItem){x.call(this);}return C.prototype.setModel.call(this,i,j);};
w.prototype.removeFilterItem=function(i){var j="";if(this._vContentPage===3&&this._oContentItem){if(typeof(i)==="object"){j=i.getId();}else if(typeof(i)==="string"){j=i;}else if(typeof(i)==="number"){j=this.getFilterItems()[i].getId();}if(this._oContentItem.getId()===j){x.call(this);}}return this.removeAggregation('filterItems',i);};
w.prototype.removeAllFilterItems=function(){if(this._vContentPage===3&&this._oContentItem){x.call(this);}return this.removeAllAggregation('filterItems');};
w.prototype.setFilterSearchCallback=function(i){this._fnFilterSearchCallback=i;return this;};
w.prototype._switchToPage=function(W,j){var i=0,k=this._getTitleLabel(),U=this._getHeader(),X=this._getSubHeader();this._checkResetStatus();this._getPage2().getCustomHeader().removeStyleClass('sapMVSDBarWithSearch');if(H.call(this)){F.call(this);}U.removeAllContentRight();X.removeAllContentRight();this._vContentPage=W;this._oContentItem=j;if(W!==3){this._getPage1().removeAllAggregation("content",true);this._addResetButtonToPage1();}else if(W===3){this._getPage2().removeAllAggregation("content",true);}if(this.getTitle()){k.setText(this.getTitle());}else{k.setText(this._rb.getText("VIEWSETTINGS_TITLE"));}this._toggleDialogTitle(this._sTitleLabelId);switch(W){case 1:if(!this._showSubHeader&&!this.getTitle()){k.setText(this._rb.getText("VIEWSETTINGS_TITLE_GROUP"));}for(;i<this._groupContent.length;i++){this._getPage1().addContent(this._groupContent[i]);}break;case 2:if(!this._showSubHeader&&!this.getTitle()){k.setText(this._rb.getText("VIEWSETTINGS_TITLE_FILTER"));}this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));this._updateFilterCounters();for(;i<this._filterContent.length;i++){this._getPage1().addContent(this._filterContent[i]);}break;case 3:this._setFilterDetailTitle(j);if(j instanceof sap.m.ViewSettingsCustomItem&&j.getCustomControl()){this._clearPresetFilter();this._getPage2().addContent(j.getCustomControl());}else if(j instanceof sap.m.ViewSettingsFilterItem&&j.getItems()){this._initFilterDetailItems(j);}break;case 0:if(!this._getPage1().getSubHeader()&&!this.getTitle()){k.setText(this._rb.getText("VIEWSETTINGS_TITLE_SORT"));}if(this._sortContent){for(;i<this._sortContent.length;i++){this._getPage1().addContent(this._sortContent[i]);}}break;default:this._getPage1().removeAllAggregation("content",true);var Y="VIEWSETTINGS_TITLE";var Z=this.getCustomTabs();if(Z.length<2){Y=Z[0].getTitle();}if(!this._getPage1().getSubHeader()&&!this.getTitle()){k.setText(Y);}Z.forEach(function($){if($.getId()===W){$.getContent().forEach(function(_){this._getPage1().addContent(_);},this);}},this);break;}if(W===3){this.fireFilterDetailPageOpened({parentFilterItem:j});}};
w.prototype._createSelectAllCheckbox=function(i,j){var k=false;if(i&&i.length!==0){k=i.every(function(W){return W.getSelected();});}var U=new a({text:this._rb.getText("COLUMNSPANEL_SELECT_ALL"),selected:k,select:function(W){var X=W.getParameter('selected');j.getItems().filter(function(Y){return Y.getVisible();}).forEach(function(Y){var Z=Y.data("item");Z.setSelected(X);});this._checkResetStatus();}.bind(this)});return U;};
w.prototype._updateSelectAllCheckBoxState=function(){var i=false,j=this._filterDetailList.getItems(),k=[];if(!this._selectAllCheckBox){return;}if(j&&j.length!==0){k=j.filter(function(U){return U.getVisible();});}if(k.length!==0){this._selectAllCheckBox.setEnabled(true);i=k.every(function(U){return U.getSelected();});}else{this._selectAllCheckBox.setEnabled(false);}this._selectAllCheckBox.setSelected(i);};
w.prototype._visibilityBySearchField=function(i){var j=this._filterSearchField.getValue(),k=this._getStringFilter(),U=k(j,i.getTitle());return U;};
w.prototype._visibilityByToggleButton=function(i){var j=this._showOnlySelectedButton.getPressed()?i.getSelected():true;return j;};
w.prototype._getFilterSearchField=function(i){var j=new S({liveChange:function(){this._setFilterDetailItemsVisibility(i);}.bind(this)});return j;};
w.prototype._setFilterDetailItemsVisibility=function(i,j){i.getItems().forEach(function(k){k.setVisible(this._visibilityByToggleButton(k)&&(j||this._visibilityBySearchField(k)));}.bind(this));this._updateSelectAllCheckBoxState();};
w.prototype._getShowOnlySelectedButton=function(){var i=this._oContentItem&&this._oFiltersSelectedOnly[this._oContentItem.getId()]?true:false,j=new c({icon:I.getIconURI("multi-select"),tooltip:this._rb.getText("SHOW_SELECTED_ONLY"),type:u.Transparent,pressed:i,press:function(){var k=this._showOnlySelectedButton.getPressed(),U=this._oContentItem.getId();if(k){this._oFiltersSelectedOnly[U]=true;}else{delete this._oFiltersSelectedOnly[U];}this._setFilterDetailItemsVisibility(this._filterDetailList);}.bind(this)});return j;};
w.prototype._getStringFilter=function(){if(this._fnFilterSearchCallback){return this._fnFilterSearchCallback;}if(!this._oStringFilter||this._oStringFilter.sOperator!==this.getFilterSearchOperator()){this._oStringFilter=new J(this.getFilterSearchOperator());}return this._oStringFilter.filter.bind(this._oStringFilter);};
w.prototype._updateListSelections=function(){this._updateListSelection(this._sortList,sap.ui.getCore().byId(this.getSelectedSortItem()));this._updateListSelection(this._sortOrderList,this.getSortDescending());this._updateListSelection(this._groupList,sap.ui.getCore().byId(this.getSelectedGroupItem()));this._updateListSelection(this._groupOrderList,this.getGroupDescending());this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));this._updateFilterCounters();};
w.prototype._updateListSelection=function(j,k){var U,i=0,W;if(!j){return false;}U=j.getItems();j.removeSelections();for(;i<U.length;i++){W=U[i].isA("sap.m.GroupHeaderListItem");if(!W&&(U[i].data("item")===k||U[i].data("item")===null)){j.setSelectedItem(U[i],(k&&k.getSelected?k.getSelected():true));return true;}}return false;};
w.prototype._updateFilterCounters=function(){var k=(this._filterList?this._filterList.getItems():[]),U,W,X=0,i=0,j;for(;i<k.length;i++){U=k[i].data("item");X=0;if(U){if(U instanceof sap.m.ViewSettingsCustomItem){X=U.getFilterCount();}else if(U instanceof sap.m.ViewSettingsFilterItem){X=0;W=U.getItems();for(j=0;j<W.length;j++){if(W[j].getSelected()){X++;}}}}k[i].setCounter(X);}};
w.prototype._clearSelectedFilters=function(){var k=this.getFilterItems(),U,i=0,j;for(;i<k.length;i++){if(k[i]instanceof sap.m.ViewSettingsFilterItem){U=k[i].getItems();for(j=0;j<U.length;j++){U[j].setProperty('selected',false,true);}}k[i].setProperty('selected',false,true);}if(this._vContentPage===2&&this._getDialog().isOpen()){this._updateFilterCounters();}};
w.prototype._clearPresetFilter=function(){if(this.getSelectedPresetFilterItem()){this.setSelectedPresetFilterItem(null);}};
w.prototype._calculateNumberOfPages=function(){var i=0,j=!!this.getSortItems().length,k=!!this.getGroupItems().length,U=!!this.getPresetFilterItems().length,W=!!this.getFilterItems().length;if(j){i++;}if(U||W){i++;}if(k){i++;}this.getCustomTabs().forEach(function(X){if(!this._isEmptyTab(X)){i++;}},this);return i;};
w.prototype._hasSubHeader=function(){return!(this._calculateNumberOfPages()<2);};
function x(){this._vContentPage=2;this._oContentItem=null;this._navContainer.to(this._getPage1().getId(),"show");}
function y(j,k){var i,U;for(i=0;i<j.length;i++){if(j[i].getKey()===k){U=j[i];break;}}return U;}
function z(i,j,k){var U;if(typeof i==="string"){U=y(j,i);if(!U){o.error(k);}}else{U=i;}return U;}
function A(i){return i&&i instanceof sap.m.ViewSettingsItem;}
w.prototype._onConfirm=function(i){var j=this._getDialog(),k=this,U=function(){var W,X,Y=k.getSelectedGroupItem();if(!k._oGroupingNoneItem||Y!=k._oGroupingNoneItem.getId()){X=sap.ui.getCore().byId(Y);}k._toggleDialogTitle(k._sTitleLabelId);W={sortItem:sap.ui.getCore().byId(k.getSelectedSortItem()),sortDescending:k.getSortDescending(),groupItem:X,groupDescending:k.getGroupDescending(),presetFilterItem:sap.ui.getCore().byId(k.getSelectedPresetFilterItem()),filterItems:k.getSelectedFilterItems(),filterKeys:k.getSelectedFilterKeys(),filterCompoundKeys:k.getSelectedFilterCompoundKeys(),filterString:k.getSelectedFilterString()};k._dialog.detachAfterClose(U);k.fireConfirm(W);};j.attachAfterClose(U);j.close();};
w.prototype._onCancel=function(i){var j=this,k=this._getDialog(),U=function(){j._toggleDialogTitle(j._sTitleLabelId);j.setSelectedSortItem(j._oPreviousState.sortItem);j.setSortDescending(j._oPreviousState.sortDescending);j.setSelectedGroupItem(j._oPreviousState.groupItem);j.setGroupDescending(j._oPreviousState.groupDescending);j.setSelectedPresetFilterItem(j._oPreviousState.presetFilterItem);j._clearSelectedFilters();j.setSelectedFilterCompoundKeys(j._oPreviousState.filterCompoundKeys);if(j._navContainer.getCurrentPage()!==j._oPreviousState.navPage){setTimeout(j._navContainer["to"].bind(j._navContainer,j._oPreviousState.navPage.getId(),"show"),0);}j._switchToPage(j._oPreviousState.contentPage,j._oPreviousState.contentItem);j._dialog.detachAfterClose(U);j.fireCancel();};k.attachAfterClose(U);k.close();};
w.prototype.clearFilters=function(){this._clearSelectedFilters();this._clearPresetFilter();this.fireResetFilters();this._updateFilterCounters();if(this._vContentPage===3){setTimeout(this._getNavContainer()['to'].bind(this._getNavContainer(),this._getPage1().getId()),0);this._switchToPage(2);this._getSegmentedButton().setSelectedButton(this._getFilterButton());}this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));return this;};
w.prototype._addResetButtonToPage1=function(){var i=this._getHeader(),j=this._getSubHeader(),k=this._getResetButton();if(this._showSubHeader){if(!this._getPage1().getSubHeader()){this._getPage1().setSubHeader(j);}}else{if(this._getPage1().getSubHeader()){this._getPage1().setSubHeader();}}i.addContentRight(k);};
w.prototype._applyContextualSettings=function(){C.prototype._applyContextualSettings.call(this);};
function F(i,j){if(!this._getPage1(true)){return;}if(i==='customTabs'&&j){if(j.getMetadata().getName()===this.getMetadata().getManagedAggregation(i).type&&this._vContentPage===j.getId()){var k=this._getPage1().getContent();k.forEach(function(U){j.addAggregation('content',U,true);});}}else if(!i&&!j){var k=this._getPage1().getContent();this.getCustomTabs().forEach(function(j){if(this._vContentPage===j.getId()){k.forEach(function(U){j.addAggregation('content',U,true);});}},this);}}
function H(){var i=[-1,0,1,2,3];return(this._getPage1().getContent().length&&i.indexOf(this._vContentPage)===-1);}
w.prototype.setBusy=function(i){this._getDialog().setBusy(i);return this;};
var J=function(i){this.sOperator=i||s.StartsWith;switch(this.sOperator){case s.Equals:this.fnOperator=K;break;case s.Contains:this.fnOperator=O;break;case s.StartsWith:this.fnOperator=Q;break;case s.AnyWordStartsWith:this.fnOperator=R;break;default:o.warning("Unknown string compare operator. Use values from sap.m.StringFilterOperator. Default operator should be used.");this.fnOperator=O;break;}};
J.prototype.filter=function(i,j){if(!i){return true;}if(!j){return false;}j=j.toLowerCase();i=i.toLowerCase();return this.fnOperator(i,j);};
function K(i,j){return j===i;}
function O(i,j){return j.indexOf(i)>-1;}
function Q(i,j){return j.indexOf(i)===0;}
function R(i,j){var k=new RegExp(".*\\b"+i+".*");return k.test(j);}
return w;});
sap.ui.predefine('sap/m/ViewSettingsDialogRenderer',[],function(){"use strict";var V={apiVersion:2};
V.render=function(r,c){};
return V;},true);
sap.ui.predefine('sap/m/ViewSettingsFilterItem',['./ViewSettingsItem','./library'],function(V,l){"use strict";
var a=V.extend("sap.m.ViewSettingsFilterItem",{metadata:{library:"sap.m",properties:{multiSelect:{type:"boolean",group:"Behavior",defaultValue:true}},aggregations:{items:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{filterDetailItemsAggregationChange:{}}}});
a.prototype._handleNewAggregationEvents=function(o){o.attachEvent('itemPropertyChanged',function(e){this.fireItemPropertyChanged({changedItem:e.getParameter('changedItem'),propertyKey:e.getParameter('propertyKey'),propertyValue:e.getParameter('propertyValue')});}.bind(this));this.fireFilterDetailItemsAggregationChange({item:o});};
a.prototype.addAggregation=function(A,o,s){V.prototype.addAggregation.apply(this,arguments);this._handleNewAggregationEvents(o);return this;};
a.prototype.insertAggregation=function(A,o,i,s){V.prototype.insertAggregation.apply(this,arguments);this._handleNewAggregationEvents(o);return this;};
a.prototype.removeAggregation=function(A,o,s){V.prototype.removeAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
a.prototype.removeAllAggregation=function(A,s){V.prototype.removeAllAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
a.prototype.destroyAggregation=function(A,s){V.prototype.destroyAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
return a;});
sap.ui.predefine('sap/m/ViewSettingsItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var V=I.extend("sap.m.ViewSettingsItem",{metadata:{library:"sap.m",properties:{selected:{type:"boolean",group:"Behavior",defaultValue:false}},events:{itemPropertyChanged:{parameters:{changedItem:{type:'sap.m.ViewSettingsItem'},propertyKey:{type:"string"},propertyValue:{type:"any"}}}}}});
V.prototype.setSelected=function(v){this.setProperty("selected",v,true);return this;};
V.prototype.setProperty=function(n,v,s,f){I.prototype.setProperty.apply(this,arguments);f=f===undefined?true:f;if(f){this.fireItemPropertyChanged({changedItem:this,propertyKey:n,propertyValue:v});}};
return V;});
sap.ui.predefine('sap/m/VisibleItem',['./library','sap/ui/core/Item',"sap/ui/thirdparty/jquery"],function(l,I,q){"use strict";
var V=I.extend("sap.m.VisibleItem",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Behavior",defaultValue:true}}}});
V.prototype._getRefs=function(){var p=this.getParent(),$,t=this;if(p&&p.$("content")){$=p.$("content").find("li").filter(function(){return q(this).html()===t.getText();});}return $;};
V.prototype.setVisible=function(v){if(this.getVisible()===v){return;}var $=this._getRefs();if($){if(v){$.removeClass('TPSliderItemHidden');}else{$.addClass('TPSliderItemHidden');}}return this.setProperty('visible',v,true);};
return V;});
sap.ui.predefine('sap/m/WheelSlider',['sap/ui/core/Control','./WheelSliderRenderer','sap/ui/core/IconPool','sap/ui/Device',"sap/ui/events/KeyCodes","sap/m/Button","sap/ui/thirdparty/jquery"],function(C,W,I,D,K,B,q){"use strict";
var a=C.extend("sap.m.WheelSlider",{
metadata:{library:"sap.m",properties:{selectedKey:{type:"string",defaultValue:null},isCyclic:{type:"boolean",defaultValue:true},label:{type:"string",defaultValue:null},isExpanded:{type:"boolean",defaultValue:false}},aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item"},_arrowUp:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_arrowDown:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{expanded:{},collapsed:{},selectedKeyChange:{parameters:{newKey:{type:"string"}}}}},
renderer:W
});
var S=sap.ui.getCore().getConfiguration().getAnimation()?200:0;var L=32;var A=32;var M=1.0;
a.prototype.init=function(){this._bIsDrag=null;this._selectionOffset=0;this._mousedown=false;this._dragSession=null;this._iSelectedItemIndex=-1;this._animatingSnap=false;this._iSelectedIndex=-1;this._animating=false;this._intervalId=null;this._maxScrollTop=null;this._minScrollTop=null;this._marginTop=null;this._marginBottom=null;this._bOneTimeValueSelectionAnimation=false;this._bEnabled=true;if(D.system.desktop){this._fnHandleTypeValues=t.call(this);}this._onTouchStart=q.proxy(o,this);this._onTouchMove=q.proxy(c,this);this._onTouchEnd=q.proxy(d,this);this._onMouseWheel=this._onMouseWheel.bind(this);this._initArrows();};
a.prototype.exit=function(){var s=this._getSliderContainerDomRef();if(s){s.stop();}this._stopAnimation();if(s[0]){this._detachEvents();}};
a.prototype.onBeforeRendering=function(){if(this._getSliderContainerDomRef()[0]){this._detachEvents();}};
a.prototype.onAfterRendering=function(){if(this._marginTop){this._previousMarginTop=this._marginTop;}if(this._marginBottom){this._previousMarginBottom=this._marginBottom;}if(this.getItems().length){this._updateDynamicLayout(this.getIsExpanded());}this._attachEvents();};
a.prototype.onThemeChanged=function(e){this.invalidate();};
a.prototype._handleTap=function(e){var s,i,g;if(!this.getIsExpanded()){if(D.system.desktop){this.focus();}else{this.setIsExpanded(true);}}else{s=e.srcElement||e.originalTarget;if(s&&s.tagName.toLowerCase()==="li"){i=q(s).text();g=F.call(this,i);this._iClickedIndex=Array.prototype.slice.call(s.parentElement.children).indexOf(s);this._bOneTimeValueSelectionAnimation=true;this.setSelectedKey(g);this.fireSelectedKeyChange({newKey:g});}else{this._addSelectionStyle();this.focus();}}};
a.prototype.setSelectedKey=function(v,r){var s=r!==undefined?!r:true,i=b(this.getItems(),function(E){return E.getKey()===v;}),i,$,e;this.setProperty("selectedKey",v,s);if(!s||i===-1){return this;}i-=this.iMinIndex;if(this.getDomRef()){$=this._getSliderContainerDomRef();e=this._getItemHeightInPx();if(this._bOneTimeValueSelectionAnimation){$.scrollTop((i-this._iClickedIndex+this._iSelectedItemIndex)*e-this._selectionOffset);this._animatingSnap=true;$.animate({scrollTop:i*e-this._selectionOffset},S,'linear',function(){$.clearQueue();this._animatingSnap=false;this._bOneTimeValueSelectionAnimation=false;}.bind(this));}else{$.scrollTop(i*e-this._selectionOffset);}this._removeSelectionStyle();this._iSelectedItemIndex=i;this._addSelectionStyle();}return this;};
a.prototype.setIsExpanded=function(v,s){this.setProperty("isExpanded",v,true);if(!this.getDomRef()){return this;}var T=this.$();if(v){T.addClass("sapMWSExpanded");this._updateDynamicLayout(true);if(!s){this.fireExpanded({ctrl:this});}}else{this._stopAnimation();if(this._animatingSnap===true){this._animatingSnap=false;this._getSliderContainerDomRef().stop(true);if(this._animatingTargetIndex!==null&&this._animatingTargetIndex!==undefined){this._scrollerSnapped(this._animatingTargetIndex);this._animatingTargetIndex=null;}else if(this._iSelectedIndex!==-1){this._scrollerSnapped(this._iSelectedIndex);}}T.removeClass("sapMWSExpanded");this._updateDynamicLayout(false);if(!s){this.fireCollapsed({ctrl:this});}}return this;};
a.prototype.onfocusin=function(e){if(D.system.desktop&&!this.getIsExpanded()){this.setIsExpanded(true);}};
a.prototype.onfocusout=function(e){var s=e.relatedTarget?e.relatedTarget.id:null,g=[this.getAggregation("_arrowUp").getId(),this.getAggregation("_arrowDown").getId()];if(s&&g.indexOf(s)!==-1){return;}if(D.system.desktop&&this.getIsExpanded()){this.setIsExpanded(false);}};
a.prototype._onMouseWheel=function(e){var O,g,w;e.preventDefault();e.stopPropagation();if(!this.getIsExpanded()){return false;}O=e.originalEvent;g=O.detail?(-O.detail>0):(O.wheelDelta>0);w=O.detail?(-O.detail/3):(O.wheelDelta/120);if(!w){return false;}this._handleWheelScroll(g,w);};
a.prototype._handleWheelScroll=function(e,w){var r=e?Math.ceil:Math.floor,R;if(!this._aWheelDeltas){this._aWheelDeltas=[];}this._aWheelDeltas.push(w);if(!this._bWheelScrolling){this._bWheelScrolling=true;this._stopAnimation();this._animating=true;this._intervalId=setInterval(function(){if(!this._aWheelDeltas.length){this._stopAnimation();this._bWheelScrolling=false;}else{R=this._aWheelDeltas[0];this._aWheelDeltas=[];R=r(R);if(R){this._offsetValue(R);}}}.bind(this),150);}return false;};
a.prototype.onsappageup=function(e){if(this.getIsExpanded()){var i=this.getItems()[0],k=i.getKey();this.setSelectedKey(k,true);this.fireSelectedKeyChange({newKey:k});}};
a.prototype.onsappagedown=function(e){if(this.getIsExpanded()){var l=this.getItems()[this.getItems().length-1],k=l.getKey();this.setSelectedKey(k,true);this.fireSelectedKeyChange({newKey:k});}};
a.prototype.onsapup=function(e){if(this.getIsExpanded()){this._offsetAnimateValue(-1);}};
a.prototype.onsapdown=function(e){if(this.getIsExpanded()){this._offsetAnimateValue(1);}};
a.prototype.onkeydown=function(e){var k=e.which||e.keyCode,g=K;if(k>=g.NUMPAD_0&&k<=g.NUMPAD_9){k=this._convertNumPadToNumKeyCode(k);}if((k>=g.A&&k<=g.Z)||(k>=g.DIGIT_0&&k<=g.DIGIT_9)){this._fnHandleTypeValues(e.timeStamp,k);}};
a.prototype._getSliderContainerDomRef=function(){return this.$().find(".sapMWSInner");};
a.prototype._getItemHeightInPx=function(){return this.$("content").find("li")[0].getBoundingClientRect().height;};
a.prototype._updateSelectionFrameLayout=function(){var $,i,e,g,s=this.$().offset(),h=s?s.top:0,j=this.$().parents(".sapMWSContainer").offset(),k=j?j.top:0;if(this.getDomRef()){g=this._getItemHeightInPx();$=this.$().find(".sapMWSSelectionFrame");e=h-k;i=(this.$().height()-g+L)/2+e;$.css("top",i);}};
a.prototype._updateConstrainedMargins=function(i){var e=this._getItemHeightInPx(),$,v,V,g,h,j,m,k;if(this.getDomRef()){e=this._getItemHeightInPx();$=this.$().find(".SliderValues3,.SliderValues4,.SliderValues5,.SliderValues6,.SliderValues7,.SliderValues8,.SliderValues9,.SliderValues10,.SliderValues11,.SliderValues12");if(!$.length){return;}if(i){v=this.getItems().length;V=e*Math.floor(v/2);g=e*Math.ceil(v/2);j=this.$().parents().hasClass('sapUiSizeCompact')?A:0;h=(this.$().height()-e+L)/2;m=h-V-L-j;k=this.$().height()-h-g-j;m=Math.max(m,0);k=Math.max(k,0);}else{m=0;k=0;}$.css("margin-top",m);$.css("margin-bottom",k);}};
a.prototype._updateDynamicLayout=function(i){if(this.getDomRef()){this._updateConstrainedMargins(i);if(i){this._updateSelectionFrameLayout();}this._updateMargins();this._updateSelectionOffset();this._reselectCurrentItem();this.$().attr('aria-expanded',i);}};
a.prototype._getSelectionFrameTopOffset=function(){var $=this._getSliderContainerDomRef().find(".sapMWSSelectionFrame"),e=$.offset();return e.top;};
a.prototype._animateScroll=function(s){var $=this._getSliderContainerDomRef(),p=$.scrollTop(),e=25,g=this.getIsCyclic(),h=0.9,i=0.05;this._animating=true;this._intervalId=setInterval(function(){p=p-s*e;if(!g){if(p>this._maxScrollTop){p=this._maxScrollTop;s=0;}if(p<this._minScrollTop){p=this._minScrollTop;s=0;}}$.scrollTop(p);s*=h;if(Math.abs(s)<i){this._stopAnimation();var j=this._getItemHeightInPx();var O=this._selectionOffset?(this._selectionOffset%j):0;var k=Math.round((p+O)/j)*j-O;this._iSelectedIndex=Math.round((p+this._selectionOffset)/j);if(this._animatingSnap){return;}this._animatingSnap=true;$.animate({scrollTop:k},S,'linear',function(){$.clearQueue();this._animatingSnap=false;if($.css("visibility")==="visible"&&!this._animating){this._scrollerSnapped(this._iSelectedIndex);}}.bind(this));}}.bind(this),e);};
a.prototype.getSelectedItemIndex=function(){var s=this.getSelectedKey();if(!s){return 0;}return b(this.getItems(),function(e){return e.getKey()===s;});};
a.prototype._reselectCurrentItem=function(){var s=this.getSelectedItemIndex(),e;if(s===-1){return;}e=this.getItems()[s].getKey();this.setSelectedKey(e);};
a.prototype._updateSelectionOffset=function(){var s=this._getSelectionFrameTopOffset(),$=this._getSliderContainerDomRef(),e=$.offset();if(this.getIsCyclic()&&this.getIsExpanded()){this._selectionOffset=s-e.top;}else{this._selectionOffset=0;}};
a.prototype._stopAnimation=function(){if(this._animating){clearInterval(this._intervalId);this._intervalId=null;this._animating=null;}};
a.prototype._startDrag=function(p){if(!this._dragSession){this._dragSession={};this._dragSession.positions=[];}this._dragSession.pageY=p;this._dragSession.startTop=this._getSliderContainerDomRef().scrollTop();};
a.prototype._doDrag=function(p,T){if(this._dragSession){this._dragSession.offsetY=p-this._dragSession.pageY;this._dragSession.positions.push({pageY:p,timeStamp:T});if(this._dragSession.positions.length>20){this._dragSession.positions.splice(0,10);}if(this._bIsDrag){this._getSliderContainerDomRef().scrollTop(this._dragSession.startTop-this._dragSession.offsetY);}}};
a.prototype._endDrag=function(p,T){if(this._dragSession){var O,e;for(var i=this._dragSession.positions.length-1;i>=0;i--){O=T-this._dragSession.positions[i].timeStamp;e=p-this._dragSession.positions[i].pageY;if(O>100){break;}}var s=(e/O);this._stopAnimation();this._dragSession=null;s=Math.min(s,M);s=Math.max(s,-M);this._animateScroll(s);}};
a.prototype._updateMargins=function(){var s=this._getSelectionFrameTopOffset(),$=this._getSliderContainerDomRef(),e=$.offset(),i,l,g,h;if(!this.getIsCyclic()){l=this.$("content");h=this._getItemHeightInPx();g=this.$().height();if(this.getIsExpanded()){this._minScrollTop=0;this._marginTop=s-e.top;this._maxScrollTop=h*(this.getItems().length-1);i=$.height();this._marginBottom=i-this._marginTop-h;if(this._marginBottom<0){this._marginBottom=g-this._marginTop-h;}}else{this._marginTop=0;this._marginBottom=g-h;}if(this._previousMarginTop!==this._marginTop){l.css("margin-top",this._marginTop);this._previousMarginTop=this._marginTop;}if(this._previousMarginBottom!==this._marginBottom){l.css("margin-bottom",this._marginBottom);this._previousMarginBottom=this._marginBottom;}}};
a.prototype._scrollerSnapped=function(i){var s=i,e=this.getItems().length,n;if(!this.getIsCyclic()){s=i;}var g=s+this.iMinIndex;if(this.getIsCyclic()){while(g<0){g=g+e;}while(g>=e){g=g-e;}}else{g=Math.min(e-1,g);}n=this.getItems()[g].getKey();var r=this.getIsCyclic()||(this.iPreviousMiddle>g&&this.iMinIndex>0)||(this.iPreviousMiddle<g&&this.iMaxIndex<e-1);this.setSelectedKey(n,r);this.fireSelectedKeyChange({newKey:n});};
a.prototype._addSelectionStyle=function(){var $=this.$("content").find("li"),s=$.eq(this._iSelectedItemIndex).text(),e,g;if(!s){return;}g=s;if(g&&g.length>1&&g.indexOf('0')===0){g=g.substring(1);}$.eq(this._iSelectedItemIndex).addClass("sapMWSItemSelected");e=this.getDomRef("valDescription");if(e.innerText!==g){e.innerText=g;}};
a.prototype._removeSelectionStyle=function(){var $=this.$("content").find("li");$.eq(this._iSelectedItemIndex).removeClass("sapMWSItemSelected");};
a.prototype._attachEvents=function(){var e=this._getSliderContainerDomRef()[0];if(D.system.combi){e.addEventListener("touchstart",this._onTouchStart,false);e.addEventListener("touchmove",this._onTouchMove,false);document.addEventListener("touchend",this._onTouchEnd,false);e.addEventListener("mousedown",this._onTouchStart,false);document.addEventListener("mousemove",this._onTouchMove,false);document.addEventListener("mouseup",this._onTouchEnd,false);}else{if(D.system.phone||D.system.tablet){e.addEventListener("touchstart",this._onTouchStart,false);e.addEventListener("touchmove",this._onTouchMove,false);document.addEventListener("touchend",this._onTouchEnd,false);}else{e.addEventListener("mousedown",this._onTouchStart,false);document.addEventListener("mousemove",this._onTouchMove,false);document.addEventListener("mouseup",this._onTouchEnd,false);}}this.$().on('selectstart',f);this.$().on(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onMouseWheel);};
function f(){return false;}
a.prototype._detachEvents=function(){var e=this._getSliderContainerDomRef()[0];if(D.system.combi){e.removeEventListener("touchstart",this._onTouchStart,false);e.removeEventListener("touchmove",this._onTouchMove,false);document.removeEventListener("touchend",this._onTouchEnd,false);e.removeEventListener("mousedown",this._onTouchStart,false);document.removeEventListener("mousemove",this._onTouchMove,false);document.removeEventListener("mouseup",this._onTouchEnd,false);}else{if(D.system.phone||D.system.tablet){e.removeEventListener("touchstart",this._onTouchStart,false);e.removeEventListener("touchmove",this._onTouchMove,false);document.removeEventListener("touchend",this._onTouchEnd,false);}else{e.removeEventListener("mousedown",this._onTouchStart,false);document.removeEventListener("mousemove",this._onTouchMove,false);document.removeEventListener("mouseup",this._onTouchEnd,false);}}this.$().off('selectstart',f);this.$().off(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onMouseWheel);};
a.prototype._offsetAnimateValue=function(i){var s=this._getSliderContainerDomRef(),e,g=this._getItemHeightInPx(),h,j,k=this.getIsCyclic();this._stopAnimation();if(this._animatingSnap===true){this._animatingSnap=false;this._getSliderContainerDomRef().stop(true);if(this._animatingTargetIndex!==null&&this._animatingTargetIndex!==undefined){this._scrollerSnapped(this._animatingTargetIndex);this._animatingTargetIndex=null;}else if(this._iSelectedIndex!==-1){this._scrollerSnapped(this._iSelectedIndex);}}j=this._iSelectedItemIndex+i;e=s.scrollTop();h=e+i*g;if(!k){if(j<0||j>=this.getItems().length){return;}if(h>this._maxScrollTop){h=this._maxScrollTop;}if(h<this._minScrollTop){h=this._minScrollTop;}}this._animatingSnap=true;this._animatingTargetIndex=j;s.animate({scrollTop:h},S,'linear',function(){s.clearQueue();this._animatingSnap=false;this._animatingTargetIndex=null;if(s.css("visibility")==="visible"){this._scrollerSnapped(j);}}.bind(this));};
a.prototype._offsetValue=function(O){var s=this._getSliderContainerDomRef().scrollTop(),e=this.getIsCyclic(),i=this._getItemHeightInPx();s=s-O*i;if(!e){if(s>this._maxScrollTop){s=this._maxScrollTop;}if(s<this._minScrollTop){s=this._minScrollTop;}}this._getSliderContainerDomRef().scrollTop(s);this._iSelectedIndex=Math.round((s+this._selectionOffset)/i);this._scrollerSnapped(this._iSelectedIndex);};
a.prototype._initArrows=function(){var e,g;e=new B({icon:I.getIconURI("slim-arrow-up"),press:function(E){this._offsetAnimateValue(-1);}.bind(this),type:'Transparent'});e.addEventDelegate({onAfterRendering:function(){e.$().attr("tabindex",-1);}});this.setAggregation("_arrowUp",e);g=new B({icon:I.getIconURI("slim-arrow-down"),press:function(E){this._offsetAnimateValue(1);}.bind(this),type:'Transparent'});g.addEventDelegate({onAfterRendering:function(){g.$().attr("tabindex",-1);}});this.setAggregation("_arrowDown",g);};
a.prototype._convertNumPadToNumKeyCode=function(k){var e=K;if(k>=e.NUMPAD_0&&k<=e.NUMPAD_9){k-=48;}return k;};
function b(e,p){if(e==null){throw new TypeError('findIndex called with null or undefined array');}if(typeof p!=='function'){throw new TypeError('predicate must be a function');}var l=e.length;var T=arguments[1];var v;for(var i=0;i<l;i++){v=e[i];if(p.call(T,v,i,e)){return i;}}return-1;}
var o=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;this._bIsDrag=false;if(!this.getIsExpanded()){return;}this._stopAnimation();this._startDrag(p);if(!D.system.desktop){e.preventDefault();}this._mousedown=true;};var c=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;if(!this._mousedown||!this.getIsExpanded()){return;}if(!this._bIsDrag&&this._dragSession&&this._dragSession.positions.length){var g=this._dragSession.positions.some(function(h){return Math.abs(h.pageY-p)>5;});if(g){this._bIsDrag=true;}}this._doDrag(p,e.timeStamp);this._mousedown=true;};var d=function(e){var p=e.changedTouches&&e.changedTouches.length?e.changedTouches[0].pageY:e.pageY;if(this._bIsDrag===false){this._handleTap(e);this._dragSession=null;}this._bIsDrag=true;if(!this.getIsExpanded()){this._dragSession=null;return;}this._endDrag(p,e.timeStamp);this._mousedown=false;};var F=function(T){var i=this.getItems();var e=b(i,function(g){return g.getText()===T;});return i[e].getKey();};var t=function(){var l=-1,i=-1,w=1000,s="",T=function(e,k){var m;if(l+w<e){s="";}else{if(i!==-1){clearTimeout(i);i=-1;}}s+=String.fromCharCode(k).toLowerCase();m=this.getItems().filter(function(g){return g.getText().indexOf(s)===0;});if(m.length>1){i=setTimeout(function(){this.setSelectedKey(m[0].getKey(),true);s="";i=-1;}.bind(this),w);}else if(m.length===1){this.setSelectedKey(m[0].getKey(),true);s="";}else{s="";}l=e;};return T;};return a;});
sap.ui.predefine('sap/m/WheelSliderContainer',['sap/ui/Device','sap/ui/base/EventProvider','sap/ui/core/Control',"sap/ui/thirdparty/jquery",'./WheelSliderContainerRenderer'],function(D,E,C,q,W){"use strict";
var a=C.extend("sap.m.WheelSliderContainer",{metadata:{library:"sap.m",properties:{labelText:{type:"string"},width:{type:"sap.ui.core.CSSSize",group:"Appearance"},height:{type:"sap.ui.core.CSSSize",group:"Appearance"}},aggregations:{sliders:{type:"sap.m.WheelSlider",multiple:true}}}});
a.prototype.init=function(){this._fnLayoutChanged=q.proxy(this._onOrientationChanged,this);D.resize.attachHandler(this._fnLayoutChanged);this._onSliderExpanded=this._onSliderExpanded.bind(this);};
a.prototype.exit=function(){this.$().off('selectstart',f);this.$().off(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);D.resize.detachHandler(this._fnOrientationChanged);};
a.prototype.onAfterRendering=function(){this.$().off(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);this.$().on(D.browser.firefox?"DOMMouseScroll":"mousewheel",q.proxy(this._onmousewheel,this));this.$().off('selectstart',f);this.$().on('selectstart',f);};
a.prototype.onsaphome=function(e){var n=this._getFirstSlider(),c=this._getCurrentSlider();if(c&&document.activeElement===c.getDomRef()){n.focus();}};
a.prototype.onsapend=function(e){var n=this._getLastSlider(),c=this._getCurrentSlider();if(c&&document.activeElement===c.getDomRef()){n.focus();}};
a.prototype.onsapleft=function(e){var n,c=this._getCurrentSlider(),i=-1,N=-1,s=this.getSliders();if(c&&document.activeElement===c.getDomRef()){i=s.indexOf(c);N=i>0?i-1:s.length-1;n=s[N];n.focus();}};
a.prototype.onsapright=function(e){var n,c=this._getCurrentSlider(),i=-1,N=-1,s=this.getSliders();if(c&&document.activeElement===c.getDomRef()){i=s.indexOf(c);N=i<s.length-1?i+1:0;n=s[N];n.focus();}};
a.prototype._onmousewheel=function(e){var c=this._getCurrentSlider();if(c){c._onMouseWheel(e);}};
a.prototype._onOrientationChanged=function(){var s=this.getSliders();for(var i=0;i<s.length;i++){if(s[i].getIsExpanded()){s[i]._updateSelectionFrameLayout();}}};
a.prototype._getCurrentSlider=function(){var s=this.getSliders();if(s){for(var i=0;i<s.length;i++){if(s[i].getIsExpanded()){return s[i];}}}return null;};
a.prototype._getFirstSlider=function(){return this.getSliders()[0]||null;};
a.prototype._getLastSlider=function(){var s=this.getSliders();return s[s.length-1]||null;};
a.prototype._onSliderExpanded=function(e){var s=this.getSliders();for(var i=0;i<s.length;i++){if(s[i]!==e.oSource&&s[i].getIsExpanded()){s[i].setIsExpanded(false);}}};
a.prototype.addSlider=function(s){if(!D.system.desktop&&!E.hasListener(s,"expanded",this._onSliderExpanded,this)){s.attachExpanded(this._onSliderExpanded);}return this.addAggregation("sliders",s);};
function f(){return false;}
return a;});
sap.ui.predefine('sap/m/WheelSliderContainerRenderer',["sap/ui/Device"],function(D){"use strict";var W={apiVersion:2};
W.render=function(r,c){var s=c.getSliders(),l=c.getLabelText()||"",R=sap.ui.getCore().getLibraryResourceBundle("sap.m"),S,b=sap.ui.getCore().getConfiguration().getRTL();r.openStart("div",c);r.class("sapMWSContainer");r.style("width",c.getWidth());r.style("height",c.getHeight());r.accessibilityState(c,{label:(l+" "+R.getText("TIMEPICKER_SCREENREADER_TAG")).trim()});r.openEnd();if(!D.system.desktop){r.openStart("div",c.getId()+"-label");r.class("sapMWSContainerLabel");r.openEnd();r.style("display","block");r.text(l);r.close("div");}if(b){for(S=s.length-1;S>=0;S--){r.renderControl(s[S]);}}else{for(S=0;S<s.length;S++){r.renderControl(s[S]);}}r.close("div");};
return W;},true);
sap.ui.predefine('sap/m/WheelSliderRenderer',[],function(){"use strict";var W={apiVersion:2};var i=60;
W.render=function(r,c){var I,a=c.getItems(),C=c.getLabel();r.openStart("div",c);r.attr("tabindex","0");r.class("sapMWS");if(c.getIsExpanded()){r.class("sapMWSExpanded");}if(!c.getIsCyclic()){r.class("sapMWSShort");}r.accessibilityState(c,{role:"list",labelledby:{value:c.getId()+"-label",append:true},describedby:{value:c.getId()+"-valDescription",append:true}});r.openEnd();r.openStart("div",c.getId()+"-label");r.class("sapMWSLabel");r.openEnd();r.text(C);r.close("div");r.openStart("div",c.getId()+"-valDescription");r.attr('aria-hidden','false');r.attr('aria-live','assertive');r.class("sapUiInvisibleText");r.openEnd();r.close("div");r.openStart("div");r.class("sapMWSArrows");r.openEnd();r.renderControl(c.getAggregation("_arrowUp"));r.close("div");r.openStart("div");r.class("sapMWSInner");W.addItemValuesCssClass(r,c);r.attr("unselectable","on");r.openEnd();r.openStart("div");r.class("sapMWSSelectionFrame");r.openEnd();r.close("div");r.openStart("ul",c.getId()+"-content");r.attr("unselectable","on");if(c._marginTop){r.style("margin-top",c._marginTop+"px");}if(c._marginBottom){r.style("margin-bottom",c._marginBottom+"px");}r.openEnd();if(a.length){var s=c.getSelectedItemIndex();var m=c.getIsCyclic()?s-i:Math.max(s-i,0);var M=c.getIsCyclic()?s+i:Math.min(s+i,a.length-1);c.iPreviousMiddle=s;c.iMinIndex=m;c.iMaxIndex=M;for(I=m;I<=M;I++){var b=I;while(b<0){b+=a.length;}while(b>=a.length){b-=a.length;}r.openStart("li");r.attr("data-sap-ui-index",b);r.class("sapMWSItem");r.accessibilityState(c);r.attr("unselectable","on");r.openEnd();r.text(a[b].getText());r.close("li");}}r.close("ul");r.close("div");r.openStart("div");r.class("sapMWSArrows");r.openEnd();r.renderControl(c.getAggregation("_arrowDown"));r.close("div");r.close("div");};
W.addItemValuesCssClass=function(r,c){var v=c.getItems().length;if(v>2&&v<13){r.class("SliderValues"+v.toString());}};
return W;});
sap.ui.predefine('sap/m/WizardProgressNavigator',["./library","sap/ui/core/Control","sap/ui/core/ResizeHandler","sap/ui/core/delegate/ItemNavigation","sap/ui/Device","sap/m/ActionSheet","sap/ui/core/InvisibleText","./WizardProgressNavigatorRenderer","./Button","sap/ui/thirdparty/jquery"],function(l,C,R,I,D,A,a,W,B,q){"use strict";
var b=C.extend("sap.m.WizardProgressNavigator",{metadata:{properties:{stepCount:{type:"int",group:"Data",defaultValue:3},stepTitles:{type:"string[]",group:"Appearance",defaultValue:[]},stepIcons:{type:"sap.ui.core.URI[]",group:"Appearance",defaultValue:[]},varyingStepCount:{type:"boolean",group:"Appearance",defaultValue:false}},events:{stepChanged:{parameters:{current:{type:"int"}}}}}});
b.CONSTANTS={MINIMUM_STEPS:3,MAXIMUM_STEPS:8,MIN_STEP_WIDTH_NO_TITLE:64,MIN_STEP_WIDTH_WITH_TITLE:200};b.TEXT={STEP:"WIZARD_PROG_NAV_STEP_TITLE",OPTIONAL_STEP:"WIZARD_STEP_OPTIONAL_STEP_TEXT"};
b.prototype.init=function(){this._iCurrentStep=1;this._iActiveStep=1;this._aCachedSteps=[];this._aStepOptionalIndication=[];this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oActionSheet=new A();this._createStepNavigation();};
b.prototype.onBeforeRendering=function(){if(this.getStepCount()!==this.getStepIcons().filter(String).length){this.setStepIcons([]);}if(this.getStepCount()!==this.getStepTitles().filter(String).length){this.setStepTitles([]);}};
b.prototype.onAfterRendering=function(){var $,z=this._iActiveStep-1,Z=this._iCurrentStep-1;this._cacheDOMElements();this._updateStepZIndex();this._updateStepNavigation(z);this._updateStepActiveAttribute(z);this._removeStepAriaDisabledAttribute(z);this._updateStepCurrentAttribute(Z);this._updateStepAriaCurrentAttribute(Z);this._updateOpenSteps();R.register(this.getDomRef(),this._updateOpenSteps.bind(this));if(D.os.name===D.os.OS.IOS){$=this.$().find(".sapMWizardProgressNavStep").css("display","block");setTimeout($["css"].bind($,"display",""),0);}};
b.prototype.ontap=function(e){if(this._isGroupAtStart(e.target)){return this._showActionSheet(e.target,true);}if(this._isGroupAtEnd(e.target)){return this._showActionSheet(e.target,false);}if(!this._isOpenStep(e.target)||!this._isActiveStep(this._getStepNumber(e.target))){return;}this._updateCurrentStep(this._getStepNumber(e.target));this.fireStepChanged({current:this._getStepNumber(e.target)});};
b.prototype.onsapspace=function(e){if(this._onEnter){this._onEnter(e,this._oStepNavigation.getFocusedIndex());}this.ontap(e);};
b.prototype.onsapenter=b.prototype.onsapspace;
b.prototype.exit=function(){R.deregisterAllForControl(this.getId());this.removeDelegate(this._oStepNavigation);this._oStepNavigation.destroy();this._oStepNavigation=null;if(this._oActionSheetInvisibleText){this._oActionSheetInvisibleText.destroy();this._oActionSheetInvisibleText=null;}this._oActionSheet.destroy();this._oActionSheet=null;this._iCurrentStep=null;this._iActiveStep=null;this._aCachedSteps=null;this._aStepOptionalIndication=null;};
b.prototype.getCurrentStep=function(){return this._iCurrentStep;};
b.prototype.getProgress=function(){return this._iActiveStep;};
b.prototype.previousStep=function(){var c=this.getCurrentStep();if(c<2){return this;}return this._moveToStep(c-1);};
b.prototype.nextStep=function(){return this._moveToStep(this.getCurrentStep()+1);};
b.prototype.incrementProgress=function(){return this._moveToStep(this.getProgress()+1);};
b.prototype.discardProgress=function(i){if(i<=0||i>this._iActiveStep){return this;}this._updateCurrentStep(i,this._iCurrentStep);this._updateStepActiveAttribute(i-1,this._iActiveStep-1);this._addStepAriaDisabledAttribute(i-1);this._updateStepNavigation(i-1);this._iCurrentStep=i;this._iActiveStep=i;};
b.prototype._setOnEnter=function(c){this._onEnter=c;};
b.prototype._createStepNavigation=function(){var t=this;this._oStepNavigation=new I();this._oStepNavigation.setCycling(false);this._oStepNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});this._oStepNavigation.attachEvent("AfterFocus",function(p){var e=p.mParameters.oEvent;if(!e||!e.relatedTarget||q(e.relatedTarget).hasClass(W.CLASSES.STEP)){return;}t._oStepNavigation.focusItem(t._iCurrentStep-1);});this.addDelegate(this._oStepNavigation);};
b.prototype._cacheDOMElements=function(){var d=this.getDomRef();this._aCachedSteps=d.querySelectorAll("."+W.CLASSES.STEP);};
b.prototype._updateStepZIndex=function(){var z=this._iCurrentStep-1,s=this._aCachedSteps.length,Z=b.CONSTANTS.MAXIMUM_STEPS;for(var i=0;i<s;i++){if(i<=z){this._aCachedSteps[i].style.zIndex=0;}else{this._aCachedSteps[i].style.zIndex=Z;Z-=1;}}};
b.prototype._updateStepNavigation=function(c){var n=this.getDomRef(),f=[];for(var i=0;i<=c;i++){if(this._aCachedSteps[i]){f.push(this._aCachedSteps[i]);}}this._oStepNavigation.setRootDomRef(n);this._oStepNavigation.setItemDomRefs(f);this._oStepNavigation.setPageSize(c);this._oStepNavigation.setFocusedIndex(c);};
b.prototype._updateStepActiveAttribute=function(n,o){if(o!==undefined&&this._aCachedSteps[o]){this._aCachedSteps[o].removeAttribute(W.ATTRIBUTES.ACTIVE_STEP);}if(this._aCachedSteps[n]){this._aCachedSteps[n].setAttribute(W.ATTRIBUTES.ACTIVE_STEP,true);}};
b.prototype._updateStepCurrentAttribute=function(n,o){if(o!==undefined&&this._aCachedSteps[o]){this._aCachedSteps[o].removeAttribute(W.ATTRIBUTES.CURRENT_STEP);}if(this._aCachedSteps[n]){this._aCachedSteps[n].setAttribute(W.ATTRIBUTES.CURRENT_STEP,true);}};
b.prototype._addStepAriaDisabledAttribute=function(c){var s=this._aCachedSteps.length,S;for(var i=c+1;i<s;i++){S=this._aCachedSteps[i];S.setAttribute(W.ATTRIBUTES.ARIA_DISABLED,true);}};
b.prototype._removeStepAriaDisabledAttribute=function(i){if(this._aCachedSteps[i]){this._aCachedSteps[i].removeAttribute(W.ATTRIBUTES.ARIA_DISABLED);}};
b.prototype._updateStepAriaCurrentAttribute=function(n,o){var s=this._aCachedSteps[n];if(o!==undefined&&this._aCachedSteps[o]){this._aCachedSteps[o].removeAttribute(W.ATTRIBUTES.ARIA_CURRENT);}if(s){s.setAttribute(W.ATTRIBUTES.ARIA_CURRENT,true);}};
b.prototype._updateStepAriaLabelAttribute=function(i){var s=this._aCachedSteps[i];var S=this._isActiveStep(i)?"ACTIVE":"INACTIVE";var c=this._aStepOptionalIndication[i]?this._oResourceBundle.getText("WIZARD_STEP_OPTIONAL_STEP_TEXT"):"";var v=this._oResourceBundle.getText("WIZARD_STEP_"+S+"_LABEL",[i+1,this.getStepTitles()[i],c]);if(s){s.setAttribute(W.ATTRIBUTES.ARIA_LABEL,v);}};
b.prototype._moveToStep=function(n){var s=this.getStepCount(),o=this.getCurrentStep();if(n>s){return this;}if(n>this._iActiveStep){this._updateActiveStep(n);}return this._updateCurrentStep(n,o);};
b.prototype._updateActiveStep=function(n,o){var z=n-1,Z=(o||this._iActiveStep)-1;this._iActiveStep=n;this._updateStepNavigation(z);this._removeStepAriaDisabledAttribute(z);this._updateStepActiveAttribute(z,Z);this._updateStepAriaLabelAttribute(z);};
b.prototype._updateCurrentStep=function(n,o){var z=n-1,Z=(o||this.getCurrentStep())-1;this._iCurrentStep=n;this._updateStepZIndex();this._updateOpenSteps();this._updateStepCurrentAttribute(z,Z);this._updateStepAriaCurrentAttribute(z,Z);return this;};
b.prototype._updateOpenSteps=function(){var w=this.$().width(),c=this._iCurrentStep-1,d=0,e=true,s=this.getStepTitles().length?Math.floor(w/b.CONSTANTS.MIN_STEP_WIDTH_WITH_TITLE):Math.floor(w/b.CONSTANTS.MIN_STEP_WIDTH_NO_TITLE);if(!this._aCachedSteps){return;}[].forEach.call(this._aCachedSteps,function(f){f.setAttribute(W.ATTRIBUTES.OPEN_STEP,false);f.setAttribute(W.ATTRIBUTES.OPEN_STEP_PREV,false);f.setAttribute(W.ATTRIBUTES.OPEN_STEP_NEXT,false);});if(this._aCachedSteps[c]){this._aCachedSteps[c].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);}for(var i=1;i<s;i++){if(e){d+=1;}if(e&&this._aCachedSteps[c+d]){this._aCachedSteps[c+d].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);e=!e;}else if(!e&&this._aCachedSteps[c-d]){this._aCachedSteps[c-d].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);e=!e;}else if(this._aCachedSteps[c+d+1]){d+=1;this._aCachedSteps[c+d].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);e=true;}else if(this._aCachedSteps[c-d]){this._aCachedSteps[c-d].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);d+=1;e=false;}}for(i=0;i<this._aCachedSteps.length;i++){if(this._aCachedSteps[i].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="true"&&this._aCachedSteps[i-1]&&this._aCachedSteps[i-1].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="false"){this._aCachedSteps[i-1].setAttribute(W.ATTRIBUTES.OPEN_STEP_PREV,true);}if(this._aCachedSteps[i].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="false"&&this._aCachedSteps[i-1]&&this._aCachedSteps[i-1].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="true"){this._aCachedSteps[i].setAttribute(W.ATTRIBUTES.OPEN_STEP_NEXT,true);break;}}};
b.prototype._isGroupAtStart=function(d){var $=q(d).closest("."+W.CLASSES.STEP);var s=this._getStepNumber($);return $.attr(W.ATTRIBUTES.OPEN_STEP_PREV)==="true"&&s>1;};
b.prototype._isGroupAtEnd=function(d){var $=q(d).closest("."+W.CLASSES.STEP);var s=this._getStepNumber($);return $.attr(W.ATTRIBUTES.OPEN_STEP_NEXT)==="true"&&s<this._aCachedSteps.length;};
b.prototype._showActionSheet=function(d,c){var f=c?0:this._getStepNumber(d)-1;var t=c?this._getStepNumber(d):this._aCachedSteps.length;var s,S,e,T,o,g,h;this._oActionSheetInvisibleText=new a({text:this._oResourceBundle.getText("WIZARD_STEPS")}).toStatic();this._oActionSheet.removeAllButtons();for(var i=f;i<t;i++){s=this.getStepIcons()[i];S=(i+1)+".";o=this._aCachedSteps[i].querySelector(".sapMWizardProgressNavStepTitle");e=o&&o.textContent;T=S+" "+e;this._oActionSheet.addButton(new B({width:"200px",text:T,icon:s,enabled:this._iActiveStep>=(i+1),press:function(j){this._moveToStep(j);this.fireStepChanged({current:j});}.bind(this,i+1)}));}this._oActionSheet.openBy(d);h=this._oActionSheetInvisibleText.getId();g=this._oActionSheet.getParent();if(g&&g.getAriaLabelledBy().indexOf(h)===-1){g.addAriaLabelledBy(h);}};
b.prototype._isOpenStep=function(d){var $=q(d).closest("."+W.CLASSES.STEP);return $.attr(W.ATTRIBUTES.OPEN_STEP)==="true"||($.attr(W.ATTRIBUTES.OPEN_STEP)==="false"&&$.attr(W.ATTRIBUTES.OPEN_STEP_PREV)==="true")||($.attr(W.ATTRIBUTES.OPEN_STEP)==="false"&&$.attr(W.ATTRIBUTES.OPEN_STEP_NEXT)==="true");};
b.prototype._isActiveStep=function(s){return s<=this._iActiveStep;};
b.prototype._getStepNumber=function(d){var $=q(d).closest("."+W.CLASSES.STEP).attr(W.ATTRIBUTES.STEP);return parseInt($);};
return b;});
sap.ui.predefine('sap/m/WizardProgressNavigatorRenderer',["sap/ui/core/InvisibleText","sap/ui/core/IconPool"],function(I,a){"use strict";var C={NAVIGATION:"sapMWizardProgressNav",LIST:"sapMWizardProgressNavList",LIST_VARYING:"sapMWizardProgressNavListVarying",LIST_NO_TITLES:"sapMWizardProgressNavListNoTitles",STEP:"sapMWizardProgressNavStep",STEP_CIRCLE:"sapMWizardProgressNavStepCircle",STEP_TITLE:"sapMWizardProgressNavStepTitle",STEP_TITLE_OPTIONAL_TITLE:"sapMWizardProgressNavStepTitleOptional",STEP_TITLE_OPTIONAL_LABEL:"sapMWizardProgressNavStepLabelOptional",STEP_ICON:"sapMWizardProgressNavStepIcon",STEP_TITLE_CONTAINER:"sapMWizardProgressNavStepTitleContainer"};var A={STEP:"data-sap-ui-wpn-step",STEP_COUNT:"data-sap-ui-wpn-step-count",CURRENT_STEP:"data-sap-ui-wpn-step-current",ACTIVE_STEP:"data-sap-ui-wpn-step-active",OPEN_STEP:"data-sap-ui-wpn-step-open",OPEN_STEP_PREV:"data-sap-ui-wpn-step-open-prev",OPEN_STEP_NEXT:"data-sap-ui-wpn-step-open-next",ARIA_CURRENT:"aria-current",ARIA_LABEL:"aria-label",ARIA_HASPOPUP:"aria-haspopup",ARIA_DISABLED:"aria-disabled",ARIA_DESCRIBEDBY:"aria-describedby"};var W={apiVersion:2,CLASSES:C,ATTRIBUTES:A},r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
W.render=function(R,c){this.startNavigator(R,c);this.renderList(R,c);this.endNavigator(R);};
W.startNavigator=function(R,c){var w=r.getText("WIZARD_PROGRESS_NAVIGATOR_ARIA_LABEL");R.openStart("nav",c).class(C.NAVIGATION).class("sapContrastPlus").attr(A.STEP_COUNT,c.getStepCount()).accessibilityState({label:w}).openEnd();};
W.renderList=function(R,c){this.startList(R,c);this.renderSteps(R,c);this.endList(R);};
W.startList=function(R,c){var s=c.getStepTitles();var w=r.getText("WIZARD_PROGRESS_NAVIGATOR_LIST_ARIA_LABEL");R.openStart("ul");if(c.getVaryingStepCount()){R.class(C.LIST_VARYING);}else{R.class(C.LIST);}if(!s.length){R.class(C.LIST_NO_TITLES);}R.accessibilityState({role:"list",label:w,controls:c.getParent().sId+"-step-container",describedby:I.getStaticId("sap.m","WIZARD_PROGRESS_NAVIGATOR_LIST_ARIA_DESCRIBEDBY")});R.openEnd();};
W.renderSteps=function(R,c){var s=c.getStepCount(),S=c.getStepTitles(),b=c._aStepOptionalIndication,d=c.getStepIcons(),o=r.getText("WIZARD_STEP_OPTIONAL_STEP_TEXT");for(var i=1;i<=s;i++){var l=b[i-1]?o:"";this.startStep(R,c,i,S[i-1],d[i-1],l);this.endStep(R);}};
W.startStep=function(R,c,s,S,i,o){var b=c._aCachedSteps;var d=b[s-1];var e=c._isActiveStep(s);var f=e?"ACTIVE":"INACTIVE";var v=r.getText("WIZARD_STEP_"+f+"_LABEL",[s,S,o]);var m={role:"listitem",label:v};R.openStart("li").class(C.STEP).attr(A.STEP,s).attr("tabindex","-1").accessibilityState(m);if(!d||parseInt(d.style.zIndex)){R.attr("aria-disabled","true");}R.attr("aria-posinset",s);if(!c.getVaryingStepCount()){R.attr("aria-setsize",c.getStepCount());}else{R.attr("aria-setsize","-1");}R.openEnd();R.openStart("div").class("sapMWizardProgressNavStepContainer");R.openEnd();this.renderStepCircle(R,i,s);if(S){this.renderStepTitle(R,S,o);}R.close("div");};
W.renderStepCircle=function(R,i,s){R.openStart("span").class(C.STEP_CIRCLE).openEnd();if(i){R.icon(i,[C.STEP_ICON],{title:null});}else{R.text(s);}R.close("span");};
W.renderStepTitle=function(R,s,o){R.openStart("span").class(C.STEP_TITLE_CONTAINER).openEnd();R.openStart("span").class(C.STEP_TITLE);if(o){R.class(C.STEP_TITLE_OPTIONAL_TITLE);}R.openEnd().text(s).close("span");if(o){R.openStart("span").class(C.STEP_TITLE_OPTIONAL_LABEL).openEnd().text("("+o+")").close("span");}R.close("span");};
W.endStep=function(R){R.close("li");};
W.endList=function(R){R.close("ul");};
W.endNavigator=function(R){R.close("nav");};
return W;},true);
sap.ui.predefine('sap/m/WizardRenderer',["sap/m/library"],function(l){"use strict";var W={apiVersion:2};
W.render=function(r,w){this.startWizard(r,w);this.renderProgressNavigator(r,w);this.renderWizardSteps(r,w);this.endWizard(r);};
W.startWizard=function(r,w){var s=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("WIZARD_LABEL");r.openStart("div",w).class("sapMWizard").class("sapMWizardMode"+w.getRenderMode()).class("sapMWizardBg"+w.getBackgroundDesign()).style("width",w.getWidth()).style("height",w.getHeight()).accessibilityState({role:"region",label:s}).openEnd();};
W.renderProgressNavigator=function(r,w){r.renderControl(w.getAggregation("_progressNavigator"));};
W.renderWizardSteps=function(r,w){r.openStart("section",w.getId()+"-step-container").class("sapMWizardStepContainer").openEnd();if(w.getRenderMode()===l.WizardRenderMode.Scroll){this._getStepsRenderingOrder(w).forEach(r.renderControl,r);}r.close("section");};
W.endWizard=function(r){r.close("div");};
W._getStepsRenderingOrder=function(w){if(!w.getEnableBranching()){return w.getSteps();}var s=w.getSteps().slice(),i,r,j,S;var c=function(a,i,r){var o=sap.ui.getCore().byId(a);if(s.indexOf(o)<s.indexOf(r)){var b=s.indexOf(o),t=s[b];s[b]=r;s[i]=t;i=0;}return i;};for(i=0;i<s.length;i++){r=s[i];S=r.getSubsequentSteps();if(S.length<1&&r.getNextStep()){S=[r.getNextStep()];}for(j=0;j<S.length;j++){i=c(S[j],i,r);}}return s;};
return W;},true);
sap.ui.predefine('sap/m/WizardStep',["./library","sap/ui/core/Control","sap/ui/core/InvisibleText","./WizardStepRenderer","./Button","./TitlePropagationSupport","sap/base/Log"],function(l,C,I,W,B,T,L){"use strict";
var a=C.extend("sap.m.WizardStep",{metadata:{properties:{title:{type:"string",group:"Appearance",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},validated:{type:"boolean",group:"Behavior",defaultValue:true},optional:{type:"boolean",group:"Appearance",defaultValue:false}},events:{complete:{parameters:{}},activate:{parameters:{}}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},_nextButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{subsequentSteps:{type:"sap.m.WizardStep",multiple:true,singularName:"subsequentStep"},nextStep:{type:"sap.m.WizardStep",multiple:false}}}});
var b=l.ButtonType;T.call(a.prototype,"content",function(){return this.getId()+"-title";});
a.prototype.init=function(){this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oNumberInvisibleText=new I({id:this.getId()+"-NumberedTitle"}).toStatic();this._createNextButton();this._initTitlePropagationSupport();};
a.prototype._createNextButton=function(){this._oNextButton=new B(this.getId()+"-nextButton",{text:this._oResourceBundle.getText("WIZARD_STEP")+2,type:b.Emphasized,press:this._complete.bind(this)}).addStyleClass("sapMWizardNextButtonVisible");this.setAggregation("_nextButton",this._oNextButton);};
a.prototype.setWizardContext=function(s){["bLast","bReviewStep","sButtonText","bParentAllowsButtonShow"].forEach(function(p){if(typeof s[p]!=="undefined"){this[p]=s[p];}}.bind(this));this._oNextButton.setText(this.sButtonText);this.setLast(this.bLast);this.setButtonVisibility();};
a.prototype._getNumberInvisibleText=function(){return this._oNumberInvisibleText;};
a.prototype._setNumberInvisibleText=function(n){return this._oNumberInvisibleText.setText(this._oResourceBundle.getText("WIZARD_STEP")+n+" "+this.getTitle());};
a.prototype.setValidated=function(v){this.setProperty("validated",v,true);this.setButtonVisibility();return this;};
a.prototype.setNextStep=function(v){this.setAssociation("nextStep",v,true);var p=this._getWizardParent();if(p!==null){p._checkCircularReference(this._getNextStepReference());p._updateProgressNavigator();}return this;};
a.prototype.setVisible=function(v){this.setProperty("visible",v,true);L.warning("Don't use the set visible method for wizard steps. If you need to show/hide steps based on some condition - use the branching property of the Wizard instead.");return this;};
a.prototype._isLeaf=function(){if(this.getNextStep()===null&&this.getSubsequentSteps().length===0){return true;}return false;};
a.prototype._isBranched=function(){return this.getSubsequentSteps().length>1;};
a.prototype._getNextStepReference=function(){if(this.getNextStep()!==null){return sap.ui.getCore().byId(this.getNextStep());}if(this.getSubsequentSteps().length===1){return sap.ui.getCore().byId(this.getSubsequentSteps()[0]);}return null;};
a.prototype._containsSubsequentStep=function(s){return this.getSubsequentSteps().some(function(S){return S===s;});};
a.prototype._getWizardParent=function(){var p=this.getParent();while(!(p instanceof sap.m.Wizard)){if(p===null){return null;}p=p.getParent();}return p;};
a.prototype.setLast=function(c){this.bLast=c;this.toggleStyleClass("sapMWizardLastActivatedStep",c);this.setButtonVisibility();};
a.prototype.setButtonVisibility=function(){var s=this.getValidated()&&this.bParentAllowsButtonShow&&this.bLast;if(typeof s==='undefined'){return;}this.displayButton(s);};
a.prototype.displayButton=function(s){this._oNextButton.toggleStyleClass("sapMWizardNextButtonHidden",!s);this._oNextButton.toggleStyleClass("sapMWizardNextButtonVisible",s);this._oNextButton.setVisible(s);};
a.prototype._activate=function(){this.setLast(true);this.addStyleClass("sapMWizardStepActivated");this.fireActivate();};
a.prototype._deactivate=function(){this.removeStyleClass("sapMWizardStepActivated");};
a.prototype._complete=function(){var w=this._getWizardParent();this.setLast(this.bReviewStep||false);this.fireComplete();if(w!==null){w._handleNextButtonPress();}};
a.prototype.exit=function(){this._oNumberInvisibleText.destroy();this._oNumberInvisibleText=null;};
return a;});
sap.ui.predefine('sap/m/WizardStepRenderer',function(){"use strict";var W={apiVersion:2};
W.render=function(r,s){this.startWizardStep(r,s);this.renderWizardStepTitle(r,s);this.renderContent(r,s);this.endWizardStep(r);};
W.startWizardStep=function(r,s){r.openStart("div",s).accessibilityState(s,{labelledby:s.getId()+"-Title",role:"region"}).class("sapMWizardStep").openEnd();};
W.renderWizardStepTitle=function(r,s){r.openStart("h3",s.getId()+"-Title").class("sapMWizardStepTitle").openEnd().text(this._resolveOrder(s)).text(s.getTitle()).close("h3");};
W.renderContent=function(r,s){s.getContent().forEach(r.renderControl,r);r.renderControl(s.getAggregation("_nextButton"));};
W.endWizardStep=function(r){r.close("div");};
W._resolveOrder=function(s){var d=s.getCustomData().filter(function(c){return c.getKey()==="stepIndex";})[0];return d?(d.getValue()+". "):"";};
return W;},true);
sap.ui.predefine('sap/m/changeHandler/AddTableColumn',["sap/ui/fl/changeHandler/BaseAddViaDelegate","sap/base/util/ObjectPath"],function(B,O){"use strict";var C="columns";var a="cells";var I="items";
function g(c,i,m,v,o){var e=O.get("oDataInformation.entityType",c);if(e){var b=c.content;return Promise.resolve().then(m.createControl.bind(m,'sap.m.Text',o,v,b.newFieldSelector.id+'--column',{text:"{/#"+e+"/"+b.bindingPath+"/@sap:label}"}));}return Promise.resolve(i.label);}
var A=B.createAddViaDelegateChangeHandler({aggregationName:C,parentAlias:"targetTable",fieldSuffix:"--field",skipCreateLabel:function(p){return!!O.get("changeDefinition.oDataInformation.entityType",p);},skipCreateLayout:true,supportsDefault:true,addProperty:function(p){var i=p.innerControls;if(i.valueHelp){return Promise.reject(new Error("Adding properties with value helps is not yet supported by addTableColumn change handler"));}var t=p.control;var m=p.modifier;var v=p.view;var o=p.appComponent;var c=p.change;var r=c.getRevertData();var b=c.getDefinition();var d=b.content;var e=d.newFieldIndex;var f=d.newFieldSelector;return Promise.resolve().then(m.getBindingTemplate.bind(m,t,I,v)).then(function(T){if(T){var s=i.control;return Promise.resolve().then(m.insertAggregation.bind(m,T,a,s,e,v)).then(m.updateAggregation.bind(m,t,I)).then(function(){r.newCellSelector={id:f.id+'--field',idIsLocal:true};c.setRevertData(r);});}return undefined;}).then(m.createControl.bind(m,'sap.m.Column',o,v,f)).then(function(h){return g(b,i,m,v,o).then(function(l){return Promise.resolve().then(m.insertAggregation.bind(m,h,'header',l,0,v)).then(m.insertAggregation.bind(m,t,C,h,e,v));});});},revertAdditionalControls:function(p){var t=p.control;var c=p.change;var o=c.getRevertData();var m=p.modifier;var b=p.appComponent;var T,n;return Promise.resolve().then(m.getBindingTemplate.bind(m,t,I)).then(function(r){T=r;if(T){return Promise.resolve().then(m.bySelector.bind(m,o.newCellSelector,b)).then(function(d){n=d;return m.removeAggregation(T,a,n);}).then(function(){return m.destroy(n);}).then(m.updateAggregation.bind(m,t,I));}return undefined;});}});return A;},true);
sap.ui.predefine('sap/m/changeHandler/ChangeLinkTarget',function(){"use strict";var C={};
C.applyChange=function(c,o,p){var m=p.modifier;var a=c.getDefinition();var t=a.content;return Promise.resolve().then(m.getProperty.bind(m,o,"target")).then(function(P){var r={target:P};m.setProperty(o,"target",t);c.setRevertData(r);});};
C.revertChange=function(c,o,p){var m=p.modifier;var r=c.getRevertData();var t=r.target;m.setProperty(o,"target",t);};
C.completeChangeContent=function(c,s,p){};
return C;});
sap.ui.predefine('sap/m/changeHandler/CombineButtons',["sap/base/util/uid","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/core/Component","sap/ui/fl/util/ManagedObjectModel"],function(u,J,C){"use strict";var a={};var c="$sap.m.flexibility.CombineButtonsModel";
function h(b,m,A,M,p,P,v,o,r){var s="";var e="";var O="";var f=[];var i=sap.ui.getCore().getConfiguration().getRTL();var g=[];return b.reduce(function(j,B,k){var I;var l=k;var n;var q;var S=o.content.buttonsIdForSave[l];var t;var w="$sap.m.flexibility.MenuButtonModel"+l;return j.then(m.getProperty.bind(m,B,"text")).then(function(R){t=R;return m.createControl("sap.m.MenuItem",A,v,S);}).then(function(x){n=x;return m.findIndexInParentAggregation(B);}).then(function(x){r.insertIndexes[l]=x;return m.createControl("sap.ui.fl.util.ManagedObjectModel",A,v,Object.assign({},S,{id:S.id+'-managedObjectModel'}),{object:B,name:c});}).then(function(x){q=x;return m.insertAggregation(n,"dependents",q,0,v);}).then(function(){return m.createControl("sap.ui.core.CustomData",A,v,Object.assign({},S,{id:S.id+'-customData'}),{key:"{ path: '"+c+">key' }",value:"{ path: '"+c+">value' }"});}).then(function(x){m.bindProperty(n,"text",c+">/text");m.bindProperty(n,"icon",c+">/icon");m.bindProperty(n,"enabled",c+">/enabled");m.bindProperty(n,"visible",c+">/visible");return m.bindAggregation(n,"customData",{path:c+">/customData",template:x,templateShareable:false},v);}).then(function(){if(t){i?g.unshift(t):g.push(t);}var N=Object.assign({},S,{id:S.id+'-originalButtonId'});return m.createControl("sap.ui.core.CustomData",A,v,N);}).then(function(R){I=R;m.setProperty(I,"key","originalButtonId");m.setProperty(I,"value",m.getId(B));return m.removeAggregation(p,P,B);}).then(function(){return m.insertAggregation(p,"dependents",B,0,v);}).then(function(){m.insertAggregation(B,"customData",I,0,v);}).then(function(){m.insertAggregation(M,"items",n,l,v);}).then(function(){return m.createControl("sap.ui.fl.util.ManagedObjectModel",A,v,Object.assign({},S,{id:S.id+'-managedObjectModelMenuItem'}),{object:n,name:w});}).then(function(x){f[l]=x;s=s+O+"${"+w+">/enabled}";e=e+O+"${"+w+">/visible}";O=" || ";return{menuButtonModels:f,menuButtonName:g,propertyEnabled:s,propertyVisible:e};});},Promise.resolve());}
a.applyChange=function(o,b,p){if(p.modifier.targets!=="jsControlTree"){return Promise.reject(new Error("Combine buttons change can't be applied on XML tree"));}var e=o.getDefinition();var m=p.modifier;var v=p.view;var A=p.appComponent;var P;var s;var i;var f;var B;var M;var g;var r={parentAggregation:"",insertIndexes:[]};var j=[];var k=[];return Promise.resolve().then(m.bySelector.bind(m,e.content.combineButtonSelectors[0],A,v)).then(function(R){s=R;P=m.getParent(s);var l=[];e.content.combineButtonSelectors.forEach(function(n){var q=Promise.resolve().then(m.bySelector.bind(m,n,A,v));l.push(q);});return Promise.all(l);}).then(function(l){B=l;return m.getParentAggregationName(B[0],P);}).then(function(R){f=R;r.parentAggregation=f;return m.findIndexInParentAggregation(s);}).then(function(l){i=l;return m.createControl("sap.m.Menu",A,v,e.content.menuIdSelector);}).then(function(l){M=l;return m.attachEvent(M,"itemSelected","sap.m.changeHandler.CombineButtons.pressHandler");}).then(function(){return h(B,m,A,M,P,f,v,e,r);}).then(function(l){j=l.menuButtonModels;k=l.menuButtonName;var n=l.propertyVisible;var q=l.propertyEnabled;return m.createControl("sap.m.MenuButton",A,v,e.content.menuButtonIdSelector,{visible:"{= "+n+"}",enabled:"{= "+q+"}"});}).then(function(l){g=l;return j.reduce(function(n,q){return n.then(m.insertAggregation.bind(m,g,"dependents",q,0,v));},Promise.resolve());}).then(function(){m.setProperty(g,"text",k.join("/"));return Promise.resolve().then(m.insertAggregation.bind(m,g,"menu",M,0,v)).then(m.insertAggregation.bind(m,P,f,g,i,v)).then(function(){o.setRevertData(r);});});};
function d(b,m){return b.reduce(function(p,o){return p.then(function(){return m.getProperty(o,"key");}).then(function(k){if(k==="originalButtonId"){return m.destroy(o);}return undefined;});},Promise.resolve());}
a.revertChange=function(o,b,p){var m=p.modifier;var v=p.view;var r=o.getRevertData();var e=o.getDefinition();var P=r.parentAggregation;var M,f,B;return Promise.resolve().then(function(){return m.bySelector(e.content.menuButtonIdSelector,p.appComponent,v);}).then(function(R){M=R;f=m.getParent(M);B=e.content.combineButtonSelectors.slice().reverse();return m.removeAggregation(f,P,M);}).then(function(){return m.destroy(M);}).then(function(){var l=B.length;return B.reduce(function(g,i,j){var I=j;var k;return g.then(function(){return m.bySelector(i,p.appComponent,v);}).then(function(R){k=R;return m.getAggregation(k,"customData");}).then(function(n){return d(n,m);}).then(function(){return m.insertAggregation(f,P,k,r.insertIndexes[l-I-1],v);});},Promise.resolve()).then(function(){o.resetRevertData();});});};
a.completeChangeContent=function(o,s,p){var m=p.modifier;var A=p.appComponent;var b=o.getDefinition();var e=s.combineElementIds;if(e&&e.length>1){o.addDependentControl(e,"combinedButtons",p);b.content.combineButtonSelectors=e.map(function(f){return m.getSelector(f,A);});b.content.menuButtonIdSelector=m.getSelector(A.createId(u()),A);b.content.menuIdSelector=m.getSelector(A.createId(u()),A);b.content.buttonsIdForSave=e.map(function(){return m.getSelector(A.createId(u()),A);});}else{throw new Error("Combine buttons action cannot be completed: oSpecificChangeInfo.combineElementIds attribute required");}};
a.pressHandler=function(e){var b=e.getParameter("item").getModel(c).getObject();b.firePress();};
return a;},true);
sap.ui.predefine('sap/m/changeHandler/MoveTableColumns',["sap/base/Log","sap/ui/thirdparty/jquery"],function(L,q){"use strict";var M={};var S="source";var T="target";var a="movedElements";var C="columns";var b="cells";var I="items";
function s(o,v,r,i,t){return Promise.resolve().then(o.getAggregation.bind(o,r,b)).then(function(c){if(!c){L.warning("Aggregation cells to move not found");return Promise.reject();}if(i<0||i>=c.length){L.warning("Move cells in table item called with invalid index: "+i);return Promise.reject();}var d=c[i];return Promise.resolve().then(o.removeAggregation.bind(o,r,b,d)).then(o.insertAggregation.bind(o,r,b,d,t,v));});}
function m(o,v,t,i,c){return Promise.resolve().then(o.getAggregation.bind(o,t,I)).then(function(d){return d.reduce(function(p,e){return p.then(function(){if(o.getControlType(e)!=="sap.m.GroupHeaderListItem"){return s(o,v,e,i,c);}return undefined;});},Promise.resolve());});}
function _(c,r,p,i){var o=p.modifier;var v=p.view;var A=p.appComponent;var d=c.getContent();var t=c.getDependentControl(S,p);var e=c.getDependentControl(T,p);var f;var g;return Promise.resolve().then(function(){return o.getAggregation(e,C);}).then(function(R){f=R;if(t!==e){L.warning("Moving columns between different tables is not yet supported.");return Promise.reject(false);}return d.movedElements.reduce(function(P,h){var j;var k;var l;var n;var u;return P.then(function(){g=o.bySelector(h.selector,A,v);if(!g){u=h.selector&&h.selector.id;L.warning("The table column with id: '"+u+"' stored in the change is not found and the move operation cannot be applied");return Promise.reject();}l=f.indexOf(g);n=h.sourceIndex;k=typeof i==="function"&&i(n);k=q.isNumeric(k)?k:h.targetIndex;if(l!==k){j=l;}else{j=n;}return o.removeAggregation(e,C,g);}).then(function(){return o.insertAggregation(e,C,g,k,v);}).then(function(){return o.getBindingTemplate(e,I);}).then(function(w){if(w){return s(o,v,w,j,k).then(o.updateAggregation.bind(o,e,I));}else{return m(o,v,e,j,k);}});},Promise.resolve());});}
M.applyChange=function(c,r,p){var R=[];return Promise.resolve().then(function(){return _(c,r,p,function(i){R.unshift({index:i});});}).then(function(){c.setRevertData(R);});};
M.revertChange=function(c,r,p){var R=c.getRevertData();return Promise.resolve().then(function(){return _(c,r,p,function(){var i=R.shift();return i&&i.index;});}).then(function(){c.resetRevertData();});};
M.completeChangeContent=function(c,d,p){var o=p.modifier;var A=p.appComponent;var e=c.getDefinition();var f=o.bySelector(d.source.id,A);var t=o.bySelector(d.target.id,A);var g={aggregation:d.source.aggregation,type:o.getControlType(f)};var h={aggregation:d.target.aggregation,type:o.getControlType(t)};e.content={movedElements:[]};d.movedElements.forEach(function(E){var i=E.element||o.bySelector(E.id,A);e.content.movedElements.push({selector:o.getSelector(i,A),sourceIndex:E.sourceIndex,targetIndex:E.targetIndex});});c.addDependentControl(d.source.id,S,p,g);c.addDependentControl(d.target.id,T,p,h);c.addDependentControl(d.movedElements.map(function(i){return i.id;}),a,p);};
return M;},true);
sap.ui.predefine('sap/m/changeHandler/SelectIconTabBarFilter',["sap/ui/fl/library"],function(f){"use strict";var S={};
S.applyChange=function(c,C,p){var m=p.modifier;var o=c.getDefinition();C._bFireSelectEvent=o.content.fireEvent;m.setProperty(C,"selectedKey",o.content.selectedKey);C._bFireSelectEvent=false;c.setRevertData({key:o.content.previousSelectedKey,fireEvent:o.content.fireEvent});};
S.revertChange=function(c,C,p){var m=p.modifier;var r=c.getRevertData();C._bFireSelectEvent=r.fireEvent;m.setProperty(C,"selectedKey",r.key);C._bFireSelectEvent=false;c.resetRevertData();};
S.completeChangeContent=function(c,s,p){};
S.getCondenserInfo=function(c){return{affectedControl:c.getSelector(),classification:f.condenser.Classification.LastOneWins,uniqueKey:c.getContent().selectedKey};};
return S;});
sap.ui.predefine('sap/m/changeHandler/SplitMenuButton',["sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/core/Component","sap/ui/fl/util/ManagedObjectModel"],function(J,C){"use strict";var S={};var a="sourceControl";
S.applyChange=function(c,o,p){if(p.modifier.targets!=="jsControlTree"){return Promise.reject(new Error("Split change can't be applied on XML tree"));}var b=c.getDefinition();var m=p.modifier;var v=p.view;var A=p.appComponent;var s=c.getDependentControl(a,p);var M;var d;var P;var i;var n;var r;var e;var f;var g;return Promise.resolve().then(function(){return m.getAggregation(s,"menu");}).then(function(R){M=R;return m.getAggregation(M,"items");}).then(function(R){d=R;g=m.getParent(s);return m.getParentAggregationName(s,g);}).then(function(R){P=R;return m.findIndexInParentAggregation(s);}).then(function(R){i=R;n=b.content.newElementIds;r={parentAggregation:P,insertIndex:i,insertedButtons:[]};return d.reduce(function(h,j,k){var l;var I;var B;return h.then(function(){I=k;l=n[I];return m.createControl("sap.m.Button",A,v,l);}).then(function(q){B=q;r.insertedButtons.push(l);e="$sap.m.flexibility.SplitButtonsModel";return m.createControl("sap.ui.fl.util.ManagedObjectModel",A,v,Object.assign({},l,{id:l.id+'-managedObjectModel'}),{object:j,name:e});}).then(function(q){f=q;return m.insertAggregation(B,"dependents",f,0,v);}).then(function(){m.bindProperty(B,"text",e+">/text");m.bindProperty(B,"icon",e+">/icon");m.bindProperty(B,"enabled",e+">/enabled");m.bindProperty(B,"visible",e+">/visible");return m.createControl("sap.ui.core.CustomData",A,v,Object.assign({},l,{id:l.id+'-customData'}),{key:{path:e+">key"},value:{path:e+">value"}});}).then(function(t){return m.bindAggregation(B,"customData",{path:e+">/customData",template:t,templateShareable:false});}).then(function(){return m.attachEvent(B,"press","sap.m.changeHandler.SplitMenuButton.pressHandler",{selector:m.getSelector(j,A),appComponentId:A.getId(),menu:M});}).then(function(){return m.insertAggregation(g,P,B,i+I,v);});},Promise.resolve());}).then(function(){return Promise.resolve().then(m.removeAggregation.bind(m,g,P,s)).then(m.insertAggregation.bind(m,g,"dependents",s,0,v)).then(function(){c.setRevertData(r);});});};
S.revertChange=function(c,o,p){var m=p.modifier;var r=c.getRevertData();var s=c.getDependentControl(a,p);var A=p.appComponent;var v=p.view;var P=m.getParent(s);var b=r.parentAggregation;var i=r.insertIndex;var I=[];return Promise.resolve().then(function(){r.insertedButtons.forEach(function(d){I.push(m.bySelector(d,A,v));});return I.reduce(function(d,B){return d.then(function(){return m.removeAggregation(P,b,B);}).then(function(){return m.destroy(B);});},Promise.resolve());}).then(m.insertAggregation.bind(m,P,b,s,i,v)).then(function(){c.resetRevertData();});};
S.completeChangeContent=function(c,s,p){var m=p.modifier;var A=p.appComponent;var o=c.getDefinition();if(!s.newElementIds){throw new Error("Split of MenuButton cannot be applied : oSpecificChangeInfo.newElementIds attribute required");}if(!s.sourceControlId){throw new Error("Split of MenuButton cannot be applied : oSpecificChangeInfo.sourceControlId attribute required");}c.addDependentControl(s.sourceControlId,a,p);o.content.sourceSelector=m.getSelector(s.sourceControlId,A);o.content.newElementIds=s.newElementIds.map(function(e){return m.getSelector(e,A);});};
S.pressHandler=function(e,p){var m=J.bySelector(p.selector,C.get(p.appComponentId));m.firePress();p.menu.fireItemSelected({item:m});};
return S;},true);
sap.ui.predefine('sap/m/delegate/DateNavigation',['sap/ui/base/EventProvider','sap/ui/core/date/UniversalDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/library'],function(E,U,C,a,u){"use strict";var P=u.CalendarIntervalType;
var D=E.extend("sap.m.delegate.DateNavigation",{constructor:function(){E.apply(this,arguments);this._unit=P.Day;this._start=new Date();this._step=1;}});
D.HOURS24=1000*3600*24;
D.prototype.setUnit=function(p){this._unit=p;};
D.prototype.setStart=function(d){this._start=d;};
D.prototype.setStep=function(s){this._step=s;};
D.prototype.setCurrent=function(d){this._current=d;};
D.prototype.getUnit=function(){return this._unit;};
D.prototype.getStart=function(){return this._start;};
D.prototype.getStep=function(){return this._step;};
D.prototype.getCurrent=function(){return this._current;};
D.prototype.getEnd=function(){var c=C._createUniversalUTCDate(this.getStart(),undefined,true);switch(this.getUnit()){case P.Day:case P.Week:c.setUTCDate(c.getUTCDate()+this.getStep()-1);break;case P.OneMonth:case"OneMonth":c.setUTCMonth(c.getUTCMonth()+1);c.setUTCDate(c.getUTCDate()-1);break;case P.Hour:c.setUTCHours(c.getUTCHours()+this.getStep()-1);break;case P.Month:c.setUTCMonth(c.getUTCMonth()+this.getStep()-1);break;default:break;}return C._createLocalDate(c,true);};
D.prototype.next=function(){var n=C._createUniversalUTCDate(this.getStart(),undefined,true);var N=this.getCurrent()?C._createUniversalUTCDate(this.getCurrent(),undefined,true):C._createUniversalUTCDate(this.getStart(),undefined,true);switch(this.getUnit()){case P.Hour:N.setUTCHours(N.getUTCHours()+this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCHours(n.getUTCHours()+this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Week:case P.Day:N.setUTCDate(N.getUTCDate()+this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCDate(n.getUTCDate()+this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Month:N.setUTCMonth(N.getUTCMonth()+this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()+this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.OneMonth:case"OneMonth":N.setUTCMonth(N.getUTCMonth()+1,1);this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()+1,1);this.setStart(C._createLocalDate(n,true));break;default:break;}};
D.prototype.previous=function(){var n=C._createUniversalUTCDate(this.getStart(),undefined,true);var N=this.getCurrent()?C._createUniversalUTCDate(this.getCurrent(),undefined,true):C._createUniversalUTCDate(this.getStart(),undefined,true);switch(this.getUnit()){case P.Hour:N.setUTCHours(N.getUTCHours()-this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCHours(n.getUTCHours()-this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Week:case P.Day:N.setUTCDate(N.getUTCDate()-this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCDate(n.getUTCDate()-this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Month:N.setUTCMonth(N.getUTCMonth()-this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()-this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.OneMonth:case"OneMonth":N.setUTCMonth(N.getUTCMonth()-1,1);this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()-1,1);this.setStart(C._createLocalDate(n,true));break;default:break;}};
D.prototype.toDate=function(t){var n,c,h,N=C._createUniversalUTCDate(t,undefined,true),o=C._createUTCDate(t,true);this.setCurrent(t);switch(this.getUnit()){case P.OneMonth:case"OneMonth":if(C.monthsDiffer(this.getStart(),t)){var f=C.getFirstDateOfMonth(o);this.setStart(C._createLocalDate(f,true));}break;case P.Day:c=C._createUniversalUTCDate(this.getStart(),undefined,true);c.setUTCDate(c.getUTCDate()+this.getStep());if(t.valueOf()>=c.valueOf()){h=1+Math.ceil((t.valueOf()-c.valueOf())/(D.HOURS24));n=C._createUniversalUTCDate(this.getStart(),undefined,true);n.setUTCDate(n.getUTCDate()+h);this.setStart(C._createLocalDate(n,true));}else if(t.valueOf()<this.getStart().valueOf()){n=C._createUniversalUTCDate(t,undefined,true);this.setStart(C._createLocalDate(n,true));}break;case P.Month:c=C._createUniversalUTCDate(this.getStart());c.setUTCMonth(c.getUTCMonth()+this.getStep());if(N.getTime()>=c.valueOf()){h=1+C._monthsBetween(t,C._createLocalDate(c,true));n=C._createUniversalUTCDate(this.getStart(),undefined,true);n.setUTCMonth(n.getUTCMonth()+h);this.setStart(C._createLocalDate(n,true));}else if(t.valueOf()<this.getStart().valueOf()){n=C._createUniversalUTCDate(t,undefined,true);this.setStart(C._createLocalDate(n,true));}break;case P.Week:var T=C.getFirstDateOfWeek(o);if(this.getStart().valueOf()!==T.valueOf()){this.setStart(C._createLocalDate(T,true));}break;case P.Hour:c=this.getEnd(this.getStart());var b=C._createUniversalUTCDate(c,undefined,true);if(N.getTime()<C._createUniversalUTCDate(this.getStart(),undefined,true).getTime()||N.getTime()>b.getTime()){this.setStart(t);}break;default:break;}};
return D;});
sap.ui.predefine('sap/m/delegate/ValueStateMessage',['sap/ui/Device','sap/ui/base/Object','sap/ui/core/Core','sap/ui/core/ValueStateSupport','sap/ui/core/Popup','sap/ui/core/library',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Aria"],function(D,B,C,V,P,c,q){"use strict";var a=c.ValueState;
var b=B.extend("sap.m.delegate.ValueState",{constructor:function(o){B.apply(this,arguments);this._oControl=o;this._oPopup=null;}});
b.prototype.open=function(){var o=this._oControl,p=this.getPopup(),m=this.createDom(),d=P.Dock,$;if(!o||!o.getDomRef()||!p||!m){return;}$=q(o.getDomRefForValueStateMessage());p.setContent(m);p.close(0);if(p.getContent()){p.getContent().style.maxWidth=o.getDomRef().offsetWidth+"px";}else{p.getContent().style.maxWidth="";}p.open(this.getOpenDuration(),d.BeginTop,d.BeginBottom,o.getDomRefForValueStateMessage(),null,null,null,D.system.phone?true:P.CLOSE_ON_SCROLL);var e=q(m);if($.offset().top<e.offset().top){e.addClass("sapMValueStateMessageBottom");}else{e.addClass("sapMValueStateMessageTop");}};
b.prototype.close=function(){if(this._oPopup){this._oPopup.close(0);}};
b.prototype.getId=function(){var o=this._oControl;if(!o){return"";}return(typeof o.getValueStateMessageId==="function")?o.getValueStateMessageId():o.getId()+"-message";};
b.prototype.getOpenDuration=function(){var o=this._oControl;if(!o){return 0;}return(o.iOpenMessagePopupDuration===undefined)?0:o.iOpenMessagePopupDuration;};
b.prototype.createPopup=function(i){i=i||this.getId();if(this._oPopup){return this._oPopup;}this._oPopup=new P(document.createElement("span"),false,false,false);this._oPopup.attachClosed(function(){q(document.getElementById(i)).remove();});this._oPopup.attachOpened(function(){var d=this._oPopup.getContent();if(d){d.style.zIndex=this._getCorrectZIndex();}}.bind(this));return this._oPopup;};
b.prototype.getPopup=function(){if(!this._oControl){return null;}return this.createPopup();};
b.prototype._getValueStateText=function(o,v){if(v===a.Success||v===a.None){return"";}var d=o.getFormattedValueStateText&&o.getFormattedValueStateText();var e=d&&d.getHtmlText();var s=o.getValueStateText()||V.getAdditionalText(o);return e?d:s;};
b.prototype.createDom=function(){var o=this._oControl;if(!o){return null;}var i=this.getId(),t,m=document.createElement("div"),v=o.getValueState(),d=this._getValueStateText(o,v);if(v===a.Success||v===a.None){m.className="sapUiInvisibleText";}else{m.className="sapMValueStateMessage sapMValueStateMessage"+v;}if(typeof d==="string"){t=document.createElement("span");t.id=i+"-text";t.appendChild(document.createTextNode(d));m.appendChild(t);}else{C.createRenderManager().render(d,m);m.lastElementChild.setAttribute("id",i+"-text");}m.id=i;m.setAttribute("role","presentation");m.setAttribute("aria-hidden","true");return m;};
b.prototype.destroy=function(){if(this._oPopup){this._oPopup.destroy();this._oPopup=null;}this._oControl=null;};
b.prototype._getCorrectZIndex=function(){var p=this._oControl.$().parents().filter(function(){var z=q(this).css('z-index');return z&&z!=='auto'&&z!=='0';});if(!p.length){return 1;}var h=0;p.each(function(){var z=parseInt(q(this).css('z-index'));if(z>h){h=z;}});return h+1;};
return b;});
sap.ui.predefine('sap/m/flexibility/Avatar.flexibility',[],function(){"use strict";return{"hideControl":"default","unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Bar.flexibility',["sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(C,S){"use strict";return{"moveControls":"default","combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};},true);
sap.ui.predefine('sap/m/flexibility/Button.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XBUT"}),"unhideControl":"default"};});
sap.ui.predefine('sap/m/flexibility/CheckBox.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XCKL"}),"unhideControl":"default"};});
sap.ui.predefine('sap/m/flexibility/Dialog.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"})};});
sap.ui.predefine('sap/m/flexibility/ExpandableText.flexibility',['sap/ui/fl/changeHandler/BaseRename'],function(B){"use strict";return{"hideControl":"default","unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/IconTabBar.flexibility',["sap/m/changeHandler/SelectIconTabBarFilter"],function(S){"use strict";return{"moveControls":"default","selectIconTabBarFilter":{"changeHandler":S,"layers":{"USER":true}}};});
sap.ui.predefine('sap/m/flexibility/IconTabFilter.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XTBS"})};});
sap.ui.predefine('sap/m/flexibility/InputListItem.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"label",translationTextType:"XBLI"}),"unhideControl":"default","moveControls":"default"};});
sap.ui.predefine('sap/m/flexibility/Label.flexibility',['sap/ui/fl/changeHandler/BaseRename'],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XFLD"}),"unhideControl":"default"};});
sap.ui.predefine('sap/m/flexibility/Link.flexibility',["sap/m/changeHandler/ChangeLinkTarget","sap/ui/fl/changeHandler/BaseRename"],function(C,B){"use strict";return{"hideControl":"default","unhideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XBUT"}),"changeLinkTarget":{"changeHandler":C,"layers":{"CUSTOMER":false}}};});
sap.ui.predefine('sap/m/flexibility/MenuButton.flexibility',["sap/m/changeHandler/SplitMenuButton","sap/ui/fl/changeHandler/BaseRename"],function(S,B){"use strict";return{"hideControl":"default","splitMenuButton":S,"rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XFLD"})};},true);
sap.ui.predefine('sap/m/flexibility/OverflowToolbar.flexibility',["sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(C,S){"use strict";return{"moveControls":"default","combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};},true);
sap.ui.predefine('sap/m/flexibility/OverflowToolbarButton.flexibility',[],function(){"use strict";return{"hideControl":"default","unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Page.flexibility',["sap/ui/fl/changeHandler/BaseRename","sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(B,C,S){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"}),"combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};});
sap.ui.predefine('sap/m/flexibility/Panel.flexibility',['sap/ui/fl/changeHandler/BaseRename'],function(B){"use strict";return{"hideControl":"default","moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"headerText",translationTextType:"XGRP"}),"unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Popover.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"})};});
sap.ui.predefine('sap/m/flexibility/RadioButton.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XBUT"}),"unhideControl":"default"};});
sap.ui.predefine('sap/m/flexibility/StandardListItem.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"}),"unhideControl":"default","moveControls":"default"};});
sap.ui.predefine('sap/m/flexibility/Table.flexibility',["sap/m/changeHandler/MoveTableColumns","sap/m/changeHandler/AddTableColumn"],function(M,A){"use strict";return{"hideControl":"default","unhideControl":"default","moveTableColumns":M,"addTableColumn":A};},true);
sap.ui.predefine('sap/m/flexibility/Text.flexibility',['sap/ui/fl/changeHandler/BaseRename'],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XTXT"}),"unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Title.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XTIT"}),"unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Toolbar.flexibility',["sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(C,S){"use strict";return{"moveControls":"default","combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};},true);
sap.ui.predefine('sap/m/inputUtils/ListHelpers',["sap/m/library","sap/base/util/deepEqual","sap/m/GroupHeaderListItem","sap/m/StandardListItem","sap/ui/base/ManagedObject"],function(l,d,G,S,M){"use strict";var L=l.ListType;var a={};a.CSS_CLASS="InputWithSuggestions";
a.getItemByListItem=function(i,o){return this.getItemBy(i,o,"ListItem");};
a.getListItem=function(i){return i&&i.data?i.data(a.CSS_CLASS+"ListItem"):null;};
a.getItemBy=function(I,D,s){var o;s=a.CSS_CLASS+s;if(!Array.isArray(I)||!D){return null;}for(var i=0;i<I.length;i++){o=I[i].data&&I[i].data(s);if(o===D||d(o,D)){return I[i];}}return null;};
a.getEnabledItems=function(i){if(!Array.isArray(i)){return[];}return i.filter(function(I){return I.getEnabled&&I.getEnabled();});};
a.getSelectableItems=function(i){if(!Array.isArray(i)){return[];}return this.getAllSelectableItems(this.getVisibleItems(i));};
a.getAllSelectableItems=function(i){if(!Array.isArray(i)){return[];}return this.getEnabledItems(i).filter(function(o){return!o.isA("sap.ui.core.SeparatorItem");});};
a.getVisibleItems=function(i){var o;if(!Array.isArray(i)){return[];}return i.filter(function(I){o=a.getListItem(I);return o&&o.getVisible();});};
a.createListItemFromCoreItem=function(i,s){var o;if(!i){return null;}var t=i.getTextDirection();if(i.isA("sap.ui.core.SeparatorItem")){o=new G({title:M.escapeSettingsValue(i.getText()),type:L.Inactive,titleTextDirection:t});}else if(i.isA("sap.ui.core.Item")){o=new S({type:L.Active,visible:i.getEnabled(),titleTextDirection:t,infoTextDirection:t});o.setTitle(i.getText());o.setInfo((i.getAdditionalText&&s)?i.getAdditionalText():"");o.setTooltip(i.getTooltip());}else{return null;}i.data(a.CSS_CLASS+"ListItem",o);i.getCustomData().forEach(function(c){o.addCustomData(c.clone(null,null,{cloneBindings:false}));});return o;};
a.fillList=function(i,I,m){if(!I||!Array.isArray(i)){return;}if(I.isA("sap.m.Table")){I.removeSelections(true);}else{I.destroyItems();}i.forEach(function(o){I.addItem(m(o));});};
return a;});
sap.ui.predefine('sap/m/inputUtils/SuggestionsPopoverDialogMixin',["sap/m/library","sap/ui/core/Core","sap/ui/core/IconPool","sap/m/Dialog","sap/m/Button","sap/m/Bar","sap/m/Title","sap/m/Toolbar","sap/m/ToggleButton","sap/m/ValueStateHeader"],function(l,C,I,D,B,a,T,b,c,V){"use strict";var d=l.TitleAlignment;return function(){this.getPickerTitle=function(){return this.getPopover().getCustomHeader().getContentMiddle()[0];};this.getOkButton=function(){var p=this.getPopover(),o=p&&p.getBeginButton();return o||null;};this.getCancelButton=function(){var p=this.getPopover(),o=p&&p.getCustomHeader()&&p.getCustomHeader().getContentRight&&p.getCustomHeader().getContentRight()[0];return o||null;};this.getFilterSelectedButton=function(){var p=this.getPopover(),o=p&&p.getSubHeader()&&p.getSubHeader().getContent()[1];return o||null;};this.getShowMoreButton=function(){return this.getPopover().getEndButton();};this.setShowMoreButton=function(s){this.getPopover().setEndButton(s);return this;};this.removeShowMoreButton=function(){this.getPopover().destroyAggregation("endButton");return this;};this.setOkPressHandler=function(h){var o=this.getOkButton();o&&o.attachPress(h);return o;};this.setCancelPressHandler=function(h){var o=this.getCancelButton();o&&o.attachPress(h);return o;};this.setShowSelectedPressHandler=function(h){var f=this.getFilterSelectedButton();f&&f.attachPress(h);return f;};this.createPopover=function(i,o){var m=C.getLibraryResourceBundle("sap.m"),t=this,p=new sap.m.Input(i.getId()+"-popup-input",{width:"100%",showValueStateMessage:false});return new D(i.getId()+"-popup",{beginButton:new B(i.getId()+"-popup-closeButton",{text:m.getText("SUGGESTIONSPOPOVER_CLOSE_BUTTON")}),stretch:true,titleAlignment:d.Auto,customHeader:new a(i.getId()+"-popup-header",{titleAlignment:d.Auto,contentMiddle:new T(),contentRight:new B({icon:I.getIconURI("decline")})}),subHeader:_(o,p),horizontalScrolling:false,initialFocus:p,beforeOpen:function(){t._updatePickerHeaderTitle();},afterClose:function(){i.focus();l.closeKeyboard();}});};this.getInput=function(){var p=this.getPopover(),s=p&&p.getSubHeader(),S=s&&s.getContent();return S&&S.filter(function(o){return o.isA("sap.m.InputBase");})[0];};this._updatePickerHeaderTitle=function(){var r=C.getLibraryResourceBundle("sap.m"),p=this.getPickerTitle(),L,f;if(!p){return;}f=this._getInputLabels();if(f.length){L=f[0];if(L&&(typeof L.getText==="function")){p.setText(L.getText());}}else{p.setText(r.getText("COMBOBOX_PICKER_TITLE"));}return p;};this._getInputLabels=function(){return this._fnInputLabels();};function _(o,p){var f=[p];if(o.showSelectedButton){f.push(e());}return new b({content:f});}function e(){var i=I.getIconURI("multiselect-all");return new c({icon:i});}this._getValueStateHeader=function(){var p=this.getPopover();if(!p.getContent().length||(p.getContent().length&&!p.getContent()[0].isA("sap.m.ValueStateHeader"))){this._createValueStateHeader();}return p.getContent()[0];};this._createValueStateHeader=function(){var v=new V();var p=this.getPopover();p.insertContent(v,0);v.setPopup(p);};};});
sap.ui.predefine('sap/m/inputUtils/SuggestionsPopoverPopoverMixin',["sap/m/library","sap/m/Popover","sap/m/ValueStateHeader"],function(l,P,V){"use strict";var a=l.PlacementType;return function(){this.createPopover=function(i){var t=this,p=new P(i.getId()+"-popup",{showArrow:false,placement:a.VerticalPreferredBottom,showHeader:true,initialFocus:i,horizontalScrolling:true,beforeClose:function(){if(t.getValueStateActiveState()){t._getValueStateHeader().removeStyleClass("sapMPseudoFocus");t.setValueStateActiveState(false);}}});return _(p,i);};this.resizePopup=function(i){var p=this.getPopover();if(this.getItemsContainer()&&p){if(this._sPopoverContentWidth){p.setContentWidth(this._sPopoverContentWidth);}else{p.setContentWidth((i.$().outerWidth())+"px");}setTimeout(function(){if(p&&p.isOpen()&&p.$().outerWidth()<i.$().outerWidth()){p.setContentWidth((i.$().outerWidth())+"px");}},0);}};this.getShowMoreButton=function(){return this.getPopover()&&this.getPopover().getFooter()&&this.getPopover().getFooter().getContent()[1];};this.setShowMoreButton=function(b){this.getPopover().setFooter(b);return this;};this.removeShowMoreButton=function(){this.getPopover().destroyAggregation("footer");return this;};function _(p,i){p.open=function(){this.openBy(i,false,true);};p.oPopup.setAnimations(function(r,R,o){o();},function(r,R,c){c();});return p;}this._getValueStateHeader=function(){var p=this.getPopover();var v=p&&p.getCustomHeader();if(p&&!v){v=this._createValueStateHeader();}return v;};this._createValueStateHeader=function(){var v=new V();var p=this.getPopover();p.setCustomHeader(v);v.setPopup(p);return v;};};});
sap.ui.predefine('sap/m/inputUtils/calculateSelectionStart',["sap/m/inputUtils/selectionRange"],function(s){"use strict";var i=function(I,t){if(typeof I!="string"||I===""||typeof t!="string"||t===""){return false;}return I.toLowerCase().startsWith(t.toLowerCase());};var c=function(S,I,t,b){var a=S&&S.start!==S.end,d=i(I,t),e=!(d&&(a||b));return e?0:S.start;};return c;});
sap.ui.predefine('sap/m/inputUtils/completeTextSelected',[],function(){"use strict";var c=function(i){var v=i&&i.value&&i.value.length;if(!i||!v||i.selectionStart!==0||i.selectionEnd!==v){return false;}return true;};return c;});
sap.ui.predefine('sap/m/inputUtils/filterItems',["sap/m/inputUtils/ListHelpers"],function(L){"use strict";var f=function(i,I,v,F,b,a){var g=[],c=[];I=I&&L.getEnabledItems(I);I.forEach(function(o){if(o.isA("sap.ui.core.SeparatorItem")){g.push({header:o,visible:false});}else if(!F||a.call(i,v,o,b)){if(g.length){g[g.length-1].visible=true;}c.push(o);}});return{items:c,groups:g};};return f;});
sap.ui.predefine('sap/m/inputUtils/forwardItemProperties',["sap/m/inputUtils/ListHelpers"],function(L){"use strict";var f=function(i,s){var I=i.item;var l=I.data(L.CSS_CLASS+"ListItem");var a;var p;var S;var d={text:"title",enabled:"visible",tooltip:"tooltip"};var b=i.propName;var c=i.propValue;if(!l){return;}if(d[b]){p=d[b];S="set"+p.charAt(0).toUpperCase()+p.slice(1);l[S](c);}if(b==="additionalText"){a=s?c:"";l.setInfo(a);}};return f;});
sap.ui.predefine('sap/m/inputUtils/forwardItemPropertiesToToken',["sap/m/inputUtils/ListHelpers","sap/m/inputUtils/getTokenByItem"],function(L,g){"use strict";var f=function(i){var I=i.item;var p=i.propName;var a=i.propValue;var t=g(I);if(!t){return;}if(p==="enabled"){t.setVisible(a);}else if(t.getMetadata().hasProperty(p)){t.setProperty(p,a);}};return f;});
sap.ui.predefine('sap/m/inputUtils/getTokenByItem',["sap/m/inputUtils/ListHelpers"],function(L){"use strict";var g=function(i){return i?i.data(L.CSS_CLASS+"Token"):null;};return g;});
sap.ui.predefine('sap/m/inputUtils/highlightDOMElements',["sap/m/inputUtils/wordStartsWithValue","sap/base/security/encodeXML"],function(w,e){"use strict";var _=function(i,I,W){var d,s,a,n,c,t=i?i.textContent:"",f="";if(!w(t,I)){return e(t);}I=I.toLowerCase();a=I.length;while(w(t,I)){d=t.toLowerCase();s=d.indexOf(I);s=(s>0)?d.indexOf(' '+I)+1:s;c=t.substring(0,s);t=t.substring(s);f+=e(c);c=t.substring(0,a);t=t.substring(a);f+='<span class="sapMInputHighlight">'+e(c)+'</span>';n=t.indexOf(" ");n=n===-1?t.length:n;c=t.substring(0,n);t=t.substring(n);f+=e(c);if(!W){break;}}if(t){f+=e(t);}return f;};var h=function(I,s,W,l){var i,a;l=l||200;if(!s||(!I&&!I.length)||I.length>l){return;}a=[];for(i=0;i<I.length;i++){a.push(_(I[i],s,W));}for(i=0;i<I.length;i++){I[i].innerHTML=a[i];}};return h;});
sap.ui.predefine('sap/m/inputUtils/inputsDefaultFilter',["sap/m/inputUtils/wordStartsWithValue"],function(w){"use strict";var d=function(v,i,f){if(!i){return false;}if(i.isA("sap.ui.core.ListItem")&&f&&w(i.getAdditionalText(),v)){return true;}return w(i.getText(),v);};return d;});
sap.ui.predefine('sap/m/inputUtils/itemsVisibilityHandler',["sap/m/inputUtils/ListHelpers"],function(L){"use strict";return function(i,f){var F,g,l;if(!Array.isArray(i)||!i.length){return;}f=f||{};F=f.items||[];g=f.groups||[];i.forEach(function(I){l=L.getListItem(I);if(!I.isA("sap.ui.core.SeparatorItem")&&l){l.setVisible(F.indexOf(I)!==-1);}});g.forEach(function(G){l=L.getListItem(G.header);l&&l.setVisible(G.visible);});};});
sap.ui.predefine('sap/m/inputUtils/scrollToItem',[],function(){"use strict";var s=function(i,p){var I=i&&i.getDomRef&&i.getDomRef(),P=p&&p.getDomRef&&p.getDomRef('cont');if(!P||!I){return;}var a=P.scrollTop,b=I.offsetTop,c=P.clientHeight,d=I.offsetHeight;if(a>b){P.scrollTop=b;}else if((b+d)>(a+c)){P.scrollTop=Math.ceil(b+d-c);}};return s;});
sap.ui.predefine('sap/m/inputUtils/selectionRange',['sap/ui/Device'],function(D){"use strict";var s=function(f,S){if(!f){return null;}var i=f.selectionStart,a=f.selectionEnd,r={start:i,end:a};return r;};return s;});
sap.ui.predefine('sap/m/inputUtils/typeAhead',["sap/ui/Device"],function(D){"use strict";var a="getText";
function h(v,i,I,t){var s,g=D.system.desktop,S=b(v,I,t);if(!Array.isArray(S)||!S.length){return[];}S=c(v,S,t);s=f(d(S[0],t),v);if(!i.isComposingCharacter()&&s){i.updateDomValue(s);}if(g){_(i,v.length,i.getValue().length);}else{setTimeout(_.bind(null,i,v.length,i.getValue().length),0);}return S||[];}
function _(i,s,E){if(document.activeElement===i.getFocusDomRef()){i.selectText(s,E);}}
function b(t,i,T){t=t&&t.toLowerCase();if(!Array.isArray(i)){return[];}return i.map(function(I){return[I,d(I,T)];}).filter(function(I){var o=I[0],g=I[1];if(!o||o.isA("sap.ui.core.SeparatorItem")||o.isA("sap.m.GroupHeaderListItem")||(o.isA("sap.m.ColumnListItem")&&!o.getVisible())){return false;}return g.some(function(s){return e(s,t);});}).map(function(I){return I[0];});}
function c(t,I,T){return I.map(function(i){return[i,d(i,T)];}).sort(function(l,r){var L,R,g=l[1],j=r[1];for(var i=0;i<g.length;i++){L=e(g[i],t);R=e(j[i],t);if(L&&R){return 0;}else if(e(g[i],t)){return-1;}else if(e(j[i],t)){return 1;}}return 0;}).map(function(i){return i[0];});}
function d(i,t){var T,g;switch(typeof t){case"function":T=t(i);break;case"string":case"undefined":g=i[t||a];T=typeof g==="function"?g.call(i):"";break;default:T="";break;}return Array.isArray(T)?T:[T];}
function e(t,s){if(!t||!s){return false;}return t.toLowerCase().indexOf(s.toLowerCase())===0;}
function f(t,s){if(!Array.isArray(t)){return"";}return t.filter(function(T){return e(T,s);})[0]||"";}
return h;});
sap.ui.predefine('sap/m/inputUtils/wordStartsWithValue',[],function(){"use strict";var w=function(t,v){var i;if(typeof t!=="string"||typeof v!=="string"){return false;}if(v===""){return true;}while(t){if(t.toLowerCase().indexOf(v.toLowerCase())===0){return true;}i=t.indexOf(' ');if(i===-1){break;}t=t.substring(i+1);}return false;};return w;});
sap.ui.predefine('sap/m/library',["sap/ui/Device","sap/ui/base/DataType","sap/ui/base/EventProvider","sap/ui/core/Control","sap/base/util/ObjectPath","sap/ui/util/openWindow","sap/ui/core/library","sap/base/strings/capitalize","sap/ui/thirdparty/jquery","sap/base/assert","sap/base/Log","sap/base/util/defineLazyProperty","sap/base/security/encodeCSS","./AvatarShape","./AvatarSize","./AvatarType","./AvatarColor","./AvatarImageFitType","./IllustratedMessageSize","./IllustratedMessageType","./upload/UploaderHttpRequestMethod","sap/ui/core/theming/Parameters","sap/ui/core/LocaleData","./Support"],function(D,a,E,C,O,o,b,d,q,e,L,f,g,A,h,n,p,r,I,s,U,P,t){"use strict";sap.ui.getCore().initLibrary({name:"sap.m",version:"1.98.0",dependencies:["sap.ui.core"],designtime:"sap/m/designtime/library.designtime",types:["sap.m.AvatarImageFitType","sap.m.AvatarShape","sap.m.AvatarSize","sap.m.AvatarType","sap.m.AvatarColor","sap.m.BackgroundDesign","sap.m.BadgeState","sap.m.BadgeAnimationType","sap.m.BarDesign","sap.m.BreadcrumbsSeparatorStyle","sap.m.ButtonType","sap.m.CarouselArrowsPlacement","sap.m.DateTimeInputType","sap.m.DeviationIndicator","sap.m.DialogRoleType","sap.m.DialogType","sap.m.DraftIndicatorState","sap.m.FacetFilterListDataType","sap.m.FacetFilterType","sap.m.FlexAlignContent","sap.m.FlexAlignItems","sap.m.FlexAlignSelf","sap.m.FlexDirection","sap.m.FlexJustifyContent","sap.m.FlexRendertype","sap.m.FlexWrap","sap.m.FrameType","sap.m.GenericTagDesign","sap.m.GenericTagValueState","sap.m.GenericTileMode","sap.m.GenericTileScope","sap.m.HeaderLevel","sap.m.IBarHTMLTag","sap.m.IconTabDensityMode","sap.m.IconTabFilterDesign","sap.m.IconTabHeaderMode","sap.m.IllustratedMessageSize","sap.m.IllustratedMessageType","sap.m.ImageMode","sap.m.InputTextFormatMode","sap.m.InputType","sap.m.LabelDesign","sap.m.LightBoxLoadingStates","sap.m.LinkConversion","sap.m.ListGrowingDirection","sap.m.ListHeaderDesign","sap.m.ListKeyboardMode","sap.m.ListMode","sap.m.ListSeparators","sap.m.ListType","sap.m.LoadState","sap.m.MenuButtonMode","sap.m.MultiSelectMode","sap.m.ObjectHeaderPictureShape","sap.m.ObjectMarkerType","sap.m.ObjectMarkerVisibility","sap.m.OverflowToolbarPriority","sap.m.P13nPanelType","sap.m.P13nConditionOperation","sap.m.PageBackgroundDesign","sap.m.PanelAccessibleRole","sap.m.PDFViewerDisplayType","sap.m.PlacementType","sap.m.PlanningCalendarBuiltInView","sap.m.PlanningCalendarStickyMode","sap.m.PopinDisplay","sap.m.PopinLayout","sap.m.QuickViewGroupElementType","sap.m.RatingIndicatorVisualMode","sap.m.ScreenSize","sap.m.SelectColumnRatio","sap.m.SelectionDetailsActionLevel","sap.m.SelectListKeyboardNavigationMode","sap.m.SelectType","sap.m.Size","sap.m.SplitAppMode","sap.m.StandardDynamicDateRangeKeys","sap.m.StandardTileType","sap.m.StepInputStepModeType","sap.m.StepInputValidationMode","sap.m.Sticky","sap.m.StringFilterOperator","sap.m.SwipeDirection","sap.m.SwitchType","sap.m.TabsOverflowMode","sap.m.TileSizeBehavior","sap.m.TimePickerMaskMode","sap.m.TitleAlignment","sap.m.TokenizerRenderMode","sap.m.ToolbarDesign","sap.m.ToolbarStyle","sap.m.UploadState","sap.m.ValueColor","sap.m.ValueCSSColor","sap.m.VerticalPlacementType","sap.m.WrappingType","sap.m.WizardRenderMode","sap.m.semantic.SemanticRuleSetType","sap.m.upload.UploaderHttpRequestMethod"],interfaces:["sap.m.IBar","sap.m.IBadge","sap.m.IBreadcrumbs","sap.m.p13n.IContent","sap.m.IconTab","sap.m.IScale","sap.m.semantic.IGroup","sap.m.semantic.IFilter","sap.m.semantic.ISort","sap.m.ObjectHeaderContainer","sap.m.IOverflowToolbarContent","sap.m.IOverflowToolbarFlexibleContent","sap.m.IHyphenation"],controls:["sap.m.ActionListItem","sap.m.ActionSelect","sap.m.ActionSheet","sap.m.App","sap.m.Avatar","sap.m.Bar","sap.m.BusyDialog","sap.m.BusyIndicator","sap.m.Button","sap.m.Breadcrumbs","sap.m.Carousel","sap.m.CheckBox","sap.m.ColumnHeaderPopover","sap.m.ColumnListItem","sap.m.ColorPalette","sap.m.ColorPalettePopover","sap.m.ComboBox","sap.m.ComboBoxTextField","sap.m.ComboBoxBase","sap.m.CustomListItem","sap.m.CustomTile","sap.m.CustomTreeItem","sap.m.DatePicker","sap.m.DateRangeSelection","sap.m.DateTimeField","sap.m.DateTimeInput","sap.m.DateTimePicker","sap.m.Dialog","sap.m.DisplayListItem","sap.m.DraftIndicator","sap.m.DynamicDateRange","sap.m.ExpandableText","sap.m.FacetFilter","sap.m.FacetFilterItem","sap.m.FacetFilterList","sap.m.FeedContent","sap.m.FeedInput","sap.m.FeedListItem","sap.m.FlexBox","sap.m.FormattedText","sap.m.GenericTag","sap.m.GenericTile","sap.m.GroupHeaderListItem","sap.m.GrowingList","sap.m.HBox","sap.m.HeaderContainer","sap.m.IconTabBar","sap.m.IconTabBarSelectList","sap.m.IconTabFilterExpandButtonBadge","sap.m.IconTabHeader","sap.m.IllustratedMessage","sap.m.Image","sap.m.ImageContent","sap.m.Input","sap.m.InputBase","sap.m.InputListItem","sap.m.Label","sap.m.LightBox","sap.m.Link","sap.m.List","sap.m.ListBase","sap.m.ListItemBase","sap.m.MaskInput","sap.m.Menu","sap.m.MenuButton","sap.m.MessagePage","sap.m.MessagePopover","sap.m.MessageView","sap.m.MessageStrip","sap.m.MultiComboBox","sap.m.MultiEditField","sap.m.MultiInput","sap.m.NavContainer","sap.m.NewsContent","sap.m.NumericContent","sap.m.NotificationList","sap.m.NotificationListBase","sap.m.NotificationListItem","sap.m.NotificationListGroup","sap.m.PagingButton","sap.m.PlanningCalendarLegend","sap.m.ObjectAttribute","sap.m.ObjectHeader","sap.m.ObjectIdentifier","sap.m.ObjectListItem","sap.m.ObjectMarker","sap.m.ObjectNumber","sap.m.ObjectStatus","sap.m.OverflowToolbar","sap.m.OverflowToolbarButton","sap.m.OverflowToolbarToggleButton","sap.m.P13nColumnsPanel","sap.m.P13nGroupPanel","sap.m.P13nSelectionPanel","sap.m.P13nDimMeasurePanel","sap.m.P13nConditionPanel","sap.m.P13nDialog","sap.m.P13nFilterPanel","sap.m.P13nPanel","sap.m.P13nSortPanel","sap.m.Page","sap.m.Panel","sap.m.PDFViewer","sap.m.PlanningCalendar","sap.m.PlanningCalendarHeader","sap.m.Popover","sap.m.ProgressIndicator","sap.m.PullToRefresh","sap.m.QuickView","sap.m.QuickViewBase","sap.m.QuickViewCard","sap.m.QuickViewPage","sap.m.RadioButton","sap.m.RadioButtonGroup","sap.m.RangeSlider","sap.m.RatingIndicator","sap.m.ResponsivePopover","sap.m.ScrollContainer","sap.m.SearchField","sap.m.SegmentedButton","sap.m.Select","sap.m.SelectDialog","sap.m.SelectDialogBase","sap.m.SelectList","sap.m.SelectionDetails","sap.m.Shell","sap.m.SimpleFixFlex","sap.m.SinglePlanningCalendar","sap.m.SinglePlanningCalendarGrid","sap.m.SinglePlanningCalendarMonthGrid","sap.m.Slider","sap.m.SliderTooltip","sap.m.SliderTooltipBase","sap.m.SliderTooltipContainer","sap.m.SlideTile","sap.m.StepInput","sap.m.SplitApp","sap.m.SplitContainer","sap.m.StandardListItem","sap.m.StandardTreeItem","sap.m.StandardTile","sap.m.Switch","sap.m.Table","sap.m.TableSelectDialog","sap.m.TabContainer","sap.m.TabStrip","sap.m.Text","sap.m.TextArea","sap.m.Tile","sap.m.TileContainer","sap.m.TileContent","sap.m.TimePicker","sap.m.TimePickerInputs","sap.m.TimePickerClock","sap.m.TimePickerClocks","sap.m.TimePickerSliders","sap.m.Title","sap.m.ToggleButton","sap.m.Token","sap.m.Tokenizer","sap.m.Toolbar","sap.m.ToolbarSpacer","sap.m.ToolbarSeparator","sap.m.Tree","sap.m.TreeItemBase","sap.m.UploadCollection","sap.m.UploadCollectionToolbarPlaceholder","sap.m.upload.UploadSet","sap.m.VBox","sap.m.ViewSettingsDialog","sap.m.WheelSlider","sap.m.WheelSliderContainer","sap.m.Wizard","sap.m.WizardStep","sap.m.semantic.DetailPage","sap.m.semantic.SemanticPage","sap.m.semantic.ShareMenuPage","sap.m.semantic.FullscreenPage","sap.m.semantic.MasterPage","sap.m.p13n.AbstractContainer","sap.m.p13n.BasePanel","sap.m.p13n.Container","sap.m.p13n.GroupPanel","sap.m.p13n.QueryPanel","sap.m.p13n.SelectionPanel","sap.m.p13n.SortPanel","sap.m.p13n.Popup","sap.m.table.ColumnMenu"],elements:["sap.m.BadgeCustomData","sap.m.Column","sap.m.ColumnPopoverActionItem","sap.m.ColumnPopoverCustomItem","sap.m.ColumnPopoverItem","sap.m.ColumnPopoverSortItem","sap.m.CustomDynamicDateOption","sap.m.DynamicDateOption","sap.m.DynamicDateValueHelpUIType","sap.m.FlexItemData","sap.m.FeedListItemAction","sap.m.IconTabFilter","sap.m.IconTabSeparator","sap.m.LightBoxItem","sap.m.OverflowToolbarLayoutData","sap.m.MaskInputRule","sap.m.MenuItem","sap.m.MessageItem","sap.m.MessagePopoverItem","sap.m.PageAccessibleLandmarkInfo","sap.m.P13nFilterItem","sap.m.P13nItem","sap.m.PlanningCalendarRow","sap.m.PlanningCalendarView","sap.m.P13nColumnsItem","sap.m.P13nDimMeasureItem","sap.m.P13nGroupItem","sap.m.P13nSortItem","sap.m.QuickViewGroup","sap.m.QuickViewGroupElement","sap.m.ResponsiveScale","sap.m.SegmentedButtonItem","sap.m.SelectionDetailsItem","sap.m.SelectionDetailsItemLine","sap.m.SinglePlanningCalendarDayView","sap.m.SinglePlanningCalendarMonthView","sap.m.SinglePlanningCalendarWeekView","sap.m.SinglePlanningCalendarWorkWeekView","sap.m.SinglePlanningCalendarView","sap.m.StandardDynamicDateOption","sap.m.SuggestionItem","sap.m.TabContainerItem","sap.m.TabStripItem","sap.m.ToolbarLayoutData","sap.m.UploadCollectionItem","sap.m.UploadCollectionParameter","sap.m.upload.Uploader","sap.m.upload.UploadSetItem","sap.m.ViewSettingsCustomItem","sap.m.ViewSettingsCustomTab","sap.m.ViewSettingsFilterItem","sap.m.ViewSettingsItem","sap.m.plugins.ColumnResizer","sap.m.plugins.DataStateIndicator","sap.m.plugins.PasteProvider","sap.m.plugins.PluginBase","sap.m.p13n.AbstractContainerItem","sap.m.semantic.AddAction","sap.m.semantic.CancelAction","sap.m.semantic.DeleteAction","sap.m.semantic.DiscussInJamAction","sap.m.semantic.EditAction","sap.m.semantic.FavoriteAction","sap.m.semantic.FilterAction","sap.m.semantic.FilterSelect","sap.m.semantic.FlagAction","sap.m.semantic.ForwardAction","sap.m.semantic.GroupAction","sap.m.semantic.GroupSelect","sap.m.semantic.MainAction","sap.m.semantic.MessagesIndicator","sap.m.semantic.MultiSelectAction","sap.m.semantic.NegativeAction","sap.m.semantic.OpenInAction","sap.m.semantic.PositiveAction","sap.m.semantic.PrintAction","sap.m.semantic.SaveAction","sap.m.semantic.SemanticButton","sap.m.semantic.SemanticControl","sap.m.semantic.SemanticSelect","sap.m.semantic.SemanticToggleButton","sap.m.semantic.SendEmailAction","sap.m.semantic.SendMessageAction","sap.m.semantic.ShareInJamAction","sap.m.semantic.SortAction","sap.m.semantic.SortSelect","sap.m.table.ColumnMenuEntry","sap.m.table.Item","sap.m.table.ItemBase","sap.m.table.QuickAction","sap.m.table.QuickActionBase"],extensions:{flChangeHandlers:{"sap.m.ActionSheet":{"moveControls":"default"},"sap.m.Avatar":"sap/m/flexibility/Avatar","sap.m.Bar":"sap/m/flexibility/Bar","sap.m.Button":"sap/m/flexibility/Button","sap.m.CheckBox":"sap/m/flexibility/CheckBox","sap.m.ColumnListItem":{"hideControl":"default","unhideControl":"default"},"sap.m.CustomListItem":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.DatePicker":{"hideControl":"default","unhideControl":"default"},"sap.m.Dialog":"sap/m/flexibility/Dialog","sap.m.ExpandableText":"sap/m/flexibility/ExpandableText","sap.m.FlexBox":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.HBox":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.IconTabBar":"sap/m/flexibility/IconTabBar","sap.m.IconTabFilter":"sap/m/flexibility/IconTabFilter","sap.m.Image":{"hideControl":"default","unhideControl":"default"},"sap.m.Input":{"hideControl":"default","unhideControl":"default"},"sap.m.InputBase":{"hideControl":"default","unhideControl":"default"},"sap.m.InputListItem":"sap/m/flexibility/InputListItem","sap.m.Label":"sap/m/flexibility/Label","sap.m.MultiInput":{"hideControl":"default","unhideControl":"default"},"sap.m.ListItemBase":{"hideControl":"default","unhideControl":"default"},"sap.m.Link":"sap/m/flexibility/Link","sap.m.List":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.ListBase":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.MaskInput":{"hideControl":"default","unhideControl":"default"},"sap.m.MenuButton":"sap/m/flexibility/MenuButton","sap.m.OverflowToolbar":"sap/m/flexibility/OverflowToolbar","sap.m.OverflowToolbarButton":"sap/m/flexibility/OverflowToolbarButton","sap.m.Page":"sap/m/flexibility/Page","sap.m.Panel":"sap/m/flexibility/Panel","sap.m.Popover":"sap/m/flexibility/Popover","sap.m.RadioButton":"sap/m/flexibility/RadioButton","sap.m.RatingIndicator":{"hideControl":"default","unhideControl":"default"},"sap.m.RangeSlider":{"hideControl":"default","unhideControl":"default"},"sap.m.ScrollContainer":{"hideControl":"default","moveControls":"default","unhideControl":"default"},"sap.m.Slider":{"hideControl":"default","unhideControl":"default"},"sap.m.StandardListItem":"sap/m/flexibility/StandardListItem","sap.m.Table":"sap/m/flexibility/Table","sap.m.Column":{"hideControl":"default","unhideControl":"default"},"sap.m.Text":"sap/m/flexibility/Text","sap.m.Title":"sap/m/flexibility/Title","sap.m.Toolbar":"sap/m/flexibility/Toolbar","sap.m.VBox":{"hideControl":"default","unhideControl":"default","moveControls":"default"}},"sap.ui.support":{publicRules:true,internalRules:true}}});var u=sap.m;u.upload.UploaderHttpRequestMethod=U;u.BackgroundDesign={Solid:"Solid",Transparent:"Transparent",Translucent:"Translucent"};u.BadgeState={Updated:"Updated",Appear:"Appear",Disappear:"Disappear"};u.BadgeAnimationType={Full:"Full",Update:"Update",None:"None"};u.EmptyIndicatorMode={On:"On",Off:"Off",Auto:"Auto"};u.BadgeStyle={Default:"Default",Attention:"Attention"};u.BarDesign={Auto:"Auto",Header:"Header",SubHeader:"SubHeader",Footer:"Footer"};u.BreadcrumbsSeparatorStyle={Slash:"Slash",BackSlash:"BackSlash",DoubleSlash:"DoubleSlash",DoubleBackSlash:"DoubleBackSlash",GreaterThan:"GreaterThan",DoubleGreaterThan:"DoubleGreaterThan"};u.ButtonType={Default:"Default",Back:"Back",Accept:"Accept",Reject:"Reject",Transparent:"Transparent",Ghost:"Ghost",Up:"Up",Unstyled:"Unstyled",Emphasized:"Emphasized",Critical:"Critical",Negative:"Negative",Success:"Success",Neutral:"Neutral",Attention:"Attention"};u.ButtonAccessibilityType={Default:"Default",Labelled:"Labelled",Described:"Described",Combined:"Combined"};u.CarouselArrowsPlacement={Content:"Content",PageIndicator:"PageIndicator"};u.PlanningCalendarBuiltInView={Hour:"Hour",Day:"Day",Month:"Month",Week:"Week",OneMonth:"One Month"};u.DateTimeInputType={Date:"Date",DateTime:"DateTime",Time:"Time"};u.DialogType={Standard:"Standard",Message:"Message"};u.DialogRoleType={Dialog:"dialog",AlertDialog:"alertdialog"};u.DeviationIndicator={Up:"Up",Down:"Down",None:"None"};u.DraftIndicatorState={Clear:"Clear",Saving:"Saving",Saved:"Saved"};u.FacetFilterListDataType={Date:"Date",DateTime:"DateTime",Time:"Time",Integer:"Integer",Float:"Float",String:"String",Boolean:"Boolean"};u.FacetFilterType={Simple:"Simple",Light:"Light"};u.FlexAlignItems={Start:"Start",End:"End",Center:"Center",Baseline:"Baseline",Stretch:"Stretch",Inherit:"Inherit"};u.FlexAlignSelf={Auto:"Auto",Start:"Start",End:"End",Center:"Center",Baseline:"Baseline",Stretch:"Stretch",Inherit:"Inherit"};u.FlexDirection={Row:"Row",Column:"Column",RowReverse:"RowReverse",ColumnReverse:"ColumnReverse",Inherit:"Inherit"};u.FlexJustifyContent={Start:"Start",End:"End",Center:"Center",SpaceBetween:"SpaceBetween",SpaceAround:"SpaceAround",Inherit:"Inherit"};u.FlexWrap={NoWrap:"NoWrap",Wrap:"Wrap",WrapReverse:"WrapReverse"};u.FlexAlignContent={Start:"Start",End:"End",Center:"Center",SpaceBetween:"SpaceBetween",SpaceAround:"SpaceAround",Stretch:"Stretch",Inherit:"Inherit"};u.FlexRendertype={Div:"Div",List:"List",Bare:"Bare"};u.FrameType={OneByOne:"OneByOne",TwoByOne:"TwoByOne",TwoThirds:"TwoThirds",Auto:"Auto",TwoByHalf:"TwoByHalf",OneByHalf:"OneByHalf",Stretch:"Stretch"};u.LinkConversion={None:"None",ProtocolOnly:"ProtocolOnly",All:"All"};u.InputTextFormatMode={Value:"Value",Key:"Key",ValueKey:"ValueKey",KeyValue:"KeyValue"};u.GenericTagDesign={Full:"Full",StatusIconHidden:"StatusIconHidden"};u.GenericTagValueState={None:"None",Error:"Error"};u.GenericTileMode={ContentMode:"ContentMode",HeaderMode:"HeaderMode",ActionMode:"ActionMode",ArticleMode:"ArticleMode",LineMode:"LineMode",IconMode:"IconMode"};u.GenericTileScope={Display:"Display",Actions:"Actions",ActionMore:"ActionMore",ActionRemove:"ActionRemove"};u.TabsOverflowMode={End:"End",StartAndEnd:"StartAndEnd"};u.TileSizeBehavior={Responsive:"Responsive",Small:"Small"};u.HeaderLevel={H1:"H1",H2:"H2",H3:"H3",H4:"H4",H5:"H5",H6:"H6"};u.IBarHTMLTag={Div:"Div",Header:"Header",Footer:"Footer"};u.IconTabHeaderMode={Standard:"Standard",Inline:"Inline"};u.IconTabDensityMode={Inherit:"Inherit",Compact:"Compact",Cozy:"Cozy"};u.IconTabFilterDesign={Horizontal:"Horizontal",Vertical:"Vertical"};u.ImageMode={Image:"Image",Background:"Background"};u.Size={XS:"XS",S:"S",M:"M",L:"L",Auto:"Auto",Responsive:"Responsive"};u.ValueColor={Neutral:"Neutral",Good:"Good",Critical:"Critical",Error:"Error",None:"None"};u.ValueCSSColor=a.createType("sap.m.ValueCSSColor",{isValid:function(v){var R=u.ValueColor.hasOwnProperty(v);if(R){return R;}else{R=b.CSSColor.isValid(v);if(R){return R;}else{return b.CSSColor.isValid(P.get(v));}}}},a.getType("string"));u.SelectColumnRatio=a.createType("sap.m.SelectColumnRatio",{isValid:function(v){return/^([0-9]+:[0-9]+)$/.test(v);}},a.getType("string"));u.InputType={Text:"Text",Date:"Date",Datetime:"Datetime",DatetimeLocale:"DatetimeLocale",Email:"Email",Month:"Month",Number:"Number",Tel:"Tel",Time:"Time",Url:"Url",Week:"Week",Password:"Password"};u.LabelDesign={Bold:"Bold",Standard:"Standard"};u.ListHeaderDesign={Standard:"Standard",Plain:"Plain"};u.ListMode={None:"None",SingleSelect:"SingleSelect",SingleSelectLeft:"SingleSelectLeft",SingleSelectMaster:"SingleSelectMaster",MultiSelect:"MultiSelect",Delete:"Delete"};u.ListKeyboardMode={Navigation:"Navigation",Edit:"Edit"};u.ListGrowingDirection={Downwards:"Downwards",Upwards:"Upwards"};u.ListSeparators={All:"All",Inner:"Inner",None:"None"};u.ListType={Inactive:"Inactive",Detail:"Detail",Navigation:"Navigation",Active:"Active",DetailAndActive:"DetailAndActive"};u.SelectListKeyboardNavigationMode={None:"None",Delimited:"Delimited"};u.LoadState={Loading:"Loading",Loaded:"Loaded",Failed:"Failed",Disabled:"Disabled"};u.MenuButtonMode={Regular:"Regular",Split:"Split"};u.OverflowToolbarPriority={NeverOverflow:"NeverOverflow",Never:"Never",High:"High",Low:"Low",Disappear:"Disappear",AlwaysOverflow:"AlwaysOverflow",Always:"Always"};u.ObjectHeaderPictureShape={Circle:"Circle",Square:"Square"};u.P13nPanelType={sort:"sort",filter:"filter",group:"group",columns:"columns",dimeasure:"dimeasure",selection:"selection"};u.P13nPopupMode={Dialog:"Dialog",ResponsivePopover:"ResponsivePopover"};u.P13nConditionOperation={BT:"BT",EQ:"EQ",Contains:"Contains",StartsWith:"StartsWith",EndsWith:"EndsWith",LT:"LT",LE:"LE",GT:"GT",GE:"GE",Initial:"Initial",Empty:"Empty",NotBT:"NotBT",NotEQ:"NotEQ",NotContains:"NotContains",NotStartsWith:"NotStartsWith",NotEndsWith:"NotEndsWith",NotLT:"NotLT",NotLE:"NotLE",NotGT:"NotGT",NotGE:"NotGE",NotInitial:"NotInitial",NotEmpty:"NotEmpty",Ascending:"Ascending",Descending:"Descending",GroupAscending:"GroupAscending",GroupDescending:"GroupDescending",Total:"Total",Average:"Average",Minimum:"Minimum",Maximum:"Maximum"};u.P13nConditionOperationType={Include:"Include",Exclude:"Exclude"};u.PageBackgroundDesign={Standard:"Standard",List:"List",Solid:"Solid",Transparent:"Transparent"};u.PanelAccessibleRole={Complementary:"Complementary",Form:"Form",Region:"Region"};u.PDFViewerDisplayType={Auto:"Auto",Embedded:"Embedded",Link:"Link"};u.PlacementType={Left:"Left",Right:"Right",Top:"Top",Bottom:"Bottom",Vertical:"Vertical",VerticalPreferedTop:"VerticalPreferedTop",VerticalPreferredTop:"VerticalPreferredTop",VerticalPreferedBottom:"VerticalPreferedBottom",VerticalPreferredBottom:"VerticalPreferredBottom",Horizontal:"Horizontal",HorizontalPreferedRight:"HorizontalPreferedRight",HorizontalPreferredRight:"HorizontalPreferredRight",HorizontalPreferedLeft:"HorizontalPreferedLeft",HorizontalPreferredLeft:"HorizontalPreferredLeft",PreferredLeftOrFlip:"PreferredLeftOrFlip",PreferredRightOrFlip:"PreferredRightOrFlip",PreferredTopOrFlip:"PreferredTopOrFlip",PreferredBottomOrFlip:"PreferredBottomOrFlip",Auto:"Auto"};u.StandardDynamicDateRangeKeys={DATE:"DATE",TODAY:"TODAY",YESTERDAY:"YESTERDAY",TOMORROW:"TOMORROW",FIRSTDAYWEEK:"FIRSTDAYWEEK",LASTDAYWEEK:"LASTDAYWEEK",FIRSTDAYMONTH:"FIRSTDAYMONTH",LASTDAYMONTH:"LASTDAYMONTH",FIRSTDAYQUARTER:"FIRSTDAYQUARTER",LASTDAYQUARTER:"LASTDAYQUARTER",FIRSTDAYYEAR:"FIRSTDAYYEAR",LASTDAYYEAR:"LASTDAYYEAR",DATERANGE:"DATERANGE",FROM:"FROM",TO:"TO",YEARTODATE:"YEARTODATE",DATETOYEAR:"DATETOYEAR",LASTDAYS:"LASTDAYS",LASTWEEKS:"LASTWEEKS",LASTMONTHS:"LASTMONTHS",LASTQUARTERS:"LASTQUARTERS",LASTYEARS:"LASTYEARS",NEXTDAYS:"NEXTDAYS",NEXTWEEKS:"NEXTWEEKS",NEXTMONTHS:"NEXTMONTHS",NEXTQUARTERS:"NEXTQUARTERS",NEXTYEARS:"NEXTYEARS",TODAYFROMTO:"TODAYFROMTO",THISWEEK:"THISWEEK",LASTWEEK:"LASTWEEK",NEXTWEEK:"NEXTWEEK",SPECIFICMONTH:"SPECIFICMONTH",THISMONTH:"THISMONTH",LASTMONTH:"LASTMONTH",NEXTMONTH:"NEXTMONTH",THISQUARTER:"THISQUARTER",LASTQUARTER:"LASTQUARTER",NEXTQUARTER:"NEXTQUARTER",QUARTER1:"QUARTER1",QUARTER2:"QUARTER2",QUARTER3:"QUARTER3",QUARTER4:"QUARTER4",THISYEAR:"THISYEAR",LASTYEAR:"LASTYEAR",NEXTYEAR:"NEXTYEAR"};u.QuickViewGroupElementType={phone:"phone",mobile:"mobile",email:"email",link:"link",text:"text",pageLink:"pageLink"};u.VerticalPlacementType={Top:"Top",Bottom:"Bottom",Vertical:"Vertical"};u.PopinDisplay={Block:"Block",Inline:"Inline",WithoutHeader:"WithoutHeader"};u.PopinLayout={Block:"Block",GridSmall:"GridSmall",GridLarge:"GridLarge"};u.Sticky={ColumnHeaders:"ColumnHeaders",HeaderToolbar:"HeaderToolbar",InfoToolbar:"InfoToolbar"};u.RatingIndicatorVisualMode={Full:"Full",Half:"Half"};u.ScreenSize={Phone:"Phone",Tablet:"Tablet",Desktop:"Desktop",XXSmall:"XXSmall",XSmall:"XSmall",Small:"Small",Medium:"Medium",Large:"Large",XLarge:"XLarge",XXLarge:"XXLarge"};u.SelectionDetailsActionLevel={Item:"Item",List:"List",Group:"Group"};u.SelectType={Default:"Default",IconOnly:"IconOnly"};u.SplitAppMode={ShowHideMode:"ShowHideMode",StretchCompressMode:"StretchCompressMode",PopoverMode:"PopoverMode",HideMode:"HideMode"};u.StandardTileType={Create:"Create",Monitor:"Monitor",None:"None"};u.semantic=u.semantic||{};u.semantic.SemanticRuleSetType={Classic:"Classic",Optimized:"Optimized"};u.ObjectMarkerType={Flagged:"Flagged",Favorite:"Favorite",Draft:"Draft",Locked:"Locked",Unsaved:"Unsaved",LockedBy:"LockedBy",UnsavedBy:"UnsavedBy"};u.ObjectMarkerVisibility={IconOnly:"IconOnly",TextOnly:"TextOnly",IconAndText:"IconAndText"};u.SwipeDirection={LeftToRight:"LeftToRight",RightToLeft:"RightToLeft",BeginToEnd:"BeginToEnd",EndToBegin:"EndToBegin",Both:"Both"};u.SwitchType={Default:"Default",AcceptReject:"AcceptReject"};u.TokenizerRenderMode={Loose:"Loose",Narrow:"Narrow"};u.ToolbarDesign={Auto:"Auto",Transparent:"Transparent",Info:"Info",Solid:"Solid"};u.ToolbarStyle={Standard:"Standard",Clear:"Clear"};u.TimePickerMaskMode={On:"On",Off:"Off"};u.StringFilterOperator={Equals:"Equals",Contains:"Contains",StartsWith:"StartsWith",AnyWordStartsWith:"AnyWordStartsWith"};u.LightBoxLoadingStates={Loading:"LOADING",Loaded:"LOADED",TimeOutError:"TIME_OUT_ERROR",Error:"ERROR"};u.StepInputValidationMode={FocusOut:"FocusOut",LiveChange:"LiveChange"};u.StepInputStepModeType={AdditionAndSubtraction:"AdditionAndSubtraction",Multiple:"Multiple"};u.UploadState={Complete:"Complete",Error:"Error",Ready:"Ready",Uploading:"Uploading"};u.WrappingType={Normal:"Normal",Hyphenated:"Hyphenated"};u.PlanningCalendarStickyMode={None:"None",All:"All",NavBarAndColHeaders:"NavBarAndColHeaders"};u.TitleAlignment={None:"None",Auto:"Auto",Start:"Start",Center:"Center"};u.ExpandableTextOverflowMode={InPlace:"InPlace",Popover:"Popover"};u.AvatarShape=A;u.AvatarSize=h;u.AvatarType=n;u.AvatarColor=p;u.AvatarImageFitType=r;u.IllustratedMessageSize=I;u.IllustratedMessageType=s;u.WizardRenderMode={Scroll:"Scroll",Page:"Page"};u.ResetAllMode={Default:"Default",ServiceDefault:"ServiceDefault",ServiceReset:"ServiceReset"};u.MultiSelectMode={Default:"Default",ClearAll:"ClearAll"};sap.ui.lazyRequire("sap.m.DynamicDate");sap.ui.lazyRequire("sap.m.MessageToast","show");sap.ui.lazyRequire("sap.m.routing.RouteMatchedHandler");sap.ui.lazyRequire("sap.m.routing.Router");sap.ui.lazyRequire("sap.m.routing.Target");sap.ui.lazyRequire("sap.m.routing.TargetHandler");sap.ui.lazyRequire("sap.m.routing.Targets");if(/sap-ui-xx-formfactor=compact/.test(location.search)){q("html").addClass("sapUiSizeCompact");u._bSizeCompact=true;}if(/sap-ui-xx-formfactor=condensed/.test(location.search)){q("html").addClass("sapUiSizeCondensed");u._bSizeCondensed=true;}
u.getInvalidDate=function(){return null;};
u.getLocale=function(){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();u.getLocale=function(){return l;};return l;};
u.getLocaleData=function(){var l=t.getInstance(u.getLocale());u.getLocaleData=function(){return l;};return l;};
u.isDate=function(v){return v&&Object.prototype.toString.call(v)=="[object Date]"&&!isNaN(v);};
u.getIScroll=function(c){if(typeof window.iScroll!="function"||!(c instanceof C)){return;}var i,j;for(i=c;i=i.oParent;){j=i.getScrollDelegate?i.getScrollDelegate()._scroller:null;if(j&&j instanceof window.iScroll){return j;}}};
u.getScrollDelegate=function(i,G){if(!(i instanceof C)){return;}var j=sap.ui.require("sap/ui/core/UIComponent");function k(c){if(!c){return;}return G&&j&&(c instanceof j)?c.oContainer:c.oParent;}for(var l=i;l=k(l);){if(l&&typeof l.getScrollDelegate=="function"){return l.getScrollDelegate(i);}}};
u.ScreenSizes={phone:240,tablet:600,desktop:1024,xxsmall:240,xsmall:320,small:480,medium:560,large:768,xlarge:960,xxlarge:1120};f(u,"BaseFontSize",function(){u.BaseFontSize=q(document.documentElement).css("font-size")||"16px";return u.BaseFontSize;});
u.closeKeyboard=function(){var c=document.activeElement;if(!D.system.desktop&&c&&/(INPUT|TEXTAREA)/i.test(c.tagName)){c.blur();}};
u.touch=u.touch||{};
u.touch.find=function(T,c){var i,j;if(!T){return;}if(c&&typeof c.identifier!=="undefined"){c=c.identifier;}else if(typeof c!=="number"){e(false,"sap.m.touch.find(): oTouch must be a touch object or a number");return;}j=T.length;for(i=0;i<j;i++){if(T[i].identifier===c){return T[i];}}};
u.touch.countContained=function(T,v){var i,c=0,j,k,$;if(!T){return 0;}if(v instanceof Element){v=q(v);}else if(typeof v==="string"){v=q(document.getElementById(v));}else if(!(v instanceof q)){e(false,"sap.m.touch.countContained(): vElement must be a jQuery object or Element reference or a string");return 0;}k=v.children().length;j=T.length;for(i=0;i<j;i++){$=q(T[i].target);if((k===0&&$.is(v))||(v[0].contains($[0]))){c++;}}return c;};
u.URLHelper=(function(){function i(v){return v&&Object.prototype.toString.call(v)=="[object String]";}function c(T){if(!i(T)){return"";}return T.replace(/[^0-9\+\*#]/g,"");}function j(T){if(!i(T)){return"";}T=T.split(/\r\n|\r|\n/g).join("\r\n");return encodeURIComponent(T);}return q.extend(new E(),{normalizeTel:function(T){return"tel:"+c(T);},normalizeSms:function(T){return"sms:"+c(T);},normalizeEmail:function(k,S,B,l,m){var v=[],w="mailto:",x=encodeURIComponent;i(k)&&(w+=x(k.trim()));i(S)&&v.push("subject="+x(S));i(B)&&v.push("body="+j(B));i(m)&&v.push("bcc="+x(m.trim()));i(l)&&v.push("cc="+x(l.trim()));if(v.length){w+="?"+v.join("&");}return w;},redirect:function(k,N){e(i(k),this+"#redirect: URL must be a string");this.fireEvent("redirect",k);if(!N){window.location.href=k;}else{o(k,"_blank");}},attachRedirect:function(F,l){return this.attachEvent("redirect",F,l);},detachRedirect:function(F,l){return this.detachEvent("redirect",F,l);},triggerTel:function(T){this.redirect(this.normalizeTel(T));},triggerSms:function(T){this.redirect(this.normalizeSms(T));},triggerEmail:function(k,S,B,l,m,N){var N=N||false;this.redirect(this.normalizeEmail.apply(0,[k,S,B,l,m]),N);},toString:function(){return"sap.m.URLHelper";}});}());u.BackgroundHelper={addBackgroundColorStyles:function(c,B,i,j){c.class(j||"sapUiGlobalBackgroundColor");if(B&&!a.getType("sap.ui.core.CSSColor").isValid(B)){L.warning(B+" is not a valid sap.ui.core.CSSColor type");B="";}if(B||i){c.style("background-image","none");c.style("filter","none");}if(B){c.style("background-color",B);}},renderBackgroundImageTag:function(c,j,v,B,R,k){c.openStart("div",j.getId()+"-BG");if(Array.isArray(v)){for(var i=0;i<v.length;i++){c.class(v[i]);}}else{c.class(v);}c.class("sapUiGlobalBackgroundImage");if(B){c.style("display","block");c.style("background-image","url("+g(B)+")");c.style("background-repeat",R?"repeat":"no-repeat");if(!R){c.style("background-size","cover");c.style("background-position","center");}else{c.style("background-position","left top");}}if(k!==1){if(k>1){k=1;}c.style("opacity",k);}c.openEnd();c.close("div");}};u.ImageHelper=(function(){function c(j,k,v){if(v!==undefined){var S=j["set"+d(k)];if(typeof(S)==="function"){S.call(j,v);return true;}}return false;}var i={getImageControl:function(j,m,v,w,x,y){e(w.src,"sap.m.ImageHelper.getImageControl: mProperties do not contain 'src'");if(m&&(m.getSrc()!=w.src)){m.destroy();m=undefined;}if(m&&(m instanceof sap.m.Image||m instanceof sap.ui.core.Icon)){for(var z in w){c(m,z,w[z]);}}else{var S=Object.assign({},w,{id:j});m=sap.ui.core.IconPool.createControlByURI(S,sap.m.Image);m.setParent(v,null,true);}if(y){for(var l=0,B=y.length;l!==B;l++){m.removeStyleClass(y[l]);}}if(x){for(var k=0,F=x.length;k!==F;k++){m.addStyleClass(x[k]);}}return m;}};return i;}());u.PopupHelper={calcPercentageSize:function(c,B){if(typeof c!=="string"){L.warning("sap.m.PopupHelper: calcPercentageSize, the first parameter"+c+"isn't with type string");return null;}if(c.indexOf("%")<=0){L.warning("sap.m.PopupHelper: calcPercentageSize, the first parameter"+c+"is not a percentage string (for example '25%')");return null;}var i=parseFloat(c)/100,j=parseFloat(B);return Math.floor(i*j)+"px";}};u.InputODataSuggestProvider=(function(){var _=function(i){var j=i.getSource();var v=j.data(j.getId()+"-#valueListAnnotation");var m=j.getModel();var k=j.getBinding("value");var w=m.resolve(k.getPath(),k.getContext());if(!v){return;}var R=i.getParameter("selectedRow");q.each(R.getCells(),function(x,y){var z=y.getBinding("text");q.each(v.outParameters,function(K,B){if(!B.displayOnly&&B.value==z.getPath()){var V=z.getValue();var F=m.resolve(K,k.getContext());if(V&&F!==w){m.setProperty(F,V);}}});});return true;};var c=function(v,R){var M=v.getModel();var w=M.oMetadata;var x=M.resolve(v.getBindingPath("value"),v.getBindingContext());var V={};V.searchSupported=false;V.collectionPath="";V.outParameters={};V.inParameters={};V.selection=[];var y=M.getProperty(x+"/#com.sap.vocabularies.Common.v1.ValueList");if(!y){return false;}var z=x.substr(x.lastIndexOf("/")+1);V.inProperty=z;q.each(y.record,function(i,B){q.each(B,function(j,F){if(F.property==="SearchSupported"&&F.bool){V.searchSupported=true;}if(F.property==="CollectionPath"){V.collectionPath=F.string;}if(F.property==="Parameters"){q.each(F.collection.record,function(k,G){if(G.type==="com.sap.vocabularies.Common.v1.ValueListParameterIn"){var H;q.each(G.propertyValue,function(m,J){if(J.property==="LocalDataProperty"){H=J.propertyPath;}});q.each(G.propertyValue,function(m,J){if(J.property==="ValueListProperty"){V.inParameters[H]={value:J.string};}});}else if(G.type==="com.sap.vocabularies.Common.v1.ValueListParameterInOut"){var H;q.each(G.propertyValue,function(m,J){if(J.property==="LocalDataProperty"){H=J.propertyPath;}});q.each(G.propertyValue,function(m,J){if(J.property==="ValueListProperty"){V.outParameters[H]={value:J.string};V.inParameters[H]={value:J.string};}});}else if(G.type==="com.sap.vocabularies.Common.v1.ValueListParameterOut"){var H;q.each(G.propertyValue,function(m,J){if(J.property==="LocalDataProperty"){H=J.propertyPath;}});q.each(G.propertyValue,function(m,J){if(J.property==="ValueListProperty"){V.outParameters[H]={value:J.string};}});}else if(G.type==="com.sap.vocabularies.Common.v1.ValueListParameterDisplayOnly"){var H;q.each(G.propertyValue,function(m,J){if(J.property==="ValueListProperty"){V.outParameters[J.string]={value:J.string,displayOnly:true};}});}});}});});V.resultEntity=w._getEntityTypeByPath("/"+V.collectionPath);V.listItem=new sap.m.ColumnListItem();q.each(V.outParameters,function(k,i){V.listItem.addCell(new sap.m.Text({text:"{"+i.value+"}",wrapping:false}));v.addSuggestionColumn(new sap.m.Column({header:new sap.m.Text({text:"{/#"+V.resultEntity.name+"/"+i.value+"/@sap:label}",wrapping:false})}));V.selection.push(i.value);});v.data(v.getId()+"-#valueListAnnotation",V);if(R){v.attachSuggestionItemSelected(_);}};var l={suggest:function(i,R,j,k){var v,m=i.getSource();R=R===undefined?true:R;j=j===undefined?true:j;if(!m.data(m.getId()+"-#valueListAnnotation")){c(m,j);}v=m.data(m.getId()+"-#valueListAnnotation");if(!v){return;}var w=function(i){var B=this.getLength();if(B&&B<=k){m.setShowTableSuggestionValueHelp(false);}else{m.setShowTableSuggestionValueHelp(true);}};if(v.searchSupported){var F=[];var S,x={};if(R){q.each(v.inParameters,function(K,y){if(K==v.inProperty){S=y.value;}else if(R){var V=m.getModel().getProperty(K,m.getBinding("value").getContext());if(V){F.push(new sap.ui.model.Filter(y.value,sap.ui.model.FilterOperator.StartsWith,V));}}});}x.search=i.getParameter("suggestValue");if(v.inParameters.length){if(S){x["search-focus"]=S;}else{e(false,"no search-focus defined");}}m.bindAggregation("suggestionRows",{path:"/"+v.collectionPath,length:k,filters:F,parameters:{select:v.selection.join(","),custom:x},events:{dataReceived:w},template:v.listItem});}else{var F=[];q.each(v.inParameters,function(K,y){if(K==v.inProperty){F.push(new sap.ui.model.Filter(y.value,sap.ui.model.FilterOperator.StartsWith,i.getParameter("suggestValue")));}else if(R){var V=m.getModel().getProperty(K,m.getBinding("value").getContext());if(V){F.push(new sap.ui.model.Filter(y.value,sap.ui.model.FilterOperator.StartsWith,V));}}});m.bindAggregation("suggestionRows",{path:"/"+v.collectionPath,filters:F,template:v.listItem,length:k,parameters:{select:v.selection.join(",")},events:{dataReceived:w}});}}};return l;}());O.set("sap.ui.layout.form.FormHelper",{createLabel:function(T,i){return new sap.m.Label(i,{text:T});},createButton:function(i,c,j){var B=new sap.m.Button(i,{type:u.ButtonType.Transparent});B.attachEvent("press",c,this);j.call(this,B);},setButtonContent:function(B,T,c,i,j){B.setText(T);B.setTooltip(c);B.setIcon(i);B.setActiveIcon(j);},addFormClass:function(){return"sapUiFormM";},setToolbar:function(T){var c=this.getToolbar();if(c&&c.setDesign){c.setDesign(c.getDesign(),true);}if(T&&T.setDesign){T.setDesign(sap.m.ToolbarDesign.Transparent,true);}return T;},getToolbarTitle:function(T){if(T){var c=T.getContent();for(var i=0;i<c.length;i++){var j=c[i];if(j.isA("sap.m.Title")){return j.getId();}}return T.getId();}},createDelimiter:function(c,i){return new sap.m.Text(i,{text:c,textAlign:b.TextAlign.Center});},createSemanticDisplayControl:function(T,i){return new sap.m.Text(i,{text:T});},updateDelimiter:function(T,c){T.setText(c);},updateSemanticDisplayControl:function(T,c){T.setText(c);},bArrowKeySupport:false,bFinal:true});O.set("sap.ui.unified.FileUploaderHelper",{createTextField:function(i){var T=new sap.m.Input(i);return T;},setTextFieldContent:function(T,w){T.setWidth(w);},createButton:function(i){var B=new sap.m.Button(i);return B;},addFormClass:function(){return"sapUiFUM";},bFinal:true});O.set("sap.ui.unified.ColorPickerHelper",{isResponsive:function(){return true;},factory:{createLabel:function(c){return new sap.m.Label(c);},createInput:function(i,c){return new sap.m.InputBase(i,c);},createSlider:function(i,c){return new sap.m.Slider(i,c);},createRadioButtonGroup:function(c){return new sap.m.RadioButtonGroup(c);},createRadioButtonItem:function(c){return new sap.m.RadioButton(c);},createButton:function(i,c){return new sap.m.Button(i,c);}},bFinal:true});O.set("sap.ui.table.TableHelper",{createLabel:function(c){return new sap.m.Label(c);},createTextView:function(c){return new sap.m.Label(c);},addTableClass:function(){return"sapUiTableM";},bFinal:true});O.set("sap.ui.layout.GridHelper",{getLibrarySpecificClass:function(){return"";},bFinal:true});if(D.os.android){q(window).on("resize",function(){var c=document.activeElement;var T=c?c.tagName:"";if(T=="INPUT"||T=="TEXTAREA"){setTimeout(function(){c.scrollIntoViewIfNeeded();},0);}});}if(!Number.MAX_SAFE_INTEGER){Number.MAX_SAFE_INTEGER=Math.pow(2,53)-1;}return u;});
sap.ui.predefine('sap/m/p13n/AbstractContainerItem',['sap/ui/core/Element',"sap/ui/core/Control"],function(E,C){"use strict";
var A=E.extend("sap.m.p13n.AbstractContainerItem",{metadata:{library:"sap.m",defaultAggregation:"content",properties:{key:{type:"string",defaultValue:null},text:{type:"string",defaultValue:null},icon:{type:"string",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:false}}}});
A.prototype.exit=function(){E.prototype.exit.apply(this,arguments);if(this._oContent){this._oContent.destroy();this._oContent=null;}};
A.prototype.setContent=function(c){this.setAggregation("content",c);if(c){this._oContent=c;}return this;};
A.prototype.getContent=function(){return this._oContent;};
return A;});
sap.ui.predefine('sap/m/plugins/ColumnResizer',["./PluginBase","sap/ui/core/Core","sap/ui/core/InvisibleText","sap/ui/Device","sap/m/ColumnPopoverActionItem","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Aria"],function(P,C,I,D,a,q){"use strict";
var b=P.extend("sap.m.plugins.ColumnResizer",{metadata:{library:"sap.m",properties:{},events:{columnResize:{allowPreventDefault:true,parameters:{column:{type:"sap.ui.core.Element"},width:{type:"sap.ui.core.CSSSize"}}}}}});
var s={};var r=false;var c="sapMPluginsColumnResizer";var R=C.getConfiguration().getRTL();var B=R?"right":"left";var e=R?"left":"right";var d=R?-1:1;b.getPlugin=P.getPlugin;
b.prototype.init=function(){this._iHoveredColumnIndex=-1;this._aPositions=[];this._oHandle=null;};
b.prototype.onActivate=function(o){o.addEventDelegate(this,this);if(o.isActive()){this.onAfterRendering();}};
b.prototype.onDeactivate=function(o){o.removeEventDelegate(this,this);this.onBeforeRendering();this._oHandle=null;};
b.prototype.onBeforeRendering=function(){if(this._$Container){this._$Container.removeClass(c+"Container").off("."+c);this._$Container.find(this.getConfig("resizable")).removeClass(c+"Resizable");this._updateAriaDescribedBy("remove");}};
b.prototype.onAfterRendering=function(){this._$Container=this.getControl().$(this.getConfig("container"));D.system.desktop&&this._$Container.on("mousemove."+c,this._onmousemove.bind(this));this._$Container.addClass(c+"Container").on("mouseleave."+c,this._onmouseleave.bind(this));this._aResizables=this._$Container.find(this.getConfig("resizable")).addClass(c+"Resizable").get();this._updateAriaDescribedBy("add");this._invalidatePositions();};
b.prototype._updateAriaDescribedBy=function(A){this._aResizables.forEach(function(o){var f=q(o).control(0,true);var F=f&&f.getFocusDomRef();q(F)[A+"AriaDescribedBy"](I.getStaticId("sap.m","COLUMNRESIZER_RESIZABLE"));});};
b.prototype.ontouchstart=function(E){if(this.getConfig("allowTouchResizing")&&q(E.target).closest(this._aResizables)[0]){this._onmousemove(E);}else if(this._iHoveredColumnIndex==-1&&this._oHandle&&this._oHandle.style[B]){this._onmousemove(E);if(this._iHoveredColumnIndex==-1){this._oHandle.style[B]="";this._oAlternateHandle.style[B]="";}}r=(this._iHoveredColumnIndex>-1);if(!r){return;}this._startResizeSession(this._iHoveredColumnIndex);s.iTouchStartX=E.targetTouches[0].clientX;s.fHandleX=parseFloat(this._oHandle.style[B]);this._$Container.addClass(c+"Resizing");q(document).on("touchend."+c+" mouseup."+c,this._ontouchend.bind(this));};
b.prototype.ontouchmove=function(E){if(!r){return;}this._setSessionDistanceX((E.targetTouches[0].clientX-s.iTouchStartX));this._oHandle.style[B]=s.fHandleX+s.iDistanceX+"px";};
b.prototype._onmousemove=function(E){if(r){return;}this._setPositions();var i=E.targetTouches?E.targetTouches[0].clientX:E.clientX;var h=this._getHoveredColumnIndex(i);this._displayHandle(h);};
b.prototype._onmouseleave=function(){this._invalidatePositions();};
b.prototype._ontouchend=function(){this._setColumnWidth();this._cancelResizing(true);};
b.prototype.onsapescape=function(){if(r){this._cancelResizing();}};
b.prototype.onsaprightmodifiers=function(E){this._onLeftRightModifiersKeyDown(E,16);};
b.prototype.onsapleftmodifiers=function(E){this._onLeftRightModifiersKeyDown(E,-16);};
b.prototype.ondblclick=function(E){var i=E.clientX,h=this._getHoveredColumnIndex(i);if(h==-1){return;}this._startResizeSession(h);this._setSessionDistanceX(this._calculateAutoColumnDistanceX());this._setColumnWidth();this._endResizeSession();};
b.prototype._getHoveredColumnIndex=function(i){return this._aPositions.findIndex(function(p){return Math.abs(p-i)<=(this._oAlternateHandle||window.matchMedia("(hover:none)").matches?20:3);},this);};
b.prototype._calculateAutoColumnDistanceX=function(){var $=this.getConfig("columnRelatedCells",this._$Container,s.oCurrentColumn.getId());if(!$||!$.length){return;}var h=q("<div></div>").addClass(c+"SizeDetector").addClass(this.getConfig("cellPaddingStyleClass"));var f=$.children().clone().removeAttr("id");this._$Container.append(h);var w=Math.round(h.append(f)[0].getBoundingClientRect().width);var i=w-s.fCurrentColumnWidth;h.remove();return i;};
b.prototype._invalidatePositions=function(){window.setTimeout(function(){this._bPositionsInvalid=true;}.bind(this));};
b.prototype._displayHandle=function(i,m){if(this._iHoveredColumnIndex==i){return;}if(!this._oHandle){this._oHandle=document.createElement("div");this._oHandle.className=c+"Handle";if(m||window.matchMedia("(hover:none)").matches){var o=document.createElement("div");o.className=c+"HandleCircle";o.style.top=this._aResizables[i].offsetHeight-8+"px";this._oHandle.appendChild(o);this._oAlternateHandle=this._oHandle.cloneNode(true);}}if(this._$Container[0]!==this._oHandle.parentNode){this._$Container.append(this._oHandle);if(m){this._$Container.append(this._oAlternateHandle);}}this._oHandle.style[B]=(i>-1)?(this._aPositions[i]-this._fContainerX)*d+"px":"";if(m){this._oAlternateHandle.style[B]=(--i>-1)?(this._aPositions[i]-this._fContainerX)*d+"px":"";}else{if(this._oAlternateHandle){this._oAlternateHandle.style[B]="";}this._iHoveredColumnIndex=i;}};
b.prototype._cancelResizing=function(f){this._$Container.removeClass(c+"Resizing");if(s.iDistanceX||!f){this._oHandle.style[B]="";}else{setTimeout(function(){this._oHandle.style[B]="";}.bind(this),300);}this._iHoveredColumnIndex=-1;q(document).off("."+c);this._endResizeSession();r=false;};
b.prototype._getColumnMinWidth=function(o){return o?48:0;};
b.prototype._startResizeSession=function(i){s.$CurrentColumn=q(this._aResizables[i]);s.oCurrentColumn=s.$CurrentColumn.control(0,true);s.fCurrentColumnWidth=s.$CurrentColumn.width();s.iMaxDecrease=this._getColumnMinWidth(s.oCurrentColumn)-s.fCurrentColumnWidth;s.iEmptySpace=this.getConfig("emptySpace",this.getControl());if(s.iEmptySpace!=-1){s.$NextColumn=q(this._aResizables[i+1]);s.oNextColumn=s.$NextColumn.control(0,true);s.fNextColumnWidth=s.$NextColumn.width()||0;s.iMaxIncrease=s.iEmptySpace+s.fNextColumnWidth-this._getColumnMinWidth(s.oNextColumn);}else{s.iMaxIncrease=window.innerWidth;}};
b.prototype._setSessionDistanceX=function(i){s.iDistanceX=((i>0)?Math.min(i,s.iMaxIncrease):Math.max(i,s.iMaxDecrease))*d;};
b.prototype._setColumnWidth=function(){if(!s.iDistanceX){return;}var w=s.fCurrentColumnWidth+s.iDistanceX+"px";if(!this._fireColumnResize(s.oCurrentColumn,w)){return;}s.oCurrentColumn.setWidth(w);if(s.oNextColumn&&(s.iEmptySpace<3||s.iDistanceX>s.iEmptySpace)){w=s.fNextColumnWidth-s.iDistanceX+s.iEmptySpace+"px";if(this._fireColumnResize(s.oNextColumn,w)){s.oNextColumn.setWidth(w);}}this.getConfig("fixAutoWidthColumns")&&this._aResizables.forEach(function(o){var $=q(o),f=$.control(0,true),w=f.getWidth();if(w&&w.toLowerCase()!="auto"){return;}w=$.css("width");if(w&&this._fireColumnResize(f,w)){f.setWidth(w);}},this);};
b.prototype._fireColumnResize=function(o,w){return this.fireColumnResize({column:o,width:w});};
b.prototype._onLeftRightModifiersKeyDown=function(E,i){if(!E.shiftKey||E.ctrlKey||E.metaKey||E.altKey||b.detectTextSelection(E.target)){return;}var o=q(E.target).closest(this._aResizables)[0],f=this._aResizables.indexOf(o);if(f===-1){return;}this._startResizeSession(f);this._setSessionDistanceX(i);this._setColumnWidth();this._endResizeSession();};
b.detectTextSelection=function(o){var S=window.getSelection(),t=S.toString().replace("/n","");return t&&q.contains(o,S.focusNode);};
b.prototype._endResizeSession=function(){s={};};
b.prototype._setPositions=function(){if(!this._bPositionsInvalid){return this._aPositions;}this._bPositionsInvalid=false;this._fContainerX=this._$Container[0].getBoundingClientRect()[B];this._aPositions=this._aResizables.map(function(o,i,p){return o.getBoundingClientRect()[e]-(++i==p.length?1.25*d:0);},this);};
b.prototype.startResizing=function(o){var i=this._aResizables.indexOf(o);this._setPositions();this._displayHandle(i,true);};
b.prototype.getColumnResizeButton=function(o){if(!o||!window.matchMedia("(hover:none)").matches){return;}return new a({text:C.getLibraryResourceBundle("sap.m").getText("COLUMNRESIZER_RESIZE_BUTTON"),icon:"sap-icon://resize-horizontal",press:this.startResizing.bind(this,o.getDomRef())});};
P.setConfigs({"sap.m.Table":{container:"listUl",resizable:".sapMListTblHeaderCell:not([aria-hidden=true])",focusable:".sapMColumnHeaderFocusable",cellPaddingStyleClass:"sapMListTblCell",fixAutoWidthColumns:true,onActivate:function(t){this._vOrigFixedLayout=t.getFixedLayout();if(!t.bActiveHeaders){t.bFocusableHeaders=true;this.allowTouchResizing=window.matchMedia("(hover:none)").matches;}t.setFixedLayout("Strict");},onDeactivate:function(t){t.bFocusableHeaders=false;t.setFixedLayout(this._vOrigFixedLayout);if(this._vOrigFixedLayout=="Strict"){t.rerender();}delete this._vOrigFixedLayout;delete this.allowTouchResizing;},emptySpace:function(t){var o=t.getDomRef("tblHeadDummyCell");return o?o.clientWidth:0;},columnRelatedCells:function($,f){return $.find(".sapMListTblCell[data-sap-ui-column='"+f+"']");}}},b);return b;});
sap.ui.predefine('sap/m/plugins/DataStateIndicator',["./PluginBase","sap/ui/core/Core","sap/ui/base/ManagedObjectObserver"],function(P,C,M){"use strict";
var D=P.extend("sap.m.plugins.DataStateIndicator",{metadata:{library:"sap.m",properties:{filter:{type:"function",invalidate:false},enableFiltering:{type:"boolean",defaultValue:false,invalidate:false}},events:{dataStateChange:{allowPreventDefault:true,parameters:{dataState:{type:"sap.ui.model.DataState"},filteredMessages:{type:"object[]"}}},applyFilter:{allowPreventDefault:true,parameters:{filter:{type:"sap.ui.model.Filter"}}},clearFilter:{allowPreventDefault:true}}}});
D.prototype.onActivate=function(c){this._bFiltering=false;var b=this._getBindingName();var B=c.getBinding(b);if(B){B.attachAggregatedDataStateChange(this._onAggregatedDataStateChange,this);this._processDataState(B.getDataState());}this._oObserver=new M(this._observeChanges.bind(this));this._oObserver.observe(c,{bindings:[b]});};
D.prototype.onDeactivate=function(c){var b=this._getBindingName();var B=c.getBinding(b);if(B){B.detachAggregatedDataStateChange(this._onAggregatedDataStateChange,this);B.getDataState().getMessages().forEach(function(m){m.removeControlId(c.getId());});}if(this._bFiltering){this._clearFilter();}if(this._oMessageStrip){this._oMessageStrip.destroy();this._oMessageStrip=null;}if(this._oLink){this._oLink.destroy();this._oLink=null;}if(this._oInfoToolbar){this._oInfoToolbar.destroy();this._oInfoToolbar=this._oInfoText=null;}this._oObserver.unobserve(c,{bindings:[b]});this._oObserver.destroy();this._oObserver=null;};
D.prototype._setLinkText=function(l){this._sLinkText=l;this._updateLinkControl();};
D.prototype.setEnableFiltering=function(e){if((e=!!e)==this.getEnableFiltering()){return this;}this.setProperty("enableFiltering",e,true);if(this.isActive()){if(e){this.refresh();}else{this._clearFilter(true);}}};
D.prototype.showMessage=function(t,T){if(!this.getEnabled()||!this.getControl()||(!t&&!this._oMessageStrip)){return;}if(this._oMessageStrip){this._oMessageStrip.setText(t).setType(T).setVisible(!!t);}else{sap.ui.require(["sap/m/MessageStrip"],function(a){var c=this.getControl();this._oMessageStrip=new a({showCloseButton:true,showIcon:true,close:function(){c.focus();}}).addStyleClass("sapUiTinyMargin");c.setAggregation("_messageStrip",this._oMessageStrip);c.addAriaLabelledBy(this._oMessageStrip);this._updateLinkControl();this.showMessage(t,T);}.bind(this));}};
D.prototype.isFiltering=function(){return!!this._bFiltering;};
D.prototype.refresh=function(){if(this.isActive()){var b=this.getControl().getBinding(this._getBindingName());if(b){this._processDataState(b.getDataState(),true);if(b.requestFilterForMessages&&this._bFiltering){this._applyFilter();}}}};
D.prototype._updateLinkControl=function(){if(!this._oMessageStrip){return;}if(!this._sLinkText){this._oMessageStrip.setLink(null);}else if(this._oLink){this._oLink.setText(this._sLinkText);this._oMessageStrip.setLink(this._oLink);}else{sap.ui.require(["sap/m/Link"],function(L){this._oLink=new L({press:[this._onLinkPress,this]});this._updateLinkControl();}.bind(this));}};
D.prototype._getBindingName=function(){return this.getConfig("defaultBindingName");};
D.prototype._processDataState=function(d,i){if(!d){return;}if(!i&&!d.getChanges().messages){return;}var p=this.getParent();var c=this.getControl();var b=c&&c.getBinding(this._getBindingName());if(b&&b.bIsBeingDestroyed){return;}var m=d.getMessages();var f=this.getFilter();if(f){m=m.filter(function(o){return f(o,p);});}if(!this.fireDataStateChange({dataState:d,filteredMessages:m})){return;}if(m.length){var s="";var u=false;var F=m[0];m.forEach(function(o){if(o.getControlIds().indexOf(c.getId())==-1){o.addControlId(c.getId());u=true;}});this._sCombinedType=this._getCombinedType(m);if(m.length==1&&F.getTarget()&&F.getTarget().endsWith(b.getPath())){s=F.getMessage();}else{s=this._translate(this._sCombinedType.toUpperCase());}this.showMessage(s,F.getType());if(!this._bFiltering&&b.requestFilterForMessages&&this.getEnableFiltering()){var f=this.getFilter();var a=f&&function(o){return f(o,p);};b.requestFilterForMessages(a).then(function(o){o&&this._setLinkText(this._translate("FILTER_ITEMS"));}.bind(this));}if(u){C.getMessageManager().getMessageModel().checkUpdate(false,true);}}else{this.showMessage("");if(this._bFiltering){this._clearFilter(true);}}};
D.prototype._onLinkPress=function(){if(this._bFiltering){this._clearFilter();}else{this._applyFilter();}};
D.prototype._clearFilter=function(c){if(this._bFiltering){this._bFiltering=false;this._hideFilterInfo(c);if(this.fireClearFilter()&&this._fnLastFilter){this._fnLastFilter("Application");delete this.getControl().getBinding(this._getBindingName()).filter;}}};
D.prototype._applyFilter=function(){var f=this.getFilter();var c=this.getControl();var b=c.getBinding(this._getBindingName());var m=f&&function(o){return f(o,c);};b.requestFilterForMessages(m).then(function(F){if(!F){return this._setLinkText("");}var r=this._bFiltering;if(!r){this._bFiltering=true;this._showFilterInfo();}if(!this.fireApplyFilter({filter:F,revert:this._clearFilter.bind(this)})){return;}if(!r){this._fnLastFilter=b.filter.bind(b,b.aApplicationFilters);this._fnBindingFilter=b.filter;}else{delete b.filter;}b.filter(F,"Application");b.filter=function(a,s){if(s=="Application"){this._fnLastFilter=this._fnBindingFilter.bind(b,a);return b;}return this._fnBindingFilter.apply(b,arguments);}.bind(this);}.bind(this));};
D.prototype._hideFilterInfo=function(c){this._oMessageStrip.setShowCloseButton(true);this._setLinkText(c?"":this._translate("FILTER_ITEMS"));this.getConfig("hideInfoToolbar",this.getControl());};
D.prototype._showFilterInfo=function(){if(this._oInfoText){this._oMessageStrip.setShowCloseButton(false);this._setLinkText(this._translate("CLEAR_FILTER"));this._oInfoText.setText(this._translate("FILTERED_BY_"+this._sCombinedType.toUpperCase()));if(!this._oInfoToolbar.getParent()){this.getConfig("showInfoToolbar",this.getControl(),this._oInfoToolbar);}}else{sap.ui.require(["sap/m/Text","sap/m/Toolbar"],function(T,a){this._oInfoText=new T();this._oInfoToolbar=new a({design:"Info",content:this._oInfoText,active:this.hasListeners("filterInfoPress"),press:this.fireEvent.bind(this,"filterInfoPress")});this._showFilterInfo();}.bind(this));}};
D.prototype._getCombinedType=function(m){if(m&&m.length){var t={None:0,Information:1,Success:2,Warning:4,Error:8};var s=0;m.forEach(function(o){s|=t[o.getType()];});if(s&t.Error&&s&t.Warning){return"Issue";}if(s&t.Error){return"Error";}if(s&t.Warning){return"Warning";}if(s&t.Success||s&t.Information){return"Notification";}}return"";};
D.prototype._onAggregatedDataStateChange=function(e){this._processDataState(e.getParameter("dataState"));};
D.prototype._observeChanges=function(c){var b=c.bindingInfo.binding;if(b){var o=(c.mutation=="ready")?"attach":"detach";b[o+"AggregatedDataStateChange"](this._onAggregatedDataStateChange,this);}};
D.prototype._translate=function(b){var B="DATASTATE_"+b;var m=this.getControl().getMetadata();var l=m.getLibraryName();var c=m.getName().split(".").pop().toUpperCase();var r=C.getLibraryResourceBundle(l);var s=c+"_"+B;if(r.hasText(s)){return r.getText(s);}if(l=="sap.m"){return r.getText(B);}return C.getLibraryResourceBundle("sap.m").getText(B);};
P.setConfigs({"sap.m.ListBase":{defaultBindingName:"items",useInfoToolbar:function(p){return p&&p.getUseInfoToolbar&&p.getUseInfoToolbar()=="Off"?false:true;},showInfoToolbar:function(c,i){if(this.useInfoToolbar(c.getParent())){this._oOldInfoToolbar=c.getInfoToolbar();this._oNewInfoToolbar=i;c.setInfoToolbar(i);}},hideInfoToolbar:function(c){if(this._oNewInfoToolbar){c.setInfoToolbar(this._oOldInfoToolbar);this._oNewInfoToolbar=this._oOldInfoToolbar=null;}},onDeactivate:function(c){this.hideInfoToolbar(c);}},"sap.ui.table.Table":{defaultBindingName:"rows",useInfoToolbar:function(p){return p&&p.getUseInfoToolbar&&p.getUseInfoToolbar()=="Off"?false:true;},showInfoToolbar:function(c,i){if(this.useInfoToolbar(c.getParent())){this._oInfoToolbar=i;c.addExtension(i);}},hideInfoToolbar:function(c){if(this._oInfoToolbar){c.removeExtension(this._oInfoToolbar);this._oInfoToolbar=null;}},onDeactivate:function(c){this.hideInfoToolbar(c);}}},D);return D;});
sap.ui.predefine('sap/m/plugins/PasteProvider',["./PluginBase","sap/ui/core/Core","sap/ui/core/util/PasteHelper"],function(P,C,a){"use strict";
var b=P.extend("sap.m.plugins.PasteProvider",{metadata:{library:"sap.m",associations:{pasteFor:{type:"sap.ui.core.Control",multiple:false}},events:{paste:{allowPreventDefault:true,parameters:{data:{type:"string[][]"},text:{type:"string"}}}}}});
var p=null;var A=null;var s="[data-sap-ui-pasteregion]";
b.prototype.onActivate=function(o){o.attachEvent(this.getConfig("pressEvent"),this._onPress,this);};
b.prototype.onDeactivate=function(o){o.detachEvent(this.getConfig("pressEvent"),this._onPress,this);};
b.prototype._onPress=function(){if(p){p.close();}A=this;var o=navigator.clipboard;if(o&&o.readText){o.readText().then(function(d){f(d);A=null;},c);}else{c();}};
function f(e){var d=a.getClipboardText(e);if(!d){return;}var E={text:d};Object.defineProperty(E,"data",{get:a.getPastedDataAs2DArray.bind(a,d)});if(!A.firePaste(E)){return;}var o=g();if(!o){return;}var h=new ClipboardEvent("paste",{clipboardData:new DataTransfer(),bubbles:true});h.clipboardData.setData("text",d);o.dispatchEvent(h);}
function g(){var o=C.byId(A.getPasteFor());var d=o&&o.getDomRef();if(!d){return;}if(d.matches(s)){return d;}else{return d.querySelector(s)||d;}}
function t(S){var o=g();o&&o.classList.toggle("sapMPluginsPasteProviderHighlight",S);}
function c(){var o=A.getControl();if(p){return p.openBy(o);}sap.ui.require(["sap/ui/Device","sap/ui/core/HTML","sap/ui/core/Icon","sap/m/Popover"],function(D,H,I,d){var m,r=C.getLibraryResourceBundle("sap.m");var e=D.system.desktop&&!D.os.ios&&!D.os.android;if(e){var S=r.getText("PASTEPROVIDER_SHORTCUT_"+(D.os.name=="mac"?"MAC":"WIN"));m=r.getText("PASTEPROVIDER_DESKTOP_MSG",'<span class="sapMPluginsPasteProviderShortCut">'+S+'</span>');}else{m=r.getText("PASTEPROVIDER_MOBILE_MSG");}var h=new H({content:'<div contenteditable="true" class="sapMPluginsPasteProviderMessage">'+m+'</div>',preferDOM:false});p=new d({title:r.getText("PASTEPROVIDER_TITLE"),showArrow:e,horizontalScrolling:false,verticalScrolling:false,placement:"Auto",content:h,initialFocus:h.getId(),beginButton:new I({src:"sap-icon://message-information"}),beforeOpen:function(){t(true);},beforeClose:function(){t(false);A=null;}});p.addEventDelegate({onpaste:function(E){E.preventDefault();f(E.originalEvent);p.close();},onkeypress:function(E){E.preventDefault();}});p.openBy(o);});}
P.setConfigs({"sap.m.Button":{pressEvent:"press",onActivate:function(B){if(!B.getText()&&!B.getIcon()&&!B.getTooltip_AsString()){B.setTooltip(C.getLibraryResourceBundle("sap.m").getText("PASTEPROVIDER_PASTE"));B.setIcon("sap-icon://paste");}}}},b);return b;});
sap.ui.predefine('sap/m/plugins/PluginBase',["sap/ui/core/Element"],function(E){"use strict";
var P=E.extend("sap.m.plugins.PluginBase",{metadata:{"abstract":true,library:"sap.m",properties:{enabled:{type:"boolean",defaultValue:true}}}});
var p={};
P.setConfigs=function(c,v){var s=(typeof v=="function")?v.getMetadata().getName():v;Object.assign(p[s]=p[s]||{},c);};
P.setControlConfig=function(c,C,v){var m={};var s=(typeof c=="function")?c.getMetadata().getName():c;m[s]=C;this.setConfigs(m,v);};
P.getPlugin=function(c,v){if(v==undefined){v=this.getMetadata().getName();}else if(typeof v=="function"){v=v.getMetadata().getName();}return c.findElements(false,function(e){return e.isA(v);})[0];};
P.prototype.isActive=function(){return!!(this._bActive);};
P.prototype.getControl=function(){var o=this.getParent();if(o){var s="get"+this.getMetadata().getName().split(".").pop()+"PluginOwner";o=o[s]?o[s](this):o;}return o;};
P.prototype.getConfig=function(k,v,a){var c=this.getControl();if(!c){return;}var s=this.getMetadata().getName();var C=c.getMetadata().getName();var m=p[s]||{};var b=m[C]||{};var r=function(e){return(typeof e[k]=="function")?e[k].call(e,v,a):e[k];};if(k in b){return r(b);}for(var d in m){if(c.isA(d)){if(!k){return m[d];}if(k in m[d]){return r(m[d]);}}}};
P.prototype.isApplicable=function(c){return Object.keys(this.getConfig()||{}).length>0;};
P.prototype.onActivate=function(c){};
P.prototype.onDeactivate=function(c){};
P.prototype.setParent=function(){this._deactivate();E.prototype.setParent.apply(this,arguments);if(this.getEnabled()){this._activate();}return this;};
P.prototype.setEnabled=function(e){var o=this.getEnabled();this.setProperty("enabled",e,true);if(this.getEnabled()!=o){if(o){this._deactivate();}else{this._activate();}}return this;};
P.prototype.setProperty=function(s,v,S){S=S||(this.getMetadata().getProperty(s).appData||{}).invalidate===false;return E.prototype.setProperty.call(this,s,v,S);};
P.prototype._activate=function(){if(this._bActive){return;}var c=this.getControl();if(!c){return;}if(c instanceof Promise){return c.then(this._activate.bind(this));}if(!this.isApplicable(c)){throw new Error(this+" is not applicable to "+c);}this.getConfig("onActivate",c,this);this.onActivate(c);this._bActive=true;};
P.prototype._deactivate=function(){if(!this._bActive){return;}var c=this.getControl();this.getConfig("onDeactivate",c,this);this.onDeactivate(c);this._bActive=false;};
return P;});
sap.ui.predefine('sap/m/routing/RouteMatchedHandler',['sap/ui/base/Object','./TargetHandler','./Router',"sap/base/Log"],function(B,T,M,L){"use strict";
var R=B.extend("sap.m.routing.RouteMatchedHandler",{constructor:function(r,c){if(r instanceof M){L.warning("A sap.m.routing.Router is used together with an sap.m.routing.RouteMatchedHandler (deprecated)."+"The RoutematchedHandler is not taking over triggering the navigations, the Router will do it.",this);return;}this._oTargetHandler=new T(c);r._oTargetHandler=this._oTargetHandler;r.attachRouteMatched(this._onHandleRouteMatched,this);r.attachRoutePatternMatched(this._handleRoutePatternMatched,this);this._oTargets=r.getTargets();if(this._oTargets){this._oTargets.attachDisplay(this._onHandleDisplay,this);}this._oRouter=r;}});
R.prototype.destroy=function(){if(this._oRouter){this._oRouter.detachRouteMatched(this._onHandleRouteMatched,this);this._oRouter.detachRoutePatternMatched(this._handleRoutePatternMatched,this);this._oRouter=null;}if(this._oTargets){this._oTargets.detachDisplay(this._onHandleRouteMatched,this);this._oTargets=null;}return this;};
R.prototype.setCloseDialogs=function(c){this._oTargetHandler.setCloseDialogs(c);return this;};
R.prototype.getCloseDialogs=function(){return this._oTargetHandler.getCloseDialogs();};
R.prototype._handleRoutePatternMatched=function(e){var t=+e.getParameter("config").viewLevel;this._oTargetHandler.navigate({level:t,navigationIdentifier:e.getParameter("name"),askHistory:true});};
R.prototype._onHandleRouteMatched=function(e){var p=e.getParameters(),c=p.config;if(!this._oRouter.getRoute(p.name)._oTarget){return;}this._oTargetHandler.addNavigation({targetControl:p.targetControl,aggregationName:p.config.targetAggregation,eventData:p.arguments,view:p.view,navigationIdentifier:p.name,transition:c.transition,transitionParameters:c.transitionParameters,preservePageInSplitContainer:c.preservePageInSplitContainer});};
R.prototype._onHandleDisplay=function(e){var p=e.getParameters(),c=p.config;this._oTargetHandler.addNavigation({targetControl:p.control,aggregationName:c.controlAggregation,eventData:p.data,view:p.view,navigationIdentifier:p.name,transition:c.transition,transitionParameters:c.transitionParameters,preservePageInSplitContainer:c.preservePageInSplitContainer});};
return R;});
sap.ui.predefine('sap/m/routing/Router',['sap/ui/core/routing/Router','./TargetHandler','./Targets'],function(R,T,a){"use strict";
var M=R.extend("sap.m.routing.Router",{
constructor:function(){this._oTargetHandler=new T();R.prototype.constructor.apply(this,arguments);},
destroy:function(){R.prototype.destroy.apply(this,arguments);this._oTargetHandler.destroy();this._oTargetHandler=null;},
getTargetHandler:function(){return this._oTargetHandler;},
_createTargets:function(c,t){return new a({views:this._oViews,config:c,targets:t,targetHandler:this._oTargetHandler});},
fireRouteMatched:function(A){var r=this.getRoute(A.name),t;if(r._oTarget){t=r._oTarget._oOptions;this._oTargetHandler.addNavigation({navigationIdentifier:A.name,transition:t.transition,transitionParameters:t.transitionParameters,eventData:A.arguments,targetControl:A.targetControl,aggregationName:t.controlAggregation,view:A.view,preservePageInSplitContainer:t.preservePageInSplitContainer});}return R.prototype.fireRouteMatched.apply(this,arguments);},
fireRoutePatternMatched:function(A){var r=A.name,o=this.getRoute(r),l;if(o._oTarget){if(this._oTargets&&this._oTargets._oLastDisplayedTarget){l=this._oTargets._getLevel(this._oTargets._oLastDisplayedTarget);}this._oTargetHandler.navigate({navigationIdentifier:r,level:l,askHistory:true});}return R.prototype.fireRoutePatternMatched.apply(this,arguments);}
});
return M;});
sap.ui.predefine('sap/m/routing/Target',['sap/ui/core/routing/Target','./async/Target','./sync/Target',"sap/base/Log","sap/base/util/UriParameters"],function(T,a,s,L,U){"use strict";
var M=T.extend("sap.m.routing.Target",{constructor:function(o,v,p,t){this._oTargetHandler=t;function c(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","MobileTarget");return true;}return false;}if(o._async===undefined){o._async=c();}T.prototype.constructor.apply(this,arguments);var b=o._async?a:s;this._super={};for(var f in b){this._super[f]=this[f];this[f]=b[f];}}});
return M;});
sap.ui.predefine('sap/m/routing/TargetHandler',['sap/m/InstanceManager','sap/m/NavContainer','sap/m/SplitContainer','sap/ui/base/Object','sap/ui/core/routing/History','sap/ui/Device',"sap/base/Log"],function(I,N,S,B,H,D,L){"use strict";var o={"onAfterShow":function(e){this.getParent().hidePlaceholder({});this.removeEventDelegate(o);}};
var T=B.extend("sap.m.routing.TargetHandler",{constructor:function(c){this._aQueue=[];this._oNavigationOrderPromise=Promise.resolve();if(c===undefined){this._bCloseDialogs=true;}else{this._bCloseDialogs=!!c;}}});
T.prototype.setCloseDialogs=function(c){this._bCloseDialogs=!!c;return this;};
T.prototype.getCloseDialogs=function(){return this._bCloseDialogs;};
T.prototype.addNavigation=function(p){this._aQueue.push(p);};
T.prototype.navigate=function(d){var u=this._groupNavigation(),r=this._createResultingNavigations(d.navigationIdentifier,u),c=false,b=this._getDirection(d),n;while(r.length){n=this._applyNavigationResult(r.shift().oParams,b);c=c||n;}if(c){this._closeDialogs();}};
T.prototype._chainNavigation=function(n,s){var p=this._oNavigationOrderPromise.then(n);this._oNavigationOrderPromise=p.catch(function(e){L.error("The following error occurred while displaying routing target with name '"+s+"': "+e);});return p;};
T.prototype._getDirection=function(d){var t=d.level,h=H.getInstance(),b=false;if(d.direction==="Backwards"){b=true;}else if(isNaN(t)||isNaN(this._iCurrentLevel)||t===this._iCurrentLevel){if(d.askHistory){b=h.getDirection()==="Backwards";}}else{b=t<this._iCurrentLevel;}this._iCurrentLevel=t;return b;};
T.prototype._groupNavigation=function(){var c,C,s,n,u=[],i;while(this._aQueue.length){c=this._aQueue.shift();C=c.targetControl;s=c.aggregationName;if(!c.preservePageInSplitContainer){for(i=0;i<u.length;i++){n=u[i];if(C!==n.targetControl||s!==n.aggregationName){continue;}u.splice(i,1);break;}}u.push(c);}return u;};
T.prototype._createResultingNavigations=function(n,u){var i,c,C,a,r=[],v,b,p,R;while(u.length){c=u.shift();C=c.targetControl;b=C instanceof S;v=c.view;a={oContainer:C,oParams:c};if(b){a.bIsMasterPage=!!C.getMasterPage(v.getId());}p=b&&c.preservePageInSplitContainer&&C.getCurrentPage(a.bIsMasterPage)&&n!==c.navigationIdentifier;for(i=0;i<r.length;i++){R=r[i];if(R.oContainer!==C){continue;}if(b){if(D.system.phone){r.splice(i,1);break;}else if(R.bIsMasterPage===a.bIsMasterPage){if(!p){r.splice(i,1);}break;}}}if(!p){r.push(a);}}return r;};
T.prototype._applyNavigationResult=function(p,b){var t=p.targetControl,P,a=p.eventData,s=p.placeholderShown?"show":(p.transition||""),c=p.transitionParameters,v=p.view&&p.view.getId(),n=t instanceof S&&!!t.getMasterPage(v),d=(t instanceof S||t instanceof N)&&p.view,e,f;if(p.placeholderConfig){e=p.placeholderConfig.autoClose;f=p.placeholderConfig.container;}if(!d){if(f&&e&&f.hidePlaceholder){f.hidePlaceholder(p.placeholderConfig);}return false;}if(t.getDomRef()&&t.getCurrentPage(n).getId()===v){if(e&&f&&f.hidePlaceholder){f.hidePlaceholder(p.placeholderConfig);}L.info("navigation to view with id: "+v+" is skipped since it already is displayed by its targetControl","sap.m.routing.TargetHandler");return false;}else if(e){p.view.addEventDelegate(o,p.view);}L.info("navigation to view with id: "+v+" the targetControl is "+t.getId()+" backwards is "+b);if(b){P=t.getPreviousPage(n);if(!P||P.getId()!==v){t.insertPreviousPage(v,s,a);}t.backToPage(v,a,c);}else{t.to(v,s,a,c);}return true;};
T.prototype._closeDialogs=function(){if(!this._bCloseDialogs){return;}if(I.hasOpenPopover()){I.closeAllPopovers();}if(I.hasOpenDialog()){I.closeAllDialogs();}if(I.hasOpenLightBox()){I.closeAllLightBoxes();}};
T.prototype.showPlaceholder=function(s){var c=s.container,n=true,O;if(s.object&&!(s.object instanceof Promise)){O=s.object;}if(s.container&&typeof s.container.needPlaceholder==="function"){n=s.container.needPlaceholder(s.aggregation,O);}if(n){return c.showPlaceholder(s);}else{return Promise.resolve();}};
return T;});
sap.ui.predefine('sap/m/routing/Targets',['sap/ui/core/routing/Targets','./TargetHandler','./Target','./async/Targets','./sync/Targets',"sap/base/Log","sap/base/util/UriParameters"],function(T,a,b,c,s,L,U){"use strict";
var M=T.extend("sap.m.routing.Targets",{
constructor:function(o){if(!o.config){o.config={_async:false};}function d(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","MobileTargets");return true;}return false;}if(o.config._async===undefined){o.config._async=(o.config.async===undefined)?d():o.config.async;}if(o.targetHandler){this._oTargetHandler=o.targetHandler;}else{this._oTargetHandler=new a();this._bHasOwnTargetHandler=true;}T.prototype.constructor.apply(this,arguments);var e=o.config._async?c:s;this._super={};for(var f in e){this._super[f]=this[f];this[f]=e[f];}},
destroy:function(){T.prototype.destroy.apply(this,arguments);if(this._bHasOwnTargetHandler){this._oTargetHandler.destroy();}this._oTargetHandler=null;},
getTargetHandler:function(){return this._oTargetHandler;},
_constructTarget:function(o,p){return new b(o,this.getViews(),p,this._oTargetHandler);},
_getLevel:function(t){var l;do{l=t._oOptions.hasOwnProperty("level")?t._oOptions.level:t._oOptions.viewLevel;if(l!==undefined){return l;}t=t._oParent;}while(t);return l;}
});
return M;});
sap.ui.predefine('sap/m/routing/async/Target',[],function(){"use strict";return{_place:function(d){var p=this._super._place.apply(this,arguments),t=this;return this._oTargetHandler._chainNavigation(function(){return p.then(function(v){t._oTargetHandler.addNavigation({navigationIdentifier:t._oOptions._name,transition:t._oOptions.transition,transitionParameters:t._oOptions.transitionParameters,eventData:d,targetControl:v.control,aggregationName:t._oOptions.controlAggregation,view:v.view,preservePageInSplitContainer:t._oOptions.preservePageInSplitContainer,placeholderConfig:v.placeholderConfig,placeholderShown:v.placeholderShown});if(d){delete d.routeConfig;}return v;});},this._oOptions._name);},showPlaceholder:function(s){return this._oTargetHandler.showPlaceholder(s);},hidePlaceholder:function(){}};},true);
sap.ui.predefine('sap/m/routing/async/Targets',[],function(){"use strict";return{_display:function(){var l,n;this._oLastDisplayedTarget=null;var p=this._super._display.apply(this,arguments);return p.then(function(v){if(this._oLastDisplayedTarget){l=this._getLevel(this._oLastDisplayedTarget);n=this._oLastDisplayedTarget._oOptions._name;}this._oTargetHandler.navigate({level:l,navigationIdentifier:n,askHistory:true});return v;}.bind(this));},_displaySingleTarget:function(t){var T=this.getTarget(t.name);return this._super._displaySingleTarget.apply(this,arguments).then(function(v){if(T){this._oLastDisplayedTarget=T;}return v;}.bind(this));}};},true);
sap.ui.predefine('sap/m/routing/sync/Target',[],function(){"use strict";return{_place:function(p,d){var r=this._super._place.apply(this,arguments);this._oTargetHandler.addNavigation({navigationIdentifier:this._oOptions._name,transition:this._oOptions.transition,transitionParameters:this._oOptions.transitionParameters,eventData:d,targetControl:r.oTargetControl,aggregationName:this._oOptions.controlAggregation,view:r.oTargetParent,preservePageInSplitContainer:this._oOptions.preservePageInSplitContainer});if(d){delete d.routeConfig;}return r;}};},true);
sap.ui.predefine('sap/m/routing/sync/Targets',[],function(){"use strict";return{_display:function(){var l,n;this._oLastDisplayedTarget=null;var r=this._super._display.apply(this,arguments);if(this._oLastDisplayedTarget){l=this._getLevel(this._oLastDisplayedTarget);n=this._oLastDisplayedTarget._oOptions._name;}this._oTargetHandler.navigate({level:l,navigationIdentifier:n,askHistory:true});return r;},_displaySingleTarget:function(n){var t=this.getTarget(n);if(t){this._oLastDisplayedTarget=t;}return this._super._displaySingleTarget.apply(this,arguments);}};},true);
sap.ui.predefine('sap/m/semantic/AddAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var A=S.extend("sap.m.semantic.AddAction",{metadata:{library:"sap.m"}});
return A;});
sap.ui.predefine('sap/m/semantic/CancelAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var C=S.extend("sap.m.semantic.CancelAction",{metadata:{library:"sap.m"}});
return C;});
sap.ui.predefine('sap/m/semantic/DeleteAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var D=S.extend("sap.m.semantic.DeleteAction",{metadata:{library:"sap.m"}});
return D;});
sap.ui.predefine('sap/m/semantic/DetailPage',["sap/m/semantic/ShareMenuPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer","sap/m/library"],function(S,a,b,l){"use strict";var c=l.semantic.SemanticRuleSetType;
var D=S.extend("sap.m.semantic.DetailPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},flagAction:{type:"sap.m.semantic.FlagAction",multiple:false},favoriteAction:{type:"sap.m.semantic.FavoriteAction",multiple:false},openInAction:{type:"sap.m.semantic.OpenInAction",multiple:false},discussInJamAction:{type:"sap.m.semantic.DiscussInJamAction",multiple:false},shareInJamAction:{type:"sap.m.semantic.ShareInJamAction",multiple:false},sendEmailAction:{type:"sap.m.semantic.SendEmailAction",multiple:false},sendMessageAction:{type:"sap.m.semantic.SendMessageAction",multiple:false},printAction:{type:"sap.m.semantic.PrintAction",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false},saveAsTileAction:{type:"sap.m.Button",multiple:false},pagingAction:{type:"sap.m.PagingButton",multiple:false},draftIndicator:{type:"sap.m.DraftIndicator",multiple:false}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/semantic/DetailPage.designtime"},
renderer:b
});
D.prototype.init=function(){S.prototype.init.call(this);this._getPage().getLandmarkInfo().setRootLabel(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_DETAIL_PAGE_TITLE"));};
D.prototype.setAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(o){this._addToInnerAggregation(o,a.getPositionInPage(A),a.getSequenceOrderIndex(A),s);this[p]=o;}else{if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p]=null;}}return this;}return S.prototype.setAggregation.call(this,A,o,s);};
D.prototype.getAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){return this['_'+A];}return S.prototype.getAggregation.call(this,A,o,s);};
D.prototype.destroyAggregation=function(A,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p].destroy();this[p]=null;}return this;}return S.prototype.destroyAggregation.call(this,A,s);};
D.prototype.getSemanticRuleSet=function(){return c.Classic;};
return D;});
sap.ui.predefine('sap/m/semantic/DiscussInJamAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var D=S.extend("sap.m.semantic.DiscussInJamAction",{metadata:{library:"sap.m"}});
return D;});
sap.ui.predefine('sap/m/semantic/EditAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var E=S.extend("sap.m.semantic.EditAction",{metadata:{library:"sap.m"}});
return E;});
sap.ui.predefine('sap/m/semantic/FavoriteAction',['sap/m/semantic/SemanticToggleButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FavoriteAction",{metadata:{library:"sap.m"}});
return F;});
sap.ui.predefine('sap/m/semantic/FilterAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FilterAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IFilter"]}});
return F;});
sap.ui.predefine('sap/m/semantic/FilterSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FilterSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IFilter"]}});
return F;});
sap.ui.predefine('sap/m/semantic/FlagAction',['sap/m/semantic/SemanticToggleButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FlagAction",{metadata:{library:"sap.m"}});
return F;});
sap.ui.predefine('sap/m/semantic/ForwardAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.ForwardAction",{metadata:{library:"sap.m"}});
return F;});
sap.ui.predefine('sap/m/semantic/FullscreenPage',["sap/m/semantic/ShareMenuPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer"],function(S,a,b){"use strict";
var F=S.extend("sap.m.semantic.FullscreenPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},flagAction:{type:"sap.m.semantic.FlagAction",multiple:false},favoriteAction:{type:"sap.m.semantic.FavoriteAction",multiple:false},openInAction:{type:"sap.m.semantic.OpenInAction",multiple:false},discussInJamAction:{type:"sap.m.semantic.DiscussInJamAction",multiple:false},shareInJamAction:{type:"sap.m.semantic.ShareInJamAction",multiple:false},sendEmailAction:{type:"sap.m.semantic.SendEmailAction",multiple:false},sendMessageAction:{type:"sap.m.semantic.SendMessageAction",multiple:false},printAction:{type:"sap.m.semantic.PrintAction",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false},saveAsTileAction:{type:"sap.m.Button",multiple:false},pagingAction:{type:"sap.m.PagingButton",multiple:false},draftIndicator:{type:"sap.m.DraftIndicator",multiple:false}}},
renderer:b
});
F.prototype.setAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(o){this._addToInnerAggregation(o,a.getPositionInPage(A),a.getSequenceOrderIndex(A),s);this[p]=o;}else{if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p]=null;}}return;}S.prototype.setAggregation.call(this,A,o,s);};
F.prototype.getAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){return this['_'+A];}return S.prototype.getAggregation.call(this,A,o,s);};
F.prototype.destroyAggregation=function(A,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p].destroy();this[p]=null;}return this;}return S.prototype.destroyAggregation.call(this,A,s);};
return F;});
sap.ui.predefine('sap/m/semantic/GroupAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var G=S.extend("sap.m.semantic.GroupAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IGroup"]}});
return G;});
sap.ui.predefine('sap/m/semantic/GroupSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var G=S.extend("sap.m.semantic.GroupSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IGroup"]}});
return G;});
sap.ui.predefine('sap/m/semantic/MainAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var M=S.extend("sap.m.semantic.MainAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return M;});
sap.ui.predefine('sap/m/semantic/MasterPage',["sap/m/semantic/SemanticPage","sap/m/semantic/SemanticPageRenderer","sap/m/library"],function(S,a,l){"use strict";var b=l.semantic.SemanticRuleSetType;
var M=S.extend("sap.m.semantic.MasterPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},multiSelectAction:{type:"sap.m.semantic.MultiSelectAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},sort:{type:"sap.m.semantic.ISort",multiple:false},filter:{type:"sap.m.semantic.IFilter",multiple:false},group:{type:"sap.m.semantic.IGroup",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false}}},
renderer:a
});
M.prototype.init=function(){S.prototype.init.call(this);this._getPage().getLandmarkInfo().setRootLabel(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_MASTER_PAGE_TITLE"));};
M.prototype.getSemanticRuleSet=function(){return b.Classic;};
return M;});
sap.ui.predefine('sap/m/semantic/MessagesIndicator',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var M=S.extend("sap.m.semantic.MessagesIndicator",{metadata:{library:"sap.m"}});
return M;});
sap.ui.predefine('sap/m/semantic/MultiSelectAction',['sap/m/semantic/SemanticToggleButton'],function(S){"use strict";
var M=S.extend("sap.m.semantic.MultiSelectAction",{metadata:{library:"sap.m"}});
var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");M._PRESSED_STATE_TO_ICON_MAP={"true":"sap-icon://sys-cancel","false":"sap-icon://multi-select"};M._ACC_TOOLTIP_TO_ICON_MAP={"true":b.getText("SEMANTIC_CONTROL_MULTI_SELECT_CANCEL"),"false":b.getText("SEMANTIC_CONTROL_MULTI_SELECT")};
M.prototype._setPressed=function(p,s){var i=M._PRESSED_STATE_TO_ICON_MAP[p];var I=M._ACC_TOOLTIP_TO_ICON_MAP[p];this._getControl().setIcon(i);this._getControl().setTooltip(I);};
return M;});
sap.ui.predefine('sap/m/semantic/NegativeAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var N=S.extend("sap.m.semantic.NegativeAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return N;});
sap.ui.predefine('sap/m/semantic/OpenInAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var O=S.extend("sap.m.semantic.OpenInAction",{metadata:{library:"sap.m"}});
return O;});
sap.ui.predefine('sap/m/semantic/PositiveAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var P=S.extend("sap.m.semantic.PositiveAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return P;});
sap.ui.predefine('sap/m/semantic/PrintAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var P=S.extend("sap.m.semantic.PrintAction",{metadata:{library:"sap.m"}});
return P;});
sap.ui.predefine('sap/m/semantic/SaveAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SaveAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/Segment',['sap/ui/base/Object',"sap/base/Log"],function(B,L){"use strict";
var S=B.extend("sap.m.semantic.Segment",{
constructor:function(C,o,s,f){if(!o){L.error("missing argumment: constructor expects a container reference",this);return;}C||(C=[]);this._aContent=C;this._oContainer=o;this._sContainerAggregationName=s;this._fnSortFunction=f;},
getInterface:function(){return this;}
});
S.prototype.getStartIndex=function(){return 0;};
S.prototype.getEndIndex=function(){return this.getStartIndex()+this._aContent.length;};
S.prototype.getContent=function(){return this._aContent.slice();};
S.prototype.indexOfContent=function(C){return this._aContent.indexOf(C);};
S.prototype.addContent=function(C,s){if(this._fnSortFunction){var i=this._matchSortToInsertIndex(C);if(typeof i!=='undefined'){this._insertContent(C,i,s);return C;}}var a=this.getEndIndex(),l=this._aContent.length,A="insert"+c(this._sContainerAggregationName);this._oContainer[A](C,a,s);this._aContent.splice(l,0,C);return C;};
S.prototype.insertContent=function(C,i,s){if(this._fnSortFunction){var I=this._matchSortToInsertIndex(C);if(typeof I!=='undefined'){this._insertContent(C,I,s);return C;}}return this._insertContent(C,i,s);};
S.prototype.removeContent=function(C,s){var l=this._aContent.indexOf(C),a="remove"+c(this._sContainerAggregationName);if(l>-1){this._aContent.splice(l,1);return this._oContainer[a](C,s);}};
S.prototype.removeAllContent=function(s){var r=[],g=this._oContainer.getAggregation(this._sContainerAggregationName),a=this.getStartIndex(),e=this.getEndIndex(),A="remove"+c(this._sContainerAggregationName);for(var i=a;i<e;i++){var I=this._oContainer[A](g[i],s);if(I){r.push(I);}}this._aContent=[];return r;};
S.prototype.destroy=function(s){var r=this.removeAllContent(s);for(var i=0;i<r.length;i++){r[i].destroy(s);}};
S.prototype._insertContent=function(C,i,s){var I=Math.min(this.getStartIndex()+i,this.getEndIndex()),a="insert"+c(this._sContainerAggregationName);I=Math.max(I,0);this._oContainer[a](C,I,s);this._aContent.splice(i,0,C);return C;};
S.prototype._matchSortToInsertIndex=function(C){for(var i=0;i<this._aContent.length;i++){if(this._fnSortFunction(C,this._aContent[i])<=0){return i;}}};
function c(n){return n.charAt(0).toUpperCase()+n.substring(1);}
return S;});
sap.ui.predefine('sap/m/semantic/SegmentedContainer',['sap/m/semantic/Segment','sap/ui/base/Object',"sap/base/Log"],function(S,B,L){"use strict";
var a=B.extend("sap.m.semantic.SegmentedContainer",{
constructor:function(c,C){if(!c){L.error("missing argumment: constructor expects a container reference",this);return;}this._oContainer=c;C||(C="content");this._sContainerAggregationName=C;this._aSegments=[];},
getInterface:function(){return this;}
});
a.prototype.addSection=function(o){if(!o||!o.sTag){L.error("missing argumment: section options expected",this);return;}if(o.aContent){var c=o.aContent;var l=c.length;for(var i=0;i<l;i++){this._oContainer.addAggregation(this._sContainerAggregationName,c[i]);}}var s=new S(c,this._oContainer,this._sContainerAggregationName,o.fnSortFunction);s.sTag=o.sTag;var b=this._aSegments;s.getStartIndex=function(){var d=0;var e=b.indexOf(this);if(e>0){var p=e-1;while(p>=0){d+=b[p].getContent().length;p--;}}return d;};this._aSegments.push(s);};
a.prototype.getSection=function(t){var s;this._aSegments.forEach(function(b){if(b.sTag===t){s=b;}});return s;};
a.prototype.destroy=function(s){this._oContainer.destroy(s);this.aSegments=null;};
a.prototype.getContainer=function(){return this._oContainer;};
return a;});
sap.ui.predefine('sap/m/semantic/SemanticButton',['sap/m/semantic/SemanticControl','sap/m/Button','sap/m/semantic/SemanticOverflowToolbarButton',"sap/ui/thirdparty/jquery"],function(S,B,a,q){"use strict";
var b=S.extend("sap.m.semantic.SemanticButton",{metadata:{library:"sap.m","abstract":true,properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true}},events:{press:{}}}});
b.prototype._getControl=function(){var c,C,n,o=this._getConfiguration();if(!o){return null;}c=this.getAggregation('_control');if(!c){C=this._getClass(o);n=this._createInstance(C);n.applySettings(o.getSettings());if(typeof o.getEventDelegates==="function"){n.addEventDelegate(o.getEventDelegates(n));}this.setAggregation('_control',n,true);c=this.getAggregation('_control');}return c;};
b.prototype._getClass=function(c){return c&&c.constraints==="IconOnly"?a:B;};
b.prototype._createInstance=function(c){return new c({id:this.getId()+"-button",press:q.proxy(this.firePress,this)});};
return b;});
sap.ui.predefine('sap/m/semantic/SemanticConfiguration',["sap/ui/base/Object","sap/m/library","sap/m/OverflowToolbarLayoutData","sap/ui/core/IconPool","sap/ui/core/InvisibleText"],function(B,l,O,I,a){"use strict";var b=l.ButtonType;var P=l.PlacementType;var S=l.semantic.SemanticRuleSetType;var c=l.OverflowToolbarPriority;
var d=B.extend("sap.m.semantic.SemanticConfiguration",{getInterface:function(){return this;}});
d.prototype._PositionInPage={headerLeft:"headerLeft",headerRight:"headerRight",headerMiddle:"headerMiddle",footerLeft:"footerLeft",footerRight_IconOnly:"footerRight_IconOnly",footerRight_TextOnly:"footerRight_TextOnly",shareMenu:"shareMenu"};d._PageMode={display:"display",edit:"edit",multimode:"multimode"};
d.isKnownSemanticType=function(t){return d.getConfiguration(t)!=undefined;};
d.getConfiguration=function(t){return d._oTypeConfigs[t];};
d.getSettings=function(t){return d._oTypeConfigs[t].getSettings();};
d.getPositionInPage=function(t){return d._oTypeConfigs[t].position;};
d.getSequenceOrderIndex=function(t){return d._oTypeConfigs[t].order;};
d.getAriaId=function(t){return d._oTypeConfigs[t].getSettings().ariaLabelledBy;};
d.getShareMenuConfig=function(r){switch(r){case S.Classic:return{baseButtonPlacement:P.Bottom,actionSheetPlacement:P.Top};case S.Optimized:return{baseButtonPlacement:P.Top,actionSheetPlacement:P.Bottom};}};
d._oTypeConfigs=(function(){var t={},o=sap.ui.getCore().getLibraryResourceBundle("sap.m");t["sap.m.semantic.MultiSelectAction"]={position:d.prototype._PositionInPage.headerRight,getSettings:function(){return{icon:I.getIconURI("multi-select"),tooltip:o.getText("SEMANTIC_CONTROL_MULTI_SELECT")};}};t["sap.m.semantic.MainAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:b.Emphasized,layoutData:new O({priority:c.NeverOverflow})};},order:0};t["sap.m.semantic.EditAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,triggers:d._PageMode.edit,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_EDIT"),type:b.Emphasized,layoutData:new O({priority:c.NeverOverflow})};},order:1};t["sap.m.semantic.SaveAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,triggers:d._PageMode.display,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_SAVE"),type:b.Emphasized,layoutData:new O({priority:c.NeverOverflow})};},order:3};t["sap.m.semantic.DeleteAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,triggers:d._PageMode.display,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_DELETE"),layoutData:new O({priority:c.NeverOverflow})};},order:4};t["sap.m.semantic.PositiveAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:b.Accept,layoutData:new O({priority:c.NeverOverflow})};},order:5};t["sap.m.semantic.NegativeAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:b.Reject,layoutData:new O({priority:c.NeverOverflow})};},order:6};t["sap.m.semantic.CancelAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,triggers:d._PageMode.display,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_CANCEL")};},order:7};t["sap.m.semantic.ForwardAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_FORWARD")};},order:8};t["sap.m.semantic.OpenInAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_OPEN_IN")};},order:9};t["sap.m.semantic.AddAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,triggers:d._PageMode.edit,getSettings:function(){return{icon:I.getIconURI("add"),text:o.getText("SEMANTIC_CONTROL_ADD"),tooltip:o.getText("SEMANTIC_CONTROL_ADD")};},order:0,constraints:"IconOnly"};t["sap.m.semantic.FavoriteAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("favorite"),text:o.getText("SEMANTIC_CONTROL_FAVORITE"),tooltip:o.getText("SEMANTIC_CONTROL_FAVORITE")};},order:1,constraints:"IconOnly"};t["sap.m.semantic.FlagAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("flag"),text:o.getText("SEMANTIC_CONTROL_FLAG"),tooltip:o.getText("SEMANTIC_CONTROL_FLAG")};},order:2,constraints:"IconOnly"};t["sap.m.semantic.ISort"]={position:d.prototype._PositionInPage.footerRight_IconOnly,order:3};t["sap.m.semantic.IFilter"]={position:d.prototype._PositionInPage.footerRight_IconOnly,order:4};t["sap.m.semantic.IGroup"]={position:d.prototype._PositionInPage.footerRight_IconOnly,order:5};t["sap.m.semantic.SortAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("sort"),text:o.getText("SEMANTIC_CONTROL_SORT"),tooltip:o.getText("SEMANTIC_CONTROL_SORT")};},constraints:"IconOnly"};t["sap.m.semantic.SortSelect"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("sort"),type:"IconOnly",autoAdjustWidth:true,tooltip:o.getText("SEMANTIC_CONTROL_SORT")};},getEventDelegates:function(C){return{onAfterRendering:function(){this.$().attr({"aria-haspopup":"listbox"});}.bind(C)};},constraints:"IconOnly"};t["sap.m.semantic.FilterAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("filter"),text:o.getText("SEMANTIC_CONTROL_FILTER"),tooltip:o.getText("SEMANTIC_CONTROL_FILTER")};},constraints:"IconOnly"};t["sap.m.semantic.FilterSelect"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("filter"),type:"IconOnly",autoAdjustWidth:true,tooltip:o.getText("SEMANTIC_CONTROL_FILTER")};},getEventDelegates:function(C){return{onAfterRendering:function(){this.$().attr({"aria-haspopup":"listbox"});}.bind(C)};},constraints:"IconOnly"};t["sap.m.semantic.GroupAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("group-2"),text:o.getText("SEMANTIC_CONTROL_GROUP"),tooltip:o.getText("SEMANTIC_CONTROL_GROUP")};},constraints:"IconOnly"};t["sap.m.semantic.GroupSelect"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("group-2"),type:"IconOnly",autoAdjustWidth:true,tooltip:o.getText("SEMANTIC_CONTROL_GROUP")};},getEventDelegates:function(C){return{onAfterRendering:function(){this.$().attr({"aria-haspopup":"listbox"});}.bind(C)};},constraints:"IconOnly"};t["saveAsTileAction"]={position:d.prototype._PositionInPage.shareMenu,order:0,constraints:"IconOnly"};t["pagingAction"]={position:d.prototype._PositionInPage.headerRight};t["sap.m.semantic.DiscussInJamAction"]={position:d.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("discussion-2"),text:o.getText("SEMANTIC_CONTROL_DISCUSS_IN_JAM")};},order:1,constraints:"IconOnly"};t["sap.m.semantic.ShareInJamAction"]={position:d.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("share-2"),text:o.getText("SEMANTIC_CONTROL_SHARE_IN_JAM")};},order:2,constraints:"IconOnly"};t["sap.m.semantic.SendMessageAction"]={position:d.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("discussion"),text:o.getText("SEMANTIC_CONTROL_SEND_MESSAGE")};},order:3,constraints:"IconOnly"};t["sap.m.semantic.SendEmailAction"]={position:d.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("email"),text:o.getText("SEMANTIC_CONTROL_SEND_EMAIL")};},order:4,constraints:"IconOnly"};t["sap.m.semantic.PrintAction"]={position:d.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("print"),text:o.getText("SEMANTIC_CONTROL_PRINT")};},order:5,constraints:"IconOnly"};t["sap.m.semantic.MessagesIndicator"]={position:d.prototype._PositionInPage.footerLeft,getSettings:function(){return{icon:I.getIconURI("message-popup"),text:{path:"message>/",formatter:function(m){return m.length||0;}},tooltip:o.getText("SEMANTIC_CONTROL_MESSAGES_INDICATOR"),type:b.Emphasized,visible:{path:"message>/",formatter:function(m){return m&&m.length>0;}},models:{message:sap.ui.getCore().getMessageManager().getMessageModel()},layoutData:new O({priority:c.NeverOverflow})};}};t["draftIndicator"]={position:d.prototype._PositionInPage.footerLeft,getSettings:function(){return{layoutData:new O({shrinkable:false})};},order:1};return t;})();return d;});
sap.ui.predefine('sap/m/semantic/SemanticControl',["sap/m/semantic/SemanticConfiguration","sap/ui/base/ManagedObject","sap/ui/core/Element","sap/ui/thirdparty/jquery"],function(S,M,E,q){"use strict";
var a=E.extend("sap.m.semantic.SemanticControl",{metadata:{library:"sap.m","abstract":true,properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true}},aggregations:{_control:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}}}});
a.prototype.setProperty=function(k,v,s){M.prototype.setProperty.call(this,k,v,true);this._applyProperty(k,v,s);return this;};
a.prototype.updateAggregation=function(n){this._getControl().updateAggregation(n);};
a.prototype.refreshAggregation=function(n){this._getControl().refreshAggregation(n);};
a.prototype.setAggregation=function(A,o,s){if(A==='_control'){return M.prototype.setAggregation.call(this,A,o,s);}return this._getControl().setAggregation(A,o,s);};
a.prototype.getAggregation=function(A,d){if(A==='_control'){return M.prototype.getAggregation.call(this,A,d);}return this._getControl().getAggregation(A,d);};
a.prototype.indexOfAggregation=function(A,o){return this._getControl().indexOfAggregation(A,o);};
a.prototype.insertAggregation=function(A,o,i,s){return this._getControl().insertAggregation(A,o,i,s);};
a.prototype.addAggregation=function(A,o,s){return this._getControl().addAggregation(A,o,s);};
a.prototype.removeAggregation=function(A,o,s){return this._getControl().removeAggregation(A,o,s);};
a.prototype.removeAllAggregation=function(A,s){return this._getControl().removeAllAggregation(A,s);};
a.prototype.destroyAggregation=function(A,s){return this._getControl().destroyAggregation(A,s);};
a.prototype.bindAggregation=function(n,b){return this._getControl().bindAggregation(n,b);};
a.prototype.unbindAggregation=function(n,s){return this._getControl().unbindAggregation(n,s);};
a.prototype.clone=function(i,l){var c=E.prototype.clone.apply(this,arguments);var p=this._getControl().clone(i,l);c.setAggregation('_control',p);return c;};
a.prototype.destroy=function(){var r=E.prototype.destroy.apply(this,arguments);if(this.getAggregation("_control")){this.getAggregation("_control").destroy();}return r;};
a.prototype.getPopupAnchorDomRef=function(){return this._getControl().getDomRef();};
a.prototype.getDomRef=function(s){return this._getControl().getDomRef(s);};
a.prototype.addEventDelegate=function(d,t){q.each(d,function(e,c){if(typeof c==='function'){var p=function(o){o.srcControl=this;c.call(t,o);}.bind(this);d[e]=p;}}.bind(this));this._getControl().addEventDelegate(d,t);return this;};
a.prototype.removeEventDelegate=function(d){this._getControl().removeEventDelegate(d);return this;};
a.prototype._getConfiguration=function(){return S.getConfiguration(this.getMetadata().getName());};
a.prototype._onPageStateChanged=function(e){this._updateState(e.sId);};
a.prototype._updateState=function(s){if(this._getConfiguration()&&this._getControl()){var o=this._getConfiguration().states[s];if(o){this._getControl().applySettings(o);}}};
a.prototype._applyProperty=function(k,v,s){var b="set"+this._capitalize(k);this._getControl()[b](v,s);};
a.prototype._capitalize=function(n){return n.charAt(0).toUpperCase()+n.slice(1);};
return a;});
sap.ui.predefine('sap/m/semantic/SemanticOverflowToolbarButton',['sap/m/OverflowToolbarButton','sap/m/ButtonRenderer'],function(O,B){"use strict";
var S=O.extend("sap.m.semantic.SemanticOverflowToolbarButton",{
metadata:{library:"sap.m"},
renderer:B
});
S.prototype._getTooltip=function(){var t=O.prototype._getTooltip.call(this);if(!t&&!this._bInOverflow&&this.getText()){t=this.getText();}return t;};
return S;});
sap.ui.predefine('sap/m/semantic/SemanticOverflowToolbarToggleButton',["sap/m/OverflowToolbarToggleButton","sap/m/ToggleButtonRenderer"],function(O,T){"use strict";
var S=O.extend("sap.m.semantic.SemanticOverflowToolbarToggleButton",{
metadata:{library:"sap.m"},
renderer:T
});
S.prototype._getTooltip=function(){var t=O.prototype._getTooltip.call(this);if(!t&&!this._bInOverflow&&this.getText()){t=this.getText();}return t;};
return S;});
sap.ui.predefine('sap/m/semantic/SemanticPage',['sap/m/semantic/SegmentedContainer','sap/m/semantic/SemanticConfiguration','sap/m/Button','sap/m/Title','sap/m/Page','sap/m/OverflowToolbar','sap/m/ToolbarSpacer','sap/m/Bar','sap/ui/core/CustomData','sap/ui/base/ManagedObject','sap/m/PageAccessibleLandmarkInfo','sap/ui/base/ManagedObjectObserver','sap/ui/core/Control','sap/ui/core/library','sap/m/library',"./SemanticPageRenderer","sap/base/Log","sap/ui/thirdparty/jquery"],function(S,a,B,T,P,O,b,c,C,M,d,e,f,g,l,h,L,q){"use strict";var i=l.ButtonType;var j=l.PageBackgroundDesign;var k=l.semantic.SemanticRuleSetType;var m=g.TitleLevel;
var n=f.extend("sap.m.semantic.SemanticPage",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:m.Auto},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},showSubHeader:{type:"boolean",group:"Appearance",defaultValue:true},enableScrolling:{type:"boolean",group:"Behavior",defaultValue:true},showFooter:{type:"boolean",group:"Appearance",defaultValue:true},floatingFooter:{type:"boolean",group:"Appearance",defaultValue:false},semanticRuleSet:{type:"sap.m.semantic.SemanticRuleSetType",group:"Misc",defaultValue:k.Classic},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:j.Standard}},defaultAggregation:"content",aggregations:{subHeader:{type:"sap.m.IBar",multiple:false},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",forwarding:{getter:"_getPage",aggregation:"content"}},customHeaderContent:{type:"sap.m.Button",multiple:true,singularName:"customHeaderContent"},customFooterContent:{type:"sap.m.Button",multiple:true,singularName:"customFooterContent"},landmarkInfo:{type:"sap.m.PageAccessibleLandmarkInfo",multiple:false,forwarding:{getter:"_getPage",aggregation:"landmarkInfo"}},_page:{type:"sap.m.Page",multiple:false,visibility:"hidden"}},events:{navButtonPress:{}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/semantic/SemanticPage.designtime"}});
n.prototype.init=function(){this._oHeaderObserver=new e(n.prototype._updateHeaderVisibility.bind(this));this._currentMode=a._PageMode.display;this._getPage().setCustomHeader(this._getInternalHeader());this._getPage().setFooter(new O(this.getId()+"-footer"));this.setLandmarkInfo(new d());this._getPage().setShowHeader(false);};
n.prototype.exit=function(){if(this._oInternalHeader){this._oInternalHeader.destroy();this._oInternalHeader=null;}if(this._oWrappedFooter){this._oWrappedFooter.destroy();this._oWrappedFooter=null;}if(this._oTitle){this._oTitle.destroy();this._oTitle=null;}if(this._oNavButton){this._oNavButton.destroy();this._oNavButton=null;}if(this._oHeaderObserver){this._oHeaderObserver.disconnect();this._oHeaderObserver=null;}this._oPositionsMap=null;};
n.prototype.setSubHeader=function(p,r){this._getPage().setSubHeader(p,r);return this;};
n.prototype.getSubHeader=function(){return this._getPage().getSubHeader();};
n.prototype.destroySubHeader=function(p){this._getPage().destroySubHeader(p);return this;};
n.prototype.getShowSubHeader=function(){return this._getPage().getShowSubHeader();};
n.prototype.setShowSubHeader=function(p,r){this._getPage().setShowSubHeader(p,r);this.setProperty("showSubHeader",p,true);return this;};
n.prototype.getShowFooter=function(){return this._getPage().getShowFooter();};
n.prototype.setShowFooter=function(p,r){this._getPage().setShowFooter(p,r);this.setProperty("showFooter",p,true);return this;};
n.prototype.setFloatingFooter=function(F,p){this._getPage().setFloatingFooter(F,p);this.setProperty("floatingFooter",F,true);return this;};
n.prototype.setTitle=function(t){var p=this._getTitle();if(p){p.setText(t);if(!p.getParent()){this._getInternalHeader().addContentMiddle(p);}}this.setProperty("title",t,true);return this;};
n.prototype.setTitleLevel=function(t){this.setProperty("titleLevel",t,true);this._getTitle().setLevel(t);return this;};
n.prototype.setShowNavButton=function(p){var r=this._getNavButton();if(r){r.setVisible(p);if(!r.getParent()){this._getInternalHeader().addContentLeft(r);}}this.setProperty("showNavButton",p,true);return this;};
n.prototype.setEnableScrolling=function(E){this._getPage().setEnableScrolling(E);this.setProperty("enableScrolling",E,true);return this;};
n.prototype.setBackgroundDesign=function(p){this.setProperty("backgroundDesign",p,true);this._getPage().setBackgroundDesign(p);return this;};
n.prototype.getCustomFooterContent=function(){return this._getSegmentedFooter().getSection("customRight").getContent();};
n.prototype.addCustomFooterContent=function(p,r){this._getSegmentedFooter().getSection("customRight").addContent(p,r);return this;};
n.prototype.indexOfCustomFooterContent=function(p){return this._getSegmentedFooter().getSection("customRight").indexOfContent(p);};
n.prototype.insertCustomFooterContent=function(p,I,r){this._getSegmentedFooter().getSection("customRight").insertContent(p,I,r);return this;};
n.prototype.removeCustomFooterContent=function(p,r){return this._getSegmentedFooter().getSection("customRight").removeContent(p,r);};
n.prototype.removeAllCustomFooterContent=function(p){return this._getSegmentedFooter().getSection("customRight").removeAllContent(p);};
n.prototype.destroyCustomFooterContent=function(p){var r=this.getCustomFooterContent();if(!r){return this;}if(p){this.iSuppressInvalidate++;}this._getSegmentedFooter().getSection("customRight").destroy(p);if(!this.isInvalidateSuppressed()){this.invalidate();}if(p){this.iSuppressInvalidate--;}return this;};
n.prototype.getCustomHeaderContent=function(){return this._getSegmentedHeader().getSection("customRight").getContent();};
n.prototype.addCustomHeaderContent=function(p,r){this._getSegmentedHeader().getSection("customRight").addContent(p,r);return this;};
n.prototype.indexOfCustomHeaderContent=function(p){return this._getSegmentedHeader().getSection("customRight").indexOfContent(p);};
n.prototype.insertCustomHeaderContent=function(p,I,r){this._getSegmentedHeader().getSection("customRight").insertContent(p,I,r);return this;};
n.prototype.removeCustomHeaderContent=function(p,r){return this._getSegmentedHeader().getSection("customRight").removeContent(p,r);};
n.prototype.removeAllCustomHeaderContent=function(p){return this._getSegmentedHeader().getSection("customRight").removeAllContent(p);};
n.prototype.destroyCustomHeaderContent=function(p){var r=this.getCustomHeaderContent();if(!r){return this;}if(p){this.iSuppressInvalidate++;}this._getSegmentedHeader().getSection("customRight").destroy(p);if(!this.isInvalidateSuppressed()){this.invalidate();}if(p){this.iSuppressInvalidate--;}return this;};
n.prototype.setAggregation=function(A,p,r){var t=this.mAggregations[A];if(t===p){return this;}p=this.validateAggregation(A,p,false);var u=this.getMetadata().getManagedAggregation(A).type;if(a.isKnownSemanticType(u)){if(t){this._stopMonitor(t);this._removeFromInnerAggregation(t._getControl(),a.getPositionInPage(u),r);}if(p){this._initMonitor(p);this._addToInnerAggregation(p._getControl(),a.getPositionInPage(u),a.getSequenceOrderIndex(u),r);}return M.prototype.setAggregation.call(this,A,p,true);}return M.prototype.setAggregation.call(this,A,p,r);};
n.prototype.destroyAggregation=function(A,p){var r=this.getMetadata().getAggregations()[A];if(r&&a.isKnownSemanticType(r.type)){var t=M.prototype.getAggregation.call(this,A);if(t){this._stopMonitor(t);if(!t._getControl().bIsDestroyed){this._removeFromInnerAggregation(t._getControl(),a.getPositionInPage(r.type),p);}}}return M.prototype.destroyAggregation.call(this,A,t,p);};
n.prototype._updateHeaderVisibility=function(){var H=this._getInternalHeader();var E=(H.getContentLeft().length===0)&&(H.getContentMiddle().length===0)&&(H.getContentRight().length===0);this._getPage().setShowHeader(!E);};
n.prototype._getTitle=function(){if(!this._oTitle){this._oTitle=new T(this.getId()+"-title",{text:this.getTitle()});}return this._oTitle;};
n.prototype._getNavButton=function(){if(!this._oNavButton){this._oNavButton=new B(this.getId()+"-navButton",{type:i.Up,tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PAGE_NAVBUTTON_TEXT"),press:q.proxy(this.fireNavButtonPress,this)});}return this._oNavButton;};
n.prototype._initMonitor=function(p){var r=p._getConfiguration();if(r.triggers){p.attachEvent("press",this._updateCurrentMode,this);}var t=r.states,u=this;if(t){q.each(a._PageMode,function(v,w){if(t[v]){u.attachEvent(v,p._onPageStateChanged,p);}});}};
n.prototype._stopMonitor=function(p){p.detachEvent("press",this._updateCurrentMode,this);var r=p._getConfiguration();var t=r.states,u=this;if(t){q.each(a._PageMode,function(v,w){if(t[v]){u.detachEvent(v,p._onPageStateChanged,p);}});}};
n.prototype._updateCurrentMode=function(E){var p=E.oSource._getConfiguration();if(typeof p.triggers==='string'){this._currentMode=p.triggers;}else{var r=p.triggers.length;if(r&&r>0){for(var I=0;I<r;I++){var t=p.triggers[I];if(t&&(t.inState===this._currentMode)){this._currentMode=t.triggers;break;}}}}this.fireEvent(this._currentMode);};
n.prototype._removeFromInnerAggregation=function(p,r,t){var u=this._getSemanticPositionsMap()[r];if(u&&u.oContainer&&u.sAggregation){u.oContainer["remove"+o(u.sAggregation)](p,t);}};
n.prototype._addToInnerAggregation=function(p,r,t,u){if(!p||!r){return;}var v=this._getSemanticPositionsMap()[r];if(!v||!v.oContainer||!v.sAggregation){return;}if(typeof t!=='undefined'){p.addCustomData(new C({key:"sortIndex",value:t}));}return v.oContainer["add"+o(v.sAggregation)](p,u);};
n.prototype._getSemanticPositionsMap=function(p,r){if(!this._oPositionsMap){this._oPositionsMap={};this._oPositionsMap[a.prototype._PositionInPage.headerLeft]={oContainer:this._getInternalHeader(),sAggregation:"contentLeft"};this._oPositionsMap[a.prototype._PositionInPage.headerRight]={oContainer:this._getSegmentedHeader().getSection("semanticRight"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.headerMiddle]={oContainer:this._getInternalHeader(),sAggregation:"contentMiddle"};this._oPositionsMap[a.prototype._PositionInPage.footerLeft]={oContainer:this._getSegmentedFooter().getSection("semanticLeft"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.footerRight_IconOnly]={oContainer:this._getSegmentedFooter().getSection("semanticRight_IconOnly"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.footerRight_TextOnly]={oContainer:this._getSegmentedFooter().getSection("semanticRight_TextOnly"),sAggregation:"content"};}return this._oPositionsMap;};
n.prototype._getPage=function(){var p=this.getAggregation("_page");if(!p){this.setAggregation("_page",new P(this.getId()+"-page"));p=this.getAggregation("_page");}return p;};
n.prototype._getInternalHeader=function(){if(!this._oInternalHeader){this._oInternalHeader=new c(this.getId()+"-intHeader");if(this._oHeaderObserver){this._oHeaderObserver.observe(this._oInternalHeader,{aggregations:["contentLeft","contentMiddle","contentRight"]});}}return this._oInternalHeader;};
n.prototype._getAnyHeader=function(){return this._getInternalHeader();};
n.prototype._getSegmentedHeader=function(){if(!this._oWrappedHeader){var H=this._getInternalHeader();if(!H){L.error("missing page header",this);return null;}this._oWrappedHeader=new S(H,"contentRight");this._oWrappedHeader.addSection({sTag:"customRight"});this._oWrappedHeader.addSection({sTag:"semanticRight"});}return this._oWrappedHeader;};
n.prototype._getSegmentedFooter=function(){if(!this._oWrappedFooter){var F=this._getPage().getFooter();if(!F){L.error("missing page footer",this);return null;}this._oWrappedFooter=new S(F);this._oWrappedFooter.addSection({sTag:"semanticLeft"});this._oWrappedFooter.addSection({sTag:"spacer",aContent:[new b()]});this._oWrappedFooter.addSection({sTag:"semanticRight_TextOnly",fnSortFunction:s});this._oWrappedFooter.addSection({sTag:"customRight"});this._oWrappedFooter.addSection({sTag:"semanticRight_IconOnly",fnSortFunction:s});}return this._oWrappedFooter;};
function o(N){return N.substring(0,1).toUpperCase()+N.substring(1);}
function s(p,r){var t=p.data("sortIndex");var u=r.data("sortIndex");if((typeof t==='undefined')||(typeof u==='undefined')){L.warning("sortIndex missing",this);return null;}return(t-u);}
return n;});
sap.ui.predefine('sap/m/semantic/SemanticPageRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,o){r.openStart("div",o);r.class("sapMSemanticPage");r.openEnd();r.renderControl(o._getPage());r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/semantic/SemanticSelect',['sap/m/semantic/SemanticControl','sap/m/Select',"sap/base/Log"],function(S,a,L){"use strict";
var b=S.extend("sap.m.semantic.SemanticSelect",{metadata:{library:"sap.m","abstract":true,properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:""}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false}},events:{change:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}}}});
b.prototype.setProperty=function(p,v,s){if(!this.getMetadata().getProperties()[p]&&!b.getMetadata().getProperties()[p]&&!S.getMetadata().getProperties()[p]){L.error("unknown property: "+p,this);return this;}S.prototype.setProperty.call(this,p,v,s);};
b.prototype.getSelectedItem=function(){return this._getControl().getSelectedItem();};
b.prototype.setSelectedItem=function(i){this._getControl().setSelectedItem(i);this.setSelectedKey(this._getControl().getSelectedKey());return this;};
b.prototype.getItemAt=function(i){return this._getControl().getItemAt(i);};
b.prototype._getControl=function(){var c=this.getAggregation('_control');if(!c){this.setAggregation('_control',new a({id:this.getId()+"-select",change:this._onInnerSelectChange.bind(this)}),true);c=this.getAggregation('_control');c.applySettings(this._getConfiguration().getSettings());if(typeof this._getConfiguration().getEventDelegates==="function"){c.addEventDelegate(this._getConfiguration().getEventDelegates(c));}}return c;};
b.prototype._onInnerSelectChange=function(e){var s=e.getSource().getSelectedItem();this.setSelectedItem(s);this.fireChange({selectedItem:s});};
return b;});
sap.ui.predefine('sap/m/semantic/SemanticToggleButton',["sap/m/semantic/SemanticButton","sap/ui/events/KeyCodes","sap/m/ToggleButton","sap/m/semantic/SemanticOverflowToolbarToggleButton"],function(S,K,T,a){"use strict";
var b=S.extend("sap.m.semantic.SemanticToggleButton",{metadata:{library:"sap.m","abstract":true,properties:{pressed:{type:"boolean",group:"Data",defaultValue:false}}}});
b.prototype._getClass=function(c){return c&&c.constraints==="IconOnly"?a:T;};
b.prototype._onPress=function(e){var p;if(this.getEnabled()){p=e.getParameter('pressed');this.setPressed(p);this.firePress({pressed:p});}};
b.prototype._applyProperty=function(p,v,s){if(p==='pressed'){this._setPressed(v,s);}else{S.prototype._applyProperty.apply(this,arguments);}};
b.prototype._setPressed=function(v,s){var t=this._getControl(),p=Boolean(v);if(t.getPressed()!==p){this._getControl().setPressed(p,s);}};
b.prototype._createInstance=function(c){var i=new c({id:this.getId()+"-toggleButton"});i.attachEvent("press",this._onPress,this);return i;};
return b;});
sap.ui.predefine('sap/m/semantic/SendEmailAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SendEmailAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/SendMessageAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SendMessageAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/ShareInJamAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.ShareInJamAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/ShareMenu',['sap/ui/base/Object','sap/ui/base/ManagedObjectObserver','sap/m/library','sap/ui/core/library','sap/m/Button','sap/m/OverflowToolbarLayoutData','sap/ui/core/IconPool','sap/m/OverflowToolbarButton',"sap/base/Log"],function(B,M,l,c,a,O,I,b,L){"use strict";var d=l.OverflowToolbarPriority;var A=c.aria.HasPopup;
var S=B.extend("sap.m.semantic.ShareMenu",{
constructor:function(o){if(!o){L.error("missing argumment: constructor expects an actionsheet reference",this);return;}this._oActionSheet=o;this._oContentObserver=new M(this._updateShareBtnVisibility.bind(this));this._setMode(S._Mode.initial);},
getInterface:function(){return this;}
});
S._Mode={initial:"initial",button:"button",actionSheet:"actionSheet"};
S.prototype.getBaseButton=function(){return this._oBaseButton;};
S.prototype.getAggregation=function(n){if(n==="content"){return this.getContent();}};
S.prototype.addAggregation=function(n,o,s){if(n==="content"){return this.addContent(o,s);}};
S.prototype.insertAggregation=function(n,o,i,s){if(n==="content"){return this.insertContent(o,i,s);}};
S.prototype.indexOfAggregation=function(n,o){if(n==="content"){return this.indexOfContent(o);}};
S.prototype.removeAggregation=function(n,o,s){if(n==="content"){return this.removeContent(o,s);}};
S.prototype.removeAllAggregation=function(n,s){if(n==="content"){return this.removeAllContent(s);}};
S.prototype.getContent=function(){var m=this._getMode();if(m===S._Mode.initial){return[];}else if(m===S._Mode.button){return[this._oBaseButton];}else{return this._oActionSheet.getAggregation("buttons")||[];}};
S.prototype.addContent=function(o,s){var m=this._getMode();this._observeButton(o);if(m===S._Mode.initial){this._setMode(S._Mode.button,s,o);return this;}if(m===S._Mode.button){this._setMode(S._Mode.actionSheet,s);}this._preProcessOverflowToolbarButton(o);this._oActionSheet.addButton(o,s);this._updateShareBtnVisibility();return this;};
S.prototype.insertContent=function(o,i,s){var m=this._getMode();this._observeButton(o);if(m===S._Mode.initial){this._setMode(S._Mode.button,s,o);return this;}if(m===S._Mode.button){this._setMode(S._Mode.actionSheet,s);}this._preProcessOverflowToolbarButton(o);this._oActionSheet.insertButton(o,i,s);this._updateShareBtnVisibility();return this;};
S.prototype.indexOfContent=function(o){if((this._getMode()===S._Mode.button)&&(o===this._oBaseButton)){return 0;}if(this._getMode()===S._Mode.actionSheet){return this._oActionSheet.indexOfAggregation("buttons",o);}return-1;};
S.prototype.removeContent=function(o,s){var r,m=this._getMode();if(m===S._Mode.actionSheet){r=this._oActionSheet.removeButton(o,s);this._postProcessOverflowToolbarButton(o);this._unobserveButton(o);if(r){if(this._oActionSheet.getAggregation("buttons").length===1){this._setMode(S._Mode.button,s);}}this._updateShareBtnVisibility();return r;}if(m===S._Mode.button){var e=this._oBaseButton;this._setMode(S._Mode.initial,s);return e;}return r;};
S.prototype.removeAllContent=function(s){var r;if(this._getMode()===S._Mode.actionSheet){r=this._oActionSheet.removeAllButtons(s);r.forEach(function(o){this._postProcessOverflowToolbarButton(o);this._unobserveButton(o);},this);this._updateShareBtnVisibility();}else if(this._getMode()===S._Mode.button){r=[this._oBaseButton];}this._setMode(S._Mode.initial,s);return r;};
S.prototype.destroy=function(s){this._oActionSheet.destroy(s);if(this._oShareMenuBtn){this._oShareMenuBtn.destroy(s);this._oShareMenuBtn=null;}if(this._oContentObserver){this._oContentObserver.disconnect();this._oContentObserver=null;}};
S.prototype._setBaseButton=function(o,s){if(this._oBaseButton===o){return this;}var e=this._oBaseButton;this._oBaseButton=o;if(e){var p=e.getParent(),P=e.sParentAggregationName;if(p){p.removeAggregation(P,e,s);p.addAggregation(P,this._oBaseButton,s);}}return this;};
S.prototype._getMode=function(){return this._mode;};
S.prototype._setMode=function(m,s,o){if(!S._Mode[m]){L.error("unknown shareMenu mode "+m,this);return this;}if(this._mode===m){return this;}if(S._Mode.initial===m){this._setBaseButton(this._getShareMenuButton().applySettings({visible:false}));this._mode=S._Mode.initial;return this;}if(m===S._Mode.button){if(this._mode===S._Mode.initial){this._setBaseButton(o);}else if(this._mode===S._Mode.actionSheet){var e=this._oActionSheet.getAggregation("buttons")[0];this._oActionSheet.removeButton(e,s);this._postProcessOverflowToolbarButton(e);this._setBaseButton(e);}this._mode=S._Mode.button;return this;}if(m===S._Mode.actionSheet){var f=this._oBaseButton;this._setBaseButton(this._getShareMenuButton().applySettings({visible:true}));if(f){this._preProcessOverflowToolbarButton(f);this._oActionSheet.addButton(f,s);}this._mode=S._Mode.actionSheet;}return this;};
S.prototype._getShareMenuButton=function(){if(!this._oShareMenuBtn){var t=this;this._oShareMenuBtn=new a(this._oActionSheet.getParent().getId()+"-shareButton",{ariaHasPopup:A.Menu,icon:I.getIconURI("action"),tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_CONTROL_ACTION_SHARE"),layoutData:new O({priority:d.NeverOverflow}),press:function(){t._oActionSheet.openBy(t._oShareMenuBtn);}});}return this._oShareMenuBtn;};
S.prototype._getVisibleContent=function(){return this.getContent().filter(function(o){return o.getVisible();});};
S.prototype._updateShareBtnVisibility=function(){var v=this._getVisibleContent(),t=v.length>0;this._getShareMenuButton().setVisible(t);};
S.prototype._preProcessOverflowToolbarButton=function(o){if(o instanceof b){o._bInOverflow=true;}};
S.prototype._postProcessOverflowToolbarButton=function(o){if(o instanceof b){delete o._bInOverflow;}};
S.prototype._observeButton=function(o){this._oContentObserver.observe(o,{properties:["visible"]});};
S.prototype._unobserveButton=function(o){this._oContentObserver.unobserve(o,{properties:["visible"]});};
return S;});
sap.ui.predefine('sap/m/semantic/ShareMenuPage',["sap/m/semantic/SemanticPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer","sap/m/semantic/SegmentedContainer","sap/m/semantic/ShareMenu","sap/m/ActionSheet","sap/m/library"],function(S,a,b,c,d,A,l){"use strict";var P=l.PlacementType;
var e=S.extend("sap.m.semantic.ShareMenuPage",{
metadata:{library:"sap.m",aggregations:{customShareMenuContent:{type:"sap.m.Button",multiple:true,singularName:"customShareMenuContent"},_actionSheet:{type:"sap.m.ActionSheet",multiple:false,visibility:"hidden"}},designtime:"sap/m/designtime/semantic/ShareMenuPage.designtime"},
renderer:b
});
e.prototype._getSemanticPositionsMap=function(C,o){if(!this._oPositionsMap){this._oPositionsMap=S.prototype._getSemanticPositionsMap.apply(this,arguments);this._oPositionsMap[a.prototype._PositionInPage.shareMenu]={oContainer:this._getSegmentedShareMenu().getSection("semantic"),sAggregation:"content"};}return this._oPositionsMap;};
e.prototype.exit=function(){S.prototype.exit.apply(this,arguments);if(this._oSegmentedShareMenu){this._oSegmentedShareMenu.destroy();this._oSegmentedShareMenu=null;}};
e.prototype.getCustomShareMenuContent=function(){return this._getSegmentedShareMenu().getSection("custom").getContent();};
e.prototype.addCustomShareMenuContent=function(B,s){this._getSegmentedShareMenu().getSection("custom").addContent(B,s);return this;};
e.prototype.indexOfCustomShareMenuContent=function(B){return this._getSegmentedShareMenu().getSection("custom").indexOfContent(B);};
e.prototype.insertCustomShareMenuContent=function(B,i,s){this._getSegmentedShareMenu().getSection("custom").insertContent(B,i,s);return this;};
e.prototype.removeCustomShareMenuContent=function(B,s){return this._getSegmentedShareMenu().getSection("custom").removeContent(B,s);};
e.prototype.removeAllCustomShareMenuContent=function(s){return this._getSegmentedShareMenu().getSection("custom").removeAllContent(s);};
e.prototype.destroyCustomShareMenuContent=function(s){var C=this.getCustomShareMenuContent();if(!C){return this;}if(s){this.iSuppressInvalidate++;}this._getSegmentedShareMenu().getSection("custom").destroy();if(!this.isInvalidateSuppressed()){this.invalidate();}if(s){this.iSuppressInvalidate--;}return this;};
e.prototype.setSemanticRuleSet=function(n){var o=this.getSemanticRuleSet();if(o===n){return this;}this.setProperty("semanticRuleSet",n,true);var O=a.getShareMenuConfig(o),s=this._getShareBaseButtonContainer(O.baseButtonPlacement).getSection("shareMenu");if(s){this._moveShareMenu(O,a.getShareMenuConfig(this.getSemanticRuleSet()));}return this;};
e.prototype._moveShareMenu=function(o,n){var O=this._getShareBaseButtonContainer(o.baseButtonPlacement).getSection("shareMenu"),f=O&&O.removeAllContent(),g=f.length&&f[0];this._placeShareMenu(g,n);};
e.prototype._getActionSheet=function(){var o=this.getAggregation("_actionSheet");if(!o){this.setAggregation("_actionSheet",new A(),true);o=this.getAggregation("_actionSheet");}return o;};
e.prototype._getSegmentedShareMenu=function(){if(!this._oSegmentedShareMenu){var s=new d(this._getActionSheet());var o=s.getBaseButton();if(s&&o){this._oSegmentedShareMenu=new c(s);this._oSegmentedShareMenu.addSection({sTag:"custom"});this._oSegmentedShareMenu.addSection({sTag:"semantic"});this._placeShareMenu(o,a.getShareMenuConfig(this.getSemanticRuleSet()));}}return this._oSegmentedShareMenu;};
e.prototype._placeShareMenu=function(s,o){var f=o.baseButtonPlacement,v=o.actionSheetPlacement;var D=this._getShareBaseButtonContainer(f),g=D.getSection("shareMenu");if(!g){D.addSection({sTag:"shareMenu"});g=D.getSection("shareMenu");}if(s){g.addContent(s);}this._getActionSheet().setPlacement(v);};
e.prototype._getShareBaseButtonContainer=function(B){return(B===P.Bottom)?this._getSegmentedFooter():this._getSegmentedHeader();};
return e;});
sap.ui.predefine('sap/m/semantic/SortAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SortAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.ISort"]}});
return a;});
sap.ui.predefine('sap/m/semantic/SortSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SortSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.ISort"]}});
return a;});
sap.ui.predefine('sap/m/table/ActionItem',["sap/m/table/ItemBase"],function(I){"use strict";
var A=I.extend("sap.m.table.ActionItem",{metadata:{library:"sap.m",properties:{label:{type:"string"},icon:{type:"sap.ui.core.URI"}},events:{press:{}}}});
A.prototype.onPress=function(e){e.preventDefault();this.firePress();};
A.prototype.getContent=function(){return null;};
return A;});
sap.ui.predefine('sap/m/table/ColumnMenu',["sap/m/ResponsivePopover","sap/m/Button","sap/m/Toolbar","sap/m/ToolbarSpacer","sap/m/library","sap/ui/core/Control","sap/ui/core/Core","sap/ui/thirdparty/jquery","sap/base/strings/capitalize","sap/m/p13n/AbstractContainerItem","sap/m/p13n/Container","sap/m/table/ColumnMenuRenderer"],function(R,B,T,a,l,C,b,q,c,A,d,e){"use strict";
var f=C.extend("sap.m.table.ColumnMenu",{metadata:{library:"sap.m",interfaces:["sap.ui.core.IColumnHeaderMenu"],aggregations:{quickActions:{type:"sap.m.table.QuickActionBase"},items:{type:"sap.m.table.ItemBase"},_quickActions:{type:"sap.m.table.QuickActionBase",visibility:"hidden"},_items:{type:"sap.m.table.ItemBase",visibility:"hidden"}}}});
var D="$default";var g=sap.ui.core.aria.HasPopup.Dialog;
f.prototype.applySettings=function(s){if(s){this._addAllToPrivateAggregation(s,"_quickActions");this._addAllToPrivateAggregation(s,"_items");}C.prototype.applySettings.apply(this,arguments);};
f.prototype.openBy=function(o){if(!this.getParent()){b.getUIArea(b.getStaticAreaRef()).addContent(this,true);}this._initPopover();if(!this._oItemsContainer){this._initItemsContainer();}this._oPopover.openBy(o);};
f.prototype.getAriaHasPopupType=function(){return g;};
f.prototype.close=function(){this._previousView=null;if(this._oPopover){this._oPopover.close();}};
f.prototype.exit=function(){C.prototype.exit.apply(this,arguments);if(this._oPopover){delete this._oPopover;}if(this._oItemsContainer){delete this._oItemsContainer;}};
f.prototype._addAllToPrivateAggregation=function(s,i){if(s[i]){s[i].forEach(function(I){this.addAggregation(i,I);}.bind(this));delete s[i];}};
f.prototype._initPopover=function(){if(this._oPopover){return;}this._oPopover=new R({showArrow:false,showHeader:false,placement:l.PlacementType.Bottom,content:new h({control:this,height:true}),contentWidth:"500px",horizontalScrolling:false,verticalScrolling:false,afterClose:[this.close,this]});this.addDependent(this._oPopover);this._oPopover.addEventDelegate({"onAfterRendering":this._focusItem},this);if(this.getItems().length==0&&!this.getAggregation("_items")){this._oPopover.attachAfterOpen(this._focusInitialQuickAction.bind(this));}};
f.prototype._initItemsContainer=function(){var i=(this.getAggregation("_items")||[]).reduce(function(I,o){return I.concat(o.getEffectiveItems());},[]);var j=this.getItems().reduce(function(I,o){return I.concat(o.getEffectiveItems());},[]);if(!this._oItemsContainer){this._createItemsContainer();}i.forEach(function(o,I){this._addView(o);I==0&&this._oItemsContainer.addSeparator();}.bind(this));j.forEach(function(o,I){this._addView(o);I==0&&this._oItemsContainer.addSeparator();}.bind(this));};
var h=C.extend("sap.m.table.AssociativeControl",{
metadata:{"final":true,properties:{height:{type:"boolean",defaultValue:false}},associations:{control:{type:"sap.ui.core.Control"}}},
renderer:{apiVersion:2,render:function(r,o){r.openStart("div",o);o.getHeight()&&r.style("height","100%");r.openEnd();r.renderControl(sap.ui.getCore().byId(o.getControl()));r.close("div");}}
});
f.prototype._addView=function(o){var i=new A({content:new h({control:o.getContent(),height:true}),key:o.getId(),text:o.getLabel(),icon:o.getIcon()});this._oItemsContainer.addView(i);this._setItemVisibility(o,o.getVisible());};
f.prototype._createItemsContainer=function(){var o=this;this._oBtnCancel=new B({text:this._getResourceText("table.COLUMNMENU_CANCEL"),press:function(){var k=o._oItemsContainer.getCurrentViewKey();if(o._fireEvent(b.byId(k),"cancel")){o.close();o.exit();}}});this._oBtnOk=new B({text:this._getResourceText("table.COLUMNMENU_CONFIRM"),press:function(){var k=o._oItemsContainer.getCurrentViewKey();if(o._fireEvent(b.byId(k),"confirm")){o.close();}}});o._oItemsContainer=new d({listLayout:true,defaultView:D,footer:new T({content:[new a(),this._oBtnOk,this._oBtnCancel]}),beforeViewSwitch:function(E){var p=E.getParameters();if(p.target!=="$default"){var i=o._oItemsContainer.getView(p.target);var j=o._getItemFromContainerItem(i);if(j&&j.firePress&&!o._fireEvent(j,"press")){E.preventDefault();return;}}},afterViewSwitch:function(E){var p=E.getParameters();this.oLayout.setShowFooter(p.target!=="$default");o._previousView=p.source;if(p.target!=="$default"){var i=o._oItemsContainer.getView(p.target);if(i){var I=o._getItemFromContainerItem(i);o._updateButtonState(I);}else{var i=o._oItemsContainer.getView(p.target);var I=o._getItemFromContainerItem(i);I&&I.focus();this._oPopover&&this._oPopover.invalidate();}}}});o._oItemsContainer.getHeader().addContentRight(new B({text:this._getResourceText("table.COLUMNMENU_RESET"),press:function(){o._fireEvent(b.byId(o._oItemsContainer.getCurrentViewKey()),"reset",false);}}));this._oPopover.addDependent(o._oItemsContainer);o.addDependent(o._oItemsContainer);};
f.prototype._fireEvent=function(o,E,i){var H=o["on"+c(E)];if(i!==false){var j=q.Event(E);H.call(o,j);return!j.isDefaultPrevented();}else{H.call(o);return true;}};
f.prototype._getResourceText=function(t,v){this.oResourceBundle=this.oResourceBundle?this.oResourceBundle:sap.ui.getCore().getLibraryResourceBundle("sap.m");return t?this.oResourceBundle.getText(t,v):this.oResourceBundle;};
f.prototype._getItemFromContainerItem=function(o){var i=this.getAggregation("_items")&&this.getAggregation("_items").find(function(j){return j.getId()==o.getKey();});if(!i){i=this.getAggregation("items")&&this.getAggregation("items").find(function(j){return j.getId()==o.getKey();});}return i;};
f.prototype._updateButtonState=function(i){this._oItemsContainer.getHeader().getContentRight()[0].setEnabled(i.getButtonSettings()["reset"]["enabled"]);this._oItemsContainer.getHeader().getContentRight()[0].setVisible(i.getButtonSettings()["reset"]["visible"]);this._oBtnOk.setVisible(i.getButtonSettings()["confirm"]["visible"]);this._oBtnCancel.setVisible(i.getButtonSettings()["cancel"]["visible"]);};
f.prototype._focusItem=function(){if(this._previousView==D){this._oItemsContainer._getNavBackBtn().focus();}else{var i=this._oItemsContainer._getNavigationList().getItems().find(function(i){return i.getVisible()&&i._key===this._previousView;}.bind(this));i&&i.focus();}};
f.prototype._focusInitialQuickAction=function(){if(this.getItems().length==0&&!this.getAggregation("_items")){var Q=[];if(this.getAggregation("_quickActions")){Q=this.getAggregation("_quickActions")[0].getEffectiveQuickActions();}else if(this.getQuickActions().length>0){Q=this.getQuickActions()[0].getEffectiveQuickActions();}Q.length>0&&Q[0].getContent().focus();}};
f.prototype._setItemVisibility=function(i,v){var L=this._oItemsContainer._getNavigationList().getItems();var o=L.find(function(o){return o._key==i.getId();});o&&o.setVisible(v);};
return f;});
sap.ui.predefine('sap/m/table/ColumnMenuEntry',["sap/ui/core/Element"],function(E){"use strict";
var C=E.extend("sap.m.table.ColumnMenuEntry",{metadata:{"abstract":true,library:"sap.m",properties:{visible:{type:"boolean",defaultValue:true}}}});
C.prototype.getMenu=function(){var e=this.getParent();while(e){if(e.isA("sap.m.table.ColumnMenu")){return e;}e=e.getMenu();}return undefined;};
C.prototype.getLabel=function(){if(this.getMetadata().hasProperty("label")){return this.getProperty("label");}throw new Error(this+" does not implement #getLabel");};
C.prototype.getContent=function(){if(this.getMetadata().hasAggregation("content")){return this.getAggregation("content");}throw new Error(this+" does not implement #getContent");};
C.prototype.setVisible=function(v){if(this.getVisible()==v){return this;}this.setProperty("visible",v);this.getMenu()&&this.getMenu()._setItemVisibility(this,v);return this;};
return C;});
sap.ui.predefine('sap/m/table/ColumnMenuRenderer',[],function(){"use strict";var C={apiVersion:2};
C.render=function(r,c){r.openStart("div",c);r.class("sapMTCMenu");r.class("sapMWrapper");r.openEnd();if(c.getQuickActions().length>0||c.getAggregation("_quickActions")){this.renderQuickActions(r,c);}if(c.getItems().length>0||c.getAggregation("_items")){this.renderItems(r,c);}r.close("div");};
C.renderQuickActions=function(r,c){r.openStart("div");r.attr("id",c.getId()+"-quickActions");if(c._oItemsContainer){if(c._oItemsContainer.getCurrentViewKey()==="$default"){r.class("sapMTQAList");}else{r.class("sapMTQAListHidden");}}else{r.class("sapMTQAList");}r.openEnd();(c.getAggregation("_quickActions")||[]).forEach(function(q){q.getEffectiveQuickActions().forEach(function(q){this.renderQuickAction(r,q);}.bind(this));}.bind(this));c.getQuickActions().forEach(function(q){q.getEffectiveQuickActions().forEach(function(q){this.renderQuickAction(r,q);}.bind(this));}.bind(this));r.close("div");};
C.renderQuickAction=function(r,q){r.openStart("div",q);r.class("sapMQAction");r.openEnd();r.openStart("div");r.class("sapMQALabel");r.openEnd();r.text(q.getLabel());r.close("div");r.openStart("div");r.openEnd();r.renderControl(q.getContent());r.close("div");r.close("div");};
C.renderItems=function(r,c){r.openStart("div");r.class("sapMContainerWrapper");r.openEnd();r.renderControl(c._oItemsContainer);r.close("div");};
return C;});
sap.ui.predefine('sap/m/table/Item',["sap/m/table/ItemBase"],function(I){"use strict";
var a=I.extend("sap.m.table.Item",{metadata:{library:"sap.m",properties:{label:{type:"string"},icon:{type:"sap.ui.core.URI"},showResetButton:{type:"boolean",defaultValue:true},resetButtonEnabled:{type:"boolean",defaultValue:true},showConfirmButton:{type:"boolean",defaultValue:true},showCancelButton:{type:"boolean",defaultValue:true}},aggregations:{content:{type:"sap.ui.core.Control",multiple:false}},events:{reset:{},confirm:{},cancel:{}}}});
a.prototype.setShowResetButton=function(s){this.setProperty("showResetButton",s);this.changeButtonSettings({reset:{visible:s}});return this;};
a.prototype.setResetButtonEnabled=function(r){this.setProperty("resetButtonEnabled",r);this.changeButtonSettings({reset:{enabled:r}});return this;};
a.prototype.setShowConfirmButton=function(s){this.setProperty("showConfirmButton",s);this.changeButtonSettings({confirm:{visible:s}});return this;};
a.prototype.setShowCancelButton=function(s){this.setProperty("showCancelButton",s);this.changeButtonSettings({cancel:{visible:s}});return this;};
return a;});
sap.ui.predefine('sap/m/table/ItemBase',["sap/m/table/ColumnMenuEntry"],function(C){"use strict";
var I=C.extend("sap.m.table.ItemBase",{metadata:{"abstract":true,library:"sap.m"}});
I.prototype.init=function(){this._oButtonSettings={reset:{visible:true,enabled:true},confirm:{visible:true,enabled:true},cancel:{visible:true,enabled:true}};};
I.prototype.getEffectiveItems=function(){return[this];};
I.prototype.getIcon=function(){if(this.getMetadata().hasProperty("icon")){return this.getProperty("icon");}throw new Error(this+" does not implement #getIcon");};
I.prototype.onPress=function(e){};
I.prototype.onBack=function(e){};
I.prototype.onConfirm=function(e){};
I.prototype.onCancel=function(e){};
I.prototype.onReset=function(e){};
I.prototype.getButtonSettings=function(){return this._oButtonSettings;};
I.prototype.changeButtonSettings=function(b){Object.keys(b).forEach(function(B){if(this._oButtonSettings.hasOwnProperty(B)){Object.keys(b[B]).forEach(function(s){this._oButtonSettings[B][s]=b[B][s];},this);}},this);this.getMenu()&&this.getMenu()._updateButtonState(this);};
return I;});
sap.ui.predefine('sap/m/table/QuickAction',["sap/m/table/QuickActionBase"],function(Q){"use strict";
var a=Q.extend("sap.m.table.QuickAction",{metadata:{library:"sap.m",properties:{label:{type:"string"}},aggregations:{content:{type:"sap.ui.core.Control",multiple:false}}}});
return a;});
sap.ui.predefine('sap/m/table/QuickActionBase',["sap/m/table/ColumnMenuEntry"],function(C){"use strict";
var Q=C.extend("sap.m.table.QuickActionBase",{metadata:{"abstract":true,library:"sap.m"}});
Q.prototype.getEffectiveQuickActions=function(){return[this];};
return Q;});
sap.ui.predefine('sap/m/table/Util',["sap/m/library","sap/ui/core/Core","sap/ui/core/theming/Parameters"],function(M,C,T){"use strict";var U={};var d="";var b=parseFloat(M.BaseFontSize);U.measureText=(function(){var e=0.05;var c=document.createElement("canvas").getContext("2d");var s=function(){d=[parseFloat(T.get({name:"sapMFontMediumSize"})||"0.875rem")*b+"px",T.get({name:"sapUiFontFamily"})||"Arial"].join(" ");return d;};C.attachThemeChanged(s);return function(t,f){c.font=f||d||s();return c.measureText(t||"").width/b+e;};})();U.calcTypeWidth=(function(){var B=0;var D=[2023,9,26,22,47,58,999];var u=new Date(Date.UTC.apply(0,D));var l=new(Function.prototype.bind.apply(Date,[null].concat(D)))();var n={Byte:3,SByte:3,Int16:5,Int32:9,Int64:12,Single:6,Float:12,Double:13,Decimal:15};C.attachThemeChanged(function(){B=0;});return function(t,s){var a=t.getMetadata().getName().split(".").pop();if(a=="Boolean"){if(!B){var r=C.getLibraryResourceBundle("sap.ui.core");var y=U.measureText(r.getText("YES"));var N=U.measureText(r.getText("NO"));B=Math.max(y,N);}return B;}if(a=="String"||t.isA("sap.ui.model.odata.type.String")){var m=s&&s.maxWidth||19;var i=t.getConstraints().maxLength||0;if(!i){return Math.max(Math.min(10,m),m*0.75);}if(i*0.25>m){return m;}var S=U.measureText("A".repeat(i));if(i<m||m<10){return Math.min(S,m);}var w=Math.log(S-m*0.16)/Math.log(m/3)*(m/2)*Math.pow(m/19,1/S);return Math.min(w,S,m);}if(a.startsWith("Date")||a.startsWith("Time")){var o=t.getFormatOptions().UTC?u:l;var c=o.toLocaleDateString();if(a=="TimeOfDay"){c=new Intl.DateTimeFormat('de',{hour:'numeric',minute:'numeric',second:'numeric'}).format(o);c=t.formatValue(c,"string");}else if(t.isA("sap.ui.model.odata.type.Time")){c=t.formatValue({__edmType:"Edm.Time",ms:u.valueOf()},"string");}else{c=t.formatValue(o,"string");}return U.measureText(c);}if(n[a]){var e=t.getConstraints().scale||0;var p=t.getConstraints().precision||20;p=Math.min(p,n[a]);var f=2*Math.pow(10,p-e-1);f=t.formatValue(f,"string");return U.measureText(f);}return s&&s.defaultWidth||8;};})();U.calcHeaderWidth=(function(){var h="";var g=function(){if(!h){h=[T.get({name:"sapUiColumnHeaderFontWeight"})||"normal",d].join(" ");}return h;};C.attachThemeChanged(function(){h="";});return function(H,c,m,i){var a=H.length;m=m||19;i=i||2;if(c>m){return m;}if(i>a){return i;}c=Math.max(c,i);if(c>a){return c;}var o=U.measureText(H,g());o=Math.min(o,m*0.7);var f=Math.max(1,1-(Math.log(Math.max(c-1.7,0.2))/Math.log(m*0.5))+1);var e=f*c;var j=Math.max(0,o-e);var k=(j<0.15)?o:e+j*(1-1/c)/Math.E;return k;};})();return U;});
sap.ui.predefine('sap/m/upload/UploadSet',["sap/ui/core/Control","sap/ui/core/Icon","sap/ui/events/KeyCodes","sap/base/Log","sap/base/util/deepEqual","sap/m/library","sap/m/Button","sap/m/Dialog","sap/m/List","sap/m/MessageBox","sap/m/OverflowToolbar","sap/m/StandardListItem","sap/m/Text","sap/m/ToolbarSpacer","sap/ui/unified/FileUploader","sap/m/upload/UploadSetItem","sap/m/upload/Uploader","sap/m/upload/UploadSetRenderer","sap/m/upload/UploaderHttpRequestMethod"],function(C,I,K,L,d,M,B,D,a,b,O,S,T,c,F,U,e,R,f){"use strict";
var g=C.extend("sap.m.upload.UploadSet",{
metadata:{library:"sap.m",properties:{fileTypes:{type:"string[]",defaultValue:null},maxFileNameLength:{type:"int",defaultValue:null},maxFileSize:{type:"float",defaultValue:null},mediaTypes:{type:"string[]",defaultValue:null},noDataText:{type:"string",defaultValue:null},noDataDescription:{type:"string",defaultValue:null},instantUpload:{type:"boolean",defaultValue:true},showIcons:{type:"boolean",defaultValue:true},terminationEnabled:{type:"boolean",defaultValue:true},uploadEnabled:{type:"boolean",defaultValue:true},uploadUrl:{type:"string",defaultValue:null},httpRequestMethod:{type:"sap.m.upload.UploaderHttpRequestMethod",defaultValue:f.Post}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.upload.UploadSetItem",multiple:true,singularName:"item"},incompleteItems:{type:"sap.m.upload.UploadSetItem",multiple:true,singularName:"incompleteItem"},headerFields:{type:"sap.ui.core.Item",multiple:true,singularName:"headerField"},toolbar:{type:"sap.m.OverflowToolbar",multiple:false},uploader:{type:"sap.m.upload.Uploader",multiple:false}},events:{afterItemAdded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},afterItemRemoved:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},afterItemEdited:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},beforeItemAdded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},beforeItemRemoved:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},beforeItemEdited:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},beforeUploadStarts:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},uploadCompleted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"},response:{type:"string"},readyState:{type:"string"},status:{type:"string"},responseXML:{type:"string"},headers:{type:"object"}}},beforeUploadTermination:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},uploadTerminated:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},fileTypeMismatch:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},fileNameLengthExceeded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},fileSizeExceeded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},mediaTypeMismatch:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},selectionChanged:{parameters:{items:{type:"sap.m.upload.UploadSetItem[]"}}}}},
renderer:R
});
var h=M.UploadState;
g.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oList=null;this._oNoDataIcon=new I(this.getId()+"-no-data-icon",{src:"sap-icon://document",size:"6rem",noTabStop:true});this._oEditedItem=null;this._oItemToBeDeleted=null;this._mListItemIdToItemMap={};this._$Body=null;this._$DragDropArea=null;this._oLastEnteredTarget=null;};
g.prototype.exit=function(){this._unbindDragAndDrop();this._oNoDataIcon.destroy();this._oNoDataIcon=null;};
g.prototype.onBeforeRendering=function(){this._unbindDragAndDrop();};
g.prototype.onAfterRendering=function(){var i;if(this._oEditedItem){i=this._oEditedItem._getFileNameEdit().$("inner");if(i){i.on("focus",function(){i.selectText(0,i.val().length);});i.trigger("focus");}}this._bindDragAndDrop();};
g.prototype.onkeydown=function(E){var l,i;if(this._oEditedItem&&this._oEditedItem._getFileNameEdit().$("inner")[0]===E.target){i=this._oEditedItem;}else if(E.target){l=sap.ui.getCore().byId(E.target.id);if(l){i=this._mListItemIdToItemMap[l.getId()];}}if(!i){return;}switch(E.keyCode){case K.F2:if(i._bInEditMode){this._handleItemEditConfirmation(E,i);}else{this._handleItemEdit(E,i);}break;case K.ESCAPE:this._handleItemEditCancelation(E,i);break;case K.DELETE:if(!i.$("fileNameEdit").hasClass("sapMInputFocused")){this._handleItemDelete(E,i);}break;case K.ENTER:if(i===this._oEditedItem){this._handleItemEditConfirmation(E,i);}else{i._handleFileNamePressed();}break;default:return;}};
g.prototype.getToolbar=function(){if(!this._oToolbar){this._oToolbar=this.getAggregation("toolbar");if(!this._oToolbar){this._oToolbar=new O(this.getId()+"-toolbar",{content:[this._oNumberOfAttachmentsTitle,new c(),this.getDefaultFileUploader()]});this.addDependent(this._oToolbar);}else{this._oToolbar.addContent(this.getDefaultFileUploader());}}return this._oToolbar;};
g.prototype.getNoDataText=function(){var n=this.getProperty("noDataText");n=n||this._oRb.getText("UPLOAD_SET_NO_DATA_TEXT");return n;};
g.prototype.getNoDataDescription=function(){var n=this.getProperty("noDataDescription");n=n||this._oRb.getText("UPLOADCOLLECTION_NO_DATA_DESCRIPTION");return n;};
g.prototype.setToolbar=function(t){this.setAggregation("toolbar",t);this.getToolbar();return this;};
g.prototype.addAggregation=function(A,o,s){C.prototype.addAggregation.call(this,A,o,s);if(o&&(A==="items"||A==="incompleteItems")){this._projectToNewListItem(o);this._refreshInnerListStyle();}};
g.prototype.insertAggregation=function(A,o,i,s){C.prototype.insertAggregation.call(this,A,o,i,s);if(o&&(A==="items"||A==="incompleteItems")){this._projectToNewListItem(o,i||0);this._refreshInnerListStyle();}};
g.prototype.removeAggregation=function(A,o,s){var l;C.prototype.removeAggregation.call(this,A,o,s);if(o&&(A==="items"||A==="incompleteItems")){l=o._getListItem();var i=this.getList().removeAggregation("items",l,s);if(i&&o){o.destroy();i.destroy();}this._refreshInnerListStyle();}};
g.prototype.removeAllAggregation=function(A,s){if(A==="items"){this.getItems().forEach(function(i){this.getList().removeAggregation("items",i._getListItem(),s);}.bind(this));}else if(A==="incompleteItems"){this.getIncompleteItems().forEach(function(i){this.getList().removeAggregation("items",i._getListItem(),s);}.bind(this));}C.prototype.removeAllAggregation.call(this,A,s);};
g.prototype.destroyAggregation=function(A,s){if(A==="items"||A==="incompleteItems"){this.removeAllAggregation(A,s);}if(this.getList().getItems().length===0){this.getList().destroyAggregation("items",s);}C.prototype.destroyAggregation.call(this,A,s);};
g.prototype.setFileTypes=function(n){var t=n||null;if(typeof t==="string"){t=t.split(",");}t=(t||[]).map(function(s){return s?s.toLowerCase():"";});if(!d(this.getFileTypes(),t)){this.setProperty("fileTypes",t,true);this._checkRestrictions();}return this;};
g.prototype.setMaxFileNameLength=function(n){if(this.getMaxFileNameLength()!==n){this.setProperty("maxFileNameLength",n,true);this._checkRestrictions();}return this;};
g.prototype.setMaxFileSize=function(n){if(this.getMaxFileSize()!==n){this.setProperty("maxFileSize",n,true);this._checkRestrictions();}return this;};
g.prototype.setMediaTypes=function(n){var t=n||null;if(typeof t==="string"){t=t.split(",");}t=(t||[]).map(function(s){return s?s.toLowerCase():"";});if(!d(this.getMediaTypes(),t)){this.setProperty("mediaTypes",t,true);this._checkRestrictions();}return this;};
g.prototype.setShowIcons=function(s){if(s!==this.getShowIcons()){this._getAllItems().forEach(function(i){i._getIcon().setVisible(s);});this.setProperty("showIcons",s,false);}return this;};
g.prototype.setTerminationEnabled=function(E){if(E!==this.getTerminationEnabled()){this._getAllItems().forEach(function(i){if(i.getUploadState()===h.Uploading){i._getTerminateButton().setVisible(E);}});this.setProperty("terminationEnabled",E,false);}return this;};
g.prototype.setUploadEnabled=function(E){if(E!==this.getUploadEnabled()){this.getDefaultFileUploader().setEnabled(E);this.setProperty("uploadEnabled",E,false);}return this;};
g.prototype.getList=function(){if(!this._oList){this._oList=new a(this.getId()+"-list",{selectionChange:[this._handleSelectionChange,this],headerToolbar:this.getToolbar()});this._oList.addStyleClass("sapMUCList");this.addDependent(this._oList);}return this._oList;};
g.prototype.upload=function(){if(!this.getUploadEnabled()){L.warning("Upload is currently disabled for this upload set.");return;}this.getIncompleteItems().forEach(function(i){this._uploadItemIfGoodToGo(i);}.bind(this));};
g.prototype.uploadItem=function(i){this._uploadItemIfGoodToGo(i);};
g.prototype.getDefaultFileUploader=function(){var t=this._oRb.getText("UPLOADCOLLECTION_UPLOAD");if(!this._oFileUploader){this._oFileUploader=new F(this.getId()+"-uploader",{buttonOnly:true,buttonText:t,tooltip:t,iconOnly:false,enabled:this.getUploadEnabled(),fileType:this.getFileTypes(),mimeType:this.getMediaTypes(),icon:"",iconFirst:false,multiple:true,style:"Transparent",name:"uploadSetFileUploader",sameFilenameAllowed:true,useMultipart:false,sendXHR:true,change:[this._onFileUploaderChange,this],uploadStart:[this._onUploadStarted,this],uploadProgress:[this._onUploadProgressed,this],uploadComplete:[this._onUploadCompleted,this],uploadAborted:[this._onUploadAborted,this],typeMissmatch:[this._fireFileTypeMismatch,this],fileSizeExceed:[this._fireFileSizeExceed,this],filenameLengthExceed:[this._fireFilenameLengthExceed,this]});}return this._oFileUploader;};
g.prototype.registerUploaderEvents=function(u){u.attachUploadStarted(this._onUploadStarted.bind(this));u.attachUploadProgressed(this._onUploadProgressed.bind(this));u.attachUploadCompleted(this._onUploadCompleted.bind(this));u.attachUploadAborted(this._onUploadAborted.bind(this));};
g.prototype._onFileUploaderChange=function(E){var o=E.getParameter("files");this._processNewFileObjects(o);};
g.prototype._onUploadStarted=function(E){var i=E.getParameter("item");i.setUploadState(h.Uploading);};
g.prototype._onUploadProgressed=function(E){var i=E.getParameter("item"),p=Math.round(E.getParameter("loaded")/E.getParameter("total")*100);i.setProgress(p);};
g.prototype._onUploadCompleted=function(E){var i=E.getParameter("item"),r=E.getParameter("responseXHR"),s=null;if(r.responseXML){s=r.responseXML.documentElement.textContent;}var x={"item":i,"response":r.response,"responseXML":s,"readyState":r.readyState,"status":r.status,"headers":r.headers};i.setProgress(100);this.insertItem(i,0);i.setUploadState(h.Complete);this.fireUploadCompleted(x);};
g.prototype._onUploadAborted=function(E){var i=E.getParameter("item");i.setUploadState(h.Error);this.fireUploadTerminated({item:i});};
g.prototype._handleItemEdit=function(E,i){if(this._oEditedItem){this._handleItemEditConfirmation(E,this._oEditedItem);}if(!this._oEditedItem){if(this.fireBeforeItemEdited({item:i})){this._oEditedItem=i;this._oEditedItem._setInEditMode(true);}}};
g.prototype._handleItemRestart=function(E,i){i.setUploadState(h.Ready);this._uploadItemIfGoodToGo(i);};
g.prototype._handleItemEditConfirmation=function(E,i){var o=i._getFileNameEdit(),n,N,s=i.getFileName(),j=U._splitFileName(s);n=o.getValue().trim();if(!n||n.length===0){i._setContainsError(true);return;}if(j.name!==n){N=j.extension?n+"."+j.extension:n;i.setFileName(N);}i._setContainsError(false);i._setInEditMode(false);this.fireAfterItemEdited({item:i});this._oEditedItem=null;};
g.prototype._handleItemEditCancelation=function(E,i){i._setContainsError(false);i._setInEditMode(false);this._oEditedItem=null;};
g.prototype._handleItemDelete=function(E,i){var m;if(this._oEditedItem){this._handleItemEditConfirmation(E,this._oEditedItem);if(this._oEditedItem){return;}}if(!i.fireRemovePressed({item:i})){return;}if(!this.fireBeforeItemRemoved({item:i})){return;}if(!i.getFileName()){m=this._oRb.getText("UPLOAD_SET_DELETE_WITHOUT_FILE_NAME_TEXT");}else{m=this._oRb.getText("UPLOAD_SET_DELETE_TEXT",i.getFileName());}this._oItemToBeDeleted=i;b.show(m,{id:this.getId()+"-deleteDialog",title:this._oRb.getText("UPLOAD_SET_DELETE_TITLE"),actions:[b.Action.OK,b.Action.CANCEL],onClose:this._handleClosedDeleteDialog.bind(this),dialogId:"messageBoxDeleteFile",styleClass:this.hasStyleClass("sapUiSizeCompact")?"sapUiSizeCompact":""});};
g.prototype._handleClosedDeleteDialog=function(A){if(A!==b.Action.OK){return;}this.removeItem(this._oItemToBeDeleted);this.removeIncompleteItem(this._oItemToBeDeleted);this.fireAfterItemRemoved({item:this._oItemToBeDeleted});this._oItemToBeDeleted=null;};
g.prototype._handleTerminateRequest=function(i,o){var j=new a({items:[new S({title:o.getFileName(),icon:o._getIcon().getSrc()})]}),k=new D({id:this.getId()+"-teminateDialog",title:this._oRb.getText("UPLOAD_SET_TERMINATE_TITLE"),content:[new T({text:this._oRb.getText("UPLOAD_SET_TERMINATE_TEXT")}),j],buttons:[new B({text:this._oRb.getText("UPLOAD_SET_OKBUTTON_TEXT"),press:[l,this]}),new B({text:this._oRb.getText("UPLOAD_SET_CANCEL_BUTTON_TEXT"),press:function(){k.close();}})],afterClose:function(){k.destroy();}});k.open();function l(){if(o.getUploadState()===h.Uploading){if(this.fireBeforeUploadTermination({item:o})){this._handleUploadTermination(o);}}else if(o.getUploadState()===h.Complete){this.removeItem(o);}k.close();this.invalidate();}};
g.prototype._handleUploadTermination=function(i){this._getActiveUploader().terminateItem(i);};
g.prototype._handleSelectionChange=function(E){var l=E.getParameter("listItems"),i=[];l.forEach(function(o){i.push(this._mListItemIdToItemMap[o.getId()]);}.bind(this));this.fireSelectionChanged({items:i});};
g.prototype._onDragEnterSet=function(E){if(E.target===this._$DragDropArea[0]&&this.getUploadEnabled()){this._$DragDropArea.addClass("sapMUCDropIndicator");}};
g.prototype._onDragLeaveSet=function(E){if(E.target===this._$DragDropArea[0]&&this.getUploadEnabled()){this._$DragDropArea.removeClass("sapMUCDropIndicator");}};
g.prototype._onDragOverSet=function(E){E.preventDefault();};
g.prototype._onDropOnSet=function(E){var o;E.preventDefault();if(E.target===this._$DragDropArea[0]&&this.getUploadEnabled()){this._$DragDropArea.removeClass("sapMUCDropIndicator");this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");o=E.originalEvent.dataTransfer.files;this._processNewFileObjects(o);}};
g.prototype._onDragEnterBody=function(E){if(this.getUploadEnabled()){this._oLastEnteredTarget=E.target;this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");}};
g.prototype._onDragLeaveBody=function(E){if(this._oLastEnteredTarget===E.target&&this.getUploadEnabled()){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");}};
g.prototype._onDragOverBody=function(E){E.preventDefault();if(this.getUploadEnabled()){this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");}};
g.prototype._onDropOnBody=function(E){if(this.getUploadEnabled()){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");}};
g.prototype._getAllItems=function(){return this.getItems().concat(this.getIncompleteItems());};
g.prototype._refreshInnerListStyle=function(){var m=this.getList().length-1;this._oList.getItems().forEach(function(l,i){l.removeStyleClass("sapMUCListSingleItem").removeStyleClass("sapMUCListFirstItem").removeStyleClass("sapMUCListLastItem").removeStyleClass("sapMUCListItem");if(i===0&&m===0){l.addStyleClass("sapMUCListSingleItem");}else if(i===0){l.addStyleClass("sapMUCListFirstItem");}else if(i===m){l.addStyleClass("sapMUCListLastItem");}else{l.addStyleClass("sapMUCListItem");}});};
g.prototype._processNewFileObjects=function(o){var j=[],k;for(var i=0;i<o.length;i++){j.push(o[i]);}j.forEach(function(l){k=new U({uploadState:h.Ready});k._setFileObject(l);k.setFileName(l.name);if(!this.fireBeforeItemAdded({item:k})){return;}this.insertIncompleteItem(k);this.fireAfterItemAdded({item:k});if(this.getInstantUpload()){this._uploadItemIfGoodToGo(k);}}.bind(this));};
g.prototype._projectToNewListItem=function(i,j){var l=i._getListItem();this._mListItemIdToItemMap[l.getId()]=i;if(j||j===0){this.getList().insertAggregation("items",l,j,true);}else{this.getList().addAggregation("items",l,true);}this._checkRestrictionsForItem(i);};
g.prototype._getImplicitUploader=function(){if(!this._oUploader){this._oUploader=new e({httpRequestMethod:this.getHttpRequestMethod()});this._oUploader.setUploadUrl(this.getUploadUrl());this.registerUploaderEvents(this._oUploader);this.addDependent(this._oUploader);}return this._oUploader;};
g.prototype._getActiveUploader=function(){return this.getUploader()||this._getImplicitUploader();};
g.prototype._uploadItemIfGoodToGo=function(i){if(i.getUploadState()===h.Ready&&!i._isRestricted()){if(this.fireBeforeUploadStarts({item:i})){var H=i.getHeaderFields().length?i.getHeaderFields():this.getHeaderFields();this._getActiveUploader().uploadItem(i,H);}}};
g.prototype._getDragDropHandlers=function(){if(!this._oDragDropHandlers){this._oDragDropHandlers={body:{"dragenter":this._onDragEnterBody.bind(this),"dragleave":this._onDragLeaveBody.bind(this),"dragover":this._onDragOverBody.bind(this),"drop":this._onDropOnBody.bind(this)},set:{"dragenter":this._onDragEnterSet.bind(this),"dragleave":this._onDragLeaveSet.bind(this),"dragover":this._onDragOverSet.bind(this),"drop":this._onDropOnSet.bind(this)}};}return this._oDragDropHandlers;};
g.prototype._bindDragAndDrop=function(){this._$Body=jQuery(document.body);Object.keys(this._getDragDropHandlers().body).forEach(function(E){this._$Body.on(E,this._getDragDropHandlers().body[E]);}.bind(this));this._$DragDropArea=this.$("drag-drop-area");Object.keys(this._getDragDropHandlers().set).forEach(function(E){this.$().on(E,this._getDragDropHandlers().set[E]);}.bind(this));};
g.prototype._unbindDragAndDrop=function(){if(this._$Body){Object.keys(this._getDragDropHandlers().body).forEach(function(E){this._$Body.off(E,this._getDragDropHandlers().body[E]);}.bind(this));}Object.keys(this._getDragDropHandlers().set).forEach(function(E){this.$().off(E,this._getDragDropHandlers().set[E]);}.bind(this));};
g.prototype._checkRestrictions=function(){this.getIncompleteItems().forEach(function(i){this._checkRestrictionsForItem(i);}.bind(this));};
g.prototype._checkRestrictionsForItem=function(i){i._checkTypeRestriction(this.getFileTypes());i._checkNameLengthRestriction(this.getMaxFileNameLength());i._checkSizeRestriction(this.getMaxFileSize());i._checkMediaTypeRestriction(this.getMediaTypes());};
g.prototype._fireFileTypeMismatch=function(i){var m=this.getMediaTypes();var j=this.getFileTypes();var s=i.getParameter("fileType");var k=i.getParameter("mimeType");var l=(!!m&&(m.length>0)&&!!k&&m.indexOf(k)===-1);var n=(!!j&&(j.length>0)&&!!s&&j.indexOf(s)===-1);if(l){this.fireMediaTypeMismatch({item:i});}else if(n){this.fireFileTypeMismatch({item:i});}};
g.prototype._fireFileSizeExceed=function(i){this.fireFileSizeExceeded({item:i});};
g.prototype._fireFilenameLengthExceed=function(i){this.fireFileNameLengthExceeded({item:i});};
return g;});
sap.ui.predefine('sap/m/upload/UploadSetItem',["sap/base/Log","sap/ui/core/library","sap/ui/core/Element","sap/ui/core/Icon","sap/ui/core/IconPool","sap/ui/core/HTML","sap/ui/core/util/File","sap/m/library","sap/m/BusyIndicator","sap/m/Button","sap/m/CustomListItem","sap/m/Image","sap/m/Input","sap/m/Label","sap/m/Link","sap/m/ProgressIndicator","sap/m/VBox","sap/m/HBox"],function(L,C,E,I,a,H,F,M,B,b,c,d,e,f,g,P,V,h){"use strict";
var U=E.extend("sap.m.upload.UploadSetItem",{metadata:{library:"sap.m",properties:{enabledRemove:{type:"boolean",defaultValue:true},enabledEdit:{type:"boolean",defaultValue:true},fileName:{type:"string",defaultValue:null},mediaType:{type:"string",defaultValue:null},thumbnailUrl:{type:"string",defaultValue:null},uploadState:{type:"sap.m.UploadState",defaultValue:null},url:{type:"string",defaultValue:null},visibleRemove:{type:"boolean",defaultValue:true},visibleEdit:{type:"boolean",defaultValue:true},uploadUrl:{type:"string",defaultValue:null}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},markers:{type:"sap.m.ObjectMarker",multiple:true,singularName:"marker"},statuses:{type:"sap.m.ObjectStatus",multiple:true,singularName:"status"},headerFields:{type:"sap.ui.core.Item",multiple:true,singularName:"headerField"}},events:{openPressed:{item:{type:"sap.m.upload.UploadSetItem"},allowPreventDefault:true},removePressed:{item:{type:"sap.m.upload.UploadSetItem"},allowPreventDefault:true}}}});
var j=M.UploadState,k=M.FlexJustifyContent,l=C.ValueState;
var D=H.extend("sap.m.upload.DynamicItemContent",{
metadata:{library:"sap.m",properties:{item:{type:"sap.m.upload.UploadSetItem"}}},
renderer:{apiVersion:2,render:function(r,o){var i=o.getItem();r.openStart("div");r.class("sapMUCTextContainer");if(this._bInEditMode){r.class("sapMUCEditMode");}r.openEnd();r.openStart("div").class("sapMUSTextInnerContainer").openEnd();r.renderControl(i._bInEditMode?i._getFileNameEdit():i._getFileNameLink());i._renderMarkers(r);r.close("div");i._renderAttributes(r);i._renderStatuses(r);r.close("div");i._renderStateAndProgress(r);i._renderButtons(r);}}
});
U.MEGABYTE=1048576;U.IMAGE_FILE_ICON="sap-icon://card";
U.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oListItem=null;this._oIcon=null;this._oFileNameLink=null;this._oFileNameEdit=null;this._oDynamicContent=null;this._oRestartButton=null;this._oEditButton=null;this._oDeleteButton=null;this._oTerminateButton=null;this._oConfirmRenameButton=null;this._oCancelRenameButton=null;this._oProgressBox=null;this._oProgressIndicator=null;this._oStateLabel=null;this._oProgressLabel=null;this._oFileObject=null;this._fFileSize=null;this._bInEditMode=false;this._bContainsError=false;this._bFileTypeRestricted=false;this._bNameLengthRestricted=false;this._bSizeRestricted=false;this._bMediaTypeRestricted=false;};
U.prototype.setFileName=function(s){var o;if(this.getFileName()!==s){this.setProperty("fileName",s,true);if(this.getParent()){this._getFileNameLink().setText(s);o=U._splitFileName(s);this._getFileNameEdit().setValue(o.name);this._checkNameLengthRestriction(this.getParent().getMaxFileNameLength());this._checkTypeRestriction(this.getParent().getFileTypes());}}return this;};
U.prototype.setUploadState=function(u){var i=this._getProgressIndicator(),s=this._getStateLabel(),m=(u!==j.Complete),n=(u===j.Uploading);this.setProperty("uploadState",u,true);i.setVisible(m);s.setVisible(m);this._getProgressLabel().setVisible(m);switch(u){case j.Complete:i.setState(l.None);s.setText("");break;case j.Error:i.setState(l.Error);s.setText(this._oRb.getText("UPLOAD_SET_ITEM_ERROR_STATE"));break;case j.Ready:i.setState(l.None);s.setText(this._oRb.getText("UPLOAD_SET_ITEM_READY_STATE"));break;case j.Uploading:i.setState(l.Information);s.setText(this._oRb.getText("UPLOAD_SET_ITEM_UPLOADING_STATE"));break;}if(this.getParent()){this._getRestartButton().setVisible(u===j.Error);if(this.getVisibleEdit()){this._getEditButton().setVisible(!n);}if(this.getVisibleRemove()){this._getDeleteButton().setVisible(!n);}this._getTerminateButton().setVisible(this.getParent().getTerminationEnabled()&&n);}return this;};
U.prototype.setEnabledRemove=function(i){if(this.getEnabledRemove()!==i){this.setProperty("enabledRemove",i,true);if(this.getParent()){this._getDeleteButton().setEnabled(i);}}return this;};
U.prototype.setVisibleRemove=function(v){if(this.getVisibleRemove()!==v){this.setProperty("visibleRemove",v,true);if(this.getParent()){this._getDeleteButton().setVisible(v);}}return this;};
U.prototype.setEnabledEdit=function(i){if(this.getEnabledEdit()!==i){this.setProperty("enabledEdit",i,true);if(this.getParent()){this._getEditButton().setEnabled(i);}}return this;};
U.prototype.setVisibleEdit=function(v){if(this.getVisibleEdit()!==v){this.setProperty("visibleEdit",v,true);if(this.getParent()){this._getEditButton().setVisible(v);}}return this;};
U.prototype.setThumbnailUrl=function(u){if(this.getThumbnailUrl()!=u){this.setProperty("thumbnailUrl",u,true);if(this._oListItem&&u){for(var i=0;i<this._oListItem.getContent().length;i++){if(this._oListItem.getContent()[i]instanceof sap.ui.core.Icon||this._oListItem.getContent()[i]instanceof sap.m.Image){var o=this._oListItem.getContent()[i];this._oListItem.removeContent(o);if(this._oIcon){this._oIcon.destroy();this._oIcon=null;}this._oIcon=a.createControlByURI({id:this.getId()+"-thumbnail",src:u,decorative:false},d);this._oIcon.addStyleClass("sapMUCItemImage sapMUCItemIcon");this._oListItem.insertContent(this._oIcon,0);}}}}return this;};
U.prototype.getFileObject=function(){return this._oFileObject;};
U.prototype.getListItem=function(){return this._getListItem();};
U.prototype.setProgress=function(p){var $;this._getProgressLabel().setText(p+"%");$=this.$("-busyIndicator");if(p===100){$.attr("aria-label",this._oRb.getText("UPLOAD_SET_UPLOAD_COMPLETED"));}else{$.attr("aria-valuenow",p);}this._getProgressIndicator().setPercentValue(p);return this;};
U.prototype.download=function(A){var p=this.getParent();if(!p){L.warning("Download cannot proceed without a parent association.");return false;}return p._getActiveUploader().downloadItem(this,[],A);};
U.prototype.isRestricted=function(){return this._isRestricted();};
U.prototype._handleFileNamePressed=function(){if(this.fireOpenPressed({item:this})){M.URLHelper.redirect(this.getUrl(),true);}};
U.prototype._getListItem=function(){if(!this._oListItem){this._oListItem=new c(this.getId()+"-listItem",{content:[this._getIcon(),this._getDynamicContent()]});this._oListItem.addStyleClass("sapMUCItem");}return this._oListItem;};
U.prototype._setFileObject=function(o){this._oFileObject=o;if(o){this._fFileSize=o.size/U.MEGABYTE;this.setMediaType(o.type);}else{this._fFileSize=null;this.setMediaType(null);}if(this.getParent()){this._checkSizeRestriction(this.getParent().getMaxFileSize());this._checkMediaTypeRestriction(this.getParent().getMediaTypes());}};
U.prototype._getIcon=function(){if(!this._oIcon){if(this.getThumbnailUrl()){this._oIcon=a.createControlByURI({id:this.getId()+"-thumbnail",src:this.getThumbnailUrl(),decorative:false},d);this._oIcon.addStyleClass("sapMUCItemImage sapMUCItemIcon");}else{this._oIcon=new I(this.getId()+"-icon",{src:this._getIconByMimeType(this.getMediaType())});this._oIcon.addStyleClass("sapMUCItemIcon");}this.addDependent(this._oIcon);}return this._oIcon;};
U.prototype._getIconByMimeType=function(m){var i=["image/png","image/tiff","image/bmp","image/jpeg","image/gif"];if(m){if(i.indexOf(m)===-1){return a.getIconForMimeType(m);}return this._getIconByFileType();}else{return this._getIconByFileType();}};
U.prototype._getIconByFileType=function(){var s=U._splitFileName(this.getFileName()).extension;if(!s){return"";}switch(s.toLowerCase()){case"bmp":case"jpg":case"jpeg":case"png":return U.IMAGE_FILE_ICON;case"csv":case"xls":case"xlsx":return"sap-icon://excel-attachment";case"doc":case"docx":case"odt":return"sap-icon://doc-attachment";case"pdf":return"sap-icon://pdf-attachment";case"ppt":case"pptx":return"sap-icon://ppt-attachment";case"txt":return"sap-icon://document-text";default:return"sap-icon://document";}};
U.prototype._getFileNameLink=function(){if(!this._oFileNameLink){this._oFileNameLink=new g({id:this.getId()+"-fileNameLink",press:[this,this._handleFileNamePressed,this]});this._oFileNameLink.setText(this.getFileName());this._oFileNameLink.addStyleClass("sapMUCFileName");this._oFileNameLink.addStyleClass("sapMUSFileName");this.addDependent(this._oFileNameLink);}this._oFileNameLink.setEnabled(!!this.getUrl());return this._oFileNameLink;};
U.prototype._getDynamicContent=function(){if(!this._oDynamicContent){this._oDynamicContent=new D({item:this});this.addDependent(this._oDynamicContent);}return this._oDynamicContent;};
U.prototype._getRestartButton=function(){var p=this.getParent();if(!this._oRestartButton){this._oRestartButton=new b({id:this.getId()+"-restartButton",icon:"sap-icon://refresh",type:M.ButtonType.Standard,visible:this.getUploadState()===j.Error,tooltip:this._oRb.getText("UPLOAD_SET_RESTART_BUTTON_TEXT"),press:[this,p._handleItemRestart,p]});this.addDependent(this._oRestartButton);}return this._oRestartButton;};
U.prototype._getEditButton=function(){var p=this.getParent();if(!this._oEditButton){this._oEditButton=new b({id:this.getId()+"-editButton",icon:"sap-icon://edit",type:M.ButtonType.Standard,enabled:this.getEnabledEdit(),visible:this.getVisibleEdit(),tooltip:this._oRb.getText("UPLOAD_SET_EDIT_BUTTON_TEXT"),press:[this,p._handleItemEdit,p]});this._oEditButton.addStyleClass("sapMUCEditBtn");this.addDependent(this._oEditButton);}return this._oEditButton;};
U.prototype._getFileNameEdit=function(){var s;if(!this._oFileNameEdit){s=U._splitFileName(this.getFileName());this._oFileNameEdit=new e({id:this.getId()+"-fileNameEdit",type:M.InputType.Text});this._oFileNameEdit.addStyleClass("sapMUCEditBox");this._oFileNameEdit.setFieldWidth("75%");this._oFileNameEdit.setDescription(s.extension);this._updateFileNameEdit();this.addDependent(this._oFileNameEdit);}return this._oFileNameEdit;};
U.prototype._updateFileNameEdit=function(){var o=this._getFileNameEdit();if(this._bContainsError){o.setValueState(l.Error);o.setValueStateText("");o.setShowValueStateMessage(true);}else{o.setValueState(l.None);if(o.getValue().length===0){o.setValueStateText(this._oRb.getText("UPLOAD_SET_TYPE_FILE_NAME"));}else{o.setValueStateText(this._oRb.getText("UPLOAD_SET_FILE_NAME_EXISTS"));}o.setShowValueStateMessage(false);}};
U.prototype._setInEditMode=function(i){if(i&&!this._bInEditMode){var s=U._splitFileName(this.getFileName());this._getFileNameEdit().setValue(s.name);}this._bInEditMode=i;this._setContainsError(false);this.invalidate();};
U.prototype._getContainsError=function(){return this._bContainsError;};
U.prototype._setContainsError=function(i){this._bContainsError=i;this._updateFileNameEdit();};
U._splitFileName=function(s,w){var r={};var R=/(?:\.([^.]+))?$/;var i=R.exec(s);if(!i[0]){i[0]="";r.name=s;}else{r.name=s?s.slice(0,s.indexOf(i[0])):"";}if(w){r.extension=i[0];}else{r.extension=i[1];}return r;};
U.prototype._getDeleteButton=function(){var p=this.getParent();if(!this._oDeleteButton){this._oDeleteButton=new b({id:this.getId()+"-deleteButton",icon:"sap-icon://decline",type:M.ButtonType.Standard,enabled:this.getEnabledRemove(),visible:this.getVisibleRemove(),tooltip:this._oRb.getText("UPLOAD_SET_DELETE_BUTTON_TEXT"),press:[this,p._handleItemDelete,p]});this._oDeleteButton.addStyleClass("sapMUCDeleteBtn");this.addDependent(this._oDeleteButton);}return this._oDeleteButton;};
U.prototype._getTerminateButton=function(){var p=this.getParent();if(!this._oTerminateButton){this._oTerminateButton=new b({id:this.getId()+"-terminateButton",icon:"sap-icon://stop",type:M.ButtonType.Standard,visible:p.getTerminationEnabled()&&this.getUploadState()===j.Uploading,tooltip:this._oRb.getText("UPLOAD_SET_TERMINATE_BUTTON_TEXT"),press:[this,p._handleTerminateRequest,p]});this._oTerminateButton.addStyleClass("sapMUCDeleteBtn");this.addDependent(this._oTerminateButton);}return this._oTerminateButton;};
U.prototype._getConfirmRenameButton=function(){var p=this.getParent();if(!this._oConfirmRenameButton){this._oConfirmRenameButton=new b({id:this.getId()+"-okButton",text:this._oRb.getText("UPLOAD_SET_RENAME_BUTTON_TEXT"),type:M.ButtonType.Transparent,press:[this,p._handleItemEditConfirmation,p]});this._oConfirmRenameButton.addStyleClass("sapMUCOkBtn");this.addDependent(this._oConfirmRenameButton);}return this._oConfirmRenameButton;};
U.prototype._getCancelRenameButton=function(){var p=this.getParent();if(!this._oCancelRenameButton){this._oCancelRenameButton=new b({id:this.getId()+"-cancelButton",text:this._oRb.getText("UPLOAD_SET_CANCEL_BUTTON_TEXT"),type:M.ButtonType.Transparent,press:[this,p._handleItemEditCancelation,p]});this._oCancelRenameButton.addStyleClass("sapMUCCancelBtn");this.addDependent(this._oCancelRenameButton);}return this._oCancelRenameButton;};
U.prototype._getProgressBox=function(){if(!this._oProgressBox){this._oProgressBox=new V({id:this.getId()+"-progressBox",items:[this._getProgressIndicator(),new h({justifyContent:k.SpaceBetween,items:[this._getStateLabel(),this._getProgressLabel()]})],width:"20%"});this._oProgressBox.addStyleClass("sapMUSProgressBox");this.addDependent(this._oProgressBox);}return this._oProgressBox;};
U.prototype._getProgressIndicator=function(){if(!this._oProgressIndicator){this._oProgressIndicator=new P({id:this.getId()+"-progressIndicator",percentValue:0,state:l.Information,visible:this.getUploadState()!==j.Complete});this._oProgressIndicator.addStyleClass("sapMUSProgressIndicator");}return this._oProgressIndicator;};
U.prototype._getStateLabel=function(){if(!this._oStateLabel){this._oStateLabel=new f({id:this.getId()+"-stateLabel",text:"Pending",visible:this.getUploadState()!==j.Complete});}return this._oStateLabel;};
U.prototype._getProgressLabel=function(){if(!this._oProgressLabel){this._oProgressLabel=new f({id:this.getId()+"-progressLabel",visible:this.getUploadState()!==j.Complete});this.setProgress(0);this.addDependent(this._oProgressLabel);}return this._oProgressLabel;};
U.prototype._renderAttributes=function(r){var i=this.getAttributes().length-1;if(this.getAttributes().length>0){r.openStart("div").class("sapMUCAttrContainer").openEnd();this.getAttributes().forEach(function(A,m){r.renderControl(A.addStyleClass("sapMUCAttr"));if(m<i&&A.getVisible()){r.openStart("div").class("sapMUCSeparator").openEnd();r.text("\u00a0\u00B7\u00a0").close("div");}});r.close("div");}};
U.prototype._renderMarkers=function(r){if(this.getMarkers().length>0){r.openStart("div").class("sapMUSObjectMarkerContainer").openEnd();this.getMarkers().forEach(function(m){r.renderControl(m.addStyleClass("sapMUCObjectMarker"));});r.close("div");}};
U.prototype._renderStatuses=function(r){var i=this.getStatuses().length-1;if(this.getStatuses().length>0){r.openStart("div").class("sapMUCStatusContainer").openEnd();this.getStatuses().forEach(function(s,m){r.renderControl(s);if(m<i){r.openStart("div").class("sapMUCSeparator").openEnd();r.text("\u00a0\u00B7\u00a0").close("div");}});r.close("div");}};
U.prototype._renderStateAndProgress=function(r){r.renderControl(this._getProgressBox());};
U.prototype._renderButtons=function(r){var i;if(this._bInEditMode){i=[this._getConfirmRenameButton(),this._getCancelRenameButton()];}else{i=[this._getRestartButton(),this._getEditButton(),this._getDeleteButton(),this._getTerminateButton()];}if(i.length>0){r.openStart("div").class("sapMUCButtonContainer").openEnd();i.forEach(function(o,m){if(m<(i.length-1)){o.addStyleClass("sapMUCFirstButton");}r.renderControl(o);});r.close("div");}};
U.prototype._checkTypeRestriction=function(t){var o=U._splitFileName(this.getFileName()),r=(!!this.getFileName()&&!!t&&(t.length>0)&&o.extension&&t.indexOf(o.extension.toLowerCase())===-1);if(r!==this._bFileTypeRestricted){this._bFileTypeRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireFileTypeMismatch({item:this});}}};
U.prototype._checkNameLengthRestriction=function(m){var r=(m&&!!this.getFileName()&&this.getFileName().length>m);if(r!==this._bNameLengthRestricted){this._bNameLengthRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireFileNameLengthExceeded({item:this});}}};
U.prototype._checkSizeRestriction=function(m){var r=(m&&this._fFileSize>m);if(r!==this._bSizeRestricted){this._bSizeRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireFileSizeExceeded({item:this});}}};
U.prototype._checkMediaTypeRestriction=function(t){var r=(!!t&&(t.length>0)&&!!this.getMediaType()&&t.indexOf(this.getMediaType())===-1);if(r!==this._bMediaTypeRestricted){this._bMediaTypeRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireMediaTypeMismatch({item:this});}}};
U.prototype._isRestricted=function(){return this._bFileTypeRestricted||this._bNameLengthRestricted||this._bSizeRestricted||this._bMediaTypeRestricted;};
U.prototype.exit=function(){if(this._oProgressIndicator){this._oProgressIndicator.destroy();this._oProgressIndicator=null;}if(this._oStateLabel){this._oStateLabel.destroy();this._oStateLabel=null;}if(this._oProgressBox){this._oProgressBox.destroy();this._oProgressBox=null;}};
return U;});
sap.ui.predefine('sap/m/upload/UploadSetRenderer',['sap/m/ListItemBaseRenderer'],function(L){"use strict";var U={apiVersion:2};
U.render=function(r,c){r.openStart("div",c);r.class("sapMUC");r.openEnd();this.renderDragDropOverlay(r,c);this.renderList(r,c);r.close("div");};
U.renderDragDropOverlay=function(r,c){r.openStart("div",c.getId()+"-drag-drop-area");r.class("sapMUCDragDropOverlay");r.class("sapMUCDragDropOverlayHide");r.openEnd();r.openStart("div");r.class("sapMUCDragDropIndicator");r.openEnd();r.close("div");r.close("div");};
U.renderList=function(r,c){var o=c.getList().getRenderer().renderNoData;c.getList().getRenderer().renderNoData=this.renderNoData;r.renderControl(c.getList());c.getList().getRenderer().renderNoData=o;};
U.renderNoData=function(r,c){var u=c.getParent();r.openStart("li",u.getList().getId("nodata"));r.attr("tabindex",0);r.class("sapMLIB").class("sapMUCNoDataPage");L.addFocusableClasses.call(L,r);r.openEnd();r.renderControl(u._oNoDataIcon);r.openStart("div",u.getId()+"-no-data-text");r.class("sapMUCNoDataText");r.openEnd();r.text(u.getNoDataText());r.close("div");if(u.getUploadEnabled()){r.openStart("div",u.getId()+"-no-data-description");r.class("sapMUCNoDataDescription");r.openEnd();r.text(u.getNoDataDescription());r.close("div");}r.close("li");};
return U;});
sap.ui.predefine('sap/m/upload/Uploader',["sap/base/Log","sap/m/library","sap/ui/core/Element","sap/ui/core/util/File","sap/ui/Device","sap/ui/core/Item","sap/m/upload/UploadSetItem","sap/m/upload/UploaderHttpRequestMethod"],function(L,M,E,F,D,H,U,a){"use strict";
var b=E.extend("sap.m.upload.Uploader",{metadata:{library:"sap.m",publicMethods:["uploadItem","terminateItem","downloadItem"],properties:{uploadUrl:{type:"string",defaultValue:null},downloadUrl:{type:"string",defaultValue:null},httpRequestMethod:{type:"sap.m.upload.UploaderHttpRequestMethod",defaultValue:a.Post},useMultipart:{type:"boolean",defaultValue:false}},events:{uploadStarted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},uploadProgressed:{parameters:{item:{type:"sap.m.upload.UploadSetItem"},loaded:{type:"int"},total:{type:"int"}}},uploadCompleted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"},responseXHR:{type:"object"}}},uploadAborted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}}}}});
b.prototype.init=function(){this._mRequestHandlers={};};
b.uploadFile=function(f,u,h){var x=new window.XMLHttpRequest();var s=this.getHttpRequestMethod();return new Promise(function(r,c){x.open(s,u,true);if((D.browser.edge||D.browser.internet_explorer)&&f.type&&x.readyState===1){x.setRequestHeader("Content-Type",f.type);}if(h){h.forEach(function(o){x.setRequestHeader(o.getKey(),o.getText());});}x.onreadystatechange=function(){if(this.readyState===window.XMLHttpRequest.DONE){if(this.status===200){r(this);}else{c(this);}}};x.send(f);});};
b.prototype.uploadItem=function(i,h){var x=new window.XMLHttpRequest(),f=i.getFileObject(),t=this,r={xhr:x,item:i},s=this.getHttpRequestMethod(),u=i.getUploadUrl()||this.getUploadUrl();x.open(s,u,true);if((D.browser.edge||D.browser.internet_explorer)&&f.type&&x.readyState===1){x.setRequestHeader("Content-Type",f.type);}if(h){h.forEach(function(c){x.setRequestHeader(c.getKey(),c.getText());});}if(this.getUseMultipart()){var o=new window.FormData();var n=f?f.name:null;if(f instanceof window.Blob&&n){o.append(n,f,f.name);}else{o.append(n,f);}o.append("_charset_","UTF-8");f=o;}x.upload.addEventListener("progress",function(e){t.fireUploadProgressed({item:i,loaded:e.loaded,total:e.total,aborted:false});});x.onreadystatechange=function(){var c=t._mRequestHandlers[i.getId()],R={};if(this.readyState===window.XMLHttpRequest.DONE&&!c.aborted){R={"response":this.response,"responseXML":this.responseXML,"readyState":this.readyState,"status":this.status,"headers":this.getAllResponseHeaders()};t.fireUploadCompleted({item:i,responseXHR:R});}};this._mRequestHandlers[i.getId()]=r;x.send(f);this.fireUploadStarted({item:i});};
b.prototype.terminateItem=function(i){var h=this._mRequestHandlers[i.getId()],t=this;h.xhr.onabort=function(){h.aborted=false;t.fireUploadAborted({item:i});};h.aborted=true;h.xhr.abort();};
b.prototype.downloadItem=function(i,h,A){var u=this.getDownloadUrl()||i.getUrl();if(D.browser.name==="sf"){A=false;}if(!i.getUrl()){L.warning("Items to download do not have a URL.");return false;}else if(A){var B=null,x=new window.XMLHttpRequest();x.open("GET",u);h.forEach(function(o){x.setRequestHeader(o.getKey(),o.getText());});x.responseType="blob";x.onload=function(){var f=i.getFileName(),s=U._splitFileName(f,false);B=x.response;F.save(B,s.name,s.extension,i.getMediaType(),"utf-8");};x.send();return true;}else{M.URLHelper.redirect(u,true);return true;}};
return b;});
sap.ui.predefine('sap/m/upload/UploaderHttpRequestMethod',[],function(){"use strict";var U={Post:"POST",Put:"PUT"};return U;});
sap.ui.predefine('sap/m/Wizard',["sap/m/library","sap/ui/core/Control","sap/ui/core/Core","sap/ui/core/delegate/ScrollEnablement","./WizardProgressNavigator","sap/ui/core/util/ResponsivePaddingsEnablement","sap/ui/Device","./WizardRenderer","sap/ui/core/CustomData","sap/ui/dom/containsOrEquals","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Focusable"],function(l,C,a,S,W,R,D,b,c,d,L,q){"use strict";var e=l.PageBackgroundDesign;var f=l.WizardRenderMode;
var g=C.extend("sap.m.Wizard",{metadata:{library:"sap.m",designtime:"sap/m/designtime/Wizard.designtime",interfaces:["sap.f.IDynamicPageStickyContent"],properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"auto"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},showNextButton:{type:"boolean",group:"Behavior",defaultValue:true},finishButtonText:{type:"string",group:"Appearance",defaultValue:"Review"},enableBranching:{type:"boolean",group:"Behavior",defaultValue:false},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:e.Standard},renderMode:{type:"sap.m.WizardRenderMode",group:"Appearance",defaultValue:f.Scroll}},defaultAggregation:"steps",aggregations:{steps:{type:"sap.m.WizardStep",multiple:true,singularName:"step"},_progressNavigator:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_nextButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{
/**
					 * This association controls the current activated step of the wizard (meaning the last step)
					 * For example if we have A->B->C->D steps, we are on step A and we setCurrentStep(C) A,B and C are going to be activated. D will still remain unvisited.
					 * The parameter needs to be a Wizard step that is part of the current Wizard
					 * @since 1.50
					 */
currentStep:{type:"sap.m.WizardStep",multiple:false}},events:{stepActivate:{parameters:{index:{type:"int"}}},complete:{parameters:{}}},dnd:{draggable:false,droppable:true}}});
g.CONSTANTS={MINIMUM_STEPS:3,MAXIMUM_STEPS:8,ANIMATION_TIME:300,SCROLL_OFFSET:16};R.call(g.prototype,{header:{suffix:"progressNavigator"},content:{suffix:"step-container"}});
g.prototype.init=function(){this._iStepCount=0;this._aStepPath=[];this._bScrollLocked=false;this._oScroller=this._initScrollEnablement();this._oResourceBundle=a.getLibraryResourceBundle("sap.m");this._initProgressNavigator();this._initResponsivePaddingsEnablement();this._iNextButtonHeight=0;};
g.prototype.onBeforeRendering=function(){var s=this._getStartingStep();if(!this._isMinStepCountReached()||this._isMaxStepCountExceeded()){L.error("The Wizard is supposed to handle from 3 to 8 steps.");}this._saveInitialValidatedState();if(s&&this._aStepPath.indexOf(s)<0){this._activateStep(s);s._setNumberInvisibleText(1);}};
g.prototype.onAfterRendering=function(){if(!this.getCurrentStep()){this.setAssociation("currentStep",this._getStartingStep(),true);}var s=this._getCurrentStepInstance();if(s){this._activateAllPreceedingSteps(s);}this._attachScrollHandler();this._renderPageMode();};
g.prototype._renderPageMode=function(s){var i,o,r;if(this.getRenderMode()!==f.Page){return;}if(s){i=this._aStepPath.indexOf(s)+1;o=s;}else{i=this._getProgressNavigator().getCurrentStep();o=this._aStepPath[i-1];}r=a.createRenderManager();r.renderControl(this._updateStepTitleNumber(o,i));r.flush(this.getDomRef("step-container"));r.destroy();};
g.prototype._updateStepTitleNumber=function(s,i){var o=s.getCustomData().filter(function(h){return h.getKey()==="stepIndex";})[0];if(o){o.setValue(i);}else{s.addCustomData(new c({key:"stepIndex",value:i}));}return s;};
g.prototype.exit=function(){var o=this.getDomRef("step-container");if(o){o.onscroll=null;}this._oScroller.destroy();this._oScroller=null;this._aStepPath=null;this._iStepCount=null;this._bScrollLocked=null;this._oResourceBundle=null;this._iNextButtonHeight=null;};
g.prototype.validateStep=function(s){if(!this._containsStep(s)){L.error("The wizard does not contain this step");return this;}s.setValidated(true);return this;};
g.prototype.invalidateStep=function(s){if(!this._containsStep(s)){L.error("The wizard does not contain this step");return this;}s.setValidated(false);return this;};
g.prototype.nextStep=function(){var i=this._getProgressNavigator().getProgress()-1;var o=this._aStepPath[i];this.validateStep(o);o._complete();return this;};
g.prototype.previousStep=function(){var p=this._getProgressNavigator().getProgress()-2;if(p>=0){this.discardProgress(this._aStepPath[p]);}return this;};
g.prototype.getProgress=function(){return this._getProgressNavigator().getProgress();};
g.prototype.getProgressStep=function(){return this._aStepPath[this.getProgress()-1];};
g.prototype.goToStep=function(s,F){var u=function(){var p=this._getProgressNavigator();p&&p._updateCurrentStep(this._aStepPath.indexOf(s)+1);};if(!this.getVisible()||this._aStepPath.indexOf(s)<0){return this;}else if(this.getRenderMode()===f.Page){u.call(this);this._renderPageMode(s);return this;}s._setNumberInvisibleText(this.getProgress());var t=this,m={scrollTop:this._getStepScrollOffset(s)},A={queue:false,duration:g.CONSTANTS.ANIMATION_TIME,start:function(){t._bScrollLocked=true;},complete:function(){t._bScrollLocked=false;u.call(t);if(F||F===undefined){t._focusFirstStepElement(s);}}};q(this.getDomRef("step-container")).animate(m,A);return this;};
g.prototype.discardProgress=function(s,p){var P=this.getProgress(),h=this._aStepPath,I=this._aStepPath.indexOf(s),o=this._aStepPath[I],j=I+1;if(j>P||j<=0){L.warning("The given step is either not yet reached, or is not present in the wizard control.");return this;}this._getProgressNavigator().discardProgress(j,true);this._updateProgressNavigator();this._restoreInitialValidatedState(j);for(var i=j;i<h.length;i++){h[i]._deactivate();if(h[i].getSubsequentSteps().length>1){h[i].setNextStep(null);}}this.setAssociation("currentStep",s);o.setWizardContext({sButtonText:this._getNextButtonText(),bLast:true});if(s.getSubsequentSteps().length>1&&!p){s.setNextStep(null);}h.splice(j);return this;};
g.prototype.setCurrentStep=function(s){var o=(typeof s==="string")?a.byId(s):s;if(!this.getEnableBranching()){this.setAssociation("currentStep",s,true);}if(o&&this._isStepReachable(o)){this._activateAllPreceedingSteps(o);}else{L.error("The given step could not be set as current step.");}return this;};
g.prototype.setShowNextButton=function(v){this.setProperty("showNextButton",v,true);this.getSteps().forEach(function(s){s.setWizardContext({bParentAllowsButtonShow:v});});return this;};
g.prototype.getFinishButtonText=function(){if(this.getProperty("finishButtonText")==="Review"){return this._oResourceBundle.getText("WIZARD_FINISH");}else{return this.getProperty("finishButtonText");}};
g.prototype.addStep=function(w){if(this._isMaxStepCountExceeded()){L.error("The Wizard is supposed to handle up to 8 steps.");return this;}w.setWizardContext({bParentAllowsButtonShow:this.getShowNextButton()});this._incrementStepCount();return this.addAggregation("steps",w);};
g.prototype.setBackgroundDesign=function(B){var s=this.getBackgroundDesign();this.setProperty("backgroundDesign",B,true);this.$().removeClass("sapMWizardBg"+s).addClass("sapMWizardBg"+this.getBackgroundDesign());return this;};
g.prototype.insertStep=function(w,i){throw new Error("Dynamic step insertion is not yet supported.");};
g.prototype.removeStep=function(w){throw new Error("Dynamic step removal is not yet supported.");};
g.prototype.removeAllSteps=function(){this._resetStepCount();return this.removeAllAggregation("steps").map(function(s){return s;},this);};
g.prototype.destroySteps=function(){this._resetStepCount();return this.destroyAggregation("steps");};
g.prototype._getStickyContent=function(){return this._getProgressNavigator();};
g.prototype._returnStickyContent=function(){if(this.bIsDestroyed){return;}this._getStickyContent().$().prependTo(this.$());};
g.prototype._setStickySubheaderSticked=function(i){this._bStickyContentSticked=i;};
g.prototype._getStickySubheaderSticked=function(){return this._bStickyContentSticked;};
g.prototype._activateAllPreceedingSteps=function(s){if(this._aStepPath.indexOf(s)>=0){this.discardProgress(s,true);return;}while(this.getProgressStep()!==s){this.nextStep();}};
g.prototype._isNextStepDetermined=function(s,p){if(!this.getEnableBranching()){return true;}s=s||this._getCurrentStepInstance();return this._getNextStep(s,p)!==null;};
g.prototype._isStepReachable=function(s){if(this.getEnableBranching()){var o=this._getStartingStep();while(o!==s){o=o._getNextStepReference();if(o==null){return false;}}this.setAssociation("currentStep",s);return true;}else{return this.getSteps().indexOf(s)>=0;}};
g.prototype._initScrollEnablement=function(){return new S(this,null,{scrollContainerId:this.getId()+"-step-container",horizontal:false,vertical:true});};
g.prototype._initProgressNavigator=function(){var t=this,p=new W(this.getId()+"-progressNavigator",{stepChanged:this._handleStepChanged.bind(this)});p._setOnEnter(function(E,s){var o=t._aStepPath[s];setTimeout(function(){this._focusFirstStepElement(o);}.bind(t),g.CONSTANTS.ANIMATION_TIME);});this.setAggregation("_progressNavigator",p);};
g.prototype._handleNextButtonPress=function(){var p=this._getProgressNavigator(),P=p.getProgress(),s=this.isStepFinal();if(s){this.fireComplete();}else{var o=this.getProgressStep();if(!this._isNextStepDetermined(o,P)){throw new Error("The wizard is in branching mode, and the nextStep association is not set.");}p.incrementProgress();this._handleStepActivated(p.getProgress());this._handleStepChanged(p.getProgress());}};
g.prototype._getStepScrollOffset=function(s){var o=this.getDomRef("step-container"),i=o?o.scrollTop:0,h=0,A=0,n=this._getNextButtonHeight(),j=s.getDomRef()?s.getDomRef().scrollHeight:0,k=o?o.clientHeight:0;if(s&&s.$()&&s.$().position()){h=s.$().position().top||0;}if(n>0&&j>k){A=n;}this._setNextButtonHeight(0);return(i+h)-(g.CONSTANTS.SCROLL_OFFSET+A);};
g.prototype._focusFirstStepElement=function(s){var $=s.$();if($&&$.firstFocusableDomRef()){$.firstFocusableDomRef().focus();}};
g.prototype._handleStepChanged=function(E){var p=((typeof E==="number")?E:E.getParameter("current"))-2,P=this._aStepPath[p],s=this._getNextStep(P,p),F=D.system.desktop?true:false;this.goToStep(s,F);};
g.prototype._handleStepActivated=function(i){var p=i-2,P=this._aStepPath[p],n=this._getNextStep(P,p),N=this._getNextButton().getDomRef();this._setNextButtonHeight(N?N.offsetHeight:0);this._activateStep(n);this._updateProgressNavigator();this.fireStepActivate({index:i});this.setAssociation("currentStep",this.getProgressStep(),true);this.getProgressStep().setWizardContext({bLast:true,bReviewStep:this.isStepFinal(),sButtonText:this._getNextButtonText()});};
g.prototype._isMaxStepCountExceeded=function(){var s=this._getStepCount();if(this.getEnableBranching()){return false;}return s>=g.CONSTANTS.MAXIMUM_STEPS;};
g.prototype._isMinStepCountReached=function(){var s=this._getStepCount();return s>=g.CONSTANTS.MINIMUM_STEPS;};
g.prototype._getStepCount=function(){return this._iStepCount;};
g.prototype._incrementStepCount=function(){this._iStepCount+=1;this._getProgressNavigator().setStepCount(this._getStepCount());};
g.prototype._decrementStepCount=function(){this._iStepCount-=1;this._getProgressNavigator().setStepCount(this._getStepCount());};
g.prototype._resetStepCount=function(){this._iStepCount=0;this._getProgressNavigator().setStepCount(this._getStepCount());};
g.prototype._getProgressNavigator=function(){return this.getAggregation("_progressNavigator");};
g.prototype._saveInitialValidatedState=function(){if(this._aInitialValidatedState){return;}this._aInitialValidatedState=this.getSteps().map(function(s){return s.getValidated();});};
g.prototype._restoreInitialValidatedState=function(I){var s=this._aStepPath,A=this.getSteps();for(var i=I;i<s.length;i++){var o=s[i],h=A.indexOf(o),j=this._aInitialValidatedState[h];o.setValidated(j);}};
g.prototype._getNextStep=function(s,p){if(!this.getEnableBranching()){return this.getSteps()[p+1];}if(p<0){return this._getStartingStep();}var n=s._getNextStepReference();if(n===null){throw new Error("The wizard is in branching mode, and no next step is defined for "+"the current step, please set one.");}if(!this._containsStep(n)){throw new Error("The next step that you have defined is not part of the wizard steps aggregation."+"Please add it to the wizard control.");}var h=s.getSubsequentSteps();if(h.length>0&&!s._containsSubsequentStep(n.getId())){throw new Error("The next step that you have defined is not contained inside the subsequentSteps"+" association of the current step.");}return n;};
g.prototype.isStepFinal=function(){var s,i=this._getStepCount(),p=this.getProgress();if(this.getEnableBranching()){s=this._aStepPath[this._aStepPath.length-1]._isLeaf();}else{s=p===i;}return s;};
g.prototype._getNextButtonText=function(){if(this.isStepFinal()){return this.getFinishButtonText();}else{return this._oResourceBundle.getText("WIZARD_STEP")+" "+(this.getProgress()+1);}};
g.prototype._getNextButton=function(){var s=this._getCurrentStepInstance();if(s){return s.getAggregation("_nextButton");}else{return null;}};
g.prototype._updateProgressNavigator=function(){var p=this._getProgressNavigator(),o=this._getStartingStep(),A=this.getSteps(),s=[o.getTitle()],h=[o.getIcon()],i=[o.getOptional()],j=1;if(this.getEnableBranching()){while(!o._isLeaf()&&o._getNextStepReference()!==null){j++;o=o._getNextStepReference();s.push(o.getTitle());i.push(o.getOptional());h.push(o.getIcon());}p.setVaryingStepCount(o._isBranched());p.setStepCount(j);}else{s=A.map(function(k){return k.getTitle();});i=A.map(function(k){return k.getOptional();});h=A.map(function(k){return k.getIcon();});}p.setStepTitles(s);p._aStepOptionalIndication=i;p.setStepIcons(h);};
g.prototype._getStartingStep=function(){return this.getSteps()[0];};
g.prototype._attachScrollHandler=function(){var o=this.getDomRef("step-container");o.onscroll=this._scrollHandler.bind(this);};
g.prototype._scrollHandler=function(E){if(this._bScrollLocked){return;}var s=E.target.scrollTop,p=this._getProgressNavigator(),o=this._aStepPath[p.getCurrentStep()-1],h=o&&o.getDomRef();if(!h){return;}var i=h.clientHeight,j=h.offsetTop,k=100;if(s+k>=j+i&&p._isActiveStep(p._iCurrentStep+1)){p.nextStep();}var m=this.getSteps();for(var n=0;n<m.length;n++){if(s+k<=j){p.previousStep();o=this._aStepPath[p.getCurrentStep()-1];h=o&&o.getDomRef();if(!h){break;}j=h.offsetTop;}}};
g.prototype._getCurrentStepInstance=function(){return a.byId(this.getCurrentStep());};
g.prototype._containsStep=function(s){return this.getSteps().some(function(o){return o===s;});};
g.prototype._checkCircularReference=function(s){if(this._aStepPath.indexOf(s)>=0){throw new Error("The step that you are trying to activate has already been visited. You are creating "+"a loop inside the wizard.");}};
g.prototype._activateStep=function(s){this._checkCircularReference(s);this._aStepPath.push(s);s._activate();};
g.prototype._getNextButtonHeight=function(){return this._iNextButtonHeight;};
g.prototype._setNextButtonHeight=function(h){this._iNextButtonHeight=h;};
return g;});
sap.ui.require.preload({
	"sap/m/MultiEditField.control.xml":'<core:FragmentDefinition xmlns:m="sap.m" xmlns:core="sap.ui.core" type="XML"><m:Select id="select" width="100%" items="{$this&gt;items}" change="_handleSelectionChange"><m:items><core:Item text="{$this&gt;text}" key="{$this&gt;key}" id="itemTemplate"/></m:items></m:Select></core:FragmentDefinition>',
	"sap/m/manifest.json":'{"_version":"1.21.0","sap.app":{"id":"sap.m","type":"library","embeds":[],"applicationVersion":{"version":"1.98.0"},"title":"The main UI5 control library, with responsive controls that can be used in touch devices as well as desktop browsers.","description":"The main UI5 control library, with responsive controls that can be used in touch devices as well as desktop browsers.","ach":"CA-UI5-CTR","resources":"resources.json","offline":true},"sap.ui":{"technology":"UI5","supportedThemes":["base","sap_hcb"]},"sap.ui5":{"dependencies":{"minUI5Version":"1.98","libs":{"sap.ui.core":{"minVersion":"1.98.0"},"sap.ui.layout":{"minVersion":"1.98.0","lazy":true},"sap.ui.unified":{"minVersion":"1.98.0","lazy":true}}},"library":{"i18n":{"bundleUrl":"messagebundle.properties","supportedLocales":["","ar","bg","ca","cs","cy","da","de","el","en","en-GB","en-US-sappsd","en-US-saprigi","en-US-saptrc","es","es-MX","et","fi","fr","fr-CA","hi","hr","hu","id","it","iw","ja","kk","ko","lt","lv","ms","nl","no","pl","pt","pt-PT","ro","ru","sh","sk","sl","sv","th","tr","uk","vi","zh-CN","zh-TW"]},"content":{"controls":["sap.m.ActionListItem","sap.m.ActionSelect","sap.m.ActionSheet","sap.m.App","sap.m.Avatar","sap.m.Bar","sap.m.BusyDialog","sap.m.BusyIndicator","sap.m.Button","sap.m.Breadcrumbs","sap.m.Carousel","sap.m.CheckBox","sap.m.ColumnHeaderPopover","sap.m.ColumnListItem","sap.m.ColorPalette","sap.m.ColorPalettePopover","sap.m.ComboBox","sap.m.ComboBoxTextField","sap.m.ComboBoxBase","sap.m.CustomListItem","sap.m.CustomTile","sap.m.CustomTreeItem","sap.m.DatePicker","sap.m.DateRangeSelection","sap.m.DateTimeField","sap.m.DateTimeInput","sap.m.DateTimePicker","sap.m.Dialog","sap.m.DisplayListItem","sap.m.DraftIndicator","sap.m.DynamicDateRange","sap.m.ExpandableText","sap.m.FacetFilter","sap.m.FacetFilterItem","sap.m.FacetFilterList","sap.m.FeedContent","sap.m.FeedInput","sap.m.FeedListItem","sap.m.FlexBox","sap.m.FormattedText","sap.m.GenericTag","sap.m.GenericTile","sap.m.GroupHeaderListItem","sap.m.GrowingList","sap.m.HBox","sap.m.HeaderContainer","sap.m.IconTabBar","sap.m.IconTabBarSelectList","sap.m.IconTabFilterExpandButtonBadge","sap.m.IconTabHeader","sap.m.IllustratedMessage","sap.m.Image","sap.m.ImageContent","sap.m.Input","sap.m.InputBase","sap.m.InputListItem","sap.m.Label","sap.m.LightBox","sap.m.Link","sap.m.List","sap.m.ListBase","sap.m.ListItemBase","sap.m.MaskInput","sap.m.Menu","sap.m.MenuButton","sap.m.MessagePage","sap.m.MessagePopover","sap.m.MessageView","sap.m.MessageStrip","sap.m.MultiComboBox","sap.m.MultiEditField","sap.m.MultiInput","sap.m.NavContainer","sap.m.NewsContent","sap.m.NumericContent","sap.m.NotificationList","sap.m.NotificationListBase","sap.m.NotificationListItem","sap.m.NotificationListGroup","sap.m.PagingButton","sap.m.PlanningCalendarLegend","sap.m.ObjectAttribute","sap.m.ObjectHeader","sap.m.ObjectIdentifier","sap.m.ObjectListItem","sap.m.ObjectMarker","sap.m.ObjectNumber","sap.m.ObjectStatus","sap.m.OverflowToolbar","sap.m.OverflowToolbarButton","sap.m.OverflowToolbarToggleButton","sap.m.P13nColumnsPanel","sap.m.P13nGroupPanel","sap.m.P13nSelectionPanel","sap.m.P13nDimMeasurePanel","sap.m.P13nConditionPanel","sap.m.P13nDialog","sap.m.P13nFilterPanel","sap.m.P13nPanel","sap.m.P13nSortPanel","sap.m.Page","sap.m.Panel","sap.m.PDFViewer","sap.m.PlanningCalendar","sap.m.PlanningCalendarHeader","sap.m.Popover","sap.m.ProgressIndicator","sap.m.PullToRefresh","sap.m.QuickView","sap.m.QuickViewBase","sap.m.QuickViewCard","sap.m.QuickViewPage","sap.m.RadioButton","sap.m.RadioButtonGroup","sap.m.RangeSlider","sap.m.RatingIndicator","sap.m.ResponsivePopover","sap.m.ScrollContainer","sap.m.SearchField","sap.m.SegmentedButton","sap.m.Select","sap.m.SelectDialog","sap.m.SelectDialogBase","sap.m.SelectList","sap.m.SelectionDetails","sap.m.Shell","sap.m.SimpleFixFlex","sap.m.SinglePlanningCalendar","sap.m.SinglePlanningCalendarGrid","sap.m.SinglePlanningCalendarMonthGrid","sap.m.Slider","sap.m.SliderTooltip","sap.m.SliderTooltipBase","sap.m.SliderTooltipContainer","sap.m.SlideTile","sap.m.StepInput","sap.m.SplitApp","sap.m.SplitContainer","sap.m.StandardListItem","sap.m.StandardTreeItem","sap.m.StandardTile","sap.m.Switch","sap.m.Table","sap.m.TableSelectDialog","sap.m.TabContainer","sap.m.TabStrip","sap.m.Text","sap.m.TextArea","sap.m.Tile","sap.m.TileContainer","sap.m.TileContent","sap.m.TimePicker","sap.m.TimePickerInputs","sap.m.TimePickerClock","sap.m.TimePickerClocks","sap.m.TimePickerSliders","sap.m.Title","sap.m.ToggleButton","sap.m.Token","sap.m.Tokenizer","sap.m.Toolbar","sap.m.ToolbarSpacer","sap.m.ToolbarSeparator","sap.m.Tree","sap.m.TreeItemBase","sap.m.UploadCollection","sap.m.UploadCollectionToolbarPlaceholder","sap.m.upload.UploadSet","sap.m.VBox","sap.m.ViewSettingsDialog","sap.m.WheelSlider","sap.m.WheelSliderContainer","sap.m.Wizard","sap.m.WizardStep","sap.m.semantic.DetailPage","sap.m.semantic.SemanticPage","sap.m.semantic.ShareMenuPage","sap.m.semantic.FullscreenPage","sap.m.semantic.MasterPage","sap.m.p13n.AbstractContainer","sap.m.p13n.BasePanel","sap.m.p13n.Container","sap.m.p13n.GroupPanel","sap.m.p13n.QueryPanel","sap.m.p13n.SelectionPanel","sap.m.p13n.SortPanel","sap.m.p13n.Popup","sap.m.table.ColumnMenu"],"elements":["sap.m.BadgeCustomData","sap.m.Column","sap.m.ColumnPopoverActionItem","sap.m.ColumnPopoverCustomItem","sap.m.ColumnPopoverItem","sap.m.ColumnPopoverSortItem","sap.m.CustomDynamicDateOption","sap.m.DynamicDateOption","sap.m.DynamicDateValueHelpUIType","sap.m.FlexItemData","sap.m.FeedListItemAction","sap.m.IconTabFilter","sap.m.IconTabSeparator","sap.m.LightBoxItem","sap.m.OverflowToolbarLayoutData","sap.m.MaskInputRule","sap.m.MenuItem","sap.m.MessageItem","sap.m.MessagePopoverItem","sap.m.PageAccessibleLandmarkInfo","sap.m.P13nFilterItem","sap.m.P13nItem","sap.m.PlanningCalendarRow","sap.m.PlanningCalendarView","sap.m.P13nColumnsItem","sap.m.P13nDimMeasureItem","sap.m.P13nGroupItem","sap.m.P13nSortItem","sap.m.QuickViewGroup","sap.m.QuickViewGroupElement","sap.m.ResponsiveScale","sap.m.SegmentedButtonItem","sap.m.SelectionDetailsItem","sap.m.SelectionDetailsItemLine","sap.m.SinglePlanningCalendarDayView","sap.m.SinglePlanningCalendarMonthView","sap.m.SinglePlanningCalendarWeekView","sap.m.SinglePlanningCalendarWorkWeekView","sap.m.SinglePlanningCalendarView","sap.m.StandardDynamicDateOption","sap.m.SuggestionItem","sap.m.TabContainerItem","sap.m.TabStripItem","sap.m.ToolbarLayoutData","sap.m.UploadCollectionItem","sap.m.UploadCollectionParameter","sap.m.upload.Uploader","sap.m.upload.UploadSetItem","sap.m.ViewSettingsCustomItem","sap.m.ViewSettingsCustomTab","sap.m.ViewSettingsFilterItem","sap.m.ViewSettingsItem","sap.m.plugins.ColumnResizer","sap.m.plugins.DataStateIndicator","sap.m.plugins.PasteProvider","sap.m.plugins.PluginBase","sap.m.p13n.AbstractContainerItem","sap.m.semantic.AddAction","sap.m.semantic.CancelAction","sap.m.semantic.DeleteAction","sap.m.semantic.DiscussInJamAction","sap.m.semantic.EditAction","sap.m.semantic.FavoriteAction","sap.m.semantic.FilterAction","sap.m.semantic.FilterSelect","sap.m.semantic.FlagAction","sap.m.semantic.ForwardAction","sap.m.semantic.GroupAction","sap.m.semantic.GroupSelect","sap.m.semantic.MainAction","sap.m.semantic.MessagesIndicator","sap.m.semantic.MultiSelectAction","sap.m.semantic.NegativeAction","sap.m.semantic.OpenInAction","sap.m.semantic.PositiveAction","sap.m.semantic.PrintAction","sap.m.semantic.SaveAction","sap.m.semantic.SemanticButton","sap.m.semantic.SemanticControl","sap.m.semantic.SemanticSelect","sap.m.semantic.SemanticToggleButton","sap.m.semantic.SendEmailAction","sap.m.semantic.SendMessageAction","sap.m.semantic.ShareInJamAction","sap.m.semantic.SortAction","sap.m.semantic.SortSelect","sap.m.table.ColumnMenuEntry","sap.m.table.Item","sap.m.table.ItemBase","sap.m.table.QuickAction","sap.m.table.QuickActionBase"],"types":["sap.m.AvatarImageFitType","sap.m.AvatarShape","sap.m.AvatarSize","sap.m.AvatarType","sap.m.AvatarColor","sap.m.BackgroundDesign","sap.m.BadgeState","sap.m.BadgeAnimationType","sap.m.BarDesign","sap.m.BreadcrumbsSeparatorStyle","sap.m.ButtonType","sap.m.CarouselArrowsPlacement","sap.m.DateTimeInputType","sap.m.DeviationIndicator","sap.m.DialogRoleType","sap.m.DialogType","sap.m.DraftIndicatorState","sap.m.FacetFilterListDataType","sap.m.FacetFilterType","sap.m.FlexAlignContent","sap.m.FlexAlignItems","sap.m.FlexAlignSelf","sap.m.FlexDirection","sap.m.FlexJustifyContent","sap.m.FlexRendertype","sap.m.FlexWrap","sap.m.FrameType","sap.m.GenericTagDesign","sap.m.GenericTagValueState","sap.m.GenericTileMode","sap.m.GenericTileScope","sap.m.HeaderLevel","sap.m.IBarHTMLTag","sap.m.IconTabDensityMode","sap.m.IconTabFilterDesign","sap.m.IconTabHeaderMode","sap.m.IllustratedMessageSize","sap.m.IllustratedMessageType","sap.m.ImageMode","sap.m.InputTextFormatMode","sap.m.InputType","sap.m.LabelDesign","sap.m.LightBoxLoadingStates","sap.m.LinkConversion","sap.m.ListGrowingDirection","sap.m.ListHeaderDesign","sap.m.ListKeyboardMode","sap.m.ListMode","sap.m.ListSeparators","sap.m.ListType","sap.m.LoadState","sap.m.MenuButtonMode","sap.m.MultiSelectMode","sap.m.ObjectHeaderPictureShape","sap.m.ObjectMarkerType","sap.m.ObjectMarkerVisibility","sap.m.OverflowToolbarPriority","sap.m.P13nPanelType","sap.m.P13nConditionOperation","sap.m.PageBackgroundDesign","sap.m.PanelAccessibleRole","sap.m.PDFViewerDisplayType","sap.m.PlacementType","sap.m.PlanningCalendarBuiltInView","sap.m.PlanningCalendarStickyMode","sap.m.PopinDisplay","sap.m.PopinLayout","sap.m.QuickViewGroupElementType","sap.m.RatingIndicatorVisualMode","sap.m.ScreenSize","sap.m.SelectColumnRatio","sap.m.SelectionDetailsActionLevel","sap.m.SelectListKeyboardNavigationMode","sap.m.SelectType","sap.m.Size","sap.m.SplitAppMode","sap.m.StandardDynamicDateRangeKeys","sap.m.StandardTileType","sap.m.StepInputStepModeType","sap.m.StepInputValidationMode","sap.m.Sticky","sap.m.StringFilterOperator","sap.m.SwipeDirection","sap.m.SwitchType","sap.m.TabsOverflowMode","sap.m.TileSizeBehavior","sap.m.TimePickerMaskMode","sap.m.TitleAlignment","sap.m.TokenizerRenderMode","sap.m.ToolbarDesign","sap.m.ToolbarStyle","sap.m.UploadState","sap.m.ValueColor","sap.m.ValueCSSColor","sap.m.VerticalPlacementType","sap.m.WrappingType","sap.m.WizardRenderMode","sap.m.semantic.SemanticRuleSetType","sap.m.upload.UploaderHttpRequestMethod"],"interfaces":["sap.m.IBar","sap.m.IBadge","sap.m.IBreadcrumbs","sap.m.p13n.IContent","sap.m.IconTab","sap.m.IScale","sap.m.semantic.IGroup","sap.m.semantic.IFilter","sap.m.semantic.ISort","sap.m.ObjectHeaderContainer","sap.m.IOverflowToolbarContent","sap.m.IOverflowToolbarFlexibleContent","sap.m.IHyphenation"]}}}}',
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
	"sap/m/SelectionDetailsFacade.js":function(){
}
},"sap/m/library-preload"
);
//# sourceMappingURL=library-preload.js.map