//@ui5-bundle sap/ui/core/library-preload.js
/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/base/ManagedObjectObserver',['sap/ui/base/Object','sap/ui/base/ManagedObject','sap/ui/base/EventProvider',"sap/base/util/array/uniqueSort",'sap/base/util/deepExtend'],function(B,M,E,u,d){"use strict";
var a=B.extend("sap.ui.base.ManagedObjectObserver",{constructor:function(C){if(!C&&typeof C!=="function"){throw new Error("Missing callback function in ManagedObjectObserver constructor");}this._fnCallback=C;}});
a.prototype.observe=function(i,C){if(!(i instanceof M)){if(i==null){return;}throw new TypeError("ManagedObjectObserver can only handle ManagedObjects, but observe was called for "+i);}p(i,C);c(i,this,C);};
a.prototype.unobserve=function(i,C){if(!(i instanceof M)){if(i==null){return;}throw new TypeError("ManagedObjectObserver can only handle ManagedObjects, but unobserve was called for "+i);}if(C){p(i,C);}r(i,this,C);};
a.prototype.isObserved=function(i,C){if(!(i instanceof M)){if(i==null){return false;}throw new TypeError("ManagedObjectObserver can only handle ManagedObjects, but isObserved was called for "+i);}return e(i,this,C);};
a.prototype.disconnect=function(){f(this);};
a.prototype.getConfiguration=function(i){return g(i,this);};
var O={},t=Object.create(null);
O.propertyChange=function(i,n,v,N){h("properties",i,n,function(){return{type:"property",old:v,current:N};});};
O.aggregationChange=function(i,n,s,v){h("aggregations",i,n,function(){return{type:"aggregation",mutation:s,children:Array.isArray(v)?v:null,child:!Array.isArray(v)?v:null};});};
O.parentChange=function(i,n,s,P){h("parent",i,n,function(){return{type:"parent",mutation:s,parent:P};});var q=s==="unset"?"remove":"insert";O.aggregationChange(P,n,q,i);};
O.associationChange=function(i,n,s,I){h("associations",i,n,function(){return{type:"association",mutation:s,ids:I};});};
O.eventChange=function(i,n,s,L,F,D){h("events",i,n,function(){return{type:"event",mutation:s,listener:L,func:F,data:D};});};
O.bindingChange=function(i,n,s,q,v){h("bindings",i,n,function(){return{type:"binding",mutation:s,bindingInfo:q,memberType:v};});};
O.objectDestroyed=function(i){h("destroy",i,null,function(){return{type:"destroy"};});var I=i.getId();if(t[I]){i.detachEvent("EventHandlerChange",H);delete t[I];}delete i._observer;};
function h(T,n,N,C){var I=n.getId(),q=t[I];if(q){var s;for(var i=0;i<q.listeners.length;i++){if(b(q.configurations[i],T,N)){if(!s){s=C();s.name=N;s.object=n;}var L=q.listeners[i];L._fnCallback(s);}}}}
function b(C,T,n){if(C==null||!T){return false;}if(T!="destroy"&&T!="parent"&&!n){return false;}return C[T]===true||(Array.isArray(C[T])&&C[T].indexOf(n)>-1);}
function c(T,L,C){j(T,L,C,false);}
function g(T,L){var i=T.getId();var n=t[i];if(n&&n.listeners){var I=n.listeners.indexOf(L);if(I>=0){var C=d({},n.configurations[I]);return C;}}return null;}
function r(T,L,C){C=C||g(T,L);j(T,L,C,true);}
function e(T,L,C){var i=T.getId(),n=t[i];C=C||g(T,L);if(!n){return false;}var I=n.listeners.indexOf(L);if(I===-1){return false;}else{return m(n.configurations[I].properties,C.properties)&&m(n.configurations[I].aggregations,C.aggregations)&&m(n.configurations[I].associations,C.associations)&&m(n.configurations[I].bindings,C.bindings)&&m(n.configurations[I].events,C.events)&&o(n.configurations[I].destroy,C.destroy)&&o(n.configurations[I].parent,C.parent);}}
function f(L){for(var n in t){var T=t[n];for(var i=0;i<T.listeners.length;i++){if(T.listeners[i]===L){T.listeners.splice(i,1);T.configurations.splice(i,1);}}if(T.listeners&&T.listeners.length===0){delete t[n];T.object._observer=undefined;}}}
function j(T,L,C,R){var i=T.getId(),n=t[i],q,I;if(R){if(!n){return;}I=n.listeners.indexOf(L);if(I>=0){q=n.configurations[I];}}else{if(!n){n=t[i]={listeners:[],configurations:[],object:T};}I=n.listeners.indexOf(L);if(I===-1){n.listeners.push(L);n.configurations.push(C);}else{q=n.configurations[I];}}if(q){q.properties=q.properties||[];l(q.properties,C.properties,R);q.aggregations=q.aggregations||[];l(q.aggregations,C.aggregations,R);q.associations=q.associations||[];l(q.associations,C.associations,R);q.bindings=q.bindings||[];l(q.bindings,C.bindings,R);q.events=q.events||[];l(q.events,C.events,R);if(C.destroy!=null){if(R){delete q.destroy;}else{q.destroy=C.destroy;}}if(C.parent!=null){if(R){delete q.parent;}else{q.parent=C.parent;}}}var s=k(T,"events");if(T._observer&&R){if(!s&&E.hasListener(T,"EventHandlerChange",H)){T.detachEvent("EventHandlerChange",H);}if(!s&&!k(T,"properties")&&!k(T,"aggregations")&&!k(T,"associations")&&!k(T,"destroy")&&!k(T,"parent")&&!k(T,"bindings")){delete T._observer;delete t[i];}}else if(!T._observer&&!R){if(s&&!E.hasListener(T,"EventHandlerChange",H)){T.attachEvent("EventHandlerChange",H);}T._observer=O;}}
function k(T,s){var i=T.getId(),n=t[i];if(n){var C=n.configurations.filter(function(q){return q.hasOwnProperty(s)&&q[s]&&(q[s]===true||q[s].length>0);});return C.length>0;}return false;}
function H(i){var T=i.getSource(),s=i.mParameters.EventId;if(T.getMetadata().hasEvent(s)){if(i.mParameters.type==="listenerAttached"){O.eventChange(T,s,"insert",i.mParameters.listener,i.mParameters.func,i.mParameters.data);}else if(i.mParameters.type==="listenerDetached"){O.eventChange(T,s,"remove",i.mParameters.listener,i.mParameters.func,i.mParameters.data);}}}
function l(n,A,R){if(!A){return;}for(var i=0;i<A.length;i++){var I=n.indexOf(A[i]);if(I>-1&&R){n.splice(I,1);}else if(I===-1&&!R){n.push(A[i]);}}}
function m(F,s){if(!Array.isArray(s)||s.length==0){return true;}if(!Array.isArray(F)||F.length==0){return false;}var U=u(F.concat(s));return F.length===U.length;}
function o(i,C){if(C==null){return true;}return i===C;}
function p(i,C){var n=i.getMetadata(),P=Object.keys(n.getAllProperties()),A=Object.keys(n.getAllAggregations()),q=Object.keys(n.getAllAssociations()),s=u(P.concat(A)),v=Object.keys(n.getAllEvents());C.properties=C.properties===true?P:C.properties;C.aggregations=C.aggregations===true?A:C.aggregations;C.associations=C.associations===true?q:C.associations;C.bindings=C.bindings===true?s:C.bindings;C.events=C.events===true?v:C.events;C.destroy=(C.destroy==null)?false:C.destroy;C.parent=(C.parent==null)?false:C.parent;}
return a;});
sap.ui.predefine('sap/ui/model/base/ManagedObjectModel',['../json/JSONModel','../json/JSONPropertyBinding','../json/JSONListBinding','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectObserver','../Context','../ChangeReason',"sap/base/util/uid","sap/base/Log","sap/base/util/isPlainObject","sap/base/util/deepClone"],function(J,a,b,M,c,C,d,u,L,e,f){"use strict";var g="@custom",I="--";
function _(n,o,A,O){var p=A.get(o)||[],q,r;if(p&&!Array.isArray(p)&&!A.multiple){p=[p];}for(var i=0;i<p.length;i++){q=p[i];if(!(q instanceof M)){continue;}r=true;if(O){n._oObserver.observe(q,{properties:true,aggregations:true});}else{n._oObserver.unobserve(q,{properties:true,aggregations:true});}var s=q.getMetadata().getAllAggregations();for(var K in s){_(n,q,s[K],O);}}if(r){var K=o.getId()+"/@"+A.name;if(O){if(!n._mObservedCount.aggregations[K]){n._mObservedCount.aggregations[K]=0;}n._mObservedCount.aggregations[K]++;}else{delete n._mObservedCount.aggregations[K];}}}
function h(n){var s,i=n.length-1,p=[];while(!(n[i].node instanceof M)){if(s){p.splice(0,0,s);}s=n[i].path;i--;}return[n[i].node,n[i+1],p,s];}
function j(o){var D="",p;var t=typeof o;if(o==null||(t!="object"&&t!="function")){D=o;}else if(e(o)){D=JSON.stringify(o);}else if(o instanceof M){D=o.getId();for(p in o.mProperties){D=D+"$"+j(o.mProperties[p]);}}else if(Array.isArray(o)){for(var i=0;o.length;i++){D=D+"$"+j(o);}}else{L.warning("Could not stringify object "+o);D="$";}return D;}
var k=b.extend("sap.ui.model.base.ManagedObjectModelAggregationBinding",{
constructor:function(){b.apply(this,arguments);this._getOriginOfManagedObjectModelBinding();},
_mightBeAffectedByChangesInside:function(o){while(o){if(o.getParent()===this._oOriginMO){return true;}o=o.getParent();}return false;},
getEntryKey:function(o){var O=o.getObject();if(O instanceof M){return O.getId();}return b.prototype.getEntryKey.apply(this,arguments);},
getEntryData:function(o){var O=o.getObject();if(O instanceof M){return j(O);}return b.prototype.getEntryData.apply(this,arguments);},
_getContexts:function(s,i){var S;if(this._oAggregation){var o=this._oOriginMO.getBinding(this._sMember);if(o){var n=o.getModel();S=n.iSizeLimit;}var B=this._oOriginMO.getBindingInfo(this._sMember);if(B&&s>=0&&i&&S&&i>S){var U=false;if(s!=B.startIndex){B.startIndex=s;U=true;}if(i!=B.length){B.length=i;U=true;}if(U){this._oAggregation.update(this._oOriginMO,"change");}}}return b.prototype._getContexts.apply(this,arguments);},
_getOriginOfManagedObjectModelBinding:function(){if(!this._oOriginMO){var o=this.oModel,n=[];o._getObject(this.sPath,this.oContext,n);var v=h(n);this._oOriginMO=v[0];this._aPartsInJSON=v[2];this._sMember=v[3];this._oAggregation=this._oOriginMO.getMetadata().getAggregation(this._sMember);}},
getLength:function(){if(this._aPartsInJSON.length==0){var i=this._oOriginMO.getBinding(this._sMember);if(i&&i.isA("sap.ui.model.ListBinding")){return i.getLength();}}return b.prototype.getLength.apply(this,arguments);},
isLengthFinal:function(){if(this._aPartsInJSON.length==0){var i=this._oOriginMO.getBinding(this._sMember);if(i&&i.isA("sap.ui.model.ListBinding")){return i.isLengthFinal();}}return true;}
});
var l=a.extend("sap.ui.model.base.ManagedObjectModelPropertyBinding");
var m=J.extend("sap.ui.model.base.ManagedObjectModel",{constructor:function(o,D){if(!D&&typeof D!="object"){D={};}D[g]={};this._oObject=o;this._mObservedCount={properties:{},aggregations:{}};this.mListBinding={};J.apply(this,[D]);this._oObserver=new c(this.observerChanges.bind(this));this.setSizeLimit(1000000);}});
m.prototype.getAggregation=J.prototype.getProperty;
m.prototype.setData=function(D,i){var n={};n[g]=D;J.prototype.setData.apply(this,[n,i]);};
m.prototype.getJSON=function(){return JSON.stringify(this.oData[g]);};
m.prototype.setProperty=function(p,v,o,A){var r=this.resolve(p,o),n,O,P;if(!r){return false;}if(r.indexOf("/"+g)===0){return J.prototype.setProperty.apply(this,arguments);}n=r.lastIndexOf("/");O=r.substring(0,n||1);P=r.substr(n+1);var N=[],q=this._getObject(O,null,N);if(q){if(q instanceof M){var s=q.getMetadata().getManagedProperty(P);if(s){if(s.get(q)!==v){s.set(q,v);var F=function(B){var p=this.resolve(B.sPath,B.oContext);return p?p.startsWith(r):false;}.bind(this);this.checkUpdate(false,A,F);return true;}}else{L.warning("The setProperty method only supports properties, the path "+r+" does not point to a property",null,"sap.ui.model.base.ManagedObjectModel");}}else if(q[P]!==v){var V=h(N);var t=f(V[1].node),w=V[2];var x=t;for(var i=0;i<w.length;i++){x=x[w[i]];}x[P]=v;var y="/"+P;if(w.length>0){y="/"+w.join("/")+y;}var D=r.lastIndexOf(y);var z=r.substr(0,D);return this.setProperty(z,t,o);}}return false;};
m.prototype.addBinding=function(B){J.prototype.addBinding.apply(this,arguments);if(B instanceof k){var A=B.sPath.replace("/","");this.mListBinding[A]=B;}B.checkUpdate(false);};
m.prototype.removeBinding=function(B){J.prototype.removeBinding.apply(this,arguments);if(B instanceof k){var A=B.sPath.replace("/","");delete this.mListBinding[A];}this._observeBeforeEvaluating(B,false);};
m.prototype.firePropertyChange=function(p){if(p.reason===d.Binding){p.resolvedPath=this.resolve(p.path,p.context);}J.prototype.firePropertyChange.call(this,p);};
m.prototype.bindAggregation=function(p,o,P){return J.prototype.bindProperty.apply(this,arguments);};
m.prototype.bindProperty=function(p,o,P){var B=new l(this,p,o,P);return B;};
m.prototype.bindList=function(p,o,s,F,P){var B=new k(this,p,o,s,F,P);return B;};
m.prototype.getManagedObject=function(p,o){if(p instanceof C){o=p;p=o.getPath();}var O=this.getProperty(p,o);if(O instanceof M){return O;}return null;};
m.prototype.getRootObject=function(){return this._oObject;};
m.prototype._observePropertyChange=function(o,p){if(!o||!p){return;}var K=o.getId()+"/@"+p.name;if(!this._oObserver.isObserved(o,{properties:[p.name]})){this._oObserver.observe(o,{properties:[p.name]});this._mObservedCount.properties[K]=1;}else{this._mObservedCount.properties[K]++;}};
m.prototype._unobservePropertyChange=function(o,p){if(!o||!p){return;}var K=o.getId()+"/@"+p.name;this._mObservedCount.properties[K]--;if(this._mObservedCount.properties[K]==0){this._oObserver.unobserve(o,{properties:[p.name]});delete this._mObservedCount.properties[K];}};
m.prototype._observeAggregationChange=function(o,A){if(!o||!A){return;}var K=o.getId()+"/@"+A.name;if(!this._oObserver.isObserved(o,{aggregations:[A.name]})){this._oObserver.observe(o,{aggregations:[A.name]});this._mObservedCount.aggregations[K]=1;_(this,o,A,true);}else{this._mObservedCount.aggregations[K]++;}};
m.prototype._unobserveAggregationChange=function(o,A){if(!o||!A){return;}var K=o.getId()+"/@"+A.name;this._mObservedCount.aggregations[K]--;if(this._mObservedCount.aggregations[K]==0){this._oObserver.unobserve(o,{aggregations:[A.name]});delete this._mObservedCount.aggregations[K];}};
m.prototype._createId=function(i){var o=this._oObject;if(typeof o.createId==="function"){return o.createId(i);}if(!i){return o.getId()+I+u();}if(i.indexOf(o.getId()+I)!=0){return o.getId()+I+i;}return i;};
m.prototype._getSpecialNode=function(n,s,p,P){if(n instanceof M){if(s==="className"){if(n.getMetadata){return n.getMetadata().getName();}else{return typeof n;}}else if(s==="id"){return n.getId();}else if(s==="metadataContexts"){return n._oProviderData;}}else if(s==="binding"&&p&&P){return p.getBinding(P);}else if(s==="bound"&&p&&P){return p.isBound(P);}else if(s==="bindingInfo"&&p&&P){return p.getBindingInfo(P);}else if(Array.isArray(n)){if(s==="length"){return n.length;}else if(s.indexOf("id=")===0){var o=s.substring(3),F=null;for(var i=0;i<n.length;i++){if(n[i].getId()===this._createId(o)||n[i].getId()===o){F=n[i];break;}}return F;}}return null;};
m.prototype._getObject=function(p,o,n){var N=this._oObject,r="",t=this;if(n){n.push({path:"/",node:N});}this.aBindings.forEach(function(B){if(!B._bAttached){t._observeBeforeEvaluating(B,true);}});if(typeof p==="string"&&p.indexOf("/")!=0&&!o){return null;}if(o instanceof M){N=o;r=p;}else if(!o||o instanceof C){r=this.resolve(p,o);if(!r){return N;}if(r.indexOf("/"+g)===0){return J.prototype._getObject.apply(this,[p,o]);}}else{N=o;r=p;}if(!N){return null;}var P=r.split("/"),i=0;if(!P[0]){i++;}var q=null,s=null,v;while(N!==null&&P[i]){v=P[i];if(v=="id"){v="@id";}if(v.indexOf("@")===0){N=this._getSpecialNode(N,v.substring(1),q,s);}else if(N instanceof M){var w=N.getMetadata();if(w.isInstanceOf("sap.ui.core.IDScope")&&v.indexOf("#")===0){N=N.byId(v.substring(1));}else{q=N;s=v;var x=w.getManagedProperty(v);if(x){N=x.get(N);}else{var A=w.getManagedAggregation(v);if(A){N=A.get(N);}else{if(N&&N[v]&&typeof N[v]==="function"){N=N[v]();}else{N=null;}}}}}else if(Array.isArray(N)||e(N)){N=N[v];}else{if(N&&N[v]&&typeof N[v]==="function"){N=N[v]();}else{N=null;}}if(n){n.push({path:v,node:N});}i++;}return N;};
m.prototype.destroy=function(){for(var n in this._mAggregationObjects){var o=this._mAggregationObjects[n];if(o.object.invalidate.fn){o.object.invalidate=o.object.invalidate.fn;}}J.prototype.destroy.apply(this,arguments);};
m.prototype._observeBeforeEvaluating=function(B,o){if(!B.isResolved()){return;}var p=B.getPath();var i=B.getContext(),n=this._oObject,r;if(i instanceof M){n=i;r=p;}else if(!i||i instanceof C){r=this.resolve(p,i);if(!r){return;}if(r.indexOf("/"+g)===0){return;}}else{return;}var P=r.split("/");if(!P[0]){P.shift();}var s=P[0];if(n.getMetadata().isInstanceOf("sap.ui.core.IDScope")&&s.indexOf("#")===0){n=n.byId(s.substring(1));s=P[1];}if(n instanceof M){var N=n.getMetadata(),q=N.getManagedProperty(s);if(q){if(o===true){this._observePropertyChange(n,q);}else if(o===false){this._unobservePropertyChange(n,q);}}else{var A=N.getAggregation(s)||N.getAllPrivateAggregations()[s];if(A){if(o===true){this._observeAggregationChange(n,A);}else if(o===false){this._unobserveAggregationChange(n,A);}}}B._bAttached=o;}};
m.prototype.observerChanges=function(o){if(o.type=="aggregation"){var A={};if(o.child instanceof M){A=o.child.getMetadata().getAllAggregations();}if(o.mutation=="insert"){if(o.child instanceof M){this._oObserver.observe(o.child,{properties:true,aggregations:true});}for(var K in A){_(this,o.child,A[K],true);}if(this.mListBinding[o.name]){var i=this._oObject.getBinding(o.name);var n=this._oObject.getAggregation(o.name);if(i&&i.getCurrentContexts().length!=n.length){return;}}}else{if(o.child instanceof M){this._oObserver.unobserve(o.child,{properties:true,aggregations:true});}for(var K in A){_(this,o.child,A[K],false);}}}else if(o.type==="property"){this.aBindings.forEach(function(B){if(B._mightBeAffectedByChangesInside&&B._mightBeAffectedByChangesInside(o.object)){B.checkUpdate(true);}});}this.checkUpdate();};
m.prototype.checkUpdate=function(F,A,i){if(A){this.bForceUpdate=this.bForceUpdate||F;if(!this.sUpdateTimer){this.fnFilter=this.fnFilter||i;this.sUpdateTimer=setTimeout(function(){this.checkUpdate(this.bForceUpdate,false,this.fnFilter);}.bind(this),0);}else if(this.fnFilter&&this.fnFilter!==i){this.fnFilter=undefined;}return;}F=this.bForceUpdate||F;i=!this.fnFilter||this.fnFilter===i?i:undefined;if(this.sUpdateTimer){clearTimeout(this.sUpdateTimer);this.sUpdateTimer=null;this.bForceUpdate=undefined;this.fnFilter=undefined;}var B=this.aBindings.slice(0);B.forEach(function(o){if(!i||i(o)){o.checkUpdate(F);}});};
return m;});
/**
 * @license
 * Lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash strict include="omit,uniq,uniqBy,uniqWith,intersection,intersectionBy,intersectionWith,pick,pickBy,debounce,throttle,max,min,castArray,curry,merge,mergeWith,toArray,xor,xorBy,xorWith,isNil,difference,differenceBy,differenceWith,flatMap,flatMapDeep,flatMapDepth,isEqual,isEqualWith,without,flatten,flattenDeep,flattenDepth,compact,zipObject,zipObjectDeep,union,unionBy,unionWith"`
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 * Modifications SAP SE or an SAP affiliate company and OpenUI5 contributors. All rights reserved.
 */
sap.ui.predefine('sap/base/util/restricted/_/lodash.custom',function(){'use strict';var u;var V='4.17.21';var L=200;var F='Expected a function';var H='__lodash_hash_undefined__';var M=500;var P='__lodash_placeholder__';var C=1,a=2,b=4;var c=1,d=2;var W=1,f=2,g=4,h=8,i=16,j=32,k=64,l=128,m=256,o=512;var p=800,q=16;var I=1/0,r=9007199254740991,s=1.7976931348623157e+308,N=0/0;var t=4294967295;var w=[['ary',l],['bind',W],['bindKey',f],['curry',h],['curryRight',i],['flip',o],['partial',j],['partialRight',k],['rearg',m]];var v='[object Arguments]',x='[object Array]',y='[object AsyncFunction]',z='[object Boolean]',A='[object Date]',B='[object Error]',D='[object Function]',E='[object GeneratorFunction]',G='[object Map]',J='[object Number]',K='[object Null]',O='[object Object]',Q='[object Promise]',R='[object Proxy]',S='[object RegExp]',T='[object Set]',U='[object String]',X='[object Symbol]',Y='[object Undefined]',Z='[object WeakMap]';var $='[object ArrayBuffer]',_='[object DataView]',a1='[object Float32Array]',b1='[object Float64Array]',c1='[object Int8Array]',d1='[object Int16Array]',e1='[object Int32Array]',f1='[object Uint8Array]',g1='[object Uint8ClampedArray]',h1='[object Uint16Array]',i1='[object Uint32Array]';var j1=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,k1=/^\w*$/,l1=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;var m1=/[\\^$.*+?()[\]{}|]/g;var n1=/^\s+/;var o1=/\s/;var p1=/\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/,q1=/\{\n\/\* \[wrapped with (.+)\] \*/,r1=/,? & /;var s1=/\\(\\)?/g;var t1=/\w*$/;var u1=/^[-+]0x[0-9a-f]+$/i;var v1=/^0b[01]+$/i;var w1=/^\[object .+?Constructor\]$/;var x1=/^0o[0-7]+$/i;var y1=/^(?:0|[1-9]\d*)$/;var z1='\\ud800-\\udfff',A1='\\u0300-\\u036f',B1='\\ufe20-\\ufe2f',C1='\\u20d0-\\u20ff',D1=A1+B1+C1,E1='\\ufe0e\\ufe0f';var F1='['+z1+']',G1='['+D1+']',H1='\\ud83c[\\udffb-\\udfff]',I1='(?:'+G1+'|'+H1+')',J1='[^'+z1+']',K1='(?:\\ud83c[\\udde6-\\uddff]){2}',L1='[\\ud800-\\udbff][\\udc00-\\udfff]',M1='\\u200d';var N1=I1+'?',O1='['+E1+']?',P1='(?:'+M1+'(?:'+[J1,K1,L1].join('|')+')'+O1+N1+')*',Q1=O1+N1+P1,R1='(?:'+[J1+G1+'?',G1,K1,L1,F1].join('|')+')';var S1=RegExp(H1+'(?='+H1+')|'+R1+Q1,'g');var T1=RegExp('['+M1+z1+D1+E1+']');var U1={};U1[a1]=U1[b1]=U1[c1]=U1[d1]=U1[e1]=U1[f1]=U1[g1]=U1[h1]=U1[i1]=true;U1[v]=U1[x]=U1[$]=U1[z]=U1[_]=U1[A]=U1[B]=U1[D]=U1[G]=U1[J]=U1[O]=U1[S]=U1[T]=U1[U]=U1[Z]=false;var V1={};V1[v]=V1[x]=V1[$]=V1[_]=V1[z]=V1[A]=V1[a1]=V1[b1]=V1[c1]=V1[d1]=V1[e1]=V1[G]=V1[J]=V1[O]=V1[S]=V1[T]=V1[U]=V1[X]=V1[f1]=V1[g1]=V1[h1]=V1[i1]=true;V1[B]=V1[D]=V1[Z]=false;var W1=parseInt;var X1=typeof global=='object'&&global&&global.Object===Object&&global;var Y1=typeof self=='object'&&self&&self.Object===Object&&self;var Z1=X1||Y1||Function('return this')();var $1=typeof exports=='object'&&exports&&!exports.nodeType&&exports;var _1=$1&&typeof module=='object'&&module&&!module.nodeType&&module;var a2=_1&&_1.exports===$1;var b2=a2&&X1.process;var c2=(function(){try{var n=_1&&_1.require&&_1.require('util').types;if(n){return n;}return b2&&b2.binding&&b2.binding('util');}catch(e){}}());var d2=c2&&c2.isMap,e2=c2&&c2.isSet,f2=c2&&c2.isTypedArray;
function g2(e,n,_6){switch(_6.length){case 0:return e.call(n);case 1:return e.call(n,_6[0]);case 2:return e.call(n,_6[0],_6[1]);case 3:return e.call(n,_6[0],_6[1],_6[2]);}return e.apply(n,_6);}
function h2(e,K7){var n=-1,_6=e==null?0:e.length;while(++n<_6){if(K7(e[n],n,e)===false){break;}}return e;}
function i2(e,n){var _6=-1,R7=e==null?0:e.length,S7=0,T7=[];while(++_6<R7){var U7=e[_6];if(n(U7,_6,e)){T7[S7++]=U7;}}return T7;}
function j2(e,n){var _6=e==null?0:e.length;return!!_6&&q2(e,n,0)>-1;}
function k2(e,n,_6){var R7=-1,S7=e==null?0:e.length;while(++R7<S7){if(_6(n,e[R7])){return true;}}return false;}
function l2(e,K7){var n=-1,_6=e==null?0:e.length,R7=Array(_6);while(++n<_6){R7[n]=K7(e[n],n,e);}return R7;}
function m2(e,H7){var n=-1,_6=H7.length,R7=e.length;while(++n<_6){e[R7+n]=H7[n];}return e;}
function n2(e,n){var _6=-1,R7=e==null?0:e.length;while(++_6<R7){if(n(e[_6],_6,e)){return true;}}return false;}
function o2(e){return e.split('');}
function p2(e,n,_6,R7){var S7=e.length,T7=_6+(R7?1:-1);while((R7?T7--:++T7<S7)){if(n(e[T7],T7,e)){return T7;}}return-1;}
function q2(e,n,_6){return n===n?G2(e,n,_6):p2(e,r2,_6);}
function r2(e){return e!==e;}
function s2(e){return function(n){return n==null?u:n[e];};}
function t2(n,K7){var e=-1,_6=Array(n);while(++e<n){_6[e]=K7(e);}return _6;}
function u2(e){return e?e.slice(0,I2(e)+1).replace(n1,''):e;}
function v2(e){return function(n){return e(n);};}
function w2(e,n){return l2(n,function(_6){return e[_6];});}
function x2(e,n){return e.has(n);}
function y2(e,n){var _6=e.length,R7=0;while(_6--){if(e[_6]===n){++R7;}}return R7;}
function z2(e,n){return e==null?u:e[n];}
function A2(e){return T1.test(e);}
function B2(e){var n,_6=[];while(!(n=e.next()).done){_6.push(n.value);}return _6;}
function C2(U6){var e=-1,n=Array(U6.size);U6.forEach(function(_6,R7){n[++e]=[R7,_6];});return n;}
function D2(e,n){return function(_6){return e(n(_6));};}
function E2(e,n){var _6=-1,R7=e.length,S7=0,T7=[];while(++_6<R7){var U7=e[_6];if(U7===n||U7===P){e[_6]=P;T7[S7++]=_6;}}return T7;}
function F2(e){var n=-1,_6=Array(e.size);e.forEach(function(R7){_6[++n]=R7;});return _6;}
function G2(e,n,_6){var R7=_6-1,S7=e.length;while(++R7<S7){if(e[R7]===n){return R7;}}return-1;}
function H2(e){return A2(e)?J2(e):o2(e);}
function I2(e){var n=e.length;while(n--&&o1.test(e.charAt(n))){}return n;}
function J2(e){return e.match(S1)||[];}
var K2=Array.prototype,L2=Function.prototype,M2=Object.prototype;var N2=Z1['__core-js_shared__'];var O2=L2.toString;var P2=M2.hasOwnProperty;var Q2=(function(){var e=/[^.]+$/.exec(N2&&N2.keys&&N2.keys.IE_PROTO||'');return e?('Symbol(src)_1.'+e):'';}());var R2=M2.toString;var S2=O2.call(Object);var T2=RegExp('^'+O2.call(P2).replace(m1,'\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,'$1.*?')+'$');var U2=a2?Z1.Buffer:u,V2=Z1.Symbol,W2=Z1.Uint8Array,X2=U2?U2.allocUnsafe:u,Y2=D2(Object.getPrototypeOf,Object),Z2=Object.create,$2=M2.propertyIsEnumerable,_2=K2.splice,a3=V2?V2.isConcatSpreadable:u,b3=V2?V2.iterator:u,c3=V2?V2.toStringTag:u;var d3=(function(){try{var n=L5(Object,'defineProperty');n({},'',{});return n;}catch(e){}}());var e3=Object.getOwnPropertySymbols,f3=U2?U2.isBuffer:u,g3=D2(Object.keys,Object),h3=Math.max,i3=Math.min,j3=Date.now;var k3=L5(Z1,'DataView'),l3=L5(Z1,'Map'),m3=L5(Z1,'Promise'),n3=L5(Z1,'Set'),o3=L5(Z1,'WeakMap'),p3=L5(Object,'create');var q3=o3&&new o3;var r3={};var s3=s6(k3),t3=s6(l3),u3=s6(m3),v3=s6(n3),w3=s6(o3);var x3=V2?V2.prototype:u,y3=x3?x3.valueOf:u,z3=x3?x3.toString:u;
function A3(){}
var B3=(function(){function e(){}return function(n){if(!j7(n)){return{};}if(Z2){return Z2(n);}e.prototype=n;var _6=new e;e.prototype=u;return _6;};}());
function C3(){}
function D3(e){this.__wrapped__=e;this.__actions__=[];this.__dir__=1;this.__filtered__=false;this.__iteratees__=[];this.__takeCount__=t;this.__views__=[];}
D3.prototype=B3(C3.prototype);D3.prototype.constructor=D3;
function E3(e){var n=-1,_6=e==null?0:e.length;this.clear();while(++n<_6){var R7=e[n];this.set(R7[0],R7[1]);}}
function F3(){this.__data__=p3?p3(null):{};this.size=0;}
function G3(e){var n=this.has(e)&&delete this.__data__[e];this.size-=n?1:0;return n;}
function H3(e){var n=this.__data__;if(p3){var _6=n[e];return _6===H?u:_6;}return P2.call(n,e)?n[e]:u;}
function I3(e){var n=this.__data__;return p3?(n[e]!==u):P2.call(n,e);}
function J3(e,n){var _6=this.__data__;this.size+=this.has(e)?0:1;_6[e]=(p3&&n===u)?H:n;return this;}
E3.prototype.clear=F3;E3.prototype['delete']=G3;E3.prototype.get=H3;E3.prototype.has=I3;E3.prototype.set=J3;
function K3(e){var n=-1,_6=e==null?0:e.length;this.clear();while(++n<_6){var R7=e[n];this.set(R7[0],R7[1]);}}
function L3(){this.__data__=[];this.size=0;}
function M3(e){var n=this.__data__,_6=g4(n,e);if(_6<0){return false;}var R7=n.length-1;if(_6==R7){n.pop();}else{_2.call(n,_6,1);}--this.size;return true;}
function N3(e){var n=this.__data__,_6=g4(n,e);return _6<0?u:n[_6][1];}
function O3(e){return g4(this.__data__,e)>-1;}
function P3(e,n){var _6=this.__data__,R7=g4(_6,e);if(R7<0){++this.size;_6.push([e,n]);}else{_6[R7][1]=n;}return this;}
K3.prototype.clear=L3;K3.prototype['delete']=M3;K3.prototype.get=N3;K3.prototype.has=O3;K3.prototype.set=P3;
function Q3(e){var n=-1,_6=e==null?0:e.length;this.clear();while(++n<_6){var R7=e[n];this.set(R7[0],R7[1]);}}
function R3(){this.size=0;this.__data__={'hash':new E3,'map':new(l3||K3),'string':new E3};}
function S3(e){var n=J5(this,e)['delete'](e);this.size-=n?1:0;return n;}
function T3(e){return J5(this,e).get(e);}
function U3(e){return J5(this,e).has(e);}
function V3(e,n){var _6=J5(this,e),R7=_6.size;_6.set(e,n);this.size+=_6.size==R7?0:1;return this;}
Q3.prototype.clear=R3;Q3.prototype['delete']=S3;Q3.prototype.get=T3;Q3.prototype.has=U3;Q3.prototype.set=V3;
function W3(H7){var e=-1,n=H7==null?0:H7.length;this.__data__=new Q3;while(++e<n){this.add(H7[e]);}}
function X3(e){this.__data__.set(e,H);return this;}
function Y3(e){return this.__data__.has(e);}
W3.prototype.add=W3.prototype.push=X3;W3.prototype.has=Y3;
function Z3(e){var n=this.__data__=new K3(e);this.size=n.size;}
function $3(){this.__data__=new K3;this.size=0;}
function _3(e){var n=this.__data__,_6=n['delete'](e);this.size=n.size;return _6;}
function a4(e){return this.__data__.get(e);}
function b4(e){return this.__data__.has(e);}
function c4(e,n){var _6=this.__data__;if(_6 instanceof K3){var R7=_6.__data__;if(!l3||(R7.length<L-1)){R7.push([e,n]);this.size=++_6.size;return this;}_6=this.__data__=new Q3(R7);}_6.set(e,n);this.size=_6.size;return this;}
Z3.prototype.clear=$3;Z3.prototype['delete']=_3;Z3.prototype.get=a4;Z3.prototype.has=b4;Z3.prototype.set=c4;
function d4(e,n){var _6=b7(e),R7=!_6&&a7(e),S7=!_6&&!R7&&e7(e),T7=!_6&&!R7&&!S7&&r7(e),U7=_6||R7||S7||T7,V7=U7?t2(e.length,String):[],W7=V7.length;for(var X7 in e){if((n||P2.call(e,X7))&&!(U7&&(X7=='length'||(S7&&(X7=='offset'||X7=='parent'))||(T7&&(X7=='buffer'||X7=='byteLength'||X7=='byteOffset'))||X5(X7,W7)))){V7.push(X7);}}return V7;}
function e4(e,n,_6){if((_6!==u&&!eq(e[n],_6))||(_6===u&&!(n in e))){j4(e,n,_6);}}
function f4(e,n,_6){var R7=e[n];if(!(P2.call(e,n)&&eq(R7,_6))||(_6===u&&!(n in e))){j4(e,n,_6);}}
function g4(e,n){var _6=e.length;while(_6--){if(eq(e[_6][0],n)){return _6;}}return-1;}
function h4(e,n){return e&&k5(n,A7(n),e);}
function i4(e,n){return e&&k5(n,B7(n),e);}
function j4(e,n,_6){if(n=='__proto__'&&d3){d3(e,n,{'configurable':true,'enumerable':true,'value':_6,'writable':true});}else{e[n]=_6;}}
function k4(e,n,_6,R7,S7,T7){var U7,V7=n&C,W7=n&a,X7=n&b;if(_6){U7=S7?_6(e,R7,S7,T7):_6(e);}if(U7!==u){return U7;}if(!j7(e)){return e;}var Y7=b7(e);if(Y7){U7=S5(e);if(!V7){return j5(e,U7);}}else{var Z7=P5(e),$7=Z7==D||Z7==E;if(e7(e)){return b5(e,V7);}if(Z7==O||Z7==v||($7&&!S7)){U7=(W7||$7)?{}:T5(e);if(!V7){return W7?m5(e,i4(U7,e)):l5(e,h4(U7,e));}}else{if(!V1[Z7]){return S7?e:{};}U7=U5(e,Z7,V7);}}T7||(T7=new Z3);var _7=T7.get(e);if(_7){return _7;}T7.set(e,U7);if(o7(e)){e.forEach(function(c8){U7.add(k4(c8,n,_6,c8,e,T7));});}else if(l7(e)){e.forEach(function(c8,R7){U7.set(R7,k4(c8,n,_6,R7,e,T7));});}var a8=X7?(W7?E5:D5):(W7?B7:A7);var b8=Y7?u:a8(e);h2(b8||e,function(c8,R7){if(b8){R7=c8;c8=e[R7];}f4(U7,R7,k4(c8,n,_6,R7,e,T7));});return U7;}
function l4(e,H7,K7,n){var _6=-1,R7=j2,S7=true,T7=e.length,U7=[],V7=H7.length;if(!T7){return U7;}if(K7){H7=l2(H7,v2(K7));}if(n){R7=k2;S7=false;}else if(H7.length>=L){R7=x2;S7=false;H7=new W3(H7);}outer:while(++_6<T7){var W7=e[_6],X7=K7==null?W7:K7(W7);W7=(n||W7!==0)?W7:0;if(S7&&X7===X7){var Y7=V7;while(Y7--){if(H7[Y7]===X7){continue outer;}}U7.push(W7);}else if(!R7(H7,X7,n)){U7.push(W7);}}return U7;}
var m4=o5(q4);
function n4(e,K7,n){var _6=-1,R7=e.length;while(++_6<R7){var S7=e[_6],T7=K7(S7);if(T7!=null&&(U7===u?(T7===T7&&!q7(T7)):n(T7,U7))){var U7=T7,V7=S7;}}return V7;}
function o4(e,n,_6,R7,S7){var T7=-1,U7=e.length;_6||(_6=W5);S7||(S7=[]);while(++T7<U7){var V7=e[T7];if(n>0&&_6(V7)){if(n>1){o4(V7,n-1,_6,R7,S7);}else{m2(S7,V7);}}else if(!R7){S7[S7.length]=V7;}}return S7;}
var p4=p5();
function q4(e,K7){return e&&p4(e,K7,A7);}
function r4(e,n){n=a5(n,e);var _6=0,R7=n.length;while(e!=null&&_6<R7){e=e[r6(n[_6++])];}return(_6&&_6==R7)?e:u;}
function s4(e,n,_6){var R7=n(e);return b7(e)?R7:m2(R7,_6(e));}
function t4(e){if(e==null){return e===u?Y:K;}return(c3&&c3 in Object(e))?M5(e):h6(e);}
function u4(e,n){return e>n;}
function v4(e,n){return e!=null&&n in Object(e);}
function w4(e,K7,n){var _6=n?k2:j2,R7=e[0].length,S7=e.length,T7=S7,U7=Array(S7),V7=Infinity,W7=[];while(T7--){var X7=e[T7];if(T7&&K7){X7=l2(X7,v2(K7));}V7=i3(X7.length,V7);U7[T7]=!n&&(K7||(R7>=120&&X7.length>=120))?new W3(T7&&X7):u;}X7=e[0];var Y7=-1,Z7=U7[0];outer:while(++Y7<R7&&W7.length<V7){var $7=X7[Y7],_7=K7?K7($7):$7;$7=(n||$7!==0)?$7:0;if(!(Z7?x2(Z7,_7):_6(W7,_7,n))){T7=S7;while(--T7){var a8=U7[T7];if(!(a8?x2(a8,_7):_6(e[T7],_7,n))){continue outer;}}if(Z7){Z7.push(_7);}W7.push($7);}}return W7;}
function x4(e){return k7(e)&&t4(e)==v;}
function y4(e,n,_6,R7,S7){if(e===n){return true;}if(e==null||n==null||(!k7(e)&&!k7(n))){return e!==e&&n!==n;}return z4(e,n,_6,R7,y4,S7);}
function z4(e,n,_6,R7,S7,T7){var U7=b7(e),V7=b7(n),W7=U7?x:P5(e),X7=V7?x:P5(n);W7=W7==v?O:W7;X7=X7==v?O:X7;var Y7=W7==O,Z7=X7==O,$7=W7==X7;if($7&&e7(e)){if(!e7(n)){return false;}U7=true;Y7=false;}if($7&&!Y7){T7||(T7=new Z3);return(U7||r7(e))?z5(e,n,_6,R7,S7,T7):A5(e,n,W7,_6,R7,S7,T7);}if(!(_6&c)){var _7=Y7&&P2.call(e,'__wrapped__'),a8=Z7&&P2.call(n,'__wrapped__');if(_7||a8){var b8=_7?e.value():e,c8=a8?n.value():n;T7||(T7=new Z3);return S7(b8,c8,_6,R7,T7);}}if(!$7){return false;}T7||(T7=new Z3);return B5(e,n,_6,R7,S7,T7);}
function A4(e){return k7(e)&&P5(e)==G;}
function B4(e,n,_6,R7){var S7=_6.length,T7=S7,U7=!R7;if(e==null){return!T7;}e=Object(e);while(S7--){var V7=_6[S7];if((U7&&V7[2])?V7[1]!==e[V7[0]]:!(V7[0]in e)){return false;}}while(++S7<T7){V7=_6[S7];var W7=V7[0],X7=e[W7],Y7=V7[1];if(U7&&V7[2]){if(X7===u&&!(W7 in e)){return false;}}else{var Z7=new Z3;if(R7){var $7=R7(X7,Y7,W7,e,n,Z7);}if(!($7===u?y4(Y7,X7,c|d,R7,Z7):$7)){return false;}}}return true;}
function C4(e){if(!j7(e)||a6(e)){return false;}var n=h7(e)?T2:w1;return n.test(s6(e));}
function D4(e){return k7(e)&&P5(e)==T;}
function E4(e){return k7(e)&&i7(e.length)&&!!U1[t4(e)];}
function F4(e){if(typeof e=='function'){return e;}if(e==null){return J7;}if(typeof e=='object'){return b7(e)?L4(e[0],e[1]):K4(e);}return M7(e);}
function G4(e){if(!b6(e)){return g3(e);}var n=[];for(var _6 in Object(e)){if(P2.call(e,_6)&&_6!='constructor'){n.push(_6);}}return n;}
function H4(e){if(!j7(e)){return g6(e);}var n=b6(e),_6=[];for(var R7 in e){if(!(R7=='constructor'&&(n||!P2.call(e,R7)))){_6.push(R7);}}return _6;}
function I4(e,n){return e<n;}
function J4(e,K7){var n=-1,_6=c7(e)?Array(e.length):[];m4(e,function(R7,S7,e){_6[++n]=K7(R7,S7,e);});return _6;}
function K4(e){var n=K5(e);if(n.length==1&&n[0][2]){return d6(n[0][0],n[0][1]);}return function(_6){return _6===e||B4(_6,e,n);};}
function L4(e,n){if(Z5(e)&&c6(n)){return d6(r6(e),n);}return function(_6){var R7=y7(_6,e);return(R7===u&&R7===n)?z7(_6,e):y4(n,R7,c|d);};}
function M4(e,n,_6,R7,S7){if(e===n){return;}p4(n,function(T7,U7){S7||(S7=new Z3);if(j7(T7)){N4(e,n,U7,_6,M4,R7,S7);}else{var V7=R7?R7(l6(e,U7),T7,(U7+''),e,n,S7):u;if(V7===u){V7=T7;}e4(e,U7,V7);}},B7);}
function N4(e,n,_6,R7,S7,T7,U7){var V7=l6(e,_6),W7=l6(n,_6),X7=U7.get(W7);if(X7){e4(e,_6,X7);return;}var Y7=T7?T7(V7,W7,(_6+''),e,n,U7):u;var Z7=Y7===u;if(Z7){var $7=b7(W7),_7=!$7&&e7(W7),a8=!$7&&!_7&&r7(W7);Y7=W7;if($7||_7||a8){if(b7(V7)){Y7=V7;}else if(d7(V7)){Y7=j5(V7);}else if(_7){Z7=false;Y7=b5(W7,true);}else if(a8){Z7=false;Y7=g5(W7,true);}else{Y7=[];}}else if(n7(W7)||a7(W7)){Y7=V7;if(a7(V7)){Y7=w7(V7);}else if(!j7(V7)||h7(V7)){Y7=T5(W7);}}else{Z7=false;}}if(Z7){U7.set(W7,Y7);S7(Y7,W7,R7,T7,U7);U7['delete'](W7);}e4(e,_6,Y7);}
function O4(e,n){return P4(e,n,function(_6,R7){return z7(e,R7);});}
function P4(e,n,_6){var R7=-1,S7=n.length,T7={};while(++R7<S7){var U7=n[R7],V7=r4(e,U7);if(_6(V7,U7)){S4(T7,a5(U7,e),V7);}}return T7;}
function Q4(e){return function(n){return r4(n,e);};}
function R4(e,n){return n6(i6(e,n,J7),e+'');}
function S4(e,n,_6,R7){if(!j7(e)){return e;}n=a5(n,e);var S7=-1,T7=n.length,U7=T7-1,V7=e;while(V7!=null&&++S7<T7){var W7=r6(n[S7]),X7=_6;if(W7==='__proto__'||W7==='constructor'||W7==='prototype'){return e;}if(S7!=U7){var Y7=V7[W7];X7=R7?R7(Y7,W7,V7):u;if(X7===u){X7=j7(Y7)?Y7:(X5(n[S7+1])?[]:{});}}f4(V7,W7,X7);V7=V7[W7];}return e;}
var T4=!q3?J7:function(e,n){q3.set(e,n);return e;};var U4=!d3?J7:function(e,n){return d3(e,'toString',{'configurable':true,'enumerable':false,'value':I7(n),'writable':true});};
function V4(e,n,_6){var R7=-1,S7=e.length;if(n<0){n=-n>S7?0:(S7+n);}_6=_6>S7?S7:_6;if(_6<0){_6+=S7;}S7=n>_6?0:((_6-n)>>>0);n>>>=0;var T7=Array(S7);while(++R7<S7){T7[R7]=e[R7+n];}return T7;}
function W4(e){if(typeof e=='string'){return e;}if(b7(e)){return l2(e,W4)+'';}if(q7(e)){return z3?z3.call(e):'';}var n=(e+'');return(n=='0'&&(1/e)==-I)?'-0':n;}
function X4(e,K7,n){var _6=-1,R7=j2,S7=e.length,T7=true,U7=[],V7=U7;if(n){T7=false;R7=k2;}else if(S7>=L){var W7=K7?null:w5(e);if(W7){return F2(W7);}T7=false;R7=x2;V7=new W3;}else{V7=K7?[]:U7;}outer:while(++_6<S7){var X7=e[_6],Y7=K7?K7(X7):X7;X7=(n||X7!==0)?X7:0;if(T7&&Y7===Y7){var Z7=V7.length;while(Z7--){if(V7[Z7]===Y7){continue outer;}}if(K7){V7.push(Y7);}U7.push(X7);}else if(!R7(V7,Y7,n)){if(V7!==U7){V7.push(Y7);}U7.push(X7);}}return U7;}
function Y4(e,n){n=a5(n,e);e=j6(e,n);return e==null||delete e[r6(E6(n))];}
function Z4(e,K7,n){var _6=e.length;if(_6<2){return _6?X4(e[0]):[];}var R7=-1,S7=Array(_6);while(++R7<_6){var T7=e[R7],U7=-1;while(++U7<_6){if(U7!=R7){S7[R7]=l4(S7[R7]||T7,e[U7],K7,n);}}}return X4(o4(S7,1),K7,n);}
function $4(e,H7,n){var _6=-1,R7=e.length,S7=H7.length,T7={};while(++_6<R7){var U7=_6<S7?H7[_6]:u;n(T7,e[_6],U7);}return T7;}
function _4(e){return d7(e)?e:[];}
function a5(e,n){if(b7(e)){return e;}return Z5(e,n)?[e]:q6(x7(e));}
function b5(e,n){if(n){return e.slice();}var _6=e.length,R7=X2?X2(_6):new e.constructor(_6);e.copy(R7);return R7;}
function c5(e){var n=new e.constructor(e.byteLength);new W2(n).set(new W2(e));return n;}
function d5(e,n){var _6=n?c5(e.buffer):e.buffer;return new e.constructor(_6,e.byteOffset,e.byteLength);}
function e5(e){var n=new e.constructor(e.source,t1.exec(e));n.lastIndex=e.lastIndex;return n;}
function f5(e){return y3?Object(y3.call(e)):{};}
function g5(e,n){var _6=n?c5(e.buffer):e.buffer;return new e.constructor(_6,e.byteOffset,e.length);}
function h5(e,n,_6,R7){var S7=-1,T7=e.length,U7=_6.length,V7=-1,W7=n.length,X7=h3(T7-U7,0),Y7=Array(W7+X7),Z7=!R7;while(++V7<W7){Y7[V7]=n[V7];}while(++S7<U7){if(Z7||S7<T7){Y7[_6[S7]]=e[S7];}}while(X7--){Y7[V7++]=e[S7++];}return Y7;}
function i5(e,n,_6,R7){var S7=-1,T7=e.length,U7=-1,V7=_6.length,W7=-1,X7=n.length,Y7=h3(T7-V7,0),Z7=Array(Y7+X7),$7=!R7;while(++S7<Y7){Z7[S7]=e[S7];}var _7=S7;while(++W7<X7){Z7[_7+W7]=n[W7];}while(++U7<V7){if($7||S7<T7){Z7[_7+_6[U7]]=e[S7++];}}return Z7;}
function j5(e,n){var _6=-1,R7=e.length;n||(n=Array(R7));while(++_6<R7){n[_6]=e[_6];}return n;}
function k5(e,n,_6,R7){var S7=!_6;_6||(_6={});var T7=-1,U7=n.length;while(++T7<U7){var V7=n[T7];var W7=R7?R7(_6[V7],e[V7],V7,_6,e):u;if(W7===u){W7=e[V7];}if(S7){j4(_6,V7,W7);}else{f4(_6,V7,W7);}}return _6;}
function l5(e,n){return k5(e,N5(e),n);}
function m5(e,n){return k5(e,O5(e),n);}
function n5(e){return R4(function(n,_6){var R7=-1,S7=_6.length,T7=S7>1?_6[S7-1]:u,U7=S7>2?_6[2]:u;T7=(e.length>3&&typeof T7=='function')?(S7--,T7):u;if(U7&&Y5(_6[0],_6[1],U7)){T7=S7<3?u:T7;S7=1;}n=Object(n);while(++R7<S7){var V7=_6[R7];if(V7){e(n,V7,R7,T7);}}return n;});}
function o5(e,n){return function(_6,K7){if(_6==null){return _6;}if(!c7(_6)){return e(_6,K7);}var R7=_6.length,S7=n?R7:-1,T7=Object(_6);while((n?S7--:++S7<R7)){if(K7(T7[S7],S7,T7)===false){break;}}return _6;};}
function p5(e){return function(n,K7,_6){var R7=-1,S7=Object(n),T7=_6(n),U7=T7.length;while(U7--){var V7=T7[e?U7:++R7];if(K7(S7[V7],V7,S7)===false){break;}}return n;};}
function q5(e,n,_6){var R7=n&W,S7=r5(e);function T7(){var fn=(this&&this!==Z1&&this instanceof T7)?S7:e;return fn.apply(R7?_6:this,arguments);}return T7;}
function r5(e){return function(){var n=arguments;switch(n.length){case 0:return new e;case 1:return new e(n[0]);case 2:return new e(n[0],n[1]);case 3:return new e(n[0],n[1],n[2]);case 4:return new e(n[0],n[1],n[2],n[3]);case 5:return new e(n[0],n[1],n[2],n[3],n[4]);case 6:return new e(n[0],n[1],n[2],n[3],n[4],n[5]);case 7:return new e(n[0],n[1],n[2],n[3],n[4],n[5],n[6]);}var _6=B3(e.prototype),R7=e.apply(_6,n);return j7(R7)?R7:_6;};}
function s5(e,n,_6){var R7=r5(e);function S7(){var T7=arguments.length,U7=Array(T7),V7=T7,W7=H5(S7);while(V7--){U7[V7]=arguments[V7];}var X7=(T7<3&&U7[0]!==W7&&U7[T7-1]!==W7)?[]:E2(U7,W7);T7-=X7.length;if(T7<_6){return v5(e,n,t5,S7.placeholder,u,U7,X7,u,u,_6-T7);}var fn=(this&&this!==Z1&&this instanceof S7)?R7:e;return g2(fn,this,U7);}return S7;}
function t5(e,n,_6,R7,S7,T7,U7,V7,W7,X7){var Y7=n&l,Z7=n&W,$7=n&f,_7=n&(h|i),a8=n&o,b8=$7?u:r5(e);function c8(){var d8=arguments.length,e8=Array(d8),f8=d8;while(f8--){e8[f8]=arguments[f8];}if(_7){var g8=H5(c8),h8=y2(e8,g8);}if(R7){e8=h5(e8,R7,S7,_7);}if(T7){e8=i5(e8,T7,U7,_7);}d8-=h8;if(_7&&d8<X7){var i8=E2(e8,g8);return v5(e,n,t5,c8.placeholder,_6,e8,i8,V7,W7,X7-d8);}var j8=Z7?_6:this,fn=$7?j8[e]:e;d8=e8.length;if(V7){e8=k6(e8,V7);}else if(a8&&d8>1){e8.reverse();}if(Y7&&W7<d8){e8.length=W7;}if(this&&this!==Z1&&this instanceof c8){fn=b8||r5(fn);}return fn.apply(j8,e8);}return c8;}
function u5(e,n,_6,R7){var S7=n&W,T7=r5(e);function U7(){var V7=-1,W7=arguments.length,X7=-1,Y7=R7.length,Z7=Array(Y7+W7),fn=(this&&this!==Z1&&this instanceof U7)?T7:e;while(++X7<Y7){Z7[X7]=R7[X7];}while(W7--){Z7[X7++]=arguments[++V7];}return g2(fn,S7?_6:this,Z7);}return U7;}
function v5(e,n,_6,R7,S7,T7,U7,V7,W7,X7){var Y7=n&h,Z7=Y7?U7:u,$7=Y7?u:U7,_7=Y7?T7:u,a8=Y7?u:T7;n|=(Y7?j:k);n&=~(Y7?k:j);if(!(n&g)){n&=~(W|f);}var b8=[e,n,S7,_7,Z7,a8,$7,V7,W7,X7];var c8=_6.apply(u,b8);if(_5(e)){m6(c8,b8);}c8.placeholder=R7;return o6(c8,e,n);}
var w5=!(n3&&(1/F2(new n3([,-0]))[1])==I)?L7:function(H7){return new n3(H7);};
function x5(e,n,_6,R7,S7,T7,U7,V7){var W7=n&f;if(!W7&&typeof e!='function'){throw new TypeError(F);}var X7=R7?R7.length:0;if(!X7){n&=~(j|k);R7=S7=u;}U7=U7===u?U7:h3(u7(U7),0);V7=V7===u?V7:u7(V7);X7-=S7?S7.length:0;if(n&k){var Y7=R7,Z7=S7;R7=S7=u;}var $7=W7?u:F5(e);var _7=[e,n,_6,R7,S7,Y7,Z7,T7,U7,V7];if($7){f6(_7,$7);}e=_7[0];n=_7[1];_6=_7[2];R7=_7[3];S7=_7[4];V7=_7[9]=_7[9]===u?(W7?0:e.length):h3(_7[9]-X7,0);if(!V7&&n&(h|i)){n&=~(h|i);}if(!n||n==W){var a8=q5(e,n,_6);}else if(n==h||n==i){a8=s5(e,n,V7);}else if((n==j||n==(W|j))&&!S7.length){a8=u5(e,n,_6,R7);}else{a8=t5.apply(u,_7);}var b8=$7?T4:m6;return o6(b8(a8,_7),e,n);}
function y5(e){return n7(e)?u:e;}
function z5(e,n,_6,R7,S7,T7){var U7=_6&c,V7=e.length,W7=n.length;if(V7!=W7&&!(U7&&W7>V7)){return false;}var X7=T7.get(e);var Y7=T7.get(n);if(X7&&Y7){return X7==n&&Y7==e;}var Z7=-1,$7=true,_7=(_6&d)?new W3:u;T7.set(e,n);T7.set(n,e);while(++Z7<V7){var a8=e[Z7],b8=n[Z7];if(R7){var c8=U7?R7(b8,a8,Z7,n,e,T7):R7(a8,b8,Z7,e,n,T7);}if(c8!==u){if(c8){continue;}$7=false;break;}if(_7){if(!n2(n,function(b8,d8){if(!x2(_7,d8)&&(a8===b8||S7(a8,b8,_6,R7,T7))){return _7.push(d8);}})){$7=false;break;}}else if(!(a8===b8||S7(a8,b8,_6,R7,T7))){$7=false;break;}}T7['delete'](e);T7['delete'](n);return $7;}
function A5(e,n,_6,R7,S7,T7,U7){switch(_6){case _:if((e.byteLength!=n.byteLength)||(e.byteOffset!=n.byteOffset)){return false;}e=e.buffer;n=n.buffer;case $:if((e.byteLength!=n.byteLength)||!T7(new W2(e),new W2(n))){return false;}return true;case z:case A:case J:return eq(+e,+n);case B:return e.name==n.name&&e.message==n.message;case S:case U:return e==(n+'');case G:var V7=C2;case T:var W7=R7&c;V7||(V7=F2);if(e.size!=n.size&&!W7){return false;}var X7=U7.get(e);if(X7){return X7==n;}R7|=d;U7.set(e,n);var Y7=z5(V7(e),V7(n),R7,S7,T7,U7);U7['delete'](e);return Y7;case X:if(y3){return y3.call(e)==y3.call(n);}}return false;}
function B5(e,n,_6,R7,S7,T7){var U7=_6&c,V7=D5(e),W7=V7.length,X7=D5(n),Y7=X7.length;if(W7!=Y7&&!U7){return false;}var Z7=W7;while(Z7--){var $7=V7[Z7];if(!(U7?$7 in n:P2.call(n,$7))){return false;}}var _7=T7.get(e);var a8=T7.get(n);if(_7&&a8){return _7==n&&a8==e;}var b8=true;T7.set(e,n);T7.set(n,e);var c8=U7;while(++Z7<W7){$7=V7[Z7];var d8=e[$7],e8=n[$7];if(R7){var f8=U7?R7(e8,d8,$7,n,e,T7):R7(d8,e8,$7,e,n,T7);}if(!(f8===u?(d8===e8||S7(d8,e8,_6,R7,T7)):f8)){b8=false;break;}c8||(c8=$7=='constructor');}if(b8&&!c8){var g8=e.constructor,h8=n.constructor;if(g8!=h8&&('constructor'in e&&'constructor'in n)&&!(typeof g8=='function'&&g8 instanceof g8&&typeof h8=='function'&&h8 instanceof h8)){b8=false;}}T7['delete'](e);T7['delete'](n);return b8;}
function C5(e){return n6(i6(e,u,y6),e+'');}
function D5(e){return s4(e,A7,N5);}
function E5(e){return s4(e,B7,O5);}
var F5=!q3?L7:function(e){return q3.get(e);};
function G5(e){var n=(e.name+''),_6=r3[n],R7=P2.call(r3,n)?_6.length:0;while(R7--){var S7=_6[R7],T7=S7.func;if(T7==null||T7==e){return S7.name;}}return n;}
function H5(e){var n=P2.call(A3,'placeholder')?A3:e;return n.placeholder;}
function I5(){var e=A3.iteratee||K7;e=e===K7?F4:e;return arguments.length?e(arguments[0],arguments[1]):e;}
function J5(U6,e){var n=U6.__data__;return $5(e)?n[typeof e=='string'?'string':'hash']:n.map;}
function K5(e){var n=A7(e),_6=n.length;while(_6--){var R7=n[_6],S7=e[R7];n[_6]=[R7,S7,c6(S7)];}return n;}
function L5(e,n){var _6=z2(e,n);return C4(_6)?_6:u;}
function M5(n){var _6=P2.call(n,c3),R7=n[c3];try{n[c3]=u;var S7=true;}catch(e){}var T7=R2.call(n);if(S7){if(_6){n[c3]=R7;}else{delete n[c3];}}return T7;}
var N5=!e3?N7:function(e){if(e==null){return[];}e=Object(e);return i2(e3(e),function(n){return $2.call(e,n);});};var O5=!e3?N7:function(e){var n=[];while(e){m2(n,N5(e));e=Y2(e);}return n;};var P5=t4;if((k3&&P5(new k3(new ArrayBuffer(1)))!=_)||(l3&&P5(new l3)!=G)||(m3&&P5(m3.resolve())!=Q)||(n3&&P5(new n3)!=T)||(o3&&P5(new o3)!=Z)){P5=function(e){var n=t4(e),_6=n==O?e.constructor:u,R7=_6?s6(_6):'';if(R7){switch(R7){case s3:return _;case t3:return G;case u3:return Q;case v3:return T;case w3:return Z;}}return n;};}
function Q5(e){var n=e.match(q1);return n?n[1].split(r1):[];}
function R5(e,n,_6){n=a5(n,e);var R7=-1,S7=n.length,T7=false;while(++R7<S7){var U7=r6(n[R7]);if(!(T7=e!=null&&_6(e,U7))){break;}e=e[U7];}if(T7||++R7!=S7){return T7;}S7=e==null?0:e.length;return!!S7&&i7(S7)&&X5(U7,S7)&&(b7(e)||a7(e));}
function S5(e){var n=e.length,_6=new e.constructor(n);if(n&&typeof e[0]=='string'&&P2.call(e,'index')){_6.index=e.index;_6.input=e.input;}return _6;}
function T5(e){return(typeof e.constructor=='function'&&!b6(e))?B3(Y2(e)):{};}
function U5(e,n,_6){var R7=e.constructor;switch(n){case $:return c5(e);case z:case A:return new R7(+e);case _:return d5(e,_6);case a1:case b1:case c1:case d1:case e1:case f1:case g1:case h1:case i1:return g5(e,_6);case G:return new R7;case J:case U:return new R7(e);case S:return e5(e);case T:return new R7;case X:return f5(e);}}
function V5(e,n){var _6=n.length;if(!_6){return e;}var R7=_6-1;n[R7]=(_6>1?'& ':'')+n[R7];n=n.join(_6>2?', ':' ');return e.replace(p1,'{\n/* [wrapped with '+n+'] */\n');}
function W5(e){return b7(e)||a7(e)||!!(a3&&e&&e[a3]);}
function X5(e,n){var _6=typeof e;n=n==null?r:n;return!!n&&(_6=='number'||(_6!='symbol'&&y1.test(e)))&&(e>-1&&e%1==0&&e<n);}
function Y5(e,n,_6){if(!j7(_6)){return false;}var R7=typeof n;if(R7=='number'?(c7(_6)&&X5(n,_6.length)):(R7=='string'&&n in _6)){return eq(_6[n],e);}return false;}
function Z5(e,n){if(b7(e)){return false;}var _6=typeof e;if(_6=='number'||_6=='symbol'||_6=='boolean'||e==null||q7(e)){return true;}return k1.test(e)||!j1.test(e)||(n!=null&&e in Object(n));}
function $5(e){var n=typeof e;return(n=='string'||n=='number'||n=='symbol'||n=='boolean')?(e!=='__proto__'):(e===null);}
function _5(e){var n=G5(e),_6=A3[n];if(typeof _6!='function'||!(n in D3.prototype)){return false;}if(e===_6){return true;}var R7=F5(_6);return!!R7&&e===R7[0];}
function a6(e){return!!Q2&&(Q2 in e);}
function b6(e){var n=e&&e.constructor,_6=(typeof n=='function'&&n.prototype)||M2;return e===_6;}
function c6(e){return e===e&&!j7(e);}
function d6(e,n){return function(_6){if(_6==null){return false;}return _6[e]===n&&(n!==u||(e in Object(_6)));};}
function e6(e){var n=Y6(e,function(R7){if(_6.size===M){_6.clear();}return R7;});var _6=n.cache;return n;}
function f6(e,n){var _6=e[1],R7=n[1],S7=_6|R7,T7=S7<(W|f|l);var U7=((R7==l)&&(_6==h))||((R7==l)&&(_6==m)&&(e[7].length<=n[8]))||((R7==(l|m))&&(n[7].length<=n[8])&&(_6==h));if(!(T7||U7)){return e;}if(R7&W){e[2]=n[2];S7|=_6&W?0:g;}var V7=n[3];if(V7){var W7=e[3];e[3]=W7?h5(W7,V7,n[4]):V7;e[4]=W7?E2(e[3],P):n[4];}V7=n[5];if(V7){W7=e[5];e[5]=W7?i5(W7,V7,n[6]):V7;e[6]=W7?E2(e[5],P):n[6];}V7=n[7];if(V7){e[7]=V7;}if(R7&l){e[8]=e[8]==null?n[8]:i3(e[8],n[8]);}if(e[9]==null){e[9]=n[9];}e[0]=n[0];e[1]=S7;return e;}
function g6(e){var n=[];if(e!=null){for(var _6 in Object(e)){n.push(_6);}}return n;}
function h6(e){return R2.call(e);}
function i6(e,n,_6){n=h3(n===u?(e.length-1):n,0);return function(){var R7=arguments,S7=-1,T7=h3(R7.length-n,0),U7=Array(T7);while(++S7<T7){U7[S7]=R7[n+S7];}S7=-1;var V7=Array(n+1);while(++S7<n){V7[S7]=R7[S7];}V7[n]=_6(U7);return g2(e,this,V7);};}
function j6(e,n){return n.length<2?e:r4(e,V4(n,0,-1));}
function k6(e,n){var _6=e.length,R7=i3(n.length,_6),S7=j5(e);while(R7--){var T7=n[R7];e[R7]=X5(T7,_6)?S7[T7]:u;}return e;}
function l6(e,n){if(n==='constructor'&&typeof e[n]==='function'){return;}if(n=='__proto__'){return;}return e[n];}
var m6=p6(T4);var n6=p6(U4);
function o6(e,n,_6){var R7=(n+'');return n6(e,V5(R7,t6(Q5(R7),_6)));}
function p6(e){var n=0,_6=0;return function(){var R7=j3(),S7=q-(R7-_6);_6=R7;if(S7>0){if(++n>=p){return arguments[0];}}else{n=0;}return e.apply(u,arguments);};}
var q6=e6(function(e){var n=[];if(e.charCodeAt(0)===46){n.push('');}e.replace(l1,function(_6,R7,S7,T7){n.push(S7?T7.replace(s1,'$1'):(R7||_6));});return n;});
function r6(e){if(typeof e=='string'||q7(e)){return e;}var n=(e+'');return(n=='0'&&(1/e)==-I)?'-0':n;}
function s6(n){if(n!=null){try{return O2.call(n);}catch(e){}try{return(n+'');}catch(e){}}return'';}
function t6(e,n){h2(w,function(_6){var R7='_.'+_6[0];if((n&_6[1])&&!j2(e,R7)){e.push(R7);}});return e.sort();}
function u6(e){var n=-1,_6=e==null?0:e.length,R7=0,S7=[];while(++n<_6){var T7=e[n];if(T7){S7[R7++]=T7;}}return S7;}
var v6=R4(function(e,H7){return d7(e)?l4(e,o4(H7,1,d7,true)):[];});var w6=R4(function(e,H7){var K7=E6(H7);if(d7(K7)){K7=u;}return d7(e)?l4(e,o4(H7,1,d7,true),I5(K7,2)):[];});var x6=R4(function(e,H7){var n=E6(H7);if(d7(n)){n=u;}return d7(e)?l4(e,o4(H7,1,d7,true),u,n):[];});
function y6(e){var n=e==null?0:e.length;return n?o4(e,1):[];}
function z6(e){var n=e==null?0:e.length;return n?o4(e,I):[];}
function A6(e,n){var _6=e==null?0:e.length;if(!_6){return[];}n=n===u?1:u7(n);return o4(e,n);}
var B6=R4(function(e){var n=l2(e,_4);return(n.length&&n[0]===e[0])?w4(n):[];});var C6=R4(function(e){var K7=E6(e),n=l2(e,_4);if(K7===E6(n)){K7=u;}else{n.pop();}return(n.length&&n[0]===e[0])?w4(n,I5(K7,2)):[];});var D6=R4(function(e){var n=E6(e),_6=l2(e,_4);n=typeof n=='function'?n:u;if(n){_6.pop();}return(_6.length&&_6[0]===e[0])?w4(_6,u,n):[];});
function E6(e){var n=e==null?0:e.length;return n?e[n-1]:u;}
var F6=R4(function(e){return X4(o4(e,1,d7,true));});var G6=R4(function(e){var K7=E6(e);if(d7(K7)){K7=u;}return X4(o4(e,1,d7,true),I5(K7,2));});var H6=R4(function(e){var n=E6(e);n=typeof n=='function'?n:u;return X4(o4(e,1,d7,true),u,n);});
function I6(e){return(e&&e.length)?X4(e):[];}
function J6(e,K7){return(e&&e.length)?X4(e,I5(K7,2)):[];}
function K6(e,n){n=typeof n=='function'?n:u;return(e&&e.length)?X4(e,u,n):[];}
var L6=R4(function(e,H7){return d7(e)?l4(e,H7):[];});var M6=R4(function(e){return Z4(i2(e,d7));});var N6=R4(function(e){var K7=E6(e);if(d7(K7)){K7=u;}return Z4(i2(e,d7),I5(K7,2));});var O6=R4(function(e){var n=E6(e);n=typeof n=='function'?n:u;return Z4(i2(e,d7),u,n);});
function P6(e,H7){return $4(e||[],H7||[],f4);}
function Q6(e,H7){return $4(e||[],H7||[],S4);}
function R6(e,K7){return o4(U6(e,K7),1);}
function S6(e,K7){return o4(U6(e,K7),I);}
function T6(e,K7,n){n=n===u?1:u7(n);return o4(U6(e,K7),n);}
function U6(e,K7){var n=b7(e)?l2:J4;return n(e,I5(K7,3));}
var V6=function(){return Z1.Date.now();};
function W6(e,n,_6){n=_6?u:n;var R7=x5(e,h,u,u,u,u,u,n);R7.placeholder=W6.placeholder;return R7;}
function X6(e,n,_6){var R7,S7,T7,U7,V7,W7,X7=0,Y7=false,Z7=false,$7=true;if(typeof e!='function'){throw new TypeError(F);}n=v7(n)||0;if(j7(_6)){Y7=!!_6.leading;Z7='maxWait'in _6;T7=Z7?h3(v7(_6.maxWait)||0,n):T7;$7='trailing'in _6?!!_6.trailing:$7;}function _7(i8){var j8=R7,k8=S7;R7=S7=u;X7=i8;U7=e.apply(k8,j8);return U7;}function a8(i8){X7=i8;V7=setTimeout(d8,n);return Y7?_7(i8):U7;}function b8(i8){var j8=i8-W7,k8=i8-X7,l8=n-j8;return Z7?i3(l8,T7-k8):l8;}function c8(i8){var j8=i8-W7,k8=i8-X7;return(W7===u||(j8>=n)||(j8<0)||(Z7&&k8>=T7));}function d8(){var i8=V6();if(c8(i8)){return e8(i8);}V7=setTimeout(d8,b8(i8));}function e8(i8){V7=u;if($7&&R7){return _7(i8);}R7=S7=u;return U7;}function f8(){if(V7!==u){clearTimeout(V7);}X7=0;R7=W7=S7=V7=u;}function g8(){return V7===u?U7:e8(V6());}function h8(){var i8=V6(),j8=c8(i8);R7=arguments;S7=this;W7=i8;if(j8){if(V7===u){return a8(W7);}if(Z7){clearTimeout(V7);V7=setTimeout(d8,n);return _7(W7);}}if(V7===u){V7=setTimeout(d8,n);}return U7;}h8.cancel=f8;h8.flush=g8;return h8;}
function Y6(e,n){if(typeof e!='function'||(n!=null&&typeof n!='function')){throw new TypeError(F);}var _6=function(){var R7=arguments,S7=n?n.apply(this,R7):R7[0],T7=_6.cache;if(T7.has(S7)){return T7.get(S7);}var U7=e.apply(this,R7);_6.cache=T7.set(S7,U7)||T7;return U7;};_6.cache=new(Y6.Cache||Q3);return _6;}
Y6.Cache=Q3;
function Z6(e,n,_6){var R7=true,S7=true;if(typeof e!='function'){throw new TypeError(F);}if(j7(_6)){R7='leading'in _6?!!_6.leading:R7;S7='trailing'in _6?!!_6.trailing:S7;}return X6(e,n,{'leading':R7,'maxWait':n,'trailing':S7});}
function $6(){if(!arguments.length){return[];}var e=arguments[0];return b7(e)?e:[e];}
function eq(e,n){return e===n||(e!==e&&n!==n);}
var a7=x4(function(){return arguments;}())?x4:function(e){return k7(e)&&P2.call(e,'callee')&&!$2.call(e,'callee');};var b7=Array.isArray;
function c7(e){return e!=null&&i7(e.length)&&!h7(e);}
function d7(e){return k7(e)&&c7(e);}
var e7=f3||O7;
function f7(e,n){return y4(e,n);}
function g7(e,n,_6){_6=typeof _6=='function'?_6:u;var R7=_6?_6(e,n):u;return R7===u?y4(e,n,u,_6):!!R7;}
function h7(e){if(!j7(e)){return false;}var n=t4(e);return n==D||n==E||n==y||n==R;}
function i7(e){return typeof e=='number'&&e>-1&&e%1==0&&e<=r;}
function j7(e){var n=typeof e;return e!=null&&(n=='object'||n=='function');}
function k7(e){return e!=null&&typeof e=='object';}
var l7=d2?v2(d2):A4;
function m7(e){return e==null;}
function n7(e){if(!k7(e)||t4(e)!=O){return false;}var n=Y2(e);if(n===null){return true;}var _6=P2.call(n,'constructor')&&n.constructor;return typeof _6=='function'&&_6 instanceof _6&&O2.call(_6)==S2;}
var o7=e2?v2(e2):D4;
function p7(e){return typeof e=='string'||(!b7(e)&&k7(e)&&t4(e)==U);}
function q7(e){return typeof e=='symbol'||(k7(e)&&t4(e)==X);}
var r7=f2?v2(f2):E4;
function s7(e){if(!e){return[];}if(c7(e)){return p7(e)?H2(e):j5(e);}if(b3&&e[b3]){return B2(e[b3]());}var n=P5(e),_6=n==G?C2:(n==T?F2:H7);return _6(e);}
function t7(e){if(!e){return e===0?e:0;}e=v7(e);if(e===I||e===-I){var n=(e<0?-1:1);return n*s;}return e===e?e:0;}
function u7(e){var n=t7(e),_6=n%1;return n===n?(_6?n-_6:n):0;}
function v7(e){if(typeof e=='number'){return e;}if(q7(e)){return N;}if(j7(e)){var n=typeof e.valueOf=='function'?e.valueOf():e;e=j7(n)?(n+''):n;}if(typeof e!='string'){return e===0?e:+e;}e=u2(e);var _6=v1.test(e);return(_6||x1.test(e))?W1(e.slice(2),_6?2:8):(u1.test(e)?N:+e);}
function w7(e){return k5(e,B7(e));}
function x7(e){return e==null?'':W4(e);}
function y7(e,n,_6){var R7=e==null?u:r4(e,n);return R7===u?_6:R7;}
function z7(e,n){return e!=null&&R5(e,n,v4);}
function A7(e){return c7(e)?d4(e):G4(e);}
function B7(e){return c7(e)?d4(e,true):H4(e);}
var C7=n5(function(e,n,_6){M4(e,n,_6);});var D7=n5(function(e,n,_6,R7){M4(e,n,_6,R7);});var E7=C5(function(e,n){var _6={};if(e==null){return _6;}var R7=false;n=l2(n,function(T7){T7=a5(T7,e);R7||(R7=T7.length>1);return T7;});k5(e,E5(e),_6);if(R7){_6=k4(_6,C|a|b,y5);}var S7=n.length;while(S7--){Y4(_6,n[S7]);}return _6;});var F7=C5(function(e,n){return e==null?{}:O4(e,n);});
function G7(e,n){if(e==null){return{};}var _6=l2(E5(e),function(R7){return[R7];});n=I5(n);return P4(e,_6,function(R7,S7){return n(R7,S7[0]);});}
function H7(e){return e==null?[]:w2(e,A7(e));}
function I7(e){return function(){return e;};}
function J7(e){return e;}
function K7(e){return F4(typeof e=='function'?e:k4(e,C));}
function L7(){}
function M7(e){return Z5(e)?s2(r6(e)):Q4(e);}
function N7(){return[];}
function O7(){return false;}
function P7(e){return(e&&e.length)?n4(e,J7,u4):u;}
function Q7(e){return(e&&e.length)?n4(e,J7,I4):u;}
A3.castArray=$6;A3.compact=u6;A3.constant=I7;A3.curry=W6;A3.debounce=X6;A3.difference=v6;A3.differenceBy=w6;A3.differenceWith=x6;A3.flatMap=R6;A3.flatMapDeep=S6;A3.flatMapDepth=T6;A3.flatten=y6;A3.flattenDeep=z6;A3.flattenDepth=A6;A3.intersection=B6;A3.intersectionBy=C6;A3.intersectionWith=D6;A3.iteratee=K7;A3.keys=A7;A3.keysIn=B7;A3.map=U6;A3.memoize=Y6;A3.merge=C7;A3.mergeWith=D7;A3.omit=E7;A3.pick=F7;A3.pickBy=G7;A3.property=M7;A3.throttle=Z6;A3.toArray=s7;A3.toPlainObject=w7;A3.union=F6;A3.unionBy=G6;A3.unionWith=H6;A3.uniq=I6;A3.uniqBy=J6;A3.uniqWith=K6;A3.values=H7;A3.without=L6;A3.xor=M6;A3.xorBy=N6;A3.xorWith=O6;A3.zipObject=P6;A3.zipObjectDeep=Q6;A3.eq=eq;A3.get=y7;A3.hasIn=z7;A3.identity=J7;A3.isArguments=a7;A3.isArray=b7;A3.isArrayLike=c7;A3.isArrayLikeObject=d7;A3.isBuffer=e7;A3.isEqual=f7;A3.isEqualWith=g7;A3.isFunction=h7;A3.isLength=i7;A3.isMap=l7;A3.isNil=m7;A3.isObject=j7;A3.isObjectLike=k7;A3.isPlainObject=n7;A3.isSet=o7;A3.isString=p7;A3.isSymbol=q7;A3.isTypedArray=r7;A3.last=E6;A3.max=P7;A3.min=Q7;A3.stubArray=N7;A3.stubFalse=O7;A3.noop=L7;A3.now=V6;A3.toFinite=t7;A3.toInteger=u7;A3.toNumber=v7;A3.toString=x7;A3.VERSION=V;W6.placeholder=A3;return A3;});
/*!
 * Copyright (c) Sindre Sorhus <sindresorhus@gmail.com> (sindresorhus.com)
 * Version 2.0.0, see https://github.com/sindresorhus/p-cancelable/tree/v2.0.0
 */
sap.ui.predefine('sap/base/util/restricted/_CancelablePromise',function(){'use strict';
function _(o,a){var p;if(typeof Symbol==="undefined"||o[Symbol.iterator]==null){if(Array.isArray(o)||(p=b(o))||a&&o&&typeof o.length==="number"){if(p)o=p;var i=0;var F=function F(){};return{s:F,n:function n(){if(i>=o.length)return{done:true};return{done:false,value:o[i++]};},e:function e(f){throw f;},f:F};}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");}var y=true,z=false,A;return{s:function s(){p=o[Symbol.iterator]();},n:function n(){var s=p.next();y=s.done;return s;},e:function e(f){z=true;A=f;},f:function f(){try{if(!y&&p.return!=null)p.return();}finally{if(z)throw A;}}};}
function b(o,a){if(!o)return;if(typeof o==="string")return c(o,a);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return c(o,a);}
function c(a,e){if(e==null||e>a.length)e=a.length;for(var i=0,f=new Array(e);i<e;i++){f[i]=a[i];}return f;}
function d(o){"@babel/helpers - typeof";if(typeof Symbol==="function"&&typeof Symbol.iterator==="symbol"){d=function d(o){return typeof o;};}else{d=function d(o){return o&&typeof Symbol==="function"&&o.constructor===Symbol&&o!==Symbol.prototype?"symbol":typeof o;};}return d(o);}
function g(i,a){if(!(i instanceof a)){throw new TypeError("Cannot call a class as a function");}}
function h(a,p){for(var i=0;i<p.length;i++){var e=p[i];e.enumerable=e.enumerable||false;e.configurable=true;if("value"in e)e.writable=true;Object.defineProperty(a,e.key,e);}}
function j(a,p,s){if(p)h(a.prototype,p);if(s)h(a,s);return a;}
function k(s,a){if(typeof a!=="function"&&a!==null){throw new TypeError("Super expression must either be null or a function");}s.prototype=Object.create(a&&a.prototype,{constructor:{value:s,writable:true,configurable:true}});if(a)w(s,a);}
function l(D){var a=u();return function f(){var S=x(D),e;if(a){var N=x(this).constructor;e=Reflect.construct(S,arguments,N);}else{e=S.apply(this,arguments);}return m(this,e);};}
function m(s,a){if(a&&(d(a)==="object"||typeof a==="function")){return a;}return q(s);}
function q(s){if(s===void 0){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return s;}
function r(a){var e=typeof Map==="function"?new Map():undefined;r=function r(a){if(a===null||!v(a))return a;if(typeof a!=="function"){throw new TypeError("Super expression must either be null or a function");}if(typeof e!=="undefined"){if(e.has(a))return e.get(a);e.set(a,W);}function W(){return t(a,arguments,x(this).constructor);}W.prototype=Object.create(a.prototype,{constructor:{value:W,enumerable:false,writable:true,configurable:true}});return w(W,a);};return r(a);}
function t(e,f,i){if(u()){t=Reflect.construct;}else{t=function t(e,f,i){var a=[null];a.push.apply(a,f);var n=Function.bind.apply(e,a);var o=new n();if(i)w(o,i.prototype);return o;};}return t.apply(null,arguments);}
function u(){if(typeof Reflect==="undefined"||!Reflect.construct)return false;if(Reflect.construct.sham)return false;if(typeof Proxy==="function")return true;try{Date.prototype.toString.call(Reflect.construct(Date,[],function(){}));return true;}catch(e){return false;}}
function v(f){return Function.toString.call(f).indexOf("[native code]")!==-1;}
function w(o,p){w=Object.setPrototypeOf||function w(o,p){o.__proto__=p;return o;};return w(o,p);}
function x(o){x=Object.setPrototypeOf?Object.getPrototypeOf:function x(o){return o.__proto__||Object.getPrototypeOf(o);};return x(o);}
var C=function(a){k(C,a);var e=l(C);function C(f){var i;g(this,C);i=e.call(this,f||'Promise was canceled');i.name='CancelError';return i;}j(C,[{key:"isCanceled",get:function f(){return true;}}]);return C;}(r(Error));var P=function(){j(P,null,[{key:"fn",value:function f(a){return function(){for(var e=arguments.length,i=new Array(e),n=0;n<e;n++){i[n]=arguments[n];}return new P(function(o,p,s){i.push(s);a.apply(void 0,i).then(o,p);});};}}]);function P(e){var a=this;g(this,P);this._cancelHandlers=[];this._isPending=true;this._isCanceled=false;this._rejectOnCancel=true;this._promise=new Promise(function(f,i){a._reject=i;var o=function o(s){a._isPending=false;f(s);};var n=function n(s){a._isPending=false;i(s);};var p=function p(s){if(!a._isPending){throw new Error('The `onCancel` handler was attached after the promise settled.');}a._cancelHandlers.push(s);};Object.defineProperties(p,{shouldReject:{get:function s(){return a._rejectOnCancel;},set:function y(s){a._rejectOnCancel=s;}}});return e(o,n,p);});}j(P,[{key:"then",value:function e(o,a){return this._promise.then(o,a);}},{key:"catch",value:function a(o){return this._promise.catch(o);}},{key:"finally",value:function a(o){return this._promise.finally(o);}},{key:"cancel",value:function p(a){if(!this._isPending||this._isCanceled){return;}if(this._cancelHandlers.length>0){try{var e=_(this._cancelHandlers),f;try{for(e.s();!(f=e.n()).done;){var i=f.value;i();}}catch(n){e.e(n);}finally{e.f();}}catch(o){this._reject(o);}}this._isCanceled=true;if(this._rejectOnCancel){this._reject(new C(a));}}},{key:"isCanceled",get:function a(){return this._isCanceled;}}]);return P;}();Object.setPrototypeOf(P.prototype,Promise.prototype);P.CancelError=C;return P;});
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('jquery.sap.act',['sap/ui/util/ActivityDetection','jquery.sap.global'],function(A,q){"use strict";q.sap.act=A;return q;});
sap.ui.predefine('jquery.sap.encoder',['jquery.sap.global','sap/base/security/encodeXML','sap/base/security/encodeJS','sap/base/security/encodeURL','sap/base/security/encodeURLParameters','sap/base/security/encodeCSS','sap/base/security/URLListValidator','sap/base/security/URLWhitelist','sap/base/security/sanitizeHTML'],function(q,e,a,b,c,d,U,f,s){"use strict";q.sap.encodeHTML=e;q.sap.encodeXML=e;q.sap.escapeHTML=e;q.sap.encodeJS=a;q.sap.escapeJS=a;q.sap.encodeURL=b;q.sap.encodeURLParameters=c;q.sap.encodeCSS=d;q.sap.clearUrlWhitelist=U.clear;q.sap.addUrlWhitelist=U.add.bind(f);
q.sap.removeUrlWhitelist=function(i){U._delete(U.entries()[i]);};
q.sap.getUrlWhitelist=U.entries;q.sap.validateUrl=U.validate;q.sap._sanitizeHTML=s;return q;});
sap.ui.predefine('jquery.sap.events',['jquery.sap.global','sap/ui/events/ControlEvents','sap/ui/events/PseudoEvents','sap/ui/events/checkMouseEnterOrLeave','sap/ui/events/isSpecialKey','sap/ui/events/isMouseEventDelayed','sap/ui/events/F6Navigation','sap/ui/events/jquery/EventSimulation','sap/ui/events/KeyCodes','sap/base/util/defineCoupledProperty','sap/ui/events/jquery/EventExtension'],function(q,C,P,c,i,I,F,E,K,d){"use strict";q.sap.PseudoEvents=P.events;q.sap.ControlEvents=C.events;q.sap.disableTouchToMouseHandling=E.disableTouchToMouseHandling;d(q.sap,"touchEventMode",E,"touchEventMode");q.sap.bindAnyEvent=C.bindAnyEvent;q.sap.unbindAnyEvent=C.unbindAnyEvent;q.sap.checkMouseEnterOrLeave=c;
q.sap.isSpecialKey=function(e){if(e.key){return i(e);}function a(e){var k=e.which;return(k===K.SHIFT)||(k===K.CONTROL)||(k===K.ALT)||(k===K.CAPS_LOCK)||(k===K.NUM_LOCK);}function b(e){var k=e.which,A=(k>=37&&k<=40);switch(e.type){case"keydown":case"keyup":return A;case"keypress":return k===0;default:return false;}}var k=e.which,s=a(e)||b(e)||(k>=33&&k<=36)||(k>=44&&k<=46)||(k>=112&&k<=123)||(k===K.BREAK)||(k===K.BACKSPACE)||(k===K.TAB)||(k===K.ENTER)||(k===K.ESCAPE)||(k===K.SCROLL_LOCK);switch(e.type){case"keydown":case"keyup":return s;case"keypress":return(k===0||k===K.BACKSPACE||k===K.ESCAPE||k===K.ENTER)||false;default:return false;}};
q.sap.handleF6GroupNavigation=function(e,s){if(!e.key&&e.keyCode===K.F6){e.key="F6";}return F.handleF6GroupNavigation(e,s);};
q.sap._FASTNAVIGATIONKEY=F.fastNavigationKey;
q.sap._refreshMouseEventDelayedFlag=function(n){q.sap.isMouseEventDelayed=I.apply(this,arguments);};
q.sap._refreshMouseEventDelayedFlag(navigator);return q;});
sap.ui.predefine('jquery.sap.history',["jquery.sap.global","sap/base/Log","sap/base/util/uid","sap/base/strings/escapeRegExp"],function(q,L,u,e){"use strict";(function(w){var s="_skip",r=/\|id-[0-9]+-[0-9]+/,a=new RegExp(s+"[0-9]*$"),b=[],h=[],S={},c=0,d,I="|",H=[],f=false,g,j=false;
q.sap.history=function(B){if(!q.isPlainObject(B)){return;}if(!j){var W=q(w),C=(w.location.href.split("#")[1]||"");W.on('hashchange',l);if(Array.isArray(B.routes)){var i,D;for(i=0;i<B.routes.length;i++){D=B.routes[i];if(D.path&&D.handler){q.sap.history.addRoute(D.path,D.handler);}}}if(typeof B.defaultHandler==="function"){g=B.defaultHandler;}h.push(C);if(C.length>1){W.trigger("hashchange",[true]);}else{d=C;}j=true;}};
q.sap.history.addHistory=function(i,B,C,V){var U,D;if(C===undefined){C=true;}if(!V){D=p(i,B);U=o(D);if(U){D+=(I+U);}D+=(I+(C?"1":"0"));}else{D=n(d);}H.push(D);S[D]=true;w.location.hash=D;return D;};
q.sap.history.addVirtualHistory=function(){q.sap.history.addHistory("",undefined,false,true);};
q.sap.history.addRoute=function(i,B,T){if(T){B=q.proxy(B,T);}var R={};R.sIdentifier=i;R['action']=B;b.push(R);return this;};
q.sap.history.setDefaultHandler=function(i){g=i;};
q.sap.history.getDefaultHandler=function(){return g;};
q.sap.history.backToHash=function(i){i=i||"";var B;if(h.length===1){if(typeof g==="function"){g();}}else{B=k(d,i);if(B<0){w.history.go(B);}else{L.error("jQuery.sap.history.backToHash: "+i+"is not in the history stack or it's after the current hash");}}};
q.sap.history.backThroughPath=function(P){P=P||"";P=w.encodeURIComponent(P);var i;if(h.length===1){if(typeof g==="function"){g();}}else{i=k(d,P,true);if(i<0){w.history.go(i);}else{L.error("jQuery.sap.history.backThroughPath: there's no history state which has the "+P+" identifier in the history stack before the current hash");}}};
q.sap.history.back=function(i){if(h.length===1){if(typeof g==="function"){g(q.sap.history.NavType.Back);}}else{if(!i){i=1;}w.history.go(-1*i);}};
q.sap.history.NavType={Back:"_back",Forward:"_forward",Bookmark:"_bookmark",Unknown:"_unknown"};
function k(C,T,P){var B=h.indexOf(C),D,i,E;if(B>0){if(P){for(i=B-1;i>=0;i--){E=h[i];if(E.indexOf(T)===0&&!v(E)){return i-B;}}}else{D=h.indexOf(T);if((D===-1)&&T.length===0){return-1*B;}if((D>-1)&&(D<B)){return D-B;}}}return 0;}
function l(E,M){var i=(w.location.href.split("#")[1]||"");i=m(i);if(M||!S[i]){H.push(i);}if(!f){f=true;if(H.length>0){var B=H.shift();if(S[B]){t(B);delete S[B];}else{y(B);}d=B;}f=false;}}
function m(i,R){var B=i,C=i?i.indexOf("#"):-1;if(C===0){B=B.slice(C+1);}if(R){B=B.replace(r,"");}return B;}
function n(i){var P=i?i:"";if(v(P)){var B=P.lastIndexOf(s);P=P.slice(0,B);}return P+s+c++;}
function p(i,B){var E=encodeURIComponent(i);var C=encodeURIComponent(JSON.stringify(B));return E+I+C;}
function o(B){var C=h.indexOf(d),i,D;if(C>-1){for(i=0;i<C+1;i++){D=h[i];if(D.slice(0,D.length-2)===B){return u();}}}return"";}
function t(i){var B=h.indexOf(d);if(!(B===-1||B===h.length-1)){h.splice(B+1,h.length-1-B);}h.push(i);}
function v(i){return a.test(i);}
function x(C,F){var B=h.indexOf(C),i;if(B!==-1){if(F){for(i=B;i<h.length;i++){if(!v(h[i])){return i-B;}}}else{for(i=B;i>=0;i--){if(!v(h[i])){return i-B;}}return-1*(B+1);}}}
function y(i){var R,B,P,N,C;if(d===undefined){P=A(i);if(!P||!P.bBookmarkable){if(typeof g==="function"){g(q.sap.history.NavType.Bookmark);}return;}}if(i.length===0){if(typeof g==="function"){g(q.sap.history.NavType.Back);}}else{N=h.indexOf(i);if(N===0){P=A(i);if(!P||!P.bBookmarkable){if(typeof g==="function"){g(q.sap.history.NavType.Back);}return;}}if(v(i)){if(v(d)){B=x(i,false);w.history.go(B);}else{var D=new RegExp(e(d+s)+"[0-9]*$");if(D.test(i)){B=x(i,true);if(B){w.history.go(B);}else{w.history.back();}}else{B=x(i,false);w.history.go(B);}}}else{if(N===-1){C=q.sap.history.NavType.Unknown;h.push(i);}else{if(h.indexOf(d,N+1)===-1){C=q.sap.history.NavType.Forward;}else{C=q.sap.history.NavType.Back;}}P=A(i);if(P){R=z(P.sIdentifier);if(R){R.action.apply(null,[P.oStateData,C]);}}else{L.error("hash format error! The current Hash: "+i);}}}}
function z(B){var i;for(i=0;i<b.length;i++){if(b[i].sIdentifier===B){return b[i];}}}
function A(B){if(v(B)){var i=B.lastIndexOf(s);B=B.slice(0,i);}var P=B.split(I),R={};if(P.length===4||P.length===3){R.sIdentifier=w.decodeURIComponent(P[0]);R.oStateData=JSON.parse(w.decodeURIComponent(P[1]));if(P.length===4){R.uid=P[2];}R.bBookmarkable=P[P.length-1]==="0"?false:true;return R;}else{return null;}}
})(this);return q;});
sap.ui.predefine('jquery.sap.keycodes',['jquery.sap.global','sap/ui/events/KeyCodes'],function(q,K){"use strict";q.sap.KeyCodes=K;return q;});
sap.ui.predefine('jquery.sap.mobile',['jquery.sap.global','sap/ui/util/Mobile','sap/ui/Device'],function(q,M,D){"use strict";
function g(t,p){var d=Object.getOwnPropertyDescriptor(t,p);return d&&d.value;}
(function(){q.os=q.extend({os:D.os.name,version:D.os.versionStr,fVersion:D.os.version},g(q,"os"));q.os[D.os.name]=true;q.device=q.extend({},g(q,"device"));q.device.is=q.extend({standalone:window.navigator.standalone,landscape:D.orientation.landscape,portrait:D.orientation.portrait,iphone:D.os.ios&&D.system.phone,ipad:D.os.ios&&D.system.tablet,android_phone:D.system.phone&&D.os.android,android_tablet:D.system.tablet&&D.os.android,tablet:D.system.tablet,phone:D.system.phone,desktop:D.system.desktop},q.device.is);})();q.sap.initMobile=M.init;q.sap.setIcons=M.setIcons;q.sap.setMobileWebAppCapable=M.setWebAppCapable;return q;});
sap.ui.predefine('jquery.sap.promise',[],function(){"use strict";});
sap.ui.predefine('jquery.sap.properties',['jquery.sap.global','sap/base/util/Properties'],function(q,P){"use strict";q.sap.properties=P.create;return q;});
sap.ui.predefine('jquery.sap.resources',['sap/base/i18n/ResourceBundle','jquery.sap.global'],function(R,q){"use strict";
q.sap.resources=function(){return R.create.apply(R,arguments);};
q.sap.resources.isBundle=function(b){return b instanceof R;};
q.sap.resources._getFallbackLocales=R._getFallbackLocales;return q;});
sap.ui.predefine('jquery.sap.sjax',['jquery.sap.global'],function(q){"use strict";q.sap.sjaxSettings={complexResult:true,fallback:undefined};
q.sap.sjax=function a(o){var s=q.extend(true,{},q.sap.sjaxSettings,o,{async:false,success:function(d,t,x){r={success:true,data:d,status:t,statusCode:x&&x.status};},error:function(x,t,e){r={success:false,data:undefined,status:t,error:e,statusCode:x.status,errorResponse:x.responseText};}});var r;q.ajax(s);if(!s.complexResult){return r.success?r.data:s.fallback;}return r;};
q.sap.syncHead=function(u){return q.sap.sjax({type:'HEAD',url:u}).success;};
q.sap.syncGet=function s(u,d,D){return q.sap.sjax({url:u,data:d,type:'GET',dataType:D||'text'});};
q.sap.syncPost=function s(u,d,D){return q.sap.sjax({url:u,data:d,type:'POST',dataType:D||'text'});};
q.sap.syncGetText=function s(u,d,f){return q.sap.sjax({url:u,data:d,type:'GET',dataType:'text',fallback:f,complexResult:(arguments.length<3)});};
q.sap.syncGetJSON=function s(u,d,f){return q.sap.sjax({url:u,data:d||null,type:'GET',dataType:'json',fallback:f,complexResult:(arguments.length<3)});};
return q;});
sap.ui.predefine('jquery.sap.storage',['jquery.sap.global','sap/base/assert','sap/ui/util/Storage'],function(q,a,S){"use strict";var s={};
q.sap.storage=function(o,i){if(!o){o=S.Type.session;}if(typeof(o)==="string"&&S.Type[o]){var k=o;if(i&&i!="state.key_"){k=o+"_"+i;}if(!s[k]){s[k]=new S(o,i);}return s[k];}a(o instanceof Object&&o.clear&&o.setItem&&o.getItem&&o.removeItem,"storage: duck typing the storage");return new S(o,i);};
q.sap.storage.Storage=S;q.sap.storage.Type=S.Type;Object.assign(q.sap.storage,S);return q;});
sap.ui.predefine('jquery.sap.strings',['jquery.sap.global','sap/base/strings/capitalize','sap/base/strings/camelize','sap/base/strings/hyphenate','sap/base/strings/escapeRegExp','sap/base/strings/formatMessage'],function(q,c,a,h,e,f){"use strict";
q.sap.endsWith=function(s,E){if(typeof(E)!="string"||E==""){return false;}return s.endsWith(E);};
q.sap.endsWithIgnoreCase=function(s,E){if(typeof(E)!="string"||E==""){return false;}s=s.toUpperCase();E=E.toUpperCase();return s.endsWith(E);};
q.sap.startsWith=function(s,S){if(typeof(S)!="string"||S==""){return false;}return s.startsWith(S);};
q.sap.startsWithIgnoreCase=function(s,S){if(typeof(S)!="string"||S==""){return false;}s=s.toUpperCase();S=S.toUpperCase();return s.startsWith(S);};
q.sap.charToUpperCase=function(s,p){if(!s){return s;}if(!p||isNaN(p)||p<=0||p>=s.length){return c(s);}var C=s.charAt(p).toUpperCase();if(p>0){return s.substring(0,p)+C+s.substring(p+1);}return C+s.substring(p+1);};
q.sap.padLeft=function(s,p,l){if(!s){s="";}if(p&&p.length===1){return s.padStart(l,p);}while(s.length<l){s=p+s;}return s;};
q.sap.padRight=function(s,p,l){if(!s){s="";}if(p&&p.length===1){return s.padEnd(l,p);}while(s.length<l){s=s+p;}return s;};
q.sap.camelCase=a;q.sap.hyphen=h;q.sap.escapeRegExp=e;q.sap.formatMessage=f;return q;});
sap.ui.predefine('jquery.sap.trace',['jquery.sap.global','sap/ui/performance/trace/Passport','sap/ui/performance/trace/Interaction','sap/ui/performance/trace/FESR','sap/base/Log','sap/ui/Global'],function(q,P,I,F,L){"use strict";
function l(){if(!(window.performance&&window.performance.getEntries)){L.warning("Interaction tracking is not supported on browsers with insufficient performance API");}}
q.sap.interaction={};
q.sap.interaction.setActive=function(){l();I.setActive.apply(this,arguments);};
q.sap.interaction.getActive=I.getActive;q.sap.interaction.notifyStepStart=I.notifyStepStart;q.sap.interaction.notifyStepEnd=I.notifyStepEnd;q.sap.interaction.notifyEventStart=I.notifyEventStart;q.sap.interaction.notifyScrollEvent=I.notifyScrollEvent;q.sap.interaction.notifyEventEnd=I.notifyEventEnd;q.sap.interaction.setStepComponent=I.setStepComponent;q.sap.fesr={};
q.sap.fesr.setActive=function(){l();F.setActive.apply(this,arguments);};
q.sap.fesr.getActive=F.getActive;q.sap.fesr.getCurrentTransactionId=P.getTransactionId;q.sap.fesr.getRootId=P.getRootId;q.sap.fesr.addBusyDuration=I.addBusyDuration;q.sap.passport={};q.sap.passport.setActive=P.setActive;q.sap.passport.traceFlags=P.traceFlags;
function g(){var a=!!document.querySelector("meta[name=sap-ui-fesr][content=true]"),p=window.location.search.match(/[\?|&]sap-ui-(?:xx-)?fesr=(true|x|X|false)&?/);if(p){a=p[1]&&p[1]!="false";}return a;}
q.sap.interaction.notifyStepStart(null,true);F.setActive(g());if(/sap-ui-xx-e2e-trace=(true|x|X)/.test(location.search)){sap.ui.requireSync("sap/ui/core/support/trace/E2eTraceLib");}return q;});
sap.ui.predefine('jquery.sap.ui',['jquery.sap.global','sap/base/util/ObjectPath','sap/ui/dom/jquery/control'],function(q,O){"use strict";
function f(c){return c.getUIArea().getInterface();}
function u(){return sap.ui.getCore().getUIArea(this.id)!=null;}
function a(){return sap.ui.getCore().getUIArea(this.id);}
q.fn.root=function(r){if(r){sap.ui.getCore().setRoot(this.get(0),r);return this;}var c=this.control();if(c.length>0){return c.map(f);}var U=this.uiarea();if(U.length>0){return U;}this.each(function(){sap.ui.getCore().createUIArea(this);});return this;};
q.fn.uiarea=function(i){var U=this.slice("[id]").filter(u).map(a).get();return typeof(i)==="number"?U[i]:U;};
q.fn.sapui=function(c,i,C){return this.each(function(){var o=null;if(this){if(c.indexOf(".")==-1){c="sap.ui.commons."+c;}var b=O.get(c);if(b){if(typeof C=='object'&&typeof C.press=='function'){C.press=q.proxy(C.press,this);}o=new(b)(i,C);o.placeAt(this);}}});};
return q;});
sap.ui.predefine('jquery.sap.xml',['jquery.sap.global','sap/ui/util/XMLHelper'],function(q,X){"use strict";q.sap.parseXML=X.parse;
q.sap.serializeXML=function(x){var s="";if(window.ActiveXObject){s=x.xml;if(s){return s;}}if(window.XMLSerializer){return X.serialize(x);}return s;};
q.sap.isEqualNode=function(n,N){if(n===N){return true;}if(!n||!N){return false;}if(n.isEqualNode){return n.isEqualNode(N);}if(n.nodeType!=N.nodeType){return false;}if(n.nodeValue!=N.nodeValue){return false;}if(n.baseName!=N.baseName){return false;}if(n.nodeName!=N.nodeName){return false;}if(n.nameSpaceURI!=N.nameSpaceURI){return false;}if(n.prefix!=N.prefix){return false;}if(n.nodeType!=1){return true;}if(n.attributes.length!=N.attributes.length){return false;}for(var i=0;i<n.attributes.length;i++){if(!q.sap.isEqualNode(n.attributes[i],N.attributes[i])){return false;}}if(n.childNodes.length!=N.childNodes.length){return false;}for(var i=0;i<n.childNodes.length;i++){if(!q.sap.isEqualNode(n.childNodes[i],N.childNodes[i])){return false;}}return true;};
q.sap.getParseError=X.getParseError;return q;});
sap.ui.predefine('sap/base/security/URLListValidator',[],function(){"use strict";var r=/^(?:([^:\/?#]+):)?((?:\/\/((?:\[[^\]]+\]|[^\/?#:]+))(?::([0-9]+))?)?([^?#]*))(?:\?([^#]*))?(?:#(.*))?$/;var a=/^([a-z0-9-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*$/i;var b=/^([a-z0-9-._~!$&'()*+,;=:@\/?]|%[0-9a-f]{2})*$/i;var c=b;var d=/^([a-z0-9!$'*+:^_`{|}~-]|%[0-9a-f]{2})+(?:\.([a-z0-9!$'*+:^_`{|}~-]|%[0-9a-f]{2})+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i;var e=/^([0-9]{1,3}\.){3}[0-9]{1,3}$/;var f=/^(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])$/;var g=/^\[[^\]]+\]$/;var h=/^\[(((([0-9a-f]{1,4}:){6}|(::([0-9a-f]{1,4}:){5})|(([0-9a-f]{1,4})?::([0-9a-f]{1,4}:){4})|((([0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::([0-9a-f]{1,4}:){3})|((([0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::([0-9a-f]{1,4}:){2})|((([0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:)|((([0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::))(([0-9a-f]{1,4}:[0-9a-f]{1,4})|(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])))|((([0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4})|((([0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::))\]$/i;var j=/^([a-z0-9]([a-z0-9\-]*[a-z0-9])?\.)*[a-z0-9]([a-z0-9\-]*[a-z0-9])?$/i;var u={};
u._createEntry=function(p,i,k,l){return new U(p,i,k,l);};
function U(p,i,k,l){Object.defineProperties(this,{protocol:{value:p&&p.toUpperCase(),enumerable:true},host:{value:i&&i.toUpperCase(),enumerable:true},port:{value:k,enumerable:true},path:{value:l,enumerable:true}});}
var A=[];
u.clear=function(){A=[];};
u.add=function(p,i,k,l){var E=this._createEntry(p,i,k,l);A.push(E);};
u._delete=function(E){A.splice(A.indexOf(E),1);};
u.entries=function(){return A.slice();};
u.validate=function(s){var k=r.exec(s);if(!k){return false;}var p=k[1],B=k[2],H=k[3],P=k[4],l=k[5],q=k[6],m=k[7];if(p){p=p.toUpperCase();if(A.length<=0){if(!/^(https?|ftp)/i.test(p)){return false;}}}if(H){if(e.test(H)){if(!f.test(H)){return false;}}else if(g.test(H)){if(!h.test(H)){return false;}}else if(!j.test(H)){return false;}H=H.toUpperCase();}if(l){if(p==="MAILTO"){var n=B.split(",");for(var i=0;i<n.length;i++){if(!d.test(n[i])){return false;}}}else{var C=l.split("/");for(var i=0;i<C.length;i++){if(!a.test(C[i])){return false;}}}}if(q){if(!b.test(q)){return false;}}if(m){if(!c.test(m)){return false;}}if(A.length>0){var F=false;for(var i=0;i<A.length;i++){if(!p||!A[i].protocol||p==A[i].protocol){var o=false;if(H&&A[i].host&&/^\*/.test(A[i].host)){if(!A[i]._hostRegexp){var t=A[i].host.slice(1).replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&");A[i]._hostRegexp=RegExp(t+"$");}var v=A[i]._hostRegexp;if(v.test(H)){o=true;}}else if(!H||!A[i].host||H==A[i].host){o=true;}if(o){if((!H&&!P)||!A[i].port||P==A[i].port){if(A[i].path&&/\*$/.test(A[i].path)){if(!A[i]._pathRegexp){var w=A[i].path.slice(0,-1).replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&");A[i]._pathRegexp=RegExp("^"+w);}var v=A[i]._pathRegexp;if(v.test(l)){F=true;}}else if(!A[i].path||l==A[i].path){F=true;}}}}if(F){break;}}if(!F){return false;}}return true;};
return u;});
sap.ui.predefine('sap/base/security/URLWhitelist',["sap/base/security/URLListValidator"],function(U){"use strict";return{"add":U.add,"delete":U._delete,"clear":U.clear,"entries":U.entries,"validate":U.validate,"_createEntry":function(p,h,a,b){return{protocol:p&&p.toUpperCase(),host:h&&h.toUpperCase(),port:a,path:b};}};});
sap.ui.predefine('sap/base/security/encodeJS',["sap/base/strings/toHex"],function(t){"use strict";var r=/[\x00-\x2b\x2d\x2f\x3a-\x40\x5b-\x5e\x60\x7b-\xff\u2028\u2029]/g,j={};var J=function(c){var E=j[c];if(!E){var C=c.charCodeAt(0);if(C<256){E="\\x"+t(C,2);}else{E="\\u"+t(C,4);}j[c]=E;}return E;};var e=function(s){return s.replace(r,J);};return e;});
sap.ui.predefine('sap/base/security/encodeURL',["sap/base/strings/toHex"],function(t){"use strict";var r=/[\ud800-\udbff][\udc00-\udfff]|[\x00-\x2c\x2f\x3a-\x40\x5b-\x5e\x60\x7b-\uffff]/g,u={};var U=function(c){var E=u[c];if(!E){var C=c.codePointAt(0);if(C<128){E="%"+t(C,2);}else if(C<2048){E="%"+t((C>>6)|192,2)+"%"+t((C&63)|128,2);}else if(C<65536){E="%"+t((C>>12)|224,2)+"%"+t(((C>>6)&63)|128,2)+"%"+t((C&63)|128,2);}else{E="%"+t((C>>18)|240,2)+"%"+t(((C>>12)&63)|128,2)+"%"+t(((C>>6)&63)|128,2)+"%"+t((C&63)|128,2);}u[c]=E;}return E;};var e=function(s){return s.replace(r,U);};return e;});
sap.ui.predefine('sap/base/security/encodeURLParameters',["./encodeURL"],function(e){"use strict";var E=function(p){if(!p){return"";}var u=[];Object.keys(p).forEach(function(n){var v=p[n];if(v instanceof String||typeof v==="string"){v=e(v);}u.push(e(n)+"="+v);});return u.join("&");};return E;});
sap.ui.predefine('sap/base/security/sanitizeHTML',["sap/base/assert","sap/base/security/URLListValidator","sap/ui/thirdparty/caja-html-sanitizer"],function(a,U){"use strict";var s=function(h,o){a(window.html&&window.html.sanitize,"Sanitizer should have been loaded");o=o||{uriRewriter:function(u){if(U.validate(u)){return u;}}};var t=o.tagPolicy||window.html.makeTagPolicy(o.uriRewriter,o.tokenPolicy);return window.html.sanitizeWithPolicy(h,t);};return s;});
sap.ui.predefine('sap/base/strings/camelize',[],function(){"use strict";var r=/-(.)/ig;var c=function(s){return s.replace(r,function(m,C){return C.toUpperCase();});};return c;});
sap.ui.predefine('sap/base/strings/capitalize',[],function(){"use strict";var c=function(s){return s.charAt(0).toUpperCase()+s.substring(1);};return c;});
sap.ui.predefine('sap/base/strings/hyphenate',[],function(){"use strict";var r=/([A-Z])/g;var h=function(s){return s.replace(r,function(m,c){return"-"+c.toLowerCase();});};return h;});
sap.ui.predefine('sap/base/strings/whitespaceReplacer',[],function(){"use strict";var w=function(i){var W=" ",u="\u00A0";if(typeof i!=="string"){return i;}return i.replaceAll("\t",W+W).replaceAll((W+W),(W+u));};return w;});
sap.ui.predefine('sap/base/util/Deferred',[],function(){"use strict";var D=function(){var t=this;this.promise=new Promise(function(r,a){t.resolve=r;t.reject=a;});};return D;});
sap.ui.predefine('sap/base/util/defineCoupledProperty',[],function(){"use strict";var d=function(t,T,s,S){var v=s[S];var p={configurable:true,get:function(){return v;},set:function(_){v=_;}};Object.defineProperty(t,T,p);Object.defineProperty(s,S,p);};return d;});
sap.ui.predefine('sap/base/util/includes',["sap/base/util/values"],function(v){"use strict";var i=function(c,V,f){if(typeof f!=='number'){f=0;}if(Array.isArray(c)||typeof c==='string'){if(f<0){f=(c.length+f)<0?0:c.length+f;}return c.includes(V,f);}else{return i(v(c),V,f);}};return i;});
sap.ui.predefine('sap/base/util/restricted/_castArray',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.castArray;});
sap.ui.predefine('sap/base/util/restricted/_compact',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.compact;});
sap.ui.predefine('sap/base/util/restricted/_curry',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.curry;});
sap.ui.predefine('sap/base/util/restricted/_debounce',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.debounce;});
sap.ui.predefine('sap/base/util/restricted/_difference',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.difference;});
sap.ui.predefine('sap/base/util/restricted/_differenceBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.differenceBy;});
sap.ui.predefine('sap/base/util/restricted/_differenceWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.differenceWith;});
sap.ui.predefine('sap/base/util/restricted/_flatMap',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flatMap;});
sap.ui.predefine('sap/base/util/restricted/_flatMapDeep',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flatMapDeep;});
sap.ui.predefine('sap/base/util/restricted/_flatMapDepth',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flatMapDepth;});
sap.ui.predefine('sap/base/util/restricted/_flatten',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flatten;});
sap.ui.predefine('sap/base/util/restricted/_flattenDeep',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flattenDeep;});
sap.ui.predefine('sap/base/util/restricted/_flattenDepth',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flattenDepth;});
sap.ui.predefine('sap/base/util/restricted/_intersection',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.intersection;});
sap.ui.predefine('sap/base/util/restricted/_intersectionBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.intersectionBy;});
sap.ui.predefine('sap/base/util/restricted/_intersectionWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.intersectionWith;});
sap.ui.predefine('sap/base/util/restricted/_isEqual',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.isEqual;});
sap.ui.predefine('sap/base/util/restricted/_isEqualWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.isEqualWith;});
sap.ui.predefine('sap/base/util/restricted/_isNil',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.isNil;});
sap.ui.predefine('sap/base/util/restricted/_max',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.max;});
sap.ui.predefine('sap/base/util/restricted/_merge',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.merge;});
sap.ui.predefine('sap/base/util/restricted/_mergeWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.mergeWith;});
sap.ui.predefine('sap/base/util/restricted/_min',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.min;});
sap.ui.predefine('sap/base/util/restricted/_omit',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.omit;});
sap.ui.predefine('sap/base/util/restricted/_pick',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.pick;});
sap.ui.predefine('sap/base/util/restricted/_pickBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.pickBy;});
sap.ui.predefine('sap/base/util/restricted/_throttle',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.throttle;});
sap.ui.predefine('sap/base/util/restricted/_toArray',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.toArray;});
sap.ui.predefine('sap/base/util/restricted/_union',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.union;});
sap.ui.predefine('sap/base/util/restricted/_unionBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.unionBy;});
sap.ui.predefine('sap/base/util/restricted/_unionWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.unionWith;});
sap.ui.predefine('sap/base/util/restricted/_uniq',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.uniq;});
sap.ui.predefine('sap/base/util/restricted/_uniqBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.uniqBy;});
sap.ui.predefine('sap/base/util/restricted/_uniqWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.uniqWith;});
sap.ui.predefine('sap/base/util/restricted/_without',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.without;});
sap.ui.predefine('sap/base/util/restricted/_xor',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.xor;});
sap.ui.predefine('sap/base/util/restricted/_xorBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.xorBy;});
sap.ui.predefine('sap/base/util/restricted/_xorWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.xorWith;});
sap.ui.predefine('sap/base/util/restricted/_zipObject',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.zipObject;});
sap.ui.predefine('sap/base/util/restricted/_zipObjectDeep',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.zipObjectDeep;});
sap.ui.predefine('sap/base/util/values',function(){"use strict";var v=function a(o){if(typeof o==="undefined"||o===null||o!==o){return[];}return Object.values(o);};return v;});
sap.ui.predefine('sap/ui/app/Application',['sap/base/assert','./ApplicationMetadata','sap/ui/core/Component','sap/ui/core/ComponentContainer','sap/ui/model/Model','sap/ui/model/json/JSONModel','jquery.sap.sjax'],function(a,A,C,b,M,J,q){"use strict";
var c=C.extend("sap.ui.app.Application",{
metadata:{"abstract":true,properties:{root:"string",config:"any"},aggregations:{rootComponent:{type:"sap.ui.core.UIComponent",multiple:false}},publicMethods:["getView"],deprecated:true},
constructor:function(i,s){if(this.onError){this.onWindowError=this.onError;}if(this.onBeforeExit){this.onWindowBeforeUnload=this.onBeforeExit;}if(this.onExit){this.onWindowUnload=this.onExit;}C.apply(this,arguments);if(sap.ui.getApplication){throw new Error("Only one instance of sap.ui.app.Application is allowed");}sap.ui.getApplication=this._getInstance.bind(this);sap.ui.getCore().attachInit(function(){this._initRootComponent();this.main();}.bind(this));},
_initRootComponent:function(){var r=this.createRootComponent();if(r){this.setRootComponent(r);var o=new b({component:r});o.placeAt(this.getRoot()||document.body);}},
createRootComponent:function(){var r=this.getMetadata().getRootComponent();var R;if(r){R=sap.ui.component({name:r});}return R;},
getView:function(){return this.getRootComponent();},
_getInstance:function(){return this;},
main:function(){},
onBeforeExit:function(){},
onExit:function(){},
onError:null,
setConfig:function(v){if(typeof v==="string"){var u=v;v=new J();var r=q.sap.sjax({url:u,dataType:'json'});if(r.success){v.setData(r.data);}else{throw new Error("Could not load config file: "+u);}}if(typeof v==="object"&&!(v instanceof M)){v=new J(v);}a(v instanceof M,"the config property value must be a string, an object or an instance of sap.ui.model.Model");this.setProperty("config",v);},
destroy:function(s){delete sap.ui.getApplication;C.prototype.destroy.apply(this,arguments);}
},A);
return c;});
sap.ui.predefine('sap/ui/app/ApplicationMetadata',['sap/base/Log','sap/ui/core/ComponentMetadata','jquery.sap.sjax'],function(L,C,q){"use strict";var A=function(c,o){C.apply(this,arguments);};A.prototype=Object.create(C.prototype);A.prototype.constructor=A;
A.preprocessClassInfo=function(c){if(c&&typeof c.metadata==="string"){c.metadata={_src:c.metadata};}return c;};
A.prototype.applySettings=function(c){var s=c.metadata;C.prototype.applySettings.call(this,c);if(s._src){L.warning("The metadata of the application "+this.getName()+" is loaded from file "+s._src+". This is a design time feature and not for productive usage!");var p=this.getName().replace(/\.\w+?$/,"");var u=sap.ui.require.toUrl(p.replace(/\./g,"/")+"/"+s._src);var r=q.sap.syncGetJSON(u);if(r.success){Object.assign(s,r.data);}else{L.error("Failed to load application metadata from \""+s._src+"\"! Reason: "+r.error);}}this._mRootComponent=s.rootComponent||null;};
A.prototype.getRootComponent=function(){return this._mRootComponent;};
return A;},true);
sap.ui.predefine('sap/ui/app/MockServer',['jquery.sap.global','sap/ui/core/util/MockServer'],function(q,M){"use strict";var a=M;return a;},true);
sap.ui.predefine('sap/ui/core/AppCacheBuster',['sap/ui/base/ManagedObject','sap/ui/thirdparty/URI','sap/base/Log','sap/base/util/extend','sap/base/strings/escapeRegExp','sap/ui/thirdparty/jquery','sap/ui/core/_IconRegistry','./Core'],function(M,U,L,a,b,q,_){"use strict";var c=sap.ui.getCore().getConfiguration();var l=c.getLanguage();var s=c.getAppCacheBusterMode()==="sync";var B=c.getAppCacheBusterMode()==="batch";var S={index:{},active:false};var v,d,f,x,E;var g=document.baseURI.replace(/\?.*|#.*/g,"");var u=U(sap.ui.require.toUrl("")+"/../");var o=u.toString();if(u.is("relative")){u=u.absoluteTo(g);}var h=u.normalize().toString();var r=U("resources").absoluteTo(h).toString();var F=new RegExp("^"+b(r));var i=function(e){if(e.length>0&&e.slice(-1)!=="/"){e+="/";}return e;};var R=function(h,e){var I=S.index;var j;var k;var m;if(Array.isArray(h)&&!B){h.forEach(function(D){R(D,e);});}else if(Array.isArray(h)&&B){var n=i(h[0]);var C=[];L.debug("sap.ui.core.AppCacheBuster.register(\""+n+"\"); // BATCH MODE!");var p=A.normalizeURL(n);L.debug("  --> normalized to: \""+p+"\"");h.forEach(function(D){k=i(D);var G=A.normalizeURL(k);if(!I[m]){C.push(G);}});if(C.length>0){var k=p+"sap-ui-cachebuster-info.json?sap-ui-language="+l;j={url:k,type:"POST",async:!s&&!!e,dataType:"json",contentType:"text/plain",data:C.join("\n"),success:function(D){A.onIndexLoaded(k,D);a(I,D);},error:function(){L.error("Failed to batch load AppCacheBuster index file from: \""+k+"\".");}};}}else{h=i(h);L.debug("sap.ui.core.AppCacheBuster.register(\""+h+"\");");m=A.normalizeURL(h);L.debug("  --> normalized to: \""+m+"\"");if(!I[m]){var k=m+"sap-ui-cachebuster-info.json?sap-ui-language="+l;j={url:k,async:!s&&!!e,dataType:"json",success:function(D){A.onIndexLoaded(k,D);I[m]=D;},error:function(){L.error("Failed to load AppCacheBuster index file from: \""+k+"\".");}};}}if(j){var t=A.onIndexLoad(j.url);if(t!=null){L.info("AppCacheBuster index file injected for: \""+k+"\".");j.success(t);}else{if(j.async){var w=e.startTask("load "+k);var y=j.success,z=j.error;Object.assign(j,{success:function(D){y.apply(this,arguments);e.finishTask(w);},error:function(){z.apply(this,arguments);e.finishTask(w,false);}});}L.info("Loading AppCacheBuster index file from: \""+k+"\".");q.ajax(j);}}};var A={boot:function(e){var C=c.getAppCacheBuster();if(C&&C.length>0){C=C.slice();var j=true;var V=String(C[0]).toLowerCase();if(C.length===1){if(V==="true"||V==="x"){var u=U(o);C=u.is("relative")?[u.toString()]:[];}else if(V==="false"){j=false;}}if(j){A.init();R(C,e);}}},init:function(){S.active=true;v=M.prototype.validateProperty;d=Object.getOwnPropertyDescriptor(HTMLScriptElement.prototype,"src");f=Object.getOwnPropertyDescriptor(HTMLLinkElement.prototype,"href");var C=A.convertURL;var n=A.normalizeURL;var I=function(e){if(this.active===true&&e&&typeof(e)==="string"){e=n(e);return!e.match(F);}return false;}.bind(S);x=XMLHttpRequest.prototype.open;XMLHttpRequest.prototype.open=function(e,p){if(p&&I(p)){arguments[1]=C(p);}x.apply(this,arguments);};E=XMLHttpRequest.prototype.open;M.prototype.validateProperty=function(p,V){var t=this.getMetadata(),P=t.getProperty(p),w;if(P&&P.type==="sap.ui.core.URI"){w=Array.prototype.slice.apply(arguments);try{if(I(w[1])){w[1]=C(w[1]);}}catch(e){}}return v.apply(this,w||arguments);};_._convertUrl=function(e){return C(e);};var j=function(e){var p={get:e.get,set:function(t){if(I(t)){t=C(t);}e.set.call(this,t);},enumerable:e.enumerable,configurable:e.configurable};p.set._sapUiCoreACB=true;return p;};var k=false;try{Object.defineProperty(HTMLScriptElement.prototype,"src",j(d));}catch(m){L.error("Your browser doesn't support redefining the src property of the script tag. Disabling AppCacheBuster as it is not supported on your browser!\nError: "+m);k=true;}try{Object.defineProperty(HTMLLinkElement.prototype,"href",j(f));}catch(m){L.error("Your browser doesn't support redefining the href property of the link tag. Disabling AppCacheBuster as it is not supported on your browser!\nError: "+m);k=true;}if(k){this.exit();}},exit:function(){M.prototype.validateProperty=v;delete _._convertUrl;if(XMLHttpRequest.prototype.open===E){XMLHttpRequest.prototype.open=x;}var e;if((e=Object.getOwnPropertyDescriptor(HTMLScriptElement.prototype,"src"))&&e.set&&e.set._sapUiCoreACB===true){Object.defineProperty(HTMLScriptElement.prototype,"src",d);}if((e=Object.getOwnPropertyDescriptor(HTMLLinkElement.prototype,"href"))&&e.set&&e.set._sapUiCoreACB===true){Object.defineProperty(HTMLLinkElement.prototype,"href",f);}S.index={};S.active=false;S={index:{},active:false};},register:function(h){R(h);},convertURL:function(e){L.debug("sap.ui.core.AppCacheBuster.convertURL(\""+e+"\");");var I=S.index;if(I&&e&&!/^#/.test(e)){var n=A.normalizeURL(e);L.debug("  --> normalized to: \""+n+"\"");if(n&&A.handleURL(n)){for(var h in I){var m=I[h],j,k;if(h&&n.length>=h.length&&n.slice(0,h.length)===h){j=n.slice(h.length);k=j.match(/([^?#]*)/)[1];if(m[k]){e=h+"~"+m[k]+"~/"+j;L.debug("  ==> rewritten to \""+e+"\";");break;}}}}}return e;},normalizeURL:function(e){var u=U(e||"./");if(u.is("relative")){u=u.absoluteTo(g);}return u.normalizeProtocol().normalizeHostname().normalizePort().normalizePath().toString();},handleURL:function(e){return true;},onIndexLoad:function(e){return null;},onIndexLoaded:function(e,I){}};var H=c.getAppCacheBusterHooks();if(H){["handleURL","onIndexLoad","onIndexLoaded"].forEach(function(e){if(typeof H[e]==="function"){A[e]=H[e];}});}return A;},true);
sap.ui.predefine('sap/ui/core/BlockLayerUtils',['sap/ui/events/jquery/EventTriggerHook',"sap/base/Log","sap/ui/thirdparty/jquery"],function(E,L,q){"use strict";var B={},p=["focusin","focusout","keydown","keypress","keyup","mousedown","touchstart","touchmove","mouseup","touchend","click"],r=/^(?:area|base|br|col|embed|hr|img|input|keygen|link|menuitem|meta|param|source|track|wbr|tr)$/i;
B.block=function(c,b,s){var P,t,o,d;if(c){P=c.getDomRef(s);if(!P){P=c.getDomRef();}if(!P){L.warning("BlockLayer could not be rendered. The outer Control instance is not valid anymore or was not rendered yet.");return;}t=P.tagName;if(r.test(t)){L.warning("BusyIndicator cannot be placed in elements with tag '"+t+"'.");return;}d=a(P,b);o={$parent:q(P),$blockLayer:q(d)};if(o.$parent.css('position')=='static'){if(P.style&&P.style.position==="static"){o.originalPosition='static';}o.$parent.css('position','relative');o.positionChanged=true;}h.call(o,true);}else{L.warning("BlockLayer couldn't be created. No Control instance given.");}return o;};
B.unblock=function(b){if(b){if(b.originalPosition){b.$parent.css('position',b.originalPosition);}else if(b.positionChanged){b.$parent.css('position',"");}h.call(b,false);b.$blockLayer.remove();}};
B.addAriaAttributes=function(d){var R=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core");d.setAttribute("role","progressbar");d.setAttribute("aria-valuemin","0");d.setAttribute("aria-valuemax","100");d.setAttribute("aria-valuetext",R.getText("BUSY_VALUE_TEXT"));d.setAttribute("alt","");d.setAttribute("tabindex","0");d.setAttribute("title",R.getText("BUSY_TEXT"));};
B.toggleAnimationStyle=function(b,s){var $=q(b.$blockLayer.get(0));if(s){$.removeClass("sapUiHiddenBusyIndicatorAnimation");$.removeClass("sapUiBlockLayerOnly");}else{$.addClass("sapUiBlockLayerOnly");$.addClass("sapUiHiddenBusyIndicatorAnimation");}};
function a(b,s){var c=document.createElement("div");c.id=s;c.className="sapUiBlockLayer ";B.addAriaAttributes(c);b.appendChild(c);return c;}
function h(e){if(e){var P=this.$parent.get(0);if(P){this.fnRedirectFocus=b.bind(this);this.oTabbableBefore=c(this.fnRedirectFocus);this.oTabbableAfter=c(this.fnRedirectFocus);P.parentNode.insertBefore(this.oTabbableBefore,P);P.parentNode.insertBefore(this.oTabbableAfter,P.nextSibling);this._fnSuppressDefaultAndStopPropagationHandler=s.bind(this);this._aSuppressHandler=f.call(this,this._fnSuppressDefaultAndStopPropagationHandler);}else{L.warning("fnHandleInteraction called with bEnabled true, but no DOMRef exists!");}}else{if(this.oTabbableBefore){d(this.oTabbableBefore,this.fnRedirectFocus);delete this.oTabbableBefore;}if(this.oTabbableAfter){d(this.oTabbableAfter,this.fnRedirectFocus);delete this.oTabbableAfter;}delete this.fnRedirectFocus;g.call(this,this._fnSuppressDefaultAndStopPropagationHandler);}function s(o){var t=o.target===this.$blockLayer.get(0),T;if(t&&o.type==='keydown'&&o.keyCode===9){L.debug("Local Busy Indicator Event keydown handled: "+o.type);T=o.shiftKey?this.oTabbableBefore:this.oTabbableAfter;T.setAttribute("tabindex",-1);this.bIgnoreFocus=true;T.focus();this.bIgnoreFocus=false;T.setAttribute("tabindex",0);o.stopImmediatePropagation();}else if(t&&(o.type==='mousedown'||o.type==='touchstart')){L.debug("Local Busy Indicator click handled on busy area: "+o.target.id);o.stopImmediatePropagation();}else{L.debug("Local Busy Indicator Event Suppressed: "+o.type);o.preventDefault();o.stopImmediatePropagation();}}function b(){if(!this.bIgnoreFocus){this.$blockLayer.get(0).focus();}}function c(R){var o=document.createElement("span");o.setAttribute("tabindex",0);o.classList.add("sapUiBlockLayerTabbable");o.addEventListener('focusin',R);return o;}function d(o,R){if(o.parentNode){o.parentNode.removeChild(o);}o.removeEventListener('focusin',R);}function f(H){var S=[],P=this.$parent.get(0),o=this.$blockLayer.get(0);for(var i=0;i<p.length;i++){P.addEventListener(p[i],H,{capture:true,passive:false});S.push(E.suppress(p[i],P,o));}this.$blockLayer.on('keydown',H);return S;}function g(H){var i,P=this.$parent.get(0),o=this.$blockLayer.get(0);if(P){for(i=0;i<p.length;i++){P.removeEventListener(p[i],H,{capture:true,passive:false});}}if(this._aSuppressHandler){for(i=0;i<this._aSuppressHandler.length;i++){E.release(this._aSuppressHandler[i]);}}if(o){this.$blockLayer.off('keydown',H);}}}
return B;});
sap.ui.predefine('sap/ui/core/BusyIndicator',['sap/ui/thirdparty/jquery','../base/EventProvider','./Popup','./BusyIndicatorUtils','sap/ui/core/library',"sap/ui/performance/trace/FESR","sap/ui/performance/trace/Interaction","sap/base/Log","sap/base/assert","sap/base/util/now"],function(q,E,P,B,l,F,I,L,a,n){"use strict";var b=l.BusyIndicatorSize;var c=Object.assign(new E(),{oPopup:null,oDomRef:null,bOpenRequested:false,iDEFAULT_DELAY_MS:1000,sDOM_ID:"sapUiBusyIndicator"});c.M_EVENTS={Open:"Open",Close:"Close"};c._bShowIsDelayed=undefined;
c._init=function(){var r=document.createElement("div");r.id=this.sDOM_ID;var o=document.createElement("div");this._oResBundle=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core");var t=this._oResBundle.getText("BUSY_TEXT");delete this._oResBundle;o.className="sapUiBusy";o.setAttribute("tabindex","0");o.setAttribute("role","progressbar");o.setAttribute("alt","");o.setAttribute("title",t);r.appendChild(o);var d=B.getElement(b.Large);d.setAttribute("title",t);r.appendChild(d);this.oDomRef=r;this.oPopup=new P(r);this.oPopup.setModal(true,"sapUiBlyBusy");this.oPopup.setShadow(false);this.oPopup.attachOpened(function(e){this._onOpen(e);},this);};
c._onOpen=function(e){var d=document.getElementById(c.sDOM_ID);d.style.height="100%";d.style.width="100%";var A=d.querySelector(".sapUiLocalBusyIndicator");A.className+=" sapUiLocalBusyIndicatorFade";if(d){d.focus();}this.fireOpen({$Busy:this.oPopup._$()});};
c.show=function(d){L.debug("sap.ui.core.BusyIndicator.show (delay: "+d+") at "+new Date().getTime());a(d===undefined||(typeof d=="number"&&(d%1==0)),"iDelay must be empty or an integer");if(!document.body||!sap.ui.getCore().isInitialized()){if(c._bShowIsDelayed===undefined){sap.ui.getCore().attachInit(function(){if(c._bShowIsDelayed){c.show(d);}});}c._bShowIsDelayed=true;return;}if((d===undefined)||((d!=0)&&(parseInt(d)==0))||(parseInt(d)<0)){d=this.iDEFAULT_DELAY_MS;}if(F.getActive()){this._fDelayedStartTime=n()+d;}if(!this.oDomRef){this._init();}this.bOpenRequested=true;if(d===0){this._showNowIfRequested();}else{setTimeout(this["_showNowIfRequested"].bind(this),d);}};
c._showNowIfRequested=function(){L.debug("sap.ui.core.BusyIndicator._showNowIfRequested (bOpenRequested: "+this.bOpenRequested+") at "+new Date().getTime());if(!this.bOpenRequested){return;}var o=(window.scrollX===undefined?window.pageXOffset:window.scrollX);var O=(window.scrollY===undefined?window.pageYOffset:window.scrollY);var s=o+" "+O;this.bOpenRequested=false;this.oPopup.open(0,P.Dock.LeftTop,P.Dock.LeftTop,document,s);};
c.hide=function(){L.debug("sap.ui.core.BusyIndicator.hide at "+new Date().getTime());if(this._fDelayedStartTime){var f=n()-this._fDelayedStartTime;I.addBusyDuration((f>0)?f:0);delete this._fDelayedStartTime;}var d=c;if(c._bShowIsDelayed===true){c._bShowIsDelayed=false;}d.bOpenRequested=false;if(d.oDomRef){var A=d.oDomRef.querySelector(".sapUiLocalBusyIndicator");q(A).removeClass("sapUiLocalBusyIndicatorFade");this.fireClose({$Busy:this.oPopup._$()});d.oPopup.close(0);}};
c.attachOpen=function(f,o){this.attachEvent(c.M_EVENTS.Open,f,o);return this;};
c.detachOpen=function(f,o){this.detachEvent(c.M_EVENTS.Open,f,o);return this;};
c.attachClose=function(f,o){this.attachEvent(c.M_EVENTS.Close,f,o);return this;};
c.detachClose=function(f,o){this.detachEvent(c.M_EVENTS.Close,f,o);return this;};
c.fireOpen=function(p){this.fireEvent(c.M_EVENTS.Open,p);};
c.fireClose=function(p){this.fireEvent(c.M_EVENTS.Close,p);};
return c;},true);
sap.ui.predefine('sap/ui/core/BusyIndicatorUtils',['./BlockLayerUtils'],function(B){"use strict";var a=function(){};
a.getElement=function(s){var S="sapUiLocalBusyIndicatorSizeMedium";if(s==="Large"){S="sapUiLocalBusyIndicatorSizeBig";}var c=document.createElement("div");c.className="sapUiLocalBusyIndicator "+S+" sapUiLocalBusyIndicatorFade";B.addAriaAttributes(c);b(c);return c;};
function b(c,s){s=s||"sapUiLocalBusyIndicatorAnimStandard";var A=document.createElement("div");A.className="sapUiLocalBusyIndicatorAnimation "+s;A.appendChild(document.createElement("div"));A.appendChild(document.createElement("div"));A.appendChild(document.createElement("div"));c.appendChild(A);}
function h(o,s){var p=o.$parent.get(0),c=o.$blockLayer.get(0);var A=c.children[0],w=A.offsetWidth;if(p.offsetWidth<w){A.className="sapUiLocalBusyIndicatorAnimation sapUiLocalBusyIndicatorAnimSmall";}}
a.addHTML=function(o,s){var c=sap.ui.require("sap/ui/core/library").BusyIndicatorSize,S="sapUiLocalBusyIndicatorSizeMedium",A;switch(s){case c.Small:S="sapUiLocalBusyIndicatorSizeMedium";A="sapUiLocalBusyIndicatorAnimSmall";break;case c.Large:S="sapUiLocalBusyIndicatorSizeBig";A="sapUiLocalBusyIndicatorAnimStandard";break;case c.Auto:S="sapUiLocalBusyIndicatorSizeMedium";A="sapUiLocalBusyIndicatorAnimStandard";break;default:S="sapUiLocalBusyIndicatorSizeMedium";A="sapUiLocalBusyIndicatorAnimStandard";break;}if(!o){return;}var p=o.$parent.get(0),d=o.$blockLayer.get(0);p.className+=" sapUiLocalBusy";d.className+=" sapUiLocalBusyIndicator "+S+" sapUiLocalBusyIndicatorFade";b(d,A);if(s===c.Auto){h(o);}};
return a;},true);
sap.ui.predefine('sap/ui/core/CommandExecution',['sap/base/Log','sap/base/util/isEmptyObject','sap/ui/core/Component','sap/ui/core/Element','sap/ui/core/Shortcut'],function(L,a,C,E,S){"use strict";
var b=E.extend("sap.ui.core.CommandExecution",{
metadata:{library:"sap.ui.core",properties:{command:{type:"string"},enabled:{type:"boolean",defaultValue:true},visible:{type:"boolean",defaultValue:true}},events:{execute:{}}},
bSkipUpdate:false,
trigger:function(){if(this.getVisible()&&this.getEnabled()){this.fireExecute({});}},
setCommand:function(c){if(!this.getCommand()){this.setProperty("command",c,true);}else{L.error("The 'command' property can only be applied initially!");}return this;},
_getCommandInfo:function(){var c,o=this.getParent(),d=C.getOwnerComponentFor(this);while(!d&&o&&o.getParent()){d=C.getOwnerComponentFor(o);o=o.getParent();}if(d){c=d.getCommand(this.getCommand());}return c?Object.assign({},c):null;},
_updateContextData:function(c){var p=this.getParent();c[this.getCommand()]={};c[this.getCommand()].enabled=this.getEnabled();c[this.getCommand()].id=this.getId();c[this.getCommand()].visible=this.getVisible();this.getModel("$cmd").setProperty("/"+p.getId(),c);},
_createCommandData:function(p){if(!this.bSkipUpdate){this.bSkipUpdate=true;var P=this.getParent(),m=P.getModel("$cmd"),d=m.getData(),c=d[P.getId()];if(!c){c=Object.create(p);}else if(p!==Object.getPrototypeOf(c)){c=Object.create(p);}this._updateContextData(c);if(!P.getObjectBinding("$cmd")){P.bindElement("$cmd>/"+P.getId());}this.bSkipUpdate=false;}},
setParent:function(p){var t=this,c,o=this.getParent(),P,s,i;function g(){var d=p.oPropagatedProperties.oBindingContexts["$cmd"];return d?d.getObject():null;}function m(){if(p.getModel("$cmd")){var P=g();t.getParent().detachModelContextChange(m);t._createCommandData(P);}}E.prototype.setParent.apply(this,arguments);c=this._getCommandInfo();if(c&&this.getVisible()){if(p&&p!==o){s=c.shortcut;i=S.isRegistered(this.getParent(),s);if(!i){S.register(p,s,this.trigger.bind(this));}if(p.getModel("$cmd")){P=g();this._createCommandData(P);}else{p.attachModelContextChange(m);}if(!p._propagateProperties._sapui_fnOrig){var O=p._propagateProperties;p._propagateProperties=function(n,d,e,u,N,U){O.apply(p,arguments);var A=p.getBindingContext("$cmd");var f=arguments[1];if(A&&f.isA("sap.ui.core.CommandExecution")){var h=A.getObject();var j=Object.getPrototypeOf(h);P=g();if(j!==P){t._createCommandData.apply(f,[P]);}}};p._propagateProperties._sapui_fnOrig=O;}}if(o&&o!=p){s=c.shortcut;i=S.isRegistered(o,s);if(i){S.unregister(o,c.shortcut);}this._cleanupContext(o);}}return this;},
_cleanupContext:function(c){if(c.getBindingContext("$cmd")){var o=c.getBindingContext("$cmd").getObject();if(o){delete o[this.getCommand()];if(a(Object.assign({},o))){if(c._propagateProperties._sapui_fnOrig){c._propagateProperties=c._propagateProperties._sapui_fnOrig;}if(!c._bIsBeingDestroyed){c.unbindElement("$cmd");}}}}},
setVisible:function(v){var p=this.getParent(),c=this.getModel("$cmd");this.setProperty("visible",v,true);v=this.getProperty("visible");if(p){var o=this._getCommandInfo(),s=o.shortcut,i=S.isRegistered(p,s);if(v&&!i){S.register(p,s,this.trigger.bind(this));}else if(!v&&i){S.unregister(p,s);}}if(c){var d=this.getBindingContext("$cmd");c.setProperty(this.getCommand()+"/visible",v,d);}return this;},
setEnabled:function(v){var c=this.getModel("$cmd");this.setProperty("enabled",v,true);if(c){var o=this.getBindingContext("$cmd");c.setProperty(this.getCommand()+"/enabled",this.getProperty("enabled"),o);}return this;},
destroy:function(){var p=this.getParent();if(p){var c=this._getCommandInfo();S.unregister(this.getParent(),c.shortcut);this._cleanupContext(p);}E.prototype.destroy.apply(this,arguments);}
});
b.find=function(c,s){var i,o,A;A=c.getDependents();for(i=0;i<A.length;i++){if(A[i].isA("sap.ui.core.CommandExecution")&&A[i].getCommand()===s){o=A[i];}}if(!o&&c.getParent()){o=b.find(c.getParent(),s);}return o;};
return b;});
sap.ui.predefine('sap/ui/core/ComponentContainer',['sap/ui/base/ManagedObject','./Control','./Component','./library',"./ComponentContainerRenderer","sap/base/Log"],function(M,C,a,l,b,L){"use strict";var c=l.ComponentLifecycle;
var d=C.extend("sap.ui.core.ComponentContainer",{
metadata:{interfaces:["sap.ui.core.IPlaceholderSupport"],library:"sap.ui.core",properties:{name:{type:"string",defaultValue:null},url:{type:"sap.ui.core.URI",defaultValue:null},async:{type:"boolean",defaultValue:false},handleValidation:{type:"boolean",defaultValue:false},settings:{type:"object",defaultValue:null},propagateModel:{type:"boolean",defaultValue:false},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},lifecycle:{type:"sap.ui.core.ComponentLifecycle",defaultValue:c.Legacy},autoPrefixId:{type:"boolean",defaultValue:false},usage:{type:"string",defaultValue:null},manifest:{type:"any",defaultValue:null}},associations:{component:{type:"sap.ui.core.UIComponent",multiple:false}},events:{componentCreated:{parameters:{component:{type:"sap.ui.core.UIComponent"}}},componentFailed:{allowPreventDefault:true,parameters:{reason:{type:"object"}}}},designtime:"sap/ui/core/designtime/ComponentContainer.designtime"},
renderer:b
});
function s(o,v,S,D){var f=typeof v==="string"?a.get(v):v;var O=o.getComponentInstance();if(O!==f){if(O){O.setContainer(undefined);if(D){O.destroy();}else{o._propagateProperties(true,O,M._oEmptyPropagatedProperties,true);}}o.setAssociation("component",f,S);f=o.getComponentInstance();if(f){f.setContainer(o);o.propagateProperties(true);}}}
d.prototype.getComponentInstance=function(){var f=this.getComponent();return f&&a.get(f);};
var p={"onAfterRendering":function(){if(this._placeholder){this._placeholder.show(this);}}};
d.prototype.showPlaceholder=function(S){var f;if(!sap.ui.getCore().getConfiguration().getPlaceholder()){return;}if(this._placeholder){this.hidePlaceholder();}if(S.placeholder){this._placeholder=S.placeholder;f=this._placeholder._load();}else{f=Promise.resolve();}if(this.getDomRef()&&this._placeholder){this._placeholder.show(this);}this.addEventDelegate(p,this);return f;};
d.prototype.hidePlaceholder=function(){if(this._placeholder){this._placeholder.hide();this.removeEventDelegate(p);this._placeholder=undefined;}};
d.prototype.setComponent=function(v,S){s(this,v,S,this.getLifecycle()===c.Container||(typeof this.getUsage()==="string"&&this.getUsage()&&this.getLifecycle()===c.Legacy));return this;};
d.prototype.applySettings=function(S,o){if(S){if(S.manifest==="true"||S.manifest==="false"){S.manifest=S.manifest==="true";}if(S.manifest&&S.async===undefined){S.async=true;}}C.prototype.applySettings.apply(this,arguments);};
function e(o){var n=o.getName();var m=o.getManifest();var u=o.getUrl();var S=o.getSettings();var f={name:n?n:undefined,manifest:m!==null?m:false,async:o.getAsync(),url:u?u:undefined,handleValidation:o.getHandleValidation(),settings:S!==null?S:undefined};return f;}
d.prototype._createComponent=function(){var o=a.getOwnerComponentFor(this),u=this.getUsage(),m=e(this);if(u){if(o){m=o._enhanceWithUsageConfig(u,m);}else{L.error("ComponentContainer \""+this.getId()+"\" does have a \"usage\", but no owner component!");}}if(this.getAutoPrefixId()){if(m.id){m.id=this.getId()+"-"+m.id;}if(m.settings&&m.settings.id){m.settings.id=this.getId()+"-"+m.settings.id;}}return a._createComponent(m,o);};
d.prototype.onBeforeRendering=function(){var o=this.getComponentInstance(),u=this.getUsage(),n=this.getName(),m=this.getManifest();if(!this._oComponentPromise&&!o&&(u||n||m)){o=this._createComponent();if(o instanceof Promise){this._oComponentPromise=o;o.then(function(o){delete this._oComponentPromise;this.setComponent(o);this.fireComponentCreated({component:o});}.bind(this),function(r){delete this._oComponentPromise;if(this.fireComponentFailed({reason:r})){L.error("Failed to load component for container "+this.getId(),r);}}.bind(this));}else if(o){this.setComponent(o,true);this.fireComponentCreated({component:o});}else{this.fireComponentFailed({reason:new Error("The component could not be created.")});}}if(o&&o.onBeforeRendering){o.onBeforeRendering();}};
d.prototype.onAfterRendering=function(){var o=this.getComponentInstance();if(o&&o.onAfterRendering){o.onAfterRendering();}};
d.prototype.exit=function(){s(this,undefined,true,this.getLifecycle()!==c.Application);};
d.prototype.propagateProperties=function(n){var o=this.getComponentInstance();if(o&&this.getPropagateModel()){this._propagateProperties(n,o);}C.prototype.propagateProperties.apply(this,arguments);};
d.prototype._propagateContextualSettings=function(){var o=this.getComponentInstance();if(o){o._applyContextualSettings(this._getContextualSettings());}};
return d;});
sap.ui.predefine('sap/ui/core/ComponentContainerRenderer',function(){"use strict";var C={apiVersion:2};
C.render=function(r,c){var o=c.getComponentInstance();var w=c.getWidth();var h=c.getHeight();r.openStart("div",c);r.style("width",w);r.style("height",h);r.class("sapUiComponentContainer");r.openEnd();r.openStart("div",c.getId()+"-uiarea");if(w&&w!=="auto"){r.style("width","100%");}if(h&&h!=="auto"){r.style("height","100%");}r.openEnd();if(o){o.render(r);}r.close("div");r.close("div");};
return C;},true);
sap.ui.predefine('sap/ui/core/ComponentSupport',['sap/ui/base/DataType','sap/ui/core/ComponentContainer','sap/ui/core/library',"sap/base/Log","sap/base/util/ObjectPath","sap/base/strings/camelize"],function(D,C,a,L,O,c){"use strict";var b=a.ComponentLifecycle;var d=C.getMetadata();var e=function(){};
e.run=function(){var E=e._find();for(var i=0,l=E.length;i<l;i++){var o=E[i];L.debug("Parsing element "+o.outerHTML,"","sap/ui/core/ComponentSupport");var s=e._parse(o);e._applyDefaultSettings(s);L.debug("Creating ComponentContainer with the following settings",JSON.stringify(s,0,2),"sap/ui/core/ComponentSupport");new C(s).placeAt(o);o.removeAttribute("data-sap-ui-component");}};
e._find=function(){return document.querySelectorAll("[data-sap-ui-component]");};
e._parse=function(E){var s={};for(var i=0,l=E.attributes.length;i<l;i++){var A=E.attributes[i];var p=/^data-((?!sap-ui-component).+)/g.exec(A.name);if(p){var k=c(p[1]);var v=A.value;if(k!=="id"){var P=d.getProperty(k);var o=!P&&d.getEvent(k);if(!P&&!o){L.warning("Property or event \""+k+"\" will be ignored as it does not exist in sap.ui.core.ComponentContainer");continue;}if(P){var t=D.getType(P.type);if(!t){throw new Error("Property \""+P.name+"\" has no known type");}v=t.parseValue(v);}else if(o){var f=O.get(v);if(typeof f!=="function"){throw new Error("Callback handler for event \""+o.name+"\" not found");}v=f;}}s[k]=v;}}return s;};
e._applyDefaultSettings=function(s){s.async=true;if(s.manifest===undefined||s.manifest==="true"){s.manifest=true;}else if(s.manifest==="false"){L.error("Ignoring \"manifest=false\" for ComponentContainer of component \""+s.name+"\" as it is not supported by ComponentSupport. "+"Forcing \"manifest=true\"","","sap/ui/core/ComponentSupport");s.manifest=true;}s.lifecycle=s.lifecycle===undefined?b.Container:s.lifecycle;s.autoPrefixId=s.autoPrefixId===undefined?true:s.autoPrefixId;};
e.run();return e;});
sap.ui.predefine('sap/ui/core/ContextMenuSupport',["./Control"],function(C){"use strict";var a=function(){var c;if(!(this instanceof C)){return;}function o(e){e.stopPropagation();if(e.srcControl!==this){return;}e.preventDefault();this._oContextMenu.openAsContextMenu(e,this);}c={oncontextmenu:o};this.setContextMenu=function(b){if(b==null&&this.getContextMenu()){this._oContextMenu=null;this.removeEventDelegate(c,this);return;}else if(!b||!b.getMetadata||!b.getMetadata().isInstanceOf("sap.ui.core.IContextMenu")){return;}if(!this._oContextMenu){this.addEventDelegate(c,this);}this._oContextMenu=b;};this.getContextMenu=function(){return this._oContextMenu;};};return a;},true);
sap.ui.predefine('sap/ui/core/Control',['./CustomStyleClassSupport','./Element','./UIArea','./RenderManager','./BusyIndicatorUtils','./BlockLayerUtils',"sap/base/Log","sap/ui/performance/trace/Interaction","sap/ui/thirdparty/jquery"],function(C,E,U,R,B,a,L,I,q){"use strict";var b;
var c=E.extend("sap.ui.core.Control",{
metadata:{stereotype:"control","abstract":true,publicMethods:["placeAt","attachBrowserEvent","detachBrowserEvent","getControlsByFieldGroup","triggerValidateFieldGroup","checkFieldGroupIds"],library:"sap.ui.core",properties:{"blocked":{type:"boolean",defaultValue:false},"busy":{type:"boolean",defaultValue:false},"busyIndicatorDelay":{type:"int",defaultValue:1000},"busyIndicatorSize":{type:"sap.ui.core.BusyIndicatorSize",defaultValue:'Medium'},"visible":{type:"boolean",group:"Appearance",defaultValue:true},"fieldGroupIds":{type:"string[]",defaultValue:[]}},events:{validateFieldGroup:{enableEventBubbling:true,parameters:{fieldGroupIds:{type:"string[]"}}}}},
constructor:function(i,s){this.bAllowTextSelection=true;E.apply(this,arguments);this.bOutput=this.getDomRef()!=null;},
renderer:null
});
c.prototype.clone=function(){var o=E.prototype.clone.apply(this,arguments);if(this.aBindParameters){for(var i=0,l=this.aBindParameters.length;i<l;i++){var p=this.aBindParameters[i];o.attachBrowserEvent(p.sEventType,p.fnHandler,p.oListener!==this?p.oListener:undefined);}}o.bAllowTextSelection=this.bAllowTextSelection;return o;};
C.apply(c.prototype);
c.prototype.isActive=function(){return document.getElementById(this.sId)!=null;};
c.prototype.invalidate=function(o){var u;if(this.bOutput&&(u=this.getUIArea())){if(!this._bIsBeingDestroyed){u.addInvalidatedControl(this);}}else{var p=this.getParent();if(p&&(this.bOutput||!(this.getVisible&&this.getVisible()===false))){p.invalidate(this);}}};
c.prototype.rerender=function(){U.rerenderControl(this);};
c.prototype.getDomRef=function(s){if(this.bOutput===false&&!this.oParent){return null;}return E.prototype.getDomRef.call(this,s);};
c.prototype.allowTextSelection=function(h){this.bAllowTextSelection=h;return this;};
c.prototype.attachBrowserEvent=function(s,h,l){if(s&&(typeof(s)==="string")){if(typeof h==="function"){if(!this.aBindParameters){this.aBindParameters=[];}l=l||this;var p=h.bind(l);this.aBindParameters.push({sEventType:s,fnHandler:h,oListener:l,fnProxy:p});if(!this._sapui_bInAfterRenderingPhase){this.$().on(s,p);}}}return this;};
c.prototype.detachBrowserEvent=function(s,h,l){if(s&&(typeof(s)==="string")){if(typeof(h)==="function"){var $=this.$(),i,p;l=l||this;if(this.aBindParameters){for(i=this.aBindParameters.length-1;i>=0;i--){p=this.aBindParameters[i];if(p.sEventType===s&&p.fnHandler===h&&p.oListener===l){this.aBindParameters.splice(i,1);$.off(s,p.fnProxy);}}}}}return this;};
c.prototype.getRenderer=function(){return R.getRenderer(this);};
c.prototype.placeAt=function(o,p){var h=sap.ui.getCore();if(h.isInitialized()){var i=o;if(typeof i==="string"){i=h.byId(o);}var j=false;if(!(i instanceof E)){i=h.createUIArea(o);j=true;}if(!i){return this;}if(!j){var k=i.getMetadata().getAggregation("content");var l=true;if(k){if(!k.multiple||k.type!="sap.ui.core.Control"){l=false;}}else if(!i.addContent||!i.insertContent||!i.removeAllContent){l=false;}if(!l){L.warning("placeAt cannot be processed because container "+i+" does not have an aggregation 'content'.");return this;}}if(typeof p==="number"){i.insertContent(this,p);}else{p=p||"last";switch(p){case"last":i.addContent(this);break;case"first":i.insertContent(this,0);break;case"only":i.removeAllContent();i.addContent(this);break;default:L.warning("Position "+p+" is not supported for function placeAt.");}}}else{var t=this;h.attachInit(function(){t.placeAt(o,p);});}return this;};
c.prototype.onselectstart=function(o){if(!this.bAllowTextSelection){o.preventDefault();o.stopPropagation();}};
c.prototype.onBeforeRendering=function(o){};
c.prototype.onAfterRendering=function(o){};
c.prototype.getIdForLabel=function(){return this.getId();};
c.prototype.destroy=function(s){if(this.bIsDestroyed){return;}this._bIsBeingDestroyed=true;this._cleanupBusyIndicator();b=b||sap.ui.require("sap/ui/core/ResizeHandler");if(b){b.deregisterAllForControl(this.getId());}if(!this.getVisible()){var p=document.getElementById(R.createInvisiblePlaceholderId(this));if(p&&p.parentNode){p.parentNode.removeChild(p);}}E.prototype.destroy.call(this,s);};
var r={onBeforeRendering:function(){e.call(this);},onAfterRendering:function(){if(this.getBlocked()&&this.getDomRef()&&!this.getDomRef("blockedLayer")){this._oBlockState=a.block(this,this.getId()+"-blockedLayer",this._sBlockSection);q(this._oBlockState.$blockLayer.get(0)).addClass("sapUiBlockLayerOnly");}if(this.getBusy()&&this.getDomRef()&&!this._busyIndicatorDelayedCallId&&!this.getDomRef("busyIndicator")){var D=this.getBusyIndicatorDelay();if(D){this._busyIndicatorDelayedCallId=setTimeout(A.bind(this),D);}else{A.call(this);}}}};
function A(){if(!this.getBusy()){return;}var $=this.$(this._sBusySection);if(this._busyIndicatorDelayedCallId){clearTimeout(this._busyIndicatorDelayedCallId);delete this._busyIndicatorDelayedCallId;}if(!$||$.length===0){L.warning("BusyIndicator could not be rendered. The outer control instance is not valid anymore.");return;}if(this._sBlockSection===this._sBusySection){if(this._oBlockState){B.addHTML(this._oBlockState,this.getBusyIndicatorSize());a.toggleAnimationStyle(this._oBlockState,true);this._oBusyBlockState=this._oBlockState;}else{d.call(this);}}else{d.call(this);}}
function f(){this._oBlockState=a.block(this,this.getId()+"-blockedLayer",this._sBlockSection);q(this._oBlockState.$blockLayer.get(0)).addClass("sapUiBlockLayerOnly");}
function d(){if(this._oBusyBlockState){a.unblock(this._oBusyBlockState);}this._oBusyBlockState=a.block(this,this.getId()+"-busyIndicator",this._sBusySection);B.addHTML(this._oBusyBlockState,this.getBusyIndicatorSize());}
function e(){a.unblock(this._oBlockState);a.unblock(this._oBusyBlockState);delete this._oBlockState;delete this._oBusyBlockState;}
function g(F){if(F){e.call(this);return;}var $=this.$(this._sBusySection);$.removeClass('sapUiLocalBusy');if(this._sBlockSection===this._sBusySection){if(!this.getBlocked()&&!this.getBusy()){e.call(this);}else if(this.getBlocked()){a.toggleAnimationStyle(this._oBlockState||this._oBusyBlockState,false);this._oBlockState=this._oBusyBlockState;}else if(this._oBusyBlockState){a.unblock(this._oBusyBlockState);delete this._oBusyBlockState;}}else if(this._oBusyBlockState){a.unblock(this._oBusyBlockState);delete this._oBusyBlockState;}}
c.prototype.setBlocked=function(h,s){if(!!h==this.getProperty("blocked")){return this;}this._sBlockSection=s||this._sBlockSection;this.setProperty("blocked",h,true);if(h){this.addDelegate(r,false,this);}else{this.removeDelegate(r);}if(!this.getDomRef()){return this;}if(h){if(this._sBlockSection===this._sBusySection){if(!this._oBusyBlockState&&!this._oBlockState){f.call(this);}else{L.info("The control is already busy. Hence, no new block-layer was created for the shared section.");}}else{f.call(this);}}else{if(this._sBlockSection===this._sBusySection){if(!this.getBlocked()&&!this.getBusy()){e.call(this);}else if(this.getBusy()){L.info("The control is already busy. Hence, no new block-layer was created for the shared section.");}}else if(this._oBlockState){a.unblock(this._oBlockState);delete this._oBlockState;}}return this;};
c.prototype.setBusy=function(h,s){if(!!h==this.getProperty("busy")){return this;}this._sBusySection=s||this._sBusySection;this.setProperty("busy",h,true);if(h){I.notifyShowBusyIndicator(this);this.addDelegate(r,false,this);}else{this.removeDelegate(r);if(this._busyIndicatorDelayedCallId){clearTimeout(this._busyIndicatorDelayedCallId);delete this._busyIndicatorDelayedCallId;}}if(!this.getDomRef()){return this;}if(h){if(this.getBusyIndicatorDelay()<=0){A.call(this);}else{this._busyIndicatorDelayedCallId=setTimeout(A.bind(this),this.getBusyIndicatorDelay());}}else{g.call(this);I.notifyHideBusyIndicator(this);}return this;};
c.prototype.isBusy=c.prototype.getBusy;
c.prototype.setBusyIndicatorDelay=function(D){this.setProperty("busyIndicatorDelay",D,true);return this;};
c.prototype._cleanupBusyIndicator=function(){if(this._busyIndicatorDelayedCallId){clearTimeout(this._busyIndicatorDelayedCallId);delete this._busyIndicatorDelayedCallId;}g.call(this,true);};
c.prototype.getControlsByFieldGroupId=function(F){return this.findAggregatedObjects(true,function(o){if(o instanceof c){return o.checkFieldGroupIds(F);}return false;});};
c.prototype.checkFieldGroupIds=function(F){if(typeof F==="string"){F=F?F.split(","):[];}var h=this._getFieldGroupIds();if(Array.isArray(F)){return F.every(function(s){return h.indexOf(s)>=0;});}else if(!F){return h.length>0;}return false;};
c.prototype.triggerValidateFieldGroup=function(F){this.fireValidateFieldGroup({fieldGroupIds:F});};
return c;});
sap.ui.predefine('sap/ui/core/CustomData',['./Element'],function(E){"use strict";var C=E._CustomData;return C;});
sap.ui.predefine('sap/ui/core/CustomStyleClassSupport',['./Element',"sap/base/assert","sap/base/Log"],function(E,a,L){"use strict";var r=/\s/;var b=/\S+/g;var C=function(){if(!(this instanceof E)){return;}var o=this.clone;this.clone=function(){var c=o.apply(this,arguments);if(this.aCustomStyleClasses){c.aCustomStyleClasses=this.aCustomStyleClasses.slice();}if(this.mCustomStyleClassMap){c.mCustomStyleClassMap=Object.assign(Object.create(null),this.mCustomStyleClassMap);}return c;};this.addStyleClass=function(s,S){a(typeof s==="string","sStyleClass must be a string");if(!s||typeof s!=="string"||s.indexOf("\"")>-1||s.indexOf("'")>-1){return this;}var c=this.aCustomStyleClasses||(this.aCustomStyleClasses=[]),m=this.mCustomStyleClassMap||(this.mCustomStyleClassMap=Object.create(null)),d,M=false,e=[],h=g();function i(j){if(!m[j]){m[j]=true;c.push(j);if(h&&h.indexOf(j)>-1){e.push(j);}M=true;}}if(r.test(s)){d=s.match(b);d&&d.forEach(i);}else{i(s);}if(!M){return this;}var R=this.getDomRef();if(R){if(d){R.classList.add.apply(R.classList,d);}else{R.classList.add(s);}}else if(S===false){this.invalidate();}if(e.length>0){f(this,e,true);}return this;};this.removeStyleClass=function(s,S){a(typeof s==="string","sStyleClass must be a string");if(!s||typeof s!=="string"||!this.aCustomStyleClasses||!this.mCustomStyleClassMap){return this;}var c=this.aCustomStyleClasses,m=this.mCustomStyleClassMap,d,e=false,h=[],i=g(),n;function j(k){if(m[k]){e=true;n=c.indexOf(k);if(n!==-1){c.splice(n,1);delete m[k];if(i&&i.indexOf(k)>-1){h.push(k);}}}}if(r.test(s)){d=s.match(b);d&&d.forEach(j);}else{j(s);}if(e){var R=this.getDomRef();if(R){if(d){R.classList.remove.apply(R.classList,d);}else{R.classList.remove(s);}}else if(S===false){this.invalidate();}if(h.length>0){f(this,h,false);}}return this;};this.toggleStyleClass=function(s,A){a(typeof s==="string","sStyleClass must be a string");if(s&&typeof s==="string"){if(A===true){this.addStyleClass(s);}else if(A===false){this.removeStyleClass(s);}else if(A===undefined){this.hasStyleClass(s)?this.removeStyleClass(s):this.addStyleClass(s);}else{L.warning(this.toString()+"- toggleStyleClass(): bAdd should be a boolean or undefined, but is '"+A+"'");}}return this;};this.hasStyleClass=function(s){a(typeof s==="string","sStyleClass must be a string");if(s&&typeof s==="string"&&this.mCustomStyleClassMap){if(r.test(s)){var c=s.match(b);return c!=null&&c.every(function(d){return this.mCustomStyleClassMap[d];},this);}else{return!!this.mCustomStyleClassMap[s];}}return false;};this.getMetadata().addPublicMethods(["addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass"]);};var P;
function g(){if(!P){P=sap.ui.require("sap/ui/core/theming/Parameters");}if(P){return P._getScopes(true);}}
function f(e,s,i){sap.ui.getCore().fireThemeScopingChanged({scopes:s,added:i,element:e});}
return C;},true);
sap.ui.predefine('sap/ui/core/DeclarativeSupport',['sap/ui/thirdparty/jquery','sap/ui/base/DataType','sap/ui/base/ManagedObject','./Control','./CustomData','./HTML','./mvc/View','./mvc/EventHandlerResolver','sap/base/Log','sap/base/util/ObjectPath','sap/base/assert','sap/base/strings/camelize'],function(q,D,M,C,a,H,V,E,L,O,b,c){"use strict";var d={};d.attributes={"data-sap-ui-type":true,"data-sap-ui-id":true,"data-sap-ui-aggregation":true,"data-sap-ui-default-aggregation":true,"data-sap-ui-binding":function(v,s){var B=M.bindingParser(v);s.objectBindings=s.objectBindings||{};s.objectBindings[B.model||undefined]=B;},"data-tooltip":function(v,s){s["tooltip"]=v;},"tooltip":function(v,s,f){s["tooltip"]=v;L.warning('[Deprecated] Control "'+s.id+'": The attribute "tooltip" is not prefixed with "data-*". Future version of declarative support will only suppport attributes with "data-*" prefix.');},"class":true,"style":true,"id":true};
d.compile=function(e,v,i){var t=this;q(e).find("[data-sap-ui-type]").filter(function(){return q(this).parents("[data-sap-ui-type]").length===0;}).each(function(){t._compile(this,v,i);});};
d._compile=function(e,v,i){var $=q(e);var t=$.attr("data-sap-ui-type");var f=[];var I=t==="sap.ui.core.UIArea";if(I){var g=this;$.children().each(function(){var o=g._createControl(this,v);if(o){f.push(o);}});}else{var o=this._createControl(e,v);if(o){f.push(o);}}$.empty();var A=[];q.each(e.attributes,function(h,j){var n=j.name;if(!I||I&&/^data-/g.test(n.toLowerCase())){A.push(n);}});if(A.length>0){$.removeAttr(A.join(" "));}f.forEach(function(o){if(o instanceof C){if(v&&!i){v.addContent(o);}else{o.placeAt(e);if(v){v.connectControl(o);}}}});};
d._createControl=function(e,v){var $=q(e);var o=null;var t=$.attr("data-sap-ui-type");if(t){var f=sap.ui.requireSync(t.replace(/\./g,"/"));f=f||O.get(t);b(typeof f!=="undefined","Class not found: "+t);var s={};s.id=this._getId($,v);if(v&&v._sProcessingMode!=null&&f.getMetadata().hasSpecialSetting("processingMode")){s.processingMode=v._sProcessingMode;}this._addSettingsForAttributes(s,f,e,v);this._addSettingsForAggregations(s,f,e,v);var o;if(V.prototype.isPrototypeOf(f.prototype)&&typeof f._sType==="string"){o=V._create(s,undefined,f._sType);}else{o=new f(s);}if(e.className){o.addStyleClass(e.className);}$.removeAttr("data-sap-ui-type");}else{o=this._createHtmlControl(e,v);}return o;};
d._createHtmlControl=function(e,v){var h=new H();h.setDOMContent(e);this.compile(e,v,true);return h;};
d._addSettingsForAttributes=function(s,f,e,v){var t=this;var S=d.attributes;var B=M.bindingParser;var g=[];var r=/^data-custom-data:(.+)/i;q.each(e.attributes,function(i,A){var n=A.name;var h=A.value;if(!r.test(n)){if(typeof S[n]==="undefined"){n=t.convertAttributeToSettingName(n,s.id);var p=t._getProperty(f,n);if(p){var o=B(h,v&&v.getController(),true);if(o&&typeof o==="object"){s[n]=o;}else{s[n]=t.convertValueToType(t.getPropertyDataType(p),o||h);}}else if(t._getAssociation(f,n)){var j=t._getAssociation(f,n);if(j.multiple){h=h.replace(/\s*,\s*|\s+/g,",");s[n]=h.split(",").map(function(I){return v?v.createId(I):I;});}else{s[n]=v?v.createId(h):h;}}else if(t._getAggregation(f,n)){var k=t._getAggregation(f,n);if(k.multiple){var o=B(h,v&&v.getController());if(o){s[n]=o;}else{throw new Error("Aggregation "+n+" with cardinality 0..n only allows binding paths as attribute value");}}else if(k.altTypes){var o=B(h,v&&v.getController(),true);if(o&&typeof o==="object"){s[n]=o;}else{s[n]=t.convertValueToType(k.altTypes[0],o||h);}}else{throw new Error("Aggregation "+n+" not supported");}}else if(t._getEvent(f,n)){var l=v&&(v._oContainingView||v).getController();var m=E.resolveEventHandler(h,l);if(m){s[n]=m;}else{throw new Error('Control "'+s.id+'": The function "'+h+'" for the event "'+n+'" is not defined');}}else{b((n==="id"),"DeclarativeSupport encountered unknown setting '"+n+"' for class '"+f.getMetadata().getName()+"' (value:'"+h+"')");}}else if(typeof S[n]==="function"){S[n](h,s,f);}}else{n=c(r.exec(n)[1]);var o=B(h,v&&v.getController());g.push(new a({key:n,value:o||h}));}});if(g.length>0){s.customData=g;}return s;};
d._addSettingsForAggregations=function(s,f,e,v){var $=q(e);var g=this._getDefaultAggregation(f,e);var t=this;var A=f.getMetadata().getAllAggregations();$.children().each(function(){var h=q(this);var i=h.attr("data-sap-ui-aggregation");var T=h.attr("data-sap-ui-type");var u=false;if(!i){u=true;i=g;}if(i&&A[i]){var m=A[i].multiple;var j=function(o){var k=t._createControl(o,v);if(k){if(m){if(!s[i]){s[i]=[];}if(typeof s[i].path==="string"){b(!s[i].template,"list bindings support only a single template object");s[i].template=k;}else{s[i].push(k);}}else{s[i]=k;}}};if(u||(T&&!u)){j(this);}else{h.children().each(function(){j(this);});}}h.removeAttr("data-sap-ui-aggregation");h.removeAttr("data-sap-ui-type");});return s;};
d._getId=function(e,v){var $=q(e);var i=$.attr("id");if(i){if(v){i=v.createId(i);$.attr("data-sap-ui-id",i);}$.attr("id","");}return i;};
d._getProperty=function(f,n){return f.getMetadata().getProperty(n);};
d.convertValueToType=function(t,v){if(t instanceof D){v=t.parseValue(v);}return typeof v==="string"?M.bindingParser.escape(v):v;};
d.getPropertyDataType=function(p){var t=D.getType(p.type);if(!t){throw new Error("Property "+p.name+" has no known type");}return t;};
d.convertAttributeToSettingName=function(A,i,e){if(A.indexOf("data-")===0){A=A.substr(5);}else if(e){L.warning('[Deprecated] Control "'+i+'": The attribute "'+A+'" is not prefixed with "data-*". Future version of declarative support will only suppport attributes with "data-*" prefix.');}else{throw new Error('Control "'+i+'": The attribute "'+A+'" is not prefixed with "data-*".');}return c(A);};
d._getAssociation=function(f,n){return f.getMetadata().getAssociation(n);};
d._getAggregation=function(f,n){return f.getMetadata().getAggregation(n);};
d._getEvent=function(f,n){return f.getMetadata().getEvent(n);};
d._getDefaultAggregation=function(f,e){var $=q(e);var s=$.attr("data-sap-ui-default-aggregation")||f.getMetadata().getDefaultAggregationName();$.removeAttr("data-sap-ui-default-aggregation");return s;};
return d;},true);
sap.ui.predefine('sap/ui/core/EnabledPropagator',[],function(){"use strict";var E=function(d,l){if(!this.isA||!this.isA("sap.ui.core.Control")){throw new Error("EnabledPropagator only supports subclasses of Control");}this._bUseEnabledPropagator=true;var o=this.getEnabled;if(o===undefined){this.getEnabled=function(){return(this._bUseEnabledPropagator&&h(this))?false:this.getProperty("enabled");};d=(d===undefined)?true:Boolean(d);if(l){this.getMetadata().addProperty("Enabled",{type:"boolean",group:"Behavior",defaultValue:d});}this.getMetadata().addProperty("enabled",{type:"boolean",group:"Behavior",defaultValue:d});this.getMetadata().addPublicMethods("getEnabled");}else{this.getEnabled=function(){return(this._bUseEnabledPropagator&&h(this))?false:o.apply(this,arguments);};}if(this.setEnabled===undefined){this.setEnabled=function(e){c(this,e);return this.setProperty("enabled",e);};this.getMetadata().addPublicMethods("setEnabled");}else{var O=this.setEnabled;this.setEnabled=function(e){c(this,e);return O.apply(this,arguments);};}this.useEnabledPropagator=function(u){this._bUseEnabledPropagator=u;};this.getMetadata().addPublicMethods("useEnabledPropagator");};
function h(C){for(var p=C.getParent();p&&!p.getEnabled&&p.getParent;p=p.getParent()){}return p&&p.getEnabled&&!p.getEnabled();}
function c(C,e){var d=C.getDomRef();if(!e&&d&&d.contains(document.activeElement)){var f=C.$().parent().closest(":focusable")[0];if(f){f.focus({preventScroll:true});}}}
return E;},true);
sap.ui.predefine('sap/ui/core/ExtensionPoint',["sap/base/Log","sap/base/util/ObjectPath","sap/ui/core/mvc/View","sap/ui/core/Component"],function(L,O,V,C){"use strict";
sap.ui.extensionpoint=function(c,e,f,t,a){L.warning("Do not use deprecated factory function 'sap.ui.extensionpoint'. Use 'sap.ui.core.ExtensionPoint.load' instead","sap.ui.extensionpoint",null,function(){return{type:"sap.ui.extensionpoint",name:e};});return E._factory(c,e,f,t,a);};
var E=sap.ui.extensionpoint;
E._factory=function(c,e,f,t,a,A){var o,v,r,s;if(c){if(c.isA("sap.ui.core.mvc.View")){s=c.sViewName;v=c;}else if(c.isA("sap.ui.core.Fragment")){s=c.getFragmentName();v=c._oContainingView;}o=C.getCustomizing(c,{type:"sap.ui.viewExtensions",name:s,extensionName:e});}if(o){if(o.className){L.info("Customizing: View extension found for extension point '"+e+"' in View '"+v.sViewName+"': "+o.className+": "+(o.viewName||o.fragmentName));var I=v&&o.id?v.createId(o.id):o.id;var F={async:A,id:I,type:o.type};if(A&&v._sProcessingMode){F.processingMode=v._sProcessingMode;}if(o.className==="sap.ui.core.Fragment"){var b=sap.ui.require("sap.ui.core.Fragment");F.fragmentName=o.fragmentName;F.containingView=v;if(A){if(b){r=b.load(F);}else{r=new Promise(function(R,i){sap.ui.require(["sap/ui/core/Fragment"],function(b){R(b.load(F));},i);});}}else{b=b||sap.ui.requireSync("sap/ui/core/Fragment");var d=new b(F);r=(Array.isArray(d)?d:[d]);}}else if(o.className==="sap.ui.core.mvc.View"){F.viewName=o.viewName;var g=V._create(F);if(A){r=g.loaded();}else{r=[g];}}else{L.warning("Customizing: Unknown extension className configured (and ignored) in Component.js for extension point '"+e+"' in View '"+v.sViewName+"': "+o.className);}}else{L.warning("Customizing: no extension className configured in Component.js for extension point '"+e+"' in View '"+v.sViewName+"': "+o.className);}}else if(E._fnExtensionProvider){var h=E._fnExtensionProvider(v);var j;if(v.isA("sap.ui.core.Fragment")){j=v._sExplicitId;var k=v.getController();v=k&&typeof k.isA==="function"&&k.isA("sap.ui.core.mvc.Controller")&&k.getView();if(v){j=v.getLocalId(j)||j;}}if(h){if(!v){L.warning("View instance could not be passed to ExtensionPoint Provider for extension point '"+e+"' "+"in fragment '"+j+"'.");}return[{providerClass:h,view:v,fragmentId:j,name:e,createDefault:f,targetControl:undefined,aggregationName:undefined,index:undefined,ready:function(i){var n=this._nextSibling;while(n!=null){n.index+=i.length;n=n._nextSibling;}},_isExtensionPoint:true,_nextSibling:null}];}}if(!r&&typeof f==='function'){r=f();}var p=function(r){if(r&&!Array.isArray(r)){r=[r];}if(r&&t){var m=t.getMetadata().getAggregation(a);if(m){for(var i=0,l=r.length;i<l;i++){t[m._sMutator](r[i]);}}else{L.error("Creating extension point failed - Tried to add extension point with name "+e+" to an aggregation of "+t.getId()+" in view "+v.sViewName+", but sAggregationName was not provided correctly and I could not find a default aggregation");}}return r||[];};if(r&&typeof r.then==='function'){return r.then(p);}else{return p(r);}};
E.registerExtensionProvider=function(e){if(e==null){delete E._fnExtensionProvider;}else if(typeof e=="function"){E._fnExtensionProvider=e;}else{L.error("ExtensionPoint provider must be a function!");}};
E.load=function(o){return Promise.resolve(E._factory(o.container,o.name,o.createDefaultContent,null,null,!!o.async));};
return E;});
sap.ui.predefine('sap/ui/core/Fragment',['sap/ui/thirdparty/jquery','../base/ManagedObject','./Element','./DeclarativeSupport','./XMLTemplateProcessor','sap/base/Log','sap/base/util/LoaderExtensions','sap/base/util/merge','sap/ui/core/Component','sap/ui/core/mvc/XMLProcessingMode'],function(q,M,E,D,X,L,a,m,C,b){"use strict";var r={},t={};
var F=M.extend("sap.ui.core.Fragment",{
metadata:{properties:{type:'string'},specialSettings:{async:{type:'boolean',visibility:'hidden'},fragmentName:'string',fragmentContent:'any',containingView:{type:'sap.ui.core.mvc.View',visibility:'hidden'},oController:{type:'sap.ui.core.mvc.Controller',visibility:'hidden'},sId:{type:'sap.ui.core.ID',visibility:'hidden'},sOwnerId:{type:'sap.ui.core.ID',visibility:'hidden'},processingMode:{type:'sap.ui.core.mvc.XMLProcessingMode',visibility:'hidden'}}},
constructor:function(i,s){M.apply(this,arguments);if(!this._bAsync){if(this._aContent&&this._aContent.length==1){return this._aContent[0];}else{return this._aContent;}}}
});
F.registerType=function(T,o){if(typeof(T)!=="string"){L.error("Ignoring non-string Fragment type: "+T);return;}if(t[T]){L.warning("sap.ui.core.Fragment.registerType(): Fragment type '"+T+"' is already defined. Overriding this type now!");}t[T]=o;};
F.prototype._initCompositeSupport=function(s){if(!s){throw new Error("Settings must be set");}if(!(s.fragmentName||s.fragmentContent)){throw new Error("Please provide a fragment name");}if(s.oController){this.oController=s.oController;}this._bAsync=s.async||false;this._sExplicitId=s.sId||s.id;this._sFragmentName=s.fragmentName;this.fnScopedRunWithOwner=s.containingView&&s.containingView.fnScopedRunWithOwner;if(!this.fnScopedRunWithOwner&&this._sOwnerId){var o=C.get(this._sOwnerId);this.fnScopedRunWithOwner=function(d){return o.runAsOwner(d);};}var c=F.getType(s.type);if(c){this._pContentPromise=c.init.apply(this,[s]);if(!this._pContentPromise){this._pContentPromise=Promise.resolve(this._aContent);}}else{throw new Error("No type for the fragment has been specified: "+s.type);}};
F.prototype.getFragmentName=function(){return this._sFragmentName;};
F.prototype.getController=function(){return this.oController;};
F.byId=function(s,i){if(!(typeof(s)==="string"&&typeof(i)==="string")){L.error("sap.ui.core.Fragment.byId: two strings must be given as parameters, but are: "+s+" and "+i);return undefined;}return sap.ui.getCore().byId(s+"--"+i);};
F.createId=function(s,i){if(!(typeof(s)==="string"&&typeof(i)==="string")){L.error("sap.ui.core.Fragment.createId: two strings must be given as parameters, but are: "+s+" and "+i);return undefined;}return s+"--"+i;};
F.prototype.createId=function(i){var c=this._sExplicitId?this._sExplicitId+"--"+i:i;if(this._oContainingView&&this._oContainingView!=this){c=this._oContainingView.createId(c);}return c;};
F.prototype.isSubView=function(){return true;};
sap.ui.fragment=function(n,T,c){var s;if(typeof(T)==="string"){s=T.toLowerCase();}else if(typeof(T)==="object"&&typeof(T.fragmentName)==="string"){s=T.fragmentName.toLowerCase();}else{s="";}L.info("Do not use deprecated factory function 'sap.ui."+s+"fragment'. Require 'sap/ui/core/Fragment' and use 'load()' instead","sap.ui."+s+"fragment",null,function(){return{type:"sap.ui."+s+"fragment",name:s?n+".fragment."+s:n};});return f(n,T,c);};
function f(n,T,c){var s={};if(typeof(n)==="string"){s.fragmentName=n;s.oController=c;s.type=T;}else if(typeof(n)==="object"){s=n;s.async=s.async===true?s.async:false;if(T){s.oController=T;}if(s.async){var d=function(){var O=s.sOwnerId||s.containingView&&s.containingView._sOwnerId;var e=C.get(O);if(e){return e.runAsOwner(function(){return new F(s);});}return new F(s);};var o=F.getType(s.type);if(s.fragmentName&&s.fragmentContent){delete s.fragmentName;}if(s.fragmentName&&typeof o.load=="function"){return new Promise(function(e,g){o.load(s).then(function(v){s.fragmentContent=v;e(d());}).catch(function(h){g(h);});});}else{return Promise.resolve(d());}}}else{L.error("sap.ui.fragment() must be called with Fragment name or config object as first parameter, but is: "+n);}return new F(s);}
F.load=function(o){var p=Object.assign({},o);if(p.name&&p.definition){L.error("The properties 'name' and 'definition' shouldn't be provided at the same time. The fragment definition will be used instead of the name. Fragment name was: "+p.name);delete p.name;}p.type=p.type||"XML";p.async=true;p.processingMode=p.processingMode||b.Sequential;p.fragmentName=p.fragmentName||p.name;p.fragmentContent=p.fragmentContent||p.definition;p.oController=p.controller;p.sOwnerId=M._sOwnerId;delete p.name;delete p.definition;delete p.controller;var c=f(p);return c.then(function(d){return d._pContentPromise;});};
F.getType=function(T){return t[T];};
sap.ui.xmlfragment=function(i,v,c){if(typeof(i)==="string"){if(typeof(v)==="string"){return sap.ui.fragment({fragmentName:v,sId:i,type:"XML"},c);}else{return sap.ui.fragment(i,"XML",v);}}else{i.type="XML";return sap.ui.fragment(i,v);}};
sap.ui.jsfragment=function(n,v,c){if(typeof n==="string"&&typeof v==="object"){if(v.createContent){r[n]=v;sap.ui.loader._.declareModule(n.replace(/\./g,"/")+".fragment.js");}else{return sap.ui.fragment(n,"JS",v);}}else if(typeof n==="string"&&v===undefined){return sap.ui.fragment(n,"JS");}else if(typeof n==="object"){n.type="JS";return sap.ui.fragment(n,v);}else if(arguments.length>=3){return sap.ui.fragment({id:n,fragmentName:v,type:"JS"},c);}else{L.error("sap.ui.jsfragment() was called with wrong parameter set: "+n+" + "+v);}};
sap.ui.htmlfragment=function(i,v,c){if(typeof(i)==="string"){if(typeof(v)==="string"){return sap.ui.fragment({fragmentName:v,sId:i,type:"HTML"},c);}else{return sap.ui.fragment(i,"HTML",v);}}else{i.type="HTML";return sap.ui.fragment(i,v);}};
F.registerType("XML",{load:function(s){return X.loadTemplatePromise(s.fragmentName,"fragment").then(function(d){return d;});},init:function(s){this._aContent=[];if(s.fragmentContent){if(typeof(s.fragmentContent)==="string"){this._xContent=q.parseXML(s.fragmentContent).documentElement;}else{this._xContent=s.fragmentContent;}}else{L.warning("Synchronous loading of fragment, due to Fragment.init() call for '"+s.fragmentName+"'. Use 'sap/ui/core/Fragment' module with Fragment.load() instead.","SyncXHR",null,function(){return{type:"SyncXHR",name:"Fragment"};});this._xContent=X.loadTemplate(s.fragmentName,"fragment");}this._oContainingView=this._sExplicitId?this:(s.containingView||this);if((this._oContainingView===this)){this._oContainingView.oController=(s.containingView&&s.containingView.oController)||s.oController;}this._sProcessingMode=s.processingMode;var S=this._oContainingView._fnSettingsPreprocessor;var p={fnRunWithPreprocessor:function(d){return M.runWithPreprocessors(d,{settings:S});}};var c=X.parseTemplatePromise(this._xContent,this,this._bAsync,p).then(function(d){this._aContent=d;if(this._aContent&&this._aContent.length&&s.objectBindings){this._aContent.forEach(function(o,i){if(o instanceof E){for(var g in s.objectBindings){o.bindObject(s.objectBindings[g]);}}});}return this._aContent.length>1?this._aContent:this._aContent[0];}.bind(this));if(!this._bAsync){try{c.unwrap();}catch(e){L.error("An Error occured during XML processing of '"+this.getMetadata().getName()+"' with id '"+this.getId()+"':\n"+e.stack);}}return c;}});F.registerType("JS",{load:function(s){var c=s.fragmentName.replace(/\./g,"/")+".fragment";return new Promise(function(d,e){sap.ui.require([c],function(g){d(g);},e);});},init:function(s){this._aContent=[];if(s.fragmentContent){m(this,s.fragmentContent);}else{if(!r[s.fragmentName]){sap.ui.requireSync(s.fragmentName.replace(/\./g,"/")+".fragment");}m(this,r[s.fragmentName]);}this._oContainingView=s.containingView||this;return M.runWithPreprocessors(function(){var c;if(this.fnScopedRunWithOwner){this.fnScopedRunWithOwner(function(){c=this.createContent(s.oController||this._oContainingView.oController);}.bind(this));}else{c=this.createContent(s.oController||this._oContainingView.oController);}if(c instanceof Promise){return c.then(function(d){this._aContent=this._aContent.concat(d);return this._aContent.length>1?this._aContent:this._aContent[0];}.bind(this));}else{return new Promise(function(d,e){this._aContent=this._aContent.concat(c);d(this._aContent.length>1?this._aContent:this._aContent[0]);}.bind(this));}}.bind(this),{settings:this._oContainingView._fnSettingsPreprocessor});}});(function(){var _={};var c=function(T){var u=sap.ui.require.toUrl(T.replace(/\./g,"/"))+".fragment.html";var h=_[u];var R;if(!h){R=T.replace(/\./g,"/")+".fragment.html";h=a.loadResource(R);_[u]=h;}return h;};F.registerType("HTML",{load:function(s){var d=s.fragmentName.replace(/\./g,"/")+".fragment";return a.loadResource(d+".html",{async:true}).then(function(o){return o;});},init:function(s){this._aContent=[];this.getContent=function(){return this._aContent;};this.addContent=function(j){this._aContent.push(j);};this._oContainingView=s.containingView||this;this._sProcessingMode=s.processingMode;var h=s.fragmentContent||c(s.fragmentName);this._oTemplate=document.createElement("div");if(typeof h==="string"){this._oTemplate.innerHTML=h;}else{var n=h;var d=document.createDocumentFragment();for(var i=0;i<n.length;i++){d.appendChild(n.item(i));}this._oTemplate.appendChild(d);}var o=this._oTemplate.getElementsByTagName("template")[0];var p=this.getMetadata().getAllProperties();if(o){var e=this;q.each(o.attributes,function(I,A){var N=D.convertAttributeToSettingName(A.name,e.getId());var v=A.value;var P=p[N];if(!s[N]){if(P){s[N]=D.convertValueToType(D.getPropertyDataType(P),v);}else if(sap.ui.core.mvc.HTMLView._mAllowedSettings[N]){s[N]=v;}}});this._oTemplate=o;}if(this._oTemplate.content){var g=this._oTemplate.content;this._oTemplate=document.createElement("div");this._oTemplate.appendChild(g);}return M.runWithPreprocessors(function(){if(this.fnScopedRunWithOwner){this.fnScopedRunWithOwner(function(){D.compile(this._oTemplate,this);}.bind(this));}else{D.compile(this._oTemplate,this);}var j=this.getContent();if(j&&j.length===1){this._aContent=[j[0]];return new Promise(function(k,l){k(this._aContent[0]);}.bind(this));}}.bind(this),{settings:this._oContainingView._fnSettingsPreprocessor});}});}());return F;});
sap.ui.predefine('sap/ui/core/HTML',['sap/ui/thirdparty/jquery',"sap/base/Log",'./Control','./RenderManager',"./HTMLRenderer","sap/base/security/sanitizeHTML"],function(q,L,C,R,H,b){"use strict";var c=R.RenderPrefixes;
var d=C.extend("sap.ui.core.HTML",{
metadata:{library:"sap.ui.core",properties:{content:{type:"string",group:"Misc",defaultValue:null},preferDOM:{type:"boolean",group:"Misc",defaultValue:true},sanitizeContent:{type:"boolean",group:"Misc",defaultValue:false},visible:{type:"boolean",group:"Appearance",defaultValue:true}},events:{afterRendering:{parameters:{isPreservedDOM:{type:"boolean"}}}}},
renderer:H
});
d.prototype.getDomRef=function(s){var i=s?this.getId()+"-"+s:this.getId();return document.getElementById(c.Dummy+i)||document.getElementById(i);};
d.prototype.setContent=function(e){function p(s){if(q.parseHTML){var a=q.parseHTML(s);if(a){var f=0,g=a.length;while(f<g&&a[f].nodeType!=1){f++;}while(f<g&&a[g-1].nodeType!=1){g--;}if(f>0||g<a.length){a=a.slice(f,g);}return q(a);}}return q(s);}if(this.getSanitizeContent()){L.trace("sanitizing HTML content for "+this);e=b(e);}this.setProperty("content",e,true);if(this.getDomRef()){var $=p(this.getContent());q(this.getDomRef()).replaceWith($);this._postprocessNewContent($);}else{this.invalidate();}return this;};
d.prototype.setSanitizeContent=function(s){this.setProperty("sanitizeContent",s,true);if(s){this.setContent(this.getContent());}return this;};
d.prototype.onBeforeRendering=function(){if(!this.getPreferDOM()){return;}var D=this.getDomRef();if(D&&!R.isPreservedContent(D)){for(var i=D.id,n;D&&D.getAttribute("data-sap-ui-preserve")==i;D=n){n=D.nextElementSibling;R.preserveContent(D,true,false);}}};
d.prototype.onAfterRendering=function(){if(!this.getVisible()){return;}var $=q(document.getElementById(c.Dummy+this.getId()));var a=R.findPreservedContent(this.getId());var e;var i=false;if((!this.getPreferDOM()||a.length==0)){a.remove();e=new q(this.getContent());$.replaceWith(e);}else if(a.length>0){$.replaceWith(a);e=a;i=true;}else{$.remove();}this._postprocessNewContent(e);this.fireAfterRendering({isPreservedDOM:i});};
d.prototype._postprocessNewContent=function($){if($&&$.length>0){if($.length>1){L.warning("[Unsupported Feature]: "+this+" has rendered "+$.length+" root nodes!");}else{var s=$.attr("id");if(s&&s!=this.getId()){L.warning("[Unsupported Feature]: Id of HTML Control '"+this.getId()+"' does not match with content id '"+s+"'!");}}if(this.getPreferDOM()){R.markPreservableContent($,this.getId());}if($.find("#"+this.getId().replace(/(:|\.)/g,'\\$1')).length===0){$.filter(":not([id])").first().attr("id",this.getId());}}else{L.debug(""+this+" is empty after rendering, setting bOutput to false");this.bOutput=false;}};
d.prototype.setDOMContent=function(D){var $=q(D);if(this.getDomRef()){q(this.getDomRef()).replaceWith($);this._postprocessNewContent($);}else{$.appendTo(R.getPreserveAreaRef());if(this.getUIArea()){this.getUIArea().invalidate();}this._postprocessNewContent($);}return this;};
d.prototype.setTooltip=function(){L.warning("The sap.ui.core.HTML control doesn't support tooltips. Add the tooltip to the HTML content instead.");return C.prototype.setTooltip.apply(this,arguments);};
"hasStyleClass addStyleClass removeStyleClass toggleStyleClass".split(" ").forEach(function(m){d.prototype[m]=function(){L.warning("The sap.ui.core.HTML control doesn't support custom style classes. Manage custom CSS classes in the HTML content instead.");return C.prototype[m].apply(this,arguments);};});return d;});
sap.ui.predefine('sap/ui/core/HTMLRenderer',['./RenderManager'],function(R){"use strict";var a=R.RenderPrefixes;var H={apiVersion:2,render:function(r,c){r.openStart("div",a.Dummy+c.getId());r.style("display","none");r.openEnd();r.close("div");}};return H;},true);
sap.ui.predefine('sap/ui/core/History',['sap/ui/base/Object',"sap/ui/util/Storage"],function(B,S){"use strict";
var H=B.extend("sap.ui.core.History",{
constructor:function(i,s){B.apply(this);if(!s){s={};}var h=s.prefix?s.prefix:document.location.pathname;this._iMaxHistory=s.max?s.max:100;this._sHistoryId=h+i;this._oStorage=new S(S.Type.local);this._fFilter=s.filter?s.filter:function(a,v){return a&&(!v||(v&&((typeof v=="string"?a.toLowerCase().startsWith(v.toLowerCase()):false))));};this._fCheckHistory=s.checkHistory?s.checkHistory:function(a){return a;};},
_initHistory:function(){if(!this._aHistory){var h=this._oStorage.get(this._sHistoryId);if(typeof(h)==="string"){h=h.split(",");}else if(!h){h=[];}this._aHistory=this._fCheckHistory(h);}return this._aHistory;},
get:function(v){var h=this._initHistory();var r=[];for(var i=0;i<h.length;i++){if(this._fFilter(h[i],v)){r.push(h[i]);}}return r;},
remove:function(v){var h=this._initHistory();for(var i=0;i<h.length;i++){if(h[i]==v){h.splice(i,1);break;}}},
add:function(v){var h=this._initHistory();for(var i=0;i<h.length;i++){if(h[i]===v){h.splice(i,1);break;}}h.unshift(v);if(h.length>this._iMaxHistory){h.splice(this._iMaxHistory);}this._oStorage.put(this._sHistoryId,h);},
clear:function(){this._oStorage.remove(this._sHistoryId);this._aHistory=null;}
});
return H;});
sap.ui.predefine('sap/ui/core/Icon',['sap/base/assert','../Device','./Control','./_IconRegistry','./InvisibleText','./library',"./IconRenderer","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/base/Log"],function(a,D,C,_,I,l,b,K,q,L){"use strict";var c=l.IconColor;var d=l.CSSColor;var i=function(v){if(v!=null&&v!==""&&!d.isValid(v)&&!(v in c)){L.error("\""+v+"\" is not of type sap.ui.core.CSSColor nor of type sap.ui.core.IconColor.");return false;}else{return true;}};
var e=C.extend("sap.ui.core.Icon",{
metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.ui.core",designtime:"sap/ui/core/designtime/Icon.designtime",properties:{src:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},size:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},color:{type:"string",group:"Appearance",defaultValue:null},hoverColor:{type:"string",group:"Appearance",defaultValue:null},activeColor:{type:"string",group:"Appearance",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},backgroundColor:{type:"string",group:"Appearance",defaultValue:null},hoverBackgroundColor:{type:"string",group:"Appearance",defaultValue:null},activeBackgroundColor:{type:"string",group:"Appearance",defaultValue:null},decorative:{type:"boolean",group:"Accessibility",defaultValue:true},useIconTooltip:{type:"boolean",group:"Accessibility",defaultValue:true},alt:{type:"string",group:"Accessibility",defaultValue:null},noTabStop:{type:"boolean",group:"Accessibility",defaultValue:false}},aggregations:{_invisibleText:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{}}},
renderer:b
});
e.prototype[D.support.touch?"ontouchstart":"onmousedown"]=function(E){if(this.hasListeners("press")){E.setMarked();}var A=this.getActiveColor(),s=this.getActiveBackgroundColor(),$;if(A||s){if(!E.targetTouches||(E.targetTouches&&E.targetTouches.length===1)){$=this.$();$.addClass("sapUiIconActive");if(A){this._addColorClass(A,"color");}if(s){this._addColorClass(s,"background-color");}}}};e.prototype[D.support.touch?"ontouchend":"onmouseup"]=function(E){if(!E.targetTouches||(E.targetTouches&&E.targetTouches.length===0)){this.$().removeClass("sapUiIconActive");this._restoreColors(D.system.desktop?"hover":undefined);}};
e.prototype.onmouseover=function(){var h=this.getHoverColor(),H=this.getHoverBackgroundColor();if(h){this._addColorClass(h,"color");}if(H){this._addColorClass(H,"background-color");}};
e.prototype.onmouseout=function(){this._restoreColors();};
e.prototype[D.support.touch&&!D.system.desktop?"ontap":"onclick"]=function(E){if(this.hasListeners("press")){E.setMarked();}this.firePress({});};
e.prototype.onkeydown=function(E){if(E.which===K.SPACE||E.which===K.ENTER){E.preventDefault();var $=this.$(),A=this.getActiveColor(),s=this.getActiveBackgroundColor();$.addClass("sapUiIconActive");if(A){this._addColorClass(A,"color");}if(s){this._addColorClass(s,"background-color");}}};
e.prototype.onkeyup=function(E){if(E.which===K.SPACE||E.which===K.ENTER){this.$().removeClass("sapUiIconActive");this._restoreColors();this.firePress({});}};
e.prototype._restoreColors=function(m){var s,B;if(m==="hover"){s=this.getHoverColor();B=this.getHoverBackgroundColor();}s=s||this.getColor();B=B||this.getBackgroundColor();this._addColorClass(s||"","color");this._addColorClass(B||"","background-color");};
e.prototype._addColorClass=function(s,f){var $=this.$(),t=this;var g="";if(f==="color"){g="sapUiIconColor";}else if(f==="background-color"){g="sapUiIconBGColor";}else{return;}q.each(c,function(p,P){t.removeStyleClass(g+P);});if(s in c){$.css(f,"");this.addStyleClass(g+s);}else{$.css(f,s);}};
e.prototype.setSrc=function(s){a(s==null||_.isIconURI(s),this+": Property 'src' (value: '"+s+"') should be a valid Icon URI (sap-icon://...)");return this.setProperty("src",s);};
e.prototype.setColor=function(s){if(i(s)){this.setProperty("color",s,true);this._addColorClass(s,"color");}return this;};
e.prototype.setActiveColor=function(s){if(i(s)){this.setProperty("activeColor",s,true);}return this;};
e.prototype.setHoverColor=function(s){if(i(s)){this.setProperty("hoverColor",s,true);}return this;};
e.prototype.setBackgroundColor=function(s){if(i(s)){this.setProperty("backgroundColor",s,true);this._addColorClass(s,"background-color");}return this;};
e.prototype.setActiveBackgroundColor=function(s){if(i(s)){this.setProperty("activeBackgroundColor",s,true);}return this;};
e.prototype.setHoverBackgroundColor=function(s){if(i(s)){this.setProperty("hoverBackgroundColor",s,true);}return this;};
e.prototype.attachEvent=function(E){C.prototype.attachEvent.apply(this,arguments);if(E=="press"&&this.hasListeners("press")){this.invalidate();}return this;};
e.prototype.detachEvent=function(E){C.prototype.detachEvent.apply(this,arguments);if(E=="press"&&!this.hasListeners("press")){this.invalidate();}return this;};
e.prototype._getOutputTitle=function(o){var t=this.getTooltip_AsString(),u=this.getUseIconTooltip();if(t||(u&&o&&o.text)){return t||o.text;}};
e.prototype._getIconLabel=function(o){var A=this.getAlt(),t=this.getTooltip_AsString(),u=this.getUseIconTooltip(),s=A||t||(u&&o&&(o.text||o.name));if(s){return s;}};
e.prototype._createInvisibleText=function(t){var o=this.getAggregation("_invisibleText");if(!o){o=new I(this.getId()+"-label",{text:t});this.setAggregation("_invisibleText",o,true);}else{o.setText(t);}return o;};
e.prototype._getAccessibilityAttributes=function(o){var f=this.getAriaLabelledBy(),A={},s=this._getIconLabel(o),g;if(this.getDecorative()){A.role="presentation";A.hidden="true";}else if(this.hasListeners("press")){A.role="button";}else{A.role="img";}if(f.length>0){if(s){g=this._createInvisibleText(s);f.push(g.getId());}A.labelledby=f.join(" ");}else if(s){A.label=s;}return A;};
e.prototype.getAccessibilityInfo=function(){if(this.getDecorative()){return null;}var h=this.hasListeners("press");var o=_.getIconInfo(this.getSrc(),undefined,"sync");return{role:h?"button":"img",type:sap.ui.getCore().getLibraryResourceBundle("sap.ui.core").getText(h?"ACC_CTR_TYPE_BUTTON":"ACC_CTR_TYPE_IMAGE"),description:this.getAlt()||this.getTooltip_AsString()||(o?o.text||o.name:""),focusable:h};};
return e;});
sap.ui.predefine('sap/ui/core/IconPool',['sap/ui/core/Icon','sap/ui/core/_IconRegistry',"sap/base/Log","sap/ui/thirdparty/jquery",'./Core'],function(I,_,L,q){"use strict";var a={};
a.createControlByURI=function(s,c){if(typeof s==="string"){s={src:s};}if(s&&s.src){var S=s.src,C=c;if(a.isIconURI(S)){C=I;if(s.tap){s.press=s.tap;delete s.tap;}}if(typeof C==="function"){s=C.getMetadata().removeUnknownSettings(s);return new C(s);}}};
a.addIcon=_.addIcon;a.getIconURI=_.getIconURI;a.getIconInfo=_.getIconInfo;
a.fontLoaded=function(c){var f=_.getFontRegistry();if(f[c]){if(f[c].metadataLoaded instanceof Promise){return f[c].metadataLoaded;}else if(f[c].metadataLoaded===true){return Promise.resolve();}}};
a.isIconURI=_.isIconURI;a.getIconCollectionNames=_.getIconCollectionNames;a.getIconNames=_.getIconNames;a.insertFontFaceStyle=_.insertFontFaceStyle;
a.registerFont=function(c){c.collectionName=c.collectionName||c.fontFamily;if(!c.fontURI){L.error("The configuration parameter fontURI is missing, cannot register the font '"+c.collectionName+"'!");return;}if(c.fontFamily===_.sapIconFontFamily){L.error("The font family"+_.sapIconFontFamily+" is already registered");return;}if(c.fontURI.substr(c.fontURI.length-1)!=="/"){c.fontURI+="/";}var f=_.getFontRegistry();if(!f[c.collectionName]||f[c.collectionName].metadataLoaded===false){f[c.collectionName]={config:c,inserted:false};}else{L.warning("The font '"+c.collectionName+"' is already registered");}if(!c.lazy){_._loadFontMetadata(c.collectionName,true);}};
var i={"application/msword":"sap-icon://doc-attachment","application/vnd.openxmlformats-officedocument.wordprocessingml.document":"sap-icon://doc-attachment","application/rtf":"sap-icon://doc-attachment","application/pdf":"sap-icon://pdf-attachment","application/vnd.openxmlformats-officedocument.spreadsheetml.sheet":"sap-icon://excel-attachment","application/vnd.ms-excel":"sap-icon://excel-attachment","application/msexcel":"sap-icon://excel-attachment","application/vnd.ms-powerpoint":"sap-icon://ppt-attachment","application/vnd.openxmlformats-officedocument.presentationml.presentation":"sap-icon://ppt-attachment","application/vnd.openxmlformats-officedocument.presentationml.slideshow":"sap-icon://ppt-attachment","application/mspowerpoint":"sap-icon://ppt-attachment","application/xml":"sap-icon://attachment-html","application/xhtml+xml":"sap-icon://attachment-html","application/x-httpd-php":"sap-icon://attachment-html","application/x-javascript":"sap-icon://attachment-html","application/gzip":"sap-icon://attachment-zip-file","application/x-rar-compressed":"sap-icon://attachment-zip-file","application/x-tar":"sap-icon://attachment-zip-file","application/zip":"sap-icon://attachment-zip-file","audio/voxware":"sap-icon://attachment-audio","audio/x-aiff":"sap-icon://attachment-audio","audio/x-midi":"sap-icon://attachment-audio","audio/x-mpeg":"sap-icon://attachment-audio","audio/x-pn-realaudio":"sap-icon://attachment-audio","audio/x-pn-realaudio-plugin":"sap-icon://attachment-audio","audio/x-qt-stream":"sap-icon://attachment-audio","audio/x-wav":"sap-icon://attachment-audio","image/png":"sap-icon://attachment-photo","image/tiff":"sap-icon://attachment-photo","image/bmp":"sap-icon://attachment-photo","image/jpeg":"sap-icon://attachment-photo","image/gif":"sap-icon://attachment-photo","text/plain":"sap-icon://attachment-text-file","text/comma-separated-values":"sap-icon://attachment-text-file","text/css":"sap-icon://attachment-text-file","text/html":"sap-icon://attachment-text-file","text/javascript":"sap-icon://attachment-text-file","text/richtext":"sap-icon://attachment-text-file","text/rtf":"sap-icon://attachment-text-file","text/tab-separated-values":"sap-icon://attachment-text-file","text/xml":"sap-icon://attachment-text-file","video/mpeg":"sap-icon://attachment-video","video/quicktime":"sap-icon://attachment-video","video/x-msvideo":"sap-icon://attachment-video","application/x-shockwave-flash":"sap-icon://attachment-video"};
a.getIconForMimeType=function(m){return i[m]||"sap-icon://document";};
return a;},true);
sap.ui.predefine('sap/ui/core/IconRenderer',['./_IconRegistry','./library',"sap/base/security/encodeCSS"],function(_,l,e){"use strict";var I=l.IconColor;var a={apiVersion:2};
a.render=function(r,c){var i=_.getIconInfo(c.getSrc(),undefined,"mixed"),w=c.getWidth(),h=c.getHeight(),C=c.getColor(),b=c.getBackgroundColor(),s=c.getSize(),t=c._getOutputTitle(i),L,o,A,d=false;if(i instanceof Promise){i.then(c.invalidate.bind(c));}else if(i){d=true;L=c.getAriaLabelledBy();A=c._getAccessibilityAttributes(i);o=c.getAggregation("_invisibleText");}r.openStart("span",c);r.class("sapUiIcon");if(d){r.accessibilityState(c,A);r.attr("data-sap-ui-icon-content",i.content);r.style("font-family","'"+e(i.fontFamily)+"'");if(!i.suppressMirroring){r.class("sapUiIconMirrorInRTL");}}if(c.hasListeners("press")){r.class("sapUiIconPointer");if(!c.getNoTabStop()){r.attr("tabindex","0");}}r.style("width",w);r.style("height",h);r.style("line-height",h);r.style("font-size",s);if(C&&!(C in I)){r.style("color",C);}if(b&&!(b in I)){r.style("background-color",b);}r.openEnd();if(t){r.openStart("span").class("sapUiIconTitle").attr("title",t).attr("aria-hidden",true).openEnd().close("span");}if(L&&L.length&&o){r.renderControl(o);}r.close("span");};
return a;},true);
sap.ui.predefine('sap/ui/core/IndicationColorSupport',['./library'],function(l){"use strict";var I=l.IndicationColor;var a={};var t=null;var e=function(){if(!t){t={};var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core");t[I.Indication01]=r.getText("INDICATION_STATE_INDICATION01");t[I.Indication02]=r.getText("INDICATION_STATE_INDICATION02");t[I.Indication03]=r.getText("INDICATION_STATE_INDICATION03");t[I.Indication04]=r.getText("INDICATION_STATE_INDICATION04");t[I.Indication05]=r.getText("INDICATION_STATE_INDICATION05");t[I.Indication06]=r.getText("INDICATION_STATE_INDICATION06");t[I.Indication07]=r.getText("INDICATION_STATE_INDICATION07");t[I.Indication08]=r.getText("INDICATION_STATE_INDICATION08");}};
a.getAdditionalText=function(v){var i=null;if(v&&v.getValueState){i=v.getIndicationColor();}else if(I[v]){i=v;}if(i){e();return t[i];}return null;};
return a;},true);
sap.ui.predefine('sap/ui/core/InvisibleMessage',["./library","sap/ui/base/ManagedObject","sap/base/Log"],function(c,M,L){"use strict";var i;var I=c.InvisibleMessageMode;
var a=M.extend("sap.ui.core.InvisibleMessage",{constructor:function(){if(i){L.warning('This is a singleton, therefore you are not able to create another instance of this class.');return i;}i=this;M.apply(this,arguments);}});
a.getInstance=function(){if(!i){i=new a("__invisiblemessage",{});}return i;};
a.prototype.init=function(){var C=sap.ui.getCore(),s=C.getStaticAreaRef();s.insertAdjacentHTML("beforeend",this.getPoliteInstance());s.insertAdjacentHTML("beforeend",this.getAssertiveInstance());};
a.prototype.announce=function(t,m){var C=sap.ui.getCore(),s=C.getStaticAreaRef(),p=s.querySelector(".sapUiInvisibleMessagePolite"),A=s.querySelector(".sapUiInvisibleMessageAssertive");if(!p||!A){return;}var n=m===I.Assertive?A:p;n.textContent="";n.textContent=t;if(m!==I.Assertive&&m!==I.Polite){L.info('You have entered an invalid mode. Valid values are: '+'"Polite" '+'and "Assertive".'+' The framework will automatically set the mode to "Polite".');}setTimeout(function(){if(n.textContent===t){n.textContent="";}},3000);};
a.prototype.getPoliteInstance=function(){var s=this.getId();return'<span id="'+s+'-polite'+'" data-sap-ui="'+s+'-polite'+'" class="sapUiInvisibleMessagePolite" role="status" aria-live="polite">'+'</span>';};
a.prototype.getAssertiveInstance=function(){var s=this.getId();return'<span id="'+s+'-assertive'+'" data-sap-ui="'+s+'-assertive'+'" class="sapUiInvisibleMessageAssertive" role="status" aria-live="assertive">'+'</span>';};
return a;});
sap.ui.predefine('sap/ui/core/InvisibleText',["./Control","sap/base/Log","sap/base/security/encodeXML","./library"],function(C,L,a){"use strict";
var I=C.extend("sap.ui.core.InvisibleText",{
metadata:{library:"sap.ui.core",publicMethods:["toStatic"],properties:{text:{type:"string",defaultValue:""}}},
renderer:{apiVersion:2,render:function(r,c){r.openStart("span",c);r.class("sapUiInvisibleText");r.attr("aria-hidden","true");r.openEnd();r.text(c.getText()||"");r.close("span");}}
});
function m(w){return function(){L.warning(w+" is not supported by control sap.ui.core.InvisibleText.");return this;};}
I.prototype.setBusy=m("Property busy");I.prototype.setBusyIndicatorDelay=m("Property busy");I.prototype.setBusyIndicatorSize=m("Property busy");I.prototype.setVisible=m("Property visible");I.prototype.setTooltip=m("Aggregation tooltip");
I.prototype.setText=function(T){this.setProperty("text",T,true);this.$().html(a(this.getText()||""));return this;};
I.prototype.getRendererMarkup=function(){var i=this.getId();return'<span id="'+i+'" data-sap-ui="'+i+'" class="sapUiInvisibleText" aria-hidden="true">'+a(this.getText())+'</span>';};
I.prototype.toStatic=function(){var c=sap.ui.getCore();try{var s=c.getStaticAreaRef();s.insertAdjacentHTML("beforeend",this.getRendererMarkup());this.bOutput=true;}catch(e){this.placeAt("sap-ui-static");}return this;};
var t=Object.create(null);
I.getStaticId=function(l,T){var s="",k,b,o;if(sap.ui.getCore().getConfiguration().getAccessibility()&&T){k=l+"|"+T;s=t[k];if(s==null){b=sap.ui.getCore().getLibraryResourceBundle(l);o=new I().setText(b.getText(T));o.toStatic();s=t[k]=o.getId();}}return s;};
sap.ui.getCore().attachLocalizationChanged(function(e){var c=sap.ui.getCore(),k,p,b,T;for(k in t){p=k.indexOf('|');b=c.getLibraryResourceBundle(k.slice(0,p));T=c.byId(t[k]);T&&T.setText(b.getText(k.slice(p+1)));}});return I;});
sap.ui.predefine('sap/ui/core/Item',['./Element','./library'],function(E,l){"use strict";var T=l.TextDirection;
var I=E.extend("sap.ui.core.Item",{metadata:{library:"sap.ui.core",properties:{text:{type:"string",group:"Misc",defaultValue:""},enabled:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Misc",defaultValue:T.Inherit},key:{type:"string",group:"Data",defaultValue:null}}}});
return I;});
sap.ui.predefine('sap/ui/core/LayoutData',['./Element',"sap/ui/thirdparty/jquery",'./library'],function(E,q){"use strict";
var L=E.extend("sap.ui.core.LayoutData",{metadata:{"abstract":true,library:"sap.ui.core"}});
L.prototype.invalidate=function(){var p=this.getParent();if(p&&p.getMetadata().getName()=="sap.ui.core.VariantLayoutData"){p=p.getParent();}if(p){var l=p.getParent();if(l){var e=q.Event("LayoutDataChange");e.srcControl=p;l._handleEvent(e);}}};
L.prototype.setLayoutData=function(l){return this;};
return L;});
sap.ui.predefine('sap/ui/core/ListItem',['./Item','./library'],function(I){"use strict";
var L=I.extend("sap.ui.core.ListItem",{metadata:{library:"sap.ui.core",properties:{icon:{type:"string",group:"Appearance",defaultValue:null},additionalText:{type:"string",group:"Data",defaultValue:null}}}});
return L;});
sap.ui.predefine('sap/ui/core/LocalBusyIndicator',['./Control','./theming/Parameters',"./LocalBusyIndicatorRenderer",'./library'],function(C,P,L){"use strict";
var a=C.extend("sap.ui.core.LocalBusyIndicator",{
metadata:{deprecated:true,library:"sap.ui.core",properties:{width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:'100px'},height:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:'100px'}}},
renderer:L
});
a.prototype.init=function(){var r="sap.ui.core.LocalBusyIndicator:";var p="sapUiLocalBusyIndicatorBoxSize";p=P.get(r+p);this._iBoxSize=8;p="sapUiLocalBusyIndicatorBoxColor";this._sBoxColor=P.get(r+p);p="sapUiLocalBusyIndicatorBoxColorActive";this._sBoxColorActive=P.get(r+p);this._animateProxy=A.bind(this);};
a.prototype.exit=function(){clearTimeout(this._delayedCallId);delete this._delayedCallId;};
a.prototype.onThemeChanged=function(e){if(this.getDomRef()){this.invalidate();}};
a.prototype.onAfterRendering=function(){var w=parseInt(this.getWidth());var h=parseInt(this.getHeight());var $=this.$();$.css("width",w+"px");$.css("height",h+"px");var b=this.$("animation");var l=Math.floor(w/2);l-=Math.floor((5*this._iBoxSize)/2);var t=Math.floor(h/2)-Math.floor(this._iBoxSize/2);b.css("left",l+"px");b.css("top",t+"px");if(!this._$left){this._$left=this.$("leftBox");}if(!this._$middle){this._$middle=this.$("middleBox");}if(!this._$right){this._$right=this.$("rightBox");}this._delayedCallId=setTimeout(this._animateProxy,0);};
var A=function(){if(this.getDomRef()){var t=this;var $,b,c;var d="",e="";if(t._$left){$=t._$left;}else{return;}if(t._$middle){b=t._$middle;}else{return;}if(t._$right){c=t._$right;}else{return;}if(t._sBoxColor){d=t._sBoxColor;}else{return;}if(t._sBoxColorActive){e=t._sBoxColorActive;}else{return;}$.css("background-color",e);setTimeout(function(){$.css("background-color",d);b.css("background-color",e);setTimeout(function(){b.css("background-color",d);c.css("background-color",e);setTimeout(function(){c.css("background-color",d);},150);},150);},150);this._delayedCallId=setTimeout(this._animateProxy,1200);}};return a;});
sap.ui.predefine('sap/ui/core/LocalBusyIndicatorRenderer',function(){"use strict";var r=function(R,c){var I=c.getId();var s=I+"-animation";var b=["-leftBox","-middleBox","-rightBox"];R.openStart('div',s);R.class("sapUiLocalBusyIndicatorAnimation");R.openEnd();for(var i=0;i<b.length;i++){R.openStart('div',I+b[i]);R.class("sapUiLocalBusyIndicatorBox");R.openEnd();R.close("div");}R.close("div");};var L={apiVersion:2};
L.render=function(R,c){R.openStart("div",c);R.class("sapUiLocalBusyIndicator");R.openEnd();r(R,c);R.close("div");};
return L;},true);
sap.ui.predefine('sap/ui/core/LocalBusyIndicatorSupport',['./Control',"sap/base/Log"],function(C,L){"use strict";var a=function(){if(this===C.prototype){this.setDelay=this.setBusyIndicatorDelay;}else{L.error("Only controls can use the LocalBusyIndicator",this);}};return a;},true);
sap.ui.predefine('sap/ui/core/LocaleData',['sap/base/util/extend','sap/ui/base/Object','./CalendarType','./Locale','sap/base/assert','sap/base/util/LoaderExtensions'],function(e,B,C,L,a,b){"use strict";
var c=B.extend("sap.ui.core.LocaleData",{
constructor:function(o){this.oLocale=o;B.apply(this);this.mData=h(o);},
_get:function(){return this._getDeep(this.mData,arguments);},
_getMerged:function(){return this._get.apply(this,arguments);},
_getDeep:function(o,p){var r=o;for(var i=0;i<p.length;i++){r=r[p[i]];if(r===undefined){break;}}return r;},
getOrientation:function(){return this._get("orientation");},
getCurrentLanguageName:function(){var o=this.getLanguages();var s;var i=this.oLocale.getModernLanguage();var S=this.oLocale.getScript();if(i==="sr"&&S==="Latn"){i="sh";S=null;}if(this.oLocale.getRegion()){s=o[i+"_"+this.oLocale.getRegion()];}if(!s&&S){s=o[i+"_"+S];}if(!s){s=o[i];}return s;},
getLanguages:function(){return this._get("languages");},
getScripts:function(){return this._get("scripts");},
getTerritories:function(){return this._get("territories");},
getMonths:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(g(s),"months","format",w);},
getMonthsStandAlone:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(g(s),"months","stand-alone",w);},
getDays:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide"||w=="short","sWidth must be narrow, abbreviate, wide or short");return this._get(g(s),"days","format",w);},
getDaysStandAlone:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide"||w=="short","sWidth must be narrow, abbreviated, wide or short");return this._get(g(s),"days","stand-alone",w);},
getQuarters:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(g(s),"quarters","format",w);},
getQuartersStandAlone:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(g(s),"quarters","stand-alone",w);},
getDayPeriods:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(g(s),"dayPeriods","format",w);},
getDayPeriodsStandAlone:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(g(s),"dayPeriods","stand-alone",w);},
getDatePattern:function(s,i){a(s=="short"||s=="medium"||s=="long"||s=="full","sStyle must be short, medium, long or full");return this._get(g(i),"dateFormats",s);},
getTimePattern:function(s,i){a(s=="short"||s=="medium"||s=="long"||s=="full","sStyle must be short, medium, long or full");return this._get(g(i),"timeFormats",s);},
getDateTimePattern:function(s,i){a(s=="short"||s=="medium"||s=="long"||s=="full","sStyle must be short, medium, long or full");return this._get(g(i),"dateTimeFormats",s);},
getCombinedDateTimePattern:function(D,t,s){a(D=="short"||D=="medium"||D=="long"||D=="full","sStyle must be short, medium, long or full");a(t=="short"||t=="medium"||t=="long"||t=="full","sStyle must be short, medium, long or full");var i=this.getDateTimePattern(D,s),j=this.getDatePattern(D,s),T=this.getTimePattern(t,s);return i.replace("{0}",T).replace("{1}",j);},
getCustomDateTimePattern:function(s,i){var A=this._get(g(i),"dateTimeFormats","availableFormats");return this._getFormatPattern(s,A,i);},
getIntervalPattern:function(i,s){var I=this._get(g(s),"dateTimeFormats","intervalFormats"),j,n,D,o,p;if(i){j=i.split("-");n=j[0];D=j[1];o=I[n];if(o){p=o[D];if(p){return p;}}}return I.intervalFormatFallback;},
getCombinedIntervalPattern:function(p,s){var i=this._get(g(s),"dateTimeFormats","intervalFormats"),F=i.intervalFormatFallback;return F.replace(/\{(0|1)\}/g,p);},
getCustomIntervalPattern:function(s,G,i){var A=this._get(g(i),"dateTimeFormats","intervalFormats");return this._getFormatPattern(s,A,i,G);},
_getFormatPattern:function(s,A,i,D){var p,P,I;if(!D){p=A[s];}else if(typeof D==="string"){if(D=="j"||D=="J"){D=this.getPreferredHourSymbol();}I=A[s];p=I&&I[D];}if(p){if(typeof p==="object"){P=Object.keys(p).map(function(K){return p[K];});}else{return p;}}if(!P){P=this._createFormatPattern(s,A,i,D);}if(P&&P.length===1){return P[0];}return P;},
_createFormatPattern:function(s,A,j,D){var t=this._parseSkeletonFormat(s),p,o=this._findBestMatch(t,s,A),T,n,S,G,P,q,r,u,v=/^([GyYqQMLwWEecdD]+)([hHkKjJmszZvVOXx]+)$/,w,i;if(D){if(typeof D==="string"){u=d[D]?d[D].group:"";if(u){w=m[u].index>t[t.length-1].index;}r=D;}else{w=true;if(t[0].symbol==="y"&&o&&o.pattern.G){S=d["G"];G=m[S.group];t.splice(0,0,{symbol:"G",group:S.group,match:S.match,index:G.index,field:G.field,length:1});}for(i=t.length-1;i>=0;i--){T=t[i];if(D[T.group]){w=false;break;}}for(i=0;i<t.length;i++){T=t[i];if(D[T.group]){r=T.symbol;break;}}if((r=="h"||r=="K")&&D.DayPeriod){r="a";}}if(w){return[this.getCustomDateTimePattern(s,j)];}if(o&&o.missingTokens.length===0){P=o.pattern[r];if(P&&o.distance>0){P=this._expandFields(P,o.patternTokens,t);}}if(!P){n=this._get(g(j),"dateTimeFormats","availableFormats");if(v.test(s)&&"ahHkKjJms".indexOf(r)>=0){P=this._getMixedFormatPattern(s,n,j,D);}else{q=this._getFormatPattern(s,n,j);P=this.getCombinedIntervalPattern(q,j);}}p=[P];}else if(!o){P=s;p=[P];}else{if(typeof o.pattern==="string"){p=[o.pattern];}else if(typeof o.pattern==="object"){p=[];for(var K in o.pattern){P=o.pattern[K];p.push(P);}}if(o.distance>0){if(o.missingTokens.length>0){if(v.test(s)){p=[this._getMixedFormatPattern(s,A,j)];}else{p=this._expandFields(p,o.patternTokens,t);p=this._appendItems(p,o.missingTokens,j);}}else{p=this._expandFields(p,o.patternTokens,t);}}}if(s.indexOf("J")>=0){p.forEach(function(P,I){p[I]=P.replace(/ ?[abB](?=([^']*'[^']*')*[^']*)$/g,"");});}return p;},
_parseSkeletonFormat:function(s){var t=[],T={index:-1},S,o,G;for(var i=0;i<s.length;i++){S=s.charAt(i);if(S=="j"||S=="J"){S=this.getPreferredHourSymbol();}if(S==T.symbol){T.length++;continue;}o=d[S];G=m[o.group];if(o.group=="Other"||G.diffOnly){throw new Error("Symbol '"+S+"' is not allowed in skeleton format '"+s+"'");}if(G.index<=T.index){throw new Error("Symbol '"+S+"' at wrong position or duplicate in skeleton format '"+s+"'");}T={symbol:S,group:o.group,match:o.match,index:G.index,field:G.field,length:1};t.push(T);}return t;},
_findBestMatch:function(t,s,A){var T,j,o,n,p,D,q,F,r,u,v={distance:10000,firstDiffPos:-1};for(var w in A){if(w==="intervalFormatFallback"||w.indexOf("B")>-1){continue;}T=this._parseSkeletonFormat(w);D=0;j=[];q=true;if(t.length<T.length){continue;}p=0;F=t.length;for(var i=0;i<t.length;i++){o=t[i];n=T[p];if(F===t.length){F=i;}if(n){r=d[o.symbol];u=d[n.symbol];if(o.symbol===n.symbol){if(o.length===n.length){if(F===i){F=t.length;}}else{if(o.length<r.numericCeiling?n.length<u.numericCeiling:n.length>=u.numericCeiling){D+=Math.abs(o.length-n.length);}else{D+=5;}}p++;continue;}else{if(o.match==n.match){D+=Math.abs(o.length-n.length)+10;p++;continue;}}}j.push(o);D+=50-i;}if(p<T.length){q=false;}if(q&&(D<v.distance||(D===v.distance&&F>v.firstDiffPos))){v.distance=D;v.firstDiffPos=F;v.missingTokens=j;v.pattern=A[w];v.patternTokens=T;}}if(v.pattern){return v;}},
_expandFields:function(p,P,t){var s=(typeof p==="string");var n;if(s){n=[p];}else{n=p;}var r=n.map(function(o){var G={},q={},R="",Q=false,i=0,S,u,v,N,w,x,y,z;t.forEach(function(T){G[T.group]=T;});P.forEach(function(T){q[T.group]=T;});while(i<o.length){z=o.charAt(i);if(Q){R+=z;if(z=="'"){Q=false;}}else{y=d[z];if(y&&G[y.group]&&q[y.group]){w=G[y.group];x=q[y.group];S=w.length;v=x.length;u=1;while(o.charAt(i+1)==z){i++;u++;}if(S===v||((S<y.numericCeiling)?(u>=y.numericCeiling):(u<y.numericCeiling))){N=u;}else{N=Math.max(u,S);}for(var j=0;j<N;j++){R+=z;}}else{R+=z;if(z=="'"){Q=true;}}}i++;}return R;});return s?r[0]:r;},
_appendItems:function(p,j,s){var A=this._get(g(s),"dateTimeFormats","appendItems");p.forEach(function(P,I){var D,n,o;j.forEach(function(t){n=A[t.group];D="'"+this.getDisplayName(t.field)+"'";o="";for(var i=0;i<t.length;i++){o+=t.symbol;}p[I]=n.replace(/\{0\}/,P).replace(/\{1\}/,o).replace(/\{2\}/,D);}.bind(this));}.bind(this));return p;},
_getMixedFormatPattern:function(s,A,i,D){var r=/^([GyYqQMLwWEecdD]+)([hHkKjJmszZvVOXx]+)$/,j=/MMMM|LLLL/,n=/MMM|LLL/,o=/E|e|c/,R,p,t,S,q,T,u,v;R=r.exec(s);p=R[1];t=R[2];q=this._getFormatPattern(p,A,i);if(D){T=this.getCustomIntervalPattern(t,D,i);}else{T=this._getFormatPattern(t,A,i);}if(j.test(p)){S=o.test(p)?"full":"long";}else if(n.test(p)){S="medium";}else{S="short";}u=this.getDateTimePattern(S,i);v=u.replace(/\{1\}/,q).replace(/\{0\}/,T);return v;},
getNumberSymbol:function(t){a(t=="decimal"||t=="group"||t=="plusSign"||t=="minusSign"||t=="percentSign","sType must be decimal, group, plusSign, minusSign or percentSign");return this._get("symbols-latn-"+t);},
getLenientNumberSymbols:function(t){a(t=="plusSign"||t=="minusSign","sType must be plusSign or minusSign");return this._get("lenient-scope-number")[t];},
getDecimalPattern:function(){return this._get("decimalFormat").standard;},
getCurrencyPattern:function(s){return this._get("currencyFormat")[s]||this._get("currencyFormat").standard;},
getCurrencySpacing:function(p){return this._get("currencyFormat","currencySpacing",p==="after"?"afterCurrency":"beforeCurrency");},
getPercentPattern:function(){return this._get("percentFormat").standard;},
getMiscPattern:function(n){a(n=="approximately"||n=="atLeast"||n=="atMost"||n=="range","sName must be approximately, atLeast, atMost or range");return this._get("miscPattern")[n];},
getMinimalDaysInFirstWeek:function(){return this._get("weekData-minDays");},
getFirstDayOfWeek:function(){return this._get("weekData-firstDay");},
getWeekendStart:function(){return this._get("weekData-weekendStart");},
getWeekendEnd:function(){return this._get("weekData-weekendEnd");},
getCustomCurrencyCodes:function(){var i=this._get("currency")||{},j={};Object.keys(i).forEach(function(s){j[s]=s;});return j;},
getCurrencyDigits:function(s){var i=this._get("currency");if(i){if(i[s]&&i[s].hasOwnProperty("digits")){return i[s].digits;}else if(i["DEFAULT"]&&i["DEFAULT"].hasOwnProperty("digits")){return i["DEFAULT"].digits;}}var D=this._get("currencyDigits",s);if(D==null){D=this._get("currencyDigits","DEFAULT");if(D==null){D=2;}}return D;},
getCurrencySymbol:function(s){var o=this.getCurrencySymbols();return(o&&o[s])||s;},
getCurrencyCodeBySymbol:function(s){var o=this._get("currencySymbols"),i;for(i in o){if(o[i]===s){return i;}}return s;},
getCurrencySymbols:function(){var i=this._get("currency"),j={},I;for(var s in i){I=i[s].isoCode;if(i[s].symbol){j[s]=i[s].symbol;}else if(I){j[s]=this._get("currencySymbols")[I];}}return Object.assign({},this._get("currencySymbols"),j);},
getUnitDisplayName:function(u){var U=this.getUnitFormat(u);return(U&&U["displayName"])||"";},
getRelativePatterns:function(s,S){if(S===undefined){S="wide";}a(S==="wide"||S==="short"||S==="narrow","sStyle is only allowed to be set with 'wide', 'short' or 'narrow'");var p=[],P=this.getPluralCategories(),o,t,v,i;if(!s){s=["year","month","week","day","hour","minute","second"];}s.forEach(function(j){o=this._get("dateFields",j+"-"+S);for(var E in o){if(E.indexOf("relative-type-")===0){v=parseInt(E.substr(14));p.push({scale:j,value:v,pattern:o[E]});}else if(E.indexOf("relativeTime-type-")==0){t=o[E];i=E.substr(18)==="past"?-1:1;P.forEach(function(K){p.push({scale:j,sign:i,pattern:t["relativeTimePattern-count-"+K]});});}}}.bind(this));return p;},
getRelativePattern:function(s,D,F,S){var p,t,K,P;if(typeof F==="string"){S=F;F=undefined;}if(F===undefined){F=D>0;}if(S===undefined){S="wide";}a(S==="wide"||S==="short"||S==="narrow","sStyle is only allowed to be set with 'wide', 'short' or 'narrow'");K=s+"-"+S;if(D===0||D===-2||D===2){p=this._get("dateFields",K,"relative-type-"+D);}if(!p){t=this._get("dateFields",K,"relativeTime-type-"+(F?"future":"past"));P=this.getPluralCategory(Math.abs(D).toString());p=t["relativeTimePattern-count-"+P];}return p;},
getRelativeSecond:function(D,s){return this.getRelativePattern("second",D,s);},
getRelativeMinute:function(D,s){if(D==0){return null;}return this.getRelativePattern("minute",D,s);},
getRelativeHour:function(D,s){if(D==0){return null;}return this.getRelativePattern("hour",D,s);},
getRelativeDay:function(D,s){return this.getRelativePattern("day",D,s);},
getRelativeWeek:function(D,s){return this.getRelativePattern("week",D,s);},
getRelativeMonth:function(D,s){return this.getRelativePattern("month",D,s);},
getDisplayName:function(t,s){a(t=="second"||t=="minute"||t=="hour"||t=="zone"||t=="day"||t=="weekday"||t=="week"||t=="month"||t=="quarter"||t=="year"||t=="era","sType must be second, minute, hour, zone, day, weekday, week, month, quarter, year, era");if(s===undefined){s="wide";}a(s==="wide"||s==="short"||s==="narrow","sStyle is only allowed to be set with 'wide', 'short' or 'narrow'");var S=["era","weekday","zone"],K=S.indexOf(t)===-1?t+"-"+s:t;return this._get("dateFields",K,"displayName");},
getRelativeYear:function(D,s){return this.getRelativePattern("year",D,s);},
getDecimalFormat:function(s,n,p){var F;var o;switch(s){case"long":o=this._get("decimalFormat-long");break;default:o=this._get("decimalFormat-short");break;}if(o){var N=n+"-"+p;F=o[N];if(!F){N=n+"-other";F=o[N];}}return F;},
getCurrencyFormat:function(s,n,p){var F;var o=this._get("currencyFormat-"+s);if(!o){if(s==="sap-short"){throw new Error("Failed to get CLDR data for property \"currencyFormat-sap-short\"");}o=this._get("currencyFormat-short");}if(o){var N=n+"-"+p;F=o[N];if(!F){N=n+"-other";F=o[N];}}return F;},
getListFormat:function(t,s){var F=this._get("listPattern-"+(t||"standard")+"-"+(s||"wide"));if(F){return F;}return{};},
getResolvedUnitFormat:function(u){u=this.getUnitFromMapping(u)||u;return this.getUnitFormat(u);},
getUnitFormat:function(u){return this._get("units","short",u);},
getUnitFormats:function(){return this._getMerged("units","short");},
getUnitFromMapping:function(s){return this._get("unitMappings",s);},
getEras:function(w,s){a(w=="wide"||w=="abbreviated"||w=="narrow","sWidth must be wide, abbreviate or narrow");var E=this._get(g(s),"era-"+w),j=[];for(var i in E){j[parseInt(i)]=E[i];}return j;},
getEraDates:function(s){var E=this._get("eras-"+s.toLowerCase()),j=[];for(var i in E){j[parseInt(i)]=E[i];}return j;},
getCalendarWeek:function(s,w){a(s=="wide"||s=="narrow","sStyle must be wide or narrow");var o=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core",this.oLocale.toString()),K="date.week.calendarweek."+s;return o.getText(K,w);},
firstDayStartsFirstWeek:function(){return this._get("weekData-algorithm")==="FIRSTDAY_STARTS_FIRSTWEEK";},
getPreferredCalendarType:function(){var s=this._get("calendarPreference"),j=s?s.split(" "):[],n,t,i;for(i=0;i<j.length;i++){n=j[i].split("-")[0];for(t in C){if(n===t.toLowerCase()){return t;}}}return C.Gregorian;},
getPreferredHourSymbol:function(){return this._get("timeData","_preferred");},
getPluralCategories:function(){var p=this._get("plurals"),i=Object.keys(p);i.push("other");return i;},
getPluralCategory:function(n){var p=this._get("plurals");if(typeof n==="number"){n=n.toString();}if(!this._pluralTest){this._pluralTest={};}for(var s in p){var t=this._pluralTest[s];if(!t){t=this._parsePluralRule(p[s]);this._pluralTest[s]=t;}if(t(n)){return s;}}return"other";},
_parsePluralRule:function(r){var O="or",j="and",n="%",p="=",q="!=",s="n",t="i",u="f",v="t",w="v",x="w",R="..",S=",";var i=0,T;T=r.split(" ");function y(o){if(T[i]===o){i++;return true;}return false;}function z(){var o=T[i];i++;return o;}function A(){var J,I;J=D();if(y(O)){I=A();return function(o){return J(o)||I(o);};}return J;}function D(){var J,K;J=E();if(y(j)){K=D();return function(o){return J(o)&&K(o);};}return J;}function E(){var J,K,N;J=F();if(y(p)){N=true;}else if(y(q)){N=false;}else{throw new Error("Expected '=' or '!='");}K=H();if(N){return function(o){return K(o).indexOf(J(o))>=0;};}else{return function(o){return K(o).indexOf(J(o))===-1;};}}function F(){var J;J=G();if(y(n)){var K=parseInt(z());return function(o){return J(o)%K;};}return J;}function G(){if(y(s)){return function(o){return o.n;};}else if(y(t)){return function(o){return o.i;};}else if(y(u)){return function(o){return o.f;};}else if(y(v)){return function(o){return o.t;};}else if(y(w)){return function(o){return o.v;};}else if(y(x)){return function(o){return o.w;};}else{throw new Error("Unknown operand: "+z());}}function H(){var V=[],J=z(),P=J.split(S),K,N,Q;P.forEach(function(o){K=o.split(R);if(K.length===1){V.push(parseInt(o));}else{N=parseInt(K[0]);Q=parseInt(K[1]);for(var i=N;i<=Q;i++){V.push(i);}}});return function(o){return V;};}var I=A();if(i!=T.length){throw new Error("Not completely parsed");}return function(V){var J=V.indexOf("."),K,N,P,o;if(J===-1){K=V;N="";P="";}else{K=V.substr(0,J);N=V.substr(J+1);P=N.replace(/0+$/,'');}o={n:parseFloat(V),i:parseInt(K),v:N.length,w:P.length,f:parseInt(N),t:parseInt(P)};return I(o);};}
});
var m={"Era":{field:"era",index:0},"Year":{field:"year",index:1},"Quarter":{field:"quarter",index:2},"Month":{field:"month",index:3},"Week":{field:"week",index:4},"Day-Of-Week":{field:"weekday",index:5},"Day":{field:"day",index:6},"DayPeriod":{field:"hour",index:7,diffOnly:true},"Hour":{field:"hour",index:8},"Minute":{field:"minute",index:9},"Second":{field:"second",index:10},"Timezone":{field:"zone",index:11}};var d={"G":{group:"Era",match:"Era",numericCeiling:1},"y":{group:"Year",match:"Year",numericCeiling:100},"Y":{group:"Year",match:"Year",numericCeiling:100},"Q":{group:"Quarter",match:"Quarter",numericCeiling:3},"q":{group:"Quarter",match:"Quarter",numericCeiling:3},"M":{group:"Month",match:"Month",numericCeiling:3},"L":{group:"Month",match:"Month",numericCeiling:3},"w":{group:"Week",match:"Week",numericCeiling:100},"W":{group:"Week",match:"Week",numericCeiling:100},"d":{group:"Day",match:"Day",numericCeiling:100},"D":{group:"Day",match:"Day",numericCeiling:100},"E":{group:"Day-Of-Week",match:"Day-Of-Week",numericCeiling:1},"e":{group:"Day-Of-Week",match:"Day-Of-Week",numericCeiling:3},"c":{group:"Day-Of-Week",match:"Day-Of-Week",numericCeiling:2},"h":{group:"Hour",match:"Hour12",numericCeiling:100},"H":{group:"Hour",match:"Hour24",numericCeiling:100},"k":{group:"Hour",match:"Hour24",numericCeiling:100},"K":{group:"Hour",match:"Hour12",numericCeiling:100},"m":{group:"Minute",match:"Minute",numericCeiling:100},"s":{group:"Second",match:"Second",numericCeiling:100},"z":{group:"Timezone",match:"Timezone",numericCeiling:1},"Z":{group:"Timezone",match:"Timezone",numericCeiling:1},"O":{group:"Timezone",match:"Timezone",numericCeiling:1},"v":{group:"Timezone",match:"Timezone",numericCeiling:1},"V":{group:"Timezone",match:"Timezone",numericCeiling:1},"X":{group:"Timezone",match:"Timezone",numericCeiling:1},"x":{group:"Timezone",match:"Timezone",numericCeiling:1},"S":{group:"Other",numericCeiling:100},"u":{group:"Other",numericCeiling:100},"U":{group:"Other",numericCeiling:1},"r":{group:"Other",numericCeiling:100},"F":{group:"Other",numericCeiling:100},"g":{group:"Other",numericCeiling:100},"a":{group:"DayPeriod",numericCeiling:1},"b":{group:"Other",numericCeiling:1},"B":{group:"Other",numericCeiling:1},"A":{group:"Other",numericCeiling:100}};var M={"iw":"he","ji":"yi"};var f=(function(){var j=L._cldrLocales,r={},i;if(j){for(i=0;i<j.length;i++){r[j[i]]=true;}}return r;}());var l={};
function g(s){if(!s){s=sap.ui.getCore().getConfiguration().getCalendarType();}return"ca-"+s.toLowerCase();}
function h(o){var s=o.getLanguage()||"",S=o.getScript()||"",r=o.getRegion()||"",D;function i(n,p){var q,v,t;if(!p){return;}for(q in p){if(p.hasOwnProperty(q)){v=n[q];t=p[q];if(v===undefined){n[q]=t;}else if(v===null){delete n[q];}else if(typeof v==='object'&&typeof t==='object'){i(v,t);}}}}function j(I){if(!l[I]&&(!f||f[I]===true)){var n=l[I]=b.loadResource("sap/ui/core/cldr/"+I+".json",{dataType:"json",failOnError:false});if(n&&n.__fallbackLocale){i(n,j(n.__fallbackLocale));delete n.__fallbackLocale;}}return l[I];}s=(s&&M[s])||s;if(s==="no"){s="nb";}if(s==="zh"&&!r){if(S==="Hans"){r="CN";}else if(S==="Hant"){r="TW";}}if(s==="sh"||(s==="sr"&&S==="Latn")){s="sr_Latn";}var I=s+"_"+r;if(s&&r){D=j(I);}if(!D&&s){D=j(s);}l[I]=D||j("en");return l[I];}
var k=c.extend("sap.ui.core.CustomLocaleData",{
constructor:function(o){c.apply(this,arguments);this.mCustomData=sap.ui.getCore().getConfiguration().getFormatSettings().getCustomLocaleData();},
_get:function(){var A=Array.prototype.slice.call(arguments),s,K;if(A[0].indexOf("ca-")==0){s=A[0];if(s==g()){A=A.slice(1);}}K=A.join("-");var v=this.mCustomData[K];if(v==null){v=this._getDeep(this.mCustomData,arguments);if(v==null){v=this._getDeep(this.mData,arguments);}}return v;},
_getMerged:function(){var D=this._getDeep(this.mData,arguments);var i=this._getDeep(this.mCustomData,arguments);return e({},D,i);}
});
c.getInstance=function(o){return o.hasPrivateUseSubtag("sapufmt")?new k(o):new c(o);};
return c;});
sap.ui.predefine('sap/ui/core/Message',['./Element','./library',"sap/base/Log"],function(E,l,L){"use strict";var M=l.MessageType;
var a=E.extend("sap.ui.core.Message",{metadata:{library:"sap.ui.core",properties:{text:{type:"string",group:"Misc",defaultValue:null},timestamp:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},level:{type:"sap.ui.core.MessageType",group:"Misc",defaultValue:M.None},readOnly:{type:"boolean",group:"Misc",defaultValue:false}}}});
a.prototype.getDefaultIcon=function(s){var m=sap.ui.require.toUrl("sap/ui/core/themes/"+sap.ui.getCore().getConfiguration().getTheme());var i=m+"/img/message/";if(s&&s=="32x32"){i+="32x32/";}else{i+="16x16/";}var u="";switch(this.getProperty("level")){case M.Error:u=i+"Message_Icon_Error.png";break;case M.Information:u=i+"Message_Icon_Information.png";break;case M.Warning:u=i+"Message_Icon_Warning.png";break;case M.Success:u=i+"Message_Icon_Success.png";break;case M.None:default:u=this.getProperty("icon");break;}return u;};
a.prototype.compareByType=function(o){return a.compareByType(this,o);};
a.compareByType=function(m,o){if(!m&&!o){return 0;}if(m&&!o){return 1;}if(!m&&o){return-1;}var s=m.getLevel();var b=o.getLevel();if(s===b){return 0;}switch(s){case M.Error:return 1;case M.Warning:return b===M.Error?-1:1;case M.Success:return b===M.Error||b===M.Warning?-1:1;case M.Information:return b===M.None?1:-1;case M.None:return-1;default:L.error("Comparison error",this);return 0;}};
return a;});
sap.ui.predefine('sap/ui/core/Placeholder',['sap/ui/base/Object','sap/base/util/Deferred','sap/base/util/LoaderExtensions','sap/ui/core/BlockLayerUtils'],function(B,D,L,a){"use strict";var p=[];
var P=B.extend("sap.ui.core.Placeholder",{
constructor:function(m){B.call(this);if(!m.html){throw new Error("An HTML page defining the placeholder's content must be given!");}this.bShow=false;this.placeholderHTML=m.html;},
show:function(c,b){this.bShow=true;return this._load().then(function(s){if(s&&this.bShow&&!c.getDomRef().contains(this.placeholder)){if(this.blockState){a.unblock(this.blockState);}this.blockState=a.block(c,c.getId()+"--placeholder",b);var d=this.blockState.$blockLayer[0];d.className+=" sapUiPlaceholder";d.insertAdjacentHTML("beforeend",s);this.placeholder=d;}return s;}.bind(this));},
hide:function(){this.bShow=false;if(this.placeholder&&this.blockState){a.unblock(this.blockState);this.placeholder=undefined;this.blockState=undefined;}if(this.pLoaded){this.pLoaded.resolve();}},
_load:function(){if(!this.pLoaded){this.pLoaded=new D();if(this.placeholderHTML){L.loadResource(this.placeholderHTML,{async:true,dataType:"html"}).then(function(s){this.placeholderContent=s;this.pLoaded.resolve(s);}.bind(this));}else{this.pLoaded.reject();}}return this.pLoaded.promise;}
});
P.registerProvider=function(f){p.push(f);};
P.hasProviders=function(){return p.length>0;};
P.getPlaceholderFromProviders=function(c){var o;if(c){p.some(function(f){o=f(c);return!!o;});}return o;};
return P;});
sap.ui.predefine('sap/ui/core/Popup',['sap/ui/Device','sap/ui/base/ManagedObject','sap/ui/base/Object','sap/ui/base/ObjectPool','./Control','./IntervalTrigger','./RenderManager','./Element','./ResizeHandler','./library',"sap/base/assert","sap/base/Log","sap/base/util/Version","sap/base/util/uid","sap/base/util/extend","sap/base/util/deepExtend","sap/ui/dom/containsOrEquals","sap/ui/thirdparty/jquery","sap/ui/events/F6Navigation","sap/ui/events/isMouseEventDelayed","sap/ui/base/EventProvider","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Focusable","sap/ui/dom/jquery/rect"],function(D,M,B,O,C,I,R,E,a,b,c,L,V,u,d,f,g,q,F,h,k){"use strict";var m=b.CSSSize;var n=b.OpenState;var s;var G;var r;var o="sapUiPopupResize";if(window.ResizeObserver){r=new window.ResizeObserver(function(e){w(q("#sap-ui-blocklayer-popup"),e[0].target);});}else{r={observe:function(e){var i=e.dataset[o];if(!i){i=a.register(e,function(j){w(q("#sap-ui-blocklayer-popup"),j.target);});e.dataset[o]=i;}},unobserve:function(e){var i=e.dataset[o];if(i){a.deregister(i);delete e.dataset[o];}}};}
function p(){if(s){return s;}var S,i;try{S=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(S);}catch(e){L.error(e);throw new Error("Popup cannot be opened because static UIArea cannot be determined.");}i=new C();s.addDependent(i);s=i.getUIArea();i.destroy();return s;}
function t(W){var e;if(typeof W==="string"){e=document.querySelector(W);}else if(W instanceof E){e=W.getDomRef();}else{e=W;}return e||window;}
function v($){var e=["left","top","width","height","position"];if($[0]){e.forEach(function(i){$[0].style.removeProperty(i);});}}
function w($,W){var e=W.getBoundingClientRect();$.css({width:e.width,height:e.height,display:"block",position:"absolute"}).position({my:"left top",at:"left top",of:W});}
var P=M.extend("sap.ui.core.Popup",{
constructor:function(e,i,S,j){c(arguments.length==0||(e&&typeof e==="object"),"oContent must be an object or there may be no arguments at all");c((i===undefined||i===true||i===false),"bModal must be true, false, or undefined");c((S===undefined||S===true||S===false),"bShadow must be true, false, or undefined");c((j===undefined||j===true||j===false),"bAutoClose must be true, false, or undefined");M.apply(this);this._popupUID=u();this.bOpen=false;this.eOpenState=n.CLOSED;this._mEvents={};this._mEvents["sap.ui.core.Popup.addFocusableContent-"+this._popupUID]=this._addFocusableArea;this._mEvents["sap.ui.core.Popup.removeFocusableContent-"+this._popupUID]=this._removeFocusableArea;this._mEvents["sap.ui.core.Popup.closePopup-"+this._popupUID]=this._closePopup;this._mEvents["sap.ui.core.Popup.onFocusEvent-"+this._popupUID]=this.onFocusEvent;this._mEvents["sap.ui.core.Popup.increaseZIndex-"+this._popupUID]=this._increaseMyZIndex;this._mEvents["sap.ui.core.Popup.contains-"+this._popupUID]=this._containsEventBusWrapper;if(e){this.setContent(e);}this._oDefaultPosition={my:P.Dock.CenterCenter,at:P.Dock.CenterCenter,of:document,offset:"0 0",collision:"flip"};this._oPosition=Object.assign({},this._oDefaultPosition);this._bModal=!!i;this._oPreviousFocus=null;this._sInitialFocusId=null;this._bShadow=typeof(S)==="boolean"?S:true;this._bAutoClose=!!j;this._animations={open:null,close:null};this._durations={open:"fast",close:"fast"};this._iZIndex=-1;this.setNavigationMode();if(this.touchEnabled){this._fAutoCloseHandler=function(l){if(l.isMarked("delayedMouseEvent")||l.isMarked("cancelAutoClose")){return;}if(this.eOpenState===n.CLOSING||this.eOpenState===n.CLOSED){return;}if(!this._contains(l.target)){this.close();}};}this._F6NavigationHandler=function(l){var J={},K=this._sF6NavMode,N;if(K=="DOCK"){if(this._bModal){K="NONE";}else if(this._oLastPosition&&this._oLastPosition.of){N=this._getOfDom(this._oLastPosition.of);if(!N||N===document){N=null;K="NONE";}}}switch(K){case"SCOPE":J.scope=this._$()[0];break;case"DOCK":J.target=N;var $=q(N).parents("[data-sap-ui-popup]");J.scope=$.length?$[0]:null;break;default:J.skip=true;}F.handleF6GroupNavigation(l,J);};},
metadata:{library:"sap.ui.core",publicMethods:["open","close","setContent","getContent","setPosition","setShadow","setModal","getModal","setAutoClose","setAutoCloseAreas","setExtraContent","isOpen","getAutoClose","getOpenState","setAnimations","setDurations","attachOpened","attachClosed","detachOpened","detachClosed"],associations:{"childPopups":{type:"sap.ui.core.Popup",multiple:true,visibility:"hidden"}},events:{"opened":{},"closed":{}}}
});
P.prototype.getChildPopups=function(){return this.getAssociation("childPopups",[]);};
P.prototype.addChildPopup=function(e){return this.addAssociation("childPopups",e);};
P.prototype.removeChildPopup=function(e){return this.removeAssociation("childPopups",e);};
P.blStack=[];P.Dock={BeginTop:"begin top",BeginCenter:"begin center",BeginBottom:"begin bottom",LeftTop:"left top",LeftCenter:"left center",LeftBottom:"left bottom",CenterTop:"center top",CenterCenter:"center center",CenterBottom:"center bottom",RightTop:"right top",RightCenter:"right center",RightBottom:"right bottom",EndTop:"end top",EndCenter:"end center",EndBottom:"end bottom"};P.prototype.touchEnabled=D.support.touch&&(D.browser.safari||!D.system.combi);P.prototype.preventBrowserFocus=D.support.touch&&!D.system.combi;
B.extend("sap.ui.core.Popup.Layer",{constructor:function(){var e=this.getDomString();this._$Ref=q(e).appendTo(sap.ui.getCore().getStaticAreaRef());}});
P.Layer.prototype.init=function(e,Z){this._$Ref.css({"visibility":"visible","z-index":Z});this.update(e,Z);this._$Ref.insertAfter(e).show();};
P.Layer.prototype.update=function(e,Z){if(e.length){var i=e.rect();this._$Ref.css({"left":i.left,"top":i.top});if(e.css("right")!="auto"&&e.css("right")!="inherit"){this._$Ref.css({"right":e.css("right"),"width":"auto"});}else{this._$Ref.css({"width":i.width,"right":"auto"});}if(e.css("bottom")!="auto"&&e.css("bottom")!="inherit"){this._$Ref.css({"bottom":e.css("bottom"),"height":"auto"});}else{this._$Ref.css({"height":i.height,"bottom":"auto"});}if(typeof(Z)==="number"){this._$Ref.css("z-index",Z);}}};
P.Layer.prototype.reset=function(){if(this._$Ref.length){this._$Ref[0].style.display="none";this._$Ref[0].style.visibility="hidden";this._$Ref.appendTo(sap.ui.getCore().getStaticAreaRef());}};
P.Layer.prototype.getDomString=function(){L.error("sap.ui.core.Popup.Layer: getDomString function must be overwritten!");return"";};
P.Layer.extend("sap.ui.core.Popup.ShieldLayer",{constructor:function(){P.Layer.apply(this);}});
P.ShieldLayer.prototype.getDomString=function(){return"<div class=\"sapUiPopupShield\" id=\"sap-ui-shieldlayer-"+u()+"\"></div>";};
P.prototype.oShieldLayerPool=new O(P.ShieldLayer);(function(){var l=0;var i=Math.pow(2,32)-1;
P.setInitialZIndex=function(e){if(e>=i){throw new Error("Z-index can't be higher than Number.MAX_SAFE_INTEGER");}l=Math.max(e,this.getLastZIndex());};
P.getLastZIndex=function(){return l;};
P.prototype.getLastZIndex=function(){return P.getLastZIndex();};
P.getNextZIndex=function(){l+=10;if(l>=i){throw new Error("Z-index can't be higher than Number.MAX_SAFE_INTEGER");}return l;};
P.prototype.getNextZIndex=function(){return P.getNextZIndex();};
}());var x=function(e,i){if((!e&&i)||(e&&!i)){return false;}if(!e&&!i){return true;}var j=3;var l=Math.abs(e.left-i.left);var T=Math.abs(e.top-i.top);var W=Math.abs(e.width-i.width);var J=Math.abs(e.height-i.height);if(l>j||T>j||W>j||J>j){return false;}return true;};
P.prototype.open=function(i,e,j,l,J,K,N,Q){c(this.oContent,"Popup content must have been set by now");if(this.eOpenState!=n.CLOSED){return;}if(typeof(i)=="string"){Q=N;N=K;K=J;J=l;l=j;j=e;e=i;i=-1;}if(typeof N==="boolean"||typeof N==="function"||N===P.CLOSE_ON_SCROLL){Q=N;N=undefined;}if(i===undefined){i=-1;}c(i===-1||(typeof i==="number"&&i%1==0),"iDuration must be an integer (or omitted)");c(e===undefined||typeof e==="string","my must be a string or empty");c(j===undefined||typeof j==="string","at must be a string or empty");c(!l||typeof l==="object"||typeof l==="function","of must be empty or an object");c(!J||typeof J==="string","offset must be empty or a string");c(!K||typeof K==="string","collision must be empty or a string");c(!N||N===window||typeof N==="string"||N instanceof E||N instanceof HTMLElement,"within must be either empty, or the global window object, or a string, or a sap.ui.core.Element, or a DOM element");c(!Q||typeof Q==="boolean"||typeof Q==="function"||Q===P.CLOSE_ON_SCROLL,"followOf must be either empty or a boolean");this.eOpenState=n.OPENING;var s=p(),U;this._bContentAddedToStatic=false;this._bUIAreaPatched=false;if(this.oContent instanceof C){if(!this.oContent.getParent()){s.addContent(this.oContent,true);this._bContentAddedToStatic=true;}else if(!this.oContent.getUIArea()){this.oContent.getUIArea=function(){return s;};this._bUIAreaPatched=true;}U=this.oContent.getUIArea();if(P._bEnableUIAreaCheck&&U.getRootNode().id!==s.getRootNode().id){L.warning("The Popup content is NOT connected with the static-UIArea and may not work properly!");}}this._oPreviousFocus=P.getCurrentFocusInfo();if(this.isInPopup(l)||this.isInPopup(this._oPosition.of)){var S=this.getParentPopupId(l)||this.getParentPopupId(this._oPosition.of);var T="";var W=this.getContent();if(W instanceof E){T=W.getId();}else if(typeof W==="object"){T=W.id;}this.addChildToPopup(S,T);this.addChildToPopup(S,this._popupUID);}var $=this._$(true);var X="fast";if((i===0)||(i>0)){X=i;}else if((this._durations.open===0)||(this._durations.open>0)){X=this._durations.open;}var Y;if(e||j||l||J||K||N){Y=this._createPosition(e,j,l,J,K,N);this._oPosition=Y;}else{Y=this._oPosition;if(!this._bOwnWithin&&G){this._oPosition.within=G;}}if(!Y.of){Y.of=this._oPosition.of||document;}this._iZIndex=this._iZIndex===this.getLastZIndex()?this._iZIndex:this.getNextZIndex();var Z=sap.ui.getCore().getStaticAreaRef();$.css({"position":"absolute","visibility":"hidden"});if(!($[0].parentNode==Z)){$.appendTo(Z);}$.css("z-index",this._iZIndex);L.debug("position popup content "+$.attr("id")+" at "+JSON.stringify(Y.at));this._applyPosition(Y);if(Q!==undefined){this.setFollowOf(Q);}$.toggleClass("sapUiShd",this._bShadow);var a1=$[0];if(a1){a1.style.display="none";a1.style.visibility="visible";}var b1=X==0;this._duringOpen(!b1);if(b1){this._opened();}else if(this._animations.open){this._animations.open.call(null,$,X,this._opened.bind(this));}else{$.fadeIn(X,this._opened.bind(this));}};
P.prototype._getDomRefToFocus=function(){var $=this._$(false,true),e,i;if(this._shouldGetFocusAfterOpen()){if(this._sInitialFocusId){i=sap.ui.getCore().byId(this._sInitialFocusId);if(i){e=i.getFocusDomRef();}e=e||window.document.getElementById(this._sInitialFocusId);}e=e||$.firstFocusableDomRef();}return e;};
P.prototype._opened=function(){if(this.eOpenState!==n.OPENING){return;}this.bOpen=true;var $=this._$(false,true);if($[0]&&$[0].style){$[0].style.display="block";}if(this._shouldGetFocusAfterOpen()){var e=this._getDomRefToFocus();if(e){e.focus();}var i=this._getOfDom(this._oLastPosition.of);var j=q(i).rect();if(this._oLastOfRect&&j&&!x(this._oLastOfRect,j)){this._applyPosition(this._oLastPosition);}}this.eOpenState=n.OPEN;if(this.getFollowOf()){P.DockTrigger.addListener(P.checkDocking,this);}this.fireOpened();};
P.prototype._duringOpen=function(e){var $=this._$(false,true),S=sap.ui.getCore().getStaticAreaRef(),i=document.getElementById(S.id+"-firstfe");P._clearSelection();this._setupUserSelection();if(h()){if(this._oTopShieldLayer){clearTimeout(this._iTopShieldRemoveTimer);this._iTopShieldRemoveTimer=null;}else{this._oTopShieldLayer=this.oShieldLayerPool.borrowObject($,this._iZIndex+1);}this._iTopShieldRemoveTimer=setTimeout(function(){this.oShieldLayerPool.returnObject(this._oTopShieldLayer);this._oTopShieldLayer=null;this._iTopShieldRemoveTimer=null;}.bind(this),500);}if(this._bModal){this._showBlockLayer();}if(!this.touchEnabled&&e&&i&&this._shouldGetFocusAfterOpen()&&!this.isInPopup(document.activeElement)&&this._getDomRefToFocus()!==document.activeElement){i.focus({preventScroll:true});}if(this.oContent instanceof E){this.oContent.addDelegate(this);}this.bOpen=true;this._activateFocusHandle();this._$(false,true).on("keydown",q.proxy(this._F6NavigationHandler,this));};
P.prototype._shouldGetFocusAfterOpen=function(){return this._bModal||this._bAutoClose||this._sInitialFocusId;};
P.prototype._contains=function(e){var i=this._$().get(0);if(!i){return false;}var j=g(i,e);var l;if(!j){l=this.getChildPopups();j=l.some(function(J){var K=(J?window.document.getElementById(J):null);var j=g(K,e);if(!j){var N="sap.ui.core.Popup.contains-"+J;var Q={domRef:e};sap.ui.getCore().getEventBus().publish("sap.ui",N,Q);j=Q.contains;}return j;});}if(!j){A.forEach(function(S){j=j||q(e).closest(S).length>0;});}return j;};
P.prototype._containsEventBusWrapper=function(e,i,j){j.contains=this._contains(j.domRef);};
P.prototype.onFocusEvent=function(e){var i=q.event.fix(e);if(arguments.length>1&&arguments[1]==="sap.ui.core.Popup.onFocusEvent-"+this._popupUID){i=q.event.fix(arguments[2]);}var j=(i.type=="focus"||i.type=="activate")?"focus":"blur";var l=false;if(j=="focus"){var J=this._$().get(0);if(J){l=this._contains(i.target);L.debug("focus event on "+i.target.id+", contains: "+l);if(this._bModal&&!l){var T=P.blStack.length>0&&P.blStack[P.blStack.length-1].popup===this;if(T){if(D.system.desktop||q(i.target).is(":input")){if(this.oLastBlurredElement){setTimeout(function(){if(this.oLastBlurredElement){this.oLastBlurredElement.focus();}}.bind(this),0);}else{J.focus();}}}}else if(this._bAutoClose&&l&&this._sTimeoutId){clearTimeout(this._sTimeoutId);this._sTimeoutId=null;}}}else if(j=="blur"){L.debug("blur event on "+i.target.id);if(this._bModal){this.oLastBlurredElement=i.target;}else if(this._bAutoClose){if(!this.touchEnabled&&!this._sTimeoutId){if(i.target===document.activeElement){return;}var K=typeof this._durations.close==="string"?0:this._durations.close;this._sTimeoutId=setTimeout(function(){this.close(K,"autocloseBlur");var N=this._oLastPosition&&this._oLastPosition.of;if(N){var Q=this.getParentPopupId(N);if(Q){var S="sap.ui.core.Popup.onFocusEvent-"+Q;sap.ui.getCore().getEventBus().publish("sap.ui",S,i);}}}.bind(this),K);}}}};
P.prototype.setInitialFocusId=function(i){c(!i||typeof i==="string","sId must be a string or empty");this._sInitialFocusId=i;};
P.prototype.close=function(i){if(P._autoCloseDebug){return;}if(this._sTimeoutId){clearTimeout(this._sTimeoutId);this._sTimeoutId=null;}c(i===undefined||(typeof i==="number"&&(i%1==0)),"iDuration must be empty or an integer");if(this.eOpenState==n.CLOSED||this.eOpenState==n.CLOSING){return;}var e="fast";if((i===0)||(i>0)){e=i;}else if((this._durations.close===0)||(this._durations.close>0)){e=this._durations.close;}this.eOpenState=n.CLOSING;if(this.getFollowOf()){P.DockTrigger.removeListener(P.checkDocking,this);}if(this.oContent){if(this._bContentAddedToStatic){sap.ui.getCore().getEventBus().publish("sap.ui","__beforePopupClose",{domNode:this._$().get(0)});var S=sap.ui.getCore().getStaticAreaRef();S=sap.ui.getCore().getUIArea(S);S.removeContent(S.indexOfContent(this.oContent),true);}else if(this._bUIAreaPatched){delete this.oContent.getUIArea;}}this._bContentAddedToStatic=false;this._bUIAreaPatched=false;this._sTimeoutId=null;this._deactivateFocusHandle();this._$(false,true).off("keydown",this._F6NavigationHandler);if(this.oContent instanceof E){this.oContent.removeDelegate(this);}var $=this._$();if(this._bEventBusEventsRegistered){this._unregisterEventBusEvents();}if(h()){if(this._oBottomShieldLayer){clearTimeout(this._iBottomShieldRemoveTimer);this._iBottomShieldRemoveTimer=null;}else{this._oBottomShieldLayer=this.oShieldLayerPool.borrowObject($,this._iZIndex-3);}this._iBottomShieldRemoveTimer=setTimeout(function(){this.oShieldLayerPool.returnObject(this._oBottomShieldLayer);this._oBottomShieldLayer=null;this._iBottomShieldRemoveTimer=null;}.bind(this),500);}if(this.isInPopup(this._oLastPosition.of)){var j=this.getParentPopupId(this._oLastPosition.of);var l="";var J=this.getContent();if(J instanceof E){l=J.getId();}else if(typeof J==="object"){l=J.id;}this.removeChildFromPopup(j,l);this.removeChildFromPopup(j,this._popupUID);}if(this._bModal&&this.preventBrowserFocus){$.one("mousedown",function(K){K.preventDefault();});}this._duringClose();if(e==0){this._closed();}else if(this._animations.close){this._animations.close.call(null,$,e,this._closed.bind(this));}else{$.fadeOut(e,this._closed.bind(this));}};
P.prototype._closed=function(){var $=this._$(false,true);if(this._bModal){this._hideBlockLayer();}P._clearSelection();this._restoreUserSelection();if($.length){var e=$.get(0);if(e){e.style.display="none";e.style.visibility="hidden";e.style.left="0px";e.style.top="0px";e.style.right="";}$=this._$(false,true);e=$.length?$[0]:null;if(e){e.style.display="none";e.style.visibility="hidden";e.style.left="0px";e.style.top="0px";e.style.right="";}}if(this._bModal){P.applyFocusInfo(this._oPreviousFocus);this._oPreviousFocus=null;this.oLastBlurredElement=null;}this.bOpen=false;this.eOpenState=n.CLOSED;var i=this.getChildPopups();for(var j=0,l=i.length;j<l;j++){this.closePopup(i[j]);}this.fireClosed();};
P.prototype._duringClose=function(){if(this._resizeListenerId){a.deregister(this._resizeListenerId);this._resizeListenerId=null;}};
P.getCurrentFocusInfo=function(){var e=null;var i=sap.ui.getCore().getCurrentFocusedControlId();if(i){var j=sap.ui.getCore().byId(i);e={'sFocusId':i,'oFocusInfo':j?j.getFocusInfo():{}};}else{var l=document.activeElement;e={'sFocusId':l.id,'oFocusedElement':l,'oFocusInfo':{}};}if(e){e.popup=this;}return e;};
P.applyFocusInfo=function(e){var i={preventScroll:true};if(e){var j=sap.ui.getCore().byId(e.sFocusId);if(j){j.applyFocusInfo(Object.assign(i,e.oFocusInfo));}else{var l=((e.sFocusId?window.document.getElementById(e.sFocusId):null))||e.oFocusedElement;if(l){l.focus(i);}}}};
P.prototype.setContent=function(e){c(typeof e==="object","oContent must be an object");this.oContent=e;return this;};
P.prototype.getContent=function(){return this.oContent;};
P.prototype.setPosition=function(e,i,j,l,J,K){c(typeof e==="string","my must be a string");c(typeof i==="string"||(typeof i==="object"&&(typeof i.left==="number")&&(typeof i.top==="number")),"my must be a string or an object with 'left' and 'top' properties");c(!j||typeof j==="object"||typeof j==="function","of must be empty or an object");c(!l||typeof l==="string","offset must be empty or a string");c(!J||typeof J==="string","collision must be empty or a string");c(!K||K===window||typeof K==="string"||K instanceof E||K instanceof HTMLElement,"within must be either empty, or the global window object, or a string, or a sap.ui.core.Element, or a DOM element");this._oPosition=this._createPosition(e,i,j,l,J,K);if(this.eOpenState!=n.CLOSED){this._applyPosition(this._oPosition);}return this;};
P.prototype._createPosition=function(e,i,j,l,J,K){var N=false;if(e&&(e.indexOf("+")>=0||e.indexOf("-")>=0)){N=true;if(l&&l!="0 0"){L.warning("offset used in my and in offset, the offset value will be ignored","sap.ui.core.Popup","setPosition");}l=null;}var Q=d({},this._oDefaultPosition,{my:e||this._oDefaultPosition.my,at:i||this._oDefaultPosition.at,of:j,offset:l,collision:J});if(K||G){Q.within=K||G;}this._bOwnWithin=!!K;if(!q.ui.version){if(P._bNewOffset==null){P._bNewOffset=true;var $=q(document.createElement("div"));$.position({of:window,using:function(X,Y){P._bNewOffset=(Y!==undefined);}});}}var S=[];var T=[];if(P._bNewOffset||V(q.ui.version).compareTo("1.8.23")>0){if(l&&l!="0 0"){S=Q.my.split(" ");T=l.split(" ");var U=[parseInt(T[0])<0?"":"+",parseInt(T[1])<0?"":"+"];Q.my=S[0]+U[0]+T[0]+" "+S[1]+U[1]+T[1];Q.offset=null;}}else if(N){S=Q.my.split(" ");T=["",""];var W=S[0].indexOf("+");if(W<0){W=S[0].indexOf("-");}if(W>=0){T[0]=S[0].slice(W);S[0]=S[0].slice(0,W);}W=S[1].indexOf("+");if(W<0){W=S[1].indexOf("-");}if(W>=0){T[1]=S[1].slice(W);S[1]=S[1].slice(0,W);}Q.my=S[0]+" "+S[1];Q.offset=T[0]+" "+T[1];}return Q;};
P.prototype._getPositionOffset=function(){var e=[];if(this._oPosition.my&&(this._oPosition.my.indexOf("+")>=0||this._oPosition.my.indexOf("-")>=0)){var i=this._oPosition.my.split(" ");var j=i[0].indexOf("+");if(j<0){j=i[0].indexOf("-");}if(j>=0){e[0]=i[0].slice(j);}j=i[1].indexOf("+");if(j<0){j=i[1].indexOf("-");}if(j>=0){e[1]=i[1].slice(j);}}else if(this._oPosition.offset){e=this._oPosition.offset.split(" ");}return e;};
P.prototype._applyPosition=function(e){var i=sap.ui.getCore().getConfiguration().getRTL();var $=this._$();if($.length){var j=e.at;var l=$.get(0);if(typeof(j)==="string"){l.style.display="block";l.style.left="";l.style.right="";$.position(this._resolveReference(this._convertPositionRTL(e,i)));this._fixPositioning(e,i);}else if(m.isValid(j.left)&&m.isValid(j.top)){$.css({"left":j.left,"top":j.top});}else if(m.isValid(j.right)&&m.isValid(j.top)){$.css({"right":j.right,"top":j.top});}else if(typeof(j.left)==="number"&&typeof(j.top)==="number"){var J=$[0];if(J&&J.style.right){var K=$[0].getBoundingClientRect().width;$.css({"right":(document.documentElement.clientWidth-(j.left+K))+"px","top":j.top+"px"});}else{$.css({"left":j.left+"px","top":j.top+"px"});}}this._oLastPosition=e;this._oLastOfRect=this._calcOfRect(e.of);}};
P.prototype._calcOfRect=function(e){var i=this._getOfDom(e);if(i){return q(i).rect();}return null;};
P.prototype._getOfDom=function(e){if(e instanceof q.Event){return null;}var $;if(typeof(e)==="string"){$=q(document.getElementById(e));}else if(e instanceof q){$=e;}else{$=q(e instanceof E?e.getDomRef():e);}return $[0];};
P.prototype._convertPositionRTL=function(e,i){var j=Object.assign({},e);if(i){var N=false;if(j.my&&(j.my.indexOf("+")>=0||j.my.indexOf("-")>=0)){N=true;}if((j.offset||N)&&((j.my.indexOf("begin")>-1)||(j.my.indexOf("end")>-1))&&((j.at.indexOf("begin")>-1)||(j.at.indexOf("end")>-1))){if(N){var l=j.my.split(" ");if(l.length==2){j.my="";if(l[0]){if(l[0].indexOf("begin")>-1||l[0].indexOf("end")>-1){if(l[0].indexOf("+")>-1){l[0]=l[0].replace("+","-");}else if(l[0].indexOf("-")>-1){l[0]=l[0].replace("-","+");}}j.my=l[0];}if(l[1]){if(l[1].indexOf("begin")>-1||l[1].indexOf("end")>-1){if(l[1].indexOf("+")>-1){l[1]=l[1].replace("+","-");}else if(l[1].indexOf("-")>-1){l[1]=l[1].replace("-","+");}}if(l[0]){j.my=j.my+" ";}j.my=j.my+l[1];}}}else{j.offset=this._mirrorOffset(j.offset);}}j.my=j.my.replace("begin","right").replace("end","left");j.at=j.at.replace("begin","right").replace("end","left");}else{j.my=j.my.replace("end","right").replace("begin","left");j.at=j.at.replace("end","right").replace("begin","left");}return j;};
P.prototype._mirrorOffset=function(e){var i=String(e).trim().split(/\s/);var j=parseInt(i[0]);return(-j)+" "+i[i.length-1];};
P.prototype._fixPositioning=function(e,i){var j=e.my;if(typeof(j)==="string"){if(P._isPositionFixingNeeded(j,i)){var $=this._$();var l=q(window).width()-$[0].getBoundingClientRect().width-$.offset().left;$.css({"right":l+"px","left":""});}}};
P._isPositionFixingNeeded=function(e,i){return i&&((e.indexOf("right")>-1)||(e.indexOf("begin")>-1)||(e.indexOf("center")>-1))||!i&&((e.indexOf("right")>-1)||(e.indexOf("end")>-1));};
P.prototype._resolveReference=function(e){var i,j=["of","within"];j.forEach(function(l){if(e[l]instanceof E){i=i||{};i[l]=e[l].getDomRef();}});return i?Object.assign({},e,i):e;};
P.prototype.setShadow=function(S){c(typeof S==="boolean","bShowShadow must be boolean");this._bShadow=S;if(this.eOpenState!=n.CLOSED){this._$().toggleClass("sapUiShd",S);}return this;};
P.prototype.setModal=function(e,i){c(typeof e==="boolean","bModal must be boolean");c(!i||typeof i==="string","sModalCSSClass must be empty or a string");var j=this._bModal;this._bModal=e;this._sModalCSSClass=i;if(this.isOpen()){if(j!==e){P._clearSelection();if(e){this._setupUserSelection();this._showBlockLayer();}else{this._hideBlockLayer();this._restoreUserSelection();}if(this.touchEnabled&&this._bAutoClose){if(!e){q(document).on("touchstart mousedown",q.proxy(this._fAutoCloseHandler,this));}else{q(document).off("touchstart mousedown",this._fAutoCloseHandler);}}}}return this;};
P.prototype.getModal=function(){return this._bModal;};
P.prototype.setNavigationMode=function(e){if(e!="NONE"&&e!="DOCK"&&e!="SCOPE"){this._sF6NavMode="NONE";}this._sF6NavMode=e;};
P.prototype.setAutoClose=function(e){c(typeof e==="boolean","bAutoClose must be boolean");if(this.touchEnabled&&this.isOpen()&&this._bAutoClose!==e){if(!this._bModal){if(e){q(document).on("touchstart mousedown",q.proxy(this._fAutoCloseHandler,this));}else{q(document).off("touchstart mousedown",this._fAutoCloseHandler);}}}this._bAutoClose=e;return this;};
P.prototype.setExtraContent=function(e){c(Array.isArray(e),"Extra popup content must be an array which contains either sap.ui.core.Element, DOM Element or an ID");if(!this._aExtraContent){this._aExtraContent=[];}var j=function(S){return{onBeforeRendering:function(){var T=S.getDomRef();if(T&&this.isOpen()){T.removeEventListener("blur",this.fnEventHandler,true);}},onAfterRendering:function(){var T=S.getDomRef();if(T&&this.isOpen()){T.addEventListener("blur",this.fnEventHandler,true);}}};};var J,K,N,Q;for(var i=0,l=e.length;i<l;i++){K=e[i];if(K instanceof E){J=K.getId();}else if(typeof K==="object"){J=K.id;}else if(typeof K==="string"){J=K;}if(this.getChildPopups().indexOf(J)===-1){this.addChildPopup(J);Q={id:J};if(K instanceof E){N=j(K);K.addEventDelegate(N,this);Q.delegate=N;}this._aExtraContent.push(Q);}}return this;};
P.prototype.setAutoCloseAreas=P.prototype.setExtraContent;
P.prototype.setAnimations=function(e,i){c(e===null||typeof e==="function","fnOpen must be a function");c(i===null||typeof i==="function","fnClose must be a function");if(e&&(typeof(e)=="function")){this._animations.open=e;}if(i&&(typeof(i)=="function")){this._animations.close=i;}return this;};
P.prototype.setDurations=function(i,e){c(i===null||(typeof i==="number"&&(i%1==0)),"iOpenDuration must be null or an integer");c(!e||(typeof e==="number"&&(e%1==0)),"iOpenDuration must be undefined or an integer");if((i>0)||(i===0)){this._durations.open=i;}if((e>0)||(e===0)){this._durations.close=e;}return this;};
P.CLOSE_ON_SCROLL="close_Popup_if_of_is_moved";
P.prototype._fnCloseOnScroll=function(e){this.close();};
P.prototype.setFollowOf=function(e){P.DockTrigger.removeListener(P.checkDocking,this);var U=false;this._bFollowOf=true;this._followOfHandler=null;if(typeof(e)==="function"){this._followOfHandler=e;U=true;}else if(typeof(e)==="boolean"){U=e;}else if(e===P.CLOSE_ON_SCROLL){this._followOfHandler=this._fnCloseOnScroll;U=true;}else{this._bFollowOf=false;if(e!==null){L.error("Trying to set an invalid type to 'followOf: "+e);}}if(U&&this._oLastPosition){this._oLastOfRect=this._calcOfRect(this._oLastPosition.of);}if(this._bFollowOf&&this.getOpenState()===n.OPEN){P.DockTrigger.addListener(P.checkDocking,this);}};
P.prototype.getAutoClose=function(){return this._bAutoClose;};
P.prototype.getFollowOf=function(){if(this._bFollowOf){return typeof(this._followOfHandler)==="function"?this._followOfHandler:true;}return false;};
P.prototype.isOpen=function(){return this.bOpen;};
P.prototype.getOpenState=function(){return this.eOpenState;};
P.prototype.destroy=function(){if(this._resizeListenerId){a.deregister(this._resizeListenerId);this._resizeListenerId=null;}this.close(0);this.oContent=null;if(this._bFollowOf){this.setFollowOf(null);}if(this._bEventBusEventsRegistered){this._unregisterEventBusEvents();}if(this._iTopShieldRemoveTimer){clearTimeout(this._iTopShieldRemoveTimer);this.oShieldLayerPool.returnObject(this._oTopShieldLayer);this._oTopShieldLayer=null;this._iTopShieldRemoveTimer=null;}if(this._iBottomShieldRemoveTimer){clearTimeout(this._iBottomShieldRemoveTimer);this.oShieldLayerPool.returnObject(this._oBottomShieldLayer);this._oBottomShieldLayer=null;this._iBottomShieldRemoveTimer=null;}if(this._aExtraContent){var e;this._aExtraContent.forEach(function(i){if(i.delegate){e=q(document.getElementById(i.id)).control(0);if(e){e.removeEventDelegate(i.delegate);}}});}M.prototype.destroy.apply(this,arguments);};
P.prototype.exit=function(){delete this._mEvents;};
P.prototype._addFocusEventListeners=function(){if(!this.fnEventHandler){this.fnEventHandler=q.proxy(this.onFocusEvent,this);}var $=this._$();var e=this.getChildPopups();var j={};var i=0,l=0;if($.length){document.addEventListener("focus",this.fnEventHandler,true);$.get(0).addEventListener("blur",this.fnEventHandler,true);for(i=0,l=e.length;i<l;i++){j=(e[i]?window.document.getElementById(e[i]):null);if(j){j.addEventListener("blur",this.fnEventHandler,true);}}}};
P.prototype._removeFocusEventListeners=function(){var $=this._$(false,true);if(!$.length){return;}var e=this.getChildPopups();var j={};var i=0,l=0;document.removeEventListener("focus",this.fnEventHandler,true);$.get(0).removeEventListener("blur",this.fnEventHandler,true);for(i=0,l=e.length;i<l;i++){j=(e[i]?window.document.getElementById(e[i]):null);if(j){j.removeEventListener("blur",this.fnEventHandler,true);}this.closePopup(e[i]);}this.fnEventHandler=null;};
P.prototype._activateFocusHandle=function(){if(this._bModal||this._bAutoClose){this._addFocusEventListeners();}if(this.touchEnabled&&!this._bModal&&this._bAutoClose){q(document).on("touchstart mousedown",q.proxy(this._fAutoCloseHandler,this));}};
P.prototype._deactivateFocusHandle=function(){if(this.fnEventHandler){this._removeFocusEventListeners();}if(this.touchEnabled&&!this._bModal&&this._bAutoClose){q(document).off("touchstart mousedown",this._fAutoCloseHandler);}};
P.prototype._registerEventBusEvents=function(){var e=this;q.each(e._mEvents,function(i,l){sap.ui.getCore().getEventBus().subscribe("sap.ui",i,l,e);});this._bEventBusEventsRegistered=true;};
P.prototype._unregisterEventBusEvents=function(){var e=this;q.each(e._mEvents,function(i,l){sap.ui.getCore().getEventBus().unsubscribe("sap.ui",i,l,e);});delete this._bEventBusEventsRegistered;};
P.prototype._addFocusableArea=function(e,i,j){if(this.getChildPopups().indexOf(j.id)===-1){this.addChildPopup(j.id);}};
P.prototype._removeFocusableArea=function(e,i,j){this.removeChildPopup(j.id);};
P.prototype._closePopup=function(e,i,j){this.close(typeof this._durations.close==="string"?0:this._durations.close);};
P.prototype._setIdentity=function($){if(typeof $==="object"){$.attr("data-sap-ui-popup",this._popupUID);}else{L.warning("Incorrect DomRef-type for 'setIdentity': "+$,this);return;}if(!this._bEventBusEventsRegistered){this._registerEventBusEvents();}};
P.prototype._$=function(e,i){var $;if(this.oContent instanceof C){$=this.oContent.$();if(e||($.length===0&&!i)){L.info("Rendering of popup content: "+this.oContent.getId());if($.length>0){R.preserveContent($[0],true,false);}sap.ui.getCore().createRenderManager().render(this.oContent,sap.ui.getCore().getStaticAreaRef());$=this.oContent.$();}}else if(this.oContent instanceof E){$=this.oContent.$();}else{$=q(this.oContent);}this._setIdentity($);return $;};
function _(e){if(P._blockLayerStateProvider){P._blockLayerStateProvider.fireEvent("blockLayerStateChange",e);}}
P.attachBlockLayerStateChange=function(e,i,l){if(!P._blockLayerStateProvider){P._blockLayerStateProvider=new k();}P._blockLayerStateProvider.attachEvent("blockLayerStateChange",e,i,l);};
P.detachBlockLayerStateChange=function(e,l){if(P._blockLayerStateProvider){P._blockLayerStateProvider.detachEvent("blockLayerStateChange",e,l);}};
function y($,W){if(W===window){v($);document.documentElement.classList.add("sapUiBLyBack");}else{w($,W);W.classList.add("sapUiBLyBack");r.observe(W);}}
function z(W){if(W===window){document.documentElement.classList.remove("sapUiBLyBack");}else{W.classList.remove("sapUiBLyBack");r.unobserve(W);}}
P.prototype._showBlockLayer=function(){var $=q("#sap-ui-blocklayer-popup"),e="sapUiBLy"+(this._sModalCSSClass?" "+this._sModalCSSClass:""),W;if($.length===0){$=q('<div id="sap-ui-blocklayer-popup" tabindex="0" class="'+e+'"></div>');$.appendTo(sap.ui.getCore().getStaticAreaRef());}else{$.removeClass().addClass(e);}var l=P.blStack[P.blStack.length-1];if(l){W=t(l.popup._oLastPosition.within);z(W);}W=t(this._oLastPosition.within);y($,W);P.blStack.push({zIndex:this._iZIndex-2,popup:this});$.css({"z-index":this._iZIndex-2,"visibility":"visible"}).show();if(P.blStack.length===1){_({visible:true,zIndex:P.blStack[0].zIndex});}};
P.prototype._hideBlockLayer=function(){var $=q("#sap-ui-blocklayer-popup"),e=$[0],i=this,l,W;W=t(this._oLastPosition.within);z(W);if($.length){if(P.blStack.length>1){P.blStack=P.blStack.filter(function(j){return j.popup!==i;});l=P.blStack[P.blStack.length-1];e.style.zIndex=l.zIndex;e.style.visibility="visible";e.style.display="block";W=t(l.popup._oLastPosition.within);y($,W);}else{l=P.blStack.pop();e.style.visibility="hidden";e.style.display="none";_({visible:false,zIndex:l.zIndex});}}};
P.prototype._isFocusInsidePopup=function(){var e=this._$(false).get(0);if(e&&g(e,document.activeElement)){return true;}return false;};
P.DockTrigger=I;
P.checkDocking=function(){if(this.getOpenState()===n.OPEN){var e=this._getOfDom(this._oLastPosition.of),i;if(e){if((e===window)||(e===window.document)||g(document.documentElement,e)){i=q(e).rect();}else if(e.id){var N=window.document.getElementById(e.id);var j=q(N).rect();if(j&&!x(i,j)){i=j;this._oLastPosition.of=N;}}}if(!i){this.close();return;}else if(i.left===0&&i.top===0&&i.height===0&&i.height===0&&this._oLastPosition.of.id){this._oLastPosition.of=window.document.getElementById(this._oLastPosition.of.id);e=this._getOfDom(this._oLastPosition.of);i=q(e).rect();if(!i){this.close();return;}}if(this._oLastOfRect){if(!x(this._oLastOfRect,i)){if(this._followOfHandler){var l=f({},this._oLastPosition),J=f({},this._oLastOfRect);this._followOfHandler({lastPosition:l,lastOfRect:J,currentOfRect:i});}else{this._applyPosition(this._oLastPosition);}}}}};
P.prototype.ontouchstart=function(e){this.onmousedown(e,true);this._bMousedownCalled=true;};
P.prototype.onmousedown=function(e,S){if(this._bMousedownCalled&&!S){this._bMousedownCalled=false;return;}if(this._iZIndex===this.getLastZIndex()||this.getModal()){return;}this._increaseMyZIndex("","mousedown",e);};
P.prototype._increaseMyZIndex=function(e,j,J){var K=this.getParentPopup(this._oLastPosition.of);if(J&&J.type==="mousedown"||J&&J.isFromParentPopup||K.length===0){this._iZIndex=this.getNextZIndex();var $=this._$(false,true);$.css("z-index",this._iZIndex);if(J&&!J.type||J&&J.type!="mousedown"||j==="mousedown"){var N=this.getChildPopups();for(var i=0,l=N.length;i<l;i++){this.increaseZIndex(N[i],true);}}}else if(K.length>0){var Q=q(K.get(0)).attr("data-sap-ui-popup");this.increaseZIndex(Q,false);}};
P.prototype.onAfterRendering=function(){var e=this.getContent();var $=e instanceof E?e.$():q(e);$.toggleClass("sapUiShd",this._bShadow);P._clearSelection();this._setupUserSelection();$.css("position","absolute");this._setIdentity($);var i=$[0];var l=i.style.left;var j=i.style.right;var J=i.style.top;var K=i.style.bottom;if(!(l&&l!="auto"||j&&j!="auto"||J&&J!="auto"||K&&K!="auto")){L.debug("reposition popup content "+$.attr("id")+" at "+JSON.stringify(this._oLastPosition.at));this._applyPosition(this._oLastPosition);}$.show().css({"visibility":"visible","z-index":this._iZIndex});if(this.isOpen()&&(this.getModal()||this.getAutoClose())){this._addFocusEventListeners();}this._$(false,true).on("keydown",q.proxy(this._F6NavigationHandler,this));};
P.prototype.onBeforeRendering=function(){if(this._resizeListenerId){a.deregister(this._resizeListenerId);this._resizeListenerId=null;}if(this.isOpen()&&(this.getModal()||this.getAutoClose())){this._removeFocusEventListeners();}this._$(false,true).off("keydown",this._F6NavigationHandler);};
P.prototype.isInPopup=function(e){var $=this.getParentPopup(e);return $&&$.length>0;};
P.prototype.getParentPopup=function(e){var T=e?e:this;var $=q(T instanceof E?T.getDomRef():T);return $.closest("[data-sap-ui-popup]");};
P.prototype.getParentPopupId=function(e){var $=this.getParentPopup(e);return $.attr("data-sap-ui-popup");};
P.prototype.addChildToPopup=function(e,i){var j="sap.ui.core.Popup.addFocusableContent-"+e;sap.ui.getCore().getEventBus().publish("sap.ui",j,{id:i});};
P.prototype.removeChildFromPopup=function(e,i){var j="sap.ui.core.Popup.removeFocusableContent-"+e;sap.ui.getCore().getEventBus().publish("sap.ui",j,{id:i});};
P.prototype.closePopup=function(e){var i="sap.ui.core.Popup.closePopup-"+e;sap.ui.getCore().getEventBus().publish("sap.ui",i);};
P.prototype.increaseZIndex=function(e,i){var j="sap.ui.core.Popup.increaseZIndex-"+e;sap.ui.getCore().getEventBus().publish("sap.ui",j,{isFromParentPopup:i?i:false});};
P.prototype.focusTabChain=function(e){var S=e.event.target,N=e.that.getMetadata().getName(),i;if((!e.$FocusablesContent||!e.$FocusablesFooter)||(!e.$FocusablesContent.length&&!e.$FocusablesFooter.length)){return;}if(S.id===e.firstFocusable){L.debug("First dummy focus element was focused","",N);if(e.$FocusablesFooter.length>0){L.debug("Last footer element will be focused","",N);i=e.$FocusablesFooter[e.$FocusablesFooter.length-1];}else{L.debug("Last content element will be focused","",N);i=e.$FocusablesContent[e.$FocusablesContent.length-1];}}else if(S.id===e.lastFocusable){L.debug("Last dummy focus element was focues","",N);if(e.$FocusablesContent.length>0){L.debug("First content element will be focused","",N);i=e.$FocusablesContent[0];}else{L.debug("First footer element will be focused","",N);i=e.$FocusablesFooter[0];}}if(i){setTimeout(function(){var j=sap.ui.getCore().byId(i.id);if(j instanceof C){L.debug("Focus will be handled by "+j.getMetadata().getName(),"",N);}else{L.debug("oFocusDomRef will be focused","",N);}if(j){j.focus();}else if(i){i.focus();}return j?j.getId():i.id;},0);}};
P.prototype._setupUserSelection=function(){var $=this._$(false,true);P._markAsUserSelectable($,this._bModal||P.blStack.length>0);if(this._bModal){if(P.blStack.length>0){var l=P.blStack[P.blStack.length-1];var e=function(i){return i.popup.getId();};if(P.blStack.map(e).indexOf(this.getId())===-1){P._markAsNotUserSelectable(l.popup._$(false,true),true);}else if(l.popup.getId()!==this.getId()){P._markAsNotUserSelectable($,true);}}else{P._markAsNotUserSelectable(q("html"),true);P._markExternalContentAsUserSelectable(true);}}};
P.prototype._restoreUserSelection=function(){var $=this._$(false,true);P._markAsNotUserSelectable($,false);if(P.blStack.length>0){P._markAsUserSelectable(P.blStack[P.blStack.length-1].popup._$(false,true),true);}else{P._markAsUserSelectable(q("html"),false);P._markExternalContentAsNotUserSelectable(false);}};
P._clearSelection=function(){var S=document.getSelection();if(!S.isCollapsed){S.removeAllRanges();}};
P._markAsUserSelectable=function($,e){$.removeClass("sapUiNotUserSelectable");if(e){$.addClass("sapUiUserSelectable");}};
P._markAsNotUserSelectable=function($,e){$.removeClass("sapUiUserSelectable");if(e){$.addClass("sapUiNotUserSelectable");}};
var A=new Set(),H="[data-sap-ui-integration-popup-content]";A.add(H);
P.addExternalContent=function(S,e){if(!Array.isArray(S)){S=[S];}S.forEach(Set.prototype.add.bind(A));if(e){P.markExternalContentAsSelectable();}};
P.removeExternalContent=function(S,e){if(!Array.isArray(S)){S=[S];}if(e){P.markExternalContentAsNotSelectable();}S.forEach(function(i){if(i!==H){A.delete(i);}});};
P.markExternalContentAsSelectable=function(){P._clearSelection();if(P.blStack.length>0){P._markExternalContentAsUserSelectable(true);}};
P.markExternalContentAsNotSelectable=function(){P._clearSelection();if(P.blStack.length>0){P._markExternalContentAsNotUserSelectable(false);}};
P._getExternalContent=function(){var e=[];if(A.size>0){A.forEach(function(S){var $=q(S);if($.length>0){e.push($);}});}return e;};
P._markExternalContentAsUserSelectable=function(e){var i=P._getExternalContent();i.forEach(function($){P._markAsUserSelectable($,e);});};
P._markExternalContentAsNotUserSelectable=function(e){var i=P._getExternalContent();i.forEach(function($){P._markAsNotUserSelectable($,e);});};
P.setWithinArea=function(e){G=e;};
P.getWithinArea=function(){return G;};
P.getWithinAreaDomRef=function(){return t(G);};
return P;});
sap.ui.predefine('sap/ui/core/ScrollBar',['sap/ui/Device','./Control','./library',"./ScrollBarRenderer","sap/ui/performance/trace/Interaction","sap/base/Log","sap/ui/dom/containsOrEquals","sap/ui/events/jquery/EventSimulation","sap/ui/thirdparty/jquery"],function(D,C,l,S,I,L,c,E,q){"use strict";var a=l.ScrollBarAction;
var b=C.extend("sap.ui.core.ScrollBar",{
metadata:{library:"sap.ui.core",properties:{vertical:{type:"boolean",group:"Behavior",defaultValue:true},scrollPosition:{type:"int",group:"Behavior",defaultValue:null},size:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},contentSize:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},steps:{type:"int",group:"Dimension",defaultValue:null}},events:{scroll:{parameters:{action:{type:"sap.ui.core.ScrollBarAction"},forward:{type:"boolean"},newScrollPos:{type:"int"},oldScrollPos:{type:"int"}}}}},
renderer:S
});
b.prototype.init=function(){this._$ScrollDomRef=null;this._iOldScrollPos=0;this._iOldStep=0;this._bScrollPosIsChecked=false;this._bRTL=sap.ui.getCore().getConfiguration().getRTL();this._bSuppressScroll=false;this._iMaxContentDivSize=1000000;if(E.touchEventMode==="ON"){sap.ui.requireSync("sap/ui/thirdparty/zyngascroll");this._iLastTouchScrollerPosition=null;this._iTouchStepTreshold=24;this._bSkipTouchHandling=false;this._oTouchScroller=new window.Scroller(q.proxy(this._handleTouchScroll,this),{bouncing:false});}};
b.prototype.onBeforeRendering=function(){this.$("sb").off("scroll",this.onscroll);};
b.prototype.onAfterRendering=function(){this._iSteps=this.getSteps();var s=this.getContentSize();this._bStepMode=!s;var i=this.getSize();if(i.endsWith("px")){i=i.substr(0,i.length-2);}else{i=this.getVertical()?this.$().height():this.$().width();}var d=null;var $=this.$("ffsize");if(D.browser.firefox){d=$.outerHeight();if(d===0){d=window.getComputedStyle(q("body").get(0))["font-size"];if(d.endsWith("px")){d=d.substr(0,d.length-2);}d=parseInt(d);}}$.remove();if(D.browser.webkit){if(!document.width){d=Math.round(40/(window.outerWidth/q(document).width()));}else{d=Math.round(40/(document.width/q(document).width()));}}if(this.getVertical()){if(D.browser.firefox){this._iFactor=d;}else if(D.browser.webkit){this._iFactor=d;}else{this._iFactor=Math.floor(i*0.125);}this._iFactorPage=D.browser.firefox?i-d:Math.floor(i*0.875);}else{if(D.browser.firefox){this._iFactor=10;this._iFactorPage=Math.floor(i*0.8);}else if(D.browser.webkit){this._iFactor=d;this._iFactorPage=Math.floor(i*0.875);}else{this._iFactor=7;this._iFactorPage=i-14;}}this._$ScrollDomRef=this.$("sb");if(this._bStepMode){if(this.getVertical()){var e=this._iSteps*this._iFactor;if(e>this._iMaxContentDivSize){this._iFactor=this._iFactor/(e/this._iMaxContentDivSize);}var f=this._$ScrollDomRef.height()+Math.ceil(this._iSteps*this._iFactor);this._$ScrollDomRef.find("div").height(f);}else{var f=this._$ScrollDomRef.width()+this._iSteps*this._iFactor;this._$ScrollDomRef.find("div").width(f);}}this.setCheckedScrollPosition(this.getScrollPosition()?this.getScrollPosition():0,true);this._$ScrollDomRef.on("scroll",q.proxy(this.onscroll,this));if(E.touchEventMode==="ON"){this._bSkipTouchHandling=true;var o={width:0,height:0};o[this.getVertical()?"height":"width"]=this._bStepMode?(this.getSteps()*this._iTouchStepTreshold):parseInt(this.getContentSize());this._oTouchScroller.setDimensions(0,0,o.width,o.height);var g=this._$ScrollDomRef.get(0);if(g){var r=g.getBoundingClientRect();this._oTouchScroller.setPosition(r.left+g.clientLeft,r.top+g.clientTop);this._bSkipTouchHandling=false;}}};
b.prototype.onmousewheel=function(e){if(this.$().is(":visible")){var o=e.originalEvent;var w=o.detail?o.detail:o.wheelDelta*(-1)/40;var f=w>0?true:false;if(c(this._$ScrollDomRef[0],e.target)){this._doScroll(a.MouseWheel,f);}else{this._bMouseWheel=true;var p=null;if(this._bStepMode){p=w+this._iOldStep;}else{p=w*this._iFactor+this._iOldScrollPos;}this.setCheckedScrollPosition(p,true);}e.preventDefault();e.stopPropagation();return false;}};
b.prototype.ontouchstart=function(e){var t=e.touches;var f=t[0];if(f&&f.target&&f.target.tagName.match(/input|textarea|select/i)){return;}if(this._oTouchScroller){this._oTouchScroller.doTouchStart(t,e.timeStamp);}if(t.length==1){e.preventDefault();}};
b.prototype.ontouchmove=function(e){if(this._oTouchScroller){this._oTouchScroller.doTouchMove(e.touches,e.timeStamp,e.scale);}};
b.prototype.ontouchend=function(e){if(this._oTouchScroller){this._oTouchScroller.doTouchEnd(e.timeStamp);}};
b.prototype.ontouchcancel=function(e){if(this._oTouchScroller){this._oTouchScroller.doTouchEnd(e.timeStamp);}};
b.prototype.onscroll=function(e){if(this._bSuppressScroll){this._bSuppressScroll=false;e.preventDefault();e.stopPropagation();return false;}var s=null;if(this._$ScrollDomRef){if(this.getVertical()){s=Math.round(this._$ScrollDomRef.scrollTop());}else{s=Math.round(this._$ScrollDomRef.scrollLeft());if(D.browser.firefox&&this._bRTL){s=Math.abs(s);}else if(D.browser.webkit&&this._bRTL){var o=this._$ScrollDomRef.get(0);s=o.scrollWidth-o.clientWidth-o.scrollLeft;}}}var d=s-this._iOldScrollPos;var f=d>0?true:false;if(d<0){d=d*(-1);}var g=a.Drag;if(d==this._iFactor){g=a.Step;}else if(d==this._iFactorPage){g=a.Page;}else if(this._bMouseWheel){g=a.MouseWheel;}if(this._bLargeDataScrolling&&g===a.Drag){this._eAction=g;this._bForward=f;}else{this._doScroll(g,f);}e.preventDefault();e.stopPropagation();return false;};
b.prototype._onScrollTimeout=function(){this._scrollTimeout=undefined;this._doScroll(this._eAction,this._bForward);this._eAction=undefined;this._bForward=undefined;this._bTouchScroll=undefined;};
b.prototype.onmouseup=function(){if(this._bLargeDataScrolling&&(this._eAction||this._bForward||this._bTouchScroll)){this._doScroll(this._eAction,this._bForward);this._eAction=undefined;this._bForward=undefined;this._bTouchScroll=undefined;}};
b.prototype.ontouchend=b.prototype.onmouseup;
b.prototype._handleTouchScroll=function(i,t,z){if(this._bSkipTouchHandling){return;}var v=this.getVertical()?t:i;var p;if(this._bStepMode){p=Math.max(Math.round(v/this._iTouchStepTreshold),0);}else{p=Math.round(v);}if(this._iLastTouchScrollerPosition!==p){this._iLastTouchScrollerPosition=p;this.setCheckedScrollPosition(p,true);if(this._bLargeDataScrolling){this._bTouchScroll=true;}else{this.fireScroll();}}};
b.prototype.unbind=function(o){if(o){this._$OwnerDomRef=q(o);if(this.getVertical()){this._$OwnerDomRef.off(D.browser.firefox?"DOMMouseScroll":"mousewheel",this.onmousewheel);}if(E.touchEventMode==="ON"){this._$OwnerDomRef.off(this._getTouchEventType("touchstart"),q.proxy(this.ontouchstart,this));this._$OwnerDomRef.off(this._getTouchEventType("touchmove"),q.proxy(this.ontouchmove,this));this._$OwnerDomRef.off(this._getTouchEventType("touchend"),q.proxy(this.ontouchend,this));this._$OwnerDomRef.off(this._getTouchEventType("touchcancel"),q.proxy(this.ontouchcancel,this));}}};
b.prototype.bind=function(o){if(o){this._$OwnerDomRef=q(o);if(this.getVertical()){this._$OwnerDomRef.on(D.browser.firefox?"DOMMouseScroll":"mousewheel",q.proxy(this.onmousewheel,this));}if(E.touchEventMode==="ON"){this._$OwnerDomRef.on(this._getTouchEventType("touchstart"),q.proxy(this.ontouchstart,this));this._$OwnerDomRef.on(this._getTouchEventType("touchmove"),q.proxy(this.ontouchmove,this));this._$OwnerDomRef.on(this._getTouchEventType("touchend"),q.proxy(this.ontouchend,this));this._$OwnerDomRef.on(this._getTouchEventType("touchcancel"),q.proxy(this.ontouchcancel,this));}}};
b.prototype._getTouchEventType=function(t){return E.touchEventMode==="SIM"?("sap"+t):t;};
b.prototype.pageUp=function(){this._doScroll(a.Page,false);};
b.prototype.pageDown=function(){this._doScroll(a.Page,true);};
b.prototype.setScrollPosition=function(s){if(this._$ScrollDomRef){this.setCheckedScrollPosition(s,true);}else{this.setProperty("scrollPosition",s);}return this;};
b.prototype.setCheckedScrollPosition=function(s,d){var i=Math.max(s,0);if(this._bStepMode===undefined){this._bStepMode=!this.getContentSize();}var e=i;if(this._bStepMode){i=Math.min(i,this.getSteps());e=i*this._iFactor;}i=Math.round(i);this._bSuppressScroll=!d;this.setProperty("scrollPosition",i,true);if(this.getVertical()){this._$ScrollDomRef.scrollTop(e);}else{if(D.browser.firefox&&this._bRTL){this._$ScrollDomRef.scrollLeft(-e);}else if(D.browser.webkit&&this._bRTL){var o=this._$ScrollDomRef.get(0);this._$ScrollDomRef.scrollLeft(o.scrollWidth-o.clientWidth-e);}else{this._$ScrollDomRef.scrollLeft(e);}}if(E.touchEventMode==="ON"){var v=i;if(this._bStepMode){v=Math.round(i*this._iTouchStepTreshold);}this._oTouchScroller.__scrollTop=this.getVertical()?v:0;this._oTouchScroller.__scrollLeft=this.getVertical()?0:v;}};
b.prototype.setContentSize=function(s){this.setProperty("contentSize",s,true);this._bStepMode=false;var $=this.$("sbcnt");if($){if(this.getVertical()){$.height(s);}else{$.width(s);}}return this;};
b.prototype._doScroll=function(A,f){var s=null;if(this._$ScrollDomRef){if(this.getVertical()){s=Math.round(this._$ScrollDomRef.scrollTop());}else{s=Math.round(this._$ScrollDomRef.scrollLeft());if(D.browser.firefox&&this._bRTL){s=Math.abs(s);}else if(D.browser.webkit&&this._bRTL){var o=this._$ScrollDomRef.get(0);s=o.scrollWidth-o.clientWidth-o.scrollLeft;}}}if(this._bStepMode){var i=Math.round(s/this._iFactor);var O=this._iOldStep;if(O!==i){this.setCheckedScrollPosition(i,false);L.debug("-----STEPMODE-----: New Step: "+i+" --- Old Step: "+O+" --- Scroll Pos in px: "+s+" --- Action: "+A+" --- Direction is forward: "+f);this.fireScroll({action:A,forward:f,newScrollPos:i,oldScrollPos:O});this._iOldStep=i;}}else{s=Math.round(s);this.setProperty("scrollPosition",s,true);L.debug("-----PIXELMODE-----: New ScrollPos: "+s+" --- Old ScrollPos: "+this._iOldScrollPos+" --- Action: "+A+" --- Direction is forward: "+f);this.fireScroll({action:A,forward:f,newScrollPos:s,oldScrollPos:this._iOldScrollPos});}this._bSuppressScroll=false;this._iOldScrollPos=s;this._bMouseWheel=false;I.notifyScrollEvent({type:A});};
b.prototype.onThemeChanged=function(){this.rerender();};
b.prototype.getNativeScrollPosition=function(){if(this._$ScrollDomRef){if(this.getVertical()){return Math.round(this._$ScrollDomRef.scrollTop());}else{return Math.round(this._$ScrollDomRef.scrollLeft());}}return 0;};
b.prototype.setNativeScrollPosition=function(n){var s=Math.round(n);if(this._$ScrollDomRef){if(this.getVertical()){this._$ScrollDomRef.scrollTop(s);}else{this._$ScrollDomRef.scrollLeft(s);}}};
return b;});
sap.ui.predefine('sap/ui/core/ScrollBarRenderer',['sap/ui/Device',"sap/ui/dom/getScrollbarSize"],function(D,g){"use strict";var S={apiVersion:2};
S.render=function(r,s){var R=sap.ui.getCore().getConfiguration().getRTL();r.openStart("div",s);r.class("sapUiScrollBar");var a;if(D.support.touch){a="sapUiScrollBarTouch";r.class(a);}var v=s.getVertical();var b=s.getSize();var c=s.getContentSize();var B=g(a);var w=B.width;var h=B.height;if(v){r.style("overflow","hidden");r.style("width",w+"px");r.style("height",b);r.openEnd();r.openStart("div",s.getId()+"-sb");r.style("width",(w*2)+"px");r.style("height","100%");r.style("overflow-y","scroll");r.style("overflow-x","hidden");if(R){r.style("margin-right","-"+w+"px");}else{r.style("margin-left","-"+w+"px");}r.openEnd();r.openStart("div",s.getId()+"-sbcnt");r.style("width",w+"px");r.style("height",c);r.openEnd();r.close("div");r.close("div");r.openStart("div");r.openEnd();r.openStart("span",s.getId()+"-ffsize");r.style("position","absolute");r.style("top","-9000px");r.style("left","-9000px");r.style("visibility","hidden");r.style("line-height","normal");r.openEnd();r.text("FF Size");r.close("span");r.close("div");}else{r.style("overflow","hidden");r.style("height",h+"px");r.style("width",b);r.openEnd();r.openStart("div",s.getId()+"-sb");r.style("height",(h*2)+"px");r.style("margin-top","-"+h+"px");r.style("overflow-x","scroll");r.style("overflow-y","hidden");r.openEnd();r.openStart("div",s.getId()+"-sbcnt");r.style("height",h+"px");r.style("width",c);r.openEnd();r.close("div");r.close("div");}r.close("div");};
return S;},true);
sap.ui.predefine('sap/ui/core/SeparatorItem',['./Item','./library'],function(I){"use strict";
var S=I.extend("sap.ui.core.SeparatorItem",{metadata:{library:"sap.ui.core"}});
return S;});
sap.ui.predefine('sap/ui/core/Shortcut',["sap/ui/core/util/ShortcutHelper",'sap/base/assert'],function(S,a){"use strict";var b={register:function(s,v,c){if(!s){throw new Error("Shortcut.register: oScopeControl must be given.");}if(typeof c!=="function"){throw new Error("Shortcut.register: a function fnCallback must be given.");}var n=S.getNormalizedShortcutSpec(v);S.validateKeyCombination(n);var e=S.findShortcut(s,n);if(e){throw new Error("Same shortcut is already registered on this element");}function w(){var f=document.activeElement,o=document.createElement("span"),g=sap.ui.getCore().getStaticAreaRef();o.setAttribute("tabindex",0);o.setAttribute("id","sap-ui-shortcut-focus");o.style.position="absolute";o.style.top="50%";o.style.bottom="50%";o.style.left="50%";o.style.right="50%";g.appendChild(o);o.focus();f.focus();g.removeChild(o);c.apply(null,arguments);}var d={};d["onkeydown"]=S.handleKeydown.bind(null,n,v,w);s.addEventDelegate(d);var D=s.data("sap.ui.core.Shortcut");if(!D){D=[];s.data("sap.ui.core.Shortcut",D);}D.push({shortcutSpec:n,platformIndependentShortcutString:S.getNormalizedShortcutString(n),delegate:d});},isRegistered:function(s,v){a(s,"Shortcut.isRegistered: oScopeControl must be given.");var n=S.getNormalizedShortcutSpec(v);return!!S.findShortcut(s,n);},unregister:function(s,v){a(s,"Shortcut.unregister: oScopeControl must be given.");var n=S.getNormalizedShortcutSpec(v);var o=S.findShortcut(s,n);if(o){s.removeEventDelegate(o.delegate);var d=s.data("sap.ui.core.Shortcut");var i=d.indexOf(o);d.splice(i,1);return true;}return false;}};return b;});
sap.ui.predefine('sap/ui/core/ShortcutHint',["sap/base/Log","sap/ui/core/Core","sap/ui/core/CommandExecution"],function(L,C,a){"use strict";var S=function(c,o){this.oControl=c;this.oConfig=o;};
S.prototype._getShortcutText=function(){var t;if(this.oConfig.commandName){t=this._getShortcutHintFromCommandExecution(this.oControl,this.oConfig.commandName);}else if(this.oConfig.message){t=this.oConfig.message;}else if(this.oConfig.messageBundleKey){t=this._getShortcutHintFromMessageBundle(this.oControl,this.oConfig.messageBundleKey);}return t;};
S.prototype._getShortcutHintFromCommandExecution=function(c,s){try{return a.find(c,s)._getCommandInfo().shortcut;}catch(e){L.error("Error on retrieving command shortcut. Command "+s+" was not found!");}};
S.prototype._getShortcutHintFromMessageBundle=function(c,m){var r=C.getLibraryResourceBundle(c.getMetadata().getLibraryName());return r.getText(m);};
return S;});
sap.ui.predefine('sap/ui/core/ShortcutHintsMixin',["sap/ui/base/EventProvider","./Element","./ShortcutHint","./Popup","./InvisibleText","sap/ui/dom/containsOrEquals","sap/ui/events/checkMouseEnterOrLeave","sap/ui/Device"],function(E,a,S,P,I,c,b,D){"use strict";var d=function(C){this.sControlId=C.getId();this._hintConfigs=[];};
d.init=function(C){C._shortcutHintsMixin=new d(C);};
d.addConfig=function(C,o,i){if(D.system.phone){return;}if(/sap-ui-xx-noshortcuthints=true/.test(document.location.search)){return;}var M=C._shortcutHintsMixin;if(!M){d.init(C);M=C._shortcutHintsMixin;}M._hintConfigs.push(o);M.initHint(o,i);};
d.hideAll=function(){var C;for(var s in h.mControls){C=a.registry.get(s);if(C){C._shortcutHintsMixin.hideShortcutHint();}}};
d.isDOMIDRegistered=function(s){return h.mDOMNodes[s]&&!!h.mDOMNodes[s].length;};
d.isControlRegistered=function(C){return!!h.mControls[C];};
d.prototype._attachToEvents=function(){var C;if(!d.isControlRegistered(this.sControlId)){C=a.registry.get(this.sControlId);C.addEventDelegate(H,this);}};
d.prototype.register=function(s,C,o){this._attachToEvents();if(!d.isControlRegistered(this.sControlId)){var i=a.registry.get(this.sControlId);i._originalExit=i.exit;i.exit=function(){if(i._originalExit){i._originalExit.apply(i,arguments);}this.deregister();}.bind(this);}h.mControls[this.sControlId]=true;if(!h.mDOMNodes[s]){h.mDOMNodes[s]=[];}h.mDOMNodes[s].push(new S(o,C));};
d.prototype.deregister=function(){var n=this.getRegisteredShortcutInfos(),i;delete h.mControls[this.sControlId];for(i=0;i<n.length;i++){delete h.mDOMNodes[n[i].id];}};
d.prototype.initHint=function(C,o){var i=this._getShortcutHintInfo(C);if(i.message){this.register(i.id,{message:i.message},o);}else if(i.messageBundleKey){this.register(i.id,{messageBundleKey:i.messageBundleKey},o);}else if(i.event){var n=E.getEventList(o)[i.event],A=[];if(n){A=n.reduce(function(r,L){if(L.fFunction&&L.fFunction._sapui_commandName){r.push(L.fFunction._sapui_commandName);}return r;},[]);}if(A.length){this.register(i.id,{commandName:A[0]},o);}else{o.attachEvent("EventHandlerChange",function(p){var F=p.getParameter("func");if(p.getParameter("type")==="listenerAttached"&&F&&F._sapui_commandName&&p.getParameter("EventId")===i.event){this.register(i.id,{commandName:F._sapui_commandName},o);}},this);}}};
d.prototype._getShortcutHintInfos=function(){return this._hintConfigs.map(this._getShortcutHintInfo,this);};
d.prototype._getShortcutHintInfo=function(o){var i;if(o.domrefid){i=o.domrefid;}else if(o.domrefid_suffix){i=this.sControlId+o.domrefid_suffix;}else{i=this.sControlId;}return{id:i,event:o.event,position:o.position,messageBundleKey:o.messageBundleKey,message:o.message,addAccessibilityLabel:o.addAccessibilityLabel};};
d.prototype.getRegisteredShortcutInfos=function(){return this._getShortcutHintInfos().filter(function(i){return d.isDOMIDRegistered(i.id);},this);};
d.prototype.showShortcutHint=function(o){var t,p=o[0].position||"0 8",M=P.Dock.CenterTop,O=P.Dock.CenterBottom,i=e(),s=o[0].ref,n=_(o[0].id),T;if(!k(s)||!j(s)){return;}T=this._getControlTooltips();if(T[o[0].id]){n=T[o[0].id].tooltip+" ("+n+")";}if(!i){i=f(n);}i.oContent.children[0].textContent=n;if(!i.isOpen()){i.open(1000,M,O,s,p,"flipfit",function(q){i.oContent.style.visibility="hidden";if(t){clearTimeout(t);}t=setTimeout(function(){if(!k(s)||!j(s)){return;}i.oContent.style.visibility="visible";},1000);i._applyPosition(i._oLastPosition);});}};
d.prototype.hideShortcutHint=function(){var p=e();if(p&&p.isOpen()){p.close();}};
d.prototype._findShortcutOptionsForRef=function(n){var o,p=this.getRegisteredShortcutInfos(),i,r=[];for(i=0;i<p.length;i++){o=p[i];o.ref=document.getElementById(o.id);if(c(o.ref,n)){r.push(o);}}return r;};
d.prototype._getControlTooltips=function(){var i=this.getRegisteredShortcutInfos(),C=a.registry.get(this.sControlId);return i.reduce(function(r,o){var t=C._getTitleAttribute&&C._getTitleAttribute(o.id);if(!t){t=C.getTooltip();}if(t){r[o.id]={tooltip:t};}return r;},{});};
d.prototype._updateShortcutHintAccLabel=function(o){var i,s,C;if(!o.addAccessibilityLabel){return;}C=a.registry.get(this.sControlId);if(!C.getAriaDescribedBy){return;}i=g(C);s=i.getId();i.setText(_(o.id));if(!i.getText()){C.removeAriaDescribedBy(s);}else if(C.getAriaDescribedBy().indexOf(s)===-1){C.addAriaDescribedBy(s);}};
var h=Object.create(null);h.mControls={};h.mDOMNodes={};var H={"onfocusin":function(o){var s=this._findShortcutOptionsForRef(o.target);if(!s.length){return;}d.hideAll();this._updateShortcutHintAccLabel(s[0]);this.showShortcutHint(s);},"onfocusout":function(o){var s=this._findShortcutOptionsForRef(o.target);if(!s.length){return;}this.hideShortcutHint();},"onmouseover":function(o){var s=this._findShortcutOptionsForRef(o.target),i;if(!s.length){return;}i=s[0].ref;if(!m(i)){return;}if(b(o,i)){d.hideAll();this.showShortcutHint(s);}},"onmouseout":function(o){var s=this._findShortcutOptionsForRef(o.target);if(!s.length){return;}if(b(o,s[0].ref)){if(c(s[0].ref,document.activeElement)){return;}this.hideShortcutHint();}},"onAfterRendering":function(){var n=this.getRegisteredShortcutInfos(),o,s;for(var i=0;i<n.length;i++){s=n[i].id;o=document.getElementById(s);o.setAttribute("aria-keyshortcuts",_(s));}}};
function _(s){var i=h.mDOMNodes[s];if(!i||!i.length){return;}return i.map(function(o){return o._getShortcutText();}).join(", ");}
function g(C){if(!C._shortcutInvisibleText){var F=C.exit;C._shortcutInvisibleText=new I();C._shortcutInvisibleText.toStatic();C.exit=function(){this._shortcutInvisibleText.destroy();F.call(this);};}return C._shortcutInvisibleText;}
function e(){return d._popup;}
function f(t){var p,C,T;C=document.createElement("span");C.classList.add("sapUiHintContainer");T=document.createElement("div");T.classList.add("sapUiHintText");T.textContent=t;C.appendChild(T);p=new P(C,false,false,false);p.setAnimations(function($,i,n){setTimeout(n,i);},function($,i,n){n();});d._popup=p;return p;}
function j(o){var r;if(!o){return false;}r=o.getBoundingClientRect();return(r.top>=0&&r.left>=0&&r.bottom<=(window.innerHeight||document.documentElement.clientHeight)&&r.right<=(window.innerWidth||document.documentElement.clientWidth));}
function k(i){return i.offsetWidth>0||i.offsetHeight>0||i.getClientRects().length>0;}
function l(i){var t=i.tabIndex;return t!=null&&t>=0&&(i.getAttribute("disabled")==null||i.getAttribute("tabindex"));}
function m(i){return i.nodeType==1&&k(i)&&l(i);}
return d;});
sap.ui.predefine('sap/ui/core/StashedControlSupport',["sap/base/assert"],function(a){"use strict";var S={},s={};
S.mixInto=function(c){a(!c.prototype.unstash,"StashedControlSupport: fnClass already has method 'unstash', sideeffects possible",c.getMetadata().getName());if(c.getMetadata().isA("sap.ui.core.Fragment")||c.getMetadata().isA("sap.ui.core.mvc.View")){throw new Error("Stashing is not supported for sap.ui.coreFragment or sap.ui.core.mvc.View");}m(c);};
function m(c){c.prototype.unstash=function(){if(this.isStashed()){var o=u(this);o.stashed=false;return o;}return this;};c.prototype.isStashed=function(){return!!s[this.getId()];};var C=c.prototype.clone;c.prototype.clone=function(){if(this.isStashed()){throw new Error("A stashed control cannot be cloned, id: '"+this.getId()+"'.");}return C.apply(this,arguments);};var d=c.prototype.destroy;c.prototype.destroy=function(){delete s[this.getId()];d.apply(this,arguments);};}
function u(w){var W;var i;var t;var o=s[w.getId()];W=w.getParent();if(W){t=W.getMetadata().getAggregation(w.sParentAggregationName);i=t.indexOf(W,w);t.remove(W,w);}w.destroy();var C=sap.ui.require("sap/ui/core/Component");var O=C&&W&&C.getOwnerComponentFor(W);var b;var f=o.fnCreate;if(O){b=O.runAsOwner(f);}else{b=f();}if(i>=0){b.forEach(function(c){t.insert(W,c,i);});}delete s[w.getId()];return b[0];}
function g(A,p){var b=[];for(var i in s){var P=sap.ui.getCore().byId(s[i].wrapperId);var I=A?P:i;var o=P&&P.getParent();if(!p||(o&&o.getId()===p)){b.push(I);}}return b;}
S.getStashedControlIds=function(p){return g(false,p);};
S.getStashedControls=function(p){return g(true,p);};
S.createStashedControl=function(b){var o={wrapperId:b.wrapperId,fnCreate:b.fnCreate};s[b.wrapperId]=o;return o;};
return S;});
sap.ui.predefine('sap/ui/core/Title',['./Element','./library'],function(E,l){"use strict";var T=l.TitleLevel;
var a=E.extend("sap.ui.core.Title",{metadata:{library:"sap.ui.core",properties:{text:{type:"string",group:"Appearance",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},level:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:T.Auto},emphasized:{type:"boolean",group:"Appearance",defaultValue:false}}}});
return a;});
sap.ui.predefine('sap/ui/core/TooltipBase',['./Control','./Popup','./library',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(C,P,l,K,q){"use strict";var O=l.OpenState;
var T=C.extend("sap.ui.core.TooltipBase",{
metadata:{"abstract":true,library:"sap.ui.core",properties:{text:{type:"string",group:"Misc",defaultValue:""},openDuration:{type:"int",group:"Behavior",defaultValue:200},closeDuration:{type:"int",group:"Behavior",defaultValue:200},myPosition:{type:"sap.ui.core.Dock",group:"Behavior",defaultValue:'begin top'},atPosition:{type:"sap.ui.core.Dock",group:"Behavior",defaultValue:'begin bottom'},offset:{type:"string",group:"Behavior",defaultValue:'10 3'},collision:{type:"sap.ui.core.Collision",group:"Behavior",defaultValue:'flip'},openDelay:{type:"int",group:"Misc",defaultValue:500},closeDelay:{type:"int",group:"Misc",defaultValue:100}},events:{closed:{}}},
renderer:null
});
T.prototype._getPopup=function(){var p=new P();p.setShadow(true);T.prototype._getPopup=function(){return p;};return p;};
T.prototype.onfocusin=function(e){var s=q(e.target).control(0);if(s!=null){var d=s.getFocusDomRef();this.sStoredTooltip=null;if(d.title&&d.title!=""){this.sStoredTooltip=d.title;d.title="";}var p=this._getPopup();if(!(p.isOpen()&&p.getContent()==this)){sap.ui.getCore().createRenderManager().render(this,sap.ui.getCore().getStaticAreaRef(),true);}var v=d.getAttribute("aria-describedby");var i=this.getId()+"-title "+this.getId()+"-txt";if(v==null||v==""){d.setAttribute("aria-describedby",i);}else if(v.indexOf(i)==-1){d.setAttribute("aria-describedby",v+" "+i);}}};
T.prototype.onfocusout=function(e){var s=q(e.target).control(0);if(s!=null){var d=s.getFocusDomRef();if(this.sStoredTooltip){d.title=this.sStoredTooltip;}var v=d.getAttribute("aria-describedby");var i=this.getId()+"-title "+this.getId()+"-txt";if(v&&v.indexOf(i)>=0){if(v.trim()==i){d.removeAttribute("aria-describedby");}else{v=v.replace(i,"");d.setAttribute("aria-describedby",v);}}}if(T.sOpenTimeout){clearTimeout(T.sOpenTimeout);T.sOpenTimeout=undefined;}this.sCloseNowTimeout=setTimeout(this["closePopup"].bind(this),this.getCloseDelay());};
T.prototype.isStandardTooltip=function(t){return typeof t==="string"&&!!t.trim();};
T.prototype.onmouseover=function(e){var E=q(e.target).control(0),c=q(e.currentTarget).control(0),L=q(e.relatedTarget).control(0);if(!E){return;}if(E===this){if(this.sCloseNowTimeout){clearTimeout(this.sCloseNowTimeout);this.sCloseNowTimeout=null;}e.stopPropagation();e.preventDefault();return;}if(c===E||!this.isStandardTooltip(E.getTooltip())){if(this.sCloseNowTimeout){clearTimeout(this.sCloseNowTimeout);this.sCloseNowTimeout=null;e.stopPropagation();e.preventDefault();}}if(L){if(L.getParent()){if(L.getParent()===c&&c===E){var o=L.getTooltip();if(!this.isStandardTooltip(o)&&(!o||!(o instanceof T))){if(this.sCloseNowTimeout){clearTimeout(this.sCloseNowTimeout);this.sCloseNowTimeout=null;e.stopPropagation();e.preventDefault();}}}}}if(this._currentControl===E||!this.isStandardTooltip(E.getTooltip())){this.removeStandardTooltips();if(T.sOpenTimeout){clearTimeout(T.sOpenTimeout);}T.sOpenTimeout=setTimeout(this["openPopup"].bind(this,this._currentControl),this.getOpenDelay());e.stopPropagation();e.preventDefault();}};
T.prototype.onmouseout=function(e){if(T.sOpenTimeout){clearTimeout(T.sOpenTimeout);T.sOpenTimeout=undefined;}if(!this.sCloseNowTimeout){this.sCloseNowTimeout=setTimeout(this["closePopup"].bind(this),this.getCloseDelay());}this.restoreStandardTooltips();e.stopPropagation();e.preventDefault();};
T.prototype.closePopup=function(){var p=this._getPopup();if(this.sCloseNowTimeout){clearTimeout(this.sCloseNowTimeout);}this.sCloseNowTimeout=undefined;p.attachClosed(this.handleClosed,this);p.close();this.restoreStandardTooltips();};
T.prototype.handleClosed=function(){this._getPopup().detachClosed(this.handleClosed,this);this.fireClosed();};
T.prototype.openPopup=function(s){if(!this.getVisible()){return;}if(s.getTooltip()!=null){if(this.sCloseNowTimeout){clearTimeout(this.sCloseNowTimeout);this.sCloseNowTimeout=null;return;}var p=this._getPopup();if(p.isOpen()&&p.getContent()==this){return;}var d=s.getDomRef();p.setContent(this);p.setPosition(this.getMyPosition(),this.getAtPosition(),d,this.getOffset(),this.getCollision());p.setDurations(this.getOpenDuration(),this.getCloseDuration());p.open();this.removeStandardTooltips();}};
T.prototype.removeStandardTooltips=function(){var d=this._currentControl.getDomRef();if(!this.aStoredTooltips){this.aStoredTooltips=[];}else{return;}var t="";while(d&&!(d===document)){t=d.title;if(t){this.aStoredTooltips.push({domref:d,tooltip:t});d.title="";}d=d.parentNode;}if(this._currentControl.getTooltipDomRefs){var D=this._currentControl.getTooltipDomRefs();for(var i=0;i<D.length;i++){d=D[i];if(d){t=d.title;if(t){this.aStoredTooltips.push({domref:d,tooltip:t});d.title="";}}}}};
T.prototype.restoreStandardTooltips=function(){var p=this._getPopup();var e=p.getOpenState();if(e===O.OPEN||e===O.OPENING){return;}if(T.sOpenTimeout){return;}if(this.aStoredTooltips){for(var i=0;i<this.aStoredTooltips.length;i++){var d=this.aStoredTooltips[i].domref;d.title=this.aStoredTooltips[i].tooltip;}}this.aStoredTooltips=null;};
T.prototype.setParent=function(p,a){var _=this._getPopup();if(_&&_.isOpen()){this.closePopup();}C.prototype.setParent.apply(this,arguments);};
T.prototype.onkeydown=function(e){if(e.ctrlKey&&e.which==K.I){var E=q(e.target).control(0);if(E!=null){if(this._currentControl===E||!this.isStandardTooltip(E.getTooltip())){this.removeStandardTooltips();this.openPopup(this._currentControl);e.preventDefault();e.stopPropagation();}}}else if(e.which==K.ESCAPE){if(T.sOpenTimeout){clearTimeout(T.sOpenTimeout);T.sOpenTimeout=undefined;}var w=this.oPopup&&this.oPopup.isOpen();this.closePopup();if(w){e.preventDefault();e.stopPropagation();}}};
T.prototype._closeOrPreventOpen=function(){var p=this._getPopup();if(p.isOpen()){this.closePopup();}else if(T.sOpenTimeout){clearTimeout(T.sOpenTimeout);T.sOpenTimeout=undefined;}};
return T;});
sap.ui.predefine('sap/ui/core/UIComponent',['../base/ManagedObject','./Component','sap/ui/core/mvc/ViewType','sap/ui/core/mvc/XMLProcessingMode','./UIComponentMetadata','./mvc/Controller','./mvc/View','sap/base/util/ObjectPath','sap/base/Log','sap/ui/core/Core'],function(M,C,V,X,U,a,b,O,L){"use strict";
var c=C.extend("sap.ui.core.UIComponent",{
constructor:function(i,s){var d=false;try{if(typeof i!=="string"){s=i;i=undefined;}if(s&&s.hasOwnProperty("_routerHashChanger")){this._oRouterHashChanger=s._routerHashChanger;delete s._routerHashChanger;}if(s&&s.hasOwnProperty("_propagateTitle")){this._bRoutingPropagateTitle=s._propagateTitle;delete s._propagateTitle;}C.apply(this,arguments);d=true;}finally{if(!d){this._destroyCreatedInstances();}}},
metadata:{"abstract":true,rootView:null,publicMethods:["render"],aggregations:{"rootControl":{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},designtime:"sap/ui/core/designtime/UIComponent.designtime",routing:{}}
},U);
c._fnOnInstanceInitialized=null;c._fnOnInstanceDestroy=null;
c.prototype.init=function(){var t=this;var p={};var r;if(this.getAutoPrefixId()){p.id=function(i){return t.createId(i);};}function s(r){var F=function(){if(typeof c._fnOnInstanceInitialized==="function"){c._fnOnInstanceInitialized(t);}};var A=function(i){t.setAggregation("rootControl",i);};if(r instanceof Promise){t.pRootControlLoaded=t.pRootControlLoaded.then(function(i){A(i);F();return i;});}else if(r instanceof b&&r.oAsyncState&&r.oAsyncState.promise){A(r);t.pRootControlLoaded=t.pRootControlLoaded.then(function(i){F();return i;});}else{A(r);F();}}function d(r,o){var i;if(r instanceof Promise){i=t.pRootControlLoaded.then(function(j){return(j instanceof b)?j.getId():undefined;});}else if(r instanceof b){i=r.getId();}if(i){if(o.targetParent===undefined){o.targetParent=i;}if(t._oTargets){t._oTargets._setRootViewId(i);}}}var R=this._getManifestEntry("/sap.ui5/routing",true)||{},o=R.config||{},v=R.routes;if(this.isA("sap.ui.core.IAsyncContentCreation")){o.async=true;}if(v){var f;var e=this._getRouterClassName();if(e){f=g(e);}else{f=sap.ui.require("sap/ui/core/routing/Router")||sap.ui.requireSync("sap/ui/core/routing/Router");}this._oRouter=new f(v,o,this,R.targets,this._oRouterHashChanger);this._oTargets=this._oRouter.getTargets();this._oViews=this._oRouter.getViews();}else if(R.targets){var h=sap.ui.require("sap/ui/core/routing/Views")||sap.ui.requireSync("sap/ui/core/routing/Views");this._oViews=new h({component:this});var T;if(o.targetsClass){T=g(o.targetsClass);}else{T=sap.ui.require("sap/ui/core/routing/Targets")||sap.ui.requireSync("sap/ui/core/routing/Targets");}this._oTargets=new T({targets:R.targets,config:o,views:this._oViews});}this.runAsOwner(function(){M.runWithPreprocessors(function(){r=t.createContent();},p);});if(r instanceof Promise){if(this.isA("sap.ui.core.IAsyncContentCreation")){this.pRootControlLoaded=r;}else{throw new Error("Interface 'sap.ui.core.IAsyncContentCreation' must be implemented for component '"+this.getMetadata().getComponentName()+"' when 'createContent' is implemented asynchronously");}}else if(r instanceof b&&r.oAsyncState&&r.oAsyncState.promise){this.pRootControlLoaded=r.loaded();}else{this.pRootControlLoaded=Promise.resolve(r);}d(r,o);s(r);};
function g(r){var f;if(typeof r==="string"){f=O.get(r);if(!f){L.error("The specified class for router or targets '"+r+"' is undefined.",this);}}else{f=r;}return f;}
c.prototype.rootControlLoaded=function(){if(!this.pRootControlLoaded){L.error("Mandatory init() not called for UIComponent: '"+this.getManifestObject().getComponentName()+"'. This is likely caused by a missing super call in the component's init implementation.",null,"sap.ui.support",function(){return{type:"missingInitInUIComponent"};});}return this.pRootControlLoaded||Promise.resolve(this.getRootControl());};
c.prototype.destroy=function(){if(typeof c._fnOnInstanceDestroy==="function"){c._fnOnInstanceDestroy(this);}this._destroyCreatedInstances();return C.prototype.destroy.apply(this,arguments);};
c.prototype._destroyCreatedInstances=function(){if(this._oRouter){this._oRouter.destroy();delete this._oRouter;}else{if(this._oTargets){this._oTargets.destroy();this._oTargets=null;}if(this._oViews){this._oViews.destroy();this._oViews=null;}}};
c.getRouterFor=function(o){var v=o;if(v instanceof a){v=v.getView();}if(v instanceof b){var d=C.getOwnerComponentFor(v);if(d){return d.getRouter();}else{return undefined;}}};
c.prototype.getRouter=function(){return this._oRouter;};
c.prototype.hasNativeRouter=function(){return this._oRouter===this.getRouter();};
c.prototype.getTargets=function(){return this._oTargets;};
c.prototype.getAutoPrefixId=function(){return!!this.getManifestObject().getEntry("/sap.ui5/autoPrefixId");};
c.prototype.byId=function(i){return sap.ui.getCore().byId(this.createId(i));};
c.prototype.createId=function(i){if(!this.isPrefixedId(i)){i=this.getId()+"---"+i;}return i;};
c.prototype.getLocalId=function(i){var p=this.getId()+"---";return(i&&i.indexOf(p)===0)?i.slice(p.length):null;};
c.prototype.isPrefixedId=function(i){return!!(i&&i.indexOf(this.getId()+"---")===0);};
c.prototype.createContent=function(){var r=this._getManifestEntry("/sap.ui5/rootView",true);if(r&&typeof r==="string"){return b._create({viewName:r,type:V.XML});}else if(r&&typeof r==="object"){if(!r.type&&!b._getModuleName(r)){r.type=V.XML;}if(r.id){r.id=this.createId(r.id);}if(r.async&&r.type===V.XML){r.processingMode=X.Sequential;}if(this.isA("sap.ui.core.IAsyncContentCreation")){return b.create(r);}return b._create(r);}else if(r){throw new Error("Configuration option 'rootView' of component '"+this.getMetadata().getName()+"' is invalid! 'rootView' must be type of string or object!");}return null;};
c.prototype.getRootControl=function(){return this.getAggregation("rootControl");};
c.prototype.render=function(r){var o=this.getRootControl();if(o&&r){r.renderControl(o);}};
c.prototype.getUIArea=function(){return(this.oContainer?this.oContainer.getUIArea():null);};
c.prototype.getEventingParent=function(){return this.getUIArea();};
c.prototype.setContainer=function(o){this.oContainer=o;if(o){this._applyContextualSettings(o._getContextualSettings());}else{this._oContextualSettings=M._defaultContextualSettings;if(!this._bIsBeingDestroyed){setTimeout(function(){if(!this.oContainer){this._propagateContextualSettings();}}.bind(this),0);}}return this;};
c.prototype.onBeforeRendering=function(){};
c.prototype.onAfterRendering=function(){};
c.prototype._getRouterClassName=function(){var r=this._getManifestEntry("/sap.ui5/routing",true)||{},R=r.config||{};return R.routerClass;};
return c;});
sap.ui.predefine('sap/ui/core/UIComponentMetadata',['./ComponentMetadata','sap/ui/core/mvc/ViewType'],function(C,V){"use strict";var U=function(c,o){C.apply(this,arguments);};U.prototype=Object.create(C.prototype);U.prototype.constructor=U;
U.preprocessClassInfo=function(c){if(c&&typeof c.metadata==="string"){c.metadata={_src:c.metadata};}return c;};
U.prototype.getRootView=function(d){return this.getManifestEntry("/sap.ui5/rootView",!d);};
U.prototype.getRoutingConfig=function(d){return this.getManifestEntry("/sap.ui5/routing/config",!d);};
U.prototype.getRoutes=function(d){return this.getManifestEntry("/sap.ui5/routing/routes",!d);};
U.prototype._convertLegacyMetadata=function(s,m){C.prototype._convertLegacyMetadata.call(this,s,m);var u=m["sap.ui5"];var r=u["rootView"]||s["rootView"];if(r){u["rootView"]=r;}var R=u["routing"]||s["routing"];if(R){u["routing"]=R;}if(u["rootView"]&&typeof u["rootView"]==="string"){u["rootView"]={viewName:u["rootView"],type:V.XML};}};
return U;},true);
sap.ui.predefine('sap/ui/core/ValueStateSupport',['./Element','./library',"sap/base/assert"],function(E,l,a){"use strict";var V=l.ValueState;var b={};var t=null;var e=function(){if(!t){t={};var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core");t[V.Error]=r.getText("VALUE_STATE_ERROR");t[V.Warning]=r.getText("VALUE_STATE_WARNING");t[V.Success]=r.getText("VALUE_STATE_SUCCESS");t[V.Information]=r.getText("VALUE_STATE_INFORMATION");}};
b.enrichTooltip=function(o,T){a(o instanceof E,"oElement must be an Element");if(!T&&o.getTooltip()){return undefined;}var s=b.getAdditionalText(o);if(s){return(T?T+" - ":"")+s;}return T;};
b.getAdditionalText=function(v){var s=null;if(v&&v.getValueState){s=v.getValueState();}else if(V[v]){s=v;}if(s&&(s!=V.None)){e();return t[s];}return null;};
b.formatValueState=function(s){switch(s){case 1:return V.Warning;case 2:return V.Success;case 3:return V.Error;case 4:return V.Information;default:return V.None;}};
return b;},true);
sap.ui.predefine('sap/ui/core/VariantLayoutData',['./LayoutData','./library'],function(L){"use strict";
var V=L.extend("sap.ui.core.VariantLayoutData",{metadata:{library:"sap.ui.core",aggregations:{multipleLayoutData:{type:"sap.ui.core.LayoutData",multiple:true,singularName:"multipleLayoutData"}}}});
return V;});
sap.ui.predefine('sap/ui/core/XMLComposite',['sap/ui/core/Control','sap/ui/core/XMLCompositeMetadata','sap/ui/model/base/ManagedObjectModel','sap/ui/core/Fragment','sap/ui/model/resource/ResourceModel','sap/base/Log','sap/ui/performance/Measurement'],function(C,X,M,F,R,L,a){"use strict";var x="sap.ui.core.XMLComposite";
var b=C.extend("sap.ui.core.XMLComposite",{
metadata:{interfaces:["sap.ui.core.IDScope"],properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%',invalidate:true},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null,invalidate:true},displayBlock:{type:"boolean",group:"Appearance",defaultValue:true,invalidate:true}},aggregations:{_content:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden",invalidate:true}}},
constructor:function(){this._bIsCreating=true;C.apply(this,arguments);delete this._bIsCreating;},
renderer:{apiVersion:2,render:function(r,c){L.debug("Start rendering '"+c.sId,x);a.start(c.getId()+"---renderControl","Rendering of "+c.getMetadata().getName(),["rendering","control"]);r.openStart("div",c);r.accessibilityState(c);if(!c.getDisplayBlock()&&(c.getWidth()!=="100%"||c.getHeight()!=="100%")){r.style("display","inline-block");}r.style("height",c.getHeight());r.style("width",c.getWidth());r.openEnd();var o=c._renderingContent?c._renderingContent():c._getCompositeAggregation();if(o){r.renderControl(o);}r.close("div");a.end(c.getId()+"---renderControl");L.debug("Stop rendering '"+c.sId,x);}}
},X);
b.prototype.byId=function(i){return sap.ui.getCore().byId(F.createId(this.getId(),i));};
b.prototype._getManagedObjectModel=function(){if(!this._oManagedObjectModel){this._oManagedObjectModel=new M(this);}return this._oManagedObjectModel;};
b.prototype.getSuppressInvalidateAggregation=function(n,s){var m=this.getMetadata(),A=m.getAggregation(n)||m.getAllPrivateAggregations()[n];if(!A){return true;}s=m._suppressInvalidate(A,s);return s;};
b.prototype.setProperty=function(n,v,s){var m=this.getMetadata(),p=m.getManagedProperty(n);if(!p){return this;}s=m._suppressInvalidate(p,s);return C.prototype.setProperty.apply(this,[n,v,s]);};
b.prototype.setAggregation=function(n,o,s){return C.prototype.setAggregation.apply(this,[n,o,this.getSuppressInvalidateAggregation(n,s)]);};
b.prototype.addAggregation=function(n,o,s){return C.prototype.addAggregation.apply(this,[n,o,this.getSuppressInvalidateAggregation(n,s)]);};
b.prototype.insertAggregation=function(n,o,i,s){return C.prototype.insertAggregation.apply(this,[n,o,i,this.getSuppressInvalidateAggregation(n,s)]);};
b.prototype.removeAggregation=function(n,o,s){return C.prototype.removeAggregation.apply(this,[n,o,this.getSuppressInvalidateAggregation(n,s)]);};
b.prototype.removeAllAggregation=function(n,s){return C.prototype.removeAllAggregation.apply(this,[n,this.getSuppressInvalidateAggregation(n,s)]);};
b.prototype.destroyAggregation=function(n,s){return C.prototype.destroyAggregation.apply(this,[n,this.getSuppressInvalidateAggregation(n,s)]);};
b.prototype.updateAggregation=function(n,s){var A=this.getMetadata().getAggregation(n);if(A&&A.type==="TemplateMetadataContext"){this.invalidate();return;}C.prototype.updateAggregation.apply(this,arguments);};
b.prototype.setVisible=function(v){this.setProperty("visible",v);if(this.getParent()){this.getParent().invalidate();}return this;};
b.prototype._destroyCompositeAggregation=function(){var c=this._getCompositeAggregation();if(c){c.destroy("KeepDom");}return this;};
b.prototype.updateBindings=function(){if(this._bIsCreating){return;}var r=C.prototype.updateBindings.apply(this,arguments);for(var n in this.mBindingInfos){var A=this.getMetadata().getAggregation(n);if(A&&A.multiple&&!A._doesNotRequireFactory&&this.isBound(n)&&!this.getBinding(n)){this[A._sDestructor]();}}return r;};
b.prototype._getCompositeAggregation=function(){var c=this.getMetadata().getCompositeAggregationName();return this.getAggregation(c);};
b.prototype._setCompositeAggregation=function(n){var c=this.getMetadata().getCompositeAggregationName();this._destroyCompositeAggregation();if(!this._oManagedObjectModel){this._getManagedObjectModel();}if(Array.isArray(n)){this.setAggregation(c,null);return;}if(n){if(!n.enhanceAccessibilityState){n.enhanceAccessibilityState=function(e,A){this.enhanceAccessibilityState(e,A);}.bind(this);}n.bindObject("$"+this.alias+">/");n.setModel(this._oManagedObjectModel,"$"+this.alias);if(this.bUsesI18n){var r=this._getResourceModel();if(r){n.setModel(r,"$"+this.alias+".i18n");}}}this.setAggregation(c,n);};
b.mResourceModels={};
b.getLibraryResourceModel=function(l){var o=b.mResourceModels[l];if(!o){o=new R({bundleName:l+".messagebundle",async:true});b.mResourceModels[l]=o;}return o;};
b.prototype._getResourceModel=function(){if(this.resourceModel){return this.resourceModel;}if(this.messageBundle){this.resourceModel=new R({bundleName:this.messageBundle,async:true});return this.resourceModel;}else{this.sLibraryName=this.sLibraryName||this.getMetadata().getLibraryName();if(this.sLibraryName){return b.getLibraryResourceModel(this.sLibraryName);}}};
b.prototype.getResourceBundle=function(){var r=this._getResourceModel();return r?r.getResourceBundle():null;};
b.prototype.destroy=function(){C.prototype.destroy.apply(this,arguments);if(this.resourceModel){this.resourceModel.destroy();}if(this._oManagedObjectModel){this._oManagedObjectModel.destroy();}};
b.prototype._initCompositeSupport=function(s){var m=this.getMetadata(),f=m._fragment,A=m.getCompositeAggregationName();this._destroyCompositeAggregation();if(s&&A&&s[A]){var n=s[A];if(n.localName==="FragmentDefinition"){f=n;delete s[A];}}var c=f?(new XMLSerializer()).serializeToString(f):undefined;this.bUsesI18n=c?(c.indexOf("$"+this.alias+".i18n")!=-1):true;this._setCompositeAggregation(sap.ui.xmlfragment({sId:this.getId(),fragmentContent:f,oController:this}));this._bIsInitialized=true;};
b.prototype.enhanceAccessibilityState=function(e,A){var p=this.getParent();if(p&&p.enhanceAccessibilityState){p.enhanceAccessibilityState(this,A);}};
b.prototype.getFocusDomRef=function(){var c=this._renderingContent?this._renderingContent():this._getCompositeAggregation();return c.getFocusDomRef();};
b.prototype.getFocusInfo=function(){var c=this._renderingContent?this._renderingContent():this._getCompositeAggregation();return c.getFocusInfo();};
b.prototype.getIdForLabel=function(){var c=this._renderingContent?this._renderingContent():this._getCompositeAggregation();return c.getIdForLabel();};
return b;});
sap.ui.predefine('sap/ui/core/XMLCompositeMetadata',['sap/ui/core/ElementMetadata','sap/ui/core/XMLTemplateProcessor',"sap/base/Log"],function(E,X,L){"use strict";var f={};var a=function(c,C){this.InvalidationMode={Render:true,None:false};if(!C.hasOwnProperty("renderer")){C.renderer="sap.ui.core.XMLCompositeRenderer";}if(!C.hasOwnProperty("alias")){C.alias="this";}E.apply(this,arguments);var b=this._bAbstract;if(!b){if(!C.fragment&&c!=="sap.ui.core.XMLComposite"){C.fragment=c;C.fragmentUnspecified=true;}if(!this._fragment&&C.fragment){try{if(!this._fragment){if(C.fragmentContent){if(typeof C.fragmentContent==="string"){var p=new DOMParser();C.fragmentContent=p.parseFromString(C.fragmentContent,"text/xml").documentElement;if(C.fragmentContent&&C.fragmentContent.getElementsByTagName("parsererror").length){var m=C.fragmentContent.getElementsByTagName("parsererror")[0].innerText;throw new Error("There was an error parsing the XML fragment for XMLComposite '"+c+"'. The following message may contain hints to find the problem: "+m);}}this._fragment=C.fragmentContent;}else{this._fragment=this._loadFragment(C.fragment,"control");}}}catch(e){if(!C.fragmentUnspecified||e.message.startsWith("There was an error parsing")){throw(e);}else{L.warning("Implicitly inferred fragment xml "+C.fragment+" not found. "+c+" is not abstract!");}}}}this._sCompositeAggregation=C.metadata?C.metadata.compositeAggregation||null:null;this._createPrivateAggregationAccessors();this._applyAggregationSettings();};a.prototype=Object.create(E.prototype);a.prototype.constructor=a;a.uid=E.uid;
a.extend=function(s){for(var k in s){a[k]=s[k];}return a;};
a.prototype.getCompositeAggregationName=function(){return this._sCompositeAggregation||"_content";};
a.prototype.getFragment=function(){if(this._fragment){return this._fragment.cloneNode(true);}};
a.prototype._applyAggregationSettings=function(){var A=this.getAllAggregations();for(var n in A){if(A[n].type==="TemplateMetadataContext"){this.getAggregation(n)._doesNotRequireFactory=true;}}};
a.prototype._createPrivateAggregationAccessors=function(){var p=this.getAllPrivateAggregations(),b=this.getClass().prototype,g=function(c,d){if(!b[c]){b[c]=d;}};for(var n in p){p[n].generate(g);}};
a.prototype._suppressInvalidate=function(m,s){if(s){return true;}if(!m.appData){m.appData={};m.appData.invalidate=this.InvalidationMode.None;}if(m&&m.appData&&m.appData.invalidate===this.InvalidationMode.Render){return false;}return true;};
a.prototype.getMandatoryAggregations=function(){if(!this._mMandatoryAggregations){var A=this.getAllAggregations(),m={};for(var n in A){if(A[n].type==="TemplateMetadataContext"&&A[n].appData.mandatory){m[n]=A[n];}}this._mMandatoryAggregations=m;}return this._mMandatoryAggregations;};
a.prototype._loadFragment=function(F,e){var s=e+"$"+F;if(!f[s]){f[s]=X.loadTemplate(F,e);}return f[s];};
return a;},true);
sap.ui.predefine('sap/ui/core/XMLTemplateProcessor',['sap/ui/thirdparty/jquery','sap/ui/base/DataType','sap/ui/base/ManagedObject','sap/ui/core/CustomData','sap/ui/core/Component','./mvc/View','./mvc/ViewType','./mvc/XMLProcessingMode','./mvc/EventHandlerResolver','./ExtensionPoint','./StashedControlSupport','sap/ui/base/SyncPromise','sap/base/Log','sap/base/util/ObjectPath','sap/base/util/values','sap/base/assert','sap/base/security/encodeXML','sap/base/util/LoaderExtensions','sap/base/util/JSTokenizer','sap/base/util/isEmptyObject'],function(q,D,M,C,a,V,b,X,E,c,S,d,L,O,v,f,g,h,J,k){"use strict";
function l(e,i,N,j,R){var p=M.bindingParser(i,j,true,false,false,false,R);if(p&&typeof p==="object"){return p;}var H=i=typeof p==="string"?p:i;var I=D.getType(e);if(I){if(I instanceof D){H=I.parseValue(i,{context:j,locals:R});if(!I.isValid(H)){L.error("Value '"+i+"' is not valid for type '"+I.getName()+"'.");}}}else{throw new Error("Property "+N+" has unknown type "+e);}return typeof H==="string"?M.bindingParser.escape(H):H;}
function m(e){return e.localName||e.nodeName;}
var n="http://www.w3.org/1999/xhtml";var o="http://www.w3.org/2000/xmlns/";var r="http://www.w3.org/2000/svg";var s="sap.ui.core";var t="http://schemas.sap.com/sapui5/extension/sap.ui.core.CustomData/1";var u="http://schemas.sap.com/sapui5/extension/sap.ui.core.support.Support.info/1";var w="http://schemas.sap.com/sapui5/extension/sap.ui.core.xmlcomposite/1";var U="http://schemas.sap.com/sapui5/extension/sap.ui.core.Internal/1";var P="http://schemas.sap.com/sapui5/preprocessorextension/";var x=/^(?:area|base|br|col|embed|hr|img|input|link|meta|param|source|track|wbr)$/;
function y(e,i){function j(H,I,K,N,Q){var R,W,Y=[];for(R=H.firstChild;R;R=R.nextSibling){W=i(H,I,K,R,false,N,Q);if(W){Y.push(W.unwrap());}}return d.resolve(Y);}function p(H,I,K,N,Q){var R,W=Promise.resolve(),Y=[N];for(R=H.firstChild;R;R=R.nextSibling){W=W.then(i.bind(null,H,I,K,R,false,N,Q));Y.push(W);}return Promise.all(Y);}return e?p:j;}
var z={};
z.loadTemplate=function(e,i){var R=e.replace(/\./g,"/")+("."+(i||"view")+".xml");return h.loadResource(R).documentElement;};
z.loadTemplatePromise=function(e,i){var R=e.replace(/\./g,"/")+("."+(i||"view")+".xml");return h.loadResource(R,{async:true}).then(function(j){return j.documentElement;});};
z.parseViewAttributes=function(e,j,p){var H=j.getMetadata().getAllProperties();for(var i=0;i<e.attributes.length;i++){var I=e.attributes[i];if(I.name==='controllerName'){j._controllerName=I.value;}else if(I.name==='resourceBundleName'){j._resourceBundleName=I.value;}else if(I.name==='resourceBundleUrl'){j._resourceBundleUrl=I.value;}else if(I.name==='resourceBundleLocale'){j._resourceBundleLocale=I.value;}else if(I.name==='resourceBundleAlias'){j._resourceBundleAlias=I.value;}else if(I.name==='class'){j.addStyleClass(I.value);}else if(!p[I.name]&&H[I.name]){p[I.name]=l(H[I.name].type,I.value,I.name,j._oContainingView.oController);}}};
z.enrichTemplateIds=function(e,i){z.enrichTemplateIdsPromise(e,i,false);return e;};
z.enrichTemplateIdsPromise=function(e,i,j){return G(e,i,true,j).then(function(){return e;});};
z.parseTemplate=function(e,i){return z.parseTemplatePromise(e,i,false).unwrap();};
z.parseTemplatePromise=function(i,j,H,I){return G(i,j,false,H,I).then(function(){var p=d.resolve(arguments[0]);if(j.isA("sap.ui.core.Fragment")){return p;}var K=arguments;if(j.isA("sap.ui.core.mvc.View")&&j._epInfo&&j._epInfo.all.length>0){p=T(H,j,{"content":j._epInfo.all});}return p.then(function(){if(Array.isArray(K[0])){K[0]=K[0].filter(function(e){return e==null||!e._isExtensionPoint;});}return K[0];});});};
function A(R){var e,i=/^[a-zA-Z_$][a-zA-Z0-9_$]*$/;if(!R||typeof R!=="object"){e="core:require in XMLView can't be parsed to a valid object";}else{Object.keys(R).some(function(K){if(!i.test(K)){e="core:require in XMLView contains invalid identifier: '"+K+"'";return true;}if(!R[K]||typeof R[K]!=="string"){e="core:require in XMLView contains invalide value '"+R[K]+"'under key '"+K+"'";return true;}});}return e;}
function B(j,p){var H=j.getAttributeNS(s,"require"),R,I,K;if(H){try{R=J.parseJS(H);}catch(e){L.error("Require attribute can't be parsed on Node: ",j.nodeName);throw e;}K=A(R);if(K){throw new Error(K+" on Node: "+j.nodeName);}if(!k(R)){I={};if(p){return new Promise(function(N,Q){var W=Object.keys(R).reduce(function(i,Y){I[Y]=sap.ui.require(R[Y]);return i&&I[Y]!==undefined;},true);if(W){N(I);return;}sap.ui.require(v(R),function(){var Y=arguments;Object.keys(R).forEach(function(Z,i){I[Z]=Y[i];});N(I);},Q);});}else{Object.keys(R).forEach(function(i){I[i]=sap.ui.requireSync(R[i]);});return d.resolve(I);}}}}
function T(e,i,j){var H=d.resolve();if(!k(j)){var I=[];var R;if(e){H=new Promise(function(p){R=p;});}Object.keys(j).forEach(function(K){var N=j[K];N.forEach(function(Q){Q.targetControl=i;var W=sap.ui.require(Q.providerClass);if(W){I.push(W.applyExtensionPoint(Q));}else{var p=new Promise(function(Y,Z){sap.ui.require([Q.providerClass],function($){Y($);},Z);}).then(function(Y){return Y.applyExtensionPoint(Q);});I.push(p);}});});if(e){Promise.all(I).then(R);}}return H;}
function F(e,i,p){var j=p;for(var H=0;H<100;H++){var R=e.lookupNamespaceURI(j);if(R==null||R===i){return j;}j=p+H;}throw new Error("Could not find an unused namespace prefix after 100 tries, giving up");}
function G(p,H,I,K,N){var R=[],Q=F(p,U,"__ui5"),W=B(p,K)||d.resolve(),Y={openStart:function(e,j){R.push(["openStart",[e,j]]);},voidStart:function(e,j){R.push(["voidStart",[e,j]]);},style:function(e,j){R.push(["style",[e,j]]);},"class":function(e){R.push(["class",[e]]);},attr:function(e,j){R.push(["attr",[e,j]]);},openEnd:function(){R.push(["openEnd"]);},voidEnd:function(){R.push(["voidEnd"]);},text:function(e){R.push(["text",[e]]);},unsafeHtml:function(e){R.push(["unsafeHtml",[e]]);},close:function(e){R.push(["close",[e]]);},renderControl:function(e){R.push(W);}};K=K&&!!H._sProcessingMode;L.debug("XML processing mode is "+(H._sProcessingMode||"default")+".","","XMLTemplateProcessor");L.debug("XML will be processed "+K?"asynchronously":"synchronously"+".","","XMLTemplateProcessor");var Z=sap.ui.getCore().getConfiguration().getDesignMode();if(Z){H._sapui_declarativeSourceInfo={xmlNode:p,xmlRootNode:H._oContainingView===H?p:H._oContainingView._sapui_declarativeSourceInfo.xmlRootNode};}var $=H.sViewName||H._sFragmentName;if(!$){var _=H;var a1=0;while(++a1<1000&&_&&_!==_._oContainingView){_=_._oContainingView;}$=_.sViewName;}if(H.isSubView()){f1(p,true,false,W);}else{if(p.localName==="View"&&p.namespaceURI!=="sap.ui.core.mvc"){L.warning("XMLView root node must have the 'sap.ui.core.mvc' namespace, not '"+p.namespaceURI+"'"+($?" (View name: "+$+")":""));}p.setAttributeNS(o,"xmlns:"+Q,U);g1(p,false,false,W);}var i=0;function b1(){for(;i<R.length;i++){var e=R[i];if(e&&typeof e.then==='function'){return e.then(c1).then(b1);}}return R;}function c1(e){var j=[i,1].concat(e);Array.prototype.splice.apply(R,j);}return W.then(b1);function d1(e){return e;}function e1(e){return H._oContainingView.createId(e);}function f1(p,e,o1,p1){if(p.nodeType===1){var q1=m(p);var r1=p.namespaceURI===n;if(r1||p.namespaceURI===r){var s1=p.getAttribute("id");if(s1==null){s1=e===true?H.getId():undefined;}else{s1=m1(H,p);}if(q1==="style"){var t1=p.attributes;var u1=p.textContent;p=document.createElement(q1);p.textContent=u1;for(var j=0;j<t1.length;j++){var v1=t1[j];if(!v1.prefix){p.setAttribute(v1.name,v1.value);}}if(s1!=null){p.setAttribute("id",s1);}if(e===true){p.setAttribute("data-sap-ui-preserve",H.getId());}Y.unsafeHtml(p.outerHTML);return;}var w1=x.test(q1);if(w1){Y.voidStart(q1,s1);}else{Y.openStart(q1,s1);}for(var i=0;i<p.attributes.length;i++){var x1=p.attributes[i];if(x1.name!=="id"){Y.attr(r1?x1.name.toLowerCase():x1.name,x1.value);}}if(e===true){Y.attr("data-sap-ui-preserve",H.getId());}if(w1){Y.voidEnd();if(p.firstChild){L.error("Content of void HTML element '"+q1+"' will be ignored");}}else{Y.openEnd();var y1=p instanceof HTMLTemplateElement?p.content:p;g1(y1,false,false,p1);Y.close(q1);}}else if(q1==="FragmentDefinition"&&p.namespaceURI===s){g1(p,false,true,p1);}else{W=W.then(function(){return j1(p,p1).then(function(z1){for(var i=0;i<z1.length;i++){var A1=z1[i];if(H.getMetadata().hasAggregation("content")){H._epInfo=H._epInfo||{contentControlsCount:0,last:null,all:[]};if(A1._isExtensionPoint){A1.index=H._epInfo.contentControlsCount;A1.targetControl=H;A1.aggregationName="content";if(H._epInfo.last){H._epInfo.last._nextSibling=A1;}H._epInfo.last=A1;H._epInfo.all.push(A1);}else{H._epInfo.contentControlsCount++;H.addAggregation("content",A1);}}else if(H.getMetadata().hasAssociation(("content"))){H.addAssociation("content",A1);}}return z1;});});Y.renderControl(W);}}else if(p.nodeType===3&&!o1){Y.text(p.textContent);}}function g1(p,e,j,o1){var p1=p.childNodes;for(var i=0;i<p1.length;i++){f1(p1[i],e,j,o1);}}function h1(e,j){var o1;var p1=sap.ui.getCore().getLoadedLibraries();q.each(p1,function(t1,u1){if(e===u1.namespace||e===u1.name){o1=u1.name+"."+((u1.tagNames&&u1.tagNames[j])||j);}});o1=o1||e+"."+j;function q1(s1){if(!s1){L.error("Control '"+o1+"' did not return a class definition from sap.ui.define.","","XMLTemplateProcessor");s1=O.get(o1);}if(!s1){L.error("Can't find object class '"+o1+"' for XML-view","","XMLTemplateProcessor");}return s1;}var r1=o1.replace(/\./g,"/");var s1=sap.ui.require(r1);if(!s1){if(K){return new Promise(function(t1,u1){sap.ui.require([r1],function(s1){s1=q1(s1);t1(s1);},u1);});}else{s1=sap.ui.requireSync(r1);s1=q1(s1);}}return s1;}function i1(e,j,o1){if(e.namespaceURI===n||e.namespaceURI===r){var id=e.attributes['id']?e.attributes['id'].textContent||e.attributes['id'].text:null;if(I){return z.enrichTemplateIdsPromise(e,H,K).then(function(){return[];});}else{var q1=function(p1){var s1={id:id?m1(H,e,id):undefined,xmlNode:e,containingView:H._oContainingView,processingMode:H._sProcessingMode};if(H.fnScopedRunWithOwner){return H.fnScopedRunWithOwner(function(){return new p1(s1);});}return new p1(s1);};if(K){return new Promise(function(p1,s1){sap.ui.require(["sap/ui/core/mvc/XMLView"],function(r1){p1([q1(r1)]);},s1);});}else{var r1=sap.ui.requireSync("sap/ui/core/mvc/XMLView");return d.resolve([q1(r1)]);}}}else{return j1(e,j,o1);}}function j1(e,j,o1){if(m(e)==="ExtensionPoint"&&e.namespaceURI===s){if(I){return d.resolve([]);}else{var p1=H instanceof V?H._oContainingView:H;var q1=c._factory.bind(null,p1,e.getAttribute("name"),function(){var w1=d.resolve();var x1=[];var y1=e.childNodes;for(var i=0;i<y1.length;i++){var z1=y1[i];if(z1.nodeType===1){w1=w1.then(i1.bind(null,z1,j,o1));x1.push(w1);}}return d.all(x1).then(function(A1){var B1=[];A1.forEach(function(C1){B1=B1.concat(C1);});return B1;});},undefined,undefined,K);return d.resolve(H.fnScopedRunWithOwner?H.fnScopedRunWithOwner(q1):q1());}}else{var r1=m(e);var s1=r1;var t1=r1.lastIndexOf(".");if(t1>=0){s1=r1.substring(t1+1,r1.length);}if(/^[a-z].*/.test(s1)){var u1=H.sViewName||H._sFragmentName||H.getId();L.warning("View or Fragment '"+u1+"' contains a Control tag that starts with lower case '"+s1+"'",H.getId(),"sap.ui.core.XMLTemplateProcessor#lowerCase");}var v1=h1(e.namespaceURI,r1);if(v1&&typeof v1.then==='function'){return v1.then(function(w1){return k1(e,w1,j,o1);});}else{return k1(e,v1,j,o1);}}}function k1(o1,p1,q1,r1){var ns=o1.namespaceURI,t1={},u1={},v1="",w1=[],x1=null,y1=null,z1=o1.getAttribute("stashed")==="true";if(!I){o1.removeAttribute("stashed");}if(!p1){return d.resolve([]);}var A1=p1.getMetadata();var B1=A1.getAllSettings();var C1=B(o1,K);if(C1){q1=d.all([q1,C1]).then(function(e){return Object.assign({},e[0],e[1]);});}q1=q1.then(function(j){if(k(j)){j=null;}if(!I){for(var i=0;i<o1.attributes.length;i++){var s1=o1.attributes[i],H1=s1.name,I1=s1.namespaceURI,J1=B1[H1],K1=s1.value;if(H1==="id"){t1[H1]=m1(H,o1,K1);}else if(H1==="class"){v1+=K1;}else if(H1==="viewName"){t1[H1]=K1;}else if(H1==="fragmentName"){t1[H1]=K1;t1['containingView']=H._oContainingView;}else if((H1==="binding"&&!J1)||H1==='objectBindings'){if(!z1){var L1=M.bindingParser(K1,H._oContainingView.oController);if(L1){t1.objectBindings=t1.objectBindings||{};t1.objectBindings[L1.model||undefined]=L1;}}}else if(H1==='metadataContexts'){if(!z1){var M1=null;try{M1=z._calculatedModelMapping(K1,H._oContainingView.oController,true);}catch(e){L.error(H+":"+e.message);}if(M1){t1.metadataContexts=M1;if(z._preprocessMetadataContexts){z._preprocessMetadataContexts(p1.getMetadata().getName(),t1,H._oContainingView.oController);}}}}else if(H1.indexOf(":")>-1){I1=s1.namespaceURI;if(I1===t){var N1=m(s1);w1.push(new C({key:N1,value:l("any",K1,N1,H._oContainingView.oController,j)}));}else if(I1===u){y1=K1;}else if(I1&&I1.startsWith(P)){L.debug(H+": XMLView parser ignored preprocessor attribute '"+H1+"' (value: '"+K1+"')");}else if(I1===U&&m(s1)==="invisible"){J1=B1.visible;if(J1&&J1._iKind===0&&J1.type==="boolean"){t1.visible=false;}}else if(I1===s||I1===U||H1.startsWith("xmlns:")){}else{if(!x1){x1={};}if(!x1.hasOwnProperty(s1.namespaceURI)){x1[s1.namespaceURI]={};}x1[s1.namespaceURI][m(s1)]=s1.nodeValue;L.debug(H+": XMLView parser encountered unknown attribute '"+H1+"' (value: '"+K1+"') with unknown namespace, stored as sap-ui-custom-settings of customData");}}else if(J1&&J1._iKind===0){t1[H1]=l(J1.type,K1,H1,H._oContainingView.oController,j);}else if(J1&&J1._iKind===1&&J1.altTypes){if(!z1){t1[H1]=l(J1.altTypes[0],K1,H1,H._oContainingView.oController,j);}}else if(J1&&J1._iKind===2){if(!z1){var L1=M.bindingParser(K1,H._oContainingView.oController,false,false,false,false,j);if(L1){t1[H1]=L1;}else{L.error(H+": aggregations with cardinality 0..n only allow binding paths as attribute value (wrong value: "+H1+"='"+K1+"')");}}}else if(J1&&J1._iKind===3){if(!z1){t1[H1]=e1(K1);}}else if(J1&&J1._iKind===4){if(!z1){t1[H1]=K1.split(/[\s,]+/g).filter(d1).map(e1);}}else if(J1&&J1._iKind===5){if(!z1){var O1=[];E.parse(K1).forEach(function(P1){var Q1=E.resolveEventHandler(P1,H._oContainingView.oController,j);if(Q1){O1.push(Q1);}else{L.warning(H+": event handler function \""+P1+"\" is not a function or does not exist in the controller.");}});if(O1.length){t1[H1]=O1;}}}else if(J1&&J1._iKind===-1){if(A1.isA("sap.ui.core.mvc.View")&&H1=="async"){t1[H1]=l(J1.type,K1,H1,H._oContainingView.oController,j);}else{L.warning(H+": setting '"+H1+"' for class "+A1.getName()+" (value:'"+K1+"') is not supported");}}else{f(H1==='xmlns',H+": encountered unknown setting '"+H1+"' for class "+A1.getName()+" (value:'"+K1+"')");if(z._supportInfo){z._supportInfo({context:o1,env:{caller:"createRegularControls",error:true,info:"unknown setting '"+H1+"' for class "+A1.getName()}});}}}if(x1){w1.push(new C({key:"sap-ui-custom-settings",value:x1}));}if(w1.length>0){t1.customData=w1;}}return j;}).catch(function(e){if(!e.isEnriched){var j=H.getMetadata().isA("sap.ui.core.mvc.View")?"View":"Fragment";var s1=o1&&o1.cloneNode(false).outerHTML;e=new Error("Error found in "+j+" (id: '"+H.getId()+"').\nXML node: '"+s1+"':\n"+e);e.isEnriched=true;L.error(e);}if(K&&H._sProcessingMode!==X.SequentialLegacy){throw e;}});var D1=y(K,E1);function E1(o1,F1,G1,e,s1,q1,r1){var H1,I1;if(e.nodeType===1){if(e.namespaceURI===w){t1[m(e)]=e.querySelector("*");return;}H1=e.namespaceURI===ns&&G1&&G1[m(e)];if(H1){return D1(e,H1,false,q1,r1);}else if(F1){if(!s1&&e.getAttribute("stashed")==="true"&&!I){var J1=e;e=e.cloneNode();J1.removeAttribute("stashed");I1=function(){var j=m1(H,e);S.createStashedControl({wrapperId:j,fnCreate:function(){var L1=K;K=false;try{return E1(o1,F1,G1,J1,true,q1,r1).unwrap();}finally{K=L1;}}});};if(H.fnScopedRunWithOwner){H.fnScopedRunWithOwner(I1);}else{I1();}e.removeAttribute("visible");l1(e,"invisible");}if(t1[F1.name]&&t1[F1.name].path&&typeof t1[F1.name].path==="string"){r1={aggregation:F1.name,id:t1.id};}return i1(e,q1,r1).then(function(L1){for(var j=0;j<L1.length;j++){var M1=L1[j];var N1=F1.name;if(M1._isExtensionPoint){if(!t1[N1]){t1[N1]=[];}var O1=u1[N1];if(!O1){O1=u1[N1]=[];}M1.index=t1[N1].length;M1.aggregationName=N1;M1.closestAggregationBindingCarrier=r1&&r1.id;M1.closestAggregationBinding=r1&&r1.aggregation;var P1=O1[O1.length-1];if(P1){P1._nextSibling=M1;}O1.push(M1);}else if(F1.multiple){if(!t1[N1]){t1[N1]=[];}if(typeof t1[N1].path==="string"){f(!t1[N1].template,"list bindings support only a single template object");t1[N1].template=M1;}else{t1[N1].push(M1);}}else{f(!t1[N1],"multiple aggregates defined for aggregation with cardinality 0..1");t1[N1]=M1;}}return L1;});}else if(m(o1)!=="FragmentDefinition"||o1.namespaceURI!==s){throw new Error("Cannot add direct child without default aggregation defined for control "+A1.getElementName());}}else if(e.nodeType===3){var K1=e.textContent||e.text;if(K1&&K1.trim()){throw new Error("Cannot add text nodes as direct child of an aggregation. For adding text to an aggregation, a surrounding html tag is needed: "+K1.trim());}}}var F1=A1.getDefaultAggregation();var G1=A1.getAllAggregations();return D1(o1,F1,G1,q1,r1).then(function(){var e;var j=d.resolve();var s1=d.resolve();var H1=o1.getAttribute("type");var I1=a.getOwnerComponentFor(H);var J1=I1&&I1.isA("sap.ui.core.IAsyncContentCreation");if(I&&o1.hasAttribute("id")){n1(H,o1);}else if(!I){if(p1.getMetadata().isA("sap.ui.core.mvc.View")){var K1=function(){if(!p1._sType&&!t1.viewName){t1.viewName="module:"+p1.getMetadata().getName().replace(/\./g,"/");}if(J1&&K){if(t1.async===false){throw new Error("A nested view contained in a Component implementing 'sap.ui.core.IAsyncContentCreation' is processed asynchronously by default and cannot be processed synchronously.\n"+"Affected Component '"+I1.getMetadata().getComponentName()+"' and View '"+t1.viewName+"'.");}t1.type=p1._sType||H1;s1=V.create(t1);}else{if(p1.getMetadata().isA("sap.ui.core.mvc.XMLView")&&H._sProcessingMode){t1.processingMode=H._sProcessingMode;}return V._create(t1,undefined,p1._sType||H1);}};if(H.fnScopedRunWithOwner){e=H.fnScopedRunWithOwner(K1);}else{e=K1();}}else if(p1.getMetadata().isA("sap.ui.core.Fragment")&&K){if(H1!==b.JS){t1.processingMode=H._sProcessingMode;}var L1="sap/ui/core/Fragment";var M1=sap.ui.require(L1);t1.name=t1.name||t1.fragmentName;if(M1){s1=M1.load(t1);}else{s1=new Promise(function(O1,P1){sap.ui.require([L1],function(M1){M1.load(t1).then(function(Q1){O1(Q1);});},P1);});}}else{var N1=function(){var O1;if(H.fnScopedRunWithOwner){O1=H.fnScopedRunWithOwner(function(){var O1=new p1(t1);return O1;});}else{O1=new p1(t1);}j=T(K,O1,u1);return O1;};if(N&&N.fnRunWithPreprocessor){e=N.fnRunWithPreprocessor(N1);}else{e=N1();}}}return s1.then(function(O1){return O1||e;}).then(function(O1){if(v1&&O1.addStyleClass){O1.addStyleClass(v1);}if(!O1){O1=[];}else if(!Array.isArray(O1)){O1=[O1];}if(z._supportInfo&&O1){for(var i=0,P1=O1.length;i<P1;i++){var Q1=O1[i];if(Q1&&Q1.getId()){var R1=z._supportInfo({context:o1,env:{caller:"createRegularControls",nodeid:o1.getAttribute("id"),controlid:Q1.getId()}}),S1=y1?y1+",":"";S1+=R1;z._supportInfo.addSupportInfo(Q1.getId(),S1);}}}if(Z){O1.forEach(function(Q1){if(A1.getCompositeAggregationName){var T1=o1.getElementsByTagName(Q1.getMetadata().getCompositeAggregationName());for(var i=0;i<T1.length;i++){o1.removeChild(T1[0]);}}Q1._sapui_declarativeSourceInfo={xmlNode:o1,xmlRootNode:H._sapui_declarativeSourceInfo.xmlRootNode,fragmentName:A1.getName()==='sap.ui.core.Fragment'?t1['fragmentName']:null};});}return j.then(function(){return O1;});});});}function l1(e,j){var o1=F(e,U,Q);e.setAttributeNS(U,o1+":"+j,"true");}function m1(H,p,e){if(p.getAttributeNS(U,"id")){return p.getAttribute("id");}else{return e1(e?e:p.getAttribute("id"));}}function n1(H,p){p.setAttribute("id",e1(p.getAttribute("id")));l1(p,"id");}}
z._preprocessMetadataContexts=null;
z._calculatedModelMapping=function(e,j,p){var H,I={},K=M.bindingParser(e,j);function N(Q){if(Q.length%2===0){throw new Error("The last entry is no binding");}for(var i=1;i<=Q.length;i=i+2){if(typeof Q[i-1]=='string'){throw new Error("Binding expected not a string");}if(Q[i]){if((typeof Q[i]!='string')||(Q[i]!=",")){throw new Error("Missing delimiter ','");}}}}if(K){if(!K.formatter){H=K;K={parts:[H]};}else{N(K.formatter.textFragments);}for(var i=0;i<K.parts.length;i++){H=K.parts[i];I[H.model]=I[H.model]||(p?[]:null);if(Array.isArray(I[H.model])){I[H.model].push(H);}else{I[H.model]=H;}}}return I;};
return z;},true);
sap.ui.predefine('sap/ui/core/_IconRegistry',['sap/ui/thirdparty/URI',"sap/base/i18n/ResourceBundle","sap/base/Log"],function(U,R,L){"use strict";var S='SAP-icons';var I='sap-icon';var f={undefined:{config:{fontFamily:S},metadataLoaded:true,inserted:true}};var r={'undefined':{'accidental-leave':0xe000,'account':0xe001,'wrench':0xe002,'windows-doors':0xe003,'washing-machine':0xe004,'visits':0xe005,'video':0xe006,'travel-expense':0x1e007,'temperature':0xe008,'task':0x1e009,'synchronize':0xe00a,'survey':0x1e00b,'settings':0xe00c,'search':0x1e00d,'sales-document':0x1e00e,'retail-store':0xe00f,'refresh':0xe010,'product':0xe011,'present':0xe012,'ppt-attachment':0xe013,'pool':0xe014,'pie-chart':0xe015,'picture':0xe016,'photo-voltaic':0xe017,'phone':0xe018,'pending':0xe019,'pdf-attachment':0xe01a,'past':0x1e01b,'outgoing-call':0xe01c,'opportunity':0xe01d,'opportunities':0x1e01e,'notes':0xe01f,'money-bills':0x1e020,'map':0xe021,'log':0xe022,'line-charts':0xe023,'lightbulb':0xe024,'leads':0xe025,'lead':0x1e026,'laptop':0xe027,'kpi-managing-my-area':0x1e028,'kpi-corporate-performance':0x1e029,'incoming-call':0xe02a,'inbox':0xe02b,'horizontal-bar-chart':0xe02c,'history':0xe02d,'heating-cooling':0xe02e,'gantt-bars':0xe02f,'future':0x1e030,'fridge':0xe031,'fallback':0xe032,'expense-report':0x1e033,'excel-attachment':0xe034,'energy-saving-lightbulb':0xe035,'employee':0xe036,'email':0xe037,'edit':0xe038,'duplicate':0xe039,'download':0xe03a,'doc-attachment':0xe03b,'dishwasher':0xe03c,'delete':0xe03d,'decline':0xe03e,'complete':0x1e03f,'competitor':0xe040,'collections-management':0xe041,'chalkboard':0x1e042,'cart':0xe043,'card':0xe044,'camera':0xe045,'calendar':0x1e046,'begin':0xe047,'basket':0xe048,'bar-chart':0xe049,'attachment':0xe04a,'arrow-top':0xe04b,'arrow-right':0xe04c,'arrow-left':0xe04d,'arrow-bottom':0xe04e,'approvals':0x1e04f,'appointment':0xe050,'alphabetical-order':0x1e051,'along-stacked-chart':0xe052,'alert':0xe053,'addresses':0xe054,'address-book':0x1e055,'add-filter':0xe056,'add-favorite':0xe057,'add':0xe058,'activities':0x1e059,'action':0xe05a,'accept':0x1e05b,'hint':0x1e05c,'group':0xe05d,'check-availability':0x1e05e,'weather-proofing':0xe05f,'payment-approval':0x1e060,'batch-payments':0x1e061,'bed':0xe062,'arobase':0x1e063,'family-care':0xe064,'favorite':0xe065,'navigation-right-arrow':0xe066,'navigation-left-arrow':0xe067,'e-care':0xe068,'less':0xe069,'lateness':0xe06a,'lab':0xe06b,'internet-browser':0xe06c,'instance':0xe06d,'inspection':0xe06e,'image-viewer':0xe06f,'home':0xe070,'grid':0xe071,'goalseek':0xe072,'general-leave-request':0xe073,'create-leave-request':0xe074,'flight':0xe075,'filter':0xe076,'favorite-list':0xe077,'factory':0xe078,'endoscopy':0xe079,'employee-pane':0xe07a,'employee-approvals':0x1e07b,'email-read':0xe07c,'electrocardiogram':0xe07d,'documents':0xe07e,'decision':0xe07f,'database':0xe080,'customer-history':0xe081,'customer':0xe082,'credit-card':0xe083,'create-entry-time':0xe084,'contacts':0xe085,'compare':0xe086,'clinical-order':0xe087,'chain-link':0xe088,'pull-down':0xe089,'cargo-train':0xe08a,'car-rental':0xe08b,'business-card':0xe08c,'bar-code':0xe08d,'folder-blank':0xe08e,'passenger-train':0xe08f,'question-mark':0x1e090,'world':0xe091,'iphone':0xe092,'ipad':0xe093,'warning':0xe094,'sort':0xe095,'course-book':0xe096,'course-program':0xe097,'add-coursebook':0xe098,'print':0xe099,'save':0xe09a,'play':0x1e09b,'pause':0xe09c,'record':0xe09d,'response':0xe09e,'pushpin-on':0xe09f,'pushpin-off':0xe0a0,'unfavorite':0xe0a1,'learning-assistant':0xe0a2,'timesheet':0xe0a3,'time-entry-request':0xe0a4,'list':0xe0a5,'action-settings':0xe0a6,'share':0xe0a7,'feed':0xe0a8,'role':0xe0a9,'flag':0x1e0aa,'post':0xe0ab,'inspect':0xe0ac,'inspect-down':0xe0ad,'appointment-2':0xe0ae,'target-group':0xe0af,'marketing-campaign':0xe0b0,'notification':0xe0b1,'message-error':0xe0b1,'comment':0xe0b2,'shipping-status':0xe0b3,'collaborate':0xe0b4,'shortcut':0xe0b5,'lead-outdated':0x1e0b6,'tools-opportunity':0xe0b7,'permission':0xe0b8,'supplier':0xe0b9,'table-view':0xe0ba,'table-chart':0xe0bb,'switch-views':0xe0bc,'e-learning':0xe0bd,'manager':0xe0be,'switch-classes':0xe0bf,'simple-payment':0x1e0c0,'signature':0xe0c1,'sales-order-item':0x1e0c2,'sales-order':0x1e0c3,'request':0xe0c4,'receipt':0xe0c5,'puzzle':0xe0c6,'process':0xe0c7,'private':0xe0c8,'popup-window':0xe0c9,'person-placeholder':0xe0ca,'per-diem':0x1e0cb,'paper-plane':0xe0cc,'paid-leave':0x1e0cd,'pdf-reader':0x1e0ce,'overview-chart':0xe0cf,'overlay':0xe0d0,'org-chart':0xe0d1,'number-sign':0xe0d2,'notification-2':0xe0d3,'my-sales-order':0x1e0d4,'meal':0xe0d5,'loan':0x1e0d6,'order-status':0x1e0d7,'customer-order-entry':0x1e0d8,'performance':0xe0d9,'menu':0xe0da,'employee-lookup':0xe0db,'education':0xe0dc,'customer-briefing':0xe0dd,'customer-and-contacts':0xe0de,'my-view':0xe0df,'accelerated':0xe0e0,'to-be-reviewed':0xe0e1,'warning2':0xe0e2,'feeder-arrow':0xe0e3,'quality-issue':0xe0e4,'workflow-tasks':0xe0e5,'create':0xe0e6,'home-share':0xe0e7,'globe':0x1e0e8,'tags':0xe0e9,'work-history':0xe0ea,'x-ray':0xe0eb,'wounds-doc':0xe0ec,'web-cam':0xe0ed,'waiver':0x1e0ee,'vertical-bar-chart':0xe0ef,'upstacked-chart':0xe0f0,'trip-report':0xe0f1,'microphone':0xe0f2,'unpaid-leave':0x1e0f3,'tree':0xe0f4,'toaster-up':0xe0f5,'toaster-top':0xe0f6,'toaster-down':0xe0f7,'time-account':0xe0f8,'theater':0xe0f9,'taxi':0xe0fa,'subway-train':0xe0fb,'study-leave':0xe0fc,'stethoscope':0xe0fd,'step':0xe0fe,'sonography':0xe0ff,'soccor':0xe100,'soccer':0xe100,'physical-activity':0xe101,'pharmacy':0xe102,'official-service':0xe103,'offsite-work':0xe104,'nutrition-activity':0xe105,'newspaper':0xe106,'monitor-payments':0x1e107,'map-2':0xe108,'machine':0xe109,'mri-scan':0xe10a,'end-user-experience-monitoring':0xe10b,'unwired':0xe10c,'customer-financial-fact-sheet':0x1e10d,'retail-store-manager':0xe10e,'Netweaver-business-client':0xe10f,'electronic-medical-record':0xe110,'eam-work-order':0x1e111,'customer-view':0xe112,'crm-service-manager':0xe113,'crm-sales':0x1e114,'widgets':0x1e115,'commission-check':0x1e116,'collections-insight':0x1e117,'clinical-tast-tracker':0xe118,'citizen-connect':0xe119,'cart-approval':0x1e11a,'capital-projects':0x1e11b,'bo-strategy-management':0xe11c,'business-objects-mobile':0xe11d,'business-objects-explorer':0xe11e,'business-objects-experience':0xe11f,'bbyd-dashboard':0xe120,'bbyd-active-sales':0x1e121,'business-by-design':0x1e122,'business-one':0x1e123,'sap-box':0xe124,'manager-insight':0xe125,'accounting-document-verification':0x1e126,'hr-approval':0x1e127,'idea-wall':0xe128,'Chart-Tree-Map':0xe129,'cart-5':0xe12a,'cart-4':0xe12b,'wallet':0xe12c,'vehicle-repair':0xe12d,'upload':0xe12e,'unlocked':0xe12f,'umbrella':0xe130,'travel-request':0x1e131,'travel-expense-report':0x1e132,'travel-itinerary':0xe133,'time-overtime':0x1e134,'thing-type':0xe135,'technical-object':0xe136,'tag':0xe137,'syringe':0xe138,'syntax':0xe139,'suitcase':0xe13a,'simulate':0xe13b,'shield':0xe13c,'share-2':0xe13d,'sales-quote':0x1e13e,'repost':0xe13f,'provision':0xe140,'projector':0xe141,'add-product':0xe142,'pipeline-analysis':0xe143,'add-photo':0xe144,'palette':0xe145,'nurse':0xe146,'sales-notification':0x1e147,'mileage':0xe148,'meeting-room':0xe149,'media-forward':0x1e14a,'media-play':0x1e14b,'media-pause':0xe14c,'media-reverse':0x1e14d,'media-rewind':0x1e14e,'measurement-document':0xe14f,'measuring-point':0xe150,'measure':0xe151,'map-3':0xe152,'locked':0xe153,'letter':0xe154,'journey-arrive':0xe155,'journey-change':0xe156,'journey-depart':0xe157,'it-system':0xe158,'it-instance':0xe159,'it-host':0xe15a,'iphone-2':0xe15b,'ipad-2':0xe15c,'inventory':0xe15d,'insurance-house':0xe15e,'insurance-life':0xe15f,'insurance-car':0xe160,'initiative':0xe161,'incident':0x1e162,'group-2':0xe163,'goal':0xe164,'functional-location':0xe165,'full-screen':0xe166,'form':0xe167,'fob-watch':0xe168,'blank-tag':0xe169,'family-protection':0xe16a,'folder':0xe16b,'fax-machine':0xe16c,'example':0xe16d,'eraser':0xe16e,'employee-rejections':0xe16f,'drop-down-list':0xe170,'draw-rectangle':0xe171,'document':0xe172,'doctor':0xe173,'discussion-2':0xe174,'discussion':0xe175,'dimension':0xe176,'customer-and-supplier':0xe177,'crop':0xe178,'add-contact':0xe179,'compare-2':0xe17a,'color-fill':0xe17b,'collision':0xe17c,'curriculum':0xe17d,'chart-axis':0xe17e,'full-stacked-chart':0xe17f,'full-stacked-column-chart':0xe180,'vertical-bar-chart-2':0xe181,'horizontal-bar-chart-2':0xe182,'horizontal-stacked-chart':0xe183,'vertical-stacked-chart':0xe184,'choropleth-chart':0x1e185,'geographic-bubble-chart':0x1e186,'multiple-radar-chart':0xe187,'radar-chart':0xe188,'crossed-line-chart':0xe189,'multiple-line-chart':0xe18a,'multiple-bar-chart':0xe18b,'line-chart':0xe18c,'line-chart-dual-axis':0xe18d,'bubble-chart':0xe18e,'scatter-chart':0xe18f,'multiple-pie-chart':0xe190,'column-chart-dual-axis':0xe191,'tag-cloud-chart':0xe192,'area-chart':0xe193,'cause':0xe194,'cart-3':0xe195,'cart-2':0xe196,'bus-public-transport':0xe197,'burglary':0xe198,'building':0xe199,'border':0xe19a,'bookmark':0xe19b,'badge':0xe19c,'attachment-audio':0xe19d,'attachment-video':0xe19e,'attachment-html':0xe19f,'attachment-photo':0xe1a0,'attachment-e-pub':0xe1a1,'attachment-zip-file':0xe1a2,'attachment-text-file':0xe1a3,'add-equipment':0xe1a4,'add-activity':0x1e1a5,'activity-individual':0xe1a6,'activity-2':0x1e1a7,'add-activity-2':0x1e1a8,'activity-items':0xe1a9,'activity-assigned-to-goal':0xe1aa,'status-completed':0xe1ab,'status-positive':0xe1ab,'status-error':0xe1ac,'status-negative':0xe1ac,'status-inactive':0xe1ad,'status-in-process':0xe1ae,'status-critical':0xe1ae,'blank-tag-2':0xe1af,'cart-full':0xe1b0,'locate-me':0xe1b1,'paging':0xe1b2,'company-view':0xe1b3,'document-text':0xe1b4,'explorer':0xe1b5,'personnel-view':0xe1b6,'sorting-ranking':0xe1b7,'drill-down':0xe1b8,'drill-up':0xe1b9,'vds-file':0xe1ba,'sap-logo-shape':0x1e1bb,'folder-full':0xe1bc,'system-exit':0xe1bd,'system-exit-2':0xe1be,'close-command-field':0xe1bf,'open-command-field':0xe1c0,'sys-enter-2':0x1e1c1,'sys-enter':0x1e1c2,'sys-help-2':0x1e1c3,'sys-help':0x1e1c4,'sys-back':0xe1c5,'sys-back-2':0xe1c6,'sys-cancel':0xe1c7,'sys-cancel-2':0xe1c8,'open-folder':0xe1c9,'sys-find-next':0xe1ca,'sys-find':0xe1cb,'sys-monitor':0xe1cc,'sys-prev-page':0xe1cd,'sys-first-page':0xe1ce,'sys-next-page':0xe1cf,'sys-last-page':0xe1d0,'generate-shortcut':0xe1d1,'create-session':0xe1d2,'display-more':0xe1d3,'enter-more':0xe1d4,'zoom-in':0xe1d5,'zoom-out':0xe1d6,'header':0xe1d7,'detail-view':0xe1d8,'show-edit':0xe1d8,'collapse':0xe1d9,'expand':0xe1da,'positive':0xe1db,'negative':0xe1dc,'display':0xe1dd,'menu2':0xe1de,'redo':0xe1df,'undo':0xe1e0,'navigation-up-arrow':0xe1e1,'navigation-down-arrow':0xe1e2,'down':0xe1e3,'up':0xe1e4,'shelf':0xe1e5,'background':0xe1e6,'resize':0xe1e7,'move':0xe1e8,'show':0xe1e9,'hide':0xe1ea,'nav-back':0xe1eb,'error':0xe1ec,'slim-arrow-right':0xe1ed,'slim-arrow-left':0xe1ee,'slim-arrow-down':0xe1ef,'slim-arrow-up':0xe1f0,'forward':0xe1f1,'overflow':0xe1f2,'value-help':0xe1f3,'multi-select':0x1e1f4,'exit-full-screen':0xe1f5,'sys-add':0xe1f6,'sys-minus':0xe1f7,'dropdown':0xe1f8,'expand-group':0xe1f9,'collapse-group':0xe200,'vertical-grip':0xe1fa,'horizontal-grip':0xe1fb,'sort-descending':0xe1fc,'sort-ascending':0xe1fd,'arrow-down':0xe1fe,'legend':0xe1ff,'message-warning':0xe201,'message-information':0x1e202,'message-success':0x1e203,'restart':0xe204,'stop':0xe205,'add-process':0xe206,'cancel-maintenance':0xe207,'activate':0xe208,'resize-horizontal':0xe209,'resize-vertical':0xe20a,'connected':0xe20b,'disconnected':0xe20c,'edit-outside':0xe20d,'key':0xe20e,'minimize':0xe20f,'back-to-top':0xe210,'hello-world':0xe211,'outbox':0xe212,'donut-chart':0xe213,'heatmap-chart':0xe214,'horizontal-bullet-chart':0xe215,'vertical-bullet-chart':0xe216,'call':0xe217,'download-from-cloud':0xe218,'upload-to-cloud':0xe219,'jam':0xe21a,'sap-ui5':0xe21b,'message-popup':0xe21c,'cloud':0xe21d,'horizontal-waterfall-chart':0x1e21e,'vertical-waterfall-chart':0x1e21f,'broken-link':0xe220,'headset':0xe221,'thumb-up':0x1e222,'thumb-down':0x1e223,'multiselect-all':0x1e224,'multiselect-none':0x1e225,'scissors':0xe226,'sound':0x1e227,'sound-loud':0x1e228,'sound-off':0x1e229,'date-time':0x1e22a,'user-settings':0xe22b,'key-user-settings':0xe22c,'developer-settings':0xe22d,'text-formatting':0x1e22e,'bold-text':0x1e22f,'italic-text':0x1e230,'underline-text':0x1e231,'text-align-justified':0x1e232,'text-align-left':0x1e233,'text-align-center':0x1e234,'text-align-right':0x1e235,'bullet-text':0x1e236,'numbered-text':0x1e237,'co':0xe238,'ui-notifications':0xe239,'bell':0xe23a,'cancel-share':0xe23b,'write-new-document':0xe23c,'write-new':0xe23d,'cancel':0x1e23e,'screen-split-one':0xe23f,'screen-split-two':0xe240,'screen-split-three':0xe241,'customize':0xe242,'user-edit':0xe243,'source-code':0xe244,'copy':0xe245,'paste':0xe246,'line-chart-time-axis':0x1e247,'clear-filter':0xe248,'reset':0xe249,'trend-up':0xe24a,'trend-down':0xe24b,'cursor-arrow':0xe24c,'add-document':0xe24d,'create-form':0xe24e,'resize-corner':0xe24f,'chevron-phase':0xe250,'chevron-phase-2':0xe251,'rhombus-milestone':0xe252,'rhombus-milestone-2':0xe253,'circle-task':0xe254,'circle-task-2':0xe255,'project-definition-triangle':0xe256,'project-definition-triangle-2':0xe257,'master-task-triangle':0xe258,'master-task-triangle-2':0xe259,'program-triangles':0xe25a,'program-triangles-2':0xe25b,'mirrored-task-circle':0xe25c,'mirrored-task-circle-2':0xe25d,'checklist-item':0xe25e,'checklist-item-2':0xe25f,'checklist':0xe260,'checklist-2':0xe261,'chart-table-view':0xe262,'filter-analytics':0xe263,'filter-facets':0xe264,'filter-fields':0xe265,'indent':0xe266,'outdent':0xe267,'heading1':0x1e268,'heading2':0x1e269,'heading3':0x1e26a,'decrease-line-height':0xe26b,'increase-line-height':0xe26c,'fx':0x1e26d,'add-folder':0xe26e,'away':0xe26f,'busy':0xe270,'appear-offline':0xe271,'blur':0xe272,'pixelate':0xe273,'horizontal-combination-chart':0xe274,'add-employee':0xe275,'text-color':0x1e276,'browse-folder':0xe277,'primary-key':0xe278,'two-keys':0xe279,'strikethrough':0xe27a,'text':0xe27b,'responsive':0xe27c,'desktop-mobile':0xe27d,'table-row':0xe27e,'table-column':0xe27f,'validate':0x1e280,'keyboard-and-mouse':0xe281,'touch':0xe282,'expand-all':0xe283,'collapse-all':0xe284,'combine':0xe285,'split':0xe286,'megamenu':0xe287,'feedback':0xe288,'information':0xe289,'s4hana':0x1e28a,'translate':0x1e28b,'clear-all':0xe28c,'command-line-interfaces':0xe28d,'sum':0x1e28e,'qr-code':0x1e28f,'space-navigation':0xe290,'in-progress':0x1e291,'not-editable':0xe292}};var c;
function g(){if(!c){c=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core");}return c;}
var _={sapIconFontFamily:S};
_.get=function(){return r;};
_.getFontRegistry=function(){return f;};
_.addIcon=function(i,a,b){if(typeof b==="string"){b={fontFamily:arguments[2],content:arguments[3],overWrite:!!arguments[4],suppressMirroring:!!arguments[5]};}if(typeof a!=="string"){a=String(a);}a=a==='undefined'?undefined:a;if(!r[a]){r[a]={};}var d=r[a],e=d[i],p,C,t,k;if(e){if(a===undefined){L.warning("Icon with name '"+i+"' in built-in collection already exists and can not be overwritten.","sap.ui.core.IconPool");return;}else if(!b.overWrite){L.warning("Icon with name '"+i+"' in collection '"+a+"' already exists. Specify 'iconInfo.overWrite' in order to overwrite.","sap.ui.core.IconPool");return;}}p={protocol:I,hostname:a||i,path:a?i:undefined};if(Array.isArray(b.content)){C=b.content.map(m).join('');}else{C=m(b.content);}if(b.resourceBundle instanceof R){k="Icon."+i;if(b.resourceBundle.hasText(k)){t=b.resourceBundle.getText(k);}}e=d[i]={name:i,collection:a,uri:U.build(p),fontFamily:b.fontFamily,content:C,text:t||'',suppressMirroring:b.suppressMirroring,skipMirroring:b.suppressMirroring};return e;};
_.getIconURI=function(i,a){var b=this.getIconInfo(i,a);return b&&b.uri;};
_.getIconInfo=function(i,a,l){var p,b,d,o,n=_.isIconURI(i);if(!i){return;}if(!l&&n){l=a;}l=l||"sync";d=(l==="async"||l==="mixed");function e(){var h=r[a];var b=h&&h[i];if(typeof b==='number'){r[a][i]=undefined;b=_.addIcon(i,a,{fontFamily:f[a].config.fontFamily,content:b&0xFFFF,suppressMirroring:!!(b&0x10000),resourceBundle:g()});}return b;}if(n){p=U.parse(i);if(p.path.length===1){a=undefined;i=p.hostname;}else{a=p.hostname;i=p.path.slice(1);}if(!i){return;}}if(typeof a!=="string"){a=String(a);}a=a==='undefined'?undefined:a;b=e();if(b===undefined&&a!==undefined){o=_._loadFontMetadata(a,d);}if(d){if(o){return o.then(function(){b=e();if(!b){L.warning("Icon info for icon '"+i+"' in collection '"+a+"' could not be fetched");}return b;});}else if(l==="async"){return Promise.resolve(b);}else{b=e();}}else{b=e();}if(!b){L.warning("Icon info for icon '"+i+"' in collection '"+a+"' could not be fetched");}return b;};
_.isIconURI=function(u){if(!u){return false;}var p=U.parse(u);return p.protocol===I&&!!p.hostname;};
_.getIconCollectionNames=function(){return Object.keys(r);};
_.getIconNames=function(a){var b=r[a];return b?Object.keys(b):[];};
_.insertFontFaceStyle=function(F,p,C){var o,f=_.getFontRegistry();function a(u){return _._convertUrl?_._convertUrl(u):u;}if(arguments.length===0||F===S){L.info("It's not needed to call IconPool.insertFontFaceStyle to insert font-face for the predefined icon font SAP-icons because the font-face is included in the library.css of sap.ui.core");return;}if(F&&p===undefined){L.error("IconPool.insertFontFaceStyle must be called with at least two parameters!");return;}if(C===undefined){C=F;}if(!f[C]){L.error("Icon font '"+C+"' has not been registered yet.");return;}if(f[C].inserted){L.info("The font face style of icon font '"+C+"' was already inserted.");return;}o=new FontFace(F,"url("+a(p+F+".woff2")+") format('woff2'),"+"local("+F+")",{weight:"normal",style:"normal"});document.fonts.add(o);o.load();f[C].inserted=true;f[C].fontFace=F;};
_._loadFontMetadata=function(a,b){var C,r=_.get(),f=_.getFontRegistry();if(f[a]){if(typeof f[a].metadataLoaded==="boolean"){return;}if(b&&f[a].metadataLoaded instanceof Promise){return f[a].metadataLoaded;}C=f[a].config;}else{if(!r[a]){L.error("The font configuration for collection '"+a+"' is not registered");}f[a]={metadataLoaded:false};}function l(F){for(var k in F){F[k]=parseInt(F[k],16);}r[a]=F;_.insertFontFaceStyle(C.fontFamily,C.fontURI,a);f[a].metadataLoaded=true;}if(C){if(C.metadataURI===undefined){C.metadataURI=C.fontURI+C.fontFamily+".json";}if(b&&!C.metadata){if(f[a].metadataLoaded instanceof Promise){return f[a].metadataLoaded;}var p=new Promise(function(d){if(r[a]===undefined){f[a].metadataLoadedResolve=d;f[a].metadataXhr=jQuery.ajax(C.metadataURI,{dataType:"json",success:function(j){l(j);delete f[a].metadataXhr;delete f[a].metadataLoadedResolve;d();},error:function(j,s){if(s!=="abort"){L.error("An error occurred loading the font metadata for collection '"+a+"'");f[a].metadataLoaded=false;d();}}});}});f[a].metadataLoaded=p;return p;}else if(C.metadataURI){if(f[a].metadataXhr){f[a].metadataXhr.abort("Replaced by sync request");f[a].metadataXhr=null;}L.warning("Synchronous loading of font meta data in IconPool, due to .getIconInfo() call"+" for '"+a+"'. Use loading mode 'async' to avoid this call.","SyncXHR",null,function(){return{type:"SyncXHR",name:"IconPool"};});jQuery.ajax(C.metadataURI,{dataType:"json",async:false,success:function(j){l(j);if(f[a].metadataLoadedResolve){f[a].metadataLoadedResolve();delete f[a].metadataLoadedResolve;}},error:function(){if(f[a].metadataLoadedResolve){f[a].metadataLoadedResolve();delete f[a].metadataLoadedResolve;}L.error("An error occurred loading the font metadata for collection '"+a+"'");f[a].metadataLoaded=false;}});}else{l(C.metadata);}}};
function m(a){return String.fromCharCode(typeof a==='number'?a:parseInt(a,16));}
return _;});
sap.ui.predefine('sap/ui/core/cache/CacheManager',['./LRUPersistentCache','./CacheManagerNOP','sap/ui/Device',"sap/base/Log","sap/ui/performance/Measurement",'sap/ui/performance/trace/Interaction'],function(L,C,D,a,M,I){"use strict";var b={_instance:null,_getInstance:function(){var p,o=d("_getInstance"),t=this;p=new Promise(function(r,e){var f;a.debug("Cache Manager: Initialization...");if(!b._instance){f=t._findImplementation();M.start(c,"CM",S);f.init().then(g,e);M.end(c,"CM");}else{g(b._instance);}function g(h){b._instance=h;o.endAsync();a.debug("Cache Manager initialized with implementation ["+b._instance.name+"], resolving _getInstance promise");r(h);}});o.endSync();return p;},_findImplementation:function(){if(i()&&this._isSupportedEnvironment()){return L;}else{a.warning("UI5 Cache Manager is switched off");return C;}},set:function(k,v){var p,o=d("set",k);a.debug("Cache Manager: Setting value of type["+typeof v+"] with key ["+k+"]");p=this._callInstanceMethod("set",arguments).then(function e(){a.debug("Cache Manager: Setting key ["+k+"] completed successfully");o.endAsync();},function(e){a.error("Cache Manager: Setting key ["+k+"] failed. Error:"+e);o.endAsync();throw e;});o.endSync();return p;},get:function(k){var p,f=I.notifyAsyncStep(),o=d("get",k);a.debug("Cache Manager: Getting key ["+k+"]");p=this._callInstanceMethod("get",arguments).then(function e(v){a.debug("Cache Manager: Getting key ["+k+"] done");o.endAsync();return v;},function(e){a.debug("Cache Manager: Getting key ["+k+"] failed. Error: "+e);o.endAsync();throw e;}).finally(f);o.endSync();return p;},has:function(k){var p,o=d("has",k);a.debug("Cache Manager: has key ["+k+"] called");p=this._callInstanceMethod("has",arguments).then(function e(r){o.endAsync();a.debug("Cache Manager: has key ["+k+"] returned "+r);return r;});o.endSync();return p;},del:function(k){var p,o=d("del",k);a.debug("Cache Manager: del called.");p=this._callInstanceMethod("del",arguments).then(function e(){a.debug("Cache Manager: del completed successfully.");o.endAsync();},function(e){a.debug("Cache Manager: del failed. Error: "+e);o.endAsync();throw e;});o.endSync();return p;},reset:function(){var p,o=d("reset");a.debug("Cache Manager: Reset called.");p=this._callInstanceMethod("reset",arguments).then(function e(){a.debug("Cache Manager: Reset completed successfully.");o.endAsync();},function(e){a.debug("Cache Manager: Reset failed. Error: "+e);o.endAsync();throw e;});o.endSync();return p;},_switchOff:function(){var t=this;return Promise.resolve().then(function(){s(t);sap.ui.getCore().getConfiguration().setUI5CacheOn(false);});},_switchOn:function(){var t=this;return Promise.resolve().then(function(){var o=sap.ui.getCore().getConfiguration();if(!o.isUI5CacheOn()){s(t);sap.ui.getCore().getConfiguration().setUI5CacheOn(true);}return Promise.resolve();});},_callInstanceMethod:function(e,A){var p,f="[sync ] _callInstanceMethod";M.start(f,"CM",S);if(this._instance){a.debug("Cache Manager: calling instance...");return this._instance[e].apply(this._instance,A);}a.debug("Cache Manager: getting instance...");p=this._getInstance().then(function h(g){return g[e].apply(g,A);});M.end(f);return p;},_isSupportedEnvironment:function(){var e=[];if(this._bSupportedEnvironment==undefined){e.push({system:D.system.SYSTEMTYPE.DESKTOP,browserName:D.browser.BROWSER.CHROME,browserVersion:49});e.push({system:D.system.SYSTEMTYPE.DESKTOP,browserName:D.browser.BROWSER.SAFARI,browserVersion:13});e.push({system:D.system.SYSTEMTYPE.TABLET,browserName:D.browser.BROWSER.SAFARI,browserVersion:13});e.push({system:D.system.SYSTEMTYPE.PHONE,browserName:D.browser.BROWSER.SAFARI,browserVersion:13});e.push({system:D.system.SYSTEMTYPE.TABLET,os:D.os.OS.ANDROID,browserName:D.browser.BROWSER.CHROME,browserVersion:80});e.push({system:D.system.SYSTEMTYPE.PHONE,os:D.os.OS.ANDROID,browserName:D.browser.BROWSER.CHROME,browserVersion:80});this._bSupportedEnvironment=e.some(function(o){var f=D.system[o.system],g=o.os?o.os===D.os.name:true,h=o.browserName===D.browser.name,j=D.browser.version>=o.browserVersion;try{return f&&g&&h&&j&&window.indexedDB;}catch(k){return false;}});}return this._bSupportedEnvironment;}};var S="CacheManager",c="[sync ] _initImplementation",m=0;
function i(){return sap.ui.getCore().getConfiguration().isUI5CacheOn();}
function s(e){if(e._instance){e._instance._destroy();e._instance=null;}}
function d(o,k){m++;var e="[async]  "+o+"["+k+"]- #"+(m),f="[sync ]  "+o+"["+k+"]- #"+(m);M.start(e,"CM",[S,o]);M.start(f,"CM",[S,o]);return{sMeasureAsync:e,sMeasureSync:f,endAsync:function(){M.end(this.sMeasureAsync);},endSync:function(){M.end(this.sMeasureSync);}};}
return b;});
sap.ui.predefine('sap/ui/core/cache/CacheManagerNOP',[],function(){"use strict";var C={name:"CacheManagerNOP",set:function(){return Promise.resolve();},get:function(){return Promise.resolve(undefined);},has:function(){return Promise.resolve(false);},del:function(){return Promise.resolve();},reset:function(){return Promise.resolve();},init:function(){return Promise.resolve(this);},_db:{close:function(){}},_getCount:function(){return Promise.resolve(0);},_destroy:function(){}};return C;});
sap.ui.predefine('sap/ui/core/cache/LRUPersistentCache',["sap/base/Log","sap/ui/performance/Measurement"],function(L,M){"use strict";var a={name:"LRUPersistentCache",defaultOptions:{databaseName:"ui5-cachemanager-db",_contentStoreName:"content-store",_metadataStoreName:"metadata-store",_metadataKey:"metadataKey"},_db:{},init:function(){this._metadata={};this._mru=-1;this._lru=-1;return l(this);},_destroy:function(){if(this._db.close){this._db.close();}this._metadata=null;this._ui5version=null;},set:function(e,i){if(E(e)){L.warning("Cache Manager ignored 'set' for key ["+e+"]");return Promise.resolve();}if(e==null){return Promise.reject("Cache Manager does not accept undefined or null as key");}if(typeof i==="undefined"){return Promise.reject("Cache Manager does not accept undefined as value");}L.debug("Cache Manager LRUPersistentCache: adding item with key ["+e+"]...");var p=this,H="[sync ] fnSet: total[sync]  key ["+e+"]",J="[sync ] fnSet: txStart[sync]  key ["+e+"]",K="[sync ] fnSet: storeOpen[sync]  key ["+e+"]",N="[sync ] fnSet: putContent[sync]  key ["+e+"]",O="[sync ] fnSet: putMetadata[sync]  key ["+e+"]",P="[sync ] fnSet: serialize[sync]  key ["+e+"]";return new Promise(function Y(Q,R){M.start(H,"CM",s);var S,T,U,V,W;W=q(p._metadata);V=new n(e,i,typeof i,++p._mru,P,s).serialize();M.start(J,"CM",s);var X=p._db.transaction([p.defaultOptions._contentStoreName,p.defaultOptions._metadataStoreName],"readwrite");M.end(J);X.onerror=function(Z){var $="Cache Manager cannot complete add/put transaction for entry with key: "+V.oData.key+". Details: "+B(Z);L.error($);p._metadata=W;r(p);R($);};X.onabort=function(Z){p._metadata=W;r(p);var $=t(p);if(y(Z)&&$>0){L.warning("Cache Manager is trying to free some space to add/put new item");x(p,e,i).then(function(){L.debug("Cache Manager LRUPersistentCache: set completed after freeing space. ItemCount changed from "+$+" to "+t(p));Q();},function(a1){var b1="Cache Manager LRUPersistentCache: set unsuccessful. Cannot free space to add/put entry. Details: "+a1;L.error(b1);R(b1);});}else{var _="Cache Manager LRUPersistentCache: set failed: "+B(Z);L.error(_);R(_);}};X.oncomplete=function(){L.debug("Cache Manager LRUPersistentCache: adding item with key ["+e+"]... done");Q();};M.start(K,"CM",s);S=X.objectStore(p.defaultOptions._contentStoreName);U=X.objectStore(p.defaultOptions._metadataStoreName);M.end(K);M.start(N,"CM",s);T=S.put(V.oData,V.oData.key);M.end(N);M.end(H);T.onsuccess=function(){u(p,V);M.start(O,"CM",s);U.put(p._metadata,p.defaultOptions._metadataKey);M.end(O);};if(L.getLevel()>=L.Level.DEBUG){L.debug("Cache Manager LRUPersistentCache: measurements: "+H+": "+M.getMeasurement(H).duration+"; "+P+": "+M.getMeasurement(P).duration+"; "+J+": "+M.getMeasurement(J).duration+"; "+K+": "+M.getMeasurement(K).duration+"; "+N+": "+M.getMeasurement(N).duration+"; "+O+": "+M.getMeasurement(O).duration);}});},has:function(e){if(E(e)){L.warning("Cache Manager ignored 'has' for key ["+e+"]");return Promise.resolve(false);}return this.get(e).then(function(i){return typeof i!=="undefined";});},_getCount:function(){return Promise.resolve(t(this));},_getAll:function(e){var i=this,p,H="[sync ] _getAll: deserialize";return new Promise(function(J,K){var N=[],O=i._db.transaction([i.defaultOptions._contentStoreName],"readonly"),P=O.objectStore(i.defaultOptions._contentStoreName);O.onerror=function(Q){K(B(Q));};O.oncomplete=function(Q){J(N);};P.openCursor().onsuccess=function(Q){var R=Q.target.result;if(R&&R.value){p=new n(R.value,H,m).deserialize();N.push({key:p.oData.key,value:p.oData.value});R.continue();}};});},_loadMetaStructure:function(){var i=this;return new Promise(function(p,H){var J=i._db.transaction([i.defaultOptions._metadataStoreName],"readonly");J.onerror=function(O){if(!J.errorHandled){J.errorHandled=true;var P="Cache Manager cannot complete transaction for read metadata. Details: "+J.error;L.error(P);H(P);}};var K=J.objectStore(i.defaultOptions._metadataStoreName);try{var N=K.get(i.defaultOptions._metadataKey);N.onsuccess=function(O){i._metadata=N.result?N.result:o(i._ui5version);if(i._metadata.__ui5version!==i._ui5version){i.reset().then(p,function(e){L.error("Cannot reset the cache. Details:"+e);J.abort();});}else{p();}};N.onerror=function(O){L.error("Cache Manager cannot complete transaction for read metadata items. Details: "+O.message);H(O.message);};}catch(e){L.error("Cache Manager cannot read metadata entries behind key: "+i.defaultOptions._metadataKey+". Details: "+e.message);H(e.message);}});},get:function(e){if(E(e)){L.warning("Cache Manager ignored 'get' for key ["+e+"]");return Promise.resolve();}return g(this,e);},del:function(e){if(E(e)){L.warning("Cache Manager ignored 'del' for key ["+e+"]");return Promise.resolve();}return d(this,e);},reset:function(){var i=this;return new Promise(function(p,H){var J,K,N,O,P;P=i._db.transaction([i.defaultOptions._contentStoreName,i.defaultOptions._metadataStoreName],"readwrite");P.onerror=P.onabort=function(Q){if(!P.errorHandled){P.errorHandled=true;var R="Cache Manager LRUPersistentCache: transaction for reset() failed. Details: "+P.error;L.error(R);H(R);}};P.oncomplete=function(Q){p();};J=P.objectStore(i.defaultOptions._contentStoreName);K=P.objectStore(i.defaultOptions._metadataStoreName);try{N=J.clear();N.onerror=function(){P.abort();};N.onsuccess=function(){O=K.clear();O.onerror=function(){P.abort();};O.onsuccess=function(){i._metadata=o(sap.ui.version);r(i);};};}catch(e){P.abort();}});}};var m="LRUPersistentCache,get",s="LRUPersistentCache,set",b=0;
function c(i){var p=i._db.transaction([i.defaultOptions._contentStoreName,i.defaultOptions._metadataStoreName],"readwrite");p.onerror=p.onabort=function(H){L.warning("Cache Manager cannot persist the information about usage of an entry. This may lead to earlier removal of the entry if browser storage space is over. Details: "+p.error);};try{p.objectStore(i.defaultOptions._metadataStoreName).put(i._metadata,i.defaultOptions._metadataKey);}catch(e){L.warning("Cache Manager cannot persist the information about usage of an entry. This may lead to earlier removal of the entry if browser storage space is over. Details: "+e.message);}}
function d(e,i){return new Promise(function(p,H){var J,K;J=e._db.transaction([e.defaultOptions._contentStoreName,e.defaultOptions._metadataStoreName],"readwrite");K=q(e._metadata);function N(P){e._metadata=K;r(e);var Q="Cache Manager LRUPersistentCache: cannot delete item with key: "+i+". Details: "+B(P);L.error(Q);H(Q);}J.onerror=N;J.onabort=N;J.oncomplete=function(){if(t(e)===0){e._lru=-1;e._mru=-1;e._metadata=o(e._ui5version);}L.debug("Cache Manager LRUPersistentCache: item with key "+i+" deleted");p();};L.debug("Cache Manager LRUPersistentCache: deleting item ["+i+"]");var O=J.objectStore(e.defaultOptions._contentStoreName).delete(i);O.onsuccess=function(){L.debug("Cache Manager LRUPersistentCache: request for deleting item ["+i+"] is successful, updating metadata...");z(e,i);J.objectStore(e.defaultOptions._metadataStoreName).put(e._metadata,e.defaultOptions._metadataKey);};});}
function g(i,H){if(i.getCounter===undefined){i.getCounter=0;}i.getCounter++;var J="[sync ] fnGet"+i.getCounter+": total[sync]  key ["+H+"]",K="[sync ] fnGet"+i.getCounter+": txStart[sync]  key ["+H+"]",N="[sync ] fnGet"+i.getCounter+": storeOpen[sync]  key ["+H+"]",O="[sync ] fnGet"+i.getCounter+": access result[sync]  key ["+H+"]",P="[sync ] fnGet"+i.getCounter+": putMetadata[sync]  key ["+H+"]",Q="[sync ] fnGet"+i.getCounter+": deserialize[sync]  key ["+H+"]",R="[sync ]  _instance.get",S="[sync ]  getRequest.onSuccess";L.debug("Cache Manager LRUPersistentCache: get for key ["+H+"]...");M.start(R,"CM",m);var p=new Promise(function Z(T,U){var V,W,X,Y;M.start(J,"CM",m);M.start(K,"CM",m);W=i._db.transaction([i.defaultOptions._contentStoreName,i.defaultOptions._metadataStoreName],"readwrite");M.end(K);W.onerror=function($){var _="Cache Manager cannot complete delete transaction for entry with key: "+H+". Details: "+W.error;L.error(_);U(_);};try{M.start(N,"CM",m);X=W.objectStore(i.defaultOptions._contentStoreName).get(H);M.end(N);X.onsuccess=function($){M.start(S,"CM",m);M.start(O,"CM",m);Y=new n(X.result,Q,m);M.end(O);G("Cache Manager LRUPersistentCache: accessing the result",H,O);if(Y.oData){M.start(P,"CM",m);if(Y.oData.lu!==i._mru){Y.oData.lu=++i._mru;u(i,Y);c(i);}M.end(P);V=Y.deserialize().oData.value;}M.end(S);L.debug("Cache Manager LRUPersistentCache: get for key ["+H+"]...done");T(V);};X.onerror=function($){L.error("Cache Manager cannot get entry with key: "+H+". Details: "+$.message);U($.message);};}catch(e){L.error("Cache Manager cannot get entry with key: "+H+". Details: "+e.message);U(e.message);return;}M.end(J);});M.end(R);return p;}
function f(e){var K=v(e);if(K==undefined){var i="Cache Manager LRUPersistentCache: deleteItemAndUpdateMetadata cannot find item to delete";L.debug(i);return Promise.reject(i);}return j(e,K).then(function(){return Promise.resolve().then(function(){z(e,K);return h(e).then(function(){return K;},function(){L.warning("Cache Manager LRUPersistentCache: Free space algorithm deleted item "+"but the metadata changes could not be persisted. This won't break the functionality.");return K;});});});}
function h(i){return new Promise(function(p,H){try{var J=i._db.transaction([i.defaultOptions._contentStoreName,i.defaultOptions._metadataStoreName],"readwrite");J.onerror=K;J.onabort=K;J.oncomplete=function(){L.debug("Cache Manager LRUPersistentCache: persistMetadata - metadata was successfully updated");p();};J.objectStore(i.defaultOptions._metadataStoreName).put(i._metadata,i.defaultOptions._metadataKey);}catch(e){K(null,e);}function K(N,O){var P="Cache Manager LRUPersistentCache: persistMetadata error - metadata was not successfully persisted. Details: "+B(N)+". Exception: "+(O?O.message:"");L.debug(P);H(P);}});}
function j(e,i){return new Promise(function(p,H){var J=e._db.transaction([e.defaultOptions._contentStoreName,e.defaultOptions._metadataStoreName],"readwrite");function K(N){var O="Cache Manager LRUPersistentCache: internalDel cannot complete delete transaction for entry with key: "+i+". Details: "+B(N);L.warning(O);H(N);}J.onerror=K;J.onabort=K;J.oncomplete=function(){if(t(e)===0){e._lru=0;e._mru=0;e._metadata=o(e._ui5version);}L.debug("Cache Manager LRUPersistentCache: internalDel deleting item ["+i+"]...done");p();};L.debug("Cache Manager LRUPersistentCache: internalDel deleting item ["+i+"]...");J.objectStore(e.defaultOptions._contentStoreName).delete(i);});}
function k(e,i,p){return new Promise(function(H,J){var K,N,O,P="[sync ] internalSet: serialize[sync]  key ["+i+"]";O=q(e._metadata);var Q=new n(i,p,typeof p,++e._mru,P,s).serialize();L.debug("Cache Manager: LRUPersistentCache: internal set with parameters: key ["+Q.oData.key+"], access index ["+Q.oData.lu+"]");N=e._db.transaction([e.defaultOptions._contentStoreName,e.defaultOptions._metadataStoreName],"readwrite");N.onerror=R;N.onabort=R;function R(S){L.debug("Cache Manager: LRUPersistentCache: internal set failed. Details: "+B(S));e._metadata=O;r(e);J(S);}N.oncomplete=function(){L.debug("Cache Manager: LRUPersistentCache: Internal set transaction completed. ItemCount: "+t(e));H();};K=N.objectStore(e.defaultOptions._contentStoreName).put(Q.oData,Q.oData.key);K.onsuccess=function(){u(e,Q);N.objectStore(e.defaultOptions._metadataStoreName).put(e._metadata,e.defaultOptions._metadataKey);};});}
function u(e,i){if(e._metadata.__byKey__[i.oData.key]!=null){var p=e._metadata.__byKey__[i.oData.key];delete e._metadata.__byIndex__[p];L.debug("Cache Manager LRUPersistentCache: set/internalset - item already exists, so its indexes are updated");}e._metadata.__byIndex__[i.oData.lu]=i.oData.key;e._metadata.__byKey__[i.oData.key]=i.oData.lu;A(e);}
function l(i){i._ui5version=sap.ui.version;return new Promise(function N(p,H){var J;L.debug("Cache Manager "+"_initIndexedDB started");function K(){try{J=window.indexedDB.open(i.defaultOptions.databaseName,1);}catch(e){L.error("Could not open Cache Manager database. Details: "+e.message);H(e.message);}}K();J.onerror=function(e){L.error("Could not initialize Cache Manager database. Details: "+e.message);H(e.error);};J.onsuccess=function(e){var O=F("init_onsuccess");i._db=J.result;i._db.onversionchange=function(e){if(!e.newVersion){e.target.close();}};i._loadMetaStructure().then(function(){L.debug("Cache Manager "+" metadataLoaded. Serialization support: "+C()+", resolving initIndexDb promise");p(i);},H);O.endSync();};J.onupgradeneeded=function(O){var P=O.target.result;P.onerror=function(O){L.error("Cache Manager error. Details: "+O.message);H(P.error);};try{var Q=P.createObjectStore(i.defaultOptions._contentStoreName);P.createObjectStore(i.defaultOptions._metadataStoreName);}catch(e){L.error("Could not initialize Cache Manager object store. Details: "+e.message);throw e;}Q.createIndex("ui5version","ui5version",{unique:false});};});}
function I(e,i,p,H){this.key=e;this.sOrigType=p;this.value=i;this.lu=H;}
function n(e,i,p,H,J,K){if(arguments.length===3){this.oData=e;this.sMeasureId=i;this.sMsrCat=p;}else{this.oData=new I(e,i,p,H);}}
n.prototype.deserialize=function(){if(C()&&this.oData.sOrigType==="object"){M.start(this.sMeasureId,this.sMeasureId,this.sMsrCat);this.oData.value=JSON.parse(this.oData.value);M.end(this.sMeasureId);G("Cache Manager LRUPersistentCache: de-serialization the result",this.oData.key,this.sMeasureId);}return this;};
n.prototype.serialize=function(){if(C()&&this.oData.sOrigType==="object"){M.start(this.sMeasureId,this.sMeasureId,this.sMsrCat);this.oData.value=JSON.stringify(this.oData.value);M.end(this.sMeasureId);G("Cache Manager LRUPersistentCache: serialization of the value",this.oData.key,this.sMeasureId);}return this;};
function o(e){return{__byKey__:{},__byIndex__:{},__ui5version:e};}
function q(e){var i=o(e.__ui5version);for(var p in e.__byIndex__){i.__byIndex__[p]=e.__byIndex__[p];}for(var H in e.__byKey__){i.__byKey__[H]=e.__byKey__[H];}return i;}
function r(e){var i=w(e._metadata.__byIndex__);e._mru=i.mru;e._lru=i.lru;L.debug("Cache Manager LRUPersistentCache: LRU counters are assigned to the CM: "+JSON.stringify(i));}
function t(e){return Object.keys(e._metadata.__byKey__).length;}
function v(e){var K=e._metadata.__byIndex__[e._lru];if(K==undefined&&!A(e)){return null;}else{return e._metadata.__byIndex__[e._lru];}}
function w(e){var i=-1,p=-1,H=Number.MAX_VALUE,J=Object.keys(e),K=J.length;if(K===0){return{mru:-1,lru:-1};}else{while(++i<K){var N=parseInt(J[i]);if(p<N){p=N;}if(H>N){H=N;}}return{mru:p,lru:H};}}
function x(e,i,p){return new Promise(function(H,J){var K=0;_(e,i,p);function _(e,i,p){K++;L.debug("Cache Manager LRUPersistentCache: cleanAndStore: freeing space attempt ["+(K)+"]");f(e).then(function(N){L.debug("Cache Manager LRUPersistentCache: cleanAndStore: deleted item with key ["+N+"]. Going to put "+i);return k(e,i,p).then(H,function(O){if(y(O)){L.debug("Cache Manager LRUPersistentCache: cleanAndStore: QuotaExceedError during freeing up space...");if(t(e)>0){_(e,i,p);}else{J("Cache Manager LRUPersistentCache: cleanAndStore: even when the cache is empty, the new item with key ["+i+"] cannot be added");}}else{J("Cache Manager LRUPersistentCache: cleanAndStore: cannot free space: "+B(O));}});},J);}});}
function y(e){return(e&&e.target&&e.target.error&&e.target.error.name==="QuotaExceededError");}
function z(e,i){var p=e._metadata.__byKey__[i];delete e._metadata.__byKey__[i];delete e._metadata.__byIndex__[p];A(e);}
function A(e){while(e._lru<=e._mru&&e._metadata.__byIndex__[e._lru]==undefined){e._lru++;}return(e._lru<=e._mru);}
function B(e){if(!e){return"";}var R=e.message;if(e.target&&e.target.error&&e.target.error.name){R+=" Error name: "+e.target.error.name;}return R;}
function C(){return sap.ui.getCore().getConfiguration().isUI5CacheSerializationSupportOn();}
function D(){return sap.ui.getCore().getConfiguration().getUI5CacheExcludedKeys();}
function E(e){return D().some(function(i){return e.indexOf(i)>-1;});}
function F(O,e){b++;var i="[async]  "+O+"["+e+"]- #"+(b),p="[sync ]  "+O+"["+e+"]- #"+(b);M.start(i,"CM",["LRUPersistentCache",O]);M.start(p,"CM",["LRUPersistentCache",O]);return{sMeasureAsync:i,sMeasureSync:p,endAsync:function(){M.end(this.sMeasureAsync);},endSync:function(){M.end(this.sMeasureSync);}};}
function G(e,K,i){if(L.getLevel()>=L.Level.DEBUG){L.debug(e+" for key ["+K+"] took: "+M.getMeasurement(i).duration);}}
return a;});
sap.ui.predefine('sap/ui/core/date/Buddhist',['./UniversalDate','../CalendarType','./_Calendars'],function(U,C,_){"use strict";
var B=U.extend("sap.ui.core.date.Buddhist",{constructor:function(){var A=arguments;if(A.length>1){A=b(A);}this.oDate=this.createDate(Date,A);this.sCalendarType=C.Buddhist;}});
B.UTC=function(){var A=b(arguments);return Date.UTC.apply(Date,A);};
B.now=function(){return Date.now();};
function t(g){var e=U.getEraStartDate(C.Buddhist,0).year,y=g.year-e+1;if(g.year<1941&&g.month<3){y-=1;}if(g.year===null){y=undefined;}return{year:y,month:g.month,day:g.day};}
function a(o){var e=U.getEraStartDate(C.Buddhist,0).year,y=o.year+e-1;if(y<1941&&o.month<3){y+=1;}if(o.year===null){y=undefined;}return{year:y,month:o.month,day:o.day};}
function b(A){var o,g;o={year:A[0],month:A[1],day:A[2]!==undefined?A[2]:1};g=a(o);A[0]=g.year;return A;}
B.prototype._getBuddhist=function(){var g={year:this.oDate.getFullYear(),month:this.oDate.getMonth(),day:this.oDate.getDate()};return t(g);};
B.prototype._setBuddhist=function(o){var g=a(o);return this.oDate.setFullYear(g.year,g.month,g.day);};
B.prototype._getUTCBuddhist=function(){var g={year:this.oDate.getUTCFullYear(),month:this.oDate.getUTCMonth(),day:this.oDate.getUTCDate()};return t(g);};
B.prototype._setUTCBuddhist=function(o){var g=a(o);return this.oDate.setUTCFullYear(g.year,g.month,g.day);};
B.prototype.getYear=function(){return this._getBuddhist().year;};
B.prototype.getFullYear=function(){return this._getBuddhist().year;};
B.prototype.getUTCFullYear=function(){return this._getUTCBuddhist().year;};
B.prototype.setYear=function(y){var o=this._getBuddhist();o.year=y;return this._setBuddhist(o);};
B.prototype.setFullYear=function(y,m,d){var o=this._getBuddhist();o.year=y;if(m!==undefined){o.month=m;}if(d!==undefined){o.day=d;}return this._setBuddhist(o);};
B.prototype.setUTCFullYear=function(y,m,d){var o=this._getUTCBuddhist();o.year=y;if(m!==undefined){o.month=m;}if(d!==undefined){o.day=d;}return this._setUTCBuddhist(o);};
B.prototype.getWeek=function(){return U.getWeekByDate(this.sCalendarType,this.oDate.getFullYear(),this.getMonth(),this.getDate());};
B.prototype.getUTCWeek=function(){return U.getWeekByDate(this.sCalendarType,this.oDate.getUTCFullYear(),this.getUTCMonth(),this.getUTCDate());};
_.set(C.Buddhist,B);return B;});
sap.ui.predefine('sap/ui/core/date/Gregorian',['./UniversalDate','../CalendarType','./_Calendars'],function(U,C,_){"use strict";
var G=U.extend("sap.ui.core.date.Gregorian",{constructor:function(){this.oDate=this.createDate(Date,arguments);this.sCalendarType=C.Gregorian;}});
G.UTC=function(){return Date.UTC.apply(Date,arguments);};
G.now=function(){return Date.now();};
_.set(C.Gregorian,G);return G;});
sap.ui.predefine('sap/ui/core/date/Islamic',['./UniversalDate','../CalendarType','sap/base/Log','./_Calendars'],function(U,C,L,_){"use strict";
var I=U.extend("sap.ui.core.date.Islamic",{constructor:function(){var a=arguments;if(a.length>1){a=f(a);}this.oDate=this.createDate(Date,a);this.sCalendarType=C.Islamic;}});
I.UTC=function(){var a=f(arguments);return Date.UTC.apply(Date,a);};
I.now=function(){return Date.now();};
var B=1400,G=1721425.5,c=1948439.5,d=-42521587200000,O=86400000;var o=null;var s=["A","B"];
function t(a){var b=a.year,l=a.month,n=a.day,q,r,u,M,D,v,J;v=0;if((l+1)>2){v=j(b)?-1:-2;}J=(G-1)+(365*(b-1))+Math.floor((b-1)/4)+(-Math.floor((b-1)/100))+Math.floor((b-1)/400)+Math.floor((((367*(l+1))-362)/12)+v+n);J=Math.floor(J)+0.5;D=J-c;M=Math.floor(D/29.530588853);if(M<0){q=Math.floor(M/12)+1;r=M%12;if(r<0){r+=12;}u=D-m(q,r)+1;}else{M++;while(g(M)>D){M--;}q=Math.floor(M/12)+1;r=M%12;u=(D-g(12*(q-1)+r))+1;}return{day:u,month:r,year:q};}
function e(a){var b=a.year,l=a.month,n=a.day,M=b<1?m(b,l):g(12*(b-1)+l),J=n+M+c-1,q=Math.floor(J-0.5)+0.5,D=q-G,Q=Math.floor(D/146097),r=h(D,146097),u=Math.floor(r/36524),v=h(r,36524),w=Math.floor(v/1461),x=h(v,1461),y=Math.floor(x/365),Y=(Q*400)+(u*100)+(w*4)+y,z,A,E,F,H,K,N,P;if(!(u==4||y==4)){Y++;}E=G+(365*(Y-1))+Math.floor((Y-1)/4)-(Math.floor((Y-1)/100))+Math.floor((Y-1)/400);F=q-E;H=(G-1)+(365*(Y-1))+Math.floor((Y-1)/4)-(Math.floor((Y-1)/100))+Math.floor((Y-1)/400)+Math.floor((739/12)+((j(Y)?-1:-2))+1);N=0;if(q<H){N=0;}else{N=j(Y)?1:2;}z=Math.floor((((F+N)*12)+373)/367);K=(G-1)+(365*(Y-1))+Math.floor((Y-1)/4)-(Math.floor((Y-1)/100))+Math.floor((Y-1)/400);P=0;if(z>2){P=j(Y)?-1:-2;}K+=Math.floor((((367*z)-362)/12)+P+1);A=(q-K)+1;return{day:A,month:z-1,year:Y};}
function f(a){var b=Array.prototype.slice.call(a),l,n;l={year:a[0],month:a[1],day:a[2]!==undefined?a[2]:1};n=e(l);b[0]=n.year;b[1]=n.month;b[2]=n.day;return b;}
function i(){var D,a;o={};D=sap.ui.getCore().getConfiguration().getFormatSettings().getLegacyDateFormat();D=k(D)?D:"A";a=sap.ui.getCore().getConfiguration().getFormatSettings().getLegacyDateCalendarCustomizing();a=a||[];if(!a.length){L.warning("No calendar customizations.");return;}a.forEach(function(E){if(E.dateFormat===D){var b=p(E.gregDate);var l=new Date(Date.UTC(b.year,b.month-1,b.day));var M=l.getTime();var n=(M-d)/O;b=p(E.islamicMonthStart);var q=(b.year-1)*12+b.month-1;o[q]=n;}});L.info("Working with date format: ["+D+"] and customization: "+JSON.stringify(a));}
function p(D){return{year:parseInt(D.substr(0,4)),month:parseInt(D.substr(4,2)),day:parseInt(D.substr(6,2))};}
function g(a){if(!o){i();}var b=o[a];if(!b){var y=Math.floor(a/12)+1;var l=a%12;b=m(y,l);}return b;}
function m(y,a){return Math.ceil(29.5*a)+(y-1)*354+Math.floor((3+11*y)/30.0);}
function h(a,b){return a-(b*Math.floor(a/b));}
function j(y){return!(y%400)||(!(y%4)&&!!(y%100));}
function k(a){return s.indexOf(a)!==-1;}
I.prototype._getIslamic=function(){return t({day:this.oDate.getDate(),month:this.oDate.getMonth(),year:this.oDate.getFullYear()});};
I.prototype._setIslamic=function(a){var b=e(a);return this.oDate.setFullYear(b.year,b.month,b.day);};
I.prototype._getUTCIslamic=function(){return t({day:this.oDate.getUTCDate(),month:this.oDate.getUTCMonth(),year:this.oDate.getUTCFullYear()});};
I.prototype._setUTCIslamic=function(a){var b=e(a);return this.oDate.setUTCFullYear(b.year,b.month,b.day);};
I.prototype.getDate=function(D){return this._getIslamic().day;};
I.prototype.getMonth=function(){return this._getIslamic().month;};
I.prototype.getYear=function(){return this._getIslamic().year-B;};
I.prototype.getFullYear=function(){return this._getIslamic().year;};
I.prototype.setDate=function(D){var a=this._getIslamic();a.day=D;return this._setIslamic(a);};
I.prototype.setMonth=function(M,D){var a=this._getIslamic();a.month=M;if(D!==undefined){a.day=D;}return this._setIslamic(a);};
I.prototype.setYear=function(y){var a=this._getIslamic();a.year=y+B;return this._setIslamic(a);};
I.prototype.setFullYear=function(y,M,D){var a=this._getIslamic();a.year=y;if(M!==undefined){a.month=M;}if(D!==undefined){a.day=D;}return this._setIslamic(a);};
I.prototype.getUTCDate=function(D){return this._getUTCIslamic().day;};
I.prototype.getUTCMonth=function(){return this._getUTCIslamic().month;};
I.prototype.getUTCFullYear=function(){return this._getUTCIslamic().year;};
I.prototype.setUTCDate=function(D){var a=this._getUTCIslamic();a.day=D;return this._setUTCIslamic(a);};
I.prototype.setUTCMonth=function(M,D){var a=this._getUTCIslamic();a.month=M;if(D!==undefined){a.day=D;}return this._setUTCIslamic(a);};
I.prototype.setUTCFullYear=function(y,M,D){var a=this._getUTCIslamic();a.year=y;if(M!==undefined){a.month=M;}if(D!==undefined){a.day=D;}return this._setUTCIslamic(a);};
_.set(C.Islamic,I);return I;});
sap.ui.predefine('sap/ui/core/date/Japanese',['./UniversalDate','../CalendarType','./_Calendars'],function(U,C,_){"use strict";
var J=U.extend("sap.ui.core.date.Japanese",{constructor:function(){var A=arguments;if(A.length>1){A=b(A);}this.oDate=this.createDate(Date,A);this.sCalendarType=C.Japanese;}});
J.UTC=function(){var A=b(arguments);return Date.UTC.apply(Date,A);};
J.now=function(){return Date.now();};
function t(g){var e=U.getEraByDate(C.Japanese,g.year,g.month,g.day),E=U.getEraStartDate(C.Japanese,e).year;return{era:e,year:g.year-E+1,month:g.month,day:g.day};}
function a(j){var e=U.getEraStartDate(C.Japanese,j.era).year;return{year:e+j.year-1,month:j.month,day:j.day};}
function b(A){var j,g,e,y=A[0];if(typeof y=="number"){if(y>=100){return A;}else{e=U.getCurrentEra(C.Japanese);y=[e,y];}}else if(!Array.isArray(y)){y=[];}j={era:y[0],year:y[1],month:A[1],day:A[2]!==undefined?A[2]:1};g=a(j);A[0]=g.year;return A;}
J.prototype._getJapanese=function(){var g={year:this.oDate.getFullYear(),month:this.oDate.getMonth(),day:this.oDate.getDate()};return t(g);};
J.prototype._setJapanese=function(j){var g=a(j);return this.oDate.setFullYear(g.year,g.month,g.day);};
J.prototype._getUTCJapanese=function(){var g={year:this.oDate.getUTCFullYear(),month:this.oDate.getUTCMonth(),day:this.oDate.getUTCDate()};return t(g);};
J.prototype._setUTCJapanese=function(j){var g=a(j);return this.oDate.setUTCFullYear(g.year,g.month,g.day);};
J.prototype.getYear=function(){return this._getJapanese().year;};
J.prototype.getFullYear=function(){return this._getJapanese().year;};
J.prototype.getEra=function(){return this._getJapanese().era;};
J.prototype.getUTCFullYear=function(){return this._getUTCJapanese().year;};
J.prototype.getUTCEra=function(){return this._getUTCJapanese().era;};
J.prototype.setYear=function(y){var j=this._getJapanese();j.year=y;return this._setJapanese(j);};
J.prototype.setFullYear=function(y,m,d){var j=this._getJapanese();j.year=y;if(m!==undefined){j.month=m;}if(d!==undefined){j.day=d;}return this._setJapanese(j);};
J.prototype.setEra=function(e,y,m,d){var E=U.getEraStartDate(C.Japanese,e),j=t(E);if(y!==undefined){j.year=y;}if(m!==undefined){j.month=m;}if(d!==undefined){j.day=d;}return this._setJapanese(j);};
J.prototype.setUTCFullYear=function(y,m,d){var j=this._getUTCJapanese();j.year=y;if(m!==undefined){j.month=m;}if(d!==undefined){j.day=d;}return this._setUTCJapanese(j);};
J.prototype.setUTCEra=function(e,y,m,d){var E=U.getEraStartDate(C.Japanese,e),j=t(E);if(y!==undefined){j.year=y;}if(m!==undefined){j.month=m;}if(d!==undefined){j.day=d;}return this._setUTCJapanese(j);};
J.prototype.getWeek=function(){return U.getWeekByDate(this.sCalendarType,this.oDate.getFullYear(),this.getMonth(),this.getDate());};
J.prototype.getUTCWeek=function(){return U.getWeekByDate(this.sCalendarType,this.oDate.getUTCFullYear(),this.getUTCMonth(),this.getUTCDate());};
_.set(C.Japanese,J);return J;});
sap.ui.predefine('sap/ui/core/date/Persian',['./UniversalDate','../CalendarType','./_Calendars'],function(U,C,_){"use strict";
var P=U.extend("sap.ui.core.date.Persian",{constructor:function(){var a=arguments;if(a.length>1){a=e(a);}this.oDate=this.createDate(Date,a);this.sCalendarType=C.Persian;}});
P.UTC=function(){var a=e(arguments);return Date.UTC.apply(Date,a);};
P.now=function(){return Date.now();};
var B=1300;
function t(G){var j=l(G.year,G.month+1,G.day);return h(j);}
function c(a){var j=g(a.year,a.month+1,a.day);return m(j);}
function e(a){var G=Array.prototype.slice.call(a),b,d;if(typeof a[0]!=="number"||typeof a[1]!=="number"||(a[2]!==undefined&&typeof a[2]!="number")){G[0]=NaN;G[1]=NaN;G[2]=NaN;return G;}b={year:a[0],month:a[1],day:a[2]!==undefined?a[2]:1};d=c(b);G[0]=d.year;G[1]=d.month;G[2]=d.day;return G;}
function f(j){var b=[-61,9,38,199,426,686,756,818,1111,1181,1210,1635,2060,2097,2192,2262,2324,2394,2456,3178],a=b.length,d=j+621,k=-14,q=b[0],r,s,u,v,w,n,i;for(i=1;i<a;i+=1){r=b[i];s=r-q;if(j<r){break;}k=k+o(s,33)*8+o(p(s,33),4);q=r;}n=j-q;k=k+o(n,33)*8+o(p(n,33)+3,4);if(p(s,33)===4&&s-n===4){k+=1;}v=o(d,4)-o((o(d,100)+1)*3,4)-150;w=20+k-v;if(s-n<6){n=n-s+o(s+4,33)*33;}u=p(p(n+1,33)-1,4);if(u===-1){u=4;}return{leap:u,gy:d,march:w};}
function g(j,a,b){while(a<1){a+=12;j--;}while(a>12){a-=12;j++;}var r=f(j);return l(r.gy,3,r.march)+(a-1)*31-o(a,7)*(a-7)+b-1;}
function h(j){var a=m(j).year,b=a-621,r=f(b),d=l(a,3,r.march),i,n,k;k=j-d;if(k>=0){if(k<=185){n=1+o(k,31);i=p(k,31)+1;return{year:b,month:n-1,day:i};}else{k-=186;}}else{b-=1;k+=179;if(r.leap===1){k+=1;}}n=7+o(k,30);i=p(k,30)+1;return{year:b,month:n-1,day:i};}
function l(a,b,i){var d=o((a+o(b-8,6)+100100)*1461,4)+o(153*p(b+9,12)+2,5)+i-34840408;d=d-o(o(a+100100+o(b-8,6),100)*3,4)+752;return d;}
function m(a){var j,i,b,d,k;j=4*a+139361631;j=j+o(o(4*a+183187720,146097)*3,4)*4-3908;i=o(p(j,1461),4)*5+308;b=o(p(i,153),5)+1;d=p(o(i,153),12)+1;k=o(j,1461)-100100+o(8-d,6);return{year:k,month:d-1,day:b};}
function o(a,b){return~~(a/b);}
function p(a,b){return a-~~(a/b)*b;}
P.prototype._getPersian=function(){return t({day:this.oDate.getDate(),month:this.oDate.getMonth(),year:this.oDate.getFullYear()});};
P.prototype._setPersian=function(a){var G=c(a);return this.oDate.setFullYear(G.year,G.month,G.day);};
P.prototype._getUTCPersian=function(){return t({day:this.oDate.getUTCDate(),month:this.oDate.getUTCMonth(),year:this.oDate.getUTCFullYear()});};
P.prototype._setUTCPersian=function(a){var G=c(a);return this.oDate.setUTCFullYear(G.year,G.month,G.day);};
P.prototype.getDate=function(d){return this._getPersian().day;};
P.prototype.getMonth=function(){return this._getPersian().month;};
P.prototype.getYear=function(){return this._getPersian().year-B;};
P.prototype.getFullYear=function(){return this._getPersian().year;};
P.prototype.setDate=function(d){var a=this._getPersian();a.day=d;return this._setPersian(a);};
P.prototype.setMonth=function(M,d){var a=this._getPersian();a.month=M;if(d!==undefined){a.day=d;}return this._setPersian(a);};
P.prototype.setYear=function(y){var a=this._getPersian();a.year=y+B;return this._setPersian(a);};
P.prototype.setFullYear=function(y,M,d){var a=this._getPersian();a.year=y;if(M!==undefined){a.month=M;}if(d!==undefined){a.day=d;}return this._setPersian(a);};
P.prototype.getUTCDate=function(d){return this._getUTCPersian().day;};
P.prototype.getUTCMonth=function(){return this._getUTCPersian().month;};
P.prototype.getUTCFullYear=function(){return this._getUTCPersian().year;};
P.prototype.setUTCDate=function(d){var a=this._getUTCPersian();a.day=d;return this._setUTCPersian(a);};
P.prototype.setUTCMonth=function(M,d){var a=this._getUTCPersian();a.month=M;if(d!==undefined){a.day=d;}return this._setUTCPersian(a);};
P.prototype.setUTCFullYear=function(y,M,d){var a=this._getUTCPersian();a.year=y;if(M!==undefined){a.month=M;}if(d!==undefined){a.day=d;}return this._setUTCPersian(a);};
_.set(C.Persian,P);return P;});
sap.ui.predefine('sap/ui/core/date/UniversalDate',['sap/ui/base/Object','sap/ui/core/LocaleData','./_Calendars'],function(B,L,_){"use strict";
var U=B.extend("sap.ui.core.date.UniversalDate",{constructor:function(){var b=U.getClass();return this.createDate(b,arguments);}});
U.UTC=function(){var b=U.getClass();return b.UTC.apply(b,arguments);};
U.now=function(){return Date.now();};
U.prototype.createDate=function(b,A){switch(A.length){case 0:return new b();case 1:return new b(A[0]instanceof Date?A[0].getTime():A[0]);case 2:return new b(A[0],A[1]);case 3:return new b(A[0],A[1],A[2]);case 4:return new b(A[0],A[1],A[2],A[3]);case 5:return new b(A[0],A[1],A[2],A[3],A[4]);case 6:return new b(A[0],A[1],A[2],A[3],A[4],A[5]);case 7:return new b(A[0],A[1],A[2],A[3],A[4],A[5],A[6]);}};
U.getInstance=function(d,C){var b,i;if(d instanceof U){d=d.getJSDate();}else if(!d){d=new Date();}if(!C){C=sap.ui.getCore().getConfiguration().getCalendarType();}b=U.getClass(C);i=Object.create(b.prototype);i.oDate=d;i.sCalendarType=C;return i;};
U.getClass=function(C){if(!C){C=sap.ui.getCore().getConfiguration().getCalendarType();}return _.get(C);};
["getDate","getMonth","getFullYear","getYear","getDay","getHours","getMinutes","getSeconds","getMilliseconds","getUTCDate","getUTCMonth","getUTCFullYear","getUTCDay","getUTCHours","getUTCMinutes","getUTCSeconds","getUTCMilliseconds","getTime","valueOf","getTimezoneOffset","toString","toDateString","setDate","setFullYear","setYear","setMonth","setHours","setMinutes","setSeconds","setMilliseconds","setUTCDate","setUTCFullYear","setUTCMonth","setUTCHours","setUTCMinutes","setUTCSeconds","setUTCMilliseconds"].forEach(function(n){U.prototype[n]=function(){return this.oDate[n].apply(this.oDate,arguments);};});
U.prototype.getJSDate=function(){return this.oDate;};
U.prototype.getCalendarType=function(){return this.sCalendarType;};
U.prototype.getEra=function(){return U.getEraByDate(this.sCalendarType,this.oDate.getFullYear(),this.oDate.getMonth(),this.oDate.getDate());};
U.prototype.setEra=function(E){};
U.prototype.getUTCEra=function(){return U.getEraByDate(this.sCalendarType,this.oDate.getUTCFullYear(),this.oDate.getUTCMonth(),this.oDate.getUTCDate());};
U.prototype.setUTCEra=function(E){};
U.prototype.getWeek=function(){return U.getWeekByDate(this.sCalendarType,this.getFullYear(),this.getMonth(),this.getDate());};
U.prototype.setWeek=function(w){var d=U.getFirstDateOfWeek(this.sCalendarType,w.year||this.getFullYear(),w.week);this.setFullYear(d.year,d.month,d.day);};
U.prototype.getUTCWeek=function(){return U.getWeekByDate(this.sCalendarType,this.getUTCFullYear(),this.getUTCMonth(),this.getUTCDate());};
U.prototype.setUTCWeek=function(w){var d=U.getFirstDateOfWeek(this.sCalendarType,w.year||this.getFullYear(),w.week);this.setUTCFullYear(d.year,d.month,d.day);};
U.prototype.getQuarter=function(){return Math.floor((this.getMonth()/3));};
U.prototype.getUTCQuarter=function(){return Math.floor((this.getUTCMonth()/3));};
U.prototype.getDayPeriod=function(){if(this.getHours()<12){return 0;}else{return 1;}};
U.prototype.getUTCDayPeriod=function(){if(this.getUTCHours()<12){return 0;}else{return 1;}};
U.prototype.getTimezoneShort=function(){if(this.oDate.getTimezoneShort){return this.oDate.getTimezoneShort();}};
U.prototype.getTimezoneLong=function(){if(this.oDate.getTimezoneLong){return this.oDate.getTimezoneLong();}};
var m=7*24*60*60*1000;
U.getWeekByDate=function(C,y,M,d){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),o=L.getInstance(l),b=this.getClass(C),f=g(b,y),D=new b(b.UTC(y,M,d)),w,i,n,h,N;if(o.firstDayStartsFirstWeek()){w=c(f,D);}else{i=y-1;n=y+1;h=g(b,i);N=g(b,n);if(D>=N){y=n;w=0;}else if(D<f){y=i;w=c(h,D);}else{w=c(f,D);}}return{year:y,week:w};};
U.getFirstDateOfWeek=function(C,y,w){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),o=L.getInstance(l),b=this.getClass(C),f=g(b,y),d=new b(f.valueOf()+w*m),i=o.firstDayStartsFirstWeek();if(i&&w===0&&f.getUTCFullYear()<y){return{year:y,month:0,day:1};}return{year:d.getUTCFullYear(),month:d.getUTCMonth(),day:d.getUTCDate()};};
function g(b,y){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),o=L.getInstance(l),M=o.getMinimalDaysInFirstWeek(),f=o.getFirstDayOfWeek(),F=new b(b.UTC(y,0,1)),d=7;while(F.getUTCDay()!==f){F.setUTCDate(F.getUTCDate()-1);d--;}if(d<M){F.setUTCDate(F.getUTCDate()+7);}return F;}
function c(f,t){return Math.floor((t.valueOf()-f.valueOf())/m);}
var e={};
U.getEraByDate=function(C,y,M,d){var E=a(C),t=new Date(0).setUTCFullYear(y,M,d),o;for(var i=E.length-1;i>=0;i--){o=E[i];if(!o){continue;}if(o._start&&t>=o._startInfo.timestamp){return i;}if(o._end&&t<o._endInfo.timestamp){return i;}}};
U.getCurrentEra=function(C){var n=new Date();return this.getEraByDate(C,n.getFullYear(),n.getMonth(),n.getDate());};
U.getEraStartDate=function(C,E){var b=a(C),o=b[E]||b[0];if(o._start){return o._startInfo;}};
function a(C){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),o=L.getInstance(l),E=e[C];if(!E){var E=o.getEraDates(C);if(!E[0]){E[0]={_start:"1-1-1"};}for(var i=0;i<E.length;i++){var b=E[i];if(!b){continue;}if(b._start){b._startInfo=p(b._start);}if(b._end){b._endInfo=p(b._end);}}e[C]=E;}return E;}
function p(d){var P=d.split("-"),y,M,D;if(P[0]==""){y=-parseInt(P[1]);M=parseInt(P[2])-1;D=parseInt(P[3]);}else{y=parseInt(P[0]);M=parseInt(P[1])-1;D=parseInt(P[2]);}return{timestamp:new Date(0).setUTCFullYear(y,M,D),year:y,month:M,day:D};}
return U;});
sap.ui.predefine('sap/ui/core/date/UniversalDateUtils',['sap/ui/core/date/UniversalDate','sap/ui/core/Locale','sap/ui/core/LocaleData','sap/base/assert'],function(U,L,a,b){"use strict";
function c(u){b(u instanceof U,"method accepts only instances of UniversalDate");return u.createDate(u.constructor,[u.getJSDate()]);}
var d={};
d.getRange=function(D,u,B,e){if(e===undefined){e=true;}if(isNaN(D)){throw new TypeError("duration is NaN, but is "+D);}D=Math.trunc(D);var s=d.resetStartTime(B==undefined?null:B),E;if(e){switch(u){case"DAY":break;case"WEEK":s=d.getWeekStartDate(s);break;case"MONTH":s=d.getMonthStartDate(s);break;case"QUARTER":s=d.getQuarterStartDate(s);break;case"YEAR":s=d.getYearStartDate(s);break;default:throw new TypeError("invalid unit "+u);}}switch(u){case"DAY":if(D>0){s.setDate(s.getDate()+1);}E=c(s);D=D==0?1:D;E.setDate(s.getDate()+D);break;case"WEEK":if(D>0){s.setDate(s.getDate()+7);}E=c(s);D=D==0?1:D;E.setDate(s.getDate()+(D*7));break;case"MONTH":if(D>0){s.setMonth(s.getMonth()+1);}E=c(s);D=D==0?1:D;E.setMonth(s.getMonth()+D);break;case"QUARTER":if(D>0){s.setMonth(s.getMonth()+3);}E=c(s);D=D==0?1:D;E.setMonth(s.getMonth()+(D*3));break;case"YEAR":if(D>0){s.setFullYear(s.getFullYear()+1);}E=c(s);D=D==0?1:D;E.setFullYear(s.getFullYear()+D);break;default:throw new TypeError("invalid unit "+u);}if(E.getTime()<s.getTime()){E=[s,s=E][0];}E.setDate(E.getDate()-1);return[d.resetStartTime(s),d.resetEndTime(E)];};
d.getWeekStartDate=function(u,l){var o=l?new L(l):sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),e=a.getInstance(o),f=e.getFirstDayOfWeek();u=u?c(u):c(d.createNewUniversalDate());u.setDate(u.getDate()-u.getDay()+f);return d.resetStartTime(u);};
d.getWeekLastDate=function(u,l){var e=d.getWeekStartDate(u,l);e.setDate(e.getDate()+6);return d.resetStartTime(e);};
d.getMonthStartDate=function(u){u=u?c(u):c(d.createNewUniversalDate());u.setDate(1);return d.resetStartTime(u);};
d.getMonthEndDate=function(u){var e=d.getMonthStartDate(u);e.setMonth(e.getMonth()+1);e.setDate(0);return d.resetStartTime(e);};
d.getQuarterStartDate=function(u){u=u?c(u):c(d.createNewUniversalDate());u.setMonth(3*Math.floor(u.getMonth()/3));u.setDate(1);return d.resetStartTime(u);};
d.getQuarterEndDate=function(u){var e=d.getQuarterStartDate(u);e.setMonth(e.getMonth()+3);e.setDate(0);return d.resetStartTime(e);};
d.getYearStartDate=function(u){u=u?c(u):c(d.createNewUniversalDate());u.setMonth(0);u.setDate(1);return d.resetStartTime(u);};
d.getYearEndDate=function(u){u=u?c(u):c(d.createNewUniversalDate());u.setFullYear(u.getFullYear()+1);u.setMonth(0);u.setDate(0);return d.resetStartTime(u);};
d.resetStartTime=function(u){u=u?c(u):c(d.createNewUniversalDate());u.setHours(0,0,0,0);return u;};
d.resetEndTime=function(u){u=u?c(u):c(d.createNewUniversalDate());u.setHours(23,59,59,999);return u;};
d.createNewUniversalDate=function(){return new U();};
d.ranges={lastDays:function(D){return d.getRange(-D,"DAY");},yesterday:function(){return d.getRange(-1,"DAY");},today:function(){return d.getRange(0,"DAY");},tomorrow:function(){return d.getRange(1,"DAY");},nextDays:function(D){return d.getRange(D,"DAY");},lastWeeks:function(w){return d.getRange(-w,"WEEK");},lastWeek:function(){return d.getRange(-1,"WEEK");},currentWeek:function(){return d.getRange(0,"WEEK");},firstDayOfWeek:function(){var s=d.getWeekStartDate();return[s,d.resetEndTime(s)];},lastDayOfWeek:function(){var e=d.getWeekLastDate();return[e,d.resetEndTime(e)];},nextWeek:function(){return d.getRange(1,"WEEK");},nextWeeks:function(w){return d.getRange(w,"WEEK");},lastMonths:function(m){return d.getRange(-m,"MONTH");},lastMonth:function(){return d.getRange(-1,"MONTH");},currentMonth:function(){return d.getRange(0,"MONTH");},firstDayOfMonth:function(){var s=d.getMonthStartDate();return[s,d.resetEndTime(s)];},lastDayOfMonth:function(){var e=d.getMonthEndDate();return[e,d.resetEndTime(e)];},nextMonth:function(){return d.getRange(1,"MONTH");},nextMonths:function(m){return d.getRange(m,"MONTH");},lastQuarters:function(q){return d.getRange(-q,"QUARTER");},lastQuarter:function(){return d.getRange(-1,"QUARTER");},firstDayOfQuarter:function(){var s=d.getQuarterStartDate();return[s,d.resetEndTime(s)];},lastDayOfQuarter:function(){var e=d.getQuarterEndDate();return[e,d.resetEndTime(e)];},currentQuarter:function(){return d.getRange(0,"QUARTER");},nextQuarter:function(){return d.getRange(1,"QUARTER");},nextQuarters:function(q){return d.getRange(q,"QUARTER");},quarter:function(q){if(q<=2){return d.getRange(q-1,"QUARTER",d.getYearStartDate());}else{var r=d.getRange(q-2,"QUARTER",d.getYearStartDate());var s=r[1];s.setMilliseconds(1000);return d.getRange(0,"QUARTER",s);}},lastYears:function(y){return d.getRange(-y,"YEAR");},lastYear:function(){return d.getRange(-1,"YEAR");},firstDayOfYear:function(){var s=d.getYearStartDate();return[s,d.resetEndTime(s)];},lastDayOfYear:function(){var e=d.getYearEndDate();return[e,d.resetEndTime(e)];},currentYear:function(){return d.getRange(0,"YEAR");},nextYear:function(){return d.getRange(1,"YEAR");},nextYears:function(y){return d.getRange(y,"YEAR");},yearToDate:function(){var t=d.createNewUniversalDate();return[d.getYearStartDate(t),d.resetEndTime(t)];},dateToYear:function(){var t=d.createNewUniversalDate();return[d.resetStartTime(t),d.resetEndTime(d.getYearEndDate(t))];}};return d;});
sap.ui.predefine('sap/ui/core/date/_Calendars',[],function(){"use strict";var r=new Map();var _={get:function(c){if(!r.has(c)){sap.ui.requireSync("sap/ui/core/date/"+c);}return r.get(c);},set:function(c,C){r.set(c,C);}};return _;});
sap.ui.predefine('sap/ui/core/delegate/ItemNavigation',['sap/ui/base/EventProvider',"sap/base/assert","sap/base/Log","sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Selectors"],function(E,a,L,c,K,q){"use strict";
var I=E.extend("sap.ui.core.delegate.ItemNavigation",{constructor:function(d,i,n){E.apply(this);this.oDomRef=null;if(d){this.setRootDomRef(d);}this.aItemDomRefs=[];if(i){this.setItemDomRefs(i);}this.iTabIndex=-1;this.iActiveTabIndex=n?-1:0;this.iFocusedIndex=-1;this.iSelectedIndex=-1;this.bCycling=true;this.bTableMode=false;this.iPageSize=-1;this._bMouseDownHappened=false;this.oDisabledModifiers={sapend:["alt","shift"],saphome:["alt","shift"]};}});
I.Events={BeforeFocus:"BeforeFocus",AfterFocus:"AfterFocus",BorderReached:"BorderReached",FocusAgain:"FocusAgain",FocusLeave:"FocusLeave"};
I.prototype.setDisabledModifiers=function(d){this.oDisabledModifiers=d;return this;};
I.prototype.getDisabledModifiers=function(d){return this.oDisabledModifiers;};
I.prototype.hasDisabledModifier=function(e){var d=this.oDisabledModifiers[e.type.replace("modifiers","")];if(Array.isArray(d)){for(var i=0;i<d.length;i++){if(e[d[i]+"Key"]){return true;}}}return false;};
I.prototype.setRootDomRef=function(d){this.oDomRef=d;if(!q(this.oDomRef).data("sap.INItem")){if(this.iFocusedIndex>=0){q(this.oDomRef).attr("tabindex",this.iTabIndex);}else{q(this.oDomRef).attr("tabindex",this.iActiveTabIndex);}}q(this.oDomRef).data("sap.INRoot",this);return this;};
I.prototype.getRootDomRef=function(){return this.oDomRef;};
I.prototype.getItemDomRefs=function(){return this.aItemDomRefs;};
I.prototype.setItemDomRefs=function(b){a(typeof b==="object"&&typeof b.length==="number","aItemDomRefs must be an array of DOM elements");this.aItemDomRefs=b;if(this.iFocusedIndex>-1){var d=b.length;if(this.iFocusedIndex>d-1){this.iFocusedIndex=d-1;}var A=document.activeElement;if(A&&A!=this.aItemDomRefs[this.iFocusedIndex]){for(var i=0;i<d;i++){if(A==this.aItemDomRefs[i]){this.iFocusedIndex=i;break;}}}}for(var i=0;i<this.aItemDomRefs.length;i++){if(this.aItemDomRefs[i]){var $=q(this.aItemDomRefs[i]);if(i==this.iFocusedIndex&&!$.data("sap.INRoot")){$.attr("tabindex",this.iActiveTabIndex);}else if($.attr("tabindex")=="0"){$.attr("tabindex",-1);}$.data("sap.INItem",true);$.data("sap.InNavArea",true);if($.data("sap.INRoot")&&i!=this.iFocusedIndex){$.data("sap.INRoot").setNestedItemsTabindex();}}}return this;};
I.prototype.setItemsTabindex=function(){for(var i=0;i<this.aItemDomRefs.length;i++){if(this.aItemDomRefs[i]){var $=q(this.aItemDomRefs[i]);if($.is(":sapFocusable")){if(i==this.iFocusedIndex&&!$.data("sap.INRoot")){$.attr("tabindex",this.iActiveTabIndex);}else{$.attr("tabindex",-1);}}}}return this;};
I.prototype.setNestedItemsTabindex=function(){if(q(this.oDomRef).data("sap.INItem")){for(var i=0;i<this.aItemDomRefs.length;i++){if(this.aItemDomRefs[i]&&q(this.aItemDomRefs[i]).attr("tabindex")=="0"){q(this.aItemDomRefs[i]).attr("tabindex",-1);}}}return this;};
I.prototype.destroy=function(){if(this.oDomRef){q(this.oDomRef).removeData("sap.INRoot");this.oDomRef=null;}if(this.aItemDomRefs){for(var i=0;i<this.aItemDomRefs.length;i++){if(this.aItemDomRefs[i]){q(this.aItemDomRefs[i]).removeData("sap.INItem");q(this.aItemDomRefs[i]).removeData("sap.InNavArea");}}this.aItemDomRefs=null;}this._bItemTabIndex=undefined;this.iFocusedIndex=-1;};
I.prototype.setCycling=function(C){this.bCycling=C;return this;};
I.prototype.setTableMode=function(t,T){this.bTableMode=t;if(this.oConfiguration===undefined){this.oConfiguration=sap.ui.getCore().getConfiguration();}this.bTableList=t?T:false;return this;};
I.prototype.setPageSize=function(p){this.iPageSize=p;return this;};
I.prototype.setSelectedIndex=function(i){this.iSelectedIndex=i;return this;};
I.prototype.setColumns=function(C,n){this.iColumns=C;this.bNoColumnChange=n;return this;};
I.prototype.setHomeEndColumnMode=function(s,C){this._bStayInRow=s;this._bCtrlEnabled=C;return this;};
I.prototype.focusItem=function(i,e,p){L.info("FocusItem: "+i+" iFocusedIndex: "+this.iFocusedIndex,"focusItem","ItemNavigation");if(i==this.iFocusedIndex&&this.aItemDomRefs[this.iFocusedIndex]==document.activeElement){this.fireEvent(I.Events.FocusAgain,{index:i,event:e});return;}if(!this.aItemDomRefs[i]||!q(this.aItemDomRefs[i]).is(":sapFocusable")){if(this.bTableMode){var C=i%this.iColumns;var o=i;if(e&&e.keyCode==K.ARROW_RIGHT){if(C<this.iColumns-1){i+=this.oConfiguration.getRTL()?-1:1;}}else if(e&&e.keyCode==K.ARROW_LEFT){if(C>1){i-=this.oConfiguration.getRTL()?-1:1;}}else{if(C>1){i-=1;}}if(i!=o){this.focusItem(i,e);}}return;}this.fireEvent(I.Events.BeforeFocus,{index:i,event:e});this.setFocusedIndex(i);this.bISetFocus=true;if(e&&q(this.aItemDomRefs[this.iFocusedIndex]).data("sap.INRoot")){var b=q(this.aItemDomRefs[this.iFocusedIndex]).data("sap.INRoot");b._sFocusEvent=e.type;}L.info("Set Focus on ID: "+this.aItemDomRefs[this.iFocusedIndex].id,"focusItem","ItemNavigation");this.aItemDomRefs[this.iFocusedIndex].focus({preventScroll:p});this.fireEvent(I.Events.AfterFocus,{index:i,event:e});};
I.prototype.setFocusedIndex=function(i){var $;if(this.aItemDomRefs.length<0){this.iFocusedIndex=-1;return this;}if(i<0){i=0;}if(i>this.aItemDomRefs.length-1){i=this.aItemDomRefs.length-1;}q(this.oDomRef).attr("tabindex",this.iTabIndex);if(this.iFocusedIndex!==-1&&this.aItemDomRefs.length>this.iFocusedIndex){q(this.aItemDomRefs[this.iFocusedIndex]).attr("tabindex",-1);$=q(this.aItemDomRefs[this.iFocusedIndex]);if($.data("sap.INRoot")&&i!=this.iFocusedIndex){q($.data("sap.INRoot").aItemDomRefs[$.data("sap.INRoot").iFocusedIndex]).attr("tabindex",-1);}}this.iFocusedIndex=i;var f=this.aItemDomRefs[this.iFocusedIndex];$=q(this.aItemDomRefs[this.iFocusedIndex]);if(!$.data("sap.INRoot")){q(f).attr("tabindex",this.iActiveTabIndex);}return this;};
I.prototype.getFocusedDomRef=function(){return this.aItemDomRefs[this.iFocusedIndex];};
I.prototype.getFocusedIndex=function(){return this.iFocusedIndex;};
I.prototype.onfocusin=function(e){var s=e.target;var i=0;if(s==this.oDomRef){if(!this._bItemTabIndex){this.setItemsTabindex();this._bItemTabIndex=true;}if(this._bMouseDownHappened){return;}var b;if(q(this.oDomRef).data("sap.INItem")&&this._sFocusEvent&&!q(this.oDomRef).data("sap.InNavArea")){switch(this._sFocusEvent){case"sapnext":b=0;break;case"sapprevious":b=this.aItemDomRefs.length-1;break;default:if(this.iSelectedIndex!=-1){b=this.iSelectedIndex;}else if(this.iFocusedIndex!=-1){b=this.iFocusedIndex;}else{b=0;}break;}this._sFocusEvent=undefined;}else{if(this.iSelectedIndex!=-1){b=this.iSelectedIndex;}else if(this.iFocusedIndex!=-1){b=this.iFocusedIndex;}else{b=0;}}this.focusItem(b,e);if(this.iFocusedIndex==-1){for(i=b+1;i<this.aItemDomRefs.length;i++){this.focusItem(i,e);if(this.iFocusedIndex==i){break;}}if(this.iFocusedIndex==-1&&b>0){for(i=b-1;i>=0;i--){this.focusItem(i,e);if(this.iFocusedIndex==i){break;}}}}e.preventDefault();e.stopPropagation();}else if(!this.bISetFocus){if(this.aItemDomRefs&&e.target!=this.aItemDomRefs[this.iFocusedIndex]){for(i=0;i<this.aItemDomRefs.length;i++){if(e.target==this.aItemDomRefs[i]){this.focusItem(i,e);break;}}}else{this.fireEvent(I.Events.AfterFocus,{index:this.iFocusedIndex,event:e});}}this.bISetFocus=false;};
I.prototype.onsapfocusleave=function(e){if(!e.relatedControlId||!c(this.oDomRef,sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef())){var i;if(this.iSelectedIndex!=-1){i=this.iSelectedIndex;}else if(this.iFocusedIndex!=-1){i=this.iFocusedIndex;}else{i=0;}this.setFocusedIndex(i);var d;if(q(this.oDomRef).data("sap.INItem")){var p;d=q(this.oDomRef);while(!p){d=d.parent();if(d.data("sap.INRoot")){p=d.get(0);}}if(!e.relatedControlId||c(p,sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef())){q(this.aItemDomRefs[this.iFocusedIndex]).attr("tabindex",-1);}}d=q(this.oDomRef);if(d.data("sap.InNavArea")===false){d.data("sap.InNavArea",true);}this.fireEvent(I.Events.FocusLeave,{index:i,event:e});}};
I.prototype.onmousedown=function(e){var s=e.target;var b=function(d,o){var f=false;var C=q(d);while(!C.is(":sapFocusable")&&C.get(0)!=o){C=C.parent();}if(C.get(0)!=o){f=true;}return f;};if(c(this.oDomRef,s)){for(var i=0;i<this.aItemDomRefs.length;i++){var o=this.aItemDomRefs[i];if(c(o,s)){if(!this.bTableMode){this.focusItem(i,e,true);}else{if(o===s||!b(s,o)){this.focusItem(i,e,true);}}return;}}if(s==this.oDomRef){this._bMouseDownHappened=true;var t=this;window.setTimeout(function(){t._bMouseDownHappened=false;},20);}}};
I.prototype.onsapnext=function(e){if(!c(this.oDomRef,e.target)){return;}if(q(this.oDomRef).data("sap.InNavArea")){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=this.iFocusedIndex,f=true,b=false;if(i>-1){if(this.bTableMode){var r=this.aItemDomRefs.length/this.iColumns,R=Math.floor(i/this.iColumns),C=i%this.iColumns;if(e.keyCode==K.ARROW_DOWN){if(R<r-1){i+=this.iColumns;}}else{if(C<this.iColumns-1){i+=1;}}}else{do{if(this.iColumns>1&&e.keyCode==K.ARROW_DOWN){if((i+this.iColumns)>=this.aItemDomRefs.length){if(!this.bNoColumnChange){if((i%this.iColumns)<(this.iColumns-1)){i=(i%this.iColumns)+1;}else if(this.bCycling){i=0;}}else{i=this.iFocusedIndex;b=true;}}else{i=i+this.iColumns;}}else{if(i==this.aItemDomRefs.length-1){if(q(this.oDomRef).data("sap.INItem")){return;}else if(this.bCycling){i=0;}else{i=this.iFocusedIndex;b=true;}}else{i++;}}if(i===this.iFocusedIndex){if(f){f=false;}else{throw new Error("ItemNavigation has no visible/existing items and is hence unable to select the next one");}}}while(!this.aItemDomRefs[i]||!q(this.aItemDomRefs[i]).is(":sapFocusable"));}this.focusItem(i,e);if(b){this.fireEvent(I.Events.BorderReached,{index:i,event:e});}e.preventDefault();e.stopPropagation();}};
I.prototype.onsapnextmodifiers=function(e){if(this.hasDisabledModifier(e)){return;}this.onsapnext(e);};
I.prototype.onsapprevious=function(e){if(!c(this.oDomRef,e.target)){return;}if(q(this.oDomRef).data("sap.InNavArea")){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=this.iFocusedIndex,f=true,b=false;var C=0;if(i>-1){if(this.bTableMode){var r=Math.floor(i/this.iColumns);C=i%this.iColumns;if(e.keyCode==K.ARROW_UP){if(r>0){i-=this.iColumns;}}else{if(C>0){i-=1;}}}else{do{if(this.iColumns>1&&e.keyCode==K.ARROW_UP){if((i-this.iColumns)<0){if(!this.bNoColumnChange){C=0;if((i%this.iColumns)>0){C=(i%this.iColumns)-1;}else if(this.bCycling){C=Math.min(this.iColumns-1,this.aItemDomRefs.length-1);}if(i===0&&C===0){i=0;}else{var R=Math.ceil(this.aItemDomRefs.length/this.iColumns);i=C+((R-1)*this.iColumns);if(i>=this.aItemDomRefs.length){i=i-this.iColumns;}}}else{i=this.iFocusedIndex;b=true;}}else{i=i-this.iColumns;}}else{if(i==0){if(q(this.oDomRef).data("sap.INItem")){return;}else if(this.bCycling){i=this.aItemDomRefs.length-1;}else{i=this.iFocusedIndex;b=true;}}else{i--;}}if(i==this.iFocusedIndex){if(f){f=false;}else{throw new Error("ItemNavigation has no visible/existing items and is hence unable to select the previous one");}}}while(!this.aItemDomRefs[i]||!q(this.aItemDomRefs[i]).is(":sapFocusable"));}this.focusItem(i,e);if(b){this.fireEvent(I.Events.BorderReached,{index:i,event:e});}e.preventDefault();e.stopPropagation();}};
I.prototype.onsappreviousmodifiers=function(e){if(this.hasDisabledModifier(e)){return;}this.onsapprevious(e);};
I.prototype.onsappageup=function(e){if(!c(this.oDomRef,e.target)){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=0;var b=false;if(this.iPageSize>0){i=this.iFocusedIndex;if(i>-1){i=i-this.iPageSize;while(i>0&&!q(this.aItemDomRefs[i]).is(":sapFocusable")){i--;}if(i<0){if(!this.bNoColumnChange){i=0;}else{i=this.iFocusedIndex;b=true;}}this.focusItem(i,e);}}else if(this.bTableMode){i=this.iFocusedIndex%this.iColumns;this.focusItem(i,e);}if(b){this.fireEvent(I.Events.BorderReached,{index:i,event:e});}e.preventDefault();e.stopPropagation();};
I.prototype.onsappagedown=function(e){if(!c(this.oDomRef,e.target)){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=0;var b=false;if(this.iPageSize>0){i=this.iFocusedIndex;if(i>-1){i=i+this.iPageSize;while(i<this.aItemDomRefs.length-1&&!q(this.aItemDomRefs[i]).is(":sapFocusable")){i++;}if(i>this.aItemDomRefs.length-1){if(!this.bNoColumnChange){i=this.aItemDomRefs.length-1;}else{i=this.iFocusedIndex;b=true;}}this.focusItem(i,e);}}else if(this.bTableMode){var r=this.aItemDomRefs.length/this.iColumns,C=this.iFocusedIndex%this.iColumns;i=(r-1)*this.iColumns+C;this.focusItem(i,e);}if(b){this.fireEvent(I.Events.BorderReached,{index:i,event:e});}e.preventDefault();e.stopPropagation();};
I.prototype.onsaphome=function(e){if(!c(this.oDomRef,e.target)){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=0;var r=0;if(this.bTableMode){if(!this.bTableList&&!(e.metaKey||e.ctrlKey)){r=Math.floor(this.iFocusedIndex/this.iColumns);i=r*this.iColumns;}}else{if((e.metaKey||e.ctrlKey)&&!this._bCtrlEnabled){return;}if(this._bStayInRow&&!(this._bCtrlEnabled&&(e.metaKey||e.ctrlKey))&&this.iColumns>0){r=Math.floor(this.iFocusedIndex/this.iColumns);i=r*this.iColumns;}else{while(!this.aItemDomRefs[i]||!q(this.aItemDomRefs[i]).is(":sapFocusable")){i++;if(i==this.aItemDomRefs.length){return;}}}}this.focusItem(i,e);e.preventDefault();e.stopPropagation();};
I.prototype.onsaphomemodifiers=function(e){if(this.hasDisabledModifier(e)){return;}this.onsaphome(e);};
I.prototype.onsapend=function(e){if(!c(this.oDomRef,e.target)){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=this.aItemDomRefs.length-1;var r=0;if(this.bTableMode){if(!this.bTableList&&!(e.metaKey||e.ctrlKey)){r=Math.floor(this.iFocusedIndex/this.iColumns);i=r*this.iColumns+this.iColumns-1;}}else{if((e.metaKey||e.ctrlKey)&&!this._bCtrlEnabled){return;}if(this._bStayInRow&&!(this._bCtrlEnabled&&(e.metaKey||e.ctrlKey))&&this.iColumns>0){r=Math.floor(this.iFocusedIndex/this.iColumns);i=(r+1)*this.iColumns-1;if(i>=this.aItemDomRefs.length){i=this.aItemDomRefs.length-1;}}else{while(!this.aItemDomRefs[i]||!q(this.aItemDomRefs[i]).is(":sapFocusable")){i--;if(i<0){return;}}}}this.focusItem(i,e);e.preventDefault();e.stopPropagation();};
I.prototype.onsapendmodifiers=function(e){if(this.hasDisabledModifier(e)){return;}this.onsapend(e);};
I.prototype.setTabIndex0=function(){this.iTabIndex=0;this.iActiveTabIndex=0;};
I.prototype.onkeyup=function(e){if(e.keyCode==K.F2){var d=q(this.oDomRef);if(d.data("sap.InNavArea")){d.data("sap.InNavArea",false);}else if(d.data("sap.InNavArea")===false){d.data("sap.InNavArea",true);}e.preventDefault();e.stopPropagation();}};
return I;});
sap.ui.predefine('sap/ui/core/delegate/ScrollEnablement',['sap/ui/Device','sap/ui/base/Object','sap/ui/core/Core','sap/ui/core/IntervalTrigger','sap/ui/core/ResizeHandler',"sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes"],function(D,B,C,I,R,q,K){"use strict";
var S=B.extend("sap.ui.core.delegate.ScrollEnablement",{
constructor:function(c,s,o){B.apply(this);this._oControl=c;this._oControl.addDelegate(this);this._sContentId=s;this._sContainerId=o.scrollContainerId;this._bHorizontal=!!o.horizontal;this._bVertical=!!o.vertical;this._scrollX=0;this._scrollY=0;this._scrollCoef=0.9;this._iLastMaxScrollTop=0;i(this);if(this._init){this._init.apply(this,arguments);}},
setHorizontal:function(h){this._bHorizontal=!!h;this._setOverflow&&this._setOverflow();},
setVertical:function(v){this._bVertical=!!v;this._setOverflow&&this._setOverflow();},
getHorizontal:function(){return this._bHorizontal;},
getVertical:function(){return this._bVertical;},
setBounce:function(b){},
setPullDown:function(c){this._oPullDown=c;return this;},
setGrowingList:function(s,a,o){this._fnScrollLoadCallback=s;this._sScrollLoadDirection=a;this.onOverflowChange(o);return this;},
onOverflowChange:function(c){this._fnOverflowChangeCallback=c;if(!this._fnOverflowChangeCallback){this._deregisterOverflowMonitor();}},
setOnAfterScrollToElement:function(c){this._fnAfterScrollToElement=c;},
setIconTabBar:function(o,s,f){this._oIconTabBar=o;this._fnScrollEndCallback=q.proxy(s,o);this._fnScrollStartCallback=q.proxy(f,o);return this;},
scrollTo:function(x,y,t,s){this._scrollX=x;this._scrollY=y;this._scrollTo(x,y,t,s);return this;},
getChildPosition:function(e){var E=e instanceof q?e:q(e),o=E.position(),O=E.offsetParent(),a;while(!O.is(this._$Container)){a=O.position();o.top+=a.top;o.left+=a.left;O=O.offsetParent();}return o;},
scrollToElement:function(e,t,o){o=o||[0,0];if(!this._$Container[0].contains(e)||e.style.display==="none"||e.offsetParent.nodeName.toUpperCase()==="HTML"){return this;}var E=q(e),s=this.getChildPosition(E),l=this.getScrollLeft()+s.left+o[0],T=this.getScrollTop()+s.top+o[1];if(this._bFlipX){l=this.getScrollLeft()-(s.left-this._$Container.width())-E.width();}this._scrollTo(l,T,t,this._fnAfterScrollToElement);return this;},
destroy:function(){if(this._exit){this._exit();}if(this._oControl){this._oControl.removeDelegate(this);this._oControl=undefined;}},
refresh:function(){if(this._refresh){this._refresh();}},
_useDefaultScroll:function(t){return t.isContentEditable;},
onkeydown:function(e){if(this._useDefaultScroll(e.target)){return;}var c=this._$Container[0];if(e.altKey&&this.getHorizontal()){switch(e.keyCode){case K.PAGE_UP:this._customScrollTo(this._scrollX-c.clientWidth,this._scrollY,e);break;case K.PAGE_DOWN:this._customScrollTo(this._scrollX+c.clientWidth,this._scrollY,e);break;}}if(e.ctrlKey&&!e.altKey){switch(e.keyCode){case K.ARROW_UP:if(this.getVertical()){this._customScrollTo(this._scrollX,this._scrollY-c.clientHeight*this._scrollCoef,e);}break;case K.ARROW_DOWN:if(this.getVertical()){this._customScrollTo(this._scrollX,this._scrollY+c.clientHeight*this._scrollCoef,e);}break;case K.ARROW_LEFT:if(this.getHorizontal()){this._customScrollTo(this._scrollX-c.clientWidth,this._scrollY,e);}break;case K.ARROW_RIGHT:if(this.getHorizontal()){this._customScrollTo(this._scrollX+c.clientWidth,this._scrollY,e);}break;case K.HOME:if(this.getHorizontal()){this._customScrollTo(0,this._scrollY,e);}if(this.getVertical()){this._customScrollTo(this._scrollX,0,e);}break;case K.END:var l=c.scrollWidth-c.clientWidth;var t=c.scrollHeight-c.clientHeight;if(!this.getHorizontal()){t=this._scrollY;}if(!this.getVertical()){l=C.getConfiguration().getRTL()?c.clientWidth-c.scrollWidth:this._scrollX;}this._customScrollTo(l,t,e);break;}}},
_customScrollTo:function(l,t,e){var N=e.target.nodeName;if(N!="INPUT"&&N!="TEXTAREA"){e.preventDefault();e.setMarked();this._scrollTo(l,t);}}
});
var n={getScrollTop:function(){return this._scrollY||0;},getScrollLeft:function(){return this._scrollX||0;},getScrollHeight:function(){var c=this._$Container;return(c&&c[0])?c[0].scrollHeight:0;},getMaxScrollTop:function(){var c=this._$Container;return(c&&c[0])?c[0].scrollHeight-c[0].clientHeight:-1;},getContainerDomRef:function(){return this._$Container&&this._$Container[0];},_cleanup:function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._deregisterOverflowMonitor();},_setOverflow:function(){var c=this._$Container;if(!c||!c[0]){return;}if(D.os.ios){c.css("overflow-x",this._bHorizontal&&!this._bDragScroll?"scroll":"hidden").css("overflow-y",this._bVertical&&!this._bDragScroll?"scroll":"hidden").css("-webkit-overflow-scrolling","touch");}else{c.css("overflow-x",this._bHorizontal&&!this._bDragScroll?"auto":"hidden").css("overflow-y",this._bVertical&&!this._bDragScroll?"auto":"hidden");}},_refresh:function(){var c=this._$Container;if(!(c&&c.length)){return;}if(this._oPullDown&&this._oPullDown._bTouchMode){var d=this._oPullDown.getDomRef();if(d){d.style.marginTop=this._oPullDown._iState==2?"":"-"+d.offsetHeight+"px";}}if(c.scrollTop()!=this._scrollY){c.scrollTop(this._scrollY);}if(!(this._oPullDown&&this._oPullDown._bTouchMode)&&!this._fnScrollLoadCallback){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}},_onScroll:function(){var c=this._$Container,s=c.scrollTop(),v=s-this._scrollY;this._scrollX=c.scrollLeft();this._scrollY=s;if(this._fnScrollLoadCallback){if(this._sScrollLoadDirection=="Upwards"){if(v<0&&s<10){this._fnScrollLoadCallback();}}else if(v>=0&&c[0].scrollHeight-s-c[0].clientHeight<100){this._fnScrollLoadCallback();}}if(this._oIconTabBar&&this._fnScrollEndCallback){this._fnScrollEndCallback();}},_onStart:function(e){var c=this._$Container[0];if(!c){return;}this._bDoDrag=this._bDragScroll;var p=e.touches?e.touches[0]:e;this._iX=p.pageX;this._iY=p.pageY;this._bPullDown=false;this._iDirection="";},_onTouchMove:function(e){var c=this._$Container[0];var p=e.touches?e.touches[0]:e;var d=p.pageX-this._iX;var a=p.pageY-this._iY;if(this._iDirection==""){if(d!=0||a!=0){this._iDirection=Math.abs(a)>Math.abs(d)?"v":"h";}if(this._oPullDown&&this._oPullDown._bTouchMode&&this._iDirection=="v"&&c.scrollTop<=1){if(a>Math.abs(d)){this._bPullDown=true;}}}if(this._bPullDown===true){var b=this._oPullDown.getDomRef();var t=e.touches[0].pageY-this._iY-b.offsetHeight;if(t>20){t=20;}b.style.marginTop=t+"px";this._oPullDown.doPull(t);e.preventDefault();this._bDoDrag=false;}if(this._bDoDrag){var s=c.scrollLeft,f=c.scrollTop;if(this._bHorizontal){if(this._bFlipX){c.scrollLeft=s-this._iX+p.pageX;}else{c.scrollLeft=s+this._iX-p.pageX;}}if(this._bVertical){c.scrollTop=f+this._iY-p.pageY;}if((c.scrollLeft!=s)||(c.scrollTop!=f)){e.setMarked&&e.setMarked();e.preventDefault();}this._iX=p.pageX;this._iY=p.pageY;return;}},_onEnd:function(e){if(this._oPullDown&&this._oPullDown._bTouchMode){this._oPullDown.doScrollEnd();this._refresh();}if(this._bDragScroll&&this._iDirection){e.setMarked&&e.setMarked();}},_onMouseDown:function(e){if(this._bDragScroll&&e.button==0){this._bScrolling=true;this._onStart(e);}},_onMouseMove:function(E){if(this._bScrolling){var e=E.originalEvent||E;var b=e.buttons||e.which;if(b==1||E.pressure){var c=this._$Container[0];if(this._bHorizontal){if(this._bFlipX){c.scrollLeft=c.scrollLeft-this._iX+E.pageX;}else{c.scrollLeft=c.scrollLeft+this._iX-E.pageX;}}if(this._bVertical){c.scrollTop=c.scrollTop+this._iY-E.pageY;}this._iX=E.pageX;this._iY=E.pageY;}}},_onMouseUp:function(){if(this._bScrolling){this._bScrolling=false;this._onEnd();}},onBeforeRendering:function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._deregisterOverflowMonitor();var c=this._$Container;if(c){if(c.height()>0){this._scrollX=c.scrollLeft();this._scrollY=c.scrollTop();}c.off();}},_checkOverflowChange:function(e){var m=this.getMaxScrollTop(),o=m>0&&this._iLastMaxScrollTop===0,u=m===0&&this._iLastMaxScrollTop>0,O=o||u;if(O){this._fnOverflowChangeCallback(o,m);}this._iLastMaxScrollTop=m;},_registerOverflowMonitor:function(){this._fnOverflowChangeCallback&&I.addListener(this._checkOverflowChange,this);},_deregisterOverflowMonitor:function(){I.removeListener(this._checkOverflowChange,this);},onAfterRendering:function(){var c=this._$Container=this._sContainerId?q(document.getElementById(this._sContainerId)):q(document.getElementById(this._sContentId)).parent();var _=q.proxy(this._refresh,this);var e=c.is(":visible");c.addClass("sapUiScrollDelegate");this._setOverflow();if(this._scrollX!==0||this._scrollY!==0){this._scrollTo(this._scrollX,this._scrollY);}this._refresh();if(!e||this._oPullDown||this._fnScrollLoadCallback){this._sResizeListenerId=R.register(c[0],_);}if(this._fnOverflowChangeCallback){this._iOverflowTimer&&window.cancelAnimationFrame(this._iOverflowTimer);this._iOverflowTimer=window.requestAnimationFrame(this._registerOverflowMonitor.bind(this));}c.on("scroll",this._onScroll.bind(this));var o=c[0];function a(E,l){E.split(" ").forEach(function(s){o&&o.addEventListener(s,l);});}function b(E){return E.pointerType=="touch"?this._onStart(E):this._onMouseDown(E);}function d(E){return E.pointerType=="touch"?this._onTouchMove(E):this._onMouseMove(E);}function f(E){return E.pointerType=="touch"?this._onEnd(E):this._onMouseUp(E);}if(D.support.pointer&&D.system.desktop){if(this._bDragScroll){a("pointerdown",b.bind(this));a("pointermove",d.bind(this));a("pointerup pointercancel pointerleave",f.bind(this));}}else if(D.support.touch){if(this._bDragScroll||this._oPullDown&&this._oPullDown._bTouchMode){c.on("touchcancel touchend",this._onEnd.bind(this)).on("touchstart",this._onStart.bind(this)).on("touchmove",this._onTouchMove.bind(this));}}else if(this._bDragScroll){c.on("mouseup mouseleave",this._onMouseUp.bind(this)).on("mousedown",this._onMouseDown.bind(this)).on("mousemove",this._onMouseMove.bind(this));}},_readActualScrollPosition:function(){if(this._$Container.width()>0){this._scrollX=this._$Container.scrollLeft();}if(this._$Container.height()>0){this._scrollY=this._$Container.scrollTop();}},_scrollTo:function(x,y,t,s){if(this._$Container.length>0){if(t>0){this._$Container.finish().animate({scrollTop:y,scrollLeft:x},t,q.proxy(function(){this._readActualScrollPosition();s&&s();},this));}else{this._$Container.scrollTop(y);this._$Container.scrollLeft(x);this._readActualScrollPosition();s&&s();}}}};
function i(s){var d={_init:function(c,a,o){if(q.event&&q.event.special&&q.event.special.swipe&&q.event.special.swipe.scrollSupressionThreshold<120){q.event.special.swipe.scrollSupressionThreshold=120;}Object.assign(this,n);if(o.nonTouchScrolling===true){this._bDragScroll=true;}if(C.getConfiguration().getRTL()){this._scrollX=9999;}},_exit:function(){if(this._cleanup){this._cleanup();}}};Object.assign(s,d);}
return S;});
sap.ui.predefine('sap/ui/core/dnd/DragAndDrop',["sap/ui/Device","../UIArea","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(D,U,q){"use strict";var a={},d=null,o=null,v=null,V=[],b=[],c=null,$,g,C,t,l={},e;
function f(E,S){if(!E){return;}if(E.addStyleClass){E.addStyleClass(S);}else{E.$().addClass(S);}}
function r(E,S){if(!E){return;}if(E.removeStyleClass){E.removeStyleClass(S);}else{E.$().removeClass(S);}}
function h(E,i){var B=q(E.target).control(0,true);if(!B){return;}var N=q.Event(null,E);N.type=i;B.getUIArea()._handleEvent(N);}
function j(E){return!E.disabled&&/^(input|textarea)$/.test(E.localName);}
function s(d,E){if(!d||!d.getDragGhost){return;}var i=d.getDragGhost();if(!i){return;}if(!g){g=q('<div class="sapUiDnDGhostContainer"></div>');q(document.body).append(g);}g.append(i);window.setTimeout(function(){g.empty();},0);var O=E.originalEvent;O.dataTransfer.setDragImage(i,O.offsetX,O.offsetY);}
function k(E){var i={},I,B=E.originalEvent.dataTransfer,F=function(T,G){B.setData(T,G);};return{setData:function(K,G){G=""+G;i[K]=G;F(K,G);},getData:function(K){return i[K];},setTextData:function(G){G=""+G;i["text/plain"]=G;i["text"]=G;F("text/plain",G);F("text",G);},getTextData:function(){return i["text/plain"];},setComplexData:function(K,G){i[K]=G;},getComplexData:function(K){return i[K];},getIndicator:function(){return $&&$[0];},setIndicatorConfig:function(G){I=G;},getIndicatorConfig:function(G){return I;},getDragControl:function(){return d;},getDropControl:function(){return v;},setDropControl:function(G){v=G;},getDropInfo:function(){return b[0]||null;},getDropPosition:function(){return C;}};}
function m(E){d=o=v=c=null;C="";V=[];b=[];}
function n(){if($){return $;}$=q("<div class='sapUiDnDIndicator'></div>");q(sap.ui.getCore().getStaticAreaRef()).append($);return $;}
function p(){if($){$.removeAttr("style");$.hide();l={};}}
function u(E,i,B,F){if(!i){return;}var I=E.dragSession&&E.dragSession.getIndicatorConfig(),G=i.getBoundingClientRect(),P=window.pageYOffset,H=window.pageXOffset,J=n(),R,S={},K={top:G.top+P,bottom:G.bottom+P,left:G.left+H,right:G.right+H,width:G.width,height:G.height};if(!B||B=="On"){R="On";F="";}else if(F=="Horizontal"){var L=E.pageX-K.left;S.height=K.height;S.top=K.top;if(B=="Between"){S.width="";if(L<K.width*0.5){R="Before";S.left=K.left;}else{R="After";S.left=K.right;}}else if(B=="OnOrBetween"){if(L<K.width*0.25){R="Before";S.left=K.left;S.width="";}else if(L>K.width*0.75){R="After";S.left=K.right;S.width="";}else{R="On";}}if(R!="On"&&sap.ui.getCore().getConfiguration().getRTL()){R=(R=="After")?"Before":"After";}}else{var M=E.pageY-K.top;S.width=K.width;S.left=K.left;if(B=="Between"){S.height="";if(M<K.height*0.5){R="Before";S.top=K.top;}else{R="After";S.top=K.bottom;}}else if(B=="OnOrBetween"){if(M<K.height*0.25){R="Before";S.top=K.top;S.height="";}else if(M>K.height*0.75){R="After";S.top=K.bottom;S.height="";}else{R="On";}}}if(I&&I.display=="none"){return R;}if(R=="On"){S.top=K.top;S.left=K.left;S.width=K.width;S.height=K.height;B=R;}else{B="Between";}if(l.top!=S.top||l.left!=S.left||l.width!=S.width||l.height!=S.height){J.attr("data-drop-layout",F);J.attr("data-drop-position",B);J.css(Object.assign(S,I));J.show();l=S;}return R;}
function w(i){var P=i.getParent(),S=(i.getDragDropConfig)?i.getDragDropConfig():[],B=(P&&P.getDragDropConfig)?P.getDragDropConfig():[];return S.concat(B);}
function x(d){var i=w(d);return i.filter(function(B){return B.isDraggable(d);});}
function y(o,i,E){var B=w(o);i=i||[];return B.filter(function(F){return!F.isA("sap.ui.core.dnd.IDragInfo");}).concat(i).filter(function(F){if(!F.isDroppable(o,E)){return false;}var G=F.getGroupName();if(!G){return true;}return i.some(function(H){return H.getGroupName()==G;});});}
function z(E,i){E.preventDefault();var B=i.getDropEffect().toLowerCase();E.originalEvent.dataTransfer.dropEffect=B;}
function A(E,i,v){var T=i.getTargetAggregation();if(!T){return u(E,v.getDomRef());}var B;if(E.getMark("DragWithin")==T){B=v.getDomRefForSetting(T);}B=B||v.getDomRef();return u(E,B,i.getDropPosition(true),i.getDropLayout(true));}
a.preprocessEvent=function(E){if(c&&E.type.indexOf("dr")==0){E.dragSession=c;}var i="onbefore"+E.type;if(a[i]){a[i](E);}};
a.postprocessEvent=function(E){var i="onafter"+E.type;if(a[i]){a[i](E);}};
a.onbeforemousedown=function(E){if((D.browser.firefox)&&j(E.target)){e=q(E.target).closest("[data-sap-ui-draggable=true]").prop("draggable",false)[0];}};
a.onbeforemouseup=function(E){if(e){e.draggable=true;e=null;}};
a.onbeforedragstart=function(E){if(!E.target.draggable){return;}if(j(document.activeElement)){E.target.getAttribute("data-sap-ui-draggable")&&E.preventDefault();return;}d=q(E.target).control(0,true);if(!d){return;}V=x(d);if(!V.length){return;}if(D.browser.firefox&&E.originalEvent.dataTransfer.types.length===0){E.originalEvent.dataTransfer.setData("ui5/dummyDataForFirefox","data");}E.dragSession=c=k(E);};
a.onafterdragstart=function(E){if(!V.length||E.isDefaultPrevented()){m();return;}V=E.isMarked("NonDraggable")?[]:V.filter(function(i){return i.fireDragStart(E);});if(!V.length){E.preventDefault();m();return;}s(d,E);f(d,"sapUiDnDDragging");if(q(E.target).closest(".sapUiScrollDelegate")[0]){q("html").addClass("sapUiDnDNoScrolling");}};
a.onbeforedragenter=function(E){var B=q(E.target).control(0,true);if(B&&o===B){E.setMark("DragWithin","SameControl");}else{t=Date.now();o=B;}var F=[];v=B;for(var i=0;i<20&&v;i++,v=v.$&&v.$().parent().control(0,true)){F=y(v,V,E);if(F.length){break;}}if(E.getMark("DragWithin")!="SameControl"){b=F;if(c){c.setIndicatorConfig(null);}}if(!b.length){v=null;}else if(!c){E.dragSession=c=k(E);}};
a.onafterdragenter=function(E){if(!v||E.isMarked("NonDroppable")){b=[];}else if(E.getMark("DragWithin")!="SameControl"){b=b.filter(function(B){return B.fireDragEnter(E);});}var i=b[0];if(!i||i.getDropEffect()=="None"){p();C="";}else{z(E,i);C=A(E,i,v);}};
a.onbeforedragover=function(E){var i=Date.now();if(i-t>=1000){h(E,"longdragover");t=i;}};
a.onafterdragover=function(E){var i=b[0];if(!i||i.getDropEffect()=="None"){return;}b.forEach(function(B){B.fireDragOver(E);});z(E,i);if(i&&i.getDropPosition(true)=="On"){return;}C=A(E,i,v);};
a.onbeforedrop=function(E){if(b.length){E.preventDefault();}};
a.onafterdrop=function(E){b.forEach(function(i){i.fireDrop(E);});this.iDragEndTimer=window.requestAnimationFrame(this.onafterdragend.bind(this,E));};
a.onafterdragend=function(E){this.iDragEndTimer=window.cancelAnimationFrame(this.iDragEndTimer);V.forEach(function(i){i.fireDragEnd(E);});r(d,"sapUiDnDDragging");q("html").removeClass("sapUiDnDNoScrolling");p();m();};
U.addEventPreprocessor(a.preprocessEvent);U.addEventPostprocessor(a.postprocessEvent);return a;},true);
sap.ui.predefine('sap/ui/core/dnd/DragDropBase',['sap/base/Log','../Element','../library','./DragAndDrop'],function(L,E){"use strict";
var D=E.extend("sap.ui.core.dnd.DragDropBase",{metadata:{"abstract":true,library:"sap.ui.core",properties:{groupName:{type:"string",defaultValue:null,invalidate:false},enabled:{type:"boolean",defaultValue:true,invalidate:false}}}});
D.prototype.bIgnoreMetadataCheck=false;
D.prototype.isDraggable=function(c){return false;};
D.prototype.isDroppable=function(c,e){return false;};
D.prototype.checkMetadata=function(c,a,r){if(this.bIgnoreMetadataCheck){return true;}var m=c.getMetadata().getDragDropInfo(a);if(!m[r]){L.warning((a?a+" aggregation of ":"")+c+" is not configured to be "+r);return false;}return true;};
D.prototype.setProperty=function(p,v,s){s=(s==undefined)?(this.getMetadata().getProperty(p).appData||{}).invalidate===false:s;return E.prototype.setProperty.call(this,p,v,s);};
return D;});
sap.ui.predefine('sap/ui/core/dnd/DragDropInfo',["./DragInfo","./DropInfo","sap/ui/Device","sap/base/Log"],function(D,a,b,L){"use strict";
var c=a.extend("sap.ui.core.dnd.DragDropInfo",{metadata:{library:"sap.ui.core",interfaces:["sap.ui.core.dnd.IDragInfo","sap.ui.core.dnd.IDropInfo"],properties:{sourceAggregation:{type:"string",defaultValue:null}},associations:{targetElement:{type:"sap.ui.core.Element",multiple:false}},events:{dragStart:{allowPreventDefault:true},dragEnd:{}}}});
D.Mixin.apply(c.prototype);
c.prototype.getDropTarget=function(){var t=this.getTargetElement();if(t){return sap.ui.getCore().byId(t);}return this.getParent();};
c.prototype.setGroupName=function(){L.error("groupName property must not be set on "+this);return this;};
return c;});
sap.ui.predefine('sap/ui/core/dnd/DragInfo',["./DragDropBase"],function(D){"use strict";
var a=D.extend("sap.ui.core.dnd.DragInfo",{metadata:{library:"sap.ui.core",interfaces:["sap.ui.core.dnd.IDragInfo"],properties:{sourceAggregation:{type:"string",defaultValue:null}},events:{dragStart:{allowPreventDefault:true},dragEnd:{}}}});
a.Mixin=function(){this.isDraggable=function(c){if(!this.getEnabled()){return false;}var d=this.getParent();if(!d){return false;}var s=this.getSourceAggregation();if(!this.checkMetadata(d,s,"draggable")){return false;}if(d===c&&!s){return true;}if(c.getParent()===d&&s===c.sParentAggregationName){return true;}return false;};this.fireDragStart=function(e){if(!e||!e.dragSession){return;}var d=e.dragSession;return this.fireEvent("dragStart",{dragSession:d,browserEvent:e.originalEvent,target:d.getDragControl()},true);};this.fireDragEnd=function(e){if(!e||!e.dragSession){return;}var d=e.dragSession;return this.fireEvent("dragEnd",{dragSession:d,browserEvent:e.originalEvent,target:d.getDragControl()});};this.setEnabled=function(e){this.setProperty("enabled",e,false);this.invalidateDraggables();return this;};this.setParent=function(){D.prototype.setParent.apply(this,arguments);this.invalidateDraggables();return this;};this.setSourceAggregation=function(s){var o=this.getSourceAggregation();if(o==s){return this;}o&&this.invalidateDraggables();this.setProperty("sourceAggregation",s,false);this.invalidateDraggables();return this;};this.invalidateDraggables=function(){var p=this.getParent();if(p&&p.bOutput==true){var s=this.getSourceAggregation();if(s){[].concat(p.getAggregation(s)).forEach(function(A){if(A&&A.bOutput==true){A.invalidate();}});}else{p.invalidate();}}};};
a.Mixin.apply(a.prototype);return a;});
sap.ui.predefine('sap/ui/core/dnd/DropInfo',["./DragDropBase"],function(D){"use strict";
var a=D.extend("sap.ui.core.dnd.DropInfo",{metadata:{library:"sap.ui.core",interfaces:["sap.ui.core.dnd.IDropInfo"],properties:{targetAggregation:{type:"string",defaultValue:null,invalidate:false},dropEffect:{type:"sap.ui.core.dnd.DropEffect",defaultValue:"Move",invalidate:false},dropPosition:{type:"sap.ui.core.dnd.DropPosition",defaultValue:"On",invalidate:false},dropLayout:{type:"sap.ui.core.dnd.DropLayout",defaultValue:"Default",invalidate:false}},events:{dragEnter:{allowPreventDefault:true},dragOver:{},drop:{}}}});
a.prototype.getDropTarget=function(){return this.getParent();};
a.prototype.isDroppable=function(c,e){this.sTemporaryDropPosition="";if(!this.getEnabled()){return false;}var d=this.getDropTarget();if(!d){return false;}var t=this.getTargetAggregation();if(!this.checkMetadata(d,t,"droppable")){return false;}var t=this.getTargetAggregation();if(d===c&&!t){return true;}if(c.getParent()===d&&t===c.sParentAggregationName){return true;}if(e&&t&&d===c){var A=c.getDomRefForSetting(t);if(A&&A!=e.target&&A.contains(e.target)){e.setMark("DragWithin",t);this.sTemporaryDropPosition="On";return true;}}return false;};
a.prototype.getDropPosition=function(c){if(c&&this.sTemporaryDropPosition){return this.sTemporaryDropPosition;}return this.getProperty("dropPosition");};
a.prototype.getDropLayout=function(d){var s=this.getProperty("dropLayout");if(!d||s!="Default"){return s;}return this.getDropTarget().getMetadata().getDragDropInfo(this.getTargetAggregation()).layout;};
a.prototype.fireDragEnter=function(e){if(!e||!e.dragSession){return;}var d=e.dragSession;return this.fireEvent("dragEnter",{dragSession:e.dragSession,browserEvent:e.originalEvent,target:d.getDropControl()},true);};
a.prototype.fireDragOver=function(e){if(!e||!e.dragSession){return;}var d=e.dragSession;return this.fireEvent("dragOver",{dragSession:e.dragSession,browserEvent:e.originalEvent,target:d.getDropControl(),dropPosition:d.getDropPosition()});};
a.prototype.fireDrop=function(e){if(!e||!e.dragSession){return;}var d=e.dragSession;this.fireEvent("drop",{dragSession:e.dragSession,browserEvent:e.originalEvent,dropPosition:d.getDropPosition(),draggedControl:d.getDragControl(),droppedControl:d.getDropControl()});};
return a;});
sap.ui.predefine('sap/ui/core/format/DateFormat',['sap/ui/core/CalendarType','sap/ui/core/Locale','sap/ui/core/LocaleData','sap/ui/core/date/UniversalDate',"sap/base/util/deepEqual","sap/base/strings/formatMessage","sap/base/Log","sap/base/util/extend"],function(C,L,a,U,d,f,b,e){"use strict";var D=function(){throw new Error();};var c={};D.oDateInfo={oDefaultFormatOptions:{style:"medium",relativeScale:"day",relativeStyle:"wide"},aFallbackFormatOptions:[{style:"short"},{style:"medium"},{pattern:"yyyy-MM-dd"},{pattern:"yyyyMMdd",strictParsing:true}],bShortFallbackFormatOptions:true,bPatternFallbackWithoutDelimiter:true,getPattern:function(o,s,i){return o.getDatePattern(s,i);},oRequiredParts:{"text":true,"year":true,"weekYear":true,"month":true,"day":true},aRelativeScales:["year","month","week","day"],aRelativeParseScales:["year","quarter","month","week","day","hour","minute","second"],aIntervalCompareFields:["Era","FullYear","Quarter","Month","Week","Date"]};D.oDateTimeInfo={oDefaultFormatOptions:{style:"medium",relativeScale:"auto",relativeStyle:"wide"},aFallbackFormatOptions:[{style:"short"},{style:"medium"},{pattern:"yyyy-MM-dd'T'HH:mm:ss"},{pattern:"yyyyMMdd HHmmss"}],getPattern:function(o,s,i){var S=s.indexOf("/");if(S>0){return o.getCombinedDateTimePattern(s.substr(0,S),s.substr(S+1),i);}else{return o.getCombinedDateTimePattern(s,s,i);}},oRequiredParts:{"text":true,"year":true,"weekYear":true,"month":true,"day":true,"hour0_23":true,"hour1_24":true,"hour0_11":true,"hour1_12":true},aRelativeScales:["year","month","week","day","hour","minute","second"],aRelativeParseScales:["year","quarter","month","week","day","hour","minute","second"],aIntervalCompareFields:["Era","FullYear","Quarter","Month","Week","Date","DayPeriod","Hours","Minutes","Seconds"]};D.oTimeInfo={oDefaultFormatOptions:{style:"medium",relativeScale:"auto",relativeStyle:"wide"},aFallbackFormatOptions:[{style:"short"},{style:"medium"},{pattern:"HH:mm:ss"},{pattern:"HHmmss"}],getPattern:function(o,s,i){return o.getTimePattern(s,i);},oRequiredParts:{"text":true,"hour0_23":true,"hour1_24":true,"hour0_11":true,"hour1_12":true},aRelativeScales:["hour","minute","second"],aRelativeParseScales:["year","quarter","month","week","day","hour","minute","second"],aIntervalCompareFields:["DayPeriod","Hours","Minutes","Seconds"]};
D.getInstance=function(o,i){return this.getDateInstance(o,i);};
D.getDateInstance=function(o,i){return this.createInstance(o,i,this.oDateInfo);};
D.getDateTimeInstance=function(o,i){return this.createInstance(o,i,this.oDateTimeInfo);};
D.getTimeInstance=function(o,i){return this.createInstance(o,i,this.oTimeInfo);};
function g(o){var P=o.oLocaleData.getIntervalPattern("",o.oFormatOptions.calendarType);P=P.replace(/[^\{\}01 ]/,"-");return P.replace(/\{(0|1)\}/g,o.oFormatOptions.pattern);}
D.createInstance=function(o,i,I){var j=Object.create(this.prototype);if(o instanceof L){i=o;o=undefined;}if(!i){i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();}j.oLocale=i;j.oLocaleData=a.getInstance(i);j.oFormatOptions=e({},I.oDefaultFormatOptions,o);if(!j.oFormatOptions.calendarType){j.oFormatOptions.calendarType=sap.ui.getCore().getConfiguration().getCalendarType();}if(!j.oFormatOptions.pattern){if(j.oFormatOptions.format){j.oFormatOptions.pattern=j.oLocaleData.getCustomDateTimePattern(j.oFormatOptions.format,j.oFormatOptions.calendarType);}else{j.oFormatOptions.pattern=I.getPattern(j.oLocaleData,j.oFormatOptions.style,j.oFormatOptions.calendarType);}}if(j.oFormatOptions.interval){if(j.oFormatOptions.format){j.intervalPatterns=j.oLocaleData.getCustomIntervalPattern(j.oFormatOptions.format,null,j.oFormatOptions.calendarType);if(typeof j.intervalPatterns==="string"){j.intervalPatterns=[j.intervalPatterns];}j.intervalPatterns.push(j.oLocaleData.getCustomDateTimePattern(j.oFormatOptions.format,j.oFormatOptions.calendarType));}else{j.intervalPatterns=[j.oLocaleData.getCombinedIntervalPattern(j.oFormatOptions.pattern,j.oFormatOptions.calendarType),j.oFormatOptions.pattern];}var s=g(j);j.intervalPatterns.push(s);}if(!j.oFormatOptions.fallback){if(!I.oFallbackFormats){I.oFallbackFormats={};}var q=i.toString(),t=j.oFormatOptions.calendarType,K=q+"-"+t,P,u;if(j.oFormatOptions.pattern&&I.bPatternFallbackWithoutDelimiter){K=K+"-"+j.oFormatOptions.pattern;}if(j.oFormatOptions.interval){K=K+"-"+"interval";}var v=I.oFallbackFormats[K]?Object.assign({},I.oFallbackFormats[K]):undefined;if(!v){u=I.aFallbackFormatOptions;if(I.bShortFallbackFormatOptions){P=I.getPattern(j.oLocaleData,"short");u=u.concat(D._createFallbackOptionsWithoutDelimiter(P));}if(j.oFormatOptions.pattern&&I.bPatternFallbackWithoutDelimiter){u=D._createFallbackOptionsWithoutDelimiter(j.oFormatOptions.pattern).concat(u);}v=D._createFallbackFormat(u,t,i,I,j.oFormatOptions.interval);}j.aFallbackFormats=v;}j.oRequiredParts=I.oRequiredParts;j.aRelativeScales=I.aRelativeScales;j.aRelativeParseScales=I.aRelativeParseScales;j.aIntervalCompareFields=I.aIntervalCompareFields;j.init();return j;};
D.prototype.init=function(){var s=this.oFormatOptions.calendarType;this.aMonthsAbbrev=this.oLocaleData.getMonths("abbreviated",s);this.aMonthsWide=this.oLocaleData.getMonths("wide",s);this.aMonthsNarrow=this.oLocaleData.getMonths("narrow",s);this.aMonthsAbbrevSt=this.oLocaleData.getMonthsStandAlone("abbreviated",s);this.aMonthsWideSt=this.oLocaleData.getMonthsStandAlone("wide",s);this.aMonthsNarrowSt=this.oLocaleData.getMonthsStandAlone("narrow",s);this.aDaysAbbrev=this.oLocaleData.getDays("abbreviated",s);this.aDaysWide=this.oLocaleData.getDays("wide",s);this.aDaysNarrow=this.oLocaleData.getDays("narrow",s);this.aDaysShort=this.oLocaleData.getDays("short",s);this.aDaysAbbrevSt=this.oLocaleData.getDaysStandAlone("abbreviated",s);this.aDaysWideSt=this.oLocaleData.getDaysStandAlone("wide",s);this.aDaysNarrowSt=this.oLocaleData.getDaysStandAlone("narrow",s);this.aDaysShortSt=this.oLocaleData.getDaysStandAlone("short",s);this.aQuartersAbbrev=this.oLocaleData.getQuarters("abbreviated",s);this.aQuartersWide=this.oLocaleData.getQuarters("wide",s);this.aQuartersNarrow=this.oLocaleData.getQuarters("narrow",s);this.aQuartersAbbrevSt=this.oLocaleData.getQuartersStandAlone("abbreviated",s);this.aQuartersWideSt=this.oLocaleData.getQuartersStandAlone("wide",s);this.aQuartersNarrowSt=this.oLocaleData.getQuartersStandAlone("narrow",s);this.aErasNarrow=this.oLocaleData.getEras("narrow",s);this.aErasAbbrev=this.oLocaleData.getEras("abbreviated",s);this.aErasWide=this.oLocaleData.getEras("wide",s);this.aDayPeriods=this.oLocaleData.getDayPeriods("abbreviated",s);this.aFormatArray=this.parseCldrDatePattern(this.oFormatOptions.pattern);this.sAllowedCharacters=this.getAllowedCharacters(this.aFormatArray);};
D._createFallbackFormat=function(i,s,o,I,j){return i.map(function(O){var q=Object.assign({},O);if(j){q.interval=true;}q.calendarType=s;q.fallback=true;var t=D.createInstance(q,o,I);t.bIsFallback=true;return t;});};
D._createFallbackOptionsWithoutDelimiter=function(B){var i=/[^dMyGU]/g,o={regex:/d+/g,replace:"dd"},M={regex:/M+/g,replace:"MM"},y={regex:/[yU]+/g,replace:["yyyy","yy"]};B=B.replace(i,"");B=B.replace(o.regex,o.replace);B=B.replace(M.regex,M.replace);return y.replace.map(function(R){return{pattern:B.replace(y.regex,R),strictParsing:true};});};
var p={isNumber:function(i){return i>=48&&i<=57;},findNumbers:function(v,M){var i=0;while(i<M&&this.isNumber(v.charCodeAt(i))){i++;}if(typeof v!=="string"){v=v.toString();}return v.substr(0,i);},findEntry:function(v,i){var o=-1,M=0;for(var j=0;j<i.length;j++){if(i[j]&&i[j].length>M&&v.indexOf(i[j])===0){o=j;M=i[j].length;}}return{index:o,value:o===-1?null:i[o]};},parseTZ:function(v,i){var j=0;var t=v.charAt(0)=="+"?-1:1;var P;j++;P=this.findNumbers(v.substr(j),2);var T=parseInt(P);j+=2;if(i){j++;}P=this.findNumbers(v.substr(j),2);var o=0;if(P){j+=2;o=parseInt(P);}return{length:j,tzDiff:(o+60*T)*t};},checkValid:function(t,P,o){if(t in o.oRequiredParts&&P){return false;}}};D.prototype.oSymbols={"":{name:"text",format:function(o,i,u,j){return o.value;},parse:function(v,P,o,i){var s;var V=true;var j=0;var q=0;var t="\u002d\u007E\u2010\u2011\u2012\u2013\u2014\ufe58\ufe63\uff0d\uFF5E";for(;q<P.value.length;q++){s=P.value.charAt(q);if(s===" "){while(v.charAt(j)===" "){j++;}}else if(t.includes(s)){if(!t.includes(v.charAt(j))){V=false;}j++;}else{if(v.charAt(j)!==s){V=false;}j++;}if(!V){break;}}if(V){return{length:j};}else{var u=false;if(i.index<i.formatArray.length-1){u=(i.formatArray[i.index+1].type in o.oRequiredParts);}return{valid:p.checkValid(P.type,u,o)};}}},"G":{name:"era",format:function(o,i,u,j){var E=u?i.getUTCEra():i.getEra();if(o.digits<=3){return j.aErasAbbrev[E];}else if(o.digits===4){return j.aErasWide[E];}else{return j.aErasNarrow[E];}},parse:function(v,P,o,j){var E=[o.aErasWide,o.aErasAbbrev,o.aErasNarrow];for(var i=0;i<E.length;i++){var V=E[i];var q=p.findEntry(v,V);if(q.index!==-1){return{era:q.index,length:q.value.length};}}return{era:o.aErasWide.length-1,valid:p.checkValid(P.type,true,o)};}},"y":{name:"year",format:function(o,i,u,j){var y=u?i.getUTCFullYear():i.getFullYear();var Y=String(y);var s=j.oFormatOptions.calendarType;if(o.digits==2&&Y.length>2){Y=Y.substr(Y.length-2);}if(s!=C.Japanese&&o.digits==1&&y<100){Y=Y.padStart(4,"0");}return Y.padStart(o.digits,"0");},parse:function(v,P,o,i){var s=o.oFormatOptions.calendarType;var j;if(P.digits==1){j=p.findNumbers(v,4);}else if(P.digits==2){j=p.findNumbers(v,2);}else{j=p.findNumbers(v,P.digits);}var y=parseInt(j);if(s!=C.Japanese&&j.length<=2){var q=U.getInstance(new Date(),s),t=q.getFullYear(),u=Math.floor(t/100),Y=u*100+y-t;if(Y<-70){y+=(u+1)*100;}else if(Y<30){y+=u*100;}else{y+=(u-1)*100;}}return{length:j.length,valid:p.checkValid(P.type,j==="",o),year:y};}},"Y":{name:"weekYear",format:function(o,i,u,j){var w=u?i.getUTCWeek():i.getWeek();var W=w.year;var s=String(W);var q=j.oFormatOptions.calendarType;if(o.digits==2&&s.length>2){s=s.substr(s.length-2);}if(q!=C.Japanese&&o.digits==1&&W<100){s=s.padStart(4,"0");}return s.padStart(o.digits,"0");},parse:function(v,P,o,i){var s=o.oFormatOptions.calendarType;var j;if(P.digits==1){j=p.findNumbers(v,4);}else if(P.digits==2){j=p.findNumbers(v,2);}else{j=p.findNumbers(v,P.digits);}var y=parseInt(j);var w;if(s!=C.Japanese&&j.length<=2){var q=U.getInstance(new Date(),s),t=q.getFullYear(),u=Math.floor(t/100),Y=u*100+w-t;if(Y<-70){w+=(u+1)*100;}else if(Y<30){w+=u*100;}else{w+=(u-1)*100;}}return{length:j.length,valid:p.checkValid(P.type,j==="",o),year:y,weekYear:w};}},"M":{name:"month",format:function(o,i,u,j){var M=u?i.getUTCMonth():i.getMonth();if(o.digits==3){return j.aMonthsAbbrev[M];}else if(o.digits==4){return j.aMonthsWide[M];}else if(o.digits>4){return j.aMonthsNarrow[M];}else{return String(M+1).padStart(o.digits,"0");}},parse:function(v,P,o,j){var M=[o.aMonthsWide,o.aMonthsWideSt,o.aMonthsAbbrev,o.aMonthsAbbrevSt,o.aMonthsNarrow,o.aMonthsNarrowSt];var V;var q;var s;if(P.digits<3){s=p.findNumbers(v,Math.max(P.digits,2));V=p.checkValid(P.type,s==="",o);q=parseInt(s)-1;if(j.strict&&(q>11||q<0)){V=false;}}else{for(var i=0;i<M.length;i++){var t=M[i];var u=p.findEntry(v,t);if(u.index!==-1){return{month:u.index,length:u.value.length};}}V=p.checkValid(P.type,true,o);}return{month:q,length:s?s.length:0,valid:V};}},"L":{name:"monthStandalone",format:function(o,i,u,j){var M=u?i.getUTCMonth():i.getMonth();if(o.digits==3){return j.aMonthsAbbrevSt[M];}else if(o.digits==4){return j.aMonthsWideSt[M];}else if(o.digits>4){return j.aMonthsNarrowSt[M];}else{return String(M+1).padStart(o.digits,"0");}},parse:function(v,P,o,j){var M=[o.aMonthsWide,o.aMonthsWideSt,o.aMonthsAbbrev,o.aMonthsAbbrevSt,o.aMonthsNarrow,o.aMonthsNarrowSt];var V;var q;var s;if(P.digits<3){s=p.findNumbers(v,Math.max(P.digits,2));V=p.checkValid(P.type,s==="",o);q=parseInt(s)-1;if(j.strict&&(q>11||q<0)){V=false;}}else{for(var i=0;i<M.length;i++){var t=M[i];var u=p.findEntry(v,t);if(u.index!==-1){return{month:u.index,length:u.value.length};}}V=p.checkValid(P.type,true,o);}return{month:q,length:s?s.length:0,valid:V};}},"w":{name:"weekInYear",format:function(o,i,u,j){var w=u?i.getUTCWeek():i.getWeek();var W=w.week;var s=String(W+1);if(o.digits<3){s=s.padStart(o.digits,"0");}else{s=j.oLocaleData.getCalendarWeek(o.digits===3?"narrow":"wide",s.padStart(2,"0"));}return s;},parse:function(v,P,o,i){var V;var s;var w;var j=0;if(P.digits<3){s=p.findNumbers(v,2);j=s.length;w=parseInt(s)-1;V=p.checkValid(P.type,!s,o);}else{s=o.oLocaleData.getCalendarWeek(P.digits===3?"narrow":"wide");s=s.replace("{0}","[0-9]+");var q=new RegExp(s),R=q.exec(v);if(R){j=R[0].length;w=parseInt(R[0])-1;}else{V=p.checkValid(P.type,true,o);}}return{length:j,valid:V,week:w};}},"W":{name:"weekInMonth",format:function(o,i,u,j){return"";},parse:function(){return{};}},"D":{name:"dayInYear",format:function(o,i,u,j){},parse:function(){return{};}},"d":{name:"day",format:function(o,i,u,j){var q=u?i.getUTCDate():i.getDate();return String(q).padStart(o.digits,"0");},parse:function(v,P,o,i){var s=p.findNumbers(v,Math.max(P.digits,2));var V=p.checkValid(P.type,s==="",o);var j=parseInt(s);if(i.strict&&(j>31||j<1)){V=false;}return{day:j,length:s.length,valid:V};}},"Q":{name:"quarter",format:function(o,i,u,j){var q=u?i.getUTCQuarter():i.getQuarter();if(o.digits==3){return j.aQuartersAbbrev[q];}else if(o.digits==4){return j.aQuartersWide[q];}else if(o.digits>4){return j.aQuartersNarrow[q];}else{return String(q+1).padStart(o.digits,"0");}},parse:function(v,P,o,j){var V;var q;var s;var Q=[o.aQuartersWide,o.aQuartersWideSt,o.aQuartersAbbrev,o.aQuartersAbbrevSt,o.aQuartersNarrow,o.aQuartersNarrowSt];if(P.digits<3){s=p.findNumbers(v,Math.max(P.digits,2));V=p.checkValid(P.type,s==="",o);q=parseInt(s)-1;if(j.strict&&q>3){V=false;}}else{for(var i=0;i<Q.length;i++){var t=Q[i];var u=p.findEntry(v,t);if(u.index!==-1){return{quarter:u.index,length:u.value.length};}}V=p.checkValid(P.type,true,o);}return{length:s?s.length:0,quarter:q,valid:V};}},"q":{name:"quarterStandalone",format:function(o,i,u,j){var q=u?i.getUTCQuarter():i.getQuarter();if(o.digits==3){return j.aQuartersAbbrevSt[q];}else if(o.digits==4){return j.aQuartersWideSt[q];}else if(o.digits>4){return j.aQuartersNarrowSt[q];}else{return String(q+1).padStart(o.digits,"0");}},parse:function(v,P,o,j){var V;var q;var s;var Q=[o.aQuartersWide,o.aQuartersWideSt,o.aQuartersAbbrev,o.aQuartersAbbrevSt,o.aQuartersNarrow,o.aQuartersNarrowSt];if(P.digits<3){s=p.findNumbers(v,Math.max(P.digits,2));V=p.checkValid(P.type,s==="",o);q=parseInt(s)-1;if(j.strict&&q>3){V=false;}}else{for(var i=0;i<Q.length;i++){var t=Q[i];var u=p.findEntry(v,t);if(u.index!==-1){return{quarter:u.index,length:u.value.length};}}V=p.checkValid(P.type,true,o);}return{length:s?s.length:0,quarter:q,valid:V};}},"F":{name:"dayOfWeekInMonth",format:function(o,i,u,j){return"";},parse:function(){return{};}},"E":{name:"dayNameInWeek",format:function(o,i,u,j){var q=u?i.getUTCDay():i.getDay();if(o.digits<4){return j.aDaysAbbrev[q];}else if(o.digits==4){return j.aDaysWide[q];}else if(o.digits==5){return j.aDaysNarrow[q];}else{return j.aDaysShort[q];}},parse:function(v,P,o,j){var q=[o.aDaysWide,o.aDaysWideSt,o.aDaysAbbrev,o.aDaysAbbrevSt,o.aDaysShort,o.aDaysShortSt,o.aDaysNarrow,o.aDaysNarrowSt];for(var i=0;i<q.length;i++){var V=q[i];var s=p.findEntry(v,V);if(s.index!==-1){return{dayOfWeek:s.index,length:s.value.length};}}}},"c":{name:"dayNameInWeekStandalone",format:function(o,i,u,j){var q=u?i.getUTCDay():i.getDay();if(o.digits<4){return j.aDaysAbbrevSt[q];}else if(o.digits==4){return j.aDaysWideSt[q];}else if(o.digits==5){return j.aDaysNarrowSt[q];}else{return j.aDaysShortSt[q];}},parse:function(v,P,o,j){var q=[o.aDaysWide,o.aDaysWideSt,o.aDaysAbbrev,o.aDaysAbbrevSt,o.aDaysShort,o.aDaysShortSt,o.aDaysNarrow,o.aDaysNarrowSt];for(var i=0;i<q.length;i++){var V=q[i];var s=p.findEntry(v,V);if(s.index!==-1){return{day:s.index,length:s.value.length};}}}},"u":{name:"dayNumberOfWeek",format:function(o,i,u,j){var q=u?i.getUTCDay():i.getDay();return j._adaptDayOfWeek(q);},parse:function(v,P,o,i){var s=p.findNumbers(v,P.digits);return{dayNumberOfWeek:parseInt(s),length:s.length};}},"a":{name:"amPmMarker",format:function(o,i,u,j){var q=u?i.getUTCDayPeriod():i.getDayPeriod();return j.aDayPeriods[q];},parse:function(v,P,o,i){var j;var q;var A=o.aDayPeriods[0],s=o.aDayPeriods[1];var t=/[aApP](?:\.)?[\x20\xA0]?[mM](?:\.)?/;var M=v.match(t);var V=(M&&M.index===0);if(V){v=M[0];A=A.replace(/[\x20\xA0]/g,"");s=s.replace(/[\x20\xA0]/g,"");v=v.replace(/[\x20\xA0]/g,"");A=A.replace(/\./g,"").toLowerCase();s=s.replace(/\./g,"").toLowerCase();v=v.replace(/\./g,"").toLowerCase();}if(v.indexOf(A)===0){j=false;q=(V?M[0].length:A.length);}else if(v.indexOf(s)===0){j=true;q=(V?M[0].length:s.length);}return{pm:j,length:q};}},"H":{name:"hour0_23",format:function(o,i,u,j){var H=u?i.getUTCHours():i.getHours();return String(H).padStart(o.digits,"0");},parse:function(v,P,o,i){var V;var s=p.findNumbers(v,Math.max(P.digits,2));var H=parseInt(s);V=p.checkValid(P.type,s==="",o);if(i.strict&&H>23){V=false;}return{hour:H,length:s.length,valid:V};}},"k":{name:"hour1_24",format:function(o,i,u,j){var H=u?i.getUTCHours():i.getHours();var s=(H===0?"24":String(H));return s.padStart(o.digits,"0");},parse:function(v,P,o,i){var V;var s=p.findNumbers(v,Math.max(P.digits,2));var H=parseInt(s);V=p.checkValid(P.type,s==="",o);if(H==24){H=0;}if(i.strict&&H>23){V=false;}return{hour:H,length:s.length,valid:V};}},"K":{name:"hour0_11",format:function(o,i,u,j){var H=u?i.getUTCHours():i.getHours();var s=String(H>11?H-12:H);return s.padStart(o.digits,"0");},parse:function(v,P,o,i){var V;var s=p.findNumbers(v,Math.max(P.digits,2));var H=parseInt(s);V=p.checkValid(P.type,s==="",o);if(i.strict&&H>11){V=false;}return{hour:H,length:s.length,valid:V};}},"h":{name:"hour1_12",format:function(o,i,u,j){var H=u?i.getUTCHours():i.getHours();var s;if(H>12){s=String(H-12);}else if(H==0){s="12";}else{s=String(H);}return s.padStart(o.digits,"0");},parse:function(v,P,o,i){var j=i.dateValue.pm;var s=p.findNumbers(v,Math.max(P.digits,2));var H=parseInt(s);var V=p.checkValid(P.type,s==="",o);if(H==12){H=0;j=(j===undefined)?true:j;}if(i.strict&&H>11){V=false;}return{hour:H,length:s.length,pm:j,valid:V};}},"m":{name:"minute",format:function(o,i,u,j){var M=u?i.getUTCMinutes():i.getMinutes();return String(M).padStart(o.digits,"0");},parse:function(v,P,o,i){var V;var s=p.findNumbers(v,Math.max(P.digits,2));var M=parseInt(s);V=p.checkValid(P.type,s==="",o);if(i.strict&&M>59){V=false;}return{length:s.length,minute:M,valid:V};}},"s":{name:"second",format:function(o,i,u,j){var s=u?i.getUTCSeconds():i.getSeconds();return String(s).padStart(o.digits,"0");},parse:function(v,P,o,i){var V;var s=p.findNumbers(v,Math.max(P.digits,2));var S=parseInt(s);V=p.checkValid(P.type,s==="",o);if(i.strict&&S>59){V=false;}return{length:s.length,second:S,valid:V};}},"S":{name:"fractionalsecond",format:function(o,i,u,j){var M=u?i.getUTCMilliseconds():i.getMilliseconds();var s=String(M);var q=s.padStart(3,"0");q=q.substr(0,o.digits);q=q.padEnd(o.digits,"0");return q;},parse:function(v,P,o,i){var s=p.findNumbers(v,P.digits);var j=s.length;s=s.substr(0,3);s=s.padEnd(3,"0");var M=parseInt(s);return{length:j,millisecond:M};}},"z":{name:"timezoneGeneral",format:function(o,i,u,j){if(o.digits>3&&i.getTimezoneLong&&i.getTimezoneLong()){return i.getTimezoneLong();}else if(i.getTimezoneShort&&i.getTimezoneShort()){return i.getTimezoneShort();}var t="GMT";var T=Math.abs(i.getTimezoneOffset());var P=i.getTimezoneOffset()>0;var H=Math.floor(T/60);var M=T%60;if(!u&&T!=0){t+=(P?"-":"+");t+=String(H).padStart(2,"0");t+=":";t+=String(M).padStart(2,"0");}else{t+="Z";}return t;},parse:function(v,P,o,i){var j=0;var t;var T=v.substring(0,3);if(T==="GMT"||T==="UTC"){j=3;}else if(v.substring(0,2)==="UT"){j=2;}else if(v.charAt(0)==="Z"){j=1;t=0;}else{return{error:"cannot be parsed correctly by sap.ui.core.format.DateFormat: The given timezone is not supported!"};}if(v.charAt(0)!=="Z"){var q=p.parseTZ(v.substr(j),true);j+=q.length;t=q.tzDiff;}return{length:j,tzDiff:t};}},"Z":{name:"timezoneRFC822",format:function(o,i,u,j){var t=Math.abs(i.getTimezoneOffset());var P=i.getTimezoneOffset()>0;var H=Math.floor(t/60);var M=t%60;var T="";if(!u){T+=(P?"-":"+");T+=String(H).padStart(2,"0");T+=String(M).padStart(2,"0");}return T;},parse:function(v,P,o,i){return p.parseTZ(v,false);}},"X":{name:"timezoneISO8601",format:function(o,i,u,j){var t=Math.abs(i.getTimezoneOffset());var P=i.getTimezoneOffset()>0;var H=Math.floor(t/60);var M=t%60;var T="";if(!u&&t!=0){T+=(P?"-":"+");T+=String(H).padStart(2,"0");if(o.digits>1||M>0){if(o.digits===3||o.digits===5){T+=":";}T+=String(M).padStart(2,"0");}}else{T+="Z";}return T;},parse:function(v,P,o,i){if(v.charAt(0)==="Z"){return{length:1,tzDiff:0};}else{return p.parseTZ(v,P.digits===3||P.digits===5);}}}};
D.prototype._format=function(j,u){if(this.oFormatOptions.relative){var R=this.formatRelative(j,u,this.oFormatOptions.relativeRange);if(R){return R;}}var s=this.oFormatOptions.calendarType;var o=U.getInstance(j,s);var B=[],P,q,S;for(var i=0;i<this.aFormatArray.length;i++){P=this.aFormatArray[i];S=P.symbol||"";B.push(this.oSymbols[S].format(P,o,u,this));}q=B.join("");if(sap.ui.getCore().getConfiguration().getOriginInfo()){q=new String(q);q.originInfo={source:"Common Locale Data Repository",locale:this.oLocale.toString(),style:this.oFormatOptions.style,pattern:this.oFormatOptions.pattern};}return q;};
D.prototype.format=function(j,u){var s=this.oFormatOptions.calendarType,R;if(u===undefined){u=this.oFormatOptions.UTC;}if(Array.isArray(j)){if(!this.oFormatOptions.interval){b.error("Non-interval DateFormat can't format more than one date instance.");return"";}if(j.length!==2){b.error("Interval DateFormat can only format with 2 date instances but "+j.length+" is given.");return"";}if(this.oFormatOptions.singleIntervalValue){if(j[0]===null){b.error("First date instance which is passed to the interval DateFormat shouldn't be null.");return"";}if(j[1]===null){R=this._format(j[0],u);}}if(R===undefined){var v=j.every(function(J){return J&&!isNaN(J.getTime());});if(!v){b.error("At least one date instance which is passed to the interval DateFormat isn't valid.");return"";}R=this._formatInterval(j,u);}}else{if(!j||isNaN(j.getTime())){b.error("The given date instance isn't valid.");return"";}if(this.oFormatOptions.interval){b.error("Interval DateFormat expects an array with two dates for the first argument but only one date is given.");return"";}R=this._format(j,u);}if(s==C.Japanese&&this.oLocale.getLanguage()==="ja"){R=R.replace(/(^|[^\d])1年/g,"$1元年");}return R;};
D.prototype._formatInterval=function(j,u){var s=this.oFormatOptions.calendarType;var o=U.getInstance(j[0],s);var t=U.getInstance(j[1],s);var q;var P;var S;var B=[];var v;var w=[];var x=this._getGreatestDiffField([o,t],u);if(!x){return this._format(j[0],u);}if(this.oFormatOptions.format){v=this.oLocaleData.getCustomIntervalPattern(this.oFormatOptions.format,x,s);}else{v=this.oLocaleData.getCombinedIntervalPattern(this.oFormatOptions.pattern,s);}w=this.parseCldrDatePattern(v);q=o;for(var i=0;i<w.length;i++){P=w[i];S=P.symbol||"";if(P.repeat){q=t;}B.push(this.oSymbols[S].format(P,q,u,this));}return B.join("");};
var F={Era:"Era",FullYear:"Year",Quarter:"Quarter",Month:"Month",Week:"Week",Date:"Day",DayPeriod:"DayPeriod",Hours:"Hour",Minutes:"Minute",Seconds:"Second"};
D.prototype._getGreatestDiffField=function(i,u){var j=false,o={};this.aIntervalCompareFields.forEach(function(s){var G="get"+(u?"UTC":""),M=G+s,q=F[s],v=i[0][M].apply(i[0]),t=i[1][M].apply(i[1]);if(!d(v,t)){j=true;o[q]=true;}});if(j){return o;}return null;};
D.prototype._parse=function(v,j,u,s){var I=0,P,S,R;var o={valid:true};var q={formatArray:j,dateValue:o,strict:s};for(var i=0;i<j.length;i++){S=v.substr(I);P=j[i];q.index=i;R=this.oSymbols[P.symbol||""].parse(S,P,this,q)||{};o=e(o,R);if(R.valid===false){break;}I+=R.length||0;}o.index=I;if(o.pm){o.hour+=12;}if(o.dayNumberOfWeek===undefined&&o.dayOfWeek!==undefined){o.dayNumberOfWeek=this._adaptDayOfWeek(o.dayOfWeek);}if(o.quarter!==undefined&&o.month===undefined&&o.day===undefined){o.month=3*o.quarter;o.day=1;}return o;};
D.prototype._parseInterval=function(v,s,u,S){var j,R,o;this.intervalPatterns.some(function(P){var q=this.parseCldrDatePattern(P);R=undefined;for(var i=0;i<q.length;i++){if(q[i].repeat){R=i;break;}}if(R===undefined){o=this._parse(v,q,u,S);if(o.index===0||o.index<v.length){o.valid=false;}if(o.valid===false){return;}j=[o,o];return true;}else{j=[];o=this._parse(v,q.slice(0,R),u,S);if(o.valid===false){return;}j.push(o);var t=o.index;o=this._parse(v.substring(t),q.slice(R),u,S);if(o.index===0||o.index+t<v.length){o.valid=false;}if(o.valid===false){return;}j.push(o);return true;}}.bind(this));return j;};
var h=function(o,s,u,S){var i,y=typeof o.year==="number"?o.year:1970;if(o.valid){if(u||o.tzDiff!==undefined){i=U.getInstance(new Date(0),s);i.setUTCEra(o.era||U.getCurrentEra(s));i.setUTCFullYear(y);i.setUTCMonth(o.month||0);i.setUTCDate(o.day||1);i.setUTCHours(o.hour||0);i.setUTCMinutes(o.minute||0);i.setUTCSeconds(o.second||0);i.setUTCMilliseconds(o.millisecond||0);if(S&&(o.day||1)!==i.getUTCDate()){o.valid=false;i=undefined;}else{if(o.tzDiff){i.setUTCMinutes((o.minute||0)+o.tzDiff);}if(o.week!==undefined&&(o.month===undefined||o.day===undefined)){i.setUTCWeek({year:o.weekYear||o.year,week:o.week});if(o.dayNumberOfWeek!==undefined){i.setUTCDate(i.getUTCDate()+o.dayNumberOfWeek-1);}}}}else{i=U.getInstance(new Date(1970,0,1,0,0,0),s);i.setEra(o.era||U.getCurrentEra(s));i.setFullYear(y);i.setMonth(o.month||0);i.setDate(o.day||1);i.setHours(o.hour||0);i.setMinutes(o.minute||0);i.setSeconds(o.second||0);i.setMilliseconds(o.millisecond||0);if(S&&(o.day||1)!==i.getDate()){o.valid=false;i=undefined;}else if(o.week!==undefined&&(o.month===undefined||o.day===undefined)){i.setWeek({year:o.weekYear||o.year,week:o.week});if(o.dayNumberOfWeek!==undefined){i.setDate(i.getDate()+o.dayNumberOfWeek-1);}}}if(o.valid){i=i.getJSDate();return i;}}return null;};
function m(o,i){if(o===i){return o;}var M={};Object.keys(o).forEach(function(K){M[K]=o[K];});Object.keys(i).forEach(function(K){if(!M.hasOwnProperty(K)){M[K]=i[K];}});return M;}
function k(s,E){if(s.getTime()>E.getTime()){return false;}return true;}
D.prototype.parse=function(v,u,s){v=v==null?"":String(v).trim();var o;var i=this.oFormatOptions.calendarType;if(u===undefined){u=this.oFormatOptions.UTC;}if(s===undefined){s=this.oFormatOptions.strictParsing;}if(i==C.Japanese&&this.oLocale.getLanguage()==="ja"){v=v.replace(/元年/g,"1年");}if(!this.oFormatOptions.interval){var j=this.parseRelative(v,u);if(j){return j;}o=this._parse(v,this.aFormatArray,u,s);if(o.index===0||o.index<v.length){o.valid=false;}j=h(o,i,u,s);if(j){return j;}}else{var q=this._parseInterval(v,i,u,s);var J,t;if(q&&q.length==2){var w=m(q[0],q[1]);var x=m(q[1],q[0]);J=h(w,i,u,s);t=h(x,i,u,s);if(J&&t){if(this.oFormatOptions.singleIntervalValue&&J.getTime()===t.getTime()){return[J,null];}var V=k(J,t);if(s&&!V){b.error("StrictParsing: Invalid date range. The given end date is before the start date.");return[null,null];}return[J,t];}}}if(!this.bIsFallback){var y;this.aFallbackFormats.every(function(z){y=z.parse(v,u,s);if(Array.isArray(y)){return!(y[0]&&y[1]);}else{return!y;}});return y;}if(!this.oFormatOptions.interval){return null;}else{return[null,null];}};
D.prototype.parseCldrDatePattern=function(P){if(c[P]){return c[P];}var j=[],i,q=false,o=null,s="",N="",A={},I=false;for(i=0;i<P.length;i++){var t=P.charAt(i),u,v,w;if(q){if(t=="'"){v=P.charAt(i-1);w=P.charAt(i-2);u=P.charAt(i+1);if(v=="'"&&w!="'"){q=false;}else if(u=="'"){i+=1;}else{q=false;continue;}}if(s=="text"){o.value+=t;}else{o={type:"text",value:t};j.push(o);s="text";}}else{if(t=="'"){q=true;}else if(this.oSymbols[t]){N=this.oSymbols[t].name;if(s==N){o.digits++;}else{o={type:N,symbol:t,digits:1};j.push(o);s=N;if(!I){if(A[N]){o.repeat=true;I=true;}else{A[N]=true;}}}}else{if(s=="text"){o.value+=t;}else{o={type:"text",value:t};j.push(o);s="text";}}}}c[P]=j;return j;};
D.prototype.parseRelative=function(v,u){var P,E,j,R,V;if(!v){return null;}P=this.oLocaleData.getRelativePatterns(this.aRelativeParseScales,this.oFormatOptions.relativeStyle);for(var i=0;i<P.length;i++){E=P[i];j=new RegExp("^\\s*"+E.pattern.replace(/\{0\}/,"(\\d+)")+"\\s*$","i");R=j.exec(v);if(R){if(E.value!==undefined){return o(E.value,E.scale);}else{V=parseInt(R[1]);return o(V*E.sign,E.scale);}}}function o(q,s){var t,T=new Date(),J;if(u){t=T.getTime();}else{t=Date.UTC(T.getFullYear(),T.getMonth(),T.getDate(),T.getHours(),T.getMinutes(),T.getSeconds(),T.getMilliseconds());}J=new Date(t);switch(s){case"second":J.setUTCSeconds(J.getUTCSeconds()+q);break;case"minute":J.setUTCMinutes(J.getUTCMinutes()+q);break;case"hour":J.setUTCHours(J.getUTCHours()+q);break;case"day":J.setUTCDate(J.getUTCDate()+q);break;case"week":J.setUTCDate(J.getUTCDate()+q*7);break;case"month":J.setUTCMonth(J.getUTCMonth()+q);break;case"quarter":J.setUTCMonth(J.getUTCMonth()+q*3);break;case"year":J.setUTCFullYear(J.getUTCFullYear()+q);break;}if(u){return J;}else{return new Date(J.getUTCFullYear(),J.getUTCMonth(),J.getUTCDate(),J.getUTCHours(),J.getUTCMinutes(),J.getUTCSeconds(),J.getUTCMilliseconds());}}};
D.prototype.formatRelative=function(j,u,R){var t=new Date(),o,s=this.oFormatOptions.relativeScale||"day",i,P,q;q=(j.getTime()-t.getTime())/1000;if(this.oFormatOptions.relativeScale=="auto"){s=this._getScale(q,this.aRelativeScales);s=l(j,t,s,q);}if(!R){R=this._mRanges[s];}if(s=="year"||s=="month"||s=="day"){t=new Date(Date.UTC(t.getFullYear(),t.getMonth(),t.getDate()));o=new Date(0);if(u){o.setUTCFullYear(j.getUTCFullYear(),j.getUTCMonth(),j.getUTCDate());}else{o.setUTCFullYear(j.getFullYear(),j.getMonth(),j.getDate());}j=o;}i=this._getDifference(s,[t,j]);if(this.oFormatOptions.relativeScale!="auto"&&(i<R[0]||i>R[1])){return null;}P=this.oLocaleData.getRelativePattern(s,i,q>0,this.oFormatOptions.relativeStyle);return f(P,[Math.abs(i)]);};
D.prototype._mRanges={second:[-60,60],minute:[-60,60],hour:[-24,24],day:[-6,6],week:[-4,4],month:[-12,12],year:[-10,10]};D.prototype._mScales={second:1,minute:60,hour:3600,day:86400,week:604800,month:2592000,quarter:7776000,year:31536000};
D.prototype._getScale=function(j,s){var S,t;j=Math.abs(j);for(var i=0;i<s.length;i++){t=s[i];if(j>=this._mScales[t]){S=t;break;}}if(!S){S=s[s.length-1];}return S;};
function l(j,t,s,i){var M=Math.abs(j.getMonth()-t.getMonth());if(s==="week"&&M===2){return"month";}else if(s==="week"&&M===1){if(j.getDate()===t.getDate()||(i<0&&j.getDate()<t.getDate())||(i>0&&j.getDate()>t.getDate())){return"month";}}else if(s==="month"&&M===1){if((i>0&&j.getDate()<t.getDate())||(i<0&&j.getDate()>t.getDate())){return"week";}}return s;}
function n(o,s){var j=["FullYear","Month","Date","Hours","Minutes","Seconds","Milliseconds"],M;var q=new Date(o.getTime());for(var i=s;i<j.length;i++){M="set"+j[s];q[M].apply(q,[0]);}return q;}
var r={year:function(o,t){return t.getFullYear()-o.getFullYear();},month:function(o,t){return t.getMonth()-o.getMonth()+(this.year(o,t)*12);},week:function(o,t,i){var j=i._adaptDayOfWeek(o.getDay());var T=i._adaptDayOfWeek(t.getDay());o=n(o,3);t=n(t,3);return(t.getTime()-o.getTime()-(T-j)*i._mScales.day*1000)/(i._mScales.week*1000);},day:function(o,t,i){o=n(o,3);t=n(t,3);return(t.getTime()-o.getTime())/(i._mScales.day*1000);},hour:function(o,t,i){o=n(o,4);t=n(t,4);return(t.getTime()-o.getTime())/(i._mScales.hour*1000);},minute:function(o,t,i){o=n(o,5);t=n(t,5);return(t.getTime()-o.getTime())/(i._mScales.minute*1000);},second:function(o,t,i){o=n(o,6);t=n(t,6);return(t.getTime()-o.getTime())/(i._mScales.second*1000);}};
D.prototype._adaptDayOfWeek=function(i){var j=a.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getFirstDayOfWeek();var o=i-(j-1);if(o<=0){o+=7;}return o;};
D.prototype._getDifference=function(s,i){var o=i[0];var t=i[1];return Math.round(r[s](o,t,this));};
D.prototype.getAllowedCharacters=function(j){if(this.oFormatOptions.relative){return"";}var A="";var N=false;var o=false;var P;for(var i=0;i<j.length;i++){P=j[i];switch(P.type){case"text":if(A.indexOf(P.value)<0){A+=P.value;}break;case"day":case"year":case"weekYear":case"dayNumberOfWeek":case"weekInYear":case"hour0_23":case"hour1_24":case"hour0_11":case"hour1_12":case"minute":case"second":case"fractionalsecond":if(!N){A+="0123456789";N=true;}break;case"month":case"monthStandalone":if(P.digits<3){if(!N){A+="0123456789";N=true;}}else{o=true;}break;default:o=true;break;}}if(o){A="";}return A;};
return D;},true);
sap.ui.predefine('sap/ui/core/format/FileSizeFormat',['sap/ui/base/Object','sap/ui/core/Locale','sap/ui/core/LocaleData','sap/ui/core/format/NumberFormat'],function(B,L,a,N){"use strict";var _=[{binaryFactor:1,decimalFactor:1,decimalUnit:"Byte",binaryUnit:"Byte"},{binaryFactor:1,decimalFactor:1,decimalUnit:"Bytes",binaryUnit:"Bytes"},{binaryFactor:Math.pow(2,10),decimalFactor:1e3,decimalUnit:"Kilobyte",binaryUnit:"Kibibyte"},{binaryFactor:Math.pow(2,20),decimalFactor:1e6,decimalUnit:"Megabyte",binaryUnit:"Mebibyte"},{binaryFactor:Math.pow(2,30),decimalFactor:1e9,decimalUnit:"Gigabyte",binaryUnit:"Gibibyte"},{binaryFactor:Math.pow(2,40),decimalFactor:1e12,decimalUnit:"Terabyte",binaryUnit:"Tebibyte"},{binaryFactor:Math.pow(2,50),decimalFactor:1e15,decimalUnit:"Petabyte",binaryUnit:"Pebibyte"},{binaryFactor:Math.pow(2,60),decimalFactor:1e18,decimalUnit:"Exabyte",binaryUnit:"Exbibyte"},{binaryFactor:Math.pow(2,70),decimalFactor:1e21,decimalUnit:"Zettabyte",binaryUnit:"Zebibyte"},{binaryFactor:Math.pow(2,80),decimalFactor:1e24,decimalUnit:"Yottabyte",binaryUnit:"Yobibyte"}];
var F=B.extend("sap.ui.core.format.FileSizeFormat",{constructor:function(f){throw new Error();}});
F.getInstance=function(f,l){return this.createInstance(f,l);};
F.createInstance=function(f,l){var o=Object.create(this.prototype);if(f instanceof L){l=f;f=undefined;}if(!l){l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();}o.oLocale=l;o.oLocaleData=a.getInstance(l);o.oNumberFormat=N.getFloatInstance(f,l);o.oBundle=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core",l.toString());o.bBinary=f?!!f.binaryFilesize:false;return o;};
F.prototype.format=function(v){var V=null,o;if(typeof v=="string"){try{if(/^\s*[\+-]?0[xX]/.test(v)){V=parseInt(v,16);}else{V=parseFloat(v,10);}}catch(e){}}else if(typeof v=="number"){V=v;}if(V===null){return"NaN";}o=V;var u=c(V,this.bBinary),s=this.oNumberFormat.format(V/u.factor);if(!u.noSecondRounding){V=this.oNumberFormat.parse(s);if((this.bBinary&&Math.abs(V)>=1024)||(!this.bBinary&&Math.abs(V)>=1000)){u=c(V*u.factor,this.bBinary);s=this.oNumberFormat.format(o/u.factor);}}return this.oBundle.getText("FileSize."+u.unit,s);};
F.prototype.parse=function(v){var u,b,V,e;if(!v){return NaN;}for(var i=0;i<_.length;i++){u=_[i];b=d(this.oBundle,u.decimalUnit,v);if(b){e=false;break;}else{b=d(this.oBundle,u.binaryUnit,v);if(b){e=true;break;}}}if(!b){b=v;e=false;u=_[0];}V=this.oNumberFormat.parse(b);return V*(e?u.binaryFactor:u.decimalFactor);};
function c(f,e){var b=Math.abs(f),u,g;for(var i=_.length-1;i>=2;i--){u=_[i];g=e?u.binaryFactor:u.decimalFactor;if(b>=g){return{factor:g,unit:e?u.binaryUnit:u.decimalUnit,noSecondRounding:(i==_.length-1)};}}return{factor:1,unit:_[b>=2?1:0].decimalUnit};}
function d(b,u,v){var p=b.getText("FileSize."+u),e;if(p.startsWith("{0}")){e=p.substr(3,p.length);if((typeof e=="string"&&e!=""?v.toLowerCase().endsWith(e.toLowerCase()):false)){return v.substr(0,v.length-e.length);}}else if(p.endsWith("{0}")){e=p.substr(0,p.length-3);if((typeof e=="string"&&e!=""?v.toLowerCase().startsWith(e.toLowerCase()):false)){return v.substr(e.length,v.length);}}else{e=p.split("{0}");if(e.length==2&&((typeof e[0]=="string"&&e[0]!=""?v.toLowerCase().startsWith(e[0].toLowerCase()):false))&&((typeof e[1]=="string"&&e[1]!=""?v.toLowerCase().endsWith(e[1].toLowerCase()):false))){return v.substr(e[0].length,v.length-e[1].length);}}return null;}
return F;});
sap.ui.predefine('sap/ui/core/format/ListFormat',['sap/ui/core/Locale','sap/ui/core/LocaleData',"sap/base/Log","sap/base/util/extend","sap/base/util/isEmptyObject"],function(L,a,b,e,c){"use strict";var d=function(){throw new Error();};d.oDefaultListFormat={type:"standard",style:"wide"};
d.getInstance=function(f,l){return this.createInstance(f,l);};
d.createInstance=function(f,l){var F=Object.create(this.prototype);if(f instanceof L){l=f;f=undefined;}if(!l){l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();}F.oLocale=l;F.oLocaleData=a.getInstance(l);F.oOriginalFormatOptions=e({},this.oDefaultListFormat,f);return F;};
d.prototype.format=function(l){if(!Array.isArray(l)){b.error("ListFormat can only format with an array given.");return"";}var o=this.oOriginalFormatOptions,m,p,v,s,M,E,V=[].concat(l),S,f;m=this.oLocaleData.getListFormat(o.type,o.style);if(c(m)){b.error("No list pattern exists for the provided format options (type, style).");return"";}function r(V,p){var R=V[0];for(var i=1;i<V.length;i++){R=p.replace("{0}",R);R=R.replace("{1}",V[i]);}return R;}if(m[V.length]){p=m[V.length];for(var i=0;i<V.length;i++){p=p.replace('{'+i+'}',V[i]);}v=p;}else if(V.length<2){v=V.toString();}else{S=V.shift();E=V.pop();f=V;s=m.start.replace("{0}",S);E=m.end.replace("{1}",E);M=r(f,m.middle);v=s.replace("{1}",E.replace("{0}",M));}return v;};
d.prototype.parse=function(v){if(typeof v!=='string'){b.error("ListFormat can only parse a String.");return[];}var r=[],s=[],m=[],E=[],f=[],o=this.oOriginalFormatOptions,l,g=/\{[01]\}/g,h,S,i,j,k;if(!o){o=d.oDefaultListFormat;}l=this.oLocaleData.getListFormat(o.type,o.style);if(c(l)){b.error("No list pattern exists for the provided format options (type, style).");return[];}i=l.start.replace(g,"");j=l.middle.replace(g,"");k=l.end.replace(g,"");s=v.split(i);r=r.concat(s.shift());E=s.join(i).split(k);h=E.pop();m=E.join(k).split(j);r=r.concat(m);r.push(h);if(s.length<1||m.length<1||E.length<1){S=l["2"].replace(g,"");f=v.split(S);if(f.length===2){return f;}if(v){return[v];}else{return[];}}return r;};
return d;});
sap.ui.predefine('sap/ui/core/format/NumberFormat',['sap/ui/base/Object','sap/ui/core/Locale','sap/ui/core/LocaleData','sap/base/Log','sap/base/assert','sap/base/util/extend'],function(B,L,a,b,c,e){"use strict";
var N=B.extend("sap.ui.core.format.NumberFormat",{constructor:function(F){throw new Error();}});
var r=/0+(\.0+)?/;var d=/^0+$/;var n={INTEGER:"integer",FLOAT:"float",CURRENCY:"currency",UNIT:"unit",PERCENT:"percent"};var R={FLOOR:"FLOOR",CEILING:"CEILING",TOWARDS_ZERO:"TOWARDS_ZERO",AWAY_FROM_ZERO:"AWAY_FROM_ZERO",HALF_FLOOR:"HALF_FLOOR",HALF_CEILING:"HALF_CEILING",HALF_TOWARDS_ZERO:"HALF_TOWARDS_ZERO",HALF_AWAY_FROM_ZERO:"HALF_AWAY_FROM_ZERO"};var m={};m[R.FLOOR]=Math.floor;m[R.CEILING]=Math.ceil;m[R.TOWARDS_ZERO]=function(i){return i>0?Math.floor(i):Math.ceil(i);};m[R.AWAY_FROM_ZERO]=function(i){return i>0?Math.ceil(i):Math.floor(i);};m[R.HALF_TOWARDS_ZERO]=function(i){return i>0?Math.ceil(i-0.5):Math.floor(i+0.5);};m[R.HALF_AWAY_FROM_ZERO]=function(i){return i>0?Math.floor(i+0.5):Math.ceil(i-0.5);};m[R.HALF_FLOOR]=function(i){return Math.ceil(i-0.5);};m[R.HALF_CEILING]=Math.round;N.RoundingMode=R;N.oDefaultIntegerFormat={minIntegerDigits:1,maxIntegerDigits:99,minFractionDigits:0,maxFractionDigits:0,groupingEnabled:false,groupingSize:3,groupingSeparator:",",decimalSeparator:".",plusSign:"+",minusSign:"-",isInteger:true,type:n.INTEGER,showMeasure:false,style:"standard",showNumber:true,parseAsString:false,preserveDecimals:false,roundingMode:N.RoundingMode.TOWARDS_ZERO,emptyString:NaN,showScale:true};N.oDefaultFloatFormat={minIntegerDigits:1,maxIntegerDigits:99,minFractionDigits:0,maxFractionDigits:99,groupingEnabled:true,groupingSize:3,groupingSeparator:",",decimalSeparator:".",plusSign:"+",minusSign:"-",isInteger:false,type:n.FLOAT,showMeasure:false,style:"standard",showNumber:true,parseAsString:false,preserveDecimals:false,roundingMode:N.RoundingMode.HALF_AWAY_FROM_ZERO,emptyString:NaN,showScale:true};N.oDefaultPercentFormat={minIntegerDigits:1,maxIntegerDigits:99,minFractionDigits:0,maxFractionDigits:99,groupingEnabled:true,groupingSize:3,groupingSeparator:",",decimalSeparator:".",plusSign:"+",minusSign:"-",percentSign:"%",isInteger:false,type:n.PERCENT,showMeasure:false,style:"standard",showNumber:true,parseAsString:false,preserveDecimals:false,roundingMode:N.RoundingMode.HALF_AWAY_FROM_ZERO,emptyString:NaN,showScale:true};N.oDefaultCurrencyFormat={minIntegerDigits:1,maxIntegerDigits:99,groupingEnabled:true,groupingSize:3,groupingSeparator:",",decimalSeparator:".",plusSign:"+",minusSign:"-",isInteger:false,type:n.CURRENCY,showMeasure:true,currencyCode:true,currencyContext:'standard',style:"standard",showNumber:true,customCurrencies:undefined,parseAsString:false,preserveDecimals:false,roundingMode:N.RoundingMode.HALF_AWAY_FROM_ZERO,emptyString:NaN,showScale:true,ignorePrecision:true};N.oDefaultUnitFormat={minIntegerDigits:1,maxIntegerDigits:99,groupingEnabled:true,groupingSize:3,groupingSeparator:",",decimalSeparator:".",plusSign:"+",minusSign:"-",isInteger:false,type:n.UNIT,showMeasure:true,style:"standard",showNumber:true,customUnits:undefined,allowedUnits:undefined,parseAsString:false,preserveDecimals:false,roundingMode:N.RoundingMode.HALF_AWAY_FROM_ZERO,emptyString:NaN,showScale:true};
N.getInstance=function(F,i){return this.getFloatInstance(F,i);};
N.getFloatInstance=function(F,i){var w=this.createInstance(F,i),x=this.getLocaleFormatOptions(w.oLocaleData,n.FLOAT);w.oFormatOptions=e({},this.oDefaultFloatFormat,x,F);return w;};
N.getIntegerInstance=function(F,i){var w=this.createInstance(F,i),x=this.getLocaleFormatOptions(w.oLocaleData,n.INTEGER);w.oFormatOptions=e({},this.oDefaultIntegerFormat,x,F);return w;};
N.getCurrencyInstance=function(F,i){var w=this.createInstance(F,i);var C=F&&F.currencyContext;var S=h(F);if(S){C=C||this.oDefaultCurrencyFormat.style;C="sap-"+C;}var x=this.getLocaleFormatOptions(w.oLocaleData,n.CURRENCY,C);w.oFormatOptions=e({},this.oDefaultCurrencyFormat,x,F);w.oFormatOptions.trailingCurrencyCode=S;w._defineCustomCurrencySymbols();return w;};
N.getUnitInstance=function(F,i){var w=this.createInstance(F,i),x=this.getLocaleFormatOptions(w.oLocaleData,n.UNIT);w.oFormatOptions=e({},this.oDefaultUnitFormat,x,F);return w;};
N.getPercentInstance=function(F,i){var w=this.createInstance(F,i),x=this.getLocaleFormatOptions(w.oLocaleData,n.PERCENT);w.oFormatOptions=e({},this.oDefaultPercentFormat,x,F);return w;};
N.createInstance=function(F,i){var w=Object.create(this.prototype),P;if(F instanceof L){i=F;F=undefined;}if(!i){i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();}w.oLocale=i;w.oLocaleData=a.getInstance(i);w.oOriginalFormatOptions=F;if(F){if(F.pattern){P=this.parseNumberPattern(F.pattern);Object.keys(P).forEach(function(x){F[x]=P[x];});}if(F.emptyString!==undefined){c(F.emptyString===""||F.emptyString===0||F.emptyString===null||F.emptyString!==F.emptyString,"The format option 'emptyString' must be either 0, null or NaN");}}return w;};
N.getDefaultUnitPattern=function(S){return"{0} "+S;};
N.getLocaleFormatOptions=function(i,T,C){var w,x;switch(T){case n.PERCENT:x=i.getPercentPattern();break;case n.CURRENCY:x=i.getCurrencyPattern(C);break;case n.UNIT:x=i.getDecimalPattern();break;default:x=i.getDecimalPattern();}w=this.parseNumberPattern(x);w.plusSign=i.getNumberSymbol("plusSign");w.minusSign=i.getNumberSymbol("minusSign");w.decimalSeparator=i.getNumberSymbol("decimal");w.groupingSeparator=i.getNumberSymbol("group");w.percentSign=i.getNumberSymbol("percentSign");w.pattern=x;switch(T){case n.UNIT:case n.FLOAT:case n.PERCENT:w.minFractionDigits=0;w.maxFractionDigits=99;break;case n.INTEGER:w.minFractionDigits=0;w.maxFractionDigits=0;w.groupingEnabled=false;break;case n.CURRENCY:w.minFractionDigits=undefined;w.maxFractionDigits=undefined;break;}return w;};
N.parseNumberPattern=function(F){var M=0,w=0,x=0,G=false,y=0,z=0,S=F.indexOf(";"),A={Integer:0,Fraction:1},C=A.Integer;if(S!==-1){F=F.substring(0,S);}for(var i=0;i<F.length;i++){var D=F[i];switch(D){case",":if(G){y=z;z=0;}G=true;break;case".":C=A.Fraction;break;case"0":if(C===A.Integer){M++;if(G){z++;}}else{w++;x++;}break;case"#":if(C===A.Integer){if(G){z++;}}else{x++;}break;}}if(!y){y=z;z=0;}return{minIntegerDigits:M,minFractionDigits:w,maxFractionDigits:x,groupingEnabled:G,groupingSize:y,groupingBaseSize:z};};
N.prototype._defineCustomCurrencySymbols=function(){var O=this.oFormatOptions;var C=this.oLocaleData.getCurrencySymbols();var F=function(S,i){var U=[];var w;for(var K in S){w=S[K];if(U.indexOf(w)===-1){U.push(w);}else if(w!==undefined){i[w]=true;b.error("Symbol '"+w+"' is defined multiple times in custom currencies.",undefined,"NumberFormat");}}};if(O.customCurrencies&&typeof O.customCurrencies==="object"){this.mKnownCurrencySymbols={};this.mKnownCurrencyCodes={};Object.keys(O.customCurrencies).forEach(function(K){if(O.customCurrencies[K].symbol){this.mKnownCurrencySymbols[K]=O.customCurrencies[K].symbol;}else{var i=O.customCurrencies[K].isoCode;if(i){this.mKnownCurrencySymbols[K]=C[i];}}this.mKnownCurrencyCodes[K]=K;}.bind(this));}else{this.mKnownCurrencySymbols=C;this.mKnownCurrencyCodes=this.oLocaleData.getCustomCurrencyCodes();}this.mDuplicatedSymbols={};F(this.mKnownCurrencySymbols,this.mDuplicatedSymbols);};
function s(i,w){if(i.indexOf(".")>=0&&!k(i)&&i.endsWith("0")){var F=i.length-i.lastIndexOf(".")-1;var x=F-w;if(x>0){while(i.endsWith("0")&&(x-->0)){i=i.substring(0,i.length-1);}if(i.endsWith(".")){i=i.substring(0,i.length-1);}}}return i;}
N.prototype.format=function(V,M){if(Array.isArray(V)){M=V[1];V=V[0];}var i="",F="",G="",w="",x="",P="",y=0,z=0,A=0,C=0,D=V<0,E=-1,O=Object.assign({},this.oFormatOptions),H=this.oOriginalFormatOptions,I=O.type===n.CURRENCY&&M==="INR"&&this.oLocale.getLanguage()==="en"&&this.oLocale.getRegion()==="IN",J,S,K,Q,U,T,W=V===undefined||V===null;if(O.showNumber&&(V===O.emptyString||(isNaN(V)&&isNaN(O.emptyString)))){return"";}if(M!==undefined&&M!==null&&typeof M!=="string"&&!(M instanceof String)){return"";}if(!O.showNumber&&!M){return"";}if(W&&(!M||!O.showMeasure||O.showNumber)){return"";}if(M&&O.customCurrencies&&!O.customCurrencies[M]){b.error("Currency '"+M+"' is unknown.");return"";}if(!O.showNumber&&!O.showMeasure){return"";}if(M&&O.type===n.UNIT){if(O.customUnits&&typeof O.customUnits==="object"){U=O.customUnits[M];}else{T=this.oLocaleData.getUnitFromMapping(M)||M;U=this.oLocaleData.getUnitFormat(T);}if(O.showMeasure){var X=!O.allowedUnits||O.allowedUnits.indexOf(M)>=0;if(!X){return"";}}if(!U&&!O.showNumber){return this._addOriginInfo(M);}O.decimals=(U&&(typeof U.decimals==="number"&&U.decimals>=0))?U.decimals:O.decimals;O.precision=(U&&(typeof U.precision==="number"&&U.precision>=0))?U.precision:O.precision;}if(O.type==n.CURRENCY){if(M&&O.trailingCurrencyCode){if(!this.mKnownCurrencyCodes[M]&&!/(^[A-Z]{3}$)/.test(M)){O.trailingCurrencyCode=false;O.pattern=this.oLocaleData.getCurrencyPattern(O.currencyContext);}}if(!O.showNumber){if(!O.currencyCode){var Y;if(O.customCurrencies&&typeof O.customCurrencies==="object"){Y=this.mKnownCurrencySymbols[M];}else{Y=this.oLocaleData.getCurrencySymbol(M);}if(Y&&Y!==M){M=Y;}}return M;}if(O.customCurrencies&&O.customCurrencies[M]){O.decimals=O.customCurrencies[M].decimals!==undefined?O.customCurrencies[M].decimals:O.decimals;}}if(O.decimals!==undefined){O.minFractionDigits=O.decimals;O.maxFractionDigits=O.decimals;}if(O.shortLimit===undefined||Math.abs(V)>=O.shortLimit){K=O.shortRefNumber===undefined?V:O.shortRefNumber;S=g(K,O,this.oLocaleData,I);if(S&&S.formatString!="0"){V=V/S.magnitude;if(O.shortDecimals!==undefined){O.minFractionDigits=O.shortDecimals;O.maxFractionDigits=O.shortDecimals;}else{if(H.minFractionDigits===undefined&&H.maxFractionDigits===undefined&&H.decimals===undefined&&H.precision===undefined&&H.pattern===undefined){O.precision=2;O.minFractionDigits=0;O.maxFractionDigits=99;}if(H.maxFractionDigits===undefined&&H.decimals===undefined){O.maxFractionDigits=99;}}O.roundingMode=N.RoundingMode.HALF_AWAY_FROM_ZERO;}}if((S||!O.ignorePrecision)&&O.precision!==undefined){O.maxFractionDigits=Math.min(O.maxFractionDigits,p(V,O.precision));O.minFractionDigits=Math.min(O.minFractionDigits,O.maxFractionDigits);}if(O.type==n.PERCENT){V=N._shiftDecimalPoint(V,2);}if(O.type==n.CURRENCY){var Z=this.oLocaleData.getCurrencyDigits(M);if(O.customCurrencies&&O.customCurrencies[M]&&O.customCurrencies[M].decimals!==undefined){Z=O.customCurrencies[M].decimals;}if(O.maxFractionDigits===undefined){O.maxFractionDigits=Z;}if(O.minFractionDigits===undefined){O.minFractionDigits=Z;}}if(typeof V==="number"&&!O.preserveDecimals){V=o(V,O.maxFractionDigits,O.roundingMode);}if(V==0){D=false;}if(O.preserveDecimals&&(typeof V==="string"||V instanceof String)){V=s(V,O.maxFractionDigits);}if(!W){x=this.convertToDecimal(V);}if(x=="NaN"){return x;}if(D){x=x.substr(1);}E=x.indexOf(".");if(E>-1){i=x.substr(0,E);F=x.substr(E+1);}else{i=x;}if(i.length<O.minIntegerDigits){i=i.padStart(O.minIntegerDigits,"0");}else if(i.length>O.maxIntegerDigits){i="".padStart(O.maxIntegerDigits,"?");}if(F.length<O.minFractionDigits){F=F.padEnd(O.minFractionDigits,"0");}else if(F.length>O.maxFractionDigits&&!O.preserveDecimals){F=F.substr(0,O.maxFractionDigits);}if(O.type===n.UNIT&&!O.showNumber){if(U){Q=this.oLocaleData.getPluralCategory(i+"."+F);P=U["unitPattern-count-"+Q];if(!P){P=U["unitPattern-count-other"];}if(!P){return this._addOriginInfo(M);}if(Q!=="other"&&P.indexOf("{0}")===-1){P=U["unitPattern-count-other"];if(!P){return this._addOriginInfo(M);}}if(P.indexOf("{0}")===-1){b.warning("Cannot separate the number from the unit because unitPattern-count-other '"+P+"' does not include the number placeholder '{0}' for unit '"+M+"'");}else{return this._addOriginInfo(P.replace("{0}","").trim());}}}z=i.length;if(O.groupingEnabled){if(I){var $=[3,2,2],_,a1=0;y=i.length;while(y>0){_=$[a1%3];y-=_;if(a1>0){G=O.groupingSeparator+G;}if(y<0){_+=y;y=0;}G=i.substr(y,_)+G;a1++;}}else{A=O.groupingSize;C=O.groupingBaseSize||A;y=Math.max(z-C,0)%A||A;G=i.substr(0,y);while(z-y>=C){G+=O.groupingSeparator;G+=i.substr(y,A);y+=A;}G+=i.substr(y);}}else{G=i;}if(D){w=O.minusSign;}w+=G;if(F){w+=O.decimalSeparator+F;}if(S&&S.formatString&&O.showScale&&O.type!==n.CURRENCY){Q=this.oLocaleData.getPluralCategory(i+"."+F);S.formatString=this.oLocaleData.getDecimalFormat(O.style,S.key,Q);w=S.formatString.replace(S.valueSubString,w);w=w.replace(/'.'/g,".");}if(O.type===n.CURRENCY){P=O.pattern;if(S&&S.formatString&&O.showScale){var b1;if(O.trailingCurrencyCode){b1="sap-short";}else{b1="short";}Q=this.oLocaleData.getPluralCategory(i+"."+F);if(I){P=j(b1,S.key,Q);}else{P=this.oLocaleData.getCurrencyFormat(b1,S.key,Q);}P=P.replace(/'.'/g,".");}J=P.split(";");if(J.length===2){P=D?J[1]:J[0];if(D){w=w.substring(O.minusSign.length);}}if(!O.currencyCode){var Y;if(O.customCurrencies&&typeof O.customCurrencies==="object"){Y=this.mKnownCurrencySymbols[M];}else{Y=this.oLocaleData.getCurrencySymbol(M);}if(Y&&Y!==M){M=Y;}}w=this._composeCurrencyResult(P,w,M,{showMeasure:O.showMeasure,negative:D,minusSign:O.minusSign});}if(O.type===n.PERCENT){P=O.pattern;w=P.replace(/[0#.,]+/,w);w=w.replace(/%/,O.percentSign);}if(O.showMeasure&&M&&O.type===n.UNIT){Q=this.oLocaleData.getPluralCategory(i+"."+F);if(U){P=U["unitPattern-count-"+Q];if(!P){P=U["unitPattern-count-other"];}if(!P){P=N.getDefaultUnitPattern(M);}}else{P=N.getDefaultUnitPattern(M);}w=P.replace("{0}",w);}return this._addOriginInfo(w);};
N.prototype._addOriginInfo=function(i){if(sap.ui.getCore().getConfiguration().getOriginInfo()){i=new String(i);i.originInfo={source:"Common Locale Data Repository",locale:this.oLocale.toString()};}return i;};
N.prototype._composeCurrencyResult=function(P,F,M,O){var i=O.minusSign;P=P.replace(/[0#.,]+/,F);if(O.showMeasure&&M){var w="\u00a4",x={"[:digit:]":/\d/,"[:^S:]":/[^\$\xA2-\xA5\u058F\u060B\u09F2\u09F3\u09FB\u0AF1\u0BF9\u0E3F\u17DB\u20A0-\u20BD\uA838\uFDFC\uFE69\uFF04\uFFE0\uFFE1\uFFE5\uFFE6]/},y=P.indexOf(w),z=y<P.length/2?"after":"before",S=this.oLocaleData.getCurrencySpacing(z),C=(z==="after"?M.charAt(M.length-1):M.charAt(0)),A,D=x[S.currencyMatch],E=x[S.surroundingMatch],I;P=P.replace(w,M);A=(z==="after"?P.charAt(y+M.length):P.charAt(y-1));if(D&&D.test(C)&&E&&E.test(A)){if(z==="after"){I=y+M.length;}else{I=y;}P=P.slice(0,I)+S.insertBetween+P.slice(I);}else if(O.negative&&z==="after"){i="\ufeff"+O.minusSign;}}else{P=P.replace(/\s*\u00a4\s*/,"");}if(O.negative){P=P.replace(/-/,i);}return P;};
N.prototype.parse=function(V){var O=this.oFormatOptions,P=O.plusSign+this.oLocaleData.getLenientNumberSymbols("plusSign"),M=O.minusSign+this.oLocaleData.getLenientNumberSymbols("minusSign"),w=q(P+M),G=q(O.groupingSeparator),D=q(O.decimalSeparator),x="^\\s*(["+w+"]?(?:[0-9"+G+"]+|[0-9"+G+"]*"+D+"[0-9]*)(?:[eE][+-][0-9]+)?)\\s*$",y="^\\s*(["+w+"]?[0-9"+G+"]+)\\s*$",z=new RegExp(G,"g"),A=new RegExp(D,"g"),C=this.oLocaleData.getNumberSymbol("percentSign"),I=O.type===n.CURRENCY&&this.oLocale.getLanguage()==="en"&&this.oLocale.getRegion()==="IN",E,F,H,J,K=0,S,Q;if(V===""){if(!O.showNumber){return null;}Q=O.emptyString;if(O.parseAsString&&(O.emptyString===0||isNaN(O.emptyString))){Q=O.emptyString+"";}if(O.type===n.CURRENCY||O.type===n.UNIT){return[Q,undefined];}else{return Q;}}if(typeof V!=="string"&&!(V instanceof String)){return null;}if(O.groupingSeparator===O.decimalSeparator){b.error("The grouping and decimal separator both have the same value '"+O.groupingSeparator+"'. "+"They must be different from each other such that values can be parsed correctly.");}J=O.type===n.PERCENT?O.pattern:this.oLocaleData.getPercentPattern();if(J.charAt(0)==="%"){x=x.slice(0,1)+"%?"+x.slice(1);}else if(J.charAt(J.length-1)==="%"){x=x.slice(0,x.length-1)+"%?"+x.slice(x.length-1);}var U;if(O.type===n.UNIT&&O.showMeasure){var T;if(O.customUnits&&typeof O.customUnits==="object"){T=O.customUnits;}else{T=this.oLocaleData.getUnitFormats();}c(T,"Unit patterns cannot be loaded");if(O.allowedUnits){var W={};for(var i=0;i<O.allowedUnits.length;i++){var X=O.allowedUnits[i];W[X]=T[X];}T=W;}var Y=t(T,V,O.showNumber);var Z=false;U=Y.cldrCode;if(U.length===1){H=U[0];if(!O.showNumber){return[undefined,H];}}else if(U.length===0){if(O.unitOptional){Y.numberValue=V;}else{return null;}}else{c(U.length===1,"Ambiguous unit ["+U.join(", ")+"] for input: '"+(V)+"'");H=undefined;Z=true;}if(O.strictParsing){if(Z){return null;}}V=Y.numberValue||V;}var $;if(O.type===n.CURRENCY&&O.showMeasure){$=v({value:V,currencySymbols:this.mKnownCurrencySymbols,customCurrencyCodes:this.mKnownCurrencyCodes,duplicatedSymbols:this.mDuplicatedSymbols,customCurrenciesAvailable:!!O.customCurrencies});if(!$){return null;}if(O.strictParsing){if(!$.currencyCode||$.duplicatedSymbolFound){return null;}}V=$.numberValue;H=$.currencyCode;if(O.customCurrencies&&H===null){return null;}if(!O.showNumber){if(V){return null;}return[undefined,H];}}V=V.replace(/[\u202a\u200e\u202c\u202b\u200f]/g,"");V=V.replace(/\s/g,"");S=f(V,this.oLocaleData,I);if(S){V=S.number;}var _=k(V);if(O.isInteger&&!S&&!_){E=new RegExp(y);}else{E=new RegExp(x);}if(!E.test(V)){return O.type===n.CURRENCY||O.type===n.UNIT?null:NaN;}V=V.replace(z,"");var a1=V.length;for(var b1=0;b1<a1;b1++){var c1=V[b1];if(P.includes(c1)){V=V.replace(c1,"+");break;}else if(M.includes(c1)){V=V.replace(c1,"-");break;}}V=V.replace(/^\+/,"");if(S){V=V.replace(A,".");V=N._shiftDecimalPoint(V,Math.round(Math.log(S.factor)/Math.LN10));}if(O.isInteger){var d1;if(_){V=V.replace(A,".");d1=l(V);if(d1===undefined){return NaN;}}else{d1=parseInt(V);}K=O.parseAsString?V:d1;}else{V=V.replace(A,".");if(V.indexOf(C)!==-1){F=true;V=V.replace(C,"");}K=O.parseAsString?V:parseFloat(V);if(F){K=N._shiftDecimalPoint(K,-2);}}if(O.parseAsString){K=N._shiftDecimalPoint(V,0);}if(O.type===n.CURRENCY||O.type===n.UNIT){return[K,H];}return K;};
N.prototype.convertToDecimal=function(V){var w=""+V,x,y,D,F,E,P;if(w.indexOf("e")==-1&&w.indexOf("E")==-1){return w;}var z=w.match(/^([+-]?)((\d+)(?:\.(\d+))?)[eE]([+-]?\d+)$/);x=z[1]=="-";y=z[2].replace(/\./g,"");D=z[3]?z[3].length:0;F=z[4]?z[4].length:0;E=parseInt(z[5]);if(E>0){if(E<F){P=D+E;w=y.substr(0,P)+"."+y.substr(P);}else{w=y;E-=F;for(var i=0;i<E;i++){w+="0";}}}else{if(-E<D){P=D+E;w=y.substr(0,P)+"."+y.substr(P);}else{w=y;E+=D;for(var i=0;i>E;i--){w="0"+w;}w="0."+w;}}if(x){w="-"+w;}return w;};
N.prototype.getScale=function(){if((this.oFormatOptions.style!=="short"&&this.oFormatOptions.style!=="long")||this.oFormatOptions.shortRefNumber===undefined){return;}var S=g(this.oFormatOptions.shortRefNumber,this.oFormatOptions,this.oLocaleData),i;if(S&&S.formatString){i=S.formatString.replace(r,"").replace(/'.'/g,".").trim();if(i){return i;}}};
N._shiftDecimalPoint=function(V,S){if(typeof S!=="number"){return NaN;}var M="";var E=V.toString().toLowerCase().split("e");if(typeof V==="number"){S=E[1]?(+E[1]+S):S;return+(E[0]+"e"+S);}else if(typeof V==="string"){if(parseFloat(V)===0&&S>=0){return d.test(V)?"0":V;}var F=E[0].charAt(0);M=F==="-"?F:"";if(M){E[0]=E[0].slice(1);}V=E[0];var D=V.indexOf("."),A,i,w;if(D===-1){V=V+".";D=V.length-1;}if(E[1]){D+=(+E[1]);}A=D+S;if(A<=0){V=V.padStart(V.length-A+1,'0');A=1;}else if(A>=V.length-1){V=V.padEnd(A+1,'0');A=V.length-1;}V=V.replace(".","");i=V.substring(0,A);w=V.substring(A);i=i.replace(/^(-?)0+(\d)/,"$1$2");return M+i+(w?("."+w):"");}else{return null;}};
function g(V,O,w,I){var S,K,x,C,y=O.style,P=O.precision!==undefined?O.precision:2;if(y!="short"&&y!="long"){return undefined;}for(var i=0;i<15;i++){K=Math.pow(10,i);if(o(Math.abs(V)/K,P-1)<10){break;}}x=K.toString();if(O.type===n.CURRENCY){if(O.trailingCurrencyCode){y="sap-short";}if(I){C=j(y,x,"other",true);}else{C=w.getCurrencyFormat(y,x,"other");}}else{C=w.getDecimalFormat(y,x,"other");}if(!C||C=="0"){return undefined;}else{S={};S.key=x;S.formatString=C;var z=C.match(r);if(z){S.valueSubString=z[0];var A=S.valueSubString.indexOf(".");if(A==-1){S.decimals=0;S.magnitude=K*Math.pow(10,1-S.valueSubString.length);}else{S.decimals=S.valueSubString.length-A-1;S.magnitude=K*Math.pow(10,1-A);}}else{return undefined;}}return S;}
function f(V,w,I){var x,F=1,K=10,P=w.getPluralCategories(),C,y={number:undefined,factor:F},G=function(A,K,S,D){if(D){C=j(S,K.toString(),A,true);}else{C=w.getDecimalFormat(S,K.toString(),A);}if(C){C=C.replace(/[\s\u00a0\u200F]/g,"");C=C.replace(/'.'/g,".");var E=C.match(r);if(E){var H=E[0];var U=C.replace(H,"");if(!U){return;}var J=V.indexOf(U);if(J>=0){x=V.replace(U,"");x=x.replace(/\u200F/g,"");F=K;F*=Math.pow(10,1-H.length);if(y.number===undefined||x.length<y.number.length){y.number=x;y.factor=F;}}}}};["long","short"].forEach(function(S){K=10;while(K<1e15){for(var i=0;i<P.length;i++){var z=P[i];G(z,K,S);}K=K*10;}});if(I&&!x){K=10;while(K<1e15){for(var i=0;i<P.length;i++){var z=P[i];G(z,K,"short",true);}K=K*10;}}if(!x){return;}return y;}
function h(F){var S=sap.ui.getCore().getConfiguration().getFormatSettings().getTrailingCurrencyCode();if(F){if(F.trailingCurrencyCode!==undefined){S=F.trailingCurrencyCode;}if(F.pattern){S=false;}if(F.currencyCode===false){S=false;}}return S;}
function j(S,K,P,D){var F,C={"short":{"1000-one":"\xa40000","1000-other":"\xa40000","10000-one":"\xa400000","10000-other":"\xa400000","100000-one":"\xa40 Lk","100000-other":"\xa40 Lk","1000000-one":"\xa400 Lk","1000000-other":"\xa400 Lk","10000000-one":"\xa40 Cr","10000000-other":"\xa40 Cr","100000000-one":"\xa400 Cr","100000000-other":"\xa400 Cr","1000000000-one":"\xa4000 Cr","1000000000-other":"\xa4000 Cr","10000000000-one":"\xa40000 Cr","10000000000-other":"\xa40000 Cr","100000000000-one":"\xa400000 Cr","100000000000-other":"\xa400000 Cr","1000000000000-one":"\xa40 Lk Cr","1000000000000-other":"\xa40 Lk Cr","10000000000000-one":"\xa400 Lk Cr","10000000000000-other":"\xa400 Lk Cr","100000000000000-one":"\xa40 Cr Cr","100000000000000-other":"\xa40 Cr Cr"},"sap-short":{"1000-one":"0000\xa0\xa4","1000-other":"0000\xa0\xa4","10000-one":"00000\xa0\xa4","10000-other":"00000\xa0\xa4","100000-one":"0 Lk\xa0\xa4","100000-other":"0 Lk\xa0\xa4","1000000-one":"00 Lk\xa0\xa4","1000000-other":"00 Lk\xa0\xa4","10000000-one":"0 Cr\xa0\xa4","10000000-other":"0 Cr\xa0\xa4","100000000-one":"00 Cr\xa0\xa4","100000000-other":"00 Cr\xa0\xa4","1000000000-one":"000 Cr\xa0\xa4","1000000000-other":"000 Cr\xa0\xa4","10000000000-one":"0000 Cr\xa0\xa4","10000000000-other":"0000 Cr\xa0\xa4","100000000000-one":"00000 Cr\xa0\xa4","100000000000-other":"00000 Cr\xa0\xa4","1000000000000-one":"0 Lk Cr\xa0\xa4","1000000000000-other":"0 Lk Cr\xa0\xa4","10000000000000-one":"00 Lk Cr\xa0\xa4","10000000000000-other":"00 Lk Cr\xa0\xa4","100000000000000-one":"0 Cr Cr\xa0\xa4","100000000000000-other":"0 Cr Cr\xa0\xa4"}},i={"short":{"1000-one":"0000","1000-other":"0000","10000-one":"00000","10000-other":"00000","100000-one":"0 Lk","100000-other":"0 Lk","1000000-one":"00 Lk","1000000-other":"00 Lk","10000000-one":"0 Cr","10000000-other":"0 Cr","100000000-one":"00 Cr","100000000-other":"00 Cr","1000000000-one":"000 Cr","1000000000-other":"000 Cr","10000000000-one":"0000 Cr","10000000000-other":"0000 Cr","100000000000-one":"00000 Cr","100000000000-other":"00000 Cr","1000000000000-one":"0 Lk Cr","1000000000000-other":"0 Lk Cr","10000000000000-one":"00 Lk Cr","10000000000000-other":"00 Lk Cr","100000000000000-one":"0 Cr Cr","100000000000000-other":"0 Cr Cr"}};i["sap-short"]=i["short"];var T=D?i:C;var w=T[S];if(!w){w=T["short"];}if(P!=="one"){P="other";}F=w[K+"-"+P];return F;}
function k(V){return V.indexOf("e")>0||V.indexOf("E")>0;}
function l(V){var i=N._shiftDecimalPoint(V,0);if(i.indexOf(".")>0&&!d.test(i.split(".")[1])){return undefined;}var F=parseFloat(i);var w=""+F;if(k(w)){w=N._shiftDecimalPoint(w,0);}var I=parseInt(w);if(I!==F){return undefined;}return I;}
function o(V,M,i){if(typeof V!=="number"){return NaN;}i=i||N.RoundingMode.HALF_AWAY_FROM_ZERO;M=parseInt(M);var w=""+V;if(!k(w)){var I=w.indexOf(".");if(I<0){return V;}if(w.substring(I+1).length<=M){return V;}}if(typeof i==="function"){V=i(V,M);}else{if(i.match(/^[a-z_]+$/)){i=i.toUpperCase();}if(!M){return m[i](V);}V=N._shiftDecimalPoint(m[i](N._shiftDecimalPoint(V,M)),-M);}return V;}
function q(i){return i.replace(/([.?*+^$[\]\\(){}|-])/g,"\\$1");}
function p(V,P){var i=Math.floor(Math.log(Math.abs(V))/Math.LN10);return Math.max(0,P-i-1);}
function t(U,V,S){var i={numberValue:undefined,cldrCode:[]};var w=Number.POSITIVE_INFINITY;var x,K;for(x in U){for(K in U[x]){if(K.indexOf("unitPattern")===0){var y=U[x][K];var z=y.indexOf("{0}");var C=z>-1;if(C&&!S){y=y.replace("{0}","").trim();C=false;}if(C){var P=y.substring(0,z);var A=y.substring(z+"{0}".length);var M=V.startsWith(P)&&V.endsWith(A);var D=M&&V.substring(P.length,V.length-A.length);if(D){if(D.length<w){w=D.length;i.numberValue=D;i.cldrCode=[x];}else if(D.length===w&&i.cldrCode.indexOf(x)===-1){i.cldrCode.push(x);}}}else if(y===V){if(S){i.cldrCode=[x];var E;if(K.endsWith("-zero")){E="0";}else if(K.endsWith("-one")){E="1";}else if(K.endsWith("-two")){E="2";}i.numberValue=E;return i;}else if(i.cldrCode.indexOf(x)===-1){i.cldrCode.push(x);}}}}}return i;}
function u(V,C){var S="",i,w;for(var x in C){w=C[x];if(V.indexOf(w)>=0&&S.length<w.length){S=w;i=x;}}return{symbol:S,code:i};}
function v(C){var V=C.value;var M=u(V,C.currencySymbols);if(!M.code){M=u(V,C.customCurrencyCodes);if(!M.code&&!C.customCurrenciesAvailable){var i=V.match(/(^[A-Z]{3}|[A-Z]{3}$)/);M.code=i&&i[0];}}if(M.code){var w=M.code.length-1;var x=M.code.charAt(w);var D;var y=/[\-\s]+/;if(/\d$/.test(x)){if(V.startsWith(M.code)){D=w+1;if(!y.test(V.charAt(D))){return undefined;}}}else if(/^\d/.test(M.code)){if(V.endsWith(M.code)){D=V.indexOf(M.code)-1;if(!y.test(V.charAt(D))){return undefined;}}}V=V.replace(M.symbol||M.code,"");}var z=false;if(C.duplicatedSymbols&&C.duplicatedSymbols[M.symbol]){M.code=undefined;z=true;b.error("The parsed currency symbol '"+M.symbol+"' is defined multiple "+"times in custom currencies.Therefore the result is not distinct.");}return{numberValue:V,currencyCode:M.code||undefined,duplicatedSymbolFound:z};}
return N;});
sap.ui.predefine('sap/ui/core/hyphenation/HyphenationTestingWords',[],function(){"use strict";var t={"bg":"непротивоконституционствувателствувайте","ca":"psiconeuroimmunoendocrinologia","hr":"prijestolonasljednikovičičinima","cs":"nejnezdevětadevadesáteronásobitelnějšími","da":"gedebukkebensoverogundergeneralkrigskommandersergenten","nl":"meervoudigepersoonlijkheidsstoornissen","en-us":"pneumonoultramicroscopicsilicovolcanoconiosis","et":"sünnipäevanädalalõpupeopärastlõunaväsimus","fi":"kolmivaihekilowattituntimittari","fr":"hippopotomonstrosesquippedaliophobie","de":"Kindercarnavalsoptochtvoorbereidingswerkzaamhedenplan","el-monoton":"ηλεκτροεγκεφαλογράφημα","hi":"किंकर्तव्यविमूढ़","hu":"megszentségteleníthetetlenségeskedéseitekért","it":"hippopotomonstrosesquippedaliofobia","lt":"nebeprisikiškiakopūstlapiaujančiuosiuose","nb-no":"supercalifragilisticexpialidocious","pl":"dziewięćdziesięciokilkuletniemu","pt":"pneumoultramicroscopicossilicovulcanoconiose","ru":"превысокомногорассмотрительствующий","sr":"семпаравиливичинаверсаламилитипиковски","sl":"dialektičnomaterialističen","es":"electroencefalografistas","sv":"realisationsvinstbeskattning","th":"ตัวอย่างข้อความที่จะใช้ในการยืนยันการถ่ายโอน","tr":"muvaffakiyetsizleştiricileştiriveremeyebileceklerimizdenmişsinizcesine","uk":"нікотинамідаденіндинуклеотидфосфат"};return t;});
sap.ui.predefine('sap/ui/core/message/MessageMixin',["sap/ui/core/library","sap/base/Log","sap/ui/core/LabelEnablement"],function(l,L,a){"use strict";var V=l.ValueState;var M=function(){this.refreshDataState=r;this.fnDestroy=this.destroy;this.destroy=d;};
function r(n,D){if(D.getChanges().messages&&this.getBinding(n)&&this.getBinding(n).isA("sap.ui.model.PropertyBinding")){var m=D.getMessages();var b=a.getReferencingLabels(this);var s=b[0];var f=false;m.forEach(function(c){if(b&&b.length>0){var e=sap.ui.getCore().byId(s);if(e.getMetadata().isInstanceOf("sap.ui.core.Label")&&e.getText&&c.getAdditionalText()!==e.getText()){c.setAdditionalText(e.getText());f=true;}else{L.warning("sap.ui.core.message.Message: Can't create labelText."+"Label with id "+s+" is no valid sap.ui.core.Label.",this);}}if(c.getControlId()!==this.getId()){c.addControlId(this.getId());f=true;}}.bind(this));var o=sap.ui.getCore().getMessageManager().getMessageModel();o.checkUpdate(f,true);if(m&&m.length>0){var c=m[0];if(V[c.type]){this.setValueState(c.type);this.setValueStateText(c.message);}}else{this.setValueState(V.None);this.setValueStateText('');}}}
function d(){var c=this.getId();function b(o){o.removeControlId(c);}for(var n in this.mBindingInfos){var B=this.mBindingInfos[n];if(B.binding){var D=B.binding.getDataState();var m=D.getAllMessages();m.forEach(b);}}this.fnDestroy.apply(this,arguments);}
return M;},true);
sap.ui.predefine('sap/ui/core/message/MessageParser',["sap/ui/base/Object","sap/base/Log"],function(O,L){"use strict";
var M=O.extend("sap.ui.core.message.MessageParser",{
metadata:{publicMethods:["parse","setProcessor"]},
constructor:function(){this._processor=null;}
});
M.prototype.setProcessor=function(p){this._processor=p;return this;};
M.prototype.getProcessor=function(){return this._processor;};
M.prototype.parse=function(r,R){L.error("MessageParser: parse-method must be implemented in the specific parser class. Messages "+"have been ignored.");};
return M;});
sap.ui.predefine('sap/ui/core/mvc/Controller',['sap/base/util/ObjectPath','sap/base/util/extend','sap/ui/base/EventProvider','sap/ui/base/ManagedObject','sap/ui/core/mvc/ControllerMetadata','sap/ui/core/mvc/ControllerExtension','sap/ui/core/mvc/ControllerExtensionProvider','sap/ui/core/mvc/OverrideExecution',"sap/base/Log"],function(O,e,E,M,C,a,b,c,L){"use strict";var r={};
var d=E.extend("sap.ui.core.mvc.Controller",{
metadata:{stereotype:"controller",methods:{"byId":{"public":true,"final":true},"getView":{"public":true,"final":true},"getInterface":{"public":false,"final":true},"onInit":{"public":false,"final":false,"overrideExecution":c.After},"onExit":{"public":false,"final":false,"overrideExecution":c.Before},"onBeforeRendering":{"public":false,"final":false,"overrideExecution":c.Before},"onAfterRendering":{"public":false,"final":false,"overrideExecution":c.After}}},
constructor:function(n){var t=null;if(typeof(n)=="string"){if(!r[n]){L.warning("Do not call sap.ui.core.mvc.Controller constructor for non typed scenario!");}t=r[n];}E.apply(this,arguments);if(t){e(this,r[n]);}if(this.extension){throw new Error("The keyword 'extension' cannot be used as a member of a controller");}this["_sapui_Extensions"]={};d.extendByMember(this,false);this._sapui_isExtended=false;this._aDestroyables=[];},
_isExtended:function(){return this._sapui_isExtended;},
getInterface:function(){var i={};var o=this.getMetadata();var p=o.getAllPublicMethods();p.forEach(function(s){var F=this[s];if(typeof F==='function'){i[s]=function(){var t=F.apply(this,arguments);return(t instanceof d)?t.getInterface():t;}.bind(this);}}.bind(this));this.getInterface=function(){return i;};return i;}
},C);
function f(o,i,l){var n=i.getMetadata().getName();var k=o.getMetadata();var p=o["_sapui_Extensions"];var I=o.getInterface();var q=a.getMetadata().getLifecycleConfiguration();var s={namespace:n,extension:i,reloadNeeded:false};i._setController(I);if(i.getMetadata().hasOverrides()){var t,u,v,w,x=i.getMetadata().getOverrides(),S=i.getMetadata().getStaticOverrides();for(w in S){v=i.getMetadata();if(!v.isMethodFinal(w)){a.overrideMethod(w,i,S,i,v.getOverrideExecution(w));}else{L.error("Method '"+w+"' of extension '"+n+"' is flagged final and cannot be overridden by calling 'override'");}}for(w in x){if(w!=='extension'){if(w in i.base){L.debug("Overriding  member '"+w+"' of original controller.");var y=x[w];var z=o[w];if(typeof z=="object"&&typeof y=="object"){u=p[w];v=u.extension.getMetadata();for(t in y){if(!v.isMethodFinal(t)){a.overrideMethod(t,z,y,i,v.getOverrideExecution(t));}else{L.error("Method '"+t+"' of extension '"+u.namespace+"' is flagged final and cannot be overridden by extension '"+n+"'");}}}else if(!k.isMethodFinal(w)){a.overrideMethod(w,o,x,i,k.getOverrideExecution(w));}else{L.error("Method '"+w+"' of controller '"+o.getMetadata().getName()+"' is flagged final and cannot be overridden by extension '"+n+"'");}}else if(w in q){a.overrideMethod(w,o,x,i,k.getOverrideExecution(w));}else{L.error("Method '"+w+"' does not exist in controller "+o.getMetadata().getName()+" and cannot be overridden");}}s.reloadNeeded=true;}if(x&&x.extension){for(var A in x.extension){v=p[A].extension.getMetadata();var B=O.create(A,o.extension);var D=p[A].extension;var F=x.extension[A];for(t in F){if(!v.isMethodFinal(t)){a.overrideMethod(t,B,F,i,v.getOverrideExecution(t));a.overrideMethod(t,D,F,i,v.getOverrideExecution(t));}else{L.error("Method '"+t+"' of extension '"+A+"' is flagged final and cannot be overridden by extension '"+n+"'");}}}}}var G=i.getInterface();if(l){p[l]=s;s.location=l;o[l]=G;I[l]=G;}else{p[n]=s;s.location="extension."+n;O.set("extension."+n,G,o);O.set("extension."+n,G,I);}}
function m(o,i,l){if(i instanceof a){f(o,i,l);}else if(i.getMetadata&&i.getMetadata().getStereotype()=="controllerextension"){var k=new i();f(o,k,l);}else{var n=a.getMetadata().getLifecycleConfiguration();for(var s in i){if(s in n){a.overrideMethod(s,o,i,o,n[s].overrideExecution);}else{a.overrideMethod(s,o,i);}}}}
function g(n,A){if(!n){throw new Error("Controller name ('sName' parameter) is required");}var s=n.replace(/\./g,"/")+".controller",i=k(sap.ui.require(s));function k(i){if(i){return i;}else if(r[n]){return d;}else{return O.get(n);}}if(A){return new Promise(function(l,o){if(!i){sap.ui.require([s],function(i){l(k(i));},o);}else{l(i);}});}else if(!i){i=sap.ui.requireSync(s);return k(i);}else{return i;}}
function h(i,n){var o;if(r[n]){o=new i(n);}else{o=new i();}if(!o){throw new Error("Controller "+n+" couldn't be instantiated");}return o;}
d.extendByMember=function(o,A){var s;for(s in o){if(o[s]&&o[s].getMetadata&&o[s].getMetadata().getStereotype()=="controllerextension"){o[s]=new o[s]();}}for(s in o){if(o[s]&&o[s].getMetadata&&o[s].getMetadata().getStereotype()=="controllerextension"){m(o,o[s],s);}}if(A){return Promise.resolve(o);}else{return o;}};
d.applyExtensions=function(o,n,s,v,A){function G(A,t){if(A){return g(t,true).then(function(u){u=r[t]||u;if(u!==undefined){if(u.getMetadata&&u.getMetadata().isA("sap.ui.core.mvc.Controller")){L.warning("Attempt to load Extension Controller "+t+" was not successful","Controller extension should be a plain object.",null,function(){return{type:"ControllerExtension",name:t};});}return u;}},function(u){L.error("Attempt to load Extension Controller "+t+" was not successful - is the Controller correctly defined in its file?");});}else{if(!r[t]&&!sap.ui.require(t)){g(t);}if(r[t]!==undefined){return r[t];}else{L.error("Attempt to load Extension Controller "+t+" was not successful - is the Controller correctly defined in its file?",null,function(){return{type:"ControllerExtension",name:t};});return{};}}}if(A){return b.getControllerExtensions(n,s,v,A).then(function(k){var t=k.customizingControllerNames.map(function(u){return G(true,u);});return Promise.all(t).then(function(p){var q=p.concat(k.providerControllers);for(var i=0,l=q.length;i<l;i++){m(o,q[i]);}return o;});},function(t){L.error("Controller Extension Provider: Error '"+t+"' thrown in "+d._sExtensionProvider+"; extension provider ignored.");return o;});}else{var k=b.getControllerExtensions(n,s,v,A);var p=k.customizingControllerNames.map(G.bind(null,false));var q=p.concat(k.providerControllers);for(var i=0,l=q.length;i<l;i++){m(o,q[i]);}}return o;};
d.create=function(o){return j(o.name,undefined,true,o._viewId);};
sap.ui.controller=function(n,o,A,v){if(A){L.info("Do not use deprecated factory function 'sap.ui.controller("+n+")'. Use 'sap.ui.core.mvc.Controller.create(...)' instead.","sap.ui.controller",null,function(){return{type:"sap.ui.controller",name:n};});}else{L.warning("Do not use synchronous controller creation for controller '"+n+"'! Use the new asynchronous factory 'sap.ui.core.mvc.Controller.create(...)' instead.","sap.ui.controller",null,function(){return{type:"sap.ui.controller",name:n};});}return j.apply(this,arguments);};
function j(n,o,A,v){var i,k,s=M._sOwnerId;if(typeof o==="boolean"){o=undefined;}if(!o){if(A){return g(n,A).then(function(k){return h(k,n);}).then(function(i){return d.applyExtensions(i,n,s,v,A);}).then(function(i){i._sapui_isExtended=true;return i;});}else{k=g(n,A);i=h(k,n);i=d.applyExtensions(i,n,s,v,A);i._sapui_isExtended=true;}return i;}else{r[n]=o;L.info("For defining controllers use Controller.extend instead");}}
d.prototype.getPublicMethods=function(){var p={},o=this.getMetadata(),i=o.getAllMethods(),l=o.getLifecycleConfiguration();Object.keys(i).forEach(function(s){if(o.isMethodPublic(s)){p[s]=i[s];p[s].reloadNeeded=!!(s in l);}});delete p.extension;var k=this["_sapui_Extensions"];Object.keys(k).forEach(function(n){var q=k[n];var s=q.extension.getInterface();var A=q.extension.getMetadata().getAllMethods();Object.keys(s).forEach(function(t){delete p[q.location];var u=e({},A[t],{reloadNeeded:q.reloadNeeded});p[q.location+"."+t]=u;});});return p;};
d.prototype._getDestroyables=function(){if(!this._aDestroyables){L.error("Mandatory super constructor not called for Controller: '"+this.getMetadata().getName()+"'.",null,"sap.ui.support",function(){return{type:"missingSuperConstructor"};});this._aDestroyables=[];}return this._aDestroyables;};
d.prototype.destroyFragments=function(){function D(v){v=Array.isArray(v)?v:[v];for(var i=0;i<v.length;i++){if(!v[i].isDestroyed()){v[i].destroy();}}}var k=this._getDestroyables();for(var i=0;i<k.length;i++){k[i]=k[i].then(D);}};
d.prototype.destroy=function(){if(this["_sapui_Extensions"]){Object.keys(this["_sapui_Extensions"]).forEach(function(k){var o=this["_sapui_Extensions"][k];O.set(o.location,null,this);}.bind(this));delete this["_sapui_Extensions"];}E.prototype.destroy.apply(this,arguments);};
d.prototype.getView=function(){return this.oView;};
d.prototype.byId=function(i){return this.oView?this.oView.byId(i):undefined;};
d.prototype.createId=function(i){return this.oView?this.oView.createId(i):undefined;};
d.prototype.getOwnerComponent=function(){var i=sap.ui.require("sap/ui/core/Component");if(i){return i.getOwnerComponentFor(this.getView());}else{return undefined;}};
d.prototype.connectToView=function(v){this.oView=v;if(this.onInit){v.attachAfterInit(this.onInit,this);}if(this.onExit){v.attachBeforeExit(this.onExit,this);if(v.bControllerIsViewManaged){v.attachBeforeExit(this.destroyFragments,this);}}if(this.onAfterRendering){v.attachAfterRendering(this.onAfterRendering,this);}if(this.onBeforeRendering){v.attachBeforeRendering(this.onBeforeRendering,this);}};
d.prototype.loadFragment=function(o){if(!this.getView()){throw new Error("Calling 'loadFragment' without a view attached is not supported!");}else if(!o||!o.name){throw new Error("oOptions must provide at least a fragment name!");}var i=this.getOwnerComponent();var A=o.addToDependents!==false;var k=o.autoPrefixId!==false;var F={name:o.name,type:o.type,id:o.id,controller:this};var D=this._getDestroyables();var p=new Promise(function(l,n){sap.ui.require(["sap/ui/core/Fragment"],function(q){l(q);},n);}).then(function(l){if(!o.id&&k){F.id=this.getView().getId();}else if(k){F.id=this.createId(o.id);}if(i){return i.runAsOwner(function(){return l.load(F);});}else{return l.load(F);}}.bind(this)).then(function(v){if(A){this.getView().applySettings({"dependents":v});}D.splice(D.indexOf(p),1);return v;}.bind(this));D.push(p);return p;};
d._sExtensionProvider=null;
d.registerExtensionProvider=function(s){d._sExtensionProvider=s;b.registerExtensionProvider(s);};
return d;});
sap.ui.predefine('sap/ui/core/mvc/ControllerExtension',['sap/ui/base/Object','sap/ui/base/Metadata','sap/ui/core/mvc/ControllerMetadata','sap/ui/core/mvc/OverrideExecution','sap/base/util/uid',"sap/base/Log"],function(B,M,C,O,u,L){"use strict";
var a=B.extend("sap.ui.core.mvc.ControllerExtension",{
metadata:{stereotype:"controllerextension",methods:{"byId":{"public":true,"final":true},"getView":{"public":true,"final":true},"getInterface":{"public":false,"final":true}}},
_setController:function(c){this.base=c;},
byId:function(i){var n=this.getMetadata().getNamespace();i=n+"."+i;return this.base?this.base.byId(i):undefined;},
getView:function(){return this.base.getView();},
getInterface:function(){var m={};var o=this.getMetadata();var p=o.getAllPublicMethods();p.forEach(function(s){var f=this[s];if(typeof f==='function'){m[s]=function(){var t=f.apply(this,arguments);return(t instanceof a)?t.getInterface():t;}.bind(this);}}.bind(this));this.getInterface=function(){return m;};return m;}
},C);
a.override=function(e){var c=M.createClass(this,"anonymousExtension~"+u(),{},C);c.getMetadata()._staticOverride=e;c.getMetadata()._override=this.getMetadata()._override;return c;};
a.overrideMethod=function(m,o,c,b,s){var f=o[m];var d=c[m];s=s||O.Instead;function w(e){(function(d,f,b,e){o[m]=function(){if(e){d.apply(b,arguments);return f.apply(o,arguments);}else{f.apply(o,arguments);return d.apply(b,arguments);}};})(d,f,b,e);}if(typeof d==='function'&&b){d=d.bind(b);}switch(s){case O.Before:if(f&&typeof f==="function"){w(true);}else if(typeof d==="function"){o[m]=d;}else{L.error("Controller extension failed: lifecycleMethod '"+m+"', is not a function");}break;case O.After:if(f&&typeof f==="function"){w(false);}else if(typeof d==="function"){o[m]=d;}else{L.error("Controller extension failed: lifecycleMethod '"+m+"', is not a function");}break;case O.Instead:default:if(m in o){L.debug("Overriding  member '"+m+"' of extension "+this.getMetadata().getName());if(!this.getMetadata().isMethodFinal(m)){o[m]=d;}else{L.error("Error in ControllerExtension.override: Method '"+m+"' of extension '"+this.getMetadata().getName()+"' is flagged final and cannot be overridden!");}}else{o[m]=d;}break;}};
return a;});
sap.ui.predefine('sap/ui/core/mvc/ControllerExtensionProvider',["sap/base/Log","sap/ui/core/Component"],function(L,C){"use strict";var e={};var a={};a._sExtensionProvider=null;
a.registerExtensionProvider=function(E){a._sExtensionProvider=E;};
a.getControllerExtensions=function(c,s,v,A){var m={customizingControllerNames:[],providerControllers:[]};var o=C.get(s);if(o&&o.getLocalId){v=o.getLocalId(v)||v;}var M=r(c,o,v);m.customizingControllerNames=M;if(A){if(a._sExtensionProvider){return l(A).then(function(E){return E.getControllerExtensions(c,s,A,v);}).then(function(b){m.providerControllers=b||[];return m;});}else{return Promise.resolve(m);}}else{if(a._sExtensionProvider){var E=l();if(E){var b=E.getControllerExtensions(c,s,A,v);if(b&&Array.isArray(b)){m.providerControllers=b;}else{L.error("Controller Extension Provider: Error in ExtensionProvider.getControllerExtensions: "+a._sExtensionProvider+" - no valid extensions returned. Return value must be an array of ControllerExtensions.");}}}return m;}};
function r(c,o,v){var b=[];var I=C.getCustomizing(o,{type:"sap.ui.controllerExtensions",name:c+"#"+v});var d=[];if(I){d.push(I);}else{var D=C.getCustomizing(o,{type:"sap.ui.controllerExtensions",name:c});if(D){d.push(D);}}for(var i=0;i<d.length;i++){var f=d[i];if(f){var E=typeof f==="string"?f:f.controllerName;b=b.concat(f.controllerNames||[]);if(E){b.unshift(E);}}}return b;}
function l(A){var p=a._sExtensionProvider.replace(/\./g,"/"),P=e[p];if(P){return A?Promise.resolve(P):P;}if(p){if(A){return new Promise(function(b,c){sap.ui.require([p],function(d){P=new d();e[p]=P;b(P);},c);});}else{var E=sap.ui.requireSync(p);P=new E();e[p]=P;return P;}}else{return A?Promise.resolve():undefined;}}
return a;});
sap.ui.predefine('sap/ui/core/mvc/ControllerMetadata',['sap/ui/base/Metadata','sap/base/util/merge','sap/ui/core/mvc/OverrideExecution',"sap/base/Log"],function(M,a,O,L){"use strict";var C=function(c,o){M.apply(this,arguments);if(this.isA("sap.ui.core.mvc.ControllerExtension")&&this.getParent().getClass().override){this.getClass().override=this.getParent().getClass().override;}};C.prototype=Object.create(M.prototype);C.prototype.constructor=C;
C.prototype.applySettings=function(c){if(c.override){this._override=c.override;delete c.override;}M.prototype.applySettings.call(this,c);var s=c.metadata;this._defaultLifecycleMethodMetadata={"onInit":{"public":true,"final":false,"overrideExecution":O.After},"onExit":{"public":true,"final":false,"overrideExecution":O.Before},"onBeforeRendering":{"public":true,"final":false,"overrideExecution":O.Before},"onAfterRendering":{"public":true,"final":false,"overrideExecution":O.After}};var i=this.isA("sap.ui.core.mvc.ControllerExtension");var r=/^_/;var e=this._oParent.isA("sap.ui.core.mvc.Controller");var d=c.metadata&&c.metadata.methods?true:false;if(!i){if(e&&!d){r=/^_|^on|^init$|^exit$/;}if(e&&d){a(s.methods,this._defaultLifecycleMethodMetadata);}}if(i||d){this._aPublicMethods=[];}this._mMethods=s.methods||{};for(var n in c){if(n!=="metadata"&&n!=="constructor"){if(!n.match(r)){if(e&&this._oParent&&this._oParent.isMethodFinal(n)){L.error("Method: '"+n+"' of controller '"+this._oParent.getName()+"' is final and cannot be overridden by controller '"+this.getName()+"'");delete this._oClass.prototype[n];}if(!(n in this._mMethods)&&typeof c[n]==='function'){if(!(c[n].getMetadata&&c[n].getMetadata().isA("sap.ui.core.mvc.ControllerExtension"))){this._mMethods[n]={"public":true,"final":false};}}}}}for(var m in this._mMethods){if(this.isMethodPublic(m)){this._aPublicMethods.push(m);}}};
C.prototype.afterApplySettings=function(){M.prototype.afterApplySettings.call(this);var i=this.isA("sap.ui.core.mvc.ControllerExtension");if(this._oParent){var p=this._oParent._mMethods?this._oParent._mMethods:{};for(var m in p){if(this._mMethods[m]&&!i){var P=this._mMethods[m].public;this._mMethods[m]=a({},p[m]);if(P!==undefined){this._mMethods[m].public=P;}if(!this.isMethodPublic(m)&&this._mMethods[m].public!==p[m].public){this._aAllPublicMethods.splice(this._aAllPublicMethods.indexOf(m),1);}}else{this._mMethods[m]=p[m];}}}if(this._oParent&&this._oParent.isA("sap.ui.core.mvc.ControllerExtension")){this._bFinal=true;}};
C.prototype.getNamespace=function(){var i=this._sClassName.indexOf("anonymousExtension~")==0;var n=i?this._oParent._sClassName:this._sClassName;return n.substr(0,n.lastIndexOf("."));};
C.prototype.isMethodFinal=function(m){var o=this._mMethods[m];return o&&o.final;};
C.prototype.isMethodPublic=function(m){var o=this._mMethods[m];return o&&o.public;};
C.prototype.getAllMethods=function(){return this._mMethods;};
C.prototype.getOverrideExecution=function(m){var o=this._mMethods[m];var s=O.Instead;if(o){s=o.overrideExecution;}return s;};
C.prototype.getOverrides=function(){return this._override;};
C.prototype.getStaticOverrides=function(){return this._staticOverride;};
C.prototype.hasOverrides=function(){return!!this._override||!!this._staticOverride;};
C.prototype.getLifecycleConfiguration=function(){return this._defaultLifecycleMethodMetadata;};
return C;});
sap.ui.predefine('sap/ui/core/mvc/EventHandlerResolver',["sap/ui/base/BindingParser","sap/ui/core/CommandExecution","sap/ui/model/BindingMode","sap/ui/model/CompositeBinding","sap/ui/model/json/JSONModel","sap/ui/model/base/ManagedObjectModel","sap/base/util/JSTokenizer","sap/base/util/ObjectPath","sap/base/util/resolveReference","sap/base/Log"],function(B,C,a,b,J,M,c,O,r,L){"use strict";var E={resolveEventHandler:function(n,o,l){var h,s,f;n=n.trim();if(sap.ui.getCore().getConfiguration().getControllerCodeDeactivated()){h=function(){};}else{if(n.startsWith("cmd:")){var d=n.substr(4);h=function(e){var j=C.find(e.getSource(),d);if(j){j.trigger();}else{L.error("Handler '"+n+"' could not be resolved. No CommandExecution defined for command: "+d);}};h._sapui_commandName=d;}else{s=n.indexOf("(");f=n;if(s>0){f=n.substring(0,s).trim();}else if(s===0){throw new Error("Event handler name starts with a bracket, must start with a function name "+"(or with a dot followed by controller-local function name): "+n);}h=r(f,Object.assign({".":o},l),{preferDotContext:f.indexOf(".")===-1,bindContext:false});}if(h&&s>0){var i=n.lastIndexOf(")");if(i>s){if(n.substring(s).indexOf("{=")>-1){L.warning("It looks like an event handler parameter contains a binding expression ({=...}). This is not allowed and will cause an error later on "+"because the entire event handler is already considered an expression: "+n);}h=(function(f,o){return function(j){var p,S,k=n;if(n.indexOf("$parameters")>-1){p=new J(j.mParameters);}if(n.indexOf("$source")>-1){S=new M(j.getSource());}var m={"$controller":o,$event:j};if(f.indexOf(".")>0){var G=f.split(".")[0];m[G]=window[G];}else if(f.indexOf(".")===-1){if(o&&o[f]){k="$controller."+k;}else if(window[f]){m[f]=window[f];}}Object.assign(m,l);var q=B.parseExpression(k.replace(/^\./,"$controller."),0,{oContext:o},m);if(q.result){try{g(q.result,j.getSource(),o,p,S);}catch(e){e.message="Error when evaluating event handler '"+n+"': "+e.message;throw e;}}if(p){p.destroy();}if(S){S.destroy();}};})(f,o);}else{L.error("Syntax error in event handler '"+n+"': arguments must be enclosed in a pair of brackets");}}}if(typeof h==="function"){h._sapui_handlerName=n;return[h,o];}L.warning("Event handler name '"+n+"' could not be resolved to an event handler function");},parse:function e(v){v=v.trim();var t=new c();var R=[];var s="";var p=0;t.init(v,0);for(;;){var S=t.next();if(S==='"'||S==="'"){var d=t.getIndex();t.string();s+=v.slice(d,t.getIndex());S=t.getCh();}if(!S){break;}switch(S){case"(":p++;break;case")":p--;break;default:break;}if(S===";"&&p===0){R.push(s.trim());s="";}else{s+=S;}}if(s){R.push(s.trim());}return R;}};
function g(o,e,d,p,s){var t,P;o.mode=a.OneWay;if(!o.parts){o.parts=[];o.parts[0]={path:o.path,targetType:o.targetType,type:o.type,suspended:o.suspended,formatOptions:o.formatOptions,constraints:o.constraints,model:o.model,mode:o.mode};delete o.path;delete o.targetType;delete o.mode;delete o.model;}for(var i=0;i<o.parts.length;i++){P=o.parts[i];if(typeof P=="string"){P={path:P};o.parts[i]=P;}if(!P.path&&P.parts){throw new Error("Bindings in event handler parameters cannot use parts. Just use one single path.");}var S=P.path.indexOf(">");if(S>0){P.model=P.path.substr(0,S);P.path=P.path.substr(S+1);}}var T,f,h,j=[];o.parts.forEach(function(P){var m;if(P.model==="$parameters"){m=p;f=p.createBindingContext("/");}else if(P.model==="$source"){m=s;f=s.createBindingContext("/");}else{m=e.getModel(P.model);f=e.getBindingContext(P.model);}t=P.type;if(typeof t=="string"){T=O.get(t);if(typeof T!=="function"){throw new Error("Cannot find type \""+t+"\" used for binding \""+P.path+"\"!");}t=new T(P.formatOptions,P.constraints);}h=m.bindProperty(P.path,f,o.parameters);h.setType(t,P.targetType||"any");h.setFormatter(P.formatter);h.setBindingMode(a.OneTime);j.push(h);});if(j.length>1||(o.formatter&&o.formatter.textFragments)){t=o.type;if(typeof t=="string"){T=O.get(t);t=new T(o.formatOptions,o.constraints);}h=new b(j,o.useRawValues,o.useInternalValues);h.setType(t,P.targetType||"any");h.setBindingMode(a.OneTime);}else{h=j[0];}h.setFormatter(o.formatter);h.initialize();return h.getExternalValue();}
return E;});
sap.ui.predefine('sap/ui/core/mvc/HTMLView',['sap/ui/thirdparty/jquery','./View','./HTMLViewRenderer','./ViewType','sap/base/util/merge','sap/ui/base/ManagedObject','sap/ui/core/DeclarativeSupport','sap/ui/model/resource/ResourceModel','sap/base/util/LoaderExtensions'],function(q,V,H,a,m,M,D,R,L){"use strict";
var b=V.extend("sap.ui.core.mvc.HTMLView",{
metadata:{library:"sap.ui.core"},
renderer:H
});
b.create=function(o){var p=m({},o);p.type=a.HTML;return V.create(p);};
sap.ui.htmlview=function(i,v){return sap.ui.view(i,v,a.HTML);};
b._sType=a.HTML;b.asyncSupport=true;b._mTemplates={};b._mAllowedSettings={"viewName":true,"controller":true,"viewContent":true,"definition":true,"controllerName":true,"resourceBundleName":true,"resourceBundleUrl":true,"resourceBundleLocale":true,"resourceBundleAlias":true};
b._getTemplate=function(t,o){var u=this._getViewUrl(t);var h=this._mTemplates[u];if(!h){h=this._loadTemplate(t,o);if(o&&o.async){var c=this;return h.then(function(_){c._mTemplates[u]=_;return Promise.resolve(_);});}else{this._mTemplates[u]=h;}}return o.async?Promise.resolve(h):h;};
b.prototype.getControllerName=function(){return this._controllerName;};
b._getViewUrl=function(t){return sap.ui.require.toUrl(t.replace(/\./g,"/"))+".view.html";};
b._loadTemplate=function(t,o){var r=t.replace(/\./g,"/")+".view.html";return L.loadResource(r,o);};
b.prototype.initViewSettings=function(s){if(!s){throw new Error("mSettings must be given");}if(s.viewName&&s.viewContent){throw new Error("View name and view content are given. There is no point in doing this, so please decide.");}else if(!s.viewName&&!s.viewContent){throw new Error("Neither view name nor view content is given. One of them is required.");}var t=this;function I(){t._oTemplate=document.createElement("div");if(typeof h==="string"){t._oTemplate.innerHTML=h;}else{var n=h;var f=document.createDocumentFragment();for(var i=0;i<n.length;i++){f.appendChild(n.item(i));}t._oTemplate.appendChild(f);}var o=t._oTemplate.getElementsByTagName("template")[0];var p=t.getMetadata().getAllProperties();if(o){q.each(o.attributes,function(d,A){var N=D.convertAttributeToSettingName(A.name,t.getId());var v=A.value;var P=p[N];if(!s[N]){if(P){s[N]=D.convertValueToType(D.getPropertyDataType(P),v);}else if(b._mAllowedSettings[N]){s[N]=v;}}});t._oTemplate=o;}if(t._oTemplate.content){var f=t._oTemplate.content;t._oTemplate=document.createElement("div");t._oTemplate.appendChild(f);}if(s.controllerName){t._controllerName=s.controllerName;}if((s.resourceBundleName||s.resourceBundleUrl)&&(!s.models||!s.models[s.resourceBundleAlias])){var c=new R({bundleName:s.resourceBundleName,bundleUrl:s.resourceBundleUrl,bundleLocale:s.resourceBundleLocale,async:s.async});var B=c.getResourceBundle();if(B instanceof Promise){return B.then(function(){t.setModel(c,s.resourceBundleAlias);});}t.setModel(c,s.resourceBundleAlias);}}var h=s.viewContent;if(!h){h=b._getTemplate(s.viewName,{async:s.async});}if(s.async){return h.then(function(_){h=_;return I();});}I();};
b.prototype.onControllerConnected=function(c){var t=this;M.runWithPreprocessors(function(){D.compile(t._oTemplate,t);},{settings:this._fnSettingsPreprocessor});};
b.prototype.exit=function(){this._oTemplate=null;V.prototype.exit.call(this);if(this._connectedControls){for(var i=0;i<this._connectedControls.length;i++){this._connectedControls[i].destroy();}this._connectedControls=null;}};
b.prototype.connectControl=function(c){this._connectedControls=this._connectedControls||[];this._connectedControls.push(c);};
return b;});
sap.ui.predefine('sap/ui/core/mvc/HTMLViewRenderer',['./ViewRenderer'],function(V){"use strict";var H={apiVersion:1};
H.render=function(r,c){r.openStart("div",c);r.class("sapUiView");r.class("sapUiHTMLView");V.addDisplayClass(r,c);r.style("width",c.getWidth());r.style("height",c.getHeight());r.openEnd();if(c._oTemplate){var h=c._oTemplate.innerHTML;var a=c.getContent();var d=[];var b=function(c){var t=H._getHTML(r,c,h);if(t){h=t;}else{d.push(c);}};if(a){if(Array.isArray(a)){for(var i=0;i<a.length;i++){b(a[i]);}}else if(a){b(a);}}r.unsafeHtml(h);for(var k=0;k<d.length;k++){r.renderControl(d[k]);}}r.close("div");};
H._getHTML=function(r,c,h){var i=c.getId();h=h.replace(/(<div)/gi,"\n$1");var a=new RegExp('<div.*?data-sap-ui-id="'+i+'".*?></div>',"gi");var m=a.exec(h);if(m){h=h.replace(m[0],r.getHTML(c));return h;}else{return"";}};
return H;},true);
sap.ui.predefine('sap/ui/core/mvc/JSONView',['./View','./JSONViewRenderer','./ViewType','./EventHandlerResolver','sap/base/util/merge','sap/ui/base/ManagedObject','sap/ui/model/resource/ResourceModel','sap/base/Log','sap/base/util/LoaderExtensions'],function(V,J,a,E,m,M,R,L,b){"use strict";
var c=V.extend("sap.ui.core.mvc.JSONView",{
metadata:{library:"sap.ui.core"},
renderer:J
});
c.create=function(o){var p=m({},o);for(var O in p){if(O==='preprocessors'){delete p['preprocessors'];L.warning("JSONView.create does not support the option preprocessors!");}}p.type=a.JSON;return V.create(p);};
sap.ui.jsonview=function(i,v){return sap.ui.view(i,v,a.JSON);};
c._sType=a.JSON;c.asyncSupport=true;
c.prototype.initViewSettings=function(s){if(!s){throw new Error("mSettings must be given");}if(s.viewName&&s.viewContent){throw new Error("View name and view content are given. There is no point in doing this, so please decide.");}else if(!s.viewName&&!s.viewContent){throw new Error("Neither view name nor view content is given. One of them is required.");}var t=this;var i=function(){if((t._oJSONView.resourceBundleName||t._oJSONView.resourceBundleUrl)&&(!s.models||!s.models[t._oJSONView.resourceBundleAlias])){var o=new R({bundleName:t._oJSONView.resourceBundleName,bundleUrl:t._oJSONView.resourceBundleUrl,async:s.async});var B=o.getResourceBundle();if(B instanceof Promise){return B.then(function(){t.setModel(o,t._oJSONView.resourceBundleAlias);});}t.setModel(o,t._oJSONView.resourceBundleAlias);}};if(s.viewName){if(s.async){return this._loadTemplate(s.viewName,{async:true}).then(i);}else{this._loadTemplate(s.viewName);i();}}else if(s.viewContent){this.mProperties["viewContent"]=s.viewContent;if(typeof s.viewContent==="string"){this._oJSONView=JSON.parse(s.viewContent);if(!this._oJSONView){throw new Error("error when parsing viewContent: "+s.viewContent);}}else if(typeof s.viewContent==="object"){this._oJSONView=s.viewContent;}else{throw new Error("viewContent must be a JSON string or object, but is a "+(typeof s.viewContent));}if(s.async){return Promise.resolve().then(i);}else{i();}}};
c.prototype.onControllerConnected=function(C){var t=this;M.runWithPreprocessors(function(){t.applySettings({content:t._oJSONView.content},C);},{id:function(i){return t.createId(i);},settings:function(s){var o=this.getMetadata(),v=o.getJSONKeys(),k,d,K;for(k in s){if((K=v[k])!==undefined){d=s[k];switch(K._iKind){case 3:if(typeof d==="string"){s[k]=t.createId(d);}break;case 5:if(typeof d==="string"){s[k]=E.resolveEventHandler(d,C);}break;}}}}});};
c.prototype._loadTemplate=function(t,o){var r=t.replace(/\./g,"/")+".view.json";if(!o||!o.async){this._oJSONView=b.loadResource(r);}else{var d=this;return b.loadResource(r,o).then(function(j){d._oJSONView=j;});}};
c.prototype.getControllerName=function(){return this._oJSONView.controllerName;};
return c;});
sap.ui.predefine('sap/ui/core/mvc/JSONViewRenderer',['./ViewRenderer'],function(V){"use strict";var J={apiVersion:2};
J.render=function(r,c){r.openStart("div",c);r.class("sapUiView");r.class("sapUiJSONView");V.addDisplayClass(r,c);r.style("width",c.getWidth());r.style("height",c.getHeight());r.openEnd();c.getContent().forEach(r.renderControl,r);r.close("div");};
return J;},true);
sap.ui.predefine('sap/ui/core/mvc/JSView',['./View','./JSViewRenderer','./ViewType','sap/base/util/extend','sap/base/util/merge','sap/ui/base/ManagedObject','sap/base/Log'],function(V,J,a,m,e,M,L){"use strict";
var b=V.extend("sap.ui.core.mvc.JSView",{
metadata:{library:"sap.ui.core"},
renderer:J
});
var r={};b.asyncSupport=true;b._sType=a.JS;
b.create=function(o){var p=m({},o);for(var O in p){if(O==='definition'||O==='preprocessors'){delete p[O];L.warning("JSView.create does not support the options definition or preprocessor!");}}p.type=a.JS;return V.create(p);};
sap.ui.jsview=function(i,c,A){return v.apply(this,arguments);};
function v(i,c,A){var s={},o;if(c&&typeof(c)=="string"){s.viewName=c;if(typeof arguments[2]=="boolean"){s.async=A;}else if(typeof arguments[2]=="object"){s.controller=arguments[2];s.async=!!arguments[3];}if(s.viewName.startsWith("module:")){throw Error("Legacy factory sap.ui.jsview doesn't support typed views!");}o=new b(i,s);return o;}else if(c&&typeof(c)=="object"){r[i]=c;sap.ui.loader._.declareModule(i.replace(/\./g,"/")+".view.js");L.warning("For defining views, use typed views with 'sap.ui.core.mvc.View.extend()'.");}else if(arguments.length==1&&typeof i=="string"||arguments.length==2&&typeof arguments[0]=="string"&&typeof arguments[1]=="boolean"){s.viewName=arguments[0];s.async=!!arguments[1];o=s.id?new b(s.id,s):new b(s);return o;}else{throw new Error("Wrong arguments ('"+i+"', '"+c+"')!"+" Either call sap.ui.jsview([sId,] sViewName) to instantiate a View"+" or sap.ui.jsview(sViewName, oViewImpl) to define a View type.");}}
b.prototype.initViewSettings=function(s){var p;L.warning("Do not use deprecated sap.ui.core.mvc.JSView: (View: "+(s.id||s.viewName)+"). "+"Use typed views defined by 'sap.ui.core.mvc.View.extend()' and created by 'sap.ui.core.mvc.View.create()'. "+"For further information, have a look at https://sapui5.hana.ondemand.com/#/topic/e6bb33d076dc4f23be50c082c271b9f0.","sap.ui.core.mvc.JSView",null,function(){return{type:"sap.ui.core.mvc.JSView",name:s.viewName};});if(Object.getPrototypeOf(this)===b.prototype){if(!r[s.viewName]){var c=s.viewName.replace(/\./g,"/")+".view";if(s.async){p=new Promise(function(d,f){sap.ui.require([c],d,f);});}else{sap.ui.requireSync(c);}}if(s.async){return Promise.resolve(p).then(function(){e(this,r[s.viewName]);}.bind(this));}e(this,r[s.viewName]);}else if(s.async){return Promise.resolve();}};
b.prototype.onControllerConnected=function(c){M.runWithPreprocessors(function(){this.applySettings({content:this.createContent(c)});},{id:this.getAutoPrefixId()?this.createId.bind(this):undefined,settings:this._fnSettingsPreprocessor},this);};
return b;});
sap.ui.predefine('sap/ui/core/mvc/JSViewRenderer',['./ViewRenderer'],function(V){"use strict";var J={apiVersion:2};
J.render=function(r,c){r.openStart("div",c);r.class("sapUiView");r.class("sapUiJSView");V.addDisplayClass(r,c);r.style("width",c.getWidth());r.style("height",c.getHeight());r.openEnd();c.getContent().forEach(r.renderControl,r);r.close("div");};
return J;},true);
sap.ui.predefine('sap/ui/core/mvc/OverrideExecution',function(){"use strict";var O={After:"After",Before:"Before",Instead:"Instead"};return O;},true);
sap.ui.predefine('sap/ui/core/mvc/TemplateView',["./View","./TemplateViewRenderer","./ViewType","sap/base/Log"],function(V,T,a,L){"use strict";
var b=V.extend("sap.ui.core.mvc.TemplateView",{
metadata:{library:"sap.ui.core"},
renderer:T
});
(function(){
sap.ui.templateview=function(i,v){L.warning("sap.ui.core.mvc.TemplateView is deprecated. Use XMLView or JSView instead.");return sap.ui.view(i,v,a.Template);};
b._sType=a.Template;
b.prototype.getControllerName=function(){return this._sControllerName;};
b._getViewUrl=function(t){return sap.ui.require.toUrl(t.replace(/\./g,"/"))+".view.tmpl";};
b.prototype.initViewSettings=function(s){if(!s){throw new Error("mSettings must be given");}if(!s.viewName){throw new Error("No view name is given.");}this._oTemplate=sap.ui.template({id:this.getId(),src:b._getViewUrl(s.viewName)});this._sControllerName=this._oTemplate._sControllerName;this._oTemplate=this._oTemplate.createControl(undefined,undefined,this);this.addContent(this._oTemplate);};
}());return b;});
sap.ui.predefine('sap/ui/core/mvc/TemplateViewRenderer',['./ViewRenderer'],function(V){"use strict";var T={apiVersion:2};
T.render=function(r,c){r.openStart("div",c);r.class("sapUiView");r.class("sapUiTmplView");V.addDisplayClass(r,c);r.style("width",c.getWidth());r.style("height",c.getHeight());r.openEnd();r.renderControl(c._oTemplate);r.close("div");};
return T;},true);
sap.ui.predefine('sap/ui/core/mvc/View',["sap/base/util/isEmptyObject","sap/ui/base/ManagedObject","sap/ui/core/Control","sap/ui/core/mvc/Controller","sap/base/util/merge","./ViewType","./ViewRenderer","./XMLProcessingMode","sap/base/assert","sap/base/Log","sap/base/util/extend","sap/ui/core/Core"],function(a,M,C,b,m,V,c,X,d,L,f){"use strict";
var g=C.extend("sap.ui.core.mvc.View",{
metadata:{interfaces:["sap.ui.core.IDScope"],"abstract":true,library:"sap.ui.core",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},viewName:{type:"string",group:"Misc",defaultValue:null},displayBlock:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},events:{afterInit:{},beforeExit:{},afterRendering:{},beforeRendering:{}},specialSettings:{controller:'sap.ui.core.mvc.Controller',controllerName:'string',preprocessors:'Object',resourceBundleName:'string',resourceBundleUrl:'sap.ui.core.URI',resourceBundleLocale:'string',resourceBundleAlias:'string',type:'string',definition:'any',viewContent:{type:'any',deprecated:true},viewData:'any',async:{type:"boolean",defaultValue:false}},designtime:"sap/ui/core/designtime/mvc/View.designtime"},
renderer:c
});
g._mPreprocessors={};
function h(P){P._settings={};for(var e in P){if(e.indexOf("_")!==0){P._settings[e]=P[e];}}}
function k(P,A){var e;if(typeof P.preprocessor==="string"){var i=P.preprocessor.replace(/\./g,"/");if(A){return new Promise(function(j,l){sap.ui.require([i],function(e){j(e);},l);});}else{return sap.ui.requireSync(i);}}else if(typeof P.preprocessor==="function"&&!P.preprocessor.process){e={process:P.preprocessor};}else{e=P.preprocessor;}if(A){return Promise.resolve(e);}else{return e;}}
function n(e,T){var j=this.mPreprocessors[T]||[],G=[],i,l,O,P=[];if(g._mPreprocessors[e]&&g._mPreprocessors[e][T]){G=g._mPreprocessors[e][T].map(function(x){return Object.assign({},x);});}for(i=0,l=G.length;i<l;i++){if(G[i]._onDemand){O=G[i];}else{P.push(G[i]);}}for(i=0,l=j.length;i<l;i++){var I=!j[i].preprocessor;if(I&&O){P.unshift(f(j[i],O));}else if(!I){P.push(j[i]);}}return P;}
function o(e,S){var i=e.getMetadata().getClass();function j(P){P.preprocessor=k(P,S.async);}e.mPreprocessors=Object.assign({},S.preprocessors);for(var _ in i.PreprocessorType){var T=i.PreprocessorType[_];if(e.mPreprocessors[T]&&!Array.isArray(e.mPreprocessors[T])){e.mPreprocessors[T]=[e.mPreprocessors[T]];}else if(!e.mPreprocessors[T]){e.mPreprocessors[T]=[];}e.mPreprocessors[T].forEach(h);e.mPreprocessors[T]=n.call(e,i._sType,T);e.mPreprocessors[T].forEach(j);}}
function p(e){e.oAsyncState={};e.oAsyncState.promise=null;}
var q=function(T,S){if(!sap.ui.getCore().getConfiguration().getControllerCodeDeactivated()){var e=S.controller,N=e&&typeof e.getMetadata==="function"&&e.getMetadata().getName(),A=S.async;if(!e&&T.getControllerName){T.bControllerIsViewManaged=true;var i=T.getControllerName();if(i){var j=sap.ui.require("sap/ui/core/Component");if(j){var l=j.getCustomizing(T,{type:"sap.ui.controllerReplacements",name:i});if(l){i=typeof l==="string"?l:l.controllerName;}}if(A){e=b.create({name:i,_viewId:T.sId});}else{e=sap.ui.controller(i,true,false,T.sId);}}}else if(e){T.bControllerIsViewManaged=false;var O=M._sOwnerId;if(!e._isExtended()){e=b.applyExtensions(e,N,O,T.sId,A);}else if(A){e=Promise.resolve(e);}}if(e){var x=function(e){T.oController=e;e.oView=T;};if(A){if(!T.oAsyncState){throw new Error("The view "+T.sViewName+" runs in sync mode and therefore cannot use async controller extensions!");}return e.then(x);}else{x(e);}}}else{sap.ui.controller("sap.ui.core.mvc.EmptyControllerImpl",{"_sap.ui.core.mvc.EmptyControllerImpl":true});T.oController=sap.ui.controller("sap.ui.core.mvc.EmptyControllerImpl");}};
g.prototype._initCompositeSupport=function(S){S=S||{};d(!S.preprocessors||this.getMetadata().getName().indexOf("XMLView"),"Preprocessors only available for XMLView");this.oViewData=S.viewData;this.sViewName=S.viewName;if(this.sViewName&&this.sViewName.startsWith("module:")){this.sViewName=this.sViewName.slice("module:".length).replace(/\//g,".");}var i=this;o(this,S);if(S.async){p(this);}var j=sap.ui.require("sap/ui/core/Component");if(j){var l=j.getCustomizing(this,{type:"sap.ui.viewModifications",name:this.sViewName});if(!a(l)){this._fnSettingsPreprocessor=function(S){var I=this.getId();if(I){if(i.isPrefixedId(I)){I=I.substring((i.getId()+"--").length);}var e=Object.assign({},l[I]);if(e){for(var x in e){if(x!=="visible"){L.warning("Customizing: custom value for property '"+x+"' of control '"+I+"' in View '"+i.sViewName+"' ignored: only the 'visible' property can be customized.");delete e[x];}}L.info("Customizing: custom value for property 'visible' of control '"+I+"' in View '"+i.sViewName+"' applied: "+e.visible);S=f(S,e);}}};}}var P=function(e,x){d(typeof e==="function","fn must be a function");var O=j&&j.getOwnerComponentFor(i);if(O){if(x){i.fnScopedRunWithOwner=i.fnScopedRunWithOwner||function(y){return O.runAsOwner(y);};}return O.runAsOwner(e);}return e();};var A=function(e){if(e.oController&&e.oController.connectToView){return e.oController.connectToView(e);}};var F=function(S){if(i.onControllerConnected){return i.onControllerConnected(i.oController,S);}};if(S.async){this.oAsyncState.promise=this.initViewSettings(S).then(function(){return P(q.bind(null,i,S),true);}).then(function(){return P(F.bind(null,S),true);}).then(function(){return A(i);}).then(function(){return i.runPreprocessor("controls",i,false);}).then(function(){return P(i.fireAfterInit.bind(i),true);}).then(function(){return i;}).catch(function(e){this.deregister();throw e;}.bind(this));}else{this.initViewSettings(S);q(this,S);F(S);A(this);this.runPreprocessor("controls",this,true);this.fireAfterInit();}};
g.prototype.getController=function(){return this.oController;};
g.prototype.byId=function(i){return sap.ui.getCore().byId(this.createId(i));};
g.prototype.createId=function(i){if(!this.isPrefixedId(i)){i=this.getId()+"--"+i;}return i;};
g.prototype.getLocalId=function(i){var P=this.getId()+"--";return(i&&i.indexOf(P)===0)?i.slice(P.length):null;};
g.prototype.isPrefixedId=function(i){return!!(i&&i.indexOf(this.getId()+"--")===0);};
g.prototype.getViewData=function(){return this.oViewData;};
function r(){this.oAsyncState=null;}
g.prototype.exit=function(){this.fireBeforeExit();if(this.oController&&this.bControllerIsViewManaged){this.oController.destroy();delete this.oController;}delete this.oPreprocessorInfo;if(this.oAsyncState){var D=r.bind(this);this.oAsyncState.promise.then(D,D);}};
g.prototype.onAfterRendering=function(){this.fireAfterRendering();};
g.prototype.onBeforeRendering=function(){this.fireBeforeRendering();};
g.prototype.clone=function(i,l){var S={},K,e;for(K in this.mProperties&&!(this.isBound&&this.isBound(K))){if(this.mProperties.hasOwnProperty(K)){S[K]=this.mProperties[K];}}e=C.prototype.clone.call(this,i,l,{cloneChildren:false,cloneBindings:true});var E,x,j;for(E in e.mEventRegistry){x=e.mEventRegistry[E];for(j=x.length-1;j>=0;j--){if(x[j].oListener===this.getController()){x[j]={oListener:e.getController(),fFunction:x[j].fFunction,oData:x[j].oData};}}}e.applySettings(S);return e;};
g.prototype.getPreprocessors=function(){return this.mPreprocessors;};
g.prototype.getPreprocessorInfo=function(S){if(!this.oPreprocessorInfo){this.oPreprocessorInfo={name:this.sViewName,componentId:this._sOwnerId,id:this.getId(),caller:this+" ("+this.sViewName+")",sync:!!S};}if(g._supportInfo){this.oPreprocessorInfo._supportInfo=g._supportInfo;}return this.oPreprocessorInfo;};
g.prototype.runPreprocessor=function(T,S,e){var j=this.getPreprocessorInfo(e),P=this.mPreprocessors&&this.mPreprocessors[T]||[],x,A,y;if(!e){A=function(j,z){return function(S){return z.preprocessor.then(function(B){return B.process(S,j,z._settings);});};};y=Promise.resolve(S);}for(var i=0,l=P.length;i<l;i++){if(e&&P[i]._syncSupport===true){x=P[i].preprocessor.process;S=x(S,j,P[i]._settings);}else if(!e){y=y.then(A(j,P[i]));}else{L.debug("Async \""+T+"\"-preprocessor was skipped in sync view execution for "+this.getMetadata().getClass()._sType+"View",this.getId());}}return e?S:y;};
function s(T,e){if(!g._mPreprocessors[e]){g._mPreprocessors[e]={};}if(!g._mPreprocessors[e][T]){g._mPreprocessors[e][T]=[];}}
function t(e,T){return g._mPreprocessors[e][T].some(function(P){return!!P._onDemand;});}
g.registerPreprocessor=function(T,P,e,S,O,i){if(typeof O!=="boolean"){i=O;O=false;}if(P){s(T,e);if(O&&t(e,T)){L.error("Registration for \""+T+"\" failed, only one on-demand-preprocessor allowed",this.getMetadata().getName());return;}g._mPreprocessors[e][T].push({preprocessor:P,_onDemand:O,_syncSupport:S,_settings:i});L.debug("Registered "+(O?"on-demand-":"")+"preprocessor for \""+T+"\""+(S?" with syncSupport":""),this.getMetadata().getName());}else{L.error("Registration for \""+T+"\" failed, no preprocessor specified",this.getMetadata().getName());}};
g.prototype.hasPreprocessor=function(T){return!!this.mPreprocessors[T].length;};
g.create=function(O){var P=m({},O);P.async=true;P.viewContent=P.definition;var e=sap.ui.require("sap/ui/core/Component");var i;if(e&&M._sOwnerId){i=e.get(M._sOwnerId);}function w(){return v(P.id,P,P.type).loaded();}return new Promise(function(j,l){var x=u(P);sap.ui.require([x],function(y){j(y);},l);}).then(function(j){if(j.getMetadata().isA("sap.ui.core.mvc.XMLView")){P.processingMode=X.Sequential;}if(i){return i.runAsOwner(w);}else{return w();}});};
g._create=v;
sap.ui.view=function(i,e,T){var j=typeof i==="string"?i:e;j=typeof j==="object"?j.viewName:j;L.warning("Do not use deprecated view factory functions (View: "+j+"). "+"Use the static create function on the view module instead: [XML|HTML|JSON]View.create().","sap.ui.view",null,function(){return{type:"sap.ui.view",name:j};});return v(i,e,T);};
function v(i,e,T){var j=null,l={};if(typeof i==="object"||typeof i==="string"&&e===undefined){e=i;i=undefined;}if(e){if(typeof e==="string"){l.viewName=e;}else{l=e;}}d(!l.async||typeof l.async==="boolean","sap.ui.view factory: Special setting async has to be of the type 'boolean'!");if(i){l.id=i;}if(T){l.type=T;}if(l.type===V.XML&&l.async){l.processingMode=l.processingMode||X.SequentialLegacy;}var x=sap.ui.require("sap/ui/core/Component");if(x&&M._sOwnerId){var y=x.getCustomizing(M._sOwnerId,{type:"sap.ui.viewReplacements",name:l.viewName});if(y){delete y.async;L.info("Customizing: View replacement for view '"+l.viewName+"' found and applied: "+y.viewName+" (type: "+y.type+")");f(l,y);}else{L.debug("Customizing: no View replacement found for view '"+l.viewName+"'.");}}var z=u(l);j=w(z,l);return j;}
function u(e){var i=g._getModuleName(e);if(i){if(e.type){L.error("When using the view factory, the 'type' setting must be omitted for typed views. When embedding typed views in XML, don't use the <JSView> tag, use the <View> tag instead.");}return i;}if(!e.type){throw new Error("No view type specified.");}else if(e.type===V.JS){i='sap/ui/core/mvc/JSView';}else if(e.type===V.JSON){i='sap/ui/core/mvc/JSONView';}else if(e.type===V.XML){i='sap/ui/core/mvc/XMLView';}else if(e.type===V.HTML){i='sap/ui/core/mvc/HTMLView';}else if(e.type===V.Template){i='sap/ui/core/mvc/TemplateView';}else{throw new Error("Unknown view type "+e.type+" specified.");}return i;}
function w(e,i){var j=sap.ui.require(e);if(!j){j=sap.ui.requireSync(e);if(i.async){L.warning("sap.ui.view was called without requiring the according view class.");}}return new j(i);}
g.prototype.loaded=function(){if(this.oAsyncState&&this.oAsyncState.promise){return this.oAsyncState.promise;}else{return Promise.resolve(this);}};
g._getModuleName=function(S){var e;if(S.viewName&&S.viewName.startsWith("module:")){e=S.viewName.slice("module:".length);}return e;};
g.prototype.getAutoPrefixId=function(){return false;};
g.prototype.onControllerConnected=function(e,S){if(!this.createContent&&typeof this.createContent!=='function'){return;}var P={id:this.getAutoPrefixId()?this.createId.bind(this):undefined,settings:this._fnSettingsPreprocessor};return M.runWithPreprocessors(function(){var i=this.createContent(e);if(S.async){i=Promise.resolve(i);return i.then(function(i){this.applySettings({content:i});}.bind(this));}else if(i instanceof Promise){throw new Error("An asynchronous view (createContent) cannot be instantiated synchronously. Affected view: '"+this.getMetadata().getName()+"'.");}else{this.applySettings({content:i});}}.bind(this),P);};
g.prototype.initViewSettings=function(S){if(!this.getMetadata()._oRenderer){this.getMetadata().getRenderer=function(){return g.getMetadata().getRenderer();};this.getMetadata().getRendererName=function(){return g.getMetadata().getRendererName();};}if(S.async){return Promise.resolve();}};
return g;});
sap.ui.predefine('sap/ui/core/mvc/ViewRenderer',function(){"use strict";var V={apiVersion:2};
V.render=function(r,c){r.openStart("div",c);r.class("sapUiView");V.addDisplayClass(r,c);r.style("width",c.getWidth());r.style("height",c.getHeight());r.openEnd();c.getContent().forEach(r.renderControl,r);r.close("div");};
V.addDisplayClass=function(r,c){if(c.getDisplayBlock()||(c.getWidth()==="100%"&&c.getHeight()==="100%")){r.class("sapUiViewDisplayBlock");}};
return V;},true);
sap.ui.predefine('sap/ui/core/mvc/XMLProcessingMode',[],function(){"use strict";var X={Sequential:"Sequential",SequentialLegacy:"SequentialLegacy"};return X;});
sap.ui.predefine('sap/ui/core/mvc/XMLView',["sap/ui/thirdparty/jquery","./View","./XMLViewRenderer","./ViewType","sap/base/util/merge","sap/ui/base/ManagedObject","sap/ui/core/XMLTemplateProcessor","sap/ui/core/Control","sap/ui/core/RenderManager","sap/ui/core/cache/CacheManager","sap/ui/model/resource/ResourceModel","sap/ui/util/XMLHelper","sap/base/strings/hash","sap/base/Log","sap/base/util/LoaderExtensions","sap/ui/performance/trace/Interaction","sap/ui/core/Core"],function(q,V,X,a,m,M,b,C,R,c,d,f,h,L,g,I){"use strict";var j=R.RenderPrefixes,x="XMLViewCacheError",n={};
var k=C.extend("sap.ui.core.mvc.XMLAfterRenderingNotifier",{
metadata:{library:"sap.ui.core"},
renderer:{apiVersion:2,render:function(o,e){o.text("");}}
});
var l=V.extend("sap.ui.core.mvc.XMLView",{
metadata:{library:"sap.ui.core",specialSettings:{containingView:{type:'sap.ui.core.mvc.XMLView',visibility:'hidden'},xmlNode:{type:'Element',visibility:'hidden'},cache:'Object',processingMode:{type:"sap.ui.core.mvc.XMLProcessingMode",visibility:"hidden"}},designtime:"sap/ui/core/designtime/mvc/XMLView.designtime"},
renderer:X
});
sap.ui.xmlview=function(i,e){return sap.ui.view(i,e,a.XML);};
l.create=function(o){var P=m({},o);P.viewContent=P.definition;P.async=true;P.type=a.XML;return V.create(P);};
l._sType=a.XML;l.asyncSupport=true;l._bUseCache=sap.ui.getCore().getConfiguration().getViewCache()&&c._isSupportedEnvironment();
function v(e){if(e.parseError.errorCode!==0){var P=e.parseError;throw new Error("The following problem occurred: XML parse Error for "+P.url+" code: "+P.errorCode+" reason: "+P.reason+" src: "+P.srcText+" line: "+P.line+" linepos: "+P.linepos+" filepos: "+P.filepos);}}
function p(o,S){if(!S){throw new Error("mSettings must be given");}else if(S.viewName&&S.viewContent){throw new Error("View name and view content are given. There is no point in doing this, so please decide.");}else if((S.viewName||S.viewContent)&&S.xmlNode){throw new Error("View name/content AND an XML node are given. There is no point in doing this, so please decide.");}else if(!(S.viewName||S.viewContent)&&!S.xmlNode){throw new Error("Neither view name/content nor an XML node is given. One of them is required.");}else if(S.cache&&!(S.cache.keys&&S.cache.keys.length)){throw new Error("No cache keys provided. At least one is required.");}}
function r(o,S){o.mProperties["viewContent"]=S.viewContent;var e=f.parse(S.viewContent);v(e);return e.documentElement;}
function s(o,S){if((o._resourceBundleName||o._resourceBundleUrl)&&(!S.models||!S.models[o._resourceBundleAlias])){var e=new d({bundleName:o._resourceBundleName,bundleUrl:o._resourceBundleUrl,bundleLocale:o._resourceBundleLocale,async:S.async});var i=e.getResourceBundle();if(i instanceof Promise){return i.then(function(){o.setModel(e,o._resourceBundleAlias);});}o.setModel(e,o._resourceBundleAlias);}}
function t(o){o.oAfterRenderingNotifier=new k();o.oAfterRenderingNotifier.addDelegate({onAfterRendering:function(){o.onAfterRenderingBeforeChildren();}});}
function u(S){var e=sap.ui.require("sap/ui/core/Component"),o;if(e){while(S){var i=e.getOwnerComponentFor(S);if(i){S=o=i;}else{if(S instanceof e){o=S;}S=S.getParent&&S.getParent();}}}return o;}
function w(o,e){var i=u(o),G=i?JSON.stringify(i.getManifest()):null,H=[];H=H.concat(A(o,i),D(),B(o),e.keys);return z(o,H).then(function(K){return{key:K+"("+h(G||"")+")",componentManifest:G,additionalData:e.additionalData};});}
function y(K){return K;}
function z(o,i){return Promise.all(i).then(function(K){K=K.filter(function(G){return G!==n;});if(K.every(y)){return K.join('_');}else{var e=new Error("Provided cache keys may not be empty or undefined.");e.name=x;return Promise.reject(e);}});}
function A(o,e){var i=e&&e.getMetadata().getName();return[i||window.location.host+window.location.pathname,o.getId(),sap.ui.getCore().getConfiguration().getLanguageTag()].concat(e&&e.getActiveTerminologies()||[]);}
function B(e){var P=e.getPreprocessors(),i=e.getPreprocessorInfo(false),G=[];function H(o){G.push(o.preprocessor.then(function(J){if(J.getCacheKey){return J.getCacheKey(i);}else{return n;}}));}for(var T in P){P[T].forEach(H);}return G;}
function D(){return sap.ui.getVersionInfo({async:true}).then(function(i){var T="";if(!i.libraries){T=sap.ui.buildinfo.buildtime;}else{i.libraries.forEach(function(o){T+=o.buildTimestamp;});}return T;}).catch(function(e){L.warning("sap.ui.getVersionInfo could not be retrieved","sap.ui.core.mvc.XMLView");L.debug(e);return"";});}
function E(e,i){var K=e.key;delete e.key;var o=e.additionalData;e.xml=f.serialize(i);if(o&&o.setAdditionalCacheData&&o.getAdditionalCacheData){e.additionalData=o.getAdditionalCacheData();}return c.set(K,e);}
function F(e){return c.get(e.key).then(function(i){if(i&&i.componentManifest==e.componentManifest){i.xml=f.parse(i.xml,"application/xml").documentElement;if(i.additionalData){var o=e.additionalData;if(o&&o.setAdditionalCacheData&&o.getAdditionalCacheData){o.setAdditionalCacheData(i.additionalData);}else{L.error("Deprecated: Don't use an object reference for caching additional Data! Use a CacheDataProvider instead!");m(e.additionalData,i.additionalData);}}return i;}});}
l.prototype.initViewSettings=function(S){var e=this,_;function i(O){e._xContent=O;if(V._supportInfo){V._supportInfo({context:e._xContent,env:{caller:"view",viewinfo:m({},e),settings:m({},S||{}),type:"xmlview"}});}if(!e.isSubView()){var P={};b.parseViewAttributes(O,e,P);if(!S.async){Object.assign(S,P);}else{e.applySettings(P);}}else{delete S.controller;}var Q=s(e,S);if(Q instanceof Promise){return Q.then(function(){t(e);});}t(e);}function o(O,P){if(e.hasPreprocessor("viewxml")){return b.enrichTemplateIdsPromise(O,e,P).then(function(){return e.runPreprocessor("viewxml",O,!P);});}return O;}function G(O){var P=I.notifyAsyncStep("VIEW PREPROCESSING");return e.runPreprocessor("xml",O).then(function(O){return o(O,true);}).finally(P);}function H(N){return g.loadResource(N,{async:true}).then(function(O){return O.documentElement;});}function J(N,O){return H(N).then(G).then(function(P){if(O){E(O,P);}return P;});}function K(N,O){return w(e,O).then(function(P){return F(P).then(function(Q){if(!Q){return J(N,P);}else{return Q.xml;}});}).catch(function(P){if(P.name===x){L.error(P.message,P.name,"sap.ui.core.mvc.XMLView");L.error("Processing the View without caching.","sap.ui.core.mvc.XMLView");return J(N);}else{return Promise.reject(P);}});}this._oContainingView=S.containingView||this;this._sProcessingMode=S.processingMode;if(this.oAsyncState){this.oAsyncState.suppressPreserve=true;}p(this,S);if(S.viewName){var N=S.viewName.replace(/\./g,"/")+".view.xml";if(S.async){if(S.cache&&l._bUseCache){return K(N,S.cache).then(i);}else{return H(N).then(G).then(i);}}else{_=g.loadResource(N).documentElement;}}else if(S.viewContent){if(S.viewContent.nodeType===window.Node.DOCUMENT_NODE){_=S.viewContent.documentElement;}else{_=r(this,S);}}else if(S.xmlNode){_=S.xmlNode;}if(S.async){return G(_).then(i);}else{_=this.runPreprocessor("xml",_,true);_=o(_,false);if(_&&typeof _.getResult==='function'){if(_.isRejected()){throw _.getResult();}_=_.getResult();}i(_);}};
l.prototype.onBeforeRendering=function(){var o=this.getDomRef();if(o&&!R.isPreservedContent(o)){R.preserveContent(o,true);}V.prototype.onBeforeRendering.apply(this,arguments);};
l.prototype.exit=function(){if(this.oAfterRenderingNotifier){this.oAfterRenderingNotifier.destroy();}V.prototype.exit.apply(this,arguments);};
l.prototype.onControllerConnected=function(o){var e=this;function i(H){return M.runWithPreprocessors(H,{settings:e._fnSettingsPreprocessor});}if(!this.oAsyncState){this._aParsedContent=i(b.parseTemplate.bind(null,this._xContent,this));}else{var G=I.notifyAsyncStep("VIEW PROCESSING");return b.parseTemplatePromise(this._xContent,this,true,{fnRunWithPreprocessor:i}).then(function(P){e._aParsedContent=P;delete e.oAsyncState.suppressPreserve;}).finally(G);}};
l.prototype.getControllerName=function(){return this._controllerName;};
l.prototype.isSubView=function(){return this._oContainingView!=this;};
l.prototype.onAfterRenderingBeforeChildren=function(){if(this._$oldContent.length!==0){var e=this.getAggregation("content");if(e){for(var i=0;i<e.length;i++){var N=document.getElementById(j.Temporary+e[i].getId())||e[i].getDomRef()||document.getElementById(j.Invisible+e[i].getId());if(N){q(document.getElementById(j.Dummy+e[i].getId())).replaceWith(N);}}}q(document.getElementById(j.Temporary+this.getId())).replaceWith(this._$oldContent);}this._$oldContent=undefined;};
l.prototype._onChildRerenderedEmpty=function(o,e){q(e).replaceWith('<div id="'+j.Dummy+o.getId()+'" class="sapUiHidden"></div>');return true;};
l.registerPreprocessor=function(T,P,e,S,o,i){var O=this.getMetadata().getClass()._sType;if(typeof e==="string"){if(e!==O){throw new TypeError("View types other than "+O+" are not supported by XMLView.registerPreprocessor,"+" check View.registerPreprocessor instead");}}else{i=o;o=S;S=e;}T=T.toUpperCase();if(l.PreprocessorType[T]){V.registerPreprocessor(l.PreprocessorType[T],P,O,S,o,i);}else{L.error("Preprocessor could not be registered due to unknown sType \""+T+"\"",this.getMetadata().getName());}};
l.PreprocessorType={XML:"xml",VIEWXML:"viewxml",CONTROLS:"controls"};l.registerPreprocessor("xml","sap.ui.core.util.XMLPreprocessor",true,true);return l;});
sap.ui.predefine('sap/ui/core/mvc/XMLViewRenderer',['./ViewRenderer','../RenderManager',"sap/ui/thirdparty/jquery"],function(V,R,q){"use strict";var P=R.RenderPrefixes.Dummy,a=R.RenderPrefixes.Invisible,b=R.RenderPrefixes.Temporary;var X={apiVersion:2};
X.render=function(r,c){var p=c._aParsedContent;var $=c._$oldContent=R.findPreservedContent(c.getId());if($.length===0){var s=c.isSubView();if(!s){r.openStart("div",c);r.class("sapUiView");r.class("sapUiXMLView");V.addDisplayClass(r,c);if(!c.oAsyncState||!c.oAsyncState.suppressPreserve){r.attr("data-sap-ui-preserve",c.getId());}r.style("width",c.getWidth());r.style("height",c.getHeight());r.openEnd();}if(p){for(var i=0;i<p.length;i++){var v=p[i];if(Array.isArray(v)){r[v[0]].apply(r,v[1]);}else{r.renderControl(v);if(!v.bOutput){r.openStart("div",P+v.getId());r.class("sapUiHidden");r.openEnd();r.close("div");}}}}if(!s){r.close("div");}}else{r.renderControl(c.oAfterRenderingNotifier);r.openStart("div",b+c.getId());r.class("sapUiHidden");r.openEnd();for(var i=0;i<p.length;i++){var f=p[i];if(!Array.isArray(f)){r.renderControl(f);var F=f.getId(),d=q(document.getElementById(F));if(d.length==0){d=q(document.getElementById(a+F));}if(!R.isPreservedContent(d[0])){d.replaceWith('<div id="'+P+F+'" class="sapUiHidden"></div>');}}}r.close("div");}};
return X;},true);
sap.ui.predefine('sap/ui/core/plugin/TemplatingSupport',["sap/base/Log",'sap/ui/core/tmpl/Template','sap/ui/core/Core'],function(L){"use strict";var T=function(){};
T.prototype.startPlugin=function(c,o){L.info("Starting TemplatingSupport plugin.");this.oCore=c;sap.ui.template();};
T.prototype.stopPlugin=function(){L.info("Stopping TemplatingSupport plugin.");this.oCore=null;};
sap.ui.getCore().registerPlugin(new T());return T;},true);
sap.ui.predefine('sap/ui/core/postmessage/Bus',["sap/ui/core/EventBus","sap/base/util/includes","sap/base/util/isPlainObject","sap/base/Log"],function(E,i,a,L){"use strict";var I;var s='______UI5______';
var P=E.extend("sap.ui.core.postmessage.Bus",{constructor:function(){if(I){return I;}I=this;E.apply(this,arguments);this._aAcceptedOrigins=[window.location.origin];this._aDeclinedOrigins=[];this._oPendingProcess=null;this._aEventQueue=[];this._receiver=this._receiver.bind(this);window.addEventListener('message',this._receiver);}});
P.event={CONNECT:'______CONNECT______',READY:'______READY______',ACCEPTED:'______ACCEPTED______',DECLINED:'______DECLINED______'};
P.prototype.destroy=function(){window.removeEventListener('message',this._receiver);this._aEventQueue=[];E.prototype.destroy.apply(this,arguments);I=undefined;this.bIsDestroyed=true;};
P.getInstance=function(){if(!I){I=new P();}return I;};
P.prototype.publish=function(p){var t=p.target;var o=p.origin;var c=p.channelId;var e=p.eventId;var d=p.data;if(e===P.event.READY){if(!t){if(window.opener&&window.opener!==window){t=window.opener;}else if(window.parent!==window){t=window.parent;}else{return;}}if(!o){o='*';}}if((typeof window==="undefined")||!(t!=null&&t===t.window)||t===window){throw TypeError("Target must be a window object and has to differ from current window");}if(typeof o!=="string"){throw TypeError("Origin must be a string");}if(typeof c!=="string"){throw TypeError("ChannelId must be a string");}if(typeof e!=="string"){throw TypeError("EventId must be a string");}if(!i([P.event.READY,P.event.ACCEPTED,P.event.DECLINED],e)&&o!=='*'&&!i(this._aAcceptedOrigins,o)){this._aAcceptedOrigins.push(o);}var m={origin:o,channelId:c,eventId:e,data:d};m[s]=true;t.postMessage(m,o);};
P.prototype._callListener=function(c,l,C,e,d){c.call(l,d);};
P.prototype._getText=function(k,p){return sap.ui.getCore().getLibraryResourceBundle(true).then(function(l){return l.getText(k,p);});};
P.prototype._receiver=function(e){var d=e.data;if(!a(d)||!d.hasOwnProperty(s)){return;}if(this._oPendingProcess){this._aEventQueue.push(e);}else{this._oPendingProcess=this._processEvent(e);}};
P.prototype._processEvent=function(e){return new Promise(function(r,R){var d=e.data;var o=e.origin;if(i(this._aDeclinedOrigins,o)){r();return;}switch(d.eventId){case P.event.CONNECT:{if(typeof d.data!=="string"){this.publish({target:e.source,origin:e.origin,channelId:d.channelId,eventId:P.event.DECLINED});r();}else if(i(this._aAcceptedOrigins,o)){this.publish({target:e.source,origin:e.origin,channelId:d.channelId,eventId:P.event.ACCEPTED});r();}else{sap.ui.require(["sap/ui/core/postmessage/confirmationDialog"],function(c){this._getText('PostMessage.Message',[d.data,o]).then(function(t){return c(t);}).then(function(){this.addAcceptedOrigin(o);this.publish({target:e.source,origin:e.origin,channelId:d.channelId,eventId:P.event.ACCEPTED});}.bind(this),function(){this.addDeclinedOrigin(o);this.publish({target:e.source,origin:e.origin,channelId:d.channelId,eventId:P.event.DECLINED});}.bind(this)).then(r);}.bind(this),R);}break;}case P.event.ACCEPTED:case P.event.DECLINED:case P.event.READY:{e.data.data=undefined;this._emitMessage(e);r();break;}default:{if(i(this._aAcceptedOrigins,o)){this._emitMessage(e);}r();}}}.bind(this)).catch(function(v){var m;var d;if(typeof v==='string'){m=v;}else if(v instanceof Error){m=v.message;d=v.stack;}else{m='Some unexpected error happened during post message processing';}L.error(m,d,'sap.ui.core.postmessage.Bus');}).then(function(){this._oPendingProcess=(this._aEventQueue.length>0?this._processEvent(this._aEventQueue.shift()):null);}.bind(this));};
P.prototype._emitMessage=function(e){var c=e.data.channelId;var b=e.data.eventId;E.prototype.publish.call(this,c,b,{originalEvent:e,channelId:c,eventId:b,source:e.source,origin:e.origin,data:e.data.data});};
P.prototype.getAcceptedOrigins=function(){return this._aAcceptedOrigins.slice();};
P.prototype.setAcceptedOrigins=function(o){if(!Array.isArray(o)){throw new TypeError('Expected an array, but got '+typeof o);}this._aAcceptedOrigins=o.slice();};
P.prototype.addAcceptedOrigin=function(o){if(typeof o!=='string'){throw new TypeError('Expected a string, but got '+typeof o);}if(!i(this._aAcceptedOrigins,o)){this._aAcceptedOrigins.push(o);}};
P.prototype.resetAcceptedOrigins=function(){this.setAcceptedOrigins([]);};
P.prototype.getDeclinedOrigins=function(){return this._aDeclinedOrigins.slice();};
P.prototype.setDeclinedOrigins=function(o){if(!Array.isArray(o)){throw new TypeError('Expected an array, but got '+typeof o);}this._aDeclinedOrigins=o.slice();};
P.prototype.addDeclinedOrigin=function(o){if(typeof o!=='string'){throw new TypeError('Expected a string, but got '+typeof o);}if(!i(this._aDeclinedOrigins,o)){this._aDeclinedOrigins.push(o);}};
P.prototype.resetDeclinedOrigins=function(){this.setDeclinedOrigins([]);};
return P;});
sap.ui.predefine('sap/ui/core/postmessage/confirmationDialog',function(){"use strict";return function(m){return new Promise(function(r,R){var M=sap.ui.getCore().getLoadedLibraries().hasOwnProperty('sap.m');if(M){sap.ui.require(['sap/m/MessageBox'],function(a){a.confirm(m,{actions:[a.Action.YES,a.Action.NO],onClose:function(A){if(A===a.Action.YES){r();}else{R();}}});},R);}else{var c=window.confirm(m);if(c){r();}else{R();}}});};});
sap.ui.predefine('sap/ui/core/routing/HashChanger',["./HashChangerBase","./RouterHashChanger",'sap/ui/thirdparty/hasher',"sap/base/Log","sap/base/util/ObjectPath","sap/ui/performance/trace/Interaction"],function(H,R,h,L,O,I){"use strict";
var a=H.extend("sap.ui.core.routing.HashChanger",{constructor:function(){H.apply(this);}});
a.prototype.init=function(){if(this._initialized){L.info("this HashChanger instance has already been initialized.");return false;}this._initialized=true;h.changed.add(this.fireHashChanged,this);if(!h.isActive()){h.initialized.addOnce(this.fireHashChanged,this);h.init();}else{this.fireHashChanged(h.getHash());}return this._initialized;};
a.prototype.fireHashChanged=function(n,o){this.fireEvent("hashChanged",{newHash:n,oldHash:o});};
a.prototype.createRouterHashChanger=function(){if(!this._oRouterHashChanger){var p=this._parseHash(this.getHash());this._oRouterHashChanger=new R({parent:this,hash:p.hash,subHashMap:p.subHashMap});this._registerListenerToRelevantEvents();this._oRouterHashChanger.attachEvent("hashSet",this._onHashModified,this);this._oRouterHashChanger.attachEvent("hashReplaced",this._onHashModified,this);}this._oRouterHashChanger.attachEvent("hashChanged",function(){I.notifyNavigation();});return this._oRouterHashChanger;};
a.prototype._registerListenerToRelevantEvents=function(){if(!this._mEventListeners){this._mEventListeners={};this.getRelevantEventsInfo().forEach(function(e){var E=e.name,l=this._onHashChangedForRouterHashChanger.bind(this,e);this._mEventListeners[E]=l;this.attachEvent(E,l,this);}.bind(this));}};
a.prototype._deregisterListenerFromRelevantEvents=function(){if(this._mEventListeners){var e=Object.keys(this._mEventListeners);e.forEach(function(E){this.detachEvent(E,this._mEventListeners[E],this);}.bind(this));delete this._mEventListeners;}};
a.prototype._onHashChangedForRouterHashChanger=function(e,E){if(this._oRouterHashChanger){var p=e.paramMapping||{},P=p["newHash"]||"newHash",n=E.getParameter(P)||"",o=this._parseHash(n);this._oRouterHashChanger.fireHashChanged(o.hash,o.subHashMap,!!e.updateHashOnly);}};
a.prototype._onHashModified=function(e){var E=e.getId(),b=[e.getParameter("hash")],k=[e.getParameter("key")],n=e.getParameter("nestedHashInfo"),d=e.getParameter("deletePrefix")||[];if(Array.isArray(n)){n.forEach(function(o){b.push(o.hash);k.push(o.key);if(Array.isArray(o.deletePrefix)){o.deletePrefix.forEach(function(D){if(d.indexOf(D)===-1){d.push(D);}});}});}if(E==="hashSet"){this._setSubHash(k,b,d);}else{this._replaceSubHash(k,b,d);}};
a.prototype._setSubHash=function(k,s,c){var b=this._reconstructHash(k,s,c);this.setHash(b);};
a.prototype._replaceSubHash=function(k,s,c){var b=this._reconstructHash(k,s,c);this.replaceHash(b);};
a.prototype._reconstructHash=function(k,v,d){var p=this.getHash().split("&/"),t=p.shift();k.forEach(function(K,b){if(d){d=d.filter(function(D){return D!==K;});}var V=v[b];if(K===undefined){t=V+"";}else{var f=p.some(function(P,i,p){if(P.startsWith(K)){if(V){p[i]=K+"/"+V;}else{d.push(K);}return true;}});if(!f){p.push(K+"/"+V);}}});if(d&&d.length>0){p=p.filter(function(P){return!d.some(function(s){return P.startsWith(s);});});}p.unshift(t);return p.join("&/");};
a.prototype._parseHash=function(s){var p=s.split("&/");return{hash:p.shift(),subHashMap:p.reduce(function(m,P){var S=P.indexOf("/");if(S===-1){m[P]="";}else{m[P.substring(0,S)]=P.substring(S+1);}return m;},{})};};
a.prototype.setHash=function(s){H.prototype.setHash.apply(this,arguments);h.setHash(s);};
a.prototype.replaceHash=function(s){H.prototype.replaceHash.apply(this,arguments);h.replaceHash(s);};
a.prototype.getHash=function(){return h.getHash();};
a.prototype.getRelevantEventsInfo=function(){return[{name:"hashChanged",paramMapping:{fullHash:"newHash"}}];};
a.prototype.destroy=function(){if(this._oRouterHashChanger){this._deregisterListenerFromRelevantEvents();this._oRouterHashChanger.destroy();this._oRouterHashChanger=undefined;}delete this._initialized;h.changed.remove(this.fireHashChanged,this);H.prototype.destroy.apply(this,arguments);};
a.prototype.deregisterRouterHashChanger=function(){this._deregisterListenerFromRelevantEvents();delete this._oRouterHashChanger;};
(function(){var _=null;
a.getInstance=function(){if(!_){_=new a();}return _;};
function e(o){var E,b,n;for(E in _.mEventRegistry){if(_.mEventRegistry.hasOwnProperty(E)){b=_.mEventRegistry[E];n=o.mEventRegistry[E];if(n){o.mEventRegistry[E]=b.concat(n);}else{o.mEventRegistry[E]=b;}}}}
a.replaceHashChanger=function(o){if(_&&o){var g=O.get("sap.ui.core.routing.History.getInstance"),b;if(g){b=g();b._setHashChanger(o);}if(_._oRouterHashChanger){_._oRouterHashChanger.detachEvent("hashSet",_._onHashModified,_);_._oRouterHashChanger.detachEvent("hashReplaced",_._onHashModified,_);_._deregisterListenerFromRelevantEvents();o._oRouterHashChanger=_._oRouterHashChanger;o._oRouterHashChanger.parent=o;delete _._oRouterHashChanger;o._oRouterHashChanger.attachEvent("hashSet",o._onHashModified,o);o._oRouterHashChanger.attachEvent("hashReplaced",o._onHashModified,o);o._registerListenerToRelevantEvents();}e(o);_.destroy();}_=o;};
}());return a;});
sap.ui.predefine('sap/ui/core/routing/HashChangerBase',['sap/ui/base/EventProvider'],function(E){"use strict";
var H=E.extend("sap.ui.core.routing.HashChangerBase",{
metadata:{"abstract":true,publicMethods:["getHash","setHash","replaceHash"]},
constructor:function(){E.apply(this);}
});
H.M_EVENTS={"HashChanged":"hashChanged","HashSet":"hashSet","HashReplaced":"hashReplaced"};
H.prototype.setHash=function(h){this.fireEvent("hashSet",{sHash:h,hash:h});};
H.prototype.replaceHash=function(h,d){this.fireEvent("hashReplaced",{sHash:h,hash:h,direction:d});};
return H;});
sap.ui.predefine('sap/ui/core/routing/History',['sap/ui/core/library','./HashChanger',"sap/base/Log","sap/base/util/ObjectPath"],function(l,H,L,O){"use strict";var a=l.routing.HistoryDirection;var D="Direction_Unchanged";var b=function(h){var t=this;this._iHistoryLength=window.history.length;this.aHistory=[];this._bIsInitial=true;function c(C){if(b._bUsePushState&&!b.getInstance()){var s=window.history.state===null?{}:window.history.state;if(typeof s==="object"){s.sap=s.sap?s.sap:{};if(s.sap.history&&Array.isArray(s.sap.history)&&s.sap.history[s.sap.history.length-1]===C){b._aStateHistory=s.sap.history;}else{b._aStateHistory.push(C);s.sap.history=b._aStateHistory;window.history.replaceState(s,window.document.title);}}else{L.debug("Unable to determine HistoryDirection as history.state is already set: "+window.history.state,"sap.ui.core.routing.History");}}t._reset();}if(!h){L.error("sap.ui.core.routing.History constructor was called and it did not get a hashChanger as parameter");}this._setHashChanger(h);if(h._initialized){c(h.getHash());}else{h.attachEventOnce("hashChanged",function(e){c(e.getParameter("newHash"));});}};b._aStateHistory=[];b._bUsePushState=window.self===window.top;
b.prototype.getHistoryStateOffset=function(){if(!b._bUsePushState){return undefined;}var s=O.get("history.state.sap.history");if(!Array.isArray(s)){return undefined;}return s.length-b._aStateHistory.length;};
b.prototype.destroy=function(){this._unRegisterHashChanger();};
b.prototype.getDirection=function(n){if(n!==undefined&&this._bIsInitial){return undefined;}if(n===undefined){return this._sCurrentDirection;}return this._getDirection(n);};
b.prototype.getPreviousHash=function(){return this.aHistory[this.iHistoryPosition-1];};
b.prototype._setHashChanger=function(h){if(this._oHashChanger){this._unRegisterHashChanger();}this._oHashChanger=h;this._mEventListeners={};h.getRelevantEventsInfo().forEach(function(e){var E=e.name,p=e.paramMapping||{},f=this._onHashChange.bind(this,p);this._mEventListeners[E]=f;this._oHashChanger.attachEvent(E,f,this);}.bind(this));this._oHashChanger.attachEvent("hashReplaced",this._hashReplaced,this);this._oHashChanger.attachEvent("hashSet",this._hashSet,this);};
b.prototype._unRegisterHashChanger=function(){if(this._mEventListeners){var e=Object.keys(this._mEventListeners);e.forEach(function(E){this._oHashChanger.detachEvent(E,this._mEventListeners[E],this);}.bind(this));delete this._mEventListeners;}this._oHashChanger.detachEvent("hashReplaced",this._hashReplaced,this);this._oHashChanger.detachEvent("hashSet",this._hashSet,this);this._oHashChanger=null;};
b.prototype._reset=function(){this.aHistory.length=0;this.iHistoryPosition=0;this._bUnknown=true;this.aHistory[0]=this._oHashChanger.getHash();};
b.prototype._getDirection=function(n,h,c){if(c&&this._oNextHash&&this._oNextHash.sHash===n){return a.NewEntry;}if(h){return a.NewEntry;}if(this._bUnknown){return a.Unknown;}if(this.aHistory[this.iHistoryPosition+1]===n&&this.aHistory[this.iHistoryPosition-1]===n){return a.Unknown;}if(this.aHistory[this.iHistoryPosition-1]===n){return a.Backwards;}if(this.aHistory[this.iHistoryPosition+1]===n){return a.Forwards;}return a.Unknown;};
b.prototype._getDirectionWithState=function(h){var s=window.history.state===null?{}:window.history.state,B,d;if(typeof s==="object"){if(s.sap===undefined){b._aStateHistory.push(h);s.sap={};s.sap.history=b._aStateHistory;window.history.replaceState(s,document.title);d=a.NewEntry;}else{B=s.sap.history.every(function(u,c){return u===b._aStateHistory[c];});if(B&&s.sap.history.length===b._aStateHistory.length){d=D;}else{d=B?a.Backwards:a.Forwards;b._aStateHistory=s.sap.history;}}}else{L.debug("Unable to determine HistoryDirection as history.state is already set: "+window.history.state,"sap.ui.core.routing.History");}return d;};
b.prototype._onHashChange=function(p,e){var n=p.newHash||"newHash",o=p.oldHash||"oldHash",f=p.fullHash||"fullHash";this._hashChange(e.getParameter(n),e.getParameter(o),e.getParameter(f));};
b.prototype._hashChange=function(n,o,f){var c=window.history.length,d;if(this._oNextHash&&this._oNextHash.bWasReplaced&&this._oNextHash.sHash===n){if(this._oNextHash.sDirection){d=this._oNextHash.sDirection;}else{this.aHistory[this.iHistoryPosition]=n;if(f!==undefined&&b._bUsePushState&&this===b.getInstance()){b._aStateHistory[b._aStateHistory.length-1]=f;window.history.replaceState({sap:{history:b._aStateHistory}},window.document.title);}this._oNextHash=null;if(!this._bIsInitial){this._sCurrentDirection=a.Unknown;}return;}}this._bIsInitial=false;if(d){this._adaptToDirection(d,{oldHash:o,newHash:n,fullHash:f});}else{if(!d&&f!==undefined&&b._bUsePushState&&this===b.getInstance()){d=this._getDirectionWithState(f);}if(d===D){return;}if(!d){d=this._getDirection(n,this._iHistoryLength<window.history.length,true);}this._bUnknown=false;switch(d){case a.Unknown:this._reset();break;case a.NewEntry:this.aHistory.splice(this.iHistoryPosition+1,this.aHistory.length-this.iHistoryPosition-1,n);this.iHistoryPosition++;break;case a.Forwards:this.iHistoryPosition++;break;case a.Backwards:this.iHistoryPosition--;break;default:break;}}this._sCurrentDirection=d;this._iHistoryLength=c;if(this._oNextHash){this._oNextHash=null;}};
b.prototype._adaptToDirection=function(d,h){var f=h.fullHash,n=h.newHash,I,s;if(b._bUsePushState&&this===b.getInstance()&&f!==undefined){switch(d){case a.NewEntry:case a.Forwards:b._aStateHistory.push(f);break;case a.Backwards:I=b._aStateHistory.lastIndexOf(f);if(I!==-1){b._aStateHistory.splice(I+1);}else{b._aStateHistory=[f];L.debug("Can't find "+f+" in "+JSON.stringify(b._aStateHistory));}break;case a.Unknown:b._aStateHistory[b._aStateHistory.length-1]=f;break;default:break;}s={};s.sap={};s.sap.history=b._aStateHistory;window.history.replaceState(s,document.title);}switch(d){case a.NewEntry:this.aHistory.splice(this.iHistoryPosition+1,this.aHistory.length-this.iHistoryPosition-1,n);this.iHistoryPosition+=1;break;case a.Forwards:I=this.aHistory.indexOf(n,this.iHistoryPosition+1);if(I!==-1){this.iHistoryPosition=I;}else{this.aHistory.splice(this.iHistoryPosition+1,this.aHistory.length-this.iHistoryPosition-1,n);this.iHistoryPosition++;}break;case a.Backwards:I=this.aHistory.lastIndexOf(n,this.iHistoryPosition-1);if(I!==-1){this.iHistoryPosition=I;}else{this.aHistory=[n];this.iHistoryPosition=0;}break;case a.Unknown:this.aHistory[this.iHistoryPosition]=n;break;default:break;}};
b.prototype._hashSet=function(e){var h=e.getParameter("hash");if(h===undefined){h=e.getParameter("sHash");}this._hashChangedByApp(h,false);};
b.prototype._hashReplaced=function(e){var h=e.getParameter("hash"),d=e.getParameter("direction");if(h===undefined){h=e.getParameter("sHash");}if(h===this._oHashChanger.getHash()&&d){this._sCurrentDirection=d;}this._hashChangedByApp(h,true,d);};
b.prototype._hashChangedByApp=function(n,w,d){this._oNextHash={sHash:n,bWasReplaced:w,sDirection:d};};
var i;
b.getInstance=function(){return i;};
i=new b(H.getInstance());return b;},true);
sap.ui.predefine('sap/ui/core/routing/Route',['sap/ui/base/EventProvider','sap/ui/core/routing/Target','sap/ui/core/routing/async/Route','sap/ui/core/routing/sync/Route','sap/ui/core/Component',"sap/base/Log","sap/base/assert","sap/base/util/deepExtend"],function(E,T,a,s,C,L,b,d){"use strict";
var R=E.extend("sap.ui.core.routing.Route",{
metadata:{publicMethods:["getURL","getPattern"]},
constructor:function(r,c,p){E.apply(this,arguments);this._validateConfig(c);this._aPattern=[];this._aRoutes=[];this._oParent=p;this._oConfig=c;this._oRouter=r;var t=this,v=c.pattern,S,e,o,f,g=r._isAsync();f=g?a:s;for(var h in f){this[h]=f[h];}if(!Array.isArray(v)){v=[v];}if(c.parent){var j=this._getParentRoute(c.parent);if(!j){L.error("No parent route with '"+c.parent+"' could be found",this);}else if(j._aPattern.length>1){L.error("Routes with multiple patterns cannot be used as parent for nested routes",this);return;}else{this._oNestingParent=j;v.forEach(function(l,i){var n=j._aPattern[0];n=n.charAt(n.length)==="/"?n:n+"/";v[i]=n+l;});}}if(Array.isArray(c.subroutes)){S=c.subroutes;c.subroutes={};S.forEach(function(i){c.subroutes[i.name]=i;});}if(!c.target){var k=this._convertToTargetOptions(c);k._async=g;this._oTarget=new T(k,r._oViews,p&&p._oTarget);this._oTarget._bUseRawViewId=true;}if(c.subroutes){for(e in c.subroutes){o=c.subroutes[e];if(o.name===undefined){o.name=e;}r.addRoute(o,t);}}if(c.pattern===undefined){return;}v.forEach(function(i,I){t._aPattern[I]=i;t._aRoutes[I]=r._oRouter.addRoute(i);t._checkRoute(t._aRoutes[I]);t._aRoutes[I].greedy=c.greedy;t._aRoutes[I].matched.add(function(){var A={};Array.from(arguments).forEach(function(l,m){A[t._aRoutes[I]._paramsIds[m]]=l;});t._routeMatched(A,true);});t._aRoutes[I].switched.add(function(){t._routeSwitched();});});},
_checkRoute:function(r){var p=r._paramsIds;if(Array.isArray(p)){var D=p.filter(function(P){return P.charAt(0)==="?";}).filter(function(P){return p.indexOf(P.substring(1))>-1;}).map(function(P){return P.substring(1);});if(D.length>0){throw Error("The config of route '"+this._oConfig.name+"' contains standard parameter and query parameter with the same name: '"+D+"'. The name of the routing parameters and query parameter have to differentiate.");}}},
_routeSwitched:function(){this._suspend();this.fireEvent("switched",{name:this._oConfig.name});},
_suspend:function(){if(this._oRouter._oTargets){this._oRouter._oTargets.suspend(this._oConfig.target);if(this._oConfig.dynamicTarget){this._oRouter._oTargets.suspend(this._oConfig.dynamicTarget);}}},
_resume:function(){if(this._oRouter._oTargets){this._oRouter._oTargets.resume(this._oConfig.target);if(this._oConfig.dynamicTarget){this._oRouter._oTargets.resume(this._oConfig.dynamicTarget);}}},
destroy:function(){E.prototype.destroy.apply(this);this._aPattern=null;this._aRoutes=null;this._oParent=null;this._oConfig=null;this.bIsDestroyed=true;return this;},
getURL:function(p){return this._aRoutes[0].interpolate(p||{});},
_alignTargetsConfig:function(t){if(!t){return[];}if(!Array.isArray(t)){return(typeof t==="string")?[{name:t}]:[t];}return t.map(function(v){if(typeof v==="string"){v={name:v};}return v;});},
_changeHashWithComponentTargets:function(c,p){var t=this._alignTargetsConfig(this._oConfig.target),o=this._oRouter._oTargets,e,l;if(t&&t.length>0&&o){e=o.getTarget(t);if(!Array.isArray(e)){e=[e];}}else{e=[];}var f=this;l=e.map(function(g,i){if(g._oOptions.type==="Component"){var h=g._load({prefix:t[i].prefix,propagateTitle:t[i].hasOwnProperty("propagateTitle")?t[i].propagateTitle:f._oRouter._oConfig.propagateTitle});return h.then(function(j){var r=j.getRouter(),H=r&&r.getHashChanger(),k=c&&c[t[i].name],m=k&&k.route,n=r&&r.getRoute(m),q;if(k){if(n){q=r._getLastMatchedRouteName()!==m;H.setHash(n.getURL(k.parameters),p||!q);return n._changeHashWithComponentTargets(k.componentTargetInfo,p||q);}else{L.error("Can not navigate to route with name '"+m+"' because the route does not exist in component with id '"+j.getId()+"'");}}});}});return Promise.all(l);},
getPattern:function(){return this._aPattern[0];},
match:function(h){return this._aRoutes.some(function(r){return r.match(h);});},
attachMatched:function(D,f,l){return this.attachEvent("matched",D,f,l);},
detachMatched:function(f,l){return this.detachEvent("matched",f,l);},
attachBeforeMatched:function(D,f,l){return this.attachEvent("beforeMatched",D,f,l);},
detachBeforeMatched:function(f,l){return this.detachEvent("beforeMatched",f,l);},
fireBeforeMatched:function(p){this.fireEvent("beforeMatched",p);return this;},
attachPatternMatched:function(D,f,l){return this.attachEvent("patternMatched",D,f,l);},
detachPatternMatched:function(f,l){return this.detachEvent("patternMatched",f,l);},
_validateConfig:function(c){if(!c.name){L.error("A name has to be specified for every route",this);}if(c.viewName){L.error("The 'viewName' option shouldn't be used in Route. please use 'view' instead",this);}},
_convertToTargetOptions:function(o){return d({},o,{rootView:o.targetParent,controlId:o.targetControl,controlAggregation:o.targetAggregation,clearControlAggregation:o.clearTarget,viewName:o.view,viewType:o.viewType,viewId:o.viewId});},
_getParentRoute:function(p){var P=p.split(":");if(P.length===1||(P.length===2&&!P[0])){return this._oRouter.getRoute(P[P.length-1]);}else{b(this._oRouter._oOwner,"No owner component for "+this._oRouter._oOwner.getId());var o=C.getOwnerComponentFor(this._oRouter._oOwner);while(o){if(o.getMetadata().getName()===P[0]){var r=o.getRouter();return r.getRoute(P[1]);}o=C.getOwnerComponentFor(o);}return null;}},
getPatternArguments:function(h){return this._aRoutes[0].extrapolate(h);}
});
R.M_EVENTS={BeforeMatched:"beforeMatched",Matched:"matched",PatternMatched:"patternMatched"};return R;});
sap.ui.predefine('sap/ui/core/routing/Router',['sap/ui/core/library','sap/ui/base/EventProvider','./HashChanger','./Route','./Views','./Targets','./History','sap/ui/thirdparty/crossroads',"sap/base/util/UriParameters","sap/base/util/deepEqual","sap/base/util/isEmptyObject","sap/base/Log","sap/ui/thirdparty/jquery","./RouterHashChanger","sap/ui/core/Component"],function(l,E,H,R,V,T,a,c,U,d,b,L,q,e,C){"use strict";var r={};
var f=E.extend("sap.ui.core.routing.Router",{
constructor:function(o,i,O,t,j){E.apply(this);this._oConfig=i||{};this._oRouter=c.create();this._oRouter.ignoreState=true;this._oRoutes={};this._oOwner=O;function k(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","Router");return true;}return false;}this._oConfig._async=this._oConfig.async;if(this._oConfig._async===undefined){this._oConfig._async=k();}this._oViews=new V({component:O,async:this._oConfig._async});if(t){this._oTargets=this._createTargets(this._oConfig,t);this._oTargets._setRouter(this);this._oTargets.attachDisplay(function(s){var I=s.getParameter("routeRelevant");if(this.isInitialized()&&!this._bMatchingProcessStarted){var u=this.getHashChanger();if(u instanceof e&&!I){u.resetHash(this);}}},this);}var m=this,n;if(!o){o={};}if(Array.isArray(o)){n=o;o={};n.forEach(function(s){o[s.name]=s;});}q.each(o,function(s,u){if(u.name===undefined){u.name=s;}m.addRoute(u);});this._oRouter.bypassed.add(q.proxy(this._onBypassed,this));if(!j){j=H.getInstance().createRouterHashChanger();}this.setHashChanger(j);var p=this._getParentRouter();if(p){this.attachTitleChanged(function(s){if(this._oOwner&&!this._oOwner._bRoutingPropagateTitle){return;}var P=s.getParameters(),N,F;if(p._fnTitleChangedFiredOnChild){p._fnTitleChangedFiredOnChild(P);}else{N=P.nestedHistory.slice();N.unshift({ownerComponentId:p._oOwner.getId(),history:p.getTitleHistory()});F={propagated:true,title:P.title,history:P.history,nestedHistory:N};p.fireTitleChanged(F);}});}},
addRoute:function(o,p){if(!o.name){L.error("A name has to be specified for every route",this);}if(this._oRoutes[o.name]){L.error("Route with name "+o.name+" already exists",this);}this._oRoutes[o.name]=this._createRoute(this,o,p);},
parse:function(n){if(this._oRouter){this._oRouter.parse(n);}else{L.warning("This router has been destroyed while the hash changed. No routing events where fired by the destroyed instance.",this);}},
initialize:function(i){var t=this,s;if(this._bIsInitialized){L.warning("Router is already initialized.",this);return this;}this._bIsInitialized=true;this._bLastHashReplaced=false;this._bHashChangedAfterTitleChange=false;this.fnHashChanged=function(k){t.parse(k.getParameter("newHash"));t._bHashChangedAfterTitleChange=true;};if(!this.oHashChanger){L.error("navTo of the router is called before the router is initialized. If you want to replace the current hash before you initialize the router you may use getUrl and use replaceHash of the Hashchanger.",this);return this;}if(this._oTargets){var o=this._oRoutes[this._oConfig.homeRoute];this._oTargets.attachTitleChanged(this._forwardTitleChanged,this);this._aHistory=[];var j=o&&h(this._oOwner,o);if(j){this._aHistory.push(j);}}if(this.oHashChanger instanceof e){this.oHashChanger._setActiveRouter(this);}this.oHashChanger.init();s=this.oHashChanger.getHash();this.oHashChanger.attachEvent("hashChanged",this.fnHashChanged);if(i){if(this._oMatchedRoute){this._oMatchedRoute._resume();}}else if(s!==e.InvalidHash){this.parse(s);}return this;},
_forwardTitleChanged:function(o){var p=o.getParameters();var i={title:p.title};var j=this._oRoutes[this._oConfig.homeRoute];if(j&&g(p.name,j._oConfig.name)){i.isHome=true;}this.fireTitleChanged(i);},
stop:function(){if(!this._bIsInitialized){L.warning("Router is not initialized. But it got stopped",this);}if(this.fnHashChanged){this.oHashChanger.detachEvent("hashChanged",this.fnHashChanged);}if(this.fnHashReplaced){this.oHashChanger.detachEvent("hashReplaced",this.fnHashReplaced);}if(this._oTargets){this._oTargets.detachTitleChanged(this._forwardTitleChanged,this);this._oTargets._oLastTitleTarget={};}if(this._oMatchedRoute){this._oMatchedRoute._routeSwitched();}this._bIsInitialized=false;delete this._oPreviousTitleChangedRoute;return this;},
isStopped:function(){return this._bIsInitialized===false;},
isInitialized:function(){return this._bIsInitialized===true;},
getHashChanger:function(){return this.oHashChanger;},
setHashChanger:function(o){if(this.oHashChanger){L.warning("The Router already has a HashChanger set and this call is ignored");}else{this.oHashChanger=o;}return this;},
destroy:function(){if(this.bIsDestroyed){return this;}E.prototype.destroy.apply(this);if(this._oViews){this._oViews.destroy();this._oViews=null;}if(!this._bIsInitialized){L.info("Router is not initialized, but got destroyed.",this);}if(this.fnHashChanged){this.oHashChanger.detachEvent("hashChanged",this.fnHashChanged);}if(this.fnHashReplaced){this.oHashChanger.detachEvent("hashReplaced",this.fnHashReplaced);}this._oRouter.removeAllRoutes();this._oRouter=null;q.each(this._oRoutes,function(i,o){o.destroy();});this._oRoutes=null;this._oConfig=null;if(this._oTargets){this._oTargets.destroy();this._oTargets=null;}delete this._bIsInitialized;this.bIsDestroyed=true;return this;},
getURL:function(n,p){var o=this.getRoute(n);if(o){return o.getURL(p);}else{L.warning("Route with name "+n+" does not exist",this);}},
match:function(s){return Object.keys(this._oRoutes).some(function(i){return this._oRoutes[i].match(s);}.bind(this));},
getRouteByHash:function(s){for(var i in this._oRoutes){if(this._oRoutes.hasOwnProperty(i)){var o=this.getRoute(i);if(o.match(s)){return o;}}}},
getRouteInfoByHash:function(s){var o=this.getRouteByHash(s);if(!o){return undefined;}return{name:o._oConfig.name,arguments:o.getPatternArguments(s)};},
getRoute:function(n){return this._oRoutes[n];},
getViews:function(){return this._oViews;},
_createTargets:function(o,t){return new T({views:this._oViews,config:o,targets:t});},
_createRoute:function(o,i,p){return new R(o,i,p);},
getView:function(v,s,i){L.warning("Deprecated API Router#getView called - use Router#getViews instead.",this);var o=this._oViews._getViewWithGlobalId({viewName:v,type:s,id:i},true);this.fireViewCreated({view:o,viewName:v,type:s});return o;},
setView:function(v,o){this._oViews.setView(v,o);return this;},
_getParentRouter:function(){var p=this._oOwner&&C.getOwnerComponentFor(this._oOwner);return p&&p.getRouter();},
navTo:function(n,p,o,i){var t=this,j=this._getLastMatchedRouteName()!==n,k=this.getRoute(n),m,s;if(this.isStopped()){L.info("The router instance "+this._sId+" is stopped. No navigation can be performed.");return this;}if(!k){L.warning("Route with name "+n+" does not exist",this);return this;}if(typeof o==="boolean"){i=o;}if(p===undefined){p={};}if(o&&!b(o)){if(!this._oConfig._async){L.error("navTo with component target info is only supported with async router",this);return this;}m=k._changeHashWithComponentTargets(o,j);}s=k.getURL(p);if(i){t._bLastHashReplaced=true;t.oHashChanger.replaceHash(s,m,!j);}else{t.oHashChanger.setHash(s,m,!j);}return this;},
_getLastMatchedRouteName:function(){return this._oMatchedRoute&&this._oMatchedRoute._oConfig.name;},
getTargets:function(){return this._oTargets;},
getTarget:function(n){return this._oTargets.getTarget(n);},
attachRouteMatched:function(D,F,o){this.attachEvent("routeMatched",D,F,o);return this;},
detachRouteMatched:function(F,o){this.detachEvent("routeMatched",F,o);return this;},
fireRouteMatched:function(p){this.fireEvent("routeMatched",p);if(f._interceptRouteMatched){f._interceptRouteMatched(this._oConfig.controlId,this);}return this;},
attachBeforeRouteMatched:function(D,F,o){this.attachEvent("beforeRouteMatched",D,F,o);return this;},
detachBeforeRouteMatched:function(F,o){this.detachEvent("beforeRouteMatched",F,o);return this;},
fireBeforeRouteMatched:function(p){this.fireEvent("beforeRouteMatched",p);return this;},
attachViewCreated:function(D,F,o){this.attachEvent("viewCreated",D,F,o);return this;},
detachViewCreated:function(F,o){this.detachEvent("viewCreated",F,o);return this;},
fireViewCreated:function(p){this.fireEvent("viewCreated",p);return this;},
attachRoutePatternMatched:function(D,F,o){this.attachEvent("routePatternMatched",D,F,o);return this;},
detachRoutePatternMatched:function(F,o){this.detachEvent("routePatternMatched",F,o);return this;},
fireRoutePatternMatched:function(p){this.fireEvent("routePatternMatched",p);return this;},
attachBypassed:function(D,F,o){return this.attachEvent(f.M_EVENTS.BYPASSED,D,F,o);},
detachBypassed:function(F,o){return this.detachEvent(f.M_EVENTS.BYPASSED,F,o);},
fireBypassed:function(p){return this.fireEvent(f.M_EVENTS.BYPASSED,p);},
attachTitleChanged:function(D,F,o){this.attachEvent(f.M_EVENTS.TITLE_CHANGED,D,F,o);return this;},
detachTitleChanged:function(F,o){return this.detachEvent(f.M_EVENTS.TITLE_CHANGED,F,o);},
fireTitleChanged:function(p){if(this.isStopped()){return this;}var I=!this._pWaitForTitleChangedOnChild;if(!p.propagated){p.propagated=false;var D=a.getInstance().getDirection(),s=this.getHashChanger().getHash(),j=l.routing.HistoryDirection,o=this._aHistory[this._aHistory.length-1],n;if(D===j.Backwards&&o&&!o.isHome){if(o&&o.title!==p.title){this._aHistory.pop();}}else if(o&&o.hash==s){o.title=p.title;this._aHistory.some(function(k,i,m){if(i<m.length-1&&d(k,o)){return m.splice(i,1);}});}else{if(this._bLastHashReplaced){this._aHistory.pop();}n={hash:s,title:p.title};this._aHistory.some(function(k,i,m){if(d(k,n)){return m.splice(i,1);}});this._aHistory.push(n);}p.history=this._aHistory.slice(0,-1);p.nestedHistory=[{history:this.getTitleHistory(),ownerComponentId:this._oOwner&&this._oOwner.getId()}];this._bLastHashReplaced=false;this._oPreviousTitleChangedRoute=this._oMatchedRoute;this._bFireTitleChanged=false;if(this._pWaitForTitleChangedOnChild){this._pWaitForTitleChangedOnChild.then(function(i){p.title=i.title;p.propagated=true;Array.prototype.push.apply(p.nestedHistory,i.nestedHistory);this._stopWaitingTitleChangedFromChild();this.fireEvent(f.M_EVENTS.TITLE_CHANGED,p);}.bind(this));}}if(I){if(this._bMatchingProcessStarted&&this._isAsync()){this.attachEventOnce("routeMatched",function(){this.fireEvent(f.M_EVENTS.TITLE_CHANGED,p);},this);}else{this.fireEvent(f.M_EVENTS.TITLE_CHANGED,p);}}return this;},
getTitleHistory:function(){return this._aHistory||[];},
_waitForTitleChangedOn:function(n){if(this._bFireTitleChanged){this._pWaitForTitleChangedOnChild=new Promise(function(i){this._fnTitleChangedFiredOnChild=i;}.bind(this));}},
_stopWaitingTitleChangedFromChild:function(){delete this._pWaitForTitleChangedOnChild;delete this._fnTitleChangedFiredOnChild;},
register:function(n){r[n]=this;return this;},
_onBypassed:function(s){var F=function(){this.fireBypassed({hash:s});}.bind(this);if(this._oConfig.bypassed){var o=this._oTargets.display(this._oConfig.bypassed.target,{hash:s});if(o instanceof Promise){o.then(F);return;}}F();},
_isAsync:function(){return this._oConfig._async;},
metadata:{publicMethods:["initialize","getURL","register","getRoute"]}
});
function g(s,i){return i&&i.indexOf(s)>-1;}
function h(o,i){var s=i.getPattern(),A=o&&o.getManifestEntry("sap.app/title");if(s===""||(s!==undefined&&!/({.*})+/.test(s))){return{hash:s,isHome:true,title:A};}else{L.error("Routes with dynamic parts cannot be resolved as home route.");}}
f.M_EVENTS={BEFORE_ROUTE_MATCHED:"beforeRouteMatched",ROUTE_MATCHED:"routeMatched",ROUTE_PATTERN_MATCHED:"routePatternMatched",VIEW_CREATED:"viewCreated",BYPASSED:"bypassed",TITLE_CHANGED:"titleChanged"};f._interceptRouteMatched=undefined;
f.getRouter=function(n){return r[n];};
return f;});
sap.ui.predefine('sap/ui/core/routing/RouterHashChanger',['./HashChangerBase'],function(H){"use strict";
var R=H.extend("sap.ui.core.routing.RouterHashChanger",{constructor:function(s){if(!s||!s.parent){throw new Error("sap.ui.core.routing.RouterHashChanger can't be instantiated without a parent");}this.parent=s.parent;this.hash=s.hash||"";this.subHashMap=s.subHashMap;this.key=s.key||"";H.apply(this);}});
R.InvalidHash=Object.create(null);
R.prototype.init=function(){this.parent.init();};
R.prototype._generatePrefixedKey=function(k){return this.key?(this.key+"-"+k):k;};
R.prototype.createSubHashChanger=function(k){this.children=this.children||{};var p=this._generatePrefixedKey(k);if(this.children[p]){return this.children[p];}var c=new R({key:p,parent:this,subHashMap:this.subHashMap,hash:(this.subHashMap&&this.subHashMap[p])||""});c.attachEvent("hashSet",this._onChildHashChanged.bind(this,p));c.attachEvent("hashReplaced",this._onChildHashChanged.bind(this,p));this.children[p]=c;return c;};
R.prototype.fireHashChanged=function(h,s,u){var k,o=this.hash;this.hash=h;this.subHashMap=s;if(!u&&h!==o){this.fireEvent("hashChanged",{newHash:h,oldHash:o});}if(this.children){k=Object.keys(this.children);k.forEach(function(c){var C=(s[c]===undefined?"":s[c]);this.children[c].fireHashChanged(C,s,u);}.bind(this));}};
R.prototype._onChildHashChanged=function(k,e){var c=e.getParameter("key")||k,h=e.getParameter("hash"),n=e.getParameter("nestedHashInfo"),d=e.getParameter("deletePrefix");if(this._bCollectMode){this._collectHash(c,h,d);}else{this.fireEvent(e.getId(),{hash:h,key:c,nestedHashInfo:n,deletePrefix:d});}};
R.prototype._collectHash=function(k,h,d){this._aCollectedHashInfo=this._aCollectedHashInfo||[];this._aCollectedHashInfo.push({key:k,hash:h,deletePrefix:d});};
R.prototype._hasRouterAttached=function(){return this.hasListeners("hashChanged");};
R.prototype._collectActiveDescendantPrefix=function(){if(this.children){var k=Object.keys(this.children);return k.reduce(function(p,K){var c=this.children[K];if(c._hasRouterAttached()){p.push(K);Array.prototype.push.apply(p,c._collectActiveDescendantPrefix());}return p;}.bind(this),[]);}else{return[];}};
R.prototype.getHash=function(){if(this._isUnderCollectMode()){return R.InvalidHash;}else{return this.hash;}};
R.prototype._setActiveRouter=function(r){if(r.getHashChanger()===this){this._oActiveRouter=r;}return this;};
R.prototype.resetHash=function(r){if(r&&this._oActiveRouter===r){this.hash=undefined;}return this;};
R.prototype.setHash=function(h,p,s){if(!(p instanceof Promise)){s=p;p=null;}return this._modifyHash(h,p,s);};
R.prototype.replaceHash=function(h,d,p,s){if(typeof d!=="string"){s=p;p=d;d=undefined;}if(!(p instanceof Promise)){s=p;p=null;}return this._modifyHash(h,p,s,true,d);};
R.prototype._modifyHash=function(h,p,s,r,d){var e=r?"hashReplaced":"hashSet",t=this,P={hash:h};if(r&&d){P.direction=d;}if(!s){P.deletePrefix=this._collectActiveDescendantPrefix();}if(p){this._bCollectMode=true;return p.then(function(){P.nestedHashInfo=t._aCollectedHashInfo;t.fireEvent(e,P);t._aCollectedHashInfo=null;t._bCollectMode=false;});}else{this.fireEvent(e,P);}};
R.prototype._isUnderCollectMode=function(){return this.parent instanceof R&&this.parent._isInCollectMode();};
R.prototype._isInCollectMode=function(){return this._bCollectMode||(this.parent instanceof R&&this.parent._isInCollectMode());};
R.prototype.destroy=function(){this.parent.deregisterRouterHashChanger(this);if(this.children){Object.keys(this.children).forEach(function(k){var c=this.children[k];c.destroy();}.bind(this));delete this.children;}delete this.hash;delete this.subHashMap;delete this.parent;delete this.key;H.prototype.destroy.apply(this,arguments);};
R.prototype.deregisterRouterHashChanger=function(r){if(this.children){Object.keys(this.children).some(function(k){var c=this.children[k];if(c===r){delete this.children[k];return true;}}.bind(this));}};
return R;});
sap.ui.predefine('sap/ui/core/routing/Target',['sap/ui/core/Control','sap/ui/base/EventProvider','sap/ui/core/mvc/View','sap/ui/core/routing/async/Target','sap/ui/core/routing/sync/Target',"sap/base/util/UriParameters","sap/base/Log"],function(C,E,V,a,s,U,L){"use strict";
var T=C.extend("sap.ui.core.routing.Target.TitleProvider",{
metadata:{library:"sap.ui.core",properties:{title:{type:"string",group:"Data",defaultValue:null}}},
constructor:function(S){this._oTarget=S.target;delete S.target;C.prototype.constructor.call(this,S);},
setTitle:function(t){this.setProperty("title",t,true);if(this._oTarget._bIsDisplayed&&t){this._oTarget.fireTitleChanged({name:this._oTarget._oOptions._name,title:t});}}
});
var b=E.extend("sap.ui.core.routing.Target",{
constructor:function(o,c){var e;function d(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","Target");return true;}return false;}if(o._async===undefined){o._async=d();}if(o.type==="Component"&&!o._async){e="sap.ui.core.routing.Target doesn't support loading component in synchronous mode, please switch routing to async";L.error(e);throw new Error(e);}this._updateOptions(o);this._oCache=c;E.apply(this,arguments);if(this._oOptions.title){this._oTitleProvider=new T({target:this});}var f=this._oOptions._async?a:s;for(var g in f){this[g]=f[g];}this._bIsDisplayed=false;this._bIsLoaded=false;},
destroy:function(){this._oParent=null;this._oOptions=null;this._oCache=null;if(this._oTitleProvider){this._oTitleProvider.destroy();}this._oTitleProvider=null;E.prototype.destroy.apply(this,arguments);this.bIsDestroyed=true;return this;},
attachDisplay:function(d,f,l){return this.attachEvent(this.M_EVENTS.DISPLAY,d,f,l);},
detachDisplay:function(f,l){return this.detachEvent(this.M_EVENTS.DISPLAY,f,l);},
fireDisplay:function(p){var t=this._oTitleProvider&&this._oTitleProvider.getTitle();if(t){this.fireTitleChanged({name:this._oOptions._name,title:t});}this._bIsDisplayed=true;return this.fireEvent(this.M_EVENTS.DISPLAY,p);},
attachTitleChanged:function(d,f,l){var h=this.hasListeners("titleChanged"),t=this._oTitleProvider&&this._oTitleProvider.getTitle();this.attachEvent(this.M_EVENTS.TITLE_CHANGED,d,f,l);if(!h&&t&&this._bIsDisplayed){this.fireTitleChanged({name:this._oOptions._name,title:t});}return this;},
detachTitleChanged:function(f,l){return this.detachEvent(this.M_EVENTS.TITLE_CHANGED,f,l);},
fireTitleChanged:function(p){return this.fireEvent(this.M_EVENTS.TITLE_CHANGED,p);},
_getEffectiveObjectName:function(n){var p=this._oOptions.path;if(p){n=p+"."+n;}return n;},
_updateOptions:function(o){if(o.viewName){if(o.name){o._name=o.name;}o.type="View";o.name=o.viewName;if(o.viewPath){o.path=o.viewPath;}if(o.viewId){o.id=o.viewId;}}this._oOptions=o;},
_bindTitleInTitleProvider:function(v){if(this._oTitleProvider&&v instanceof V){this._oTitleProvider.applySettings({title:this._oOptions.title},v.getController());}},
_addTitleProviderAsDependent:function(v){if(!this._oTitleProvider){return;}var o=this._oTitleProvider.getParent();if(o){o.removeDependent(this._oTitleProvider);}if(v instanceof V){v.addDependent(this._oTitleProvider);}},
_beforePlacingViewIntoContainer:function(A){},
M_EVENTS:{DISPLAY:"display",TITLE_CHANGED:"titleChanged"}
});
return b;});
sap.ui.predefine('sap/ui/core/routing/TargetCache',['sap/ui/base/EventProvider','sap/ui/core/routing/async/TargetCache','sap/ui/core/routing/sync/TargetCache',"sap/base/assert","sap/base/Log"],function(E,a,s,b,L){"use strict";
var T=E.extend("sap.ui.core.routing.TargetCache",{
constructor:function(o){if(!o){o={};}this._oCache={view:{},component:{}};this._oComponent=o.component;if(this._oComponent){b(this._oComponent.isA("sap.ui.core.UIComponent"),this+' - the component passed to the constructor needs to be an instance of UIComponent');}E.apply(this,arguments);this.async=o.async;if(this.async===undefined){this.async=true;}var C=this.async?a:s;for(var f in C){this[f]=C[f];}},
metadata:{publicMethods:["get","set"]},
get:function(o,t){var O;try{if(t==="Component"&&!this.async){L.error("sap.ui.core.routing.Target doesn't support loading component in synchronous mode, please switch routing to async");throw new Error("sap.ui.core.routing.Target doesn't support loading component in synchronous mode, please switch routing to async");}if(!o){L.error("the oOptions parameter of getObject is mandatory",this);throw new Error("the oOptions parameter of getObject is mandatory");}O=this._get(o,t);}catch(e){return Promise.reject(e);}if(O instanceof Promise){return O;}else if(O.isA("sap.ui.core.mvc.View")){return O.loaded();}else{return Promise.resolve(O);}},
fetch:function(o,t){return this._get(o,t,undefined,undefined,true);},
set:function(n,t,o){var i;this._checkName(n,t);b(t==="View"||t==="Component","sType must be either 'View' or 'Component'");i=this._oCache[t.toLowerCase()][n];if(!i){i=this._oCache[t.toLowerCase()][n]={};}i[undefined]=o;return this;},
destroy:function(){E.prototype.destroy.apply(this);if(this.bIsDestroyed){return this;}function d(o){if(o&&o.destroy&&!o._bIsBeingDestroyed){o.destroy();}}Object.keys(this._oCache).forEach(function(t){var o=this._oCache[t];Object.keys(o).forEach(function(k){var i=o[k];Object.keys(i).forEach(function(I){var O=i[I];if(O instanceof Promise){O.then(d);}else{d(O);}});});}.bind(this));this._oCache=undefined;this.bIsDestroyed=true;return this;},
attachCreated:function(d,f,l){return this.attachEvent("created",d,f,l);},
detachCreated:function(f,l){return this.detachEvent("created",f,l);},
fireCreated:function(p){return this.fireEvent("created",p);},
_get:function(o,t,g,i,n){var O;switch(t){case"View":O=this._getView(o,g,n);break;case"Component":O=this._getComponent(o,g,i,n);break;default:throw Error("The given sType: "+t+" isn't supported by TargetCache.getObject");}return O;},
_getView:function(o,g,n){if(!g){o=this._createId(o);}return this._getViewWithGlobalId(o,false,n);},
_getComponent:function(o,g,i,n){if(!g){o=this._createId(o);}return this._getComponentWithGlobalId(o,i,n);},
_createId:function(o){if(this._oComponent&&o.id){o=Object.assign({},o,{id:this._oComponent.createId(o.id)});}return o;},
_checkName:function(n,t){if(!n){var m="A name for the "+t.toLowerCase()+" has to be defined";L.error(m,this);throw Error(m);}}
});
return T;});
sap.ui.predefine('sap/ui/core/routing/Targets',['sap/ui/base/EventProvider','./Target','./async/Targets','./sync/Targets',"sap/base/util/UriParameters","sap/base/Log","sap/base/util/deepExtend"],function(E,T,a,s,U,L,d){"use strict";
var b=E.extend("sap.ui.core.routing.Targets",{
constructor:function(o){var t,c;E.apply(this);this._mTargets={};this._oLastTitleTarget={};this._oConfig=o.config;this._oCache=o.cache||o.views;if(!this._oConfig){this._oConfig={_async:false};}function e(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","Targets");return true;}return false;}if(this._oConfig._async===undefined){this._oConfig._async=(this._oConfig.async===undefined)?e():this._oConfig.async;}var f=this._oConfig._async?a:s;for(var g in f){this[g]=f[g];}for(t in o.targets){if(o.targets.hasOwnProperty(t)){this._createTarget(t,o.targets[t]);}}for(c in this._mTargets){if(this._mTargets.hasOwnProperty(c)){this._addParentTo(this._mTargets[c]);}}},
_setRouter:function(r){if(!this._oRouter){this._oRouter=r;}else{L.warning("The Targets is already connected with a router and this call of _setRouter is ignored");}return this;},
destroy:function(){var t;E.prototype.destroy.apply(this);for(t in this._mTargets){if(this._mTargets.hasOwnProperty(t)){this._mTargets[t].destroy();}}this._mTargets=null;this._oCache=null;this._oConfig=null;this.bIsDestroyed=true;return this;},
getViews:function(){return this._oCache;},
getCache:function(){return this._oCache;},
getTarget:function(n,S){var t=this,c=this._alignTargetsInfo(n),e;e=c.reduce(function(A,C){var o=t._mTargets[C.name];if(o){A.push(o);}else if(!S){L.error("The target you tried to get \""+C.name+"\" does not exist!",t);}return A;},[]);return e.length<=1?e[0]:e;},
addTarget:function(n,t){var o=this.getTarget(n,true),c;if(o){L.error("Target with name "+n+" already exists",this);}else{c=this._createTarget(n,t);this._addParentTo(c);}return this;},
suspend:function(t){var c=this._alignTargetsInfo(t);c.forEach(function(o){var e=o.name;var f=this.getTarget(e);if(f){f.suspend();}}.bind(this));return this;},
resume:function(t){var c=this._alignTargetsInfo(t);c.forEach(function(o){var e=o.name;var f=this.getTarget(e);if(f){f.resume();}}.bind(this));return this;},
attachDisplay:function(D,f,l){return this.attachEvent(this.M_EVENTS.DISPLAY,D,f,l);},
detachDisplay:function(f,l){return this.detachEvent(this.M_EVENTS.DISPLAY,f,l);},
fireDisplay:function(p){return this.fireEvent(this.M_EVENTS.DISPLAY,p);},
attachTitleChanged:function(D,f,l){this.attachEvent(this.M_EVENTS.TITLE_CHANGED,D,f,l);return this;},
detachTitleChanged:function(f,l){return this.detachEvent(this.M_EVENTS.TITLE_CHANGED,f,l);},
fireTitleChanged:function(p){if(this._oLastTitleTarget.name!==p.name||this._oLastTitleTarget.title!==p.title){this._oLastTitleTarget.name=p.name;this._oLastTitleTarget.title=p.title;this.fireEvent(this.M_EVENTS.TITLE_CHANGED,p);}return this;},
M_EVENTS:{DISPLAY:"display",TITLE_CHANGED:"titleChanged"},
_alignTargetsInfo:function(t){if(t===undefined){return[];}if(!Array.isArray(t)){return(typeof t==="object")?[t]:[{name:t}];}return t.map(function(v){if(typeof v!=="object"){v={name:v};}return v;});},
_createTarget:function(n,t){var o,O,D={_name:n};if(this._vRootViewId){D.rootView=this._vRootViewId;}O=d(D,this._oConfig,t);o=this._constructTarget(O);o.attachDisplay(function(e){var p=e.getParameters();this.fireDisplay({name:n,view:p.view,object:p.object,control:p.control,config:p.config,data:p.data,routeRelevant:p.routeRelevant});},this);this._mTargets[n]=o;return o;},
_addParentTo:function(t){var p,P=t._oOptions.parent;if(!P){return;}p=this._mTargets[P];if(!p){L.error("The target '"+t._oOptions._name+" has a parent '"+P+"' defined, but it was not found in the other targets",this);return;}t._oParent=p;},
_constructTarget:function(o,p){return new T(o,this._oCache,p);},
_setRootViewId:function(i){var t,o;for(t in this._mTargets){if(this._mTargets.hasOwnProperty(t)){o=this._mTargets[t]._oOptions;if(o.rootView===undefined){o.rootView=i;}}}this._vRootViewId=i;},
_getTitleTargetName:function(t,p){var o,c;if(p){t=[p];}t=this._alignTargetsInfo(t);t.some(function(e){o=this.getTarget(e);while(o&&!o._oOptions.title){o=o._oParent;}if(o){c=o._oOptions._name;return true;}}.bind(this));return c;},
_forwardTitleChanged:function(e){this.fireTitleChanged({name:e.getParameter("name"),title:e.getParameter("title")});},
_attachTitleChanged:function(t,c){var o,C;C=this._getTitleTargetName(t,c);if(C){o=this.getTarget(C);}if(this._oLastDisplayedTitleTarget){this._oLastDisplayedTitleTarget.detachTitleChanged(this._forwardTitleChanged,this);this._oLastDisplayedTitleTarget._bIsDisplayed=false;}if(o){o.attachTitleChanged({name:o._oOptions._name},this._forwardTitleChanged,this);this._oLastDisplayedTitleTarget=o;}else if(c){L.error("The target with the name \""+c+"\" where the titleChanged event should be fired does not exist!",this);}}
});
return b;});
sap.ui.predefine('sap/ui/core/routing/Views',["./TargetCache","sap/base/util/UriParameters","sap/base/Log"],function(T,U,L){"use strict";
var V=T.extend("sap.ui.core.routing.Views",{
metadata:{publicMethods:["getView","setView"]},
constructor:function(o){if(!o){o={};}function c(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","TargetCache");return true;}return false;}if(o.async===undefined){o.async=c();}T.apply(this,[o]);},
getView:function(o){return this.get(o,"View");},
setView:function(v,o){return this.set(v,"View",o);},
fireCreated:function(p){if(p){p.view=p.object;p.viewOptions=p.options;}return this.fireEvent("created",p);}
});
return V;});
sap.ui.predefine('sap/ui/core/routing/async/Route',["sap/base/Log","sap/base/util/extend","sap/ui/core/Component"],function(L,e,C){"use strict";return{_routeMatched:function(a,s,n){var r=this._oRouter,t,T,c,E,v=null,o=null,i,b,d,A,R=(r._oMatchedRoute===this);r._stopWaitingTitleChangedFromChild();if(r._oMatchedRoute){delete r._oMatchedRoute._oConfig.dynamicTarget;}r._oMatchedRoute=this;r._bMatchingProcessStarted=true;c=e({},r._oConfig,this._oConfig);T=r.getTargets();var f;if(T){f=T._getTitleTargetName(c.target,c.titleTarget);if(f&&r._oPreviousTitleChangedRoute!==this){r._bFireTitleChanged=true;if((r._oOwner&&r._oOwner._bRoutingPropagateTitle)){var p=C.getOwnerComponentFor(r._oOwner);var P=p&&p.getRouter();if(P){P._waitForTitleChangedOn(r);}}}else{r._bFireTitleChanged=false;}if(this._oConfig.target){A=T._alignTargetsInfo(this._oConfig.target);A.forEach(function(t){t.propagateTitle=t.hasOwnProperty("propagateTitle")?t.propagateTitle:r._oConfig.propagateTitle;t.routeRelevant=true;t.repeatedRoute=R;});}}else{A=this._oConfig.target;}if(!s||s===true){i=true;s=Promise.resolve();}if(this._oParent){s=this._oParent._routeMatched(a,s);}else if(this._oNestingParent){this._oNestingParent._routeMatched(a,s,this);}b=Object.assign({},a);b.routeConfig=c;E={name:c.name,arguments:a,config:c};if(n){E.nestedRoute=n;}this.fireBeforeMatched(E);r.fireBeforeRouteMatched(E);if(this._oTarget){t=this._oTarget;t._updateOptions(this._convertToTargetOptions(c));s=t._place(s,{legacy:true});if(this._oRouter._oTargetHandler&&this._oRouter._oTargetHandler._chainNavigation){d=s;s=this._oRouter._oTargetHandler._chainNavigation(function(){return d;});}}else{s=r._oTargets._display(A,b,this._oConfig.titleTarget,s);}return s.then(function(g){r._bMatchingProcessStarted=false;var h,V,j;if(Array.isArray(g)){h=g;g=h[0];}g=g||{};v=g.view;o=g.control;E.view=v;E.targetControl=o;if(h){V=[];j=[];h.forEach(function(g){V.push(g.view);j.push(g.control);});E.views=V;E.targetControls=j;}if(c.callback){c.callback(this,a,c,o,v);}this.fireEvent("matched",E);r.fireRouteMatched(E);if(i){L.info("The route named '"+c.name+"' did match with its pattern",this);this.fireEvent("patternMatched",E);r.fireRoutePatternMatched(E);}return g;}.bind(this));}};});
sap.ui.predefine('sap/ui/core/routing/async/Target',["sap/base/Log","sap/ui/base/ManagedObjectMetadata","sap/ui/core/ComponentContainer","sap/ui/core/Placeholder","sap/ui/core/library"],function(L,M,C,P,c){"use strict";var a=c.ComponentLifecycle;return{display:function(d){var s=Promise.resolve();return this._display(d,s);},_display:function(d,s,t){if(this._oParent){s=this._oParent._display(d,s,Object.assign({},t));}return this._place(d,s,t);},suspend:function(){if(this._oParent){this._oParent.suspend();}if(this._isLoaded()){var o=this._get(),r;if(o.isA("sap.ui.core.UIComponent")&&(r=o.getRouter())&&o.hasNativeRouter()){r.stop();}}else{L.warning("The target with name '"+this._oOptions._name+"' can't be suspended because it's being loaded or not loaded yet");}return this;},resume:function(){if(this._oParent){this._oParent.resume();}if(this._isLoaded()){var o=this._get(),r;if(o.isA("sap.ui.core.UIComponent")&&(r=o.getRouter())&&o.hasNativeRouter()){r.initialize(true);}}return this;},_isLoaded:function(){return this._bIsLoaded;},_getCreateOptions:function(t){var n=this._getEffectiveObjectName(this._oOptions.name),o=this._oOptions,b;t=t||{};switch(o.type){case"View":b={name:n,type:o.viewType,id:o.id,async:true};break;case"Component":b={id:o.id};if(o.usage){b.usage=o.usage;}else{b.name=n;}b=Object.assign({},o.options||{},b);break;default:throw new Error("The given type "+o.type+" isn't support by sap.ui.core.routing.Target");}return b;},_get:function(t){var o=this._getCreateOptions(t);return this._oCache._get(o,this._oOptions.type,this._bUseRawViewId,t);},_load:function(t){var o=this._get(t),p;if(!(o instanceof Promise)){if(o.isA("sap.ui.core.mvc.View")){p=o.loaded();}else{p=Promise.resolve(o);}}else{p=o;}return p.then(function(o){this._bIsLoaded=true;return o;}.bind(this));},load:function(t){return this._load(t).then(function(l){return{object:l,nestedComponentReady:this.waitForComponentTarget({target:l,createInfo:t})};}.bind(this));},waitForComponentTarget:function(t){return new Promise(function(r,b){var l=t.target;var T=t.createInfo;var i=true;if(l.isA("sap.ui.core.UIComponent")){var R=l.getRouter();if(R&&l.hasNativeRouter()){var h=R.getHashChanger().getHash();var o=R.getRouteByHash(h);var I=T&&T.ignoreInitialHash;if(!R._oConfig.async){throw new Error("The router of component '"+l.getId()+"' which is loaded via the target '"+this._oOptions._name+"' is defined as synchronous which is not supported using as a nested component.");}if(R._oOwner&&T){R._oOwner._bRoutingPropagateTitle=T.propagateTitle;}if(!I&&(!R.isInitialized()||R._bMatchingProcessStarted)&&o&&o._oConfig.target){i=false;R.attachRouteMatched(r);}if(R.isStopped()){R.initialize(I);}}}if(i){r();}}.bind(this));},resolveContainerControl:function(p){return Promise.resolve().then(function(){p=p||{};var o=this._oOptions;var v=this._isValid(p);var e;if(v!==true){e=v;return this._refuseInvalidTarget(o._name,e);}var V=p.view,b=p.control,d,f;if(V&&V.isA("sap.ui.core.ComponentContainer")){V=V.getComponentInstance().getRootControl();}if(!V&&o.rootView){d=Promise.resolve(o.rootView).then(function(r){var g;if(r){g=sap.ui.getCore().byId(r);o.rootView=r;}if(!g){e="Did not find the root view with the id "+o.rootView;return this._refuseInvalidTarget(o._name,e);}else{return g;}}.bind(this));}else{d=Promise.resolve(V);}d=d.then(function(g){if(g&&g.isA("sap.ui.core.mvc.View")){return g.loaded();}else{return g;}});if(o.controlId){f=d.then(function(g){var h;if(g){h=g.byId(o.controlId);}if(!h){h=sap.ui.getCore().byId(o.controlId);}return h;});}else{f=Promise.resolve(b);}return f.then(function(g){if(!g){e="Control with ID "+o.controlId+" could not be found";return this._refuseInvalidTarget(o._name,e);}else{return g;}}.bind(this));}.bind(this));},displayPlaceholder:function(t,o){var O,b=this._oOptions,i=b.type==="Component",h=false,p=t.placeholder||b.placeholder||{},d=Promise.resolve();if(P.hasProviders()){Object.assign(p,P.getPlaceholderFromProviders({name:b.name,type:b.type}));}if(Object.keys(p).length>0){if(p.autoClose===undefined){p.autoClose=true;}h=true;}if(i){var e=this._oCache._oComponent;var s=t.componentId+"-container";O=(e&&e.byId(s))||sap.ui.getCore().byId(s);if(!O){var f=Object.assign({height:"100%",width:"100%",lifecycle:a.Application},b.containerOptions);if(e){e.runAsOwner(function(){O=new C(e.createId(s),f);});}else{O=new C(s,f);}}if(h){p.container=O;}}if(h&&o.isA("sap.ui.core.IPlaceholderSupport")){p.container=o;}if(p.container&&!t.repeatedRoute){p.aggregation=this._oOptions.controlAggregation;var g=this._getCreateOptions(t);var j=this._oCache.fetch(g,this._oOptions.type);if(j&&i){p.object=O;}else{p.object=j;}if(p.html){p.placeholder=new P({html:p.html});}if(p.placeholder&&sap.ui.getCore().getConfiguration().getPlaceholder()){d=this.showPlaceholder(p);}}return d.then(function(k){return{containerControl:o,object:O,placeholderConfig:p,placeholderShown:!!k};});},_place:function(d,s,t){var o=this._oOptions,b=this,e,i=o.type==="Component";var p,f;if(d instanceof Promise){t=s;s=d;d=undefined;}t=t||{};if(i){t.componentId=o.id||M.uid("uicomponent");}if((o.name||o.usage)&&o.type){p=this.load(t);if(this._oParent||t.legacy){f=s.then(this.resolveContainerControl.bind(this));}else{f=this.resolveContainerControl();}f=f.then(this.displayPlaceholder.bind(this,t));s=Promise.all([p,f,s]).then(function(A){var O=A[0].object,v=A[1],V,r;v.nestedComponentReady=A[0].nestedComponentReady;if(i){var g=O.destroy;O.destroy=function(){if(g){g.apply(this);}v.object.destroy();};v.object.setComponent(O);r=O.getRootControl();if(r&&r.isA("sap.ui.core.mvc.View")){V=r;}}else{v.object=O;V=O;}b._bindTitleInTitleProvider(V);b._addTitleProviderAsDependent(V);return v;}).then(function(v){var g=v.containerControl,O=v.object;b._beforePlacingViewIntoContainer({container:g,view:O,data:d});var A=g.getMetadata().getJSONKeys()[o.controlAggregation];if(!A){e="Control "+o.controlId+" does not have an aggregation called "+o.controlAggregation;return b._refuseInvalidTarget(o._name,e);}if(o.clearControlAggregation===true){g[A._sRemoveAllMutator]();}L.info("Did place the "+o.type.toLowerCase()+" target '"+(o.name?b._getEffectiveObjectName(o.name):o.usage)+"' with the id '"+O.getId()+"' into the aggregation '"+o.controlAggregation+"' of a control with the id '"+g.getId()+"'",b);g[A._sMutator](O);return{name:o._name,view:O,control:g,nestedComponentReady:v.nestedComponentReady,placeholderConfig:v.placeholderConfig,placeholderShown:v.placeholderShown};});}else{s=s.then(function(){return{name:o._name};});}return s.then(function(g){var h=g.nestedComponentReady||Promise.resolve();return h.then(function(){var j=g.control,O=g.view,k=g.placeholderConfig;if(j&&O){b.fireDisplay({view:O.isA("sap.ui.core.mvc.View")?O:undefined,object:O,control:j,config:b._oOptions,data:d,routeRelevant:t.routeRelevant});}if(k&&k.container&&k.autoClose&&b.hidePlaceholder){b.hidePlaceholder(k);}return g;});});},showPlaceholder:function(s){if(s.container&&s.container.showPlaceholder){return s.container.showPlaceholder(s);}else{return Promise.resolve();}},hidePlaceholder:function(s){if(s.container.hidePlaceholder){s.container.hidePlaceholder();}},_isValid:function(p){var o=this._oOptions,b=p&&p.control,h=(b||o.controlId),i=true,l="";if(!h){l="The target "+o._name+" has no controlId set and no parent so the target cannot be displayed.";i=false;}if(!o.controlAggregation){l="The target "+o._name+" has a control id or a parent but no 'controlAggregation' was set, so the target could not be displayed.";i=false;}if(l){L.error(l,this);}return i||l;},_refuseInvalidTarget:function(n,m){return Promise.reject(new Error(m+" - Target: "+n));}};});
sap.ui.predefine('sap/ui/core/routing/async/TargetCache',["sap/ui/core/mvc/View","sap/ui/core/Component","sap/ui/core/routing/HashChanger"],function(V,C,H){"use strict";return{_getObjectWithGlobalId:function(o,t,T,s,n){var a=this,p,N,i,O=this._oComponent,w=[];T=T||{};function c(){switch(t){case"View":o.viewName=o.name;delete o.name;return(!o.async||s)?V._create(o):V.create(o);case"Component":o.settings=o.settings||{};o.settings._propagateTitle=T.propagateTitle;var r=a._createRouterHashChanger(T.prefix);if(r){o.settings._routerHashChanger=r;}o.id=o.id||T.componentId;if(o.usage){return O.createComponent(o);}else{return C.create(o);}default:}}function b(d){if(a._oCache){w.forEach(function(I){i[I]=d;});if(T.afterCreate){T.afterCreate(d);}a.fireCreated({object:d,type:t,options:o});}return d;}if(o.async===undefined){o.async=true;}N=o.usage||o.name;this._checkName(N,t);i=this._oCache[t.toLowerCase()][N];p=i&&i[o.id];if(n||p){return p;}if(O){p=O.runAsOwner(c);}else{p=c();}if(p instanceof Promise){p=p.then(b);}else{p.loaded().then(b);}if(!i){i=this._oCache[t.toLowerCase()][N]={};i[undefined]=p;w.push(undefined);}if(o.id!==undefined){i[o.id]=p;w.push(o.id);}return p;},_getViewWithGlobalId:function(o,s,n){if(o&&!o.name){o.name=o.viewName;}return this._getObjectWithGlobalId(o,"View",undefined,s,n);},_getComponentWithGlobalId:function(o,t,n){return this._getObjectWithGlobalId(o,"Component",t,n);},_createRouterHashChanger:function(p){var r;var R=this._oComponent&&this._oComponent.getRouter();if(R){r=R.getHashChanger();if(r&&p){r=r.createSubHashChanger(p);}}return r||H.getInstance().createRouterHashChanger();}};});
sap.ui.predefine('sap/ui/core/routing/async/Targets',["sap/base/Log"],function(L){"use strict";return{display:function(t,d,T){var s=Promise.resolve();return this._display(t,d,T,s);},_display:function(t,d,T,s){var a=this,v=[];if(!Array.isArray(t)){t=[t];}this._attachTitleChanged(t,T);return this._alignTargetsInfo(t).reduce(function(p,o){var b={prefix:o.prefix,propagateTitle:o.propagateTitle||false,ignoreInitialHash:o.ignoreInitialHash,placeholder:o.placeholder,repeatedRoute:o.repeatedRoute,routeRelevant:o.routeRelevant||false};return a._displaySingleTarget(o,d,p,b).then(function(V){V=V||{};V.targetInfo=o;v.push(V);});},s).then(function(){return v;});},_addDynamicTargetToRoute:function(t){if(this._oRouter){var r=this._oRouter._getLastMatchedRouteName();var R,s;if(r){R=this._oRouter.getRoute(r);if(R&&R._oConfig&&R._oConfig.target){s=this._alignTargetsInfo(R._oConfig.target).some(function(c){return c.name===t.name;});if(!s){R._oConfig.dynamicTarget=R._oConfig.dynamicTarget||[];R._oConfig.dynamicTarget.push(t);}}}}},_displaySingleTarget:function(t,d,s,T){var n=t.name,o=this.getTarget(n);if(o!==undefined){if(t.routeRelevant){this._addDynamicTargetToRoute(t);}return o._display(d,s,T);}else{var e="The target with the name \""+n+"\" does not exist!";L.error(e,this);return Promise.resolve({name:n,error:e});}}};});
sap.ui.predefine('sap/ui/core/routing/sync/Route',["sap/base/Log","sap/base/util/extend"],function(L,e){"use strict";return{_routeMatched:function(a,i,n){var r=this._oRouter,p,P,t,c,E,v=null,T=null,o,C,V,b,d;r._oMatchedRoute=this;r._bMatchingProcessStarted=true;if(this._oParent){p=this._oParent._routeMatched(a);}else if(this._oNestingParent){this._oNestingParent._routeMatched(a,false,this);}c=e({},r._oConfig,this._oConfig);o=Object.assign({},a);o.routeConfig=c;E={name:c.name,arguments:a,config:c};if(n){E.nestedRoute=n;}this.fireBeforeMatched(E);r.fireBeforeRouteMatched(E);if(this._oTarget){t=this._oTarget;t._updateOptions(this._convertToTargetOptions(c));if(t._isValid(p,false)){P=t._place(p);}P=P||{};v=P.oTargetParent;T=P.oTargetControl;E.view=v;E.targetControl=T;}else{V=[];b=[];C=function(f){V.push(f.getParameter("view"));b.push(f.getParameter("control"));};if(Array.isArray(this._oConfig.target)){d=this._oConfig.target;}else{d=[this._oConfig.target];}d.forEach(function(s){var t=r._oTargets.getTarget(s);if(t){t.attachEventOnce("display",C);}});r._oTargets._display(this._oConfig.target,o,this._oConfig.titleTarget);E.view=V[0];E.targetControl=b[0];E.views=V;E.targetControls=b;}r._bMatchingProcessStarted=false;if(c.callback){c.callback(this,a,c,T,v);}this.fireEvent("matched",E);r.fireRouteMatched(E);if(i){L.info("The route named '"+c.name+"' did match with its pattern",this);this.fireEvent("patternMatched",E);r.fireRoutePatternMatched(E);}return P;}};});
sap.ui.predefine('sap/ui/core/routing/sync/Target',["sap/base/Log"],function(L){"use strict";return{display:function(d){var p;if(this._oParent){p=this._oParent.display(d);}return this._place(p,d);},suspend:function(){return this;},resume:function(){return this;},_place:function(p,d){var o=this._oOptions;p=p||{};var v,c=p.oTargetControl,V=p.oTargetParent;if(!this._isValid(p,true)){return undefined;}if(!V&&o.rootView){V=sap.ui.getCore().byId(o.rootView);if(!V){L.error("Did not find the root view with the id "+o.rootView,this);return undefined;}}if(o.controlId){if(V){c=V.byId(o.controlId);}if(!c){c=sap.ui.getCore().byId(o.controlId);}if(!c){L.error("Control with ID "+o.controlId+" could not be found",this);return undefined;}}var a=c.getMetadata().getJSONKeys()[o.controlAggregation];if(!a){L.error("Control "+o.controlId+" does not have an aggregation called "+o.controlAggregation,this);return undefined;}var s=this._getEffectiveObjectName(o.viewName);var b={name:s,type:o.viewType,id:o.viewId};v=this._oCache._get(b,"View",this._bUseRawViewId);this._beforePlacingViewIntoContainer({container:c,view:v,data:d});this._bindTitleInTitleProvider(v);this._addTitleProviderAsDependent(v);if(o.clearControlAggregation===true){c[a._sRemoveAllMutator]();}L.info("Did place the view '"+s+"' with the id '"+v.getId()+"' into the aggregation '"+o.controlAggregation+"' of a control with the id '"+c.getId()+"'",this);c[a._sMutator](v);this.fireDisplay({view:v,control:c,config:this._oOptions,data:d});return{oTargetParent:v,oTargetControl:c};},_isValid:function(p,l){var o=this._oOptions,c=p&&p.oTargetControl,h=(c||o.controlId),i=true,s="";if(!h){s="The target "+o._name+" has no controlId set and no parent so the target cannot be displayed.";i=false;}if(!o.controlAggregation){s="The target "+o._name+" has a control id or a parent but no 'controlAggregation' was set, so the target could not be displayed.";i=false;}if(!o.viewName){s="The target "+o._name+" no viewName defined.";i=false;}if(l&&s){L.error(s,this);}return i;}};});
sap.ui.predefine('sap/ui/core/routing/sync/TargetCache',["sap/ui/core/mvc/View"],function(V){"use strict";return{_getObjectWithGlobalId:function(o){function c(){o.viewName=o.name;delete o.name;return V._create(o);}var v,s=o.name,i;this._checkName(s,"View");i=this._oCache.view[s];v=i&&i[o.id];if(v){return v;}if(this._oComponent){v=this._oComponent.runAsOwner(c);}else{v=c();}i=this._oCache.view[s];if(!i){i=this._oCache.view[s]={};i[undefined]=v;}if(o.id!==undefined){i[o.id]=v;}this.fireCreated({object:v,type:"View",options:o});return v;},_getViewWithGlobalId:function(o){if(o&&!o.name){o.name=o.viewName;}return this._getObjectWithGlobalId(o);}};});
sap.ui.predefine('sap/ui/core/routing/sync/Targets',["sap/base/Log"],function(L){"use strict";return{display:function(t,d,T){this._display(t,d,T);},_display:function(t,d,T){var a=this;this._attachTitleChanged(t,T);if(Array.isArray(t)){t.forEach(function(s){a._displaySingleTarget(s,d);});}else{this._displaySingleTarget(t,d);}return this;},_displaySingleTarget:function(n,d){var t=this.getTarget(n);if(t!==undefined){t.display(d);}else{L.error("The target with the name \""+n+"\" does not exist!",this);}}};});
sap.ui.predefine('sap/ui/core/search/OpenSearchProvider',['./SearchProvider',"sap/base/Log","sap/base/security/encodeURL","sap/ui/thirdparty/jquery",'sap/ui/core/library'],function(S,L,e,q){"use strict";
var O=S.extend("sap.ui.core.search.OpenSearchProvider",{metadata:{library:"sap.ui.core",properties:{suggestUrl:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},suggestType:{type:"string",group:"Misc",defaultValue:'json'}}}});
O.prototype.suggest=function(v,c){var u=this.getSuggestUrl();if(!u){return;}u=u.replace("{searchTerms}",e(v));var t=this.getSuggestType();var s;if(t&&t.toLowerCase()==="xml"){t="xml";s=function(d){var x=q(d);var i=x.find("Text");var a=[];i.each(function(){a.push(q(this).text());});c(v,a);};}else{t="json";s=function(d){c(v,d[1]);};}q.ajax({url:u,dataType:t,success:s,error:function(X,a,b){L.fatal("The following problem occurred: "+a,X.responseText+","+X.status);}});};
return O;});
sap.ui.predefine('sap/ui/core/search/SearchProvider',['sap/ui/core/Element',"sap/base/Log",'sap/ui/core/library'],function(E,L){"use strict";
var S=E.extend("sap.ui.core.search.SearchProvider",{metadata:{"abstract":true,library:"sap.ui.core",properties:{icon:{type:"string",group:"Misc",defaultValue:null}}}});
S.prototype.suggest=function(v,c){L.warning("sap.ui.core.search.SearchProvider is the abstract base class for all SearchProviders. Do not create instances of this class, but use a concrete sub class instead.");};
return S;});
sap.ui.predefine('sap/ui/core/service/Service',['sap/ui/base/Object',"sap/base/assert","sap/base/Log"],function(B,a,L){"use strict";
var S=B.extend("sap.ui.core.service.Service",{
metadata:{"abstract":true,"library":"sap.ui.core"},
constructor:function(s){B.apply(this);if(s){a(typeof s.scopeObject==="object","The service context requires a scope object!");a(typeof s.scopeType==="string","The service context requires a scope type!");}this._oServiceContext=s;if(typeof this.init==="function"){this.init();}}
});
S.create=function(s){var A=function A(o){for(var m in s){if(!m.match(/^(metadata|constructor|getContext|destroy)$/)){this[m]=s[m];}else{L.warning("The member "+m+" is not allowed for anonymous service declaration and will be ignored!");}}S.apply(this,arguments);};A.prototype=Object.create(S.prototype);return A;};
S.prototype.getInterface=function(){var p=Object.create(null);for(var m in this){if(!m.match(/^_|^metadata$|^constructor$|^getInterface$|^destroy$|^init$|^exit$|^getContext$/)&&typeof this[m]==="function"){p[m]=this[m].bind(this);}}this.getInterface=function(){return p;};return p;};
S.prototype.getContext=function(){return this._oServiceContext;};
S.prototype.destroy=function(){if(typeof this.exit==="function"){this.exit();}B.prototype.destroy.apply(this,arguments);delete this._oServiceContext;};
return S;});
sap.ui.predefine('sap/ui/core/service/ServiceFactory',['sap/ui/base/Object','sap/ui/core/service/Service',"sap/base/assert"],function(B,S,a){"use strict";
var b=B.extend("sap.ui.core.service.ServiceFactory",{
metadata:{"library":"sap.ui.core"},
constructor:function(s){B.apply(this);var f=typeof s==="object"?S.create(s):s;a(!f||f&&typeof f==="function","The service constructor either should be undefined or a constructor function!");this._fnService=f;}
});
b.prototype.destroy=function(){B.prototype.destroy.apply(this,arguments);delete this._fnService;};
b.prototype.createInstance=function(s){if(typeof this._fnService==="function"){return Promise.resolve(new this._fnService(s));}else{return Promise.reject(new Error("Usage of sap.ui.core.service.ServiceFactory requires a service constructor function to create a new service instance or to override the createInstance function!"));}};
return b;});
sap.ui.predefine('sap/ui/core/service/ServiceFactoryRegistry',['./ServiceFactory',"sap/base/assert"],function(S,a){"use strict";var s=Object.create(null);var b=Object.create(null);
b.register=function(c,o){a(c,"sServiceFactoryName must not be empty, null or undefined");a(o instanceof S,"oServiceFactory must be an instance of sap.ui.core.service.ServiceFactory");s[c]=o;return this;};
b.unregister=function(c){a(c,"sServiceFactoryName must not be empty, null or undefined");delete s[c];return this;};
b.get=function(c){return s[c];};
return b;},true);
sap.ui.predefine('sap/ui/core/syncStyleClass',['sap/ui/thirdparty/jquery','sap/ui/base/Object','sap/base/assert'],function(q,B,a){"use strict";var s=function(S,v,d){if(!S){return d;}if(B.isA(v,'sap.ui.core.Control')){v=v.$();}else if(typeof v==="string"){v=q(document.getElementById(v));}else if(!(v instanceof q)){a(false,'sap/ui/core/syncStyleClass(): vSource must be a jQuery object or a Control or a string');return d;}var c=!!v.closest("."+S).length;if(d instanceof q){d.toggleClass(S,c);}else if(B.isA(d,'sap.ui.core.Control')){d.toggleStyleClass(S,c);}else{a(false,'sap/ui/core/syncStyleClass(): vDestination must be a jQuery object or a Control');}return d;};return s;});
sap.ui.predefine('sap/ui/core/theming/Parameters',['sap/ui/thirdparty/URI','../Element','sap/base/util/UriParameters','sap/base/Log','sap/base/util/extend','sap/ui/core/ThemeCheck','sap/ui/thirdparty/jquery','./ThemeHelper'],function(U,E,a,L,e,T,q,b){"use strict";var c=window["sap-ui-config"]||{};var s=0;if(c['xx-nosync']==='warn'||/(?:\?|&)sap-ui-xx-nosync=(?:warn)/.exec(window.location.search)){s=1;}if(c['xx-nosync']===true||c['xx-nosync']==='true'||/(?:\?|&)sap-ui-xx-nosync=(?:x|X|true)/.exec(window.location.search)){s=2;}var P={};var p=null;var t=null;var d=[];var C=[];var B=new U(sap.ui.require.toUrl(""),document.baseURI).origin();var o={};var r=/url[\s]*\('?"?([^\'")]*)'?"?\)/;var u=a.fromQuery(window.location.search).get("sap-ui-xx-no-inline-theming-parameters")!=="true";
function f(i,j){var M=r.exec(i);if(M){var D=new U(M[1]);if(D.is("relative")){var N=D.absoluteTo(j).normalize().toString();i="url('"+N+"')";}}return i;}
function m(i,N,j){for(var D in N){if(typeof i[D]==="undefined"){i[D]=f(N[D],j);}}return i;}
function g(N,i){if(typeof N["default"]!=="object"){N={"default":N,"scopes":{}};}p=p||{};p["default"]=p["default"]||{};p["scopes"]=p["scopes"]||{};m(p["default"],N["default"],i);if(typeof N["scopes"]==="object"){for(var S in N["scopes"]){p["scopes"][S]=p["scopes"][S]||{};m(p["scopes"][S],N["scopes"][S],i);}}}
function h(i){q("link[id^=sap-ui-theme-]").each(function(){i(this.getAttribute("id"));});}
function k(i){var j=n(i);var D=T.checkStyle(i);if(!D){L.warning("Parameters have been requested but theme is not applied, yet.","sap.ui.core.theming.Parameters");}if(D&&u){var $=q(document.getElementById(i));var F=$.css("background-image");var G=/\(["']?data:text\/plain;utf-8,(.*?)['"]?\)$/i.exec(F);if(G&&G.length>=2){var H=G[1];if(H.charAt(0)!=="{"&&H.charAt(H.length-1)!=="}"){try{H=decodeURIComponent(H);}catch(I){L.warning("Could not decode theme parameters URI from "+j.styleSheetUrl);}}try{var J=JSON.parse(H);g(J,j.themeBaseUrl);return true;}catch(I){L.warning("Could not parse theme parameters from "+j.styleSheetUrl+". Loading library-parameters.json as fallback solution.");}}}return false;}
function l(i){var j=n(i);if(!k(i)){var D=j.styleSheetUrl.replace(/\/(?:css_variables|library)([^\/.]*)\.(?:css|less)($|[?#])/,function($,H,I){return"/library-parameters.json"+(I?I:"");});if(s===2){L.error("[nosync] Loading library-parameters.json ignored",D,"sap.ui.core.theming.Parameters");return;}else if(s===1){L.error("[nosync] Loading library-parameters.json with sync XHR",D,"sap.ui.core.theming.Parameters");}var F=new U(j.themeBaseUrl).origin();var W=o[F];var G=[];if(W===undefined){if(D.startsWith(B)){G=[false,true];}else{G=[true,false];}}else{G=[W];}v(D,j.themeBaseUrl,G);}}
function n(i){var j=document.getElementById(i);if(!j){L.warning("Could not find stylesheet element with ID",i,"sap.ui.core.theming.Parameters");return undefined;}var S=j.href;return{themeBaseUrl:new U(S).filename("").query("").toString(),styleSheetUrl:S};}
function v(i,D,W){var F=W.shift();var H=F?{"X-Requested-With":"XMLHttpRequest"}:{};q.ajax({url:i,dataType:'json',async:false,xhrFields:{withCredentials:F},headers:H,success:function(G,I,J){var K=new U(D).origin();o[K]=F;if(Array.isArray(G)){for(var j=0;j<G.length;j++){var M=G[j];g(M,D);}}else{g(G,D);}},error:function(j,G,I){L.error("Could not load theme parameters from: "+i,I);if(W.length>0){L.warning("Initial library-parameters.json request failed ('withCredentials="+F+"'; sUrl: '"+i+"').\n"+"Retrying with 'withCredentials="+!F+"'.","sap.ui.core.theming.Parameters");v(i,D,W);}}});}
function w(i){if(!p){g({},"");h(function(I){if(i){if(T.checkStyle(I)){k(I);}else{d.push(I);}}else{l(I);}});}return p;}
function x(){var i=[];d.forEach(function(I){if(T.checkStyle(I)){k(I);}else{i.push(I);}});d=i;}
function y(){d.forEach(l);d=[];}
P._addLibraryTheme=function(i){if(p){d.push("sap-ui-theme-"+i);}};
function z(O){var i=O.async,j=w(i);if(O.scopeName){j=j["scopes"][O.scopeName];}else{j=j["default"];}var D=j[O.parameterName];if(!D){var I=O.parameterName.indexOf(":");if(I!=-1){var F=O.parameterName.substr(I+1);D=j[F];}}if(O.loadPendingParameters&&typeof D==="undefined"&&!i){y();D=z({parameterName:O.parameterName,scopeName:O.scopeName,loadPendingParameters:false});}return D;}
function A(j,D,F){var S=P.getActiveScopesFor(D,F);var G=S.flat().reduce(function(R,J){if(R.indexOf(J)===-1){R.push(J);}return R;},[]);for(var i=0;i<G.length;i++){var H=G[i];var I=z({parameterName:j,scopeName:H,async:F});if(I){return I;}}return z({parameterName:j,async:F});}
P._getScopes=function(i,j){if(i&&!p){return;}var D=w(j);var S=Object.keys(D["scopes"]);return S;};
P.getActiveScopesFor=function(i,j){var S=[];if(i instanceof E){var D=i.getDomRef();if(j){x();}else{y();}var F=this._getScopes(undefined,j);if(F.length){if(D){var N=function(I){var J=D.classList;return J&&J.contains(I);};while(D){var G=F.filter(N);if(G.length>0){S.push(G);}D=D.parentNode;}}else{var H=function(I){return typeof i.hasStyleClass==="function"&&i.hasStyleClass(I);};while(i){var G=F.filter(H);if(G.length>0){S.push(G);}i=typeof i.getParent==="function"&&i.getParent();}}}}return S;};
P.get=function(N,j){var D,F,G,H,I;var J=function(S){return S.callback===F;};if(!sap.ui.getCore().isInitialized()){L.warning("Called sap.ui.core.theming.Parameters.get() before core has been initialized. "+"Consider using the API only when required, e.g. onBeforeRendering.");}if(!t){t=sap.ui.getCore().getConfiguration().getTheme();}if(arguments.length===0){L.warning("Legacy variant usage of sap.ui.core.theming.Parameters.get API detected. Do not use the Parameters.get() API to retrieve ALL theming parameters, "+"as this will lead to unwanted synchronous requests. "+"Use the asynchronous API variant instead and retrieve a fixed set of parameters.","LegacyParametersGet","sap.ui.support",function(){return{type:"LegacyParametersGet"};});y();var K=w();return Object.assign({},K["default"]);}if(!N){return undefined;}if(N instanceof Object&&!Array.isArray(N)){if(!N.name){L.warning("sap.ui.core.theming.Parameters.get was called with an object argument without one or more parameter names.");return undefined;}j=N.scopeElement;F=N.callback;H=typeof N.name==="string"?[N.name]:N.name;G=true;}else{if(typeof N==="string"){H=[N];}else{H=N;}L.warning("Legacy variant usage of sap.ui.core.theming.Parameters.get API detected for parameter(s): '"+H.join(", ")+"'. This could lead to bad performance and additional synchronous XHRs, as parameters might not be available yet. Use asynchronous variant instead.","LegacyParametersGet","sap.ui.support",function(){return{type:"LegacyParametersGet"};});}var M,R;var O=function(S){if(j instanceof E){return A(S,j,G);}else{if(G){x();}return z({parameterName:S,loadPendingParameters:!G,async:G});}};R={};for(var i=0;i<H.length;i++){D=H[i];var Q=O(D);if(!G||Q){R[D]=Q;}}if(G&&F&&Object.keys(R).length!==H.length){if(!sap.ui.getCore().isThemeApplied()){M=function(){sap.ui.getCore().detachThemeChanged(M);var S=this.get({name:N.name,scopeElement:N.scopeElement});if(!S||(typeof S==="object"&&(Object.keys(S).length!==H.length))){L.error("One or more parameters could not be found.","sap.ui.core.theming.Parameters");}F(S);C.splice(C.findIndex(J),1);}.bind(this);I=C.findIndex(J);if(I>=0){sap.ui.getCore().detachThemeChanged(C[I].eventHandler);C[I].eventHandler=M;}else{C.push({callback:F,eventHandler:M});}sap.ui.getCore().attachThemeChanged(M);return undefined;}else{L.error("One or more parameters could not be found.","sap.ui.core.theming.Parameters");}}return H.length===1?R[H[0]]:R;};
P._setOrLoadParameters=function(i){p={"default":{},"scopes":{}};t=sap.ui.getCore().getConfiguration().getTheme();h(function(I){var j=I.substr(13);if(i[j]){e(p["default"],i[j]);}else{l(I);}});};
P.reset=function(){var O=arguments[0]===true;if(!O||sap.ui.getCore().getConfiguration().getTheme()!==t){t=sap.ui.getCore().getConfiguration().getTheme();d=[];p=null;b.reset();}};
P._getThemeImage=function(i,F){i=i||"sapUiGlobalLogo";var j=P.get(i);if(j){var D=r.exec(j);if(D){j=D[1];}else if(j==="''"||j==="none"){j=null;}}if(F&&!j){return sap.ui.resource('sap.ui.core','themes/base/img/1x1.gif');}return j;};
return P;},true);
sap.ui.predefine('sap/ui/core/tmpl/DOMAttribute',['sap/ui/core/Element','sap/ui/core/library'],function(E){"use strict";
var D=E.extend("sap.ui.core.tmpl.DOMAttribute",{metadata:{library:"sap.ui.core",properties:{name:{type:"string",group:"Data",defaultValue:null},value:{type:"string",group:"Data",defaultValue:null}}}});
D.prototype.setValue=function(v){this.setProperty("value",v,true);var p=this.getParent(),$=p&&p.$();if($&&$.length>0){$.attr(this.getName(),this.getProperty("value"));}return this;};
return D;});
sap.ui.predefine('sap/ui/core/tmpl/DOMElement',['sap/ui/core/Control','./DOMAttribute',"./DOMElementRenderer","sap/base/Log","sap/ui/thirdparty/jquery",'sap/ui/core/library'],function(C,D,a,L,q){"use strict";
var b=C.extend("sap.ui.core.tmpl.DOMElement",{
metadata:{library:"sap.ui.core",properties:{text:{type:"string",group:"Appearance",defaultValue:null},tag:{type:"string",group:"Behavior",defaultValue:'span'}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.ui.core.tmpl.DOMAttribute",multiple:true,singularName:"attribute"},elements:{type:"sap.ui.core.tmpl.DOMElement",multiple:true,singularName:"element"}}},
renderer:a
});
b.prototype.applySettings=function(s){var m=this.getMetadata(),j=m.getJSONKeys();if(s){if(!s["attributes"]){var A=s["attributes"]=[];q.each(s,function(k,v){if(k!=="id"&&!j[k]&&typeof v==="string"){A.push(new D({name:k,value:v}));delete s[k];}});}else{L.warning("DOMElement#"+this.getId()+": custom attributes in settings will be ignored since attributes are provided!");}}C.prototype.applySettings.apply(this,arguments);};
b.prototype.exit=b.prototype.onBeforeRendering=function(){var t=this.getTag().toLowerCase();if(t==="input"||t==="textarea"||t==="select"){this.$().off("change");}};
b.prototype.onAfterRendering=function(){var t=this.getTag().toLowerCase();if(t==="input"||t==="textarea"||t==="select"){this.$().on("change",q.proxy(this.oninputchange,this));}};
b.prototype.oninputchange=function(e){var t=this.getTag().toLowerCase();if(t==="input"){var v=this.$().val();this.getAttributes().forEach(function(A){if(A.getName().toLowerCase()==="value"){A.setValue(v);}});}else if(t==="textarea"){var T=this.$().val();this.setText(T);}else if(t==="select"){var T="";this.$().find("select option:selected").each(function(){T+=q(this).text()+" ";});this.setText(T);}};
b.prototype.attr=function(k,v){var A=this.getAttributes(),o;A.forEach(function(V){var n=V.getName();if(n.toLowerCase()===k){o=V;return false;}});if(v===undefined){return o&&o.getValue();}else{if(o){if(v===null){this.removeAttribute(o);}else{o.setValue(v);}}else{if(v!==null){this.addAttribute(new D({name:k,value:v}));}}return this;}};
b.prototype.removeAttr=function(k){this.attr(k,null);return this;};
b.prototype.setText=function(t){this.setProperty("text",t,true);var $=this.$();if($.length>0){var T=this.getTag().toLowerCase();if(T==="textarea"){$.val(this.getProperty("text"));}else{$.text(this.getProperty("text"));}}return this;};
return b;});
sap.ui.predefine('sap/ui/core/tmpl/DOMElementRenderer',["sap/base/Log","sap/base/security/encodeXML"],function(L,e){"use strict";var D={apiVersion:2};var r=/^(?:area|base|br|col|embed|hr|img|input|link|meta|param|source|track|wbr)$/i;
D.render=function(R,E){var s=e(E.getTag()),i=r.test(s);if(i){R.voidStart(s,E);}else{R.openStart(s,E);}E.getAttributes().forEach(function(A){var n=A.getName().toLowerCase();if(n==="class"){var c=A.getValue().split(" ");c.forEach(function(C){var C=C.trim();if(C){R.class(C);}});}else if(n==="style"){var S=A.getValue().split(";");S.forEach(function(b){var I=b.indexOf(":");if(I!=-1){var k=b.substring(0,I).trim();var v=b.substring(I+1).trim();R.style(e(k),v);}});}else if(A.getName()){R.attr(e(A.getName()),A.getValue());}else{L.error("Attributes must have a non-empty name");}});if(i){R.voidEnd();}else{R.openEnd();}var a=E.getElements(),h=!!E.getText()||a.length>0;if(h){if(i){L.error("Void element '"+s+"' is rendered with children");}if(E.getText()){R.text(E.getText());}a.forEach(function(I,c){R.renderControl(c);});}if(!i){R.close(s);}};
return D;},true);
sap.ui.predefine('sap/ui/core/tmpl/HandlebarsTemplate',['./Template','./TemplateControl','sap/ui/thirdparty/handlebars','sap/ui/base/ManagedObject','sap/base/util/ObjectPath',"sap/base/security/encodeXML","sap/base/util/isEmptyObject",'sap/ui/core/Core'],function(T,a,H,M,O,e,b){"use strict";
var c=T.extend("sap.ui.core.tmpl.HandlebarsTemplate",{
metadata:{library:"sap.ui.core"},
constructor:function(i,s){T.apply(this,arguments);}
});
T.registerType("text/x-handlebars-template","sap.ui.core.tmpl.HandlebarsTemplate");
function d(h){for(var k in h){h[k]=h[k].replace("&gt;",">").replace("&lt;","<").replace("&quot;","\"").replace("&amp;","&");}}
function f(p,P){var r=/^((\w+)>)?(.*)/,g=r.exec(p),s=g[2],h=r.exec(P),i=h[2];var g=r.exec(p);if(P&&s==i){return P+g[3];}else{return p;}}
c.RENDER_HELPERS=(function(){var E=H.helpers["each"],w=H.helpers["with"],I=H.helpers["if"],u=H.helpers["unless"],r=sap.ui.getCore().createRenderManager();r.renderControl=function(C){this.writeControlData(C);this.writeClasses(C);this.writeStyles(C);};var h={"each":function(g,o){o=o||g;if(!o.hash.path){return E.apply(this,arguments);}else{d(o.hash);var R=o.data.renderManager,i=o.data.rootControl,p=o.data.path,P=o.data.parentControl,s=f(o.hash.path,p),j=i.bindList(s),k=[],l;if(o.data){l=H.createFrame(o.data);}if(j){for(var K in j){if(l){l.renderManager=R;l.rootControl=i;l.path=s+"/"+K+"/";l.parentControl=P;}k.push(o.fn({},{data:l}));}}if(!P){return new H.SafeString(k.join(""));}}},"with":function(g,o){o=o||g;if(!o.hash.path){return w.apply(this,arguments);}},"if":function(g,o){o=o||g;if(!o.hash.path){return I.apply(this,arguments);}else{d(o.hash);var R=o.data.rootControl,p=o.data.path,P=f(o.hash.path,p);if(P){var v=R.bindProp(P);if(v){return o.fn(this);}else{return o.inverse(this);}}}},"unless":function(g,o){o=o||g;if(!o.hash.path){return u.apply(this,arguments);}else{d(o.hash);var R=o.data.rootControl,p=o.data.path,P=f(o.hash.path,p);if(P){var v=R.bindProp(P);if(!v){return o.fn(this);}else{return o.inverse(this);}}}},"text":function(g,o){o=o||g;d(o.hash);var R=o.data.rootControl,p=o.data.path,P=f(o.hash.path,p);if(P){var v=R.bindProp(P);return v&&new H.SafeString(e(v));}else{throw new Error("The expression \"text\" requires the option \"path\"!");}},"element":function(g,o){o=o||g;d(o.hash);var R=o.data.renderManager,i=o.data.rootControl,j=i.createDOMElement(o.hash,o.data.path),p=o.data.parentElement;if(o.fn){o.fn({},{data:{renderManager:R,rootControl:i,parentElement:j}});}if(p){p.addElement(j);return;}return new H.SafeString(R.getHTML(j));},"control":function(g,o){o=o||g;d(o.hash);var R=o.data.renderManager,C=o.data.control;if(C){return new H.SafeString(R.getHTML(C));}var j=o.data.rootControl,p=o.data.path,P=o.data.children,t=o.hash["sap-ui-type"],k=O.get(t||""),m=k&&k.getMetadata(),D=o.hash["sap-ui-default-aggregation"]||m&&m.getDefaultAggregationName(),v=o.data.view;if(!k){throw new Error("Control of type "+t+" cannot be found.");}var n={};if(o.fn){o.fn({},{data:{rootControl:j,path:p,children:n,defaultAggregation:D,view:v}});}var s=Object.assign({},o.hash),S;for(var K in s){if(K==="sap-ui-class"&&typeof s[K]==="string"){S=s["sap-ui-class"]&&s["sap-ui-class"].split(" ");delete s[K];}else if(n[K]){delete s[K];}}var N=j.createControl(s,o.data.path,!!P,v);if(S&&S.length>0){S.forEach(N.addStyleClass.bind(N));}if(!b(n)){s=o.hash;var A=m.getAllAggregations();for(var q in n){var x=n[q];for(var i=0,l=x.length;i<l;i++){var y=x[i],z=A[q],B=z&&z.multiple;if(typeof s[q]==="string"){var F=M.bindingParser(s[q],v&&v.getController());F.template=y;N.bindAggregation(q,F);}else{if(B){N.addAggregation(q,y);}else{N.setAggregation(q,y);}}}}}if(P){var q=o.hash["sap-ui-aggregation"]||o.data.defaultAggregation;P[q]=P[q]||[];P[q].push(N);return;}return new H.SafeString(R.getHTML(N));},"property":function(g,o){o=o||g;d(o.hash);var R=o.data.rootControl,m=R.getMetadata(),p=o.hash.name,G=m.getProperty(p)._sGetter;return R[G]();},"aggregation":function(g,o){o=o||g;d(o.hash);if(o.data.children){var A=o.hash.name;if(o.fn){var D=Object.assign({},o.data,{defaultAggregation:A});o.fn({},{data:D});}}else{var R=o.data.renderManager,j=o.data.rootControl,m=j.getMetadata(),A=o.hash.name,G=m.getAggregation(A)._sGetter,k=[];var C=j[G]();if(C){for(var i=0,l=C.length;i<l;i++){if(o.fn){k.push(o.fn({},{data:{renderManager:R,rootControl:j,control:C[i]}}));}else{k.push(R.getHTML(C[i]));}}}return new H.SafeString(k.join(""));}},"event":function(g,o){o=o||g;},"controlData":function(g,o){o=o||g;var R=o.data.rootControl;return new H.SafeString(r.getHTML(R));}};return h;}());
c.prototype.createMetadata=function(){var t=this.getContent(),g=this._fnTemplate=this._fnTemplate||H.compile(t);var m={},j=a.getMetadata().getAllSettings(),p=a.getMetadata().getAllPrivateAggregations();var h={"property":function(i,o){o=o||i;d(o.hash);var n=o.hash.name;if(n&&n!=="id"&&!j[n]){m.properties=m.properties||{};m.properties[n]=Object.assign({},{type:"string"},o.hash);}else{throw new Error("The property name \""+n+"\" is reserved.");}},"aggregation":function(i,o){o=o||i;d(o.hash);var n=o.hash.name;if(n&&!j[n]&&!p[n]){o.hash.multiple=o.hash.multiple=="true";m.aggregations=m.aggregations||{};m.aggregations[n]=Object.assign({},o.hash);}else{throw new Error("The aggregation name \""+n+"\" is reserved.");}},"event":function(i,o){o=o||i;},"controlData":function(i,o){o=o||i;m._hasControlData=true;}};["each","if","unless","with"].forEach(function(v){h[v]=function(){};});g({},{helpers:h});return m;};
c.prototype.createRenderer=function(v){var t=this.getContent(),g=this._fnTemplate=this._fnTemplate||H.compile(t);var r=function(h,C){var s=g(C.getContext()||{},{data:{renderManager:h,rootControl:C,view:v},helpers:c.RENDER_HELPERS});h.write(s);};return r;};
return c;});
sap.ui.predefine('sap/ui/core/tmpl/Template',['sap/ui/base/ManagedObject','sap/ui/base/BindingParser','sap/ui/core/Control','sap/ui/core/RenderManager','sap/base/util/ObjectPath','sap/base/Log','sap/base/assert','sap/ui/thirdparty/jquery','sap/ui/core/tmpl/TemplateControl','./_parsePath'],function(M,B,C,R,O,L,a,q,T,p){"use strict";
var b=M.extend("sap.ui.core.tmpl.Template",{
constructor:function(i,s){M.apply(this,arguments);},
metadata:{stereotype:"template","abstract":true,library:"sap.ui.core",properties:{"content":{type:"string",group:"Data",defaultValue:null}},publicMethods:["declareControl","createControl","placeAt","createMetadata","createRenderer"]}
});
var t={};
b.prototype.register=function(){var i=this.getId(),o=t[i],m;if(o&&this!==o){m="adding template with duplicate id '"+i+"'";L.error(m);throw new Error("Error: "+m);}t[i]=this;};
b.prototype.deregister=function(){delete t[this.getId()];};
b.byId=function(i){return t[i];};
b.prototype.getInterface=function(){return this;};
b._mSupportedTypes={};
b.registerType=function(s,c){b._mSupportedTypes[s]=c;};
b.unregisterType=function(s){delete b._mSupportedTypes[s];};
b.parsePath=p;
b.prototype.init=function(s,S){if(this.getMetadata().getName()==="sap.ui.core.tmpl.Template"){throw new Error("The class 'sap.ui.core.tmpl.Template' is abstract and must not be instantiated!");}if(M.bindingParser===B.complexParser){b.prototype.extractBindingInfo=function(v,i,S){M.bindingParser=B.simpleParser;var r=C.prototype.extractBindingInfo.apply(this,arguments);M.bindingParser=B.complexParser;return r;};}};
b.prototype.declareControl=function(c){a(!!c,"A fully qualified name must be specified!");if(c){var m=this.createMetadata(),r=this.createRenderer(),d=this;T.extend(c,{metadata:m,init:function(){T.prototype.init.apply(this,arguments);this.setTemplate(d);},renderer:{renderTemplate:r,hasControlData:m._hasControlData}});return O.get(c||"");}};
b.prototype.createControl=function(i,c,v){var o=new T({id:i,template:this,context:c});o.setTemplateRenderer(this.createRenderer(v));return o;};
b.prototype.placeAt=function(r,c,P,i){if(typeof c==="string"||typeof c==="number"){P=c;c=undefined;}var I;if(!(r instanceof C)&&i){var $=typeof r==="string"?q(document.getElementById(r)):q(r);if($.length>0){I=$.attr("id");r=$.get(0);var s=$.attr("data-context");c=c||s&&JSON.parse(s);R.markInlineTemplate($);}}var o=this.createControl(I,c);o.placeAt(r,P);return o;};
b.prototype.createMetadata=function(){L.error("The function createMetadata is an abstract function which needs to be implemented by subclasses.");};
b.prototype.createRenderer=function(){L.error("The function createRenderer is an abstract function which needs to be implemented by subclasses.");};
sap.ui.template=function(o){var l=function(N){L.warning("The usage of Template Views is deprecated since 1.56. Please make use of the asynchronous create functions of the different view classes, e.g. XMLView.create()","Deprecation",null,function(){return{type:"sap.ui.template",name:N};});};if(!o){var c=[];q.each(b._mSupportedTypes,function(s,k){q("script[type='"+s+"'], [data-type='"+s+"']").each(function(r,E){c.push(sap.ui.template({id:E.id,domref:E,type:s,_class:k}));});});return c;}else{if(typeof o==="string"){return sap.ui.template({id:o});}else if(o&&o.tagName&&o.nodeName&&o.ownerDocument&&o.nodeType===1){return sap.ui.template({id:o.id,domref:o});}o=q.extend({type:b.DEFAULT_TEMPLATE},o);l(o.id);var i,s,d,e,f=false,g=typeof o.src==="string",I=false;if(g){q.ajax({url:o.src,dataType:"text",async:false,success:function(r){i=o.id;s=o.type;d=o.control;e=r;var u=/^<!--\sUI5:Template\stype=([a-z\/\-]*)\s(?:controller=([A-Za-z.]*)\s)?-->/,v=e.match(u);if(v){s=v[1];if(v.length==3){f=v[2];}e=e.substr(v[0].length);}},error:function(){throw new Error("The template could not be loaded from "+o.src+"!");}});}else{var E=o.domref||((o.id?window.document.getElementById(o.id):null)),$=q(E);I=false;i=o.id||E&&E.id;s=$.attr("type")||o.type;d=$.attr("data-control")||o.control;if(i){var h=sap.ui.getCore().getTemplate(i);if(!h instanceof b){throw new Error("Object for id \""+i+"\" is no sap.ui.core.tmpl.Template!");}else{if(h){return h;}}}if($.length===0){throw new Error("DOM element for the Template with the id \""+i+"\" not found!");}e=$.html();var j=E.tagName.toLowerCase();if(j!=="script"){I=$.parents("body").length===1;}}var k=o._class;if(!k){k=b._mSupportedTypes[s];if(!k){throw new Error("The type \""+s+"\" is not supported.");}}var m=sap.ui.requireSync(k.replace(/\./g,"/"));m=m||O.get(k||"");var n=new m({id:i,content:e});if(d){n.declareControl(d);}if(f){n._sControllerName=f;}if(I){n.placeAt(i,o.context,undefined,true);}return n;}};
b.DEFAULT_TEMPLATE="text/x-handlebars-template";b.registerType(b.DEFAULT_TEMPLATE,"sap.ui.core.tmpl.HandlebarsTemplate");return b;});
sap.ui.predefine('sap/ui/core/tmpl/TemplateControl',['sap/ui/core/Control','sap/ui/core/DeclarativeSupport','sap/ui/core/UIArea','./DOMElement',"./TemplateControlRenderer","./_parsePath","sap/base/strings/capitalize","sap/base/strings/hyphenate","sap/base/Log","sap/ui/thirdparty/jquery",'sap/ui/core/library'],function(C,D,U,a,T,p,c,h,L,q){"use strict";
var b=C.extend("sap.ui.core.tmpl.TemplateControl",{
metadata:{library:"sap.ui.core",properties:{context:{type:"object",group:"Data",defaultValue:null}},aggregations:{controls:{type:"sap.ui.core.Control",multiple:true,singularName:"control",visibility:"hidden"}},associations:{template:{type:"sap.ui.core.tmpl.Template",multiple:false}},events:{afterRendering:{},beforeRendering:{}}},
renderer:T
});
b.prototype.init=function(){this._aBindingInfos=[];};
b.prototype.isInline=function(){var i=false,P=this.getParent();if(P instanceof U&&q(P.getRootNode()).attr("id")===this.getId()){i=true;}return i;};
b.prototype.placeAt=function(r,P){var i=this.isInline();var $=this.$(),u=this.getUIArea();C.prototype.placeAt.apply(this,arguments);if(i&&$.length===1){$.remove();u.destroyContent();}};
b.prototype.getTemplateRenderer=function(){return this.fnRenderer;};
b.prototype.setTemplateRenderer=function(r){this.fnRenderer=r;return this;};
b.prototype._cleanup=function(){this.destroyAggregation("controls");this._aBindingInfos.forEach(function(B){var o=B.binding;if(o){o.detachChange(B.changeHandler);o.destroy();}});this._aBindingInfos=[];};
b.prototype._compile=function(){var t=sap.ui.getCore().byId(this.getTemplate()),d=t&&t.getDeclarativeSupport();if(d){var e=this;setTimeout(function(){D.compile(e.getDomRef());});}};
b.prototype.exit=function(){this._cleanup();};
b.prototype.onBeforeRendering=function(){this.fireBeforeRendering();this._cleanup();};
b.prototype.onAfterRendering=function(){this.fireAfterRendering();};
b.prototype.clone=function(){var o=C.prototype.clone.apply(this,arguments);o.fnRenderer=this.fnRenderer;return o;};
b.prototype.updateBindings=function(u,m){C.prototype.updateBindings.apply(this,arguments);if(this.getDomRef()){this.invalidate();}};
b.prototype.bind=function(P,t){var o=p(P),m=this.getModel(o.model),P=o.path,M=t?"bind"+c(t):"bindProperty",B=m&&m[M](P),d={binding:B,path:o.path,model:o.model};if(B){d.changeHandler=function(){L.debug("TemplateControl#"+this.getId()+": "+t+" binding changed for path \""+P+"\"");this.invalidate();}.bind(this);B.attachChange(d.changeHandler);}this._aBindingInfos.push(d);return B;};
b.prototype.calculatePath=function(P,t){var B=this.getBindingContext(),s=B&&B.getPath();if(P&&s&&!P.startsWith("/")){if(!s.endsWith("/")){s+="/";}P=s+P;}return P;};
b.prototype.bindProp=function(P){var B=this.bind(this.calculatePath(P),"property");return B&&B.getExternalValue();};
b.prototype.bindList=function(P){var B=this.bind(this.calculatePath(P),"list"),m=B&&B.getModel(),P=B&&B.getPath();return B&&m.getProperty(P);};
b.prototype.createDOMElement=function(s,P,d){var e=new a(s);if(P){e.bindObject(P);}if(!d){this.addAggregation("controls",e);}return e;};
b.prototype.createControl=function(s,P,d,v){var H={};q.each(s,function(k,V){H["data-"+h(k)]=V;});var $=q("<div></div>",H);var o=D._createControl($.get(0),v);if(P){o.bindObject(P);}if(!d){this.addAggregation("controls",o);}return o;};
return b;});
sap.ui.predefine('sap/ui/core/tmpl/TemplateControlRenderer',function(){"use strict";var T={apiVersion:1};
T.render=function(r,c){var s=c.isInline()||this.hasControlData;if(!s){r.openStart("div",c).openEnd();}var R=this.renderTemplate||c.getTemplateRenderer();if(R){R.apply(this,arguments);}if(!s){r.close("div");}};
return T;},true);
sap.ui.predefine('sap/ui/core/tmpl/_parsePath',[],function(){"use strict";return function(p){var m,s=p.indexOf(">");if(s>0){m=p.substr(0,s);p=p.substr(s+1);}return{path:p,model:m};};});
sap.ui.predefine('sap/ui/core/util/AsyncHintsHelper',[],function(){'use strict';var A={};
A.modifyUrls=function(a,u){function _(o,U){if(U===undefined){delete o.url;}}[a.components,a.libs].forEach(function(i){if(Array.isArray(i)){i.forEach(function(v){if(typeof v!=="object"){return;}if(typeof v.url==="string"){v.url=u(v.url);_(v,v.url);}else if(typeof v.url==="object"&&typeof v.url.url==="string"){v.url.url=u(v.url.url);_(v,v.url.url);}});}});return a;};
return A;});
sap.ui.predefine('sap/ui/core/util/DraftEnabledMockServer',["sap/ui/thirdparty/jquery","sap/base/util/isEmptyObject"],function(q,a){"use strict";return{_oDraftMetadata:{},_oConstants:{COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT:"com.sap.vocabularies.Common.v1.DraftRoot",COM_SAP_VOCABULARIES_COMMON_V1_DRAFTNODE:"com.sap.vocabularies.Common.v1.DraftNode",COM_SAP_VOCABULARIES_COMMON_V1_SEMANTICKEY:"com.sap.vocabularies.Common.v1.SemanticKey",EMPTY_GUID:"00000000-0000-0000-0000-000000000000",SIBLINGENTITY_NAVIGATION:"SiblingEntity",DRAFT_ADMINISTRATIVE_DATA:"DraftAdministrativeData",DRAFT_ADMINISTRATIVE_DATA_UUID:"DraftAdministrativeDataUUID",ACTIVATION_ACTION:"ActivationAction",EDIT_ACTION:"EditAction",VALIDATE_ACTION:"ValidationFunction",PREPARE_ACTION:"PreparationAction"},handleDraft:function(A,m){var M=sap.ui.require("sap/ui/core/util/MockServer");var s=M._syncAjax;var n=function(b){var N=b.getParameter("oEntity");N.IsActiveEntity=false;N.HasActiveEntity=false;N.HasDraftEntity=false;};var d=function(b){var x=b.getParameter("oXhr");var c=s({url:x.url,dataType:"json"}).data.d;for(var i=0;i<this._oDraftMetadata.draftNodes.length;i++){for(var f in this._mEntitySets[this._oDraftMetadata.draftRootName].navprops){if(this._mEntitySets[this._oDraftMetadata.draftRootName].navprops[f].to.entitySet===this._oDraftMetadata.draftNodes[i]){var r=s({url:c[f].__deferred.uri,dataType:"json"});if(r.data&&r.data.d&&r.data.d.results){var N;for(var j=0;j<r.data.d.results.length;j++){N=r.data.d.results[j];s({url:N.__metadata.uri,type:"DELETE"});}}}}}};if(A&&A.EntityContainer){var e=A.EntityContainer[Object.keys(A.EntityContainer)[0]];for(var E in e){var o=e[E];if(o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT]){this._oDraftMetadata.draftRootName=E;this._oDraftMetadata.annotations=A;this._oDraftMetadata.mockServerRootUri=m.getRootUri();if(o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT][this._oConstants.ACTIVATION_ACTION]){this._oDraftMetadata.draftRootActivationName=o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT][this._oConstants.ACTIVATION_ACTION].String;}if(this._oDraftMetadata.draftRootActivationName){this._oDraftMetadata.draftRootActivationName=this._oDraftMetadata.draftRootActivationName.substring(this._oDraftMetadata.draftRootActivationName.lastIndexOf("/")+1);}this._oDraftMetadata.draftRootEditName=o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT][this._oConstants.EDIT_ACTION];this._oDraftMetadata.draftRootEditName=this._oDraftMetadata.draftRootEditName?this._oDraftMetadata.draftRootEditName.String:undefined;if(this._oDraftMetadata.draftRootEditName){this._oDraftMetadata.draftRootEditName=this._oDraftMetadata.draftRootEditName.substring(this._oDraftMetadata.draftRootEditName.lastIndexOf("/")+1);}this._oDraftMetadata.draftRootValidationName=o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT][this._oConstants.VALIDATE_ACTION];this._oDraftMetadata.draftRootValidationName=this._oDraftMetadata.draftRootValidationName?this._oDraftMetadata.draftRootValidationName.String:undefined;if(this._oDraftMetadata.draftRootValidationName){this._oDraftMetadata.draftRootValidationName=this._oDraftMetadata.draftRootValidationName.substring(this._oDraftMetadata.draftRootValidationName.lastIndexOf("/")+1);}this._oDraftMetadata.draftRootPreparationtionName=o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT][this._oConstants.PREPARE_ACTION];this._oDraftMetadata.draftRootPreparationtionName=this._oDraftMetadata.draftRootPreparationtionName?this._oDraftMetadata.draftRootPreparationtionName.String:undefined;if(this._oDraftMetadata.draftRootPreparationtionName){this._oDraftMetadata.draftRootPreparationtionName=this._oDraftMetadata.draftRootPreparationtionName.substring(this._oDraftMetadata.draftRootPreparationtionName.lastIndexOf("/")+1);}q.extend(m,this);m.attachAfter(M.HTTPMETHOD.POST,n,this._oDraftMetadata.draftRootName);m.attachBefore(M.HTTPMETHOD.DELETE,d,this._oDraftMetadata.draftRootName);m.attachAfter(M.HTTPMETHOD.GET,this._fnDraftAdministrativeData,this._oDraftMetadata.draftRootName);}}}},_calcSemanticKeys:function(e,E){var s=[];for(var b in this._oDraftMetadata.annotations){if(b.lastIndexOf(E[e].type)>-1){s=this._oDraftMetadata.annotations[b][this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_SEMANTICKEY]||[];break;}}var S=[];var c;for(var i=0;i<s.length;i++){c=s[i];for(var k in c){S.push(c[k]);}}return S;},_prepareDraftMetadata:function(e){var t=this;var M=sap.ui.require("sap/ui/core/util/MockServer");this._oDraftMetadata.draftNodes=[];this._oDraftMetadata.draftRootKey=e[this._oDraftMetadata.draftRootName].keys.filter(function(x){return t._calcSemanticKeys(t._oDraftMetadata.draftRootName,e).indexOf(x)<0;})[0];var A=t._oDraftMetadata.annotations;var E=A.EntityContainer[Object.keys(A.EntityContainer)[0]];for(var s in E){var o=E[s];if(o[t._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTNODE]){this._oDraftMetadata.draftNodes.push(s);}}for(var j=0;j<this._oDraftMetadata.draftNodes.length;j++){this.attachAfter(M.HTTPMETHOD.GET,this._fnDraftAdministrativeData,this._oDraftMetadata.draftNodes[j]);}},_fnDraftAdministrativeData:function(e){var E={};var d=e.getParameter("oFilteredData");if(!d){E=e.getParameter("oEntry");if(E.IsActiveEntity&&!E.HasDraftEntity){E[this._oConstants.DRAFT_ADMINISTRATIVE_DATA]=null;}}else{if(d.results){d=d.results;}else{if(a(d)){d=null;return;}}for(var i=0;i<d.length;i++){E=d[i];if(E.IsActiveEntity&&!E.HasDraftEntity){E[this._oConstants.DRAFT_ADMINISTRATIVE_DATA]=null;}}}},_handleDraftArtifacts:function(e){var t=this;var m=this._oMockdata;var d=m[this._oDraftMetadata.draftRootName];var g=function(c,C){return c.filter(function(x){return C.indexOf(x)<0;})[0];};if(d.length===100){for(var i=0;i<d.length;i++){var E=d[i];if(i<25){E.IsActiveEntity=true;E.HasActiveEntity=false;E.HasDraftEntity=false;E[this._oDraftMetadata.draftRootKey]=this._oConstants.EMPTY_GUID;if(E[this._oConstants.DRAFT_ADMINISTRATIVE_DATA_UUID]){E[this._oConstants.DRAFT_ADMINISTRATIVE_DATA_UUID]=null;}var D=[];var s=[];for(var j=0;j<this._oDraftMetadata.draftNodes.length;j++){s=this._calcSemanticKeys(this._oDraftMetadata.draftNodes[j],e);D=m[this._oDraftMetadata.draftNodes[j]];var o=e[this._oDraftMetadata.draftRootName];for(var n in o.navprops){var N=o.navprops[n];if(N.to.entitySet===this._oDraftMetadata.draftNodes[j]){var p=N.from.propRef.length;for(var k=0;k<p;k++){D[i][N.to.propRef[k]]=E[N.from.propRef[k]];}}}D[i].IsActiveEntity=true;D[i].HasActiveEntity=false;D[i].HasDraftEntity=false;D[i][this._oDraftMetadata.draftRootKey]=this._oConstants.EMPTY_GUID;if(D[i][this._oConstants.DRAFT_ADMINISTRATIVE_DATA_UUID]){D[i][this._oConstants.DRAFT_ADMINISTRATIVE_DATA_UUID]=null;}var b=g(e[this._oDraftMetadata.draftNodes[j]].keys,s);D[i][b]=this._oConstants.EMPTY_GUID;}}else if(i<50){E.IsActiveEntity=false;E.HasActiveEntity=false;E.HasDraftEntity=false;D=[];s=[];for(var j=0;j<this._oDraftMetadata.draftNodes.length;j++){s=this._calcSemanticKeys(this._oDraftMetadata.draftNodes[j],e);D=m[this._oDraftMetadata.draftNodes[j]];var o=e[this._oDraftMetadata.draftRootName];for(var n in o.navprops){var N=o.navprops[n];if(N.to.entitySet===this._oDraftMetadata.draftNodes[j]){var p=N.from.propRef.length;for(var k=0;k<p;k++){D[i][N.to.propRef[k]]=E[N.from.propRef[k]];}}}D[i].IsActiveEntity=false;D[i].HasActiveEntity=false;D[i].HasDraftEntity=false;b=g(e[this._oDraftMetadata.draftNodes[j]].keys,s);}}else if(i<75){var S=q.extend(true,{},E);E.IsActiveEntity=true;E.HasActiveEntity=false;E.HasDraftEntity=true;E[this._oDraftMetadata.draftRootKey]=this._oConstants.EMPTY_GUID;D=[];s=[];for(var j=0;j<this._oDraftMetadata.draftNodes.length;j++){s=this._calcSemanticKeys(this._oDraftMetadata.draftNodes[j],e);D=m[this._oDraftMetadata.draftNodes[j]];var o=e[this._oDraftMetadata.draftRootName];for(var n in o.navprops){var N=o.navprops[n];if(N.to.entitySet===this._oDraftMetadata.draftNodes[j]){var p=N.from.propRef.length;for(var k=0;k<p;k++){D[i][N.to.propRef[k]]=E[N.from.propRef[k]];}}}D[i].IsActiveEntity=true;D[i].HasActiveEntity=false;D[i].HasDraftEntity=true;b=g(e[this._oDraftMetadata.draftNodes[j]].keys,s);D[i][b]=this._oConstants.EMPTY_GUID;}S.IsActiveEntity=false;S.HasActiveEntity=true;S.HasDraftEntity=false;d[i+25]=S;}}}var r=this._getRootUri();q.each(e,function(c,o){q.each(m[c],function(I,f){f.__metadata=f.__metadata||{};f.__metadata.uri=r+c+"("+t._createKeysString(o,f)+")";f.__metadata.type=o.schema+"."+o.type;q.each(o.navprops,function(K){f[K]={__deferred:{uri:r+c+"("+t._createKeysString(o,f)+")/"+K}};});});});},_activate:function(e){var M=sap.ui.require("sap/ui/core/util/MockServer");var s=M._syncAjax;var r;var g=function(c,C){return c.filter(function(x){return C.indexOf(x)<0;})[0];};for(var i=0;i<this._oDraftMetadata.draftNodes.length;i++){for(var n in this._mEntitySets[this._oDraftMetadata.draftRootName].navprops){if(this._mEntitySets[this._oDraftMetadata.draftRootName].navprops[n].to.entitySet===this._oDraftMetadata.draftNodes[i]){r=s({url:e[n].__deferred.uri,dataType:"json"});if(r.success&&r.data&&r.data.d&&r.data.d.results){var N;for(var j=0;j<r.data.d.results.length;j++){N=r.data.d.results[j];N.IsActiveEntity=true;N.HasActiveEntity=false;N.HasDraftEntity=false;N[this._oDraftMetadata.draftRootKey]=this._oConstants.EMPTY_GUID;var S=this._calcSemanticKeys(this._oDraftMetadata.draftNodes[i],this._mEntitySets);var d=g(this._mEntitySets[this._oDraftMetadata.draftNodes[i]].keys,S);N[d]=this._oConstants.EMPTY_GUID;s({url:N.__metadata.uri,type:"PATCH",data:JSON.stringify(N)});}}}}}e.IsActiveEntity=true;e.HasActiveEntity=false;e.HasDraftEntity=false;e[this._oDraftMetadata.draftRootKey]=this._oConstants.EMPTY_GUID;s({url:e.__metadata.uri,type:"PATCH",data:JSON.stringify(e)});return e;},setRequests:function(r){var t=this;var M=sap.ui.require("sap/ui/core/util/MockServer");var s=M._syncAjax;r.push({method:"POST",path:new RegExp(t._oDraftMetadata.draftRootActivationName),response:function(x){var R=JSON.parse(x.requestBody);var f=[];for(var p in R){f.push(p+" eq "+R[p]);}var o=s({url:t._oDraftMetadata.mockServerRootUri+t._oDraftMetadata.draftRootName+"?$filter="+f.join(" and "),dataType:"json"});if(!o.success||!o.data.d.results[0]){x.respond(404);}var e=o.data.d.results[0];if(e.IsActiveEntity){x.respond(400);}if(e.HasActiveEntity){var S=e.SiblingEntity.__deferred.uri;o=s({url:S,dataType:"json"});if(o.success&&o.data&&o.data.d.__metadata){var b=o.data.d;o=s({url:b.__metadata.uri,type:"DELETE"});}}e=t._activate(e);x.respondJSON(200,{},JSON.stringify({d:e}));return true;}});if(t._oDraftMetadata.draftRootEditName){r.push({method:"POST",path:new RegExp(t._oDraftMetadata.draftRootEditName+"(\\?(.*))?"),response:function(x,u){var f=[];var R=JSON.parse(x.requestBody);if(R&&!a(R)){for(var p in R){f.push(p+" eq "+R[p]);}}else{var U=decodeURIComponent(u).replace("?","&").split("&");for(var b in U){var P=U[b];var c=new RegExp("(.*)=(.*)");var d;if(P){d=c.exec(P);f.push(d[1]+" eq "+d[2]);}}}var o=s({url:t._oDraftMetadata.mockServerRootUri+t._oDraftMetadata.draftRootName+"?$filter="+f.join(" and "),dataType:"json"});if(!o.success||!o.data.d.results[0]){x.respond(404);}var e=o.data.d.results[0];if(!e.IsActiveEntity||e.HasDraftEntity){x.respond(400);}var D=q.extend(true,{},e);D.IsActiveEntity=false;D.HasActiveEntity=true;D.HasDraftEntity=false;D[t._oDraftMetadata.draftRootKey]=t._generatePropertyValue(t._oDraftMetadata.draftRootKey,"Guid");var g=t._getRootUri();var E=t._mEntitySets[t._oDraftMetadata.draftRootName];D.__metadata=D.__metadata||{};D.__metadata.uri=g+t._oDraftMetadata.draftRootName+"("+t._createKeysString(E,D)+")";D.__metadata.type=E.schema+"."+E.type;q.each(E.navprops,function(k){D[k]={__deferred:{uri:g+t._oDraftMetadata.draftRootName+"("+t._createKeysString(E,D)+")/"+k}};});t._oMockdata[t._oDraftMetadata.draftRootName].push(D);o=s({url:e.__metadata.uri,type:"PATCH",data:JSON.stringify({HasDraftEntity:true})});x.respondJSON(200,{},JSON.stringify({d:D}));return true;}});}if(t._oDraftMetadata.draftRootValidationName){r.push({method:"GET",path:new RegExp(t._oDraftMetadata.draftRootValidationName+"(\\?(.*))?"),response:function(x,u){var v=t._oDraftMetadata.draftRootValidationName;t.fireEvent(M.HTTPMETHOD.GET+v+":before",{oXhr:x,sUrlParams:u});t.fireEvent(M.HTTPMETHOD.GET+":before",{oXhr:x,sUrlParams:u});var R={d:{}};R.d[v]={"__metadata":{"type":"ValidationResult"},"IsValid":true};t.fireEvent(M.HTTPMETHOD.GET+v+":after",{oXhr:x,oResult:R});t.fireEvent(M.HTTPMETHOD.GET+":after",{oXhr:x,oResult:R});x.respondJSON(200,{},JSON.stringify(R));return true;}});}if(t._oDraftMetadata.draftRootPreparationtionName){r.push({method:"POST",path:new RegExp(t._oDraftMetadata.draftRootPreparationtionName),response:function(x){t.fireEvent(M.HTTPMETHOD.POST+t._oDraftMetadata.draftRootPreparationtionName+":before",{oXhr:x});t.fireEvent(M.HTTPMETHOD.POST+":before",{oXhr:x});var R=JSON.parse(x.requestBody);var f=[];for(var p in R){f.push(p+" eq "+R[p]);}var o=s({url:t._oDraftMetadata.mockServerRootUri+t._oDraftMetadata.draftRootName+"?$filter="+f.join(" and "),dataType:"json"});if(!o.success||!o.data.d.results[0]){x.respond(404);}var e=o.data.d.results[0];t.fireEvent(M.HTTPMETHOD.POST+t._oDraftMetadata.draftRootPreparationtionName+":after",{oXhr:x,oEntry:e});t.fireEvent(M.HTTPMETHOD.POST+":after",{oXhr:x,oEntry:e});x.respondJSON(200,{},JSON.stringify({d:e}));return true;}});}M.prototype.setRequests.apply(this,[r]);},_generateMockdata:function(e,b){var M=sap.ui.require("sap/ui/core/util/MockServer");M.prototype._generateMockdata.apply(this,[e,b]);this._handleDraftArtifacts(e);},_loadMockdata:function(e,b){var M=sap.ui.require("sap/ui/core/util/MockServer");M.prototype._loadMockdata.apply(this,[e,b]);this._handleDraftArtifacts(e);},_resolveNavigation:function(e,f,n,E){var M=sap.ui.require("sap/ui/core/util/MockServer");var b=M.prototype._resolveNavigation.apply(this,[e,f,n,E]);if(n===this._oConstants.SIBLINGENTITY_NAVIGATION){if(E&&E.IsActiveEntity){b.splice(0,1);}else{b.length>1?b.splice(1,1):b.splice(0,1);}}else if(n===this._oConstants.DRAFT_ADMINISTRATIVE_DATA){if(E){if(E.IsActiveEntity&&!E.HasDraftEntity){b[0]=null;}}else{b[0]=null;}}return b;},_findEntitySets:function(m){var M=sap.ui.require("sap/ui/core/util/MockServer");var e=M.prototype._findEntitySets.apply(this,[m]);this._prepareDraftMetadata(e);return e;},getEntitySetData:function(e){var M=sap.ui.require("sap/ui/core/util/MockServer");var E=M.prototype.getEntitySetData.apply(this,[e]);var g=function(){return E;};if(e===this._oDraftMetadata.draftRootName){this._fnDraftAdministrativeData({getParameter:g});return E;}for(var j=0;j<this._oDraftMetadata.draftNodes.length;j++){if(e===this._oDraftMetadata.draftNodes[j]){this._fnDraftAdministrativeData({getParameter:g});return E;}}return E;}};},true);
sap.ui.predefine('sap/ui/core/util/Export',['sap/ui/core/Control','./ExportRow','./File','sap/base/Log','./ExportColumn','./ExportType'],function(C,E,F,L){'use strict';
function w(f,o){if(f){return function(){return f.apply(o,arguments);};}else{return f;}}
function p(m){L.warning("Usage of deprecated jQuery Promise method: '"+m+"'. "+"Please use the standard Promise methods 'then' / 'catch' instead!","","sap.ui.core.util.Export");}
function c(P,o){var O=new Promise(P);o=o||O;var r=false,R=false;O.then(function(v){r=true;return v;},function(e){R=true;throw e;});var m={then:O.then,"catch":O["catch"]};function b(d){d.then=function(s,e){var A=[w(s,o),w(e,o)];return b(m.then.apply(d,A),o);};d["catch"]=function(f){var A=[w(f,o)];return b(m["catch"].apply(d,A),o);};[{jq:"done",es6:"then"},{jq:"fail",es6:"catch"},{jq:"always",es6:"then"}].forEach(function(e){d[e.jq]=function(){p(e.jq);var f=null;Array.prototype.concat.apply([],arguments).forEach(function(g){var W=w(g,o);var h=function(v){W.apply(this,arguments);return v;};var A=[h];if(e.jq==="always"){A.push(h);}if(!f){f=m[e.es6].apply(d,A);}else{f=f[e.es6].apply(f,A);}});return b(f,o);};});d.pipe=function(D,f){p("pipe");return d.then(D,f);};d.state=function(){p("state");if(r){return"resolved";}else if(R){return"rejected";}else{return"pending";}};return d;}return b(O);}
var a=C.extend('sap.ui.core.util.Export',{
metadata:{publicMethods:["generate","saveFile"],library:"sap.ui.core",aggregations:{exportType:{type:'sap.ui.core.util.ExportType',multiple:false},columns:{type:'sap.ui.core.util.ExportColumn',multiple:true,bindable:'bindable'},rows:{type:'sap.ui.core.util.ExportRow',multiple:true,bindable:'bindable'},_template:{type:'sap.ui.core.util.ExportRow',multiple:false,visibility:'hidden'}}},
renderer:null
});
a.getMetadata().getAggregation("rows")._doesNotRequireFactory=true;
a.prototype.init=function(){this._oPromise=null;this._fnResolvePromise=null;this._oRowBindingArgs=null;};
a.prototype.exit=function(){delete this._oPromise;delete this._fnResolvePromise;delete this._oRowBindingArgs;};
a.prototype._createRowTemplate=function(){var t=new E(this.getId()+"-row"),b=this.getColumns();for(var i=0,l=b.length;i<l;i++){var o=b[i].getTemplate();if(o){t.addCell(o.clone("col"+i));}}return t;};
a.prototype.bindAggregation=function(n,b){if(n==='rows'){this._oRowBindingArgs=arguments;return this;}return C.prototype.bindAggregation.apply(this,arguments);};
a.prototype.updateRows=function(r){if(r==='change'&&this._fnResolvePromise){var s=this.getExportType()._generate(this);this.destroyAggregation('_template');this.unbindAggregation('rows');this._fnResolvePromise(s);this._oPromise=null;this._fnResolvePromise=null;}};
a.prototype.generate=function(){var t=this;if(!this._oPromise){this._oPromise=c(function(r,b){t._fnResolvePromise=r;if(!t.hasModel()){b("Generate is not possible beause no model was set.");}else{var T=t._createRowTemplate();t.setAggregation('_template',T,true);C.prototype.bindAggregation.apply(t,t._oRowBindingArgs);if(t.getBinding("rows")){t.getBinding("rows").getContexts(0,t.getBinding("rows").getLength());}}},this);}return this._oPromise;};
a.prototype.saveFile=function(f){return this.generate().then(function(s){var e=this.getExportType();F.save(s,f||"data",e.getFileExtension(),e.getMimeType(),e.getCharset(),e.getByteOrderMark());});};
return a;});
sap.ui.predefine('sap/ui/core/util/ExportCell',['sap/ui/core/Element'],function(E){'use strict';
var a=E.extend('sap.ui.core.util.ExportCell',{metadata:{library:"sap.ui.core",properties:{content:'string'}}});
return a;});
sap.ui.predefine('sap/ui/core/util/ExportColumn',['sap/ui/base/ManagedObject','./ExportCell'],function(M){'use strict';
var E=M.extend("sap.ui.core.util.ExportColumn",{metadata:{library:"sap.ui.core",properties:{name:"string"},aggregations:{template:{type:"sap.ui.core.util.ExportCell",multiple:false}}}});
return E;});
sap.ui.predefine('sap/ui/core/util/ExportRow',['sap/ui/base/ManagedObject','./ExportCell'],function(M){'use strict';
var E=M.extend("sap.ui.core.util.ExportRow",{metadata:{library:"sap.ui.core",aggregations:{cells:{type:"sap.ui.core.util.ExportCell",multiple:true}}}});
return E;});
sap.ui.predefine('sap/ui/core/util/ExportType',['sap/ui/base/ManagedObject'],function(M){'use strict';
var E=M.extend('sap.ui.core.util.ExportType',{metadata:{library:"sap.ui.core",properties:{fileExtension:'string',mimeType:'string',charset:'string',byteOrderMark:{type:'boolean',defaultValue:undefined}}}});
E.prototype.init=function(){this._oExport=null;};
E.prototype._generate=function(e){this._oExport=e;var c=this.generate();this._oExport=null;return c;};
E.prototype.generate=function(){return'';};
E.prototype.getColumnCount=function(){if(this._oExport){return this._oExport.getColumns().length;}return 0;};
E.prototype.getRowCount=function(){if(this._oExport&&this._oExport.getBinding("rows")){return this._oExport.getBinding("rows").getLength();}return 0;};
E.prototype.columnGenerator=function(){var i=0,c=this._oExport.getColumns(),C=c.length;return{next:function(){if(i<C){var I=i;i++;return{value:{index:I,name:c[I].getName()},done:false};}else{return{value:undefined,done:true};}}};};
E.prototype.cellGenerator=function(){var i=0,r=this._oExport.getAggregation('_template'),c=r.getCells(),C=c.length;return{next:function(){if(i<C){var I=i;i++;var m={};c[I].getCustomData().forEach(function(o){m[o.getKey()]=o.getValue();});return{value:{index:I,content:c[I].getContent(),customData:m},done:false};}else{return{value:undefined,done:true};}}};};
E.prototype.rowGenerator=function(){var t=this,i=0,e=this._oExport,b=e.getBinding("rows"),B=e.getBindingInfo("rows"),c=b.getContexts(0,b.getLength()),C=c.length,r=e.getAggregation('_template');return{next:function(){if(i<C){var I=i;i++;r.setBindingContext(c[I],B.model);return{value:{index:I,cells:t.cellGenerator()},done:false};}else{return{value:undefined,done:true};}}};};
return E;});
sap.ui.predefine('sap/ui/core/util/ExportTypeCSV',['./ExportType'],function(E){'use strict';var r=/[\r\n"\t;,]/;var a=/^[=\+\-@](?![\d.,]+(?:e[\+-]?\d+)?$)/i;
var C=E.extend('sap.ui.core.util.ExportTypeCSV',{metadata:{library:"sap.ui.core",properties:{separatorChar:{type:'string',defaultValue:','}}}});
C.MAX_CELL_LENGTH=32760;
C.prototype.setSeparatorChar=function(s){var s=this.validateProperty('separatorChar',s);if(s.length>1){throw new Error("Value of property \"separatorChar\" needs to be exactly one character or empty. "+"\""+s+"\" is "+s.length+" characters long.");}return this.setProperty('separatorChar',s);};
C.prototype.init=function(){this.setProperty('fileExtension','csv',true);this.setProperty('mimeType','text/csv',true);this.setProperty('charset','utf-8',true);};
C.prototype.escapeContent=function(v){if(!v){return v;}if(v.length>C.MAX_CELL_LENGTH){v=v.slice(0,C.MAX_CELL_LENGTH);}if(a.test(v)){v="'"+v;}var c=v.indexOf(this.getSeparatorChar())>-1;if(c||r.test(v)){v=v.replace(/"/g,'""');v='"'+v+'"';}return v;};
C.prototype.generate=function(){var b=[];this.generateColumns(b);this.generateRows(b);return b.join('\r\n');};
C.prototype.generateColumns=function(b){var c=[],o=this.columnGenerator(),d;while(!(d=o.next()).done){c.push(this.escapeContent(d.value.name));}b.push(c.join(this.getSeparatorChar()));};
C.prototype.generateRows=function(b){var R=this.rowGenerator(),o;while(!(o=R.next()).done){var c=[];var d=o.value.cells,e;while(!(e=d.next()).done){c.push(this.escapeContent(e.value.content));}b.push(c.join(this.getSeparatorChar()));}};
return C;});
sap.ui.predefine('sap/ui/core/util/File',["sap/ui/thirdparty/jquery"],function(q){'use strict';var F={save:function(d,f,s,m,c,b){var a=f+'.'+s;if(typeof b==='undefined'&&c==='utf-8'&&s==='csv'){b=true;}if(b===true&&c==='utf-8'){d='\ufeff'+d;}if(window.Blob){var t='data:'+m;if(c){t+=';charset='+c;}var B=new window.Blob([d],{type:t});if(window.navigator.msSaveOrOpenBlob){window.navigator.msSaveOrOpenBlob(B,a);}else{var u=window.URL||window.webkitURL;var e=u.createObjectURL(B);var l=window.document.createElement('a');if('download'in l){var $=q(document.body);var g=q(l).attr({download:a,href:e,style:'display:none'});$.append(g);g.get(0).click();g.remove();}else{d=encodeURI(d);var w=window.open(t+","+d);w.opener=null;if(!w){throw new Error("Could not download the file, please deactivate your pop-up blocker.");}}}}}};return F;},true);
sap.ui.predefine('sap/ui/core/util/LibraryInfo',['sap/ui/base/Object',"sap/base/Log","sap/base/util/Version","sap/ui/thirdparty/jquery"],function(B,L,V,q){"use strict";
var a=B.extend("sap.ui.core.util.LibraryInfo",{
constructor:function(){B.apply(this);this._oLibInfos={};},
destroy:function(){B.prototype.destroy.apply(this,arguments);this._oLibInfos={};},
getInterface:function(){return this;}
});
a.prototype._loadLibraryMetadata=function(l,c){l=l.replace(/\//g,".");if(this._oLibInfos[l]){setTimeout(c.bind(window,this._oLibInfos[l]),0);return;}var t=this,u,s,p=/themelib_(.*)/i.exec(l),r;if(!p){s=".library";u=sap.ui.require.toUrl(l.replace(/\./g,"/"))+"/";}else{s=".theme";u=sap.ui.require.toUrl("sap/ui/core/themes/"+p[1]+"/");}r=typeof t.getResourceUrl==="function"?t.getResourceUrl(u):u;q.ajax({url:r+s,dataType:"xml",error:function(x,b,e){L.error("failed to load library details from '"+u+s+": "+b+", "+e);t._oLibInfos[l]={name:l,data:null,url:u};c(t._oLibInfos[l]);},success:function(d,S,x){t._oLibInfos[l]={name:l,data:d,url:u};c(t._oLibInfos[l]);}});};
a.prototype._getLibraryInfo=function(l,c){this._loadLibraryMetadata(l,function(d){var r={libs:[],library:d.name,libraryUrl:d.url};if(d.data){var $=q(d.data);r.vendor=$.find("vendor").text();r.copyright=$.find("copyright").text();r.version=$.find("version").text();r.documentation=$.find("documentation").text();r.releasenotes=$.find("releasenotes").attr("url");r.componentInfo=a.prototype._getLibraryComponentInfo($);}c(r);});};
a.prototype._getThirdPartyInfo=function(l,c){this._loadLibraryMetadata(l,function(d){var r={libs:[],library:d.name,libraryUrl:d.url};if(d.data){var $=q(d.data).find("appData").find("thirdparty").children();$.each(function(i,o){if(o.nodeName==="lib"){var b=q(o);var e=b.children("license");r.libs.push({displayName:b.attr("displayName"),homepage:b.attr("homepage"),license:{url:e.attr("url"),type:e.attr("type"),file:d.url+e.attr("file")}});}});}c(r);});};
a.prototype._getDocuIndex=function(l,c){var t=this;this._loadLibraryMetadata(l,function(d){var b=d.name,f=d.url,r={"docu":{},library:b,libraryUrl:f};if(!d.data){c(r);return;}var D=q(d.data).find("appData").find("documentation");var u=D.attr("indexUrl");if(!u){c(r);return;}if(D.attr("resolve")=="lib"){u=d.url+u;}if(typeof t.getResourceUrl==="function"){u=t.getResourceUrl(u);}q.ajax({url:u,dataType:"json",error:function(x,s,e){L.error("failed to load library docu from '"+u+"': "+s+", "+e);c(r);},success:function(d,s,x){d.library=b;d.libraryUrl=f;c(d);}});});};
a.prototype._getReleaseNotes=function(l,v,c){var t=this;this._loadLibraryMetadata(l,function(d){if(!d.data){c({});return;}var i=(v.split(".").length===3)&&!(/-SNAPSHOT/.test(v));var o=V(v);var m=o.getMajor();var M=o.getMinor();var p=o.getPatch();var D=q(d.data).find("appData").find("releasenotes");var u=D.attr("url");var r=typeof t.getResourceUrl==="function";if(!u){L.warning("failed to load release notes for library "+l);c({});return;}if(o.getSuffix()==="-SNAPSHOT"){if(M%2!=0){M=(M+1);p=0;}v=m+"."+M+"."+p;}var b=r?t.getResourceUrl(""):window.location.href,f=/\/\d.\d{1,2}.\d{1,2}\//;if(D.attr("resolve")=="lib"){if(f.test(b)||i===false){u=d.url+u;}else{u="{major}.{minor}.{patch}/"+d.url+u;}}u=u.replace(/\{major\}/g,m);u=u.replace(/\{minor\}/g,M);u=u.replace(/\{patch\}/g,p);if(r){u=t.getResourceUrl(u);}q.ajax({url:u,dataType:"json",error:function(x,s,e){if(s==="parsererror"){L.error("failed to parse release notes for library '"+l+", "+e);}else{L.warning("failed to load release notes for library '"+l+", "+e);}c({});},success:function(d,s,x){c(d,v);}});});};
a.prototype._getLibraryComponentInfo=function(d){var A={};var c=[];var D="";d.find("ownership > component").each(function(b,C){if(C.childElementCount===0){D=C.textContent;}else{var v=C.getElementsByTagName("name");if(v&&v.length>0){v=v[0].textContent;var e=C.getElementsByTagName("module");if(v&&e&&e.length>0){var m=[];for(var i=0;i<e.length;i++){var M=e[i].textContent.replace(/\//g,".");if(M){m.push(M);}}if(m.length>0){c.push({"component":v,"modules":m});}}}}});A["defaultComponent"]=D;if(c&&c.length>0){A["specialCases"]=c;}return A;};
a.prototype._getActualComponent=function(c,m){function b(m,p){m=m.toLowerCase();p=p.toLowerCase();return(m===p||p.match(/\*$/)&&m.indexOf(p.slice(0,-1))===0||p.match(/\.\*$/)&&m===p.slice(0,-2));}if(m){for(var k in c){if(!c[k]){L.error("No library information deployed for "+k);continue;}var C;if(m.indexOf(k)===0){C=c[k].defaultComponent;}var s=c[k].specialCases;if(s){for(var i=0;i<s.length;i++){var S=s[i].modules;for(var j=0;j<S.length;j++){if(b(m,S[j])){C=s[i].component;}}}}if(C){return C;}}}};
a.prototype._getDefaultComponent=function(l){return l&&l.componentInfo&&l.componentInfo.defaultComponent;};
return a;});
sap.ui.predefine('sap/ui/core/util/MockServer',['sap/base/Log','sap/base/util/isEmptyObject','sap/ui/base/ManagedObject','sap/ui/core/util/MockServerAnnotationsHandler','sap/ui/core/util/DraftEnabledMockServer','sap/ui/thirdparty/jquery','sap/ui/thirdparty/sinon'],function(L,d,M,f,D,q,g){"use strict";
var h=M.extend("sap.ui.core.util.MockServer",{
constructor:function(i,s,S){M.apply(this,arguments);h._aServers.push(this);},
metadata:{library:"sap.ui.core",properties:{rootUri:"string",recordRequests:{type:"boolean",defaultValue:true},requests:{type:"object[]",defaultValue:[]}}},
_oServer:null,
_aFilter:null,
_oMockdata:null,
_oMetadata:null,
_sMetadataUrl:null,
_sMockdataBaseUrl:null,
_mEntitySets:null,
_oErrorMessages:{INVALID_SYSTEM_QUERY_OPTION_VALUE:"Invalid system query options value",IS_NOT_A_VALID_SYSTEM_QUERY_OPTION:"## is not a valid system query option",URI_VIOLATING_CONSTRUCTION_RULES:"The URI is violating the construction rules defined in the Data Services specification",UNSUPPORTED_FORMAT_VALUE:"Unsupported format value. Only json format is supported",MALFORMED_SYNTAX:"The Data Services Request could not be understood due to malformed syntax",RESOURCE_NOT_FOUND:"Resource not found",INVALID_SORTORDER_DETECTED:"Invalid sortorder ## detected",PROPERTY_NOT_FOUND:"Property ## not found",INVALID_FILTER_QUERY_STATEMENT:"Invalid filter query statement",INVALID_FILTER_OPERATOR:"Invalid $filter operator ##",RESOURCE_NOT_FOUND_FOR_SEGMENT:"Resource not found for the segment ##",MALFORMED_URI_LITERAL_SYNTAX_IN_KEY:"Malformed URI literal syntax in key ##",INVALID_KEY_NAME:"Invalid key name in key predicate. Expected name is ##",INVALID_KEY_PREDICATE_QUANTITY:"Invalid key predicate. The quantity of provided keys does not match the expected value",INVALID_KEY_TYPE:"Invalid key predicate. The key literal for key property ## does not match its type."},
_oRandomSeed:{}
});
h.prototype._getPseudoRandomNumber=function(t){if(!this._oRandomSeed){this._oRandomSeed={};}if(!this._oRandomSeed.hasOwnProperty(t)){this._oRandomSeed[t]=0;}this._oRandomSeed[t]=(this._oRandomSeed[t]+11)*25214903917%281474976710655;return this._oRandomSeed[t]/281474976710655;};
h.prototype._resetPseudoRandomNumberGenerator=function(){this._oRandomSeed={};};
h.prototype.start=function(){this._oServer=h._getInstance();this._aFilters=[];var r=this.getRequests();var t=this;r.forEach(function(R){var a;if(t.getRecordRequests()===false&&R.response){a=function(){R.response.apply(this,arguments);t._oServer.requests=[];};}else{a=R.response;}t._addRequestHandler(R.method,R.path,a);});};
h.prototype.stop=function(){if(this.isStarted()){this._removeAllRequestHandlers();this._removeAllFilters();this._oServer=null;}};
h.prototype.attachBefore=function(H,c,e){e=e?e:"";this.attachEvent(H+e+":before",c);};
h.prototype.attachAfter=function(H,c,e){e=e?e:"";this.attachEvent(H+e+":after",c);};
h.prototype.detachBefore=function(H,c,e){e=e?e:"";this.detachEvent(H+e+":before",c);};
h.prototype.detachAfter=function(H,c,e){e=e?e:"";this.detachEvent(H+e+":after",c);};
h.prototype.isStarted=function(){return!!this._oServer;};
h.prototype.getEntitySetData=function(e){var t=this;var c;if(this._oMockdata&&this._oMockdata.hasOwnProperty(e)){c=q.extend(true,[],t._oMockdata[e]);}else{L.error("Unrecognized EntitySet name: "+e);}return c;};
h.prototype.setEntitySetData=function(e,a){if(this._oMockdata&&this._oMockdata.hasOwnProperty(e)){this._oMockdata[e]=a;}else{L.error("Unrecognized EntitySet name: "+e);}};
h.prototype._applyQueryOnCollection=function(F,Q,e,u){var a=Q.split('=');var o=a[1];if(o===""){return;}if(o.lastIndexOf(',')===o.length-1){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.URI_VIOLATING_CONSTRUCTION_RULES);}switch(a[0]){case"$top":if(!(new RegExp(/^\d+$/).test(o))){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.INVALID_SYSTEM_QUERY_OPTION_VALUE);}F.results=F.results.slice(0,o);break;case"$skip":if(!(new RegExp(/^\d+$/).test(o))){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.INVALID_SYSTEM_QUERY_OPTION_VALUE);}F.results=F.results.slice(o,F.results.length);break;case"$orderby":F.results=this._getOdataQueryOrderby(F.results,o,e);break;case"$filter":F.results=this._recursiveOdataQueryFilter(F.results,o);break;case"search-focus":break;case"search":var s="";for(var i=0;i<u.length;i++){if(u[i].indexOf("search-focus")!=-1){s=u[i].split('=')[1];break;}}F.results=this._recursiveOdataQuerySearch(F.results,o,s,e);break;case"$select":F.results=this._getOdataQuerySelect(F.results,o,e);break;case"$inlinecount":var c=this._getOdataInlineCount(F.results,o);if(c){F.__count=c;}break;case"$expand":F.results=this._getOdataQueryExpand(F.results,o,e);break;case"$format":F.results=this._getOdataQueryFormat(F.results,o);break;default:this._logAndThrowMockServerCustomError(400,this._oErrorMessages.IS_NOT_A_VALID_SYSTEM_QUERY_OPTION,a[0]);}};
h.prototype._applyQueryOnEntry=function(e,Q,E){var a=Q.split('=');var o=a[1];if(o===""){return;}if(o.lastIndexOf(',')===o.length-1){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.URI_VIOLATING_CONSTRUCTION_RULES);}switch(a[0]){case"$filter":return this._recursiveOdataQueryFilter([e],o)[0];case"$select":return this._getOdataQuerySelect([e],o,E)[0];case"$expand":return this._getOdataQueryExpand([e],o,E)[0];case"$format":return this._getOdataQueryFormat([e],o);default:this._logAndThrowMockServerCustomError(400,this._oErrorMessages.IS_NOT_A_VALID_SYSTEM_QUERY_OPTION,a[0]);}};
h.prototype._getOdataQueryOrderby=function(c,o,e){var p=o.split(',');var t=this;q.each(p,function(i,P){p[i]=t._trim(P);});var C=function r(a,b){for(var i=0;i<p.length;i++){var s=p[i].split(' ');var S=1;if(s.length>1){switch(s[1]){case'asc':S=1;break;case'desc':S=-1;break;default:t._logAndThrowMockServerCustomError(400,t._oErrorMessages.INVALID_SORTORDER_DETECTED,s[1]);}}var P,j;var k=s[0].indexOf("/");if(k!==-1){P=s[0].substring(k+1);j=s[0].substring(0,k);if(!a[j].hasOwnProperty(P)){var E=false;var T=[];if(j){var m=t._mEntitySets[e].navprops[j].to.entitySet;T=t._mEntityTypes[t._mEntitySets[m].type].properties;for(var i=0;i<T.length;i++){if(T[i].name===P){E=true;break;}}}if(!E){t._logAndThrowMockServerCustomError(400,t._oErrorMessages.PROPERTY_NOT_FOUND,P);}}if(a[j][P]<b[j][P]){return-1*S;}if(a[j][P]>b[j][P]){return 1*S;}}else{P=s[0];if(!a.hasOwnProperty(P)){t._logAndThrowMockServerCustomError(400,t._oErrorMessages.PROPERTY_NOT_FOUND,P);}if(a[P]<b[P]){return-1*S;}if(a[P]>b[P]){return 1*S;}}}return 0;};return c.sort(C);};
h.prototype._arrayUnique=function(b){var a=b.concat();for(var i=0;i<a.length;++i){for(var j=i+1;j<a.length;++j){if(a[i]===a[j]){a.splice(j--,1);}}}return a;};
h.prototype._getBracketIndices=function(s){var S=[];var r=0;var i,e=0;for(var c=0;c<s.length;c++){if(s[c]==='('){if(/[substringof|endswith|startswith]$/.test(s.substring(0,c))){++r;}else{S.push(s[c]);if(i===undefined){i=c;}}}else if(s[c]===')'){if(!r){S.pop();e=c;if(S.length===0){return{start:i,end:e};}}else{--r;}}}return{start:i,end:e};};
h.prototype._recursiveOdataQueryFilter=function(a,o){var I=this._getBracketIndices(o);if(I.start===0&&I.end===o.length-1){o=this._trim(o.substring(I.start+1,I.end));return this._recursiveOdataQueryFilter(a,o);}var r=/([^substringof|endswith|startswith]|^)\((.*)\)/,s,p;var O;if(r.test(o)){var b=o.substring(I.start,I.end+1);var c=new RegExp("(.*) +(or|and) +("+this._trim(this._escapeStringForRegExp(b))+".*)");if(I.start===0){c=new RegExp("("+this._trim(this._escapeStringForRegExp(b))+") +(or|and) +(.*)");}var e=c.exec(o);if(e===null){return this._getOdataQueryFilter(a,this._trim(o));}var E=e[1];O=e[2];var j=e[3];var S=this._recursiveOdataQueryFilter(a,E);if(O==="or"){s=this._recursiveOdataQueryFilter(a,j);return this._arrayUnique(S.concat(s));}if(O==="and"){return this._recursiveOdataQueryFilter(S,j);}}else{p=o.split(/ +and | or +/);if(p.length===1){return this._getOdataQueryFilter(a,this._trim(o));}var R=this._recursiveOdataQueryFilter(a,p[0]);var k;for(var i=1;i<p.length;i++){k=new RegExp(this._trim(this._escapeStringForRegExp(p[i-1]))+" +(and|or) +"+this._trim(this._escapeStringForRegExp(p[i])));O=k.exec(o)[1];if(O==="or"){s=this._recursiveOdataQueryFilter(a,p[i]);R=this._arrayUnique(R.concat(s));}if(O==="and"){R=this._recursiveOdataQueryFilter(R,p[i]);}}return R;}};
h.prototype._getOdataQueryFilter=function(a,o){if(a.length===0){return a;}var r=new RegExp("(.*) (eq|ne|gt|lt|le|ge) (.*)");var b=new RegExp("(endswith|startswith|substringof)\\((.*)");var O=null;var c=r.exec(o);if(c){O=c[2];}else{c=b.exec(o);if(c){O=c[1];}else{this._logAndThrowMockServerCustomError(400,this._oErrorMessages.INVALID_FILTER_QUERY_STATEMENT);}}var t=this;var G=function(v,V,p,s){var c,e,P;if(!v){c=r.exec(o);e=t._trim(c[V+1]);P=t._trim(c[p+1]);}else{var i=new RegExp("(substringof|startswith|endswith)\\(([^\\)]*),(.*)\\)");c=i.exec(o);e=t._trim(c[V+2]);P=t._trim(c[p+2]);}if(/^\(.+\)$/.test(e)){e=e.replace(/^\(|\)$/g,"");}var T=e[e.length-1];if(T==="M"||T==="m"||T==="L"||T==="f"){e=e.substring(0,e.length-1);}if(e.indexOf("datetime")===0){e=t._getJsonDate(e);}else if(e.indexOf("guid")===0){e=e.substring(5,e.length-1);}else if(e==="true"){e=true;}else if(e==="false"){e=false;}else if(t._isValidNumber(e)){e=parseFloat(e);}else if((e.charAt(0)==="'")&&(e.charAt(e.length-1)==="'")){e=e.substr(1,e.length-2);}var C=P.indexOf("/");if(C!==-1){var j=P.substring(C+1);var k=P.substring(0,C);if(a[0][k]){if(!a[0][k].hasOwnProperty(j)){var E=t._oErrorMessages.PROPERTY_NOT_FOUND.replace("##","'"+j+"'");L.error("MockServer: navigation property '"+k+"' was not expanded, so "+E);return a;}}else{t._logAndThrowMockServerCustomError(400,t._oErrorMessages.PROPERTY_NOT_FOUND,P);}return s(P,e,k,j);}else{if(!a[0].hasOwnProperty(P)){t._logAndThrowMockServerCustomError(400,t._oErrorMessages.PROPERTY_NOT_FOUND,P);}return s(P,e);}};switch(O){case"substringof":return G(true,0,1,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(typeof m[C][P]==="string"&&m[C][P].indexOf(v)!==-1);}return(typeof m[p]==="string"&&m[p].indexOf(v)!==-1);});});case"startswith":return G(true,1,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(typeof m[C][P]==="string"&&m[C][P].indexOf(v)===0);}return(typeof m[p]==="string"&&m[p].indexOf(v)===0);});});case"endswith":return G(true,1,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(typeof m[C][P]==="string"&&m[C][P].indexOf(v)===(m[C][P].length-v.length));}return(typeof m[p]==="string"&&m[p].indexOf(v)===(m[p].length-v.length));});});case"eq":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]===v);}return(m[p]===v);});});case"ne":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]!==v);}return(m[p]!==v);});});case"gt":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]>v);}return(m[p]>v);});});case"lt":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]<v);}return(m[p]<v);});});case"ge":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]>=v);}return(m[p]>=v);});});case"le":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]<=v);}return(m[p]<=v);});});default:this._logAndThrowMockServerCustomError(400,t._oErrorMessages.INVALID_FILTER_OPERATOR,O);}};
h.prototype._recursiveOdataQuerySearch=function(a,o,O,e){var F="";if(O==""||O==undefined){for(var i=0;i<this._mEntitySets[e].keys.length;i++){if(i!=0){F=F+" or ";}F=F+"startswith("+this._mEntitySets[e].keys[i]+",'"+o+"')";}}else{F="substringof('"+o+"',"+O+")";}return this._recursiveOdataQueryFilter(a,F);};
h.prototype._getOdataQuerySelect=function(a,o,e){var t=this;var p,c;var P=o.split(',');var s=[];var b;var k=a[0]?a[0][P[0].split('/')[0]]:null;if(!(k!=null&&k.results&&k.results.length>0)){var C=function(P,r,b,u){var v={};q.each(P,function(i,j){var w=j.indexOf("/");if(w!==-1){p=j.substring(w+1);c=j.substring(0,w);if(v[c]){v[c].push(p);}else{v[c]=[p];}}});q.each(Object.keys(v),function(i,j){if(!b[j]){b[j]={};}b[j]=C(v[j],r[j],b[j],j);});if(r.results){var F=[];q.each(r.results,function(i,R){var w={};q.each(P,function(j,x){w[x]=R[x];});F.push(w);});if(b){b.results=F;}}else{if(r["__metadata"]){b["__metadata"]=r["__metadata"];}q.each(P,function(i,j){var w=j.indexOf("/");if(w===-1){if(r&&!r.hasOwnProperty(j)){var E=false;var T=[];if(u){var x=t._mEntitySets[e].navprops[u].to.entitySet;T=t._mEntityTypes[t._mEntitySets[x].type].properties;for(var i=0;i<T.length;i++){if(T[i].name===j){E=true;break;}}}if(!E){t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND_FOR_SEGMENT,j);}}b[j]=r[j];}});}return b;};if(P.indexOf("*")!==-1){return a;}q.each(P,function(i,j){P[i]=t._trim(j);});q.each(a,function(i,j){b={};s.push(C(P,j,b));});}else{var m=function(i,j,r){var u={};r=r||'';if(typeof i!=='object'){return i;}if(typeof i.slice==='function'){return i.map(function(v,w){return m(v,j,r);});}if(i.__metadata!==undefined&&r.length===0){u.__metadata=i.__metadata;}j.filter(function(v){return(v+'/').indexOf(r)===0;}).forEach(function(v,_,w){var x=v.substr(r.length).split('/')[0];if(i[x]!==undefined){u[x]=m(i[x],w,r+x+'/');}});if(i.results!==undefined){u.results=m(i.results,j,r);}return u;};s=m(a,P);}return s;};
h.prototype._getOdataInlineCount=function(a,o){var p=o.split(',');if(p.length!==1||(p[0]!=='none'&&p[0]!=='allpages')){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.INVALID_SYSTEM_QUERY_OPTION_VALUE);}if(p[0]==='none'){return;}return a.length;};
h.prototype._getOdataQueryFormat=function(a,o){if(o!=='json'){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.UNSUPPORTED_FORMAT_VALUE);}return a;};
h.prototype._getOdataQueryExpand=function(a,o,e){var t=this;var N=o.split(',');q.each(N,function(i,p){N[i]=t._trim(p);});var E=t._mEntitySets[e].navprops;q.each(a,function(i,r){q.each(N,function(i,s){var b=s.split("/");var c=b[0];if(!r[c]){t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND_FOR_SEGMENT,c);}var j=r[c].results||r[c];if(!j||j.__deferred){j=q.extend(true,[],t._resolveNavigation(e,r,c,r));}else if(!Array.isArray(j)){j=[j];}if(j&&b.length>1){var R=b.splice(1,b.length).join("/");j=t._getOdataQueryExpand(j,R,E[c].to.entitySet);}if(E[c].to.multiplicity==="*"){r[c]={results:j};}else{r[c]=j[0]?j[0]:{};}});});return a;};
h.prototype._refreshData=function(){var m=this._loadMetadata(this._sMetadataString);if(!m){return;}this._mEntitySets=this._findEntitySets(this._oMetadata);this._mEntityTypes=this._findEntityTypes(this._oMetadata);if(!this._sMockdataBaseUrl){this._generateMockdata(this._mEntitySets,this._oMetadata);}else{if(!this._sMockdataBaseUrl.endsWith("/")&&!this._sMockdataBaseUrl.endsWith(".json")){this._sMockdataBaseUrl+="/";}this._loadMockdata(this._mEntitySets,this._sMockdataBaseUrl);}};
h.prototype._getRootUri=function(){var u=this.getRootUri();u=u&&/([^?#]*)([?#].*)?/.exec(u)[1];return u;};
h.prototype._loadMetadata=function(m){var m;m=m.trim();if(m.substring(0,1)!=="<"){m=l({url:m,dataType:"text"}).data;if(!m){L.error("MockServer: The metadata for url \""+m+"\" could not be found!");}}this._sMetadata=m;try{this._oMetadata=q.parseXML(m);}catch(e){L.error("MockServer: Invalid metadata XML! Reason: "+e);}return this._oMetadata;};
h.prototype._findEntitySets=function(m){var e={};var p=q(m).find("Principal");var o=q(m).find("Dependent");q(m).find("EntitySet").each(function(i,E){var $=q(E);var a=/((.*)\.)?(.*)/.exec($.attr("EntityType"));e[$.attr("Name")]={"name":$.attr("Name"),"schema":a[2],"type":a[3],"keys":[],"keysType":{},"navprops":{}};});var r=function(R,a,A,F){var E=q(A).find("End[Role='"+R+"']").attr("EntitySet");var s=q(a).find("End[Role='"+R+"']").attr("Multiplicity");var P=[];var c=q(a).find("ReferentialConstraint > [Role='"+R+"']");if(c&&c.length>0){q(c[0]).children("PropertyRef").each(function(i,j){P.push(q(j).attr("Name"));});}else{var b=(F)?p:o;q(b).each(function(i,j){if(R===(q(j).attr("Role"))){q(j).children("PropertyRef").each(function(i,k){P.push(q(k).attr("Name"));});return false;}});}return{"role":R,"entitySet":E,"propRef":P,"multiplicity":s};};q.each(e,function(E,a){var $=q(m).find("EntityType[Name='"+a.type+"']");var k=q($).find("PropertyRef");q.each(k,function(i,P){var K=q(P).attr("Name");a.keys.push(K);a.keysType[K]=q($).find("Property[Name='"+K+"']").attr("Type");});var N=q(m).find("EntityType[Name='"+a.type+"'] NavigationProperty");q.each(N,function(i,b){var c=q(b);var R=c.attr("Relationship").split(".");var A=q(m).find("AssociationSet[Association = '"+R.join(".")+"']");var s=R.pop();var j=q(m).find("Association[Name = '"+s+"']");a.navprops[c.attr("Name")]={"name":c.attr("Name"),"from":r(c.attr("FromRole"),j,A,true),"to":r(c.attr("ToRole"),j,A,false)};});});return e;};
h.prototype._findEntityTypes=function(m){var e={};q(m).find("EntityType").each(function(i,E){var $=q(E);e[$.attr("Name")]={"name":$.attr("Name"),"properties":[],"keys":[]};$.find("Property").each(function(i,p){var P=q(p);var t=P.attr("Type");e[$.attr("Name")].properties.push({"schema":t.substring(0,t.lastIndexOf(".")),"type":t.substring(t.lastIndexOf(".")+1),"name":P.attr("Name"),"precision":P.attr("Precision"),"scale":P.attr("Scale")});});$.find("PropertyRef").each(function(i,k){var K=q(k);var p=K.attr("Name");e[$.attr("Name")].keys.push(p);});});return e;};
h.prototype._findComplexTypes=function(m){var c={};q(m).find("ComplexType").each(function(i,C){var $=q(C);c[$.attr("Name")]={"name":$.attr("Name"),"properties":[]};$.find("Property").each(function(i,p){var P=q(p);var t=P.attr("Type");c[$.attr("Name")].properties.push({"schema":t.substring(0,t.lastIndexOf(".")),"type":t.substring(t.lastIndexOf(".")+1),"name":P.attr("Name"),"precision":P.attr("Precision"),"scale":P.attr("Scale")});});});return c;};
h.prototype._createKeysString=function(e,E){var t=this;var k="";if(E){q.each(e.keys,function(i,K){if(k){k+=",";}var o=E[K];if(e.keysType[K]==="Edm.String"){o=encodeURIComponent("'"+o+"'");}else if(e.keysType[K]==="Edm.DateTime"){o=t._getDateTime(o);o=encodeURIComponent(o);}else if(e.keysType[K]==="Edm.Guid"){o="guid'"+o+"'";}if(e.keys.length===1){k+=o;return k;}k+=K+"="+o;});}return k;};
h.prototype._loadMockdata=function(e,b){var t=this,m={};this._oMockdata={};var a=function(u,o){var r=l({url:u,dataType:"json"});if(r.success){if(r.data.d){if(r.data.d.results){m[o.name]=r.data.d.results;}else{L.error("The mock data format for entity set \""+o.name+"\" invalid");}}else{if(Array.isArray(r.data)){m[o.name]=r.data;}else{L.error("The mock data for entity set \""+o.name+"\" could not be loaded due to wrong format!");return false;}}return true;}else{if(r.status==="parsererror"){L.error("The mock data for entity set \""+o.name+"\" could not be loaded due to a parsing error!");}return false;}};if(b.endsWith(".json")){var r=l({url:b,dataType:"json"});if(r.success){m=r.data;}else{L.warning("The mock data for all the entity types could not be found at \""+b+"\"!");}}else{var E={};if(t._aEntitySetsNames&&t._aEntitySetsNames.length>0){var s;for(var i=0;i<t._aEntitySetsNames.length;i++){s=t._aEntitySetsNames[i];if(e[s]){E[s]=e[s];}}}else{E=e;}q.each(E,function(c,o){if(!m[o.type]||!m[o.name]){var j=b+o.name+".json";if(!a(j,o)){L.warning("The mock data for entity set \""+o.name+"\" could not be found at \""+b+"\"!");var k=b+o.type+".json";if(!a(k,o)){L.warning("The mock data for entity type \""+o.type+"\" could not be found at \""+b+"\"!");if(t._bGenerateMissingMockData){var p={};p[o.name]=o;m[o.type]=t._generateODataMockdataForEntitySet(p,t._oMetadata)[o.name];}}}}});}q.each(e,function(c,o){t._oMockdata[c]=[];if(m[o.name]){q.each(m[o.name],function(I,j){t._oMockdata[c].push(q.extend(true,{},j));});}else if(m[o.type]){q.each(m[o.type],function(I,j){t._oMockdata[c].push(q.extend(true,{},j));});}});q.each(e,function(c,o){if(t._oMockdata[c].length>0){t._enhanceWithMetadata(o,t._oMockdata[c]);}});return this._oMockdata;};
h.prototype._enhanceWithMetadata=function(e,m){if(m){var t=this,r=this._getRootUri(),E=e&&e.name;q.each(m,function(i,o){o.__metadata=o.__metadata||{};o.__metadata.id=r+E+"("+t._createKeysString(e,o)+")";o.__metadata.type=e.schema+"."+e.type;o.__metadata.uri=r+E+"("+t._createKeysString(e,o)+")";q.each(e.navprops,function(k,N){if(o[k]&&!d(o[k])&&!o[k]["__deferred"]){t._oMockdata[N.to.entitySet]=t._oMockdata[N.to.entitySet].concat(o[k]);}o[k]={__deferred:{uri:r+E+"("+t._createKeysString(e,o)+")/"+k}};});});}};
h.prototype._isRequestedKeysValid=function(e,r){if(r.length===1){var s=r[0].split('=');if(this._trim(s[0])!==e.keys[0]){r=[e.keys[0]+"="+r[0]];}}for(var i=0;i<r.length;i++){var k=this._trim(r[i].substring(0,r[i].indexOf('=')));var R=this._trim(r[i].substring(r[i].indexOf('=')+1));var F=R.charAt(0);var a=R.charAt(R.length-1);if(e.keysType[k]==="Edm.String"){if(F!=="'"||a!=="'"){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.MALFORMED_URI_LITERAL_SYNTAX_IN_KEY,k);}}else if(e.keysType[k]==="Edm.DateTime"){if(F==="'"||a!=="'"){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.MALFORMED_URI_LITERAL_SYNTAX_IN_KEY,k);}}else if(e.keysType[k]==="Edm.Guid"){if(F==="'"||a!=="'"){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.MALFORMED_URI_LITERAL_SYNTAX_IN_KEY,k);}}else if(e.keysType[k]==="Edm.Binary"){if(!(new RegExp("(binary|X)'[A-Fa-f0-9][A-Fa-f0-9]*'").test(R))){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.MALFORMED_URI_LITERAL_SYNTAX_IN_KEY,k);}}else{if((F==="'"&&a!=="'")||(a==="'"&&F!=="'")){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.MALFORMED_URI_LITERAL_SYNTAX_IN_KEY,k);}}var K=e.keys.join(",");if(e.keys.indexOf(k)===-1){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.INVALID_KEY_NAME,K);}}};
h.prototype._parseKeys=function(k,e){var r={};var p=k.split(",");var K,s,P;for(var i=0;i<p.length;i++){P=p[i].split("=");if(P.length===1&&e.keys.length===1){K=e.keys[0];s=P[0];}else{if(P.length===2){K=P[0];s=P[1];}}r[K]=s;switch(e.keysType[K]){case"Edm.String":r[K]=r[K].replace(/^\'|\'$/g,"");break;case"Edm.Int16":case"Edm.Int32":case"Edm.Int64":case"Edm.Decimal":case"Edm.Byte":case"Edm.Double":case"Edm.Single":case"Edm.SByte":r[K]=parseFloat(r[K]);break;case"Edm.Guid":r[K]=r[K].replace(/^guid\'|\'$/g,"");break;case"Edm.Boolean":case"Edm.Binary":case"Edm.DateTimeOffset":default:}}return r;};
h.prototype._generatePropertyValue=function(k,t,C,i){var I=i;if(!I){I=Math.floor(this._getPseudoRandomNumber("String")*10000)+101;}switch(t){case"String":return k+" "+I;case"DateTime":var a=new Date();a.setFullYear(2000+Math.floor(this._getPseudoRandomNumber("DateTime")*20));a.setDate(Math.floor(this._getPseudoRandomNumber("DateTime")*30));a.setMonth(Math.floor(this._getPseudoRandomNumber("DateTime")*12));a.setMilliseconds(0);return"/Date("+a.getTime()+")/";case"Int16":case"Int32":case"Int64":return Math.floor(this._getPseudoRandomNumber("Int")*10000);case"Decimal":return Math.floor(this._getPseudoRandomNumber("Decimal")*1000000)/100;case"Boolean":return this._getPseudoRandomNumber("Boolean")<0.5;case"Byte":return Math.floor(this._getPseudoRandomNumber("Byte")*10);case"Double":return this._getPseudoRandomNumber("Double")*10;case"Single":return this._getPseudoRandomNumber("Single")*1000000000;case"SByte":return Math.floor(this._getPseudoRandomNumber("SByte")*10);case"Time":return"PT"+Math.floor(this._getPseudoRandomNumber("Time")*23)+"H"+Math.floor(this._getPseudoRandomNumber("Time")*59)+"M"+Math.floor(this._getPseudoRandomNumber("Time")*59)+"S";case"Guid":return'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g,function(c){var r=this._getPseudoRandomNumber("Guid")*16|0,v=c==='x'?r:(r&0x3|0x8);return v.toString(16);}.bind(this));case"Binary":var b=Math.floor(-2147483648+this._getPseudoRandomNumber("Binary")*4294967295),m="";for(var e=0,j=b;e<32;e++,m+=String(j>>>31),j<<=1);return m;case"DateTimeOffset":var a=new Date();a.setFullYear(2000+Math.floor(this._getPseudoRandomNumber("DateTimeOffset")*20));a.setDate(Math.floor(this._getPseudoRandomNumber("DateTimeOffset")*30));a.setMonth(Math.floor(this._getPseudoRandomNumber("DateTimeOffset")*12));a.setMilliseconds(0);return"/Date("+a.getTime()+"+0000)/";default:return this._generateDataFromEntity(C[t],I,C);}};
h.prototype._isFalseyValue=function(k,K,s){switch(s){case"Edm.String":return k==="";case"Edm.Boolean":return k===false;case"Edm.Int16":case"Edm.Int32":case"Edm.Int64":case"Edm.Decimal":case"Edm.Byte":case"Edm.Double":case"Edm.Single":case"Edm.SByte":return k===0||isNaN(k);default:return false;}};
h.prototype._completeKey=function(e,k,E){if(E){for(var i=0;i<e.keys.length;i++){var K=e.keys[i];if(k[K]!==undefined&&k[K]!==null){if(!E[K]){switch(e.keysType[K]){case"Edm.DateTime":E[K]=this._getJsonDate(k[K]);break;case"Edm.Guid":E[K]=k[K].replace(/^guid\'|\'$/g,"");break;default:E[K]=k[K];}}}else{if(!E[K]){E[K]=this._generatePropertyValue(K,e.keysType[K].substring(e.keysType[K].lastIndexOf('.')+1));}}}}};
h.prototype._generateDataFromEntity=function(e,I,c){var E={};if(!e){return E;}for(var i=0;i<e.properties.length;i++){var p=e.properties[i];E[p.name]=this._generatePropertyValue(p.name,p.type,c,I);}return E;};
h.prototype._generateDataFromEntitySet=function(e,E,c){var o=E[e.type];var m=[];for(var i=0;i<100;i++){m.push(this._generateDataFromEntity(o,i+1,c));}return m;};
h.prototype._generateMockdata=function(e,m){var t=this;var o={};var r=this._getRootUri();q.each(e,function(E,a){var b={};b[a.name]=a;o[E]=t._generateODataMockdataForEntitySet(b,m)[E];});q.each(e,function(E,a){for(var b in a.navprops){var N=a.navprops[b];var p=N.from.propRef.length;for(var j=0;j<p;j++){for(var i=0;i<o[E].length;i++){var c=o[E][i];o[N.to.entitySet][i][N.to.propRef[j]]=c[N.from.propRef[j]];}}}q.each(o[E],function(I,k){k.__metadata={uri:r+E+"("+t._createKeysString(a,k)+")",type:a.schema+"."+a.type};q.each(a.navprops,function(K,N){k[K]={__deferred:{uri:r+E+"("+t._createKeysString(a,k)+")/"+K}};});});});this._oMockdata=o;};
h.prototype._generateODataMockdataForEntitySet=function(e,m){var t=this,o={};var E=this._findEntityTypes(m);var c=this._findComplexTypes(m);q.each(e,function(s,a){o[s]=t._generateDataFromEntitySet(a,E,c);});return o;};
h.prototype._resolveNavigation=function(e,F,N){var E=this._mEntitySets[e];var o=E.navprops[N];if(!o){this._logAndThrowMockServerCustomError(404,this._oErrorMessages.RESOURCE_NOT_FOUND);}var a=[];var p=o.from.propRef.length;if(p===0){if(o.to.multiplicity==="*"){return this._oMockdata[o.to.entitySet];}else{a.push(this._oMockdata[o.to.entitySet][0]);return a;}}q.each(this._oMockdata[o.to.entitySet],function(I,t){var b=true;for(var i=0;i<p;i++){if(F[o.from.propRef[i]]!==t[o.to.propRef[i]]){b=false;break;}}if(b){a.push(t);}});return a;};
h.prototype.simulate=function(s,v){var t=this;this._sMetadataString=s;if(!v||typeof v==="string"){this._sMockdataBaseUrl=v;}else{this._sMockdataBaseUrl=v.sMockdataBaseUrl;this._bGenerateMissingMockData=v.bGenerateMissingMockData;this._aEntitySetsNames=v.aEntitySetsNames;}var o=this._loadMetadata(this._sMetadataString);if(!o){return;}if(this._sMetadata){var a=f.parse(this._oMetadata,this._sMetadata);D.handleDraft(a,this);}this._resetPseudoRandomNumberGenerator();this._refreshData();var H=function(x,m){if(x.requestHeaders["x-csrf-token"]==="Fetch"||x.requestHeaders["X-CSRF-Token"]==="Fetch"){m["X-CSRF-Token"]="42424242424242424242424242424242";}};var G=function(e,k){k=decodeURIComponent(k);var F;var E=t._mEntitySets[e];var K=E.keys;var j=k.split(',');if(j.length!==K.length){t._logAndThrowMockServerCustomError(400,t._oErrorMessages.INVALID_KEY_PREDICATE_QUANTITY);}t._isRequestedKeysValid(E,j);if(j.length===1&&!j[0].split('=')[1]){j=[K[0]+"="+j[0]];}q.each(t._oMockdata[e],function(I,m){for(var i=0;i<j.length;i++){var p=j[i].split('=');var u=t._trim(p[0]);if(!K||K.indexOf(u)===-1){return true;}var N=t._trim(p[1]);var O=m[u];switch(E.keysType[u]){case"Edm.String":N=N.replace(/^\'|\'$/g,'');break;case"Edm.Time":case"Edm.DateTime":O=t._getDateTime(O);break;case"Edm.Int16":case"Edm.Int32":case"Edm.Decimal":case"Edm.Byte":case"Edm.Double":case"Edm.Single":case"Edm.SByte":if(!t._isValidNumber(N)){return false;}N=parseFloat(N);break;case"Edm.Guid":N=N.replace(/^guid\'|\'$/g,'');break;case"Edm.Boolean":if(["true","false"].indexOf(N)===-1){t._logAndThrowMockServerCustomError(400,t._oErrorMessages.INVALID_KEY_TYPE,u);}N=N==="true";break;case"Edm.Binary":case"Edm.DateTimeOffset":default:}if(O!==N){return true;}}F={index:I,entry:m};return false;});return F;};var r=function(e,k,u){var S=e.name;var i;if(u){i=e.navprops[u];}if(i){S=i.to.entitySet;}return S;};var b=function(u){var U=[];var S=function(V){var j=V.indexOf("'");var m=V.indexOf("\"");if(j===-1&&m===-1){return null;}else{if(j>-1&&m===-1){return"appost";}if(m>-1&&j===-1){return"doublequotes";}if(j>-1&&m>-1&&j<m){return"appost";}if(j>-1&&m>-1&&m<j){return"doublequotes";}}};var A=function(p,P,m,w){var x=p[m];var j=m+1;while(j<p.length&&p[j].indexOf(w)===-1){x=x+"&"+p[j];j++;}x=x+"&"+p[j];P.push(x);m=j;return m;};for(var i=0;i<u.length;i++){if(!S(u[i])){U.push(u[i]);}if(S(u[i])==="appost"){var e=u[i].indexOf("'");if(u[i].indexOf("'",e+1)===-1){i=A(u,U,i,"'");}else{U.push(u[i]);}}if(S(u[i])==="doublequotes"){var k=u[i].indexOf("\"");if(u[i].indexOf("\"",k+1)===-1){i=A(u,U,i,"\"");}else{U.push(u[i]);}}}return U;};var c=function(x,T,k,u){k=k?decodeURIComponent(k):k;var e=JSON.parse(x.requestBody);if(e){var K={};if(k){K=t._parseKeys(k,t._mEntitySets[T]);}t._completeKey(t._mEntitySets[T],K,e);t._enhanceWithMetadata(t._mEntitySets[T],[e]);return e;}return null;};var R=[];R.push({method:"GET",path:new RegExp("\\$metadata([?#].*)?"),response:function(x){L.debug("MockServer: incoming request for url: "+x.url);var m={"Content-Type":"application/xml;charset=utf-8"};H(x,m);x.respond(200,m,t._sMetadata);L.debug("MockServer: response sent with: 200, "+t._sMetadata);return true;}});R.push({method:"HEAD",path:new RegExp("$"),response:function(x){L.debug("MockServer: incoming request for url: "+x.url);var m={"Content-Type":"application/json;charset=utf-8"};H(x,m);x.respond(200,m);L.debug("MockServer: response sent with: 200");return true;}});R.push({method:"GET",path:new RegExp("$"),response:function(x){L.debug("MockServer: incoming request for url: "+x.url);var m={"Content-Type":"application/json;charset=utf-8"};H(x,m);var e=[];q.each(t._mEntitySets,function(E,j){e.push(E);});var i={EntitySets:e};x.respond(200,m,JSON.stringify({d:i}));L.debug("MockServer: response sent with: 200, "+JSON.stringify({d:i}));return true;}});R.push({method:"POST",path:new RegExp("\\$batch([?#].*)?"),response:function(x){L.debug("MockServer: incoming request for url: "+x.url);var e=function(c1){switch(c1.statusCode){case 200:return"200 OK";case 201:return"201 Created";case 204:return"204 No Content";case 400:return"400 Bad Request";case 401:return"401 Unauthorized";case 403:return"403 Forbidden";case 404:return"404 Not Found";case 405:return"405 Method Not Allowed";case 409:return"409 Conflict";case 412:return"412 Precondition Failed";case 415:return"415 Unsupported Media Type";case 500:return"500 Internal Server Error";case 501:return"501 Not Implemented";case 503:return"503 Service Unavailable";default:return c1.statusCode+" "+c1.status;}};var B=function(c1,d1){var e1;if(c1.success){e1=JSON.stringify(c1.data)||"";}else{e1=c1.errorResponse;}d1=d1||"application/json";if(c1.responseHeaders){return"HTTP/1.1 "+e(c1)+"\r\n"+c1.responseHeaders+"dataserviceversion: 2.0\r\n\r\n"+e1+"\r\n";}else{return"HTTP/1.1 "+e(c1)+"\r\nContent-Type: "+d1+"\r\nContent-Length: "+e1.length+"\r\ndataserviceversion: 2.0\r\n\r\n"+e1+"\r\n";}};var C=function(c1,W,d1,Q,X){var e1;var f1=function(h1,i1,j1){e1={success:true,data:h1,status:i1,statusCode:j1&&j1.status,responseHeaders:j1&&j1.getAllResponseHeaders()};};var g1=function(h1,i1,j1){e1={success:false,data:undefined,status:i1,error:j1,statusCode:h1.status,errorResponse:h1.responseText,responseHeaders:h1&&h1.getAllResponseHeaders()};};q.ajax({type:d1,async:false,url:c1,headers:X,data:W,dataType:"json",success:f1,error:g1});if(e1.statusCode===400||e1.statusCode===404){var a1=B(e1);throw new Error(a1);}Q.push(B(e1));};var p=function(c1,z){var d1;var e1;var f1=function(h1,i1,j1){d1={success:true,data:h1,status:i1,statusCode:j1&&j1.status,responseHeaders:j1&&j1.getAllResponseHeaders()};};var g1=function(h1,i1,j1){d1={success:false,data:undefined,status:i1,error:j1,statusCode:h1.status,errorResponse:h1.responseText,responseHeaders:h1&&h1.getAllResponseHeaders()};};q.ajax({async:false,url:c1,dataType:"json",success:f1,error:g1});var e1;if(c1.indexOf('$count')!==-1){e1=B(d1,"text/plain");}else{e1=B(d1);}z.push("\r\nContent-Type: application/http\r\n"+"Content-Length: "+e1.length+"\r\n"+"content-transfer-encoding: binary\r\n\r\n"+e1);};var P=function(V){var X={};V.split("HTTP/1.1")[1].split("{")[0].split("\n").forEach(function(c1){if(c1.indexOf(":")!==-1){var d1=c1.split(":");X[d1[0].trim()]=d1[1].trim();}});delete X["Content-Length"];return X;};var u=x.requestBody;var w=new RegExp("--batch_[a-z0-9-]*");var y=w.exec(u)[0];if(y){var z=[];var A=u.split(y);var S=x.url.split("$")[0];var E=new RegExp("PUT (.*) HTTP");var F=new RegExp("MERGE (.*) HTTP");var I=new RegExp("POST (.*) HTTP");var J=new RegExp("DELETE (.*) HTTP");var K=new RegExp("GET (.*) HTTP");for(var i=1;i<A.length-1;i++){var N=A[i];if(K.test(N)&&N.indexOf("multipart/mixed")===-1){if(E.test(N)||I.test(N)||J.test(N)){x.respond(400,null,"The Data Services Request could not be understood due to malformed syntax");L.debug("MockServer: response sent with: 400");return true;}p(S+K.exec(N)[1],z);}else{var O=q.extend(true,{},t._oMockdata);var Q=[];var T=N.substring(N.indexOf("boundary=")+9,N.indexOf("\r\n\r\n"));var U=N.split("--"+T);try{for(var j=1;j<U.length-1;j++){var V=U[j];var W;if(K.test(V)){t._oMockdata=O;x.respond(400,null,"The Data Services Request could not be understood due to malformed syntax");L.debug("MockServer: response sent with: 400");return;}else{var W=V.substring(V.indexOf("{"),V.lastIndexOf("}")+1),X=P(V),Y,Z;if(E.test(V)){Z="PUT";Y=E.exec(V)[1];}else if(F.test(V)){Z="MERGE";Y=F.exec(V)[1];}else if(I.test(V)){Z="POST";Y=I.exec(V)[1];}else if(J.test(V)){Z="DELETE";W=undefined;Y=J.exec(V)[1];}C(S+Y,W,Z,Q,X);}}var $="\r\nContent-Type: multipart/mixed; boundary=ejjeeffe1\r\n\r\n--ejjeeffe1";for(var k=0;k<Q.length;k++){$+="\r\nContent-Type: application/http\r\n"+"Content-Length: "+Q[k].length+"\r\n"+"content-transfer-encoding: binary\r\n\r\n"+Q[k]+"--ejjeeffe1";}$+="--\r\n";z.push($);}catch(_){t._oMockdata=O;var a1="\r\nContent-Type: application/http\r\n"+"Content-Length: "+_.message.length+"\r\n"+"content-transfer-encoding: binary\r\n\r\n"+_.message;z.push(a1);}}}var b1="--ejjeeffe0";for(var m=0;m<z.length;m++){b1+=z[m]+"--ejjeeffe0";}b1+="--";var X={'Content-Type':"multipart/mixed; boundary=ejjeeffe0"};H(x,X);x.respond(202,X,b1);L.debug("MockServer: response sent with: 202, "+b1);}else{x.respond(202);}return true;}});q.each(this._mEntitySets,function(E,i){R.push({method:"GET",path:new RegExp("("+E+")/\\$count/?(.*)?"),response:function(x,E,u){L.debug("MockServer: incoming request for url: "+x.url);t.fireEvent(h.HTTPMETHOD.GET+E+":before",{oXhr:x,sUrlParams:u});t.fireEvent(h.HTTPMETHOD.GET+":before",{oXhr:x,sUrlParams:u});var m={"Content-Type":"text/plain;charset=utf-8"};H(x,m);try{var j=t._oMockdata[E];if(j){var F={results:q.extend(true,[],j)};if(u){var U=decodeURIComponent(u).replace("?","&").split("&");U=b(U);if(U.length>1){U=t._orderQueryOptions(U);}q.each(U,function(I,Q){t._applyQueryOnCollection(F,Q,E,U);});}t.fireEvent(h.HTTPMETHOD.GET+E+":after",{oXhr:x,oFilteredData:F});t.fireEvent(h.HTTPMETHOD.GET+":after",{oXhr:x,oFilteredData:F});x.respond(200,m,""+F.results.length);L.debug("MockServer: response sent with: 200, "+F.results.length);}else{t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND);}}catch(e){if(e.error){x.respond(e.error.code,m,JSON.stringify(e));}else{L.error("MockServer: request failed due to invalid system query options value!");x.respond(parseInt(e.message||e.number));}}return true;}});R.push({method:"GET",path:new RegExp("("+E+")/?(\\?(.*))?"),response:function(x,E,u){L.debug("MockServer: incoming request for url: "+x.url);t.fireEvent(h.HTTPMETHOD.GET+E+":before",{oXhr:x,sUrlParams:u});t.fireEvent(h.HTTPMETHOD.GET+":before",{oXhr:x,sUrlParams:u});var m={"Content-Type":"application/json;charset=utf-8"};H(x,m);try{var j=t._oMockdata[E];if(j){var F={results:q.extend(true,[],j)};if(u){var U=decodeURIComponent(u).replace("?","&").split("&");U=b(U);if(U.length>1){U=t._orderQueryOptions(U);}q.each(U,function(I,Q){t._applyQueryOnCollection(F,Q,E,U);});}t.fireEvent(h.HTTPMETHOD.GET+E+":after",{oXhr:x,oFilteredData:F});t.fireEvent(h.HTTPMETHOD.GET+":after",{oXhr:x,oFilteredData:F});x.respond(200,m,JSON.stringify({d:F}));L.debug("MockServer: response sent with: 200, "+JSON.stringify({d:F}));}else{t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND);}}catch(e){if(e.error){x.respond(e.error.code,m,JSON.stringify(e));}else{L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));x.respond(parseInt(e.message||e.number));}}return true;}});R.push({method:"GET",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/?(\\?(.*))?"),response:function(x,E,k,u){L.debug("MockServer: incoming request for url: "+x.url);t.fireEvent(h.HTTPMETHOD.GET+E+":before",{oXhr:x,sKeys:k,sUrlParams:u});t.fireEvent(h.HTTPMETHOD.GET+":before",{oXhr:x,sKeys:k,sUrlParams:u});var m={"Content-Type":"application/json;charset=utf-8"};try{var j=q.extend(true,{},G(E,k));if(!d(j)){if(u){var U=decodeURIComponent(u).replace("?","&").split("&");U=b(U);if(U.length>1){U=t._orderQueryOptions(U);}q.each(U,function(I,Q){j.entry=t._applyQueryOnEntry(j.entry,Q,E);});}t.fireEvent(h.HTTPMETHOD.GET+E+":after",{oXhr:x,oEntry:j.entry});t.fireEvent(h.HTTPMETHOD.GET+":after",{oXhr:x,oEntry:j.entry});x.respond(200,m,JSON.stringify({d:j.entry}));L.debug("MockServer: response sent with: 200, "+JSON.stringify({d:j.entry}));}else{t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND);}}catch(e){if(e.error){x.respond(e.error.code,m,JSON.stringify(e));}else{L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));x.respond(parseInt(e.message||e.number));}}return true;}});q.each(i.navprops,function(N,j){R.push({method:"GET",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/("+N+")/\\$count/?(.*)?"),response:function(x,E,k,m,u){L.debug("MockServer: incoming request for url: "+x.url);t.fireEvent(h.HTTPMETHOD.GET+E+":before",{oXhr:x,sKeys:k,sNavProp:m,sUrlParams:u});t.fireEvent(h.HTTPMETHOD.GET+":before",{oXhr:x,sKeys:k,sNavProp:m,sUrlParams:u});var p={"Content-Type":"text/plain;charset=utf-8"};H(x,p);try{var w=G(E,k);if(w){var y,F={};y=t._resolveNavigation(E,w.entry,m);var z=t._mEntitySets[E].navprops[m].to.multiplicity;if(z==="*"){F={results:q.extend(true,[],y)};}else{F=q.extend(true,{},y[0]);}if(y&&y.length!==0){if(u){var U=decodeURIComponent(u).replace("?","&").split("&");U=b(U);if(U.length>1){U=t._orderQueryOptions(U);}if(z==="*"){q.each(U,function(I,Q){t._applyQueryOnCollection(F,Q,t._mEntitySets[E].navprops[m].to.entitySet,U);});}else{q.each(U,function(I,Q){F=t._applyQueryOnEntry(F,Q,t._mEntitySets[E].navprops[m].to.entitySet);});}}}t.fireEvent(h.HTTPMETHOD.GET+E+":after",{oXhr:x,oFilteredData:F});t.fireEvent(h.HTTPMETHOD.GET+":after",{oXhr:x,oFilteredData:F});F.results=F.results||[];x.respond(200,p,""+F.results.length);L.debug("MockServer: response sent with: 200, "+F.results.length);}else{t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND);}}catch(e){if(e.error){x.respond(e.error.code,p,JSON.stringify(e));}else{L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));x.respond(parseInt(e.message||e.number));}}return true;}});R.push({method:"GET",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/("+N+")/?(\\?(.*))?"),response:function(x,E,k,m,u){L.debug("MockServer: incoming request for url: "+x.url);t.fireEvent(h.HTTPMETHOD.GET+E+":before",{oXhr:x,sKeys:k,sNavProp:m,sUrlParams:u});t.fireEvent(h.HTTPMETHOD.GET+":before",{oXhr:x,sKeys:k,sNavProp:m,sUrlParams:u});var p={"Content-Type":"application/json;charset=utf-8"};H(x,p);try{var w=G(E,k);if(w){var y,F={};y=t._resolveNavigation(E,w.entry,m,w.entry);var z=t._mEntitySets[E].navprops[m].to.multiplicity;if(z==="*"){F={results:q.extend(true,[],y)};}else{F=q.extend(true,{},y[0]);}if(y&&y.length!==0){if(u){var U=decodeURIComponent(u).replace("?","&").split("&");U=b(U);if(U.length>1){U=t._orderQueryOptions(U);}if(z==="*"){q.each(U,function(I,Q){t._applyQueryOnCollection(F,Q,t._mEntitySets[E].navprops[m].to.entitySet,U);});}else{q.each(U,function(I,Q){F=t._applyQueryOnEntry(F,Q,t._mEntitySets[E].navprops[m].to.entitySet);});}}}t.fireEvent(h.HTTPMETHOD.GET+E+":after",{oXhr:x,oFilteredData:F});t.fireEvent(h.HTTPMETHOD.GET+":after",{oXhr:x,oFilteredData:F});x.respond(200,p,JSON.stringify({d:F}));L.debug("MockServer: response sent with: 200, "+JSON.stringify({d:F}));}else{t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND);}}catch(e){if(e.error){x.respond(e.error.code,p,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});});R.push({method:"POST",path:new RegExp("("+E+")(\\(([^/\\?#]+)\\)/?(.*)?)?"),response:function(x,E,j,k,N){var m=false;if(x.requestHeaders["x-http-method"]==="MERGE"){m=true;}L.debug("MockServer: incoming create request for url: "+x.url);t.fireEvent(h.HTTPMETHOD.POST+E+":before",{oXhr:x,sKeys:k,sNavName:N});t.fireEvent(h.HTTPMETHOD.POST+":before",{oXhr:x,sKeys:k,sNavName:N});var p=null;var u=null;var w=405;try{if(k&&!k.split('=')[1]){k=t._mEntitySets[E].keys[0]+"="+k;}var T=r(i,decodeURIComponent(k),N);if(T){var y=c(x,T,k,N);if(y){u={"Content-Type":"application/json;charset=utf-8"};t.fireEvent(h.HTTPMETHOD.POST+E+":after",{oXhr:x,oEntity:y});t.fireEvent(h.HTTPMETHOD.POST+":after",{oXhr:x,oEntity:y});if(m){var z=G(E,k);if(z){q.extend(t._oMockdata[E][z.index],y);}w=204;}else{var U=t._getRootUri()+T+"("+t._createKeysString(t._mEntitySets[T],y)+")";p=JSON.stringify({d:y,uri:U});t._oMockdata[T]=t._oMockdata[T].concat([y]);w=201;}}}x.respond(w,u,p);L.debug("MockServer: response sent with: "+w+", "+p);}catch(e){if(e.error){var A={"Content-Type":"text/plain;charset=utf-8"};x.respond(e.error.code,A,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});R.push({method:"PUT",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/?(.*)?"),response:function(x,E,k,N){L.debug("MockServer: incoming update request for url: "+x.url);t.fireEvent(h.HTTPMETHOD.PUT+E+":before",{oXhr:x,sKeys:k,sNavName:N});t.fireEvent(h.HTTPMETHOD.PUT+":before",{oXhr:x,sKeys:k,sNavName:N});var j=405;var m=null;var p=null;try{var T=r(i,decodeURIComponent(k),N);if(T){var u=c(x,T,k,N);if(u){p={"Content-Type":"application/json;charset=utf-8"};t.fireEvent(h.HTTPMETHOD.PUT+E+":after",{oXhr:x,oEntity:u});t.fireEvent(h.HTTPMETHOD.PUT+":after",{oXhr:x,oEntity:u});var w=G(E,k);if(w){t._oMockdata[E][w.index]=u;}j=204;}}x.respond(j,p,m);L.debug("MockServer: response sent with: "+j+", "+m);}catch(e){if(e.error){var y={"Content-Type":"text/plain;charset=utf-8"};x.respond(e.error.code,y,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});R.push({method:"MERGE",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/?(.*)?"),response:function(x,E,k,N){L.debug("MockServer: incoming merge update request for url: "+x.url);t.fireEvent(h.HTTPMETHOD.MERGE+E+":before",{oXhr:x,sKeys:k,sNavName:N});t.fireEvent(h.HTTPMETHOD.MERGE+":before",{oXhr:x,sKeys:k,sNavName:N});var j=405;var m=null;var p=null;try{var T=r(i,decodeURIComponent(k),N);if(T){var u=c(x,T,k,N);if(u){p={"Content-Type":"application/json;charset=utf-8"};t.fireEvent(h.HTTPMETHOD.MERGE+E+":after",{oXhr:x,oEntity:u});t.fireEvent(h.HTTPMETHOD.MERGE+":after",{oXhr:x,oEntity:u});var w=G(E,k);if(w){q.extend(t._oMockdata[E][w.index],u);}j=204;}}x.respond(j,p,m);L.debug("MockServer: response sent with: "+j+", "+m);}catch(e){if(e.error){var y={"Content-Type":"text/plain;charset=utf-8"};x.respond(e.error.code,y,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});R.push({method:"PATCH",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/?(.*)?"),response:function(x,E,k,N){L.debug("MockServer: incoming patch update request for url: "+x.url);t.fireEvent(h.HTTPMETHOD.PATCH+E+":before",{oXhr:x,sKeys:k,sNavName:N});t.fireEvent(h.HTTPMETHOD.PATCH+":before",{oXhr:x,sKeys:k,sNavName:N});var j=405;var m=null;var p=null;try{var T=r(i,decodeURIComponent(k),N);if(T){var u=c(x,T,k,N);if(u){p={"Content-Type":"application/json;charset=utf-8"};t.fireEvent(h.HTTPMETHOD.PATCH+E+":after",{oXhr:x,oEntity:u});t.fireEvent(h.HTTPMETHOD.PATCH+":after",{oXhr:x,oEntity:u});var w=G(E,k);if(w){q.extend(t._oMockdata[E][w.index],u);}j=204;}}x.respond(j,p,m);L.debug("MockServer: response sent with: "+j+", "+m);}catch(e){if(e.error){var y={"Content-Type":"text/plain;charset=utf-8"};x.respond(e.error.code,y,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});R.push({method:"DELETE",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/?(.*)?"),response:function(x,E,k,u){L.debug("MockServer: incoming delete request for url: "+x.url);t.fireEvent(h.HTTPMETHOD.DELETE+E+":before",{oXhr:x});t.fireEvent(h.HTTPMETHOD.DELETE+":before",{oXhr:x});var j=204;try{var m=G(E,k);if(m){t._oMockdata[E].splice(m.index,1);}else{j=400;}t.fireEvent(h.HTTPMETHOD.DELETE+E+":after",{oXhr:x});t.fireEvent(h.HTTPMETHOD.DELETE+":after",{oXhr:x});x.respond(j,null,null);L.debug("MockServer: response sent with: "+j);}catch(e){if(e.error){var p={"Content-Type":"text/plain;charset=utf-8"};x.respond(e.error.code,p,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});});this.setRequests(R);};
h.prototype._orderQueryOptions=function(u){var F,i,s,t,o,S,e,a,b,c,O=[];var j=this;q.each(u,function(I,Q){var k=u.indexOf(Q);switch(Q.split('=')[0]){case"$top":t=k;break;case"$skip":s=k;break;case"$orderby":o=k;break;case"$expand":e=k;break;case"$filter":F=k;break;case"$select":S=k;break;case"$inlinecount":i=k;break;case"$format":a=k;break;case"search-focus":c=k;break;case"search":b=k;break;default:if(Q.split('=')[0].indexOf('$')===0){j._logAndThrowMockServerCustomError(400,j._oErrorMessages.IS_NOT_A_VALID_SYSTEM_QUERY_OPTION,Q.split('=')[0]);}}});if(e>=0){O.push(u[e]);}if(F>=0){O.push(u[F]);}if(c>=0){O.push(u[c]);}if(b>=0){O.push(u[b]);}if(i>=0){O.push(u[i]);}if(o>=0){O.push(u[o]);}if(s>=0){O.push(u[s]);}if(t>=0){O.push(u[t]);}if(S>=0){O.push(u[S]);}if(a>=0){O.push(u[a]);}return O;};
h.prototype._removeAllRequestHandlers=function(){var r=this.getRequests();var a=r.length;for(var i=0;i<a;i++){h._removeResponse(r[i].response);}};
h.prototype._removeAllFilters=function(){for(var i=0;i<this._aFilters.length;i++){h._removeFilter(this._aFilters[i]);}this._aFilters=null;};
h.prototype._addRequestHandler=function(m,p,r){m=m?m.toUpperCase():m;if(typeof m!=="string"){throw new Error("Error in request configuration: value of 'method' has to be a string");}if(!(typeof p==="string"||p instanceof RegExp)){throw new Error("Error in request configuration: value of 'path' has to be a string or a regular expression");}if(typeof r!=="function"){throw new Error("Error in request configuration: value of 'response' has to be a function");}var u=this._getRootUri();u=u&&new RegExp(this._escapeStringForRegExp(u));if(p&&!(p instanceof RegExp)){p=new RegExp(this._createRegExpPattern(p));}var R=this._createRegExp(u?u.source+p.source:p.source);this._addFilter(this._createFilter(m,R));this._oServer.respondWith(m,R,r);L.debug("MockServer: adding "+m+" request handler for pattern "+R);};
h.prototype._createRegExp=function(p){return new RegExp("^"+p+"$");};
h.prototype._createRegExpPattern=function(p){return p.replace(/:([\w\d]+)/g,"([^\/]+)");};
h.prototype._escapeStringForRegExp=function(s){return s.replace(/[\\\/\[\]\{\}\(\)\-\*\+\?\.\^\$\|]/g,"\\$&");};
h.prototype._trim=function(s){return s&&s.replace(/^\s+|\s+$/g,"");};
h.prototype._isValidNumber=function(s){return!isNaN(parseFloat(s))&&isFinite(s);};
h.prototype._getDateTime=function(s){if(!s){return;}return"datetime'"+new Date(Number(s.replace("/Date(",'').replace(")/",''))).toJSON().substring(0,19)+"'";};
h.prototype._getJsonDate=function(S){if(!S){return;}var N=function(s){var a=q.map(s.slice(0,-5).split(/\D/),function(i){return parseInt(i)||0;});a[1]-=1;a=new Date(Date.UTC.apply(Date,a));var o=s.slice(-5);var b=parseInt(o)/100;if(o.slice(0,1)==="+"){b*=-1;}a.setHours(a.getHours()+b);return a.getTime();};if(S.indexOf("datetimeoffset")>-1){return"/Date("+N(S.substring("datetimeoffset'".length,S.length-1))+")/";}else{return"/Date("+N(S.substring("datetime'".length,S.length-1))+")/";}};
h.prototype._addFilter=function(F){this._aFilters.push(F);h._addFilter(F);};
h.prototype._createFilter=function(r,R){return function(m,u,a,U,p){return r===m&&R.test(u);};};
h.prototype._logAndThrowMockServerCustomError=function(e,E,p){if(E.indexOf('##')>-1&&p){E=E.replace("##","'"+p+"'");}L.error("MockServer: "+E);throw{error:{code:e,message:{lang:"en",value:E}}};};
h.prototype.destroy=function(s){M.prototype.destroy.apply(this,arguments);this.stop();var S=h._aServers;var i=S.indexOf(this);S.splice(i,1);};
h._aFilters=[];h._oServer=null;h._aServers=[];
h._getInstance=function(){if(!this._oServer){this._oServer=window.sinon.fakeServer.create();this._oServer.autoRespond=true;}return this._oServer;};
h.config=function(c){var s=this._getInstance();s.autoRespond=c.autoRespond===false?false:true;s.autoRespondAfter=c.autoRespondAfter||0;s.fakeHTTPMethods=c.fakeHTTPMethods||false;};
h.respond=function(){this._getInstance().respond();};
h.startAll=function(){for(var i=0;i<this._aServers.length;i++){this._aServers[i].start();}};
h.stopAll=function(){for(var i=0;i<this._aServers.length;i++){this._aServers[i].stop();}this._getInstance().restore();this._oServer=null;};
h.destroyAll=function(){this.stopAll();while(this._aServers.length>0){this._aServers[0].destroy();}};
h.HTTPMETHOD={GET:"GET",POST:"POST",DELETE:"DELETE",PUT:"PUT",MERGE:"MERGE",PATCH:"PATCH"};
h._addFilter=function(F){this._aFilters.push(F);};
h._removeFilter=function(F){this._aFilters.splice(this._aFilters.indexOf(F),1);};
h._removeResponse=function(r){var R=this._oServer.responses;var a=R.length;for(var i=0;i<a;i++){if(R[i].response===r){R.splice(i,1);return true;}}return false;};
function l(o){var r;Object.assign(o,{async:false,success:function(a,t,x){r={success:true,data:a,status:t,statusCode:x&&x.status};},error:function(x,t,e){r={success:false,data:undefined,status:t,error:e,statusCode:x.status,errorResponse:x.responseText};}});q.ajax(o);return r;}
h._syncAjax=l;window.sinon.FakeXMLHttpRequest.useFilters=true;window.sinon.FakeXMLHttpRequest.addFilter(function(m,u,a,U,p){var F=h._aFilters;for(var i=0;i<F.length;i++){var b=F[i];if(b(m,u,a,U,p)){return false;}}return true;});var n=function(F){if(/.*\.json$/i.test(F)){return"JSON";}if(/.*\.xml$/i.test(F)){return"XML";}if(/.*metadata$/i.test(F)){return"XML";}return null;};
window.sinon.FakeXMLHttpRequest.prototype.respondFile=function(s,H,F){var r=l({url:F,dataType:"text"});if(!r.success){throw new Error("Could not load file from: "+F);}var o=r.data;var m=n(F);if(this["respond"+m]){this["respond"+m](s,H,o);}else{this.respond(s,H,o);}};
window.sinon.FakeXMLHttpRequest.prototype.respondJSON=function(s,H,j){H=H||{};H["Content-Type"]=H["Content-Type"]||"application/json";this.respond(s,H,typeof j==="string"?j:JSON.stringify(j));};
window.sinon.FakeXMLHttpRequest.prototype.respondXML=function(s,H,x){H=H||{};H["Content-Type"]=H["Content-Type"]||"application/xml";this.respond(s,H,x);};
return h;});
sap.ui.predefine('sap/ui/core/util/MockServerAnnotationsHandler',['sap/ui/model/odata/ODataModel'],function(O){"use strict";return{parse:function(m,M){if(!this._index){this._index=0;}var u="/annotationhandler"+this._index++ +"/";var a=sap.ui.require("sap/ui/core/util/MockServer");var o=new a({rootUri:u,requests:[{method:"GET",path:new RegExp("\\$metadata"),response:function(x){x.respond(200,{"Content-Type":"application/xml;charset=utf-8"},M);}}]});o.start();var b={annotationURI:[u+"$metadata"],json:true};var c=new O(u,b);var A=c.getServiceAnnotations();o.destroy();return A;}};},true);
sap.ui.predefine('sap/ui/core/util/PasteHelper',["sap/ui/core/Core","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/base/Log"],function(C,P,V,L){"use strict";var a={};
a.getClipboardText=function(e){return(typeof e=="string")?e:e.clipboardData.getData("text");};
a.getPastedDataAs2DArray=function(e){var d,r,R=[];var b=/sapui5Placeholder4MultiLine/g;var p=b.source;var c=/""/g;var D=this.getClipboardText(e);var f=[];var m=false;var g=D.indexOf("\""),h=-1;var k,l;while(g>-1){l=D.charAt(g-1);if((g===0)||(l==='\n')||(l==='\t')||(l==='\r')){h=D.indexOf("\"",g+1);if(h>-1){k=D.charAt(h+1);while((h>-1)&&(k==='\"')){h=D.indexOf("\"",h+2);k=D.charAt(h+1);}if((k==='\n')||(k==='\t')||(k==='')||(k==='\r')){var M=D.substring(g+1,h);D=D.replace("\""+M+"\"",p);M=M.replace(c,"\"");f.push(M);g=D.indexOf("\"",g+p.length+1);m=true;}}}if(!m){g=D.indexOf("\"",g+1);}m=false;}d=D.split(/\r\n|\r|\n/);var j=0;var G=function(){return f[j++];};for(var i=0;i<d.length;i++){r=d[i];if(f.length>0){r=r.replace(b,G);}if(r.length||i<d.length-1){R.push(r.split("\t"));}}return R;};
a.parse=function(d,c){var r={parsedData:null,errors:null};if(!d){throw new Error("Parameter aData is not specified");}if(c){for(var i=0;i<c.length;i++){var o=c[i];if(o.ignore){continue;}if(o.property){if(o.type){var t=o.type;if(t.isA&&t.isA("sap.ui.model.SimpleType")){o.typeInstance=t;}else{throw new Error("Data type "+o.type+" is not an instance of any data type");}}else if(o.customParseFunction==undefined){throw new Error("Missing ColumnInfo.type or custom type parse function for column "+(i+1)+". Check the application calling PasteHelper.parse(aData, aColumnInfo) and specify the missing type in the parameter aColumnInfo.");}}else{throw new Error("Missing ColumnInfo.property for column "+(i+1)+". Check the application calling PasteHelper.parse(aData, aColumnInfo) and specify the missing property in the parameter aColumnInfo.");}}}else{throw new Error("Missing parameter aColumnInfo");}var e=[],R=[],b=C.getLibraryResourceBundle();var p=function(g,t){return t.parseValue(g,"string");};var v=function(g,t){return t.validateValue(g);};for(var i=0;i<d.length;i++){var f=d[i];var s=a._parseRow(f,c,i,p,v,b,e);R.push(s);}return Promise.all(R).then(function(g){if(e.length>0){r.parsedData=null;r.errors=e;}else{if(g){r.parsedData=g;}r.errors=null;}return r;});};
a._parseRow=function(r,c,R,p,v,b,e){var d=[],o={};for(var i=0;(i<c.length)&&(i<r.length);i++){var f=c[i];if(f.ignore){continue;}var s=r[i];if(!f.typeInstance){p=f.customParseFunction;v=function(){};}var S=a._parseCell(i,s,f,R,p,v,b,o,e);d.push(S);}return Promise.all(d).then(function(){return o;});};
a._parseCell=function(i,c,o,r,p,v,b,O,e){return Promise.resolve(c).then(function(d){return p(d,o.typeInstance);}).then(function(d){return Promise.all([d,v(d,o.typeInstance)]);}).then(function(R){O[o.property]=R[0];}).catch(function(E){if(E instanceof P||E instanceof V){var d={row:r+1,column:i+1,property:o.property,value:c,type:o.type,message:b.getText("PasteHelper.ErrorMessage",[c,r+1,i+1])+" "+E.message+"\n"};e.push(d);c=null;}else{L.error(E);}});};
return a;});
sap.ui.predefine('sap/ui/core/util/ResponsivePaddingsEnablement',["sap/base/Log",'sap/ui/core/ResizeHandler',"sap/ui/thirdparty/jquery","sap/ui/core/library"],function(L,R,q){"use strict";var B={S:599,M:1023,L:1439};var M={S:"sapUi-Std-PaddingS",M:"sapUi-Std-PaddingM",L:"sapUi-Std-PaddingL",XL:"sapUi-Std-PaddingXL"};var a=function(s){if(!this.isA||!this.isA("sap.ui.core.Control")){L.error("Responsive Paddings enablement could be applied over controls only");return;}this._initResponsivePaddingsEnablement=function(){this.addEventDelegate({onAfterRendering:b,onBeforeRendering:o},this);};function o(){c(this);}function b(){var S=e(this,s);if(S.length){window.requestAnimationFrame(function(){_(this);}.bind(this));}}function _(C){d(C);if(!C.__iResponsivePaddingsResizeHandlerId__){C.__iResponsivePaddingsResizeHandlerId__=R.register(C,d.bind(C,C));}}function c(C){if(C.__iResponsivePaddingsResizeHandlerId__){R.deregister(C.__iResponsivePaddingsResizeHandlerId__);C.__iResponsivePaddingsResizeHandlerId__=null;}}function d(C,E){var r=e(C,s);var $=f(C,r);var w=E?E.size.width:C.$().width();g($);h($,w);}function e(C,s){var S=i(s);S=S.filter(function(j){return C.hasStyleClass(j);});if(!S.length){return[];}S=S.map(function(j){return j.split("--")[1];});S=S.map(function(A){return s[A];}).filter(function(j){return j;});return S;}function f(C,S){var $=q();S.forEach(function(j){if(j.suffix){$=$.add(C.$(j.suffix));}if(j.selector){$=$.add(C.$().find(j.selector).first());}});return $;}function g($){var C=Object.keys(M).map(function(k){return M[k];});$.each(function(j,k){var l=q(k).control(0);if(k===l.getDomRef()){C.forEach(l.removeStyleClass.bind(l));}else{q(k).removeClass(C.join(" "));}});}function h($,w){var k;switch(true){case w<=B.S:k="S";break;case w<=B.M&&w>B.S:k="M";break;case w<=B.L&&w>B.M:k="L";break;default:k="XL";break;}$.each(function(j,l){var C=q(l).control(0);if(l===C.getDomRef()){C.addStyleClass(M[k]);}else{q(l).addClass(M[k]);}});}function i(s){return Object.keys(s).map(function(k){return"sapUiResponsivePadding--"+k;});}};return a;});
sap.ui.predefine('sap/ui/core/util/ShortcutHelper',['sap/ui/Device','sap/ui/events/jquery/EventExtension'],function(D){"use strict";var k={plus:"+",space:" "};var E={OS:"Meta"};var d={"ctrl+l":"jump to address bar","ctrl+n":"new window, cannot be registered in Chrome","ctrl+shift+n":"new incognito window, cannot be registered in Chrome","ctrl+alt+shift+p":"UI5 Technical Info","ctrl+q":"quit Chrome in Mac","ctrl+alt+shift+s":"UI5 Support Popup","ctrl+t":"new tab, cannot be registered in Chrome","ctrl+shift+t":"reopen last tab, cannot be registered in Chrome","ctrl+w":"close tab, cannot be registered in Chrome","ctrl+shift+w":"close window, cannot be registered in Chrome","ctrl+0":"reset zoom","ctrl+-":"zoom out","ctrl++":"zoom in","ctrl+shift+=":"cannot be handled","tab":"TAB-based keyboard navigation","shift+tab":"TAB-based keyboard navigation","ctrl+tab":"cycling through tabs, cannot be registered in Chrome","ctrl+shift+tab":"cycling through tabs, cannot be registered in Chrome","ctrl+alt+delete":"nice try","ctrl+pageup":"cycling through tabs, cannot be registered in Chrome","ctrl+pagedown":"cycling through tabs, cannot be registered in Chrome","f6":"F6-based group navigation","f11":"fullscreen, cannot be registered in Chrome","f12":"browser dev tools"};var l=false;document.addEventListener('keydown',function(e){try{if(e.keyCode===18){l=(typeof e.location!=="number"||e.location===1);return;}}catch(a){}});var s={findShortcut:function(S,n){var r=S.data("sap.ui.core.Shortcut");if(!r){return;}var m=r.filter(function(o){var M=o.shortcutSpec.key===n.key&&o.shortcutSpec.ctrlKey===n.ctrlKey&&o.shortcutSpec.altKey===n.altKey&&o.shortcutSpec.shiftKey===n.shiftKey&&o.shortcutSpec.metaKey===n.metaKey;return M;});return m[0];},getNormalizedShortcutSpec:function(S){var n;if(typeof S==="string"){n=s.parseShortcut(S);}else{var a=S.key;var v=/^([a-z0-9\.,\-\*\/= +]|Tab|Enter|Backspace|Home|Delete|End|Pageup|Pagedown|ArrowUp|ArrowDown|ArrowLeft|ArrowRight|Escape|F[1-9]|F1[0-2])$/i.test(a);if(!v){throw new Error("Shortcut key '"+a+"' is not a valid shortcut key. It must match /^([a-z0-9\.,\-\*\/= +]|Tab|Enter|Backspace|Home|Delete|End|Pageup|Pagedown|ArrowUp|ArrowDown|ArrowLeft|ArrowRight|Escape|F[1-9]|F1[0-2])$/i");}n={key:s.translateRegisteredKeyToStandard(a).toLowerCase(),ctrlKey:D.os.macintosh?false:!!S.ctrl,ctrlRequested:S.ctrl,altKey:!!S.alt,shiftKey:!!S.shift,metaKey:D.os.macintosh?!!S.ctrl:false};}return n;},parseShortcut:function(S){this.validateShortcutString(S);var p=S.toLowerCase().split("+");return{key:s.translateRegisteredKeyToStandard(p.pop()),ctrlKey:D.os.macintosh?false:p.indexOf("ctrl")>-1,ctrlRequested:p.indexOf("ctrl")>-1,altKey:p.indexOf("alt")>-1,shiftKey:p.indexOf("shift")>-1,metaKey:D.os.macintosh?p.indexOf("ctrl")>-1:false};},translateRegisteredKeyToStandard:function(K){return k.hasOwnProperty(K)?k[K]:K;},validateShortcutString:function(S){var v=/^((Ctrl|Shift|Alt)\+){0,3}([a-z0-9\.,\-\*\/=]|Plus|Tab|Space|Enter|Backspace|Home|Delete|End|Pageup|Pagedown|Escape|ArrowUp|ArrowDown|ArrowLeft|ArrowRight|F[1-9]|F1[0-2])$/i.test(S);if(!v){throw new Error("Shortcut '"+S+"' is not a valid shortcut string. It must be a '+'-separated list of modifier keys and the actual key, like 'Ctrl+Alt+S'. Or more generally, it must match the expression /^((Ctrl|Shift|Alt)\+){0,3}([a-z0-9\.,\-\*\/=]|Plus|Tab|Space|Enter|Backspace|Home|Delete|End|Pageup|Pagedown|ArrowUp|ArrowDown|ArrowLeft|ArrowRight|Escape|F[1-9]|F1[0-2])$/i.");}},validateKeyCombination:function(n){var N=n.ctrlRequested?"ctrl+":"";N+=n.altKey?"alt+":"";N+=n.shiftKey?"shift+":"";N+=n.key;if(d[N]){throw new Error("Registering the shortcut '"+N+"' is not allowed ("+d[N]+").");}if([".",",","-","+","=","*","/"].indexOf(n.key)>-1&&N.indexOf("shift")>-1){throw new Error("Registering the shortcut '"+N+"' is not allowed because the 'Shift' modifier changes the meaning of the "+n.key+" key on many keyboards.");}},getNormalizedShortcutString:function(n){var N=n.ctrlRequested?"ctrl+":"";N+=n.altKey?"alt+":"";N+=n.shiftKey?"shift+":"";N+=n.key;return N;},shortcutMayBeUsedHere:function(S,o){var t=o.tagName.toLowerCase();if((t==="input"||t==="textarea")&&S.key.includes("arrow")){return false;}return true;},handleKeydown:function(S,o,c,e){if(e.key==="Control"||e.key==="Shift"||e.key==="Alt"||e.key==="AltGraph"||e.key==="Meta"){return;}if(e.isMarked()){return;}if(e.altKey&&!l){return;}var a=E.hasOwnProperty(e.key)?E[e.key]:e.key;a=a.toLowerCase();if(a!==S.key||e.ctrlKey!==S.ctrlKey||e.altKey!==S.altKey||e.shiftKey!==S.shiftKey||e.metaKey!==S.metaKey){return;}if(!s.shortcutMayBeUsedHere(S,e.target||e.srcElement)){return;}e.preventDefault();e.setMarked();e.stopPropagation();var b={registeredShortcut:o,originalBrowserEvent:e.originalEvent||e};c(b);}};return s;});
sap.ui.predefine('sap/ui/core/util/XMLPreprocessor',["sap/base/Log","sap/base/util/deepExtend","sap/base/util/JSTokenizer","sap/base/util/ObjectPath","sap/ui/base/BindingParser","sap/ui/base/ManagedObject","sap/ui/base/SyncPromise","sap/ui/core/Component","sap/ui/core/XMLTemplateProcessor","sap/ui/model/BindingMode","sap/ui/model/CompositeBinding","sap/ui/model/Context","sap/ui/performance/Measurement"],function(L,d,J,O,B,M,S,C,X,a,b,c,f){"use strict";var N="http://schemas.sap.com/sapui5/extension/sap.ui.core.template/1",x="sap.ui.core.util.XMLPreprocessor",p=[x],P=x+"/getResolvedBinding",s=x+"/insertFragment",g=x+".process",o=S.resolve(),h=S.resolve(true),t=Object.prototype.toString,v={},W=M.extend("sap.ui.core.util._with",{metadata:{library:"sap.ui.core",properties:{any:"any"},aggregations:{child:{multiple:false,type:"sap.ui.core.util._with"}}},updateProperty:function(){this.setAny(this.mBindingInfos.any.binding.getExternalValue());}}),R=W.extend("sap.ui.core.util._repeat",{metadata:{library:"sap.ui.core",aggregations:{list:{multiple:true,type:"n/a",_doesNotRequireFactory:true}}},updateList:function(){}});
function j(w,e,i,n){function r(y){if(!n){n=w.getBinding("any");if(n instanceof b){n=n.getBindings();if(i!==undefined){n=n[i];}}}return Array.isArray(n)?n[y]:n;}function u(y){return y instanceof c?y.getPath():y.getModel().resolve(y.getPath(),y.getContext());}return{getInterface:function(y,z){var A,D,E;if(typeof y==="string"){z=y;y=undefined;}r();if(Array.isArray(n)){if(y>=0&&y<n.length){D=n[y];}else{throw new Error("Invalid index of part: "+y);}}else if(y!==undefined){throw new Error("Not the root formatter of a composite binding");}else if(z){D=n;}else{throw new Error("Missing path");}if(z){E=D.getModel();if(z.charAt(0)!=='/'){A=D instanceof c?D:E.createBindingContext(D.getPath(),D.getContext());}D=E.createBindingContext(z,A);if(!D){throw new Error("Model could not create binding context synchronously: "+E);}}return j(null,e,undefined,D);},getModel:function(y){var z=r(y);return z&&z.getModel();},getPath:function(y){var z=r(y);return z&&u(z);},getSetting:function(y){if(y==="bindingContexts"||y==="models"){throw new Error("Illegal argument: "+y);}return e[y];}};}
function k(w,n,r,u,A){var V=false;function y(I,i){var F=I.formatter,z,D=I.model;if(I.path&&I.path.indexOf(">")>0){D=I.path.slice(0,I.path.indexOf(">"));}z=w.getModel(D);if(F&&F.requiresIContext===true){F=I.formatter=F.bind(null,j(w,r,i));}if(F&&A&&(z&&z.$$valueAsPromise||i===undefined&&V)){I.formatter=function(){var E=this;return S.all(arguments).then(function(G){return F.apply(E,G);});};I.formatter.textFragments=F.textFragments;}I.mode=a.OneTime;I.parameters=I.parameters||{};I.parameters.scope=u;if(A&&z&&z.$$valueAsPromise){V=I.parameters.$$valueAsPromise=true;}}try{if(n.parts){n.parts.forEach(y);}y(n);w.bindProperty("any",n);return w.getBinding("any")?S.resolve(w.getAny()):null;}catch(e){return S.reject(e);}finally{w.unbindProperty("any",true);}}
function l(e,n){var i=-1;function r(F){if(F){return e[i];}i+=1;if(i<e.length){return n(e[i],i,e).then(r);}}return e.length?r():o;}
function m(e){var A,r=e.attributes,T="<"+e.nodeName,i,n;for(i=0,n=r.length;i<n;i+=1){A=r.item(i);T+=" "+A.name+'="'+A.value+'"';}return T+(e.childNodes.length?">":"/>");}
function q(e,i){return i.visitNode(e);}
return{plugIn:function(V,n,e){var i=v[n];if(V!==null&&typeof V!=="function"||V===q){throw new Error("Invalid visitor: "+V);}if(!n||n===N||n==="sap.ui.core"||n.indexOf(" ")>=0){throw new Error("Invalid namespace: "+n);}L.debug("Plug-in visitor for namespace '"+n+"', local name '"+e+"'",V,x);if(e){n=n+" "+e;i=v[n]||i;}v[n]=V;return i||q;},visitNodeWrapper:q,process:function(r,V,u){var w=V.caller,D=L.isLoggable(L.Level.DEBUG,x),y=D,z=V.name,F={},A,E=0,G={},H=V._supportInfo,I=L.isLoggable(L.Level.WARNING,x);function K(i){return{find:function(n,q1){try{return S.resolve(l(n,q1));}catch(e){return S.reject(e);}},getContext:function(e){var n,q1,r1;e=e||"";if(e[0]==="{"){throw new Error("Must be a simple path, not a binding: "+e);}n=B.simpleParser("{"+e+"}");q1=i.getModel(n.model);if(!q1){throw new Error("Unknown model '"+n.model+"': "+e);}r1=q1.resolve(n.path,i.getBindingContext(n.model));if(!r1){throw new Error("Cannot resolve path: "+e);}return q1.createBindingContext(r1);},getResult:function(e,n){return _(e,n,i,true);},getSettings:function(){return u;},getViewInfo:function(){return d({},V);},insertFragment:function(e,n){return a1(e,n,i);},visitAttribute:function(e,n){return l1(e,n,i);},visitAttributes:function(e){return m1(e,i);},visitChildNodes:function(n){return n1(n,i);},visitNode:function(n){try{return o1(n,i);}catch(e){return S.reject(e);}},"with":function(e,n){var q1,r1=false,A,s1=new W();if(!n){i.setChild(s1);}for(A in e){q1=e[A];r1=true;s1.setModel(q1.getModel(),A);s1.bindObject({model:A,path:q1.getPath()});}return r1||n?K(s1):this;}};}function Q(e){if(D){L.debug(Z()+Array.prototype.slice.call(arguments,1).join(" "),e&&m(e),x);}}function T(e){if(D){L.debug(Z()+"Finished","</"+e.nodeName+">",x);}}function U(e,i){e=e+m(i);L.error(e,w,x);throw new Error(w+": "+e);}function Y(e){var q1,r1=Array.prototype.filter.call(e.childNodes,t1),i,n,s1=false;function t1(v1){return v1.nodeType===1;}function u1(v1,w1){return v1.namespaceURI===N&&v1.localName===w1;}if(!r1.length||!u1(r1[0],"then")){return null;}for(i=1,n=r1.length;i<n;i+=1){q1=r1[i];if(s1){U("Expected </"+e.prefix+":if>, but instead saw ",q1);}if(u1(q1,"else")){s1=true;}else if(!u1(q1,"elseif")){U("Expected <"+e.prefix+":elseif> or <"+e.prefix+":else>, but instead saw ",r1[i]);}}return r1;}function Z(){return(E<10?"[ ":"[")+E+"] ";}function $(A){return A&&A.charAt(0)==="."?O.get(A.slice(1),G):O.get(A||"",G)||O.get(A||"");}function _(i,n,q1,r1,s1){var t1,u1;f.average(P,"",p);try{t1=B.complexParser(i,G,r1,true,true,true)||i;}catch(e){return S.reject(e);}if(t1.functionsNotFound){if(r1){p1(n,'Function name(s)',t1.functionsNotFound.join(", "),'not found');}f.end(P);return null;}if(typeof t1==="object"){u1=k(q1,t1,u,G,!V.sync);if(r1&&!u1){p1(n,'Binding not ready');}else if(V.sync&&u1&&u1.isPending()){U("Async formatter in sync view in "+i+" of ",n);}}else{u1=S.resolve(t1);if(s1){s1();}}f.end(P);return u1;}function a1(e,i,n){var q1,r1=V.sync?X.loadTemplate:X.loadTemplatePromise,s1=z;n.$mFragmentContexts=n.$mFragmentContexts||{};if(n.$mFragmentContexts[e]){U("Cyclic reference to fragment '"+e+"' ",i);}E++;Q(i,"fragmentName =",e);n.$mFragmentContexts[e]=true;z=e;f.average(s,"",p);q1=F[e];if(!q1){F[e]=q1=S.resolve(r1(e,"fragment"));}return q1.then(function(t1){t1=i.ownerDocument.importNode(t1,true);f.end(s);return d1(t1).then(function(){if(t1.namespaceURI==="sap.ui.core"&&t1.localName==="FragmentDefinition"){return b1(t1,n,i);}i.parentNode.insertBefore(t1,i);return o1(t1,n);});}).then(function(){i.parentNode.removeChild(i);z=s1;n.$mFragmentContexts[e]=false;T(i);E-=1;});}function b1(e,i,n){return n1(e,i).then(function(){var q1;n=n||e;while((q1=e.firstChild)){n.parentNode.insertBefore(q1,n);}});}function c1(e,i){var n=p1.bind(null,e,'Constant test condition'),q1=_(e.getAttribute("test"),e,i,true,n)||S.resolve(false);return q1.catch(function(ex){p1(e,'Error in formatter:',ex);}).then(function(r1){var s1=!!r1&&r1!=="false";if(D){if(typeof r1==="string"){r1=JSON.stringify(r1);}else if(r1===undefined){r1="undefined";}else if(Array.isArray(r1)){r1="[object Array]";}Q(e,"test ==",r1,"-->",s1);}return s1;});}function d1(e){var n={},q1=e.getAttributeNodeNS(N,"require"),r1,s1;function t1(){return new S(function(i,u1){var v1=s1.map(sap.ui.require);if(v1.every(Boolean)){i(v1);}else{sap.ui.require(s1,function(){i(arguments);},u1);}}).then(function(u1){Object.keys(n).forEach(function(v1,i){G[v1]=u1[i];});});}if(q1&&q1.value){r1=q1.value;e.removeAttributeNode(q1);if(r1[0]==="{"){n=J.parseJS(r1);s1=Object.keys(n).map(function(i){return n[i];});return t1();}s1=r1.split(" ").map(function(i){return i.replace(/\./g,"/");});if(!V.sync){return t1();}s1.forEach(sap.ui.requireSync);}return o;}function e1(e,i,n){var q1=_(i.value,e,n,false);if(!q1){Q(e,'Binding not ready for attribute',i.name);return o;}return q1.then(function(r1){if(r1===undefined){Q(e,"Removed attribute",i.name);e.removeAttributeNode(i);}else if(r1!==i.value){switch(typeof r1){case"boolean":case"number":case"string":Q(e,i.name,"=",r1);i.value=r1;break;default:Q(e,"Ignoring",t.call(r1),"value for attribute",i.name);}}},function(r1){Q(e,"Error in formatter of attribute",i.name,r1);});}function f1(e,i){var A=e.getAttribute("name"),n,q1,r1=e.getAttribute("value");if(A&&A[0]==="."){A=A.slice(1);}if(!A||A.includes(".")){U("Missing proper relative name in ",e);}n=$(r1);if(!n){U("Invalid value in ",e);}q1=G[A];G[A]=n;return b1(e,i).then(function(){e.parentNode.removeChild(e);G[A]=q1;});}function g1(e,i){var n=e.getAttribute("name"),q1=_(n,e,i,true);if(!q1){return h;}return q1.then(function(A){var r1;if(A!==n){Q(e,"name =",A);}r1=C.getCustomizing(V.componentId,{extensionName:A,name:z,type:"sap.ui.viewExtensions"});if(r1&&r1.className==="sap.ui.core.Fragment"&&r1.type==="XML"){return a1(r1.fragmentName,e,i);}return true;},function(ex){p1(e,'Error in formatter:',ex);return true;});}function h1(e,i){var n=e.getAttribute("fragmentName"),q1=_(n,e,i,true);if(!q1){return o;}return q1.then(function(n){var r1=G;G=Object.create(G);return a1(n,e,i).then(function(){G=r1;});},function(ex){p1(e,'Error in formatter:',ex);});}function i1(i,e){E++;return l(Y(i)||[i],function(n){if(n.localName==="else"){return h;}if(n.localName==="then"){n=i;}return c1(n,e);}).then(function(n){return(n?b1(n,e,i):o).then(function(){i.parentNode.removeChild(i);T(i);E-=1;});});}function j1(e,n){var q1=e.getAttribute("list")||"",r1=B.complexParser(q1,G,false,true,true,true),s1,t1,u1,v1,w1,x1=e.getAttribute("var");if(x1===""){U("Missing variable name for ",e);}if(!r1){U("Missing binding for ",e);}if(r1.functionsNotFound){p1(e,'Function name(s)',r1.functionsNotFound.join(", "),'not found');}v1=new R();n.setChild(v1);r1.mode=a.OneTime;v1.bindAggregation("list",r1);t1=v1.getBinding("list");v1.unbindAggregation("list",true);u1=r1.model;if(!t1){U("Missing model '"+u1+"' in ",e);}t1.enableExtendedChangeDetection();s1=t1.getContexts(r1.startIndex,r1.length||Infinity);if(!V.sync&&s1.dataRequested){w1=new S(function(i){t1.attachEventOnce("change",i);}).then(function(){return t1.getContexts(r1.startIndex,r1.length);});}else{w1=S.resolve(s1);}x1=x1||u1;v1.setModel(t1.getModel(),x1);E++;Q(e,"Starting");return w1.then(function(s1){return l(s1,function(y1,i){var z1=(i===s1.length-1)?e:e.cloneNode(true);v1.setBindingContext(y1,x1);Q(e,x1,"=",y1.getPath());return b1(z1,v1,e);}).then(function(){T(e);E-=1;e.parentNode.removeChild(e);});});}function k1(e,i){var n,q1,r1,s1,t1=e.getAttribute("helper"),u1,v1=e.getAttribute("path"),w1,x1,y1=e.getAttribute("var");if(y1===""){U("Missing variable name for ",e);}r1=new W();i.setChild(r1);n=B.simpleParser("{"+v1+"}");y1=y1||n.model;if(t1||y1){q1=i.getModel(n.model);if(!q1){U("Missing model '"+n.model+"' in ",e);}x1=q1.resolve(n.path,i.getBindingContext(n.model));if(!x1){U("Cannot resolve path for ",e);}u1=q1.createBindingContext(x1);if(t1){s1=$(t1);if(typeof s1!=="function"){U("Cannot resolve helper for ",e);}u1=s1(u1);}w1=S.resolve(u1);if(V.sync&&w1.isPending()){U("Async helper in sync view in ",e);}w1=w1.then(function(u1){if(u1 instanceof c){q1=u1.getModel();x1=u1.getPath();}else if(u1!==undefined){if(typeof u1!=="string"||u1===""){U("Illegal helper result '"+u1+"' in ",e);}x1=u1;}r1.setModel(q1,y1);r1.bindObject({model:y1,path:x1});});}else{x1=v1;r1.bindObject(x1);w1=o;}return w1.then(function(){E++;Q(e,y1,"=",x1);if(r1.getBindingContext(y1)===i.getBindingContext(y1)){p1(e,'Set unchanged path:',x1);r1=i;}return b1(e,r1).then(function(){e.parentNode.removeChild(e);T(e);E-=1;});});}function l1(e,i,n){if(H){H({context:undefined,env:{caller:"visitAttribute",before:{name:i.name,value:i.value}}});}return e1(e,i,n).then(function(){if(H){H({context:undefined,env:{caller:"visitAttribute",after:{name:i.name,value:i.value}}});}});}function m1(e,i){function n(q1,r1){return q1.name.localeCompare(r1.name);}return l(Array.prototype.slice.apply(e.attributes).sort(n),function(q1){return l1(e,q1,i);});}function n1(n,e){return l(Array.prototype.slice.apply(n.childNodes),function(i){return o1(i,e);});}function o1(n,e){var i;function q1(){return m1(n,e).then(function(){return n1(n,e);}).then(function(){if(H){H({context:n,env:{caller:"visitNode",after:{name:n.tagName}}});}});}if(n.nodeType!==1){return o;}if(H){H({context:n,env:{caller:"visitNode",before:{name:n.tagName}}});}if(n.namespaceURI===N){switch(n.localName){case"alias":return f1(n,e);case"if":return i1(n,e);case"repeat":return j1(n,e);case"with":return k1(n,e);default:U("Unexpected tag ",n);}}else if(n.namespaceURI==="sap.ui.core"){switch(n.localName){case"ExtensionPoint":return g1(n,e).then(function(r1){if(r1){return q1();}});case"Fragment":if(n.getAttribute("type")==="XML"){return h1(n,e);}break;}}else{i=v[n.namespaceURI+" "+n.localName]||v[n.namespaceURI];if(i){E++;Q(n,"Calling visitor");return i(n,K(e)).then(function(r1){if(r1!==undefined){U("Unexpected return value from visitor for ",n);}T(n);E-=1;});}}return q1();}function p1(e){if(I){if(!y){y=true;L.warning("Warning(s) during processing of "+w,null,x);}L.warning(Z()+Array.prototype.slice.call(arguments,1).join(" "),e&&m(e),x);}}f.average(g,"",p);u=u||{};if(D){Q(undefined,"Start processing",w);if(u.bindingContexts instanceof c){Q(undefined,"undefined =",u.bindingContexts);}else{for(A in u.bindingContexts){Q(undefined,A,"=",u.bindingContexts[A]);}}}if(H){H({context:r,env:{caller:"view",viewinfo:d({},V),settings:d({},u),clone:r.cloneNode(true),type:"template"}});}return d1(r).then(function(){return o1(r,new W({models:u.models,bindingContexts:u.bindingContexts}));}).then(function(){Q(undefined,"Finished processing",w);f.end(g);return r;}).unwrap();}};},true);
sap.ui.predefine('sap/ui/core/util/reflection/BaseTreeModifier',["sap/ui/base/ManagedObject","sap/ui/base/ManagedObjectMetadata","sap/base/util/ObjectPath","sap/ui/util/XMLHelper","sap/ui/core/XMLTemplateProcessor","sap/ui/core/util/XMLPreprocessor","sap/base/util/isPlainObject","sap/base/Log"],function(M,a,O,X,b,c,d,L){"use strict";return{bySelectorExtensionPointEnabled:function(s,A,v){return Promise.resolve(this.bySelector(s,A,v));},bySelectorTypeIndependent:function(s,A,v){var C;return Promise.resolve().then(function(){if(s&&s.name){v=v||this.bySelector(s.viewSelector,A);return this.getExtensionPointInfo(s.name,v).then(function(e){return e?e.parent:undefined;});}C=this.getControlIdBySelector(s,A);return this._byId(C,v);}.bind(this));},bySelector:function(s,A,v){var C=this.getControlIdBySelector(s,A);return this._byId(C,v);},getControlIdBySelector:function(s,A){if(!s){return undefined;}if(typeof s==="string"){s={id:s};}var C=s.id;if(s.idIsLocal){if(A){C=A.createId(C);}else{throw new Error("App Component instance needed to get a control's ID from selector");}}return C;},getSelector:function(C,A,m){var s=C;if(typeof s!=="string"){s=(C)?this.getId(C):undefined;}else if(!A){throw new Error("App Component instance needed to get a selector from string ID");}if(m&&(m.id||m.idIsLocal)){throw new Error("A selector of control with the ID '"+s+"' was requested, "+"but core properties were overwritten by the additionally passed information.");}var v=this.checkControlId(s,A);if(!v){throw new Error("Generated ID attribute found - to offer flexibility a stable control ID is needed to assign the changes to, but for this control the ID was generated by SAPUI5 "+s);}var S=Object.assign({},m,{id:"",idIsLocal:false});if(this.hasLocalIdSuffix(s,A)){var l=A.getLocalId(s);S.id=l;S.idIsLocal=true;}else{S.id=s;}return S;},checkControlId:function(C,A){var s=C instanceof M?C.getId():C;var i=a.isGeneratedId(s);return!i||this.hasLocalIdSuffix(C,A);},hasLocalIdSuffix:function(C,A){var s=(C instanceof M)?C.getId():C;if(!A){L.error("Determination of a local ID suffix failed due to missing app component for "+s);return false;}return!!A.getLocalId(s);},_checkAndPrefixIdsInFragment:function(f,I){var p=X.getParseError(f);if(p.errorCode!==0){return Promise.reject(new Error(f.parseError.reason));}var C=f.documentElement;var r=[],e=[];if(C.localName==="FragmentDefinition"){r=this._getElementNodeChildren(C);}else{r=[C];}e=[].concat(r);function o(g){e.push(g);}var P=Promise.resolve();for(var i=0,n=r.length;i<n;i++){P=P.then(this._traverseXmlTree.bind(this,o,r[i]));}return P.then(function(){for(var j=0,m=e.length;j<m;j++){if(e[j].getAttribute("id")){e[j].setAttribute("id",I+"."+e[j].getAttribute("id"));}else{throw new Error("At least one control does not have a stable ID");}}return C;});},_getElementNodeChildren:function(N){var C=[];var e=N.childNodes;for(var i=0,n=e.length;i<n;i++){if(e[i].nodeType===1){C.push(e[i]);}}return C;},_getControlMetadataInXml:function(C){var s=this._getControlTypeInXml(C).replace(/\./g,"/");var o=sap.ui.require(s);if(o&&o.getMetadata){return Promise.resolve(o.getMetadata());}return new Promise(function(r,R){sap.ui.require([s],function(e){if(e.getMetadata){r(e.getMetadata());}R(new Error("getMetadata function is not available on control type"));},function(){R(new Error("Required control '"+s+"' couldn't be found"));});});},getControlMetadata:function(C){},getLibraryName:function(C){return this.getControlMetadata(C).then(function(m){return m.getLibraryName();});},_getControlTypeInXml:function(C){var s=C.namespaceURI;s=s?s+".":"";s+=C.localName;return s;},_traverseXmlTree:function(C,r){function e(p,o,i){return Promise.resolve().then(function(){if(!i){return this._getControlMetadataInXml(o,true);}return undefined;}.bind(this)).then(function(m){return m&&m.getAllAggregations();}).then(function(A){var f=this._getElementNodeChildren(o);var P=Promise.resolve();f.forEach(function(g){var I=A&&A[g.localName];P=P.then(function(){return e.call(this,o,g,I).then(function(){if(!I){C(g);}});}.bind(this));}.bind(this));return P;}.bind(this));}return e.call(this,r,r,false);},_getSerializedValue:function(p){if(this._isSerializable(p)&&typeof p!=="string"){return JSON.stringify(p);}return p;},_isSerializable:function(p){return d(p)||Array.isArray(p)||Object(p)!==p;},_escapeCurlyBracketsInString:function(p){return typeof p==="string"?p.replace(/({|})/g,"\\$&"):p;},_templateFragment:function(f,p){return Promise.resolve(c.process(b.loadTemplate(f,"fragment"),{name:f},p));},getPropertyBindingOrProperty:function(C,p){var P=this.getPropertyBinding(C,p);if(P){return Promise.resolve(P);}return this.getProperty(C,p);},setPropertyBindingOrProperty:function(C,p,B){var i=B&&(B.path||B.parts);var I=B&&typeof B==="string"&&B.substring(0,1)==="{"&&B.slice(-1)==="}";var o=i||I?"setPropertyBinding":"setProperty";this[o](C,p,B);},setVisible:function(C,v){},getVisible:function(C){},setStashed:function(C,s){},getStashed:function(C){},bindProperty:function(C,p,B){},unbindProperty:function(C,p){},bindAggregation:function(C,A,B){},unbindAggregation:function(C,A){},setProperty:function(C,p,P){},getProperty:function(C,p){},isPropertyInitial:function(C,p){},setPropertyBinding:function(C,p,P){},getPropertyBinding:function(C,p){},createAndAddCustomData:function(C,s,v,A){},createControl:function(C,A,v,s,S){},applySettings:function(C,s){},_byId:function(i,v){},getId:function(C){},getParent:function(C){},getControlType:function(C){},setAssociation:function(p,n,i){},getAssociation:function(p,n){},getAllAggregations:function(C){},getAggregation:function(p,n){},insertAggregation:function(p,A,o,i,v,s){},removeAggregation:function(p,A,o){},removeAllAggregation:function(p,A){},getBindingTemplate:function(C,A){},updateAggregation:function(p,A){},findIndexInParentAggregation:function(C){},getParentAggregationName:function(C,p){},findAggregation:function(C,A){},validateType:function(C,A,p,f,i){},instantiateFragment:function(f,n,v){},templateControlFragment:function(f,p,v){},destroy:function(C){},getChangeHandlerModulePath:function(C){return this._getFlexCustomData(C,"flexibility");},_getFlexCustomData:function(C){},getFlexDelegate:function(C){var D;var s=this._getFlexCustomData(C,"delegate");if(typeof s==="string"){try{D=JSON.parse(s);if(D.payload===undefined){D.payload={};}}catch(e){L.error("Flex Delegate for control "+this.getId(C)+" is malformed",e.message);}}return D;},attachEvent:function(C,e,f,D){},detachEvent:function(C,e,f){},getExtensionPointInfo:function(e,v){}};});
sap.ui.predefine('sap/ui/core/util/reflection/JsControlTreeModifier',["sap/ui/base/BindingParser","./BaseTreeModifier","./XmlTreeModifier","sap/base/util/ObjectPath","sap/ui/util/XMLHelper","sap/base/util/merge","sap/ui/core/Fragment"],function(B,a,X,O,b,m,F){"use strict";var J={targets:"jsControlTree",setVisible:function(c,v){if(c.setVisible){this.unbindProperty(c,"visible");c.setVisible(v);}else{throw new Error("Provided control instance has no setVisible method");}},getVisible:function(c){if(c.getVisible){return Promise.resolve(c.getVisible());}else{return Promise.reject(new Error("Provided control instance has no getVisible method"));}},setStashed:function(c,s){s=!!s;if(c.unstash){if(c.isStashed()===true&&s===false){c=c.unstash();}if(c.setVisible){this.setVisible(c,!s);}return c;}else{throw new Error("Provided control instance has no unstash method");}},getStashed:function(c){if(c.isStashed){if(c.isStashed()){return Promise.resolve(true);}return this.getVisible(c).then(function(i){return!i;});}return Promise.reject(new Error("Provided control instance has no isStashed method"));},bindProperty:function(c,p,v){c.bindProperty(p,v);},unbindProperty:function(c,p){if(c){c.unbindProperty(p,true);}},setProperty:function(c,p,P){var M=c.getMetadata().getPropertyLikeSetting(p);var o;var e;this.unbindProperty(c,p);try{o=B.complexParser(P,undefined,true);}catch(d){e=true;}if(M){if(this._isSerializable(P)){if(o&&typeof o==="object"||e){P=this._escapeCurlyBracketsInString(P);}var s=M._sMutator;c[s](P);}else{throw new TypeError("Value cannot be stringified","sap.ui.core.util.reflection.JsControlTreeModifier");}}},getProperty:function(c,p){var M=c.getMetadata().getPropertyLikeSetting(p);var P;if(M){var s=M._sGetter;P=c[s]();}return Promise.resolve(P);},isPropertyInitial:function(c,p){return c.isPropertyInitial(p);},setPropertyBinding:function(c,p,P){this.unbindProperty(c,p);var s={};s[p]=P;return c.applySettings(s);},getPropertyBinding:function(c,p){return c.getBindingInfo(p);},createAndAddCustomData:function(c,C,v,A){return this.createControl("sap.ui.core.CustomData",A).then(function(o){this.setProperty(o,"key",C);this.setProperty(o,"value",v);return this.insertAggregation(c,"customData",o,0);}.bind(this));},createControl:function(c,A,v,s,S){c=c.replace(/\./g,"/");if(this.bySelector(s,A)){var e="Can't create a control with duplicated ID "+(s.id||s);return Promise.reject(e);}var p;var C=sap.ui.require(c);if(C){p=Promise.resolve(C);}else{p=new Promise(function(r,R){sap.ui.require([c],function(C){r(C);},function(){R(new Error("Required control '"+c+"' couldn't be created asynchronously"));});});}return p.then(function(d){var i=this.getControlIdBySelector(s,A);return new d(i,S);}.bind(this));},applySettings:function(c,s){return Promise.resolve(c.applySettings(s));},_byId:function(i){return sap.ui.getCore().byId(i);},getId:function(c){return c.getId();},getParent:function(c){return c.getParent&&c.getParent();},getControlMetadata:function(c){return Promise.resolve(c&&c.getMetadata());},getControlType:function(c){return c&&c.getMetadata().getName();},setAssociation:function(p,n,i){var M=p.getMetadata().getAssociation(n);M.set(p,i);},getAssociation:function(p,n){var M=p.getMetadata().getAssociation(n);return M.get(p);},getAllAggregations:function(p){return Promise.resolve(p.getMetadata().getAllAggregations());},getAggregation:function(p,n){return this.findAggregation(p,n).then(function(A){if(A){return p[A._sGetter]();}return undefined;});},insertAggregation:function(p,n,o,i){if(n==="customData"){return p.insertAggregation(n,o,i,true);}return this.findAggregation(p,n).then(function(A){if(A){if(A.multiple){var I=i||0;p[A._sInsertMutator](o,I);}else{p[A._sMutator](o);}}});},removeAggregation:function(c,n,o){if(n==="customData"){c.removeAggregation(n,o,true);return Promise.resolve();}return this.findAggregation(c,n).then(function(A){if(A){c[A._sRemoveMutator](o);}});},removeAllAggregation:function(c,n){if(n==="customData"){c.removeAllAggregation(n,true);return Promise.resolve();}return this.findAggregation(c,n).then(function(A){if(A){c[A._sRemoveAllMutator]();}});},getBindingTemplate:function(c,A){var o=c.getBindingInfo(A);return Promise.resolve(o&&o.template);},updateAggregation:function(c,A){return this.findAggregation(c,A).then(function(o){if(o&&c.getBinding(A)){c[o._sDestructor]();c.updateAggregation(A);}});},findIndexInParentAggregation:function(c){var p=this.getParent(c);if(!p){return Promise.resolve(-1);}return this.getParentAggregationName(c).then(function(P){return this.getAggregation(p,P);}.bind(this)).then(function(C){if(Array.isArray(C)){return C.indexOf(c);}else{return 0;}});},getParentAggregationName:function(c){return Promise.resolve(c.sParentAggregationName);},findAggregation:function(c,A){return new Promise(function(r,d){if(c){if(c.getMetadata){var M=c.getMetadata();var o=M.getAllAggregations();if(o){r(o[A]);return;}}}r();});},validateType:function(c,A,p,f){var t=A.type;return this.getAggregation(p,A.name).then(function(o){if(A.multiple===false&&o&&o.length>0){return false;}return c.isA(t);});},instantiateFragment:function(f,n,v){var o=b.parse(f);return this._checkAndPrefixIdsInFragment(o,n).then(function(o){return F.load({definition:o,sId:v&&v.getId(),controller:v.getController()});}).then(function(N){if(N&&!Array.isArray(N)){N=[N];}return N||[];});},templateControlFragment:function(f,p,v){return a._templateFragment(f,p).then(function(o){var c=(v&&v.getController())||undefined;return F.load({definition:o,controller:c});});},destroy:function(c,s){c.destroy(s);},_getFlexCustomData:function(c,t){var C=typeof c==="object"&&typeof c.data==="function"&&c.data("sap-ui-custom-settings");return O.get(["sap.ui.fl",t],C);},attachEvent:function(o,e,f,d){return new Promise(function(r,R){var c=O.get(f);if(typeof c!=="function"){R(new Error("Can't attach event because the event handler function is not found or not a function."));}r(o.attachEvent(e,d,c));});},detachEvent:function(o,e,f){return new Promise(function(r,R){var c=O.get(f);if(typeof c!=="function"){R(new Error("Can't attach event because the event handler function is not found or not a function."));}r(o.detachEvent(e,c));});},bindAggregation:function(c,A,o){return Promise.resolve(c.bindAggregation(A,o));},unbindAggregation:function(c,A){return Promise.resolve(c.unbindAggregation(A));},getExtensionPointInfo:function(e,v){var V=(v._xContent)?v._xContent:v;return X.getExtensionPointInfo(e,V).then(function(E){if(E){E.index--;E.parent=E.parent&&this._byId(v.createId(E.parent.getAttribute("id")));E.defaultContent=E.defaultContent.map(function(n){var i=v.createId(n.getAttribute("id"));return this._byId(i);}.bind(this)).filter(function(c){return!!c;});}return E;}.bind(this));}};return m({},a,J);},true);
sap.ui.predefine('sap/ui/core/util/reflection/XmlTreeModifier',["./BaseTreeModifier","sap/ui/base/ManagedObject","sap/ui/base/DataType","sap/base/util/merge","sap/ui/util/XMLHelper","sap/ui/core/mvc/EventHandlerResolver","sap/base/util/includes","sap/base/util/ObjectPath","sap/base/util/isPlainObject","sap/ui/core/Fragment"],function(B,M,D,m,X,E,a,O,b,F){"use strict";var C="http://schemas.sap.com/sapui5/extension/sap.ui.core.CustomData/1";var c=m({},B,{targets:"xmlTree",setVisible:function(o,v){if(v){o.removeAttribute("visible");}else{o.setAttribute("visible",v);}},getVisible:function(o){return c.getProperty(o,"visible");},setStashed:function(o,s){if(!s){o.removeAttribute("stashed");}else{o.setAttribute("stashed",s);}c.setVisible(o,!s);},getStashed:function(o){return Promise.all([c.getProperty(o,"stashed"),c.getProperty(o,"visible")]).then(function(p){return!!p[0]||!p[1];});},bindProperty:function(o,p,v){o.setAttribute(p,"{"+v+"}");},unbindProperty:function(o,p){o.removeAttribute(p);},_setProperty:function(o,p,P,e){var v=c._getSerializedValue(P);if(e){v=c._escapeCurlyBracketsInString(v);}o.setAttribute(p,v);},setProperty:function(o,p,P){c._setProperty(o,p,P,true);},getProperty:function(o,p){var P;var t;var v=o.getAttribute(p);return c.getControlMetadata(o).then(function(d){P=d.getProperty(p);if(P){t=P.getType();if(p==="value"&&c.getControlType(o)==="sap.ui.core.CustomData"){return c.getProperty(o,"key").then(function(k){if(k==="sap-ui-custom-settings"){t=D.getType("object");}});}}return undefined;}).then(function(){if(P){if(v===null){v=P.getDefaultValue()||t.getDefaultValue();}else{var u=M.bindingParser(v,undefined,true);if(b(u)){if(u.path||u.parts){v=undefined;}else{v=u;}}else{v=t.parseValue(u||v);}}}return v;});},isPropertyInitial:function(o,p){var P=o.getAttribute(p);return(P==null);},setPropertyBinding:function(o,p,P){if(typeof P!=="string"){throw new Error("For XML, only strings are supported to be set as property binding.");}o.setAttribute(p,P);},getPropertyBinding:function(o,p){var P=o.getAttribute(p);if(P){var u=M.bindingParser(P,undefined,true);if(u&&(u.path||u.parts)){return u;}}return undefined;},createAndAddCustomData:function(o,s,v){o.setAttributeNS(C,"custom.data.via.modifier:"+s,c._escapeCurlyBracketsInString(v));return Promise.resolve();},createControl:function(s,A,v,S,d,e){var i,l,o;if(!c.bySelector(S,A,v)){var f=s.split('.');var n="";if(f.length>1){l=f.pop();n=f.join('.');}var N=v.ownerDocument.createElementNS(n,l);i=c.getControlIdBySelector(S,A);if(i){N.setAttribute("id",i);}return Promise.resolve().then(function(){if(d){return c.applySettings(N,d);}return undefined;}).then(function(){return Promise.resolve(N);});}else{o=new Error("Can't create a control with duplicated ID "+i);return Promise.reject(o);}},applySettings:function(o,s){return c.getControlMetadata(o).then(function(d){var e=d.getJSONKeys();Object.keys(s).forEach(function(k){var K=e[k];var v=s[k];switch(K._iKind){case 0:c._setProperty(o,k,v,false);break;case 3:c.setAssociation(o,k,v);break;default:throw new Error("Unsupported in applySettings on XMLTreeModifier: "+k);}});});},_byId:function(i,v){if(v){if(v.ownerDocument&&v.ownerDocument.getElementById&&v.ownerDocument.getElementById(i)){return v.ownerDocument.getElementById(i);}return v.querySelector("[id='"+i+"']");}return undefined;},getId:function(o){return o.getAttribute("id");},getParent:function(o){var p=o.parentNode;if(!c.getId(p)&&!c._isExtensionPoint(p)){p=p.parentNode;}return p;},_getLocalName:function(x){return x.localName||x.baseName||x.nodeName;},getControlType:function(o){return c._getControlTypeInXml(o);},setAssociation:function(p,n,i){if(typeof i!=="string"){i=c.getId(i);}p.setAttribute(n,i);},getAssociation:function(p,n){return p.getAttribute(n);},getAllAggregations:function(o){return c.getControlMetadata(o).then(function(d){return d.getAllAggregations();});},getAggregation:function(p,n){var d=[];var s;return c._isSingleValueAggregation(p,n).then(function(S){s=S;return c._findAggregationNode(p,n);}).then(function(A){if(A){return c._getControlsInAggregation(p,A).then(function(e){d=e;});}return c._isAltTypeAggregation(p,n).then(function(i){if(i&&s){return c.getProperty(p,n).then(function(o){d.push(o);});}return undefined;});}).then(function(){if(n==="customData"){var e;var N=Array.prototype.slice.call(p.attributes).reduce(function(f,A){var l=c._getLocalName(A);if(A.namespaceURI===C){var o=p.ownerDocument.createElementNS("sap.ui.core","CustomData");o.setAttribute("key",l);o.setAttribute("value",A.value);f.push(o);}else if(A.namespaceURI&&A.name.indexOf("xmlns:")!==0){if(!e){e={};}if(!e.hasOwnProperty(A.namespaceURI)){e[A.namespaceURI]={};}e[A.namespaceURI][l]=A.nodeValue;}return f;},[]);d=d.concat(N);if(e){var o=p.ownerDocument.createElementNS("sap.ui.core","CustomData");o.setAttribute("key","sap-ui-custom-settings");c.setProperty(o,"value",e);d.push(o);}}return s?d[0]:d;});},insertAggregation:function(p,n,o,I,v,s){return c._findAggregationNode(p,n).then(function(A){if(!A){var N=p.namespaceURI;return c.createControl(N+"."+n,undefined,v).then(function(A){p.appendChild(A);return A;});}return A;}).then(function(A){if(!s){var d=A.children;var e=0;var S=(I<d.length)?I:d.length;for(var i=0;i<S;i++){if(d[i].namespaceURI==="sap.ui.core"&&d[i].tagName.indexOf("ExtensionPoint")>-1){e=e+1-d[i].children.length;}}I=I+e;}if(I>=A.childElementCount){A.appendChild(o);}else{return c._getControlsInAggregation(p,A).then(function(r){A.insertBefore(o,r[I]);});}return undefined;});},removeAggregation:function(p,n,o){return c._findAggregationNode(p,n).then(function(A){A.removeChild(o);});},removeAllAggregation:function(o,n){return c._findAggregationNode(o,n).then(function(A){if(o===A){return c._getControlsInAggregation(o,o).then(function(d){d.forEach(function(e){o.removeChild(e);});});}return o.removeChild(A);});},_findAggregationNode:function(p,n){var A;var d=c._children(p);for(var i=0;i<d.length;i++){var N=d[i];if(N.localName===n){A=N;break;}}var P=Promise.resolve(A);if(!A){P=P.then(c._isDefaultAggregation.bind(c,p,n)).then(function(I){if(I){return p;}return A;});}return P;},_isDefaultAggregation:function(p,A){return c.getControlMetadata(p).then(function(o){var d=o.getDefaultAggregation();return d&&A===d.name;});},_isNotNamedAggregationNode:function(p,o){return c.getAllAggregations(p).then(function(A){var d=A[o.localName];return p.namespaceURI!==o.namespaceURI||!d;});},_isSingleValueAggregation:function(p,A){return c.getAllAggregations(p).then(function(d){var o=d[A];return!o.multiple;});},_isAltTypeAggregation:function(p,A){return c.getControlMetadata(p).then(function(o){return o.getAllAggregations()[A];}).then(function(o){return!!o.altTypes;});},_isExtensionPoint:function(o){return c._getControlTypeInXml(o)==="sap.ui.core.ExtensionPoint";},getControlMetadata:function(o){return c._getControlMetadataInXml(o);},_getControlsInAggregation:function(p,A){var d=Array.prototype.slice.call(c._children(A));return Promise.all(d.map(function(o){return c._isNotNamedAggregationNode(p,o).then(function(i){return i?o:undefined;});})).then(function(d){return d.filter(function(o){return!!o;});});},_children:function(p){if(p.children){return p.children;}else{var d=[];for(var i=0;i<p.childNodes.length;i++){var n=p.childNodes[i];if(n.nodeType===n.ELEMENT_NODE){d.push(n);}}return d;}},getBindingTemplate:function(o,A){return c._findAggregationNode(o,A).then(function(d){if(d){var e=c._children(d);if(e.length===1){return e[0];}}return undefined;});},updateAggregation:function(o,A){},findIndexInParentAggregation:function(o){var p=c.getParent(o);if(!p){return Promise.resolve(-1);}return c.getParentAggregationName(o,p).then(function(A){return c.getAggregation(p,A);}).then(function(d){if(Array.isArray(d)){var P=d.map(function(o){return Promise.resolve().then(function(){if(c._isExtensionPoint(o)){return o;}return c.getProperty(o,"stashed").then(function(e){return!e?o:undefined;});});});return Promise.all(P).then(function(d){return d.filter(function(o){return!!o;}).indexOf(o);});}else{return 0;}});},getParentAggregationName:function(o,p){return Promise.resolve().then(function(){if(!p.isSameNode(o.parentNode)){return false;}else{return c._isNotNamedAggregationNode(p,o);}}).then(function(n){if(n){return c.getControlMetadata(p).then(function(d){return d.getDefaultAggregationName();});}else{return c._getLocalName(o.parentNode);}});},findAggregation:function(o,A){return c.getControlMetadata(o).then(function(d){return d.getAllAggregations();}).then(function(d){if(d){return d[A];}return undefined;});},validateType:function(o,A,p,f,i){var t=A.type;return c.getAggregation(p,A.name).then(function(d){if(A.multiple===false&&d&&d.length>0){return false;}return F.load({definition:f});}).then(function(d){if(!Array.isArray(d)){d=[d];}var r=d[i].isA(t);d.forEach(function(e){e.destroy();});return r;});},instantiateFragment:function(f,n,v){var o=X.parse(f);return c._checkAndPrefixIdsInFragment(o,n).then(function(o){var d;if(o.localName==="FragmentDefinition"){d=c._getElementNodeChildren(o);}else{d=[o];}d.forEach(function(N){if(c._byId(N.getAttribute("id"),v)){throw Error("The following ID is already in the view: "+N.getAttribute("id"));}});return d;});},templateControlFragment:function(f,p){return B._templateFragment(f,p).then(function(o){return c._children(o);});},destroy:function(o){var p=o.parentNode;if(p){p.removeChild(o);}},_getFlexCustomData:function(o,t){if(!o){return undefined;}return o.getAttributeNS("sap.ui.fl",t);},attachEvent:function(n,e,f,d){if(typeof O.get(f)!=="function"){return Promise.reject(new Error("Can't attach event because the event handler function is not found or not a function."));}return c.getProperty(n,e).then(function(v){v=v||"";var g=E.parse(v);var s=f;var p=["$event"];if(d){p.push(JSON.stringify(d));}s+="("+p.join(",")+")";if(!a(g,s)){g.push(s);}n.setAttribute(e,g.join(";"));});},detachEvent:function(n,e,f){if(typeof O.get(f)!=="function"){return Promise.reject(new Error("Can't attach event because the event handler function is not found or not a function."));}return c.getProperty(n,e).then(function(v){v=v||"";var d=E.parse(v);var i=d.findIndex(function(s){return s.includes(f);});if(i>-1){d.splice(i,1);}if(d.length){n.setAttribute(e,d.join(";"));}else{n.removeAttribute(e);}});},bindAggregation:function(n,A,v,V){return Promise.resolve().then(function(){c.bindProperty(n,A,v.path);return c.insertAggregation(n,A,v.template,0,V);});},unbindAggregation:function(n,A){return Promise.resolve().then(function(){if(n.hasAttribute(A)){n.removeAttribute(A);return c.removeAllAggregation(n,A);}return undefined;});},getExtensionPointInfo:function(e,v){return Promise.resolve().then(function(){if(v&&e){var d=Array.prototype.slice.call(v.getElementsByTagNameNS("sap.ui.core","ExtensionPoint"));var f=d.filter(function(g){return g.getAttribute("name")===e;});var o=(f.length===1)?f[0]:undefined;if(o){var p=c.getParent(o);return Promise.all([c.getParentAggregationName(o,p),c.findIndexInParentAggregation(o)]).then(function(P){var g={parent:p,aggregationName:P[0],index:P[1]+1,defaultContent:Array.prototype.slice.call(c._children(o))};return g;});}}return undefined;});}});return c;},true);
sap.ui.predefine('sap/ui/core/util/serializer/HTMLViewSerializer',['sap/ui/base/EventProvider','./Serializer','./delegate/HTML','sap/ui/thirdparty/vkbeautify'],function(E,S,H,v){"use strict";
var a=E.extend("sap.ui.core.util.serializer.HTMLViewSerializer",{constructor:function(V,w,g,G){E.apply(this);this._oView=V;this._oWindow=w;this._fnGetControlId=g;this._fnGetEventHandlerName=G;}});
a.prototype.serialize=function(){var t=this;var s=function(C){return C instanceof this._oWindow.sap.ui.core.mvc.View&&C!==t._oView;};var c=new S(this._oView,new H(this._fnGetControlId,this._fnGetEventHandlerName),true,this._oWindow,s);var r=c.serialize();var V=[];V.push('<template');if(this._oView.getControllerName&&this._oView.getControllerName()){V.push(' data-controller-name="'+this._oView.getControllerName()+'"');}V.push(" >");V.push(r);V.push("</template>");return v.xml(V.join(""));};
return a;});
sap.ui.predefine('sap/ui/core/util/serializer/Serializer',['sap/ui/base/EventProvider',"sap/base/assert"],function(E,a){"use strict";
var S=E.extend("sap.ui.core.util.serializer.Serializer",{constructor:function(r,s,b,w,f,c){E.apply(this);this._oRootControl=r;this._delegate=s;this._bSkipRoot=!!b;this._oWindow=w||window;this._fnSkipAggregations=f;this._fnSkipElement=c;}});
S.prototype.serialize=function(){return this._serializeRecursive(this._oRootControl,0);};
S.prototype._serializeRecursive=function(c,l,A,b){a(typeof c!=="undefined","The control must not be undefined");var C=[];var w=(!this._bSkipRoot||l!==0);if(w){var s=this._delegate.start(c,A,b);var m=this._delegate.middle(c,A,b);C.push(s+m);}var d=c.getMetadata().getAllAggregations();if(d){for(var n in d){if(this._fnSkipAggregations&&this._fnSkipAggregations(c,n)){continue;}var e=[];var o=d[n];var v=c[o._sGetter]();if(c.getBindingPath(n)&&c.getBindingInfo(n).template){e.push(c.getBindingInfo(n).template);}else if(v&&v.length){for(var i=0;i<v.length;i++){var O=v[i];if(this._isObjectSerializable(O)){e.push(O);}}}else if(this._isObjectSerializable(v)){e.push(v);}if(e.length>0){if(w){C.push(this._delegate.startAggregation(c,n));}var f=this._isDefaultAggregation(c,n);for(var j=0;j<e.length;j++){C.push(this._serializeRecursive(e[j],l+1,n,f));}if(w){C.push(this._delegate.endAggregation(c,n));}}}}if(w){var g=this._delegate.end(c,A,b);C.push(g);}return C.join("");};
S.prototype._isObjectSerializable=function(o){return o instanceof this._oWindow.sap.ui.core.Element&&!(this._fnSkipElement&&this._fnSkipElement(o));};
S.prototype._isDefaultAggregation=function(c,A){return c.getMetadata().getDefaultAggregationName()===A;};
return S;});
sap.ui.predefine('sap/ui/core/util/serializer/ViewSerializer',['sap/ui/base/EventProvider','./HTMLViewSerializer','./XMLViewSerializer',"sap/base/assert"],function(E,H,X,a){"use strict";
var V=E.extend("sap.ui.core.util.serializer.ViewSerializer",{constructor:function(r,w,d){E.apply(this);this._oRootControl=r;this._oWindow=w||window;this._mViews={};this._sDefaultXmlNamespace=d;}});
V.prototype.serializeToXML=function(){return this.serialize("XML");};
V.prototype.serializeToHTML=function(){return this.serialize("HTML");};
V.prototype.serialize=function(c){this._mViews={};this._sConvertToViewType=c||undefined;return this._serializeRecursive(this._oRootControl);};
V.prototype._getViewType=function(v){if(!this._sConvertToViewType){if(v instanceof this._oWindow.sap.ui.core.mvc.HTMLView){return"HTML";}else if(v instanceof this._oWindow.sap.ui.core.mvc.XMLView){return"XML";}}return this._sConvertToViewType;};
V.prototype._serializeRecursive=function(c){a(typeof c!=="undefined","The control must not be undefined");if(c instanceof this._oWindow.sap.ui.core.mvc.View){var v=this._getViewSerializer(c,this._getViewType(c));if(v){var o=c.getViewName()||c.getControllerName();if(!this._mViews[o]){this._mViews[o]=v.serialize(this._getViewType(c));}}}if(c.getMetadata().getClass()===this._oWindow.sap.ui.core.UIArea){var C=c.getContent();for(var i=0;i<C.length;i++){this._serializeRecursive(C[i]);}}else if(c.getMetadata().getClass()===this._oWindow.sap.ui.core.ComponentContainer){this._serializeRecursive(c.getComponentInstance().getRootControl());}else{var A=c.getMetadata().getAllAggregations();if(A){for(var n in A){var b=A[n];var d=c[b._sGetter]();if(d&&d.length){for(var i=0;i<d.length;i++){var O=d[i];if(O instanceof this._oWindow.sap.ui.core.Element){this._serializeRecursive(O);}}}else if(d instanceof this._oWindow.sap.ui.core.Element){this._serializeRecursive(d);}}}}return this._mViews;};
V.prototype._getViewSerializer=function(v,t){var g=function(e){if(e.fFunction&&e.fFunction._sapui_handlerName){var h=e.fFunction._sapui_handlerName;var c=v.getController();if(c[h]||sap.ui.getCore().getConfiguration().getControllerCodeDeactivated()){return h;}}};var G=function(c){if(c._sapui_controlId){return c._sapui_controlId;}return c.getId().replace(v.createId(""),"");};if(t==="HTML"){return new H(v,this._oWindow,G,g);}else if(t==="XML"){return new X(v,this._oWindow,this._sDefaultXmlNamespace,G,g);}else{var t=(v)?v.constructor:"?";throw Error("View type '"+t+"' is not supported for conversion. Only HTML and XML is supported");}};
return V;});
sap.ui.predefine('sap/ui/core/util/serializer/XMLViewSerializer',['sap/ui/base/EventProvider','./Serializer','./delegate/XML','sap/ui/thirdparty/vkbeautify'],function(E,S,X,v){"use strict";
var a=E.extend("sap.ui.core.util.serializer.XMLViewSerializer",{constructor:function(V,w,d,g,G){E.apply(this);this._oView=V;this._oWindow=w;this._sDefaultNamespace=d;this._fnGetControlId=g;this._fnGetEventHandlerName=G;}});
a.prototype.serialize=function(){var p=[];var m=function(C,P){if(!P){var T=(C)?C.constructor:"?";throw Error("Controls with empty package are currently not supported by the XML serializer: "+T);}if(p.indexOf(P)===-1){p.push(P);}};var t=this;var s=function(C){return C instanceof this._oWindow.sap.ui.core.mvc.View&&C!==t._oView;};var c=new S(this._oView,new X(this._sDefaultNamespace,this._fnGetControlId,this._fnGetEventHandlerName,m),true,this._oWindow,s);var r=c.serialize();var V=[];V.push('<sap.ui.core.mvc:View');if(this._oView.getControllerName&&this._oView.getControllerName()){V.push(' controllerName="'+this._oView.getControllerName()+'"');}if(p.indexOf('sap.ui.core.mvc')===-1){p.push('sap.ui.core.mvc');}for(var i=0;i<p.length;i++){if(this._sDefaultNamespace&&this._sDefaultNamespace===p[i]){V.push(' xmlns="'+p[i]+'"');}else{V.push(' xmlns:'+p[i]+'="'+p[i]+'"');}}V.push(" >");V.push(r);V.push("</sap.ui.core.mvc:View>");return v.xml(V.join(""));};
return a;});
sap.ui.predefine('sap/ui/core/util/serializer/delegate/Delegate',['sap/ui/base/EventProvider'],function(E){"use strict";
var D=E.extend("sap.ui.core.util.serializer.delegate.Delegate",{constructor:function(){E.apply(this);}});
D.prototype.start=function(c,a,i){return"";};
D.prototype.middle=function(c,a,i){return"";};
D.prototype.end=function(c,a,i){return"";};
D.prototype.startAggregation=function(c,a){return"";};
D.prototype.endAggregation=function(c,a){return"";};
return D;});
sap.ui.predefine('sap/ui/core/util/serializer/delegate/HTML',['./Delegate',"sap/base/strings/hyphenate","sap/base/util/deepEqual"],function(D,h,d){"use strict";
var H=D.extend("sap.ui.core.util.serializer.delegate.HTML",{constructor:function(g,G){D.apply(this);this._fnGetControlId=g;this._fnGetEventHandlerName=G;}});
H.prototype.startAggregation=function(c,a){return'<div data-sap-ui-aggregation="'+a+'">';};
H.prototype.endAggregation=function(c,a){return'</div>';};
H.prototype.start=function(c,a,i){return"<div";};
H.prototype.middle=function(c,a,b){var e=[];var I=(this._fnGetControlId)?this._fnGetControlId(c):c.getId();if(I.indexOf("__")!==0){e.push(this._createAttribute("id",I));}e.push(this._createAttribute("data-sap-ui-type",c.getMetadata()._sClassName));if(c.aCustomStyleClasses){var C=c.aCustomStyleClasses;var f=[];for(var i=0;i<C.length;i++){var s=C[i];if(!s.startsWith("sapM")&&!s.startsWith("sapUi")){f.push(s);}}if(f.length>0){e.push(this._createAttribute("class",f.join(" ")));}}if(this._fnGetEventHandlerName){var E=c.getMetadata().getAllEvents();for(var g in E){if(c.hasListeners(g)){var j=c.mEventRegistry[g];for(var i=0;i<j.length;i++){var k=this._fnGetEventHandlerName(j[i]);if(k){e.push(this._createAttribute("data-"+this._createHtmlAttributeName(g),k));break;}}}}}var A=c.getMetadata().getAllAssociations();this._createAttributes(e,c,A,function(n,v){if(A[n].multiple){return v.join(" ");}return v;},function(n,v){return(v!==null&&v!=="");});var p=c.getMetadata().getAllProperties();var o=c.getMetadata().getPropertyDefaults();this._createAttributes(e,c,p,null,function(n,v){return!d(v,o[n]);});var l=c.getMetadata().getAllAggregations();this._createAttributes(e,c,l,null,function(n,v){if(!c.getBindingInfo(n)&&(!v||(typeof v!=="string"))){return false;}return true;});e.push('>');return e.join('');};
H.prototype.end=function(c,a,i){return"</div>";};
H.prototype._createAttributes=function(a,c,o,g,v){for(var n in o){var p=o[n];var G=p._sGetter;if(c[G]){var V=c[G]();V=g?g(n,V):V;if(!c.getBindingInfo(n)){if(!v||v(n,V)){a.push(this._createAttribute("data-"+this._createHtmlAttributeName(n),V));}}else{a.push(this._createDataBindingAttribute(c,n,V));}}}};
H.prototype._createDataBindingAttribute=function(c,n,v){var b=c.getBindingInfo(n);var B=null;var p=v;if(!b.bindingString){if(b.binding){var C=b.binding.getMetadata().getName();if(C==="sap.ui.model.PropertyBinding"||C==="sap.ui.model.resource.ResourcePropertyBinding"){B=b.binding.getValue();}}if(b.parts){b=b.parts[0];}var m=b.model;if(B===v||B===null){p="{"+(m?(m+">"+b.path):b.path)+"}";}}else{p=b.bindingString;}return this._createAttribute("data-"+this._createHtmlAttributeName(n),p);};
H.prototype._createAttribute=function(a,v){return' '+a+'="'+v+'"';};
H.prototype._createHtmlAttributeName=function(n){return h(n);};
return H;});
sap.ui.predefine('sap/ui/core/util/serializer/delegate/XML',['./Delegate',"sap/base/util/deepEqual","sap/base/security/encodeXML"],function(D,d,e){"use strict";
var X=D.extend("sap.ui.core.util.serializer.delegate.XML",{constructor:function(s,g,G,m){D.apply(this);this._sDefaultNamespace=s;this._fnGetControlId=g;this._fnMemorizePackage=m;this._fnGetEventHandlerName=G;}});
X.prototype.startAggregation=function(c,a){return'<'+this._createAggregationName(c,a)+'>';};
X.prototype.endAggregation=function(c,a){return'</'+this._createAggregationName(c,a)+'>';};
X.prototype.start=function(c,a,i){return"<"+this._createTagName(c);};
X.prototype.end=function(c,a,i){return"</"+this._createTagName(c)+">";};
X.prototype.middle=function(c,a,b){var x=[];var I=(this._fnGetControlId)?this._fnGetControlId(c):c.getId();if(I.indexOf("__")!==0){x.push(this._createAttribute("id",I));}if(c.aCustomStyleClasses){var C=c.aCustomStyleClasses;var f=[];for(var i=0;i<C.length;i++){var s=C[i];if(!s.startsWith("sapM")&&!s.startsWith("sapUi")){f.push(s);}}if(f.length>0){x.push(this._createAttribute("class",f.join(" ")));}}if(this._fnGetEventHandlerName){var E=c.getMetadata().getAllEvents();for(var g in E){if(c.hasListeners(g)){var h=c.mEventRegistry[g];for(var i=0;i<h.length;i++){var H=this._fnGetEventHandlerName(h[i]);if(H){x.push(this._createAttribute(g,H));break;}}}}}var A=c.getMetadata().getAllAssociations();this._createAttributes(x,c,A,function(n,v){if(A[n].multiple){return v.join(" ");}return v;},function(n,v){return(v!==null&&v!=="");});var p=c.getMetadata().getAllProperties();var o=c.getMetadata().getPropertyDefaults();this._createAttributes(x,c,p,null,function(n,v){return!d(v,o[n]);});var j=c.getMetadata().getAllAggregations();this._createAttributes(x,c,j,null,function(n,v){if(!c.getBindingInfo(n)&&(!v||(typeof v!=="string"))){return false;}return true;});x.push('>');return x.join('');};
X.prototype._createAttributes=function(x,c,o,g,v){for(var n in o){var p=o[n];var G=p._sGetter;if(c[G]){var V=c[G]();V=g?g(n,V):V;if(!c.getBindingInfo(n)){if(!v||v(n,V)){x.push(this._createAttribute(n,V));}}else{x.push(this._createDataBindingAttribute(c,n,V));}}}};
X.prototype._createDataBindingAttribute=function(c,n,v){var b=c.getBindingInfo(n);var B=null;var p=v;if(!b.bindingString){if(b.binding){var C=b.binding.getMetadata().getName();if(C==="sap.ui.model.PropertyBinding"||C==="sap.ui.model.resource.ResourcePropertyBinding"){B=b.binding.getValue();}}if(b.parts){b=b.parts[0];}var m=b.model;if(B===v||B===null){p="{"+(m?(m+">"+b.path):b.path)+"}";}}else{p=b.bindingString;}return this._createAttribute(n,p);};
X.prototype._createAttribute=function(a,v){var E=(typeof v==="string"||v instanceof String)?e(v):v;return' '+a+'="'+E+'"';};
X.prototype._createTagName=function(c){var C=c.getMetadata()._sClassName;var l=C.lastIndexOf(".");var s=(l===-1)?C:C.substring(l+1);var p=(l===-1)?C:C.substring(0,l);if(this._fnMemorizePackage){this._fnMemorizePackage(c,p);}return this._createNamespace(p,s);};
X.prototype._createAggregationName=function(c,a){var C=c.getMetadata()._sClassName;var l=C.lastIndexOf(".");var p=(l===-1)?C:C.substring(0,l);return this._createNamespace(p,a);};
X.prototype._createNamespace=function(n,N){if(this._sDefaultNamespace&&this._sDefaultNamespace===n){return N;}else{return n+":"+N;}};
return X;});
sap.ui.predefine('sap/ui/core/ws/ReadyState',function(){"use strict";var R={CONNECTING:0,OPEN:1,CLOSING:2,CLOSED:3};return R;},true);
sap.ui.predefine('sap/ui/core/ws/SapPcpWebSocket',['./WebSocket',"sap/base/Log"],function(W,L){"use strict";
var S=W.extend("sap.ui.core.ws.SapPcpWebSocket",{constructor:function(u,p){W.apply(this,arguments);}});
S.SUPPORTED_PROTOCOLS={v10:"v10.pcp.sap.com"};S._deserializeRegexp=/((?:[^:\\]|(?:\\.))+):((?:[^:\\\n]|(?:\\.))*)/;S._SEPARATOR="\n\n";S._MESSAGE="MESSAGE";
S.prototype._onopen=function(){var s=false;if(this.getProtocol()===""){s=true;}else{for(var p in S.SUPPORTED_PROTOCOLS){if(S.SUPPORTED_PROTOCOLS.hasOwnProperty(p)){if(S.SUPPORTED_PROTOCOLS[p]===this.getProtocol()){s=true;break;}}}}if(s){this.fireOpen();}else{L.error("Unsupported protocol '"+this.getProtocol()+"' selected by the server. "+"Connection will be closed.");this.close("Unsupported protocol selected by the server");}};
S.prototype._onmessage=function(m){var s=-1,e={};if(typeof m.data==="string"){s=m.data.indexOf(S._SEPARATOR);}if(s!==-1){e.pcpFields=this._extractPcpFields(m.data.substring(0,s));e.data=m.data.substr(s+S._SEPARATOR.length);}else{L.warning("Invalid PCP message received: "+m.data);e.pcpFields={};e.data=m.data;}this.fireMessage(e);};
S.prototype._extractPcpFields=function(h){var f=h.split("\n"),l=[],p={};for(var i=0;i<f.length;i++){l=f[i].match(S._deserializeRegexp);if(l&&l.length===3){p[this._unescape(l[1])]=this._unescape(l[2]);}}return p;};
S.prototype._unescape=function(e){var p=e.split("\u0008"),u="";for(var i=0;i<p.length;i++){p[i]=p[i].replace(/\\\\/g,"\u0008").replace(/\\:/g,':').replace(/\\n/g,'\n').replace(/\u0008/g,"\\");}u=p.join("\u0008");return u;};
S.prototype._serializePcpFields=function(p,m,P){var s="",f="",a="";if(m==='string'){a='text';}else if(m==='blob'||m==='arraybuffer'){a='binary';}if(p&&typeof p==='object'){for(f in p){if(p.hasOwnProperty(f)&&f.indexOf('pcp-')!==0){s+=this._escape(f)+":"+this._escape(String(p[f]))+"\n";}}}return"pcp-action:"+P+"\npcp-body-type:"+a+"\n"+s+"\n";};
S.prototype._escape=function(u){return u.replace(/\\/g,'\\\\').replace(/:/g,'\\:').replace(/\n/g,'\\n');};
S.prototype.send=function(m,p){var M=typeof m,P="";P=this._serializePcpFields(p,M,S._MESSAGE);W.prototype.send.call(this,P+m);return this;};
return S;});
sap.ui.predefine('sap/ui/core/ws/WebSocket',['sap/ui/Device','sap/ui/base/EventProvider','./ReadyState','sap/ui/thirdparty/URI',"sap/base/Log","sap/ui/thirdparty/jquery"],function(D,E,R,U,L,q){"use strict";
var W=E.extend("sap.ui.core.ws.WebSocket",{
constructor:function(u,p){E.apply(this);if(!D.support.websocket){throw new Error("Browser does not support WebSockets.");}if(typeof(u)!=="string"){throw new Error("sUrl must be a string.");}if(typeof(p)!=='undefined'&&!Array.isArray(p)&&typeof(p)!=='string'){throw new Error("aProtocols must be a string, array of strings or undefined.");}this._openConnection(u,p);},
metadata:{publicMethods:["send","close","getReadyState","getProtocol"]}
});
W.prototype.getInterface=function(){return this;};
W.M_EVENTS={Open:"open",Close:"close",Error:"error",Message:"message"};
W.prototype.attachOpen=function(d,f,l){this.attachEvent("open",d,f,l);return this;};
W.prototype.detachOpen=function(f,l){this.detachEvent("open",f,l);return this;};
W.prototype.fireOpen=function(p){this.fireEvent("open",p);return this;};
W.prototype.attachClose=function(d,f,l){this.attachEvent("close",d,f,l);return this;};
W.prototype.detachClose=function(f,l){this.detachEvent("close",f,l);return this;};
W.prototype.fireClose=function(p){this.fireEvent("close",p);return this;};
W.prototype.attachError=function(d,f,l){this.attachEvent("error",d,f,l);return this;};
W.prototype.detachError=function(f,l){this.detachEvent("error",f,l);return this;};
W.prototype.fireError=function(p){this.fireEvent("error",p);return this;};
W.prototype.attachMessage=function(d,f,l){this.attachEvent("message",d,f,l);return this;};
W.prototype.detachMessage=function(f,l){this.detachEvent("message",f,l);return this;};
W.prototype.fireMessage=function(p){this.fireEvent("message",p);return this;};
W.prototype._resolveFullUrl=function(u){var o=new U(u);var b=new U(document.baseURI);b.search('');b.protocol(b.protocol()==='https'?'wss':'ws');o=o.absoluteTo(b);return o.toString();};
W.prototype._openConnection=function(u,p){var u=this._resolveFullUrl(u);this._oWs=(typeof(p)==='undefined')?new window.WebSocket(u):new window.WebSocket(u,p);this._oWs.onopen=q.proxy(this._onopen,this);this._oWs.onclose=q.proxy(this._onclose,this);this._oWs.onmessage=q.proxy(this._onmessage,this);this._oWs.onerror=q.proxy(this._onerror,this);};
W.prototype._onopen=function(){this.fireOpen();};
W.prototype._onclose=function(c){this.fireClose({code:c.code,reason:c.reason,wasClean:c.wasClean});};
W.prototype._onerror=function(e){this.fireError();};
W.prototype._onmessage=function(m){this.fireMessage({data:m.data});};
W.prototype.send=function(m){if(this.getReadyState()===R.OPEN){this._oWs.send(m);}else if(this.getReadyState()===R.CONNECTING){this.attachEventOnce("open",function(e){this._oWs.send(m);});}else{L.warning("Unable to send WebSocket message. "+"Connection is already closed or closing. message: "+m);}return this;};
W.prototype.close=function(c,r){if(typeof(c)==='string'){r=c;c=undefined;}c=(typeof(c)==='undefined')?1000:c;r=(typeof(r)==='undefined')?"":r;if(this.getReadyState()===R.OPEN){this._oWs.close(c,r);}else if(this.getReadyState()===R.CONNECTING){this.attachEventOnce("open",function(e){this._oWs.close(c,r);});}else{var t='';switch(this.getReadyState()){case R.CLOSED:t="Connection is already closed.";break;case R.CLOSING:t="Connection is already closing.";break;}L.warning("Unable to close WebSocket connection. "+t);}return this;};
W.prototype.getReadyState=function(){return this._oWs.readyState;};
W.prototype.getProtocol=function(){return this._oWs.protocol;};
return W;});
sap.ui.predefine('sap/ui/dom/denormalizeScrollBeginRTL',["sap/ui/util/_FeatureDetection"],function(_){"use strict";var d;if(_.initialScrollPositionIsZero()){d=function(n,o){return-n;};}else{d=function(n,o){return o.scrollWidth-o.clientWidth-n;};}var D=function(n,o){if(o){return d(n,o);}};return D;});
sap.ui.predefine('sap/ui/dom/denormalizeScrollLeftRTL',["sap/ui/util/_FeatureDetection"],function(_){"use strict";var d;if(_.initialScrollPositionIsZero()){d=function(n,o){return o.clientWidth+n-o.scrollWidth;};}else{d=function(n,o){return n;};}var D=function(n,o){if(o){return d(n,o);}};return D;});
sap.ui.predefine('sap/ui/dom/getFirstEditableInput',["sap/ui/thirdparty/jquery","sap/ui/dom/isHidden"],function(q,i){"use strict";
function f(c){return q(c).find('input, textarea').not('input[readonly],textarea[readonly],input[type=hidden],input[type=button],input[type=submit],input[type=reset],input[type=image],button').filter(':enabled:visible:first')[0];}
function g(c){if(!c||i(c)){return null;}return f(c);}
return g;});
sap.ui.predefine('sap/ui/dom/getOwnerWindow',[],function(){"use strict";var g=function o(d){if(d.ownerDocument.parentWindow){return d.ownerDocument.parentWindow;}return d.ownerDocument.defaultView;};return g;});
sap.ui.predefine('sap/ui/dom/isHidden',["sap/ui/thirdparty/jquery"],function(q){"use strict";
function i(e){return(e.offsetWidth<=0&&e.offsetHeight<=0)||q.css(e,'visibility')==='hidden';}
return i;});
sap.ui.predefine('sap/ui/dom/jquery/Aria',['sap/ui/thirdparty/jquery'],function(q){"use strict";
function a(A,v,p){var s=this.attr(A);if(!s){return this.attr(A,v);}var b=s.split(" ");if(b.indexOf(v)==-1){p?b.unshift(v):b.push(v);this.attr(A,b.join(" "));}return this;}
function r(A,v){var s=this.attr(A)||"",b=s.split(" "),i=b.indexOf(v);if(i==-1){return this;}b.splice(i,1);if(b.length){this.attr(A,b.join(" "));}else{this.removeAttr(A);}return this;}
q.fn.addAriaLabelledBy=function(i,p){return a.call(this,"aria-labelledby",i,p);};
q.fn.removeAriaLabelledBy=function(i){return r.call(this,"aria-labelledby",i);};
q.fn.addAriaDescribedBy=function(i,p){return a.call(this,"aria-describedby",i,p);};
q.fn.removeAriaDescribedBy=function(i){return r.call(this,"aria-describedby",i);};
return q;});
sap.ui.predefine('sap/ui/dom/jquery/Focusable',["sap/ui/thirdparty/jquery","sap/ui/dom/isHidden","./hasTabIndex"],function(q,i){"use strict";
function f(c,F){var C=F?c.firstChild:c.lastChild,o;while(C){if(C.nodeType==1&&!i(C)){if(q(C).hasTabIndex()){return C;}o=f(C,F);if(o){return o;}}C=F?C.nextSibling:C.previousSibling;}return null;}
q.fn.firstFocusableDomRef=function(){var c=this.get(0);if(!c||i(c)){return null;}return f(c,true);};
q.fn.lastFocusableDomRef=function(){var c=this.get(0);if(!c||i(c)){return null;}return f(c,false);};
return q;});
sap.ui.predefine('sap/ui/dom/jquery/Selection',["sap/ui/thirdparty/jquery"],function(q){"use strict";
q.fn.disableSelection=function(){return this.on(("onselectstart"in document.createElement("div")?"selectstart":"mousedown")+".ui-disableSelection",function(e){e.preventDefault();});};
q.fn.enableSelection=function(){return this.off(".ui-disableSelection");};
return q;});
sap.ui.predefine('sap/ui/dom/jquery/cursorPos',['sap/ui/thirdparty/jquery'],function(q){"use strict";var c=function a(p){var l=arguments.length,t,T;t=this.prop("tagName");T=this.prop("type");if(this.length===1&&((t=="INPUT"&&(T=="text"||T=="password"||T=="search"))||t=="TEXTAREA")){var d=this.get(0);if(l>0){if(typeof(d.selectionStart)=="number"){d.focus();d.selectionStart=p;d.selectionEnd=p;}return this;}else{if(typeof(d.selectionStart)=="number"){return d.selectionStart;}return-1;}}else{return this;}};q.fn.cursorPos=c;return q;});
sap.ui.predefine('sap/ui/dom/jquery/getSelectedText',['sap/ui/thirdparty/jquery'],function(q){"use strict";var g=function(){var d=this.get(0);try{if(typeof d.selectionStart==="number"){return d.value.substring(d.selectionStart,d.selectionEnd);}}catch(e){}return"";};q.fn.getSelectedText=g;return q;});
sap.ui.predefine('sap/ui/dom/jquery/hasTabIndex',["sap/ui/thirdparty/jquery"],function(q){"use strict";var h=function(e){var t=q.prop(e,"tabIndex");return t!=null&&t>=0&&(!q.attr(e,"disabled")||q.attr(e,"tabindex"));};
q.fn.hasTabIndex=function(){return h(this.get(0));};
return q;});
sap.ui.predefine('sap/ui/dom/jquery/parentByAttribute',['sap/ui/thirdparty/jquery'],function(q){"use strict";var p=function b(a,v){if(this.length>0){if(v){return this.first().parents("["+a+"='"+v+"']").get(0);}else{return this.first().parents("["+a+"]").get(0);}}};q.fn.parentByAttribute=p;return q;});
sap.ui.predefine('sap/ui/dom/jquery/rect',["sap/ui/thirdparty/jquery","sap/ui/dom/getOwnerWindow"],function(q,d){"use strict";var r=function a(){var D=this.get(0);if(D){if(D.getBoundingClientRect){var c=D.getBoundingClientRect();var R={top:c.top,left:c.left,width:c.right-c.left,height:c.bottom-c.top};var w=d(D);R.left+=q(w).scrollLeft();R.top+=q(w).scrollTop();return R;}else{return{top:10,left:10,width:D.offsetWidth,height:D.offsetHeight};}}return null;};q.fn.rect=r;return q;});
sap.ui.predefine('sap/ui/dom/jquery/rectContains',["sap/ui/thirdparty/jquery","sap/base/assert","sap/ui/dom/jquery/rect"],function(q,a){"use strict";var r=function b(p,P){a(!isNaN(p),"iPosX must be a number");a(!isNaN(P),"iPosY must be a number");var R=this.rect();if(R){return p>=R.left&&p<=R.left+R.width&&P>=R.top&&P<=R.top+R.height;}return false;};q.fn.rectContains=r;return q;});
sap.ui.predefine('sap/ui/dom/jquery/scrollLeftRTL',["sap/ui/dom/denormalizeScrollLeftRTL","sap/ui/util/_FeatureDetection","sap/ui/thirdparty/jquery"],function(d,_,q){"use strict";var s;if(_.initialScrollPositionIsZero()){s=function(D){return D.scrollWidth+D.scrollLeft-D.clientWidth;};}else{s=function(D){return D.scrollLeft;};}var S=function(p){var D=this.get(0);if(D){if(p===undefined){return s(D);}else{D.scrollLeft=d(p,D);return this;}}};q.fn.scrollLeftRTL=S;return q;});
sap.ui.predefine('sap/ui/dom/jquery/scrollRightRTL',["sap/ui/util/_FeatureDetection","sap/ui/thirdparty/jquery"],function(_,q){"use strict";var s;if(_.initialScrollPositionIsZero()){s=function(d){return(-d.scrollLeft);};}else{s=function(d){return d.scrollWidth-d.scrollLeft-d.clientWidth;};}var S=function(){var d=this.get(0);if(d){return s(d);}};q.fn.scrollRightRTL=S;return q;});
sap.ui.predefine('sap/ui/dom/jquery/selectText',['sap/ui/thirdparty/jquery'],function(q){"use strict";var s=function a(S,E){var d=this.get(0);try{if(typeof(d.selectionStart)==="number"){d.setSelectionRange(S>0?S:0,E);}}catch(e){}return this;};q.fn.selectText=s;return q;});
sap.ui.predefine('sap/ui/dom/units/Rem',['sap/base/assert'],function(a){"use strict";
function g(){var r=document.documentElement;if(!r){return 16;}return parseFloat(window.getComputedStyle(r).getPropertyValue("font-size"));}
var R={fromPx:function(p){a(((typeof p==="string")&&(p!=="")&&!isNaN(parseFloat(p))&&(typeof parseFloat(p)==="number"))||((typeof p==="number")&&!isNaN(p)),'Rem.fromPx: either the "vPx" parameter must be an integer, or a string e.g.: "16px"');return parseFloat(p)/g();},toPx:function(r){a(((typeof r==="string")&&(r!=="")&&!isNaN(parseFloat(r))&&(typeof parseFloat(r)==="number"))||((typeof r==="number")&&!isNaN(r)),'Rem.toPx: either the "vRem" parameter must be an integer, or a string e.g.: "1rem"');return parseFloat(r)*g();}};return R;});
sap.ui.predefine('sap/ui/events/isMouseEventDelayed',["sap/ui/Device"],function(D){"use strict";var i=function(n){n=n||navigator;return!!(D.browser.mobile&&!((D.os.ios&&D.os.version>=8&&D.browser.safari&&!D.browser.webview)||(D.browser.chrome&&!/SAMSUNG/.test(n.userAgent)&&D.browser.version>=32)));};return i;});
sap.ui.predefine('sap/ui/events/isSpecialKey',function(){"use strict";var i=function(e){function a(e){var k=e.key;return(k==='Shift')||(k==='Control')||(k==='Alt')||(k==='AltGraph')||(k==='CapsLock')||(k==='NumLock');}function b(e){var k=e.key;return(k==='ArrowLeft')||(k==='ArrowUp')||(k==='ArrowRight')||(k==='ArrowDown');}var k=e.key,s=a(e)||b(e)||k==='PageUp'||k==='PageDown'||k==='End'||k==='Home'||k==='PrintScreen'||k==='Insert'||k==='Delete'||k==='F1'||k==='F2'||k==='F3'||k==='F4'||k==='F5'||k==='F6'||k==='F7'||k==='F8'||k==='F9'||k==='F10'||k==='F11'||k==='F12'||k==='Pause'||k==='Backspace'||k==='Tab'||k==='Enter'||k==='Escape'||k==='ScrollLock';switch(e.type){case"keydown":case"keyup":case"keypress":return s;default:return false;}};return i;});
sap.ui.predefine('sap/ui/events/jquery/EventTriggerHook',['sap/base/Log','sap/ui/dom/containsOrEquals','sap/ui/thirdparty/jquery','sap/base/util/uid'],function(L,c,q,u){"use strict";var t={};
function T(e){var i=L.isLoggable(L.Level.DEBUG),E=t[e.type],o=E.originalTriggerHook,a=window.performance.now(),b,I,d;if(!e.isPropagationStopped()&&!e.isSimulated){for(I in E.domRefs){d=E.domRefs[I];if(d.excludedDomRefs.indexOf(e.target)===-1&&c(d.domRef,e.target)){e.preventDefault();e.stopImmediatePropagation();if(i){b=window.performance.now();L.debug("Perf: jQuery trigger suppression event handler "+e.type+" took "+(b-a)+" milliseconds.");}return false;}}}if(o){return o.call(this,e);}}
function _(e){if(!q.event.special[e]){q.event.special[e]={};}var S=q.event.special[e],o=S.trigger;S.trigger=T;return o;}
function s(e,d,E){var m=t[e];var i=u();if(!m){m=t[e]={domRefs:{},originalTriggerHook:_(e)};}m.domRefs[i]={domRef:d,excludedDomRefs:[].concat(E)};return{id:i,type:e};}
function r(h){if(!h){L.error("Release trigger events must not be called without passing a valid handler!");return;}var e=t[h.type];if(!e){return;}else if(!e.domRefs[h.id]||!e.domRefs[h.id].domRef){L.warning("Release trigger event for event type "+h.type+"on Control "+h.id+": DomRef does not exists");return;}delete e.domRefs[h.id];}
return{suppress:s,release:r};});
sap.ui.predefine('sap/ui/model/ClientTreeBindingAdapter',['sap/ui/model/TreeBinding','sap/ui/model/ClientTreeBinding','./TreeBindingAdapter','sap/ui/model/ChangeReason',"sap/base/assert","sap/base/Log"],function(T,C,a,b,c,L){"use strict";var d=function(){if(!(this instanceof T)||this._bIsAdapted){return;}a.apply(this);for(var f in d.prototype){if(d.prototype.hasOwnProperty(f)){this[f]=d.prototype[f];}}this._invalidTree=true;this.setNumberOfExpandedLevels(this.mParameters.numberOfExpandedLevels||0);};
d.prototype.setNumberOfExpandedLevels=function(n){this._iNumberOfExpandedLevels=parseInt(n);};
d.prototype.getNumberOfExpandedLevels=function(){return this._iNumberOfExpandedLevels;};
d.prototype.nodeHasChildren=function(n){c(n,"TreeBindingAdapter.nodeHasChildren: No node given!");if(!n){return false;}else if(n.isArtificial){return true;}else{return C.prototype.hasChildren.call(this,n.context);}};
d.prototype.resetData=function(o,p){var r=C.prototype.resetData.call(this,o,p);this._aRowIndexMap=[];this._oRootNode=undefined;this._iPageSize=0;this._iThreshold=0;if(!p||p.reason!==b.Sort){this.clearSelection();this._createTreeState(true);}return r;};
d.prototype._calculateGroupID=function(n){var B=this.getPath();var g;if(n.context){var s=n.context.getPath();if(B!="/"){var m=s.match(B+"(.*)");if(m!=null&&m[1]){g=m[1];}else{L.warning("CTBA: BindingPath/ContextPath matching problem!");}}if(!g){g=s;}if(g.startsWith("/")){g=g.substring(1,g.length);}var p;if(!n.parent){p=this._calculateGroupID({context:n.context._parentContext||null});}else{p=n.parent.groupID;}g=p+g.replace(/\//g,"_")+"/";}else if(n.context===null){g="/";}return g;};
d.prototype.expand=function(){this._buildTree();a.prototype.expand.apply(this,arguments);};
d.prototype.collapse=function(){this._buildTree();a.prototype.collapse.apply(this,arguments);};
d.prototype._buildTree=function(s,l){if(this._invalidTree){s=s||0;l=l||this.getRootContexts().length;this._invalidTree=false;this._aRowIndexMap=[];a.prototype._buildTree.call(this,s,l);}};
d.prototype.findNode=function(p){this._buildTree();return a.prototype.findNode.apply(this,arguments);};
d.prototype.setSelectedIndex=function(r){this._buildTree();a.prototype.setSelectedIndex.apply(this,arguments);};
d.prototype.setSelectionInterval=function(f,t){this._buildTree();a.prototype.setSelectionInterval.apply(this,arguments);};
d.prototype.addSelectionInterval=function(){this._buildTree();a.prototype.addSelectionInterval.apply(this,arguments);};
d.prototype.removeSelectionInterval=function(){this._buildTree();a.prototype.removeSelectionInterval.apply(this,arguments);};
d.prototype.clearSelection=function(){this._buildTree();a.prototype.clearSelection.apply(this,arguments);};
d.prototype.selectAll=function(){this._buildTree();a.prototype.selectAll.apply(this,arguments);};
d.prototype._calculateRequestLength=function(m,s){return m;};
d.prototype.getLength=function(){this._buildTree();return a.prototype.getLength.apply(this,arguments);};
d.prototype._fireChange=function(){this._invalidTree=true;this.constructor.prototype._fireChange.apply(this,arguments);};
return d;},true);
sap.ui.predefine('sap/ui/model/MetaModel',['./Model'],function(M){"use strict";
var a=M.extend("sap.ui.model.MetaModel",{constructor:function(){M.apply(this,arguments);}});
a.prototype.createBindingContext=function(p,c,P,C){if(typeof c=="function"){C=c;c=null;}if(typeof P=="function"){C=P;P=null;}var s=this.resolve(p,c),n=(s==undefined)?undefined:this.getContext(s?s:"/");if(!n){n=null;}if(C){C(n);}return n;};
a.prototype.destroyBindingContext=function(){};
return a;});
sap.ui.predefine('sap/ui/model/SelectionModel',['sap/ui/base/EventProvider',"sap/base/assert"],function(E,c){"use strict";
var S=E.extend("sap.ui.model.SelectionModel",{constructor:function(s){E.apply(this);this.iSelectionMode=s||S.SINGLE_SELECTION;this.aSelectedIndices=[];this.iLeadIndex=-1;this.fnSort=function(a,b){return a-b;};this.fnSortReverse=function(a,b){return b-a;};}});
S.SINGLE_SELECTION=0;S.MULTI_SELECTION=1;
S.prototype.getSelectionMode=function(){return this.iSelectionMode;};
S.prototype.setSelectionMode=function(s){this.iSelectionMode=s||S.SINGLE_SELECTION;};
S.prototype.isSelectedIndex=function(i){return this.aSelectedIndices.indexOf(i)!==-1;};
S.prototype.getLeadSelectedIndex=function(){return this.iLeadIndex;};
S.prototype.setLeadSelectedIndex=function(l){c(typeof l==="number","iLeadIndex must be an integer");this.setSelectionInterval(l,l);return this;};
S.prototype.getMinSelectionIndex=function(){if(this.aSelectedIndices.length>0){var i=this.aSelectedIndices.sort(this.fnSort);return i[0];}else{return-1;}};
S.prototype.getMaxSelectionIndex=function(){if(this.aSelectedIndices.length>0){var i=this.aSelectedIndices.sort(this.fnSortReverse);return i[0];}else{return-1;}};
S.prototype.getSelectedIndices=function(){var i=this.aSelectedIndices.sort(this.fnSort);return i;};
S.prototype.setSelectionInterval=function(f,t){c(typeof f==="number","iFromIndex must be an integer");c(typeof t==="number","iToIndex must be an integer");if(this.iSelectionMode===S.SINGLE_SELECTION){f=t;}var F=Math.min(f,t);var T=Math.max(f,t);var o=this.aSelectedIndices.slice();var l={};var C=[];for(var i=0;i<o.length;i++){l[o[i]]=true;if(o[i]<f||o[i]>t){C.push(o[i]);}}var s=[];for(var I=F;I<=T;I++){s.push(I);if(!l[I]){C.push(I);}}this._update(s,t,C);return this;};
S.prototype.addSelectionInterval=function(f,t){c(typeof f==="number","iFromIndex must be an integer");c(typeof t==="number","iToIndex must be an integer");if(this.iSelectionMode===S.SINGLE_SELECTION){return this.setSelectionInterval(f,t);}var F=Math.min(f,t);var T=Math.max(f,t);var C=[];var s=this.aSelectedIndices;for(var i=F;i<=T;i++){if(s.indexOf(i)===-1){s.push(i);C.push(i);}}this._update(s,T,C);return this;};
S.prototype.moveSelectionInterval=function(s,m){c(typeof s==="number","iFromIndex must be an integer");c(typeof m==="number","iToIndex must be an integer");var C=[];var a=this.aSelectedIndices;var l=this.iLeadIndex;for(var i=0;i<a.length;i++){var I=a[i];if(I>=s){C.push(a[i]);a[i]+=m;C.push(a[i]);if(I===this.iLeadIndex){l+=m;}}}this._update(a,l,C);return this;};
S.prototype.removeSelectionInterval=function(f,t){c(typeof f==="number","iFromIndex must be an integer");c(typeof t==="number","iToIndex must be an integer");if(this.iSelectionMode===S.SINGLE_SELECTION){f=t;}var F=Math.min(f,t);var T=Math.max(f,t);var C=[];var s=this.aSelectedIndices;var l=this.iLeadIndex;for(var i=F;i<=T;i++){var I=s.indexOf(i);if(I>-1){s.splice(I,1);C.push(i);}if(i===this.iLeadIndex){l=-1;}}this._update(s,l,C);return this;};
S.prototype.sliceSelectionInterval=function(f,t){c(typeof f==="number","iFromIndex must be an integer");c(typeof t==="number","iToIndex must be an integer");var F=Math.min(f,t);var T=Math.max(f,t);var C=[];var r=[];var o=this.aSelectedIndices.slice(0);var s=this.aSelectedIndices;var l=this.iLeadIndex;var R=T-F+1;for(var I=T;I>=F;I--){var a=s.indexOf(I);if(a>-1){s.splice(a,1);r.push(I);}if(I===this.iLeadIndex){l=-1;}}for(var I=0;I<s.length;I++){var O=s[I];if(O>=F){var n=s[I]-R;if(O===l){l=n;}s[I]=n;if(o.indexOf(n)===-1){C.push(n);}}}for(var i=0;i<r.length;i++){var I=o[o.length-1-i];if(C.indexOf(I)===-1){C.push(I);}}for(var i=0;i<r.length;i++){if(s.indexOf(r[i])===-1&&C.indexOf(r[i])===-1){C.push(r[i]);}}this._update(s,l,C);return this;};
S.prototype.clearSelection=function(){if(this.aSelectedIndices.length>0||this.iLeadIndex!==-1){this._update([],-1,this.aSelectedIndices.slice());}return this;};
S.prototype.attachSelectionChanged=function(d,f,l){this.attachEvent("selectionChanged",d,f,l);return this;};
S.prototype.detachSelectionChanged=function(f,l){this.detachEvent("selectionChanged",f,l);return this;};
S.prototype.fireSelectionChanged=function(p){this.fireEvent("selectionChanged",p);return this;};
S.prototype._update=function(s,l,C,b){var p={rowIndices:C&&C.sort(this.fnSort),selectAll:b};this.aSelectedIndices=s;p.oldIndex=this.iLeadIndex;if(this.iLeadIndex!==l){this.iLeadIndex=l;p.leadIndex=this.iLeadIndex;}if(C.length>0||typeof p.leadIndex!=="undefined"){this.fireSelectionChanged(p);}};
S.prototype.selectAll=function(t){c(typeof t==="number","iToIndex must be an integer");var o=this.aSelectedIndices.slice();var l={};var C=[];var s=[];var i=0;for(i=0;i<o.length;i++){l[o[i]]=true;if(o[i]>t){C.push(o[i]);}}for(i=0;i<=t;i++){s.push(i);if(!l[i]){C.push(i);}}this._update(s,0,C,true);return this;};
return S;});
sap.ui.predefine('sap/ui/model/TreeAutoExpandMode',[],function(){"use strict";var T={Sequential:"Sequential",Bundled:"Bundled"};return T;},true);
sap.ui.predefine('sap/ui/model/TreeBindingAdapter',['sap/ui/model/TreeBinding','sap/ui/model/TreeAutoExpandMode','sap/ui/model/ChangeReason','sap/ui/model/TreeBindingUtils',"sap/base/assert","sap/base/Log","sap/base/util/each","sap/base/util/isEmptyObject"],function(T,c,C,d,e,L,f,g){"use strict";var h=function(){if(!(this instanceof T)||this._bIsAdapted){return;}for(var a in h.prototype){if(h.prototype.hasOwnProperty(a)){this[a]=h.prototype[a];}}this.mParameters=this.mParameters||{};this._aRowIndexMap=[];this._iThreshold=0;this._iPageSize=0;this.setAutoExpandMode(this.mParameters.autoExpandMode||c.Sequential);if(this.mParameters.collapseRecursive===undefined){this.bCollapseRecursive=true;}else{this.bCollapseRecursive=!!this.mParameters.collapseRecursive;}this._createTreeState();this._bIsAdapted=true;};
h.prototype.getCurrentTreeState=function(){var D=";",G;var E={};for(G in this._mTreeState.expanded){E[G]=true;}var m={};for(G in this._mTreeState.collapsed){m[G]=true;}var s={};for(G in this._mTreeState.selected){s[G]=true;}return{_getExpandedList:function(){return Object.keys(E).join(D);},_getCollapsedList:function(){return Object.keys(m).join(D);},_getSelectedList:function(){return Object.keys(s).join(D);},_isExpanded:function(G){return!!E[G];},_isCollapsed:function(G){return!!m[G];},_remove:function(G){delete E[G];delete m[G];delete s[G];}};};
h.prototype.setTreeState=function(t){this._oInitialTreeState=t;};
h.prototype.setAutoExpandMode=function(a){this._autoExpandMode=a;};
h.prototype.getLength=function(){if(!this._oRootNode){return 0;}return this._oRootNode.magnitude;};
h.prototype.getContextByIndex=function(i){if(this.isInitial()){return undefined;}var n=this.findNode(i);return n?n.context:undefined;};
h.prototype.getNodeByIndex=function(i){if(this.isInitial()){return undefined;}if(i>=this.getLength()){return undefined;}return this.findNode(i);};
h.prototype.findNode=function(r){if(this.isInitial()){return undefined;}var p=typeof r;var F;var s=[];if(p==="number"){F=this._aRowIndexMap[r];if(!F){var i=-1;this._match(this._oRootNode,s,1,function(n){if(i===r){return true;}i+=1;return false;});F=s[0];}}return F;};
h.prototype._createTreeState=function(r){if(!this._mTreeState||r){this._mTreeState={expanded:{},collapsed:{},selected:{},deselected:{}};}};
h.prototype._updateTreeState=function(p){p=p||{};var t=p.expanded?this._mTreeState.expanded:this._mTreeState.collapsed;var s=p.expanded?this._mTreeState.collapsed:this._mTreeState.expanded;var n=this._getNodeState(p.groupID);if(!n){n=p.fallbackNodeState||this._createNodeState({groupID:p.groupID,expanded:p.expanded,sum:p.sum});}delete s[p.groupID];t[p.groupID]=n;n.expanded=p.expanded;return n;};
h.prototype._createNodeState=function(p){if(!p.groupID){e(false,"To create a node state a group ID is mandatory!");return undefined;}var i;var I;if(this._oInitialTreeState){i=this._oInitialTreeState._isExpanded(p.groupID);I=this._oInitialTreeState._isCollapsed(p.groupID);this._oInitialTreeState._remove(p.groupID);}var b=p.expanded||i||false;var a=p.selected||false;var n={groupID:p.groupID,expanded:b,sections:p.sections||[{startIndex:0,length:this._iPageSize}],sum:p.sum||false,selected:a};if(i||I){this._updateTreeState({groupID:p.groupID,fallbackNodeState:n,expanded:i,collapsed:I});}return n;};
h.prototype._getNodeState=function(G){var E=this._mTreeState.expanded[G];var o=this._mTreeState.collapsed[G];var s=this._mTreeState.selected[G];var D=this._mTreeState.deselected[G];return E||o||s||D;};
h.prototype._updateNodeSections=function(G,n){var N=this._getNodeState(G);if(!N){e(false,"No Node State for Group ID '"+G+"' found!");return undefined;}else if(!n){e(false,"No Section given!");return undefined;}else if(n.length<=0){e(false,"The length of the given section must be positive greater than 0.");return undefined;}else if(n.startIndex<0){e(false,"The sections start index must be greater/equal to 0.");return undefined;}N.sections=d.mergeSections(N.sections,n);return N.sections;};
h.prototype._increaseSections=function(){var I=function(n){if(!n){return;}var m=this._getMaxGroupSize(n);var N=n.nodeState;if(m===undefined){var a=[];for(var i=0;i<N.sections.length;i++){var o=N.sections[i];o.length=Math.max(o.length,this._iPageSize);a=d.mergeSections(a,o);}N.sections=a;}};this._map(this._oRootNode,I);};
h.prototype._getMaxGroupSize=function(n){var m=0;if(n.isArtificial){var i=this.oModel.isList(this.sPath,this.getContext());if(this.bDisplayRootNode&&!i&&!this._bRootMissing){m=1;}else{m=this._getGroupSize(n)||0;}}else{m=this.nodeHasChildren(n)?this._getGroupSize(n):0;}return m;};
h.prototype.getContexts=function(s,l,t){return this._getContextsOrNodes(false,s,l,t);};
h.prototype._getContextsOrNodes=function(r,s,l,t){var m,n,a=[],N=[];if(!this.isResolved()||this.isInitial()){return[];}if(!l){l=this.oModel.iSizeLimit;}if(!t){t=0;}if(l>this._iPageSize){this._iPageSize=l;this._increaseSections();}this._iThreshold=Math.max(this._iThreshold,t);this._aRowIndexMap=[];this._buildTree(s,l);if(this._oRootNode){N=this._retrieveNodeSection(this._oRootNode,s,l);}this._updateRowIndexMap(N,s);for(var i=0;i<N.length;i++){n=N[i];if(!n.context){m=m||{};var p=n.parent;m[p.groupID]=p;this._updateNodeSections(p.groupID,{startIndex:n.positionInParent,length:1});}a.push(n.context);}if(m){var b=this;f(m,function(G,n){n.magnitude=0;n.numberOfTotals=0;b._loadChildContexts(n);});a=[];for(var j=0;j<N.length;j++){n=N[j];a.push(n.context);}}if(r){return N;}else{return a;}};
h.prototype.getNodes=function(s,l,t){return this._getContextsOrNodes(true,s,l,t);};
h.prototype._updateRowIndexMap=function(n,s){this._aRowIndexMap=[];for(var i=0;i<n.length;i++){this._aRowIndexMap[s+i]=n[i];}};
h.prototype._retrieveNodeSection=function(n,s,l){var N=-1;var a=[];this._match(this._oRootNode,[],l,function(n,p,P){if(!n||!n.isArtificial){N++;}if(N>=s&&N<s+l){if(!n){n=this._createNode({parent:P,positionInParent:p});P.children[p]=n;}a.push(n);return true;}return false;});return a;};
h.prototype._buildTree=function(s,l){this._oRootNode=undefined;var r=null;var R=this._calculateGroupID({context:r,parent:null});var o=this._getNodeState(R);if(!o){o=this._createNodeState({groupID:R,sum:true,sections:[{startIndex:s,length:l}]});this._updateTreeState({groupID:o.groupID,fallbackNodeState:o,expanded:true});}this._oRootNode=this._createNode({context:r,parent:null,level:this.bDisplayRootNode&&!(r===null)?0:-1,nodeState:o,isLeaf:false,autoExpand:this.getNumberOfExpandedLevels()+1});this._oRootNode.isArtificial=true;if(this._mTreeState.expanded[this._oRootNode.groupID]){this._loadChildContexts(this._oRootNode);}};
h.prototype._calculateRequestLength=function(m,s){var r;if(!m){r=s.length;}else{r=Math.max(Math.min(s.length,m-s.startIndex),0);}return r;};
h.prototype._loadChildContexts=function(n){var N=n.nodeState;var m=this._getMaxGroupSize(n);if(m>0){if(!n.children[m-1]){n.children[m-1]=undefined;}N.leafCount=m;}if(this.bClientOperation){N.sections=[{startIndex:0,length:m}];}for(var i=0;i<N.sections.length;i++){var o=N.sections[i];var r=this._calculateRequestLength(m,o);if(n.autoExpand>=0&&this._autoExpandMode===c.Bundled){r=Math.max(0,m);}var a;if(n.isArtificial){a=this.getRootContexts(o.startIndex,r,this._iThreshold);}else{a=this.nodeHasChildren(n)?this.getNodeContexts(n.context,o.startIndex,r,this._iThreshold):[];}for(var j=0;j<a.length;j++){var b=a[j];if(!b){continue;}var k=j+o.startIndex;var l=n.children[k];var u={context:a[j],parent:n,level:n.level+1,positionInParent:k,autoExpand:Math.max(n.autoExpand-1,-1)};if(l){l.context=u.context;l.parent=u.parent;l.level=u.level;l.positionInParent=u.positionInParent;l.magnitude=0;l.numberOfTotals=0;l.autoExpand=u.autoExpand;var G;if(b){G=this._calculateGroupID(l);}l.groupID=G;}else{l=this._createNode(u);}l.nodeState=this._getNodeState(l.groupID);if(!l.nodeState){l.nodeState=this._createNodeState({groupID:l.groupID,expanded:false});}l.nodeState.parentGroupID=n.groupID;l.isLeaf=!this.nodeHasChildren(l);n.children[k]=l;if(l.isLeaf){n.numberOfLeafs+=1;}if(l.parent.nodeState.selectAllMode&&!this._mTreeState.deselected[l.groupID]){this.setNodeSelection(l.nodeState,true);}if((l.autoExpand>0||l.nodeState.expanded)&&this.isGrouped()){if(!this._mTreeState.collapsed[l.groupID]&&!l.isLeaf){this._updateTreeState({groupID:l.nodeState.groupID,fallbackNodeState:l.nodeState,expanded:true});this._loadChildContexts(l);}n.magnitude+=Math.max(l.magnitude||0,0);n.numberOfLeafs+=l.numberOfLeafs;}}}n.magnitude+=Math.max(m||0,0);};
h.prototype.isGrouped=function(){return true;};
h.prototype._calculateGroupID=function(n){L.error("TreeBindingAdapter#_calculateGroupID: Not implemented. Needs to be implemented in respective sub-classes.");};
h.prototype._createNode=function(p){p=p||{};var o=p.context;var l=p.level||0;var n={context:o,level:l,children:p.children||[],parent:p.parent,nodeState:p.nodeState,isLeaf:p.isLeaf||false,positionInParent:p.positionInParent,magnitude:p.magnitude||0,numberOfTotals:p.numberOfTotals||0,numberOfLeafs:p.numberOfLeafs||0,autoExpand:p.autoExpand||0,absoluteNodeIndex:p.absoluteNodeIndex||0,totalNumberOfLeafs:0};if(o!==undefined){n.groupID=this._calculateGroupID(n);}return n;};
h.prototype.expand=function(i,s){var n=this.findNode(i);if(!n){e(false,"No node found for index "+i);return;}this._updateTreeState({groupID:n.nodeState.groupID,fallbackNodeState:n.nodeState,expanded:true});if(!s){this._fireChange({reason:C.Expand});}};
h.prototype.expandToLevel=function(l){this._mTreeState.collapsed={};this.setNumberOfExpandedLevels(l);this._fireChange({reason:C.Expand});};
h.prototype.isExpanded=function(i){var n=this.findNode(i);return n&&n.nodeState?n.nodeState.expanded:false;};
h.prototype.collapse=function(p,s){var n;var t=this;if(typeof p==="object"){n=p;}else if(typeof p==="number"){var N=this.findNode(p);if(!N){e(false,"No node found for index "+p);return;}n=N.nodeState;}this._updateTreeState({groupID:n.groupID,fallbackNodeState:n,expanded:false});n.selectAllMode=false;if(this.bCollapseRecursive){var G=n.groupID;f(this._mTreeState.expanded,function(b,o){if(typeof G=="string"&&G.length>0&&b.startsWith(G)){t._updateTreeState({groupID:b,expanded:false});}});var D=[];f(this._mTreeState.selected,function(b,o){if(typeof G=="string"&&G.length>0&&b.startsWith(G)&&b!==G){o.selectAllMode=false;t.setNodeSelection(o,false);D.push(b);}});if(D.length){var a={rowIndices:[]};var i=-1;this._map(this._oRootNode,function(N){if(!N||!N.isArtificial){i++;}if(N&&D.indexOf(N.groupID)!==-1){if(N.groupID===this._sLeadSelectionGroupID){a.oldIndex=i;a.leadIndex=-1;}a.rowIndices.push(i);}});this._publishSelectionChanges(a);}}if(!s){this._fireChange({reason:C.Collapse});}};
h.prototype.collapseToLevel=function(l){if(!l||l<0){l=0;}var t=this;f(this._mTreeState.expanded,function(G,n){var N=t._getGroupIdLevel(G)-1;if(N===l){t.collapse(n,true);}});if(this.bCollapseRecursive){this.setNumberOfExpandedLevels(l);}this._fireChange({reason:C.Collapse});};
h.prototype._map=function(n,m){m.call(this,n);if(!n){return;}for(var i=0;i<n.children.length;i++){var o=n.children[i];this._map(o,m);}if(this._afterMapHook){this._afterMapHook(n,m);}};
h.prototype._match=function(n,r,m,M,p,P){if(r.length===m){return true;}var N=M.call(this,n,p,P);if(N){r.push(n);}if(!n){return false;}for(var i=0;i<n.children.length;i++){var o=n.children[i];var b=this._match(o,r,m,M,i,n);if(b){return true;}}return this._afterMatchHook?this._afterMatchHook(n,r,m,M,p,P):false;};
h.prototype.toggleIndex=function(i){var n=this.findNode(i);if(!n){e(false,"There is no node at index "+i+".");return;}if(n.nodeState.expanded){this.collapse(i);}else{this.expand(i);}};
h.prototype._getGroupIdLevel=function(G){if(G==null){L.warning("assertion failed: no need to determine level of group ID = null");return-1;}return G.split("/").length-2;};
h.prototype._getGroupSize=function(n){return this.getChildCount(n.context);};
h.prototype.setNodeSelection=function(n,i){if(!n.groupID){e(false,"NodeState must have a group ID!");return;}n.selected=i;if(i){this._mTreeState.selected[n.groupID]=n;delete this._mTreeState.deselected[n.groupID];}else{delete this._mTreeState.selected[n.groupID];this._mTreeState.deselected[n.groupID]=n;}};
h.prototype.isIndexSelected=function(r){var n=this.getNodeByIndex(r);return n&&n.nodeState?n.nodeState.selected:false;};
h.prototype.isIndexSelectable=function(r){var n=this.getNodeByIndex(r);return this._isNodeSelectable(n);};
h.prototype._isNodeSelectable=function(n){return!!n&&!n.isArtificial;};
h.prototype.setSelectedIndex=function(r){var n=this.findNode(r);if(n&&this._isNodeSelectable(n)){var o=this._clearSelection();var i=o.rowIndices.indexOf(r);if(i>=0){o.rowIndices.splice(i,1);}else{o.rowIndices.push(r);}o.leadGroupID=n.groupID;o.leadIndex=r;this.setNodeSelection(n.nodeState,true);this._publishSelectionChanges(o);}else{L.warning("TreeBindingAdapter: The selection was ignored. Please make sure to only select rows, for which data has been fetched to the client. For AnalyticalTables, some rows might not be selectable at all.");}};
h.prototype.getSelectedIndex=function(){if(!this._sLeadSelectionGroupID||g(this._mTreeState.selected)){return-1;}var n=-1;var a=false;var m=function(N){if(!N||!N.isArtificial){n++;}if(N){if(N.groupID===this._sLeadSelectionGroupID){a=true;return true;}}return false;};this._match(this._oRootNode,[],1,m);if(a){return n;}return-1;};
h.prototype.getSelectedIndices=function(){var r=[];var t=this;if(g(this._mTreeState.selected)){return r;}var n=Object.keys(this._mTreeState.selected).length;var N=-1;var m=function(o){if(!o||!o.isArtificial){N++;}if(o){if(o.nodeState&&o.nodeState.selected&&!o.isArtificial){r.push(N);t._aRowIndexMap[N]=o;return true;}}return false;};this._match(this._oRootNode,[],n,m);return r;};
h.prototype.getSelectedNodesCount=function(){var s;if(this._oRootNode&&this._oRootNode.nodeState.selectAllMode){var G,v,p,o;var a,V=[];if(this.filterInfo&&this.oCombinedFilter){for(var i=this.filterInfo.aFilteredContexts.length-1;i>=0;i--){a=this.filterInfo.aFilteredContexts[i];V.push(this._calculateGroupID({context:a}));}}v=0;for(G in this._mTreeState.expanded){if(!this.oCombinedFilter||V.indexOf(G)!==-1){o=this._mTreeState.expanded[G];if(!o.selectAllMode&&o.leafCount!==undefined){v+=o.leafCount;}}}for(G in this._mTreeState.selected){if(!this.oCombinedFilter||V.indexOf(G)!==-1){o=this._mTreeState.selected[G];p=this._mTreeState.expanded[o.parentGroupID];if(p&&!p.selectAllMode){v--;}}}for(G in this._mTreeState.deselected){if(!this.oCombinedFilter||V.indexOf(G)!==-1){o=this._mTreeState.deselected[G];p=this._mTreeState.expanded[o.parentGroupID];if(p&&p.selectAllMode){v++;}}}s=this._getSelectableNodesCount(this._oRootNode)-v;}else{s=Object.keys(this._mTreeState.selected).length;}return s;};
h.prototype._getSelectableNodesCount=function(n){if(n){return n.magnitude;}else{return 0;}};
h.prototype.getSelectedContexts=function(){var r=[];var t=this;if(g(this._mTreeState.selected)){return r;}var n=Object.keys(this._mTreeState.selected).length;var N=-1;var m=function(o){if(!o||!o.isArtificial){N++;}if(o){if(o.nodeState&&o.nodeState.selected&&!o.isArtificial){r.push(o.context);t._aRowIndexMap[N]=o;return true;}}return false;};this._match(this._oRootNode,[],n,m);return r;};
h.prototype.setSelectionInterval=function(F,t){var i,I,m=this._clearSelection(),a={},r=[],s=this._setSelectionInterval(F,t,true);for(i=0;i<m.rowIndices.length;i++){I=m.rowIndices[i];a[I]=true;}for(i=0;i<s.rowIndices.length;i++){I=s.rowIndices[i];if(a[I]){delete a[I];}else{a[I]=true;}}for(I in a){if(a[I]){r.push(parseInt(I));}}this._publishSelectionChanges({rowIndices:r,oldIndex:m.oldIndex,leadIndex:s.leadIndex,leadGroupID:s.leadGroupID});};
h.prototype._setSelectionInterval=function(F,t,s){var n=Math.min(F,t);var N=Math.max(F,t);var a=[];var b=[];var i=Math.abs(N-n)+1;var o;var j=-1;var m=function(k){if(!k||!k.isArtificial){j++;}if(k){if(j>=n&&j<=N){if(this._isNodeSelectable(k)){if(k.nodeState.selected!==!!s){b.push(j);}if(k.groupID===this._sLeadSelectionGroupID){o=j;}this.setNodeSelection(k.nodeState,!!s);}return true;}}return false;};this._match(this._oRootNode,a,i,m);var p={rowIndices:b,oldIndex:o,leadIndex:o&&!s?-1:undefined};if(a.length>0&&s){var l=a[a.length-1];p.leadGroupID=l.groupID;p.leadIndex=N;}return p;};
h.prototype.addSelectionInterval=function(F,t){var p=this._setSelectionInterval(F,t,true);this._publishSelectionChanges(p);};
h.prototype.removeSelectionInterval=function(F,t){var p=this._setSelectionInterval(F,t,false);this._publishSelectionChanges(p);};
h.prototype.selectAll=function(){this._mTreeState.deselected={};var p={rowIndices:[],oldIndex:-1,selectAll:true};var n=-1;this._map(this._oRootNode,function(N){if(!N||!N.isArtificial){n++;}if(N){if(N.groupID===this._sLeadSelectionGroupID){p.oldIndex=n;}if(this._isNodeSelectable(N)){if(N.nodeState.selected!==true){p.rowIndices.push(n);}this.setNodeSelection(N.nodeState,true);p.leadGroupID=N.groupID;p.leadIndex=n;}if(N.nodeState.expanded){N.nodeState.selectAllMode=true;}}});this._publishSelectionChanges(p);};
h.prototype._clearSelection=function(){var n=-1;var o=-1;var m;var a=[];if(this._oRootNode&&!this._oRootNode.nodeState.selectAllMode){m=0;for(var G in this._mTreeState.selected){if(G){m++;}}}var M=function(N){if(!N||!N.isArtificial){n++;}if(N){N.nodeState.selectAllMode=false;if(this._mTreeState.selected[N.groupID]){if(!N.isArtificial){a.push(n);}this.setNodeSelection(N.nodeState,false);if(N.groupID===this._sLeadSelectionGroupID){o=n;}return true;}}return false;};this._match(this._oRootNode,[],m,M);if(this._oRootNode&&this._oRootNode.nodeState&&this._oRootNode.isArtificial){this._oRootNode.nodeState.selectAllMode=false;}return{rowIndices:a,oldIndex:o,leadIndex:-1};};
h.prototype.clearSelection=function(s){var o=this._clearSelection();if(!s){this._publishSelectionChanges(o);}};
h.prototype._publishSelectionChanges=function(p){p.oldIndex=p.oldIndex||this.getSelectedIndex();p.rowIndices.sort(function(a,b){return a-b;});if(p.leadIndex>=0&&p.leadGroupID){this._sLeadSelectionGroupID=p.leadGroupID;}else if(p.leadIndex===-1){this._sLeadSelectionGroupID=undefined;}else{p.leadIndex=p.oldIndex;}if(p.rowIndices.length>0||(p.leadIndex!=undefined&&p.leadIndex!==-1)){this.fireSelectionChanged(p);}};
h.prototype.setCollapseRecursive=function(b){this.bCollapseRecursive=!!b;};
h.prototype.getCollapseRecursive=function(){return this.bCollapseRecursive;};
h.prototype.attachSelectionChanged=function(D,F,l){this.attachEvent("selectionChanged",D,F,l);return this;};
h.prototype.detachSelectionChanged=function(F,l){this.detachEvent("selectionChanged",F,l);return this;};
h.prototype.fireSelectionChanged=function(p){this.fireEvent("selectionChanged",p);return this;};
return h;},true);
sap.ui.predefine('sap/ui/model/TreeBindingCompatibilityAdapter',["sap/base/util/each"],function(e){"use strict";var T=function(b,c){Object.assign(b,{_init:function(E){this._bExpandFirstLevel=E;this.mContextInfo={};this._initContexts();if(E&&!this._bFirstLevelExpanded){this._expandFirstLevel();}},_initContexts:function(s){this.aContexts=this.getRootContexts(0,Number.MAX_VALUE);for(var i=0,l=this.aContexts.length;i<l;i++){var o=this._getContextInfo(this.aContexts[i]);this._setContextInfo({oContext:this.aContexts[i],iLevel:0,bExpanded:o?o.bExpanded:false});}if(this._bExpandFirstLevel&&!this._bFirstLevelExpanded){this._expandFirstLevel(s);}},_expandFirstLevel:function(s){var t=this;if(this.aContexts&&this.aContexts.length>0){e(this.aContexts.slice(),function(i,C){if(!s){t._loadChildContexts(C);}t._getContextInfo(C).bExpanded=true;});this._bFirstLevelExpanded=true;}},_fnFireFilter:b._fireFilter,_fireFilter:function(){this._fnFireFilter.apply(this,arguments);this._initContexts(true);this._restoreContexts(this.aContexts);},_fnFireChange:b._fireChange,_fireChange:function(){this._fnFireChange.apply(this,arguments);this._initContexts(true);this._restoreContexts(this.aContexts);},_restoreContexts:function(C){var t=this;var n=[];e(C.slice(),function(i,o){var a=t._getContextInfo(o);if(a&&a.bExpanded){n.push.apply(n,t._loadChildContexts(o));}});if(n.length>0){this._restoreContexts(n);}},_loadChildContexts:function(C){var o=this._getContextInfo(C);var I=(this.aContexts?this.aContexts.indexOf(C):-1);var n=this.getNodeContexts(C,0,Number.MAX_VALUE);for(var i=0,l=n.length;i<l;i++){this.aContexts.splice(I+i+1,0,n[i]);var a=this._getContextInfo(n[i]);this._setContextInfo({oParentContext:C,oContext:n[i],iLevel:o.iLevel+1,bExpanded:a?a.bExpanded:false});}return n;},_getContextInfo:function(C){return C?this.mContextInfo[C.getPath()]:undefined;},_setContextInfo:function(d){if(d&&d.oContext){this.mContextInfo[d.oContext.getPath()]=d;}},getLength:function(){return this.aContexts?this.aContexts.length:0;},getContexts:function(s,l){return this.aContexts.slice(s,s+l);},getNodes:function(s,l){var C=this.getContexts(s,s+l);var n=[];for(var i=0;i<C.length;i++){var o=this._getContextInfo(C[i])||{};var a=C[i];n.push({context:a,level:o.iLevel,parent:o.oParentContext,nodeState:{expanded:o.bExpanded,collapsed:!o.bExpanded,selected:false}});}return n;},hasChildren:function(){return true;},nodeHasChildren:function(){return true;},getContextByIndex:function(r){return this.aContexts[r];},getLevel:function(C){var o=this._getContextInfo(C);return o?o.iLevel:-1;},isExpanded:function(r){var C=this.getContextByIndex(r);var o=this._getContextInfo(C);return o?o.bExpanded:false;},expandContext:function(C){var o=this._getContextInfo(C);if(o&&!o.bExpanded){this.storeSelection();this._loadChildContexts(C);o.bExpanded=true;this._fireChange();this.restoreSelection();}},expand:function(r){this.expandContext(this.getContextByIndex(r));},collapseContext:function(C,s){var o=this._getContextInfo(C);if(o&&o.bExpanded){this.storeSelection();for(var i=this.aContexts.length-1;i>0;i--){if(this._getContextInfo(this.aContexts[i]).oParentContext===C){this.aContexts.splice(i,1);}}o.bExpanded=false;if(!s){this._fireChange();}this.restoreSelection();}},collapse:function(r){this.collapseContext(this.getContextByIndex(r));},collapseToLevel:function(l){if(!l||l<0){l=0;}var C=this.aContexts.slice();for(var i=C.length-1;i>=0;i--){var a=this.getLevel(C[i]);if(a!=-1&&a>=l){this.collapseContext(C[i],true);}}this._fireChange();},toggleContext:function(C){var o=this._getContextInfo(C);if(o){if(o.bExpanded){this.collapseContext(C);}else{this.expandContext(C);}}},toggleIndex:function(r){this.toggleContext(this.getContextByIndex(r));},storeSelection:function(){var s=c.getSelectedIndices();var S=[];e(s,function(i,v){S.push(c.getContextByIndex(v));});this._aSelectedContexts=S;},restoreSelection:function(){c.clearSelection();var _=this._aSelectedContexts;e(this.aContexts,function(i,C){if(((_?_.indexOf(C):-1))>=0){c.addSelectionInterval(i,i);}});this._aSelectedContexts=undefined;},attachSelectionChanged:function(){return undefined;},detachSelectionChanged:function(){},clearSelection:function(){c._oSelection.clearSelection();},attachSort:function(){},detachSort:function(){}});b._init(c.getExpandFirstLevel());};return T;},true);
sap.ui.predefine('sap/ui/model/TreeBindingUtils',function(){"use strict";var T=function(){};
T.mergeSections=function(s,n){var N=[];for(var i=0;i<s.length;i++){var c=s[i];var C=c.startIndex+c.length;var a=n.startIndex+n.length;if(n.startIndex<=C&&a>=C&&n.startIndex>=c.startIndex){n.startIndex=c.startIndex;n.length=a-c.startIndex;}else if(n.startIndex<=c.startIndex&&a>=c.startIndex&&a<=C){n.length=C-n.startIndex;}else if(n.startIndex>=c.startIndex&&a<=C){n.startIndex=c.startIndex;n.length=c.length;}else if(a<c.startIndex||n.startIndex>C){N.push(c);}}N.push(n);return N;};
T._determineRequestDelta=function(n,p){var N=n.iSkip+n.iTop;var P=p.iSkip+p.iTop;if(n.iSkip===p.iSkip&&n.iTop===p.iTop){return false;}else if(n.iSkip<p.iSkip&&N>p.iSkip&&N<=P){n.iTop=p.iSkip-n.iSkip;if(n.iThreshold){n.iTop=n.iTop+n.iThreshold;n.iSkip=Math.max(0,n.iSkip-n.iThreshold);n.iThreshold=0;}}else if(n.iSkip<P&&N>P&&n.iSkip>=p.iSkip){n.iSkip=P;n.iTop=N-n.iSkip;if(n.iThreshold){n.iTop+=n.iThreshold;n.iThreshold=0;}}else if(n.iSkip>=p.iSkip&&N<=P){return false;}else if(n.iSkip<=p.iSkip&&N>=P){p.oRequestHandle.abort();}else if(N<=p.iSkip||n.iSkip>=P){}return undefined;};
return T;});
sap.ui.predefine('sap/ui/model/analytics/AnalyticalBinding',["./AnalyticalVersionInfo","./BatchResponseCollector","./odata4analytics","sap/base/Log","sap/base/util/deepExtend","sap/base/util/each","sap/base/util/extend","sap/base/util/isEmptyObject","sap/base/util/uid","sap/ui/model/ChangeReason","sap/ui/model/Filter","sap/ui/model/FilterOperator","sap/ui/model/FilterProcessor","sap/ui/model/FilterType","sap/ui/model/Sorter","sap/ui/model/TreeAutoExpandMode","sap/ui/model/TreeBinding","sap/ui/model/odata/CountMode","sap/ui/model/odata/ODataUtils"],function(A,B,a,L,d,b,c,f,u,C,F,t,v,w,S,T,x,y,O){"use strict";var D="sap.ui.model.analytics.AnalyticalBinding",I=0,E=L.getLogger(D);
function G(o){var e,g,s,h,i,j,m,n,p,k=new a.QueryResultRequest(o.oAnalyticalQueryResult),l=o.mParameters.select.split(","),q=J(l,o.sPath);k.setAggregationLevel(o.aMaxAggregationLevel);k.setMeasures(o.aMeasureName);Object.keys(o.oDimensionDetailsSet).forEach(function(r){h=o.oDimensionDetailsSet[r];k.includeDimensionKeyTextAttributes(r,true,h.textPropertyName!==undefined,h.aAttributeName);});Object.keys(o.oMeasureDetailsSet).forEach(function(r){m=o.oMeasureDetailsSet[r];k.includeMeasureRawFormattedValueUnit(r,m.rawValuePropertyName!==undefined,m.formattedValuePropertyName!==undefined,m.unitPropertyName!==undefined);});s=k.getURIQueryOptionValue("$select");if(s){g=s.split(",");for(i=0,n=g.length;i<n;i++){p=g[i];j=l.indexOf(p);if(j<0){e=o.mAnalyticalInfoByProperty[p];if(!e||(!e.visible&&!e.inResult)){continue;}E.warning("Ignored the 'select' binding parameter, because"+" it does not contain the property '"+p+"'",o.sPath);q=true;}else{l.splice(j,1);}}}for(i=0,n=l.length;i<n;i++){p=l[i];h=o.oAnalyticalQueryResult.findDimensionByPropertyName(p);if(h&&o.oDimensionDetailsSet[h.getName()]===undefined){H(o.sPath,p,h);q=true;}m=o.oAnalyticalQueryResult.findMeasureByPropertyName(p);if(m&&o.oMeasureDetailsSet[m.getName()]===undefined){H(o.sPath,p,m);q=true;}}return q?[]:l;}
function H(p,s,o){var e=o instanceof sap.ui.model.analytics.odata4analytics.Dimension?"dimension":"measure";if(o.getName()===s){E.warning("Ignored the 'select' binding parameter, because it contains"+" the "+e+" property '"+s+"' which is not contained in the analytical info (see updateAnalyticalInfo)",p);}else{E.warning("Ignored the 'select' binding parameter, because the property '"+s+"' is associated with the "+e+" property '"+o.getName()+"' which is not contained in the analytical"+" info (see updateAnalyticalInfo)",p);}}
function J(s,p){var e,g=false,i,n;for(i=0,n=s.length;i<n;i++){s[i]=s[i].trim();}for(i=s.length-1;i>=0;i--){e=s[i];if(s.indexOf(e)!==i){E.warning("Ignored the 'select' binding parameter, because it"+" contains the property '"+e+"' multiple times",p);s.splice(i,1);g=true;}}return g;}
var K=x.extend("sap.ui.model.analytics.AnalyticalBinding",{constructor:function(m,p,o,s,e,P){x.call(this,m,p,o,e,P);this.aAdditionalSelects=[];this.sEntitySetName=(P&&P.entitySet)?P.entitySet:undefined;this.bArtificalRootContext=false;this.aApplicationFilter=this._convertDeprecatedFilterObjects(e);this.aControlFilter=undefined;this.aSorter=s?s:[];this.aMaxAggregationLevel=[];this.aAggregationLevel=[];this.oPendingRequests={};this.oPendingRequestHandle=[];this.oGroupedRequests={};this.bUseBatchRequests=(P&&P.useBatchRequests===true)?true:false;this.bProvideTotalSize=(P&&P.provideTotalResultSize===false)?false:true;this.bProvideGrandTotals=(P&&P.provideGrandTotals===false)?false:true;this.bReloadSingleUnitMeasures=(P&&P.reloadSingleUnitMeasures===false)?false:true;this.bUseAcceleratedAutoExpand=(P&&P.useAcceleratedAutoExpand===false)?false:true;this.bNoPaging=(P&&P.noPaging===true)?true:false;I+=1;this._iId=I;this.iTotalSize=-1;this.mServiceKey={};this.mServiceLength={};this.mServiceFinalLength={};this.mKeyIndex={};this.mFinalLength=this.mServiceFinalLength;this.mLength={};this.mMultiUnitKey={};this.aMultiUnitLoadFactor={};this.bNeedsUpdate=false;this.bApplySortersToGroups=true;this.sLastAutoExpandMode=undefined;this.mEntityKey={};this.sCustomParams=this.oModel.createCustomParams({custom:this.mParameters.custom});this.oAnalyticalQueryResult=null;this.aAnalyticalInfo=[];this.mAnalyticalInfoByProperty={};this.aBatchRequestQueue=[];if(P&&P.countMode==y.None){E.fatal("requested count mode is ignored; OData requests will include"+" $inlinecount options");}else if(P&&(P.countMode==y.Request||P.countMode==y.Both)){E.warning("default count mode is ignored; OData requests will include"+" $inlinecount options");}else if(this.oModel.sDefaultCountMode==y.Request){E.warning("default count mode is ignored; OData requests will include"+" $inlinecount options");}this.iModelVersion=A.getVersion(this.oModel);if(this.iModelVersion===null){E.error("The AnalyticalBinding does not support Models other than sap.ui.model.odata.ODataModel version 1 or 2.");return;}this.aAllDimensionSortedByName=null;this.aInitialAnalyticalInfo=(P==undefined?[]:P.analyticalInfo);this.bInitial=true;}});
function M(o,e){return function(){if(!o.__supportUID){o.__supportUID=u();}return{type:D,analyticalError:e,analyticalBindingId:o.__supportUID};};}
K.prototype.setContext=function(o){var r;if(this.oContext!==o){this.oContext=o;if(!this.isRelative()){return;}this.oDataState=null;this.bApplySortersToGroups=true;this.iTotalSize=-1;this._abortAllPendingRequests();r=this.getResolvedPath();if(r){this.resetData();this._initialize();this._fireChange({reason:C.Context});}else{this.bInitial=true;}}};
K.prototype.initialize=function(){if(this.oModel.oMetadata&&this.oModel.oMetadata.isLoaded()&&this.isInitial()){var i=this.isRelative();if(!i||(i&&this.oContext)){this._initialize();}this._fireRefresh({reason:C.Refresh});}return this;};
K.prototype._initialize=function(){if(this.oModel.oMetadata&&this.oModel.oMetadata.isLoaded()){this.bInitial=false;this.oAnalyticalQueryResult=this.oModel.getAnalyticalExtensions().findQueryResultByName(this._getEntitySet());if(!this.oAnalyticalQueryResult){throw("Error in AnalyticalBinding - The QueryResult '"+this._getEntitySet()+"' could not be retrieved. Please check your service definition.");}this.updateAnalyticalInfo(this.aInitialAnalyticalInfo);this.aAllDimensionSortedByName=this.oAnalyticalQueryResult.getAllDimensionNames().concat([]).sort();this._fireRefresh({reason:C.Refresh});}};
K.prototype.getRootContexts=function(p,l,n,i){if(typeof p!=="object"){p={length:l,numberOfExpandedLevels:n,startIndex:p,threshold:i};}if(this.isInitial()){return[];}var e=(p&&p.numberOfExpandedLevels?p.numberOfExpandedLevels+1:1);var r=null;var R=this._getRequestId(K._requestType.groupMembersQuery,{groupId:null});if(this.bArtificalRootContext&&!this._cleanupGroupingForCompletedRequest(R)){return r;}r=this._getContextsForParentContext(null);if(r.length==1){return r;}if(e<=1){if(e==1){this._considerRequestGrouping([R,this._getRequestId(K._requestType.groupMembersQuery,{groupId:"/"})]);this.getNodeContexts(this.getModel().getContext("/"),{startIndex:p.startIndex,length:p.length,threshold:p.threshold,level:0,numberOfExpandedLevels:0});}}else{var g=this._prepareGroupMembersAutoExpansionRequestIds("/",p.numberOfExpandedLevels);g.push(R);this._considerRequestGrouping(g);this.getNodeContexts(this.getModel().getContext("/"),{startIndex:p.startIndex,length:p.length,threshold:p.threshold,level:0,numberOfExpandedLevels:p.numberOfExpandedLevels});}if(r.length>1){E.fatal("assertion failed: grand total represented by a single entry");}return r;};
K.prototype.getNodeContexts=function(o,p){if(this.isInitial()){return[];}var s,l,i,e,n,g;if(typeof p=="object"){s=p.startIndex;l=p.length;i=p.threshold;e=p.level;n=p.numberOfExpandedLevels;g=p.supressRequest;}else{s=arguments[1];l=arguments[2];i=arguments[3];e=arguments[4];n=arguments[5];g=arguments[6];}var h=this._getContextsForParentContext(o,s,l,i,e,n,g);return h;};
K.prototype.ContextsAvailabilityStatus={ALL:2,SOME:1,NONE:0};
K.prototype.hasAvailableNodeContexts=function(o,l){var g=this._getGroupIdFromContext(o,l);if(this._getKeys(g)!=undefined){if(this.mFinalLength[g]==true){return K.prototype.ContextsAvailabilityStatus.ALL;}else{return K.prototype.ContextsAvailabilityStatus.SOME;}}else{return K.prototype.ContextsAvailabilityStatus.NONE;}};
K.prototype.getGroupSize=function(o,l){if(o===undefined){return 0;}var g=this._getGroupIdFromContext(o,l);return this.mFinalLength[g]?this.mLength[g]:-1;};
K.prototype.getCount=function(){return this.iTotalSize>=0?this.iTotalSize:undefined;};
K.prototype.getTotalSize=function(){if(!this.bProvideTotalSize){E.fatal("total size of result explicitly turned off, but getter invoked");}return this.iTotalSize;};
K.prototype.hasChildren=function(o,p){p=p||{level:1};if(o===undefined){return false;}if(o==null){return true;}var i=p.level;if(i==0){return true;}if(this.aAggregationLevel.length<i){return false;}return this.aMaxAggregationLevel.indexOf(this.aAggregationLevel[i-1])<this.aMaxAggregationLevel.length-1;};
K.prototype.hasMeasures=function(){var h=false;for(var p in this.oMeasureDetailsSet){if(this.oMeasureDetailsSet.hasOwnProperty(p)){h=true;break;}}return h;};
K.prototype.getDimensionDetails=function(){return this.oDimensionDetailsSet;};
K.prototype.getMeasureDetails=function(){return this.oMeasureDetailsSet;};
K.prototype.providesGrandTotal=function(){return this.bProvideGrandTotals;};
K.prototype.getProperty=function(p){if(this.isInitial()){return{};}return this.oAnalyticalQueryResult.getEntityType().findPropertyByName(p);};
K.prototype.getFilterablePropertyNames=function(){if(this.isInitial()){return[];}return this.oAnalyticalQueryResult.getEntityType().getFilterablePropertyNames();};
K.prototype.getSortablePropertyNames=function(){if(this.isInitial()){return[];}return this.oAnalyticalQueryResult.getEntityType().getSortablePropertyNames();};
K.prototype.getPropertyLabel=function(p){if(this.isInitial()){return"";}return this.oAnalyticalQueryResult.getEntityType().getLabelOfProperty(p);};
K.prototype.getPropertyHeading=function(p){if(this.isInitial()){return"";}return this.oAnalyticalQueryResult.getEntityType().getHeadingOfProperty(p);};
K.prototype.getPropertyQuickInfo=function(p){if(this.isInitial()){return"";}return this.oAnalyticalQueryResult.getEntityType().getQuickInfoOfProperty(p);};
K.prototype.isMeasure=function(p){return this.aMeasureName&&this.aMeasureName.indexOf(p)!==-1;};
K.prototype.filter=function(e,s){if(!e){e=[];}if(e instanceof F){e=[e];}e=this._convertDeprecatedFilterObjects(e);if(s==w.Application){this.aApplicationFilter=e;}else{this.aControlFilter=e;}this.iTotalSize=-1;this._abortAllPendingRequests();this.resetData();this.bApplySortersToGroups=true;this._fireRefresh({reason:C.Filter});return this;};
K.prototype.getFilterInfo=function(i){var o=v.combineFilters(this.aControlFilter,this.aApplicationFilter);if(o){return o.getAST(i);}return null;};
K.prototype.sort=function(s){if(s instanceof S){s=[s];}this.aSorter=s?s:[];this._abortAllPendingRequests();this.resetData(undefined,{reason:C.Sort});this._fireRefresh({reason:C.Sort});return this;};
K.prototype.getGroupName=function(o,l){if(o===undefined){return"";}var g=this.aAggregationLevel[l-1],e=this.oAnalyticalQueryResult.findDimensionByPropertyName(g),V=this.mAnalyticalInfoByProperty[g]&&this.mAnalyticalInfoByProperty[g].formatter,p=o.getProperty(g),s,h,i,j,k,m,n,q;if(e&&this.oDimensionDetailsSet[g].textPropertyName){k=e.getTextProperty();}if(k){m=k.name;q=this.mAnalyticalInfoByProperty[m]&&this.mAnalyticalInfoByProperty[m].formatter;n=o.getProperty(m);s=V?V(p,n):p;h=q?q(n,p):n;}else{s=V?V(p):p;}j=e.getLabelText&&e.getLabelText();i=(j?j+': ':'')+s;if(h){i+=' - '+h;}return i;};
K.prototype.updateAnalyticalInfo=function(e,g){var h,o,k,l,m=this;function n(W){var X=W.level,Y=W.name;l=l||k.getAllHierarchyPropertyNames();l.forEach(function(Z){var $=m.oAnalyticalQueryResult.findDimensionByPropertyName(Z).getHierarchy(),_=null,a1=$.getNodeIDProperty().name,b1;if(a1===Y){_=p($);}else{b1=$.getNodeExternalKeyProperty();if(b1&&b1.name===Y){_=p($);_.nodeExternalKeyName=Y;}else{b1=k.getTextPropertyOfProperty(a1);if(b1&&b1.name===Y){_=p($);_.nodeTextName=Y;}}}if(_&&"level"in W){if(typeof X==="number"){if("level"in _&&_.level!==X){throw new Error("Multiple different level filter for hierarchy '"+a1+"' defined");}_.level=X;_.grouped=!!W.grouped;}else{throw new Error("The level of '"+a1+"' has to be an integer value");}}});}function p(W){var X=W.getNodeIDProperty().name,Y,Z=m.mHierarchyDetailsByName[X];if(!Z){Y=W.getNodeLevelProperty();Z={dimensionName:W.getNodeValueProperty().name,nodeIDName:X,nodeLevelName:Y&&Y.name};m.mHierarchyDetailsByName[X]=Z;}return Z;}if(!this.oModel.oMetadata||!this.oModel.oMetadata.isLoaded()||this.isInitial()){this.aInitialAnalyticalInfo=e;return;}h=a.helper.deepEqual(this._aLastChangedAnalyticalInfo,e,function(W){m.mAnalyticalInfoByProperty[W.name].formatter=W.formatter;});if(h){this._aLastChangedAnalyticalInfo=[];for(var j=0;j<e.length;j++){this._aLastChangedAnalyticalInfo[j]=c({},e[j]);}}if(h<2){if(g||h){setTimeout(function(){this._fireChange({reason:C.Change});}.bind(this),0);}return;}var P=this.oDimensionDetailsSet||{},q=this.oMeasureDetailsSet||{};this.mAnalyticalInfoByProperty={};this.aMaxAggregationLevel=[];this.aAggregationLevel=[];this.aMeasureName=[];if(this.iAnalyticalInfoVersionNumber==undefined){this.iAnalyticalInfoVersionNumber=1;}else if(this.iAnalyticalInfoVersionNumber>999){this.iAnalyticalInfoVersionNumber=1;}else{this.iAnalyticalInfoVersionNumber=this.iAnalyticalInfoVersionNumber+1;}this.oMeasureDetailsSet={};this.oDimensionDetailsSet={};this.aAdditionalSelects=[];this.mHierarchyDetailsByName={};k=this.oAnalyticalQueryResult.getEntityType();for(var i=0;i<e.length;i++){var r=this.oAnalyticalQueryResult.findDimensionByPropertyName(e[i].name);if(r&&(e[i].inResult==true||e[i].visible==true)){e[i].dimensionPropertyName=r.getName();o=this.oDimensionDetailsSet[r.getName()];if(!o){o={};o.name=r.getName();o.aAttributeName=[];o.grouped=false;this.oDimensionDetailsSet[r.getName()]=o;this.aMaxAggregationLevel.push(o.name);if(e[i].grouped==true){this.aAggregationLevel.push(o.name);}}if(e[i].grouped==true){if(!this.getSortablePropertyNames()||this.getSortablePropertyNames().indexOf(r.getName())==-1){E.fatal("property "+r.getName()+" must be sortable in order to be used as grouped dimension");}o.grouped=true;}if(r.getName()==e[i].name){o.keyPropertyName=e[i].name;}var s=r.getTextProperty();if(s&&s.name==e[i].name){o.textPropertyName=e[i].name;}if(r.findAttributeByName(e[i].name)){o.aAttributeName.push(e[i].name);}o.analyticalInfo=e[i];}var z=this.oAnalyticalQueryResult.findMeasureByPropertyName(e[i].name);if(z&&(e[i].inResult==true||e[i].visible==true)){e[i].measurePropertyName=z.getName();var N=this.oMeasureDetailsSet[z.getName()];if(!N){N={};N.name=z.getName();this.oMeasureDetailsSet[z.getName()]=N;this.aMeasureName.push(N.name);}if(z.getRawValueProperty().name==e[i].name){N.rawValuePropertyName=e[i].name;}var Q=z.getFormattedValueProperty();if(Q&&Q.name==e[i].name){N.formattedValuePropertyName=e[i].name;}N.analyticalInfo=e[i];}if(!r&&!z){n(e[i]);}this.mAnalyticalInfoByProperty[e[i].name]=e[i];}Object.keys(this.mHierarchyDetailsByName).forEach(function(W){var X=m.mHierarchyDetailsByName[W];if(!("level"in X)){delete m.mHierarchyDetailsByName[W];if(E.isLoggable(L.Level.INFO)){E.info("No level specified for hierarchy node '"+W+"'; ignoring hierarchy","");}}else if(!m.oDimensionDetailsSet[W]){m.oDimensionDetailsSet[W]={aAttributeName:[],grouped:X.grouped,isHierarchyDimension:true,name:W};m.aMaxAggregationLevel.push(W);if(X.grouped){m.aAggregationLevel.push(W);}}});for(var R in this.oMeasureDetailsSet){var U=this.oAnalyticalQueryResult.findMeasureByName(R).getUnitProperty();if(U){this.oMeasureDetailsSet[R].unitPropertyName=U.name;}}var V=Object.keys(P).sort().join(";")!==Object.keys(this.oDimensionDetailsSet).sort().join(";");if(V){this.iTotalSize=-1;}if(V||Object.keys(q).sort().join(";")!==Object.keys(this.oMeasureDetailsSet).sort().join(";")){this.bApplySortersToGroups=true;}this.aAnalyticalInfo=e;this.resetData();this.bNeedsUpdate=false;if(this.mParameters.select){this.aAdditionalSelects=G(this);}if(g){this._fireChange({reason:C.Change});}};
K.prototype.getAnalyticalInfoForColumn=function(s){return this.mAnalyticalInfoByProperty[s];};
K.prototype.loadGroups=function(g){var e=[];for(var s in g){e.push(s);this._resetData(s);var h=g[s];for(var i=0;i<h.length;i++){var o=h[i];this._getContextsForParentGroupId(s,o.startIndex,o.length,o.threshold);}var r=[];for(var j=-1,k;(k=e[++j])!==undefined;){r.push(this._getRequestId(K._requestType.groupMembersQuery,{groupId:k}));}this._considerRequestGrouping(r);}};
K.prototype.getAnalyticalQueryResult=function(){return this.oAnalyticalQueryResult;};
K._requestType={groupMembersQuery:1,totalSizeQuery:2,groupMembersAutoExpansionQuery:3,levelMembersQuery:4,reloadMeasuresQuery:5};K._artificialRootContextGroupId="artificialRootContext";
K._addHierarchyLevelFilters=function(e,o){e.forEach(function(g){o.removeConditions(g.propertyName);o.addCondition(g.propertyName,t.EQ,g.level);});};
K.prototype._getContextsForParentContext=function(p,s,l,i,e,n,g){if(p===undefined){return[];}if(p&&p.getPath()=="/"+K._artificialRootContextGroupId){p=this.getModel().getContext("/");}var P=this._getGroupIdFromContext(p,e);return this._getContextsForParentGroupId(P,s,l,i,n,g);};
K.prototype._getContextsForParentGroupId=function(p,s,l,e,n,g){if(p===undefined){return[];}if(!s){s=0;}if(!l){l=this.oModel.iSizeLimit;}if(this.mFinalLength[p]&&this.mLength[p]<s+l){l=this.mLength[p]-s;if(l<0){E.fatal("invalid start index greater than total group length passed");}}if(!e){e=0;}if(!n){n=0;}if(p==null){if(n>0){E.fatal("invalid request to determine nodes of root context");return null;}}else{if(this._getGroupIdLevel(p)>=this.aAggregationLevel.length&&n>0){E.fatal("invalid request to determine nodes of context with group ID "+p);return null;}if(this._getGroupIdLevel(p)+n>this.aAggregationLevel.length){n=this.aAggregationLevel.length-this._getGroupIdLevel(p)-1;}}var h=[],k,o,m,q;var r=p==null?0:this._getGroupIdLevel(p)+1;if(!this.aMultiUnitLoadFactor[r]){this.aMultiUnitLoadFactor[r]=1;}var z=n>0&&p!=null;if(z){var N=this._getGroupIdLevel(p);var P=N+n;var Q=true;if(!g){m=this._calculateRequiredGroupExpansion(p,P,s,l+e);Q=m.groupId_Missing==null;Q=Q||m.groupId_Missing.length<p.length||m.groupId_Missing.substring(0,p.length)!=p;}if(Q){h=this._getLoadedContextsForGroup(p,s,l);}else{q=l+e;}k=!Q;q=Math.ceil(q*this.aMultiUnitLoadFactor[r]);}else{h=this._getLoadedContextsForGroup(p,s,l,g);k=false;if(!g){if(this._oWatermark&&p===this._oWatermark.groupID){e=10000;}o=this._calculateRequiredGroupSection(p,s,l,e);var R=o.length>0&&l<o.length;k=(h.length!=l&&!(this.mFinalLength[p]&&h.length>=this.mLength[p]-s))||R;o.length=Math.ceil(o.length*this.aMultiUnitLoadFactor[r]);}}if(!k){this._cleanupGroupingForCompletedRequest(this._getRequestId(K._requestType.groupMembersQuery,{groupId:p}));}var U=false;if(this.oModel.getServiceMetadata()){if(k){var V=this.bProvideTotalSize&&this.iTotalSize==-1&&!this._isRequestPending(this._getRequestId(K._requestType.totalSizeQuery));U=true;var W;if(this.bUseBatchRequests){if(z){W=this._prepareGroupMembersAutoExpansionRequestIds(p,n);for(var i=-1,X;(X=W[++i])!==undefined;){if(this._isRequestPending(X)){U=false;break;}}if(U){this.aBatchRequestQueue.push([K._requestType.groupMembersAutoExpansionQuery,p,m,q,n]);}}else{U=o.length&&!this._isRequestPending(this._getRequestId(K._requestType.groupMembersQuery,{groupId:p}));if(U){this.aBatchRequestQueue.push([K._requestType.groupMembersQuery,p,o.startIndex,o.length]);W=[this._getRequestId(K._requestType.groupMembersQuery,{groupId:p})];}}if(U&&V){W.push(this._getRequestId(K._requestType.totalSizeQuery));this._considerRequestGrouping(W);this.aBatchRequestQueue.push([K._requestType.totalSizeQuery]);}if(U){if(p==null){this._abortAllPendingRequests();}Promise.resolve().then(K.prototype._processRequestQueue.bind(this));}}else{var Y;if(z){W=this._prepareGroupMembersAutoExpansionRequestIds(p,n);for(var j=-1,Z;(Z=W[++j])!==undefined;){if(this._isRequestPending(Z)){U=false;break;}}if(U){Y=this._prepareGroupMembersAutoExpansionQueryRequest(K._requestType.groupMembersAutoExpansionQuery,p,m,q,n);}}else{U=o.length&&!this._isRequestPending(this._getRequestId(K._requestType.groupMembersQuery,{groupId:p}));if(U){Y=this._prepareGroupMembersQueryRequest(K._requestType.groupMembersQuery,p,o.startIndex,o.length);W=[Y.sRequestId];}}if(U){if(p==null){this._abortAllPendingRequests();}this._executeQueryRequest(Y);if(V&&!Y.bIsFlatListRequest){W.push(this._getRequestId(K._requestType.totalSizeQuery));this._considerRequestGrouping(W);this._executeQueryRequest(this._prepareTotalSizeQueryRequest(K._requestType.totalSizeQuery));}}}}}return h;};
K.prototype._getHierarchyLevelFiltersAndAddRecursiveHierarchy=function(o,g){var h,e=[],i=this;if(g===null){return e;}h=Object.keys(this.mHierarchyDetailsByName);if(h.length>0&&g!=="/"){E.error("Hierarchy cannot be requested for members of a group",g);return e;}h.forEach(function(s){var j=i.mHierarchyDetailsByName[s];o.addRecursiveHierarchy(j.dimensionName,!!j.nodeExternalKeyName,!!j.nodeTextName);e.push({propertyName:j.nodeLevelName,level:j.level});});return e;};
K.prototype._getNonHierarchyDimensions=function(e){var g=this;return e.filter(function(s){return!g.oDimensionDetailsSet[s].isHierarchyDimension;});};
K.prototype._processRequestQueue=function(r){if(r===undefined||r===null){r=this.aBatchRequestQueue||[];}if(r.length==0){return;}var R=[];var e=false;var i,o,g;for(i=-1;(g=r[++i])!==undefined;){if(g[0]==K._requestType.groupMembersQuery){o=K.prototype._prepareGroupMembersQueryRequest.apply(this,g);e=e||o.bIsFlatListRequest;R.push(o);}}for(i=-1;(g=r[++i])!==undefined;){o=null;switch(g[0]){case K._requestType.groupMembersQuery:continue;case K._requestType.totalSizeQuery:if(!e){o=K.prototype._prepareTotalSizeQueryRequest.apply(this,g);R.push(o);}break;case K._requestType.groupMembersAutoExpansionQuery:o=K.prototype._prepareGroupMembersAutoExpansionQueryRequest.apply(this,g);for(var j=-1,l;(l=o.aGroupMembersAutoExpansionRequestDetails[++j])!==undefined;){R.push(l);}break;case K._requestType.reloadMeasuresQuery:{var h=g[1];for(var k=-1,m;(m=h[++k])!==undefined;){R.push(m);}break;}default:E.fatal("unhandled request type "+r[i][0]);continue;}}if(R.length>1){this._executeBatchRequest(R);}else{this._executeQueryRequest(R[0]);}if(r===this.aBatchRequestQueue){this.aBatchRequestQueue=[];}};
K.prototype._prepareGroupMembersQueryRequest=function(r,g,s,e){var h=[],m=[],o;var p=new a.QueryResultRequest(this.oAnalyticalQueryResult);p.setResourcePath(this._getResourcePath());p.getSortExpression().clear();var q=0,z=-1;if(g){h=this._getGroupIdComponents(g);q=z=h.length;var U=0;for(var j=0,N=0;j<q;N++){if(this.oDimensionDetailsSet[this.aMaxAggregationLevel[N]].grouped==false){++U;}else{++j;}}q=z=q+U;if(this.aMaxAggregationLevel.length>0){while(this.oDimensionDetailsSet[this.aMaxAggregationLevel[z]].grouped==false){if(++z==this.aMaxAggregationLevel.length){break;}}}}var P=z>=this.aMaxAggregationLevel.length-1;o=this._getHierarchyLevelFiltersAndAddRecursiveHierarchy(p,g);var Q=this.aMaxAggregationLevel.slice(0,z+1);var R=this._getNonHierarchyDimensions(Q);p.setAggregationLevel(R);for(var i=0;i<R.length;i++){var V=this.oDimensionDetailsSet[R[i]];var W=(V.textPropertyName!=undefined);p.includeDimensionKeyTextAttributes(V.name,true,W,V.aAttributeName);if(V.grouped){m.push({sPath:R[i],bDescending:false});}}var X=p.getFilterExpression();X.clear();if(this.aApplicationFilter){X.addUI5FilterConditions(this.aApplicationFilter);}if(this.aControlFilter){X.addUI5FilterConditions(this.aControlFilter);}if(q>=1){for(var k=0,l=h.length;k<l;k++){X.removeConditions(this.aAggregationLevel[k]);X.addCondition(this.aAggregationLevel[k],t.EQ,h[k]);}}K._addHierarchyLevelFilters(o,X);var Y;var Z;var $;var _;var a1=[];if(g!=null||this.bProvideGrandTotals||(this._canApplySortersToGroups()&&this.aSorter.length>0)){p.setMeasures(this.aMeasureName);for(var b1 in this.oMeasureDetailsSet){_=this.oMeasureDetailsSet[b1];if(!P&&this._isSkippingTotalForMeasure(b1)){Y=false;Z=false;$=false;}else{Y=(_.rawValuePropertyName!=undefined);Z=(_.formattedValuePropertyName!=undefined);$=(_.unitPropertyName!=undefined);if($){if(a1.indexOf(_.unitPropertyName)==-1){a1.push(_.unitPropertyName);}}}p.includeMeasureRawFormattedValueUnit(_.name,Y,Z,$);}for(var n in R){var c1;if((c1=a1.indexOf(R[n]))!=-1){a1.splice(c1,1);}}}if(g){this._addSorters(p.getSortExpression(),m);}if(e==0){E.fatal("unhandled case: load 0 entities of sub group");}var d1=this._getKeyIndexMapping(g,s);if(!this.bNoPaging){p.setResultPageBoundaries(d1.iServiceKeyIndex+1,d1.iServiceKeyIndex+e);}p.setRequestOptions(null,!this.mFinalLength[g]);return{iRequestType:r,sRequestId:this._getRequestId(K._requestType.groupMembersQuery,{groupId:g}),oAnalyticalQueryRequest:p,sGroupId:g,aSelectedUnitPropertyName:a1,aAggregationLevel:Q,bIsFlatListRequest:P&&q==0,bIsLeafGroupsRequest:P,iStartIndex:s,iLength:e,oKeyIndexMapping:d1};};
K.prototype._prepareTotalSizeQueryRequest=function(r){var h;var o=new a.QueryResultRequest(this.oAnalyticalQueryResult);o.setResourcePath(this._getResourcePath());h=this._getHierarchyLevelFiltersAndAddRecursiveHierarchy(o,"/");o.setAggregationLevel(this._getNonHierarchyDimensions(this.aMaxAggregationLevel));o.setMeasures([]);var e=o.getFilterExpression();e.clear();if(this.aApplicationFilter){e.addUI5FilterConditions(this.aApplicationFilter);}if(this.aControlFilter){e.addUI5FilterConditions(this.aControlFilter);}K._addHierarchyLevelFilters(h,e);o.setRequestOptions(null,null,true);o.setRequestOptions(null,true);return{iRequestType:r,sRequestId:this._getRequestId(K._requestType.totalSizeQuery),oAnalyticalQueryRequest:o};};
K.prototype._prepareGroupMembersAutoExpansionQueryRequest=function(r,g,o,e,n){var h=this;var p=function(o,s){var P=[];if(o.groupId_Missing==null){E.fatal("missing group Id not present");return P;}var z=h._getGroupIdComponents(o.groupId_Missing);var N=z.length;if(N>s){E.fatal("the given group ID is too deep for requested level for auto expansion");return P;}var k=[];for(var i=0;i<N;i++){var l=h.aAggregationLevel[i];var b1=z[i];var c1=h._getFilterOperatorMatchingPropertySortOrder(l);k[i]=new F(l,c1,b1);}var d1=null;if(o.startIndex_Missing>0){var e1=h._getKey(o.groupId_Missing,o.startIndex_Missing-1);var f1=h.oModel.getObject("/"+e1);var g1=h.aAggregationLevel[N];var h1=f1[g1];d1=new F(g1,h._getFilterOperatorMatchingPropertySortOrder(g1,false),h1);}for(var U=0;U<s;U++){var i1=[];var j1=Math.min(N,U+1);for(var k1=0;k1<j1;k1++){var l1=[];var m1=Math.min(N,k1+1);var n1=o.startIndex_Missing>0;for(var o1=0;o1<m1;o1++){var p1=new F("x",t.EQ,"x");p1=d(p1,k[o1]);if(m1>1&&o1<m1-1){p1.sOperator=t.EQ;}if(o1==N-1&&U>N-1&&!n1){if(p1.sOperator==t.GT){p1.sOperator=t.GE;}else{p1.sOperator=t.LE;}}l1.push(p1);}if(l1.length>0){i1.push(new F(l1,true));if(U>N-1&&k1==N-1&&n1){var q1=[];for(var j=0;j<l1.length;j++){var r1=new F("x",t.EQ,"x");r1=d(r1,l1[j]);q1.push(r1);}q1[N-1].sOperator=t.EQ;q1.push(d1);i1.push(new F(q1,true));break;}}}if(i1.length>0){P[U]=new F(i1,false);}else{P[U]=null;}}return P;};var m=function(r,g,U,b1,V,e,c1,d1){var e1;var f1=new a.QueryResultRequest(h.oAnalyticalQueryResult);f1.setResourcePath(h._getResourcePath());f1.getSortExpression().clear();var g1=0,h1=-1;g1=h1=U-1;var i1=0;for(var i=0,j1=0;i<g1;j1++){if(h.oDimensionDetailsSet[h.aMaxAggregationLevel[j1]].grouped==false){++i1;}else{++i;}}g1=h1=g1+i1;if(h.aMaxAggregationLevel.length>0){while(h.aMaxAggregationLevel[h1]&&h.oDimensionDetailsSet[h.aMaxAggregationLevel[h1]].grouped==false){if(++h1==h.aMaxAggregationLevel.length){break;}}}var k1=h1>=h.aMaxAggregationLevel.length-1;e1=h._getHierarchyLevelFiltersAndAddRecursiveHierarchy(f1,g);var l1=h.aMaxAggregationLevel.slice(0,h1+1);f1.setAggregationLevel(l1);for(var l=0;l<l1.length;l++){var m1=h.oDimensionDetailsSet[l1[l]];var n1=(m1.textPropertyName!=undefined);f1.includeDimensionKeyTextAttributes(m1.name,true,n1,m1.aAttributeName);if(m1.grouped){f1.getSortExpression().addSorter(l1[l],a.SortOrder.Ascending);}}var o1=f1.getFilterExpression();o1.clear();if(h.aApplicationFilter){o1.addUI5FilterConditions(h.aApplicationFilter);}if(h.aControlFilter){o1.addUI5FilterConditions(h.aControlFilter);}if(b1){o1.addUI5FilterConditions([b1]);}K._addHierarchyLevelFilters(e1,o1);var p1;var q1;var r1;var s1;var t1=[];f1.setMeasures(h.aMeasureName);for(var u1 in h.oMeasureDetailsSet){s1=h.oMeasureDetailsSet[u1];if(!k1&&h._isSkippingTotalForMeasure(u1)){p1=false;q1=false;r1=false;}else{p1=(s1.rawValuePropertyName!=undefined);q1=(s1.formattedValuePropertyName!=undefined);r1=(s1.unitPropertyName!=undefined);if(r1){if(t1.indexOf(s1.unitPropertyName)==-1){t1.push(s1.unitPropertyName);}}}f1.includeMeasureRawFormattedValueUnit(s1.name,p1,q1,r1);}for(var j in l1){var v1;if((v1=t1.indexOf(l1[j]))!=-1){t1.splice(v1,1);}}var w1=f1.getSortExpression();for(var k=0;k<h.aSorter.length;k++){if(h.aSorter[k]){w1.addSorter(h.aSorter[k].sPath,h.aSorter[k].bDescending?a.SortOrder.Descending:a.SortOrder.Ascending);}}if(e==0){E.fatal("unhandled case: load 0 entities of sub group");}var x1=V;if(!d1){x1=0;}else{var y1=0;for(var z1 in h.mServiceKey){if(z1.split("/").length===U+1){y1+=h.mServiceKey[z1].length;}}x1=Math.max(x1,y1);}if(!h.bNoPaging){f1.setResultPageBoundaries(x1+1,x1+e);}return{iRequestType:r,sRequestId:null,oAnalyticalQueryRequest:f1,iLevel:U,aSelectedUnitPropertyName:t1,aAggregationLevel:l1,bIsFlatListRequest:k1,bIsLeafGroupsRequest:k1,iStartIndex:V,iLength:e,bAvoidLengthUpdate:c1};};var q=[];var R=[];if(!o){E.fatal("no first missing group member specified");}var s=this._getGroupIdLevel(g)+n+1;var z=h._getGroupIdComponents(o.groupId_Missing);var N=z.length;var P=p(o,s);var Q;for(var U=1;U<=s;U++){var V;if(U>=N+2){V=0;Q=undefined;}else if(U==N+1){V=o.startIndex_Missing;Q=o.groupId_Missing;}else if(N>0){if(U==N){Q=o.groupId_Missing;}else{Q=this._getGroupIdAncestors(o.groupId_Missing,-(N-U))[0];}var W=this._getGroupIdAncestors(o.groupId_Missing,-(N-U+1))[0];if(!W){E.fatal("failed to determine group id at parent level; group ID = "+g+", level = "+U);}V=this._findKeyIndex(W,this.mEntityKey[Q]);if(V==-1){E.fatal("failed to determine position of value "+Q+" in group "+W);}Q=W;V++;}var X=e>U?Math.ceil((e-U)/(s-U+1)):e;var Y=P[U-1];if(this.bUseAcceleratedAutoExpand){var Z=m(K._requestType.levelMembersQuery,g,U,Y,V,X,false,Y==null?true:false);Z.sGroupId_Missing_AtLevel=Q;Z.sRequestId=this._getRequestId(K._requestType.levelMembersQuery,{groupId:g,level:U});q.push(Z);R.push(Z.sRequestId);}else if(Y&&Y.aFilters.length>0){if(!Y._bMultiFilter||Y.bAnd){E.fatal("level filter in wrong shape; cannot break it up");}for(var i=0;i<Y.aFilters.length;i++){var $=Y.aFilters[i];var _=m(K._requestType.levelMembersQuery,g,U,$,V,X,false,Y==null?true:false);_.sGroupId_Missing_AtLevel=Q;_.sRequestId=this._getRequestId(K._requestType.levelMembersQuery,{groupId:g,level:U,tupleIndex:i});q.push(_);R.push(_.sRequestId);}}else{var a1=m(K._requestType.levelMembersQuery,g,U,null,V,X,false,Y==null?true:false);a1.sGroupId_Missing_AtLevel=Q;a1.sRequestId=this._getRequestId(K._requestType.levelMembersQuery,{groupId:g,level:U});q.push(a1);R.push(a1.sRequestId);}}return{iRequestType:r,aRequestId:R,aGroupMembersAutoExpansionRequestDetails:q,sGroupId:g,iLength:e};};
K.prototype._prepareReloadMeasurePropertiesQueryRequest=function(r,g,m){var o=new a.QueryResultRequest(this.oAnalyticalQueryResult);o.setResourcePath(this._getResourcePath());o.getSortExpression().clear();var e=g.aAggregationLevel;o.setAggregationLevel(e);var h=g.bIsLeafGroupsRequest;var k=o.getFilterExpression();k.clear();if(this.aApplicationFilter){k.addUI5FilterConditions(this.aApplicationFilter);}if(this.aControlFilter){k.addUI5FilterConditions(this.aControlFilter);}var l=[];for(var i=0;i<e.length;i++){var n=new F(e[i],t.EQ,m.oEntry[e[i]]);l.push(n);}k.addUI5FilterConditions(l);var p;var q;var s;var z;var N=[];o.setMeasures(m.aReloadMeasurePropertyName);for(var P in this.oMeasureDetailsSet){z=this.oMeasureDetailsSet[P];if(!m.aReloadMeasurePropertyName||m.aReloadMeasurePropertyName.indexOf(z.name)==-1){continue;}if(!h&&this._isSkippingTotalForMeasure(P)){p=false;q=false;s=false;}else{p=(z.rawValuePropertyName!=undefined);q=(z.formattedValuePropertyName!=undefined);s=(z.unitPropertyName!=undefined);if(s){if(N.indexOf(z.unitPropertyName)==-1){N.push(z.unitPropertyName);}}}o.includeMeasureRawFormattedValueUnit(z.name,p,q,s);}for(var j in e){var Q;if((Q=N.indexOf(e[j]))!=-1){N.splice(Q,1);}}return{iRequestType:r,sRequestId:this._getRequestId(K._requestType.reloadMeasuresQuery,{multiUnitEntryKey:this.oModel.getKey(m.oEntry)}),oAnalyticalQueryRequest:o,aSelectedUnitPropertyName:N,aAggregationLevel:e,oMultiUnitRepresentative:m};};
K.prototype._prepareGroupMembersAutoExpansionRequestIds=function(g,n){var m=this._getGroupIdLevel(g)+1;var i=m+n;var r=[];for(var l=m;l<=i;l++){r.push(this._getRequestId(K._requestType.levelMembersQuery,{groupId:g,level:l}));}return r;};
K.prototype._getQueryODataRequestOptions=function(o,g,p){var i;p=p||{};try{o.getFilterExpression().checkValidity();}catch(e){E.fatal("filter expression is not valid",e.toString());return undefined;}var s=o.getURIQueryOptionValue("$select");var h=o.getURIQueryOptionValue("$filter");var j=o.getURIQueryOptionValue("$orderby");var k=o.getURIQueryOptionValue("$skip");var l=o.getURIQueryOptionValue("$top");var m=o.getURIQueryOptionValue("$inlinecount");if(g&&this.aAdditionalSelects.length>0){s=(s?s.split(","):[]).concat(this.aAdditionalSelects).join(",");}if(this.mParameters&&this.mParameters["filter"]){if(h===null){h=this.mParameters["filter"];}else{h+="and ("+this.mParameters["filter"]+")";}}var P=[];if(s!==null){P.push("$select="+s);}if(h!==null){P.push("$filter="+h);}if(j!==null){P.push("$orderby="+j);}if(k!==null){P.push("$skip="+k);}if(l!==null){P.push("$top="+l);}if(m!==null){P.push("$inlinecount="+m);}if(p.encode===true){for(i=0;i<P.length;i++){P[i]=P[i].replace(/\ /g,"%20");}}return P;};
K.prototype._executeBatchRequest=function(r){var e=this.iAnalyticalInfoVersionNumber,R,g=this;var h=[],l=[];function m(){g.fireDataReceived({__simulateAsyncAnalyticalBinding:true});}var o=new B();function s(j,k){o.success(k);}function n(j,k){o.error(k||j);}this.bNeedsUpdate=true;for(var p=0;p<r.length;p++){var q=r[p];if(q.aAggregationLevel&&q.aAggregationLevel.length>0){this.bNeedsUpdate=false;}}for(var i=-1,z;(z=r[++i])!==undefined;){var N=z.oAnalyticalQueryRequest,P=z.sGroupId;if(N.getURIQueryOptionValue("$select")==null){this.fireDataRequested({__simulateAsyncAnalyticalBinding:true});P=null;this.mServiceLength[P]=this.mLength[P]=1;this.mServiceFinalLength[P]=true;this._setServiceKey(this._getKeyIndexMapping(P,0),K._artificialRootContextGroupId);setTimeout(m);this.bArtificalRootContext=true;continue;}var Q=N.getURIToQueryResultEntries();if(!this.oContext&&Q[0]!=="/"){Q="/"+Q;}if(!this._isRequestPending(z.sRequestId)){this._registerNewRequest(z.sRequestId);if(this.iModelVersion===A.V1){h.push(this.oModel.createBatchOperation(Q.replace(/\ /g,"%20"),"GET"));}else if(this.iModelVersion===A.V2){var U=this._getQueryODataRequestOptions(N,z.bIsLeafGroupsRequest,{encode:true});if(this.sCustomParams){U.push(this.sCustomParams);}var V=this.oModel.read(Q.replace(/\ /g,"%20"),{success:s,error:n,context:this.oContext,urlParameters:U});h.push(V);}l.push(z);}}if(h.length>0){E.debug("AnalyticalBinding: executing batch request with "+l.length+" operations");var W;R=this._getIdForNewRequestHandle();this.fireDataRequested();if(this.iModelVersion===A.V1){this.oModel.addBatchReadOperations(h);W=this.oModel.submitBatch(X,Y,true,true);this.oModel.fireRequestSent({url:this.oModel.sServiceUrl+"/$batch",type:"POST",async:true,info:"",infoObject:{}});}else{W={abort:function(){for(var j=0;j<h.length;j++){h[j].abort();}}};o.setup({executedRequests:l,binding:this,success:X,error:Y});}this._registerNewRequestHandle(R,W);}function X(Z,$){g._deregisterHandleOfCompletedRequest(R);if(l.length!=Z.__batchResponses.length){E.fatal("assertion failed: received "+Z.__batchResponses.length+" responses for "+l.length+" read operations in the batch request");}if(e!=g.iAnalyticalInfoVersionNumber){for(var j=0;j<l.length;j++){var _=l[j].sRequestId;if(_!==undefined){g._deregisterCompletedRequest(_);g._cleanupGroupingForCompletedRequest(_);}}g.fireDataReceived({data:[]});return;}var a1=0;for(var k=0;k<Z.__batchResponses.length;k++){if(Z.__batchResponses[k].data!=undefined){if(Z.__batchResponses[k].data.results.length==0){a1++;}switch(l[k].iRequestType){case K._requestType.groupMembersQuery:g._processGroupMembersQueryResponse(l[k],Z.__batchResponses[k].data);break;case K._requestType.totalSizeQuery:g._processTotalSizeQueryResponse(l[k],Z.__batchResponses[k].data);break;case K._requestType.levelMembersQuery:g._processLevelMembersQueryResponse(l[k],Z.__batchResponses[k].data);break;case K._requestType.reloadMeasuresQuery:g._processReloadMeasurePropertiesQueryResponse(l[k],Z.__batchResponses[k].data);break;default:E.fatal("invalid request type "+l[k].iRequestType);continue;}}g._deregisterCompletedRequest(l[k].sRequestId);g._cleanupGroupingForCompletedRequest(l[k].sRequestId);}if(g.mParameters&&g.mParameters.numberOfExpandedLevels>0){if(a1==Z.__batchResponses.length){g.mLength["/"]=0;g.mFinalLength["/"]=true;}}var b1=true;var c1;g.fireDataReceived({data:Z});var d1={};if(g.iModelVersion===A.V1){c1=g.oModel._getBatchErrors(Z);if(c1.length>0){b1=false;d1=g.oModel._handleError(c1[0]);}g.oModel.fireRequestCompleted({url:$.requestUri,type:"POST",async:true,info:"",infoObject:{},success:b1,errorobject:b1?{}:d1});if(b1){g.oModel.checkUpdate();}}}function Y(k){if(k&&k.statusText!="abort"){g._deregisterHandleOfCompletedRequest(R);for(var j=-1,Z;(Z=l[++j])!==undefined;){g._deregisterCompletedRequest(Z.sRequestId);g._cleanupGroupingForCompletedRequest(Z.sRequestId);}}if(e!=g.iAnalyticalInfoVersionNumber){return;}var $=k;if(g.iModelVersion===A.V1){$=g.oModel._handleError(k);}g.oModel.fireRequestCompleted({url:"",type:"POST",async:true,info:"",infoObject:{},success:false,errorobject:$});if(g.iModelVersion===A.V1){g.oModel.fireRequestFailed($);}g.fireDataReceived();}};
K.prototype._executeQueryRequest=function(r){if(r.iRequestType==K._requestType.groupMembersAutoExpansionQuery){for(var i=-1,o;(o=r.aGroupMembersAutoExpansionRequestDetails[++i])!==undefined;){this._executeQueryRequest(o);}return;}var e=this.iAnalyticalInfoVersionNumber;var g=r.oAnalyticalQueryRequest,s=r.sGroupId;var p=g.getURIToQueryResultEntitySet();var P=this._getQueryODataRequestOptions(g,r.bIsLeafGroupsRequest);if(!P){return;}var h=this;if(g.getURIQueryOptionValue("$select")==null){this.fireDataRequested({__simulateAsyncAnalyticalBinding:true});s=null;this.mServiceLength[s]=this.mLength[s]=1;this.mServiceFinalLength[s]=true;this._setServiceKey(this._getKeyIndexMapping(s,0),K._artificialRootContextGroupId);this.bNeedsUpdate=true;setTimeout(function(){if(h._cleanupGroupingForCompletedRequest(r.sRequestId)){h.fireDataReceived({__simulateAsyncAnalyticalBinding:true});}});this.bArtificalRootContext=true;return;}this._registerNewRequest(r.sRequestId);this.fireDataRequested();for(var j=0;j<P.length;j++){P[j]=P[j].replace(/\ /g,"%20");}E.debug("AnalyticalBinding: executing query request");var R=this._getIdForNewRequestHandle();if(this.iModelVersion===A.V1){this.oModel._loadData(p,P,l,n,false,U,m);}else{if(this.sCustomParams){P.push(this.sCustomParams);}var k=this.oModel.read(p.replace(/ /g,"%20"),{success:l,error:n,context:this.oContext,urlParameters:P});h._registerNewRequestHandle(R,k);}function l(q){h._deregisterHandleOfCompletedRequest(R);if(e!=h.iAnalyticalInfoVersionNumber){h._deregisterCompletedRequest(r.sRequestId);return;}switch(r.iRequestType){case K._requestType.groupMembersQuery:h._processGroupMembersQueryResponse(r,q);break;case K._requestType.totalSizeQuery:h._processTotalSizeQueryResponse(r,q);break;case K._requestType.levelMembersQuery:h._processLevelMembersQueryResponse(r,q);break;case K._requestType.reloadMeasuresQuery:h._processReloadMeasurePropertiesQueryResponse(r,q);break;default:E.fatal("invalid request type "+r.iRequestType);break;}h._deregisterCompletedRequest(r.sRequestId);if(h.iModelVersion===A.V2){m(q);}}function m(q){if(e!=h.iAnalyticalInfoVersionNumber){return;}if(h._cleanupGroupingForCompletedRequest(r.sRequestId)){h.fireDataReceived({data:q});}}function n(q){if(q&&q.statusText=="abort"){h.fireDataReceived();return;}h._deregisterHandleOfCompletedRequest(R);h._deregisterCompletedRequest(r.sRequestId);h._cleanupGroupingForCompletedRequest(r.sRequestId);if(e!=h.iAnalyticalInfoVersionNumber){return;}h.fireDataReceived();}function U(k){h._registerNewRequestHandle(R,k);}};
K.prototype._abortAllPendingRequests=function(){this._abortAllPendingRequestsByHandle();this._clearAllPendingRequests();};
K.prototype._processGroupMembersQueryResponse=function(R,e){var s,n=R.sGroupId,z=this.aSorter.length>0,N=R.aSelectedUnitPropertyName,P=R.aAggregationLevel,Q=R.oKeyIndexMapping.iIndex,U=R.oKeyIndexMapping.iServiceKeyIndex,V=R.iLength,W=R.oKeyIndexMapping,X=n==null?0:this._getGroupIdLevel(n)+1,Y=(N.length>0),Z,$,_,a1=0,b1,c1,d1=[];var e1=e.results.length;if(n===null&&e1>1&&this._canApplySortersToGroups()){this._warnNoSortingOfGroups(z?"binding is refreshed":undefined);if(z){setTimeout(this.refresh.bind(this),0);return;}}var f1=this._getServiceKeys(n,W.iIndex-1);Z=undefined;if(f1&&f1.length>0){for(var i=0,g1=f1.length;i<g1;i++){e.results[i-g1]=this.oModel.getObject("/"+f1[i]);}var h1=e.results[-f1.length];Z="";for(var j=0;j<P.length;j++){Z+=h1[P[j]]+"|";}}b1=f1&&f1.length==1;for(var h=0;h<e1;h++){var i1=e.results[h];if(Y){$="";for(var g=0;g<P.length;g++){$+=i1[P[g]]+"|";}if(Z==$){this._warnNoSortingOfGroups();if(_===undefined){if(h==0){_=-f1.length;W.iServiceKeyIndex-=f1.length-1;}else{_=h-1;}}var j1=-1,k1=e.results[h-1];for(var k=0;k<N.length;k++){if(k1[N[k]]!=i1[N[k]]){j1=k;break;}}if(j1==-1){E.fatal("assertion failed: no deviating units found for result entries "+(h-1)+" and "+h,null,null,M(this,"NO_DEVIATING_UNITS"));}}if((Z!=$||h==e1-1)&&_!==undefined){var l1=[];for(var l=_;l<h;l++){l1.push(e.results[l]);}if(Z==$){l1.push(e.results[h]);}var m1=[];for(var m=0;m<N.length;m++){var n1=N[m];for(var o=1;o<l1.length;o++){if(l1[o-1][n1]!=l1[o][n1]){m1.push(n1);break;}}}var o1=this._createMultiUnitRepresentativeEntry(n,e.results[_],N,m1,R.bIsFlatListRequest);if(o1.aReloadMeasurePropertyName.length>0){c1=this._prepareReloadMeasurePropertiesQueryRequest(K._requestType.reloadMeasuresQuery,R,o1);if(c1.oAnalyticalQueryRequest&&c1.oAnalyticalQueryRequest.getURIQueryOptionValue("$select")!=null){d1.push(c1);}}var p1=this._setAdjacentMultiUnitKeys(W,o1,l1);var q1;if(o1.bIsNewEntry){q1=l1.length-1;}else{q1=p1;}if(b1){b1=false;}if(q1<0){E.fatal("assertion failed: iDiscardedEntriesCount must be non-negative");}a1+=q1;var r1=this.oModel._getKey(o1.oEntry);var s1=this.oModel.getContext('/'+r1);this._getGroupIdFromContext(s1,X);this.mEntityKey[s]=r1;_=undefined;if(Z!=$){b1=this._setServiceKey(W,this.oModel._getKey(i1));}}else if(Z!=$){b1=this._setServiceKey(W,this.oModel._getKey(i1));}Z=$;}else{this._setServiceKey(W,this.oModel._getKey(i1));}if(!R.bIsLeafGroupsRequest){var t1=this._getKey(n,W.iIndex-1);s=this._getGroupIdFromContext(this.oModel.getContext('/'+t1),X);this.mEntityKey[s]=t1;}}var u1=[];if(this.bReloadSingleUnitMeasures&&d1.length>0){if(this.bUseBatchRequests){this.aBatchRequestQueue.push([K._requestType.reloadMeasuresQuery,d1]);Promise.resolve().then(K.prototype._processRequestQueue.bind(this));}else{for(var q=0;q<d1.length;q++){var v1=d1[q];this._executeQueryRequest(v1);}}for(var p=0;p<d1.length;p++){var w1=d1[p];u1.push(w1.sRequestId);}this._considerRequestGrouping(u1);}if(f1&&f1.length>0){for(var r=0,x1=f1.length;r<x1;r++){delete e.results[r-x1];}}if(Y){a1+=this._mergeLoadedKeyIndexWithSubsequentIndexes(W,P,N,R.bIsFlatListRequest);}if(!R.bAvoidLengthUpdate){var y1=false;if(e.__count){this.mServiceLength[n]=parseInt(e.__count);this.mLength[n]=this.mServiceLength[n]-a1;this.mFinalLength[n]=true;if(R.bIsFlatListRequest){this.iTotalSize=this.mServiceLength[n];}y1=true;}if(!(n in this.mServiceLength)||this.mServiceLength[n]<U+e1){this.mServiceLength[n]=U+e1;this.mLength[n]=Q+e1-a1;this.mFinalLength[n]=false;}if(e1<V||V===undefined){this.mServiceLength[n]=U+e1;this.mLength[n]=Q+W.iIndex-Q;this.mFinalLength[n]=true;y1=true;}if(e1==0){this.mLength[n]=this.mServiceLength[n]=0;this.mFinalLength[n]=true;y1=true;}if(!y1&&this.mLength[n]!==undefined&&a1>0){this.mLength[n]-=a1;}}this.bNeedsUpdate=true;if(a1>0){if(e.results.length-a1>0){this.aMultiUnitLoadFactor[P.length]=e.results.length/(e.results.length-a1);}if(this.aMultiUnitLoadFactor[P.length]<1.5){this.aMultiUnitLoadFactor[P.length]=2;}}E.info("MultiUnit Situation in Group ("+n+"), discarded: "+a1+", load-factor is now: "+this.aMultiUnitLoadFactor[P.length]);};
K.prototype._processTotalSizeQueryResponse=function(r,o){if(o.__count==undefined){E.fatal("missing entity count in query result");return;}this.iTotalSize=parseInt(o.__count);};
K.prototype._processLevelMembersQueryResponse=function(r,o){var e=this;var p,P;var g=function(h,l){var m={iRequestType:K._requestType.groupMembersQuery,sRequestId:e._getRequestId(K._requestType.groupMembersQuery,{groupId:p}),oAnalyticalQueryRequest:r.oAnalyticalQueryRequest,sGroupId:p,aSelectedUnitPropertyName:r.aSelectedUnitPropertyName,aAggregationLevel:r.aAggregationLevel,bIsFlatListRequest:r.bIsFlatListRequest,bIsLeafGroupsRequest:r.bIsLeafGroupsRequest,iStartIndex:h?r.iStartIndex:0,iLength:r.iLength,bAvoidLengthUpdate:r.bAvoidLengthUpdate};if(h&&r.iStartIndex>0&&(r.sGroupId_Missing_AtLevel!=m.sGroupId||e._getKeys(m.sGroupId)===undefined)){var s=e._getParentGroupId(m.sGroupId);var n=e._findKeyIndex(s,e.mEntityKey[m.sGroupId]);if(n<0){E.fatal("assertion failed: failed to determine position of "+m.sGroupId+" in group "+s);}else if(!n){e.mFinalLength[r.sGroupId_Missing_AtLevel]=true;}else if(e._getKey(s,n-1)!==undefined){var q=e._getKey(s,n-1);var z=e._getGroupIdFromContext(e.oModel.getContext('/'+q),e._getGroupIdLevel(m.sGroupId));e.mFinalLength[z]=true;m.iStartIndex=0;}}if(l){m.iLength=P.length;}m.oKeyIndexMapping=e._getKeyIndexMapping(m.sGroupId,m.iStartIndex);var N=d({},o);N.results=P;e._processGroupMembersQueryResponse(m,N);};if(o.results.length==0){this.bNeedsUpdate=true;return;}p=this._getGroupIdFromContext(this.oModel.getContext("/"+this.oModel._getKey(o.results[0])),r.iLevel-1);P=[];var h=true;for(var i=0;i<o.results.length;i++){var j=o.results[i];var k=this.oModel.getContext("/"+this.oModel._getKey(o.results[i]));var s=this._getGroupIdFromContext(k,r.iLevel-1);if(p==s){P.push(j);if(i<o.results.length-1){continue;}}g(h,o.results.length==r.iLength&&i==o.results.length-1);h=false;if(p!=s){P=[j];}p=s;}if(o.results.length>1&&P.length==1){g(h,o.results.length==r.iLength);}};
K.prototype._processReloadMeasurePropertiesQueryResponse=function(r,o){var m=r.oMultiUnitRepresentative;var s=this.oModel.getKey(m.oEntry);if(o.results.length!=1){E.fatal("assertion failed: more than one entity for reloaded measure properties of entity with key "+s);return;}var R=o.results[0];var e=this.oModel.getObject("/"+s);if(!e){E.fatal("assertion failed: no entity found with key "+s);return;}var g=m.aReloadMeasurePropertyName;for(var i=0;i<g.length;i++){e[g[i]]=R[g[i]];}};
K.prototype._getLoadedContextsForGroup=function(g,s,l,e){var h=[],o,i,k=this._getKeys(g),j;if(!k){return h;}if(!s){s=0;}if(!l){l=this.oModel.iSizeLimit;if(this.mFinalLength[g]){l=this.mLength[g];}}if(e){i=s||0;j=k(i);while(j){o=this.oModel.getContext('/'+j);h.push(o);i++;j=k(i);}return h;}for(i=s;i<s+l;i++){j=k(i);if(!j){break;}o=this.oModel.getContext('/'+j);h.push(o);}return h;};
K.prototype._calculateRequiredGroupSection=function(g,s,l,i){var e=this.mKeyIndex[g]||[],h=this.mFinalLength[g]?this.mLength[g]:undefined,j=O._getReadIntervals(e,s,l,i,h),o=O._mergeIntervals(j);if(o){return{startIndex:o.start,length:o.end-o.start};}return{startIndex:0,length:Math.min(0,l)};};
K.prototype._calculateRequiredGroupExpansion=function(g,e,s,l){var n={groupId_Missing:null,length_Missing:0};var h=this;var j=function(g,e,s,l){var k=h._getGroupIdLevel(g);if(k==e){var N=h._getLoadedContextsForGroup(g,s,l);var Q=s+N.length-1;if(N.length>=l){return n;}else if(h.mFinalLength[g]){if(N.length>=h.mLength[g]){return{groupId_Missing:null,length_Missing:l-N.length};}else{return{groupId_Missing:g,startIndex_Missing:Q+1,length_Missing:l-N.length};}}else{return{groupId_Missing:g,startIndex_Missing:Q+1,length_Missing:l-N.length};}}var R=h._getLoadedContextsForGroup(g,s,l);var m=l,U=s+R.length-1;for(var i=-1,V;(V=R[++i])!==undefined;){m--;var p=j(h._getGroupIdFromContext(V,k+1),e,0,m);if(p.groupId_Missing==null){if(p.length_Missing==0){return p;}else{m=p.length_Missing;}}else{return p;}if(m==0){break;}}if(h.mFinalLength[g]||m==0){return{groupId_Missing:null,length_Missing:m};}else{return{groupId_Missing:g,startIndex_Missing:U+1,length_Missing:m};}};var k=this._getGroupIdLevel(g);if(k==e+1){g=this._getParentGroupId(g);--k;}if(g==null||k>e){return n;}var m=l,o=s;while(g!=null){var p=j(g,e,o,m);if(p.groupId_Missing!=null){return p;}else if(p.length_Missing==0){return p;}else{var q=false;while(!q){var P=this._getParentGroupId(g);if(P==null){g=P;--k;break;}var r=this.mEntityKey[g];if(!r){return n;}var z=this._findKeyIndex(P,r);if(z==-1){return n;}if(z==this._getKeyCount(P)-1){if(this.mFinalLength[P]){g=P;--k;continue;}else{return{groupId_Missing:P,startIndex_Missing:z+1,length_Missing:m};}}else{r=this._getKey(P,z+1);g=this._getGroupIdFromContext(this.oModel.getContext('/'+r),k);q=true;}}o=0;m=p.length_Missing;}}return{groupId_Missing:null,length_Missing:m};};
K.prototype._getResourcePath=function(){return this.isRelative()?this.getResolvedPath():this.sPath;};
K.prototype._getEntitySet=function(){var e=this.sEntitySetName;if(!e){e=this.sPath.split("/")[1];if(e.indexOf("(")!=-1){e=e.split("(")[0]+"Results";}}return e;};
K.prototype._getEffectiveSortOrder=function(p){for(var i=0;i<this.aSorter.length;i++){if(this.aSorter[i]&&this.aSorter[i].sPath==p){return this.aSorter[i].bDescending?a.SortOrder.Descending:a.SortOrder.Ascending;}}return null;};
K.prototype._getFilterOperatorMatchingPropertySortOrder=function(p,W){var s;switch(this._getEffectiveSortOrder(p)){case a.SortOrder.Ascending:if(W){s=t.GE;}else{s=t.GT;}break;case a.SortOrder.Descending:if(W){s=t.LE;}else{s=t.LT;}break;default:s=t.GT;}return s;};
K.prototype._convertDeprecatedFilterObjects=function(e){if(!e){return e;}var g=sap.ui.require("sap/ui/model/odata/Filter");if(typeof g==='function'){for(var i=0,l=e.length;i<l;i++){if(e[i]instanceof g){e[i]=e[i].convert();}}}return e;};
K.prototype._getGroupIdFromContext=function(o,l){if(!o){return null;}var g="/";var s=null;if(l>this.aAggregationLevel.length){E.fatal("assertion failed: aggregation level deeper than number of current aggregation levels");}for(var i=0;i<l;i++){s=o.getProperty(this.aAggregationLevel[i]);if(s!=null){if(s.__edmType==="Edm.Time"){s=s.ms;}g+=encodeURIComponent(s)+"/";}else{g+="@/";}}return g;};
K.prototype._getGroupIdLevel=function(g){if(g==null){E.fatal("assertion failed: no need to determine level of group ID = null");return-1;}return g.split("/").length-2;};
K.prototype._getGroupIdComponents=function(g){if(g==null){return null;}var e=g.split("/");var h=[];for(var i=1;i<e.length-1;i++){if(e[i]=="@"){h[i-1]=null;}else{h[i-1]=decodeURIComponent(e[i]);}}return h;};
K.prototype._getGroupIdAncestors=function(g,n){if(!n){return[];}if(g==null){E.fatal("group ID null does not have ancestors");return[];}if(g=="/"){if(Math.abs(n)==1){return[null];}else{E.fatal("invalid level count "+n+" for ancestors of groupId "+g);return[];}}var e=g.split("/");var h=[],s="";var k=0,l=e.length-3;if(n>0){if(n-1>l){E.fatal("invalid level count "+n+" for ancestors of groupId "+g);}else{l=n-1;}}else if(-(n+1)>l){E.fatal("invalid level count "+n+" for ancestors of groupId "+g);}else{k=l+1+n;for(var i=0;i<k;i++){s+=e[i]+"/";}}for(var j=k;j<=l;j++){s+=e[j]+"/";h.push(s);}return h;};
K.prototype._getParentGroupId=function(g){return this._getGroupIdAncestors(g,-1)[0];};
K.prototype._removeDuplicatesFromStringArray=function(e){var o={};for(var i=0;i<e.length;i++){o[e[i]]=true;}var U=[];for(var s in o){U.push(s);}return U;};
K.prototype._getIdForNewRequestHandle=function(){if(this.oPendingRequestHandle===undefined){this.oPendingRequestHandle=[];}for(var i=0;i<this.oPendingRequestHandle.length;i++){if(this.oPendingRequestHandle[i]===undefined){return i;}}this.oPendingRequestHandle[this.oPendingRequestHandle.length]=undefined;return this.oPendingRequestHandle.length-1;};
K.prototype._registerNewRequestHandle=function(r,R){if(this.oPendingRequestHandle[r]!==undefined){E.fatal("request handle ID already in use");}this.oPendingRequestHandle[r]=R;};
K.prototype._deregisterHandleOfCompletedRequest=function(r){if(f(this.oPendingRequestHandle)){E.warning("No request handles to be cleared. Previous abort/resetData?");return;}if(this.oPendingRequestHandle[r]===undefined){E.fatal("no handle found for this request ID");}this.oPendingRequestHandle[r]=undefined;};
K.prototype._abortAllPendingRequestsByHandle=function(){for(var i=0;i<this.oPendingRequestHandle.length;i++){if(this.oPendingRequestHandle[i]){if(this.oPendingRequestHandle[i]!==undefined){this.oPendingRequestHandle[i].abort();}}}this.oPendingRequestHandle=[];};
K.prototype._getRequestId=function(r,p){switch(r){case K._requestType.groupMembersQuery:if(p.groupId===undefined){E.fatal("missing group ID");}return K._requestType.groupMembersQuery+(p.groupId==null?"":p.groupId);case K._requestType.levelMembersQuery:if(p.level===undefined){E.fatal("missing level");}if(p.groupId===undefined){E.fatal("missing groupId");}return""+K._requestType.levelMembersQuery+p.level+(p.tupleIndex?"-"+p.tupleIndex:"");case K._requestType.totalSizeQuery:return K._requestType.totalSizeQuery;case K._requestType.reloadMeasuresQuery:if(!p.multiUnitEntryKey){E.fatal("missing multi unit entry key");}return K._requestType.reloadMeasuresQuery+p.multiUnitEntryKey;default:E.fatal("invalid request type "+r);return-1;}};
K.prototype._registerNewRequest=function(r){if(r==undefined||r==""){E.fatal("missing request ID");return;}if(!this.oPendingRequests[r]){this.oPendingRequests[r]=1;}else{++this.oPendingRequests[r];}};
K.prototype._considerRequestGrouping=function(r){for(var i=-1,R;(R=r[++i])!==undefined;){if(this.oGroupedRequests[R]===undefined){this.oGroupedRequests[R]={};}var g=this.oGroupedRequests[R];for(var j=0;j<r.length;j++){g[r[j]]=true;}}};
K.prototype._isRequestPending=function(r){return this.oPendingRequests[r]!=undefined&&this.oPendingRequests[r]>0;};
K.prototype._deregisterCompletedRequest=function(r){if(f(this.oPendingRequests)){E.warning("There are no pending requests which could be set to 'completed'.");return;}if(!this.oPendingRequests[r]){E.fatal("assertion failed: there is no pending request ID "+r);}if(this.oPendingRequests[r]==1){delete this.oPendingRequests[r];}else{--this.oPendingRequests[r];}};
K.prototype._cleanupGroupingForCompletedRequest=function(r){if(this._isRequestPending(r)){return false;}var g=true;if(this.oGroupedRequests[r]!=undefined){for(var o in this.oGroupedRequests[r]){if(this.oPendingRequests[o]){g=false;break;}}}if(g){var R=this.oGroupedRequests[r];delete this.oGroupedRequests[r];for(var s in R){if(s!=r){this._cleanupGroupingForCompletedRequest(s);}}}return g;};
K.prototype._getKeyIndexMapping=function(g,s){var i,l,e,k=this.mKeyIndex[g],o={sGroupId:g,iIndex:s,iServiceKeyIndex:s},h=this.mServiceKey[g];if(k!==undefined){if(k[s]!==undefined){o.iServiceKeyIndex=k[s]==="ZERO"?0:Math.abs(k[s]);return o;}l=s;if(l>0){while(--l>0){if(k[l]!==undefined){break;}}}if(l==0){e=0;}else{if(k[l]>=0){e=k[l];}else if(k[l+1]===undefined){e=-k[l];while(h[e+1]!==undefined){++e;}}else{e=Math.abs(k[l+1])-1;}if(h[e]===undefined){E.fatal("assertion failed: no service key at iLastOccupiedServiceKeyIndex = "+e);}}i=s-l;o.iServiceKeyIndex=e+i;}return o;};
K.prototype._moveKeyIndexMapping=function(k,i){return this._getKeyIndexMapping(k.sGroupId,k.iIndex+i);};
K.prototype._getKey=function(g,i){var s=this.mKeyIndex[g][i];if(s===undefined){return undefined;}if(s>=0){return this.mServiceKey[g][s];}if(this.mMultiUnitKey[g]===undefined){E.fatal("assertion failed: missing expected multi currency key for group with ID "+g);return null;}var k=this.mMultiUnitKey[g][i];if(k===undefined){E.fatal("assertion failed: missing expected multi currency key for group with ID "+g+" at pos "+i);return null;}return k;};
K.prototype._getKeys=function(g){if(this.mKeyIndex[g]===undefined){return undefined;}var e=this;return function(i){return e._getKey(g,i);};};
K.prototype._getServiceKeys=function(g,e){var k=this.mKeyIndex[g];if(k===undefined){return undefined;}var s=this.mServiceKey[g],h=k[e];if(h===undefined){return undefined;}if(h>=0){return[s[h]];}var j=[];if(k[e+1]===undefined){h=k[e]=="ZERO"?0:-k[e];while(s[h]!==undefined){j.push(s[h++]);}}else{h=k[e]=="ZERO"?0:-k[e];for(var i=h,n=Math.abs(k[e+1]);i<n;i++){j.push(s[i]);}}return j;};
K.prototype._getKeyCount=function(g){if(this.mKeyIndex[g]===undefined){return undefined;}return this.mKeyIndex[g].length;};
K.prototype._findKeyIndex=function(g,k){var e=this.mKeyIndex[g];var s=this.mServiceKey[g];var m=this.mMultiUnitKey[g];for(var i=0;i<this.mLength[g];i++){if(e[i]<0||e[i]==="ZERO"){if(m[i]==k){return i;}}else if(s[e[i]]==k){return i;}}return-1;};
K.prototype._setServiceKey=function(k,s){if(!this.mServiceKey[k.sGroupId]){this.mServiceKey[k.sGroupId]=[];}if(!this.mKeyIndex[k.sGroupId]){this.mKeyIndex[k.sGroupId]=[];}var n=this.mServiceKey[k.sGroupId][k.iServiceKeyIndex]===undefined;this.mServiceKey[k.sGroupId][k.iServiceKeyIndex++]=s;this.mKeyIndex[k.sGroupId][k.iIndex++]=k.iServiceKeyIndex-1;return n;};
K.prototype._setAdjacentMultiUnitKeys=function(k,m,e){if(!this.mServiceKey[k.sGroupId]){this.mServiceKey[k.sGroupId]=[];}if(!this.mKeyIndex[k.sGroupId]){this.mKeyIndex[k.sGroupId]=[];}if(!this.mMultiUnitKey[k.sGroupId]){this.mMultiUnitKey[k.sGroupId]=[];}--k.iIndex;--k.iServiceKeyIndex;this.mMultiUnitKey[k.sGroupId][k.iIndex]=this.oModel._getKey(m.oEntry);this.mKeyIndex[k.sGroupId][k.iIndex++]=k.iServiceKeyIndex>0?-k.iServiceKeyIndex:"ZERO";var n=0;for(var i=0;i<e.length;i++){if(!this.mServiceKey[k.sGroupId][k.iServiceKeyIndex]){++n;}this.mServiceKey[k.sGroupId][k.iServiceKeyIndex++]=this.oModel._getKey(e[i]);}return n;};
K.prototype._mergeLoadedKeyIndexWithSubsequentIndexes=function(k,e,s,g){var h=this.mKeyIndex[k.sGroupId],j=this.mServiceKey[k.sGroupId],m=this.mMultiUnitKey[k.sGroupId],l=0,n=k.iServiceKeyIndex,o=k.iIndex;var p,q;if(h===undefined){return l;}var N=false;var P=j[n-1],r=j[n];if(r===undefined){return l;}if(P===undefined){E.fatal("assertion failed: missing expected entry before given key index");return l;}var z=this.oModel.getObject("/"+P);var Q=this.oModel.getObject("/"+r);var R="",U="";for(var i=0;i<e.length;i++){R+=z[e[i]]+"|";U+=Q[e[i]]+"|";}N=R==U;var V=o;if(V>=this.mLength[k.sGroupId]){E.fatal("assertion failed: service key exists,but no corresponding key index found");return l;}while(h[V]===undefined||Math.abs(h[V])<n){++V;}if(N){if(Math.abs(h[V])==n&&h[V]<0){if(V>o){if(h[o-1]<0){m[V]=undefined;h.splice(o,V-o+1);m.splice(o,V-o+1);}else{h[o-1]=-h[o-1];m[o-1]=m[V];m[V]=undefined;h.splice(o,V-o+1);m.splice(o,V-o+1);l=1;}}}else if(Math.abs(h[V])>n){var W=V-1;if(h[W]>0){p=this._createMultiUnitRepresentativeEntry(k.sGroupId,z,s,undefined,g);q=this.oModel._getKey(p.oEntry);h[W]=-h[W];m[W]=q;if(W>o){h.splice(o,W-o);m.splice(o,W-o);}if(p.bIsNewEntry){l=1;}else{l=0;}}else if(h[o-1]<0){if(V>o){m[W]=undefined;h.splice(o,W-o+1);m.splice(o,W-o+1);}}else{h[o-1]=-h[o-1];m[o-1]=m[W];m[W]=undefined;h.splice(o,W-o+1);m.splice(o,W-o+1);}}else if(h[V]==n){if(V>o){if(h[o-1]<0){h.splice(o,V-o+1);m.splice(o,V-o+1);l=1;}else{p=this._createMultiUnitRepresentativeEntry(k.sGroupId,z,s,undefined,g);q=this.oModel._getKey(p.oEntry);if(!p.bIsNewEntry){E.fatal("assertion failed: multi-unit entry already existed before");}h[o-1]=-h[o-1];m[o-1]=q;h.splice(o,V-o+1);m.splice(o,V-o+1);l=1;}}}else{E.fatal("assertion failed: uncovered case detected");return l;}}else if(h[V]>n){E.fatal("unstable query result for group ID "+k.sGroupId+": entries have been removed or added. Complete reload required");}else if(V-o>0){h.splice(o,V-o);m.splice(o,V-o);}return l;};
K.prototype._createMultiUnitRepresentativeEntry=function(g,r,s,e,i){var m=d({},r);var R=[];for(var h in this.oMeasureDetailsSet){var o=this.oMeasureDetailsSet[h];if(!i&&this._isSkippingTotalForMeasure(h)){if(o.rawValuePropertyName!=undefined){m[o.rawValuePropertyName]=undefined;}if(o.formattedValuePropertyName!=undefined){m[o.formattedValuePropertyName]=undefined;}}else{if(o.rawValuePropertyName!=undefined){m[o.rawValuePropertyName]=null;}if(o.formattedValuePropertyName!=undefined){m[o.formattedValuePropertyName]="*";}}if(e){if(!o.unitPropertyName||e.indexOf(o.unitPropertyName)==-1){R.push(o.rawValuePropertyName||o.name);}}}for(var k=0;k<s.length;k++){if(e.indexOf(s[k])!=-1){m[s[k]]="*";}}var j="";for(var l=0;l<this.aAllDimensionSortedByName.length;l++){var n=m[this.aAllDimensionSortedByName[l]];var p=n===""?'""':n;p=p===undefined?"":p;j+=(encodeURIComponent(p)+",");}j+="-multiple-units-not-dereferencable|"+this._iId;var q;if(this.mMultiUnitKey[g]&&(q=this.mMultiUnitKey[g].indexOf(j))!=-1){return{oEntry:this.oModel.getObject("/"+j),bIsNewEntry:false,iIndex:q,aReloadMeasurePropertyName:R};}m.__metadata.uri=j;delete m.__metadata["self"];delete m.__metadata["self_link_extensions"];m["^~volatile"]=true;this.oModel._importData(m,{},{});var z=this.oModel._getKey(m);this.oModel.getContext('/'+z)["_volatile"]=true;return{oEntry:m,bIsNewEntry:true,aReloadMeasurePropertyName:R};};
K.prototype._clearAllPendingRequests=function(){this.oPendingRequests={};this.oGroupedRequests={};};
K.prototype.resetData=function(o){var g=o?o.getPath():undefined;this._resetData(g);};
K.prototype._resetData=function(g){if(g){delete this.mServiceKey[g];delete this.mServiceLength[g];delete this.mServiceFinalLength[g];delete this.mKeyIndex[g];delete this.mLength[g];delete this.mMultiUnitKey[g];delete this.mEntityKey[g];}else{this.mServiceKey={};this.mServiceLength={};this.mServiceFinalLength={};this.mFinalLength=this.mServiceFinalLength;this.mKeyIndex={};this.mLength={};this.mMultiUnitKey={};this.mEntityKey={};}};
K.prototype.refresh=function(e){K.prototype._refresh.apply(this,arguments);};
K.prototype._refresh=function(e,m,g){var h=false;if(!e){if(g){var r=this.getResolvedPath();var o=this.oModel.oMetadata._getEntityTypeByPath(r);if(o&&(o.entityType in g)){h=true;}}if(m&&!h){b(this.mServiceKey,function(i,n){b(n,function(i,k){if(k in m){h=true;return false;}return true;});if(h){return false;}return true;});}if(!m&&!g){h=true;}}if(e||h){this.iTotalSize=-1;this._abortAllPendingRequests();this.resetData();this.bNeedsUpdate=false;this._fireRefresh({reason:C.Refresh});}};
K.prototype.checkUpdate=function(e,m){var g=false;if(!e){if(this.bNeedsUpdate||!m){g=true;}else{b(this.mServiceKey,function(i,n){b(n,function(i,k){if(k in m){g=true;return false;}return true;});if(g){return false;}return true;});}}if(e||g){this.bNeedsUpdate=false;this._fireChange({reason:C.Change});}};
K.prototype.getDownloadUrl=function(s){var e,p,z;var o=new a.QueryResultRequest(this.oAnalyticalQueryResult);o.setResourcePath(this._getResourcePath());var g=[];var h=[];for(var n in this.oDimensionDetailsSet){g.push(n);}o.setAggregationLevel(g);for(var q in this.oDimensionDetailsSet){var r=this.oDimensionDetailsSet[q];var N=(r.textPropertyName!=undefined);o.includeDimensionKeyTextAttributes(r.name,true,N,r.aAttributeName);}for(var P in this.oMeasureDetailsSet){h.push(P);}o.setMeasures(h);for(var Q in this.oMeasureDetailsSet){var R=this.oMeasureDetailsSet[Q];var U=(R.rawValuePropertyName!=undefined);var V=(R.formattedValuePropertyName!=undefined);var W=(R.unitPropertyName!=undefined);o.includeMeasureRawFormattedValueUnit(R.name,U,V,W);}var X=o.getSortExpression();X.clear();for(var i=0;i<this.aSorter.length;i++){if(this.aSorter[i]){X.addSorter(this.aSorter[i].sPath,this.aSorter[i].bDescending?a.SortOrder.Descending:a.SortOrder.Ascending);}}var Y=o.getFilterExpression();Y.clear();if(this.aApplicationFilter){Y.addUI5FilterConditions(this.aApplicationFilter);}if(this.aControlFilter){Y.addUI5FilterConditions(this.aControlFilter);}var Z=o.getURIToQueryResultEntitySet();var $=this._getQueryODataRequestOptions(o,true);if(!$){return undefined;}var _=[];for(var k=0,m=this.aAnalyticalInfo.length;k<m;k++){var a1=this.aAnalyticalInfo[k];if((a1.visible||a1.inResult)&&a1.name!==""&&a1.name!==_[_.length-1]){_.push(a1.name);if(this.oMeasureDetailsSet[a1.name]!=undefined&&this.oMeasureDetailsSet[a1.name].unitPropertyName!=undefined){_.push(this.oMeasureDetailsSet[a1.name].unitPropertyName);}}}for(var j=0,l=$.length;j<l;j++){if(/^\$select/i.test($[j])){if(this.mParameters.select){e=$[j].slice(8).split(",");for(z=0;z<e.length;z++){p=e[z];if(_.indexOf(p)===-1){_.push(p);}}}$[j]="$select="+_.join(",");break;}}if(s){$.splice(0,0,"$format="+encodeURIComponent(s));}if(this.sCustomParams){$.push(this.sCustomParams);}if(Z){return this.oModel._createRequestUrl(Z,null,$).replace(/ /g,"%20");}return undefined;};
K.prototype._addSorters=function(s,g){var e=this._canApplySortersToGroups()?[].concat(this.aSorter).concat(g):[].concat(g).concat(this.aSorter);e.forEach(function(o){s.addSorter(o.sPath,o.bDescending?a.SortOrder.Descending:a.SortOrder.Ascending);});};
K.prototype._canApplySortersToGroups=function(){var s=this._autoExpandMode;if(this.bApplySortersToGroups){if(this.aSorter.length>0){if(s!==this.sLastAutoExpandMode&&s!==T.Sequential){E.warning("Applying sorters to groups is only possible with auto"+" expand mode 'Sequential'; current mode is: "+s,this.sPath);}this.sLastAutoExpandMode=s;}return s===T.Sequential;}return false;};
K.prototype._warnNoSortingOfGroups=function(s){var m;if(this.bApplySortersToGroups){m="Detected a multi-unit case, so sorting is only possible on leaves";if(s){m+="; "+s;}E.warning(m,this.sPath);}this.bApplySortersToGroups=false;};
K.prototype._isSkippingTotalForMeasure=function(m){var o=this.mAnalyticalInfoByProperty[m];return!!o&&o.total==false;};
K.Logger=E;return K;});
sap.ui.predefine('sap/ui/model/analytics/AnalyticalTreeBindingAdapter',["./AnalyticalBinding","sap/base/assert","sap/base/Log","sap/base/util/each","sap/ui/model/ChangeReason","sap/ui/model/TreeAutoExpandMode","sap/ui/model/TreeBinding","sap/ui/model/TreeBindingAdapter","sap/ui/model/odata/ODataTreeBindingAdapter"],function(A,a,L,e,C,T,b,c,O){"use strict";var d=function(){if(!(this instanceof b)||this._bIsAdapted){return;}O.apply(this);for(var f in d.prototype){if(d.prototype.hasOwnProperty(f)){this[f]=d.prototype[f];}}this.setAutoExpandMode(this.mParameters.autoExpandMode||T.Bundled);},s="sap.ui.model.analytics.AnalyticalTreeBindingAdapter";
d.prototype.getGrandTotalContext=function(){return this._oRootNode&&this._oRootNode.context;};
d.prototype.getGrandTotalNode=function(){return this._oRootNode;};
d.prototype.getGrandTotalContextInfo=function(){return this._oRootNode;};
d.prototype.getLength=function(){if(!this._oRootNode){return 0;}if(this._oRootNode&&this._oWatermark&&this._isRunningInAutoExpand(T.Bundled)){if(this._oWatermark.groupID===this._oRootNode.groupID){return this._oRootNode.magnitude+this._oRootNode.numberOfTotals;}return this._oWatermark.absoluteNodeIndex+this._oRootNode.numberOfTotals+1;}return this._oRootNode.magnitude+this._oRootNode.numberOfTotals;};
d.prototype.getContextByIndex=function(i){if(this._oRootNode&&i===(this.getLength()-1)&&this.providesGrandTotal()&&this.hasTotaledMeasures()){return this._oRootNode.context;}var n=this.findNode(i);if(!n||!n.context){n={context:this.getContexts(i,1,0)[0]};}return n?n.context:undefined;};
d.prototype.getNodeByIndex=function(i){if(i===(this.getLength()-1)&&this.providesGrandTotal()&&this.hasTotaledMeasures()){return this._oRootNode;}if(i>=this.getLength()){return undefined;}return this.findNode(i);};
d.prototype._isNodeSelectable=function(n){if(!n){return false;}return n.isLeaf&&!n.isArtificial;};
d.prototype._getContextsOrNodes=function(r,S,l,t){if(!this.isResolved()){return[];}if(!l){l=this.oModel.iSizeLimit;}if(!t){t=0;}this._iPageSize=l;this._iThreshold=Math.max(this._iThreshold,t);this._aRowIndexMap=[];this._buildTree(S,l);var n=[];if(this._oRootNode){n=this._retrieveNodeSection(this._oRootNode,S,l);}this._updateRowIndexMap(n,S);var f=[];var m;var N;for(var i=0;i<n.length;i++){N=n[i];if(this._isRunningInAutoExpand(T.Bundled)&&this._oWatermark){if(N.groupID===this._oWatermark.groupID||(this._oWatermark.groupID===this._oRootNode.groupID&&(S+i+1)==this.getLength()-1)){this._autoExpandPaging();}}if(!N.context){m=m||{};var p=N.parent;m[p.groupID]=p;this._updateNodeSections(p.groupID,{startIndex:N.positionInParent,length:1});}f.push(N.context);}if(m){var g=this;e(m,function(G,N){N.magnitude=0;N.numberOfTotals=0;g._loadChildContexts(N,{absoluteNodeIndex:N.absoluteNodeIndex});});f=[];for(var j=0;j<n.length;j++){N=n[j];f.push(N.context);}}if(r){return n;}else{return f;}};
d.prototype._autoExpandPaging=function(){a(this._oWatermark,"No watermark was set!");a(this._isRunningInAutoExpand(T.Bundled),"Optimised AutoExpand Paging can only be used with TreeAutoExpandMode.Bundled!");var f=this.getNodeContexts(this._oWatermark.context,{startIndex:this._oWatermark.startIndex,length:this._iPageSize,threshold:this._iThreshold,level:this._oWatermark.level,numberOfExpandedLevels:this._oWatermark.autoExpand});return f;};
d.prototype._afterMatchHook=function(n,r,m,M,p,P){if(n.sumNode&&n!==this._oRootNode){if(r.length===m){return true;}var N=M.call(this,n.sumNode,n.sumNode.positionInParent,P);if(N){r.push(n.sumNode);}}return undefined;};
d.prototype._afterMapHook=function(n,m){if(n.sumNode&&n!==this._oRootNode){m.call(this,n.sumNode);}};
d.prototype._createSumNode=function(n){var f;if(this.bProvideGrandTotals&&!this.mParameters.sumOnTop&&this.hasTotaledMeasures()&&n.children.length>1){f=this._createNode({parent:n.parent,positionInParent:n.children.length,context:n.context,level:n.level});f.nodeState=this._createNodeState({groupID:f.groupID,sum:true,expanded:false});}return f;};
d.prototype._buildTree=function(S,l){this._oRootNode=undefined;this._oWatermark=undefined;var n=this.mParameters&&this.getNumberOfExpandedLevels();var r=this.getRootContexts({startIndex:0,length:this._iPageSize,threshold:this._iThreshold,numberOfExpandedLevels:this._autoExpandMode===T.Bundled?n:undefined});var R;if(r==null){L.warning("AnalyticalTreeBindingAdapter: No Dimensions given. An artificial rootContext has be created. Please check your Table/Service definition for dimension columns!");}else{R=r[0];}if(!R){return;}var o=this._getNodeState("/");if(!o){o=this._updateTreeState({groupID:"/",expanded:true,sum:true});this._updateNodeSections("/",{startIndex:0,length:l});}this._oRootNode=this._createNode({context:R,parent:null,level:0,nodeState:o,isLeaf:false,autoExpand:n,absoluteNodeIndex:-1});this._oRootNode.isArtificial=true;this._loadChildContexts(this._oRootNode,{absoluteNodeIndex:-1});};
d.prototype._loadChildContexts=function(n,r){var N=n.nodeState;var m=this.getGroupSize(n.context,n.level);if(m>=0){if(!n.children[m-1]){n.children[m-1]=undefined;}if(n.level===this.aAggregationLevel.length){N.leafCount=m;}n.sumNode=this._createSumNode(n);}for(var i=0;i<N.sections.length;i++){var o=N.sections[i];if(o.startIndex>n.children.length){continue;}var R;if(m===-1){R=o.length;}else{R=Math.min(o.length,m-o.startIndex);}var S=false;if(n.autoExpand>=0&&this._isRunningInAutoExpand(T.Bundled)){S=true;R=Math.max(0,m);}var f=this.getNodeContexts(n.context,{startIndex:o.startIndex,length:R,threshold:S?0:this._iThreshold,level:n.level,supressRequest:S});for(var j=0;j<f.length;j++){var g=f[j];var h=j+o.startIndex;var k=n.children[h];var u={context:f[j],parent:n,level:n.level+1,positionInParent:h,autoExpand:Math.max(n.autoExpand-1,-1),absoluteNodeIndex:(++r.absoluteNodeIndex)};if(k){k.context=u.context;k.parent=u.parent;k.level=u.level;k.positionInParent=u.positionInParent;k.magnitude=0;k.numberOfTotals=0;k.totalNumberOfLeafs=0;k.autoExpand=u.autoExpand;k.absoluteNodeIndex=u.absoluteNodeIndex;var G;if(g){G=this._calculateGroupID(k);}k.groupID=G;}else{k=this._createNode(u);}k.nodeState=this._getNodeState(k.groupID);if(!k.nodeState){k.nodeState=this._createNodeState({groupID:k.groupID,expanded:false});}k.nodeState.parentGroupID=n.groupID;k.isLeaf=!this.nodeHasChildren(k);n.children[h]=k;if(k.isLeaf){n.numberOfLeafs+=1;}if(k.parent.nodeState.selectAllMode&&!this._mTreeState.deselected[k.groupID]&&k.isLeaf){this.setNodeSelection(k.nodeState,true);}if((k.autoExpand>=0||k.nodeState.expanded)&&this.isGrouped()){if(!this._mTreeState.collapsed[k.groupID]){if(k.autoExpand>=0&&k.parent.nodeState.selectAllMode&&!this._mTreeState.deselected[k.groupID]){if(k.nodeState.selectAllMode===undefined){k.nodeState.selectAllMode=true;}}this._updateTreeState({groupID:k.nodeState.groupID,fallbackNodeState:k.nodeState,expanded:true});this._loadChildContexts(k,r);}n.magnitude+=k.magnitude;n.numberOfTotals+=k.numberOfTotals;n.numberOfLeafs+=k.numberOfLeafs;}if(k&&k.isLeaf){n.totalNumberOfLeafs=m;}else{n.totalNumberOfLeafs+=k.totalNumberOfLeafs;}}}m=this._isRunningInAutoExpand(T.Bundled)?n.children.length:m;n.magnitude+=Math.max(m||0,0);if(!m&&!this._isRunningInAutoExpand(T.Bundled)){L.warning("AnalyticalTreeBindingAdapter: iMaxGroupSize("+m+") is undefined for node '"+n.groupID+"'!");}if(n.sumNode||(n===this._oRootNode&&this.providesGrandTotal()&&this.hasTotaledMeasures())){n.numberOfTotals+=1;}if(this._isRunningInAutoExpand(T.Bundled)&&n.autoExpand!=-1){if(!this._oWatermark&&!n.isLeaf&&!this.mFinalLength[n.groupID]){this._oWatermark={groupID:n.groupID,context:n.context,absoluteNodeIndex:n.absoluteNodeIndex,startIndex:n.children.length,level:n.level,autoExpand:n.autoExpand};}}};
d.prototype._calculateGroupID=function(n){var g;var m=this.aAggregationLevel.length;if(!this.isGrouped()&&n&&n.positionInParent){g="/"+n.positionInParent+"/";}else if(n.level>m){g=this._getGroupIdFromContext(n.context,m);a(n.positionInParent!=undefined,"If the node level is greater than the number of grouped columns, the position of the node to its parent must be defined!");g+=n.positionInParent+"/";}else{g=this._getGroupIdFromContext(n.context,n.level);}return g;};
d.prototype.collapse=function(p){var n,N;if(typeof p==="object"){n=p;}else if(typeof p==="number"){N=this.findNode(p);a(N&&N.nodeState,"AnalyticalTreeBindingAdapter.collapse("+p+"): No node found!");if(!N){return;}n=N.nodeState;}this._updateTreeState({groupID:n.groupID,expanded:false});n.selectAllMode=false;var f=false;if(this.bCollapseRecursive||this._isRunningInAutoExpand(T.Bundled)){var g=n.groupID;if(this._isRunningInAutoExpand(T.Bundled)&&this._oWatermark&&(typeof g=="string"&&g.length>0&&this._oWatermark.groupID.startsWith(g))){if(N&&N.parent){this._oWatermark={groupID:N.parent.groupID,context:N.parent.context,absoluteNodeIndex:N.parent.absoluteNodeIndex,startIndex:N.positionInParent+1,level:N.parent.level,autoExpand:N.parent.autoExpand};}this._autoExpandPaging();f=true;}var t=this;e(this._mTreeState.expanded,function(G,o){if(typeof g=="string"&&g.length>0&&G.startsWith(g)){t._updateTreeState({groupID:G,expanded:false});}});var D=[];e(this._mTreeState.selected,function(G,o){if(typeof g=="string"&&g.length>0&&G.startsWith(g)){o.selectAllMode=false;t.setNodeSelection(o,false);D.push(G);}});if(D.length){var h={rowIndices:[]};var i=0;this._map(this._oRootNode,function(N){if(!N||!N.isArtificial){i++;}if(N&&D.indexOf(N.groupID)!==-1){if(N.groupID===this._sLeadSelectionGroupID){h.oldIndex=i;h.leadIndex=-1;}h.rowIndices.push(i);}});this._publishSelectionChanges(h);}}if(!f){this._fireChange({reason:C.Collapse});}};
d.prototype.collapseToLevel=function(l){this.setNumberOfExpandedLevels(l,true);c.prototype.collapseToLevel.call(this,l);};
d.prototype.nodeHasChildren=function(n){a(n,"AnalyticalTreeBindingAdapter.nodeHasChildren: No node given!");if(!n||!n.parent||n.nodeState.sum){return false;}else if(n.isArtificial){return true;}else{return A.prototype.hasChildren.call(this,n.context,{level:n.level});}};
d.prototype.resetData=function(o,p){var r=A.prototype.resetData.call(this,o,p);this._aRowIndexMap=[];this._oRootNode=undefined;this._oWatermark=undefined;this._iPageSize=0;this._iThreshold=0;if(!p||p.reason!==C.Sort){this.clearSelection();this._createTreeState(true);}return r;};
d.prototype.hasTotaledMeasures=function(){var h=false;e(this.getMeasureDetails()||[],function(i,m){if(m.analyticalInfo.total){h=true;return false;}return true;});return h;};
d.prototype.isGrouped=function(){return(this.aAggregationLevel.length>0);};
d.prototype._isRunningInAutoExpand=function(f){if(this.getNumberOfExpandedLevels()>0&&this._autoExpandMode===f){return true;}else{return false;}};
d.prototype.setNumberOfExpandedLevels=function(l,S){var n;l=l||0;if(l<0){L.warning("Number of expanded levels was set to 0. Negative values are prohibited",this,s);l=0;}n=this.aAggregationLevel.length;if(l>n){L.warning("Number of expanded levels was reduced from "+l+" to "+n+" which is the number of grouped dimensions",this,s);l=n;}if(!S){this.resetData();}this.mParameters.numberOfExpandedLevels=l;};
d.prototype.getNumberOfExpandedLevels=function(){return this.mParameters.numberOfExpandedLevels;};
d.prototype._getSelectableNodesCount=function(n){if(n){return n.totalNumberOfLeafs;}else{return 0;}};
return d;},true);
sap.ui.predefine('sap/ui/model/analytics/AnalyticalVersionInfo',["sap/base/Log"],function(L){"use strict";var A={NONE:null,V1:1,V2:2,getVersion:function(o){var v;var O;if(o&&o.getMetadata){O=o.getMetadata().getName();}switch(O){case"sap.ui.model.odata.ODataModel":v=this.V1;break;case"sap.ui.model.odata.v2.ODataModel":v=this.V2;break;default:v=this.NONE;L.info("AnalyticalVersionInfo.getVersion(...) - The given object is no instance of ODataModel V1 or V2!");break;}return v;}};return A;},true);
sap.ui.predefine('sap/ui/model/analytics/BatchResponseCollector',function(){"use strict";
function B(p){if(p){this.setup(p);}}
B.TYPE_SUCCESS="success";B.TYPE_ERROR="error";
B.prototype.setup=function(p){this.iRequestCollectionCount=0;this.aCollectedSuccesses=[];this.aCollectedErrors=[];this.aExecutedRequestDetails=p.executedRequests;this.oAnalyticalBinding=p.binding;this.fnSuccessHandler=p.success;this.fnErrorHandler=p.error;};
B.prototype.success=function(r){this.collect(r,B.TYPE_SUCCESS);};
B.prototype.error=function(r){this.collect(r,B.TYPE_ERROR);};
B.prototype.collect=function(r,R){this.iRequestCollectionCount++;if(R===B.TYPE_SUCCESS){this.aCollectedSuccesses.push(r);}else{this.aCollectedErrors.push(r);}var o=(this.aCollectedSuccesses.length+this.aCollectedErrors.length);if(o===this.aExecutedRequestDetails.length){if((this.aCollectedSuccesses.length===o)&&this.aCollectedErrors.length===0){this.fnSuccessHandler.call(window,{__batchResponses:this.aCollectedSuccesses},{requestUri:this.oAnalyticalBinding.oModel.sServiceUrl+"/$batch"});}else{this.fnErrorHandler.call(window,this.aCollectedErrors[0]||{});}}};
return B;},true);
sap.ui.predefine('sap/ui/model/analytics/ODataModelAdapter',['./AnalyticalBinding',"./AnalyticalTreeBindingAdapter",'./odata4analytics','./AnalyticalVersionInfo',"sap/base/Log"],function(A,a,o,b,L){"use strict";var O=function(){var m=b.getVersion(this);if(m===b.NONE||this.getAnalyticalExtensions){return;}this._mPreadapterFunctions={bindList:this.bindList,bindTree:this.bindTree};for(var f in O.prototype){if(O.prototype.hasOwnProperty(f)){this[f]=O.prototype[f];}}if(m===b.V1&&this.isCountSupported()){L.info("ODataModelAdapter: switched ODataModel to use inlinecount (mandatory for the AnalyticalBinding)");this.setCountSupported(false);}};
O.prototype.bindList=function(p,c,s,f,P){if(P&&P.analyticalInfo){var B=new A(this,p,c,s,f,P);a.apply(B);return B;}else{return this._mPreadapterFunctions.bindList.apply(this,arguments);}};
O.prototype.bindTree=function(p,c,f,P){if(P&&P.analyticalInfo){var B=new A(this,p,c,[],f,P);return B;}else{return this._mPreadapterFunctions.bindTree.apply(this,arguments);}};
O.prototype.getAnalyticalExtensions=function(){if(this.oOData4SAPAnalyticsModel!=undefined&&this.oOData4SAPAnalyticsModel!=null){return this.oOData4SAPAnalyticsModel;}var m=b.getVersion(this);if(m===b.V2&&!(this.oMetadata&&this.oMetadata.isLoaded())){throw"Failed to get the analytical extensions. The metadata have not been loaded by the model yet."+"Register for the 'metadataLoaded' event of the ODataModel(v2) to know when the analytical extensions can be retrieved.";}try{this.oOData4SAPAnalyticsModel=new o.Model(new o.Model.ReferenceByModel(this));}catch(e){throw"Failed to instantiate analytical extensions for given OData model: "+e.message;}return this.oOData4SAPAnalyticsModel;};
O.prototype.setAnalyticalExtensions=function(c){this.oOData4SAPAnalyticsModel=c;};
return O;},true);
sap.ui.predefine('sap/ui/model/analytics/odata4analytics',['sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/model/Sorter','./AnalyticalVersionInfo',"sap/base/security/encodeURL"],function(F,c,S,A,e){"use strict";var o=o||{},d=/^\d+$/;o.constants={};o.constants["SAP_NAMESPACE"]="http://www.sap.com/Protocols/SAPData";o.constants["VERSION"]="0.7";o.helper={deepEqual:function(O,N,f){var a,b,r=0,i,n;if(!O||O.length!==N.length){return 2;}if(O!==N){for(i=0,n=O.length;i<n;i+=1){b=O[i];a=N[i];if(b.grouped!==a.grouped||b.inResult!==a.inResult||b.level!==a.level||b.name!==a.name||b.total!==a.total||b.visible!==a.visible){return 2;}if(b.formatter!==a.formatter){r=1;if(f){f(a);}}}}return r;},tokenizeNametoLabelText:function(n){var l="";l=n.replace(/^P_(.*)/,"$1");l=l.replace(/([^A-Z0-9_]+)([A-Z0-9_])/g,"$1 $2");l=l.replace(/([A-Z0-9_]{2,})([A-Z0-9_])([^A-Z0-9_]+)/g,"$1 $2$3");l=l.replace(/(.*) _E$/,"$1");l=l.replace(/(.*) _(.*)/g,"$1 $2");return l;}};
o.Model=function(m,p){this._init(m,p);};
o.Model.ReferenceByURI=function(u){return{sServiceURI:u};};
o.Model.ReferenceByModel=function(m){return{oModel:m};};
o.Model.ReferenceWithWorkaround=function(m,w){return{oModelReference:m,aWorkaroundID:w};};
o.Model.prototype={_init:function(m,p){var O,t=this;if(typeof p=="string"){throw"Deprecated second argument: Adjust your invocation by passing an object with a property sAnnotationJSONDoc as a second argument instead";}this._mParameter=p;this._oActivatedWorkarounds={};if(m&&m.aWorkaroundID){for(var i=-1,I;(I=m.aWorkaroundID[++i])!==undefined;){this._oActivatedWorkarounds[I]=true;}m=m.oModelReference;}if(!m||(!m.sServiceURI&&!m.oModel)){throw"Usage with oModelReference being an instance of Model.ReferenceByURI or Model.ReferenceByModel";}if(m.oModel){this._oModel=m.oModel;this._iVersion=A.getVersion(this._oModel);a();}else if(p&&p.modelVersion===A.V2){O=sap.ui.require("sap/ui/model/odata/v2/ODataModel")||sap.ui.requireSync("sap/ui/model/odata/v2/ODataModel");this._oModel=new O(m.sServiceURI);this._iVersion=A.V2;a();}else{O=sap.ui.require("sap/ui/model/odata/ODataModel")||sap.ui.requireSync("sap/ui/model/odata/ODataModel");this._oModel=new O(m.sServiceURI);this._iVersion=A.V1;a();}if(this._oModel.getServiceMetadata()&&this._oModel.getServiceMetadata().dataServices==undefined){throw"Model could not be loaded";}function a(){if(!t._oModel.getServiceMetadata()){t._oModel.attachMetadataLoaded(b);}else{b();}}function b(){if(t.bIsInitialized){return;}t.bIsInitialized=true;if(p&&p.sAnnotationJSONDoc){t.mergeV2Annotations(p.sAnnotationJSONDoc);}t._interpreteMetadata(t._oModel.getServiceMetadata().dataServices);}},_interpreteMetadata:function(M){this._oQueryResultSet={};this._oParameterizationSet={};this._oEntityTypeSet={};this._oEntitySetSet={};this._oEntityTypeNameToEntitySetMap={};var a=this._oModel.getServiceMetadata().dataServices.schema[0];for(var j=-1,C;(C=a.entityContainer[++j])!==undefined;){if(C.isDefaultEntityContainer=="true"){this._oDefaultEntityContainer=C;break;}}var E=a.entityType;var q=[],P=[],u=[];for(var k=-1,T;(T=E[++k])!==undefined;){var b=false;if(T.extensions!=undefined){for(var l=-1,f;(f=T.extensions[++l])!==undefined;){if(f.namespace==o.constants.SAP_NAMESPACE&&f.name=="semantics"){b=true;switch(f.value){case"aggregate":q.push(T);break;case"parameters":P.push(T);break;default:u.push(T);}}if(b){continue;}}if(!b){u.push(T);}}else{u.push(T);}}for(var m=-1,g;(g=u[++m])!==undefined;){var h=new o.EntityType(this._oModel.getServiceMetadata(),a,g);this._oEntityTypeSet[h.getQName()]=h;var i=this._getEntitySetsOfType(a,h.getQName());if(i.length==0){throw"Invalid consumption model: No entity set for entity type "+h.getQName()+" found";}if(i.length>1){throw"Unsupported consumption model: More than one entity set for entity type "+h.getQName()+" found";}var v=new o.EntitySet(this._oModel.getServiceMetadata(),a,i[0][0],i[0][1],h);this._oEntitySetSet[v.getQName()]=v;this._oEntityTypeNameToEntitySetMap[h.getQName()]=v;}var w={};for(var n=-1,x;(x=P[++n])!==undefined;){var y=new o.EntityType(this._oModel.getServiceMetadata(),a,x);this._oEntityTypeSet[y.getQName()]=y;var z=this._getEntitySetsOfType(a,y.getQName());if(z.length==0){throw"Invalid consumption model: No entity set for parameter entity type "+y.getQName()+" found";}if(z.length>1){throw"Unsupported consumption model: More than one entity set for parameter entity type "+y.getQName()+" found";}var B=new o.EntitySet(this._oModel.getServiceMetadata(),a,z[0][0],z[0][1],y);this._oEntitySetSet[B.getQName()]=B;this._oEntityTypeNameToEntitySetMap[y.getQName()]=B;var D=new o.Parameterization(y,B);this._oParameterizationSet[D.getName()]=D;w[y.getQName()]=D;var G=y.getQName();if(a.association!=undefined){for(var p=-1,H;(H=a.association[++p])!==undefined;){if(H.referentialConstraint==undefined){continue;}var I=null;if(H.end[0].type==G&&H.end[0].multiplicity=="*"&&H.end[1].multiplicity=="1"){I=H.end[1].type;}else if(H.end[1].type==G&&H.end[1].multiplicity=="*"&&H.end[0].multiplicity=="1"){I=H.end[0].type;}if(!I){continue;}if(H.referentialConstraint.dependent.propertyRef.length!=1){continue;}var J=D.findParameterByName(H.referentialConstraint.dependent.propertyRef[0].name);if(J==null){continue;}var V=this._oEntityTypeSet[I];var K=this._oEntityTypeNameToEntitySetMap[I];J.setValueSetEntity(V,K);}}}for(var r=-1,L;(L=q[++r])!==undefined;){var N=new o.EntityType(this._oModel.getServiceMetadata(),a,L);this._oEntityTypeSet[N.getQName()]=N;var Q=N.getQName();var O=null;var R=null;if(a.association!=undefined){for(var s=-1,U;(U=a.association[++s])!==undefined;){var W=null;if(U.end[0].type==Q){W=U.end[1].type;}else if(U.end[1].type==Q){W=U.end[0].type;}else{continue;}var X=null;X=w[W];if(X!=null){if(O!=null){throw"Unable to handle multiple parameter entity types of query entity "+N.name;}else{O=X;R=U;}}}}var Y=this._getEntitySetsOfType(a,N.getQName());if(Y.length!=1){throw"Invalid consumption model: There must be exactly one entity set for an entity type annotated with aggregating semantics";}var Z=new o.EntitySet(this._oModel.getServiceMetadata(),a,Y[0][0],Y[0][1],N);this._oEntitySetSet[Z.getQName()]=Z;this._oEntityTypeNameToEntitySetMap[N.getQName()]=Z;var $=new o.QueryResult(this,N,Z,O);this._oQueryResultSet[$.getName()]=$;if(O){O.setTargetQueryResult($,R);}if(a.association!=undefined){for(var t=-1,_;(_=a.association[++t])!==undefined;){if(_.referentialConstraint==undefined){continue;}var a1=null;if(_.end[0].type==Q&&_.end[0].multiplicity=="*"&&_.end[1].multiplicity=="1"){a1=_.end[1].type;}else if(_.end[1].type==Q&&_.end[1].multiplicity=="*"&&_.end[0].multiplicity=="1"){a1=_.end[0].type;}if(!a1){continue;}if(_.referentialConstraint.dependent.propertyRef.length!=1){continue;}var b1=$.findDimensionByName(_.referentialConstraint.dependent.propertyRef[0].name);if(b1==null){continue;}var c1=this._oEntityTypeNameToEntitySetMap[a1];b1.setMembersEntitySet(c1);}}}},oUI5ODataModelAnnotatableObject:{objectName:"schema",keyPropName:"namespace",extensions:true,aSubObject:[{objectName:"entityType",keyPropName:"name",extensions:true,aSubObject:[{objectName:"property",keyPropName:"name",aSubObject:[],extensions:true}]},{objectName:"entityContainer",keyPropName:"name",extensions:false,aSubObject:[{objectName:"entitySet",keyPropName:"name",extensions:true,aSubObject:[]}]}]},mergeV2Annotations:function(a){var b=null;try{b=JSON.parse(a);}catch(f){return;}var m;try{m=this._oModel.getServiceMetadata().dataServices;}catch(f){return;}for(var p in b){if(!(this.oUI5ODataModelAnnotatableObject.objectName==p)){continue;}if(!(b[p]instanceof Array)){continue;}this.mergeV2AnnotationLevel(m[this.oUI5ODataModelAnnotatableObject.objectName],b[this.oUI5ODataModelAnnotatableObject.objectName],this.oUI5ODataModelAnnotatableObject);break;}return;},mergeV2AnnotationLevel:function(M,a,u){for(var i=-1,b;(b=a[++i])!==undefined;){for(var j=-1,f;(f=M[++j])!==undefined;){if(!(b[u.keyPropName]==f[u.keyPropName])){continue;}if(b["extensions"]!=undefined){if(f["extensions"]==undefined){f["extensions"]=[];}for(var l=-1,g;(g=b["extensions"][++l])!==undefined;){var h=false;for(var m=-1,n;(n=f["extensions"][++m])!==undefined;){if(g.name==n.name&&g.namespace==n.namespace){n.value=g.value;h=true;break;}}if(!h){f["extensions"].push(g);}}}for(var k=-1,U;(U=u.aSubObject[++k])!==undefined;){for(var p in b){if(!(U.objectName==p)){continue;}if(!(b[U.objectName]instanceof Array)){continue;}if((f[U.objectName]==undefined)||(!(f[U.objectName]instanceof Array))){continue;}this.mergeV2AnnotationLevel(f[U.objectName],b[U.objectName],U);break;}}}}return;},findQueryResultByName:function(n){var q=this._oQueryResultSet[n];if(!q&&this._oDefaultEntityContainer){var Q=this._oDefaultEntityContainer.name+"."+n;q=this._oQueryResultSet[Q];}return q;},getAllQueryResultNames:function(){if(this._aQueryResultNames){return this._aQueryResultNames;}this._aQueryResultNames=new Array(0);for(var n in this._oQueryResultSet){this._aQueryResultNames.push(this._oQueryResultSet[n].getName());}return this._aQueryResultNames;},getAllQueryResults:function(){return this._oQueryResultSet;},getODataModel:function(){return this._oModel;},_getEntitySetsOfType:function(s,q){var E=[];for(var i=-1,a;(a=s.entityContainer[++i])!==undefined;){for(var j=-1,b;(b=a.entitySet[++j])!==undefined;){if(b.entityType==q){E.push([a,b]);}}}return E;},_mParameter:null,_oModel:null,_oDefaultEntityContainer:null,_aQueryResultNames:null,_oQueryResultSet:null,_oParameterizationSet:null,_oEntityTypeSet:null,_oEntitySetSet:null,_oEntityTypeNameToEntitySetMap:null,_oActivatedWorkarounds:null};
o.QueryResult=function(m,E,a,p){this._init(m,E,a,p);};
o.QueryResult.prototype={_init:function(m,E,a,p,b){this._oModel=m;this._oEntityType=E;this._oEntitySet=a;this._oParameterization=p;this._oDimensionSet={};this._oMeasureSet={};var P=E.getTypeDescription().property;var f={};for(var i=-1,g;(g=P[++i])!==undefined;){if(g.extensions==undefined){continue;}for(var j=-1,h;(h=g.extensions[++j])!==undefined;){if(!h.namespace==o.constants.SAP_NAMESPACE){continue;}switch(h.name){case"aggregation-role":switch(h.value){case"dimension":{var D=new o.Dimension(this,g);this._oDimensionSet[D.getName()]=D;break;}case"measure":{var M=new o.Measure(this,g);this._oMeasureSet[M.getName()]=M;break;}case"totaled-properties-list":this._oTotaledPropertyListProperty=g;break;default:}break;case"attribute-for":{var k=new o.DimensionAttribute(this,g);var K=k.getKeyProperty();f[K.name]=k;break;}default:}}}for(var s in f){var l=f[s];l.getDimension().addAttribute(l);}if(m._oActivatedWorkarounds.IdentifyTextPropertiesByName){var n=[];for(var q in this._oDimensionSet){var r=this._oDimensionSet[q];if(!r.getTextProperty()){var T=null;T=E.findPropertyByName(q+"Name");if(!T){T=E.findPropertyByName(q+"Text");}if(!T){T=E.findPropertyByName(q+"Desc");}if(!T){T=E.findPropertyByName(q+"Description");}if(T){r.setTextProperty(T);n.push(T.name);}}}for(var t=-1,u;(u=n[++t])!==undefined;){delete this._oDimensionSet[u];}}},getName:function(){return this.getEntitySet().getQName();},getParameterization:function(){return this._oParameterization;},getAllDimensionNames:function(){if(this._aDimensionNames){return this._aDimensionNames;}this._aDimensionNames=[];for(var n in this._oDimensionSet){this._aDimensionNames.push(this._oDimensionSet[n].getName());}return this._aDimensionNames;},getAllDimensions:function(){return this._oDimensionSet;},getAllMeasureNames:function(){if(this._aMeasureNames){return this._aMeasureNames;}this._aMeasureNames=[];for(var n in this._oMeasureSet){this._aMeasureNames.push(this._oMeasureSet[n].getName());}return this._aMeasureNames;},getAllMeasures:function(){return this._oMeasureSet;},findDimensionByName:function(n){return this._oDimensionSet[n];},findDimensionByPropertyName:function(n){if(this._oDimensionSet[n]){return this._oDimensionSet[n];}for(var D in this._oDimensionSet){var a=this._oDimensionSet[D];var t=a.getTextProperty();if(t&&t.name==n){return a;}if(a.findAttributeByName(n)){return a;}}return null;},getTotaledPropertiesListProperty:function(){return this._oTotaledPropertyListProperty;},findMeasureByName:function(n){return this._oMeasureSet[n];},findMeasureByPropertyName:function(n){if(this._oMeasureSet[n]){return this._oMeasureSet[n];}for(var m in this._oMeasureSet){var M=this._oMeasureSet[m];var f=M.getFormattedValueProperty();if(f&&f.name==n){return M;}}return null;},getModel:function(){return this._oModel;},getEntityType:function(){return this._oEntityType;},getEntitySet:function(){return this._oEntitySet;},_oModel:null,_oEntityType:null,_oEntitySet:null,_oParameterization:null,_aDimensionNames:null,_oDimensionSet:null,_aMeasureNames:null,_oMeasureSet:null,_oTotaledPropertyListProperty:null};
o.Parameterization=function(E,a){this._init(E,a);};
o.Parameterization.prototype={_init:function(E,a){this._oEntityType=E;this._oEntitySet=a;this._oParameterSet={};var p=E.getTypeDescription().property;for(var i=-1,P;(P=p[++i])!==undefined;){if(P.extensions==undefined){continue;}for(var j=-1,b;(b=P.extensions[++j])!==undefined;){if(!b.namespace==o.constants.SAP_NAMESPACE){continue;}switch(b.name){case"parameter":{var f=new o.Parameter(this,P);this._oParameterSet[f.getName()]=f;break;}default:}}}},setTargetQueryResult:function(q,a){this._oQueryResult=q;var Q=this._oEntityType.getSchema().namespace+"."+a.name;var n=this._oEntityType.getTypeDescription().navigationProperty;if(!n){throw"Invalid consumption model: Parameters entity type lacks navigation property for association to query result entity type";}for(var i=-1,N;(N=n[++i])!==undefined;){if(N.relationship==Q){this._oNavPropToQueryResult=N.name;}}if(!this._oNavPropToQueryResult){throw"Invalid consumption model: Parameters entity type lacks navigation property for association to query result entity type";}},getTargetQueryResult:function(){if(!this._oQueryResult){throw"No target query result set";}return this._oQueryResult;},getName:function(){return this.getEntitySet().getQName();},getAllParameterNames:function(){if(this._aParameterNames){return this._aParameterNames;}this._aParameterNames=[];for(var n in this._oParameterSet){this._aParameterNames.push(this._oParameterSet[n].getName());}return this._aParameterNames;},getAllParameters:function(){return this._oParameterSet;},findParameterByName:function(n){return this._oParameterSet[n];},getNavigationPropertyToQueryResult:function(){return this._oNavPropToQueryResult;},getEntityType:function(){return this._oEntityType;},getEntitySet:function(){return this._oEntitySet;},_oEntityType:null,_oEntitySet:null,_oQueryResult:null,_oNavPropToQueryResult:null,_aParameterNames:null,_oParameterSet:null};
o.Parameter=function(p,P){this._init(p,P);};
o.Parameter.prototype={_init:function(p,P){this._oParameterization=p;this._oProperty=P;var E=p.getEntityType();if(P.extensions!=undefined){for(var i=-1,a;(a=P.extensions[++i])!==undefined;){if(!a.namespace==o.constants.SAP_NAMESPACE){continue;}switch(a.name){case"parameter":switch(a.value){case"mandatory":this._bRequired=true;break;case"optional":this._bRequired=false;break;default:throw"Invalid annotation value for parameter property";}break;case"label":this._sLabelText=a.value;break;case"text":this._oTextProperty=E.findPropertyByName(a.value);break;case"upper-boundary":this._bIntervalBoundaryParameter=true;this._oUpperIntervalBoundaryParameterProperty=E.findPropertyByName(a.value);break;case"lower-boundary":this._bIntervalBoundaryParameter=true;this._oLowerIntervalBoundaryParameterProperty=E.findPropertyByName(a.value);break;default:}}}if(!this._sLabelText){this._sLabelText="";}},setValueSetEntity:function(E,a){this._oValueSetEntityType=E;this._oValueSetEntitySet=a;},getTextProperty:function(){return this._oTextProperty;},getLabelText:function(){if(!this._sLabelText&&this._oParameterization._oQueryResult._oModel._oActivatedWorkarounds.CreateLabelsFromTechnicalNames){this._sLabelText=o.helper.tokenizeNametoLabelText(this.getName());}return this._sLabelText;},isOptional:function(){return(!this._bRequired);},isIntervalBoundary:function(){return this._bIntervalBoundaryParameter;},isLowerIntervalBoundary:function(){return(this._oUpperIntervalBoundaryParameterProperty?true:false);},getPeerIntervalBoundaryParameter:function(){var p=null;if(this._oLowerIntervalBoundaryParameterProperty){p=this._oLowerIntervalBoundaryParameterProperty.name;}else{p=this._oUpperIntervalBoundaryParameterProperty.name;}if(!p){throw"Parameter is not an interval boundary";}return this._oParameterization.findParameterByName(p);},isValueSetAvailable:function(){return(this._oValueSetEntityType?true:false);},getName:function(){return this._oProperty.name;},getProperty:function(){return this._oProperty;},getContainingParameterization:function(){return this._oParameterization;},getURIToValueEntitySet:function(s){var u=null;u=(s?s:"")+"/"+this._oValueSetEntitySet.getQName();return u;},_oParameterization:null,_oProperty:null,_sLabelText:null,_oTextProperty:null,_bRequired:false,_bIntervalBoundaryParameter:false,_oLowerIntervalBoundaryParameterProperty:null,_oUpperIntervalBoundaryParameterProperty:null,_oValueSetEntityType:null,_oValueSetEntitySet:null};
o.Dimension=function(q,p){this._init(q,p);};
o.Dimension.prototype={_init:function(q,p){this._oQueryResult=q;this._oProperty=p;this._oAttributeSet={};},setMembersEntitySet:function(E){this._oMembersEntitySet=E;},getName:function(){return this._oProperty.name;},getKeyProperty:function(){return this._oProperty;},getTextProperty:function(){if(!this._oTextProperty){this._oTextProperty=this._oQueryResult.getEntityType().getTextPropertyOfProperty(this.getName());}return this._oTextProperty;},setTextProperty:function(t){this._oTextProperty=t;},getLabelText:function(){if(!this._sLabelText){this._sLabelText=this._oQueryResult.getEntityType().getLabelOfProperty(this.getName());}if(!this._sLabelText&&this._oQueryResult._oModel._oActivatedWorkarounds.CreateLabelsFromTechnicalNames){this._sLabelText=o.helper.tokenizeNametoLabelText(this.getName());}return(this._sLabelText==null?"":this._sLabelText);},getSuperOrdinateDimension:function(){if(!this._sSuperOrdinateDimension){var s=this._oQueryResult.getEntityType().getSuperOrdinatePropertyOfProperty(this.getName());if(s){this._sSuperOrdinateDimension=this._oQueryResult.findDimensionByName(s.name);}}return this._sSuperOrdinateDimension;},getHierarchy:function(){if(!this._oHierarchy){this._oHierarchy=this._oQueryResult.getEntityType().getHierarchy(this._oProperty.name);}return this._oHierarchy;},getAllAttributeNames:function(){if(this._aAttributeNames){return this._aAttributeNames;}this._aAttributeNames=[];for(var n in this._oAttributeSet){this._aAttributeNames.push(this._oAttributeSet[n].getName());}return this._aAttributeNames;},getAllAttributes:function(){return this._oAttributeSet;},findAttributeByName:function(n){return this._oAttributeSet[n];},addAttribute:function(D){this._oAttributeSet[D.getName()]=D;},getContainingQueryResult:function(){return this._oQueryResult;},hasMasterData:function(){return this._oMembersEntitySet!=null?true:false;},getMasterDataEntitySet:function(){return this._oMembersEntitySet;},_oQueryResult:null,_oProperty:null,_oTextProperty:null,_sLabelText:null,_sSuperOrdinateDimension:null,_aAttributeNames:null,_oAttributeSet:null,_oMembersEntitySet:null,_oHierarchy:null};
o.DimensionAttribute=function(q,p){this._init(q,p);};
o.DimensionAttribute.prototype={_init:function(q,p){this._oQueryResult=q;this._oProperty=p;if(p.extensions!=undefined){for(var i=-1,E;(E=p.extensions[++i])!==undefined;){if(!E.namespace==o.constants.SAP_NAMESPACE){continue;}switch(E.name){case"attribute-for":this._sDimensionName=E.value;break;case"label":this._sLabelText=E.value;break;case"text":this._oTextProperty=q.getEntityType().findPropertyByName(E.value);break;default:}}}},getName:function(){return this._oProperty.name;},getKeyProperty:function(){return this._oProperty;},getTextProperty:function(){return this._oTextProperty;},getLabelText:function(){if(!this._sLabelText&&this._oQueryResult._oModel._oActivatedWorkarounds.CreateLabelsFromTechnicalNames){this._sLabelText=o.helper.tokenizeNametoLabelText(this.getName());}return this._sLabelText;},getDimension:function(){return this._oQueryResult.findDimensionByName(this._sDimensionName);},_oQueryResult:null,_oProperty:null,_oTextProperty:null,_sLabelText:null,_sDimensionName:null};
o.Measure=function(q,p){this._init(q,p);};
o.Measure.prototype={_init:function(q,p){this._oQueryResult=q;this._oProperty=p;if(p.extensions!=undefined){for(var i=-1,E;(E=p.extensions[++i])!==undefined;){if(!E.namespace==o.constants.SAP_NAMESPACE){continue;}switch(E.name){case"label":this._sLabelText=E.value;break;case"text":this._oTextProperty=q.getEntityType().findPropertyByName(E.value);break;case"unit":this._oUnitProperty=q.getEntityType().findPropertyByName(E.value);break;default:}}}if(!this._sLabelText){this._sLabelText="";}},getName:function(){return this._oProperty.name;},getRawValueProperty:function(){return this._oProperty;},getFormattedValueProperty:function(){return this._oTextProperty;},getUnitProperty:function(){return this._oUnitProperty;},getLabelText:function(){if(!this._sLabelText&&this._oQueryResult._oModel._oActivatedWorkarounds.CreateLabelsFromTechnicalNames){this._sLabelText=o.helper.tokenizeNametoLabelText(this.getName());}return this._sLabelText;},isUpdatable:function(){if(this._bIsUpdatable!=null){return this._bIsUpdatable;}var u=this._oQueryResult.getEntitySet().getUpdatablePropertyNameSet();return(u[this.getName()]!=undefined);},_oQueryResult:null,_oProperty:null,_oTextProperty:null,_sLabelText:null,_oUnitProperty:null,_bIsUpdatable:null};
o.EntitySet=function(m,s,C,E,a){this._init(m,s,C,E,a);};
o.EntitySet.prototype={_init:function(m,s,C,E,a){this._oEntityType=a;this._oEntitySet=E;this._oContainer=C;this._oSchema=s;this._oModel=m;if(s.entityContainer.length>1){this._sQName=C.name+"."+E.name;}else{this._sQName=E.name;}},getQName:function(){return this._sQName;},getSetDescription:function(){return this._oEntitySet;},getEntityType:function(){return this._oEntityType;},getSchema:function(){return this._oSchema;},getModel:function(){return this._oModel;},getUpdatablePropertyNameSet:function(){if(this._oUpdatablePropertyNames){return this._oUpdatablePropertyNames;}this._oUpdatablePropertyNames={};var s=true;if(this._oEntitySet.extensions!=undefined){for(var j=-1,E;(E=this._oEntitySet.extensions[++j])!==undefined;){if(E.namespace==o.constants.SAP_NAMESPACE&&E.name=="updatable"){if(E.value=="false"){s=false;break;}}}}if(!s){return this._oUpdatablePropertyNames;}var p=this._oEntityType.getTypeDescription().property;for(var i=-1,P;(P=p[++i])!==undefined;){var b=true;if(P.extensions==undefined){continue;}for(var k=-1,a;(a=P.extensions[++k])!==undefined;){if(a.namespace!=o.constants.SAP_NAMESPACE){continue;}if(a.name=="updatable"){if(a.value=="false"){b=false;break;}}}if(b){this._oUpdatablePropertyNames[P.name]=true;}}return this._oUpdatablePropertyNames;},_oEntityType:null,_oEntitySet:null,_oContainer:null,_oSchema:null,_oModel:null,_sQName:null,_oUpdatablePropertyNames:null};
o.EntityType=function(m,s,E){this._init(m,s,E);};
o.EntityType.propertyFilterRestriction={SINGLE_VALUE:"single-value",MULTI_VALUE:"multi-value",INTERVAL:"interval"};o.EntityType.prototype={_init:function(m,s,E){this._oEntityType=E;this._oSchema=s;this._oModel=m;this._aKeyProperties=[];this._oPropertySet={};this._aFilterablePropertyNames=[];this._aSortablePropertyNames=[];this._aRequiredFilterPropertyNames=[];this._oPropertyFilterRestrictionSet={};this._oPropertyHeadingsSet={};this._oPropertyQuickInfosSet={};this._sQName=s.namespace+"."+E.name;var r={};function g(K){var R=r[K];if(!R){R=r[K]={};}return R;}for(var i=-1,p;(p=E.key.propertyRef[++i])!==undefined;){this._aKeyProperties.push(p.name);}for(var k=-1,P;(P=E.property[++k])!==undefined;){this._oPropertySet[P.name]=P;this._aFilterablePropertyNames.push(P.name);this._aSortablePropertyNames.push(P.name);if(P.extensions==undefined){continue;}for(var j=-1,a;(a=P.extensions[++j])!==undefined;){if(a.namespace!==o.constants.SAP_NAMESPACE){continue;}switch(a.name){case"filterable":if(a.value=="false"){this._aFilterablePropertyNames.pop(P.name);}break;case"sortable":if(a.value=="false"){this._aSortablePropertyNames.pop(P.name);}break;case"required-in-filter":if(a.value=="true"){this._aRequiredFilterPropertyNames.push(P.name);}break;case"filter-restriction":if(a.value==o.EntityType.propertyFilterRestriction.SINGLE_VALUE||a.value==o.EntityType.propertyFilterRestriction.MULTI_VALUE||a.value==o.EntityType.propertyFilterRestriction.INTERVAL){this._oPropertyFilterRestrictionSet[P.name]=a.value;}break;case"hierarchy-node-external-key-for":g(a.value).externalKeyProperty=P;break;case"hierarchy-node-for":g(P.name).dimensionName=a.value;break;case"hierarchy-parent-node-for":case"hierarchy-parent-nod":g(a.value).parentNodeIDProperty=P;break;case"hierarchy-level-for":g(a.value).levelProperty=P;break;case"hierarchy-drill-state-for":case"hierarchy-drill-stat":g(a.value).drillStateProperty=P;break;default:}}}this._oRecursiveHierarchySet={};for(var h in r){var H=r[h];var b=this._oPropertySet[h];var D=this._oPropertySet[H.dimensionName];if(D==null){D=b;}this._oRecursiveHierarchySet[D.name]=new o.RecursiveHierarchy(E,b,H.parentNodeIDProperty,H.levelProperty,D,H.externalKeyProperty);}},getProperties:function(){return this._oPropertySet;},findPropertyByName:function(p){return this._oPropertySet[p];},getKeyProperties:function(){return this._aKeyProperties;},getLabelOfProperty:function(p){var P=this._oPropertySet[p];if(P==null){throw"no such property with name "+p;}if(P.extensions!=undefined){for(var i=-1,E;(E=P.extensions[++i])!==undefined;){if(!E.namespace==o.constants.SAP_NAMESPACE){continue;}if(E.name=="label"){return E.value;}}}return null;},getHeadingOfProperty:function(p){var P=this._oPropertySet[p];if(P==null){throw"no such property with name "+p;}var s=null;if(P.extensions!=undefined){for(var i=-1,E;(E=P.extensions[++i])!==undefined;){if(!E.namespace==o.constants.SAP_NAMESPACE){continue;}if(E.name=="heading"){return E.value;}if(E.name=="label"){s=E.value;}}}return s;},getQuickInfoOfProperty:function(p){var P=this._oPropertySet[p];if(P==null){throw"no such property with name "+p;}var s=null;if(P.extensions!=undefined){for(var i=-1,E;(E=P.extensions[++i])!==undefined;){if(!E.namespace==o.constants.SAP_NAMESPACE){continue;}if(E.name=="quickinfo"){return E.value;}if(E.name=="label"){s=E.value;}}}return s;},getTextPropertyOfProperty:function(p){var P=this._oPropertySet[p];if(P==null){throw"no such property with name "+p;}if(P.extensions!=undefined){for(var i=-1,E;(E=P.extensions[++i])!==undefined;){if(E.name=="text"){return this.findPropertyByName(E.value);}}}return null;},getSuperOrdinatePropertyOfProperty:function(p){var P=this._oPropertySet[p];if(P==null){throw"no such property with name "+p;}if(P.extensions!=undefined){for(var i=-1,E;(E=P.extensions[++i])!==undefined;){if(E.name=="super-ordinate"){return this.findPropertyByName(E.value);}}}return null;},getFilterablePropertyNames:function(){return this._aFilterablePropertyNames;},getSortablePropertyNames:function(){return this._aSortablePropertyNames;},getRequiredFilterPropertyNames:function(){return this._aRequiredFilterPropertyNames;},getPropertiesWithFilterRestrictions:function(){return this._oPropertyFilterRestrictionSet;},getAllHierarchyPropertyNames:function(){if(this._aHierarchyPropertyNames){return this._aHierarchyPropertyNames;}this._aHierarchyPropertyNames=[];for(var n in this._oRecursiveHierarchySet){this._aHierarchyPropertyNames.push(this._oRecursiveHierarchySet[n].getNodeValueProperty().name);}return this._aHierarchyPropertyNames;},getHierarchy:function(n){if(this._oRecursiveHierarchySet[n]==undefined){return null;}return this._oRecursiveHierarchySet[n];},getQName:function(){return this._sQName;},getTypeDescription:function(){return this._oEntityType;},getSchema:function(){return this._oSchema;},getModel:function(){return this._oModel;},_oEntityType:null,_oSchema:null,_oModel:null,_sQName:null,_aKeyProperties:null,_oPropertySet:null,_aFilterablePropertyNames:null,_aRequiredFilterPropertyNames:null,_oPropertyFilterRestrictionSet:null,_aHierarchyPropertyNames:null,_oRecursiveHierarchySet:null};
o.RecursiveHierarchy=function(E,n,p,N,a,b){this._init(E,n,p,N,a,b);};
o.RecursiveHierarchy.prototype={_init:function(E,n,p,N,a,b){this._oEntityType=E;this._oNodeIDProperty=n;this._oParentNodeIDProperty=p;this._oNodeLevelProperty=N;this._oNodeValueProperty=a;this._oNodeExternalKeyProperty=b;},isRecursiveHierarchy:function(){return true;},isLeveledHierarchy:function(){return false;},getNodeExternalKeyProperty:function(){return this._oNodeExternalKeyProperty;},getNodeIDProperty:function(){return this._oNodeIDProperty;},getParentNodeIDProperty:function(){return this._oParentNodeIDProperty;},getNodeLevelProperty:function(){return this._oNodeLevelProperty;},getNodeValueProperty:function(){return this._oNodeValueProperty;},_oEntityType:null,_oNodeIDProperty:null,_oParentNodeIDProperty:null,_oNodeLevelProperty:null,_oNodeValueProperty:null,_oNodeExternalKeyProperty:null};
o.FilterExpression=function(m,s,E){this._init(m,s,E);};
o.FilterExpression.prototype={_init:function(m,s,E){this._oEntityType=E;this._oSchema=s;this._oModel=m;this._aConditionUI5Filter=[];this._aUI5FilterArray=[];},_renderPropertyFilterValue:function(f,p){if(p==="Edm.Time"&&d.test(f)){f={ms:parseInt(f),__edmType:"Edm.Time"};}return e(this._oModel.getODataModel().formatValue(f,p));},clear:function(){this._aConditionUI5Filter=[];this._aUI5FilterArray=[];},_addCondition:function(p,O,v,V){for(var i=-1,u;(u=this._aConditionUI5Filter[++i])!==undefined;){if(u.sPath==p&&u.sOperator==O&&u.oValue1==v&&u.oValue2==V){return;}}this._aConditionUI5Filter.push(new F(p,O,v,V));},_addUI5FilterArray:function(u){this._aUI5FilterArray.push(u);},addCondition:function(p,O,v,V){var P=this._oEntityType.findPropertyByName(p);if(P==null){throw"Cannot add filter condition for unknown property name "+p;}var f=this._oEntityType.getFilterablePropertyNames();if(((f?Array.prototype.indexOf.call(f,p):-1))===-1){throw"Cannot add filter condition for not filterable property name "+p;}this._addCondition(p,O,v,V);return this;},removeConditions:function(p){var P=this._oEntityType.findPropertyByName(p);if(P==null){throw"Cannot remove filter conditions for unknown property name "+p;}for(var i=0;i<this._aConditionUI5Filter.length;i++){var u=this._aConditionUI5Filter[i];if(u.sPath==p){this._aConditionUI5Filter.splice(i--,1);}}return this;},addSetCondition:function(p,v){var P=this._oEntityType.findPropertyByName(p);if(P==null){throw"Cannot add filter condition for unknown property name "+p;}var f=this._oEntityType.getFilterablePropertyNames();if(((f?Array.prototype.indexOf.call(f,p):-1))===-1){throw"Cannot add filter condition for not filterable property name "+p;}for(var i=-1,V;(V=v[++i])!==undefined;){this._addCondition(p,c.EQ,V);}return this;},addUI5FilterConditions:function(u){if(!Array.isArray(u)){throw"Argument is not an array";}if(u.length==0){return this;}var h=false;for(var i=0;i<u.length;i++){if(u[i].aFilters!=undefined){h=true;break;}}if(h){this._addUI5FilterArray(u);}else{for(var j=0;j<u.length;j++){this.addCondition(u[j].sPath,u[j].sOperator,u[j].oValue1,u[j].oValue2);}}return this;},getExpressionAsUI5FilterArray:function(){var f=this._aConditionUI5Filter.concat([]);for(var i=-1,a;(a=this._aUI5FilterArray[++i])!==undefined;){for(var j=-1,b;(b=a[++j])!==undefined;){f.push(b);}}return f;},getPropertiesReferencedByUI5FilterArray:function(u,r){for(var i=-1,U;(U=u[++i])!==undefined;){if(U.aFilters!=undefined){this.getPropertiesReferencedByUI5FilterArray(U.aFilters,r);}else{if(r[U.sPath]==undefined){r[U.sPath]=[];}r[U.sPath].push(U);}}},getReferencedProperties:function(){var r={};for(var i=-1,u;(u=this._aConditionUI5Filter[++i])!==undefined;){if(r[u.sPath]==undefined){r[u.sPath]=[];}r[u.sPath].push(u);}for(var j=-1,U;(U=this._aUI5FilterArray[++j])!==undefined;){this.getPropertiesReferencedByUI5FilterArray(U,r);}return r;},renderUI5Filter:function(u){var f=null,p=this._oEntityType.findPropertyByName(u.sPath);if(p==null){throw"Cannot add filter condition for unknown property name "+u.sPath;}switch(u.sOperator){case c.BT:f="("+u.sPath+" ge "+this._renderPropertyFilterValue(u.oValue1,p.type)+" and "+u.sPath+" le "+this._renderPropertyFilterValue(u.oValue2,p.type)+")";break;case c.NB:f="("+u.sPath+" lt "+this._renderPropertyFilterValue(u.oValue1,p.type)+" or "+u.sPath+" gt "+this._renderPropertyFilterValue(u.oValue2,p.type)+")";break;case c.Contains:case c.NotContains:f=(u.sOperator[0]==="N"?"not ":"")+"substringof("+this._renderPropertyFilterValue(u.oValue1,"Edm.String")+","+u.sPath+")";break;case c.StartsWith:case c.EndsWith:case c.NotStartsWith:case c.NotEndsWith:f=u.sOperator.toLowerCase().replace("not","not ")+"("+u.sPath+","+this._renderPropertyFilterValue(u.oValue1,"Edm.String")+")";break;default:f=u.sPath+" "+u.sOperator.toLowerCase()+" "+this._renderPropertyFilterValue(u.oValue1,p.type);}return f;},renderUI5MultiFilter:function(u){var U=[];var O="";var l=u.bAnd==true?" and ":" or ";for(var i=-1,a;(a=u.aFilters[++i])!==undefined;){if(a.aFilters!=undefined){U.push(a);continue;}O+=(O==""?"":l)+"("+this.renderUI5Filter(a)+")";}if(U.length>0){for(var j=-1,m;(m=U[++j])!==undefined;){O+=(O==""?"":l)+"("+this.renderUI5MultiFilter(m)+")";}}return O;},renderUI5FilterArray:function(u){if(u.length==0){return"";}var O="";u.sort(function(a,b){if(a.sPath==b.sPath){return 0;}if(a.sPath>b.sPath){return 1;}else{return-1;}});var p=u[0].sPath;var s="";var n=[],U=[];for(var i=-1,f;(f=u[++i])!==undefined;){if(f.aFilters!=undefined){U.push(f);continue;}if(p!=f.sPath){if(s!=""){O+=(O==""?"":" and ")+"("+s+")";}s="";if(n.length>0){for(var j=-1,N;(N=n[++j])!==undefined;){s+=(s==""?"":" and ")+this.renderUI5Filter(N);}O+=(O==""?"":" and ")+"("+s+")";s="";}p=f.sPath;n=[];}if(f.sOperator==c.NE){n.push(f);continue;}s+=(s==""?"":" or ")+this.renderUI5Filter(f);}if(s!=""){O+=(O==""?"":" and ")+"("+s+")";}if(n.length>0){s="";for(var k=-1,g;(g=n[++k])!==undefined;){s+=(s==""?"":" and ")+this.renderUI5Filter(g);}O+=(O==""?"":" and ")+"("+s+")";}if(U.length>0){for(var l=-1,m;(m=U[++l])!==undefined;){O+=(O==""?"":" and ")+"("+this.renderUI5MultiFilter(m)+")";}}return O;},getURIFilterOptionValue:function(){var O=this.renderUI5FilterArray(this._aConditionUI5Filter);for(var i=-1,u;(u=this._aUI5FilterArray[++i])!==undefined;){O+=(O==""?"":" and ")+"("+this.renderUI5FilterArray(u)+")";}return O;},checkValidity:function(){var r=this._oEntityType.getRequiredFilterPropertyNames();var p=this.getReferencedProperties();for(var i=-1,P;(P=r[++i])!==undefined;){if(p[P]==undefined){throw"filter expression does not contain required property "+P;}}var a=this._oEntityType.getPropertiesWithFilterRestrictions();for(var s in a){var f=a[s];if(f==o.EntityType.propertyFilterRestriction.SINGLE_VALUE){if(p[s]!=undefined){if(p[s].length>1){var t=p[s][0].oValue1;for(var j=0;j<p[s].length;j++){if(p[s][j].oValue1!=t||p[s][j].sOperator!=c.EQ){throw"filter expression may use "+s+" only with a single EQ condition";}}}}}}return true;},getEntityType:function(){return this._oEntityType;},getSchema:function(){return this._oSchema;},getModel:function(){return this._oModel;},_oEntityType:null,_oSchema:null,_oModel:null,_aFilterCondition:null};o.SortOrder={Ascending:"asc",Descending:"desc"};
o.SortExpression=function(m,s,E){this._init(m,s,E);};
o.SortExpression.prototype={_init:function(m,s,E){this._oEntityType=E;this._oSchema=s;this._oModel=m;this._aSortCondition=[];},_containsSorter:function(p){var r=null;for(var i=-1,C;(C=this._aSortCondition[++i])!==undefined;){if(C.property.name===p){r={sorter:C,index:i};break;}}return r;},_removeFromArray:function(a,f,t){var r=a.slice((t||f)+1||a.length);a.length=f<0?a.length+f:f;return a.push.apply(a,r);},clear:function(){this._aSortCondition=[];},addSorter:function(p,s){var P=this._oEntityType.findPropertyByName(p);if(P==null){throw"Cannot add sort condition for unknown property name "+p;}var E=this._containsSorter(p);if(E!=null){E.sorter.order=s;return this;}var a=this._oEntityType.getSortablePropertyNames();if(((a?Array.prototype.indexOf.call(a,p):-1))===-1){throw"Cannot add sort condition for not sortable property name "+p;}this._aSortCondition.push({property:P,order:s});return this;},removeSorter:function(p){if(!p){return;}var s=this._containsSorter(p);if(s){this._removeFromArray(this._aSortCondition,s.index);}},getExpressionsAsUI5SorterArray:function(){var s=[];for(var i=-1,C;(C=this._aSortCondition[++i])!==undefined;){s.push(new S(C.property.name,C.order==o.SortOrder.Descending));}return s;},getExpressionAsUI5Sorter:function(){var s=this.getExpressionsAsUI5SorterArray();if(s.length==0){return null;}else{return s[0];}},getURIOrderByOptionValue:function(s){if(this._aSortCondition.length==0){return"";}var O="";for(var i=-1,C;(C=this._aSortCondition[++i])!==undefined;){if(!s[C.property.name]){continue;}O+=(O==""?"":",")+C.property.name+" "+C.order;}return O;},getEntityType:function(){return this._oEntityType;},getSchema:function(){return this._oSchema;},getModel:function(){return this._oModel;},_oEntityType:null,_oSchema:null,_oModel:null,_aSortCondition:null};
o.ParameterizationRequest=function(p){this._init(p);};
o.ParameterizationRequest.prototype={_init:function(p){if(!p){throw"No parameterization given";}this._oParameterization=p;this._oParameterValueAssignment=[];},_renderParameterKeyValue:function(k,p){return e(this._oParameterization.getTargetQueryResult().getModel().getODataModel().formatValue(k,p));},getParameterization:function(){return this._oParameterization;},setParameterValue:function(p,v,t){var P=this._oParameterization.findParameterByName(p);if(!P){throw"Invalid parameter name "+p;}if(t!=null){if(!P.isIntervalBoundary()){throw"Range value cannot be applied to parameter "+p+" accepting only single values";}if(!P.isLowerIntervalBoundary()){throw"Range value given, but parameter "+p+" does not hold the lower boundary";}}if(!P.isIntervalBoundary()){if(v==null){delete this._oParameterValueAssignment[p];}else{this._oParameterValueAssignment[p]=v;}}else{if(v==null&&t!=null){throw"Parameter "+p+": An upper boundary cannot be given without the lower boundary";}if(v==null){delete this._oParameterValueAssignment[p];t=null;}else{this._oParameterValueAssignment[p]=v;}var u=P.getPeerIntervalBoundaryParameter();if(t==null){t=v;}if(v==null){delete this._oParameterValueAssignment[u.getName()];}else{this._oParameterValueAssignment[u.getName()]=t;}}return;},getURIToParameterizationEntitySet:function(s){return(s?s:"")+"/"+this._oParameterization.getEntitySet().getQName();},getURIToParameterizationEntry:function(s){var D=this._oParameterization.getAllParameters();for(var a in D){if(this._oParameterValueAssignment[a]==undefined){throw"Parameter "+a+" has no value assigned";}}var k="",f=true;for(var p in this._oParameterValueAssignment){k+=(f?"":",")+p+"="+this._renderParameterKeyValue(this._oParameterValueAssignment[p],D[p].getProperty().type);f=false;}return(s?s:"")+"/"+this._oParameterization.getEntitySet().getQName()+"("+k+")";},_oParameterization:null,_oParameterValueAssignment:null};
o.QueryResultRequest=function(q,p){this._init(q,p);};
o.QueryResultRequest.prototype={_init:function(q,p){this._oQueryResult=q;this._oParameterizationRequest=p;this._oAggregationLevel={};this._oDimensionHierarchies={};this._oMeasures={};this._bIncludeEntityKey=false;this._oFilterExpression=null;this._oSortExpression=null;this._oSelectedPropertyNames=null;},addRecursiveHierarchy:function(h,i,I){var D;if(!h){return;}D=this._oQueryResult.findDimensionByName(h);if(!D){throw new Error("'"+h+"' is not a dimension property");}if(!D.getHierarchy()){throw new Error("Dimension '"+h+"' does not have a hierarchy");}this._oSelectedPropertyNames=null;this._oDimensionHierarchies[h]={externalKey:i,id:true,text:I};},setParameterizationRequest:function(p){this._oParameterizationRequest=p;},setResourcePath:function(r){this._sResourcePath=r;if(this._sResourcePath.indexOf("/")!=0){throw"Missing leading / (slash) for resource path";}if(this._oQueryResult.getParameterization()){var l=r.lastIndexOf("/");if(l==-1){throw"Missing navigation from parameter entity set to query result in resource path";}var n=r.substring(l+1);if(n!=this._oQueryResult.getParameterization().getNavigationPropertyToQueryResult()){throw"Invalid navigation property from parameter entity set to query result in resource path";}}},getParameterizationRequest:function(){return this._oParameterizationRequest;},getQueryResult:function(){return this._oQueryResult;},setAggregationLevel:function(D){this._oAggregationLevel={};if(!D){D=this._oQueryResult.getAllDimensionNames();}this.addToAggregationLevel(D);this._oSelectedPropertyNames=null;},addToAggregationLevel:function(D){if(!D){return;}this._oSelectedPropertyNames=null;for(var i=-1,s;(s=D[++i])!==undefined;){if(!this._oQueryResult.findDimensionByName(s)){throw s+" is not a valid dimension name";}this._oAggregationLevel[s]={key:true,text:false,attributes:null};}},removeFromAggregationLevel:function(D){if(!D){return;}this._oSelectedPropertyNames=null;for(var i=-1,s;(s=D[++i])!==undefined;){if(!this._oQueryResult.findDimensionByName(s)){throw s+" is not a valid dimension name";}if(this._oAggregationLevel[s]!=undefined){delete this._oAggregationLevel[s];this.getSortExpression().removeSorter(s);}}},getAggregationLevel:function(){var D=[];for(var s in this._oAggregationLevel){D.push(s);}return D;},getAggregationLevelDetails:function(D){if(this._oAggregationLevel[D]==undefined){throw"Aggregation level does not include dimension "+D;}return this._oAggregationLevel[D];},setMeasures:function(m){if(!m){m=this._oQueryResult.getAllMeasureNames();}this._oSelectedPropertyNames=null;this._oMeasures={};for(var i=-1,M;(M=m[++i])!==undefined;){if(!this._oQueryResult.findMeasureByName(M)){throw M+" is not a valid measure name";}this._oMeasures[M]={value:true,text:false,unit:false};}},getMeasureNames:function(){var m=[];for(var M in this._oMeasures){m.push(M);}return m;},includeDimensionKeyTextAttributes:function(D,I,b,a){this._oSelectedPropertyNames=null;var f=[];if(D){if(this._oAggregationLevel[D]==undefined){throw D+" is not included in the aggregation level";}f.push(D);}else{for(var n in this._oAggregationLevel){f.push(n);}a=null;}for(var i=-1,s;(s=f[++i])!==undefined;){if(I!=null){this._oAggregationLevel[s].key=I;}if(b!=null){this._oAggregationLevel[s].text=b;}if(a!=null){this._oAggregationLevel[s].attributes=a;}}},includeMeasureRawFormattedValueUnit:function(m,I,b,a){this._oSelectedPropertyNames=null;var M=[];if(m){if(this._oMeasures[m]==undefined){throw m+" is not part of the query result";}M.push(m);}else{for(var n in this._oMeasures){M.push(n);}}for(var i=-1,s;(s=M[++i])!==undefined;){if(I!=null){this._oMeasures[s].value=I;}if(b!=null){this._oMeasures[s].text=b;}if(a!=null){this._oMeasures[s].unit=a;}}},getFilterExpression:function(){if(this._oFilterExpression==null){var E=this._oQueryResult.getEntityType();this._oFilterExpression=new o.FilterExpression(this._oQueryResult.getModel(),E.getSchema(),E);}return this._oFilterExpression;},setFilterExpression:function(f){this._oFilterExpression=f;},getSortExpression:function(){if(this._oSortExpression==null){var E=this._oQueryResult.getEntityType();this._oSortExpression=new o.SortExpression(E.getModel(),E.getSchema(),E);}return this._oSortExpression;},setSortExpression:function(s){this._oSortExpression=s;},setRequestOptions:function(i,I,r){if(i!=null){this._bIncludeEntityKey=i;}if(I!=null){this._bIncludeCount=I;}if(r!=null){this._bReturnNoEntities=r;}},setResultPageBoundaries:function(s,a){if(s!=null&&typeof s!=="number"){throw"Start value must be null or numeric";}if(a!==null&&typeof a!=="number"){throw"End value must be null or numeric";}if(s==null){s=1;}if(s<1||s>(a==null?s:a)){throw"Invalid values for requested page boundaries";}this._iSkipRequestOption=(s>1)?s-1:null;this._iTopRequestOption=(a!=null)?(a-s+1):null;},getResultPageBoundaries:function(){var E=null;if(this._iTopRequestOption!=null){if(this._iSkipRequestOption==null){E=1;}else{E=this._iSkipRequestOption+this._iTopRequestOption;}}return{start:(this._iSkipRequestOption==null)?1:this._iSkipRequestOption,end:E};},getURIToQueryResultEntitySet:function(s){var u=null;if(this._sResourcePath!=null){u=(s?s:"")+this._sResourcePath;}else if(this._oQueryResult.getParameterization()){if(!this._oParameterizationRequest){throw"Missing parameterization request";}else{u=this._oParameterizationRequest.getURIToParameterizationEntry(s)+"/"+this._oQueryResult.getParameterization().getNavigationPropertyToQueryResult();}}else{u=(s?s:"")+"/"+this._oQueryResult.getEntitySet().getQName();}return u;},getURIOrderByOptionValue:function(){var a,C,O=null,s=this._oSortExpression?this._oSortExpression._aSortCondition:[],i,n=s.length;if(n){a=this._oQueryResult.getAllMeasureNames();for(i=0;i<n;i+=1){C=s[i];if(!this._oSelectedPropertyNames[C.property.name]&&a.indexOf(C.property.name)<0){continue;}O=(O?O+",":"")+C.property.name+" "+C.order;}}return O;},getURIQueryOptionValue:function(q){var n,Q=null,s,t=this;function a(p){var P;if(!p){return;}P=typeof p==="string"?p:p.name;if(!t._oSelectedPropertyNames[P]){s+=(s==""?"":",")+P;t._oSelectedPropertyNames[P]=true;}}switch(q){case"$select":{s="";this._oSelectedPropertyNames={};for(n in this._oAggregationLevel){var D=this._oQueryResult.findDimensionByName(n);var b=this._oAggregationLevel[n];if(b.key==true){a(D.getKeyProperty());}if(b.text==true){a(D.getTextProperty());}if(b.attributes){for(var i=-1,f;(f=b.attributes[++i])!==undefined;){a(D.findAttributeByName(f).getName());}}}for(n in this._oMeasures){var m=this._oQueryResult.findMeasureByName(n);var M=this._oMeasures[n];if(M.value==true){a(m.getRawValueProperty());}if(M.text==true){a(m.getFormattedValueProperty());}if(M.unit==true){a(m.getUnitProperty());}}for(n in this._oDimensionHierarchies){var h=this._oQueryResult.findDimensionByName(n).getHierarchy();var H=this._oDimensionHierarchies[n];if(H.id){a(h.getNodeIDProperty());}if(H.externalKey){a(h.getNodeExternalKeyProperty());}if(H.text){a(this._oQueryResult.getEntityType().getTextPropertyOfProperty(h.getNodeIDProperty().name));}}if(this._bIncludeEntityKey){var k=this._oQueryResult.getEntityType().getTypeDescription().key.propertyRef;for(var j=-1,K;(K=k[++j])!==undefined;){s+=(s==""?"":",")+K.name;}}Q=(s?s:null);break;}case"$filter":{var g=null;if(this._oFilterExpression){g=this._oFilterExpression.getURIFilterOptionValue();}Q=(g?g:null);break;}case"$orderby":{Q=this.getURIOrderByOptionValue();break;}case"$top":{Q=null;if(this._bReturnNoEntities){Q=0;}else if(this._iTopRequestOption!==null){Q=this._iTopRequestOption;}break;}case"$skip":{Q=null;if(!this._bReturnNoEntities){Q=this._iSkipRequestOption;}break;}case"$inlinecount":{Q=(this._bIncludeCount==true?"allpages":null);break;}default:break;}return Q;},getURIToQueryResultEntries:function(s,r){if(!r){r=this.getURIToQueryResultEntitySet(s);}this.getFilterExpression().checkValidity();var a=this.getURIQueryOptionValue("$select");var f=this.getURIQueryOptionValue("$filter");var b=this.getURIQueryOptionValue("$orderby");var t=this.getURIQueryOptionValue("$top");var g=this.getURIQueryOptionValue("$skip");var i=this.getURIQueryOptionValue("$inlinecount");var u=r;var q=false;if(a!==null){u+="?$select="+a;q=true;}if(this._oFilterExpression&&f!==null){if(!q){u+="?";q=true;}else{u+="&";}u+="$filter="+f;}if(this._oSortExpression&&b!==null){if(!q){u+="?";q=true;}else{u+="&";}u+="$orderby="+b;}if((this._iTopRequestOption||this._bReturnNoEntities)&&t!==null){if(!q){u+="?";q=true;}else{u+="&";}u+="$top="+t;}if(this._iSkipRequestOption&&g!==null){if(!q){u+="?";q=true;}else{u+="&";}u+="$skip="+g;}if(this._bIncludeCount&&i!==null){if(!q){u+="?";q=true;}else{u+="&";}u+="$inlinecount="+i;}return u;},_oQueryResult:null,_oParameterizationRequest:null,_sResourcePath:null,_oAggregationLevel:null,_oDimensionHierarchies:null,_oMeasures:null,_bIncludeEntityKey:null,_bIncludeCount:null,_bReturnNoEntities:null,_oFilterExpression:null,_oSortExpression:null,_iSkipRequestOption:null,_iTopRequestOption:null};
o.ParameterValueSetRequest=function(p){this._init(p);};
o.ParameterValueSetRequest.prototype={_init:function(p){this._oParameter=p;this._oValueSetResult={};this._oFilterExpression=null;this._oSortExpression=null;},includeParameterText:function(i){if(i!=null){this._oValueSetResult.text=i;}},getFilterExpression:function(){if(this._oFilterExpression==null){var E=this._oParameter.getContainingParameterization().getEntityType();var m=this._oParameter.getContainingParameterization().getTargetQueryResult().getModel();this._oFilterExpression=new o.FilterExpression(m,E.getSchema(),E);}return this._oFilterExpression;},setFilterExpression:function(f){this._oFilterExpression=f;},getSortExpression:function(){if(this._oSortExpression==null){var E=this._oParameter.getContainingParameterization().getEntityType();this._oSortExpression=new o.SortExpression(E.getModel(),E.getSchema(),E);}return this._oSortExpression;},setSortExpression:function(s){this._oSortExpression=s;},getURIQueryOptionValue:function(q){var Q=null;switch(q){case"$select":{var s="";s+=(s==""?"":",")+this._oParameter.getProperty().name;if(this._oValueSetResult.text==true&&this._oParameter.getTextProperty()){s+=(s==""?"":",")+this._oParameter.getTextProperty().name;}Q=(s?s:null);break;}case"$filter":{var f=null;if(this._oFilterExpression){f=this._oFilterExpression.getURIFilterOptionValue();}Q=(f?f:null);break;}case"$orderby":{var a=null;if(this._oSortExpression){a=this._oSortExpression.getURIOrderByOptionValue();}Q=(a?a:null);break;}default:break;}return Q;},getURIToParameterValueSetEntries:function(s){var r=null;r=(s?s:"")+"/"+this._oParameter.getContainingParameterization().getEntitySet().getQName();this.getFilterExpression().checkValidity();var a=this.getURIQueryOptionValue("$select");var f=this.getURIQueryOptionValue("$filter");var b=this.getURIQueryOptionValue("$orderby");var u=r;var q=false;if(a){u+="?$select="+a;q=true;}if(this._oFilterExpression&&f){if(!q){u+="?";q=true;}else{u+="&";}u+="$filter="+f;}if(this._oSortExpression&&b){if(!q){u+="?";q=true;}else{u+="&";}u+="$orderby="+b;}return u;},_oParameter:null,_oFilterExpression:null,_oSortExpression:null,_oValueSetResult:null};
o.DimensionMemberSetRequest=function(D,p,u){this._init(D,p,u);};
o.DimensionMemberSetRequest.prototype={_init:function(D,p,u){this._oDimension=D;this._oParameterizationRequest=p;this._bUseMasterData=u;this._oValueSetResult={};this._oFilterExpression=null;this._oSortExpression=null;if(this._oParameterizationRequest!=null&&this._bUseMasterData==true){throw"Parameterized master data entity sets are not yet implemented";}if(this._bUseMasterData){this._oEntitySet=this._oDimension.getMasterDataEntitySet();}else{this._oEntitySet=this._oDimension.getContainingQueryResult().getEntitySet();if(this._oDimension.getContainingQueryResult().getParameterization()&&!this._oParameterizationRequest){throw"Missing parameterization request";}}},setParameterizationRequest:function(p){this._oParameterizationRequest=p;},includeDimensionTextAttributes:function(i,I){this._oValueSetResult.text={text:false,attributes:false};if(i==true){this._oValueSetResult.text=true;}if(I==true){this._oValueSetResult.attributes=true;}},getFilterExpression:function(){if(this._oFilterExpression==null){var E=this._oEntitySet.getEntityType();var m=this._oDimension.getContainingQueryResult().getModel();this._oFilterExpression=new o.FilterExpression(m,E.getSchema(),E);}return this._oFilterExpression;},setFilterExpression:function(f){this._oFilterExpression=f;},getSortExpression:function(){if(this._oSortExpression==null){this._oSortExpression=new o.SortExpression(this._oEntityType.getModel(),this._oEntityType.getSchema(),this._oEntityType);}return this._oSortExpression;},setSortExpression:function(s){this._oSortExpression=s;},setRequestOptions:function(i){if(i!=null){this._bIncludeCount=i;}},setResultPageBoundaries:function(s,a){if(s!=null&&typeof s!=="number"){throw"Start value must be null or numeric";}if(a!==null&&typeof a!=="number"){throw"End value must be null or numeric";}if(s==null){s=1;}if(s<1||s>(a==null?s:a)){throw"Invalid values for requested page boundaries";}this._iSkipRequestOption=(s>1)?s-1:null;this._iTopRequestOption=(a!=null)?(a-s+1):null;},getResultPageBoundaries:function(){var E=null;if(this._iTopRequestOption!=null){if(this._iSkipRequestOption==null){E=1;}else{E=this._iSkipRequestOption+this._iTopRequestOption;}}return{start:(this._iSkipRequestOption==null)?1:this._iSkipRequestOption,end:E};},getURIQueryOptionValue:function(q){var Q=null;switch(q){case"$select":{var s="";var E=this._oEntitySet.getEntityType();var K=E.getKeyProperties();var a=[];if(this._bUseMasterData){for(var i=-1,b;(b=K[++i])!==undefined;){s+=(s==""?"":",")+b;var f=E.getTextPropertyOfProperty(b);if(f){if(this._oValueSetResult.text==true){s+=","+f.name;}a.push(f.name);}}}else{s+=(s==""?"":",")+this._oDimension.getKeyProperty().name;if(this._oValueSetResult.text==true&&this._oDimension.getTextProperty()){s+=(s==""?"":",")+this._oDimension.getTextProperty().name;}}if(this._oValueSetResult.attributes){if(this._bUseMasterData){var g=E.getProperties();for(var p in g){var I=false;for(var j=-1,h;(h=K[++j])!==undefined;){if(p==h){I=true;break;}}if(I){continue;}for(var k=-1,m;(m=a[++k])!==undefined;){if(p==m){I=true;break;}}if(!I){s+=","+p;}}}else{var n=this._oDimension.getAllAttributeNames();for(var l=-1,r;(r=n[++l])!==undefined;){s+=(s==""?"":",")+this._oDimension.findAttributeByName(r).getName();}}}Q=(s?s:null);break;}case"$filter":{var t=null;if(this._oFilterExpression){t=this._oFilterExpression.getURIFilterOptionValue();}Q=(t?t:null);break;}case"$orderby":{var u=null;if(this._oSortExpression){u=this._oSortExpression.getURIOrderByOptionValue();}Q=(u?u:null);break;}case"$top":{if(this._iTopRequestOption!==null){Q=this._iTopRequestOption;}break;}case"$skip":{Q=this._iSkipRequestOption;break;}case"$inlinecount":{Q=(this._bIncludeCount==true?"allpages":null);break;}default:break;}return Q;},getURIToDimensionMemberEntitySet:function(s){var r=null;if(!this._bUseMasterData&&this._oParameterizationRequest){r=this._oParameterizationRequest.getURIToParameterizationEntry(s)+"/"+this._oDimension.getContainingQueryResult().getParameterization().getNavigationPropertyToQueryResult();}else{r=(s?s:"")+"/"+this._oEntitySet.getQName();}return r;},getURIToDimensionMemberEntries:function(s){var r=this.getURIToDimensionMemberEntitySet(s);this.getFilterExpression().checkValidity();var a=this.getURIQueryOptionValue("$select");var f=this.getURIQueryOptionValue("$filter");var b=this.getURIQueryOptionValue("$orderby");var t=this.getURIQueryOptionValue("$top");var g=this.getURIQueryOptionValue("$skip");var i=this.getURIQueryOptionValue("$inlinecount");var u=r;var q=false;if(a){u+="?$select="+a;q=true;}if(this._oFilterExpression&&f){if(!q){u+="?";q=true;}else{u+="&";}u+="$filter="+f;}if(this._oSortExpression&&b){if(!q){u+="?";q=true;}else{u+="&";}u+="$orderby="+b;}if(this._iTopRequestOption&&t){if(!q){u+="?";q=true;}else{u+="&";}u+="$top="+t;}if(this._iSkipRequestOption&&g){if(!q){u+="?";q=true;}else{u+="&";}u+="$skip="+g;}if(this._bIncludeCount&&i){if(!q){u+="?";q=true;}else{u+="&";}u+="$inlinecount="+i;}return u;},_oDimension:null,_oParameterizationRequest:null,_oEntitySet:null,_bUseMasterData:false,_oFilterExpression:null,_oSortExpression:null,_oValueSetResult:null,_bIncludeCount:null,_iSkipRequestOption:0,_iTopRequestOption:null};return o;},true);
sap.ui.predefine('sap/ui/model/json/JSONListBinding',["sap/base/Log","sap/base/util/deepEqual","sap/base/util/deepExtend","sap/base/util/each","sap/base/util/extend","sap/ui/model/ChangeReason","sap/ui/model/ClientListBinding"],function(L,d,a,e,b,C,c){"use strict";
var J=c.extend("sap.ui.model.json.JSONListBinding");
J.prototype.getContexts=function(s,l){this.iLastStartIndex=s;this.iLastLength=l;if(!s){s=0;}if(!l){l=Math.min(this.iLength,this.oModel.iSizeLimit);}var f=this._getContexts(s,l),g=[];if(this.bUseExtendedChangeDetection){try{for(var i=0;i<f.length;i++){g.push(this.getContextData(f[i]));}if(this.aLastContextData&&s<this.iLastEndIndex){f.diff=this.diffData(this.aLastContextData,g);}this.iLastEndIndex=s+l;this.aLastContexts=f.slice(0);this.aLastContextData=g.slice(0);}catch(E){this.bUseExtendedChangeDetection=false;L.warning("JSONListBinding: Extended change detection has been disabled as JSON data could not be serialized.");}}return f;};
J.prototype.getCurrentContexts=function(){if(this.bUseExtendedChangeDetection){return this.aLastContexts||[];}else{return this.getContexts(this.iLastStartIndex,this.iLastLength);}};
J.prototype.updateIndices=function(){var i;this.aIndices=[];if(Array.isArray(this.oList)){for(i=0;i<this.oList.length;i++){this.aIndices.push(i);}}else{for(i in this.oList){this.aIndices.push(i);}}};
J.prototype.update=function(){var l=this.oModel._getObject(this.sPath,this.oContext);if(l){if(Array.isArray(l)){if(this.bUseExtendedChangeDetection){this.oList=a([],l);}else{this.oList=l.slice(0);}}else{this.oList=this.bUseExtendedChangeDetection?a({},l):b({},l);}this.updateIndices();this.applyFilter();this.applySort();this.iLength=this._getLength();}else{this.oList=[];this.aIndices=[];this.iLength=0;}};
J.prototype.checkUpdate=function(f){var l;if(this.bSuspended&&!this.bIgnoreSuspend&&!f){return;}if(!this.bUseExtendedChangeDetection){l=this.oModel._getObject(this.sPath,this.oContext)||[];if(!d(this.oList,l)||f){this.update();this._fireChange({reason:C.Change});}}else{var g=false;var t=this;l=this.oModel._getObject(this.sPath,this.oContext)||[];if(this.oList.length!=l.length){g=true;}if(!d(this.oList,l)){this.update();}var h=this._getContexts(this.iLastStartIndex,this.iLastLength);if(this.aLastContexts){if(this.aLastContexts.length!=h.length){g=true;}else{e(this.aLastContextData,function(i,o){var j=t.getContextData(h[i]);if(j!==o){g=true;return false;}return true;});}}else{g=true;}if(g||f){this._fireChange({reason:C.Change});}}};
return J;});
sap.ui.predefine('sap/ui/model/json/JSONModel',["./JSONListBinding","./JSONPropertyBinding","./JSONTreeBinding","sap/base/Log","sap/base/util/deepExtend","sap/base/util/isPlainObject","sap/ui/model/ClientModel","sap/ui/model/Context"],function(J,a,b,L,d,c,C,f){"use strict";
var g=C.extend("sap.ui.model.json.JSONModel",{
constructor:function(D,o){this.pSequentialImportCompleted=Promise.resolve();C.apply(this,arguments);this.bObserve=o;if(D&&typeof D=="object"){this.setData(D);}},
metadata:{publicMethods:["setJSON","getJSON"]}
});
g.prototype.setData=function(D,m){if(m){this.oData=d(Array.isArray(this.oData)?[]:{},this.oData,D);}else{this.oData=D;}if(this.bObserve){this.observeData();}this.checkUpdate();};
g.prototype.observeData=function(){var t=this;function e(v){return function(){return v;};}function h(O,n){return function(v){o(v,O,n);t.checkUpdate();};}function j(O,n,v){if(typeof v=="function"){O[n]=v;}else{Object.defineProperty(O,n,{get:e(v),set:h(O,n)});}}function o(O,p,n){var i;if(Array.isArray(O)){for(i=0;i<O.length;i++){o(O[i],O,i);}}else if(c(O)){for(i in O){o(O[i],O,i);}}if(p){j(p,n,O);}}o(this.oData);};
g.prototype.setJSON=function(j,m){var o;try{o=JSON.parse(j+"");this.setData(o,m);}catch(e){L.fatal("The following problem occurred: JSON parse Error: "+e);this.fireParseError({url:"",errorCode:-1,reason:"",srcText:e,line:-1,linepos:-1,filepos:-1});}};
g.prototype.getJSON=function(){return JSON.stringify(this.oData);};
g.prototype.loadData=function(u,p,A,t,m,e,h){var i;A=(A!==false);t=t||"GET";e=e===undefined?this.bCache:e;this.fireRequestSent({url:u,type:t,async:A,headers:h,info:"cache="+e+";bMerge="+m,infoObject:{cache:e,merge:m}});var s=function(D){if(!D){L.fatal("The following problem occurred: No data was retrieved by service: "+u);}this.setData(D,m);this.fireRequestCompleted({url:u,type:t,async:A,headers:h,info:"cache="+e+";bMerge="+m,infoObject:{cache:e,merge:m},success:true});}.bind(this);var E=function(P,T){var M=T||P.textStatus;var p=A?P.request:P;var S=p.status;var k=p.statusText;var r=p.responseText;var o={message:M,statusCode:S,statusText:k,responseText:r};L.fatal("The following problem occurred: "+M,r+","+S+","+k);this.fireRequestCompleted({url:u,type:t,async:A,headers:h,info:"cache="+e+";bMerge="+m,infoObject:{cache:e,merge:m},success:false,errorobject:o});this.fireRequestFailed(o);if(A){return Promise.reject(o);}return undefined;}.bind(this);var _=function(s,E){this._ajax({url:u,async:A,dataType:'json',cache:e,data:p,headers:h,type:t,success:s,error:E});}.bind(this);if(A){i=new Promise(function(r,k){var R=function(x,T,o){k({request:x,textStatus:T,error:o});};_(r,R);});var j=this.pSequentialImportCompleted.then(function(){return i.then(s,E);});this.pSequentialImportCompleted=j.catch(function(o){L.error("Loading of data failed: "+o.stack);});return j;}else{_(s,E);return undefined;}};
g.prototype.dataLoaded=function(){return this.pSequentialImportCompleted;};
g.prototype.bindProperty=function(p,o,P){var B=new a(this,p,o,P);return B;};
g.prototype.bindList=function(p,o,s,F,P){var B=new J(this,p,o,s,F,P);return B;};
g.prototype.bindTree=function(p,o,F,P,s){var B=new b(this,p,o,F,P,s);return B;};
g.prototype.setProperty=function(p,v,o,A){var r=this.resolve(p,o),l,O,P;if(!r){return false;}if(r=="/"){this.setData(v);return true;}l=r.lastIndexOf("/");O=r.substring(0,l||1);P=r.substr(l+1);var e=this._getObject(O);if(e){e[P]=v;this.checkUpdate(false,A);return true;}return false;};
g.prototype.getProperty=function(p,o){return this._getObject(p,o);};
g.prototype._getObject=function(p,o){var n=this.isLegacySyntax()?this.oData:null;if(o instanceof f){n=this._getObject(o.getPath());}else if(o!=null){n=o;}if(!p){return n;}var P=p.split("/"),i=0;if(!P[0]){n=this.oData;i++;}while(n&&P[i]){n=n[P[i]];i++;}return n;};
g.prototype.isList=function(p,o){var A=this.resolve(p,o);return Array.isArray(this._getObject(A));};
g.prototype._setMetaModel=function(m){this._oMetaModel=m;};
g.prototype.getMetaModel=function(){return this._oMetaModel;};
return g;});
sap.ui.predefine('sap/ui/model/json/JSONPropertyBinding',['sap/ui/model/ChangeReason','sap/ui/model/ClientPropertyBinding',"sap/base/util/deepEqual"],function(C,a,d){"use strict";
var J=a.extend("sap.ui.model.json.JSONPropertyBinding");
J.prototype.setValue=function(v){if(this.bSuspended){return;}if(!d(this.oValue,v)){if(this.oModel.setProperty(this.sPath,v,this.oContext,true)){this.oValue=v;this.getDataState().setValue(this.oValue);this.oModel.firePropertyChange({reason:C.Binding,path:this.sPath,context:this.oContext,value:v});}}};
J.prototype.checkUpdate=function(f){if(this.bSuspended&&!f){return;}var v=this._getValue();if(!d(v,this.oValue)||f){this.oValue=v;this.getDataState().setValue(this.oValue);this.checkDataState();this._fireChange({reason:C.Change});}};
return J;});
sap.ui.predefine('sap/ui/model/json/JSONTreeBinding',['sap/ui/model/ClientTreeBinding'],function(C){"use strict";
var J=C.extend("sap.ui.model.json.JSONTreeBinding");
J.prototype._saveSubContext=function(n,c,s,N){if(n&&typeof n=="object"){var o=this.oModel.getContext(s+N);if(this.oCombinedFilter&&!this.bIsFiltering){if(this.filterInfo.aFilteredContexts&&this.filterInfo.aFilteredContexts.indexOf(o)!=-1){c.push(o);}}else{c.push(o);}}};
return J;});
sap.ui.predefine('sap/ui/model/odata/AnnotationHelper',["./_AnnotationHelperBasics","./_AnnotationHelperExpression","sap/base/Log","sap/ui/base/BindingParser"],function(B,E,L,a){'use strict';
function c(f,b){return function(){return f.call(this,b.apply(this,arguments));};}
var A={createPropertySetting:function(p,r){var m=false,P;p=p.slice();p.forEach(function(v,i){switch(typeof v){case"boolean":case"number":case"undefined":m=true;break;case"string":P=a.complexParser(v,null,true,true);if(P!==undefined){if(P.functionsNotFound){throw new Error("Function name(s) "+P.functionsNotFound.join(", ")+" not found");}p[i]=v=P;}case"object":if(!v||typeof v!=="object"||!("path"in v)){m=true;}break;default:throw new Error("Unsupported part: "+v);}});P={formatter:r,parts:p};if(m){a.mergeParts(P);}r=P.formatter;if(P.parts.length===0){P=r&&r();if(typeof P==="string"){P=a.complexParser.escape(P);}}else if(P.parts.length===1){if(r&&!r.textFragments&&P.parts[0].formatter){P.formatter=c(r,P.parts[0].formatter);P.parts[0]=Object.assign({},P.parts[0]);delete P.parts[0].formatter;}}return P;},format:function(i,r){if(arguments.length===1){r=i.getObject("");}return E.getExpression(i,r,true);},getNavigationPath:function(i,r){if(arguments.length===1){r=i.getObject("");}var R=B.followPath(i,r);return R?"{"+R.navigationProperties.join("/")+"}":"";},gotoEntitySet:function(C){var e,s,r=C.getObject(),R;if(typeof r==="string"){e=r;}else{R=B.followPath(C,r);e=R&&R.associationSetEnd&&R.associationSetEnd.entitySet;}if(e){s=C.getModel().getODataEntitySet(e,true);}if(!s){L.warning(C.getPath()+": found '"+e+"' which is not a name of an entity set",undefined,"sap.ui.model.odata.AnnotationHelper");}return s;},gotoEntityType:function(C){var e=C.getProperty(""),r=C.getModel().getODataEntityType(e,true);if(!r){L.warning(C.getPath()+": found '"+e+"' which is not a name of an entity type",undefined,"sap.ui.model.odata.AnnotationHelper");}return r;},gotoFunctionImport:function(C){var f=C.getProperty("String"),r=C.getModel().getODataFunctionImport(f,true);if(!r){L.warning(C.getPath()+": found '"+f+"' which is not a name of a function import",undefined,"sap.ui.model.odata.AnnotationHelper");}return r;},isMultiple:function(i,r){if(arguments.length===1){r=i.getObject("");}var R=B.followPath(i,r);if(R){if(R.navigationAfterMultiple){throw new Error('Association end with multiplicity "*" is not the last one: '+r.AnnotationPath);}return String(R.isMultiple);}return"";},resolvePath:function(C){var r=B.followPath(C,C.getObject());if(!r){L.warning(C.getPath()+": Path could not be resolved ",undefined,"sap.ui.model.odata.AnnotationHelper");}return r?r.resolvedPath:undefined;},simplePath:function(i,r){if(arguments.length===1){r=i.getObject("");}return E.getExpression(i,r,false);}};A.format.requiresIContext=true;A.getNavigationPath.requiresIContext=true;A.isMultiple.requiresIContext=true;A.simplePath.requiresIContext=true;return A;},true);
sap.ui.predefine('sap/ui/model/odata/AnnotationParser',["sap/base/assert","sap/base/Log","sap/base/util/isEmptyObject"],function(a,L,b){"use strict";var A={EnumMember:true,Path:true,PropertyPath:true,NavigationPropertyPath:true,AnnotationPath:true};var t={Binary:true,Bool:true,Date:true,DateTimeOffset:true,Decimal:true,Duration:true,Float:true,Guid:true,Int:true,String:true,TimeOfDay:true,LabelElementReference:true,EnumMember:true,Path:true,PropertyPath:true,NavigationPropertyPath:true,AnnotationPath:true};var M={And:true,Or:true,Eq:true,Ne:true,Gt:true,Ge:true,Lt:true,Le:true,If:true,Collection:true};
function g(o){return o.getAttribute("Qualifier")||o.parentNode.nodeName==="Annotations"&&o.parentNode.getAttribute("Qualifier");}
var c={merge:function(T,s){var d,e;var S=["annotationsAtArrays","propertyAnnotations","EntityContainer","annotationReferences"];for(d in s){if(S.indexOf(d)!==-1){continue;}c._mergeAnnotation(d,s,T);}for(var i=1;i<S.length;++i){var f=S[i];T[f]=T[f]||{};for(d in s[f]){for(e in s[f][d]){T[f][d]=T[f][d]||{};c._mergeAnnotation(e,s[f][d],T[f][d]);}}}if(s.annotationsAtArrays){T.annotationsAtArrays=(T.annotationsAtArrays||[]).concat(s.annotationsAtArrays);}},_mergeAnnotation:function(n,m,T){if(Array.isArray(m[n])){T[n]=m[n].slice(0);}else{T[n]=T[n]||{};for(var k in m[n]){T[n][k]=m[n][k];}}},parse:function(m,x,s){try{c._parserData={};c._oXPath=c.getXPath();return c._parse(m,x,s);}finally{delete c._parserData;delete c._oXPath;}},_parse:function(m,x,s){var d={},e,f,h,T,l,n,p,q,r,u,v,w,y,z,B,C,D,E,F,G,H,i,I,J=[];c._parserData.metadataInstance=m;c._parserData.serviceMetadata=m.getServiceMetadata();c._parserData.xmlDocument=c._oXPath.setNameSpace(x);c._parserData.schema={};c._parserData.aliases={};c._parserData.url=s?s:"metadata document";c._parserData.annotationsAtArrays=J;e=c._oXPath.selectNodes("//d:Schema",c._parserData.xmlDocument);for(i=0;i<e.length;i+=1){f=c._oXPath.nextNode(e,i);c._parserData.schema.Alias=f.getAttribute("Alias");c._parserData.schema.Namespace=f.getAttribute("Namespace");}var K={};var N=c._parseReferences(K);if(N){d.annotationReferences=K;d.aliasDefinitions=c._parserData.aliases;}h=c._oXPath.selectNodes("//d:Term",c._parserData.xmlDocument);if(h.length>0){T={};for(I=0;I<h.length;I+=1){l=c._oXPath.nextNode(h,I);n=c.replaceWithAlias(l.getAttribute("Type"));T["@"+c._parserData.schema.Alias+"."+l.getAttribute("Name")]=n;}d.termDefinitions=T;}c._parserData.metadataProperties=c.getAllPropertiesMetadata(c._parserData.serviceMetadata);if(c._parserData.metadataProperties.extensions){d.propertyExtensions=c._parserData.metadataProperties.extensions;}p=c._oXPath.selectNodes("//d:Annotations ",c._parserData.xmlDocument);for(I=0;I<p.length;I+=1){q=c._oXPath.nextNode(p,I);if(q.hasChildNodes()===false){continue;}r=q.getAttribute("Target");u=r.split(".")[0];if(u&&c._parserData.aliases[u]){r=r.replace(new RegExp(u,""),c._parserData.aliases[u]);}v=r;w=null;var O=null;if(r.indexOf("/")>0){v=r.split("/")[0];var S=c._parserData.serviceMetadata.dataServices&&c._parserData.serviceMetadata.dataServices.schema&&c._parserData.serviceMetadata.dataServices.schema.length;if(S){for(var j=c._parserData.serviceMetadata.dataServices.schema.length-1;j>=0;j--){var P=c._parserData.serviceMetadata.dataServices.schema[j];if(P.entityContainer){var Q=v.split('.');for(var k=P.entityContainer.length-1;k>=0;k--){if(P.entityContainer[k].name===Q[Q.length-1]){O=r.replace(v+"/","");break;}}}}}if(!O){w=r.replace(v+"/","");}}if(w){if(!d.propertyAnnotations){d.propertyAnnotations={};}if(!d.propertyAnnotations[v]){d.propertyAnnotations[v]={};}if(!d.propertyAnnotations[v][w]){d.propertyAnnotations[v][w]={};}y=c._oXPath.selectNodes("./d:Annotation",q);for(var R=0;R<y.length;R+=1){z=c._oXPath.nextNode(y,R);B=c.replaceWithAlias(z.getAttribute("Term"));var U=g(z);if(U){B+="#"+U;}if(z.hasChildNodes()===false){var o={};c.enrichFromPropertyValueAttributes(o,z);if(b(o)){o.Bool="true";}d.propertyAnnotations[v][w][B]=o;}else{d.propertyAnnotations[v][w][B]=c.getPropertyValue(z);}}}else{var V;if(O){if(!d["EntityContainer"]){d["EntityContainer"]={};}if(!d["EntityContainer"][v]){d["EntityContainer"][v]={};}V=d["EntityContainer"][v];}else{if(!d[v]){d[v]={};}V=d[v];}C=v.replace(c._parserData.aliases[u],u);y=c._oXPath.selectNodes("./d:Annotation",q);for(var W=0;W<y.length;W+=1){z=c._oXPath.nextNode(y,W);var X=V;if(O){if(!V[O]){V[O]={};}X=V[O];}c._parseAnnotation(v,z,X);}D=c._oXPath.selectNodes("//d:Annotations[contains(@Target, '"+C+"')]//d:PropertyValue[contains(@Path, '/')]//@Path",c._parserData.xmlDocument);for(i=0;i<D.length;i+=1){E=c._oXPath.nextNode(D,i);F=E.value;if(d.propertyAnnotations){if(d.propertyAnnotations[v]){if(d.propertyAnnotations[v][F]){continue;}}}G=F.split('/');if(c.findNavProperty(v,G[0])){if(!d.expand){d.expand={};}if(!d.expand[v]){d.expand[v]={};}d.expand[v][G[0]]=G[0];}}H=c._oXPath.selectNodes("//d:Annotations[contains(@Target, '"+C+"')]//d:Path[contains(., '/')]",c._parserData.xmlDocument);for(i=0;i<H.length;i+=1){E=c._oXPath.nextNode(H,i);F=c._oXPath.getNodeText(E);if(d.propertyAnnotations&&d.propertyAnnotations[v]&&d.propertyAnnotations[v][F]){continue;}if(!d.expand){d.expand={};}if(!d.expand[v]){d.expand[v]={};}G=F.split('/');if(c.findNavProperty(v,G[0])){if(!d.expand){d.expand={};}if(!d.expand[v]){d.expand[v]={};}d.expand[v][G[0]]=G[0];}}}}if(J.length){d.annotationsAtArrays=J.map(function(Y){return c.backupAnnotationAtArray(Y,d);});}return d;},backupAnnotationAtArray:function(e,m){var q,s=[];function i(){return Array.prototype.filter.call(e.parentNode.childNodes,function(n){return n.nodeType===1;}).indexOf(e);}while(e.nodeName!=="Annotations"){switch(e.nodeName){case"Annotation":q=g(e);s.unshift(e.getAttribute("Term")+(q?"#"+q:""));break;case"Collection":break;case"PropertyValue":s.unshift(e.getAttribute("Property"));break;case"Record":if(e.parentNode.nodeName==="Collection"){s.unshift(i());}break;default:if(e.parentNode.nodeName==="Apply"){s.unshift("Value");s.unshift(i());s.unshift("Parameters");}else{s.unshift(e.nodeName);}break;}e=e.parentNode;}s.unshift(e.getAttribute("Target"));s=s.map(function(S){return typeof S==="string"?c.replaceWithAlias(S):S;});c.syncAnnotationsAtArrays(m,s,true);return s;},restoreAnnotationsAtArrays:function(m){if(m.annotationsAtArrays){m.annotationsAtArrays.forEach(function(s){c.syncAnnotationsAtArrays(m,s);});}},syncAnnotationsAtArrays:function(m,s,w){var i,n=s.length-2,d=s[n+1],p=m,P=s[n],S=P+"@"+d;for(i=0;i<n;i+=1){p=p&&p[s[i]];}if(p&&Array.isArray(p[P])){if(!(S in p)){p[S]=p[P][d];}if(!(d in p[P])){p[P][d]=p[S];}}else if(w){L.warning("Wrong path to annotation at array",s,"sap.ui.model.odata.AnnotationParser");}},_parseAnnotation:function(s,o,d){var q=g(o);var T=c.replaceWithAlias(o.getAttribute("Term"));if(q){T+="#"+q;}var v=c.getPropertyValue(o,s);v=c.setEdmTypes(v,c._parserData.metadataProperties.types,s,c._parserData.schema);d[T]=v;if(Array.isArray(d)){c._parserData.annotationsAtArrays.push(o);}},_parseReferences:function(m){var f=false;var n,i;var x=c._oXPath;var s="//edmx:Reference/edmx:Include[@Namespace and @Alias]";var o=x.selectNodes(s,c._parserData.xmlDocument);for(i=0;i<o.length;++i){f=true;n=x.nextNode(o,i);c._parserData.aliases[n.getAttribute("Alias")]=n.getAttribute("Namespace");}c._parserData.aliasesByLength=Object.keys(c._parserData.aliases).sort(function(h,j){return j.length-h.length;});var r="//edmx:Reference[@Uri]/edmx:IncludeAnnotations[@TermNamespace]";var R=x.selectNodes(r,c._parserData.xmlDocument);for(i=0;i<R.length;++i){f=true;n=x.nextNode(R,i);var T=n.getAttribute("TermNamespace");var d=n.getAttribute("TargetNamespace");var e=n.parentNode.getAttribute("Uri");if(d){if(!m[d]){m[d]={};}m[d][T]=e;}else{m[T]=e;}}return f;},getAllPropertiesMetadata:function(o){var d={},P={},e={},f=false,n,E,C,h={},q={},r={},s=false,u,v,w,T,x,R={types:P};if(!o.dataServices.schema){return R;}for(var i=o.dataServices.schema.length-1;i>=0;i-=1){d=o.dataServices.schema[i];if(d.entityType){n=d.namespace;E=d.entityType;C=d.complexType;for(var j=0;j<E.length;j+=1){h=E[j];r={};q={};if(h.property){for(var k=0;k<h.property.length;k+=1){u=h.property[k];if(u.type.substring(0,n.length)===n){if(C){for(var l=0;l<C.length;l+=1){if(C[l].name===u.type.substring(n.length+1)){if(C[l].property){for(var m=0;m<C[l].property.length;m+=1){v=C[l].property[m];q[C[l].name+"/"+v.name]=v.type;}}}}}}else{w=u.name;T=u.type;if(u.extensions){for(var p=0;p<u.extensions.length;p+=1){x=u.extensions[p];if((x.name==="display-format")&&(x.value==="Date")){T="Edm.Date";}else{s=true;if(!r[w]){r[w]={};}if(x.namespace&&!r[w][x.namespace]){r[w][x.namespace]={};}r[w][x.namespace][x.name]=x.value;}}}q[w]=T;}}}if(!P[n+"."+h.name]){P[n+"."+h.name]={};}P[n+"."+h.name]=q;if(s){if(!e[n+"."+h.name]){f=true;}e[n+"."+h.name]={};e[n+"."+h.name]=r;}}}}if(f){R={types:P,extensions:e};}return R;},setEdmTypes:function(p,P,T,s){function d(e){var o,E='';if(p[e]){o=p[e];if(o.Value&&o.Value.Path){E=c.getEdmType(o.Value.Path,P,T,s);if(E){p[e].EdmType=E;}}else if(o.Path){E=c.getEdmType(o.Path,P,T,s);if(E){p[e].EdmType=E;}}else if(o.Facets){p[e].Facets=c.setEdmTypes(o.Facets,P,T,s);}else if(o.Data){p[e].Data=c.setEdmTypes(o.Data,P,T,s);}else if(e==="Data"){p.Data=c.setEdmTypes(o,P,T,s);}else if(o.Value&&o.Value.Apply){p[e].Value.Apply.Parameters=c.setEdmTypes(o.Value.Apply.Parameters,P,T,s);}else if(o.Value&&o.Type&&(o.Type==="Path")){E=c.getEdmType(o.Value,P,T,s);if(E){p[e].EdmType=E;}}}}if(Array.isArray(p)){for(var v=0;v<p.length;v+=1){d(v);}}else{for(var V in p){d(V);}}return p;},getEdmType:function(p,P,T,s){var i=p.indexOf("/");if(i>-1){var d=p.substr(0,i);var n=c.findNavProperty(T,d);if(n){var m=c._parserData.metadataInstance._getEntityTypeByNavPropertyObject(n);if(m){T=m.entityType;p=p.substr(i+1);}}}if((p.charAt(0)==="@")&&(p.indexOf(s.Alias)===1)){p=p.slice(s.Alias.length+2);}if(p.indexOf("/")>=0){if(P[p.slice(0,p.indexOf("/"))]){T=p.slice(0,p.indexOf("/"));p=p.slice(p.indexOf("/")+1);}}return P[T]&&P[T][p];},enrichFromPropertyValueAttributes:function(m,n){var I={"Property":true,"Qualifier":true,"Term":true,"xmlns":true};for(var i=0;i<n.attributes.length;i+=1){var N=n.attributes[i].name;if(!I[N]&&(N.indexOf("xmlns:")!==0)){var v=n.attributes[i].value;if(N==="EnumMember"&&v.indexOf(" ")>-1){var V=v.split(" ");m[N]=V.map(c.replaceWithAlias).join(" ");}else{m[N]=c.replaceWithAlias(v);}}}return m;},_getRecordValues:function(n){var N=[];var x=c._oXPath;for(var i=0;i<n.length;++i){var o=x.nextNode(n,i);var v=c.getPropertyValues(o);var T=o.getAttribute("Type");if(T){v["RecordType"]=c.replaceWithAlias(T);}N.push(v);}return N;},_getTextValues:function(n){var N=[];var x=c._oXPath;for(var i=0;i<n.length;i+=1){var o=x.nextNode(n,i);var v={};var T=x.getNodeText(o);v[o.nodeName]=c._parserData.aliases?c.replaceWithAlias(T):T;N.push(v);}return N;},_getTextValue:function(n){var x=c._oXPath;var v="";if(n.nodeName in A){v=c.replaceWithAlias(x.getNodeText(n));}else{v=x.getNodeText(n);}if(n.nodeName!=="String"){v=v.trim();}return v;},getPropertyValue:function(d,s){var i;var x=c._oXPath;var p=d.nodeName==="Collection"?[]:{};if(d.hasChildNodes()){var r=x.selectNodes("./d:Record",d);var R=c._getRecordValues(r);var C=x.selectNodes("./d:Collection/d:Record | ./d:Collection/d:If/d:Record",d);var e=c._getRecordValues(C);var P=R.concat(e);if(P.length>0){if(C.length===0&&r.length>0){p=P[0];}else{p=P;}}else{var o=x.selectNodes("./d:Collection/d:AnnotationPath | ./d:Collection/d:NavigationPropertyPath | ./d:Collection/d:PropertyPath",d);if(o.length>0){p=c._getTextValues(o);}else{var f=x.selectNodes("./d:*[not(local-name() = \"Annotation\")]",d);if(f.length>0){for(i=0;i<f.length;i++){var h=x.nextNode(f,i);var v;var n=h.nodeName;var j=h.parentNode.nodeName;if(n==="Apply"){v=c.getApplyFunctions(h);}else{v=c.getPropertyValue(h);}if(M[j]){if(!Array.isArray(p)){p=[];}var V={};V[n]=v;p.push(V);}else if(n==="Collection"){p=v;}else{if(p[n]){L.warning("Annotation contained multiple "+n+" values. Only the last "+"one will be stored: "+x.getPath(h));}p[n]=v;}}c.enrichFromPropertyValueAttributes(p,d);}else if(d.nodeName in t){p=c._getTextValue(d);}else{c.enrichFromPropertyValueAttributes(p,d);}}}var N=x.selectNodes("./d:Annotation",d);if(N.length>0){for(i=0;i<N.length;i++){var k=x.nextNode(N,i);c._parseAnnotation(s,k,p);}}}else if(d.nodeName in t){p=c._getTextValue(d);}else if(d.nodeName.toLowerCase()==="null"){p=null;}else{c.enrichFromPropertyValueAttributes(p,d);}return p;},getPropertyValues:function(p){var P={},i;var x=c._oXPath;var o=x.selectNodes("./d:Annotation",p);var d=x.selectNodes("./d:PropertyValue",p);function e(p,w,N){var l,m=p;while(m.nodeName!=="Annotation"){m=m.parentNode;}l=m.parentNode;return(w+" '"+N+"' is defined twice; "+"Source = "+c._parserData.url+", Annotation Target = "+l.getAttribute("Target")+", Term = "+m.getAttribute("Term"));}if(o.length===0&&d.length===0){P=c.getPropertyValue(p);}else{for(i=0;i<o.length;i++){var f=x.nextNode(o,i);var T=c.replaceWithAlias(f.getAttribute("Term"));a(!P[T],function(){return e(p,"Annotation",T);});P[T]=c.getPropertyValue(f);}for(i=0;i<d.length;i++){var h=x.nextNode(d,i);var s=h.getAttribute("Property");a(!P[s],function(){return e(p,"Property",s);});P[s]=c.getPropertyValue(h);var j=x.selectNodes("./d:Apply",h);for(var n=0;n<j.length;n+=1){var k=x.nextNode(j,n);P[s]={};P[s]['Apply']=c.getApplyFunctions(k);}}}return P;},getApplyFunctions:function(d){var x=c._oXPath;var m={Name:d.getAttribute('Function'),Parameters:[]};var p=x.selectNodes("./d:*",d);for(var i=0;i<p.length;i+=1){var P=x.nextNode(p,i);var e={Type:P.nodeName};if(P.nodeName==="Apply"){e.Value=c.getApplyFunctions(P);}else if(P.nodeName==="LabeledElement"){e.Value=c.getPropertyValue(P);e.Name=e.Value.Name;delete e.Value.Name;}else if(M[P.nodeName]){e.Value=c.getPropertyValue(P);}else{e.Value=x.getNodeText(P);}m.Parameters.push(e);}return m;},findNavProperty:function(e,p){var m=c._parserData.serviceMetadata;for(var i=m.dataServices.schema.length-1;i>=0;i-=1){var o=m.dataServices.schema[i];if(o.entityType){var n=o.namespace+".";var E=o.entityType;for(var k=E.length-1;k>=0;k-=1){if(n+E[k].name===e&&E[k].navigationProperty){for(var j=0;j<E[k].navigationProperty.length;j+=1){if(E[k].navigationProperty[j].name===p){return E[k].navigationProperty[j];}}}}}}return null;},replaceWithAlias:function(v){c._parserData.aliasesByLength.some(function(s){if(v.includes(s+".")&&!v.includes("."+s+".")){v=v.replace(s+".",c._parserData.aliases[s]+".");return true;}return false;});return v;},getXPath:function(){var x={};var p=c._parserData;x={setNameSpace:function(o){return o;},nsResolver:function(d){var n={"edmx":"http://docs.oasis-open.org/odata/ns/edmx","d":"http://docs.oasis-open.org/odata/ns/edm"};return n[d]||null;},selectNodes:function(P,i){var d=p.xmlDocument.evaluate(P,i,this.nsResolver,7,null);d.length=d.snapshotLength;return d;},nextNode:function(n,i){return n.snapshotItem(i);},getNodeText:function(n){return n.textContent;}};x.getPath=function(n){var P="";var I="getAttribute"in n?n.getAttribute("id"):"";var T=n.tagName?n.tagName:"";if(I){P='id("'+I+'")';}else if(n instanceof Document){P="/";}else if(T.toLowerCase()==="body"){P=T;}else if(n.parentNode){var d=1;for(var i=0;i<n.parentNode.childNodes.length;++i){if(n.parentNode.childNodes[i]===n){P=x.getPath(n.parentNode)+"/"+T+"["+d+"]";break;}else if(n.parentNode.childNodes[i].nodeType===1&&n.parentNode.childNodes[i].tagName===T){++d;}}}else{L.error("Wrong Input node - cannot find XPath to it: "+T);}return P;};return x;}};return c;});
sap.ui.predefine('sap/ui/model/odata/CountMode',function(){"use strict";var C={Request:"Request",Inline:"Inline",InlineRepeat:"InlineRepeat",Both:"Both",None:"None"};return C;},true);
sap.ui.predefine('sap/ui/model/odata/Filter',['sap/ui/base/Object','sap/ui/model/Filter'],function(B,F){"use strict";
var O=B.extend("sap.ui.model.odata.Filter",{
constructor:function(p,v,a){if(typeof p==="object"){var f=p;p=f.path;v=f.values;a=f.and;}this.sPath=p;this.aValues=v;this.bAND=a==undefined?true:a;},
convert:function(){var f=[];for(var i=0,l=this.aValues&&this.aValues.length||0;i<l;i++){f.push(new F({path:this.sPath,operator:this.aValues[i].operator,value1:this.aValues[i].value1,value2:this.aValues[i].value2}));}if(f.length>1){var o=new F({filters:f,and:this.bAND});return o;}else{return f[0];}}
});
return O;});
sap.ui.predefine('sap/ui/model/odata/MessageScope',function(){"use strict";var M={RequestedObjects:"RequestedObjects",BusinessObject:"BusinessObject"};return M;},true);
sap.ui.predefine('sap/ui/model/odata/ODataAnnotations',["./AnnotationParser","sap/base/assert","sap/base/Log","sap/base/util/extend","sap/base/util/isEmptyObject","sap/ui/base/EventProvider","sap/ui/thirdparty/jquery"],function(A,a,L,e,b,E,q){"use strict";
var O=E.extend("sap.ui.model.odata.ODataAnnotations",{
constructor:function(o){E.apply(this,arguments);if(arguments.length!==1){if(typeof arguments[2]==="object"){o=arguments[2];}o.urls=arguments[0];o.metadata=arguments[1];}this.oMetadata=o.metadata;this.oAnnotations=o.annotationData?o.annotationData:{};this.bLoaded=false;this.bAsync=o&&o.async;this.xPath=null;this.oError=null;this.bValidXML=true;this.oRequestHandles=[];this.oLoadEvent=null;this.oFailedEvent=null;this.mCustomHeaders=o.headers?e({},o.headers):{};if(o.urls){this.addUrl(o.urls);if(!this.bAsync){a(!b(this.oMetadata),"Metadata must be available for synchronous annotation loading");if(this.oError){L.error("OData annotations could not be loaded: "+this.oError.message);}}}},
metadata:{publicMethods:["parse","getAnnotationsData","attachFailed","detachFailed","attachLoaded","detachLoaded"]}
});
O.prototype.getAnnotationsData=function(){return this.oAnnotations;};
O.prototype.isLoaded=function(){return this.bLoaded;};
O.prototype.isFailed=function(){return this.oError!==null;};
O.prototype.fireLoaded=function(p){this.fireEvent("loaded",p);return this;};
O.prototype.attachLoaded=function(d,f,l){this.attachEvent("loaded",d,f,l);return this;};
O.prototype.detachLoaded=function(f,l){this.detachEvent("loaded",f,l);return this;};
O.prototype.fireFailed=function(p){this.fireEvent("failed",p);return this;};
O.prototype.attachFailed=function(d,f,l){this.attachEvent("failed",d,f,l);return this;};
O.prototype.detachFailed=function(f,l){this.detachEvent("failed",f,l);return this;};
O.prototype.setHeaders=function(h){this.mCustomHeaders=e({},h);};
O.prototype._createXMLDocument=function(x,X){var o=null;if(typeof x==="string"){X=x;x=null;}if(x){o=x;}else{o=new DOMParser().parseFromString(X,'application/xml');}return o;};
O.prototype._documentHasErrors=function(x){return x.getElementsByTagName("parsererror").length>0;};
O.prototype._mergeAnnotationData=function(m,s){if(!this.oAnnotations){this.oAnnotations={};}A.merge(this.oAnnotations,m);this.bLoaded=true;if(!s){this.fireLoaded({annotations:m});}};
O.prototype.setXML=function(x,X,o){var d={success:function(){},error:function(){},fireEvents:false};o=e({},d,o);var c=this._createXMLDocument(x,X);var p=function(c){var r={xmlDoc:c};var f=A.parse(this.oMetadata,c);if(f){r.annotations=f;o.success(r);this._mergeAnnotationData(f,!o.fireEvents);}else{o.error(r);if(o.fireEvents){this.fireFailed(r);}}}.bind(this,c);if(this._documentHasErrors(c)){o.error({xmlDoc:c});return false;}else{var m=this.oMetadata.getServiceMetadata();if(!m||b(m)){this.oMetadata.attachLoaded(p);}else{p();}return true;}};
O.prototype.addUrl=function(u){var t=this;var U=u;if(Array.isArray(u)&&u.length==0){return Promise.resolve({annotations:this.oAnnotations});}if(!Array.isArray(u)){U=[u];}return new Promise(function(r,R){var l=0;var m={annotations:null,success:[],fail:[]};var f=function(d){l++;if(d.type==="success"){m.success.push(d);}else{m.fail.push(d);}if(l===U.length){m.annotations=t.oAnnotations;if(m.success.length>0){var s={annotations:t.oAnnotations,results:m};t.fireLoaded(s);}if(m.success.length<U.length){var o=new Error("At least one annotation failed to load/parse/merge");o.annotations=m.annotations;o.success=m.success;o.fail=m.fail;R(o);}else{r(m);}}};var i=0;if(t.bAsync){var p=Promise.resolve();for(i=0;i<U.length;++i){var c=t._loadFromUrl.bind(t,U[i]);p=p.then(c,c).then(f,f);}}else{for(i=0;i<U.length;++i){t._loadFromUrl(U[i]).then(f,f);}}});};
O.prototype._loadFromUrl=function(u){var t=this;return new Promise(function(r,R){var m={url:u,async:t.bAsync,headers:e({},t.mCustomHeaders,{"Accept-Language":sap.ui.getCore().getConfiguration().getLanguageTag()})};var o;var f=function(j,S){if(o&&o.bSuppressErrorHandlerCall){return;}t.oError={type:"fail",url:u,message:S,statusCode:j.status,statusText:j.statusText,responseText:j.responseText};if(t.bAsync){t.oFailedEvent=setTimeout(t.fireFailed.bind(t,t.oError),0);}else{t.fireFailed(t.oError);}R(t.oError);};var s=function(d,S,j){t.setXML(j.responseXML,j.responseText,{success:function(D){r({type:"success",url:u,message:S,statusCode:j.status,statusText:j.statusText,responseText:j.responseText});},error:function(D){f(j,"Malformed XML document");},url:u});};q.ajax(m).done(s).fail(f);});};
O.prototype.destroy=function(){for(var i=0;i<this.oRequestHandles.length;++i){if(this.oRequestHandles[i]){this.oRequestHandles[i].bSuppressErrorHandlerCall=true;this.oRequestHandles[i].abort();this.oRequestHandles[i]=null;}}E.prototype.destroy.apply(this,arguments);if(this.oLoadEvent){clearTimeout(this.oLoadEvent);}if(this.oFailedEvent){clearTimeout(this.oFailedEvent);}};
return O;});
sap.ui.predefine('sap/ui/model/odata/ODataContextBinding',['sap/ui/model/ContextBinding','sap/ui/model/ChangeReason'],function(C,a){"use strict";
var O=C.extend("sap.ui.model.odata.ODataContextBinding",{constructor:function(m,p,c,P,e){C.call(this,m,p,c,P,e);}});
O.prototype.initialize=function(){var t=this,r=this.oModel.resolve(this.sPath,this.oContext),d=this.oModel._getObject(this.sPath,this.oContext),R=this.oModel._isReloadNeeded(r,d,this.mParameters);if(this.oModel.oMetadata.isLoaded()){if(r&&R){this.fireDataRequested();}this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(c){t.oElementContext=c;t._fireChange({reason:a.Context});if(r&&R){t.fireDataReceived();}},R);}};
O.prototype.refresh=function(f,c){var t=this,k,s,b=false,r=this.oModel.resolve(this.sPath,this.oContext);if(c){s=this.oModel._getObject(this.sPath,this.oContext);if(s){k=this.oModel._getKey(s);if(k in c){b=true;}}}else{b=true;}if(f||b){if(r){this.fireDataRequested();}this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(o){if(t.oElementContext===o){if(f){t._fireChange({reason:a.Context});}}else{t.oElementContext=o;t._fireChange({reason:a.Context});}if(r){t.fireDataReceived();}},true);}};
O.prototype.setContext=function(c){var t=this,r,d,R;if(this.oContext!==c&&this.isRelative()){this.oContext=c;r=this.oModel.resolve(this.sPath,this.oContext);d=this.oModel._getObject(this.sPath,this.oContext);R=this.oModel._isReloadNeeded(r,d,this.mParameters);if(r&&R){this.fireDataRequested();}this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(c){t.oElementContext=c;t._fireChange({reason:a.Context});if(r&&R){t.fireDataReceived();}},R);}};
return O;});
sap.ui.predefine('sap/ui/model/odata/ODataListBinding',["./CountMode","./ODataUtils","sap/base/assert","sap/base/Log","sap/base/util/deepEqual","sap/base/util/each","sap/base/util/merge","sap/base/util/array/diff","sap/ui/model/ChangeReason","sap/ui/model/Filter","sap/ui/model/FilterProcessor","sap/ui/model/FilterType","sap/ui/model/ListBinding","sap/ui/model/Sorter","sap/ui/model/odata/Filter"],function(C,O,a,L,d,e,m,b,c,F,f,g,h,S,k){"use strict";
var l=h.extend("sap.ui.model.odata.ODataListBinding",{constructor:function(M,p,o,s,i,P){h.apply(this,arguments);this.sFilterParams=null;this.sSortParams=null;this.sRangeParams=null;this.sCustomParams=this.oModel.createCustomParams(this.mParameters);this.iStartIndex=0;this.bPendingChange=false;this.aKeys=[];this.bInitial=true;this.sCountMode=(P&&P.countMode)||this.oModel.sDefaultCountMode;this.bRefresh=false;this.bNeedsUpdate=false;this.bDataAvailable=false;this.bIgnoreSuspend=false;this.oCombinedFilter=null;this.oModel.checkFilterOperation(this.aApplicationFilters);if(!this.oModel.getServiceMetadata()){var t=this,j=function(E){t.bInitial=false;t._initSortersFilters();t.oModel.detachMetadataLoaded(j);};this.oModel.attachMetadataLoaded(this,j);}else{this.bInitial=false;this._initSortersFilters();}var r=this.oModel._getObject(this.sPath,this.oContext);this.aExpandRefs=r;if(Array.isArray(r)&&!s&&!i){this.aKeys=r;this.iLength=r.length;this.bLengthFinal=true;this.bDataAvailable=true;}else if(r===null&&this.oModel.resolve(this.sPath,this.oContext)){this.aKeys=[];this.iLength=0;this.bLengthFinal=true;this.bDataAvailable=true;}else if(this.oModel.getServiceMetadata()){this.resetData();}}});
l.prototype.getContexts=function(s,j,t){if(this.bInitial){return[];}this.iLastLength=j;this.iLastStartIndex=s;this.iLastThreshold=t;if(!s){s=0;}if(!j){j=this.oModel.iSizeLimit;if(this.bLengthFinal&&this.iLength<j){j=this.iLength;}}if(!t){t=0;}var n=true,o=this._getContexts(s,j),p={},q;q=this.calculateSection(s,j,t,o);n=o.length!=j&&!(this.bLengthFinal&&o.length>=this.iLength-s);if(this.oModel.getServiceMetadata()){if(!this.bPendingRequest&&q.length>0&&(n||j<q.length)){this.loadData(q.startIndex,q.length);o.dataRequested=true;}}if(this.bRefresh){if(this.bLengthFinal&&this.iLength==0){this.loadData(q.startIndex,q.length,true);o.dataRequested=true;}this.bRefresh=false;}else{for(var i=0;i<o.length;i++){p[o[i].getPath()]=o[i].getObject();}if(this.bUseExtendedChangeDetection){if(this.aLastContexts&&s<this.iLastEndIndex){var r=this;var D=b(this.aLastContexts,o,function(u,N){return d(u&&r.oLastContextData&&r.oLastContextData[u.getPath()],N&&p&&p[N.getPath()]);});o.diff=D;}}this.iLastEndIndex=s+j;this.aLastContexts=o.slice(0);this.oLastContextData=m({},p);}return o;};
l.prototype.getCurrentContexts=function(){return this.aLastContexts||[];};
l.prototype._getContexts=function(s,j){var n=[],o,K;if(!s){s=0;}if(!j){j=this.oModel.iSizeLimit;if(this.bLengthFinal&&this.iLength<j){j=this.iLength;}}for(var i=s;i<s+j;i++){K=this.aKeys[i];if(!K){break;}o=this.oModel.getContext('/'+K);n.push(o);}return n;};
l.prototype.calculateSection=function(s,n,t,o){var p,q,P,r,R,u={},K;q=s;p=0;for(var i=s;i>=Math.max(s-t,0);i--){K=this.aKeys[i];if(!K){r=i+1;break;}}for(var j=s+n;j<s+n+t;j++){K=this.aKeys[j];if(!K){P=j;break;}}R=s-r;if(r&&s>t&&R<t){if(o.length!=n){q=s-t;}else{q=r-t;}p=t;}q=Math.max(q,0);if(q==s){q+=o.length;}if(o.length!=n){p+=n-o.length;}R=P-s-n;if(R==0){p+=t;}if(P&&R<t&&R>0){if(q>s){q=P;p+=t;}}if(this.bLengthFinal&&this.iLength<(p+q)){p=this.iLength-q;}u.startIndex=q;u.length=p;return u;};
l.prototype.setContext=function(o){if(this.oContext!=o){this.oContext=o;if(this.isRelative()){this._initSortersFilters();if(!this.bInitial){var r=this.oModel._getObject(this.sPath,this.oContext);this.aExpandRefs=r;if(Array.isArray(r)&&!this.aSorters.length>0&&!this.aFilters.length>0){this.aKeys=r;this.iLength=r.length;this.bLengthFinal=true;this._fireChange({reason:c.Context});}else if(!this.oModel.resolve(this.sPath,this.oContext)||r===null){this.aKeys=[];this.iLength=0;this.bLengthFinal=true;this._fireChange({reason:c.Context});}else{this.refresh();}}}}};
l.prototype.getDownloadUrl=function(s){var p=[],P;if(s){p.push("$format="+encodeURIComponent(s));}if(this.sSortParams){p.push(this.sSortParams);}if(this.sFilterParams){p.push(this.sFilterParams);}if(this.sCustomParams){p.push(this.sCustomParams);}P=this.oModel.resolve(this.sPath,this.oContext);return P&&this.oModel._createRequestUrl(P,null,p);};
l.prototype.loadData=function(s,j,p){var t=this,I=false;if(s||j){this.sRangeParams="$skip="+s+"&$top="+j;this.iStartIndex=s;}else{s=this.iStartIndex;}var P=[];if(this.sRangeParams){P.push(this.sRangeParams);}if(this.sSortParams){P.push(this.sSortParams);}if(this.sFilterParams){P.push(this.sFilterParams);}if(this.sCustomParams){P.push(this.sCustomParams);}if(!this.bLengthFinal&&(this.sCountMode==C.Inline||this.sCountMode==C.Both)){P.push("$inlinecount=allpages");I=true;}function n(D){e(D.results,function(i,v){t.aKeys[s+i]=t.oModel._getKey(v);});if(I&&D.__count){t.iLength=parseInt(D.__count);t.bLengthFinal=true;}if(t.iLength<s+D.results.length){t.iLength=s+D.results.length;t.bLengthFinal=false;}if(D.results.length<j||j===undefined){t.iLength=s+D.results.length;t.bLengthFinal=true;}if(s==0&&D.results.length==0){t.iLength=0;t.bLengthFinal=true;}t.oRequestHandle=null;t.bPendingRequest=false;t.bNeedsUpdate=true;t.bIgnoreSuspend=true;}function o(D){t.fireDataReceived({data:D});}function E(i,A){t.oRequestHandle=null;t.bPendingRequest=false;if(!A){t.aKeys=[];t.iLength=0;t.bLengthFinal=true;t.bDataAvailable=true;t._fireChange({reason:c.Change});}t.fireDataReceived();}function u(H){t.oRequestHandle=H;}var q=this.sPath,r=this.oContext;if(this.isRelative()){q=this.oModel.resolve(q,r);}if(q){if(p){var U=this.oModel._createRequestUrl(q,null,P);this.fireDataRequested();this.oModel.fireRequestSent({url:U,method:"GET",async:true});setTimeout(function(){t.bNeedsUpdate=true;t.checkUpdate();t.oModel.fireRequestCompleted({url:U,method:"GET",async:true,success:true});t.fireDataReceived({data:{}});},0);}else{this.bPendingRequest=true;this.fireDataRequested();this.oModel._loadData(q,P,n,E,false,u,o);}}};
l.prototype.getLength=function(){if(this.bLengthFinal||this.iLength==0){return this.iLength;}else{var A=this.iLastThreshold||this.iLastLength||10;return this.iLength+A;}};
l.prototype.isLengthFinal=function(){return this.bLengthFinal;};
l.prototype._getLength=function(){var t=this;var p=[];if(this.sFilterParams){p.push(this.sFilterParams);}if(this.mParameters&&this.mParameters.custom){var o={custom:{}};e(this.mParameters.custom,function(s,v){o.custom[s]=v;});p.push(this.oModel.createCustomParams(o));}function _(D){t.iLength=parseInt(D);t.bLengthFinal=true;}function i(E){var s="Request for $count failed: "+E.message;if(E.response){s+=", "+E.response.statusCode+", "+E.response.statusText+", "+E.response.body;}L.warning(s);}var P=this.oModel.resolve(this.sPath,this.oContext);if(P){var u=this.oModel._createRequestUrl(P+"/$count",null,p);var r=this.oModel._createRequest(u,"GET",false);r.headers["Accept"]="text/plain, */*;q=0.5";this.oModel._request(r,_,i,undefined,undefined,this.oModel.getServiceMetadata());}};
l.prototype.refresh=function(j,n,E){var o=false;if(!j){if(E){var r=this.oModel.resolve(this.sPath,this.oContext);var p=this.oModel.oMetadata._getEntityTypeByPath(r);if(p&&(p.entityType in E)){o=true;}}if(n&&!o){e(this.aKeys,function(i,K){if(K in n){o=true;return false;}return true;});}if(!n&&!E){o=true;}}if(j||o){this.abortPendingRequest();this.resetData();this._fireRefresh({reason:c.Refresh});}};
l.prototype._fireRefresh=function(p){if(this.oModel.resolve(this.sPath,this.oContext)){this.bRefresh=true;this.fireEvent("refresh",p);}};
l.prototype.initialize=function(){if(this.oModel.oMetadata.isLoaded()){if(this.bDataAvailable){this._fireChange({reason:c.Change});}else{this._fireRefresh({reason:c.Refresh});}}};
l.prototype.checkUpdate=function(j,n){var s=this.sChangeReason?this.sChangeReason:c.Change,o=false,p,q,t=this,r,R;if(this.bSuspended&&!this.bIgnoreSuspend){return;}if(!j&&!this.bNeedsUpdate){r=this.oModel._getObject(this.sPath,this.oContext);R=Array.isArray(r)&&!d(r,this.aExpandRefs);this.aExpandRefs=r;if(R){if(this.aSorters.length>0||this.aFilters.length>0){this.refresh();return;}else{this.aKeys=r;this.iLength=r.length;this.bLengthFinal=true;o=true;}}else if(n){e(this.aKeys,function(i,K){if(K in n){o=true;return false;}return true;});}else{o=true;}if(o&&this.aLastContexts){o=false;var u=this._getContexts(this.iLastStartIndex,this.iLastLength,this.iLastThreshold);if(this.aLastContexts.length!=u.length){o=true;}else{e(this.aLastContexts,function(i,v){p=t.oLastContextData[v.getPath()];q=u[i].getObject();if(!d(p,q,true)){o=true;return false;}return true;});}}}if(j||o||this.bNeedsUpdate){this.bNeedsUpdate=false;this._fireChange({reason:s});}this.sChangeReason=undefined;this.bIgnoreSuspend=false;};
l.prototype.resetData=function(){this.aKeys=[];this.iLength=0;this.bLengthFinal=false;this.sChangeReason=undefined;this.bDataAvailable=false;if(this.oModel.isCountSupported()&&(this.sCountMode==C.Request||this.sCountMode==C.Both)){this._getLength();}};
l.prototype.abortPendingRequest=function(){if(this.oRequestHandle){this.oRequestHandle.abort();this.oRequestHandle=null;this.bPendingRequest=false;}};
l.prototype.sort=function(s,r){var i=false;if(!s){s=[];}if(s instanceof S){s=[s];}this.aSorters=s;this.createSortParams(s);if(!this.bInitial){this.aKeys=[];this.abortPendingRequest();this.sChangeReason=c.Sort;this._fireRefresh({reason:this.sChangeReason});this._fireSort({sorter:s});i=true;}if(r){return i;}else{return this;}};
l.prototype.createSortParams=function(s){this.sSortParams=O.createSortParams(s);};
l.prototype.filter=function(i,s,r){var j=false;if(!i){i=[];}if(i instanceof F){i=[i];}this.oModel.checkFilterOperation(i);if(s==g.Application){this.aApplicationFilters=i;}else{this.aFilters=i;}if(!i||!Array.isArray(i)||i.length==0){this.aFilters=[];}if(!this.aApplicationFilters||!Array.isArray(this.aApplicationFilters)||this.aApplicationFilters.length===0){this.aApplicationFilters=[];}this.convertFilters();this.oCombinedFilter=f.combineFilters(this.aFilters,this.aApplicationFilters);this.createFilterParams(this.oCombinedFilter);if(!this.bInitial){this.resetData();this.abortPendingRequest();this.sChangeReason=c.Filter;this._fireRefresh({reason:this.sChangeReason});if(s==g.Application){this._fireFilter({filters:this.aApplicationFilters});}else{this._fireFilter({filters:this.aFilters});}j=true;}if(r){return j;}else{return this;}};
l.prototype.convertFilters=function(){this.aFilters=this.aFilters.map(function(o){return o instanceof k?o.convert():o;});this.aApplicationFilters=this.aApplicationFilters.map(function(o){return o instanceof k?o.convert():o;});};
l.prototype.createFilterParams=function(o){this.sFilterParams=O.createFilterParams(o,this.oModel.oMetadata,this.oEntityType);};
l.prototype._initSortersFilters=function(){var r=this.oModel.resolve(this.sPath,this.oContext);if(!r){return;}this.oEntityType=this._getEntityType();this.convertFilters();this.oCombinedFilter=f.combineFilters(this.aFilters,this.aApplicationFilters);this.createSortParams(this.aSorters);this.createFilterParams(this.oCombinedFilter);};
l.prototype._getEntityType=function(){var r=this.oModel.resolve(this.sPath,this.oContext);if(r){var E=this.oModel.oMetadata._getEntityTypeByPath(r);a(E,"EntityType for path "+r+" could not be found!");return E;}return undefined;};
l.prototype.resume=function(){this.bIgnoreSuspend=false;h.prototype.resume.apply(this,arguments);};
return l;});
sap.ui.predefine('sap/ui/model/odata/ODataMessageParser',["sap/ui/model/odata/ODataMetadata","sap/ui/model/odata/ODataUtils","sap/ui/core/library","sap/ui/thirdparty/URI","sap/ui/core/message/MessageParser","sap/ui/core/message/Message","sap/base/Log"],function(O,a,c,U,M,b,L){"use strict";var C="sap.ui.model.odata.ODataMessageParser",r=/^\/+|\/$/g,d=c.MessageType,s={"error":d.Error,"info":d.Information,"success":d.Success,"warning":d.Warning};
var e=M.extend("sap.ui.model.odata.ODataMessageParser",{
metadata:{publicMethods:["parse","setProcessor","getHeaderField","setHeaderField"]},
constructor:function(S,m,p){M.apply(this);this._serviceUrl=f(this._parseUrl(S).url);this._metadata=m;this._headerField="sap-message";this._lastMessages=[];this._bPersistTechnicalMessages=p;}
});
e.prototype.getHeaderField=function(){return this._headerField;};
e.prototype.setHeaderField=function(F){this._headerField=F;return this;};
e.prototype.parse=function(R,o,G,m,i){var j,k,S=String(R.statusCode);if(o.method==="GET"&&S==="204"){return;}k={request:o,response:R,url:o.requestUri};if(R.statusCode>=200&&R.statusCode<300){j=this._parseHeader(R,k);}else if(R.statusCode>=400&&R.statusCode<600){try{j=this._parseBody(R,k);this._logErrorMessages(j,o,S);}catch(n){j=this._createGenericError(k);L.error("Request failed with status code "+S+": "+o.method+" "+o.requestUri,n,C);}}else{j=this._createGenericError(k);L.error("Request failed with unsupported status code "+S+": "+o.method+" "+o.requestUri,undefined,C);}if(o.method==="GET"&&S==="424"){return;}this._propagateMessages(j,k,G,m,!i);};
e.prototype._getAffectedTargets=function(m,R,G,i){var A=Object.assign({"":true},G,i),E,j=this._parseUrl(R.url).url;if(R.request.key&&R.request.created){A[R.request.key]=true;}if(j.startsWith(this._serviceUrl)){j=j.slice(this._serviceUrl.length+1);}E=this._metadata._getEntitySetByPath(j);if(E){A[E.name]=true;}m.forEach(function(o){o.getTargets().forEach(function(t){var p,S,T;if(!t){return;}T=t.replace(r,"");A[T]=true;S=T.lastIndexOf("/");if(S>0){p=T.slice(0,S);A[p]=true;}});});return A;};
e.prototype._propagateMessages=function(m,R,G,i,S){var A,D=R.request.deepPath,k=[],j,p=D&&R.request.updateAggregatedMessages,t=R.request.headers&&R.request.headers["sap-messages"]==="transientOnly",n=[],o=O._returnsCollection(R.request.functionMetadata),q,u,v;function w(x,T){return T.some(function(y){return A[y];})||p&&x.aFullTargets.some(function(F){if(o){return j.some(function(K){var y=K.slice(K.indexOf("("));return F.startsWith(D+y);});}else{return F.startsWith(D);}});}G=G||{};if(t){k=this._lastMessages;q=m.some(function(x){return!x.getPersistent()&&!x.getTechnical();});if(q){L.error("Unexpected non-persistent message in response, but requested only "+"transition messages",undefined,C);}}else{A=this._getAffectedTargets(m,R,G,i);j=Object.keys(G);u=R.response.statusCode;v=(u>=200&&u<300);this._lastMessages.forEach(function(x){var T=x.getTargets().map(function(y){y=y.replace(r,"");var P=y.lastIndexOf(")/");if(P>0){y=y.substr(0,P+1);}return y;});if(v||S){if(!x.getPersistent()&&w(x,T)){n.push(x);}else{k.push(x);}}else if(!x.getPersistent()&&x.getTechnical()&&w(x,T)){n.push(x);}else{k.push(x);}});}this.getProcessor().fireMessageChange({oldMessages:n,newMessages:m});this._lastMessages=k.concat(m);};
e.prototype._createMessage=function(m,R,i){var p=m.target&&m.target.indexOf("/#TRANSIENT#")===0||m.transient||m.transition||i&&this._bPersistTechnicalMessages,t,T=typeof m.message==="object"?m.message.value:m.message,j=m["@sap.severity"]||m.severity;m.transition=!!p;t=this._createTargets(m,R,i);return new b({code:m.code||"",description:m.description,descriptionUrl:m.longtext_url||"",fullTarget:t.aDeepPaths,message:T,persistent:!!p,processor:this._processor,target:t.aTargets,technical:i,technicalDetails:{headers:R.response.headers,statusCode:R.response.statusCode},type:s[j]||j});};
e._isResponseForCreate=function(R){var o=R.request,i=R.response;if(o.method==="POST"&&i.statusCode==201&&i.headers["location"]){return true;}if(o.key&&o.created&&i.statusCode>=400){return false;}return undefined;};
e.prototype._createTarget=function(o,R,i,j){var k,m,D,p,P,n,u,q,t,v=R.request,w=R.response;if(o===undefined&&(!i&&v.headers["sap-message-scope"]==="BusinessObject"||i&&j)){return{deepPath:"",target:""};}o=o||"";o=o.startsWith("/#TRANSIENT#")?o.slice(12):o;if(o[0]!=="/"){m=e._isResponseForCreate(R);D=v.deepPath||"";if(m===true){t=w.headers["location"];}else if(m===false){t=v.key;}else{t=R.url;}q=this._parseUrl(t);u=q.url;p=u.indexOf(this._serviceUrl);if(p>-1){n=u.slice(p+this._serviceUrl.length);}else{n="/"+u;}if(!m&&v.functionMetadata){n=v.functionTarget;}if(n.slice(n.lastIndexOf("/")).indexOf("(")>-1||!this._metadata._isCollection(n)){D=o?D+"/"+o:D;o=o?n+"/"+o:n;}else{D=D+o;o=n+o;}}k=this._processor.resolve(o,undefined,true);while(k&&k.lastIndexOf("/")>0&&k!==P){P=k;k=this._processor.resolve(k,undefined,true)||P;}o=k||o;return{deepPath:this._metadata._getReducedPath(D||o),target:a._normalizeKey(o)};};
e.prototype._createTargets=function(m,R,i){var D=[],j=Array.isArray(m.additionalTargets)?[m.target].concat(m.additionalTargets):[m.target],t,T=[],k=this;if(m.propertyref!==undefined&&j[0]!==undefined){L.warning("Used the message's 'target' property for target calculation; the property"+" 'propertyref' is deprecated and must not be used together with 'target'",R.url,C);}else if(j[0]===undefined){j[0]=m.propertyref;}j.forEach(function(A){t=k._createTarget(A,R,i,m.transition);D.push(t.deepPath);T.push(t.target);});return{aDeepPaths:D,aTargets:T};};
e.prototype._parseHeader=function(R,m){var i,k,j,S,F=this.getHeaderField(),n=[];if(!R.headers){return n;}for(k in R.headers){if(k.toLowerCase()===F.toLowerCase()){F=k;}}if(!R.headers[F]){return n;}j=R.headers[F];try{S=JSON.parse(j);n.push(this._createMessage(S,m));if(Array.isArray(S.details)){for(i=0;i<S.details.length;i+=1){n.push(this._createMessage(S.details[i],m));}}}catch(o){L.error("The message string returned by the back-end could not be parsed: '"+o.message+"'");return n;}return n;};
e.prototype._parseBody=function(R,m){var i=g(R);return(i&&i.indexOf("xml")>-1)?this._parseBodyXML(R,m,i):this._parseBodyJSON(R,m);};
e.prototype._createGenericError=function(R){return[this._createMessage({description:R.response.body,message:sap.ui.getCore().getLibraryResourceBundle().getText("CommunicationError"),severity:d.Error,transition:true},R,true)];};
e.prototype._getBodyMessages=function(o,i,R){var j=R.request.headers["Content-ID"],m=[],k=this._createMessage(o,R,true),t=this;i.forEach(function(I){var n=t._createMessage(I,R,true);if(k&&k.getCode()===n.getCode()&&k.getMessage()===n.getMessage()){k=undefined;}if(!j||!I.ContentID||j===I.ContentID){m.push(n);}});if(k){m.unshift(k);}return m;};
e.prototype._logErrorMessages=function(m,R,S){var E=m.length?JSON.stringify(m.map(function(o){return{code:o.getCode(),message:o.getMessage(),persistent:o.getPersistent(),targets:o.getTargets(),type:o.getType()};})):"Another request in the same change set failed";L.error("Request failed with status code "+S+": "+R.method+" "+R.requestUri,E,C);};
e.prototype._parseBodyXML=function(R,j,k){var o,p,E,i,m,n,N,D=new DOMParser().parseFromString(R.body,k),q=h(D,["error","errordetail"]),t=[];if(!q.length){return this._createGenericError(j);}for(i=0;i<q.length;i+=1){N=q[i];E={};E.severity=d.Error;for(n=0;n<N.childNodes.length;n+=1){o=N.childNodes[n];p=o.nodeName;if(p==="errordetails"||p==="details"||p==="innererror"||p==="#text"){continue;}if(p==="message"&&o.hasChildNodes()&&o.firstChild.nodeType!==window.Node.TEXT_NODE){for(m=0;m<o.childNodes.length;m+=1){if(o.childNodes[m].nodeName==="value"){E.message=o.childNodes[m].text||o.childNodes[m].textContent;}}}else{E[o.nodeName]=o.text||o.textContent;}}t.push(E);}return this._getBodyMessages(t[0],t.slice(1),j);};
e.prototype._parseBodyJSON=function(R,m){var i,o,E=JSON.parse(R.body);if(E.error){o=E.error;}else{o=E["odata.error"];}if(!o){L.error("Error message returned by server did not contain error-field");return this._createGenericError(m);}o.severity=d.Error;if(Array.isArray(o.details)){i=o.details;}else if(o.innererror&&Array.isArray(o.innererror.errordetails)){i=o.innererror.errordetails;}else{i=[];}return this._getBodyMessages(o,i,m);};
e.prototype._parseUrl=function(u){var m={url:u,parameters:{},hash:""};var p=-1;p=u.indexOf("#");if(p>-1){m.hash=m.url.substr(p+1);m.url=m.url.substr(0,p);}p=u.indexOf("?");if(p>-1){var P=m.url.substr(p+1);m.parameters=U.parseQuery(P);m.url=m.url.substr(0,p);}return m;};
e.prototype._setPersistTechnicalMessages=function(p){this._bPersistTechnicalMessages=p;};
function g(R){if(R&&R.headers){for(var H in R.headers){if(H.toLowerCase()==="content-type"){return R.headers[H].replace(/([^;]*);.*/,"$1");}}}return false;}
var l=document.createElement("a");
function f(u){l.href=u;return U.parse(l.href).path;}
function h(D,E){var j=[];var m={};for(var i=0;i<E.length;i+=1){m[E[i]]=true;}var o=D;while(o){if(m[o.tagName]){j.push(o);}if(o.hasChildNodes()){o=o.firstChild;}else{while(!o.nextSibling){o=o.parentNode;if(!o||o===D){o=null;break;}}if(o){o=o.nextSibling;}}}return j;}
return e;});
sap.ui.predefine('sap/ui/model/odata/ODataMetaModel',["./_ODataMetaModelUtils","sap/base/Log","sap/base/util/extend","sap/base/util/isEmptyObject","sap/ui/base/BindingParser","sap/ui/base/ManagedObject","sap/ui/base/SyncPromise","sap/ui/model/BindingMode","sap/ui/model/ClientContextBinding","sap/ui/model/Context","sap/ui/model/FilterProcessor","sap/ui/model/MetaModel","sap/ui/model/json/JSONListBinding","sap/ui/model/json/JSONModel","sap/ui/model/json/JSONPropertyBinding","sap/ui/model/json/JSONTreeBinding","sap/ui/performance/Measurement"],function(U,L,e,a,B,M,S,b,C,c,F,d,J,f,g,h,k){"use strict";var m=new Map(),o="sap.ui.model.odata.ODataMetaModel",p=[o],P=o+"/load",r=/^((\/dataServices\/schema\/\d+)\/(?:complexType|entityType)\/\d+)\/property\/\d+$/;var O=J.extend("sap.ui.model.odata.ODataMetaListBinding"),R=M.extend("sap.ui.model.odata._resolver",{metadata:{properties:{any:"any"}}});
O.prototype.applyFilter=function(){var t=this,i=F.combineFilters(this.aFilters,this.aApplicationFilters);this.aIndices=F.apply(this.aIndices,i,function(v,s){return s==="@sapui.name"?v:t.oModel.getProperty(s,t.oList[v]);},this.mNormalizeCache);this.iLength=this.aIndices.length;};
var l=d.extend("sap.ui.model.odata.ODataMetaModel",{constructor:function(i,A,D){var j=D.annotationsLoaded(),t=this;function n(){var q;if(t.bDestroyed){throw new Error("Meta model already destroyed");}k.average(P,"",p);q=JSON.parse(JSON.stringify(i.getServiceMetadata()));t.oModel=new f(q);t.oModel.setDefaultBindingMode(t.sDefaultBindingMode);U.merge(A?A.getAnnotationsData():{},q,t);k.end(P);}d.apply(this);this.oModel=null;this.mContext2Promise={};this.sDefaultBindingMode=b.OneTime;this.oLoadedPromise=j?j.then(n):new Promise(function(q,s){n();q();});this.oLoadedPromiseSync=S.resolve(this.oLoadedPromise);this.oMetadata=i;this.oDataModel=D;this.mQueryCache={};this.mQName2PendingRequest={};this.oResolver=undefined;this.mSupportedBindingModes={"OneTime":true};}});
l.prototype._getObject=function(s,j){var n=j,q,t,i,E,N,v,u,w=s||"",x;if(!j||j instanceof c){w=this.resolve(s||"",j);if(!w){L.error("Invalid relative path w/o context",s,o);return null;}}if(w.charAt(0)==="/"){n=this.oModel._getObject("/");w=w.slice(1);}u="/";N=n;while(w){v=undefined;q=undefined;if(w.charAt(0)==='['){try{x=B.parseExpression(w,1);E=x.at;if(w.length===E+1||w.charAt(E+1)==='/'){q=x.result;v=w.slice(0,E+1);w=w.slice(E+2);}}catch(y){if(!(y instanceof SyntaxError)){throw y;}}}if(v===undefined){E=w.indexOf("/");if(E<0){v=w;w="";}else{v=w.slice(0,E);w=w.slice(E+1);}}if(!N){if(L.isLoggable(L.Level.WARNING,o)){L.warning("Invalid part: "+v,"path: "+s+", context: "+(j instanceof c?j.getPath():j),o);}break;}if(q){if(n===j){L.error("A query is not allowed when an object context has been given",s,o);return null;}if(!Array.isArray(N)){L.error("Invalid query: '"+u+"' does not point to an array",s,o);return null;}t=u+v;v=this.mQueryCache[t];if(v===undefined){this.oResolver=this.oResolver||new R({models:this.oModel});for(i=0;i<N.length;i+=1){this.oResolver.bindObject(u+i);this.oResolver.bindProperty("any",q);try{if(this.oResolver.getAny()){this.mQueryCache[t]=v=i;break;}}finally{this.oResolver.unbindProperty("any");this.oResolver.unbindObject();}}}}N=N[v];u=u+v+"/";}return N;};
l.prototype._getOrCreateSharedModelCache=function(){var D=this.oDataModel;if(!this.oSharedModelCache){this.oSharedModelCache={bFirstCodeListRequested:false,oModel:new D.constructor(D.getCodeListModelParameters())};}return this.oSharedModelCache;};
l.prototype._mergeMetadata=function(i){var E=this.getODataEntityContainer(),j=U.getChildAnnotations(i.annotations,E.namespace+"."+E.name,true),n=E.entitySet.length,s=this.oModel.getObject("/dataServices/schema"),t=this;i.entitySets.forEach(function(q){var u,v,T=q.entityType,N=T.slice(0,T.lastIndexOf("."));if(!t.getODataEntitySet(q.name)){E.entitySet.push(JSON.parse(JSON.stringify(q)));if(!t.getODataEntityType(T)){u=t.oMetadata._getEntityTypeByName(T);v=U.getSchema(s,N);v.entityType.push(JSON.parse(JSON.stringify(u)));U.visitParents(v,i.annotations,"entityType",U.visitEntityType,v.entityType.length-1);}}});U.visitChildren(E.entitySet,j,"EntitySet",s,null,n);};
l.prototype._sendBundledRequest=function(){var q=this.mQName2PendingRequest,Q=Object.keys(q),t=this;if(!Q.length){return;}this.mQName2PendingRequest={};Q=Q.sort();Q.forEach(function(s,i){Q[i]=encodeURIComponent(s);});this.oDataModel.addAnnotationUrl("$metadata?sap-value-list="+Q.join(",")).then(function(i){var s;t._mergeMetadata(i);for(s in q){try{q[s].resolve(i);}catch(E){q[s].reject(E);}}},function(E){var s;for(s in q){q[s].reject(E);}});};
l.prototype.bindContext=function(s,i,j){return new C(this,s,i,j);};
l.prototype.bindList=function(s,i,j,n,q){return new O(this,s,i,j,n,q);};
l.prototype.bindProperty=function(s,i,j){return new g(this,s,i,j);};
l.prototype.bindTree=function(s,i,j,n){return new h(this,s,i,j,n);};
l.prototype.destroy=function(){d.prototype.destroy.apply(this,arguments);if(this.oSharedModelCache){this.oSharedModelCache.oModel.destroy();delete this.oSharedModelCache;}return this.oModel&&this.oModel.destroy.apply(this.oModel,arguments);};
l.prototype.fetchCodeList=function(t){var i=this;return this.oLoadedPromiseSync.then(function(){var s,j,n,q,u,v,w,x,y="com.sap.vocabularies.CodeList.v1."+t,z=i.getODataEntityContainer()[y];if(!z||!z.Url.String){return null;}if(z.Url.String!=="./$metadata"){throw new Error(y+"/Url/String has to be './$metadata' for the service "+i.oDataModel.getCodeListModelParameters().serviceUrl);}q=z.CollectionPath.String;v=i.oDataModel.getMetadataUrl();s=v+"#"+q;w=m.get(s);if(w){return w;}n=i._getOrCreateSharedModelCache();j=n.oModel;x=new S(function(A,D){j.read("/"+q,{error:D,success:A,urlParameters:{$skip:0,$top:5000}});});u=new S(function(A,D){try{A(i._getPropertyNamesForCodeListCustomizing(q));}catch(E){D(E);}});w=S.all([x,u]).then(function(A){var D=A[0].results,E=A[1];return D.reduce(function(G,H){var I=H[E.code],K={Text:H[E.text],UnitSpecificScale:H[E.unitSpecificScale]};if(E.standardCode){K.StandardCode=H[E.standardCode];}if(K.UnitSpecificScale===null){L.error("Ignoring customizing w/o unit-specific scale for code "+I+" from "+q,i.oDataModel.getCodeListModelParameters().serviceUrl,o);}else{G[I]=K;}return G;},{});}).catch(function(E){if(j.bDestroyed){m.delete(s);}else{L.error("Couldn't load code list: "+q+" for "+i.oDataModel.getCodeListModelParameters().serviceUrl,E,o);}throw E;}).finally(function(){if(n.bFirstCodeListRequested){if(!j.bDestroyed){j.destroy();}delete i.oSharedModelCache;}else{n.bFirstCodeListRequested=true;}});m.set(s,w);return w;});};
l.prototype.getMetaContext=function(s){var A,E,i,j,n,N,q,t,Q;function u(v){var w=v.indexOf("(");return w>=0?v.slice(0,w):v;}if(!s){return null;}t=s.split("/");if(t[0]!==""){throw new Error("Not an absolute path: "+s);}t.shift();q=u(t[0]);E=this.getODataEntitySet(q);if(E){Q=E.entityType;}else{j=this.getODataFunctionImport(q);if(j){if(t.length===1){n=this.getODataFunctionImport(q,true);}Q=j.returnType;if(Q.lastIndexOf("Collection(",0)===0){Q=Q.slice(11,-1);}}else{throw new Error("Entity set or function import not found: "+q);}}t.shift();while(t.length){i=this.getODataEntityType(Q);if(i){N=u(t[0]);A=this.getODataAssociationEnd(i,N);}else{i=this.getODataComplexType(Q);}if(A){Q=A.type;if(A.multiplicity==="1"&&N!==t[0]){throw new Error("Multiplicity is 1: "+t[0]);}t.shift();}else{n=this.getODataProperty(i,t,true);if(t.length){throw new Error("Property not found: "+t.join("/"));}break;}}n=n||this.getODataEntityType(Q,true);return this.createBindingContext(n);};
l.prototype.getODataAssociationEnd=function(E,n){var N=E?U.findObject(E.navigationProperty,n):null,A=N?U.getObject(this.oModel,"association",N.relationship):null,i=A?U.findObject(A.end,N.toRole,"role"):null;return i;};
l.prototype.getODataAssociationSetEnd=function(E,n){var A,i=null,j=this.getODataEntityContainer(),N=E?U.findObject(E.navigationProperty,n):null;if(j&&N){A=U.findObject(j.associationSet,N.relationship,"association");i=A?U.findObject(A.end,N.toRole,"role"):null;}return i;};
l.prototype.getODataComplexType=function(q,A){return U.getObject(this.oModel,"complexType",q,A);};
l.prototype.getODataEntityContainer=function(A){var v=A?undefined:null,s=this.oModel.getObject("/dataServices/schema");if(s){s.forEach(function(n,i){var j=U.findIndex(n.entityContainer,"true","isDefaultEntityContainer");if(j>=0){v=A?"/dataServices/schema/"+i+"/entityContainer/"+j:n.entityContainer[j];}});if(!v&&s.length===1&&s[0].entityContainer&&s[0].entityContainer.length===1){v=A?"/dataServices/schema/0/entityContainer/0":s[0].entityContainer[0];}}return v;};
l.prototype.getODataEntitySet=function(n,A){return U.getFromContainer(this.getODataEntityContainer(),"entitySet",n,A);};
l.prototype.getODataEntityType=function(q,A){return U.getObject(this.oModel,"entityType",q,A);};
l.prototype.getODataFunctionImport=function(n,A){var i=n&&n.indexOf('/')>=0?n.split('/'):undefined,E=i?U.getObject(this.oModel,"entityContainer",i[0]):this.getODataEntityContainer();return U.getFromContainer(E,"functionImport",i?i[1]:n,A);};
l.prototype.getODataProperty=function(t,n,A){var i,j=Array.isArray(n)?n:[n],q=null,s;while(t&&j.length){i=U.findIndex(t.property,j[0]);if(i<0){break;}j.shift();q=t.property[i];s=t.$path+"/property/"+i;if(j.length){t=this.getODataComplexType(q.type);}}return A?s:q;};
l.prototype.getODataValueLists=function(i){var j=false,n,s=i.getPath(),q=this.mContext2Promise[s],t=this;if(q){return q;}n=r.exec(s);if(!n){throw new Error("Unsupported property context with path "+s);}q=new Promise(function(u,v){var w=i.getObject(),Q,V=U.getValueLists(w);if(!(""in V)&&w["sap:value-list"]){j=true;Q=t.oModel.getObject(n[2]).namespace+"."+t.oModel.getObject(n[1]).name;t.mQName2PendingRequest[Q+"/"+w.name]={resolve:function(x){e(w,(x.annotations.propertyAnnotations[Q]||{})[w.name]);V=U.getValueLists(w);if(a(V)){v(new Error("No value lists returned for "+s));}else{delete t.mContext2Promise[s];u(V);}},reject:v};setTimeout(t._sendBundledRequest.bind(t),0);}else{u(V);}});if(j){this.mContext2Promise[s]=q;}return q;};
l.prototype.getProperty=function(){return this._getObject.apply(this,arguments);};
l.prototype.isList=function(){return this.oModel.isList.apply(this.oModel,arguments);};
l.prototype.loaded=function(){return this.oLoadedPromise;};
l.prototype.refresh=function(){throw new Error("Unsupported operation: ODataMetaModel#refresh");};
l.prototype.requestCurrencyCodes=function(){return Promise.resolve(this.fetchCodeList("CurrencyCodes"));};
l.prototype.requestUnitsOfMeasure=function(){return Promise.resolve(this.fetchCodeList("UnitsOfMeasure"));};
l.prototype.setLegacySyntax=function(i){if(i){throw new Error("Legacy syntax not supported by ODataMetaModel");}};
l.prototype.setProperty=function(){throw new Error("Unsupported operation: ODataMetaModel#setProperty");};
l.prototype._getPropertyNamesForCodeListCustomizing=function(s){var i="/"+s+"/##",t=this.oDataModel.getObject(i),A=t["Org.OData.Core.V1.AlternateKeys"],K=l._getKeyPath(t,i),j=this.oDataModel.getObject("/"+s+"/"+K+"/##");if(A){if(A.length!==1){throw new Error("Single alternative expected: "+i+"Org.OData.Core.V1.AlternateKeys");}else if(A[0].Key.length!==1){throw new Error("Single key expected: "+i+"Org.OData.Core.V1.AlternateKeys/0/Key");}K=A[0].Key[0].Name.Path;}return{code:K,standardCode:j["com.sap.vocabularies.CodeList.v1.StandardCode"]&&j["com.sap.vocabularies.CodeList.v1.StandardCode"].Path,text:j["com.sap.vocabularies.Common.v1.Text"].Path,unitSpecificScale:j["com.sap.vocabularies.Common.v1.UnitSpecificScale"].Path};};
l._getKeyPath=function(t,T){var K=t.key.propertyRef;if(K&&K.length===1){return K[0].name;}throw new Error("Single key expected: "+T);};
l.getCodeListTerm=function(D){if(D==="/##@@requestCurrencyCodes"){return"CurrencyCodes";}else if(D==="/##@@requestUnitsOfMeasure"){return"UnitsOfMeasure";}return undefined;};
return l;});
sap.ui.predefine('sap/ui/model/odata/ODataMetadata',["./_ODataMetaModelUtils","sap/base/assert","sap/base/Log","sap/base/util/each","sap/base/util/extend","sap/base/util/isEmptyObject","sap/base/util/uid","sap/ui/base/EventProvider","sap/ui/core/cache/CacheManager","sap/ui/thirdparty/datajs"],function(U,a,L,e,b,c,u,E,C,O){"use strict";var s="sap.ui.model.odata.ODataMetadata",S="http://www.sap.com/Protocols/SAPData";
var d=E.extend("sap.ui.model.odata.ODataMetadata",{
constructor:function(m,p){E.apply(this,arguments);this.bLoaded=false;this.bFailed=false;this.mEntityTypes={};this.mRequestHandles={};this.sUrl=m;this.bAsync=p.async;this.sUser=p.user;this.bWithCredentials=p.withCredentials;this.sPassword=p.password;this.mHeaders=p.headers;this.sCacheKey=p.cacheKey;this.oLoadEvent=null;this.oFailedEvent=null;this.oMetadata=null;this.bMessageScopeSupported=false;this.mNamespaces=p.namespaces||{sap:"http://www.sap.com/Protocols/SAPData",m:"http://schemas.microsoft.com/ado/2007/08/dataservices/metadata","":"http://schemas.microsoft.com/ado/2007/06/edmx"};var t=this;this.pLoadedWithReject=new Promise(function(r,f){t.fnResolve=r;t.fnReject=f;});this.pLoaded=this.pLoadedWithReject.catch(function(o){return new Promise(function(r,f){t.fnResolve=r;});});function w(p){C.set(t.sCacheKey,JSON.stringify({metadata:t.oMetadata,params:p}));}function l(o){L.error("[ODataMetadata] initial loading of metadata failed");if(o&&o.message){L.error("Error: "+o.message);}}if(this.sCacheKey){C.get(this.sCacheKey).then(function(M){if(M){var o=JSON.parse(M);this.oMetadata=o.metadata;this._handleLoaded(this.oMetadata,o.params,false);}else{this._loadMetadata().then(w).catch(l);}}.bind(this)).catch(l);}else{this._loadMetadata().catch(l);}},
metadata:{publicMethods:["getServiceMetadata","attachFailed","detachFailed","attachLoaded","detachLoaded","refresh"]}
});
d._returnsCollection=function(f){if(f&&f.returnType&&f.returnType.startsWith("Collection(")){return true;}return false;};
d.prototype._setNamespaces=function(n){this.mNamespaces=n;};
d.prototype._handleLoaded=function(m,p,f){var h=[];this.oMetadata=this.oMetadata?this.merge(this.oMetadata,m,h):m;this.oRequestHandle=null;p.entitySets=h;this.fnResolve(p);if(this.bAsync&&!f){this.fireLoaded(this);}else if(!this.bAsync&&!f){this.bLoaded=true;this.bFailed=false;this.oLoadEvent=setTimeout(this.fireLoaded.bind(this,p),0);}};
d.prototype._loadMetadata=function(f,h){var t=this;f=f||this.sUrl;var r=this._createRequest(f);return new Promise(function(i,j){var R;function _(m,o){if(!m||!m.dataServices){var p={message:"Invalid metadata document",request:r,response:o};k(p);return;}t.sMetadataBody=o.body;t.oRequestHandle=null;var P={metadataString:t.sMetadataBody};var l=o.headers["Last-Modified"];if(l){P.lastModified=l;}var n=o.headers["eTag"];if(n){P.eTag=n;}t._handleLoaded(m,P,h);i(P);}function k(o){var p={message:o.message,request:o.request,response:o.response};if(o.response){p.statusCode=o.response.statusCode;p.statusText=o.response.statusText;p.responseText=o.response.body;}if(R&&R.bSuppressErrorHandlerCall){return;}if(t.bAsync){delete t.mRequestHandles[R.id];}j(p);t.fnReject(p);if(t.bAsync&&!h){t.fireFailed(p);}else if(!t.bAsync&&!h){t.bFailed=true;t.oFailedEvent=setTimeout(t.fireFailed.bind(t,p),0);}}R=O.request(r,_,k,O.metadataHandler);if(t.bAsync){R.id=u();t.mRequestHandles[R.id]=R;}});};
d.prototype.refresh=function(){return this._loadMetadata();};
d.prototype.getServiceMetadata=function(){return this.oMetadata;};
d.prototype.isLoaded=function(){return this.bLoaded;};
d.prototype.loaded=function(r){return r?this.pLoadedWithReject:this.pLoaded;};
d.prototype.isFailed=function(){return this.bFailed;};
d.prototype.fireLoaded=function(p){this.bLoaded=true;this.bFailed=false;this.fireEvent("loaded",p);L.debug(this+" - loaded was fired");return this;};
d.prototype.attachLoaded=function(D,f,l){this.attachEvent("loaded",D,f,l);return this;};
d.prototype.detachLoaded=function(f,l){this.detachEvent("loaded",f,l);return this;};
d.prototype.fireFailed=function(p){this.bFailed=true;this.fireEvent("failed",p);return this;};
d.prototype.attachFailed=function(D,f,l){this.attachEvent("failed",D,f,l);return this;};
d.prototype.detachFailed=function(f,l){this.detachEvent("failed",f,l);return this;};
d.prototype._getEntityAssociationEnd=function(o,n){var f;if(!this._checkMetadataLoaded()){return null;}this._mGetEntityAssociationEndCache=this._mGetEntityAssociationEndCache||{};f=o.namespace+"."+o.name+"/"+n;if(this._mGetEntityAssociationEndCache[f]===undefined){var N=o?U.findObject(o.navigationProperty,n):null,A=N?U.getObject(this.oMetadata.dataServices.schema,"association",N.relationship):null,h=A?U.findObject(A.end,N.toRole,"role"):null;this._mGetEntityAssociationEndCache[f]=h;}return this._mGetEntityAssociationEndCache[f];};
function g(f){var m={};for(var i=0;i<f.length;i++){var o=f[i];if(o.entityContainer){for(var j=0;j<o.entityContainer.length;j++){var h=o.entityContainer[j];if(h.entitySet){for(var k=0;k<h.entitySet.length;k++){if(h.entitySet[k].name!=null){m[h.entitySet[k].name]=h.entitySet[k];}}}}}}return m;}
d.prototype._findEntitySetByName=function(n){if(!this.mEntitySets){this.mEntitySets=g(this.oMetadata.dataServices.schema);}return this.mEntitySets[n];};
d.prototype._getEntityTypeByPath=function(p){if(!p){a(undefined,"sPath not defined!");return null;}if(this.mEntityTypes[p]){return this.mEntityTypes[p];}if(!this._checkMetadataLoaded()){return null;}var f=p.replace(/^\/|\/$/g,""),P=f.split("/"),l=P.length,o,h,j,r,t=this;if(P[0].indexOf("(")!=-1){P[0]=P[0].substring(0,P[0].indexOf("("));}if(l>1){o=t._getEntityTypeByPath(P[0]);for(var i=1;i<P.length;i++){if(o){if(P[i].indexOf("(")!=-1){P[i]=P[i].substring(0,P[i].indexOf("("));}r=t._getEntityTypeByNavProperty(o,P[i]);if(r){o=r;}j=o;}}}else{h=this._splitName(this._getEntityTypeName(P[0]));j=this._getObjectMetadata("entityType",h.name,h.namespace);if(j){j.entityType=this._getEntityTypeName(P[0]);}}if(!j){var F=P[P.length-1];var k=this._getFunctionImportMetadata(F,"GET");if(!k){k=this._getFunctionImportMetadata(F,"POST");}if(k&&k.entitySet){j=Object.assign({},this._getEntityTypeByPath(k.entitySet));if(j){j.entityType=this._getEntityTypeName(k.entitySet);j.isFunction=true;}}}if(j){this.mEntityTypes[p]=j;}return j;};
d.prototype._getEntityTypeByName=function(n){var o,t=this,f,N,h;if(!n){a(undefined,"sName not defined!");return null;}h=this._splitName(n);N=h.namespace;f=h.name;if(!this._checkMetadataLoaded()){return null;}if(this.mEntityTypes[n]){o=this.mEntityTypes[n];}else{e(this.oMetadata.dataServices.schema,function(i,j){if(j.entityType&&(!N||j.namespace===N)){e(j.entityType,function(k,l){if(l.name===f){o=l;t.mEntityTypes[n]=o;o.namespace=j.namespace;return false;}return true;});}});}return o;};
d.prototype._checkMetadataLoaded=function(){if(!this.oMetadata||c(this.oMetadata)){a(undefined,"No metadata loaded!");return false;}return true;};
d.prototype._getAnnotation=function(p){var n,P,m,M,o,f,h;P=p.split('/#');M=P[1].split('/');if(!P[0]){o=this._getEntityTypeByName(M[0]);a(o,M[0]+" is not a valid EntityType");if(!o){return undefined;}f=P[1].substr(P[1].indexOf('/')+1);h=this._getPropertyMetadata(o,f);a(h,f+" is not a valid property path");if(!h){return undefined;}m=f.substr(f.indexOf(h.name));m=m.substr(m.indexOf('/')+1);}else{o=this._getEntityTypeByPath(P[0]);a(o,P[0]+" is not a valid path");if(!o){return undefined;}p=P[0].replace(/^\/|\/$/g,"");f=p;while(!h&&f.indexOf("/")>0){f=f.substr(f.indexOf('/')+1);h=this._getPropertyMetadata(o,f);}a(h,f+" is not a valid property path");if(!h){return undefined;}m=M.join('/');}n=this._getAnnotationObject(o,h,m);return n;};
d.prototype._getAnnotationObject=function(o,f,m){var A,h,j,k,i,n,p;if(!f){return undefined;}n=f;p=m.split('/');if(p[0].indexOf('.')>-1){return this._getV4AnnotationObject(o,f,p);}else if(p.length>1){n=n[p[0]];if(!n&&f.extensions){for(i=0;i<f.extensions.length;i++){k=f.extensions[i];if(k.name==p[0]){n=k;break;}}}m=p.splice(0,1);A=this._getAnnotationObject(o,n,p.join('/'));}else if(p[0].indexOf('@')>-1){h=p[0].substr(1);j=h.split(':');A=n[j[0]];if(!A&&n.extensions){for(i=0;i<n.extensions.length;i++){k=n.extensions[i];if(k.name===j[1]&&k.namespace===this.mNamespaces[j[0]]){A=k.value;break;}}}}else{j=p[0].split(':');A=n[j[0]];A=n[p[0]];if(!A&&n.extensions){for(i=0;i<n.extensions.length;i++){k=n.extensions[i];if(k.name===j[1]&&k.namespace===this.mNamespaces[j[0]]){A=k;break;}}}}return A;};
d.prototype._getV4AnnotationObject=function(o,f,p){var A,h=[];if(p.length>1){a(p.length==1,"'"+p.join('/')+"' is not a valid annotation path");return undefined;}var t=o.namespace?o.namespace+".":"";t+=o.name+"/"+f.name;e(this.oMetadata.dataServices.schema,function(i,j){if(j.annotations){e(j.annotations,function(k,f){if(f.target===t&&!f.qualifier){h.push(f.annotation);return false;}return true;});}});if(h){e(h,function(i,k){e(k,function(j,l){if(l.term===p[0]){A=l;}});});}return A;};
d.prototype._splitName=function(f){var i={};if(f){var h=f.lastIndexOf(".");i.name=f.substr(h+1);i.namespace=f.substr(0,h);}return i;};
d.prototype._getEntityTypeName=function(f){var h,o;if(f){o=this._findEntitySetByName(f);if(o){h=o.entityType;}}return h;};
d.prototype._getObjectMetadata=function(o,f,n){var h;if(f&&n){e(this.oMetadata.dataServices.schema,function(i,k){if(k[o]&&k.namespace===n){e(k[o],function(j,l){if(l.name===f){h=l;h.namespace=k.namespace;return false;}return true;});return!h;}return true;});}return h;};
d.prototype.getUseBatch=function(){var f=false;e(this.oMetadata.dataServices.schema,function(i,o){if(o.entityContainer){e(o.entityContainer,function(k,h){if(h.extensions){e(h.extensions,function(l,j){if(j.name==="use-batch"&&j.namespace==="http://www.sap.com/Protocols/SAPData"){f=(typeof j.value==='string')?(j.value.toLowerCase()==='true'):!!j.value;return false;}return true;});}});}});return f;};
d.prototype._getFunctionImportMetadataIterate=function(f,h){var o=[];e(this.oMetadata.dataServices.schema,function(i,j){if(j["entityContainer"]){e(j["entityContainer"],function(k,l){if(l["functionImport"]){e(l["functionImport"],function(F,m){if(f(m)){o.push(m);if(h){return false;}}return true;});}return!(h&&o.length===1);});}return!(h&&o.length===1);});return o;};
d.prototype._getFirstMatchingFunctionImportMetadata=function(f){var o=this._getFunctionImportMetadataIterate(f,true);return o.length===1?o[0]:null;};
d.prototype._getFunctionImportMetadataByName=function(f){if(f.indexOf("/")>-1){f=f.substr(f.indexOf("/")+1);}return this._getFunctionImportMetadataIterate(function(F){return F.name===f;});};
d.prototype._getFunctionImportMetadata=function(f,m){if(f.indexOf("/")>-1){f=f.substr(f.indexOf("/")+1);}return this._getFirstMatchingFunctionImportMetadata(function(F){return F.name===f&&F.httpMethod===m;});};
d.prototype._getEntityTypeByNavProperty=function(m,n){if(!m.navigationProperty){return undefined;}for(var i=0;i<m.navigationProperty.length;++i){var N=m.navigationProperty[i];if(N.name===n){return this._getEntityTypeByNavPropertyObject(N);}}return undefined;};
d.prototype._getEntityTypeByNavPropertyObject=function(n){var t;var A=this._splitName(n.relationship);var m=this._getObjectMetadata("association",A.name,A.namespace);if(m){var f=m.end[0];if(f.role!==n.toRole){f=m.end[1];}var o=this._splitName(f.type);t=this._getObjectMetadata("entityType",o.name,o.namespace);if(t){t.entityType=f.type;}}return t;};
d.prototype._getNavigationPropertyNames=function(o){var n=[];if(o.navigationProperty){e(o.navigationProperty,function(k,N){n.push(N.name);});}return n;};
d.prototype._getNavPropertyRefInfo=function(o,p){var n,A,f,h,P,D,j,r,k,l,K,t=this;e(o.navigationProperty,function(i,N){f=t._splitName(N.relationship);A=t._getObjectMetadata("association",f.name,f.namespace);if(!A||!A.referentialConstraint){return;}D=A.referentialConstraint.dependent;k=A.end.find(function(k){return k.role===D.role;});if(k.type!==o.namespace+"."+o.name){return;}j=D.propertyRef.some(function(m){return m.name===p;});if(!j){return;}P=A.referentialConstraint.principal;r=P.role;h=t._getAssociationSetByAssociation(N.relationship);k=h.end.find(function(k){return k.role===r;});l=k.entitySet;K=P.propertyRef.map(function(m){return m.name;});n={name:N.name,entitySet:l,keys:K};});return n;};
d.prototype._getPropertyMetadata=function(o,p){var P,t=this;if(!o){return undefined;}p=p.replace(/^\/|\/$/g,"");var f=p.split("/");e(o.property,function(k,h){if(h.name===f[0]){P=h;return false;}return true;});if(f.length>1){if(!P){while(o&&f.length>1){o=this._getEntityTypeByNavProperty(o,f[0]);f.shift();}if(o){P=t._getPropertyMetadata(o,f[0]);}}else if(!P.type.toLowerCase().startsWith("edm.")){var n=this._splitName(P.type);P=this._getPropertyMetadata(this._getObjectMetadata("complexType",n.name,n.namespace),f[1]);}}return P;};
d.prototype.destroy=function(){delete this.oMetadata;var t=this;e(this.mRequestHandles,function(k,r){r.bSuppressErrorHandlerCall=true;r.abort();delete t.mRequestHandles[k];});if(this.oLoadEvent){clearTimeout(this.oLoadEvent);}if(this.oFailedEvent){clearTimeout(this.oFailedEvent);}E.prototype.destroy.apply(this,arguments);};
d.prototype._fillElementCaches=function(){var t=this;if(this._entitySetMap||!this._checkMetadataLoaded()){return;}this._entitySetMap={};this.oMetadata.dataServices.schema.forEach(function(m){(m.entityContainer||[]).forEach(function(f){(f.entitySet||[]).forEach(function(h){var o=t._getEntityTypeByName(h.entityType);o.__navigationPropertiesMap={};(o.navigationProperty||[]).forEach(function(p){o.__navigationPropertiesMap[p.name]=p;});h.__entityType=o;t._entitySetMap[h.entityType]=h;});});});};
d.prototype._createRequest=function(f){var D={"sap-cancel-on-close":true},l={"Accept-Language":sap.ui.getCore().getConfiguration().getLanguageTag()};b(D,this.mHeaders,l);var r={headers:D,requestUri:f,method:'GET',user:this.sUser,password:this.sPassword,async:this.bAsync};if(this.bAsync){r.withCredentials=this.bWithCredentials;}return r;};
d.prototype._getEntitySetByPath=function(f){var o;this._fillElementCaches();o=this._getEntityTypeByPath(f);return o&&this._entitySetMap[o.entityType];};
d.prototype._addUrl=function(v){var f=[].concat(v);return Promise.all(f.map(function(h){return this._loadMetadata(h,true);},this));};
d.prototype.merge=function(t,f,h){var m=this;if(this.mEntitySets){delete this.mEntitySets;}e(t.dataServices.schema,function(i,T){e(f.dataServices.schema,function(j,n){if(n.namespace===T.namespace){if(n.entityType){if(!m.mEntityTypeNames){m.mEntityTypeNames={};T.entityType.map(function(o){m.mEntityTypeNames[o.name]=true;});}T.entityType=!T.entityType?[]:T.entityType;for(var i=0;i<n.entityType.length;i++){if(!(n.entityType[i].name in m.mEntityTypeNames)){T.entityType.push(n.entityType[i]);m.mEntityTypeNames[n.entityType[i].name]=true;}}}if(T.entityContainer&&n.entityContainer){e(T.entityContainer,function(k,p){e(n.entityContainer,function(l,q){if(q.entitySet){if(q.name===p.name){if(!m.mEntitySetNames){m.mEntitySetNames={};p.entitySet.map(function(o){m.mEntitySetNames[o.name]=true;});}p.entitySet=!p.entitySet?[]:p.entitySet;for(var i=0;i<q.entitySet.length;i++){if(!(q.entitySet[i].name in m.mEntitySetNames)){p.entitySet.push(q.entitySet[i]);m.mEntitySetNames[q.entitySet[i].name]=true;}}q.entitySet.forEach(function(o){h.push(o);});}}});});}if(n.annotations){T.annotations=!T.annotations?[]:T.annotations;T.annotations=T.annotations.concat(n.annotations);}}});});return t;};
d.prototype._getEntitySetByType=function(f){var h=f.namespace+"."+f.name;var j=this.oMetadata.dataServices.schema;for(var i=0;i<j.length;++i){var k=j[i].entityContainer;if(k){for(var n=0;n<k.length;++n){var l=k[n].entitySet;if(l){for(var m=0;m<l.length;++m){if(l[m].entityType===h){return l[m];}}}}}}return null;};
d.prototype._calculateCanonicalPath=function(p){var f,i,P,t;if(p){i=p.lastIndexOf(")");if(i!==-1){t=p.substr(0,i+1);var o=this._getEntitySetByPath(t);if(o){if(o.__entityType.isFunction){f=p;}else{P=p.split("/");if(t==="/"+P[1]){if(!(P[2]in o.__entityType.__navigationPropertiesMap)){f=p;}}else{P=t.split("/");t='/'+o.name+P[P.length-1].substr(P[P.length-1].indexOf("("))+p.substr(i+1);if(t!==p){f=t;}}}}}}return f;};
d.prototype._getAssociationSetByAssociation=function(A){var f=this.oMetadata.dataServices.schema;for(var i=0;i<f.length;++i){var h=f[i].entityContainer;if(h){for(var n=0;n<h.length;++n){var j=h[n].associationSet;if(j){for(var m=0;m<j.length;++m){if(j[m].association===A){return j[m];}}}}}}return null;};
d.prototype._isMessageScopeSupported=function(){var f=this.oMetadata.dataServices.schema,o,h;if(!this.bMessageScopeSupported&&f){for(var i=0;i<f.length;++i){h=f[i].entityContainer;if(h){for(var n=0;n<h.length;++n){o=h[n];if(o.extensions&&Array.isArray(o.extensions)){for(var m=0;m<o.extensions.length;++m){if(o.extensions[m].name==="message-scope-supported"&&o.extensions[m].namespace===this.mNamespaces.sap){if(o.extensions[m].value==="true"){this.bMessageScopeSupported=true;break;}}}}}}}}return this.bMessageScopeSupported;};
d.prototype._isCollection=function(p){var f=false;var i=p.lastIndexOf("/");if(i>0){var h=p.substring(0,i);var o=this._getEntityTypeByPath(h);if(o){var A=this._getEntityAssociationEnd(o,p.substring(i+1));if(A&&A.multiplicity==="*"){f=true;}}}else{f=true;}return f;};
d.prototype._getReducedPath=function(p){var A,i,k,n,N,o,f,h=p.split("/"),j;if(h.length<4){return p;}this._fillElementCaches();for(i=1;i<h.length-2;i+=1){j=this._getEntityTypeByPath(h.slice(0,i+1).join('/'));N=j&&j.__navigationPropertiesMap[h[i+1].split("(")[0]];if(!N){continue;}f=h[i+2].split("(")[0];n=this._getEntityTypeByNavPropertyObject(N);o=n&&n.__navigationPropertiesMap[f];if(!o||N.relationship!==o.relationship){continue;}k=h[i+2].slice(f.length);A=this._getEntityAssociationEnd(n,f);if(A.multiplicity!=="*"||k&&h[i].endsWith(k)){h.splice(i+1,2);return this._getReducedPath(h.join("/"));}}return h.join("/");};
d.prototype.getKeyPropertyNamesByPath=function(p){var A,o,i=p.lastIndexOf("/");if(i>0){o=this._getEntityTypeByPath(p.slice(0,i));if(o){A=this._getEntityAssociationEnd(o,p.slice(i+1).split("(")[0]);o=A?this._getEntityTypeByName(A.type):undefined;}}else{o=this._getEntityTypeByPath(p);}return o&&o.key.propertyRef.map(function(k){return k.name;});};
d.prototype._getCanonicalPathOfFunctionImport=function(f,F){var A,m,h,i,k,p,P,j=f.extensions,l=f.returnType,I="",n=false;if(j){for(i=0;i<j.length;i+=1){if(j[i].name==="action-for"){A=j[i].value;break;}}}if(d._returnsCollection(f)){n=true;l=l.slice(11,-1);}if(A){h=this._getEntityTypeByName(A);}else if(f.entitySet){h=this._getEntityTypeByPath(f.entitySet);}else if(l){h=this._getEntityTypeByName(l);}if(h){m=this._getEntitySetByType(h);if(m&&h.key&&h.key.propertyRef){if(n){return"/"+m.name;}P=h.key.propertyRef;if(P.length===1){p=P[0].name;if(F[p]){I=F[p];}}else{k=[];for(i=0;i<P.length;i+=1){p=P[i].name;if(F[p]){k.push(p+"="+F[p]);}}I=k.join(",");}return"/"+m.name+"("+I+")";}else if(!m){L.error("Cannot determine path of the entity set for the function import '"+f.name+"'",this,s);}else{L.error("Cannot determine keys of the entity type '"+h.entityType+"' for the function import '"+f.name+"'",this,s);}}return"";};
d.prototype._splitByLastNavigationProperty=function(p){var o,i,k,l,f,h=p.split("/"),F="/"+h[1],j=h.length;this._fillElementCaches();o=this._getEntityTypeByPath(F);for(i=2;i<j;i+=1){f=h[i];k=f.indexOf("(");if(k!==-1){f=f.slice(0,k);}if(o&&o.__navigationPropertiesMap[f]){l=i;o=this._getEntityTypeByNavProperty(o,f);}else{break;}}if(l===undefined){return{pathBeforeLastNavigationProperty:p,lastNavigationProperty:"",addressable:true,pathAfterLastNavigationProperty:""};}return{pathBeforeLastNavigationProperty:h.slice(0,l).join("/"),lastNavigationProperty:"/"+h[l],addressable:this._isAddressable(o),pathAfterLastNavigationProperty:(l+1)>=j?"":("/"+h.slice(l+1).join("/"))};};
d.prototype._isAddressable=function(o){var f;if(!o){return true;}f=this._entitySetMap[o.entityType];if(!f||!f.extensions){return true;}return!f.extensions.some(function(h){return h.name==="addressable"&&h.namespace===S&&h.value==="false";});};
return d;});
sap.ui.predefine('sap/ui/model/odata/ODataModel',["./CountMode","./ODataContextBinding","./ODataListBinding","./ODataMetadata","./ODataPropertyBinding","./ODataTreeBinding","./ODataUtils","sap/base/assert","sap/base/Log","sap/base/security/encodeURL","sap/base/util/each","sap/base/util/extend","sap/base/util/isEmptyObject","sap/base/util/isPlainObject","sap/base/util/merge","sap/base/util/uid","sap/ui/model/BindingMode","sap/ui/model/Context","sap/ui/model/FilterProcessor","sap/ui/model/Model","sap/ui/model/odata/ODataAnnotations","sap/ui/model/odata/ODataMetaModel","sap/ui/thirdparty/datajs","sap/ui/thirdparty/URI"],function(C,O,a,b,c,d,e,f,L,g,h,m,n,o,p,u,B,q,F,M,r,s,t,U){"use strict";
var v=M.extend("sap.ui.model.odata.ODataModel",{
constructor:function(S,j,i,P,H,T,w,l){M.apply(this,arguments);var k,R,x,A=null,y,z,D,E,G,I,J=this;if(typeof(S)==="object"){j=S;S=j.serviceUrl;}if(typeof j==="object"){i=j.user;P=j.password;H=j.headers;T=j.tokenHandling;l=j.loadMetadataAsync;w=j.withCredentials;x=j.maxDataServiceVersion;k=j.useBatch;R=j.refreshAfterChange;A=j.annotationURI;y=j.loadAnnotationsJoined;D=j.defaultCountMode;z=j.metadataNamespaces;E=j.serviceUrlParams;G=j.metadataUrlParams;I=j.skipMetadataAnnotationParsing;j=j.json;}this.oServiceData={};this.sDefaultBindingMode=B.OneWay;this.mSupportedBindingModes={"OneWay":true,"OneTime":true,"TwoWay":true};this.mUnsupportedFilterOperators={"Any":true,"All":true};this.bCountSupported=true;this.bJSON=j;this.bCache=true;this.aPendingRequestHandles=[];this.oRequestQueue={};this.aBatchOperations=[];this.oHandler=undefined;this.bTokenHandling=T!==false;this.bWithCredentials=w===true;this.bUseBatch=k===true;this.bRefreshAfterChange=R!==false;this.sMaxDataServiceVersion=x;this.bLoadMetadataAsync=!!l;this.bLoadAnnotationsJoined=y===undefined?true:y;this.sAnnotationURI=A;this.sDefaultCountMode=D||C.Both;this.oMetadataLoadEvent=null;this.oMetadataFailedEvent=null;this.bSkipMetadataAnnotationParsing=I;this.oHeaders={};this.setHeaders(H);this.oData={};this.oMetadata=null;this.oAnnotations=null;this.aUrlParams=[];if(S.indexOf("?")==-1){this.sServiceUrl=S;}else{var K=S.split("?");this.sServiceUrl=K[0];if(K[1]){this.aUrlParams.push(K[1]);}}if(sap.ui.getCore().getConfiguration().getStatistics()){this.aUrlParams.push("sap-statistics=true");}this.sServiceUrl=this.sServiceUrl.replace(/\/$/,"");var N=this._createRequestUrl("$metadata",undefined,G);if(!v.mServiceData[N]){v.mServiceData[N]={};}this.oServiceData=v.mServiceData[N];if(this.bTokenHandling&&this.oServiceData.securityToken){this.oHeaders["x-csrf-token"]=this.oServiceData.securityToken;}this.sUser=i;this.sPassword=P;this.oHeaders["Accept-Language"]=sap.ui.getCore().getConfiguration().getLanguageTag();if(!this.oServiceData.oMetadata){this.oServiceData.oMetadata=new b(N,{async:this.bLoadMetadataAsync,user:this.sUser,password:this.sPassword,headers:this.mCustomHeaders,namespaces:z,withCredentials:this.bWithCredentials});}this.oMetadata=this.oServiceData.oMetadata;this.pAnnotationsLoaded=this.oMetadata.loaded();if(this.sAnnotationURI||!this.bSkipMetadataAnnotationParsing){var Q=this._getAnnotationParser();if(!this.bSkipMetadataAnnotationParsing){if(!this.bLoadMetadataAsync){this.addAnnotationXML(this.oMetadata.sMetadataBody,!!this.sAnnotationURI);}else{this.pAnnotationsLoaded=this.oMetadata.loaded().then(function(V,W){if(this.bDestroyed){return Promise.reject();}return this.addAnnotationXML(W["metadataString"],V);}.bind(this,!!this.sAnnotationURI));}}if(this.sAnnotationURI){if(this.bLoadMetadataAsync){this.pAnnotationsLoaded=this.pAnnotationsLoaded.then(Q.addUrl.bind(Q,this.sAnnotationURI));}else{this.pAnnotationsLoaded=Promise.all([this.pAnnotationsLoaded,Q.addUrl(this.sAnnotationURI)]);}}}if(E){this.aUrlParams=this.aUrlParams.concat(e._createUrlParamsArray(E));}this.onMetadataLoaded=function(V){J._initializeMetadata();J.initialize();};this.onMetadataFailed=function(V){J.fireMetadataFailed(V.getParameters());};if(!this.oMetadata.isLoaded()){this.oMetadata.attachLoaded(this.onMetadataLoaded);this.oMetadata.attachFailed(this.onMetadataFailed);}if(this.oMetadata.isFailed()){this.refreshMetadata();}if(this.oMetadata.isLoaded()){this._initializeMetadata(true);}if(this.bJSON){if(this.sMaxDataServiceVersion==="3.0"){this.oHeaders["Accept"]="application/json;odata=fullmetadata";}else{this.oHeaders["Accept"]="application/json";}this.oHandler=t.jsonHandler;}else{this.oHeaders["Accept"]="application/atom+xml,application/atomsvc+xml,application/xml";this.oHandler=t.atomHandler;}this.oHeaders["MaxDataServiceVersion"]="2.0";if(this.sMaxDataServiceVersion){this.oHeaders["MaxDataServiceVersion"]=this.sMaxDataServiceVersion;}this.oHeaders["DataServiceVersion"]="2.0";},
metadata:{publicMethods:["create","remove","update","submitChanges","getServiceMetadata","read","hasPendingChanges","refresh","refreshMetadata","resetChanges","isCountSupported","setCountSupported","setDefaultCountMode","getDefaultCountMode","forceNoCache","setProperty","getSecurityToken","refreshSecurityToken","setHeaders","getHeaders","setUseBatch"]}
});
v.M_EVENTS={RejectChange:"rejectChange",MetadataLoaded:"metadataLoaded",MetadataFailed:"metadataFailed",AnnotationsLoaded:"annotationsLoaded",AnnotationsFailed:"annotationsFailed"};v.mServiceData={};
v.prototype.fireRejectChange=function(P){this.fireEvent("rejectChange",P);return this;};
v.prototype.attachRejectChange=function(D,i,l){this.attachEvent("rejectChange",D,i,l);return this;};
v.prototype.detachRejectChange=function(i,l){this.detachEvent("rejectChange",i,l);return this;};
v.prototype._initializeMetadata=function(D){var i=this;this.bUseBatch=this.bUseBatch||this.oMetadata.getUseBatch();var j=function(k){if(k){i.metadataLoadEvent=setTimeout(j.bind(i),0);}else if(i.oMetadata){i.fireMetadataLoaded({metadata:i.oMetadata});L.debug("ODataModel fired metadataloaded");}};if(this.sAnnotationURI&&this.bLoadAnnotationsJoined){if(this.oAnnotations&&(this.oAnnotations.bInitialized||this.oAnnotations.isFailed())){j(!this.bLoadMetadataAsync);}else{this.oAnnotations.attachEventOnce("loaded",function(){j(true);});}}else{j(D);}};
v.prototype.fireAnnotationsLoaded=function(P){if(!this.bLoadMetadataAsync){setTimeout(this.fireEvent.bind(this,"annotationsLoaded",P),0);}else{this.fireEvent("annotationsLoaded",P);}return this;};
v.prototype.attachAnnotationsLoaded=function(D,i,l){this.attachEvent("annotationsLoaded",D,i,l);return this;};
v.prototype.detachAnnotationsLoaded=function(i,l){this.detachEvent("annotationsLoaded",i,l);return this;};
v.prototype.fireAnnotationsFailed=function(P){if(!this.bLoadMetadataAsync){setTimeout(this.fireEvent.bind(this,"annotationsFailed",P),0);}else{this.fireEvent("annotationsFailed",P);}L.debug("ODataModel fired annotationsFailed");return this;};
v.prototype.attachAnnotationsFailed=function(D,i,l){this.attachEvent("annotationsFailed",D,i,l);return this;};
v.prototype.detachAnnotationsFailed=function(i,l){this.detachEvent("annotationsFailed",i,l);return this;};
v.prototype.fireMetadataLoaded=function(P){this.fireEvent("metadataLoaded",P);return this;};
v.prototype.attachMetadataLoaded=function(D,i,l){this.attachEvent("metadataLoaded",D,i,l);return this;};
v.prototype.detachMetadataLoaded=function(i,l){this.detachEvent("metadataLoaded",i,l);return this;};
v.prototype.fireMetadataFailed=function(P){this.fireEvent("metadataFailed",P);return this;};
v.prototype.attachMetadataFailed=function(D,i,l){this.attachEvent("metadataFailed",D,i,l);return this;};
v.prototype.detachMetadataFailed=function(i,l){this.detachEvent("metadataFailed",i,l);return this;};
v.prototype.refreshMetadata=function(){if(this.oMetadata&&this.oMetadata.refresh){this.oMetadata.refresh();}};
v.prototype._createRequestUrl=function(P,i,j,k,l){var w,R,x,y="";if(P&&P.indexOf('?')!=-1){x=P.substr(P.indexOf('?')+1);P=P.substr(0,P.indexOf('?'));}R=this._normalizePath(P,i);if(!k){y=this.sServiceUrl+R;}else{y=R.substr(R.indexOf('/')+1);}w=e._createUrlParamsArray(j);if(this.aUrlParams){w=w.concat(this.aUrlParams);}if(x){w.push(x);}if(w.length>0){y+="?"+w.join("&");}if(l===undefined){l=true;}if(l===false){var z=Date.now();var A=y.replace(/([?&])_=[^&]*/,"$1_="+z);y=A+((A===y)?(/\?/.test(y)?"&":"?")+"_="+z:"");}return y;};
v.prototype._loadData=function(P,i,S,E,j,H,k){var R,l=[],w=this._createRequestUrl(P,null,i,null,j||this.bCache),x=this._createRequest(w,"GET",true),y=this;function _(D,G){var I=D,J={};if(G.statusCode==204){if(S){S(null);}if(k){k(null);}y.fireRequestCompleted({url:x.requestUri,type:"GET",async:x.async,info:"Accept headers:"+y.oHeaders["Accept"],infoObject:{acceptHeaders:y.oHeaders["Accept"]},success:true});return undefined;}if(!I){L.fatal("The following problem occurred: No data was retrieved by service: "+G.requestUri);y.fireRequestCompleted({url:x.requestUri,type:"GET",async:x.async,info:"Accept headers:"+y.oHeaders["Accept"],infoObject:{acceptHeaders:y.oHeaders["Accept"]},success:false});return false;}if(y.bUseBatch){var K=y._getBatchErrors(D);if(K.length>0){z(K[0]);return false;}if(I.__batchResponses&&I.__batchResponses.length>0){I=I.__batchResponses[0].data;}else{L.fatal("The following problem occurred: No data was retrieved by service: "+G.requestUri);}}l=l.concat(I.results);if(I.__next){var N=new U(I.__next);x.requestUri=N.absoluteTo(G.requestUri).toString();A(x);}else{if(I.results){var V,Q;for(Q in l){V=l[Q];if(l===V){continue;}I.results[Q]=V;}}if(I.results&&!Array.isArray(I.results)){I=I.results;}y._importData(I,J);if(y.sChangeKey&&J){var T=y.sChangeKey.substr(y.sChangeKey.lastIndexOf('/')+1);if(J[T]){delete y.oRequestQueue[y.sChangeKey];y.sChangeKey=null;}}if(S){S(I);}y.checkUpdate(false,false,J);if(k){k(I);}y.fireRequestCompleted({url:x.requestUri,type:"GET",async:x.async,info:"Accept headers:"+y.oHeaders["Accept"],infoObject:{acceptHeaders:y.oHeaders["Accept"]},success:true});}return undefined;}function z(D){if(y.bTokenHandling&&D.response){var T=y._getHeader("x-csrf-token",D.response.headers);if(!x.bTokenReset&&D.response.statusCode=='403'&&T&&T.toLowerCase()=="required"){y.resetSecurityToken();x.bTokenReset=true;A();return;}}var G=y._handleError(D);if(E){E(D,R&&R.bAborted);}y.fireRequestCompleted({url:x.requestUri,type:"GET",async:x.async,info:"Accept headers:"+y.oHeaders["Accept"],infoObject:{acceptHeaders:y.oHeaders["Accept"]},success:false,errorobject:G});if(!R||!R.bAborted){G.url=x.requestUri;y.fireRequestFailed(G);}}function A(){if(y.bUseBatch){y.updateSecurityToken();var D=U.parse(x.requestUri).query;var G=y._createRequestUrl(P,null,D,y.bUseBatch);x=y._createRequest(G,"GET",true);if(y.bTokenHandling){delete x.headers["x-csrf-token"];}var I=y._createBatchRequest([x],true);R=y._request(I,_,z,t.batchHandler,undefined,y.getServiceMetadata());}else{R=y._request(x,_,z,y.oHandler,undefined,y.getServiceMetadata());}if(H){var W={abort:function(){R.bAborted=true;R.abort();}};H(W);}}if(y.bTokenHandling){delete x.headers["x-csrf-token"];}this.fireRequestSent({url:x.requestUri,type:"GET",async:x.async,info:"Accept headers:"+this.oHeaders["Accept"],infoObject:{acceptHeaders:this.oHeaders["Accept"]}});A();};
v.prototype._importData=function(D,k){var j=this,l,K,R,E;if(D.results){l=[];h(D.results,function(i,w){l.push(j._importData(w,k));});return l;}else{K=this._getKey(D);E=this.oData[K];if(!E){E=D;this.oData[K]=E;}h(D,function(N,P){if(P&&(P.__metadata&&P.__metadata.uri||P.results)&&!P.__deferred){R=j._importData(P,k);if(Array.isArray(R)){E[N]={__list:R};}else{E[N]={__ref:R};}}else if(!P||!P.__deferred){E[N]=P;}});k[K]=true;return K;}};
v.prototype._removeReferences=function(D){var j=this,l;if(D.results){l=[];h(D.results,function(i,k){l.push(j._removeReferences(k));});return l;}else{h(D,function(P,i){if(i){if(i["__ref"]||i["__list"]){delete D[P];}}});return D;}};
v.prototype._restoreReferences=function(D){var k=this,l,R=[];if(D.results){l=[];h(D.results,function(i,j){l.push(k._restoreReferences(j));});return l;}else{h(D,function(P,i){if(i&&i["__ref"]){var w=k._getObject("/"+i["__ref"]);f(w,"ODataModel inconsistent: "+i["__ref"]+" not found!");if(w){delete i["__ref"];D[P]=w;k._restoreReferences(w);}}else if(i&&i["__list"]){h(i["__list"],function(j,E){var w=k._getObject("/"+i["__list"][j]);f(w,"ODataModel inconsistent: "+i["__list"][j]+" not found!");if(w){R.push(w);k._restoreReferences(w);}});delete i["__list"];i.results=R;R=[];}});return D;}};
v.prototype.removeData=function(){this.oData={};};
v.prototype.initialize=function(){var i=this.getBindings();h(i,function(I,j){j.initialize();});};
v.prototype.refresh=function(i,R){if(R){this.removeData();}this._refresh(i);};
v.prototype._refresh=function(i,j,E){var k=this.getBindings();h(k,function(I,l){l.refresh(i,j,E);});};
v.prototype.checkUpdate=function(i,A,j,k){if(A){if(!this.sUpdateTimer){this.sUpdateTimer=setTimeout(function(){this.checkUpdate(i,false,j);}.bind(this),0);}return;}if(this.sUpdateTimer){clearTimeout(this.sUpdateTimer);this.sUpdateTimer=null;}var l=this.getBindings();h(l,function(I,w){if(!k||this.isMetaModelPath(w.getPath())){w.checkUpdate(i,j);}}.bind(this));};
v.prototype.bindProperty=function(P,i,j){var k=new c(this,P,i,j);return k;};
v.prototype.bindList=function(P,i,S,j,k){var l=new a(this,P,i,S,j,k);return l;};
v.prototype.bindTree=function(P,i,j,k){var l=new d(this,P,i,j,k);return l;};
v.prototype.createBindingContext=function(P,i,j,k,R){var l=this.resolve(P,i);R=!!R;if(typeof i=="function"){k=i;i=null;}if(typeof j=="function"){k=j;j=null;}if(!l){if(k){k(null);}return null;}var D=this._getObject(P,i),K,N,w=this;if(!R){R=this._isReloadNeeded(l,D,j);}if(!R){K=this._getKey(D);N=this.getContext('/'+K);if(k){k(N);}return N;}if(k){var I=!P.startsWith("/");if(l){var x=[],y=this.createCustomParams(j);if(y){x.push(y);}this._loadData(l,x,function(D){K=D?w._getKey(D):undefined;if(K&&i&&I){var z=i.getPath();z=z.substr(1);if(w.oData[z]){w.oData[z][P]={__ref:K};}}N=w.getContext('/'+K);k(N);},function(){k(null);});}else{k(null);}}return undefined;};
v.prototype._isReloadNeeded=function(j,D,P){var k,i,N,l,R,S,w=[],x=[];if(!j){return false;}if(!D){return true;}if(P&&P["expand"]){N=P["expand"].replace(/\s/g,"");w=N.split(',');}if(w){for(i=0;i<w.length;i++){var y=w[i].indexOf("/");if(y!==-1){var z=w[i].slice(0,y);var A=w[i].slice(y+1);w[i]=[z,A];}}}for(i=0;i<w.length;i++){var E=w[i];if(Array.isArray(E)){var G=D[E[0]];var H=E[1];if(!G||(G&&G.__deferred)){return true;}else if(G){if(G.__list&&G.__list.length>0){for(var I=0;I<G.__list.length;I++){l="/"+G.__list[I];k=this.getObject(l);R=this._isReloadNeeded(l,k,{expand:H});if(R){return true;}}}else if(G.__ref){l="/"+G.__ref;k=this.getObject(l);R=this._isReloadNeeded(l,k,{expand:H});if(R){return true;}}}}else if(D[E]===undefined||(D[E]&&D[E].__deferred)){return true;}}if(P&&P["select"]){S=P["select"].replace(/\s/g,"");x=S.split(',');}for(i=0;i<x.length;i++){if(D[x[i]]===undefined){return true;}}if(x.length==0){var J=this.oMetadata._getEntityTypeByPath(j);if(!J){return false;}else{for(i=0;i<J.property.length;i++){if(D[J.property[i].name]===undefined){return true;}}}}return false;};
v.prototype.destroyBindingContext=function(i){};
v.prototype.createCustomParams=function(P){var N,i,j=[],k,S={expand:true,select:true};for(i in P){if(i in S){j.push("$"+i+"="+g(P[i]));}if(i=="custom"){k=P[i];for(N in k){if(N.indexOf("$")==0){L.warning("Trying to set OData parameter "+N+" as custom query option!");}else{j.push(N+"="+g(k[N]));}}}}return j.join("&");};
v.prototype.bindContext=function(P,i,j){var k=new O(this,P,i,j);return k;};
v.prototype.setCountSupported=function(i){this.bCountSupported=i;};
v.prototype.isCountSupported=function(){return this.bCountSupported;};
v.prototype.setDefaultCountMode=function(i){this.sDefaultCountMode=i;};
v.prototype.getDefaultCountMode=function(){return this.sDefaultCountMode;};
v.prototype._getKey=function(i,D){var k,j;if(i instanceof q){k=i.getPath().substr(1);}else if(i&&i.__metadata&&i.__metadata.uri){j=i.__metadata.uri;k=j.substr(j.lastIndexOf("/")+1);}if(D){k=decodeURIComponent(k);}return k;};
v.prototype.getKey=function(i,D){return this._getKey(i,D);};
v.prototype.createKey=function(j,k,D){var E=this.oMetadata._getEntityTypeByPath(j),K=j,l=this,N,V,P;f(E,"Could not find entity type of collection \""+j+"\" in service metadata!");K+="(";if(E.key.propertyRef.length==1){N=E.key.propertyRef[0].name;f(N in k,"Key property \""+N+"\" is missing in object!");P=this.oMetadata._getPropertyMetadata(E,N);V=e.formatValue(k[N],P.type);K+=D?V:encodeURIComponent(V);}else{h(E.key.propertyRef,function(i,w){if(i>0){K+=",";}N=w.name;f(N in k,"Key property \""+N+"\" is missing in object!");P=l.oMetadata._getPropertyMetadata(E,N);V=e.formatValue(k[N],P.type);K+=N;K+="=";K+=D?V:encodeURIComponent(V);});}K+=")";return K;};
v.prototype.getProperty=function(P,i,I){var V=this._getObject(P,i);if(I==null||I==undefined){return V;}if(!o(V)){return V;}V=p({},V);if(I==true){return this._restoreReferences(V);}else{return this._removeReferences(V);}};
v.prototype._getObject=function(P,i){var N=this.isLegacySyntax()?this.oData:null,R=this.resolve(P,i),S,D,j,k,K,l;if(this.oMetadata&&R&&R.indexOf('/#')>-1){if(this.isMetaModelPath(R)){S=R.indexOf('/##');l=this.getMetaModel();if(!this.bMetaModelLoaded){return null;}D=R.substr(0,S);j=R.substr(S+3);k=l.getMetaContext(D);N=l.getProperty(j,k);}else{N=this.oMetadata._getAnnotation(R);}}else{if(i){K=i.getPath();K=K.substr(1);N=this.oData[K];}if(!P){return N;}var w=P.split("/"),I=0;if(!w[0]){N=this.oData;I++;}while(N&&w[I]){N=N[w[I]];if(N){if(N.__ref){N=this.oData[N.__ref];}else if(N.__list){N=N.__list;}else if(N.__deferred){N=undefined;}}I++;}}return N;};
v.prototype.updateSecurityToken=function(){if(this.bTokenHandling){if(!this.oServiceData.securityToken){this.refreshSecurityToken();}if(this.bTokenHandling){this.oHeaders["x-csrf-token"]=this.oServiceData.securityToken;}}};
v.prototype.resetSecurityToken=function(){delete this.oServiceData.securityToken;delete this.oHeaders["x-csrf-token"];};
v.prototype.getSecurityToken=function(){var T=this.oServiceData.securityToken;if(!T){this.refreshSecurityToken();T=this.oServiceData.securityToken;}return T;};
v.prototype.refreshSecurityToken=function(S,E,A){var i=this,j,T;A=A===true;j=this._createRequestUrl("/");var R=this._createRequest(j,"GET",A);R.headers["x-csrf-token"]="Fetch";function _(D,l){if(l){T=i._getHeader("x-csrf-token",l.headers);if(T){i.oServiceData.securityToken=T;i.oHeaders["x-csrf-token"]=T;}else{i.resetSecurityToken();i.bTokenHandling=false;}}if(S){S(D,l);}}function k(l){i.resetSecurityToken();i.bTokenHandling=false;i._handleError(l);if(E){E(l);}}return this._request(R,_,k,undefined,undefined,this.getServiceMetadata());};
v.prototype._submitRequest=function(R,i,S,E,H,I){var j=this,k,l={};function _(D,y){if(i&&H){var z=j._getBatchErrors(D);if(z.length>0){w(z[0]);return false;}if(D.__batchResponses&&D.__batchResponses.length>0){k=D.__batchResponses[0].data;if(!k&&D.__batchResponses[0].__changeResponses){k=D.__batchResponses[0].__changeResponses[0].data;}}D=k;}if(I){if(D&&D.__batchResponses){h(D.__batchResponses,function(A,y){if(y&&y.data){j._importData(y.data,l);}});}}j._handleETag(R,y,i);j._updateRequestQueue(R,i);if(j._isRefreshNeeded(R,y)){j._refresh(false,R.keys,R.entityTypes);}if(S){S(D,y);}return undefined;}function w(y){if(j.bTokenHandling&&y.response){var T=j._getHeader("x-csrf-token",y.response.headers);if(!R.bTokenReset&&y.response.statusCode=='403'&&T&&T.toLowerCase()=="required"){j.resetSecurityToken();R.bTokenReset=true;x();return;}}j._handleError(y);if(E){E(y);}}function x(){if(j.bTokenHandling){delete R.headers["x-csrf-token"];}if(j.bTokenHandling&&R.method!=="GET"){j.updateSecurityToken();if(j.bTokenHandling){R.headers["x-csrf-token"]=j.oServiceData.securityToken;}}if(i){return j._request(R,_,w,t.batchHandler,undefined,j.getServiceMetadata());}else{return j._request(R,_,w,j.oHandler,undefined,j.getServiceMetadata());}}return x();};
v.prototype._createBatchRequest=function(w,A){var x,R,y={},P={},K={},E={};P.__batchRequests=w;x=this.sServiceUrl+"/$batch";if(this.aUrlParams.length>0){x+="?"+this.aUrlParams.join("&");}m(y,this.mCustomHeaders,this.oHeaders);delete y["Content-Type"];R={headers:y,requestUri:x,method:"POST",data:P,user:this.sUser,password:this.sPassword,async:A};if(A){R.withCredentials=this.bWithCredentials;}h(w,function(i,z){if(z["__changeRequests"]){h(z["__changeRequests"],function(j,D){if(D.keys&&D.method!="POST"){h(D.keys,function(k,l){K[k]=l;});}else if(D.entityTypes&&D.method=="POST"){h(D.entityTypes,function(l,k){E[l]=k;});}});}});R.keys=K;R.entityTypes=E;return R;};
v.prototype._handleETag=function(R,k,l){var w,E,x,y,z,A;if(l){z=R.data.__batchRequests;A=k.data.__batchResponses;if(A&&z){for(var i=0;i<z.length;i++){x=z[i].__changeRequests;if(A[i]){y=A[i].__changeResponses;if(x&&y){for(var j=0;j<x.length;j++){if(x[j].method=="MERGE"||x[j].method=="PUT"){w=x[j].requestUri.replace(this.sServiceUrl+'/','');if(!w.startsWith("/")){w="/"+w;}E=this._getObject(w);if(E&&E.__metadata&&y[j].headers&&y[j].headers.ETag){E.__metadata.etag=y[j].headers.ETag;}}}}}else{L.warning("could not update ETags for batch request: corresponding response for request missing");}}}else{L.warning("could not update ETags for batch request: no batch responses/requests available");}}else{w=R.requestUri.replace(this.sServiceUrl+'/','');if(!w.startsWith("/")){w="/"+w;}E=this._getObject(w);if(E&&E.__metadata&&k.headers.ETag){E.__metadata.etag=k.headers.ETag;}}};
v.prototype._handleBatchErrors=function(R,D){this._getBatchErrors(D);this._handleETag();};
v.prototype._getBatchErrors=function(D){var E=[],i;h(D.__batchResponses,function(I,j){if(j.message){i="The following problem occurred: "+j.message;if(j.response){i+=j.response.statusCode+","+j.response.statusText+","+j.response.body;}E.push(j);L.fatal(i);}if(j.__changeResponses){h(j.__changeResponses,function(I,k){if(k.message){i="The following problem occurred: "+k.message;if(k.response){i+=k.response.statusCode+","+k.response.statusText+","+k.response.body;}E.push(k);L.fatal(i);}});}});return E;};
v.prototype._handleError=function(E){var P={},T;var i="The following problem occurred: "+E.message;P.message=E.message;if(E.response){if(this.bTokenHandling){T=this._getHeader("x-csrf-token",E.response.headers);if(E.response.statusCode=='403'&&T&&T.toLowerCase()=="required"){this.resetSecurityToken();}}i+=E.response.statusCode+","+E.response.statusText+","+E.response.body;P.statusCode=E.response.statusCode;P.statusText=E.response.statusText;P.responseText=E.response.body;}L.fatal(i);return P;};
v.prototype.getData=function(P,i,I){return this.getProperty(P,i,I);};
v.prototype._getETag=function(P,i,E){var j,k,I;if(E){j=E;}else if(i&&i.__metadata){j=i.__metadata.etag;}else if(P){k=P.replace(this.sServiceUrl+'/','');I=k.indexOf("?");if(I>-1){k=k.substr(0,I);}if(this.oData.hasOwnProperty(k)){j=this.getProperty('/'+k+'/__metadata/etag');}}return j;};
v.prototype._createRequest=function(i,j,A,P,E){var k={},l;m(k,this.mCustomHeaders,this.oHeaders);l=this._getETag(i,P,E);if(l&&j!="GET"){k["If-Match"]=l;}if(this.bJSON&&j!="DELETE"&&this.sMaxDataServiceVersion==="2.0"){k["Content-Type"]="application/json";}if(j=="MERGE"&&!this.bUseBatch){k["x-http-method"]="MERGE";j="POST";}var R={headers:k,requestUri:i,method:j,user:this.sUser,password:this.sPassword,async:A};if(P){R.data=P;}if(A){R.withCredentials=this.bWithCredentials;}return R;};
v.prototype._isRefreshNeeded=function(R,i){var j=false,E,k=[],l=this;if(!this.bRefreshAfterChange){return j;}if(R.data&&Array.isArray(R.data.__batchRequests)){if(i){k=l._getBatchErrors(i.data);h(k,function(I,w){if(w.response&&w.response.statusCode=="412"){E=w.response.statusCode;return false;}return true;});if(E){return false;}}h(R.data.__batchRequests,function(I,w){if(Array.isArray(w.__changeRequests)){h(w.__changeRequests,function(I,x){j=j||l._isRefreshNeeded(x);return!j;});}return!j;});}else if(R.method==="GET"){return false;}else if(i&&i.statusCode=="412"){j=false;}else{j=true;}return j;};
v.prototype.update=function(P,D,i){var S,E,j,R,k,l,w,x,y,z,K,A,G=false;if(i instanceof q||arguments.length>3){l=i;S=arguments[3];E=arguments[4];j=arguments[5];}else{l=i.context||i.oContext;S=i.success||i.fnSuccess;E=i.error||i.fnError;w=i.eTag||i.sETag;j=typeof(i.merge)=="undefined"?i.bMerge===true:i.merge===true;G=typeof(i.async)=="undefined"?i.bAsync===true:i.async===true;A=i.urlParameters;}k=this._createRequestUrl(P,l,A,this.bUseBatch);if(j){R=this._createRequest(k,"MERGE",G,D,w);}else{R=this._createRequest(k,"PUT",G,D,w);}P=this._normalizePath(P,l);z=this._getObject(P);R.keys={};if(z){K=this._getKey(z);R.keys[K]=true;}if(this.bUseBatch){y=this._createBatchRequest([{__changeRequests:[R]}],G);x=this._submitRequest(y,this.bUseBatch,S,E,true);}else{x=this._submitRequest(R,this.bUseBatch,S,E);}return x;};
v.prototype.create=function(P,D,i){var R,j,k,l,E,w,S,x,A=false,y;if(i&&typeof(i)=="object"&&!(i instanceof q)){w=i.context;S=i.success;y=i.urlParameters;x=i.error;A=i.async===true;}else{w=i;S=arguments[3];x=arguments[4];}k=this._createRequestUrl(P,w,y,this.bUseBatch);R=this._createRequest(k,"POST",A,D);P=this._normalizePath(P,w);E=this.oMetadata._getEntityTypeByPath(P);R.entityTypes={};if(E){R.entityTypes[E.entityType]=true;}if(this.bUseBatch){j=this._createBatchRequest([{__changeRequests:[R]}],A);l=this._submitRequest(j,this.bUseBatch,S,x,true);}else{l=this._submitRequest(R,this.bUseBatch,S,x);}return l;};
v.prototype.remove=function(P,i){var j,E,S,k,l,R,w,x,K,y,_,z,A,D,G=false,H=this;if((i instanceof q)||arguments[2]){j=i;k=arguments[2];l=arguments[3];}else if(i){j=i.context||i.oContext;k=i.success||i.fnSuccess;l=i.error||i.fnError;x=i.eTag||i.sETag;y=i.payload||i.oPayload;G=typeof(i.async)=="undefined"?i.bAsync===true:i.async===true;D=i.urlParameters;}_=function(I,J){E=w.substr(w.lastIndexOf('/')+1);if(E.indexOf('?')!=-1){E=E.substr(0,E.indexOf('?'));}delete H.oData[E];delete H.mContexts["/"+E];if(k){k(I,J);}};w=this._createRequestUrl(P,j,D,this.bUseBatch);R=this._createRequest(w,"DELETE",G,y,x);P=this._normalizePath(P,j);S=this._getObject(P);R.keys={};if(S){K=this._getKey(S);R.keys[K]=true;}if(this.bUseBatch){z=this._createBatchRequest([{__changeRequests:[R]}],G);A=this._submitRequest(z,this.bUseBatch,_,l,true);}else{A=this._submitRequest(R,this.bUseBatch,_,l);}return A;};
v.prototype.callFunction=function(i,P){var R,j,k,l,w,x,y,S,E,A,z="GET",D={},G=this;if(P&&typeof(P)=="object"){z=P.method?P.method:z;x=P.urlParameters;y=P.context;S=P.success;E=P.error;A=P.async===true;}else{z=P;x=arguments[2];y=arguments[3];S=arguments[4];E=arguments[5];A=arguments[6]===true;}w=this.oMetadata._getFunctionImportMetadata(i,z);f(w,"Function "+i+" not found in the metadata !");if(w){k=this._createRequestUrl(i,y,null,this.bUseBatch);var H=new U(k);if(w.parameter!=null){h(x,function(I,J){var K=w.parameter.filter(function(Q){return Q.name==I&&Q.mode=="In";});if(K.length>0){var N=K[0];D[I]=e.formatValue(J,N.type);}else{L.warning("Parameter "+I+" is not defined for function call "+i+"!");}});}if(z==="GET"){return G.read(i,y,D,true,S,E);}else{h(D,function(I,J){H.addQuery(I,J);});R=this._createRequest(H.toString(),z,A);if(this.bUseBatch){j=this._createBatchRequest([{__changeRequests:[R]}],A);l=this._submitRequest(j,this.bUseBatch,S,E,true);}else{l=this._submitRequest(R,this.bUseBatch,S,E);}return l;}}return undefined;};
v.prototype.read=function(P,i){var R,j,k,l,w,x,A,S,E,y,z,D,G,H,I,J,K;if(i&&typeof(i)=="object"&&!(i instanceof q)){w=i.context;x=i.urlParameters;A=i.async!==false;S=i.success;E=i.error;y=i.filters;z=i.sorters;}else{w=i;x=arguments[2];A=arguments[3]!==false;S=arguments[4];E=arguments[5];}A=A!==false;K=e._createUrlParamsArray(x);G=e.createSortParams(z);if(G){K.push(G);}if(y&&!this.oMetadata){L.fatal("Tried to use filters in read method before metadata is available.");}else{J=this._normalizePath(P,w);I=this.oMetadata&&this.oMetadata._getEntityTypeByPath(J);H=F.groupFilters(y);D=e.createFilterParams(H,this.oMetadata,I);if(D){K.push(D);}}j=this._createRequestUrl(P,w,K,this.bUseBatch);R=this._createRequest(j,"GET",A);if(this.bUseBatch){l=this._createBatchRequest([R],A);k=this._submitRequest(l,this.bUseBatch,S,E,true);}else{k=this._submitRequest(R,this.bUseBatch,S,E);}return k;};
v.prototype.createBatchOperation=function(P,i,D,j){var k={},E,S,K,l;m(k,this.mCustomHeaders,this.oHeaders);if(P.startsWith("/")){P=P.substr(1);}if(j){E=j.sETag;}if(i!="GET"){E=this._getETag(P,D,E);if(E){k["If-Match"]=E;}}if(this.bJSON){if(i!="DELETE"&&i!="GET"&&this.sMaxDataServiceVersion==="2.0"){k["Content-Type"]="application/json";}}else{k["Content-Type"]="application/atom+xml";}var R={requestUri:P,method:i.toUpperCase(),headers:k};if(D){R.data=D;}if(i!="GET"&&i!="POST"){if(P&&P.indexOf("/")!=0){P='/'+P;}S=this._getObject(P);if(S){K=this._getKey(S);R.keys={};R.keys[K]=true;}}else if(i=="POST"){var N=P;if(P.indexOf('?')!=-1){N=P.substr(0,P.indexOf('?'));}l=this.oMetadata._getEntityTypeByPath(N);if(l){R.entityTypes={};R.entityTypes[l.entityType]=true;}}return R;};
v.prototype.addBatchReadOperations=function(R){if(!Array.isArray(R)||R.length<=0){L.warning("No array with batch operations provided!");return false;}var i=this;h(R,function(I,j){if(j.method!="GET"){L.warning("Batch operation should be a GET operation!");return false;}i.aBatchOperations.push(j);return true;});return undefined;};
v.prototype.addBatchChangeOperations=function(i){if(!Array.isArray(i)||i.length<=0){return false;}h(i,function(I,j){if(j.method!="POST"&&j.method!="PUT"&&j.method!="MERGE"&&j.method!="DELETE"){L.warning("Batch operation should be a POST/PUT/MERGE/DELETE operation!");return false;}return true;});this.aBatchOperations.push({__changeRequests:i});return undefined;};
v.prototype.clearBatch=function(){this.aBatchOperations=[];};
v.prototype.submitBatch=function(S,E,A,i){var R,j,k=this;function _(D,x){if(S){S(D,x,k._getBatchErrors(D));}}if(!(typeof(S)=="function")){var l=A;var w=E;A=S;S=w;E=l;}A=A!==false;if(this.aBatchOperations.length<=0){L.warning("No batch operations in batch. No request will be triggered!");return false;}R=this._createBatchRequest(this.aBatchOperations,A);j=this._submitRequest(R,true,_,E,false,i);this.clearBatch();return j;};
v.prototype.getServiceMetadata=function(){if(this.oMetadata&&this.oMetadata.isLoaded()){return this.oMetadata.getServiceMetadata();}return undefined;};
v.prototype.getServiceAnnotations=function(){if(this.oAnnotations&&this.oAnnotations.getAnnotationsData){return this.oAnnotations.getAnnotationsData();}return undefined;};
v.prototype.submitChanges=function(S,E,P){var R,i,j=this,k,l,T,w,x,K;if(this.sChangeKey){k=this.sChangeKey.replace(this.sServiceUrl,'');x=this._getObject(k);i=x;if(o(x)){i=p({},x);if(i.__metadata){T=i.__metadata.type;w=i.__metadata.etag;delete i.__metadata;if(T||w){i.__metadata={};}if(T){i.__metadata.type=T;}if(w){i.__metadata.etag=w;}}h(i,function(A,D){if(D&&D.__deferred){delete i[A];}});var y=this.oMetadata._getEntityTypeByPath(k);if(y){var N=this.oMetadata._getNavigationPropertyNames(y);h(N,function(I,A){delete i[A];});}i=this._removeReferences(i);}if(P&&P.sETag){l=P.sETag;}R=this._createRequest(this.sChangeKey,"MERGE",true,i,l);if(this.sUrlParams){R.requestUri+="?"+this.sUrlParams;}R.keys={};if(x){K=this._getKey(x);R.keys[K]=true;}this.oRequestQueue[this.sChangeKey]=R;}if(n(this.oRequestQueue)){return undefined;}if(this.bUseBatch){var z=[];h(this.oRequestQueue,function(K,A){delete A._oRef;var D=p({},A);A._oRef=D;D.requestUri=D.requestUri.replace(j.sServiceUrl+'/','');if(D.data._bCreate){delete D.data._bCreate;}z.push(D);});R=this._createBatchRequest([{__changeRequests:z}],true);this._submitRequest(R,this.bUseBatch,S,E,true);}else{h(this.oRequestQueue,function(K,A){delete A._oRef;var D=p({},A);A._oRef=D;if(D.data&&D.data._bCreate){delete D.data._bCreate;}j._submitRequest(D,this.bUseBatch,S,E,true);});}return undefined;};
v.prototype._updateRequestQueue=function(R,k){var l,w,x,y=this;if(k){l=R.data.__batchRequests;if(l){for(var i=0;i<l.length;i++){w=l[i].__changeRequests;if(w){for(var j=0;j<w.length;j++){x=w[j];h(this.oRequestQueue,function(K,z){if(z._oRef===x&&K!==y.sChangeKey){delete y.oRequestQueue[K];delete y.oData[K];delete y.mContexts["/"+K];}else if(y.sChangeKey&&K===y.sChangeKey){delete y.oRequestQueue[K];y.sChangeKey=null;}});}}}}}else{h(this.oRequestQueue,function(K,z){if(z._oRef===R&&K!==y.sChangeKey){delete y.oRequestQueue[K];delete y.oData[K];delete y.mContexts["/"+K];}else if(y.sChangeKey&&K===y.sChangeKey){delete y.oRequestQueue[K];y.sChangeKey=null;}});}};
v.prototype.resetChanges=function(S,E){var P;if(this.sChangeKey){P=this.sChangeKey.replace(this.sServiceUrl,'');this._loadData(P,null,S,E);}};
v.prototype.setProperty=function(P,V,j,A){var k,E={},D={},l=this._createRequestUrl(P,j),w=P.substring(0,P.lastIndexOf("/")),K,x,y={},z=false;if(!this.resolve(P,j)){return false;}l=l.replace(this.sServiceUrl+'/','');l=l.substring(0,l.indexOf("/"));l=this.sServiceUrl+'/'+l;k=P.substr(P.lastIndexOf("/")+1);D=this._getObject(w,j);if(!D){return false;}x=w.split("/");for(var i=x.length-1;i>=0;i--){E=this._getObject(x.join("/"),j);if(E){K=this._getKey(E);if(K){break;}}x.splice(i-1,1);}if(!K){K=this._getKey(j);}if(K){y[K]=true;}if(D._bCreate){D[k]=V;z=true;this.checkUpdate(false,A,y);}else{if(!this.sChangeKey){this.sChangeKey=l;}if(this.sChangeKey==l){D[k]=V;z=true;this.checkUpdate(false,A,y);}else{this.fireRejectChange({rejectedValue:V,oldValue:D[k]});}}return z;};
v.prototype._isHeaderPrivate=function(H){switch(H.toLowerCase()){case"accept":case"accept-language":case"maxdataserviceversion":case"dataserviceversion":return true;case"x-csrf-token":return this.bTokenHandling;default:return false;}};
v.prototype.setHeaders=function(H){var i={},j=this;if(H){h(H,function(k,l){if(j._isHeaderPrivate(k)){L.warning("Not allowed to modify private header: "+k);}else{i[k]=l;}});this.mCustomHeaders=i;}else{this.mCustomHeaders={};}if(this.oAnnotations){this.oAnnotations.setHeaders(this.mCustomHeaders);}};
v.prototype.getHeaders=function(){return m({},this.mCustomHeaders,this.oHeaders);};
v.prototype._getHeader=function(i,H){var j;for(j in H){if(j.toLowerCase()===i.toLowerCase()){return H[j];}}return null;};
v.prototype.hasPendingChanges=function(){return this.sChangeKey!=null;};
v.prototype.updateBindings=function(i){this.checkUpdate(i);};
v.prototype.forceNoCache=function(i){this.bCache=!i;};
v.prototype.setTokenHandlingEnabled=function(T){this.bTokenHandling=T;};
v.prototype.setUseBatch=function(i){this.bUseBatch=i;};
v.prototype.formatValue=function(V,T){return e.formatValue(V,T);};
v.prototype.deleteCreatedEntry=function(i){if(i){var P=i.getPath();delete this.mContexts[P];if(P.startsWith("/")){P=P.substr(1);}delete this.oRequestQueue[P];delete this.oData[P];}};
v.prototype.createEntry=function(P,j){var E={},k,l,R;if(!P.startsWith("/")){P="/"+P;}var w=this.oMetadata._getEntityTypeByPath(P);if(!w){f(w,"No Metadata for collection "+P+" found");return undefined;}if(typeof j==="object"&&!Array.isArray(j)){E=j;}else{for(var i=0;i<w.property.length;i++){var x=w.property[i];var y=j&&j.indexOf(x.name)>-1;if(!j||y){E[x.name]=this._createPropertyValue(x.type);if(y){j.splice(j.indexOf(x.name),1);}}}if(j){f(j.length===0,"No metadata for the following properties found: "+j.join(","));}}E._bCreate=true;k=P.substring(1)+"('"+u()+"')";this.oData[k]=E;E.__metadata={type:""+w.entityType};l=this._createRequestUrl(P);R=this._createRequest(l,"POST",true,E);R.entityTypes={};R.entityTypes[w.entityType]=true;this.oRequestQueue[k]=R;return this.getContext("/"+k);};
v.prototype._createPropertyValue=function(T){var j=this.oMetadata._splitName(T);var N=j.namespace;var k=j.name;if(N.toUpperCase()!=='EDM'){var l={};var w=this.oMetadata._getObjectMetadata("complexType",k,N);f(w,"Complex type "+T+" not found in the metadata !");for(var i=0;i<w.property.length;i++){var P=w.property[i];l[P.name]=this._createPropertyValue(P.type);}return l;}else{return this._getDefaultPropertyValue(k,N);}};
v.prototype._getDefaultPropertyValue=function(T,N){return undefined;};
v.prototype._normalizePath=function(P,i){if(P&&P.indexOf('?')!=-1){P=P.substr(0,P.indexOf('?'));}if(!i&&!P.startsWith("/")){P='/'+P;L.warning(this+" path "+P+" should be absolute if no Context is set");}return this.resolve(P,i);};
v.prototype.setRefreshAfterChange=function(R){this.bRefreshAfterChange=R;};
v.prototype.isList=function(P,i){P=this.resolve(P,i);return P&&P.substr(P.lastIndexOf("/")).indexOf("(")===-1;};
v.prototype.isMetaModelPath=function(P){return P.indexOf("##")==0||P.indexOf("/##")>-1;};
v.prototype._request=function(R,S,E,H,i,j){var k;if(this.bDestroyed){return{abort:function(){}};}var l=this;function w(x){return function(){if(l.aPendingRequestHandles){var I=l.aPendingRequestHandles.indexOf(k);if(I>-1){l.aPendingRequestHandles.splice(I,1);}}if(!(k&&k.bSuppressErrorHandlerCall)){x.apply(this,arguments);}};}k=t.request(R,w(S||t.defaultSuccess),w(E||t.defaultError),H,i,j);if(R.async!==false){this.aPendingRequestHandles.push(k);}return k;};
v.prototype.destroy=function(){this.bDestroyed=true;if(this.aPendingRequestHandles){for(var i=this.aPendingRequestHandles.length-1;i>=0;i--){var R=this.aPendingRequestHandles[i];if(R&&R.abort){R.bSuppressErrorHandlerCall=true;R.abort();}}delete this.aPendingRequestHandles;}if(this.oMetadataLoadEvent){clearTimeout(this.oMetadataLoadEvent);}if(this.oMetadataFailedEvent){clearTimeout(this.oMetadataFailedEvent);}if(this.oMetadata){this.oMetadata.detachLoaded(this.onMetadataLoaded);this.oMetadata.detachFailed(this.onMetadataFailed);if(!this.oMetadata.isLoaded()&&!this.oMetadata.hasListeners("loaded")){this.oMetadata.destroy();delete this.oServiceData.oMetadata;}delete this.oMetadata;}if(this.oAnnotations){this.oAnnotations.detachFailed(this.onAnnotationsFailed);this.oAnnotations.detachLoaded(this.onAnnotationsLoaded);this.oAnnotations.destroy();delete this.oAnnotations;delete this.pAnnotationsLoaded;}M.prototype.destroy.apply(this,arguments);};
v.prototype._getAnnotationParser=function(A){if(!this.oAnnotations){this.oAnnotations=new r({annotationData:A,url:null,metadata:this.oMetadata,async:this.bLoadMetadataAsync,headers:this.mCustomHeaders});this.oAnnotations.attachFailed(this.onAnnotationsFailed,this);this.oAnnotations.attachLoaded(this.onAnnotationsLoaded,this);}return this.oAnnotations;};
v.prototype.onAnnotationsFailed=function(E){this.fireAnnotationsFailed(E.getParameters());};
v.prototype.onAnnotationsLoaded=function(E){this.fireAnnotationsLoaded(E.getParameters());};
v.prototype.addAnnotationUrl=function(j){var k=[].concat(j),l=[],A=[],E=[],w=this;h(k,function(i,x){var I=x.indexOf("$metadata");if(I>=0){if(I==0){x=w.sServiceUrl+'/'+x;}l.push(x);}else{A.push(x);}});return this.oMetadata._addUrl(l).then(function(P){return Promise.all(P.map(function(i){E=E.concat(i.entitySets);return w.addAnnotationXML(i["metadataString"]);}));}).then(function(){return w._getAnnotationParser().addUrl(A);}).then(function(P){return{annotations:P.annotations,entitySets:E};});};
v.prototype.addAnnotationXML=function(x,S){return new Promise(function(i,j){this._getAnnotationParser().setXML(null,x,{success:i,error:j,fireEvents:!S});}.bind(this));};
v.prototype.getMetaModel=function(){var i=this;if(!this.oMetaModel){this.oMetaModel=new s(this.oMetadata,this.oAnnotations,this);this.oMetaModel.loaded().then(function(){i.bMetaModelLoaded=true;i.checkUpdate(false,false,null,true);});}return this.oMetaModel;};
v.prototype.annotationsLoaded=function(){return this.oMetadata.isLoaded()&&(!this.oAnnotations||this.oAnnotations.isLoaded())?null:this.pAnnotationsLoaded;};
return v;});
sap.ui.predefine('sap/ui/model/odata/ODataPropertyBinding',['./ODataMetaModel','sap/ui/model/Context','sap/ui/model/ChangeReason','sap/ui/model/PropertyBinding',"sap/base/util/deepEqual",'sap/ui/model/ChangeReason'],function(O,C,a,P,d){"use strict";
var b=P.extend("sap.ui.model.odata.ODataPropertyBinding",{constructor:function(m,p,c,e){P.apply(this,arguments);this.bInitial=true;this.oValue=this._getValue();this.vOriginalValue=undefined;this.getDataState().setValue(this.oValue);this.setIgnoreMessages(e&&e.ignoreMessages);}});
b.prototype.initialize=function(){if(this.oModel.oMetadata.isLoaded()&&this.bInitial){this.checkUpdate(true);this.bInitial=false;}};
b.prototype.getValue=function(){return this.oValue;};
b.prototype._getValue=function(){return this.oModel._getObject(this.sPath,this.oContext);};
b.prototype.setValue=function(v){if(this.bSuspended){return;}if(!d(v,this.oValue)&&this.oModel.setProperty(this.sPath,v,this.oContext,true)){this.oValue=v;var D=this.getDataState();D.setValue(this.oValue);this.oModel.firePropertyChange({reason:a.Binding,path:this.sPath,context:this.oContext,value:v});}};
b.prototype.setContext=function(c){var f,o=this.oContext;if(c&&c.isPreliminary()){return;}if(C.hasChanged(this.oContext,c)){this.oContext=c;if(this.isRelative()){f=!!(o!==c&&this.getDataState().getControlMessages().length);this.checkUpdate(f);}}};
b.prototype.checkUpdate=function(f){var c,t=this;if(this.bSuspended&&!f){return;}c=O.getCodeListTerm(this.sPath);if(c){if(this.bInitial){this.oModel.getMetaModel().fetchCodeList(c).then(function(m){t.oValue=m;t._fireChange({reason:a.Change});},function(){});}return;}var D=this.getDataState();var e=false;var o=this.oModel.getOriginalProperty(this.sPath,this.oContext);if(f||!d(o,this.vOriginalValue)){this.vOriginalValue=o;D.setOriginalValue(o);e=true;}var v=this._getValue();if(f||!d(v,this.oValue)){this.oValue=v;D.setValue(this.oValue);this._fireChange({reason:a.Change});e=true;}if(e){this.checkDataState();}};
b.prototype.checkDataState=function(p){var c=this.oModel.resolve(this.sPath,this.oContext,true)||this.getResolvedPath();this.getDataState().setLaundering(!!p&&!!(c in p));P.prototype._checkDataState.call(this,c,p);};
b.prototype.supportsIgnoreMessages=function(){return true;};
return b;});
sap.ui.predefine('sap/ui/model/odata/ODataTreeBinding',["./CountMode","sap/base/Log","sap/base/util/each","sap/ui/model/TreeBinding"],function(C,L,e,T){"use strict";
var O=T.extend("sap.ui.model.odata.ODataTreeBinding",{constructor:function(m,p,c,f,P){T.apply(this,arguments);this.bPendingRequest=false;this.oFinalLengths={};this.oLengths={};this.oKeys={};this.bNeedsUpdate=false;this.bHasTreeAnnotations=this._hasTreeAnnotations();this.oRootContext=null;this.iNumberOfExpandedLevels=P&&P.numberOfExpandedLevels;this.sCountMode=(P&&P.countMode)||this.oModel.sDefaultCountMode;if(!this.bHasTreeAnnotations){if(!P||!P.navigation){L.error("A navigation paths parameter object has to be defined");this.oNavigationPaths={};}else{this.oNavigationPaths=P.navigation;}}else{L.warning("Tree hierarchy annotations are deprecated and may not work correctly with the sap.ui.model.odata.ODataModel."+" Please use the sap.ui.model.odata.v2.ODataModel (since version 1.28) instead which fully supports hierarchy annotations.");}}});
O.prototype.getRootContexts=function(s,l,t){var n=null,r={numberOfExpandedLevels:this.iNumberOfExpandedLevels},R=[],b=true,a=this;if(this.bHasTreeAnnotations){r.level=0;if(!this.bDisplayRootNode){r.level=1;}}else{n=this.oModel.resolve(this.getPath(),this.getContext());r.navPath=this._getNavPath(this.getPath());if(r.numberOfExpandedLevels>0){var A=n;for(var i=0;i<r.numberOfExpandedLevels;i++){var N=this._getNavPath(A);r.navPath+="/"+N;A+="/"+N;}}var I=this.oModel.isList(this.sPath,this.getContext());if(I){this.bDisplayRootNode=true;}else{b=false;this.oModel.createBindingContext(n,null,{expand:r.navPath},function(o){R=[o];if(a.oRootContext!==o){a.oRootContext=o;a._processODataObject(o.getObject(),n,r.navPath);a.bNeedsUpdate=true;}},this.bRefresh);this.bRefresh=false;}}if(b){if(!this.bDisplayRootNode){R=this._getContextsForNodeId(n,0,1,0,r);}else{R=this._getContextsForNodeId(n,s,l,t,r);}}if(!this.bDisplayRootNode&&R.length>0){this.oRootContext=R[0];R=this.getNodeContexts(R[0],s,l,t);}return R;};
O.prototype.getNodeContexts=function(c,s,l,t){var n,r={};if(this.bHasTreeAnnotations){var d=c.getProperty(this.oTreeProperties["hierarchy-drill-state-for"]);if(d=="leaf"){return[];}n=c.getProperty(this.oTreeProperties["hierarchy-node-for"]);r.level=parseInt(c.getProperty(this.oTreeProperties["hierarchy-level-for"]))+1;}else{var N=this._getNavPath(c.getPath());if(!N){return[];}n=this.oModel.resolve(N,c);r.navPath=this.oNavigationPaths[N];}return this._getContextsForNodeId(n,s,l,t,r);};
O.prototype.hasChildren=function(c){if(!c){return false;}if(this.bHasTreeAnnotations){var d=c.getProperty(this.oTreeProperties["hierarchy-drill-state-for"]);return d==="expanded"||d==="collapsed";}else{var n=this._getNavPath(c.getPath());var p=c.getPath()+"/"+n;return n&&this.oLengths[p]>0;}};
O.prototype.getChildCount=function(c){if(this.bHasTreeAnnotations){var h;if(!c){if(this.oRootContext){h=this.oRootContext.getProperty(this.oTreeProperties["hierarchy-node-for"]);}else{h="000000";}}else{h=c.getProperty(this.oTreeProperties["hierarchy-node-for"]);}return this.oLengths[h];}else{if(!c){return this.oLengths[this.getPath()];}return this.oLengths[c.getPath()+"/"+this._getNavPath(c.getPath())];}};
O.prototype._getContextsForNodeId=function(n,s,l,t,p){var c=[],b,k;if(!s){s=0;}if(!l){l=this.oModel.iSizeLimit;}if(!t){t=0;}if(this.bHasTreeAnnotations){if(n==null){n="000000";}if(p.level==0){p.level++;}}if(this.oFinalLengths[n]&&this.oLengths[n]<l){l=this.oLengths[n];}if(this.oKeys[n]){for(var i=s;i<s+l;i++){k=this.oKeys[n][i];if(!k){break;}c.push(this.oModel.getContext('/'+k));}}b=c.length!=l&&!(this.oFinalLengths[n]&&c.length>=this.oLengths[n]);if(this.oModel.getServiceMetadata()){if(!this.bPendingRequest&&b){var P=[];if(this.bHasTreeAnnotations){if(p.numberOfExpandedLevels>0){var a=p.level+p.numberOfExpandedLevels;P.push("$filter="+this.oTreeProperties["hierarchy-level-for"]+" le '0"+a+"'");}else{P.push("$filter="+this.oTreeProperties["hierarchy-level-for"]+" eq '0"+p.level+"' and "+this.oTreeProperties["hierarchy-parent-node-for"]+" eq '"+n+"'");}}else if(p.navPath){P.push("$expand="+p.navPath);}this._loadSubNodes(n,s,l,t,P,p);}}return c;};
O.prototype._getCountForNodeId=function(n,s,l,t,p){var a=this;var P=[];function _(d){a.oFinalLengths[n]=true;a.oLengths[n]=parseInt(d);}function b(E){var d="Request for $count failed: "+E.message;if(E.response){d+=", "+E.response.statusCode+", "+E.response.statusText+", "+E.response.body;}L.warning(d);}var c;if(this.bHasTreeAnnotations){c=this.oModel.resolve(this.getPath(),this.getContext());P.push("$filter="+this.oTreeProperties["hierarchy-parent-node-for"]+" eq '"+n+"'");}else{c=n;}if(c){var u=this.oModel._createRequestUrl(c+"/$count",null,P);var r=this.oModel._createRequest(u,"GET",false);r.headers["Accept"]="text/plain, */*;q=0.5";this.oModel._request(r,_,b,undefined,undefined,this.oModel.getServiceMetadata());}};
O.prototype._loadSubNodes=function(n,s,l,t,p,P){var a=this,I=false;if(s||l){p.push("$skip="+s+"&$top="+l);}if(!a.bHasTreeAnnotations&&!this.oFinalLengths[n]&&(this.sCountMode==C.Inline||this.sCountMode==C.Both)){p.push("$inlinecount=allpages");I=true;}function S(d){var o,i;if(d.results){if(!a.bHasTreeAnnotations){if(I&&d.__count){a.oLengths[n]=parseInt(d.__count);a.oFinalLengths[n]=true;}else if(a.oModel.isCountSupported()){a._getCountForNodeId(n);}a.oKeys[n]=[];for(i=0;i<d.results.length;i++){o=d.results[i];var k=a.oModel._getKey(o);a._processODataObject(o,"/"+k,P.navPath);a.oKeys[n][i+s]=k;}}else{var m={};for(i=0;i<d.results.length;i++){o=d.results[i];n=o[a.oTreeProperties["hierarchy-parent-node-for"]];if(i==0){m[n]=s;}else if(m[n]==undefined){m[n]=0;}if(!(n in a.oKeys)){a.oKeys[n]=[];a._getCountForNodeId(n);}a.oKeys[n][m[n]]=a.oModel._getKey(o);m[n]++;}}}else{a.oKeys[null]=a.oModel._getKey(d);if(!a.bHasTreeAnnotations){a._processODataObject(d,n,P.navPath);}}a.oRequestHandle=null;a.bPendingRequest=false;a.bNeedsUpdate=true;}function c(){a.fireDataReceived();}function E(d){a.oRequestHandle=null;a.bPendingRequest=false;a.fireDataReceived();}function u(h){a.oRequestHandle=h;}if(n){if(!this.oFinalLengths[n]){this.bPendingRequest=true;this.fireDataRequested();var A;if(this.bHasTreeAnnotations){A=this.oModel.resolve(this.getPath(),this.getContext());}else{A=n;}this.oModel._loadData(A,p,S,E,false,u,c);}}};
O.prototype.resetData=function(c){if(c){var p=c.getPath();delete this.oKeys[p];delete this.oLengths[p];delete this.oFinalLengths[p];}else{this.oKeys={};this.oLengths={};this.oFinalLengths={};this.oRootContext=null;}};
O.prototype.refresh=function(f,c,E){var b=false;if(!f){if(E){var r=this.oModel.resolve(this.sPath,this.oContext);var o=this.oModel.oMetadata._getEntityTypeByPath(r);if(o&&(o.entityType in E)){b=true;}}if(c&&!b){e(this.oKeys,function(i,n){e(n,function(i,k){if(k in c){b=true;return false;}return true;});if(b){return false;}return true;});}if(!c&&!E){b=true;}}if(f||b){this.resetData();this.bNeedsUpdate=false;this.bRefresh=true;this._fireChange();}};
O.prototype.filter=function(f){L.warning("Filtering is currently not possible in the ODataTreeBinding");return this;};
O.prototype.checkUpdate=function(f,c){var b=false;if(!f){if(this.bNeedsUpdate||!c){b=true;}else{e(this.oKeys,function(i,n){e(n,function(i,k){if(k in c){b=true;return false;}return true;});if(b){return false;}return true;});}}if(f||b){this.bNeedsUpdate=false;this._fireChange();}};
O.prototype._getNavPath=function(p){var a=this.oModel.resolve(p,this.getContext());if(!a){return undefined;}var P=a.split("/"),E=P[P.length-1],n;var c=E.split("(")[0];if(c&&this.oNavigationPaths[c]){n=this.oNavigationPaths[c];}return n;};
O.prototype._processODataObject=function(o,p,n){var N=[],t=this;if(n&&n.indexOf("/")>-1){N=n.split("/");n=N[0];N.splice(0,1);}var r=this.oModel._getObject(p);if(Array.isArray(r)){this.oKeys[p]=r;this.oLengths[p]=r.length;this.oFinalLengths[p]=true;}if(n&&o[n]){if(Array.isArray(r)){r.forEach(function(R){var o=t.getModel().getData("/"+R);t._processODataObject(o,"/"+R+"/"+n,N.join("/"));});}else if(typeof r==="object"){t._processODataObject(o,p+"/"+n,N.join("/"));}}};
O.prototype._hasTreeAnnotations=function(){var m=this.oModel,M=m.oMetadata,a=m.resolve(this.getPath(),this.getContext()),E=M._getEntityTypeByPath(a),t=M.mNamespaces["sap"],b=this;this.oTreeProperties={"hierarchy-level-for":false,"hierarchy-parent-node-for":false,"hierarchy-node-for":false,"hierarchy-drill-state-for":false};if(!E){L.fatal("EntityType for path "+a+" could not be found.");return false;}e(E.property,function(i,p){if(!p.extensions){return true;}e(p.extensions,function(i,o){var n=o.name;if(o.namespace===t&&n in b.oTreeProperties&&!b.oTreeProperties[n]){b.oTreeProperties[n]=p.name;}});return true;});var c=false;e(this.oTreeProperties,function(i,o){if(!o){c=true;return false;}return true;});return!c;};
return O;});
sap.ui.predefine('sap/ui/model/odata/ODataTreeBindingAdapter',['sap/ui/model/TreeBinding','./v2/ODataTreeBinding','sap/ui/model/TreeBindingAdapter','sap/ui/model/TreeAutoExpandMode','sap/ui/model/ChangeReason','./OperationMode','sap/base/assert','sap/ui/model/Filter','sap/ui/model/odata/ODataUtils'],function(T,O,a,b,C,c,d,F,e){"use strict";var f=function(){if(!(this instanceof T)||this._bIsAdapted){return;}a.apply(this);for(var g in f.prototype){if(f.prototype.hasOwnProperty(g)){this[g]=f.prototype[g];}}this.mParameters=this.mParameters||{};this._aRowIndexMap=[];this._iThreshold=0;this._iPageSize=0;this.setAutoExpandMode(this.mParameters.autoExpandMode||b.Sequential);if(this.mParameters.collapseRecursive===undefined){this.bCollapseRecursive=true;}else{this.bCollapseRecursive=!!this.mParameters.collapseRecursive;}this._createTreeState();if(this.mParameters.treeState&&this.sOperationMode==c.Client){this.setTreeState(this.mParameters.treeState);}};
f.prototype.nodeHasChildren=function(n){d(n,"ODataTreeBindingAdapter.nodeHasChildren: No node given!");if(!n){return false;}else if(n.isArtificial){return true;}else{return O.prototype.hasChildren.call(this,n.context);}};
f.prototype._calculateGroupID=function(n){var g="";var G="";var E;if(n.context===null){return"/";}if(n.parent){g=n.parent.groupID;g=g[g.length-1]!=="/"?g+"/":g;if(this.bHasTreeAnnotations){E=(n.context.getProperty(this.oTreeProperties["hierarchy-node-for"])+"").replace(/\//g,"%2F");G=E+"/";}else{G=n.context.sPath.substring(1)+"/";}}else if(this.bHasTreeAnnotations){g="/";E=(n.context.getProperty(this.oTreeProperties["hierarchy-node-for"])+"").replace(/\//g,"%2F");G=E+"/";}else{g="/";G=n.context.sPath[0]==="/"?n.context.sPath.substring(1):n.context.sPath;}var s=g+G;return s;};
f.prototype.resetData=function(o,p){O.prototype.resetData.call(this,o,p);this._aRowIndexMap=[];this._oRootNode=undefined;this._iPageSize=0;this._iThreshold=0;if(!p||p.reason!==C.Sort){this.clearSelection();this._createTreeState(true);}};
f.prototype.expandNodeToLevel=function(i,l,s){var t=this;if(this.sOperationMode!=="Server"){return Promise.reject(new Error("expandNodeToLevel() does not support binding operation modes other than OperationMode.Server"));}var n=this.findNode(i),p=[],A="";if(this.sOperationMode=="Server"||this.bUseServersideApplicationFilters){A=this.getFilterParams();}var N=n.context.getProperty(this.oTreeProperties["hierarchy-node-for"]);var E=this._getEntityType();var g=e._createFilterParams(new F(this.oTreeProperties["hierarchy-node-for"],"EQ",N),this.oModel.oMetadata,E);var L=this._getLevelFilterParams("LE",l);p.push("$filter="+g+"%20and%20"+L+(A?"%20and%20"+A:""));if(this.sCustomParams){p.push(this.sCustomParams);}return this._loadSubTree(n,p).then(function(D){var h=D.results.filter(function(o){return o[t.oTreeProperties["hierarchy-level-for"]]<l;});this._expandSubTree(n,h);if(!s){this._fireChange({reason:C.Expand});}}.bind(this));};
f.prototype._expandSubTree=function(p,D){this._updateTreeState({groupID:p.groupID,expanded:true});var P,s,n,m={},i;n=p.context.getProperty(this.oTreeProperties["hierarchy-node-for"]);m[n]=p.groupID;for(i=1;i<D.length;i++){var I,k,g,E,o;E=D[i];I=E[this.oTreeProperties["hierarchy-node-for"]];P=E[this.oTreeProperties["hierarchy-parent-node-for"]];if(E[this.oTreeProperties["hierarchy-drill-state-for"]]==="leaf"){continue;}k=this.oModel._getKey(E);o=this.oModel.getContext("/"+k);s=m[P];g=this._calculateGroupID({parent:{groupID:s},context:o});m[I]=g;this._updateTreeState({groupID:g,expanded:true});}};
f.prototype.getLength=function(){if((!this._oRootNode||!this._oRootNode.magnitude)&&this.oFinalLengths[null]){return this.oLengths[null];}return a.prototype.getLength.apply(this);};
return f;},true);
sap.ui.predefine('sap/ui/model/odata/ODataTreeBindingFlat',["sap/base/assert","sap/base/Log","sap/base/util/extend","sap/base/util/isEmptyObject","sap/base/util/uid","sap/ui/model/ChangeReason","sap/ui/model/Filter","sap/ui/model/TreeBinding","sap/ui/model/TreeBindingUtils","sap/ui/model/odata/v2/ODataTreeBinding"],function(c,L,e,d,u,C,F,T,f,O){"use strict";var g=function(){if(!(this instanceof T)||this._bIsAdapted){return;}for(var a in g.prototype){if(g.prototype.hasOwnProperty(a)){this[a]=g.prototype[a];}}this.mParameters=this.mParameters||{};this._iPageSize=0;this._aNodes=this._aNodes||[];this._aNodeCache=[];this._aCollapsed=this._aCollapsed||[];this._aExpanded=this._aExpanded||[];this._aRemoved=[];this._aAdded=[];this._aNodeChanges=[];this._aAllChangedNodes=[];this._mSubtreeHandles={};this._iLowestServerLevel=null;this._aExpandedAfterSelectAll=this._aExpandedAfterSelectAll||[];this._mSelected=this._mSelected||{};this._mDeselected=this._mDeselected||{};this._bSelectAll=false;this._iLengthDelta=0;if(this.mParameters.collapseRecursive===undefined){this.bCollapseRecursive=true;}else{this.bCollapseRecursive=!!this.mParameters.collapseRecursive;}this._bIsAdapted=true;this._bReadOnly=true;this._aPendingRequests=[];this._aPendingChildrenRequests=[];this._aPendingSubtreeRequests=[];};
g.prototype.setNumberOfExpandedLevels=function(l){this.resetData();O.prototype.setNumberOfExpandedLevels.apply(this,arguments);};
g.prototype.getContexts=function(s,l,t){return this._getContextsOrNodes(false,s,l,t);};
g.prototype._getContextsOrNodes=function(r,s,l,t){if(!this.isResolved()||this.isInitial()){return[];}s=s||0;l=l||this.oModel.iSizeLimit;t=t||0;this._iPageSize=l;this._iThreshold=t;if(this._aNodes.length==0&&!this.isLengthFinal()){this._loadData(s,l,t);}var R=[];var n=this._retrieveNodeSection(s,l);this._aNodeCache=[];var S;var a=0;var b=0;var G={};for(var i=0;i<n.length;i++){var N=n[i];this._aNodeCache[s+i]=N&&N.context?N:undefined;R.push(N.context);if(!N.context){if(N.serverIndex!=undefined){if(S==undefined){S=N.serverIndex;}b=N.serverIndex;}else if(N.positionInParent!=undefined){var p=N.parent;G[p.key]=G[p.key]||[];G[p.key].push(N);}}}a=1+Math.max(b-(S||0),0);if(S!=undefined&&a){this._loadData(S,a,t);}for(var m in G){var o=this._calculateRequestParameters(G[m]);this._loadChildren(G[m][0].parent,o.skip,o.top);}if(r){return n;}else{return R;}};
g.prototype._calculateRequestParameters=function(m){var i,M=m[0].positionInParent,p=m[0].parent,a=Math.min(M+Math.max(this._iThreshold,m.length),p.children.length);for(i=M;i<a;i++){var o=p.children[i];if(o){break;}}return{skip:M,top:i-M};};
g.prototype._retrieveNodeSection=function(s,l){return this._bReadOnly?this._indexRetrieveNodeSection(s,l):this._mapRetrieveNodeSection(s,l);};
g.prototype._mapRetrieveNodeSection=function(s,l){var n=-1;var N=[];this._map(function(o,r,i,I,p){n++;if(n>=s){if(!o){if(i=="serverIndex"){o={serverIndex:I};}else if(i=="positionInParent"){o={positionInParent:I,parent:p};}}N.push(o);}if(N.length>=l){r.broken=true;}});return N;};
g.prototype._indexRetrieveNodeSection=function(s,l){var i,n=[],N,o;for(i=s;i<s+l;i++){N=this.getNodeInfoByRowIndex(i);if(N.index!==undefined&&N.index<this._aNodes.length){o=this._aNodes[N.index];if(!o){o={serverIndex:N.index};}}else if(N.parent){o=N.parent.children[N.childIndex];if(!o){o={parent:N.parent,positionInParent:N.childIndex};}}if(o){n.push(o);o=null;}}return n;};
g.prototype.getNodes=function(s,l,t){return this._getContextsOrNodes(true,s,l,t);};
g.prototype._map=function(m){var a,t,b,h,r={broken:false};a=function(n){if(n.addedSubtrees.length>0&&!n.nodeState.collapsed){for(var j=0;j<n.addedSubtrees.length;j++){var s=n.addedSubtrees[j];t(n,s);if(r.broken){return;}}}};t=function(n,s){var S=s._getSubtree();if(s){if(Array.isArray(S)){if(s._oSubtreeRoot){h(S,s._oSubtreeRoot.serverIndex,s._oSubtreeRoot,s._oSubtreeRoot.originalLevel||0,n.level+1);}else{h(S,null,null,0,n.level+1);}}else{s._oSubtreeRoot.level=n.level+1;b(s._oSubtreeRoot,false,s._oNewParentNode,-1,s._oSubtreeRoot);}}};b=function(n,I,p,P,o){if(!I){if(!n.nodeState.removed||o==n){m(n,r,"positionInParent",P,p);if(r.broken){return;}}}a(n);if(r.broken){return;}if(n&&n.children&&n.nodeState.expanded){for(var i=0;i<n.children.length;i++){var j=n.children[i];if(j&&!j.nodeState.removed&&!j.nodeState.reinserted){j.level=n.level+1;}if(j&&!j.nodeState.removed){b(j,false,n,i,o);}else if(!j){m(j,r,"positionInParent",i,n);}if(r.broken){return;}}}};h=function(j,s,I,S,n){for(var i=0;i<j.length;i++){var N=j[i];if(N&&N.nodeState&&N.nodeState.removed&&N!=I){if(!N.initiallyCollapsed){i+=N.magnitude;}continue;}if(N&&S>=0&&n>=0){N.level=N.originalLevel||0;var l=(N.level-S)||0;N.level=n+l||0;}if(s===null){m(N,r,"newNode");}else{m(N,r,"serverIndex",s+i);}if(r.broken){return;}if(N&&N.nodeState){if(!N.initiallyCollapsed&&N.nodeState.collapsed){i+=N.magnitude;}else if(N.initiallyCollapsed&&N.nodeState.expanded){b(N,true);if(r.broken){return;}}else if(!N.initiallyCollapsed&&N.nodeState.expanded){a(N);}}if(r.broken){return;}}};h(this._aNodes,0,null);};
g.prototype._loadData=function(s,t,i){var a=this;if(!this.bSkipDataEvents){this.fireDataRequested();}this.bSkipDataEvents=false;return this._requestServerIndexNodes(s,t,i).then(function(r){a._addServerIndexNodes(r.oData,r.iSkip);a._fireChange({reason:C.Change});a.fireDataReceived({data:r.oData});},function(E){var A=E.statusCode===0;if(!A){a._aNodes=[];a._bLengthFinal=true;a._fireChange({reason:C.Change});a.fireDataReceived();}});};
g.prototype._restoreServerIndexNodes=function(s,t,i){var a=this;return this._requestServerIndexNodes(s,t,0,i).then(function(r){a._addServerIndexNodes(r.oData,r.iSkip);return r;});};
g.prototype._addServerIndexNodes=function(D,s){var E,k,I,i,t=function(n,b){return(!n.isDeepOne&&!n.initiallyCollapsed&&n.serverIndex<I&&n.serverIndex+n.magnitude>=I);};if(!this._bLengthFinal){var a=D.__count?parseInt(D.__count):0;this._aNodes[a-1]=undefined;this._bLengthFinal=true;}if(D.results&&D.results.length>0){for(i=0;i<D.results.length;i++){E=D.results[i];k=this.oModel.getKey(E);I=s+i;var m=E[this.oTreeProperties["hierarchy-node-descendant-count-for"]];if(m<0){m=0;L.error("The entry data with key '"+k+"' under binding path '"+this.getPath()+"' has a negative 'hierarchy-node-descendant-count-for' which isn't allowed.");}var n=this._aNodes[I]=this._aNodes[I]||{key:k,context:this.oModel.getContext("/"+k),magnitude:m,level:E[this.oTreeProperties["hierarchy-level-for"]],originalLevel:E[this.oTreeProperties["hierarchy-level-for"]],initiallyCollapsed:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="collapsed",nodeState:{isLeaf:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="leaf",expanded:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="expanded",collapsed:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="collapsed",selected:this._mSelected[k]?this._mSelected[k].nodeState.selected:false},children:[],addedSubtrees:[],serverIndex:I,parent:null,isDeepOne:false};if(this._iLowestServerLevel===null){this._iLowestServerLevel=n.level;}else{this._iLowestServerLevel=Math.min(this._iLowestServerLevel,n.level);}if(this._bSelectAll){if(!this._aExpandedAfterSelectAll.some(t)){this.setNodeSelection(n,true);}}}}};
g.prototype._requestServerIndexNodes=function(s,t,h,I){return new Promise(function(r,j){var R={iSkip:s,iTop:t+(h||0),iThreshold:h};this._aPendingRequests.sort(function(a,b){return a.iSkip-b.iSkip;});for(var i=0;i<this._aPendingRequests.length;i++){if(f._determineRequestDelta(R,this._aPendingRequests[i])===false){return;}}s=R.iSkip;t=R.iTop;function _(D){var a=this._aPendingRequests.indexOf(R);this._aPendingRequests.splice(a,1);r({oData:D,iSkip:s,iTop:t});}function k(E){var a=this._aPendingRequests.indexOf(R);this._aPendingRequests.splice(a,1);j(E);}var U=["$skip="+s,"$top="+t];if(!this._bLengthFinal||I){U.push("$inlinecount=allpages");}if(this.sCustomParams){U.push(this.sCustomParams);}var l=new F(this.oTreeProperties["hierarchy-level-for"],"LE",this.getNumberOfExpandedLevels());var m=[l];if(this.aApplicationFilters){m=m.concat(this.aApplicationFilters);}var A=this.getResolvedPath();if(A){R.oRequestHandle=this.oModel.read(A,{urlParameters:U,filters:[new F({filters:m,and:true})],sorters:this.aSorters||[],success:_.bind(this),error:k.bind(this),groupId:this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId});this._aPendingRequests.push(R);}}.bind(this));};
g.prototype._propagateMagnitudeChange=function(p,D){while(p!=null&&(p.initiallyCollapsed||p.isDeepOne)){p.magnitude+=D;if(!p.nodeState.expanded){return;}p=p.parent;}};
g.prototype._getInitialMagnitude=function(n){var D=0,o;if(n.isDeepOne){return 0;}if(n.children){for(var i=0;i<n.children.length;i++){o=n.children[i];D+=o.magnitude+1;}}return n.magnitude-D;};
g.prototype._loadChildren=function(p,s,t){var a=this;if(!this.bSkipDataEvents){this.fireDataRequested();}this.bSkipDataEvents=false;this._requestChildren(p,s,t).then(function(r){a._addChildNodes(r.oData,p,r.iSkip);a._fireChange({reason:C.Change});a.fireDataReceived({data:r.oData});},function(E){var A=E.statusCode===0;if(!A){if(p.childCount===undefined){p.children=[];p.childCount=0;a._fireChange({reason:C.Change});}a.fireDataReceived();}});};
g.prototype._restoreChildren=function(p,s,t){var a=this,P=p.context.getProperty(this.oTreeProperties["hierarchy-node-for"]);return this._requestChildren(p,s,t,true).then(function(r){var n;a._map(function(N,R){if(N&&N.context.getProperty(a.oTreeProperties["hierarchy-node-for"])===P){n=N;R.broken=true;}});if(n){a._addChildNodes(r.oData,n,r.iSkip);a.expand(n,true);}return r;});};
g.prototype._addChildNodes=function(D,p,s){if(p.childCount==undefined&&D&&D.__count){var a=D.__count?parseInt(D.__count):0;p.childCount=a;p.children[a-1]=undefined;if(p.nodeState.expanded){this._propagateMagnitudeChange(p,a);}else{p.magnitude=a;}this._cleanTreeStateMaps();}if(D.results&&D.results.length>0){for(var i=0;i<D.results.length;i++){var E=D.results[i];this._createChildNode(E,p,s+i);}}};
g.prototype._createChildNode=function(E,p,P){var k=this.oModel.getKey(E);var i;if(p.containingServerIndex!==undefined){i=p.containingServerIndex;}else{i=p.serverIndex;}var n=p.children[P]=p.children[P]||{key:k,context:this.oModel.getContext("/"+k),magnitude:0,level:p.level+1,originalLevel:p.level+1,initiallyCollapsed:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="collapsed",nodeState:{isLeaf:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="leaf",expanded:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="expanded",collapsed:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="collapsed",selected:this._mSelected[k]?this._mSelected[k].nodeState.selected:false},positionInParent:P,children:[],addedSubtrees:[],parent:p,originalParent:p,isDeepOne:true,containingServerIndex:i};if(this._bSelectAll&&this._aExpandedAfterSelectAll.indexOf(p)===-1){this.setNodeSelection(n,true);}return n;};
g.prototype._requestChildren=function(p,s,t,I){return new Promise(function(r,h){var R={sParent:p.key,iSkip:s,iTop:t};this._aPendingChildrenRequests.sort(function(a,b){return a.iSkip-b.iSkip;});for(var i=0;i<this._aPendingChildrenRequests.length;i++){var P=this._aPendingChildrenRequests[i];if(P.sParent===R.sParent){if(f._determineRequestDelta(R,P)===false){return;}}}s=R.iSkip;t=R.iTop;function _(D){var a=this._aPendingChildrenRequests.indexOf(R);this._aPendingChildrenRequests.splice(a,1);r({oData:D,iSkip:s,iTop:t});}function j(E){var a=this._aPendingChildrenRequests.indexOf(R);this._aPendingChildrenRequests.splice(a,1);h(E);}var U=["$skip="+s,"$top="+t];if(p.childCount==undefined||I){U.push("$inlinecount=allpages");}if(this.sCustomParams){U.push(this.sCustomParams);}var l=new F(this.oTreeProperties["hierarchy-parent-node-for"],"EQ",p.context.getProperty(this.oTreeProperties["hierarchy-node-for"]));var k=[l];if(this.aApplicationFilters){k=k.concat(this.aApplicationFilters);}var A=this.getResolvedPath();if(A){R.oRequestHandle=this.oModel.read(A,{urlParameters:U,filters:[new F({filters:k,and:true})],sorters:this.aSorters||[],success:_.bind(this),error:j.bind(this),groupId:this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId});this._aPendingChildrenRequests.push(R);}}.bind(this));};
g.prototype._loadSubTree=function(p,l){var t=this;var m;if(p.serverIndex!==undefined&&!p.initiallyCollapsed){var M=[];var s;var S=p.serverIndex+1;var a=S+p.magnitude;for(var i=S;i<a;i++){if(this._aNodes[i]===undefined){if(!s){s={iSkip:i,iTop:1};M.push(s);}else{s.iTop++;}}else{s=null;}}if(M.length){m=Promise.all(M.map(function(o){return t._loadData(o.iSkip,o.iTop);}));}}if(!m){m=Promise.resolve();}return m.then(function(){if(!t.bSkipDataEvents){t.fireDataRequested();}t.bSkipDataEvents=false;return t._requestSubTree(p,l).then(function(r){t._addSubTree(r.oData,p);t.fireDataReceived({data:r.oData});},function(E){L.warning("ODataTreeBindingFlat: Error during subtree request",E.message);var A=E.statusCode===0;if(!A){t.fireDataReceived();}});});};
g.prototype._addSubTree=function(D,s){if(D.results&&D.results.length>0){var n,p,E,N,P,a=[],m={},i,j,k;if(s.serverIndex!==undefined&&!s.initiallyCollapsed){a=this._aNodes.slice(s.serverIndex,s.serverIndex+s.magnitude+1);}else{a.push(s);}for(j=a.length-1;j>=0;j--){N=a[j];if(N.nodeState.isLeaf){continue;}if(N.initiallyCollapsed||N.isDeepOne){N.childCount=undefined;if(N.magnitude&&N.nodeState.expanded){this._propagateMagnitudeChange(N.parent,-N.magnitude);}N.magnitude=0;}m[N.context.getProperty(this.oTreeProperties["hierarchy-node-for"])]=N;}for(i=0;i<D.results.length;i++){E=D.results[i];n=E[this.oTreeProperties["hierarchy-node-for"]];if(m[n]){continue;}p=E[this.oTreeProperties["hierarchy-parent-node-for"]];P=m[p];if(P.childCount===undefined){P.childCount=0;}N=P.children[P.childCount];if(N){a.push(N);if(N.childCount){N.childCount=undefined;if(N.initiallyCollapsed||N.isDeepOne){N.magnitude=0;}}}else{N=this._createChildNode(E,P,P.childCount);if(N.nodeState.expanded){this._aExpanded.push(N);this._sortNodes(this._aExpanded);}}P.childCount++;if(P.nodeState.expanded){this._propagateMagnitudeChange(P,1);}else{P.magnitude++;}if(!N.nodeState.isLeaf){m[n]=N;}}for(k=a.length-1;k>=0;k--){N=a[k];if(!N.nodeState.expanded&&!N.nodeState.isLeaf){this.expand(N,true);}}}};
g.prototype._requestSubTree=function(p,l){return new Promise(function(r,a){var R={sParent:p.key,iLevel:l};for(var i=0;i<this._aPendingSubtreeRequests.length;i++){var P=this._aPendingSubtreeRequests[i];if(P.sParent===R.sParent&&P.iLevel===R.iLevel){return;}}function _(D){var j=this._aPendingSubtreeRequests.indexOf(R);this._aPendingSubtreeRequests.splice(j,1);r({oData:D,sParent:R.sParent,iLevel:R.iLevel});}function b(E){var j=this._aPendingSubtreeRequests.indexOf(R);this._aPendingSubtreeRequests.splice(j,1);a(E);}var U=[];if(this.sCustomParams){U.push(this.sCustomParams);}var n=new F(this.oTreeProperties["hierarchy-node-for"],"EQ",p.context.getProperty(this.oTreeProperties["hierarchy-node-for"]));var o=new F(this.oTreeProperties["hierarchy-level-for"],"LE",l);var h=[n,o];if(this.aApplicationFilters){h=h.concat(this.aApplicationFilters);}var A=this.getResolvedPath();if(A){R.oRequestHandle=this.oModel.read(A,{urlParameters:U,filters:[new F({filters:h,and:true})],sorters:this.aSorters||[],success:_.bind(this),error:b.bind(this),groupId:this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId});this._aPendingSubtreeRequests.push(R);}}.bind(this));};
g.prototype.findNode=function(r){return this._bReadOnly?this._indexFindNode(r):this._mapFindNode(r);};
g.prototype._mapFindNode=function(r){if(this.isInitial()){return undefined;}var o=this._aNodeCache[r];if(o){return o;}var n=-1;this._map(function(N,R,i,I,p){n++;if(n===r){o=N;R.broken=true;}});return o;};
g.prototype._indexFindNode=function(r){if(this.isInitial()){return undefined;}var n=this._aNodeCache[r];if(n){return n;}var N=this.getNodeInfoByRowIndex(r);if(N.parent){n=N.parent.children[N.childIndex];}else{n=this._aNodes[N.index];}this._aNodeCache[r]=n;return n;};
g.prototype.toggleIndex=function(r){var t=this.findNode(r);c(t!=undefined,"toggleIndex("+r+"): Node not found!");if(t){if(t.nodeState.expanded){this.collapse(t);}else{this.expand(t);}}};
g.prototype.expand=function(r,s){var t=r;if(typeof r!=="object"){t=this.findNode(r);c(t!=undefined,"expand("+r+"): Node not found!");}if(t.nodeState.expanded){return;}t.nodeState.expanded=true;t.nodeState.collapsed=false;var i=this._aCollapsed.indexOf(t);if(i!=-1){this._aCollapsed.splice(i,1);}this._aExpanded.push(t);this._sortNodes(this._aExpanded);if(t.serverIndex!==undefined){this._aNodeChanges[t.serverIndex]=true;}if(this._bSelectAll){this._aExpandedAfterSelectAll.push(t);}if(t.initiallyCollapsed&&t.childCount==undefined){this._loadChildren(t,0,this._iPageSize+this._iThreshold);}else{this._propagateMagnitudeChange(t.parent,t.magnitude);}this._cleanTreeStateMaps();this._aNodeCache=[];if(!s){this._fireChange({reason:C.Expand});}};
g.prototype.expandToLevel=function(l){this.setNumberOfExpandedLevels(l);};
g.prototype.expandNodeToLevel=function(i,l,s){if(!this._bReadOnly){return Promise.reject(new Error("ODataTreeBindingFlat: expandNodeToLevel is not supported while there are pending changes in the hierarchy"));}var S=this.findNode(i);return this._loadSubTree(S,l).then(function(){if(!s){this._fireChange({reason:C.Expand});}}.bind(this));};
g.prototype.collapse=function(r,s){var t=r;if(typeof r!=="object"){t=this.findNode(r);c(t!=undefined,"expand("+r+"): Node not found!");}if(t.nodeState.collapsed){return;}t.nodeState.expanded=false;t.nodeState.collapsed=true;var i=this._aExpanded.indexOf(t);if(i!=-1){this._aExpanded.splice(i,1);}if(this._bSelectAll){i=this._aExpandedAfterSelectAll.indexOf(t);if(i!==-1){this._aExpandedAfterSelectAll.splice(i,1);}}this._aCollapsed.push(t);this._sortNodes(this._aCollapsed);if(t.isDeepOne){this._propagateMagnitudeChange(t.parent,t.magnitude*-1);}if(t.serverIndex!==undefined){this._aNodeChanges[t.serverIndex]=true;}this._cleanUpSelection();this._cleanTreeStateMaps();this._aNodeCache=[];if(!s){this._fireChange({reason:C.Collapse});}};
g.prototype.collapseToLevel=function(l){var o=-1,a=[],r;if(this.bCollapseRecursive){for(var k in this._mSelected){var s=this._mSelected[k];if(s.level>l){r=this.getRowIndexByNode(s);a.push(r);if(this._sLeadSelectionKey==k){o=r;}this.setNodeSelection(s,false);}}}this.setNumberOfExpandedLevels(l);if(this.bCollapseRecursive&&a.length){this._publishSelectionChanges({rowIndices:a,oldIndex:o,leadIndex:-1});}};
g.prototype._getInvisibleSelectedNodes=function(){var a=[];var i=true;var b=function(n,B){if(n.nodeState.collapsed||(n.nodeState.removed&&!n.nodeState.reinserted)){i=false;B.broken=true;}};for(var k in this._mSelected){var s=this._mSelected[k];i=true;this._up(s,b,false);if(!i){a.push(s);}}return a;};
g.prototype._cleanUpSelection=function(b){var i=this._getInvisibleSelectedNodes();i.forEach(function(s){if(s.key==this._sLeadSelectionKey){this._sLeadSelectionKey=null;}if(this.bCollapseRecursive||b){this.setNodeSelection(s,false);}}.bind(this));if((this.bCollapseRecursive||b)&&i.length){this._publishSelectionChanges({rowIndices:[],indexChangesCouldNotBeDetermined:true});}};
g.prototype._isInSubtree=function(a,o){var i=false;var b=function(n,B){if(n==a){B.broken=true;i=true;}};this._up(o,b,false);return i;};
g.prototype._up=function(n,U,o){var r={broken:false};var p=this._getParent(n,o);if(p){this._structuralUp(p,U,r,o);}else{this._flatUp(n,U,r,true);}};
g.prototype._structuralUp=function(n,U,b,o){var p=n;do{U(p,b);if(b.broken){return;}n=p;p=this._getParent(p);}while(p);this._flatUp(n,U,b);};
g.prototype._flatUp=function(n,U,b,I){var s=n.serverIndex,i=I?s-1:s,o,p;for(;i>=0;i--){if(this._aNodeChanges[i]){o=this._aNodes[i];if(o.initiallyCollapsed){continue;}if(o.serverIndex+o.magnitude>=s){U(o,b);if(b.broken){return;}p=this._getParent(o);if(p){this._structuralUp(p,U,b);return;}}else{continue;}}}};
g.prototype._getParent=function(n,o){return o?n.originalParent:n.parent;};
g.prototype._cleanTreeStateMaps=function(){this._iLengthDelta=this._bReadOnly?this._indexCleanTreeStateMaps():this._mapCleanTreeStateMaps();};
g.prototype._indexCleanTreeStateMaps=function(){return this._calcIndexDelta(this._aNodes.length);};
g.prototype._mapCleanTreeStateMaps=function(){var a=this._aCollapsed.concat(this._aRemoved).concat(this._aExpanded).concat(this._aAdded),v=true,V,D=0,b=function(n,B){if(n.nodeState.collapsed||(n.nodeState.removed&&!n.nodeState.reinserted)){v=false;B.broken=true;}},s={};var h=[[0,1],[-1,0]];a.forEach(function(n){if(s[n.key]){return;}else{s[n.key]=true;}if(n.nodeState.added){if(!n.nodeState.removed||n.nodeState.reinserted){v=true;this._up(n,b,false);if(v){D++;}}}else if(n.nodeState.collapsed||n.nodeState.expanded||n.nodeState.removed){v=true;this._up(n,b,false);if(v){if(n.nodeState.removed&&!n.nodeState.reinserted){if(n.isDeepOne||n.initiallyCollapsed){D-=1;}else{D-=(n.magnitude+1);}}else{if(n.nodeState.collapsed&&n.serverIndex!==undefined&&!n.initiallyCollapsed){D-=n.magnitude;}if(n.nodeState.expanded&&(n.isDeepOne||n.initiallyCollapsed)){D+=n.children.length;}}}if(n.nodeState.reinserted){V=v;v=true;this._up(n,b,true);var i=(h[v|0][V|0]);if(i){if(n.isDeepOne){D+=i*1;}else if(n.initiallyCollapsed){D+=i;}else{D+=i*(1+n.magnitude);}}}}}.bind(this));return D;};
g.prototype.isLengthFinal=function(){return this._bLengthFinal;};
g.prototype.getLength=function(){return this._aNodes.length+this._iLengthDelta;};
g.prototype.getContextByIndex=function(r){if(this.isInitial()){return undefined;}var n=this.findNode(r);return n&&n.context;};
g.prototype.getNodeByIndex=function(r){if(this.isInitial()){return undefined;}var n=this.findNode(r);return n;};
g.prototype.isExpanded=function(r){var n=this.findNode(r);return n&&n.nodeState.expanded;};
g.prototype.hasChildren=function(o){if(!o){return false;}var n=this._findNodeByContext(o);var N=n&&n.node;return!(N&&N.nodeState.isLeaf);};
g.prototype.nodeHasChildren=function(n){return!(n&&n.nodeState.isLeaf);};
g.prototype._hasChangedEntity=function(m){var b=false;this._map(function(n,r){if(n.key in m){b=true;r.broken=true;}});return b;};
g.prototype.setNodeSelection=function(n,i){c(n,"Node must be defined!");n.nodeState.selected=i;if(i){delete this._mDeselected[n.key];this._mSelected[n.key]=n;}else{delete this._mSelected[n.key];this._mDeselected[n.key]=n;if(n.key===this._sLeadSelectionKey){this._sLeadSelectionKey=null;}}};
g.prototype.isIndexSelected=function(r){var n=this.findNode(r);return n&&n.nodeState?n.nodeState.selected:false;};
g.prototype.isIndexSelectable=function(r){var n=this.findNode(r);return!!n;};
g.prototype._clearSelection=function(){return this._bReadOnly?this._indexClearSelection():this._mapClearSelection();};
g.prototype._indexClearSelection=function(){var o=-1,a=[],s,n,r;this._bSelectAll=false;this._aExpandedAfterSelectAll=[];for(s in this._mSelected){n=this._mSelected[s];this.setNodeSelection(n,false);r=this.getRowIndexByNode(n);a.push(r);if(this._sLeadSelectionKey==s){o=r;}}return{rowIndices:a,oldIndex:o,leadIndex:-1};};
g.prototype._mapClearSelection=function(){var n=-1;var o=-1;var m=0;var a=[];this._bSelectAll=false;this._aExpandedAfterSelectAll=[];for(var k in this._mSelected){if(k){m++;}}this._map(function(N,r,i,I,p){n++;if(N&&N.nodeState.selected){this.setNodeSelection(N,false);a.push(n);if(this._sLeadSelectionKey==N.key){o=n;}if(a.length==m){r.broken=true;}}}.bind(this));return{rowIndices:a,oldIndex:o,leadIndex:-1};};
g.prototype.setSelectedIndex=function(r){var n=this.findNode(r);if(n){var o=this._clearSelection();var i=o.rowIndices.indexOf(r);if(i>=0){o.rowIndices.splice(i,1);}else{o.rowIndices.push(r);}o.leadKey=n.key;o.leadIndex=r;this.setNodeSelection(n,true);this._publishSelectionChanges(o);}else{L.warning("ODataTreeBindingFlat: The selection of index '"+r+"' was ignored. Please make sure to only select rows, for which data has been fetched to the client.");}};
g.prototype.getSelectedIndex=function(){return this._bReadOnly?this._indexGetSelectedIndex():this._mapGetSelectedIndex();};
g.prototype._indexGetSelectedIndex=function(){if(!this._sLeadSelectionKey||d(this._mSelected)){return-1;}var s=this._mSelected[this._sLeadSelectionKey];if(s){return this.getRowIndexByNode(s);}else{return-1;}};
g.prototype._mapGetSelectedIndex=function(){if(!this._sLeadSelectionKey||d(this._mSelected)){return-1;}var n=-1;this._map(function(N,r){n++;if(N){if(N.key===this._sLeadSelectionKey){r.broken=true;}}}.bind(this));return n;};
g.prototype.getSelectedIndices=function(){return this._bReadOnly?this._indexGetSelectedIndices():this._mapGetSelectedIndices();};
g.prototype._indexGetSelectedIndices=function(){var n=this._getSelectedNodesInfo();return n.map(function(N){return N.rowIndex;});};
g.prototype._mapGetSelectedIndices=function(){var r=[];if(d(this._mSelected)){return r;}var n=-1;this._map(function(N){n++;if(N){if(N.nodeState&&N.nodeState.selected){r.push(n);}}});return r;};
g.prototype.getSelectedNodesCount=function(){var s;if(this._bSelectAll){if(this._bReadOnly){var r=[],n=0,k;this._aExpandedAfterSelectAll.sort(function(a,b){var A=this._getRelatedServerIndex(a);var B=this._getRelatedServerIndex(b);c(A!=undefined,"getSelectedNodesCount: (containing) Server-Index not found for node 'a'");c(B!=undefined,"getSelectedNodesCount: (containing) Server-Index not found node 'b'");if(A==B&&a.isDeepOne&&b.isDeepOne){return a.originalLevel-b.originalLevel;}return A-B;}.bind(this));var l=-1,N,h,i;for(i=0;i<this._aExpandedAfterSelectAll.length;i++){N=this._aExpandedAfterSelectAll[i];h=this._getRelatedServerIndex(N);if(h<=l&&!N.initiallyCollapsed){continue;}if(N.initiallyCollapsed){l=h;}else{l=h+N.magnitude;}r.push(N);n+=N.magnitude;}var j=function(N,b){if(r.indexOf(N)!==-1){n--;b.broken=true;}};for(k in this._mSelected){this._up(this._mSelected[k],j,true);}var I;var m=function(N,b){if(N.nodeState.collapsed||(N.nodeState.removed&&!N.nodeState.reinserted)||r.indexOf(N)!==-1){I=false;b.broken=true;}};for(k in this._mDeselected){I=true;this._up(this._mDeselected[k],m,true);if(I){n++;}}s=this.getLength()-n;}else{s=0;this._map(function(N,R,a,b,p){var P;if(N){if(N.nodeState.selected){s++;}}else if(N===undefined&&a==="serverIndex"){var q=true;for(var i=b-1;i>=0;i--){if(this._aNodeChanges[i]){P=this._aNodes[i];if(P.serverIndex+P.magnitude>=b&&this._aExpandedAfterSelectAll.indexOf(P)!==-1){q=false;break;}}}if(q){s++;}}}.bind(this));}}else{var o=this._getInvisibleSelectedNodes();s=Math.max(Object.keys(this._mSelected).length-o.length,0);}return s;};
g.prototype.getSelectedContexts=function(){return this._bReadOnly?this._indexGetSelectedContexts():this._mapGetSelectedContexts();};
g.prototype._indexGetSelectedContexts=function(){var n=this._getSelectedNodesInfo();return n.map(function(N){return N.node.context;});};
g.prototype._mapGetSelectedContexts=function(){var r=[];if(d(this._mSelected)){return r;}var m=function(n){if(n){if(n.nodeState.selected&&!n.isArtificial){r.push(n.context);}}};this._map(m);return r;};
g.prototype.setSelectionInterval=function(a,t){var I,i,m=this._clearSelection(),b={},r=[],s=this._setSelectionInterval(a,t,true);for(i=0;i<m.rowIndices.length;i++){I=m.rowIndices[i];b[I]=true;}for(i=0;i<s.rowIndices.length;i++){I=s.rowIndices[i];if(b[I]){delete b[I];}else{b[I]=true;}}for(I in b){if(b[I]){r.push(parseInt(I));}}this._publishSelectionChanges({rowIndices:r,oldIndex:m.oldIndex,leadIndex:s.leadIndex,leadKey:s.leadKey});};
g.prototype._setSelectionInterval=function(i,t,s){return this._bReadOnly?this._indexSetSelectionInterval(i,t,s):this._mapSetSelectionInterval(i,t,s);};
g.prototype._indexSetSelectionInterval=function(a,t,s){var n=Math.min(a,t),N=Math.max(a,t),b=[],h=[],o,j,i,p;s=!!s;for(i=n;i<=N;i++){j=this.findNode(i);if(j){if(j.nodeState.selected!==s){h.push(i);}if(j.key===this._sLeadSelectionKey){o=i;}this.setNodeSelection(j,s);b.push(j);}}p={rowIndices:h,oldIndex:o,leadIndex:o&&!s?-1:undefined};if(b.length>0&&s){p.leadKey=b[b.length-1].key;p.leadIndex=N;}return p;};
g.prototype._mapSetSelectionInterval=function(i,t,s){var n=Math.min(i,t);var N=Math.max(i,t);var a=[];var b=[];var h=Math.abs(N-n)+1;var o;var j=-1;var m=function(k,r,I,q,P){j++;if(k){if(j>=n&&j<=N){if(k.nodeState.selected!==!!s){b.push(j);}if(k.key===this._sLeadSelectionKey){o=j;}this.setNodeSelection(k,!!s);a.push(k);if(a.length===h){r.broken=true;}}}}.bind(this);this._map(m);var p={rowIndices:b,oldIndex:o,leadIndex:o&&!s?-1:undefined};if(a.length>0&&s){var l=a[a.length-1];p.leadKey=l.key;p.leadIndex=N;}return p;};
g.prototype.addSelectionInterval=function(i,t){var p=this._setSelectionInterval(i,t,true);this._publishSelectionChanges(p);};
g.prototype.removeSelectionInterval=function(i,t){var p=this._setSelectionInterval(i,t,false);this._publishSelectionChanges(p);};
g.prototype.selectAll=function(){if(this._bReadOnly){this._indexSelectAll();}else{this._mapSelectAll();}};
g.prototype._indexSelectAll=function(){this._bSelectAll=true;this._aExpandedAfterSelectAll=[];var p={rowIndices:[],oldIndex:-1,selectAll:true};var l=this.getLength(),i,n;for(i=0;i<l;i++){n=this.findNode(i);if(n&&!n.isArtificial){if(n.key===this._sLeadSelectionKey){p.oldIndex=i;}if(!n.nodeState.selected){p.rowIndices.push(i);}this.setNodeSelection(n,true);p.leadKey=n.key;p.leadIndex=i;}}this._publishSelectionChanges(p);};
g.prototype._mapSelectAll=function(){this._bSelectAll=true;this._aExpandedAfterSelectAll=[];var p={rowIndices:[],oldIndex:-1,selectAll:true};var n=-1;this._map(function(N){if(!N||!N.isArtificial){n++;}if(N){if(N.key===this._sLeadSelectionKey){p.oldIndex=n;}if(N){if(!N.isArtificial&&!N.nodeState.selected){p.rowIndices.push(n);}this.setNodeSelection(N,true);p.leadKey=N.key;p.leadIndex=n;}}}.bind(this));this._publishSelectionChanges(p);};
g.prototype.clearSelection=function(s){var o=this._clearSelection();if(!s){this._publishSelectionChanges(o);}};
g.prototype._publishSelectionChanges=function(p){p.oldIndex=p.oldIndex||this.getSelectedIndex();p.rowIndices.sort(function(a,b){return a-b;});if(p.leadIndex>=0&&p.leadKey){this._sLeadSelectionKey=p.leadKey;}else if(p.leadIndex===-1){this._sLeadSelectionKey=undefined;}else{p.leadIndex=p.oldIndex;}if(p.rowIndices.length>0||(p.leadIndex!=undefined&&p.leadIndex!==-1)||p.indexChangesCouldNotBeDetermined){this.fireSelectionChanged(p);}};
g.prototype.setCollapseRecursive=function(b){this.bCollapseRecursive=!!b;};
g.prototype.resetData=function(){O.prototype.resetData.apply(this,arguments);this._aNodes=[];this._aNodeCache=[];this._aCollapsed=[];this._aExpanded=[];this._aExpandedAfterSelectAll=[];this._mSelected={};this._mDeselected={};this._aAdded=[];this._aRemoved=[];this._aNodeChanges=[];this._aAllChangedNodes=[];this._bLengthFinal=false;this._iLowestServerLevel=null;this._bSelectAll=false;this._bReadOnly=true;this._iLengthDelta=0;};
g.prototype._findNodeByContext=function(o){for(var i in this._aNodeCache){if(this._aNodeCache[i]&&this._aNodeCache[i].context==o){return{node:this._aNodeCache[i],index:parseInt(i)};}}var n=-1;var N;this._map(function(a,r,I,b,p){n++;if(a){if(a.context===o){N=a;r.broken=true;}}});return{node:N,index:n};};
g.prototype._getCorrectChangeGroup=function(k){if(!k){k=this.getResolvedPath();}return this.oModel._resolveGroup(k).groupId;};
g.prototype.createEntry=function(p){var a=this.getResolvedPath();var n;if(a){p=p||{};p.groupId=this._getCorrectChangeGroup(a);p.refreshAfterChange=false;n=this.oModel.createEntry(a,p);}else{L.warning("ODataTreeBindingFlat: createEntry failed, as the binding path could not be resolved.");}return n;};
g.prototype.submitChanges=function(p){p=p||{};var a=this.getResolvedPath(),o=this._optimizeChanges();if(!a){L.warning("ODataTreeBindingFlat: submitChanges failed, because the binding-path could not be resolved.");return;}p.groupId=this._getCorrectChangeGroup(a);var b=p.success||function(){};var h=p.error||function(){};var r=false;p.success=function(D){b(D);var s=false;if(D.__batchResponses&&D.__batchResponses[0]&&D.__batchResponses[0].__changeResponses&&D.__batchResponses[0].__changeResponses.length>0){var j=D.__batchResponses[0].__changeResponses;for(var i=0;i<j.length;i++){var R=j[i];var S=parseInt(R.statusCode);if(S<200||S>299){s=true;break;}}if(s){}else if(this._bRestoreTreeStateAfterChange&&!r&&(!this.aApplicationFilters||this.aApplicationFilters.length===0)){this._restoreTreeState(o).catch(function(k){L.error("ODataTreeBindingFlat - "+k.message,k.stack);this._refresh(true);}.bind(this));}else{this._refresh(true);}}else{L.warning("ODataTreeBindingFlat.submitChanges - success: Batch-request response does not contain change response.");}}.bind(this);p.error=function(E){h(E);};this._generateSubmitData(o,function(i){L.error("ODataTreeBindingFlat - Tree state restoration request failed. "+i.message,i.stack);r=true;});this.oModel.submitChanges(p);};
g.prototype._generateSubmitData=function(o,r){var R=o.removed,a=o.creationCancelled,A=o.added,m=o.moved,t=this;function s(n){c(n.context,"Node does not have a context.");var p=n.parent.context.getProperty(t.oTreeProperties["hierarchy-node-for"]);t.oModel.setProperty(t.oTreeProperties["hierarchy-parent-node-for"],p,n.context);}var b={groupId:this._getCorrectChangeGroup(),error:r};A.forEach(s);m.forEach(function(n){s(n);if(this._bRestoreTreeStateAfterChange&&(!this.aApplicationFilters||this.aApplicationFilters.length===0)){this._generatePreorderPositionRequest(n,b);this._generateSiblingsPositionRequest(n,b);}}.bind(this));R.forEach(function(n){this._generateDeleteRequest(n);L.debug("ODataTreeBindingFlat: DELETE "+n.key);}.bind(this));a.forEach(function(n){this._generateDeleteRequest(n);}.bind(this));};
g.prototype._generatePreorderPositionRequest=function(n,p){var G,k,K,U,s,a,b=[],S=this.aSorters||[],i;if(p){G=p.groupId||this.sGroupId;s=p.success;a=p.error;}if(this.aApplicationFilters){b=b.concat(this.aApplicationFilters);}for(i=this._aTreeKeyProperties.length-1;i>=0;i--){k=this._aTreeKeyProperties[i];if(!K){K=k;}else{K+=","+k;}b.push(new F(k,"EQ",n.context.getProperty(k)));}b.push(new F(this.oTreeProperties["hierarchy-level-for"],"LE",this.getNumberOfExpandedLevels()));U=e({},this.mParameters);U.select=K+","+this.oTreeProperties["hierarchy-node-for"]+","+this.oTreeProperties["hierarchy-node-descendant-count-for"]+","+this.oTreeProperties["hierarchy-drill-state-for"]+","+this.oTreeProperties["hierarchy-preorder-rank-for"];var A=this.getResolvedPath();if(A){this.oModel.read(A,{urlParameters:this.oModel.createCustomParams(U),filters:[new F({filters:b,and:true})],sorters:S,groupId:G,success:s,error:a});}};
g.prototype._generateSiblingsPositionRequest=function(n,p){var G,U,s,a;if(p){G=p.groupId||this.sGroupId;s=p.success;a=p.error;}U=e({},this.mParameters);U.select=this.oTreeProperties["hierarchy-sibling-rank-for"];this.oModel.read(n.context.getPath(),{urlParameters:this.oModel.createCustomParams(U),groupId:G,success:s,error:a});};
g.prototype._nodeIsOnTopLevel=function(n){if(n&&n.serverIndex>=0){var p=n.parent==null;if(p){if(n.originalLevel==this._iLowestServerLevel){return true;}else{return false;}}}else{L.warning("ODataTreeBindingFlat.nodeIsOnTopLevel: Node is not defined or not a server-indexed node.");}return undefined;};
g.prototype._generateDeleteRequest=function(n){var o=n.context;if(n.nodeState.added){this.oModel.deleteCreatedEntry(o);return undefined;}else{var D=this.oModel.remove(o.getPath(),{groupId:this._getCorrectChangeGroup(),refreshAfterChange:false});return D;}};
g.prototype._filterChangeForServerSections=function(o){var a={};a.removed=o.removed.filter(function(r){return!r.isDeepOne;});a.added=o.added.filter(function(A){return!A.isDeepOne;});o.moved.forEach(function(m){if(!m.newIsDeepOne){a.added.push(m);}if(!m.isDeepOne){a.removed.push(m);}});return a;};
g.prototype._filterChangesForDeepSections=function(o){var m={};o.removed.forEach(function(r){var p;if(r.isDeepOne){p=r.parent;if(!m[p.key]){m[p.key]={added:[],removed:[]};}m[p.key].removed.push(r);}});o.added.forEach(function(a){var p;if(a.isDeepOne){p=a.parent;if(!m[p.key]){m[p.key]={added:[],removed:[]};}m[p.key].added.push(a);}});o.moved.forEach(function(M){var p;if(M.newIsDeepOne){p=M.parent;if(!m[p.key]){m[p.key]={added:[],removed:[]};}m[p.key].added.push(M);}if(M.isDeepOne){p=M.originalParent;if(!m[p.key]){m[p.key]={added:[],removed:[]};}m[p.key].removed.push(M);}});return m;};
g.prototype._optimizeOptimizedChanges=function(o){var A,t=this;A=o.added.slice();A.sort(function(a,b){var I=a.newIsDeepOne!==undefined?a.newIsDeepOne:a.isDeepOne,h=b.newIsDeepOne!==undefined?b.newIsDeepOne:b.isDeepOne;if(I&&h){return 0;}if(I){return 1;}if(h){return-1;}return a.context.getProperty(t.oTreeProperties["hierarchy-preorder-rank-for"])-b.context.getProperty(t.oTreeProperties["hierarchy-preorder-rank-for"]);});var i=-1;A=A.filter(function(n,a){if(n.newIsDeepOne!==undefined?n.newIsDeepOne:n.isDeepOne){return true;}if(a<=i){return false;}var m=n.context.getProperty(t.oTreeProperties["hierarchy-node-descendant-count-for"]);if(m){i=a+m;}return true;});return{added:A,removed:o.removed,moved:o.moved};};
g.prototype._updateNodeInfoAfterSave=function(n){var i=n.context.getProperty(this.oTreeProperties["hierarchy-preorder-rank-for"])===undefined;if(n.isDeepOne===undefined){n.isDeepOne=i;}else{n.newIsDeepOne=i;}var I=n.context.getProperty(this.oTreeProperties["hierarchy-drill-state-for"])==="collapsed";if(n.initiallyCollapsed===undefined){n.initiallyCollapsed=I;}else{n.newInitiallyCollapsed=I;}};
g.prototype._requestExtraInfoForAddedNodes=function(a){var P=[],t=this;a.forEach(function(n){var p=new Promise(function(r,b){t._generatePreorderPositionRequest(n,{success:r,error:b});});P.push(p);});P=P.map(function(p){return p.then(function(r){return{responseData:r};},function(E){return{error:E};});});return Promise.all(P).then(function(D){var A=0;D.forEach(function(o){if(o.error){if(o.error.statusCode===0){A++;}else{throw new Error("Tree state restoration request failed. Complete or partial tree state might get lost. Error: "+(o.error.message.value||o.error.message));}}});return A===0;});};
g.prototype._restoreTreeState=function(o){var t=this;this._abortPendingRequest();o=o||{creationCancelled:[],added:[],removed:[],moved:[]};if(!this.bSkipDataEvents){this.fireDataRequested();}this.bSkipDataEvents=false;return this._requestExtraInfoForAddedNodes(o.added).then(function(n){if(n){return t._executeRestoreTreeState(o).then(function(D){if(D){t._fireChange({reason:C.Change});t.fireDataReceived({data:D});return D;}return undefined;});}return undefined;});};
g.prototype._executeRestoreTreeState=function(o){var a,s,S,D,b,m,p,i,j,k,l,h,n,t=this;o.added.forEach(this._updateNodeInfoAfterSave.bind(this));o.moved.forEach(this._updateNodeInfoAfterSave.bind(this));p=[];S=this._collectServerSections(this._aNodes);o=this._optimizeOptimizedChanges(o);h=this._filterChangeForServerSections(o);this._adaptSections(S,h);for(i=0;i<S.length;i++){s=S[i];p.push(this._restoreServerIndexNodes(s.iSkip,s.iTop,i===0));}var q=this._collectDeepNodes();n=this._filterChangesForDeepSections(o);for(j=0;j<q.length;j++){D=q[j];if(n){h=n[D.oParentNode.key];if(h){this._adaptSections(D.aChildSections,h,{indexName:"positionInParent",ignoreMagnitude:true});}}for(k=0;k<D.aChildSections.length;k++){b=D.aChildSections[k];p.push(this._restoreChildren(D.oParentNode,b.iSkip,b.iTop));}}m={};for(l=0;l<this._aCollapsed.length;l++){m[this._aCollapsed[l].key]=true;}a=this._aCollapsed.length;this.resetData(true);function r(){if(a>0){t._map(function(N,R){if(N&&m[N.key]){t.collapse(N,true);a--;if(a===0){R.broken=true;}}});}}p=p.map(function(v){return v.then(function(R){return{responseData:R};},function(E){return{error:E};});});return Promise.all(p).then(function(v){var A=0;v.forEach(function(w){if(w.error){if(w.error.statusCode===0){A++;}else{throw new Error("Tree state restoration request failed. Complete or partial tree state might get lost. Error: "+(w.error.message.value||w.error.message));}}});if(A<v.length){r();return v;}return undefined;});};
g.prototype._collectServerSections=function(n){var s=[];var S;for(var i=0;i<n.length;i++){if(n[i]!==undefined){if(!S){S={iSkip:i,iTop:1};s.push(S);}else{S.iTop++;}}else{S=null;}}return s;};
g.prototype._adaptSections=function(s,o,h){var r=o.removed||[],A=o.added||[],I=(h&&h.indexName)||"serverIndex",N,S,p,R,q,t=0,M,P,v,w,x,y,z,B=0,D,E,G=[];for(var l=A.length-1;l>=0;l--){N=A[l];if(N.newIsDeepOne!==undefined?N.newIsDeepOne:N.isDeepOne){E=this.oTreeProperties["hierarchy-sibling-rank-for"];}else{E=this.oTreeProperties["hierarchy-preorder-rank-for"];if(N.newInitiallyCollapsed!==undefined?!N.newInitiallyCollapsed:!N.initiallyCollapsed){M=N.context.getProperty(this.oTreeProperties["hierarchy-node-descendant-count-for"]);}}P=N.context.getProperty(E);if(P===undefined){L.warning("ODataTreeBindingFlat","Missing "+E+" value for node "+N.key);break;}G.push({position:P,magnitude:M||0,assignedToSection:false});}for(var i=0;i<s.length;i++){S=s[i];z=B;v=w;w=0;D=0;for(var j=r.length-1;j>=0;j--){N=r[j];P=N[I];if(P>=S.iSkip&&P<=S.iSkip+S.iTop){if(I==="serverIndex"){t++;}M=(h&&h.ignoreMagnitude)?0:this._getInitialMagnitude(N);q=(1+M);R=(S.iSkip+S.iTop)-P-q;if(R>0){D-=q;}else{D-=(S.iSkip+S.iTop)-P;if(R<0){w=P+q;}}z-=q;}}if(S.iSkip<=v){x=S.iSkip-v;D+=x;if(S.iTop+D<0){w=v;}}S.iSkip+=B;S.iTop+=D;if(S.iTop>0){B=0;D=0;for(var k=0;k<G.length;k++){p=G[k];P=p.position;y=(h&&h.ignoreMagnitude)?1:p.magnitude+1;if(P>=S.iSkip&&P<=S.iSkip+S.iTop){D+=y;G[k].assignedToSection=true;}else if(P<S.iSkip){B+=y;}}S.iSkip+=B;S.iTop+=D;S.iTop+=t;}if(S.iTop<=0){s.splice(i,1);i--;}B=z;}for(var m=0;m<G.length;m++){p=G[m];y=(h&&h.ignoreMagnitude)?1:p.magnitude+1;if(!p.assignedToSection){s.push({iSkip:p.position,iTop:y});}}s.sort(function(a,b){return a.iSkip-b.iSkip;});for(var n=0;n<s.length;n++){if(n+1<s.length){S=s[n];var H=s[n+1];if(S.iSkip+S.iTop===H.iSkip){S.iTop+=H.iTop;s.splice(n+1,1);n--;}}}};
g.prototype._optimizeChanges=function(){var r=[],h=[],A=[],m=[];var I=false;var j=function(N,b){if(N.nodeState.removed&&!N.nodeState.reinserted){I=true;b.broken=true;}};var p=[];var t=function(N){if((N.isDeepOne||N.serverIndex>=0)&&p.indexOf(N)==-1){p.push(N);}if(N.nodeState.added){h.push(N);}};this._aAllChangedNodes.forEach(function(N){I=false;this._up(N,j,false);if(I){t(N);}else if(N.nodeState.removed&&!N.nodeState.reinserted){t(N);}else if(N.nodeState.added){A.push(N);}else{m.push(N);}}.bind(this));p.sort(function(a,b){var k=this._getRelatedServerIndex(a);var B=this._getRelatedServerIndex(b);c(k!=undefined,"_generateSubmitData: (containing) Server-Index not found for node 'a'");c(B!=undefined,"_generateSubmitData: (containing) Server-Index not found node 'b'");if(k==B&&a.isDeepOne&&b.isDeepOne){if(a.parent===b.parent){return a.positionInParent-b.positionInParent;}else{return a.originalLevel-b.originalLevel;}}return k-B;}.bind(this));var n=function(D){var b=false;this._up(D,function(P,B){if(P.nodeState.removed&&!P.nodeState.reinserted){b=true;B.broken=true;}},true);return b;}.bind(this);for(var i=0;i<p.length;i++){var D=p[i];if(!n(D)){r.push(D);}}return{removed:r,creationCancelled:h,added:A,moved:m};};
g.prototype._collectDeepNodes=function(){var D=[],t=this;this._map(function(n){if(n&&n.nodeState.expanded&&((n.initiallyCollapsed||n.isDeepOne))){D.push({oParentNode:n,aChildSections:t._collectServerSections(n.children)});}});return D;};
g.prototype._trackChangedNode=function(n){if(this._aAllChangedNodes.indexOf(n)==-1){this._aAllChangedNodes.push(n);}};
g.prototype.addContexts=function(p,v){var n=this._findNodeByContext(p),N=n.node,m=this.getModel(),o,a;c(p&&v,"ODataTreeBinding.addContexts() was called with incomplete arguments!");if(N){this._bReadOnly=false;if(N.nodeState&&N.nodeState.isLeaf){N.nodeState.isLeaf=false;N.nodeState.collapsed=true;}if(!Array.isArray(v)){if(v instanceof sap.ui.model.Context){v=[v];}else{L.warning("ODataTreeBinding.addContexts(): The child node argument is not of type sap.ui.model.Context.");}}var b=function(h){return function(){return[h];};};v=v.slice();v.reverse();for(var j=0;j<v.length;j++){a=v[j];if(!a||!(a instanceof sap.ui.model.Context)){L.warning("ODataTreeBindingFlat.addContexts(): no valid child context given!");return;}o=this._mSubtreeHandles[a.getPath()];this._ensureHierarchyNodeIDForContext(a);if(o&&o._isRemovedSubtree){L.info("ODataTreeBindingFlat.addContexts(): Existing context added '"+a.getPath()+"'");o._oNewParentNode=N;o._oSubtreeRoot.nodeState.reinserted=true;o._oSubtreeRoot.originalParent=o._oSubtreeRoot.originalParent||o._oSubtreeRoot.parent;o._oSubtreeRoot.parent=N;o._oSubtreeRoot.containingSubtreeHandle=o;this._trackChangedNode(o._oSubtreeRoot);}else{L.info("ODataTreeBindingFlat.addContexts(): Newly created context added.");this._ensureHierarchyNodeIDForContext(a);var h={context:a,key:m.getKey(a),parent:N,nodeState:{isLeaf:true,collapsed:false,expanded:false,selected:false,added:true},addedSubtrees:[],children:[],magnitude:0};this._trackChangedNode(h);this._aAdded.push(h);o={_getSubtree:b(h),_oSubtreeRoot:null,_oNewParentNode:N};}N.addedSubtrees.unshift(o);if(N.serverIndex!==undefined){this._aNodeChanges[N.serverIndex]=true;}}this._aNodeCache=[];this._cleanTreeStateMaps();this._fireChange({reason:C.Add});}else{L.warning("The given parent context could not be found in the tree. No new sub-nodes were added!");}};
g.prototype._ensureHierarchyNodeIDForContext=function(o){if(o){var n=o.getProperty(this.oTreeProperties["hierarchy-node-for"]);if(o.isTransient()&&!n){this.oModel.setProperty(this.oTreeProperties["hierarchy-node-for"],u(),o);}}};
g.prototype.removeContext=function(o){var t=this;var n=this._findNodeByContext(o);var N=n.node;var i=n.index;if(N){this._bReadOnly=false;N.nodeState.removed=true;this._aRemoved.push(N);this._trackChangedNode(N);if(N.serverIndex!==undefined){this._aNodeChanges[N.serverIndex]=true;}if(N.containingSubtreeHandle&&N.parent!=null){var a=N.parent.addedSubtrees.indexOf(N.containingSubtreeHandle);if(a!=-1){N.parent.addedSubtrees.splice(a,1);N.nodeState.reinserted=false;N.parent=null;}}this._aNodeCache=[];this.setNodeSelection(N,false);this._cleanUpSelection(true);this._cleanTreeStateMaps();this._fireChange({reason:C.Remove});this._mSubtreeHandles[o.getPath()]={_removedFromVisualIndex:i,_isRemovedSubtree:true,_oSubtreeRoot:N,_getSubtree:function(){if(N.serverIndex!=undefined&&!N.initiallyCollapsed){return t._aNodes.slice(N.serverIndex,N.serverIndex+N.magnitude+1);}else{return N;}},getContext:function(){return o;},_restore:function(){N.nodeState.removed=false;var b=t._aRemoved.indexOf(N);if(b!=-1){t._aRemoved.splice(b,1);}this._aNodeCache=[];t._cleanTreeStateMaps();t._fireChange({reason:C.Add});}};return o;}else{L.warning("ODataTreeBinding.removeContexts(): The given context is not part of the tree. Was it removed already?");}return undefined;};
g.prototype._getRelatedServerIndex=function(n){if(n.serverIndex===undefined){return n.containingServerIndex;}else{return n.serverIndex;}};
g.prototype.getNodeInfoByRowIndex=function(r){var i=0,E=0,n,t,v=-1;while(i<this._aCollapsed.length||E<this._aExpanded.length){if(this._aCollapsed[i]&&this._aExpanded[E]){if(this._getRelatedServerIndex(this._aCollapsed[i])>this._getRelatedServerIndex(this._aExpanded[E])){n=this._aExpanded[E];E++;t=false;}else{n=this._aCollapsed[i];i++;t=true;}}else if(this._aCollapsed[i]){n=this._aCollapsed[i];i++;t=true;}else{n=this._aExpanded[E];E++;t=false;}if(r<=this._getRelatedServerIndex(n)){break;}if(t){if(!n.isDeepOne&&!n.initiallyCollapsed&&n.serverIndex>v){r+=n.magnitude;v=n.serverIndex+n.magnitude;}}else if(n.serverIndex>v){if(!n.isDeepOne&&n.initiallyCollapsed){r-=n.magnitude;}if(r<=n.serverIndex){return this._calcDirectIndex(n,r+n.magnitude-n.serverIndex-1);}}}return{index:r};};
g.prototype._calcDirectIndex=function(n,I){var o,i,m;for(i=0;i<n.children.length;i++){o=n.children[i];if(I===0){return{parent:n,childIndex:i};}m=o?o.magnitude:0;I--;if(!o||o.nodeState.collapsed){continue;}if(I<m){return this._calcDirectIndex(o,I);}else{I-=m;}}return undefined;};
g.prototype.getRowIndexByNode=function(n){var D=0;var o;var i;if(n.isDeepOne){while(n.parent){D+=n.positionInParent+1;for(i=0;i<n.positionInParent;i++){o=n.parent.children[i];if(o&&o.nodeState.expanded){D+=o.magnitude;}}n=n.parent;}}return this._calcIndexDelta(n.serverIndex)+n.serverIndex+D;};
g.prototype._getSelectedNodesInfo=function(){var n=[];if(d(this._mSelected)){return n;}var i=true;var a=function(N,b){if(N.nodeState.collapsed||(N.nodeState.removed&&!N.nodeState.reinserted)){i=false;b.broken=true;}};for(var k in this._mSelected){var s=this._mSelected[k];i=true;this._up(s,a,false);if(i){n.push({node:s,rowIndex:this.getRowIndexByNode(s)});}}n.sort(function(N,o){return N.rowIndex-o.rowIndex;});return n;};
g.prototype._calcIndexDelta=function(E){var i,I,a=0,m={},l=0;this._aCollapsed.forEach(function(n){if(n.serverIndex>=0&&n.serverIndex<E&&!n.isDeepOne&&!n.initiallyCollapsed){m[n.serverIndex]=n.magnitude;}});for(i=0;i<this._aCollapsed.length;i++){var o=this._aCollapsed[i];if(this._getRelatedServerIndex(o)>=E){break;}if(!o.isDeepOne){if(o.serverIndex>=l&&!o.initiallyCollapsed){a-=o.magnitude;l=o.serverIndex+o.magnitude;}else{}}else{}}var b=0;var h=function(n){var I=false;var q=n.serverIndex||n.containingServerIndex;for(var j in m){if(q>j&&q<j+m[j]){I=true;break;}}return I;};for(i=0;i<this._aExpanded.length;i++){var k=this._aExpanded[i];if(this._getRelatedServerIndex(k)>=E){break;}if(k.isDeepOne){var p=k.parent;var y=false;while(p){if(p.nodeState.collapsed){y=true;break;}p=p.parent;}I=h(k);if(!y&&!I){b+=k.children.length;}}else if(k.initiallyCollapsed){I=h(k);if(!I){b+=k.children.length;}}}return b+a;};
g.prototype._sortNodes=function(n){var s=function(a,b){var A=this._getRelatedServerIndex(a);var B=this._getRelatedServerIndex(b);return A-B;}.bind(this);n.sort(s);};
g.prototype._abortPendingRequest=function(){if(this._aPendingRequests.length||this._aPendingChildrenRequests.length){this.bSkipDataEvents=true;var i,j;for(i=this._aPendingRequests.length-1;i>=0;i--){this._aPendingRequests[i].oRequestHandle.abort();}this._aPendingRequests=[];for(j=this._aPendingChildrenRequests.length-1;j>=0;j--){this._aPendingChildrenRequests[j].oRequestHandle.abort();}this._aPendingChildrenRequests=[];}};
g.prototype.attachSelectionChanged=function(D,a,l){this.attachEvent("selectionChanged",D,a,l);return this;};
g.prototype.detachSelectionChanged=function(a,l){this.detachEvent("selectionChanged",a,l);return this;};
g.prototype.fireSelectionChanged=function(p){this.fireEvent("selectionChanged",p);return this;};
g.prototype.getRootContexts=function(){};
g.prototype.getNodeContexts=function(){};
return g;},true);
sap.ui.predefine('sap/ui/model/odata/ODataUtils',["sap/base/assert","sap/base/Log","sap/base/security/encodeURL","sap/base/util/each","sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/FilterProcessor","sap/ui/model/Sorter"],function(a,L,e,b,C,D,F,S){"use strict";var d,o,c,r=/^([-+]?)0*(\d+)(\.\d+|)$/,t,f=/\.$/,g=/0+$/;
function s(){if(!d){d=D.getDateInstance({pattern:"'datetime'''yyyy-MM-dd'T'HH:mm:ss''",calendarType:C.Gregorian});o=D.getDateInstance({pattern:"'datetime'''yyyy-MM-dd'T'HH:mm:ss.SSS''",calendarType:C.Gregorian});c=D.getDateInstance({pattern:"'datetimeoffset'''yyyy-MM-dd'T'HH:mm:ss'Z'''",calendarType:C.Gregorian});t=D.getTimeInstance({pattern:"'time''PT'HH'H'mm'M'ss'S'''",calendarType:C.Gregorian});}}
var O=function(){};
O.createSortParams=function(n){var y;if(!n||n.length==0){return undefined;}y="$orderby=";for(var i=0;i<n.length;i++){var z=n[i];if(z instanceof S){y+=z.sPath;y+=z.bDescending?"%20desc":"%20asc";y+=",";}else{L.error("Trying to use "+z+" as a Sorter, but it is a "+typeof z);}}y=y.slice(0,-1);return y;};
function h(i){if(i&&typeof i.convert==="function"){i=i.convert();}return i;}
O.createFilterParams=function(i,M,E){var n;if(Array.isArray(i)){i=i.map(h);n=F.groupFilters(i);}else{n=h(i);}if(!n){return undefined;}return"$filter="+this._createFilterParams(n,M,E);};
O._createFilterParams=function(n,M,E){var y=this,z=Array.isArray(n)?F.groupFilters(n):n;function A(z,i){z=h(z);if(z.aFilters){return B(z,i);}return y._createFilterSegment(z.sPath,M,E,z.sOperator,z.oValue1,z.oValue2,z.bCaseSensitive);}function B(G,H){var I=G.aFilters,J=!!G.bAnd,K="";if(I.length===0){return J?"true":"false";}if(I.length===1){if(I[0]._bMultiFilter){return A(I[0]);}return A(I[0],true);}if(!H){K+="(";}K+=A(I[0]);for(var i=1;i<I.length;i++){K+=J?"%20and%20":"%20or%20";K+=A(I[i]);}if(!H){K+=")";}return K;}if(!z){return undefined;}return A(z,true);};
O._createUrlParamsArray=function(P){var U,T=typeof P,i;if(Array.isArray(P)){return P;}U=[];if(T==="string"||P instanceof String){if(P){U.push(P);}}else if(T==="object"){i=this._encodeURLParameters(P);if(i){U.push(i);}}return U;};
O._encodeURLParameters=function(P){if(!P){return"";}var U=[];b(P,function(n,V){if(typeof V==="string"||V instanceof String){V=encodeURIComponent(V);}n=n.startsWith('$')?n:encodeURIComponent(n);U.push(n+"="+V);});return U.join("&");};
O.setOrigin=function(i,P){var n,y,z;if(!i||!P||i.indexOf(";mo")>0){return i;}if(typeof P=="string"){n=P;}else{n=P.alias;if(!n){y=P.system;z=P.client;if(!y||!z){L.warning("ODataUtils.setOrigin: No Client or System ID given for Origin");return i;}n="sid("+y+"."+z+")";}}var U=i.split("?");var B=U[0];var A=U[1]?"?"+U[1]:"";var T="";if(B[B.length-1]==="/"){B=B.substring(0,B.length-1);T="/";}var E=/(\/[^\/]+)$/g;var G=/(;o=[^\/;]+)/g;var H=B.match(E)[0];var I=H.match(G);var J=I?I[0]:null;if(J){if(P.force){var K=H.replace(J,";o="+n);B=B.replace(H,K);return B+T+A;}return i;}B=B+";o="+n+T;return B+A;};
O.setAnnotationOrigin=function(A,P){var i;var n=A.indexOf("/Annotations(");var H=P&&P.preOriginBaseUri?P.preOriginBaseUri.indexOf(".xsodata"):-1;if(n===-1){n=A.indexOf("/Annotations%28");}if(n>=0){if(A.indexOf("/$value",n)===-1){L.warning("ODataUtils.setAnnotationOrigin: Annotation url is missing $value segment.");i=A;}else{var y=A.substring(0,n);var z=A.substring(n,A.length);var B=O.setOrigin(y,P);i=B+z;}}else if(H>=0){i=O.setOrigin(A,P);}else{i=A.replace(P.preOriginBaseUri,P.postOriginBaseUri);}return i;};
O._resolveMultiFilter=function(M,n,E){var y=this,z=M.aFilters,A="";if(z){A+="(";b(z,function(i,B){if(B._bMultiFilter){A+=y._resolveMultiFilter(B,n,E);}else if(B.sPath){A+=y._createFilterSegment(B.sPath,n,E,B.sOperator,B.oValue1,B.oValue2,"",B.bCaseSensitive);}if(i<(z.length-1)){if(M.bAnd){A+="%20and%20";}else{A+="%20or%20";}}});A+=")";}return A;};
O._createFilterSegment=function(P,M,E,i,V,n,y){var z,T;if(y===undefined){y=true;}if(E){z=M._getPropertyMetadata(E,P);T=z&&z.type;a(z,"PropertyType for property "+P+" of EntityType "+E.name+" not found!");}if(T){V=this.formatValue(V,T,y);n=(n!=null)?this.formatValue(n,T,y):null;}else{a(null,"Type for filter property could not be found in metadata!");}if(V){V=e(String(V));}if(n){n=e(String(n));}if(!y&&T==="Edm.String"){P="toupper("+P+")";}switch(i){case"EQ":case"NE":case"GT":case"GE":case"LT":case"LE":return P+"%20"+i.toLowerCase()+"%20"+V;case"BT":return"("+P+"%20ge%20"+V+"%20and%20"+P+"%20le%20"+n+")";case"NB":return"not%20("+P+"%20ge%20"+V+"%20and%20"+P+"%20le%20"+n+")";case"Contains":return"substringof("+V+","+P+")";case"NotContains":return"not%20substringof("+V+","+P+")";case"StartsWith":return"startswith("+P+","+V+")";case"NotStartsWith":return"not%20startswith("+P+","+V+")";case"EndsWith":return"endswith("+P+","+V+")";case"NotEndsWith":return"not%20endswith("+P+","+V+")";default:L.error("ODataUtils :: Unknown filter operator "+i);return"true";}};
O.formatValue=function(V,T,i){var n,y;if(i===undefined){i=true;}if(V===null||V===undefined){return"null";}s();switch(T){case"Edm.String":V=i?V:V.toUpperCase();y="'"+String(V).replace(/'/g,"''")+"'";break;case"Edm.Time":if(typeof V==="object"){y=t.format(new Date(V.ms),true);}else{y="time'"+V+"'";}break;case"Edm.DateTime":n=V instanceof Date?V:new Date(V);if(n.getMilliseconds()>0){y=o.format(n,true);}else{y=d.format(n,true);}break;case"Edm.DateTimeOffset":n=V instanceof Date?V:new Date(V);y=c.format(n,true);break;case"Edm.Guid":y="guid'"+V+"'";break;case"Edm.Decimal":y=V+"m";break;case"Edm.Int64":y=V+"l";break;case"Edm.Double":y=V+"d";break;case"Edm.Float":case"Edm.Single":y=V+"f";break;case"Edm.Binary":y="binary'"+V+"'";break;default:y=String(V);break;}return y;};
O.parseValue=function(V){var i=V[0],n=V[V.length-1];s();if(i==="'"){return V.slice(1,-1).replace(/''/g,"'");}else if(V.startsWith("time'")){return{__edmType:"Edm.Time",ms:t.parse(V,true).getTime()};}else if(V.startsWith("datetime'")){if(V.indexOf(".")===-1){return d.parse(V,true);}else{return o.parse(V,true);}}else if(V.startsWith("datetimeoffset'")){return c.parse(V,true);}else if(V.startsWith("guid'")){return V.slice(5,-1);}else if(V==="null"){return null;}else if(n==="m"||n==="l"||n==="d"||n==="f"){return V.slice(0,-1);}else if(!isNaN(i)||i==="-"){return parseInt(V);}else if(V==="true"||V==="false"){return V==="true";}else if(V.startsWith("binary'")){return V.slice(7,-1);}throw new Error("Cannot parse value '"+V+"', no Edm type found");};
function j(V,i){if(V===i){return 0;}if(V===null||i===null||V===undefined||i===undefined){return NaN;}return V>i?1:-1;}
function p(V){var M;if(typeof V!=="string"){return undefined;}M=r.exec(V);if(!M){return undefined;}return{sign:M[1]==="-"?-1:1,integerLength:M[2].length,abs:M[2]+M[3].replace(g,"").replace(f,"")};}
function k(V,i){var n,y,R;if(V===i){return 0;}n=p(V);y=p(i);if(!n||!y){return NaN;}if(n.sign!==y.sign){return n.sign>y.sign?1:-1;}R=j(n.integerLength,y.integerLength)||j(n.abs,y.abs);return n.sign*R;}
var l=/^PT(\d\d)H(\d\d)M(\d\d)S$/;
function m(V){if(typeof V==="string"&&l.test(V)){V=parseInt(RegExp.$1)*3600000+parseInt(RegExp.$2)*60000+parseInt(RegExp.$3)*1000;}if(V instanceof Date){return V.getTime();}if(V&&V.__edmType==="Edm.Time"){return V.ms;}return V;}
O.compare=function(V,i,A){return A?k(V,i):j(m(V),m(i));};
O.getComparator=function(E){switch(E){case"Edm.Date":case"Edm.DateTime":case"Edm.DateTimeOffset":case"Edm.Time":return O.compare;case"Edm.Decimal":case"Edm.Int64":return k;default:return j;}};
var q=/([(=,])('.*?')([,)])/g,u=/[MLDF](?=[,)](?:[^']*'[^']*')*[^']*$)/g,v=/([(=,])(X')/g,N=function(i,n,y,z){return n+encodeURIComponent(decodeURIComponent(y))+z;},w=function(i){return i.toLowerCase();},x=function(i,n){return n+"binary'";};
O._normalizeKey=function(K){return K.replace(q,N).replace(u,w).replace(v,x);};
O._mergeIntervals=function(i){if(i.length){return{start:i[0].start,end:i[i.length-1].end};}return undefined;};
O._getReadIntervals=function(E,y,z,P,A){var i,B,n,G=-1,I=[],R=O._getReadRange(E,y,z,P);if(A===undefined){A=Infinity;}B=Math.min(R.start+R.length,A);n=Math.min(B,Math.max(R.start,E.length)+1);for(i=R.start;i<n;i+=1){if(E[i]!==undefined){if(G>=0){I.push({start:G,end:i});G=-1;}}else if(G<0){G=i;}}if(G>=0){I.push({start:G,end:B});}return I;};
O._getReadRange=function(E,n,y,P){function z(n,A){var i;for(i=n;i<A;i+=1){if(E[i]===undefined){return true;}}return false;}if(z(n+y,n+y+P/2)){y+=P;}if(z(Math.max(n-P/2,0),n)){y+=P;n-=P;if(n<0){y+=n;if(isNaN(y)){y=Infinity;}n=0;}}return{length:y,start:n};};
return O;},true);
sap.ui.predefine('sap/ui/model/odata/OperationMode',function(){"use strict";var O={Default:"Default",Server:"Server",Client:"Client",Auto:"Auto"};return O;},true);
sap.ui.predefine('sap/ui/model/odata/UpdateMethod',function(){"use strict";var U={Merge:"MERGE",Put:"PUT"};return U;},true);
sap.ui.predefine('sap/ui/model/odata/_AnnotationHelperBasics',["sap/base/Log","sap/base/util/extend","sap/ui/base/BindingParser","sap/ui/performance/Measurement"],function(L,a,B,M){'use strict';var A="sap.ui.model.odata.AnnotationHelper",r=/[\\\{\}:]/,b,d=/^(\/dataServices\/schema\/\d+\/entityContainer\/\d+\/entitySet\/\d+)(?:\/|$)/,p=[A],P=A+"/followPath",f=/^(\/dataServices\/schema\/\d+\/(?:complex|entity)Type\/\d+)(?:\/|$)/,u={"Edm.Boolean":"sap.ui.model.odata.type.Boolean","Edm.Byte":"sap.ui.model.odata.type.Byte","Edm.Date":"sap.ui.model.odata.type.Date","Edm.DateTime":"sap.ui.model.odata.type.DateTime","Edm.DateTimeOffset":"sap.ui.model.odata.type.DateTimeOffset","Edm.Decimal":"sap.ui.model.odata.type.Decimal","Edm.Double":"sap.ui.model.odata.type.Double","Edm.Float":"sap.ui.model.odata.type.Single","Edm.Guid":"sap.ui.model.odata.type.Guid","Edm.Int16":"sap.ui.model.odata.type.Int16","Edm.Int32":"sap.ui.model.odata.type.Int32","Edm.Int64":"sap.ui.model.odata.type.Int64","Edm.SByte":"sap.ui.model.odata.type.SByte","Edm.Single":"sap.ui.model.odata.type.Single","Edm.String":"sap.ui.model.odata.type.String","Edm.Stream":"sap.ui.model.odata.type.Stream","Edm.Time":"sap.ui.model.odata.type.Time","Edm.TimeOfDay":"sap.ui.model.odata.type.TimeOfDay"};b={descend:function(o,v,e){var t=a({},o);b.expectType(o,typeof v==="number"?"array":"object");t.path=o.path+"/"+v;t.value=o.value[v];if(e===true){t.asExpression=true;}else if(e){b.expectType(t,e);}return t;},error:function(o,m,c){m=o.path+": "+m;L.error(m,b.toErrorString(o.value),c||A);throw new SyntaxError(m);},expectType:function(o,e){var E,v=o.value;if(e==="array"){E=!Array.isArray(v);}else{E=typeof v!==e||v===null||Array.isArray(v);}if(E){b.error(o,"Expected "+e);}},followPath:function(i,R){var o,s,c,I,m=i.getModel(),e,g={associationSetEnd:undefined,navigationAfterMultiple:false,isMultiple:false,navigationProperties:[],resolvedPath:undefined},S,t;M.average(P,"",p);s=b.getPath(R);c=s!==undefined&&b.getStartingPoint(i,s);if(!c){M.end(P);return undefined;}e=s.split("/");if(s){while(e.length&&c){S=e[0];I=S.indexOf("@");if(I===0){c+="/"+S.slice(1);e.shift();continue;}t=m.getObject(c);o=m.getODataAssociationEnd(t,S);if(o){g.associationSetEnd=m.getODataAssociationSetEnd(t,S);g.navigationProperties.push(S);if(g.isMultiple){g.navigationAfterMultiple=true;}g.isMultiple=o.multiplicity==="*";c=m.getODataEntityType(o.type,true);e.shift();continue;}c=m.getODataProperty(t,e,true);}}g.resolvedPath=c;M.end(P);return g;},getPath:function(R){if(R){if(R.hasOwnProperty("AnnotationPath")){return R.AnnotationPath;}if(R.hasOwnProperty("Path")){return R.Path;}if(R.hasOwnProperty("PropertyPath")){return R.PropertyPath;}if(R.hasOwnProperty("NavigationPropertyPath")){return R.NavigationPropertyPath;}}return undefined;},getStartingPoint:function(i,s){var e,m=f.exec(i.getPath()),o;if(m){return m[1];}m=d.exec(i.getPath());if(m){if(!s){return m[1];}o=i.getModel();e=o.getObject(m[1]);return o.getODataEntityType(e.entityType,true);}return undefined;},property:function(o,v,e){return b.descend(o,v,e).value;},resultToString:function(R,e,w,c){var v=R.value;function g(i){var C,F,s=R.parameters&&b.toJSON(R.parameters),H=s&&s!=="{}",j,t=u[R.type];i=i&&!R.ignoreTypeInPath&&t;if(i||r.test(v)||H){j="{path:"+b.toJSON(v);if(i){j+=",type:'"+t+"'";C=b.toJSON(R.constraints);if(C&&C!=="{}"){j+=",constraints:"+C;}F=R.formatOptions&&b.toJSON(R.formatOptions);if(F&&F!=="{}"){j+=",formatOptions:"+F;}}if(H){j+=",parameters:"+s;}return j+"}";}return"{"+v+"}";}function h(R){switch(R.type){case"Edm.Boolean":case"Edm.Double":case"Edm.Int32":return String(R.value);default:return b.toJSON(R.value);}}switch(R.result){case"binding":if(e){return(c?"%":"$")+g(w);}return g(w);case"composite":if(e){throw new Error("Trying to embed a composite binding into an expression binding");}return v;case"constant":if(R.type==="edm:Null"){if(R.value===undefined){return e?"undefined":undefined;}return e?"null":null;}if(e){return h(R);}return typeof v==="string"?B.complexParser.escape(v):String(v);case"expression":return e?v:"{="+v+"}";default:return undefined;}},toErrorString:function(v){var j;if(typeof v!=="function"){try{j=b.toJSON(v);if(j!==undefined&&j!=="null"){return j;}}catch(e){}}return String(v);},toJSON:function(v){var s,e=false,R="",i,c;s=JSON.stringify(v);if(s===undefined){return undefined;}for(i=0;i<s.length;i+=1){switch(c=s.charAt(i)){case"'":R+="\\'";break;case'"':if(e){R+=c;e=false;}else{R+="'";}break;case"\\":if(e){R+="\\\\";}e=!e;break;default:if(e){R+="\\";e=false;}R+=c;}}return R;}};return b;});
sap.ui.predefine('sap/ui/model/odata/_AnnotationHelperExpression',["./_AnnotationHelperBasics","sap/base/Log","sap/ui/base/BindingParser","sap/ui/base/ManagedObject","sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/odata/ODataUtils","sap/ui/performance/Measurement"],function(B,L,a,M,C,D,O,b){'use strict';var A="sap.ui.model.odata.AnnotationHelper",d,o,s="\\d{4}-(?:0[1-9]|1[0-2])-(?:0[1-9]|[12]\\d|3[01])",c="[-+]?\\d+(?:\\.\\d+)?",m="9007199254740991",f="-"+m,p=[A],P=A+"/getExpression",t,T="(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(\\.\\d{1,12})?)?",E={Bool:/^true$|^false$/i,Float:new RegExp("^"+c+"(?:[eE][-+]?\\d+)?$|^NaN$|^-INF$|^INF$"),Date:new RegExp("^"+s+"$"),DateTimeOffset:new RegExp("^"+s+"T"+T+"(?:Z|[-+](?:0\\d|1[0-3]):[0-5]\\d|[-+]14:00)$","i"),Decimal:new RegExp("^"+c+"$"),Guid:/^[A-F0-9]{8}-(?:[A-F0-9]{4}-){3}[A-F0-9]{12}$/i,Int:/^[-+]?\d{1,19}$/,TimeOfDay:new RegExp("^"+T+"$")},g,r=/^\{@i18n>[^\\\{\}:]+\}$/,h=/^\d+$/,j={And:"&&",Eq:"===",Ge:">=",Gt:">",Le:"<=",Lt:"<",Ne:"!==",Not:"!",Or:"||"},k=/^(\/dataServices\/schema\/\d+)(?:\/|$)/,l={"Edm.Boolean":"boolean","Edm.Byte":"number","Edm.Date":"date","Edm.DateTime":"datetime","Edm.DateTimeOffset":"datetime","Edm.Decimal":"decimal","Edm.Double":"number","Edm.Float":"number","Edm.Guid":"string","Edm.Int16":"number","Edm.Int32":"number","Edm.Int64":"decimal","Edm.SByte":"number","Edm.Single":"number","Edm.String":"string","Edm.Time":"time","Edm.TimeOfDay":"time"},n={Bool:"Edm.Boolean",Float:"Edm.Double",Date:"Edm.Date",DateTimeOffset:"Edm.DateTimeOffset",Decimal:"Edm.Decimal",Guid:"Edm.Guid",Int:"Edm.Int64",String:"Edm.String",TimeOfDay:"Edm.TimeOfDay"},q={"boolean":false,"date":true,"datetime":true,"decimal":true,"number":false,"string":false,"time":true};g={_setDateTimeFormatter:function(){d=D.getDateInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd",strictParsing:true,UTC:true});o=D.getDateTimeInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd'T'HH:mm:ss.SSSXXX",strictParsing:true});t=D.getTimeInstance({calendarType:C.Gregorian,pattern:"HH:mm:ss.SSS",strictParsing:true,UTC:true});},adjustOperands:function(e,i){if(e.result!=="constant"&&e.category==="number"&&i.result==="constant"&&i.type==="Edm.Int64"){i.category="number";}if(e.result!=="constant"&&e.category==="decimal"&&i.result==="constant"&&i.type==="Edm.Int32"){i.category="decimal";i.type=e.type;}if(e.result==="constant"&&e.category==="date"&&i.result!=="constant"&&i.category==="datetime"){i.category="date";}},apply:function(i,e){var N=B.descend(e,"Name","string"),u=B.descend(e,"Parameters");switch(N.value){case"odata.concat":return g.concat(i,u);case"odata.fillUriTemplate":return g.fillUriTemplate(i,u);case"odata.uriEncode":return g.uriEncode(i,u);default:B.error(N,"unknown function: "+N.value);return undefined;}},concat:function(I,e){var u=e.asExpression,v=[],R,w=[];B.expectType(e,"array");e.value.forEach(function(_,i){R=g.parameter(I,e,i);u=u||R.result==="expression";w.push(R);});w.forEach(function(R){if(u){g.wrapExpression(R);}if(R.type!=='edm:Null'){v.push(B.resultToString(R,u,e.withType));}});R=u?{result:"expression",value:v.join("+")}:{result:"composite",value:v.join("")};R.type="Edm.String";return R;},conditional:function(i,e){var u=g.parameter(i,e,0,"Edm.Boolean"),v=g.parameter(i,e,1),w=g.parameter(i,e,2),x=v.type,W=e.withType;if(v.type==="edm:Null"){x=w.type;}else if(w.type!=="edm:Null"&&v.type!==w.type){B.error(e,"Expected same type for second and third parameter, types are '"+v.type+"' and '"+w.type+"'");}return{result:"expression",type:x,value:B.resultToString(g.wrapExpression(u),true,false)+"?"+B.resultToString(g.wrapExpression(v),true,W)+":"+B.resultToString(g.wrapExpression(w),true,W)};},constant:function(i,e,u){var v=e.value;B.expectType(e,"string");if(u==="String"){if(r.test(v)){return{ignoreTypeInPath:true,result:"binding",type:"Edm.String",value:v.slice(1,-1)};}else if(i.getSetting&&i.getSetting("bindTexts")){return{result:"binding",type:"Edm.String",ignoreTypeInPath:true,value:"/##"+g.replaceIndexes(i.getModel(),e.path)};}u="Edm.String";}else if(!E[u].test(v)){B.error(e,"Expected "+u+" value but instead saw '"+v+"'");}else{u=n[u];if(u==="Edm.Int64"&&O.compare(v,f,true)>=0&&O.compare(v,m,true)<=0){u="Edm.Int32";}}return{result:"constant",type:u,value:v};},expression:function(i,e){var R=e.value,S,u;B.expectType(e,"object");if(R.hasOwnProperty("Type")){u=B.property(e,"Type","string");S=B.descend(e,"Value");}else{["And","Apply","Bool","Date","DateTimeOffset","Decimal","Float","Eq","Ge","Gt","Guid","If","Int","Le","Lt","Ne","Not","Null","Or","Path","PropertyPath","String","TimeOfDay"].forEach(function(v){if(R.hasOwnProperty(v)){u=v;S=B.descend(e,v);}});}switch(u){case"Apply":return g.apply(i,S);case"If":return g.conditional(i,S);case"Path":case"PropertyPath":return g.path(i,S);case"Bool":case"Date":case"DateTimeOffset":case"Decimal":case"Float":case"Guid":case"Int":case"String":case"TimeOfDay":return g.constant(i,S,u);case"And":case"Eq":case"Ge":case"Gt":case"Le":case"Lt":case"Ne":case"Or":return g.operator(i,S,u);case"Not":return g.not(i,S);case"Null":return{result:"constant",value:"null",type:"edm:Null"};default:B.error(e,"Unsupported OData expression");return undefined;}},formatOperand:function(e,i,R,w){var u;if(R.result==="constant"){switch(R.category){case"boolean":case"number":return R.value;case"date":u=g.parseDate(R.value);if(!u){B.error(B.descend(e,i),"Invalid Date "+R.value);}return String(u.getTime());case"datetime":u=g.parseDateTimeOffset(R.value);if(!u){B.error(B.descend(e,i),"Invalid DateTime "+R.value);}return String(u.getTime());case"time":return String(g.parseTimeOfDay(R.value).getTime());}}if(w){g.wrapExpression(R);}return B.resultToString(R,true);},getExpression:function(i,R,w){var u;if(R===undefined){return undefined;}b.average(P,"",p);if(!g.simpleParserWarningLogged&&M.bindingParser===a.simpleParser){L.warning("Complex binding syntax not active",null,A);g.simpleParserWarningLogged=true;}try{u=g.expression(i,{asExpression:false,path:i.getPath(),value:R,withType:w});b.end(P);return B.resultToString(u,false,w);}catch(e){b.end(P);if(e instanceof SyntaxError){return"Unsupported: "+a.complexParser.escape(B.toErrorString(R));}throw e;}},fillUriTemplate:function(I,e){var i,N,u=[],v="",w,x=e.value,R,y=g.parameter(I,e,0,"Edm.String");u.push('odata.fillUriTemplate(',B.resultToString(y,true),',{');for(i=1;i<x.length;i+=1){w=B.descend(e,i,"object");N=B.property(w,"Name","string");R=g.expression(I,B.descend(w,"Value"),true);u.push(v,B.toJSON(N),":",B.resultToString(R,true));v=",";}u.push("})");return{result:"expression",value:u.join(""),type:"Edm.String"};},not:function(i,e){var u;e.asExpression=true;u=g.expression(i,e);return{result:"expression",value:"!"+B.resultToString(g.wrapExpression(u),true),type:"Edm.Boolean"};},operator:function(i,e,u){var v=u==="And"||u==="Or"?"Edm.Boolean":undefined,w=g.parameter(i,e,0,v),x=g.parameter(i,e,1,v),y,N,V,z;if(w.type!=="edm:Null"&&x.type!=="edm:Null"){w.category=l[w.type];x.category=l[x.type];g.adjustOperands(w,x);g.adjustOperands(x,w);if(w.category!==x.category){B.error(e,"Expected two comparable parameters but instead saw "+w.type+" and "+x.type);}y=w.category==="decimal"?",true":"";N=q[w.category];}V=g.formatOperand(e,0,w,!N);z=g.formatOperand(e,1,x,!N);return{result:"expression",value:N?"odata.compare("+V+","+z+y+")"+j[u]+"0":V+j[u]+z,type:"Edm.Boolean"};},parameter:function(i,e,I,u){var v=B.descend(e,I),R;v.asExpression=true;R=g.expression(i,v);if(u&&u!==R.type){B.error(v,"Expected "+u+" but instead saw "+R.type);}return R;},parseDate:function(v){return d.parse(v);},parseDateTimeOffset:function(v){var e=E.DateTimeOffset.exec(v);if(e&&e[1]&&e[1].length>4){v=v.replace(e[1],e[1].slice(0,4));}return o.parse(v.toUpperCase());},parseTimeOfDay:function(v){if(v.length>12){v=v.slice(0,12);}return t.parse(v);},path:function(i,e){var u=e.value,v={},w,I,x,y=i.getModel(),z={getModel:function(){return y;},getPath:function(){return e.path;}},F,R={result:"binding",value:u},G;B.expectType(e,"string");G=B.followPath(z,{"Path":u});if(G&&G.resolvedPath){F=y.getProperty(G.resolvedPath);R.type=F.type;switch(F.type){case"Edm.DateTime":v.displayFormat=F["sap:display-format"];break;case"Edm.Decimal":if(F.precision){v.precision=F.precision;}if(F.scale){v.scale=F.scale;}x=F["Org.OData.Validation.V1.Minimum"];if(x&&(x.Decimal||x.String)){v.minimum=x.Decimal||x.String;w=x["Org.OData.Validation.V1.Exclusive"];if(w){v.minimumExclusive=w.Bool||"true";}}x=F["Org.OData.Validation.V1.Maximum"];if(x&&(x.Decimal||x.String)){v.maximum=x.Decimal||x.String;w=x["Org.OData.Validation.V1.Exclusive"];if(w){v.maximumExclusive=w.Bool||"true";}}break;case"Edm.String":v.maxLength=F.maxLength;I=F["com.sap.vocabularies.Common.v1.IsDigitSequence"];if(I){v.isDigitSequence=I.Bool||"true";}break;}if(F.nullable==="false"){v.nullable="false";}R.constraints=v;}else{L.warning("Could not find property '"+u+"' starting from '"+e.path+"'",null,A);}return R;},replaceIndexes:function(e,u){var v,w=u.split('/'),x,R;function y(z,i){var F=e.getProperty(x+"/"+z);if(typeof F==="string"){w[i]="[${"+z+"}==="+B.toJSON(F)+"]";return true;}return false;}v=k.exec(u);if(!v){return u;}x=v[1];if(!y("namespace",3)){return u;}for(var i=4;i<w.length;i+=1){x=x+"/"+w[i];if(h.test(w[i])&&!y("name",i)){R=e.getProperty(x+"/RecordType");if(R){if(R==="com.sap.vocabularies.UI.v1.DataFieldForAction"){y("Action/String",i);}else if(R==="com.sap.vocabularies.UI.v1.DataFieldForAnnotation"){y("Target/AnnotationPath",i);}else if(R.indexOf("com.sap.vocabularies.UI.v1.DataField")===0){y("Value/Path",i);}}}}return w.join('/');},simpleParserWarningLogged:false,uriEncode:function(i,e){var R=g.parameter(i,e,0);if(R.result==="constant"){if(R.type==="Edm.Date"){R.type="Edm.DateTime";R.value=R.value+"T00:00:00Z";}else if(R.type==="Edm.TimeOfDay"){R.type="Edm.Time";R.value="PT"+R.value.slice(0,2)+"H"+R.value.slice(3,5)+"M"+R.value.slice(6,8)+"S";}}return{result:"expression",value:'odata.uriEncode('+B.resultToString(R,true)+","+B.toJSON(R.type)+")",type:"Edm.String"};},wrapExpression:function(R){if(R.result==="expression"){R.value="("+R.value+")";}return R;}};g._setDateTimeFormatter();return g;});
sap.ui.predefine('sap/ui/model/odata/_ODataMetaModelUtils',["./_AnnotationHelperBasics","sap/base/Log","sap/base/util/deepExtend","sap/base/util/extend"],function(_,L,d,e){"use strict";var b={"Bool":"false"},B={"Bool":"true"},D={"fiscalyear":"IsFiscalYear","fiscalyearperiod":"IsFiscalYearPeriod","year":"IsCalendarYear","yearmonth":"IsCalendarYearMonth","yearmonthday":"IsCalendarDate","yearquarter":"IsCalendarYearQuarter","yearweek":"IsCalendarYearWeek"},f={"interval":"SingleInterval","multi-value":"MultiValue","single-value":"SingleValue"},l="sap.ui.model.odata.ODataMetaModel",s={"bday":"Contact","city":"Contact/adr","country":"Contact/adr","email":"Contact/email","familyname":"Contact/n","givenname":"Contact/n","honorific":"Contact/n","middlename":"Contact/n","name":"Contact","nickname":"Contact","note":"Contact","org":"Contact","org-role":"Contact","org-unit":"Contact","photo":"Contact","pobox":"Contact/adr","region":"Contact/adr","street":"Contact/adr","suffix":"Contact/n","tel":"Contact/tel","title":"Contact","zip":"Contact/adr","class":"Event","dtend":"Event","dtstart":"Event","duration":"Event","fbtype":"Event","location":"Event","status":"Event","transp":"Event","wholeday":"Event","body":"Message","from":"Message","received":"Message","sender":"Message","subject":"Message","completed":"Task","due":"Task","percent-complete":"Task","priority":"Task"},r=/(\w+)(?:;type=([\w,]+))?/,v={"email":{typeMapping:{"home":"home","pref":"preferred","work":"work"},v4EnumType:"com.sap.vocabularies.Communication.v1.ContactInformationType",v4PropertyAnnotation:"com.sap.vocabularies.Communication.v1.IsEmailAddress"},"tel":{typeMapping:{"cell":"cell","fax":"fax","home":"home","pref":"preferred","video":"video","voice":"voice","work":"work"},v4EnumType:"com.sap.vocabularies.Communication.v1.PhoneType",v4PropertyAnnotation:"com.sap.vocabularies.Communication.v1.IsPhoneNumber"}},V={creatable:{"Org.OData.Capabilities.V1.InsertRestrictions":{"Insertable":b}},pageable:{"Org.OData.Capabilities.V1.SkipSupported":b,"Org.OData.Capabilities.V1.TopSupported":b},"requires-filter":{"Org.OData.Capabilities.V1.FilterRestrictions":{"RequiresFilter":B}},topable:{"Org.OData.Capabilities.V1.TopSupported":b}},m={"city":"locality","email":"address","familyname":"surname","givenname":"given","honorific":"prefix","middlename":"additional","name":"fn","org-role":"role","org-unit":"orgunit","percent-complete":"percentcomplete","tel":"uri","zip":"code"},a={"sap:filterable":["Org.OData.Capabilities.V1.FilterRestrictions","NonFilterableProperties"],"sap:required-in-filter":["Org.OData.Capabilities.V1.FilterRestrictions","RequiredProperties"],"sap:sortable":["Org.OData.Capabilities.V1.SortRestrictions","NonSortableProperties"]},c=/^com\.sap\.vocabularies\.Common\.v1\.ValueList(#.*)?$/,w=L.Level.WARNING,U;U={addEntitySetAnnotation:function(o,E,t,n,g){if(t==="EntitySet"&&E.value===n){if(g){d(o,V[E.name]);}else{e(o,V[E.name]);}}},addFilterRestriction:function(p,E){var F,g=f[p["sap:filter-restriction"]];if(!g){if(L.isLoggable(w,l)){L.warning("Unsupported sap:filter-restriction: "+p["sap:filter-restriction"],E.entityType+"."+p.name,l);}return;}F=E["com.sap.vocabularies.Common.v1.FilterExpressionRestrictions"]||[];F.push({"Property":{"PropertyPath":p.name},"AllowedExpressions":{"EnumMember":"com.sap.vocabularies.Common.v1.FilterExpressionType/"+g}});E["com.sap.vocabularies.Common.v1.FilterExpressionRestrictions"]=F;},addNavigationFilterRestriction:function(n,E){var N=E["Org.OData.Capabilities.V1.NavigationRestrictions"]||{};N.RestrictedProperties=N.RestrictedProperties||[];N.RestrictedProperties.push({"FilterRestrictions":{"Filterable":b},"NavigationProperty":{"NavigationPropertyPath":n.name}});E["Org.OData.Capabilities.V1.NavigationRestrictions"]=N;},addPropertyToAnnotation:function(g,E,p){var n=a[g],t=n[0],C=n[1],A=E[t]||{},h=A[C]||[];h.push({"PropertyPath":p.name});A[C]=h;E[t]=A;},addSapSemantics:function(t){if(t.property){t.property.forEach(function(p){var A,i,M,S,T,g=p["sap:semantics"],h,j,o,k,n;if(!g){return;}if(g==="url"){p["Org.OData.Core.V1.IsURL"]=B;return;}if(g in D){h="com.sap.vocabularies.Common.v1."+D[g];p[h]=B;return;}M=r.exec(g);if(!M){if(L.isLoggable(w,l)){L.warning("Unsupported sap:semantics: "+g,t.name+"."+p.name,l);}return;}if(M[2]){g=M[1];n=U.getV4TypesForV2Semantics(g,M[2],p,t);}k=v[g];i=g==="tel"||g==="email";j=s[g];if(j){A=j.split("/");h="com.sap.vocabularies.Communication.v1."+A[0];t[h]=t[h]||{};o=t[h];S=A[1];if(S){o[S]=o[S]||(i?[]:{});if(i){T={};o[S].push(T);o=T;}else{o=o[S];}}o[m[g]||g]={"Path":p.name};if(n){o.type={"EnumMember":n};}}if(k){p[k.v4PropertyAnnotation]=p[k.v4PropertyAnnotation]||B;}});}},addUnitAnnotations:function(S,M){function p(t){(t||[]).forEach(function(T){(T.property||[]).forEach(function(P){var A,i,g,o,u,h=P["sap:unit"],j;if(h){i={getModel:function(){return M;},getPath:function(){return T.$path;}};u={"Path":h};o=_.followPath(i,u);if(o&&o.resolvedPath){j=M.getProperty(o.resolvedPath);g=j["sap:semantics"];if(g==="unit-of-measure"){A="Org.OData.Measures.V1.Unit";}else if(g==="currency-code"){A="Org.OData.Measures.V1.ISOCurrency";}else if(L.isLoggable(w,l)){L.warning("Unsupported sap:semantics='"+g+"' at sap:unit='"+h+"'; "+"expected 'currency-code' or 'unit-of-measure'",T.namespace+"."+T.name+"/"+P.name,l);}if(A&&!(A in P)){P[A]=u;}}else if(L.isLoggable(w,l)){L.warning("Path '"+h+"' for sap:unit cannot be resolved",T.namespace+"."+T.name+"/"+P.name,l);}}});});}S.forEach(function(o){p(o.complexType);p(o.entityType);});},addV4Annotation:function(o,E,t){switch(E.name){case"aggregation-role":if(E.value==="dimension"){o["com.sap.vocabularies.Analytics.v1.Dimension"]=B;}else if(E.value==="measure"){o["com.sap.vocabularies.Analytics.v1.Measure"]=B;}break;case"display-format":if(E.value==="NonNegative"){o["com.sap.vocabularies.Common.v1.IsDigitSequence"]=B;}else if(E.value==="UpperCase"){o["com.sap.vocabularies.Common.v1.IsUpperCase"]=B;}break;case"pageable":case"topable":U.addEntitySetAnnotation(o,E,t,"false",false);break;case"creatable":U.addEntitySetAnnotation(o,E,t,"false",true);break;case"deletable":case"deletable-path":U.handleXableAndXablePath(o,E,t,"Org.OData.Capabilities.V1.DeleteRestrictions","Deletable");break;case"updatable":case"updatable-path":U.handleXableAndXablePath(o,E,t,"Org.OData.Capabilities.V1.UpdateRestrictions","Updatable");break;case"requires-filter":U.addEntitySetAnnotation(o,E,t,"true",true);break;case"field-control":o["com.sap.vocabularies.Common.v1.FieldControl"]={"Path":E.value};break;case"heading":o["com.sap.vocabularies.Common.v1.Heading"]={"String":E.value};break;case"label":o["com.sap.vocabularies.Common.v1.Label"]={"String":E.value};break;case"precision":o["Org.OData.Measures.V1.Scale"]={"Path":E.value};break;case"quickinfo":o["com.sap.vocabularies.Common.v1.QuickInfo"]={"String":E.value};break;case"text":o["com.sap.vocabularies.Common.v1.Text"]={"Path":E.value};break;case"visible":if(E.value==="false"){o["com.sap.vocabularies.Common.v1.FieldControl"]={"EnumMember":"com.sap.vocabularies.Common.v1.FieldControlType/Hidden"};o["com.sap.vocabularies.UI.v1.Hidden"]=B;}break;default:}},calculateEntitySetAnnotations:function(E,o){if(o.property){o.property.forEach(function(p){if(p["sap:filterable"]==="false"){U.addPropertyToAnnotation("sap:filterable",E,p);}if(p["sap:required-in-filter"]==="true"){U.addPropertyToAnnotation("sap:required-in-filter",E,p);}if(p["sap:sortable"]==="false"){U.addPropertyToAnnotation("sap:sortable",E,p);}if(p["sap:filter-restriction"]){U.addFilterRestriction(p,E);}});}if(o.navigationProperty){o.navigationProperty.forEach(function(n){if(n["sap:filterable"]==="false"){U.addNavigationFilterRestriction(n,E);U.addPropertyToAnnotation("sap:filterable",E,n);}U.handleCreatableNavigationProperty(E,n);});}},findIndex:function(A,E,p){var i,n;p=p||"name";if(A){for(i=0,n=A.length;i<n;i+=1){if(A[i][p]===E){return i;}}}return-1;},findObject:function(A,E,p){var i=U.findIndex(A,E,p);return i<0?null:A[i];},getChildAnnotations:function(A,q,i){var o=i?A.EntityContainer:A.propertyAnnotations;return o&&o[q]||{};},getFromContainer:function(E,A,n,g){var k,R=g?undefined:null;if(E){k=U.findIndex(E[A],n);if(k>=0){R=g?E.$path+"/"+A+"/"+k:E[A][k];}}return R;},getObject:function(M,A,q,g){var h,R=g?undefined:null,S,i,n,N;q=q||"";i=q.lastIndexOf(".");n=q.slice(0,i);N=q.slice(i+1);S=U.getSchema(M,n);if(S){h=S[A];if(h){h.some(function(t){if(t.name===N){R=g?t.$path:t;return true;}return false;});}}return R;},getSchema:function(M,n){var S=null,g=Array.isArray(M)?M:M.getObject("/dataServices/schema");if(g){g.some(function(o){if(o.namespace===n){S=o;return true;}return false;});}return S;},getV4TypesForV2Semantics:function(S,t,p,T){var R=[],o=v[S];if(o){t.split(",").forEach(function(g){var h=o.typeMapping[g];if(h){R.push(o.v4EnumType+"/"+h);}else if(L.isLoggable(w,l)){L.warning("Unsupported type for sap:semantics: "+g,T.name+"."+p.name,l);}});}return R.join(" ");},getValueLists:function(p){var M,n,q,g={};for(n in p){M=c.exec(n);if(M){q=(M[1]||"").slice(1);g[q]=p[n];}}return g;},handleCreatableNavigationProperty:function(E,n){var C=n["sap:creatable"],g=n["sap:creatable-path"],i,N={"NavigationPropertyPath":n.name},h;if(C&&g){L.warning("Inconsistent service","Use either 'sap:creatable' or 'sap:creatable-path' at navigation property "+"'"+E.entityType+"/"+n.name+"'",l);C="false";g=undefined;}if(C==="false"||g){i=E["Org.OData.Capabilities.V1.InsertRestrictions"]=E["Org.OData.Capabilities.V1.InsertRestrictions"]||{};h=i["NonInsertableNavigationProperties"]=i["NonInsertableNavigationProperties"]||[];if(g){N={"If":[{"Not":{"Path":g}},N]};}h.push(N);}},handleXableAndXablePath:function(o,E,t,T,p){var g=p.toLowerCase(),h;if(t!=="EntitySet"){return;}if(o["sap:"+g]&&o["sap:"+g+"-path"]){L.warning("Inconsistent service","Use either 'sap:"+g+"' or 'sap:"+g+"-path'"+" at entity set '"+o.name+"'",l);h=b;}else if(g!==E.name){h={"Path":E.value};}else if(E.value==="false"){h=b;}if(h){o[T]=o[T]||{};o[T][p]=h;}},liftSAPData:function(o,t){if(!o.extensions){return;}o.extensions.forEach(function(E){if(E.namespace==="http://www.sap.com/Protocols/SAPData"){o["sap:"+E.name]=E.value;U.addV4Annotation(o,E,t);}});switch(t){case"Property":if(o["sap:updatable"]==="false"){if(o["sap:creatable"]==="false"){o["Org.OData.Core.V1.Computed"]=B;}else{o["Org.OData.Core.V1.Immutable"]=B;}}break;case"EntitySet":if(o["sap:searchable"]!=="true"){o["Org.OData.Capabilities.V1.SearchRestrictions"]={"Searchable":b};}break;default:}},merge:function(A,o,M){var S=o.dataServices.schema;if(!S){return;}S.forEach(function(g,i){var h;delete g.annotations;U.liftSAPData(g);g.$path="/dataServices/schema/"+i;h=g["sap:schema-version"];if(h){g["Org.Odata.Core.V1.SchemaVersion"]={String:h};}e(g,A[g.namespace]);U.visitParents(g,A,"association",function(j,C){U.visitChildren(j.end,C);});U.visitParents(g,A,"complexType",function(C,j){U.visitChildren(C.property,j,"Property");U.addSapSemantics(C);});U.visitParents(g,A,"entityType",U.visitEntityType);});S.forEach(function(g){U.visitParents(g,A,"entityContainer",function(E,C){U.visitChildren(E.associationSet,C);U.visitChildren(E.entitySet,C,"EntitySet",S);U.visitChildren(E.functionImport,C,"",null,U.visitParameters.bind(this,A,g,E));});});U.addUnitAnnotations(S,M);},visitChildren:function(C,g,t,S,h,i){if(!C){return;}if(i){C=C.slice(i);}C.forEach(function(o){U.liftSAPData(o,t);});C.forEach(function(o){var E;if(t==="EntitySet"){E=U.getObject(S,"entityType",o.entityType);U.calculateEntitySetAnnotations(o,E);}if(h){h(o);}e(o,g[o.name||o.role]);});},visitEntityType:function(E,C){U.visitChildren(E.property,C,"Property");U.visitChildren(E.navigationProperty,C);U.addSapSemantics(E);},visitParameters:function(A,S,E,F){var g;if(!F.parameter){return;}g=U.getChildAnnotations(A,S.namespace+"."+E.name,true);F.parameter.forEach(function(p){U.liftSAPData(p);e(p,g[F.name+"/"+p.name]);});},visitParents:function(S,A,g,C,i){var p=S[g];function h(P,j){var q=S.namespace+"."+P.name,k=U.getChildAnnotations(A,q,g==="entityContainer");U.liftSAPData(P);P.namespace=S.namespace;P.$path=S.$path+"/"+g+"/"+j;C(P,k);e(P,A[q]);}if(!p){return;}if(i!==undefined){h(p[i],i);}else{p.forEach(h);}}};return U;});
sap.ui.predefine('sap/ui/model/odata/type/Boolean',["sap/base/Log","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType","sap/ui/core/Core"],function(L,F,P,V,O){"use strict";
function g(){return a("EnterYesOrNo",[b(true),b(false)]);}
function a(k,p){return sap.ui.getCore().getLibraryResourceBundle().getText(k,p);}
function b(v){return a(v?"YES":"NO");}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}}
var E=O.extend("sap.ui.model.odata.type.Boolean",{constructor:function(f,c){O.apply(this,arguments);s(this,c);}});
E.prototype.formatValue=function(v,t){if(v===null||v===undefined){return null;}switch(this.getPrimitiveType(t)){case"any":case"boolean":return v;case"string":return b(v);default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
E.prototype.parseValue=function(v,S){var c;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"boolean":return v;case"string":c=v.trim().toLowerCase();if(c===b(true).toLowerCase()){return true;}if(c===b(false).toLowerCase()){return false;}throw new P(g());default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}};
E.prototype.validateValue=function(v){if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g());}return;}if(typeof v!=="boolean"){throw new V("Illegal "+this.getName()+" value: "+v);}};
E.prototype.getName=function(){return"sap.ui.model.odata.type.Boolean";};
return E;});
sap.ui.predefine('sap/ui/model/odata/type/Byte',["sap/ui/model/odata/type/Int"],function(I){"use strict";var r={minimum:0,maximum:255};
var B=I.extend("sap.ui.model.odata.type.Byte",{constructor:function(){I.apply(this,arguments);}});
B.prototype.getName=function(){return"sap.ui.model.odata.type.Byte";};
B.prototype.getRange=function(){return r;};
return B;});
sap.ui.predefine('sap/ui/model/odata/type/Currency',["./UnitMixin","sap/ui/model/type/Currency"],function(a,B){"use strict";
var C=B.extend("sap.ui.model.odata.type.Currency",{constructor:function(f,c){this._applyUnitMixin.apply(this,arguments);}});
a(C.prototype,B,"customCurrencies","Currency");
C.prototype.getCustomUnitForKey=function(c,k){return{decimals:c[k].UnitSpecificScale,isoCode:c[k].StandardCode};};
C.prototype.getName=function(){return"sap.ui.model.odata.type.Currency";};
return C;});
sap.ui.predefine('sap/ui/model/odata/type/Date',["sap/base/Log","sap/base/util/extend","sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,e,C,D,F,P,V,O){"use strict";var r=/\d{4}-(?:0[1-9]|1[0-2])-(?:0[1-9]|[12]\d|3[01])/,d=new Date().getFullYear()+"-12-31",m;
function g(t){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterDate",[t.formatValue(d,"string")]);}
function a(t){var f;if(!t.oFormat){f=e({strictParsing:true},t.oFormatOptions);f.UTC=true;t.oFormat=D.getDateInstance(f);}return t.oFormat;}
function b(){if(!m){m=D.getDateInstance({calendarType:C.Gregorian,pattern:'yyyy-MM-dd',strictParsing:true,UTC:true});}return m;}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}}
var E=O.extend("sap.ui.model.odata.type.Date",{constructor:function(f,c){O.apply(this,arguments);this.oFormatOptions=f;s(this,c);}});
E.prototype._handleLocalizationChange=function(){this.oFormat=null;};
E.prototype.formatValue=function(v,t){var o;if(v===undefined||v===null){return null;}switch(this.getPrimitiveType(t)){case"any":return v;case"object":return v instanceof Date?new Date(v.getUTCFullYear(),v.getUTCMonth(),v.getUTCDate()):b().parse(v,false);case"string":o=v instanceof Date?v:b().parse(v);return o?a(this).format(o):v;default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
E.prototype.getModelFormat=function(){return b();};
E.prototype.getName=function(){return"sap.ui.model.odata.type.Date";};
E.prototype.parseValue=function(v,S){var R;if(v===""||v===null){return null;}switch(this.getPrimitiveType(S)){case"object":return b().format(v,false);case"string":R=a(this).parse(v);if(!R){throw new P(g(this));}return b().format(R);default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}};
E.prototype.validateValue=function(v){if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g(this));}}else if(typeof v!=="string"||!r.test(v)){throw new V("Illegal "+this.getName()+" value: "+v);}};
E._resetModelFormatter=function(){m=undefined;};
return E;});
sap.ui.predefine('sap/ui/model/odata/type/DateTime',["sap/base/Log","sap/ui/model/odata/type/DateTimeBase"],function(L,D){"use strict";
function a(t,c){var A={};if(c){switch(c.displayFormat){case"Date":A.isDateOnly=true;break;case undefined:break;default:L.warning("Illegal displayFormat: "+c.displayFormat,null,t.getName());}A.nullable=c.nullable;}return A;}
var b=D.extend("sap.ui.model.odata.type.DateTime",{constructor:function(f,c){D.call(this,f,a(this,c));}});
b.prototype.getConstraints=function(){var c=D.prototype.getConstraints.call(this);if(c.isDateOnly){c.displayFormat="Date";delete c.isDateOnly;}return c;};
b.prototype.getName=function(){return"sap.ui.model.odata.type.DateTime";};
return b;});
sap.ui.predefine('sap/ui/model/odata/type/DateTimeBase',["sap/base/Log","sap/base/util/extend","sap/ui/core/format/DateFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,e,D,F,P,V,O){"use strict";var f=new Date().getFullYear(),d=new Date(Date.UTC(f,11,31)),o=new Date(f,11,31,23,59,58);
function i(t){return t.oConstraints&&t.oConstraints.isDateOnly;}
function g(t){return sap.ui.getCore().getLibraryResourceBundle().getText(i(t)?"EnterDate":"EnterDateTime",[t.formatValue(i(t)?d:o,"string")]);}
function a(t){var c;if(!t.oFormat){c=e({strictParsing:true},t.oFormatOptions);if(i(t)){c.UTC=true;t.oFormat=D.getDateInstance(c);}else{t.oFormat=D.getDateTimeInstance(c);}}return t.oFormat;}
function s(t,c){var n,p;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}if(c.isDateOnly===true){t.oConstraints=t.oConstraints||{};t.oConstraints.isDateOnly=true;}p=c.precision;if(p!==undefined){if(p===Math.floor(p)&&p>=1&&p<=12){t.oConstraints=t.oConstraints||{};t.oConstraints.precision=p;}else if(p!==0){L.warning("Illegal precision: "+p,null,t.getName());}}}t._handleLocalizationChange();}
var b=O.extend("sap.ui.model.odata.type.DateTimeBase",{
constructor:function(c,C){O.apply(this,arguments);s(this,C);this.oFormat=null;this.oFormatOptions=c;},
metadata:{"abstract":true}
});
b.prototype.formatValue=function(v,t){if(v===null||v===undefined){return null;}switch(this.getPrimitiveType(t)){case"any":case"object":return v;case"string":if(!(v instanceof Date)){throw new F("Illegal "+this.getName()+" value: "+v);}return a(this).format(v);default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
b.prototype.parseValue=function(v,S){var r;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"object":return v;case"string":r=a(this).parse(v);if(!r){throw new P(g(this));}return r;default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}};
b.prototype._handleLocalizationChange=function(){this.oFormat=null;};
b.prototype.validateValue=function(v){if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g(this));}return;}else if(v instanceof Date){if(v.getFullYear()===0){throw new V(g(this));}return;}throw new V("Illegal "+this.getName()+" value: "+v);};
return b;});
sap.ui.predefine('sap/ui/model/odata/type/DateTimeOffset',["sap/base/Log","sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/FormatException","sap/ui/model/odata/type/DateTimeBase"],function(L,C,D,F,a){"use strict";
var b=a.extend("sap.ui.model.odata.type.DateTimeOffset",{constructor:function(f,c){var v;a.call(this,f,{nullable:c?c.nullable:undefined,precision:c?c.precision:undefined});this.rDateTimeOffset=undefined;this.oModelFormat=undefined;this.bV4=false;if(c){v=c.V4;if(v===true){this.bV4=true;}else if(v!==undefined&&v!==false){L.warning("Illegal V4: "+v,null,this.getName());}}}});
function g(t){var p="yyyy-MM-dd'T'HH:mm:ss",P;if(!t.oModelFormat){P=t.oConstraints&&t.oConstraints.precision;if(P){p+="."+"".padEnd(P,"S");}t.oModelFormat=D.getDateInstance({calendarType:C.Gregorian,pattern:p+"XXX",strictParsing:true,UTC:t.oFormatOptions&&t.oFormatOptions.UTC});}return t.oModelFormat;}
b.prototype._resetModelFormatter=function(){this.oModelFormat=undefined;};
b.prototype.formatValue=function(v,t){var d;if(v===undefined||v===null){return null;}if(this.getPrimitiveType(t)==="object"){if(v instanceof Date){return new Date(v.getUTCFullYear(),v.getUTCMonth(),v.getUTCDate(),v.getUTCHours(),v.getUTCMinutes(),v.getUTCSeconds());}return g(this).parse(v);}if(typeof v==="string"&&this.getPrimitiveType(t)==="string"){d=g(this).parse(v);if(!d){throw new F("Illegal "+this.getName()+" value: "+v);}v=d;}return a.prototype.formatValue.call(this,v,t);};
b.prototype.getConstraints=function(){var c=a.prototype.getConstraints.call(this);if(this.bV4){c.V4=true;}return c;};
b.prototype.getModelFormat=function(){if(this.bV4){return g(this);}return a.prototype.getModelFormat.call(this);};
b.prototype.getName=function(){return"sap.ui.model.odata.type.DateTimeOffset";};
b.prototype.parseValue=function(v,s){var r=a.prototype.parseValue.call(this,v,s);return this.bV4&&r!==null?g(this).format(r):r;};
b.prototype.setV4=function(){this.bV4=true;return this;};
b.prototype.validateValue=function(v){var p;if(this.bV4){if(typeof v==="string"){if(!this.rDateTimeOffset){p=this.oConstraints&&this.oConstraints.precision;this.rDateTimeOffset=new RegExp("^"+"\\d{4}-(?:0[1-9]|1[0-2])-(?:0[1-9]|[12]\\d|3[01])"+"T"+"(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d"+(p?"(\\.\\d{1,"+p+"})?":"")+")?"+"(?:Z|[-+](?:0\\d|1[0-3]):[0-5]\\d|[-+]14:00)$","i");}if(this.rDateTimeOffset.test(v)){return;}}else if(v){v=v.toString();}}a.prototype.validateValue.call(this,v);};
return b;});
sap.ui.predefine('sap/ui/model/odata/type/Decimal',["sap/base/Log","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/ODataUtils","sap/ui/model/odata/type/ODataType"],function(L,N,F,P,V,B,O){"use strict";var r=/^[-+]?(\d+)(?:\.(\d+))?$/,a=/(?:(\.[0-9]*[1-9]+)0+|\.0*)$/;
function g(t){var f,S,T;if(!t.oFormat){f={groupingEnabled:true,maxIntegerDigits:Infinity};S=b(t);if(S!==Infinity){f.minFractionDigits=f.maxFractionDigits=S;}T=t.oFormatOptions||{};if(T.style!=="short"&&T.style!=="long"){f.preserveDecimals=true;}Object.assign(f,t.oFormatOptions);f.parseAsString=true;t.oFormat=N.getFloatInstance(f);}return t.oFormat;}
function b(t){return(t.oConstraints&&t.oConstraints.scale)||0;}
function c(k,p){return sap.ui.getCore().getLibraryResourceBundle().getText(k,p);}
function d(v){if(v.indexOf(".")>=0){v=v.replace(a,"$1");}return v;}
function s(t,C){var n,p,v,S,e;function l(k,m){L.warning("Illegal "+m+": "+k,null,t.getName());}function f(k,m,M,o){var q=typeof k==="string"?parseInt(k):k;if(q===undefined){return m;}if(typeof q!=="number"||isNaN(q)||q<M){l(k,o);return m;}return q;}function h(k,m){if(k){if(k.match(r)){return k;}l(k,m);}return undefined;}function i(k,m){if(k===true||k==="true"){return true;}if(k!==undefined&&k!==false&&k!=="false"){l(k,m);}return undefined;}function j(k,m,o){if(m!==o){t.oConstraints=t.oConstraints||{};t.oConstraints[k]=m;}}t.oConstraints=undefined;if(C){n=C.nullable;v=C.precision;e=C.scale;S=e==="variable"?Infinity:f(e,0,0,"scale");p=f(v,Infinity,1,"precision");if(S!==Infinity&&p<S){L.warning("Illegal scale: must be less than or equal to precision (precision="+v+", scale="+e+")",null,t.getName());S=Infinity;}j("precision",p,Infinity);j("scale",S,0);if(n===false||n==="false"){j("nullable",false,true);}else if(n!==undefined&&n!==true&&n!=="true"){l(n,"nullable");}j("minimum",h(C.minimum,"minimum"));j("minimumExclusive",i(C.minimumExclusive,"minimumExclusive"));j("maximum",h(C.maximum,"maximum"));j("maximumExclusive",i(C.maximumExclusive,"maximumExclusive"));}t._handleLocalizationChange();}
var D=O.extend("sap.ui.model.odata.type.Decimal",{constructor:function(f,C){O.apply(this,arguments);this.oFormatOptions=f;s(this,C);}});
D.prototype.formatValue=function(v,t){if(v===null||v===undefined){return null;}switch(this.getPrimitiveType(t)){case"any":return v;case"float":return parseFloat(v);case"int":return Math.floor(parseFloat(v));case"string":return g(this).format(d(String(v)));default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
D.prototype.parseValue=function(v,S){var R;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"string":R=g(this).parse(v);if(!R){throw new P(sap.ui.getCore().getLibraryResourceBundle().getText("EnterNumber"));}R=d(R);break;case"int":case"float":R=N.getFloatInstance({maxIntegerDigits:Infinity,decimalSeparator:".",groupingEnabled:false}).format(v);break;default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}return R;};
D.prototype._handleLocalizationChange=function(){this.oFormat=null;};
D.prototype.validateValue=function(v){var f,i,m,M,e,h,j,p,S;if(v===null&&(!this.oConstraints||this.oConstraints.nullable!==false)){return;}if(typeof v!=="string"){throw new V(c("EnterNumber"));}m=r.exec(v);if(!m){throw new V(c("EnterNumber"));}i=m[1].length;f=(m[2]||"").length;S=b(this);p=(this.oConstraints&&this.oConstraints.precision)||Infinity;h=this.oConstraints&&this.oConstraints.minimum;M=this.oConstraints&&this.oConstraints.maximum;if(f>S){if(S===0){throw new V(c("EnterInt"));}else if(i+S>p){if(S!==p){throw new V(c("EnterNumberIntegerFraction",[p-S,S]));}if(m[1]!=="0"){throw new V(c("EnterNumberFractionOnly",[S]));}}throw new V(c("EnterNumberFraction",[S]));}if(S===Infinity){if(i+f>p){throw new V(c("EnterNumberPrecision",[p]));}}else if(i>p-S){if(S!==p){if(S){throw new V(c("EnterNumberInteger",[p-S]));}throw new V(c("EnterMaximumOfDigits",[p]));}if(m[1]!=="0"){throw new V(c("EnterNumberFractionOnly",[S]));}}if(h){j=this.oConstraints.minimumExclusive;if(B.compare(h,v,true)>=(j?0:1)){throw new V(c(j?"EnterNumberMinExclusive":"EnterNumberMin",[this.formatValue(h,"string")]));}}if(M){e=this.oConstraints.maximumExclusive;if(B.compare(M,v,true)<=(e?0:-1)){throw new V(c(e?"EnterNumberMaxExclusive":"EnterNumberMax",[this.formatValue(M,"string")]));}}};
D.prototype.getName=function(){return"sap.ui.model.odata.type.Decimal";};
return D;});
sap.ui.predefine('sap/ui/model/odata/type/Double',["sap/base/Log","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,N,F,P,V,O){"use strict";
function g(){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterNumber");}
function a(t){var f,T;if(!t.oFormat){f={groupingEnabled:true};T=t.oFormatOptions||{};if(T.style!=="short"&&T.style!=="long"){f.preserveDecimals=true;}Object.assign(f,t.oFormatOptions);t.oFormat=N.getFloatInstance(f);}return t.oFormat;}
function i(t){return!t.oConstraints||t.oConstraints.nullable!==false;}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}t._handleLocalizationChange();}
var D=O.extend("sap.ui.model.odata.type.Double",{constructor:function(f,c){O.apply(this,arguments);this.oFormatOptions=f;s(this,c);}});
D.prototype.formatValue=function(v,t){var f,b;if(v===null||v===undefined){return null;}if(typeof v==="number"){b=v;}else if(typeof v==="string"){b=parseFloat(v);}else if(t!=="any"){throw new F("Illegal "+this.getName()+" value: "+v);}switch(this.getPrimitiveType(t)){case"any":return v;case"float":return b;case"int":return Math.floor(b);case"string":if(b&&(Math.abs(b)>=1e15||Math.abs(b)<1e-4)){f=a(this).oFormatOptions;return b.toExponential().replace("e","\u00a0E").replace(".",f.decimalSeparator).replace("+",f.plusSign).replace("-",f.minusSign);}return a(this).format(b);default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
D.prototype.parseValue=function(v,S){var r;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"string":r=a(this).parse(v);if(isNaN(r)){throw new P(g());}break;case"int":case"float":r=v;break;default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}return r;};
D.prototype._handleLocalizationChange=function(){this.oFormat=null;};
D.prototype.validateValue=function(v){if(v===null&&i(this)){return;}if(typeof v==="number"){return;}throw new V(g());};
D.prototype.getName=function(){return"sap.ui.model.odata.type.Double";};
return D;});
sap.ui.predefine('sap/ui/model/odata/type/Guid',["sap/base/Log","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,F,P,V,O){"use strict";var r=/[-\s]/g,a=/^[A-F0-9]{8}-([A-F0-9]{4}-){3}[A-F0-9]{12}$/i;
function g(){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterGuid");}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}}
var E=O.extend("sap.ui.model.odata.type.Guid",{constructor:function(f,c){O.apply(this,arguments);s(this,c);}});
E.prototype.formatValue=function(v,t){if(v===undefined||v===null){return null;}switch(this.getPrimitiveType(t)){case"any":case"string":return v;default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
E.prototype.getName=function(){return"sap.ui.model.odata.type.Guid";};
E.prototype.parseValue=function(v,S){var R;if(v===""||v===null){return null;}if(this.getPrimitiveType(S)!=="string"){throw new P("Don't know how to parse "+this.getName()+" from "+S);}R=v.replace(r,'');if(R.length!==32){return v;}return R.slice(0,8)+'-'+R.slice(8,12)+'-'+R.slice(12,16)+'-'+R.slice(16,20)+'-'+R.slice(20);};
E.prototype.validateValue=function(v){if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g());}return;}if(typeof v!=="string"){throw new V("Illegal "+this.getName()+" value: "+v);}if(!a.test(v)){throw new V(g());}};
return E;});
sap.ui.predefine('sap/ui/model/odata/type/Int',["sap/base/Log","sap/base/util/extend","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,e,N,F,P,V,O){"use strict";
function g(t){var f;if(!t.oFormat){f=e({groupingEnabled:true},t.oFormatOptions);t.oFormat=N.getIntegerInstance(f);}return t.oFormat;}
function a(k,p){return sap.ui.getCore().getLibraryResourceBundle().getText(k,p);}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}t._handleLocalizationChange();}
var I=O.extend("sap.ui.model.odata.type.Int",{
constructor:function(f,c){O.apply(this,arguments);this.oFormatOptions=f;s(this,c);},
metadata:{"abstract":true}
});
I.prototype._handleLocalizationChange=function(){this.oFormat=null;};
I.prototype.formatValue=function(v,t){if(v===undefined||v===null){return null;}if(typeof v!=="number"&&t!=="any"){throw new F("Illegal "+this.getName()+" value: "+v);}switch(this.getPrimitiveType(t)){case"string":return g(this).format(v);case"int":return Math.floor(v);case"float":case"any":return v;default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
I.prototype.parseValue=function(v,S){var r;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"string":r=g(this).parse(v);if(isNaN(r)){throw new P(a("EnterInt"));}return r;case"float":return Math.floor(v);case"int":return v;default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}};
I.prototype.validateValue=function(v){var r=this.getRange();if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(a("EnterInt"));}return;}if(typeof v!=="number"){throw new V(v+" (of type "+typeof v+") is not a valid "+this.getName()+" value");}if(Math.floor(v)!==v){throw new V(a("EnterInt"));}if(v<r.minimum){throw new V(a("EnterNumberMin",[this.formatValue(r.minimum,"string")]));}if(v>r.maximum){throw new V(a("EnterNumberMax",[this.formatValue(r.maximum,"string")]));}};
return I;});
sap.ui.predefine('sap/ui/model/odata/type/Int16',["sap/ui/model/odata/type/Int"],function(I){"use strict";var r={minimum:-32768,maximum:32767};
var a=I.extend("sap.ui.model.odata.type.Int16",{constructor:function(){I.apply(this,arguments);}});
a.prototype.getName=function(){return"sap.ui.model.odata.type.Int16";};
a.prototype.getRange=function(){return r;};
return a;});
sap.ui.predefine('sap/ui/model/odata/type/Int32',["sap/ui/model/odata/type/Int"],function(I){"use strict";var r={minimum:-2147483648,maximum:2147483647};
var a=I.extend("sap.ui.model.odata.type.Int32",{constructor:function(){I.apply(this,arguments);}});
a.prototype.getName=function(){return"sap.ui.model.odata.type.Int32";};
a.prototype.getRange=function(){return r;};
return a;});
sap.ui.predefine('sap/ui/model/odata/type/Int64',["sap/base/Log","sap/base/util/extend","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,e,N,F,P,V,O){"use strict";var r=/^[-+]?(\d+)$/,R={minimum:"-9223372036854775808",maximum:"9223372036854775807"},s={minimum:"-9007199254740991",maximum:"9007199254740991"};
function c(t,v,R){var A,m,n;m=r.exec(v);if(m){n=v.charAt(0)==='-';A=n?R.minimum.slice(1):R.maximum;if(m[1].length<A.length){return undefined;}if(m[1].length>A.length||m[1]>A){if(n){return a("EnterNumberMin",[t.formatValue(R.minimum,"string")]);}else{return a("EnterNumberMax",[t.formatValue(R.maximum,"string")]);}}return undefined;}return a("EnterInt");}
function g(t){var f;if(!t.oFormat){f=e({groupingEnabled:true},t.oFormatOptions);f.parseAsString=true;t.oFormat=N.getIntegerInstance(f);}return t.oFormat;}
function a(k,p){return sap.ui.getCore().getLibraryResourceBundle().getText(k,p);}
function i(t){return!t.oConstraints||t.oConstraints.nullable!==false;}
function b(t,C){var n;t.oConstraints=undefined;if(C){n=C.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}t._handleLocalizationChange();}
var I=O.extend("sap.ui.model.odata.type.Int64",{constructor:function(f,C){O.apply(this,arguments);this.oFormatOptions=f;b(this,C);}});
I.prototype.formatValue=function(v,t){var E;if(v===null||v===undefined){return null;}switch(this.getPrimitiveType(t)){case"any":return v;case"float":case"int":E=c(this,v,s);if(E){throw new F(E);}return parseInt(v);case"string":return g(this).format(v);default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
I.prototype.getName=function(){return"sap.ui.model.odata.type.Int64";};
I.prototype._handleLocalizationChange=function(){this.oFormat=null;};
I.prototype.parseValue=function(v,S){var d;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"string":d=g(this).parse(v);if(!d){throw new P(a("EnterInt"));}break;case"int":case"float":d=N.getIntegerInstance({maxIntegerDigits:Infinity,groupingEnabled:false}).format(v);break;default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}return d;};
I.prototype.validateValue=function(v){var E;if(v===null&&i(this)){return;}if(typeof v==="string"){E=c(this,v,R);if(E){throw new V(E);}return;}throw new V(a("EnterInt"));};
return I;});
sap.ui.predefine('sap/ui/model/odata/type/ODataType',["sap/ui/model/SimpleType"],function(S){"use strict";
var O=S.extend("sap.ui.model.odata.type.ODataType",{
constructor:function(f,c){},
metadata:{"abstract":true}
});
O.prototype.setConstraints=function(c){};
O.prototype.setFormatOptions=function(f){};
return O;});
sap.ui.predefine('sap/ui/model/odata/type/Raw',["sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(F,P,V,O){"use strict";
var R=O.extend("sap.ui.model.odata.type.Raw",{constructor:function(f,c){O.apply(this,arguments);if(f!==undefined||c!==undefined||arguments.length>2){throw new Error("Unsupported arguments");}}});
R.prototype.formatValue=function(v,t){if(t==="any"){return v;}throw new F("Type 'sap.ui.model.odata.type.Raw' does not support formatting");};
R.prototype.getName=function(){return"sap.ui.model.odata.type.Raw";};
R.prototype.parseValue=function(){throw new P("Type 'sap.ui.model.odata.type.Raw' does not support parsing");};
R.prototype.validateValue=function(){throw new V("Type 'sap.ui.model.odata.type.Raw' does not support validating");};
return R;});
sap.ui.predefine('sap/ui/model/odata/type/SByte',["sap/ui/model/odata/type/Int"],function(I){"use strict";var r={minimum:-128,maximum:127};
var S=I.extend("sap.ui.model.odata.type.SByte",{constructor:function(){I.apply(this,arguments);}});
S.prototype.getName=function(){return"sap.ui.model.odata.type.SByte";};
S.prototype.getRange=function(){return r;};
return S;});
sap.ui.predefine('sap/ui/model/odata/type/Single',["sap/base/Log","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,N,F,P,V,O){"use strict";
function g(){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterNumber");}
function a(t){var f,T;if(!t.oFormat){f={groupingEnabled:true};T=t.oFormatOptions||{};if(T.style!=="short"&&T.style!=="long"){f.preserveDecimals=true;}Object.assign(f,t.oFormatOptions);t.oFormat=N.getFloatInstance(f);}return t.oFormat;}
function i(t){return!t.oConstraints||t.oConstraints.nullable!==false;}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}t._handleLocalizationChange();}
var S=O.extend("sap.ui.model.odata.type.Single",{constructor:function(f,c){O.apply(this,arguments);this.oFormatOptions=f;s(this,c);}});
S.prototype.formatValue=function(v,t){var f;if(v===null||v===undefined){return null;}if(typeof v==="number"){f=v;}else if(typeof v==="string"){f=parseFloat(v);}else if(t!=="any"){throw new F("Illegal "+this.getName()+" value: "+v);}switch(this.getPrimitiveType(t)){case"any":return v;case"float":return f;case"int":return Math.floor(f);case"string":return a(this).format(parseFloat(f.toPrecision(7)));default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
S.prototype.parseValue=function(v,b){var r;if(v===null||v===""){return null;}switch(this.getPrimitiveType(b)){case"string":r=a(this).parse(v);if(isNaN(r)){throw new P(g());}break;case"int":case"float":r=v;break;default:throw new P("Don't know how to parse "+this.getName()+" from "+b);}return Math.fround(r);};
S.prototype._handleLocalizationChange=function(){this.oFormat=null;};
S.prototype.validateValue=function(v){if(v===null&&i(this)){return;}if(typeof v==="number"){return;}throw new V(g());};
S.prototype.getName=function(){return"sap.ui.model.odata.type.Single";};
return S;});
sap.ui.predefine('sap/ui/model/odata/type/Stream',["sap/base/Log","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,F,P,V,O){"use strict";
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true){L.warning("Illegal nullable: "+n,null,t.getName());}}}
var S=O.extend("sap.ui.model.odata.type.Stream",{constructor:function(f,c){O.apply(this,arguments);if(f!==undefined){throw new Error("Unsupported arguments");}s(this,c);}});
S.prototype.formatValue=function(v,t){switch(this.getPrimitiveType(t)){case"any":case"string":return v;default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
S.prototype.getName=function(){return"sap.ui.model.odata.type.Stream";};
S.prototype.parseValue=function(){throw new P("Type 'sap.ui.model.odata.type.Stream' does not support parsing");};
S.prototype.validateValue=function(){throw new V("Type 'sap.ui.model.odata.type.Stream' does not support validating");};
return S;});
sap.ui.predefine('sap/ui/model/odata/type/String',["sap/base/Log","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType","sap/ui/model/type/String"],function(L,V,O,S){"use strict";var r=/^\d+$/,a=/^0*(?=\d)/;
function i(v,c){return c&&c.isDigitSequence&&v&&v.match(r);}
function s(t,c){var I,m,n;t.oConstraints=undefined;if(c){m=c.maxLength;if(typeof m==="string"){m=parseInt(m);}if(typeof m==="number"&&!isNaN(m)&&m>0){t.oConstraints={maxLength:m};}else if(m!==undefined){L.warning("Illegal maxLength: "+c.maxLength,null,t.getName());}I=c.isDigitSequence;if(I===true||I==="true"){t.oConstraints=t.oConstraints||{};t.oConstraints.isDigitSequence=true;}else if(I!==undefined&&I!==false&&I!=="false"){L.warning("Illegal isDigitSequence: "+I,null,t.getName());}n=c.nullable;if(n===false||n==="false"){t.oConstraints=t.oConstraints||{};t.oConstraints.nullable=false;}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}}
var E=O.extend("sap.ui.model.odata.type.String",{constructor:function(f,c){var p=f?f.parseKeepsEmptyString:undefined;O.apply(this,arguments);this.oFormatOptions=f;s(this,c);this._sParsedEmptyString=null;if(this.oConstraints&&this.oConstraints.nullable===false&&this.oConstraints.isDigitSequence){this._sParsedEmptyString="0";}else if(p!==undefined){if(p===true){this._sParsedEmptyString="";}else if(p!==false){L.warning("Illegal parseKeepsEmptyString: "+p,null,this.getName());}}}});
E.prototype.formatValue=function(v,t){if(v===null&&this.getPrimitiveType(t)==="string"){return"";}if(i(v,this.oConstraints)){v=v.replace(a,"");if(this.oConstraints.maxLength&&v==="0"&&this.getPrimitiveType(t)==="string"){return"";}}return S.prototype.formatValue.call(this,v,t);};
E.prototype.parseValue=function(v,b){var R;R=v===""?this._sParsedEmptyString:S.prototype.parseValue.apply(this,arguments);if(i(R,this.oConstraints)){R=R.replace(a,"");if(this.oConstraints.maxLength){R=R.padStart(this.oConstraints.maxLength,"0");}}return R;};
E.prototype.validateValue=function(v){var c=this.oConstraints||{},m=c.maxLength;if(v===null){if(c.nullable!==false){return;}}else if(v===""&&this._sParsedEmptyString===""){return;}else if(typeof v!=="string"){throw new V("Illegal "+this.getName()+" value: "+v);}else if(c.isDigitSequence){if(!v.match(r)){throw new V(sap.ui.getCore().getLibraryResourceBundle().getText("EnterDigitsOnly"));}if(m&&v.length>m){throw new V(sap.ui.getCore().getLibraryResourceBundle().getText("EnterMaximumOfDigits",[m]));}return;}else if(!m||v.length<=m){return;}throw new V(sap.ui.getCore().getLibraryResourceBundle().getText(m?"EnterTextMaxLength":"EnterText",[m]));};
E.prototype.getName=function(){return"sap.ui.model.odata.type.String";};
return E;});
sap.ui.predefine('sap/ui/model/odata/type/Time',["sap/base/Log","sap/base/util/extend","sap/ui/core/format/DateFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,a,D,F,P,V,O){"use strict";var d={__edmType:"Edm.Time",ms:86398000},m={format:c,parse:t};
function g(o){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterTime",[o.formatValue(d,"string")]);}
function b(o){var e;if(!o.oFormat){e=a({strictParsing:true},o.oFormatOptions);e.UTC=true;o.oFormat=D.getTimeInstance(e);}return o.oFormat;}
function i(o){return typeof o==="object"&&o.__edmType==="Edm.Time"&&typeof o.ms==="number";}
function s(o,C){var n;o.oConstraints=undefined;if(C){n=C.nullable;if(n===false||n==="false"){o.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,o.getName());}}}
function t(o){if(!i(o)){throw new F("Illegal sap.ui.model.odata.type.Time value: "+f(o));}return new Date(o.ms);}
function c(o){return{__edmType:"Edm.Time",ms:((o.getUTCHours()*60+o.getUTCMinutes())*60+o.getUTCSeconds())*1000+o.getUTCMilliseconds()};}
function f(v){try{return JSON.stringify(v);}catch(e){return String(v);}}
var T=O.extend("sap.ui.model.odata.type.Time",{constructor:function(o,C){O.apply(this,arguments);s(this,C);this.oFormatOptions=o;}});
T.prototype.formatValue=function(v,e){if(v===undefined||v===null){return null;}switch(this.getPrimitiveType(e)){case"any":return v;case"string":return b(this).format(t(v));default:throw new F("Don't know how to format "+this.getName()+" to "+e);}};
T.prototype.getModelFormat=function(){return m;};
T.prototype.getName=function(){return"sap.ui.model.odata.type.Time";};
T.prototype.parseValue=function(v,S){var o;if(v===""||v===null){return null;}if(this.getPrimitiveType(S)!=="string"){throw new P("Don't know how to parse "+this.getName()+" from "+S);}o=b(this).parse(v);if(!o){throw new P(g(this));}return c(o);};
T.prototype.validateValue=function(v){if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g(this));}return;}if(!i(v)){throw new V("Illegal "+this.getName()+" value: "+f(v));}};
T.prototype._handleLocalizationChange=function(){this.oFormat=null;};
return T;});
sap.ui.predefine('sap/ui/model/odata/type/TimeOfDay',["sap/base/Log","sap/base/util/extend","sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,e,C,D,F,P,V,O){"use strict";
function g(t){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterTime",[t.formatValue("23:59:58","string")]);}
function a(t){var f;if(!t.oUiFormat){f=e({strictParsing:true},t.oFormatOptions);f.UTC=true;t.oUiFormat=D.getTimeInstance(f);}return t.oUiFormat;}
function s(t,c){var n,p;t.oConstraints=undefined;if(c){n=c.nullable;p=c.precision;if(n===false){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true){L.warning("Illegal nullable: "+n,null,t.getName());}if(p===Math.floor(p)&&p>0&&p<=12){t.oConstraints=t.oConstraints||{};t.oConstraints.precision=p;}else if(p!==undefined&&p!==0){L.warning("Illegal precision: "+p,null,t.getName());}}}
var T=O.extend("sap.ui.model.odata.type.TimeOfDay",{constructor:function(f,c){O.apply(this,arguments);this.oModelFormat=undefined;this.rTimeOfDay=undefined;this.oUiFormat=undefined;s(this,c);this.oFormatOptions=f;}});
T.prototype._handleLocalizationChange=function(){this.oUiFormat=null;};
T.prototype._resetModelFormatter=function(){this.oModelFormat=undefined;};
T.prototype.formatValue=function(v,t){var d,i,p;if(v===undefined||v===null){return null;}p=this.getPrimitiveType(t);switch(p){case"any":return v;case"object":case"string":i=v.indexOf(".");if(i>=0){v=v.slice(0,i+4);}d=this.getModelFormat().parse(v);if(d){if(p==="object"){return new Date(1970,0,1,d.getUTCHours(),d.getUTCMinutes(),d.getUTCSeconds());}return a(this).format(d);}throw new F("Illegal "+this.getName()+" value: "+v);default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
T.prototype.getModelFormat=function(){var p="HH:mm:ss",i;if(!this.oModelFormat){i=this.oConstraints&&this.oConstraints.precision;if(i){p+="."+"".padEnd(i,"S");}this.oModelFormat=D.getTimeInstance({calendarType:C.Gregorian,pattern:p,strictParsing:true,UTC:true});}return this.oModelFormat;};
T.prototype.getName=function(){return"sap.ui.model.odata.type.TimeOfDay";};
T.prototype.parseValue=function(v,S){var d;if(v===""||v===null){return null;}switch(this.getPrimitiveType(S)){case"object":return this.getModelFormat().format(v,false);case"string":d=a(this).parse(v);if(!d){throw new P(g(this));}return this.getModelFormat().format(d);default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}};
T.prototype.validateValue=function(v){var p;if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g(this));}return;}if(!this.rTimeOfDay){p=this.oConstraints&&this.oConstraints.precision;this.rTimeOfDay=new RegExp("^(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d"+(p?"(\\.\\d{1,"+p+"})?":"")+")?$");}if(!this.rTimeOfDay.test(v)){throw new V("Illegal sap.ui.model.odata.type.TimeOfDay value: "+v);}};
return T;});
sap.ui.predefine('sap/ui/model/odata/type/Unit',["./UnitMixin","sap/ui/core/format/NumberFormat","sap/ui/model/type/Unit"],function(a,N,B){"use strict";
var U=B.extend("sap.ui.model.odata.type.Unit",{constructor:function(f,c,d){this._applyUnitMixin.apply(this,arguments);}});
a(U.prototype,B,"customUnits","Unit");
U.prototype.getCustomUnitForKey=function(c,k){return{decimals:c[k].UnitSpecificScale,displayName:c[k].Text,"unitPattern-count-other":N.getDefaultUnitPattern(k)};};
U.prototype.getName=function(){return"sap.ui.model.odata.type.Unit";};
return U;});
sap.ui.predefine('sap/ui/model/odata/type/UnitMixin',["sap/ui/model/ParseException","sap/ui/model/ValidateException"],function(P,V){"use strict";var c=new Map(),r=/\.(\d+)$/,a=/\.$/,b=/0+$/;
function g(k,p){return sap.ui.getCore().getLibraryResourceBundle().getText(k,p);}
return function(p,B,f,m){function d(k,t){var F,l=this;if(this.mCustomUnits===undefined&&k&&k[2]!==undefined){if(k[2]===null){this.mCustomUnits=null;}else{this.mCustomUnits=c.get(k[2]);if(!this.mCustomUnits){this.mCustomUnits={};Object.keys(k[2]).forEach(function(K){l.mCustomUnits[K]=l.getCustomUnitForKey(k[2],K);});c.set(k[2],this.mCustomUnits);}F={};F[f]=this.mCustomUnits;B.prototype.setFormatOptions.call(this,Object.assign(F,this.oFormatOptions));}}if(!k||k[0]===undefined||k[1]===undefined||this.mCustomUnits===undefined&&k[2]===undefined){return null;}return B.prototype.formatValue.call(this,k.slice(0,2),t);}function e(){var o=B.prototype.getFormatOptions.call(this);delete o[f];return o;}function h(){if(!this.bShowMeasure){return[1,2];}else if(!this.bShowNumber){return[0,2];}return[2];}function i(D){var t;if(!this.bShowNumber){t=D?g(m+".WithDecimals",[D]):g(m+".WithoutDecimals");}else{t=D?g("EnterNumberFraction",[D]):g("EnterInt");}return new V(t);}function j(k,s){var l;if(this.mCustomUnits===undefined){throw new P("Cannot parse value without customizing");}l=B.prototype.parseValue.apply(this,arguments);if(l[0]&&typeof l[0]==="string"&&l[0].includes(".")){l[0]=l[0].replace(b,"").replace(a,"");}return l;}function v(k){var D,F,M,n=k[0],u=k[1];if(this.mCustomUnits===undefined){throw new V("Cannot validate value without customizing");}if(!n||!u||!this.mCustomUnits||this.oConstraints.skipDecimalsValidation){return;}M=r.exec(n);F=M?M[1].length:0;D=this.mCustomUnits[u].decimals;if(F>D){throw this.getValidateException(D);}}function U(F,C){var k=C?Object.keys(C):[];function l(s){if(s!=="skipDecimalsValidation"){throw new Error("Only 'skipDecimalsValidation' constraint is supported");}}if(F&&F[f]){throw new Error("Format option "+f+" is not supported");}k.forEach(l);if(arguments.length>2){throw new Error("Only parameters oFormatOptions and oConstraints are supported");}F=Object.assign({emptyString:0,parseAsString:true,unitOptional:!F||["showMeasure","showNumber"].every(function(o){return!(o in F)||F[o];})},F);C=Object.assign({},C);B.call(this,F,C);this.mCustomUnits=undefined;this.setConstraints=function(){throw new Error("Constraints are immutable");};this.setFormatOptions=function(){throw new Error("Format options are immutable");};}p._applyUnitMixin=U;p.formatValue=d;p.getFormatOptions=e;p.getPartsIgnoringMessages=h;p.getValidateException=i;p.parseValue=j;p.validateValue=v;};});
sap.ui.predefine('sap/ui/model/odata/v2/BatchMode',function(){"use strict";var B={None:"None",Group:"Group"};return B;},true);
sap.ui.predefine('sap/ui/model/odata/v2/Context',["sap/ui/base/SyncPromise","sap/ui/model/Context"],function(S,B){"use strict";
var C=B.extend("sap.ui.model.odata.v2.Context",{constructor:function(m,p,d,c,i){var t=this;B.call(this,m,p);this.oCreatePromise=undefined;this.sDeepPath=d||p;this.bForceRefresh=false;this.bPreliminary=false;this.oSyncCreatePromise=c;this.bUpdated=false;this.bInactive=!!i;this.fnActivate=undefined;this.oActivatedPromise=i?new S(function(r){t.fnActivate=r;}):S.resolve();}});
C.prototype.activate=function(){this.bInactive=false;if(this.fnActivate){this.fnActivate();}};
C.prototype.created=function(){if(this.oSyncCreatePromise&&!this.oCreatePromise){this.oCreatePromise=Promise.resolve(this.oSyncCreatePromise).then(function(){});}return this.oCreatePromise;};
C.prototype.fetchActivated=function(){return this.oActivatedPromise;};
C.prototype.getDeepPath=function(){return this.sDeepPath;};
C.prototype.hasChanged=function(){return this.bUpdated||this.bForceRefresh;};
C.prototype.isInactive=function(){return this.bInactive;};
C.prototype.isPreliminary=function(){return this.bPreliminary;};
C.prototype.isRefreshForced=function(){return this.bForceRefresh;};
C.prototype.isTransient=function(){return this.oSyncCreatePromise&&this.oSyncCreatePromise.isPending();};
C.prototype.isUpdated=function(){return this.bUpdated;};
C.prototype.resetCreatedPromise=function(){this.oCreatePromise=undefined;this.oSyncCreatePromise=undefined;};
C.prototype.setDeepPath=function(d){this.sDeepPath=d;};
C.prototype.setForceRefresh=function(f){this.bForceRefresh=f;};
C.prototype.setPreliminary=function(p){this.bPreliminary=p;};
C.prototype.setUpdated=function(u){this.bUpdated=u;};
return C;});
sap.ui.predefine('sap/ui/model/odata/v2/ODataAnnotations',["sap/base/assert","sap/base/util/extend","sap/ui/base/EventProvider","sap/ui/core/cache/CacheManager","sap/ui/model/odata/AnnotationParser","sap/ui/thirdparty/jquery"],function(a,e,E,C,A,q){"use strict";
var O=E.extend("sap.ui.model.odata.v2.ODataAnnotations",{
constructor:function(m,o){var t=this;E.apply(this,[o]);this._oMetadata=m;this._pLoaded=m.loaded();this._mCustomHeaders={};this._mAnnotations={};this._hasErrors=false;function w(r){if(!t._hasErrors){C.set(t.sCacheKey,JSON.stringify(r));}}if(!o||!o.skipMetadata){if(!o){o={};}if(!o.source){o.source=[];}else if(Array.isArray(o.source)){o.source=o.source.slice(0);}else{o.source=[o.source];}o.source.unshift({type:"xml",data:m.loaded().then(function(p){return{xml:p["metadataString"],lastModified:p["lastModified"],eTag:p["eTag"]};})});}if(o){this.sCacheKey=o.cacheKey;this.setHeaders(o.headers);if(this.sCacheKey){this._pLoaded=C.get(t.sCacheKey).then(function(s){var r;if(s){r=JSON.parse(s);}if(Array.isArray(r)){r.annotations={};r.forEach(function(b){A.restoreAnnotationsAtArrays(b.annotations);A.merge(r.annotations,b.annotations);});t._mAnnotations=r.annotations;t._fireSomeLoaded(r);t._fireLoaded(r);return r;}else{return t.addSource(o.source).then(function(r){w(r);return r;});}});}else{this._pLoaded=this.addSource(o.source);}}},
metadata:{publicMethods:["getData","addSource","getHeaders","setHeaders","attachSuccess","detachSuccess","attachError","detachError","attachLoaded","detachLoaded","attachFailed","detachFailed"]}
});
O.prototype.getData=function(){return this._mAnnotations;};
O.prototype.getAnnotationsData=function(){return this._mAnnotations;};
O.prototype.getHeaders=function(){return e({},this._mCustomHeaders);};
O.prototype.setHeaders=function(h){this._mCustomHeaders=e({},h);};
O.prototype.loaded=function(){return this._pLoaded;};
O.prototype.addSource=function(s){if(!s||Array.isArray(s)&&s.length===0){return this._oMetadata.loaded();}if(!Array.isArray(s)){s=[s];}var t=this;var m=s.map(function(v){v=(typeof v==="string")?{type:"url",data:v}:v;return t._loadSource(v).then(t._parseSourceXML).then(t._parseSource.bind(t)).catch(function(o){return o;});});return Promise.all(m).then(function(b){return b.map(function(o){try{o=t._mergeSource(o);t._fireSuccess(o);}catch(c){t._fireError(o);}return o;});}).then(function(r){r.annotations=t.getData();var b=r.filter(function(R){return R instanceof Error;});if(b.length>0){t._hasErrors=true;if(b.length!==r.length){t._fireSomeLoaded(r);t._fireFailed(r);}else{t._fireFailed(r);t._fireAllFailed(r);return Promise.reject(r);}}else{t._fireSomeLoaded(r);t._fireLoaded(r);}return r;});};
O.prototype.attachSuccess=function(d,f,l){return this.attachEvent("success",d,f,l);};
O.prototype.detachSuccess=function(f,l){return this.detachEvent("success",f,l);};
O.prototype.attachError=function(d,f,l){return this.attachEvent("error",d,f,l);};
O.prototype.detachError=function(f,l){return this.detachEvent("error",f,l);};
O.prototype.attachLoaded=function(d,f,l){return this.attachEvent("loaded",d,f,l);};
O.prototype.detachLoaded=function(f,l){return this.detachEvent("loaded",f,l);};
O.prototype.attachFailed=function(d,f,l){return this.attachEvent("failed",d,f,l);};
O.prototype.detachFailed=function(f,l){return this.detachEvent("failed",f,l);};
O.prototype.attachSomeLoaded=function(d,f,l){return this.attachEvent("someLoaded",d,f,l);};
O.prototype.detachSomeLoaded=function(f,l){return this.detachEvent("someLoaded",f,l);};
O.prototype.attachAllFailed=function(d,f,l){return this.attachEvent("allFailed",d,f,l);};
O.prototype.detachAllFailed=function(f,l){return this.detachEvent("allFailed",f,l);};
O.prototype._fireSuccess=function(r){return this.fireEvent("success",{result:r},false,false);};
O.prototype._fireError=function(o){return this.fireEvent("error",{result:o},false,false);};
O.prototype._fireLoaded=function(r){return this.fireEvent("loaded",{result:r},false,false);};
O.prototype._fireFailed=function(b){return this.fireEvent("failed",{result:b},false,false);};
O.prototype._fireSomeLoaded=function(r){return this.fireEvent("someLoaded",{result:r},false,false);};
O.prototype._fireAllFailed=function(b){return this.fireEvent("allFailed",{result:b},false,false);};
O.prototype._loadSource=function(s){if(s.data instanceof Promise){return s.data.then(function(d){delete s.data;s.type="xml";s.xml=d.xml;s.lastModified=d.lastModified;s.eTag=d.eTag;return this._loadSource(s);}.bind(this));}else if(s.type==="xml"){if(typeof s.data==="string"){s.xml=s.data;delete s.data;}return Promise.resolve(s);}else if(s.type==="url"){return this._loadUrl(s);}else{var o=new Error("Unknown source type: \""+s.type+"\"");o.source=s;return Promise.reject(o);}};
O.prototype._loadUrl=function(s){a(s.type==="url","Source type must be \"url\" in order to be loaded");return new Promise(function(r,R){var m={url:s.data,async:true,headers:this._getHeaders(),beforeSend:function(x){x.overrideMimeType("text/plain");}};var S=function(d,b,x){s.xml=x.responseText;if(x.getResponseHeader("Last-Modified")){s.lastModified=new Date(x.getResponseHeader("Last-Modified"));}if(x.getResponseHeader("eTag")){s.eTag=x.getResponseHeader("eTag");}r(s);};var f=function(x,b){var o=new Error("Could not load annotation URL: \""+s.data+"\"");o.source=s;R(o);};q.ajax(m).done(S).fail(f);}.bind(this));};
O.prototype._parseSourceXML=function(s){a(typeof s.xml==="string","Source must contain XML string in order to be parsed");return new Promise(function(r,R){var x=new DOMParser().parseFromString(s.xml,'application/xml');if(x.getElementsByTagName("parsererror").length>0){var o=new Error("There were errors parsing the XML.");o.source={type:s.type,data:s.data,xml:s.xml,document:x};R(o);}else{s.document=x;r(s);}});};
O.prototype._parseSource=function(s){return this._oMetadata.loaded().then(function(){s.annotations=A.parse(this._oMetadata,s.document,s.data);delete s.document;return s;}.bind(this));};
O.prototype._mergeSource=function(s){a(typeof s.annotations==="object","Source must contain an annotation object to be merged");A.merge(this._mAnnotations,s.annotations);return s;};
O.prototype._getHeaders=function(){return e({"sap-cancel-on-close":true},this.getHeaders(),{"Accept-Language":sap.ui.getCore().getConfiguration().getLanguageTag()});};
return O;});
sap.ui.predefine('sap/ui/model/odata/v2/ODataContextBinding',["sap/base/util/deepExtend","sap/base/util/extend","sap/ui/model/ChangeReason","sap/ui/model/Context","sap/ui/model/ContextBinding"],function(d,e,C,a,b){"use strict";
var O=b.extend("sap.ui.model.odata.v2.ODataContextBinding",{constructor:function(m,p,c,P,E){b.call(this,m,p,c,P,E);this.sRefreshGroupId=undefined;this.bPendingRequest=false;this.mParameters=d({},this.mParameters);this.bCreatePreliminaryContext=this.mParameters.createPreliminaryContext||m.bPreliminaryContext;this.bUsePreliminaryContext=this.mParameters.usePreliminaryContext||m.bPreliminaryContext;this.mParameters.createPreliminaryContext=this.bCreatePreliminaryContext;this.mParameters.usePreliminaryContext=this.bUsePreliminaryContext;this.bPendingRequest=false;}});
O.prototype.initialize=function(){var c,r,R,p=this.oContext&&this.oContext.isPreliminary(),f=this.isRelative()&&this.oContext&&this.oContext.isTransient&&this.oContext.isTransient(),t=this;if(!this.oModel.oMetadata.isLoaded()||!this.bInitial){return;}this.bInitial=false;if(p&&!this.bUsePreliminaryContext){return;}R=this.getResolvedPath();if(!R||f){this.oElementContext=null;this._fireChange({reason:C.Context});return;}r=this.oModel._isReloadNeeded(R,this.mParameters);if(r){this.fireDataRequested();this.bPendingRequest=true;}c=this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(n){var D,F=n&&n.isRefreshForced(),u=n&&n.isUpdated();if(t.bCreatePreliminaryContext&&n&&t.oElementContext){t.oElementContext.setPreliminary(false);t.oModel._updateContext(t.oElementContext,n.getPath());t._fireChange({reason:C.Context},false,true);}else if(!n||a.hasChanged(n,t.oElementContext)){t.oElementContext=n;t._fireChange({reason:C.Context},F,u);}if(r){if(t.oElementContext){D=t.oElementContext.getObject(t.mParameters);}t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:D});});t.bPendingRequest=false;}},r);if(c){if(this.bCreatePreliminaryContext&&this.oElementContext!==c){c.setPreliminary(true);this.oElementContext=c;this.oModel.oMetadata.loaded().then(function(){this._fireChange({reason:C.Context});}.bind(this));}}else if(this.oContext){this.oElementContext=null;this._fireChange({reason:C.Context});}};
O.prototype.checkUpdate=function(){var c,p=this.mParameters,P=this.oContext&&this.oContext.isPreliminary();if(this.bInitial||this.bPendingRequest){return;}if(this.oContext&&this.oContext.isUpdated()){this.setContext(this.oContext);return;}if(P&&!this.bUsePreliminaryContext){return;}if(p.createPreliminaryContext){p=Object.assign({},p);delete p.createPreliminaryContext;}c=this.oModel.createBindingContext(this.sPath,this.oContext,p);if(c!==undefined&&c!==this.oElementContext){this.oElementContext=c;this._fireChange({reason:C.Context});}};
O.prototype.refresh=function(f,g){if(typeof f==="string"){g=f;f=false;}this.sRefreshGroupId=g;this._refresh(f);this.sRefreshGroupId=undefined;};
O.prototype._refresh=function(f,c){var o,s,D,k,S,g=false,p=this.mParameters,r=this.isRelative()&&this.oContext&&this.oContext.isTransient&&this.oContext.isTransient(),R=this.getResolvedPath(),t=this;if(this.bInitial||r){return;}if(c){S=this.oModel._getObject(this.sPath,this.oContext);if(S){k=this.oModel._getKey(S);if(k in c){g=true;}}}else{g=true;}if(f||g){if(R){this.fireDataRequested();this.bPendingRequest=true;}if(this.sRefreshGroupId){p=e({},this.mParameters);p.groupId=this.sRefreshGroupId;}o=this.oModel.createBindingContext(this.sPath,this.oContext,p,function(n){if(t.bCreatePreliminaryContext&&n&&t.oElementContext){t.oElementContext.setPreliminary(false);t.oModel._updateContext(t.oElementContext,n.getPath());t._fireChange({reason:C.Context},false,true);}else if(a.hasChanged(n,t.oElementContext)||f){t.oElementContext=n;t._fireChange({reason:C.Context},f);}if(t.oElementContext){D=t.oElementContext.getObject(t.mParameters);}if(R){t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:D});});t.bPendingRequest=false;}},true);if(o&&this.bCreatePreliminaryContext){if(this.oElementContext!==o||f){o.setPreliminary(true);this.oElementContext=o;s=this.oElementContext.sPath;this.oModel._updateContext(this.oElementContext,R);this._fireChange({reason:C.Context},f);this.oModel._updateContext(this.oElementContext,s);}}}};
O.prototype.setContext=function(c){var B,s,D,r,R,f=c&&c.isRefreshForced(),p=c&&c.isPreliminary(),t=c&&c.isTransient&&c.isTransient(),u=c&&c.isUpdated(),g=this;if(this.bInitial||!this.isRelative()){return;}if(p&&!this.bUsePreliminaryContext){return;}if(u&&this.bUsePreliminaryContext){this._fireChange({reason:C.Context});return;}if(a.hasChanged(this.oContext,c)){this.oContext=c;R=this.getResolvedPath();if(!R||t){if(this.oElementContext!==null){this.oElementContext=null;this._fireChange({reason:C.Context});}return;}D=this.oModel._getObject(this.sPath,this.oContext);r=f||this.oModel._isReloadNeeded(R,this.mParameters);if(R&&r){this.fireDataRequested();this.bPendingRequest=true;}B=this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(c){if(g.bCreatePreliminaryContext&&c&&g.oElementContext){g.oElementContext.setPreliminary(false);g.oModel._updateContext(g.oElementContext,c.getPath());g._fireChange({reason:C.Context},false,true);}else if(a.hasChanged(c,g.oElementContext)){g.oElementContext=c;g._fireChange({reason:C.Context},f,u);}if(R&&r){if(g.oElementContext){D=g.oElementContext.getObject(g.mParameters);}g.oModel.callAfterUpdate(function(){g.fireDataReceived({data:D});});g.bPendingRequest=false;}},r);if(B){if(this.bCreatePreliminaryContext){B.setPreliminary(true);this.oElementContext=B;s=this.oElementContext.sPath;this.oModel._updateContext(this.oElementContext,R);this._fireChange({reason:C.Context},f);this.oModel._updateContext(this.oElementContext,s);}}else if(this.oContext&&this.oElementContext!==null){this.oElementContext=null;this._fireChange({reason:C.Context});}}};
O.prototype._fireChange=function(p,f,u){if(this.oElementContext){this.oElementContext.setForceRefresh(f);this.oElementContext.setUpdated(u);}b.prototype._fireChange.call(this,p);if(this.oElementContext){this.oElementContext.setForceRefresh(false);this.oElementContext.setUpdated(false);}};
return O;});
sap.ui.predefine('sap/ui/model/odata/v2/ODataListBinding',["sap/base/assert","sap/base/Log","sap/base/util/deepEqual","sap/base/util/each","sap/base/util/isEmptyObject","sap/base/util/uid","sap/ui/model/ChangeReason","sap/ui/model/Context","sap/ui/model/Filter","sap/ui/model/FilterOperator","sap/ui/model/FilterProcessor","sap/ui/model/FilterType","sap/ui/model/ListBinding","sap/ui/model/Sorter","sap/ui/model/SorterProcessor","sap/ui/model/odata/CountMode","sap/ui/model/odata/Filter","sap/ui/model/odata/ODataUtils","sap/ui/model/odata/OperationMode"],function(a,L,d,e,b,u,C,c,F,f,g,h,j,S,k,l,O,m,n){"use strict";var o=["changeSetId","error","expand","groupId","inactive","success"];
var p=j.extend("sap.ui.model.odata.v2.ODataListBinding",{
constructor:function(M,P,i,s,t,v){j.apply(this,arguments);this.sFilterParams=null;this.sSortParams=null;this.sRangeParams=null;this.sCustomParams=this.oModel.createCustomParams(this.mParameters);this.mCustomParams=v&&v.custom;this.iStartIndex=0;this.iLength=0;this.bPendingChange=false;this.aAllKeys=null;this.aKeys=[];this.sCountMode=(v&&v.countMode)||this.oModel.sDefaultCountMode;this.sOperationMode=(v&&v.operationMode)||this.oModel.sDefaultOperationMode;this.bCreatePreliminaryContext=(v&&v.createPreliminaryContext)||M.bPreliminaryContext;this.bUsePreliminaryContext=(v&&v.usePreliminaryContext)||M.bPreliminaryContext;this.bRefresh=false;this.bNeedsUpdate=false;this.bDataAvailable=false;this.bIgnoreSuspend=false;this.bPendingRefresh=false;this.sGroupId=undefined;this.sRefreshGroupId=undefined;this.bLengthRequested=false;this.bUseExtendedChangeDetection=true;this.bFaultTolerant=v&&v.faultTolerant;this.bLengthFinal=false;this.iLastEndIndex=0;this.aLastContexts=null;this.aLastContextData=null;this.bInitial=true;this.mRequestHandles={};this.oCountHandle=null;this.bSkipDataEvents=false;this.bUseExpandedList=false;this.oCombinedFilter=null;this.sDeepPath=M.resolveDeep(P,i);this.bCanonicalRequest=v&&v.bCanonicalRequest;this.mNormalizeCache={};this.bTransitionMessagesOnly=!!(v&&v.transitionMessagesOnly);this.sCreatedEntitiesKey=v&&v.createdEntitiesKey||"";this.oModel.checkFilterOperation(this.aApplicationFilters);if(v&&(v.batchGroupId||v.groupId)){this.sGroupId=v.groupId||v.batchGroupId;}this.iThreshold=(v&&v.threshold)||0;this.bThresholdRejected=false;if(this.sCountMode==l.None){this.bThresholdRejected=true;}if(!this.checkExpandedList()){this._removePersistedCreatedContexts();this.resetData();}},
metadata:{publicMethods:["getLength"]}
});
p.prototype.attachCreateActivate=function(i,s){this.attachEvent("createActivate",i,s);};
p.prototype.detachCreateActivate=function(i,s){this.detachEvent("createActivate",i,s);};
p.prototype.getAllCurrentContexts=function(){var i=this._getCreatedContexts(),t=this;this.aKeys.forEach(function(K){i.push(t.oModel.getContext("/"+K));});return i;};
p.prototype.getContexts=function(s,t,T){var v,I,w,x,y,z=[];if(this.bInitial){return[];}if(!this.bLengthFinal&&this.sOperationMode==n.Auto&&(this.sCountMode==l.Request||this.sCountMode==l.Both)){if(!this.bLengthRequested){this._getLength();this.bLengthRequested=true;}return[];}if(!this.bLengthFinal&&!this.bPendingRequest&&!this.bLengthRequested){this._getLength();this.bLengthRequested=true;}this.iLastLength=t;this.iLastStartIndex=s;this.iLastThreshold=T;if(!s){s=0;}if(!t){t=this._getMaximumLength();}if(!T){T=0;}if(this.sOperationMode==n.Auto){if(this.iThreshold>=0){T=Math.max(this.iThreshold,T);}}v=this._getContexts(s,t);if(this.useClientMode()){if(!this.aAllKeys&&!this.bPendingRequest&&this.oModel.getServiceMetadata()){this.loadData();v.dataRequested=true;}}else{x=this.bLengthFinal?this.iLength:undefined;y=this._getSkipAndTop(s,t);w=m._getReadIntervals(this.aKeys,y.skip,y.top,T,x);I=m._mergeIntervals(w);if(this.oModel.getServiceMetadata()){if(!this.bPendingRequest&&I){this.loadData(I.start,I.end-I.start);v.dataRequested=true;}}}if(this.bRefresh){this.bRefresh=false;if(!v.dataRequested&&v.length>0){this._fireChange({reason:C.Change});}}else{for(var i=0;i<v.length;i++){z.push(this.getContextData(v[i]));}if(this.bUseExtendedChangeDetection){if(this.aLastContexts&&s<this.iLastEndIndex){v.diff=this.diffData(this.aLastContextData,z);}}this.iLastEndIndex=s+t;this.aLastContexts=v.slice(0);this.aLastContextData=z.slice(0);}return v;};
p.prototype.getCurrentContexts=function(){return this.aLastContexts||[];};
p.prototype.getEntryKey=function(i){return i.getPath();};
p.prototype.getEntryData=function(i){return JSON.stringify(i.getObject(this.mParameters));};
p.prototype._getContexts=function(s,t){var v,i,E,K,A=this.isFirstCreateAtEnd(),w=[],x=this._getCreatedContexts(),y=x.length,D=this.oModel.resolveDeep(this.sPath,this.oContext);if(!s){s=0;}if(!t){t=this._getMaximumLength();}E=s+t;for(i=s;i<E;i+=1){if(!A&&i<y){v=x[i];}else if(A&&i>=this.iLength){if(i-this.iLength>=y){break;}v=x[i-this.iLength];}else{K=this.aKeys[A?i:i-y];if(!K){break;}v=this.oModel.getContext('/'+K,D+K.substr(K.indexOf("(")));}w.push(v);}return w;};
p.prototype.setContext=function(i){var H,R,s=i&&i.isRefreshForced(),P=i&&i.isPreliminary(),t=i&&i.isTransient&&i.isTransient(),U=i&&i.isUpdated();if(this.bInitial||!this.isRelative()){return;}if(P&&!this.bUsePreliminaryContext){return;}if(U&&this.bUsePreliminaryContext&&this.oContext===i){this._fireChange({reason:C.Context});return;}if(c.hasChanged(this.oContext,i)){if(this.oContext!==i){H=this._getCreatedContexts().length>0;}this.oContext=i;R=this.getResolvedPath();this.sDeepPath=this.oModel.resolveDeep(this.sPath,this.oContext);if(!this._checkPathType()){L.error("List Binding is not bound against a list for "+R);}this.checkDataState();if(!R||t){if(H||this.aAllKeys||this.aKeys.length>0||this.iLength>0){this.aAllKeys=null;this.aKeys=[];this.iLength=0;this.bLengthFinal=true;this._fireChange({reason:C.Context});}return;}this._initSortersFilters();if(this.checkExpandedList()&&!s){this.abortPendingRequest();this._fireChange({reason:C.Context});}else{this._removePersistedCreatedContexts();this._refresh();}}};
p.prototype.checkExpandedList=function(s){var R=!!this.getResolvedPath(),i=this.oModel._getObject(this.sPath,this.oContext);if(!R||i===undefined||this.mCustomParams||(this.sOperationMode===n.Server&&(this.aApplicationFilters.length>0||this.aFilters.length>0||this.aSorters.length>0))){this.bUseExpandedList=false;this.aExpandRefs=undefined;return false;}else{this.bUseExpandedList=true;if(Array.isArray(i)){if(!s&&(this.oModel._isReloadNeeded("/"+i[0],this.mParameters)||this.oModel._isReloadNeeded("/"+i[i.length-1],this.mParameters))){this.bUseExpandedList=false;this.aExpandRefs=undefined;return false;}this.aExpandRefs=i;this.aAllKeys=i;this.iLength=i.length;this.bLengthFinal=true;this.bDataAvailable=true;this._initSortersFilters();this.applyFilter();this.applySort();}else{this.aExpandRefs=undefined;this.aAllKeys=null;this.aKeys=[];this.iLength=0;this.bLengthFinal=true;this.bDataAvailable=true;}return true;}};
p.prototype.updateExpandedList=function(K){if(this.aExpandRefs){for(var i=0;i<K.length;i++){this.aExpandRefs[i]=K[i];}this.aExpandRefs.length=K.length;}};
p.prototype.useClientMode=function(){return(this.sOperationMode===n.Client||this.sOperationMode===n.Auto&&!this.bThresholdRejected||this.sOperationMode!==n.Server&&this.bUseExpandedList);};
p.prototype._addFilterQueryOption=function(U,i){var E=this._getCreatedPersistedExcludeFilter();if(this.sFilterParams&&i){if(E){U.push("$filter=("+this.sFilterParams.slice(8)+")%20and%20"+E);}else{U.push(this.sFilterParams);}}else if(E){U.push("$filter="+E);}};
p.prototype._getCreatedPersistedExcludeFilter=function(){var E,i,s=this._getCreatedContexts().filter(function(v){return!v.isTransient();}),t=this;if(s.length>0){i=s.map(function(v){var P=v.getPath();return t._getFilterForPredicate(P.slice(P.indexOf("(")));});E="not("+m._createFilterParams(i.length===1?i[0]:new F({filters:i}),this.oModel.oMetadata,this.oEntityType)+")";}return E;};
p.prototype.loadData=function(s,t){var G,v=u(),I=false,P=[],w=this.sPath,x=this;if(s||t){this.sRangeParams="$skip="+s+"&$top="+t;this.iStartIndex=s;}else{s=this.iStartIndex;}if(this.sRangeParams&&!this.useClientMode()){P.push(this.sRangeParams);}if(this.sSortParams){P.push(this.sSortParams);}this._addFilterQueryOption(P,!this.useClientMode());if(this.sCustomParams){P.push(this.sCustomParams);}if(this.sCountMode==l.InlineRepeat||!this.bLengthFinal&&(this.sCountMode===l.Inline||this.sCountMode===l.Both)){P.push("$inlinecount=allpages");I=true;}function y(D){if(I&&D.__count!==undefined){x.iLength=parseInt(D.__count);x.bLengthFinal=true;if(x.sOperationMode==n.Auto){if(x.iLength<=x.mParameters.threshold){x.bThresholdRejected=false;}else{x.bThresholdRejected=true;delete x.mRequestHandles[v];x.bPendingRequest=false;x.bNeedsUpdate=true;return;}}}if(x.useClientMode()){x.aKeys=[];e(D.results,function(i,z){x.aKeys[i]=x.oModel._getKey(z);});x.updateExpandedList(x.aKeys);x.aAllKeys=x.aKeys.slice();x.iLength=x.aKeys.length;x.bLengthFinal=true;x.applyFilter();x.applySort();}else if(D.results.length>0){e(D.results,function(i,z){x.aKeys[s+i]=x.oModel._getKey(z);});if(x.iLength<s+D.results.length){x.iLength=s+D.results.length;x.bLengthFinal=false;}if(!D.__next&&(D.results.length<t||t===undefined)){x.iLength=s+D.results.length;x.bLengthFinal=true;}}else{if(x.bFaultTolerant&&D.__next){x.iLength=s;x.bLengthFinal=true;}if(s===0){x.iLength=0;x.aKeys=[];x.bLengthFinal=true;}if(s===x.iLength){x.bLengthFinal=true;}}delete x.mRequestHandles[v];x.bPendingRequest=false;x.bNeedsUpdate=true;x.bIgnoreSuspend=true;x.oModel.callAfterUpdate(function(){x.fireDataReceived({data:D});});}function E(i){var A=i.statusCode==0;delete x.mRequestHandles[v];x.bPendingRequest=false;if(x.bFaultTolerant){x.iLength=x.aKeys.length;x.bLengthFinal=true;x.bDataAvailable=true;}else if(!A){x.aKeys=[];x.aAllKeys=[];x.iLength=0;x.bLengthFinal=true;x.bDataAvailable=true;x._fireChange({reason:C.Change});}if(!x.bSkipDataEvents){x.fireDataReceived();}}if(this.isRelative()){w=this.getResolvedPath();}if(w){this.bPendingRequest=true;if(!this.bSkipDataEvents){this.fireDataRequested();}this.bSkipDataEvents=false;G=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;this.mRequestHandles[v]=this.oModel.read(this.sPath,{headers:this.bTransitionMessagesOnly?{"sap-messages":"transientOnly"}:undefined,context:this.oContext,groupId:G,urlParameters:P,success:y,error:E,canonicalRequest:this.bCanonicalRequest,updateAggregatedMessages:this.bRefresh});}};
p.prototype.isLengthFinal=function(){return this.bLengthFinal;};
p.prototype.getLength=function(){var R=this.iLength+this._getCreatedContexts().length;if(this.bLengthFinal||this.iLength===0){return R;}return R+(this.iLastThreshold||this.iLastLength||10);};
p.prototype._getLength=function(){var G,P,i=[],t=this;if(this.sCountMode!==l.Request&&this.sCountMode!==l.Both){return;}this._addFilterQueryOption(i,this.sOperationMode!==n.Auto);if(this.mParameters&&this.mParameters.custom){var s={custom:{}};e(this.mParameters.custom,function(w,V){s.custom[w]=V;});i.push(this.oModel.createCustomParams(s));}function _(D){t.iLength=parseInt(D);t.bLengthFinal=true;t.bLengthRequested=true;t.oCountHandle=null;if(t.sOperationMode==n.Auto){if(t.iLength<=t.mParameters.threshold){t.bThresholdRejected=false;}else{t.bThresholdRejected=true;}t._fireChange({reason:C.Change});}}function v(E){delete t.mRequestHandles[P];var w="Request for $count failed: "+E.message;if(E.response){w+=", "+E.response.statusCode+", "+E.response.statusText+", "+E.response.body;}L.warning(w);}P=this.getResolvedPath();if(P){G=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;this.oCountHandle=this.oModel.read(this.sPath+"/$count",{context:this.oContext,withCredentials:this.oModel.bWithCredentials,groupId:G,urlParameters:i,success:_,error:v,canonicalRequest:this.bCanonicalRequest});}};
p.prototype._getMaximumLength=function(){var i=this.oModel.iSizeLimit;if(this.bLengthFinal){i=Math.min(i,this.iLength+this._getCreatedContexts().length);}return i;};
p.prototype.refresh=function(i,G){if(typeof i==="string"){G=i;i=false;}this._removePersistedCreatedContexts();this.sRefreshGroupId=G;this._refresh(i);this.sRefreshGroupId=undefined;};
p.prototype._refresh=function(s,t,E){var v,R,w=false,x=this.isRelative()&&this.oContext&&this.oContext.isTransient&&this.oContext.isTransient();if(x){return;}this.bPendingRefresh=false;if(!s){if(E){R=this.getResolvedPath();if(R){v=this.oModel.oMetadata._getEntityTypeByPath(R);if(v&&(v.entityType in E)){w=true;}}}if(t&&!w){e(this.aKeys,function(i,K){if(K in t){w=true;return false;}return true;});}if(!t&&!E){w=true;}}if(s||w){if(this.bSuspended&&!this.bIgnoreSuspend&&!s){this.bPendingRefresh=true;return;}this.abortPendingRequest(true);this.resetData();this._fireRefresh({reason:C.Refresh});}};
p.prototype._fireRefresh=function(P){if(this.getResolvedPath()){this.bRefresh=true;this.fireEvent("refresh",P);}};
p.prototype._checkPathType=function(){var P=this.getResolvedPath();if(P){if(!this._mPathType||!this._mPathType[P]){this._mPathType={};var I=P.lastIndexOf("/");var t,E;if(I>1){E=this.oModel.oMetadata._getEntityTypeByPath(P.substring(0,I));if(E){t=this.oModel.oMetadata._getEntityAssociationEnd(E,P.substring(I+1));if(t&&t.multiplicity==="*"){this._mPathType[P]=true;}}}else if(I===0){var M,N=P.substring(1);M=this.oModel.oMetadata._findEntitySetByName(N);if(M){this._mPathType[P]=true;}else{var s=this.oModel.oMetadata._getFunctionImportMetadataByName(N);for(var i=0;i<s.length;i++){var v=s[i];if(v.entitySet){M=this.oModel.oMetadata._findEntitySetByName(v.entitySet);if(M){this._mPathType[P]=true;}}}}}}return!!this._mPathType[P];}return true;};
p.prototype.initialize=function(){var R=this.isRelative()&&this.oContext&&this.oContext.isTransient&&this.oContext.isTransient();if(this.oModel.oMetadata&&this.oModel.oMetadata.isLoaded()&&this.bInitial&&!R){if(!this._checkPathType()){L.error("List Binding is not bound against a list for "+this.getResolvedPath());}this.bInitial=false;this._initSortersFilters();if(!this.bSuspended){if(this.bDataAvailable){this._fireChange({reason:C.Change});}else{this._fireRefresh({reason:C.Refresh});}}this.checkDataState();}return this;};
p.prototype.checkUpdate=function(i,s){var t,v,E,w,x,y=false,z=this.sChangeReason?this.sChangeReason:C.Change,A=this;if((this.bSuspended&&!this.bIgnoreSuspend&&!i)||this.bPendingRequest){return;}if(this.bInitial){if(this.oContext&&this.oContext.isUpdated()){this.initialize();}return;}this.bIgnoreSuspend=false;if(!i&&!this.bNeedsUpdate){x=this.aExpandRefs;w=this.aKeys.slice();E=this.checkExpandedList(true);if(!E&&this.useClientMode()){this.applyFilter();this.applySort();}if(!d(x,this.aExpandRefs)){y=true;}else if(s){if(this.aKeys.length!==w.length){y=true;}else{for(var K in s){if(this.aKeys.indexOf(K)>-1||w.indexOf(K)>-1){y=true;break;}}}}else{y=true;}if(y&&this.aLastContexts){y=false;t=this._getContexts(this.iLastStartIndex,this.iLastLength);if(this.aLastContexts.length!==t.length){y=true;}else{e(this.aLastContextData,function(I,B){v=A.getContextData(t[I]);if(B!==v){y=true;return false;}return true;});}}}if(i||y||this.bNeedsUpdate){this.bNeedsUpdate=false;this._fireChange({reason:z});}this.sChangeReason=undefined;};
p.prototype.resetData=function(){this.aKeys=[];this.aAllKeys=null;this.iLength=0;this.bLengthFinal=false;this.sChangeReason=undefined;this.bDataAvailable=false;this.bLengthRequested=false;this.bThresholdRejected=false;if(this.sCountMode==l.None){this.bThresholdRejected=true;}};
p.prototype.abortPendingRequest=function(A){if(!b(this.mRequestHandles)){this.bSkipDataEvents=true;e(this.mRequestHandles,function(P,R){R.abort();});if(A&&this.oCountHandle){this.oCountHandle.abort();}this.mRequestHandles={};this.bPendingRequest=false;}};
p.prototype.getDownloadUrl=function(s){var P=[],i;if(s){P.push("$format="+encodeURIComponent(s));}if(this.sSortParams){P.push(this.sSortParams);}if(this.sFilterParams){P.push(this.sFilterParams);}if(this.sCustomParams){P.push(this.sCustomParams);}i=this.getResolvedPath();return i&&this.oModel._createRequestUrl(i,null,P);};
p.prototype.sort=function(s,R){var i=false;this.bIgnoreSuspend=true;if(!s){s=[];}if(s instanceof S){s=[s];}this.aSorters=s;if(!this.useClientMode()){this.createSortParams(s);}if(!this.bInitial){this.addComparators(s,true);if(this.useClientMode()){if(this.aAllKeys){if(s.length==0){this.applyFilter();}else{this.applySort();}this._fireChange({reason:C.Sort});}else{this.sChangeReason=C.Sort;}}else{this.iLength+=this._removePersistedCreatedContexts().length;this.aKeys=[];this.abortPendingRequest(false);this.sChangeReason=C.Sort;this._fireRefresh({reason:this.sChangeReason});}this._fireSort({sorter:s});i=true;}if(R){return i;}else{return this;}};
p.prototype.addComparators=function(E,s){var P,t,i=this.oEntityType,v;if(!i){L.warning("Cannot determine sort/filter comparators, as entitytype of the collection is unknown!");return;}E.forEach(function(w){if(w.aFilters){this.addComparators(w.aFilters);}else if(!w.fnCompare){P=this.oModel.oMetadata._getPropertyMetadata(i,w.sPath);t=P&&P.type;a(P,"PropertyType for property "+w.sPath+" of EntityType "+i.name+" not found!");v=m.getComparator(t);if(s){w.fnCompare=q(v);}else{w.fnCompare=v;r(t,w);}}}.bind(this));};
function q(i){return function(v,V){if(v===V){return 0;}if(v===null){return-1;}if(V===null){return 1;}return i(v,V);};}
function r(t,i){switch(t){case"Edm.Decimal":case"Edm.Int64":if(typeof i.oValue1=="number"){i.oValue1=i.oValue1.toString();}if(typeof i.oValue2=="number"){i.oValue2=i.oValue2.toString();}break;case"Edm.Byte":case"Edm.Int16":case"Edm.Int32":case"Edm.SByte":if(typeof i.oValue1=="string"){i.oValue1=parseInt(i.oValue1);}if(typeof i.oValue2=="string"){i.oValue2=parseInt(i.oValue2);}break;case"Edm.Float":case"Edm.Single":case"Edm.Double":if(typeof i.oValue1=="string"){i.oValue1=parseFloat(i.oValue1);}if(typeof i.oValue2=="string"){i.oValue2=parseFloat(i.oValue2);}break;default:}}
p.prototype.applySort=function(){var t=this,i;this.aKeys=k.apply(this.aKeys,this.aSorters,function(R,P){i=t.oModel.getContext('/'+R);return t.oModel.getProperty(P,i);});};
p.prototype.createSortParams=function(s){this.sSortParams=m.createSortParams(s);};
p.prototype.filter=function(i,s,R){var t=false;this.bIgnoreSuspend=true;if(!i){i=[];}if(i instanceof F){i=[i];}this.oModel.checkFilterOperation(i);if(s===h.Application){this.aApplicationFilters=i;}else{this.aFilters=i;}if(!this.aFilters||!Array.isArray(this.aFilters)){this.aFilters=[];}if(!this.aApplicationFilters||!Array.isArray(this.aApplicationFilters)){this.aApplicationFilters=[];}this.convertFilters();this.oCombinedFilter=g.combineFilters(this.aFilters,this.aApplicationFilters);if(!this.useClientMode()){this.createFilterParams(this.oCombinedFilter);}if(!this.bInitial){this.addComparators(this.aFilters);this.addComparators(this.aApplicationFilters);if(this.useClientMode()){if(this.aAllKeys){this.applyFilter();this.applySort();this._fireChange({reason:C.Filter});}else{this.sChangeReason=C.Filter;}}else{this._removePersistedCreatedContexts();this.resetData();this.abortPendingRequest(true);this.sChangeReason=C.Filter;this._fireRefresh({reason:this.sChangeReason});}if(s===h.Application){this._fireFilter({filters:this.aApplicationFilters});}else{this._fireFilter({filters:this.aFilters});}t=true;}if(R){return t;}else{return this;}};
p.prototype.convertFilters=function(){this.aFilters=this.aFilters.map(function(i){return i instanceof O?i.convert():i;});this.aApplicationFilters=this.aApplicationFilters.map(function(i){return i instanceof O?i.convert():i;});};
p.prototype.applyFilter=function(){var t=this,i;this.oCombinedFilter=g.combineFilters(this.aFilters,this.aApplicationFilters);this.aKeys=g.apply(this.aAllKeys,this.oCombinedFilter,function(R,P){i=t.oModel.getContext('/'+R);return t.oModel.getProperty(P,i);},this.mNormalizeCache);this.iLength=this.aKeys.length;};
p.prototype.createFilterParams=function(i){this.sFilterParams=m.createFilterParams(i,this.oModel.oMetadata,this.oEntityType);};
p.prototype._initSortersFilters=function(){var R=this.getResolvedPath();if(!R){return;}this.oEntityType=this._getEntityType();this.addComparators(this.aSorters,true);this.addComparators(this.aFilters);this.addComparators(this.aApplicationFilters);this.convertFilters();this.oCombinedFilter=g.combineFilters(this.aFilters,this.aApplicationFilters);if(!this.useClientMode()){this.createSortParams(this.aSorters);this.createFilterParams(this.oCombinedFilter);}};
p.prototype._getEntityType=function(){var R=this.getResolvedPath();if(R){var E=this.oModel.oMetadata._getEntityTypeByPath(R);a(E,"EntityType for path "+R+" could not be found!");return E;}return undefined;};
p.prototype.resume=function(){this.bIgnoreSuspend=false;this.bSuspended=false;if(this.bPendingRefresh){this._refresh();}else{this.checkUpdate();}};
p.prototype.suspend=function(){if(this.bInitial){this.bPendingRefresh=true;}j.prototype.suspend.apply(this,arguments);};
p.prototype._checkDataStateMessages=function(D,R){if(R){D.setModelMessages(this.oModel.getMessagesByPath(this.sDeepPath,true));}};
p.prototype._getFilterForPredicate=function(P){var i=[],K=P.slice(1,-1).split(","),t=this;K.forEach(function(s){var v=s.split("="),w=v[0],V=v[1];if(v.length===1){V=w;w=t.oModel.oMetadata.getKeyPropertyNamesByPath(t.sDeepPath)[0];}i.push(new F(w,f.EQ,m.parseValue(decodeURIComponent(V))));});if(i.length===1){return i[0];}return new F({and:true,filters:i});};
p.prototype.create=function(i,A,P){var s,t,R,v={context:this.oContext,properties:i,refreshAfterChange:false},w=this.isFirstCreateAtEnd(),x=this;A=!!A;if(w===undefined){w=A;}if(w&&!this.bLengthFinal){throw new Error("Must know the final length to create at the end");}Object.keys(P||{}).forEach(function(y){if(!o.includes(y)){throw new Error("Parameter '"+y+"' is not supported");}});if(this.oContext&&this.oContext.isTransient&&this.oContext.isTransient()){throw new Error("Parent context is transient");}if(this.bUseExpandedList){throw new Error("The collection has been read via $expand while reading the parent"+" entity");}if(!this.oModel.oMetadata.isLoaded()){throw new Error("Metadata is not loaded");}R=this.getResolvedPath();t=this.oModel._getCreatedContextsCache();Object.assign(v,P);s=this.oModel.createEntry(this.sPath,v);t.addContext(s,R,this.sCreatedEntitiesKey,A);if(v.inactive){s.fetchActivated().then(function(){x.fireEvent("createActivate");});}this._fireChange({reason:C.Add});return s;};
p.prototype.requestFilterForMessages=function(i){var D=this.sDeepPath,s=null,t=[],P=new Set(),R=this.getResolvedPath(),v=this;if(!R){return Promise.resolve(null);}this.oModel.getMessagesByPath(D,true).forEach(function(M){var w;if(!i||i(M)){M.aFullTargets.forEach(function(x){if(x.startsWith(D)){w=x.slice(D.length).split("/")[0];if(w){P.add(w);}}});}});P.forEach(function(w){t.push(v._getFilterForPredicate(w));});if(t.length===1){s=t[0];}else if(t.length>1){s=new F({filters:t});}return Promise.resolve(s);};
p.prototype.isFirstCreateAtEnd=function(){return this.oModel._getCreatedContextsCache().isAtEnd(this.getResolvedPath(),this.sCreatedEntitiesKey);};
p.prototype._getCreatedContexts=function(){return this.oModel._getCreatedContextsCache().getContexts(this.getResolvedPath(),this.sCreatedEntitiesKey);};
p.prototype._getSkipAndTop=function(s,i){var t=this._getCreatedContexts().length,v=this.isFirstCreateAtEnd()?s:Math.max(0,s-t),T=this.bLengthFinal&&v+i>=this.iLength?Math.max(0,this.iLength-v):i;return{skip:v,top:T};};
p.prototype._removePersistedCreatedContexts=function(){return this.oModel._getCreatedContextsCache().removePersistedContexts(this.getResolvedPath(),this.sCreatedEntitiesKey);};
p.prototype.getCount=function(){if(!this.isLengthFinal()){return undefined;}return this.getLength()-this._getCreatedContexts().filter(function(i){return i.isInactive();}).length;};
return p;});
sap.ui.predefine('sap/ui/model/odata/v2/ODataModel',["./_CreatedContextsCache","./Context","./ODataAnnotations","./ODataContextBinding","./ODataListBinding","./ODataTreeBinding","sap/base/assert","sap/base/Log","sap/base/security/encodeURL","sap/base/util/deepEqual","sap/base/util/deepExtend","sap/base/util/each","sap/base/util/extend","sap/base/util/isEmptyObject","sap/base/util/isPlainObject","sap/base/util/merge","sap/base/util/uid","sap/base/util/UriParameters","sap/ui/base/SyncPromise","sap/ui/core/library","sap/ui/core/message/Message","sap/ui/core/message/MessageParser","sap/ui/model/BindingMode","sap/ui/model/Context","sap/ui/model/FilterProcessor","sap/ui/model/Model","sap/ui/model/odata/CountMode","sap/ui/model/odata/MessageScope","sap/ui/model/odata/ODataMetadata","sap/ui/model/odata/ODataMetaModel","sap/ui/model/odata/ODataMessageParser","sap/ui/model/odata/ODataPropertyBinding","sap/ui/model/odata/ODataUtils","sap/ui/model/odata/OperationMode","sap/ui/model/odata/UpdateMethod","sap/ui/thirdparty/datajs","sap/ui/thirdparty/URI","sap/ui/util/isCrossOriginURL"],function(_,C,O,a,b,c,d,L,e,f,g,h,l,m,o,p,u,U,S,q,M,r,B,s,F,t,v,w,x,y,z,A,D,E,G,H,I,J){"use strict";var K="sap.ui.model.odata.v2.ODataModel",N=q.MessageType,P={};P[N.Error]=0;P[N.Warning]=1;P[N.Success]=2;P[N.Information]=3;P[N.None]=4;
var Q=t.extend("sap.ui.model.odata.v2.ODataModel",{
constructor:function(i,j){t.apply(this,arguments);var k,n,R,T,W,V,X,Y,Z,$,a1,b1,c1,d1,e1,f1,g1,h1,i1,j1,k1,l1,m1,n1,o1,p1,q1,r1,s1,t1,u1=this;if(typeof(i)==="object"){j=i;this.sServiceUrl=j.serviceUrl;}else{this.sServiceUrl=i;}this.mCodeListModelParams=this.createCodeListModelParameters(j);if(j){k=j.user;n=j.password;R=j.headers;T=j.tokenHandling;W=j.withCredentials;V=j.maxDataServiceVersion;X=j.useBatch;Y=j.refreshAfterChange;Z=j.annotationURI;$=j.loadAnnotationsJoined;c1=j.defaultBindingMode;a1=j.defaultCountMode;b1=j.preliminaryContext;d1=j.defaultOperationMode;e1=j.metadataNamespaces;f1=j.serviceUrlParams;g1=j.metadataUrlParams;h1=j.json;i1=j.messageParser;j1=j.skipMetadataAnnotationParsing;k1=j.defaultUpdateMethod;l1=j.disableHeadRequestForToken;m1=j.sequentializeRequests;n1=j.disableSoftStateHeader;o1=j.bindableResponseHeaders;p1=j.warmupUrl;q1=j.canonicalRequests;r1=j.tokenHandlingForGet;s1=j.earlyTokenRequest;t1=j.persistTechnicalMessages;}this.mPathCache={};this.mInvalidatedPaths={};this.bCanonicalRequests=!!q1;this.bTokenHandlingForGet=!!r1;this.sMessageScope=w.RequestedObjects;this.sWarmupUrl=p1;this.bWarmup=!!p1;this.mSupportedBindingModes={"OneWay":true,"OneTime":true,"TwoWay":true};this.mUnsupportedFilterOperators={"Any":true,"All":true};this.sDefaultBindingMode=c1||B.OneWay;this.bIsMessageScopeSupported=false;this.iPendingDeferredRequests=0;this.bJSON=h1!==false;this.aPendingRequestHandles=[];this.aCallAfterUpdate=[];this.mRequests={};this.mDeferredRequests={};this.mChangedEntities={};this.mChangeHandles={};this.mDeferredGroups={};this.mLaunderingState={};this.sDefaultUpdateMethod=k1||G.Merge;this.bTokenHandling=T!==false;this.bWithCredentials=W===true;this.bUseBatch=X!==false;this.bRefreshAfterChange=Y!==false;this.sMaxDataServiceVersion=V;this.bLoadAnnotationsJoined=$!==false;this.sAnnotationURI=Z;this.sDefaultCountMode=a1||v.Request;this.sDefaultOperationMode=d1||E.Default;this.sMetadataLoadEvent=null;this.oMetadataFailedEvent=null;this.sRefreshGroupId=undefined;this.bIncludeInCurrentBatch=false;this.bSkipMetadataAnnotationParsing=!!j1;this.bDisableHeadRequestForToken=!!l1;this.bSequentializeRequests=!!m1;this.bDisableSoftStateHeader=!!n1;this.aBindableResponseHeaders=o1?o1:null;this.bPreliminaryContext=b1||false;this.mMetadataUrlParams=g1||{};this.mChangedEntities4checkUpdate={};this.bPersistTechnicalMessages=t1===undefined?undefined:!!t1;this.oCreatedContextsCache=new _();if(i1){i1.setProcessor(this);}this.oMessageParser=i1;this.sDefaultChangeGroup="changes";this.setDeferredGroups([this.sDefaultChangeGroup]);this.setChangeGroups({"*":{groupId:this.sDefaultChangeGroup}});this.oData={};this.oMetadata=null;this.oAnnotations=null;this.aUrlParams=[];this.pSequentialRequestCompleted=Promise.resolve();this.pReadyForRequest=Promise.resolve();var v1=this.sServiceUrl.split("?");if(v1.length>1){this.sServiceUrl=v1[0];if(v1[1]){this.aUrlParams.push(v1[1]);}}this.sServiceUrl=this.sServiceUrl.replace(/\/$/,"");this.sUser=k;this.sPassword=n;if(sap.ui.getCore().getConfiguration().getStatistics()){this.aUrlParams.push("sap-statistics=true");}this.oHeaders={};this.setHeaders(R);if(!this.bDisableSoftStateHeader){this.oHeaders["sap-contextid-accept"]="header";this.mCustomHeaders["sap-contextid-accept"]="header";}var w1=this._getServerUrl();this.sMetadataUrl=this.sWarmupUrl||this._createMetadataUrl("/$metadata");this.oSharedServerData=Q._getSharedData("server",w1);this.oSharedServiceData=Q._getSharedData("service",this.sServiceUrl);this.oSharedMetaData=Q._getSharedData("meta",this.sMetadataUrl);this.bUseCache=this._cacheSupported(this.sMetadataUrl);if(!this.oSharedMetaData.oMetadata||this.oSharedMetaData.oMetadata.bFailed){this.oMetadata=new x(this.sMetadataUrl,{async:true,cacheKey:this.bUseCache?this.sMetadataUrl:undefined,user:this.sUser,password:this.sPassword,headers:this.mCustomHeaders,namespaces:e1,withCredentials:this.bWithCredentials});if(!this.bWarmup){this.oSharedMetaData.oMetadata=this.oMetadata;}}else{this.oMetadata=this.oSharedMetaData.oMetadata;}this.oAnnotations=new O(this.oMetadata,{source:this.sAnnotationURI,skipMetadata:this.bSkipMetadataAnnotationParsing,headers:this.mCustomHeaders,combineEvents:true,cacheKey:this._getAnnotationCacheKey(this.sMetadataUrl),useCache:this.bUseCache});if(!this.bDisableSoftStateHeader){delete this.mCustomHeaders["sap-contextid-accept"];}this.oAnnotations.attachAllFailed(this.onAnnotationsFailed,this);this.oAnnotations.attachSomeLoaded(this.onAnnotationsLoaded,this);this.pAnnotationsLoaded=this.oAnnotations.loaded();if(f1){this.aUrlParams=this.aUrlParams.concat(D._createUrlParamsArray(f1));}this.onMetadataFailed=function(x1){u1.fireMetadataFailed(x1.getParameters());};if(!this.oMetadata.isLoaded()){this.oMetadata.attachFailed(this.onMetadataFailed);}this.oMetadata.loaded().then(function(){u1._initializeMetadata();});if(this.bJSON){if(this.sMaxDataServiceVersion==="3.0"){this.oHeaders["Accept"]="application/json;odata=fullmetadata";}else{this.oHeaders["Accept"]="application/json";}}else{this.oHeaders["Accept"]="application/atom+xml,application/atomsvc+xml,application/xml";}if(this.bTokenHandling){if(this.oSharedServiceData.securityToken){this.oHeaders["x-csrf-token"]=this.oSharedServiceData.securityToken;}else if(this.oSharedServerData.securityToken){this.oSharedServiceData.securityToken=this.oSharedServerData.securityToken;this.oHeaders["x-csrf-token"]=this.oSharedServiceData.securityToken;}if(s1){this.securityTokenAvailable();}}this.oHeaders["Accept-Language"]=sap.ui.getCore().getConfiguration().getLanguageTag();this.oHeaders["DataServiceVersion"]="2.0";this.oHeaders["MaxDataServiceVersion"]="2.0";if(this.sMaxDataServiceVersion){this.oHeaders["MaxDataServiceVersion"]=this.sMaxDataServiceVersion;}if(!this.mCustomHeaders["X-Requested-With"]&&!J(this.sServiceUrl)){this.oHeaders["X-Requested-With"]="XMLHttpRequest";}},
metadata:{publicMethods:["read","create","update","remove","submitChanges","getServiceMetadata","metadataLoaded","hasPendingChanges","getPendingChanges","refresh","refreshMetadata","resetChanges","setDefaultCountMode","setDefaultBindingMode","getDefaultBindingMode","getDefaultCountMode","setProperty","getSecurityToken","refreshSecurityToken","setHeaders","getHeaders","setUseBatch","setDeferredBatchGroups","getDeferredBatchGroups","setChangeBatchGroups","getChangeBatchGroups"]}
});
Q.M_EVENTS={MetadataLoaded:"metadataLoaded",MetadataFailed:"metadataFailed",AnnotationsLoaded:"annotationsLoaded",AnnotationsFailed:"annotationsFailed",BatchRequestFailed:"batchRequestFailed",BatchRequestSent:"batchRequestSent",BatchRequestCompleted:"batchRequestCompleted"};
Q.prototype.attachBatchRequestFailed=function(i,j,k){this.attachEvent("batchRequestFailed",i,j,k);return this;};
Q.prototype.detachBatchRequestFailed=function(i,j){this.detachEvent("batchRequestFailed",i,j);return this;};
Q.prototype.fireBatchRequestFailed=function(i){this.fireEvent("batchRequestFailed",i);return this;};
Q.prototype.attachBatchRequestSent=function(i,j,k){this.attachEvent("batchRequestSent",i,j,k);return this;};
Q.prototype.detachBatchRequestSent=function(i,j){this.detachEvent("batchRequestSent",i,j);return this;};
Q.prototype.fireBatchRequestSent=function(i){this.fireEvent("batchRequestSent",i);return this;};
Q.prototype.attachBatchRequestCompleted=function(i,j,k){this.attachEvent("batchRequestCompleted",i,j,k);return this;};
Q.prototype.detachBatchRequestCompleted=function(i,j){this.detachEvent("batchRequestCompleted",i,j);return this;};
Q.prototype.fireBatchRequestCompleted=function(i){this.fireEvent("batchRequestCompleted",i);return this;};
Q.mSharedData={server:{},service:{},meta:{}};
Q._getSharedData=function(i,k){var j=this.mSharedData[i][k];if(!j){j={};this.mSharedData[i][k]=j;}return j;};
Q.prototype._initializeMetadata=function(){if(this.bDestroyed){return;}this.bIsMessageScopeSupported=this.oMetadata._isMessageScopeSupported();var i=function(){this.fireMetadataLoaded({metadata:this.oMetadata});L.debug(this+" - metadataloaded fired");}.bind(this);this.initialize();if(this.bLoadAnnotationsJoined){this.oAnnotations.loaded().then(i,this.fireMetadataFailed.bind(this));}else{i();}};
Q.prototype.refreshMetadata=function(){if(this.oMetadata&&this.oMetadata.refresh){return this.oMetadata.refresh();}return undefined;};
Q.prototype.fireAnnotationsLoaded=function(i){this.fireEvent("annotationsLoaded",i);return this;};
Q.prototype.attachAnnotationsLoaded=function(i,j,k){this.attachEvent("annotationsLoaded",i,j,k);return this;};
Q.prototype.detachAnnotationsLoaded=function(i,j){this.detachEvent("annotationsLoaded",i,j);return this;};
Q.prototype.fireAnnotationsFailed=function(i){this.fireEvent("annotationsFailed",i);L.debug(this+" - annotationsfailed fired");return this;};
Q.prototype.attachAnnotationsFailed=function(i,j,k){this.attachEvent("annotationsFailed",i,j,k);return this;};
Q.prototype.detachAnnotationsFailed=function(i,j){this.detachEvent("annotationsFailed",i,j);return this;};
Q.prototype.fireMetadataLoaded=function(i){this.fireEvent("metadataLoaded",i);return this;};
Q.prototype.attachMetadataLoaded=function(i,j,k){this.attachEvent("metadataLoaded",i,j,k);return this;};
Q.prototype.detachMetadataLoaded=function(i,j){this.detachEvent("metadataLoaded",i,j);return this;};
Q.prototype.fireMetadataFailed=function(i){this.fireEvent("metadataFailed",i);return this;};
Q.prototype.attachMetadataFailed=function(i,j,k){this.attachEvent("metadataFailed",i,j,k);return this;};
Q.prototype.detachMetadataFailed=function(i,j){this.detachEvent("metadataFailed",i,j);return this;};
Q.prototype._createEventInfo=function(R,k,n){var T,V,W={};W.url=R.requestUri;W.method=R.method;W.async=R.async;W.headers=R.headers;if(n){W.requests=[];for(var i=0;i<n.length;i++){V={};if(Array.isArray(n[i])){var X=n[i];for(var j=0;j<X.length;j++){R=X[j].request;T=n[i][j].response;V={};V.url=R.requestUri;V.method=R.method;V.headers=R.headers;if(T){V.response={};if(R._aborted){V.success=false;V.response.statusCode=0;V.response.statusText="abort";}else{V.success=true;if(T.message){V.response.message=T.message;T=T.response;V.response.responseText=T.body;V.success=false;}V.response.headers=T.headers;V.response.statusCode=T.statusCode;V.response.statusText=T.statusText;}}W.requests.push(V);}}else{R=n[i].request;T=n[i].response;V.url=R.requestUri;V.method=R.method;V.headers=R.headers;if(T){V.response={};if(R._aborted){V.success=false;V.response.statusCode=0;V.response.statusText="abort";}else{V.success=true;if(T.message){V.response.message=T.message;T=T.response;V.response.responseText=T.body;V.success=false;}V.response.headers=T.headers;V.response.statusCode=T.statusCode;V.response.statusText=T.statusText;}}W.requests.push(V);}}}if(k){W.response={};W.success=true;if(k.message){W.response.message=k.message;W.success=false;}if(k.response){k=k.response;}if(k&&k.statusCode!=undefined){W.response.headers=k.headers;W.response.statusCode=k.statusCode;W.response.statusText=k.statusText;W.response.responseText=k.body!==undefined?k.body:k.responseText;if(k.expandAfterCreateFailed){W.response.expandAfterCreateFailed=true;}if(k.expandAfterFunctionCallFailed){W.response.expandAfterFunctionCallFailed=true;}}}W.ID=R.requestID;return W;};
Q.prototype._createRequestID=function(){var R;R=u();return R;};
Q.prototype._getServerUrl=function(){var i,j;i=new I(this.sServiceUrl).absoluteTo(document.baseURI);j=new I("/").absoluteTo(i).toString();return j;};
Q.prototype._createMetadataUrl=function(i){if(i.indexOf(this.sServiceUrl)==-1){if(!i.startsWith("/")){i="/"+i;}i=this.sServiceUrl+i;}var j=U.fromURL(i||window.location.href);var k=Object.assign({},this.mMetadataUrlParams);Array.from(j.keys()).forEach(function(T){k[T]=j.get(T);});var n=D._createUrlParamsArray(k);var R=i.split("?");if(R.length>1){i=R[0];}return this._addUrlParams(i,n);};
Q.prototype._addUrlParams=function(i,j){var k=[];if(this.aUrlParams){k=k.concat(this.aUrlParams);}if(j){k=k.concat(j);}if(k.length>0){i+="?"+k.join("&");}return i;};
Q.prototype._createRequestUrl=function(i,j,k,n){return this._createRequestUrlWithNormalizedPath(this._normalizePath(i,j),k,n);};
Q.prototype._createRequestUrlWithNormalizedPath=function(n,i,j){var k="";if(!j){k=this.sServiceUrl+n;}else{k=n.substr(n.indexOf('/')+1);}return this._addUrlParams(k,i);};
Q.prototype._importData=function(j,k,R,n,T,V,W,X){var Y=this,Z,$,a1,b1;n=n||"";V=V||"";if(j.results&&Array.isArray(j.results)){Z=[];h(j.results,function(i,i1){var V=Y._getKey(i1);V=Y._importData(i1,k,R,n.substr(0,n.lastIndexOf("/")),T,V);if(V){Z.push(V);}});return Z;}else{if(V){n="/"+V;T+=V.substr(V.indexOf("("));}else{V=this._getKey(j);}if(!V){return V;}a1=this._getEntity(V);b1=a1;if(!a1||(a1.__metadata&&a1.__metadata.invalid)){if(!b1){b1=j;}a1=j;V=this._addEntity(a1);}if(this.aBindableResponseHeaders){var c1={};for(var d1 in R.headers){var e1=d1.toLowerCase();if(this.aBindableResponseHeaders.indexOf(e1)>-1){c1[e1]=R.headers[d1];}}if(!m(c1)){if(!j.__metadata){j.__metadata={};}j.__metadata.headers=c1;}}h(j,function(i,i1){if(i1&&(i1.__metadata&&i1.__metadata.uri||i1.results)&&!i1.__deferred){var j1=n+"/"+i;var k1=T+"/"+i;$=Y._importData(i1,k,R,j1,k1,undefined,false,"/"+V+"/"+i);if(Array.isArray($)){a1[i]={__list:$};}else{if(b1[i]&&b1[i].__ref){if(b1[i].__ref!==$){Y.mInvalidatedPaths[n.substr(n.lastIndexOf("("))+"/"+i]="/"+$;}}a1[i]={__ref:$};}}else if(!i1||!i1.__deferred){if(b1[i]&&i1===null){Y.mInvalidatedPaths[n.substr(n.lastIndexOf("("))+"/"+i]=null;}a1[i]=i1;}});var f1={};f1[V]=a1;if(this.hasContext("/"+V)&&this.getContext("/"+V).isPreliminary()){var g1=this.getContext("/"+V);g1.setUpdated(true);g1.setPreliminary(false);}this._updateChangedEntities(f1);k[V]=true;n=n||'/'+V;T=T||n;var h1=this.resolveFromCache(T);if(h1==="/"+V||(h1&&h1.split("/").length>2)){this._writePathCache(h1,"/"+V,W);}this._writePathCache(n,"/"+V,W);this._writePathCache(T,"/"+V,W,true);if(X){this._writePathCache(X,"/"+V,W);}return V;}};
Q.prototype._writePathCache=function(i,j,k,n){var R,T,V,W,X,Y;if(i&&j){if(!this.mPathCache[i]){this.mPathCache[i]={};}if(!k&&i.lastIndexOf("/")===0){j=i;}this.mPathCache[i].canonicalPath=j;if(n){X=i.split("/");for(Y=3;Y<X.length;Y+=1){V=X.slice(0,Y).join("/");W=this.mPathCache[V];if(W){R=W.canonicalPath+i.slice(V.length);T=this.mPathCache[R];if(T){T.canonicalPath=j;}}}}}};
Q.prototype._removeReferences=function(j){var k=this,n;if(!j){return j;}if(j.results){n=[];h(j.results,function(i,R){n.push(k._removeReferences(R));});return n;}else{h(j,function(i,R){if(R){if(R["__ref"]||R["__list"]){delete j[i];}}});return j;}};
Q.prototype._restoreReferences=function(j,V){var k=this,n,R,T;function W(n){var R=V[n];if(!R){R=k._getObject("/"+n);d(R,"ODataModel inconsistent: "+n+" not found!");if(R){R=p({},R);V[n]=R;k._restoreReferences(R,V);}}return R;}if(!V){V={};}h(j,function(X,Y){if(Y){if(Y.__ref){n=Y.__ref;R=W(n);if(R){j[X]=R;}delete Y.__ref;}else if(Y.__list){T=[];h(Y.__list,function(i,n){R=W(n);if(R){T.push(R);}});delete Y.__list;Y.results=T;}}});return j;};
Q.prototype.removeData=function(){this.oData={};};
Q.prototype.initialize=function(){var i=this.getBindings();i.forEach(function(j){j.initialize();});};
Q.prototype.invalidate=function(i){var j;for(var k in this.oData){j=this.oData[k];if(!i||i(k,j)){j.__metadata.invalid=true;}}};
Q.prototype.invalidateEntry=function(i){var j;if(typeof i==="string"){if(i.indexOf("/")===0){j=this._getObject(i);}else{j=this.oData[i];}}else if(i instanceof s){j=this._getObject(i.getPath());}if(j&&j.__metadata){j.__metadata.invalid=true;}};
Q.prototype.invalidateEntityType=function(i){var j;for(var k in this.oData){j=this.oData[k];if(j.__metadata.type===i){j.__metadata.invalid=true;}}};
Q.prototype.refresh=function(i,R,j){if(typeof i==="string"){j=i;i=false;R=false;}if(R){this.removeData();}this._refresh(i,j);};
Q.prototype._refresh=function(i,j,k,n){var R=this.getBindings();this.sRefreshGroupId=j;R.forEach(function(T){T._refresh(i,k,n);});this.sRefreshGroupId=undefined;};
Q.prototype.checkUpdate=function(i,j,k,n){if(j){this.bForceUpdate=this.bForceUpdate||i;Object.assign(this.mChangedEntities4checkUpdate,k);if(!this.sUpdateTimer){this.sUpdateTimer=setTimeout(function(){this.checkUpdate(this.bForceUpdate,false,this.mChangedEntities4checkUpdate);}.bind(this),0);}return;}i=this.bForceUpdate||i;if(this.sUpdateTimer){clearTimeout(this.sUpdateTimer);this.sUpdateTimer=null;this.bForceUpdate=undefined;this.mChangedEntities4checkUpdate={};}var R=this.getBindings();R.forEach(function(T){if(!n||this.isMetaModelPath(T.getPath())){T.checkUpdate(i,k);}}.bind(this));this._processAfterUpdate();};
Q.prototype.checkDataState=function(i){var j=this.getBindings();j.forEach(function(k){if(k.checkDataState){k.checkDataState(i);}});};
Q.prototype.bindProperty=function(i,j,k){var n=new A(this,i,j,k);return n;};
Q.prototype.bindList=function(i,j,k,n,R){var T=new b(this,i,j,k,n,R);return T;};
Q.prototype.bindTree=function(i,j,k,n,R){var T=new c(this,i,j,k,n,R);return T;};
Q.prototype.createBindingContext=function(i,j,k,n,R){var T,V,W,X,Y,Z,$,a1,b1,c1=this;if(j!==null&&typeof j==="object"&&!(j instanceof s)){R=n;n=k;k=j;j=undefined;}if(typeof j=="function"){R=k;n=j;k=undefined;j=undefined;}if(typeof j=="boolean"){R=j;n=undefined;k=undefined;j=undefined;}if(typeof k=="function"){R=n;n=k;k=undefined;}if(typeof k=="boolean"){R=k;n=undefined;k=undefined;}if(typeof n=="boolean"){R=n;n=undefined;}if(k){T=k.canonicalRequest;}T=this._isCanonicalRequestNeeded(T);b1=this.resolve(i,j,T);if(!b1&&T){b1=this.resolve(i,j);}X=this.resolveDeep(i,j);if(!b1){if(n){n(null);}return null;}if(R===undefined){R=this._isReloadNeeded(b1,k);}if(!R){V=this.resolve(i,j,true);if(V){$=this.getContext(V,X);}else{$=null;}if(n){n($);}return $;}function d1(f1){var g1=f1?c1._getKey(f1):null,h1=!(i===""||i.indexOf("/")>0),i1=null,j1,k1;$=null;if(g1){$=c1.getContext('/'+g1,X);i1={__ref:g1};}if(j&&Z&&h1){j1=j.getPath();j1=j1.substr(1);k1=c1._getEntity(j1);if(k1){k1[i]=i1;}}n($);}function e1(f1){var g1;if(f1.statusCode=='404'&&j&&Z){var h1=j.getPath();h1=h1.substr(1);g1=c1._getEntity(h1);if(g1){g1[i]={__ref:null};}}n(null);}if(n){Z=!i.startsWith("/");a1=[];W=this.createCustomParams(k);if(W){a1.push(W);}if(k&&(k.batchGroupId||k.groupId)){Y=k.groupId||k.batchGroupId;}this.read(i,{canonicalRequest:T,context:j,error:e1,groupId:Y,success:d1,updateAggregatedMessages:true,urlParameters:a1});}if(k&&k.createPreliminaryContext){b1=this.resolve(i,j,T);if(!b1&&T){b1=this.resolve(i,j);}$=this.getContext(b1,X);return $;}return undefined;};
Q.prototype._updateContext=function(i,j,k){i.sPath=j;if(k!==undefined){i.sDeepPath=k;}this.mContexts[j]=i;};
Q.prototype._splitEntries=function(i){return i.replace(/\s/g,"").split(',').map(function(j){return j.split("/");});};
Q.prototype._filterOwnSelect=function(i,j){var k,n;if(!j){return[];}n=j.map(function(R){return R.name;});k=i.filter(function(R){return R.length===1;}).map(function(R){return R[0];});if(i.length===0||k.indexOf("*")!==-1||k.indexOf("**")!==-1){return n;}else{return k.filter(function(R){return n.indexOf(R)!==-1;});}};
Q.prototype._filterOwnExpand=function(i,j){return i.map(function(k){return k[0];}).filter(function(V,k,n){return n.indexOf(V)===k;}).filter(function(V){return j.length===0||j.some(function(k){return k.indexOf(V)===0||k.indexOf("**")===0;});});};
Q.prototype._filterSelectByNavProp=function(i,n){return i.filter(function(j){return j[0]===n;}).map(function(j){return j.length>1?j.slice(1):["**"];});};
Q.prototype._filterExpandByNavProp=function(i,n){return i.filter(function(j){return j.length>1&&j[0]===n;}).map(function(j){return j.slice(1);});};
Q.prototype._isReloadNeeded=function(k,n){var R=this,T=this.oMetadata,V,W=this._getObject(k),X=[],Y=[];if(!this.oMetadata.isLoaded()){return true;}V=this.oMetadata._getEntityTypeByPath(k);if(this._isCreatedEntity(W)){return false;}function Z(V,W,Y,X){var $,i,a1,b1,c1,d1,e1,f1,g1,h1;if(!V){return false;}if(W===null){return false;}if(!W){return true;}if(W.__metadata&&W.__metadata.invalid){return true;}g1=R._filterOwnSelect(Y,V.property);for(i=0;i<g1.length;i++){h1=g1[i];if(W[h1]===undefined){return true;}}f1=R._filterOwnExpand(X,Y);for(i=0;i<f1.length;i++){$=f1[i];a1=W[$];if(a1===null){continue;}if(a1===undefined||a1.__deferred){return true;}c1=T._getEntityTypeByNavProperty(V,$);e1=R._filterSelectByNavProp(Y,$);d1=R._filterExpandByNavProp(X,$);if(a1.__ref){b1=R._getEntity(a1.__ref);if(Z(c1,b1,e1,d1)){return true;}}if(a1.__list){for(var j=0;j<a1.__list.length;j++){b1=R._getEntity(a1.__list[j]);if(Z(c1,b1,e1,d1)){return true;}}}}return false;}if(n){if(n.select){Y=this._splitEntries(n.select);}if(n.expand){X=this._splitEntries(n.expand);}}return Z(V,W,Y,X);};
Q.prototype.createCustomParams=function(i){var j=[],k,n={expand:true,select:true};for(var R in i){if(R in n){j.push("$"+R+"="+e(i[R]));}if(R==="custom"){k=i[R];for(R in k){if(R.indexOf("$")===0){L.warning(this+" - Trying to set OData parameter '"+R+"' as custom query option!");}else if(typeof k[R]==='string'){j.push(R+"="+e(k[R]));}else{j.push(R);}}}}return j.join("&");};
Q.prototype.bindContext=function(i,j,k){var n=new a(this,i,j,k);return n;};
Q.prototype.setDefaultCountMode=function(i){this.sDefaultCountMode=i;};
Q.prototype.getDefaultCountMode=function(){return this.sDefaultCountMode;};
Q.prototype._addEntity=function(i){var k=this._getKey(i);this.oData[k]=i;return k;};
Q.prototype._removeEntity=function(k){k=k&&D._normalizeKey(k);delete this.oData[k];delete this.mChangedEntities[k];delete this.mContexts["/"+k];};
Q.prototype._getEntity=function(k){var i=this.oData[k];if(!i){k=k&&D._normalizeKey(k);i=this.oData[k];}return i;};
Q.prototype._getKey=function(V){var k,i;if(V instanceof s){k=V.getPath().substr(1);}else if(V&&V.__metadata&&V.__metadata.uri){i=V.__metadata.uri;k=i.substr(i.lastIndexOf("/")+1);}else if(typeof V==='string'){k=V.substr(V.lastIndexOf("/")+1);}if(!this.oData[k]){k=k&&D._normalizeKey(k);}return k;};
Q.prototype.getKey=function(V){return this._getKey(V);};
Q.prototype.createKey=function(j,k){var n=this.oMetadata._getEntityTypeByPath(j),R=j,T=this,V,W;d(n,"Could not find entity type of collection \""+j+"\" in service metadata!");R+="(";if(n.key.propertyRef.length===1){V=n.key.propertyRef[0].name;d(V in k,"Key property \""+V+"\" is missing in object!");W=this.oMetadata._getPropertyMetadata(n,V);R+=encodeURIComponent(D.formatValue(k[V],W.type));}else{h(n.key.propertyRef,function(i,X){if(i>0){R+=",";}V=X.name;d(V in k,"Key property \""+V+"\" is missing in object!");W=T.oMetadata._getPropertyMetadata(n,V);R+=V;R+="=";R+=encodeURIComponent(D.formatValue(k[V],W.type));});}R+=")";return R;};
Q.prototype.getProperty=function(i,j,k){var V=this._getObject(i,j);if(!k){return V;}if(!o(V)){return V;}V=p({},V);if(k===true){return this._restoreReferences(V);}else{return this._removeReferences(V);}};
Q.prototype.getObject=function(n,R,T){if(o(R)){T=R;R=undefined;}var V=this,W=this.resolve(n,R),X=this._getObject(W),Y=this.oMetadata._getEntityTypeByPath(W),Z=[],$=[];if(!Y||!o(X)||!X.__metadata||!X.__metadata.uri){return X;}if(!T||!(T.select||T.expand)){return p({},X);}function a1(Y,X,$,Z){var b1,i,c1,d1,e1,f1,g1,h1,i1,j1,k1,l1,m1,n1;if(!X){return undefined;}if(!Y){return undefined;}k1=V._filterOwnSelect($,Y.property);m1={};for(i=0;i<k1.length;i++){n1=k1[i];if(X[n1]!==undefined){m1[n1]=X[n1];}else{L.fatal("No data loaded for select property: "+n1+" of entry: "+V.getKey(X));return undefined;}}if(X.__metadata){m1.__metadata=X.__metadata;}i1=V._filterOwnExpand(Z,$);for(i=0;i<i1.length;i++){b1=i1[i];c1=X[b1];d1=V.oMetadata._getEntityTypeByNavProperty(Y,b1);g1=V._filterSelectByNavProp($,b1);e1=V._filterExpandByNavProp(Z,b1);if(c1&&c1.__ref){f1=V._getObject("/"+c1.__ref);h1=a1(d1,f1,g1,e1);if(h1!==undefined){m1[b1]=h1;}else{L.fatal("No data loaded for expand property: "+b1+" of entry: "+V.getKey(h1));return undefined;}}if(c1&&c1.__list){l1=[];for(var j=0;j<c1.__list.length;j++){f1=V._getObject("/"+c1.__list[j]);h1=a1(d1,f1,g1,e1);if(h1!==undefined){l1.push(h1);}else{L.fatal("No data loaded for expand property: "+b1+" of entry: "+V.getKey(h1));return undefined;}}m1[b1]=l1;}}j1=V._filterOwnSelect($,Y.navigationProperty);for(var k=0;k<j1.length;k++){b1=j1[k];if(i1.indexOf(b1)===-1){var o1=m1.__metadata.uri+"/"+b1;m1[b1]={__deferred:{uri:o1}};}}return m1;}if(T.select){$=this._splitEntries(T.select);}if(T.expand){Z=this._splitEntries(T.expand);}X=a1(Y,X,$,Z);return X;};
Q.prototype._getObject=function(i,j,k){var n,R,T,V,W,X,Y,Z,$,a1,b1,c1=this.isLegacySyntax()?this.oData:null;a1=this.resolve(i,j,this.bCanonicalRequests);if(!a1&&this.bCanonicalRequests){a1=this.resolve(i,j);}if(!a1){return c1;}if(this._isMetadataPath(a1)){if(this.oMetadata&&this.oMetadata.isLoaded()){if(this.isMetaModelPath(a1)){Y=this.getMetaModel();T=y.getCodeListTerm(a1);if(T){R=Y.fetchCodeList(T);if(R.isFulfilled()){return R.getResult();}if(R.isRejected()){R.caught();}return undefined;}if(!this.bMetaModelLoaded){return null;}b1=a1.indexOf('/##');V=a1.substr(0,b1);Z=a1.substr(b1+3);X=Y.getMetaContext(V);c1=Y.getProperty(Z,X);}else{c1=this.oMetadata._getAnnotation(a1);}}else if(y.getCodeListTerm(a1)){return undefined;}}else{if(a1==="/"){return this.oData;}var d1=a1.split("/"),e1=0;W=d1[1];d1.splice(0,2);n=this.mChangedEntities[W];$=this._getEntity(W);c1=k?$:n||$;while(c1&&d1[e1]){var f1=n&&n.hasOwnProperty(d1[e1]);n=n&&n[d1[e1]];$=$&&$[d1[e1]];c1=k||!f1?$:n;if(c1){if(c1.__ref){n=this.mChangedEntities[c1.__ref];$=this._getEntity(c1.__ref);c1=k?$:n||$;}else if(c1.__list){c1=c1.__list;}else if(c1.__deferred){c1=undefined;}}e1++;}}if(o(n)){c1=k?$:p({},$,n);}return c1;};
Q.prototype.updateSecurityToken=function(){if(this.bTokenHandling){if(!this.oSharedServiceData.securityToken){this.refreshSecurityToken();}if(this.bTokenHandling){this.oHeaders["x-csrf-token"]=this.oSharedServiceData.securityToken;}}};
Q.prototype.resetSecurityToken=function(){delete this.oSharedServiceData.securityToken;delete this.oHeaders["x-csrf-token"];delete this.pSecurityToken;};
Q.prototype.getSecurityToken=function(){var T=this.oSharedServiceData.securityToken;if(!T){this.refreshSecurityToken();T=this.oSharedServiceData.securityToken;}return T;};
Q.prototype.securityTokenAvailable=function(){if(!this.pSecurityToken){if(this.oSharedServiceData.securityToken){this.pSecurityToken=Promise.resolve(this.oSharedServiceData.securityToken);}else{this.pSecurityToken=new Promise(function(i,j){this.refreshSecurityToken(function(){i(this.oSharedServiceData.securityToken);}.bind(this),function(){j();},true);}.bind(this));}}return this.pSecurityToken;};
Q.prototype.refreshSecurityToken=function(i,j,k){var R,T,n={abort:function(){this.request.abort();}},V=this._createRequestUrlWithNormalizedPath("/"),W=this;function X(a1,b1){if(b1){T=W._getHeader("x-csrf-token",b1.headers);W._setSessionContextIdHeader(W._getHeader("sap-contextid",b1.headers));if(T){W.oSharedServerData.securityToken=T;W.oSharedServiceData.securityToken=T;W.pSecurityToken=Promise.resolve(T);W.oHeaders["x-csrf-token"]=T;}else{W.resetSecurityToken();W.bTokenHandling=false;}}if(i){i(a1,b1);}}function Y(a1){W.resetSecurityToken();W.bTokenHandling=false;W._handleError(a1,R);if(j){j(a1);}}function Z(a1){n.request=$("GET",Y);}function $(a1,j){R=W._createRequest(V,"",a1,W._getHeaders(undefined,true),null,null,!!k);R.headers["x-csrf-token"]="Fetch";return W._request(R,X,j,undefined,undefined,W.getServiceMetadata());}if(this.bDisableHeadRequestForToken){n.request=$("GET",Y);}else{n.request=$("HEAD",Z);}return n;};
Q.prototype._submitRequest=function(R,j,k){var n=this,T,V,W,X,Y;X=new Promise(function(i,e1){Y=i;});function Z(i,e1){if(j){j(i,e1);}Y();}function $(i){if(n.bTokenHandling&&i.response){var e1=n._getHeader("x-csrf-token",i.response.headers);if(!R.bTokenReset&&i.response.statusCode=='403'&&e1&&e1.toLowerCase()==="required"){n.resetSecurityToken();R.bTokenReset=true;b1();return;}}if(k){k(i);}Y();}function a1(R){if(n.bTokenHandling&&(R.method!=="GET"||n.bTokenHandlingForGet)){n.pReadyForRequest=n.securityTokenAvailable();}return n.pReadyForRequest;}function b1(){if(n.bTokenHandling){delete R.headers["x-csrf-token"];}a1(R).then(function(i){if(n.bTokenHandling&&(R.method!=="GET"||n.bTokenHandlingForGet)){R.headers["x-csrf-token"]=i;}d1();},function(){d1();});}function c1(e1,R,f1){var g1,h1=R.eventInfo.requests;if(h1){h(h1,function(i,R){if(Array.isArray(R)){R.forEach(function(R){h(R.parts,function(i,i1){g1=n._createEventInfo(R.request,i1.fnError);n["fireRequest"+e1](g1);});});}else if(R.parts){h(R.parts,function(i,i1){g1=n._createEventInfo(R.request,i1.fnError);n["fireRequest"+e1](g1);});}else{g1=n._createEventInfo(R.request,R.fnError);n["fireRequest"+e1](g1);}});if(R.eventInfo.batch){g1=n._createEventInfo(R,f1,h1);n["fireBatchRequest"+e1](g1);}}}function d1(){if(n.sSessionContextId){R.headers["sap-contextid"]=n.sSessionContextId;}V=n._request(R,Z,$,T,undefined,n.getServiceMetadata());if(R.eventInfo){c1("Sent",R,null);delete R.eventInfo;}if(W&&V){V.abort();}}T=n._getODataHandler(R.requestUri);if(this.bSequentializeRequests){this.pSequentialRequestCompleted.then(function(){b1();});this.pSequentialRequestCompleted=X;}else{b1();}return{abort:function(){if(V){V.abort();}W=true;}};};
Q.prototype._setSessionContextIdHeader=function(i){if(i){this.sSessionContextId=i;}};
Q.prototype._submitSingleRequest=function(R){var j=this,k,n={},T={},V={};function W(Y,Z){if(Y===undefined&&Z.statusCode===200){X({message:"Response did not contain a valid OData result",response:Z});return;}function $(Y,Z){for(var i=0;i<R.parts.length;i++){if(R.parts[i].request._aborted){j._processAborted(R.parts[i].request,Z);}else if(R.parts[i].fnSuccess){R.parts[i].fnSuccess(Y,Z);}}if(R.request.requestUri.indexOf("$count")===-1){j.checkUpdate(false,false,T);if(R.bRefreshAfterChange){j._refresh(false,undefined,n,V);}}}j._processSuccess(R.request,Z,$,T,n,V);j._invalidatePathCache();j._setSessionContextIdHeader(j._getHeader("sap-contextid",Z.headers));}function X(Y){var i;if(Y.message=="Request aborted"){for(i=0;i<R.parts.length;i++){j._processAborted(R.parts[i].request,Y);}}else{for(i=0;i<R.parts.length;i++){j._processError(R.parts[i].request,Y,R.parts[i].fnError);}}j._processAfterUpdate();}R.request.eventInfo={requests:R.parts,batch:false};k=this._submitRequest(R.request,W,X);return k;};
Q.prototype._submitBatchRequest=function(k,R,n,T){var V=this,W={},X={},Y={},Z={};function $(j,f1,g1){var h1,i1,i;for(i=0;i<j.parts.length;i++){if(g1||j.parts[i].request._aborted){V._processAborted(j.parts[i].request,f1);}else if(f1.message){V._processError(j.parts[i].request,f1,j.parts[i].fnError);}else{if(j.request.contentID){h1=j.request.contentID;if(j.request.created||j.request.functionMetadata){i1=V._getKey(f1.data);X[h1]={key:i1,deepPath:j.request.deepPath.replace("('"+h1+"')",i1.slice(i1.indexOf("(")))};}else{i1=X[h1].key;j.request.requestUri=j.request.requestUri.replace("$"+h1,i1);j.request.deepPath=X[h1].deepPath;}}V._processSuccess(j.parts[i].request,f1,j.parts[i].fnSuccess,Y,W,Z,false,undefined,X);}}}function a1(f1,g1){if(f1===undefined&&g1.statusCode===200){b1({message:"Response did not contain a valid OData batch result",response:g1});return;}var h1,i1,j1,k1=f1.__batchResponses;if(k1){var i,j;for(i=0;i<k1.length;i++){h1=k1[i];if(Array.isArray(R[i])){if(h1.message){for(j=0;j<R[i].length;j++){h1.$reported=false;i1=R[i][j];$(i1,h1);i1.response=h1;}}else{j1=h1.__changeResponses;for(j=0;j<j1.length;j++){var l1=j1[j];i1=R[i][j];$(i1,l1);i1.response=l1;}}}else{i1=R[i];$(i1,h1);i1.response=h1;}}V._invalidatePathCache();V.checkUpdate(false,false,Y);}V._processSuccess(k,g1,n,Y,W,Z,true,R);V._setSessionContextIdHeader(V._getHeader("sap-contextid",g1.headers));}function b1(j){var f1=j.message=="Request aborted";j.$reported=true;h(R,function(i,g1){if(Array.isArray(g1)){g1.forEach(function(g1){$(g1,j,f1);});}else{$(g1,j,f1);}});V._processAfterUpdate();if(f1){V._processAborted(k,j,true);}else{j.$reported=false;V._processError(k,j,T,true,R);}}k.eventInfo={requests:R,batch:true};var c1=this._submitRequest(k,a1,b1);function d1(j){var T;for(var i=0;i<j.parts.length;i++){T=j.parts[i].fnError;if(!j.parts[i].request._aborted&&T){T(Q._createAbortedError());}}}var e1={abort:function(j){h(R,function(i,f1){if(Array.isArray(f1)){f1.forEach(function(f1){d1(f1);});}else{d1(f1);}});if(T&&!j){T(Q._createAbortedError());}c1.abort();}};return e1;};
Q.prototype._invalidatePathCache=function(){var i=this,j;if(Object.keys(this.mInvalidatedPaths).length>0){Object.keys(this.mPathCache).forEach(function(k){for(var n in i.mInvalidatedPaths){j=k.indexOf(n);if(j>-1){if(j+n.length!==k.length){var R=k.substr(j+n.length);i.mPathCache[k].canonicalPath=i.mInvalidatedPaths[n]===null?null:i.mInvalidatedPaths[n]+R;}else{i.mPathCache[k].canonicalPath=i.mInvalidatedPaths[n];}}}});}this.mInvalidatedPaths={};};
Q.prototype._createBatchRequest=function(i){var j,R,k={},n={},T=true;n.__batchRequests=i;for(var V in i){if(i[V]&&i[V].__changeRequests||i[V]&&i[V].headers&&!i[V].headers['sap-cancel-on-close']){T=false;break;}}j=this.sServiceUrl+"/$batch";if(this.aUrlParams.length>0){j+="?"+this.aUrlParams.join("&");}l(k,this.mCustomHeaders,this.oHeaders);k["Accept"]="multipart/mixed";delete k["Content-Type"];k['sap-cancel-on-close']=T;R={headers:k,requestUri:j,method:"POST",data:n,user:this.sUser,password:this.sPassword,async:true};R.withCredentials=this.bWithCredentials;return R;};
Q.prototype.abortInternalRequest=function(j,k){var R=this.mRequests;var n,T;if(k){n=k.requestKey;T=k.path;}if(j in this.mDeferredGroups){R=this.mDeferredRequests;}var V=function(X){for(var i=0;i<X.parts.length;i++){X.parts[i].requestHandle.abort();}};var W=R[j];if(W){if(n in W.map){V(W.map[n]);}else if(T){h(W.map,function(n,i){if(n.indexOf(T)>=0){V(i);}});}else if(j&&!k){h(W.map,function(i,X){V(X);});}}};
Q.prototype._pushToRequestQueue=function(R,i,j,k,n,T,V,W){var X,Y=R[i],Z=k.key?k.key:k.method+":"+k.requestUri;if(this.bWarmup){return;}if(!Y){Y={};Y.map={};Y.requests=[];R[i]=Y;}if(Z in Y.map&&(k.key||k.method==='GET')){X=Y.map[Z];var $=X.request;k.deepPath=$.deepPath;if(this.sMessageScope===w.BusinessObject){k.headers["sap-message-scope"]=$.headers["sap-message-scope"];}if(X.bRefreshAfterChange===undefined){X.bRefreshAfterChange=W;}if(!k.key){X.parts.push({request:k,fnSuccess:n,fnError:T,requestHandle:V});}if(k.method==="GET"){delete $.data;}else{$.method=k.method;$.headers=k.headers;$.data=k.data;if(k.method==="PUT"){delete $.headers["x-http-method"];}if($._aborted){delete $._aborted;}}if($.functionMetadata){$.requestUri=k.requestUri;$.functionTarget=k.functionTarget;}}else{X={request:k,bRefreshAfterChange:W,parts:[{request:k,fnSuccess:n,fnError:T,requestHandle:V}]};if(k.method==="GET"){Y.requests.push(X);}else{if(!Y.changes){Y.changes={};}var a1=Y.changes[j];if(!a1){a1=[];Y.changes[j]=a1;}X.changeSetId=j;a1.push(X);}Y.map[Z]=X;}};
Q.prototype._collectChangedEntities=function(j,k,n){var R=this;if(j.changes){h(j.changes,function(T,V){for(var i=0;i<V.length;i++){if(V[i].bRefreshAfterChange){var W=V[i].request,X="/"+W.requestUri.split("?")[0],Y,Z;if(W.method==="POST"||W.method==="DELETE"){var $=R.oMetadata._getEntityTypeByPath(X);if($){n[$.entityType]=true;}}else{Y=R._getObject(X);if(Y){Z=R._getKey(Y);}else if(X.lastIndexOf("/")===0){Z=R._getKey(X);}if(Z){k[Z]=true;}}}}});}};
Q.prototype._processRequestQueue=function(R,j,k,n){var T=this,V,W=[];function X(Z,$){for(var i=0;i<Z.parts.length;i++){var a1=Z.parts[i];if(a1.request._aborted){T._processAborted(Z.request,null);Z.parts.splice(i,1);i--;}else if($){a1.request._handle=$;$.iRelevantRequests++;}}}function Y(){return{iRelevantRequests:0,oRequestHandle:{},abort:function(){this.iRelevantRequests--;if(this.iRelevantRequests===0&&this.oRequestHandle){this.oRequestHandle.abort(true);if(k){k({},undefined);}}}};}if(this.bUseBatch){h(R,function(i,Z){if(i===j||!j){var $={},a1={};T._collectChangedEntities(Z,$,a1);if(Object.keys($).length||Object.keys(a1).length){T.bIncludeInCurrentBatch=true;T._refresh(false,i,$,a1);T.bIncludeInCurrentBatch=false;}}});h(R,function(Z,$){if(Z===j||!j){var a1=[],b1=[],c1,d1;var e1=Y();if($.changes){h($.changes,function(h1,i1){var j1,i,k1;c1={__changeRequests:[]};d1=[];for(i=0;i<i1.length;i++){j1=i1[i].request;V='/'+T.getKey(j1.data);T.increaseLaundering(V,j1.data);X(i1[i],e1);if(i1[i].parts.length>0){T.removeInternalMetadata(j1.data);c1.__changeRequests.push(j1);if(j1.expandRequest){k1=i1[i].parts[0];T._pushToRequestQueue(R,Z,undefined,j1.expandRequest,k1.fnSuccess,k1.fnError,k1.requestHandle,false);}d1.push(i1[i]);}}if(c1.__changeRequests&&c1.__changeRequests.length>0){a1.push(c1);b1.push(d1);}});}if($.requests){var f1=$.requests;for(var i=0;i<f1.length;i++){X(f1[i],e1);if(f1[i].parts.length>0){a1.push(f1[i].request);b1.push(f1[i]);}}}if(a1.length>0){var g1=T._createBatchRequest(a1);e1.oRequestHandle=T._submitBatchRequest(g1,b1,k,n);W.push(e1.oRequestHandle);}delete R[Z];}});}else{h(R,function(Z,$){if(Z===j||!j){if($.changes){h($.changes,function(c1,d1){for(var i=0;i<d1.length;i++){var b1=Y();V='/'+T.getKey(d1[i].request.data);T.increaseLaundering(V,d1[i].request.data);X(d1[i],b1);if(d1[i].parts.length>0){T.removeInternalMetadata(d1[i].request.data);b1.oRequestHandle=T._submitSingleRequest(d1[i]);W.push(b1.oRequestHandle);}}});}if($.requests){var a1=$.requests;for(var i=0;i<a1.length;i++){var b1=Y();X(a1[i],b1);if(a1[i].parts.length>0){b1.oRequestHandle=T._submitSingleRequest(a1[i]);W.push(b1.oRequestHandle);}}}delete R[Z];}});}this.checkDataState(this.mLaunderingState);return W.length==1?W[0]:W;};
Q.prototype._processRequestQueueAsync=function(R){var i=this;if(!this.pCallAsync){this.pCallAsync=this.oMetadata.loaded().then(function(){return Promise.resolve().then(function(){i._processRequestQueue(R);i.pCallAsync=undefined;});});}};
Q.prototype._processSuccess=function(R,i,j,k,n,T,V,W,X){var Y,Z,$,a1,b1,c1,d1,e1,f1,g1,h1,i1,j1,k1={},l1={},m1=i.data,n1=this;if(!V){Z=!(i.statusCode===204||i.statusCode==='204');j1=R.requestUri;h1=j1.replace(this.sServiceUrl,"");if(!h1.startsWith('/')){h1='/'+h1;}f1=this._normalizePath(h1);b1=this.oMetadata._getEntityTypeByPath(f1);e1=b1&&b1.isFunction;h1=this._normalizePath(h1,undefined,!e1);this.decreaseLaundering(h1,R.data);this._decreaseDeferredRequestCount(R);if(R.functionMetadata){if(i.headers&&i.headers.location){c1=i.headers.location;i1=c1.lastIndexOf(this.sServiceUrl);if(i1>-1){Y=c1.slice(i1+this.sServiceUrl.length);if(R.functionTarget===Y){$=this.getDeepPathForCanonicalPath(Y);if($){R.deepPath=$;}}R.functionTarget=Y;}}if(R.adjustDeepPath){R.deepPath=R.adjustDeepPath({deepPath:$||R.functionTarget,response:p({},i)});}else if(!$){R.deepPath=R.functionTarget;}if(X&&R.contentID){X[R.contentID].deepPath=R.deepPath;}}if(Z&&m1===undefined&&i){this._parseResponse(i,R);L.fatal(this+" - No data was retrieved by service: '"+i.requestUri+"'");n1.fireRequestCompleted({url:i.requestUri,type:"GET",async:i.async,info:"Accept headers:"+this.oHeaders["Accept"],infoObject:{acceptHeaders:this.oHeaders["Accept"]},success:false});return false;}if(m1&&!m1.__metadata&&m1.results&&!Array.isArray(m1.results)){m1=m1.results;}if(!i._imported&&m1&&(Array.isArray(m1)||typeof m1=='object')){d1=p({},m1);if(R.key||R.created){n1._importData(d1,l1,i,undefined,undefined,undefined,e1);}else{n1._importData(d1,l1,i,h1,R.deepPath,undefined,e1);}i._imported=true;}a1=this._getEntity(R.key);if(l1&&a1&&a1.__metadata.created&&a1.__metadata.created.functionImport){var o1=[];var p1=a1["$result"];if(p1&&p1.__list){h(l1,function(r1){o1.push(r1);});p1.__list=o1;}else if(p1&&p1.__ref){h(l1,function(r1){p1.__ref=r1;});}}if(!Z){g1=h1.split("/");if(g1[1]){k1[g1[1]]=R;var q1={};q1[g1[1]]=R.data;this._updateChangedEntities(q1);}if(R.method==="DELETE"&&g1[2]!=="$links"){this._removeEntity(g1[1]);}}if(Z&&R.method==="POST"||R.functionMetadata){if(b1){T[b1.entityType]=true;}if(R.key){if(R.created){var r1=this._getKey(m1);var s1=this.getContext("/"+R.key);$=R.deepPath;if(s1.isTransient()&&$.endsWith(")")){R.deepPath=$.slice(0,$.lastIndexOf("("))+r1.slice(r1.indexOf("("));}this._updateContext(s1,'/'+r1,R.deepPath);s1.setUpdated(true);this.callAfterUpdate(function(){s1.setUpdated(false);});a1=this._getEntity(r1);if(a1){delete a1.__metadata.created;}this._removeEntity(R.key);}else{delete this.mChangedEntities[R.key];}}}this._parseResponse(i,R,l1,k1);l(k,l1);l(n,k1);this._updateETag(R,i);}if(j){j(m1,i);}var t1=this._createEventInfo(R,i,W);if(V){this.fireBatchRequestCompleted(t1);}else{this.fireRequestCompleted(t1);}return true;};
Q.prototype._processError=function(R,i,j,k,n){var T,V;if(R.functionMetadata){R.deepPath=R.functionTarget;}T=this._handleError(i,R);if(!k){V='/'+this.getKey(R.data);this.decreaseLaundering(V,R.data);this._decreaseDeferredRequestCount(R);}if(j){j(T);}var W=this._createEventInfo(R,T,n);if(k){this.fireBatchRequestCompleted(W);this.fireBatchRequestFailed(W);}else{this.fireRequestCompleted(W);this.fireRequestFailed(W);}};
Q.prototype._processAborted=function(R,i,j){var k,n;if(!j){n='/'+this.getKey(R.data);this.decreaseLaundering(n,R.data);this._decreaseDeferredRequestCount(R);}if(i){k=this._createEventInfo(R,Q._createAbortedError());k.success=false;if(j){this.fireBatchRequestCompleted(k);}else{this.fireRequestCompleted(k);}}};
Q.prototype._processAfterUpdate=function(){var j=this.aCallAfterUpdate;this.aCallAfterUpdate=[];for(var i=0;i<j.length;i++){j[i]();}};
Q.prototype._processChange=function(k,i,j,R){var T,V,W,X,Y,Z,$,a1,b1,c1,d1,e1,f1,g1=this;if(R&&this.mChangedEntities[k]&&this.mChangedEntities[k].__metadata){this.mChangedEntities[k].__metadata.deepPath=R;}else if(!R&&this.mChangedEntities[k]&&this.mChangedEntities[k].__metadata&&this.mChangedEntities[k].__metadata.deepPath){R=this.mChangedEntities[k].__metadata.deepPath;}W=this.oMetadata._getEntityTypeByPath(k);if(!j){j="MERGE";}b1=p({},this._getObject('/'+k,true),i);if(i.__metadata&&i.__metadata.created){$=i.__metadata.created.method?i.__metadata.created.method:"POST";k=i.__metadata.created.key;V=true;a1=i.__metadata.created;Y=i.__metadata.created.expandRequest;T=i.__metadata.created.contentID;if(i.__metadata.created.functionImport){a1.urlParameters=this._createFunctionImportParameters(i.__metadata.created.key,$,b1);b1=undefined;}else{delete b1.__metadata['uri'];}}else if(j==="MERGE"){$="MERGE";d1=this._getEntity(k);}else{$="PUT";}if(b1&&b1.__metadata){for(var n in b1.__metadata){if(n!=='type'&&n!=='uri'&&n!=='etag'&&n!=='content_type'&&n!=='media_src'){delete b1.__metadata[n];}}}if(b1&&W){var h1=this.oMetadata._getNavigationPropertyNames(W);h1.forEach(function(k1){delete b1[k1];});}if($==="MERGE"&&W&&d1){h(b1,function(k1,l1){if(k1!=='__metadata'){if(f(d1[k1],l1)&&!g1.isLaundering('/'+k+'/'+k1)){delete b1[k1];}}});var i1="/"+k,j1;h(b1,function(k1,l1){if(k1!=='__metadata'){j1=g1.getProperty(i1+"/"+k1+"/#@sap:unit");if(j1){if(b1[j1]===undefined){b1[j1]=d1[j1];}}}});if(d1.__metadata.etag){b1.__metadata.etag=d1.__metadata.etag;}}b1=this._removeReferences(b1);f1=a1&&a1.urlParameters?D._createUrlParamsArray(a1.urlParameters):undefined;Z=a1?this._getHeaders(a1.headers):this._getHeaders();X=a1&&a1.eTag?a1.eTag:this.getETag(b1);e1=this._createRequestUrl('/'+k,null,f1,this.bUseBatch);c1=this._createRequest(e1,R,$,Z,b1,X,undefined,true);if(V){c1.created=true;if(Y){c1.expandRequest=Y;c1.contentID=T;}if(i.__metadata.created.functionMetadata){c1.functionTarget=this.oMetadata._getCanonicalPathOfFunctionImport(i.__metadata.created.functionMetadata,a1.urlParameters);}}if(this.bUseBatch){c1.requestUri=c1.requestUri.replace(this.sServiceUrl+'/','');}return c1;};
Q.prototype._resolveGroup=function(k){var i,j,n,R,T,V;j=this.oMetadata._getEntityTypeByPath(k);V=this._getObject('/'+k);if(V){n=V.__metadata.created;if(n){return{groupId:n.groupId,changeSetId:n.changeSetId};}}if(this.mChangeGroups[j.name]){i=this.mChangeGroups[j.name];R=i.groupId;T=i.single?u():i.changeSetId;}else if(this.mChangeGroups['*']){i=this.mChangeGroups['*'];R=i.groupId;T=i.single?u():i.changeSetId;}return{groupId:R,changeSetId:T};};
Q.prototype._updateETag=function(R,i){var j,k,n;j=R.requestUri.replace(this.sServiceUrl+'/','');if(!j.startsWith("/")){j="/"+j;}k=this._getObject(j.split("?")[0],undefined,true);n=this._getHeader("etag",i.headers);if(k&&k.__metadata&&n){k.__metadata.etag=n;}};
Q.prototype._handleError=function(i,R){var T,j={message:i.message};if(i.response){if(!i.$reported){this._parseResponse(i.response,R);if(this.bTokenHandling){T=this._getHeader("x-csrf-token",i.response.headers);if(i.response.statusCode=='403'&&T&&T.toLowerCase()==="required"){this.resetSecurityToken();}}}j.statusCode=i.response.statusCode;j.statusText=i.response.statusText;j.headers=i.response.headers;j.responseText=i.response.body;}else if(!i.$reported){L.error("The following problem occurred: "+i.message,undefined,K);}i.$reported=true;return j;};
Q.prototype.getData=function(i,j,k){return this.getProperty(i,j,k);};
Q.prototype._getODataHandler=function(i){if(i.indexOf("$batch")>-1){return H.batchHandler;}else if(i.indexOf("$count")>-1){return undefined;}else if(this.bJSON){return H.jsonHandler;}else{return H.atomHandler;}};
Q.prototype.getETag=function(i,j,k){if(typeof i=="object"){k=i;i="";}return this._getETag(i,j,k);};
Q.prototype._getETag=function(i,j,k){if(!k||!k.__metadata){k=this._getObject(i,j);}if(k&&k.__metadata){return k.__metadata.etag;}return null;};
Q.prototype.forceEntityUpdate=function(k){var i=this.mChangedEntities[k];if(i&&i.__metadata){i.__metadata.etag='*';}else{L.error(this+" - Entity with key "+k+" does not exist or has no change");}};
Q.prototype._createRequest=function(i,j,k,n,R,T,V,W){var X;V=V!==false;if(T&&k!=="GET"){n["If-Match"]=T;}if(!n["Content-Type"]&&k!=="DELETE"&&k!=="GET"){if(this.bJSON){n["Content-Type"]="application/json";}else{n["Content-Type"]="application/atom+xml";}}if(i.indexOf("$count")>-1){n["Accept"]="text/plain, */*;q=0.5";}if(k==="MERGE"&&!this.bUseBatch){n["x-http-method"]="MERGE";k="POST";}if(this.sMessageScope===w.BusinessObject){if(this.bIsMessageScopeSupported){n["sap-message-scope"]=this.sMessageScope;}else{L.error("Message scope 'sap.ui.model.odata.MessageScope.BusinessObject' is not"+" supported by the service: "+this.sServiceUrl,undefined,K);}}W=W&&this.sMessageScope===w.BusinessObject&&this.bIsMessageScopeSupported;if(this.bUseBatch&&k!=="GET"&&k!=="HEAD"&&!n["Content-ID"]){n["Content-ID"]=u();}X={headers:n,requestUri:i,method:k,user:this.sUser,password:this.sPassword,async:V,deepPath:j,updateAggregatedMessages:W};if(R){X.data=R;}if(this.bWithCredentials){X.withCredentials=this.bWithCredentials;}X.requestID=this._createRequestID();return X;};
Q.prototype._processRequest=function(i,j,k){var R,n,T=false,V=this;if(this.bWarmup){return{abort:function(){}};}if(k){this.iPendingDeferredRequests+=1;}n={abort:function(){if(k&&!T){V.iPendingDeferredRequests-=1;}if(!T&&j){j(Q._createAbortedError());}if(R){R._aborted=true;if(R._handle){R._handle.abort();}}T=true;}};this.oMetadata.loaded().then(function(){R=i(n);if(R){R.deferred=!!k;}V._processRequestQueueAsync(V.mRequests);if(T){n.abort();}});return n;};
Q.prototype.update=function(i,j,k){var n,R,T,V,W,X,Y,Z,$,a1,b1,c1,d1,e1,f1,g1=this,h1,i1,j1;if(k){Z=k.groupId||k.batchGroupId;$=k.changeSetId;W=k.context;n=k.success;R=k.error;X=k.eTag;b1=k.headers;a1=k.urlParameters;e1=k.refreshAfterChange;j1=k.canonicalRequest;if(k.merge!==undefined){c1=k.merge?"MERGE":"PUT";}}j1=this._isCanonicalRequestNeeded(j1);f1=Z in g1.mDeferredGroups;e1=this._getRefreshAfterChange(e1,Z);Y=D._createUrlParamsArray(a1);b1=this._getHeaders(b1);c1=c1?c1:this.sDefaultUpdateMethod;X=X||this._getETag(i,W,j);h1=this._normalizePath(i,W,j1);i1=this.resolveDeep(i,W);return this._processRequest(function(k1){V=g1._createRequestUrlWithNormalizedPath(h1,Y,g1.bUseBatch);T=g1._createRequest(V,i1,c1,b1,j,X);d1=g1.mRequests;if(f1){d1=g1.mDeferredRequests;}g1._pushToRequestQueue(d1,Z,$,T,n,R,k1,e1);return T;},R,f1);};
Q.prototype.create=function(i,j,k){var R,n,T,V,W,X,Y,Z,$,a1,b1,c1,d1,e1,f1,g1,h1=this,i1,j1,k1;if(k){V=k.context;Y=k.urlParameters;W=k.success;X=k.error;c1=k.groupId||k.batchGroupId;e1=k.changeSetId;b1=k.eTag;$=k.headers;f1=k.refreshAfterChange;k1=k.canonicalRequest;}k1=this._isCanonicalRequestNeeded(k1);f1=this._getRefreshAfterChange(f1,c1);a1=D._createUrlParamsArray(Y);$=this._getHeaders($);d1="POST";g1=c1 in h1.mDeferredGroups;i1=h1._normalizePath(i,V,k1);j1=this.resolveDeep(i,V);return this._processRequest(function(l1){n=h1._createRequestUrlWithNormalizedPath(i1,a1,h1.bUseBatch);R=h1._createRequest(n,j1,d1,$,j,b1);R.created=true;T=h1.oMetadata._getEntityTypeByPath(i1);R.entityTypes={};if(T){R.entityTypes[T.entityType]=true;}Z=h1.mRequests;if(g1){Z=h1.mDeferredRequests;}h1._pushToRequestQueue(Z,c1,e1,R,W,X,l1,f1);return R;},X,g1);};
Q.prototype.remove=function(i,j){var k,n,R,T,V,W,X,Y,Z,$,a1,b1,c1,d1,e1,f1,g1,h1,i1,j1=this.bCanonicalRequests,k1=this;if(j){Y=j.groupId||j.batchGroupId;k=j.changeSetId;n=j.context;f1=j.success;W=j.error;X=j.eTag;Z=j.headers;i1=j.urlParameters;c1=j.refreshAfterChange;j1=j.canonicalRequest;}j1=this._isCanonicalRequestNeeded(j1);c1=this._getRefreshAfterChange(c1,Y);h1=D._createUrlParamsArray(i1);Z=this._getHeaders(Z);a1="DELETE";X=X||this._getETag(i,n);V=Y in k1.mDeferredGroups;b1=this._normalizePath(i,n,j1);T=this.resolveDeep(i,n);function l1(m1,n1){k1._removeEntity($);if(R&&R.isTransient()===false){k1.oCreatedContextsCache.findAndRemoveContext(R);}if(f1){f1(m1,n1);}}return this._processRequest(function(m1){g1=k1._createRequestUrlWithNormalizedPath(b1,h1,k1.bUseBatch);$=g1.substr(g1.lastIndexOf('/')+1);$=$.split("?")[0];R=k1.mContexts["/"+$];d1=k1._createRequest(g1,T,a1,Z,undefined,X,undefined,true);e1=k1.mRequests;if(V){e1=k1.mDeferredRequests;}k1._pushToRequestQueue(e1,Y,k,d1,l1,W,m1,c1);return d1;},W,V);};
Q.prototype.callFunction=function(i,j){var k,n,R,T,V,W,X,Y,Z,$,a1,b1,c1,d1,e1=this;if(!i.startsWith("/")){L.fatal("callFunction: sFunctionName has to be absolute, but the given '"+i+"' is not absolute",this,K);return undefined;}j=j||{};k=j.changeSetId;R=j.error;T=j.eTag;V=j.expand;W=j.groupId||j.batchGroupId;X=j.headers;Y=j.method||"GET";Z=j.refreshAfterChange;c1=j.success;d1=Object.assign({},j.urlParameters);if(V){if(!this.bUseBatch){throw new Error("Use 'expand' parameter only with 'useBatch' set to 'true'");}if(Y!=="POST"){throw new Error("Use 'expand' parameter only with HTTP method 'POST'");}}Z=this._getRefreshAfterChange(Z,W);n=new Promise(function(f1,g1){b1=f1;$=g1;});a1=this._processRequest(function(f1){var g1,h1,i1,j1,k1,l1,m1,n1,o1,p1,q1,r1={},s1=R,t1=false,u1=c1;i1=e1.oMetadata._getFunctionImportMetadata(i,Y);if(!i1){L.error("Function '"+i+"' not found in the metadata",e1,K);$();return undefined;}if(i1.entitySet||i1.entitySetPath){r1.$result={__list:[]};if(i1.returnType&&!i1.returnType.startsWith("Collection")){r1.$result={__ref:{}};}}if(V&&(!r1.$result||!r1.$result.__ref)){$(new Error("Use 'expand' parameter only for functions returning a single"+" entity"));return undefined;}if(i1.parameter!=null){i1.parameter.forEach(function(v1){r1[v1.name]=e1._createPropertyValue(v1.type);if(d1[v1.name]!==undefined){r1[v1.name]=d1[v1.name];d1[v1.name]=D.formatValue(d1[v1.name],v1.type);}else{L.warning("No value given for parameter '"+v1.name+"' of function import '"+i+"'",e1,K);}});}o1=u();if(V){X=Object.assign({},X,{"Content-ID":o1,"sap-messages":"transientOnly"});c1=function(r1,v1){if(!k1){k1=r1;j1=v1;return;}if(u1){r1=Object.assign({},k1,r1);u1(r1,j1);}};R=function(v1){if(k1){j1.expandAfterFunctionCallFailed=true;v1.expandAfterFunctionCallFailed=true;L.error("Function '"+i+"' was called successfully, but"+" expansion of navigation properties ("+V+") failed",v1,K);if(u1){u1(k1,j1);}return;}if(!t1){t1=true;if(s1){s1(v1);}}else{v1.expandAfterFunctionCallFailed=true;}};}r1.__metadata={uri:e1.sServiceUrl+i+"('"+o1+"')",created:{changeSetId:k,error:R,eTag:T,functionImport:true,groupId:W,headers:Object.assign({},X),key:i.substring(1),method:Y,success:c1}};l1=e1._addEntity(r1);g1=e1.getContext("/"+l1);e1._writePathCache("/"+l1,"/"+l1);b1(g1);q1=D._createUrlParamsArray(d1);p1=e1._createRequestUrlWithNormalizedPath(i,q1,e1.bUseBatch);m1=e1._createRequest(p1,i,Y,e1._getHeaders(X),undefined,T,undefined,true);m1.adjustDeepPath=j.adjustDeepPath;m1.functionMetadata=i1;r1.__metadata.created.functionMetadata=i1;m1.functionTarget=e1.oMetadata._getCanonicalPathOfFunctionImport(i1,d1);m1.key=l1;if(V){h1=e1._createRequest("$"+o1+"?"+D._encodeURLParameters({$expand:V,$select:V}),"/$"+o1,"GET",e1._getHeaders(undefined,true),undefined,undefined,undefined,true);h1.contentID=o1;m1.expandRequest=h1;m1.contentID=o1;}n1=e1.mRequests;if(W in e1.mDeferredGroups){n1=e1.mDeferredRequests;}e1._pushToRequestQueue(n1,W,k,m1,c1,R,f1,Z);return m1;},R);a1.contextCreated=function(){return n;};return a1;};
Q.prototype._createFunctionImportParameters=function(i,j,k){var n=g({},k);delete n.__metadata;delete n["$result"];var R=this.oMetadata._getFunctionImportMetadata(i,j);d(R,this+": Function "+i+" not found in the metadata !");if(!R){return undefined;}if(R.parameter!=null){h(R.parameter,function(T,V){if(n&&n[V.name]!==undefined){n[V.name]=D.formatValue(n[V.name],V.type);}});}return n;};
Q.prototype._getResourcePath=function(i,j,k,n){var R,T,V,W;if(!i){return this.resolve(k,n);}V=this.oMetadata._splitByLastNavigationProperty(j);T=V.pathBeforeLastNavigationProperty;R=V.lastNavigationProperty;if(R.includes("(")&&V.addressable){W=this.resolve(T+R,undefined,true);if(W){return W+V.pathAfterLastNavigationProperty;}}W=this.resolve(T,undefined,true)||T;return W+R+V.pathAfterLastNavigationProperty;};
Q.prototype.read=function(i,j){var k,n,R,T,V,W,X,Y,Z,$,a1,b1,c1,d1,e1=this;if(j){k=j.canonicalRequest;n=j.context;R=j.error;V=j.filters;W=j.groupId||j.batchGroupId;X=j.headers;$=j.sorters;a1=j.success;b1=j.updateAggregatedMessages;d1=j.urlParameters;}k=this._isCanonicalRequestNeeded(k);if(i&&i.indexOf('?')!==-1){i=i.slice(0,i.indexOf('?'));}if(this.sRefreshGroupId){W=this.sRefreshGroupId;}c1=D._createUrlParamsArray(d1);X=this._getHeaders(X,true);Y="GET";T=this._getETag(i,n);var f1={abort:function(){if(Z){Z._aborted=true;}}};function g1(h1){var i1,j1,k1,l1,m1,n1,o1=e1.resolveDeep(i,n),p1=e1._getResourcePath(k,o1,i,n);m1=D.createSortParams($);if(m1){c1.push(m1);}i1=e1.oMetadata._getEntityTypeByPath(p1);j1=F.groupFilters(V);k1=D.createFilterParams(j1,e1.oMetadata,i1);if(k1){c1.push(k1);}n1=e1._createRequestUrlWithNormalizedPath(p1,c1,e1.bUseBatch);Z=e1._createRequest(n1,o1,Y,X,null,T,undefined,b1);l1=e1.mRequests;if(W in e1.mDeferredGroups){l1=e1.mDeferredRequests;}e1._pushToRequestQueue(l1,W,null,Z,a1,R,h1,false);return Z;}if(this.bUseBatch&&this.bIncludeInCurrentBatch){Z=g1(f1);return f1;}else{return this._processRequest(g1,R);}};
Q.prototype.getServiceMetadata=function(){if(this.oMetadata&&this.oMetadata.isLoaded()){return this.oMetadata.getServiceMetadata();}return undefined;};
Q.prototype.metadataLoaded=function(R){var i=this.oMetadata.loaded(R);if(this.bLoadAnnotationsJoined){if(R){return Promise.all([i,this.pAnnotationsLoaded]);}var j=function(){return i;};return this.pAnnotationsLoaded.then(j,j);}else{return i;}};
Q.prototype.annotationsLoaded=function(){return this.pAnnotationsLoaded;};
Q.prototype.isMetadataLoadingFailed=function(){return this.oMetadata.isFailed();};
Q.prototype.getServiceAnnotations=function(){var i=this.oAnnotations.getData();return m(i)?null:i;};
Q.prototype.onAnnotationsFailed=function(i){this.fireAnnotationsFailed(i.getParameters());};
Q.prototype.onAnnotationsLoaded=function(i){this.fireAnnotationsLoaded(i.getParameters());};
Q.prototype.addAnnotationUrl=function(i){var j=[].concat(i),k=[],n=[],R=[],T=this;j.forEach(function(V){var W=V.indexOf("$metadata");if(W>=0){V=T._createMetadataUrl(V);k.push(V);}else{n.push(V);}});return this.oMetadata._addUrl(k).then(function(V){return Promise.all(V.map(function(W){R=R.concat(W.entitySets);return T.oAnnotations.addSource({type:"xml",data:W["metadataString"]});}));}).then(function(){return T.oAnnotations.addSource(n);}).then(function(V){return{annotations:T.oAnnotations.getData(),entitySets:R};});};
Q.prototype.addAnnotationXML=function(X,i){return this.oAnnotations.addSource({type:"xml",data:X});};
Q.prototype.submitChanges=function(j){var k,n,R,T,V,W,X,Y=false,Z=this.bRefreshAfterChange,$=this;if(j){R=j.groupId||j.batchGroupId;X=j.success;n=j.error;if(j.merge!==undefined){T=j.merge?"MERGE":"PUT";}}if(R&&!this.mDeferredGroups[R]){L.fatal(this+" submitChanges: \""+R+"\" is not a deferred group!");}k=p({},$.mChangedEntities);this.oMetadata.loaded().then(function(){var a1,b1,c1,i,d1,e1;h(k,function(f1,g1){var h1,i1,j1,k1=$._resolveGroup(f1);if(k1.groupId===R||!R){i1=$._processChange(f1,g1,T||$.sDefaultUpdateMethod);i1.key=f1;h1=g1.__metadata&&g1.__metadata.created?g1.__metadata.created:{};j1={abort:function(){i1._aborted=true;}};if(k1.groupId in $.mDeferredGroups){$._pushToRequestQueue($.mDeferredRequests,k1.groupId,k1.changeSetId,i1,h1.success,h1.error,j1,h1.refreshAfterChange===undefined?Z:h1.refreshAfterChange);}}});for(d1 in $.mDeferredRequests){e1=$.mDeferredRequests[d1];for(c1 in e1.changes){b1=e1.changes[c1];for(i=b1.length-1;i>=0;i--){a1=b1[i];if(a1.bRefreshAfterChange===undefined){a1.bRefreshAfterChange=Z;}}}}W=$._processRequestQueue($.mDeferredRequests,R,X,n);if(Y){V.abort();}if(Array.isArray(W)&&W.length==0&&X){X({},undefined);}});V={abort:function(){if(W){if(Array.isArray(W)){W.forEach(function(V){V.abort();});}else{W.abort();}}else{Y=true;}}};return V;};
Q.prototype._updateChangedEntities=function(i){var j=this,R,k,n;function T(V,W,X){h(W,function(Y){var Z=X+'/'+Y;if(o(W[Y])&&o(V[Y])){T(V[Y],W[Y],Z);if(m(W[Y])){delete W[Y];}}else if(X.endsWith("__metadata")||f(W[Y],V[Y])&&!j.isLaundering(Z)){delete W[Y];if(X===R){k=j.oMetadata._getEntityTypeByPath(R);n=k&&j.oMetadata._getNavPropertyRefInfo(k,Y);if(n&&W[n.name]){V[n.name]=W[n.name];delete W[n.name];}}}});}h(i,function(V,W){if(V in j.mChangedEntities){var X=j._getObject('/'+V,null,true);var Y=j._getObject('/'+V);p(X,W);R='/'+V;var Z=j.removeInternalMetadata(Y).deepPath;T(X,Y,R);if(m(Y)){delete j.mChangedEntities[V];j.abortInternalRequest(j._resolveGroup(V).groupId,{requestKey:V});}else{j.mChangedEntities[V]=Y;Y.__metadata={deepPath:Z};l(Y.__metadata,X.__metadata);}}});};
Q.prototype._discardEntityChanges=function(k,i,j){var n=j&&j.created,R=true,T=this._resolveGroup(k).groupId,V=this.oMetadata.loaded(),W=this;V.then(function(){W.abortInternalRequest(T,{requestKey:k});});if(i&&n){this.oCreatedContextsCache.findAndRemoveContext(this.mContexts["/"+k]);this._removeEntity(k);if(n.abort){n.abort(Q._createAbortedError());}R=false;}else{delete this.mChangedEntities[k];}sap.ui.getCore().getMessageManager().removeMessages(this.getMessagesByEntity(k,R));return V;};
Q.prototype.resetChanges=function(j,k,n){var R=this.oMetadata.loaded(),T=this;if(k){R.then(function(){h(T.mDeferredGroups,function(i){if(j){j.forEach(function(V){T.abortInternalRequest(i,{path:V.substring(1)});});}else{T.abortInternalRequest(i);}});});}if(j){h(j,function(V,W){var X,Y,i,Z,$,a1,b1={};if(T.getEntityByPath(W,null,b1)){a1=b1.propertyPath.split("/");$=a1[a1.length-1];Z=b1.key;X=T.mChangedEntities[Z];if(X){for(i=0;i<a1.length-1;i+=1){if(X&&X.hasOwnProperty(a1[i])){X=X[a1[i]];}else{X=undefined;break;}}if(X&&X.hasOwnProperty($)){delete X[$];}Y=T.mChangedEntities[Z].__metadata;delete T.mChangedEntities[Z].__metadata;if(m(T.mChangedEntities[Z])||!b1.propertyPath){T._discardEntityChanges(Z,n,Y);}else{T.mChangedEntities[Z].__metadata=Y;}}}});}else{h(this.mChangedEntities,function(i,V){T._discardEntityChanges(i,n,V.__metadata);});}this.checkUpdate(true);return R;};
Q.prototype.setProperty=function(j,V,k,n){var R,T,W,X,Y,Z,$,a1,b1,c1,d1,e1,f1,g1,h1,i1,j1,k1,l1,m1,n1,o1,p1,q1={},r1={},s1=false,t1=this;function u1(w1,x1){h(x1,function(c1){if(o(x1[c1])&&o(w1[c1])){u1(w1[c1],x1[c1]);if(m(x1[c1])){delete x1[c1];}}else if(f(x1[c1],w1[c1])){delete x1[c1];}});}p1=this.resolve(j,k);X=this.resolveDeep(j,k);$=this.getEntityByPath(p1,null,r1);if(!$){return false;}j1=p1.substring(p1.lastIndexOf("/")+1);c1=r1.key;f1=this._getObject('/'+c1,null,true);g1=this._getObject(j,k,true);if(!this.mChangedEntities[c1]){Y=$.__metadata;$={};$.__metadata=Object.assign({},Y);if(r1.propertyPath.length>0){var v1=X.lastIndexOf(r1.propertyPath);$.__metadata.deepPath=X.substring(0,v1-1);}this.mChangedEntities[c1]=$;}T=this.mChangedEntities[c1];i1=r1.propertyPath.split("/");for(var i=0;i<i1.length-1;i++){if(!T.hasOwnProperty(i1[i])){T[i1[i]]={};}T=T[i1[i]];}s1=f1.__metadata.created&&f1.__metadata.created.functionImport;T[j1]=V;Z=this.oMetadata._getEntityTypeByPath(r1.key);e1=Z&&this.oMetadata._getNavPropertyRefInfo(Z,j1);b1=e1&&f1[e1.name]&&f1[e1.name].__ref;if(b1&&e1.keys.length===1){if(V===null){k1=null;}else{d1={};e1.keys.forEach(function(w1){d1[w1]=$[w1]!==undefined?$[w1]:f1[w1];});d1[e1.keys[0]]=V;k1=this.createKey(e1.entitySet,d1);}T[e1.name]={__ref:k1};}if(f(V,g1)&&!this.isLaundering('/'+c1)&&!s1){Y=this.mChangedEntities[c1].__metadata;W=Y&&Y.created;delete this.mChangedEntities[c1].__metadata;if(!W){u1(f1,this.mChangedEntities[c1]);}if(m(this.mChangedEntities[c1])){delete this.mChangedEntities[c1];q1[c1]=true;this.checkUpdate(false,n,q1);t1.oMetadata.loaded().then(function(){t1.abortInternalRequest(t1._resolveGroup(c1).groupId,{requestKey:c1});});return true;}this.mChangedEntities[c1].__metadata=Y;}a1=this._resolveGroup(c1);n1=this.mRequests;if(a1.groupId in this.mDeferredGroups){n1=this.mDeferredRequests;m1=this._processChange(c1,{__metadata:$.__metadata},this.sDefaultUpdateMethod);}else{m1=this._processChange(c1,this._getObject('/'+c1),this.sDefaultUpdateMethod);}m1.key=c1;h1=T.__metadata&&T.__metadata.created?T.__metadata.created:{};l1=this._getRefreshAfterChange(undefined,a1.groupId);if($.__metadata.created&&!$.__metadata.created.functionImport){R=this.oCreatedContextsCache.findCreatedContext(p1);if(R){R.activate();}}this.oMetadata.loaded().then(function(){o1={abort:function(){m1._aborted=true;}};t1._pushToRequestQueue(n1,a1.groupId,a1.changeSetId,m1,h1.success,h1.error,o1,l1);t1._processRequestQueueAsync(t1.mRequests);});q1[c1]=true;this.checkUpdate(false,n,q1);return true;};
Q.prototype._isHeaderPrivate=function(i){switch(i.toLowerCase()){case"accept":case"accept-language":case"maxdataserviceversion":case"dataserviceversion":return true;case"x-csrf-token":return this.bTokenHandling;case"sap-contextid-accept":case"sap-contextid":return!this.bDisableSoftStateHeader;default:return false;}};
Q.prototype.setHeaders=function(i){var j={},k=this;this.mCustomHeaders={};if(i){h(i,function(n,R){if(k._isHeaderPrivate(n)){L.warning(this+" - modifying private header: '"+n+"' not allowed!");}else{j[n]=R;}});this.mCustomHeaders=j;}if(this.oAnnotations){this.oAnnotations.setHeaders(this.mCustomHeaders);}};
Q.prototype._getHeaders=function(i,j){var k={},n=this;if(i){h(i,function(R,T){if(n._isHeaderPrivate(R)){L.warning(this+" - modifying private header: '"+R+"' not allowed!");}else{k[R]=T;}});}return l({'sap-cancel-on-close':!!j},this.mCustomHeaders,k,this.oHeaders);};
Q.prototype.getHeaders=function(){return l({},this.mCustomHeaders,this.oHeaders);};
Q.prototype._getHeader=function(i,j){var k;for(k in j){if(k.toLowerCase()===i.toLowerCase()){return j[k];}}return null;};
Q.prototype.hasPendingChanges=function(i){var j=!m(this.mChangedEntities);if(i){j=j||this.iPendingDeferredRequests>0;}return j;};
Q.prototype.hasPendingRequests=function(){return this.aPendingRequestHandles.length>0;};
Q.prototype.getPendingChanges=function(){return p({},this.mChangedEntities);};
Q.prototype.updateBindings=function(i){this.checkUpdate(i);};
Q.prototype.setTokenHandlingEnabled=function(T){this.bTokenHandling=T;};
Q.prototype.setUseBatch=function(i){this.bUseBatch=i;};
Q.prototype.formatValue=function(V,T){return D.formatValue(V,T);};
Q.prototype.deleteCreatedEntry=function(i){var j,k,n=this;if(i){k=i.getPath().substr(1);j=this._resolveGroup(k).groupId;n.oMetadata.loaded().then(function(){n.abortInternalRequest(j,{requestKey:k});});n._removeEntity(k);sap.ui.getCore().getMessageManager().removeMessages(this.getMessagesByEntity(i.getPath(),true));}};
Q.prototype.createEntry=function(j,k){var n,R,T,V,W,X,Y,Z,$,a1,b1,c1,d1,e1,f1,g1,h1,i1,j1,k1,l1,m1,n1,o1={},p1="POST",q1=this;if(k){g1=k.properties;b1=k.groupId||k.batchGroupId;R=k.changeSetId;T=k.context;k1=k.success;Z=k.error;V=k.created;$=k.eTag;c1=k.headers;n1=k.urlParameters;h1=k.refreshAfterChange;n=k.canonicalRequest;a1=k.expand;d1=k.inactive;}if(a1&&!this.bUseBatch){throw new Error("The 'expand' parameter is only supported if batch mode is used");}n=this._isCanonicalRequestNeeded(n);c1=c1||{};h1=this._getRefreshAfterChange(h1,b1);b1=b1?b1:this.sDefaultChangeGroup;m1=D._createUrlParamsArray(n1);var r1={abort:function(){if(i1){i1._aborted=true;if(i1.expandRequest){i1.expandRequest._aborted=true;}}}};if(!j.startsWith("/")&&!T){j="/"+j;}f1=q1._normalizePath(j,T,n);Y=q1.resolveDeep(j,T);function s1(){var t1,u1,v1,w1,x1,y1,z1=false,A1=Z,B1=k1;var C1=q1.oMetadata._getEntityTypeByPath(f1);if(!C1){d(C1,"No Metadata for collection "+f1+" found");return undefined;}if(typeof g1==="object"&&!Array.isArray(g1)){o1=p({},g1);}else{for(var i=0;i<C1.property.length;i++){var D1=C1.property[i];var E1=(g1?g1.indexOf(D1.name):-1)>-1;if(!g1||E1){o1[D1.name]=q1._createPropertyValue(D1.type);if(E1){g1.splice(g1.indexOf(D1.name),1);}}}if(g1){d(g1.length===0,"No metadata for the following properties found: "+g1.join(","));}}w1=q1.oMetadata._getEntitySetByType(C1);y1=u();e1=w1.name+"('"+y1+"')";if(Y&&q1.oMetadata._isCollection(Y)){Y=Y+"('"+y1+"')";}if(a1){c1=Object.assign({},c1,{"Content-ID":y1,"sap-messages":"transientOnly"});k1=function(F1,G1){if(!t1){t1=F1;v1=G1;return;}if(B1){F1=Object.assign({},t1,F1);B1(F1,v1);}X();};Z=function(F1){if(t1){v1.expandAfterCreateFailed=true;F1.expandAfterCreateFailed=true;L.error("Entity creation was successful but expansion of navigation"+" properties failed",F1,K);if(B1){B1(t1,v1);}X();return;}if(!z1){z1=true;if(A1){A1(F1);}}else{F1.expandAfterCreateFailed=true;z1=false;}};}else{k1=function(F1,v1){if(B1){B1(F1,v1);}X();};}o1.__metadata={type:""+C1.entityType,uri:q1.sServiceUrl+'/'+e1,created:{changeSetId:R,error:Z,eTag:$,groupId:b1,headers:c1,key:f1.substring(1),refreshAfterChange:h1,success:k1,urlParameters:n1},deepPath:Y};W=new S(function(F1,G1){X=function(){if(!q1.oCreatedContextsCache.getCacheInfo(u1)){u1.resetCreatedPromise();}F1();};o1.__metadata.created.abort=G1;});W.catch(function(){});e1=q1._addEntity(p({},o1));if(!d1){q1.mChangedEntities[e1]=o1;}l1=q1._createRequestUrlWithNormalizedPath(f1,m1,q1.bUseBatch);i1=q1._createRequest(l1,Y,p1,c1,o1,$);if(a1){x1=q1._createRequest("$"+y1+"?"+D._encodeURLParameters({$expand:a1,$select:a1}),"/$"+y1,"GET",q1._getHeaders(undefined,true),null,undefined,undefined,true);x1.contentID=y1;i1.expandRequest=x1;i1.contentID=y1;o1.__metadata.created.expandRequest=x1;o1.__metadata.created.contentID=y1;}u1=q1.getContext("/"+e1,Y,W,d1);i1.key=e1;i1.created=true;j1=q1.mRequests;if(b1 in q1.mDeferredGroups){j1=q1.mDeferredRequests;}q1.oMetadata.loaded().then(function(){u1.fetchActivated().then(function(){q1._pushToRequestQueue(j1,b1,R,i1,k1,Z,r1,h1);q1._processRequestQueueAsync(q1.mRequests);});});return u1;}if(V){this.oMetadata.loaded().then(function(){V(s1());});}else if(this.oMetadata.isLoaded()){return s1();}else{L.error("Tried to use createEntry without created-callback, before metadata is "+"available!");}return undefined;};
Q.prototype._isCreatedEntity=function(i){return!!(i&&i.__metadata&&i.__metadata.created);};
Q.prototype._createPropertyValue=function(T){var j=this.oMetadata._splitName(T);var n=j.namespace;var k=j.name;if(n.toUpperCase()!=='EDM'){var R={};var V=this.oMetadata._getObjectMetadata("complexType",k,n);d(V,"Complex type "+T+" not found in the metadata !");for(var i=0;i<V.property.length;i++){var W=V.property[i];R[W.name]=this._createPropertyValue(W.type);}return R;}else{return this._getDefaultPropertyValue(k,n);}};
Q.prototype._getDefaultPropertyValue=function(T,n){return undefined;};
Q.prototype._normalizePath=function(i,j,k){if(i&&i.indexOf('?')!==-1){i=i.substr(0,i.indexOf('?'));}if(!j&&!i.startsWith("/")){L.fatal(this+" path "+i+" must be absolute if no Context is set");}return this.resolve(i,j,k)||this.resolve(i,j);};
Q.prototype.getRefreshAfterChange=function(){return this.bRefreshAfterChange;};
Q.prototype.setRefreshAfterChange=function(R){this.bRefreshAfterChange=R;};
Q.prototype.isList=function(i,j){i=this.resolve(i,j);return i&&i.substr(i.lastIndexOf("/")).indexOf("(")===-1;};
Q.prototype._isMetadataPath=function(i){var j=false;if(i&&i.indexOf('/#')>-1){j=true;}return j;};
Q.prototype.isMetaModelPath=function(i){return i.indexOf("##")==0||i.indexOf("/##")>-1;};
Q.prototype._request=function(R,i,j,k,n,T){var V;if(this.bDestroyed){return{abort:function(){}};}var W=this;function X(Y){return function(){if(W.aPendingRequestHandles){var Z=W.aPendingRequestHandles.indexOf(V);if(Z>-1){W.aPendingRequestHandles.splice(Z,1);}}if(!(V&&V.bSuppressErrorHandlerCall)){Y.apply(this,arguments);}};}V=H.request(R,X(i||H.defaultSuccess),X(j||H.defaultError),k,n,T);if(R.async!==false){this.aPendingRequestHandles.push(V);}return V;};
Q.prototype.destroy=function(){this.bDestroyed=true;t.prototype.destroy.apply(this,arguments);if(this.aPendingRequestHandles){for(var i=this.aPendingRequestHandles.length-1;i>=0;i--){var R=this.aPendingRequestHandles[i];if(R&&R.abort){R.bSuppressErrorHandlerCall=true;R.abort();}}delete this.aPendingRequestHandles;}if(this.sMetadataLoadEvent){clearTimeout(this.sMetadataLoadEvent);}if(this.oMetadataFailedEvent){clearTimeout(this.oMetadataFailedEvent);}if(this.oMetadata){this.oMetadata.detachFailed(this.onMetadataFailed);if(!this.oMetadata.isLoaded()&&!this.oMetadata.hasListeners("loaded")){this.oMetadata.destroy();delete this.oSharedMetaData.oMetadata;}delete this.oMetadata;delete this.pMetadataLoaded;}if(this.oMetaModel){this.oMetaModel.destroy();delete this.oMetaModel;}if(this.oAnnotations){this.oAnnotations.detachSomeLoaded(this.onAnnotationsLoaded);this.oAnnotations.detachAllFailed(this.onAnnotationsFailed);this.oAnnotations.destroy();delete this.oAnnotations;delete this.pAnnotationsLoaded;}};
Q.prototype.setDeferredBatchGroups=function(i){this.setDeferredGroups(i);};
Q.prototype.setDeferredGroups=function(i){var j=this;this.mDeferredGroups={};h(i,function(k,n){j.mDeferredGroups[n]=n;});};
Q.prototype.getDeferredBatchGroups=function(){return this.getDeferredGroups();};
Q.prototype.getDeferredGroups=function(){return Object.keys(this.mDeferredGroups);};
Q.prototype.setChangeBatchGroups=function(i){h(i,function(j,k){k.groupId=k.batchGroupId;});this.setChangeGroups(i);};
Q.prototype.setChangeGroups=function(i){this.mChangeGroups=i;};
Q.prototype.getChangeBatchGroups=function(){return this.getChangeGroups();};
Q.prototype.getChangeGroups=function(){return this.mChangeGroups;};
Q.prototype.setMessageParser=function(i){if(!(i instanceof r)){L.error("Given MessageParser is not of type sap.ui.core.message.MessageParser");return this;}i.setProcessor(this);this.oMessageParser=i;return this;};
Q.prototype._parseResponse=function(R,i,j,k){try{if(!this.oMessageParser){this.oMessageParser=new z(this.sServiceUrl,this.oMetadata,!!this.bPersistTechnicalMessages);this.oMessageParser.setProcessor(this);}this.oMessageParser.parse(R,i,j,k,this.bIsMessageScopeSupported);}catch(n){L.error("Error parsing OData messages: "+n);}};
Q.prototype.callAfterUpdate=function(i){this.aCallAfterUpdate.push(i);};
Q.prototype.getMetaModel=function(){var i=this;if(!this.oMetaModel){this.oMetaModel=new y(this.oMetadata,this.oAnnotations,this);this.oMetaModel.loaded().then(function(){i.bMetaModelLoaded=true;i.checkUpdate(false,false,null,true);},function(j){var k=j.message,n;if(!k&&j.xmlDoc&&j.xmlDoc.parseError){k=j.xmlDoc.parseError.reason;n=j.xmlDoc.parseError.srcText;}L.error("error in ODataMetaModel.loaded(): "+k,n,K);});}return this.oMetaModel;};
Q.prototype.getOriginalProperty=function(i,j){return this._getObject(i,j,true);};
Q.prototype.getEntityByPath=function(i,j,k){var n,R=t.prototype.resolve.call(this,i,j);if(!R){return null;}var T=R.split("/"),V=null,W=[];while(T.length>0){var X=T.join("/"),Y=this._getObject(X);if(o(Y)){n=this._getKey(Y);if(n){V=Y;break;}}W.unshift(T.pop());}if(V){k.propertyPath=W.join("/");k.key=n;return V;}return null;};
Q.prototype.resolveFromCache=function(i){if(!this.mPathCache){return undefined;}var j,k="",n,R,T;n=this.mPathCache[i]?this.mPathCache[i].canonicalPath:undefined;if(i&&n!==i){j=n||i;if(!n){T=j.lastIndexOf("/");k=j.substr(T);j=j.substr(0,T);}R=this.resolveFromCache(j);if(R&&R!==j){n=R+k;}}return n;};
Q.prototype.resolve=function(i,j,k){var R=t.prototype.resolve.call(this,i,j);if(R&&!this._isMetadataPath(R)&&k){var n=this.resolveFromCache(R);if(!n){n=this.oMetadata._calculateCanonicalPath(R);n=this.resolveFromCache(n)||n;}this._writePathCache(R,n);return n;}return R;};
Q.prototype.resolveDeep=function(i,j){var R=t.prototype.resolve.call(this,i,j);if(i&&!i.startsWith("/")){R=j?j.sDeepPath+'/'+i:R;}if(i===""){R=j?j.sDeepPath:R;}return R;};
Q.prototype.isLaundering=function(i,j){var R=this.resolve(i,j);return(R in this.mLaunderingState)&&this.mLaunderingState[R]>0;};
Q.prototype.increaseLaundering=function(i,j){if(!o(j)){return;}for(var n in j){if(n==="__metadata"){continue;}var k=j[n];if(o(k)){this.increaseLaundering(i+"/"+n,k);}else{var T=i+"/"+n;if(!(T in this.mLaunderingState)){this.mLaunderingState[T]=0;}this.mLaunderingState[T]++;}}if(!(i in this.mLaunderingState)){this.mLaunderingState[i]=0;}this.mLaunderingState[i]++;};
Q.prototype.decreaseLaundering=function(i,j){if(!o(j)){return;}for(var n in j){if(n==="__metadata"){continue;}var k=j[n],T=i+"/"+n;if(o(k)){this.decreaseLaundering(T,k);}else if(T in this.mLaunderingState){this.mLaunderingState[T]--;if(this.mLaunderingState[T]===0){delete this.mLaunderingState[T];}}}this.mLaunderingState[i]--;if(this.mLaunderingState[i]===0){delete this.mLaunderingState[i];}};
Q.prototype._getRefreshAfterChange=function(R,i){if(R===undefined&&!(i in this.mDeferredGroups)){return this.bRefreshAfterChange;}return R;};
Q.prototype.getMessagesByEntity=function(j,k){var n=j,R=[],T;function V(R){var W=[];for(var i=0;i<R.length;i++){if(!k||(k&&!R[i].persistent)){W.push(R[i]);}}return W;}if(!n.startsWith('/')){n='/'+n;}if(this.mMessages){for(T in this.mMessages){if(typeof n=="string"&&n.length>0&&T.startsWith(n)){R=R.concat(V(this.mMessages[T]));}}return R;}return null;};
Q.prototype._cacheSupported=function(i){var j=/\/~[\w\-]+~[A-Z0-9]?/;var k=[i];if(this.sAnnotationURI){if(!Array.isArray(this.sAnnotationURI)){this.sAnnotationURI=[this.sAnnotationURI];}k=k.concat(this.sAnnotationURI);}k=k.filter(function(n){return n.indexOf("sap-context-token")===-1;});k=k.filter(function(n){return!j.test(n);});return k.length===0?true:false;};
Q.prototype._getAnnotationCacheKey=function(i){var j;if(this.bUseCache){if(!this.bSkipMetadataAnnotationParsing){j=i+"#annotations";}if(this.sAnnotationURI){if(!Array.isArray(this.sAnnotationURI)){this.sAnnotationURI=[this.sAnnotationURI];}this.sAnnotationURI=this.sAnnotationURI.map(function(k){return k+"#annotations";});j=this.bSkipMetadataAnnotationParsing?this.sAnnotationURI.join("_"):j+"_"+this.sAnnotationURI.join("_");}}return j;};
Q.prototype.canonicalRequestsEnabled=function(){return this.bCanonicalRequests;};
Q.prototype._decreaseDeferredRequestCount=function(R){if(R.deferred){this.iPendingDeferredRequests--;}};
Q.prototype.enableCanonicalRequests=function(i){this.bCanonicalRequests=!!i;};
Q.prototype.getMessageScope=function(){return this.sMessageScope;};
Q.prototype.setMessageScope=function(i){if(i!==w.RequestedObjects&&i!==w.BusinessObject){throw new Error("Unsupported message scope: "+i);}this.sMessageScope=i;};
Q.prototype.messageScopeSupported=function(){var i=this;return this.metadataLoaded().then(function(){return i.bIsMessageScopeSupported;});};
Q.prototype.getContext=function(i,j,k,n){var R=this.mContexts[i];if(!R){R=this.mContexts[i]=new C(this,i,j,k,n);}else{R.setDeepPath(j||R.getDeepPath()||i);}return R;};
Q.prototype.hasContext=function(i){return this.mContexts[i];};
Q.prototype.removeInternalMetadata=function(i){var j,k,n,R,V;if(i&&i.__metadata){j=i.__metadata.created;k=i.__metadata.deepPath;n=i.__metadata.invalid;delete i.__metadata.created;delete i.__metadata.deepPath;delete i.__metadata.invalid;}for(R in i){V=i[R];if(Array.isArray(V)){V.forEach(Q.prototype.removeInternalMetadata);}else if(typeof V==="object"){Q.prototype.removeInternalMetadata(V);}}return{created:j,deepPath:k,invalid:n};};
Q.prototype._isCanonicalRequestNeeded=function(i){if(i!==undefined){return!!i;}else{return!!this.bCanonicalRequests;}};
Q.prototype.filterMatchingMessages=function(i,j){var k=this;return this.mMessages[i].filter(function(n){return k.isMessageMatching(n,j);});};
Q.prototype.isMessageMatching=function(i,j){var k=j.length;return i.aFullTargets.some(function(n){return n===j||n.startsWith(j)&&(j==="/"||n[k]==="/"||n[k]==="(");});};
Q.prototype.getMessages=function(i){return this.getMessagesByPath(i.sDeepPath,true).sort(M.compare);};
Q.prototype.getDeepPathForCanonicalPath=function(j){var k,R,T,V,W,i,n,X=j.slice(j.indexOf("("));W=this.aBindings.filter(function(Y){return(Y instanceof a||Y instanceof b)&&Y.isResolved();});for(i=0,n=W.length;i<n;i+=1){k=W[i];T=this.resolveDeep(k instanceof b?k.sPath+X:k.sPath,k.oContext);R=this.resolveFromCache(T);if(R===j){if(V&&V!==T){return undefined;}V=T;}}return V;};
Q.prototype.getPersistTechnicalMessages=function(){return this.bPersistTechnicalMessages;};
Q.prototype.setPersistTechnicalMessages=function(i){i=!!i;if(this.bPersistTechnicalMessages===i){return;}if(this.bPersistTechnicalMessages!==undefined){L.warning("The flag whether technical messages should always be treated as persistent"+" has been overwritten to "+i,undefined,K);}this.bPersistTechnicalMessages=i;if(this.oMessageParser){this.oMessageParser._setPersistTechnicalMessages(i);}};
Q.prototype.createCodeListModelParameters=function(i){i=i||{};return{defaultCountMode:v.None,disableSoftStateHeader:true,headers:i.headers&&Object.assign({},i.headers),json:i.json,metadataUrlParams:i.metadataUrlParams&&Object.assign({},i.metadataUrlParams),persistTechnicalMessages:i.persistTechnicalMessages,serviceUrl:this.sServiceUrl,serviceUrlParams:i.serviceUrlParams&&Object.assign({},i.serviceUrlParams),tokenHandling:false,useBatch:false,warmupUrl:i.warmupUrl};};
Q.prototype.getCodeListModelParameters=function(){return this.mCodeListModelParams;};
Q.prototype.getMetadataUrl=function(){return this.sMetadataUrl;};
Q._createAbortedError=function(){return{aborted:true,headers:{},message:"Request aborted",responseText:"",statusCode:0,statusText:"abort"};};
Q.prototype._getCreatedContextsCache=function(){return this.oCreatedContextsCache;};
return Q;});
sap.ui.predefine('sap/ui/model/odata/v2/ODataTreeBinding',["sap/base/assert","sap/base/Log","sap/base/util/deepExtend","sap/base/util/each","sap/base/util/includes","sap/base/util/isEmptyObject","sap/ui/model/ChangeReason","sap/ui/model/Context","sap/ui/model/Filter","sap/ui/model/FilterProcessor","sap/ui/model/FilterType","sap/ui/model/Sorter","sap/ui/model/SorterProcessor","sap/ui/model/TreeBinding","sap/ui/model/TreeBindingUtils","sap/ui/model/odata/CountMode","sap/ui/model/odata/ODataUtils","sap/ui/model/odata/OperationMode"],function(a,L,d,e,b,c,C,f,F,g,h,S,l,T,m,n,O,o){"use strict";
var p=T.extend("sap.ui.model.odata.v2.ODataTreeBinding",{constructor:function(M,P,i,v,j,s){T.apply(this,arguments);this.mParameters=this.mParameters||j||{};this.sGroupId=undefined;this.sRefreshGroupId=undefined;this.oFinalLengths={};this.oLengths={};this.oKeys={};this.bNeedsUpdate=false;this._bRootMissing=false;this.bSkipDataEvents=false;if(s instanceof S){s=[s];}this.aSorters=s||[];this.sFilterParams="";this.mNormalizeCache={};if(v instanceof F){v=[v];}this.aApplicationFilters=v;this.oModel.checkFilterOperation(this.aApplicationFilters);this.mRequestHandles={};this.oRootContext=null;this.iNumberOfExpandedLevels=(j&&j.numberOfExpandedLevels)||0;this.iRootLevel=(j&&j.rootLevel)||0;this.sCountMode=(j&&j.countMode)||this.oModel.sDefaultCountMode;if(this.sCountMode==n.None){L.fatal("To use an ODataTreeBinding at least one CountMode must be supported by the service!");}if(j){this.sGroupId=j.groupId||j.batchGroupId;}this.bInitial=true;this._mLoadedSections={};this._iPageSize=0;this.sOperationMode=(j&&j.operationMode)||this.oModel.sDefaultOperationMode;if(this.sOperationMode===o.Default){this.sOperationMode=o.Server;}this.bClientOperation=this.sOperationMode===o.Client;this.iThreshold=(j&&j.threshold)||0;this.bThresholdRejected=false;this.iTotalCollectionCount=null;this.bUseServersideApplicationFilters=(j&&j.useServersideApplicationFilters)||false;this.bUsePreliminaryContext=this.mParameters.usePreliminaryContext||M.bPreliminaryContext;this.oAllKeys=null;this.oAllLengths=null;this.oAllFinalLengths=null;}});
p.DRILLSTATES={Collapsed:"collapsed",Expanded:"expanded",Leaf:"leaf"};
p.prototype._getNodeFilterParams=function(P){var s=P.isRoot?this.oTreeProperties["hierarchy-node-for"]:this.oTreeProperties["hierarchy-parent-node-for"];var E=this._getEntityType();return O._createFilterParams(new F(s,"EQ",P.id),this.oModel.oMetadata,E);};
p.prototype._getLevelFilterParams=function(s,i){var E=this._getEntityType();return O._createFilterParams(new F(this.oTreeProperties["hierarchy-level-for"],s,i),this.oModel.oMetadata,E);};
p.prototype._loadSingleRootNodeByNavigationProperties=function(N,r){var t=this,G;if(this.mRequestHandles[r]){this.mRequestHandles[r].abort();}G=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;var A=this.getResolvedPath();if(A){this.mRequestHandles[r]=this.oModel.read(A,{groupId:G,success:function(D){var s=t._getNavPath(t.getPath());if(D){var E=D;var k=t.oModel._getKey(E);var i=t.oModel.getContext('/'+k);t.oRootContext=i;t._processODataObject(i.getObject(),N,s);}else{t._bRootMissing=true;}t.bNeedsUpdate=true;delete t.mRequestHandles[r];t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:D});});},error:function(E){if(E&&E.statusCode!=0&&E.statusText!="abort"){t.bNeedsUpdate=true;t._bRootMissing=true;delete t.mRequestHandles[r];t.fireDataReceived();}}});}};
p.prototype.getRootContexts=function(s,i,t){var N=null,r={numberOfExpandedLevels:this.iNumberOfExpandedLevels},R=[];if(this.isInitial()){return R;}s=s||0;i=i||this.oModel.sizeLimit;t=t||0;var j=""+N+"-"+s+"-"+this._iPageSize+"-"+t;if(this.bHasTreeAnnotations){this.bDisplayRootNode=true;R=this._getContextsForNodeId(null,s,i,t);}else{N=this.getResolvedPath();var I=this.oModel.isList(this.sPath,this.getContext());if(I){this.bDisplayRootNode=true;}if(this.bDisplayRootNode&&!I){if(this.oRootContext){return[this.oRootContext];}else if(this._bRootMissing){return[];}else{this._loadSingleRootNodeByNavigationProperties(N,j);}}else{r.navPath=this._getNavPath(this.getPath());if(!this.bDisplayRootNode){N+="/"+r.navPath;}R=this._getContextsForNodeId(N,s,i,t,r);}}return R;};
p.prototype.getNodeContexts=function(i,s,j,t){var N,r={};if(this.isInitial()){return[];}if(this.bHasTreeAnnotations){N=this.oModel.getKey(i);r.level=parseInt(i.getProperty(this.oTreeProperties["hierarchy-level-for"]))+1;}else{var k=this._getNavPath(i.getPath());if(!k){return[];}N=this.oModel.resolve(k,i);r.navPath=this.oNavigationPaths[k];}return this._getContextsForNodeId(N,s,j,t,r);};
p.prototype.hasChildren=function(i){var j;if(this.bHasTreeAnnotations){if(!i){return false;}var D=i.getProperty(this.oTreeProperties["hierarchy-drill-state-for"]);var N=this.oModel.getKey(i);j=this.oLengths[N];if(j===0&&this.oFinalLengths[N]){return false;}if(D==="expanded"||D==="collapsed"){return true;}else if(D==="leaf"){return false;}else{L.warning("The entity '"+i.getPath()+"' has not specified Drilldown State property value.");if(D===undefined||D===""){return true;}return false;}}else{if(!i){return this.oLengths[this.getPath()]>0;}j=this.oLengths[i.getPath()+"/"+this._getNavPath(i.getPath())];return j!==0;}};
p.prototype.getChildCount=function(i){if(this.bHasTreeAnnotations){var H;if(!i){H=null;}else{H=this.oModel.getKey(i);}return this.oLengths[H];}else{if(!i){if(!this.bDisplayRootNode){return this.oLengths[this.getPath()+"/"+this._getNavPath(this.getPath())];}else{return this.oLengths[this.getPath()];}}return this.oLengths[i.getPath()+"/"+this._getNavPath(i.getPath())];}};
p.prototype._getContextsForNodeId=function(N,s,j,t,r){var k=[],K;if(this.sOperationMode==o.Auto){if(this.iTotalCollectionCount==null){if(!this.bCollectionCountRequested){this._getCountForCollection();this.bCollectionCountRequested=true;}return[];}}s=s||0;j=j||this.oModel.iSizeLimit;t=t||0;if(this.sOperationMode==o.Auto){if(this.iThreshold>=0){t=Math.max(this.iThreshold,t);}}if(!this._mLoadedSections[N]){this._mLoadedSections[N]=[];}if(this.oFinalLengths[N]&&this.oLengths[N]<s+j){j=Math.max(this.oLengths[N]-s,0);}var q=this;var u=function(s){for(var i=0;i<q._mLoadedSections[N].length;i++){var Q=q._mLoadedSections[N][i];if(s>=Q.startIndex&&s<Q.startIndex+Q.length){return true;}}return false;};var M=[];var i=Math.max((s-t-this._iPageSize),0);if(this.oKeys[N]){var v=s+j+(t);if(this.oLengths[N]){v=Math.min(v,this.oLengths[N]);}for(i;i<v;i++){K=this.oKeys[N][i];if(!K){if(!this.bClientOperation&&!u(i)){M=m.mergeSections(M,{startIndex:i,length:1});}}if(i>=s&&i<s+j){if(K){k.push(this.oModel.getContext('/'+K));}else{k.push(undefined);}}}var B=Math.max((s-t-this._iPageSize),0);var E=s+j+(t);var w=M[0]&&M[0].startIndex===B&&M[0].startIndex+M[0].length===E;if(M.length>0&&!w){i=Math.max((M[0].startIndex-t-this._iPageSize),0);var x=M[0].startIndex;for(i;i<x;i++){K=this.oKeys[N][i];if(!K){if(!u(i)){M=m.mergeSections(M,{startIndex:i,length:1});}}}i=M[M.length-1].startIndex+M[M.length-1].length;var y=i+t+this._iPageSize;if(this.oLengths[N]){y=Math.min(y,this.oLengths[N]);}for(i;i<y;i++){K=this.oKeys[N][i];if(!K){if(!u(i)){M=m.mergeSections(M,{startIndex:i,length:1});}}}}}else if(!u(s)){var z=s-i;M=m.mergeSections(M,{startIndex:i,length:j+z+t});}if(this.oModel.getServiceMetadata()){if(M.length>0){var P=[];var A="";if(this.bHasTreeAnnotations){if(this.sOperationMode=="Server"||this.bUseServersideApplicationFilters){A=this.getFilterParams();}if(N){A=A?"%20and%20"+A:"";var D=this.oModel.getContext("/"+N);var G=D.getProperty(this.oTreeProperties["hierarchy-node-for"]);var H=this._getNodeFilterParams({id:G});P.push("$filter="+H+A);}else if(N==null){var I="";if(!this.bClientOperation||this.iRootLevel>0){var J=this.bClientOperation?"GE":"EQ";I=this._getLevelFilterParams(J,this.iRootLevel);}if(I||A){if(A&&I){A="%20and%20"+A;}P.push("$filter="+I+A);}}}else{A=this.getFilterParams();if(A){P.push("$filter="+A);}}if(this.sCustomParams){P.push(this.sCustomParams);}if(!this.bClientOperation){for(i=0;i<M.length;i++){var R=M[i];this._mLoadedSections[N]=m.mergeSections(this._mLoadedSections[N],{startIndex:R.startIndex,length:R.length});this._loadSubNodes(N,R.startIndex,R.length,0,P,r,R);}}else if(!this.oAllKeys&&!this.mRequestHandles[p.REQUEST_KEY_CLIENT]){this._loadCompleteTreeWithAnnotations(P);}}}return k;};
p.prototype._getCountForCollection=function(){if(!this.bHasTreeAnnotations||this.sOperationMode!=o.Auto){L.error("The Count for the collection can only be retrieved with Hierarchy Annotations and in OperationMode.Auto.");return;}var P=[];function _(D){var q=D.__count?parseInt(D.__count):parseInt(D);this.iTotalCollectionCount=q;if(this.sOperationMode==o.Auto){if(this.iTotalCollectionCount<=this.iThreshold){this.bClientOperation=true;this.bThresholdRejected=false;}else{this.bClientOperation=false;this.bThresholdRejected=true;}this._fireChange({reason:C.Change});}}function i(E){if(E&&E.statusCode===0&&E.statusText==="abort"){return;}var q="Request for $count failed: "+E.message;if(E.response){q+=", "+E.response.statusCode+", "+E.response.statusText+", "+E.response.body;}L.warning(q);}var A=this.getResolvedPath();var s="";if(this.iRootLevel>0){s=this._getLevelFilterParams("GE",this.getRootLevel());}var j="";if(this.bUseServersideApplicationFilters){j=this.getFilterParams();}if(s||j){if(j&&s){j="%20and%20"+j;}P.push("$filter="+s+j);}var k="";if(this.sCountMode==n.Request||this.sCountMode==n.Both){k="/$count";}else if(this.sCountMode==n.Inline||this.sCountMode==n.InlineRepeat){P.push("$top=0");P.push("$inlinecount=allpages");}if(A){this.oModel.read(A+k,{urlParameters:P,success:_.bind(this),error:i.bind(this),groupId:this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId});}};
p.prototype._getCountForNodeId=function(N){var t=this,G;var P=[];function _(D){t.oFinalLengths[N]=true;t.oLengths[N]=parseInt(D);}function i(E){if(E&&E.statusCode===0&&E.statusText==="abort"){return;}var r="Request for $count failed: "+E.message;if(E.response){r+=", "+E.response.statusCode+", "+E.response.statusText+", "+E.response.body;}L.warning(r);}var A;var s=this.getFilterParams()||"";var j="";if(this.bHasTreeAnnotations){var k=this.oModel.getContext("/"+N);var H=k.getProperty(this.oTreeProperties["hierarchy-node-for"]);A=this.getResolvedPath();if(N!=null){j=this._getNodeFilterParams({id:H});}else{j=this._getLevelFilterParams("EQ",this.getRootLevel());}}else{A=N;}if(j||s){var q="";if(j&&s){q="%20and%20";}s="$filter="+s+q+j;P.push(s);}if(A){G=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;this.oModel.read(A+"/$count",{urlParameters:P,success:_,error:i,sorters:this.aSorters,groupId:G});}};
p.prototype._getParentMap=function(D){var P={};for(var i=0;i<D.length;i++){var I=D[i][this.oTreeProperties["hierarchy-node-for"]];if(P[I]){L.warning("ODataTreeBinding: Duplicate key: "+I+"!");}P[I]=this.oModel._getKey(D[i]);}return P;};
p.prototype._createKeyMap=function(D,s){if(D&&D.length>0){var P=this._getParentMap(D),k={};for(var i=s?1:0;i<D.length;i++){var j=D[i][this.oTreeProperties["hierarchy-parent-node-for"]],q=P[j];if(parseInt(D[i][this.oTreeProperties["hierarchy-level-for"]])===this.iRootLevel){q="null";}if(!k[q]){k[q]=[];}k[q].push(this.oModel._getKey(D[i]));}return k;}return undefined;};
p.prototype._importCompleteKeysHierarchy=function(k){var i,K;for(K in k){i=k[K].length||0;this.oKeys[K]=k[K];this.oLengths[K]=i;this.oFinalLengths[K]=true;this._mLoadedSections[K]=[{startIndex:0,length:i}];}};
p.prototype._updateNodeKey=function(N,s){var i=this.oModel.getKey(N.context),P,j;if(parseInt(N.context.getProperty(this.oTreeProperties["hierarchy-level-for"]))===this.iRootLevel){P="null";}else{P=this.oModel.getKey(N.parent.context);}j=this.oKeys[P].indexOf(i);if(j!==-1){this.oKeys[P][j]=s;}else{this.oKeys[P].push(s);}};
p.prototype._loadSubTree=function(N,P){return new Promise(function(r,i){var R,G,A;if(!this.bHasTreeAnnotations){i(new Error("_loadSubTree: doesn't support hierarchies without tree annotations"));return;}R="loadSubTree-"+P.join("-");if(this.mRequestHandles[R]){this.mRequestHandles[R].abort();}var s=function(D){if(D.results.length>0){var j=this.oModel.getKey(D.results[0]);this._updateNodeKey(N,j);var k=this._createKeyMap(D.results);this._importCompleteKeysHierarchy(k);}delete this.mRequestHandles[R];this.bNeedsUpdate=true;this.oModel.callAfterUpdate(function(){this.fireDataReceived({data:D});}.bind(this));r(D);}.bind(this);var E=function(j){delete this.mRequestHandles[R];if(j&&j.statusCode===0&&j.statusText==="abort"){return;}this.fireDataReceived();i();}.bind(this);if(!this.bSkipDataEvents){this.fireDataRequested();}this.bSkipDataEvents=false;A=this.getResolvedPath();if(A){G=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;this.mRequestHandles[R]=this.oModel.read(A,{urlParameters:P,success:s,error:E,sorters:this.aSorters,groupId:G});}}.bind(this));};
p.prototype._loadSubNodes=function(N,s,j,t,P,k,r){var q=this,G,I=false;if((s||j)&&!this.bClientOperation){P.push("$skip="+s+"&$top="+(j+t));}if(!this.oFinalLengths[N]||this.sCountMode==n.InlineRepeat){if(this.sCountMode==n.Inline||this.sCountMode==n.InlineRepeat||this.sCountMode==n.Both){P.push("$inlinecount=allpages");I=true;}else if(this.sCountMode==n.Request){q._getCountForNodeId(N);}}var R=""+N+"-"+s+"-"+this._iPageSize+"-"+t;function u(D){var v,i;if(D){q.oKeys[N]=q.oKeys[N]||[];if(I&&D.__count>=0){q.oLengths[N]=parseInt(D.__count);q.oFinalLengths[N]=true;}}if(Array.isArray(D.results)&&D.results.length>0){if(q.bHasTreeAnnotations){var w={};for(i=0;i<D.results.length;i++){v=D.results[i];if(i==0){w[N]=s;}else if(w[N]==undefined){w[N]=0;}q.oKeys[N][w[N]]=q.oModel._getKey(v);w[N]++;}}else{for(i=0;i<D.results.length;i++){v=D.results[i];var K=q.oModel._getKey(v);q._processODataObject(v,"/"+K,k.navPath);q.oKeys[N][i+s]=K;}}}else if(D&&!Array.isArray(D.results)){q.oKeys[null]=q.oModel._getKey(D);if(!q.bHasTreeAnnotations){q._processODataObject(D,N,k.navPath);}}delete q.mRequestHandles[R];q.bNeedsUpdate=true;q.oModel.callAfterUpdate(function(){q.fireDataReceived({data:D});});}function E(v){if(v&&v.statusCode===0&&v.statusText==="abort"){return;}q.fireDataReceived();delete q.mRequestHandles[R];if(r){var w=[];for(var i=0;i<q._mLoadedSections[N].length;i++){var x=q._mLoadedSections[N][i];if(r.startIndex>=x.startIndex&&r.startIndex+r.length<=x.startIndex+x.length){if(r.startIndex!==x.startIndex&&r.length!==x.length){w=m.mergeSections(w,{startIndex:x.startIndex,length:r.startIndex-x.startIndex});w=m.mergeSections(w,{startIndex:r.startIndex+r.length,length:(x.startIndex+x.length)-(r.startIndex+r.length)});}}else{w.push(x);}}q._mLoadedSections[N]=w;}}if(N!==undefined){if(!this.bSkipDataEvents){this.fireDataRequested();}this.bSkipDataEvents=false;var A;if(this.bHasTreeAnnotations){A=this.getResolvedPath();}else{A=N;}if(this.mRequestHandles[R]){this.mRequestHandles[R].abort();}if(A){G=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;this.mRequestHandles[R]=this.oModel.read(A,{urlParameters:P,success:u,error:E,sorters:this.aSorters,groupId:G});}}};
p.REQUEST_KEY_CLIENT="_OPERATIONMODE_CLIENT_TREE_LOADING";
p.prototype._loadCompleteTreeWithAnnotations=function(u){var t=this;var r=p.REQUEST_KEY_CLIENT;var s=function(D){if(D.results&&D.results.length>0){var P={};var j;for(var k=0;k<D.results.length;k++){j=D.results[k];var q=j[t.oTreeProperties["hierarchy-node-for"]];if(P[q]){L.warning("ODataTreeBinding - Duplicate data entry for key: "+q+"!");}P[q]=t.oModel._getKey(j);}for(var i=0;i<D.results.length;i++){j=D.results[i];var v=j[t.oTreeProperties["hierarchy-parent-node-for"]];var w=P[v];if(parseInt(j[t.oTreeProperties["hierarchy-level-for"]])===t.iRootLevel){w="null";}t.oKeys[w]=t.oKeys[w]||[];var K=t.oModel._getKey(j);t.oKeys[w].push(K);t.oLengths[w]=t.oLengths[w]||0;t.oLengths[w]++;t.oFinalLengths[w]=true;t._mLoadedSections[w]=t._mLoadedSections[w]||[];t._mLoadedSections[w][0]=t._mLoadedSections[w][0]||{startIndex:0,length:0};t._mLoadedSections[w][0].length++;}}else{t.oKeys["null"]=[];t.oLengths["null"]=0;t.oFinalLengths["null"]=true;}t.oAllKeys=d({},t.oKeys);t.oAllLengths=d({},t.oLengths);t.oAllFinalLengths=d({},t.oFinalLengths);delete t.mRequestHandles[r];t.bNeedsUpdate=true;if((t.aApplicationFilters&&t.aApplicationFilters.length>0)||(t.aFilters&&t.aFilters.length>0)){t._applyFilter();}if(t.aSorters&&t.aSorters.length>0){t._applySort();}t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:D});});};var E=function(i){delete t.mRequestHandles[r];var j=i.statusCode==0;if(!j){t.oKeys={};t.oLengths={};t.oFinalLengths={};t.oAllKeys={};t.oAllLengths={};t.oAllFinalLengths={};t._fireChange({reason:C.Change});t.fireDataReceived();}};if(!this.bSkipDataEvents){this.fireDataRequested();}this.bSkipDataEvents=false;if(this.mRequestHandles[r]){this.mRequestHandles[r].abort();}var A=this.getResolvedPath();if(A){this.mRequestHandles[r]=this.oModel.read(A,{urlParameters:u,success:s,error:E,sorters:this.aSorters,groupId:this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId});}};
p.prototype.resetData=function(v){var i,D=false;if(typeof v==="boolean"){D=v;}else{i=v;}if(i){var P=i.getPath();delete this.oKeys[P];delete this.oLengths[P];delete this.oFinalLengths[P];delete this._mLoadedSections[P];}else{this.oKeys={};this.bClientOperation=this.sOperationMode===o.Client;this.bThresholdRejected=false;this.iTotalCollectionCount=null;this.bCollectionCountRequested=false;this.oAllKeys=null;this.oAllLengths=null;this.oAllFinalLengths=null;this.oLengths={};this.oFinalLengths={};this.oRootContext=null;this._bRootMissing=false;if(!D){this._abortPendingRequest();}this._mLoadedSections={};this._iPageSize=0;this.sFilterParams="";}};
p.prototype.refresh=function(i,G){if(typeof i==="string"){G=i;}this.sRefreshGroupId=G;this._refresh(i);this.sRefreshGroupId=undefined;};
p.prototype._refresh=function(i,j,E){var k=false;if(!i){if(E){var r=this.getResolvedPath();if(r){if(r.indexOf("?")!==-1){r=r.split("?")[0];}var q=this.oModel.oMetadata._getEntityTypeByPath(r);if(q&&(q.entityType in E)){k=true;}}}if(j&&!k){k=this._hasChangedEntity(j);}if(!j&&!E){k=true;}}if(i||k){this.resetData();this.bNeedsUpdate=false;this.bRefresh=true;this._fireRefresh({reason:C.Refresh});}};
p.prototype._hasChangedEntity=function(i){var s,N;for(N in this.oKeys){for(s in i){if(b(this.oKeys[N],s)){return true;}}}return false;};
p.prototype.filter=function(i,s,r){var j=false;s=s||h.Control;this.oModel.checkFilterOperation(i);if(s==h.Control&&(!this.bClientOperation||this.sOperationMode==o.Server)){L.warning("Filtering with ControlFilters is ONLY possible if the ODataTreeBinding is running in OperationMode.Client or "+"OperationMode.Auto, in case the given threshold is lower than the total number of tree nodes.");return this;}if(!i){i=[];}if(i instanceof F){i=[i];}if(s===h.Control){this.aFilters=i;}else{this.aApplicationFilters=i;}if(!this.bInitial){if(this.bClientOperation&&(s===h.Control||(s===h.Application&&!this.bUseServersideApplicationFilters))){if(this.oAllKeys){this.oKeys=d({},this.oAllKeys);this.oLengths=d({},this.oAllLengths);this.oFinalLengths=d({},this.oAllFinalLengths);this._applyFilter();this._applySort();this._fireChange({reason:C.Filter});}else{this.sChangeReason=C.Filter;}}else{this.resetData();this.sChangeReason=C.Filter;this._fireRefresh({reason:this.sChangeReason});}j=true;}if(r){return j;}else{return this;}};
p.prototype._applyFilter=function(){var t=this;var i;if(this.bUseServersideApplicationFilters){i=g.groupFilters(this.aFilters);}else{i=g.combineFilters(this.aFilters,this.aApplicationFilters);}var j=function(K){var q=g.apply([K],i,function(r,P){var s=t.oModel.getContext('/'+r);return t.oModel.getProperty(P,s);},t.mNormalizeCache);return q.length>0;};var k={};this._filterRecursive({id:"null"},k,j);this.oKeys=k;if(!this.oKeys["null"]){L.warning("Clientside filter did not match on any node!");}else{this.oLengths["null"]=this.oKeys["null"].length;this.oFinalLengths["null"]=true;}};
p.prototype._filterRecursive=function(N,k,j){var q=this.oKeys[N.id];if(q){N.children=N.children||[];for(var i=0;i<q.length;i++){var r=this._filterRecursive({id:q[i]},k,j);if(r.isFiltered){k[N.id]=k[N.id]||[];k[N.id].push(r.id);N.children.push(r);}}if(N.children.length>0){N.isFiltered=true;}else{N.isFiltered=j(N.id);}if(N.isFiltered){this.oLengths[N.id]=N.children.length;this.oFinalLengths[N.id]=true;}return N;}else{N.isFiltered=j(N.id);return N;}};
p.prototype.sort=function(s,r){var i=false;if(s instanceof S){s=[s];}this.aSorters=s||[];if(!this.bInitial){this._abortPendingRequest();if(this.bClientOperation){this.addSortComparators(s,this.oEntityType);if(this.oAllKeys){this._applySort();this._fireChange({reason:C.Sort});}else{this.sChangeReason=C.Sort;}}else{this.resetData(undefined,{reason:C.Sort});this.sChangeReason=C.Sort;this._fireRefresh({reason:this.sChangeReason});}i=true;}if(r){return i;}else{return this;}};
p.prototype.addSortComparators=function(s,E){var P,t;if(!E){L.warning("Cannot determine sort comparators, as entitytype of the collection is unknown!");return;}e(s,function(i,j){if(!j.fnCompare){P=this.oModel.oMetadata._getPropertyMetadata(E,j.sPath);t=P&&P.type;a(P,"PropertyType for property "+j.sPath+" of EntityType "+E.name+" not found!");j.fnCompare=O.getComparator(t);}}.bind(this));};
p.prototype._applySort=function(){var t=this,i;var G=function(k,P){i=t.oModel.getContext('/'+k);return t.oModel.getProperty(P,i);};for(var N in this.oKeys){l.apply(this.oKeys[N],this.aSorters,G);}};
p.prototype.checkUpdate=function(j,k){var s=this.sChangeReason?this.sChangeReason:C.Change;var q=false;if(!j){if(this.bNeedsUpdate||!k){q=true;}else{e(this.oKeys,function(i,N){e(N,function(i,K){if(K in k){q=true;return false;}return true;});if(q){return false;}return true;});}}if(j||q){this.bNeedsUpdate=false;this._fireChange({reason:s});}this.sChangeReason=undefined;};
p.prototype._getNavPath=function(P){var A=this.oModel.resolve(P,this.getContext());if(!A){return undefined;}var i=A.split("/"),E=i[i.length-1],N;var s=E.split("(")[0];if(s&&this.oNavigationPaths[s]){N=this.oNavigationPaths[s];}return N;};
p.prototype._processODataObject=function(i,P,N){var j=[],t=this;if(N&&N.indexOf("/")>-1){j=N.split("/");N=j[0];j.splice(0,1);}var r=this.oModel._getObject(P);if(Array.isArray(r)){this.oKeys[P]=r;this.oLengths[P]=r.length;this.oFinalLengths[P]=true;}else if(r){this.oLengths[P]=1;this.oFinalLengths[P]=true;}if(N&&i[N]){if(Array.isArray(r)){r.forEach(function(R){var i=t.getModel().getData("/"+R);t._processODataObject(i,"/"+R+"/"+N,j.join("/"));});}else if(typeof r==="object"){t._processODataObject(i,P+"/"+N,j.join("/"));}}};
p.prototype._hasTreeAnnotations=function(){var M=this.oModel.oMetadata,A=this.getResolvedPath(),E,t=M.mNamespaces["sap"],i=this;this.oTreeProperties={"hierarchy-level-for":false,"hierarchy-parent-node-for":false,"hierarchy-node-for":false,"hierarchy-drill-state-for":false};var s=function(){var j=0;var k=0;e(i.oTreeProperties,function(P,q){k++;if(q){j+=1;}});if(j===k){return true;}else if(j>0&&j<k){L.warning("Incomplete hierarchy tree annotations. Please check your service metadata definition!");}return false;};if(this.mParameters&&this.mParameters.treeAnnotationProperties){this.oTreeProperties["hierarchy-level-for"]=this.mParameters.treeAnnotationProperties.hierarchyLevelFor;this.oTreeProperties["hierarchy-parent-node-for"]=this.mParameters.treeAnnotationProperties.hierarchyParentNodeFor;this.oTreeProperties["hierarchy-node-for"]=this.mParameters.treeAnnotationProperties.hierarchyNodeFor;this.oTreeProperties["hierarchy-drill-state-for"]=this.mParameters.treeAnnotationProperties.hierarchyDrillStateFor;return s();}if(A.indexOf("?")!==-1){A=A.split("?")[0];}E=M._getEntityTypeByPath(A);if(!E){L.fatal("EntityType for path "+A+" could not be found.");return false;}e(E.property,function(I,P){if(!P.extensions){return true;}e(P.extensions,function(I,j){var N=j.name;if(j.namespace===t&&N in i.oTreeProperties&&!i.oTreeProperties[N]){i.oTreeProperties[N]=P.name;}});return true;});return s();};
p.prototype.initialize=function(){if(this.oModel.oMetadata&&this.oModel.oMetadata.isLoaded()&&this.bInitial){if(this.isResolved()){this._initialize(this._fireRefresh.bind(this,{reason:C.Refresh}));}else{this._fireRefresh({reason:C.Refresh});}}return this;};
p.prototype._initialize=function(i){this.bInitial=false;this.bHasTreeAnnotations=this._hasTreeAnnotations();this.oEntityType=this._getEntityType();this._processSelectParameters();this._applyAdapter(i);return this;};
p.prototype.setContext=function(i){if(i&&i.isPreliminary()&&!this.bUsePreliminaryContext){return;}if(i&&i.isUpdated()&&this.bUsePreliminaryContext&&this.oContext===i){this._fireChange({reason:C.Context});return;}if(f.hasChanged(this.oContext,i)){this.oContext=i;if(!this.isRelative()){return;}if(this.getResolvedPath()){this.resetData();this._initialize(this._fireChange.bind(this,{reason:C.Context}));}else if(!c(this.oAllKeys)||!c(this.oKeys)||!c(this._aNodes)){this.resetData();this._fireChange({reason:C.Context});}}};
p.prototype.applyAdapterInterface=function(){this.getContexts=this.getContexts||function(){return[];};this.getNodes=this.getNodes||function(){return[];};this.getLength=this.getLength||function(){return 0;};this.isLengthFinal=this.isLengthFinal||function(){return false;};this.getContextByIndex=this.getContextByIndex||function(){return;};this.attachSelectionChanged=this.attachSelectionChanged||function(D,i,j){this.attachEvent("selectionChanged",D,i,j);return this;};this.detachSelectionChanged=this.detachSelectionChanged||function(i,j){this.detachEvent("selectionChanged",i,j);return this;};this.fireSelectionChanged=this.fireSelectionChanged||function(P){this.fireEvent("selectionChanged",P);return this;};return this;};
p.prototype._applyAdapter=function(k){var A,E,i,j,K,N,s="sap/ui/model/odata/ODataTreeBindingAdapter",M="hierarchy-node-descendant-count-for",P="hierarchy-preorder-rank-for",q="hierarchy-sibling-rank-for",t=this;if(!this.bHasTreeAnnotations&&!this.oNavigationPaths){L.error("Neither hierarchy annotations, "+"nor navigation properties are specified to build the tree.",this);return;}if(this.bHasTreeAnnotations){A=this.getResolvedPath();if(A.indexOf("?")!==-1){A=A.split("?")[0];}E=this.oModel.oMetadata._getEntityTypeByPath(A);e(E.property,function(I,r){if(!r.extensions){return true;}e(r.extensions,function(I,u){N=u.name;if(u.namespace===t.oModel.oMetadata.mNamespaces["sap"]&&(N==M||N==q||N==P)){t.oTreeProperties[N]=r.name;}});return true;});this.oTreeProperties[M]=this.oTreeProperties[M]||(this.mParameters.treeAnnotationProperties&&this.mParameters.treeAnnotationProperties.hierarchyNodeDescendantCountFor);if(this.oTreeProperties[M]&&this.sOperationMode==o.Server){this.oTreeProperties[q]=this.oTreeProperties[q]||(this.mParameters.treeAnnotationProperties&&this.mParameters.treeAnnotationProperties.hierarchySiblingRankFor);this.oTreeProperties[P]=this.oTreeProperties[P]||(this.mParameters.treeAnnotationProperties&&this.mParameters.treeAnnotationProperties.hierarchyPreorderRankFor);if(this.mParameters.restoreTreeStateAfterChange){if(this.oTreeProperties[q]&&this.oTreeProperties[P]){this._bRestoreTreeStateAfterChange=true;this._aTreeKeyProperties=[];for(i=E.key.propertyRef.length-1;i>=0;i--){this._aTreeKeyProperties.push(E.key.propertyRef[i].name);}}else{L.warning("Tree state restoration not possible: Missing annotation "+"\"hierarchy-sibling-rank-for\" and/or "+"\"hierarchy-preorder-rank-for\"");this._bRestoreTreeStateAfterChange=false;}}else{this._bRestoreTreeStateAfterChange=false;}if(this.mParameters&&this.mParameters.select){if(this.mParameters.select.indexOf(this.oTreeProperties[M])===-1){this.mParameters.select+=","+this.oTreeProperties[M];}if(this._bRestoreTreeStateAfterChange){for(j=this._aTreeKeyProperties.length-1;j>=0;j--){K=this._aTreeKeyProperties[j];if(this.mParameters.select.indexOf(K)===-1){this.mParameters.select+=","+K;}}}this.sCustomParams=this.oModel.createCustomParams(this.mParameters);}s="sap/ui/model/odata/ODataTreeBindingFlat";}}sap.ui.require([s],function(r){r.apply(t);k();});};
p.prototype._processSelectParameters=function(){if(this.mParameters){this.oNavigationPaths=this.mParameters.navigation;if(this.mParameters.select){var s=this.mParameters.select.split(",");var N=[];if(this.oNavigationPaths){e(this.oNavigationPaths,function(P,i){if(N.indexOf(i)==-1){N.push(i);}});}e(N,function(P,i){if(s.indexOf(i)==-1){s.push(i);}});if(this.bHasTreeAnnotations){e(this.oTreeProperties,function(A,t){if(t){if(s.indexOf(t)==-1){s.push(t);}}});}this.mParameters.select=s.join(",");}this.sCustomParams=this.oModel.createCustomParams(this.mParameters);}if(!this.bHasTreeAnnotations&&!this.oNavigationPaths){L.error("Neither navigation paths parameters, nor (complete/valid) tree hierarchy annotations where provided to the TreeBinding.");this.oNavigationPaths={};}};
p.prototype.getTreeAnnotation=function(A){return this.bHasTreeAnnotations?this.oTreeProperties[A]:undefined;};
p.prototype.getDownloadUrl=function(s){var P=[],i;if(s){P.push("$format="+encodeURIComponent(s));}if(this.aSorters&&this.aSorters.length>0){P.push(O.createSortParams(this.aSorters));}if(this.getFilterParams()){P.push("$filter="+this.getFilterParams());}if(this.sCustomParams){P.push(this.sCustomParams);}i=this.getResolvedPath();return i&&this.oModel._createRequestUrl(i,null,P);};
p.prototype.setNumberOfExpandedLevels=function(i){i=i||0;if(i<0){L.warning("ODataTreeBinding: numberOfExpandedLevels was set to 0. Negative values are prohibited.");i=0;}this.iNumberOfExpandedLevels=i;this._fireChange();};
p.prototype.getNumberOfExpandedLevels=function(){return this.iNumberOfExpandedLevels;};
p.prototype.setRootLevel=function(r){r=parseInt(r||0);if(r<0){L.warning("ODataTreeBinding: rootLevels was set to 0. Negative values are prohibited.");r=0;}this.iRootLevel=r;this.refresh();};
p.prototype.getRootLevel=function(){return parseInt(this.iRootLevel);};
p.prototype._getEntityType=function(){var r=this.getResolvedPath();if(r){var E=this.oModel.oMetadata._getEntityTypeByPath(r);a(E,"EntityType for path "+r+" could not be found!");return E;}return undefined;};
p.prototype.getFilterParams=function(){var G;if(this.aApplicationFilters){this.aApplicationFilters=Array.isArray(this.aApplicationFilters)?this.aApplicationFilters:[this.aApplicationFilters];if(this.aApplicationFilters.length>0&&!this.sFilterParams){G=g.groupFilters(this.aApplicationFilters);this.sFilterParams=O._createFilterParams(G,this.oModel.oMetadata,this.oEntityType);this.sFilterParams=this.sFilterParams?"("+this.sFilterParams+")":"";}}else{this.sFilterParams="";}return this.sFilterParams;};
p.prototype._abortPendingRequest=function(){if(!c(this.mRequestHandles)){this.bSkipDataEvents=true;e(this.mRequestHandles,function(r,R){if(R){R.abort();}});this.mRequestHandles={};}};
return p;});
sap.ui.predefine('sap/ui/model/odata/v2/_CreatedContextsCache',[],function(){"use strict";
function _(){this.mCache={};}
_.prototype.addContext=function(c,p,l,a){var C,L;L=this.mCache[p];if(!L){L=this.mCache[p]={};}C=L[l];if(!C){C=L[l]=[];C.bAtEnd=a;}if(a){C.push(c);}else{C.unshift(c);}};
_.prototype.findAndRemoveContext=function(c){var r=this.getCacheInfo(c);if(r){this.removeContext(c,r.cachePath,r.listID);}};
_.prototype.findCreatedContext=function(p){var c;Object.values(this.mCache).some(function(l){return Object.values(l).some(function(C){return C.some(function(o){if(p.startsWith(o.getPath())){c=o;return true;}return false;});});});return c;};
_.prototype.getCacheInfo=function(c){var r,t=this;Object.keys(this.mCache).some(function(C){var l=t.mCache[C];return Object.keys(l).some(function(L){var a=t.mCache[C][L];if(a.includes(c)){r={cachePath:C,listID:L};return true;}return false;});});return r;};
_.prototype.getContexts=function(p,l){var L=this.mCache[p],c=L&&L[l];return c?c.slice():[];};
_.prototype.isAtEnd=function(p,l){var L=this.mCache[p],c=L&&L[l];return c&&c.bAtEnd;};
_.prototype.removeContext=function(c,p,l){var L=this.mCache[p],C=L[l];C.splice(C.indexOf(c),1);if(!C.length){delete L[l];if(!Object.keys(L).length){delete this.mCache[p];}}};
_.prototype.removePersistedContexts=function(p,l){var c=this.getContexts(p,l).filter(function(C){return C.isTransient()===false;}),t=this;c.forEach(function(C){C.resetCreatedPromise();t.removeContext(C,p,l);});return c;};
return _;});
sap.ui.predefine('sap/ui/model/odata/v4/AnnotationHelper',["./_AnnotationHelperExpression"],function(E){"use strict";var r=/[\\{}:]/,a=/\/\$count$/,b=/\$(?:(?:Annotation)|(?:(?:Navigation)?Property))?Path/,c=/^(.+?\/(\$(?:Annotation)?Path))(\/?)(.*)$/,d=/\$(?:Navigation)?PropertyPath/,A={format:function(R,D){var m,M=D.context.getModel(),p=D.context.getPath();function g(P){if(p.endsWith("/")){p=p.slice(0,-1);}return E.getExpression({asExpression:false,complexBinding:true,formatOptions:D.arguments&&D.arguments[1],ignoreAsPrefix:D.overload&&D.overload.$IsBound&&!p.includes("/$Parameter/")?D.overload.$Parameter[0].$Name+"/":"",model:M,parameters:D.arguments&&D.arguments[0],path:p,prefix:P,value:R,$$valueAsPromise:true});}if(p.endsWith("/$Path")){p=p.slice(0,-6);R={$Path:R};}else if(p.endsWith("/$PropertyPath")){p=p.slice(0,-14);R={$PropertyPath:R};}m=d.exec(p);if(m){throw new Error("Unsupported path segment "+m[0]+" in "+p);}m=c.exec(p);if(m&&p.length>m[1].length){if(c.test(m[4])){throw new Error("Only one $Path or $AnnotationPath segment is supported: "+p);}return M.fetchObject(m[1]).then(function(P){var I=m[2]==="$AnnotationPath",s=I?P.split("@")[0]:P,i;if(!I&&m[3]){s+="/";}else if(!s.endsWith("/")){i=s.lastIndexOf("/");s=i<0?"":s.slice(0,i+1);}return g(s);});}return g("");},getNavigationBinding:function(p){p=A.getNavigationPath(p);if(r.test(p)){throw new Error("Invalid OData identifier: "+p);}return p?"{"+p+"}":p;},getNavigationPath:function(p){var i;if(!p||p[0]==="@"){return"";}if(a.test(p)){return p.slice(0,-7);}i=p.indexOf("@");if(i>-1){p=p.slice(0,i);}if(p[p.length-1]==="/"){p=p.slice(0,-1);}if(p.includes(".")){p=p.split("/").filter(function(s){return!s.includes(".");}).join("/");}return p;},getValueListType:function(R,D){var p=typeof R==="string"?"/"+D.schemaChildName+"/"+R:D.context.getPath();return D.$$valueAsPromise?D.context.getModel().fetchValueListType(p).unwrap():D.context.getModel().getValueListType(p);},isMultiple:function(p,D){var i;function e(v){return v===true;}if(!p||p[0]==="@"){return false;}if(a.test(p)){return true;}i=p.indexOf("@");if(i>-1){p=p.slice(0,i);}if(p[p.length-1]!=="/"){p+="/";}p="/"+D.schemaChildName+"/"+p+"$isCollection";return D.$$valueAsPromise?D.context.getModel().fetchObject(p).then(e).unwrap():D.context.getObject(p)===true;},label:function(R,D){var n;if(R.Label){return A.value(R.Label,{context:D.context.getModel().createBindingContext("Label",D.context)});}if(R.Value&&R.Value.$Path){n=D.context.getModel().createBindingContext("Value/$Path@com.sap.vocabularies.Common.v1.Label",D.context);if(D.$$valueAsPromise){return n.getModel().fetchObject("",n).then(function(o){return A.value(o,{context:n});}).unwrap();}return A.value(n.getObject(""),{context:n});}},resolve$Path:function(C){var e,i,I,l,m,p=C.getPath(),P,v;for(;;){m=p.match(b);if(!m){return p;}I=m.index;e=I+m[0].length;P=p.slice(0,e);v=C.getModel().getObject(P);if(typeof v!=="string"){throw new Error("Cannot resolve "+P+" due to unexpected value "+v);}P=p.slice(0,I);i=P.indexOf("@");l=P.lastIndexOf("/",i);if(l===0){P=P.slice(0,i);if(i>1&&v){P+="/";}}else{P=P.slice(0,l+1);}p=P+v+p.slice(e);}},value:function(R,D){var p=D.context.getPath();if(p.endsWith("/")){p=p.slice(0,-1);}else if(p.endsWith("/$Path")){p=p.slice(0,-6);R={$Path:R};}else if(p.endsWith("/$PropertyPath")){p=p.slice(0,-14);R={$PropertyPath:R};}return E.getExpression({asExpression:false,complexBinding:false,ignoreAsPrefix:D.overload&&D.overload.$IsBound&&!p.includes("/$Parameter/")?D.overload.$Parameter[0].$Name+"/":"",model:D.context.getModel(),parameters:D.arguments&&D.arguments[0],path:p,prefix:"",value:R,$$valueAsPromise:D.$$valueAsPromise});}};return A;},true);
sap.ui.predefine('sap/ui/model/odata/v4/Context',["./lib/_Helper","sap/base/Log","sap/ui/base/SyncPromise","sap/ui/model/Context"],function(_,L,S,B){"use strict";var c="sap.ui.model.odata.v4.Context",g=0,m,v=-9007199254740991;
function f(o,p,e,b){var E,P=[o.fetchValue(p,null,b)],r=o.oModel.resolve(p,o);if(e){P.push(o.oModel.getMetaModel().fetchUI5Type(r));}return S.all(P).then(function(R){var t=R[1],V=R[0];if(V&&typeof V==="object"){E=new Error("Accessed value is not primitive: "+r);E.isNotPrimitive=true;throw E;}return e?t.formatValue(V,"string"):V;});}
var C=B.extend("sap.ui.model.odata.v4.Context",{constructor:function(M,b,p,i,o,G,I){if(p[0]!=="/"){throw new Error("Not an absolute path: "+p);}if(p.endsWith("/")){throw new Error("Unsupported trailing slash: "+p);}B.call(this,M,p);this.oBinding=b;this.oCreatedPromise=o&&Promise.resolve(o).then(function(){});this.oSyncCreatePromise=o;this.iGeneration=G||0;this.bInactive=I||undefined;this.iIndex=i;this.bKeepAlive=false;this.fnOnBeforeDestroy=undefined;}});
C.prototype._delete=function(G,e,d){var t=this;if(!G){return this.oBinding._delete(null,"n/a",this,null,true);}return this.fetchCanonicalPath().then(function(s){return t.oBinding._delete(G,s.slice(1),t,e,d);});};
C.prototype.adjustPredicate=function(t,p,P){var T=this.sPath;this.sPath=T.replace(t,p);if(P){P(T,this.sPath);}this.oModel.getDependentBindings(this).forEach(function(d){d.adjustPredicate(t,p);});};
C.prototype.checkUpdate=function(){this.oModel.getDependentBindings(this).forEach(function(d){d.checkUpdate();});};
C.prototype.checkUpdateInternal=function(){return S.all(this.oModel.getDependentBindings(this).map(function(d){return d.checkUpdateInternal();}));};
C.prototype.collapse=function(){switch(this.getProperty("@$ui5.node.level")===0?undefined:this.isExpanded()){case true:this.oBinding.collapse(this);break;case false:throw new Error("Already collapsed: "+this);default:throw new Error("Not expandable: "+this);}};
C.prototype.created=function(){return this.oCreatedPromise;};
C.prototype.delete=function(G,d){var o=null,M=this.oModel,t=this;this.oBinding.checkSuspended();if(this.isTransient()){G=null;}else if(this.hasPendingChanges()){throw new Error("Cannot delete due to pending changes");}else if(G===null){if(!(this.bKeepAlive&&this.iIndex===undefined)){throw new Error("Cannot delete "+this);}}if(G===null){d=true;}else{M.checkGroupId(G);o=this.oBinding.lockGroup(G,true,true);G=o.getGroupId();if(this.oModel.isApiGroup(G)){throw new Error("Illegal update group ID: "+G);}}return this._delete(o,null,d).then(function(){var r=t.sPath.slice(1);M.getAllBindings().forEach(function(b){b.removeCachesAndMessages(r,true);});}).catch(function(e){if(o){o.unlock(true);}M.reportError("Failed to delete "+t,c,e);throw e;});};
C.prototype.destroy=function(){var o=this.fnOnBeforeDestroy;if(o){this.fnOnBeforeDestroy=undefined;o();}this.oModel.getDependentBindings(this).forEach(function(d){d.setContext(undefined);});this.oBinding=undefined;this.oModel=undefined;B.prototype.destroy.call(this);};
C.prototype.doSetProperty=function(p,V,G,s){var M=this.oModel.getMetaModel(),t=this;if(this.oModel.bAutoExpandSelect){p=M.getReducedPath(this.oModel.resolve(p,this),this.oBinding.getBaseForPathReduction());}return this.withCache(function(o,a,b){return b.doSetProperty(a,V,G)||M.fetchUpdateData(p,t,!G).then(function(r){var e=_.getRelativePath(r.entityPath,b.oReturnValueContext?b.oReturnValueContext.getPath():b.getResolvedPath()),F=false;function d(E){t.oModel.reportError("Failed to update path "+t.oModel.resolve(p,t),c,E);h(false);}function h(j){if(F){b.firePatchCompleted(j);F=false;}}function i(){F=true;b.firePatchSent();}if(!G){return o.setProperty(r.propertyPath,V,e);}if(t.isInactive()){b.fireCreateActivate(t);t.bInactive=false;}return o.update(G,r.propertyPath,V,s?undefined:d,r.editUrl,e,M.getUnitOrCurrencyPath(t.oModel.resolve(p,t)),b.isPatchWithoutSideEffects(),i,t.isKeepAlive.bind(t)).then(function(){h(true);},function(E){h(false);throw E;});});},p,false,true);};
C.prototype.expand=function(){var t=this;switch(this.isExpanded()){case false:this.oBinding.expand(this).catch(function(e){t.oModel.reportError("Failed to expand "+t,c,e);});break;case true:throw new Error("Already expanded: "+this);default:throw new Error("Not expandable: "+this);}};
C.prototype.fetchCanonicalPath=function(){return this.oModel.getMetaModel().fetchCanonicalPath(this);};
C.prototype.fetchValue=function(p,l,b){if(this.iIndex===v){return S.resolve();}if(!p||p[0]!=="/"){p=this.oModel.resolve(p,this);if(this.oModel.bAutoExpandSelect){p=this.oModel.getMetaModel().getReducedPath(p,this.oBinding.getBaseForPathReduction());}}return this.oBinding.fetchValue(p,l,b);};
C.prototype.getBinding=function(){return this.oBinding;};
C.prototype.getCanonicalPath=_.createGetMethod("fetchCanonicalPath",true);
C.prototype.getGeneration=function(o){if(this.iGeneration||o){return this.iGeneration;}return this.oBinding.getGeneration();};
C.prototype.getGroupId=function(){return this.oBinding.getGroupId();};
C.prototype.getIndex=function(){if(this.oBinding.bCreatedAtEnd){if(this.iIndex<0){return this.oBinding.bLengthFinal?this.oBinding.iMaxLength-this.iIndex-1:-this.iIndex-1;}return this.iIndex;}return this.getModelIndex();};
C.prototype.getModelIndex=function(){if(this.iIndex!==undefined&&this.oBinding.iCreatedContexts){return this.iIndex+this.oBinding.iCreatedContexts;}return this.iIndex;};
C.prototype.getObject=function(p){return _.publicClone(this.getValue(p));};
C.prototype.getProperty=function(p,e){var E,s;this.oBinding.checkSuspended();s=f(this,p,e,true);if(s.isRejected()){s.caught();E=s.getResult();if(E.isNotPrimitive){throw E;}else if(!E.$cached){L.warning(E.message,p,c);}}return s.isFulfilled()?s.getResult():undefined;};
C.prototype.getQueryOptionsForPath=function(p){return this.oBinding.getQueryOptionsForPath(p);};
C.prototype.getUpdateGroupId=function(){return this.oBinding.getUpdateGroupId();};
C.prototype.getValue=function(p){var s,t=this;this.oBinding.checkSuspended();s=this.fetchValue(p,null,true).catch(function(e){if(!e.$cached){t.oModel.reportError("Unexpected error",c,e);}});if(s.isFulfilled()){return s.getResult();}};
C.prototype.hasPendingChanges=function(){return this.isTransient()||this.oModel.getDependentBindings(this).some(function(d){return d.hasPendingChanges();})||this.oModel.withUnresolvedBindings("hasPendingChangesInCaches",this.sPath.slice(1));};
C.prototype.isExpanded=function(){return this.getProperty("@$ui5.node.isExpanded");};
C.prototype.isInactive=function(){return this.bInactive;};
C.prototype.isKeepAlive=function(){return this.bKeepAlive;};
C.prototype.isTransient=function(){return this.oSyncCreatePromise&&this.oSyncCreatePromise.isPending();};
C.prototype.patch=function(d){return this.withCache(function(o,p){o.patch(p,d);},"");};
C.prototype.refresh=function(G,a){this.requestRefresh.apply(this,arguments).catch(this.oModel.getReporter());};
C.prototype.refreshDependentBindings=function(r,G,b,k){return S.all(this.oModel.getDependentBindings(this).map(function(d){return d.refreshInternal(r,G,b,k);}));};
C.prototype.replaceWith=function(o){var e;this.oBinding.checkSuspended();if(this.iIndex===undefined||this.isTransient()){throw new Error("Cannot replace "+this);}if(o.oBinding!==this.oBinding||o.iIndex!==undefined){throw new Error("Cannot replace with "+o);}e=o.getValue();this.oBinding.doReplaceWith(this,e,_.getPrivateAnnotation(e,"predicate"));};
C.prototype.requestCanonicalPath=_.createRequestMethod("fetchCanonicalPath");
C.prototype.requestObject=function(p){this.oBinding.checkSuspended();return Promise.resolve(this.fetchValue(p)).then(_.publicClone);};
C.prototype.requestProperty=function(p,e){var P=Array.isArray(p)?p:[p],t=this;this.oBinding.checkSuspended();return Promise.all(P.map(function(s){return t.oBinding.fetchIfChildCanUseCache(t,s,S.resolve({})).then(function(r){if(r){return f(t,r,e);}L.error("Not a valid property path: "+s,undefined,c);});})).then(function(V){return Array.isArray(p)?V:V[0];});};
C.prototype.requestRefresh=function(G,a){var p;this.oModel.checkGroupId(G);this.oBinding.checkSuspended();if(this.hasPendingChanges()){throw new Error("Cannot refresh entity due to pending changes: "+this);}if(this.oBinding.refreshSingle){p=this.oBinding.refreshSingle(this,this.oBinding.lockGroup(G,true),a);}else{if(arguments.length>1){throw new Error("Unsupported parameter bAllowRemoval: "+a);}p=this.oBinding.refreshReturnValueContext(this,G)||this.oBinding.requestRefresh(G);}this.oModel.withUnresolvedBindings("removeCachesAndMessages",this.sPath.slice(1));return Promise.resolve(p).then(function(){});};
C.prototype.requestSideEffects=function(p,G){var e,M=this.oModel.getMetaModel(),P=[],a=[],r,R,t=this;function i(s){if(!s){return false;}if(s==="*"){return true;}if(s.endsWith("/*")){s=s.slice(0,-2);}return!s.includes("*");}this.oBinding.checkSuspended();this.oModel.checkGroupId(G);if(this.isTransient()){throw new Error("Unsupported context: "+this);}if(!p||!p.length){throw new Error("Missing edm:(Navigation)PropertyPath expressions");}if(!this.oBinding.isResolved()){throw new Error("Cannot request side effects of unresolved binding's context: "+this);}e=M.getObject("/$EntityContainer");if(!e){throw new Error("Missing metadata");}e="/"+e+"/";p.map(function(b){if(b&&typeof b==="object"){if(i(b.$PropertyPath)){return b.$PropertyPath;}if(typeof b.$NavigationPropertyPath==="string"&&!b.$NavigationPropertyPath.includes("*")){return b.$NavigationPropertyPath;}}else if(typeof b==="string"&&(!b||i(b))){return b;}throw new Error("Not an edm:(Navigation)PropertyPath expression: "+JSON.stringify(b));}).forEach(function(s){if(s[0]==="/"){if(!s.startsWith(e)){throw new Error("Path must start with '"+e+"': "+s);}a.push(s.slice(e.length-1));}else{P.push(s);}});r=this.oBinding.getRootBinding();R=r.getResolvedPath();P=P.reduce(function(b,s){return b.concat(M.getAllPathReductions(_.buildPath(t.getPath(),s),R));},[]);P=_.filterPaths(a,P);G=G||this.getUpdateGroupId();return Promise.resolve(S.resolve(this.oModel.isAutoGroup(G)&&this.oModel.oRequestor.waitForRunningChangeRequests(G).then(function(){t.oModel.oRequestor.relocateAll("$parked."+G,G);})).then(function(){return S.all([t.oModel.requestSideEffects(G,a),t.requestSideEffectsInternal(P,G)]);})).then(function(){});};
C.prototype.requestSideEffectsInternal=function(a,G){var t=this,b,o=t,d,O=[],p,P=[],s,e=[];if(!a.length){return undefined;}for(;;){b=o.getBinding();s=b.getPath();p=b.getContext();if(b.oCache&&(!d||b.oCache.hasChangeListeners())){d=o;}if(d&&s){break;}if(!b.getBoundContext){throw new Error("Not a context binding: "+b);}o=p;}b=d.getBinding();a.forEach(function(A){var r=_.getRelativePath(A,d.getPath());if(r===undefined){P.push(A);}else{O.push(r);}});if(P.length){e.push(b.getContext().requestSideEffectsInternal(P,G));}if(O.length&&b.oCache!==undefined){e.push(b.requestSideEffects(G,O,d));}return S.all(e);};
C.prototype.resetKeepAlive=function(){this.bKeepAlive=false;};
C.prototype.setNewGeneration=function(){g+=1;this.iGeneration=g;};
C.prototype.setKeepAlive=function(k,o,r){var M,t=this;if(this.isTransient()){throw new Error("Unsupported transient context "+this);}if(!_.getPrivateAnnotation(this.getValue(),"predicate")){throw new Error("No key predicate known at "+this);}this.oBinding.checkKeepAlive(this);if(k&&r){if(!this.oModel.bAutoExpandSelect){throw new Error("Missing parameter autoExpandSelect at model");}M=this.oModel.getMetaModel().getObject(_.getMetaPath(this.sPath)+"/@com.sap.vocabularies.Common.v1.Messages/$Path");if(!M){throw new Error("Missing @com.sap.vocabularies.Common.v1.Messages");}this.oBinding.fetchIfChildCanUseCache(this,M,{}).then(function(R){return t.fetchValue(R);}).catch(this.oModel.getReporter());}this.bKeepAlive=k;this.fnOnBeforeDestroy=k?o:undefined;};
C.prototype.setProperty=function(p,V,G,r){var o=null,t=this;this.oBinding.checkSuspended();if(typeof V==="function"||(V&&typeof V==="object")){throw new Error("Not a primitive value");}if(G!==null){this.oModel.checkGroupId(G);o=this.oBinding.lockGroup(G,true,true);}return Promise.resolve(this.doSetProperty(p,V,o,!r)).catch(function(e){if(o){o.unlock(true);}t.oModel.reportError("Failed to update path "+t.oModel.resolve(p,t),c,e);throw e;});};
C.prototype.toString=function(){var i="";if(this.iIndex!==undefined){i="["+this.iIndex+(this.isTransient()?"|transient":"")+"]";}return this.sPath+i;};
C.prototype.withCache=function(p,P,s,w){if(this.iIndex===v){return S.resolve();}return this.oBinding.withCache(p,this.oModel.resolve(P,this),s,w);};
m={create:function(M,b,p,i,o,I){return new C(M,b,p,i,o,0,I);},createNewContext:function(M,b,p){g+=1;return new C(M,b,p,undefined,undefined,g);}};Object.defineProperty(m,"VIRTUAL",{value:v});return m;},false);
sap.ui.predefine('sap/ui/model/odata/v4/ODataBinding',["./lib/_Helper","sap/ui/base/SyncPromise","sap/ui/model/ChangeReason","sap/ui/model/odata/OperationMode","sap/ui/model/odata/v4/Context"],function(_,S,C,O,a){"use strict";var c=[C.Context,C.Change,C.Refresh,C.Sort,C.Filter],s="sap.ui.model.odata.v4.ODataBinding",r=/\/\d|\(\$uid=/;
function h(e,f){return c.indexOf(e)>c.indexOf(f);}
function b(){this.mCacheByResourcePath=undefined;this.oCache=null;this.oCachePromise=S.resolve(null);this.mCacheQueryOptions=undefined;this.oFetchCacheCallToken=undefined;this.mLateQueryOptions=undefined;this.sReducedPath=undefined;this.sResumeChangeReason=undefined;}
b.prototype.adjustPredicate=function(t,p){this.sReducedPath=this.sReducedPath.replace(t,p);};
b.prototype.assertSameCache=function(e){var E;if(this.oCache!==e){E=new Error(this+" is ignoring response from inactive cache: "+e);E.canceled=true;throw E;}};
b.prototype.checkBindingParameters=function(p,A){var t=this;Object.keys(p).forEach(function(k){var v=p[k];if(!k.startsWith("$$")){return;}if(A.indexOf(k)<0){throw new Error("Unsupported binding parameter: "+k);}switch(k){case"$$aggregation":break;case"$$groupId":case"$$updateGroupId":t.oModel.checkGroupId(v,false,"Unsupported value for binding parameter '"+k+"': ");break;case"$$ignoreMessages":if(v!==true&&v!==false){throw new Error("Unsupported value for binding parameter "+"'$$ignoreMessages': "+v);}break;case"$$inheritExpandSelect":if(v!==true&&v!==false){throw new Error("Unsupported value for binding parameter "+"'$$inheritExpandSelect': "+v);}if(!t.oOperation){throw new Error("Unsupported binding parameter $$inheritExpandSelect: "+"binding is not an operation binding");}if(p.$expand){throw new Error("Must not set parameter $$inheritExpandSelect on a binding "+"which has a $expand binding parameter");}break;case"$$operationMode":if(v!==O.Server){throw new Error("Unsupported operation mode: "+v);}break;case"$$canonicalPath":case"$$noPatch":case"$$ownRequest":case"$$patchWithoutSideEffects":case"$$sharedRequest":if(v!==true){throw new Error("Unsupported value for binding parameter '"+k+"': "+v);}break;default:throw new Error("Unknown binding-specific parameter: "+k);}});};
b.prototype.checkSuspended=function(i){var R=this.getRootBinding();if(R&&R.isSuspended()&&(!i||this.isRoot()||this.getResumeChangeReason())){throw new Error("Must not call method when the binding's root binding is suspended: "+this);}};
b.prototype.checkUpdate=function(f){if(arguments.length>1){throw new Error("Only the parameter bForceUpdate is supported");}this.checkUpdateInternal(f).catch(this.oModel.getReporter());};
b.prototype.createAndSetCache=function(q,R,o,e,f){var g,D,G;this.mCacheQueryOptions=Object.assign({},this.oModel.mUriParameters,q);if(this.bRelative){if(o.isTransient&&o.isTransient()&&o.getProperty("@$ui5.context.isTransient")){this.oCache=null;return null;}g=this.mCacheByResourcePath&&this.mCacheByResourcePath[R];G=o.getGeneration&&o.getGeneration()||0;if(g&&g.$generation>=G){g.setActive(true);}else{D=this.oModel.resolve(this.sPath,o).slice(1);g=this.doCreateCache(R,this.mCacheQueryOptions,o,D,e,f);if(!(this.mParameters&&this.mParameters.$$sharedRequest)){this.mCacheByResourcePath=this.mCacheByResourcePath||{};this.mCacheByResourcePath[R]=g;}g.$deepResourcePath=D;g.$generation=G;}}else{g=this.doCreateCache(R,this.mCacheQueryOptions,undefined,undefined,e,f);}if(f!==g){if(f){f.setActive(false);}if(this.mLateQueryOptions){g.setLateQueryOptions(this.mLateQueryOptions);}}this.oCache=g;return g;};
b.prototype.destroy=function(){this.mCacheByResourcePath=undefined;this.oCachePromise.then(function(o){if(o){o.setActive(false);}},function(){});this.oCache=null;this.oCachePromise=S.resolve(null);this.mCacheQueryOptions=undefined;this.oContext=undefined;this.oFetchCacheCallToken=undefined;};
b.prototype.doDeregisterChangeListener=function(p,l){this.oCache.deregisterChange(p,l);};
b.prototype.fetchCache=function(o,i,k,K){var e=this.oCache,f={oOldCache:e===undefined?this.oFetchCacheCallToken.oOldCache:e},p,t=this;if(!this.bRelative){o=undefined;}if(!e&&k){if(e===undefined){throw new Error("Unsupported bKeepQueryOptions while oCachePromise is pending");}return;}this.oCache=undefined;this.oFetchCacheCallToken=f;if(k){this.oCachePromise=S.resolve(Promise.resolve()).then(function(){return t.createAndSetCache(t.mCacheQueryOptions,e.getResourcePath(),o,K,e);});return;}p=[this.fetchQueryOptionsForOwnCache(o,i),this.oModel.oRequestor.ready()];this.mCacheQueryOptions=undefined;this.oCachePromise=S.all(p).then(function(R){var q=R[0].mQueryOptions;t.sReducedPath=R[0].sReducedPath;if(q&&!(o&&o.iIndex===a.VIRTUAL)){return t.fetchResourcePath(o).then(function(g){var E;if(t.oFetchCacheCallToken!==f){E=new Error("Cache discarded as a new cache has been created");E.canceled=true;throw E;}return t.createAndSetCache(q,g,o,K,f.oOldCache);});}t.oCache=null;return null;});this.oCachePromise.catch(function(E){t.oModel.reportError("Failed to create cache for binding "+t,s,E);});};
b.prototype.fetchQueryOptionsForOwnCache=function(o,i){var H,q,R=this.oModel.resolve(this.sPath,o),t=this;function w(Q,e){return S.resolve(Q).then(function(m){return{mQueryOptions:m,sReducedPath:e||R};});}if(this.oOperation||this.bRelative&&!o||this.isMeta()){return w(undefined);}q=this.doFetchQueryOptions(o);if(this.oModel.bAutoExpandSelect&&this.aChildCanUseCachePromises&&!(this.mParameters&&this.mParameters.$$aggregation)){q=S.all([q,Promise.resolve().then(function(){return S.all(t.aChildCanUseCachePromises);})]).then(function(e){t.aChildCanUseCachePromises=[];t.updateAggregatedQueryOptions(e[0]);return t.mAggregatedQueryOptions;});}if(i||!this.bRelative||!o.fetchValue){return w(q);}if(this.oModel.bAutoExpandSelect){H=this.mParameters&&Object.keys(t.mParameters).some(function(k){return k[0]!=="$"||k[1]==="$";});if(H){return w(q);}return o.getBinding().fetchIfChildCanUseCache(o,t.sPath,q).then(function(e){return w(e?undefined:q,e);});}if(this.mParameters&&Object.keys(this.mParameters).length){return w(q);}return q.then(function(Q){return w(Object.keys(Q).length?Q:undefined);});};
b.prototype.fetchResourcePath=function(o){var e,f,g,t=this;if(!this.bRelative){return S.resolve(this.sPath.slice(1));}o=o||this.oContext;if(!o){return S.resolve();}f=o.getPath();e=o.fetchCanonicalPath&&(this.mParameters&&this.mParameters.$$canonicalPath||r.test(f));g=e?o.fetchCanonicalPath():S.resolve(f);return g.then(function(i){return _.buildPath(i,t.sPath).slice(1);});};
b.prototype.getGroupId=function(){return this.sGroupId||(this.bRelative&&this.oContext&&this.oContext.getGroupId&&this.oContext.getGroupId())||this.oModel.getGroupId();};
b.prototype.getRelativePath=function(p){var R;if(p[0]==="/"){R=_.getRelativePath(p,this.getResolvedPath());if(R===undefined&&this.oReturnValueContext){R=_.getRelativePath(p,this.oReturnValueContext.getPath());}return R;}return p;};
b.prototype.getResumeChangeReason=function(){var e=this.sResumeChangeReason;this.getDependentBindings().forEach(function(D){var f=D.getResumeChangeReason();if(f&&h(f,e)){e=f;}});return e;};
b.prototype.getRootBinding=function(){if(this.bRelative){if(!this.oContext){return undefined;}if(this.oContext.getBinding){return this.oContext.getBinding().getRootBinding();}}return this;};
b.prototype.getRootBindingResumePromise=function(){var R=this.getRootBinding();return R&&R.getResumePromise()||S.resolve();};
b.prototype.getUpdateGroupId=function(){return this.sUpdateGroupId||(this.bRelative&&this.oContext&&this.oContext.getUpdateGroupId&&this.oContext.getUpdateGroupId())||this.oModel.getUpdateGroupId();};
b.prototype.hasPendingChanges=function(i){return this.isResolved()&&(this.hasPendingChangesForPath("",i)||this.hasPendingChangesInDependents(i));};
b.prototype.hasPendingChangesForPath=function(p,i){return this.withCache(function(o,e,B){return o.hasPendingChangesForPath(e,i,i&&B.isRoot());},p,true).unwrap();};
b.prototype.hasPendingChangesInCaches=function(R){var t=this;if(!this.mCacheByResourcePath){return false;}return Object.keys(this.mCacheByResourcePath).some(function(e){var o=t.mCacheByResourcePath[e];return o.$deepResourcePath.startsWith(R)&&o.hasPendingChangesForPath("");});};
b.prototype.isInitial=function(){throw new Error("Unsupported operation: isInitial");};
b.prototype.isRoot=function(){return!this.bRelative||this.oContext&&!this.oContext.getBinding;};
b.prototype.isRootBindingSuspended=function(){var R=this.getRootBinding();return R&&R.isSuspended();};
b.prototype.lockGroup=function(g,l,m,f){g=g||(m?this.getUpdateGroupId():this.getGroupId());return this.oModel.lockGroup(g,this,l,m,f);};
b.prototype.refresh=function(g){if(typeof g==="boolean"){throw new Error("Unsupported parameter bForceUpdate");}this.requestRefresh(g).catch(this.oModel.getReporter());};
b.prototype.refreshSuspended=function(g){if(g&&g!==this.getGroupId()){throw new Error(this+": Cannot refresh a suspended binding with group ID '"+g+"' (own group ID is '"+this.getGroupId()+"')");}this.setResumeChangeReason(C.Refresh);};
b.prototype.removeCachesAndMessages=function(R,e){var t=this;if(!e&&this.oCache){this.oCache.removeMessages();}if(this.mCacheByResourcePath){Object.keys(this.mCacheByResourcePath).forEach(function(f){var o=t.mCacheByResourcePath[f],D=o.$deepResourcePath;if(_.hasPathPrefix(D,R)){if(!e){o.removeMessages();}delete t.mCacheByResourcePath[f];}});}};
b.prototype.requestAbsoluteSideEffects=function(g,A){var p=[],m=_.getMetaPath(this.getResolvedPath());A.some(function(e){var R=_.getRelativePath(e,m);if(R!==undefined){p.push(R);}else if(_.hasPathPrefix(m,e)){p=[""];return true;}});if(p.length){if(this.requestSideEffects){return this.requestSideEffects(g,p);}return this.refreshInternal("",g,true,true);}};
b.prototype.requestRefresh=function(g){if(!this.isRoot()){throw new Error("Refresh on this binding is not supported");}if(this.hasPendingChanges()){throw new Error("Cannot refresh due to pending changes");}this.oModel.checkGroupId(g);return Promise.resolve(this.refreshInternal("",g,true)).then(function(){});};
b.prototype.resetChanges=function(){var p=[];this.checkSuspended();this.resetChangesForPath("",p);this.resetChangesInDependents(p);this.resetInvalidDataState();return Promise.all(p).then(function(){});};
b.prototype.resetChangesForPath=function(p,P){P.push(this.withCache(function(o,e){o.resetChangesForPath(e);},p).unwrap());};
b.prototype.resetInvalidDataState=function(){};
b.prototype.setResumeChangeReason=function(e){if(h(e,this.sResumeChangeReason)){this.sResumeChangeReason=e;}};
b.prototype.toString=function(){return this.getMetadata().getName()+": "+(this.bRelative?this.oContext+"|":"")+this.sPath;};
b.prototype.withCache=function(p,P,e,w){var o=e?S.resolve(this.oCache):this.oCachePromise,R,t=this;P=P||"";return o.then(function(f){if(f){R=t.getRelativePath(P);if(R!==undefined){return p(f,R,t);}}else if(f===undefined){return undefined;}else if(t.oOperation){return w?p(null,t.getRelativePath(P),t):undefined;}if(t.bRelative&&t.oContext&&t.oContext.withCache){return t.oContext.withCache(p,P[0]==="/"?P:_.buildPath(t.sPath,P),e,w);}return undefined;});};
function d(p){if(this){b.apply(this,arguments);}else{Object.assign(p,b.prototype);}}
["adjustPredicate","destroy","doDeregisterChangeListener","hasPendingChangesForPath"].forEach(function(m){d.prototype[m]=b.prototype[m];});return d;},false);
sap.ui.predefine('sap/ui/model/odata/v4/ODataContextBinding',["./Context","./ODataParentBinding","./lib/_Cache","./lib/_GroupLock","./lib/_Helper","sap/ui/base/SyncPromise","sap/ui/model/Binding","sap/ui/model/ChangeReason","sap/ui/model/ContextBinding"],function(C,a,_,b,c,S,B,d,f){"use strict";var s="sap.ui.model.odata.v4.ODataContextBinding",m={AggregatedDataStateChange:true,change:true,dataReceived:true,dataRequested:true,DataStateChange:true,patchCompleted:true,patchSent:true};
function g(p,r){var e=p.slice(0,p.lastIndexOf("/")),i=e.indexOf("(");return(i<0?e:p.slice(0,i))+r;}
var O=f.extend("sap.ui.model.odata.v4.ODataContextBinding",{
constructor:function(M,p,o,P){var i=p.indexOf("(...)"),t=this;f.call(this,M,p);a.call(this);if(p.endsWith("/")){throw new Error("Invalid path: "+p);}this.oOperation=undefined;this.oParameterContext=null;this.oReturnValueContext=null;if(i>=0){if(i!==this.sPath.length-5){throw new Error("The path must not continue after a deferred operation: "+this.sPath);}this.oOperation={bAction:undefined,mChangeListeners:{},mParameters:{},sResourcePath:undefined};if(!this.bRelative){this.oParameterContext=C.create(this.oModel,this,this.sPath+"/$Parameter");}}P=c.clone(P)||{};this.checkBindingParameters(P,["$$canonicalPath","$$groupId","$$inheritExpandSelect","$$ownRequest","$$patchWithoutSideEffects","$$updateGroupId"]);this.sGroupId=P.$$groupId;this.bInheritExpandSelect=P.$$inheritExpandSelect;this.sUpdateGroupId=P.$$updateGroupId;this.applyParameters(P);this.oElementContext=this.bRelative?null:C.createNewContext(this.oModel,this,p);if(!this.oOperation&&(!this.bRelative||o&&!o.fetchValue)){this.createReadGroupLock(this.getGroupId(),true);}this.setContext(o);M.bindingCreated(this);Promise.resolve().then(function(){t.bInitial=false;});},
metadata:{publicMethods:[]}
});
a(O.prototype);
O.prototype._delete=function(G,e,h,i,D){var E=this._findEmptyPathParentContext(this.oElementContext),o=E.getBinding();if(!o.execute){return this.fetchValue("",undefined,true).then(function(j){return E._delete(G,j,D);});}return this.deleteFromCache(G,e,"",null,D,function(){o._destroyContextAfterDelete();});};
O.prototype._destroyContextAfterDelete=function(){this.oElementContext.destroy();this.oElementContext=null;if(this.oReturnValueContext){this.oReturnValueContext.destroy();this.oReturnValueContext=null;}this._fireChange({reason:d.Remove});};
O.prototype._execute=function(G,p,i,o,r){var M=this.oModel.getMetaModel(),e,P,R=this.getResolvedPathWithReplacedTransientPredicates(),h=c.getMetaPath(R),t=this;function j(){t._fireChange({reason:d.Change});return t.refreshDependentBindings("",G.getGroupId(),true);}P=M.fetchObject(h+"/@$ui5.overload").then(function(k){var l,I,n;if(!k){e=M.getObject(h);if(!e||e.$kind!=="NavigationProperty"||!r){throw new Error("Unknown operation: "+R);}}else if(k.length!==1){throw new Error("Expected a single overload, but found "+k.length+" for "+R);}else{e=k[0];}if(t.bRelative&&t.oContext.getBinding){I=t.sPath.lastIndexOf("/");n=I>=0?t.sPath.slice(0,I):"";l=t.oContext.getValue.bind(t.oContext,n);}return t.createCacheAndRequest(G,R,e,p,l,i,o);}).then(function(k){return j().then(function(){var l,n,q,u;if(t.isReturnValueLikeBindingParameter(e)){n=t.oContext.getValue();l=n&&c.getPrivateAnnotation(n,"predicate");q=c.getPrivateAnnotation(k,"predicate");if(l===q){t.oContext.patch(k);}}if(t.hasReturnValueContext(e)){if(t.oReturnValueContext){t.oReturnValueContext.destroy();}if(r){t.oCache=null;t.oCachePromise=S.resolve(null);u=t.oContext.getBinding().doReplaceWith(t.oContext,k,q);u.setNewGeneration();return u;}t.oReturnValueContext=C.createNewContext(t.oModel,t,g(R,q));t.oCache.setResourcePath(t.oReturnValueContext.getPath().slice(1));return t.oReturnValueContext;}else if(r){throw new Error("Cannot replace w/o return value context");}});},function(E){c.adjustTargetsInError(E,e,t.oParameterContext.getPath(),t.bRelative?t.oContext.getPath():undefined);return j().then(function(){throw E;});}).catch(function(E){G.unlock(true);if(t.oReturnValueContext){t.oReturnValueContext.destroy();t.oReturnValueContext=null;}t.oModel.reportError("Failed to execute "+R,s,E);throw E;});return Promise.resolve(P);};
O.prototype.adjustPredicate=function(t,p){a.prototype.adjustPredicate.apply(this,arguments);if(this.mCacheQueryOptions){this.fetchCache(this.oContext,true);}if(this.oElementContext){this.oElementContext.adjustPredicate(t,p);}};
O.prototype.applyParameters=function(p,e){this.mQueryOptions=this.oModel.buildQueryOptions(p,true);this.mParameters=p;if(this.isRootBindingSuspended()){if(!this.oOperation){this.sResumeChangeReason=d.Change;}}else if(!this.oOperation){this.fetchCache(this.oContext);if(e){this.refreshInternal("",undefined,true).catch(this.oModel.getReporter());}}else if(this.oOperation.bAction===false){this.execute().catch(this.oModel.getReporter());}};
O.prototype.attachEvent=function(e,h,i,j){if(!(e in m)){throw new Error("Unsupported event '"+e+"': v4.ODataContextBinding#attachEvent");}return f.prototype.attachEvent.apply(this,arguments);};
O.prototype.computeOperationQueryOptions=function(){return Object.assign({},this.oModel.mUriParameters,this.getQueryOptionsFromParameters());};
O.prototype.checkKeepAlive=function(){throw new Error("Unsupported "+this);};
O.prototype.createCacheAndRequest=function(G,p,o,P,e,i,h){var A=o.$kind==="Action",j,E=e,M=this.oModel,k=c.getMetaPath(p),l=p.slice(1),r=M.oRequestor,t=this;function n(R){if(t.hasReturnValueContext(o)){return g(l,c.getPrivateAnnotation(R,"predicate"));}if(t.isReturnValueLikeBindingParameter(o)&&c.getPrivateAnnotation(E,"predicate")===c.getPrivateAnnotation(R,"predicate")){return l.slice(0,l.lastIndexOf("/"));}return l;}function q(u){var R;c.adjustTargetsInError(u,o,t.oParameterContext.getPath(),t.bRelative?t.oContext.getPath():undefined);u.error.$ignoreTopLevel=true;R=h(c.extractMessages(u).map(function(v){return t.oModel.createUI5Message(v);}));if(!(R instanceof Promise)){throw new Error("Not a promise: "+R);}return R;}if(h&&o.$kind!=="Action"){throw new Error("Not an action: "+p);}if(!A&&o.$kind!=="Function"&&o.$kind!=="NavigationProperty"){throw new Error("Not an operation: "+p);}if(A&&e){E=e();}if(i&&!(A&&o.$IsBound&&E)){throw new Error("Not a bound action: "+p);}if(this.bInheritExpandSelect&&!this.isReturnValueLikeBindingParameter(o)){throw new Error("Must not set parameter $$inheritExpandSelect on this binding");}if(o.$kind!=="NavigationProperty"){k+="/@$ui5.overload/0/$ReturnType";if(o.$ReturnType&&!o.$ReturnType.$Type.startsWith("Edm.")){k+="/$Type";}}else if(Object.keys(P).length){throw new Error("Unsupported parameters for navigation property");}this.oOperation.bAction=A;this.oOperation.mRefreshParameters=P;P=Object.assign({},P);this.mCacheQueryOptions=this.computeOperationQueryOptions();p=r.getPathAndAddQueryOptions(p,o,P,this.mCacheQueryOptions,E);j=_.createSingle(r,p,this.mCacheQueryOptions,M.bAutoExpandSelect,M.bSharedRequests,n,A,k);this.oCache=j;this.oCachePromise=S.resolve(j);return A?j.post(G,P,E,i,h&&q):j.fetchValue(G);};
O.prototype.destroy=function(){if(this.oElementContext){this.oElementContext.destroy();this.oElementContext=undefined;}if(this.oParameterContext){this.oParameterContext.destroy();this.oParameterContext=undefined;}if(this.oReturnValueContext){this.oReturnValueContext.destroy();this.oReturnValueContext=undefined;}this.oModel.bindingDestroyed(this);this.oOperation=undefined;this.mParameters=undefined;this.mQueryOptions=undefined;a.prototype.destroy.call(this);f.prototype.destroy.call(this);};
O.prototype.doCreateCache=function(r,q,e,D){return _.createSingle(this.oModel.oRequestor,r,q,this.oModel.bAutoExpandSelect,this.oModel.bSharedRequests,function(){return D;});};
O.prototype.doDeregisterChangeListener=function(p,l){if(this.oOperation&&(p==="$Parameter"||p.startsWith("$Parameter/"))){c.removeByPath(this.oOperation.mChangeListeners,p.slice(11),l);return;}a.prototype.doDeregisterChangeListener.apply(this,arguments);};
O.prototype.doFetchQueryOptions=function(o){return this.fetchResolvedQueryOptions(o);};
O.prototype.doSetProperty=function(p,v,G){if(this.oOperation&&(p==="$Parameter"||p.startsWith("$Parameter/"))){c.updateAll(this.oOperation.mChangeListeners,"",this.oOperation.mParameters,_.makeUpdateData(p.split("/").slice(1),v));this.oOperation.bAction=undefined;if(G){G.unlock();}return S.resolve();}};
O.prototype.doSuspend=function(){if(this.bInitial&&!this.oOperation){this.sResumeChangeReason=d.Change;}};
O.prototype.execute=function(G,i,o,r){var R=this.getResolvedPath();this.checkSuspended();this.oModel.checkGroupId(G);if(!this.oOperation){throw new Error("The binding must be deferred: "+this.sPath);}if(this.bRelative){if(!R){throw new Error("Unresolved binding: "+this.sPath);}if(this.oContext.isTransient&&this.oContext.isTransient()){throw new Error("Execute for transient context not allowed: "+R);}if(this.oContext.getPath().includes("(...)")){throw new Error("Nested deferred operation bindings not supported: "+R);}if(r){if(!this.oContext.getBinding||this.oContext.iIndex===undefined){throw new Error("Cannot replace this parent context: "+this.oContext);}this.oContext.getBinding().checkKeepAlive(this.oContext);}}else if(r){throw new Error("Cannot replace when operation is not relative");}return this._execute(this.lockGroup(G,true),c.publicClone(this.oOperation.mParameters,true),i,o,r);};
O.prototype.fetchValue=function(p,l,e){var o=e&&this.oCache!==undefined?S.resolve(this.oCache):this.oCachePromise,E,r=this.getRootBinding(),t=this;if(r&&r.isSuspended()){E=new Error("Suspended binding provides no value");E.canceled="noDebugLog";throw E;}return o.then(function(h){var D=false,G,R=t.getResolvedPath(),i=h||t.oOperation?t.getRelativePath(p):undefined,j,v;if(t.oOperation){if(i===undefined){return t.oContext.fetchValue(p,l,e);}j=i.split("/");if(j[0]==="$Parameter"){if(j.length===1){return undefined;}c.addByPath(t.oOperation.mChangeListeners,i.slice(11),l);v=c.drillDown(t.oOperation.mParameters,j.slice(1));return v===undefined?null:v;}}if(h&&i!==undefined){if(e){G=b.$cached;}else{G=t.oReadGroupLock||t.lockGroup();t.oReadGroupLock=undefined;}return t.resolveRefreshPromise(h.fetchValue(G,i,function(){D=true;t.fireDataRequested();},l)).then(function(v){t.assertSameCache(h);return v;}).then(function(v){if(D){t.fireDataReceived({data:{}});}return v;},function(E){G.unlock(true);if(D){t.oModel.reportError("Failed to read path "+R,s,E);t.fireDataReceived(E.canceled?{data:{}}:{error:E});}throw E;});}if(!t.oOperation&&t.oContext){return t.oContext.fetchValue(p,l,e);}});};
O.prototype.getDependentBindings=function(){return this.oModel.getDependentBindings(this);};
O.prototype.getParameterContext=function(){if(!this.oOperation){throw new Error("Not a deferred operation binding: "+this);}return this.oParameterContext;};
O.prototype.getQueryOptionsFromParameters=function(){var i,q=this.mQueryOptions;if(this.bInheritExpandSelect){i=this.oContext.getBinding().getInheritableQueryOptions();q=Object.assign({},q);if("$select"in i){q.$select=q.$select&&q.$select.slice();c.addToSelect(q,i.$select);}if("$expand"in i){q.$expand=i.$expand;}}return q;};
O.prototype.getResolvedPathWithReplacedTransientPredicates=function(){var p="",r=this.getResolvedPath(),e,t=this;if(r&&r.includes("($uid=")){e=r.slice(1).split("/");r="";e.forEach(function(h){var E,P,T;p+="/"+h;T=h.indexOf("($uid=");if(T>=0){E=t.oContext.getValue(p);P=E&&c.getPrivateAnnotation(E,"predicate");if(!P){throw new Error("No key predicate known at "+p);}r+="/"+h.slice(0,T)+P;}else{r+="/"+h;}});}return r;};
O.prototype.hasReturnValueContext=function(M){var e;if(!this.isReturnValueLikeBindingParameter(M)){return false;}e=c.getMetaPath(this.getResolvedPath()).split("/");return e.length===3&&this.oModel.getMetaModel().getObject("/"+e[1]).$kind==="EntitySet";};
O.prototype.initialize=function(){this.bInitial=false;if(this.isResolved()&&!this.getRootBinding().isSuspended()){this._fireChange({reason:d.Change});}};
O.prototype.isReturnValueLikeBindingParameter=function(M){var p,P;if(!(this.bRelative&&this.oContext&&this.oContext.getBinding)){return false;}if(M.$kind==="NavigationProperty"){if(M.$isCollection||this.sPath.includes("/")){return false;}P=c.getMetaPath(this.oContext.getPath());if(P.lastIndexOf("/")>0){return false;}p=this.oModel.getMetaModel().getObject(P);return p.$kind==="EntitySet"&&p.$Type===M.$Type&&p.$NavigationPropertyBinding&&p.$NavigationPropertyBinding[this.sPath.slice(0,-5)]===P.slice(1);}return M.$IsBound&&M.$ReturnType&&!M.$ReturnType.$isCollection&&M.$EntitySetPath&&!M.$EntitySetPath.includes("/");};
O.prototype.moveEntityTo=function(l){if(!this.isRoot()){throw new Error(this+": must be a root binding");}if(this.oOperation){throw new Error(this+": must not be an operation binding");}if(this.hasPendingChanges()){throw new Error(this+": has pending changes");}l.moveEntityHere(this.oElementContext);this.oElementContext=null;};
O.prototype.refreshInternal=function(r,G,e,k){var t=this;if(this.oOperation&&this.oOperation.bAction!==false){return S.resolve();}if(this.isRootBindingSuspended()){this.refreshSuspended(G);return this.refreshDependentBindings(r,G,e,k);}this.createReadGroupLock(G,this.isRoot());return this.oCachePromise.then(function(o){var h,p=t.oRefreshPromise,R=t.oReadGroupLock;if(!t.oElementContext){t.oElementContext=C.create(t.oModel,t,t.getResolvedPath());if(!o){t._fireChange({reason:d.Refresh});}}if(t.oOperation){t.oReadGroupLock=undefined;return t._execute(R,t.oOperation.mRefreshParameters);}if(o&&!p){h=o.hasChangeListeners();t.removeCachesAndMessages(r);t.fetchCache(t.oContext,false,false,k);p=h?t.createRefreshPromise():undefined;if(k&&p){p=p.catch(function(E){return t.fetchResourcePath(t.oContext).then(function(i){if(!t.bRelative||o.getResourcePath()===i){t.oCache=o;t.oCachePromise=S.resolve(o);o.setActive(true);return t.checkUpdateInternal();}}).then(function(){throw E;});});}if(!e){t.fetchValue("").catch(t.oModel.getReporter());}}return S.all([p,t.refreshDependentBindings(r,G,e,k)]);});};
O.prototype.refreshReturnValueContext=function(o,G,k){var e=this.oCache,h=this.mCacheQueryOptions,M=this.oModel,p,t=this;if(this.oReturnValueContext!==o){return null;}this.mCacheQueryOptions=this.computeOperationQueryOptions();if(this.mLateQueryOptions){c.aggregateExpandSelect(this.mCacheQueryOptions,this.mLateQueryOptions);}this.oCache=_.createSingle(M.oRequestor,o.getPath().slice(1),this.mCacheQueryOptions,true,M.bSharedRequests);this.oCachePromise=S.resolve(this.oCache);this.createReadGroupLock(G,true);p=o.refreshDependentBindings("",G,true,k);if(k){p=p.catch(function(E){t.oCache=e;t.oCachePromise=S.resolve(e);t.mCacheQueryOptions=h;e.setActive(true);return o.checkUpdateInternal().then(function(){throw E;});});}return p;};
O.prototype.requestSideEffects=function(G,p,o){var M=this.oModel,n={},P=[],t=this;function r(h){return h.catch(function(E){M.reportError("Failed to request side effects",s,E);if(!E.canceled){throw E;}});}if(p.indexOf("")<0){try{P.push(this.oCache.requestSideEffects(this.lockGroup(G),p,n,o&&o.getPath().slice(1)));this.visitSideEffects(G,p,o,n,P);return S.all(P.map(r)).then(function(){return t.refreshDependentListBindingsWithoutCache();});}catch(e){if(!e.message.startsWith("Unsupported collection-valued navigation property ")){throw e;}}}return o&&this.refreshReturnValueContext(o,G,true)||this.refreshInternal("",G,true,true);};
O.prototype.requestObject=function(p){return this.oElementContext?this.oElementContext.requestObject(p):Promise.resolve();};
O.prototype.resumeInternal=function(e,p){var r=this.sResumeChangeReason,t=this;function h(){t.getDependentBindings().forEach(function(D){D.resumeInternal(e,!!r);});}this.sResumeChangeReason=undefined;if(this.oOperation){h();return;}if(p||r){this.mAggregatedQueryOptions={};this.bAggregatedQueryOptionsInitial=true;this.removeCachesAndMessages("");this.fetchCache(this.oContext);}h();if(r){this._fireChange({reason:r});}};
O.prototype.setContext=function(o){if(this.oContext!==o){if(this.bRelative&&(this.oContext||o)){this.checkSuspended(true);if(this.oElementContext){this.oElementContext.destroy();this.oElementContext=null;}if(this.oReturnValueContext){this.oReturnValueContext.destroy();this.oReturnValueContext=null;}if(this.oParameterContext){this.oParameterContext.destroy();this.oParameterContext=null;}this.fetchCache(o);if(o){this.oElementContext=C.create(this.oModel,this,this.oModel.resolve(this.sPath,o));if(this.oOperation){this.oParameterContext=C.create(this.oModel,this,this.oModel.resolve(this.sPath+"/$Parameter",o));}}B.prototype.setContext.call(this,o);}else{this.oContext=o;}}};
O.prototype.setParameter=function(p,v){var o;if(!this.oOperation){throw new Error("The binding must be deferred: "+this.sPath);}if(!p){throw new Error("Missing parameter name");}if(v===undefined){throw new Error("Missing value for parameter: "+p);}o=this.oOperation.mParameters[p];this.oOperation.mParameters[p]=v;c.informAll(this.oOperation.mChangeListeners,p,o,v);this.oOperation.bAction=undefined;return this;};
return O;});
sap.ui.predefine('sap/ui/model/odata/v4/ODataListBinding',["./Context","./ODataParentBinding","./lib/_AggregationCache","./lib/_AggregationHelper","./lib/_Cache","./lib/_GroupLock","./lib/_Helper","./lib/_Parser","sap/base/Log","sap/base/util/uid","sap/ui/base/SyncPromise","sap/ui/model/Binding","sap/ui/model/ChangeReason","sap/ui/model/Filter","sap/ui/model/FilterOperator","sap/ui/model/FilterProcessor","sap/ui/model/FilterType","sap/ui/model/ListBinding","sap/ui/model/Sorter","sap/ui/model/odata/OperationMode"],function(C,a,_,b,c,d,e,f,L,u,S,B,g,F,h,j,k,l,m,O){"use strict";var s="sap.ui.model.odata.v4.ODataListBinding",n={AggregatedDataStateChange:true,change:true,createActivate:true,createCompleted:true,createSent:true,dataReceived:true,dataRequested:true,DataStateChange:true,patchCompleted:true,patchSent:true,refresh:true};
var o=l.extend("sap.ui.model.odata.v4.ODataListBinding",{constructor:function(M,p,i,v,q,P){l.call(this,M,p);a.call(this);if(p.endsWith("/")){throw new Error("Invalid path: "+p);}P=e.clone(P)||{};this.checkBindingParameters(P,["$$aggregation","$$canonicalPath","$$groupId","$$operationMode","$$ownRequest","$$patchWithoutSideEffects","$$sharedRequest","$$updateGroupId"]);this.iActiveContexts=0;this.aApplicationFilters=e.toArray(q);this.sChangeReason=M.bAutoExpandSelect&&!P.$$aggregation?"AddVirtualContext":undefined;this.iCreatedContexts=0;this.oDiff=undefined;this.aFilters=[];this.sGroupId=P.$$groupId;this.bHasAnalyticalInfo=false;this.oHeaderContext=this.bRelative?null:C.createNewContext(M,this,p);this.sOperationMode=P.$$operationMode||M.sOperationMode;this.mPreviousContextsByPath={};this.aPreviousData=[];this.bSharedRequest=P.$$sharedRequest||M.bSharedRequests;this.aSorters=e.toArray(v);this.sUpdateGroupId=P.$$updateGroupId;if(!this.sOperationMode&&(this.aSorters.length||this.aApplicationFilters.length)){throw new Error("Unsupported operation mode: "+this.sOperationMode);}this.applyParameters(P);if(!this.bRelative||i&&!i.fetchValue){this.createReadGroupLock(this.getGroupId(),true);}this.setContext(i);M.bindingCreated(this);}});
a(o.prototype);
o.prototype.attachCreateActivate=function(i,p){this.attachEvent("createActivate",i,p);};
o.prototype.detachCreateActivate=function(i,p){this.detachEvent("createActivate",i,p);};
o.prototype.attachCreateCompleted=function(i,p){this.attachEvent("createCompleted",i,p);};
o.prototype.detachCreateCompleted=function(i,p){this.detachEvent("createCompleted",i,p);};
o.prototype.attachCreateSent=function(i,p){this.attachEvent("createSent",i,p);};
o.prototype.detachCreateSent=function(i,p){this.detachEvent("createSent",i,p);};
o.prototype._delete=function(G,E,p,q,D){var r,t=false,P=p.iIndex===undefined?e.getRelativePath(p.getPath(),this.oHeaderContext.getPath()):String(p.iIndex),R=false,v=this;return this.deleteFromCache(G,E,P,q,D,function(I,w){var x,y,z,A,i;if(p.isKeepAlive()){p.resetKeepAlive();r=true;}if(p.created()){v.destroyCreated(p);t=true;}else if(I>=0){for(i=I;i<v.aContexts.length;i+=1){p=v.aContexts[i];if(p){v.mPreviousContextsByPath[p.getPath()]=p;}}z=v.getResolvedPath();v.aContexts.splice(I,1);for(i=I;i<v.aContexts.length;i+=1){if(v.aContexts[i]){A=i-v.iCreatedContexts;y=e.getPrivateAnnotation(w[i],"predicate");x=z+(y||"/"+A);p=v.mPreviousContextsByPath[x];if(p){delete v.mPreviousContextsByPath[x];if(p.iIndex===A){p.checkUpdate();}else{p.iIndex=A;}}else{p=C.create(v.oModel,v,x,A);}v.aContexts[i]=p;}}v.iMaxLength-=1;t=true;}else if(v.bLengthFinal){R=true;}}).then(function(){var i=v.iMaxLength;if(R){v.iMaxLength=v.fetchValue("$count",undefined,true).getResult()-v.iActiveContexts;t=i!==v.iMaxLength;}if(t){v._fireChange({reason:g.Remove});}else if(r){delete v.mPreviousContextsByPath[p.getPath()];p.destroy();}});};
o.prototype.adjustPredicate=function(t,p,i){var q=this;function r(v,N){var I=q.aPreviousData.indexOf(v);if(I>=0){q.aPreviousData[I]=N;}}if(i){i.adjustPredicate(t,p,r);}else{a.prototype.adjustPredicate.apply(this,arguments);if(this.mCacheQueryOptions){this.fetchCache(this.oContext,true);}this.oHeaderContext.adjustPredicate(t,p);this.aContexts.forEach(function(i){i.adjustPredicate(t,p,r);});}};
o.prototype.applyParameters=function(p,i){var A,q=this.mParameters&&this.mParameters.$$aggregation,r=this.mQueryOptions&&this.mQueryOptions.$apply;if("$$aggregation"in p){if("$apply"in p){throw new Error("Cannot combine $$aggregation and $apply");}A=b.buildApply(p.$$aggregation).$apply;}this.mQueryOptions=this.oModel.buildQueryOptions(p,true);this.mParameters=p;if(A){this.mQueryOptions.$apply=A;}if(i===""){if(this.mQueryOptions.$apply===r&&(!this.mParameters.$$aggregation||!q||e.deepEqual(this.mParameters.$$aggregation,q))){return;}i=this.bHasAnalyticalInfo?g.Change:g.Filter;}if(this.isRootBindingSuspended()){this.setResumeChangeReason(i);return;}this.removeCachesAndMessages("");this.fetchCache(this.oContext);this.reset(i);if(this.oHeaderContext){this.oHeaderContext.checkUpdate();}};
o.prototype.attachEvent=function(E,i,p,q){if(!(E in n)){throw new Error("Unsupported event '"+E+"': v4.ODataListBinding#attachEvent");}return l.prototype.attachEvent.apply(this,arguments);};
o.prototype._checkDataStateMessages=function(D,r){if(r){D.setModelMessages(this.oModel.getMessagesByPath(r,true));}};
o.prototype.checkKeepAlive=function(i){if(this.isRelative()&&!this.mParameters.$$ownRequest){throw new Error("Missing $$ownRequest at "+this);}if(i===this.oHeaderContext){throw new Error("Unsupported header context "+i);}if(this.mParameters.$$aggregation){throw new Error("Unsupported $$aggregation at "+this);}if(this.bSharedRequest){throw new Error("Unsupported $$sharedRequest at "+this);}};
o.prototype.collapse=function(p){var q=this.aContexts,r=this.oCache.collapse(e.getRelativePath(p.getPath(),this.oHeaderContext.getPath())),M=p.getModelIndex(),i,t=this;if(r>0){q.splice(M+1,r).forEach(function(p){t.mPreviousContextsByPath[p.getPath()]=p;});for(i=M+1;i<q.length;i+=1){if(q[i]){q[i].iIndex=i;}}this.iMaxLength-=r;this._fireChange({reason:g.Change});}};
o.prototype.create=function(i,p,A,I){var q,r=this.fetchResourcePath(),t,G=this.getUpdateGroupId(),v,R=this.getResolvedPath(),T="($uid="+u()+")",w=R+T,x=this;if(!R){throw new Error("Binding is unresolved: "+this);}this.checkSuspended();A=!!A;if(A&&!(this.bLengthFinal||this.mParameters.$count)){throw new Error("Must know the final length to create at the end. Consider setting $count");}if(this.bCreatedAtEnd!==undefined&&this.bCreatedAtEnd!==A){throw new Error("Creating entities at the start and at the end is not supported.");}if(I){if(this.isRelative()&&!this.mParameters.$$ownRequest){throw new Error("Missing $$ownRequest at "+this);}if(!this.oModel.isAutoGroup(G)){throw new Error("bInactive only supported for update group with SubmitMode.Auto: "+this);}G="$inactive."+G;}else{this.iActiveContexts+=1;}this.bCreatedAtEnd=A;v=this.lockGroup(G,true,true,function(){x.destroyCreated(q);return Promise.resolve().then(function(){x._fireChange({reason:g.Remove});});});t=this.createInCache(v,r,R,T,i,function(E){x.oModel.reportError("POST on '"+r+"' failed; will be repeated automatically",s,E);x.fireEvent("createCompleted",{context:q,success:false});},function(){x.fireEvent("createSent",{context:q});}).then(function(y){var G,P;if(!(i&&i["@$ui5.keepTransientPath"])){P=e.getPrivateAnnotation(y,"predicate");if(P){x.adjustPredicate(T,P,q);x.oModel.checkMessages();}}x.fireEvent("createCompleted",{context:q,success:true});G=x.getGroupId();if(p){return q.refreshDependentBindings(q.getPath().slice(1),G,true);}if(!x.oModel.isDirectGroup(G)&&!x.oModel.isAutoGroup(G)){G="$auto";}return x.refreshSingle(q,x.lockGroup(G));},function(E){v.unlock(true);throw E;});this.iCreatedContexts+=1;q=C.create(this.oModel,this,w,-this.iCreatedContexts,t,I);this.aContexts.unshift(q);this._fireChange({reason:g.Add});return q;};
o.prototype.createContexts=function(p,r){var q=false,t,v,w=r.$count,x,y=this.bLengthFinal,M=this.oModel,P=this.getResolvedPath(),z,A,D=p>this.aContexts.length,i,E=this;function G(){var N=E.iMaxLength+E.iCreatedContexts,i;if(N>=E.aContexts.length){return;}for(i=N;i<E.aContexts.length;i+=1){if(E.aContexts[i]){E.aContexts[i].destroy();}}while(N>0&&!E.aContexts[N-1]){N-=1;}E.aContexts.length=N;q=true;}for(i=0;i<r.length;i+=1){if(this.aContexts[p+i]===undefined&&r[i]){q=true;x=p+i-this.iCreatedContexts;z=e.getPrivateAnnotation(r[i],"predicate")||e.getPrivateAnnotation(r[i],"transientPredicate");v=P+(z||"/"+x);t=this.mPreviousContextsByPath[v];if(t&&(!t.created()||t.isTransient())){delete this.mPreviousContextsByPath[v];if(t.isTransient()&&!this.iCreatedContexts){this.iCreatedContexts=this.iActiveContexts=-t.iIndex;}else{t.iIndex=x;}t.checkUpdate();}else{t=C.create(M,this,v,x);}this.aContexts[p+i]=t;}}A=Object.keys(this.mPreviousContextsByPath);if(A.length){M.addPrerenderingTask(this.destroyPreviousContexts.bind(this,A));}if(w!==undefined){this.bLengthFinal=true;this.iMaxLength=w-this.iActiveContexts;G();}else{if(!r.length){this.iMaxLength=p-this.iCreatedContexts;G();}else if(this.aContexts.length>this.iMaxLength+this.iCreatedContexts){this.iMaxLength=Infinity;}if(!(D&&r.length===0)){this.bLengthFinal=this.aContexts.length===this.iMaxLength+this.iCreatedContexts;}}if(this.bLengthFinal!==y){q=true;}return q;};
o.prototype.destroy=function(){if(this.bHasAnalyticalInfo&&this.aContexts===undefined){return;}this.aContexts.forEach(function(i){i.destroy();});this.destroyPreviousContexts();if(this.oHeaderContext){this.oHeaderContext.destroy();}this.oModel.bindingDestroyed(this);this.aApplicationFilters=undefined;this.aContexts=undefined;this.oDiff=undefined;this.aFilters=undefined;this.oHeaderContext=undefined;this.mPreviousContextsByPath=undefined;this.aPreviousData=undefined;this.mQueryOptions=undefined;this.aSorters=undefined;a.prototype.destroy.call(this);l.prototype.destroy.call(this);};
o.prototype.destroyCreated=function(p){var I=p.getModelIndex(),i;this.iCreatedContexts-=1;if(!p.isInactive()){this.iActiveContexts-=1;}for(i=0;i<I;i+=1){this.aContexts[i].iIndex+=1;}if(!this.iCreatedContexts){this.bCreatedAtEnd=undefined;}this.aContexts.splice(I,1);this.destroyLater(p);};
o.prototype.destroyLater=function(i){if(this.iCurrentEnd){this.mPreviousContextsByPath[i.getPath()]=i;}else{i.destroy();}};
o.prototype.destroyPreviousContexts=function(p){var P=this.mPreviousContextsByPath;if(P){(p||Object.keys(P)).forEach(function(i){var q=P[i];if(q){if(p&&q.isKeepAlive()){q.iIndex=undefined;}else{q.destroy();delete P[i];}}});}};
o.prototype.doCreateCache=function(r,q,i,D,p,t){var v,K,w,x=this;if(t&&t.getResourcePath()===r&&t.$deepResourcePath===D){v=this.oHeaderContext.getPath();K=Object.keys(this.mPreviousContextsByPath).filter(function(P){return x.mPreviousContextsByPath[P].isKeepAlive();});if(!p&&(K.length||this.iCreatedContexts)){t.reset(K.map(function(P){return e.getRelativePath(P,v);}));t.setQueryOptions(q,true);return t;}}w=_.create(this.oModel.oRequestor,r,D,this.mParameters.$$aggregation,this.inheritQueryOptions(q,i),this.oModel.bAutoExpandSelect,this.bSharedRequest);if(K&&K.length){w.setLateQueryOptions(t.getLateQueryOptions());K.forEach(function(P){w.addKeptElement(t.getValue(e.getRelativePath(P,v)));x.mPreviousContextsByPath[P].checkUpdate();});}return w;};
o.prototype.doFetchQueryOptions=function(i){var t=this;return this.fetchResolvedQueryOptions(i).then(function(q){return t.fetchFilter(i,q.$filter).then(function(p){return e.mergeQueryOptions(q,t.getOrderby(q.$orderby),p);});});};
o.prototype.doReplaceWith=function(i,E,p){var I=i.iIndex,K=i.isKeepAlive(),N,q=i.fnOnBeforeDestroy,r,P=this.oHeaderContext.getPath()+p,R=this.mPreviousContextsByPath[P];if(R){if(R===i){return R;}if(R.iIndex!==undefined){throw new Error("Unexpected index: "+R);}R.iIndex=I;delete this.mPreviousContextsByPath[P];}else{R=C.create(this.oModel,this,P,I);N=true;}i.iIndex=undefined;this.aContexts[I]=R;this.oCache.doReplaceWith(I,E);if(K){this.mPreviousContextsByPath[i.getPath()]=i;if(N){if(q){r=(q.$original||q).bind(null,R);r.$original=q;}R.setKeepAlive(true,r);}}else{this.destroyLater(i);}this._fireChange({reason:g.Change});return R;};
o.prototype.doSetProperty=function(){};
o.prototype.expand=function(p){var D=false,t=this;this.checkSuspended();return this.oCache.expand(this.lockGroup(),e.getRelativePath(p.getPath(),this.oHeaderContext.getPath()),function(){D=true;t.fireDataRequested();}).then(function(q){var r=t.aContexts,M,v,i;if(q>0){M=p.getModelIndex();for(i=r.length-1;i>M;i-=1){v=r[i];if(v){v.iIndex+=q;r[i+q]=v;delete r[i];}}t.iMaxLength+=q;t._fireChange({reason:g.Change});}if(D){t.fireDataReceived({});}},function(E){if(D){t.fireDataReceived({error:E});}throw E;});};
o.prototype.fetchContexts=function(i,p,M,G,A,D){var P,t=this;if(this.bCreatedAtEnd){i+=this.iCreatedContexts;}G=G||this.lockGroup();P=this.fetchData(i,p,M,G,D);if(A){P=Promise.resolve(P);}return P.then(function(r){var E;if(!t.aContexts){E=new Error("Binding already destroyed");E.canceled=true;throw E;}return r&&t.createContexts(i,r.value);},function(E){G.unlock(true);throw E;});};
o.prototype.fetchData=function(i,p,M,G,D){var q=this.oContext,t=this;return this.oCachePromise.then(function(r){if(t.bRelative&&q!==t.oContext){return undefined;}if(r){return r.read(i,p,M,G,D).then(function(R){t.assertSameCache(r);return R;});}G.unlock();return q.fetchValue(t.sReducedPath).then(function(R){var v;R=R||[];v=R.$count;R=R.slice(i,i+p);R.$count=v;return{value:R};});});};
o.prototype.fetchDownloadUrl=function(){var U=this.oModel.mUriParameters;if(!this.isResolved()){throw new Error("Binding is unresolved");}return this.withCache(function(i,p){return i.getDownloadUrl(p,U);});};
o.prototype.fetchFilter=function(i,p){var q,r,M,t;function v(z,E,W){var A,D,T,V;function G(H){return T?"tolower("+H+")":H;}T=E==="Edm.String"&&z.bCaseSensitive===false;D=G(decodeURIComponent(z.sPath));V=G(e.formatLiteral(z.oValue1,E));switch(z.sOperator){case h.BT:A=D+" ge "+V+" and "+D+" le "+G(e.formatLiteral(z.oValue2,E));break;case h.NB:A=y(D+" lt "+V+" or "+D+" gt "+G(e.formatLiteral(z.oValue2,E)),W);break;case h.EQ:case h.GE:case h.GT:case h.LE:case h.LT:case h.NE:A=D+" "+z.sOperator.toLowerCase()+" "+V;break;case h.Contains:case h.EndsWith:case h.NotContains:case h.NotEndsWith:case h.NotStartsWith:case h.StartsWith:A=z.sOperator.toLowerCase().replace("not","not ")+"("+D+","+V+")";break;default:throw new Error("Unsupported operator: "+z.sOperator);}return A;}function w(z,A,W){var R;if(!z){return S.resolve();}if(z.aFilters){return S.all(z.aFilters.map(function(D){return w(D,A,z.bAnd);})).then(function(D){return y(D.join(z.bAnd?" and ":" or "),W&&!z.bAnd);});}R=M.resolve(x(z.sPath,A),t);return M.fetchObject(R).then(function(P){var D,E,G;if(!P){throw new Error("Type cannot be determined, no metadata for path: "+R);}G=z.sOperator;if(G===h.All||G===h.Any){D=z.oCondition;E=z.sVariable;if(G===h.Any&&!D){return z.sPath+"/any()";}A=Object.create(A);A[E]=x(z.sPath,A);return w(D,A).then(function(H){return z.sPath+"/"+z.sOperator.toLowerCase()+"("+E+":"+H+")";});}return v(z,P.$Type,W);});}function x(P,z){var A=P.split("/");A[0]=z[A[0]];return A[0]?A.join("/"):P;}function y(z,W){return W?"("+z+")":z;}q=j.combineFilters(this.aFilters,this.aApplicationFilters);if(!q){return S.resolve([p]);}r=b.splitFilter(q,this.mParameters.$$aggregation);M=this.oModel.getMetaModel();t=M.getMetaContext(this.oModel.resolve(this.sPath,i));return S.all([w(r[0],{},p).then(function(z){return z&&p?z+" and ("+p+")":z||p;}),w(r[1],{})]);};
o.prototype.fetchValue=function(p,i,q){var r=q&&this.oCache!==undefined?S.resolve(this.oCache):this.oCachePromise,t=this;return r.then(function(v){var G,R;if(v){G=q?d.$cached:t.lockGroup();R=t.getRelativePath(p);if(R!==undefined){return v.fetchValue(G,R,undefined,i);}}if(t.oContext){return t.oContext.fetchValue(p,i,q);}});};
o.prototype.filter=function(v,i){var p=e.toArray(v);if(this.sOperationMode!==O.Server){throw new Error("Operation mode has to be sap.ui.model.odata.OperationMode.Server");}if(i===k.Control&&e.deepEqual(p,this.aFilters)||e.deepEqual(p,this.aApplicationFilters)){return this;}if(this.hasPendingChanges(true)){throw new Error("Cannot filter due to pending changes");}if(i===k.Control){this.aFilters=p;}else{this.aApplicationFilters=p;}if(this.isRootBindingSuspended()){this.setResumeChangeReason(g.Filter);return this;}this.createReadGroupLock(this.getGroupId(),true);this.removeCachesAndMessages("");this.fetchCache(this.oContext);this.reset(g.Filter);if(this.oHeaderContext){this.oHeaderContext.checkUpdate();}return this;};
o.prototype.fireCreateActivate=function(i){this.iActiveContexts+=1;this.fireEvent("createActivate");};
o.prototype.getAllCurrentContexts=function(){return this.aContexts.filter(function(i){return i;}).concat(Object.values(this.mPreviousContextsByPath));};
o.prototype.getContexts=function(i,p,M,K){var q,r,D=false,t=false,G,P,R=!!this.sChangeReason,v=this.getResolvedPath(),V,w=this;L.debug(this+"#getContexts("+i+", "+p+", "+M+")",undefined,s);this.checkSuspended();i=i||0;if(i!==0&&this.bUseExtendedChangeDetection){throw new Error("Unsupported operation: v4.ODataListBinding#getContexts,"+" iStart must be 0 if extended change detection is enabled, but is "+i);}if(this.bUseExtendedChangeDetection){if(M!==undefined){throw new Error("Unsupported operation: v4.ODataListBinding#getContexts,"+" iMaximumPrefetchSize must not be set if extended change detection is"+" enabled");}if(K){throw new Error("Unsupported operation: v4.ODataListBinding#getContexts,"+" must not use bKeepCurrent if extended change detection is enabled");}}if(M&&K){throw new Error("Unsupported operation: v4.ODataListBinding#getContexts,"+" must not use both iMaximumPrefetchSize and bKeepCurrent");}if(!this.isResolved()){this.aPreviousData=[];return[];}q=this.sChangeReason||g.Change;this.sChangeReason=undefined;if(q==="AddVirtualContext"){this.oModel.addPrerenderingTask(function(){var x=w.bUseExtendedChangeDetection;if(w.aContexts===undefined){V.destroy();return;}if(!w.isRootBindingSuspended()){w.bUseExtendedChangeDetection=false;w.getContexts(i,p,M);w.bUseExtendedChangeDetection=x;}w.oModel.addPrerenderingTask(function(){if(w.aContexts&&!w.isRootBindingSuspended()){w.sChangeReason="RemoveVirtualContext";w._fireChange({detailedReason:"RemoveVirtualContext",reason:g.Change});w.reset(g.Refresh);}V.destroy();});},true);V=C.create(this.oModel,this,v+"/"+C.VIRTUAL,C.VIRTUAL);return[V];}if(q==="RemoveVirtualContext"||(this.oContext&&this.oContext.iIndex===C.VIRTUAL)){return[];}p=p||this.oModel.iSizeLimit;if(!M||M<0){M=0;}G=this.oReadGroupLock;this.oReadGroupLock=undefined;if(!this.oDiff){P=this.fetchContexts(i,p,M,G,R,function(){D=true;w.fireDataRequested();});this.resolveRefreshPromise(P);P.then(function(x){if(w.bUseExtendedChangeDetection){w.oDiff={aDiff:w.getDiff(p),iLength:p};}if(t){if(x||(w.oDiff&&w.oDiff.aDiff.length)){w._fireChange({reason:q});}else{w.oDiff=undefined;}}if(D){w.fireDataReceived({data:{}});}},function(E){if(D){w.fireDataReceived(E.canceled?{data:{}}:{error:E});}throw E;}).catch(function(E){w.oModel.reportError("Failed to get contexts for "+w.oModel.sServiceUrl+v.slice(1)+" with start index "+i+" and length "+p,s,E);});t=true;}if(!K){this.iCurrentBegin=i;this.iCurrentEnd=i+p;}r=this.getContextsInViewOrder(i,p);if(this.bUseExtendedChangeDetection){if(this.oDiff&&p!==this.oDiff.iLength){throw new Error("Extended change detection protocol violation: Expected "+"getContexts(0,"+this.oDiff.iLength+"), but got getContexts(0,"+p+")");}r.dataRequested=!this.oDiff;r.diff=this.oDiff?this.oDiff.aDiff:[];}this.oDiff=undefined;return r;};
o.prototype.getContextsInViewOrder=function(p,q){var r,t,i;if(this.bCreatedAtEnd){r=[];t=Math.min(q,this.getLength()-p);for(i=0;i<t;i+=1){r[i]=this.aContexts[this.getModelIndex(p+i)];}}else{r=this.aContexts.slice(p,p+q);}return r;};
o.prototype.getCount=function(){var H=this.getHeaderContext();return H?H.getProperty("$count"):undefined;};
o.prototype.getCurrentContexts=function(){var i,p=Math.min(this.iCurrentEnd,this.iMaxLength+this.iCreatedContexts)-this.iCurrentBegin;i=this.getContextsInViewOrder(this.iCurrentBegin,p);while(i.length<p){i.push(undefined);}return i;};
o.prototype.getDependentBindings=function(){var t=this;return this.oModel.getDependentBindings(this).filter(function(D){return D.oContext.isKeepAlive()||!(D.oContext.getPath()in t.mPreviousContextsByPath);});};
o.prototype.getDiff=function(i){var p=this.aPreviousData,t=this;this.aPreviousData=this.getContextsInViewOrder(0,i).map(function(q){return t.getContextData(q);});return this.diffData(p,this.aPreviousData);};
o.prototype.getDistinctValues=function(i){throw new Error("Unsupported operation: v4.ODataListBinding#getDistinctValues");};
o.prototype.getDownloadUrl=e.createGetMethod("fetchDownloadUrl",true);
o.prototype.getEntryData=function(i){return JSON.stringify(i.getValue());};
o.prototype.getEntryKey=function(i){return i.getPath();};
o.prototype.getFilterInfo=function(i){var p=j.combineFilters(this.aFilters,this.aApplicationFilters),r=null,q;if(p){r=p.getAST(i);}if(this.mQueryOptions.$filter){q={expression:this.mQueryOptions.$filter,syntax:"OData "+this.oModel.getODataVersion(),type:"Custom"};if(r){r={left:r,op:"&&",right:q,type:"Logical"};}else{r=q;}}return r;};
o.prototype.getGeneration=function(){return this.oHeaderContext.getGeneration(true)||a.prototype.getGeneration.call(this);};
o.prototype.getHeaderContext=function(){return this.isResolved()?this.oHeaderContext:null;};
o.prototype.getModelIndex=function(v){if(!this.bCreatedAtEnd){return v;}if(!this.bLengthFinal){return this.aContexts.length-v-1;}return v<this.getLength()-this.iCreatedContexts?v+this.iCreatedContexts:this.getLength()-v-1;};
o.prototype.getLength=function(){if(this.bLengthFinal){return this.iMaxLength+this.iCreatedContexts;}return this.aContexts.length?this.aContexts.length+10:0;};
o.prototype.getOrderby=function(i){var p=[],t=this;this.aSorters.forEach(function(q){if(q instanceof m){p.push(q.sPath+(q.bDescending?" desc":""));}else{throw new Error("Unsupported sorter: "+q+" - "+t);}});if(i){p.push(i);}return p.join(",");};
o.prototype.getQueryOptions=function(w){var r={},t=this;if(w){throw new Error("Unsupported parameter value: bWithSystemQueryOptions: "+w);}Object.keys(this.mQueryOptions).forEach(function(K){if(K[0]!=="$"){r[K]=e.clone(t.mQueryOptions[K]);}});return r;};
o.prototype.getQueryOptionsFromParameters=function(){return this.mQueryOptions;};
o.prototype.hasPendingChangesForPath=function(i){if(this.oCache===undefined){return this.iActiveContexts>0;}return a.prototype.hasPendingChangesForPath.apply(this,arguments);};
o.prototype.inheritQueryOptions=function(q,i){var I;if(!Object.keys(this.mParameters).length){I=this.getQueryOptionsForPath("",i);if(q.$orderby&&I.$orderby){q.$orderby+=","+I.$orderby;}if(q.$filter&&I.$filter){q.$filter="("+q.$filter+") and ("+I.$filter+")";}q=Object.assign({},I,q);e.aggregateExpandSelect(q,I);}return q;};
o.prototype.initialize=function(){if(this.isResolved()){if(this.getRootBinding().isSuspended()){this.sResumeChangeReason=this.sChangeReason==="AddVirtualContext"?g.Change:g.Refresh;}else if(this.sChangeReason==="AddVirtualContext"){this._fireChange({detailedReason:"AddVirtualContext",reason:g.Change});}else{this.sChangeReason=g.Refresh;this._fireRefresh({reason:g.Refresh});}}};
o.prototype.isLengthFinal=function(){return this.bLengthFinal;};
o.prototype.moveEntityHere=function(E){var i,p,q=E.getPath(),r=E.getBinding().getInheritableQueryOptions(),R=e.getRelativePath(q,this.oHeaderContext.getPath());if(!R||R.includes("/")){throw new Error(this+": "+q+" is not an entity of the collection");}if(!this.getRootBinding().isSuspended()){throw new Error(this+": must be suspended");}this.checkKeepAlive(E);p=E.fetchValue(null,null,true);if(p.isPending()){throw new Error("Cannot move the entity; the context binding has not finished loading: "+E.getBinding());}i=p.getResult();if(!e.getPrivateAnnotation(i,"predicate")){throw new Error("No key predicate known at "+q);}if(!this.aggregateQueryOptions(r,e.getMetaPath(q),true)){throw new Error(E+": could not move the entity. Probably a list binding"+" w/o $$ownRequest depends on it");}this.getRootBinding().resume();E.oBinding=this;this.mPreviousContextsByPath[q]=E;this.oCachePromise.then(function(t){t.addKeptElement(i);E.setKeepAlive(true);E.checkUpdate();});};
o.prototype.refreshInternal=function(r,G,i,K){var t=this;function p(P){var v=t.getResolvedPath();t.mPreviousContextsByPath[v+P].resetKeepAlive();}function q(v){return v.map(function(w){if(w.bIsBeingDestroyed){return;}return w.refreshInternal(r,G,false,K);});}if(this.isRootBindingSuspended()){this.refreshSuspended(G);return S.all(q(t.getDependentBindings()));}this.createReadGroupLock(G,this.isRoot());return this.oCachePromise.then(function(v){var A=t.iActiveContexts,w=t.iCreatedContexts,D,x,P=t.oRefreshPromise;if(v&&!P){t.removeCachesAndMessages(r);t.fetchCache(t.oContext,false,true,K);x=t.oCachePromise.then(function(N){return N.refreshKeptElements(t.lockGroup(G),p);}).catch(function(E){t.oModel.reportError("Failed to refresh kept-alive elements",s,E);throw E;});if(t.iCurrentEnd>0){P=t.createRefreshPromise().catch(function(E){if(!K||E.canceled){throw E;}return t.fetchResourcePath(t.oContext).then(function(R){if(!t.bRelative||v.getResourcePath()===R){t.oCache=v;t.oCachePromise=S.resolve(v);t.iActiveContexts=A;t.iCreatedContexts=w;v.setActive(true);t._fireChange({reason:g.Change});}throw E;});});}}D=t.getDependentBindings();t.reset(g.Refresh,true);return S.all(q(D).concat(P,x,t.oHeaderContext.checkUpdate()));});};
o.prototype.refreshSingle=function(p,G,A){var q=p.getPath(),r=q.slice(1),t=this;if(p===this.oHeaderContext){throw new Error("Unsupported header context: "+p);}return this.withCache(function(v,P,w){var D=false,x=false,K=p.isKeepAlive(),y=e.getRelativePath(q,t.oHeaderContext.getPath()),z=[];function E(i){if(D){t.fireDataReceived(i);}}function H(){D=true;t.fireDataRequested();}function I(J){var M=p.getModelIndex(),i;if(p.created()){t.destroyCreated(p);x=true;}else{if(M===undefined){delete t.mPreviousContextsByPath[q];}else{t.aContexts.splice(M,1);t.iMaxLength-=1;for(i=M;i<t.aContexts.length;i+=1){if(t.aContexts[i]){t.aContexts[i].iIndex-=1;}}if(J){t.mPreviousContextsByPath[q]=p;}}if(!J){x=true;p.destroy();}}if(M!==undefined){t._fireChange({reason:g.Remove});}}z.push((A?v.refreshSingleWithRemove(G,P,p.getModelIndex(),y,K,H,I):v.refreshSingle(G,P,p.getModelIndex(),y,K,H)).then(function(){var U=[];E({data:{}});w.assertSameCache(v);if(!x){U.push(p.checkUpdateInternal());if(A){U.push(p.refreshDependentBindings(r,G.getGroupId()));}}return S.all(U);},function(i){E({error:i});throw i;}).catch(function(i){G.unlock(true);t.oModel.reportError("Failed to refresh entity: "+p,s,i);if(!i.canceled){throw i;}}));if(!A){z.push(p.refreshDependentBindings(r,G.getGroupId()));}return S.all(z);});};
o.prototype.requestContexts=function(i,p,G){var t=this;if(!this.isResolved()){throw new Error("Unresolved binding: "+this.sPath);}this.checkSuspended();this.oModel.checkGroupId(G);i=i||0;p=p||this.oModel.iSizeLimit;return Promise.resolve(this.fetchContexts(i,p,0,this.lockGroup(G,true))).then(function(q){if(q){t._fireChange({reason:g.Change});}return t.getContextsInViewOrder(i,p);},function(E){t.oModel.reportError("Failed to get contexts for "+t.oModel.sServiceUrl+t.getResolvedPath().slice(1)+" with start index "+i+" and length "+p,s,E);throw E;});};
o.prototype.requestDownloadUrl=e.createRequestMethod("fetchDownloadUrl");
o.prototype.requestFilterForMessages=function(i){var M=this.oModel.getMetaModel(),p,r=this.oHeaderContext&&this.oHeaderContext.getPath(),t=this;if(!r){return Promise.resolve(null);}p=e.getMetaPath(r);return M.requestObject(p+"/").then(function(E){var q,P={};t.oModel.getMessagesByPath(r,true).filter(function(v){return!i||i(v);}).forEach(function(v){v.getTargets().forEach(function(T){var w=T.slice(r.length).split("/")[0];if(w&&!w.startsWith("($uid=")){P[w]=true;}});});q=Object.keys(P).map(function(v){return o.getFilterForPredicate(v,E,M,p);});if(q.length===0){return null;}return q.length===1?q[0]:new F({filters:q});});};
o.prototype.requestSideEffects=function(G,p,i){var q,M,r=this.oModel,N={},P,t,R=this.oHeaderContext.getPath().length,v=i&&i!==this.oHeaderContext,w=this;function x(y){return y.catch(function(E){r.reportError("Failed to request side effects",s,E);if(!E.canceled){throw E;}});}if(this.mParameters.$$aggregation){if(v){throw new Error("Must not request side effects for a context of a binding with $$aggregation");}if(b.isAffected(this.mParameters.$$aggregation,this.aFilters.concat(this.aApplicationFilters),p)){return this.refreshInternal("",G,false,true);}return S.resolve();}if(p.indexOf("")<0){if(v){q=[i];}else{q=this.getCurrentContexts().filter(function(y){return!y.isTransient();});Object.keys(this.mPreviousContextsByPath).forEach(function(y){var z=w.mPreviousContextsByPath[y];if(z.isKeepAlive()){q.push(z);}});}P=q.map(function(i){return i.getPath().slice(R);});M=P.some(function(y){return y[0]!=="(";});if(!M){t=this.oCache?[this.oCache.requestSideEffects(this.lockGroup(G),p,N,P,v)]:[];this.visitSideEffects(G,p,v?i:undefined,N,t);return S.all(t.map(x)).then(function(){return w.refreshDependentListBindingsWithoutCache();});}}if(v){return this.refreshSingle(i,this.lockGroup(G),false);}if(this.iCurrentEnd===0){return S.resolve();}return this.refreshInternal("",G,false,true);};
o.prototype.reset=function(p,D){var q,E=this.iCurrentEnd===0,t=0,i,r=this;if(D){this.iActiveContexts=0;this.iCreatedContexts=0;}if(this.aContexts){this.aContexts.slice(this.iCreatedContexts).forEach(function(q){r.mPreviousContextsByPath[q.getPath()]=q;});for(i=0;i<this.iCreatedContexts;i+=1){q=this.aContexts[i];if(q.isTransient()){this.aContexts[t]=q;t+=1;}else{this.iActiveContexts-=1;this.mPreviousContextsByPath[q.getPath()]=q;}}for(i=0;i<t;i+=1){this.aContexts[i].iIndex=i-t;}this.aContexts.length=this.iCreatedContexts=t;}else{this.aContexts=[];}if(!this.iCreatedContexts){this.bCreatedAtEnd=undefined;}this.iCurrentBegin=this.iCurrentEnd=0;this.iMaxLength=Infinity;this.bLengthFinal=false;if(p&&!(E&&p===g.Change)){this.sChangeReason=p;this._fireRefresh({reason:p});}};
o.prototype.resetKeepAlive=function(){var p=this.mPreviousContextsByPath;function r(i){if(i.isKeepAlive()){i.resetKeepAlive();}}Object.keys(p).forEach(function(P){r(p[P]);});this.aContexts.forEach(r);};
o.prototype.resumeInternal=function(i,p){var q=this.getDependentBindings(),r=this.sResumeChangeReason,R=p||r;this.sResumeChangeReason=undefined;if(R){this.removeCachesAndMessages("");this.reset();this.fetchCache(this.oContext,!p);}q.forEach(function(D){D.resumeInternal(!R,!!r&&!D.oContext.isKeepAlive());});if(this.sChangeReason==="AddVirtualContext"){this._fireChange({detailedReason:"AddVirtualContext",reason:r});}else if(r){this._fireRefresh({reason:r});}this.oHeaderContext.checkUpdate();};
o.prototype.setAggregation=function(A){var p;function i(q){return q.some(function(r){return r&&r.isKeepAlive();});}if(this.hasPendingChanges()){throw new Error("Cannot set $$aggregation due to pending changes");}if(i(this.aContexts)||i(Object.values(this.mPreviousContextsByPath))){throw new Error("Cannot set $$aggregation due to a kept-alive context");}p=Object.assign({},this.mParameters);if(A===undefined){delete p.$$aggregation;}else{p.$$aggregation=e.clone(A);this.resetKeepAlive();}this.applyParameters(p,"");};
o.prototype.setContext=function(p){var r,i,t=this;if(this.oContext!==p){if(this.bRelative){this.checkSuspended(true);for(i=0;i<t.iCreatedContexts;i+=1){if(t.aContexts[i].isTransient()){throw new Error("setContext on relative binding is forbidden if a "+"transient entity exists: "+t);}}this.reset();this.resetKeepAlive();this.fetchCache(p);if(p){r=this.oModel.resolve(this.sPath,p);if(this.oHeaderContext&&this.oHeaderContext.getPath()!==r){this.mPreviousContextsByPath[this.oHeaderContext.getPath()]=this.oHeaderContext;this.oHeaderContext=null;}if(!this.oHeaderContext){this.oHeaderContext=C.create(this.oModel,this,r);}if(this.bHasPathReductionToParent&&this.oModel.bAutoExpandSelect&&!this.mParameters.$$aggregation){this.sChangeReason="AddVirtualContext";}if(p.getBinding&&p.getBinding().getRootBinding().isSuspended()){this.oContext=p;this.setResumeChangeReason(g.Context);return;}}B.prototype.setContext.call(this,p,{detailedReason:this.sChangeReason});}else{this.oContext=p;}}};
o.prototype.sort=function(v){var i=e.toArray(v);if(this.sOperationMode!==O.Server){throw new Error("Operation mode has to be sap.ui.model.odata.OperationMode.Server");}if(e.deepEqual(i,this.aSorters)){return this;}if(this.hasPendingChanges(true)){throw new Error("Cannot sort due to pending changes");}this.aSorters=i;if(this.isRootBindingSuspended()){this.setResumeChangeReason(g.Sort);return this;}this.createReadGroupLock(this.getGroupId(),true);this.removeCachesAndMessages("");this.fetchCache(this.oContext);this.reset(g.Sort);if(this.oHeaderContext){this.oHeaderContext.checkUpdate();}return this;};
o.prototype.updateAnalyticalInfo=function(A){var i={aggregate:{},group:{},search:this.mParameters.$$aggregation&&this.mParameters.$$aggregation.search},H=false,t=this;A.forEach(function(p){var D={};if("total"in p){if("grouped"in p){throw new Error("Both dimension and measure: "+p.name);}if(p.as){D.name=p.name;i.aggregate[p.as]=D;}else{i.aggregate[p.name]=D;}if(p.min){D.min=true;H=true;}if(p.max){D.max=true;H=true;}if(p.with){D.with=p.with;}}else if(!("grouped"in p)||p.inResult||p.visible){i.group[p.name]=D;}});this.bHasAnalyticalInfo=true;this.setAggregation(i);if(H){return{measureRangePromise:Promise.resolve(this.getRootBindingResumePromise().then(function(){return t.oCachePromise;}).then(function(p){return p.getMeasureRangePromise();}))};}};
o.getFilterForPredicate=function(p,E,M,i){var q,v=f.parseKeyPredicate(p);if(""in v){v[E.$Key[0]]=v[""];delete v[""];}q=E.$Key.map(function(K){var r,t;if(typeof K==="string"){t=r=K;}else{r=Object.keys(K)[0];t=K[r];}return new F(t,h.EQ,e.parseLiteral(decodeURIComponent(v[r]),M.getObject(i+"/"+t+"/$Type"),t));});return q.length===1?q[0]:new F({and:true,filters:q});};
return o;});
sap.ui.predefine('sap/ui/model/odata/v4/ODataMetaModel',["./AnnotationHelper","./ValueListType","./lib/_Helper","sap/base/assert","sap/base/Log","sap/base/util/isEmptyObject","sap/base/util/JSTokenizer","sap/base/util/ObjectPath","sap/ui/base/ManagedObject","sap/ui/base/SyncPromise","sap/ui/model/BindingMode","sap/ui/model/ChangeReason","sap/ui/model/ClientListBinding","sap/ui/model/Context","sap/ui/model/ContextBinding","sap/ui/model/MetaModel","sap/ui/model/PropertyBinding","sap/ui/model/odata/OperationMode","sap/ui/model/odata/type/Boolean","sap/ui/model/odata/type/Byte","sap/ui/model/odata/type/Date","sap/ui/model/odata/type/DateTimeOffset","sap/ui/model/odata/type/Decimal","sap/ui/model/odata/type/Double","sap/ui/model/odata/type/Guid","sap/ui/model/odata/type/Int16","sap/ui/model/odata/type/Int32","sap/ui/model/odata/type/Int64","sap/ui/model/odata/type/Raw","sap/ui/model/odata/type/SByte","sap/ui/model/odata/type/Single","sap/ui/model/odata/type/Stream","sap/ui/model/odata/type/String","sap/ui/model/odata/type/TimeOfDay","sap/ui/thirdparty/URI"],function(A,V,_,a,L,b,J,O,M,S,B,C,c,d,f,g,P,h,k,l,E,D,m,o,G,I,p,q,R,r,s,t,u,T,U){"use strict";var v=M.extend("sap.ui.model.odata.v4._any",{metadata:{properties:{any:"any"}}}),w,x=new Map(),y=L.Level.DEBUG,z=/\$\(/g,F=/^-?\d+$/,H,K,N="sap.ui.model.odata.v4.ODataMetaModel",Q,W=/\(.*\)$/,X=new R(),Y=/\$\)/g,Z=new Map(),$={messageChange:true},a1={"Edm.Boolean":{Type:k},"Edm.Byte":{Type:l},"Edm.Date":{Type:E},"Edm.DateTimeOffset":{constraints:{$Precision:"precision"},Type:D},"Edm.Decimal":{constraints:{"@Org.OData.Validation.V1.Minimum/$Decimal":"minimum","@Org.OData.Validation.V1.Minimum@Org.OData.Validation.V1.Exclusive":"minimumExclusive","@Org.OData.Validation.V1.Maximum/$Decimal":"maximum","@Org.OData.Validation.V1.Maximum@Org.OData.Validation.V1.Exclusive":"maximumExclusive",$Precision:"precision",$Scale:"scale"},Type:m},"Edm.Double":{Type:o},"Edm.Guid":{Type:G},"Edm.Int16":{Type:I},"Edm.Int32":{Type:p},"Edm.Int64":{Type:q},"Edm.SByte":{Type:r},"Edm.Single":{Type:s},"Edm.Stream":{Type:t},"Edm.String":{constraints:{"@com.sap.vocabularies.Common.v1.IsDigitSequence":"isDigitSequence",$MaxLength:"maxLength"},Type:u},"Edm.TimeOfDay":{constraints:{$Precision:"precision"},Type:T}},b1={},c1="@com.sap.vocabularies.Common.v1.ValueList",d1="@com.sap.vocabularies.Common.v1.ValueListMapping",e1="@com.sap.vocabularies.Common.v1.ValueListReferences",f1="@com.sap.vocabularies.Common.v1.ValueListRelevantQualifiers",g1="@com.sap.vocabularies.Common.v1.ValueListWithFixedValues",h1=L.Level.WARNING;
function i1(e,i,j,n){var r1,s1=e.mSchema2MetadataUrl[i];if(!s1){s1=e.mSchema2MetadataUrl[i]={};s1[j]=false;}else if(!(j in s1)){r1=Object.keys(s1)[0];if(s1[r1]){o1(e,"A schema cannot span more than one document: "+i+" - expected reference URI "+r1+" but instead saw "+j,n);}s1[j]=false;}}
function j1(e,i,j,n){var r1,s1,t1,u1;function v1(w1){var x1,y1;if(!(j in w1)){n(h1,s1," does not contain ",j);return;}n(y,"Including ",j," from ",s1);for(y1 in w1){if(y1[0]!=="$"&&p1(y1)===j){x1=w1[y1];i[y1]=x1;n1(x1,i.$Annotations);}}}if(j in i){return i[j];}u1=e.mSchema2MetadataUrl[j];if(u1){t1=Object.keys(u1);if(t1.length>1){o1(e,"A schema cannot span more than one document: "+"schema is referenced by following URLs: "+t1.join(", "),j);}s1=t1[0];u1[s1]=true;n(y,"Namespace ",j," found in $Include of ",s1);r1=e.mMetadataUrl2Promise[s1];if(!r1){n(y,"Reading ",s1);r1=e.mMetadataUrl2Promise[s1]=S.resolve(e.oRequestor.read(s1)).then(e.validate.bind(e,s1));}r1=r1.then(v1);if(j in i){return i[j];}i[j]=r1;return r1;}}
function k1(e,i){if(e===i){return"";}if(e.startsWith(i)&&e[i.length]==="#"&&!e.includes("@",i.length)){return e.slice(i.length+1);}}
function l1(e){var i=k1(e,d1);return i!==undefined?i:k1(e,c1);}
function m1(n,e){return e.some(function(i){return n==="$ReturnType"?i.$ReturnType:i.$Parameter&&i.$Parameter.some(function(j){return j.$Name===n;});});}
function n1(e,i,j){var n;function r1(s1,t1){var u1;for(u1 in t1){if(j||!(u1 in s1)){s1[u1]=t1[u1];}}}for(n in e.$Annotations){if(!(n in i)){i[n]={};}r1(i[n],e.$Annotations[n]);}delete e.$Annotations;}
function o1(e,i,j){var n=new Error(j+": "+i);e.oModel.reportError(i,N,n);throw n;}
function p1(e){return e.slice(0,e.lastIndexOf(".")+1);}
H=f.extend("sap.ui.model.odata.v4.ODataMetaContextBinding",{constructor:function(e,i,j){a(!j||j.getModel()===e,"oContext must belong to this model");f.call(this,e,i,j);},initialize:function(){var e=this.oModel.createBindingContext(this.sPath,this.oContext);this.bInitial=false;if(e!==this.oElementContext){this.oElementContext=e;this._fireChange();}},setContext:function(e){a(!e||e.getModel()===this.oModel,"oContext must belong to this model");if(e!==this.oContext){this.oContext=e;if(!this.bInitial){this.initialize();}}}});K=c.extend("sap.ui.model.odata.v4.ODataMetaListBinding",{constructor:function(){c.apply(this,arguments);},_fireFilter:function(){},_fireSort:function(){},checkUpdate:function(e){var i=this.oList.length;this.update();if(e||this.oList.length!==i){this._fireChange({reason:C.Change});}},fetchContexts:function(){var i,e=this.getResolvedPath(),j=this;if(!e){return S.resolve([]);}i=e.endsWith("@");if(!i&&!e.endsWith("/")){e+="/";}return this.oModel.fetchObject(e).then(function(n){if(!n){return[];}if(i){e=e.slice(0,-1);}return Object.keys(n).filter(function(r1){return r1[0]!=="$"&&i!==(r1[0]!=="@");}).map(function(r1){return new d(j.oModel,e+r1);});});},getContexts:function(i,e){this.iCurrentStart=i||0;this.iCurrentLength=Math.min(e||Infinity,this.iLength-this.iCurrentStart);return this.getCurrentContexts();},getCurrentContexts:function(){var e=[],i,n=this.iCurrentStart+this.iCurrentLength;for(i=this.iCurrentStart;i<n;i+=1){e.push(this.oList[this.aIndices[i]]);}if(this.oList.dataRequested){e.dataRequested=true;}return e;},setContexts:function(e){this.oList=e;this.updateIndices();this.applyFilter();this.applySort();this.iLength=this._getLength();},update:function(){var e=[],i=this.fetchContexts(),j=this;if(i.isFulfilled()){e=i.getResult();}else{i.then(function(e){j.setContexts(e);j._fireChange({reason:C.Change});});e.dataRequested=true;}this.setContexts(e);}});Q=P.extend("sap.ui.model.odata.v4.ODataMetaPropertyBinding",{constructor:function(){P.apply(this,arguments);this.vValue=undefined;},checkUpdate:function(e,i){var j,n=this;function r1(s1){if(e||s1!==n.vValue){n.vValue=s1;n._fireChange({reason:i||C.Change});}return s1;}j=this.oModel.fetchObject(this.sPath,this.oContext,this.mParameters).then(r1);if(this.mParameters&&this.mParameters.$$valueAsPromise&&j.isPending()){r1(j.unwrap());}else if(j.isRejected()){j.unwrap();}},getValue:function(){return this.vValue;},setContext:function(e){if(this.oContext!==e){this.oContext=e;if(this.bRelative){this.checkUpdate(false,C.Context);}}},setValue:function(){throw new Error("Unsupported operation: ODataMetaPropertyBinding#setValue");}});
var q1=g.extend("sap.ui.model.odata.v4.ODataMetaModel",{constructor:function(e,i,j,n,r1){g.call(this);this.aAnnotationUris=j&&!Array.isArray(j)?[j]:j;this.sDefaultBindingMode=B.OneTime;this.mETags={};this.oLastModified=new Date(0);this.oMetadataPromise=null;this.oModel=n;this.mMetadataUrl2Promise={};this.oRequestor=e;this.mSchema2MetadataUrl={};this.mSupportedBindingModes={OneTime:true,OneWay:true};this.bSupportReferences=r1!==false;this.mUnsupportedFilterOperators={All:true,Any:true};this.sUrl=i;}});
q1.prototype.$$valueAsPromise=true;
q1.prototype._mergeAnnotations=function(e,j){var n=this;this.validate(this.sUrl,e);e.$Annotations={};Object.keys(e).forEach(function(i){if(e[i].$kind==="Schema"){i1(n,i,n.sUrl);n1(e[i],e.$Annotations);}});j.forEach(function(r1,i){var s1,t1;n.validate(n.aAnnotationUris[i],r1);for(t1 in r1){if(t1[0]!=="$"){if(t1 in e){o1(n,"A schema cannot span more than one document: "+t1,n.aAnnotationUris[i]);}s1=r1[t1];e[t1]=s1;if(s1.$kind==="Schema"){i1(n,t1,n.aAnnotationUris[i]);n1(s1,e.$Annotations,true);}}}});};
q1.prototype.attachEvent=function(e,i,j,n){if(!(e in $)){throw new Error("Unsupported event '"+e+"': v4.ODataMetaModel#attachEvent");}return g.prototype.attachEvent.apply(this,arguments);};
q1.prototype.bindContext=function(e,i){return new H(this,e,i);};
q1.prototype.bindList=function(e,i,j,n){return new K(this,e,i,j,n);};
q1.prototype.bindProperty=function(e,i,j){return new Q(this,e,i,j);};
q1.prototype.bindTree=function(e,i,j,n,r1){throw new Error("Unsupported operation: v4.ODataMetaModel#bindTree");};
q1.prototype.fetchCanonicalPath=function(e){return this.fetchUpdateData("",e).then(function(i){if(!i.editUrl){throw new Error(e.getPath()+": No canonical path for transient entity");}if(i.propertyPath){throw new Error("Context "+e.getPath()+" does not point to an entity. It should be "+i.entityPath);}return"/"+i.editUrl;});};
q1.prototype.fetchData=function(){return this.fetchEntityContainer().then(function(e){return JSON.parse(JSON.stringify(e));});};
q1.prototype.fetchEntityContainer=function(e){var i,j=this;if(!this.oMetadataPromise){i=[S.resolve(this.oRequestor.read(this.sUrl,false,e))];if(this.aAnnotationUris){this.aAnnotationUris.forEach(function(n){i.push(S.resolve(j.oRequestor.read(n,true,e)));});}if(!e){this.oMetadataPromise=S.all(i).then(function(n){var r1=n[0];j._mergeAnnotations(r1,n.slice(1));return r1;});}}return this.oMetadataPromise;};
q1.prototype.fetchObject=function(j,n,r1){var s1=this.resolve(j,n),t1=this;if(!s1){L.error("Invalid relative path w/o context",j,N);return S.resolve(null);}return this.fetchEntityContainer().then(function(u1){var v1,w1,x1,y1,z1,A1,B1,C1,D1,E1;function F1(e,i,N1){var O1,P1,Q1,R1,S1="";if(i){P1=i.indexOf("@@");if(P1>0){i=i.slice(0,P1);}}else{i=e;}N1=N1||"";if(v1){B1=R1=E1.filter(I1);if(R1.length!==1){return J1(h1,"Expected a single overload, but found "+R1.length);}if(v1!==b1){S1=R1[0].$Parameter[0].$isCollection?"Collection("+v1+")":v1;}Q1=D1+"("+S1+")"+N1;if(u1.$Annotations[Q1]){if(i==="@"){E1=u1.$Annotations[Q1];O1=u1.$Annotations[D1+N1];if(O1){E1=Object.assign({},O1,E1);}return false;}if(i in u1.$Annotations[Q1]){D1=Q1;E1=u1;return true;}}}D1+=N1;E1=u1;return true;}function G1(i,j){var N1,O1,P1,Q1=i.indexOf("@",2);if(Q1>-1){return J1(h1,"Unsupported path after ",i.slice(0,Q1));}i=i.slice(2);P1=i.indexOf("(");if(P1>0){if(!i.endsWith(")")){return J1(h1,"Expected ')' instead of '",i.slice(-1),"'");}try{O1=J.parseJS("["+i.slice(P1+1,-1).replace(z,"{").replace(Y,"}")+"]");}catch(e){return J1(h1,e.message,": ",e.text.slice(1,e.at),"<--",e.text.slice(e.at,-1));}i=i.slice(0,P1);}N1=i[0]==="."?O.get(i.slice(1),r1.scope):r1&&O.get(i,r1.scope)||(i==="requestCurrencyCodes"||i==="requestUnitsOfMeasure"?t1[i].bind(t1):O.get(i));if(typeof N1!=="function"){return J1(h1,i," is not a function but: "+N1);}try{E1=N1(E1,{$$valueAsPromise:r1&&r1.$$valueAsPromise,arguments:O1,context:new d(t1,j),schemaChildName:C1,overload:B1.length===1?B1[0]:undefined});}catch(e){J1(h1,"Error calling ",i,": ",e);}return true;}function H1(e,i){var N1;if(e==="$ReturnType"){if(i.$ReturnType){E1=i.$ReturnType;return true;}}else if(e&&i.$Parameter){N1=i.$Parameter.filter(function(O1){return O1.$Name===e;});if(N1.length){E1=N1[0];return true;}}return false;}function I1(e){return!e.$IsBound&&v1===b1||e.$IsBound&&v1===e.$Parameter[0].$Type;}function J1(i){var e;if(L.isLoggable(i,N)){e=Array.isArray(y1)?y1.join("/"):y1;L[i===y?"debug":"warning"](Array.prototype.slice.call(arguments,1).join("")+(e?" at /"+e:""),s1,N);}if(i===h1){E1=undefined;}return false;}function K1(e,i){var N1;function O1(){y1=y1||D1&&i&&D1+"/"+i;return J1.apply(this,arguments);}v1=E1&&E1.$Type||v1;if(t1.bSupportReferences&&!(e in u1)){N1=p1(e);E1=j1(t1,u1,N1,O1);}if(e in u1){D1=z1=C1=e;E1=B1=u1[C1];if(!S.isThenable(E1)){return true;}}if(S.isThenable(E1)&&E1.isPending()){return O1(y,"Waiting for ",N1);}return O1(h1,"Unknown qualified name ",e);}function L1(e,i,N1){var O1,P1,Q1;if(e==="$Annotations"){return J1(h1,"Invalid segment: $Annotations");}e=e.replaceAll("%2F","/");if(i&&typeof E1==="object"&&e in E1){if(e[0]==="$"||F.test(e)){A1=false;}}else{O1=e.indexOf("@@");if(O1<0){if(e.endsWith("@sapui.name")){O1=e.length-11;}else{O1=e.indexOf("@");}}if(O1>0){if(!L1(e.slice(0,O1),i,N1)){return false;}e=e.slice(O1);Q1=true;if(E1&&(E1.$kind==="EntitySet"||E1.$kind==="Singleton")){w1=E1;}}if(typeof E1==="string"&&!(Q1&&(e==="@sapui.name"||e[1]==="@"))&&!(A1&&B1&&B1.$kind==="EnumType")&&!M1(E1,N1.slice(0,i))){return false;}if(A1){if(e[0]==="$"&&e!=="$Parameter"&&e!=="$ReturnType"||F.test(e)){A1=false;}else{P1=typeof E1==="object";if(Q1){}else if(e[0]!=="@"&&e.includes(".",1)){return K1(e);}else if(P1&&"$Type"in E1){if(!K1(E1.$Type,"$Type")){return false;}}else if(P1&&"$Action"in E1){if(!K1(E1.$Action,"$Action")){return false;}v1=b1;}else if(P1&&"$Function"in E1){if(!K1(E1.$Function,"$Function")){return false;}v1=b1;}else if(!i){D1=z1=C1=C1||u1.$EntityContainer;E1=B1=B1||u1[C1];if(Array.isArray(E1)&&H1(e,E1[0])){return true;}if(e&&e[0]!=="@"&&!(e in B1)){return J1(h1,"Unknown child ",e," of ",C1);}}if(Array.isArray(E1)){if(e==="$Parameter"){return true;}if(e.startsWith("@$ui5.overload@")){e=e.slice(14);Q1=true;}if(Q1){if(e[1]!=="@"&&!F1(e)){return false;}}else{if(e!==N1[i]&&N1[i][e.length+1]!=="@"&&m1(e,E1)){z1=e;return F1(e,N1[i].slice(e.length),"/"+z1);}if(v1){E1=E1.filter(I1);}if(e==="@$ui5.overload"){return true;}if(E1.length!==1){return J1(h1,"Expected a single overload, but found "+E1.length);}if(H1(e,E1[0])){return true;}E1=E1[0].$ReturnType;D1+="/0/$ReturnType";if(E1){if(e==="value"&&!(u1[E1.$Type]&&u1[E1.$Type].value)){z1=undefined;return true;}if(!K1(E1.$Type,"$Type")){return false;}}if(!e){return true;}}}}}if(!e){return i+1>=N1.length||J1(h1,"Invalid empty segment");}if(e[0]==="@"){if(e==="@sapui.name"){E1=z1;if(E1===undefined){J1(h1,"Unsupported path before @sapui.name");}else if(i+1<N1.length){J1(h1,"Unsupported path after @sapui.name");}return false;}if(e[1]==="@"){if(i+1<N1.length){return J1(h1,"Unsupported path after ",e);}return G1(e,[""].concat(N1.slice(0,i),N1[i].slice(0,O1)).join("/"));}}if(A1&&e[0]==="@"){v1=E1&&E1.$Type||v1;E1=u1.$Annotations[D1]||{};A1=false;}else if(e==="$"&&i+1<N1.length){return J1(h1,"Unsupported path after $");}else if(!E1||typeof E1!=="object"){E1=undefined;return!x1&&J1(y,"Invalid segment: ",e);}}if(e!=="@"&&e!=="$"){if(e[0]==="@"){x1=true;}z1=A1||e[0]==="@"?e:undefined;D1=A1?D1+"/"+e:undefined;E1=E1[e];}return true;}function M1(e,i){var N1;if(y1){return J1(h1,"Invalid recursion");}y1=i;x1=false;A1=true;E1=u1;if(w1){if(!e){E1=w1;w1=y1=undefined;return true;}C1=w1.$Type;w1=B1=undefined;}N1=e.split("/").every(L1);y1=undefined;return N1;}if(!M1(s1.slice(1))&&S.isThenable(E1)){E1=E1.then(function(){return t1.fetchObject(j,n,r1);});}return E1;});};
q1.prototype.fetchUI5Type=function(e,i){var j=this.getMetaContext(e),n=this;if(e.endsWith("/$count")){w=w||new q();return S.resolve(w);}return this.fetchObject(undefined,j).catch(this.oModel.getReporter()).then(function(r1){var s1=X,t1;if(!r1){L.warning("No metadata for path '"+e+"', using "+s1.getName(),undefined,N);return s1;}if(i){if(b(i)){i=undefined;}else if("parseKeepsEmptyString"in i&&r1.$Type!=="Edm.String"){if(Object.keys(i).length===1){i=undefined;}else{i=Object.assign({},i);delete i.parseKeepsEmptyString;}}}if(!i&&r1["$ui5.type"]){return r1["$ui5.type"];}if(r1.$isCollection){L.warning("Unsupported collection type, using "+s1.getName(),e,N);}else{t1=a1[r1.$Type];if(t1){s1=new t1.Type(i,n.getConstraints(r1,j.getPath()));}else{L.warning("Unsupported type '"+r1.$Type+"', using "+s1.getName(),e,N);}}if(!i){r1["$ui5.type"]=s1;}return s1;});};
q1.prototype.fetchUpdateData=function(e,j,n){var r1=j.getModel(),s1=r1.resolve(e,j),t1=this;function u1(i){var v1=new Error(s1+": "+i);r1.reportError(i,N,v1);throw v1;}return this.fetchObject(_.getMetaPath(s1)).then(function(){return t1.fetchEntityContainer();}).then(function(v1){var w1,x1=v1[v1.$EntityContainer],y1,z1,A1,B1,C1=false,D1,E1,F1,G1;function H1(L1){var i=L1.indexOf("(");return i>=0?L1.slice(i):"";}function I1(i){w1.push({path:D1,prefix:i,type:G1});}function J1(L1){var i=L1.indexOf("(");return i>=0?L1.slice(0,i):L1;}function K1(i){if(i.includes("($uid=")){I1(J1(i));}else{w1.push(i);}}F1=s1.slice(1).split("/");B1=F1.shift();D1="/"+B1;y1=D1;A1=decodeURIComponent(J1(B1));z1=x1[A1];if(!z1){u1("Not an entity set: "+A1);}G1=v1[z1.$Type];e="";E1="";w1=[];K1(B1);F1.forEach(function(i){var L1,M1;D1+="/"+i;if(F.test(i)){I1(w1.pop());y1+="/"+i;}else{M1=decodeURIComponent(J1(i));E1=_.buildPath(E1,M1);L1=C1?{}:G1[M1];if(!L1){if(M1.includes("@")){if(M1.includes("@$ui5.")){u1("Read-only path must not be updated");}C1=true;L1={};}else{u1("Not a (navigation) property: "+M1);}}G1=v1[L1.$Type];if(L1.$kind==="NavigationProperty"){if(z1.$NavigationPropertyBinding&&E1 in z1.$NavigationPropertyBinding){A1=z1.$NavigationPropertyBinding[E1];z1=x1[A1];E1="";w1=[encodeURIComponent(A1)+H1(i)];if(!L1.$isCollection){I1(w1.pop());}}else{K1(i);}y1=D1;e="";}else{e=_.buildPath(e,i);}}});if(n){return S.resolve({editUrl:undefined,entityPath:y1,propertyPath:e});}return S.all(w1.map(function(i){if(typeof i==="string"){return i;}return j.fetchValue(i.path).then(function(L1){var M1;if(!L1){u1("No instance to calculate key predicate at "+i.path);}if(_.hasPrivateAnnotation(L1,"transient")){n=true;return undefined;}M1=_.getPrivateAnnotation(L1,"predicate");if(!M1){u1("No key predicate known at "+i.path);}return i.prefix+M1;},function(L1){u1(L1.message+" at "+i.path);});})).then(function(i){return{editUrl:n?undefined:i.join("/"),entityPath:y1,propertyPath:e};});});};
q1.prototype.fetchValueListMappings=function(e,i,j,n){var r1=this,s1=e.getMetaModel();function t1(){var u1=n[0],v1="";if(n.length!==1){throw new Error("Expected a single overload, but found "+n.length);}if(u1.$IsBound){v1=u1.$Parameter[0].$isCollection?"Collection("+u1.$Parameter[0].$Type+")":u1.$Parameter[0].$Type;}return i+"("+v1+")";}return s1.fetchEntityContainer().then(function(u1){var v1,w1=u1.$Annotations,x1,y1=_.namespace(i),z1={},A1=r1===s1,B1,C1;if(j.$Name){x1=t1()+"/"+j.$Name;C1=i+"/"+j.$Name;}B1=Object.keys(w1).filter(function(D1){if(_.namespace(D1)===y1){if(x1?D1===x1||D1===C1:r1.getObject("/"+D1)===j){return true;}if(A1||C1&&_.getMetaPath(D1)===C1){return false;}throw new Error("Unexpected annotation target '"+D1+"' with namespace of data service in "+e.sServiceUrl);}return false;});if(!B1.length){throw new Error("No annotation '"+c1.slice(1)+"' in "+e.sServiceUrl);}if(B1.length===1){v1=w1[B1[0]];}else{v1=Object.assign({},w1[C1],w1[x1]);}Object.keys(v1).forEach(function(D1){var E1=l1(D1);if(E1!==undefined){z1[E1]=v1[D1];["CollectionRoot","SearchSupported"].forEach(function(F1){if(F1 in v1[D1]){throw new Error("Property '"+F1+"' is not allowed in annotation '"+D1.slice(1)+"' for target '"+B1[0]+"' in "+e.sServiceUrl);}});}else if(!A1){throw new Error("Unexpected annotation '"+D1.slice(1)+"' for target '"+B1[0]+"' with namespace of data service in "+e.sServiceUrl);}});return z1;});};
q1.prototype.fetchValueListType=function(e){var i=this.getMetaContext(e),j=this;return this.fetchObject(undefined,i).then(function(n){var r1,s1;if(!n){throw new Error("No metadata for "+e);}r1=j.getObject("@",i);if(r1[g1]){return V.Fixed;}for(s1 in r1){if(k1(s1,e1)!==undefined||k1(s1,d1)!==undefined){return V.Standard;}if(k1(s1,c1)!==undefined){return r1[s1].SearchSupported===false?V.Fixed:V.Standard;}}return V.None;});};
q1.prototype.getAbsoluteServiceUrl=function(e){var i=new U(this.sUrl).absoluteTo(document.baseURI).pathname().toString();return new U(e).absoluteTo(i).filename("").toString();};
q1.prototype.getAllPathReductions=function(e,n,r1,s1){var t1=n.split("/").length,u1,v1={},w1=e.split("/"),x1=this;function y1(j,z1,A1,B1){var C1,D1,i;function E1(F1){if(!r1){y1(j,z1,i-1,true);}if(B1){z1=z1.slice();j=j.slice();}z1.splice(i,F1);j.splice(i,F1);if(!r1){v1[j.join("/")]=true;}}for(i=A1;i>=t1;i-=1){C1=F.test(j[i+1])?i+2:i+1;if(C1<j.length&&z1[i].$Partner===j[C1]&&!z1[C1].$isCollection&&z1[C1].$Partner===j[i].replace(W,"")){E1(C1-i+1);}else if(Array.isArray(z1[i])&&j[i+1]==="$Parameter"){D1=x1.getObject(_.getMetaPath(j.slice(0,i+1).join("/")+"/@$ui5.overload"));if(D1.length===1&&D1[0].$Parameter[0].$Name===j[i+2]){E1(3);}}else if(s1&&z1[i].$isCollection){break;}}}u1=w1.map(function(i,j){return j<t1||i[0]==="#"||i[0]==="@"||F.test(i)||i==="$Parameter"?{}:x1.getObject(_.getMetaPath(w1.slice(0,j+1).join("/")))||{};});v1[e]=true;if(!(s1&&u1[w1.length-1].$isCollection)){y1(w1,u1,w1.length-2);}return r1?w1.join("/"):Object.keys(v1);};
q1.prototype.getConstraints=function(e,i){var j,n,r1,s1=a1[e.$Type];function t1(u1,v1){if(v1!==undefined){n=n||{};n[u1]=v1;}}if(s1){r1=s1.constraints;for(j in r1){t1(r1[j],j[0]==="@"?this.getObject(i+j):e[j]);}if(e.$Nullable===false){t1("nullable",false);}}return n;};
q1.prototype.getData=_.createGetMethod("fetchData");
q1.prototype.getETags=function(){return this.mETags;};
q1.prototype.getLastModified=function(){return this.oLastModified;};
q1.prototype.getMetaContext=function(e){return new d(this,_.getMetaPath(e));};
q1.prototype.getMetaPath=function(e){return _.getMetaPath(e);};
q1.prototype.getObject=_.createGetMethod("fetchObject");
q1.prototype.getOrCreateSharedModel=function(e,i,j){var n,r1;e=this.getAbsoluteServiceUrl(e);n=!!j+e;r1=Z.get(n);if(!r1){r1=new this.oModel.constructor({autoExpandSelect:j,groupId:i,httpHeaders:this.oModel.getHttpHeaders(),operationMode:h.Server,serviceUrl:e,sharedRequests:true,synchronizationMode:"None"});Z.set(n,r1);}return r1;};
q1.prototype.getOriginalProperty=function(){throw new Error("Unsupported operation: v4.ODataMetaModel#getOriginalProperty");};
q1.prototype.getProperty=q1.prototype.getObject;
q1.prototype.getReducedPath=function(e,i){return this.getAllPathReductions(e,i,true,true);};
q1.prototype.getUI5Type=_.createGetMethod("fetchUI5Type",true);
q1.prototype.getUnitOrCurrencyPath=function(e){var i=this.getObject("@",this.getMetaContext(e)),j=i&&(i["@Org.OData.Measures.V1.Unit"]||i["@Org.OData.Measures.V1.ISOCurrency"]);return j&&j.$Path;};
q1.prototype.getValueListType=_.createGetMethod("fetchValueListType",true);
q1.prototype.isList=function(){throw new Error("Unsupported operation: v4.ODataMetaModel#isList");};
q1.prototype.refresh=function(){throw new Error("Unsupported operation: v4.ODataMetaModel#refresh");};
q1.prototype.requestCodeList=function(e,i,j){var n=this.fetchEntityContainer().getResult(),r1=n[n.$EntityContainer],s1=this;if(j&&j.context){if(j.context.getModel()!==this||j.context.getPath()!=="/"){throw new Error("Unsupported context: "+j.context);}}if(i!==undefined&&i!==r1){throw new Error("Unsupported raw value: "+i);}return this.requestObject("/@com.sap.vocabularies.CodeList.v1."+e).then(function(t1){var u1,v1,w1,x1,y1;if(!t1){return null;}u1=s1.getAbsoluteServiceUrl(t1.Url)+"#"+t1.CollectionPath;x1=x.get(u1);if(x1){return x1;}w1=s1.getOrCreateSharedModel(t1.Url,"$direct");v1=w1.getMetaModel();y1="/"+t1.CollectionPath+"/";x1=v1.requestObject(y1).then(function(z1){var A1=y1+"@Org.OData.Core.V1.AlternateKeys",B1=v1.getObject(A1),C1,D1=L1(z1.$Key),E1=y1+D1+"@com.sap.vocabularies.Common.v1.",F1,G1,H1=y1+D1+"@com.sap.vocabularies.CodeList.v1.StandardCode/$Path",I1,J1;function K1(M1,N1){var O1=N1.getProperty(D1),P1={Text:N1.getProperty(J1),UnitSpecificScale:N1.getProperty(G1)};if(I1){P1.StandardCode=N1.getProperty(I1);}if(P1.UnitSpecificScale===null){L.error("Ignoring customizing w/o unit-specific scale for code "+O1+" from "+t1.CollectionPath,t1.Url,N);}else{M1[O1]=P1;}return M1;}function L1(M1){var N1;if(M1&&M1.length===1){N1=M1[0];}else{throw new Error("Single key expected: "+y1);}return typeof N1==="string"?N1:N1[Object.keys(N1)[0]];}if(B1){if(B1.length!==1){throw new Error("Single alternative expected: "+A1);}else if(B1[0].Key.length!==1){throw new Error("Single key expected: "+A1+"/0/Key");}D1=B1[0].Key[0].Name.$PropertyPath;}G1=v1.getObject(E1+"UnitSpecificScale/$Path");J1=v1.getObject(E1+"Text/$Path");F1=[D1,G1,J1];I1=v1.getObject(H1);if(I1){F1.push(I1);}C1=w1.bindList("/"+t1.CollectionPath,null,null,null,{$select:F1});return C1.requestContexts(0,Infinity).then(function(M1){if(!M1.length){L.error("Customizing empty for ",w1.sServiceUrl+t1.CollectionPath,N);}return M1.reduce(K1,{});}).finally(function(){C1.destroy();});});x.set(u1,x1);return x1;});};
q1.prototype.requestCurrencyCodes=function(e,i){return this.requestCodeList("CurrencyCodes",e,i);};
q1.prototype.requestData=_.createRequestMethod("fetchData");q1.prototype.requestObject=_.createRequestMethod("fetchObject");q1.prototype.requestUI5Type=_.createRequestMethod("fetchUI5Type");
q1.prototype.requestUnitsOfMeasure=function(e,i){return this.requestCodeList("UnitsOfMeasure",e,i);};
q1.prototype.requestValue4Annotation=function(e,i,j){var n=new v({any:A.value(e,{context:this.createBindingContext(i)}),bindingContexts:j,models:j.getModel()}),r1=n.getBinding("any"),s1;if(r1){if(r1.getBindings){s1=Promise.all(r1.getBindings().map(function(t1){return t1.requestValue();}));}else{s1=r1.requestValue();}}else{s1=Promise.resolve();}return s1.then(function(){return n.getAny();});};
q1.prototype.requestValueListInfo=function(e,j,n){var r1=_.getMetaPath(e),s1=r1.slice(0,r1.lastIndexOf("/")).replace("/$Parameter",""),t1=s1.slice(s1.lastIndexOf("/")+1),u1=this;if(!t1.includes(".")){t1=undefined;}return Promise.all([t1||this.requestObject(s1+"/@sapui.name"),this.requestObject(r1),this.requestObject(r1+"@"),this.requestObject(r1+g1),this.requestObject(s1+"/@$ui5.overload")]).then(function(v1){var w1=v1[2],x1=v1[3],y1={},z1=v1[1],A1={};function B1(i,C1,D1,E1){if(x1!==undefined&&"SearchSupported"in i){throw new Error("Must not set 'SearchSupported' in annotation "+"'com.sap.vocabularies.Common.v1.ValueList' and annotation "+"'com.sap.vocabularies.Common.v1.ValueListWithFixedValues'");}if("CollectionRoot"in i){E1=u1.getOrCreateSharedModel(i.CollectionRoot,undefined,j);if(A1[C1]&&A1[C1].$model===E1){y1[C1]=undefined;}}if(y1[C1]){throw new Error("Annotations '"+c1.slice(1)+"' with identical qualifier '"+C1+"' for property "+e+" in "+y1[C1]+" and "+D1);}y1[C1]=D1;i=_.clone(i);i.$model=E1;delete i.CollectionRoot;delete i.SearchSupported;A1[C1]=i;}if(!z1){throw new Error("No metadata for "+e);}return Promise.all(Object.keys(w1).filter(function(i){return k1(i,e1)!==undefined;}).map(function(C1){var D1=w1[C1];return Promise.all(D1.map(function(i){var E1=u1.getOrCreateSharedModel(i,undefined,j);return u1.fetchValueListMappings(E1,v1[0],z1,v1[4]).then(function(F1){return{valueListMappingByQualifier:F1,$model:E1};});})).then(function(v1){D1.forEach(function(E1,i){var F1=v1[i].valueListMappingByQualifier;Object.keys(F1).forEach(function(G1){B1(F1[G1],G1,E1,v1[i].$model);});});});})).then(function(){var i=w1[f1];Object.keys(w1).filter(function(C1){return l1(C1)!==undefined;}).forEach(function(C1){B1(w1[C1],l1(C1),u1.sUrl,u1.oModel);});if(b(A1)){throw new Error("No annotation '"+e1.slice(1)+"' for "+e);}return i&&n&&n.getBinding?u1.filterValueListRelevantQualifiers(A1,i,r1+f1,n):A1;}).then(function(i){var C1,D1;if(x1){C1=Object.keys(i);if(C1.length!==1){throw new Error("Annotation '"+g1.slice(1)+"' but not exactly one '"+c1.slice(1)+"' for property "+e);}D1=i[C1[0]];D1.$qualifier=C1[0];return{"":D1};}return i;});});};
q1.prototype.filterValueListRelevantQualifiers=function(e,i,j,n){return this.requestValue4Annotation(i,j,n).then(function(r1){var s1={};r1.forEach(function(t1){if(t1 in e){s1[t1]=e[t1];}});return s1;});};
q1.prototype.requestValueListType=_.createRequestMethod("fetchValueListType");
q1.prototype.resolve=function(e,i){var j,n;if(!e){return i?i.getPath():undefined;}n=e[0];if(n==="/"){return e;}if(!i){return undefined;}if(n==="."){if(e[1]!=="/"){throw new Error("Unsupported relative path: "+e);}e=e.slice(2);}j=i.getPath();return n==="@"||j.endsWith("/")?j+e:j+"/"+e;};
q1.prototype.setLegacySyntax=function(){throw new Error("Unsupported operation: v4.ODataMetaModel#setLegacySyntax");};
q1.prototype.toString=function(){return N+": "+this.sUrl;};
q1.prototype.validate=function(e,j){var n,r1,s1,t1,u1,i;if(!this.bSupportReferences){return j;}for(u1 in j.$Reference){t1=j.$Reference[u1];u1=new U(u1).absoluteTo(this.sUrl).toString();if("$IncludeAnnotations"in t1){o1(this,"Unsupported IncludeAnnotations",e);}for(i in t1.$Include){s1=t1.$Include[i];if(s1 in j){o1(this,"A schema cannot span more than one document: "+s1+" - is both included and defined",e);}i1(this,s1,u1,e);}}r1=j.$LastModified?new Date(j.$LastModified):null;this.mETags[e]=j.$ETag?j.$ETag:r1;n=j.$Date?new Date(j.$Date):new Date();r1=r1||n;if(this.oLastModified<r1){this.oLastModified=r1;}delete j.$Date;delete j.$ETag;delete j.$LastModified;return j;};
return q1;});
sap.ui.predefine('sap/ui/model/odata/v4/ODataModel',["./ODataContextBinding","./ODataListBinding","./ODataMetaModel","./ODataPropertyBinding","./SubmitMode","./lib/_GroupLock","./lib/_Helper","./lib/_MetadataRequestor","./lib/_Parser","./lib/_Requestor","sap/base/assert","sap/base/Log","sap/ui/base/SyncPromise","sap/ui/core/library","sap/ui/core/message/Message","sap/ui/model/BindingMode","sap/ui/model/Context","sap/ui/model/Model","sap/ui/model/odata/OperationMode","sap/ui/thirdparty/URI"],function(O,a,b,c,S,_,d,e,f,g,h,L,i,j,M,B,k,l,m,U){"use strict";var r=/^\w+$/,C="sap.ui.model.odata.v4.ODataModel",E=["$count","$expand","$filter","$levels","$orderby","$search","$select"],n=/^(\$auto(\.\w+)?|\$direct|\w+)$/,o=j.MessageType,p=[undefined,o.Success,o.Information,o.Warning,o.Error],s={messageChange:true,sessionTimeout:true},q={annotationURI:true,autoExpandSelect:true,earlyRequests:true,groupId:true,groupProperties:true,httpHeaders:true,metadataUrlParams:true,odataVersion:true,operationMode:true,serviceUrl:true,sharedRequests:true,supportReferences:true,synchronizationMode:true,updateGroupId:true},t=["$apply","$count","$expand","$filter","$orderby","$search","$select"],u=/^[ -~]+$/;
var v=l.extend("sap.ui.model.odata.v4.ODataModel",{constructor:function(P){var G,w,x=sap.ui.getCore().getConfiguration().getLanguageTag(),y,z,A,D,F,H=this;l.call(this);if(!P||P.synchronizationMode!=="None"){throw new Error("Synchronization mode must be 'None'");}y=P.odataVersion||"4.0";this.sODataVersion=y;if(y!=="4.0"&&y!=="2.0"){throw new Error("Unsupported value for parameter odataVersion: "+y);}for(z in P){if(!(z in q)){throw new Error("Unsupported parameter: "+z);}}A=P.serviceUrl;if(!A){throw new Error("Missing service root URL");}D=new U(A);if(D.path()[D.path().length-1]!=="/"){throw new Error("Service root URL must end with '/'");}if(P.operationMode&&P.operationMode!==m.Server){throw new Error("Unsupported operation mode: "+P.operationMode);}this.sOperationMode=P.operationMode;F=this.buildQueryOptions(D.query(true),false,true);this.mUriParameters=F;if(sap.ui.getCore().getConfiguration().getStatistics()){F=Object.assign({"sap-statistics":true},F);}this.sServiceUrl=D.query("").toString();this.sGroupId=P.groupId;if(this.sGroupId===undefined){this.sGroupId="$auto";}if(this.sGroupId!=="$auto"&&this.sGroupId!=="$direct"){throw new Error("Group ID must be '$auto' or '$direct'");}this.checkGroupId(P.updateGroupId,false,"Invalid update group ID: ");this.sUpdateGroupId=P.updateGroupId||this.getGroupId();this.mGroupProperties={};for(G in P.groupProperties){H.checkGroupId(G,true);w=P.groupProperties[G];if(typeof w!=="object"||Object.keys(w).length!==1||!(w.submit in S)){throw new Error("Group '"+G+"' has invalid properties: '"+w+"'");}}this.mGroupProperties=d.clone(P.groupProperties)||{};this.mGroupProperties.$auto={submit:S.Auto};this.mGroupProperties.$direct={submit:S.Direct};if(P.autoExpandSelect!==undefined&&typeof P.autoExpandSelect!=="boolean"){throw new Error("Value for autoExpandSelect must be true or false");}this.bAutoExpandSelect=P.autoExpandSelect===true;if("sharedRequests"in P&&P.sharedRequests!==true){throw new Error("Value for sharedRequests must be true");}this.bSharedRequests=P.sharedRequests===true;this.mHeaders={"Accept-Language":x};this.mMetadataHeaders={"Accept-Language":x};this.oMetaModel=new b(e.create(this.mMetadataHeaders,y,Object.assign({},F,P.metadataUrlParams)),this.sServiceUrl+"$metadata",P.annotationURI,this,P.supportReferences);this.oInterface={fetchEntityContainer:this.oMetaModel.fetchEntityContainer.bind(this.oMetaModel),fetchMetadata:this.oMetaModel.fetchObject.bind(this.oMetaModel),fireSessionTimeout:function(){H.fireEvent("sessionTimeout");},getGroupProperty:this.getGroupProperty.bind(this),onCreateGroup:function(G){if(H.isAutoGroup(G)){H.addPrerenderingTask(H._submitBatch.bind(H,G,true));}},reportStateMessages:this.reportStateMessages.bind(this),reportTransitionMessages:this.reportTransitionMessages.bind(this)};this.oRequestor=g.create(this.sServiceUrl,this.oInterface,this.mHeaders,F,y);this.changeHttpHeaders(P.httpHeaders);if(P.earlyRequests){this.oMetaModel.fetchEntityContainer(true);this.initializeSecurityToken();}this.aAllBindings=[];this.mSupportedBindingModes={OneTime:true,OneWay:true};if(P.sharedRequests){this.sDefaultBindingMode=B.OneWay;}else{this.sDefaultBindingMode=B.TwoWay;this.mSupportedBindingModes.TwoWay=true;}this.aPrerenderingTasks=null;}});
v.prototype._submitBatch=function(G,w){var x=this;return this.oRequestor.submitBatch(G).catch(function(y){x.reportError("$batch failed",C,y);if(!w){throw y;}});};
v.prototype.addPrerenderingTask=function(P,F){var R,T,w=this;function x(y){clearTimeout(T);while(y.length){y.shift()();}if(w.aPrerenderingTasks===y){w.aPrerenderingTasks=null;}}if(!this.aPrerenderingTasks){this.aPrerenderingTasks=[];R=x.bind(null,this.aPrerenderingTasks);sap.ui.getCore().addPrerenderingTask(R);T=setTimeout(function(){T=setTimeout(R,0);},0);}if(F){this.aPrerenderingTasks.unshift(P);}else{this.aPrerenderingTasks.push(P);}};
v.prototype.attachEvent=function(w,x,y,z){if(!(w in s)){throw new Error("Unsupported event '"+w+"': v4.ODataModel#attachEvent");}return l.prototype.attachEvent.apply(this,arguments);};
v.prototype.attachSessionTimeout=function(F,w){return this.attachEvent("sessionTimeout",F,w);};
v.prototype.bindContext=function(P,w,x){return new O(this,P,w,x);};
v.prototype.bindingCreated=function(w){this.aAllBindings.push(w);};
v.prototype.bindingDestroyed=function(w){var I=this.aAllBindings.indexOf(w);if(I<0){throw new Error("Unknown "+w);}this.aAllBindings.splice(I,1);};
v.prototype.bindList=function(P,w,x,F,y){return new a(this,P,w,x,F,y);};
v.prototype.bindProperty=function(P,w,x){return new c(this,P,w,x);};
v.prototype.bindTree=function(w,x,y,z,A){throw new Error("Unsupported operation: v4.ODataModel#bindTree");};
v.prototype.buildQueryOptions=function(P,w,x){var y,T=d.clone(P)||{};function z(A,D,F){var G,H,I,V=A[D];if(!w||F.indexOf(D)<0){throw new Error("System query option "+D+" is not supported");}if((D==="$expand"||D==="$select")&&typeof V==="string"){V=f.parseSystemQueryOption(D+"="+V)[D];A[D]=V;}if(D==="$expand"){for(I in V){H=V[I];if(H===null||typeof H!=="object"){H=V[I]={};}for(G in H){z(H,G,E);}}}else if(D==="$count"){if(typeof V==="boolean"){if(!V){delete A.$count;}}else{switch(typeof V==="string"&&V.toLowerCase()){case"false":delete A.$count;break;case"true":A.$count=true;break;default:throw new Error("Invalid value for $count: "+V);}}}}if(P){for(y in P){if(y.startsWith("$$")){delete T[y];}else if(y[0]==="@"){throw new Error("Parameter "+y+" is not supported");}else if(y[0]==="$"){z(T,y,t);}else if(!x&&y.startsWith("sap-")&&!y.startsWith("sap-valid-")){throw new Error("Custom query option "+y+" is not supported");}}}return T;};
v.prototype.changeHttpHeaders=function(H){var w,x,y={},z,K;this.oRequestor.checkHeaderNames(H);for(K in H){x=K.toLowerCase();z=H[K];if(y[x]){throw new Error("Duplicate header "+K);}else if(!(typeof z==="string"&&u.test(z)||z===undefined)){throw new Error("Unsupported value for header '"+K+"': "+z);}else{if(x==="x-csrf-token"){K="X-CSRF-Token";}y[x]={key:K,value:z};}}this.oRequestor.checkForOpenRequests();for(K in this.mHeaders){x=K.toLowerCase();w=y[x];if(w){delete this.mHeaders[K];delete this.mMetadataHeaders[K];if(w.value!==undefined){this.mHeaders[w.key]=w.value;this.mMetadataHeaders[w.key]=w.value;}delete y[x];}}for(K in y){w=y[K];if(w.value!==undefined){this.mHeaders[w.key]=w.value;if(K!=="x-csrf-token"){this.mMetadataHeaders[w.key]=w.value;}}}};
v.prototype.checkBatchGroupId=function(G){this.checkGroupId(G);if(this.isDirectGroup(G)){throw new Error("Group ID does not use batch requests: "+G);}};
v.prototype.checkGroupId=function(G,A,w){if(!A&&G===undefined||typeof G==="string"&&(A?r:n).test(G)){return;}throw new Error((w||"Invalid group ID: ")+G);};
v.prototype.createBindingContext=function(P,w){var D,x,y,R,z;function A(y){var F=y.indexOf("."),G=y.indexOf("/");return F>0&&(G<0||F<G);}if(arguments.length>2){throw new Error("Only the parameters sPath and oContext are supported");}if(w&&w.getBinding){throw new Error("Unsupported type: oContext must be of type sap.ui.model.Context, "+"but was sap.ui.model.odata.v4.Context");}R=this.resolve(P,w);if(R===undefined){throw new Error("Cannot create binding context from relative path '"+P+"' without context");}z=R.indexOf("#");if(z>=0){D=R.slice(0,z);y=R.slice(z+1);if(y[0]==="#"){y=y.slice(1);}else if(D.length>1&&y[0]!=="@"&&A(y)){return new k(this,R);}if(y[0]==="/"){y="."+y;}x=this.oMetaModel.getMetaContext(D);return this.oMetaModel.createBindingContext(y,x);}return new k(this,R);};
v.prototype.createUI5Message=function(R,w,x){var I=typeof R.target==="string",y=R.longtextUrl,T;function z(A){return A[0]==="/"?A:d.buildPath("/"+w,x,A);}if(I){w=w&&w.split("?")[0];T=[z(R.target)];if(R.additionalTargets){R.additionalTargets.forEach(function(A){T.push(z(A));});}}if(y&&w){y=d.makeAbsolute(y,this.sServiceUrl+w);}return new M({code:R.code,descriptionUrl:y||undefined,message:R.message,persistent:!I||R.transition,processor:this,target:I?T:"",technical:R.technical,technicalDetails:d.createTechnicalDetails(R),type:p[R.numericSeverity]||o.None});};
v.prototype.destroy=function(){this.oMetaModel.destroy();this.oRequestor.destroy();this.mHeaders=undefined;this.mMetadataHeaders=undefined;return l.prototype.destroy.apply(this,arguments);};
v.prototype.destroyBindingContext=function(){throw new Error("Unsupported operation: v4.ODataModel#destroyBindingContext");};
v.prototype.detachSessionTimeout=function(F,w){return this.detachEvent("sessionTimeout",F,w);};
v.prototype.filterMatchingMessages=function(w,P){return d.hasPathPrefix(w,P)?this.mMessages[w]:[];};
v.prototype.getAllBindings=function(){return this.aAllBindings.slice();};
v.prototype.getContext=function(){throw new Error("Unsupported operation: v4.ODataModel#getContext");};
v.prototype.getDependentBindings=function(P){return this.aAllBindings.filter(function(w){var x=w.getContext();return w.isRelative()&&(x===P||x&&x.getBinding&&x.getBinding()===P);});};
v.prototype.getGroupId=function(){return this.sGroupId;};
v.prototype.getGroupProperty=function(G,P){switch(P){case"submit":if(G.startsWith("$auto.")){return S.Auto;}return this.mGroupProperties[G]?this.mGroupProperties[G].submit:S.API;default:throw new Error("Unsupported group property: '"+P+"'");}};
v.prototype.getHttpHeaders=function(I){var H=Object.assign({},this.mHeaders);if(!I){delete H["SAP-ContextId"];}if(H["X-CSRF-Token"]===null){delete H["X-CSRF-Token"];}return H;};
v.prototype.getMessages=function(w){return this.getMessagesByPath(w.getPath(),true).sort(M.compare);};
v.prototype.getMetaModel=function(){return this.oMetaModel;};
v.prototype.getObject=function(){throw new Error("Unsupported operation: v4.ODataModel#getObject");};
v.prototype.getODataVersion=function(){return this.sODataVersion;};
v.prototype.getOriginalProperty=function(){throw new Error("Unsupported operation: v4.ODataModel#getOriginalProperty");};
v.prototype.getProperty=function(){throw new Error("Unsupported operation: v4.ODataModel#getProperty");};
v.prototype.getUpdateGroupId=function(){return this.sUpdateGroupId;};
v.prototype.getReporter=function(){var w=this;return function(x){if(!x.$reported){w.reportError(x.message,C,x);}};};
v.prototype.hasPendingChanges=function(G){if(G!==undefined){this.checkBatchGroupId(G);if(this.isAutoGroup(G)&&this.oRequestor.hasPendingChanges("$parked."+G)){return true;}}return this.oRequestor.hasPendingChanges(G);};
v.prototype.initializeSecurityToken=function(){this.oRequestor.refreshSecurityToken().catch(function(){});};
v.prototype.isApiGroup=function(G){return this.getGroupProperty(G,"submit")===S.API;};
v.prototype.isAutoGroup=function(G){return this.getGroupProperty(G,"submit")===S.Auto;};
v.prototype.isDirectGroup=function(G){return this.getGroupProperty(G,"submit")===S.Direct;};
v.prototype.isList=function(){throw new Error("Unsupported operation: v4.ODataModel#isList");};
v.prototype.lockGroup=function(G,w,x,y,z){return this.oRequestor.lockGroup(G,w,x,y,z);};
v.prototype.refresh=function(G){if(typeof G==="boolean"){throw new Error("Unsupported parameter bForceUpdate");}this.checkGroupId(G);this.getBindings().forEach(function(w){if(w.isRoot()){w.refresh(w.isSuspended()?undefined:G);}});};
v.prototype.reportError=function(w,R,x){var D;if(x.canceled==="noDebugLog"){return;}D=x.stack.includes(x.message)?x.stack:x.message+"\n"+x.stack;if(x.canceled){L.debug(w,D,R);return;}L.error(w,D,R);if(x.$reported){return;}x.$reported=true;this.reportTransitionMessages(d.extractMessages(x),x.resourcePath);};
v.prototype.reportStateMessages=function(R,P,w){var D="/"+R,N=[],x=[],y=this;Object.keys(P).forEach(function(z){P[z].forEach(function(A){N.push(y.createUI5Message(A,R,z));});});(w||[""]).forEach(function(z){var A=d.buildPath(D,z);Object.keys(y.mMessages).forEach(function(F){if(F===A||F.startsWith(A+"/")||F.startsWith(A+"(")){x=x.concat(y.mMessages[F].filter(function(G){return!G.persistent;}));}});});if(N.length||x.length){this.fireMessageChange({newMessages:N,oldMessages:x});}};
v.prototype.reportTransitionMessages=function(w,R){var x=this;if(w&&w.length){this.fireMessageChange({newMessages:w.map(function(y){y.transition=true;return x.createUI5Message(y,R);})});}};
v.prototype.requestCanonicalPath=function(w){h(w.getModel()===this,"oEntityContext must belong to this model");return w.requestCanonicalPath();};
v.prototype.requestSideEffects=function(G,A){if(!A.length){return undefined;}return i.all(this.aAllBindings.filter(function(w){return w.isRoot();}).map(function(R){return R.requestAbsoluteSideEffects(G,A);}));};
v.prototype.resetChanges=function(G){G=G||this.sUpdateGroupId;this.checkBatchGroupId(G);if(this.isAutoGroup(G)){this.oRequestor.cancelChanges("$parked."+G);}this.oRequestor.cancelChanges(G);this.aAllBindings.forEach(function(w){if(G===w.getUpdateGroupId()){w.resetInvalidDataState();}});};
v.prototype.resolve=function(P,w){var R;if(P&&P[0]==="/"){R=P;}else if(w){R=w.getPath();if(P){if(!R.endsWith("/")){R+="/";}R+=P;}}if(R&&R!=="/"&&R[R.length-1]==="/"&&!R.includes("#")){R=R.slice(0,R.length-1);}return R;};
v.prototype.setLegacySyntax=function(){throw new Error("Unsupported operation: v4.ODataModel#setLegacySyntax");};
v.prototype.submitBatch=function(G){var w=this;this.checkBatchGroupId(G);if(this.isAutoGroup(G)){this.oRequestor.relocateAll("$parked."+G,G);}else{this.oRequestor.addChangeSet(G);}return new Promise(function(x){w.addPrerenderingTask(function(){x(w._submitBatch(G));});});};
v.prototype.toString=function(){return C+": "+this.sServiceUrl;};
v.prototype.withUnresolvedBindings=function(w,P){return this.aAllBindings.filter(function(x){return!x.isResolved();}).some(function(x){return x[w](P);});};
return v;});
sap.ui.predefine('sap/ui/model/odata/v4/ODataParentBinding',["./Context","./ODataBinding","./lib/_Helper","sap/base/Log","sap/ui/base/SyncPromise","sap/ui/model/ChangeReason"],function(C,a,_,L,S,b){"use strict";
function O(){a.call(this);this.mAggregatedQueryOptions={};this.bAggregatedQueryOptionsInitial=true;this.aChildCanUseCachePromises=[];this.bHasPathReductionToParent=false;this.iPatchCounter=0;this.bPatchSuccess=true;this.oReadGroupLock=undefined;this.oRefreshPromise=null;this.oResumePromise=undefined;}
a(O.prototype);var c="sap.ui.model.odata.v4.ODataParentBinding";
O.prototype.attachPatchCompleted=function(f,l){this.attachEvent("patchCompleted",f,l);};
O.prototype.detachPatchCompleted=function(f,l){this.detachEvent("patchCompleted",f,l);};
O.prototype.doSuspend=function(){};
O.prototype.firePatchCompleted=function(s){if(this.iPatchCounter===0){throw new Error("Completed more PATCH requests than sent");}this.iPatchCounter-=1;this.bPatchSuccess=this.bPatchSuccess&&s;if(this.iPatchCounter===0){this.fireEvent("patchCompleted",{success:this.bPatchSuccess});this.bPatchSuccess=true;}};
O.prototype.attachPatchSent=function(f,l){this.attachEvent("patchSent",f,l);};
O.prototype.detachPatchSent=function(f,l){this.detachEvent("patchSent",f,l);};
O.prototype.firePatchSent=function(){this.iPatchCounter+=1;if(this.iPatchCounter===1){this.fireEvent("patchSent");}};
O.prototype._findEmptyPathParentContext=function(o){if(this.sPath===""&&this.oContext.getBinding){return this.oContext.getBinding()._findEmptyPathParentContext(this.oContext);}return o;};
O.prototype.aggregateQueryOptions=function(q,B,e){var A=_.merge({},e&&this.mLateQueryOptions||this.mAggregatedQueryOptions),f=false,t=this;function m(g,Q,M,i,h){function j(E){var l=!g.$expand[E],s=M+"/"+E;if(l){g.$expand[E]={};if(e&&t.oModel.getMetaModel().fetchObject(s).getResult().$isCollection){return false;}f=true;}return m(g.$expand[E],Q.$expand[E],s,true,l);}function k(s){if(g.$select.indexOf(s)<0){f=true;g.$select.push(s);}return true;}return(!i||Object.keys(g).every(function(n){return n in Q||n==="$count"||n==="$expand"||n==="$select";}))&&Object.keys(Q).every(function(n){switch(n){case"$count":if(Q.$count){g.$count=true;}return true;case"$expand":g.$expand=g.$expand||{};return Object.keys(Q.$expand).every(j);case"$select":g.$select=g.$select||[];return Q.$select.every(k);default:if(h){g[n]=Q[n];return true;}return Q[n]===g[n];}});}if(m(A,q,B)){if(!e){this.mAggregatedQueryOptions=A;}else if(f){this.mLateQueryOptions=A;}return true;}return false;};
O.prototype.changeParameters=function(p){var B=Object.assign({},this.mParameters),s,k,t=this;function u(n){if(t.oModel.bAutoExpandSelect&&(n==="$expand"||n==="$select")){throw new Error("Cannot change "+n+" parameter in auto-$expand/$select mode: "+JSON.stringify(p[n])+" !== "+JSON.stringify(B[n]));}if(n==="$filter"||n==="$search"){s=b.Filter;}else if(n==="$orderby"&&s!==b.Filter){s=b.Sort;}else if(!s){s=b.Change;}}if(!p){throw new Error("Missing map of binding parameters");}for(k in p){if(k.startsWith("$$")){if(p[k]===B[k]){continue;}throw new Error("Unsupported parameter: "+k);}if(p[k]===undefined&&B[k]!==undefined){u(k);delete B[k];}else if(B[k]!==p[k]){u(k);if(typeof p[k]==="object"){B[k]=_.clone(p[k]);}else{B[k]=p[k];}}}if(s){if(this.hasPendingChanges(true)){throw new Error("Cannot change parameters due to pending changes");}this.applyParameters(B,s);}};
O.prototype.checkUpdateInternal=function(f){var t=this;function u(){return S.all(t.getDependentBindings().map(function(D){return D.checkUpdateInternal();}));}if(f!==undefined){throw new Error("Unsupported operation: "+c+"#checkUpdateInternal must not"+" be called with parameters");}return this.oCachePromise.then(function(o){if(o&&t.bRelative){return t.fetchResourcePath(t.oContext).then(function(r){if(o.getResourcePath()===r){return u();}return t.refreshInternal("");});}return u();});};
O.prototype.createInCache=function(u,v,s,t,i,e,f){var g=this;return this.oCachePromise.then(function(o){var p;if(o){p=_.getRelativePath(s,g.getResolvedPath());return o.create(u,v,p,t,i,e,f).then(function(h){if(g.mCacheByResourcePath){delete g.mCacheByResourcePath[o.getResourcePath()];}return h;});}return g.oContext.getBinding().createInCache(u,v,s,t,i,e,f);});};
O.prototype.createReadGroupLock=function(g,l,i){var G,t=this;function e(){t.oModel.addPrerenderingTask(function(){i-=1;if(i>0){Promise.resolve().then(e);}else if(t.oReadGroupLock===G){L.debug("Timeout: unlocked "+G,null,c);t.removeReadGroupLock();}});}this.removeReadGroupLock();this.oReadGroupLock=G=this.lockGroup(g,l);if(l){i=2+(i||0);e();}};
O.prototype.createRefreshPromise=function(){var p,r;p=new Promise(function(e){r=e;});p.$resolve=r;this.oRefreshPromise=p;return p;};
O.prototype.deleteFromCache=function(g,e,p,E,D,f){return this.withCache(function(o,s){return o._delete(g,e,s,E,D,f);},p,true);};
O.prototype.destroy=function(){this.aChildCanUseCachePromises=[];this.removeReadGroupLock();this.oResumePromise=undefined;a.prototype.destroy.call(this);};
O.prototype.fetchIfChildCanUseCache=function(o,s,v){var B=this.getBaseForPathReduction(),e=_.getMetaPath(o.getPath()),f,g,D=o.getPath().includes("(...)"),i=o.getIndex(),I=s[0]==="#",m=this.oModel.getMetaModel(),p,r=this.oModel.resolve(s,o),t=this;function h(){if(I){return m.fetchObject(e+"/");}return _.fetchPropertyAndType(t.oModel.oInterface.fetchMetadata,j(r));}function j(P){var i;P=_.getMetaPath(P);i=P.indexOf("@");return i>0?P.slice(0,i):P;}if(D&&!r.includes("/$Parameter/")||this.getRootBinding().isSuspended()||this.mParameters&&this.mParameters.$$aggregation){return S.resolve(r);}f=this.oCachePromise.isRejected()||i!==undefined&&i!==C.VIRTUAL||o.isKeepAlive()||this.oCache===null||this.oCache&&this.oCache.hasSentRequest();p=[this.doFetchQueryOptions(this.oContext),h(),v];g=S.all(p).then(function(R){var k=R[2],w,l=R[0],P=R[1],n,q;if(Array.isArray(P)){return undefined;}q=m.getReducedPath(r,B);n=_.getRelativePath(j(q),e);if(n===undefined){t.bHasPathReductionToParent=true;return t.oContext.getBinding().fetchIfChildCanUseCache(t.oContext,_.getRelativePath(r,t.oContext.getPath()),v);}if(D||n==="$count"||n.endsWith("/$count")){return q;}if(t.bAggregatedQueryOptionsInitial){t.selectKeyProperties(l,e);t.mAggregatedQueryOptions=_.clone(l);t.bAggregatedQueryOptionsInitial=false;}if(I){w={$select:[n.slice(1)]};return t.aggregateQueryOptions(w,e,f)?q:undefined;}if(n===""||P&&(P.$kind==="Property"||P.$kind==="NavigationProperty")){w=_.wrapChildQueryOptions(e,n,k,t.oModel.oInterface.fetchMetadata);if(w){return t.aggregateQueryOptions(w,e,f)?q:undefined;}return undefined;}if(n==="value"){return t.aggregateQueryOptions(k,e,f)?q:undefined;}L.error("Failed to enhance query options for auto-$expand/$select as the path '"+r+"' does not point to a property",JSON.stringify(P),c);return undefined;}).then(function(R){if(t.mLateQueryOptions){if(t.oCache){t.oCache.setLateQueryOptions(t.mLateQueryOptions);}else if(t.oCache===null){return t.oContext.getBinding().fetchIfChildCanUseCache(t.oContext,t.sPath,S.resolve(t.mLateQueryOptions)).then(function(P){return P&&R;});}}return R;});this.aChildCanUseCachePromises.push(g);this.oCachePromise=S.all([this.oCachePromise,g]).then(function(R){var k=R[0];if(k&&!k.hasSentRequest()&&!t.oOperation){if(t.bSharedRequest){k.setActive(false);k=t.createAndSetCache(t.mAggregatedQueryOptions,k.getResourcePath(),o);}else{k.setQueryOptions(_.merge({},t.oModel.mUriParameters,t.mAggregatedQueryOptions));}}return k;});this.oCachePromise.catch(function(E){t.oModel.reportError(t+": Failed to enhance query options for "+"auto-$expand/$select for child "+s,c,E);});return g;};
O.prototype.fetchResolvedQueryOptions=function(o){var f,m,M,e=this.oModel,q=this.getQueryOptionsFromParameters();if(!(e.bAutoExpandSelect&&q.$select)){return S.resolve(q);}f=e.oInterface.fetchMetadata;M=_.getMetaPath(e.resolve(this.sPath,o));m=Object.assign({},q,{$select:[]});return S.all(q.$select.map(function(s){return _.fetchPropertyAndType(f,M+"/"+s).then(function(){var w=_.wrapChildQueryOptions(M,s,{},f);if(w){_.aggregateExpandSelect(m,w);}else{_.addToSelect(m,[s]);}});})).then(function(){return m;});};
O.prototype.getBaseForPathReduction=function(){var p,P;if(!this.isRoot()){p=this.oContext.getBinding();P=p.getUpdateGroupId();if(P===this.getUpdateGroupId()||!this.oModel.isApiGroup(P)){return p.getBaseForPathReduction();}}return this.getResolvedPath();};
O.prototype.getInheritableQueryOptions=function(){if(this.mLateQueryOptions){return _.merge({},this.mCacheQueryOptions,this.mLateQueryOptions);}return this.mCacheQueryOptions||_.getQueryOptionsForPath(this.oContext.getBinding().getInheritableQueryOptions(),this.sPath);};
O.prototype.getGeneration=function(){return this.bRelative&&this.oContext.getGeneration&&this.oContext.getGeneration()||0;};
O.prototype.getQueryOptionsForPath=function(p,o){if(Object.keys(this.mParameters).length){return _.getQueryOptionsForPath(this.getQueryOptionsFromParameters(),p);}o=o||this.oContext;if(!this.bRelative||!o.getQueryOptionsForPath){return{};}return o.getQueryOptionsForPath(_.buildPath(this.sPath,p));};
O.prototype.getResumePromise=function(){return this.oResumePromise;};
O.prototype.hasPendingChangesInDependents=function(i){return this.getDependentBindings().some(function(D){var o=D.oCache,h;if(i&&D.oContext.isKeepAlive()){return false;}if(o!==undefined){if(o&&o.hasPendingChangesForPath("")){return true;}}else if(D.hasPendingChangesForPath("")){return true;}if(D.mCacheByResourcePath){h=Object.keys(D.mCacheByResourcePath).some(function(p){var e=D.mCacheByResourcePath[p];return e!==o&&e.hasPendingChangesForPath("");});if(h){return true;}}return D.hasPendingChangesInDependents();})||this.oModel.withUnresolvedBindings("hasPendingChangesInCaches",this.getResolvedPath().slice(1));};
O.prototype.isPatchWithoutSideEffects=function(){return this.mParameters.$$patchWithoutSideEffects||!this.isRoot()&&this.oContext&&this.oContext.getBinding().isPatchWithoutSideEffects();};
O.prototype.isMeta=function(){return false;};
O.prototype.refreshDependentBindings=function(r,g,e,k){return S.all(this.getDependentBindings().map(function(D){return D.refreshInternal(r,g,e,k);}));};
O.prototype.refreshDependentListBindingsWithoutCache=function(){return S.all(this.getDependentBindings().map(function(D){if(D.filter&&D.oCache===null){return D.refreshInternal("");}if(D.refreshDependentListBindingsWithoutCache){return D.refreshDependentListBindingsWithoutCache();}}));};
O.prototype.removeReadGroupLock=function(){if(this.oReadGroupLock){this.oReadGroupLock.unlock(true);this.oReadGroupLock=undefined;}};
O.prototype.resetChangesInDependents=function(p){this.getDependentBindings().forEach(function(D){p.push(D.oCachePromise.then(function(o){if(o){o.resetChangesForPath("");}D.resetInvalidDataState();}).unwrap());if(D.mCacheByResourcePath){Object.keys(D.mCacheByResourcePath).forEach(function(P){D.mCacheByResourcePath[P].resetChangesForPath("");});}D.resetChangesInDependents(p);});};
O.prototype.resolveRefreshPromise=function(p){if(this.oRefreshPromise){this.oRefreshPromise.$resolve(p.catch(function(e){if(!e.canceled){throw e;}}));this.oRefreshPromise=null;}return p;};
O.prototype._resume=function(A){var t=this;function e(){t.bSuspended=false;if(t.oResumePromise){t.resumeInternal(true);t.oResumePromise.$resolve();t.oResumePromise=undefined;}}if(this.oOperation){throw new Error("Cannot resume an operation binding: "+this);}if(!this.isRoot()){throw new Error("Cannot resume a relative binding: "+this);}if(!this.bSuspended){throw new Error("Cannot resume a not suspended binding: "+this);}if(A){this.createReadGroupLock(this.getGroupId(),true,1);this.oModel.addPrerenderingTask(e);}else{this.createReadGroupLock(this.getGroupId(),true);e();}};
O.prototype.resume=function(){this._resume(false);};
O.prototype.resumeAsync=function(){this._resume(true);return Promise.resolve(this.oResumePromise);};
O.prototype.selectKeyProperties=function(q,m){_.selectKeyProperties(q,this.oModel.getMetaModel().getObject(m+"/"));};
O.prototype.suspend=function(){var r;if(this.oOperation){throw new Error("Cannot suspend an operation binding: "+this);}if(!this.isRoot()){throw new Error("Cannot suspend a relative binding: "+this);}if(this.bSuspended){throw new Error("Cannot suspend a suspended binding: "+this);}if(this.hasPendingChanges(true)){throw new Error("Cannot suspend a binding with pending changes: "+this);}this.bSuspended=true;this.oResumePromise=new S(function(e){r=e;});this.oResumePromise.$resolve=r;this.removeReadGroupLock();this.doSuspend();};
O.prototype.updateAggregatedQueryOptions=function(n){var A=Object.keys(n),t=this;if(this.mAggregatedQueryOptions){A=A.concat(Object.keys(this.mAggregatedQueryOptions));A.forEach(function(N){if(t.bAggregatedQueryOptionsInitial||N!=="$select"&&N!=="$expand"){if(n[N]===undefined){delete t.mAggregatedQueryOptions[N];}else{t.mAggregatedQueryOptions[N]=n[N];}}});}};
O.prototype.visitSideEffects=function(g,p,o,n,P,s){var D=o?this.oModel.getDependentBindings(o):this.getDependentBindings();D.forEach(function(e){var f=_.buildPath(s,_.getMetaPath(e.getPath())),h;if(e.oCache){h=_.stripPathPrefix(f,p);if(h.length){P.push(e.requestSideEffects(g,h));}}else if(n[f]){P.push(e.refreshInternal("",g));}else{e.visitSideEffects(g,p,null,n,P,f);}});};
function d(p){if(this){O.apply(this,arguments);}else{Object.assign(p,O.prototype);}}
["adjustPredicate","destroy","doDeregisterChangeListener","getGeneration","hasPendingChangesForPath"].forEach(function(m){d.prototype[m]=O.prototype[m];});return d;},false);
sap.ui.predefine('sap/ui/model/odata/v4/ODataPropertyBinding',["./ODataBinding","./lib/_Cache","./lib/_Helper","sap/base/Log","sap/ui/base/SyncPromise","sap/ui/model/BindingMode","sap/ui/model/ChangeReason","sap/ui/model/odata/v4/Context","sap/ui/model/PropertyBinding"],function(a,_,b,L,S,B,C,c,P){"use strict";var s="sap.ui.model.odata.v4.ODataPropertyBinding",i=Object.freeze([]),m={AggregatedDataStateChange:true,change:true,dataReceived:true,dataRequested:true,DataStateChange:true},v="/"+c.VIRTUAL;
var O=P.extend("sap.ui.model.odata.v4.ODataPropertyBinding",{
constructor:function(M,p,o,d){P.call(this,M,p);a.call(this);if(p.endsWith("/")){throw new Error("Invalid path: "+p);}if(d){this.checkBindingParameters(d,["$$groupId","$$ignoreMessages","$$noPatch"]);this.sGroupId=d.$$groupId;this.bNoPatch=d.$$noPatch;this.setIgnoreMessages(d.$$ignoreMessages);}else{this.sGroupId=undefined;this.bNoPatch=false;}this.oCheckUpdateCallToken=undefined;this.oContext=o;this.bHasDeclaredType=undefined;this.bInitial=true;this.mQueryOptions=this.oModel.buildQueryOptions(b.clone(d),p.endsWith("$count"));this.vValue=undefined;this.fetchCache(o);M.bindingCreated(this);},
metadata:{publicMethods:[]}
});
a(O.prototype);
O.prototype.attachEvent=function(e,d,f,g){if(!(e in m)){throw new Error("Unsupported event '"+e+"': v4.ODataPropertyBinding#attachEvent");}return P.prototype.attachEvent.apply(this,arguments);};
O.prototype.checkUpdateInternal=function(f,d,g,V){var D=false,h=this.sPath.indexOf("##"),I=h>=0,M=this.oModel.getMetaModel(),p={data:{}},r=this.getResolvedPath(),o={forceUpdate:r&&(f||f===undefined&&this.getDataState().getControlMessages().length>0||this.oCheckUpdateCallToken&&this.oCheckUpdateCallToken.forceUpdate)},t=this.oType,e=this;this.oCheckUpdateCallToken=o;if(this.bHasDeclaredType===undefined){this.bHasDeclaredType=!!t;}if(r&&!this.bHasDeclaredType&&this.sInternalType!=="any"&&!I){t=M.fetchUI5Type(r);}if(arguments.length<4){V=this.oCachePromise.then(function(j){var k,l;if(j){return j.fetchValue(e.lockGroup(g||e.getGroupId()),undefined,function(){D=true;e.fireDataRequested();},e).then(function(R){e.assertSameCache(j);return R;});}if(!e.sReducedPath||!e.isResolved()){return undefined;}if(r.includes(v)){o.forceUpdate=false;}if(!I){return e.oContext.fetchValue(e.sReducedPath,e);}k=e.sPath.slice(0,h);l=e.sPath.slice(h+2);if(l[0]==="/"){l="."+l;}return M.fetchObject(l,M.getMetaContext(e.oModel.resolve(k,e.oContext)));}).then(function(V){if(!V||typeof V!=="object"){return V;}if(e.sInternalType==="any"&&(e.getBindingMode()===B.OneTime||(e.sPath[e.sPath.lastIndexOf("/")+1]==="#"&&!I))){if(I){return V;}else if(e.bRelative){return b.publicClone(V);}}L.error("Accessed value is not primitive",r,s);},function(E){e.oModel.reportError("Failed to read path "+r,s,E);if(E.canceled){o.forceUpdate=false;return e.vValue;}p={error:E};});if(f&&V.isFulfilled()){if(t&&t.isFulfilled&&t.isFulfilled()){this.setType(t.getResult(),this.sInternalType);}this.vValue=V.getResult();}V=Promise.resolve(V);}return S.all([V,t]).then(function(R){var T=R[1],V=R[0];if(o===e.oCheckUpdateCallToken){e.oCheckUpdateCallToken=undefined;e.setType(T,e.sInternalType);if(o.forceUpdate||e.vValue!==V){e.bInitial=false;e.vValue=V;e._fireChange({reason:d||C.Change});}e.checkDataState();}if(D){e.fireDataReceived(p);}if(p.error){throw p.error;}});};
O.prototype.deregisterChange=function(){var t=this;this.withCache(function(d,p,o){o.doDeregisterChangeListener(p,t);}).catch(function(e){t.oModel.reportError("Error in deregisterChange",s,e);},"",false,true);};
O.prototype.destroy=function(){this.deregisterChange();this.oModel.bindingDestroyed(this);this.oCheckUpdateCallToken=undefined;this.mQueryOptions=undefined;this.vValue=undefined;a.prototype.destroy.call(this);P.prototype.destroy.apply(this,arguments);};
O.prototype.doCreateCache=function(r,q){return _.createProperty(this.oModel.oRequestor,r,q);};
O.prototype.doFetchQueryOptions=function(){return this.isRoot()?S.resolve(this.mQueryOptions):S.resolve({});};
O.prototype.getDependentBindings=function(){return i;};
O.prototype.getResumePromise=function(){};
O.prototype.getValue=function(){return this.vValue;};
O.prototype.getValueListType=function(){var r=this.getResolvedPath();if(!r){throw new Error(this+" is unresolved");}return this.getModel().getMetaModel().getValueListType(r);};
O.prototype.hasPendingChangesInDependents=function(){return false;};
O.prototype.initialize=function(){if(this.isResolved()){if(this.getRootBinding().isSuspended()){this.sResumeChangeReason=C.Change;}else{this.checkUpdate(true);}}};
O.prototype.isMeta=function(){return this.sPath.includes("##");};
O.prototype.onChange=function(V){this.checkUpdateInternal(undefined,undefined,undefined,V).catch(this.oModel.getReporter());};
O.prototype.refreshInternal=function(d,g,e,k){var t=this;if(this.isRootBindingSuspended()){this.refreshSuspended(g);return S.resolve();}return this.oCachePromise.then(function(){t.fetchCache(t.oContext,false,true,k);if(e){return t.checkUpdateInternal(undefined,C.Refresh,g);}});};
O.prototype.requestValue=function(){var t=this;return Promise.resolve(this.checkUpdateInternal(false).then(function(){return t.getValue();}));};
O.prototype.requestValueListInfo=function(A){var r=this.getResolvedPath();if(!r){throw new Error(this+" is unresolved");}return this.getModel().getMetaModel().requestValueListInfo(r,A,this.oContext);};
O.prototype.requestValueListType=function(){var r=this.getResolvedPath();if(!r){throw new Error(this+" is unresolved");}return this.getModel().getMetaModel().requestValueListType(r);};
O.prototype.resetChangesInDependents=function(){};
O.prototype.resetInvalidDataState=function(){if(this.getDataState().isControlDirty()){this._fireChange({reason:C.Change});}};
O.prototype.resume=function(){throw new Error("Unsupported operation: resume");};
O.prototype.resumeInternal=function(d,p){var r=this.sResumeChangeReason;this.sResumeChangeReason=undefined;this.fetchCache(this.oContext);if(d){this.checkUpdateInternal(p?undefined:false,r).catch(this.oModel.getReporter());}};
O.prototype.setContext=function(o){if(this.oContext!==o){if(this.bRelative){this.checkSuspended(true);this.deregisterChange();}this.oContext=o;this.sResumeChangeReason=undefined;if(this.bRelative){this.fetchCache(this.oContext);this.checkUpdateInternal(this.bInitial||undefined,C.Context).catch(this.oModel.getReporter());}}};
O.prototype.setType=function(t,d){var o=this.oType;if(t&&t.getName()==="sap.ui.model.odata.type.DateTimeOffset"){t.setV4();}P.prototype.setType.apply(this,arguments);if(!this.bInitial&&o!==t){this._fireChange({reason:C.Change});}};
O.prototype.setValue=function(V,g){var G,t=this;function r(e){t.oModel.reportError("Failed to update path "+t.getResolvedPath(),s,e);return e;}this.checkSuspended();if(this.bNoPatch&&g){throw r(new Error("Must not specify a group ID ("+g+") with $$noPatch"));}this.oModel.checkGroupId(g);if(typeof V==="function"||(V&&typeof V==="object")){throw r(new Error("Not a primitive value"));}if(!this.bNoPatch&&this.vValue===undefined){throw r(new Error("Must not change a property before it has been read"));}if(this.vValue!==V){if(this.oCache){r(new Error("Cannot set value on this binding as it is not relative"+" to a sap.ui.model.odata.v4.Context"));return;}G=this.bNoPatch?null:this.lockGroup(g,true,true);this.oContext.doSetProperty(this.sPath,V,G).catch(function(e){if(G){G.unlock(true);}r(e);});}};
O.prototype.supportsIgnoreMessages=function(){return true;};
O.prototype.suspend=function(){throw new Error("Unsupported operation: suspend");};
O.prototype.visitSideEffects=function(){};
return O;});
sap.ui.predefine('sap/ui/model/odata/v4/ODataUtils',["sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/odata/ODataUtils","sap/ui/model/odata/v4/lib/_Batch","sap/ui/model/odata/v4/lib/_Helper"],function(C,D,B,_,a){"use strict";var d,o,s="\\d{4}-(?:0[1-9]|1[0-2])-(?:0[1-9]|[12]\\d|3[01])",t,T="(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(\\.\\d{1,12})?)?",r=new RegExp("^"+s+"$"),b=new RegExp("^"+s+"T"+T+"(?:Z|[-+](?:0\\d|1[0-3]):[0-5]\\d|[-+]14:00)$","i"),c=new RegExp("^"+T+"$"),O={_setDateTimeFormatter:function(){d=D.getDateInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd",strictParsing:true,UTC:true});o=D.getDateTimeInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd'T'HH:mm:ss.SSSXXX",strictParsing:true});t=D.getTimeInstance({calendarType:C.Gregorian,pattern:"HH:mm:ss.SSS",strictParsing:true,UTC:true});},compare:function(v,V,e){if(e===true||e==="Decimal"){return B.compare(v,V,true);}if(e==="DateTime"){return B.compare(O.parseDateTimeOffset(v),O.parseDateTimeOffset(V));}return B.compare(v,V);},deserializeBatchResponse:function(e,R){return _.deserializeBatchResponse(e,R);},formatLiteral:function(v,e){return a.formatLiteral(v,e);},parseDate:function(e){var f=r.test(e)&&d.parse(e);if(!f){throw new Error("Not a valid Edm.Date value: "+e);}return f;},parseDateTimeOffset:function(e){var f,m=b.exec(e);if(m){if(m[1]&&m[1].length>4){e=e.replace(m[1],m[1].slice(0,4));}f=o.parse(e.toUpperCase());}if(!f){throw new Error("Not a valid Edm.DateTimeOffset value: "+e);}return f;},parseTimeOfDay:function(e){var f;if(c.test(e)){if(e.length>12){e=e.slice(0,12);}f=t.parse(e);}if(!f){throw new Error("Not a valid Edm.TimeOfDay value: "+e);}return f;},serializeBatchRequest:function(R,e){return _.serializeBatchRequest(R,e);}};O._setDateTimeFormatter();return O;},true);
sap.ui.predefine('sap/ui/model/odata/v4/SubmitMode',function(){"use strict";var S={API:"API",Auto:"Auto",Direct:"Direct"};return S;},true);
sap.ui.predefine('sap/ui/model/odata/v4/ValueListType',function(){"use strict";var V={None:"None",Fixed:"Fixed",Standard:"Standard"};return V;},true);
sap.ui.predefine('sap/ui/model/odata/v4/_AnnotationHelperExpression',["../_AnnotationHelperBasics","sap/base/Log","sap/ui/base/BindingParser","sap/ui/base/ManagedObject","sap/ui/base/SyncPromise","sap/ui/performance/Measurement"],function(B,L,a,M,S,b){"use strict";var A="sap.ui.model.odata.v4.AnnotationHelper",p=[A],P=A+"/getExpression",r=/^{@i18n>[^\\{}:]+}$/,o={And:"&&",Eq:"===",Ge:">=",Gt:">",Le:"<=",Lt:"<",Ne:"!==",Not:"!",Or:"||"},s=false,t={"Edm.Boolean":"boolean","Edm.Byte":"number","Edm.Date":"Date","Edm.DateTimeOffset":"DateTimeOffset","Edm.Decimal":"Decimal","Edm.Double":"number","Edm.Guid":"string","Edm.Int16":"number","Edm.Int32":"number","Edm.Int64":"Decimal","Edm.SByte":"number","Edm.Single":"number","Edm.String":"string","Edm.TimeOfDay":"TimeOfDay"},T={Bool:"Edm.Boolean",Float:"Edm.Double",Date:"Edm.Date",DateTimeOffset:"Edm.DateTimeOffset",Decimal:"Edm.Decimal",Guid:"Edm.Guid",Int:"Edm.Int64",Int32:"Edm.Int32",String:"Edm.String",TimeOfDay:"Edm.TimeOfDay"},m={boolean:false,Date:false,DateTimeOffset:true,Decimal:true,number:false,string:false,TimeOfDay:false},E;
function c(e,f){return S.resolve().then(function(){d(e,f);});}
function d(e,f){B.error(e,f,A);}
E={adjustOperands:function(O,e){if(O.result!=="constant"&&O.category==="number"&&e.result==="constant"&&e.type==="Edm.Int64"){e.category="number";}if(O.result!=="constant"&&O.category==="Decimal"&&e.result==="constant"&&e.type==="Edm.Int32"){e.category="Decimal";e.type=O.type;}},apply:function(e,f){var F=B.descend(e,"$Function","string");switch(F.value){case"odata.concat":return E.concat(f);case"odata.fillUriTemplate":return E.fillUriTemplate(f);case"odata.uriEncode":return E.uriEncode(f);default:return c(F,"unknown function: "+F.value);}},collection:function(e){var f;B.expectType(e,"array");f=e.value.map(function(_,i){return E.expression(B.descend(e,i,true),true);});return S.all(f).then(function(g){g=g.map(function(h){return B.resultToString(h,true,false,true);});return{result:"expression",value:"odata.collection(["+g.join(",")+"])"};});},concat:function(e){var f;B.expectType(e,"array");f=e.value.map(function(_,i){return E.parameter(e,i);});return S.all(f).then(function(g){var h,i,R;h=e.asExpression||g.some(function(j){return j.result==="expression";});i=g.filter(function(j){return j.type!=="edm:Null";}).map(function(j){if(h){E.wrapExpression(j);}return B.resultToString(j,h,e.complexBinding);});R=h?{result:"expression",value:i.join("+")}:{result:"composite",value:i.join("")};R.type="Edm.String";return R;});},conditional:function(e,i){var C=e.complexBinding,f=C?Object.assign({},e,{complexBinding:false}):e;function g(h,j,R){return B.resultToString(E.wrapExpression(h),true,j,R);}return S.all([E.parameter(f,0,"Edm.Boolean"),E.parameter(e,1),i&&e.value.length===2?{result:"constant",type:"edm:Null",value:undefined}:E.parameter(e,2)]).then(function(R){var h=R[0],j=R[1],k=R[2],l=j.type;if(j.type==="edm:Null"){l=k.type;}else if(k.type!=="edm:Null"&&j.type!==k.type){d(e,"Expected same type for second and third parameter, types are '"+j.type+"' and '"+k.type+"'");}return{result:"expression",type:l,value:g(h,false,true)+"?"+g(j,C)+":"+g(k,C)};});},constant:function(e,f){var v=e.value;if(f==="String"){if(r.test(v)){return{ignoreTypeInPath:true,result:"binding",type:"Edm.String",value:v.slice(1,-1)};}}return{result:"constant",type:T[f],value:v};},expression:function(e,i){var R=e.value,f=e,g;if(R===null){g="Null";}else if(typeof R==="boolean"){g="Bool";}else if(typeof R==="number"){g=isFinite(R)&&Math.floor(R)===R?"Int32":"Float";}else if(typeof R==="string"){g="String";}else if(Array.isArray(R)){return E.collection(e);}else{B.expectType(e,"object");if(R.$kind==="Property"){e.value=e.model.getObject(e.path+"@sapui.name");return E.path(e);}["$And","$Apply","$Date","$DateTimeOffset","$Decimal","$Float","$Eq","$Ge","$Gt","$Guid","$If","$Int","$Le","$Lt","$Name","$Ne","$Not","$Null","$Or","$Path","$PropertyPath","$TimeOfDay","$LabeledElement"].forEach(function(h){if(R.hasOwnProperty(h)){g=h.slice(1);f=B.descend(e,h);}});}switch(g){case"Apply":return E.apply(e,f);case"If":return E.conditional(f,i);case"Name":case"Path":case"PropertyPath":return E.path(f);case"Date":case"DateTimeOffset":case"Decimal":case"Guid":case"Int":case"String":case"TimeOfDay":B.expectType(f,"string");case"Bool":case"Float":case"Int32":return S.resolve(E.constant(f,g));case"And":case"Eq":case"Ge":case"Gt":case"Le":case"Lt":case"Ne":case"Or":return E.operator(f,g);case"Not":return E.not(f);case"Null":return S.resolve({result:"constant",type:"edm:Null",value:null});default:return c(e,"Unsupported OData expression");}},fetchCurrencyOrUnit:function(e,v,f,C){var g="sap.ui.model.odata.type.Unit",h="@@requestUnitsOfMeasure",i=e.model,j=e.path+"@Org.OData.Measures.V1.Unit/$Path",k=i.getObject(j);function l(n,q,u){return B.resultToString(E.pathResult(e,q,u,n),false,true);}if(!k){g="sap.ui.model.odata.type.Currency";h="@@requestCurrencyCodes";j=e.path+"@Org.OData.Measures.V1.ISOCurrency/$Path";k=i.getObject(j);}if(!k){return undefined;}return i.fetchObject(j+"/$").then(function(n){var q=i.getObject(e.path+"@com.sap.vocabularies.UI.v1.DoNotCheckScaleOfMeasureQuantity")?",constraints:{'skipDecimalsValidation':true}":"";return{result:"composite",type:g,value:(t[f]==="number"?"{formatOptions:{parseAsString:false},":"{")+"mode:'TwoWay',parts:["+l(C,f,v)+","+l(i.getConstraints(n,j),n.$Type,k)+",{mode:'OneTime',path:'/##"+h+"',targetType:'any'}"+"],type:'"+g+"'"+q+"}"};});},fillUriTemplate:function(e){var f=[],g,i;e.complexBinding=false;g=[E.parameter(e,0,"Edm.String")];for(i=1;i<e.value.length;i+=1){f[i]=B.descend(e,i,"object");g.push(E.expression(B.descend(f[i],"$LabeledElement",true)));}return S.all(g).then(function(R){var n,h=[],j="";h.push("odata.fillUriTemplate(",B.resultToString(R[0],true,false,true),",{");for(i=1;i<e.value.length;i+=1){n=B.property(f[i],"$Name","string");h.push(j,B.toJSON(n),":",B.resultToString(R[i],true,false,true));j=",";}h.push("})");return{result:"expression",type:"Edm.String",value:h.join("")};});},formatOperand:function(R,w){if(R.result==="constant"){switch(R.category){case"boolean":case"number":return String(R.value);}}if(w){E.wrapExpression(R);}return B.resultToString(R,true,false,true);},getExpression:function(f){if(f.value===undefined){return undefined;}b.average(P,"",p);if(!s&&M.bindingParser===a.simpleParser){L.warning("Complex binding syntax not active",null,A);s=true;}return E.expression(f).then(function(R){return B.resultToString(R,false,f.complexBinding);},function(e){if(e instanceof SyntaxError){return"Unsupported: "+a.complexParser.escape(B.toErrorString(f.value));}throw e;}).finally(function(){b.end(P);}).unwrap();},not:function(e){e.asExpression=true;e.complexBinding=false;return E.expression(e).then(function(f){return{result:"expression",type:"Edm.Boolean",value:"!"+B.resultToString(E.wrapExpression(f),true,false,true)};});},operator:function(e,f){var g=f==="And"||f==="Or"?"Edm.Boolean":undefined;e.complexBinding=false;return S.all([E.parameter(e,0,g),E.parameter(e,1,g)]).then(function(R){var n,h=R[0],i=R[1],j="",v,V;if(h.type!=="edm:Null"&&i.type!=="edm:Null"){h.category=t[h.type];i.category=t[i.type];E.adjustOperands(h,i);E.adjustOperands(i,h);if(h.category!==i.category){d(e,"Expected two comparable parameters but instead saw "+h.type+" and "+i.type);}switch(h.category){case"Decimal":j=",'Decimal'";break;case"DateTimeOffset":j=",'DateTime'";break;}n=m[h.category];}v=E.formatOperand(h,!n);V=E.formatOperand(i,!n);return{result:"expression",type:"Edm.Boolean",value:n?"odata.compare("+v+","+V+j+")"+o[f]+"0":v+o[f]+V};});},parameter:function(e,i,f){var g=B.descend(e,i,true);return E.expression(g).then(function(R){if(f&&f!==R.type){d(g,"Expected "+f+" but instead saw "+R.type);}return R;});},path:function(e){var i=e.ignoreAsPrefix,f=e.model,g,v=e.value;if(i&&v.startsWith(i)){v=v.slice(i.length);}B.expectType(e,"string");g=f.fetchObject(e.path+"/$");if(g.isPending()&&!e.$$valueAsPromise){g.caught();g=S.resolve();}return g.then(function(h){var C,j,k=h&&h.$Type;if(h&&e.complexBinding){C=f.getConstraints(h,e.path);j=E.fetchCurrencyOrUnit(e,v,k,C);}return j||E.pathResult(e,k,v,C);});},pathResult:function(e,f,g,C){return{constraints:C,formatOptions:f==="Edm.String"?Object.assign({parseKeepsEmptyString:true},e.formatOptions):e.formatOptions,parameters:e.parameters,result:"binding",type:f,value:e.prefix+g};},uriEncode:function(e){return E.parameter(e,0).then(function(R){return{result:"expression",type:"Edm.String",value:R.type==="Edm.String"?"odata.uriEncode("+B.resultToString(R,true,false,true)+","+B.toJSON(R.type)+")":"String("+B.resultToString(R,true,false,true)+")"};});},wrapExpression:function(R){if(R.result==="expression"){R.value="("+R.value+")";}return R;}};return E;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_AggregationCache',["./_AggregationHelper","./_Cache","./_ConcatHelper","./_GroupLock","./_Helper","./_MinMaxHelper","sap/base/Log","sap/ui/base/SyncPromise"],function(_,a,b,c,d,e,L,S){"use strict";
function f(r,R,A,q,h){var C=function(){},l=null,t=this;a.call(this,r,R,q,true);this.oAggregation=A;this.sDownloadUrl=a.prototype.getDownloadUrl.call(this,"");this.aElements=[];this.aElements.$byPredicate={};this.aElements.$count=undefined;this.aElements.$created=0;this.oLeavesPromise=undefined;if(q.$count&&A.groupLevels.length){q.$$leaves=true;this.oLeavesPromise=new S(function(g){l=function(o){g(parseInt(o.UI5__leaves));};});}this.oFirstLevel=this.createGroupLevelCache(null,h||!!l);this.oGrandTotalPromise=undefined;if(h){this.oGrandTotalPromise=new S(function(g){b.enhanceCache(t.oFirstLevel,A,[l,function(G){var o;if(A["grandTotal like 1.84"]){_.removeUI5grand__(G);}_.setAnnotations(G,true,true,0,_.getAllProperties(A));if(A.grandTotalAtBottomOnly===false){o=Object.assign({},G,{"@$ui5.node.isExpanded":undefined});d.setPrivateAnnotation(G,"copy",o);d.setPrivateAnnotation(o,"predicate","($isTotal=true)");}d.setPrivateAnnotation(G,"predicate","()");g(G);},C]);});}else if(l){b.enhanceCache(t.oFirstLevel,A,[l,C]);}}
f.prototype=Object.create(a.prototype);
f.prototype.addElements=function(r,o,C,s){var E=this.aElements;function g(h,i){var O=E[o+i],p,P=d.getPrivateAnnotation(h,"predicate");if(O){if(O===h){return;}p=d.getPrivateAnnotation(O,"parent");if(!p){throw new Error("Unexpected element");}if(p!==C||d.getPrivateAnnotation(O,"index")!==s+i){throw new Error("Wrong placeholder");}}else if(o+i>=E.length){throw new Error("Array index out of bounds: "+(o+i));}if(P in E.$byPredicate&&E.$byPredicate[P]!==h){throw new Error("Duplicate predicate: "+P);}E[o+i]=h;E.$byPredicate[P]=h;}if(o<0){throw new Error("Illegal offset: "+o);}if(Array.isArray(r)){r.forEach(g);}else{g(r,0);}};
f.prototype.collapse=function(g){var C,h=0,E=this.aElements,G=this.fetchValue(c.$cached,g).getResult(),k=G["@$ui5.node.level"],I=E.indexOf(G),i=I+1;function l(j){delete E.$byPredicate[d.getPrivateAnnotation(E[j],"predicate")];h+=1;}C=d.getPrivateAnnotation(G,"collapsed");d.updateAll(this.mChangeListeners,g,G,C);while(i<E.length&&E[i]["@$ui5.node.level"]>k){l(i);i+=1;}if(this.oAggregation.subtotalsAtBottomOnly!==undefined&&Object.keys(C).length>1){l(i);}d.setPrivateAnnotation(G,"spliced",E.splice(I+1,h));E.$count-=h;return h;};
f.prototype.createGroupLevelCache=function(g,h){var A=this.oAggregation,i=_.getAllProperties(A),C,G,l,j,q,t;j=g?g["@$ui5.node.level"]+1:1;l=j>A.groupLevels.length;G=l?A.groupLevels.concat(Object.keys(A.group).sort()):A.groupLevels.slice(0,j);q=_.filterOrderby(this.mQueryOptions,A,j);t=!l&&Object.keys(A.aggregate).some(function(s){return A.aggregate[s].subtotals;});if(g){q.$$filterBeforeAggregate=d.getPrivateAnnotation(g,"filter")+(q.$$filterBeforeAggregate?" and ("+q.$$filterBeforeAggregate+")":"");}if(!h){delete q.$count;q=_.buildApply(A,q,j);}q.$count=true;C=a.create(this.oRequestor,this.sResourcePath,q,true);C.calculateKeyPredicate=f.calculateKeyPredicate.bind(null,g,G,i,l,t);return C;};
f.prototype.expand=function(g,G){var C,h,E=this.aElements,o=typeof G==="string"?this.fetchValue(c.$cached,G).getResult():G,I,s=d.getPrivateAnnotation(o,"spliced"),t=this;if(G!==o){d.updateAll(this.mChangeListeners,G,o,_.getOrCreateExpandedObject(this.oAggregation,o));}if(s){d.deletePrivateAnnotation(o,"spliced");I=E.indexOf(o)+1;this.aElements=E.concat(s,E.splice(I));this.aElements.$byPredicate=E.$byPredicate;h=s.length;this.aElements.$count=E.$count+h;s.forEach(function(i){var p=d.getPrivateAnnotation(i,"predicate");if(p){t.aElements.$byPredicate[p]=i;if(d.getPrivateAnnotation(i,"expanding")){d.deletePrivateAnnotation(i,"expanding");h+=t.expand(c.$cached,i).getResult();}}});d.updateAll(t.mChangeListeners,G,o,{"@$ui5.node.groupLevelCount":d.getPrivateAnnotation(o,"groupLevelCount")});return S.resolve(h);}C=d.getPrivateAnnotation(o,"cache");if(!C){C=this.createGroupLevelCache(o);d.setPrivateAnnotation(o,"cache",C);}return C.read(0,this.iReadLength,0,g).then(function(r){var I=t.aElements.indexOf(o)+1,l=o["@$ui5.node.level"],j=d.getPrivateAnnotation(o,"collapsed"),k=t.oAggregation.subtotalsAtBottomOnly!==undefined&&Object.keys(j).length>1,i;if(!o["@$ui5.node.isExpanded"]){d.deletePrivateAnnotation(o,"spliced");return 0;}if(!I){d.setPrivateAnnotation(o,"expanding",true);return 0;}h=r.value.$count;d.setPrivateAnnotation(o,"groupLevelCount",h);d.updateAll(t.mChangeListeners,G,o,{"@$ui5.node.groupLevelCount":h});if(k){h+=1;}if(I===t.aElements.length){t.aElements.length+=h;}else{for(i=t.aElements.length-1;i>=I;i-=1){t.aElements[i+h]=t.aElements[i];delete t.aElements[i];}}t.addElements(r.value,I,C,0);for(i=I+r.value.length;i<I+r.value.$count;i+=1){t.aElements[i]=_.createPlaceholder(l+1,i-I,C);}if(k){j=Object.assign({},j);_.setAnnotations(j,undefined,true,l,_.getAllProperties(t.oAggregation));d.setPrivateAnnotation(j,"predicate",d.getPrivateAnnotation(o,"predicate").slice(0,-1)+",$isTotal=true)");t.addElements(j,I+h-1);}t.aElements.$count+=h;return h;},function(i){d.updateAll(t.mChangeListeners,G,o,d.getPrivateAnnotation(o,"collapsed"));throw i;});};
f.prototype.fetchValue=function(g,p,D,l){if(p==="$count"){if(this.oLeavesPromise){return this.oLeavesPromise;}if(this.oAggregation.groupLevels.length){L.error("Failed to drill-down into $count, invalid segment: $count",this.toString(),"sap.ui.model.odata.v4.lib._Cache");return S.resolve();}return this.oFirstLevel.fetchValue(g,p,D,l);}this.registerChange(p,l);return this.drillDown(this.aElements,p,g);};
f.prototype.getDownloadQueryOptions=function(q){return _.buildApply(this.oAggregation,_.filterOrderby(q,this.oAggregation),0,true);};
f.prototype.getDownloadUrl=function(g,h){return this.sDownloadUrl;};
f.prototype.read=function(I,l,p,g,D){var C,F=I,h=l,G,k,H=!!this.oGrandTotalPromise,m=H&&this.oAggregation.grandTotalAtBottomOnly!==true,r=[],i,n,t=this;function o(k,j){var q=G,Q=G.getQueryOptions(),s=d.getPrivateAnnotation(t.aElements[k],"index"),u=t.aElements[k];if(Q.$count){delete Q.$count;G.setQueryOptions(Q,true);}r.push(G.read(s,j-k,0,g.getUnlockedCopy(),D).then(function(R){var v=false,E;if(u!==t.aElements[k]&&R.value[0]!==t.aElements[k]){v=true;k=t.aElements.indexOf(u);if(k<0){k=t.aElements.indexOf(R.value[0]);if(k<0){E=new Error("Collapse before read has finished");E.canceled=true;throw E;}}}t.addElements(R.value,k,q,s);if(v){E=new Error("Collapse or expand before read has finished");E.canceled=true;throw E;}}));}if(m&&!I&&l===1){if(p!==0){throw new Error("Unsupported prefetch length: "+p);}g.unlock();return this.oGrandTotalPromise.then(function(j){return{value:[j]};});}else if(this.aElements.$count===undefined){this.iReadLength=l+p;if(m){if(F){F-=1;}else{h-=1;}}r.push(this.oFirstLevel.read(F,h,p,g,D).then(function(R){var q,s,O=0,j;t.aElements.length=t.aElements.$count=R.value.$count;if(H){t.aElements.$count+=1;t.aElements.length+=1;q=t.oGrandTotalPromise.getResult();switch(t.oAggregation.grandTotalAtBottomOnly){case false:O=1;t.aElements.$count+=1;t.aElements.length+=1;t.addElements(q,0);s=d.getPrivateAnnotation(q,"copy");t.addElements(s,t.aElements.length-1);break;case true:t.addElements(q,t.aElements.length-1);break;default:O=1;t.addElements(q,0);}}t.addElements(R.value,F+O,t.oFirstLevel,F);for(j=0;j<t.aElements.$count;j+=1){if(!t.aElements[j]){t.aElements[j]=_.createPlaceholder(1,j-O,t.oFirstLevel);}}}));}else{for(i=I,n=Math.min(I+l,this.aElements.length);i<n;i+=1){C=d.getPrivateAnnotation(this.aElements[i],"parent");if(C!==G){if(k){o(k,i);G=k=undefined;}if(C){k=i;G=C;}}}if(k){o(k,i);}g.unlock();}return S.all(r).then(function(){var E=t.aElements.slice(I,I+l);E.$count=t.aElements.$count;return{value:E};});};
f.prototype.refreshKeptElements=function(){};
f.prototype.toString=function(){return this.sDownloadUrl;};
f.calculateKeyPredicate=function(g,G,A,l,t,E,T,m){var p;if(!(m in T)){return undefined;}if(g){A.forEach(function(P){if(Array.isArray(P)){d.inheritPathValue(P,g,E);}else if(!(P in E)){E[P]=g[P];}});}p=l&&d.getKeyPredicate(E,m,T)||d.getKeyPredicate(E,m,T,G,true);d.setPrivateAnnotation(E,"predicate",p);if(!l){d.setPrivateAnnotation(E,"filter",d.getKeyFilter(E,m,T,G));}_.setAnnotations(E,l?undefined:false,t,g?g["@$ui5.node.level"]+1:1,g?null:A);return p;};
f.create=function(r,R,D,A,q,s,g){var h,H,i;if(A){h=_.hasGrandTotal(A.aggregate);H=!!A.groupLevels.length;i=_.hasMinOrMax(A.aggregate);if(q.$filter&&(h&&!A["grandTotal like 1.84"]||H)){throw new Error("Unsupported system query option: $filter");}if(q.$search&&(h||H)){throw new Error("Unsupported system query option: $search");}if(i){if(h){throw new Error("Unsupported grand totals together with min/max");}if(H){throw new Error("Unsupported group levels together with min/max");}}if(h||H||i){if("$expand"in q){throw new Error("Unsupported system query option: $expand");}if("$select"in q){throw new Error("Unsupported system query option: $select");}return i?e.createCache(r,R,A,q):new f(r,R,A,q,h);}}if(q.$$filterBeforeAggregate){q.$apply="filter("+q.$$filterBeforeAggregate+")/"+q.$apply;delete q.$$filterBeforeAggregate;}return a.create(r,R,q,s,D,g);};
return f;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_AggregationHelper',["./_Helper","./_Parser","sap/ui/model/Filter"],function(_,a,F){"use strict";var A={aggregate:{"*":{grandTotal:"boolean",max:"boolean",min:"boolean",name:"string",subtotals:"boolean",unit:"string",with:"string"}},"grandTotal like 1.84":"boolean",grandTotalAtBottomOnly:"boolean",group:{"*":{additionally:["string"]}},groupLevels:["string"],search:"string",subtotalsAtBottomOnly:"boolean"},r=/,|%2C|%2c/,b=new RegExp("^("+a.sODataIdentifier+"(?:/"+a.sODataIdentifier+")*"+")(?:"+a.sWhitespace+"+(?:asc|desc))?$"),c;
function d(o,g,e,G,f,i,h){var D=o.aggregate[f],j=D.name||f,u=D.unit,w=D.with;if(G){if(w==="average"||w==="countdistinct"){throw new Error("Cannot aggregate totals with '"+w+"'");}j=f;f="UI5grand__"+f;}if(w){j+=" with "+w+" as "+f;}else if(D.name){j+=" as "+f;}e.push(j);if(u&&e.indexOf(u)<0&&h.indexOf(u,i+1)<0&&g.indexOf(u)<0){e.push(u);}}
function s(q){var t=[];if(q.$skip){t.push("skip("+q.$skip+")");}delete q.$skip;if(q.$top<Infinity){t.push("top("+q.$top+")");}delete q.$top;return t.join("/");}
c={buildApply:function(o,q,l,f,m){var e,g="",G=[],h=o["grandTotal like 1.84"],i,I,L,M=[],S,j=[];function p(n,k){var t,D=o.aggregate[n];if(D[k]){t="UI5"+k+"__"+n;M.push(n+" with "+k+" as "+t);if(m){m[t]={measure:n,method:k};}}}q=Object.assign({},q);c.checkTypeof(o,A,"$$aggregation");o.groupLevels=o.groupLevels||[];I=!l||l>o.groupLevels.length;o.group=o.group||{};o.groupLevels.forEach(function(k){o.group[k]=o.group[k]||{};});i=I?Object.keys(o.group).sort().filter(function(k){return o.groupLevels.indexOf(k)<0;}):[o.groupLevels[l-1]];if(!l){i=o.groupLevels.concat(i);}o.aggregate=o.aggregate||{};e=Object.keys(o.aggregate).sort();if(l===1&&!f){e.filter(function(k){return o.aggregate[k].grandTotal;}).forEach(d.bind(null,o,[],G,h));}if(!f){e.forEach(function(k){p(k,"min");p(k,"max");});}e.filter(function(k){return I||o.aggregate[k].subtotals;}).forEach(d.bind(null,o,i,j,false));if(j.length){g="aggregate("+j.join(",")+")";}if(i.length){i.forEach(function(k){var n=o.group[k].additionally;if(n){i.push.apply(i,n);}});g="groupby(("+i.join(",")+(g?"),"+g+")":"))");}if(f){delete q.$count;}else if(q.$count){M.push("$count as UI5__count");delete q.$count;}if(q.$filter){g+="/filter("+q.$filter+")";delete q.$filter;}if(q.$orderby){g+="/orderby("+q.$orderby+")";delete q.$orderby;}S=s(q);if(h&&G.length){if(o.groupLevels.length){throw new Error("Cannot combine visual grouping with grand total");}g+="/concat(aggregate("+G.join(",")+"),aggregate("+M.join(",")+"),"+(S||"identity")+")";}else{if(M.length){g+="/concat(aggregate("+M.join(",")+"),"+(S||"identity")+")";}else if(S){g+="/"+S;}if(l===1&&q.$$leaves&&!f){L="groupby(("+Object.keys(o.group).sort().join(",")+"))/aggregate($count as UI5__leaves)";}delete q.$$leaves;if(G.length){g="concat("+(L?L+",":"")+"aggregate("+G.join(",")+"),"+g+")";}else if(L){g="concat("+L+","+g+")";}}if(o.search){g="search("+o.search+")/"+g;}if(q.$$filterBeforeAggregate){g="filter("+q.$$filterBeforeAggregate+")/"+g;delete q.$$filterBeforeAggregate;}if(g){q.$apply=g;}return q;},checkTypeof:function(v,t,p){if(Array.isArray(t)){if(!Array.isArray(v)){throw new Error("Not an array value for '"+p+"'");}v.forEach(function(e,i){c.checkTypeof(e,t[0],p+"/"+i);});}else if(typeof t==="object"){var I="*"in t;if(typeof v!=="object"||!v||Array.isArray(v)){throw new Error("Not an object value for '"+p+"'");}Object.keys(v).forEach(function(k){if(!I&&!(k in t)){throw new Error("Unsupported property: '"+p+"/"+k+"'");}c.checkTypeof(v[k],t[I?"*":k],p+"/"+k);});}else if(typeof v!==t){throw new Error("Not a "+t+" value for '"+p+"'");}},createPlaceholder:function(l,i,p){var P={"@$ui5.node.level":l};_.setPrivateAnnotation(P,"index",i);_.setPrivateAnnotation(P,"parent",p);return P;},extractSubtotals:function(o,g,C,e){var l=g["@$ui5.node.level"];Object.keys(o.aggregate).forEach(function(f){var D=o.aggregate[f],i,u=D.unit;if(!D.subtotals){return;}C[f]=g[f];if(e){e[f]=null;}if(u){C[u]=g[u];if(e){i=o.groupLevels.indexOf(u);if(i<0||i>=l){e[u]=null;}}}});},filterOrderby:function(q,o,l){var f=c.getFilteredOrderby(q.$orderby,o,l);q=Object.assign({},q);if(f){q.$orderby=f;}else{delete q.$orderby;}return q;},getAllProperties:function(o){var e=Object.keys(o.aggregate),g=Object.keys(o.group),f=e.concat(g);e.forEach(function(h){var u=o.aggregate[h].unit;if(u){f.push(u);}});g.forEach(function(G){var h=o.group[G].additionally;if(h){h.forEach(function(i){f.push(i.includes("/")?i.split("/"):i);});}});return f;},getFilteredOrderby:function(o,e,l){var i=!l||l>e.groupLevels.length;function f(n){return Object.keys(e.aggregate).some(function(j){var D=e.aggregate[j];return D.subtotals&&n===D.unit;});}function g(n){if(n in e.group&&(!l||e.groupLevels.indexOf(n)<0)){return true;}return Object.keys(e.aggregate).some(function(j){return n===e.aggregate[j].unit;})||Object.keys(e.group).some(function(G){return(!l||e.groupLevels.indexOf(G)<0)&&h(n,G);});}function h(n,G){return n===G||e.group[G].additionally&&e.group[G].additionally.indexOf(n)>=0;}if(o){return o.split(r).filter(function(O){var m=b.exec(O),n;if(m){n=m[1];return n in e.aggregate&&(i||e.aggregate[n].subtotals)||i&&g(n)||!i&&(h(n,e.groupLevels[l-1])||f(n));}return true;}).join(",");}},getOrCreateExpandedObject:function(o,g){var C,e=_.getPrivateAnnotation(g,"expanded");if(!e){C={"@$ui5.node.isExpanded":false};_.setPrivateAnnotation(g,"collapsed",C);e={"@$ui5.node.isExpanded":true};_.setPrivateAnnotation(g,"expanded",e);if(o.subtotalsAtBottomOnly!==undefined){c.extractSubtotals(o,g,C,o.subtotalsAtBottomOnly?e:null);}}return e;},hasGrandTotal:function(m){return Object.keys(m).some(function(e){return m[e].grandTotal;});},hasMinOrMax:function(m){return Object.keys(m).some(function(e){var D=m[e];return D.min||D.max;});},isAffected:function(o,f,S){function e(g,p){if(g.endsWith("/*")){g=g.slice(0,-2);}return _.hasPathPrefix(p,g)||_.hasPathPrefix(g,p);}function h(g,i){return i.some(function(j){return j.aFilters?h(g,j.aFilters):e(g,j.sPath);});}return S.some(function(g){var i=e.bind(null,g);return g===""||g==="*"||Object.keys(o.aggregate).some(function(j){var D=o.aggregate[j];return e(g,D.name||j);})||Object.keys(o.group).some(i)||o.groupLevels.some(i)||h(g,f);});},removeUI5grand__:function(g){Object.keys(g).forEach(function(k){if(k.startsWith("UI5grand__")){g[k.slice(10)]=g[k];delete g[k];}});},setAnnotations:function(e,i,I,l,f){e["@$ui5.node.isExpanded"]=i;e["@$ui5.node.isTotal"]=I;e["@$ui5.node.level"]=l;if(f){f.forEach(function(p){if(Array.isArray(p)){_.createMissing(e,p);}else if(!(p in e)){e[p]=null;}});}},splitFilter:function(f,o){var e=[],g=[];function i(f){return f.aFilters?f.aFilters.some(i):f.sPath in o.aggregate;}function h(f){if(f.aFilters&&f.bAnd){f.aFilters.forEach(h);}else{(i(f)?e:g).push(f);}}function w(j){return j.length>1?new F(j,true):j[0];}if(!o||!o.aggregate){return[f];}h(f);return[w(e),w(g)];}};return c;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_Batch',["./_Helper","sap/base/strings/escapeRegExp"],function(_,e){"use strict";var a={POST:true,PUT:true,PATCH:true,DELETE:true},r=/^\$\d+/,b=/(\S*?)=(?:"(.+)"|(\S+))/;
function g(C){var B=c(C,"boundary"),m=C.trim().indexOf("multipart/mixed");if(m!==0||!B){throw new Error('Invalid $batch response header "Content-Type": '+C);}B=e(B);return new RegExp("--"+B+"(?:[ \t]*\r\n|--)");}
function c(H,p){var P,i=H.split(";"),m;p=p.toLowerCase();for(P=1;P<i.length;P+=1){m=b.exec(i[P]);if(m[1].toLowerCase()===p){return m[2]||m[3];}}}
function d(m){var C=h(m,"content-type");return C.startsWith("multipart/mixed;")?C:undefined;}
function f(m){var C=h(m,"content-id"),R;if(!C){throw new Error("Content-ID MIME header missing for the change set response.");}R=parseInt(C);if(isNaN(R)){throw new Error("Invalid Content-ID value in change set response.");}return R;}
function h(H,l){var m,n=H.split("\r\n"),i;for(i=0;i<n.length;i+=1){m=n[i].split(":");if(m[0].toLowerCase().trim()===l){return m[1].trim();}}}
function j(C,R,I){var B=R.split(g(C)),l=[];B=B.slice(1,-1);B.forEach(function(m){var n,o,p,H,q,t,u,v,w,x,M,y,z={},A,i;y=m.indexOf("\r\n\r\n");M=m.slice(0,y);w=m.indexOf("\r\n\r\n",y+4);v=m.slice(y+4,w);n=d(M);if(n){l.push(j(n,m.slice(y+4),true));return;}u=v.split("\r\n");x=u[0].split(" ");z.status=parseInt(x[1]);z.statusText=x.slice(2).join(" ");z.headers={};for(i=1;i<u.length;i+=1){H=u[i];p=H.indexOf(":");q=H.slice(0,p).trim();t=H.slice(p+1).trim();z.headers[q]=t;if(q.toLowerCase()==="content-type"){o=c(t,"charset");if(o&&o.toLowerCase()!=="utf-8"){throw new Error('Unsupported "Content-Type" charset: '+o);}}}z.responseText=m.slice(w+4,-2);if(I){A=f(M);l[A]=z;}else{l.push(z);}});return l;}
function s(H){var i,l=[];for(i in H){l.push(i,":",H[i],"\r\n");}return l;}
function k(R,C,E){var B=(C!==undefined?"changeset_":"batch_")+_.uid(),i=C!==undefined,l=[];if(i){l.push("Content-Type: multipart/mixed;boundary=",B,"\r\n\r\n");}R.forEach(function(o,m){var n="",u=o.url;if(i){o.$ContentID=m+"."+C;n="Content-ID:"+o.$ContentID+"\r\n";}l.push("--",B,"\r\n");if(Array.isArray(o)){if(i){throw new Error("Change set must not contain a nested change set.");}l=l.concat(k(o,m).body);}else{if(i&&!a[o.method]){throw new Error("Invalid HTTP request method: "+o.method+". Change set must contain only POST, PUT, PATCH, or DELETE requests.");}if(C!==undefined&&u[0]==="$"){u=u.replace(r,"$&."+C);}l=l.concat("Content-Type:application/http\r\n","Content-Transfer-Encoding:binary\r\n",n,"\r\n",o.method," ",u," HTTP/1.1\r\n",s(_.resolveIfMatchHeader(o.headers)),"\r\n",JSON.stringify(o.body)||"","\r\n");}});l.push("--",B,"--\r\n",E);return{body:l,batchBoundary:B};}
return{deserializeBatchResponse:function(C,R){return j(C,R,false);},serializeBatchRequest:function(R,E){var B=k(R,undefined,E);return{body:B.body.join(""),headers:{"Content-Type":"multipart/mixed; boundary="+B.batchBoundary,"MIME-Version":"1.0"}};}};},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_Cache',["./_GroupLock","./_Helper","./_Requestor","sap/base/Log","sap/base/util/isEmptyObject","sap/ui/base/SyncPromise","sap/ui/model/odata/ODataUtils"],function(_,a,b,L,c,S,O){"use strict";var C="sap.ui.model.odata.v4.lib._Cache",r=/\(\$uid=[-\w]+\)$/,d=/^\$inactive\./,m="@com.sap.vocabularies.Common.v1.Messages",e=/^-?\d+$/,f=/^([^(]*)(\(.*\))$/;
function g(i,p,n,D){if(n.$count!==undefined){s(i,p,n,n.$count+D);}}
function h(R,p){return p===""||R===p||R.startsWith(p+"/");}
function s(i,p,n,v){if(typeof v==="string"){v=parseInt(v);}a.updateExisting(i,p,n,{$count:v});}
function j(R,i,q,n,G,p){this.iActiveUsages=1;this.mChangeListeners={};this.fnGetOriginalResourcePath=G;this.iInactiveSince=Infinity;this.mPatchRequests={};this.oPendingRequestsPromise=null;this.mPostRequests={};this.sReportedMessagesPath=undefined;this.oRequestor=R;this.bSentRequest=false;this.bSortExpandSelect=n;this.setResourcePath(i);this.setQueryOptions(q);this.bSharedRequest=p;}
j.prototype._delete=function(G,E,p,i,D,n){var q=p.split("/"),v=q.pop(),I=e.test(v)?Number(v):undefined,P=q.join("/"),t=this;this.checkSharedRequest();this.addPendingRequest();return this.fetchValue(_.$cached,P).then(function(u){var w=j.from$skip(v,u),x=v?u[w]||u.$byPredicate[w]:u,H,K=a.getPrivateAnnotation(x,"predicate"),y=a.buildPath(P,Array.isArray(u)?K:v),T=a.getPrivateAnnotation(x,"transient");if(T===true){throw new Error("No 'delete' allowed while waiting for server response");}if(T){t.oRequestor.removePost(T,x);return undefined;}if(x["$ui5.deleting"]){throw new Error("Must not delete twice: "+E);}x["$ui5.deleting"]=true;H={"If-Match":i||x};E+=t.oRequestor.buildQueryString(t.sMetaPath,t.mQueryOptions,true);return S.all([G&&t.oRequestor.request("DELETE",E,G.getUnlockedCopy(),H,undefined,undefined,undefined,undefined,a.buildPath(t.getOriginalResourcePath(x),y)).catch(function(z){if(z.status!==404){delete x["$ui5.deleting"];throw z;}}),I===undefined&&!D&&t.requestCount(G),G&&G.unlock()]).then(function(){if(Array.isArray(u)){n(t.removeElement(u,I,K,P),u);}else{if(v){a.updateExisting(t.mChangeListeners,P,u,j.makeUpdateData([v],null));}else{x["$ui5.deleted"]=true;}n();}t.oRequestor.getModelInterface().reportStateMessages(t.sResourcePath,{},[y]);});}).finally(function(){t.removePendingRequest();});};
j.prototype.addPendingRequest=function(){var R;if(!this.oPendingRequestsPromise){this.oPendingRequestsPromise=new S(function(i){R=i;});this.oPendingRequestsPromise.$count=0;this.oPendingRequestsPromise.$resolve=R;}this.oPendingRequestsPromise.$count+=1;};
j.prototype.calculateKeyPredicate=function(i,t,M){var p,T=t[M];if(T&&T.$Key){p=a.getKeyPredicate(i,M,t);if(p){a.setPrivateAnnotation(i,"predicate",p);}}return p;};
j.prototype.checkSharedRequest=function(){if(this.bSharedRequest){throw new Error(this+" is read-only");}};
j.prototype.create=function(G,p,P,t,E,i,n){var q=this.getValue(P),u=G.getGroupId(),K=E&&E["@$ui5.keepTransientPath"],v,w=this;function x(){a.removeByPath(w.mPostRequests,P,E);q.splice(q.indexOf(E),1);q.$created-=1;if(!E["@$ui5.context.isInactive"]){w.iActiveElements-=1;g(w.mChangeListeners,P,q,-1);}delete q.$byPredicate[t];if(!P){w.adjustReadRequests(0,-1);}G.cancel();}function y(){w.addPendingRequest();a.setPrivateAnnotation(E,"transient",true);n();}function z(A,B){a.setPrivateAnnotation(E,"transient",u);a.addByPath(w.mPostRequests,P,E);return S.all([w.oRequestor.request("POST",A,B,null,v,y,x,undefined,a.buildPath(w.sResourcePath,P,t)),w.fetchTypes()]).then(function(R){var D=R[0],F,H;a.deletePrivateAnnotation(E,"postBody");a.deletePrivateAnnotation(E,"transient");E["@$ui5.context.isTransient"]=false;a.removeByPath(w.mPostRequests,P,E);w.visitResponse(D,R[1],a.getMetaPath(a.buildPath(w.sMetaPath,P)),P+t,K);F=a.getPrivateAnnotation(D,"predicate");if(F){a.setPrivateAnnotation(E,"predicate",F);if(K){F=t;}else{q.$byPredicate[F]=E;a.updateTransientPaths(w.mChangeListeners,t,F);}}H=a.getQueryOptionsForPath(w.mQueryOptions,P).$select;a.updateSelected(w.mChangeListeners,a.buildPath(P,F||t),E,D,H&&H.concat("@odata.etag"));w.removePendingRequest();return E;},function(D){if(D.canceled){throw D;}w.removePendingRequest();i(D);if(w.fetchTypes().isRejected()){throw D;}u=u.replace(d,"");u=w.oRequestor.getGroupSubmitMode(u)==="API"?u:"$parked."+u;return z(A,w.oRequestor.lockGroup(u,w,true,true));});}this.checkSharedRequest();if(!Array.isArray(q)){throw new Error("Create is only supported for collections; '"+P+"' does not reference a collection");}E=a.publicClone(E,true)||{};v=a.merge({},E);a.setPrivateAnnotation(E,"postBody",v);a.setPrivateAnnotation(E,"transientPredicate",t);E["@$ui5.context.isTransient"]=true;if(u.startsWith("$inactive.")){E["@$ui5.context.isInactive"]=true;}else{this.iActiveElements+=1;g(this.mChangeListeners,P,q,1);}q.unshift(E);q.$created+=1;q.$byPredicate=q.$byPredicate||{};q.$byPredicate[t]=E;if(!P){w.adjustReadRequests(0,1);}return p.then(function(A){A+=w.oRequestor.buildQueryString(w.sMetaPath,w.mQueryOptions,true);return z(A,G);});};
j.prototype.deregisterChange=function(p,i){if(!this.bSharedRequest){a.removeByPath(this.mChangeListeners,p,i);}};
j.prototype.drillDown=function(D,p,G,n){var q=S.resolve(D),E,t,u,T=false,v=this;function w(i,A){L[A?"info":"error"]("Failed to drill-down into "+p+", invalid segment: "+i,v.toString(),C);return undefined;}function x(V,i,P){var y=u.slice(0,P).join("/"),R,z;if(Array.isArray(V)){return w(i,i==="0");}return v.oRequestor.getModelInterface().fetchMetadata(v.sMetaPath+"/"+a.getMetaPath(y)).then(function(A){var B;if(!A){return w(i);}if(A.$Type==="Edm.Stream"){R=V[i+"@odata.mediaReadLink"]||V[i+"@mediaReadLink"];z=v.oRequestor.getServiceUrl();return R||a.buildPath(z+v.sResourcePath,y);}if(!T){B=V[a.getAnnotationKey(V,".Permissions",i)];if(B===0||B==="None"){return undefined;}if(!E&&!Array.isArray(D)){E=D;t=0;}return E&&v.fetchLateProperty(G,E,u.slice(0,t).join("/"),u.slice(t).join("/"),u.slice(t,P).join("/"))||w(i);}if(A.$kind==="NavigationProperty"){return null;}if(!A.$Type.startsWith("Edm.")){return{};}if("$DefaultValue"in A){return A.$Type==="Edm.String"?A.$DefaultValue:a.parseLiteral(A.$DefaultValue,A.$Type,y);}return null;});}if(!p){return q;}u=p.split("/");return u.reduce(function(P,y,i){return P.then(function(V){var I,M,z;if(y==="$count"){return Array.isArray(V)?V.$count:w(y);}if(V===undefined||V===null){return undefined;}if(typeof V!=="object"||y==="@$ui5._"||Array.isArray(V)&&(y[0]==="$"||y==="length")){return w(y);}if(a.hasPrivateAnnotation(V,"predicate")){E=V;t=i;}z=V;T=T||V["@$ui5.context.isTransient"];M=f.exec(y);if(M){if(M[1]){V=V[M[1]];}if(V){V=V.$byPredicate&&V.$byPredicate[M[2]];}}else{I=j.from$skip(y,V);if(n&&I===y&&(V[y]===undefined||V[y]===null)){V[y]={};}V=V[I];}return V===undefined&&y[0]!=="#"&&!y.includes("@")?x(z,y,i+1):V;});},q);};
j.prototype.fetchLateProperty=function(G,R,i,n,M){var F,p,q,P,Q,t,u=a.getMetaPath(i),T=this.fetchTypes().getResult(),U=[n],v=this;function w(x,B){var y=a.buildPath(F,B),E=T[y],z;if(!E){E=v.fetchType(T,y).getResult();}if(B){(E.$Key||[]).forEach(function(K){if(typeof K==="object"){K=K[Object.keys(K)[0]];}U.push(a.buildPath(B,K));});U.push(B+"/@odata.etag");U.push(B+"/@$ui5._/predicate");}if(x.$expand){z=Object.keys(x.$expand)[0];w(x.$expand[z],a.buildPath(B,z));}}if(!this.mLateQueryOptions){return undefined;}F=a.buildPath(this.sMetaPath,u);Q=a.intersectQueryOptions(a.getQueryOptionsForPath(this.mLateQueryOptions,i),[n],this.oRequestor.getModelInterface().fetchMetadata,F,{});if(!Q){return undefined;}w(Q);p=a.buildPath(this.sResourcePath,i);t=p+this.oRequestor.buildQueryString(F,Q,false,true);P=this.mPropertyRequestByPath[t];if(!P){q=p+this.oRequestor.buildQueryString(F,this.mQueryOptions,true);P=this.oRequestor.request("GET",q,G.getUnlockedCopy(),undefined,undefined,undefined,undefined,F,undefined,false,Q).then(function(D){v.visitResponse(D,T,F,i);return D;});this.mPropertyRequestByPath[t]=P;}return P.then(function(D){var x=a.getPrivateAnnotation(D,"predicate");if(x&&a.getPrivateAnnotation(R,"predicate")!==x){throw new Error("GET "+t+": Key predicate changed from "+a.getPrivateAnnotation(R,"predicate")+" to "+x);}if(D["@odata.etag"]!==R["@odata.etag"]){throw new Error("GET "+t+": ETag changed");}a.updateSelected(v.mChangeListeners,i,R,D,U);return a.drillDown(R,M.split("/"));}).finally(function(){delete v.mPropertyRequestByPath[t];});};
j.prototype.fetchType=function(t,M){var i=this;return this.oRequestor.fetchTypeForPath(M).then(function(T){var n,p=[];if(T){n=i.oRequestor.getModelInterface().fetchMetadata(M+"/"+m).getResult();if(n){T=Object.create(T);T[m]=n;}t[M]=T;(T.$Key||[]).forEach(function(K){if(typeof K==="object"){K=K[Object.keys(K)[0]];p.push(i.fetchType(t,M+"/"+K.slice(0,K.lastIndexOf("/"))));}});return S.all(p).then(function(){return T;});}});};
j.prototype.fetchTypes=function(){var p,t,i=this;function n(B,q){if(q&&q.$expand){Object.keys(q.$expand).forEach(function(N){var M=B;N.split("/").forEach(function(u){M+="/"+u;p.push(i.fetchType(t,M));});n(M,q.$expand[N]);});}}if(!this.oTypePromise){p=[];t={};p.push(this.fetchType(t,this.sMetaPath));n(this.sMetaPath,this.mQueryOptions);this.oTypePromise=S.all(p).then(function(){return t;});}return this.oTypePromise;};
j.prototype.getDownloadQueryOptions=function(q){return q;};
j.prototype.getDownloadUrl=function(p,i){var q=this.mQueryOptions;if(p){q=a.getQueryOptionsForPath(q,p);q=a.merge({},i,q);}return this.oRequestor.getServiceUrl()+a.buildPath(this.sResourcePath,p)+this.oRequestor.buildQueryString(a.buildPath(this.sMetaPath,a.getMetaPath(p)),this.getDownloadQueryOptions(q));};
j.prototype.getLateQueryOptions=function(){return this.mLateQueryOptions;};
j.prototype.getQueryOptions=function(){return this.mQueryOptions;};
j.prototype.getValue=function(i){throw new Error("Unsupported operation");};
j.prototype.getOriginalResourcePath=function(E){return this.fnGetOriginalResourcePath&&this.fnGetOriginalResourcePath(E)||this.sResourcePath;};
j.prototype.getResourcePath=function(){return this.sResourcePath;};
j.prototype.hasChangeListeners=function(){return!c(this.mChangeListeners);};
j.prototype.hasPendingChangesForPath=function(p,i,I){var t=this;return Object.keys(this.mPatchRequests).some(function(R){return h(R,p)&&!(i&&t.mPatchRequests[R].every(function(P){return P.$isKeepAlive();}));})||!I&&Object.keys(this.mPostRequests).some(function(R){return h(R,p)&&t.mPostRequests[R].some(function(E){return!E["@$ui5.context.isInactive"];});});};
j.prototype.hasSentRequest=function(){return this.bSentRequest;};
j.prototype.patch=function(p,D){var t=this;this.checkSharedRequest();return this.fetchValue(_.$cached,p).then(function(i){a.updateExisting(t.mChangeListeners,p,i,D);return i;});};
j.prototype.refreshSingle=function(G,p,i,P,K,D){var t=this;this.checkSharedRequest();return this.fetchValue(_.$cached,p).then(function(E){var q=Object.assign({},a.getQueryOptionsForPath(t.mQueryOptions,p)),R;if(i!==undefined){P=a.getPrivateAnnotation(E[i],"predicate");}R=a.buildPath(t.sResourcePath,p,P);if(K&&t.mLateQueryOptions){a.aggregateExpandSelect(q,t.mLateQueryOptions);}delete q.$apply;delete q.$count;delete q.$filter;delete q.$orderby;delete q.$search;R+=t.oRequestor.buildQueryString(t.sMetaPath,q,false,t.bSortExpandSelect);t.bSentRequest=true;return S.all([t.oRequestor.request("GET",R,G,undefined,undefined,D),t.fetchTypes()]).then(function(n){var u=n[0];t.replaceElement(E,i,P,u,n[1],p);});});};
j.prototype.refreshSingleWithRemove=function(G,p,i,P,K,D,n){var t=this;this.checkSharedRequest();return S.all([this.fetchValue(_.$cached,p),this.fetchTypes()]).then(function(R){var E=R[0],q,I,u={},v,w,Q=Object.assign({},a.getQueryOptionsForPath(t.mQueryOptions,p)),x,y=a.buildPath(t.sResourcePath,p),z=[],T=R[1];if(i!==undefined){q=E[i];P=a.getPrivateAnnotation(q,"predicate");}else{q=E.$byPredicate[P];}w=a.getKeyFilter(q,t.sMetaPath,T);I=(Q.$filter?"("+Q.$filter+") and ":"")+w;delete Q.$count;delete Q.$orderby;t.bSentRequest=true;if(K){if(t.mLateQueryOptions){a.aggregateExpandSelect(Q,t.mLateQueryOptions);}u=Object.assign({},Q);u.$filter=I;Q.$filter=w;delete Q.$search;x=y+t.oRequestor.buildQueryString(t.sMetaPath,Q,false,t.bSortExpandSelect);z.push(t.oRequestor.request("GET",x,G,undefined,undefined,D));if(i!==undefined&&(w!==I||u.$search)){delete u.$select;delete u.$expand;u.$count=true;u.$top=0;v=y+t.oRequestor.buildQueryString(t.sMetaPath,u);z.push(t.oRequestor.request("GET",v,G.getUnlockedCopy()));}}else{Q.$filter=I;x=y+t.oRequestor.buildQueryString(t.sMetaPath,Q,false,t.bSortExpandSelect);z.push(t.oRequestor.request("GET",x,G,undefined,undefined,D));}return S.all(z).then(function(R){var A=R[0].value,B=R[1]&&R[1]["@odata.count"]==="0";if(A.length>1){throw new Error("Unexpected server response, more than one entity returned.");}else if(A.length===0){t.removeElement(E,i,P,p);t.oRequestor.getModelInterface().reportStateMessages(t.sResourcePath,{},[p+P]);n(false);}else if(B){t.removeElement(E,i,P,p);t.replaceElement(E,undefined,P,A[0],T,p);n(true);}else{t.replaceElement(E,i,P,A[0],T,p);}});});};
j.prototype.registerChange=function(p,i){if(!this.bSharedRequest){a.addByPath(this.mChangeListeners,p,i);}};
j.prototype.removeElement=function(E,i,p,P){var n,t;n=E.$byPredicate[p];if(i!==undefined){i=j.getElementIndex(E,p,i);E.splice(i,1);g(this.mChangeListeners,P,E,-1);}delete E.$byPredicate[p];t=a.getPrivateAnnotation(n,"transientPredicate");if(t){E.$created-=1;if(!P){this.iActiveElements-=1;}delete E.$byPredicate[t];}else if(!P){if(i!==undefined){this.iLimit-=1;this.adjustReadRequests(i,-1);}}return i;};
j.prototype.removeMessages=function(){if(this.sReportedMessagesPath){this.oRequestor.getModelInterface().reportStateMessages(this.sReportedMessagesPath,{});this.sReportedMessagesPath=undefined;}};
j.prototype.removePendingRequest=function(){if(this.oPendingRequestsPromise){this.oPendingRequestsPromise.$count-=1;if(!this.oPendingRequestsPromise.$count){this.oPendingRequestsPromise.$resolve();this.oPendingRequestsPromise=null;}}};
j.prototype.replaceElement=function(E,i,p,n,t,P){var q,T;if(i===undefined){E.$byPredicate[p]=n;}else{i=j.getElementIndex(E,p,i);q=E[i];E[i]=E.$byPredicate[p]=n;T=a.getPrivateAnnotation(q,"transientPredicate");if(T){n["@$ui5.context.isTransient"]=false;E.$byPredicate[T]=n;a.setPrivateAnnotation(n,"transientPredicate",T);}}this.visitResponse(n,t,a.getMetaPath(a.buildPath(this.sMetaPath,P)),P+p);};
j.prototype.requestCount=function(G){var E,q,R,t=this;if(this.mQueryOptions&&this.mQueryOptions.$count){q=Object.assign({},this.mQueryOptions);delete q.$expand;delete q.$orderby;delete q.$select;E=this.getFilterExcludingCreated();if(E){q.$filter=q.$filter?"("+q.$filter+") and "+E:E;}q.$top=0;R=this.sResourcePath+this.oRequestor.buildQueryString(this.sMetaPath,q);return this.oRequestor.request("GET",R,G.getUnlockedCopy()).catch(function(i){if(i.cause&&i.cause.status===404){return t.oRequestor.request("GET",R,G.getUnlockedCopy());}throw i;}).then(function(i){var n=parseInt(i["@odata.count"])+t.iActiveElements;s(t.mChangeListeners,"",t.aElements,n);t.iLimit=n;});}};
j.prototype.resetChangesForPath=function(p){var t=this;Object.keys(this.mPatchRequests).forEach(function(R){var P,i;if(h(R,p)){P=t.mPatchRequests[R];for(i=P.length-1;i>=0;i-=1){t.oRequestor.removePatch(P[i]);}delete t.mPatchRequests[R];}});Object.keys(this.mPostRequests).forEach(function(R){var E,T,i;if(h(R,p)){E=t.mPostRequests[R];for(i=E.length-1;i>=0;i-=1){T=a.getPrivateAnnotation(E[i],"transient");if(!T.startsWith("$inactive.")){t.oRequestor.removePost(T,E[i]);}}}});};
j.prototype.setActive=function(A){if(A){this.iActiveUsages+=1;this.iInactiveSince=Infinity;}else{this.iActiveUsages-=1;if(!this.iActiveUsages){this.iInactiveSince=Date.now();}this.mChangeListeners={};}};
j.prototype.setLateQueryOptions=function(q){if(q){this.mLateQueryOptions={$select:q.$select,$expand:q.$expand};}else{this.mLateQueryOptions=null;}};
j.prototype.setProperty=function(p,v,E){var t=this;this.checkSharedRequest();return this.fetchValue(_.$cached,E,null,null,true).then(function(i){a.updateAll(t.mChangeListeners,E,i,j.makeUpdateData(p.split("/"),v));});};
j.prototype.setQueryOptions=function(q,F){this.checkSharedRequest();if(this.bSentRequest&&!F){throw new Error("Cannot set query options: Cache has already sent a request");}this.mQueryOptions=q;this.sQueryString=this.oRequestor.buildQueryString(this.sMetaPath,q,false,this.bSortExpandSelect);};
j.prototype.setResourcePath=function(R){this.checkSharedRequest();this.sResourcePath=R;this.sMetaPath=a.getMetaPath("/"+R);this.oTypePromise=undefined;this.mLateQueryOptions=null;this.mPropertyRequestByPath={};};
j.prototype.toString=function(){return this.oRequestor.getServiceUrl()+this.sResourcePath+this.sQueryString;};
j.prototype.update=function(G,p,v,E,i,n,u,P,q,I){var t,w=p.split("/"),U,x=this;this.checkSharedRequest();try{t=this.fetchValue(_.$cached,n);}catch(y){if(!y.$cached||this.oPromise!==null){throw y;}t=this.oPromise=S.resolve({"@odata.etag":"*"});}return t.then(function(z){var F=a.buildPath(n,p),A=G.getGroupId(),B,D,H,J,T,K,M=j.makeUpdateData(w,v);function N(){a.removeByPath(x.mPatchRequests,F,D);a.updateExisting(x.mChangeListeners,n,z,j.makeUpdateData(w,B));}function Q(R,V){var W={"If-Match":z},X;function Y(){X=x.oRequestor.lockGroup(A,x,true);q();}if(P){W.Prefer="return=minimal";}D=x.oRequestor.request("PATCH",i,R,W,M,Y,N,undefined,a.buildPath(x.getOriginalResourcePath(z),n),V);D.$isKeepAlive=I;a.addByPath(x.mPatchRequests,F,D);return S.all([D,x.fetchTypes()]).then(function(Z){var $=Z[0];a.removeByPath(x.mPatchRequests,F,D);if(!P){x.visitResponse($,Z[1],a.getMetaPath(a.buildPath(x.sMetaPath,n)),n);}a.updateExisting(x.mChangeListeners,n,z,P?{"@odata.etag":$["@odata.etag"]}:$);},function(y){var Z=A;if(!E){N();throw y;}a.removeByPath(x.mPatchRequests,F,D);if(y.canceled){throw y;}E(y);switch(x.oRequestor.getGroupSubmitMode(A)){case"API":break;case"Auto":if(!x.oRequestor.hasChanges(A,z)){Z="$parked."+A;}break;default:throw y;}X.unlock();X=undefined;return Q(x.oRequestor.lockGroup(Z,x,true,true),true);}).finally(function(){if(X){X.unlock();}});}if(!z){throw new Error("Cannot update '"+p+"': '"+n+"' does not exist");}T=a.getPrivateAnnotation(z,"transient");if(T){if(T===true){throw new Error("No 'update' allowed while waiting for server response");}if(T.startsWith("$parked.")||T.startsWith("$inactive.")){J=T;T=T.slice(T.indexOf(".")+1);}if(T!==A){throw new Error("The entity will be created via group '"+T+"'. Cannot patch via group '"+A+"'");}}B=a.drillDown(z,w);H=a.getPrivateAnnotation(z,"postBody");if(H){a.updateAll({},n,H,M);if(z["@$ui5.context.isInactive"]){M["@$ui5.context.isInactive"]=false;x.iActiveElements+=1;g(x.mChangeListeners,"",x.aElements,1);}}a.updateAll(x.mChangeListeners,n,z,M);if(u){U=u.split("/");u=a.buildPath(n,u);K=x.getValue(u);if(K===undefined){L.debug("Missing value for unit of measure "+u+" when updating "+F,x.toString(),C);}else{a.merge(T?H:M,j.makeUpdateData(U,K));}}if(T){if(J){a.setPrivateAnnotation(z,"transient",T);x.oRequestor.relocate(J,H,T);}G.unlock();return Promise.resolve();}x.oRequestor.relocateAll("$parked."+A,A,z);i+=x.oRequestor.buildQueryString(x.sMetaPath,x.mQueryOptions,true);return Q(G);});};
j.prototype.visitResponse=function(R,t,n,p,K,q){var u,H=false,P={},v=this.oRequestor.getServiceUrl()+this.sResourcePath,w=this;function x(M,i,B){H=true;if(M&&M.length){P[i]=M;M.forEach(function(D){if(D.longtextUrl){D.longtextUrl=a.makeAbsolute(D.longtextUrl,B);}});}}function y(B,i){return i?a.makeAbsolute(i,B):B;}function z(I,M,B,D){var E={},F,G,J,i;for(i=0;i<I.length;i+=1){G=I[i];F=B===""?q+i:i;if(G&&typeof G==="object"){A(G,M,B,D,F);J=a.getPrivateAnnotation(G,"predicate");if(!B){u.push(J||F.toString());}if(J){E[J]=G;I.$byPredicate=E;}}}}function A(i,M,I,B,D){var E,F,T=t[M],G=T&&T[m]&&T[m].$Path,J;B=y(B,i["@odata.context"]);F=w.calculateKeyPredicate(i,t,M);if(D!==undefined){I=a.buildPath(I,F||D);}else if(!K&&F){E=r.exec(I);if(E){I=I.slice(0,-E[0].length)+F;}}if(p&&!u){u=[I];}if(G){J=a.drillDown(i,G.split("/"));if(J!==undefined){x(J,I,B);}}Object.keys(i).forEach(function(N){var Q,U=M+"/"+N,V=i[N],W=a.buildPath(I,N);if(N.endsWith("@odata.mediaReadLink")||N.endsWith("@mediaReadLink")){i[N]=a.makeAbsolute(V,B);}if(N.includes("@")){return;}if(Array.isArray(V)){V.$created=0;V.$count=undefined;Q=i[N+"@odata.count"];if(Q){s({},"",V,Q);}else if(!i[N+"@odata.nextLink"]){s({},"",V,V.length);}z(V,U,W,y(B,i[N+"@odata.context"]));}else if(V&&typeof V==="object"){A(V,U,W,B);}});}if(q!==undefined){u=[];z(R.value,n||this.sMetaPath,"",y(v,R["@odata.context"]));}else if(R&&typeof R==="object"){A(R,n||this.sMetaPath,p||"",v);}if(H){this.sReportedMessagesPath=this.getOriginalResourcePath(R);this.oRequestor.getModelInterface().reportStateMessages(this.sReportedMessagesPath,P,u);}};
function k(R,i,q,n,D,p){j.call(this,R,i,q,n,function(){return D;},p);this.iActiveElements=0;this.sContext=undefined;this.aElements=[];this.aElements.$byPredicate={};this.aElements.$count=undefined;this.aElements.$created=0;this.aElements.$tail=undefined;this.iLimit=Infinity;this.aReadRequests=[];this.bServerDrivenPaging=false;this.oSyncPromiseAll=undefined;}
k.prototype=Object.create(j.prototype);
k.prototype.addKeptElement=function(E){this.aElements.$byPredicate[a.getPrivateAnnotation(E,"predicate")]=E;};
k.prototype.adjustReadRequests=function(i,n){this.aReadRequests.forEach(function(R){if(R.iStart>=i){R.iStart+=n;R.iEnd+=n;}});};
k.prototype.doReplaceWith=function(i,E){this.aElements[i]=E;this.addKeptElement(E);};
k.prototype.fetchValue=function(G,p,i,n,q){var E,F=p.split("/")[0],t,u=this;G.unlock();if(this.aElements.$byPredicate[F]){t=S.resolve();}else if((G===_.$cached||F!=="$count")&&this.aElements[F]!==undefined){t=S.resolve(this.aElements[F]);}else{if(!this.oSyncPromiseAll){E=this.aElements.$tail?this.aElements.concat(this.aElements.$tail):this.aElements;this.oSyncPromiseAll=S.all(E);}t=this.oSyncPromiseAll;}return t.then(function(){u.registerChange(p,n);return u.drillDown(u.aElements,p,G,q);});};
k.prototype.fill=function(p,q,E){var i,n=Math.max(this.aElements.length,1024);if(E>n){if(this.aElements.$tail&&p){throw new Error("Cannot fill from "+q+" to "+E+", $tail already in use, # of elements is "+this.aElements.length);}this.aElements.$tail=p;E=this.aElements.length;}for(i=q;i<E;i+=1){this.aElements[i]=p;}this.oSyncPromiseAll=undefined;};
k.prototype.getFilterExcludingCreated=function(){var E,K,n=[],t,i;for(i=0;i<this.aElements.$created;i+=1){E=this.aElements[i];if(!E["@$ui5.context.isTransient"]){t=t||this.fetchTypes().getResult();K=a.getKeyFilter(E,this.sMetaPath,t);if(K){n.push(K);}}}return n.length?"not ("+n.join(" or ")+")":undefined;};
k.prototype.getQueryString=function(){var E=this.getFilterExcludingCreated(),q=Object.assign({},this.mQueryOptions),F=q.$filter,Q=this.sQueryString;if(E){if(F){q.$filter="("+F+") and "+E;Q=this.oRequestor.buildQueryString(this.sMetaPath,q,false,this.bSortExpandSelect);}else{Q+=(Q?"&":"?")+"$filter="+a.encode(E,false);}}return Q;};
k.prototype.getResourcePathWithQuery=function(i,E){var n=this.aElements.$created,q=this.getQueryString(),D=q?"&":"?",p=E-i,R=this.sResourcePath+q;if(i<n){throw new Error("Must not request created element");}i-=n;if(i>0||p<Infinity){R+=D+"$skip="+i;}if(p<Infinity){R+="&$top="+p;}return R;};
k.prototype.getValue=function(p){var i=this.drillDown(this.aElements,p,_.$cached);if(i.isFulfilled()){return i.getResult();}};
k.prototype.handleResponse=function(n,E,R,t){var p,q=this.aElements.$created,u,K,v=-1,w=this.aElements.$count,P,x=R.value.length,i;this.sContext=R["@odata.context"];this.visitResponse(R,t,undefined,undefined,undefined,n);for(i=0;i<x;i+=1){u=R.value[i];P=a.getPrivateAnnotation(u,"predicate");if(P){K=this.aElements.$byPredicate[P];if(K){if(u["@odata.etag"]===K["@odata.etag"]){a.updateNonExisting(K,u);u=K;}else if(this.hasPendingChangesForPath(P)){throw new Error("Modified on client and on server: "+this.sResourcePath+P);}}this.aElements.$byPredicate[P]=u;}this.aElements[n+i]=u;}p=R["@odata.count"];if(p){this.iLimit=v=parseInt(p);}if(R["@odata.nextLink"]){this.bServerDrivenPaging=true;if(E<this.aElements.length){for(i=n+x;i<E;i+=1){delete this.aElements[i];}}else{this.aElements.length=n+x;}}else if(x<E-n){if(v===-1){v=w&&w-this.iActiveElements;}v=Math.min(v!==undefined?v:Infinity,n-q+x);this.aElements.length=q+v;this.iLimit=v;if(!p&&v>0&&!this.aElements[v-1]){v=undefined;}}if(v!==-1){s(this.mChangeListeners,"",this.aElements,v!==undefined?v+this.iActiveElements:undefined);}};
k.prototype.read=function(i,n,p,G,D){var E,P=this.oPendingRequestsPromise||this.aElements.$tail,t=this;if(i<0){throw new Error("Illegal index "+i+", must be >= 0");}if(n<0){throw new Error("Illegal length "+n+", must be >= 0");}if(P){return P.then(function(){return t.read(i,n,p,G,D);});}O._getReadIntervals(this.aElements,i,n,this.bServerDrivenPaging?0:p,this.aElements.$created+this.iLimit).forEach(function(I){t.requestElements(I.start,I.end,G.getUnlockedCopy(),D);D=undefined;});G.unlock();E=this.aElements.slice(i,i+n+p);if(this.aElements.$tail&&i+n>this.aElements.length){E.push(this.aElements.$tail);}return S.all(E).then(function(){var q=t.aElements.slice(i,i+n);q.$count=t.aElements.$count;return{"@odata.context":t.sContext,value:q};});};
k.prototype.refreshKeptElements=function(G,i){var p=Object.keys(this.aElements.$byPredicate).sort(),t,n=this;function q(){var K,Q=a.merge({},n.mQueryOptions);if(n.mLateQueryOptions){a.aggregateExpandSelect(Q,n.mLateQueryOptions);}delete Q.$count;delete Q.$orderby;delete Q.$search;K=p.map(function(P){return a.getKeyFilter(n.aElements.$byPredicate[P],n.sMetaPath,t);});Q.$filter=K.join(" or ");if(K.length>1){Q.$top=K.length;}return n.sResourcePath+n.oRequestor.buildQueryString(n.sMetaPath,Q,false,true);}if(p.length===0){return undefined;}t=this.fetchTypes().getResult();return this.oRequestor.request("GET",q(),G).then(function(R){var u;n.visitResponse(R,t,undefined,undefined,undefined,0);u=R.value.$byPredicate||{};p.forEach(function(P){if(P in u){a.updateAll(n.mChangeListeners,P,n.aElements.$byPredicate[P],u[P]);}else{delete n.aElements.$byPredicate[P];i(P);}});});};
k.prototype.requestElements=function(i,E,G,D){var p,R={iEnd:E,iStart:i},t=this;this.aReadRequests.push(R);this.bSentRequest=true;p=S.all([this.oRequestor.request("GET",this.getResourcePathWithQuery(i,E),G,undefined,undefined,D),this.fetchTypes()]).then(function(n){if(t.aElements.$tail===p){t.aElements.$tail=undefined;}t.handleResponse(R.iStart,R.iEnd,n[0],n[1]);}).catch(function(n){t.fill(undefined,R.iStart,R.iEnd);throw n;}).finally(function(){t.aReadRequests.splice(t.aReadRequests.indexOf(R),1);});this.fill(p,i,E);};
k.prototype.requestSideEffects=function(G,p,N,P,q){var E,M=-1,t,Q,u={},R,v,T=this.fetchTypes().getResult(),w=this;this.checkSharedRequest();if(this.oPendingRequestsPromise){return this.oPendingRequestsPromise.then(function(){return w.requestSideEffects(G,p,N,P,q);});}Q=a.intersectQueryOptions(Object.assign({},this.mQueryOptions,this.mLateQueryOptions),p,this.oRequestor.getModelInterface().fetchMetadata,this.sMetaPath,N,"",true);if(!Q){return S.resolve();}if(q){E=[this.aElements.$byPredicate[P[0]]];}else{P.forEach(function(i){u[i]=true;});E=this.aElements.filter(function(n,i){var x;if(!n){return false;}if(a.hasPrivateAnnotation(n,"transient")){M=i;return false;}x=a.getPrivateAnnotation(n,"predicate");if(u[x]||a.hasPrivateAnnotation(n,"transientPredicate")){M=i;delete u[x];return true;}delete w.aElements[i];delete w.aElements.$byPredicate[x];return false;});this.aElements.length=M+1;if(!E.length){return S.resolve();}Object.keys(u).forEach(function(i){E.push(w.aElements.$byPredicate[i]);});}Q.$filter=E.map(function(i){return a.getKeyFilter(i,w.sMetaPath,T);}).join(" or ");if(E.length>1){Q.$top=E.length;}a.selectKeyProperties(Q,T[this.sMetaPath]);delete Q.$count;delete Q.$orderby;delete Q.$search;t=a.extractMergeableQueryOptions(Q);R=this.sResourcePath+this.oRequestor.buildQueryString(this.sMetaPath,Q,false,true);return this.oRequestor.request("GET",R,G,undefined,undefined,undefined,undefined,this.sMetaPath,undefined,false,t,this,function(i){if(arguments.length){p=p.concat(i);}else{v=true;return p;}}).then(function(x){var y,z,i,n;function A(B){B=B.slice(z.length+1);return!p.some(function(D){return a.getRelativePath(B,D)!==undefined;});}if(v){return;}if(x.value.length!==E.length){throw new Error("Expected "+E.length+" row(s), but instead saw "+x.value.length);}w.visitResponse(x,T,undefined,"",false,NaN);for(i=0,n=x.value.length;i<n;i+=1){y=x.value[i];z=a.getPrivateAnnotation(y,"predicate");a.updateAll(w.mChangeListeners,z,w.aElements.$byPredicate[z],y,A);}});};
k.prototype.reset=function(K){var B=this.aElements.$byPredicate,n=this.mChangeListeners,E,t=0,i,p=this;for(i=0;i<this.aElements.$created;i+=1){E=this.aElements[i];if(a.getPrivateAnnotation(E,"transient")){K.push(a.getPrivateAnnotation(E,"transientPredicate"));this.aElements[t]=E;t+=1;}else{this.iActiveElements-=1;}}this.mChangeListeners={};this.sContext=undefined;this.aElements.length=this.aElements.$created=t;this.aElements.$byPredicate={};this.aElements.$count=undefined;this.iLimit=Infinity;Object.keys(n).forEach(function(P){if(K.includes(P.split("/")[0])){p.mChangeListeners[P]=n[P];}});K.forEach(function(P){p.aElements.$byPredicate[P]=B[P];});};
function l(R,i,q){j.call(this,R,i,q);this.oPromise=null;}
l.prototype=Object.create(j.prototype);
l.prototype._delete=function(){throw new Error("Unsupported");};
l.prototype.create=function(){throw new Error("Unsupported");};
l.prototype.fetchValue=function(G,i,D,n,p){var t=this;if(p){throw new Error("Unsupported argument: bCreateOnDemand");}if(this.oPromise){G.unlock();}else{this.bSentRequest=true;this.oPromise=S.resolve(this.oRequestor.request("GET",this.sResourcePath+this.sQueryString,G,undefined,undefined,D,undefined,this.sMetaPath));}return this.oPromise.then(function(R){t.registerChange("",n);return R&&typeof R==="object"?R.value:R;});};
l.prototype.update=function(){throw new Error("Unsupported");};
function o(R,i,q,n,p,G,P,M){j.call(this,R,i,q,n,G,p);this.sMetaPath=M||this.sMetaPath;this.bPost=P;this.bPosting=false;this.oPromise=null;}
o.prototype=Object.create(j.prototype);
o.prototype.fetchValue=function(G,p,D,i,n){var R=this.sResourcePath+this.sQueryString,t=this;if(this.oPromise){G.unlock();}else{if(this.bPost){throw new Error("Cannot fetch a value before the POST request");}this.oPromise=S.all([this.oRequestor.request("GET",R,G,undefined,undefined,D,undefined,this.sMetaPath),this.fetchTypes()]).then(function(q){t.visitResponse(q[0],q[1]);return q[0];});this.bSentRequest=true;}return this.oPromise.then(function(q){if(q&&q["$ui5.deleted"]){throw new Error("Cannot read a deleted entity");}t.registerChange(p,i);return t.drillDown(q,p,G,n);});};
o.prototype.getValue=function(p){var i;if(this.oPromise&&this.oPromise.isFulfilled()){i=this.drillDown(this.oPromise.getResult(),p,_.$cached);if(i.isFulfilled()){return i.getResult();}}};
o.prototype.post=function(G,D,E,i,n){var p,H=E?{"If-Match":i&&"@odata.etag"in E?"*":E}:{},q="POST",t=this;function u(v){t.bPosting=true;return S.all([t.oRequestor.request(q,t.sResourcePath+t.sQueryString,v,H,D),t.fetchTypes()]).then(function(R){t.visitResponse(R[0],R[1]);t.bPosting=false;return R[0];},function(w){t.bPosting=false;if(n&&w.strictHandlingFailed){return n(w).then(function(x){var y;if(x){delete H["Prefer"];return u(v.getUnlockedCopy());}y=Error("Action canceled due to strict handling");y.canceled=true;throw y;});}throw w;});}this.checkSharedRequest();if(!this.bPost){throw new Error("POST request not allowed");}if(this.bPosting){throw new Error("Parallel POST requests not allowed");}if(E){p=G.getGroupId();this.oRequestor.relocateAll("$parked."+p,p,E);}if(D){q=D["X-HTTP-Method"]||q;delete D["X-HTTP-Method"];if(this.oRequestor.isActionBodyOptional()&&!Object.keys(D).length){D=undefined;}}this.bSentRequest=true;if(n){H["Prefer"]="handling=strict";}this.oPromise=u(G);return this.oPromise;};
o.prototype.requestSideEffects=function(G,p,n,R){var M,q,i,t,u=this;this.checkSharedRequest();q=this.oPromise&&a.intersectQueryOptions(Object.assign({},this.mQueryOptions,this.mLateQueryOptions),p,this.oRequestor.getModelInterface().fetchMetadata,this.sMetaPath,n);if(!q){return S.resolve();}M=a.extractMergeableQueryOptions(q);R=(R||this.sResourcePath)+this.oRequestor.buildQueryString(this.sMetaPath,q,false,true);i=S.all([this.oRequestor.request("GET",R,G,undefined,undefined,undefined,undefined,this.sMetaPath,undefined,false,M,this,function(v){if(arguments.length){p=p.concat(v);}else{t=true;return p;}}),this.fetchTypes(),this.fetchValue(_.$cached,"")]).then(function(v){return v;}).then(function(v){var N=v[0],w=v[2];if(t){return;}a.setPrivateAnnotation(N,"predicate",a.getPrivateAnnotation(w,"predicate"));u.visitResponse(N,v[1]);a.updateAll(u.mChangeListeners,"",w,N,function(P){return!p.some(function(x){return a.getRelativePath(P,x)!==undefined;});});});return i;};
j.create=function(R,i,q,n,D,p){var t,K,P,u,v;if(p){P=i+R.buildQueryString(a.getMetaPath("/"+i),q,false,n);v=R.$mSharedCollectionCacheByPath;if(!v){v=R.$mSharedCollectionCacheByPath={};}u=v[P];if(u){u.setActive(true);}else{K=Object.keys(v);t=K.length;if(t>100){K.filter(function(w){return!v[w].iActiveUsages;}).sort(function(w,x){return v[w].iInactiveSince-v[x].iInactiveSince;}).every(function(w){delete v[w];t-=1;return t>100;});}u=v[P]=new k(R,i,q,n,D,p);}return u;}return new k(R,i,q,n,D);};
j.createProperty=function(R,i,q){return new l(R,i,q);};
j.createSingle=function(R,i,q,n,p,G,P,M){return new o(R,i,q,n,p,G,P,M);};
j.from$skip=function(i,n){return e.test(i)?(n.$created||0)+Number(i):i;};
j.getElementIndex=function(E,K,i){var n=E[i];if(!n||a.getPrivateAnnotation(n,"predicate")!==K){i=E.indexOf(E.$byPredicate[K]);}return i;};
j.makeUpdateData=function(p,v){return p.reduceRight(function(V,i){var R={};R[i]=V;return R;},v);};
return j;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_ConcatHelper',["./_AggregationHelper"],function(_){"use strict";return{enhanceCache:function(c,a,A,m){var f;c.getResourcePathWithQuery=function(s,e){var q=_.buildApply(a,Object.assign({},this.mQueryOptions,{$skip:s,$top:e-s}),1,f,m);f=true;return this.sResourcePath+this.oRequestor.buildQueryString(this.sMetaPath,q,false,true);};c.handleResponse=function(s,e,r,t){A.forEach(function(h){var o;if(h){o=r.value.shift();if("UI5__count"in o){r["@odata.count"]=o.UI5__count;}h(o);}});delete this.handleResponse;this.handleResponse(s,e,r,t);};}};},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_GroupLock',["sap/ui/base/SyncPromise"],function(S){"use strict";
function _(g,o,l,m,s,c){if(!o){throw new Error("Missing owner");}if(m&&!l){throw new Error("A modifying group lock has to be locked");}this.fnCancel=c;this.bCanceled=false;this.sGroupId=g;this.bLocked=!!l;this.bModifying=!!m;this.oOwner=o;this.oPromise=null;this.iSerialNumber=s===undefined?Infinity:s;}
_.prototype.cancel=function(){if(!this.bCanceled){this.bCanceled=true;if(this.fnCancel){this.fnCancel();}this.unlock(true);}};
_.prototype.getGroupId=function(){return this.sGroupId;};
_.prototype.getSerialNumber=function(){return this.iSerialNumber;};
_.prototype.getUnlockedCopy=function(){return new _(this.sGroupId,this.oOwner,false,false,this.iSerialNumber);};
_.prototype.isCanceled=function(){return this.bCanceled;};
_.prototype.isLocked=function(){return this.bLocked;};
_.prototype.isModifying=function(){return this.bModifying;};
_.prototype.toString=function(){return"sap.ui.model.odata.v4.lib._GroupLock(group="+this.sGroupId+", owner="+this.oOwner+(this.isLocked()?", locked":"")+(this.isModifying()?", modifying":"")+(this.iSerialNumber!==Infinity?", serialNumber="+this.iSerialNumber:"")+")";};
_.prototype.unlock=function(f){if(this.bLocked===undefined&&!f){throw new Error("GroupLock unlocked twice");}this.bLocked=undefined;if(this.oPromise){this.oPromise.$resolve();}};
_.prototype.waitFor=function(g){var r;if(this.bLocked&&this.sGroupId===g){if(!this.oPromise){this.oPromise=new S(function(a){r=a;});this.oPromise.$resolve=r;}return this.oPromise;}};
_.$cached=new _("$cached","sap.ui.model.odata.v4.lib._GroupLock");
_.$cached.unlock=function(){};
return _;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_Helper',["sap/base/Log","sap/base/util/deepEqual","sap/base/util/isEmptyObject","sap/base/util/merge","sap/base/util/uid","sap/ui/thirdparty/URI"],function(L,d,a,m,u,U){"use strict";var r=/&/g,c="sap.ui.model.odata.v4.lib._Helper",b=/\=/g,f=/%29/g,g=/%28/g,h=/%27/g,j=/#/g,k=/\([^/]*|\/-?\d+/g,l=/\+/g,n=/'/g,o=/''/g,p=/\s+/g,_;_={addByPath:function(M,P,i){if(i){if(!M[P]){M[P]=[i];}else if(M[P].indexOf(i)<0){M[P].push(i);}}},addChildrenWithAncestor:function(C,A,e){if(A.length){C.forEach(function(P){var s;if(A.indexOf(P)>=0){e[P]=true;return;}s=P.split("/");s.pop();while(s.length){if(A.indexOf(s.join("/"))>=0){e[P]=true;break;}s.pop();}});}},addToSelect:function(q,s){q.$select=q.$select||[];s.forEach(function(P){if(q.$select.indexOf(P)<0){q.$select.push(P);}});},adjustTargets:function(M,O,P,C){var A=_.getAnnotationKey(M,".additionalTargets"),t;t=[M.target].concat(M[A]).map(function(T){return T&&_.getAdjustedTarget(T,O,P,C);}).filter(function(T){return T;});M.target=t[0];if(A){M[A]=t.slice(1);}},adjustTargetsInError:function(e,O,P,C){if(!e.error){return;}_.adjustTargets(e.error,O,P,C);if(e.error.details){e.error.details.forEach(function(M){_.adjustTargets(M,O,P,C);});}},aggregateExpandSelect:function(A,q){if(q.$select){_.addToSelect(A,q.$select);}if(q.$expand){A.$expand=A.$expand||{};Object.keys(q.$expand).forEach(function(P){if(A.$expand[P]){_.aggregateExpandSelect(A.$expand[P],q.$expand[P]);}else{A.$expand[P]=q.$expand[P];}});}},buildPath:function(){var P="",s,i;for(i=0;i<arguments.length;i+=1){s=arguments[i];if(s||s===0){if(P&&P!=="/"&&s[0]!=="("){P+="/";}P+=s;}}return P;},buildQuery:function(P){var K,q;if(!P){return"";}K=Object.keys(P);if(K.length===0){return"";}q=[];K.forEach(function(s){var v=P[s];if(Array.isArray(v)){v.forEach(function(i){q.push(_.encodePair(s,i));});}else{q.push(_.encodePair(s,v));}});return"?"+q.join("&");},clone:function e(v,R){return v===undefined||v===Infinity||v===-Infinity||v!==v?v:JSON.parse(JSON.stringify(v,R));},createError:function(i,M,R,s){var B=i.responseText,C=i.getResponseHeader("Content-Type"),P,q=new Error(M+": "+i.status+" "+i.statusText),t=i.getResponseHeader("Retry-After"),v;q.status=i.status;q.statusText=i.statusText;q.requestUrl=R;q.resourcePath=s;if(i.status===0){q.message="Network error";return q;}if(C){C=C.split(";")[0];}if(i.status===412){P=i.getResponseHeader("Preference-Applied");if(P&&P.replace(p,"")==="handling=strict"){q.strictHandlingFailed=true;}else{q.isConcurrentModification=true;}}if(t){v=parseInt(t);q.retryAfter=new Date(Number.isNaN(v)?t:Date.now()+v*1000);}if(C==="application/json"){try{q.error=JSON.parse(B).error;q.message=q.error.message;if(typeof q.message==="object"){q.message=q.error.message.value;}}catch(e){L.warning(e.toString(),B,c);}}else if(C==="text/plain"){q.message=B;}return q;},createGetMethod:function(F,t){return function(){var s=this[F].apply(this,arguments);if(s.isFulfilled()){return s.getResult();}else if(t){if(s.isRejected()){s.caught();throw s.getResult();}else{throw new Error("Result pending");}}};},createMissing:function(O,s){s.reduce(function(C,S,i){if(!(S in C)){C[S]=i+1<s.length?{}:null;}return C[S];},O);},createRequestMethod:function(F){return function(){return Promise.resolve(this[F].apply(this,arguments));};},createTechnicalDetails:function(M){var C,e=M["@$ui5.error"],O=M["@$ui5.originalMessage"]||M,t={};if(e&&(e.status||e.cause)){e=e.cause||e;t.httpStatus=e.status;if(e.isConcurrentModification){t.isConcurrentModification=true;}if(e.retryAfter){t.retryAfter=e.retryAfter;}}if(!(O instanceof Error)){Object.defineProperty(t,"originalMessage",{enumerable:true,get:function(){if(!C){C=_.publicClone(O);}return C;}});}return t;},decomposeError:function(e,R,s){var D=e.error.details&&e.error.details.map(function(i){return _.getContentID(i);}),t=_.getContentID(e.error);return R.map(function(q,i){var C=new Error(e.message);function v(M,w){if(i===0&&!w){if(M.target){M.message=M.target+": "+M.message;}delete M.target;return true;}return w===q.$ContentID;}C.error=_.clone(e.error);C.requestUrl=s+q.url;C.resourcePath=q.$resourcePath;C.status=e.status;C.statusText=e.statusText;if(!v(C.error,t)){C.error.$ignoreTopLevel=true;}if(C.error.details){C.error.details=C.error.details.filter(function(w,i){return v(w,D[i]);});}return C;});},deepEqual:d,deletePrivateAnnotation:function(O,A){var P=O["@$ui5._"];if(P){delete P[A];}},drillDown:function(O,s){return s.reduce(function(C,S){return(C&&S in C)?C[S]:undefined;},O);},encode:function(P,e){var E=encodeURI(P).replace(r,"%26").replace(j,"%23").replace(l,"%2B");if(e){E=E.replace(b,"%3D");}return E;},encodePair:function(K,v){return _.encode(K,true)+"="+_.encode(v,false);},extractMessages:function(e){var M=[];function i(q,N,t){var R={additionalTargets:_.getAdditionalTargets(q),code:q.code,message:q.message,numericSeverity:N,technical:t||q.technical,"@$ui5.error":e,"@$ui5.originalMessage":q};Object.keys(q).forEach(function(P){if(P[0]==="@"){if(P.endsWith(".numericSeverity")){R.numericSeverity=q[P];}else if(P.endsWith(".longtextUrl")&&e.requestUrl&&q[P]){R.longtextUrl=_.makeAbsolute(q[P],e.requestUrl);}}});if(typeof q.target==="string"){if(q.target[0]==="$"||!e.resourcePath){R.message=q.target+": "+q.message;}else{R.target=q.target;}}R.transition=true;M.push(R);}if(e.error){if(!e.error.$ignoreTopLevel){i(e.error,4,true);}if(e.error.details){e.error.details.forEach(function(q){i(q);});}}else{i(e,4,true);}return M;},extractMergeableQueryOptions:function(q){var e={};if("$expand"in q){e.$expand=q.$expand;q.$expand="~";}if("$select"in q){e.$select=q.$select;q.$select="~";}return e;},fetchPropertyAndType:function(F,M){return F(M).then(function(P){if(P&&P.$kind==="NavigationProperty"){return F(M+"/").then(function(){return P;});}return P;});},filterPaths:function(M,P){return P.filter(function(s){var e=_.getMetaPath(s);return M.every(function(i){return!_.hasPathPrefix(e,i);});});},fireChange:function(C,P,v){var e=C[P],i;if(e){for(i=0;i<e.length;i+=1){e[i].onChange(v);}}},fireChanges:function(C,P,v,R){Object.keys(v).forEach(function(s){var e=_.buildPath(P,s),V=v[s];if(V&&typeof V==="object"){_.fireChanges(C,e,V,R);}else{_.fireChange(C,e,R?undefined:V);}});_.fireChange(C,P,R?undefined:v);},formatLiteral:function(v,t){if(v===undefined){throw new Error("Illegal value: undefined");}if(v===null){return"null";}switch(t){case"Edm.Binary":return"binary'"+v+"'";case"Edm.Boolean":case"Edm.Byte":case"Edm.Double":case"Edm.Int16":case"Edm.Int32":case"Edm.SByte":case"Edm.Single":return String(v);case"Edm.Date":case"Edm.DateTimeOffset":case"Edm.Decimal":case"Edm.Guid":case"Edm.Int64":case"Edm.TimeOfDay":return v;case"Edm.Duration":return"duration'"+v+"'";case"Edm.String":return"'"+v.replace(n,"''")+"'";default:throw new Error("Unsupported type: "+t);}},getAdditionalTargets:function(M){return _.getAnnotation(M,".additionalTargets");},getAdjustedTarget:function(t,O,P,C){var i,s,S;S=t.split("/");s=S.shift();if(s==="$Parameter"){t=S.join("/");s=S.shift();}if(O.$IsBound&&s===O.$Parameter[0].$Name){t=_.buildPath(C,S.join("/"));return t;}i=O.$Parameter.some(function(e){return s===e.$Name;});if(i){t=P+"/"+t;return t;}},getAnnotation:function(M,N){var A=_.getAnnotationKey(M,N);return A&&M[A];},getAnnotationKey:function(O,N,P){var A,D,s=(P||"")+"@";Object.keys(O).forEach(function(K){if(K.startsWith(s)&&K.endsWith(N)){if(A){L.warning("Cannot distinguish "+A+" from "+K,undefined,c);D=true;}A=K;}});return D?undefined:A;},getContentID:function(M){return _.getAnnotation(M,".ContentID");},getKeyFilter:function(i,M,t,K){var F=[],s,e=_.getKeyProperties(i,M,t,K);if(!e){return undefined;}for(s in e){F.push(s+" eq "+e[s]);}return F.join(" and ");},getKeyPredicate:function(i,M,t,K,e){var q=_.getKeyProperties(i,M,t,K,true);if(!q){return undefined;}K=Object.keys(q).map(function(A,s,v){var V=encodeURIComponent(q[A]);return e||v.length>1?encodeURIComponent(A)+"="+V:V;});return"("+K.join(",")+")";},getKeyProperties:function(i,M,t,K,R){var F,e={};K=K||t[M].$Key;F=K.some(function(v){var s,q,P,S,T,V;if(typeof v==="string"){s=q=v;}else{s=Object.keys(v)[0];q=v[s];if(!R){s=q;}}S=q.split("/");V=_.drillDown(i,S);if(V===undefined){return true;}P=S.pop();T=t[_.buildPath(M,S.join("/"))];V=_.formatLiteral(V,T[P].$Type);e[s]=V;});return F?undefined:e;},getMetaPath:function(P){if(P[0]==="/"){return P.replace(k,"");}if(P[0]!=="("){P="/"+P;}return P.replace(k,"").slice(1);},getPrivateAnnotation:function(O,A){var P=O["@$ui5._"];return P&&P[A];},getQueryOptionsForPath:function(q,P){P=_.getMetaPath(P);if(P){P.split("/").some(function(s){q=q&&q.$expand&&q.$expand[s];if(!q||q===true){q={};return true;}});}return q||{};},getRelativePath:function(P,B){if(B.length){if(!P.startsWith(B)){return undefined;}P=P.slice(B.length);if(P){if(P[0]==="/"){return P.slice(1);}if(P[0]!=="("){return undefined;}}}return P;},hasPrivateAnnotation:function(O,A){var P=O["@$ui5._"];return P?A in P:false;},informAll:function(C,P,O,N){if(N===O){return;}if(N&&typeof N==="object"){Object.keys(N).forEach(function(s){_.informAll(C,_.buildPath(P,s),O&&O[s],N[s]);});}else{_.fireChange(C,P,N===undefined?null:N);N={};}if(O&&typeof O==="object"){Object.keys(O).forEach(function(s){if(!N.hasOwnProperty(s)){_.informAll(C,_.buildPath(P,s),O[s],undefined);}});}},inheritPathValue:function(s,S,t){s.forEach(function(e,i){var M=!(e in t);if(i+1<s.length){if(M){t[e]={};}S=S[e];t=t[e];}else if(M){t[e]=S[e];}});},intersectQueryOptions:function(C,P,F,R,N,s,A){var e=[],E={},q,t,S,v={};function w(x,M){var y=M.split("/");return y.every(function(z,i){return i===0&&x||z==="$count"||F(R+"/"+y.slice(0,i+1).join("/")).getResult().$kind==="Property";});}if(P.indexOf("")>=0){throw new Error("Unsupported empty navigation property path");}if(P.indexOf("*")>=0){S=C&&C.$select||[];}else if(C&&C.$select&&C.$select.indexOf("*")<0){_.addChildrenWithAncestor(P,C.$select,v);_.addChildrenWithAncestor(C.$select,P,v);S=Object.keys(v).filter(w.bind(null,true));}else{S=P.filter(w.bind(null,false));}if(C&&C.$expand){e=Object.keys(C.$expand);e.forEach(function(i){var x,M=R+"/"+i,y=_.buildPath(s,i),z={},B;_.addChildrenWithAncestor([i],P,z);if(!a(z)){if(F(M).getResult().$isCollection){N[y]=true;}E[i]=C.$expand[i];return;}B=_.stripPathPrefix(i,P);if(B.length){if(F(M).getResult().$isCollection){throw new Error("Unsupported collection-valued navigation property "+M);}x=_.intersectQueryOptions(C.$expand[i]||{},B,F,M,N,y);if(x){E[i]=x;}}});}if(!S.length&&a(E)){return null;}q=Object.assign({},C,{$select:S});t=F(R).getResult();if(t.$kind==="NavigationProperty"&&!t.$isCollection){_.selectKeyProperties(q,F(R+"/").getResult());}else if(!S.length&&!A){q.$select=Object.keys(E).slice(0,1);}if(a(E)){delete q.$expand;}else{q.$expand=E;}return q;},hasPathPrefix:function(P,B){return _.getRelativePath(P,B)!==undefined;},isSafeInteger:function(N){if(typeof N!=="number"||!isFinite(N)){return false;}N=Math.abs(N);return N<=9007199254740991&&Math.floor(N)===N;},makeAbsolute:function(s,B){return new U(s).absoluteTo(B).toString().replace(h,"'").replace(g,"(").replace(f,")");},merge:m,mergeQueryOptions:function(q,O,F){var R;function s(P,v){if(v&&(!q||q[P]!==v)){if(!R){R=q?_.clone(q):{};}R[P]=v;}}s("$orderby",O);if(F){s("$filter",F[0]);s("$$filterBeforeAggregate",F[1]);}return R||q;},namespace:function(N){var i;N=N.split("/")[0].split("(")[0];i=N.lastIndexOf(".");return i<0?"":N.slice(0,i);},parseLiteral:function(s,t,P){function e(i){if(!isFinite(i)){throw new Error(P+": Not a valid "+t+" literal: "+s);}return i;}if(s==="null"){return null;}switch(t){case"Edm.Boolean":return s==="true";case"Edm.Byte":case"Edm.Int16":case"Edm.Int32":case"Edm.SByte":return e(parseInt(s));case"Edm.Date":case"Edm.DateTimeOffset":case"Edm.Decimal":case"Edm.Guid":case"Edm.Int64":case"Edm.TimeOfDay":return s;case"Edm.Double":case"Edm.Single":return s==="INF"||s==="-INF"||s==="NaN"?s:e(parseFloat(s));case"Edm.String":return s.slice(1,-1).replace(o,"'");default:throw new Error(P+": Unsupported type: "+t);}},publicClone:function(v,R){return _.clone(v,function(K,v){if(R?!K.startsWith("@$ui5."):K!=="@$ui5._"){return v;}});},removeByPath:function(M,P,i){var I=M[P],e;if(I){e=I.indexOf(i);if(e>=0){if(I.length===1){delete M[P];}else{I.splice(e,1);}}}},resolveIfMatchHeader:function(H){var i=H&&H["If-Match"];if(i&&typeof i==="object"){i=i["@odata.etag"];H=Object.assign({},H);if(i===undefined){delete H["If-Match"];}else{H["If-Match"]=i;}}return H;},selectKeyProperties:function(q,t){if(t&&t.$Key){_.addToSelect(q,t.$Key.map(function(K){if(typeof K==="object"){return K[Object.keys(K)[0]];}return K;}));}},setPrivateAnnotation:function(O,A,v){var P=O["@$ui5._"];if(!P){P=O["@$ui5._"]={};}P[A]=v;},stripPathPrefix:function(P,e){var s=P+"/";if(P===""){return e;}return e.filter(function(i){return i===P||i.startsWith(s);}).map(function(i){return i.slice(s.length);});},toArray:function(e){if(e===undefined||e===null){return[];}if(Array.isArray(e)){return e.slice();}return[e];},uid:u,updateAll:function(C,P,t,s,e){Object.keys(s).forEach(function(i){var q=_.buildPath(P,i),S,v=s[i],T,w=t[i];if(i==="@$ui5._"){S=_.getPrivateAnnotation(s,"predicate");if(e&&e(P)){T=_.getPrivateAnnotation(t,"predicate");if(S!==T){throw new Error("Key predicate of '"+P+"' changed from "+T+" to "+S);}}else{_.setPrivateAnnotation(t,"predicate",S);}}else if(Array.isArray(v)){t[i]=v;}else if(v&&typeof v==="object"){t[i]=_.updateAll(C,q,w||{},v,e);}else if(w!==v){t[i]=v;if(w&&typeof w==="object"){_.fireChanges(C,q,w,true);}else{_.fireChange(C,q,v);}}});return t;},updateExisting:function(C,P,O,N){if(!N){return;}Object.keys(O).forEach(function(s){var e=_.buildPath(P,s),v=O[s],i=N[s];if(s in N||s[0]==="#"){if(Array.isArray(i)){O[s]=i;}else if(i&&typeof i==="object"){if(v){_.updateExisting(C,e,v,i);}else{O[s]=i;_.fireChanges(C,e,i,false);}}else if(v!==i){O[s]=i;if(v&&typeof v==="object"){_.fireChanges(C,e,v,true);}else{_.fireChange(C,e,i);}}}});Object.keys(N).filter(function(s){return s[0]==="#";}).filter(function(A){return!(A in O);}).forEach(function(s){var v=N[s],e=_.buildPath(P,s);O[s]=v;_.fireChanges(C,e,v,false);});},updateNonExisting:function(t,s){Object.keys(s).forEach(function(K){var S=s[K],T;if(K in t){T=t[K];if(S&&T&&typeof S==="object"&&!Array.isArray(S)){_.updateNonExisting(T,S);}}else{t[K]=S;}});},updateSelected:function(C,P,O,N,s){function e(i,S,t){var q=i.split("/");q.every(function(v,I){var w=S[v],T=t[v];if(Array.isArray(w)){t[v]=w;}else if(w&&typeof w==="object"){t=t[v]=T||{};S=w;return true;}else if(T!==w){t[v]=w;if(T&&typeof T==="object"){_.fireChanges(C,_.buildPath(P,q.slice(0,I+1).join("/")),T,true);}else if(I===q.length-1){_.fireChange(C,_.buildPath(P,i),w);}}return false;});}if(!s||s.indexOf("*")>=0){_.updateAll(C,P,O,N);return;}s.forEach(function(i){e(i,N,O);});},updateTransientPaths:function(M,t,P){var s;for(s in M){if(s.includes(t)){M[s.replace(t,P)]=M[s];delete M[s];}}},wrapChildQueryOptions:function(B,C,e,F){var E="",M=C.split("/"),P,s=B,q={},Q=q,i;if(C===""){return e;}for(i=0;i<M.length;i+=1){s=_.buildPath(s,M[i]);E=_.buildPath(E,M[i]);P=F(s).getResult();if(P.$kind==="NavigationProperty"){Q.$expand={};Q=Q.$expand[E]=(i===M.length-1)?e:{};_.selectKeyProperties(Q,F(s+"/").getResult());E="";}else if(P.$kind!=="Property"){return undefined;}}if(P.$kind==="Property"){if(Object.keys(e).length>0){L.error("Failed to enhance query options for auto-$expand/$select as the"+" child binding has query options, but its path '"+C+"' points to a structural property",JSON.stringify(e),c);return undefined;}_.addToSelect(Q,[E]);}if("$apply"in e){L.debug("Cannot wrap $apply into $expand: "+C,JSON.stringify(e),c);return undefined;}return q;}};return _;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_MetadataConverter',["./_Helper","sap/base/Log","sap/ui/performance/Measurement"],function(_,L,M){"use strict";var c="sap.ui.model.odata.v4.lib._MetadataConverter";
function a(){this.aliases={};this.oAnnotatable=null;this.entityContainer=null;this.entitySet=null;this.namespace=null;this.oOperation=null;this.reference=null;this.schema=null;this.type=null;this.result=null;this.url=null;this.xmlns=null;}
a.prototype.rCollection=/^Collection\((.*)\)$/;a.prototype.sEdmNamespace="http://docs.oasis-open.org/odata/ns/edm";a.prototype.sEdmxNamespace="http://docs.oasis-open.org/odata/ns/edmx";
a.prototype.addToResult=function(q,v){if(q in this.result){L.warning("Duplicate qualified name "+q,undefined,c);}this.result[q]=v;};
a.prototype.annotatable=function(t,p,q){var A,o,P;if(typeof t==="string"){A=this.oAnnotatable;if(A){t=_.buildPath(A.path,t);}P=t;o=this.schema.$Annotations;if(o&&o[t]){t=o[t];}}this.oAnnotatable={parent:this.oAnnotatable,path:P,prefix:p||"",qualifiedName:undefined,qualifier:q,target:t};};
a.prototype.convertXMLMetadata=function(d,u){var e;M.average("convertXMLMetadata","","sap.ui.model.odata.v4.lib._V4MetadataConverter");e=d.documentElement;if(e.localName!=="Edmx"||e.namespaceURI!==this.sRootNamespace){throw new Error(u+": expected <Edmx> in namespace '"+this.sRootNamespace+"'");}this.result={};this.url=u;this.traverse(e,this.oAliasConfig);this.traverse(e,this.oFullConfig,true);this.finalize();M.end("convertXMLMetadata");return this.result;};
a.prototype.getAnnotationValue=function(t,v){var V,b,i;switch(t){case"AnnotationPath":case"NavigationPropertyPath":case"Path":case"PropertyPath":v=this.resolveAliasInPath(v);case"Binary":case"Date":case"DateTimeOffset":case"Decimal":case"Duration":case"Guid":case"TimeOfDay":case"UrlRef":V={};V["$"+t]=v;return V;case"Bool":return v==="true";case"EnumMember":b=v.trim().replace(/ +/g," ").split(" ");for(i=0;i<b.length;i+=1){b[i]=this.resolveAliasInPath(b[i]);}return{$EnumMember:b.join(" ")};case"Float":if(v==="NaN"||v==="INF"||v==="-INF"){return{$Float:v};}return parseFloat(v);case"Int":V=parseInt(v);return _.isSafeInteger(V)?V:{$Int:v};case"String":return v;default:return undefined;}};
a.prototype.getInlineAnnotationValue=function(e){var A,o=e.attributes,v,i;for(i=o.length-1;i>=0;i-=1){A=o.item(i);v=this.getAnnotationValue(A.name,A.value);if(v!==undefined){return v;}}return true;};
a.prototype.getOrCreateArray=function(p,P){var r=p[P];if(!r){r=p[P]=[];}return r;};
a.prototype.getOrCreateObject=function(p,P){var r=p[P];if(!r){r=p[P]={};}return r;};
a.prototype.postProcessAnnotation=function(e,r){var A=this.oAnnotatable.parent;A.target[A.qualifiedName]=r.length?r[0]:this.getInlineAnnotationValue(e);};
a.prototype.postProcessApply=function(e,r){var R=this.oAnnotatable.target;R.$Apply=r;R.$Function=this.resolveAlias(e.getAttribute("Function"));return R;};
a.prototype.postProcessCastOrIsOf=function(e,r){var n=e.localName,R=this.oAnnotatable.target;R["$"+n]=r[0];this.processTypedCollection(e.getAttribute("Type"),R);this.processFacetAttributes(e,R);return R;};
a.prototype.postProcessCollection=function(b,r){return r;};
a.prototype.postProcessLabeledElement=function(e,r){var R=this.oAnnotatable.target;R.$LabeledElement=r.length?r[0]:this.getInlineAnnotationValue(e);R.$Name=e.getAttribute("Name");return R;};
a.prototype.postProcessLabeledElementReference=function(e,b){return{$LabeledElementReference:this.resolveAlias(e.textContent)};};
a.prototype.postProcessLeaf=function(e,b){return this.getAnnotationValue(e.localName,e.textContent);};
a.prototype.postProcessNot=function(b,r){var R=this.oAnnotatable.target;R.$Not=r[0];return R;};
a.prototype.postProcessNull=function(b,d){var A=this.oAnnotatable,r=null;if(A.qualifiedName){r=A.target;r.$Null=null;}return r;};
a.prototype.postProcessOperation=function(e,r){var R=this.oAnnotatable.target;R["$"+e.localName]=r;return R;};
a.prototype.postProcessPropertyValue=function(e,r){return{property:e.getAttribute("Property"),value:r.length?r[0]:this.getInlineAnnotationValue(e)};};
a.prototype.postProcessRecord=function(e,r){var p,R=this.oAnnotatable.target,t=e.getAttribute("Type"),i;if(t){R.$Type=this.resolveAlias(t);}for(i=0;i<r.length;i+=1){p=r[i];R[p.property]=p.value;}return R;};
a.prototype.postProcessUrlRef=function(b,r){return{$UrlRef:r[0]};};
a.prototype.processAlias=function(e){var A=e.getAttribute("Alias");if(A){this.aliases[A]=e.getAttribute("Namespace")+".";}};
a.prototype.processAnnotatableExpression=function(b){this.annotatable({});};
a.prototype.processAnnotation=function(e){var A=this.oAnnotatable,o,q=A.prefix+"@"+this.resolveAlias(e.getAttribute("Term")),Q=A.qualifier||e.getAttribute("Qualifier");if(Q){q+="#"+Q;}if(typeof A.target==="string"){o=this.getOrCreateObject(this.schema,"$Annotations");A.target=o[A.target]={};}A.qualifiedName=q;A.target[q]=true;this.annotatable(A.target,q);};
a.prototype.processAnnotations=function(e){this.annotatable(this.resolveAliasInPath(e.getAttribute("Target"),true),undefined,e.getAttribute("Qualifier"));};
a.prototype.processAttributes=function(e,t,C){var p;for(p in C){var v=C[p](e.getAttribute(p));if(v!==undefined&&v!==null){t["$"+p]=v;}}};
a.prototype.processInclude=function(e){var i=this.getOrCreateArray(this.reference,"$Include");i.push(e.getAttribute("Namespace")+".");};
a.prototype.processIncludeAnnotations=function(e){var r=this.reference,i={$TermNamespace:e.getAttribute("TermNamespace")+"."},I=this.getOrCreateArray(r,"$IncludeAnnotations");this.processAttributes(e,i,{TargetNamespace:function s(v){return v?v+".":v;},Qualifier:this.setValue});I.push(i);};
a.prototype.processPropertyValue=function(e){this.annotatable(this.oAnnotatable.target,e.getAttribute("Property"));};
a.prototype.processReference=function(e){var r=this.getOrCreateObject(this.result,"$Reference");this.reference=r[e.getAttribute("Uri")]={};this.annotatable(this.reference);};
a.prototype.resolveAlias=function(n){var d=n?n.indexOf("."):-1,N;if(d>=0&&!n.includes(".",d+1)){N=this.aliases[n.slice(0,d)];if(N){return N+n.slice(d+1);}}return n;};
a.prototype.resolveAliasInParentheses=function(h,s){var p=h?s.indexOf("("):-1;if(p>=0){return this.resolveAlias(s.slice(0,p))+"("+s.slice(p+1,-1).split(",").map(this.resolveAliasInParentheses.bind(this,h)).join(",")+")";}return this.resolveAlias(s);};
a.prototype.resolveAliasInPath=function(p,h){var A,t="";if(!p.includes(".")){return p;}A=p.indexOf("@");if(A>=0){t="@"+this.resolveAlias(p.slice(A+1));p=p.slice(0,A);}return p.split("/").map(this.resolveAliasInParentheses.bind(this,h)).join("/")+t;};
a.prototype.setIfFalse=function(v){return v==="false"?false:undefined;};
a.prototype.setIfTrue=function(v){return v==="true"?true:undefined;};
a.prototype.setNumber=function(v){return v?parseInt(v):undefined;};
a.prototype.setValue=function(v){return v;};
a.prototype.traverse=function(e,C,u){var A=this.oAnnotatable,o,b=e.childNodes,d,v,I,n,p=this.xmlns,r,R=[],x=C.__xmlns||this.xmlns,i,j;if(x&&x!==e.namespaceURI){return undefined;}this.xmlns=x;if(u){this.processElement(e,C.__processor);}else if(C.__processor){C.__processor.call(this,e);}for(i=0;i<b.length;i+=1){d=b.item(i);if(d.nodeType===1){n=d.localName;o=C[n];if(!o&&C.__include){I=C.__include;for(j=0;j<I.length;j+=1){o=I[j][n];if(o){break;}}}if(o){v=this.traverse(d,o,u);if(v!==undefined&&C.__postProcessor){R.push(v);}}}}if(C.__postProcessor){r=C.__postProcessor.call(this,e,R);}this.oAnnotatable=A;this.xmlns=p;return r;};
(function($){var A,o,b,e,O;b={AnnotationPath:{__postProcessor:$.postProcessLeaf},Binary:{__postProcessor:$.postProcessLeaf},Bool:{__postProcessor:$.postProcessLeaf},Date:{__postProcessor:$.postProcessLeaf},DateTimeOffset:{__postProcessor:$.postProcessLeaf},Decimal:{__postProcessor:$.postProcessLeaf},Duration:{__postProcessor:$.postProcessLeaf},EnumMember:{__postProcessor:$.postProcessLeaf},Float:{__postProcessor:$.postProcessLeaf},Guid:{__postProcessor:$.postProcessLeaf},Int:{__postProcessor:$.postProcessLeaf},LabeledElementReference:{__postProcessor:$.postProcessLabeledElementReference},NavigationPropertyPath:{__postProcessor:$.postProcessLeaf},Path:{__postProcessor:$.postProcessLeaf},PropertyPath:{__postProcessor:$.postProcessLeaf},String:{__postProcessor:$.postProcessLeaf},TimeOfDay:{__postProcessor:$.postProcessLeaf}};e=[b];$.oAnnotationConfig={Annotation:{__xmlns:$.sEdmNamespace,__processor:$.processAnnotation,__postProcessor:$.postProcessAnnotation,__include:e}};A=[b,$.oAnnotationConfig];O={__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessOperation,__include:A};o={And:O,Apply:{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessApply,__include:A},Cast:{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessCastOrIsOf,__include:A},Collection:{__postProcessor:$.postProcessCollection,__include:e},Eq:O,Ge:O,Gt:O,If:O,IsOf:{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessCastOrIsOf,__include:A},LabeledElement:{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessLabeledElement,__include:A},Le:O,Lt:O,Ne:O,Null:{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessNull,__include:[$.oAnnotationConfig]},Not:{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessNot,__include:A},Or:O,Record:{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessRecord,__include:[$.oAnnotationConfig],PropertyValue:{__processor:$.processPropertyValue,__postProcessor:$.postProcessPropertyValue,__include:A}},UrlRef:{__postProcessor:$.postProcessUrlRef,__include:e}};$.oAnnotationsConfig={Annotations:{__processor:$.processAnnotations,__include:[$.oAnnotationConfig]}};e.push(o);A.push(o);$.oAnnotationConfig.Annotation.Annotation=$.oAnnotationConfig.Annotation;$.oReferenceInclude={Reference:{__xmlns:$.sEdmxNamespace,__processor:$.processReference,__include:[$.oAnnotationConfig],Include:{__processor:$.processInclude},IncludeAnnotations:{__processor:$.processIncludeAnnotations}}};})(a.prototype);return a;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_MetadataRequestor',["./_Helper","./_V2MetadataConverter","./_V4MetadataConverter","sap/base/Log","sap/ui/thirdparty/jquery"],function(_,a,b,L,q){"use strict";return{create:function(h,o,Q){var u={},s=_.buildQuery(Q);return{read:function(U,A,p){var P;function c(j){var C=o==="4.0"||A?b:a,d=j.$XML;delete j.$XML;return Object.assign(new C().convertXMLMetadata(d,U),j);}if(U in u){if(p){throw new Error("Must not prefetch twice: "+U);}P=u[U].then(c);delete u[U];}else{P=new Promise(function(r,R){q.ajax(A?U:U+s,{method:"GET",headers:h}).then(function(d,e,j){var D=j.getResponseHeader("Date"),E=j.getResponseHeader("ETag"),J={$XML:d},l=j.getResponseHeader("Last-Modified");if(D){J.$Date=D;}if(E){J.$ETag=E;}if(l){J.$LastModified=l;}r(J);},function(j,d,e){var E=_.createError(j,"Could not load metadata");L.error("GET "+U,E.message,"sap.ui.model.odata.v4.lib._MetadataRequestor");R(E);});if(!A&&Q&&"sap-context-token"in Q){delete Q["sap-context-token"];s=_.buildQuery(Q);}});if(p){u[U]=P;}else{P=P.then(c);}}return P;}};}};},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_MinMaxHelper',["./_Cache","./_ConcatHelper"],function(_,a){"use strict";return{createCache:function(r,R,A,q){var m={},c,M,o=new Promise(function(b){M=b;});function h(b){var s,d={};function g(e){d[e]=d[e]||{};return d[e];}for(s in m){g(m[s].measure)[m[s].method]=b[s];}M(d);}c=_.create(r,R,q,true);a.enhanceCache(c,A,[h],m);c.getMeasureRangePromise=function(){return o;};return c;}};},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_Parser',[],function(){"use strict";var d="[=(),; \t\"']|%(09|20|22|27|28|29|2c|2C|3b|3B)",s="\\$\\w+",o="[a-zA-Z_\\u0080-\\uFFFF][\\w\\u0080-\\uFFFF]*",w="(?:[ \\t]|%09|%20)",r=new RegExp(w+"+","g"),a=new RegExp("^not"+w+"+"),O="("+w+"+)(and|eq|ge|gt|le|lt|ne|or)"+w+"+",g="[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}",S="(?:\\*|%2[aA])",n=o+"(?:[./]"+o+")*"+"(?:[./]"+S+"|/\\$ref|/\\$count)?",b=S+"(?:/\\$ref)?",p=n+"|"+b,v='(?:[-+:./\\w"]|%2[bB])+',e=new RegExp("^(?:"+O+"|"+d+"|("+g+")|("+p+")|("+v+")|("+s+"))"),f=/^[0-9a-f]{2}$/i,F={ceiling:{ambiguousParameters:true},concat:{type:"Edm.String"},contains:{type:"Edm.Boolean"},day:{type:"Edm.Int32",ambiguousParameters:true},endswith:{type:"Edm.Boolean"},floor:{ambiguousParameters:true},hour:{type:"Edm.Int32",ambiguousParameters:true},indexof:{type:"Edm.Int32"},length:{type:"Edm.Int32"},minute:{type:"Edm.Int32",ambiguousParameters:true},month:{type:"Edm.Int32",ambiguousParameters:true},round:{ambiguousParameters:true},second:{type:"Edm.Int32",ambiguousParameters:true},startswith:{type:"Edm.Boolean"},substring:{type:"Edm.String"},tolower:{type:"Edm.String"},toupper:{type:"Edm.String"},trim:{type:"Edm.String"},year:{type:"Edm.Int32",ambiguousParameters:true}},m={"(":{lbp:9,led:function(T,L){var c,P;if(L.id!=="PATH"){this.error("Unexpected ",T);}c=F[L.value];if(!c){this.error("Unknown function ",L);}L.id="FUNCTION";if(c.type){L.type=c.type;}L.parameters=[];do{this.advanceBws();P=this.expression(0);if(c.ambiguousParameters){P.ambiguous=true;}L.parameters.push(P);this.advanceBws();}while(this.advanceIf(","));this.advanceBws();this.advance(")");return L;},nud:function(){var T;this.advanceBws();T=this.expression(0);this.advanceBws();this.advance(")");return T;}},not:{lbp:7,nud:function(T){T.precedence=7;T.right=this.expression(7);T.type="Edm.Boolean";return T;}}};
function h(i,L){m[i]={lbp:L,led:function(T,c){T.type="Edm.Boolean";T.precedence=L;T.left=c;T.right=this.expression(L);return T;}};}
function j(i){m[i]={lbp:0,nud:function(T){T.precedence=99;return T;}};}
h("and",2);h("eq",3);h("ge",4);h("gt",4);h("le",4);h("lt",4);h("ne",3);h("or",1);j("PATH");j("VALUE");
function _(){}
_.prototype.advance=function(E){var T=this.current();if(E&&(!T||T.id!==E)){if(E==="OPTION"){E="system query option";}else if(E.length===1){E="'"+E+"'";}this.expected(E,T);}this.iCurrentToken+=1;return T;};
_.prototype.advanceIf=function(E){var T=this.current();if(T&&T.id===E){this.iCurrentToken+=1;return true;}return false;};
_.prototype.current=function(){return this.aTokens[this.iCurrentToken];};
_.prototype.error=function(M,T){var v;if(T){v=T.value;M+="'"+(v===" "?v:v.replace(r,""))+"' at "+T.at;}else{M+="end of input";}throw new SyntaxError(M+": "+this.sText);};
_.prototype.expected=function(W,T){this.error("Expected "+W+" but instead saw ",T);};
_.prototype.finish=function(){if(this.iCurrentToken<this.aTokens.length){this.expected("end of input",this.aTokens[this.iCurrentToken]);}};
_.prototype.init=function(T){this.sText=T;this.aTokens=y(T);this.iCurrentToken=0;};
function k(){}
k.prototype=Object.create(_.prototype);
k.prototype.advanceBws=function(){var T;for(;;){T=this.current();if(!T||(T.id!==" "&&T.id!=="\t")){return;}this.advance();}};
k.prototype.expression=function(R){var L,c,T;T=this.advance();if(!T){this.expected("expression");}L=this.getSymbolValue(T,"nud");if(!L){this.expected("expression",T);}c=L.call(this,T);T=this.current();while(T&&this.getSymbolValue(T,"lbp",0)>R){c=this.getSymbolValue(T,"led").call(this,this.advance(),c);T=this.current();}return c;};
k.prototype.getSymbolValue=function(T,W,D){var c=m[T.id];return c&&W in c?c[W]:D;};
k.prototype.parse=function(c){var R;this.init(c);R=this.expression(0);this.finish();return R;};
function l(){}
l.prototype=Object.create(_.prototype);
l.prototype.parse=function(K){var c,i={},v;this.init(K);this.advance("(");if(this.current().id==="VALUE"){i[""]=this.advance().value;}else{do{c=this.advance("PATH").value;this.advance("=");v=this.advance("VALUE").value;i[c]=v;}while(this.advanceIf(","));}this.advance(")");this.finish();return i;};
function q(){}
q.prototype=Object.create(_.prototype);
q.prototype.parse=function(c){var R;this.init(c);R=this.parseSystemQueryOption();this.finish();return R;};
q.prototype.parseAnythingWithBrackets=function(c){var v="",R={},T,i=this;function z(){for(;;){T=i.advance();if(!T||T.id===";"){i.expected("')'",T);}v+=T.value;if(T.id===")"){return;}if(T.id==="("){z();}}}this.advance("=");for(;;){T=this.current();if(!T||T.id===")"||T.id===";"){break;}v+=this.advance().value;if(T.id==="("){z();}}if(!v){this.expected("an option value",T);}R[c.value]=v;return R;};
q.prototype.parseExpand=function(){var E={},c,Q,i,V;this.advance("=");do{V=null;c=this.advance("PATH").value.replace(/%2a/i,"*");if(this.advanceIf("(")){V={};do{Q=this.parseSystemQueryOption();i=Object.keys(Q)[0];V[i]=Q[i];}while(this.advanceIf(";"));this.advance(")");}E[c]=V;}while(this.advanceIf(","));return{$expand:E};};
q.prototype.parseSelect=function(){var p,P,c=[],T;this.advance("=");do{T=this.advance("PATH");p=T.value.replace(/%2a/i,"*");if(this.advanceIf("(")){P="(";do{p+=P+this.advance("PATH").value;P=",";}while(this.advanceIf(","));p+=this.advance(")").value;}c.push(p);}while(this.advanceIf(","));return{$select:c};};
q.prototype.parseSystemQueryOption=function(){var T=this.advance("OPTION");switch(T.value){case"$expand":return this.parseExpand();case"$select":return this.parseSelect();default:return this.parseAnythingWithBrackets(T);}};
function u(E){return String.fromCharCode(parseInt(E,16));}
function t(N,z,A){var i;function B(C){var c=N[i];if(c==="%"&&N[i+1]==="2"&&N[i+2]==="7"){c="'";if(C){i+=2;}}if(C){i+=1;}return c;}for(i=1;i<N.length;){if(B(true)==="'"){if(B(false)!=="'"){return N.slice(0,i);}B(true);}}throw new SyntaxError("Unterminated string at "+A+": "+z);}
function x(N,z,A){var c,E,B=false,i;for(i=1;i<N.length;i+=1){if(B){B=false;}else{c=N[i];if(c==="%"){E=N.slice(i+1,i+3);if(f.test(E)){c=u(E);i+=2;}}if(c==='"'){return N.slice(0,i+1);}B=c==="\\";}}throw new SyntaxError("Unterminated string at "+A+": "+z);}
function y(c){var A=1,i,M,N=c,z,T,B=[],v;while(N.length){M=e.exec(N);z=0;if(M){v=M[0];if(M[7]){i="OPTION";}else if(M[6]||M[4]){i="VALUE";}else if(M[5]){i="PATH";if(v==="false"||v==="true"||v==="null"){i="VALUE";}else if(v==="not"){M=a.exec(N);if(M){i="not";v=M[0];}}}else if(M[3]){i=u(M[3]);}else if(M[2]){i=M[2];z=M[1].length;}else{i=M[0];}if(i==='"'){i="VALUE";v=x(N,c,A);}else if(i==="'"){i="VALUE";v=t(N,c,A);}T={at:A+z,id:i,value:v};}else{throw new SyntaxError("Unknown character '"+N[0]+"' at "+A+": "+c);}N=N.slice(v.length);A+=v.length;B.push(T);}return B;}
return{buildFilterString:function(c){function i(N,P){var z;if(!N){return"";}if(N.parameters){z=N.parameters.map(function(A){return i(A,0);}).join(",");return N.value+"("+z+")";}z=i(N.left,N.precedence)+N.value+i(N.right,N.precedence);if(N.precedence<P){z="("+z+")";}return z;}return i(c,0);},parseFilter:function(c){return new k().parse(c);},parseKeyPredicate:function(K){return new l().parse(K);},parseSystemQueryOption:function(c){return new q().parse(c);},sODataIdentifier:o,sWhitespace:w};},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_Requestor',["./_Batch","./_GroupLock","./_Helper","./_V2Requestor","sap/base/Log","sap/ui/base/SyncPromise","sap/ui/thirdparty/jquery"],function(_,a,b,c,L,S,q){"use strict";var B={Accept:"multipart/mixed"},C="sap.ui.model.odata.v4.lib._Requestor",r=/(\$\w+)=~/g,d=/^\d+$/;
function g(h){var R;h=h.toLowerCase();for(R in this.headers){if(R.toLowerCase()===h){return this.headers[R];}}}
function e(s,h,Q,m){this.mBatchQueue={};this.mHeaders=h||{};this.aLockedGroupLocks=[];this.oModelInterface=m;this.sQueryParams=b.buildQuery(Q);this.mRunningChangeRequests={};this.iSessionTimer=0;this.iSerialNumber=0;this.sServiceUrl=s;this.vStatistics=Q&&Q["sap-statistics"];this.processSecurityTokenHandlers();}
e.prototype.mFinalHeaders={"Content-Type":"application/json;charset=UTF-8;IEEE754Compatible=true"};e.prototype.mPredefinedPartHeaders={Accept:"application/json;odata.metadata=minimal;IEEE754Compatible=true"};e.prototype.mPredefinedRequestHeaders={Accept:"application/json;odata.metadata=minimal;IEEE754Compatible=true","OData-MaxVersion":"4.0","OData-Version":"4.0","X-CSRF-Token":"Fetch"};e.prototype.mReservedHeaders={accept:true,"accept-charset":true,"content-encoding":true,"content-id":true,"content-language":true,"content-length":true,"content-transfer-encoding":true,"content-type":true,"if-match":true,"if-none-match":true,isolation:true,"odata-isolation":true,"odata-maxversion":true,"odata-version":true,prefer:true,"sap-contextid":true};
e.prototype.addChangeSet=function(G){var f=[],R=this.getOrCreateBatchQueue(G);f.iSerialNumber=this.getSerialNumber();R.iChangeSet+=1;R.splice(R.iChangeSet,0,f);};
e.prototype.addChangeToGroup=function(o,G){var R;if(this.getGroupSubmitMode(G)==="Direct"){o.$resolve(this.request(o.method,o.url,this.lockGroup(G,this,true,true),o.headers,o.body,o.$submit,o.$cancel));}else{R=this.getOrCreateBatchQueue(G);R[R.iChangeSet].push(o);}};
e.prototype.addQueryString=function(R,m,Q){var s;Q=this.convertQueryOptions(m,Q,false,true);R=R.replace(r,function(f,o){var v=Q[o];delete Q[o];return b.encodePair(o,v);});s=b.buildQuery(Q);if(!s){return R;}return R+(R.includes("?")?"&"+s.slice(1):s);};
e.prototype.batchRequestSent=function(G,R,h){var p,f;if(h){if(!(G in this.mRunningChangeRequests)){this.mRunningChangeRequests[G]=[];}p=new S(function(i){f=i;});p.$resolve=f;p.$requests=R;this.mRunningChangeRequests[G].push(p);}};
e.prototype.batchResponseReceived=function(G,R,h){var p;if(h){p=this.mRunningChangeRequests[G].filter(function(P){if(P.$requests===R){P.$resolve();return false;}return true;});if(p.length){this.mRunningChangeRequests[G]=p;}else{delete this.mRunningChangeRequests[G];}}};
e.prototype.buildQueryString=function(m,Q,D,s){return b.buildQuery(this.convertQueryOptions(m,Q,D,s));};
e.prototype.cancelChanges=function(G){if(this.mRunningChangeRequests[G]){throw new Error("Cannot cancel the changes for group '"+G+"', the batch request is running");}this.cancelChangesByFilter(function(){return true;},G);this.cancelGroupLocks(G);};
e.prototype.cancelChangesByFilter=function(f,G){var h=false,t=this;function k(s){var l=t.mBatchQueue[s],o,m,E,i,j;for(j=l.length-1;j>=0;j-=1){if(Array.isArray(l[j])){m=l[j];for(i=m.length-1;i>=0;i-=1){o=m[i];if(o.$cancel&&f(o)){o.$cancel();E=new Error("Request canceled: "+o.method+" "+o.url+"; group: "+s);E.canceled=true;o.$reject(E);m.splice(i,1);h=true;}}}}}if(G){if(this.mBatchQueue[G]){k(G);}}else{for(G in this.mBatchQueue){k(G);}}return h;};
e.prototype.cancelGroupLocks=function(G){this.aLockedGroupLocks.forEach(function(o){if((!G||G===o.getGroupId())&&o.isModifying()&&o.isLocked()){o.cancel();}});};
e.prototype.checkConflictingStrictRequest=function(R,f,h){function j(l,i){return h!==i&&l.some(k);}function k(R){return R.headers["Prefer"]==="handling=strict";}if(k(R)&&f.slice(0,f.iChangeSet+1).some(j)){throw new Error("All requests with strict handling must belong to the same change set");}};
e.prototype.checkForOpenRequests=function(){var t=this;if(Object.keys(this.mRunningChangeRequests).length||Object.keys(this.mBatchQueue).some(function(G){return t.mBatchQueue[G].some(function(R){return Array.isArray(R)?R.length:true;});})||this.aLockedGroupLocks.some(function(G){return G.isLocked();})){throw new Error("Unexpected open requests");}};
e.prototype.checkHeaderNames=function(h){var k;for(k in h){if(this.mReservedHeaders[k.toLowerCase()]){throw new Error("Unsupported header: "+k);}}};
e.prototype.cleanUpChangeSets=function(R){var f,h=false,i;function j(o){if(!m(o)){f.push(o);}}function m(o){if(o.method!=="PATCH"){return false;}return f.some(function(k){if(k.method==="PATCH"&&k.headers["If-Match"]===o.headers["If-Match"]){b.merge(k.body,o.body);o.$resolve(k.$promise);return true;}});}for(i=R.iChangeSet;i>=0;i-=1){f=[];R[i].forEach(j);if(f.length===0){R.splice(i,1);}else if(f.length===1&&this.isChangeSetOptional()){R[i]=f[0];}else{R[i]=f;}h=h||f.length>0;}return h;};
e.prototype.clearSessionContext=function(t){if(t){this.oModelInterface.fireSessionTimeout();}delete this.mHeaders["SAP-ContextId"];if(this.iSessionTimer){clearInterval(this.iSessionTimer);this.iSessionTimer=0;}};
e.prototype.convertExpand=function(E,s){var k,R=[],t=this;if(!E||typeof E!=="object"){throw new Error("$expand must be a valid object");}k=Object.keys(E);if(s){k=k.sort();}k.forEach(function(f){var v=E[f];if(v&&typeof v==="object"){R.push(t.convertExpandOptions(f,v,s));}else{R.push(f);}});return R.join(",");};
e.prototype.convertExpandOptions=function(E,v,s){var f=[];this.doConvertSystemQueryOptions(undefined,v,function(o,O){f.push(o+"="+O);},undefined,s);return f.length?E+"("+f.join(";")+")":E;};
e.prototype.convertQueryOptions=function(m,Q,D,s){var f={};if(!Q){return undefined;}this.doConvertSystemQueryOptions(m,Q,function(k,v){f[k]=v;},D,s);return f;};
e.prototype.convertResourcePath=function(R){return R;};
e.prototype.destroy=function(){this.clearSessionContext();};
e.prototype.doCheckVersionHeader=function(G,R,v){var o=G("OData-Version"),D=!o&&G("DataServiceVersion");if(D){throw new Error("Expected 'OData-Version' header with value '4.0' but received"+" 'DataServiceVersion' header with value '"+D+"' in response for "+this.sServiceUrl+R);}if(o==="4.0"||!o&&v){return;}throw new Error("Expected 'OData-Version' header with value '4.0' but received value '"+o+"' in response for "+this.sServiceUrl+R);};
e.prototype.doConvertResponse=function(R,f){return R;};
e.prototype.doConvertSystemQueryOptions=function(f,Q,R,D,s){var t=this;Object.keys(Q).forEach(function(k){var v=Q[k];if(D&&k[0]==="$"){return;}switch(k){case"$expand":if(v!=="~"){v=t.convertExpand(v,s);}break;case"$select":if(Array.isArray(v)){v=s?v.sort().join(","):v.join(",");}break;default:}R(k,v);});};
e.prototype.fetchTypeForPath=function(m,A){return this.oModelInterface.fetchMetadata(m+(A?"/$Type":"/"));};
e.prototype.formatPropertyAsLiteral=function(v,p){return b.formatLiteral(v,p.$Type);};
e.prototype.getGroupSubmitMode=function(G){return this.oModelInterface.getGroupProperty(G,"submit");};
e.prototype.getModelInterface=function(){return this.oModelInterface;};
e.prototype.getOrCreateBatchQueue=function(G){var f,R=this.mBatchQueue[G];if(!R){f=[];f.iSerialNumber=0;R=this.mBatchQueue[G]=[f];R.iChangeSet=0;if(this.oModelInterface.onCreateGroup){this.oModelInterface.onCreateGroup(G);}}return R;};
e.prototype.getPathAndAddQueryOptions=function(p,o,P){var A=[],n,N={},f,t=this;p=p.slice(1,-5);if(o.$Parameter){o.$Parameter.forEach(function(f){N[f.$Name]=f;});}if(o.$kind==="Function"){for(n in P){f=N[n];if(f){if(f.$isCollection){throw new Error("Unsupported collection-valued parameter: "+n);}A.push(encodeURIComponent(n)+"="+encodeURIComponent(t.formatPropertyAsLiteral(P[n],f)));}}p+="("+A.join(",")+")";}else{for(n in P){if(!(n in N)){delete P[n];}}}return p;};
e.prototype.getSerialNumber=function(){this.iSerialNumber+=1;return this.iSerialNumber;};
e.prototype.getServiceUrl=function(){return this.sServiceUrl;};
e.prototype.hasChanges=function(G,E){var R=this.mBatchQueue[G];if(R){return R.some(function(v){return Array.isArray(v)&&v.some(function(o){return o.headers["If-Match"]===E;});});}return false;};
e.prototype.hasPendingChanges=function(G){var t=this;function f(m){if(!G){return Object.keys(m);}return G in m?[G]:[];}return f(this.mRunningChangeRequests).length>0||this.aLockedGroupLocks.some(function(o){var s=o.getGroupId();return(G===undefined||s===G)&&o.isModifying()&&o.isLocked()&&!s.startsWith("$inactive.");})||f(this.mBatchQueue).some(function(s){return!s.startsWith("$inactive.")&&t.mBatchQueue[s].some(function(R){return Array.isArray(R)&&R.some(function(o){return o.$cancel;});});});};
e.prototype.isActionBodyOptional=function(){return false;};
e.prototype.isChangeSetOptional=function(){return true;};
e.prototype.mergeGetRequests=function(R){var f=[],t=this;function m(o){return o.$queryOptions&&f.some(function(h){if(h.$queryOptions&&o.url===h.url&&o.$owner===h.$owner){b.aggregateExpandSelect(h.$queryOptions,o.$queryOptions);o.$resolve(h.$promise);if(h.$mergeRequests&&o.$mergeRequests){h.$mergeRequests(o.$mergeRequests());}return true;}return false;});}R.forEach(function(o){if(!m(o)){f.push(o);}});f.forEach(function(o){if(o.$queryOptions){o.url=t.addQueryString(o.url,o.$metaPath,o.$queryOptions);}});f.iChangeSet=R.iChangeSet;return f;};
e.prototype.processBatch=function(G){var h,R=this.mBatchQueue[G]||[],t=this;function o(i){if(Array.isArray(i)){i.forEach(o);}else if(i.$submit){i.$submit();}}function f(E,i){if(Array.isArray(i)){i.forEach(f.bind(null,E));}else{i.$reject(E);}}function v(R,j){var k;R.forEach(function(l,m){var E,s,n,p=j[m];if(Array.isArray(p)){v(l,p);}else if(!p){E=new Error("HTTP request was not processed because the previous request failed");E.cause=k;E.$reported=true;l.$reject(E);}else if(p.status>=400){p.getResponseHeader=g;k=b.createError(p,"Communication error",l.url?t.sServiceUrl+l.url:undefined,l.$resourcePath);if(Array.isArray(l)){b.decomposeError(k,l,t.sServiceUrl).forEach(function(E,i){l[i].$reject(E);});}else{l.$reject(k);}}else{if(p.responseText){try{t.doCheckVersionHeader(g.bind(p),l.url,true);n=t.doConvertResponse(JSON.parse(p.responseText),l.$metaPath);}catch(u){l.$reject(u);return;}}else{n=l.method==="GET"?null:{};}t.reportHeaderMessages(l.url,g.call(p,"sap-messages"));s=g.call(p,"ETag");if(s){n["@odata.etag"]=s;}l.$resolve(n);}});}delete this.mBatchQueue[G];o(R);h=this.cleanUpChangeSets(R);if(R.length===0){return Promise.resolve();}R=this.mergeGetRequests(R);this.batchRequestSent(G,R,h);return this.sendBatch(R,G).then(function(i){v(R,i);}).catch(function(E){var i=new Error("HTTP request was not processed because $batch failed");i.cause=E;f(i,R);throw E;}).finally(function(){t.batchResponseReceived(G,R,h);});};
e.prototype.ready=function(){return S.resolve();};
e.prototype.lockGroup=function(G,o,l,m,f){var h;h=new a(G,o,l,m,this.getSerialNumber(),f);if(l){this.aLockedGroupLocks.push(h);}return h;};
e.prototype.processSecurityTokenHandlers=function(){var t=this;this.oSecurityTokenPromise=null;sap.ui.getCore().getConfiguration().getSecurityTokenHandlers().some(function(h){var s=h(t.sServiceUrl);if(s!==undefined){t.oSecurityTokenPromise=s.then(function(H){t.checkHeaderNames(H);Object.assign(t.mHeaders,{"X-CSRF-Token":undefined},H);t.oSecurityTokenPromise=null;}).catch(function(E){L.error("An error occurred within security token handler: "+h,E,C);throw E;});return true;}});};
e.prototype.refreshSecurityToken=function(o){var t=this;if(!this.oSecurityTokenPromise){if(o!==this.mHeaders["X-CSRF-Token"]){return Promise.resolve();}this.oSecurityTokenPromise=new Promise(function(R,f){q.ajax(t.sServiceUrl+t.sQueryParams,{method:"HEAD",headers:Object.assign({},t.mHeaders,{"X-CSRF-Token":"Fetch"})}).then(function(h,i,j){var s=j.getResponseHeader("X-CSRF-Token");if(s){t.mHeaders["X-CSRF-Token"]=s;}else{delete t.mHeaders["X-CSRF-Token"];}t.oSecurityTokenPromise=null;R();},function(j){t.oSecurityTokenPromise=null;f(b.createError(j,"Could not refresh security token"));});});}return this.oSecurityTokenPromise;};
e.prototype.relocate=function(s,o,n){var R=this.mBatchQueue[s],t=this,f=R&&R[0].some(function(h,i){if(h.body===o){t.addChangeToGroup(h,n);R[0].splice(i,1);return true;}});if(!f){throw new Error("Request not found in group '"+s+"'");}};
e.prototype.relocateAll=function(s,n,E){var j=0,R=this.mBatchQueue[s],t=this;if(R){R[0].slice().forEach(function(o){if(!E||o.headers["If-Match"]===E){t.addChangeToGroup(o,n);R[0].splice(j,1);}else{j+=1;}});}};
e.prototype.removePatch=function(p){var f=this.cancelChangesByFilter(function(o){return o.$promise===p;});if(!f){throw new Error("Cannot reset the changes, the batch request is running");}};
e.prototype.removePost=function(G,E){var o=b.getPrivateAnnotation(E,"postBody"),f=this.cancelChangesByFilter(function(h){return h.body===o;},G);if(!f){throw new Error("Cannot reset the changes, the batch request is running");}};
e.prototype.reportHeaderMessages=function(R,m){if(m){this.oModelInterface.reportTransitionMessages(JSON.parse(m),R);}};
e.prototype.request=function(m,R,G,h,p,s,f,M,o,A,Q,O,i){var j,E,k=G&&G.getGroupId()||"$direct",P,l=Infinity,n,t=this;if(k==="$cached"){E=new Error("Unexpected request: "+m+" "+R);E.$cached=true;throw E;}if(G&&G.isCanceled()){if(f){f();}E=new Error("Request already canceled");E.canceled=true;return Promise.reject(E);}if(G){G.unlock();l=G.getSerialNumber();}R=this.convertResourcePath(R);o=o||R;if(this.getGroupSubmitMode(k)!=="Direct"){P=new Promise(function(u,v){var w=t.getOrCreateBatchQueue(k);n={method:m,url:R,headers:Object.assign({},t.mPredefinedPartHeaders,t.mHeaders,h,t.mFinalHeaders),body:p,$cancel:f,$mergeRequests:i,$metaPath:M,$owner:O,$queryOptions:Q,$reject:v,$resolve:u,$resourcePath:o,$submit:s};if(m==="GET"){w.push(n);}else if(A){w[0].unshift(n);}else{j=w.iChangeSet;while(w[j].iSerialNumber>l){j-=1;}t.checkConflictingStrictRequest(n,w,j);w[j].push(n);}});n.$promise=P;return P;}if(this.vStatistics!==undefined){Q=Object.assign({"sap-statistics":this.vStatistics},Q);}if(Q){R=t.addQueryString(R,M,Q);}if(s){s();}return this.sendRequest(m,R,Object.assign({},h,this.mFinalHeaders),JSON.stringify(p),o).then(function(u){t.reportHeaderMessages(u.resourcePath,u.messages);return t.doConvertResponse(u.body,M);});};
e.prototype.sendBatch=function(R,G){var o=_.serializeBatchRequest(R,this.getGroupSubmitMode(G)==="Auto"?"Group ID: "+G:"Group ID (API): "+G);return this.sendRequest("POST","$batch"+this.sQueryParams,Object.assign(o.headers,B),o.body).then(function(f){if(f.messages!==null){throw new Error("Unexpected 'sap-messages' response header for batch request");}return _.deserializeBatchResponse(f.contentType,f.body);});};
e.prototype.sendRequest=function(m,R,h,p,o){var s=this.sServiceUrl+R,t=this;return new Promise(function(f,i){function j(I){var O=t.mHeaders["X-CSRF-Token"];return q.ajax(s,{contentType:h&&h["Content-Type"],data:p,headers:Object.assign({},t.mPredefinedRequestHeaders,t.mHeaders,b.resolveIfMatchHeader(h)),method:m}).then(function(v,k,l){var E=l.getResponseHeader("ETag"),n=l.getResponseHeader("X-CSRF-Token");try{t.doCheckVersionHeader(l.getResponseHeader,R,!v);}catch(u){i(u);return;}if(n){t.mHeaders["X-CSRF-Token"]=n;}t.setSessionContext(l.getResponseHeader("SAP-ContextId"),l.getResponseHeader("SAP-Http-Session-Timeout"));if(!v){v=m==="GET"?null:{};}if(E&&typeof v==="object"){v["@odata.etag"]=E;}f({body:v,contentType:l.getResponseHeader("Content-Type"),messages:l.getResponseHeader("sap-messages"),resourcePath:R});},function(k){var l=k.getResponseHeader("SAP-ContextId"),n=k.getResponseHeader("X-CSRF-Token"),M;if(!I&&k.status===403&&n&&n.toLowerCase()==="required"){t.refreshSecurityToken(O).then(function(){j(true);},i);}else{M="Communication error";if(l){t.setSessionContext(l,k.getResponseHeader("SAP-Http-Session-Timeout"));}else if(t.mHeaders["SAP-ContextId"]){M="Session not found on server";L.error(M,undefined,C);t.clearSessionContext(true);}i(b.createError(k,M,s,o));}});}if(t.oSecurityTokenPromise&&m!=="GET"){t.oSecurityTokenPromise.then(j);}else{j();}});};
e.prototype.setSessionContext=function(s,f){var t=d.test(f)?parseInt(f):0,i=Date.now()+30*60*1000,h=this;this.clearSessionContext();if(s){h.mHeaders["SAP-ContextId"]=s;if(t>=60){this.iSessionTimer=setInterval(function(){if(Date.now()>=i){h.clearSessionContext(true);}else{q.ajax(h.sServiceUrl+h.sQueryParams,{method:"HEAD",headers:{"SAP-ContextId":h.mHeaders["SAP-ContextId"]}}).fail(function(j){if(j.getResponseHeader("SAP-Err-Id")==="ICMENOSESSION"){L.error("Session not found on server",undefined,C);h.clearSessionContext(true);}});}},(t-5)*1000);}else if(f!==null){L.warning("Unsupported SAP-Http-Session-Timeout header",f,C);}}};
e.prototype.submitBatch=function(G){var f,p,t=this;p=S.all(this.aLockedGroupLocks.map(function(o){return o.waitFor(G);}));f=p.isPending();if(f){L.info("submitBatch('"+G+"') is waiting for locks",null,C);}return p.then(function(){if(f){L.info("submitBatch('"+G+"') continues",null,C);}t.aLockedGroupLocks=t.aLockedGroupLocks.filter(function(o){return o.isLocked();});return t.processBatch(G);});};
e.prototype.waitForRunningChangeRequests=function(G){var p=this.mRunningChangeRequests[G];if(p){return p.length>1?S.all(p):p[0];}return S.resolve();};
e.create=function(s,m,h,Q,o){var R=new e(s,h,Q,m);if(o==="2.0"){c(R);}return R;};
return e;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_V2MetadataConverter',["./_Helper","./_MetadataConverter","sap/base/Log"],function(_,a,L){"use strict";var c="sap.ui.model.odata.v4.lib._V2MetadataConverter",r=/^(?:DELETE|GET|MERGE|PATCH|POST|PUT)$/,e="http://schemas.microsoft.com/ado/2007/06/edmx",m="http://schemas.microsoft.com/ado/2007/08/dataservices/metadata",s="http://www.sap.com/Protocols/SAPData",v={creatable:{property:"Insertable",term:"@Org.OData.Capabilities.V1.InsertRestrictions"},deletable:{property:"Deletable",term:"@Org.OData.Capabilities.V1.DeleteRestrictions"},"deletable-path":{property:"Deletable",term:"@Org.OData.Capabilities.V1.DeleteRestrictions"},"field-control":{term:"@com.sap.vocabularies.Common.v1.FieldControl"},heading:{term:"@com.sap.vocabularies.Common.v1.Heading"},label:{term:"@com.sap.vocabularies.Common.v1.Label"},precision:{term:"@Org.OData.Measures.V1.Scale"},quickinfo:{term:"@com.sap.vocabularies.Common.v1.QuickInfo"},"requires-filter":{property:"RequiresFilter",term:"@Org.OData.Capabilities.V1.FilterRestrictions"},searchable:{property:"Searchable",term:"@Org.OData.Capabilities.V1.SearchRestrictions"},text:{term:"@com.sap.vocabularies.Common.v1.Text"},topable:{term:"@Org.OData.Capabilities.V1.TopSupported"},updatable:{property:"Updatable",term:"@Org.OData.Capabilities.V1.UpdateRestrictions"},"updatable-path":{property:"Updatable",term:"@Org.OData.Capabilities.V1.UpdateRestrictions"}},V={bday:{TermName:"Contact"},city:{Path:"adr",TermName:"Contact",V4Attribute:"locality"},country:{Path:"adr",TermName:"Contact"},email:{Path:"address",TermName:"Contact",V4Attribute:"uri",typeMapping:{home:"home",pref:"preferred",work:"work"},v4EnumType:"com.sap.vocabularies.Communication.v1.ContactInformationType",v4PropertyAnnotation:"@com.sap.vocabularies.Communication.v1.IsEmailAddress"},familyname:{Path:"n",TermName:"Contact",V4Attribute:"surname"},givenname:{Path:"n",TermName:"Contact",V4Attribute:"given"},honorific:{Path:"n",TermName:"Contact",V4Attribute:"prefix"},middlename:{Path:"n",TermName:"Contact",V4Attribute:"additional"},name:{TermName:"Contact",V4Attribute:"fn"},nickname:{TermName:"Contact"},note:{TermName:"Contact"},org:{TermName:"Contact"},"org-role":{TermName:"Contact",V4Attribute:"role"},"org-unit":{TermName:"Contact",V4Attribute:"orgunit"},photo:{TermName:"Contact"},pobox:{Path:"adr",TermName:"Contact"},region:{Path:"adr",TermName:"Contact"},street:{Path:"adr",TermName:"Contact"},suffix:{Path:"n",TermName:"Contact"},tel:{Path:"tel",TermName:"Contact",V4Attribute:"uri",typeMapping:{cell:"cell",fax:"fax",home:"home",pref:"preferred",video:"video",voice:"voice",work:"work"},v4EnumType:"com.sap.vocabularies.Communication.v1.PhoneType",v4PropertyAnnotation:"@com.sap.vocabularies.Communication.v1.IsPhoneNumber"},title:{TermName:"Contact"},zip:{Path:"adr",TermName:"Contact",V4Attribute:"code"},class:{TermName:"Event"},dtend:{TermName:"Event"},dtstart:{TermName:"Event"},duration:{TermName:"Event"},fbtype:{TermName:"Event"},location:{TermName:"Event"},status:{TermName:"Event"},transp:{TermName:"Event"},wholeday:{TermName:"Event"},body:{TermName:"Message"},from:{TermName:"Message"},received:{TermName:"Message"},sender:{TermName:"Message"},subject:{TermName:"Message"},completed:{TermName:"Task"},due:{TermName:"Task"},"percent-complete":{TermName:"Task",V4Attribute:"percentcomplete"},priority:{TermName:"Task"}},b={fiscalyear:"@com.sap.vocabularies.Common.v1.IsFiscalYear",fiscalyearperiod:"@com.sap.vocabularies.Common.v1.IsFiscalYearPeriod",year:"@com.sap.vocabularies.Common.v1.IsCalendarYear",yearmonth:"@com.sap.vocabularies.Common.v1.IsCalendarYearMonth",yearmonthday:"@com.sap.vocabularies.Common.v1.IsCalendarDate",yearquarter:"@com.sap.vocabularies.Common.v1.IsCalendarYearQuarter",yearweek:"@com.sap.vocabularies.Common.v1.IsCalendarYearWeek",url:"@Org.OData.Core.V1.IsURL"};
function A(C,t){var p=C.oAnnotatable;if(p){t=_.buildPath(p.sPath,t);}this.oConverter=C;this.sPath=t;this.oParent=p;this.mSapAttributes=C.mSapAttributes;this.mAnnotationsForTarget=null;}
A.prototype.annotate=function(t,g){this.getTarget()[t]=g;};
A.prototype.consume=function(n){return this.oConverter.consumeSapAnnotation(n);};
A.prototype.convert=function(g,h){var o,i;if(h===undefined||h===""){return;}i=v[g];if(i.property){o=this.getOrCreateAnnotationRecord(i.term);o[i.property]=h;}else{this.annotate(i.term,h);}};
A.prototype.getOrCreateAnnotationRecord=function(t){return this.oConverter.getOrCreateObject(this.getTarget(),t);};
A.prototype.getTarget=function(){if(!this.mAnnotationsForTarget){this.mAnnotationsForTarget=this.oConverter.convertedV2Annotations[this.sPath]={};}return this.mAnnotationsForTarget;};
A.prototype.peek=function(n){return this.oConverter.mSapAnnotations[n];};
function d(){this.association=null;this.associations={};this.associationSet=null;this.associationSets=[];this.aBoundOperations=[];this.constraintRole=null;this.convertedV2Annotations={};this.defaultEntityContainer=null;this.mEntityContainersOfSchema={};this.mEntityType2EntitySetAnnotation={};this.mProperty2Semantics={};this.sPropertyName=null;this.navigationProperties=[];this.mSapAnnotations={};this.sTypeName=null;this.mProperty2Unit={};a.call(this);}
d.prototype=Object.create(a.prototype);
d.prototype.collectSapAnnotations=function(E){var o,g=E.attributes,i,n;this.mSapAnnotations={};for(i=0,n=g.length;i<n;i+=1){o=g.item(i);if(o.namespaceURI===s&&o.localName!=="content-version"){this.mSapAnnotations[o.localName]=o.value;}}};
d.prototype.consumeSapAnnotation=function(n){var g=this.mSapAnnotations[n];delete this.mSapAnnotations[n];return g;};
d.prototype.convertEntitySetAnnotation=function(o,n){var C,g;switch(n){case"creatable":case"deletable":case"updatable":if(o.peek(n)==="false"){o.convert(n,false);}break;case"deletable-path":case"updatable-path":C=n.slice(0,9);g=o.consume(n);if(o.peek(C)){o.convert(n,false);L.warning("Inconsistent metadata in '"+this.url+"'","Use either 'sap:"+C+"' or 'sap:"+C+"-path'"+" at entity set '"+o.sPath+"'",c);}else{o.convert(n,{$Path:g});}break;case"label":this.convertLabel(o);break;case"pageable":g=o.consume(n);if(g==="false"){o.annotate("@Org.OData.Capabilities.V1.SkipSupported",false);o.annotate("@Org.OData.Capabilities.V1.TopSupported",false);}break;case"requires-filter":g=o.consume(n);if(g==="true"){o.convert(n,true);}break;case"topable":g=o.consume(n);if(g==="false"){o.convert(n,false);}break;default:}};
d.prototype.convertLabel=function(o){o.convert("label",o.consume("label"));};
d.prototype.convertPropertyAnnotation=function(o,n){var g;switch(n){case"heading":case"label":case"quickinfo":o.convert(n,o.consume(n));break;case"field-control":case"precision":case"text":o.convert(n,{$Path:o.consume(n)});break;case"aggregation-role":g=o.consume(n);if(g==="dimension"){o.annotate("@com.sap.vocabularies.Analytics.v1.Dimension",true);}else if(g==="measure"){o.annotate("@com.sap.vocabularies.Analytics.v1.Measure",true);}break;case"display-format":g=o.consume(n);if(g==="NonNegative"){o.annotate("@com.sap.vocabularies.Common.v1.IsDigitSequence",true);}else if(g==="UpperCase"){o.annotate("@com.sap.vocabularies.Common.v1.IsUpperCase",true);}break;case"semantics":this.convertPropertySemanticsAnnotation(o);break;case"unit":this.mProperty2Unit[o.sPath]=o.consume("unit");break;case"visible":g=o.consume(n);if(g==="false"){o.annotate("@com.sap.vocabularies.UI.v1.Hidden",true);o.annotate("@com.sap.vocabularies.Common.v1.FieldControl",{$EnumMember:"com.sap.vocabularies.Common.v1.FieldControlType/Hidden"});}break;default:}};
d.prototype.convertPropertySemanticsAnnotation=function(o){var g,E,p,R,S,h=o.peek("semantics").split(";"),i=h[0],j=V[i];if(i==="unit-of-measure"||i==="currency-code"){this.mProperty2Semantics[o.sPath]=o.consume("semantics");}else if(b[i]){o.annotate(b[i],true);o.consume("semantics");}else if(j){p={$Path:this.sPropertyName};g=o.oParent.getOrCreateAnnotationRecord("@com.sap.vocabularies.Communication.v1."+j.TermName);if(j.Path){S=this.getOrCreateObject(g,j.Path);S[j.V4Attribute||i]=p;if(j.v4PropertyAnnotation){o.annotate(j.v4PropertyAnnotation,true);if(h[1]){R=[];E=h[1].split("=")[1];E.split(",").forEach(function(t){var T=j.typeMapping[t];if(T){R.push(j.v4EnumType+"/"+T);}else{L.warning("Unsupported semantic type: "+t,undefined,c);}});if(R.length>0){S.type={EnumMember:R.join(" ")};}}g[j.Path]=[S];}else{g[j.Path]=S;}}else{g[j.V4Attribute||i]=p;}o.consume("semantics");}};
d.prototype.finalize=function(){this.result.$Version="4.0";this.setDefaultEntityContainer();this.updateNavigationPropertiesAndCreateBindings();this.processBoundOperations();this.processUnitConversion();};
d.prototype.mergeAnnotations=function(C,g){var h;for(h in C){if(h in g){g[h]=Object.assign(C[h],g[h]);}else{g[h]=C[h];}}};
d.prototype.postProcessSchema=function(g,h){var i,E,j,o,k,t;for(j in this.mEntityContainersOfSchema){E=this.mEntityContainersOfSchema[j];for(k in E){o=E[k];if(o.$kind!=="EntitySet"){continue;}t=j+"/"+k;i=_.merge(this.convertedV2Annotations[t]||{},this.mEntityType2EntitySetAnnotation[o.$Type]);if(Object.keys(i).length){this.convertedV2Annotations[t]=i;}}}if(this.schema.$Annotations){this.mergeAnnotations(this.convertedV2Annotations,this.schema.$Annotations);}else if(Object.keys(this.convertedV2Annotations).length>0){this.schema.$Annotations=this.convertedV2Annotations;}this.convertedV2Annotations={};this.mEntityContainersOfSchema={};};
d.prototype.processAssociation=function(E){var n=this.namespace+E.getAttribute("Name");this.associations[n]=this.association={referentialConstraint:null,roles:{}};};
d.prototype.processAssociationEnd=function(E){var n=E.getAttribute("Role");this.association.roles[n]={multiplicity:E.getAttribute("Multiplicity"),propertyName:undefined,typeName:this.resolveAlias(E.getAttribute("Type"))};};
d.prototype.processAssociationSet=function(E){var o={associationName:this.resolveAlias(E.getAttribute("Association")),ends:[],entityContainer:this.entityContainer};this.associationSet=o;this.associationSets.push(o);this.consumeSapAnnotation("creatable");this.consumeSapAnnotation("deletable");this.consumeSapAnnotation("updatable");};
d.prototype.processAssociationSetEnd=function(E){this.associationSet.ends.push({entitySetName:E.getAttribute("EntitySet"),roleName:E.getAttribute("Role")});};
d.prototype.processComplexType=function(E){this.processType(E,{$kind:"ComplexType"});};
d.prototype.processDataServices=function(E){if(E.getAttributeNS(m,"DataServiceVersion")!=="2.0"){throw new Error(this.url+": expected DataServiceVersion=\"2.0\": "+f(E));}};
d.prototype.processDependent=function(E){var C=this.association.referentialConstraint;this.constraintRole=C.dependent={roleName:E.getAttribute("Role")};};
d.prototype.processElement=function(E,p){this.collectSapAnnotations(E);if(p){p.call(this,E);}this.warnUnsupportedSapAnnotations(E);};
d.prototype.processEntityContainer=function(E){var q=this.namespace+E.getAttribute("Name");this.mEntityContainersOfSchema[q]=this.entityContainer={$kind:"EntityContainer"};this.addToResult(q,this.entityContainer);if(E.getAttributeNS(m,"IsDefaultEntityContainer")==="true"){this.defaultEntityContainer=q;}this.v2annotatable(q);};
d.prototype.processEntitySet=function(E){var o,n=E.getAttribute("Name");this.entityContainer[n]=this.entitySet={$kind:"EntitySet",$Type:this.resolveAlias(E.getAttribute("EntityType"))};o=this.v2annotatable(n,this.convertEntitySetAnnotation);o.consume("creatable");o.consume("deletable");o.consume("updatable");if(o.consume("searchable")!=="true"){o.convert("searchable",false);}};
d.prototype.processEntityType=function(E){var t={$kind:"EntityType"},g=this;this.processType(E,t);this.processAttributes(E,t,{Abstract:this.setIfTrue,BaseType:function(T){return T?g.resolveAlias(T):undefined;}});this.convertLabel(this.oAnnotatable);};
d.prototype.processEntityTypeKeyPropertyRef=function(E){var n=E.getAttribute("Name");this.getOrCreateArray(this.type,"$Key").push(n);};
d.prototype.processFacetAttributes=function(E,R){var t=this;this.processAttributes(E,R,{DefaultValue:this.setValue,MaxLength:function(g){return g==="Max"?undefined:t.setNumber(g);},Nullable:this.setIfFalse,Precision:this.setNumber,Scale:this.setNumber,Unicode:this.setIfFalse});if(E.getAttribute("FixedLength")==="false"){R.$Scale="variable";}};
d.prototype.processFunctionImport=function(E){var g,h=E.getAttributeNS(m,"HttpMethod"),k=h!=="GET"?"Action":"Function",l,n=E.getAttribute("Name"),o={$kind:k},O={$kind:k+"Import"},q=this.namespace+n,R=E.getAttribute("ReturnType"),i;O["$"+k]=q;this.processAttributes(E,O,{EntitySet:this.setValue});if(R){o.$ReturnType=i={};this.processTypedCollection(R,i);}if(!r.test(h)){L.warning("Unsupported HttpMethod at FunctionImport '"+n+"', removing this FunctionImport",undefined,c);this.consumeSapAnnotation("action-for");this.consumeSapAnnotation("applicable-path");}else{if(h!=="GET"&&h!=="POST"){o.$v2HttpMethod=h;}this.addToResult(q,[o]);g=this.consumeSapAnnotation("action-for");if(g){o.$IsBound=true;o.$Parameter=[{$Name:null,$Nullable:false,$Type:this.resolveAlias(g)}];this.aBoundOperations.push(o);this.consumeSapAnnotation("applicable-path");l=this.consumeSapAnnotation("label");if(l){o[v["label"].term]=l;}}else{this.entityContainer[n]=O;this.v2annotatable(n);this.convertLabel(this.oAnnotatable);}}this.oOperation=o;};
d.prototype.processParameter=function(E){var l,o=this.oOperation,p={$Name:E.getAttribute("Name")};this.processFacetAttributes(E,p);this.processTypedCollection(E.getAttribute("Type"),p);this.getOrCreateArray(o,"$Parameter").push(p);l=this.consumeSapAnnotation("label");if(l){p[v["label"].term]=l;}};
d.prototype.processPrincipal=function(E){var C=this.association.referentialConstraint;this.constraintRole=C.principal={roleName:E.getAttribute("Role")};};
d.prototype.processReferentialConstraint=function(g){this.association.referentialConstraint={};};
d.prototype.processReferentialConstraintPropertyRef=function(E){this.constraintRole.propertyRef=E.getAttribute("Name");};
d.prototype.processSchema=function(E){var S=this.consumeSapAnnotation("schema-version");this.namespace=E.getAttribute("Namespace")+".";this.schema={$kind:"Schema"};this.addToResult(this.namespace,this.schema);if(S){this.schema["@Org.Odata.Core.V1.SchemaVersion"]=S;}};
d.prototype.processType=function(E,t){var q=this.namespace+E.getAttribute("Name");this.sTypeName=q;this.type=t;this.addToResult(q,t);this.v2annotatable(q);};
d.prototype.processTypedCollection=function(t,p){var M=this.rCollection.exec(t);if(M){p.$isCollection=true;t=M[1];}if(!t.includes(".")){t="Edm."+t;}switch(t){case"Edm.DateTime":p.$v2Type=t;if(this.mSapAnnotations["display-format"]==="Date"){t="Edm.Date";delete p.$Precision;}else{t="Edm.DateTimeOffset";}break;case"Edm.Float":p.$v2Type=t;t="Edm.Single";break;case"Edm.Time":p.$v2Type=t;t="Edm.TimeOfDay";break;default:t=this.resolveAlias(t);}p.$Type=t;};
d.prototype.processTypeNavigationProperty=function(E){var C=this.consumeSapAnnotation("creatable"),g=this.consumeSapAnnotation("creatable-path"),F=this.consumeSapAnnotation("filterable"),o,h,n=E.getAttribute("Name"),N,p={$kind:"NavigationProperty"},t=this;function i(T,P,j){h=t.getOrCreateObject(t.mEntityType2EntitySetAnnotation,t.sTypeName);h=t.getOrCreateObject(h,T);h=t.getOrCreateArray(h,P);h.push(j);}this.type[n]=p;this.navigationProperties.push({associationName:this.resolveAlias(E.getAttribute("Relationship")),fromRoleName:E.getAttribute("FromRole"),property:p,propertyName:n,toRoleName:E.getAttribute("ToRole")});this.v2annotatable(n);if(C){N={$NavigationPropertyPath:n};if(g){L.warning("Inconsistent metadata in '"+this.url+"'","Use either 'sap:creatable' or 'sap:creatable-path' at navigation property '"+this.oAnnotatable.sPath+"'",c);}else if(C==="true"){N=null;}}else if(g){N={$If:[{$Not:{$Path:g}},{$NavigationPropertyPath:n}]};}if(N){i("@Org.OData.Capabilities.V1.InsertRestrictions","NonInsertableNavigationProperties",N);}if(F==="false"){o={NavigationProperty:{$NavigationPropertyPath:n},FilterRestrictions:{Filterable:false}};i("@Org.OData.Capabilities.V1.NavigationRestrictions","RestrictedProperties",o);}};
d.prototype.processTypeProperty=function(E){var o,g,F,h,n=E.getAttribute("Name"),p={$kind:"Property"},t=this;function i(T,P,j){if(t.type.$kind==="EntityType"){h=t.getOrCreateObject(t.mEntityType2EntitySetAnnotation,t.sTypeName);h=t.getOrCreateObject(h,T);h=t.getOrCreateArray(h,P);h.push({$PropertyPath:n});}else{L.warning("Unsupported SAP annotation at a complex type in '"+t.url+"'","sap:"+j+" at property '"+o.sPath+"'",c);}}this.sPropertyName=n;this.type[n]=p;this.processFacetAttributes(E,p);this.processTypedCollection(E.getAttribute("Type"),p);o=this.v2annotatable(n,this.convertPropertyAnnotation);if(o.consume("updatable")==="false"){if(o.consume("creatable")==="false"){o.annotate("@Org.OData.Core.V1.Computed",true);}else{o.annotate("@Org.OData.Core.V1.Immutable",true);}}if(o.consume("filterable")==="false"){i("@Org.OData.Capabilities.V1.FilterRestrictions","NonFilterableProperties","filterable");}F=o.consume("filter-restriction");if(F){switch(F){case"interval":g="SingleInterval";break;case"multi-value":g="MultiValue";break;case"single-value":g="SingleValue";break;default:L.warning("Inconsistent metadata in '"+this.url+"'","Unsupported sap:filter-restriction=\""+F+"\" at property '"+o.sPath+"'",c);}if(g){if(this.type.$kind==="EntityType"){h=this.getOrCreateObject(this.mEntityType2EntitySetAnnotation,this.sTypeName);h=this.getOrCreateArray(h,"@com.sap.vocabularies.Common.v1.FilterExpressionRestrictions");h.push({AllowedExpressions:{EnumMember:"com.sap.vocabularies.Common.v1.FilterExpressionType/"+g},Property:{$PropertyPath:n}});}else{L.warning("Unsupported SAP annotation at a complex type in '"+this.url+"'","sap:filter-restriction at property '"+o.sPath+"'",c);}}}if(o.consume("required-in-filter")==="true"){i("@Org.OData.Capabilities.V1.FilterRestrictions","RequiredProperties","required-in-filter");}if(o.consume("sortable")==="false"){i("@Org.OData.Capabilities.V1.SortRestrictions","NonSortableProperties","sortable");}};
d.prototype.processBoundOperations=function(){var t=this;this.aBoundOperations.forEach(function(o){var E=t.result[o.$Parameter[0].$Type];E.$Key.forEach(function(k){o.$Parameter.some(function(p,i){if(p.$Name===k){o.$Parameter.splice(i,1);return true;}});});});};
d.prototype.processUnitConversion=function(){var t=this;Object.keys(this.mProperty2Unit).forEach(function(p){var h,T,g=p.split("/")[0],u,U=t.mProperty2Unit[p],j=U.split("/"),o,k,i,n=j.length;for(i=0;i<n;i+=1){T=t.result[g];o=T[j[i]];if(!o){L.warning("Path '"+U+"' for sap:unit cannot be resolved",p,c);return;}if(i<n-1){g=o.$Type;}}k=t.mProperty2Semantics[g+"/"+j[n-1]];if(!k){L.warning("Unsupported sap:semantics at sap:unit='"+U+"'; expected 'currency-code' or 'unit-of-measure'",p,c);return;}u=k==="currency-code"?"ISOCurrency":"Unit";u="@Org.OData.Measures.V1."+u;h=t.getOrCreateObject(t.result[_.namespace(p)+"."],"$Annotations");h=t.getOrCreateObject(h,p);if(!(u in h)){h[u]={$Path:U};}});};
function f(E){var o,g=E.attributes,t="<"+E.nodeName,i,n;for(i=0,n=g.length;i<n;i+=1){o=g.item(i);t+=" "+o.name+'="'+o.value+'"';}return t+(E.childNodes.length?">":"/>");}
d.prototype.setDefaultEntityContainer=function(){var D=this.defaultEntityContainer,E,R=this.result;if(D){R.$EntityContainer=D;}else{E=Object.keys(R).filter(function(q){return R[q].$kind==="EntityContainer";});if(E.length===1){R.$EntityContainer=E[0];}}};
d.prototype.updateNavigationPropertiesAndCreateBindings=function(){var t=this;this.navigationProperties.forEach(function(n){var o=t.associations[n.associationName],C=o.referentialConstraint,N=n.property,T=o.roles[n.toRoleName];N.$Type=T.typeName;T.propertyName=n.propertyName;if(T.multiplicity==="1"){N.$Nullable=false;}if(T.multiplicity==="*"){N.$isCollection=true;}if(C&&C.principal.roleName===n.toRoleName){N.$ReferentialConstraint={};N.$ReferentialConstraint[C.dependent.propertyRef]=C.principal.propertyRef;}});this.associationSets.forEach(function(o){var g=t.associations[o.associationName],E=o.entityContainer;function h(i,j){var k=E[i.entitySetName],T=g.roles[j.roleName];if(T.propertyName){k.$NavigationPropertyBinding=k.$NavigationPropertyBinding||{};k.$NavigationPropertyBinding[T.propertyName]=j.entitySetName;}}h(o.ends[0],o.ends[1]);h(o.ends[1],o.ends[0]);});};
d.prototype.v2annotatable=function(n,p){var o=new A(this,n);this.oAnnotatable=o;if(p){p=p.bind(this);Object.keys(this.mSapAnnotations).forEach(function(n){p(o,n);});}return o;};
d.prototype.warnUnsupportedSapAnnotations=function(E){Object.keys(this.mSapAnnotations).forEach(function(n){L.warning("Unsupported annotation 'sap:"+n+"'",f(E),c);});};
(function($){var S;$.sRootNamespace=e;$.oAliasConfig={Reference:{__xmlns:a.sEdmxNamespace,Include:{__processor:$.processAlias}},DataServices:{Schema:{__processor:$.processAlias}}};S={NavigationProperty:{__processor:$.processTypeNavigationProperty},Property:{__processor:$.processTypeProperty}};$.oFullConfig={__include:[$.oReferenceInclude],DataServices:{__processor:$.processDataServices,Schema:{__postProcessor:$.postProcessSchema,__processor:$.processSchema,__include:[$.oAnnotationsConfig],Association:{__processor:$.processAssociation,End:{__processor:$.processAssociationEnd},ReferentialConstraint:{__processor:$.processReferentialConstraint,Dependent:{__processor:$.processDependent,PropertyRef:{__processor:$.processReferentialConstraintPropertyRef}},Principal:{__processor:$.processPrincipal,PropertyRef:{__processor:$.processReferentialConstraintPropertyRef}}}},ComplexType:{__processor:$.processComplexType,__include:[S]},EntityContainer:{__processor:$.processEntityContainer,AssociationSet:{__processor:$.processAssociationSet,End:{__processor:$.processAssociationSetEnd}},EntitySet:{__processor:$.processEntitySet},FunctionImport:{__processor:$.processFunctionImport,Parameter:{__processor:$.processParameter}}},EntityType:{__processor:$.processEntityType,__include:[S],Key:{PropertyRef:{__processor:$.processEntityTypeKeyPropertyRef}}}}}};})(d.prototype);return d;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_V2Requestor',["./_Helper","./_Parser","sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/odata/ODataUtils"],function(_,a,C,D,O){"use strict";var r=/^\/Date\((-?\d+)\)\/$/,d,b=/^\/Date\((-?\d+)(?:([-+])(\d\d)(\d\d))?\)\/$/,o,p={},c=/\+/g,e=/^([^(]+)(\(.+\))$/,f=/\//g,g=/^PT(?:(?:(\d+)H)?(?:(\d+)M)?(?:(\d+)(\.\d+)?S)?)$/i,t;
function h(){}
h.prototype.mFinalHeaders={"Content-Type":"application/json;charset=UTF-8"};h.prototype.mPredefinedPartHeaders={Accept:"application/json"};h.prototype.mPredefinedRequestHeaders={Accept:"application/json",MaxDataServiceVersion:"2.0",DataServiceVersion:"2.0","X-CSRF-Token":"Fetch"};h.prototype.mReservedHeaders={accept:true,"content-id":true,"content-transfer-encoding":true,"content-type":true,dataserviceversion:true,"if-match":true,"if-none-match":true,maxdataserviceversion:true,"sap-contextid":true,"x-http-method":true};
h.prototype.convertBinary=function(v){return v.replace(c,"-").replace(f,"_");};
h.prototype.convertDate=function(v){var j,m=r.exec(v);if(!m){throw new Error("Not a valid Edm.DateTime value '"+v+"'");}j=new Date(parseInt(m[1]));if(Number(m[1]%(24*60*60*1000))!==0){throw new Error("Cannot convert Edm.DateTime value '"+v+"' to Edm.Date because it contains a time of day");}return d.format(j);};
h.prototype.convertDateTimeOffset=function(v,P){var m=b.exec(v),s,j,k,l,n="yyyy-MM-dd'T'HH:mm:ss",q=P.$Precision,T;if(!m){throw new Error("Not a valid Edm.DateTimeOffset value '"+v+"'");}T=parseInt(m[1]);j=parseInt(m[3]);k=parseInt(m[4]);if(!m[2]||j===0&&k===0){s="Z";}else{l=m[2]==="-"?-1:1;T+=l*(j*60*60*1000+k*60*1000);s=m[2]+m[3]+":"+m[4];}if(q>0){n+="."+"".padEnd(q,"S");}if(!p[n]){p[n]=D.getDateTimeInstance({calendarType:C.Gregorian,pattern:n,UTC:true});}return p[n].format(new Date(T))+s;};
h.prototype.convertDoubleSingle=function(v){switch(v){case"NaN":case"INF":case"-INF":return v;default:return parseFloat(v);}};
h.prototype.convertFilter=function(F,m){var j=a.parseFilter(F),k=this;function l(L,s){var M,T=q(s);if(T.$Type!=="Edm.String"){M=_.parseLiteral(L.value,T.$Type,T.path);L.value=k.formatPropertyAsLiteral(M,T);}}function n(N,M){throw new Error("Cannot convert filter to V2, "+M+" at "+N.at+": "+F);}function q(N){var P;if(N.type){return{$Type:N.type};}if(N.id==="PATH"){P=k.oModelInterface.fetchMetadata(m+"/"+N.value).getResult();if(!P){throw new Error("Invalid filter path: "+N.value);}return{path:N.value,$Type:P.$Type,$v2Type:P.$v2Type};}return q(N.parameters[0]);}function v(N){if(N){if(N.id==="VALUE"&&N.ambiguous){n(N,"ambiguous type for the literal");}v(N.left);v(N.right);if(N.parameters){if(N.value==="contains"){N.value="substringof";N.parameters.push(N.parameters.shift());}N.parameters.forEach(v);}if(N.left&&N.right){if(N.left.id==="VALUE"){if(N.right.id==="VALUE"){n(N,"saw literals on both sides of '"+N.id+"'");}l(N.left,N.right);}else if(N.right.id==="VALUE"){l(N.right,N.left);}}}}v(j);return a.buildFilterString(j);};
h.prototype.convertKeyPredicate=function(v,P){var E=this.fetchTypeForPath(_.getMetaPath(P)).getResult(),k=a.parseKeyPredicate(decodeURIComponent(v)),j=this;function l(s,V){var m=E[s];if(m.$Type!=="Edm.String"){V=j.formatPropertyAsLiteral(_.parseLiteral(V,m.$Type,P),m);}return encodeURIComponent(V);}if(""in k){return"("+l(E.$Key[0],k[""])+")";}return"("+E.$Key.map(function(s){return encodeURIComponent(s)+"="+l(s,k[s]);}).join(",")+")";};
h.prototype.convertResourcePath=function(R){var I=R.indexOf("?"),q="",s,S=-1,j=this;if(I>0){q=R.slice(I);R=R.slice(0,I);}s=R.split("/");return s.map(function(k){var m=e.exec(k);S+=k.length+1;if(m){k=m[1]+j.convertKeyPredicate(m[2],"/"+R.slice(0,S));}return k;}).join("/")+q;};
h.prototype.convertTimeOfDay=function(v){var j,m=g.exec(v),T;if(!m){throw new Error("Not a valid Edm.Time value '"+v+"'");}T=Date.UTC(1970,0,1,m[1]||0,m[2]||0,m[3]||0);j=new Date(T);return t.format(j)+(m[4]||"");};
h.prototype.convertNonPrimitive=function(j){var P,T,s,v,k=this;if(Array.isArray(j.results)){j.results.forEach(function(I){k.convertNonPrimitive(I);});return j.results;}if(!j.__metadata||!j.__metadata.type){throw new Error("Cannot convert structured value without type information in "+"__metadata.type: "+JSON.stringify(j));}s=j.__metadata.type;T=k.getTypeForName(s);delete j.__metadata;for(P in j){v=j[P];if(v===null){continue;}if(typeof v==="object"){if(v.__deferred){delete j[P];}else{j[P]=this.convertNonPrimitive(v);}continue;}j[P]=this.convertPrimitive(v,T[P],s,P);}return j;};
h.prototype.convertPrimitive=function(v,P,T,s){switch(P&&P.$Type){case"Edm.Binary":return this.convertBinary(v);case"Edm.Date":return this.convertDate(v);case"Edm.DateTimeOffset":return this.convertDateTimeOffset(v,P);case"Edm.Boolean":case"Edm.Byte":case"Edm.Decimal":case"Edm.Guid":case"Edm.Int16":case"Edm.Int32":case"Edm.Int64":case"Edm.SByte":case"Edm.String":return v;case"Edm.Double":case"Edm.Single":return this.convertDoubleSingle(v);case"Edm.TimeOfDay":return this.convertTimeOfDay(v);default:throw new Error("Type '"+(P&&P.$Type)+"' of property '"+s+"' in type '"+T+"' is unknown; cannot convert value: "+v);}};
h.prototype.doCheckVersionHeader=function(G,R,j){var s=G("DataServiceVersion"),v=!s&&G("OData-Version");if(v){throw new Error("Expected 'DataServiceVersion' header with value '1.0' or '2.0' but "+"received 'OData-Version' header with value '"+v+"' in response for "+this.sServiceUrl+R);}if(!s){return;}s=s.split(";")[0];if(s==="1.0"||s==="2.0"){return;}throw new Error("Expected 'DataServiceVersion' header with value '1.0' or '2.0' but "+"received value '"+s+"' in response for "+this.sServiceUrl+R);};
h.prototype.doConvertResponse=function(R,m){var j,I,k,P,l,n=this;R=R.d;I=Array.isArray(R.results);if(!I&&!R.__metadata){k=Object.keys(R);j=R[k[0]];if(k.length===1){if(j===null){return{value:null};}else if(typeof j!=="object"){return{value:this.convertPrimitive(j,this.oModelInterface.fetchMetadata(m).getResult(),m,k[0])};}else if(j.__metadata){R=j;}}}if(I&&!R.results.length){P=[];}else if(I&&!R.results[0].__metadata){l=this.oModelInterface.fetchMetadata(m).getResult();P=R.results.map(function(v){return n.convertPrimitive(v,l,m,"");});}else{P=this.convertNonPrimitive(R);}if(I){P={value:P};if(R.__count){P["@odata.count"]=R.__count;}if(R.__next){P["@odata.nextLink"]=R.__next;}}return P;};
h.prototype.doConvertSystemQueryOptions=function(m,q,R,j,s){var S,k={},l=this;function n(v,E){if(!Array.isArray(v)){v=v.split(",");}v.forEach(function(w){var I=w.indexOf("/");if(I>=0&&!w.includes(".")){w=w.slice(0,I);}k[_.buildPath(E,w)]=true;});}function u(E,v,P){if(!v||typeof v!=="object"){throw new Error("$expand must be a valid object");}Object.keys(v).forEach(function(w){var A=_.buildPath(P,w),x=v[w];E.push(A);if(typeof x==="object"){Object.keys(x).forEach(function(Q){switch(Q){case"$expand":u(E,x.$expand,A);break;case"$select":n(x.$select,A);break;default:throw new Error("Unsupported query option in $expand: "+Q);}});}if(!x.$select){k[A+"/*"]=true;}});return E;}Object.keys(q).forEach(function(N){var I=N[0]==="$",v=q[N];if(j&&I){return;}switch(N){case"$count":N="$inlinecount";v=v?"allpages":"none";break;case"$expand":v=u([],v,"");v=(s?v.sort():v).join(",");break;case"$orderby":case"$search":break;case"$select":n(v);return;case"$filter":v=l.convertFilter(v,m);break;default:if(I){throw new Error("Unsupported system query option: "+N);}}R(N,v);});S=Object.keys(k);if(S.length>0){if(!q.$select){S.push("*");}R("$select",(s?S.sort():S).join(","));}};
h.prototype.formatPropertyAsLiteral=function(v,P){function j(k,V){var l=k.parse(V);if(!l){throw new Error("Not a valid "+P.$Type+" value: "+V);}return l;}if(v===null){return"null";}switch(P.$Type){case"Edm.Boolean":case"Edm.Byte":case"Edm.Decimal":case"Edm.Double":case"Edm.Guid":case"Edm.Int16":case"Edm.Int32":case"Edm.Int64":case"Edm.SByte":case"Edm.Single":case"Edm.String":break;case"Edm.Date":v=j(d,v);break;case"Edm.DateTimeOffset":v=j(o,v);break;case"Edm.TimeOfDay":v={__edmType:"Edm.Time",ms:j(t,v).getTime()};break;default:throw new Error("Type '"+P.$Type+"' in the key predicate is not supported");}return O.formatValue(v,P.$v2Type||P.$Type);};
h.prototype.getPathAndAddQueryOptions=function(P,j,m,q,E){var n,T,k=this;P=P.slice(1,-5);if(j.$IsBound){P=P.slice(P.lastIndexOf(".")+1);if(typeof E==="function"){E=E();}T=this.getTypeForName(j.$Parameter[0].$Type);T.$Key.forEach(function(n){q[n]=k.formatPropertyAsLiteral(E[n],T[n]);});}if(j.$Parameter){j.$Parameter.forEach(function(l){n=l.$Name;if(n in m){if(l.$isCollection){throw new Error("Unsupported collection-valued parameter: "+n);}q[n]=k.formatPropertyAsLiteral(m[n],l);delete m[n];}});}for(n in m){delete m[n];}if(j.$v2HttpMethod){m["X-HTTP-Method"]=j.$v2HttpMethod;}return P;};
h.prototype.getTypeForName=function(n){var T;this.mTypesByName=this.mTypesByName||{};T=this.mTypesByName[n];if(!T){T=this.mTypesByName[n]=this.oModelInterface.fetchMetadata("/"+n).getResult();}return T;};
h.prototype.isActionBodyOptional=function(){return true;};
h.prototype.isChangeSetOptional=function(){return false;};
h.prototype.ready=function(){return this.oModelInterface.fetchEntityContainer().then(function(){});};
function i(R){Object.assign(R,h.prototype);R.oModelInterface.reportStateMessages=function(){};R.oModelInterface.reportTransitionMessages=function(){};}
i._setDateTimeFormatter=function(){d=D.getDateInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd",UTC:true});o=D.getDateTimeInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd'T'HH:mm:ss.SSSZ"});t=D.getTimeInstance({calendarType:C.Gregorian,pattern:"HH:mm:ss",UTC:true});};
i._setDateTimeFormatter();return i;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_V4MetadataConverter',["./_Helper","./_MetadataConverter"],function(_,a){"use strict";
function b(){this.enumType=null;this.enumTypeMemberCounter=0;this.navigationProperty=null;a.call(this);}
b.prototype=Object.create(a.prototype);
b.prototype.finalize=function(){if(this.result.$Version!=="4.0"){throw new Error(this.url+": Unsupported OData version "+this.result.$Version);}};
b.prototype.processActionOrFunction=function(e){var k=e.localName,o={$kind:k},O,p,q=this.namespace+e.getAttribute("Name"),s="",t=this;function g(P){var T={};t.processTypedCollection(P.getAttribute("Type"),T);return T.$isCollection?"Collection("+T.$Type+")":T.$Type;}this.processAttributes(e,o,{IsBound:this.setIfTrue,EntitySetPath:this.setValue,IsComposable:this.setIfTrue});O=this.getOrCreateArray(this.result,q);if(!Array.isArray(O)){O=[];this.addToResult(q,O);}O.push(o);this.oOperation=o;if(o.$IsBound){p=e.getElementsByTagName("Parameter");s=e.localName==="Action"?g(p[0]):Array.prototype.map.call(p,g).join(",");}this.annotatable(q+"("+s+")");};
b.prototype.processComplexType=function(e){this.processType(e,{$kind:"ComplexType"});};
b.prototype.processEdmx=function(e){this.processAttributes(e,this.result,{Version:this.setValue});};
b.prototype.processElement=function(e,p){if(p){p.call(this,e);}};
b.prototype.processEntityContainer=function(e){var q=this.namespace+e.getAttribute("Name");this.entityContainer={$kind:"EntityContainer"};this.addToResult(q,this.entityContainer);this.addToResult("$EntityContainer",q);this.annotatable(q);};
b.prototype.processEntitySet=function(e){var n=e.getAttribute("Name");this.entityContainer[n]=this.entitySet={$kind:"EntitySet",$Type:this.resolveAlias(e.getAttribute("EntityType"))};this.processAttributes(e,this.entitySet,{IncludeInServiceDocument:this.setIfFalse});this.annotatable(n);};
b.prototype.processEntityType=function(e){this.processType(e,{$kind:"EntityType"});};
b.prototype.processEntityTypeKeyPropertyRef=function(e){var A=e.getAttribute("Alias"),k,n=e.getAttribute("Name");if(A){k={};k[A]=n;}else{k=n;}this.getOrCreateArray(this.type,"$Key").push(k);};
b.prototype.processEnumType=function(e){var q=this.namespace+e.getAttribute("Name"),E={$kind:"EnumType"};this.processAttributes(e,E,{IsFlags:this.setIfTrue,UnderlyingType:function(v){return v!=="Edm.Int32"?v:undefined;}});this.enumType=E;this.addToResult(q,E);this.enumTypeMemberCounter=0;this.annotatable(q);};
b.prototype.processEnumTypeMember=function(e){var n=e.getAttribute("Name"),v=e.getAttribute("Value"),V;if(v){V=parseInt(v);if(!_.isSafeInteger(V)){V=v;}}else{V=this.enumTypeMemberCounter;this.enumTypeMemberCounter+=1;}this.enumType[n]=V;this.annotatable(n);};
b.prototype.processFacetAttributes=function(e,r){var t=this;this.processAttributes(e,r,{MaxLength:function(v){return v==="max"?undefined:t.setNumber(v);},Precision:this.setNumber,Scale:function(v){return v==="variable"?v:t.setNumber(v);},SRID:this.setValue,Unicode:this.setIfFalse});};
b.prototype.processImport=function(e){var k=e.localName,i={$kind:k},n=e.getAttribute("Name"),t=this;k=k.replace("Import","");i["$"+k]=this.resolveAlias(e.getAttribute(k));this.processAttributes(e,i,{EntitySet:function(v){return t.resolveTargetPath(v);},IncludeInServiceDocument:this.setIfTrue});this.entityContainer[n]=i;this.annotatable(n);};
b.prototype.processNavigationPropertyBinding=function(e){var n=this.getOrCreateObject(this.entitySet,"$NavigationPropertyBinding");n[e.getAttribute("Path")]=this.resolveTargetPath(e.getAttribute("Target"));};
b.prototype.processParameter=function(e){var A=this.oOperation,p={};this.processTypedCollection(e.getAttribute("Type"),p);this.processAttributes(e,p,{Name:this.setValue,Nullable:this.setIfFalse});this.processFacetAttributes(e,p);this.getOrCreateArray(A,"$Parameter").push(p);this.annotatable(p.$Name);};
b.prototype.processReturnType=function(e){var A=this.oOperation,r={};this.processTypedCollection(e.getAttribute("Type"),r);this.processAttributes(e,r,{Nullable:this.setIfFalse});this.processFacetAttributes(e,r);A.$ReturnType=r;this.annotatable("$ReturnType");};
b.prototype.processSchema=function(e){this.namespace=e.getAttribute("Namespace")+".";this.schema={$kind:"Schema"};this.addToResult(this.namespace,this.schema);this.annotatable(this.schema);};
b.prototype.processSingleton=function(e){var n=e.getAttribute("Name");this.entityContainer[n]=this.entitySet={$kind:"Singleton",$Type:this.resolveAlias(e.getAttribute("Type"))};this.annotatable(n);};
b.prototype.processTerm=function(e){var q=this.namespace+e.getAttribute("Name"),t={$kind:"Term"},c=this;this.processTypedCollection(e.getAttribute("Type"),t);this.processAttributes(e,t,{Nullable:this.setIfFalse,BaseTerm:function(v){return v?c.resolveAlias(v):undefined;}});this.processFacetAttributes(e,t);this.addToResult(q,t);this.annotatable(q);};
b.prototype.processType=function(e,t){var q=this.namespace+e.getAttribute("Name"),c=this;this.processAttributes(e,t,{OpenType:c.setIfTrue,HasStream:c.setIfTrue,Abstract:c.setIfTrue,BaseType:function(T){return T?c.resolveAlias(T):undefined;}});this.type=t;this.addToResult(q,t);this.annotatable(q);};
b.prototype.processTypedCollection=function(t,p){var m=this.rCollection.exec(t);if(m){p.$isCollection=true;t=m[1];}p.$Type=this.resolveAlias(t);};
b.prototype.processTypeDefinition=function(e){var q=this.namespace+e.getAttribute("Name"),t={$kind:"TypeDefinition",$UnderlyingType:e.getAttribute("UnderlyingType")};this.addToResult(q,t);this.processFacetAttributes(e,t);this.annotatable(q);};
b.prototype.processTypeNavigationProperty=function(e){var n=e.getAttribute("Name"),p={$kind:"NavigationProperty"};this.processTypedCollection(e.getAttribute("Type"),p);this.processAttributes(e,p,{Nullable:this.setIfFalse,Partner:this.setValue,ContainsTarget:this.setIfTrue});this.type[n]=this.navigationProperty=p;this.annotatable(n);};
b.prototype.processTypeNavigationPropertyOnDelete=function(e){this.navigationProperty.$OnDelete=e.getAttribute("Action");this.annotatable(this.navigationProperty,"$OnDelete");};
b.prototype.processTypeNavigationPropertyReferentialConstraint=function(e){var p=e.getAttribute("Property"),r=this.getOrCreateObject(this.navigationProperty,"$ReferentialConstraint");r[p]=e.getAttribute("ReferencedProperty");this.annotatable(r,p);};
b.prototype.processTypeProperty=function(e){var n=e.getAttribute("Name"),p={$kind:"Property"};this.processTypedCollection(e.getAttribute("Type"),p);this.processAttributes(e,p,{Nullable:this.setIfFalse,DefaultValue:this.setValue});this.processFacetAttributes(e,p);this.type[n]=p;this.annotatable(n);};
b.prototype.resolveTargetPath=function(p){var s;if(!p){return p;}p=this.resolveAliasInPath(p);s=p.indexOf("/");if(s>=0&&!p.includes("/",s+1)){if(p.slice(0,s)===this.result.$EntityContainer){return p.slice(s+1);}}return p;};
(function($){var A,e,s;$.sRootNamespace=$.sEdmxNamespace;$.oAliasConfig={__xmlns:$.sEdmxNamespace,Reference:{Include:{__processor:$.processAlias}},DataServices:{Schema:{__xmlns:$.sEdmNamespace,__processor:$.processAlias}}};s={Property:{__processor:$.processTypeProperty,__include:[$.oAnnotationConfig]},NavigationProperty:{__processor:$.processTypeNavigationProperty,__include:[$.oAnnotationConfig],OnDelete:{__processor:$.processTypeNavigationPropertyOnDelete,__include:[$.oAnnotationConfig]},ReferentialConstraint:{__processor:$.processTypeNavigationPropertyReferentialConstraint,__include:[$.oAnnotationConfig]}}};e={NavigationPropertyBinding:{__processor:$.processNavigationPropertyBinding}};A={Parameter:{__processor:$.processParameter,__include:[$.oAnnotationConfig]},ReturnType:{__processor:$.processReturnType,__include:[$.oAnnotationConfig]}};$.oFullConfig={__xmlns:$.sEdmxNamespace,__processor:$.processEdmx,__include:[$.oReferenceInclude],DataServices:{Schema:{__xmlns:$.sEdmNamespace,__processor:$.processSchema,__include:[$.oAnnotationsConfig,$.oAnnotationConfig],Action:{__processor:$.processActionOrFunction,__include:[A,$.oAnnotationConfig]},Function:{__processor:$.processActionOrFunction,__include:[A,$.oAnnotationConfig]},EntityType:{__processor:$.processEntityType,__include:[s,$.oAnnotationConfig],Key:{PropertyRef:{__processor:$.processEntityTypeKeyPropertyRef}}},ComplexType:{__processor:$.processComplexType,__include:[s,$.oAnnotationConfig]},EntityContainer:{__processor:$.processEntityContainer,__include:[$.oAnnotationConfig],ActionImport:{__processor:$.processImport,__include:[$.oAnnotationConfig]},EntitySet:{__processor:$.processEntitySet,__include:[e,$.oAnnotationConfig]},FunctionImport:{__processor:$.processImport,__include:[$.oAnnotationConfig]},Singleton:{__processor:$.processSingleton,__include:[e,$.oAnnotationConfig]}},EnumType:{__processor:$.processEnumType,__include:[$.oAnnotationConfig],Member:{__processor:$.processEnumTypeMember,__include:[$.oAnnotationConfig]}},Term:{__processor:$.processTerm,__include:[$.oAnnotationConfig]},TypeDefinition:{__processor:$.processTypeDefinition,__include:[$.oAnnotationConfig]}}}};})(b.prototype);return b;},false);
sap.ui.predefine('sap/ui/model/resource/ResourceModel',['sap/ui/model/BindingMode','sap/ui/model/Model','./ResourcePropertyBinding',"sap/base/i18n/ResourceBundle","sap/base/Log"],function(B,M,R,a,L){"use strict";var r=/^(?:\/|\.)*/;
var b=M.extend("sap.ui.model.resource.ResourceModel",{constructor:function(d){var u;M.apply(this,arguments);this.aCustomBundles=[];this.bReenhance=false;this.bAsync=!!(d&&d.async);this.sDefaultBindingMode=d.defaultBindingMode||B.OneWay;this.mSupportedBindingModes={"OneWay":true,"TwoWay":false,"OneTime":!this.bAsync};if(this.bAsync&&this.sDefaultBindingMode==B.OneTime){L.warning("Using binding mode OneTime for asynchronous ResourceModel is not supported!");}this.oData=Object.assign({},d);u=Array.isArray(this.oData.enhanceWith)&&this.oData.enhanceWith.some(function(e){return e instanceof a;});if(d&&d.bundle){this._oResourceBundle=d.bundle;u=true;}else if(d&&(d.bundleUrl||d.bundleName)){if(u){delete this.oData.enhanceWith;if(d.terminologies||d.activeTerminologies){throw new Error("'terminologies' parameter and 'activeTerminologies' parameter are not"+" supported in configuration when enhanceWith contains ResourceBundles");}}_(this);}else{throw new Error("At least bundle, bundleName or bundleUrl must be provided!");}if(u&&Array.isArray(d.enhanceWith)){if(this.bAsync){this._pEnhanced=d.enhanceWith.reduce(function(c,e){return c.then(this.enhance.bind(this,e));}.bind(this),Promise.resolve());}else{d.enhanceWith.forEach(this.enhance.bind(this));}}}});
b._sanitizeBundleName=function(s){if(s&&(s[0]==="/"||s[0]===".")){L.error('Incorrect resource bundle name "'+s+'"','Leading slashes or dots in resource bundle names are ignored, since such names are'+' invalid UI5 module names. Please check whether the resource bundle "'+s+'" is actually needed by your application.',"sap.base.i18n.ResourceBundle");s=s.replace(r,"");}return s;};
b.loadResourceBundle=function(d,A){var c=sap.ui.getCore().getConfiguration(),l=d.bundleLocale,p;if(!l){l=c.getLanguage();}d.bundleName=b._sanitizeBundleName(d.bundleName);p=Object.assign({async:A,includeInfo:c.getOriginInfo(),locale:l},d);return a.create(p);};
b.prototype.enhance=function(d){var t=this,f,p=this.bAsync?new Promise(function(e){f=e;}):null;function c(){if(d instanceof a){t._oResourceBundle._enhance(d);t.checkUpdate(true);if(p){f(true);}}else{if(d.terminologies){throw new Error("'terminologies' parameter is not"+" supported for enhancement");}var e=b.loadResourceBundle(d,t.bAsync);if(e instanceof Promise){e.then(function(g){t._oResourceBundle._enhance(g);t.checkUpdate(true);f(true);},function(){f(true);});}else if(e){t._oResourceBundle._enhance(e);t.checkUpdate(true);}}}if(this._oPromise){Promise.resolve(this._oPromise).then(c);}else{c();}if(!this.bReenhance){this.aCustomBundles.push(d);}return p;};
b.prototype.bindProperty=function(p){return new R(this,p);};
b.prototype.getProperty=function(p){return this._oResourceBundle?this._oResourceBundle.getText(p):null;};
b.prototype.getResourceBundle=function(){if(!this.bAsync){return this._oResourceBundle;}else{var p=this._oPromise;if(p){return new Promise(function(c,d){function e(o){c(o);}p.then(e,e);});}else{return Promise.resolve(this._oResourceBundle);}}};
b.prototype._handleLocalizationChange=function(){_(this);};
b.prototype._reenhance=function(){this.bReenhance=true;this.aCustomBundles.forEach(function(d){this.enhance(d);}.bind(this));this.bReenhance=false;};
function _(m){var d=m.oData;if(d&&(d.bundleUrl||d.bundleName)){var c=b.loadResourceBundle(d,d.async);if(c instanceof Promise){var e={url:a._getUrl(d.bundleUrl,b._sanitizeBundleName(d.bundleName)),async:true};m.fireRequestSent(e);m._oPromise=c;m._oPromise.then(function(o){m._oResourceBundle=o;m._reenhance();delete m._oPromise;m.checkUpdate(true);m.fireRequestCompleted(e);});}else{m._oResourceBundle=c;m._reenhance();m.checkUpdate(true);}}}
return b;});
sap.ui.predefine('sap/ui/model/resource/ResourcePropertyBinding',['sap/ui/model/PropertyBinding','sap/ui/model/ChangeReason'],function(P,C){"use strict";
var R=P.extend("sap.ui.model.resource.ResourcePropertyBinding",{constructor:function(m,p){P.apply(this,arguments);this.oValue=this.oModel.getProperty(p);}});
R.prototype.getValue=function(){return this.oValue;};
R.prototype.checkUpdate=function(f){if(!this.bSuspended){var v=this.oModel.getProperty(this.sPath);if(f||v!=this.oValue){this.oValue=v;this._fireChange({reason:C.Change});}}};
return R;});
sap.ui.predefine('sap/ui/model/type/Boolean',['sap/ui/model/SimpleType','sap/ui/model/FormatException','sap/ui/model/ParseException'],function(S,F,P){"use strict";
var B=S.extend("sap.ui.model.type.Boolean",{constructor:function(){S.apply(this,arguments);this.sName="Boolean";}});
B.prototype.formatValue=function(v,i){if(v==undefined||v==null){return null;}switch(this.getPrimitiveType(i)){case"any":case"boolean":return v;case"string":return v.toString();default:throw new F("Don't know how to format Boolean to "+i);}};
B.prototype.parseValue=function(v,i){var b;switch(this.getPrimitiveType(i)){case"boolean":return v;case"string":if(v.toLowerCase()=="true"||v=="X"){return true;}if(v.toLowerCase()=="false"||v==""||v==" "){return false;}b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText("Boolean.Invalid"));default:throw new P("Don't know how to parse Boolean from "+i);}};
B.prototype.validateValue=function(){};
return B;});
sap.ui.predefine('sap/ui/model/type/Currency',["sap/base/Log","sap/base/util/each","sap/base/util/isEmptyObject","sap/ui/core/format/NumberFormat","sap/ui/model/CompositeType","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException"],function(L,e,i,N,C,F,P,V){"use strict";
var a=C.extend("sap.ui.model.type.Currency",{constructor:function(f){C.apply(this,arguments);this.sName="Currency";this.bShowMeasure=!f||!("showMeasure"in f)||f.showMeasure;this.bShowNumber=!f||!("showNumber"in f)||f.showNumber;this.bUseRawValues=true;}});
a.prototype.formatValue=function(v,t){var b=v;if(v==undefined||v==null){return null;}if(this.oInputFormat){b=this.oInputFormat.parse(v);}if(!Array.isArray(b)){throw new F("Cannot format currency: "+v+" has the wrong format");}if((b[0]==undefined||b[0]==null)&&this.bShowNumber){return null;}switch(this.getPrimitiveType(t)){case"string":return this.oOutputFormat.format(b);default:throw new F("Don't know how to format currency to "+t);}};
a.prototype.parseValue=function(v,s){var r;switch(this.getPrimitiveType(s)){case"string":r=this.oOutputFormat.parse(v);if(!Array.isArray(r)||this.bShowNumber&&isNaN(r[0])){throw this.getParseException();}break;default:throw new P("Don't know how to parse Currency from "+s);}if(this.oInputFormat){r=this.oInputFormat.format(r);}return r;};
a.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[],d=v,f;if(this.oInputFormat){d=this.oInputFormat.parse(v);}f=d[0];e(this.oConstraints,function(n,o){switch(n){case"minimum":if(f<o){c.push("minimum");m.push(b.getText("Currency.Minimum",[o]));}break;case"maximum":if(f>o){c.push("maximum");m.push(b.getText("Currency.Maximum",[o]));}break;default:L.warning("Unknown constraint '"+n+"': Value is not validated.",null,"sap.ui.model.type.Currency");}});if(c.length>0){throw new V(this.combineMessages(m),c);}}};
a.prototype.setFormatOptions=function(f){this.oFormatOptions=Object.assign(f.style!=="short"&&f.style!=="long"?{preserveDecimals:true}:{},f);this._createFormats();};
a.prototype._handleLocalizationChange=function(){this._createFormats();};
a.prototype._createFormats=function(){var s=this.oFormatOptions.source;this.oOutputFormat=N.getCurrencyInstance(this.oFormatOptions);if(s){if(i(s)){s={groupingEnabled:false,groupingSeparator:",",decimalSeparator:"."};}this.oInputFormat=N.getCurrencyInstance(s);}};
a.prototype.getParseException=function(){var b=sap.ui.getCore().getLibraryResourceBundle(),t;if(!this.bShowNumber){t=b.getText("Currency.InvalidMeasure");}else if(!this.bShowMeasure){t=b.getText("EnterNumber");}else{t=b.getText("Currency.Invalid");}return new P(t);};
a.prototype.getPartsIgnoringMessages=function(){if(!this.bShowMeasure){return[1];}else if(!this.bShowNumber){return[0];}return[];};
return a;});
sap.ui.predefine('sap/ui/model/type/Date',["sap/base/util/each","sap/base/util/isEmptyObject","sap/ui/core/format/DateFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/SimpleType","sap/ui/model/ValidateException"],function(e,i,D,F,P,S,V){"use strict";
var a=S.extend("sap.ui.model.type.Date",{constructor:function(){S.apply(this,arguments);this.sName="Date";}});
a.prototype.formatValue=function(v,I){var f;switch(this.getPrimitiveType(I)){case"string":case"any":if(v==null){return"";}if(this.oFormatOptions.source&&this.oFormatOptions.source.pattern!=="timestamp"&&v===""){return"";}f=this.getModelFormat();v=f.parse(v);return this.oOutputFormat.format(v);default:throw new F("Don't know how to format Date to "+I);}};
a.prototype.parseValue=function(v,I){var r,b;switch(this.getPrimitiveType(I)){case"string":if(v===""){return null;}r=this.oOutputFormat.parse(v);if(!r){b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText(this.sName+".Invalid"));}if(this.oInputFormat){if(this.oFormatOptions.source.pattern=="timestamp"){r=r.getTime();}else{r=this.oInputFormat.format(r);}}return r;default:throw new P("Don't know how to parse Date from "+I);}};
a.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[],I=this.oInputFormat,C,d=this;if(I&&this.oFormatOptions.source.pattern!="timestamp"){v=I.parse(v);}e(this.oConstraints,function(n,o){if(I){o=I.parse(o);}C=d.oOutputFormat.format(o);switch(n){case"minimum":if(v<o){c.push("minimum");m.push(b.getText(d.sName+".Minimum",[C]));}break;case"maximum":if(v>o){c.push("maximum");m.push(b.getText(d.sName+".Maximum",[C]));}break;default:break;}});if(c.length>0){throw new V(this.combineMessages(m),c);}}};
var t={format:function(v){if(v instanceof Date){return v.getTime();}return null;},parse:function(v){if(typeof(v)!="number"){if(isNaN(v)){throw new F("Cannot format date: "+v+" is not a valid Timestamp");}else{v=parseInt(v);}}v=new Date(v);return v;}};
a.prototype.getModelFormat=function(){if(this.oInputFormat){if(this.oFormatOptions.source.pattern=="timestamp"){return t;}else{return this.oInputFormat;}}else{return S.prototype.getModelFormat.call(this);}};
a.prototype.setFormatOptions=function(f){this.oFormatOptions=f;this._createFormats();};
a.prototype.getOutputPattern=function(){return this.oOutputFormat.oFormatOptions.pattern;};
a.prototype._handleLocalizationChange=function(){this._createFormats();};
a.prototype._createFormats=function(){var s=this.oFormatOptions.source;this.oOutputFormat=D.getInstance(this.oFormatOptions);if(s){if(i(s)){s={pattern:"yyyy-MM-dd"};}this.oInputFormat=D.getInstance(s);}};
return a;});
sap.ui.predefine('sap/ui/model/type/DateInterval',['sap/ui/core/format/DateFormat','sap/ui/model/CompositeType','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/ValidateException',"sap/base/util/isEmptyObject"],function(D,C,F,P,V,i){"use strict";
var a=C.extend("sap.ui.model.type.DateInterval",{constructor:function(){C.apply(this,arguments);this.sName="DateInterval";this.bUseInternalValues=true;}});
a.prototype.formatValue=function(v,I){if(!Array.isArray(v)){throw new F("Cannot format date interval: "+v+" is expected as an Array but given the wrong format");}switch(this.getPrimitiveType(I)){case"string":case"any":if(!v[0]||(!v[1]&&!this.oFormatOptions.singleIntervalValue)){return"";}if(this.oInputFormat){v=v.slice(0,2);v.forEach(function(o,b){if(this.oFormatOptions.source.pattern=="timestamp"){if(typeof(o)!="number"){if(isNaN(o)){throw new F("Cannot format date: "+o+" is not a valid Timestamp");}else{o=parseInt(o);}}o=new Date(o);}else{o=this.oInputFormat.parse(o);if(o==null){throw new F("Cannot format date: "+o+" has the wrong format");}}v[b]=o;}.bind(this));}return this.oOutputFormat.format(v);default:throw new F("Don't know how to format Date to "+I);}};
a.prototype.parseValue=function(v,I){var d;function t(n){var b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText(n+".Invalid"));}switch(this.getPrimitiveType(I)){case"string":if(v===""){return[null,null];}d=this.oOutputFormat.parse(v);if(!d[0]||(!d[1]&&!this.oFormatOptions.singleIntervalValue)){t(this.sName);}if(this.oInputFormat){d.forEach(function(o,b){if(this.oFormatOptions.source.pattern=="timestamp"){o=o.getTime();}else{o=this.oInputFormat.format(o);}d[b]=o;}.bind(this));}return d;default:throw new P("Don't know how to parse Date from "+I);}};
a.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[];if(this.oInputFormat&&this.oFormatOptions.source.pattern!="timestamp"){v=v.slice(0,2);v.forEach(function(o,d){o=this.oInputFormat.parse(o);v[d]=o;}.bind(this));}Object.keys(this.oConstraints).forEach(function(k){var o=this.oConstraints[k];var d=true;switch(k){case"minimum":if(this.oFormatOptions.singleIntervalValue&&v[1]===null){if(v[0]<o){d=false;}}else if(v[0]<o||v[1]<o){d=false;}if(d===false){c.push("minimum");m.push(b.getText("Date.Minimum",[o]));}break;case"maximum":if(this.oFormatOptions.singleIntervalValue&&v[1]===null){if(v[0]>o){d=false;}}else if(v[0]>o||v[1]>o){d=false;}if(d===false){c.push("maximum");m.push(b.getText("Date.Maximum",[o]));}break;default:break;}}.bind(this));if(c.length>0){throw new V(this.combineMessages(m),c);}}};
a.prototype.setFormatOptions=function(f){this.oFormatOptions=f;this._createFormats();};
a.prototype._handleLocalizationChange=function(){this._createFormats();};
a.prototype._createFormats=function(){var s=this.oFormatOptions.source;this.oFormatOptions.interval=true;this.oOutputFormat=D.getDateInstance(this.oFormatOptions);if(s){if(i(s)){s={pattern:"yyyy-MM-dd"};}this.oInputFormat=D.getDateInstance(s);}};
return a;});
sap.ui.predefine('sap/ui/model/type/DateTime',['./Date','sap/ui/core/format/DateFormat'],function(D,a){"use strict";
var b=D.extend("sap.ui.model.type.DateTime",{constructor:function(){D.apply(this,arguments);this.sName="DateTime";}});
b.prototype._createFormats=function(){this.oOutputFormat=a.getDateTimeInstance(this.oFormatOptions);if(this.oFormatOptions.source){this.oInputFormat=a.getDateTimeInstance(this.oFormatOptions.source);}};
return b;});
sap.ui.predefine('sap/ui/model/type/DateTimeInterval',['./DateInterval','sap/ui/core/format/DateFormat'],function(D,a){"use strict";
var b=D.extend("sap.ui.model.type.DateTimeInterval",{constructor:function(){D.apply(this,arguments);this.sName="DateTimeInterval";}});
b.prototype._createFormats=function(){this.oFormatOptions.interval=true;this.oOutputFormat=a.getDateTimeInstance(this.oFormatOptions);if(this.oFormatOptions.source){this.oInputFormat=a.getDateTimeInstance(this.oFormatOptions.source);}};
return b;});
sap.ui.predefine('sap/ui/model/type/FileSize',["sap/base/util/each","sap/ui/core/format/FileSizeFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/SimpleType","sap/ui/model/ValidateException"],function(e,F,a,P,S,V){"use strict";
var b=S.extend("sap.ui.model.type.FileSize",{constructor:function(){S.apply(this,arguments);this.sName="FileSize";}});
b.prototype.formatValue=function(v,i){var f;if(v==undefined||v==null){return null;}if(this.oInputFormat&&typeof v==="string"){f=this.oInputFormat.parse(v);if(isNaN(f)){throw new a("Cannot format file size: "+v+" has the wrong format");}}else if(!this.oInputFormat&&typeof v==="string"){throw new a("Cannot format file size: "+v+" of type string without input/source formatter");}else if(typeof v==="number"){f=v;}else{throw new a("Cannot format file size: "+v+" has wrong type: "+(typeof v));}if(f==undefined||f==null){return null;}switch(this.getPrimitiveType(i)){case"string":return this.oOutputFormat.format(f);case"int":return Math.floor(f);case"float":case"any":return f;default:throw new a("Don't know how to format FileSize to "+i);}};
b.prototype.parseValue=function(v,i){var r,B;if(v==undefined||v==null){return null;}switch(this.getPrimitiveType(i)){case"string":r=this.oOutputFormat.parse(v);if(isNaN(r)){B=sap.ui.getCore().getLibraryResourceBundle();throw new P(B.getText("FileSize.Invalid"));}break;case"int":case"float":r=v;break;default:throw new P("Don't know how to parse FileSize from "+i);}if(this.oInputFormat){r=this.oInputFormat.format(r);}return r;};
b.prototype.validateValue=function(v){if(this.oConstraints){var B=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[],i=this.oInputFormat;if(i&&typeof v==="string"){v=i.parse(v);}else if(!i&&typeof v==="string"){throw new Error("No Validation possible: '"+v+"' is of type string but not input/source format specified.");}e(this.oConstraints,function(n,C){if(i&&typeof C==="string"){C=i.parse(C);}else if(!i&&typeof C==="string"){throw new Error("No Validation possible: Compare value ("+n+") '"+C+"' is of type string but not input/source format specified.");}switch(n){case"minimum":if(v<C){c.push("minimum");m.push(B.getText("FileSize.Minimum",[C]));}break;case"maximum":if(v>C){c.push("maximum");m.push(B.getText("FileSize.Maximum",[C]));}break;default:break;}});if(c.length>0){throw new V(this.combineMessages(m),c);}}};
b.prototype.setFormatOptions=function(f){this.oFormatOptions=f;this._handleLocalizationChange();};
b.prototype._handleLocalizationChange=function(){this.oOutputFormat=F.getInstance(this.oFormatOptions);if(this.oFormatOptions.source){this.oInputFormat=F.getInstance(this.oFormatOptions.source);}};
return b;});
sap.ui.predefine('sap/ui/model/type/Float',["sap/base/util/each","sap/base/util/isEmptyObject","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/SimpleType","sap/ui/model/ValidateException"],function(e,i,N,F,P,S,V){"use strict";
var a=S.extend("sap.ui.model.type.Float",{constructor:function(){S.apply(this,arguments);this.sName="Float";}});
a.prototype.formatValue=function(v,I){var f=v;if(v==undefined||v==null){return null;}if(this.oInputFormat){f=this.oInputFormat.parse(v);if(f==null){throw new F("Cannot format float: "+v+" has the wrong format");}}switch(this.getPrimitiveType(I)){case"string":return this.oOutputFormat.format(f);case"int":return Math.floor(f);case"float":case"any":return f;default:throw new F("Don't know how to format Float to "+I);}};
a.prototype.parseValue=function(v,I){var r,b;switch(this.getPrimitiveType(I)){case"string":r=this.oOutputFormat.parse(v);if(isNaN(r)){b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText("Float.Invalid"));}break;case"int":case"float":r=v;break;default:throw new P("Don't know how to parse Float from "+I);}if(this.oInputFormat){r=this.oInputFormat.format(r);}return r;};
a.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[],f=v,t=this;if(this.oInputFormat){f=this.oInputFormat.parse(v);}e(this.oConstraints,function(n,C){switch(n){case"minimum":if(f<C){c.push("minimum");m.push(b.getText("Float.Minimum",[t.oOutputFormat.format(C)]));}break;case"maximum":if(f>C){c.push("maximum");m.push(b.getText("Float.Maximum",[t.oOutputFormat.format(C)]));}break;default:break;}});if(c.length>0){throw new V(this.combineMessages(m),c);}}};
a.prototype.setFormatOptions=function(f){this.oFormatOptions=Object.assign(f.style!=="short"&&f.style!=="long"?{preserveDecimals:true}:{},f);this._createFormats();};
a.prototype._handleLocalizationChange=function(){this._createFormats();};
a.prototype._createFormats=function(){var s=this.oFormatOptions.source;this.oOutputFormat=N.getFloatInstance(this.oFormatOptions);if(s){if(i(s)){s={groupingEnabled:false,groupingSeparator:",",decimalSeparator:"."};}this.oInputFormat=N.getFloatInstance(s);}};
return a;});
sap.ui.predefine('sap/ui/model/type/Integer',["sap/base/util/each","sap/base/util/isEmptyObject","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/SimpleType","sap/ui/model/ValidateException"],function(e,i,N,F,P,S,V){"use strict";
var I=S.extend("sap.ui.model.type.Integer",{constructor:function(){S.apply(this,arguments);this.sName="Integer";}});
I.prototype.formatValue=function(v,s){var a=v;if(v==undefined||v==null){return null;}if(this.oInputFormat){a=this.oInputFormat.parse(v);if(a==null){throw new F("Cannot format float: "+v+" has the wrong format");}}switch(this.getPrimitiveType(s)){case"string":return this.oOutputFormat.format(a);case"int":case"float":case"any":return a;default:throw new F("Don't know how to format Integer to "+s);}};
I.prototype.parseValue=function(v,s){var r,b;switch(this.getPrimitiveType(s)){case"string":r=this.oOutputFormat.parse(String(v));if(isNaN(r)){b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText("EnterInt"));}break;case"float":r=Math.floor(v);if(r!=v){b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText("EnterInt"));}break;case"int":r=v;break;default:throw new P("Don't know how to parse Integer from "+s);}if(this.oInputFormat){r=this.oInputFormat.format(r);}return r;};
I.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),a=[],m=[],c=v,t=this;if(this.oInputFormat){c=this.oInputFormat.parse(v);}e(this.oConstraints,function(n,C){switch(n){case"minimum":if(c<C){a.push("minimum");m.push(b.getText("Integer.Minimum",[t.oOutputFormat.format(C)]));}break;case"maximum":if(c>C){a.push("maximum");m.push(b.getText("Integer.Maximum",[t.oOutputFormat.format(C)]));}break;default:break;}});if(a.length>0){throw new V(this.combineMessages(m),a);}}};
I.prototype.setFormatOptions=function(f){this.oFormatOptions=f;this._createFormats();};
I.prototype._handleLocalizationChange=function(){this._createFormats();};
I.prototype._createFormats=function(){var s=this.oFormatOptions.source;this.oOutputFormat=N.getIntegerInstance(this.oFormatOptions);if(s){if(i(s)){s={groupingEnabled:false,groupingSeparator:",",decimalSeparator:"."};}this.oInputFormat=N.getIntegerInstance(s);}};
return I;});
sap.ui.predefine('sap/ui/model/type/String',["sap/base/Log","sap/base/util/each","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/SimpleType","sap/ui/model/ValidateException"],function(L,e,F,P,S,V){"use strict";
var a=S.extend("sap.ui.model.type.String",{constructor:function(){S.apply(this,arguments);this.sName="String";if(this.oConstraints.search&&typeof this.oConstraints.search=="string"){this.oConstraints.search=new RegExp(this.oConstraints.search);}}});
a.prototype.formatValue=function(v,t){if(v==undefined||v==null){return null;}switch(this.getPrimitiveType(t)){case"string":case"any":return v;case"int":var r=parseInt(v);if(isNaN(r)){throw new F(v+" is not a valid int value");}return r;case"float":var R=parseFloat(v);if(isNaN(R)){throw new F(v+" is not a valid float value");}return R;case"boolean":if(v.toLowerCase()=="true"||v=="X"){return true;}if(v.toLowerCase()=="false"||v==""){return false;}throw new F(v+" is not a valid boolean value");default:throw new F("Don't know how to format String to "+t);}};
a.prototype.parseValue=function(v,s){switch(this.getPrimitiveType(s)){case"string":return v;case"boolean":case"int":case"float":return v.toString();default:throw new P("Don't know how to parse String from "+s);}};
a.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[];if(v===null){v="";}e(this.oConstraints,function(n,C){switch(n){case"maxLength":if(v.length>C){c.push("maxLength");m.push(b.getText("String.MaxLength",[C]));}break;case"minLength":if(v.length<C){c.push("minLength");m.push(b.getText("String.MinLength",[C]));}break;case"startsWith":if(!(typeof C=="string"&&C.length>0&&v.startsWith(C))){c.push("startsWith");m.push(b.getText("String.StartsWith",[C]));}break;case"startsWithIgnoreCase":if(!(typeof C=="string"&&C!=""?v.toLowerCase().startsWith(C.toLowerCase()):false)){c.push("startsWithIgnoreCase");m.push(b.getText("String.StartsWith",[C]));}break;case"endsWith":if(!(typeof C=="string"&&C.length>0&&v.endsWith(C))){c.push("endsWith");m.push(b.getText("String.EndsWith",[C]));}break;case"endsWithIgnoreCase":if(!((typeof C=="string"&&C!=""?v.toLowerCase().endsWith(C.toLowerCase()):false))){c.push("endsWithIgnoreCase");m.push(b.getText("String.EndsWith",[C]));}break;case"contains":if(v.indexOf(C)==-1){c.push("contains");m.push(b.getText("String.Contains",[C]));}break;case"equals":if(v!=C){c.push("equals");m.push(b.getText("String.Equals",[C]));}break;case"search":if(v.search(C)==-1){c.push("search");m.push(b.getText("String.Search",[C]));}break;default:L.warning("Ignoring unknown constraint: '"+n+"'",null,"sap.ui.model.type.String");}});if(c.length>0){throw new V(this.combineMessages(m),c);}}};
return a;});
sap.ui.predefine('sap/ui/model/type/Time',['./Date','sap/ui/core/format/DateFormat'],function(D,a){"use strict";
var T=D.extend("sap.ui.model.type.Time",{constructor:function(){D.apply(this,arguments);this.sName="Time";}});
T.prototype._createFormats=function(){this.oOutputFormat=a.getTimeInstance(this.oFormatOptions);if(this.oFormatOptions.source){this.oInputFormat=a.getTimeInstance(this.oFormatOptions.source);}};
return T;});
sap.ui.predefine('sap/ui/model/type/TimeInterval',['./DateInterval','sap/ui/core/format/DateFormat'],function(D,a){"use strict";
var T=D.extend("sap.ui.model.type.TimeInterval",{constructor:function(){D.apply(this,arguments);this.sName="TimeInterval";}});
T.prototype._createFormats=function(){this.oFormatOptions.interval=true;this.oOutputFormat=a.getTimeInstance(this.oFormatOptions);if(this.oFormatOptions.source){this.oInputFormat=a.getTimeInstance(this.oFormatOptions.source);}};
return T;});
sap.ui.predefine('sap/ui/model/type/Unit',["sap/base/strings/hash","sap/base/util/each","sap/base/util/extend","sap/base/util/isEmptyObject","sap/ui/core/LocaleData","sap/ui/core/format/NumberFormat","sap/ui/model/CompositeType","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException"],function(h,e,a,i,L,N,C,F,P,V){"use strict";
var U=C.extend("sap.ui.model.type.Unit",{constructor:function(f,c,d){C.apply(this,arguments);this.sName="Unit";this.bShowMeasure=!f||!("showMeasure"in f)||f.showMeasure;this.bShowNumber=!f||!("showNumber"in f)||f.showNumber;this.bUseRawValues=true;this.aDynamicFormatOptionNames=d;}});
U.prototype._getInstance=function(A,u){var f=this.createFormatOptions(A);if(u&&!this.oFormatOptions.customUnits&&!f.customUnits){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var o=L.getInstance(l);var s=o.getUnitFromMapping(u)||u;var m=o.getUnitFormat(s);if(m){var b=a({},m);b.decimals=(f.decimals!=undefined)?f.decimals:b.decimals;b.precision=(f.precision!=undefined)?f.precision:b.precision;f.customUnits={};f.customUnits[u]=b;}}var c=f;if(this.oFormatOptions){c=a({},this.oFormatOptions,f);}if(this.getMetadata().getClass()!==U){var M=this.getMetadata();M._mTypeInstanceCache=M._mTypeInstanceCache||{};var H=h(JSON.stringify(c)||"");var d=M._mTypeInstanceCache[H];if(!d){d=N.getUnitInstance(c);M._mTypeInstanceCache[H]=d;}return d;}else{return N.getUnitInstance(c);}};
U.prototype._clearInstances=function(){if(this.getMetadata().getClass()!==U){var m=this.getMetadata();if(m._mTypeInstanceCache){m._mTypeInstanceCache={};}}};
U.prototype.createFormatOptions=function(v){var f={};if(this.aDynamicFormatOptionNames&&v.length>=this.aDynamicFormatOptionNames.length){this.aDynamicFormatOptionNames.forEach(function(d,I){if(d){f[d]=v[I];}});}return f;};
U.prototype.extractArguments=function(v){return Array.isArray(v)&&v.length>2?v.slice(2):[];};
U.prototype.formatValue=function(v,I){var b=v;if(v==undefined||v==null){return null;}if(this.oInputFormat){b=this.oInputFormat.parse(v);}if(!Array.isArray(b)){throw new F("Cannot format Unit: "+v+" has the wrong format");}if((b[0]==undefined||b[0]==null)&&this.bShowNumber){return null;}switch(this.getPrimitiveType(I)){case"string":this.aDynamicValues=this.extractArguments(b);this.oOutputFormat=this._getInstance(this.aDynamicValues,b[1]);return this.oOutputFormat.format(b);case"int":case"float":case"any":default:throw new F("Don't know how to format Unit to "+I);}};
U.prototype.parseValue=function(v,I){var r;switch(this.getPrimitiveType(I)){case"string":this.oOutputFormat=this._getInstance(this.aDynamicValues);r=this.oOutputFormat.parse(v);if(!Array.isArray(r)||this.bShowNumber&&isNaN(r[0])){throw this.getParseException();}break;case"int":case"float":default:throw new P("Don't know how to parse Unit from "+I);}if(this.oInputFormat){r=this.oInputFormat.format(r);}return r;};
U.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[],d=v,f;if(this.oInputFormat){d=this.oInputFormat.parse(v);}f=d[0];e(this.oConstraints,function(n,o){switch(n){case"minimum":if(f<o){c.push("minimum");m.push(b.getText("Unit.Minimum",[o]));}break;case"maximum":if(f>o){c.push("maximum");m.push(b.getText("Unit.Maximum",[o]));}break;case"decimals":var t=N._shiftDecimalPoint(f,o);if(Math.floor(t)!==t){c.push("decimals");m.push(b.getText("Unit.Decimals",[o]));}break;default:break;}});if(c.length>0){throw new V(m.join(" "),c);}}};
U.prototype.setFormatOptions=function(f){this.oFormatOptions=Object.assign(f.style!=="short"&&f.style!=="long"?{preserveDecimals:true}:{},f);this._clearInstances();this._createInputFormat();};
U.prototype._handleLocalizationChange=function(){this._clearInstances();this._createInputFormat();};
U.prototype._createInputFormat=function(){var s=this.oFormatOptions.source;if(s){if(i(s)){s={groupingEnabled:false,groupingSeparator:",",decimalSeparator:"."};}this.oInputFormat=N.getUnitInstance(s);}};
U.prototype.getParseException=function(){var b=sap.ui.getCore().getLibraryResourceBundle(),t;if(!this.bShowNumber){t=b.getText("Unit.InvalidMeasure");}else if(!this.bShowMeasure){t=b.getText("EnterNumber");}else{t=b.getText("Unit.Invalid");}return new P(t);};
U.prototype.getPartsIgnoringMessages=function(){if(!this.bShowMeasure){return[1];}else if(!this.bShowNumber){return[0];}return[];};
return U;});
sap.ui.predefine('sap/ui/model/xml/XMLListBinding',['sap/ui/model/ChangeReason','sap/ui/model/ClientListBinding',"sap/ui/util/XMLHelper","sap/base/util/deepEqual","sap/base/util/each"],function(C,a,X,d,e){"use strict";
var b=a.extend("sap.ui.model.xml.XMLListBinding");
b.prototype.getContexts=function(s,l){this.iLastStartIndex=s;this.iLastLength=l;if(!s){s=0;}if(!l){l=Math.min(this.iLength,this.oModel.iSizeLimit);}var c=this._getContexts(s,l),f=[];if(this.bUseExtendedChangeDetection){for(var i=0;i<c.length;i++){f.push(this.getContextData(c[i]));}if(this.aLastContexts&&s<this.iLastEndIndex){c.diff=this.diffData(this.aLastContextData,f);}this.iLastEndIndex=s+l;this.aLastContexts=c.slice(0);this.aLastContextData=f.slice(0);}return c;};
b.prototype.getCurrentContexts=function(){if(this.bUseExtendedChangeDetection){return this.aLastContexts||[];}else{return this.getContexts(this.iLastStartIndex,this.iLastLength);}};
b.prototype.getEntryData=function(c){return X.serialize(c.getObject());};
b.prototype.update=function(){var l=this.oModel._getObject(this.sPath,this.oContext);if(l){this.oList=[];var t=this;if(this.bUseExtendedChangeDetection){e(l,function(k,n){t.oList.push(n.cloneNode(true));});}else{this.oList=l.slice(0);}this.updateIndices();this.applyFilter();this.applySort();this.iLength=this._getLength();}else{this.oList=[];this.aIndices=[];this.iLength=0;}};
b.prototype.checkUpdate=function(f){var l;if(this.bSuspended&&!this.bIgnoreSuspend&&!f){return;}if(!this.bUseExtendedChangeDetection){l=this.oModel._getObject(this.sPath,this.oContext)||[];if(l.length!=this.oList.length||f){this.update();this._fireChange({reason:C.Change});}}else{var c=false;var t=this;l=this.oModel._getObject(this.sPath,this.oContext)||[];if(this.oList.length!=l.length){c=true;}if(!d(this.oList,l)){this.update();}var g=this._getContexts(this.iLastStartIndex,this.iLastLength);if(this.aLastContexts){if(this.aLastContexts.length!=g.length){c=true;}else{e(this.aLastContextData,function(i,L){var o=t.getContextData(g[i]);if(o!==L){c=true;return false;}return true;});}}else{c=true;}if(c||f){this._fireChange({reason:C.Change});}}};
return b;});
sap.ui.predefine('sap/ui/model/xml/XMLModel',['sap/ui/model/ClientModel','sap/ui/model/Context','./XMLListBinding','./XMLPropertyBinding','./XMLTreeBinding',"sap/ui/util/XMLHelper","sap/base/Log","sap/base/util/each"],function(C,a,X,b,c,d,L,e){"use strict";
var f=C.extend("sap.ui.model.xml.XMLModel",{
constructor:function(D){C.apply(this,arguments);this.oNameSpaces=null;if(D&&D.documentElement){this.setData(D);}},
metadata:{publicMethods:["setXML","getXML","setNameSpace"]}
});
f.prototype.setXML=function(x){var o=d.parse(x);if(o.parseError.errorCode!=0){var p=o.parseError;L.fatal("The following problem occurred: XML parse Error for "+p.url+" code: "+p.errorCode+" reason: "+p.reason+" src: "+p.srcText+" line: "+p.line+" linepos: "+p.linepos+" filepos: "+p.filepos);this.fireParseError({url:p.url,errorCode:p.errorCode,reason:p.reason,srcText:p.srcText,line:p.line,linepos:p.linepos,filepos:p.filepos});}this.setData(o);};
f.prototype.getXML=function(){return d.serialize(this.oData);};
f.prototype.setData=function(D){this.oData=D;this.checkUpdate();};
f.prototype.loadData=function(u,p,A,t,g,h){var i=this;A=(A!==false);t=t||"GET";g=g===undefined?this.bCache:g;this.fireRequestSent({url:u,type:t,async:A,headers:h,info:"cache="+g,infoObject:{cache:g}});this._ajax({url:u,async:A,cache:g,dataType:'xml',data:p,headers:h,type:t,success:function(D){if(!D){L.fatal("The following problem occurred: No data was retrieved by service: "+u);}i.setData(D);i.fireRequestCompleted({url:u,type:t,async:A,headers:h,info:"cache="+g,infoObject:{cache:g},success:true});},error:function(j,k,l){var E={message:k,statusCode:j.status,statusText:j.statusText,responseText:j.responseText};L.fatal("The following problem occurred: "+k,j.responseText+","+j.status+","+j.statusText);i.fireRequestCompleted({url:u,type:t,async:A,headers:h,info:"cache="+g,infoObject:{cache:g},success:false,errorobject:E});i.fireRequestFailed(E);}});};
f.prototype.setNameSpace=function(n,p){if(!p){p="";}if(!this.oNameSpaces){this.oNameSpaces={};}this.oNameSpaces[p]=n;};
f.prototype.bindProperty=function(p,o,P){var B=new b(this,p,o,P);return B;};
f.prototype.bindList=function(p,o,s,F,P){var B=new X(this,p,o,s,F,P);return B;};
f.prototype.bindTree=function(p,o,F,P,s){var B=new c(this,p,o,F,P,s);return B;};
f.prototype.setProperty=function(p,v,o,A){var O=p.substring(0,p.lastIndexOf("/")+1),P=p.substr(p.lastIndexOf("/")+1);if(!this.resolve(p,o)){return false;}if(!this.oData.documentElement){L.warning("Trying to set property "+p+", but no document exists.");return false;}var g;if(P.indexOf("@")==0){g=this._getObject(O,o);if(g[0]){g[0].setAttribute(P.substr(1),v);this.checkUpdate(false,A);return true;}}else{g=this._getObject(p,o);if(g[0]){g[0].textContent=v;this.checkUpdate(false,A);return true;}}return false;};
f.prototype.getProperty=function(p,o){var r=this._getObject(p,o);if(r&&typeof r!="string"){r=r[0]?r[0].textContent:"";}return r;};
f.prototype.getObject=function(p,o){var O=this._getObject(p,o);if(Array.isArray(O)){O=O[0];}return O;};
f.prototype._getObject=function(p,o){var r=this.oData.documentElement;if(!r){return null;}var n=this.isLegacySyntax()?[r]:[];if(o instanceof a){n=this._getObject(o.getPath());}else if(o){n=[o];}if(!p){return n;}var P=p.split("/"),s,i=0;if(!P[0]){n=r;i++;}n=n.length==undefined?[n]:n;n=n[0]?n:null;while(n&&n.length>0&&P[i]){s=P[i];if(s.indexOf("@")==0){n=this._getAttribute(n[0],s.substr(1));}else if(s=="text()"){n=n[0]?n[0].textContent:"";}else if(isNaN(s)){n=this._getChildElementsByTagName(n[0],s);}else{n=[n[s]];}i++;}return n;};
f.prototype._getAttribute=function(n,N){if(!this.oNameSpaces||N.indexOf(":")==-1){return n.getAttribute(N);}var s=this._getNameSpace(N),l=this._getLocalName(N);return n.getAttributeNS(s,l);};
f.prototype._getChildElementsByTagName=function(n,N){var g=n.childNodes,r=[];if(this.oNameSpaces){var s=this._getNameSpace(N),l=this._getLocalName(N),h;e(g,function(i,o){h=o.localName||o.baseName;if(o.nodeType==1&&h==l&&o.namespaceURI==s){r.push(o);}});}else{e(g,function(i,o){if(o.nodeType==1&&o.nodeName==N){r.push(o);}});}return r;};
f.prototype._getNameSpace=function(n){var i=n.indexOf(":"),p="";if(i>0){p=n.substr(0,i);}return this.oNameSpaces[p];};
f.prototype._getLocalName=function(n){var i=n.indexOf(":"),l=n;if(i>0){l=n.substr(i+1);}return l;};
f.prototype._getDocNSPrefixes=function(){var p={},D=this.oData&&this.oData.documentElement;if(!D){return p;}var A=D.attributes;e(A,function(i,o){var n=o.name,v=o.value;if(n=="xmlns"){p[v]="";}else if(n.indexOf("xmlns")==0){p[v]=n.substr(6);}});return p;};
f.prototype._resolve=function(p,o){var i=!p.startsWith("/"),r=p;if(i){if(o){r=o.getPath()+"/"+p;}else{r=this.isLegacySyntax()?"/"+p:undefined;}}return r;};
f.prototype.isList=function(p,o){return false;};
f.prototype._setMetaModel=function(m){this._oMetaModel=m;};
f.prototype.getMetaModel=function(){return this._oMetaModel;};
return f;});
sap.ui.predefine('sap/ui/model/xml/XMLPropertyBinding',['sap/ui/model/ChangeReason','sap/ui/model/ClientPropertyBinding',"sap/base/util/deepEqual"],function(C,a,d){"use strict";
var X=a.extend("sap.ui.model.xml.XMLPropertyBinding");
X.prototype.setValue=function(v){if(this.bSuspended){return;}if(this.oValue!=v){if(this.oModel.setProperty(this.sPath,v,this.oContext,true)){this.oValue=v;this.oModel.firePropertyChange({reason:C.Binding,path:this.sPath,context:this.oContext,value:v});}}};
X.prototype.checkUpdate=function(f){if(this.bSuspended&&!f){return;}var v=this._getValue();if(!d(v,this.oValue)||f){this.oValue=v;this._fireChange({reason:C.Change});}};
return X;});
sap.ui.predefine('sap/ui/model/xml/XMLTreeBinding',['sap/ui/model/ClientTreeBinding',"sap/base/util/each"],function(C,e){"use strict";
var X=C.extend("sap.ui.model.xml.XMLTreeBinding");
X.prototype.getNodeContexts=function(c,s,l){if(!s){s=0;}if(!l){l=this.oModel.iSizeLimit;}var a=c.getPath();if(!a.endsWith("/")){a=a+"/";}if(!a.startsWith("/")){a="/"+a;}var b=[],n={},t=this,N=this.oModel._getObject(c.getPath()),d,o;e(N[0].childNodes,function(f,g){if(g.nodeType==1){if(n[g.nodeName]==undefined){n[g.nodeName]=0;}else{n[g.nodeName]++;}d=a+g.nodeName+"/"+n[g.nodeName];o=t.oModel.getContext(d);if(t.oCombinedFilter&&!t.bIsFiltering){if(t.filterInfo.aFilteredContexts&&t.filterInfo.aFilteredContexts.indexOf(o)!=-1){b.push(o);}}else{b.push(o);}}});this._applySorter(b);this._setLengthCache(a,b.length);return b.slice(s,s+l);};
return X;});
sap.ui.predefine('sap/ui/util/Mobile',['sap/ui/Device','sap/base/Log',"sap/ui/thirdparty/jquery"],function(D,L,q){"use strict";var M={};var _=false;
M.init=function(o){var $=q("head");if(!_){_=true;o=q.extend({},{viewport:true,statusBar:"default",hideBrowser:true,preventScroll:true,preventPhoneNumberDetection:true,useFullScreenHeight:true,homeIconPrecomposed:false,mobileWebAppCapable:"default"},o);if(o.preventPhoneNumberDetection){$.append(q('<meta name="format-detection" content="telephone=no">'));}if(o.viewport){var m;var i=D.resize.height;var I=D.resize.width;m="width=device-width, initial-scale=1.0";$.append(q('<meta name="viewport" content="'+m+'">'));if((i!==window.innerHeight||I!==window.innerWidth)&&D.resize._update){D.resize._update();}}if(o.useFullScreenHeight){q(function(){document.documentElement.style.height="100%";});}if(o.preventScroll&&(D.os.ios||(D.os.mac&&D.browser.mobile))){q(function(){document.documentElement.style.position="fixed";document.documentElement.style.overflow="hidden";document.documentElement.style.height="100%";document.documentElement.style.width="100%";});}}if(o){if(o.homeIcon){var a;if(typeof o.homeIcon==="string"){a={phone:o.homeIcon,favicon:o.homeIcon};}else{a=q.extend({},o.homeIcon);a.phone=o.homeIcon.phone||o.homeIcon.icon||a.favicon;a.favicon=a.favicon||o.homeIcon.icon||o.homeIcon.phone;a.icon=undefined;}a.precomposed=o.homeIconPrecomposed||a.precomposed;M.setIcons(a);}if(o.hasOwnProperty("mobileWebAppCapable")){M.setWebAppCapable(o.mobileWebAppCapable,o.statusBar);}}};
M.setIcons=function(i){if(!i||(typeof i!=="object")){L.warning("Call to sap/ui/util/Mobile.setIcons() has been ignored because there were no icons given or the argument was not an object.");return;}var $=q("head"),p=i.precomposed?"-precomposed":"",g=function(r){return i[r]||i['tablet@2']||i['phone@2']||i['phone']||i['tablet'];},s={"phone":"","tablet":"76x76","phone@2":"120x120","tablet@2":"152x152"};if(i["favicon"]){var a=$.find("[rel=icon]");a.each(function(){if(this.rel==="icon"){q(this).remove();}});$.append(q('<link rel="icon" href="'+i["favicon"]+'">'));}if(g("phone")){$.find("[rel=apple-touch-icon]").remove();$.find("[rel=apple-touch-icon-precomposed]").remove();}for(var b in s){i[b]=i[b]||g(b);if(i[b]){var c=s[b];$.append(q('<link rel="apple-touch-icon'+p+'" '+(c?'sizes="'+c+'"':"")+' href="'+i[b]+'">'));}}};
M.setWebAppCapable=function(v,a){if(!D.system.tablet&&!D.system.phone){return;}var h=q("head"),p=["","apple"],n="mobile-web-app-capable",c=v?"yes":"no",i,N,w;for(i=0;i<p.length;i++){N=p[i]?(p[i]+"-"+n):n;w=h.children('meta[name="'+N+'"]');if(w.length){w.attr("content",c);}else{h.append(q('<meta name="'+N+'" content="'+c+'">'));if(p[i]==="apple"){h.append(q('<meta name="apple-mobile-web-app-status-bar-style" content="'+(a?a:'default')+'">'));}}}};
return M;});
sap.ui.predefine('sap/ui/util/Storage',["sap/base/assert"],function(a){"use strict";var S="state.key_";var b=function(c,s){var t="unknown",P=(s||S)+"-",o;if(!c||typeof(c)==="string"){t=c||b.Type.session;try{o=window[t+"Storage"];if(o){var T=P+"___sapui5TEST___";o.setItem(T,"1");o.removeItem(T);}}catch(e){o=null;}}else if(typeof(c)==="object"){t=c.getType?c.getType():"unknown";o=c;}var h=function(f){try{if(this.isSupported()){f();return true;}}catch(e){return false;}return false;}.bind(this);this.isSupported=function(){return typeof(o.isSupported)=="function"?o.isSupported():true;};this.put=function(k,d){a(typeof k==="string"&&k.length>0,"key must be a non-empty string");return h(function(){o.setItem(P+k,JSON.stringify(d));});};this.get=function(k){a(typeof k==="string"&&k.length>0,"key must be a non-empty string");var d;h(function(){d=JSON.parse(o.getItem(P+k));});return d!==undefined?d:null;};this.remove=function(k){a(typeof k==="string"&&k.length>0,"key must be a non-empty string");return h(function(){o.removeItem(P+k);});};this.removeAll=function(I){return h(function(){var p=P+(I||""),k=[],d,i;for(i=0;i<o.length;i++){d=o.key(i);if(d&&d.startsWith(p)){k.push(d);}}for(i=0;i<k.length;i++){o.removeItem(k[i]);}});};this.clear=function(){return h(function(){o.clear();});};this.getType=function(){return t;};};b.Type={local:"local",session:"session"};Object.assign(b,new b());return b;});
sap.ui.predefine('sap/ui/util/XMLHelper',['sap/ui/Device'],function(D){"use strict";var H={};
H.parse=function(x){var X;var p;var a=new DOMParser();X=a.parseFromString(x,"text/xml");p=H.getParseError(X);if(p){if(!X.parseError){X.parseError=p;}}return X;};
H.getParseError=function(d){var p={errorCode:-1,url:"",reason:"unknown error",srcText:"",line:-1,linepos:-1,filepos:-1,type:"error"};if(D.browser.firefox&&d&&d.documentElement&&d.documentElement.tagName=="parsererror"){var e=d.documentElement.firstChild.nodeValue,r=/XML Parsing Error: (.*)\nLocation: (.*)\nLine Number (\d+), Column (\d+):(.*)/,m=r.exec(e);if(m){p.reason=m[1];p.url=m[2];p.line=parseInt(m[3]);p.linepos=parseInt(m[4]);p.srcText=m[5];p.type="error";}return p;}if(D.browser.webkit&&d&&d.documentElement&&d.getElementsByTagName("parsererror").length>0){var e=H.serialize(d),r=/(error|warning) on line (\d+) at column (\d+): ([^<]*)\n/,m=r.exec(e);if(m){p.reason=m[4];p.url="";p.line=parseInt(m[2]);p.linepos=parseInt(m[3]);p.srcText="";p.type=m[1];}return p;}if(!d||!d.documentElement){return p;}return{errorCode:0};};
H.serialize=function(x){var s=new XMLSerializer();return s.serializeToString(x);};
return H;});
sap.ui.predefine('sap/ui/util/_FeatureDetection',[],function(){"use strict";var d={};
function a(){var b=document.createElement("div");b.innerHTML='<div dir="rtl"><div><span></span><span></span></div></div>';b.firstChild.style='width: 1px; height: 1px; position: fixed; top: 0px; left: 0px; overflow: hidden';b.firstChild.firstChild.style='width: 2px';b.firstChild.firstChild.firstChild.style='display: inline-block; width: 1px';b.firstChild.firstChild.lastChild.style='display: inline-block; width: 1px';document.documentElement.appendChild(b);var c=b.firstChild;d.initialZero=c.scrollLeft==0;document.documentElement.removeChild(b);}
a();var _={initialScrollPositionIsZero:function(){return d.initialZero;}};return _;});
sap.ui.predefine('sap/ui/util/defaultLinkTypes',[],function(){"use strict";var d=function a(r,t){r=typeof r==="string"?r.trim():r;if(!r&&t&&t!=="_self"){return"noopener noreferrer";}return r;};return d;});
sap.ui.predefine('sap/ui/util/isCrossOriginURL',[],function(){"use strict";
function i(h){var u=new URL(h,document.baseURI);return(u.origin==='null'||window.location.origin==='null'||u.origin!==window.location.origin);}
return i;});
sap.ui.predefine('sap/ui/util/openWindow',[],function(){"use strict";var o=function a(u,w){var W="noopener,noreferrer";return window.open(u,w,W);};return o;});
sap.ui.predefine('jquery.sap.dom',['jquery.sap.global','sap/ui/dom/containsOrEquals','sap/ui/core/syncStyleClass','sap/ui/dom/getOwnerWindow','sap/ui/dom/getScrollbarSize','sap/ui/dom/denormalizeScrollLeftRTL','sap/ui/dom/denormalizeScrollBeginRTL','sap/ui/dom/units/Rem','sap/ui/dom/jquery/Aria','sap/ui/dom/jquery/Selection','sap/ui/dom/jquery/zIndex','sap/ui/dom/jquery/parentByAttribute','sap/ui/dom/jquery/cursorPos','sap/ui/dom/jquery/selectText','sap/ui/dom/jquery/getSelectedText','sap/ui/dom/jquery/rect','sap/ui/dom/jquery/rectContains','sap/ui/dom/jquery/Focusable','sap/ui/dom/jquery/hasTabIndex','sap/ui/dom/jquery/scrollLeftRTL','sap/ui/dom/jquery/scrollRightRTL','sap/ui/dom/jquery/Selectors'],function(q,d,s,a,b,c,e,f){"use strict";
q.sap.domById=function g(i,w){return i?(w||window).document.getElementById(i):null;};
q.sap.byId=function h(i,C){var g="";if(i){g="#"+i.replace(/(:|\.)/g,'\\$1');}return q(g,C);};
q.sap.focus=function g(D){if(!D){return;}D.focus();return true;};
q.sap.pxToRem=f.fromPx;q.sap.remToPx=f.toPx;
q.fn.outerHTML=function(){var D=this.get(0);if(D&&D.outerHTML){return D.outerHTML.trim();}else{var g=this[0]?this[0].ownerDocument:document;var o=g.createElement("div");o.appendChild(D.cloneNode(true));return o.innerHTML;}};
q.sap.containsOrEquals=d;q.sap.denormalizeScrollLeftRTL=c;q.sap.denormalizeScrollBeginRTL=e;
/*
	 * The following implementation of jQuery.support.selectstart is taken from jQuery UI core but modified.
	 *
	 * jQuery UI Core
	 * http://jqueryui.com
	 *
	 * Copyright 2014 jQuery Foundation and other contributors
	 * Released under the MIT license.
	 * http://jquery.org/license
	 *
	 * http://api.jqueryui.com/category/ui-core/
	 */
q.support.selectstart="onselectstart"in document.createElement("div");q.sap.ownerWindow=a;q.sap.scrollbarSize=b;q.sap.syncStyleClass=s;return q;});
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('jquery.sap.script',['jquery.sap.global','sap/base/util/uid','sap/base/strings/hash','sap/base/util/array/uniqueSort','sap/base/util/deepEqual','sap/base/util/each','sap/base/util/array/diff','sap/base/util/JSTokenizer','sap/base/util/merge','sap/base/util/UriParameters'],function(q,u,h,a,d,e,b,J,m,U){"use strict";q.sap.uid=u;q.sap.hashCode=h;q.sap.unique=a;q.sap.equal=d;q.sap.each=e;q.sap.arraySymbolDiff=b;
q.sap._createJSTokenizer=function(){return new J();};
q.sap.parseJS=J.parseJS;
q.sap.extend=function(){var c=arguments,f=false;if(typeof arguments[0]==="boolean"){f=arguments[0];c=Array.prototype.slice.call(arguments,1);}if(f){return m.apply(this,c);}else{
/*
			 * The code in this function is taken from jQuery 3.6.0 "jQuery.extend" and got modified.
			 *
			 * jQuery JavaScript Library v3.6.0
			 * https://jquery.com/
			 *
			 * Copyright OpenJS Foundation and other contributors
			 * Released under the MIT license
			 * https://jquery.org/license
			 */
var g,n,o,t=arguments[0]||{},i=1,l=arguments.length;if(typeof t!=="object"&&typeof t!=="function"){t={};}for(;i<l;i++){o=arguments[i];for(n in o){g=o[n];if(n==="__proto__"||t===g){continue;}t[n]=g;}}return t;}};
q.sap.getUriParameters=function g(s){return U.fromURL(s||window.location.href);};
q.sap.delayedCall=function f(D,o,c,p){return setTimeout(function(){if(typeof c==="string"){c=o[c];}c.apply(o,p||[]);},D);};
q.sap.clearDelayedCall=function c(D){clearTimeout(D);return this;};
q.sap.intervalCall=function f(i,o,c,p){return setInterval(function(){if(typeof c==="string"){c=o[c];}c.apply(o,p||[]);},i);};
q.sap.clearIntervalCall=function c(i){clearInterval(i);return this;};
q.sap.forIn=e;
q.sap.arrayDiff=function(o,n,c,f){c=c||function(v,V){return d(v,V);};var O=[];var N=[];var M=[];for(var i=0;i<n.length;i++){var g=n[i];var F=0;var t;if(f&&c(o[i],g)){F=1;t=i;}else{for(var j=0;j<o.length;j++){if(c(o[j],g)){F++;t=j;if(f||F>1){break;}}}}if(F==1){var k={oldIndex:t,newIndex:i};if(M[t]){delete O[t];delete N[M[t].newIndex];}else{N[i]={data:n[i],row:t};O[t]={data:o[t],row:i};M[t]=k;}}}for(var i=0;i<n.length-1;i++){if(N[i]&&!N[i+1]&&N[i].row+1<o.length&&!O[N[i].row+1]&&c(o[N[i].row+1],n[i+1])){N[i+1]={data:n[i+1],row:N[i].row+1};O[N[i].row+1]={data:O[N[i].row+1],row:i+1};}}for(var i=n.length-1;i>0;i--){if(N[i]&&!N[i-1]&&N[i].row>0&&!O[N[i].row-1]&&c(o[N[i].row-1],n[i-1])){N[i-1]={data:n[i-1],row:N[i].row-1};O[N[i].row-1]={data:O[N[i].row-1],row:i-1};}}var D=[];if(n.length==0){for(var i=0;i<o.length;i++){D.push({index:0,type:'delete'});}}else{var l=0;if(!O[0]){for(var i=0;i<o.length&&!O[i];i++){D.push({index:0,type:'delete'});l=i+1;}}for(var i=0;i<n.length;i++){if(!N[i]||N[i].row>l){D.push({index:i,type:'insert'});}else{l=N[i].row+1;for(var j=N[i].row+1;j<o.length&&(!O[j]||O[j].row<i);j++){D.push({index:i+1,type:'delete'});l=j+1;}}}}return D;};
return q;});
/*!
* OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
*/
sap.ui.predefine('sap/ui/core/hyphenation/Hyphenation',["./HyphenationTestingWords","sap/ui/base/ManagedObject","sap/base/Log","sap/ui/core/Locale"],function(H,M,L,a){"use strict";var t={'bg':true,'ca':true,'hr':true,'cs':false,
// no valid license
'da':true,'nl':true,'en-us':true,'et':true,'fi':true,'fr':true,'de':true,'el-monoton':true,'hi':true,'hu':true,'it':true,'lt':true,'nb-no':true,'pl':false,'pt':true,'ru':true,'sr':false,'sl':true,'es':true,'sv':true,'th':true,'tr':true,'uk':true};var l={"bg":"Bulgarian","ca":"Catalan","hr":"Croatian","cs":"Czech","da":"Danish","nl":"Dutch","en":"English","et":"Estonian","fi":"Finnish","fr":"French","de":"German","el":"Greek","hi":"Hindi","hu":"Hungarian","it":"Italian","lt":"Lithuanian","nb":"Norwegian Bokmål","no":"Norwegian","pl":"Polish","pt":"Portuguese","ru":"Russian","sr":"Serbian","sl":"Slovenian","es":"Spanish","sv":"Swedish","th":"Thai","tr":"Turkish","uk":"Ukrainian"};var b={};var s={};var T={};var h=null;var f=null;var o={};
function i(e){L.info("[UI5 Hyphenation] Initializing third-party module for language "+u(e),"sap.ui.core.hyphenation.Hyphenation.initialize()");var x=c();x.require[e]="FORCEHYPHENOPOLY";return d(sap.ui.require.toUrl("sap/ui/thirdparty/hyphenopoly/"),"Hyphenopoly_Loader.js").then(function(){delete x.require[e];return window.Hyphenopoly.hyphenators[e];});}
function c(){if(!window.Hyphenopoly){window.Hyphenopoly={require:{},setup:{selectors:{".hyphenate":{hyphen:"\u00AD",leftmin:3,rightmin:3,compound:"all"}},hide:"DONT_HIDE"},handleEvent:{error:function(e){if(e.msg.match(/engine for language .* loaded, but no elements found./)){e.preventDefault();}}}};}return window.Hyphenopoly;}
function d(P,F){return new Promise(function(e,x){var y=document.createElement('script');y.async=true;y.src=P+F;y.addEventListener('load',e);y.addEventListener('error',function(){return x('Error loading script: '+F);});y.addEventListener('abort',function(){return x(F+' Script loading aborted.');});document.head.appendChild(y);});}
var g=(function x(){var e=["visibility:hidden;","-moz-hyphens:auto;","-webkit-hyphens:auto;","hyphens:auto;","width:48px;","font-size:12px;","line-height:12px;","border:none;","padding:0;","word-wrap:normal"];return e.join("");}());
function j(e,x){if(!f){f=document.createElement("body");}var y=document.createElement("div");y.lang=e;y.id=e;y.style.cssText=g;y.appendChild(document.createTextNode(x));f.appendChild(y);}
function k(e){if(f){e.appendChild(f);return f;}return null;}
function m(){if(f){f.parentNode.removeChild(f);}}
function n(e){return(e.style.hyphens==="auto"||e.style.webkitHyphens==="auto"||e.style.msHyphens==="auto"||e.style["-moz-hyphens"]==="auto");}
function p(e){var x;if(e){x=new a(e);}else{x=sap.ui.getCore().getConfiguration().getLocale();}var y=x.getLanguage().toLowerCase();switch(y){case"en":y="en-us";break;case"nb":y="nb-no";break;case"no":y="nb-no";break;case"el":y="el-monoton";break;default:break;}return y;}
function q(e){if(e){return new a(e).toString();}return sap.ui.getCore().getConfiguration().getLocale().toString();}
function r(P){if(typeof P==="string"){return P.substring(0,2);}else{return null;}}
function u(P){var e=r(P);if(l.hasOwnProperty(e)){return"'"+l[e]+"' (code:'"+e+"')";}else{return"'"+e+"'";}}
function v(e){h.fireError(e);L.error("[UI5 Hyphenation] "+e,"sap.ui.core.hyphenation.Hyphenation");}
var w=M.extend("sap.ui.core.hyphenation.Hyphenation",{metadata:{library:"sap.ui.core",events:{error:{parameters:{sErrorMessage:{type:"string"}}}}}});
w.prototype.canUseNativeHyphenation=function(e){var x=q(e),y=p(e),C;if(!this.isLanguageSupported(y)){return null;}if(!b.hasOwnProperty(x)){j(x,H[y.toLowerCase()]);var z=k(document.documentElement);if(z!==null){var A=document.getElementById(x);if(n(A)&&A.offsetHeight>12){C=true;}else{C=false;}m();}b[x]=C;if(C){L.info("[UI5 Hyphenation] Browser-native hyphenation can be used for language "+u(x),"sap.ui.core.hyphenation.Hyphenation.canUseNativeHyphenation()");}else{L.info("[UI5 Hyphenation] Browser-native hyphenation is not supported by current platform for language "+u(x),"sap.ui.core.hyphenation.Hyphenation.canUseNativeHyphenation()");}}else{C=b[x];}return C;};
w.prototype.canUseThirdPartyHyphenation=function(e){var x=p(e),C;if(!this.isLanguageSupported(e)){return null;}if(!T.hasOwnProperty(x)){C=t.hasOwnProperty(x)&&t[x];if(C){L.info("[UI5 Hyphenation] Third-party hyphenation can be used for language "+u(x),"sap.ui.core.hyphenation.Hyphenation.canUseThirdPartyHyphenation()");}else{L.info("[UI5 Hyphenation] Third-party hyphenation is not supported for language "+u(x),"sap.ui.core.hyphenation.Hyphenation.canUseThirdPartyHyphenation()");}T[x]=C;}else{C=T[x];}return C;};
w.prototype.isLanguageSupported=function(e){var x=p(e),I;if(!s.hasOwnProperty(x)){I=H.hasOwnProperty(x);if(!I){L.info("[UI5 Hyphenation] Language "+u(x)+" is not known to the Hyphenation API","sap.ui.core.hyphenation.Hyphenation.isLanguageSupported()");}s[x]=I;}else{I=s[x];}return I;};
w.prototype.hyphenate=function(e,x){var y=p(x);if(!o.hasOwnProperty(y)){v("Language "+u(y)+" is not initialized. You have to initialize it first with method 'initialize()'");return e;}return o[y](e);};
w.prototype.getInitializedLanguages=function(){return Object.keys(o).map(function(e){return r(e);});};
w.prototype.isLanguageInitialized=function(e){var e=p(e);return Object.keys(o).indexOf(e)!=-1;};
w.prototype.initialize=function(e){var x=p(e);if(!t[x]){var y="Language "+u(e)+" can not be initialized. It is either not supported by the third-party module or an error occurred";v(y);return Promise.reject(y);}if(o[x]){return Promise.resolve();}var z;if(!this._pInitLanguage){z=this._pInitLanguage=i(x).then(function(A){o[x]=A;this._pInitLanguage=null;}.bind(this));}else{z=this._pInitLanguage.then(function(){return this.initialize(e);}.bind(this));}return z;};
w.getInstance=function(){if(!h){h=new w();}return h;};
return w;});
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/core/library',['sap/ui/base/DataType','sap/ui/core/mvc/ViewType','./CalendarType','./Core'],function(D,V){"use strict";sap.ui.getCore().initLibrary({name:"sap.ui.core",version:"1.98.0",designtime:"sap/ui/core/designtime/library.designtime",types:["any","boolean","float","int","object","string","void","sap.ui.core.AbsoluteCSSSize","sap.ui.core.AccessibleRole","sap.ui.core.AccessibleLandmarkRole","sap.ui.core.aria.HasPopup","sap.ui.core.BarColor","sap.ui.core.BusyIndicatorSize","sap.ui.core.CalendarType","sap.ui.core.CSSColor","sap.ui.core.CSSSize","sap.ui.core.CSSSizeShortHand","sap.ui.core.Collision","sap.ui.core.ComponentLifecycle","sap.ui.core.Design","sap.ui.core.Dock","sap.ui.core.HorizontalAlign","sap.ui.core.ID","sap.ui.core.IconColor","sap.ui.core.ImeMode","sap.ui.core.IndicationColor","sap.ui.core.MessageType","sap.ui.core.OpenState","sap.ui.core.Orientation","sap.ui.core.Percentage","sap.ui.core.Priority","sap.ui.core.ScrollBarAction","sap.ui.core.Scrolling","sap.ui.core.SortOrder","sap.ui.core.TextAlign","sap.ui.core.TextDirection","sap.ui.core.TitleLevel","sap.ui.core.URI","sap.ui.core.ValueState","sap.ui.core.VerticalAlign","sap.ui.core.Wrapping","sap.ui.core.InvisibleMessageMode","sap.ui.core.dnd.DropEffect","sap.ui.core.dnd.DropLayout","sap.ui.core.dnd.DropPosition","sap.ui.core.mvc.ViewType","sap.ui.core.routing.HistoryDirection"],interfaces:["sap.ui.core.IShrinkable","sap.ui.core.Label","sap.ui.core.PopupInterface","sap.ui.core.Toolbar","sap.ui.core.IContextMenu","sap.ui.core.IFormContent","sap.ui.core.dnd.IDragInfo","sap.ui.core.dnd.IDropInfo","sap.ui.core.IDScope","sap.ui.core.ITitleContent","sap.ui.core.IAsyncContentCreation","sap.ui.core.IPlaceholderSupport","sap.ui.core.IColumnHeaderMenu"],controls:["sap.ui.core.ComponentContainer","sap.ui.core.Control","sap.ui.core.HTML","sap.ui.core.Icon","sap.ui.core.InvisibleText","sap.ui.core.LocalBusyIndicator","sap.ui.core.ScrollBar","sap.ui.core.TooltipBase","sap.ui.core.XMLComposite","sap.ui.core.mvc.HTMLView","sap.ui.core.mvc.JSONView","sap.ui.core.mvc.JSView","sap.ui.core.mvc.TemplateView","sap.ui.core.mvc.View","sap.ui.core.mvc.XMLView","sap.ui.core.tmpl.DOMElement","sap.ui.core.tmpl.TemplateControl","sap.ui.core.util.Export"],elements:["sap.ui.core.CustomData","sap.ui.core.Element","sap.ui.core.Item","sap.ui.core.LayoutData","sap.ui.core.ListItem","sap.ui.core.Message","sap.ui.core.SeparatorItem","sap.ui.core.Title","sap.ui.core.VariantLayoutData","sap.ui.core.dnd.DragDropBase","sap.ui.core.dnd.DragInfo","sap.ui.core.dnd.DropInfo","sap.ui.core.dnd.DragDropInfo","sap.ui.core.search.OpenSearchProvider","sap.ui.core.search.SearchProvider","sap.ui.core.tmpl.DOMAttribute","sap.ui.core.util.ExportCell","sap.ui.core.InvisibleMessage"],extensions:{"sap.ui.support":{diagnosticPlugins:["sap/ui/core/support/plugins/TechInfo","sap/ui/core/support/plugins/ControlTree","sap/ui/core/support/plugins/Debugging","sap/ui/core/support/plugins/Trace","sap/ui/core/support/plugins/Selector","sap/ui/core/support/plugins/Breakpoint","sap/ui/core/support/plugins/ViewInfo","sap/ui/core/support/plugins/LocalStorage","sap/ui/core/support/plugins/Interaction","sap/ui/core/support/plugins/Performance"],publicRules:true,internalRules:true}}});var t=sap.ui.core;t.AbsoluteCSSSize=D.createType('sap.ui.core.AbsoluteCSSSize',{isValid:function(v){return/^([-+]?(0*|([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]))|calc\(\s*(\(\s*)*[-+]?(([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC])?)(\s*(\)\s*)*(\s[-+]\s|[*\/])\s*(\(\s*)*([-+]?(([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC])?)))*\s*(\)\s*)*\))$/.test(v);}},D.getType('string'));t.AccessibleRole={Alert:"Alert",AlertDialog:"AlertDialog",Application:"Application",Banner:"Banner",Button:"Button",Checkbox:"Checkbox",ColumnHeader:"ColumnHeader",Combobox:"Combobox",
/**
		 * Information about the content on the page. Examples are footnotes, copyrights, or links to privacy statements.
		 *
		 * @public
		 */
ContentInfo:"ContentInfo",Definition:"Definition",Description:"Description",Dialog:"Dialog",Directory:"Directory",Document:"Document",Grid:"Grid",GridCell:"GridCell",Group:"Group",Heading:"Heading",Img:"Img",Link:"Link",List:"List",Listbox:"Listbox",ListItem:"ListItem",Log:"Log",Main:"Main",Marquee:"Marquee",Menu:"Menu",Menubar:"Menubar",MenuItem:"MenuItem",MenuItemCheckbox:"MenuItemCheckbox",MenuItemRadio:"MenuItemRadio",Navigation:"Navigation",Note:"Note",Option:"Option",Presentation:"Presentation",ProgressBar:"ProgressBar",Radio:"Radio",RadioGroup:"RadioGroup",Region:"Region",Row:"Row",RowHeader:"RowHeader",Search:"Search",Secondary:"Secondary",SeeAlso:"SeeAlso",Separator:"Separator",Slider:"Slider",SpinButton:"SpinButton",Status:"Status",Tab:"Tab",Tablist:"Tablist",Tabpanel:"Tabpanel",Textbox:"Textbox",Timer:"Timer",Toolbar:"Toolbar",Tooltip:"Tooltip",Tree:"Tree",TreeGrid:"TreeGrid",TreeItem:"TreeItem"};t.AccessibleLandmarkRole={None:"None",Banner:"Banner",Main:"Main",Region:"Region",Navigation:"Navigation",Search:"Search",Complementary:"Complementary",Form:"Form",ContentInfo:"ContentInfo"};t.aria=t.aria||{};t.aria.HasPopup={None:"None",Menu:"Menu",ListBox:"ListBox",Tree:"Tree",Grid:"Grid",Dialog:"Dialog"};t.BarColor={NEUTRAL:"NEUTRAL",POSITIVE:"POSITIVE",CRITICAL:"CRITICAL",NEGATIVE:"NEGATIVE"};t.BusyIndicatorSize={Auto:"Auto",Small:"Small",Medium:"Medium",Large:"Large"};t.CSSColor=D.createType('sap.ui.core.CSSColor',{isValid:function(v){return/^(#([0-9a-fA-F]{3}|[0-9a-fA-F]{6})|rgb\(\s*((1?[0-9]?[0-9]|2([0-4][0-9]|5[0-5]))|([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*(,\s*((1?[0-9]?[0-9]|2([0-4][0-9]|5[0-5]))|([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*){2}\)|rgba\((\s*((1?[0-9]?[0-9]|2([0-4][0-9]|5[0-5]))|([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*,){3}\s*(0(\.[0-9]+)?|1(\.0+)?)\s*\)|hsl\(\s*([0-2]?[0-9]?[0-9]|3([0-5][0-9]|60))\s*(,\s*(([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*){2}\)|hsla\(\s*([0-2]?[0-9]?[0-9]|3([0-5][0-9]|60))\s*,(\s*(([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*,){2}\s*(0(\.[0-9]+)?|1(\.0+)?)\s*\)|aliceblue|antiquewhite|aqua|aquamarine|azure|beige|bisque|black|blanchedalmond|blue|blueviolet|brown|burlywood|cadetblue|chartreuse|chocolate|coral|cornflowerblue|cornsilk|crimson|cyan|darkblue|darkcyan|darkgoldenrod|darkgray|darkgrey|darkgreen|darkkhaki|darkmagenta|darkolivegreen|darkorange|darkorchid|darkred|darksalmon|darkseagreen|darkslateblue|darkslategray|darkslategrey|darkturquoise|darkviolet|deeppink|deepskyblue|dimgray|dimgrey|dodgerblue|firebrick|floralwhite|forestgreen|fuchsia|gainsboro|ghostwhite|gold|goldenrod|gray|grey|green|greenyellow|honeydew|hotpink|indianred|indigo|ivory|khaki|lavender|lavenderblush|lawngreen|lemonchiffon|lightblue|lightcoral|lightcyan|lightgoldenrodyellow|lightgray|lightgrey|lightgreen|lightpink|lightsalmon|lightseagreen|lightskyblue|lightslategray|lightslategrey|lightsteelblue|lightyellow|lime|limegreen|linen|magenta|maroon|mediumaquamarine|mediumblue|mediumorchid|mediumpurple|mediumseagreen|mediumslateblue|mediumspringgreen|mediumturquoise|mediumvioletred|midnightblue|mintcream|mistyrose|moccasin|navajowhite|navy|oldlace|olive|olivedrab|orange|orangered|orchid|palegoldenrod|palegreen|paleturquoise|palevioletred|papayawhip|peachpuff|peru|pink|plum|powderblue|purple|red|rosybrown|royalblue|saddlebrown|salmon|sandybrown|seagreen|seashell|sienna|silverskyblue|slateblue|slategray|slategrey|snow|springgreen|steelblue|tan|teal|thistle|tomato|turquoise|violet|wheat|white|whitesmoke|yellow|yellowgreen|transparent|inherit|)$/.test(v);}},D.getType('string'));t.CSSSize=D.createType('sap.ui.core.CSSSize',{isValid:function(v){return/^(auto|inherit|[-+]?(0*|([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|[vV][wW]|[vV][hH]|[vV][mM][iI][nN]|[vV][mM][aA][xX]|%))|calc\(\s*(\(\s*)*[-+]?(([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|[vV][wW]|[vV][hH]|[vV][mM][iI][nN]|[vV][mM][aA][xX]|%)?)(\s*(\)\s*)*(\s[-+]\s|[*\/])\s*(\(\s*)*([-+]?(([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|[vV][wW]|[vV][hH]|[vV][mM][iI][nN]|[vV][mM][aA][xX]|%)?)))*\s*(\)\s*)*\))$/.test(v);}},D.getType('string'));t.CSSSizeShortHand=D.createType('sap.ui.core.CSSSizeShortHand',{isValid:function(v){return/^(inherit|(auto|[-+]?(0*|(\d+|\d*\.\d+)([eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|%))){1}(\s(auto|[-+]?(0*|(\d+|\d*\.\d+)([eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|%)))){0,3})$/.test(v);}},D.getType('string'));t.Collision=D.createType('sap.ui.core.Collision',{isValid:function(v){return/^((flip|fit|none)( (flip|fit|none))?)$/.test(v);}},D.getType('string'));t.Design={Standard:"Standard",Monospace:"Monospace"};t.Dock=D.createType('sap.ui.core.Dock',{isValid:function(v){return/^((begin|left|center|right|end) (top|center|bottom))$/.test(v);}},D.getType('string'));t.HorizontalAlign={Begin:"Begin",End:"End",Left:"Left",Right:"Right",Center:"Center"};t.ID=D.createType('sap.ui.core.ID',{isValid:function(v){return/^([A-Za-z_][-A-Za-z0-9_.:]*)$/.test(v);}},D.getType('string'));t.IconColor={Default:"Default",Positive:"Positive",Negative:"Negative",Critical:"Critical",Neutral:"Neutral",Contrast:"Contrast",NonInteractive:"NonInteractive",Tile:"Tile",Marker:"Marker"};t.ImeMode={Auto:"Auto",Active:"Active",Inactive:"Inactive",Disabled:"Disabled"};t.IndicationColor={Indication01:"Indication01",Indication02:"Indication02",Indication03:"Indication03",Indication04:"Indication04",Indication05:"Indication05",Indication06:"Indication06",Indication07:"Indication07",Indication08:"Indication08"};t.MessageType={Information:"Information",Warning:"Warning",Error:"Error",None:"None",Success:"Success"};t.OpenState={OPEN:"OPEN",CLOSED:"CLOSED",OPENING:"OPENING",CLOSING:"CLOSING"};t.Orientation={Horizontal:"Horizontal",Vertical:"Vertical"};t.Percentage=D.createType('sap.ui.core.Percentage',{isValid:function(v){return/^([0-9][0-9]*(\.[0-9]+)?%)$/.test(v);}},D.getType('string'));t.Priority={None:"None",Low:"Low",Medium:"Medium",High:"High"};t.ScrollBarAction={Step:"Step",Page:"Page",MouseWheel:"MouseWheel",Drag:"Drag"};t.Scrolling={None:"None",Auto:"Auto",Scroll:"Scroll",Hidden:"Hidden"};t.SortOrder={None:"None",Ascending:"Ascending",Descending:"Descending"};t.TextAlign={Begin:"Begin",End:"End",Left:"Left",Right:"Right",Center:"Center",Initial:"Initial"};t.TextDirection={LTR:"LTR",RTL:"RTL",Inherit:"Inherit"};t.TitleLevel={Auto:"Auto",H1:"H1",H2:"H2",H3:"H3",H4:"H4",H5:"H5",H6:"H6"};t.URI=D.createType('sap.ui.core.URI',{isValid:function(v){return/^((([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?)$/.test(v);}},D.getType('string'));t.ValueState={Error:"Error",Warning:"Warning",Success:"Success",Information:"Information",None:"None"};t.VerticalAlign={Bottom:"Bottom",Middle:"Middle",Top:"Top",Inherit:"Inherit"};t.Wrapping={None:"None",Soft:"Soft",Hard:"Hard",Off:"Off"};t.dnd=t.dnd||{};t.dnd.DropPosition={On:"On",Between:"Between",OnOrBetween:"OnOrBetween"};t.dnd.DropLayout={Default:"Default",Vertical:"Vertical",Horizontal:"Horizontal"};t.dnd.DropEffect={Copy:"Copy",Move:"Move",Link:"Link",None:"None"};t.mvc=t.mvc||{};t.mvc.ViewType=V;t.routing=t.routing||{};t.routing.HistoryDirection={Forwards:"Forwards",Backwards:"Backwards",NewEntry:"NewEntry",Unknown:"Unknown"};sap.ui.core.ComponentLifecycle={Legacy:"Legacy",Application:"Application",Container:"Container"};sap.ui.core.InvisibleMessageMode={Polite:"Polite",Assertive:"Assertive"};var l=sap.ui.lazyRequire;
function e(p,c,s){for(var i=0;i<c.length;i++){if(s){l(s,c[i].toLowerCase(),p+c[i]);}else{l(p+c[i],"new extend getMetadata");}}}
l("sap.ui.core.BusyIndicator","show hide attachOpen detachOpen attachClose detachClose");l("sap.ui.core.tmpl.Template","registerType unregisterType");l("sap.ui.core.Fragment","registerType byId createId");l("sap.ui.core.IconPool","createControlByURI addIcon getIconURI getIconInfo isIconURI getIconCollectionNames getIconNames getIconForMimeType");l("sap.ui.core.service.ServiceFactoryRegistry","register unregister get");l("sap.ui.model.odata.AnnotationHelper","createPropertySetting format getNavigationPath"+" gotoEntitySet gotoEntityType gotoFunctionImport isMultiple resolvePath simplePath");var A=sap.ui.model&&sap.ui.model.odata&&sap.ui.model.odata.AnnotationHelper;if(A){A.format.requiresIContext=true;A.getNavigationPath.requiresIContext=true;A.isMultiple.requiresIContext=true;A.simplePath.requiresIContext=true;}l("sap.ui","xmlfragment","sap.ui.core.Fragment");l("sap.ui","jsfragment","sap.ui.core.Fragment");l("sap.ui","htmlfragment","sap.ui.core.Fragment");e("sap.ui.model.",["Filter","Sorter","json.JSONModel","resource.ResourceModel","odata.ODataModel","odata.v2.ODataModel","odata.v4.ODataModel","xml.XMLModel"]);e("sap.ui.model.type.",["Boolean","Integer","Float","String","Date","Time","DateTime","FileSize","Currency","Unit","DateInterval","DateTimeInterval","TimeInterval"]);e("sap.ui.model.odata.type.",["Boolean","Byte","Currency","Date","DateTime","DateTimeOffset","Double","Decimal","Guid","Int16","Int32","Int64","Raw","SByte","Single","Stream","String","Time","TimeOfDay","Unit"]);e("sap.ui.core.",["Locale","LocaleData","mvc.Controller","UIComponent"]);e("sap.ui.core.mvc.",["Controller","View","JSView","JSONView","XMLView","HTMLView","TemplateView"],"sap.ui");e("sap.ui.core.",["Component"],"sap.ui");e("sap.ui.core.tmpl.",["Template"],"sap.ui");e("sap.ui.core.routing.",["HashChanger","History","Route","Router","Target","Targets","Views"]);e("sap.ui.core.service.",["ServiceFactory","Service"]);return sap.ui.core;});
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/dom/jquery/zIndex',['sap/ui/thirdparty/jquery'],function(q){"use strict";
function g(t,p){var d=Object.getOwnPropertyDescriptor(t,p);return d&&d.value;}
if(!g(q.fn,"zIndex")){var f=function(z){if(z!==undefined){return this.css("zIndex",z);}if(this.length){var e=q(this[0]),p,v;while(e.length&&e[0]!==document){p=e.css("position");if(p==="absolute"||p==="relative"||p==="fixed"){v=parseInt(e.css("zIndex"));if(!isNaN(v)&&v!==0){return v;}}e=e.parent();}}return 0;};
/*!
		 * The following function is taken from
		 * jQuery UI Core 1.11.1
		 * http://jqueryui.com
		 *
		 * Copyright 2014 jQuery Foundation and other contributors
		 * Released under the MIT license.
		 * http://jquery.org/license
		 *
		 * http://api.jqueryui.com/category/ui-core/
		 */
q.fn.zIndex=f;}return q;});
sap.ui.require.preload({
	"sap/ui/core/manifest.json":'{"_version":"1.21.0","sap.app":{"id":"sap.ui.core","type":"library","embeds":[],"applicationVersion":{"version":"1.98.0"},"title":"The SAPUI5 Core Runtime.","description":"The SAPUI5 Core Runtime.\\n\\n  Contains the UI5 jQuery plugins (jQuery.sap.*), the Core and all its components,\\n  base classes for Controls, Components and the Model View Controller classes.","ach":"CA-UI5-COR","resources":"resources.json","offline":true,"openSourceComponents":[{"name":"jquery-3","packagedWithMySelf":true,"version":"3.6.0"},{"name":"jquery-1","packagedWithMySelf":true,"version":"1.7.1"},{"name":"jquery_UI_1-8-17","packagedWithMySelf":true,"version":"1.8.17"},{"name":"jquery_UI-1-10-4","packagedWithMySelf":true,"version":"1.10.4"},{"name":"jquery_UI_1-11-1","packagedWithMySelf":true,"version":"1.11.1"},{"name":"qunit","packagedWithMySelf":true,"version":"1.18.0"},{"name":"qunit-2","packagedWithMySelf":true,"version":"2.3.2"},{"name":"jquery-migrate","packagedWithMySelf":true,"version":"3.3.1"},{"name":"jquery_mobile","packagedWithMySelf":true,"version":"1.3.1"},{"name":"jquery.rtl-scroll-type","packagedWithMySelf":true,"version":"2.0.0"},{"name":"qunit-composite","packagedWithMySelf":true,"version":"1.0.2-pre"},{"name":"qunit-reporter-junit","packagedWithMySelf":true,"version":"1.1.1"},{"name":"iscroll","packagedWithMySelf":true,"version":"4.2.5"},{"name":"iscroll-lite","packagedWithMySelf":true,"version":"4.1.6"},{"name":"swipeview","packagedWithMySelf":true,"version":"1.0"},{"name":"mobify","packagedWithMySelf":true,"version":"1.1"},{"name":"zynga","packagedWithMySelf":true,"version":"1.2.1-0-g5d43806"},{"name":"less","packagedWithMySelf":true,"version":"1.6.3"},{"name":"datajs","packagedWithMySelf":true,"version":"unknown"},{"name":"d3","packagedWithMySelf":true,"version":"3.4.12"},{"name":"jszip","packagedWithMySelf":true,"version":"2.2.0"},{"name":"caja","packagedWithMySelf":true,"version":"Build 4884"},{"name":"cldr","packagedWithMySelf":true,"version":"35.1"},{"name":"mobiscroll","packagedWithMySelf":true,"version":"2.9.0"},{"name":"sinonjs","packagedWithMySelf":true,"version":"1.14.1"},{"name":"sinonjs4","packagedWithMySelf":true,"version":"4.4.6"},{"name":"sinon-qunit","packagedWithMySelf":true,"version":"2.0.0"},{"name":"urijs","packagedWithMySelf":true,"version":"1.19.7"},{"name":"punycodejs","packagedWithMySelf":true,"version":"1.4.0"},{"name":"handlebars","packagedWithMySelf":true,"version":"4.7.7"},{"name":"requirejs","packagedWithMySelf":true,"version":"2.1.8"},{"name":"crossroadsjs","packagedWithMySelf":true,"version":"0.12.0"},{"name":"hasherjs","packagedWithMySelf":true,"version":"1.2.0"},{"name":"jssignals","packagedWithMySelf":true,"version":"1.0.0"},{"name":"blanket","packagedWithMySelf":true,"version":"1.1.5"},{"name":"json-in-js","packagedWithMySelf":true,"version":"ff55d8d451"},{"name":"tdop","packagedWithMySelf":true,"version":"unknown"},{"name":"klayjs","packagedWithMySelf":true,"version":"0.4.1"},{"name":"bignumber","packagedWithMySelf":true,"version":"6.0.0"},{"name":"lodash","packagedWithMySelf":true,"version":"4.17.21"},{"name":"hyphenopoly","packagedWithMySelf":true,"version":"3.4.0"},{"name":"p-cancelable","packagedWithMySelf":true,"version":"2.0.0"},{"name":"@babel/helpers","packagedWithMySelf":true,"version":"7.10.4"},{"name":"jalaali","packagedWithMySelf":true,"version":"unknown"},{"name":"vkbeautify","packagedWithMySelf":true,"version":"0.99.00.beta"},{"name":"node-lru-cache","packagedWithMySelf":true,"version":"2.7.3"}]},"sap.ui":{"technology":"UI5","supportedThemes":["base","sap_hcb"]},"sap.ui5":{"dependencies":{"minUI5Version":"1.98","libs":{}},"library":{"i18n":{"bundleUrl":"messagebundle.properties","supportedLocales":["","ar","bg","ca","cs","cy","da","de","el","en","en-GB","en-US-sappsd","en-US-saprigi","en-US-saptrc","es","es-MX","et","fi","fr","fr-CA","hi","hr","hu","id","it","iw","ja","kk","ko","lt","lv","ms","nl","no","pl","pt","pt-PT","ro","ru","sh","sk","sl","sv","th","tr","uk","vi","zh-CN","zh-TW"]},"content":{"controls":["sap.ui.core.ComponentContainer","sap.ui.core.Control","sap.ui.core.HTML","sap.ui.core.Icon","sap.ui.core.InvisibleText","sap.ui.core.LocalBusyIndicator","sap.ui.core.ScrollBar","sap.ui.core.TooltipBase","sap.ui.core.XMLComposite","sap.ui.core.mvc.HTMLView","sap.ui.core.mvc.JSONView","sap.ui.core.mvc.JSView","sap.ui.core.mvc.TemplateView","sap.ui.core.mvc.View","sap.ui.core.mvc.XMLView","sap.ui.core.tmpl.DOMElement","sap.ui.core.tmpl.TemplateControl","sap.ui.core.util.Export"],"elements":["sap.ui.core.CustomData","sap.ui.core.Element","sap.ui.core.Item","sap.ui.core.LayoutData","sap.ui.core.ListItem","sap.ui.core.Message","sap.ui.core.SeparatorItem","sap.ui.core.Title","sap.ui.core.VariantLayoutData","sap.ui.core.dnd.DragDropBase","sap.ui.core.dnd.DragInfo","sap.ui.core.dnd.DropInfo","sap.ui.core.dnd.DragDropInfo","sap.ui.core.search.OpenSearchProvider","sap.ui.core.search.SearchProvider","sap.ui.core.tmpl.DOMAttribute","sap.ui.core.util.ExportCell","sap.ui.core.InvisibleMessage"],"types":["any","boolean","float","int","object","string","void","sap.ui.core.AbsoluteCSSSize","sap.ui.core.AccessibleRole","sap.ui.core.AccessibleLandmarkRole","sap.ui.core.aria.HasPopup","sap.ui.core.BarColor","sap.ui.core.BusyIndicatorSize","sap.ui.core.CalendarType","sap.ui.core.CSSColor","sap.ui.core.CSSSize","sap.ui.core.CSSSizeShortHand","sap.ui.core.Collision","sap.ui.core.ComponentLifecycle","sap.ui.core.Design","sap.ui.core.Dock","sap.ui.core.HorizontalAlign","sap.ui.core.ID","sap.ui.core.IconColor","sap.ui.core.ImeMode","sap.ui.core.IndicationColor","sap.ui.core.MessageType","sap.ui.core.OpenState","sap.ui.core.Orientation","sap.ui.core.Percentage","sap.ui.core.Priority","sap.ui.core.ScrollBarAction","sap.ui.core.Scrolling","sap.ui.core.SortOrder","sap.ui.core.TextAlign","sap.ui.core.TextDirection","sap.ui.core.TitleLevel","sap.ui.core.URI","sap.ui.core.ValueState","sap.ui.core.VerticalAlign","sap.ui.core.Wrapping","sap.ui.core.InvisibleMessageMode","sap.ui.core.dnd.DropEffect","sap.ui.core.dnd.DropLayout","sap.ui.core.dnd.DropPosition","sap.ui.core.mvc.ViewType","sap.ui.core.routing.HistoryDirection"],"interfaces":["sap.ui.core.IShrinkable","sap.ui.core.Label","sap.ui.core.PopupInterface","sap.ui.core.Toolbar","sap.ui.core.IContextMenu","sap.ui.core.IFormContent","sap.ui.core.dnd.IDragInfo","sap.ui.core.dnd.IDropInfo","sap.ui.core.IDScope","sap.ui.core.ITitleContent","sap.ui.core.IAsyncContentCreation","sap.ui.core.IPlaceholderSupport","sap.ui.core.IColumnHeaderMenu"]}}}}',
/*!!
 * Hasher <http://github.com/millermedeiros/hasher>
 * @author Miller Medeiros
 * @version 1.2.0 (2013/11/11 03:18 PM)
 * Released under the MIT License
 */
	"sap/ui/thirdparty/hasher.js":function(){;(function(){var f=function(s){var h=(function(w){var P=25,d=w.document,a=w.history,S=s.Signal,h,_,b,c,g,i,j=/#(.*)$/,k=/(\?.*)|(\#.*)/,l=/^\#/,m=(!+"\v1"),n=('onhashchange'in w)&&d.documentMode!==7,o=m&&!n,p=(location.protocol==='file:');function q(e){return String(e||'').replace(/\W/g,"\\$&");}function r(e){if(!e)return'';var D=new RegExp('^'+q(h.prependHash)+'|'+q(h.appendHash)+'$','g');return e.replace(D,'');}function t(){var D=j.exec(h.getURL());var E=(D&&D[1])||'';try{return h.raw?E:decodeURIComponent(E);}catch(e){return E;}}function u(){return(g)?g.contentWindow.frameHash:null;}function v(){g=d.createElement('iframe');g.src='about:blank';g.style.display='none';d.body.appendChild(g);}function x(){if(g&&_!==u()){var e=g.contentWindow.document;e.open();e.write('<html><head><title>'+d.title+'</title><script type="text/javascript">var frameHash="'+_+'";</script></head><body>&nbsp;</body></html>');e.close();}}function y(e,D){if(_!==e){var E=_;_=e;if(o){if(!D){x();}else{g.contentWindow.frameHash=e;}}return function(){h.changed.dispatch(r(e),r(E));};}}if(o){i=function(){var e=t(),D=u(),E;if(D!==_&&D!==e){h.setHash(r(D));}else if(e!==_){E=y(e);E&&E();}};}else{i=function(){var e=t(),D;if(e!==_){D=y(e);D&&D();}};}function z(e,D,E){if(e.addEventListener){e.addEventListener(D,E,false);}else if(e.attachEvent){e.attachEvent('on'+D,E);}}function A(e,D,E){if(e.removeEventListener){e.removeEventListener(D,E,false);}else if(e.detachEvent){e.detachEvent('on'+D,E);}}function B(e){e=Array.prototype.slice.call(arguments);var D=e.join(h.separator);D=D?h.prependHash+D.replace(l,'')+h.appendHash:D;return D;}function C(e){e=encodeURI(e);if(m&&p){e=e.replace(/\?/,'%3F');}return e;}h={VERSION:'1.2.0',raw:false,appendHash:'',prependHash:'/',separator:'/',changed:new S(),stopped:new S(),initialized:new S(),init:function(){if(c)return;_=t();if(n){z(w,'hashchange',i);}else{if(o){if(!g){v();}x();}b=setInterval(i,P);}c=true;h.initialized.dispatch(r(_));},stop:function(){if(!c)return;if(n){A(w,'hashchange',i);}else{clearInterval(b);b=null;}c=false;h.stopped.dispatch(r(_));},isActive:function(){return c;},getURL:function(){return w.location.href;},getBaseURL:function(){return h.getURL().replace(k,'');},setHash:function(e){var D;e=B.apply(null,arguments);if(e!==_){D=y(e);if(!h.raw){e=C(e);}w.location.hash='#'+e;D&&D();}},replaceHash:function(e){var D,E=w.location.href,F=E.indexOf("#");e=B.apply(null,arguments);if(e!==_){D=y(e);if(!h.raw){e=C(e);}if(F!==-1){E=E.slice(0,F);}w.location.replace(E+'#'+e);D&&D();}},getHash:function(){return r(_);},getHashAsArray:function(){return h.getHash().split(h.separator);},dispose:function(){h.stop();h.initialized.dispose();h.stopped.dispose();h.changed.dispose();g=h=w.hasher=null;},toString:function(){return'[hasher version="'+h.VERSION+'" hash="'+h.getHash()+'"]';}};h.initialized.memorize=true;return h;}(window));return h;};if(typeof define==='function'&&define.amd){define(['signals'],f);}else if(typeof exports==='object'){module.exports=f(require('signals'));}else{window['hasher']=f(window['signals']);}}());
},
/** @license
 * JS Signals <http://millermedeiros.github.com/js-signals/>
 * Released under the MIT license
 * Author: Miller Medeiros
 * Version: 1.0.0 - Build: 268 (2012/11/29 05:48 PM)
 */
	"sap/ui/thirdparty/signals.js":function(){(function(g){
function S(b,l,i,c,p){this._listener=l;this._isOnce=i;this.context=c;this._signal=b;this._priority=p||0;}
S.prototype={active:true,params:null,execute:function(p){var h,b;if(this.active&&!!this._listener){b=this.params?this.params.concat(p):p;h=this._listener.apply(this.context,b);if(this._isOnce){this.detach();}}return h;},detach:function(){return this.isBound()?this._signal.remove(this._listener,this.context):null;},isBound:function(){return(!!this._signal&&!!this._listener);},isOnce:function(){return this._isOnce;},getListener:function(){return this._listener;},getSignal:function(){return this._signal;},_destroy:function(){delete this._signal;delete this._listener;delete this.context;},toString:function(){return'[SignalBinding isOnce:'+this._isOnce+', isBound:'+this.isBound()+', active:'+this.active+']';}};
function v(l,n){if(typeof l!=='function'){throw new Error('listener is a required param of {fn}() and should be a Function.'.replace('{fn}',n));}}
function a(){this._bindings=[];this._prevParams=null;var b=this;this.dispatch=function(){a.prototype.dispatch.apply(b,arguments);};}
a.prototype={VERSION:'1.0.0',memorize:false,_shouldPropagate:true,active:true,_registerListener:function(l,i,b,p){var c=this._indexOfListener(l,b),d;if(c!==-1){d=this._bindings[c];if(d.isOnce()!==i){throw new Error('You cannot add'+(i?'':'Once')+'() then add'+(!i?'':'Once')+'() the same listener without removing the relationship first.');}}else{d=new S(this,l,i,b,p);this._addBinding(d);}if(this.memorize&&this._prevParams){d.execute(this._prevParams);}return d;},_addBinding:function(b){var n=this._bindings.length;do{--n;}while(this._bindings[n]&&b._priority<=this._bindings[n]._priority);this._bindings.splice(n+1,0,b);},_indexOfListener:function(l,c){var n=this._bindings.length,b;while(n--){b=this._bindings[n];if(b._listener===l&&b.context===c){return n;}}return-1;},has:function(l,c){return this._indexOfListener(l,c)!==-1;},add:function(l,b,p){v(l,'add');return this._registerListener(l,false,b,p);},addOnce:function(l,b,p){v(l,'addOnce');return this._registerListener(l,true,b,p);},remove:function(l,c){v(l,'remove');var i=this._indexOfListener(l,c);if(i!==-1){this._bindings[i]._destroy();this._bindings.splice(i,1);}return l;},removeAll:function(){var n=this._bindings.length;while(n--){this._bindings[n]._destroy();}this._bindings.length=0;},getNumListeners:function(){return this._bindings.length;},halt:function(){this._shouldPropagate=false;},dispatch:function(p){if(!this.active){return;}var b=Array.prototype.slice.call(arguments),n=this._bindings.length,c;if(this.memorize){this._prevParams=b;}if(!n){return;}c=this._bindings.slice();this._shouldPropagate=true;do{n--;}while(c[n]&&this._shouldPropagate&&c[n].execute(b)!==false);},forget:function(){this._prevParams=null;},dispose:function(){this.removeAll();delete this._bindings;delete this._prevParams;},toString:function(){return'[Signal active:'+this.active+' numListeners:'+this.getNumListeners()+']';}};var s=a;s.Signal=a;if(typeof define==='function'&&define.amd){define(function(){return s;});}else{g['signals']=s;}}(this));
},
/** @license
 * crossroads <http://millermedeiros.github.com/crossroads.js/>
 * Author: Miller Medeiros | MIT License
 * v0.12.0 (2013/01/21 13:47)
 */
	"sap/ui/thirdparty/crossroads.js":function(){(function(){var f=function(s){var c,_,U;_=(/t(.+)?/).exec('t')[1]==='';function a(i,v){if(i.indexOf){return i.indexOf(v);}else{var n=i.length;while(n--){if(i[n]===v){return n;}}return-1;}}function b(l,m){var i=a(l,m);if(i!==-1){l.splice(i,1);}}function d(v,i){return'[object '+i+']'===Object.prototype.toString.call(v);}function e(v){return d(v,'RegExp');}function g(v){return d(v,'Array');}function h(v){return typeof v==='function';}function t(v){var r;if(v===null||v==='null'){r=null;}else if(v==='true'){r=true;}else if(v==='false'){r=false;}else if(v===U||v==='undefined'){r=U;}else if(v===''||isNaN(v)){r=v;}else{r=parseFloat(v);}return r;}function j(v){var n=v.length,r=[];while(n--){r[n]=t(v[n]);}return r;}function k(i,l){var q=(i||'').replace('?','').split('&'),n=q.length,o={},m,v;while(n--){m=q[n].split('=');v=l?t(m[1]):m[1];o[m[0]]=(typeof v==='string')?decodeURIComponent(v):v;}return o;}function C(){this.bypassed=new s.Signal();this.routed=new s.Signal();this._routes=[];this._prevRoutes=[];this._piped=[];this.resetState();}C.prototype={greedy:false,greedyEnabled:true,ignoreCase:true,ignoreState:false,shouldTypecast:false,normalizeFn:null,resetState:function(){this._prevRoutes.length=0;this._prevMatchedRequest=null;this._prevBypassedRequest=null;},create:function(){return new C();},addRoute:function(p,i,l){var r=new R(p,i,l,this);this._sortedInsert(r);return r;},removeRoute:function(r){b(this._routes,r);r._destroy();},removeAllRoutes:function(){var n=this.getNumRoutes();while(n--){this._routes[n]._destroy();}this._routes.length=0;},parse:function(r,l){r=r||'';l=l||[];if(!this.ignoreState&&(r===this._prevMatchedRequest||r===this._prevBypassedRequest)){return;}var m=this._getMatchedRoutes(r),i=0,n=m.length,o;if(n){this._prevMatchedRequest=r;this._notifyPrevRoutes(m,r);this._prevRoutes=m;while(i<n){o=m[i];o.route.matched.dispatch.apply(o.route.matched,l.concat(o.params));o.isFirst=!i;this.routed.dispatch.apply(this.routed,l.concat([r,o]));i+=1;}}else{this._prevBypassedRequest=r;this.bypassed.dispatch.apply(this.bypassed,l.concat([r]));}this._pipeParse(r,l);},_notifyPrevRoutes:function(m,r){var i=0,p;while(p=this._prevRoutes[i++]){if(p.route.switched&&this._didSwitch(p.route,m)){p.route.switched.dispatch(r);}}},_didSwitch:function(r,m){var l,i=0;while(l=m[i++]){if(l.route===r){return false;}}return true;},_pipeParse:function(r,l){var i=0,m;while(m=this._piped[i++]){m.parse(r,l);}},getNumRoutes:function(){return this._routes.length;},_sortedInsert:function(r){var i=this._routes,n=i.length;do{--n;}while(i[n]&&r._priority<=i[n]._priority);i.splice(n+1,0,r);},_getMatchedRoutes:function(r){var i=[],l=this._routes,n=l.length,m;while(m=l[--n]){if((!i.length||this.greedy||m.greedy)&&m.match(r)){i.push({route:m,params:m._getParamsArray(r)});}if(!this.greedyEnabled&&i.length){break;}}return i;},pipe:function(o){this._piped.push(o);},unpipe:function(o){b(this._piped,o);},toString:function(){return'[crossroads numRoutes:'+this.getNumRoutes()+']';}};c=new C();c.VERSION='0.12.0';c.NORM_AS_ARRAY=function(r,v){return[v.vals_];};c.NORM_AS_OBJECT=function(r,v){return[v];};function R(p,i,l,r){var m=e(p),n=r.patternLexer;this._router=r;this._pattern=p;this._paramsIds=m?null:n.getParamIds(p);this._optionalParamsIds=m?null:n.getOptionalParamsIds(p);this._matchRegexp=m?p:n.compilePattern(p,r.ignoreCase);this.matched=new s.Signal();this.switched=new s.Signal();if(i){this.matched.add(i);}this._priority=l||0;}R.prototype={greedy:false,rules:void(0),match:function(r){r=r||'';return this._matchRegexp.test(r)&&this._validateParams(r);},_validateParams:function(r){var i=this.rules,v=this._getParamsObject(r),l;for(l in i){if(l!=='normalize_'&&i.hasOwnProperty(l)&&!this._isValidParam(r,l,v)){return false;}}return true;},_isValidParam:function(r,p,v){var i=this.rules[p],l=v[p],m=false,n=(p.indexOf('?')===0);if(l==null&&this._optionalParamsIds&&a(this._optionalParamsIds,p)!==-1){m=true;}else if(e(i)){if(n){l=v[p+'_'];}m=i.test(l);}else if(g(i)){if(n){l=v[p+'_'];}m=this._isValidArrayRule(i,l);}else if(h(i)){m=i(l,r,v);}return m;},_isValidArrayRule:function(i,v){if(!this._router.ignoreCase){return a(i,v)!==-1;}if(typeof v==='string'){v=v.toLowerCase();}var n=i.length,l,m;while(n--){l=i[n];m=(typeof l==='string')?l.toLowerCase():l;if(m===v){return true;}}return false;},_getParamsObject:function(r){var i=this._router.shouldTypecast,v=this._router.patternLexer.getParamValues(r,this._matchRegexp,i),o={},n=v.length,p,l;while(n--){l=v[n];if(this._paramsIds){p=this._paramsIds[n];if(p.indexOf('?')===0&&l){o[p+'_']=l;l=k(l,i);v[n]=l;}if(_&&l===''&&a(this._optionalParamsIds,p)!==-1){l=void(0);v[n]=l;}o[p]=l;}o[n]=l;}o.request_=i?t(r):r;o.vals_=v;return o;},_getParamsArray:function(r){var n=this.rules?this.rules.normalize_:null,p;n=n||this._router.normalizeFn;if(n&&h(n)){p=n(r,this._getParamsObject(r));}else{p=this._getParamsObject(r).vals_;}return p;},interpolate:function(r){var i=this._router.patternLexer.interpolate(this._pattern,r);if(!this._validateParams(i)){throw new Error('Generated string doesn\'t validate against `Route.rules`.');}return i;},extrapolate:function(r){var i={};if(!r){return i;}var p=this._getParamsObject(r);this._paramsIds.forEach(function(l){if(p.hasOwnProperty(l)){i[l]=p[l];}});return i;},dispose:function(){this._router.removeRoute(this);},_destroy:function(){this.matched.dispose();this.switched.dispose();this.matched=this.switched=this._pattern=this._matchRegexp=null;},toString:function(){return'[Route pattern:"'+this._pattern+'", numListeners:'+this.matched.getNumListeners()+']';}};C.prototype.patternLexer=(function(){var E=/[\\.+*?\^$\[\](){}\/'#]/g,L=/^\/|\/$/g,i=/\/$/g,P=/(?:\{|:)([^}:]+)(?:\}|:)/g,r=function(z,A,B){var D=B.lastIndexOf("__CR_RS__"),F=B.indexOf("__CR_RQ__"),G=B.indexOf("__CR_OQ__"),H=B.indexOf("\\/",A),I=Math.min(G===-1?B.length:G,F===-1?B.length:F),J=A+z.length;if(J>=I||J<D||J<H){return T.OS.res_normal;}else{return T.OS.res_arsbq;}},T={'OS':{rgx:/([:})]|\w(?=\/))\/?(:|(?:\{\?))/g,save:'$1{{id}}$2',res:r,res_normal:'\\/?',res_arsbq:'(?:(?:\\/(?=(?:[^\\/?]+)?))|(?:\\/?(?=\\?))|^\\/?|\\/?$)'},'RS':{rgx:/([:}])\/?(\{)/g,save:'$1{{id}}$2',res:'\\/'},'RQ':{rgx:/\{\?([^}]+)\}/g,res:'\\?(.+)'},'OQ':{rgx:/:\?([^:]+):/g,res:'(?:\\?(.*))?'},'OR':{rgx:/:([^:]+)\*:/g,res:'(.*)?'},'RR':{rgx:/\{([^}]+)\*\}/g,res:'(.+)'},'RP':{rgx:/\{([^}]+)\}/g,res:'([^\\/?]+)'},'OP':{rgx:/:([^:]+):/g,res:'([^\\/?]+)?(?:\\/(?!\\/))?'}},l=1,S=2,m=3,n=l;function p(){var z,A;for(z in T){if(T.hasOwnProperty(z)){A=T[z];A.id='__CR_'+z+'__';A.save=('save'in A)?A.save.replace('{{id}}',A.id):A.id;A.rRestore=new RegExp(A.id,'g');}}}p();function o(z,A){var B=[],D;z.lastIndex=0;while(D=z.exec(A)){B.push(D[1]);}return B;}function q(z){return o(P,z);}function u(z){return o(T.OP.rgx,z);}function v(z,A){z=z||'';if(z){if(n===l){z=z.replace(L,'');}else if(n===m){z=z.replace(i,'');}z=w(z,'rgx','save');z=z.replace(E,'\\$&');z=w(z,'rRestore','res');if(n===l){z='\\/?'+z;}}if(n!==S){z+='\\/?';}return new RegExp('^'+z+'$',A?'i':'');}function w(z,A,B){var D,F;for(F in T){if(T.hasOwnProperty(F)){D=T[F];z=z.replace(D[A],D[B]);}}return z;}function x(z,A,B){var D=A.exec(z);if(D){D.shift();if(B){D=j(D);}}return D;}function y(z,A){if(typeof z!=='string'){throw new Error('Route pattern should be a string.');}var B=function(D,F){var G,H;if(F.charAt(0)==='?'){H=A[F]||A[F.substring(1)];}else{H=A[F];}if(H!=null){if(typeof H==='object'){var I=[];for(var J in H){I.push(encodeURI(J+'='+H[J]));}G='?'+I.join('&');}else{G=String(H);}if(D.indexOf('*')===-1&&G.indexOf('/')!==-1){throw new Error('Invalid value "'+G+'" for segment "'+D+'".');}}else if(D.indexOf('{')!==-1){throw new Error('The segment '+D+' is required.');}else{G='';}return G;};if(!T.OS.trail){T.OS.trail=new RegExp('(?:'+T.OS.id+')+$');}return z.replace(T.OS.rgx,T.OS.save).replace(P,B).replace(T.OS.trail,'').replace(T.OS.rRestore,'/');}return{strict:function(){n=S;},loose:function(){n=l;},legacy:function(){n=m;},getParamIds:q,getOptionalParamsIds:u,getParamValues:x,compilePattern:v,interpolate:y};}());return c;};if(typeof define==='function'&&define.amd){define(['signals'],f);}else{window['crossroads']=f(window['signals']);}}());
},
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
	"jquery.sap.logger.js":function(){jQuery.sap.declare("jquery.sap.logger",false);
},
/*!
 * jQuery UI Core 1.10.4
 * http://jqueryui.com
 *
 * Copyright 2014 jQuery Foundation and other contributors
 * Released under the MIT license.
 * http://jquery.org/license
 *
 * http://api.jqueryui.com/category/ui-core/
 */
	"sap/ui/thirdparty/jqueryui/jquery-ui-core.js":function(){(function($,u){$.fn.zIndex=u;$.fn.enableSelection=u;$.fn.disableSelection=u;$.expr.pseudos.focusable=u;var b=0,r=/^ui-id-\d+$/;$.ui=$.ui||{};$.extend($.ui,{version:"1.10.4",keyCode:{BACKSPACE:8,COMMA:188,DELETE:46,DOWN:40,END:35,ENTER:13,ESCAPE:27,HOME:36,LEFT:37,NUMPAD_ADD:107,NUMPAD_DECIMAL:110,NUMPAD_DIVIDE:111,NUMPAD_ENTER:108,NUMPAD_MULTIPLY:106,NUMPAD_SUBTRACT:109,PAGE_DOWN:34,PAGE_UP:33,PERIOD:190,RIGHT:39,SPACE:32,TAB:9,UP:38}});$.fn.extend({focus:(function(o){return function(d,a){return typeof d==="number"?this.each(function(){var e=this;setTimeout(function(){$(e).trigger("focus");if(a){a.call(e);}},d);}):o.apply(this,arguments);};})($.fn.focus),scrollParent:function(){var s;if(($.ui.ie&&(/(static|relative)/).test(this.css("position")))||(/absolute/).test(this.css("position"))){s=this.parents().filter(function(){return(/(relative|absolute|fixed)/).test($.css(this,"position"))&&(/(auto|scroll)/).test($.css(this,"overflow")+$.css(this,"overflow-y")+$.css(this,"overflow-x"));}).eq(0);}else{s=this.parents().filter(function(){return(/(auto|scroll)/).test($.css(this,"overflow")+$.css(this,"overflow-y")+$.css(this,"overflow-x"));}).eq(0);}return(/fixed/).test(this.css("position"))||!s.length?$(document):s;},zIndex:function(z){if(z!==u){return this.css("zIndex",z);}if(this.length){var e=$(this[0]),p,a;while(e.length&&e[0]!==document){p=e.css("position");if(p==="absolute"||p==="relative"||p==="fixed"){a=parseInt(e.css("zIndex"),10);if(!isNaN(a)&&a!==0){return a;}}e=e.parent();}}return 0;},uniqueId:function(){return this.each(function(){if(!this.id){this.id="ui-id-"+(++b);}});},removeUniqueId:function(){return this.each(function(){if(r.test(this.id)){$(this).removeAttr("id");}});}});
function f(e,i){var m,a,c,n=e.nodeName.toLowerCase();if("area"===n){m=e.parentNode;a=m.name;if(!e.href||!a||m.nodeName.toLowerCase()!=="map"){return false;}c=$("img[usemap='#"+a+"']")[0];return!!c&&v(c);}return(/input|select|textarea|button|object/.test(n)?!e.disabled:"a"===n?e.href||i:i)&&v(e);}
function v(e){return $.expr.filters.visible(e)&&!$(e).parents().addBack().filter(function(){return $.css(this,"visibility")==="hidden";}).length;}
$.extend($.expr.pseudos,{data:$.expr.createPseudo?$.expr.createPseudo(function(d){return function(e){return!!$.data(e,d);};}):function(e,i,m){return!!$.data(e,m[3]);},focusable:function(e){return f(e,!isNaN($.attr(e,"tabindex")));},tabbable:function(e){var t=$.attr(e,"tabindex"),i=isNaN(t);return(i||t>=0)&&f(e,!i);}});if(!$("<a>").outerWidth(1).jquery){$.each(["Width","Height"],function(i,n){var s=n==="Width"?["Left","Right"]:["Top","Bottom"],t=n.toLowerCase(),o={innerWidth:$.fn.innerWidth,innerHeight:$.fn.innerHeight,outerWidth:$.fn.outerWidth,outerHeight:$.fn.outerHeight};function a(e,c,d,m){$.each(s,function(){c-=parseFloat($.css(e,"padding"+this))||0;if(d){c-=parseFloat($.css(e,"border"+this+"Width"))||0;}if(m){c-=parseFloat($.css(e,"margin"+this))||0;}});return c;}$.fn["inner"+n]=function(c){if(c===u){return o["inner"+n].call(this);}return this.each(function(){$(this).css(t,a(this,c)+"px");});};$.fn["outer"+n]=function(c,m){if(typeof c!=="number"){return o["outer"+n].call(this,c);}return this.each(function(){$(this).css(t,a(this,c,true,m)+"px");});};});}if(!$.fn.addBack){$.fn.addBack=function(s){return this.add(s==null?this.prevObject:this.prevObject.filter(s));};}if($("<a>").data("a-b","a").removeData("a-b").data("a-b")){$.fn.removeData=(function(a){return function(k){if(arguments.length){return a.call(this,$.camelCase(k));}else{return a.call(this);}};})($.fn.removeData);}$.ui.ie=!!/msie [\w.]+/.exec(navigator.userAgent.toLowerCase());$.support.selectstart="onselectstart"in document.createElement("div");$.fn.extend({disableSelection:function(){return this.on(($.support.selectstart?"selectstart":"mousedown")+".ui-disableSelection",function(e){e.preventDefault();});},enableSelection:function(){return this.off(".ui-disableSelection");}});$.extend($.ui,{plugin:{add:function(m,o,s){var i,p=$.ui[m].prototype;for(i in s){p.plugins[i]=p.plugins[i]||[];p.plugins[i].push([o,s[i]]);}},call:function(a,n,c){var i,s=a.plugins[n];if(!s||!a.element[0].parentNode||a.element[0].parentNode.nodeType===11){return;}for(i=0;i<s.length;i++){if(a.options[s[i][0]]){s[i][1].apply(a.element,c);}}}},hasScroll:function(e,a){if($(e).css("overflow")==="hidden"){return false;}var s=(a&&a==="left")?"scrollLeft":"scrollTop",h=false;if(e[s]>0){return true;}e[s]=1;h=(e[s]>0);e[s]=0;return h;}});})(jQuery);
},
/*!
 * jQuery UI Datepicker 1.10.4
 * http://jqueryui.com
 *
 * Copyright 2014 jQuery Foundation and other contributors
 * Released under the MIT license.
 * http://jquery.org/license
 *
 * http://api.jqueryui.com/datepicker/
 *
 * Depends:
 *	jquery.ui.core.js
 */
	"sap/ui/thirdparty/jqueryui/jquery-ui-datepicker.js":function(){(function($,u){$.extend($.ui,{datepicker:{version:"1.10.4"}});var P="datepicker",c;
function D(){this._curInst=null;this._keyEvent=false;this._disabledInputs=[];this._datepickerShowing=false;this._inDialog=false;this._mainDivId="ui-datepicker-div";this._inlineClass="ui-datepicker-inline";this._appendClass="ui-datepicker-append";this._triggerClass="ui-datepicker-trigger";this._dialogClass="ui-datepicker-dialog";this._disableClass="ui-datepicker-disabled";this._unselectableClass="ui-datepicker-unselectable";this._currentClass="ui-datepicker-current-day";this._dayOverClass="ui-datepicker-days-cell-over";this.regional=[];this.regional[""]={closeText:"Done",prevText:"Prev",nextText:"Next",currentText:"Today",monthNames:["January","February","March","April","May","June","July","August","September","October","November","December"],monthNamesShort:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],dayNames:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],dayNamesShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dayNamesMin:["Su","Mo","Tu","We","Th","Fr","Sa"],weekHeader:"Wk",dateFormat:"mm/dd/yy",firstDay:0,isRTL:false,showMonthAfterYear:false,yearSuffix:""};this._defaults={showOn:"focus",showAnim:"fadeIn",showOptions:{},defaultDate:null,appendText:"",buttonText:"...",buttonImage:"",buttonImageOnly:false,hideIfNoPrevNext:false,navigationAsDateFormat:false,gotoCurrent:false,changeMonth:false,changeYear:false,yearRange:"c-10:c+10",showOtherMonths:false,selectOtherMonths:false,showWeek:false,calculateWeek:this.iso8601Week,shortYearCutoff:"+10",minDate:null,maxDate:null,duration:"fast",beforeShowDay:null,beforeShow:null,onSelect:null,onChangeMonthYear:null,onClose:null,numberOfMonths:1,showCurrentAtPos:0,stepMonths:1,stepBigMonths:12,altField:"",altFormat:"",constrainInput:true,showButtonPanel:false,autoSize:false,disabled:false};$.extend(this._defaults,this.regional[""]);this.dpDiv=d($("<div id='"+this._mainDivId+"' class='ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all'></div>"));}
$.extend(D.prototype,{markerClassName:"hasDatepicker",maxRows:4,_widgetDatepicker:function(){return this.dpDiv;},setDefaults:function(s){f(this._defaults,s||{});return this;},_attachDatepicker:function(t,s){var n,i,a;n=t.nodeName.toLowerCase();i=(n==="div"||n==="span");if(!t.id){this.uuid+=1;t.id="dp"+this.uuid;}a=this._newInst($(t),i);a.settings=$.extend({},s||{});if(n==="input"){this._connectDatepicker(t,a);}else if(i){this._inlineDatepicker(t,a);}},_newInst:function(t,i){var a=t[0].id.replace(/([^A-Za-z0-9_\-])/g,"\\\\$1");return{id:a,input:t,selectedDay:0,selectedMonth:0,selectedYear:0,drawMonth:0,drawYear:0,inline:i,dpDiv:(!i?this.dpDiv:d($("<div class='"+this._inlineClass+" ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all'></div>")))};},_connectDatepicker:function(t,i){var a=$(t);i.append=$([]);i.trigger=$([]);if(a.hasClass(this.markerClassName)){return;}this._attachments(a,i);a.addClass(this.markerClassName).on("keydown",this._doKeyDown).keypress(this._doKeyPress).on("keyup",this._doKeyUp);this._autoSize(i);$.data(t,P,i);if(i.settings.disabled){this._disableDatepicker(t);}},_attachments:function(i,a){var s,b,e,g=this._get(a,"appendText"),h=this._get(a,"isRTL");if(a.append){a.append.remove();}if(g){a.append=$("<span class='"+this._appendClass+"'>"+g+"</span>");i[h?"before":"after"](a.append);}i.off("focus",this._showDatepicker);if(a.trigger){a.trigger.remove();}s=this._get(a,"showOn");if(s==="focus"||s==="both"){i.on("focus",this._showDatepicker);}if(s==="button"||s==="both"){b=this._get(a,"buttonText");e=this._get(a,"buttonImage");a.trigger=$(this._get(a,"buttonImageOnly")?$("<img/>").addClass(this._triggerClass).attr({src:e,alt:b,title:b}):$("<button type='button'></button>").addClass(this._triggerClass).html(!e?b:$("<img/>").attr({src:e,alt:b,title:b})));i[h?"before":"after"](a.trigger);a.trigger.click(function(){if($.datepicker._datepickerShowing&&$.datepicker._lastInput===i[0]){$.datepicker._hideDatepicker();}else if($.datepicker._datepickerShowing&&$.datepicker._lastInput!==i[0]){$.datepicker._hideDatepicker();$.datepicker._showDatepicker(i[0]);}else{$.datepicker._showDatepicker(i[0]);}return false;});}},_autoSize:function(a){if(this._get(a,"autoSize")&&!a.inline){var b,m,e,i,g=new Date(2009,12-1,20),h=this._get(a,"dateFormat");if(h.match(/[DM]/)){b=function(n){m=0;e=0;for(i=0;i<n.length;i++){if(n[i].length>m){m=n[i].length;e=i;}}return e;};g.setMonth(b(this._get(a,(h.match(/MM/)?"monthNames":"monthNamesShort"))));g.setDate(b(this._get(a,(h.match(/DD/)?"dayNames":"dayNamesShort")))+20-g.getDay());}a.input.attr("size",this._formatDate(a,g).length);}},_inlineDatepicker:function(t,i){var a=$(t);if(a.hasClass(this.markerClassName)){return;}a.addClass(this.markerClassName).append(i.dpDiv);$.data(t,P,i);this._setDate(i,this._getDefaultDate(i),true);this._updateDatepicker(i);this._updateAlternate(i);if(i.settings.disabled){this._disableDatepicker(t);}i.dpDiv.css("display","block");},_dialogDatepicker:function(i,a,o,s,p){var b,e,g,h,j,k=this._dialogInst;if(!k){this.uuid+=1;b="dp"+this.uuid;this._dialogInput=$("<input type='text' id='"+b+"'/>").css({position:"absolute",top:"-100px",width:"0px"});this._dialogInput.on("keydown",this._doKeyDown);$("body").append(this._dialogInput);k=this._dialogInst=this._newInst(this._dialogInput,false);k.settings={};$.data(this._dialogInput[0],P,k);}f(k.settings,s||{});a=(a&&a.constructor===Date?this._formatDate(k,a):a);this._dialogInput.val(a);this._pos=(p?(p.length?p:[p.pageX,p.pageY]):null);if(!this._pos){e=document.documentElement.clientWidth;g=document.documentElement.clientHeight;h=document.documentElement.scrollLeft||document.body.scrollLeft;j=document.documentElement.scrollTop||document.body.scrollTop;this._pos=[(e/2)-100+h,(g/2)-150+j];}this._dialogInput.css("left",(this._pos[0]+20)+"px").css("top",this._pos[1]+"px");k.settings.onSelect=o;this._inDialog=true;this.dpDiv.addClass(this._dialogClass);this._showDatepicker(this._dialogInput[0]);if($.blockUI){$.blockUI(this.dpDiv);}$.data(this._dialogInput[0],P,k);return this;},_destroyDatepicker:function(t){var n,a=$(t),i=$.data(t,P);if(!a.hasClass(this.markerClassName)){return;}n=t.nodeName.toLowerCase();$.removeData(t,P);if(n==="input"){i.append.remove();i.trigger.remove();a.removeClass(this.markerClassName).unbind("focus",this._showDatepicker).unbind("keydown",this._doKeyDown).unbind("keypress",this._doKeyPress).unbind("keyup",this._doKeyUp);}else if(n==="div"||n==="span"){a.removeClass(this.markerClassName).empty();}},_enableDatepicker:function(t){var n,i,a=$(t),b=$.data(t,P);if(!a.hasClass(this.markerClassName)){return;}n=t.nodeName.toLowerCase();if(n==="input"){t.disabled=false;b.trigger.filter("button").each(function(){this.disabled=false;}).end().filter("img").css({opacity:"1.0",cursor:""});}else if(n==="div"||n==="span"){i=a.children("."+this._inlineClass);i.children().removeClass("ui-state-disabled");i.find("select.ui-datepicker-month, select.ui-datepicker-year").prop("disabled",false);}this._disabledInputs=$.map(this._disabledInputs,function(v){return(v===t?null:v);});},_disableDatepicker:function(t){var n,i,a=$(t),b=$.data(t,P);if(!a.hasClass(this.markerClassName)){return;}n=t.nodeName.toLowerCase();if(n==="input"){t.disabled=true;b.trigger.filter("button").each(function(){this.disabled=true;}).end().filter("img").css({opacity:"0.5",cursor:"default"});}else if(n==="div"||n==="span"){i=a.children("."+this._inlineClass);i.children().addClass("ui-state-disabled");i.find("select.ui-datepicker-month, select.ui-datepicker-year").prop("disabled",true);}this._disabledInputs=$.map(this._disabledInputs,function(v){return(v===t?null:v);});this._disabledInputs[this._disabledInputs.length]=t;},_isDisabledDatepicker:function(t){if(!t){return false;}for(var i=0;i<this._disabledInputs.length;i++){if(this._disabledInputs[i]===t){return true;}}return false;},_getInst:function(t){try{return $.data(t,P);}catch(e){throw"Missing instance data for this datepicker";}},_optionDatepicker:function(t,n,v){var s,a,m,b,i=this._getInst(t);if(arguments.length===2&&typeof n==="string"){return(n==="defaults"?$.extend({},$.datepicker._defaults):(i?(n==="all"?$.extend({},i.settings):this._get(i,n)):null));}s=n||{};if(typeof n==="string"){s={};s[n]=v;}if(i){if(this._curInst===i){this._hideDatepicker();}a=this._getDateDatepicker(t,true);m=this._getMinMaxDate(i,"min");b=this._getMinMaxDate(i,"max");f(i.settings,s);if(m!==null&&s.dateFormat!==u&&s.minDate===u){i.settings.minDate=this._formatDate(i,m);}if(b!==null&&s.dateFormat!==u&&s.maxDate===u){i.settings.maxDate=this._formatDate(i,b);}if("disabled"in s){if(s.disabled){this._disableDatepicker(t);}else{this._enableDatepicker(t);}}this._attachments($(t),i);this._autoSize(i);this._setDate(i,a);this._updateAlternate(i);this._updateDatepicker(i);}},_changeDatepicker:function(t,n,v){this._optionDatepicker(t,n,v);},_refreshDatepicker:function(t){var i=this._getInst(t);if(i){this._updateDatepicker(i);}},_setDateDatepicker:function(t,a){var i=this._getInst(t);if(i){this._setDate(i,a);this._updateDatepicker(i);this._updateAlternate(i);}},_getDateDatepicker:function(t,n){var i=this._getInst(t);if(i&&!i.inline){this._setDateFromField(i,n);}return(i?this._getDate(i):null);},_doKeyDown:function(e){var o,a,s,i=$.datepicker._getInst(e.target),h=true,b=i.dpDiv.is(".ui-datepicker-rtl");i._keyEvent=true;if($.datepicker._datepickerShowing){switch(e.keyCode){case 9:$.datepicker._hideDatepicker();h=false;break;case 13:s=$("td."+$.datepicker._dayOverClass+":not(."+$.datepicker._currentClass+")",i.dpDiv);if(s[0]){$.datepicker._selectDay(e.target,i.selectedMonth,i.selectedYear,s[0]);}o=$.datepicker._get(i,"onSelect");if(o){a=$.datepicker._formatDate(i);o.apply((i.input?i.input[0]:null),[a,i]);}else{$.datepicker._hideDatepicker();}return false;case 27:$.datepicker._hideDatepicker();break;case 33:$.datepicker._adjustDate(e.target,(e.ctrlKey?-$.datepicker._get(i,"stepBigMonths"):-$.datepicker._get(i,"stepMonths")),"M");break;case 34:$.datepicker._adjustDate(e.target,(e.ctrlKey?+$.datepicker._get(i,"stepBigMonths"):+$.datepicker._get(i,"stepMonths")),"M");break;case 35:if(e.ctrlKey||e.metaKey){$.datepicker._clearDate(e.target);}h=e.ctrlKey||e.metaKey;break;case 36:if(e.ctrlKey||e.metaKey){$.datepicker._gotoToday(e.target);}h=e.ctrlKey||e.metaKey;break;case 37:if(e.ctrlKey||e.metaKey){$.datepicker._adjustDate(e.target,(b?+1:-1),"D");}h=e.ctrlKey||e.metaKey;if(e.originalEvent.altKey){$.datepicker._adjustDate(e.target,(e.ctrlKey?-$.datepicker._get(i,"stepBigMonths"):-$.datepicker._get(i,"stepMonths")),"M");}break;case 38:if(e.ctrlKey||e.metaKey){$.datepicker._adjustDate(e.target,-7,"D");}h=e.ctrlKey||e.metaKey;break;case 39:if(e.ctrlKey||e.metaKey){$.datepicker._adjustDate(e.target,(b?-1:+1),"D");}h=e.ctrlKey||e.metaKey;if(e.originalEvent.altKey){$.datepicker._adjustDate(e.target,(e.ctrlKey?+$.datepicker._get(i,"stepBigMonths"):+$.datepicker._get(i,"stepMonths")),"M");}break;case 40:if(e.ctrlKey||e.metaKey){$.datepicker._adjustDate(e.target,+7,"D");}h=e.ctrlKey||e.metaKey;break;default:h=false;}}else if(e.keyCode===36&&e.ctrlKey){$.datepicker._showDatepicker(this);}else{h=false;}if(h){e.preventDefault();e.stopPropagation();}},_doKeyPress:function(e){var a,b,i=$.datepicker._getInst(e.target);if($.datepicker._get(i,"constrainInput")){a=$.datepicker._possibleChars($.datepicker._get(i,"dateFormat"));b=String.fromCharCode(e.charCode==null?e.keyCode:e.charCode);return e.ctrlKey||e.metaKey||(b<" "||!a||a.indexOf(b)>-1);}},_doKeyUp:function(e){var a,i=$.datepicker._getInst(e.target);if(i.input.val()!==i.lastVal){try{a=$.datepicker.parseDate($.datepicker._get(i,"dateFormat"),(i.input?i.input.val():null),$.datepicker._getFormatConfig(i));if(a){$.datepicker._setDateFromField(i);$.datepicker._updateAlternate(i);$.datepicker._updateDatepicker(i);}}catch(b){}}return true;},_showDatepicker:function(i){i=i.target||i;if(i.nodeName.toLowerCase()!=="input"){i=$("input",i.parentNode)[0];}if($.datepicker._isDisabledDatepicker(i)||$.datepicker._lastInput===i){return;}var a,b,e,g,o,s,h;a=$.datepicker._getInst(i);if($.datepicker._curInst&&$.datepicker._curInst!==a){$.datepicker._curInst.dpDiv.stop(true,true);if(a&&$.datepicker._datepickerShowing){$.datepicker._hideDatepicker($.datepicker._curInst.input[0]);}}b=$.datepicker._get(a,"beforeShow");e=b?b.apply(i,[i,a]):{};if(e===false){return;}f(a.settings,e);a.lastVal=null;$.datepicker._lastInput=i;$.datepicker._setDateFromField(a);if($.datepicker._inDialog){i.value="";}if(!$.datepicker._pos){$.datepicker._pos=$.datepicker._findPos(i);$.datepicker._pos[1]+=i.offsetHeight;}g=false;$(i).parents().each(function(){g|=$(this).css("position")==="fixed";return!g;});o={left:$.datepicker._pos[0],top:$.datepicker._pos[1]};$.datepicker._pos=null;a.dpDiv.empty();a.dpDiv.css({position:"absolute",display:"block",top:"-1000px"});$.datepicker._updateDatepicker(a);o=$.datepicker._checkOffset(a,o,g);a.dpDiv.css({position:($.datepicker._inDialog&&$.blockUI?"static":(g?"fixed":"absolute")),display:"none",left:o.left+"px",top:o.top+"px"});if(!a.inline){s=$.datepicker._get(a,"showAnim");h=$.datepicker._get(a,"duration");a.dpDiv.zIndex($(i).zIndex()+1);$.datepicker._datepickerShowing=true;if($.effects&&$.effects.effect[s]){a.dpDiv.show(s,$.datepicker._get(a,"showOptions"),h);}else{a.dpDiv[s||"show"](s?h:null);}if($.datepicker._shouldFocusInput(a)){a.input.focus();}$.datepicker._curInst=a;}},_updateDatepicker:function(i){this.maxRows=4;c=i;i.dpDiv.empty().append(this._generateHTML(i));this._attachHandlers(i);i.dpDiv.find("."+this._dayOverClass+" a").mouseover();var o,n=this._getNumberOfMonths(i),a=n[1],w=17;i.dpDiv.removeClass("ui-datepicker-multi-2 ui-datepicker-multi-3 ui-datepicker-multi-4").width("");if(a>1){i.dpDiv.addClass("ui-datepicker-multi-"+a).css("width",(w*a)+"em");}i.dpDiv[(n[0]!==1||n[1]!==1?"add":"remove")+"Class"]("ui-datepicker-multi");i.dpDiv[(this._get(i,"isRTL")?"add":"remove")+"Class"]("ui-datepicker-rtl");if(i===$.datepicker._curInst&&$.datepicker._datepickerShowing&&$.datepicker._shouldFocusInput(i)){i.input.focus();}if(i.yearshtml){o=i.yearshtml;setTimeout(function(){if(o===i.yearshtml&&i.yearshtml){i.dpDiv.find("select.ui-datepicker-year:first").replaceWith(i.yearshtml);}o=i.yearshtml=null;},0);}},_shouldFocusInput:function(i){return i.input&&i.input.is(":visible")&&!i.input.is(":disabled")&&!i.input.is(":focus");},_checkOffset:function(i,o,a){var b=i.dpDiv.outerWidth(),e=i.dpDiv.outerHeight(),g=i.input?i.input.outerWidth():0,h=i.input?i.input.outerHeight():0,v=document.documentElement.clientWidth+(a?0:$(document).scrollLeft()),j=document.documentElement.clientHeight+(a?0:$(document).scrollTop());o.left-=(this._get(i,"isRTL")?(b-g):0);o.left-=(a&&o.left===i.input.offset().left)?$(document).scrollLeft():0;o.top-=(a&&o.top===(i.input.offset().top+h))?$(document).scrollTop():0;o.left-=Math.min(o.left,(o.left+b>v&&v>b)?Math.abs(o.left+b-v):0);o.top-=Math.min(o.top,(o.top+e>j&&j>e)?Math.abs(e+h):0);return o;},_findPos:function(o){var p,i=this._getInst(o),a=this._get(i,"isRTL");while(o&&(o.type==="hidden"||o.nodeType!==1||$.expr.filters.hidden(o))){o=o[a?"previousSibling":"nextSibling"];}p=$(o).offset();return[p.left,p.top];},_hideDatepicker:function(i){var s,a,p,o,b=this._curInst;if(!b||(i&&b!==$.data(i,P))){return;}if(this._datepickerShowing){s=this._get(b,"showAnim");a=this._get(b,"duration");p=function(){$.datepicker._tidyDialog(b);};if($.effects&&($.effects.effect[s]||$.effects[s])){b.dpDiv.hide(s,$.datepicker._get(b,"showOptions"),a,p);}else{b.dpDiv[(s==="slideDown"?"slideUp":(s==="fadeIn"?"fadeOut":"hide"))]((s?a:null),p);}if(!s){p();}this._datepickerShowing=false;o=this._get(b,"onClose");if(o){o.apply((b.input?b.input[0]:null),[(b.input?b.input.val():""),b]);}this._lastInput=null;if(this._inDialog){this._dialogInput.css({position:"absolute",left:"0",top:"-100px"});if($.blockUI){$.unblockUI();$("body").append(this.dpDiv);}}this._inDialog=false;}},_tidyDialog:function(i){i.dpDiv.removeClass(this._dialogClass).off(".ui-datepicker-calendar");},_checkExternalClick:function(e){if(!$.datepicker._curInst){return;}var a=$(e.target),i=$.datepicker._getInst(a[0]);if(((a[0].id!==$.datepicker._mainDivId&&a.parents("#"+$.datepicker._mainDivId).length===0&&!a.hasClass($.datepicker.markerClassName)&&!a.closest("."+$.datepicker._triggerClass).length&&$.datepicker._datepickerShowing&&!($.datepicker._inDialog&&$.blockUI)))||(a.hasClass($.datepicker.markerClassName)&&$.datepicker._curInst!==i)){$.datepicker._hideDatepicker();}},_adjustDate:function(i,o,p){var t=$(i),a=this._getInst(t[0]);if(this._isDisabledDatepicker(t[0])){return;}this._adjustInstDate(a,o+(p==="M"?this._get(a,"showCurrentAtPos"):0),p);this._updateDatepicker(a);},_gotoToday:function(i){var a,t=$(i),b=this._getInst(t[0]);if(this._get(b,"gotoCurrent")&&b.currentDay){b.selectedDay=b.currentDay;b.drawMonth=b.selectedMonth=b.currentMonth;b.drawYear=b.selectedYear=b.currentYear;}else{a=new Date();b.selectedDay=a.getDate();b.drawMonth=b.selectedMonth=a.getMonth();b.drawYear=b.selectedYear=a.getFullYear();}this._notifyChange(b);this._adjustDate(t);},_selectMonthYear:function(i,s,p){var t=$(i),a=this._getInst(t[0]);a["selected"+(p==="M"?"Month":"Year")]=a["draw"+(p==="M"?"Month":"Year")]=parseInt(s.options[s.selectedIndex].value,10);this._notifyChange(a);this._adjustDate(t);},_selectDay:function(i,m,y,t){var a,b=$(i);if($(t).hasClass(this._unselectableClass)||this._isDisabledDatepicker(b[0])){return;}a=this._getInst(b[0]);a.selectedDay=a.currentDay=$("a",t).html();a.selectedMonth=a.currentMonth=m;a.selectedYear=a.currentYear=y;this._selectDate(i,this._formatDate(a,a.currentDay,a.currentMonth,a.currentYear));},_clearDate:function(i){var t=$(i);this._selectDate(t,"");},_selectDate:function(i,a){var o,t=$(i),b=this._getInst(t[0]);a=(a!=null?a:this._formatDate(b));if(b.input){b.input.val(a);}this._updateAlternate(b);o=this._get(b,"onSelect");if(o){o.apply((b.input?b.input[0]:null),[a,b]);}else if(b.input){b.input.trigger("change");}if(b.inline){this._updateDatepicker(b);}else{this._hideDatepicker();this._lastInput=b.input[0];if(typeof(b.input[0])!=="object"){b.input.focus();}this._lastInput=null;}},_updateAlternate:function(i){var a,b,e,g=this._get(i,"altField");if(g){a=this._get(i,"altFormat")||this._get(i,"dateFormat");b=this._getDate(i);e=this.formatDate(a,b,this._getFormatConfig(i));$(g).each(function(){$(this).val(e);});}},noWeekends:function(a){var b=a.getDay();return[(b>0&&b<6),""];},iso8601Week:function(a){var t,b=new Date(a.getTime());b.setDate(b.getDate()+4-(b.getDay()||7));t=b.getTime();b.setMonth(0);b.setDate(1);return Math.floor(Math.round((t-b)/86400000)/7)+1;},parseDate:function(e,g,s){if(e==null||g==null){throw"Invalid arguments";}g=(typeof g==="object"?g.toString():g+"");if(g===""){return null;}var F,h,j,V=0,l=(s?s.shortYearCutoff:null)||this._defaults.shortYearCutoff,m=(typeof l!=="string"?l:new Date().getFullYear()%100+parseInt(l,10)),n=(s?s.dayNamesShort:null)||this._defaults.dayNamesShort,o=(s?s.dayNames:null)||this._defaults.dayNames,p=(s?s.monthNamesShort:null)||this._defaults.monthNamesShort,q=(s?s.monthNames:null)||this._defaults.monthNames,y=-1,r=-1,t=-1,w=-1,x=false,z,A=function(a){var b=(F+1<e.length&&e.charAt(F+1)===a);if(b){F++;}return b;},B=function(a){var i=A(a),b=(a==="@"?14:(a==="!"?20:(a==="y"&&i?4:(a==="o"?3:2)))),k=new RegExp("^\\d{1,"+b+"}"),v=g.substring(V).match(k);if(!v){throw"Missing number at position "+V;}V+=v[0].length;return parseInt(v[0],10);},C=function(G,H,I){var J=-1,K=$.map(A(G)?I:H,function(v,k){return[[k,v]];}).sort(function(a,b){return-(a[1].length-b[1].length);});$.each(K,function(i,a){var b=a[1];if(g.substr(V,b.length).toLowerCase()===b.toLowerCase()){J=a[0];V+=b.length;return false;}});if(J!==-1){return J+1;}else{throw"Unknown name at position "+V;}},E=function(){if(g.charAt(V)!==e.charAt(F)){throw"Unexpected literal at position "+V;}V++;};for(F=0;F<e.length;F++){if(x){if(e.charAt(F)==="'"&&!A("'")){x=false;}else{E();}}else{switch(e.charAt(F)){case"d":t=B("d");break;case"D":C("D",n,o);break;case"o":w=B("o");break;case"m":r=B("m");break;case"M":r=C("M",p,q);break;case"y":y=B("y");break;case"@":z=new Date(B("@"));y=z.getFullYear();r=z.getMonth()+1;t=z.getDate();break;case"!":z=new Date((B("!")-this._ticksTo1970)/10000);y=z.getFullYear();r=z.getMonth()+1;t=z.getDate();break;case"'":if(A("'")){E();}else{x=true;}break;default:E();}}}if(V<g.length){j=g.substr(V);if(!/^\s+/.test(j)){throw"Extra/unparsed characters found in date: "+j;}}if(y===-1){y=new Date().getFullYear();}else if(y<100){y+=new Date().getFullYear()-new Date().getFullYear()%100+(y<=m?0:-100);}if(w>-1){r=1;t=w;do{h=this._getDaysInMonth(y,r-1);if(t<=h){break;}r++;t-=h;}while(true);}z=this._daylightSavingAdjust(new Date(y,r-1,t));if(z.getFullYear()!==y||z.getMonth()+1!==r||z.getDate()!==t){throw"Invalid date";}return z;},ATOM:"yy-mm-dd",COOKIE:"D, dd M yy",ISO_8601:"yy-mm-dd",RFC_822:"D, d M y",RFC_850:"DD, dd-M-y",RFC_1036:"D, d M y",RFC_1123:"D, d M yy",RFC_2822:"D, d M yy",RSS:"D, d M y",TICKS:"!",TIMESTAMP:"@",W3C:"yy-mm-dd",_ticksTo1970:(((1970-1)*365+Math.floor(1970/4)-Math.floor(1970/100)+Math.floor(1970/400))*24*60*60*10000000),formatDate:function(a,b,s){if(!b){return"";}var F,e=(s?s.dayNamesShort:null)||this._defaults.dayNamesShort,g=(s?s.dayNames:null)||this._defaults.dayNames,m=(s?s.monthNamesShort:null)||this._defaults.monthNamesShort,h=(s?s.monthNames:null)||this._defaults.monthNames,l=function(n){var p=(F+1<a.length&&a.charAt(F+1)===n);if(p){F++;}return p;},i=function(n,v,p){var q=""+v;if(l(n)){while(q.length<p){q="0"+q;}}return q;},j=function(n,v,p,q){return(l(n)?q[v]:p[v]);},o="",k=false;if(b){for(F=0;F<a.length;F++){if(k){if(a.charAt(F)==="'"&&!l("'")){k=false;}else{o+=a.charAt(F);}}else{switch(a.charAt(F)){case"d":o+=i("d",b.getDate(),2);break;case"D":o+=j("D",b.getDay(),e,g);break;case"o":o+=i("o",Math.round((new Date(b.getFullYear(),b.getMonth(),b.getDate()).getTime()-new Date(b.getFullYear(),0,0).getTime())/86400000),3);break;case"m":o+=i("m",b.getMonth()+1,2);break;case"M":o+=j("M",b.getMonth(),m,h);break;case"y":o+=(l("y")?b.getFullYear():(b.getYear()%100<10?"0":"")+b.getYear()%100);break;case"@":o+=b.getTime();break;case"!":o+=b.getTime()*10000+this._ticksTo1970;break;case"'":if(l("'")){o+="'";}else{k=true;}break;default:o+=a.charAt(F);}}}}return o;},_possibleChars:function(a){var F,b="",l=false,e=function(m){var g=(F+1<a.length&&a.charAt(F+1)===m);if(g){F++;}return g;};for(F=0;F<a.length;F++){if(l){if(a.charAt(F)==="'"&&!e("'")){l=false;}else{b+=a.charAt(F);}}else{switch(a.charAt(F)){case"d":case"m":case"y":case"@":b+="0123456789";break;case"D":case"M":return null;case"'":if(e("'")){b+="'";}else{l=true;}break;default:b+=a.charAt(F);}}}return b;},_get:function(i,n){return i.settings[n]!==u?i.settings[n]:this._defaults[n];},_setDateFromField:function(i,n){if(i.input.val()===i.lastVal){return;}var a=this._get(i,"dateFormat"),b=i.lastVal=i.input?i.input.val():null,e=this._getDefaultDate(i),g=e,s=this._getFormatConfig(i);try{g=this.parseDate(a,b,s)||e;}catch(h){b=(n?"":b);}i.selectedDay=g.getDate();i.drawMonth=i.selectedMonth=g.getMonth();i.drawYear=i.selectedYear=g.getFullYear();i.currentDay=(b?g.getDate():0);i.currentMonth=(b?g.getMonth():0);i.currentYear=(b?g.getFullYear():0);this._adjustInstDate(i);},_getDefaultDate:function(i){return this._restrictMinMax(i,this._determineDate(i,this._get(i,"defaultDate"),new Date()));},_determineDate:function(i,a,b){var o=function(e){var a=new Date();a.setDate(a.getDate()+e);return a;},g=function(h){try{return $.datepicker.parseDate($.datepicker._get(i,"dateFormat"),h,$.datepicker._getFormatConfig(i));}catch(e){}var a=(h.toLowerCase().match(/^c/)?$.datepicker._getDate(i):null)||new Date(),y=a.getFullYear(),m=a.getMonth(),j=a.getDate(),p=/([+\-]?[0-9]+)\s*(d|D|w|W|m|M|y|Y)?/g,k=p.exec(h);while(k){switch(k[2]||"d"){case"d":case"D":j+=parseInt(k[1],10);break;case"w":case"W":j+=parseInt(k[1],10)*7;break;case"m":case"M":m+=parseInt(k[1],10);j=Math.min(j,$.datepicker._getDaysInMonth(y,m));break;case"y":case"Y":y+=parseInt(k[1],10);j=Math.min(j,$.datepicker._getDaysInMonth(y,m));break;}k=p.exec(h);}return new Date(y,m,j);},n=(a==null||a===""?b:(typeof a==="string"?g(a):(typeof a==="number"?(isNaN(a)?b:o(a)):new Date(a.getTime()))));n=(n&&n.toString()==="Invalid Date"?b:n);if(n){n.setHours(0);n.setMinutes(0);n.setSeconds(0);n.setMilliseconds(0);}return this._daylightSavingAdjust(n);},_daylightSavingAdjust:function(a){if(!a){return null;}a.setHours(a.getHours()>12?a.getHours()+2:0);return a;},_setDate:function(i,a,n){var b=!a,o=i.selectedMonth,e=i.selectedYear,g=this._restrictMinMax(i,this._determineDate(i,a,new Date()));i.selectedDay=i.currentDay=g.getDate();i.drawMonth=i.selectedMonth=i.currentMonth=g.getMonth();i.drawYear=i.selectedYear=i.currentYear=g.getFullYear();if((o!==i.selectedMonth||e!==i.selectedYear)&&!n){this._notifyChange(i);}this._adjustInstDate(i);if(i.input){i.input.val(b?"":this._formatDate(i));}},_getDate:function(i){var s=(!i.currentYear||(i.input&&i.input.val()==="")?null:this._daylightSavingAdjust(new Date(i.currentYear,i.currentMonth,i.currentDay)));return s;},_attachHandlers:function(i){var s=this._get(i,"stepMonths"),a="#"+i.id.replace(/\\\\/g,"\\");i.dpDiv.find("[data-handler]").map(function(){var h={prev:function(){$.datepicker._adjustDate(a,-s,"M");},next:function(){$.datepicker._adjustDate(a,+s,"M");},hide:function(){$.datepicker._hideDatepicker();},today:function(){$.datepicker._gotoToday(a);},selectDay:function(){$.datepicker._selectDay(a,+this.getAttribute("data-month"),+this.getAttribute("data-year"),this);return false;},selectMonth:function(){$.datepicker._selectMonthYear(a,this,"M");return false;},selectYear:function(){$.datepicker._selectMonthYear(a,this,"Y");return false;}};$(this).on(this.getAttribute("data-event"),h[this.getAttribute("data-handler")]);});},_generateHTML:function(i){var m,p,a,n,b,e,g,h,j,k,s,l,o,q,r,t,v,w,x,y,z,A,B,C,E,F,G,H,I,J,K,L,M,N,R,O,Q,S,T,U=new Date(),V=this._daylightSavingAdjust(new Date(U.getFullYear(),U.getMonth(),U.getDate())),W=this._get(i,"isRTL"),X=this._get(i,"showButtonPanel"),Y=this._get(i,"hideIfNoPrevNext"),Z=this._get(i,"navigationAsDateFormat"),_=this._getNumberOfMonths(i),a1=this._get(i,"showCurrentAtPos"),b1=this._get(i,"stepMonths"),c1=(_[0]!==1||_[1]!==1),d1=this._daylightSavingAdjust((!i.currentDay?new Date(9999,9,9):new Date(i.currentYear,i.currentMonth,i.currentDay))),e1=this._getMinMaxDate(i,"min"),f1=this._getMinMaxDate(i,"max"),g1=i.drawMonth-a1,h1=i.drawYear;if(g1<0){g1+=12;h1--;}if(f1){m=this._daylightSavingAdjust(new Date(f1.getFullYear(),f1.getMonth()-(_[0]*_[1])+1,f1.getDate()));m=(e1&&m<e1?e1:m);while(this._daylightSavingAdjust(new Date(h1,g1,1))>m){g1--;if(g1<0){g1=11;h1--;}}}i.drawMonth=g1;i.drawYear=h1;p=this._get(i,"prevText");p=(!Z?p:this.formatDate(p,this._daylightSavingAdjust(new Date(h1,g1-b1,1)),this._getFormatConfig(i)));a=(this._canAdjustMonth(i,-1,h1,g1)?"<a class='ui-datepicker-prev ui-corner-all' data-handler='prev' data-event='click'"+" title='"+p+"'><span class='ui-icon ui-icon-circle-triangle-"+(W?"e":"w")+"'>"+p+"</span></a>":(Y?"":"<a class='ui-datepicker-prev ui-corner-all ui-state-disabled' title='"+p+"'><span class='ui-icon ui-icon-circle-triangle-"+(W?"e":"w")+"'>"+p+"</span></a>"));n=this._get(i,"nextText");n=(!Z?n:this.formatDate(n,this._daylightSavingAdjust(new Date(h1,g1+b1,1)),this._getFormatConfig(i)));b=(this._canAdjustMonth(i,+1,h1,g1)?"<a class='ui-datepicker-next ui-corner-all' data-handler='next' data-event='click'"+" title='"+n+"'><span class='ui-icon ui-icon-circle-triangle-"+(W?"w":"e")+"'>"+n+"</span></a>":(Y?"":"<a class='ui-datepicker-next ui-corner-all ui-state-disabled' title='"+n+"'><span class='ui-icon ui-icon-circle-triangle-"+(W?"w":"e")+"'>"+n+"</span></a>"));e=this._get(i,"currentText");g=(this._get(i,"gotoCurrent")&&i.currentDay?d1:V);e=(!Z?e:this.formatDate(e,g,this._getFormatConfig(i)));h=(!i.inline?"<button type='button' class='ui-datepicker-close ui-state-default ui-priority-primary ui-corner-all' data-handler='hide' data-event='click'>"+this._get(i,"closeText")+"</button>":"");j=(X)?"<div class='ui-datepicker-buttonpane ui-widget-content'>"+(W?h:"")+(this._isInRange(i,g)?"<button type='button' class='ui-datepicker-current ui-state-default ui-priority-secondary ui-corner-all' data-handler='today' data-event='click'"+">"+e+"</button>":"")+(W?"":h)+"</div>":"";k=parseInt(this._get(i,"firstDay"),10);k=(isNaN(k)?0:k);s=this._get(i,"showWeek");l=this._get(i,"dayNames");o=this._get(i,"dayNamesMin");q=this._get(i,"monthNames");r=this._get(i,"monthNamesShort");t=this._get(i,"beforeShowDay");v=this._get(i,"showOtherMonths");w=this._get(i,"selectOtherMonths");x=this._getDefaultDate(i);y="";z;for(A=0;A<_[0];A++){B="";this.maxRows=4;for(C=0;C<_[1];C++){E=this._daylightSavingAdjust(new Date(h1,g1,i.selectedDay));F=" ui-corner-all";G="";if(c1){G+="<div class='ui-datepicker-group";if(_[1]>1){switch(C){case 0:G+=" ui-datepicker-group-first";F=" ui-corner-"+(W?"right":"left");break;case _[1]-1:G+=" ui-datepicker-group-last";F=" ui-corner-"+(W?"left":"right");break;default:G+=" ui-datepicker-group-middle";F="";break;}}G+="'>";}G+="<div class='ui-datepicker-header ui-widget-header ui-helper-clearfix"+F+"'>"+(/all|left/.test(F)&&A===0?(W?b:a):"")+(/all|right/.test(F)&&A===0?(W?a:b):"")+this._generateMonthYearHeader(i,g1,h1,e1,f1,A>0||C>0,q,r)+"</div><table class='ui-datepicker-calendar'><thead>"+"<tr>";H=(s?"<th class='ui-datepicker-week-col'>"+this._get(i,"weekHeader")+"</th>":"");for(z=0;z<7;z++){I=(z+k)%7;H+="<th"+((z+k+6)%7>=5?" class='ui-datepicker-week-end'":"")+">"+"<span title='"+l[I]+"'>"+o[I]+"</span></th>";}G+=H+"</tr></thead><tbody>";J=this._getDaysInMonth(h1,g1);if(h1===i.selectedYear&&g1===i.selectedMonth){i.selectedDay=Math.min(i.selectedDay,J);}K=(this._getFirstDayOfMonth(h1,g1)-k+7)%7;L=Math.ceil((K+J)/7);M=(c1?this.maxRows>L?this.maxRows:L:L);this.maxRows=M;N=this._daylightSavingAdjust(new Date(h1,g1,1-K));for(R=0;R<M;R++){G+="<tr>";O=(!s?"":"<td class='ui-datepicker-week-col'>"+this._get(i,"calculateWeek")(N)+"</td>");for(z=0;z<7;z++){Q=(t?t.apply((i.input?i.input[0]:null),[N]):[true,""]);S=(N.getMonth()!==g1);T=(S&&!w)||!Q[0]||(e1&&N<e1)||(f1&&N>f1);O+="<td class='"+((z+k+6)%7>=5?" ui-datepicker-week-end":"")+(S?" ui-datepicker-other-month":"")+((N.getTime()===E.getTime()&&g1===i.selectedMonth&&i._keyEvent)||(x.getTime()===N.getTime()&&x.getTime()===E.getTime())?" "+this._dayOverClass:"")+(T?" "+this._unselectableClass+" ui-state-disabled":"")+(S&&!v?"":" "+Q[1]+(N.getTime()===d1.getTime()?" "+this._currentClass:"")+(N.getTime()===V.getTime()?" ui-datepicker-today":""))+"'"+((!S||v)&&Q[2]?" title='"+Q[2].replace(/'/g,"&#39;")+"'":"")+(T?"":" data-handler='selectDay' data-event='click' data-month='"+N.getMonth()+"' data-year='"+N.getFullYear()+"'")+">"+(S&&!v?"&#xa0;":(T?"<span class='ui-state-default'>"+N.getDate()+"</span>":"<a class='ui-state-default"+(N.getTime()===V.getTime()?" ui-state-highlight":"")+(N.getTime()===d1.getTime()?" ui-state-active":"")+(S?" ui-priority-secondary":"")+"' href='#'>"+N.getDate()+"</a>"))+"</td>";N.setDate(N.getDate()+1);N=this._daylightSavingAdjust(N);}G+=O+"</tr>";}g1++;if(g1>11){g1=0;h1++;}G+="</tbody></table>"+(c1?"</div>"+((_[0]>0&&C===_[1]-1)?"<div class='ui-datepicker-row-break'></div>":""):"");B+=G;}y+=B;}y+=j;i._keyEvent=false;return y;},_generateMonthYearHeader:function(i,a,b,m,e,s,g,h){var j,k,l,y,t,n,o,p,q=this._get(i,"changeMonth"),r=this._get(i,"changeYear"),v=this._get(i,"showMonthAfterYear"),w="<div class='ui-datepicker-title'>",x="";if(s||!q){x+="<span class='ui-datepicker-month'>"+g[a]+"</span>";}else{j=(m&&m.getFullYear()===b);k=(e&&e.getFullYear()===b);x+="<select class='ui-datepicker-month' data-handler='selectMonth' data-event='change'>";for(l=0;l<12;l++){if((!j||l>=m.getMonth())&&(!k||l<=e.getMonth())){x+="<option value='"+l+"'"+(l===a?" selected='selected'":"")+">"+h[l]+"</option>";}}x+="</select>";}if(!v){w+=x+(s||!(q&&r)?"&#xa0;":"");}if(!i.yearshtml){i.yearshtml="";if(s||!r){w+="<span class='ui-datepicker-year'>"+b+"</span>";}else{y=this._get(i,"yearRange").split(":");t=new Date().getFullYear();n=function(z){var o=(z.match(/c[+\-].*/)?b+parseInt(z.substring(1),10):(z.match(/[+\-].*/)?t+parseInt(z,10):parseInt(z,10)));return(isNaN(o)?t:o);};o=n(y[0]);p=Math.max(o,n(y[1]||""));o=(m?Math.max(o,m.getFullYear()):o);p=(e?Math.min(p,e.getFullYear()):p);i.yearshtml+="<select class='ui-datepicker-year' data-handler='selectYear' data-event='change'>";for(;o<=p;o++){i.yearshtml+="<option value='"+o+"'"+(o===b?" selected='selected'":"")+">"+o+"</option>";}i.yearshtml+="</select>";w+=i.yearshtml;i.yearshtml=null;}}w+=this._get(i,"yearSuffix");if(v){w+=(s||!(q&&r)?"&#xa0;":"")+x;}w+="</div>";return w;},_adjustInstDate:function(i,o,p){var y=i.drawYear+(p==="Y"?o:0),m=i.drawMonth+(p==="M"?o:0),a=Math.min(i.selectedDay,this._getDaysInMonth(y,m))+(p==="D"?o:0),b=this._restrictMinMax(i,this._daylightSavingAdjust(new Date(y,m,a)));i.selectedDay=b.getDate();i.drawMonth=i.selectedMonth=b.getMonth();i.drawYear=i.selectedYear=b.getFullYear();if(p==="M"||p==="Y"){this._notifyChange(i);}},_restrictMinMax:function(i,a){var m=this._getMinMaxDate(i,"min"),b=this._getMinMaxDate(i,"max"),n=(m&&a<m?m:a);return(b&&n>b?b:n);},_notifyChange:function(i){var o=this._get(i,"onChangeMonthYear");if(o){o.apply((i.input?i.input[0]:null),[i.selectedYear,i.selectedMonth+1,i]);}},_getNumberOfMonths:function(i){var n=this._get(i,"numberOfMonths");return(n==null?[1,1]:(typeof n==="number"?[1,n]:n));},_getMinMaxDate:function(i,m){return this._determineDate(i,this._get(i,m+"Date"),null);},_getDaysInMonth:function(y,m){return 32-this._daylightSavingAdjust(new Date(y,m,32)).getDate();},_getFirstDayOfMonth:function(y,m){return new Date(y,m,1).getDay();},_canAdjustMonth:function(i,o,a,b){var n=this._getNumberOfMonths(i),e=this._daylightSavingAdjust(new Date(a,b+(o<0?o:n[0]*n[1]),1));if(o<0){e.setDate(this._getDaysInMonth(e.getFullYear(),e.getMonth()));}return this._isInRange(i,e);},_isInRange:function(i,a){var y,b,m=this._getMinMaxDate(i,"min"),e=this._getMinMaxDate(i,"max"),g=null,h=null,j=this._get(i,"yearRange");if(j){y=j.split(":");b=new Date().getFullYear();g=parseInt(y[0],10);h=parseInt(y[1],10);if(y[0].match(/[+\-].*/)){g+=b;}if(y[1].match(/[+\-].*/)){h+=b;}}return((!m||a.getTime()>=m.getTime())&&(!e||a.getTime()<=e.getTime())&&(!g||a.getFullYear()>=g)&&(!h||a.getFullYear()<=h));},_getFormatConfig:function(i){var s=this._get(i,"shortYearCutoff");s=(typeof s!=="string"?s:new Date().getFullYear()%100+parseInt(s,10));return{shortYearCutoff:s,dayNamesShort:this._get(i,"dayNamesShort"),dayNames:this._get(i,"dayNames"),monthNamesShort:this._get(i,"monthNamesShort"),monthNames:this._get(i,"monthNames")};},_formatDate:function(i,a,m,y){if(!a){i.currentDay=i.selectedDay;i.currentMonth=i.selectedMonth;i.currentYear=i.selectedYear;}var b=(a?(typeof a==="object"?a:this._daylightSavingAdjust(new Date(y,m,a))):this._daylightSavingAdjust(new Date(i.currentYear,i.currentMonth,i.currentDay)));return this.formatDate(this._get(i,"dateFormat"),b,this._getFormatConfig(i));}});
function d(a){var s="button, .ui-datepicker-prev, .ui-datepicker-next, .ui-datepicker-calendar td a";return a.delegate(s,"mouseout",function(){$(this).removeClass("ui-state-hover");if(this.className.indexOf("ui-datepicker-prev")!==-1){$(this).removeClass("ui-datepicker-prev-hover");}if(this.className.indexOf("ui-datepicker-next")!==-1){$(this).removeClass("ui-datepicker-next-hover");}}).delegate(s,"mouseover",function(){if(!$.datepicker._isDisabledDatepicker(c.inline?a.parent()[0]:c.input[0])){$(this).parents(".ui-datepicker-calendar").find("a").removeClass("ui-state-hover");$(this).addClass("ui-state-hover");if(this.className.indexOf("ui-datepicker-prev")!==-1){$(this).addClass("ui-datepicker-prev-hover");}if(this.className.indexOf("ui-datepicker-next")!==-1){$(this).addClass("ui-datepicker-next-hover");}}});}
function f(t,p){$.extend(t,p);for(var n in p){if(p[n]==null){t[n]=p[n];}}return t;}
$.fn.datepicker=function(o){if(!this.length){return this;}if(!$.datepicker.initialized){$(document).on("mousedown",$.datepicker._checkExternalClick);$.datepicker.initialized=true;}if($("#"+$.datepicker._mainDivId).length===0){$("body").append($.datepicker.dpDiv);}var a=Array.prototype.slice.call(arguments,1);if(typeof o==="string"&&(o==="isDisabled"||o==="getDate"||o==="widget")){return $.datepicker["_"+o+"Datepicker"].apply($.datepicker,[this[0]].concat(a));}if(o==="option"&&arguments.length===2&&typeof arguments[1]==="string"){return $.datepicker["_"+o+"Datepicker"].apply($.datepicker,[this[0]].concat(a));}return this.each(function(){typeof o==="string"?$.datepicker["_"+o+"Datepicker"].apply($.datepicker,[this].concat(a)):$.datepicker._attachDatepicker(this,o);});};
$.datepicker=new D();$.datepicker.initialized=false;$.datepicker.uuid=new Date().getTime();$.datepicker.version="1.10.4";})(jQuery);
},
	"sap/ui/thirdparty/caja-html-sanitizer.js":function(){
/* the subsequent text seems not to contain a copyright or license statement */
(function(){
/* Copyright Google Inc.
 * Licensed under the Apache Licence Version 2.0
 * Autogenerated at Tue May 22 10:18:21 PDT 2012
 * \@overrides window
 * \@provides cssSchema, CSS_PROP_BIT_QUANTITY, CSS_PROP_BIT_HASH_VALUE, CSS_PROP_BIT_NEGATIVE_QUANTITY, CSS_PROP_BIT_QSTRING_CONTENT, CSS_PROP_BIT_QSTRING_URL, CSS_PROP_BIT_HISTORY_INSENSITIVE, CSS_PROP_BIT_Z_INDEX, CSS_PROP_BIT_ALLOWED_IN_LINK */
var C=1;var a=2;var b=4;var d=8;var f=16;var g=32;var l=64;var o=128;var r=(function(){var s=['rgb(?:\\(\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)\\s*,\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)\\s*,\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)|a\\(\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)\\s*,\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)\\s*,\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)\\s*,\\s*(?:\\d+|0(?:\\.\\d+)?|\\.\\d+|1(?:\\.0+)?|0|\\d+(?:\\.\\d+)?%)) *\\)'],c=[/^ *$/i,RegExp('^ *(?:\\s*'+s[0]+'|(?:\\s*'+s[0]+')?)+ *$','i'),RegExp('^ *\\s*'+s[0]+' *$','i'),RegExp('^ *\\s*'+s[0]+'\\s*'+s[0]+' *$','i')],L=[['aliceblue','antiquewhite','aqua','aquamarine','azure','beige','bisque','black','blanchedalmond','blue','blueviolet','brown','burlywood','cadetblue','chartreuse','chocolate','coral','cornflowerblue','cornsilk','crimson','cyan','darkblue','darkcyan','darkgoldenrod','darkgray','darkgreen','darkkhaki','darkmagenta','darkolivegreen','darkorange','darkorchid','darkred','darksalmon','darkseagreen','darkslateblue','darkslategray','darkturquoise','darkviolet','deeppink','deepskyblue','dimgray','dodgerblue','firebrick','floralwhite','forestgreen','fuchsia','gainsboro','ghostwhite','gold','goldenrod','gray','green','greenyellow','honeydew','hotpink','indianred','indigo','ivory','khaki','lavender','lavenderblush','lawngreen','lemonchiffon','lightblue','lightcoral','lightcyan','lightgoldenrodyellow','lightgreen','lightgrey','lightpink','lightsalmon','lightseagreen','lightskyblue','lightslategray','lightsteelblue','lightyellow','lime','limegreen','linen','magenta','maroon','mediumaquamarine','mediumblue','mediumorchid','mediumpurple','mediumseagreen','mediumslateblue','mediumspringgreen','mediumturquoise','mediumvioletred','midnightblue','mintcream','mistyrose','moccasin','navajowhite','navy','oldlace','olive','olivedrab','orange','orangered','orchid','palegoldenrod','palegreen','paleturquoise','palevioletred','papayawhip','peachpuff','peru','pink','plum','powderblue','purple','red','rosybrown','royalblue','saddlebrown','salmon','sandybrown','seagreen','seashell','sienna','silver','skyblue','slateblue','slategray','snow','springgreen','steelblue','tan','teal','thistle','tomato','turquoise','violet','wheat','white','whitesmoke','yellow','yellowgreen'],['all-scroll','col-resize','crosshair','default','e-resize','hand','help','move','n-resize','ne-resize','no-drop','not-allowed','nw-resize','pointer','progress','row-resize','s-resize','se-resize','sw-resize','text','vertical-text','w-resize','wait'],['-moz-inline-box','-moz-inline-stack','block','inline','inline-block','inline-table','list-item','run-in','table','table-caption','table-cell','table-column','table-column-group','table-footer-group','table-header-group','table-row','table-row-group'],['armenian','circle','decimal','decimal-leading-zero','disc','georgian','lower-alpha','lower-greek','lower-latin','lower-roman','square','upper-alpha','upper-latin','upper-roman'],['100','200','300','400','500','600','700','800','900','bold','bolder','lighter'],['condensed','expanded','extra-condensed','extra-expanded','narrower','semi-condensed','semi-expanded','ultra-condensed','ultra-expanded','wider'],['behind','center-left','center-right','far-left','far-right','left-side','leftwards','right-side','rightwards'],['large','larger','small','smaller','x-large','x-small','xx-large','xx-small'],['-moz-pre-wrap','-o-pre-wrap','-pre-wrap','nowrap','pre','pre-line','pre-wrap'],['dashed','dotted','double','groove','outset','ridge','solid'],['baseline','middle','sub','super','text-bottom','text-top'],['caption','icon','menu','message-box','small-caption','status-bar'],['fast','faster','slow','slower','x-fast','x-slow'],['above','below','higher','level','lower'],['border-box','contain','content-box','cover','padding-box'],['cursive','fantasy','monospace','sans-serif','serif'],['loud','silent','soft','x-loud','x-soft'],['no-repeat','repeat-x','repeat-y','round','space'],['blink','line-through','overline','underline'],['high','low','x-high','x-low'],['absolute','relative','static'],['capitalize','lowercase','uppercase'],['child','female','male'],['bidi-override','embed'],['bottom','top'],['clip','ellipsis'],['continuous','digits'],['hide','show'],['inside','outside'],['italic','oblique'],['left','right'],['ltr','rtl'],['no-content','no-display'],['suppress','unrestricted'],['thick','thin'],[','],['/'],['always'],['auto'],['avoid'],['both'],['break-word'],['center'],['code'],['collapse'],['fixed'],['hidden'],['inherit'],['inset'],['invert'],['justify'],['local'],['medium'],['mix'],['none'],['normal'],['once'],['repeat'],['scroll'],['separate'],['small-caps'],['spell-out'],['transparent'],['visible']];return{'-moz-border-radius':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[36]]},'-moz-border-radius-bottomleft':{'cssExtra':c[0],'cssPropBits':5},'-moz-border-radius-bottomright':{'cssExtra':c[0],'cssPropBits':5},'-moz-border-radius-topleft':{'cssExtra':c[0],'cssPropBits':5},'-moz-border-radius-topright':{'cssExtra':c[0],'cssPropBits':5},'-moz-box-shadow':{'cssExtra':c[1],'cssAlternates':['boxShadow'],'cssPropBits':7,'cssLitGroup':[L[0],L[35],L[48],L[54]]},'-moz-opacity':{'cssPropBits':1,'cssLitGroup':[L[47]]},'-moz-outline':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[49],L[52],L[54]]},'-moz-outline-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[49]]},'-moz-outline-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'-moz-outline-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'-o-text-overflow':{'cssPropBits':0,'cssLitGroup':[L[25]]},'-webkit-border-bottom-left-radius':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-bottom-right-radius':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-radius':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[36]]},'-webkit-border-radius-bottom-left':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-radius-bottom-right':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-radius-top-left':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-radius-top-right':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-top-left-radius':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-top-right-radius':{'cssExtra':c[0],'cssPropBits':5},'-webkit-box-shadow':{'cssExtra':c[1],'cssAlternates':['boxShadow'],'cssPropBits':7,'cssLitGroup':[L[0],L[35],L[48],L[54]]},'azimuth':{'cssPropBits':5,'cssLitGroup':[L[6],L[30],L[42],L[47]]},'background':{'cssExtra':RegExp('^ *(?:\\s*'+s[0]+'){0,2} *$','i'),'cssPropBits':23,'cssLitGroup':[L[0],L[14],L[17],L[24],L[30],L[35],L[36],L[38],L[42],L[45],L[47],L[51],L[54],L[57],L[58],L[62]]},'background-attachment':{'cssExtra':c[0],'cssPropBits':0,'cssLitGroup':[L[35],L[45],L[51],L[58]]},'background-color':{'cssExtra':c[2],'cssPropBits':130,'cssLitGroup':[L[0],L[47],L[62]]},'background-image':{'cssExtra':c[0],'cssPropBits':16,'cssLitGroup':[L[35],L[54]]},'background-position':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[24],L[30],L[35],L[42]]},'background-repeat':{'cssExtra':c[0],'cssPropBits':0,'cssLitGroup':[L[17],L[35],L[57]]},'border':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[52],L[54],L[62]]},'border-bottom':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[52],L[54],L[62]]},'border-bottom-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[62]]},'border-bottom-left-radius':{'cssExtra':c[0],'cssPropBits':5},'border-bottom-right-radius':{'cssExtra':c[0],'cssPropBits':5},'border-bottom-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'border-bottom-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'border-collapse':{'cssPropBits':0,'cssLitGroup':[L[44],L[47],L[59]]},'border-color':{'cssExtra':RegExp('^ *(?:\\s*'+s[0]+'){1,4} *$','i'),'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[62]]},'border-left':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[52],L[54],L[62]]},'border-left-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[62]]},'border-left-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'border-left-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'border-radius':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[36]]},'border-right':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[52],L[54],L[62]]},'border-right-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[62]]},'border-right-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'border-right-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'border-spacing':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[47]]},'border-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'border-top':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[52],L[54],L[62]]},'border-top-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[62]]},'border-top-left-radius':{'cssExtra':c[0],'cssPropBits':5},'border-top-right-radius':{'cssExtra':c[0],'cssPropBits':5},'border-top-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'border-top-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'border-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'bottom':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'box-shadow':{'cssExtra':c[1],'cssPropBits':7,'cssLitGroup':[L[0],L[35],L[48],L[54]]},'caption-side':{'cssPropBits':0,'cssLitGroup':[L[24],L[47]]},'clear':{'cssPropBits':0,'cssLitGroup':[L[30],L[40],L[47],L[54]]},'clip':{'cssExtra':/^ *\s*rect\(\s*(?:0|[+\-]?\d+(?:\.\d+)?(?:[cem]m|ex|in|p[ctx])|auto)\s*,\s*(?:0|[+\-]?\d+(?:\.\d+)?(?:[cem]m|ex|in|p[ctx])|auto)\s*,\s*(?:0|[+\-]?\d+(?:\.\d+)?(?:[cem]m|ex|in|p[ctx])|auto)\s*,\s*(?:0|[+\-]?\d+(?:\.\d+)?(?:[cem]m|ex|in|p[ctx])|auto) *\) *$/i,'cssPropBits':0,'cssLitGroup':[L[38],L[47]]},'color':{'cssExtra':c[2],'cssPropBits':130,'cssLitGroup':[L[0],L[47]]},'content':{'cssPropBits':0},'counter-increment':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[47],L[54]]},'counter-reset':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[47],L[54]]},'cue':{'cssPropBits':16,'cssLitGroup':[L[47],L[54]]},'cue-after':{'cssPropBits':16,'cssLitGroup':[L[47],L[54]]},'cue-before':{'cssPropBits':16,'cssLitGroup':[L[47],L[54]]},'cursor':{'cssExtra':c[0],'cssPropBits':144,'cssLitGroup':[L[1],L[35],L[38],L[47]]},'direction':{'cssPropBits':0,'cssLitGroup':[L[31],L[47]]},'display':{'cssPropBits':32,'cssLitGroup':[L[2],L[47],L[54]]},'elevation':{'cssPropBits':5,'cssLitGroup':[L[13],L[47]]},'empty-cells':{'cssPropBits':0,'cssLitGroup':[L[27],L[47]]},'filter':{'cssExtra':/^ *(?:\s*alpha\(\s*opacity\s*=\s*(?:0|\d+(?:\.\d+)?%|[+\-]?\d+(?:\.\d+)?) *\))+ *$/i,'cssPropBits':32},'float':{'cssAlternates':['cssFloat','styleFloat'],'cssPropBits':32,'cssLitGroup':[L[30],L[47],L[54]]},'font':{'cssExtra':c[0],'cssPropBits':9,'cssLitGroup':[L[4],L[7],L[11],L[15],L[29],L[35],L[36],L[47],L[52],L[55],L[60]]},'font-family':{'cssExtra':c[0],'cssPropBits':8,'cssLitGroup':[L[15],L[35],L[47]]},'font-size':{'cssPropBits':1,'cssLitGroup':[L[7],L[47],L[52]]},'font-stretch':{'cssPropBits':0,'cssLitGroup':[L[5],L[55]]},'font-style':{'cssPropBits':0,'cssLitGroup':[L[29],L[47],L[55]]},'font-variant':{'cssPropBits':0,'cssLitGroup':[L[47],L[55],L[60]]},'font-weight':{'cssPropBits':0,'cssLitGroup':[L[4],L[47],L[55]]},'height':{'cssPropBits':37,'cssLitGroup':[L[38],L[47]]},'left':{'cssPropBits':37,'cssLitGroup':[L[38],L[47]]},'letter-spacing':{'cssPropBits':5,'cssLitGroup':[L[47],L[55]]},'line-height':{'cssPropBits':1,'cssLitGroup':[L[47],L[55]]},'list-style':{'cssPropBits':16,'cssLitGroup':[L[3],L[28],L[47],L[54]]},'list-style-image':{'cssPropBits':16,'cssLitGroup':[L[47],L[54]]},'list-style-position':{'cssPropBits':0,'cssLitGroup':[L[28],L[47]]},'list-style-type':{'cssPropBits':0,'cssLitGroup':[L[3],L[47],L[54]]},'margin':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'margin-bottom':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'margin-left':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'margin-right':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'margin-top':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'max-height':{'cssPropBits':1,'cssLitGroup':[L[38],L[47],L[54]]},'max-width':{'cssPropBits':1,'cssLitGroup':[L[38],L[47],L[54]]},'min-height':{'cssPropBits':1,'cssLitGroup':[L[38],L[47]]},'min-width':{'cssPropBits':1,'cssLitGroup':[L[38],L[47]]},'opacity':{'cssPropBits':33,'cssLitGroup':[L[47]]},'outline':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[49],L[52],L[54]]},'outline-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[49]]},'outline-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'outline-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'overflow':{'cssPropBits':32,'cssLitGroup':[L[38],L[46],L[47],L[58],L[63]]},'overflow-x':{'cssPropBits':0,'cssLitGroup':[L[32],L[38],L[46],L[58],L[63]]},'overflow-y':{'cssPropBits':0,'cssLitGroup':[L[32],L[38],L[46],L[58],L[63]]},'padding':{'cssPropBits':1,'cssLitGroup':[L[47]]},'padding-bottom':{'cssPropBits':33,'cssLitGroup':[L[47]]},'padding-left':{'cssPropBits':33,'cssLitGroup':[L[47]]},'padding-right':{'cssPropBits':33,'cssLitGroup':[L[47]]},'padding-top':{'cssPropBits':33,'cssLitGroup':[L[47]]},'page-break-after':{'cssPropBits':0,'cssLitGroup':[L[30],L[37],L[38],L[39],L[47]]},'page-break-before':{'cssPropBits':0,'cssLitGroup':[L[30],L[37],L[38],L[39],L[47]]},'page-break-inside':{'cssPropBits':0,'cssLitGroup':[L[38],L[39],L[47]]},'pause':{'cssPropBits':5,'cssLitGroup':[L[47]]},'pause-after':{'cssPropBits':5,'cssLitGroup':[L[47]]},'pause-before':{'cssPropBits':5,'cssLitGroup':[L[47]]},'pitch':{'cssPropBits':5,'cssLitGroup':[L[19],L[47],L[52]]},'pitch-range':{'cssPropBits':5,'cssLitGroup':[L[47]]},'play-during':{'cssExtra':c[0],'cssPropBits':16,'cssLitGroup':[L[38],L[47],L[53],L[54],L[57]]},'position':{'cssPropBits':32,'cssLitGroup':[L[20],L[47]]},'quotes':{'cssExtra':c[0],'cssPropBits':0,'cssLitGroup':[L[47],L[54]]},'richness':{'cssPropBits':5,'cssLitGroup':[L[47]]},'right':{'cssPropBits':37,'cssLitGroup':[L[38],L[47]]},'speak':{'cssPropBits':0,'cssLitGroup':[L[47],L[54],L[55],L[61]]},'speak-header':{'cssPropBits':0,'cssLitGroup':[L[37],L[47],L[56]]},'speak-numeral':{'cssPropBits':0,'cssLitGroup':[L[26],L[47]]},'speak-punctuation':{'cssPropBits':0,'cssLitGroup':[L[43],L[47],L[54]]},'speech-rate':{'cssPropBits':5,'cssLitGroup':[L[12],L[47],L[52]]},'stress':{'cssPropBits':5,'cssLitGroup':[L[47]]},'table-layout':{'cssPropBits':0,'cssLitGroup':[L[38],L[45],L[47]]},'text-align':{'cssPropBits':0,'cssLitGroup':[L[30],L[42],L[47],L[50]]},'text-decoration':{'cssPropBits':0,'cssLitGroup':[L[18],L[47],L[54]]},'text-indent':{'cssPropBits':5,'cssLitGroup':[L[47]]},'text-overflow':{'cssPropBits':0,'cssLitGroup':[L[25]]},'text-shadow':{'cssExtra':c[1],'cssPropBits':7,'cssLitGroup':[L[0],L[35],L[48],L[54]]},'text-transform':{'cssPropBits':0,'cssLitGroup':[L[21],L[47],L[54]]},'text-wrap':{'cssPropBits':0,'cssLitGroup':[L[33],L[54],L[55]]},'top':{'cssPropBits':37,'cssLitGroup':[L[38],L[47]]},'unicode-bidi':{'cssPropBits':0,'cssLitGroup':[L[23],L[47],L[55]]},'vertical-align':{'cssPropBits':5,'cssLitGroup':[L[10],L[24],L[47]]},'visibility':{'cssPropBits':32,'cssLitGroup':[L[44],L[46],L[47],L[63]]},'voice-family':{'cssExtra':c[0],'cssPropBits':8,'cssLitGroup':[L[22],L[35],L[47]]},'volume':{'cssPropBits':1,'cssLitGroup':[L[16],L[47],L[52]]},'white-space':{'cssPropBits':0,'cssLitGroup':[L[8],L[47],L[55]]},'width':{'cssPropBits':33,'cssLitGroup':[L[38],L[47]]},'word-spacing':{'cssPropBits':5,'cssLitGroup':[L[47],L[55]]},'word-wrap':{'cssPropBits':0,'cssLitGroup':[L[41],L[55]]},'z-index':{'cssPropBits':69,'cssLitGroup':[L[38],L[47]]},'zoom':{'cssPropBits':1,'cssLitGroup':[L[55]]}};})();if(typeof window!=='undefined'){window['cssSchema']=r;}
// Copyright (C) 2011 Google Inc.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//      http://www.apache.org/licenses/LICENSE-2.0
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.
var t;var u;(function(){
function c(s){var i=parseInt(s.substring(1),16);if(i>0xffff){return i-=0x10000,String.fromCharCode(0xd800+(i>>10),0xdc00+(i&0x3FF));}else if(i==i){return String.fromCharCode(i);}else if(s[1]<' '){return'';}else{return s[1];}}
function e(s,i){return'"'+s.replace(/[\u0000-\u001f\\\"<>]/g,i)+'"';}
function h(i){return m[i]||(m[i]='\\'+i.charCodeAt(0).toString(16)+' ');}
function k(i){return p[i]||(p[i]=(i<'\x10'?'%0':'%')+i.charCodeAt(0).toString(16));}
var m={'\\':'\\\\'};var p={'\\':'%5c'};var q='[\\t\\n\\f ]';var W=q+'*';var N='[\\n\\f]';var v='[\\ud800-\\udbff][\\udc00-\\udfff]';var F='[\\u0080-\\ud7ff\\ue000-\\ufffd]|'+v;var U='[0-9a-fA-F]{1,6}'+q+'?';var G='\\\\'+U;var H='(?:'+U+'|[\\u0020-\\u007e\\u0080-\\ud7ff\\ue000\\ufffd]|'+v+')';var I='\\\\'+H;var J='(?:[\\t\\x21\\x23-\\x26\\x28-\\x5b\\x5d-\\x7e]|'+F+'|'+I+')';var K='[^\'"\\n\\f\\\\]|\\\\[\\s\\S]';var L='"(?:\'|'+K+')*"'+'|\'(?:\"|'+K+')*\'';var M='[-+]?(?:[0-9]+(?:[.][0-9]+)?|[.][0-9]+)';var O='(?:[a-zA-Z_]|'+F+'|'+I+')';var P='(?:[a-zA-Z0-9_-]|'+F+'|'+I+')';var Q=P+'+';var R='-?'+O+P+'*';var T='@'+R;var V='#'+Q;var X=M;var Y='(?:@?-?'+O+'|#)'+P+'*';var Z=M+'%';var $=M+R;var _=M+'(?:%|'+R+')?';var a1='url[(]'+W+'(?:'+L+'|'+J+'*)'+W+'[)]';var b1='U[+][0-9A-F?]{1,6}(?:-[0-9A-F]{1,6})?';var c1='<\!--';var d1='-->';var S=q+'+';var e1='/(?:[*][^*]*[*]+(?:[^/][^*]*[*]+)*/|/[^\\n\\f]*)';var f1='(?!url[(])(?=('+R+'))\\1[(]';var g1='~=';var h1='[|]=';var i1='[^]=';var j1='[$]=';var k1='[*]=';var l1='[~|^$*]=';var m1='[^"\'\\\\/]|/(?![/*])';var n1='\\uFEFF';var o1=new RegExp([n1,b1,a1,f1,Y,L,_,c1,d1,S,e1,l1,m1].join("|"),'gi');u=function(i){return i.replace(new RegExp('\\\\(?:'+H+'|'+N+')','g'),c);};t=function(s){s=''+s;var p1=s.replace(/\r\n?/g,'\n').match(o1)||[];var j=0;var q1=' ';for(var i=0,n=p1.length;i<n;++i){var r1=u(p1[i]);var s1=r1.length;var cc=r1.charCodeAt(0);r1=(cc=='"'.charCodeAt(0)||cc=='\''.charCodeAt(0))?e(r1.substring(1,s1-1),h):(cc=='/'.charCodeAt(0)&&s1>1||r1=='\\'||r1==d1||r1==c1||r1=='\ufeff'||cc<=' '.charCodeAt(0))?' ':/url\(/i.test(r1)?'url('+e(r1.replace(new RegExp('^url\\('+W+'["\']?|["\']?'+W+'\\)$','gi'),''),k)+')':r1;if(q1!=r1||r1!=' '){p1[j++]=q1=r1;}}p1.length=j;return p1;};})();if(typeof window!=='undefined'){window['lexCss']=t;window['decodeCss']=u;}
// Copyright (C) 2011 Google Inc.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//      http://www.apache.org/licenses/LICENSE-2.0
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.
var w=(function(){var N='url("about:blank")';var c=/[\n\f\r\"\'()*<>]/g;var e={'\n':'%0a','\f':'%0c','\r':'%0d','"':'%22','\'':'%27','(':'%28',')':'%29','*':'%2a','<':'%3c','>':'%3e'};function h(s){if('string'===typeof s){return'url("'+s.replace(c,m)+'")';}else{return N;}}function m(i){return e[i];}var U=new RegExp('^'+'(?:'+'([^:\/?# ]+)'+':)?');var p=/^(?:https?|mailto)$/i;function q(i,j,n){if(!n){return null;}var k=(''+i).match(U);if(k&&(!k[1]||p.test(k[1]))){return n(i,j);}else{return null;}}function v(k){var n={};for(var i=k.length;--i>=0;){var s=k[i];for(var j=s.length;--j>=0;){n[s[j]]=G;}}return n;}function F(i,s){var j=1,k=s+1,n=i.length;while(k<n&&j){var H=i[k++];j+=(H==='('?1:H===')'?-1:0);}return k;}var G={};return function(j,n,s,H){var I=n.cssPropBits;var J=I&(d|f);var K=NaN;var i=0,k=0;for(;i<s.length;++i){var L=s[i].toLowerCase();var M=L.charCodeAt(0),O,P,Q,R,S;var T,V;L=((M===' '.charCodeAt(0))?'':(M==='"'.charCodeAt(0))?((J===f&&H)?(h(q(u(s[i].substring(1,L.length-1)),j,H))):(J===d)?L:''):(M==='#'.charCodeAt(0)&&/^#(?:[0-9a-f]{3}){1,2}$/.test(L))?(I&a?L:''):('0'.charCodeAt(0)<=M&&M<='9'.charCodeAt(0))?((I&C)?((I&l)?(L.match(/^\d{1,7}$/)?L:''):L):''):(O=L.charCodeAt(1),P=L.charCodeAt(2),Q='0'.charCodeAt(0)<=O&&O<='9'.charCodeAt(0),R='0'.charCodeAt(0)<=P&&P<='9'.charCodeAt(0),(M==='+'.charCodeAt(0)&&(Q||(O==='.'.charCodeAt(0)&&R))))?((I&C)?((I&l)?(L.match(/^\+\d{1,7}$/)?L:''):((Q?'':'0')+L.substring(1))):''):(M==='-'.charCodeAt(0)&&(Q||(O==='.'.charCodeAt(0)&&R)))?((I&b)?((I&l)?(L.match(/^\-\d{1,7}$/)?L:''):((Q?'-':'-0')+L.substring(1))):((I&C)?'0':'')):(M==='.'.charCodeAt(0)&&Q)?((I&C)?'0'+L:''):('url('===L.substring(0,4))?((H&&(J&f))?h(q(s[i].substring(5,L.length-2),j,H)):''):((L.charAt(L.length-1)==='(')&&(S=F(s,i),s.splice(i,S-i,L=s.slice(i,S).join(' '))),T=n.cssLitGroup,V=(T?(n.cssLitMap||(n.cssLitMap=v(T))):G),(V[L]===G||n.cssExtra&&n.cssExtra.test(L)))?L:(/^\w+$/.test(L)&&(J===d))?(K+1===k?(s[K]=s[K].substring(0,s[K].length-1)+' '+L+'"',L=''):(K=k,'"'+L+'"')):'');if(L){s[k++]=L;}}if(k===1&&s[0]===N){k=0;}s.length=k;};})();
function x(s,c){var h=[];var e=[];var k=0,i;for(i=0;i<s.length;++i){if(!(s[i]==' '&&(s[i-1]=='>'||s[i+1]=='>'))){s[k++]=s[i];}}s.length=k;var n=s.length,j=0;for(i=0;i<n;++i){if(s[i]==','){p(j,i);j=i+1;}}p(j,n);function p(j,m){var q=false;if(s[j]===' '){++j;}if(m-1!==j&&s[m]===' '){--m;}var v=[];var F=j;var G='';for(var i=j;i<m;++i){var H=s[i];var I=(H==='>');if(I||H===' '){G=J(F,i,false);if(!G||(I&&/^html/i.test(G))){return;}F=i+1;v.push(G,I?' > ':' ');}}G=J(F,m,true);if(!G){return;}v.push(G);function J(j,m,L){var M=j,N=m;var O,P,Q,H,R;O='';if(j<m){H=s[j].toLowerCase();if(H==='*'||(H==='body'&&j+1!==m&&!L)||('number'===typeof(R=B.ELEMENTS[H])&&!(R&B.eflags.UNSAFE))){++j;O=H;}}P='';while(j<m){H=s[j];if(H.charAt(0)==='#'){if(/^#_|__$|[^#0-9A-Za-z:_\-]/.test(H)){return null;}P+=H+'-'+c;}else if(H==='.'){if(++j<m&&/^[0-9A-Za-z:_\-]+$/.test(H=s[j])&&!/^_|__$/.test(H)){P+='.'+H;}else{return null;}}else{break;}++j;}Q='';if(j<m&&s[j]===':'){H=s[++j];if(H==='visited'||H==='link'){if(!/^[a*]?$/.test(O)){return null;}q=true;Q=':'+H;O='a';++j;}}if(j===m){return O+P+Q;}return null;}var K=v.join('');if(/^body\b/.test(K)){K='.vdoc-body___.'+c+K.substring(4);}else{K='.'+c+' '+K;}(q?h:e).push(K);}return[e,h];}
var y=(function(){var c={};var e={'braille':c,'embossed':c,'handheld':c,'print':c,'projection':c,'screen':c,'speech':c,'tty':c,'tv':c};function s(h){var j=false;for(var i=0,n=h.length;i<n-1;++i){var k=h[i];if(':'===h[i+1]){j=!(r[k].cssPropBits&o);}if(j){h[i]='';}if(';'===k){j=false;}}return h.join('');}return function(h,i,j){var k=void 0;var m=[];var n=false;z(h,{startStylesheet:function(){k=[];},endStylesheet:function(){},startAtrule:function(q,v){if(n){q=null;}else if(q==='@media'){v=v.filter(function(F){return e[F]==c;});if(v.length){k.push(q,v.join(','),'{');}else{q=null;}}else{if(q==='@import'){if(window.console){window.console.log('@import '+v.join(' ')+' elided');}}q=null;}n=!q;m.push(q);},endAtrule:function(){var q=m.pop();if(!n){k.push(';');}p();},startBlock:function(){if(!n){k.push('{');}},endBlock:function(){if(!n){k.push('}');n=true;}},startRuleset:function(q){var v=void 0;var F=false;if(!n){var G=x(q,i);var H=G[0];v=G[1];if(!H.length&&!v.length){n=true;}else{var I=H.join(', ');if(!I){I='head > html';F=true;}k.push(I,'{');}}m.push(n?null:{historySensitiveSelectors:v,endOfSelectors:k.length-1,removeHistoryInsensitiveSelectors:F});},endRuleset:function(){var q=m.pop();var v=k.length;if(!n){k.push('}');if(q){var F=q.historySensitiveSelectors;if(F.length){var G=k.slice(q.endOfSelectors);k.push(F.join(', '),s(G));}}}if(q&&q.removeHistoryInsensitiveSelectors){k.splice(q.endOfSelectors-1,v+1);}p();},declaration:function(q,v){if(!n){var F=r[q];if(F){w(q,F,v,j);if(v.length){k.push(q,':',v.join(' '),';');}}}}});function p(){n=m.length!==0&&m[m.length-1]!==null;}return k.join('');};})();if(typeof window!=='undefined'){window['sanitizeCssProperty']=w;window['sanitizeCssSelectors']=x;window['sanitizeStylesheet']=y;}
// Copyright (C) 2010 Google Inc.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//      http://www.apache.org/licenses/LICENSE-2.0
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.
var z;var A;(function(){z=function(e,j){var s=t(e);if(j.startStylesheet){j.startStylesheet();}for(var i=0,n=s.length;i<n;){i=s[i]===' '?i+1:c(s,i,n,j);}if(j.endStylesheet){j.endStylesheet();}};
function c(e,i,n,j){if(i<n){var s=e[i];if(s.charAt(0)==='@'){return h(e,i,n,j,true);}else{return m(e,i,n,j);}}else{return i;}}
function h(j,i,n,F,G){var H=i++;while(i<n&&j[i]!=='{'&&j[i]!==';'){++i;}if(i<n&&(G||j[i]===';')){var s=H+1,e=i;if(s<n&&j[s]===' '){++s;}if(e>s&&j[e-1]===' '){--e;}if(F.startAtrule){F.startAtrule(j[H].toLowerCase(),j.slice(s,e));}i=(j[i]==='{')?k(j,i,n,F):i+1;if(F.endAtrule){F.endAtrule();}}return i;}
function k(e,i,n,j){++i;if(j.startBlock){j.startBlock();}while(i<n){var s=e[i].charAt(0);if(s=='}'){++i;break;}if(s===' '||s===';'){i=i+1;}else if(s==='@'){i=h(e,i,n,j,false);}else if(s==='{'){i=k(e,i,n,j);}else{i=m(e,i,n,j);}}if(j.endBlock){j.endBlock();}return i;}
function m(j,i,n,F){var s=i,e=p(j,i,n,true);if(e<0){e=~e;return i===e?e+1:e;}i=e;if(e>s&&j[e-1]===' '){--e;}var G=j[i];++i;if(G!=='{'){return i;}if(F.startRuleset){F.startRuleset(j.slice(s,e));}while(i<n){G=j[i];if(G==='}'){++i;break;}if(G===' '){i=i+1;}else{i=v(j,i,n,F);}}if(F.endRuleset){F.endRuleset();}return i<n?i+1:i;}
function p(e,i,n,j){var s=i;var F;var G=[],H=-1;for(;i<n;++i){F=e[i].charAt(0);if(F==='['||F==='('){G[++H]=F;}else if((F===']'&&G[H]==='[')||(F===')'&&G[H]==='(')){--H;}else if(F==='{'||F==='}'||F===';'||F==='@'||(F===':'&&!j)){break;}}if(H>=0){i=~(i+1);}return i;}
var q=/^-?[a-z]/i;
function v(F,i,n,G){var H=F[i++];if(!q.test(H)){return i+1;}var I;if(i<n&&F[i]===' '){++i;}if(i==n||F[i]!==':'){while(i<n&&(I=F[i])!==';'&&I!=='}'){++i;}return i;}++i;if(i<n&&F[i]===' '){++i;}var s=i,e=p(F,i,n,false);if(e<0){e=~e;}else{var J=[],K=0;for(var j=s;j<e;++j){I=F[j];if(I!==' '){J[K++]=I;}}if(e<n){do{I=F[e];if(I===';'||I==='}'){break;}K=0;}while(++e<n);if(I===';'){++e;}}if(K&&G.declaration){G.declaration(H.toLowerCase(),J);}}return e;}
A=function(e,j){var s=t(e);for(var i=0,n=s.length;i<n;){i=s[i]!==' '?v(s,i,n,j):i+1;}};})();if(typeof window!=='undefined'){window['parseCssStylesheet']=z;window['parseCssDeclarations']=A;}
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
var B={};B.atype={NONE:0,URI:1,URI_FRAGMENT:11,SCRIPT:2,STYLE:3,ID:4,IDREF:5,IDREFS:6,GLOBAL_NAME:7,LOCAL_NAME:8,CLASSES:9,FRAME_TARGET:10};B.ATTRIBS={'*::accesskey':0,'*::class':9,'*::contenteditable':0,'*::contextmenu':0,'*::dir':0,'*::draggable':0,'*::dropzone':0,'*::hidden':0,'*::id':4,'*::lang':0,'*::onabort':2,'*::onblur':2,'*::oncanplay':2,'*::oncanplaythrough':2,'*::onchange':2,'*::onclick':2,'*::oncontextmenu':2,'*::oncuechange':2,'*::ondblclick':2,'*::ondrag':2,'*::ondragend':2,'*::ondragenter':2,'*::ondragleave':2,'*::ondragover':2,'*::ondragstart':2,'*::ondrop':2,'*::ondurationchange':2,'*::onemptied':2,'*::onended':2,'*::onerror':2,'*::onfocus':2,'*::oninput':2,'*::oninvalid':2,'*::onkeydown':2,'*::onkeypress':2,'*::onkeyup':2,'*::onload':2,'*::onloadeddata':2,'*::onloadedmetadata':2,'*::onloadstart':2,'*::onmousedown':2,'*::onmousemove':2,'*::onmouseout':2,'*::onmouseover':2,'*::onmouseup':2,'*::onmousewheel':2,'*::onpause':2,'*::onplay':2,'*::onplaying':2,'*::onprogress':2,'*::onratechange':2,'*::onreadystatechange':2,'*::onreset':2,'*::onscroll':2,'*::onseeked':2,'*::onseeking':2,'*::onselect':2,'*::onshow':2,'*::onstalled':2,'*::onsubmit':2,'*::onsuspend':2,'*::ontimeupdate':2,'*::onvolumechange':2,'*::onwaiting':2,'*::spellcheck':0,'*::style':3,'*::tabindex':0,'*::title':0,'a::href':1,'a::hreflang':0,'a::media':0,'a::rel':0,'a::target':0,'a::type':0,'area::alt':0,'area::coords':0,'area::href':1,'area::hreflang':0,'area::media':0,'area::rel':0,'area::shape':0,'area::target':10,'area::type':0,'audio::autoplay':0,'audio::controls':0,'audio::loop':0,'audio::mediagroup':0,'audio::preload':0,'audio::src':1,'base::href':1,'base::target':10,'blockquote::cite':1,'body::onafterprint':2,'body::onbeforeprint':2,'body::onbeforeunload':2,'body::onblur':2,'body::onerror':2,'body::onfocus':2,'body::onhashchange':2,'body::onload':2,'body::onmessage':2,'body::onoffline':2,'body::ononline':2,'body::onpagehide':2,'body::onpageshow':2,'body::onpopstate':2,'body::onredo':2,'body::onresize':2,'body::onscroll':2,'body::onstorage':2,'body::onundo':2,'body::onunload':2,'button::autofocus':0,'button::disabled':0,'button::form':0,'button::formaction':1,'button::formenctype':0,'button::formmethod':0,'button::formnovalidate':0,'button::formtarget':10,'button::name':8,'button::type':0,'button::value':0,'canvas::height':0,'canvas::width':0,'col::span':0,'colgroup::span':0,'command::checked':0,'command::disabled':0,'command::icon':1,'command::label':0,'command::radiogroup':0,'command::type':0,'del::cite':1,'del::datetime':0,'details::open':0,'embed::height':0,'embed::src':1,'embed::type':0,'embed::width':0,'fieldset::disabled':0,'fieldset::form':0,'fieldset::name':8,'form::accept-charset':0,'form::action':1,'form::autocomplete':0,'form::enctype':0,'form::method':0,'form::name':7,'form::novalidate':0,'form::target':10,'html:: manifest':1,'iframe::height':0,'iframe::name':7,'iframe::sandbox':0,'iframe::seamless':0,'iframe::src':1,'iframe::srcdoc':10,'iframe::width':0,'img::alt':0,'img::height':0,'img::ismap':0,'img::name':7,'img::src':1,'img::usemap':11,'img::width':0,'input::accept':0,'input::alt':0,'input::autocomplete':0,'input::autofocus':0,'input::checked':0,'input::dirname':0,'input::disabled':0,'input::form':0,'input::formaction':1,'input::formenctype':0,'input::formmethod':0,'input::formnovalidate':0,'input::formtarget':10,'input::height':0,'input::list':0,'input::max':0,'input::maxlength':0,'input::min':0,'input::multiple':0,'input::name':8,'input::pattern':0,'input::placeholder':0,'input::readonly':0,'input::required':0,'input::step':0,'input::size':0,'input::src':1,'input::type':0,'input::value':0,'input::width':0,'ins::cite':1,'ins::datetime':0,'keygen::autofocus':0,'keygen::challenge':0,'keygen::disabled':0,'keygen::form':0,'keygen::keytype':0,'keygen::name':8,'label::for':5,'label::form':0,'link::href':1,'link::hreflang':0,'link::media':0,'link::rel':0,'link::sizes':0,'link::type':0,'li::value':0,'map::name':7,'menu::label':0,'menu::type':0,'meta::charset':0,'meta::content':0,'meta::http-equiv':0,'meta::name':7,'meter::form':0,'meter::high':0,'meter::low':0,'meter::max':0,'meter::min':0,'meter::optimum':0,'meter::value':0,'object::data':1,'object::form':0,'object::height':0,'object::name':8,'object::type':0,'object::usemap':11,'object::width':0,'ol::reversed':0,'ol::start':0,'optgroup::disabled':0,'optgroup::label':0,'option::disabled':0,'option::label':0,'option::selected':0,'option::value':0,'output::for':5,'output::form':0,'output::name':8,'param::name':8,'param::value':0,'progress::form':0,'progress::max':0,'progress::value':0,'q::cite':1,'script::async':0,'script::charset':0,'script::defer':0,'script::src':1,'script::type':0,'select::autofocus':0,'select::disabled':0,'select::form':0,'select::multiple':0,'select::name':8,'select::required':0,'select::size':0,'source::media':0,'source::src':1,'source::type':0,'style::media':0,'style::scoped':0,'style::type':0,'table::border':0,'td::colspan':0,'td::headers':6,'td::rowspan':0,'textarea::autofocus':0,'textarea::cols':0,'textarea::disabled':0,'textarea::form':0,'textarea::maxlength':0,'textarea::name':8,'textarea::placeholder':0,'textarea::readonly':0,'textarea::required':0,'textarea::rows':0,'textarea::wrap':0,'th::colspan':0,'th::headers':6,'th::rowspan':0,'th::scope':0,'time::datetime':0,'time::pubdate':0,'track::default':0,'track::kind':0,'track::label':0,'track::src':1,'track::srclang':0,'video::autoplay':0,'video::controls':0,'video::height':0,'video::loop':0,'video::mediagroup':0,'video::poster':1,'video::preload':0,'video::src':1,'video::width':0};B.eflags={OPTIONAL_ENDTAG:1,EMPTY:2,CDATA:4,RCDATA:8,UNSAFE:16,FOLDABLE:32,SCRIPT:64,STYLE:128};B.ELEMENTS={'a':0,'abbr':0,'address':0,'area':2,'article':0,'aside':0,'audio':0,'b':0,'base':18,'bdi':0,'bdo':0,'blockquote':0,'body':49,'br':2,'button':0,'canvas':0,'caption':0,'cite':0,'code':0,'col':2,'colgroup':1,'command':2,'datalist':0,'dd':1,'del':0,'details':0,'dfn':0,'div':0,'dl':0,'dt':1,'em':0,'embed':18,'fieldset':0,'figcaption':0,'figure':0,'footer':0,'form':0,'h1':0,'h2':0,'h3':0,'h4':0,'h5':0,'h6':0,'head':49,'header':0,'hgroup':0,'hr':2,'html':49,'i':0,'iframe':4,'img':2,'input':2,'ins':0,'kbd':0,'keygen':2,'label':0,'legend':0,'li':1,'link':18,'map':0,'mark':0,'menu':0,'meta':18,'meter':0,'nav':0,'noscript':20,'object':16,'ol':0,'optgroup':1,'option':1,'output':0,'p':1,'param':18,'pre':0,'progress':0,'q':0,'rp':1,'rt':1,'ruby':0,'s':0,'samp':0,'script':84,'section':0,'select':0,'small':0,'source':2,'span':0,'strong':0,'style':148,'sub':0,'summary':0,'sup':0,'table':0,'tbody':1,'td':1,'textarea':8,'tfoot':1,'th':1,'thead':1,'time':0,'title':24,'tr':1,'track':2,'u':0,'ul':0,'var':0,'video':0,'wbr':2};B.ueffects={NOT_LOADED:0,SAME_DOCUMENT:1,NEW_DOCUMENT:2};B.URIEFFECTS={'a::href':2,'area::href':2,'audio::src':1,'base::href':2,'blockquote::cite':0,'button::formaction':2,'command::icon':1,'del::cite':0,'embed::src':1,'form::action':2,'html:: manifest':1,'iframe::src':1,'img::src':1,'input::formaction':2,'input::src':1,'ins::cite':0,'link::href':2,'object::data':1,'q::cite':0,'script::src':1,'source::src':1,'track::src':1,'video::poster':1,'video::src':1};B.ltypes={UNSANDBOXED:2,SANDBOXED:1,DATA:0};B.LOADERTYPES={'a::href':2,'area::href':2,'audio::src':1,'base::href':2,'blockquote::cite':2,'button::formaction':2,'command::icon':1,'del::cite':2,'embed::src':1,'form::action':2,'html:: manifest':1,'iframe::src':1,'img::src':1,'input::formaction':2,'input::src':1,'ins::cite':2,'link::href':2,'object::data':0,'q::cite':2,'script::src':1,'source::src':1,'track::src':1,'video::poster':1,'video::src':1};if(typeof window!=='undefined'){window['html4']=B;}
// Copyright (C) 2006 Google Inc.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//      http://www.apache.org/licenses/LICENSE-2.0
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.
var D=(function(B){var A,w,r;if('undefined'!==typeof window){A=window['parseCssDeclarations'];w=window['sanitizeCssProperty'];r=window['cssSchema'];}var c;if('script'==='SCRIPT'.toLowerCase()){c=function(s){return s.toLowerCase();};}else{c=function(s){return s.replace(/[A-Z]/g,function(e){return String.fromCharCode(e.charCodeAt(0)|32);});};}var j={'lt':'<','gt':'>','amp':'&','nbsp':'\xA0','quot':'"','apos':'\''};var k=/^#(\d+)$/;var F=/^#x([0-9A-Fa-f]+)$/;function G(n){n=c(n);if(j.hasOwnProperty(n)){return j[n];}var m=n.match(k);if(m){return String.fromCharCode(parseInt(m[1],10));}else if(!!(m=n.match(F))){return String.fromCharCode(parseInt(m[1],16));}return'';}function H(_,n){return G(n);}var I=/\0/g;function J(s){return s.replace(I,'');}var K=/&(#\d+|#x[0-9A-Fa-f]+|\w+);/g;function L(s){return s.replace(K,H);}var M=/&/g;var N=/&([^a-z#]|#(?:[^0-9x]|x(?:[^0-9a-f]|$)|$)|$)/gi;var O=/[<]/g;var P=/>/g;var Q=/\"/g;function R(s){return(''+s).replace(M,'&amp;').replace(O,'&lt;').replace(P,'&gt;').replace(Q,'&#34;');}function S(e){return e.replace(N,'&amp;$1').replace(O,'&lt;').replace(P,'&gt;');}var T=new RegExp('^\\s*'+'([a-z][a-z-]*)'+'(?:'+('\\s*(=)\\s*'+'('+('(\")[^\"]*(\"|$)'+'|'+'(\')[^\']*(\'|$)'+'|'+'(?=[a-z][a-z-]*\\s*=)'+'|'+'[^\"\'\\s]*')+')')+')?','i');var U=/^(#[0-9]+|#x[0-9a-f]+|\w+);/i;var V=('a,b'.split(/(,)/).length===3);var W=B.eflags.CDATA|B.eflags.RCDATA;function X(h){return function(e,p){return Z(e,h,p);};}var Y={};function Z(e,i,n){var h=i;var m,p,q;var s=b1(e);var v={noMoreGT:false,noMoreEndComments:false};a1(i,s,0,v,n);}function $(h,p,i,s,e){return function(){a1(h,p,i,s,e);};}function a1(h,i,n,s,q){try{if(h.startDoc&&n==0){h.startDoc(q);}var m,p,v;for(var _=n,q1=i.length;_<q1;){var r1=i[_++];var s1=i[_];switch(r1){case'&':if(U.test(s1)){if(h.pcdata){h.pcdata('&'+s1,q,Y,$(h,i,_,s,q));}_++;}else{if(h.pcdata){h.pcdata("&amp;",q,Y,$(h,i,_,s,q));}}break;case'<\/':if(m=/^(\w+)[^\'\"]*/.exec(s1)){if(m[0].length===s1.length&&i[_+1]==='>'){_+=2;v=c(m[1]);if(B.ELEMENTS.hasOwnProperty(v)){if(h.endTag){h.endTag(v,q,Y,$(h,i,_,s,q));}}}else{_=c1(i,_,h,q,Y,s);}}else{if(h.pcdata){h.pcdata('&lt;/',q,Y,$(h,i,_,s,q));}}break;case'<':if(m=/^(\w+)\s*\/?/.exec(s1)){if(m[0].length===s1.length&&i[_+1]==='>'){_+=2;v=c(m[1]);if(B.ELEMENTS.hasOwnProperty(v)){if(h.startTag){h.startTag(v,[],q,Y,$(h,i,_,s,q));}var t1=B.ELEMENTS[v];if(t1&W){var u1={name:v,next:_,eflags:t1};_=f1(i,u1,h,q,Y,s);}}}else{_=d1(i,_,h,q,Y,s);}}else{if(h.pcdata){h.pcdata('&lt;',q,Y,$(h,i,_,s,q));}}break;case'<\!--':if(!s.noMoreEndComments){for(p=_+1;p<q1;p++){if(i[p]==='>'&&/--$/.test(i[p-1])){break;}}if(p<q1){_=p+1;}else{s.noMoreEndComments=true;}}if(s.noMoreEndComments){if(h.pcdata){h.pcdata('&lt;!--',q,Y,$(h,i,_,s,q));}}break;case'<\!':if(!/^\w/.test(s1)){if(h.pcdata){h.pcdata('&lt;!',q,Y,$(h,i,_,s,q));}}else{if(!s.noMoreGT){for(p=_+1;p<q1;p++){if(i[p]==='>'){break;}}if(p<q1){_=p+1;}else{s.noMoreGT=true;}}if(s.noMoreGT){if(h.pcdata){h.pcdata('&lt;!',q,Y,$(h,i,_,s,q));}}}break;case'<?':if(!s.noMoreGT){for(p=_+1;p<q1;p++){if(i[p]==='>'){break;}}if(p<q1){_=p+1;}else{s.noMoreGT=true;}}if(s.noMoreGT){if(h.pcdata){h.pcdata('&lt;?',q,Y,$(h,i,_,s,q));}}break;case'>':if(h.pcdata){h.pcdata("&gt;",q,Y,$(h,i,_,s,q));}break;case'':break;default:if(h.pcdata){h.pcdata(r1,q,Y,$(h,i,_,s,q));}break;}}if(h.endDoc){h.endDoc(q);}}catch(e){if(e!==Y){throw e;}}}function b1(s){var e=/(<\/|<\!--|<[!?]|[&<>])/g;s+='';if(V){return s.split(e);}else{var p=[];var h=0;var m;while((m=e.exec(s))!==null){p.push(s.substring(h,m.index));p.push(m[0]);h=m.index+m[0].length;}p.push(s.substring(h));return p;}}function c1(p,e,h,i,Y,s){var m=g1(p,e);if(!m){return p.length;}if(m.eflags!==void 0){if(h.endTag){h.endTag(m.name,i,Y,$(h,p,e,s,i));}}return m.next;}function d1(p,e,h,i,Y,s){var m=g1(p,e);if(!m){return p.length;}if(m.eflags!==void 0){if(h.startTag){h.startTag(m.name,m.attrs,i,Y,$(h,p,m.next,s,i));}if(m.eflags&W){return f1(p,m,h,i,Y,s);}}return m.next;}var e1={};function f1(e,i,h,m,Y,s){var n=e.length;if(!e1.hasOwnProperty(i.name)){e1[i.name]=new RegExp('^'+i.name+'(?:[\\s\\/]|$)','i');}var q=e1[i.name];var v=i.next;var p=i.next+1;for(;p<n;p++){if(e[p-1]==='<\/'&&q.test(e[p])){break;}}if(p<n){p-=1;}var _=e.slice(v,p).join('');if(i.eflags&B.eflags.CDATA){if(h.cdata){h.cdata(_,m,Y,$(h,e,p,s,m));}}else if(i.eflags&B.eflags.RCDATA){if(h.rcdata){h.rcdata(S(_),m,Y,$(h,e,p,s,m));}}else{throw new Error('bug');}return p;}function g1(e,h){var m=/^(\w+)/.exec(e[h]);var i={name:c(m[1])};if(B.ELEMENTS.hasOwnProperty(i.name)){i.eflags=B.ELEMENTS[i.name];}else{i.eflags=void 0;}var n=e[h].substr(m[0].length);var p=h+1;var q=e.length;for(;p<q;p++){if(e[p]==='>'){break;}n+=e[p];}if(q<=p){return void 0;}var s=[];while(n!==''){m=T.exec(n);if(!m){n=n.replace(/^[\s\S][^a-z\s]*/,'');}else if((m[4]&&!m[5])||(m[6]&&!m[7])){var v=m[4]||m[6];var _=false;var q1=[n,e[p++]];for(;p<q;p++){if(_){if(e[p]==='>'){break;}}else if(0<=e[p].indexOf(v)){_=true;}q1.push(e[p]);}if(q<=p){break;}n=q1.join('');continue;}else{var r1=c(m[1]);var s1=m[2]?h1(m[3]):r1;s.push(r1,s1);n=n.substr(m[0].length);}}i.attrs=s;i.next=p+1;return i;}function h1(v){var q=v.charCodeAt(0);if(q===0x22||q===0x27){v=v.substr(1,v.length-2);}return L(J(v));}function i1(e){var s;var h;var m=function(i,n){if(!h){n.push(i);}};return X({startDoc:function(_){s=[];h=false;},startTag:function(p,q,v){if(h){return;}if(!B.ELEMENTS.hasOwnProperty(p)){return;}var _=B.ELEMENTS[p];if(_&B.eflags.FOLDABLE){return;}q=e(p,q);if(!q){h=!(_&B.eflags.EMPTY);return;}if(!(_&B.eflags.EMPTY)){s.push(p);}v.push('<',p);for(var i=0,n=q.length;i<n;i+=2){var q1=q[i],r1=q[i+1];if(r1!==null&&r1!==void 0){v.push(' ',q1,'="',R(r1),'"');}}v.push('>');},endTag:function(n,p){if(h){h=false;return;}if(!B.ELEMENTS.hasOwnProperty(n)){return;}var q=B.ELEMENTS[n];if(!(q&(B.eflags.EMPTY|B.eflags.FOLDABLE))){var v;if(q&B.eflags.OPTIONAL_ENDTAG){for(v=s.length;--v>=0;){var _=s[v];if(_===n){break;}if(!(B.ELEMENTS[_]&B.eflags.OPTIONAL_ENDTAG)){return;}}}else{for(v=s.length;--v>=0;){if(s[v]===n){break;}}}if(v<0){return;}for(var i=s.length;--i>v;){var _=s[i];if(!(B.ELEMENTS[_]&B.eflags.OPTIONAL_ENDTAG)){p.push('<\/',_,'>');}}s.length=v;p.push('<\/',n,'>');}},pcdata:m,rcdata:m,cdata:m,endDoc:function(i){for(;s.length;s.length--){i.push('<\/',s[s.length-1],'>');}}});}var j1=new RegExp('^'+'(?:'+'([^:\/?# ]+)'+':)?');var k1=/^(?:https?|mailto)$/i;function l1(e,n){if(!n){return null;}var p=(''+e).match(j1);if(p&&(!p[1]||k1.test(p[1]))){return n(e);}else{return null;}}function m1(e,h,m,n){for(var i=0;i<h.length;i+=2){var p=h[i];var v=h[i+1];var q=null,s;if((s=e+'::'+p,B.ATTRIBS.hasOwnProperty(s))||(s='*::'+p,B.ATTRIBS.hasOwnProperty(s))){q=B.ATTRIBS[s];}if(q!==null){switch(q){case B.atype.NONE:break;case B.atype.SCRIPT:v=null;break;case B.atype.STYLE:if('undefined'===typeof A){v=null;break;}var _=[];A(v,{declaration:function(q1,r1){var s1=q1.toLowerCase();var t1=r[s1];if(!t1){return;}w(s1,t1,r1,m);_.push(q1+': '+r1.join(' '));}});v=_.length>0?_.join(' ; '):null;break;case B.atype.ID:case B.atype.IDREF:case B.atype.IDREFS:case B.atype.GLOBAL_NAME:case B.atype.LOCAL_NAME:case B.atype.CLASSES:v=n?n(v):v;break;case B.atype.URI:v=l1(v,m);break;case B.atype.URI_FRAGMENT:if(v&&'#'===v.charAt(0)){v=v.substring(1);v=n?n(v):v;if(v!==null&&v!==void 0){v='#'+v;}}else{v=null;}break;default:v=null;break;}}else{v=null;}h[i+1]=v;}return h;}function n1(e,h){return function(i,m){if(!(B.ELEMENTS[i]&B.eflags.UNSAFE)){return m1(i,m,e,h);}};}function o1(i,e){var h=[];i1(e)(i,h);return h.join('');}function p1(i,e,h){var m=n1(e,h);return o1(i,m);}return{escapeAttrib:R,makeHtmlSanitizer:i1,makeSaxParser:X,makeTagPolicy:n1,normalizeRCData:S,sanitize:p1,sanitizeAttribs:m1,sanitizeWithPolicy:o1,unescapeEntities:L};})(B);var E=D.sanitize;if(typeof window!=='undefined'){window['html']=D;window['html_sanitize']=E;}}());
}
},"sap/ui/core/library-preload"
);
//# sourceMappingURL=library-preload.js.map