//@ui5-bundle sap/ui/layout/library-preload.js
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/layout/AlignedFlowLayout',["sap/ui/core/Core","sap/ui/core/Control","./library","sap/ui/core/ResizeHandler","./AlignedFlowLayoutRenderer","sap/ui/dom/units/Rem"],function(C,a,l,R,A,b){"use strict";
var c=a.extend("sap.ui.layout.AlignedFlowLayout",{metadata:{library:"sap.ui.layout",properties:{minItemWidth:{type:"sap.ui.core.AbsoluteCSSSize",defaultValue:"12rem"},maxItemWidth:{type:"sap.ui.core.AbsoluteCSSSize",defaultValue:"24rem"}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true},endContent:{type:"sap.ui.core.Control",multiple:true}}}});
c.prototype.init=function(){if(typeof ResizeObserver==="function"){this.oResizeObserver=new ResizeObserver(this.onResize.bind(this));this.fLayoutWidth=0;this.fEndItemWidth=0;}else{this._sResizeHandlerContainerListenerID=R.register(this,this.onResizeHandler.bind(this));}this.fnReflow=this.reflow.bind(this);this.bReflowSuspended=false;};
c.prototype.exit=function(){this.fnReflow=null;this.disconnectResizeObserver();this.oResizeObserver=null;this.fLayoutWidth=undefined;this.fEndItemWidth=undefined;this.disconnectResizeHandler();this._sResizeHandlerContainerListenerID="";this._sResizeHandlerEndItemListenerID="";};
c.prototype.onAfterRenderingOrThemeChanged=function(){window.requestAnimationFrame(function(){var d=this.getDomRef(),e=this.getDomRef("endItem"),E=!!(this.hasContent()&&d&&e);if(E){var L=window.getComputedStyle(d,null),i=L.getPropertyValue("padding-top"),m=e.style;if(C.getConfiguration().getRTL()){m.left=L.getPropertyValue("padding-left");}else{m.right=L.getPropertyValue("padding-right");}m.bottom=i;}var D={domRef:d,endItemDomRef:e};this.reflow(D);}.bind(this));};
c.prototype.onBeforeRendering=function(){this.disconnectResizeObserver();this.disconnectResizeHandlerForEndItem();};
c.prototype.onAfterRendering=function(){this.observeSizeChangesIfRequired();this.onAfterRenderingOrThemeChanged();};
c.prototype.onThemeChanged=c.prototype.onAfterRenderingOrThemeChanged;
c.prototype.onResizeHandler=function(e){if(e.size.width!==e.oldSize.width){this.reflow();}};
c.prototype.onResize=function(o){var d=this.getDomRef();this.bReflowSuspended=this.bReflowSuspended||this.unobserveSizeChangesIfReflowSuspended(d);if(this.bReflowSuspended){return;}var e,O=o[0],w=h(this.fLayoutWidth,O,d),n=O.contentRect.width,N=O.contentRect.height;if(w){this.fLayoutWidth=n;this.fLayoutHeight=N;}else{e=this.getDomRef("endItem");w=h(this.fEndItemWidth,O,e);if(w){this.fEndItemWidth=n;this.fLayoutHeight=N;}else if(this.fLayoutHeight!==N){this.fLayoutHeight=N;}else{return;}}window.requestAnimationFrame(function(){var D={domRef:d,endItemDomRef:e};this.reflow(D);}.bind(this));};
c.prototype.reflow=function(d){if(this.bReflowSuspended){this.bReflowSuspended=false;if(this.oResizeObserver){this.observeSizeChangesIfRequired();}}var e=this.getContent();if((e.length===0)||!e[0].isActive()){return;}d=d||{};var D=d.domRef||this.getDomRef();if(!D){return;}var E=d.endItemDomRef||this.getDomRef("endItem"),L=this.getLastItemDomRef();if(!E||!L){if(!D.offsetParent){return;}this.toggleDisplayOfSpacers(D);return;}var o=D.lastElementChild;r(D,o);if(!D.offsetParent){return;}var m=o.style,i=E.offsetHeight,f=E.offsetWidth,g=L.offsetTop,j=L.offsetLeft,k,n;if(C.getConfiguration().getRTL()){n=j;}else{var p=Number.parseFloat(window.getComputedStyle(L).marginRight);var q=j+L.offsetWidth+p;n=D.offsetWidth-q;}var s=Number.parseFloat(window.getComputedStyle(E).marginRight);var t=n>=(f+s);if(t){if(this.checkItemsWrapping(D)){if(E.offsetTop<g){m.height=Math.max(0,i-g)+"px";if(L.offsetTop>=E.offsetTop){k=E.offsetLeft;j=L.offsetLeft;if((k>=j)&&(k<=(j+L.offsetWidth))){m.height=i+"px";}}m.display="block";}else{m.height="0";m.display="";}}else{if(E.offsetTop<g){m.height=i+"px";}m.display="block";}}else{m.height=i+"px";m.display="block";}var u=f+"px";m.width=u;m.minWidth=u;this.toggleDisplayOfSpacers(D);};
c.prototype.toggleDisplayOfSpacers=function(d){var e=this.getRenderer().CSS_CLASS+"OneLine",E=true;if(this.checkItemsWrapping(d,E)){d.classList.remove(e);}else{d.classList.add(e);}};
function h(o,O,t){var W=0.25,n=O.contentRect.width;return(t===O.target)&&(Math.abs(n-o)>=W);}
function r(d,L){var m=L&&L.style;if(m){m.width="";m.height="";m.display="";}d.classList.remove(d.classList.item(0)+"OneLine");}
c.prototype.checkItemsWrapping=function(d,e){d=d||this.getDomRef();if(!d){return false;}var f=d.firstElementChild,L=this.getLastItemDomRef();if(!f||!L){return false;}var F=f.offsetTop,i=L.offsetTop,g=f.offsetHeight;if(i>=(F+g)){return true;}if(e){return false;}var E=this.getDomRef("endItem");return!!E&&(E.offsetTop>=(F+g));};
c.prototype.getLastItemDomRef=function(){var d=this.getContent(),i=d.length;if(i){var o=d[i-1],e=o.getDomRef();if(e){return e.parentElement;}}return null;};
c.prototype.getLastVisibleDomRef=function(){return this.getDomRef("endItem")||this.getLastItemDomRef();};
c.prototype.computeNumberOfSpacers=function(){var i=this.getContent().length;if(i===0){return 0;}var s=i,m=this.getMinItemWidth(),M;if(m.lastIndexOf("rem")!==-1){M=b.toPx(m);}else if(m.lastIndexOf("px")!==-1){M=parseFloat(m);}if(M){var d=Math.max(document.documentElement.clientWidth,window.screen.width);s=Math.abs(d/M);}s=Math.min(s,i-1);s=Math.max(1,s);s=Math.floor(s);return s;};
c.prototype.observeSizeChangesIfRequired=function(){if(this.hasContent()){this.observeSizeChanges();}};
c.prototype.observeSizeChanges=function(){var d=this.getDomRef();if(!d){return;}var e=this.getDomRef("endItem");if(this.oResizeObserver){this.oResizeObserver.observe(d);if(e){this.oResizeObserver.observe(e);}return;}if(e){this._sResizeHandlerEndItemListenerID=R.register(e,this.onResizeHandler.bind(this));}};
c.prototype.unobserveSizeChanges=function(d){if(this.oResizeObserver&&d){this.oResizeObserver.unobserve(d);}};
c.prototype.unobserveSizeChangesIfReflowSuspended=function(d){var e=R.isSuspended(d,this.fnReflow);if(e){this.unobserveSizeChanges(d);this.unobserveSizeChanges(this.getDomRef("endItem"));return true;}return false;};
c.prototype.disconnectResizeObserver=function(){if(this.oResizeObserver){this.oResizeObserver.disconnect();}};
c.prototype.disconnectResizeHandler=function(){if(this._sResizeHandlerContainerListenerID){R.deregister(this._sResizeHandlerContainerListenerID);}this.disconnectResizeHandlerForEndItem();};
c.prototype.disconnectResizeHandlerForEndItem=function(){if(this._sResizeHandlerEndItemListenerID){R.deregister(this._sResizeHandlerEndItemListenerID);}};
c.prototype.hasContent=function(){return this.getContent().length>0;};
return c;});
sap.ui.predefine('sap/ui/layout/AlignedFlowLayoutRenderer',['./library'],function(l){"use strict";var A={apiVersion:2};A.CSS_CLASS="sapUiAFLayout";
A.render=function(r,c){var C=c.getContent();r.openStart("div",c);r.class(A.CSS_CLASS);if(C.length===0){r.class(A.CSS_CLASS+"NoContent");}r.openEnd();this.renderItems(r,c,C);this.renderEndItem(r,c);this.renderSpacers(r,c);r.close("div");};
A.renderItems=function(r,c,C){C=C||c.getContent();C.forEach(function(o){this.renderItem(r,c,o);},this);};
A.renderItem=function(r,c,C){r.openStart("div");r.class(A.CSS_CLASS+"Item");r.style("flex-basis",c.getMinItemWidth());r.style("max-width",c.getMaxItemWidth());r.openEnd();r.renderControl(C);r.close("div");};
A.renderEndItem=function(r,c,e){e=e||c.getEndContent();if(e.length){r.openStart("div",c.getId()+"-endItem");r.class(A.CSS_CLASS+"End");if(c.getContent().length){r.style("flex-basis",c.getMinItemWidth());}r.openEnd();e.forEach(function(E){this.renderEndContent(r,c,E);},this);r.close("div");}};
A.renderEndContent=function(r,c,C){r.renderControl(C);};
A.renderSpacers=function(r,c){var s=c.computeNumberOfSpacers(),m=c.getMinItemWidth(),M=c.getMaxItemWidth(),C=A.CSS_CLASS,I=c.getId(),S=I+"-spacer",L=I+"-spacerlast";for(var i=0;i<s;i++){var b=i===(s-1),a=b?L:S+i;r.openStart("div",a);r.class(C+"Item");r.class(C+"Spacer");r.style("flex-basis",m);r.style("max-width",M);r.openEnd();r.close("div");}};
return A;},true);
sap.ui.predefine('sap/ui/layout/AssociativeSplitter',['./Splitter','./SplitterRenderer',"sap/base/Log","sap/ui/layout/SplitterLayoutData"],function(S,a,L,b){"use strict";
var A=S.extend("sap.ui.layout.AssociativeSplitter",{
metadata:{associations:{associatedContentAreas:{type:"sap.ui.core.Control",multiple:true,singularName:"associatedContentArea"}}},
renderer:a
});
A.prototype.init=function(){S.prototype.init.call(this);this._keyListeners={increase:this._onKeyboardResize.bind(this,"inc",1),decrease:this._onKeyboardResize.bind(this,"dec",1),increaseMore:this._onKeyboardResize.bind(this,"incMore",2),decreaseMore:this._onKeyboardResize.bind(this,"decMore",2),max:this._onKeyboardResize.bind(this,"max",1),min:this._onKeyboardResize.bind(this,"min",1)};this._enableKeyboardListeners();};
A.prototype.addAssociatedContentArea=function(c){this._ensureLayoutData(c);return this.addAssociation("associatedContentAreas",c);};
A.prototype._enableKeyboardListeners=function(){S.prototype._enableKeyboardListeners.call(this);this.onsaprightmodifiers=this._keyListeners.increase;this.onsapleftmodifiers=this._keyListeners.decrease;this.onsapupmodifiers=this._keyListeners.decrease;this.onsapdownmodifiers=this._keyListeners.increase;this.onsapright=this._keyListeners.increaseMore;this.onsapdown=this._keyListeners.increaseMore;this.onsapleft=this._keyListeners.decreaseMore;this.onsapup=this._keyListeners.decreaseMore;this.onsapend=this._keyListeners.max;this.onsaphome=this._keyListeners.min;this._keyboardEnabled=true;};
A.prototype._getContentAreas=function(){var c=this.getAssociatedContentAreas()||[];var C=this.getContentAreas();var v=c.map(function(i){return sap.ui.getCore().byId(i);}).filter(function(o){return o;});return C.concat(v);};
A.prototype.ondblclick=function(e){var i=this.getId(),B,c;if(!(e.target.contains(this._oLastDOMclicked)&&(this._oLastDOMclicked.id.indexOf(i+"-splitbar")>-1))){return;}B=parseInt(this._oLastDOMclicked.id.substr((i+"-splitbar-").length));c=this._getContentAreas()[B];c._currentPosition=this.getCalculatedSizes()[B];c._lastPosition=c._lastPosition||c._currentPosition;if(c._currentPosition===c._lastPosition){this._resizeContents(B,(this.getCalculatedSizes()[B])*-1,true);}else{this._resizeContents(B,c._lastPosition,true);c._lastPosition=null;}};
A.prototype._resizeContents=function(l,p,f){var c,o,d,s,e,C,$,n,N,m,M,F,g,D,h=parseFloat(this._move.c1Size).toFixed(5),i=parseFloat(this._move.c2Size).toFixed(5),j=parseFloat(h),k=parseFloat(i);if(isNaN(p)){L.warning("Splitter: Received invalid resizing values - resize aborted.");return;}c=this._getContentAreas();o=c[l].getLayoutData();d=c[l+1].getLayoutData();s=o.getSize();e=d.getSize();C=this.$("content-"+l);$=this.$("content-"+(l+1));n=j+p;N=k-p;m=parseInt(o.getMinSize());M=parseInt(d.getMinSize());if(n<m){D=m-n;p+=D;n=m;N-=D;}else if(N<M){D=M-N;p-=D;N=M;n-=D;}if(f){var q=this._calcAvailableContentSize();if(s==="auto"&&e!=="auto"){g=this._pxToPercent(N,q);d.setSize(g);d._markModified();}else if(s!=="auto"&&e==="auto"){F=this._pxToPercent(n,q);o.setSize(F);o._markModified();}else{F=this._pxToPercent(n,q);g=this._pxToPercent(N,q);o.setSize(F);d.setSize(g);o._markModified();d._markModified();}}else{var t=this._getTotalSize();F=this._pxToPercent(n,t);g=this._pxToPercent(N,t);C.css(this._sizeType,F);$.css(this._sizeType,g);}};
A.prototype._calcPercentBasedSizes=function(p,r){var c=this._getContentAreas(),d=this._calcAvailableContentSize();if(p.length===1&&c.length===1){this._calculatedSizes[p[0]]=d;r-=d;}else{r=S.prototype._calcPercentBasedSizes.apply(this,arguments);}var m=c.filter(function(o){return o.getLayoutData().getSize()==="auto";}).reduce(function(s,o){return s+o.getLayoutData().getMinSize();},0);if(r<m){var n=Math.abs(r-m);for(var i=p.length-1;i>=0;i--){var I=p[i],o=c[I],C=this._calculatedSizes[I],l=o.getLayoutData();if(l._isMarked()){var N=C-n;if(N<l.getMinSize()){N=l.getMinSize();}this._calculatedSizes[I]=N;var e=C-N;n-=e;r+=e;}if(n<=0){break;}}}return r;};
A.prototype._pxToPercent=function(p,f){return(p*100)/f+"%";};
A.prototype._logConstraintsViolated=function(){L.warning("The set sizes and minimal sizes of the splitter contents are bigger than the available space in the UI. "+"Consider enabling the pagination mechanism by setting the 'requiredParentWidth' property of the panes",null,"sap.ui.layout.ResponsiveSplitter");};
A.prototype.containsControl=function(c){var C=this._getContentAreas(),o,i;for(i=0;i<C.length;i++){o=C[i];if(o.isA("sap.ui.layout.AssociativeSplitter")){if(o.containsControl(c)){return true;}}else{if(o.getId()===c){return true;}}}};
return A;});
sap.ui.predefine('sap/ui/layout/BlockLayout',['sap/ui/core/Control','./library','sap/ui/core/ResizeHandler',"./BlockLayoutRenderer"],function(C,l,R,B){"use strict";
var a=C.extend("sap.ui.layout.BlockLayout",{metadata:{library:"sap.ui.layout",properties:{background:{type:"sap.ui.layout.BlockBackgroundType",group:"Appearance",defaultValue:"Default"},keepFontSize:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.layout.BlockLayoutRow",multiple:true}},designtime:"sap/ui/layout/designtime/BlockLayout.designtime"}});
a.CONSTANTS={SIZES:{S:600,M:1024,L:1440,XL:null}};
a.prototype.init=function(){this._currentBreakpoint=null;};
a.prototype.onBeforeRendering=function(){this._detachResizeHandler();};
a.prototype.onAfterRendering=function(){this._onParentResize();this._notifySizeListeners();};
a.prototype._onParentResize=function(){var p,d=this.getDomRef(),w=d.clientWidth,s=a.CONSTANTS.SIZES;this._detachResizeHandler();if(w>0){this._removeBreakpointClasses();for(p in s){if(s.hasOwnProperty(p)&&(s[p]===null||s[p]>w)){if(this._currentBreakpoint!=p){this._currentBreakpoint=p;this._notifySizeListeners();}this.addStyleClass("sapUiBlockLayoutSize"+p,true);break;}}}this._attachResizeHandler();};
a.prototype._notifySizeListeners=function(){var t=this;this.getContent().forEach(function(r){r._onParentSizeChange(t._currentBreakpoint);});};
a.prototype._removeBreakpointClasses=function(){var s=a.CONSTANTS.SIZES;for(var p in s){if(s.hasOwnProperty(p)){this.removeStyleClass("sapUiBlockLayoutSize"+p,true);}}};
a.prototype._attachResizeHandler=function(){if(!this._parentResizeHandler){this._parentResizeHandler=R.register(this,this._onParentResize.bind(this));}};
a.prototype._detachResizeHandler=function(){if(this._parentResizeHandler){R.deregister(this._parentResizeHandler);this._parentResizeHandler=null;}};
a.prototype.exit=function(){this._detachResizeHandler();};
return a;});
sap.ui.predefine('sap/ui/layout/BlockLayoutCell',['sap/ui/core/Control','./library',"./BlockLayoutCellRenderer","sap/base/Log","./BlockLayoutCellData","sap/ui/thirdparty/jquery"],function(C,l,B,L,a,q){"use strict";
var b=C.extend("sap.ui.layout.BlockLayoutCell",{metadata:{library:"sap.ui.layout",properties:{title:{type:"string",group:"Appearance",defaultValue:null},titleAlignment:{type:"sap.ui.core.HorizontalAlign",group:"Appearance",defaultValue:"Begin"},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:"Auto"},width:{type:"int",group:"Appearance",defaultValue:0},backgroundColorSet:{type:"sap.ui.layout.BlockLayoutCellColorSet",group:"Appearance"},backgroundColorShade:{type:"sap.ui.layout.BlockLayoutCellColorShade",group:"Appearance"}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},titleLink:{type:"sap.ui.core.Control",multiple:false}},designtime:"sap/ui/layout/designtime/BlockLayoutCell.designtime"}});
b.prototype.setLayoutData=function(o){this.setAggregation("layoutData",o,true);var r=this.getParent();if(r){var e=q.Event("LayoutDataChange");e.srcControl=this;r._handleEvent(e);}if(o&&this.getWidth()!=0){this.getLayoutData().setSize(this.getWidth());}return this;};
b.prototype.setWidth=function(w){this.setProperty("width",w);if(this.getLayoutData()&&(this.getLayoutData().isA("sap.ui.layout.BlockLayoutCellData"))){this.getLayoutData().setSize(w);}return this;};
b.prototype.setTitleLink=function(o){if(o&&o.getMetadata().getName()!=="sap.m.Link"){L.warning("sap.ui.layout.BlockLayoutCell "+this.getId()+": Can't add value for titleLink aggregation different than sap.m.Link.");return this;}this.setAggregation("titleLink",o);return this;};
b.prototype._setParentRowScrollable=function(s){this._parentRowScrollable=s;};
b.prototype._getParentRowScrollable=function(){return this._parentRowScrollable;};
b.prototype._setFlexWidth=function(f){this._flexWidth=f;};
b.prototype._getFlexWidth=function(){return this._flexWidth;};
return b;});
sap.ui.predefine('sap/ui/layout/BlockLayoutCellData',['sap/ui/core/LayoutData','./library'],function(L,l){"use strict";
var B=L.extend("sap.ui.layout.BlockLayoutCellData",{metadata:{library:"sap.ui.layout",properties:{sSize:{type:"int",group:"Appearance",defaultValue:1},mSize:{type:"int",group:"Appearance",defaultValue:1},lSize:{type:"int",group:"Appearance",defaultValue:1},xlSize:{type:"int",group:"Appearance",defaultValue:1}}}});
B.prototype.breakRowOnSSize=true;B.prototype.breakRowOnMSize=false;B.prototype.breakRowOnLSize=false;B.prototype.breakRowOnXlSize=false;
B.prototype.setSize=function(v){this.setProperty("mSize",v);this.setProperty("lSize",v);this.setProperty("xlSize",v);var r=this.getParent();if(r&&r.getParent()){r.getParent().invalidate();}return this;};
return B;});
sap.ui.predefine('sap/ui/layout/BlockLayoutCellRenderer',['./library','sap/ui/core/library',"sap/base/Log"],function(l,c,L){"use strict";var T=c.TitleLevel;var B={apiVersion:2};
B.render=function(r,b){this.startCell(r,b);this.addContent(r,b);this.endCell(r);};
B.startCell=function(r,b){var C=this.getCellColor(r,b);r.openStart("div",b).class("sapUiBlockLayoutCell");C&&r.class(C);this.setWidth(r,b);r.openEnd();};
B.getCellColor=function(r,b){var C=b.getBackgroundColorSet(),s=b.getBackgroundColorShade();if(!C&&!s){return"";}else if((C&&!s)||(!C&&s)){L.warning("Both, backgroundColorSet and backgroundColorShade should be defined. ColoSet is not applied to "+b.getId()+".");return"";}C=C.replace("ColorSet","");s=s.replace("Shade","");return"sapUiBlockLayoutCellColor"+C+s;};
B.setWidth=function(r,b){var w=b.getWidth();if(b._getParentRowScrollable()){if(w!==0){r.style("width",w+"%");}}else{this.addFlex(r,b._getFlexWidth());}};
B.addFlex=function(r,f){r.style("-webkit-flex",f);r.style("-ms-flex",f);r.style("flex",f);};
B.addTitle=function(r,b){var t=b.getTitleLink();var s=b.getTitle();if(s||t){var a="sapUiBlockCell"+b.getTitleAlignment(),d="sapUiBlockCellTitle "+a;if(b.getContent().length===0){d+=" sapUiBlockCellTitleNoContent";}var e=b.getTitleLevel(),f=e===T.Auto,g=f?"h2":e;var h=d.split(" ");r.openStart(g,this.getTitleId(b));for(var i=0;i<h.length;i++){r.class(h[i]);}r.openEnd();if(t){r.renderControl(t);}else{r.text(s);}r.close(g);}};
B.getTitleId=function(b){return b.getId()+"-Title";};
B.hasTitle=function(b){return b.getTitleLink()||b.getTitle();};
B.addContent=function(r,b){var a=b.getContent(),h=this.hasTitle(b);r.openStart("div").class("sapUiBlockCellContent");if(b.getTitleAlignment()==="Center"){r.class("sapUiBlockCellCenteredContent");}if(h){r.attr("aria-labelledby",this.getTitleId(b));}r.openEnd();if(h){this.addTitle(r,b);}a.forEach(r.renderControl,r);r.close("div");};
B.endCell=function(r){r.close("div");};
return B;},true);
sap.ui.predefine('sap/ui/layout/BlockLayoutRenderer',['./library'],function(l){"use strict";var B=l.BlockRowColorSets;var a={apiVersion:2};
a.render=function(r,b){this.startLayout(r,b);this.addContent(r,b);this.endLayout(r);};
a.startLayout=function(r,b){r.openStart("div",b).class("sapUiBlockLayout").class("sapUiBlockLayoutBackground"+b.getBackground());if(b.getKeepFontSize()){r.class("sapUiBlockLayoutKeepFontSize");}r.openEnd();};
a.addContent=function(r,b){var c=b.getContent(),t=Object.keys(B).map(function(k){return B[k];}),n=t.length;c.forEach(function(o,i,R){var T=o.getRowColorSet()||t[i%n],C="sapUiBlockLayoutBackground"+T,p=(i&&R[i-1])||null;if(p&&p.hasStyleClass(C)){o.removeStyleClass(C);C+="Inverted";}if(C){o.addStyleClass(C);}r.renderControl(o);});};
a.endLayout=function(r){r.close("div");};
return a;},true);
sap.ui.predefine('sap/ui/layout/BlockLayoutRow',['sap/ui/core/Control','./library','sap/ui/layout/BlockLayoutCellData',"./BlockLayoutRowRenderer","sap/base/Log"],function(C,l,B,a,L){"use strict";var b=l.BlockBackgroundType;var c=l.BlockRowColorSets;
var d=C.extend("sap.ui.layout.BlockLayoutRow",{metadata:{library:"sap.ui.layout",properties:{scrollable:{type:"boolean",group:"Appearance",defaultValue:false},rowColorSet:{type:"sap.ui.layout.BlockRowColorSets",group:"Appearance"}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.layout.BlockLayoutCell",multiple:true,singularName:"content"}},associations:{accentCells:{type:"sap.ui.layout.BlockLayoutCell",multiple:true,singularName:"accentCell"}},designtime:"sap/ui/layout/designtime/BlockLayoutRow.designtime"}});
d.prototype.init=function(){this._applyLayoutData={};};
d.prototype.addContent=function(o){this._ensureLayoutData(o);return this.addAggregation("content",o);};
d.prototype.insertContent=function(o,i){this._ensureLayoutData(o);return this.insertAggregation("content",o,i);};
d.prototype.onBeforeRendering=function(){var e=this.getContent(),t=this;e.forEach(function(o,i){t._ensureLayoutData(o);o._setParentRowScrollable(t.getScrollable());});this._calculateBreakpointRendering();};
d.prototype.setRowColorSet=function(t){var A=Array.prototype.slice.call(arguments),o=C.prototype.setProperty.apply(this,["rowColorSet"].concat(A)),s="sapUiBlockLayoutBackground"+t,e=this.getParent(),f=e&&e.getBackground(),T=e&&e.indexOfAggregation("content",this),p=e&&e.getContent(),P=(T&&p[T-1])||null,n=(p&&p[T+1])||null,g=Object.keys(c).map(function(k){return c[k];}),i=false;if(P&&P._hasStyleClass(s,f,i,t)){s+="Inverted";i=true;}g.forEach(function(h){var j="sapUiBlockLayoutBackground"+h,I=j+"Inverted";if(this._hasStyleClass(j,f,false,h)){this.removeStyleClass(j,true);}else if(this._hasStyleClass(I,f,true,h)){this.removeStyleClass(I,true);}},this);this.addStyleClass(s,true);if(n&&n._hasStyleClass(s,f,i,t)){n.setRowColorSet(t);}this.invalidate();return o;};
d.prototype.addAccentCell=function(i){var o,I=i&&i.getId?i.getId():i,e=this.getParent(),s=e&&(e.getBackground()||"");o=this.addAssociation("accentCells",i);if(!e){return this;}if([b.Accent,b.Mixed].indexOf(s)===-1){L.warning(I+" was not set as accent cell. Accent cells could be set only for 'Accent' and 'Mixed' layout backgrounds.");return this;}return o;};
d.prototype._ensureLayoutData=function(o){var O=o.getLayoutData();if(!O||!(O instanceof B)){o.setLayoutData(new B());}};
d.prototype._onParentSizeChange=function(e){this._currentSize=e;this._calculateBreakpointRendering();this.invalidate();};
d.prototype._getCellArangementForCurrentSize=function(){if(!this._arrangements||!this._currentSize){return null;}return this._arrangements[this._currentSize];};
d.prototype._calculateBreakpointRendering=function(){if(!this._currentSize){return;}this._arrangements={"S":this._calcArrangementForSize("S"),"M":this._calcArrangementForSize("M"),"L":this._calcArrangementForSize("L"),"XL":this._calcArrangementForSize("Xl")};};
d.prototype._calcArrangementForSize=function(s){var e=this.getContent();if(e.length>=3&&s==="M"&&e.length<5){return this._generateArrangementForMCase();}else{return this._generateArrangement(s);}};
d.prototype._generateArrangement=function(s){var o,I=0,f=[],e=[],A=[[]],g=this.getContent();g.forEach(function(h){o=h.getLayoutData();e.push(o["breakRowOn"+s+"Size"]);f.push(o["get"+s+"Size"]());});f.forEach(function(D,i){A[I].push(D);if(e[i+1]){I++;A[I]=[];}});return A;};
d.prototype._generateArrangementForMCase=function(){var e=this.getContent();if(e.length===3&&this._isAllCellsHasSameWidth("M")){return[[1,1,1]];}else if(e.length===3){return[[1,1],[1]];}else if(e.length===4){return[[1,1],[1,1]];}};
d.prototype._isAllCellsHasSameWidth=function(s){var e,f=this.getContent(),F=f[0].getLayoutData()["get"+s+"Size"]();for(var i=1;i<f.length;i++){e=f[i].getLayoutData()["get"+s+"Size"]();if(e!==F){return false;}}return true;};
d.prototype._processMixedCellStyles=function(i,e){var o,p;if(!e||!e.length){return this;}o=this.getParent();p=o&&(o.hasStyleClass("sapUiBlockLayoutSizeL")||o.hasStyleClass("sapUiBlockLayoutSizeXL"));e.forEach(function(f){var g,u;if(p&&f.getId()===i&&f.getWidth()===1){f.addStyleClass("sapContrast").addStyleClass("sapContrastPlus");g=c;u=this._hasStyleClass("sapUiBlockLayoutBackground"+g.ColorSet1,b.Mixed,false,g.ColorSet1)||this._hasStyleClass("sapUiBlockLayoutBackground"+g.ColorSet1,b.Mixed,true,g.ColorSet1);if(u){f.addStyleClass("sapUiBlockLayoutBackgroundContrast2");}}else if((!p||f.getId()!==i)&&(f.hasStyleClass("sapContrast")||f.hasStyleClass("sapContrastPlus"))){f.removeStyleClass("sapContrast").removeStyleClass("sapContrastPlus").removeStyleClass("sapUiBlockLayoutBackgroundContrast2");this.removeAssociation("accentCells",f);L.warning(i+" was removed as accent cell. Only one cell at a time could be accented for Mixed layout background");}},this);return this;};
d.prototype._processAccentCellStyles=function(A,r){var o,s,e,i=0,I=0,f=Array.prototype.slice.call(A);if(!A||!A.length){return this;}for(i=0;i<r.length;i++){o=r[i];s=o.getId();if(!f.length){break;}if(f.indexOf(s)>-1){I++;e="sapUiBlockLayoutBackgroundColorSetGray"+((I%2)+1);if(o.hasStyleClass(e)){continue;}f.splice(f.indexOf(s),1);o.removeStyleClass("sapUiBlockLayoutBackgroundColorSetGray1").removeStyleClass("sapUiBlockLayoutBackgroundColorSetGray2").addStyleClass(e);}}return this;};
d.prototype._hasStyleClass=function(s,e,I,t){var o=b,f=c,i,S,E;if([o.Light,o.Mixed].indexOf(e)===-1){return this.hasStyleClass(s);}else if(this.hasStyleClass(s)){return true;}E=[[f.ColorSet1,f.ColorSet3],[f.ColorSet2,f.ColorSet4]];for(i=0;i<=E.length;i++){if(E[i]&&E[i].indexOf(t)>-1){break;}}if(!E[i]){return false;}S=E[i].map(function(g){return"sapUiBlockLayoutBackground"+g+(I?"Inverted":"");});return S.some(this.hasStyleClass,this);};
return d;});
sap.ui.predefine('sap/ui/layout/BlockLayoutRowRenderer',['./library'],function(l){"use strict";var B=l.BlockBackgroundType;var a={apiVersion:2};
a.render=function(r,b){this.startRow(r,b);this.renderContent(r,b);this.endRow(r,b);};
a.startRow=function(r,b){r.openStart("div",b).class("sapUiBlockLayoutRow");this.addRowRenderingClass(r,b);r.openEnd();};
a.addRowRenderingClass=function(r,b){if(b.getScrollable()){r.class("sapUiBlockScrollingRow");if(b.getContent().length>=6){r.class("sapUiBlockScrollingNarrowCells");}}else{r.class("sapUiBlockHorizontalCellsRow");}};
a.renderContent=function(r,b){var c=b.getContent(),s=b.getScrollable(),L=b.getParent().getBackground(),A=b.getAccentCells(),C=0,f;c.forEach(function(o,e){(e%2)==0?o.addStyleClass("sapUiBlockLayoutOddCell"):o.addStyleClass("sapUiBlockLayoutEvenCell");if(s){o.addStyleClass("sapUiBlockScrollableCell");}else{o.addStyleClass("sapUiBlockHorizontalCell");}});switch(L){case B.Mixed:if(A.length>0){b._processMixedCellStyles(A[A.length-1],c);}break;case B.Accent:b._processAccentCellStyles(A,c);break;}var d=b._getCellArangementForCurrentSize();if(s){c.forEach(r.renderControl,r);}else if(d){for(var i=0;i<d.length;i++){var S=d[i];r.openStart("div");r.style("display","flex");r.openEnd();for(var j=0;j<S.length;j++){f=S[j];c[C]._setFlexWidth(f);r.renderControl(c[C]);C++;}r.close("div");}}};
a.endRow=function(r){r.close("div");};
return a;},true);
sap.ui.predefine('sap/ui/layout/DynamicSideContent',['sap/ui/thirdparty/jquery','sap/ui/core/Control','sap/ui/core/ResizeHandler','sap/ui/core/delegate/ScrollEnablement','sap/ui/layout/library','./DynamicSideContentRenderer'],function(q,C,R,a,l,D){"use strict";var b=l.SideContentPosition;var c=l.SideContentFallDown;var d=l.SideContentVisibility;
var e=C.extend("sap.ui.layout.DynamicSideContent",{metadata:{library:"sap.ui.layout",properties:{showSideContent:{type:"boolean",group:"Appearance",defaultValue:true},showMainContent:{type:"boolean",group:"Appearance",defaultValue:true},sideContentVisibility:{type:"sap.ui.layout.SideContentVisibility",group:"Appearance",defaultValue:d.ShowAboveS},sideContentFallDown:{type:"sap.ui.layout.SideContentFallDown",group:"Appearance",defaultValue:c.OnMinimumWidth},equalSplit:{type:"boolean",group:"Appearance",defaultValue:false},containerQuery:{type:"boolean",group:"Behavior",defaultValue:false},sideContentPosition:{type:"sap.ui.layout.SideContentPosition",group:"Appearance",defaultValue:b.End},mcSpan:{type:"int",defaultValue:0,visibility:"hidden"},scSpan:{type:"int",defaultValue:0,visibility:"hidden"}},defaultAggregation:"mainContent",events:{breakpointChanged:{parameters:{currentBreakpoint:{type:"string"}}}},aggregations:{mainContent:{type:"sap.ui.core.Control",multiple:true},sideContent:{type:"sap.ui.core.Control",multiple:true}},designTime:"sap/ui/layout/designtime/DynamicSideContent.designtime",dnd:{draggable:false,droppable:true}}});
var S="S",M="M",L="L",X="XL",H="sapUiHidden",f="sapUiDSCSpan12",g="sapUiDSCMCFixed",h="sapUiDSCSCFixed",i=3,j=4,k=6,m=8,n=9,o=12,I="Invalid Breakpoint. Expected: S, M, L or XL",p="SCGridCell",r="MCGridCell",s=720,t=1024,u=1440;
e.prototype.setSideContentVisibility=function(v,w){this.setProperty("sideContentVisibility",v,true);if(!w&&this.$().length){this._setResizeData(this.getCurrentBreakpoint());this._changeGridState();}return this;};
e.prototype.setShowSideContent=function(v,w){if(v===this.getShowSideContent()){return this;}this.setProperty("showSideContent",v,true);this._SCVisible=v;if(!w&&this.$().length){this._setResizeData(this.getCurrentBreakpoint(),this.getEqualSplit());if(this._currentBreakpoint===S){this._MCVisible=true;}this._changeGridState();}return this;};
e.prototype.setShowMainContent=function(v,w){if(v===this.getShowMainContent()){return this;}this.setProperty("showMainContent",v,true);this._MCVisible=v;if(!w&&this.$().length){this._setResizeData(this.getCurrentBreakpoint(),this.getEqualSplit());if(this._currentBreakpoint===S){this._SCVisible=true;}this._changeGridState();}return this;};
e.prototype.isSideContentVisible=function(){if(this._currentBreakpoint===S){return this._SCVisible&&this.getProperty("showSideContent");}else{return this.getProperty("showSideContent");}};
e.prototype.isMainContentVisible=function(){if(this._currentBreakpoint===S){return this._MCVisible&&this.getProperty("showMainContent");}else{return this.getProperty("showMainContent");}};
e.prototype.setEqualSplit=function(v){this._MCVisible=true;this._SCVisible=true;this.setProperty("equalSplit",v,true);if(this._currentBreakpoint){this._setResizeData(this._currentBreakpoint,v);this._changeGridState();}return this;};
e.prototype.addSideContent=function(v){this.addAggregation("sideContent",v,true);this._rerenderControl(this.getAggregation("sideContent"),this.$(p));return this;};
e.prototype.addMainContent=function(v){this.addAggregation("mainContent",v,true);this._rerenderControl(this.getAggregation("mainContent"),this.$(r));return this;};
e.prototype.toggle=function(){if(this._currentBreakpoint===S){if(!this.getProperty("showMainContent")){this.setShowMainContent(true,true);this._MCVisible=false;}if(!this.getProperty("showSideContent")){this.setShowSideContent(true,true);this._SCVisible=false;}if(this._MCVisible&&!this._SCVisible){this._SCVisible=true;this._MCVisible=false;}else if(!this._MCVisible&&this._SCVisible){this._MCVisible=true;this._SCVisible=false;}this._changeGridState();}return this;};
e.prototype.getCurrentBreakpoint=function(){return this._currentBreakpoint;};
e.prototype.onBeforeRendering=function(){this._bSuppressInitialFireBreakPointChange=true;this._detachContainerResizeListener();this._SCVisible=(this._SCVisible===undefined)?this.getProperty("showSideContent"):this._SCVisible;this._MCVisible=(this._MCVisible===undefined)?this.getProperty("showMainContent"):this._MCVisible;if(!this.getContainerQuery()){this._iWindowWidth=q(window).width();this._setBreakpointFromWidth(this._iWindowWidth);this._setResizeData(this._currentBreakpoint,this.getEqualSplit());}};
e.prototype.onAfterRendering=function(){if(this.getContainerQuery()){this._attachContainerResizeListener();this._adjustToScreenSize();}else{var v=this;q(window).on("resize",function(){v._adjustToScreenSize();});}this._changeGridState();this._initScrolling();};
e.prototype.onThemeChanged=function(){if(this.getContainerQuery()){this._adjustToScreenSize();}};
e.prototype.exit=function(){this._detachContainerResizeListener();if(this._oSCScroller){this._oSCScroller.destroy();this._oSCScroller=null;}if(this._oMCScroller){this._oMCScroller.destroy();this._oMCScroller=null;}};
e.prototype.getScrollDelegate=function(v){var w=v,x=this.getParent(),B=this._getBreakPointFromWidth(),y=this.getShowMainContent()&&this._MCVisible,z=this.getShowSideContent()&&this._SCVisible;if(B&&B!==L&&B!==X){if(w&&((w.sParentAggregationName==="sideContent"&&!z)||(w.sParentAggregationName==="mainContent"&&!y))){return;}else{while(x&&(!x.getScrollDelegate||!x.getScrollDelegate())){x=x.getParent();}return x.getScrollDelegate();}}if(this._oMCScroller&&this._oSCScroller){while(w&&w.getId()!==this.getId()){if(w.sParentAggregationName==="mainContent"&&y){return this._oMCScroller;}if(w.sParentAggregationName==="sideContent"&&z){return this._oSCScroller;}w=w.getParent();}}return;};
e.prototype._rerenderControl=function(v,$){if(this.getDomRef()){var w=sap.ui.getCore().createRenderManager();this.getRenderer().renderControls(w,v);w.flush($[0]);w.destroy();}return this;};
e.prototype._initScrolling=function(){var v=this.getId(),w=v+"-"+p,x=v+"-"+r;if(!this._oSCScroller&&!this._oMCScroller){this._oSCScroller=new a(this,null,{scrollContainerId:w,horizontal:false,vertical:true});this._oMCScroller=new a(this,null,{scrollContainerId:x,horizontal:false,vertical:true});}};
e.prototype._attachContainerResizeListener=function(){setTimeout(function(){this._sContainerResizeListener=R.register(this,this._adjustToScreenSize.bind(this));}.bind(this),0);};
e.prototype._detachContainerResizeListener=function(){if(this._sContainerResizeListener){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;}};
e.prototype._getBreakPointFromWidth=function(w){if(w<=s&&this._currentBreakpoint!==S){return S;}else if((w>s)&&(w<=t)&&this._currentBreakpoint!==M){return M;}else if((w>t)&&(w<=u)&&this._currentBreakpoint!==L){return L;}else if(w>u&&this._currentBreakpoint!==X){return X;}return this._currentBreakpoint;};
e.prototype._setBreakpointFromWidth=function(w){this._currentBreakpoint=this._getBreakPointFromWidth(w);if(this._bSuppressInitialFireBreakPointChange){this._bSuppressInitialFireBreakPointChange=false;}else{this.fireBreakpointChanged({currentBreakpoint:this._currentBreakpoint});}};
e.prototype._adjustToScreenSize=function(){if(this.getContainerQuery()){this._iWindowWidth=this.$().parent().width();}else{this._iWindowWidth=q(window).width();}this._currentBreakpoint=this._getBreakPointFromWidth(this._iWindowWidth);this._setResizeData(this._currentBreakpoint,this.getEqualSplit());this._changeGridState();this._setBreakpointFromWidth(this._iWindowWidth);};
e.prototype._setResizeData=function(v,w){var x=this.getSideContentVisibility(),y=this.getSideContentFallDown();if(!w){switch(v){case S:this._setSpanSize(o,o);if(this.getProperty("showSideContent")&&this.getProperty("showMainContent")&&this._MCVisible){this._SCVisible=x===d.AlwaysShow;}this._bFixedSideContent=false;break;case M:var z=Math.ceil((33.333/100)*this._iWindowWidth);if(y===c.BelowL||y===c.BelowXL||(z<=320&&y===c.OnMinimumWidth)){this._setSpanSize(o,o);this._bFixedSideContent=false;}else{this._setSpanSize(j,m);this._bFixedSideContent=true;}this._SCVisible=x===d.ShowAboveS||x===d.AlwaysShow;this._MCVisible=true;break;case L:if(y===c.BelowXL){this._setSpanSize(o,o);}else{this._setSpanSize(j,m);}this._SCVisible=x===d.ShowAboveS||x===d.ShowAboveM||x===d.AlwaysShow;this._MCVisible=true;this._bFixedSideContent=false;break;case X:this._setSpanSize(i,n);this._SCVisible=x!==d.NeverShow;this._MCVisible=true;this._bFixedSideContent=false;break;default:throw new Error(I);}}else{switch(v){case S:this._setSpanSize(o,o);this._SCVisible=false;break;default:this._setSpanSize(k,k);this._SCVisible=true;this._MCVisible=true;}this._bFixedSideContent=false;}return this;};
e.prototype._shouldSetHeight=function(){var v,B,O,w,x,F,y;v=(this.getProperty("scSpan")+this.getProperty("mcSpan"))===o;B=this._MCVisible&&this._SCVisible;O=!this._MCVisible&&this._SCVisible;w=this._MCVisible&&!this._SCVisible;x=O||w;F=this._fixedSideContent;y=this.getSideContentVisibility()===d.NeverShow;return((v&&B)||x||F||y);};
e.prototype._changeGridState=function(){var $=this.$(p),v=this.$(r),w=this.getProperty("showMainContent"),x=this.getProperty("showSideContent");if(this._bFixedSideContent){$.removeClass().addClass(h);v.removeClass().addClass(g);}else{$.removeClass(h);v.removeClass(g);}if(this._SCVisible&&this._MCVisible&&x&&w){if(!this._bFixedSideContent){v.removeClass().addClass("sapUiDSCSpan"+this.getProperty("mcSpan"));$.removeClass().addClass("sapUiDSCSpan"+this.getProperty("scSpan"));}if(this._shouldSetHeight()){$.css("height","100%").css("float","left");v.css("height","100%").css("float","left");}else{$.css("height","auto").css("float","none");v.css("height","auto").css("float","none");}}else if(!this._SCVisible&&!this._MCVisible){v.addClass(H);$.addClass(H);}else if(this._MCVisible&&w){v.removeClass().addClass(f);$.addClass(H);}else if(this._SCVisible&&x){$.removeClass().addClass(f);v.addClass(H);}else if(!w&&!x){v.addClass(H);$.addClass(H);}v.addClass("sapUiDSCM");$.addClass("sapUiDSCS");};
e.prototype._setSpanSize=function(v,w){this.setProperty("scSpan",v);this.setProperty("mcSpan",w);};
return e;});
sap.ui.predefine('sap/ui/layout/DynamicSideContentRenderer',["sap/ui/layout/library","sap/ui/Device"],function(l,D){"use strict";var S=l.SideContentPosition;var a="SIDE_CONTENT_LABEL";var b={apiVersion:2};
b.render=function(r,s){r.openStart("div",s);r.class("sapUiDSC");r.style("height","100%");r.openEnd();this.renderSubControls(r,s);r.close("div");};
b.renderSubControls=function(r,s){var i=s.getId(),c=s._shouldSetHeight(),p=sap.ui.getCore().getConfiguration().getRTL(),d=s.getSideContentPosition();if((d===S.Begin&&!p)||(p&&d===S.End)){this._renderSideContent(r,s,i,c);this._renderMainContent(r,s,i,c);}else{this._renderMainContent(r,s,i,c);this._renderSideContent(r,s,i,c);}};
b.renderControls=function(r,c){var L=c.length,i=0;for(;i<L;i++){r.renderControl(c[i]);}};
b._renderMainContent=function(r,s,i,c){r.openStart("div",i+"-MCGridCell");r.class("sapUiDSCM");if(s.getProperty("mcSpan")){if(s.getShowSideContent()&&s._SCVisible){r.class("sapUiDSCSpan"+s.getProperty("mcSpan"));}else{r.class("sapUiDSCSpan12");c=true;}}if(c){r.style("height","100%");}r.openEnd();this.renderControls(r,s.getMainContent());r.close("div");};
b._renderSideContent=function(r,s,i,c){var d=D.browser.firefox?"div":"aside";r.openStart(d,i+"-SCGridCell");r.class("sapUiDSCS");var m=sap.ui.getCore().getLibraryResourceBundle("sap.ui.layout");r.attr("aria-label",m.getText(a));r.accessibilityState(s,{role:"complementary"});if(s.getProperty("scSpan")){if(s.getShowMainContent()&&s._MCVisible){r.class("sapUiDSCSpan"+s.getProperty("scSpan"));}else{r.class("sapUiDSCSpan12");c=true;}}if(c){r.style("height","100%");}r.openEnd();this.renderControls(r,s.getSideContent());r.close(d);};
return b;},true);
sap.ui.predefine('sap/ui/layout/FixFlex',["sap/ui/core/Control","sap/ui/core/EnabledPropagator","sap/ui/core/ResizeHandler","sap/ui/core/delegate/ScrollEnablement","sap/ui/layout/library","./FixFlexRenderer"],function(C,E,R,S){"use strict";
var F=C.extend("sap.ui.layout.FixFlex",{metadata:{library:"sap.ui.layout",properties:{vertical:{type:"boolean",group:"Appearance",defaultValue:true},fixFirst:{type:"boolean",group:"Misc",defaultValue:true},fixContentSize:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},minFlexSize:{type:"int",defaultValue:0}},aggregations:{fixContent:{type:"sap.ui.core.Control",multiple:true,singularName:"fixContent"},flexContent:{type:"sap.ui.core.Control",multiple:false}},designtime:"sap/ui/layout/designtime/FixFlex.designtime",dnd:{draggable:false,droppable:true}}});
E.call(F.prototype);
F.prototype.init=function(){this._scroller=new S(this,null,{scrollContainerId:this.getId()});this._innerScroller=new S(this,this.getId()+"-FlexibleContainer",{scrollContainerId:this.getId()+"-Flexible"});};
F.prototype.exit=function(){this._deregisterControl();if(this._scroller){this._scroller.destroy();this._scroller=null;}if(this._innerScroller){this._innerScroller.destroy();this._innerScroller=null;}};
F.prototype.onBeforeRendering=function(){this._deregisterControl();this._scroller.setVertical(false);this._scroller.setHorizontal(false);var s=this.getMinFlexSize()!==0;this._innerScroller.setVertical(s);this._innerScroller.setHorizontal(s);};
F.prototype.onAfterRendering=function(){if(this.getMinFlexSize()!==0){this.sResizeListenerFixFlexScroll=R.register(this.getDomRef(),this._changeScrolling.bind(this));this.sResizeListenerFixFlexScrollFlexPart=R.register(this.getDomRef("Fixed"),this._changeScrolling.bind(this));var f=this.getDomRef("FlexibleContainer").firstChild;if(f){this.sResizeListenerFixFlexContainerScroll=R.register(f,this._changeFlexibleContainerScroll.bind(this));}this._changeScrolling();}};
F.prototype.getScrollDelegate=function(){return this._innerScroller;};
F.prototype._deregisterControl=function(){if(this.sResizeListenerFixFlexScroll){R.deregister(this.sResizeListenerFixFlexScroll);this.sResizeListenerFixFlexScroll=null;}if(this.sResizeListenerFixFlexScrollFlexPart){R.deregister(this.sResizeListenerFixFlexScrollFlexPart);this.sResizeListenerFixFlexScrollFlexPart=null;}if(this.sResizeListenerFixFlexContainerScroll){R.deregister(this.sResizeListenerFixFlexContainerScroll);this.sResizeListenerFixFlexContainerScroll=null;}};
F.prototype._changeScrolling=function(){var f,d,$=this.$(),m=this.getMinFlexSize(),i=this.getVertical();if(i){f=this.$().height()-this.$("Fixed").height();d="height";}else{f=this.$().width()-this.$("Fixed").width();d="width";}if(f<=parseInt(this.getMinFlexSize())){$.addClass("sapUiFixFlexScrolling");$.removeClass("sapUiFixFlexInnerScrolling");if(i){this._scroller.setVertical(true);this._innerScroller.setVertical(false);}else{this._scroller.setHorizontal(true);this._innerScroller.setHorizontal(false);}if(this.$("FlexibleContainer").children().height()>m){this.$("Flexible").attr("style","min-"+d+":"+m+"px");}else{this.$("Flexible").attr("style",d+":"+m+"px");}}else{$.addClass("sapUiFixFlexInnerScrolling");$.removeClass("sapUiFixFlexScrolling");if(i){this._scroller.setVertical(false);this._innerScroller.setVertical(true);}else{this._scroller.setHorizontal(false);this._innerScroller.setHorizontal(true);}this._changeFlexibleContainerScroll();this.$("Flexible").removeAttr("style");}};
F.prototype._changeFlexibleContainerScroll=function(){var $=this.$("FlexibleContainer"),c=$.height(),a=$.children().height();if(c==a){return;}if(c>a){$.removeClass('sapUiFixFlexFlexibleContainerGrowing');}else{$.addClass('sapUiFixFlexFlexibleContainerGrowing');}};
return F;});
sap.ui.predefine('sap/ui/layout/FixFlexRenderer',[],function(){"use strict";var F={apiVersion:2};
F.render=function(r,c){r.openStart("div",c).class("sapUiFixFlex");if(c.getMinFlexSize()!==0){r.class("sapUiFixFlexInnerScrolling");}if(!c.getVertical()){r.class("sapUiFixFlexRow");}r.openEnd();if(c.getFixFirst()){this.renderFixChild(r,c);this.renderFlexChild(r,c);}else{this.renderFlexChild(r,c);this.renderFixChild(r,c);}r.close("div");};
F.renderFixChild=function(r,c){r.openStart("div",c.getId()+"-Fixed").class("sapUiFixFlexFixed");if(c.getFixContentSize()!=="auto"){if(c.getVertical()){r.style("height",c.getFixContentSize());}else{r.style("width",c.getFixContentSize());}}r.openEnd();c.getFixContent().forEach(r.renderControl,r);r.close("div");};
F.renderFlexChild=function(r,c){r.openStart("div",c.getId()+"-Flexible").class("sapUiFixFlexFlexible").openEnd();r.openStart("div",c.getId()+"-FlexibleContainer").class("sapUiFixFlexFlexibleContainer");if(c.getMinFlexSize()!==0){if(c.getVertical()){r.style("min-height",c.getMinFlexSize()+"px");}else{r.style("min-width",c.getMinFlexSize()+"px");}}r.openEnd();r.renderControl(c.getFlexContent());r.close("div").close("div");};
return F;},true);
sap.ui.predefine('sap/ui/layout/Grid',['sap/ui/core/Control','./library','sap/ui/Device','sap/ui/core/ResizeHandler','sap/ui/base/ManagedObjectObserver',"./GridRenderer","sap/ui/thirdparty/jquery"],function(C,l,D,R,M,G,q){"use strict";
var a=C.extend("sap.ui.layout.Grid",{metadata:{library:"sap.ui.layout",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},vSpacing:{type:"float",group:"Dimension",defaultValue:1},hSpacing:{type:"float",group:"Dimension",defaultValue:1},position:{type:"sap.ui.layout.GridPosition",group:"Dimension",defaultValue:"Left"},defaultSpan:{type:"sap.ui.layout.GridSpan",group:"Behavior",defaultValue:"XL3 L3 M6 S12"},defaultIndent:{type:"sap.ui.layout.GridIndent",group:"Behavior",defaultValue:"XL0 L0 M0 S0"},containerQuery:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},designtime:"sap/ui/layout/designtime/Grid.designtime"}});
(function(){
a.prototype.init=function(){var c=l.GridHelper.getLibrarySpecificClass();if(c){this.addStyleClass(c);}this._iBreakPointTablet=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[0];this._iBreakPointDesktop=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[1];this._iBreakPointLargeDesktop=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[2];this._indentXLChanged=false;this._spanXLChanged=false;this._oObserver=new M(a.prototype._observeChanges.bind(this));this._oObserver.observe(this,{aggregations:["content"]});};
a.prototype.onAfterRendering=function(){if(this.getContainerQuery()){this._sContainerResizeListener=R.register(this,q.proxy(this._onParentResize,this));this._onParentResize();}else{this._attachMediaContainerWidthChange(this._handleMediaChange,this,D.media.RANGESETS.SAP_STANDARD_EXTENDED);}};
a.prototype.onBeforeRendering=function(){this._cleanup();};
a.prototype.exit=function(){this._cleanup();if(this._oObserver){this._oObserver.disconnect();this._oObserver=null;}};
a.prototype._cleanup=function(){if(this._sContainerResizeListener){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;}this._detachMediaContainerWidthChange(this._handleMediaChange,this,D.media.RANGESETS.SAP_STANDARD_EXTENDED);};
a.prototype._observeVisibility=function(c){this._oObserver.observe(c,{properties:["visible"]});};
a.prototype._unobserveVisibility=function(c){this._oObserver.unobserve(c,{properties:["visible"]});};
a.prototype._observeChanges=function(c){var o=c.object,s=c.name,m=c.mutation,b=c.child;if(o===this){if(m==="insert"){this._observeVisibility(b);}else if(m==="remove"){this._unobserveVisibility(b);}}else if(s==="visible"){var e=this.getContent().indexOf(o);q(this.$().children()[e]).toggleClass("sapUiRespGridSpanInvisible",!c.current);}};
a.prototype._handleMediaChange=function(p){this._toggleClass(p.name);};
a.prototype._setBreakPointTablet=function(b){this._iBreakPointTablet=b;};
a.prototype._setBreakPointDesktop=function(b){this._iBreakPointDesktop=b;};
a.prototype._setBreakPointLargeDesktop=function(b){this._iBreakPointLargeDesktop=b;};
a.prototype.setDefaultIndent=function(d){if(/XL/gi.test(d)){this._setIndentXLChanged(true);}return this.setProperty("defaultIndent",d);};
a.prototype._setIndentXLChanged=function(c){this._indentXLChanged=c;};
a.prototype._getIndentXLChanged=function(){return this._indentXLChanged;};
a.prototype.setDefaultSpan=function(d){if(/XL/gi.test(d)){this._setSpanXLChanged(true);}return this.setProperty("defaultSpan",d);};
a.prototype._setSpanXLChanged=function(c){this._spanXLChanged=c;};
a.prototype._getSpanXLChanged=function(){return this._spanXLChanged;};
a.prototype._onParentResize=function(){var d=this.getDomRef();if(!d){this._cleanup();return;}if(!q(d).is(":visible")){return;}var c=d.clientWidth;if(c<=this._iBreakPointTablet){this._toggleClass("Phone");}else if((c>this._iBreakPointTablet)&&(c<=this._iBreakPointDesktop)){this._toggleClass("Tablet");}else if((c>this._iBreakPointDesktop)&&(c<=this._iBreakPointLargeDesktop)){this._toggleClass("Desktop");}else{this._toggleClass("LargeDesktop");}};
a.prototype._toggleClass=function(m){var d=this.$();if(!d){return;}if(d.hasClass("sapUiRespGridMedia-Std-"+m)){return;}d.toggleClass("sapUiRespGridMedia-Std-"+m,true);if(m==="Phone"){d.toggleClass("sapUiRespGridMedia-Std-Desktop",false).toggleClass("sapUiRespGridMedia-Std-Tablet",false).toggleClass("sapUiRespGridMedia-Std-LargeDesktop",false);}else if(m==="Tablet"){d.toggleClass("sapUiRespGridMedia-Std-Desktop",false).toggleClass("sapUiRespGridMedia-Std-Phone",false).toggleClass("sapUiRespGridMedia-Std-LargeDesktop",false);}else if(m==="LargeDesktop"){d.toggleClass("sapUiRespGridMedia-Std-Desktop",false).toggleClass("sapUiRespGridMedia-Std-Phone",false).toggleClass("sapUiRespGridMedia-Std-Tablet",false);}else{d.toggleClass("sapUiRespGridMedia-Std-Phone",false).toggleClass("sapUiRespGridMedia-Std-Tablet",false).toggleClass("sapUiRespGridMedia-Std-LargeDesktop",false);}this.fireEvent("mediaChanged",{media:m});};
a.prototype._getLayoutDataForControl=function(c){var L=c.getLayoutData();if(!L){return undefined;}else if(L instanceof sap.ui.layout.GridData){return L;}else if(L.isA("sap.ui.core.VariantLayoutData")){var b=L.getMultipleLayoutData();for(var i=0;i<b.length;i++){var o=b[i];if(o instanceof sap.ui.layout.GridData){return o;}}}};
a.prototype.onLayoutDataChange=function(e){if(this.getDomRef()){this.invalidate();}};
a.prototype._getAccessibleRole=function(){return null;};
a.prototype.getAccessibilityInfo=function(){return{children:this.getContent().filter(function(c){return c.$().is(':visible');})};};
}());return a;});
sap.ui.predefine('sap/ui/layout/GridData',['sap/ui/core/LayoutData','./library',"sap/base/Log"],function(L,l,a){"use strict";
var G=L.extend("sap.ui.layout.GridData",{metadata:{library:"sap.ui.layout",properties:{span:{type:"sap.ui.layout.GridSpan",group:"Behavior",defaultValue:null},spanXL:{type:"int",group:"Behavior",defaultValue:null},spanL:{type:"int",group:"Behavior",defaultValue:null},spanM:{type:"int",group:"Behavior",defaultValue:null},spanS:{type:"int",group:"Behavior",defaultValue:null},indent:{type:"sap.ui.layout.GridIndent",group:"Behavior",defaultValue:null},indentXL:{type:"int",group:"Behavior",defaultValue:null},indentL:{type:"int",group:"Behavior",defaultValue:null},indentM:{type:"int",group:"Behavior",defaultValue:null},indentS:{type:"int",group:"Behavior",defaultValue:null},visibleXL:{type:"boolean",group:"Behavior",defaultValue:true},visibleL:{type:"boolean",group:"Behavior",defaultValue:true},visibleM:{type:"boolean",group:"Behavior",defaultValue:true},visibleS:{type:"boolean",group:"Behavior",defaultValue:true},moveBackwards:{type:"sap.ui.layout.GridIndent",group:"Misc",defaultValue:null},moveForward:{type:"sap.ui.layout.GridIndent",group:"Misc",defaultValue:null},linebreak:{type:"boolean",group:"Misc",defaultValue:false},linebreakXL:{type:"boolean",group:"Misc",defaultValue:false},linebreakL:{type:"boolean",group:"Misc",defaultValue:false},linebreakM:{type:"boolean",group:"Misc",defaultValue:false},linebreakS:{type:"boolean",group:"Misc",defaultValue:false},spanLarge:{type:"int",group:"Behavior",defaultValue:null,deprecated:true},spanMedium:{type:"int",group:"Behavior",defaultValue:null,deprecated:true},spanSmall:{type:"int",group:"Behavior",defaultValue:null,deprecated:true},indentLarge:{type:"int",group:"Behavior",defaultValue:null,deprecated:true},indentMedium:{type:"int",group:"Behavior",defaultValue:null,deprecated:true},indentSmall:{type:"int",group:"Behavior",defaultValue:null,deprecated:true},visibleOnLarge:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true},visibleOnMedium:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true},visibleOnSmall:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true}}}});
(function(){
G.prototype._setStylesInternal=function(s){if(s&&s.length>0){this._sStylesInternal=s;}else{this._sStylesInternal=undefined;}};
G.prototype._getEffectiveSpanXLarge=function(){var s=this.getSpanXL();if(s&&(s>0)&&(s<13)){return s;}var S=/XL([1-9]|1[0-2])(?:\s|$)/i;var b=S.exec(this.getSpan());if(b){var c=b[0];if(c){c=c.toUpperCase();if(c.substr(0,2)==="XL"){return parseInt(c.substr(2));}}}return undefined;};
G.prototype._getEffectiveSpanLarge=function(){var s=this.getSpanL();if(s&&(s>0)&&(s<13)){return s;}var S=/\bL([1-9]|1[0-2])(?:\s|$)/i;var b=S.exec(this.getSpan());if(b){var c=b[0];if(c){c=c.toUpperCase();if(c.substr(0,1)==="L"){return parseInt(c.substr(1));}}}return undefined;};
G.prototype._getEffectiveSpanMedium=function(){var s=this.getSpanM();if(s&&(s>0)&&(s<13)){return s;}var S=/M([1-9]|1[0-2])(?:\s|$)/i;var b=S.exec(this.getSpan());if(b){var c=b[0];if(c){c=c.toUpperCase();if(c.substr(0,1)==="M"){return parseInt(c.substr(1));}}}return undefined;};
G.prototype._getEffectiveSpanSmall=function(){var s=this.getSpanS();if(s&&(s>0)&&(s<13)){return s;}var S=/S([1-9]|1[0-2])(?:\s|$)/i;var b=S.exec(this.getSpan());if(b){var c=b[0];if(c){c=c.toUpperCase();if(c.substr(0,1)==="S"){return parseInt(c.substr(1));}}}return undefined;};
G.prototype.init=function(){this._bLinebreakXLChanged=false;};
G.prototype.setLinebreakXL=function(b){this.setProperty("linebreakXL",b);this._bLinebreakXLChanged=true;return this;};
G.prototype._getLinebreakXLChanged=function(){return this._bLinebreakXLChanged;};
G.prototype.setSpanLarge=function(s){this.setSpanL(s);a.warning("Deprecated property spanLarge is used, please use spanL instead.");return this;};
G.prototype.setSpanMedium=function(s){a.warning("Deprecated property spanMedium is used, please use spanM instead.");return this.setSpanM(s);};
G.prototype.setSpanSmall=function(s){a.warning("Deprecated property spanSmall is used, please use spanS instead.");return this.setSpanS(s);};
G.prototype.setIndentLarge=function(i){a.warning("Deprecated property indentLarge is used, please use indentL instead.");return this.setIndentL(i);};
G.prototype.setIndentMedium=function(i){a.warning("Deprecated property indentMedium is used, please use indentM instead.");return this.setIndentM(i);};
G.prototype.setIndentSmall=function(i){a.warning("Deprecated property indentSmall is used, please use indentS instead.");return this.setIndentS(i);};
G.prototype.setVisibleOnLarge=function(v){a.warning("Deprecated property visibleOnLarge is used, please use visibleL instead.");return this.setVisibleL(v);};
G.prototype.setVisibleOnMedium=function(v){a.warning("Deprecated property visibleOnMedium is used, please use visibleM instead.");return this.setVisibleM(v);};
G.prototype.setVisibleOnSmall=function(v){a.warning("Deprecated property visibleOnSmall is used, please use visibleS instead.");return this.setVisibleS(v);};
G.prototype.getSpanLarge=function(){a.warning("Deprecated property spanLarge is used, please use spanL instead.");return this.getSpanL();};
G.prototype.getSpanMedium=function(){a.warning("Deprecated property spanMedium is used, please use spanM instead.");return this.getSpanM();};
G.prototype.getSpanSmall=function(){a.warning("Deprecated property spanSmall is used, please use spanS instead.");return this.getSpanS();};
G.prototype.getIndentLarge=function(){a.warning("Deprecated property indentLarge is used, please use indentL instead.");return this.getIndentL();};
G.prototype.getIndentMedium=function(){a.warning("Deprecated property indentMedium is used, please use indentM instead.");return this.getIndentM();};
G.prototype.getIndentSmall=function(){a.warning("Deprecated property indentSmall is used, please use indentS instead.");return this.getIndentS();};
G.prototype.getVisibleOnLarge=function(){a.warning("Deprecated property visibleOnLarge is used, please use visibleL instead.");return this.getVisibleL();};
G.prototype.getVisibleOnMedium=function(){a.warning("Deprecated property visibleOnMedium is used, please use visibleM instead.");return this.getVisibleM();};
G.prototype.getVisibleOnSmall=function(){a.warning("Deprecated property visibleOnSmall is used, please use visibleS instead.");return this.getVisibleS();};
}());return G;});
sap.ui.predefine('sap/ui/layout/GridRenderer',["sap/ui/Device","sap/ui/layout/library"],function(D,l){"use strict";var G=l.GridPosition;var a={apiVersion:2};
a.render=function(r,c){var I=/^([X][L](?:[0-9]|1[0-1]))? ?([L](?:[0-9]|1[0-1]))? ?([M](?:[0-9]|1[0-1]))? ?([S](?:[0-9]|1[0-1]))?$/i;var S=/^([X][L](?:[1-9]|1[0-2]))? ?([L](?:[1-9]|1[0-2]))? ?([M](?:[1-9]|1[0-2]))? ?([S](?:[1-9]|1[0-2]))?$/i;r.openStart("div",c);r.class("sapUiRespGrid");var m=c._getCurrentMediaContainerRange(D.media.RANGESETS.SAP_STANDARD_EXTENDED).name;r.class("sapUiRespGridMedia-Std-"+m);var h=c.getHSpacing();if(h===0.5){h="05";}else if((h!==0)&&(h!==1)&&(h!==2)){h=1;}r.class("sapUiRespGridHSpace"+h);var v=c.getVSpacing();if(v===0.5){v="05";}else if((v!==0)&&(v!==1)&&(v!==2)){v=1;}r.class("sapUiRespGridVSpace"+v);var p=c.getPosition();if(p){p=p.toUpperCase();if(p===G.Center.toUpperCase()){r.class("sapUiRespGridPosCenter");}else if(p===G.Right.toUpperCase()){r.class("sapUiRespGridPosRight");}}var w=c.getWidth();if(w!=="100%"&&w!=="auto"&&w!=="inherit"){if(h===0){r.style("width",w);}else{r.style("width","-webkit-calc("+w+" - "+h+"rem)");r.style("width","calc("+w+" - "+h+"rem)");}}var R=c._getAccessibleRole();var A;if(R){A={role:R};}r.accessibilityState(c,A);r.openEnd();var b=c.getContent();var d=c.getDefaultSpan();var e=["","XL3","L3","M6","S12"];var f=["","XL0","L0","M0","S0"];var g=S.exec(d);var k=c._getSpanXLChanged();var n=c._getIndentXLChanged();var s=c.getDefaultIndent();var o=I.exec(s);for(var i=0;i<b.length;i++){r.openStart("div",c.getId()+"-wrapperfor-"+b[i].getId());var L=c._getLayoutDataForControl(b[i]);var C=false;if(!b[i].getVisible()){r.class("sapUiRespGridSpanInvisible");}if(L){var B=false;if(L.getLinebreak()===true){r.class("sapUiRespGridBreak");}else{if(L.getLinebreakXL()===true){B=true;r.class("sapUiRespGridBreakXL");}if(L.getLinebreakL()===true){if(!B&&!L._getLinebreakXLChanged()){r.class("sapUiRespGridBreakXL");}r.class("sapUiRespGridBreakL");}if(L.getLinebreakM()===true){r.class("sapUiRespGridBreakM");}if(L.getLinebreakS()===true){r.class("sapUiRespGridBreakS");}}var q;var t;var u=L.getSpan();if(!u||!u.lenght==0){q=g;}else{q=S.exec(u);if(/XL/gi.test(u)){C=true;}}if(q){for(var j=1;j<q.length;j++){var x=q[j];if(!x){x=g[j];if(!x){x=e[j];}}if(x.substr(0,1)==="L"){t=x.substr(1,2);}var y=L.getSpanXL();var z=L.getSpanL();var E=L.getSpanM();var F=L.getSpanS();x=x.toUpperCase();if((x.substr(0,2)==="XL")&&(y>0)&&(y<13)){r.class("sapUiRespGridSpanXL"+y);C=true;}else if((x.substr(0,1)==="L")&&(z>0)&&(z<13)){r.class("sapUiRespGridSpanL"+z);t=z;}else if((x.substr(0,1)==="M")&&(E>0)&&(E<13)){r.class("sapUiRespGridSpanM"+E);}else if((x.substr(0,1)==="S")&&(F>0)&&(F<13)){r.class("sapUiRespGridSpanS"+F);}else{if((x.substr(0,2)!=="XL")||k||C){r.class("sapUiRespGridSpan"+x);}}}if(!k&&!C){r.class("sapUiRespGridSpanXL"+t);}}var H;var J;var K=L.getIndent();if(!K||K.length==0){H=o;}else{H=I.exec(K);if(/XL/gi.test(K)){n=true;}}if(!H){H=o;if(!H){H=undefined;}}var M=L.getIndentXL();var N=L.getIndentL();var O=L.getIndentM();var P=L.getIndentS();if(H){for(var j=1;j<H.length;j++){var Q=H[j];if(!Q){if(o&&o[j]){Q=o[j];}else{Q=f[j];}}if(Q){Q=Q.toUpperCase();if(Q.substr(0,1)==="L"){J=Q.substr(1,2);}if((Q.substr(0,2)==="XL")&&(M>0)&&(M<12)){r.class("sapUiRespGridIndentXL"+M);n=true;}else if((Q.substr(0,1)==="L")&&(N>0)&&(N<12)){r.class("sapUiRespGridIndentL"+N);J=N;}else if((Q.substr(0,1)==="M")&&(O>0)&&(O<12)){r.class("sapUiRespGridIndentM"+O);}else if((Q.substr(0,1)==="S")&&(P>0)&&(P<12)){r.class("sapUiRespGridIndentS"+P);}else{if(!(/^(XL0)? ?(L0)? ?(M0)? ?(S0)?$/.exec(Q))){r.class("sapUiRespGridIndent"+Q);}}}}if(!n){if(J&&J>0){r.class("sapUiRespGridIndentXL"+J);}}}if(!L.getVisibleXL()){r.class("sapUiRespGridHiddenXL");}if(!L.getVisibleL()){r.class("sapUiRespGridHiddenL");}if(!L.getVisibleM()){r.class("sapUiRespGridHiddenM");}if(!L.getVisibleS()){r.class("sapUiRespGridHiddenS");}var T=L.getMoveBackwards();if(T&&T.length>0){var U=I.exec(T);if(U){for(var j=1;j<U.length;j++){var V=U[j];if(V){r.class("sapUiRespGridBwd"+V.toUpperCase());}}}}var W=L.getMoveForward();if(W&&W.length>0){var X=I.exec(W);if(X){for(var j=1;j<X.length;j++){var Y=X[j];if(Y){r.class("sapUiRespGridFwd"+Y.toUpperCase());}}}}if(typeof L._sStylesInternal==="string"){var Z=L._sStylesInternal.split(" ");for(var $=0;$<Z.length;$++){r.class(Z[$]);}}}if(!L){var x="";if(g){for(var j=1;j<g.length;j++){x=g[j];if(!x){if((j===1)&&(g[j+1])){x="X"+g[j+1];}else{x=e[j];}}r.class("sapUiRespGridSpan"+x.toUpperCase());}}else{for(var j=1;j<e.length;j++){x=e[j];r.class("sapUiRespGridSpan"+x.toUpperCase());}}var Q="";if(o){for(var j=1;j<o.length;j++){Q=o[j];if(!Q){if((j===1)&&(o[j+1])){Q="X"+o[j+1];}else{Q=f[j];}}if(((Q.substr(0,1)!=="X")&&(Q.substr(1,1)!=="0"))||((Q.substr(0,1)=="X")&&(Q.substr(2,1)!=="0"))){r.class("sapUiRespGridIndent"+Q.toUpperCase());}}}}r.openEnd();r.renderControl(b[i]);r.close("div");}r.close("div");};
return a;},true);
sap.ui.predefine('sap/ui/layout/HorizontalLayout',['sap/ui/core/Control','./library',"./HorizontalLayoutRenderer"],function(C,l,H){"use strict";
var a=C.extend("sap.ui.layout.HorizontalLayout",{metadata:{library:"sap.ui.layout",properties:{allowWrapping:{type:"boolean",group:"Misc",defaultValue:false}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},designtime:"sap/ui/layout/designtime/HorizontalLayout.designtime",dnd:{draggable:false,droppable:true}}});
a.prototype.getAccessibilityInfo=function(){return{children:this.getContent()};};
return a;});
sap.ui.predefine('sap/ui/layout/HorizontalLayoutRenderer',[],function(){"use strict";var H={apiVersion:2};
H.render=function(r,c){var a=r;var n=!c.getAllowWrapping();a.openStart("div",c);a.class("sapUiHLayout");if(n){a.class("sapUiHLayoutNoWrap");}a.openEnd();var C=c.getContent();for(var i=0;i<C.length;i++){if(n){a.openStart("div");a.class("sapUiHLayoutChildWrapper");a.openEnd();}a.renderControl(C[i]);if(n){a.close("div");}}a.close("div");};
return H;},true);
sap.ui.predefine('sap/ui/layout/PaneContainer',['./library','sap/ui/core/Element','./AssociativeSplitter','sap/ui/core/library'],function(l,E,A,c){"use strict";var O=c.Orientation;
var P=E.extend("sap.ui.layout.PaneContainer",{metadata:{library:"sap.ui.layout",properties:{orientation:{type:"sap.ui.core.Orientation",group:"Behavior",defaultValue:O.Horizontal}},defaultAggregation:"panes",aggregations:{panes:{type:"sap.ui.core.Element",multiple:true,singularName:"pane"}},events:{resize:{parameters:{oldSizes:{type:"float[]"},newSizes:{type:"float[]"}}}}}});
P.prototype.init=function(){this._oSplitter=new A({orientation:this.getOrientation(),height:"100%",resize:this._onSplitterResize.bind(this)});};
P.prototype.exit=function(){this._oSplitter.destroy();this._oSplitter=null;};
P.prototype._onSplitterResize=function(e){this.fireResize({oldSizes:e.getParameter("oldSizes"),newSizes:e.getParameter("newSizes")});};
P.prototype.setOrientation=function(o){this._oSplitter.setOrientation(o);return this.setProperty("orientation",o);};
P.prototype._getPanesInInterval=function(f){return this.getPanes().filter(function(p){return p instanceof sap.ui.layout.SplitPane&&p._isInInterval(f);});};
P.prototype.setLayoutData=function(L){this._oSplitter.setLayoutData(L);return this;};
P.prototype.getLayoutData=function(){return this._oSplitter.getLayoutData();};
P.prototype.insertPane=function(o,i){var r=this.insertAggregation("panes",o,i),e={onAfterRendering:function(){this.triggerResize();this.removeEventDelegate(e);}};if(o instanceof P&&o._oSplitter){o._oSplitter.addEventDelegate(e,o._oSplitter);}return r;};
P.prototype.removePane=function(o){var r=this.removeAggregation("panes",o),e={onAfterRendering:function(){this.triggerResize();this.removeEventDelegate(e);}};this.getPanes().forEach(function(p){if(p instanceof P&&p._oSplitter){p._oSplitter.addEventDelegate(e,p._oSplitter);}});return r;};
return P;});
sap.ui.predefine('sap/ui/layout/ResponsiveFlowLayout',['sap/ui/core/Control','./ResponsiveFlowLayoutData','./library','sap/ui/core/ResizeHandler','./ResponsiveFlowLayoutRenderer',"sap/ui/thirdparty/jquery",'sap/ui/dom/jquery/rect'],function(C,R,l,a,b,q){"use strict";
var c=C.extend("sap.ui.layout.ResponsiveFlowLayout",{metadata:{library:"sap.ui.layout",properties:{responsive:{type:"boolean",group:"Misc",defaultValue:true}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}}});
(function(){
c.prototype.init=function(){this._rows=[];this._bIsRegistered=false;this._proxyComputeWidths=f.bind(this);this._iRowCounter=0;};
c.prototype.exit=function(){delete this._rows;if(this._IntervalCall){clearTimeout(this._IntervalCall);this._IntervalCall=undefined;}if(this._resizeHandlerComputeWidthsID){a.deregister(this._resizeHandlerComputeWidthsID);}delete this._resizeHandlerComputeWidthsID;delete this._proxyComputeWidths;if(this.oRm){this.oRm.destroy();delete this.oRm;}delete this._$DomRef;delete this._oDomRef;delete this._iRowCounter;};
var u=function(t){var h=t.getContent();var r=[];var j=-1;var I={},L={};var s="";var o;var m=0,w=0,k=0;var B=false,M=false,n=false;for(var i=0;i<h.length;i++){m=R.MIN_WIDTH;w=R.WEIGHT;B=R.LINEBREAK;M=R.MARGIN;n=R.LINEBREAKABLE;o=_(h[i]);if(o instanceof R){B=o.getLinebreak();m=o.getMinWidth();w=o.getWeight();M=o.getMargin();n=o.getLinebreakable();}if(j<0||B){j++;r.push({height:-1,cont:[]});}k=r[j].cont.length;s=h[i].getId()+"-cont"+j+"_"+k;I={minWidth:m,weight:w,linebreakable:n,padding:M,control:h[i],id:s,breakWith:[]};var p=false;if(!n){for(var v=k;v>0;v--){L=r[j].cont[v-1];if(L.linebreakable){L.breakWith.push(I);p=true;break;}}}if(!p){r[j].cont.push(I);}}t._rows=r;};var g=function(o,$,t){var r=[];var h=10000000;var k=-1;var m=function(j){var n=q(document.getElementById(o.cont[j].id));if(n.length>0){var p=n[0].offsetLeft;if(h>=p){r.push({cont:[]});k++;}h=p;r[k].cont.push(o.cont[j]);}};if(sap.ui.getCore().getConfiguration().getRTL()){for(var i=o.cont.length-1;i>=0;i--){m(i);}}else{for(var i=0;i<o.cont.length;i++){m(i);}}return r;};var d=function(o,w){var r=[];var h=-1;var i=0;var t=0;var m=0;var n=0,p=0;var j=0,k=0;for(j=0;j<o.cont.length;j++){i=0;t=0;for(k=m;k<=j;k++){t=t+o.cont[k].weight;}for(k=m;k<=j;k++){n=w/t*o.cont[k].weight;n=Math.floor(n);p=o.cont[k].minWidth;i+=Math.max(n,p);}if(h==-1||i>w){r.push({cont:[]});if(h!==-1){m=j;}h++;}r[h].cont.push(o.cont[j]);}return r;};var e=function(w,h){if(w.length!=h.length){return true;}for(var i=0;i<w.length;i++){if(w[i].cont.length!=h[i].cont.length){return true;}}return false;};
c.prototype.renderContent=function(t,w){var r=t,h=0,W=[],i=0,k=0,j=0,m=0,n=0,p=0,o,s=0,v=0,B=[],x=[],I=this.getId(),H="",y=this._getRenderManager();for(i=0;i<r.length;i++){p=0;W.length=0;h=100;x.length=0;x.push("sapUiRFLRow");if(r[i].cont.length<=1){x.push("sapUiRFLCompleteRow");}var z=I+"-row"+this._iRowCounter;var S={};y.writeHeader(z,S,x);n=0;for(k=0;k<r[i].cont.length;k++){n+=r[i].cont[k].weight;}for(j=0;j<r[i].cont.length;j++){o=r[i].cont[j];s=0;v=0;if(o.breakWith.length>0){s=o.weight;v=o.minWidth;for(var A=0;A<o.breakWith.length;A++){s+=o.breakWith[A].weight;v+=o.breakWith[A].minWidth;}}H=r[i].cont[j].id;x.length=0;S={"min-width":o.breakWith.length>0?v:o.minWidth};p=100/n*o.weight;var P=S["min-width"]/w*100;var D=Math.ceil(P);var E=Math.floor(p);if(E!==100&&D>E){p=D;}else{p=E;}p=h<p?h:p;h-=p;W.push(p);if(h>0&&j===(r[i].cont.length-1)){p+=h;}x.push("sapUiRFLContainer");S["width"]=p+"%";S["min-width"]=S["min-width"]+"px";y.writeHeader(H,S,x);x.length=0;x.push("sapUiRFLContainerContent");if(o.breakWith.length>0){x.push("sapUiRFLMultiContainerContent");}if(o.padding){x.push("sapUiRFLPaddingClass");}var F=this._addContentClass(o.control,j);if(F){x.push(F);}S={};y.writeHeader("",S,x);if(o.breakWith.length>0){H=r[i].cont[j].id+"-multi0";x.length=0;S={"min-width":v+"px"};var G=100/s*o.weight;G=Math.floor(G);B.push(G);x.push("sapUiRFLMultiContent");S["width"]=G+"%";if(r[i].cont[j].padding){x.push("sapUiRFLPaddingClass");}y.writeHeader(H,S,x);var J=G;y.renderControl(o.control);y.close("div");for(m=0;m<o.breakWith.length;m++){H=o.breakWith[m].id+'-multi'+(m+1);x.length=0;S={"min-width":o.breakWith[m].minWidth+"px"};G=100/s*o.breakWith[m].weight;G=Math.floor(G);B.push(G);J+=G;if(J<100&&m===(o.breakWith.length-1)){G+=100-J;}x.push("sapUiRFLMultiContent");S["width"]=G+"%";if(o.breakWith[m].padding){x.push("sapUiRFLPaddingClass");}y.writeHeader(H,S,x);y.renderControl(o.breakWith[m].control);y.close("div");}}else{y.renderControl(o.control);}y.close("div");y.close("div");}y.close("div");this._iRowCounter++;}};
var f=function(){this._iRowCounter=0;this._oDomRef=this.getDomRef();if(this._oDomRef){var I=this.getId();var h=q(this._oDomRef).width();var r=false;if(this._rows){for(var i=0;i<this._rows.length;i++){var $=q(document.getElementById(I+"-row"+i));var t=d(this._rows[i],h);var o=g(this._rows[i],$,this);r=e(o,t);var j=this._getElementRect($);var p=this._rows[i].oRect;if(j&&p){r=r||(j.width!==p.width)&&(j.height!==p.height);}if(this._bLayoutDataChanged||r){this._oDomRef.innerHTML="";this._bLayoutDataChanged=false;this.renderContent(t,h);}}if(this._oDomRef.innerHTML===""){this._getRenderManager().flush(this._oDomRef);for(var i=0;i<this._rows.length;i++){var T=this._getElementRect(q(document.getElementById(I+"-row"+i)));this._rows[i].oRect=T;}}if(this._rows.length===0){if(this._resizeHandlerComputeWidthsID){a.deregister(this._resizeHandlerComputeWidthsID);delete this._resizeHandlerComputeWidthsID;}}}}};
c.prototype.onBeforeRendering=function(){u(this);if(this._resizeHandlerFullLengthID){a.deregister(this._resizeHandlerFullLengthID);delete this._resizeHandlerFullLengthID;}};
c.prototype.onAfterRendering=function(){this._oDomRef=this.getDomRef();this._$DomRef=q(this._oDomRef);this._proxyComputeWidths();if(this.getResponsive()){if(!this._resizeHandlerComputeWidthsID){this._resizeHandlerComputeWidthsID=a.register(this,c.prototype.rerender.bind(this));}}else{if(this._resizeHandlerComputeWidthsID){a.deregister(this._resizeHandlerComputeWidthsID);delete this._resizeHandlerComputeWidthsID;}}};
c.prototype.onThemeChanged=function(E){if(E.type==="LayoutDataChange"){this._bLayoutDataChanged=true;}if(!this._resizeHandlerComputeWidthsID){this._resizeHandlerComputeWidthsID=a.register(this,c.prototype.rerender.bind(this));}u(this);this._proxyComputeWidths();};
c.prototype.onLayoutDataChange=c.prototype.onThemeChanged;var _=function(o){var L=o.getLayoutData();if(!L){return undefined;}else if(L instanceof R){return L;}else if(L.getMetadata().getName()=="sap.ui.core.VariantLayoutData"){var h=L.getMultipleLayoutData();for(var i=0;i<h.length;i++){var j=h[i];if(j instanceof R){return j;}}}};
c.prototype.addContent=function(o){if(o&&this._IntervalCall){clearTimeout(this._IntervalCall);this._IntervalCall=undefined;}this.addAggregation("content",o);return this;};
c.prototype.insertContent=function(o,i){if(o&&this._IntervalCall){clearTimeout(this._IntervalCall);this._IntervalCall=undefined;}this.insertAggregation("content",o,i);return this;};
c.prototype.removeContent=function(o){if(o&&this._IntervalCall){clearTimeout(this._IntervalCall);this._IntervalCall=undefined;}this.removeAggregation("content",o);};
c.prototype._getAccessibleRole=function(){return null;};
c.prototype._addContentClass=function(o,i){return null;};
c.prototype._getElementRect=function(E){var r=E&&E.rect();if(r){r.height=r.height.toFixed(1);r.width=r.width.toFixed(1);}return r;};
c.prototype._getRenderManager=function(){if(!this.oRm){this.oRm=sap.ui.getCore().createRenderManager();this.oRm.writeHeader=function(I,s,h){this.openStart("div",I);if(s){for(var k in s){if(k==="width"&&s[k]==="100%"){this.class("sapUiRFLFullLength");}this.style(k,s[k]);}}for(var i=0;i<h.length;i++){this.class(h[i]);}this.openEnd();};}return this.oRm;};
}());return c;});
sap.ui.predefine('sap/ui/layout/ResponsiveFlowLayoutData',['sap/ui/core/LayoutData','./library',"sap/base/Log"],function(L,l,a){"use strict";
var R=L.extend("sap.ui.layout.ResponsiveFlowLayoutData",{metadata:{library:"sap.ui.layout",properties:{minWidth:{type:"int",group:"Misc",defaultValue:100},weight:{type:"int",group:"Misc",defaultValue:1},linebreak:{type:"boolean",group:"Misc",defaultValue:false},margin:{type:"boolean",group:"Misc",defaultValue:true},linebreakable:{type:"boolean",group:"Misc",defaultValue:true}}}});
R.MIN_WIDTH=100;R.WEIGHT=1;R.LINEBREAK=false;R.MARGIN=true;R.LINEBREAKABLE=true;
R.prototype.setWeight=function(w){if(w>=1){this.setProperty("weight",w);}else{a.warning("Values smaller than 1 are invalid. Default value '1' is used instead",this);this.setProperty("weight",R.WEIGHT);}return this;};
R.prototype.setLinebreak=function(b){if(this.getLinebreakable()==false&&b){a.warning("Setting 'linebreak' AND 'linebreakable' doesn't make any sense. Please set either 'linebreak' or 'linebreakable'",this);}else{this.setProperty("linebreak",b);}return this;};
R.prototype.setLinebreakable=function(b){if(this.getLinebreak()===true&&b===false){a.warning("Setting 'linebreak' AND 'linebreakable' doesn't make any sense. Please set either 'linebreak' or 'linebreakable'",this);}else{this.setProperty("linebreakable",b);}return this;};
return R;});
sap.ui.predefine('sap/ui/layout/ResponsiveFlowLayoutRenderer',[],function(){"use strict";var R={apiVersion:2};(function(){
R.render=function(r,c){r.openStart("div",c);r.class("sapUiRFL");var s=c._getAccessibleRole();var a;if(s){a={role:s};}r.accessibilityState(c,a);r.openEnd();r.close("div");};
}());return R;},true);
sap.ui.predefine('sap/ui/layout/ResponsiveSplitter',["./library","./PaneContainer","./ResponsiveSplitterPage","./ResponsiveSplitterRenderer","./ResponsiveSplitterUtilities","./SplitPane","./Splitter","sap/ui/core/Core","sap/ui/core/Control","sap/ui/core/delegate/ItemNavigation","sap/ui/core/ResizeHandler","sap/ui/core/RenderManager"],function(l,P,R,c,d,S,e,C,f,I,g,h){"use strict";
var j=f.extend("sap.ui.layout.ResponsiveSplitter",{
metadata:{library:"sap.ui.layout",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'100%'}},defaultAggregation:"rootPaneContainer",aggregations:{rootPaneContainer:{type:"sap.ui.layout.PaneContainer",multiple:false},_pages:{type:"sap.ui.layout.ResponsiveSplitterPage",multiple:true,visibility:"hidden"}},associations:{defaultPane:{type:"sap.ui.layout.SplitPane",multiple:false}},events:{}},
renderer:c
});
var k={MAX_VISIBLE_BUTTONS:7};
j.prototype.init=function(){this._aPaneContainers=[];this._aPanes=[];this._oResourceBundle=C.getLibraryResourceBundle("sap.ui.layout");this._oItemNavigation=new I();this._oItemNavigation.setCycling(false);this.addDelegate(this._oItemNavigation);this._iDefaultPageIndex=0;};
j.prototype.onBeforeRendering=function(){var r=this.getRootPaneContainer();if(r){this._oSplitterDelegate=this._oSplitterDelegate||{onAfterRendering:function(){this._setSplitterBarsTooltips(r._oSplitter);this._updatePaginatorButtonsTooltips();}};r._oSplitter.addEventDelegate(this._oSplitterDelegate,this);this._createWidthIntervals();this._createPages();this._detachResizeHandler();}};
j.prototype.onAfterRendering=function(){this._parentResizeHandler=g.register(this,this._onParentResize.bind(this));var r=this.getRootPaneContainer();if(r){this._onParentResize();this._updatePaginatorButtonsTooltips();}this._setItemNavigation();};
j.prototype.exit=function(){this._detachResizeHandler();this._clearItemNavigation();this._oSplitterDelegate=null;};
j.prototype._setSplitterBarsTooltips=function(o,p){var s=o.$().find(" > .sapUiLoSplitterBar"),a=o.$().find(" > .sapUiLoSplitterContent"),t="",b,n,A,m;for(var i=0;i<a.length;i++){m=a[i].childNodes[0].id;A=C.byId(m);b=i+1;n=i+2;if(p){t+=this._oResourceBundle.getText("RESPONSIVE_SPLITTER_RESIZE",[p+"."+b,p+"."+n]);}else{t+=this._oResourceBundle.getText("RESPONSIVE_SPLITTER_RESIZE",[b,n]);}if(s[i]){s[i].setAttribute("title",t);t="";}if(A instanceof e){this._setSplitterBarsTooltips(A,b);}}};
j.prototype._updatePaginatorButtonsTooltips=function(){var v=Array.prototype.slice.call(this._getVisibleButtons()),H=this.getRootPaneContainer()._oSplitter.getAssociatedContentAreas().length,s=this._oResourceBundle.getText("RESPONSIVE_SPLITTER_HOME")+" ",a=this._oResourceBundle.getText("RESPONSIVE_SPLITTER_AND"),t="",b=this,o;if(v.length>0){o=v.shift();for(var i=1;i<=H;i++){s+=i;if(i<(H-1)){s+=", ";}else if(i===H-1){s+=" "+a+" ";}}o.setAttribute("title",s);[].forEach.call(v,function(B){t=b._oResourceBundle.getText("RESPONSIVE_SPLITTER_GOTO")+" "+(H+1);H+=1;B.setAttribute("title",t);});}};
j.prototype.onsapright=function(E){this._handleArrowNavigation(6,"Forward",E);};
j.prototype.onsapleft=function(E){this._handleArrowNavigation(0,"Back",E);};
j.prototype._setItemNavigation=function(){var b=this._getVisibleButtons(),D=[];this._oItemNavigation.setRootDomRef(this.$().find(".sapUiResponsiveSplitterPaginator")[0]);for(var i=0;i<b.length;i++){if(b[i]){D.push(b[i]);}}this._oItemNavigation.setItemDomRefs(D);this._oItemNavigation.setFocusedIndex(this._iDefaultPageIndex);};
j.prototype._clearItemNavigation=function(){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;};
j.prototype._handleArrowNavigation=function(b,D,E){if(E.target===this._getVisibleButtons()[b]){this["_handlePaginator"+D](E);this._setItemNavigation();}else{return;}};
j.prototype._onParentResize=function(){var i=this._intervalHasChanged(),r=this.getRootPaneContainer();if(i&&r){this._arrangeContent();this._setPaginatorVisibility();}};
j.prototype._detachResizeHandler=function(){if(this._parentResizeHandler){g.deregister(this._parentResizeHandler);this._parentResizeHandler=null;}};
j.prototype._createWidthIntervals=function(){var B=[];this._aIntervals=[];d.visitPanes(this.getRootPaneContainer(),function(p){var r=p.getRequiredParentWidth();if(B.indexOf(r)==-1){B.push(r);}});B.push(Number.NEGATIVE_INFINITY);B.push(Number.POSITIVE_INFINITY);B.sort(function(a,b){return a-b;});for(var i=0;i<B.length-1;i++){var o=new d.splitterInterval(B[i],B[i+1],this.getRootPaneContainer());this._aIntervals.push(o);}};
j.prototype._createPages=function(){var m=this._getMaxPageCount(),p=this.getAggregation("_pages")||[],i=p.length;if(i<m){while(i<m){i++;var o=new R();this.addAggregation("_pages",o,true);}}else if(i>m){while(i>m){i--;if(p[i].getDomRef()){h.preserveContent(p[i].getDomRef());}p[i].destroy();}}};
j.prototype._intervalHasChanged=function(){var w=this.getDomRef().clientWidth,o=null,a=this._aIntervals;for(var i=0;i<a.length;i++){if(a[i].iFrom<w&&w<=a[i].iTo){o=a[i];break;}}if(this._currentInterval!==o){this._currentInterval=o;return true;}return false;};
j.prototype._setPaginatorVisibility=function(){var b=this.$().find(".sapUiResponsiveSplitterPaginatorButton"),n=this.$().find(".sapUiResponsiveSplitterPaginatorNavButton"),p=this.$().find(".sapUiResponsiveSplitterPaginator"),i=(this._getHiddenPanes().length+1),m=this._getMaxPageCount(),s=i<k.MAX_VISIBLE_BUTTONS;b.addClass("sapUiResponsiveSplitterHiddenElement");if(m>1&&i>1){this.addStyleClass("sapUiRSVisiblePaginator");b=b.slice(0,s?i:k.MAX_VISIBLE_BUTTONS);b.removeClass("sapUiResponsiveSplitterHiddenElement");b.removeClass("sapUiResponsiveSplitterHiddenPaginatorButton");n.toggleClass("sapUiResponsiveSplitterHiddenPaginatorButton",s);p.toggleClass("sapUiResponsiveSplitterWithNavButtons",!s);}else{this.removeStyleClass("sapUiRSVisiblePaginator");}};
j.prototype._getMaxPageCount=function(){var t=0;this._aIntervals.forEach(function(i){if(i.iPagesCount>t){t=i.iPagesCount;}});return t;};
j.prototype._arrangeContent=function(){var p=this.getAggregation("_pages")||[],D=0,o=C.byId(this.getDefaultPane()),a,s,i;this._clearContent();p.forEach(function(b){b.setVisible(false);});this._fillPageContent(this.getRootPaneContainer());if(o){a=o.getContent();if(a){s=a.getId();for(i=0;i<p.length;i++){if(p[i].containsControl(s)){D=i;break;}}}}this._iDefaultPageIndex=D;this._activatePage(D);};
j.prototype._activatePage=function(p){var $=this.$().find(".sapUiResponsiveSplitterPaginatorButton"),o=this.$().find(".sapUiResponsiveSplitterPaginatorSelectedButton"),O=$.index(o),a=this.getAggregation("_pages")||[];a[O]&&a[O].setVisible(false);a[p]&&a[p].setVisible(true);o.removeClass("sapUiResponsiveSplitterPaginatorSelectedButton");$.eq(p).addClass("sapUiResponsiveSplitterPaginatorSelectedButton");o.attr("aria-checked",false);$.eq(p).attr("aria-checked",true);};
j.prototype._fillPageContent=function(s){var b=s instanceof P,a=s instanceof S,o=s.getParent(),m=o instanceof P,p=this.getAggregation("_pages"),H,n,q,D,r,M;if(b&&p){this._aPaneContainers.push(s);n=this._getAllPanesInInterval(s,this._currentInterval.iFrom).length>0;q=s._oSplitter;if(m&&n){o._oSplitter.addAssociatedContentArea(q);}else if(!m){p[0].setContent(q);}s.getPanes().forEach(function(t){this._fillPageContent(t);},this);}else if(a&&p){this._assignDefault(s);this._aPanes.push(s);D=s.getDemandPane();H=this._getHiddenPanes();r=H.length;M=this._getMaxPageCount();var i;if(s._isInInterval(this._currentInterval.iFrom)){o._oSplitter.addAssociatedContentArea(s.getContent());}else if(D&&(r<M)){for(i=0;i<r;i++){p[i+1].setContent(H[i].getContent());}}else if(D&&r===M){for(i=0;i<r;i++){p[i].setContent(H[i].getContent());}}else if(this._isDefault(s)){p[0].setContent(s.getContent());}}};
j.prototype._isDefault=function(p){return this.getDefaultPane()===p.getId();};
j.prototype._assignDefault=function(p){var D=this.getDefaultPane();this.setDefaultPane(D||p);};
j.prototype._getAllPanesInInterval=function(p,F){var a=[];function v(p){p.getPanes().forEach(function(o){if(o instanceof P){v(o);}else if(o._isInInterval(F)){a.push(o);}});return a;}return v(p,F);};
j.prototype._getHiddenPanes=function(){return this._aPanes.filter(function(p){return p.getDemandPane()&&!p._isInInterval(this._currentInterval.iFrom);},this);};
j.prototype._clearContent=function(){this._aPaneContainers.forEach(function(p){p._oSplitter.removeAllAssociatedContentAreas();});this._aPaneContainers=[];this._aPanes=[];};
j.prototype._getVisibleButtons=function(){return this.$().find(".sapUiResponsiveSplitterPaginatorButton:not(.sapUiResponsiveSplitterHiddenElement, .sapUiResponsiveSplitterHiddenPaginatorButton)");};
j.prototype._handlePaginatorButtonTap=function(E){var t=E.target,T=E.target.classList,p;if(T&&T.contains("sapUiResponsiveSplitterPaginatorButton")){p=parseInt(t.getAttribute("page-index"));this._activatePage(p);}else if(T&&T.contains("sapUiResponsiveSplitterPaginatorNavButton")){if(T.contains("sapUiResponsiveSplitterPaginatorButtonForward")){this._handlePaginatorForward(E);}else{this._handlePaginatorBack(E);}}};
j.prototype._handlePaginatorForward=function(E){var v=this._getVisibleButtons(),H=this._getHiddenPanes().length,$=this.$().find(".sapUiResponsiveSplitterPaginatorButton.sapUiResponsiveSplitterHiddenElement"),p,a=$.filter(function(){p=parseInt(this.getAttribute("page-index"));return p>=k.MAX_VISIBLE_BUTTONS&&p<=H;});if(a.length>0){v.first().addClass("sapUiResponsiveSplitterHiddenElement");a.last().removeClass("sapUiResponsiveSplitterHiddenElement");}};
j.prototype._handlePaginatorBack=function(E){var v=this._getVisibleButtons(),m=this._getMaxPageCount()-k.MAX_VISIBLE_BUTTONS,H=this.$().find(".sapUiResponsiveSplitterPaginatorButton.sapUiResponsiveSplitterHiddenElement"),$=H.filter(function(){return parseInt(this.getAttribute("page-index"))<m;});if($.length>0){v.last().addClass("sapUiResponsiveSplitterHiddenElement");$.last().removeClass("sapUiResponsiveSplitterHiddenElement");}};
j.prototype.ontap=j.prototype._handlePaginatorButtonTap;j.prototype.onsapenter=j.prototype._handlePaginatorButtonTap;j.prototype.onsapspace=j.prototype._handlePaginatorButtonTap;return j;});
sap.ui.predefine('sap/ui/layout/ResponsiveSplitterPage',["./library","sap/ui/core/Control","sap/ui/core/Core"],function(l,C,a){"use strict";
var R=C.extend("sap.ui.layout.ResponsiveSplitterPage",{
metadata:{library:"sap.ui.layout",associations:{content:{type:"sap.ui.core.Control",multiple:false,singularName:"content"}}},
renderer:{apiVersion:2,render:function(r,c){r.openStart("div",c).class("sapUiResponsiveSplitterPage").openEnd();var o=a.byId(c.getAssociation("content"));if(o){r.renderControl(o);}r.close("div");}}
});
R.prototype.containsControl=function(c){var o=a.byId(this.getAssociation("content"));if(!o){return false;}if(o.isA("sap.ui.layout.AssociativeSplitter")){return o.containsControl(c);}return o.getId()===c;};
return R;});
sap.ui.predefine('sap/ui/layout/ResponsiveSplitterRenderer',["sap/ui/core/Core","sap/ui/core/IconPool"],function(C,I){"use strict";var r=C.getLibraryResourceBundle("sap.ui.layout");var R={apiVersion:2};I.insertFontFaceStyle();
R.render=function(o,a){o.openStart("div",a).class("sapUiResponsiveSplitter").style("width",a.getWidth()).style("height",a.getHeight()).openEnd();var p=a.getAggregation("_pages");if(p){p.forEach(o.renderControl,o);this.renderPaginator(o,a);}o.close("div");};
R.renderPaginator=function(o,a){var m=a._getMaxPageCount(),p=a.getAggregation("_pages")||[];if(m<=1){return;}o.openStart("div").attr("role","navigation").class("sapUiResponsiveSplitterPaginator").openEnd();o.openStart("div").class("sapUiResponsiveSplitterPaginatorNavButton").class("sapUiResponsiveSplitterHiddenPaginatorButton").class("sapUiResponsiveSplitterPaginatorButtonBack").openEnd().close("div");o.openStart("div").class("sapUiResponsiveSplitterPaginatorButtons").attr("role","radiogroup").attr("aria-label",r.getText("RESPONSIVE_SPLITTER_ARIA_PAGINATOR_LABEL"));if(p.length>0){o.attr("aria-controls",p[0].getParent().getId());}o.openEnd();for(var i=0;i<m;i++){o.openStart("div").attr("tabindex",0).attr("page-index",i);if(i===0){o.class("sapUiResponsiveSplitterPaginatorSelectedButton");}o.class("sapUiResponsiveSplitterHiddenElement").class("sapUiResponsiveSplitterPaginatorButton").attr("role","radio").attr("aria-checked",false).openEnd().close("div");}o.close("div");o.openStart("div").class("sapUiResponsiveSplitterPaginatorNavButton").class("sapUiResponsiveSplitterHiddenPaginatorButton").class("sapUiResponsiveSplitterPaginatorButtonForward").openEnd().close("div");o.close("div");};
return R;},true);
sap.ui.predefine('sap/ui/layout/ResponsiveSplitterUtilities',[],function(){"use strict";var R={};
R.visitPanes=function(p,c){var P,o;if(!p){return;}P=p.getPanes();for(var i=0;i<P.length;i++){o=P[i];if(o instanceof sap.ui.layout.SplitPane){c(o);}else{R.visitPanes(o,c);}}};
R.splitterInterval=function(f,t,p){this.iFrom=f;this.iTo=t;this.iPagesCount=0;var m=[],P=[m];R.visitPanes(p,function(a){var w=a.getRequiredParentWidth();var b={demandPane:a.getDemandPane()};if(w<=f){m.push(b);}else{P.push(b);}});if(m.length==0){P.splice(0,1);}this.iPagesCount=P.length;this.aPages=P;};
return R;},true);
sap.ui.predefine('sap/ui/layout/SplitPane',['./library','sap/ui/core/Element'],function(l,E){"use strict";
var S=E.extend("sap.ui.layout.SplitPane",{metadata:{library:"sap.ui.layout",properties:{demandPane:{type:"boolean",group:"Behavior",defaultValue:true},requiredParentWidth:{type:"int",defaultValue:800}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:false,singularName:"content"}}}});
S.prototype.setLayoutData=function(L){var c=this.getContent();if(c){return c.setLayoutData(L);}this._oLayoutData=L;return this;};
S.prototype.getLayoutData=function(){var c=this.getContent();if(c){return c.getLayoutData();}return this._oLayoutData;};
S.prototype.setContent=function(c){if(this._oLayoutData){c.setLayoutData(this._oLayoutData);this._oLayoutData=null;}return this.setAggregation("content",c);};
S.prototype.onLayoutDataChange=function(){var p=this.getParent();if(p){p._oSplitter._delayedResize();}};
S.prototype._isInInterval=function(f){return this.getRequiredParentWidth()<=f;};
return S;});
sap.ui.predefine('sap/ui/layout/Splitter',['sap/ui/core/Control','./library','sap/ui/core/library','sap/ui/core/ResizeHandler','sap/ui/core/RenderManager','./SplitterRenderer',"sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/layout/SplitterLayoutData"],function(C,l,c,R,a,S,L,q,b){"use strict";var O=c.Orientation;var r=16;
var d=C.extend("sap.ui.layout.Splitter",{
metadata:{library:"sap.ui.layout",properties:{orientation:{type:"sap.ui.core.Orientation",group:"Behavior",defaultValue:O.Horizontal},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'100%'}},defaultAggregation:"contentAreas",aggregations:{contentAreas:{type:"sap.ui.core.Control",multiple:true,singularName:"contentArea"}},events:{resize:{parameters:{id:{type:"string"},oldSizes:{type:"int[]"},newSizes:{type:"int[]"}}}},designtime:"sap/ui/layout/designtime/Splitter.designtime"},
renderer:S
});
d.prototype.init=function(){this._liveResize=true;this._keyboardEnabled=true;this._bHorizontal=true;this._calculatedSizes=[];this._move={};this._resizeTimeout=null;this._resizeCallback=function(E){this._delayedResize(0);}.bind(this);this._resizeHandlerId=null;this._autoResize=true;this.enableAutoResize();this._boundBarMoveEnd=this._onBarMoveEnd.bind(this);this._boundBarMove=this._onBarMove.bind(this);this._initOrientationProperties();this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._keyListeners={increase:this._onKeyboardResize.bind(this,"inc",20),decrease:this._onKeyboardResize.bind(this,"dec",20),increaseMore:this._onKeyboardResize.bind(this,"incMore",20),decreaseMore:this._onKeyboardResize.bind(this,"decMore",20),max:this._onKeyboardResize.bind(this,"max",20),min:this._onKeyboardResize.bind(this,"min",20)};this._enableKeyboardListeners();};
d.prototype.exit=function(){this.disableAutoResize();delete this._resizeCallback;delete this._boundBarMoveEnd;delete this._boundBarMove;delete this._$SplitterOverlay;delete this._$SplitterOverlayBar;};
d.prototype.onBeforeRendering=function(){this._initOrientationProperties();};
d.prototype.onAfterRendering=function(){this._$SplitterOverlay=this.$("overlay");this._$SplitterOverlayBar=this.$("overlayBar");this._resize();};
d.prototype.triggerResize=function(f){if(f){this._resize();}else{this._delayedResize();}};
d.prototype.resetContentAreasSizes=function(){var f=this._getContentAreas();for(var i=0;i<f.length;i++){f[i].getLayoutData().setSize("auto");}};
d.prototype.getCalculatedSizes=function(){return this._calculatedSizes;};
d.prototype.enableAutoResize=function(t){if(t&&!this._autoResize){return;}this._autoResize=true;var f=this;sap.ui.getCore().attachInit(function(){f._resizeHandlerId=R.register(f,f._resizeCallback);});this._delayedResize();};
d.prototype.disableAutoResize=function(t){R.deregister(this._resizeHandlerId);if(!t){this._autoResize=false;}};
d.prototype.enableLiveResize=function(){this._liveResize=true;this.removeStyleClass("sapUiLoSplitterAnimated");};
d.prototype.disableLiveResize=function(){this._liveResize=false;this.addStyleClass("sapUiLoSplitterAnimated");};
d.prototype.enableKeyboardSupport=function(){var B=this.$().find(".sapUiLoSplitterBar");B.attr("tabindex","0");this._enableKeyboardListeners();};
d.prototype.disableKeyboardSupport=function(){var B=this.$().find(".sapUiLoSplitterBar");B.attr("tabindex","-1");this._disableKeyboardListeners();};
d.prototype.onLayoutDataChange=function(){this._delayedResize();};
d.prototype.ontouchstart=function(E){if(this._ignoreTouch){return;}var t=this._getBar(E.target);if(!t){return;}if(!E.changedTouches||!E.changedTouches[0]){return;}this._ignoreMouse=true;this._onBarMoveStart(E.changedTouches[0],t,true);};
d.prototype.onmousedown=function(E){if(this._ignoreMouse){return;}var t=this._getBar(E.target);if(!t){return;}this._ignoreTouch=true;this._onBarMoveStart(E,t);this._oLastDOMclicked=t;};
d.prototype._onBarMoveStart=function(E,B,t){var I=this.getId();this.disableAutoResize(true);var p=E[this._moveCord];var f=parseInt(B.id.substr((I+"-splitbar-").length));var $=q(B);var m=this.getCalculatedSizes();var g=this._bHorizontal?$.outerWidth():$.outerHeight();var h=this._getContentAreas();var o=h[f].getLayoutData();var j=h[f+1].getLayoutData();if(!o.getResizable()||!j.getResizable()){e(t);return;}var k=0-g;for(var i=0;i<=f;++i){k+=m[i]+g;}this._move={start:p,relStart:k,barNum:f,$bar:$,c1Size:m[f],c1MinSize:o.getMinSize(),c2Size:m[f+1],c2MinSize:j.getMinSize()};if(t){document.addEventListener("touchend",this._boundBarMoveEnd);document.addEventListener("touchmove",this._boundBarMove);}else{document.addEventListener("mouseup",this._boundBarMoveEnd);document.addEventListener("mousemove",this._boundBarMove);}this._$SplitterOverlay.css("display","block");this._$SplitterOverlayBar.css(this._sizeDirNot,"");this._move.$bar.css("visibility","hidden");this._onBarMove(E);};
d.prototype._onBarMove=function(E){if(E.preventDefault&&!(E.changedTouches)){E.preventDefault();}var o=E;if(E.changedTouches&&E.changedTouches[0]){o=o.changedTouches[0];}var p=o[this._moveCord];var D=(p-this._move.start);if(this.getOrientation()==O.Horizontal&&this._bRtl){D=-D;}var f=this._move.c1Size+D;var g=this._move.c2Size-D;var i=(f>=0&&g>=0&&f>=this._move.c1MinSize&&g>=this._move.c2MinSize);if(i){this._$SplitterOverlayBar.css(this._sizeDir,this._move.relStart+D);if(this._liveResize){var m=(this._move["start"]-o[this._moveCord]);if(this.getOrientation()==O.Horizontal&&this._bRtl){m=-m;}this._resizeContents(this._move["barNum"],-m,false);}}};
d.prototype._onBarMoveEnd=function(E){this._ignoreMouse=false;this._ignoreTouch=false;var o=E;if(E.changedTouches&&E.changedTouches[0]){o=o.changedTouches[0];}var p=o[this._moveCord];var m=this._move["start"]-p;if(this.getOrientation()==O.Horizontal&&this._bRtl){m=-m;}this._resizeContents(this._move["barNum"],-m,true);this._move.$bar.css("visibility","");this._$SplitterOverlay.css("display","");document.removeEventListener("mouseup",this._boundBarMoveEnd);document.removeEventListener("mousemove",this._boundBarMove);document.removeEventListener("touchend",this._boundBarMoveEnd);document.removeEventListener("touchmove",this._boundBarMove);this.enableAutoResize(true);if(this._move.$bar){this._move.$bar.trigger("focus");}};
d.prototype._resizeContents=function(i,p,f){if(isNaN(p)){L.warning("Splitter: Received invalid resizing values - resize aborted.");return;}var g=this._getContentAreas();var o=g[i].getLayoutData();var h=g[i+1].getLayoutData();var s=o.getSize();var j=h.getSize();var $=this.$("content-"+i);var k=this.$("content-"+(i+1));var n=this._move.c1Size+p;var N=this._move.c2Size-p;var m=o.getMinSize();var M=h.getMinSize();var D;if(n<m){D=m-n;p+=D;n=m;N-=D;}else if(N<M){D=M-N;p-=D;N=M;n-=D;}if(f){if(s==="auto"&&j!=="auto"){h.setSize(N+"px");}else if(s!=="auto"&&j==="auto"){o.setSize(n+"px");}else{o.setSize(n+"px");h.setSize(N+"px");}}else{$.css(this._sizeType,n+"px");k.css(this._sizeType,N+"px");}};
d.prototype._delayedResize=function(D){if(D===undefined){D=0;}if(this.getDomRef()){clearTimeout(this._resizeTimeout);this._resizeTimeout=setTimeout(this._resize.bind(this),D);}};
d.prototype._resizeBars=function(f){var i,B,s=this._bHorizontal?this.$().innerHeight():this.$().innerWidth();for(i=0;i<f.length-1;++i){B=this.$("splitbar-"+i);B.css(this._sizeTypeNot,"");}for(i=0;i<f.length-1;++i){B=this.$("splitbar-"+i);B.css(this._sizeType,"");B.css(this._sizeTypeNot,s+"px");}};
d.prototype._resize=function(){var D=this.getDomRef();if(!D||a.getPreserveAreaRef().contains(D)||D.scrollHeight===0||D.scrollWidth===0){return;}var i=0,B;var f=this._getContentAreas();this._resizeBars(f);var o=this.getCalculatedSizes();this._recalculateSizes();var n=this.getCalculatedSizes();var s=false;for(i=0;i<n.length;++i){if(n[i]!==0){s=true;break;}}if(!s){this._delayedResize(100);return;}var g=true;for(i=0;i<f.length;++i){var $=this.$("content-"+i);var h=f[i];$.css(this._sizeType,n[i]+"px");$.css(this._sizeTypeNot,"");var j=h.getLayoutData();var k=j&&j.getResizable();if(i>0){var m=k&&g;B=this.$("splitbar-"+(i-1));B.toggleClass("sapUiLoSplitterNoResize",!m);B.attr("tabindex",m&&this._keyboardEnabled?"0":"-1");}g=k;}this._resizeBars(f);if(_(o,n)){this.fireResize({oldSizes:o,newSizes:n});}};
d.prototype._getTotalSize=function(){return this._bHorizontal?this.$().innerWidth():this.$().innerHeight();};
d.prototype._calcAvailableContentSize=function(){return this._getTotalSize()-this._calcBarsSize();};
d.prototype._calcBarsSize=function(){var s=0,B=this._getContentAreas().length-1;for(var i=0;i<B;i++){s+=this._bHorizontal?this.$("splitbar-"+i).outerWidth():this.$("splitbar-"+i).outerHeight();}return s;};
d.prototype._recalculateSizes=function(){var i,A,f,m;var s=[];var g=this._getContentAreas();var h=this._calcAvailableContentSize();var j=[];var k=[];var p=[];this._calculatedSizes=[];for(i=0;i<g.length;++i){s.push(g[i].getLayoutData().getSize());}for(i=0;i<s.length;++i){var n=s[i];var o;if(n.indexOf("rem")>-1){o=parseFloat(n)*r;h-=o;this._calculatedSizes[i]=o;}else if(n.indexOf("px")>-1){o=parseInt(n);h-=o;this._calculatedSizes[i]=o;}else if(n.indexOf("%")>-1){p.push(i);}else if(n==="auto"){if(g[i].getLayoutData().getMinSize()!==0){k.push(i);}else{j.push(i);}}else{L.error("Illegal size value: "+s[i]);}}var w=false;if(h<0){w=true;h=0;}h=this._calcPercentBasedSizes(p,h);if(h<0){w=true;h=0;}var t=Math.floor(h/(k.length+j.length),0);for(i=0;i<k.length;++i){A=t;f=k[i];m=g[f].getLayoutData().getMinSize();if(A>h){A=h;}if(A<m){A=m;}this._calculatedSizes[f]=A;h-=A;}if(h<0){w=true;h=0;}var u=j.length;t=Math.floor(h/u,0);for(i=0;i<u;++i){f=j[i];this._calculatedSizes[f]=t;h-=t;}if(w){this._logConstraintsViolated();}};
d.prototype._calcPercentBasedSizes=function(p,f){var g=this._getContentAreas(),A=this._calcAvailableContentSize();for(var i=0;i<p.length;++i){var h=p[i];var j=parseFloat(g[h].getLayoutData().getSize())/100*A;var m=g[h].getLayoutData().getMinSize();if(j<m){j=m;}this._calculatedSizes[h]=j;f-=j;}return f;};
d.prototype._logConstraintsViolated=function(){L.warning("The set sizes and minimal sizes of the splitter contents are bigger than the available space in the UI.",null,"sap.ui.layout.Splitter");};
d.prototype._initOrientationProperties=function(){this._bHorizontal=this.getOrientation()===O.Horizontal;if(this._bHorizontal){this._sizeDirNot="top";this._sizeTypeNot="height";this._sizeType="width";this._moveCord="pageX";if(this._bRtl){this._sizeDir="right";}else{this._sizeDir="left";}}else{this._moveCord="pageY";this._sizeType="height";this._sizeTypeNot="width";this._sizeDir="top";this._sizeDirNot="left";}};
d.prototype._onKeyboardResize=function(t,s,E){var B=this.getId()+"-splitbar-";if(!E||!E.target||!E.target.id||E.target.id.indexOf(B)!==0){return;}var i=999999;var f=parseInt(E.target.id.substr(B.length));var m=this.getCalculatedSizes();this._move.c1Size=m[f];this._move.c2Size=m[f+1];var g=0;switch(t){case"inc":g=s;break;case"incMore":g=s*10;break;case"dec":g=0-s;break;case"decMore":g=0-s*10;break;case"max":g=i;break;case"min":g=0-i;break;default:L.warn("[Splitter] Invalid keyboard resize type");break;}this._resizeContents(f,g,true);};
d.prototype._enableKeyboardListeners=function(){this.onsapright=this._keyListeners.increase;this.onsapdown=this._keyListeners.increase;this.onsapleft=this._keyListeners.decrease;this.onsapup=this._keyListeners.decrease;this.onsappageup=this._keyListeners.decreaseMore;this.onsappagedown=this._keyListeners.increaseMore;this.onsapend=this._keyListeners.max;this.onsaphome=this._keyListeners.min;this._keyboardEnabled=true;};
d.prototype._disableKeyboardListeners=function(){delete this.onsapincreasemodifiers;delete this.onsapdecreasemodifiers;delete this.onsapendmodifiers;delete this.onsaphomemodifiers;this._keyboardEnabled=false;};
d.prototype._getBar=function(t){var B=t,i=this.getId();if(B.classList.contains("sapUiLoSplitterBarGripIcon")){B=t.parentElement;}if(B.classList.contains("sapUiLoSplitterBarDecorationBefore")||B.classList.contains("sapUiLoSplitterBarDecorationAfter")||B.classList.contains("sapUiLoSplitterBarGrip")){B=B.parentElement;}if(!B.id||B.id.indexOf(i+"-splitbar")!==0){return null;}return B;};
function _(s,f){if(s===f){return false;}if(!s||!f||s.length===undefined||f.length===undefined){return true;}if(s.length!=f.length){return true;}for(var i=0;i<s.length;++i){if(s[i]!==f[i]){return true;}}return false;}
function e(t){var p=function(E){if(!t){E.preventDefault();}};var A=null;A=function(){document.removeEventListener("touchend",A);document.removeEventListener("touchmove",p);document.removeEventListener("mouseup",A);document.removeEventListener("mousemove",p);};if(t){this._ignoreMouse=true;document.addEventListener("touchend",A);document.addEventListener("touchmove",p);}else{document.addEventListener("mouseup",A);document.addEventListener("mousemove",p);}}
d.prototype._ensureLayoutData=function(o){var f=o.getLayoutData();if(f&&(!f.getResizable||!f.getSize||!f.getMinSize)){L.warning("Content \""+o.getId()+"\" for the Splitter contained wrong LayoutData. "+"The LayoutData has been replaced with default values.");f=null;}if(!f){o.setLayoutData(new b());}};
d.prototype.invalidate=function(o){var f=(o&&this.indexOfContentArea(o)!=-1)||(o&&o instanceof sap.ui.core.CustomData&&o.getWriteToDom())||(o===undefined);if(f){C.prototype.invalidate.apply(this,arguments);}};
d.prototype.addContentArea=function(o){this._ensureLayoutData(o);return this.addAggregation("contentAreas",o);};
d.prototype.insertContentArea=function(o,i){this._ensureLayoutData(o);return this.insertAggregation("contentAreas",o,i);};
d.prototype._getContentAreas=function(){return this.getContentAreas();};
return d;});
sap.ui.predefine('sap/ui/layout/SplitterLayoutData',['sap/ui/core/LayoutData','./library'],function(L,l){"use strict";
var S=L.extend("sap.ui.layout.SplitterLayoutData",{metadata:{library:"sap.ui.layout",properties:{resizable:{type:"boolean",group:"Behavior",defaultValue:true},size:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},minSize:{type:"int",group:"Dimension",defaultValue:0}}}});
S.prototype.init=function(){L.prototype.init.apply(this,arguments);this._bIsModified=false;};
S.prototype._markModified=function(){this._bIsModified=true;};
S.prototype._isMarked=function(){return this._bIsModified;};
return S;});
sap.ui.predefine('sap/ui/layout/SplitterRenderer',["sap/ui/core/library","sap/ui/core/Core"],function(c,C){"use strict";var O=c.Orientation;var r=C.getLibraryResourceBundle("sap.ui.layout");var S={apiVersion:2};
S.render=function(R,s){var h=s.getOrientation()===O.Horizontal,o=h?"sapUiLoSplitterH":"sapUiLoSplitterV",a=C.getConfiguration().getAnimation();R.openStart("div",s).class("sapUiLoSplitter").class(o);if(a&&!s._liveResize){R.class("sapUiLoSplitterAnimated");}R.style("width",s.getWidth()).style("height",s.getHeight()).openEnd();this.renderContentAreas(R,s);R.close("div");};
S.renderContentAreas=function(R,s){var I=s.getId(),h=s.getOrientation()===O.Horizontal,a=h?"width":"height",b=s._getContentAreas(),l=b.length,d=s.getCalculatedSizes();b.forEach(function(o,i){var L=o.getLayoutData(),e="0";if(d[i]){e=d[i]+"px";}else if(L){e=L.getSize();}R.openStart("section",I+"-content-"+i).style(a,e).class("sapUiLoSplitterContent").openEnd();R.renderControl(o);R.close("section");if(i<l-1){S.renderBar(R,h,s.getId()+"-splitbar-"+i,"sapUiLoSplitterBar");}});R.openStart("div",I+"-overlay").class("sapUiLoSplitterOverlay").openEnd();S.renderBar(R,h,I+"-overlayBar","sapUiLoSplitterOverlayBar");R.close("div");};
S.renderBar=function(R,h,b,s){R.openStart("div",b).attr("role","separator").attr("title",r.getText("SPLITTER_MOVE")).attr("aria-orientation",(h?"vertical":"horizontal")).attr("tabindex",0).class(s).openEnd();S.renderBarGripAndDecorations(R,h);R.close("div");};
S.renderBarGripAndDecorations=function(R,h){var i=h?"sap-icon://vertical-grip":"sap-icon://horizontal-grip";R.openStart("div").class("sapUiLoSplitterBarDecorationBefore").openEnd().close("div");R.openStart("div").class("sapUiLoSplitterBarGrip").openEnd().icon(i,["sapUiLoSplitterBarGripIcon"]).close("div");R.openStart("div").class("sapUiLoSplitterBarDecorationAfter").openEnd().close("div");};
return S;},true);
sap.ui.predefine('sap/ui/layout/VerticalLayout',['sap/ui/core/Control','sap/ui/core/EnabledPropagator','./library',"./VerticalLayoutRenderer"],function(C,E,l,V){"use strict";
var a=C.extend("sap.ui.layout.VerticalLayout",{metadata:{library:"sap.ui.layout",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},dnd:{draggable:false,droppable:true},designtime:"sap/ui/layout/designtime/VerticalLayout.designtime"}});
a.prototype.getAccessibilityInfo=function(){return{children:this.getContent()};};
E.call(a.prototype);return a;});
sap.ui.predefine('sap/ui/layout/VerticalLayoutRenderer',[],function(){"use strict";var V={apiVersion:2};
V.render=function(r,v){var a=r;a.openStart("div",v);a.class("sapUiVlt");a.class("sapuiVlt");if(v.getWidth()&&v.getWidth()!=''){a.style("width",v.getWidth());}a.openEnd();var c=v.getContent();for(var i=0;i<c.length;i++){a.openStart("div");a.class("sapUiVltCell");a.class("sapuiVltCell");a.openEnd();a.renderControl(c[i]);a.close("div");}a.close("div");};
return V;},true);
sap.ui.predefine('sap/ui/layout/changeHandler/AddFormContainer',["sap/ui/fl/changeHandler/Base","sap/ui/core/util/reflection/JsControlTreeModifier","sap/base/Log","sap/ui/thirdparty/jquery"],function(B,J,L,q){"use strict";var A={};
A.applyChange=function(c,f,p){var m=p.modifier;var a=p.appComponent;var v=p.view;var C=c.getDefinition();if(C.texts&&C.texts.groupLabel&&C.texts.groupLabel.value&&C.content&&C.content.group&&(C.content.group.selector||C.content.group.id)){var t=C.texts.groupLabel.value;var i=C.content.group.index;var n=C.content.group.selector||{id:C.content.group.id};var N=q.extend({},n);N.id=N.id+"--title";c.setRevertData({newGroupSelector:n});if(m.bySelector(N,a)){return B.markAsNotApplicable("Control to be created already exists:"+N);}else if(m.bySelector(n,a)){return B.markAsNotApplicable("Control to be created already exists:"+n);}return Promise.resolve().then(function(){return Promise.all([m.createControl("sap.ui.core.Title",a,v,N),m.createControl("sap.ui.layout.form.FormContainer",a,v,n)]);}).then(function(b){var T=b[0];var g=b[1];m.setProperty(T,"text",t);return Promise.resolve().then(m.insertAggregation.bind(m,g,"title",T,0,v)).then(m.insertAggregation.bind(m,f,"formContainers",g,i,v));});}else{L.error("Change does not contain sufficient information to be applied: ["+C.layer+"]"+C.namespace+"/"+C.fileName+"."+C.fileType);return Promise.resolve();}};
A.completeChangeContent=function(c,s,p){var C=c.getDefinition();var a=p.appComponent;if(s.newLabel){B.setTextInChange(C,"groupLabel",s.newLabel,"XFLD");}else{throw new Error("Cannot create a new group: oSpecificChangeInfo.groupLabel attribute required");}if(!C.content){C.content={};}if(!C.content.group){C.content.group={};}if(s.index===undefined){throw new Error("Cannot create a new group: oSpecificChangeInfo.index attribute required");}else{C.content.group.index=s.index;}if(s.newControlId){C.content.group.selector=J.getSelector(s.newControlId,a);}else{throw new Error("Cannot create a new group: oSpecificChangeInfo.newControlId attribute required");}};
A.revertChange=function(c,f,p){var a=p.appComponent;var v=p.view;var m=p.modifier;var n=c.getRevertData().newGroupSelector;var g=m.bySelector(n,a,v);return Promise.resolve().then(function(){return m.removeAggregation(f,"formContainers",g);}).then(function(){m.destroy(g);c.resetRevertData();});};
return A;},true);
sap.ui.predefine('sap/ui/layout/changeHandler/AddFormField',["sap/ui/fl/changeHandler/BaseAddViaDelegate"],function(B){"use strict";var A=B.createAddViaDelegateChangeHandler({addProperty:function(p){var i=p.innerControls;var m=p.modifier;var v=p.view;var a=p.appComponent;var c=p.change;var C=c.getContent();var I=C.newFieldIndex;var f=C.newFieldSelector;var o;var P;return Promise.resolve().then(function(){if(!i.layoutControl){return Promise.resolve().then(m.createControl.bind(m,"sap.ui.layout.form.FormElement",a,v,f)).then(function(b){o=b;return Promise.all([m.insertAggregation(o,"label",i.label,0,v),m.insertAggregation(o,"fields",i.control,0,v)]);});}o=i.control;return undefined;}).then(function(){P=c.getDependentControl("parentFormContainer",p);return m.insertAggregation(P,"formElements",o,I,v);}).then(function(){if(i.valueHelp){return m.insertAggregation(P,"dependents",i.valueHelp,0,v);}return undefined;});},aggregationName:"formElements",parentAlias:"parentFormContainer",fieldSuffix:"-field",supportsDefault:true});return A;},true);
sap.ui.predefine('sap/ui/layout/changeHandler/AddSimpleFormField',["sap/ui/fl/changeHandler/BaseAddViaDelegate","sap/ui/core/util/reflection/JsControlTreeModifier"],function(B,J){"use strict";var t="sap.ui.core.Title";var T="sap.m.Toolbar";var s="sap.m.Label";var a="sap.ui.comp.smartfield.SmartLabel";
function g(c,p){var C=p.change;var m=p.modifier;var b=C.getContent();var d=b.newFieldIndex;var o=C.getDependentControl("targetContainerHeader",p);var I=c.indexOf(o);var n=0;var f=0;if(c.length===1||c.length===I+1){n=c.length;}else{var j=0;for(j=I+1;j<c.length;j++){var e=m.getControlType(c[j]);if(e===s||e===a){if(f===d){n=j;break;}f++;}if(e===t||e===T){n=j;break;}if(j===(c.length-1)){n=c.length;}}}return n;}
function i(c,n,I){var C=c.slice();C.splice(n,0,I.label,I.control);return C;}
function r(S,c,m,p){return c.reduce(function(P,C,I){return P.then(function(){return m.insertAggregation(S,"content",C,I,p.view);});},Promise.resolve());}
var A=B.createAddViaDelegateChangeHandler({addProperty:function(p){var S=p.control;var I=p.innerControls;var m=p.modifier;var o=p.appComponent;var c;var n;var C;var b=p.change;var R=b.getRevertData();R.labelSelector=m.getSelector(I.label,o);return Promise.resolve().then(m.getAggregation.bind(m,S,"content")).then(function(d){c=d;n=g(c,p);C=i(c,n,I);return m.removeAllAggregation(S,"content");}).then(function(){return r(S,C,m,p);}).then(function(){if(I.valueHelp){return m.insertAggregation(S,"dependents",I.valueHelp,0,p.view);}return undefined;});},revertAdditionalControls:function(p){var S=p.control;var c=p.change;var m=p.modifier;var o=p.appComponent;var l=c.getRevertData().labelSelector;if(l){var L=m.bySelector(l,o);return Promise.resolve().then(m.removeAggregation.bind(m,S,"content",L)).then(m.destroy.bind(m,L));}return Promise.resolve();},aggregationName:"content",mapParentIdIntoChange:function(c,S,p){var o=p.appComponent;var v=p.view;var f=p.modifier.bySelector(S.parentId,o,v);var b=f.getTitle()||f.getToolbar();if(b){c.addDependentControl(b.getId(),"targetContainerHeader",p);}},parentAlias:"_",fieldSuffix:"",skipCreateLayout:true,supportsDefault:true});
A.getChangeVisualizationInfo=function(c,o){var R=c.getRevertData();if(R&&R.labelSelector){return{affectedControls:[J.bySelector(R.labelSelector,o).getParent().getId()]};}return{affectedControls:[c.getContent().newFieldSelector]};};
return A;},true);
sap.ui.predefine('sap/ui/layout/changeHandler/AddSimpleFormGroup',["sap/ui/fl/changeHandler/Base","sap/ui/core/util/reflection/JsControlTreeModifier","sap/base/Log"],function(B,J,L){"use strict";var A={};A.CONTENT_AGGREGATION="content";var f=function(M,s,c){return c.reduce(function(p,C){return p.then(function(r){if(r!==undefined){return r;}var t=M.getControlType(C);if(s.indexOf(t)===-1){return Promise.resolve().then(M.getVisible.bind(M,C)).then(function(v){return v||undefined;});}else{return false;}});},Promise.resolve());};var m=function(M,s,c,g){var r;var C=-1;if(g===0){return g;}return f(M,s,c).then(function(F){if(F){C++;}for(var i=0;i<c.length;i++){var t=M.getControlType(c[i]);if(s.indexOf(t)>-1){C++;if(C===g){r=c[i];return c.indexOf(r);}}}return c.length;});};
A.applyChange=function(c,F,p){var M=p.modifier;var v=p.view;var a=p.appComponent;var i;var C=c.getDefinition();if(C.texts&&C.texts.groupLabel&&C.texts.groupLabel.value&&C.content&&C.content.group&&(C.content.group.selector||C.content.group.id)){var g=C.content.group.selector;var G;if(g){if(g.idIsLocal){G=a.createId(g.id);}else{G=g.id;}}else{G=C.content.group.id;}c.setRevertData({groupId:G});var l=C.texts.groupLabel.value;var r;return Promise.resolve().then(function(){return M.getAggregation(F,A.CONTENT_AGGREGATION);}).then(function(b){if(typeof C.content.group.index==="number"){return C.content.group.index;}else{r=C.content.group.relativeIndex;return m(M,["sap.ui.core.Title","sap.m.Title","sap.m.Toolbar","sap.m.OverflowToolbar"],b,r);}}).then(function(R){i=R;if(M.bySelector(G,a)){return B.markAsNotApplicable("Control to be created already exists:"+G);}return M.createControl("sap.ui.core.Title",a,v,G);}).then(function(t){M.setProperty(t,"text",l);return M.insertAggregation(F,"content",t,i,v);});}else{L.error("Change does not contain sufficient information to be applied: ["+C.layer+"]"+C.namespace+"/"+C.fileName+"."+C.fileType);}};
A.completeChangeContent=function(c,s,p){var C=c.getDefinition();var a=p.appComponent;if(s.newLabel){B.setTextInChange(C,"groupLabel",s.newLabel,"XFLD");}else{throw new Error("oSpecificChangeInfo.newLabel attribute required");}if(!C.content){C.content={};}if(!C.content.group){C.content.group={};}if(s.newControlId){C.content.group.selector=J.getSelector(s.newControlId,a);}else{throw new Error("oSpecificChangeInfo.newControlId attribute required");}if(s.index===undefined){throw new Error("oSpecificChangeInfo.index attribute required");}else{C.content.group.relativeIndex=s.index;}};
A.getControlIdFromChangeContent=function(c){var C;if(c&&c._oDefinition){C=c._oDefinition.content.group.id;}return C;};
A.revertChange=function(c,F,p){var a=p.appComponent;var v=p.view;var M=p.modifier;var g=c.getRevertData().groupId;var G=M.getSelector(g,a);var o=M.bySelector(G,a,v);return Promise.resolve().then(function(){return M.removeAggregation(F,A.CONTENT_AGGREGATION,o);}).then(function(){M.destroy(o);c.resetRevertData();});};
A.getChangeVisualizationInfo=function(c,a){var s=c.getDefinition().content.group.selector;var o=J.bySelector(s,a).getParent().getId();return{affectedControls:[o]};};
return A;},true);
sap.ui.predefine('sap/ui/layout/changeHandler/HideSimpleForm',["sap/ui/core/util/reflection/JsControlTreeModifier","sap/base/Log"],function(J,L){"use strict";var H={};var I=function(c,m){var C=m.getControlType(c);return(C==="sap.ui.core.Title")||(C==="sap.m.Title")||(C==="sap.m.Toolbar")||(C==="sap.m.OverflowToolbar");};var g=function(c,m){var i;for(i=0;i<c.length;++i){if(I(c[i],m)){return c[i];}}return undefined;};
function _(p){return p.modifier.targets==="xmlTree";}
H.applyChange=function(c,C,p){var m=p.modifier;var v=p.view;var a=p.appComponent;var o=c.getDefinition();if(_(p)){return Promise.reject(Error("Change cannot be applied in XML. Retrying in JS."));}var r=m.bySelector(o.content.elementSelector||o.content.sHideId,a,v);var b;return this._getState(C,m,a).then(function(s){c.setRevertData(s);return m.getAggregation(C,"content");}).then(function(A){b=A;return m.removeAllAggregation(C,"content");}).then(function(){return b.reduce(function(P,d,i){return P.then(m.insertAggregation.bind(m,C,"content",d,i,v));},Promise.resolve());}).then(function(){var s=-1;if(o.changeType==="hideSimpleFormField"){b.some(function(F,i){if(F===r){s=i;m.setVisible(F,false);}if(s>=0&&i>s){if((m.getControlType(F)==="sap.m.Label")||(m.getControlType(F)==="sap.ui.comp.smartfield.SmartLabel")||I(F,m)){return true;}else{m.setVisible(F,false);}}});}else if(o.changeType==="removeSimpleFormGroup"){var P=[];var t=g(b,m);var f=t&&!r;b.some(function(F,i){if(!t){m.setVisible(F,false);}else if(f){s=0;m.setVisible(F,false);f=false;}else{if(F===r){s=i;}if(s>=0&&i>s){if(I(F,m)){if(s===0){P.push(function(){return Promise.resolve().then(m.removeAggregation.bind(m,C,"content",F,v));});P.push(function(){return Promise.resolve().then(m.insertAggregation.bind(m,C,"content",F,0,v));});}return true;}else{m.setVisible(F,false);}}}});if(r){P.push(function(){return Promise.resolve().then(m.removeAggregation.bind(m,C,"content",r,v));});P.push(function(){return Promise.resolve().then(m.insertAggregation.bind(m,C,"dependents",r,0,v));});}if(P.length>0){return P.reduce(function(d,e){return d.then(e);},Promise.resolve());}}return Promise.resolve();}).catch(function(e){c.resetRevertData();L.error(e.message||e.name);});};
H._getStableElement=function(e){if(e.getMetadata().getName()==="sap.ui.layout.form.FormContainer"){return e.getTitle()||e.getToolbar();}else if(e.getMetadata().getName()==="sap.ui.layout.form.FormElement"){return e.getLabel();}else{return e;}};
H.completeChangeContent=function(c,s,p){var C=c.getDefinition();if(s.removedElement&&s.removedElement.id){var S=this._getStableElement(sap.ui.getCore().byId(s.removedElement.id));C.content.elementSelector=J.getSelector(S,p.appComponent);c.addDependentControl(S,"elementSelector",p);}else{throw new Error("oSpecificChangeInfo.removedElement.id attribute required");}};
H._getState=function(c,m,a){return Promise.resolve().then(function(){return m.getAggregation(c,"content");}).then(function(C){if(!C){return Promise.reject(new Error("Cannot get control state: 'content' aggregation doesn't exist"));}return{content:C.map(function(e){return{elementSelector:m.getSelector(m.getId(e),a),visible:e.getVisible?e.getVisible():undefined,index:C.indexOf(e)};})};});};
H.revertChange=function(c,C,p){var s=c.getRevertData();var a=p.appComponent;var m=p.modifier;return Promise.resolve().then(m.removeAllAggregation.bind(m,C,"content")).then(function(){return s.content.reduce(function(P,e){var E=m.bySelector(e.elementSelector,a,p.view);var b=m.getId(E);return P.then(m.getAggregation.bind(m,C,"dependents")).then(function(d){var o=Promise.resolve();d.some(function(D){var f=m.getId(D);if(f===b){o=o.then(m.removeAggregation.bind(m,C,"dependents",D,p.view));return true;}});return o;}).then(m.insertAggregation.bind(m,C,"content",E,e.index,p.view)).then(function(){m.setProperty(E,"visible",e.visible);});},Promise.resolve()).then(function(){c.resetRevertData();});});};
H.getChangeVisualizationInfo=function(c,a){var s=c.getDefinition().content.elementSelector;var e=J.bySelector(s,a);var d=c.getChangeType()==="removeSimpleFormGroup"?e.getParent().getId():e.getParent().getParent().getId();return{affectedControls:[s],displayControls:[d]};};
return H;},true);
sap.ui.predefine('sap/ui/layout/changeHandler/MoveSimpleForm',["sap/ui/core/util/reflection/JsControlTreeModifier","sap/base/util/uid","sap/base/Log"],function(J,u,L){"use strict";var M={};M.CHANGE_TYPE_MOVE_FIELD="moveSimpleFormField";M.CHANGE_TYPE_MOVE_GROUP="moveSimpleFormGroup";M.sTypeTitle="sap.ui.core.Title";M.sTypeMTitle="sap.m.Title";M.sTypeToolBar="sap.m.Toolbar";M.sTypeOverflowToolBar="sap.m.OverflowToolbar";M.sTypeLabel="sap.m.Label";M.sTypeSmartLabel="sap.ui.comp.smartfield.SmartLabel";M.CONTENT_AGGREGATION="content";
function f(o,s,C){return C.reduce(function(p,i){return p.then(function(R){if(R!==undefined){return R;}var t=o.getControlType(i);if(s.indexOf(t)===-1){return Promise.resolve().then(o.getVisible.bind(o,i)).then(function(v){return v||undefined;});}else{return false;}});},Promise.resolve());}
function a(C,o,i,s,p,S,G){return f(o,S,i).then(function(F){if(F){var v=p.view;var A=p.appComponent;var t;return Promise.resolve().then(o.createControl.bind(o,"sap.ui.core.Title",A,v,G)).then(function(l){t=l;o.setProperty(t,"text","");return o.insertAggregation(s,"content",t,0,v);}).then(function(){var n=C.getRevertData();n.createdTitleSelector=p.modifier.getSelector(t,p.appComponent);C.setRevertData(n);});}return Promise.resolve();}).then(function(){return o.getAggregation(s,"content");});}
function m(o,s,C,G){var R;var l=-1;return f(o,s,C).then(function(F){if(F){l++;}for(var i=0;i<C.length;i++){var t=o.getControlType(C[i]);if(s.indexOf(t)>-1){l++;if(l===G){R=C[i];break;}}}return C.indexOf(R);});}
function b(E,i,o){if(i>=E.length||i===-1){return true;}var t=o.getControlType(E[i]);return(M.sTypeTitle===t||M.sTypeToolBar===t||M.sTypeMTitle===t||M.sTypeOverflowToolBar===t);}
function c(o,l,C,s){var i=0;for(i=l+1;i<C.length;++i){var t=o.getControlType(C[i]);if(s.indexOf(t)>-1){break;}}return i-l;}
function g(o,E,i){return c(o,i,E,[M.sTypeTitle,M.sTypeMTitle,M.sTypeToolBar,M.sTypeOverflowToolBar,M.sTypeLabel,M.sTypeSmartLabel]);}
function d(o,C,G,F,U){if(!b(C,G,o)){L.error("Illegal argument. iIndex has to point to a Label.");}else{F=U?F+1:F;var i=0;var A=G;var l;while(A<C.length&&i<F){++i;l=g(o,C,A);A+=l;}return A;}}
function e(s,S,t,T,l){var R=t;for(var i=0;i<l;i++){R.splice(T+i,0,s[S+i]);}return R;}
function h(H){var R=H.getTitle();if(!R){R=H.getToolbar();}return R;}
function j(s,i,p){var o=h(i.element);var S=p.modifier.getSelector(s,p.appComponent);var l={elementSelector:p.modifier.getSelector(o,p.appComponent),source:{groupIndex:i.sourceIndex},target:{groupIndex:i.targetIndex}};return{changeType:M.CHANGE_TYPE_MOVE_GROUP,targetSelector:S,movedControl:o,movedElements:[l]};}
function k(s,i,S,t,p){var o=p.modifier.getSelector(s,p.appComponent);var l=i.element.getLabel();var n=p.modifier.getSelector(l,p.appComponent);var T=h(t.parent);var q=h(S.parent);var v=p.modifier.getSelector(T,p.appComponent);var w=p.modifier.getSelector(q,p.appComponent);var x={elementSelector:n,source:{groupSelector:w,fieldIndex:i.sourceIndex},target:{groupSelector:v,fieldIndex:i.targetIndex}};return{changeType:M.CHANGE_TYPE_MOVE_FIELD,targetSelector:o,target:T,source:q,movedControl:l,movedElements:[x]};}
function r(o,s,M,C,v){return Promise.resolve().then(o.removeAllAggregation.bind(o,s,M.CONTENT_AGGREGATION)).then(function(){return C.reduce(function(p,i,I){return p.then(o.insertAggregation.bind(o,s,M.CONTENT_AGGREGATION,i,I,v));},Promise.resolve());});}
M.applyChange=function(C,s,p){var o=p.modifier;var v=p.view;var A=p.appComponent;var t;var i;var l;var n=C.getContent();var q=n.movedElements[0];return Promise.resolve().then(function(){return o.getAggregation(s,M.CONTENT_AGGREGATION);}).then(function(w){var x=w.map(function(R){return o.getSelector(R,A);});var S={content:x};C.setRevertData(S);if(C.getChangeType()===M.CHANGE_TYPE_MOVE_FIELD){var y=o.bySelector(q.elementSelector||q.element,A,v);var z=w.indexOf(y);var B=g(o,w,z);t=o.bySelector(q.target.groupSelector||q.target.groupId,A,v);var T=w.indexOf(t);var D=o.bySelector(q.source.groupSelector||q.source.groupId,A,v);var E=w.indexOf(D);var F=d(o,w,T,q.target.fieldIndex,(E===T)&&(q.source.fieldIndex<q.target.fieldIndex));var G=g(o,w,F);i=w.slice();var H=i.slice(z,z+B);var I,K,N,O;if(z<F){I=i.slice(0,z);N=i.slice(z+B,F+G);O=i.slice(F+G,i.length);i=I.concat(N.concat(H.concat(O)));}else if(z>F){K=i.slice(0,F+G);N=i.slice(F+G,z);O=i.slice(z+B,i.length);i=K.concat(H.concat(N.concat(O)));}if(z!=F){return r(o,s,M,i,v);}}else if(C.getChangeType()===M.CHANGE_TYPE_MOVE_GROUP){var P=[M.sTypeTitle,M.sTypeToolBar,M.sTypeMTitle,M.sTypeOverflowToolBar];var Q=o.bySelector(q.elementSelector||q.element,A,v);return Promise.resolve().then(function(){if(q.target.groupIndex===0||!Q){return a(C,o,w,s,p,P,n.newControlId).then(function(R){w=R;});}return undefined;}).then(function(){l=Q?w.indexOf(Q):0;return m(o,P,w,q.target.groupIndex);}).then(function(R){t=w[R];var U=c(o,R,w,P);var V=c(o,l,w,P);i=w.slice();i.splice(l,V);R=i.indexOf(t);var W=q.source.groupIndex<q.target.groupIndex?U:0;i=e(w,l,i,R+W,V);return r(o,s,M,i,v);});}else{L.warning("Unknown change type detected. Cannot apply to SimpleForm");}});};
M.completeChangeContent=function(C,s,p){var S;var o=p.modifier;var v=p.view;var A=p.appComponent;var i=o.bySelector(s.selector,A,v);var l=s.movedElements;if(l.length>1){L.warning("Moving more than 1 Formelement is not yet supported.");}var n=l[0];n.element=sap.ui.getCore().byId(n.id);var q=Object.assign({},s.source);var t=Object.assign({},s.target);if(!t.parent){t.parent=sap.ui.getCore().byId(t.id);}if(!q.parent){q.parent=sap.ui.getCore().byId(q.id);}if(i&&n.element&&t.parent){if(s.changeType==="moveSimpleFormGroup"){S=j(i,n,p);}else if(s.changeType==="moveSimpleFormField"){S=k(i,n,q,t,p);}}else{L.error("Element not found. This may be caused by an unstable id!");}var w=C.getDefinition();w.content.targetSelector=S.targetSelector;w.content.movedElements=S.movedElements;w.content.newControlId=o.getSelector(v.createId(u()),A);if(S.source&&S.target){C.addDependentControl(S.source,"sourceParent",p);C.addDependentControl(S.target,"targetParent",p);}C.addDependentControl([S.movedControl],"movedElements",p);};
M.revertChange=function(C,s,p){var o=p.modifier;var A=p.appComponent;var v=p.view;var R=C.getRevertData();var i=R.content;var l=i.map(function(S){return o.bySelector(S,A,v);});return r(o,s,M,l,v).then(function(){var n=R.createdTitleSelector;var q=p.modifier.bySelector(n,p.appComponent);if(q){q.destroy();}C.resetRevertData();return true;});};
M.getChangeVisualizationInfo=function(C,A){var o=C.getContent().movedElements[0];var G=o.source.groupSelector;var i=J.bySelector(o.elementSelector,A).getParent().getId();return{affectedControls:[i],dependentControls:[G&&G.id?G:C.getContent().targetSelector]};};
return M;},true);
sap.ui.predefine('sap/ui/layout/changeHandler/RenameFormContainer',["sap/ui/fl/changeHandler/Base","sap/base/Log"],function(B,L){"use strict";var R={};var _={TARGET_ALIAS:"target"};
R.applyChange=function(c,C,p){var m=p.modifier,o=c.getDefinition(),r=c.getDependentControl(_.TARGET_ALIAS,p);return Promise.resolve().then(function(){return m.getAggregation(r,"title");}).then(function(t){if(o.texts&&o.texts.formText&&this._isProvided(o.texts.formText.value)){var v=o.texts.formText.value;var a;if(typeof t==="string"){a=Promise.resolve(m.getProperty(r,"title")).then(function(T){c.setRevertData(T);m.setProperty(r,"title",v);});}else{a=Promise.resolve(m.getProperty(t,"text")).then(function(T){c.setRevertData(T);m.setProperty(t,"text",v);});}return a;}else{L.error("Change does not contain sufficient information to be applied: ["+o.layer+"]"+o.namespace+"/"+o.fileName+"."+o.fileType);}}.bind(this));};
R.completeChangeContent=function(c,s,p){var C=c.getDefinition();if(!(s.renamedElement&&s.renamedElement.id)){throw new Error("Rename of the group cannot be executed: oSpecificChangeInfo.renamedElement attribute required");}if(!this._isProvided(s.value)){throw new Error("Rename of the group cannot be executed: oSpecificChangeInfo.value attribute required");}c.addDependentControl(s.renamedElement.id,_.TARGET_ALIAS,p);B.setTextInChange(C,"formText",s.value,"XGRP");};
R.revertChange=function(c,C,p){var o=c.getRevertData(),m=p.modifier,r=c.getDependentControl(_.TARGET_ALIAS,p);return Promise.resolve().then(function(){return m.getAggregation(r,"title");}).then(function(t){if(typeof t==="string"){m.setProperty(r,"title",o);}else{m.setProperty(t,"text",o);}c.resetRevertData();});};
R._isProvided=function(s){return typeof(s)==="string";};
return R;},true);
sap.ui.predefine('sap/ui/layout/changeHandler/RenameSimpleForm',["sap/ui/fl/changeHandler/Base","sap/ui/core/util/reflection/JsControlTreeModifier","sap/base/Log"],function(B,J,L){"use strict";var R={};
R.applyChange=function(c,C,p){var m=p.modifier;var v=p.view;var a=p.appComponent;var o=c.getDefinition();var s=o.content.elementSelector||o.content.sRenameId;var r=m.bySelector(s,a,v);if(o.texts&&o.texts.formText&&this._isProvided(o.texts.formText.value)){if(!C){return Promise.reject(new Error("no Control provided for renaming"));}return m.getProperty(r,"text").then(function(P){c.setRevertData(P);var V=o.texts.formText.value;m.setProperty(r,"text",V);});}else{L.error("Change does not contain sufficient information to be applied: ["+o.layer+"]"+o.namespace+"/"+o.fileName+"."+o.fileType);return Promise.resolve();}};
R.revertChange=function(c,C,p){var o=c.getRevertData();var a=p.appComponent;var b=c.getDefinition();var v=p.view;var m=p.modifier;var s=b.content.elementSelector||b.content.sRenameId;var r=m.bySelector(s,a,v);if(o||o===""){m.setProperty(r,"text",o);r.getParent().invalidate();c.resetRevertData();}else{L.error("Change doesn't contain sufficient information to be reverted. Most Likely the Change didn't go through applyChange.");}};
R.completeChangeContent=function(c,s,p){var C=c.getDefinition();if(!s.changeType){throw new Error("oSpecificChangeInfo.changeType attribute required");}if(s.renamedElement&&s.renamedElement.id){var r=sap.ui.getCore().byId(s.renamedElement.id);var S;if(s.changeType==="renameLabel"){S=r.getLabel();}else if(s.changeType==="renameTitle"){S=r.getTitle();}C.content.elementSelector=J.getSelector(S,p.appComponent);c.addDependentControl(S,"elementSelector",p);}else{throw new Error("oSpecificChangeInfo.renamedElement attribute required");}if(this._isProvided(s.value)){B.setTextInChange(C,"formText",s.value,"XFLD");}else{throw new Error("oSpecificChangeInfo.value attribute required");}};
R._isProvided=function(s){return typeof(s)==="string";};
R.getChangeVisualizationInfo=function(c,a){var e=c.getDefinition().content.elementSelector;var A=J.bySelector(e,a).getParent().getId();return{affectedControls:[A],payload:{originalLabel:c.getRevertData(),newLabel:c.getDefinition().texts.formText.value}};};
return R;},true);
sap.ui.predefine('sap/ui/layout/changeHandler/UnhideSimpleForm',["sap/ui/core/util/reflection/JsControlTreeModifier"],function(J){"use strict";var U={};
function _(p){return p.modifier.targets==="xmlTree";}
U.applyChange=function(c,C,p){var m=p.modifier;var v=p.view;var a=p.appComponent;var o=c.getDefinition();if(_(p)){return Promise.reject(Error("Change cannot be applied in XML. Retrying in JS."));}var b=m.bySelector(o.content.elementSelector||o.content.sUnhideId,a,v);return Promise.resolve().then(function(){return m.getAggregation(C,"content");}).then(function(d){var s=-1;if(o.changeType==="unhideSimpleFormField"){c.setRevertData(true);d.some(function(f,i){if(f===b){s=i;m.setVisible(f,true);}if(s>=0&&i>s){if((m.getControlType(f)==="sap.m.Label")||(m.getControlType(f)==="sap.ui.comp.smartfield.SmartLabel")||(m.getControlType(f)==="sap.ui.core.Title")||(m.getControlType(f)==="sap.m.Title")||(m.getControlType(f)==="sap.m.Toolbar")||(m.getControlType(f)==="sap.m.OverflowToolbar")){return true;}m.setVisible(f,true);}});}});};
U.completeChangeContent=function(c,s,p){var C=c.getDefinition();if(s.sUnhideId){var u=sap.ui.getCore().byId(s.sUnhideId);C.content.elementSelector=J.getSelector(u,p.appComponent);c.addDependentControl(u,"elementSelector",p);}else if(s.revealedElementId){var f=sap.ui.getCore().byId(s.revealedElementId||s.sUnhideId);var l=f.getLabel();C.content.elementSelector=J.getSelector(l,p.appComponent);c.addDependentControl(l,"elementSelector",p);}else{throw new Error("oSpecificChangeInfo.revealedElementId attribute required");}};
U.revertChange=function(c,C,p){var m=p.modifier;var v=p.view;var a=p.appComponent;var o=c.getDefinition();var b=m.bySelector(o.content.elementSelector||o.content.sUnhideId,a,v);return Promise.resolve().then(function(){return m.getAggregation(C,"content");}).then(function(d){var s=-1;if(o.changeType==="unhideSimpleFormField"){d.some(function(f,i){if(f===b){s=i;m.setVisible(f,false);}if(s>=0&&i>s){if((m.getControlType(f)==="sap.m.Label")||(m.getControlType(f)==="sap.ui.comp.smartfield.SmartLabel")||(m.getControlType(f)==="sap.ui.core.Title")||(m.getControlType(f)==="sap.m.Title")||(m.getControlType(f)==="sap.m.Toolbar")||(m.getControlType(f)==="sap.m.OverflowToolbar")){return undefined;}m.setVisible(f,false);}});c.resetRevertData();}return Promise.resolve();});};
U.getChangeVisualizationInfo=function(c,a){return{affectedControls:[J.bySelector(c.getDefinition().content.elementSelector,a).getParent().getId()]};};
return U;},true);
sap.ui.predefine('sap/ui/layout/cssgrid/CSSGrid',["sap/ui/core/Control","sap/ui/layout/cssgrid/GridLayoutBase","sap/ui/layout/cssgrid/GridBasicLayout","sap/ui/layout/cssgrid/GridLayoutDelegate","./CSSGridRenderer","sap/ui/base/ManagedObjectObserver","sap/ui/layout/library"],function(C,G,a,b,c,M){"use strict";
var d=C.extend("sap.ui.layout.cssgrid.CSSGrid",{
metadata:{library:"sap.ui.layout",defaultAggregation:"items",interfaces:["sap.ui.layout.cssgrid.IGridConfigurable"],properties:{width:{type:"sap.ui.core.CSSSize",defaultValue:"100%"},gridTemplateColumns:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridTemplateRows:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridRowGap:{type:"sap.ui.core.CSSSize",defaultValue:""},gridColumnGap:{type:"sap.ui.core.CSSSize",defaultValue:""},gridGap:{type:"sap.ui.layout.cssgrid.CSSGridGapShortHand",defaultValue:""},gridAutoRows:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridAutoColumns:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridAutoFlow:{type:"sap.ui.layout.cssgrid.CSSGridAutoFlow",defaultValue:"Row"}},aggregations:{customLayout:{type:"sap.ui.layout.cssgrid.GridLayoutBase",multiple:false},items:{type:"sap.ui.core.Control",multiple:true,singularName:"item",dnd:true}},dnd:{draggable:false,droppable:true}},
renderer:c
});
d.prototype.getGridDomRefs=function(){return[this.getDomRef()];};
d.prototype.getGridLayoutConfiguration=function(){if(this.getCustomLayout()){return this.getCustomLayout();}else{return this._getDefaultGridLayout();}};
d.prototype._getDefaultGridLayout=function(){var D=new a({gridTemplateColumns:this.getGridTemplateColumns(),gridTemplateRows:this.getGridTemplateRows(),gridRowGap:this.getGridRowGap(),gridColumnGap:this.getGridColumnGap(),gridGap:this.getGridGap(),gridAutoRows:this.getGridAutoRows(),gridAutoColumns:this.getGridAutoColumns(),gridAutoFlow:this.getGridAutoFlow()});return D;};
d.prototype.init=function(){this._oItemDelegate={onAfterRendering:this._onAfterItemRendering};this._oGridObserver=new M(this._onGridChange.bind(this));this._oGridObserver.observe(this,{aggregations:["items"]});this._addGridLayoutDelegate();};
d.prototype.exit=function(){this._removeGridLayoutDelegate();if(this._oGridObserver){this._oGridObserver.disconnect();this._oGridObserver=null;}};
d.prototype._addGridLayoutDelegate=function(){if(!this.oGridLayoutDelegate){this.oGridLayoutDelegate=new b();this.addDelegate(this.oGridLayoutDelegate,false,this,false);}};
d.prototype._removeGridLayoutDelegate=function(){if(this.oGridLayoutDelegate){this.removeDelegate(this.oGridLayoutDelegate);this.oGridLayoutDelegate.destroy();this.oGridLayoutDelegate=null;}};
d.prototype._onGridChange=function(o){var e;if(o.name!=="items"||!o.child){return;}if(o.mutation==="insert"){e=!o.child.isA("sap.ui.core.HTML");o.child.addDelegate(this._oItemDelegate,e,o.child);}else if(o.mutation==="remove"){o.child.removeEventDelegate(this._oItemDelegate,o.child);}};
d.prototype._onAfterItemRendering=function(){G.setItemStyles(this);};
d.prototype.onLayoutDataChange=function(e){G.setItemStyles(e.srcControl);};
return d;});
sap.ui.predefine('sap/ui/layout/cssgrid/CSSGridRenderer',[],function(){"use strict";var C={apiVersion:2};
C.render=function(r,c){r.openStart("div",c).class("sapUiLayoutCSSGrid");if(c.getWidth()){r.style("width",c.getWidth());}c.getGridLayoutConfiguration().addGridStyles(r);r.openEnd();c.getItems().forEach(r.renderControl,r);r.close("div");};
return C;});
sap.ui.predefine('sap/ui/layout/cssgrid/GridBasicLayout',["sap/ui/layout/cssgrid/GridLayoutBase","sap/ui/layout/cssgrid/GridSettings","sap/ui/layout/library"],function(G,a){"use strict";
var b=G.extend("sap.ui.layout.cssgrid.GridBasicLayout",{metadata:{library:"sap.ui.layout",properties:{gridTemplateColumns:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridTemplateRows:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridRowGap:{type:"sap.ui.core.CSSSize",defaultValue:""},gridColumnGap:{type:"sap.ui.core.CSSSize",defaultValue:""},gridGap:{type:"sap.ui.layout.cssgrid.CSSGridGapShortHand",defaultValue:""},gridAutoRows:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridAutoColumns:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridAutoFlow:{type:"sap.ui.layout.cssgrid.CSSGridAutoFlow",defaultValue:"Row"}}}});
b.prototype.getActiveGridSettings=function(){return new a({gridTemplateColumns:this.getGridTemplateColumns(),gridTemplateRows:this.getGridTemplateRows(),gridRowGap:this.getGridRowGap(),gridColumnGap:this.getGridColumnGap(),gridGap:this.getGridGap(),gridAutoRows:this.getGridAutoRows(),gridAutoColumns:this.getGridAutoColumns(),gridAutoFlow:this.getGridAutoFlow()});};
return b;});
sap.ui.predefine('sap/ui/layout/cssgrid/GridBoxLayout',["sap/ui/layout/cssgrid/GridLayoutBase","sap/ui/layout/cssgrid/GridSettings","sap/ui/Device","sap/ui/thirdparty/jquery"],function(G,a,D,q){"use strict";var S=/^([X][L](?:[1-9]|1[0-2]))? ?([L](?:[1-9]|1[0-2]))? ?([M](?:[1-9]|1[0-2]))? ?([S](?:[1-9]|1[0-2]))?$/i;var b=S.exec("XL7 L6 M4 S2");var s={"Phone":"sapUiLayoutCSSGridBoxLayoutSizeS","Tablet":"sapUiLayoutCSSGridBoxLayoutSizeM","Desktop":"sapUiLayoutCSSGridBoxLayoutSizeL","LargeDesktop":"sapUiLayoutCSSGridBoxLayoutSizeXL"};var c={"XL":"sapUiLayoutCSSGridBoxLayoutSpanXL7","L":"sapUiLayoutCSSGridBoxLayoutSpanL6","M":"sapUiLayoutCSSGridBoxLayoutSpanM4","S":"sapUiLayoutCSSGridBoxLayoutSpanS2"};var d="0.5rem";
var e=G.extend("sap.ui.layout.cssgrid.GridBoxLayout",{metadata:{library:"sap.ui.layout",properties:{boxMinWidth:{type:"sap.ui.core.CSSSize",defaultValue:""},boxWidth:{type:"sap.ui.core.CSSSize",defaultValue:""},boxesPerRowConfig:{type:"sap.ui.layout.BoxesPerRowConfig",group:"Behavior",defaultValue:"XL7 L6 M4 S2"}}}});
e.prototype.getActiveGridSettings=function(){return new a({gridTemplateColumns:this._getTemplateColumns(),gridGap:d+" "+d});};
e.prototype._applySingleGridLayout=function(E){G.prototype._applySingleGridLayout.call(this,E);var g=sap.ui.getCore().byId(E.parentElement.id);if(g&&g.isA("sap.f.GridList")&&g.isGrouped()){this._flattenHeight(g);}};
e.prototype.addGridStyles=function(r){G.prototype.addGridStyles.apply(this,arguments);this._addSpanClasses(r);r.class("sapUiLayoutCSSGridBoxLayoutContainer");};
e.prototype.onGridAfterRendering=function(g){g.getGridDomRefs().forEach(function(o){if(o.children){for(var i=0;i<o.children.length;i++){if(!o.children[i].classList.contains("sapMGHLI")&&!o.children[i].classList.contains("sapUiBlockLayerTabbable")){o.children[i].classList.add("sapUiLayoutCSSGridItem");}}}});if(!this._hasBoxWidth()){this._applySizeClass(g);}if(g.isA("sap.f.GridList")&&g.getGrowing()){var C=g._oGrowingDelegate._onAfterPageLoaded;g._oGrowingDelegate._onAfterPageLoaded=function(){C.call(g._oGrowingDelegate);if(g.isA("sap.f.GridList")&&g.isGrouped()){this._flattenHeight(g);}}.bind(this);}};
e.prototype.isResponsive=function(){return true;};
e.prototype.onGridResize=function(E){if(E.control&&E.control.isA("sap.f.GridList")&&E.control.isGrouped()){this._flattenHeight(E.control);}if(E){if(!this._hasBoxWidth()){this._applySizeClass(E.control);}}};
e.prototype._flattenHeight=function(C){var m=0,M;this._loopOverGridItems(C,function(g){if(!g.classList.contains("sapMGHLI")){g.style.height="";}});this._loopOverGridItems(C,function(g){if(!g.classList.contains("sapMGHLI")){m=Math.max(q(g).outerHeight(),m);}});M=m+"px";this._loopOverGridItems(C,function(g){if(!g.classList.contains("sapMGHLI")){g.style.height=M;}});};
e.prototype._applySizeClass=function(C){var r=D.media.getCurrentRange("StdExt",C.$().width());if(!r){return;}var f=s[r.name];C.getGridDomRefs().forEach(function(o){if(!o.classList.contains(f)){Object.keys(s).map(function(g){o.classList.remove(s[g]);});o.classList.add(f);}});};
e.prototype._getTemplateColumns=function(){var t="";if(this.getBoxWidth()){t="repeat(auto-fit, "+this.getBoxWidth()+")";}else if(this.getBoxMinWidth()){t="repeat(auto-fit, minmax("+this.getBoxMinWidth()+", 1fr))";}return t;};
e.prototype._hasBoxWidth=function(){if(this.getBoxWidth()||this.getBoxMinWidth()){return true;}else{return false;}};
e.prototype._addSpanClasses=function(r){var f,g=this.getBoxesPerRowConfig(),h,j,k,l;if(this._hasBoxWidth()){return;}if(!g||!g.length===0){f=b;}else{f=S.exec(g);}if(f){for(var i=1;i<f.length;i++){var m=f[i];if(!m){continue;}m=m.toUpperCase();switch(m.substr(0,1)){case"X":if(m.substr(1,1)==="L"){h=this._getBoxesPerRowClass(m,2);}break;case"L":j=this._getBoxesPerRowClass(m,1);break;case"M":k=this._getBoxesPerRowClass(m,1);break;case"S":l=this._getBoxesPerRowClass(m,1);break;default:break;}}}h=h||c.XL;j=j||c.L;k=k||c.M;l=l||c.S;r.class(h).class(j).class(k).class(l);};
e.prototype._getBoxesPerRowClass=function(f,i){var g=parseInt(f.substr(i,f.length));if(g&&g>0&&g<13){return"sapUiLayoutCSSGridBoxLayoutSpan"+f;}};
e.prototype._loopOverGridItems=function(C,f){C.getGridDomRefs().forEach(function(o){if(o&&o.children){for(var i=0;i<o.children.length;i++){if(o.children[i].style.display!=="none"&&o.children[i].style.visibility!=="hidden"){f(o.children[i]);}}}});};
return e;});
sap.ui.predefine('sap/ui/layout/cssgrid/GridItemLayoutData',["sap/ui/core/LayoutData","sap/ui/layout/library"],function(L){"use strict";var g={gridColumnStart:"grid-column-start",gridColumnEnd:"grid-column-end",gridRowStart:"grid-row-start",gridRowEnd:"grid-row-end",gridColumn:"grid-column",gridRow:"grid-row"};
var G=L.extend("sap.ui.layout.cssgrid.GridItemLayoutData",{metadata:{library:"sap.ui.layout",interfaces:["sap.ui.layout.cssgrid.IGridItemLayoutData"],properties:{gridColumnStart:{type:"sap.ui.layout.cssgrid.CSSGridLine",defaultValue:""},gridColumnEnd:{type:"sap.ui.layout.cssgrid.CSSGridLine",defaultValue:""},gridRowStart:{type:"sap.ui.layout.cssgrid.CSSGridLine",defaultValue:""},gridRowEnd:{type:"sap.ui.layout.cssgrid.CSSGridLine",defaultValue:""},gridColumn:{type:"sap.ui.layout.cssgrid.CSSGridLine",defaultValue:""},gridRow:{type:"sap.ui.layout.cssgrid.CSSGridLine",defaultValue:""}}}});
G.prototype.setItemStyles=function(i){if(!i){return;}var p=this.getMetadata().getProperties();for(var P in g){if(p[P]){var s=this.getProperty(P);if(typeof s!=="undefined"){G._setItemStyle(i,g[P],s);}}}};
G.removeItemStyles=function(i){for(var p in g){i.style.removeProperty(g[p]);}};
G._setItemStyle=function(i,p,v){if(v!=="0"&&!v){i.style.removeProperty(p);}else{i.style.setProperty(p,v);}};
return G;});
sap.ui.predefine('sap/ui/layout/cssgrid/GridLayoutBase',["sap/ui/base/ManagedObject","./GridItemLayoutData"],function(M,G){"use strict";var g={gridTemplateColumns:"grid-template-columns",gridTemplateRows:"grid-template-rows",gridGap:"grid-gap",gridColumnGap:"grid-column-gap",gridRowGap:"grid-row-gap",gridAutoRows:"grid-auto-rows",gridAutoColumns:"grid-auto-columns",gridAutoFlow:"grid-auto-flow"};var m={Row:"row",Column:"column",RowDense:"row dense",ColumnDense:"column dense"};
var a=M.extend("sap.ui.layout.cssgrid.GridLayoutBase",{metadata:{library:"sap.ui.layout","abstract":true}});
a.setItemStyles=function(i){if(!i){return;}var l=a._getLayoutDataForControl(i),e=i.getDomRef();if(!e){return;}if(!l){G.removeItemStyles(e);}else{l.setItemStyles(e);}};
a._getLayoutDataForControl=function(c){var l,L,I;if(!c){return undefined;}l=c.getLayoutData();if(!l){return undefined;}if(l.isA("sap.ui.layout.cssgrid.IGridItemLayoutData")){return l;}if(l.isA("sap.ui.core.VariantLayoutData")){L=l.getMultipleLayoutData();for(var i=0;i<L.length;i++){I=L[i];if(I.isA("sap.ui.layout.cssgrid.IGridItemLayoutData")){return I;}}}};
a.prototype.applyGridLayout=function(e){if(!e){return;}e.forEach(this._applySingleGridLayout,this);};
a.prototype._applySingleGridLayout=function(e){if(!e){return;}e=e instanceof window.HTMLElement?e:e.getDomRef();var o=this.getActiveGridSettings();if(e.style.getPropertyValue("display")!=="grid"){e.style.setProperty("display","grid");}if(o){this._setGridLayout(e,o);}else{this._removeGridLayout(e);}};
a.prototype._setGridLayout=function(e,o){var p=o.getMetadata().getProperties(),P,s;for(P in g){if(p[P]){s=o.getProperty(P);if(P==="gridAutoFlow"){s=m[s];}if(s===""&&(P==="gridRowGap"||P==="gridColumnGap")){continue;}e.style.setProperty(g[P],s);}}};
a.prototype._removeGridLayout=function(e){for(var p in g){e.style.removeProperty(g[p]);}};
a.prototype.getActiveGridSettings=function(){throw new Error("GridLayoutBase getActiveGridSettings not implemented in child class");};
a.prototype.onGridAfterRendering=function(o){};
a.prototype.onGridResize=function(e){};
a.prototype.isResponsive=function(){return false;};
a.prototype.addGridStyles=function(r){var o=this.getActiveGridSettings();r.style("display","grid");if(!o||this.isResponsive()){return;}var p=o.getMetadata().getProperties();for(var P in g){if(p[P]){var s=o.getProperty(P);if(P==="gridAutoFlow"){s=m[s];}r.style(g[P],s);}}};
return a;});
sap.ui.predefine('sap/ui/layout/cssgrid/GridLayoutDelegate',["sap/ui/base/Object","sap/ui/core/ResizeHandler"],function(B,R){"use strict";
var G=B.extend("sap.ui.layout.cssgrid.GridLayoutDelegate");
G.prototype.onBeforeRendering=function(){G.deregisterResizeListener(this);};
G.prototype.onAfterRendering=function(){var g=this.getGridLayoutConfiguration();if(!g){return;}g.onGridAfterRendering(this);if(g.isResponsive()){g.applyGridLayout(this.getGridDomRefs());G.registerResizeListener(this);}};
G.prototype.exit=function(){G.deregisterResizeListener(this);};
G.registerResizeListener=function(c){c.__grid__sResizeListenerId=R.register(c,G.onResize.bind(c));};
G.deregisterResizeListener=function(c){if(c.__grid__sResizeListenerId){R.deregister(c.__grid__sResizeListenerId);c.__grid__sResizeListenerId=null;}};
G.onResize=function(e){var g=this.getGridLayoutConfiguration();if(!g){return;}g.onGridResize(e);g.applyGridLayout(this.getGridDomRefs());};
return G;});
sap.ui.predefine('sap/ui/layout/cssgrid/GridResponsiveLayout',["sap/ui/layout/cssgrid/GridLayoutBase","sap/ui/Device"],function(G,D){"use strict";
var a=G.extend("sap.ui.layout.cssgrid.GridResponsiveLayout",{metadata:{library:"sap.ui.layout",properties:{containerQuery:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{layout:{type:"sap.ui.layout.cssgrid.GridSettings",multiple:false},layoutS:{type:"sap.ui.layout.cssgrid.GridSettings",multiple:false},layoutM:{type:"sap.ui.layout.cssgrid.GridSettings",multiple:false},layoutL:{type:"sap.ui.layout.cssgrid.GridSettings",multiple:false},layoutXL:{type:"sap.ui.layout.cssgrid.GridSettings",multiple:false}},events:{layoutChange:{parameters:{layout:{type:"string"}}}}}});
a.mSizeClasses={"Phone":"sapUiLayoutCSSGridS","Tablet":"sapUiLayoutCSSGridM","Desktop":"sapUiLayoutCSSGridL","LargeDesktop":"sapUiLayoutCSSGridXL"};a.mSizeLayouts={"Phone":"layoutS","Tablet":"layoutM","Desktop":"layoutL","LargeDesktop":"layoutXL"};
a.prototype.init=function(){this._sActiveLayout="layout";};
a.prototype.getActiveGridSettings=function(){return this.getAggregation(this._sActiveLayout);};
a.prototype.isResponsive=function(){return true;};
a.prototype.onGridAfterRendering=function(g){this.setActiveLayout(g,false);};
a.prototype.onGridResize=function(e){if(!e||e.size.width===0){return;}this.setActiveLayout(e.control,true);};
a.prototype.applySizeClass=function(g,s){if(g.hasClass(s)){return;}var c=Object.keys(a.mSizeClasses).map(function(S){return a.mSizeClasses[S];});g.removeClass(c.join(" "));g.addClass(s);};
a.prototype.setActiveLayout=function(g,t){var w=this.getContainerQuery()?g.$().outerWidth():window.innerWidth;var r=D.media.getCurrentRange("StdExt",w),l=a.mSizeLayouts[r.name],L=this._getLayoutToApply(l);this.applySizeClass(g.$(),a.mSizeClasses[r.name]);if(this._sActiveLayout===L){return;}this._sActiveLayout=L;if(t){this.fireLayoutChange({layout:L});}};
a.prototype._getLayoutToApply=function(l){if(this.getAggregation(l)){return l;}return"layout";};
return a;});
sap.ui.predefine('sap/ui/layout/cssgrid/GridSettings',["sap/ui/base/ManagedObject","sap/ui/layout/library"],function(M){"use strict";
var G=M.extend("sap.ui.layout.cssgrid.GridSettings",{metadata:{library:"sap.ui.layout",properties:{gridTemplateColumns:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridTemplateRows:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridRowGap:{type:"sap.ui.core.CSSSize",defaultValue:""},gridColumnGap:{type:"sap.ui.core.CSSSize",defaultValue:""},gridGap:{type:"sap.ui.layout.cssgrid.CSSGridGapShortHand",defaultValue:""},gridAutoRows:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridAutoColumns:{type:"sap.ui.layout.cssgrid.CSSGridTrack",defaultValue:""},gridAutoFlow:{type:"sap.ui.layout.cssgrid.CSSGridAutoFlow",defaultValue:"Row"}}}});
return G;});
sap.ui.predefine('sap/ui/layout/cssgrid/ResponsiveColumnItemLayoutData',["sap/ui/core/LayoutData","sap/ui/layout/library"],function(L){"use strict";
var R=L.extend("sap.ui.layout.cssgrid.ResponsiveColumnItemLayoutData",{metadata:{library:"sap.ui.layout",interfaces:["sap.ui.layout.cssgrid.IGridItemLayoutData"],properties:{columns:{type:"int",group:"Misc",defaultValue:1},rows:{type:"int",group:"Misc",defaultValue:1}}}});
R.prototype.setItemStyles=function(i){i.style.setProperty('grid-row','span '+this.getRows());i.style.setProperty('grid-column','span '+this.getColumns());};
return R;});
sap.ui.predefine('sap/ui/layout/cssgrid/ResponsiveColumnLayout',["sap/ui/layout/cssgrid/GridLayoutBase","sap/ui/Device","sap/ui/layout/library"],function(G,D){"use strict";var R="RCLRangeSet";D.media.initRangeSet(R,[600,1024,1280,1440,1680,1920],"px",["S","M","ML","L","XL","XXL","XXXL"],true);
var a=G.extend("sap.ui.layout.cssgrid.ResponsiveColumnLayout",{metadata:{library:"sap.ui.layout",properties:{},events:{layoutChange:{parameters:{layout:{type:"string"}}}}}});
a.prototype._sCurrentLayoutClassName="";
a.prototype.isResponsive=function(){return true;};
a.prototype.onGridAfterRendering=function(g){this._applyLayout(g);};
a.prototype.getActiveGridSettings=function(){return null;};
a.prototype.onGridResize=function(e){if(!e||e.size.width===0){return;}this._applyLayout(e.control);};
a.prototype.addGridStyles=function(r){G.prototype.addGridStyles.apply(this,arguments);r.class("sapUiLayoutCSSGridRCL");};
a.prototype._applyLayout=function(g){var p=g.getParent(),w=p?p.getDomRef().offsetWidth:g.getDomRef().parentElement.offsetWidth,r=D.media.getCurrentRange(R,w),c="sapUiLayoutCSSGridRCL-Layout"+r.name;if(this._sCurrentLayoutClassName===c){return;}g.removeStyleClass(this._sCurrentLayoutClassName);g.addStyleClass(c);this._sCurrentLayoutClassName=c;this.fireLayoutChange({layout:r.name});};
return a;});
sap.ui.predefine('sap/ui/layout/flexibility/BlockLayoutCell.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"}),"unhideControl":"default"};});
sap.ui.predefine('sap/ui/layout/flexibility/Form.flexibility',["sap/ui/layout/changeHandler/AddFormContainer","sap/ui/layout/changeHandler/AddFormField"],function(A,a){"use strict";return{"moveControls":"default","addGroup":A,"addFormField":a};},true);
sap.ui.predefine('sap/ui/layout/flexibility/FormContainer.flexibility',["sap/ui/layout/changeHandler/RenameFormContainer","sap/ui/layout/changeHandler/AddFormField"],function(R,A){"use strict";return{"hideControl":"default","renameGroup":R,"moveControls":"default","addFormField":A};},true);
sap.ui.predefine('sap/ui/layout/flexibility/FormElement.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","unhideControl":"default","renameField":B.createRenameChangeHandler({propertyName:"label",translationTextType:"XFLD",changePropertyName:"fieldLabel"})};},true);
sap.ui.predefine('sap/ui/layout/flexibility/SimpleForm.flexibility',["sap/ui/layout/changeHandler/RenameSimpleForm","sap/ui/layout/changeHandler/MoveSimpleForm","sap/ui/layout/changeHandler/HideSimpleForm","sap/ui/layout/changeHandler/UnhideSimpleForm","sap/ui/layout/changeHandler/AddSimpleFormGroup","sap/ui/layout/changeHandler/AddSimpleFormField"],function(R,M,H,U,A,a){"use strict";return{"renameLabel":R,"renameTitle":R,"moveSimpleFormField":M,"moveSimpleFormGroup":M,"hideSimpleFormField":H,"unhideSimpleFormField":U,"removeSimpleFormGroup":H,"addSimpleFormGroup":A,"addSimpleFormField":a};},true);
sap.ui.predefine('sap/ui/layout/form/ColumnContainerData',['sap/ui/core/LayoutData','sap/ui/layout/library'],function(L,l){"use strict";
var C=L.extend("sap.ui.layout.form.ColumnContainerData",{metadata:{library:"sap.ui.layout",properties:{columnsXL:{type:"sap.ui.layout.form.ColumnsXL",group:"Appearance",defaultValue:2},columnsL:{type:"sap.ui.layout.form.ColumnsL",group:"Appearance",defaultValue:2},columnsM:{type:"sap.ui.layout.form.ColumnsM",group:"Appearance",defaultValue:1}}}});
return C;});
sap.ui.predefine('sap/ui/layout/form/ColumnElementData',['sap/ui/core/LayoutData','sap/ui/layout/library'],function(L,l){"use strict";
var C=L.extend("sap.ui.layout.form.ColumnElementData",{metadata:{library:"sap.ui.layout",properties:{cellsLarge:{type:"sap.ui.layout.form.ColumnCells",group:"Appearance",defaultValue:8},cellsSmall:{type:"sap.ui.layout.form.ColumnCells",group:"Appearance",defaultValue:12}}}});
return C;});
sap.ui.predefine('sap/ui/layout/form/ColumnLayout',['sap/ui/Device','sap/ui/core/ResizeHandler','sap/ui/layout/library','./FormLayout','./ColumnLayoutRenderer',"sap/ui/thirdparty/jquery"],function(D,R,l,F,C,q){"use strict";
var a=F.extend("sap.ui.layout.form.ColumnLayout",{metadata:{library:"sap.ui.layout",properties:{columnsXL:{type:"sap.ui.layout.form.ColumnsXL",group:"Appearance",defaultValue:2},columnsL:{type:"sap.ui.layout.form.ColumnsL",group:"Appearance",defaultValue:2},columnsM:{type:"sap.ui.layout.form.ColumnsM",group:"Appearance",defaultValue:1},labelCellsLarge:{type:"sap.ui.layout.form.ColumnCells",group:"Appearance",defaultValue:4},emptyCellsLarge:{type:"sap.ui.layout.form.EmptyCells",group:"Appearance",defaultValue:0}}}});
a.prototype.init=function(){F.prototype.init.apply(this,arguments);this._iBreakPointTablet=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[0];this._iBreakPointDesktop=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[1];this._iBreakPointLargeDesktop=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD_EXTENDED].points[2];this._resizeProxy=q.proxy(b,this);if(typeof ResizeObserver==="function"){this._oResizeObserver=new ResizeObserver(this._resizeProxy);}};
a.prototype.exit=function(){_.call(this);this._oResizeObserver=undefined;};
a.prototype.onBeforeRendering=function(e){F.prototype.onBeforeRendering.apply(this,arguments);if(this.getColumnsM()>this.getColumnsL()||this.getColumnsL()>this.getColumnsXL()){throw new Error("Column size not correct defined for "+this);}_.call(this);};
a.prototype.onAfterRendering=function(e){if(this._oResizeObserver){var d=this.getDomRef();this._oResizeObserver.observe(d);}else{this._sResizeListener=R.register(this,this._resizeProxy);}c.call(this);};
a.prototype.toggleContainerExpanded=function(o){o.$().toggleClass("sapUiFormCLContainerColl",!o.getExpanded());};
a.prototype.onLayoutDataChange=function(e){this.invalidate();};
a.prototype.onsapup=function(e){this.onsapleft(e);};
a.prototype.onsapdown=function(e){this.onsapright(e);};
a.prototype.getContainerRenderedDomRef=function(o){return o.getDomRef();};
a.prototype.getElementRenderedDomRef=function(e){return e.getDomRef();};
a.prototype._getContainerSize=function(o){var f=this.getParent();var L=this.getLayoutDataForElement(o,"sap.ui.layout.form.ColumnContainerData");var d=f.getVisibleFormContainers();var e=d.length;var g=this.getColumnsM();var h=this.getColumnsL();var j=this.getColumnsXL();var O={S:{Size:1,Break:false,FirstRow:false},M:{Size:1,Break:false,FirstRow:false},L:{Size:1,Break:false,FirstRow:false},XL:{Size:1,Break:false,FirstRow:false}};var k=function(x,O,e,I,y){if(e<x){O.Size=Math.floor(x/e);if(y&&O.Size*e<x){O.Size=O.Size+x-O.Size*e;}}O.Break=x>1&&I>0&&(I%x)===0;O.FirstRow=e>1&&I<x;};if(L){O.M.Size=L.getColumnsM();O.L.Size=L.getColumnsL();O.XL.Size=L.getColumnsXL();if(O.M.Size>g||O.L.Size>h||O.XL.Size>j){throw new Error("More cells defined for FormContainer "+o.getId()+" than columns on "+this);}}if(e===1){if(!L){O.M.Size=g;O.L.Size=h;O.XL.Size=j;}O.S.FirstRow=true;O.M.FirstRow=true;O.L.FirstRow=true;O.XL.FirstRow=true;}else{var m=0;var M=0;var n=0;var p;var r=false;var s=0;var t=g;var u=h;var v=j;var i=0;for(i=0;i<e;i++){if(o===d[i]){m=i;p=L;}else{p=this.getLayoutDataForElement(d[i],"sap.ui.layout.form.ColumnContainerData");}if(!p){var E=d[i].getVisibleFormElements();if(M<E.length){M=E.length;n=i;}s++;}else{r=true;t=t-p.getColumnsM();u=u-p.getColumnsL();v=v-p.getColumnsXL();}}O.S.FirstRow=e>1&&m===0;O.S.Break=m>0;if(!r){k(g,O.M,e,m,m===n);k(h,O.L,e,m,m===n);k(j,O.XL,e,m,m===n);}else{if(!L){if(s<t){k(t,O.M,s,m,m===n);}if(s<u){k(u,O.L,s,m,m===n);}if(s<v){k(v,O.XL,s,m,m===n);}}var S={M:{rowColumns:0,lineBreak:false,first:true},L:{rowColumns:0,lineBreak:false,first:true},XL:{rowColumns:0,lineBreak:false,first:true}};var w=function(x,y,U){if(U){if(x.rowColumns+U<=y){x.rowColumns=x.rowColumns+U;x.lineBreak=false;}else{x.rowColumns=U;if(y>1){x.lineBreak=true;}x.first=false;}}else{if(x.rowColumns<y){x.rowColumns++;x.lineBreak=false;}else{x.rowColumns=1;if(y>1){x.lineBreak=true;}x.first=false;}}};for(i=0;i<e;i++){if(o===d[i]){p=L;}else{p=this.getLayoutDataForElement(d[i],"sap.ui.layout.form.ColumnContainerData");}w(S.M,g,(p?p.getColumnsM():0));w(S.L,h,(p?p.getColumnsL():0));w(S.XL,j,(p?p.getColumnsXL():0));if(o===d[i]){O.M.Break=S.M.lineBreak;O.L.Break=S.L.lineBreak;O.XL.Break=S.XL.lineBreak;O.M.FirstRow=S.M.first;O.L.FirstRow=S.L.first;O.XL.FirstRow=S.XL.first;break;}}}}return O;};
a.prototype._getFieldSize=function(f){var d=12;var L=this.getLayoutDataForElement(f,"sap.ui.layout.form.ColumnElementData");var o={S:{Size:d,Break:false,Space:0},L:{Size:d,Break:false,Space:0}};var e=d;var g=this.getLabelCellsLarge();if(L){o.S.Size=L.getCellsSmall()===-1?d:L.getCellsSmall();o.L.Size=L.getCellsLarge()===-1?d:L.getCellsLarge();}var E=f.getParent();var h=E.getLabelControl();if(h===f){if(!L||L.getCellsSmall()===-1){o.S.Size=e;}if(!L||L.getCellsLarge()===-1){o.L.Size=g;}}else{var j=E.getFieldsForRendering();var k=j.length;var m=d;var n=d-this.getEmptyCellsLarge();if(h){var p=this.getLayoutDataForElement(h,"sap.ui.layout.form.ColumnElementData");if(p){e=p.getCellsSmall()===-1?e:p.getCellsSmall();g=p.getCellsLarge()===-1?g:p.getCellsLarge();}if(e<d){m=m-e;}if(g<d){n=n-g;}}else{e=0;g=0;}if(k===1){if(!L||L.getCellsSmall()===-1){o.S.Size=m;}else if(h){if(o.S.Size>m){o.S.Break=true;}}if(!L||L.getCellsLarge()===-1){o.L.Size=n;}else if(h){if(o.L.Size>n){o.L.Break=true;}}}else{var i=0;var r=[];var s=[];var t={availableCells:m,first:0,last:999,firstDefault:-1,defaultFields:0};var u=0;var v=0;var w=0;var O;r.push(q.extend({},t));t.availableCells=n;s.push(q.extend({},t));var x=function(B,G,I,d){B[G].last=I-1;B.push(q.extend({},t));G++;B[G].first=I;B[G].availableCells=d;return G;};var y=function(B,G,H,U,I){if(B[G].availableCells-B[G].defaultFields<H){if(H<=U){G=x(B,G,I,U);}else{G=x(B,G,I,d);}}B[G].availableCells=B[G].availableCells-H;return G;};var z=function(B,G,d,I){if(B[G].availableCells===B[G].defaultFields){G=x(B,G,I,d);}if(B[G].firstDefault<0){B[G].firstDefault=I;}B[G].defaultFields++;return G;};for(i=0;i<k;i++){if(f!==j[i]){O=this.getLayoutDataForElement(j[i],"sap.ui.layout.form.ColumnElementData");}else{O=L;w=i;}if(O&&O.getCellsSmall()>0){u=y(r,u,O.getCellsSmall(),m,i);}else{u=z(r,u,m,i);}if(O&&O.getCellsLarge()>0){v=y(s,v,O.getCellsLarge(),n,i);}else{v=z(s,v,n,i);}}var A=function(B,w,G,o,H){var I=0;var t;for(i=0;i<B.length;i++){if(w>=B[i].first&&w<=B[i].last){t=B[i];break;}}if(G<=0){o.Size=Math.floor(t.availableCells/t.defaultFields);}if(w===t.first&&w>0){o.Break=true;if(H>0&&H<d&&o.Size<=d-H){o.Space=H;}}if(w===t.firstDefault){I=t.availableCells-t.defaultFields*o.Size;if(I>0){o.Size=o.Size+I;}}};A(r,w,L?L.getCellsSmall():-1,o.S,e);A(s,w,L?L.getCellsLarge():-1,o.L,g);}}return o;};
function _(){if(this._oResizeObserver){this._oResizeObserver.disconnect();}if(this._sResizeListener){R.deregister(this._sResizeListener);this._sResizeListener=undefined;}}
function b(e,n){window.requestAnimationFrame(function(){c.call(this,e,n);}.bind(this));}
function c(e,n){var d=this.getDomRef();if(!d){_.call(this);return;}var $=this.$();if(!$.is(":visible")){return;}if(R.isSuspended(d,this._resizeProxy)){return;}var w=d.clientWidth;var i=1;if(w<=this._iBreakPointTablet){$.toggleClass("sapUiFormCLMedia-Std-Phone",true);$.toggleClass("sapUiFormCLMedia-Std-Desktop",false).toggleClass("sapUiFormCLMedia-Std-Tablet",false).toggleClass("sapUiFormCLMedia-Std-LargeDesktop",false);}else if((w>this._iBreakPointTablet)&&(w<=this._iBreakPointDesktop)){$.toggleClass("sapUiFormCLMedia-Std-Tablet",true);$.toggleClass("sapUiFormCLMedia-Std-Desktop",false).toggleClass("sapUiFormCLMedia-Std-Phone",false).toggleClass("sapUiFormCLMedia-Std-LargeDesktop",false);i=this.getColumnsM();}else if((w>this._iBreakPointDesktop)&&(w<=this._iBreakPointLargeDesktop)){$.toggleClass("sapUiFormCLMedia-Std-Desktop",true);$.toggleClass("sapUiFormCLMedia-Std-Phone",false).toggleClass("sapUiFormCLMedia-Std-Tablet",false).toggleClass("sapUiFormCLMedia-Std-LargeDesktop",false);i=this.getColumnsL();}else{$.toggleClass("sapUiFormCLMedia-Std-LargeDesktop",true);$.toggleClass("sapUiFormCLMedia-Std-Desktop",false).toggleClass("sapUiFormCLMedia-Std-Phone",false).toggleClass("sapUiFormCLMedia-Std-Tablet",false);i=this.getColumnsXL();}var W=this.getLabelCellsLarge()<12&&w/i>this._iBreakPointTablet;$.toggleClass("sapUiFormCLWideColumns",W);$.toggleClass("sapUiFormCLSmallColumns",!W);}
a.prototype.getLayoutDataForDelimiter=function(){var d=sap.ui.require("sap/ui/layout/form/ColumnElementData");if(!d){var r;sap.ui.require(["sap/ui/layout/form/ColumnElementData"],function(d){r(new d({cellsLarge:1,cellsSmall:1}));});return new Promise(function(f){r=f;});}else{return new d({cellsLarge:1,cellsSmall:1});}};
a.prototype.getLayoutDataForSemanticField=function(f,i,L){if(L){if(L.isA("sap.ui.layout.form.ColumnElementData")){L.setCellsLarge(-1).setCellsSmall(11);return L;}else{L.destroy();}}var d=sap.ui.require("sap/ui/layout/form/ColumnElementData");if(!d){var r;sap.ui.require(["sap/ui/layout/form/ColumnElementData"],function(d){r(new d({cellsLarge:-1,cellsSmall:11}));});return new Promise(function(e){r=e;});}else{return new d({cellsLarge:-1,cellsSmall:11});}};
return a;});
sap.ui.predefine('sap/ui/layout/form/ColumnLayoutRenderer',['sap/ui/core/Renderer','sap/ui/Device','./FormLayoutRenderer'],function(R,D,F){"use strict";var C=R.extend(F);C.apiVersion=2;
C.getMainClass=function(){return"sapUiFormCL";};
C.renderContainers=function(r,l,f){var c=f.getVisibleFormContainers();var a=c.length;if(a>0){var o=a===1&&!l.getLayoutDataForElement(c[0],"sap.ui.layout.form.ColumnContainerData");if(!o){var b=l.getColumnsM();var d=l.getColumnsL();var e=l.getColumnsXL();r.openStart("div");r.class("sapUiFormCLContent");r.class("sapUiFormCLColumnsM"+b);r.class("sapUiFormCLColumnsL"+d);r.class("sapUiFormCLColumnsXL"+e);r.openEnd();}for(var i=0;i<a;i++){var g=c[i];this.renderContainer(r,l,g);}if(!o){r.close("div");}}};
C.renderContainer=function(r,l,c){var e=c.getExpandable();var t=c.getToolbar();var T=c.getTitle();var o=l._getContainerSize(c);c._checkProperties();r.openStart("section",c);r.class("sapUiFormCLContainer");r.class("sapUiFormCLContainerS"+o.S.Size);r.class("sapUiFormCLContainerM"+o.M.Size);r.class("sapUiFormCLContainerL"+o.L.Size);r.class("sapUiFormCLContainerXL"+o.XL.Size);if(o.M.Break){r.class("sapUiFormCLContainerMBreak");}if(o.L.Break){r.class("sapUiFormCLContainerLBreak");}if(o.XL.Break){r.class("sapUiFormCLContainerXLBreak");}if(o.S.FirstRow){r.class("sapUiFormCLContainerSFirstRow");}if(o.M.FirstRow){r.class("sapUiFormCLContainerMFirstRow");}if(o.L.FirstRow){r.class("sapUiFormCLContainerLFirstRow");}if(o.XL.FirstRow){r.class("sapUiFormCLContainerXLFirstRow");}if(t){r.class("sapUiFormContainerToolbar");}else if(T){r.class("sapUiFormContainerTitle");}if(!c.getExpanded()){r.class("sapUiFormCLContainerColl");}if(c.getTooltip_AsString()){r.attr('title',c.getTooltip_AsString());}this.writeAccessibilityStateContainer(r,c);r.openEnd();this.renderHeader(r,t,T,c._oExpandButton,e,l._sFormSubTitleSize,c.getId());r.openStart("div",c.getId()+"-content").class("sapUiFormCLContainerCont").openEnd();var E=c.getVisibleFormElements();for(var i=0;i<E.length;i++){var a=E[i];this.renderElement(r,l,a);if(D.browser.chrome&&i<o.XL.Size-1&&E.length>1&&E.length<=o.XL.Size){r.openStart("div").class("sapUiFormCLElementDummy").openEnd().close("div");}}r.close("div");r.close("section");};
C.renderElement=function(r,l,e){var L=e.getLabelControl();var o;r.openStart("div",e);r.class("sapUiFormCLElement");if(e.getTooltip_AsString()){r.attr('title',e.getTooltip_AsString());}r.openEnd();if(L){o=l._getFieldSize(L);r.openStart("div").class("sapUiFormElementLbl").class("sapUiFormCLCellsS"+o.S.Size).class("sapUiFormCLCellsL"+o.L.Size).openEnd();r.renderControl(L);r.close("div");}var f=e.getFieldsForRendering();if(f&&f.length>0){for(var k=0,a=f.length;k<a;k++){var b=f[k];if(!b.isA("sap.ui.core.IFormContent")){throw new Error(b+" is not a valid Form content! Only use valid content in "+l);}o=l._getFieldSize(b);r.openStart("div");r.class("sapUiFormCLCellsS"+o.S.Size);r.class("sapUiFormCLCellsL"+o.L.Size);if(o.S.Break){r.class("sapUiFormCLCellSBreak");}if(o.L.Break){r.class("sapUiFormCLCellLBreak");}if(o.S.Space){r.class("sapUiFormCLCellSSpace"+o.S.Space);}if(o.L.Space){r.class("sapUiFormCLCellLSpace"+o.L.Space);}r.openEnd();r.renderControl(b);r.close("div");}}r.close("div");};
return C;},true);
sap.ui.predefine('sap/ui/layout/form/Form',['sap/ui/core/Control','sap/ui/base/ManagedObjectObserver','sap/ui/layout/library','./FormRenderer'],function(C,M,l,F){"use strict";
var a=C.extend("sap.ui.layout.form.Form",{metadata:{library:"sap.ui.layout",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},editable:{type:"boolean",group:"Misc",defaultValue:false}},defaultAggregation:"formContainers",aggregations:{formContainers:{type:"sap.ui.layout.form.FormContainer",multiple:true,singularName:"formContainer"},title:{type:"sap.ui.core.Title",altTypes:["string"],multiple:false},toolbar:{type:"sap.ui.core.Toolbar",multiple:false},layout:{type:"sap.ui.layout.form.FormLayout",multiple:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},designtime:"sap/ui/layout/designtime/form/Form.designtime"}});
a.prototype.init=function(){this._oObserver=new M(b.bind(this));this._oObserver.observe(this,{properties:["editable"],aggregations:["formContainers"]});};
a.prototype.exit=function(){this._oObserver.disconnect();this._oObserver=undefined;};
a.prototype.toggleContainerExpanded=function(o){var L=this.getLayout();if(L){L.toggleContainerExpanded(o);}};
a.prototype.contentOnAfterRendering=function(f,o){var L=this.getLayout();if(L&&L.contentOnAfterRendering){L.contentOnAfterRendering(f,o);}};
a.prototype.onLayoutDataChange=function(e){var L=this.getLayout();if(L&&L.onLayoutDataChange){L.onLayoutDataChange(e);}};
a.prototype.onBeforeFastNavigationFocus=function(e){var L=this.getLayout();if(L&&L.onBeforeFastNavigationFocus){L.onBeforeFastNavigationFocus(e);}};
a.prototype.setEditable=function(e){this.setProperty("editable",e,true);return this;};
function _(e,o){if(e!=o&&this.getDomRef()){if(e){this.$().addClass("sapUiFormEdit").addClass("sapUiFormEdit-CTX");this.$().removeAttr("aria-readonly");}else{this.$().removeClass("sapUiFormEdit").removeClass("sapUiFormEdit-CTX");this.$().attr("aria-readonly","true");}}var f=this.getFormContainers();for(var i=0;i<f.length;i++){var d=f[i];d._setEditable(e);}}
a.prototype.setToolbar=function(t){t=l.form.FormHelper.setToolbar.call(this,t);this.setAggregation("toolbar",t);return this;};
a.prototype.invalidate=function(o){if(!this._bNoInvalidate){C.prototype.invalidate.apply(this,arguments);}};
a.prototype.getContainerRenderedDomRef=function(o){var L=this.getLayout();if(L&&L.getContainerRenderedDomRef){return L.getContainerRenderedDomRef(o);}else{return null;}};
a.prototype.getElementRenderedDomRef=function(e){var L=this.getLayout();if(L&&L.getElementRenderedDomRef){return L.getElementRenderedDomRef(e);}else{return null;}};
a.prototype.getVisibleFormContainers=function(){var d=this.getFormContainers();var v=[];for(var i=0;i<d.length;i++){var o=d[i];if(o.isVisible()){v.push(o);}}return v;};
a.prototype._suggestTitleId=function(t){this._sSuggestedTitleId=t;if(this.getDomRef()){this.invalidate();}return this;};
function b(o){if(o.name==="editable"){_.call(this,o.current,o.old);}else if(o.name==="formContainers"){c.call(this,o.mutation,o.child);}}
function c(m,f){if(m==="insert"){f._setEditable(this.getEditable());}}
return a;});
sap.ui.predefine('sap/ui/layout/form/FormContainer',['sap/ui/core/Element','sap/ui/base/ManagedObjectObserver','sap/ui/core/theming/Parameters','sap/ui/layout/library',"sap/base/Log"],function(E,M,P,l,L){"use strict";
var F=E.extend("sap.ui.layout.form.FormContainer",{metadata:{library:"sap.ui.layout",properties:{expanded:{type:"boolean",group:"Misc",defaultValue:true},expandable:{type:"boolean",group:"Misc",defaultValue:false},visible:{type:"boolean",group:"Misc",defaultValue:true},_editable:{type:"boolean",group:"Misc",defaultValue:false,visibility:"hidden"}},defaultAggregation:"formElements",aggregations:{formElements:{type:"sap.ui.layout.form.FormElement",multiple:true,singularName:"formElement"},title:{type:"sap.ui.core.Title",altTypes:["string"],multiple:false},toolbar:{type:"sap.ui.core.Toolbar",multiple:false},_expandButton:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},designtime:"sap/ui/layout/designtime/form/FormContainer.designtime"}});
F.prototype.init=function(){this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.ui.layout");this._oObserver=new M(this._observeChanges.bind(this));this._oObserver.observe(this,{properties:["expanded","expandable"],aggregations:["formElements"]});};
F.prototype.exit=function(){if(this._oExpandButton){delete this._oExpandButton;}this._rb=undefined;this._oObserver.disconnect();this._oObserver=undefined;};
function _(f){if(f){if(!this._oExpandButton){if(!this._bExpandButtonRequired){this._bExpandButtonRequired=true;l.form.FormHelper.createButton.call(this,this.getId()+"--Exp",d,a);}}else{c.call(this);}}}
function a(B){if(!this._bIsBeingDestroyed){this._oExpandButton=B;this.setAggregation("_expandButton",this._oExpandButton);c.call(this);}}
function b(f){c.call(this);var o=this.getParent();if(o&&o.toggleContainerExpanded){o.toggleContainerExpanded(this);}}
F.prototype.setToolbar=function(t){t=l.form.FormHelper.setToolbar.call(this,t);this.setAggregation("toolbar",t);return this;};
F.prototype.contentOnAfterRendering=function(f,C){var p=this.getParent();if(p&&p.contentOnAfterRendering){p.contentOnAfterRendering(f,C);}};
F.prototype.onLayoutDataChange=function(o){var p=this.getParent();if(p&&p.onLayoutDataChange){p.onLayoutDataChange(o);}};
F.prototype._checkProperties=function(){var r=0;if(this.getExpandable()&&(!this.getTitle()||this.getToolbar())){L.warning("Expander only displayed if title is set",this.getId(),"FormContainer");r=1;}return r;};
F.prototype.getRenderedDomRef=function(){var t=this;var f=this.getParent();if(f&&f.getContainerRenderedDomRef){return f.getContainerRenderedDomRef(t);}else{return null;}};
F.prototype.getElementRenderedDomRef=function(o){var f=this.getParent();if(f&&f.getElementRenderedDomRef){return f.getElementRenderedDomRef(o);}else{return null;}};
F.prototype.getVisibleFormElements=function(){var f=this.getFormElements();var v=[];for(var i=0;i<f.length;i++){var o=f[i];if(o.isVisible()){v.push(o);}}return v;};
F.prototype._setEditable=function(f){var o=this.getProperty("_editable");this.setProperty("_editable",f,true);if(f!==o){var g=this.getFormElements();for(var i=0;i<g.length;i++){var h=g[i];h._setEditable(f);}}};
F.prototype.isVisible=function(){return this.getVisible();};
function c(){if(!this._oExpandButton){return;}var i,I,t,T;if(this.getExpanded()){i=P._getThemeImage('_sap_ui_layout_Form_FormContainerColImageURL');I=P._getThemeImage('_sap_ui_layout_Form_FormContainerColImageDownURL');t="-";T=this._rb.getText("FORM_COLLAPSE");}else{i=P._getThemeImage('_sap_ui_layout_Form_FormContainerExpImageURL');I=P._getThemeImage('_sap_ui_layout_Form_FormContainerExpImageDownURL');t="+";T=this._rb.getText("FORM_EXPAND");}if(i){t="";}l.form.FormHelper.setButtonContent(this._oExpandButton,t,T,i,I);}
function d(o){this.setExpanded(!this.getExpanded());}
F.prototype._observeChanges=function(C){if(C.name=="formElements"){e.call(this,C.mutation,C.child);}else if(C.name=="expanded"){b.call(this,C.current);}else if(C.name=="expandable"){_.call(this,C.current);}};
function e(m,f){if(m==="insert"){var g=this.getProperty("_editable");f._setEditable(g);}}
return F;});
sap.ui.predefine('sap/ui/layout/form/FormElement',['sap/ui/core/Element','sap/ui/core/Control','sap/ui/base/ManagedObjectObserver','sap/ui/layout/library',"sap/base/Log"],function(E,C,M,l,L){"use strict";
var F=E.extend("sap.ui.layout.form.FormElement",{metadata:{library:"sap.ui.layout",properties:{visible:{type:"boolean",group:"Misc",defaultValue:true},_editable:{type:"boolean",group:"Misc",defaultValue:false,visibility:"hidden"}},defaultAggregation:"fields",aggregations:{label:{type:"sap.ui.core.Label",altTypes:["string"],multiple:false},_label:{type:"sap.ui.core.Label",multiple:false,visibility:"hidden"},fields:{type:"sap.ui.core.Control",multiple:true,singularName:"field"}},designtime:"sap/ui/layout/designtime/form/FormElement.designtime"}});
F.prototype.init=function(){this._oFieldDelegate={oElement:this,onAfterRendering:h};this._oObserver=new M(this._observeChanges.bind(this));this._oObserver.observe(this,{aggregations:["fields"]});};
F.prototype.exit=function(){if(this._oLabel){delete this._oLabel;}this._oFieldDelegate=undefined;this._oObserver.disconnect();this._oObserver=undefined;};
F.prototype.setLabel=function(A){if(!this._oLabel){var o=this.getLabel();if(o){if(o.setAlternativeLabelFor){o.setAlternativeLabelFor(null);}if(o.isRequired){o.isRequired=o._sapuiIsRequired;o._sapuiIsRequired=undefined;o.disableRequiredChangeCheck(false);}if(o.isDisplayOnly){o.isDisplayOnly=o._sapuiIsDisplayOnly;o._sapuiIsDisplayOnly=undefined;}if(o.isWrapping){o.isWrapping=o._sapuiIsWrapping;o._sapuiIsWrapping=undefined;}}}this.setAggregation("label",A);var i=A;if(typeof i==="string"){this._setInternalLabel(i);}else{if(this._oLabel){this._oLabel.destroy();delete this._oLabel;}if(i&&i.isRequired){i._sapuiIsRequired=i.isRequired;i.isRequired=b;i.disableRequiredChangeCheck(true);}if(i&&i.isDisplayOnly){i._sapuiIsDisplayOnly=i.isDisplayOnly;i.isDisplayOnly=c;}if(i&&i.isWrapping){i._sapuiIsWrapping=i.isWrapping;i.isWrapping=d;}e.call(this);}return this;};
F.prototype._setInternalLabel=function(t){if(!this._oLabel){this._oLabel=l.form.FormHelper.createLabel(t,this.getId()+"-label");this.setAggregation("_label",this._oLabel,true);this._oLabel.disableRequiredChangeCheck(true);if(this._oLabel.isRequired){this._oLabel.isRequired=b;}if(this._oLabel.isDisplayOnly){this._oLabel.isDisplayOnly=c;}if(this._oLabel.setWrapping){this._oLabel.setWrapping(true);}}else{this._oLabel.setText(t);}e.call(this);};
F.prototype.destroyLabel=function(){this.destroyAggregation("label");if(this._oLabel){this._oLabel.destroy();delete this._oLabel;}return this;};
F.prototype.getLabelControl=function(){if(this._oLabel){return this._oLabel;}else{return this.getLabel();}};
F.prototype.updateFields=function(){var j=this.getFields();var o;var i=0;for(i=0;i<j.length;i++){o=j[i];g.call(this,o);}this.updateAggregation("fields");j=this.getFields();for(i=0;i<j.length;i++){o=j[i];f.call(this,o);}e.call(this);return this;};
F.prototype.enhanceAccessibilityState=function(o,A){var i=this.getLabelControl();if(i&&i!=o){var s=A["labelledby"];if(!s){s=i.getId();}else{var j=s.split(" ");if(j.indexOf(i.getId())<0){j.splice(0,0,i.getId());s=j.join(" ");}}A["labelledby"]=s;}};
F.prototype.onLayoutDataChange=function(o){var p=this.getParent();if(p&&p.onLayoutDataChange){p.onLayoutDataChange(o);}};
F.prototype.getRenderedDomRef=function(){var t=this;var o=this.getParent();if(o&&o.getElementRenderedDomRef){return o.getElementRenderedDomRef(t);}else{return null;}};
F.prototype._setEditable=function(i){var o=this.getProperty("_editable");this.setProperty("_editable",i,true);if(i!==o){this.invalidateLabel();}};
F.prototype.invalidateLabel=function(){var o=this.getLabelControl();if(o&&o.getDomRef()){o.invalidate();}};
F.prototype.isVisible=function(){return this.getVisible();};
F.prototype.getFieldsForRendering=function(){return this.getFields();};
F.prototype._observeChanges=function(o){if(o.object==this){if(o.name=="fields"){_.call(this,o.child,o.mutation);}}else{a.call(this,o);}};
function _(o,m){if(m=="insert"){if(!o.isA("sap.ui.core.IFormContent")){L.warning(o+" is not valid Form content",this);}f.call(this,o);}else{g.call(this,o);}e.call(this);}
function a(o){if(o.name=="required"||o.name=="editable"){this.invalidateLabel();}}
function b(){if(this.getRequired&&this.getRequired()){return true;}var o=this.getParent();var j=o.getFields();for(var i=0;i<j.length;i++){var k=j[i];if(k.getRequired&&k.getRequired()===true&&(!k.getEditable||k.getEditable())){return true;}}return false;}
function c(){if(this.getDisplayOnly){if(!this.isPropertyInitial("displayOnly")){return this.getDisplayOnly();}var o=this.getParent();return!o.getProperty("_editable");}return false;}
function d(){if(this.getWrapping&&!this.isPropertyInitial("wrapping")){return this.getWrapping();}return true;}
function e(){var i=this.getFields();var o=i.length>0?i[0]:null;var j=this._oLabel;if(j){j.setLabelFor(o);}else{j=this.getLabel();if(j instanceof C){j.setAlternativeLabelFor(o);}}}
function f(o){o.addDelegate(this._oFieldDelegate);if(!this._bNoObserverChange){if(o.getMetadata().getProperty("required")){this._oObserver.observe(o,{properties:["required"]});}if(o.getMetadata().getProperty("editable")){this._oObserver.observe(o,{properties:["editable"]});}}}
function g(o){o.removeDelegate(this._oFieldDelegate);if(!this._bNoObserverChange){this._oObserver.unobserve(o);}}
function h(o){var p=this.oElement.getParent();if(p&&p.contentOnAfterRendering){p.contentOnAfterRendering(this.oElement,o.srcControl);}}
return F;});
sap.ui.predefine('sap/ui/layout/form/FormLayout',['sap/ui/core/Control','sap/ui/layout/library','./FormLayoutRenderer','sap/ui/core/theming/Parameters','sap/ui/thirdparty/jquery','sap/ui/dom/jquery/Selectors','sap/ui/dom/jquery/control'],function(C,l,F,P,q){"use strict";var B=l.BackgroundDesign;
var a=C.extend("sap.ui.layout.form.FormLayout",{metadata:{library:"sap.ui.layout",properties:{backgroundDesign:{type:"sap.ui.layout.BackgroundDesign",group:"Appearance",defaultValue:B.Translucent}}}});
a.prototype.init=function(){this._sFormTitleSize="H4";this._sFormSubTitleSize="H5";};
a.prototype.onBeforeRendering=function(e){this.loadTitleSizes();};
a.prototype.contentOnAfterRendering=function(f,c){if(l.form.FormHelper.bArrowKeySupport){q(c.getFocusDomRef()).data("sap.InNavArea",true);}if(c.getWidth&&(!c.getWidth()||c.getWidth()=="auto")&&(!c.getFormDoNotAdjustWidth||!c.getFormDoNotAdjustWidth())){c.$().css("width","100%");}};
a.prototype.toggleContainerExpanded=function(c){var e=c.getExpanded();if(this.getDomRef()){if(e){c.$("content").css("display","");}else{c.$("content").css("display","none");}}};
a.prototype.getLayoutDataForElement=function(e,t){var L=e.getLayoutData();if(!L){return undefined;}else if(L.isA(t)){return L;}else if(L.isA("sap.ui.core.VariantLayoutData")){var b=L.getMultipleLayoutData();for(var i=0;i<b.length;i++){var o=b[i];if(o.isA(t)){return o;}}}};
a.prototype.onsapright=function(e){if(l.form.FormHelper.bArrowKeySupport){var r=sap.ui.getCore().getConfiguration().getRTL();if(!r){this.navigateForward(e);}else{this.navigateBack(e);}}};
a.prototype.onsapleft=function(e){if(l.form.FormHelper.bArrowKeySupport){var r=sap.ui.getCore().getConfiguration().getRTL();if(!r){this.navigateBack(e);}else{this.navigateForward(e);}}};
a.prototype.onsapdown=function(e){if(l.form.FormHelper.bArrowKeySupport){var c=e.srcControl;var n;var r=this.findElement(c);var E=r.element;c=r.rootControl;if(E&&E.isA("sap.ui.layout.form.FormElement")){n=this.findFieldBelow(c,E);}else if(E&&E.isA("sap.ui.layout.form.FormContainer")){n=this.findFirstFieldOfNextElement(E,0);}if(n){n.focus();e.preventDefault();}}};
a.prototype.onsapup=function(e){if(l.form.FormHelper.bArrowKeySupport){var c=e.srcControl;var i=0;var n;var r=this.findElement(c);var E=r.element;c=r.rootControl;if(E&&E.isA("sap.ui.layout.form.FormElement")){n=this.findFieldAbove(c,E);}else if(E&&E.isA("sap.ui.layout.form.FormContainer")){var f=E.getParent();i=f.indexOfFormContainer(E);n=this.findLastFieldOfLastElementInPrevContainer(f,i-1);}if(n){n.focus();e.preventDefault();}}};
a.prototype.onsaphome=function(e){if(l.form.FormHelper.bArrowKeySupport){var c=e.srcControl;var i=0;var n;var r=this.findElement(c);var E=r.element;var o=E.getParent();var f=o.getParent();i=f.indexOfFormContainer(o);n=this.findFirstFieldOfFirstElementInNextContainer(f,i);if(n){n.focus();e.preventDefault();}}};
a.prototype.onsaptop=function(e){if(l.form.FormHelper.bArrowKeySupport){var c=e.srcControl;var r=this.findElement(c);var E=r.element;var n;var o;if(E&&E.isA("sap.ui.layout.form.FormElement")){o=E.getParent();}else if(E&&E.isA("sap.ui.layout.form.FormContainer")){o=E;}var f=o.getParent();n=this.findFirstFieldOfForm(f);if(n){n.focus();e.preventDefault();}}};
a.prototype.onsapend=function(e){if(l.form.FormHelper.bArrowKeySupport){var c=e.srcControl;var i=0;var n;var r=this.findElement(c);var E=r.element;var o=E.getParent();var f=o.getParent();i=f.indexOfFormContainer(o);n=this.findLastFieldOfLastElementInPrevContainer(f,i);if(n){n.focus();e.preventDefault();}}};
a.prototype.onsapbottom=function(e){if(l.form.FormHelper.bArrowKeySupport){var c=e.srcControl;var r=this.findElement(c);var E=r.element;var n;var o;if(E&&E.isA("sap.ui.layout.form.FormElement")){o=E.getParent();}else if(E&&E.isA("sap.ui.layout.form.FormContainer")){o=E;}var f=o.getParent();var b=f.getFormContainers();var L=b.length;n=this.findLastFieldOfLastElementInPrevContainer(f,L-1);if(n){n.focus();e.preventDefault();}}};
a.prototype.onsapexpand=function(e){var c=e.srcControl;var r=this.findElement(c);var E=r.element;var o;if(E.isA("sap.ui.layout.form.FormContainer")){o=E;}else{o=E.getParent();}if(o.getExpandable()&&c===o._oExpandButton){o.setExpanded(true);}};
a.prototype.onsapcollapse=function(e){var c=e.srcControl;var r=this.findElement(c);var E=r.element;var o;if(E.isA("sap.ui.layout.form.FormContainer")){o=E;}else{o=E.getParent();}if(o.getExpandable()&&c===o._oExpandButton){o.setExpanded(false);}};
a.prototype.onsapskipforward=function(e){var c=e.srcControl;var r=this.findElement(c);var E=r.element;c=r.rootControl;var n;var o;if(E&&E.isA("sap.ui.layout.form.FormElement")){o=E.getParent();}else if(E&&E.isA("sap.ui.layout.form.FormContainer")){o=E;}var f=o.getParent();var i=f.indexOfFormContainer(o);n=this.findFirstFieldOfFirstElementInNextContainer(f,i+1);if(n){n.focus();e.preventDefault();}};
a.prototype.onsapskipback=function(e){var c=e.srcControl;var r=this.findElement(c);var E=r.element;c=r.rootControl;var n;var o;if(E&&E.isA("sap.ui.layout.form.FormElement")){o=E.getParent();}else if(E&&E.isA("sap.ui.layout.form.FormContainer")){o=E;}var f=o.getParent();var b=f.getFormContainers();var i=f.indexOfFormContainer(o);while(!n&&i>0){var p=b[i-1];if(!p.getExpandable()||p.getExpanded()){n=this.findFirstFieldOfFirstElementInPrevContainer(f,i-1);}i=i-1;}if(n&&n!==c.getFocusDomRef()){n.focus();e.preventDefault();}};
a.prototype.onBeforeFastNavigationFocus=function(e){if(q.contains(this.getDomRef(),e.source)){e.srcControl=q(e.source).control(0);if(e.forward){this.onsapskipforward(e);}else{this.onsapskipback(e);}}else{var n=e.forward?this.findFirstFieldOfForm(this.getParent()):this.findFirstFieldOfLastContainerOfForm(this.getParent());if(n){n.focus();e.preventDefault();}}};
a.prototype.findElement=function(c){var e=c.getParent();var r=c;while(e&&!(e.isA("sap.ui.layout.form.FormElement"))&&!(e.isA("sap.ui.layout.form.FormContainer"))&&!(e.isA("sap.ui.layout.form.Form"))){r=e;e=e.getParent();}return({rootControl:r,element:e});};
a.prototype.navigateForward=function(e){var c=e.srcControl;var i=0;var n;var r=this.findElement(c);var E=r.element;c=r.rootControl;if(E&&E.isA("sap.ui.layout.form.FormElement")){if(c==E.getLabelControl()){i=-1;}else{i=E.indexOfField(c);}n=this.findNextFieldOfElement(E,i+1);if(!n){var o=E.getParent();i=o.indexOfFormElement(E);n=this.findFirstFieldOfNextElement(o,i+1);if(!n){var f=o.getParent();i=f.indexOfFormContainer(o);n=this.findFirstFieldOfFirstElementInNextContainer(f,i+1);}}}else if(E&&E.isA("sap.ui.layout.form.FormContainer")){n=this.findFirstFieldOfNextElement(E,0);}if(n){n.focus();e.preventDefault();}};
a.prototype.tabForward=function(e){var f;var c=e.srcControl;var i=0;var n;var r=this.findElement(c);var E=r.element;c=r.rootControl;if(E&&E.isA("sap.ui.layout.form.FormElement")){if(c==E.getLabelControl()){i=-1;}else{i=E.indexOfField(c);}n=this.findNextFieldOfElement(E,i+1,true);if(!n){var o=E.getParent();i=o.indexOfFormElement(E);n=this.findFirstFieldOfNextElement(o,i+1,true);if(!n){f=o.getParent();i=f.indexOfFormContainer(o);n=this.findFirstFieldOfFirstElementInNextContainer(f,i+1,true);}}}else if(E&&E.isA("sap.ui.layout.form.FormContainer")){n=this.findFirstFieldOfNextElement(E,0,true);if(!n){f=E.getParent();i=f.indexOfFormContainer(E);n=this.findFirstFieldOfFirstElementInNextContainer(f,i+1,true);}}if(n){n.focus();e.preventDefault();}};
a.prototype.findNextFieldOfElement=function(e,s,t){var f=e.getFieldsForRendering();var L=f.length;var n;for(var i=s;i<L;i++){var o=f[i];var d=this._getDomRef(o);if(t==true){if((!o.getEditable||o.getEditable())&&(!o.getEnabled||o.getEnabled())&&d){n=d;break;}}else{if((!o.getEnabled||o.getEnabled())&&d){n=d;break;}}}return n;};
a.prototype.findFirstFieldOfNextElement=function(c,s,t){var e=c.getFormElements();var L=e.length;var n;var i=s;while(!n&&i<L){var E=e[i];if(t==true){n=this.findNextFieldOfElement(E,0,true);}else{n=this.findNextFieldOfElement(E,0);}i++;}return n;};
a.prototype.findFirstFieldOfForm=function(f){var n=this.findFirstFieldOfFirstElementInNextContainer(f,0);return n;};
a.prototype.findFirstFieldOfLastContainerOfForm=function(f){var n;var c=f.getFormContainers();var i=c.length;while(!n&&i>0){var p=c[i-1];if(!p.getExpandable()||p.getExpanded()){n=this.findFirstFieldOfFirstElementInPrevContainer(f,i-1);}i=i-1;}return n;};
a.prototype.findFirstFieldOfFirstElementInNextContainer=function(f,s,t){var c=f.getFormContainers();var L=c.length;var n;var i=s;while(!n&&i<L){var o=c[i];if(o.getExpandable()&&t){n=o._oExpandButton.getFocusDomRef();if(n){break;}}if(!o.getExpandable()||o.getExpanded()){if(t==true){n=this.findFirstFieldOfNextElement(o,0,true);}else{n=this.findFirstFieldOfNextElement(o,0);}}i++;}return n;};
a.prototype.findFirstFieldOfFirstElementInPrevContainer=function(f,s){var c=f.getFormContainers();var L=c.length;var n;var i=s;while(!n&&i<L&&i>=0){var o=c[i];if(!o.getExpandable()||o.getExpanded()){n=this.findFirstFieldOfNextElement(o,0);}i++;}return n;};
a.prototype.navigateBack=function(e){var f;var c=e.srcControl;var i=0;var n;var r=this.findElement(c);var E=r.element;c=r.rootControl;if(E&&E.isA("sap.ui.layout.form.FormElement")){if(c==E.getLabelControl()){i=0;}else{i=E.indexOfField(c);}n=this.findPrevFieldOfElement(E,i-1);if(!n){var o=E.getParent();i=o.indexOfFormElement(E);n=this.findLastFieldOfPrevElement(o,i-1);if(!n){f=o.getParent();i=f.indexOfFormContainer(o);n=this.findLastFieldOfLastElementInPrevContainer(f,i-1);}}}else if(E&&E.isA("sap.ui.layout.form.FormContainer")){f=E.getParent();i=f.indexOfFormContainer(E);n=this.findLastFieldOfLastElementInPrevContainer(f,i-1);}if(n){n.focus();e.preventDefault();}};
a.prototype.tabBack=function(e){var f;var c=e.srcControl;var i=0;var n;var r=this.findElement(c);var E=r.element;c=r.rootControl;if(E&&E.isA("sap.ui.layout.form.FormElement")){if(c==E.getLabelControl()){i=0;}else{i=E.indexOfField(c);}n=this.findPrevFieldOfElement(E,i-1,true);if(!n){var o=E.getParent();i=o.indexOfFormElement(E);n=this.findLastFieldOfPrevElement(o,i-1,true);if(!n){f=o.getParent();i=f.indexOfFormContainer(o);if(o.getExpandable()){n=o._oExpandButton.getFocusDomRef();}if(!n){n=this.findLastFieldOfLastElementInPrevContainer(f,i-1,true);}}}}else if(E&&E.isA("sap.ui.layout.form.FormContainer")){f=E.getParent();i=f.indexOfFormContainer(E);n=this.findLastFieldOfLastElementInPrevContainer(f,i-1,true);}if(n){n.focus();e.preventDefault();}};
a.prototype.findPrevFieldOfElement=function(e,s,t){var f=e.getFieldsForRendering();var n;for(var i=s;i>=0;i--){var o=f[i];var d=this._getDomRef(o);if(t==true){if((!o.getEditable||o.getEditable())&&(!o.getEnabled||o.getEnabled())&&d){n=d;break;}}else{if((!o.getEnabled||o.getEnabled())&&d){n=d;break;}}}return n;};
a.prototype.findLastFieldOfPrevElement=function(c,s,t){var e=c.getFormElements();var n;var i=s;while(!n&&i>=0){var E=e[i];var L=E.getFieldsForRendering().length;if(t==true){n=this.findPrevFieldOfElement(E,L-1,true);}else{n=this.findPrevFieldOfElement(E,L-1);}i--;}return n;};
a.prototype.findLastFieldOfLastElementInPrevContainer=function(f,s,t){var c=f.getFormContainers();var n;var i=s;while(!n&&i>=0){var o=c[i];if(o.getExpandable()&&!o.getExpanded()&&t){n=o._oExpandButton.getFocusDomRef();if(n){break;}}if(!o.getExpandable()||o.getExpanded()){var L=o.getFormElements().length;if(t==true){n=this.findLastFieldOfPrevElement(o,L-1,true);}else{n=this.findLastFieldOfPrevElement(o,L-1,0);}}i--;}return n;};
a.prototype.findFieldBelow=function(c,e){var o=e.getParent();var i=o.indexOfFormElement(e);var n=this.findFirstFieldOfNextElement(o,i+1);if(!n){var f=o.getParent();i=f.indexOfFormContainer(o);n=this.findFirstFieldOfFirstElementInNextContainer(f,i+1);}return n;};
a.prototype.findFieldAbove=function(c,e){var o=e.getParent();var b=o.indexOfFormElement(e);var E=o.getFormElements();var n;var i=b-1;while(!n&&i>=0){var m=E[i];n=this.findPrevFieldOfElement(m,0);i--;}if(!n){var f=o.getParent();b=f.indexOfFormContainer(o);n=this.findLastFieldOfLastElementInPrevContainer(f,b-1);}return n;};
a.prototype._getDomRef=function(c){var d=c.getFocusDomRef();if(!q(d).is(":sapFocusable")){d=undefined;}return d;};
a.prototype.getContainerRenderedDomRef=function(c){if(this.getDomRef()){return c.getDomRef();}else{return null;}};
a.prototype.getElementRenderedDomRef=function(e){if(this.getDomRef()){return e.getDomRef();}else{return null;}};
a.prototype.getLayoutDataForDelimiter=function(){};
a.prototype.getLayoutDataForSemanticField=function(f,i,L){};
a.prototype.loadTitleSizes=function(){var s=P.get({name:['sap.ui.layout.FormLayout:_sap_ui_layout_FormLayout_FormTitleSize','sap.ui.layout.FormLayout:_sap_ui_layout_FormLayout_FormSubTitleSize'],callback:this.applyTitleSizes.bind(this)});if(s&&s.hasOwnProperty('sap.ui.layout.FormLayout:_sap_ui_layout_FormLayout_FormTitleSize')){this.applyTitleSizes(s,true);}};
a.prototype.applyTitleSizes=function(s,S){if(s&&(this._sFormTitleSize!==s["sap.ui.layout.FormLayout:_sap_ui_layout_FormLayout_FormTitleSize"]||this._sFormSubTitleSize!==s["sap.ui.layout.FormLayout:_sap_ui_layout_FormLayout_FormSubTitleSize"])){this._sFormTitleSize=s["sap.ui.layout.FormLayout:_sap_ui_layout_FormLayout_FormTitleSize"];this._sFormSubTitleSize=s["sap.ui.layout.FormLayout:_sap_ui_layout_FormLayout_FormSubTitleSize"];if(!S){this.invalidate();}}};
return a;});
sap.ui.predefine('sap/ui/layout/form/FormLayoutRenderer',['sap/ui/core/library','sap/ui/layout/library','sap/ui/layout/form/Form','sap/ui/core/IconPool'],function(c,l,F,I){"use strict";var T=c.TitleLevel;var B=l.BackgroundDesign;var a={apiVersion:2};
a.render=function(r,L){var f=L.getParent();if(f&&f instanceof F){this.renderForm(r,L,f);}};
a.renderForm=function(r,L,f){var t=f.getToolbar();r.openStart("div",L);r.class(this.getMainClass());if(t){r.class("sapUiFormToolbar");}this.addBackgroundClass(r,L);r.openEnd();this.renderHeader(r,t,f.getTitle(),undefined,false,L._sFormTitleSize,f.getId());this.renderContainers(r,L,f);r.close("div");};
a.getMainClass=function(){return"sapUiFormLayout";};
a.addBackgroundClass=function(r,L){var b=L.getBackgroundDesign();if(b!=B.Transparent){r.class("sapUiFormBackgr"+b);}};
a.renderContainers=function(r,L,f){var C=f.getVisibleFormContainers();for(var i=0,b=C.length;i<b;i++){var o=C[i];this.renderContainer(r,L,o);}};
a.renderContainer=function(r,L,C){var e=C.getExpandable();var t=C.getToolbar();var o=C.getTitle();r.openStart("section",C);r.class("sapUiFormContainer");if(t){r.class("sapUiFormContainerToolbar");}else if(o){r.class("sapUiFormContainerTitle");}if(C.getTooltip_AsString()){r.attr('title',C.getTooltip_AsString());}this.writeAccessibilityStateContainer(r,C);r.openEnd();this.renderHeader(r,t,o,C._oExpandButton,e,L._sFormSubTitleSize,C.getId());if(e){r.openStart("div",C.getId()+"-content");if(!C.getExpanded()){r.style("display","none");}r.openEnd();}var E=C.getVisibleFormElements();for(var j=0,b=E.length;j<b;j++){var d=E[j];this.renderElement(r,L,d);}if(e){r.close("div");}r.close("section");};
a.renderElement=function(r,L,e){var o=e.getLabelControl();r.openStart("div",e);r.class("sapUiFormElement");if(o){r.class("sapUiFormElementLbl");}r.openEnd();if(o){r.renderControl(o);}var f=e.getFieldsForRendering();if(f&&f.length>0){for(var k=0,b=f.length;k<b;k++){var d=f[k];r.renderControl(d);}}r.close("div");};
a.renderTitle=function(r,t,e,E,L,C){if(t){if(typeof t!=="string"&&t.getLevel()!=T.Auto){L=t.getLevel();}if(!L){L="H5";}if(typeof t!=="string"){r.openStart(L.toLowerCase(),t);if(t.getTooltip_AsString()){r.attr('title',t.getTooltip_AsString());}if(t.getEmphasized()){r.class("sapUiFormTitleEmph");}}else{r.openStart(L.toLowerCase(),C+"--title");}r.class("sapUiFormTitle");r.class("sapUiFormTitle"+L);if(E&&e){r.class("sapUiFormTitleExpandable");}r.openEnd();if(E&&e){r.renderControl(e);}if(typeof t==="string"){t.split(/\n/).forEach(function(s,d){if(d>0){r.voidStart("br").voidEnd();}r.text(s);});}else{var i=t.getIcon();if(i){var b=[];var A={"title":null};A["id"]=t.getId()+"-ico";r.icon(i,b,A);}t.getText().split(/\n/).forEach(function(s,d){if(d>0){r.voidStart("br").voidEnd();}r.text(s);});}r.close(L.toLowerCase());}};
a.renderHeader=function(r,t,o,e,E,L,C){if(t){r.renderControl(t);}else{this.renderTitle(r,o,e,E,L,C);}};
a.writeAccessibilityStateContainer=function(r,C){var A={};var t=C.getTitle();var o=C.getToolbar();if(o){if(!C.getAriaLabelledBy()||C.getAriaLabelledBy().length==0){var s=l.form.FormHelper.getToolbarTitle(o);A["labelledby"]={value:s,append:true};}}else if(t){var i="";if(typeof t=="string"){i=C.getId()+"--title";}else{i=t.getId();}A["labelledby"]={value:i,append:true};}if(A["labelledby"]||C.getAriaLabelledBy().length>0){A["role"]="form";}r.accessibilityState(C,A);};
return a;},true);
sap.ui.predefine('sap/ui/layout/form/FormRenderer',['sap/ui/layout/library',"sap/base/Log"],function(l,L){"use strict";var F={apiVersion:2};
F.render=function(r,f){var o=f.getLayout();var a={role:"form"};r.openStart("div",f).class("sapUiForm").class("sapUiFormLblColon").attr("data-sap-ui-customfastnavgroup","true");var c=l.form.FormHelper.addFormClass();if(c){r.class(c);}if(f.getEditable()){r.class("sapUiFormEdit");r.class("sapUiFormEdit-CTX");}else{a.readonly="";}if(f.getWidth()){r.style("width",f.getWidth());}if(f.getTooltip_AsString()){r.attr('title',f.getTooltip_AsString());}var t=f.getTitle();var T=f.getToolbar();if(T){if(!f.getAriaLabelledBy()||f.getAriaLabelledBy().length==0){var s=l.form.FormHelper.getToolbarTitle(T);a["labelledby"]=s;}}else if(t){var i="";if(typeof t=="string"){i=f.getId()+"--title";}else{i=t.getId();}a["labelledby"]={value:i,append:true};}else if(f._sSuggestedTitleId){a["labelledby"]={value:f._sSuggestedTitleId,append:true};}r.accessibilityState(f,a);r.openEnd();if(o){r.renderControl(o);}else{L.warning("Form \""+f.getId()+"\" - Layout missing!","Renderer","Form");}r.close("div");};
return F;},true);
sap.ui.predefine('sap/ui/layout/form/GridContainerData',['sap/ui/core/LayoutData','sap/ui/layout/library'],function(L,l){"use strict";
var G=L.extend("sap.ui.layout.form.GridContainerData",{metadata:{library:"sap.ui.layout",properties:{halfGrid:{type:"boolean",group:"Misc",defaultValue:false}}}});
return G;});
sap.ui.predefine('sap/ui/layout/form/GridElementData',['sap/ui/core/LayoutData','sap/ui/layout/library'],function(L,l){"use strict";
var G=L.extend("sap.ui.layout.form.GridElementData",{metadata:{library:"sap.ui.layout",properties:{hCells:{type:"sap.ui.layout.form.GridElementCells",group:"Appearance",defaultValue:'auto'},vCells:{type:"int",group:"Appearance",defaultValue:1}}}});
return G;});
sap.ui.predefine('sap/ui/layout/form/GridLayout',['sap/ui/layout/library','./FormLayout','./GridLayoutRenderer'],function(l,F,G){"use strict";
var a=F.extend("sap.ui.layout.form.GridLayout",{metadata:{library:"sap.ui.layout",deprecated:true,properties:{singleColumn:{type:"boolean",group:"Misc",defaultValue:false}}}});
a.prototype.toggleContainerExpanded=function(c){this.invalidate();};
a.prototype.onAfterRendering=function(){var f=this.getParent();if(f){var c=f.getVisibleFormContainers();for(var i=0;i<c.length;i++){var C=c[i];if(C.getExpandable()&&C._oExpandButton){C._oExpandButton.$().attr("tabindex","-1");}}}};
a.prototype.onLayoutDataChange=function(e){if(this.getDomRef()){this.invalidate();}};
a.prototype.onsaptabnext=function(e){this.tabForward(e);};
a.prototype.onsaptabprevious=function(e){this.tabBack(e);};
a.prototype.findFieldOfElement=function(e,s,L){if(!L){return F.prototype.findPrevFieldOfElement.apply(this,arguments);}if(!e.isVisible()){return null;}var f=e.getFieldsForRendering();var n;var I=f.length;s=I-1;for(var i=s;i>=0;i--){var o=f[i];var b=o.$().offset().left;if(L<b&&i!=0){continue;}var d=this._getDomRef(o);if((!o.getEnabled||o.getEnabled())&&d){n=d;break;}}return n;};
a.prototype.findFieldBelow=function(c,e){var C=e.getParent();var b=C.indexOfFormElement(e);var n;if(C.isVisible()){var E=C.getFormElements();var m=E.length;var i=b+1;var L=c.$().offset().left;while(!n&&i<m){var N=E[i];n=this.findFieldOfElement(N,0,L);i++;}}if(!n){var f=C.getParent();b=f.indexOfFormContainer(C);n=this.findFirstFieldOfFirstElementInNextContainer(f,b+1);}return n;};
a.prototype.findFieldAbove=function(c,e){var C=e.getParent();var b=C.indexOfFormElement(e);var n;if(C.isVisible()){var E=C.getFormElements();var i=b-1;var L=c.$().offset().left;while(!n&&i>=0){var N=E[i];n=this.findFieldOfElement(N,0,L);i--;}}if(!n){var f=C.getParent();b=f.indexOfFormContainer(C);n=this.findLastFieldOfLastElementInPrevContainer(f,b-1);}return n;};
a.prototype.getContainerRenderedDomRef=function(c){return null;};
a.prototype.getElementRenderedDomRef=function(e){if(this.getDomRef()){var s=this.getSingleColumn();var c=e.getParent();var C=this.getLayoutDataForElement(c,"sap.ui.layout.form.GridContainerData");if((s||!C||!C.getHalfGrid())&&!this.getRenderer().checkFullSizeElement(this,e)){return e.getDomRef();}}return null;};
return a;});
sap.ui.predefine('sap/ui/layout/form/GridLayoutRenderer',['sap/ui/core/Renderer','sap/ui/core/theming/Parameters','./FormLayoutRenderer',"sap/base/Log"],function(R,t,F,L){"use strict";var G=R.extend(F);G.apiVersion=2;
G.renderForm=function(r,l,f){var s=l.getSingleColumn();var c=16;var S=false;var C=0;var a=f.getFormContainers();var b=a.length;var i=0;var o;var d;var T=f.getToolbar();var e=f.getTitle();if(s){c=c/2;C=c;}else{C=c/2;for(i=0;i<b;i++){d=this.getContainerData(l,a[i]);if(d&&d.getHalfGrid()){S=true;break;}}}r.openStart("table",l).attr("role","presentation").attr("cellpadding","0").attr("cellspacing","0").style("border-collapse","collapse").style("table-layout","fixed").style("width","100%").class("sapUiGrid");this.addBackgroundClass(r,l);if(T){r.class("sapUiFormToolbar");}r.openEnd();r.openStart("colgroup").openEnd();r.voidStart("col").attr("span",C).voidEnd();if(S){r.voidStart("col").class("sapUiGridSpace").attr("span","1").voidEnd();}if(!s){r.voidStart("col").attr("span",C).voidEnd();}r.close("colgroup");r.openStart("tbody").openEnd();if(T||e){var g=c;if(S){g++;}r.openStart("tr").class("sapUiGridTitle").openEnd();r.openStart("th").attr("colspan",g).openEnd();this.renderHeader(r,T,e,undefined,false,l._sFormTitleSize,f.getId());r.close("th");r.close("tr");}i=0;var h;var j;while(i<b){o=a[i];o._checkProperties();if(o.isVisible()){d=this.getContainerData(l,o);if(d&&d.getHalfGrid()&&!s){h=a[i+1];j=undefined;if(h&&h.isVisible()){j=this.getContainerData(l,h);}if(j&&j.getHalfGrid()){h._checkProperties();this.renderContainerHalfSize(r,l,o,h,c);i++;}else{this.renderContainerHalfSize(r,l,o,undefined,c);}}else{this.renderContainerFullSize(r,l,o,c,S);}}i++;}r.close("tbody");r.close("table");};
G.renderContainerFullSize=function(r,l,c,C,s){var e=c.getExpandable();var T=c.getTooltip_AsString();var o=c.getToolbar();var a=c.getTitle();if(o||a){var b=C;if(s){b++;}r.openStart("tr").class("sapUiGridConteinerFirstRow").class("sapUiGridConteinerHeaderRow").openEnd();r.openStart("td").attr("colspan",b);r.class("sapUiGridHeader");if(T){r.attr('title',T);}if(o){r.class("sapUiFormContainerToolbar");}else if(a){r.class("sapUiFormContainerTitle");}r.openEnd();this.renderHeader(r,o,c.getTitle(),c._oExpandButton,e,l._sFormSubTitleSize,c.getId());r.close("td");r.close("tr");}if(!e||c.getExpanded()){var E=c.getFormElements();var d;var f=[];var g;var h=false;for(var j=0,k=E.length;j<k;j++){d=E[j];if(d.isVisible()){g=f[0]&&(f[0][0]==C);if(!this.checkFullSizeElement(l,d)&&f[0]!="full"&&!g){r.openStart("tr",d);r.class("sapUiFormElement");}else{r.openStart("tr");}if(!h){h=true;if(!o&&!a){r.class("sapUiGridConteinerFirstRow");}}r.openEnd();if(!g){f=this.renderElement(r,l,d,false,C,s,f);}else{f.splice(0,1);}r.close("tr");if(f[0]=="full"||g){j=j-1;}}}if(f.length>0){for(var i=0;i<f.length;i++){r.openStart("tr").openEnd().close("tr");}}}};
G.renderContainerHalfSize=function(r,l,c,C,a){var b=a/2;var e=c.getExpandable();var T=c.getTooltip_AsString();var s;var o=c.getTitle();var d;var f=c.getToolbar();var g;var E=[];if(!e||c.getExpanded()){E=c.getFormElements();}var h=E.length;var j=[];var k=0;var m=false;if(C){m=C.getExpandable();s=C.getTooltip_AsString();d=C.getTitle();g=C.getToolbar();if(!m||C.getExpanded()){j=C.getFormElements();}k=j.length;}if(o||d||f||g){r.openStart("tr").class("sapUiGridConteinerFirstRow").class("sapUiGridConteinerHeaderRow").openEnd();r.openStart("td").attr("colspan",b);r.class("sapUiGridHeader");if(T){r.attr('title',T);}if(f){r.class("sapUiFormContainerToolbar");}else if(o){r.class("sapUiFormContainerTitle");}r.openEnd();if(c){this.renderHeader(r,f,o,c._oExpandButton,e,l._sFormSubTitleSize,c.getId());}r.close("td");r.openStart("td").openEnd().close("td");r.openStart("td").attr("colspan",b);r.class("sapUiGridHeader");if(s){r.attr('title',s);}if(g){r.class("sapUiFormContainerToolbar");}else if(d){r.class("sapUiFormContainerTitle");}r.openEnd();if(C){this.renderHeader(r,g,d,C._oExpandButton,m,l._sFormSubTitleSize,C.getId());}r.close("td");r.close("tr");}if((!e||c.getExpanded())||(!m||C.getExpanded())){var n=[],p=[];var q=0,u=0;var v;var w;var x;var y;var z=false;while(q<h||u<k){v=E[q];w=j[u];x=n[0]&&(n[0][0]==b);y=p[0]&&(p[0][0]==b);if((v&&v.isVisible())||(w&&w.isVisible())||x||y){r.openStart("tr");if(!z){z=true;if(!f&&!o&&!g&&!d){r.class("sapUiGridConteinerFirstRow");}}r.openEnd();if(!x){if(v&&v.isVisible()&&(!e||c.getExpanded())){n=this.renderElement(r,l,v,true,b,false,n);}else{r.openStart("td").attr("colspan",b).openEnd().close("td");}if(n[0]!="full"){q++;}}else{if(n[0][2]>0){r.openStart("td").attr("colspan",n[0][2]).openEnd().close("td");}n.splice(0,1);}r.openStart("td").openEnd().close("td");if(!y){if(w&&w.isVisible()&&(!m||C.getExpanded())){p=this.renderElement(r,l,w,true,b,false,p);}else{r.openStart("td").attr("colspan",b).openEnd().close("td");}if(p[0]!="full"){u++;}}else{if(p[0][2]>0){r.openStart("td").attr("colspan",p[0][2]).openEnd().close("td");}p.splice(0,1);}r.close("tr");}else{q++;u++;}}if(n.length>0||p.length>0){for(var i=0;i<n.length||i<p.length;i++){r.openStart("tr").openEnd().close("tr");}}}};
G.renderElement=function(r,l,e,h,c,s,a){var o=e.getLabelControl();var b=0;var f=e.getFieldsForRendering();var C=0;var A=0;var m=false;var d=1;var g=1;var x=0;if(this.checkFullSizeElement(l,e)){if(a.length>0&&a[0]!="full"){L.error("Element \""+e.getId()+"\" - Too much fields for one row!","Renderer","GridLayout");return a;}if(s){c=c+1;}if(o&&a[0]!="full"){r.openStart("td").attr("colspan",c).class("sapUiFormElementLbl").class("sapUiGridLabelFull").openEnd();r.renderControl(o);r.close("td");return["full"];}else{a.splice(0,1);g=this.getElementData(l,f[0]).getVCells();r.openStart("td").attr("colspan",c);if(g>1&&h){r.attr("rowspan",g);for(x=0;x<g-1;x++){a.push([c,undefined,false]);}}r.openEnd();r.renderControl(f[0]);r.close("td");return a;}}if(a.length>0&&a[0][0]>0){c=c-a[0][0]+a[0][2];m=a[0][1];b=a[0][2];a.splice(0,1);}var j=b;var E;var k="";if(o||b>0){j=3;if(o&&b==0){E=this.getElementData(l,o);if(E){k=E.getHCells();if(k!="auto"&&k!="full"){j=parseInt(k);}}}r.openStart("td").attr("colspan",j).class("sapUiFormElementLbl").openEnd();if(o){r.renderControl(o);}c=c-j;r.close("td");}if(f&&f.length>0){var n=c;var p=f.length;var q;var i=0;var u=0;for(i=0,u=f.length;i<u;i++){q=f[i];E=this.getElementData(l,q);if(E&&E.getHCells()!="auto"){n=n-parseInt(E.getHCells());p=p-1;}}var v=0;for(i=0,v=0,u=f.length;i<u;i++){q=f[i];E=this.getElementData(l,q);k="auto";d=1;g=1;if(E){k=E.getHCells();g=E.getVCells();}if(k=="auto"){if(n>0){d=Math.floor(n/p);if(d<1){d=1;}v++;A=A+d;if((v==p)&&(n>A)){d=d+(n-A);}}else{d=1;}}else{d=parseInt(k);}C=C+d;if(C>c){L.error("Element \""+e.getId()+"\" - Too much fields for one row!","Renderer","GridLayout");C=C-d;break;}if(g>1){for(x=0;x<g-1;x++){if(o){b=j;}if(a.length>x){a[x][0]=a[x][0]+d;a[x][2]=b;}else{a.push([j+d,undefined,b]);}}}if(s&&C>=Math.floor(c/2)&&!m){d=d+1;m=true;if(g>1){for(x=0;x<g-1;x++){a[x][1]=true;}}}r.openStart("td");if(d>1){r.attr("colspan",d);}if(g>1){r.attr("rowspan",g);}r.openEnd();r.renderControl(q);r.close("td");}}if(C<c){var w=c-C;if(!h&&s&&!m){w++;}r.openStart("td").attr("colspan",w).openEnd().close("td");}return a;};
G.checkFullSizeElement=function(l,e){var f=e.getFieldsForRendering();if(f.length==1&&this.getElementData(l,f[0])&&this.getElementData(l,f[0]).getHCells()=="full"){return true;}else{return false;}};
G.getContainerData=function(l,c){return l.getLayoutDataForElement(c,"sap.ui.layout.form.GridContainerData");};
G.getElementData=function(l,c){return l.getLayoutDataForElement(c,"sap.ui.layout.form.GridElementData");};
return G;},true);
sap.ui.predefine('sap/ui/layout/form/ResponsiveGridLayout',['sap/ui/core/Control','sap/ui/core/ResizeHandler','sap/ui/layout/library','sap/ui/layout/Grid','sap/ui/layout/GridData','./Form','./FormContainer','./FormElement','./FormLayout','./ResponsiveGridLayoutRenderer',"sap/ui/thirdparty/jquery"],function(C,R,l,G,a,F,b,c,d,e,q){"use strict";
var f=d.extend("sap.ui.layout.form.ResponsiveGridLayout",{metadata:{library:"sap.ui.layout",properties:{labelSpanXL:{type:"int",group:"Misc",defaultValue:-1},labelSpanL:{type:"int",group:"Misc",defaultValue:4},labelSpanM:{type:"int",group:"Misc",defaultValue:2},labelSpanS:{type:"int",group:"Misc",defaultValue:12},adjustLabelSpan:{type:"boolean",group:"Misc",defaultValue:true},emptySpanXL:{type:"int",group:"Misc",defaultValue:-1},emptySpanL:{type:"int",group:"Misc",defaultValue:0},emptySpanM:{type:"int",group:"Misc",defaultValue:0},emptySpanS:{type:"int",group:"Misc",defaultValue:0},columnsXL:{type:"int",group:"Misc",defaultValue:-1},columnsL:{type:"int",group:"Misc",defaultValue:2},columnsM:{type:"int",group:"Misc",defaultValue:1},singleContainerFullSize:{type:"boolean",group:"Misc",defaultValue:true},breakpointXL:{type:"int",group:"Misc",defaultValue:1440},breakpointL:{type:"int",group:"Misc",defaultValue:1024},breakpointM:{type:"int",group:"Misc",defaultValue:600}}}});
var P=C.extend("sap.ui.layout.form.ResponsiveGridLayoutPanel",{
metadata:{library:"sap.ui.layout",aggregations:{"content":{type:"sap.ui.layout.Grid",multiple:false}},associations:{"container":{type:"sap.ui.layout.form.FormContainer",multiple:false},"layout":{type:"sap.ui.layout.form.ResponsiveGridLayout",multiple:false}}},
getLayoutData:function(){var i=sap.ui.getCore().byId(this.getContainer());var L=sap.ui.getCore().byId(this.getLayout());var j;if(L&&i){j=L.getLayoutDataForElement(i,"sap.ui.layout.GridData");}if(j){return j;}else{return this.getAggregation("layoutData");}},
getCustomData:function(){var i=sap.ui.getCore().byId(this.getContainer());if(i){return i.getCustomData();}},
refreshExpanded:function(){var i=sap.ui.getCore().byId(this.getContainer());if(i){if(i.getExpanded()){this.$().removeClass("sapUiRGLContainerColl");}else{this.$().addClass("sapUiRGLContainerColl");}}},
renderer:{apiVersion:2,render:function(i,j){var s=sap.ui.getCore().byId(j.getContainer());var L=sap.ui.getCore().byId(j.getLayout());var t=j.getContent();var E=s.getExpandable();var T=s.getTooltip_AsString();var u=s.getToolbar();var v=s.getTitle();i.openStart("div",j);i.class("sapUiRGLContainer");if(E&&!s.getExpanded()){i.class("sapUiRGLContainerColl");}if(u){i.class("sapUiFormContainerToolbar");}else if(v){i.class("sapUiFormContainerTitle");}if(T){i.attr('title',T);}L.getRenderer().writeAccessibilityStateContainer(i,s);i.openEnd();L.getRenderer().renderHeader(i,u,v,s._oExpandButton,E,L._sFormSubTitleSize,s.getId());if(t){i.openStart("div");i.class("sapUiRGLContainerCont");i.openEnd();i.renderControl(t);i.close("div");}i.close("div");}}
});
f.prototype.init=function(){d.prototype.init.apply(this,arguments);this.mContainers={};this.oDummyLayoutData=new a(this.getId()+"--Dummy");};
f.prototype.exit=function(){for(var s in this.mContainers){p.call(this,s,true);}if(this._mainGrid){this._mainGrid.destroy();delete this._mainGrid;}this.oDummyLayoutData.destroy();this.oDummyLayoutData=undefined;};
f.prototype.onBeforeRendering=function(E){d.prototype.onBeforeRendering.apply(this,arguments);var i=this.getParent();if(!i||!(i instanceof F)){return;}i._bNoInvalidate=true;_.call(this,i);r.call(this,i);i._bNoInvalidate=false;};
f.prototype.onAfterRendering=function(E){if(this._mainGrid&&this._mainGrid.__bIsUsed){for(var s in this.mContainers){if(this.mContainers[s][1]._sContainerResizeListener){R.deregister(this.mContainers[s][1]._sContainerResizeListener);this.mContainers[s][1]._sContainerResizeListener=null;}}}};
f.prototype.toggleContainerExpanded=function(i){var s=i.getId();if(this.mContainers[s]&&this.mContainers[s][0]){var j=this.mContainers[s][0];j.refreshExpanded();}};
f.prototype.onLayoutDataChange=function(E){var s=E.srcControl;if(s instanceof b){if(this._mainGrid){this._mainGrid.onLayoutDataChange(E);this.invalidate();}}else if(!(s instanceof c)){var i=s.getParent();if(i instanceof c){var j=i.getParent();var t=j.getId();if(this.mContainers[t]&&this.mContainers[t][1]){this.mContainers[t][1].onLayoutDataChange(E);}}}};
f.prototype.onsapup=function(E){this.onsapleft(E);};
f.prototype.onsapdown=function(E){this.onsapright(E);};
f.prototype.getContainerRenderedDomRef=function(i){if(this.getDomRef()){var s=i.getId();if(this.mContainers[s]){if(this.mContainers[s][0]){var j=this.mContainers[s][0];return j.getDomRef();}else if(this.mContainers[s][1]){var t=this.mContainers[s][1];return t.getDomRef();}}}return null;};
f.prototype.getElementRenderedDomRef=function(E){return null;};
function _(j){var v=j.getVisibleFormContainers();var V=v.length;var s=0;var t;var u;var w;var x;var i=0;for(i=0;i<V;i++){w=v[i];w._checkProperties();if(w.isVisible()){s++;x=w.getId();t=undefined;u=undefined;var y=v[i+1];if(this.mContainers[x]&&this.mContainers[x][1]){u=this.mContainers[x][1];}else{u=k.call(this,w);}var T=w.getTitle();var z=w.getToolbar();if(z||T||w.getExpandable()){if(this.mContainers[x]&&this.mContainers[x][0]){t=this.mContainers[x][0];}else{t=g.call(this,w,u);n(u,true);}o(t,w,s,y,V);}else{if(this.mContainers[x]&&this.mContainers[x][0]){h(this.mContainers[x][0]);}n(u,false);o(u,w,s,y,V);}this.mContainers[x]=[t,u];}}var O=Object.keys(this.mContainers).length;if(V<O){for(x in this.mContainers){var A=false;for(i=0;i<V;i++){w=v[i];if(x==w.getId()){A=true;break;}}if(!A){p.call(this,x);}}}}
function g(i,j){var s=i.getId();var t=new P(s+"---Panel",{container:i,layout:this,content:j});return t;}
function h(i,D){i.setLayout(null);i.setContainer(null);if(!D||!i.getParent()){i.setContent(null);i.destroy();}}
function k(t){var I=t.getId()+"--Grid";var u=new G(I,{vSpacing:0,hSpacing:0,containerQuery:true});u.__myParentLayout=this;u.__myParentContainerId=t.getId();u.addStyleClass("sapUiFormResGridCont").addStyleClass("sapUiRespGridOverflowHidden");u.getContent=function(){var t=sap.ui.getCore().byId(this.__myParentContainerId);if(t){var s=[];var E=t.getVisibleFormElements();var w;var y;for(var i=0;i<E.length;i++){var z=E[i];y=z.getLabelControl();if(y){s.push(y);}w=z.getFieldsForRendering();for(var j=0;j<w.length;j++){s.push(w[j]);}}return s;}else{return false;}};u.getAriaLabelledBy=function(){var t=sap.ui.getCore().byId(this.__myParentContainerId);if(t&&!t.getToolbar()&&!t.getTitle()&&!t.getExpandable()){return t.getAriaLabelledBy();}return[];};var B={labelSpan:0,span:0,firstField:false,defaultFields:0,row:0,myRow:false,freeFields:0,finished:false};var x={id:"XL",getEffectiveSpan:function(i){var s=i._getEffectiveSpanXLarge();if(!s){s=i._getEffectiveSpanLarge();}return s;},getEmptySpan:function(i){var E=i.getEmptySpanXL();if(E<0){E=i.getEmptySpanL();}return E;},getLabelSpan:function(i){return i.getLabelSpanXL();},setIndent:function(i,j){i.setIndentXL(j);},setLinebreak:function(i,j){i.setLinebreakXL(j);}};q.extend(x,B);var L={id:"L",getEffectiveSpan:function(i){return i._getEffectiveSpanLarge();},getEmptySpan:function(i){return i.getEmptySpanL();},getLabelSpan:function(i){return i.getLabelSpanL();},setIndent:function(i,j){i.setIndentL(j);},setLinebreak:function(i,j){i.setLinebreakL(j);}};q.extend(L,B);var M={id:"M",getEffectiveSpan:function(i){return i._getEffectiveSpanMedium();},getEmptySpan:function(i){return i.getEmptySpanM();},getLabelSpan:function(i){return i.getLabelSpanM();},setIndent:function(i,j){i.setIndentM(j);},setLinebreak:function(i,j){i.setLinebreakM(j);}};q.extend(M,B);var S={id:"S",getEffectiveSpan:function(i){return i._getEffectiveSpanSmall();},getEmptySpan:function(i){return i.getEmptySpanS();},getLabelSpan:function(i){return i.getLabelSpanS();},setIndent:function(i,j){i.setIndentS(j);},setLinebreak:function(i,j){i.setLinebreakS(j);}};q.extend(S,B);var v=[x,L,M,S];u._getLayoutDataForControl=function(j){var w=this.__myParentLayout;var y=w.getLayoutDataForElement(j,"sap.ui.layout.GridData");var E=j.getParent();var z=E.getLabelControl();if(y){if(z==j){y._setStylesInternal("sapUiFormElementLbl");}return y;}else{var t=sap.ui.getCore().byId(this.__myParentContainerId);var A=w.getLayoutDataForElement(t,"sap.ui.layout.GridData");var D=t.getParent();var H;var s=0;for(s=0;s<v.length;s++){H=v[s];q.extend(H,B);H.labelSpan=H.getLabelSpan(w);}if(w.getAdjustLabelSpan()){if(D.getVisibleFormContainers().length>=1&&w.getColumnsM()>1){M.labelSpan=w.getLabelSpanL();}if(A){if(A._getEffectiveSpanLarge()==12){L.labelSpan=w.getLabelSpanM();M.labelSpan=w.getLabelSpanM();}}if(D.getVisibleFormContainers().length==1||w.getColumnsL()==1){L.labelSpan=w.getLabelSpanM();M.labelSpan=w.getLabelSpanM();}}if(x.labelSpan<0){x.labelSpan=L.labelSpan;}if(z==j){w.oDummyLayoutData.setSpan("XL"+x.labelSpan+" L"+L.labelSpan+" M"+M.labelSpan+" S"+S.labelSpan);w.oDummyLayoutData.setLinebreak(true);w.oDummyLayoutData.setIndentXL(0).setIndentL(0).setIndentM(0).setIndentS(0);w.oDummyLayoutData._setStylesInternal("sapUiFormElementLbl");return w.oDummyLayoutData;}else{var J;if(z){J=w.getLayoutDataForElement(z,"sap.ui.layout.GridData");}var K=E.getFieldsForRendering();var N=K.length;var O;var Q;var T=1;var U=false;var V;var i=0;for(s=0;s<v.length;s++){H=v[s];H.span=12-H.getEmptySpan(w);if(z){if(J){V=H.getEffectiveSpan(J);if(V){H.labelSpan=V;}}if(H.labelSpan<12){H.span=H.span-H.labelSpan;}}H.spanFields=H.span;}for(i=0;i<N;i++){O=K[i];if(O!=j){Q=w.getLayoutDataForElement(O,"sap.ui.layout.GridData");if(Q){for(s=0;s<v.length;s++){H=v[s];V=H.getEffectiveSpan(Q);if(V&&V<H.span){H.span=H.span-V;}}}else{T++;}}else{if(T==1){U=true;}}}var W=[];for(s=0;s<v.length;s++){H=v[s];H.firstField=U;H.defaultFields=T;if(H.span<T){H.defaultFields=0;H.row=0;H.myRow=false;H.freeFields=H.spanFields;H.span=H.spanFields;H.finished=false;W.push(H);}}if(W.length>0){for(i=0;i<N;i++){O=K[i];Q=undefined;if(O!=j){Q=w.getLayoutDataForElement(O,"sap.ui.layout.GridData");}for(s=0;s<W.length;s++){H=W[s];if(H.finished){continue;}if(Q){V=H.getEffectiveSpan(Q);H.span=H.span-V;}else{V=1;}if(H.freeFields>=V){H.freeFields=H.freeFields-V;if(!Q){H.defaultFields++;}}else{if(H.myRow){H.finished=true;}else{H.freeFields=H.spanFields-V;H.row++;if(Q){H.defaultFields=0;H.span=H.spanFields-V;}else{H.defaultFields=1;H.span=H.spanFields;}if(O==j){H.firstField=true;}}}if(O==j){H.myRow=true;}}}}var X=0;var Y="";var Z;for(s=0;s<v.length;s++){H=v[s];if(H.id!="S"||H.labelSpan<12){if(H.firstField){X=H.span-Math.floor(H.span/H.defaultFields)*H.defaultFields;Z=Math.floor(H.span/H.defaultFields)+X;}else{Z=Math.floor(H.span/H.defaultFields);}}else{Z=12;}if(Y){Y=Y+" ";}Y=Y+H.id+Z;H.setLinebreak(w.oDummyLayoutData,H.firstField&&(H.row>0));H.setIndent(w.oDummyLayoutData,H.firstField&&(H.row>0)?H.labelSpan:0);}w.oDummyLayoutData.setSpan(Y);w.oDummyLayoutData.setLinebreak(U&&!z);w.oDummyLayoutData._setStylesInternal(undefined);return w.oDummyLayoutData;}}};u._onParentResizeOrig=u._onParentResize;u._onParentResize=function(){if(!this.getDomRef()){this._cleanup();return;}if(!q(this.getDomRef()).is(":visible")){return;}var i=this.__myParentLayout;if(!i._mainGrid||!i._mainGrid.__bIsUsed){var j=i.getParent().getVisibleFormContainers()[0];if(!j||!i.mContainers[j.getId()]||j.getId()!=this.__myParentContainerId){return;}if(i.mContainers[this.__myParentContainerId][0]){var D=i.mContainers[this.__myParentContainerId][0].getDomRef();var s=D.clientWidth;if(s<=i.getBreakpointM()){this._toggleClass("Phone");}else if((s>i.getBreakpointM())&&(s<=i.getBreakpointL())){this._toggleClass("Tablet");}else if((s>i.getBreakpointL())&&(s<=i.getBreakpointXL())){this._toggleClass("Desktop");}else{this._toggleClass("LargeDesktop");}}else{this._setBreakPointTablet(i.getBreakpointM());this._setBreakPointDesktop(i.getBreakpointL());this._setBreakPointLargeDesktop(i.getBreakpointXL());this._onParentResizeOrig();}}else{var $=i._mainGrid.$();if($.hasClass("sapUiRespGridMedia-Std-Phone")){this._toggleClass("Phone");}else if($.hasClass("sapUiRespGridMedia-Std-Tablet")){this._toggleClass("Tablet");}else if($.hasClass("sapUiRespGridMedia-Std-Desktop")){this._toggleClass("Desktop");}else{this._toggleClass("LargeDesktop");}}};u._getAccessibleRole=function(){var t=sap.ui.getCore().byId(this.__myParentContainerId);var i=this.__myParentLayout;if(i._mainGrid&&i._mainGrid.__bIsUsed&&!t.getToolbar()&&!t.getTitle()&&!t.getExpandable()&&t.getAriaLabelledBy().length>0){return"form";}};u.getUIArea=function(){var i=this.__myParentLayout;if(i){return i.getUIArea();}else{return null;}};return u;}
function m(i,D){if(i.__myParentContainerId){i.__myParentContainerId=undefined;}i.__myParentLayout=undefined;if(!D||!i.getParent()){i.destroy();}}
function n(i,O){if(O){if(i.__originalGetLayoutData){i.getLayoutData=i.__originalGetLayoutData;delete i.__originalGetLayoutData;}}else if(!i.__originalGetLayoutData){i.__originalGetLayoutData=i.getLayoutData;i.getLayoutData=function(){var L=this.__myParentLayout;var j=sap.ui.getCore().byId(this.__myParentContainerId);var s;if(j){s=L.getLayoutDataForElement(j,"sap.ui.layout.GridData");}if(s){return s;}else{return this.getAggregation("layoutData");}};}}
function o(i,j,v,s,V){var L;if(i instanceof P){L=sap.ui.getCore().byId(i.getLayout());}else{L=i.__myParentLayout;}var t=L.getLayoutDataForElement(j,"sap.ui.layout.GridData");if(!t){var u=L.getColumnsM();var w=L.getColumnsL();var x=L.getColumnsXL();var y=(v%w)==1;var z=(v%w)==0;var A=v>(w*(Math.ceil(V/w)-1));var B=v<=w;var D=(v%u)==1;var E=(v%u)==0;var H=v>(u*(Math.ceil(V/u)-1));var I=v<=u;var J=false;var K=z;var M=A;var N=B;if(x>0){J=(v%x)==1;K=(v%x)==0;M=v>(x*(Math.ceil(V/x)-1));N=v<=x;}if(s){var O=L.getLayoutDataForElement(s,"sap.ui.layout.GridData");if(O&&(O.getLinebreak()||O.getLinebreakXL())){K=true;M=false;}if(O&&(O.getLinebreak()||O.getLinebreakL())){z=true;A=false;}if(O&&(O.getLinebreak()||O.getLinebreakM())){E=true;H=false;}}var S="";if(K){S="sapUiFormResGridLastContXL";}if(z){if(S){S=S+" ";}S=S+"sapUiFormResGridLastContL";}if(E){if(S){S=S+" ";}S=S+"sapUiFormResGridLastContM";}if(M){if(S){S=S+" ";}S=S+"sapUiFormResGridLastRowXL";}if(A){if(S){S=S+" ";}S=S+"sapUiFormResGridLastRowL";}if(H){if(S){S=S+" ";}S=S+"sapUiFormResGridLastRowM";}if(N){if(S){S=S+" ";}S=S+"sapUiFormResGridFirstRowXL";}if(B){if(S){S=S+" ";}S=S+"sapUiFormResGridFirstRowL";}if(I){if(S){S=S+" ";}S=S+"sapUiFormResGridFirstRowM";}t=i.getLayoutData();if(!t){t=new a(i.getId()+"--LD",{linebreakL:y,linebreakM:D});i.setLayoutData(t);}else{t.setLinebreakL(y);t.setLinebreakM(D);}if(x>0){t.setLinebreakXL(J);}t._setStylesInternal(S);}}
function p(s,D){var i=this.mContainers[s];var j=i[1];if(j){m(j,D);}var t=i[0];if(t){h(t,D);}delete this.mContainers[s];}
function r(s){var v=s.getVisibleFormContainers();var t;var u;var L=v.length;var w=0;var i=0;var j=0;if(L>1||!this.getSingleContainerFullSize()){var S=Math.floor(12/this.getColumnsM());var x=Math.floor(12/this.getColumnsL());var y;var D="";var z=this.getColumnsXL();if(z>=0){y=Math.floor(12/z);D=D+"XL"+y+" ";}D=D+"L"+x+" M"+S+" S12";if(!this._mainGrid){this._mainGrid=new G(s.getId()+"--Grid",{defaultSpan:D,hSpacing:0,vSpacing:0,containerQuery:true}).setParent(this);this._mainGrid.addStyleClass("sapUiFormResGridMain").addStyleClass("sapUiRespGridOverflowHidden");this._mainGrid._onParentResizeOrig=this._mainGrid._onParentResize;this._mainGrid._onParentResize=function(){this._onParentResizeOrig();var J=this.getParent();for(var u in J.mContainers){J.mContainers[u][1]._onParentResize();}};}else{this._mainGrid.setDefaultSpan(D);var A=this._mainGrid.getContent();w=A.length;var E=false;for(i=0;i<w;i++){var B=A[i];t=undefined;if(B.getContainer){t=sap.ui.getCore().byId(B.getContainer());}else{t=sap.ui.getCore().byId(B.__myParentContainerId);}if(t&&t.isVisible()){var V=v[j];if(t!=V){E=true;break;}var H=this.mContainers[t.getId()];if(H[0]&&H[0]!=B){E=true;break;}if(!H[0]&&H[1]&&H[1]!=B){E=true;break;}j++;}else{this._mainGrid.removeContent(B);}}if(E){this._mainGrid.removeAllContent();w=0;}}this._mainGrid._setBreakPointTablet(this.getBreakpointM());this._mainGrid._setBreakPointDesktop(this.getBreakpointL());this._mainGrid._setBreakPointLargeDesktop(this.getBreakpointXL());this._mainGrid.__bIsUsed=true;if(w<L){var I=0;if(w>0){I=w--;}for(i=I;i<L;i++){t=v[i];u=t.getId();if(this.mContainers[u]){if(this.mContainers[u][0]){this._mainGrid.addContent(this.mContainers[u][0]);}else if(this.mContainers[u][1]){this._mainGrid.addContent(this.mContainers[u][1]);}}}}}else{if(this._mainGrid){this._mainGrid.__bIsUsed=false;}for(i=0;i<L;i++){t=v[i];u=t.getId();if(this.mContainers[u]){if(this.mContainers[u][0]){if(this.mContainers[u][0].getParent()!==this){this.addDependent(this.mContainers[u][0]);}}else if(this.mContainers[u][1]){if(this.mContainers[u][1].getParent()!==this){this.addDependent(this.mContainers[u][1]);}}}}}}
f.prototype.getLayoutDataForDelimiter=function(){return new a({spanS:1,spanM:1,spanL:1,spanXL:1});};
f.prototype.getLayoutDataForSemanticField=function(i,I,L){var j=8-(i-1);j=Math.floor(j/i);if(i===I){j=j+8-((i-1)+i*j);}if(L){if(L.isA("sap.ui.layout.GridData")){L.setSpanS(11).setSpanM(j).setSpanL(j).setSpanXL(j);return L;}else{L.destroy();}}return new a({spanS:11,spanM:j,spanL:j,spanXL:j});};
return f;});
sap.ui.predefine('sap/ui/layout/form/ResponsiveGridLayoutRenderer',['sap/ui/core/Renderer','./FormLayoutRenderer'],function(R,F){"use strict";var a=R.extend(F);a.apiVersion=2;
a.getMainClass=function(){return"sapUiFormResGrid";};
a.renderContainers=function(r,l,f){var v=f.getVisibleFormContainers();var L=v.length;if(L>0){if(L>1||!l.getSingleContainerFullSize()){r.renderControl(l._mainGrid);}else if(l.mContainers[v[0].getId()][0]){r.renderControl(l.mContainers[v[0].getId()][0]);}else{r.renderControl(l.mContainers[v[0].getId()][1]);}}};
return a;},true);
sap.ui.predefine('sap/ui/layout/form/ResponsiveLayout',['sap/ui/core/Control','sap/ui/layout/library','sap/ui/layout/ResponsiveFlowLayout','sap/ui/layout/ResponsiveFlowLayoutData','./Form','./FormContainer','./FormElement','./FormLayout','./ResponsiveLayoutRenderer'],function(C,l,R,a,F,b,c,d,e){"use strict";
var f=d.extend("sap.ui.layout.form.ResponsiveLayout",{metadata:{library:"sap.ui.layout"}});
var P=C.extend("sap.ui.layout.form.ResponsiveLayoutPanel",{
metadata:{library:"sap.ui.layout",aggregations:{"content":{type:"sap.ui.layout.ResponsiveFlowLayout",multiple:false}},associations:{"container":{type:"sap.ui.layout.form.FormContainer",multiple:false},"layout":{type:"sap.ui.layout.form.ResponsiveLayout",multiple:false}}},
getLayoutData:function(){var i=sap.ui.getCore().byId(this.getContainer());var L=sap.ui.getCore().byId(this.getLayout());var j;if(L&&i){j=L.getLayoutDataForElement(i,"sap.ui.layout.ResponsiveFlowLayoutData");}return j;},
getCustomData:function(){var i=sap.ui.getCore().byId(this.getContainer());if(i){return i.getCustomData();}},
refreshExpanded:function(){var i=sap.ui.getCore().byId(this.getContainer());if(i){if(i.getExpanded()){this.$().removeClass("sapUiRLContainerColl");}else{this.$().addClass("sapUiRLContainerColl");}}},
renderer:{apiVersion:2,render:function(i,j){var t=sap.ui.getCore().byId(j.getContainer());var L=sap.ui.getCore().byId(j.getLayout());var u=j.getContent();if(!t||!L){return;}var E=t.getExpandable();var T=t.getTooltip_AsString();var v=t.getToolbar();var w=t.getTitle();i.openStart("div",j);i.class("sapUiRLContainer");if(E&&!t.getExpanded()){i.class("sapUiRLContainerColl");}if(v){i.class("sapUiFormContainerToolbar");}else if(w){i.class("sapUiFormContainerTitle");}if(T){i.attr('title',T);}L.getRenderer().writeAccessibilityStateContainer(i,t);i.openEnd();L.getRenderer().renderHeader(i,v,w,t._oExpandButton,E,L._sFormSubTitleSize,t.getId());if(u){i.openStart("div");i.class("sapUiRLContainerCont");i.openEnd();i.renderControl(u);i.close("div");}i.close("div");}}
});
f.prototype.init=function(){d.prototype.init.apply(this,arguments);this.mContainers={};this._defaultLayoutData=new a({margin:false});};
f.prototype.exit=function(){for(var i in this.mContainers){q.call(this,i);}if(this._mainRFLayout){this._mainRFLayout.destroy();delete this._mainRFLayout;}this._defaultLayoutData.destroy();delete this._defaultLayoutData;};
f.prototype.onBeforeRendering=function(E){d.prototype.onBeforeRendering.apply(this,arguments);var i=this.getParent();if(!i||!(i instanceof F)){return;}i._bNoInvalidate=true;_.call(this,i);s.call(this,i);i._bNoInvalidate=false;};
f.prototype.toggleContainerExpanded=function(i){var j=i.getId();if(this.mContainers[j]&&this.mContainers[j][0]){var t=this.mContainers[j][0];t.refreshExpanded();}};
f.prototype.onLayoutDataChange=function(E){var S=E.srcControl;var i;var j;var t;if(S instanceof b){if(this._mainRFLayout){this._mainRFLayout.onLayoutDataChange(E);}}else if(S instanceof c){j=S.getParent().getId();if(this.mContainers[j]&&this.mContainers[j][1]){this.mContainers[j][1].onLayoutDataChange(E);}}else{var u=S.getParent();if(u instanceof c){i=u.getParent();j=i.getId();t=u.getId();if(this.mContainers[j]&&this.mContainers[j][2]&&this.mContainers[j][2][t]){if(this.mContainers[j][2][t][1]){var v=u.getFieldsForRendering();o.call(this,this.mContainers[j][2][t][1],v);}this.mContainers[j][2][t][0].onLayoutDataChange(E);}}}};
f.prototype.onsapup=function(E){this.onsapleft(E);};
f.prototype.onsapdown=function(E){this.onsapright(E);};
f.prototype.getContainerRenderedDomRef=function(i){if(this.getDomRef()){var j=i.getId();if(this.mContainers[j]){if(this.mContainers[j][0]){var t=this.mContainers[j][0];return t.getDomRef();}else if(this.mContainers[j][1]){var u=this.mContainers[j][1];return u.getDomRef();}}}return null;};
f.prototype.getElementRenderedDomRef=function(E){if(this.getDomRef()){var i=E.getParent();var j=E.getId();var t=i.getId();if(this.mContainers[t]){if(this.mContainers[t][2]){var u=this.mContainers[t][2];if(u[j]){var v=u[j][0];return v.getDomRef();}}}}return null;};
function _(j){var v=j.getVisibleFormContainers();var V=v.length;var t;var u;var w;var x;var i=0;for(i=0;i<V;i++){t=v[i];t._checkProperties();u=t.getId();w=undefined;x=undefined;if(this.mContainers[u]&&this.mContainers[u][1]){x=this.mContainers[u][1];}else{x=m.call(this,t,undefined);}var T=t.getTitle();var y=t.getToolbar();if(y||T||t.getExpandable()){if(this.mContainers[u]&&this.mContainers[u][0]){w=this.mContainers[u][0];}else{w=g.call(this,t,x);n(x,true);}x.removeStyleClass("sapUiRLContainer");}else{if(this.mContainers[u]&&this.mContainers[u][0]){h(this.mContainers[u][0]);n(x,false);}x.addStyleClass("sapUiRLContainer");}var z=k.call(this,t,x);this.mContainers[u]=[w,x,z];}var O=Object.keys(this.mContainers).length;if(V<O){for(u in this.mContainers){var A=false;for(i=0;i<V;i++){t=v[i];if(u==t.getId()){A=true;break;}}if(!A){q.call(this,u);}}}}
function g(i,j){var t=i.getId();var u=new P(t+"--Panel",{container:i,layout:this,content:j});return u;}
function h(i){i.setContent(null);i.setLayout(null);i.setContainer(null);i.destroy();}
function k(j,t){var u=j.getId();var E=j.getVisibleFormElements();var v=E.length;var w={};if(this.mContainers[u]&&this.mContainers[u][2]){w=this.mContainers[u][2];}var x;var y;var L=-1;var z;var A;var i=0;for(i=0;i<v;i++){z=E[i];A=z.getId();r.call(this,j,z,w,t,i);if(w[A]){x=w[A][0];L=t.indexOfContent(x);if(L!=v){t.removeContent(x);t.insertContent(x,v);L=v;}}else{x=m.call(this,j,z);x.addStyleClass("sapUiRLElement");if(z.getLabel()){x.addStyleClass("sapUiRLElementWithLabel");}w[A]=[x,undefined];L++;t.insertContent(x,L);}var B=z.getFieldsForRendering();if(z.getLabel()&&B.length>1){if(w[A][1]){y=w[A][1];}else{y=m.call(this,j,z,true);y.addStyleClass("sapUiRLElementFields");w[A][1]=y;}o.call(this,y,B);}else{if(w[A][1]){y=w[A][1];p(y);w[A][1]=undefined;}}}var O=Object.keys(w).length;if(v<O){for(A in w){var D=false;for(i=0;i<v;i++){z=E[i];if(A==z.getId()){D=true;break;}}if(!D){if(w[A][1]){y=w[A][1];p(y);}x=w[A][0];t.removeContent(x);p(x);delete w[A];}}}return w;}
function m(i,E,j){var I;if(E&&!j){I=E.getId()+"--RFLayout";}else if(E&&j){I=E.getId()+"--content--RFLayout";}else if(i){I=i.getId()+"--RFLayout";}else{return false;}var t=new R(I);t.__myParentLayout=this;t.__myParentContainerId=i.getId();if(E){t.__myParentElementId=E.getId();if(!j){t.getContent=function(){var E=sap.ui.getCore().byId(this.__myParentElementId);if(E){var u=[];var L=E.getLabelControl();var v=E.getFieldsForRendering();if(!L||v.length<=1){u=v;if(L){u.unshift(L);}}else{var w=this.__myParentLayout;var x=this.__myParentContainerId;var y=E.getId();if(L){u.push(L);}if(w.mContainers[x]&&w.mContainers[x][2]&&w.mContainers[x][2][y]&&w.mContainers[x][2][y][1]){u.push(w.mContainers[x][2][y][1]);}}return u;}else{return false;}};t._addContentClass=function(u,v){if(v==0){var E=sap.ui.getCore().byId(this.__myParentElementId);if(E){var L=E.getLabelControl();if(u==L){return"sapUiFormElementLbl";}}}return null;};}else{t.getContent=function(){var E=sap.ui.getCore().byId(this.__myParentElementId);if(E){return E.getFieldsForRendering();}else{return false;}};}}else if(i){t._getAccessibleRole=function(){var i=sap.ui.getCore().byId(this.__myParentContainerId);var L=this.__myParentLayout;if(L._mainRFLayout&&!i.getToolbar()&&!i.getTitle()&&!i.getExpandable()&&i.getAriaLabelledBy().length>0){return"form";}};t.getAriaLabelledBy=function(){var i=sap.ui.getCore().byId(this.__myParentContainerId);if(i&&!i.getToolbar()&&!i.getTitle()&&!i.getExpandable()){return i.getAriaLabelledBy();}return[];};}if((E&&!j)||(!E&&!i.getToolbar()&&!i.getTitle()&&!i.getExpandable())){n(t,false);}else{t.setLayoutData(new a({margin:false}));}return t;}
function n(i,O){if(O){if(i.__originalGetLayoutData){i.getLayoutData=i.__originalGetLayoutData;delete i.__originalGetLayoutData;}}else if(!i.__originalGetLayoutData){i.__originalGetLayoutData=i.getLayoutData;i.getLayoutData=function(){var L=this.__myParentLayout;var j=sap.ui.getCore().byId(this.__myParentContainerId);var E=sap.ui.getCore().byId(this.__myParentElementId);var t;if(E){t=L.getLayoutDataForElement(E,"sap.ui.layout.ResponsiveFlowLayoutData");}else if(j){t=L.getLayoutDataForElement(j,"sap.ui.layout.ResponsiveFlowLayoutData");}if(t){return t;}else if(E){return L._defaultLayoutData;}};}}
function o(j,t){var L;var w=0;for(var i=0;i<t.length;i++){var u=t[i];L=this.getLayoutDataForElement(u,"sap.ui.layout.ResponsiveFlowLayoutData");if(L){w=w+L.getWeight();}else{w++;}}L=j.getLayoutData();if(L){L.setWeight(w);}else{j.setLayoutData(new a({weight:w}));}}
function p(i){if(i.__myParentContainerId){i.__myParentContainerId=undefined;}if(i.__myParentElementId){i.__myParentElementId=undefined;}i.__myParentLayout=undefined;i.destroy();}
function q(i){var j=this.mContainers[i];var t;var E=j[2];if(E){for(var u in E){if(E[u][1]){p(E[u][1]);}t=E[u][0];p(t);delete E[u];}}t=j[1];if(t){t.removeAllContent();p(t);}var v=j[0];if(v){h(v);}delete this.mContainers[i];}
function r(i,E,j,t,I){var u=E.getId();var v=u+"--RFLayout";var w=sap.ui.getCore().byId(v);if(!j[u]&&w){var O=w.__myParentContainerId;j[u]=this.mContainers[O][2][u];t.insertContent(w,I);w.__myParentContainerId=i.getId();if(j[u][1]){j[u][1].__myParentContainerId=i.getId();}delete this.mContainers[O][2][u];}}
function s(t){var v=t.getVisibleFormContainers();var u;var L=v.length;var w=0;var i=0;var j=0;if(L>1){if(!this._mainRFLayout){this._mainRFLayout=new R(t.getId()+"--RFLayout").setParent(this);}else{var x=this._mainRFLayout.getContent();w=x.length;var E=false;for(i=0;i<w;i++){var y=x[i];u=undefined;if(y.getContainer){u=sap.ui.getCore().byId(y.getContainer());}else{u=sap.ui.getCore().byId(y.__myParentContainerId);}if(u&&u.isVisible()){var V=v[j];if(u!=V){E=true;break;}var z=this.mContainers[u.getId()];if(z[0]&&z[0]!=y){E=true;break;}if(!z[0]&&z[1]&&z[1]!=y){E=true;break;}j++;}else{this._mainRFLayout.removeContent(y);}}if(E){this._mainRFLayout.removeAllContent();w=0;}}if(w<L){var S=0;if(w>0){S=w--;}for(i=S;i<L;i++){u=v[i];var A=u.getId();if(this.mContainers[A]){if(this.mContainers[A][0]){this._mainRFLayout.addContent(this.mContainers[A][0]);}else if(this.mContainers[A][1]){this._mainRFLayout.addContent(this.mContainers[A][1]);}}}}}}
return f;});
sap.ui.predefine('sap/ui/layout/form/ResponsiveLayoutRenderer',['sap/ui/core/Renderer','./FormLayoutRenderer'],function(R,F){"use strict";var a=R.extend(F);a.apiVersion=2;
a.getMainClass=function(){return"sapUiFormResLayout";};
a.renderContainers=function(r,l,f){var v=f.getVisibleFormContainers();var L=v.length;if(L>0){if(L>1){r.renderControl(l._mainRFLayout);}else if(l.mContainers[v[0].getId()][0]){r.renderControl(l.mContainers[v[0].getId()][0]);}else{r.renderControl(l.mContainers[v[0].getId()][1]);}}};
return a;},true);
sap.ui.predefine('sap/ui/layout/form/SemanticFormElement',['./FormElement','sap/ui/layout/library'],function(F,l){"use strict";
var S=F.extend("sap.ui.layout.form.SemanticFormElement",{metadata:{library:"sap.ui.layout",properties:{delimiter:{type:"string",group:"Data",defaultValue:"/"}},aggregations:{fieldLabels:{type:"sap.ui.core.Label",multiple:true},_delimiters:{type:"sap.ui.core.Control",multiple:true,visibility:"hidden"},_displayField:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}}}});
S.prototype.init=function(){F.prototype.init.apply(this,arguments);this._oObserver.observe(this,{properties:["_editable","delimiter"],aggregations:["fieldLabels"]});};
S.prototype.exit=function(){F.prototype.exit.apply(this,arguments);};
S.prototype.enhanceAccessibilityState=function(E,A){var D=this.getAggregation("delimiters",[]);if(D.indexOf(E)<0){if(this.getProperty("_editable")){var i=this.indexOfField(E);if(i>=0){var n=this.getFieldLabels();var L=n[i];if(L){var t;if(typeof L==="string"){t=L;}else{t=L.getText();}var s=A["label"];if(!s){s=t;}else{s=s+" "+t;}A["label"]=s;var o=A["labelledby"];if(o){L=this.getLabelControl();var p=o.split(" ");i=p.indexOf(L.getId());if(i>=0){p.splice(i,1);o=p.join(" ");}A["labelledby"]=o;}return A;}}}}F.prototype.enhanceAccessibilityState.apply(this,arguments);};
S.prototype.onLayoutDataChange=function(E){var o=E.srcControl;var L=o.getLayoutData();if(!L||!L._bSetBySemanticFormElement){m.call(this);}F.prototype.onLayoutDataChange.apply(this,arguments);};
S.prototype.getFieldsForRendering=function(){var n=[];if(!this._bLayoutDataCreated){m.call(this);}if(this.getProperty("_editable")){var o=this.getFields();var D=this.getAggregation("_delimiters",[]);for(var i=0;i<o.length;i++){var p=o[i];if(p.getVisible()){if(n.length>0&&D[i-1]){n.push(D[i-1]);}n.push(p);}}}else{var q=this.getAggregation("_displayField");if(q){n.push(q);}}return n;};
S.prototype._observeChanges=function(C){F.prototype._observeChanges.apply(this,arguments);if(C.object===this){if(C.name==="fields"){a.call(this,C.child,C.mutation);}else if(C.name==="_editable"){_.call(this,C.current);}else if(C.name==="delimiter"){b.call(this,C.current);}else if(C.name==="fieldLabels"){c.call(this,C.mutation,C.child);}}else{if(C.object.isA("sap.ui.core.Label")){e.call(this,C);}else{d.call(this,C);}}};
function _(E){if(E){this.destroyAggregation("_displayField");f.call(this);}else{this.destroyAggregation("_delimiters");g.call(this);}}
function a(o,M){if(M==="insert"){if(!o.isA("sap.ui.core.IFormContent")||!o.isA("sap.ui.core.ISemanticFormContent")){throw new Error(o+" is not valid Form content. "+this);}var p=["visible"];if(o.getFormValueProperty){p.push(o.getFormValueProperty());}else if(o.getMetadata().getProperty("value")){p.push("value");}else if(o.getMetadata().getProperty("text")){p.push("text");}this._oObserver.observe(o,{properties:p});}else{var L=o.getLayoutData();if(L&&L._bSetBySemanticFormElement){L.destroy();}}if(this.getProperty("_editable")){f.call(this);}else{g.call(this,true);}k.call(this);}
function b(D){if(this.getProperty("_editable")){f.call(this);}else{h.call(this,false);}k.call(this);}
function c(M,L){if(typeof L!=="string"){if(M==="insert"){this._oObserver.observe(L,{properties:["text"]});}else{this._oObserver.unobserve(L);}}k.call(this);}
function d(C){var p=C.object.getFormValueProperty?C.object.getFormValueProperty():null;if(C.name===p||C.name==="value"||C.name==="text"){if(!this.getProperty("_editable")){h.call(this,false);}}else if(C.name==="visible"){if(this.getProperty("_editable")){f.call(this);}else{g.call(this,true);}k.call(this);this.invalidate();}}
function e(C){k.call(this);}
function f(){var n=this.getFields();var D=this.getAggregation("_delimiters",[]);var s=this.getDelimiter();var I=this.getId()+"-delimiter-";var i=0;for(i=0;i<n.length;i++){if(i<n.length-1){if(D.length>i){l.form.FormHelper.updateDelimiter(D[i],s);}else{var o=l.form.FormHelper.createDelimiter(s,I+i);this.addAggregation("_delimiters",o);}}}if(D.length>0&&D.length>n.length-1){for(i=n.length-1;i<D.length;i++){D[i].destroy();}}m.call(this);}
var r={onBeforeRendering:function(){h.call(this,true);}};
function g(s){var D=this.getAggregation("_displayField");if(D){h.call(this,false);}else{var i=this.getId()+"-display";D=l.form.FormHelper.createSemanticDisplayControl("",i);D.addDelegate(r,true,this);this.setAggregation("_displayField",D);}}
function h(n){var D=this.getAggregation("_displayField");if(D&&(D.getDomRef()||n)){if(n&&D._bNoForceUpdate){D._bNoForceUpdate=false;return;}var o=this.getFields();var t=[];var A=false;for(var i=0;i<o.length;i++){var p=o[i];if(p.getVisible()){var P=p.getFormValueProperty?p.getFormValueProperty():null;var T;if(p.getFormFormattedValue){T=p.getFormFormattedValue();if(T instanceof Promise){A=true;}}else if(P){T=p.getProperty(P);}else if(p.getMetadata().getProperty("value")){T=p.getValue();}else if(p.getMetadata().getProperty("text")){T=p.getText();}t.push(T);}}D._bNoForceUpdate=true;if(A){Promise.all(t).then(function(t){var D=this.getAggregation("_displayField");var s=j.call(this,t);D._bNoForceUpdate=true;l.form.FormHelper.updateSemanticDisplayControl(D,s);}.bind(this));}else{var s=j.call(this,t);l.form.FormHelper.updateSemanticDisplayControl(D,s);}}else if(D&&D._bNoForceUpdate){D._bNoForceUpdate=false;}}
function j(t){var D=this.getDelimiter();var T="";for(var i=0;i<t.length;i++){T=T+t[i];if(i<t.length-1){T=T+" "+D+" ";}}return T;}
function k(){if(!this.getLabel()){var n=this.getFieldLabels();var o=this.getFields();var t=[];for(var i=0;i<n.length;i++){if(o[i]&&o[i].getVisible()){var p=n[i];if(typeof p==="string"){t.push(p);}else{t.push(p.getText());}}}var T=j.call(this,t);this._setInternalLabel(T);}}
function m(){var n=this.getFields().filter(function(t){return t.getVisible();});var D=this.getAggregation("_delimiters",[]);var o=this.getParent();var p=o&&o.getParent();var L=p&&p.getLayout();var q;var i=0;if(!L||!L.getLayoutDataForDelimiter){return;}if(this.getProperty("_editable")){for(i=0;i<D.length;i++){var s=D[i];if(!s.getLayoutData()){q=L.getLayoutDataForDelimiter();if(q){if(q instanceof Promise){q.then(function(q){q._bSetBySemanticFormElement=true;this.setLayoutData(q);}.bind(s));}else if(q.isA("sap.ui.core.LayoutData")){q._bSetBySemanticFormElement=true;s.setLayoutData(q);}}}}if(n.length>1){for(i=0;i<n.length;i++){var t=n[i];q=t.getLayoutData();if(!q||q._bSetBySemanticFormElement){q=L.getLayoutDataForSemanticField(n.length,i+1,q);if(q){if(q instanceof Promise){q.then(function(q){q._bSetBySemanticFormElement=true;this.setLayoutData(q);}.bind(t));}else if(q.isA("sap.ui.core.LayoutData")&&!q._bSetBySemanticFormElement){q._bSetBySemanticFormElement=true;t.setLayoutData(q);}}}}}this._bLayoutDataCreated=true;}}
return S;});
sap.ui.predefine('sap/ui/layout/form/SimpleForm',['sap/ui/core/Control','sap/ui/base/ManagedObjectObserver','sap/ui/core/ResizeHandler','sap/ui/layout/library','./Form','./FormContainer','./FormElement','./FormLayout','./SimpleFormRenderer',"sap/base/Log","sap/ui/thirdparty/jquery"],function(C,M,R,l,F,a,b,c,S,L,q){"use strict";var B=l.BackgroundDesign;var d=l.form.SimpleFormLayout;var e;var f;var g;var G;var h;var m;var n;
var o=C.extend("sap.ui.layout.form.SimpleForm",{metadata:{library:"sap.ui.layout",properties:{maxContainerCols:{type:"int",group:"Appearance",defaultValue:2},minWidth:{type:"int",group:"Appearance",defaultValue:-1},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},editable:{type:"boolean",group:"Misc",defaultValue:null},labelMinWidth:{type:"int",group:"Misc",defaultValue:192},layout:{type:"sap.ui.layout.form.SimpleFormLayout",group:"Misc",defaultValue:d.ResponsiveLayout},labelSpanXL:{type:"int",group:"Misc",defaultValue:-1},labelSpanL:{type:"int",group:"Misc",defaultValue:4},labelSpanM:{type:"int",group:"Misc",defaultValue:2},labelSpanS:{type:"int",group:"Misc",defaultValue:12},adjustLabelSpan:{type:"boolean",group:"Misc",defaultValue:true},emptySpanXL:{type:"int",group:"Misc",defaultValue:-1},emptySpanL:{type:"int",group:"Misc",defaultValue:0},emptySpanM:{type:"int",group:"Misc",defaultValue:0},emptySpanS:{type:"int",group:"Misc",defaultValue:0},columnsXL:{type:"int",group:"Misc",defaultValue:-1},columnsL:{type:"int",group:"Misc",defaultValue:2},columnsM:{type:"int",group:"Misc",defaultValue:1},singleContainerFullSize:{type:"boolean",group:"Misc",defaultValue:true},breakpointXL:{type:"int",group:"Misc",defaultValue:1440},breakpointL:{type:"int",group:"Misc",defaultValue:1024},breakpointM:{type:"int",group:"Misc",defaultValue:600},backgroundDesign:{type:"sap.ui.layout.BackgroundDesign",group:"Appearance",defaultValue:B.Translucent}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Element",multiple:true,singularName:"content"},form:{type:"sap.ui.layout.form.Form",multiple:false,visibility:"hidden"},title:{type:"sap.ui.core.Title",altTypes:["string"],multiple:false},toolbar:{type:"sap.ui.core.Toolbar",multiple:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},designtime:"sap/ui/layout/designtime/form/SimpleForm.designtime"}});
o.prototype.init=function(){this._iMaxWeight=8;this._iLabelWeight=3;this._iCurrentWidth=0;var i=new F(this.getId()+"--Form");i.getTitle=function(){return this.getParent().getTitle();};i._origInvalidate=i.invalidate;i.invalidate=function(j){if(this.bOutput){this._origInvalidate(j);}if(this._bIsBeingDestroyed){return;}var k=this.getParent();if(k){k._formInvalidated(j);}};i.getAriaLabelledBy=function(){var j=this.getParent();if(j){return j.getAriaLabelledBy();}else{return null;}};i._origOnLayoutDataChange=i.onLayoutDataChange;i.onLayoutDataChange=function(j){this._origOnLayoutDataChange(j);var k=this.getParent();if(k){k._onLayoutDataChange(j);}};this.setAggregation("form",i);this._aElements=null;this._aLayouts=[];this._changedFormContainers=[];this._changedFormElements=[];this._oObserver=new M(W.bind(this));};
o.prototype.exit=function(){var j=this.getAggregation("form");j.invalidate=j._origInvalidate;U.call(this);for(var i=0;i<this._aLayouts.length;i++){var k=sap.ui.getCore().byId(this._aLayouts[i]);if(k&&k.destroy){k.destroy();}}this._aLayouts=[];this._aElements=null;this._changedFormContainers=[];this._changedFormElements=[];this._oObserver.disconnect();this._oObserver=undefined;};
o.prototype.onBeforeRendering=function(){U.call(this);var i=this.getAggregation("form");var j=this.getLayout();if((!this._bResponsiveLayoutRequested&&j===d.ResponsiveLayout)||(!this._bGridLayoutRequested&&j===d.GridLayout)||(!this._bResponsiveGridLayoutRequested&&j===d.ResponsiveGridLayout)||(!this._bColumnLayoutRequested&&j===d.ColumnLayout)){var k=true;if(!i.getLayout()){k=_.call(this);}if(k){x.call(this);}}};
o.prototype.onAfterRendering=function(){if(this.getLayout()==d.ResponsiveLayout){this._bChangedByMe=true;this.$().css("visibility","hidden");this._applyLinebreaks();this._sResizeListenerId=R.register(this.getDomRef(),q.proxy(this._resize,this));this._bChangedByMe=false;}};
o.prototype.setEditable=function(i){this._bChangedByMe=true;this.setProperty("editable",i,true);var j=this.getAggregation("form");j.setEditable(i);this._bChangedByMe=false;return this;};
o.prototype.setToolbar=function(i){this._bChangedByMe=true;var j=this.getAggregation("form");j.setToolbar(i);this._bChangedByMe=false;return this;};
o.prototype.getToolbar=function(){var i=this.getAggregation("form");return i.getToolbar();};
o.prototype.destroyToolbar=function(){this._bChangedByMe=true;var i=this.getAggregation("form");i.destroyToolbar();this._bChangedByMe=false;return this;};
o.prototype.setLabelMinWidth=function(j){this.setProperty("labelMinWidth",j,true);if(this.getLayout()==d.ResponsiveLayout){this._bLayoutDataChangedByMe=true;var k=this.getContent();for(var i=0;i<k.length;i++){var Y=k[i];if(Y.isA("sap.ui.core.Label")){var Z=A.call(this,Y);if(Z&&Z.isA("sap.ui.layout.ResponsiveFlowLayoutData")&&y.call(this,Z)){Z.setMinWidth(j);}}}this._bLayoutDataChangedByMe=false;}return this;};
o.prototype.indexOfContent=function(j){var k=this._aElements;if(k){for(var i=0;i<k.length;i++){if(k[i]==j){return i;}}}return-1;};
o.prototype.addContent=function(i){i=this.validateAggregation("content",i,true);if(this.indexOfContent(i)>=0){L.warning("SimpleForm.addContent: Content element '"+i+"' already assigned. Please remove before adding!",this);this.removeContent(i);}if(!this._aElements){this._aElements=[];}this._bChangedByMe=true;var j=this._aElements.length;var k;var Y=this.getAggregation("form");var Z;var $;var a1;var b1;if(i.isA(["sap.ui.core.Title","sap.ui.core.Toolbar"])){Z=P.call(this,i);Y.addFormContainer(Z);this._changedFormContainers.push(Z);}else if(i.isA("sap.ui.core.Label")){if(j>0){k=this._aElements[j-1];a1=k.getParent();if(a1 instanceof b){Z=a1.getParent();}else if(a1 instanceof a){Z=a1;}}if(!Z){Z=P.call(this);Y.addFormContainer(Z);this._changedFormContainers.push(Z);}$=K.call(this,Z,i);}else{if(j>0){k=this._aElements[j-1];a1=k.getParent();if(a1 instanceof b){Z=a1.getParent();$=a1;b1=A.call(this,i);if(b1&&b1.isA("sap.ui.layout.ResponsiveFlowLayoutData")&&!y.call(this,b1)&&b1.getLinebreak()){$=K.call(this,Z);}}else if(a1 instanceof a){Z=a1;$=K.call(this,Z);}}else{Z=P.call(this);Y.addFormContainer(Z);this._changedFormContainers.push(Z);$=K.call(this,Z);}E.call(this,i,5,false,true);$.addField(i);V(this._changedFormElements,$);}this._aElements.push(i);this._oObserver.observe(i,{properties:["visible"]});this.invalidate();this._bChangedByMe=false;return this;};
o.prototype.insertContent=function(j,k){j=this.validateAggregation("content",j,true);if(this.indexOfContent(j)>=0){L.warning("SimpleForm.insertContent: Content element '"+j+"' already assigned. Please remove before insert!",this);this.removeContent(j);}if(!this._aElements){this._aElements=[];}var Y=this._aElements.length;var Z;if(k<0){Z=0;}else if(k>Y){Z=Y;}else{Z=k;}if(Z!==k){L.warning("SimpleForm.insertContent: index '"+k+"' out of range [0,"+Y+"], forced to "+Z);}if(Z==Y){this.addContent(j);return this;}this._bChangedByMe=true;var $=this._aElements[Z];var a1=this.getAggregation("form");var b1;var c1;var d1;var e1;var f1;var g1=0;var h1;var i1;var j1;var k1;var i=0;var l1;var m1;if(j.isA(["sap.ui.core.Title","sap.ui.core.Toolbar"])){if(k==0&&!($.isA(["sap.ui.core.Title","sap.ui.core.Toolbar"]))){b1=$.getParent().getParent();if(j.isA("sap.ui.core.Title")){b1.setTitle(j);}else{b1.setToolbar(j);}}else{b1=P.call(this,j);if($.isA(["sap.ui.core.Title","sap.ui.core.Toolbar"])){d1=$.getParent();f1=a1.indexOfFormContainer(d1);}else{e1=$.getParent();d1=e1.getParent();f1=a1.indexOfFormContainer(d1)+1;g1=d1.indexOfFormElement(e1);if(!$.isA("sap.ui.core.Label")){h1=e1.indexOfField($);if(h1>0||e1.getLabel()){c1=K.call(this,b1);this._changedFormElements.push(c1);V(this._changedFormElements,e1);i1=e1.getFields();for(i=h1;i<i1.length;i++){l1=i1[i];c1.addField(l1);}g1++;}}j1=d1.getFormElements();for(i=g1;i<j1.length;i++){b1.addFormElement(j1[i]);}}a1.insertFormContainer(b1,f1);}this._changedFormContainers.push(b1);}else if(j.isA("sap.ui.core.Label")){if($.isA(["sap.ui.core.Title","sap.ui.core.Toolbar"])){d1=$.getParent();f1=a1.indexOfFormContainer(d1);k1=a1.getFormContainers();if(f1==0){b1=P.call(this);a1.insertFormContainer(b1,f1);this._changedFormContainers.push(b1);}else{b1=k1[f1-1];}c1=K.call(this,b1,j);}else if($.isA("sap.ui.core.Label")){d1=$.getParent().getParent();g1=d1.indexOfFormElement($.getParent());c1=N.call(this,d1,j,g1);}else{e1=$.getParent();d1=e1.getParent();g1=d1.indexOfFormElement(e1)+1;h1=e1.indexOfField($);if(h1==0&&!e1.getLabel()){c1=e1;c1.setLabel(j);E.call(this,j,this._iLabelWeight,false,true,this.getLabelMinWidth());}else{c1=N.call(this,d1,j,g1);V(this._changedFormElements,e1);i1=e1.getFields();for(i=h1;i<i1.length;i++){l1=i1[i];c1.addField(l1);}}}this._changedFormElements.push(c1);}else{m1=A.call(this,j);if($.isA(["sap.ui.core.Title","sap.ui.core.Toolbar"])){d1=$.getParent();f1=a1.indexOfFormContainer(d1);if(f1==0){b1=P.call(this);a1.insertFormContainer(b1,f1);this._changedFormContainers.push(b1);}else{k1=a1.getFormContainers();b1=k1[f1-1];}j1=b1.getFormElements();if(j1.length==0){c1=K.call(this,b1);}else if(m1&&m1.isA("sap.ui.layout.ResponsiveFlowLayoutData")&&!y.call(this,m1)&&m1.getLinebreak()){c1=K.call(this,b1);}else{c1=j1[j1.length-1];}c1.addField(j);}else if($.isA("sap.ui.core.Label")){e1=$.getParent();b1=e1.getParent();g1=b1.indexOfFormElement(e1);if(g1==0){c1=N.call(this,b1,null,0);}else if(m1&&m1.isA("sap.ui.layout.ResponsiveFlowLayoutData")&&!y.call(this,m1)&&m1.getLinebreak()){c1=N.call(this,b1,null,g1);}else{j1=b1.getFormElements();c1=j1[g1-1];}c1.addField(j);}else{c1=$.getParent();h1=c1.indexOfField($);if(m1&&m1.isA("sap.ui.layout.ResponsiveFlowLayoutData")&&!y.call(this,m1)&&m1.getLinebreak()&&h1>0){b1=c1.getParent();g1=b1.indexOfFormElement(c1);V(this._changedFormElements,c1);i1=c1.getFields();c1=N.call(this,b1,undefined,g1+1);c1.addField(j);for(i=h1;i<i1.length;i++){l1=i1[i];c1.addField(l1);}}else{c1.insertField(j,h1);}}V(this._changedFormElements,c1);E.call(this,j,5,false,true);}this._aElements.splice(Z,0,j);this._oObserver.observe(j,{properties:["visible"]});this.invalidate();this._bChangedByMe=false;return this;};
o.prototype.removeContent=function(j){var k=null;var Y=-1;var i=0;if(this._aElements){if(typeof(j)=="string"){j=sap.ui.getCore().byId(j);}if(typeof(j)=="object"){for(i=0;i<this._aElements.length;i++){if(this._aElements[i]==j){j=i;break;}}}if(typeof(j)=="number"){if(j<0||j>=this._aElements.length){L.warning("Element.removeAggregation called with invalid index: Items, "+j);}else{Y=j;k=this._aElements[Y];}}}if(k){this._bChangedByMe=true;var Z=this.getAggregation("form");var $;var a1;var b1;var c1;if(k.isA(["sap.ui.core.Title","sap.ui.core.Toolbar"])){$=k.getParent();$.setTitle(null);$.setToolbar(null);if(Y>0){b1=$.getFormElements();var d1=Z.indexOfFormContainer($);var e1=Z.getFormContainers()[d1-1];if(b1.length>0&&!b1[0].getLabel()){var f1=e1.getFormElements();var g1=f1[f1.length-1];c1=b1[0].getFields();for(i=0;i<c1.length;i++){g1.addField(c1[i]);}V(this._changedFormElements,g1);$.removeFormElement(b1[0]);b1[0].destroy();b1.splice(0,1);}for(i=0;i<b1.length;i++){e1.addFormElement(b1[i]);}V(this._changedFormContainers,e1);Z.removeFormContainer($);$.destroy();}else if($.getFormElements().length==0){Z.removeFormContainer($);$.destroy();}}else if(k.isA("sap.ui.core.Label")){a1=k.getParent();$=a1.getParent();a1.setLabel(null);var h1=$.indexOfFormElement(a1);if(h1==0){if(a1.getFields().length==0){$.removeFormElement(a1);a1.destroy();if($.getFormElements().length==0&&!$.getTitle()&&!$.getToolbar()){Z.removeFormContainer($);$.destroy();}}else{V(this._changedFormElements,a1);}}else{b1=$.getFormElements();var i1=b1[h1-1];c1=a1.getFields();for(i=0;i<c1.length;i++){i1.addField(c1[i]);}V(this._changedFormElements,i1);$.removeFormElement(a1);a1.destroy();}}else{a1=k.getParent();a1.removeField(k);if(a1.getFields().length==0&&!a1.getLabel()){$=a1.getParent();$.removeFormElement(a1);a1.destroy();if($.getFormElements().length==0&&!$.getTitle()&&!$.getToolbar()){Z.removeFormContainer($);$.destroy();}}else{V(this._changedFormElements,a1);}}this._aElements.splice(Y,1);k.setParent(null);this._oObserver.unobserve(k);J.call(this,k);this.invalidate();this._bChangedByMe=false;return k;}return null;};
o.prototype.removeAllContent=function(){var i=0;if(this._aElements){this._bChangedByMe=true;var k=this.getAggregation("form");var Y=k.getFormContainers();for(i=0;i<Y.length;i++){var Z=Y[i];Z.setTitle(null);Z.setToolbar(null);var $=Z.getFormElements();for(var j=0;j<$.length;j++){var a1=$[j];a1.setLabel(null);a1.removeAllFields();}Z.destroyFormElements();}k.destroyFormContainers();for(i=0;i<this._aElements.length;i++){var b1=this._aElements[i];J.call(this,b1);this._oObserver.unobserve(b1);}var c1=this._aElements;this._aElements=null;this.invalidate();this._bChangedByMe=false;return c1;}else{return[];}};
o.prototype.destroyContent=function(){var j=this.removeAllContent();if(j){this._bChangedByMe=true;for(var i=0;i<j.length;i++){j[i].destroy();}this.invalidate();this._bChangedByMe=false;}return this;};
o.prototype.getContent=function(){if(!this._aElements){this._aElements=this.getAggregation("content",[]);}return this._aElements.slice();};
o.prototype.setLayout=function(i){var j=this.getLayout();if(i!=j){v.call(this);}this.setProperty("layout",i);if(i!=j){var k=_.call(this);if(k){w.call(this);}}return this;};
o.prototype.clone=function(k){this._bChangedByMe=true;var Y=C.prototype.clone.apply(this,arguments);var Z=this.getContent();for(var i=0;i<Z.length;i++){var $=Z[i];var a1=$.getLayoutData();this._oObserver.unobserve($);var b1=$.clone(k);this._oObserver.observe($,{properties:["visible"]});if(a1){if(a1.isA("sap.ui.core.VariantLayoutData")){var c1=a1.getMultipleLayoutData();for(var j=0;j<c1.length;j++){if(y.call(this,c1[j])){Y._aLayouts.push(b1.getLayoutData().getMultipleLayoutData()[j].getId());}}}else if(y.call(this,a1)){Y._aLayouts.push(b1.getLayoutData().getId());}}Y.addContent(b1);}this._bChangedByMe=false;return Y;};
function _(){var i=this.getAggregation("form");if(i.getLayout()){this._bChangedByMe=true;i.destroyLayout();U.call(this);this._bChangedByMe=false;}var j;switch(this.getLayout()){case d.ResponsiveLayout:if((!e||!f)&&!this._bResponsiveLayoutRequested){e=sap.ui.require("sap/ui/layout/form/ResponsiveLayout");f=sap.ui.require("sap/ui/layout/ResponsiveFlowLayoutData");if(!e||!f){sap.ui.require(["sap/ui/layout/form/ResponsiveLayout","sap/ui/layout/ResponsiveFlowLayoutData"],p.bind(this));this._bResponsiveLayoutRequested=true;}}if(e&&f){j=new e(this.getId()+"--Layout");}break;case d.GridLayout:if((!G||!h||!m)&&!this._bGridLayoutRequested){G=sap.ui.require("sap/ui/layout/form/GridLayout");h=sap.ui.require("sap/ui/layout/form/GridContainerData");m=sap.ui.require("sap/ui/layout/form/GridElementData");if(!G||!h||!m){sap.ui.require(["sap/ui/layout/form/GridLayout","sap/ui/layout/form/GridContainerData","sap/ui/layout/form/GridElementData"],r.bind(this));this._bGridLayoutRequested=true;}}if(G&&h&&m){j=new G(this.getId()+"--Layout");}break;case d.ResponsiveGridLayout:if(!g&&!this._bResponsiveGridLayoutRequested){g=sap.ui.require("sap/ui/layout/form/ResponsiveGridLayout");if(!g){sap.ui.require(["sap/ui/layout/form/ResponsiveGridLayout"],s.bind(this));this._bResponsiveGridLayoutRequested=true;}}if(g){j=new g(this.getId()+"--Layout");}break;case d.ColumnLayout:if(!n&&!this._bColumnLayoutRequested){n=sap.ui.require("sap/ui/layout/form/ColumnLayout");if(!n){sap.ui.require(["sap/ui/layout/form/ColumnLayout"],t.bind(this));this._bColumnLayoutRequested=true;}}if(n){j=new n(this.getId()+"--Layout");}break;}if(j){this._bChangedByMe=true;i.setLayout(j);this._bChangedByMe=false;return true;}return false;}
function p(i,j){e=i;f=j;this._bResponsiveLayoutRequested=false;if(this.getLayout()==d.ResponsiveLayout){u.call(this);}}
function r(i,j,k){G=i;h=j;m=k;this._bGridLayoutRequested=false;if(this.getLayout()==d.GridLayout){u.call(this);}}
function s(i){g=i;this._bResponsiveGridLayoutRequested=false;if(this.getLayout()==d.ResponsiveGridLayout){u.call(this);}}
function t(i){n=i;this._bColumnLayoutRequested=false;if(this.getLayout()==d.ColumnLayout){u.call(this);}}
function u(){if(!this._bIsBeingDestroyed){_.call(this);w.call(this);if(this.getDomRef()){x.call(this);}}}
function v(){this._bChangedByMe=true;var Y=this.getAggregation("form");var Z=Y.getFormContainers();for(var i=0;i<Z.length;i++){var $=Z[i];V(this._changedFormContainers,$);if($.getLayoutData()){$.destroyLayoutData();}var a1=$.getFormElements();for(var j=0;j<a1.length;j++){var b1=a1[j];V(this._changedFormElements,b1);if(b1.getLayoutData()){b1.destroyLayoutData();}var c1=b1.getLabel();if(c1){J.call(this,c1);}var d1=b1.getFields();for(var k=0;k<d1.length;k++){var e1=d1[k];J.call(this,e1);}}}this._bChangedByMe=false;}
function w(){this._bChangedByMe=true;var Y=this.getAggregation("form");var Z=Y.getFormContainers();for(var i=0;i<Z.length;i++){var $=Z[i];V(this._changedFormContainers,$);I.call(this,$);var a1=$.getFormElements();for(var j=0;j<a1.length;j++){var b1=a1[j];V(this._changedFormElements,b1);H.call(this,b1);var c1=b1.getLabel();if(c1){E.call(this,c1,this._iLabelWeight,false,true,this.getLabelMinWidth());}var d1=b1.getFields();for(var k=0;k<d1.length;k++){var e1=d1[k];E.call(this,e1,5,false,true);}}}this._bChangedByMe=false;}
function x(){this._bChangedByMe=true;this._changedFormContainers=[];var j=this.getLayout();var k=this.getAggregation("form").getLayout();k.setBackgroundDesign(this.getBackgroundDesign());switch(j){case d.ResponsiveLayout:this._applyLinebreaks();for(var i=0;i<this._changedFormElements.length;i++){var Y=this._changedFormElements[i];Q.call(this,Y);}break;case d.GridLayout:T.call(this);break;case d.ResponsiveGridLayout:k.setLabelSpanXL(this.getLabelSpanXL());k.setLabelSpanL(this.getLabelSpanL());k.setLabelSpanM(this.getLabelSpanM());k.setLabelSpanS(this.getLabelSpanS());k.setAdjustLabelSpan(this.getAdjustLabelSpan());k.setEmptySpanXL(this.getEmptySpanXL());k.setEmptySpanL(this.getEmptySpanL());k.setEmptySpanM(this.getEmptySpanM());k.setEmptySpanS(this.getEmptySpanS());k.setColumnsXL(this.getColumnsXL());k.setColumnsL(this.getColumnsL());k.setColumnsM(this.getColumnsM());k.setSingleContainerFullSize(this.getSingleContainerFullSize());k.setBreakpointXL(this.getBreakpointXL());k.setBreakpointL(this.getBreakpointL());k.setBreakpointM(this.getBreakpointM());break;case d.ColumnLayout:k.setColumnsXL(this.getColumnsXL()>0?this.getColumnsXL():this.getColumnsL());k.setColumnsL(this.getColumnsL());k.setColumnsM(this.getColumnsM());k.setLabelCellsLarge(this.getLabelSpanL());k.setEmptyCellsLarge(this.getEmptySpanL());break;}this._changedFormElements=[];this._bChangedByMe=false;}
function y(i){var j=i.getId(),k=" "+this._aLayouts.join(" ")+" ";return k.indexOf(" "+j+" ")>-1;}
function z(i,j,k,Y){var Z=new f({weight:i,linebreak:j===true,linebreakable:k===true});if(Y){Z.setMinWidth(Y);}this._aLayouts.push(Z.getId());return Z;}
function A(i){var j;switch(this.getLayout()){case d.ResponsiveLayout:j=c.prototype.getLayoutDataForElement(i,"sap.ui.layout.ResponsiveFlowLayoutData");break;case d.GridLayout:j=c.prototype.getLayoutDataForElement(i,"sap.ui.layout.form.GridElementData");break;case d.ResponsiveGridLayout:j=c.prototype.getLayoutDataForElement(i,"sap.ui.layout.GridData");break;case d.ColumnLayout:j=c.prototype.getLayoutDataForElement(i,"sap.ui.layout.form.ColumnElementData");break;}return j;}
function D(){var i=this.getLayout();if((i===d.ResponsiveLayout&&this._bResponsiveLayoutRequested)||(i===d.GridLayout&&this._bGridLayoutRequested)||(i===d.ResponsiveGridLayout&&this._bResponsiveGridLayoutRequested)||(i===d.ColumnLayout&&this._bColumnLayoutRequested)){return false;}if(!this.getAggregation("form").getLayout()){var j=this._bChangedByMe;var k=_.call(this);this._bChangedByMe=j;if(!k){return false;}}return true;}
function E(i,j,k,Y,Z){if(this.getLayout()!=d.ResponsiveLayout){return;}if(!D.call(this)){return;}this._bLayoutDataChangedByMe=true;var $=A.call(this,i);if(!$||!y.call(this,$)){$=i.getLayoutData();if($&&$.isA("sap.ui.core.VariantLayoutData")){$.addMultipleLayoutData(z.call(this,j,k,Y,Z));}else if(!$){i.setLayoutData(z.call(this,j,k,Y,Z));}else{L.warning("ResponsiveFlowLayoutData can not be set on Field "+i.getId(),"_createFieldLayoutData","SimpleForm");}}this._bLayoutDataChangedByMe=false;}
function H(i){if(this.getLayout()!=d.ResponsiveLayout){return;}if(!D.call(this)){return;}this._bLayoutDataChangedByMe=true;i.setLayoutData(new f({linebreak:true,margin:false}));this._bLayoutDataChangedByMe=false;}
function I(i){var j=this.getLayout();if(j!=d.ResponsiveLayout&&j!=d.GridLayout){return;}if(!D.call(this)){return;}this._bLayoutDataChangedByMe=true;switch(j){case d.ResponsiveLayout:i.setLayoutData(new f({minWidth:280}));break;case d.GridLayout:if(this.getMaxContainerCols()>1){i.setLayoutData(new h({halfGrid:true}));}else{i.setLayoutData(new h({halfGrid:false}));}break;}this._bLayoutDataChangedByMe=false;}
function J(j){this._bLayoutDataChangedByMe=true;var k=A.call(this,j);if(k){var Y=k.getId();for(var i=0;i<this._aLayouts.length;i++){var Z=this._aLayouts[i];if(Y==Z){k.destroy();this._aLayouts.splice(i,1);break;}}}this._bLayoutDataChangedByMe=false;}
function K(i,j){var k=O.call(this,j);i.addFormElement(k);return k;}
function N(i,j,k){var Y=O.call(this,j);i.insertFormElement(Y,k);return Y;}
function O(j){var k=new b();H.call(this,k);if(j){j.addStyleClass("sapUiFormLabel-CTX");k.setLabel(j);if(!A.call(this,j)){E.call(this,j,this._iLabelWeight,false,true,this.getLabelMinWidth());}}k.isVisible=function(){var Y=this.getFields();var Z=false;for(var i=0;i<Y.length;i++){var $=Y[i];if($.getVisible()){Z=true;break;}}return Z;};return k;}
function P(i){var j=new a();I.call(this,j);j.getAriaLabelledBy=function(){var k=this.getToolbar();if(k){return k.getAriaLabelledBy();}else{return[];}};if(i){if(i.isA("sap.ui.core.Title")){j.setTitle(i);}else if(i.isA("sap.ui.core.Toolbar")){j.setToolbar(i);}}return j;}
function Q(j){var k=this._iMaxWeight;var Y=j.getFields();var Z;var $=Y.length;var a1=j.getLabel();var b1;var i=0;this._bLayoutDataChangedByMe=true;if(a1&&A.call(this,a1)){k=k-A.call(this,a1).getWeight();}for(i=0;i<Y.length;i++){Z=Y[i];b1=A.call(this,Z);if(b1&&b1.isA("sap.ui.layout.ResponsiveFlowLayoutData")&&!y.call(this,b1)){k=k-b1.getWeight();$--;}}var c1=Math.floor(k/$);var d1=k%$;for(i=0;i<Y.length;i++){Z=Y[i];b1=A.call(this,Z);var e1=c1;if(!b1){E.call(this,Z,e1,false,i==0);}else if(y.call(this,b1)&&b1.isA("sap.ui.layout.ResponsiveFlowLayoutData")){if(d1>0){e1++;d1--;}b1.setWeight(e1);}}this._bLayoutDataChangedByMe=false;}
o.prototype._applyLinebreaks=function(){if(!e||this._bResponsiveLayoutRequested){return;}this._bLayoutDataChangedByMe=true;var j=this.getAggregation("form"),k=j.getFormContainers();var Y=this.getDomRef();var Z=this.$();for(var i=1;i<k.length;i++){var $=k[i],a1=$.getLayoutData();if(!Y||Z.outerWidth(true)>this.getMinWidth()){if(i%this.getMaxContainerCols()==0){a1.setLinebreak(true);}else{a1.setLinebreak(false);}}else{a1.setLinebreak(true);}}if(Y&&Z.css("visibility")=="hidden"){var b1=this;setTimeout(function(){if(b1.getDomRef()){b1.$().css("visibility","");}},10);}this._bLayoutDataChangedByMe=false;};
function T(){this._bLayoutDataChangedByMe=true;var j=this.getAggregation("form");var k=j.getFormContainers();var Y=k.length;for(var i=0;i<Y;i++){var Z=k[i];if((this.getMaxContainerCols()<=1)||((i==Y-1)&&(Y%2>0))){Z.getLayoutData().setHalfGrid(false);}else if(!Z.getLayoutData().getHalfGrid()){Z.getLayoutData().setHalfGrid(true);}}this._bLayoutDataChangedByMe=false;}
o.prototype._resize=function(i){this._bChangedByMe=true;if(this._iCurrentWidth==i.size.width){return;}this._iCurrentWidth=i.size.width;this._applyLinebreaks();this._bChangedByMe=false;};
function U(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}}
function V(j,k){var Y=false;for(var i=0;i<j.length;i++){var Z=j[i];if(Z==k){Y=true;break;}}if(!Y){j.push(k);}}
function W(i){if(i.name=="visible"){var j=i.object.getParent();j.invalidate();}}
function X(Y){var Z=[];var $=Y.getFormContainers();for(var i=0;i<$.length;i++){var a1=$[i];var b1=a1.getTitle();if(b1){Z.push(b1);}else{var c1=a1.getToolbar();if(c1){Z.push(c1);}}var d1=a1.getFormElements();for(var j=0;j<d1.length;j++){var e1=d1[j];var f1=e1.getLabel();if(f1){Z.push(f1);}var g1=e1.getFields();for(var k=0;k<g1.length;k++){var h1=g1[k];Z.push(h1);}}}return Z;}
o.prototype._formInvalidated=function(k){if(!this._bChangedByMe){var Y=X(this.getAggregation("form"));var i=0;var j=0;var Z=false;if(!this._aElements||Y.length<this._aElements.length){Z=true;}else{for(i=0;i<Y.length;i++){var $=Y[i];var a1=this._aElements[j];if($===a1){j++;}else{var b1=Y[i+1];if(b1===a1){this.insertContent($,i);break;}b1=this._aElements[j+1];if(b1===$){Z=true;break;}break;}}}if(Z){this.removeAllContent();for(i=0;i<Y.length;i++){var c1=Y[i];this.addContent(c1);}}}};
o.prototype._onLayoutDataChange=function(i){if(!this._bLayoutDataChangedByMe&&!this._bIsBeingDestroyed){switch(this.getLayout()){case d.ResponsiveLayout:var j=i.srcControl;var k=j.getParent();if(k instanceof b){var Y=this.indexOfContent(j);this.removeContent(j);this.insertContent(j,Y);}break;}}};
o.prototype._suggestTitleId=function(i){var j=this.getAggregation("form");j._suggestTitleId(i);return this;};
return o;});
sap.ui.predefine('sap/ui/layout/form/SimpleFormRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,c){c._bChangedByMe=true;r.openStart("div",c).class("sapUiSimpleForm").style("width",c.getWidth()).openEnd();var f=c.getAggregation("form");r.renderControl(f);r.close("div");c._bChangedByMe=false;};
return S;},true);
sap.ui.predefine('sap/ui/layout/library',['sap/ui/base/DataType','sap/ui/core/library'],function(D,l){"use strict";sap.ui.getCore().initLibrary({name:"sap.ui.layout",version:"1.98.0",dependencies:["sap.ui.core"],designtime:"sap/ui/layout/designtime/library.designtime",types:["sap.ui.layout.BackgroundDesign","sap.ui.layout.BlockBackgroundType","sap.ui.layout.BlockLayoutCellColorSet","sap.ui.layout.BlockLayoutCellColorShade","sap.ui.layout.BlockRowColorSets","sap.ui.layout.BoxesPerRowConfig","sap.ui.layout.GridIndent","sap.ui.layout.GridPosition","sap.ui.layout.GridSpan","sap.ui.layout.SideContentFallDown","sap.ui.layout.SideContentPosition","sap.ui.layout.SideContentVisibility","sap.ui.layout.form.ColumnsXL","sap.ui.layout.form.ColumnsL","sap.ui.layout.form.ColumnsM","sap.ui.layout.form.ColumnCells","sap.ui.layout.form.EmptyCells","sap.ui.layout.form.GridElementCells","sap.ui.layout.form.SimpleFormLayout","sap.ui.layout.cssgrid.CSSGridAutoFlow","sap.ui.layout.cssgrid.CSSGridTrack","sap.ui.layout.cssgrid.CSSGridLine","sap.ui.layout.cssgrid.CSSGridGapShortHand"],interfaces:["sap.ui.layout.cssgrid.IGridConfigurable","sap.ui.layout.cssgrid.IGridItemLayoutData"],controls:["sap.ui.layout.AlignedFlowLayout","sap.ui.layout.DynamicSideContent","sap.ui.layout.FixFlex","sap.ui.layout.Grid","sap.ui.layout.HorizontalLayout","sap.ui.layout.ResponsiveFlowLayout","sap.ui.layout.ResponsiveSplitter","sap.ui.layout.ResponsiveSplitterPage","sap.ui.layout.Splitter","sap.ui.layout.VerticalLayout","sap.ui.layout.BlockLayoutCell","sap.ui.layout.BlockLayoutRow","sap.ui.layout.BlockLayout","sap.ui.layout.form.Form","sap.ui.layout.form.FormLayout","sap.ui.layout.form.GridLayout","sap.ui.layout.form.ColumnLayout","sap.ui.layout.form.ResponsiveGridLayout","sap.ui.layout.form.ResponsiveLayout","sap.ui.layout.form.SimpleForm","sap.ui.layout.cssgrid.CSSGrid"],elements:["sap.ui.layout.BlockLayoutCellData","sap.ui.layout.GridData","sap.ui.layout.ResponsiveFlowLayoutData","sap.ui.layout.SplitterLayoutData","sap.ui.layout.form.FormContainer","sap.ui.layout.form.FormElement","sap.ui.layout.form.GridContainerData","sap.ui.layout.PaneContainer","sap.ui.layout.SplitPane","sap.ui.layout.form.GridElementData","sap.ui.layout.form.ColumnElementData","sap.ui.layout.form.ColumnContainerData","sap.ui.layout.cssgrid.GridItemLayoutData"],extensions:{flChangeHandlers:{"sap.ui.layout.BlockLayout":{"moveControls":"default"},"sap.ui.layout.BlockLayoutRow":{"moveControls":"default","hideControl":"default","unhideControl":"default"},"sap.ui.layout.BlockLayoutCell":"sap/ui/layout/flexibility/BlockLayoutCell","sap.ui.layout.DynamicSideContent":{"moveControls":"default","hideControl":"default","unhideControl":"default"},"sap.ui.layout.form.SimpleForm":"sap/ui/layout/flexibility/SimpleForm","sap.ui.layout.Grid":{"moveControls":"default","hideControl":"default","unhideControl":"default"},"sap.ui.layout.FixFlex":{"moveControls":"default","hideControl":"default","unhideControl":"default"},"sap.ui.layout.form.Form":"sap/ui/layout/flexibility/Form","sap.ui.layout.form.FormContainer":"sap/ui/layout/flexibility/FormContainer","sap.ui.layout.form.FormElement":"sap/ui/layout/flexibility/FormElement","sap.ui.layout.HorizontalLayout":{"moveControls":"default","hideControl":"default","unhideControl":"default"},"sap.ui.layout.Splitter":{"moveControls":"default","hideControl":"default","unhideControl":"default"},"sap.ui.layout.VerticalLayout":{"moveControls":"default","hideControl":"default","unhideControl":"default"}},"sap.ui.support":{publicRules:true,internalRules:true}}});sap.ui.layout.BackgroundDesign={Solid:"Solid",Transparent:"Transparent",Translucent:"Translucent"};sap.ui.layout.GridIndent=D.createType('sap.ui.layout.GridIndent',{isValid:function(v){return/^(([Xx][Ll](?:[0-9]|1[0-1]))? ?([Ll](?:[0-9]|1[0-1]))? ?([Mm](?:[0-9]|1[0-1]))? ?([Ss](?:[0-9]|1[0-1]))?)$/.test(v);}},D.getType('string'));sap.ui.layout.GridPosition={Left:"Left",Right:"Right",Center:"Center"};sap.ui.layout.GridSpan=D.createType('sap.ui.layout.GridSpan',{isValid:function(v){return/^(([Xx][Ll](?:[1-9]|1[0-2]))? ?([Ll](?:[1-9]|1[0-2]))? ?([Mm](?:[1-9]|1[0-2]))? ?([Ss](?:[1-9]|1[0-2]))?)$/.test(v);}},D.getType('string'));sap.ui.layout.BlockBackgroundType={Default:"Default",Light:"Light",Mixed:"Mixed",Accent:"Accent",Dashboard:"Dashboard"};sap.ui.layout.BlockRowColorSets={ColorSet1:"ColorSet1",ColorSet2:"ColorSet2",ColorSet3:"ColorSet3",ColorSet4:"ColorSet4"};sap.ui.layout.BlockLayoutCellColorSet={ColorSet1:"ColorSet1",ColorSet2:"ColorSet2",ColorSet3:"ColorSet3",ColorSet4:"ColorSet4",ColorSet5:"ColorSet5",ColorSet6:"ColorSet6",ColorSet7:"ColorSet7",ColorSet8:"ColorSet8",ColorSet9:"ColorSet9",ColorSet10:"ColorSet10",ColorSet11:"ColorSet11"};sap.ui.layout.BlockLayoutCellColorShade={ShadeA:"ShadeA",ShadeB:"ShadeB",ShadeC:"ShadeC",ShadeD:"ShadeD",ShadeE:"ShadeE",ShadeF:"ShadeF"};sap.ui.layout.form=sap.ui.layout.form||{};sap.ui.layout.form.GridElementCells=D.createType('sap.ui.layout.form.GridElementCells',{isValid:function(v){return/^(auto|full|([1-9]|1[0-6]))$/.test(v);}},D.getType('string'));sap.ui.layout.form.SimpleFormLayout={ResponsiveLayout:"ResponsiveLayout",GridLayout:"GridLayout",ResponsiveGridLayout:"ResponsiveGridLayout",ColumnLayout:"ColumnLayout"};sap.ui.layout.SideContentVisibility={AlwaysShow:"AlwaysShow",ShowAboveL:"ShowAboveL",ShowAboveM:"ShowAboveM",ShowAboveS:"ShowAboveS",NeverShow:"NeverShow"};sap.ui.layout.SideContentFallDown={BelowXL:"BelowXL",BelowL:"BelowL",BelowM:"BelowM",OnMinimumWidth:"OnMinimumWidth"};sap.ui.layout.SideContentPosition={End:"End",Begin:"Begin"};sap.ui.layout.form.ColumnsXL=D.createType('sap.ui.layout.form.ColumnsXL',{isValid:function(v){if(v>0&&v<=6){return true;}else{return false;}}},D.getType('int'));sap.ui.layout.form.ColumnsL=D.createType('sap.ui.layout.form.ColumnsL',{isValid:function(v){if(v>0&&v<=3){return true;}else{return false;}}},D.getType('int'));sap.ui.layout.form.ColumnsM=D.createType('sap.ui.layout.form.ColumnsM',{isValid:function(v){if(v>0&&v<=2){return true;}else{return false;}}},D.getType('int'));sap.ui.layout.form.ColumnCells=D.createType('sap.ui.layout.form.ColumnCells',{isValid:function(v){if(v===-1){return true;}else if(v>0&&v<=12){return true;}else{return false;}}},D.getType('int'));sap.ui.layout.form.EmptyCells=D.createType('sap.ui.layout.form.EmptyCells',{isValid:function(v){if(v>=0&&v<12){return true;}else{return false;}}},D.getType('int'));if(!sap.ui.layout.form.FormHelper){sap.ui.layout.form.FormHelper={createLabel:function(t){throw new Error("no Label control available!");},createButton:function(i,p,c){throw new Error("no Button control available!");},setButtonContent:function(b,t,T,i,I){throw new Error("no Button control available!");},addFormClass:function(){return null;},setToolbar:function(t){return t;},getToolbarTitle:function(t){return t&&t.getId();},createDelimiter:function(d,i){throw new Error("no delimiter control available!");},createSemanticDisplayControl:function(t,i){throw new Error("no display control available!");},updateDelimiter:function(d,s){throw new Error("no delimiter control available!");},updateSemanticDisplayControl:function(c,t){throw new Error("no display control available!");},bArrowKeySupport:true,bFinal:false};}if(!sap.ui.layout.GridHelper){sap.ui.layout.GridHelper={getLibrarySpecificClass:function(){return"";},bFinal:false};}sap.ui.layout.cssgrid.CSSGridTrack=D.createType("sap.ui.layout.cssgrid.CSSGridTrack",{isValid:function(v){var c=/(auto|inherit|(([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|[vV][wW]|[vV][hH]|[vV][mM][iI][nN]|[vV][mM][aA][xX]|%))|calc\(\s*(\(\s*)*[-+]?(([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|[vV][wW]|[vV][hH]|[vV][mM][iI][nN]|[vV][mM][aA][xX]|%)?)(\s*(\)\s*)*(\s[-+]\s|[*\/])\s*(\(\s*)*([-+]?(([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|[vV][wW]|[vV][hH]|[vV][mM][iI][nN]|[vV][mM][aA][xX]|%)?)))*\s*(\)\s*)*\))/g;v=v.replace(/(minmax|repeat|fit-content|max-content|min-content|auto-fill|auto-fit|fr|min|max)/g,"");v=v.replace(c,"");v=v.replace(/\(|\)|\+|\-|\*|\/|calc|\%|\,/g,"");v=v.replace(/[0-9]/g,"");v=v.replace(/\s/g,"");return v.length===0;},parseValue:function(v){return v.trim().split(/\s+/).join(" ");}},D.getType("string"));sap.ui.layout.cssgrid.CSSGridGapShortHand=D.createType("sap.ui.layout.cssgrid.CSSGridGapShortHand",{isValid:function(v){var r=true,V=v.split(/\s+/);V.forEach(function(s){if(!l.CSSSize.isValid(s)){r=false;}});return r;},parseValue:function(v){return v.trim().split(/\s+/).join(" ");}},D.getType("string"));sap.ui.layout.cssgrid.CSSGridLine=D.createType("sap.ui.layout.cssgrid.CSSGridLine",{isValid:function(v){return/^(auto|inherit|((span)?(\s)?-?[0-9]+(\s\/\s(span)?(\s)?-?[0-9]*)?)?)$/.test(v);}},D.getType("string"));sap.ui.layout.cssgrid.CSSGridAutoFlow={Row:"Row",Column:"Column",RowDense:"RowDense",ColumnDense:"ColumnDense"};sap.ui.layout.BoxesPerRowConfig=D.createType("sap.ui.layout.BoxesPerRowConfig",{isValid:function(v){return/^(([Xx][Ll](?:[1-9]|1[0-2]))? ?([Ll](?:[1-9]|1[0-2]))? ?([Mm](?:[1-9]|1[0-2]))? ?([Ss](?:[1-9]|1[0-2]))?)$/.test(v);}},D.getType("string"));return sap.ui.layout;});
sap.ui.require.preload({
	"sap/ui/layout/manifest.json":'{"_version":"1.21.0","sap.app":{"id":"sap.ui.layout","type":"library","embeds":[],"applicationVersion":{"version":"1.98.0"},"title":"SAPUI5 library with layout controls.","description":"SAPUI5 library with layout controls.","ach":"CA-UI5-CTR","resources":"resources.json","offline":true},"sap.ui":{"technology":"UI5","supportedThemes":["base","sap_hcb"]},"sap.ui5":{"dependencies":{"minUI5Version":"1.98","libs":{"sap.ui.core":{"minVersion":"1.98.0"}}},"library":{"i18n":{"bundleUrl":"messagebundle.properties","supportedLocales":["","ar","bg","ca","cs","cy","da","de","el","en","en-GB","en-US-sappsd","en-US-saprigi","en-US-saptrc","es","es-MX","et","fi","fr","fr-CA","hi","hr","hu","id","it","iw","ja","kk","ko","lt","lv","ms","nl","no","pl","pt","pt-PT","ro","ru","sh","sk","sl","sv","th","tr","uk","vi","zh-CN","zh-TW"]},"content":{"controls":["sap.ui.layout.AlignedFlowLayout","sap.ui.layout.DynamicSideContent","sap.ui.layout.FixFlex","sap.ui.layout.Grid","sap.ui.layout.HorizontalLayout","sap.ui.layout.ResponsiveFlowLayout","sap.ui.layout.ResponsiveSplitter","sap.ui.layout.ResponsiveSplitterPage","sap.ui.layout.Splitter","sap.ui.layout.VerticalLayout","sap.ui.layout.BlockLayoutCell","sap.ui.layout.BlockLayoutRow","sap.ui.layout.BlockLayout","sap.ui.layout.form.Form","sap.ui.layout.form.FormLayout","sap.ui.layout.form.GridLayout","sap.ui.layout.form.ColumnLayout","sap.ui.layout.form.ResponsiveGridLayout","sap.ui.layout.form.ResponsiveLayout","sap.ui.layout.form.SimpleForm","sap.ui.layout.cssgrid.CSSGrid"],"elements":["sap.ui.layout.BlockLayoutCellData","sap.ui.layout.GridData","sap.ui.layout.ResponsiveFlowLayoutData","sap.ui.layout.SplitterLayoutData","sap.ui.layout.form.FormContainer","sap.ui.layout.form.FormElement","sap.ui.layout.form.GridContainerData","sap.ui.layout.PaneContainer","sap.ui.layout.SplitPane","sap.ui.layout.form.GridElementData","sap.ui.layout.form.ColumnElementData","sap.ui.layout.form.ColumnContainerData","sap.ui.layout.cssgrid.GridItemLayoutData"],"types":["sap.ui.layout.BackgroundDesign","sap.ui.layout.BlockBackgroundType","sap.ui.layout.BlockLayoutCellColorSet","sap.ui.layout.BlockLayoutCellColorShade","sap.ui.layout.BlockRowColorSets","sap.ui.layout.BoxesPerRowConfig","sap.ui.layout.GridIndent","sap.ui.layout.GridPosition","sap.ui.layout.GridSpan","sap.ui.layout.SideContentFallDown","sap.ui.layout.SideContentPosition","sap.ui.layout.SideContentVisibility","sap.ui.layout.form.ColumnsXL","sap.ui.layout.form.ColumnsL","sap.ui.layout.form.ColumnsM","sap.ui.layout.form.ColumnCells","sap.ui.layout.form.EmptyCells","sap.ui.layout.form.GridElementCells","sap.ui.layout.form.SimpleFormLayout","sap.ui.layout.cssgrid.CSSGridAutoFlow","sap.ui.layout.cssgrid.CSSGridTrack","sap.ui.layout.cssgrid.CSSGridLine","sap.ui.layout.cssgrid.CSSGridGapShortHand"],"interfaces":["sap.ui.layout.cssgrid.IGridConfigurable","sap.ui.layout.cssgrid.IGridItemLayoutData"]}}}}'
},"sap/ui/layout/library-preload"
);
//# sourceMappingURL=library-preload.js.map